/**
 * @license
 * Copyright 2019 The Emscripten Authors
 * SPDX-License-Identifier: MIT
 */

// wasm2js.js - enough of a polyfill for the WebAssembly object so that we can load
// wasm2js code that way.

// Emit "var WebAssembly" if definitely using wasm2js. Otherwise, in MAYBE_WASM2JS
// mode, we can't use a "var" since it would prevent normal wasm from working.
/** @suppress{duplicate, const} */
var
WebAssembly = {
  // Note that we do not use closure quoting (this['buffer'], etc.) on these
  // functions, as they are just meant for internal use. In other words, this is
  // not a fully general polyfill.
  /** @constructor */
  Memory: function(opts) {
    this.buffer = new ArrayBuffer(opts['initial'] * 65536);
  },

  Module: function(binary) {
    // TODO: use the binary and info somehow - right now the wasm2js output is embedded in
    // the main JS
  },

  /** @constructor */
  Instance: function(module, info) {
    // TODO: use the module somehow - right now the wasm2js output is embedded in
    // the main JS
    // This will be replaced by the actual wasm2js code.
    this.exports = (
// EMSCRIPTEN_START_ASM
function instantiate(sb){function c(d){d.set=function(a,b){this[a]=b};d.get=function(a){return this[a]};return d}var e;var f=new ArrayBuffer(16);var g=new Int32Array(f);var h=new Float32Array(f);var i=new Float64Array(f);function j(k){return g[k]}function l(k,m){g[k]=m}function n(){return i[0]}function o(m){i[0]=m}function p(){throw new Error("abort")}function q(m){h[2]=m}function r(){return h[2]}function qb(rb){var s=rb.a;var t=s.a;var u=t.buffer;t.grow=ob;var v=new Int8Array(u);var w=new Int16Array(u);var x=new Int32Array(u);var y=new Uint8Array(u);var z=new Uint16Array(u);var A=new Uint32Array(u);var B=new Float32Array(u);var C=new Float64Array(u);var D=Math.imul;var E=Math.fround;var F=Math.abs;var G=Math.clz32;var H=Math.min;var I=Math.max;var J=Math.floor;var K=Math.ceil;var L=Math.trunc;var M=Math.sqrt;var N=s.b;var O=s.c;var P=s.d;var Q=s.e;var R=s.f;var S=s.g;var T=s.h;var U=s.i;var V=s.j;var W=s.k;var X=s.l;var Y=s.m;var Z=s.n;var _=s.o;var $=s.p;var aa=s.q;var ba=s.r;var ca=s.s;var da=s.t;var ea=s.u;var fa=s.v;var ga=s.w;var ha=s.x;var ia=s.y;var ja=s.z;var ka=s.A;var la=s.B;var ma=s.C;var na=s.D;var oa=s.E;var pa=s.F;var qa=s.G;var ra=s.H;var sa=s.I;var ta=s.J;var ua=s.K;var va=s.L;var wa=s.M;var xa=s.N;var ya=s.O;var za=s.P;var Aa=s.Q;var Ba=s.R;var Ca=s.S;var Da=s.T;var Ea=s.U;var Fa=s.V;var Ga=s.W;var Ha=s.X;var Ia=s.Y;var Ja=s.Z;var Ka=s._;var La=s.$;var Ma=s.aa;var Na=s.ba;var Oa=s.ca;var Pa=s.da;var Qa=s.ea;var Ra=s.fa;var Sa=s.ga;var Ta=s.ha;var Ua=s.ia;var Va=s.ja;var Wa=s.ka;var Xa=s.la;var Ya=s.ma;var Za=s.na;var _a=s.oa;var $a=s.pa;var ab=s.qa;var bb=s.ra;var cb=s.sa;var db=s.ta;var eb=s.ua;var fb=567792;var gb=0;var hb=0;
// EMSCRIPTEN_START_FUNCS
function LM(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,C=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,P=0,R=0,T=0,U=E(0),V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=E(0),Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=E(0),Ta=0;ea=fb-32|0;fb=ea;ga=ea+28|0;x[ga>>2]=48836;x[ga>>2]=48736;e=EB(ea+20|0);f=EB(ea+12|0);ha=b;la=c;ma=x[e>>2];Ca=y[e+4|0];na=x[f>>2];Da=y[f+4|0];b=0;K=fb-96|0;fb=K;d=a;oa=a+24604|0;a=oa;a:{if(!x[a+16>>2]){break a}c=x[a+20>>2];if(c>>>0>4|!(1<<c&22)){break a}a=x[a+28>>2];if(a>>>0>4){break a}b=23>>>a&1}if(!b){a=K+80|0;kS(a,9149,13086,221,45);b=fb-48|0;fb=b;c=uc(b+24|0,18391);x[31609]=0;f=b+12|0;O(884,f|0,17467);e=x[31609];x[31609]=0;b:{c:{d:{e:{if((e|0)!=1){x[31609]=0;e=b+36|0;S(2,e|0,c|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break e}x[31609]=0;S(885,a|0,1,e|0);a=x[31609];x[31609]=0;if((a|0)!=1){break b}a=N()|0;tb(e);break d}a=N()|0;break c}a=N()|0}tb(b+12|0)}tb(c);Q(a|0);p()}tb(b+36|0);tb(b+12|0);tb(c);fb=b+48|0}pa=d+8204|0;qa=d+397452|0;ra=d+397448|0;$=d+393352|0;J=d+397456|0;Y=d+12|0;Ea=d+1074376|0;while(1){f:{g:{b=x[d+480208>>2];if(!(!ha|b&512)){h:{if(x[d+1074380>>2]){break h}a=b|512;i:{if(b&256){break i}j=fb-48|0;fb=j;G=fb-32|0;fb=G;k=d+1074312|0;f=d+1074992|0;o=d+1298264|0;n=d+1074424|0;s=d+484360|0;m=d+1074448|0;t=d+1074376|0;a=x[d+1074392>>2];P=d+480210|0;j:{k:while(1){l:{a=a+1|0;x[d+1074392>>2]=a;if(Kl(t)>>>0>a>>>0){break l}FT(G+30|0,x[d+480180>>2],z[d+480188>>1],t,(x[d+480208>>2]&524288)>>>19|0);m:{n:{o:{p:{l=x[d+480208>>2];if(l&32){g=x[d+484348>>2];r=x[d+484344>>2];b=z[d+1074446>>1];break p}b=65535;q=Xb(x[d+484360>>2],y[d+484376|0]);i=x[q>>2];C=x[q+4>>2];e=$c(i,C);a=z[d+1074448>>1];if(e>>>0>a>>>0){b=z[bc(i,a)>>1]}w[d+1074446>>1]=b;q:{r:{c=b&65535;r=x[d+484344>>2];g=x[d+484348>>2];u=Yj(r,g);if(c>>>0>=u>>>0){break r}c=Wb(r,c);if(Ib(x[c>>2],x[c+4>>2])){break r}c=0;break q}c=1}while(1){if(!c){b=65534;w[d+1074446>>1]=65534;c=1;continue}c=z[q+28>>1];while(1){s:{t:{u:{h=b&65535;if(h>>>0>=u>>>0){b=a&65535;if(!((h|0)!=65535&e>>>0>b>>>0)){if(c){a=c;h=$c(i,C);break t}if(!(a&65535)|b>>>0>e>>>0){break u}while(1){a=b;b=a-1|0;if(!b){break u}if(z[bc(i,b)>>1]!=65535){continue}break}h=e;break t}a=a+1|0;w[m>>1]=a;b=a&65535;break s}w[d+1074450>>1]=a;break p}a=0;h=e}w[d+1074448>>1]=a;l=l&-524289;x[d+480208>>2]=l;while(1){b=a&65535;if(h>>>0<=b>>>0){break o}if(z[bc(i,b)>>1]==65534){a=a+1|0;w[m>>1]=a;continue}break}if(!Yi(q,a&65535)){break o}}if(b>>>0>=e>>>0){b=65535;w[d+1074446>>1]=65535;continue}b=z[bc(i,b)>>1];w[d+1074446>>1]=b;if(b>>>0>=u>>>0){continue}h=Wb(r,b);if(Ib(x[h>>2],x[h+4>>2])){continue}break}c=0;continue}}b=b&65535;if(!Je(r,g,b)){break n}a=x[n>>2];if(a>>>0>=A[Wb(r,b)+12>>2]){x[n>>2]=0;a=0}if(l&32?x[d+480272>>2]!=-1:0){break m}if(!Yu(o,z[m>>1],a,Iq(G+20|0,f),y[G+30|0])){break m}a=x[d+480272>>2];if(a){if((a|0)>0){x[d+480272>>2]=a-1}Lo(o,1);Yu(o,z[m>>1],x[n>>2],Iq(G+20|0,f),y[G+30|0]);break m}if(!(y[P|0]&64)){break o}if(!Xu(o,m,n)){x[d+1074424>>2]=0;x[d+1074428>>2]=0;x[d+1074448>>2]=0;b=Hj(x[d+484360>>2],x[d+484364>>2])-1|0;a=y[d+484376|0];if((b|0)<=(a|0)){Wj(s,0);break o}Wj(s,a+1&255);Lo(o,1)}a=0;while(1)if((a|0)==256){aS(d);x[d+1074416>>2]=x[d+480196>>2];x[d+1074420>>2]=x[d+480204>>2];x[d+1074456>>2]=x[d+480200>>2];a=z[d+1074448>>1];w[d+1074450>>1]=a;b=x[d+1074424>>2];x[d+1074428>>2]=b;c=Xb(x[d+484360>>2],y[d+484376|0]);e=x[c>>2];if($c(e,x[c+4>>2])>>>0>a>>>0){Qa=d,Ra=z[bc(e,a)>>1],w[Qa+1074446>>1]=Ra}Yu(o,a,b,Iq(G+20|0,f),y[G+30|0]);if(!Je(x[d+484344>>2],x[d+484348>>2],z[d+1074446>>1])){break n}break m}else{Po((D(a,872)+d|0)+1074992|0,d,a&65535,67108864);a=a+1|0;continue}}Lo(o,1)}a=0;break j}ET(d,t,(x[d+480208>>2]&32)>>>5|0);a=Wb(x[d+484344>>2],z[d+1074446>>1]);b=md(x[a>>2],x[x[a+48>>2]+12>>2],x[d+1074424>>2],0);e=f+D(z[d+480188>>1],872)|0;a=f;while(1){if((a|0)==(e|0)){v:{w:{a=x[d+484344>>2];b=z[d+1074446>>1];if(Cn(a,x[d+484348>>2],b)){a=Wb(a,b);c=x[a+16>>2];b=x[a+20>>2];if(BT(c,b)){break w}}x[d+1074408>>2]=x[d+480216>>2];b=x[d+480220>>2];break v}x[d+1074408>>2]=c}x[d+1074412>>2]=b;if(!y[G+30|0]){break l}a=x[d+1074416>>2];x[d+1074392>>2]=a;continue k}Jb(G+20|0,k,82);x:{if(!Gb(x[x[G+20>>2]>>2],x[G+24>>2])|y[a+805|0]!=1){break x}c=y[b+3|0];if((c|0)!=2&(c|0)!=3){break x}Qa=a,Ra=zh(d,y[a+800|0],w[a+772>>1],x[a+704>>2]),x[Qa+700>>2]=Ra}Jb(G+20|0,k,91);y:{if(!Gb(x[x[G+20>>2]>>2],x[G+24>>2])){break y}if(Tc(y[b|0])){break y}c=y[a+788|0];if(!Tc(c)|y[a+791|0]!=19){break y}h=y[a+793|0];if((h&240)!=208|A[d+1074416>>2]>(h&15)>>>0){break y}Qa=a,Ra=zh(d,c,w[a+772>>1],0),x[Qa+700>>2]=Ra}Jb(G+20|0,k,118);z:{if(!Gb(x[x[G+20>>2]>>2],x[G+24>>2])){break z}if(Tc(y[b|0])|!(y[a+89|0]&2)){break z}c=x[a+708>>2];if(!c){break z}if(!Tc(y[a+788|0])){break z}if(!Ll(y[a+790|0],y[a+791|0])){break z}x[a+700>>2]=c}c=G+20|0;Jb(c,k,92);A:{if(!Gb(x[x[G+20>>2]>>2],x[G+24>>2])){break A}Jb(G+12|0,k,5);if(Gb(x[x[G+12>>2]>>2],x[G+16>>2])|x[d+1074416>>2]!=1|y[a+791|0]!=17){break A}v[G+20|0]=1;Qa=d,Ra=D(y[cf(c,a+793|0)|0],1e4),x[Qa+1074420>>2]=Ra}c=y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24);v[a+788|0]=c;v[a+789|0]=c>>>8;v[a+790|0]=c>>>16;v[a+791|0]=c>>>24;c=y[b+4|0]|y[b+5|0]<<8;v[a+792|0]=c;v[a+793|0]=c>>>8;c=x[a+676>>2];x[a+20>>2]=x[a+672>>2];x[a+24>>2]=c;x[a+88>>2]=x[a+88>>2]&-393217;Jb(G+20|0,k,21);if(!Gb(x[x[G+20>>2]>>2],x[G+24>>2])){v[a+831|0]=0}x[a+860>>2]=0;v[a+805|0]=0;b=b+6|0;a=a+872|0;continue}}break}c=x[d+1074416>>2];if(!c){x[d+1074416>>2]=1;c=1}a=x[d+480208>>2];e=x[d+1074392>>2];B:{C:{if(e){b=a&-4097;x[d+480208>>2]=b;f=x[d+480180>>2];if(f&1048580|!(a&2097152)&(f|0)==1){break B}if(Kl(t)>>>0<=e>>>0){break B}if(!((e>>>0)%(x[d+1074400>>2]+c>>>0)|0)){break C}break B}b=a&-528385}x[d+480208>>2]=b|4096}q=0;i=fb-16|0;fb=i;w[d+1074444>>1]=65535;a=d+1074436|0;x[a>>2]=-1;x[a+4>>2]=-1;W=d+1075809|0;s=d+1074312|0;R=d+906300|0;C=d+1074376|0;V=d+480209|0;Z=d+480210|0;while(1){if(z[d+480188>>1]<=q>>>0){D:{if(!(y[d+480209|0]&16)){break D}if(!tT(d,C,Xb(x[d+484360>>2],y[d+484376|0]),1)){break D}x[d+480208>>2]=x[d+480208>>2]|524288}fb=i+16|0}else{n=D(q,872)+d|0;g=n+1075785|0;a=y[g|0];o=n+1075784|0;u=y[o|0];H=n+1075781|0;c=y[H|0];b=x[d+1074400>>2];e=x[d+1074392>>2];f=x[d+1074416>>2];T=n+1075782|0;m=y[T|0];k=n+1075783|0;t=y[k|0];h=Ll(m,t);L=n+1075843|0;v[L|0]=x[d+480208>>2]>>>12&1|y[L|0]&254;f=(e>>>0)%(b+f>>>0)|0;M=n+1075780|0;b=y[M|0];E:{F:{G:{if((b|0)==252){l=Dj(m,u);r=Dj(t,a);b=252;e=c-1|0;if((e&255)>>>0>249){break G}e=x[$d(R,e)>>2];if(!e){break G}ib[x[x[e>>2]+44>>2]](e,l,E(E(r>>>0)/E(999)));b=y[M|0]}if((b&255)==251){break F}}if(B[n+1075852>>2]==E(0)|t){break E}}l=x[d+480208>>2]&4096;H:{if(!l){e=y[n+1075862|0];break H}e=y[H|0];v[n+1075862|0]=e}if((e-1&255)>>>0>249){break E}r=$d(R,(e&255)-1|0);e=x[r>>2];if(!e){break E}I:{if(!l){b=z[n+1075860>>1];break I}b=rB(y[T|0],y[o|0]);w[n+1075860>>1]=b;U=E(E(rB(y[k|0],y[g|0])>>>0)/E(999));B[n+1075856>>2]=U;Qa=n+1075852|0,Sa=E(E(U-E(ib[x[x[e>>2]+48>>2]](e,b)))/E(Kl(C)>>>0)),B[Qa>>2]=Sa;e=x[r>>2]}g=b;b=(x[d+1074392>>2]+1|0)==(Kl(C)|0);ib[x[x[e>>2]+(b?44:108)>>2]](e,g,B[(b?n+1075856|0:n+1075852|0)>>2]);b=y[M|0]}o=n+1074992|0;if(jT(b&255)){b=fb-16|0;fb=b;w[b+12>>1]=0;x[b+8>>2]=0;a=Ng(b+8|0);c=y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24);v[o+788|0]=c;v[o+789|0]=c>>>8;v[o+790|0]=c>>>16;v[o+791|0]=c>>>24;a=y[a+4|0]|y[a+5|0]<<8;v[o+792|0]=a;v[o+793|0]=a>>>8;fb=b+16|0;t=0;u=0;m=0;c=0;h=0;a=0}J:{if(!(y[V|0]&16)){MS(d,o);break J}if(!c){break J}x[n+1075752>>2]=0}K:{L:{if((t|0)==33){Jb(i+8|0,s,30);b=a>>>4|0;dB(d,q&65535,b+(a&15)|0,Gb(x[x[i+8>>2]>>2],x[i+12>>2]));break L}b=0;if((t-19&255)>>>0>1){break L}M:{if(!(!(x[d+480180>>2]&16777250)|a)){a=y[n+1075825|0];break M}v[n+1075825|0]=a}e=a&240;if((e|0)==208){e=a&15;if(!e){e=x[d+480180>>2];if(e&16777248){b=1;break L}if((e|0)!=2){break L}break K}if(e>>>0>=x[d+1074400>>2]+x[d+1074416>>2]>>>0){Jb(i+8|0,s,14);b=e;if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break L}if(!c){break K}v[n+1075795|0]=c;break K}b=e;break L}if(!(x[d+480208>>2]&4096)|(e|0)!=224){break L}e=x[d+480180>>2];if(x[d+1074396>>2]?e&16777250:0){break L}g=a&15;if(!(e&2?g:1)){break L}x[d+1074396>>2]=g+1}I=a&15;g=x[d+480180>>2]==16&(t|0)==19&(a&240)==208;P=g?0:b;N:{if(!P|y[M|0]!=255|y[T|0]!=2){break N}Jb(i+8|0,s,74);if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break N}v[T|0]=0}k=I|144;e=x[d+1074392>>2];Jb(i+8|0,s,72);O:{if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){r=0;if(P>>>0>=A[d+1074416>>2]){break O}}Jb(i+8|0,s,88);e=(e|0)==(P|0);r=e|(f|0)==(P|0);if(!(!P|!Gb(x[x[i+8>>2]>>2],x[i+12>>2]))){break O}r=e}a=g?k:a;b=i+8|0;Jb(b,s,44);e=y[L|0];Qa=L,Ra=(Gb(x[x[i+8>>2]>>2],x[i+12>>2])?e&252|(f|0)==(P|0):e)&253,v[Qa|0]=Ra;Jb(b,s,66);e=(!P|Gb(x[x[i+8>>2]>>2],x[i+12>>2])^1)&h;P:{Q:{R:{if(!(x[d+1074392>>2]|(!(y[Z|0]&32)|!c))){x[n+1075652>>2]=0;if(r){h=y[M|0];break R}if(!Oi(x[o+8>>2],x[o+12>>2])){break P}v[n+1075795|0]=c;if(z[d+480190>>1]<c>>>0){break P}b=D(c,104)+d|0;x[n+1075680>>2]=z[b+484410>>1];w[n+1075764>>1]=v[b+484417|0];break P}if(!r){break P}h=y[M|0];if(!c){break Q}}v[n+1075795|0]=c}S:{T:{b=h&255;if(!Tc(b)){break T}Jb(i+8|0,s,67);if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break T}f=w[n+1075762>>1];U:{if(!c|e){break U}g=qr(d,b,c);if(!g){break U}f=v[oi(d,g)+36|0]}h=(b+f|0)-132>>>0>=4294967176?h:0;break S}if(!(x[d+480180>>2]&25165856)){break S}f=z[d+480192>>1];if(!f){break S}if(b){b=Tc(b)}else{b=1}if(!b){break S}b=c;V:{if(!b){b=y[n+1075796|0];if(!b){break V}}if(x[((b<<2)+d|0)+900380>>2]?b>>>0<=f>>>0:0){break S}h=0}c=0}if(!((t|0)!=25|a)){Jb(i+8|0,s,55);b=Gb(x[x[i+8>>2]>>2],x[i+12>>2]);c=b?0:c;h=b?0:h}b=i+8|0;Jb(b,s,65);k=Gb(x[x[i+8>>2]>>2],x[i+12>>2]);l=1;if(!(x[d+480180>>2]&16777248)){Jb(b,s,107);l=Gb(x[x[i+8>>2]>>2],x[i+12>>2])}f=(c|0)!=0;b=h&255;X=!b;Jb(i+8|0,s,85);W:{if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break W}if(Oi(x[o+8>>2],x[o+12>>2])){break W}g=x[n+1075096>>2];if(g){if(le(x[g>>2],x[g+20>>2])){break W}}l=1}X=f&X;g=f&k;X:{Y:{Z:{_:{$:{aa:{if(!(x[d+480180>>2]&1048580)){break aa}ba:{if((b|0)!=255){break ba}if(!(!((m|0)==1|c)&(t|0)!=13)){Jb(i+8|0,s,55);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break ba}}f=x[n+1075648>>2];if(v[f+60|0]&1?f:0){break ba}x[n+1075680>>2]=0;b=n+1075080|0;x[b>>2]=x[b>>2]|2097152;ca:{if(!(x[d+480208>>2]&4096)){break ca}Jb(i+8|0,s,86);if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break ca}x[b>>2]=x[b>>2]|4096}c=0;h=0;b=0;f=0;k=1;if(g){break Y}break X}Jb(i+8|0,s,59);if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])|x[d+480208>>2]&4096){break aa}da:{if(!b){h=y[n+1075789|0]-y[n+1075762|0]|0;break da}if(b>>>0>250){l=0;g=1;h=0;break da}ea:{if(c){break ea}Jb(i+8|0,s,98);if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break ea}c=0;break da}l=1;g=1}f=h;e=0;break $}f=0;if(!X){break _}}Jb(i+8|0,s,65);if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break Z}h=f;f=1}b=h;k=1;if(g){break Y}break X}h=f;f=1;k=g}fa:{ga:{if(!z[d+480192>>1]){if(z[d+480190>>1]<c>>>0){break fa}b=(D(c,104)+d|0)+484380|0;break ga}b=x[n+1075096>>2];if(!b){break fa}}ha:{if(w[b+34>>1]<0){break ha}if(x[d+480180>>2]==2){if(!le(x[b>>2],x[b+20>>2])){break ha}}x[n+1075680>>2]=z[b+30>>1];g=n+1075080|0;x[g>>2]=x[g>>2]|2097152}if(!k){break fa}Rq(o,z[b+28>>1],d)}b=h}Jb(i+8|0,s,71);if(!(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])|!c)){v[n+1075831|0]=32}ia:{if(!z[d+480192>>1]){break ia}Jb(i+8|0,s,100);if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])|!c){break ia}if(Tc(b&255)){break ia}h=x[d+480208>>2];ja:{if(e){if(h&8){break ja}break ia}if(!(h&4)){break ia}}Zm(o);x[n+1075688>>2]=65536;h=n+1075080|0;x[h>>2]=x[h>>2]|2097152}if(f){Jb(i+8|0,s,11);ka:{la:{ma:{if(!(Gb(x[x[i+8>>2]>>2],x[i+12>>2])|x[d+480180>>2]==268435456)){h=z[d+480192>>1];break ma}Jb(i+8|0,s,87);f=0;if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){f=Oi(x[o+8>>2],x[o+12>>2])^1}h=z[d+480192>>1];na:{if(h){if(c>>>0>h>>>0){break la}if(x[n+1075648>>2]!=x[((c<<2)+d|0)+900380>>2]|f){break na}break la}if((f^-1)&x[n+1075096>>2]==((D(c,104)+d|0)+484380|0)){break ka}}b=y[n+1075789|0]}if(!(h&65535)){break ka}}if(!(x[d+480180>>2]&1048588)){break ka}Zm(o);v[n+1075810|0]=0;x[n+1075748>>2]=0;x[n+1075688>>2]=65536;f=n+1075080|0;x[f>>2]=x[f>>2]&-2101249|2097152;Jb(i+8|0,s,86);if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break ka}x[f>>2]=x[f>>2]&-2049}c=l?c:0}h=b&255;oa:{if(h>>>0<251){break oa}Jb(i+8|0,s,50);pa:{if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])|!c){break pa}f=qr(d,y[n+1075791|0],c);if(!f){break pa}f=D(f,104)+d|0;if(w[f+484414>>1]<0){break pa}x[n+1075680>>2]=z[f+484410>>1]}Jb(i+8|0,s,100);if(Qa=Gb(x[x[i+8>>2]>>2],x[i+12>>2]),Ra=0,Ta=x[d+480208>>2]&4,Ta?Qa:Ra){break oa}c=0}g=Tc(h);if(g){v[n+1075794|0]=b;v[n+1075791|0]=b;if(!e){NS(d,q&65535,c,h,0)}nV(o)}qa:{ra:{sa:{ta:{ua:{if(c){f=n+1075096|0;k=x[f>>2];Ko(d,o,c,e,1,1);va:{if(x[n+1075080>>2]&67109888){break va}b=x[f>>2];if(!b|!(y[b+35|0]&2)){break va}l=x[d+1298300>>2];if(!Ed(l)){break va}RB(l,q&65535,b+68|0)}wa:{xa:{if(x[d+480180>>2]==1){if(!e){break xa}Jb(i+8|0,s,85);if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break xa}break wa}Jb(i+8|0,s,50);if((g|Gb(x[x[i+8>>2]>>2],x[i+12>>2])^1)!=1){break wa}}v[n+1075795|0]=0}Jb(i+8|0,s,42);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){if(!g|(k|0)==x[f>>2]){break ta}break ua}if(x[d+480180>>2]&16777248){b=0;if(g&(k|0)!=x[f>>2]){break sa}}Jb(i+8|0,s,107);ya:{if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])|(!(g^1|e)|(k|0)==x[f>>2])){break ya}b=n+1075068|0;if(A[b>>2]>=A[o+4>>2]){break ya}x[b>>2]=0;break ta}Jb(i+8|0,s,85);if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break ta}if(!Oi(x[o+8>>2],x[o+12>>2])){break ua}break ta}if(!h){b=e;break qa}f=0;k=n+1075795|0;b=y[k|0];if(!(!b|g^1)){Ko(d,o,b,e,!(x[n+1075096>>2]?1:x[n+1075648>>2]),!(x[d+480180>>2]&1048580));v[k|0]=0;f=1}b=e;break ra}x[o>>2]=0;x[o+4>>2]=0}b=e}f=0;if(!h){break qa}}e=n+1075080|0;za:{if(x[e>>2]&67109888){break za}g=x[n+1075096>>2];if(!g|!(y[g+35|0]&2)){break za}k=x[d+1298300>>2];if(!Ed(k)){break za}if(!f){if(OS(k,q&65535)){break za}}RB(k,q&65535,g+68|0)}f=q&65535;Su(d,o,h,b,!(x[d+480180>>2]&1048580),0,f);yT(x[d+480180>>2],z[d+480188>>1],C,f);if(!(!(x[d+480180>>2]&1048580)|(!b|!c))){x[e>>2]=x[e>>2]|2097152;Zm(o);v[n+1075810|0]=0;x[n+1075748>>2]=0}if(!(x[e>>2]&512)){break qa}if(!Ed(x[d+1298300>>2])){break qa}if(h>>>0<=253){if((h|0)!=253){break qa}Jb(i+8|0,s,99);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break qa}}Jb(i+8|0,s,110);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){TB(x[d+1298300>>2],f,0,1,0)}zk(x[d+1298300>>2],f)}Aa:{Ba:{switch(m-1|0){case 0:u=u>>>0>=64?64:u;x[n+1075680>>2]=u<<2;c=n+1075080|0;x[c>>2]=x[c>>2]|2097152;break Aa;case 1:break Ba;default:break Aa}}_m(d,o,u,6)}if(z[d+480192>>1]){LS(d,q&65535)}e=b}Jb(i+8|0,s,77);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){if(x[((q<<5)+d|0)+480280>>2]&1024){break K}}b=x[d+1074392>>2];Jb(i+8|0,s,75);f=b>>>0>=P>>>0;Ca:{Da:{Ea:{Fa:{if(!P|!Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break Fa}c=x[d+1074392>>2];if(!c){break Ea}f=1;if((c|0)!=(P|0)){break Fa}f=!y[H|0]&(m|0)!=11}b=m;if(!f|b>>>0<3){break Ea}if((b|0)==11){b=i+8|0;xB(b,d,y[M+3|0],y[M+4|0],P);b=y[_e(b)|0];cB(d,q&65535,z[i+8>>1]);if(b){break Da}m=11;break Ea}Jb(i+8|0,s,62);Ga:{Ha:{Ia:{Ja:{Ka:{La:{Ma:{if(!(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])|u)){u=0;m=0;Na:{switch(b-8|0){case 0:break Ma;case 1:break Na;default:break Ea}}if(y[V|0]&16){break Ea}x[n+1075684>>2]=0;break Ea}Jb(i+8|0,s,41);Oa:{if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break Oa}if(u){v[n+1075826|0]=u;break Oa}u=y[n+1075826|0]}Pa:{switch(b-3|0){case 0:case 1:Qa:{Ra:{if(u){break Ra}Jb(i+8|0,s,41);if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break Ra}u=y[n+1075826|0];if(u){break Qa}u=0;break Ea}v[n+1075826|0]=u}Io(d,o,((b|0)==3?u<<4:u)&255);break Ea;case 2:if((P|0)!=x[d+1074392>>2]){Jb(i+8|0,s,41);m=5;if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break Ea}}Jb(i+8|0,s,41);Ho(d,o,u,Gb(x[x[i+8>>2]>>2],x[i+12>>2]));m=5;break Ea;case 3:if((P|0)!=x[d+1074392>>2]){Jb(i+8|0,s,41);m=6;if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break Ea}}Jb(i+8|0,s,41);Go(d,o,u,Gb(x[x[i+8>>2]>>2],x[i+12>>2]));m=6;break Ea;case 11:break Ga;case 12:break Ha;case 10:break Ia;case 9:break Ja;case 7:break Ka;case 6:break La;case 5:break Ma;case 4:break Pa;default:break Ea}}Jb(i+8|0,s,53);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){v[n+1075815|0]=u&15;m=7;break Ea}Il(o,u<<4);m=7;break Ea}Il(o,u);m=8;break Ea}Jb(i+8|0,s,62);bB(d,o,u,Gb(x[x[i+8>>2]>>2],x[i+12>>2])^1);m=9;break Ea}Jb(i+8|0,s,62);bB(d,o,u<<4&240,Gb(x[x[i+8>>2]>>2],x[i+12>>2])^1);m=10;break Ea}m=12;Jb(i+8|0,s,12);KS(d,q&65535,u<<2&252,Gb(x[x[i+8>>2]>>2],x[i+12>>2]));break Ea}Jb(i+8|0,s,12);JS(d,q&65535,u<<2&252,Gb(x[x[i+8>>2]>>2],x[i+12>>2]));m=13;break Ea}m=15;if(!r){break Ea}b=x[n+1075096>>2];if(!b|u>>>0>9){break Ea}Sa:{if(!u){c=x[n+1075656>>2];break Sa}c=x[yb(b+68|0,u-1|0)>>2];x[n+1075656>>2]=c}Jo(d,o,c);break Ea}m=14;if(u>>>0>1){break Ea}v[L|0]=(y[L|0]&247|u<<3)^8}c=a;Ta:{Ua:{Va:{switch(t-1|0){case 12:if(!(y[d+480209|0]&16)){break Da}b=D(q,872)+d|0;x[b+1075680>>2]=a>>>0>=64?256:a<<2;b=b+1075080|0;x[b>>2]=x[b>>2]|2097152;break Da;case 45:if(!(y[d+480209|0]&16)){break Da}b=D(q,872)+d|0;x[b+1075680>>2]=a;b=b+1075080|0;x[b>>2]=x[b>>2]|2097152;break Da;case 1:if(!a){c=0;if(v[d+480180|0]&1){break Ca}}KS(d,q&65535,a,0);break Da;case 2:if(!a){c=0;if(v[d+480180|0]&1){break Ca}}JS(d,q&65535,a,0);break Da;case 10:if(!a){c=0;if(x[d+480180>>2]==1){break Ca}}Io(d,o,a);break Da;case 3:cB(d,q&65535,a);break Da;case 5:if(!(!a&x[d+480180>>2]==1)){Io(d,o,a)}cB(d,q&65535,0);break Da;case 4:Il(o,a);break Da;case 6:if(!(!a&x[d+480180>>2]==1)){Io(d,o,a)}Il(o,0);break Da;case 15:if(!(y[d+480209|0]&16)){break Da}break Ta;case 16:Jb(i+8|0,s,5);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){if(!(y[d+480209|0]&16)){break Da}if(a){break Ta}break Da}c=Fo(d,z[d+1074446>>1],x[d+1074424>>2],q&65535,0);Wa:{if(!(x[d+480180>>2]&16777250)){break Wa}if(c){v[(D(q,872)+d|0)+1075827|0]=c;break Wa}c=y[(D(q,872)+d|0)+1075827|0]}x[i+8>>2]=D(c,1e4);xc(i+8|0,D(x[x[d+8>>2]+24>>2],1e4));a=fb-16|0;fb=a;e=x[i+8>>2];x[a+12>>2]=e;b=x[d+8>>2];Xa:{if(e>>>0>=(x[d+480180>>2]&16393?1e4:32e4)>>>0){e=x[d+480208>>2];f=a+4|0;Jb(f,d+1074312|0,92);if((Gb(x[x[a+4>>2]>>2],x[a+8>>2])|0)==((e&4096)>>>12|0)){break Xa}x[a+4>>2]=D(x[b+24>>2],1e4);Qa=d+1074420|0,Ra=x[Hb(a+12|0,f)>>2],x[Qa>>2]=Ra;break Xa}if(y[d+480209|0]&16){break Xa}f=d+1074420|0;e=(e>>>0)/1e4|0;h=D(e&15,1e4);x[f>>2]=x[f>>2]+((e&240)==16?h:0-h|0);e=x[b+20>>2];b=x[b+24>>2];Jb(a+4|0,d+1074312|0,8);Ep(f,D(e,1e4),Gb(x[x[a+4>>2]>>2],x[a+8>>2])?255e4:D(b,1e4))}fb=a+16|0;break Ca;case 9:if(!r|x[d+480180>>2]==4&e){break Da}xT(d,o,q&65535,x[d+1074424>>2],z[d+1074446>>1]);break Da;case 43:if(!r){break Da}c=Iua(x[(D(q,872)+d|0)+1075068>>2],0,a,0);b=hb;l=b>>>8|0;Jo(d,o,Bc((b&255)<<24|c>>>8,l));break Da;case 0:if(x[d+1074392>>2]){break Da}b=D(q,872)+d|0;Ya:{if(y[b+1075789|0]?x[b+1075692>>2]:0){break Ya}b=x[b+1075648>>2];if(b){if(Kj(y[b+31|0])){break Ya}}Jb(i+8|0,s,13);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break Ya}if(x[d+480180>>2]&16777248){break Da}}if(!a){c=0;if(y[d+480180|0]&5){break Ca}v[(D(q,872)+d|0)+1075797|0]=1;break Ca}b=D(q,872)+d|0;v[b+1075798|0]=a;v[b+1075797|0]=1;break Da;case 14:if(x[d+480180>>2]&1048580){if(!(a&240)){a=y[(D(q,872)+d|0)+1075799|0]&240|a}if(!(a&15)){a=y[(D(q,872)+d|0)+1075799|0]&15|a}a=a|256}c=a;Jb(i+8|0,s,23);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){b=d;e=q&65535;if(a){v[(D(q,872)+d|0)+1075799|0]=a}else{a=y[(D(q,872)+d|0)+1075799|0]}aB(b,e,a&255,(m|0)==15?u+1|0:0);break Ca}Za:{if(c){v[(D(q,872)+d|0)+1075799|0]=c;break Za}c=y[(D(q,872)+d|0)+1075799|0]}aB(d,q&65535,c,(m|0)==15?u+1|0:0);break Ca;case 17:if(!(y[d+480209|0]&16)){break Da}Jb(i+8|0,s,22);_a:{$a:{if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){if(!a){a=0;break $a}if(y[d+480208|0]&4){break $a}a=a&240?a-16|0:a;a=a-((a&15)!=0)|0;v[(D(q,872)+d|0)+1075832|0]=a;break $a}Jb(i+8|0,s,71);if(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break _a}}b=(D(q,872)+d|0)+1075831|0;v[b|0]=y[b|0]|128}b=D(q,872)+d|0;v[b+1075797|0]=18;if(!a){c=0;break Ca}v[b+1075832|0]=a;break Da;case 22:if(!(y[d+480209|0]&16)){break Da}b=a;a=x[d+480180>>2];c=b<<!(a&59593760);if(c>>>0<=128){x[d+1074456>>2]=c<<1;break Ca}if(a&16777250){break Ca}x[d+1074456>>2]=256;break Ca;case 23:Jb(i+8|0,s,9);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){IS(d,a,(D(q,872)+d|0)+1075809|0);break Da}IS(d,a,W);break Da;case 8:if(!(y[d+480209|0]&16)){break Da}_m(d,o,a,8);break Da;case 28:bB(d,o,a,1);break Da;case 7:pT(o,a);break Da;case 25:qT(d,o,a);break Da;case 18:f=fb-16|0;fb=f;g=d+1074376|0;c=q&65535;h=D(c,872);e=(g+h|0)+616|0;b=a&15;ab:{bb:{switch(a>>>4|0){case 0:c=(a&1)<<14;e=z[d+480188>>1];b=0;while(1){if((b|0)==(e|0)){break ab}h=(D(b,872)+d|0)+1075080|0;x[h>>2]=(c|x[h>>2]&-16385)^16384;b=b+1|0;continue};case 1:if(!b){b=0;if(!(x[d+480180>>2]&1048580)){break ab}}nB(d,e,b);Jb(f+8|0,d+1074312|0,117);if(Gb(x[x[f+8>>2]>>2],x[f+12>>2])){break ab}zo(d,c,a|240,1);break ab;case 2:if(!b){b=0;if(!(x[d+480180>>2]&1048580)){break ab}}mB(d,e,b);Jb(f+8|0,d+1074312|0,117);if(Gb(x[x[f+8>>2]>>2],x[f+12>>2])){break ab}zo(d,c,0-(a|240)|0,1);break ab;case 3:c=(d+h|0)+1075080|0;x[c>>2]=x[c>>2]&-1048577|((b|0)!=0)<<20;break ab;case 4:v[(d+h|0)+1075814|0]=a&7;break ab;case 5:if(!(y[d+480209|0]&16)){break ab}g=x[d+480180>>2];if(g&69206025){c=D(c,872)+d|0;b=b<<28>>24;w[c+1075764>>1]=b;e=c+1075692|0;if(!x[e>>2]){break ab}if(!Tc(y[c+1075780|0])){break ab}Qa=e,Ra=zh(d,y[c+1075789|0],b,x[c+1075696>>2]),x[Qa>>2]=Ra;break ab}e=D(c,872)+d|0;h=Tc(y[e+1075780|0]);if((g|0)==16){if(!h){break ab}c=x[e+1075096>>2];if(!c){break ab}v[c+37|0]=b;w[e+1075764>>1]=b;c=e+1075692|0;if(!x[c>>2]){break ab}Qa=c,Ra=zh(d,y[e+1075789|0],b,x[e+1075696>>2]),x[Qa>>2]=Ra;break ab}if(!h){break ab}b=D(c,872)+d|0;c=(a<<4^-128)<<24>>24;w[b+1075764>>1]=c;e=b+1075692|0;if(!x[e>>2]){break ab}Qa=e,Ra=zh(d,y[b+1075789|0],c,x[b+1075696>>2]),x[Qa>>2]=Ra;break ab;case 6:if(!(y[d+480209|0]&16)){break ab}wB(d,g,c,b);break ab;case 7:v[(d+h|0)+1075817|0]=a&7;break ab;case 8:if(!(y[d+480209|0]&16)){break ab}_m(d,e,b,4);break ab;case 9:aB(d,c,b,0);break ab;case 10:if(b){Ho(d,e,b,0);break ab}if(!(x[d+480180>>2]&1048580)){break ab}Ho(d,e,0,0);break ab;case 11:if(b){Go(d,e,b,0);break ab}if(!(x[d+480180>>2]&1048580)){break ab}Go(d,e,0,0);break ab;case 12:dB(d,c,b,0);break ab;case 15:break bb;default:break ab}}if(x[d+480180>>2]==1){v[(D(c,872)+d|0)+1075838|0]=b;if(!(y[d+480209|0]&16)){break ab}MS(d,e);break ab}v[(D(c,872)+d|0)+1075836|0]=b}fb=f+16|0;break Da;case 19:HS(d,q&65535,a);break Da;case 24:Jb(i+8|0,s,55);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){if(x[d+1074392>>2]!=(a|0)){break Da}c=D(q,872)+d|0;b=x[c+1075648>>2];if(v[b+60|0]&1?b:0){break Ua}if(!(!(y[H|0]|y[T|0])|a)){b=c+1075080|0;x[b>>2]=x[b>>2]|4096;break Ua}b=D(q,872)+d|0;x[b+1075680>>2]=0;b=b+1075080|0;x[b>>2]=x[b>>2]|2097152;break Ua}if(y[d+480209|0]&16){break Ua}break Da;case 27:b=(a&240)-16>>>4|0;if(b>>>0>9){break Da}if(!(1<<b&880)){if(b){if((b|0)!=1){break Da}lB(d,o,I);Jb(i+8|0,s,117);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break Da}zo(d,q&65535,-224-I|0,1);break Da}oB(d,o,I);Jb(i+8|0,s,117);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break Da}zo(d,q&65535,I|224,1);break Da}Jb(i+8|0,s,58);if(Gb(x[x[i+8>>2]>>2],x[i+12>>2])){break Da}HS(d,q&65535,a);break Da;case 34:case 35:f=(t|0)==36;if(!(f|x[d+480208>>2]&4096)){break Da}e=q&65535;c=C+D(e,872)|0;h=c+616|0;b=uT(d,z[d+1074446>>1],x[d+1074424>>2],e);cb:{if(!f){break cb}f=Kl(C)-x[C+16>>2]|0;if((f|0)<2){break cb}g=b;b=w[c+1390>>1];b=gd(((g-b|0)/(f|0)|0)+b|0)}w[c+1390>>1]=b;c=Dq(d,x[c+704>>2],x[h+656>>2]);if(c){ib[x[x[c>>2]+80>>2]](c,(b<<16>>16)+32768>>>2|0,e)}break Da;case 20:if(!(y[d+480209|0]&16)|a>>>0>64){break Da}b=D(q,872)+d|0;x[b+1075740>>2]=a;b=b+1075080|0;x[b>>2]=x[b>>2]|2097152;break Da;case 21:h=x[d+480180>>2];f=x[d+480208>>2];b=a;db:{if(a){v[o+816|0]=a;break db}b=y[o+816|0]}c=b&15;e=b&255;eb:{fb:{if(!((c|0)!=15|e>>>0<16)){if(!(f&4096)){break eb}b=e>>>4|0;break fb}f=f&4096;g=e&240;if(!(!c|(g|0)!=240)){if(!f){break eb}b=0-c|0;break fb}if(f){break eb}if(c){b=0-c|0;if(!g|!(h&25690144)){break fb}break eb}if((b&255)>>>0<16){break eb}b=e>>>4|0}Qa=o,Ra=Yb(b+x[o+748>>2]|0,0,64),x[Qa+748>>2]=Ra}break Da;case 26:oT(o,a);break Da;case 29:if(!(y[d+480209|0]&16)){break Da}b=D(q,872)+d|0;x[b+1075716>>2]=a;Jb(i+8|0,s,60);if(Qa=0,Ra=Gb(x[x[i+8>>2]>>2],x[i+12>>2]),Ta=y[b+1075722|0]&4,Ta?Qa:Ra){break Da}x[b+1075732>>2]=a;x[b+1075724>>2]=a;break Da;case 11:sT(d,C,q&65535);break Da;case 13:b=rT(d,C,q&65535,a);if((b|0)==-1){break Da}x[d+1074436>>2]=b;if(!(y[d+480208|0]&32)){break Da}w[d+1074444>>1]=z[d+1074448>>1];break Da;case 37:case 38:case 39:case 40:gT(d,o,a,(t|0)==38|(t|0)==40,(t&254)==40);break Da;case 41:wT(o,a);break Da;case 42:if(x[d+1074392>>2]|I>>>0>1|a>>>0>47){break Da}b=(a&240)==16;f=b?z[d+480188>>1]-1|0:q;c=b?0:q;b=((I|0)==1)<<25;while(1){e=c&65535;if(e>>>0>(f&65535)>>>0){break Da}h=(D(e,872)+d|0)+1075080|0;g=x[h>>2];e=((e<<5)+d|0)+480280|0;x[e>>2]=b|x[e>>2]&-33554433;x[h>>2]=b|g&-33554433;c=c+1|0;continue};case 44:break Va;default:break Ca}}vT(o,a);break Da}Eo(d,o);break Da}CT(d,C,a)}c=a}Jb(i+8|0,s,78);if(!(!Gb(x[x[i+8>>2]>>2],x[i+12>>2])|!c)){lT(o,c&255)}a=y[H|0];if(!a){break K}v[n+1075796|0]=a}q=q+1|0;continue}break}a=1}fb=G+32|0;L=a&x[d+1074420>>2]!=0;gb:{if(!L){break gb}a=AT(d,d+1074376|0);x[d+1074380>>2]=a;x[d+1074404>>2]=a;b=Ld(z[d+480188>>1],1,31);hb:{if(Id(y[d+1074366|0])){a=x[d+24628>>2];if((a|0)>=129){a=((D(a-128|0,b+4|0)|0)/16|0)+128|0}o=((D(x[d+480228>>2],a)<<1&-128)>>>0)/y[(b>>>1|0)+30496|0]|0;break hb}o=x[d+480228>>2]}w[d+480212>>1]=0;i=d+1074312|0;C=d+480210|0;M=d+480209|0;t=0;while(1){if((t|0)==256){a=x[d+24608>>2];b=z[d+480212>>1];if(a>>>0>b>>>0){break gb}o=fb-16|0;fb=o;x[o+12>>2]=d;e=d+1074478|0;c=e+(a<<1)|0;if((c|0)!=(e|0)){f=e+(b<<1)|0;ib:{b=c-e>>1;if((b|0)<2){break ib}a=b-2>>>1|0;while(1){if((a|0)<0){break ib}NR(e,x[o+12>>2],b,e+(a<<1)|0);a=a-1|0;continue}}b=c-e>>1;a=c;while(1){if((a|0)!=(f|0)){if(Fl(x[o+12>>2],z[a>>1],z[e>>1])){MR(a,e);NR(e,x[o+12>>2],b,e)}a=a+2|0;continue}break}a=c-e>>1;while(1){if((a|0)>1){g=z[e>>1];b=e;m=x[o+12>>2];f=0;h=a;l=a-2>>>1|0;while(1){k=f<<1;f=k|1;r=b+k|0;a=r+2|0;k=k+2|0;if((k|0)<(h|0)){t=k;k=r+4|0;r=Fl(m,z[a>>1],z[k>>1]);f=r?t:f;a=r?k:a}w[b>>1]=z[a>>1];b=a;if((f|0)<=(l|0)){continue}break}f=c-2|0;jb:{if((f|0)==(a|0)){w[a>>1]=g;break jb}w[b>>1]=z[f>>1];w[f>>1]=g;k=x[o+12>>2];b=b+2|0;a=b-e>>1;kb:{if((a|0)<2){break kb}f=a-2|0;a=e+(f&-2)|0;b=b-2|0;if(!Fl(k,z[a>>1],z[b>>1])){break kb}f=f>>>1|0;m=z[b>>1];while(1){lb:{g=b;b=a;w[g>>1]=z[a>>1];if(!f){break lb}a=f-1|0;f=a>>>1|0;a=e+(a&-2)|0;if(Fl(k,z[a>>1],m)){continue}}break}w[b>>1]=m}}a=h-1|0;c=c-2|0;continue}break}}fb=o+16|0}else{k=D(t,872)+d|0;r=k+1075080|0;mb:{if(!(x[r>>2]&4096)|(x[k+1075016>>2]|(x[k+1075012>>2]|x[k+1075688>>2]))){break mb}Jb(j+16|0,i,64);if(Gb(x[x[j+16>>2]>>2],x[j+20>>2])){break mb}x[k+1075068>>2]=0;a=k+1075084|0;x[a>>2]=0;x[a+4>>2]=0}c=z[d+480188>>1];a=x[r>>2];nb:{if(x[k+1075068>>2]|c>>>0>t>>>0?a&1024:1){if(c>>>0>t>>>0){SR(d,t&65535)}w[k+1075834>>1]=0;break nb}b=0;I=k+1075712|0;x[I>>2]=0;s=k+1075672|0;x[s>>2]=0;n=k+1075e3|0;e=n;x[e>>2]=0;x[e+4>>2]=0;x[k+1075092>>2]=0;x[j+44>>2]=1065353216;w[j+42>>1]=0;P=k+1075648|0;G=x[P>>2];x[j+36>>2]=0;m=0;q=k+1075692|0;m=x[q>>2]?x[k+1075068>>2]!=0:m;e=k+1074992|0;ob:{pb:{qb:{if(c>>>0<=t>>>0){break qb}if(y[((t<<5)+d|0)+480288|0]){break pb}if(!G){break qb}b=y[G+34|0]!=0}if((b|m)!=1){break ob}}x[j+8>>2]=x[k+1075680>>2];x[j+32>>2]=x[k+1075744>>2];H=j+16|0;Jb(H,i,28);b=j+8|0;a=Gb(x[x[j+16>>2]>>2],x[j+20>>2])?j+32|0:b;c=d+1074312|0;rb:{if(Ob(c,28)){x[a>>2]=x[a>>2]+w[e+776>>1];He(a,0,64);break rb}f=Ob(c,1);c=w[e+776>>1];if(f){x[a>>2]=c+x[a>>2];He(a,0,256);break rb}x[e+688>>2]=c+x[e+688>>2];He(e+688|0,0,256);x[a>>2]=x[e+688>>2];w[e+776>>1]=0}sb:{tb:{a=d+1074312|0;if(!Ob(a,28)){if(!Ob(a,1)){break tb}}x[e+684>>2]=x[e+692>>2]+w[e+778>>1];He(e+684|0,0,256);break sb}x[e+692>>2]=x[e+692>>2]+w[e+778>>1];He(e+692|0,0,256);w[e+778>>1]=0;x[e+684>>2]=x[e+692>>2]}ub:{if(!(y[e+90|0]&4)|(x[d+480208>>2]&2101248)==2101248){break ub}vb:{if(x[b>>2]<=0){if(!Ob(d+1074312|0,21)){break vb}}c=5;if(!(y[d+480180|0]&5)){c=Ob(d+1074312|0,21)?5:6}a=KA(d,y[e+825|0],y[e+820|0]);wb:{if((y[e+825|0]&3)!=1){break wb}if(!Ob(d+1074312|0,89)){break wb}a=y[e+819|0];h=y[e+820|0];f=h<<2&124;a=(!(y[e+90|0]&2)|y[d+480209|0]&16?a:y[e+823|0]+a|0)&32?f^127:f;a=h&32?0-a|0:a}if(x[d+480180>>2]!=131072){a=x[b>>2]+((D(y[e+827|0],a)|0)/(1<<c)|0)|0}else{c=64-a|0;a=x[b>>2];a=((D(y[e+827|0],D(c,a))|0)/-8192|0)+a|0}x[b>>2]=a}a=x[d+480208>>2];if(!(x[d+480180>>2]&16777248)|a&4?a&4096:0){break ub}a=Ob(d+1074312|0,21);c=y[e+826|0];v[e+820|0]=y[e+820|0]+(a?c<<2:c)}f=t&65535;h=fb-16|0;fb=h;a=d+1074312|0;Jb(h+8|0,a,71);xb:{if(Gb(x[x[h+8>>2]>>2],x[h+12>>2])){g=D(f,872)+d|0;a=g+1075831|0;c=v[a|0];if((c|0)>=0){break xb}if(!(y[d+480209|0]&16|y[g+1075797|0]!=18)){yb:{zb:{if((c&-33)!=-64){c=c&223;if((c|0)!=128){break zb}c=y[g+1075832|0]>>>4|-64;break yb}c=y[(D(f,872)+d|0)+1075832|0]&15|-128;break yb}c=c-1|0}v[a|0]=c;a=(D(f,872)+d|0)+1075080|0;x[a>>2]=x[a>>2]|2097152}if((c&224)!=128){break xb}x[b>>2]=0;break xb}g=D(f,872)+d|0;if(y[g+1075797|0]!=18){break xb}Jb(h+8|0,a,22);Ab:{if(Gb(x[x[h+8>>2]>>2],x[h+12>>2])){a=g+1075831|0;l=y[a|0];c=l<<24>>24;if(!(!x[g+1075068>>2]|(c|0)>=0)){Bb:{Cb:{if((l|0)!=192){if((l|0)!=128){break Cb}c=y[g+1075832|0]>>>4|-64;break Bb}c=y[(D(f,872)+d|0)+1075832|0]&15|-128;break Bb}c=c-1|0}v[a|0]=c}if((c&192)!=128){break Ab}x[b>>2]=0;break Ab}a=y[(D(f,872)+d|0)+1075832|0];c=a>>>4|0;u=c+(a&15)|0;g=x[d+480180>>2];if(!(y[d+480208|0]&4?0:g&16777248)){u=u+2|0;c=c+1|0}a=(D(f,872)+d|0)+1075831|0;l=y[a|0];if(!(g&4)){g=c;c=(l&255)>>>0<u>>>0?l:0;if(g>>>0<=(c&255)>>>0){x[b>>2]=0}v[a|0]=c+1;break Ab}Db:{if(y[d+480209|0]&16){a=l&255;g=a-1|0;l=a>>>0>=g>>>0?g:0;break Db}v[a|0]=l+1}if(((l&255)>>>0)%(u>>>0)>>>0<c>>>0){break Ab}x[b>>2]=0}a=(D(f,872)+d|0)+1075080|0;x[a>>2]=x[a>>2]|2097152}a=D(f,872)+d|0;Eb:{if(y[a+1075797|0]!=18){break Eb}c=x[a+1075648>>2];if(!c){break Eb}l=y[c+34|0];if(x[a+1075080>>2]&67109888|(!l|y[c+15|0]&2)){break Eb}g=a+1075791|0;u=y[g|0];if(!Tc(u)){break Eb}a=x[$d(d+906300|0,l-1|0)>>2];if(!a){break Eb}l=ib[x[x[a>>2]+104>>2]](a,u,f)|0;u=x[b>>2];if(!(!l|u)){ib[x[x[a>>2]+96>>2]](a,c,y[g|0]|256,0,f);break Eb}if(l|!u){break Eb}ib[x[x[a>>2]+96>>2]](a,c,y[g|0],z[(D(f,872)+d|0)+1075680>>1],f)}fb=h+16|0;He(b,0,256);x[j+8>>2]=x[j+8>>2]<<6;Fb:{if(G){Jb(H,i,31);if(Gb(x[x[j+16>>2]>>2],x[j+20>>2])){Nu(d,e)}a=j+8|0;Gb:{if(!IA(d,e,0)){break Gb}c=x[e+656>>2];h=d+1074312|0;g=Ob(h,31);b=x[e+724>>2];if(b?0:g){break Gb}l=b-Ob(h,31)|0;b=Qq(c+48|0,l,256,64);u=y[c+65|0];Hb:{if((u|0)==255){break Hb}g=w[e+728>>1];if((g|0)==-1){break Hb}u=yb(x[c+48>>2],u);H=y[u+2|0];c=H<<2;b=(l|0)==z[u>>1]?c:b;if(Ob(h,94)){b=g+(b-c<<1)|0;break Hb}if(!H){b=0;break Hb}b=(D(b,g)|0)/(c|0)|0}Qa=a,Ra=(D(Yb(b,0,512),x[a>>2])|0)/256|0,x[Qa>>2]=Ra}eT(e,a);Ib:{if(!IA(d,e,1)){break Ib}a=x[e+656>>2];b=d+1074312|0;h=Ob(b,31);c=x[e+732>>2];if(c?0:h){break Ib}b=Qq(a+68|0,c-Ob(b,31)|0,64,64)-32|0;a=x[e+684>>2];Qa=e,Ra=Yb(((D(b,(a|0)>127?256-a|0:a)|0)/32|0)+a|0,0,256),x[Qa+684>>2]=Ra}Jb(j+16|0,i,115);if(Gb(x[x[j+16>>2]>>2],x[j+20>>2])){break Fb}b=y[k+1075789|0];if(!b){break Fb}a=x[P>>2];if(!a|!y[a+26|0]){break Fb}hT(k+1075676|0,b,y[a+26|0],y[a+27|0]);break Fb}if(!(y[r+1|0]&16)){break Fb}x[k+1075688>>2]=0;x[j+8>>2]=0}Jb:{if(y[k+1075843|0]&8){b=0;x[j+8>>2]=0;break Jb}b=x[j+8>>2];if(!b){b=0;break Jb}if(y[r+3|0]&4){x[s>>2]=0;break Jb}if(Id(y[d+1074365|0])){a=D(x[j+32>>2],x[k+1075740>>2]);c=a;h=a>>31;a=b<<8;Qa=s,Ra=Gc(Jua(Iua(c,h,a,a>>31),hb,1048576,0),hb),x[Qa>>2]=Ra;break Jb}a=D(x[j+32>>2],x[k+1075740>>2]);c=a;h=a>>31;a=D(x[d+1074456>>2],b);Qa=s,Ra=Gc(Jua(Iua(c,h,a,a>>31),hb,1048576,0),hb),x[Qa>>2]=Ra}x[I>>2]=b;Kb:{Lb:{b=x[q>>2];if(!(x[d+480180>>2]==2|(b|0)>=x[d+480260>>2])){if(!Aj(d)){break Lb}b=x[q>>2]}if((b|0)<x[d+480264>>2]){break Kb}Jb(j+16|0,i,113);if(!Gb(x[x[j+16>>2]>>2],x[j+20>>2])){break Kb}if(Aj(d)){break Kb}x[q>>2]=x[d+480264>>2];break Kb}x[q>>2]=x[d+480260>>2]}Jb(j+16|0,i,73);a=x[q>>2];x[j+36>>2]=a;Mb:{if((x[r>>2]&1572864)!=1572864){break Mb}b=x[d+480208>>2];if(b&2097152){if(!Ll(y[k+1075782|0],y[k+1075783|0])|b&4096){break Mb}}b=k+1075704|0;Nb:{if((a|0)==x[b>>2]){b=x[k+1075708>>2];break Nb}x[b>>2]=a;c=a;a=k+1075764|0;b=k+1075696|0;b=zh(d,Ku(d,c,w[a>>1],x[b>>2]),w[a>>1],x[b>>2]);x[k+1075708>>2]=b}x[j+36>>2]=b}h=fb-16|0;fb=h;b=D(f,872)+d|0;u=b;H=b+1075648|0;a=x[H>>2];Ob:{if(!a){break Ob}c=y[a+34|0];if(x[b+1075080>>2]&67109888|(!c|y[a+15|0]&2)){break Ob}if(!x[$d(d+906300|0,c-1|0)>>2]){break Ob}g=b+1075780|0;a=y[b+1075793|0];T=b+1075783|0;l=y[T|0];Pb:{Qb:{if((l|0)==1){b=a;Rb:{Sb:{switch(((A[d+1074392>>2]%(x[d+1074400>>2]+x[d+1074416>>2]>>>0)>>>0)%3|0)-1|0){case 0:b=a+(y[(D(f,872)+d|0)+1075798|0]>>>4|0)|0;break Rb;case 1:break Sb;default:break Rb}}b=a+(y[(D(f,872)+d|0)+1075798|0]&15)|0}c=D(f,872)+d|0;if(y[c+1075792|0]==(b&255)){break Pb}if(!(v[c+1075843|0]&1)){break Qb}if(!Tc(y[g|0])){break Qb}if(Ll(y[g+2|0],1)){break Qb}break Pb}if(y[g|0]){b=a;if(!Ll(y[g+2|0],l)){break Pb}}b=a;if(!y[(D(f,872)+d|0)+1075792|0]){break Pb}}Ym(d,f,b&255|512,z[(D(f,872)+d|0)+1075680>>1])}R=(D(f,872)+d|0)+1075792|0;c=y[R|0];Tb:{Ub:{if(c){if((l|0)!=1|(b&255)!=(c|0)){break Ub}break Tb}if(!(v[(D(f,872)+d|0)+1075843|0]&1)|(l|0)!=1){break Tb}if(Tc(y[g|0])){break Tb}c=a;if(!Tc(a)){break Tb}}Ym(d,f,c&255|256,0)}v[R|0]=y[T|0]==1?b:0}Vb:{if(y[u+1075797|0]!=1){break Vb}if(Lj(x[H>>2])){b=0;Wb:{Xb:{Yb:{switch(A[d+1074392>>2]%3|0){case 1:b=y[(D(f,872)+d|0)+1075798|0]>>>4|0;break Xb;case 0:break Xb;case 2:break Yb;default:break Wb}}b=y[(D(f,872)+d|0)+1075798|0]&15}w[j+42>>1]=b}a=(D(f,872)+d|0)+1075843|0;v[a|0]=y[a|0]|96;break Vb}if(!(!(y[d+480209|0]&16)|x[d+480180>>2]!=1048576)){a=D(f,872)+d|0;b=zh(d,y[a+1075789|0],w[a+1075764>>1],x[a+1075696>>2]);x[j+36>>2]=b;x[a+1075692>>2]=b}c=d+1074312|0;Jb(h+8|0,c,13);if(Gb(x[x[h+8>>2]>>2],x[h+12>>2])){b=y[(D(f,872)+d|0)+1075798|0];if(!b){break Vb}a=65536;Zb:{switch(((A[d+1074392>>2]%(x[d+1074400>>2]+x[d+1074416>>2]>>>0)>>>0)%3|0)-1|0){case 1:b=b<<4;case 0:a=x[((b&240)<<2)+35504>>2];break;default:break Zb}}f=Aj(d);b=x[j+36>>2];c=b>>31;if(f){a=Iua(b,c,a,a>>31);f=hb;a=a+32768|0;f=a>>>0<32768?f+1|0:f;a=Jua(a,f,65536,0);b=hb}else{f=(a|0)/2|0;l=f>>31;g=c<<16|b>>>16;c=b<<16;b=c+f|0;l=g+l|0;a=Jua(b,b>>>0<c>>>0?l+1|0:l,a,a>>31);b=hb}Qa=j,Ra=Gc(a,b),x[Qa+36>>2]=Ra;break Vb}Jb(h+8|0,c,51);if(Gb(x[x[h+8>>2]>>2],x[h+12>>2])){if(y[d+480209|0]&16){break Vb}_b:{$b:{a=x[d+1074416>>2];b=a-(A[d+1074392>>2]%(a>>>0)|0)|0;if((b|0)>16){break $b}if((b|0)==16){break Vb}a=0;ac:{switch((b|0)%3|0){case 0:break Vb;case 2:break $b;case 1:break ac;default:break _b}}a=y[(D(f,872)+d|0)+1075798|0]>>>4|0;break _b}a=y[(D(f,872)+d|0)+1075798|0]&15}c=a;a=D(f,872)+d|0;b=a+1075764|0;a=a+1075696|0;c=c+Ku(d,x[j+36>>2],w[b>>1],x[a>>2])|0;b=zh(d,c,w[b>>1],x[a>>2]);x[j+36>>2]=b;if(c>>>0<109){break Vb}x[h+8>>2]=b;Qa=h,Ra=zh(d,109,0,x[a>>2]),x[Qa+4>>2]=Ra;Qa=j,Ra=x[bd(h+8|0,h+4|0)>>2],x[Qa+36>>2]=Ra;break Vb}g=x[d+1074392>>2];b=x[d+480180>>2];bc:{if((b|0)!=1){a=y[(D(f,872)+d|0)+1075789|0];break bc}a=D(f,872)+d|0;a=Ku(d,x[j+36>>2],w[a+1075764>>1],x[a+1075696>>2]);b=x[d+480180>>2]}cc:{dc:{switch((((b&67633152?g+2|0:g)>>>0)%3|0)-1|0){case 0:a=(y[(D(f,872)+d|0)+1075798|0]>>>4|0)+a|0;break cc;case 1:break dc;default:break cc}}a=(y[(D(f,872)+d|0)+1075798|0]&15)+a|0}if(!(b&67633408|y[(D(f,872)+d|0)+1075789|0]!=(a&255))){Jb(h+8|0,c,82);if(!Gb(x[x[h+8>>2]>>2],x[h+12>>2])){break Vb}}if(y[d+480210|0]&32){b=a&255;if((b|0)==85){x[j+36>>2]=2147483647;break Vb}a=b>>>0>85?a-37|0:a}b=D(f,872)+d|0;g=zh(d,a&255,w[b+1075764>>1],x[b+1075696>>2]);x[j+36>>2]=g;if(x[d+480180>>2]&71860480){x[b+1075692>>2]=g;break Vb}Jb(h+8|0,c,82);if(!Gb(x[x[h+8>>2]>>2],x[h+12>>2])){break Vb}v[(D(f,872)+d|0)+1075792|0]=a}fb=h+16|0;if(!(!(y[C|0]&33)|x[j+36>>2]==2147483647)){ec:{if(x[d+480180>>2]==2){b=452;a=3424;break ec}a=D(z[k+1075764>>1]>>>4&15,24);b=z[a+31238>>1]>>>1|0;b=b>>>0<=452?452:b;a=z[a+31216>>1]<<1}He(j+36|0,b,a);He(q,b,a)}mT(d,e);a=x[r>>2]}fc:{if(!(a&256)|y[M|0]&64){break fc}Jb(j+16|0,i,37);if(!Gb(x[x[j+16>>2]>>2],x[j+20>>2])){break fc}x[k+1075676>>2]=128}a=zT(d,e);gc:{if((a|0)<0|!(y[r+1|0]&2)){break gc}b=x[d+1298300>>2];if(!Ed(b)){break gc}Oq(b,t&65535,a&255,1)}h=t&65535;SR(d,h);hc:{if(!m){break hc}a=fT(d,e,j+36|0);if((a|0)<0|!(y[r+1|0]&2)){break hc}b=x[d+1298300>>2];if(!Ed(b)){break hc}Oq(b,h,a>>>2&255,1)}ic:{if(y[k+1075782|0]!=8){break ic}jc:{kc:{a=y[k+1075783|0];switch(a-5|0){case 1:break ic;case 0:case 2:break jc;default:break kc}}if((a|0)!=26){break ic}}a=x[d+480180>>2];if((a|0)==4){if(y[M|0]&16){break ic}a=k+1075811|0;v[a|0]=y[a|0]+y[k+1075815|0];break ic}if(!(a&16777248)){break ic}Il(e,y[k+1075784|0]);RR(d,h,j+36|0,j+44|0)}a=j+36|0;RR(d,h,a,j+44|0);lc:{if(!m){break lc}x[j+32>>2]=0;m=fb-16|0;fb=m;c=x[e+104>>2];mc:{if(!c|!y[c+40|0]){break mc}q=Lj(x[e+656>>2]);l=Aj(d);b=l?36528:35504;f=l?35504:36528;if(!(q|!Ob(d+1074312|0,21)|x[d+480180>>2]==1048576)){u=y[c+41|0];if(!u){break mc}g=y[e+818|0];x[m+12>>2]=x[e+756>>2]+y[c+39|0];vi(m+12|0,y[c+40|0]<<8);q=x[m+12>>2];v[e+818|0]=g+u;x[e+756>>2]=q;q=(q|0)/256|0;nc:{oc:{switch(y[c+38|0]-1|0){case 3:g=PR(Do(d))+-64|0;break nc;case 2:g=64-(g+1>>>1|0)|0;break nc;case 1:g=(g+1>>>1|0)+-64|0;break nc;case 0:g=(g^-1)>>>1&64;break nc;default:break oc}}g=v[g+31808|0]}vi(a,8388607);c=x[a>>2]<<8;x[a>>2]=c;H=D(g,q);q=(H|0)/64|0;g=q>>31;g=(g^q)-g|0;q=g&3;u=g>>>2|0;g=a;a=c>>31;T=a;pc:{qc:{if((H|0)<=-64){b=x[(u<<2)+b>>2];a=Gc(Jua(Iua(b,b>>31,c,a),hb,65536,0),hb)-c|0;if(!q){break pc}b=l?35440:35376;break qc}b=x[f+(u<<2)>>2];a=Gc(Jua(Iua(b,b>>31,c,a),hb,65536,0),hb)-c|0;if(!q){break pc}b=l?35376:35440}b=x[(q<<2)+b>>2];a=(Gc(Jua(Iua(c,T,b,b>>31),hb,65536,0),hb)+a|0)-c|0}x[g>>2]=(a+c|0)/256;x[j+32>>2]=a&255;break mc}l=x[d+480180>>2]&16777248;g=y[c+39|0];rc:{if(!(l|g)){x[e+756>>2]=y[c+40|0]<<8;break rc}sc:{if(l){x[e+756>>2]=x[e+756>>2]+(g<<1);l=y[c+40|0];break sc}l=y[c+40|0];if(y[e+89|0]&8){break sc}x[e+756>>2]=x[e+756>>2]+(((l<<8&65280)>>>0)/(g>>>0)|0)}vi(e+756|0,l<<8)}g=y[e+818|0]+y[c+41|0]|0;v[e+818|0]=g;g=g<<24>>24;tc:{uc:{switch(y[c+38|0]-1|0){case 3:v[e+818|0]=g+1;l=v[(g&63)+31744|0];break tc;case 2:l=(64-(g>>>1|0)&127)+-64|0;break tc;case 1:l=((g>>>1|0)- -64&127)+-64|0;break tc;case 0:l=(g|0)>=0?-64:64;break tc;default:break uc}}l=0-v[(g&255)+31808|0]|0;if(x[d+480180>>2]!=1048576){break tc}l=(64-v[(g+-64&255)+31808|0]|0)/2<<16>>16}g=l;u=D(g,x[e+756>>2]);l=(u|0)/256|0;if(q){B[j+44>>2]=B[j+44>>2]+E(E(E(D(g,y[c+40|0])|0)*E(.05000000074505806))*E(.000244140625));v[e+851|0]=y[e+851|0]|64;break mc}if(x[d+480180>>2]!=4){vc:{if((u|0)<=-256){l=0-l|0;c=l>>>8|0;f=(c<<2)+b|0;break vc}b=f;c=l>>>8|0;f=b+(c<<2)|0}g=x[a>>2];c=x[((c<<2)+b|0)+4>>2];b=x[f>>2];b=((D(c-b|0,l>>>2&63)|0)/64|0)+b|0;b=Gc(Jua(Iua(g,g>>31,b,b>>31),hb,256,0),hb);x[a>>2]=b;x[j+32>>2]=b&255;x[a>>2]=x[a>>2]/256;break mc}x[a>>2]=x[a>>2]+((u|0)/16384|0)}fb=m+16|0;m=x[j+36>>2];if((m|0)<=x[d+480260>>2]){Jb(j+16|0,i,81);if(Gb(x[x[j+16>>2]>>2],x[j+20>>2])){x[k+1075068>>2]=0}m=x[d+480260>>2];x[j+36>>2]=m}wc:{if(!Lj(x[e+656>>2])){break wc}a=k+1075843|0;b=y[a|0];if(!(x[d+1074392>>2]|!(b&32)?b&64:1)){break wc}mV(e,B[j+44>>2],w[j+42>>1],d);b=a;a=y[a|0];v[b|0]=(a&64?-65:-97)&a}a=j+16|0;yB(a,d,e,m,x[j+32>>2]);f=Ab(a);a=Iua(x[j+16>>2],x[j+20>>2],x[d+480240>>2],0);l=hb;b=Jua(a,l,65536,0);c=hb;g=b;a=a+65535|0;b=!(a>>>0<65535?l+1|0:l)&a>>>0<131071;a=b?1:g;x[j+16>>2]=a;b=b?0:c;x[j+20>>2]=b;x[n>>2]=a;x[n+4>>2]=b;if((x[r>>2]&67110400)!=512){break lc}if(!Ed(x[d+1298300>>2])){break lc}Jb(j+8|0,i,99);a=x[r>>2];c=a&4096;xc:{yc:{if(Qa=Gb(x[x[j+8>>2]>>2],x[j+12>>2]),Ra=1,Ta=c,Ta?Qa:Ra){b=x[d+480180>>2];break yc}b=x[d+480180>>2];if((b|0)!=2){break xc}}g=(b|0)==2;b=a&2048;zc:{if(b?g:0){break zc}a=x[d+480240>>2];g=Iua(x[f>>2],0,261625,0);f=hb;g=g+66904|0;f=g>>>0<66904?f+1|0:f;a=Iua(a,0,Bc(Kua(g,f,133808,0),hb),0);l=hb;a=a+32768|0;l=a>>>0<32768?l+1|0:l;f=Bc((l&65535)<<16|a>>>16,l>>>16|0);a=1;Ac:{if(b){break Ac}a=0;if(!c){break Ac}a=!x[k+1075688>>2]}b=j+8|0;Jb(b,i,110);if(Qa=Gb(x[x[j+8>>2]>>2],x[j+12>>2]),Ra=0,Ta=a,Ta?Qa:Ra){break zc}c=x[d+1298300>>2];Jb(b,i,95);TB(c,h,f,a,Gb(x[x[j+8>>2]>>2],x[j+12>>2]))}a=x[d+1298300>>2];b=Iua(D(x[k+1075744>>2],D(x[k+1075740>>2],x[I>>2])),0,63,0);g=hb;b=b+33554432|0;g=b>>>0<33554432?g+1|0:g;Oq(a,h,Bc((g&67108863)<<6|b>>>26,g>>>26|0)&255,0);a=k+1075676|0;g=a;b=x[a>>2];c=0;a=x[d+1298300>>2];f=Rl(a,h);Bc:{if((f|0)==255){break Bc}m=x[a>>2];if(Gj(m)){break Bc}c=xb(Vd(a+318|0,f),10);l=x[a+4>>2];f=bv(f)|192;a=y[c|0]&-49;a=(b|0)<171?a|16:a;a=(b|0)>84?a|32:a;Ah(m,l,h,f,a&255);c=(a>>>5&1)+(a<<27>>31)|0}x[g>>2]=(c<<7)+128}Cc:{a=x[P>>2];if(!a|(y[a+60|0]&7)!=1){break Cc}b=x[a+48>>2];a=x[a+52>>2];if(mc(b,a)){break Cc}b=x[QR(e,0)>>2];a=xf(a);if(b>>>0<z[a>>1]|y[a+2|0]){break Cc}Fj(x[d+1298300>>2],h,1);Jb(j+8|0,i,109);a=x[r>>2];Qa=r,Ra=(Gb(x[x[j+8>>2]>>2],x[j+12>>2])?a:a&-4609)|4096,x[Qa>>2]=Ra;x[k+1075688>>2]=0;break lc}Jb(j+8|0,i,99);if(!Gb(x[x[j+8>>2]>>2],x[j+12>>2])|!(y[r+1|0]&16)|x[k+1075688>>2]){break lc}Fj(x[d+1298300>>2],h,1);x[r>>2]=x[r>>2]&-513}Dc:{if(!G){break Dc}Jb(j+16|0,i,31);if(Gb(x[x[j+16>>2]>>2],x[j+20>>2])){break Dc}Nu(d,e)}f=x[r>>2];g=x[s>>2];u=k+1075016|0;G=k+1075012|0;l=f&-65537|(g|(x[u>>2]|x[G>>2])?!(f&512)<<16:0);x[r>>2]=l;s=k+1075664|0;a=s;x[a>>2]=0;x[a+4>>2]=0;h=k+1075834|0;a=y[h|0];b=a-4|0;a=a>>>0>=b>>>0?b:0;v[h|0]=a;q=k+1075835|0;b=y[q|0];c=b-4|0;b=b>>>0>=c>>>0?c:0;v[q|0]=b;Ec:{Fc:{Gc:{Hc:{Ic:{Jc:{Kc:{Lc:{Mc:{c=x[k+1075096>>2];Nc:{if(!c){break Nc}m=x[c+20>>2];if(!le(x[c>>2],m)|!x[k+1075068>>2]){break Nc}if(Oi(x[e+8>>2],x[e+12>>2])){break Mc}}x[k+1075008>>2]=0;break Lc}x[k+1075008>>2]=m;if(m){break Kc}}if(!Cj(x[e+656>>2])){break Jc}m=0;if(f&6144){break Jc}}I=x[k+1075676>>2];c=(D(g,256-I|0)|0)/16384|0;c=c>>>0>=127?127:c;if(a<<24>>24<0){v[h|0]=c;_=c}else{_=a}a=c>>>1|0;if((_&255)>>>0<a>>>0){v[h|0]=a}a=(D(g,I)|0)/16384|0;a=a>>>0>=127?127:a;if(b<<24>>24<0){v[q|0]=a;b=a}a=a>>>1|0;if(a>>>0>(b&255)>>>0){break Ic}break Hc}if((a&255)>>>0>=129){v[h|0]=0}m=0;a=0;if((b&255)>>>0<129){break Gc}}v[q|0]=a}if(!m){break Gc}m=128;h=x[d+24624>>2];if(h>>>0>=2){m=Yb(x[k+1075676>>2],0,256)}x[j+16>>2]=m;a=D(g,o)>>>(Id(y[d+1074366|0])?7:8)|0;Oc:{Pc:{Qc:{switch(y[d+1074364|0]){case 0:if(!(y[d+24616|0]&16)){break Pc}case 1:if((m|0)<=127){b=a>>>1|0;c=(D(a,m)|0)/256|0;break Oc}b=(D(a,256-m|0)|0)/256|0;c=a>>>1|0;break Oc;case 3:break Qc;default:break Pc}}vi(j+16|0,255);c=x[j+16>>2];if((c|0)<=0){b=65536}else{b=z[(0-c<<1)+38064>>1]}b=D(b,a)>>>16|0;c=D(a,z[(c<<1)+37552>>1])>>>16|0;break Oc}b=(D(a,256-m|0)|0)/256|0;c=(D(a,m)|0)/256|0}a=x[P>>2];Rc:{if(a){m=y[a+14|0];if(tp(m)){break Rc}}m=y[d+480268|0];if(tp(m)){break Rc}a=y[d+24648|0];m=y[C|0]&128?x[d+24668>>2]?-1:a:a}g=k+1075668|0;l=k+1075786|0;v[l|0]=m;a=x[n>>2];q=x[n+4>>2];if(!(f&131072|((a|0)!=0|(q|0)!=1)|(x[k+1075748>>2]|(m&255)==255))){v[l|0]=0}l=b;b=1<<x[d+1074360>>2];x[s>>2]=(l|0)/(b|0);b=(c|0)/(b|0)|0;x[g>>2]=(f&256)>>>8|0?(h|0)==2?0-b|0:b:b;if(f&128){x[n>>2]=0-a;x[n+4>>2]=0-(((a|0)!=0)+q|0)}l=0;h=fb-16|0;fb=h;x[e+28>>2]=0;x[e+32>>2]=0;vi(e+672|0,524287);vi(e+676|0,524287);a=x[e+676>>2];b=x[e+672>>2];Sc:{Tc:{c=x[e+88>>2];if(!(c&65536)){break Tc}f=x[e+20>>2];g=x[e+24>>2];if((f|0)==(b|0)&(g|0)==(a|0)){break Tc}c=x[d+24620>>2];g=(b|0)<=(f|0)&(a|0)<=(g|0);Uc:{if(!g){a=fv(c,x[d+24636>>2]);break Uc}a=fv(c,x[d+24640>>2])}if(!(!Ob(d+1074312|0,4)|!(y[d+480180|0]&4))){a=x[d+24620>>2];a=Iua(a,a>>31,5,0);f=hb;a=a+500|0;f=a>>>0<500?f+1|0:f;a=Gc(Jua(a,f,1e3,0),hb)}b=a;c=x[e+656>>2];Vc:{if(g|!c){break Vc}c=z[c+12>>1];if(!c){break Vc}l=1;b=(D(c,x[d+24620>>2])>>>0)/1e5|0}m=b>>>0<=1?1:b;f=x[e+672>>2];n=x[e+20>>2];q=f-n<<12;s=e;c=x[e+676>>2];b=x[e+24>>2];g=c-b<<12;if(!(y[e+90|0]&32|(!(c|f)|(!(b|n)|l)))){x[h+12>>2]=x[d+1074380>>2];He(h+12|0,a,2048);m=x[h+12>>2]}g=(g|0)/(m|0)|0;x[s+32>>2]=g;l=(q|0)/(m|0)|0;x[e+28>>2]=l;a=c+((D(g,m)|0)/-4096|0)|0;x[e+24>>2]=a;b=f+((D(l,m)|0)/-4096|0)|0;x[e+20>>2]=b;if(g|l){x[e+100>>2]=m;c=x[e+88>>2];break Sc}x[e+24>>2]=c;x[e+20>>2]=f;a=c;b=f;c=x[e+88>>2]&-65537;break Sc}x[e+24>>2]=a;x[e+20>>2]=b;c=c&-65537}x[e+88>>2]=c&-2097153;x[e+40>>2]=a<<12;x[e+36>>2]=b<<12;fb=h+16|0;l=x[r>>2];if(!(l&512)){break Fc}break Ec}x[G>>2]=0;x[u>>2]=0;x[k+1075068>>2]=0;if(x[k+1075088>>2]){break Fc}if(!x[k+1075084>>2]){break Ec}}a=z[d+480212>>1];w[d+480212>>1]=a+1;w[((a<<1)+d|0)+1074478>>1]=t}x[k+1075660>>2]=l;a=k+1075843|0;v[a|0]=y[a|0]&253}t=t+1|0;continue}break}}fb=j+48|0;if(L){b=x[d+480208>>2];break h}if(Id(y[d+1298424|0])){a=x[d+480208>>2]|512;break i}k=0;Wc:{a=x[d+24620>>2]/10|0;b=Gc(a,a>>31);if(!b){break Wc}c=b>>>0>=1048576?1048576:b;x[d+1074380>>2]=c;f=z[d+480212>>1];e=d+1074376|0;while(1){if((f|0)==(k|0)){break Wc}a=e+D(z[(e+(k<<1)|0)+102>>1],872)|0;h=a+1288|0;x[h>>2]=0;x[h+4>>2]=0;x[a+716>>2]=c;h=x[a+640>>2]<<12;x[a+656>>2]=h;g=x[a+636>>2]<<12;x[a+652>>2]=g;x[a+704>>2]=x[a+704>>2]|65536;x[a+644>>2]=(0-g|0)/(c|0);x[a+648>>2]=(0-h|0)/(c|0);k=k+1|0;continue}}c=x[d+480208>>2];a=c|256;if(b){break i}a=c|512}b=a;x[d+480208>>2]=b}if(!(b&512)){break g}Qa=d+1074392|0,Ra=Kl(Ea),x[Qa>>2]=Ra}fb=K+96|0;break f}x[K+80>>2]=512;a=x[d+1074380>>2];x[K+88>>2]=ha;x[K+84>>2]=a;o=vE(K+80|0);if(x[d+24632>>2]){b=0;a=fb-48|0;fb=a;c=o<<2;while(1){if((b|0)==4){Xc:{b=0;while(1){if((b|0)==4){break Xc}x[(a+32|0)+(b<<2)>>2]=((b<<11)+d|0)+16396;b=b+1|0;continue}}}else{x[a+32>>2]=0;e=((b<<11)+d|0)+16396|0;Yz(e,c+e|0,a+32|0);b=b+1|0;continue}break}b=x[d+24632>>2];x[a+28>>2]=o;x[a+24>>2]=b;x[a+20>>2]=a+32;b=x[x[ga>>2]+8>>2];x[a+16>>2]=o;c=x[a+24>>2];x[a+8>>2]=x[a+20>>2];x[a+12>>2]=c;ib[b|0](ga,a+8|0);fb=a+48|0}if(Id(Da)){b=0;while(1){if((b|0)==4){a=x[d+24632>>2];x[K+76>>2]=o;x[K+72>>2]=a;x[K+68>>2]=K+80;a=x[x[na>>2]+8>>2];x[K+40>>2]=o;b=x[K+72>>2];x[K+32>>2]=x[K+68>>2];x[K+36>>2]=b;ib[a|0](na,K+32|0)}else{x[(K+80|0)+(b<<2)>>2]=((b<<11)+d|0)+16396;b=b+1|0;continue}break}}aa=0;k=fb-48|0;fb=k;if(o){u=d+12|0;G=d+24592|0;P=d+24588|0;Ln(u,o,G,P);if(A[d+24624>>2]>=3){Ln(d+8204|0,o,d+24600|0,d+24596|0)}w[k+42>>1]=0;sa=d+1074312|0;Fa=d+24648|0;ta=d+906300|0;_=d+24596|0;Ga=d+24600|0;Ha=d+8204|0;t=d+397452|0;q=d+397448|0;s=d+393352|0;ua=d+397456|0;ja=d+1074376|0;while(1){if(z[d+480212>>1]<=aa>>>0){Qa=d,Ra=z[qe(d+480214|0,k+42|0)>>1],w[Qa+480214>>1]=Ra}else{f=ja+(aa<<1)|0;C=z[f+102>>1];a=D(C,872);H=a+ja|0;Yc:{Zc:{if(x[H+632>>2]){break Zc}b=a+d|0;if(x[b+1075088>>2]){break Zc}if(!x[b+1075084>>2]){break Yc}}j=a+d|0;a=y[j+1075786|0]+1&255;if(a>>>0<=5){g=x[(a<<2)+26144>>2]}else{g=0}M=j+1075080|0;h=x[M>>2];_c:{if(!(y[d+24612|0]&32)|(h&16777216)>>>24){b=G;e=u;c=h;l=P;if(!(c&8388608)){break _c}}if(!y[ua+12|0]){Ln(s,o,q,t)}v[ua+12|0]=1;C=z[f+102>>1];c=x[M>>2];b=q;e=s;l=t}a=c>>>8&A[d+24624>>2]>2;T=a?_:l;R=a?Ga:b;c=a?Ha:e;ka=pm(d,ja,C&65535,2,1)-1|0;va=(ka&255)>>>0>249;$c:{if(va){break $c}b=x[$d(ta,ka)>>2];if(!b){break $c}a=x[b+24>>2];if(!a){break $c}T=b+36|0;R=b+40|0;if(!(v[b+28|0]&1)){Ln(a,o,R,T);x[b+28>>2]=x[b+28>>2]|1}c=a}m=H+616|0;if(y[j+1075843|0]&8){YF(m,c,o);a=j+1075084|0;x[R>>2]=x[R>>2]+x[a>>2];x[T>>2]=x[T>>2]+x[j+1075088>>2];x[a>>2]=0;x[a+4>>2]=0;break Yc}ba=0;a=k+20|0;x[a>>2]=0;x[a+4>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;b=d+1074312|0;Qa=a,Ra=Ob(b,33),v[Qa+16|0]=Ra;Qa=a,Ra=Ob(b,116)^1,v[Qa+17|0]=Ra;if(x[m+16>>2]){XF(a,m);b=x[m+12>>2];f=b>>31;e=f;l=e^x[m+8>>2];b=(b^e)-((e>>>0>l>>>0)+e|0)|0;x[a+12>>2]=b>>>0>8191?2:16384/(b+1>>>0)|0}Ia=h>>>12&8|(h>>>5&2|(g|h&1));Ja=j+1075795|0;Ka=j+1075778|0;La=j+1075688|0;Ma=j+1075024|0;Na=j+1075020|0;Oa=j+1075668|0;Pa=j+1075664|0;V=j+1075088|0;W=j+1075084|0;wa=j+1075016|0;xa=j+1075012|0;ca=j+1075096|0;Z=j+1075076|0;L=j+1075068|0;I=j+1075e3|0;ia=j+1075072|0;X=j+1075092|0;n=a;b=o;while(1){ad:{a=x[X>>2];fa=a?a>>>0<b>>>0?a:b:b;x[k+12>>2]=fa;bd:{cd:{if(!fa){break cd}h=x[I>>2];a=x[I+4>>2];if(!(h|a)){break cd}g=x[L>>2];if(!g){break cd}e=x[n>>2];if(!e){break cd}C=x[M>>2];r=C&2;l=x[ia>>2];x[H+632>>2]=e;e=x[m>>2];dd:{ed:{j=l&C<<30>>31;f=x[m+4>>2];if((j|0)>(f|0)){if((a|0)<0){e=hh(0,j<<1,e,f);x[m>>2]=e;f=hb;x[m+4>>2]=f;if(!(f>>>0<g+j>>>1>>>0&(f|0)>=(j|0))){e=0;x[m>>2]=e;f=j;x[m+4>>2]=f}fd:{if(C&4){C=C&-129;x[M>>2]=C;a=0-(((h|0)!=0)+a|0)|0;h=0-h|0;x[I>>2]=h;x[I+4>>2]=a;break fd}x[m>>2]=e;f=g-1|0;x[m+4>>2]=f}if(!r){break cd}if(f>>>0<g>>>0){break dd}break cd}if((f|0)>0|(f|0)>=0){break dd}f=0;break ed}if(f>>>0<g>>>0){break dd}if(!r){break cd}if(C&4){if(!!h&(a|0)>=0|(a|0)>0){a=0-(((h|0)!=0)+a|0)|0;h=0-h|0;x[I>>2]=h;x[I+4>>2]=a}C=C|128;x[M>>2]=C;if(y[k+37|0]){r=y[k+36|0];i=x[Z>>2]-(r+l|0)|0;e=hh(e,f,0,g);f=hb;if(f>>>0<i>>>0){e=hh(0,g-r|0,e,f);f=hb;break ed}f=l;e=0;break ed}r=0-e|0;i=(g<<1)-((1-((e|0)!=0)|0)+f|0)|0;f=i;e=r;x[m>>2]=e;da=0;f=da|f;x[m+4>>2]=f;if(g>>>0>i>>>0&i>>>0>l>>>0){break dd}x[k+44>>2]=y[k+36|0]+1;f=da|g-x[Hb(L,k+44|0)>>2];break ed}if((a|0)<0){a=0-(((h|0)!=0)+a|0)|0;h=0-h|0;x[I>>2]=h;x[I+4>>2]=a}Pb(m,0,l-g|0);C=x[M>>2]|8192;x[M>>2]=C;e=x[m>>2];f=x[m+4>>2];break dd}x[m>>2]=e;x[m+4>>2]=f}gd:{if((f|0)<(j|0)){if((a|f)<0){break cd}x[k+44>>2]=fa;g=h;l=a;break gd}g=x[L>>2];if(g>>>0<f>>>0|(!!h&(a|0)>=0|(a|0)>0)&(f|0)==(g|0)){break cd}x[k+44>>2]=fa;l=a>>31;i=l^h;g=i-l|0;l=(a^l)-((i>>>0<l>>>0)+l|0)|0}r=g;i=l;xc(k+12|0,x[k+32>>2]);ya=x[k+12>>2];fg(e,f,vf(h,a,ya-1|0),hb);l=hb;g=x[ia>>2];za=g>>>0>f>>>0|g+16>>>0<=f>>>0;if(za){C=C&-8193;x[M>>2]=C}hd:{id:{da=x[k+24>>2];jd:{if(da){g=x[k+28>>2];if(g>>>0<=f>>>0){kd:{if((a|0)<0){h=0;a=g;break kd}h=e;a=f;e=0;f=x[Z>>2]}Qa=k,Ra=Fp(hh(hh(e,f,h,a),hb,1,0),hb,r,i)+1|0,x[Qa+44>>2]=Ra;x[H+632>>2]=da;break hd}if(!(za|!(C&8192))){Qa=k,Ra=Fp(hh(hh(0,j+16|0,e,f),hb,1,0),hb,r,i)+1|0,x[Qa+44>>2]=Ra;Qa=H,Ra=da+D(x[Z>>2]-j|0,_k(z[x[ca>>2]+34>>1]))|0,x[Qa+632>>2]=Ra;break hd}if(!h&(a|0)<=0|(a|0)<0){break jd}if(fa>>>0<2|g>>>0>l>>>0){break id}Qa=k,Ra=Fp(hh(hh(0,g,e,f),hb,1,0),hb,r,i)+1|0,x[Qa+44>>2]=Ra;break hd}if((a|0)>0|(a|0)>=0){break id}}if((j|0)<=(l|0)){break hd}Qa=k,Ra=Fp(hh(hh(e,f,0,j),hb,1,0),hb,r,i)+1|0,x[Qa+44>>2]=Ra;break hd}g=x[L>>2];if((g|0)>(l|0)){break hd}Qa=k,Ra=Fp(hh(hh(0,g,e,f),hb,1,0),hb,r,i)+1|0,x[Qa+44>>2]=Ra}Ep(k+44|0,1,ya);f=x[k+44>>2];if((f|0)>0){break bd}}x[H+632>>2]=0;x[L>>2]=0;x[m>>2]=0;x[m+4>>2]=0;x[X>>2]=0;YF(m,c,b);x[R>>2]=x[R>>2]+x[W>>2];x[T>>2]=x[T>>2]+x[V>>2];x[V>>2]=0;x[W>>2]=0;x[M>>2]=x[M>>2]&-129;break ad}ld:{md:{if(A[d+24608>>2]>z[k+42>>1]){a=4;if(x[X>>2]){break md}a=0;if(x[wa>>2]|x[xa>>2]){break md}}Pb(m,vf(x[I>>2],x[I+4>>2],f),hb);ba=0;x[V>>2]=0;x[W>>2]=0;c=(f<<3)+c|0;break ld}e=(f<<3)+c|0;h=e-8|0;x[W>>2]=0-x[h>>2];g=e-4|0;x[V>>2]=0-x[g>>2];ib[x[((a|Ia)<<2)+25760>>2]](m,Fa,c,f);x[W>>2]=x[W>>2]+x[h>>2];x[V>>2]=x[V>>2]+x[g>>2];ba=1;c=e}a=x[X>>2];nd:{if(!a){break nd}if(a>>>0<=f>>>0){x[X>>2]=0;x[xa>>2]=x[Pa>>2];x[wa>>2]=x[Oa>>2];x[Na>>2]=0;x[Ma>>2]=0;if(x[La>>2]|!(y[M+1|0]&16)){break nd}x[L>>2]=0;x[H+632>>2]=0;break nd}x[X>>2]=a-f}e=0;C=0;a=x[m+4>>2];C=a>>>0>=A[Z>>2]?(y[M|0]&2)>>>1|0:C;h=a;a=x[L>>2];e=x[M>>2]&2|(h>>>0<a>>>0|!a)?e:!z[Ka>>1];b=b-f|0;Jb(k+12|0,sa,85);od:{pd:{qd:{if(!Gb(x[x[k+12>>2]>>2],x[k+16>>2])){break qd}a=y[Ja|0];if(!a){break qd}if(a>>>0<=z[d+480190>>1]){break pd}}l=0;break od}h=x[ca>>2];a=D(a,104)+d|0;f=a+484380|0;l=(h|0)!=(f|0);if((f|0)==(h|0)|(e|C)!=1){break od}x[ca>>2]=f;e=x[a+484400>>2];x[H+632>>2]=e;f=z[a+484414>>1];x[M>>2]=f|x[M>>2]&-768;h=f<<30>>31;f=x[a+484388>>2];x[L>>2]=h&f;a=x[a+484384>>2];x[ia>>2]=a;x[Z>>2]=f;x[m+4>>2]=a;XF(n,m);if(!e){break ad}if((b|0)>0){continue}break ad}rd:{if(!C|l){break rd}Jb(k+12|0,sa,83);if(!Gb(x[x[k+12>>2]>>2],x[k+16>>2])|x[ia>>2]){break rd}x[m>>2]=x[m>>2];x[m+4>>2]=0;a=x[x[ca>>2]+8>>2];x[L>>2]=a;x[Z>>2]=a}if((b|0)>0){continue}}break}x[H+632>>2]=x[n>>2];w[k+42>>1]=z[k+42>>1]+ba;if(va|!ba){break Yc}a=x[$d(ta,ka)>>2];if(!a){break Yc}ib[x[x[a>>2]+152>>2]](a)}aa=aa+1|0;continue}break}}fb=k+48|0;n=x[d+1298300>>2];if(Ed(n)){b=Y;c=o;a=(D(x[d+480232>>2],x[d+480236>>2])>>>0)/48|0;m=fb-16|0;fb=m;sd:{if(!y[n+534|0]){break sd}e=Iua(a,0,6169,0);a=hb;g=a>>>16|0;t=Bc((a&65535)<<16|e>>>16,g);while(1){if(!c){break sd}h=x[n>>2];j=x[h>>2];a=x[h+4>>2];while(1){if((a|0)>=(j|0)){x[h+8>>2]=x[h+12>>2];j=0;l=0;k=0;a=fb-16|0;fb=a;while(1){if((k|0)==18){e=(j|0)>=32767?32767:j;w[h+12>>1]=(e|0)<=-32768?-32768:e;e=(l|0)>=32767?32767:l;w[h+14>>1]=(e|0)<=-32768?-32768:e;w[h+3832>>1]=z[h+3832>>1]+1;e=(z[h+3834>>1]+1>>>0)%13440|0;w[h+3834>>1]=e;e=e>>>0<6720?e:13440-e|0;w[h+3836>>1]=e>>>8;if(!y[h+3843|0]){w[h+3836>>1]=e>>>10}e=z[h+3838>>1]+1|0;w[h+3838>>1]=e;if((e&65535)>>>0>=1024){w[h+3838>>1]=0;w[h+3840>>1]=z[h+3840>>1]+1&7}fb=a+16|0}else{f=h+D(k,44)|0;td:{if(!y[f+56|0]){w[a+12>>1]=0;w[a+14>>1]=0;break td}g=x[f+32>>2];e=z[g+3840>>1];if(e&3){g=(z[f+36>>1]>>>7&7)>>>(y[g+3844|0]^1)>>>(e&1)<<z[f+38>>1];e=e&4?0-g|0:g}else{e=0}g=x[f+52>>2];ud:{if(g){s=z[g+32>>1];q=z[f+48>>1];e=e<<16>>16;g=Eg(x[f+16>>2],x[f+40>>2],e,0,w[f+46>>1]);r=x[f+40>>2];i=x[f+20>>2];if(!s){if(!q){g=Eg(i,r,e,g,0);g=Eg(x[f+24>>2],x[f+40>>2],e,g,0);e=Eg(x[f+28>>2],x[f+40>>2],e,g,0);break ud}r=Eg(i,r,e,0,0);r=Eg(x[f+24>>2],x[f+40>>2],e,r,0);e=Eg(x[f+28>>2],x[f+40>>2],e,r,0)+g|0;break ud}if(!q){g=Eg(i,r,e,g,0);r=Eg(x[f+24>>2],x[f+40>>2],e,0,0);e=Eg(x[f+28>>2],x[f+40>>2],e,r,0)+g|0;break ud}r=Eg(i,r,e,0,0);e=(Eg(x[f+24>>2],x[f+40>>2],e,r,0)+g|0)+Eg(x[f+28>>2],x[f+40>>2],e,0,0)|0;break ud}q=z[f+48>>1];e=e<<16>>16;g=Eg(x[f+16>>2],x[f+40>>2],e,0,w[f+46>>1]);r=x[f+40>>2];i=x[f+20>>2];if(!q){e=Eg(i,r,e,g,0);break ud}e=Eg(i,r,e,0,0)+g|0}w[a+14>>1]=y[f+57|0]?e:0;w[a+12>>1]=y[f+58|0]?e:0}k=k+1|0;l=w[a+12>>1]+l|0;j=w[a+14>>1]+j|0;continue}break}j=x[h>>2];a=x[h+4>>2]-j|0;x[h+4>>2]=a;continue}break}e=j-a|0;w[m+14>>1]=(D(w[h+12>>1],a)+D(e,w[h+8>>1])|0)/(j|0);w[m+12>>1]=(D(w[h+14>>1],a)+D(e,w[h+10>>1])|0)/(j|0);x[h+4>>2]=a+49716;x[b>>2]=x[b>>2]+D(t,w[m+14>>1]);x[b+4>>2]=x[b+4>>2]+D(t,w[m+12>>1]);b=b+8|0;c=c-1|0;continue}}fb=m+16|0}a=y[J+12|0];if(a|x[J+16>>2]){if(!a){Ln($,o,ra,qa)}a=x[J>>2];b=x[J+80>>2];c=D(a,b)>>>4|0;c=c>>>0>=32767?32767:c;w[J+98>>1]=c;w[J+96>>1]=c;c=x[J+49948>>2];e=D(c,a)>>>4|0;e=e>>>0>=65536?65536:e;f=e+127>>>3|0;w[J+49946>>1]=f;e=e+255>>>4|0;w[J+49944>>1]=e;w[J+49942>>1]=e;w[J+49940>>1]=f;b=(b|0)>(c|0)?b:c;a=36-a>>>1|0;a=16-(a>>>0<=8?8:a)|0;a=16-(D((b|0)>=32768?32768:b,a>>>0<=16?a:0)>>15)|0;j=0;while(1){if((j|0)!=(o|0)){b=j<<3;c=b+Y|0;x[c>>2]=x[c>>2]+D(a,x[b+$>>2]>>4);b=b|4;c=b+Y|0;x[c>>2]=x[c>>2]+D(a,x[b+$>>2]>>4);j=j+1|0;continue}break}j=J+68|0;k=0;c=w[J+84>>1];a=x[J+40>>2];f=x[J+36>>2];while(1){if((k|0)==(o|0)){x[J+40>>2]=a;x[J+36>>2]=f;h=o}else{b=(k<<3)+$|0;e=x[b>>2]>>12;f=(D(c,e-f|0)>>15)+e|0;x[b>>2]=f;e=b;b=x[b+4>>2]>>12;a=(D(c,b-a|0)>>15)+b|0;x[e+4>>2]=a;k=k+1|0;continue}break}if(h){c=$;b=h;k=x[j>>2]-1|0;e=z[j+22>>1];g=z[j+20>>1];a=w[j+26>>1];f=w[j+24>>1];i=w[j+18>>1];n=w[j+16>>1];C=x[j+4>>2];m=j+32928|0;while(1){if(b){l=pd(x[c>>2]);r=pd(x[c+4>>2]);g=pd((g<<16>>16)-l|0);e=pd((e<<16>>16)-r|0);g=gd(pd((D(g,n)|0)/65536<<1)+l|0);e=gd(pd((D(e,i)|0)/65536<<1)+r|0);r=m+(C<<2)|0;t=w[r>>1];l=gd(((D(t,f)|0)/-65536|0)+g|0);C=C+1&127;q=m+(C<<2)|0;r=w[r+2>>1];s=gd(((D(r,a)|0)/-65536|0)+e|0);w[q+2>>1]=s;w[q>>1]=l;k=k+1&8191;q=j+(k<<2)|0;Qa=q,Ra=gd(t+((D(f,l)|0)/65536|0)|0),w[Qa+160>>1]=Ra;Qa=q,Ra=gd(r+((D(a,s)|0)/65536|0)|0),w[Qa+162>>1]=Ra;c=c+8|0;b=b-1|0;continue}break}w[j+22>>1]=e;w[j+20>>1]=g;x[j+4>>2]=C}g=J+49892|0;u=J+33508|0;c=h;b=$;while(1){if(c){f=x[J+76>>2];k=f&4095;e=u+(k<<2)|0;a=b;k=4096-k|0;q=f-x[J+49892>>2]&4095;f=4096-q|0;f=f>>>0>k>>>0?k:f;f=c>>>0<f>>>0?c:f;f=f>>>0>=64?64:f;C=f;t=0;m=fb-32|0;fb=m;k=x[j>>2];while(1){if((t|0)==7){vd:{i=w[j+28>>1]/8<<16>>16;wd:while(1){if(!C){break vd}C=C-1|0;t=0;l=0;r=0;while(1)if((t|0)==4){t=4;k=0;s=gd((r|0)/32768|0);G=gd((l|0)/32768|0);l=0;while(1)if((t|0)==7){l=gd(s+((l|0)/32768|0)|0);w[e>>1]=l;x[a>>2]=D(i,l);k=gd(G+((k|0)/32768|0)|0);w[e+2>>1]=k;x[a+4>>2]=D(i,k);a=a+8|0;e=e+4|0;continue wd}else{r=m+(t<<2)|0;n=x[r>>2]+1&8191;x[r>>2]=n;_=k;k=j+(n<<2)|0;n=w[k+160>>1];r=j+(t<<4)|0;P=w[k+162>>1];k=(_+D(n,w[r+44>>1])|0)+D(P,w[r+46>>1])|0;l=(D(n,w[r+40>>1])+l|0)+D(P,w[r+42>>1])|0;t=t+1|0;continue}}else{k=m+(t<<2)|0;n=x[k>>2]+1&8191;x[k>>2]=n;_=l;l=j+(n<<2)|0;n=w[l+160>>1];k=j+(t<<4)|0;s=w[l+162>>1];l=(_+D(n,w[k+44>>1])|0)+D(s,w[k+46>>1])|0;r=(D(n,w[k+40>>1])+r|0)+D(s,w[k+42>>1])|0;t=t+1|0;continue}}}}else{x[m+(t<<2)>>2]=k+(x[(j+(t<<4)|0)+32>>2]^-1);t=t+1|0;continue}break}fb=m+32|0;k=u+(q<<2)|0;e=b;a=f;G=g+2|0;l=x[g+4>>2];m=g+24640|0;r=g+16448|0;while(1){i=l&2047;if(a){T=g+8256|0;P=w[T+((l+1206&2047)<<2)>>1];t=g- -64|0;s=w[t+((l+1750&2047)<<2)>>1];C=w[(G+((l+754&2047)<<2)|0)+8256>>1];M=w[(G+((l+1602&2047)<<2)|0)- -64>>1];n=w[k>>1];q=w[k+2>>1];I=m+((l+502&2047)<<2)|0;L=w[I>>1];H=pd(w[g+32>>1]-L|0);I=w[I+2>>1];R=pd(w[g+34>>1]-I|0);V=w[g+26>>1];W=m+((l+22&2047)<<2)|0;Z=w[W>>1];X=pd(w[g+36>>1]-Z|0);aa=w[g+28>>1];W=w[W+2>>1];ba=pd(w[g+38>>1]-W|0);ca=w[g+30>>1];L=gd(pd((D(H,w[g+24>>1])|0)/65536<<1)+L|0);w[g+32>>1]=L;Qa=g,Ra=gd(pd((D(R,V)|0)/65536<<1)+I|0),w[Qa+34>>1]=Ra;Qa=g,Ra=gd(pd((D(X,aa)|0)/65536<<1)+Z|0),w[Qa+36>>1]=Ra;I=gd(pd((D(ba,ca)|0)/65536<<1)+W|0);w[g+38>>1]=I;L=pd((D(L,w[g+16>>1])|0)/32768|0);H=pd((D(I,w[g+22>>1])|0)/32768|0);I=pd(((n|0)/4<<16>>16)+L|0);L=pd(H+((q|0)/4<<16>>16)|0);n=w[g+8>>1];H=pd(I+((D(n,s)|0)/-65536|0)|0);_=t;t=i<<2;R=_+t|0;q=w[g+10>>1];V=pd(L+((D(q,M)|0)/-65536|0)|0);w[R+2>>1]=V;w[R>>1]=H;s=pd(s+((D(n,H)|0)/65536|0)|0);H=r+t|0;R=pd(M+((D(q,V)|0)/65536|0)|0);w[H+2>>1]=R;w[H>>1]=s;M=pd(s+I|0);I=pd(L+R|0);s=r+((l+682&2047)<<2)|0;L=w[s+2>>1];H=w[s>>1];s=pd((D(L,w[g+42>>1])+D(H,w[g+40>>1])|0)/32768|0);l=r+((l+426&2047)<<2)|0;R=w[l+2>>1];V=w[l>>1];l=pd((D(R,w[g+46>>1])+D(V,w[g+44>>1])|0)/32768|0);H=pd(pd(H+M|0)-s|0);L=pd(pd(I+L|0)-l|0);M=pd(pd(M+V|0)-s|0);I=pd(pd(I+R|0)-l|0);s=pd(s+((D(n,P)|0)/-65536|0)|0);T=t+T|0;R=pd(l+((D(q,C)|0)/-65536|0)|0);w[T+2>>1]=R;w[T>>1]=s;n=(D(n,s)|0)/65536|0;l=pd(n+P|0);t=m+t|0;q=(D(q,R)|0)/65536|0;s=pd(q+C|0);w[t+2>>1]=s;w[t>>1]=l;Qa=e,Ra=(x[e>>2]+D(pd(l+H|0),w[g+48>>1])|0)+D(pd(s+L|0),w[g+50>>1])|0,x[Qa>>2]=Ra;Qa=e,Ra=(x[e+4>>2]+D(pd(pd(n)+M|0),w[g+52>>1])|0)+D(pd(pd(q)+I|0),w[g+54>>1])|0,x[Qa+4>>2]=Ra;e=e+8|0;l=i+1|0;k=k+4|0;a=a-1|0;continue}break}x[g+4>>2]=i;x[J+76>>2]=f+x[J+76>>2]&4095;x[J+68>>2]=f+x[J+68>>2]&8191;c=c-f|0;b=(f<<3)+b|0;continue}break}x[J+68>>2]=x[J+68>>2]&8191;k=$;e=Y;a=h;f=0;g=0;l=x[J+56>>2];c=x[J- -64>>2];j=x[J+52>>2];b=x[J+60>>2];while(1){if(a){f=x[k>>2];g=x[k+4>>2];c=c-g|0;c=(((c|0)/1024|0)-c|0)+l|0;x[e+4>>2]=c+x[e+4>>2];b=b-f|0;b=(((b|0)/1024|0)-b|0)+j|0;x[e>>2]=b+x[e>>2];l=c+((c|0)/-512|0)|0;j=b+((b|0)/-512|0)|0;e=e+8|0;k=k+8|0;a=a-1|0;b=f;c=g;continue}break}x[J+64>>2]=g;x[J+60>>2]=f;x[J+56>>2]=l;x[J+52>>2]=j;a=x[J+20>>2];xd:{if(y[J+12|0]){break xd}a=x[J+16>>2];if(a>>>0>h>>>0){a=a-h|0;break xd}OP(J,ra,qa);a=0}v[J+12|0]=0;x[J+16>>2]=a}if(x[d+946300>>2]){yd:{t=0;e=0;f=o<<2;i=d+906300|0;C=z[d+480214>>1]!=0;Aa=B[d+1074336>>2];U=B[d+1074332>>2];while(1)if((t|0)==250){g=d+12|0;k=d+12300|0;m=d+14348|0;$w(g,k,m,o,U);a=d+1074476|0;u=y[a|0];v[a|0]=0;b=m;a=k;while(1){zd:{Ad:{Bd:{if((e|0)!=250){r=$d(i,e);h=x[r>>2];if(!h|!x[h+24>>2]){break zd}if(!ui(h+44|0)){break zd}l=h;Cd:{if(Dp(y[r+24|0])){break Cd}c=ib[x[x[h>>2]+148>>2]](h)|0;l=x[r>>2];if(c){break Cd}t=0;if(y[l+28|0]&2){break Cd}while(1){if((e|0)==(t|0)){break zd}c=$d(i,t);t=t+1|0;if((Jn(x[c+28>>2])|0)!=(e|0)){continue}break}}c=x[h+44>>2];n=Hc(c,0);q=Hc(c,1);s=(a|0)==(n|0);a=s?k:a;j=a;b=s?m:b;f=x[r+28>>2];c=b;Dd:{if(!f){break Dd}f=Jn(f);c=b;if(f>>>0<=e>>>0){break Dd}c=b;if(f>>>0>249){break Dd}f=x[$d(i,f)>>2];c=b;if(!f){break Dd}if(!(y[l+28|0]&4)){ib[x[x[f>>2]+152>>2]](f)}c=b;if(!ui(f+44|0)){break Dd}c=x[f+44>>2];j=Hc(c,0);c=Hc(c,1)}if(!Dp(y[r+24|0])){break Ad}t=0;Ed:{if(s){break Ed}while(1){if((o|0)==(t|0)){break Ed}f=t<<2;s=f+n|0;G=a+f|0;B[s>>2]=B[G>>2]+B[s>>2];s=f+q|0;f=b+f|0;B[s>>2]=B[f>>2]+B[s>>2];x[G>>2]=0;x[f>>2]=0;t=t+1|0;continue}}b=c;a=j;if(!(C&1)){break Ad}a=x[r>>2];if(a){ib[x[x[a>>2]+152>>2]](a)}f=Jn(x[r+28>>2]);b=e;while(1){a=f;f=a&255;if(f>>>0>249|f>>>0<=(b&255)>>>0){break Bd}t=$d(i,f);f=Jn(x[t+28>>2]);b=a;a=x[t>>2];if(!a){continue}ib[x[x[a>>2]+152>>2]](a);continue}}c=0;while(1){if((c|0)!=(o|0)){U=E(B[a>>2]*Aa);Fd:{if(E(F(U))<E(2147483648)){e=~~U;break Fd}e=-2147483648}x[g>>2]=e;U=E(B[b>>2]*Aa);Gd:{if(E(F(U))<E(2147483648)){e=~~U;break Gd}e=-2147483648}x[g+4>>2]=e;c=c+1|0;g=g+8|0;b=b+4|0;a=a+4|0;continue}break}break yd}b=c;a=j}Hd:{Id:{f=y[r+24|0];if(!UF(f)){if(!TF(f)|!(y[l+28|0]&4)){break Id}}t=0;while(1){if((o|0)==(t|0)){break Hd}f=t<<2;h=f+j|0;B[h>>2]=B[f+n>>2]+B[h>>2];h=c+f|0;B[h>>2]=B[f+q>>2]+B[h>>2];t=t+1|0;continue}}if(u){ib[x[x[h>>2]+132>>2]](h)}ib[x[x[h>>2]+60>>2]](h,j,c,o);x[l+32>>2]=o+x[l+32>>2];if(!TF(y[r+24|0])){break Hd}if((ib[x[x[h>>2]+160>>2]](h)|0)<=0){break Hd}t=0;if(A[l+32>>2]<x[d+24620>>2]<<2>>>0){break Hd}Jd:{while(1){if((o|0)==(t|0)){break Jd}f=t<<2;U=B[f+j>>2];Kd:{if(U>=E(1.1920928955078125e-7)|U<=E(-1.1920928955078125e-7)){break Kd}U=B[c+f>>2];if(U>=E(1.1920928955078125e-7)){break Kd}t=t+1|0;if(!(U<=E(-1.1920928955078125e-7))){continue}}break}x[l+32>>2]=0;break Hd}x[l+28>>2]=x[l+28>>2]|4}x[l+28>>2]=x[l+28>>2]&-3}e=e+1|0;continue}}else{h=$d(i,t);a=x[h>>2];Ld:{if(!a|!x[a+24>>2]){break Ld}if(!ui(a+44|0)){break Ld}if(!(ib[x[x[a>>2]+116>>2]](a)|0)){ib[x[x[a>>2]+112>>2]](a,1);ib[x[x[a>>2]+124>>2]](a)}c=x[a+44>>2];b=Hc(c,0);c=Hc(c,1);Md:{if(v[a+28|0]&1){$w(x[a+24>>2],b,c,o,U);break Md}g=a+40|0;if(x[g>>2]|x[a+36>>2]){Ln(x[a+24>>2],o,g,a+36|0);$w(x[a+24>>2],b,c,o,U);break Md}Rb(b,0,f);Rb(c,0,f)}b=a;a=x[a+28>>2];x[b+28>>2]=a&-2;if(Dp(y[h+24|0])){break Ld}C=!(a&4)|C}t=t+1|0;continue}}}if(x[d+24624>>2]==1){c=0;while(1){if((c|0)!=(o|0)){a=(c<<3)+Y|0;x[(c<<2)+Y>>2]=(x[a+4>>2]+x[a>>2]|0)/2;c=c+1|0;continue}break}}if(Id(y[d+1074365|0])){a=0;h=fb-16|0;fb=h;Nd:{if(!x[d+1074376>>2]){k=d+1074460|0;b=k;x[b>>2]=0;x[b+4>>2]=0;b=x[d+1074456>>2];x[d+1074468>>2]=b;break Nd}b=x[d+1074456>>2];c=x[d+1074468>>2];Od:{if((b|0)==(c|0)){e=x[d+1074460>>2];break Od}x[d+1074468>>2]=b;e=x[d+24620>>2];f=d+1074460|0;Pd:{if((b|0)>(c|0)){e=fv(e,x[d+24636>>2]);break Pd}e=fv(e,x[d+24640>>2])}x[f>>2]=e;x[d+1074464>>2]=e;c=b}k=d+1074460|0;if((e|0)<=0){break Nd}c=(c<<12)-x[d+1074472>>2]|0;a=(c|0)/(e|0)|0;if(y[d+1074368|0]!=2){break Nd}x[h+12>>2]=50;f=x[d+1074464>>2];x[h+8>>2]=1e4/(f+1|0);g=x[Xe(h+12|0,h+8|0)>>2];while(1){j=a>>31;if((g|0)>=((j^a)-j|0)){break Nd}e=e+f|0;x[k>>2]=e;a=(c|0)/(e|0)|0;continue}}Qd:{Rd:{switch(x[d+24624>>2]-1|0){case 0:g=b<<12;e=d+12|0;j=b>>31;c=0;while(1){if((c|0)==(o|0)){break Qd}Sd:{if(x[k>>2]>0){f=x[d+1074472>>2]+a|0;x[d+1074472>>2]=f;m=x[e>>2];Qa=e,Ra=Gc(Jua(Iua(m,m>>31,f,f>>31),hb,1048576,0),hb),x[Qa>>2]=Ra;x[d+1074460>>2]=x[d+1074460>>2]-1;break Sd}f=x[e>>2];Qa=e,Ra=Gc(Jua(Iua(f,f>>31,b,j),hb,256,0),hb),x[Qa>>2]=Ra;x[d+1074472>>2]=g}c=c+1|0;e=e+4|0;continue};case 1:j=b<<12;e=d+12|0;f=b>>31;c=0;while(1){if((c|0)==(o|0)){break Qd}Td:{if(x[k>>2]>0){g=x[d+1074472>>2]+a|0;x[d+1074472>>2]=g;m=x[e>>2];Qa=e,Ra=Gc(Jua(Iua(m,m>>31,g,g>>31),hb,1048576,0),hb),x[Qa>>2]=Ra;g=x[d+1074472>>2];l=g;r=g>>31;g=x[e+4>>2];Qa=e,Ra=Gc(Jua(Iua(l,r,g,g>>31),hb,1048576,0),hb),x[Qa+4>>2]=Ra;x[d+1074460>>2]=x[d+1074460>>2]-1;break Td}g=x[e>>2];Qa=e,Ra=Gc(Jua(Iua(g,g>>31,b,f),hb,256,0),hb),x[Qa>>2]=Ra;g=x[e+4>>2];Qa=e,Ra=Gc(Jua(Iua(g,g>>31,b,f),hb,256,0),hb),x[Qa+4>>2]=Ra;x[d+1074472>>2]=j}c=c+1|0;e=e+8|0;continue};case 3:break Rd;default:break Qd}}m=b<<12;e=d+8204|0;c=d+12|0;f=b;g=b>>31;b=0;while(1){if((b|0)==(o|0)){break Qd}Ud:{if(x[k>>2]>0){j=x[d+1074472>>2]+a|0;x[d+1074472>>2]=j;l=x[c>>2];Qa=c,Ra=Gc(Jua(Iua(l,l>>31,j,j>>31),hb,1048576,0),hb),x[Qa>>2]=Ra;j=x[d+1074472>>2];l=j;r=j>>31;j=x[c+4>>2];Qa=c,Ra=Gc(Jua(Iua(l,r,j,j>>31),hb,1048576,0),hb),x[Qa+4>>2]=Ra;j=x[d+1074472>>2];l=j;r=j>>31;j=x[e>>2];Qa=e,Ra=Gc(Jua(Iua(l,r,j,j>>31),hb,1048576,0),hb),x[Qa>>2]=Ra;j=x[d+1074472>>2];l=j;r=j>>31;j=x[e+4>>2];Qa=e,Ra=Gc(Jua(Iua(l,r,j,j>>31),hb,1048576,0),hb),x[Qa+4>>2]=Ra;x[d+1074460>>2]=x[d+1074460>>2]-1;break Ud}j=x[c>>2];Qa=c,Ra=Gc(Jua(Iua(j,j>>31,f,g),hb,256,0),hb),x[Qa>>2]=Ra;j=x[c+4>>2];Qa=c,Ra=Gc(Jua(Iua(j,j>>31,f,g),hb,256,0),hb),x[Qa+4>>2]=Ra;j=x[e>>2];Qa=e,Ra=Gc(Jua(Iua(j,j>>31,f,g),hb,256,0),hb),x[Qa>>2]=Ra;j=x[e+4>>2];Qa=e,Ra=Gc(Jua(Iua(j,j>>31,f,g),hb,256,0),hb),x[Qa+4>>2]=Ra;x[d+1074472>>2]=m}b=b+1|0;e=e+8|0;c=c+8|0;continue}}fb=h+16|0}if(x[oa>>2]!=128){b=d+12|0;c=d+8204|0;a=x[d+24604>>2];e=x[d+24624>>2];Vd:{if((a|0)==128|e>>>0<2){break Vd}LR(b,o,a);if(e>>>0<4){break Vd}LR(c,o,a)}}b=x[d+24624>>2];if((b|0)==4){b=o;while(1){b=b-1|0;if((b|0)>=0){a=(b<<4)+Y|0;c=b<<3;e=c|4;x[a+12>>2]=x[e+pa>>2];x[a+8>>2]=x[c+pa>>2];x[a+4>>2]=x[e+Y>>2];x[a>>2]=x[c+Y>>2];continue}break}b=x[d+24624>>2]}if(Id(Ca)){x[K- -64>>2]=o;x[K+60>>2]=b;x[K+56>>2]=Y;a=x[x[ma>>2]+8>>2];x[K+24>>2]=o;b=x[K+60>>2];x[K+16>>2]=x[K+56>>2];x[K+20>>2]=b;ib[a|0](ma,K+16|0);b=x[d+24624>>2]}x[K+52>>2]=o;x[K+48>>2]=b;x[K+44>>2]=Y;a=x[x[la>>2]+8>>2];x[K+8>>2]=o;b=x[K+48>>2];x[K>>2]=x[K+44>>2];x[K+4>>2]=b;ib[a|0](la,K);x[d+1074380>>2]=x[d+1074380>>2]-o;x[d+1074376>>2]=o+x[d+1074376>>2];ha=ha-o|0;Ba=o+Ba|0;continue}break}fb=ea+32|0;return Ba}function dg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=E(0),o=0,q=0,s=0,t=0,u=E(0),G=0,H=0,I=0,J=E(0),K=0,L=0,M=0,O=0,V=0;s=fb-2240|0;fb=s;a:{b:{c:{d:{e:{f:{g:{if(bx(x[c>>2])){xc(b,268435456);L=x[c+8>>2];I=s+2220|0;e=I;x[e>>2]=0;x[e+4>>2]=0;Nb(e+8|0);h:{i:{j:{k:{l:{e=y[a+3|0];m:{n:{if((e-4&255)>>>0<=4){x[31609]=0;j=R(202,c|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break n}break b}if(e>>>0>17){break m}o:{d=1<<e;if(!(d&63503)){if(!(d&198144)){break m}break o}if(y[a|0]){break o}break n}e=0;f=AD(a,x[b>>2]);x[31609]=0;d=s+48|0;S(186,d|0,c|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break l}f=x[d+4>>2];x[I>>2]=x[d>>2];x[I+4>>2]=f;An(I+8|0,d+8|0);Kc(d);f=Ze(I);if(!f){break h}j=x[I>>2]}e=y[a+3|0]}p:{q:{switch(e&255){case 0:case 1:case 2:case 3:case 11:case 12:case 13:case 14:case 15:h=y[a|0];break p;case 9:case 10:case 16:case 17:break q;default:break p}}h=8}d=!h;h=x[b>>2];if(!(d|h>>>0<262145)){d=e&255;x[s+48>>2]=((d|0)==10)<<4;x[s+28>>2]=j;k=j-x[Hb(s+48|0,s+28|0)>>2]|0;if(d>>>0>15){break k}r:{if(!(1<<d&63503)){if((d|0)==10){break r}break k}if(!(y[a|0]&7)){break k}}e=(k|0)<0?-1:k<<1;break j}e=e&255;if(e>>>0>8){break i}if(!(1<<e&432)){if((e|0)!=6){break i}e=0;if(j>>>0<10){break h}x[31609]=0;P(183,c|0,4)|0;e=x[31609];x[31609]=0;if((e|0)==1){break b}x[31609]=0;d=R(151,c|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){x[s+48>>2]=d;x[s+28>>2]=j;e=x[Hb(s+48|0,s+28|0)>>2];Ih(c,8);e=((e>>>0>50529027?-1:D(e,85))>>>0)/(y[a|0]>>>3>>>0)|0;break j}a=N()|0;break a}d=8/(ir(y[a+1|0])>>>0)|0;e=D(d,j);Iua(d,0,j,0);e=hb?-1:e;break j}a=N()|0;break a}h=0;e=ir(y[a+1|0]);s:{t:{switch(d|0){case 0:case 1:case 2:case 3:case 11:case 12:case 13:case 14:case 15:h=y[a|0];break s;case 9:h=16;break s;case 10:h=4;break s;case 16:case 17:break t;default:break s}}h=8}d=D(e,h)>>>3|0;e=(d+k|0)-1|0;e=((e>>>0<k>>>0?-1:e)>>>0)/(d>>>0)|0}xc(b,e);h=x[b>>2]}if(!h){e=0;break h}w[b+34>>1]=z[b+34>>1]&65470|y[a|0]>15|(y[a+1|0]!=1)<<6;if(!Gh(b)){e=0;x[b>>2]=0;break h}u:{e=s+48|0;if(oe(a,Zc(e,8,1,0,10))){x[31609]=0;d=P(203,c|0,e|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){e=0;if(!d){break u}a=x[b>>2];h=0;x[31609]=0;x[s+28>>2]=a+1>>>1;e=R(202,c|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}xc(s+28|0,e);a=f+16|0;b=x[b+20>>2];g=x[s+28>>2];e=g;while(1)if(e){d=s+48|0;f=y[d|y[a|0]&15]+h|0;v[b|0]=f;h=y[d|y[a|0]>>>4]+(f&255)|0;v[b+1|0]=h;e=e-1|0;a=a+1|0;b=b+2|0;continue}else{e=g+16|0;break u}}a=N()|0;break a}v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{h=y[a+3|0];switch(h-4|0){case 3:break B;case 4:break E;case 5:break F;case 2:break G;case 0:case 1:break H;default:break D}}x[31609]=0;b=ba(204,s+1132|0,c|0,b|0,(h|0)==5|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break g}ub(b);e=x[c+8>>2]-L|0;break u}if(y[a+1|0]!=1){break C}x[31609]=0;P(183,c|0,4)|0;a=x[31609];x[31609]=0;if((a|0)==1){break g}x[31609]=0;e=R(151,c|0)|0;a=x[31609];x[31609]=0;I:{J:{K:{if((a|0)!=1){x[31609]=0;x[s+28>>2]=e;f=R(197,c|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break K}x[31609]=0;d=s+48|0;S(205,d|0,c|0,e|0);a=x[31609];x[31609]=0;if((a|0)==1){break J}xc(s+28|0,x[s+48>>2]);e=x[s+28>>2];Nn(s+1124|0,d);cc(s+1116|0,x[b+20>>2],Rk(x[b>>2],z[b+34>>1]));x[31609]=0;aa(206,x[s+1124>>2],x[s+1128>>2],x[s+1116>>2],x[s+1120>>2],f<<24>>24);a=x[31609];x[31609]=0;if((a|0)==1){break I}e=e+9|0;Kc(d);break u}a=N()|0;break a}a=N()|0;break a}a=N()|0;break a}a=N()|0;Kc(s+48|0);break a}if(y[a+1|0]!=1|y[a|0]!=16){break C}e=Yk(s+1114|0);a=x[b>>2];d=x[b+20>>2];e=z[e>>1];h=fb-16|0;fb=h;x[h+12>>2]=j>>>1;x[h+8>>2]=a;b=x[Hb(h+12|0,h+8|0)>>2];g=b;while(1){if(g){a=y[f|0]+e|0;e=a+y[f+1|0]|0;w[d>>1]=e<<8|a&255;d=d+2|0;f=f+2|0;g=g-1|0;continue}break}fb=h+16|0;e=b<<1;break u}if(y[a+1|0]!=1|y[a|0]>16){break C}d=x[c+8>>2];f=x[c>>2];e=0;x[31609]=0;d=U(150,f|0,d|0,8)|0;f=x[31609];x[31609]=0;if((f|0)==1){break g}if(!d){break u}x[31609]=0;d=R(151,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break g}if(d>>>0<4){break u}x[31609]=0;f=s+28|0;S(185,f|0,c|0,d|0);e=x[31609];x[31609]=0;if((e|0)==1){break d}o=ls(s+48|0,f);ub(f);e=x[o>>2];x[31609]=0;f=R(207,e|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break f}e=f+4|0;k=y[a|0];h=(k|0)!=16;f=0;while(1){if(A[b>>2]<=f>>>0){break w}L:{if(h){break L}x[31609]=0;i=P(158,o|0,8)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break L}a=T(28816)|0;break x}x[31609]=0;g=P(158,o|0,1)|0;a=x[31609];x[31609]=0;if((a|0)==1){break y}x[31609]=0;d=P(158,o|0,1)|0;a=x[31609];x[31609]=0;if((a|0)==1){break y}M:{N:{O:{if(!d){j=8;while(1){x[31609]=0;d=P(158,o|0,1)|0;a=x[31609];x[31609]=0;if((a|0)==1){break M}if(d){break O}j=j+16|0;continue}}x[31609]=0;a=P(158,o|0,3)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break N}break y}x[31609]=0;d=P(158,o|0,4)|0;a=x[31609];x[31609]=0;if((a|0)==1){break y}a=d+j|0}t=(t&255)+(((g?-1:0)^a)&255)|0;P:{if((k|0)!=16){v[x[b+20>>2]+f|0]=t;break P}w[x[b+20>>2]+(f<<1)>>1]=i&255|t<<8}f=f+1|0;continue}break}a=T(28816)|0;break x}Q:{if((h|0)==16){e=y[a|0];break Q}e=y[a|0];if((h|0)!=17){break z}}if((e&255)!=16){break z}d=y[a+1|0];if((d-1&255)>>>0>1){break z}M=s,O=D(x[b>>2],ir(d)),x[M+48>>2]=O;xc(s+48|0,j);a=x[b+20>>2];e=x[s+48>>2];if((h|0)==16){b=e;while(1){if(!b){break u}M=a,O=z[bc(28848,y[f|0])>>1],w[M>>1]=O;a=a+2|0;f=f+1|0;b=b-1|0;continue}}b=e;while(1){if(!b){break u}M=a,O=z[bc(29360,y[f|0])>>1],w[M>>1]=O;a=a+2|0;f=f+1|0;b=b-1|0;continue}}if((h|0)!=7){break A}}if(y[a+1|0]!=1|y[a|0]>16){break A}e=0;if(j>>>0<5){break u}f=x[b+20>>2];e=z[b+34>>1];a=x[b>>2];x[31609]=0;e=U(208,c|0,f|0,Rk(a,e)|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break u}break g}e=y[a|0]}d=(e&255)!=8;if(!(d|y[a+1|0]!=1)){R:{switch(h|0){case 0:a=x[b>>2];e=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){v[e|0]=y[f|0];e=e+1|0;f=f+1|0;b=b-1|0;continue}break};fb=d+16|0;e=a;break u;case 1:a=x[b>>2];e=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){v[e|0]=y[f|0]^128;e=e+1|0;f=f+1|0;b=b-1|0;continue}break};fb=d+16|0;e=a;break u;default:e=0;if((h|0)!=11){break u}break;case 2:break R}}e=uv(s+27|0);a=x[b>>2];g=x[b+20>>2];b=y[e|0];d=fb-16|0;fb=d;x[d+12>>2]=j;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){b=y[f|0]+b|0;v[g|0]=b;g=g+1|0;f=f+1|0;e=e-1|0;continue}break}fb=d+16|0;e=a;break u}if(!(y[a+1|0]!=3|d)){S:{switch(h|0){case 0:i=fb-16|0;fb=i;x[i+12>>2]=j;e=x[b>>2];x[i+8>>2]=e;a=i+8|0;g=x[Hb(a,i+12|0)>>2];x[i+8>>2]=e;x[i+4>>2]=j-g;e=x[Hb(a,i+4|0)>>2];h=x[b+20>>2];a=g;d=f;while(1){if(a){v[h|0]=y[d|0];h=h+2|0;d=d+1|0;a=a-1|0;continue}break};h=x[b+20>>2]+1|0;d=x[b>>2]+f|0;a=e;while(1){if(a){v[h|0]=y[d|0];h=h+2|0;d=d+1|0;a=a-1|0;continue}break};fb=i+16|0;e=e+g|0;break u;case 1:i=fb-16|0;fb=i;x[i+12>>2]=j;e=x[b>>2];x[i+8>>2]=e;a=i+8|0;g=x[Hb(a,i+12|0)>>2];x[i+8>>2]=e;x[i+4>>2]=j-g;e=x[Hb(a,i+4|0)>>2];h=x[b+20>>2];a=g;d=f;while(1){if(a){v[h|0]=y[d|0]^128;h=h+2|0;d=d+1|0;a=a-1|0;continue}break};h=x[b+20>>2]+1|0;d=x[b>>2]+f|0;a=e;while(1){if(a){v[h|0]=y[d|0]^128;h=h+2|0;d=d+1|0;a=a-1|0;continue}break};fb=i+16|0;e=e+g|0;break u;default:e=0;if((h|0)!=11){break u}break;case 2:break S}}g=y[uv(s+26|0)|0];k=fb-16|0;fb=k;x[k+12>>2]=j;d=x[b>>2];x[k+8>>2]=d;e=k+8|0;h=x[Hb(e,k+12|0)>>2];x[k+8>>2]=d;x[k+4>>2]=j-h;d=x[Hb(e,k+4|0)>>2];j=b;t=x[b+20>>2];e=g;b=h;i=f;while(1){if(b){e=y[i|0]+e|0;v[t|0]=e;t=t+2|0;i=i+1|0;b=b-1|0;continue}break}t=x[j+20>>2]+1|0;i=x[j>>2]+f|0;b=d;while(1){if(b){g=y[i|0]+g|0;v[t|0]=g;t=t+2|0;i=i+1|0;b=b-1|0;continue}break}fb=k+16|0;e=d+h|0;if(y[a+3|0]!=11){break u}a=x[j+20>>2];b=a+(x[j>>2]<<1)|0;while(1){if(a>>>0>=b>>>0){break u}v[a+1|0]=y[a+1|0]+y[a|0];a=a+2|0;continue}}d=e&255;if(!((d|0)!=8|y[a+1|0]!=2)){e=0;T:{switch(h|0){case 0:a=x[b>>2];e=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>1;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){v[e|0]=y[f|0];v[e+1|0]=y[f+1|0];e=e+2|0;f=f+2|0;b=b-1|0;continue}break};fb=d+16|0;e=a<<1;break u;case 1:a=x[b>>2];e=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>1;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){v[e|0]=y[f|0]^128;v[e+1|0]=y[f+1|0]^128;e=e+2|0;f=f+2|0;b=b-1|0;continue}break};fb=d+16|0;e=a<<1;break u;case 2:break T;default:break u}}e=uv(s+25|0);a=x[b>>2];d=x[b+20>>2];b=y[e|0];h=fb-16|0;fb=h;x[h+12>>2]=j>>>1;x[h+8>>2]=a;a=b;e=x[Hb(h+12|0,h+8|0)>>2];g=e;while(1){if(g){b=y[f|0]+b|0;v[d|0]=b;a=y[f+1|0]+a|0;v[d+1|0]=a;d=d+2|0;f=f+2|0;g=g-1|0;continue}break}fb=h+16|0;e=e<<1;break u}if(!(y[a+2|0]|((d|0)!=16|y[a+1|0]!=1))){U:{switch(h|0){case 0:a=x[b>>2];e=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>1;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){w[e>>1]=y[f|0]|y[f+1|0]<<8;e=e+2|0;f=f+2|0;b=b-1|0;continue}break};fb=d+16|0;e=a<<1;break u;case 1:a=x[b>>2];e=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>1;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){w[e>>1]=(y[f|0]|y[f+1|0]<<8)^32768;e=e+2|0;f=f+2|0;b=b-1|0;continue}break};fb=d+16|0;e=a<<1;break u;default:e=0;if((h|0)!=11){break u}break;case 2:break U}}e=Yk(s+22|0);a=x[b>>2];g=x[b+20>>2];b=z[e>>1];d=fb-16|0;fb=d;x[d+12>>2]=j>>>1;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){b=(y[f|0]+b|0)+(y[f+1|0]<<8)|0;w[g>>1]=b;g=g+2|0;f=f+2|0;e=e-1|0;continue}break}fb=d+16|0;e=a<<1;break u}d=e&255;if(!((d|0)!=16|y[a+1|0]!=1|y[a+2|0]!=1)){e=0;V:{switch(h|0){case 0:a=x[b>>2];g=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>1;x[d+8>>2]=a;b=x[Hb(d+12|0,d+8|0)>>2];e=b;while(1){if(e){a=y[f|0]|y[f+1|0]<<8;w[g>>1]=a<<8|a>>>8;g=g+2|0;f=f+2|0;e=e-1|0;continue}break};fb=d+16|0;e=b<<1;break u;case 1:a=x[b>>2];g=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>1;x[d+8>>2]=a;b=x[Hb(d+12|0,d+8|0)>>2];e=b;while(1){if(e){a=y[f|0]|y[f+1|0]<<8;w[g>>1]=(a<<8|a>>>8)^32768;g=g+2|0;f=f+2|0;e=e-1|0;continue}break};fb=d+16|0;e=b<<1;break u;case 2:break V;default:break u}}e=Yk(s+20|0);a=x[b>>2];g=x[b+20>>2];b=z[e>>1];d=fb-16|0;fb=d;x[d+12>>2]=j>>>1;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){b=(y[f+1|0]+b|0)+(y[f|0]<<8)|0;w[g>>1]=b;g=g+2|0;f=f+2|0;e=e-1|0;continue}break}fb=d+16|0;e=a<<1;break u}if(!(y[a+2|0]|((d|0)!=16|y[a+1|0]!=3))){W:{switch(h|0){case 0:k=fb-16|0;fb=k;x[k+12>>2]=j;i=x[b>>2]<<1;x[k+8>>2]=i;a=k+8|0;e=x[Hb(a,k+12|0)>>2];x[k+8>>2]=i;x[k+4>>2]=j-e;a=x[Hb(a,k+4|0)>>2];g=x[b+20>>2];e=e>>>1|0;h=e;d=f;while(1){if(h){w[g>>1]=y[d|0]|y[d+1|0]<<8;g=g+4|0;d=d+2|0;h=h-1|0;continue}break};g=f+i|0;d=x[b+20>>2]+2|0;a=a>>>1|0;h=a;while(1){if(h){w[d>>1]=y[g|0]|y[g+1|0]<<8;d=d+4|0;g=g+2|0;h=h-1|0;continue}break};fb=k+16|0;e=a+e<<1;break u;case 1:k=fb-16|0;fb=k;x[k+12>>2]=j;i=x[b>>2]<<1;x[k+8>>2]=i;a=k+8|0;e=x[Hb(a,k+12|0)>>2];x[k+8>>2]=i;x[k+4>>2]=j-e;a=x[Hb(a,k+4|0)>>2];g=x[b+20>>2];e=e>>>1|0;h=e;d=f;while(1){if(h){w[g>>1]=(y[d|0]|y[d+1|0]<<8)^32768;g=g+4|0;d=d+2|0;h=h-1|0;continue}break};g=f+i|0;d=x[b+20>>2]+2|0;a=a>>>1|0;h=a;while(1){if(h){w[d>>1]=(y[g|0]|y[g+1|0]<<8)^32768;d=d+4|0;g=g+2|0;h=h-1|0;continue}break};fb=k+16|0;e=a+e<<1;break u;default:e=0;if((h|0)!=11){break u}break;case 2:break W}}g=z[Yk(s+18|0)>>1];o=fb-16|0;fb=o;x[o+12>>2]=j;k=x[b>>2]<<1;x[o+8>>2]=k;e=o+8|0;d=x[Hb(e,o+12|0)>>2];x[o+8>>2]=k;x[o+4>>2]=j-d;h=x[Hb(e,o+4|0)>>2];t=x[b+20>>2];e=g;d=d>>>1|0;i=d;j=f;while(1){if(i){e=(y[j|0]+e|0)+(y[j+1|0]<<8)|0;w[t>>1]=e;t=t+4|0;j=j+2|0;i=i-1|0;continue}break}j=f+k|0;t=x[b+20>>2]+2|0;e=h>>>1|0;i=e;while(1){if(i){g=(y[j|0]+g|0)+(y[j+1|0]<<8)|0;w[t>>1]=g;t=t+4|0;j=j+2|0;i=i-1|0;continue}break}fb=o+16|0;e=d+e<<1;if(y[a+3|0]!=11){break u}a=x[b+20>>2];b=a+(x[b>>2]<<2)|0;while(1){if(a>>>0>=b>>>0){break u}w[a+2>>1]=z[a+2>>1]+z[a>>1];a=a+4|0;continue}}d=e&255;if(!((d|0)!=16|y[a+1|0]!=3|y[a+2|0]!=1)){e=0;X:{switch(h|0){case 0:o=fb-16|0;fb=o;x[o+12>>2]=j;k=x[b>>2]<<1;x[o+8>>2]=k;a=o+8|0;e=x[Hb(a,o+12|0)>>2];x[o+8>>2]=k;x[o+4>>2]=j-e;d=x[Hb(a,o+4|0)>>2];i=x[b+20>>2];e=e>>>1|0;g=e;h=f;while(1){if(g){a=y[h|0]|y[h+1|0]<<8;w[i>>1]=a<<8|a>>>8;i=i+4|0;h=h+2|0;g=g-1|0;continue}break};i=f+k|0;h=x[b+20>>2]+2|0;b=d>>>1|0;g=b;while(1){if(g){a=y[i|0]|y[i+1|0]<<8;w[h>>1]=a<<8|a>>>8;h=h+4|0;i=i+2|0;g=g-1|0;continue}break};fb=o+16|0;e=b+e<<1;break u;case 1:o=fb-16|0;fb=o;x[o+12>>2]=j;k=x[b>>2]<<1;x[o+8>>2]=k;a=o+8|0;e=x[Hb(a,o+12|0)>>2];x[o+8>>2]=k;x[o+4>>2]=j-e;d=x[Hb(a,o+4|0)>>2];i=x[b+20>>2];e=e>>>1|0;g=e;h=f;while(1){if(g){a=y[h|0]|y[h+1|0]<<8;w[i>>1]=(a<<8|a>>>8)^32768;i=i+4|0;h=h+2|0;g=g-1|0;continue}break};i=f+k|0;h=x[b+20>>2]+2|0;b=d>>>1|0;g=b;while(1){if(g){a=y[i|0]|y[i+1|0]<<8;w[h>>1]=(a<<8|a>>>8)^32768;h=h+4|0;i=i+2|0;g=g-1|0;continue}break};fb=o+16|0;e=b+e<<1;break u;case 2:break X;default:break u}}e=z[Yk(s+16|0)>>1];o=fb-16|0;fb=o;x[o+12>>2]=j;k=x[b>>2]<<1;x[o+8>>2]=k;a=o+8|0;d=x[Hb(a,o+12|0)>>2];x[o+8>>2]=k;x[o+4>>2]=j-d;j=x[Hb(a,o+4|0)>>2];i=x[b+20>>2];a=e;h=d>>>1|0;g=h;d=f;while(1){if(g){a=(y[d+1|0]+a|0)+(y[d|0]<<8)|0;w[i>>1]=a;i=i+4|0;d=d+2|0;g=g-1|0;continue}break}d=f+k|0;i=x[b+20>>2]+2|0;a=j>>>1|0;g=a;while(1){if(g){e=(y[d+1|0]+e|0)+(y[d|0]<<8)|0;w[i>>1]=e;i=i+4|0;d=d+2|0;g=g-1|0;continue}break}fb=o+16|0;e=a+h<<1;break u}if(!(y[a+2|0]|((d|0)!=16|y[a+1|0]!=2))){e=0;Y:{switch(h|0){case 0:a=x[b>>2];e=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>2;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){w[e>>1]=y[f|0]|y[f+1|0]<<8;w[e+2>>1]=y[f+2|0]|y[f+3|0]<<8;e=e+4|0;f=f+4|0;b=b-1|0;continue}break};fb=d+16|0;e=a<<2;break u;case 1:a=x[b>>2];e=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>2;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){w[e>>1]=(y[f|0]|y[f+1|0]<<8)^32768;w[e+2>>1]=(y[f+2|0]|y[f+3|0]<<8)^32768;e=e+4|0;f=f+4|0;b=b-1|0;continue}break};fb=d+16|0;e=a<<2;break u;case 2:break Y;default:break u}}e=Yk(s+14|0);a=x[b>>2];d=x[b+20>>2];b=z[e>>1];h=fb-16|0;fb=h;x[h+12>>2]=j>>>2;x[h+8>>2]=a;a=b;e=x[Hb(h+12|0,h+8|0)>>2];g=e;while(1){if(g){b=(y[f|0]+b|0)+(y[f+1|0]<<8)|0;w[d>>1]=b;a=(y[f+2|0]+a|0)+(y[f+3|0]<<8)|0;w[d+2>>1]=a;d=d+4|0;f=f+4|0;g=g-1|0;continue}break}fb=h+16|0;e=e<<2;break u}d=e&255;if(!((d|0)!=16|y[a+1|0]!=2|y[a+2|0]!=1)){e=0;Z:{switch(h|0){case 0:a=x[b>>2];g=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>2;x[d+8>>2]=a;b=x[Hb(d+12|0,d+8|0)>>2];e=b;while(1){if(e){a=y[f|0]|y[f+1|0]<<8;w[g>>1]=a<<8|a>>>8;a=y[f+2|0]|y[f+3|0]<<8;w[g+2>>1]=a<<8|a>>>8;g=g+4|0;f=f+4|0;e=e-1|0;continue}break};fb=d+16|0;e=b<<2;break u;case 1:a=x[b>>2];g=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>2;x[d+8>>2]=a;b=x[Hb(d+12|0,d+8|0)>>2];e=b;while(1){if(e){a=y[f|0]|y[f+1|0]<<8;w[g>>1]=(a<<8|a>>>8)^32768;a=y[f+2|0]|y[f+3|0]<<8;w[g+2>>1]=(a<<8|a>>>8)^32768;g=g+4|0;f=f+4|0;e=e-1|0;continue}break};fb=d+16|0;e=b<<2;break u;case 2:break Z;default:break u}}e=Yk(s+12|0);a=x[b>>2];d=x[b+20>>2];b=z[e>>1];h=fb-16|0;fb=h;x[h+12>>2]=j>>>2;x[h+8>>2]=a;a=b;e=x[Hb(h+12|0,h+8|0)>>2];g=e;while(1){if(g){b=(y[f+1|0]+b|0)+(y[f|0]<<8)|0;w[d>>1]=b;a=(y[f+3|0]+a|0)+(y[f+2|0]<<8)|0;w[d+2>>1]=a;d=d+4|0;f=f+4|0;g=g-1|0;continue}break}fb=h+16|0;e=e<<2;break u}if(!(h|y[a+1|0]!=1|(d|0)!=24)){e=x[b+20>>2];b=x[b>>2];if(!y[a+2|0]){d=fb-16|0;fb=d;x[d+12>>2]=(j>>>0)/3;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){M=e,O=rd(y[f+1|0]<<16|y[f|0]<<8|y[f+2|0]<<24,16),w[M>>1]=O;e=e+2|0;f=f+3|0;b=b-1|0;continue}break}fb=d+16|0;e=D(a,3);break u}d=fb-16|0;fb=d;x[d+12>>2]=(j>>>0)/3;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){M=e,O=rd(y[f+1|0]<<16|y[f+2|0]<<8|y[f|0]<<24,16),w[M>>1]=O;e=e+2|0;f=f+3|0;b=b-1|0;continue}break}fb=d+16|0;e=D(a,3);break u}d=e&255;if(!(h|y[a+1|0]!=2|(d|0)!=24)){e=x[b+20>>2];b=x[b>>2];if(!y[a+2|0]){d=fb-16|0;fb=d;x[d+12>>2]=(j>>>0)/6;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){M=e,O=rd(y[f+1|0]<<16|y[f|0]<<8|y[f+2|0]<<24,16),w[M>>1]=O;M=e,O=rd(y[f+4|0]<<16|y[f+3|0]<<8|y[f+5|0]<<24,16),w[M+2>>1]=O;e=e+4|0;f=f+6|0;b=b-1|0;continue}break}fb=d+16|0;e=D(a,6);break u}d=fb-16|0;fb=d;x[d+12>>2]=(j>>>0)/6;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){M=e,O=rd(y[f+1|0]<<16|y[f+2|0]<<8|y[f|0]<<24,16),w[M>>1]=O;M=e,O=rd(y[f+4|0]<<16|y[f+5|0]<<8|y[f+3|0]<<24,16),w[M+2>>1]=O;e=e+4|0;f=f+6|0;b=b-1|0;continue}break}fb=d+16|0;e=D(a,6);break u}if(!(h|y[a+1|0]!=1|(d|0)!=32)){e=x[b+20>>2];b=x[b>>2];if(!y[a+2|0]){d=fb-16|0;fb=d;x[d+12>>2]=j>>>2;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){M=e,O=rd(y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24),16),w[M>>1]=O;e=e+2|0;f=f+4|0;b=b-1|0;continue}break}fb=d+16|0;e=a<<2;break u}d=fb-16|0;fb=d;x[d+12>>2]=j>>>2;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];g=a;while(1){if(g){b=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);M=e,O=rd(b<<24|(b&65280)<<8|(b>>>8&65280|b>>>24),16),w[M>>1]=O;e=e+2|0;f=f+4|0;g=g-1|0;continue}break}fb=d+16|0;e=a<<2;break u}d=e&255;if(!(h|y[a+1|0]!=2|(d|0)!=32)){e=x[b+20>>2];b=x[b>>2];if(!y[a+2|0]){d=fb-16|0;fb=d;x[d+12>>2]=j>>>3;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){M=e,O=rd(y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24),16),w[M>>1]=O;M=e,O=rd(y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24),16),w[M+2>>1]=O;e=e+4|0;f=f+8|0;b=b-1|0;continue}break}fb=d+16|0;e=a<<3;break u}d=fb-16|0;fb=d;x[d+12>>2]=j>>>3;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];g=a;while(1){if(g){b=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);M=e,O=rd(b<<24|(b&65280)<<8|(b>>>8&65280|b>>>24),16),w[M>>1]=O;b=y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24);M=e,O=rd(b<<24|(b&65280)<<8|(b>>>8&65280|b>>>24),16),w[M+2>>1]=O;e=e+4|0;f=f+8|0;g=g-1|0;continue}break}fb=d+16|0;e=a<<3;break u}if(!(h|y[a+1|0]!=1|(d|0)!=64)){e=x[b+20>>2];b=x[b>>2];if(!y[a+2|0]){d=fb-16|0;fb=d;x[d+12>>2]=j>>>3;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){M=e,O=Sc(y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24),y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24),48),w[M>>1]=O;e=e+2|0;f=f+8|0;b=b-1|0;continue}break}fb=d+16|0;e=a<<3;break u}k=fb-16|0;fb=k;x[k+12>>2]=j>>>3;x[k+8>>2]=b;h=x[Hb(k+12|0,k+8|0)>>2];b=h;while(1){if(b){i=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);g=i<<24|(i&65280)<<8;a=i&-16777216;d=a>>>24|0;o=a<<8;a=i&16711680;j=y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24);M=e,O=Sc(o|a<<24|(((j&255)<<24|i>>>8)&-16777216|((j&16777215)<<8|i>>>24)&16711680|(j>>>8&65280|j>>>24)),g|(d|a>>>8),48),w[M>>1]=O;e=e+2|0;f=f+8|0;b=b-1|0;continue}break}fb=k+16|0;e=h<<3;break u}d=e&255;if(!(h|y[a+1|0]!=2|(d|0)!=64)){e=x[b+20>>2];b=x[b>>2];if(!y[a+2|0]){d=fb-16|0;fb=d;x[d+12>>2]=j>>>4;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){M=e,O=Sc(y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24),y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24),48),w[M>>1]=O;M=e,O=Sc(y[f+8|0]|y[f+9|0]<<8|(y[f+10|0]<<16|y[f+11|0]<<24),y[f+12|0]|y[f+13|0]<<8|(y[f+14|0]<<16|y[f+15|0]<<24),48),w[M+2>>1]=O;e=e+4|0;f=f+16|0;b=b-1|0;continue}break}fb=d+16|0;e=a<<4;break u}k=fb-16|0;fb=k;x[k+12>>2]=j>>>4;x[k+8>>2]=b;h=x[Hb(k+12|0,k+8|0)>>2];b=h;while(1){if(b){i=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);g=i<<24|(i&65280)<<8;a=i&-16777216;d=a>>>24|0;o=a<<8;a=i&16711680;j=y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24);M=e,O=Sc(o|a<<24|(((j&255)<<24|i>>>8)&-16777216|((j&16777215)<<8|i>>>24)&16711680|(j>>>8&65280|j>>>24)),g|(d|a>>>8),48),w[M>>1]=O;i=y[f+8|0]|y[f+9|0]<<8|(y[f+10|0]<<16|y[f+11|0]<<24);g=i<<24|(i&65280)<<8;a=i&-16777216;d=a>>>24|0;o=a<<8;a=i&16711680;j=y[f+12|0]|y[f+13|0]<<8|(y[f+14|0]<<16|y[f+15|0]<<24);M=e,O=Sc(o|a<<24|(((j&255)<<24|i>>>8)&-16777216|((j&16777215)<<8|i>>>24)&16711680|(j>>>8&65280|j>>>24)),g|(d|a>>>8),48),w[M+2>>1]=O;e=e+4|0;f=f+16|0;b=b-1|0;continue}break}fb=k+16|0;e=h<<4;break u}if(!(y[a+1|0]!=1|(h|0)!=3|(d|0)!=32)){e=x[b+20>>2];b=x[b>>2];if(!y[a+2|0]){d=fb-16|0;fb=d;x[d+12>>2]=j>>>2;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){m=ag((l(2,y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24)),r()));m=ni(E(Pd(Kg(m)?m>=E(0)?E(1):E(-1):m,E(-1))*E(32768)));_:{if(E(F(m))<E(2147483648)){g=~~m;break _}g=-2147483648}M=e,O=gd(g),w[M>>1]=O;e=e+2|0;f=f+4|0;b=b-1|0;continue}break}fb=d+16|0;e=a<<2;break u}d=fb-16|0;fb=d;x[d+12>>2]=j>>>2;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];g=a;while(1){if(g){b=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);m=ag((l(2,b<<24|(b&65280)<<8|(b>>>8&65280|b>>>24)),r()));m=ni(E(Pd(Kg(m)?m>=E(0)?E(1):E(-1):m,E(-1))*E(32768)));$:{if(E(F(m))<E(2147483648)){b=~~m;break $}b=-2147483648}M=e,O=gd(b),w[M>>1]=O;e=e+2|0;f=f+4|0;g=g-1|0;continue}break}fb=d+16|0;e=a<<2;break u}d=e&255;if(!(y[a+1|0]!=2|(h|0)!=3|(d|0)!=32)){e=x[b+20>>2];b=x[b>>2];if(!y[a+2|0]){d=fb-16|0;fb=d;x[d+12>>2]=j>>>3;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){m=ag((l(2,y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24)),r()));m=ni(E(Pd(Kg(m)?m>=E(0)?E(1):E(-1):m,E(-1))*E(32768)));aa:{if(E(F(m))<E(2147483648)){g=~~m;break aa}g=-2147483648}M=e,O=gd(g),w[M>>1]=O;m=ag((l(2,y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24)),r()));m=ni(E(Pd(Kg(m)?m>=E(0)?E(1):E(-1):m,E(-1))*E(32768)));ba:{if(E(F(m))<E(2147483648)){g=~~m;break ba}g=-2147483648}M=e,O=gd(g),w[M+2>>1]=O;e=e+4|0;f=f+8|0;b=b-1|0;continue}break}fb=d+16|0;e=a<<3;break u}d=fb-16|0;fb=d;x[d+12>>2]=j>>>3;x[d+8>>2]=b;a=x[Hb(d+12|0,d+8|0)>>2];g=a;while(1){if(g){b=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);m=ag((l(2,b<<24|(b&65280)<<8|(b>>>8&65280|b>>>24)),r()));m=ni(E(Pd(Kg(m)?m>=E(0)?E(1):E(-1):m,E(-1))*E(32768)));ca:{if(E(F(m))<E(2147483648)){b=~~m;break ca}b=-2147483648}M=e,O=gd(b),w[M>>1]=O;b=y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24);m=ag((l(2,b<<24|(b&65280)<<8|(b>>>8&65280|b>>>24)),r()));m=ni(E(Pd(Kg(m)?m>=E(0)?E(1):E(-1):m,E(-1))*E(32768)));da:{if(E(F(m))<E(2147483648)){b=~~m;break da}b=-2147483648}M=e,O=gd(b),w[M+2>>1]=O;e=e+4|0;f=f+8|0;g=g-1|0;continue}break}fb=d+16|0;e=a<<3;break u}if(!(y[a+1|0]!=1|(h|0)!=3|(d|0)!=64)){e=x[b+20>>2];b=x[b>>2];if(!y[a+2|0]){g=fb-32|0;fb=g;x[g+24>>2]=j>>>3;x[g+16>>2]=b;d=x[Hb(g+24|0,g+16|0)>>2];b=d;while(1){if(b){a=y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24);l(0,y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24));l(1,a|0);q=Jg(+n());M=g,V=Af(q)?q>=0?1:-1:q,C[M+24>>3]=V;x[g+16>>2]=0;x[g+20>>2]=-1074790400;x[g+8>>2]=0;x[g+12>>2]=1072693248;q=Ge(C[Yg(g+24|0,g+16|0,g+8|0)>>3]*32768);ea:{if(F(q)<2147483648){a=~~q;break ea}a=-2147483648}M=e,O=gd(a),w[M>>1]=O;e=e+2|0;f=f+8|0;b=b-1|0;continue}break}fb=g+32|0;e=d<<3;break u}k=fb-32|0;fb=k;x[k+24>>2]=j>>>3;x[k+16>>2]=b;h=x[Hb(k+24|0,k+16|0)>>2];b=h;while(1){if(b){i=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);g=i<<24|(i&65280)<<8;a=i&-16777216;d=a>>>24|0;o=a<<8;a=i&16711680;j=y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24);l(0,o|a<<24|(((j&255)<<24|i>>>8)&-16777216|((j&16777215)<<8|i>>>24)&16711680|(j>>>8&65280|j>>>24)));l(1,g|(d|a>>>8));q=Jg(+n());M=k,V=Af(q)?q>=0?1:-1:q,C[M+24>>3]=V;x[k+16>>2]=0;x[k+20>>2]=-1074790400;x[k+8>>2]=0;x[k+12>>2]=1072693248;q=Ge(C[Yg(k+24|0,k+16|0,k+8|0)>>3]*32768);fa:{if(F(q)<2147483648){a=~~q;break fa}a=-2147483648}M=e,O=gd(a),w[M>>1]=O;e=e+2|0;f=f+8|0;b=b-1|0;continue}break}fb=k+32|0;e=h<<3;break u}d=e&255;if(!(y[a+1|0]!=2|(h|0)!=3|(d|0)!=64)){e=x[b+20>>2];b=x[b>>2];if(!y[a+2|0]){g=fb-32|0;fb=g;x[g+24>>2]=j>>>4;x[g+16>>2]=b;d=x[Hb(g+24|0,g+16|0)>>2];b=d;while(1){if(b){a=y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24);l(0,y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24));l(1,a|0);q=Jg(+n());M=g,V=Af(q)?q>=0?1:-1:q,C[M+24>>3]=V;x[g+16>>2]=0;x[g+20>>2]=-1074790400;x[g+8>>2]=0;x[g+12>>2]=1072693248;q=Ge(C[Yg(g+24|0,g+16|0,g+8|0)>>3]*32768);ga:{if(F(q)<2147483648){a=~~q;break ga}a=-2147483648}M=e,O=gd(a),w[M>>1]=O;a=y[f+12|0]|y[f+13|0]<<8|(y[f+14|0]<<16|y[f+15|0]<<24);l(0,y[f+8|0]|y[f+9|0]<<8|(y[f+10|0]<<16|y[f+11|0]<<24));l(1,a|0);q=Jg(+n());M=g,V=Af(q)?q>=0?1:-1:q,C[M+24>>3]=V;x[g+16>>2]=0;x[g+20>>2]=-1074790400;x[g+8>>2]=0;x[g+12>>2]=1072693248;q=Ge(C[Yg(g+24|0,g+16|0,g+8|0)>>3]*32768);ha:{if(F(q)<2147483648){a=~~q;break ha}a=-2147483648}M=e,O=gd(a),w[M+2>>1]=O;e=e+4|0;f=f+16|0;b=b-1|0;continue}break}fb=g+32|0;e=d<<4;break u}k=fb-32|0;fb=k;x[k+24>>2]=j>>>4;x[k+16>>2]=b;h=x[Hb(k+24|0,k+16|0)>>2];b=h;while(1){if(b){i=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);g=i<<24|(i&65280)<<8;a=i&-16777216;d=a>>>24|0;o=a<<8;a=i&16711680;j=y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24);l(0,o|a<<24|(((j&255)<<24|i>>>8)&-16777216|((j&16777215)<<8|i>>>24)&16711680|(j>>>8&65280|j>>>24)));l(1,g|(d|a>>>8));q=Jg(+n());M=k,V=Af(q)?q>=0?1:-1:q,C[M+24>>3]=V;x[k+16>>2]=0;x[k+20>>2]=-1074790400;x[k+8>>2]=0;x[k+12>>2]=1072693248;q=Ge(C[Yg(k+24|0,k+16|0,k+8|0)>>3]*32768);ia:{if(F(q)<2147483648){a=~~q;break ia}a=-2147483648}M=e,O=gd(a),w[M>>1]=O;i=y[f+8|0]|y[f+9|0]<<8|(y[f+10|0]<<16|y[f+11|0]<<24);g=i<<24|(i&65280)<<8;a=i&-16777216;d=a>>>24|0;o=a<<8;a=i&16711680;j=y[f+12|0]|y[f+13|0]<<8|(y[f+14|0]<<16|y[f+15|0]<<24);l(0,o|a<<24|(((j&255)<<24|i>>>8)&-16777216|((j&16777215)<<8|i>>>24)&16711680|(j>>>8&65280|j>>>24)));l(1,g|(d|a>>>8));q=Jg(+n());M=k,V=Af(q)?q>=0?1:-1:q,C[M+24>>3]=V;x[k+16>>2]=0;x[k+20>>2]=-1074790400;x[k+8>>2]=0;x[k+12>>2]=1072693248;q=Ge(C[Yg(k+24|0,k+16|0,k+8|0)>>3]*32768);ja:{if(F(q)<2147483648){a=~~q;break ja}a=-2147483648}M=e,O=gd(a),w[M+2>>1]=O;e=e+4|0;f=f+16|0;b=b-1|0;continue}break}fb=k+32|0;e=h<<4;break u}ka:{if((d|0)==24){if((h|0)!=15|(y[a+1|0]-1&255)>>>0>1){break ka}x[s+48>>2]=-2147483648;la:{if(!y[a+2|0]){o=s+48|0;t=fb-16|0;fb=t;M=t,O=D(x[b>>2],_d(z[b+34>>1])),x[M+12>>2]=O;xc(t+12|0,(j>>>0)/3|0);e=f;h=x[t+12>>2];d=h;while(1){if(d){i=y[e+1|0]<<16|y[e|0]<<8|y[e+2|0]<<24;ma:{if((i|0)<0){a=-2147483648;if((i|0)==-2147483648){break ma}i=0-i|0}a=g>>>0<i>>>0?i:g}g=a;d=d-1|0;e=e+3|0;continue}else{na:{if(!g){break na}k=g-1|0;j=g>>>1|0;i=x[b+20>>2];e=h;while(1){if(!e){break na}a=y[f+1|0]<<16|y[f|0]<<8|y[f+2|0]<<24;d=a&-2147483648|a>>>1;a=j|a<<31;oa:{if((d|0)>0|(d|0)>=0){a=Kua(a,d,g,0);d=hb;break oa}d=Kua(k-a|0,0-((a>>>0>k>>>0)+d|0)|0,g,0);a=0-d|0;d=0-(hb+((d|0)!=0)|0)|0}M=i,O=rd(Gc(a,d),16),w[M>>1]=O;e=e-1|0;f=f+3|0;i=i+2|0;continue}}}break}if(o){x[o>>2]=g}fb=t+16|0;e=D(h,3);break la}o=s+48|0;t=fb-16|0;fb=t;M=t,O=D(x[b>>2],_d(z[b+34>>1])),x[M+12>>2]=O;xc(t+12|0,(j>>>0)/3|0);e=f;h=x[t+12>>2];d=h;while(1){if(d){i=y[e+1|0]<<16|y[e+2|0]<<8|y[e|0]<<24;pa:{if((i|0)<0){a=-2147483648;if((i|0)==-2147483648){break pa}i=0-i|0}a=g>>>0<i>>>0?i:g}g=a;d=d-1|0;e=e+3|0;continue}else{qa:{if(!g){break qa}k=g-1|0;j=g>>>1|0;i=x[b+20>>2];e=h;while(1){if(!e){break qa}a=y[f+1|0]<<16|y[f+2|0]<<8|y[f|0]<<24;d=a&-2147483648|a>>>1;a=j|a<<31;ra:{if((d|0)>0|(d|0)>=0){a=Kua(a,d,g,0);d=hb;break ra}d=Kua(k-a|0,0-((a>>>0>k>>>0)+d|0)|0,g,0);a=0-d|0;d=0-(hb+((d|0)!=0)|0)|0}M=i,O=rd(Gc(a,d),16),w[M>>1]=O;e=e-1|0;f=f+3|0;i=i+2|0;continue}}}break}if(o){x[o>>2]=g}fb=t+16|0;e=D(h,3)}if(!e){break u}a=x[s+48>>2];if((a|0)==-2147483648){break u}f=Iua(z[b+32>>1],0,a,0);a=hb;f=f+1073741824|0;a=f>>>0<1073741824?a+1|0:a;M=b,O=Ld(Bc((a&2147483647)<<1|f>>>31,a>>>31|0),1,64),w[M+32>>1]=O;w[b+34>>1]=z[b+34>>1]|8192;break u}d=e&255;if((d|0)==32){if(!((h|0)!=15|(y[a+1|0]-1&255)>>>0>1)){x[s+48>>2]=-2147483648;sa:{if(!y[a+2|0]){o=s+48|0;t=fb-16|0;fb=t;M=t,O=D(x[b>>2],_d(z[b+34>>1])),x[M+12>>2]=O;xc(t+12|0,j>>>2|0);d=f;h=x[t+12>>2];g=h;while(1){if(g){e=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);ta:{if((e|0)<0){a=-2147483648;if((e|0)==-2147483648){break ta}e=0-e|0}a=e>>>0>i>>>0?e:i}i=a;g=g-1|0;d=d+4|0;continue}else{ua:{if(!i){break ua}k=i-1|0;j=i>>>1|0;g=x[b+20>>2];e=h;while(1){if(!e){break ua}a=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);d=a&-2147483648|a>>>1;a=j|a<<31;va:{if((d|0)>0|(d|0)>=0){a=Kua(a,d,i,0);d=hb;break va}d=Kua(k-a|0,0-((a>>>0>k>>>0)+d|0)|0,i,0);a=0-d|0;d=0-(hb+((d|0)!=0)|0)|0}M=g,O=rd(Gc(a,d),16),w[M>>1]=O;e=e-1|0;f=f+4|0;g=g+2|0;continue}}}break}if(o){x[o>>2]=i}fb=t+16|0;e=h<<2;break sa}o=s+48|0;t=fb-16|0;fb=t;M=t,O=D(x[b>>2],_d(z[b+34>>1])),x[M+12>>2]=O;xc(t+12|0,j>>>2|0);g=f;h=x[t+12>>2];e=h;while(1){if(e){a=y[g|0]|y[g+1|0]<<8|(y[g+2|0]<<16|y[g+3|0]<<24);d=a<<24|(a&65280)<<8|(a>>>8&65280|a>>>24);wa:{if((d|0)<0){a=-2147483648;if((d|0)==-2147483648){break wa}d=0-d|0}a=d>>>0>i>>>0?d:i}i=a;e=e-1|0;g=g+4|0;continue}else{xa:{if(!i){break xa}k=i-1|0;j=i>>>1|0;g=x[b+20>>2];e=h;while(1){if(!e){break xa}a=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);a=a<<24|(a&65280)<<8|(a>>>8&65280|a>>>24);d=a&-2147483648|a>>>1;a=j|a<<31;ya:{if((d|0)>0|(d|0)>=0){a=Kua(a,d,i,0);d=hb;break ya}d=Kua(k-a|0,0-((a>>>0>k>>>0)+d|0)|0,i,0);a=0-d|0;d=0-(hb+((d|0)!=0)|0)|0}M=g,O=rd(Gc(a,d),16),w[M>>1]=O;e=e-1|0;f=f+4|0;g=g+2|0;continue}}}break}if(o){x[o>>2]=i}fb=t+16|0;e=h<<2}if(!e){break u}a=x[s+48>>2];if((a|0)==-2147483648){break u}f=Iua(z[b+32>>1],0,a,0);a=hb;f=f+1073741824|0;a=f>>>0<1073741824?a+1|0:a;M=b,O=Ld(Bc((a&2147483647)<<1|f>>>31,a>>>31|0),1,64),w[M+32>>1]=O;w[b+34>>1]=z[b+34>>1]|8192;break u}if((h|0)!=14|(y[a+1|0]-1&255)>>>0>1){break ka}x[s+48>>2]=1065353216;za:{if(!y[a+2|0]){d=s+48|0;g=fb-16|0;fb=g;M=g,O=D(x[b>>2],_d(z[b+34>>1])),x[M+12>>2]=O;xc(g+12|0,j>>>2|0);h=f;a=x[g+12>>2];e=a;while(1){if(e){m=ag((l(2,y[h|0]|y[h+1|0]<<8|(y[h+2|0]<<16|y[h+3|0]<<24)),r()));m=E(F(Kg(m)?m>=E(0)?E(1):E(-1):m));u=m>u?m:u;e=e-1|0;h=h+4|0;continue}else{Aa:{if(u==E(0)){break Aa}J=E(E(1)/u);h=x[b+20>>2];e=a;while(1){if(!e){break Aa}m=ag((l(2,y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24)),r()));m=ni(E(Pd(E(J*(Kg(m)?m>=E(0)?E(1):E(-1):m)),E(-1))*E(32768)));Ba:{if(E(F(m))<E(2147483648)){i=~~m;break Ba}i=-2147483648}M=h,O=gd(i),w[M>>1]=O;e=e-1|0;f=f+4|0;h=h+2|0;continue}}if(d){B[d>>2]=u}fb=g+16|0;e=a<<2}break}break za}d=s+48|0;i=fb-16|0;fb=i;M=i,O=D(x[b>>2],_d(z[b+34>>1])),x[M+12>>2]=O;xc(i+12|0,j>>>2|0);g=f;a=x[i+12>>2];e=a;while(1){if(e){h=y[g|0]|y[g+1|0]<<8|(y[g+2|0]<<16|y[g+3|0]<<24);m=ag((l(2,h<<24|(h&65280)<<8|(h>>>8&65280|h>>>24)),r()));m=E(F(Kg(m)?m>=E(0)?E(1):E(-1):m));u=m>u?m:u;e=e-1|0;g=g+4|0;continue}else{Ca:{if(u==E(0)){break Ca}J=E(E(1)/u);g=x[b+20>>2];e=a;while(1){if(!e){break Ca}h=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);m=ag((l(2,h<<24|(h&65280)<<8|(h>>>8&65280|h>>>24)),r()));m=ni(E(Pd(E(J*(Kg(m)?m>=E(0)?E(1):E(-1):m)),E(-1))*E(32768)));Da:{if(E(F(m))<E(2147483648)){h=~~m;break Da}h=-2147483648}M=g,O=gd(h),w[M>>1]=O;e=e-1|0;f=f+4|0;g=g+2|0;continue}}if(d){B[d>>2]=u}fb=i+16|0;e=a<<2}break}}if(!e){break u}m=B[s+48>>2];if(m==E(1)){break u}m=ni(CB(E(m*E(z[b+32>>1])),E(1),E(64)));a=65535;Ea:{if(m>=E(65535)){break Ea}a=0;if(m<=E(0)){break Ea}a=~~m>>>0;if(m<E(4294967296)&m>=E(0)){break Ea}a=0}w[b+32>>1]=a;w[b+34>>1]=z[b+34>>1]|8192;break u}if((h|0)!=14|(y[a+1|0]-1&255)>>>0>1|(d|0)!=64){break ka}x[s+48>>2]=0;x[s+52>>2]=1072693248;Fa:{if(!y[a+2|0]){h=s+48|0;i=fb-32|0;fb=i;M=i,O=D(x[b>>2],_d(z[b+34>>1])),x[M+4>>2]=O;xc(i+4|0,j>>>3|0);d=f;a=x[i+4>>2];e=a;while(1){if(e){g=y[d+4|0]|y[d+5|0]<<8|(y[d+6|0]<<16|y[d+7|0]<<24);l(0,y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24));l(1,g|0);q=Jg(+n());q=F(Af(q)?q>=0?1:-1:q);H=q>H?q:H;e=e-1|0;d=d+8|0;continue}else{Ga:{if(H==0){break Ga}K=1/H;d=x[b+20>>2];e=a;while(1){if(!e){break Ga}g=y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24);l(0,y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24));l(1,g|0);q=Jg(+n());M=i,V=K*(Af(q)?q>=0?1:-1:q),C[M+24>>3]=V;x[i+16>>2]=0;x[i+20>>2]=-1074790400;x[i+8>>2]=0;x[i+12>>2]=1072693248;q=Ge(C[Yg(i+24|0,i+16|0,i+8|0)>>3]*32768);Ha:{if(F(q)<2147483648){g=~~q;break Ha}g=-2147483648}M=d,O=gd(g),w[M>>1]=O;e=e-1|0;f=f+8|0;d=d+2|0;continue}}if(h){C[h>>3]=H}fb=i+32|0;e=a<<3}break}break Fa}o=s+48|0;G=fb-32|0;fb=G;M=G,O=D(x[b>>2],_d(z[b+34>>1])),x[M+4>>2]=O;xc(G+4|0,j>>>3|0);d=f;a=x[G+4>>2];e=a;while(1){if(e){k=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);j=k<<24|(k&65280)<<8;g=k&-16777216;h=g>>>24|0;t=g<<8;g=k&16711680;i=y[d+4|0]|y[d+5|0]<<8|(y[d+6|0]<<16|y[d+7|0]<<24);l(0,t|g<<24|(((i&255)<<24|k>>>8)&-16777216|((i&16777215)<<8|k>>>24)&16711680|(i>>>8&65280|i>>>24)));l(1,j|(h|g>>>8));q=Jg(+n());q=F(Af(q)?q>=0?1:-1:q);H=q>H?q:H;e=e-1|0;d=d+8|0;continue}else{Ia:{if(H==0){break Ia}K=1/H;d=x[b+20>>2];e=a;while(1){if(!e){break Ia}t=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);k=t<<24|(t&65280)<<8;i=t&16711680;j=i>>>8|0;h=t&-16777216;g=h>>>24|0;i=h<<8|i<<24;h=y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24);l(0,i|(((h&255)<<24|t>>>8)&-16777216|((h&16777215)<<8|t>>>24)&16711680|(h>>>8&65280|h>>>24)));l(1,k|(g|j));q=Jg(+n());M=G,V=K*(Af(q)?q>=0?1:-1:q),C[M+24>>3]=V;x[G+16>>2]=0;x[G+20>>2]=-1074790400;x[G+8>>2]=0;x[G+12>>2]=1072693248;q=Ge(C[Yg(G+24|0,G+16|0,G+8|0)>>3]*32768);Ja:{if(F(q)<2147483648){g=~~q;break Ja}g=-2147483648}M=d,O=gd(g),w[M>>1]=O;e=e-1|0;f=f+8|0;d=d+2|0;continue}}if(o){C[o>>3]=H}fb=G+32|0;e=a<<3}break}}if(!e){break u}q=C[s+48>>3];if(q==1){break u}M=b,O=LD(Zv(q*+z[b+32>>1],1,64)),w[M+32>>1]=O;w[b+34>>1]=z[b+34>>1]|8192;break u}Ka:{La:{Ma:{Na:{d=(e&255)!=32;Oa:{if(!(d|(y[a+1|0]!=1|(h|0)!=12))){u=E(30517578125e-15);if(!y[a+2|0]){break Oa}break Ka}if(!(y[a+1|0]!=2|(h|0)!=12|d)){u=E(30517578125e-15);if(!y[a+2|0]){break Ma}break La}d=(e&255)!=32;if(d|(y[a+1|0]!=1|(h|0)!=13)){break Na}u=E(1.1920928955078125e-7);if(y[a+2|0]){break Ka}}a=x[b>>2];e=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>2;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){m=ag((l(2,y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24)),r()));m=ni(E(Pd(E((Kg(m)?m>=E(0)?E(1):E(-1):m)*u),E(-1))*E(32768)));Pa:{if(E(F(m))<E(2147483648)){g=~~m;break Pa}g=-2147483648}M=e,O=gd(g),w[M>>1]=O;e=e+2|0;f=f+4|0;b=b-1|0;continue}break}fb=d+16|0;e=a<<2;break u}e=0;if(y[a+1|0]!=2|(h|0)!=13|d){break u}u=E(1.1920928955078125e-7);if(y[a+2|0]){break La}}a=x[b>>2];e=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>3;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];b=a;while(1){if(b){m=ag((l(2,y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24)),r()));m=ni(E(Pd(E((Kg(m)?m>=E(0)?E(1):E(-1):m)*u),E(-1))*E(32768)));Qa:{if(E(F(m))<E(2147483648)){g=~~m;break Qa}g=-2147483648}M=e,O=gd(g),w[M>>1]=O;m=ag((l(2,y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24)),r()));m=ni(E(Pd(E((Kg(m)?m>=E(0)?E(1):E(-1):m)*u),E(-1))*E(32768)));Ra:{if(E(F(m))<E(2147483648)){g=~~m;break Ra}g=-2147483648}M=e,O=gd(g),w[M+2>>1]=O;e=e+4|0;f=f+8|0;b=b-1|0;continue}break}fb=d+16|0;e=a<<3;break u}a=x[b>>2];g=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>3;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){b=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);m=ag((l(2,b<<24|(b&65280)<<8|(b>>>8&65280|b>>>24)),r()));m=ni(E(Pd(E((Kg(m)?m>=E(0)?E(1):E(-1):m)*u),E(-1))*E(32768)));Sa:{if(E(F(m))<E(2147483648)){b=~~m;break Sa}b=-2147483648}M=g,O=gd(b),w[M>>1]=O;b=y[f+4|0]|y[f+5|0]<<8|(y[f+6|0]<<16|y[f+7|0]<<24);m=ag((l(2,b<<24|(b&65280)<<8|(b>>>8&65280|b>>>24)),r()));m=ni(E(Pd(E((Kg(m)?m>=E(0)?E(1):E(-1):m)*u),E(-1))*E(32768)));Ta:{if(E(F(m))<E(2147483648)){b=~~m;break Ta}b=-2147483648}M=g,O=gd(b),w[M+2>>1]=O;g=g+4|0;f=f+8|0;e=e-1|0;continue}break}fb=d+16|0;e=a<<3;break u}a=x[b>>2];g=x[b+20>>2];d=fb-16|0;fb=d;x[d+12>>2]=j>>>2;x[d+8>>2]=a;a=x[Hb(d+12|0,d+8|0)>>2];e=a;while(1){if(e){b=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);m=ag((l(2,b<<24|(b&65280)<<8|(b>>>8&65280|b>>>24)),r()));m=ni(E(Pd(E((Kg(m)?m>=E(0)?E(1):E(-1):m)*u),E(-1))*E(32768)));Ua:{if(E(F(m))<E(2147483648)){b=~~m;break Ua}b=-2147483648}M=g,O=gd(b),w[M>>1]=O;g=g+2|0;f=f+4|0;e=e-1|0;continue}break}fb=d+16|0;e=a<<2;break u}a=T(28816)|0}if((gb|0)!=($(28816)|0)){break e}Y(a|0)|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)==1){break v}}ub(o);break u}a=N()|0;break e}x[31609]=0;P(149,c|0,e+L|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break g}}Kc(I)}fb=s+2240|0;return e|0}a=N()|0;break a}a=N()|0}ub(o);break a}a=N()|0;break a}a=N()|0;break a}a=N()|0}Kc(I);Q(a|0);p()}function gsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,T=0;e=fb-608|0;fb=e;yc(b);d=fb-16|0;fb=d;g=e+416|0;sw(d+8|0,g);j=x[d+12>>2];lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2]);h=x[d+4>>2];if((h|0)==(j|0)){Vb(b,x[d+12>>2])}fb=d+16|0;d=(h|0)==(j|0);if(!d){OZ(g)}a:{b:{c:{if(!d){break c}if(!QZ(g)){break c}if(!Mb(x[b>>2],x[b+8>>2],Bc(PZ(g),hb))){break c}f=1;if((c|0)==64){break c}Dd(a,32);v[e+415|0]=0;j=Fb(e+400|0);d:{e:{f:{g:{h:{i:{if((y[e+416|0]|y[e+417|0]<<8|(y[e+418|0]<<16|y[e+419|0]<<24))==778924148){x[31609]=0;O(417,a|0,16777216);d=x[31609];x[31609]=0;if((d|0)==1){break b}d=x[b>>2];x[31609]=0;d=R(154,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break b}x[31609]=0;P(149,b|0,d-4|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break b}x[31609]=0;u=R(151,b|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break i}break b}j:{k:{l:{m:{n:{o:{if(((y[e+456|0]|y[e+457|0]<<8)-2185&65535)>>>0>1910){break o}d=x[b>>2];x[31609]=0;d=R(154,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break b}x[31609]=0;P(149,b|0,d-4|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break b}x[31609]=0;u=R(151,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break b}if(u>>>0<256){break o}d=x[b>>2];x[31609]=0;d=R(154,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break b}if(d>>>0<=u>>>0){break o}x[31609]=0;d=P(149,b|0,u|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break b}if(!d){break o}x[31609]=0;d=R(418,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break b}if(!d){break o}x[31609]=0;O(417,a|0,16777216);d=x[31609];x[31609]=0;if((d|0)==1){break b}d=y[e+456|0]|y[e+457|0]<<8;if(d>>>0>=4096){x[31609]=0;c=P(1,e+160|0,16553)|0;b=x[31609];x[31609]=0;if((b|0)==1){break h}a=x[a+1298472>>2];x[31609]=0;S(385,a|0,1,c|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(c);f=0;break d}b=N()|0;tb(c);break a}if(d>>>0<2194){break o}x[31609]=0;d=P(1,e+388|0,16082)|0;f=x[31609];x[31609]=0;if((f|0)==1){break n}f=x[a+1298472>>2];x[31609]=0;S(385,f|0,4,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break m}tb(d)}if(x[a+480180>>2]!=32){break i}d=y[e+456|0]|y[e+457|0]<<8;if((d&61440)!=20480){break j}d=d&4095;f=d<<16;if((y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24))!=1414548815){break l}v[e+415|0]=1;break k}b=N()|0;break a}b=N()|0;tb(d);break a}if(d>>>0<297){break k}f=y[e+476|0]|y[e+477|0]<<8|f}x[a+1074308>>2]=f;break i}f=y[e+458|0]|y[e+459|0]<<8;if(!((f|0)!=2184&(d|0)!=2184)){v[e+415|0]=1;x[a+1074308>>2]=18284544;break i}if((d|0)!=768){if((d|0)!=532|(f|0)!=514|(y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24))){break i}x[a+1074308>>2]=17367040;x[31609]=0;d=P(1,e+376|0,14750)|0;f=x[31609];x[31609]=0;if((f|0)!=1){zb(j,d);tb(d);v[e+415|0]=1;break i}b=N()|0;break a}if(y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24)|(f|0)!=768|((y[e+448|0]|y[e+449|0]<<8)!=256|y[e+468|0]!=128)){break i}if(y[e+469|0]){break i}x[a+1074308>>2]=18285088;v[e+415|0]=1}d=y[e+460|0]|y[e+461|0]<<8;f=d>>>2|0;x[a+480208>>2]=d<<3&32768|(f&8|(f&4|(x[a+480208>>2]&-32797|d<<1&16)));f=e+280|0;Wr(f,e+420|0);x[31609]=0;d=e+160|0;O(218,d|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break g}zb(a+1298308|0,d);tb(d);if(!(!(y[e+462|0]&4)|x[a+1074308>>2]-18285314>>>0>4276681982)){x[a+480216>>2]=y[e+446|0];x[a+480220>>2]=y[e+447|0]}d=y[e+464|0];x[a+480200>>2]=d>>>0>128?256:d<<1;d=y[e+466|0];if(d){x[a+480196>>2]=d}v[e+160|0]=31;v[e+280|0]=y[e+467|0];d=e+160|0;f=e+280|0;M=a,T=D(y[cf(d,f)|0],1e4),x[M+480204>>2]=T;v[e+160|0]=y[e+465|0];v[e+280|0]=128;M=a,T=y[Qb(d,f)|0],x[M+480228>>2]=T;f=0;while(1){if((f|0)==64){p:{x[31609]=0;P(149,b|0,192)|0;d=x[31609];x[31609]=0;if((d|0)==1){break b}if(x[a+480180>>2]==16777216){if(((y[e+456|0]|y[e+457|0]<<8)-2187&65535)>>>0<=2){break p}}d=y[a+484376|0];f=x[a+484360>>2];x[31609]=0;aa(348,Xb(f,d)|0,b|0,y[e+448|0]|y[e+449|0]<<8,255,254);d=x[31609];x[31609]=0;if((d|0)==1){break b}break e}}else{h=(e+416|0)+f|0;i=h- -64|0;q:{if(y[i|0]==255){break q}g=(f<<5)+a|0;d=g+480280|0;Ue(d);M=g+480286|0,T=Ld(y[h+128|0],0,64),w[M>>1]=T;h=v[i|0];if((h|0)<0){x[d>>2]=x[d>>2]|1024}h=h&127;if(h>>>0<=64){w[g+480284>>1]=h<<2;break q}if((h|0)!=100){break q}x[d>>2]=x[d>>2]|256}f=f+1|0;continue}break}f=0;x[31609]=0;d=R(189,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break f}if(d){break d}x[31609]=0;d=R(151,b|0)|0;g=x[31609];x[31609]=0;r:{if((g|0)==1){break r}if(d>>>0>4e3){break d}g=y[a+484376|0];h=x[a+484360>>2];x[31609]=0;d=U(419,Xb(h,g)|0,b|0,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break r}if(!d){break d}break e}b=N()|0;break a}b=N()|0;break a}b=N()|0;break a}b=N()|0;break a}r=Nb(e+364|0);q=Nb(e+352|0);f=0;o=Nb(e+340|0);x[31609]=0;d=U(420,b|0,r|0,y[e+450|0]|y[e+451|0]<<8)|0;g=x[31609];x[31609]=0;s:{t:{u:{if((g|0)==1){break u}if(!d){break s}x[31609]=0;d=U(420,b|0,q|0,y[e+452|0]|y[e+453|0]<<8)|0;g=x[31609];x[31609]=0;if((g|0)==1){break u}if(!d){break s}x[31609]=0;d=U(420,b|0,o|0,y[e+454|0]|y[e+455|0]<<8)|0;g=x[31609];x[31609]=0;if((g|0)==1){break u}if(!d){break s}x[e+336>>2]=-1;M=e,T=wb(x[r>>2]),x[M+160>>2]=T;g=wb(x[r+4>>2]);d=x[e+336>>2];while(1){f=x[e+160>>2];if(Ib(f,g)){f=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);if(!(!f|d>>>0<=f>>>0)){x[e+336>>2]=f;d=f}We(e+160|0);continue}else{M=e,T=wb(x[q>>2]),x[M+160>>2]=T;g=wb(x[q+4>>2]);d=x[e+336>>2];while(1){f=x[e+160>>2];if(Ib(f,g)){f=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);if(!(!f|d>>>0<=f>>>0)){x[e+336>>2]=f;d=f}We(e+160|0);continue}else{M=e,T=wb(x[o>>2]),x[M+160>>2]=T;g=wb(x[o+4>>2]);d=x[e+336>>2];v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{while(1){f=x[e+160>>2];if(Ib(f,g)){f=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);if(!(!f|d>>>0<=f>>>0)){x[e+336>>2]=f;d=f}We(e+160|0);continue}else{if(v[e+462|0]&1){x[e+160>>2]=y[e+472|0]|y[e+473|0]<<8|(y[e+474|0]<<16|y[e+475|0]<<24);d=x[Hb(e+336|0,e+160|0)>>2];x[e+336>>2]=d}f=0;if((y[e+458|0]|y[e+459|0]<<8)!=532){break D}g=y[e+456|0]|y[e+457|0]<<8;if(y[e+447|0]|(g?(g|0)!=532:0)|(y[e+446|0]|y[e+469|0])){break D}if(y[e+460|0]&192|(y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24))){break D}if(y[e+450|0]|y[e+451|0]<<8){break E}g=y[e+452|0]|y[e+453|0]<<8;if(!g){break E}if((x[b+8>>2]+(oc(x[q>>2],x[q+4>>2])<<2)|0)+2>>>0>d>>>0){break E}}break}while(1){d=f&65535;if(d>>>0<(g&65535)>>>0){x[31609]=0;g=R(151,b|0)|0;h=x[31609];x[31609]=0;F:{if((h|0)!=1){if(!g){break F}Ih(b,(d<<2)+4|0);break E}b=N()|0;break t}f=f+1|0;g=y[e+452|0]|y[e+453|0]<<8;continue}break}x[31609]=0;d=P(1,e+324|0,15065)|0;f=x[31609];x[31609]=0;if((f|0)==1){break C}zb(j,d);tb(d)}f=1;if(y[e+456|0]|y[e+457|0]<<8){break D}x[31609]=0;d=P(1,e+312|0,15518)|0;g=x[31609];x[31609]=0;if((g|0)==1){break B}zb(j,d);tb(d)}d=y[e+462|0]|y[e+463|0]<<8;G:{if(d&2){x[31609]=0;g=R(189,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break w}d=x[b+8>>2];h=x[b>>2];x[31609]=0;i=d;d=g<<3;h=U(150,h|0,i|0,d|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break w}if(!(!h|A[e+336>>2]<d+x[b+8>>2]>>>0)){x[31609]=0;O(421,a+1298412|0,g|0);d=x[31609];x[31609]=0;if((d|0)==1){break w}M=e,T=wb(x[a+1298412>>2]),x[M+280>>2]=T;h=wb(x[a+1298416>>2]);H:{I:{while(1){d=x[e+280>>2];if(!Ib(d,h)){if(!(!g&f)){break G}if(!(y[e+462|0]&4)){break H}x[31609]=0;d=P(1,e+300|0,15551)|0;f=x[31609];x[31609]=0;if((f|0)==1){break I}zb(j,d);tb(d);break G}x[31609]=0;O(422,b|0,e+160|0);i=x[31609];x[31609]=0;if((i|0)!=1){x[d>>2]=0;x[d+4>>2]=0;x[d+24>>2]=0;x[d+28>>2]=0;x[d+8>>2]=0;x[d+12>>2]=0;x[d+16>>2]=0;i=y[e+160|0]|y[e+161|0]<<8;if(i|(y[e+162|0]|y[e+163|0]<<8)){x[d>>2]=((i&65024)>>>9|0)+1980;M=d,T=Yb((y[e+160|0]|y[e+161|0]<<8)>>>5&15,1,12),x[M+4>>2]=T;M=d,T=Yb((y[e+160|0]|y[e+161|0]<<8)&31,1,31),x[M+8>>2]=T;M=d,T=Yb((y[e+162|0]|y[e+163|0]<<8)>>>11|0,0,23),x[M+12>>2]=T;M=d,T=Yb((y[e+162|0]|y[e+163|0]<<8)>>>5&63,0,59),x[M+16>>2]=T;i=Yb((y[e+162|0]|y[e+163|0]<<8)<<1&62,0,59);x[d+24>>2]=i;x[d+28>>2]=i>>31}x[d+32>>2]=y[e+164|0]|y[e+165|0]<<8|(y[e+166|0]<<16|y[e+167|0]<<24);x[e+280>>2]=x[e+280>>2]+40;continue}break}b=N()|0;break t}b=N()|0;break t}x[31609]=0;d=P(1,e+300|0,15087)|0;f=x[31609];x[31609]=0;if((f|0)!=1){zb(j,d);tb(d);break G}b=N()|0;break t}Ih(b,2);break G}if(f^1|d>>>0>1){break G}x[31609]=0;d=R(189,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break v}if(!d){x[31609]=0;d=P(1,e+300|0,15065)|0;f=x[31609];x[31609]=0;if((f|0)!=1){zb(j,d);tb(d);break G}b=N()|0;break t}Ih(b,2)}J:{if(!(y[e+460|0]&128|y[e+462|0]&8)){break J}x[31609]=0;d=a+901404|0;f=P(423,b|0,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break A}if(!f){break J}DD(d)}if((y[e+456|0]|y[e+457|0]<<8)>>>0<=531){kr(a+901404|0)}x[31609]=0;B=R(168,e+280|0)|0;d=x[31609];x[31609]=0;K:{L:{M:{if((d|0)!=1){x[31609]=0;f=P(412,b|0,13951)|0;d=x[31609];x[31609]=0;if((d|0)==1){break M}if(f){x[31609]=0;g=R(151,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break L}x[31609]=0;d=e+260|0;S(185,d|0,b|0,g|0);g=x[31609];x[31609]=0;if((g|0)==1){break L}g=hc(e+160|0,d);kd(B,g);ub(g);ub(d)}w[a+480188>>1]=1;x[31609]=0;d=P(412,b|0,13956)|0;g=x[31609];x[31609]=0;if((g|0)==1){break M}if(!d){break y}x[31609]=0;d=R(151,b|0)|0;f=x[31609];x[31609]=0;if((f|0)!=1){x[31609]=0;S(185,e+260|0,b|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){break K}}b=N()|0;break x}b=N()|0;break t}b=N()|0;break x}b=N()|0;break x}f=e+260|0;d=hc(e+160|0,f);ub(f);g=x[d>>2];x[31609]=0;g=R(154,g|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break z}w[e+260>>1]=(g>>>0)/20;g=z[Oc(25044,f)>>1];w[a+480188>>1]=g;f=0;while(1){if((f|0)==(g|0)){ub(d);f=1;break y}x[31609]=0;S(424,d|0,((f<<5)+a|0)+480289|0,20);h=x[31609];x[31609]=0;if((h|0)!=1){f=f+1|0;continue}break}break z}b=N()|0;break t}b=N()|0;break t}b=N()|0;break t}b=N()|0;ub(d);break x}N:{O:{P:{Q:{R:{S:{T:{U:{V:{d=x[e+336>>2];g=x[b+8>>2];W:{if(d>>>0>=g>>>0){d=d-g|0;break W}x[31609]=0;d=R(202,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break V}}x[31609]=0;g=e+160|0;S(185,g|0,b|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break V}C=hc(e+260|0,g);ub(g);x[31609]=0;d=e+258|0;S(425,d|0,a|0,C|0);g=x[31609];x[31609]=0;if((g|0)==1){break U}E=Jc(d);F=y[e+258|0]!=0|f;if((y[e+456|0]|y[e+457|0]<<8)!=535|(y[e+458|0]|y[e+459|0]<<8)!=512|(y[E|0]|(y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24)))){break Q}X:{if(F){break X}f=Xb(x[a+484360>>2],y[a+484376|0]);d=x[f+4>>2];if(!mc(x[f>>2],d)){if(z[Hn(d)>>1]==65535){break X}}if(!qq(e+480|0,255,64)){break S}}x[a+1074308>>2]=18219008;x[31609]=0;d=P(1,e+244|0,14916)|0;f=x[31609];x[31609]=0;if((f|0)==1){break T}break R}b=N()|0;break x}b=N()|0;break N}b=N()|0;break N}x[a+1074308>>2]=18284544;x[31609]=0;d=P(1,e+244|0,16904)|0;f=x[31609];x[31609]=0;if((f|0)==1){break P}}zb(j,d);tb(d);v[e+415|0]=1}Y:{if(!(v[e+462|0]&1)|!(y[e+470|0]|y[e+471|0]<<8)){break Y}x[31609]=0;d=P(149,b|0,y[e+472|0]|y[e+473|0]<<8|(y[e+474|0]<<16|y[e+475|0]<<24))|0;f=x[31609];x[31609]=0;if((f|0)==1){break O}if(!d){break Y}x[31609]=0;V(336,a+1298332|0,b|0,y[e+470|0]|y[e+471|0]<<8,4);d=x[31609];x[31609]=0;if((d|0)==1){break O}}w[a+480192>>1]=0;d=0;if(y[e+460|0]&4){w[e+160>>1]=y[e+450|0]|y[e+451|0]<<8;w[e+100>>1]=255;d=z[Oc(e+160|0,e+100|0)>>1];w[a+480192>>1]=d}f=0;Z:{while(1){if((d&65535)>>>0<=f>>>0){x[e+240>>2]=0;f=y[e+452|0]|y[e+453|0]<<8;if(f){d=yb(x[q>>2],f-1|0);x[e+240>>2]=(y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24))+80}w[e+160>>1]=f;w[e+100>>1]=3999;d=z[Oc(e+160|0,e+100|0)>>1];w[a+480190>>1]=d;n=c&2;s=e+180|0;f=0;while(1){_:{$:{aa:{ba:{ca:{da:{ea:{fa:{ga:{if((d&65535)>>>0>f>>>0){d=yb(x[q>>2],f);d=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);if(!d){break $}x[31609]=0;d=P(149,b|0,d|0)|0;g=x[31609];x[31609]=0;ha:{ia:{ja:{ka:{la:{if((g|0)==1){break la}if(!d){break $}x[31609]=0;d=e+160|0;g=P(426,b|0,d|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break la}if(!g){break $}x[31609]=0;g=f+1|0;h=D(g,104)+a|0;i=h+484380|0;k=P(427,d|0,i|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break ka}l=e+148|0;Wr(l,s);x[31609]=0;d=e+100|0;O(218,d|0,l|0);l=x[31609];x[31609]=0;if((l|0)==1){break ja}Ac(((g<<5)+a|0)+946304|0,d);tb(d);x[31609]=0;k=P(149,b|0,k|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break ka}if(!k){break $}h=z[h+484414>>1];if(!(h&512)){break ia}x[31609]=0;d=P(428,b|0,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break ga}if(!d){break ha}x[e+16>>2]=y[e+108|0]|y[e+109|0]<<8|(y[e+110|0]<<16|y[e+111|0]<<24);d=y[e+104|0]|y[e+105|0]<<8|(y[e+106|0]<<16|y[e+107|0]<<24);x[e+8>>2]=y[e+100|0]|y[e+101|0]<<8|(y[e+102|0]<<16|y[e+103|0]<<24);x[e+12>>2]=d;Tk(i,1,e+8|0);break ha}b=N()|0;break N}b=N()|0;break N}b=N()|0;break N}if(!(h&16384)){l=y[e+456|0]|y[e+457|0]<<8;t=e+100|0;h=y[e+178|0];k=h&2;d=y[e+206|0];g=Zc(t,k?16:8,1,0,(d^-1)&1);if(!(!(h&4)|l>>>0<532)){vp(g,3)}ma:{na:{if(h&8){h=d&4?5:4;break na}if(!k){h=10;if((d|0)==255){break na}}if(d&2){v[g+2|0]=1}if(d&4){wg(g,2)}if(!(d&8)){break ma}h=9;if(!k){break ma}}wg(g,h)}if(n){d=0;x[31609]=0;U(215,t|0,i|0,b|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){break ca}break _}d=1;g=y[e+103|0];if(g>>>0>17){break ba}h=1<<g;if(!(h&63503)){if(!(h&198144)){break ba}break da}if(y[e+100|0]){break da}break ca}x[31609]=0;O(429,b|0,e+88|0);d=x[31609];x[31609]=0;if((d|0)==1){break ea}h=x[e+88>>2];if(!(!n|!h)){d=Fb(e+100|0);x[31609]=0;S(270,b|0,d|0,h|0);h=x[31609];x[31609]=0;oa:{pa:{qa:{ra:{sa:{ta:{ua:{if((h|0)!=1){x[31609]=0;h=e+136|0;O(383,h|0,16475);i=x[31609];x[31609]=0;if((i|0)==1){break ua}x[e+76>>2]=g;x[31609]=0;g=e+124|0;S(258,g|0,0,d|0);i=x[31609];x[31609]=0;if((i|0)==1){break ta}x[31609]=0;i=e+148|0;V(430,i|0,h|0,e+76|0,g|0);k=x[31609];x[31609]=0;if((k|0)==1){break sa}k=x[a+1298472>>2];x[31609]=0;S(385,k|0,2,i|0);k=x[31609];x[31609]=0;if((k|0)==1){break ra}tb(i);tb(g);Eb(h);tb(d);break ha}b=N()|0;break oa}b=N()|0;break oa}b=N()|0;break pa}b=N()|0;break qa}b=N()|0;tb(e+148|0)}tb(e+124|0)}Eb(e+136|0)}tb(d);break N}x[31609]=0;P(183,b|0,h|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break ea}}d=0;break aa}w[e+160>>1]=1;w[e+100>>1]=d;M=a,T=z[qe(e+160|0,e+100|0)>>1],w[M+480190>>1]=T;if(!((y[e+456|0]|y[e+457|0]<<8)==516&m)|(y[e+458|0]|y[e+459|0]<<8)!=512|(y[e+462|0]|y[e+463|0]<<8|(y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24)))){break fa}if(((y[e+460|0]|y[e+461|0]<<8)&65527)!=21|y[e+464|0]!=128|(y[e+465|0]!=48|y[e+468|0]!=128)){break fa}if(y[e+469|0]|(y[e+470|0]|y[e+471|0]<<8)){break fa}f=1;g=64;while(1){d=128;if((g|0)==128){while(1)if((d|0)==192){d=20;while(1){if((d|0)==26){va:{if(!(f&1)){break fa}x[31609]=0;d=P(1,e+148|0,9895)|0;f=x[31609];x[31609]=0;if((f|0)==1){break va}zb(j,d);tb(d);break fa}}else{f=!y[(e+d|0)+420|0]&f;d=d+1|0;continue}break}b=N()|0;break N}else{f=y[(e+416|0)+d|0]==64&f;d=d+1|0;continue}}else{f=(y[(e+416|0)+g|0]&127)==32&f;g=g+1|0;continue}}}b=N()|0;break N}x[a+480260>>2]=0;x[a+480264>>2]=2147483647;f=oc(x[o>>2],x[o+4>>2]);w[e+160>>1]=f;d=e+160|0;s=z[Oc(d,x[a+8>>2]+10|0)>>1];w[e+122>>1]=s;wa:{xa:{ya:{za:{if((f|0)!=(s|0)){x[31609]=0;f=e+100|0;W(431,f|0);g=x[31609];x[31609]=0;if((g|0)==1){break wa}g=x[o+4>>2];h=x[o>>2];x[31609]=0;M=e,T=oc(h,g),x[M+136>>2]=T;V(432,d|0,f|0,e+136|0,e+122|0);g=x[31609];x[31609]=0;if((g|0)==1){break ya}g=x[a+1298472>>2];x[31609]=0;S(385,g|0,2,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break za}tb(d);Eb(f)}if(!(c&1)){w[e+122>>1]=0;s=0}h=0;Aa:{Ba:{Ca:{Da:{Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{Ka:{La:{Ma:{Na:{Oa:{Pa:{Qa:{while(1){Ra:{if((h|0)==(s|0)){c=x[e+240>>2];if(!c){break Oa}x[31609]=0;P(149,b|0,c|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Qa}if(!t){break Oa}while(1){Sa:{c=x[b+8>>2];d=x[b>>2];x[31609]=0;c=U(150,d|0,c|0,4)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Sa}if(!c){break Oa}x[31609]=0;c=P(412,b|0,13930)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Sa}Ta:{if(!c){x[31609]=0;c=P(412,b|0,13935)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Sa}if(!c){break Ta}}x[31609]=0;c=R(151,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Pa}Ih(b,8);if(c&-2139062144){break Ta}if(c&1616928864){break Oa}}x[31609]=0;c=R(189,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Sa}x[31609]=0;P(183,b|0,c|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){continue}}break}b=N()|0;break N}Ua:{c=yb(x[o>>2],h);c=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);Va:{if(!c){break Va}x[31609]=0;c=P(149,b|0,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Na}if(!c){break Va}x[31609]=0;d=R(189,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Aa}x[31609]=0;n=R(189,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Ba}if((n-1025&65535)>>>0<64512){break Va}x[31609]=0;c=P(183,b|0,4)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Ba}if(!c){break Va}x[31609]=0;c=e+100|0;S(185,c|0,b|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break Ca}d=hc(e+160|0,c);ub(c);c=z[a+480188>>1];m=0;x[31609]=0;g=P(433,e+136|0,c|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Ea}Wa:{Xa:while(1){k=m>>>0>=n>>>0;while(1){if(k){break Wa}c=x[d>>2];x[31609]=0;c=U(150,c|0,x[e+168>>2],1)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Ua}if(!c){break Wa}x[31609]=0;c=R(197,d|0)|0;f=x[31609];x[31609]=0;Ya:{if((f|0)!=1){c=c<<24>>24;if(c){break Ya}m=m+1|0;continue Xa}break Ra}Za:{f=c&127;l=f?f+65535|0:0;i=l&65535;if(Xc(x[g>>2],x[e+140>>2])>>>0>i>>>0){break Za}x[31609]=0;v[e+100|0]=0;S(434,g|0,i+1|0,e+100|0);f=x[31609];x[31609]=0;if((f|0)!=1){break Za}break Ra}_a:{if((c|0)<0){x[31609]=0;c=R(197,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break _a}M=xb(x[g>>2],i),T=c,v[M|0]=T}f=xb(x[g>>2],i);c=y[f|0];if(!(!(c&15)|i>>>0<z[a+480188>>1])){w[a+480188>>1]=l+1;c=y[f|0]}if(c&1){x[31609]=0;P(183,d|0,1)|0;c=x[31609];x[31609]=0;if((c|0)==1){break _a}f=xb(x[g>>2],i)}if(y[f|0]&2){x[31609]=0;P(183,d|0,1)|0;c=x[31609];x[31609]=0;if((c|0)==1){break _a}f=xb(x[g>>2],i)}if(y[f|0]&4){x[31609]=0;P(183,d|0,1)|0;c=x[31609];x[31609]=0;if((c|0)==1){break _a}f=xb(x[g>>2],i)}if(!(y[f|0]&8)){continue}x[31609]=0;P(183,d|0,2)|0;c=x[31609];x[31609]=0;if((c|0)!=1){continue}}break}break}break Ra}x[e+100>>2]=x[b+8>>2];M=e,T=x[bd(e+240|0,e+100|0)>>2],x[M+240>>2]=T;ec(g);ub(d)}h=h+1|0;continue}}break}b=N()|0;ec(g);break Da}b=N()|0;break N}b=N()|0;break N}x[31609]=0;t=P(435,a|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){c=t|y[e+415|0];v[e+415|0]=c;if(!(y[E|0]|!(c&255))){Vv(a+1074312|0);v[a+1074368|0]=0}x[31609]=0;H=ba(436,a|0,b|0,0,e+415|0)|0;c=x[31609];x[31609]=0;$a:{if((c|0)==1){break $a}x[31609]=0;l=a+484344|0;O(223,l|0,s|0);c=x[31609];x[31609]=0;if((c|0)==1){break $a}L=a+480183|0;h=0;while(1){ab:{bb:{cb:{db:{eb:{fb:{gb:{hb:{ib:{jb:{kb:{lb:{mb:{nb:{ob:{pb:{qb:{rb:{sb:{tb:{if((h|0)!=(s|0)){c=yb(x[o>>2],h);c=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);if(c){x[31609]=0;c=P(149,b|0,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break ob}if(c){break nb}}x[31609]=0;c=U(196,l|0,h&65535,64)|0;d=x[31609];x[31609]=0;if((d|0)==1){break ob}if(c){break pb}w[e+64>>1]=h;x[31609]=0;c=e+100|0;W(437,c|0);d=x[31609];x[31609]=0;if((d|0)==1){break tb}x[31609]=0;d=e+160|0;S(438,d|0,c|0,e- -64|0);f=x[31609];x[31609]=0;if((f|0)==1){break sb}f=x[a+1298472>>2];x[31609]=0;S(385,f|0,2,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break rb}tb(d);Eb(c)}if(!x[a+1074308>>2]){f=y[e+456|0]|y[e+457|0]<<8;if((f|0)!=2184){break lb}x[a+1074308>>2]=18284544}if(!Ad(x[j+4>>2],y[j+11|0])){break mb}x[31609]=0;c=P(1,e+100|0,18262)|0;d=x[31609];x[31609]=0;if((d|0)==1){break cb}f=x[a+1074308>>2];x[31609]=0;d=e+76|0;O(134,d|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break eb}x[31609]=0;f=e+160|0;S(2,f|0,c|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break fb}g=zb(j,f);tb(f);tb(d);tb(c);f=x[a+1074308>>2];if((y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24))==1414548815){break kb}if((f|0)!=18284544){break jb}f=18284544;if(!(t|(F|H))){break ib}break hb}b=N()|0;break N}b=N()|0;break qb}b=N()|0;tb(e+160|0)}Eb(e+100|0);break N}c=x[l>>2];x[31609]=0;O(439,Wb(c,h)|0,B|0);c=x[31609];x[31609]=0;if((c|0)!=1){break ab}}b=N()|0;break N}x[31609]=0;d=R(189,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Fa}x[31609]=0;I=R(189,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Ga}x[31609]=0;c=P(183,b|0,4)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Ga}if(!c){break ab}x[31609]=0;c=U(196,l|0,h&65535,I|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Ga}if(!c){break ab}x[31609]=0;c=e+100|0;S(185,c|0,b|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break Ha}n=hc(e+160|0,c);ub(c);d=x[l>>2];x[31609]=0;O(439,Wb(d,h)|0,B|0);d=x[31609];x[31609]=0;if((d|0)==1){break Ja}d=z[a+480188>>1];x[31609]=0;k=P(433,e+124|0,d|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Ka}d=z[a+480188>>1];w[e+104>>1]=0;x[31609]=0;x[e+100>>2]=0;m=U(440,e+88|0,d|0,c|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Ma}M=e,T=wb(x[Wb(x[l>>2],h)>>2]),x[M+76>>2]=T;G=0;while(1){ub:{vb:{wb:{xb:{if(G>>>0>=I>>>0){break xb}c=x[n>>2];x[31609]=0;c=U(150,c|0,x[e+168>>2],1)|0;d=x[31609];x[31609]=0;if((d|0)==1){break bb}if(!c){break xb}x[31609]=0;c=R(197,n|0)|0;d=x[31609];x[31609]=0;yb:{if((d|0)!=1){c=c<<24>>24;if(c){break yb}B_(e+76|0,z[a+480188>>1]);G=G+1|0;continue}break bb}zb:{d=c&127;i=d?d-1&65535:0;if(Xc(x[k>>2],x[e+128>>2])>>>0>i>>>0){break zb}x[31609]=0;v[e+100|0]=0;d=i+1|0;f=e+100|0;S(434,k|0,d|0,f|0);g=x[31609];x[31609]=0;if((g|0)==1){break bb}w[e+104>>1]=0;x[31609]=0;x[e+100>>2]=0;S(441,m|0,d|0,f|0);d=x[31609];x[31609]=0;if((d|0)!=1){break zb}break bb}if((c|0)<0){x[31609]=0;c=R(197,n|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break bb}M=xb(x[k>>2],i),T=c,v[M|0]=T}w[e+104>>1]=0;x[e+100>>2]=0;d=e+100|0;if(i>>>0<z[a+480188>>1]){d=Yc(x[e+76>>2],i)}g=xb(x[k>>2],i);f=y[g|0];if(f&16){M=d,T=y[Yc(x[m>>2],i)|0],v[M|0]=T;f=y[g|0]}if(f&32){M=d,T=y[Yc(x[m>>2],i)+1|0],v[M+1|0]=T;f=y[g|0]}if(f&64){c=Yc(x[m>>2],i);v[d+2|0]=y[c+2|0];v[d+4|0]=y[c+4|0];f=y[g|0]}if(f<<24>>24<0){c=Yc(x[m>>2],i);v[d+3|0]=y[c+3|0];v[d+5|0]=y[c+5|0];f=y[g|0]}if(f&1){x[31609]=0;c=R(197,n|0)|0;f=x[31609];x[31609]=0;Ab:{Bb:{if((f|0)!=1){c=c<<24>>24;c=(((c^-1)&128)>>>7|0)+c|0;if(!(v[L|0]&1)){break Bb}f=c;break Ab}break bb}f=253;if((c-121&255)>>>0<132){break Ab}f=(c&255)!=253?c:0}v[d|0]=f;M=Yc(x[m>>2],i),T=f,v[M|0]=T;g=xb(x[k>>2],i)}if(y[g|0]&2){x[31609]=0;c=R(197,n|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break bb}v[d+1|0]=c;M=Yc(x[m>>2],i),T=c,v[M+1|0]=T;g=xb(x[k>>2],i)}if(!(y[g|0]&4)){break ub}x[31609]=0;g=R(197,n|0)|0;c=x[31609];x[31609]=0;Cb:{Db:{if((c|0)!=1){if(g>>>0>64){break Db}v[d+4|0]=g;f=1;break Cb}break bb}if(g<<24>>24<=-64){f=2;v[d+2|0]=2;g=g&127;v[d+4|0]=g;break vb}if(g>>>0<=74){f=5;v[d+2|0]=5;g=g-65|0;v[d+4|0]=g;break vb}if(g>>>0<=84){f=6;v[d+2|0]=6;g=g-75|0;v[d+4|0]=g;break vb}if(g>>>0<=94){f=3;v[d+2|0]=3;g=g-85|0;v[d+4|0]=g;break vb}if(g>>>0<=104){f=4;v[d+2|0]=4;g=g-95|0;v[d+4|0]=g;break vb}if(g>>>0<=114){f=13;v[d+2|0]=13;g=g-105|0;v[d+4|0]=g;break vb}if(g>>>0<=124){f=12;v[d+2|0]=12;g=g-115|0;v[d+4|0]=g;break vb}c=g+63|0;if((c&255)>>>0<=9){v[d+4|0]=c;f=11;v[d+2|0]=11;g=c;break vb}c=g+53|0;J=c&255;if(J>>>0<=9){v[d+4|0]=c;f=8;v[d+2|0]=8;if(!J){g=0;break vb}if(x[a+1074308>>2]-1>>>0>18285139){break wb}f=7;v[d+2|0]=7;break wb}g=g+33|0;if((g&255)>>>0>=10){g=y[d+4|0];f=y[d+2|0];break vb}v[d+4|0]=g;f=15}v[d+2|0]=f;break vb}Nk(m);ec(k);ub(n);break ab}g=c}c=Yc(x[m>>2],i);v[c+4|0]=g;v[c+2|0]=f;g=xb(x[k>>2],i)}if(!(y[g|0]&8)){continue}x[31609]=0;c=e+52|0;O(198,c|0,n|0);f=x[31609];x[31609]=0;if((f|0)!=1){BD(d,y[e+52|0],y[Jc(c)|0],1);c=Yc(x[m>>2],i);v[c+3|0]=y[d+3|0];v[c+5|0]=y[d+5|0];continue}break}break bb}f=y[e+456|0]|y[e+457|0]<<8}Eb:{Fb:{Gb:{Hb:{Ib:{Jb:{Kb:{Lb:{Mb:{Nb:{Ob:{Pb:{c=f&65535;switch(c>>>12|0){case 13:break Jb;case 7:break Kb;case 6:break Lb;case 4:break Mb;case 1:break Ob;case 0:break Pb;default:break gb}}if(y[E|0]){x[31609]=0;c=P(1,e+160|0,8340)|0;d=x[31609];x[31609]=0;if((d|0)!=1){zb(j,c);tb(c);break gb}b=N()|0;break N}Qb:{Rb:{Sb:{Tb:{Ub:{Vb:{Wb:{Xb:{Yb:{c=f&65535;if((c|0)!=532){break Yb}d=y[e+458|0]|y[e+459|0]<<8;if((d|0)!=512){break Xb}if(y[e+462|0]|y[e+463|0]<<8|(y[e+460|0]|y[e+461|0]<<8)!=9|(y[e+447|0]|y[e+446|0])){break Yb}if(y[e+450|0]|y[e+451|0]<<8|((y[e+454|0]|y[e+455|0]<<8)+1|0)!=(y[e+448|0]|y[e+449|0]<<8)|(y[e+464|0]!=128|y[e+465|0]!=100)){break Yb}if(y[e+466|0]!=1|y[e+468|0]!=128|(y[e+469|0]|(y[e+470|0]|y[e+471|0]<<8))){break Yb}if(y[e+472|0]|y[e+473|0]<<8|(y[e+474|0]<<16|y[e+475|0]<<24)|(y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24))){break Yb}x[31609]=0;c=P(1,e+160|0,9876)|0;d=x[31609];x[31609]=0;if((d|0)!=1){zb(j,c);tb(c);break gb}b=N()|0;break N}Zb:{if((c|0)!=514|(y[e+458|0]|y[e+459|0]<<8)!=512|(y[e+447|0]|y[e+446|0])){break Zb}if(y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24)){break Zb}c=x[o>>2];if(mc(c,x[o+4>>2])){break Vb}d=x[q>>2];if(mc(d,x[q+4>>2])){break Vb}c=yb(c,0);g=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);if(!g){break Vb}c=yb(d,0);if(g>>>0>=(y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24))>>>0){break Vb}x[a+1074308>>2]=16777376;x[31609]=0;c=P(1,e+160|0,13487)|0;d=x[31609];x[31609]=0;if((d|0)!=1){zb(j,c);tb(c);v[e+415|0]=1;break gb}b=N()|0;break N}if((f&65535)!=532){break Wb}d=y[e+458|0]|y[e+459|0]<<8;if((d|0)!=512){break Xb}f=532;if(y[e+447|0]|y[e+446|0]){break Fb}d=512;if(y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24)){break Eb}_b:{if(y[e+462|0]&6){$b:{d=x[r>>2];if(oc(d,x[r+4>>2])>>>0<2){break $b}c=yb(d,1);f=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);c=yb(d,0);if((f-(y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24))|0)!=557){break $b}x[a+1074308>>2]=16777394;x[31609]=0;c=P(1,e+160|0,15298)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break _b}b=N()|0;break N}x[a+1074308>>2]=16777393;x[31609]=0;c=P(1,e+160|0,13377)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break _b}b=N()|0;break N}x[a+1074308>>2]=16777381;x[31609]=0;c=P(1,e+160|0,14997)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Ib}}zb(j,c);tb(c);v[e+415|0]=1;break gb}f=532;if((d|0)!=532){break Ub}if((y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24))==1229080643){x[31609]=0;c=P(1,e+160|0,8378)|0;d=x[31609];x[31609]=0;if((d|0)!=1){zb(j,c);tb(c);f=a+1074312|0;d=38;break Nb}b=N()|0;break N}if(y[e+469|0]|(y[e+462|0]|y[e+463|0]<<8)>>>0>1|(y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24)|((y[e+460|0]|y[e+461|0]<<8)&4294)!=4)){break Vb}if(!z[a+480190>>1]){break Vb}x[31609]=0;f=P(36,e+100|0,13620)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Sb}c=fb-32|0;fb=c;d=fb-16|0;fb=d;Uw(d+8|0,a+484527|0);uZ(c+24|0,x[d+8>>2],x[d+12>>2]);fb=d+16|0;fe(c+16|0,f);d=x[c+20>>2];x[c+8>>2]=x[c+16>>2];x[c+12>>2]=d;d=Ic(x[c+24>>2],x[c+28>>2],c+8|0);fb=c+32|0;tb(f);if(d){break Tb}f=y[e+456|0]|y[e+457|0]<<8}if(f&65535){break Vb}if(Ad(x[j+4>>2],y[j+11|0])){break Qb}}d=y[e+458|0]|y[e+459|0]<<8}if((d&65535)>>>0>767){break gb}break Eb}x[31609]=0;c=P(1,e+160|0,8404)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Rb}zb(j,c);tb(c);break gb}b=N()|0;break N}b=N()|0;break N}x[31609]=0;c=P(1,e+160|0,9766)|0;d=x[31609];x[31609]=0;if((d|0)!=1){zb(j,c);tb(c);break gb}b=N()|0;break N}f=y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24);x[31609]=0;d=e+160|0;S(442,d|0,c|0,y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24));g=x[31609];x[31609]=0;ac:{bc:{cc:{dc:{ec:{fc:{gc:{hc:{ic:{jc:{kc:{lc:{mc:{nc:{if((g|0)!=1){zb(j,d);tb(d);c=(c|0)==8191?f:c-4176|0;if((c|0)>1915){break nc}d=x[a+480208>>2];if(!(d&16)){break mc}x[31609]=0;P(267,a+1074312|0,7)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break lc}break Gb}b=N()|0;break N}if(c>>>0>4200){break jc}d=x[a+480208>>2]}if(!(d&16)){x[31609]=0;P(267,a+1074312|0,7)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Gb}}if((c|0)>2385){break kc}}x[31609]=0;P(267,a+1074312|0,38)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Gb}}x[31609]=0;c=P(267,a+1074312|0,102)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Gb}x[31609]=0;P(267,c|0,48)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Gb}break ic}if(c>>>0>4383){break hc}}x[31609]=0;c=U(266,a+1074312|0,116,1)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Gb}x[31609]=0;P(267,c|0,115)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Gb}break gc}if(c>>>0>4563){break fc}}x[31609]=0;c=P(267,a+1074312|0,43)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Gb}x[31609]=0;c=P(267,c|0,42)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Gb}x[31609]=0;P(267,c|0,87)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Gb}break ec}if(c>>>0>4876){break dc}}x[31609]=0;P(267,a+1074312|0,120)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Gb}break cc}if(c>>>0>5100){break bc}}x[31609]=0;c=P(267,a+1074312|0,47)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Gb}x[31609]=0;P(267,c|0,39)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Gb}break ac}if(c>>>0>5103){break gb}}x[31609]=0;f=P(267,a+1074312|0,44)|0;c=x[31609];x[31609]=0;d=87;if((c|0)==1){break Gb}}x[31609]=0;P(267,f|0,d|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Gb}break gb}x[31609]=0;c=e+100|0;W(443,c|0);d=x[31609];x[31609]=0;oc:{pc:{qc:{if((d|0)!=1){d=y[e+456|0]|y[e+457|0]<<8;x[e+64>>2]=d>>>8&15;x[31609]=0;x[e+52>>2]=d&255;d=e+76|0;O(444,d|0,e+52|0);f=x[31609];x[31609]=0;if((f|0)==1){break qc}x[31609]=0;f=e+160|0;V(430,f|0,c|0,e- -64|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break pc}zb(j,f);tb(f);tb(d);Eb(c);break gb}b=N()|0;break N}b=N()|0;break oc}b=N()|0;tb(e+76|0)}Eb(e+100|0);break N}x[31609]=0;c=P(1,e+160|0,8340)|0;d=x[31609];x[31609]=0;if((d|0)!=1){zb(j,c);tb(c);break gb}b=N()|0;break N}if(!((c|0)!=32767|(y[e+458|0]|y[e+459|0]<<8)!=533)){x[31609]=0;c=P(1,e+160|0,5042)|0;d=x[31609];x[31609]=0;if((d|0)!=1){zb(j,c);tb(c);break gb}b=N()|0;break N}x[31609]=0;c=e+100|0;O(131,c|0,4150);d=x[31609];x[31609]=0;rc:{if((d|0)!=1){d=y[e+456|0]|y[e+457|0]<<8;x[e+76>>2]=d>>>8&15;x[e+64>>2]=d>>>4&15;x[31609]=0;x[e+52>>2]=d&15;d=e+160|0;aa(132,d|0,c|0,e+76|0,e- -64|0,e+52|0);f=x[31609];x[31609]=0;if((f|0)==1){break rc}zb(j,d);tb(d);Eb(c);break gb}b=N()|0;break N}b=N()|0;Eb(e+100|0);break N}x[31609]=0;c=P(1,e+160|0,6123)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Hb}zb(j,c);tb(c);break gb}b=N()|0;break N}b=N()|0;break N}b=N()|0;break N}d=512}if(!Ad(x[j+4>>2],y[j+11|0])){break gb}sc:{tc:{uc:{vc:{wc:{if((d&65535)>>>0>=533){x[31609]=0;c=P(1,e+76|0,15029)|0;d=x[31609];x[31609]=0;if((d|0)!=1){zb(j,c);tb(c);break wc}b=N()|0;break N}if((f&65535)>>>0>=533){x[31609]=0;c=e+76|0;O(445,c|0,4015);d=x[31609];x[31609]=0;xc:{if((d|0)!=1){x[31609]=0;x[e+64>>2]=(y[e+456|0]|y[e+457|0]<<8)-532;d=e+160|0;S(446,d|0,c|0,e- -64|0);f=x[31609];x[31609]=0;if((f|0)==1){break xc}zb(j,d);tb(d);Eb(c);break wc}b=N()|0;break N}b=N()|0;Eb(e+76|0);break N}x[31609]=0;c=e+76|0;O(268,c|0,4314);d=x[31609];x[31609]=0;if((d|0)==1){break vc}d=y[e+456|0]|y[e+457|0]<<8;x[e+52>>2]=d>>>8&15;x[31609]=0;x[e+40>>2]=d&255;d=e- -64|0;O(444,d|0,e+40|0);f=x[31609];x[31609]=0;if((f|0)==1){break uc}x[31609]=0;f=e+160|0;V(430,f|0,c|0,e+52|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break tc}zb(j,f);tb(f);tb(d);Eb(c)}if(!mc(x[a+1298412>>2],x[a+1298416>>2])){break gb}c=y[e+476|0]|y[e+477|0]<<8|(y[e+478|0]<<16|y[e+479|0]<<24);if(!c){break gb}c=HF(y[e+456|0]|y[e+457|0]<<8,c);d=jp(e+160|0);x[d+32>>2]=c;x[31609]=0;O(447,a+1298412|0,d|0);c=x[31609];x[31609]=0;if((c|0)!=1){break gb}b=N()|0;break N}b=N()|0;break N}b=N()|0;break sc}b=N()|0;tb(e- -64|0)}Eb(e+76|0);break N}if(!(t|((f|0)!=18284544|H|F))){break ib}break hb}if(((y[e+456|0]|y[e+457|0]<<8)&61440)!=20480){break hb}}x[31609]=0;c=P(1,e+160|0,16916)|0;d=x[31609];x[31609]=0;yc:{if((d|0)!=1){x[31609]=0;P(74,g|0,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break yc}tb(c);break gb}b=N()|0;break N}b=N()|0;tb(c);break N}if(!TG(f)){break gb}x[31609]=0;c=P(1,e+160|0,17152)|0;d=x[31609];x[31609]=0;zc:{if((d|0)!=1){x[31609]=0;P(74,g|0,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break zc}tb(c);break gb}b=N()|0;break N}b=N()|0;tb(c);break N}Ac:{Bc:{Cc:{Dc:{Ec:{Fc:{Gc:{Hc:{Ic:{if(K&1){x[31609]=0;c=P(1,e- -64|0,17166)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Ic}x[31609]=0;P(74,j|0,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Hc}tb(c)}f=x[a+480180>>2];if(!((f|0)!=16777216|(y[e+456|0]|y[e+457|0]<<8)>>>0<2186)){x[31609]=0;c=P(149,b|0,u|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break $a}if(c){x[31609]=0;S(448,a|0,b|0,y[e+456|0]|y[e+457|0]<<8);b=x[31609];x[31609]=0;if((b|0)==1){break $a}}f=x[a+480180>>2]}if((f|0)!=16777216){break Gc}x[31609]=0;P(1,e+52|0,13913)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break Fc}b=N()|0;break N}b=N()|0;break N}b=N()|0;tb(c);break N}x[31609]=0;b=e+40|0;O(268,b|0,4314);c=x[31609];x[31609]=0;if((c|0)==1){break Ec}c=y[e+458|0]|y[e+459|0]<<8;x[e+36>>2]=c>>>8;x[31609]=0;x[e+20>>2]=c&255;c=e+24|0;O(444,c|0,e+20|0);d=x[31609];x[31609]=0;if((d|0)==1){break Dc}x[31609]=0;V(430,e+52|0,b|0,e+36|0,c|0);b=x[31609];x[31609]=0;if((b|0)==1){break Cc}}b=e+52|0;zb(a+1298344|0,b);tb(b);if((f|0)!=16777216){tb(e+24|0);Eb(e+40|0)}b=x[a+480180>>2];x[31609]=0;b=P(1,e+52|0,((b|0)==16777216?10140:6127)|0)|0;c=x[31609];x[31609]=0;f=1;if((c|0)==1){break Ac}zb(a+1298356|0,b);tb(b);zb(a+1298368|0,j);M=a+1298404|0,T=x[Fc(e+36|0,x[a+1074308>>2]?22:4)>>2],x[M>>2]=T;x[a+1298408>>2]=0;ub(C);ub(B);break s}b=N()|0;break N}b=N()|0;break Bc}b=N()|0;tb(e+24|0)}Eb(e+40|0);break N}b=N()|0;break N}b=N()|0;tb(e+76|0);break db}b=N()|0}tb(c);break N}b=N()|0;break N}b=N()|0;Nk(m);break La}h=h+1|0;continue}}b=N()|0;break N}b=N()|0;break N}b=N()|0;break N}b=N()|0}ec(k);break Ia}b=N()|0;break Ia}b=N()|0}ub(n);break N}b=N()|0;break N}b=N()|0;break N}b=N()|0;break N}b=N()|0}ub(d);break N}b=N()|0;break N}b=N()|0;break N}b=N()|0;break N}b=N()|0;tb(e+160|0);break xa}b=N()|0}Eb(e+100|0);break N}b=N()|0;break N}b=N()|0;break N}d=0;g=AD(e+100|0,x[i>>2]);x[31609]=0;P(183,b|0,g|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break _}}g=y[e+103|0];if(!x[i>>2]|(g|0)!=1){break ba}m=1;break aa}K=(g|0)==10|K}x[e+100>>2]=x[b+8>>2];M=e,T=x[bd(e+240|0,e+100|0)>>2],x[M+240>>2]=T;t=(d|0)!=0}f=f+1|0;d=z[a+480190>>1];continue}break}b=N()|0;break N}Jc:{d=yb(x[r>>2],f);d=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);Kc:{if(!d){break Kc}x[31609]=0;d=P(149,b|0,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break Jc}if(!d){break Kc}d=x[b+8>>2];g=x[b>>2];x[31609]=0;d=U(150,g|0,d|0,554)|0;g=x[31609];x[31609]=0;if((g|0)==1){break Jc}if(!d){break Kc}x[31609]=0;d=U(251,a|0,f+1&65535,0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break Z}if(!d){break Kc}x[31609]=0;V(449,a|0,b|0,d|0,y[e+458|0]|y[e+459|0]<<8);g=x[31609];x[31609]=0;if((g|0)==1){break Z}v[d+33|0]=y[e+469|0]}f=f+1|0;d=z[a+480192>>1];continue}break}b=N()|0;break N}b=N()|0;break N}b=N()|0;break N}b=N()|0}ub(C)}ub(B);break t}b=N()|0;break t}b=N()|0;break t}}}}}b=N()|0}wc(o);wc(q);wc(r);break a}wc(o);wc(q);wc(r)}tb(j)}fb=e+608|0;return f|0}b=N()|0}tb(j);Q(b|0);p()}function Kqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,T=0;d=fb-1712|0;fb=d;yc(b);h=d+1704|0;a:{if(!wi(b,h)){break a}if(!wY(h)){break a}g=1;if((c|0)==64){break a}m=y[d+1707|0];v[d+1703|0]=m;x[d+1696>>2]=-1;x[d+1692>>2]=1048576;if(m>>>0>=5){h=Rg(b);x[d+1696>>2]=h;g=0;if(!Mb(x[b>>2],x[b+8>>2],h)){break a}x[d+288>>2]=134217727;M=d,T=x[Hb(d+288|0,d+1696|0)>>2]<<5,x[M+1692>>2]=T}C=Nb(d+1680|0);x[d+288>>2]=y[d+1708|0]|y[d+1709|0]<<8|(y[d+1710|0]<<16|y[d+1711|0]<<24);h=x[Hb(d+1692|0,d+288|0)>>2];x[31609]=0;O(553,C|0,h|0);h=x[31609];x[31609]=0;b:{c:{d:{e:{f:{if((h|0)!=1){x[31609]=0;h=U(554,b|0,C|0,y[d+1708|0]|y[d+1709|0]<<8|(y[d+1710|0]<<16|y[d+1711|0]<<24))|0;e=x[31609];x[31609]=0;g:{if((e|0)==1){break g}g=0;if(!h){break b}if(m>>>0>=5){x[31609]=0;P(149,b|0,x[d+1696>>2]+12|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break g}}x[31609]=0;O(246,a|0,0);h=x[31609];x[31609]=0;if((h|0)==1){break g}eg(a);se(d+1648|0,x[C>>2],x[C+4>>2]);h=Md(d+1640|0);x[31609]=0;e=x[h+4>>2];x[d+88>>2]=x[h>>2];x[d+92>>2]=e;n=hg(555,d+1660|0,x[d+1648>>2],x[d+1652>>2],d+88|0);h=x[31609];x[31609]=0;h:{i:{j:{if((h|0)!=1){x[31609]=0;S(358,n|0,a+1298308|0,-1);h=x[31609];x[31609]=0;if((h|0)==1){break j}x[31609]=0;S(358,n|0,a+1298332|0,-1);h=x[31609];x[31609]=0;if((h|0)==1){break j}x[31609]=0;h=P(556,n|0,d+1218|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break f}if(!h){break c}h=v[d+1218|0];if((h|0)<=0|(y[d+1227|0]|y[d+1228|0]<<8)>>>0>255|(y[d+1229|0]|y[d+1230|0]<<8)>>>0>3999){break c}w[a+480188>>1]=h&255;$e(Xb(x[a+484360>>2],y[a+484376|0]),y[d+1221|0]|y[d+1222|0]<<8);w[a+480192>>1]=y[d+1227|0]|y[d+1228|0]<<8;w[a+480190>>1]=y[d+1229|0]|y[d+1230|0]<<8;h=y[d+1231|0];x[a+480196>>2]=h?h:6;h=y[d+1232|0];x[a+480204>>2]=D(h?h:125,1e4);e=y[d+1233|0]|y[d+1234|0]<<8|(y[d+1235|0]<<16|y[d+1236|0]<<24);h=32;k:{if(e&256){break k}h=2;if(e&2){break k}h=1;if(e&128){break k}h=e&8?16:4}x[31609]=0;O(417,a|0,h|0);h=x[31609];x[31609]=0;if((h|0)==1){break f}h=x[a+480208>>2];e=h|16777216;x[a+480208>>2]=e;f=y[d+1233|0]|y[d+1234|0]<<8|(y[d+1235|0]<<16|y[d+1236|0]<<24);if(f&1){e=h|16777232;x[a+480208>>2]=e}h=x[a+480180>>2];j=(h|0)==32;i=j&!(f&1024);l=(h|0)==2;g=l&f>>>4;s=f&2097152;l=l&f>>>2;j=j&!(f&2048);if(i|(s|l|(j|g))){e=g?e|65536:e;e=l?e|2:e;e=j?e|4:e;x[a+480208>>2]=s>>>6|(i?e|8:e)}if(f&524288){x[31609]=0;U(266,a+1074312|0,5,1)|0;h=x[31609];x[31609]=0;if((h|0)==1){break f}h=x[a+480180>>2]}if((h|0)==2){break i}if((h|0)!=32){break h}v[d+288|0]=y[d+1237|0];v[d+220|0]=128;M=a,T=y[Qb(d+288|0,d+220|0)|0]<<1,x[M+480200>>2]=T;break h}f=N()|0;break d}f=N()|0;break e}v[d+288|0]=y[d+1237|0];v[d+220|0]=64;M=a,T=y[Qb(d+288|0,d+220|0)|0]<<2,x[M+480200>>2]=T}E=a+480188|0;e=v[d+1239|0];l:{if((e|0)<0){f=e+52<<24>>24;break l}G=Dt(+(e|0)*3.1/20);m:{if(G<4294967296&G>=0){f=~~G>>>0;break m}f=0}f=f+51|0}x[a+480228>>2]=f;w[d+288>>1]=64;i=z[Oc(E,d+288|0)>>1];e=0;j=(h|0)!=32;l=(h|0)==4;g=0;while(1)if((g|0)==(i|0)){g=0;j=0;while(1){if((e|0)!=16){j=y[(d+e|0)+1368|0]!=0|j;e=e+1|0;continue}break}while(1){if((g|0)!=128){j=y[((g<<1)+d|0)+1385|0]!=0|j;g=g+1|0;continue}break}n:{if(!(j&1)){break n}h=a+901692|0;g=0;while(1){if((g|0)==16){h=a+902204|0;g=0;while(1){if((g|0)!=128){e=(d+1218|0)+(g<<1)|0;o:{if(y[e+167|0]){x[31609]=0;f=d+220|0;W(557,f|0);i=x[31609];x[31609]=0;p:{q:{r:{s:{t:{if((i|0)!=1){i=y[e+167|0];x[31609]=0;x[d+244>>2]=i-1;i=d+1164|0;O(558,i|0,d+244|0);j=x[31609];x[31609]=0;if((j|0)==1){break t}e=y[e+166|0];x[31609]=0;v[d+192|0]=e;e=d+1144|0;O(559,e|0,d+192|0);j=x[31609];x[31609]=0;if((j|0)==1){break s}x[31609]=0;j=d+288|0;V(560,j|0,f|0,i|0,e|0);l=x[31609];x[31609]=0;if((l|0)==1){break r}fe(d+1192|0,j);rf(Pe(h,g),x[d+1192>>2],x[d+1196>>2]);tb(j);tb(e);tb(i);Eb(f);break o}f=N()|0;break e}f=N()|0;break p}f=N()|0;break q}f=N()|0;tb(d+1144|0)}tb(d+1164|0)}Eb(d+220|0);break e}e=qc(d+1184|0,22292);rf(Pe(h,g),x[e>>2],x[d+1188>>2])}g=g+1|0;continue}break}h=x[a+480180>>2];break n}f=(d+g|0)+1368|0;u:{if(y[f|0]){x[31609]=0;e=d+220|0;W(561,e|0);i=x[31609];x[31609]=0;v:{w:{x:{if((i|0)!=1){f=y[f|0];x[31609]=0;x[d+1144>>2]=f-1;f=d+1164|0;O(558,f|0,d+1144|0);i=x[31609];x[31609]=0;if((i|0)==1){break x}x[31609]=0;i=d+288|0;S(290,i|0,e|0,f|0);j=x[31609];x[31609]=0;if((j|0)==1){break w}fe(d+1208|0,i);rf(Pe(h,g),x[d+1208>>2],x[d+1212>>2]);tb(i);tb(f);Eb(e);break u}f=N()|0;break e}f=N()|0;break v}f=N()|0;tb(d+1164|0)}Eb(d+220|0);break e}e=qc(d+1200|0,22292);rf(Pe(h,g),x[e>>2],x[d+1204>>2])}g=g+1|0;continue}}e=y[a+484376|0];f=x[a+484360>>2];x[31609]=0;h=h&5;aa(348,Xb(f,e)|0,n|0,y[d+1219|0]|y[d+1220|0]<<8,(h?65535:255)|0,(h?65535:254)|0);h=x[31609];x[31609]=0;if((h|0)!=1){x[31609]=0;h=d+288|0;S(185,h|0,n|0,D(y[d+1218|0],y[d+1223|0]|y[d+1224|0]<<8)<<1);e=x[31609];x[31609]=0;if((e|0)!=1){H=hc(d+1164|0,h);ub(h);x[31609]=0;S(185,h|0,n|0,(y[d+1223|0]|y[d+1224|0]<<8)<<1);e=x[31609];x[31609]=0;y:{if((e|0)!=1){I=hc(d+1144|0,h);ub(h);x[31609]=0;s=P(214,d+1132|0,y[d+1225|0]|y[d+1226|0]<<8)|0;h=x[31609];x[31609]=0;z:{if((h|0)!=1){M=d,T=wb(x[s>>2]),x[M+244>>2]=T;e=wb(x[s+4>>2]);A:{B:{C:{while(1){f=x[d+244>>2];if(!Ib(f,e)){h=x[a+480180>>2];t=c&1;if(!t){break B}x[31609]=0;O(223,a+484344|0,y[d+1223|0]|y[d+1224|0]<<8);e=x[31609];x[31609]=0;if((e|0)!=1){break B}f=N()|0;break A}x[31609]=0;i=R(151,n|0)|0;h=x[31609];x[31609]=0;if((h|0)!=1){x[31609]=0;h=d+220|0;S(185,h|0,n|0,i|0);i=x[31609];x[31609]=0;if((i|0)==1){break C}i=f;f=hc(d+288|0,h);kd(i,f);ub(f);ub(h);Qf(d+244|0);continue}break}f=N()|0;break A}f=N()|0;break A}r=(h|0)==16?14:(h|0)==32?1:13;J=a+484344|0;l=1;while(1){D:{E:{F:{G:{H:{I:{if((y[d+1223|0]|y[d+1224|0]<<8)>>>0<=q>>>0){switch(x[a+480180>>2]-1|0){case 0:break G;case 3:break I;default:break F}}x[31609]=0;h=R(189,I|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break H}x[d+220>>2]=h;if(!t){break D}x[31609]=0;e=U(196,J|0,q&65535,h|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break H}h=0;if(!e){break D}while(1){f=h&65535;if(f>>>0>=y[d+1218|0]){break D}x[31609]=0;e=R(189,H|0)|0;i=x[31609];x[31609]=0;J:{if((i|0)!=1){i=x[s>>2];if(Sf(i,x[s+4>>2])>>>0<=e>>>0){break J}k=ch(i,e);yc(k);e=0;i=Wb(x[J>>2],q);g=md(x[i>>2],x[x[i+48>>2]+12>>2],0,f);K:while(1){if(A[d+220>>2]<=e>>>0){break J}x[31609]=0;f=R(197,k|0)|0;i=x[31609];x[31609]=0;if((i|0)!=1){if(!f){break J}u=f>>>4|0;B=f&15;j=0;i=Ng(d+288|0);while(1){L:{M:{N:{if(B>>>0>(j&255)>>>0){x[31609]=0;f=d+244|0;O(198,f|0,k|0);o=x[31609];x[31609]=0;if((o|0)==1){break N}O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{_:{$:{aa:{ba:{ca:{da:{ea:{f=y[xb(f,0)|0];switch(f-1|0){case 2:case 3:case 4:case 7:case 8:case 9:case 11:case 12:case 13:case 16:case 18:case 21:case 22:case 23:case 24:case 25:case 27:case 32:break O;case 33:break S;case 30:case 31:break T;case 29:break U;case 28:break V;case 26:break W;case 19:case 20:break X;case 17:break Y;case 15:break Z;case 14:break _;case 10:break $;case 6:break aa;case 5:break ba;case 1:break ca;case 0:break da;default:break ea}}switch(f-48|0){case 4:break P;case 1:case 2:break Q;case 0:break R;default:break O}}f=y[xb(d+244|0,1)|0];fa:{if(f>>>0<=119){f=f+r|0;break fa}ga:{switch(f-254|0){case 1:f=255;break fa;case 0:f=254;break fa;default:break ga}}f=253}v[i|0]=f;l=OD(f)&l;break L}M=d,T=y[xb(d+244|0,1)|0]+1|0,v[M+289|0]=T;break L}ha:{if(y[d+290|0]){break ha}f=x[a+480180>>2];if((f|0)!=32){if((f|0)!=4){break ha}f=y[xb(d+244|0,1)|0];if(f&15){break ha}v[d+290|0]=11;v[d+292|0]=f>>>4;break L}f=0;o=y[xb(d+244|0,1)|0];while(1){if((f|0)==10){break ha}if((o|0)==y[f+42144|0]){v[d+292|0]=f;v[d+290|0]=11;break L}else{f=f+1|0;continue}}}M=d,T=y[xb(d+244|0,1)|0],v[M+293|0]=T;v[d+291|0]=4;break L}f=xb(d+244|0,1);ia:{if(y[d+290|0]){break ia}o=y[f|0];if(x[a+480180>>2]!=32|o>>>0>9){break ia}v[d+292|0]=o;v[d+290|0]=8;break L}v[d+293|0]=y[f|0];v[d+291|0]=5;break L}ja:{if(y[d+290|0]){break ja}ka:{f=x[a+480180>>2];if((f|0)!=4){if((f|0)!=32){break ja}f=xb(d+244|0,1);o=y[f|0];if((o|0)!=255){break ka}v[d+292|0]=64;v[d+290|0]=2;break L}f=xb(d+244|0,1);if(y[f|0]&15){break ja}break M}if(!(o&3)){break M}}M=d,T=y[xb(d+244|0,1)|0],v[M+293|0]=T;v[d+291|0]=9;break L}o=y[d+290|0];f=xb(d+244|0,1);la:{if(o|x[a+480180>>2]==1){break la}o=y[f|0];if(o>>>0>64){break la}v[d+292|0]=o;v[d+290|0]=1;break L}v[d+293|0]=y[f|0];v[d+291|0]=13;break L}f=y[xb(d+244|0,1)|0];v[d+293|0]=f;v[d+291|0]=14;if(x[a+480180>>2]==32){break L}v[d+293|0]=D((f&240)>>>4|0,10)+(f&15);break L}f=y[xb(d+244|0,1)|0];v[d+293|0]=f;v[d+291|0]=f>>>0<32?16:17;break L}o=y[xb(d+244|0,1)|0];if(o>>>0>=16){v[d+292|0]=o>>>4;v[d+290|0]=(f|0)==20?3:5;break L}v[d+292|0]=o;v[d+290|0]=(f|0)==20?4:6;break L}f=y[xb(d+244|0,1)|0];if(f>>>0>=16){v[d+290|0]=10;v[d+292|0]=f>>>4;break L}v[d+292|0]=f;v[d+290|0]=9;break L}f=y[xb(d+244|0,1)|0];v[d+291|0]=28;v[d+293|0]=f|16;break L}f=y[xb(d+244|0,1)|0];v[d+291|0]=28;v[d+293|0]=f|32;break L}M=d,T=y[xb(d+244|0,1)|0],v[M+292|0]=T;v[d+290|0]=(f|0)==31?7:8;break L}f=y[d+291|0];v[d+291|0]=(f|0)==4?6:(f|0)==5?7:11;M=d,T=y[xb(d+244|0,1)|0],v[M+293|0]=T;break L}f=xb(d+244|0,1);v[d+292|0]=y[f|0]%10;f=y[f|0];if(f>>>0<=9){v[d+290|0]=5;break L}if(f>>>0<=19){v[d+290|0]=6;break L}if(f>>>0<=29){v[d+290|0]=3;break L}if(f>>>0>39){break L}v[d+290|0]=4;break L}M=d,T=y[xb(d+244|0,1)|0],v[M+292|0]=T;v[d+290|0]=(f|0)==49?13:12;break L}f=y[xb(d+244|0,1)|0]+33|0;if((f&255)>>>0>9){break L}v[d+290|0]=15;v[d+292|0]=f;break L}if(f>>>0>57){break L}M=d,T=y[xb(d+244|0,1)|0],v[M+293|0]=T;v[d+291|0]=y[f+25216|0];break L}x[d+244>>2]=e+u;f=x[Hb(d+244|0,d+220|0)>>2];f=e>>>0>f>>>0?e:f;while(1){if((e|0)!=(f|0)){j=y[i|0]|y[i+1|0]<<8|(y[i+2|0]<<16|y[i+3|0]<<24);v[g|0]=j;v[g+1|0]=j>>>8;v[g+2|0]=j>>>16;v[g+3|0]=j>>>24;j=y[i+4|0]|y[i+5|0]<<8;v[g+4|0]=j;v[g+5|0]=j>>>8;e=e+1|0;g=D(y[d+1218|0],6)+g|0;continue}break}e=f;continue K}f=N()|0;break A}f=y[f|0];v[d+290|0]=2;v[d+292|0]=f>>>2}j=j+1|0;continue}}break}f=N()|0;break A}f=N()|0;break A}h=h+1|0;continue}}g=z[a+480192>>1];h=0;break E}f=N()|0;break A}if(!(z[E>>1]==4&l)){break F}x[a+480208>>2]=x[a+480208>>2]|8454144}g=0;h=!((y[d+1233|0]|y[d+1234|0]<<8|(y[d+1235|0]<<16|y[d+1236|0]<<24))&512)}x[31609]=0;o=P(562,d+1120|0,g|0)|0;e=x[31609];x[31609]=0;ma:{na:{oa:{pa:{qa:{if((e|0)!=1){g=m>>>0<5;j=1;ra:{while(1){i=j&65535;if(i>>>0>z[a+480192>>1]){break ra}sa:{ta:{ua:{va:{if(!h){x[31609]=0;f=U(251,a|0,i|0,0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break va}if(f){break ua}}while(1){x[31609]=0;e=R(197,n|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break na}if(e){continue}break}if(!g){while(1){x[31609]=0;e=R(197,n|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){f=N()|0;break ma}if(e){continue}break}}x[31609]=0;P(183,n|0,826)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break ta}}f=N()|0;break ma}e=Fb(d+220|0);x[31609]=0;S(358,n|0,e|0,-1);l=x[31609];x[31609]=0;if((l|0)==1){break sa}Ac(f+492|0,e);if(!g){x[31609]=0;S(358,n|0,e|0,-1);l=x[31609];x[31609]=0;if((l|0)==1){break sa}Ac(f+524|0,e)}x[31609]=0;l=d+288|0;q=P(563,n|0,l|0)|0;m=x[31609];x[31609]=0;if((m|0)==1){break oa}if(!q){break qa}q=x[a+480180>>2];x[31609]=0;S(564,l|0,f|0,q|0);f=x[31609];x[31609]=0;if((f|0)==1){break oa}if(x[a+480180>>2]==4){f=yb(x[o>>2],i-1|0);i=y[d+1090|0]|y[d+1091|0]<<8|(y[d+1092|0]<<16|y[d+1093|0]<<24);v[f|0]=i;v[f+1|0]=i>>>8;v[f+2|0]=i>>>16;v[f+3|0]=i>>>24}tb(e)}j=j+1|0;continue}break}break oa}if(!h){break pa}w[a+480192>>1]=0;break pa}f=N()|0;break A}tb(e)}h=z[a+480190>>1];x[31609]=0;q=P(565,d+276|0,h|0)|0;h=x[31609];x[31609]=0;if((h|0)!=1){B=y[d+1703|0];L=!(v[d+1233|0]&1)|B>>>0>4;t=c&2;j=1;c=0;while(1){h=c;wa:{xa:{ya:{za:{Aa:{Ba:{Ca:{Da:{Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{Ka:{La:{Ma:{Na:{Oa:{Pa:{Qa:{l=j&65535;if(l>>>0<=z[a+480190>>1]){g=Fb(d+264|0);x[31609]=0;S(358,n|0,g|0,-1);c=x[31609];x[31609]=0;Ra:{Sa:{if((c|0)!=1){Ac(((l<<5)+a|0)+946304|0,g);c=B>>>0<5;if(c){break Sa}x[31609]=0;S(358,n|0,g|0,-1);e=x[31609];x[31609]=0;if((e|0)!=1){break Ra}}f=N()|0;break za}sf(g)}x[31609]=0;e=d+288|0;f=P(566,n|0,e|0)|0;i=x[31609];x[31609]=0;Ta:{Ua:{if((i|0)==1){break Ua}if(!f){break Ta}i=x[a+480180>>2];x[31609]=0;k=e;f=D(l,104)+a|0;e=f+484380|0;V(567,k|0,e|0,i|0,L|0);i=x[31609];x[31609]=0;if((i|0)==1){break Ua}Be(f+484423|0,g);r=0;Va:{if(((y[d+308|0]|y[d+309|0]<<8)&61440)!=28672|c){break Va}x[31609]=0;r=R(568,n|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break Va}f=N()|0;break za}if(!t){break xa}i=y[d+323|0]|y[d+324|0]<<8|(y[d+325|0]<<16|y[d+326|0]<<24);c=y[d+308|0]|y[d+309|0]<<8;m=c&61440;if(!(i|m)){c=Zc(d+220|0,c&1?16:8,c&1024?3:1,0,0);x[31609]=0;U(215,c|0,e|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break xa}f=N()|0;break za}if((i|0)<0){c=i+l|0;if((c|0)<=0){break xa}vY(e,(D(c,104)+a|0)+484380|0);break xa}if((i|0)<=0){break xa}if(c&1){k=f+484414|0;w[k>>1]=z[k>>1]|1}if(c&1024){k=f+484414|0;w[k>>1]=z[k>>1]|64}x[31609]=0;k=d+220|0;S(185,k|0,b|0,i|0);i=x[31609];x[31609]=0;Wa:{Xa:{Ya:{Za:{_a:{$a:{if((i|0)!=1){i=hc(d+244|0,k);ub(k);k=_d(z[e+34>>1]);K=(m|0)==16384;if(!K&(m|0)!=8192){break Za}u=x[i>>2];x[31609]=0;u=R(154,u|0)|0;F=x[31609];x[31609]=0;if((F|0)==1){break Wa}F=4/(k>>>0)|0;Iua(F,0,u,0);xc(e,hb?-1:D(u,F));if((m|0)==8192){break $a}if(!K){break Za}if(!Gh(e)){break Ya}c=x[f+484400>>2];e=x[e>>2];if(!(v[d+308|0]&1)){break _a}x[31609]=0;V(569,i|0,c|0,e|0,k|0);e=x[31609];x[31609]=0;c=h;if((e|0)==1){break Ba}break Xa}f=N()|0;break za}if(!Gh(e)){break Ya}c=x[f+484400>>2];e=x[e>>2];if(v[d+308|0]&1){x[31609]=0;V(570,i|0,c|0,e|0,k|0);e=x[31609];x[31609]=0;c=h;if((e|0)!=1){break Xa}break Ba}x[31609]=0;V(571,i|0,c|0,e|0,k|0);e=x[31609];x[31609]=0;c=h;if((e|0)==1){break Ba}break Xa}x[31609]=0;V(572,i|0,c|0,e|0,k|0);e=x[31609];x[31609]=0;c=h;if((e|0)==1){break Ba}break Xa}if((c&45056)==12288){c=uY(d+220|0,i,y[d+327|0]|y[d+328|0]<<8,r);M=kd(wf(x[q>>2],l-1|0),c),T=x[c+20>>2],x[M+20>>2]=T;ub(c);break Ya}if((m|0)!=32768){c=1;if((m|0)!=4096){break Xa}m=Ie(d+220|0,i);x[31609]=0;c=P(573,d+214|0,i|0)|0;k=x[31609];x[31609]=0;if((k|0)!=1){ab:{bb:{if(!y[d+219|0]){break bb}r=y[d+327|0]|y[d+328|0]<<8;k=z[d+216>>1]<<1;if(r>>>0<(k&65535)>>>0){break bb}k=r-k|0;v[d+327|0]=k;v[d+328|0]=k>>>8;c=z[c>>1];x[31609]=0;P(149,i|0,c|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break ab}x[31609]=0;k=R(202,i|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break ab}x[31609]=0;c=d+172|0;S(185,c|0,i|0,k|0);k=x[31609];x[31609]=0;if((k|0)==1){break ab}k=hc(d+192|0,c);kd(m,k);ub(k);ub(c)}x[31609]=0;l=U(574,a|0,l|0,m|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break ab}c=1;if(l){c=y[d+327|0]|y[d+328|0]<<8;cb:{if(!c){break cb}l=z[e+34>>1];k=Rk(x[e>>2],l);if(k>>>0<=c>>>0){break cb}l=_k(l);f=x[f+484400>>2];gl(f,c+f|0,k-c|0);x[e>>2]=x[e>>2]-((c>>>0)/(l>>>0)|0)}xc(e,y[d+296|0]|y[d+297|0]<<8|(y[d+298|0]<<16|y[d+299|0]<<24));c=h}ub(m);break Xa}}f=N()|0;ub(m);break Aa}x[31609]=0;c=P(428,i|0,d+220|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Qa}if(!c){break Ya}x[d+80>>2]=y[d+228|0]|y[d+229|0]<<8|(y[d+230|0]<<16|y[d+231|0]<<24);c=y[d+224|0]|y[d+225|0]<<8|(y[d+226|0]<<16|y[d+227|0]<<24);x[d+72>>2]=y[d+220|0]|y[d+221|0]<<8|(y[d+222|0]<<16|y[d+223|0]<<24);x[d+76>>2]=c;Tk(e,1,d+72|0)}c=h}ub(i);break wa}f=N()|0;break Aa}f=N()|0;break za}tb(g)}db:{if(!t){break db}l=1;while(1){i=l&65535;if(i>>>0>z[a+480190>>1]){break db}b=wf(x[q>>2],i-1|0);c=x[b>>2];x[31609]=0;c=R(172,c|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Pa}eb:{fb:{if(!c){break fb}c=i+w[b+22>>1]|0;c=((c|0)>0?c:l)&65535;j=z[b+20>>1];g=(c|0)!=(i|0)&(c|0)!=0&c>>>0<=z[a+480190>>1]&(j|0)!=0;gb:{if(g){e=wf(x[q>>2],c-1|0);break gb}c=x[b>>2];x[31609]=0;j=R(154,c|0)|0;c=x[31609];x[31609]=0;e=b;if((c|0)==1){break Oa}}yc(e);hb:{if(g){c=x[e+8>>2];f=x[e>>2];m=z[b+20>>1];x[31609]=0;c=U(150,f|0,c|0,m|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Oa}if(!c){break fb}x[d+220>>2]=0;x[d+244>>2]=0;x[31609]=0;c=d+288|0;S(186,c|0,e|0,j|0);f=x[31609];x[31609]=0;ib:{if((f|0)!=1){f=cD(Ze(c),uh(x[d+288>>2]),d+220|0,d+244|0);x[31609]=0;P(183,e|0,x[d+220>>2])|0;e=x[31609];x[31609]=0;if((e|0)==1){break ib}Kc(c);break hb}f=N()|0;break ya}f=N()|0;Kc(d+288|0);break ya}f=0;x[d+220>>2]=0;x[d+244>>2]=0}x[31609]=0;c=d+288|0;O(575,c|0,b|0);e=x[31609];x[31609]=0;jb:{kb:{if((e|0)!=1){c=Ze(c);j=x[d+288>>2];if(!g){f=cD(c,uh(j),d+220|0,d+244|0);x[31609]=0;e=x[d+220>>2];P(183,b|0,e|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break eb}j=j-e|0;c=c+e|0}if(f){break kb}h=1;break jb}f=N()|0;break ya}e=D(i,104)+a|0;m=e+484380|0;Gh(m);u=e+484400|0;e=0;g=x[d+244>>2];while(1){lb:{if(!j|(g|0)!=1?g:0){break lb}i=x[m>>2];if(i>>>0<=e>>>0){break lb}if(!le(i,x[m+20>>2])){break lb}x[d+192>>2]=0;x[d+172>>2]=0;i=d+172|0;k=tY(f,c,uh(j),d+192|0,d+264|0,i);x[31609]=0;x[d+220>>2]=k;P(183,b|0,k|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break Ca}vi(i,uh(x[m>>2]-e|0));i=x[d+172>>2];mb:{if((i|0)<=0){break mb}g=x[d+192>>2];B=z[m+34>>1];if((_d(B)|0)!=(g|0)){break mb}t=D(e,g);r=x[u>>2];if(B&1){x[d+168>>2]=i;x[d+156>>2]=i;x[d- -64>>2]=i;x[d+48>>2]=i;x[d+152>>2]=g;x[d+148>>2]=x[d+264>>2];x[d+164>>2]=g;x[d+160>>2]=r+(t<<1);x[31609]=0;g=x[d+152>>2];x[d+40>>2]=x[d+148>>2];x[d+44>>2]=g;g=x[d+164>>2];x[d+56>>2]=x[d+160>>2];x[d+60>>2]=g;O(576,d+56|0,d+40|0);g=x[31609];x[31609]=0;if((g|0)!=1){break mb}break Ca}x[d+144>>2]=i;x[d+132>>2]=i;x[d+32>>2]=i;x[d+16>>2]=i;x[d+128>>2]=g;x[d+124>>2]=x[d+264>>2];x[d+140>>2]=g;x[d+136>>2]=r+t;x[31609]=0;g=x[d+128>>2];x[d+8>>2]=x[d+124>>2];x[d+12>>2]=g;g=x[d+140>>2];x[d+24>>2]=x[d+136>>2];x[d+28>>2]=g;O(577,d+24|0,d+8|0);g=x[31609];x[31609]=0;if((g|0)==1){break Ca}}j=j-k|0;c=c+k|0;g=sY(f);x[d+244>>2]=g;e=e+i|0;continue}break}rY(f)}Kc(d+288|0)}l=l+1|0;continue}break}break Ca}nb:{if(x[a+480180>>2]!=4){break nb}g=0;while(1){if(z[a+480192>>1]<=g>>>0){break nb}b=yb(x[o>>2],g);c=y[b+3|0];e=y[b+2|0];f=y[b+1|0];b=y[b|0];x[31609]=0;g=g+1|0;ja(400,a|0,g&65535,b|0,f|0,e|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){continue}break}f=N()|0;break ya}if(!(y[d+1235|0]&16)){break Ka}b=x[n+8>>2];c=x[n>>2];x[31609]=0;b=U(150,c|0,b|0,1)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Ma}if(!b){break Ka}g=0;x[31609]=0;b=R(197,n|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Na}if(!(b&1)){break La}while(1){if(z[E>>1]<=g>>>0){break La}x[31609]=0;b=R(151,n|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){v[((g<<5)+a|0)+480288|0]=b;g=g+1|0;continue}break}f=N()|0;break ya}f=N()|0;break Aa}f=N()|0;break ya}f=N()|0;break ya}f=N()|0;break ya}f=N()|0;break ya}f=a+906300|0;while(1){b=x[n+8>>2];c=x[n>>2];x[31609]=0;b=U(150,c|0,b|0,1)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Da}if(!b){break Ka}x[31609]=0;b=R(197,n|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Ia}if(!b){break Ka}x[31609]=0;c=R(151,n|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Ja}x[31609]=0;e=d+220|0;S(185,e|0,n|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break Ja}c=hc(d+288|0,e);ub(e);ob:{if(b>>>0<=250){x[31609]=0;O(450,c|0,$d(f,b-1|0)|0);b=x[31609];x[31609]=0;if((b|0)==1){break ob}}ub(c);continue}break}f=N()|0;ub(c);break ya}i=a+901404|0;c=Fb(d+192|0);f=0;l=0;while(1){b=x[n+8>>2];e=x[n>>2];x[31609]=0;b=U(150,e|0,b|0,8)|0;e=x[31609];x[31609]=0;pb:{qb:{rb:{sb:{tb:{if((e|0)!=1){if(b){x[31609]=0;e=R(151,n|0)|0;b=x[31609];x[31609]=0;ub:{vb:{wb:{xb:{yb:{zb:{Ab:{Bb:{if((b|0)!=1){x[31609]=0;b=R(151,n|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break Bb}x[31609]=0;g=d+288|0;S(185,g|0,n|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break Ab}b=hc(d+220|0,g);ub(g);if((e|0)==1229211981){break xb}if((e|0)==1229476432){break yb}if((e|0)==1397900630){break zb}if((e|0)!=1414548815){break pb}x[31609]=0;e=P(412,b|0,13951)|0;j=x[31609];x[31609]=0;if((j|0)==1){break Ha}if(!e){break qb}x[31609]=0;e=R(151,b|0)|0;j=x[31609];x[31609]=0;if((j|0)!=1){x[31609]=0;S(185,g|0,b|0,e|0);e=x[31609];x[31609]=0;if((e|0)!=1){break wb}}f=N()|0;break Ga}f=N()|0;break Ea}f=N()|0;break Ea}f=N()|0;break Ea}Cb:{Db:{Eb:{e=x[a+480180>>2];switch(e-2|0){case 1:break pb;case 0:break vb;case 2:break Db;default:break Eb}}if((e|0)==16){break Cb}if((e|0)!=32){break pb}x[31609]=0;f=R(189,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Ha}x[31609]=0;l=R(189,b|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break pb}break Ha}e=Fc(d+120|0,4);x[d+288>>2]=32;g=x[b>>2];x[31609]=0;g=R(154,g|0)|0;j=x[31609];x[31609]=0;if((j|0)!=1){x[d+244>>2]=g;e=x[e>>2];g=x[Hb(d+288|0,d+244|0)>>2];x[31609]=0;V(578,b|0,c|0,e|0,g|0);e=x[31609];x[31609]=0;if((e|0)!=1){break pb}}f=N()|0;break Ga}x[31609]=0;e=R(197,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break ub}x[31609]=0;g=d+244|0;O(579,g|0,4211);j=x[31609];x[31609]=0;Fb:{if((j|0)!=1){x[d+264>>2]=e>>>4;x[31609]=0;x[d+104>>2]=e&15;e=d+288|0;V(307,e|0,g|0,d+264|0,d+104|0);j=x[31609];x[31609]=0;if((j|0)==1){break Fb}zb(c,e);tb(e);Eb(g);break pb}f=N()|0;break Ga}f=N()|0;Eb(d+244|0);break Ga}x[31609]=0;e=R(197,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break Ha}x[a+480216>>2]=e;x[31609]=0;e=R(197,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break Ha}x[a+480220>>2]=e;break pb}x[31609]=0;P(423,b|0,i|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Ha}DD(i);break pb}g=d+288|0;e=hc(d+244|0,g);ub(g);j=x[e>>2];x[31609]=0;j=R(154,j|0)|0;m=x[31609];x[31609]=0;if((m|0)==1){break rb}w[d+288>>1]=j>>>5;M=d,T=Yj(x[a+484344>>2],x[a+484348>>2]),w[M+264>>1]=T;j=z[Oc(g,d+264|0)>>1];g=0;while(1){if((g|0)==(j|0)){ub(e);break qb}x[31609]=0;m=d+288|0;O(580,e|0,m|0);k=x[31609];x[31609]=0;Gb:{if((k|0)==1){break Gb}k=x[J>>2];x[31609]=0;O(581,Wb(k,g)|0,m|0);m=x[31609];x[31609]=0;if((m|0)==1){break Gb}g=g+1|0;continue}break}break rb}x[31609]=0;f=R(189,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Ha}break pb}f=N()|0;break Ga}b=x[a+480180>>2];Hb:{Ib:{Jb:{if((b|0)!=32){break Jb}e=f&65535;if(e>>>0<256){break Jb}if(e>>>0<532){break Ib}}b=(b|0)!=2;Kb:{if(b){break Kb}e=f&65535;if(e>>>0<12544){break Kb}if(e>>>0<12820){break Ib}}if(b){break Hb}b=f&65535;if(b>>>0<4864|b>>>0>4895){break Hb}}kr(i)}g=1;Lb:{if(!(v[d+1235|0]&1)){break Lb}e=x[a+1074308>>2];if(!e){while(1){b=g&65535;if(b>>>0<=z[a+480192>>1]){b=x[((b<<2)+a|0)+900380>>2];if(b){e=x[a+480180>>2];x[31609]=0;O(582,Yh(b,2)|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break tb}v[b+19|0]=y[b+19|0]+3>>>2}g=g+1|0;continue}break}e=x[a+1074308>>2]}if(e>>>0<=18350079){x[31609]=0;b=P(267,a+1074312|0,27)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Fa}x[31609]=0;P(267,b|0,57)|0;b=x[31609];x[31609]=0;if((b|0)==1){break Fa}e=x[a+1074308>>2]}if(e>>>0<=19070975){x[31609]=0;P(267,a+1074312|0,73)|0;b=x[31609];x[31609]=0;if((b|0)==1){break Fa}e=x[a+1074308>>2]}if(e>>>0>19267583){break Lb}x[31609]=0;P(267,a+1074312|0,50)|0;b=x[31609];x[31609]=0;if((b|0)==1){break Fa}}Mb:{Nb:{Ob:{Pb:{Qb:{Rb:{Sb:{Tb:{Ub:{Vb:{Wb:{Xb:{Yb:{Zb:{if(Ad(x[c+4>>2],y[c+11|0])){x[31609]=0;e=d+220|0;W(583,e|0);b=x[31609];x[31609]=0;_b:{if((b|0)!=1){x[31609]=0;f=d+288|0;S(551,f|0,e|0,d+1703|0);b=x[31609];x[31609]=0;if((b|0)==1){break _b}break Zb}f=N()|0;break Ea}f=N()|0;Eb(d+220|0);break Ea}x[31609]=0;e=d+220|0;W(584,e|0);b=x[31609];x[31609]=0;if((b|0)==1){break Yb}x[31609]=0;f=d+288|0;V(585,f|0,e|0,d+1703|0,c|0);b=x[31609];x[31609]=0;if((b|0)==1){break Xb}}zb(c,f);tb(f);Eb(e);x[31609]=0;e=d+220|0;O(550,e|0,3977);b=x[31609];x[31609]=0;if((b|0)==1){break Vb}x[31609]=0;b=d+288|0;S(551,b|0,e|0,d+1703|0);f=x[31609];x[31609]=0;if((f|0)==1){break Ub}zb(a+1298344|0,b);tb(b);Eb(e);x[31609]=0;b=P(1,b|0,15083)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Tb}zb(a+1298356|0,b);tb(b);b=x[a+480180>>2];switch(b-1|0){case 2:break sb;case 1:break Pb;case 3:break Qb;case 0:break Rb;default:break Wb}}f=N()|0;break Ea}f=N()|0;Eb(d+220|0);break Ea}if((b|0)==16){break Sb}if((b|0)==32){break Ob}if((b|0)!=16777216){break sb}x[31609]=0;b=P(1,d+220|0,10140)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Nb}zb(a+1298392|0,b);tb(b);x[31609]=0;b=P(1,d+244|0,13913)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Mb}zb(a+1298380|0,b);tb(b);break sb}f=N()|0;break Ea}f=N()|0;Eb(d+220|0);break Ea}f=N()|0;break Ea}x[31609]=0;b=P(1,d+220|0,10145)|0;e=x[31609];x[31609]=0;$b:{if((e|0)!=1){zb(a+1298392|0,b);tb(b);x[31609]=0;b=P(1,d+244|0,8365)|0;e=x[31609];x[31609]=0;if((e|0)==1){break $b}zb(a+1298380|0,b);tb(b);break sb}f=N()|0;break Ea}f=N()|0;break Ea}x[31609]=0;b=P(1,d+220|0,12402)|0;e=x[31609];x[31609]=0;ac:{if((e|0)!=1){zb(a+1298392|0,b);tb(b);x[31609]=0;b=P(1,d+244|0,14309)|0;e=x[31609];x[31609]=0;if((e|0)==1){break ac}zb(a+1298380|0,b);tb(b);break sb}f=N()|0;break Ea}f=N()|0;break Ea}x[31609]=0;b=P(1,d+220|0,10118)|0;e=x[31609];x[31609]=0;bc:{if((e|0)!=1){zb(a+1298392|0,b);tb(b);x[31609]=0;b=P(1,d+244|0,15384)|0;e=x[31609];x[31609]=0;if((e|0)==1){break bc}zb(a+1298380|0,b);tb(b);break sb}f=N()|0;break Ea}f=N()|0;break Ea}x[31609]=0;b=P(1,d+220|0,10490)|0;e=x[31609];x[31609]=0;cc:{if((e|0)!=1){zb(a+1298392|0,b);tb(b);x[31609]=0;b=P(1,d+244|0,15125)|0;e=x[31609];x[31609]=0;if((e|0)==1){break cc}zb(a+1298380|0,b);tb(b);break sb}f=N()|0;break Ea}f=N()|0;break Ea}x[31609]=0;b=P(1,d+220|0,6127)|0;e=x[31609];x[31609]=0;dc:{ec:{fc:{gc:{hc:{if((e|0)!=1){zb(a+1298392|0,b);tb(b);if(!(l&65535)){break dc}x[31609]=0;b=d+264|0;O(268,b|0,4314);e=x[31609];x[31609]=0;if((e|0)==1){break hc}x[d+116>>2]=(l&65280)>>>8;x[31609]=0;x[d+100>>2]=l&255;e=d+104|0;O(444,e|0,d+100|0);f=x[31609];x[31609]=0;if((f|0)==1){break gc}x[31609]=0;f=d+244|0;V(430,f|0,b|0,d+116|0,e|0);i=x[31609];x[31609]=0;if((i|0)==1){break fc}zb(a+1298380|0,f);tb(f);tb(e);Eb(b);break sb}f=N()|0;break Ea}f=N()|0;break Ea}f=N()|0;break ec}f=N()|0;tb(d+104|0)}Eb(d+264|0);break Ea}x[31609]=0;b=P(1,d+244|0,8573)|0;e=x[31609];x[31609]=0;if((e|0)!=1){zb(a+1298380|0,b);tb(b);break sb}f=N()|0;break Ea}f=N()|0;break Ea}f=N()|0;break Ea}f=N()|0;break Ea}f=N()|0;break Ea}zb(a+1298368|0,c);ic:{if(x[a+1074308>>2]){M=a,T=x[Fc(d+264|0,22)>>2],x[M+1298404>>2]=T;break ic}if(x[a+480180>>2]==1){M=a,T=x[Fc(d+264|0,28)>>2],x[M+1298404>>2]=T;break ic}M=a,T=x[Fc(d+264|0,4)>>2],x[M+1298404>>2]=T}g=1;jc:{kc:{if(h&1){x[31609]=0;b=P(1,d+264|0,16687)|0;h=x[31609];x[31609]=0;if((h|0)==1){break kc}a=x[a+1298472>>2];x[31609]=0;S(385,a|0,2,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break jc}tb(b)}tb(c);qY(q);wc(o);Rc(s);ub(I);ub(H);break c}f=N()|0;break Ea}f=N()|0;tb(b);break Ea}f=N()|0;ub(e);break Ga}x[31609]=0;e=P(412,b|0,13956)|0;g=x[31609];x[31609]=0;if((g|0)==1){break Ha}lc:{if(!e){break lc}x[31609]=0;e=R(151,b|0)|0;g=x[31609];x[31609]=0;mc:{if((g|0)!=1){x[31609]=0;S(185,d+244|0,b|0,e|0);e=x[31609];x[31609]=0;if((e|0)!=1){break mc}}f=N()|0;break Ga}g=d+244|0;e=hc(d+288|0,g);ub(g);j=x[e>>2];x[31609]=0;j=R(154,j|0)|0;m=x[31609];x[31609]=0;if((m|0)!=1){w[d+244>>1]=(j>>>0)/20;w[d+264>>1]=z[E>>1];j=z[Oc(g,d+264|0)>>1];g=0;while(1){if((g|0)==(j|0)){ub(e);break lc}x[31609]=0;S(424,e|0,((g<<5)+a|0)+480289|0,20);m=x[31609];x[31609]=0;if((m|0)!=1){g=g+1|0;continue}break}}f=N()|0;ub(e);break Ga}x[31609]=0;P(435,a|0,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Ha}x[31609]=0;ba(436,a|0,b|0,1,0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Ha}if((f-2186&65535)>>>0<=117){x[a+480180>>2]=16777216;x[31609]=0;S(448,a|0,b|0,f&65535);e=x[31609];x[31609]=0;if((e|0)==1){break Ha}}if(!x[a+1074308>>2]){break pb}x[31609]=0;e=P(1,d+172|0,18262)|0;g=x[31609];x[31609]=0;nc:{oc:{pc:{if((g|0)!=1){j=x[a+1074308>>2];x[31609]=0;g=d+244|0;O(134,g|0,j|0);j=x[31609];x[31609]=0;if((j|0)==1){break pc}x[31609]=0;j=d+288|0;S(2,j|0,e|0,g|0);m=x[31609];x[31609]=0;if((m|0)==1){break oc}zb(c,j);tb(j);tb(g);tb(e);break pb}f=N()|0;break Ga}f=N()|0;break nc}f=N()|0;tb(d+244|0)}tb(e);break Ga}ub(b);continue}}f=N()|0;break ya}f=N()|0;break ya}f=N()|0}ub(b);break Ea}f=N()|0}tb(c);break ya}f=N()|0;break ya}f=N()|0;Kc(d+288|0);break ya}f=N()|0}ub(i)}tb(g)}qY(q);break ma}c=h}tb(g);j=j+1|0;continue}}f=N()|0;break ma}f=N()|0;tb(e);break ma}f=N()|0}wc(o);break A}q=q+1|0;continue}}Rc(s);break z}f=N()|0}ub(I);break y}f=N()|0}ub(H);break e}f=N()|0;break e}f=N()|0;break e}else{qc:{rc:{if(!j){v[d+288|0]=y[(d+g|0)+1240|0];v[d+220|0]=64;M=((g<<5)+a|0)+480286|0,T=y[Qb(d+288|0,d+220|0)|0],w[M>>1]=T;break rc}if(l){break qc}}sc:{f=y[(d+g|0)+1304|0];if((f|0)!=255){if((f|0)!=127){break sc}x[((g<<5)+a|0)+480280>>2]=256;break qc}w[((g<<5)+a|0)+480284>>1]=256;break qc}w[((g<<5)+a|0)+480284>>1]=f}g=g+1|0;continue}}f=N()|0;break d}f=N()|0;break d}f=N()|0}ub(n)}ec(C);Q(f|0);p()}ub(n)}ec(C)}fb=d+1712|0;return g|0}function Wqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,T=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;e=fb-944|0;fb=e;yc(b);f=e+892|0;a:{if(!LY(b,f)){break a}if(!PY(f)){break a}if(!Mb(x[b>>2],x[b+8>>2],Bc(OY(f),hb))){break a}d=1;if((c|0)==64){break a}Dd(a,8);eg(a);h=y[e+895|0]-48|0;v[e+891|0]=h;dd(b,$b(y[e+900|0]|y[e+901|0]<<8|(y[e+902|0]<<16|y[e+903|0]<<24)));f=e+584|0;he(f,b,504);L=hc(e+868|0,f);ub(f);d=0;x[31609]=0;O(524,b|0,f|0);f=x[31609];x[31609]=0;b:{c:{d:{e:{f:{g:{if((f|0)!=1){if(y[e+867|0]>63){break b}if(Bb(z[e+584>>1])<<16>>16<0){break b}f=e+504|0;Rb(f,0,80);h:{d=$b(y[e+924|0]|y[e+925|0]<<8|(y[e+926|0]<<16|y[e+927|0]<<24));if(!d){break h}x[31609]=0;d=P(149,b|0,d|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){if(!d){break h}x[31609]=0;O(525,b|0,f|0);f=x[31609];x[31609]=0;if((f|0)!=1){break h}}i=N()|0;break e}x[31609]=0;f=e+500|0;S(526,f|0,b|0,h&255);d=x[31609];x[31609]=0;if((d|0)!=1){X=_e(f);d=0;f=z[e+500>>1];if((f-128&65535)>>>0<65409){break b}w[a+480188>>1]=f;H=Nb(e+488|0);f=$b(y[e+916|0]|y[e+917|0]<<8|(y[e+918|0]<<16|y[e+919|0]<<24));i:{if(f){x[31609]=0;P(149,b|0,f|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break g}x[31609]=0;S(527,b|0,H|0,y[e+867|0]);f=x[31609];x[31609]=0;if((f|0)==1){break g}g=y[e+867|0];break i}g=y[e+867|0];if(g){break c}}F=a+480188|0;g=g&255;w[a+480192>>1]=g;w[a+480190>>1]=g;Y=(h&255)>>>0<2|v[e+848|0]>=0;B=!Y;u=c&2;k=1;n=1;while(1){j:{k:{l:{m:{n:{o:{d=n&65535;if(d>>>0<=(g&65535)>>>0){x[31609]=0;q=k&65535;f=U(251,a|0,d|0,q|0)|0;g=x[31609];x[31609]=0;p:{if((g|0)!=1){if(f){break p}break d}i=N()|0;break f}f=x[((d<<2)+a|0)+900380>>2];w[e+92>>1]=0;x[e+88>>2]=0;x[31609]=0;j=R(168,e+468|0)|0;g=x[31609];x[31609]=0;q:{if((g|0)!=1){d=yb(x[H>>2],d-1|0);d=$b(y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24));r:{if(!d){break r}x[31609]=0;d=P(149,b|0,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break k}if(!d){break r}x[31609]=0;O(528,b|0,e+88|0);d=x[31609];x[31609]=0;if((d|0)==1){break k}g=x[e+88>>2];h=w[e+92>>1];x[31609]=0;d=e+128|0;i=$b(g);g=ze(h);S(185,d|0,b|0,i<<((g|0)>0&(g&65504)>>>5));g=x[31609];x[31609]=0;if((g|0)==1){break k}g=hc(e+188|0,d);kd(j,g);ub(g);ub(d)}g=ze(w[e+92>>1]);d=g&15;if((g|0)>=0){break q}Ov(f,0);$=1;break o}i=N()|0;break f}if(d>>>0>6){break o}l=y[d+25094|0];if(!d){break m}w[a+480190>>1]=(z[a+480190>>1]+l|0)-1;t=f+108|0;m=f+236|0;i=4;r=l-2<<3;s:while(1){h=1;if((i|0)==10){break n}h=D(i,12);d=i+r|0;o=y[d+25100|0]+k|0;s=y[d+25148|0];d=0;while(1)if((d|0)==12){i=i+1|0;continue s}else{A=d+h|0;ia=bc(m,A),ja=o,w[ia>>1]=ja;A=xb(t,A);v[A|0]=s+y[A|0];d=d+1|0;continue}}}t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{f=$b(x[e+508>>2]);if(!f){break D}if(!Bb(z[e+512>>1])){break D}x[31609]=0;f=P(149,b|0,f|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break C}if(!f){break D}ia=e,ja=Bb(z[e+512>>1]),w[ia+188>>1]=ja;w[e+128>>1]=y[e+867|0];k=z[Oc(e+188|0,e+128|0)>>1];f=e+136|0;l=e+132|0;h=Bb(z[e+514>>1]);n=h>>>0<5;m=h>>>0<19;q=h>>>0<21;r=h>>>0<15;B=h>>>0<6;g=0;while(1){if((g|0)==(k|0)){break D}x[31609]=0;S(529,b|0,e+188|0,h|0);d=x[31609];x[31609]=0;E:{F:{G:{if((d|0)!=1){g=g+1|0;d=x[((g<<2)+a|0)+900380>>2];j=y[e+188|0];if(j){t=Zl(e+128|0,0,64);Zl(l,j-1&65535,64);i=y[e+189|0];if(i){i=64/(i>>>0)|0}else{i=0}Zl(f,i+j|0,0);x[31609]=0;j=d+48|0;S(530,j|0,t|0,3);i=x[31609];x[31609]=0;if((i|0)==1){break G}if(y[e+188|0]==1){i=x[vb(e+464|0,wb(x[j>>2]))>>2];t=wb(x[j>>2]);i=x[j>>2]+(Mv(i,t)<<2)|0;Jd(j,Lv(i+4|0,x[j+4>>2],i));wb(i)}j=y[e+189|0];x[d>>2]=j?j<<9:32767;v[d+60|0]=y[d+60|0]|1;t=1}H:{if(n){break H}j=y[e+192|0];if(j){ia=xb(d+108|0,24),ja=j+24|0,v[ia|0]=ja;t=1}if(m){break H}x[d+4>>2]=y[e+206|0]+1>>>1;if(q){break H}w[d+28>>1]=y[e+208|0]|y[e+209|0]<<8}d=D(z[bc(d+236|0,61)>>1],104)+a|0;v[d+484417|0]=y[e+191|0]<<4;if(r){break F}j=$b(y[e+198|0]|y[e+199|0]<<8|(y[e+200|0]<<16|y[e+201|0]<<24));x[d+484384>>2]=j;ia=d+484388|0,ja=$b(y[e+202|0]|y[e+203|0]<<8|(y[e+204|0]<<16|y[e+205|0]<<24))+j|0,x[ia>>2]=ja;break E}i=N()|0;break f}i=N()|0;break f}if(B){continue}}j=d+484414|0;i=j;o=z[j>>1]&65529;j=y[e+193|0];w[i>>1]=o|j<<1&2|j>>>1&4;if(!(j&4)){continue}w[d+484412>>1]=0;continue}}I:{f=$b(x[e+524>>2]);if(!f){break I}if(!Bb(z[e+528>>1])){break I}x[31609]=0;f=P(149,b|0,f|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break C}if(!f){break I}ia=e,ja=Bb(z[e+528>>1]),w[ia+188>>1]=ja;w[e+128>>1]=y[e+867|0];j=z[Oc(e+188|0,e+128|0)>>1];i=Bb(z[e+530>>1]);d=0;J:while(1){if((d|0)==(j|0)){break I}x[31609]=0;f=e+188|0;S(531,b|0,f|0,i|0);g=x[31609];x[31609]=0;if((g|0)==1){break t}g=e+88|0;I_(g,f);x[31609]=0;f=e+128|0;O(218,f|0,g|0);g=x[31609];x[31609]=0;if((g|0)==1){break u}d=d+1|0;h=((d<<2)+a|0)+900380|0;Ac(x[h>>2]+492|0,f);tb(f);g=x[h>>2];x[31609]=0;O(389,f|0,g|0);g=x[31609];x[31609]=0;if((g|0)==1){break v}ia=e,ja=Vi(x[e+128>>2]),x[ia+88>>2]=ja;k=Pf(f);while(1){f=x[e+88>>2];if(Ib(f,k)){g=(z[cp(f)>>1]<<5)+a|0;l=g+946328|0;f=x[h>>2];n=x[f+520>>2];x[l>>2]=x[f+516>>2];x[l+4>>2]=n;n=x[f+512>>2];l=g+946320|0;x[l>>2]=x[f+508>>2];x[l+4>>2]=n;n=x[f+504>>2];l=g+946312|0;x[l>>2]=x[f+500>>2];x[l+4>>2]=n;l=x[f+496>>2];g=g+946304|0;x[g>>2]=x[f+492>>2];x[g+4>>2]=l;ah(e+88|0);continue}else{Yv(e+128|0);continue J}}}}kr(a+901404|0);f=qc(e+456|0,4940);rf(Pe(a+901692|0,0),x[f>>2],x[f+4>>2]);yc(b);aa=c&1;r=a+484344|0;B=a+1298332|0;Z=a+1298308|0;M=a+484360|0;j=0;n=0;while(1){K:{c=j&255;if(c>>>0>=y[X|0]){break K}x[31609]=0;V(532,b|0,e+892|0,e+504|0,e+584|0);f=x[31609];x[31609]=0;L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{if((f|0)==1){break X}Y:{if(!c){d=0;break Y}x[31609]=0;c=R(274,M|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break X}d=j;if((c|0)==255){break d}}k=Nj(x[M>>2],d&255);m=og(e+444|0);Nc(k);if(y[e+891|0]<=1){c=Bb(z[e+586>>1]);if(c>>>0>256){break Q}f=e+188|0;IY(f,e+584|0);x[31609]=0;S(533,k|0,f|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break W}ia=e,ja=wb(x[k>>2]),x[ia+188>>2]=ja;f=wb(x[k+4>>2]);while(1){c=x[e+188>>2];if(Ib(c,f)){w[c>>1]=z[c>>1]+n;ge(e+188|0);continue}break}Wh(a,1);w[e+188>>1]=16;c=z[Oc(F,e+188|0)>>1];d=0;while(1)if((c|0)==(d|0)){c=32;break M}else{v[e+188|0]=y[(d+e|0)+850|0];v[e+128|0]=64;ia=((d<<5)+a|0)+480286|0,ja=y[Qb(e+188|0,e+128|0)|0],w[ia>>1]=ja;d=d+1|0;continue}}IY(e+188|0,e+584|0);c=Bb(z[e+200>>1]);if(!c|c>>>0>64|z[F>>1]>64){break Q}l=$b(x[e+208>>2]);c=Bb(z[e+212>>1]);if(c){w[e+128>>1]=c;w[e+88>>1]=800;c=Bc(((z[Oc(e+128|0,e+88|0)>>1]<<5)+50>>>0)/100|0,0)}else{c=32}f=x[e+196>>2];x[31609]=0;f=P(149,b|0,$b(f)|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break V}d=0;Z:{if(!f){break Z}while(1){if(z[F>>1]<=d>>>0){break Z}x[31609]=0;f=R(197,b|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){v[e+128|0]=f;v[e+88|0]=64;ia=((d<<5)+a|0)+480286|0,ja=y[Qb(e+128|0,e+88|0)|0],w[ia>>1]=ja;d=d+1|0;continue}break}i=N()|0;break w}_:{$:{f=$b(x[e+204>>2]);if(!f){break $}x[31609]=0;f=P(149,b|0,f|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break V}d=0;if(!f){break $}while(1){if(z[F>>1]<=d>>>0){break _}x[31609]=0;f=R(534,b|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){ia=((d<<5)+a|0)+480284|0,ja=(Yb(f,-16,16)<<3)+128|0,w[ia>>1]=ja;d=d+1|0;continue}break}i=N()|0;break w}Wh(a,1)}f=Nb(e+176|0);d=x[e+192>>2];x[31609]=0;h=P(149,b|0,$b(d)|0)|0;d=x[31609];x[31609]=0;aa:{if((d|0)==1){break aa}g=33;d=0;if(!h){break N}h=z[e+586>>1];i=x[b+8>>2];q=x[b>>2];x[31609]=0;h=U(150,q|0,i|0,Bb(h)<<1)|0;i=x[31609];x[31609]=0;if((i|0)==1){break aa}if(!h){break N}h=z[e+586>>1];x[31609]=0;h=U(535,b|0,f|0,Bb(h)|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break aa}if(!h){break N}ia=e,ja=wb(x[f>>2]),x[ia+172>>2]=ja;q=wb(x[e+180>>2]);u=x[e+188>>2];o=z[e+202>>1];while(1){d=x[e+172>>2];if(!Ib(d,q)){g=0;d=1;break N}d=Bb(y[d|0]|y[d+1|0]<<8);ba:{if(Bb(o)>>>0<d>>>0){break ba}x[31609]=0;P(149,b|0,$b(u)+(d<<2)|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break U}x[31609]=0;d=R(281,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break U}x[31609]=0;d=P(149,b|0,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break U}if(!d){break ba}d=x[b+8>>2];g=x[b>>2];x[31609]=0;d=U(150,g|0,d|0,42)|0;g=x[31609];x[31609]=0;if((g|0)==1){break U}if(!d){break ba}x[31609]=0;O(536,b|0,e+128|0);d=x[31609];x[31609]=0;ca:{if((d|0)!=1){if(mc(x[k>>2],x[k+4>>2])){break ca}x[31609]=0;O(537,k|0,65534);d=x[31609];x[31609]=0;if((d|0)!=1){break ca}}i=N()|0;break O}d=Bb(y[e+168|0]|y[e+169|0]<<8);x[e+124>>2]=d;g=x[b+8>>2];h=x[b>>2];x[31609]=0;d=U(150,h|0,g|0,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break T}if(!d){x[31609]=0;d=R(202,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break T}xc(e+124|0,d)}xc(e+124|0,65534);g=x[k+4>>2];h=x[k>>2];d=0;x[31609]=0;i=x[e+124>>2];s=$c(h,g);O(538,k|0,i+s|0);g=x[31609];x[31609]=0;if((g|0)==1){break P}while(1){da:{if((d|0)==(i|0)){if(y[e+128|0]){Fn(e+88|0,e+128|0);x[31609]=0;d=e+112|0;S(539,d|0,x[e+88>>2],x[e+92>>2]);g=x[31609];x[31609]=0;if((g|0)==1){break S}op(k,d);tb(d)}d=$b(y[e+160|0]|y[e+161|0]<<8|(y[e+162|0]<<16|y[e+163|0]<<24));if(!d){break ba}x[31609]=0;d=P(149,b|0,d|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){break da}break P}x[31609]=0;g=R(273,b|0)|0;h=x[31609];x[31609]=0;ea:{if((h|0)!=1){g=g<<16>>16;if((g|0)<0){break ea}x[31609]=0;O(537,k|0,g+n&65535);g=x[31609];x[31609]=0;if((g|0)!=1){break ea}}i=N()|0;break O}d=d+1|0;continue}break}if(!d){break ba}while(1){fa:{x[31609]=0;d=P(540,b|0,e+108|0)|0;g=x[31609];x[31609]=0;ga:{ha:{ia:{ja:{if((g|0)!=1){if(!d){break ba}x[31609]=0;d=e+68|0;S(185,d|0,b|0,y[e+111|0]);g=x[31609];x[31609]=0;if((g|0)==1){break ja}g=hc(e+88|0,d);ub(d);h=Bb(z[e+108>>1]);d=cm(h+s|0);w[e+68>>1]=d;if((h|0)==65535){break fa}i=x[k>>2];if($c(i,x[k+4>>2])>>>0<=d>>>0){break fa}h=65535;switch(y[e+110|0]-1|0){case 0:break ha;case 1:break ia;default:break ga}}i=N()|0;break O}i=N()|0;break O}x[31609]=0;d=R(273,g|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break R}x[31609]=0;h=P(541,m|0,e+68|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break R}w[h>>1]=d;i=x[k>>2];h=65534;d=z[e+68>>1]}ia=bc(i,d),ja=h,w[ia>>1]=ja}ub(g);continue}break}ub(g)}ge(e+172|0);continue}}i=N()|0;break O}i=N()|0;break f}i=N()|0;break w}i=N()|0;break w}i=N()|0;break O}i=N()|0;break O}i=N()|0;break O}i=N()|0;ub(g);break O}iD(m);break d}i=N()|0}od(f);break w}od(f);if(!d){break L}c=c>>>(l>>>1&1)|0}d=Bb(z[e+844>>1]);g=y[e+847|0];_=g&64;f=y[e+848|0];T=f&32;I=(f&31)+1|0;ia=a,ja=FY(d,_>>>6|0,T>>>5|0,I),x[ia+480204>>2]=ja;ia=a,ja=Ld(y[e+849|0],1,32),x[ia+480196>>2]=ja;if(T){x[a+480216>>2]=I;x[a+480220>>2]=I<<2}f=y[e+866|0];if(f){v[e+188|0]=f;v[e+128|0]=64;ia=a,ja=y[Qb(e+188|0,e+128|0)|0]<<2,x[ia+480200>>2]=ja}x[a+480228>>2]=c;x[a+480232>>2]=c;x[a+480208>>2]=x[a+480208>>2]&-3|(g^-1)>>>4&2;ka:{la:{ma:{na:{oa:{pa:{qa:{ra:{sa:{ta:{c=$b(x[e+548>>2]);ua:{if(!c){break ua}x[31609]=0;c=P(149,b|0,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break ta}if(!c){break ua}c=x[e+552>>2];x[31609]=0;S(270,b|0,Z|0,$b(c)|0);c=x[31609];x[31609]=0;if((c|0)==1){break ta}if(y[X|0]<2){break ua}x[31609]=0;c=e+56|0;S(258,c|0,28,Z|0);f=x[31609];x[31609]=0;if((f|0)==1){break ta}op(k,c);tb(c)}va:{if($b(x[e+520>>2])>>>0<2){break va}c=x[e+516>>2];x[31609]=0;c=P(149,b|0,$b(c)|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break ta}if(!c){break va}c=x[e+520>>2];x[31609]=0;V(336,B|0,b|0,$b(c)-1|0,4);c=x[31609];x[31609]=0;if((c|0)==1){break ta}}c=$b(x[e+560>>2]);if(!c){break ka}x[31609]=0;c=P(149,b|0,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break ta}if(!c){break ka}c=x[b+8>>2];f=x[b>>2];x[31609]=0;c=U(150,f|0,c|0,12)|0;f=x[31609];x[31609]=0;if((f|0)==1){break ta}if(!c){break ka}x[31609]=0;P(183,b|0,6)|0;c=x[31609];x[31609]=0;if((c|0)==1){break ta}x[31609]=0;c=R(273,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break ta}if((c|0)!=1){break ka}x[31609]=0;c=R(281,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break ra}if(!c){break ka}f=x[b+8>>2];d=x[b>>2];x[31609]=0;f=U(150,d|0,f|0,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break ra}if(f){break sa}break ka}i=N()|0;break w}f=VG(e+188|0,B);x[31609]=0;V(336,B|0,b|0,c|0,4);c=x[31609];x[31609]=0;if((c|0)==1){break ma}if(!Ad(x[e+192>>2],y[e+199|0])){x[31609]=0;c=U(542,e+32|0,2,13)|0;d=x[31609];x[31609]=0;if((d|0)==1){break qa}x[31609]=0;d=e+128|0;S(543,d|0,f|0,c|0);h=x[31609];x[31609]=0;if((h|0)==1){break pa}x[31609]=0;h=e+44|0;S(544,h|0,d|0,B|0);i=x[31609];x[31609]=0;if((i|0)==1){break oa}zb(B,h);tb(h);tb(d);tb(c)}tb(f);break ka}i=N()|0;break w}i=N()|0;break la}i=N()|0;break na}i=N()|0;tb(e+128|0)}tb(c);break la}i=N()|0}tb(f);break w}wa:{J=y[e+891|0];if(J>>>0<2){break wa}i=0;if(!$b(x[e+572>>2])){break wa}while(1){if(z[F>>1]<=i>>>0){break wa}c=x[e+572>>2];x[31609]=0;c=P(149,b|0,$b(c)+(i<<2)|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break x}xa:{if(!c){break xa}x[31609]=0;c=R(281,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break x}x[31609]=0;c=P(149,b|0,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break x}h=0;d=0;if(!c){break xa}while(1){ya:{c=x[b+8>>2];f=x[b>>2];x[31609]=0;c=U(150,f|0,c|0,8)|0;f=x[31609];x[31609]=0;za:{Aa:{Ba:{if((f|0)!=1){if(!c){break ya}x[31609]=0;O(545,b|0,e+188|0);c=x[31609];x[31609]=0;if((c|0)==1){break Ba}c=$b(x[e+188>>2]);if(!c){break ya}switch((c&536870911)-1|0){case 1:break za;case 0:break Aa;default:continue}}i=N()|0;break w}i=N()|0;break w}h=$b(x[e+192>>2]);continue}d=$b(x[e+192>>2]);continue}break}if(!h|!d){break xa}x[31609]=0;c=P(149,b|0,h|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break y}if(!c){break xa}x[31609]=0;S(424,b|0,((i<<5)+a|0)+480289|0,d|0);c=x[31609];x[31609]=0;if((c|0)==1){break y}}i=i+1|0;continue}}ia=e,ja=Bb(z[e+584>>1]),w[ia+172>>1]=ja;Hf(e+172|0,(n^-1)&65535);x[31609]=0;u=z[e+172>>1];O(223,r|0,u+n&65535);c=x[31609];x[31609]=0;Ca:{if((c|0)==1){break Ca}ba=n&65535;o=0;ca=(g&16)!=0;Da:{Ea:{while(1){if((o|0)==(u|0)){ia=e,ja=Vi(x[m>>2]),x[ia+128>>2]=ja;g=Pf(m);while(1){Fa:{Ga:{Ha:{Ia:{Ja:{Ka:{c=x[e+128>>2];if(!Zg(c,g)){c=$b(x[e+504>>2]);if(c){break Ka}g=31;break Ja}c=cp(c);f=_e(c);d=z[c>>1];if(!d){d=0;break Ia}h=d-1&65535;if(!Yi(k,h)){break Ia}x[31609]=0;d=P(368,k|0,h|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Fa}break Ha}x[31609]=0;c=P(149,b|0,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Ca}g=c?0:31}n=n+u|0;break L}if(z[f>>1]==(d+1|0)){break Ga}x[31609]=0;d=P(367,r|0,1)|0;h=x[31609];x[31609]=0;if((h|0)==1){break Fa}if((d|0)==65535){break Ga}ia=bc(x[k>>2],z[c>>1]),ja=d,w[ia>>1]=ja}c=Wb(x[r>>2],d);Ae(c,Bn(Ve(Oe(e+188|0,12,ew(z[f>>1])),x[c+12>>2]-1|0)));u=(u&65535)>>>0>d>>>0?u:d+1|0}ah(e+128|0);continue}break}i=N()|0;break w}La:{Ma:{if(!aa){break Ma}c=y[e+908|0]|y[e+909|0]<<8|(y[e+910|0]<<16|y[e+911|0]<<24);x[31609]=0;c=P(149,b|0,$b(c)+(o<<2)|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Ea}if(!c){break Ma}x[31609]=0;c=R(281,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Ea}x[31609]=0;c=P(149,b|0,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Ea}if(!c){break Ma}A=Fb(e+68|0);x[31609]=0;c=v[e+846|0];K=R(168,e+12|0)|0;f=x[31609];x[31609]=0;Na:{Oa:{if((f|0)!=1){l=c+48|0;if(J){break Oa}x[31609]=0;O(546,b|0,e+188|0);c=x[31609];x[31609]=0;if((c|0)==1){break La}w[e+124>>1]=y[e+188|0];s=y[e+189|0]+1|0;break Na}i=N()|0;break z}x[31609]=0;O(547,b|0,e+176|0);f=x[31609];x[31609]=0;Pa:{Qa:{if((f|0)!=1){d=Bb(z[e+176>>1]);w[e+124>>1]=d;s=Bb(z[e+178>>1])+1|0;f=$b(z[e+180>>1]|z[e+182>>1]<<16);if(!f){break Pa}g=x[b+8>>2];x[31609]=0;P(149,b|0,f|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break A}x[31609]=0;O(548,b|0,e+188|0);f=x[31609];x[31609]=0;if((f|0)==1){break A}f=y[e+192|0]|y[e+193|0]<<8|(y[e+194|0]<<16|y[e+195|0]<<24);x[31609]=0;f=P(149,b|0,$b(f)|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break A}if(!f){break Qa}f=y[e+196|0]|y[e+197|0]<<8|(y[e+198|0]<<16|y[e+199|0]<<24);x[31609]=0;S(270,b|0,A|0,$b(f)|0);f=x[31609];x[31609]=0;if((f|0)!=1){break Qa}break A}break A}f=$b(y[e+204|0]|y[e+205|0]<<8|(y[e+206|0]<<16|y[e+207|0]<<24));Ra:{if(!f){break Ra}x[31609]=0;f=P(149,b|0,f|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break A}if(!f){break Ra}x[31609]=0;f=R(281,b|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break A}x[31609]=0;f=P(149,b|0,f|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break A}if(!f){break Ra}x[31609]=0;f=e+88|0;S(185,f|0,b|0,D(d,s)|0);d=x[31609];x[31609]=0;if((d|0)==1){break A}d=hc(e+128|0,f);kd(K,d);ub(d);ub(f)}x[31609]=0;P(149,b|0,g|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break A}}l=J>>>0>2?c+24|0:l}x[31609]=0;c=o+ba|0;f=U(196,r|0,c&65535,s|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break A}Sa:{if(!f){break Sa}f=x[r>>2];x[31609]=0;q=Wb(f,c);O(283,q|0,A|0);c=x[31609];x[31609]=0;if((c|0)==1){break Da}Hf(e+124|0,z[F>>1]);da=s-1|0;c=0;ea=z[e+124>>1];Ta:while(1){if((c|0)==(s|0)){break Sa}f=c+1|0;fa=c-1|0;i=0;d=md(x[q>>2],x[x[q+48>>2]+12>>2],c,0);ga=c>>>0>=da>>>0;while(1){G=i&65535;if(ea>>>0<=G>>>0){c=f;continue Ta}zD(e+128|0,y[d+3|0],d+5|0);Ua:{if(!J){x[31609]=0;g=e+188|0;O(549,g|0,b|0);h=x[31609];x[31609]=0;if((h|0)!=1){h=y[e+188|0];C=Jc(g);v[d+1|0]=h>>>3&16|y[C|0]>>>4|h>>>1&32;C=y[C|0];ia=d,ja=y[_e(g)|0],v[ia+5|0]=ja;g=h&63;g=g?g+l|0:0;h=C&15;break Ua}break A}x[31609]=0;g=e+188|0;O(357,g|0,b|0);h=x[31609];x[31609]=0;Va:{Wa:{if((h|0)!=1){h=Jc(g);C=_e(g);W=_i(g);x[31609]=0;g=R(197,K|0)|0;E=x[31609];x[31609]=0;if((E|0)==1){break A}v[d+4|0]=g;E=y[e+188|0];g=E&127;if(!g){break Wa}g=g+l|0;break Va}break A}g=0;if((E|0)!=128){break Va}v[d|0]=254}v[d+1|0]=y[h|0]&63;h=y[C|0];v[d+5|0]=y[W|0]}if(g-1>>>0<=119){v[d|0]=g}W=(g|0)>84;C=e+188|0;E=(_|0)!=0;ha=(T|0)!=0;g=fb-16|0;fb=g;v[d+3|0]=0;Xa:{Ya:{Za:{_a:{$a:{ab:{bb:{cb:{db:{eb:{fb:{gb:{hb:{ib:{jb:{kb:{lb:{mb:{nb:{ob:{pb:{qb:{rb:{sb:{tb:{h=h&255;switch(h-4|0){case 4:case 10:break Ya;case 42:break _a;case 37:break $a;case 28:break ab;case 27:break bb;case 26:break cb;case 25:break db;case 24:break eb;case 23:break fb;case 22:break gb;case 21:break hb;case 20:break ib;case 18:break jb;case 17:break kb;case 16:break lb;case 14:break mb;case 13:break nb;case 12:break ob;case 11:break pb;case 9:break qb;case 8:break rb;case 5:break sb;case 0:break tb;default:break Za}}v[d+3|0]=5;h=y[d+5|0];v[g+15|0]=h>>>3;v[g+14|0]=15;E=y[Qb(g+15|0,g+14|0)|0];v[g+13|0]=h<<1&30;v[g+12|0]=15;ia=d,ja=y[Qb(g+13|0,g+12|0)|0]|E<<4,v[ia+5|0]=ja;break Ya}if((y[d+5|0]-1&255)>>>0>19){break Ya}v[d+3|0]=16;break Ya}v[d+3|0]=13;h=y[d+5|0];ub:{if(!ca){if(h>>>0>152){break ub}v[d+5|0]=D((h&240)>>>4|0,10)+(h&15);break Ya}v[d+5|0]=(h&127)+1>>>1;break Ya}v[d+3|0]=0;break Ya}v[d+3|0]=11;break Ya}h=y[d+5|0];if(!h){v[d+3|0]=14;break Ya}if(h>>>0>240){break Ya}v[d+3|0]=17;if(h>>>0<=2){v[d+5|0]=112;break Ya}h=LD(+(FY(h,E,ha,I)>>>0)/1e4);if(h>>>0<=255){v[d+5|0]=h;break Ya}v[d+5|0]=h>>>8;v[g+11|0]=h;ee(C,34,g+11|0);break Xa}v[d+3|0]=31;v[d+5|0]=y[d+5|0]|128;break Ya}v[d+3|0]=19;v[g+10|0]=15;ia=d,ja=y[Qb(d+5|0,g+10|0)|0]|16,v[ia+5|0]=ja;break Ya}v[d+3|0]=19;v[g+9|0]=15;ia=d,ja=y[Qb(d+5|0,g+9|0)|0]|32,v[ia+5|0]=ja;break Ya}v[d+3|0]=5;h=y[d+5|0];v[g+8|0]=(h>>>4|0)+1;v[g+7|0]=15;ia=d,ja=h&15|y[Qb(g+8|0,g+7|0)|0]<<4,v[ia+5|0]=ja;break Ya}v[d+3|0]=19;v[d+5|0]=y[d+5|0]&15|80;break Ya}v[d+3|0]=19;v[g+6|0]=15;ia=d,ja=y[Qb(d+5|0,g+6|0)|0]|96,v[ia+5|0]=ja;break Ya}v[d+3|0]=19;v[g+5|0]=15;ia=d,ja=y[Qb(d+5|0,g+5|0)|0]|192,v[ia+5|0]=ja;break Ya}v[d+3|0]=10;break Ya}v[d+3|0]=19;v[g+4|0]=15;ia=d,ja=y[Qb(d+5|0,g+4|0)|0]|160,v[ia+5|0]=ja;break Ya}v[d+3|0]=19;v[g+3|0]=15;ia=d,ja=y[Qb(d+5|0,g+3|0)|0]|176,v[ia+5|0]=ja;break Ya}h=y[d+5|0]-1<<24>>24;if((h|0)<0){break Ya}v[d+5|0]=h;v[d+3|0]=31;break Ya}v[d+3|0]=14;break Ya}v[d+3|0]=19;v[g+2|0]=15;ia=d,ja=y[Qb(d+5|0,g+2|0)|0]|224,v[ia+5|0]=ja;break Ya}h=y[d+5|0];if(h>>>0>=16){v[d+3|0]=19;v[d+5|0]=h>>>4|208;break Ya}if(!h){break Ya}v[d+3|0]=19;v[d+5|0]=h|144;break Ya}if(y[d+5|0]|y[d+4|0]){break Ya}if(!Tc(y[d|0])){break Ya}v[d+5|0]=159;v[d+3|0]=20;break Ya}h=y[d+4|0];if(!h){break Ya}v[d+3|0]=44;ia=d,ja=ti(Bc(((y[d+5|0]<<8&65280)>>>0)/(h>>>0)|0,0)),v[ia+5|0]=ja;break Ya}h=y[d+5|0];if((h+16&255)>>>0>32){break Ya}v[d+3|0]=9;ia=d,ja=Eh(((h^128)<<3)-896|0),v[ia+5|0]=ja;break Ya}if(h>>>0>15){break Ya}Cf(d,h,y[d+5|0])}v[g+1|0]=0;zD(C,0,g+1|0)}fb=g+16|0;vb:{if(y[e+128|0]!=34){break vb}if(!y[d+3|0]){g=z[e+128>>1];v[d+3|0]=g;v[d+5|0]=g>>>8;break vb}if(!c){break vb}ia=md(x[q>>2],x[x[q+48>>2]+12>>2],fa,G),ja=255,v[ia+5|0]=ja}g=W&Y;wb:{if(!y[e+188|0]){break wb}if(!ga){h=md(x[q>>2],x[x[q+48>>2]+12>>2],f,G);G=z[e+188>>1];v[h+3|0]=G;v[h+5|0]=G>>>8;break wb}v[d+5|0]=255}t=g|t;d=d+6|0;i=i+1|0;continue}}}ub(K);tb(A)}o=o+1|0;continue}break}break A}i=N()|0;break w}break A}i=N()|0;break w}iD(m);d=0;xb:{switch(g-31|0){default:if(g){break c}break;case 2:break xb;case 1:break c;case 0:break K}}j=j+1|0;continue}break}Wj(M,0);d=1;if(t&1){break B}while(1){b=d&65535;if(b>>>0>z[a+480192>>1]){w[a+480192>>1]=0;break B}b=((b<<2)+a|0)+900380|0;c=x[b>>2];if(c){Db(Nv(c))}x[b>>2]=0;d=d+1|0;continue}}i=N()|0;break f}yb:{if(!$){break yb}x[31609]=0;b=P(1,e+188|0,16428)|0;c=x[31609];x[31609]=0;zb:{if((c|0)!=1){c=x[a+1298472>>2];x[31609]=0;S(385,c|0,2,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break zb}tb(b);break yb}i=N()|0;break f}i=N()|0;tb(b);break f}g=22292;Ab:{Bb:{switch(y[e+891|0]){case 0:g=z[F>>1]>4?17316:17302;break Ab;case 1:g=17284;break Ab;case 2:g=17266;break Ab;case 3:break Bb;default:break Ab}}g=17239}x[31609]=0;b=e+88|0;O(550,b|0,16838);c=x[31609];x[31609]=0;Cb:{Db:{Eb:{if((c|0)!=1){x[31609]=0;c=e+128|0;S(551,c|0,b|0,e+891|0);f=x[31609];x[31609]=0;if((f|0)==1){break Eb}zb(a+1298344|0,c);tb(c);Eb(b);x[31609]=0;c=P(1,c|0,12722)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Db}zb(a+1298356|0,c);tb(c);x[31609]=0;O(130,a+1298368|0,g|0);c=x[31609];x[31609]=0;if((c|0)==1){break Cb}ia=a+1298404|0,ja=x[Fc(b,28)>>2],x[ia>>2]=ja;d=1;break c}i=N()|0;break f}i=N()|0;Eb(e+88|0);break f}i=N()|0;break f}i=N()|0;break f}i=N()|0;ub(K)}tb(A);break w}i=N()|0;break w}i=N()|0}iD(m);break f}i=N()|0;break f}i=N()|0;break f}i=N()|0;break f}l=1;if((d|0)!=7){break m}d=f+108|0;h=QC(d);while(1){if((d|0)!=(h|0)){ia=d,ja=iw(y[d|0]-24|0),v[ia|0]=ja;d=d+1|0;continue}break}h=0}t=1;break l}h=0;Fb:{if(B|(g|0)<0){break Fb}m=f+108|0;i=7;Gb:while(1){if((i|0)==10){break Fb}r=D(i,12);o=D(i,-12)+72|0;d=0;while(1)if((d|0)==12){i=i+1|0;continue Gb}else{s=xb(m,d+r|0);v[s|0]=o+y[s|0];d=d+1|0;continue}}}}x[31609]=0;O(552,L|0,e+188|0);d=x[31609];x[31609]=0;if((d|0)!=1){Hb:{d=y[e+192|0];if((d-1&255)>>>0<=15){v[f+31|0]=d;t=1}d=y[e+193|0];if(d-1<<24>>24>=0){v[f+30|0]=d}d=0;Ib:{while(1){if((d|0)==(l|0)){if(!u){break j}if((g|0)>=0){break Ib}break j}x[31609]=0;f=D(d+q|0,104)+a|0;O(279,f+484380|0,8);i=x[31609];x[31609]=0;if((i|0)!=1){v[e+128|0]=y[e+194|0];v[e+68|0]=64;ia=f+484410|0,ja=y[Qb(e+128|0,e+68|0)|0]<<2,w[ia>>1]=ja;v[f+484416|0]=y[e+195|0];d=d+1|0;continue}break}break k}f=Zc(e+128|0,8,1,1,0);r=Bb(z[e+190>>1]);i=Bb(z[e+188>>1]);d=x[j>>2];x[31609]=0;g=R(154,d|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){d=ze(w[e+92>>1]);if(d&16){hd(f,16);g=g>>>1|0}if(d&32){vp(f,3);g=g>>>1|0}if(d&64){wg(f,2)}if(h){g=(g>>>0)/((-1<<l^-1)>>>0)|0}h=i+r|0;d=0;while(1){if((d|0)==(l|0)){break j}m=D(d+q|0,104)+a|0;o=m+484380|0;x[o>>2]=g;x[31609]=0;U(215,f|0,o|0,j|0)|0;o=x[31609];x[31609]=0;if((o|0)==1){break Hb}i=i<<1;h=h<<1;if(r>>>0>=2){x[m+484388>>2]=h;x[m+484384>>2]=i;m=m+484414|0;w[m>>1]=z[m>>1]|2}d=d+1|0;g=g<<1;continue}}}}}i=N()|0;ub(j);break f}ub(j);n=n+1|0;k=k+l|0;g=z[a+480192>>1];continue}}i=N()|0;break e}i=N()|0;break e}i=N()|0}wc(H)}ub(L);Q(i|0);p()}d=0}wc(H)}ub(L)}fb=e+944|0;return d|0}function zoa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=E(0),k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,C=0,F=E(0),G=0,H=0,I=0,J=0,K=0,L=0,M=0,T=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ca=0,da=0,ea=E(0),fa=0,ga=0,ia=0,ja=0,ka=0;e=fb-608|0;fb=e;yc(b);a:{b:{c:{f=e+600|0;if(!wi(b,f)){break c}if(!rW(f)){break c}if((np(b)|0)>=0){break c}d=1;if((c|0)==64){break c}Dd(a,16777216);x[a+480208>>2]=x[a+480208>>2]|1681e4;rr(e+256|0,32);f=x[e+268>>2];d=a+1074320|0;x[d>>2]=x[e+264>>2];x[d+4>>2]=f;d=x[e+260>>2];x[a+1074312>>2]=x[e+256>>2];x[a+1074316>>2]=d;bg(a+1074312|0,38);q=Nb(e+588|0);r=Nb(e+576|0);u=Nb(e+564|0);k=Nb(e+552|0);Ih(b,4);i=a+480190|0;K=c&1;H=a+1298332|0;s=2500;I=!(c&2);d:{e:{f:{while(1){c=x[b+8>>2];d=x[b>>2];x[31609]=0;c=U(150,d|0,c|0,4)|0;d=x[31609];x[31609]=0;g:{h:{i:{j:{k:{l:{m:{if((d|0)!=1){n:{if(c){x[31609]=0;c=R(711,b|0)|0;d=x[31609];x[31609]=0;o:{if((d|0)==1){break o}n=4;d=0;p:{q:{r:{switch(c+21|0){case 20:x[31609]=0;c=R(281,b|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){d=c&65535;if(z[a+480188>>1]|d-1>>>0>126){continue}w[a+480188>>1]=c;ja=a,ka=Yb(512/(d>>>0)|0,16,128),x[ja+480228>>2]=ka;continue}c=N()|0;break a;case 19:x[31609]=0;M=R(281,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break o}if(M>>>0<=1024){continue}break m;case 16:x[31609]=0;c=R(281,b|0)|0;f=x[31609];x[31609]=0;if((f|0)!=1){if((c&65535)==4){continue}break m}c=N()|0;break a;case 15:x[31609]=0;c=R(281,b|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){x[e+256>>2]=c;x[e+152>>2]=800;ja=a,ka=Ye(+A[Hb(e+256|0,e+152|0)>>2]*1.24*1e4),x[ja+480204>>2]=ka;continue}c=N()|0;break a;case 31:x[31609]=0;c=R(281,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break o}Z=1;s=Ld(c,0,1e4);continue;case 32:case 33:x[31609]=0;c=R(281,b|0)|0;d=x[31609];x[31609]=0;s:{t:{if((d|0)!=1){Z=1;if(!c){continue}x[31609]=0;d=P(1,e+540|0,12631)|0;c=x[31609];x[31609]=0;if((c|0)==1){break t}c=x[a+1298472>>2];x[31609]=0;S(385,c|0,2,d|0);c=x[31609];x[31609]=0;if((c|0)==1){break s}tb(d);continue}c=N()|0;break a}c=N()|0;break a}c=N()|0;tb(d);break a;case 14:x[31609]=0;P(183,b|0,4)|0;c=x[31609];x[31609]=0;if((c|0)==1){break o}g=!z[i>>1]|g;continue;case 11:if(!K){break q}if(!mc(x[q>>2],x[q+4>>2])){break q}x[31609]=0;c=e+256|0;O(712,c|0,b|0);d=x[31609];x[31609]=0;if((d|0)!=1){if(x[q>>2]){Nc(q);d=x[q>>2];Yo(q);Db(d);ja=Ab(q),ka=0,x[ja>>2]=ka;x[q>>2]=0;x[q+4>>2]=0}x[q>>2]=x[c>>2];x[q+4>>2]=x[c+4>>2];d=Ab(c);ja=Ab(q),ka=x[d>>2],x[ja>>2]=ka;x[d>>2]=0;x[c>>2]=0;x[c+4>>2]=0;Si(c);continue}c=N()|0;break a;case 3:case 4:case 10:f=Sh(x[k>>2],x[k+4>>2]);d=z[i>>1];if(f>>>0<=d>>>0){continue}if((g|I)&1){break q}if(!pi(d)){break q}d=d+1|0;w[i>>1]=d;t=Nb(e+528|0);x[31609]=0;m=R(168,e+508|0)|0;g=x[31609];x[31609]=0;u:{v:{w:{if((g|0)!=1){if((c|0)==-17){break w}if((c|0)!=-11){break v}x[31609]=0;g=R(281,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break u}x[31609]=0;c=e+152|0;S(185,c|0,b|0,g|0);g=x[31609];x[31609]=0;if((g|0)==1){break u}g=hc(e+256|0,c);kd(m,g);ub(g);break g}c=N()|0;break d}x[31609]=0;c=e+256|0;O(713,c|0,b|0);g=x[31609];x[31609]=0;x:{if((g|0)!=1){g=An(t,c);ec(c);se(e+480|0,x[g>>2],x[e+532>>2]);c=Md(e+472|0);x[31609]=0;g=x[c+4>>2];x[e+16>>2]=x[c>>2];x[e+20>>2]=g;c=hg(327,e+488|0,x[e+480>>2],x[e+484>>2],e+16|0);g=x[31609];x[31609]=0;if((g|0)==1){break x}kd(m,c);break g}c=N()|0;break e}c=N()|0;break e}x[31609]=0;c=e+256|0;O(714,c|0,b|0);g=x[31609];x[31609]=0;y:{if((g|0)!=1){g=An(t,c);ec(c);se(e+440|0,x[g>>2],x[e+532>>2]);c=Md(e+432|0);x[31609]=0;g=x[c+4>>2];x[e+8>>2]=x[c>>2];x[e+12>>2]=g;c=hg(327,e+452|0,x[e+440>>2],x[e+444>>2],e+8|0);g=x[31609];x[31609]=0;if((g|0)==1){break y}kd(m,c);break g}c=N()|0;break e}c=N()|0;break e}c=N()|0;break e;case 9:c=z[i>>1];if(!pi(c)){continue}w[i>>1]=c+1;continue;case 8:if(!K){break q}if(!mc(x[u>>2],x[u+4>>2])){break q}x[31609]=0;c=e+256|0;O(715,c|0,b|0);d=x[31609];x[31609]=0;if((d|0)!=1){qW(u,c);wc(c);continue}c=N()|0;break a;case 7:if(!mc(x[k>>2],x[k+4>>2])){break q}x[31609]=0;c=e+256|0;O(716,c|0,b|0);d=x[31609];x[31609]=0;if((d|0)!=1){if(x[k>>2]){Nc(k);d=x[k>>2];pC(k);Db(d);ja=Ab(k),ka=0,x[ja>>2]=ka;x[k>>2]=0;x[k+4>>2]=0}x[k>>2]=x[c>>2];x[k+4>>2]=x[c+4>>2];d=Ab(c);ja=Ab(k),ka=x[d>>2],x[ja>>2]=ka;x[d>>2]=0;x[c>>2]=0;x[c+4>>2]=0;tv(c);continue}c=N()|0;break a;case 6:if(!K){break q}if(!mc(x[r>>2],x[r+4>>2])){break q}x[31609]=0;c=e+256|0;O(717,c|0,b|0);d=x[31609];x[31609]=0;if((d|0)!=1){if(x[r>>2]){Nc(r);d=x[r>>2];kv(r);Db(d);ja=Ab(r),ka=0,x[ja>>2]=ka;x[r>>2]=0;x[r+4>>2]=0}x[r>>2]=x[c>>2];x[r+4>>2]=x[c+4>>2];d=Ab(c);ja=Ab(r),ka=x[d>>2],x[ja>>2]=ka;x[d>>2]=0;x[c>>2]=0;x[c+4>>2]=0;ln(c);continue}c=N()|0;break a;case 17:case 18:break p;case 0:case 1:case 2:break q;case 5:break r;default:break m}}x[31609]=0;d=e+256|0;O(718,d|0,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break n}z:{c=x[e+256>>2];f=x[e+260>>2];if(mc(c,f)){break z}x[31609]=0;V(343,H|0,c|0,Xc(c,f)|0,1);c=x[31609];x[31609]=0;if((c|0)!=1){break z}c=N()|0;ec(d);break a}ec(e+256|0);continue}x[31609]=0;n=R(281,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break o}}x[31609]=0;P(183,b|0,n|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){continue}}c=N()|0;break a}d=0;if(!z[a+480188>>1]|!M){break m}b=x[k>>2];c=x[k+4>>2];if(mc(b,c)){break m}if(K){if(mc(x[q>>2],x[q+4>>2])){break m}if(mc(x[u>>2],x[u+4>>2])){break m}if(mc(x[r>>2],x[r+4>>2])){break m}}b=Sh(b,c);if(b>>>0>=256){x[31609]=0;O(719,k|0,255);b=x[31609];x[31609]=0;if((b|0)==1){break b}b=Sh(x[k>>2],x[k+4>>2])}w[a+480192>>1]=b;n=a+480192|0;ja=a,ka=z[qe(i,n)>>1],w[ja+480190>>1]=ka;if(g&1){x[31609]=0;b=P(1,e+528|0,16517)|0;c=x[31609];x[31609]=0;if((c|0)==1){break h}c=x[a+1298472>>2];x[31609]=0;S(385,c|0,2,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break i}tb(b)}g=0;A:while(1){if((g|0)!=2){d=1;while(1){h=d&65535;if(h>>>0>z[n>>1]){g=g+1|0;continue A}B:{f=jn(x[k>>2],h-1|0);if(!y[f|0]|v[f+128|0]<0){break B}if((qv(f)|0)==((g|0)!=1|0)){break B}C:{D:{E:{c=0;F:{if(!qv(f)){break F}if(Bb(y[f+6|0]|y[f+7|0]<<8)){break F}if(Bb(y[f+14|0]|y[f+15|0]<<8)>>>0>20){break F}c=(Bb(y[f+18|0]|y[f+19|0]<<8)|0)==4}G:{H:{if(c){c=y[f+23|0];b=y[f+140|0];x[31609]=0;b=ha(720,f|0,a|0,(b&2)>>>1|0,(D(h,104)+a|0)+484380|0,s&65535)|0;l=x[31609];x[31609]=0;I:{J:{if((l|0)!=1){if(!b){break I}x[31609]=0;b=P(36,e+384|0,10771)|0;l=x[31609];x[31609]=0;if((l|0)==1){break J}Ac(((h<<5)+a|0)+946304|0,b);tb(b);l=x[k>>2];b=d;if(Sh(l,x[k+4>>2])>>>0<=c>>>0){break G}ja=f,ka=y[f+143|0]+y[jn(l,c)+143|0]|0,v[ja+143|0]=ka;break H}c=N()|0;break a}c=N()|0;break a}b=c+1|0;break G}c=0;K:{if(!qv(f)){break K}if((Bb(y[f+6|0]|y[f+7|0]<<8)|0)!=1){break K}if((Bb(y[f+14|0]|y[f+15|0]<<8)|0)!=2){break K}c=(Bb(y[f+18|0]|y[f+19|0]<<8)|0)==10}b=d;if(!c){break G}c=e+256|0;iW(c,f);b=Bb(y[e+276|0]|y[e+277|0]<<8);if(b>>>0>=z[i>>1]){break H}x[31609]=0;l=R(709,e+152|0)|0;m=x[31609];x[31609]=0;if((m|0)==1){break E}m=y[e+292|0]|y[e+293|0]<<8;o=z[a+480190>>1];x[31609]=0;t=c;C=D(b,104);b=a+484380|0;c=Bb(m);b=ba(721,t|0,(C+b|0)+104|0,(c>>>0<o>>>0?(b+D(c,104)|0)+104|0:l)|0,b+D(h,104)|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break D}if(!b){break H}x[31609]=0;b=P(36,e+140|0,11269)|0;c=x[31609];x[31609]=0;if((c|0)==1){break C}Ac(((h<<5)+a|0)+946304|0,b);tb(b);v[f+139|0]=y[f+139|0]+12}b=d}x[31609]=0;b=b&65535;c=U(251,a|0,h|0,b|0)|0;h=x[31609];x[31609]=0;if((h|0)!=1){if(!c|b>>>0>z[i>>1]){break B}x[31609]=0;V(722,f|0,c|0,(D(b,104)+a|0)+484380|0,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){break B}}c=N()|0;break a}c=N()|0;break a}c=N()|0;break a}c=N()|0;break a}d=d+1|0;continue}}break}I=og(e+128|0);t=og(e+116|0);b=oc(x[u>>2],x[u+4>>2]);_=D(z[a+480188>>1],M);$=cm((b>>>0)/(_>>>0)|0);x[31609]=0;X=a+484344|0;O(223,X|0,$|0);b=x[31609];x[31609]=0;if((b|0)==1){break k}Nc(Xb(x[a+484360>>2],y[a+484376|0]));b=z[a+480188>>1];x[31609]=0;C=P(723,e+104|0,b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break l}ja=e,ka=wb(x[r>>2]),x[ja+52>>2]=ka;fa=a+902204|0;ga=wb(x[r+4>>2]);while(1){L:{M:{N:{m=x[e+52>>2];if(!Ib(m,ga)){break N}b=ze((y[m+6|0]|y[m+7|0]<<8)<<16>>16);if((b|0)==1){break L}if((b&65535)==65535){break N}g=Bb(y[m|0]|y[m+1|0]<<8);b=x[q>>2];f=x[q+4>>2];c=Mg(b,f);if(g>>>0>=c>>>0){break L}d=Bb(y[m+2|0]|y[m+3|0]<<8);if(d>>>0>c>>>0|!d|g>>>0>c-d>>>0){break L}c=b+(Mg(b,f)<<5)|0;x[e+256>>2]=b;x[e+260>>2]=c-b>>5;b=x[e+256>>2];Zb(e+76|0,b+(Bb(y[m|0]|y[m+1|0]<<8)<<5)|0,Bb(y[m+2|0]|y[m+3|0]<<8));O:{G=Xb(x[a+484360>>2],y[a+484376|0]);if(mc(x[G>>2],x[G+4>>2])){break O}x[31609]=0;O(537,G|0,65534);b=x[31609];x[31609]=0;if((b|0)!=1){break O}break M}ja=e,ka=wb(x[e+76>>2]),x[ja+40>>2]=ka;b=fb-16|0;fb=b;ia=x[vb(b+12|0,x[e+76>>2]+(x[e+80>>2]<<5)|0)>>2];fb=b+16|0;while(1){i=x[e+40>>2];if(!Ib(i,ia)){break L}b=ze(ze((y[m+8|0]|y[m+9|0]<<8)<<16>>16)+ze((y[i+16|0]|y[i+17|0]<<8)<<16>>16)<<16>>16);v[i+16|0]=b;v[i+17|0]=b>>>8;b=de(I);while(1){P:{c=0;if(!b){break P}d=b+14|0;if(!mv(i,d)){c=1;if(!mv(d,i)){break P}b=b+4|0}b=x[b>>2];continue}break}Q:{R:{S:{if(c){x[31609]=0;b=P(724,I|0,i|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break M}H=z[b>>1];break S}H=0;if(!K){break S}b=y[i+12|0]|y[i+13|0]<<8;x[31609]=0;H=P(367,X|0,Bb(b)|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break M}if((H|0)==65535){break L}x[31609]=0;b=P(724,I|0,i|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break M}w[b>>1]=H;if(Bb(y[i+8|0]|y[i+9|0]<<8)>>>0>=$>>>0){break R}if(Bb(y[i+10|0]|y[i+11|0]<<8)>>>0>=M>>>0){break R}l=Bb(y[i+14|0]|y[i+15|0]<<8);c=Fk(wb(x[u>>2]),D(Bb(y[i+8|0]|y[i+9|0]<<8),_));b=z[a+480188>>1];ja=e,ka=Fk(c,D(b,Bb(y[i+10|0]|y[i+11|0]<<8))),x[ja+28>>2]=ka;T=0;x[e+100>>2]=0;o=Ng(e- -64|0);T:while(1){U:{d=Bb(y[i+12|0]|y[i+13|0]<<8);c=Wb(x[X>>2],H);if(d>>>0<=T>>>0){break U}n=0;Y=md(x[c>>2],x[x[c+48>>2]+12>>2],T,0);c=0;while(1){if((b&65535)>>>0<=n>>>0){T=T+1|0;continue T}b=wb(x[u+4>>2]);d=x[e+28>>2];h=Ib(d,b)?d:e+100|0;b=wb(x[u+4>>2]);if(Ib(x[e+28>>2],b)){oW(e+28|0)}d=Y+D(n,6)|0;g=y[h+1|0];b=(g>>>0>=85?-1:g+25|0)<<24>>24;s=0;f=x[k>>2];L=Sh(f,x[k+4>>2]);J=y[h+3|0];V:{if(L>>>0<=J>>>0){break V}s=J+1|0;if(v[jn(f,J)+142|0]&1|(b|0)<0){break V}b=ze((y[i+16|0]|y[i+17|0]<<8)<<16>>16)+b<<24>>24;aa=b&255;b=(b|0)<=0?1:aa>>>0>=120?120:aa}W:{if(!y[d|0]|!(y[h|0]|(g|0)!=255|J|y[h+2|0])){break W}g=y[d+1|0];if(!g|g>>>0>L>>>0){break W}if(y[jn(f,g-1|0)+132|0]!=2){break W}Vo(d)}f=sv(x[C>>2],n);X:{Y:{if(!(c&1)){g=y[h|0];break Y}c=y[o|0]|y[o+1|0]<<8|(y[o+2|0]<<16|y[o+3|0]<<24);v[d|0]=c;v[d+1|0]=c>>>8;v[d+2|0]=c>>>16;v[d+3|0]=c>>>24;c=y[o+4|0]|y[o+5|0]<<8;v[d+4|0]=c;v[d+5|0]=c>>>8;Z:{if(y[d+3|0]){break Z}g=y[f+21|0];c=y[sv(x[C>>2],n-1|0)+21|0];if((g|0)==(c|0)){break Z}v[d+3|0]=21;v[f+21|0]=c;v[d+5|0]=c}c=0;g=y[h|0];if(!(g-24>>>0<2|(g|0)==9|!g&(y[h+2|0]+7&255)>>>0<2)){break X}}_:{$:{aa:{ba:{ca:{da:{switch(g|0){case 5:c=y[f+17|0];break ca;case 0:ea:{c=y[h+2|0];if(c>>>0>=201){g=0;fa:{switch(c-242|0){case 11:v[d+4|0]=1;v[d+2|0]=14;v[f+16|0]=0;break $;case 9:if(!y[d|0]){v[d|0]=y[f+17|0]}v[d+4|0]=1;v[d+2|0]=15;break $;case 8:if((l&255)>>>0<2){break $}l=l-1|0;break aa;case 7:if((l&255)==255){l=255;break $}l=l+1|0;break aa;case 6:v[f+17|0]=b;if(y[f+18|0]!=(s&255)){break $}v[d|0]=b;v[d+5|0]=255;v[d+3|0]=4;w[f+32>>1]=0;x[f+8>>2]=0;break $;case 5:v[d+5|0]=242;v[d+3|0]=2;break $;case 4:v[d+5|0]=242;v[d+3|0]=3;break $;case 3:v[d+5|0]=244;v[d+3|0]=2;break $;case 2:v[d+5|0]=244;v[d+3|0]=3;break $;case 1:v[d+5|0]=248;v[d+3|0]=2;break $;case 12:break ea;case 0:break fa;default:break $}}v[d+5|0]=248;v[d+3|0]=3;break $}g=0;L=v[h+1|0];if((L|0)<0&c>>>0>99){break $}if((L|0)>=0){v[f+17|0]=b;v[d|0]=b;v[f+18|0]=s;v[d+1|0]=s;w[f+32>>1]=0;x[f+8>>2]=0;c=y[h+2|0]}b=c&255;if(!b){break $}ja=f,ka=_l(+(b>>>0)*.64),v[ja+19|0]=ka;j=B[f>>2];x[f>>2]=0;g=j!=E(0);break $}v[d+4|0]=0;v[d+2|0]=14;v[f+16|0]=1;break $;case 1:x[f+4>>2]=0;B[f>>2]=E(y[h+2|0])*E(.0333000011742115);break _;case 2:x[f+4>>2]=0;B[f>>2]=E(y[h+2|0])*E(-.0333000011742115);break _;case 12:v[e+256|0]=15;v[e+96|0]=y[h+3|0]>>>3;b=y[Qb(e+256|0,e+96|0)|0];v[e+256|0]=15;v[e+96|0]=y[h+2|0]>>>3;ja=f,ka=y[Qb(e+256|0,e+96|0)|0]|b<<4,v[ja+24|0]=ka;break _;case 3:x[f+12>>2]=0;b=y[h+2|0];w[f+32>>1]=0;B[f+8>>2]=E(b>>>0)*E(.0333000011742115);break _;case 4:x[f+12>>2]=0;b=y[h+2|0];w[f+32>>1]=0;B[f+8>>2]=E(b>>>0)*E(-.0333000011742115);break _;case 15:if(!y[h+2|0]|(b|0)<0){break _}g=b-y[f+17|0]<<5;c=g>>31;c=(c^g)-c|0;x[e+256>>2]=c;v[f+17|0]=b;x[f+8>>2]=0;v[d|0]=b;v[d+3|0]=4;b=Eh((c>>>0)/(y[h+2|0]<<1>>>0)|0);v[d+5|0]=b;v[f+27|0]=b;x[e+96>>2]=D(b,(l&255)-1|0);ja=f,ka=c-x[Cd(e+256|0,e+96|0)>>2]|0,w[ja+32>>1]=ka;break _;case 13:v[e+256|0]=15;v[e+96|0]=y[h+3|0]>>>3;b=y[Qb(e+256|0,e+96|0)|0];v[e+256|0]=15;v[e+96|0]=y[h+2|0];ja=f,ka=y[Qb(e+256|0,e+96|0)|0]|b<<4,v[ja+23|0]=ka;break _;case 18:b=y[h+2|0]+y[f+17|0]&255;b=b?b>>>0>=120?120:b:1;v[f+17|0]=b;v[d|0]=b;v[d+5|0]=255;v[d+3|0]=4;break ba;case 23:case 24:case 25:b=de(t);while(1){ga:{c=0;if(!b){break ga}g=b+13|0;if(!ov(h,g)){c=1;if(!ov(g,h)){break ga}b=b+4|0}b=x[b>>2];continue}break};if(c){v[d+3|0]=31;x[31609]=0;b=P(725,t|0,h|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break M}v[d+5|0]=y[b|0];break _}b=x[Ab(t)>>2];if(b>>>0>127){break _}x[e+92>>2]=y[h|0]|y[h+1|0]<<8|(y[h+2|0]<<16|y[h+3|0]<<24);c=x[a+480208>>2];x[31609]=0;x[e+24>>2]=x[e+92>>2];c=U(726,e+24|0,Pe(fa,b)|0,c|0)|0;g=x[31609];x[31609]=0;ha:{if((g|0)==1){break ha}if(!c){break _}v[d+3|0]=31;x[31609]=0;c=P(725,t|0,h|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break ha}b=b|-128;v[c|0]=b;v[d+5|0]=b;ca=(y[h|0]&254)==24|ca;break _}break M;case 16:if(!y[h+2|0]){break _}v[d+3|0]=15;x[e+256>>2]=15;x[e+96>>2]=y[h+3|0]+1;ja=d,ka=x[Cd(e+256|0,e+96|0)>>2],v[ja+5|0]=ka;w[f+30>>1]=D(y[h+2|0],y[h+3|0]+1|0);break _;case 9:v[d+3|0]=16;b=y[h+2|0];l=b?b:4;v[d+5|0]=l;break _;case 19:ia:{b=y[h+1|0];switch(b|0){case 0:case 4:break ia;default:break _}}g=128;g=(b|0)==4?y[h+3|0]:g;v[e+91|0]=g;v[e+256|0]=y[h+2|0];v[e+96|0]=100;b=e+256|0;s=e+96|0;c=y[Qb(b,s)|0];x[e+256>>2]=128;x[e+96>>2]=256-(g&255);g=x[Cd(b,s)>>2];v[e+256|0]=128;b=y[Qb(b,e+91|0)|0];g=(D(c,g)|0)/128|0;s=g&255;if((s|0)!=y[f+20|0]){v[f+20|0]=g;v[d+3|0]=21;g=Bc(((D(s,y[f+19|0])+50&65535)>>>0)/100|0,0);v[f+21|0]=g;v[d+5|0]=g}if(y[h+1|0]!=4|(z[a+480188>>1]-1|0)<=(n|0)){break _}g=n+1|0;h=sv(x[C>>2],g);b=D(b,c)>>>7|0;if(y[h+20|0]==(b&255)){break _}v[h+20|0]=b;b=Y+D(g,6)|0;v[b+3|0]=21;c=Bc(((D(y[f+20|0],y[f+19|0])+50&65535)>>>0)/100|0,0);v[f+21|0]=c;v[b+5|0]=c;break _;case 10:case 11:case 17:case 20:v[d+3|0]=0;break _;case 7:b=y[h+2|0];v[f+25|0]=0;v[f+26|0]=0;v[f+22|0]=b;break _;case 8:v[f+22|0]=y[f+22|0]+y[h+2|0];break _;case 14:v[f+25|0]=y[h+3|0];v[f+26|0]=y[h+2|0];break _;case 6:break da;default:break _}}v[f+18|0]=s;v[f+17|0]=b;v[d+1|0]=s;c=b}v[d|0]=c;if((b|0)>=0){v[f+18|0]=s;v[d+1|0]=s}if(y[h|0]==5){v[d+4|0]=1;v[d+2|0]=11}b=y[f+26|0];c=y[f+22|0];if(!(b|(c|y[h+2|0]))){break ba}if(b){da=(Ri(+z[f+28>>1]*.006135923151542565+4.71238898038469)+-1)*+(b>>>0)*.25}else{da=0}v[d+3|0]=44;ja=d,ka=_l(da+ +(c+y[h+2|0]|0)),v[ja+5|0]=ka}w[f+32>>1]=0;break _}v[d+5|0]=l;v[d+3|0]=16}b=Bc(((D(y[f+20|0],y[f+19|0])+50&65535)>>>0)/100|0,0);if(!(!g&y[f+21|0]==(b&255))){v[f+21|0]=b;v[d+5|0]=b;v[d+3|0]=21}if(n&1|v[h+1|0]<=0|(z[a+480188>>1]-1|0)<=(n|0)){break _}b=x[k>>2];if(Sh(b,x[k+4>>2])>>>0<=J>>>0){break _}if(y[jn(b,J)+132|0]!=1){break _}g=n|1;b=Y+D(g,6)|0;c=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);v[b|0]=c;v[b+1|0]=c>>>8;v[b+2|0]=c>>>16;v[b+3|0]=c>>>24;c=y[d+4|0]|y[d+5|0]<<8;v[b+4|0]=c;v[b+5|0]=c>>>8;v[b+1|0]=y[b+1|0]+1;b=sv(x[C>>2],g);v[b+19|0]=y[f+19|0];B[b>>2]=B[f>>2];B[b+4>>2]=B[f+4>>2];B[b+8>>2]=B[f+8>>2];B[b+12>>2]=B[f+12>>2];w[b+30>>1]=z[f+30>>1]}ja:{if(y[d|0]){v[f+16|0]=0;break ja}c=0;if(y[f+16|0]){break X}}ka:{if(!z[f+30>>1]){break ka}b=l&255;w[e+256>>1]=b;c=f+30|0;ja=c,ka=z[qe(c,e+256|0)>>1]-b|0,w[ja>>1]=ka;if(y[d+3|0]){break ka}v[d+3|0]=15;v[d+5|0]=0}j=B[f>>2];la:{if(j==E(0)){break la}b=l&255;j=E(E(j*E(b>>>0))+B[f+4>>2]);B[f+4>>2]=j;if(y[d+3|0]){break la}ma:{na:{oa:{pa:{if(b>>>0>=2){g=b-1|0;F=E(g|0);if(!(F<=j)){break pa}v[e+256|0]=15;ja=e,ka=Bh(E(j/F)),v[ja+96|0]=ka;b=y[Qb(e+256|0,e+96|0)|0];B[f+4>>2]=j-E(D(b,g)|0);v[d+3|0]=22;c=b<<4;break ma}if(!(j>=E(1))){break oa}break na}if(j>=E(1)){break na}if(!(j<=E(1-b|0))){break oa}v[e+256|0]=15;ja=e,ka=Bh(E(E(-j)/F)),v[ja+96|0]=ka;c=y[Qb(e+256|0,e+96|0)|0];B[f+4>>2]=j+E(D(g,c)|0);v[d+3|0]=22;break ma}if(!(j<=E(-1))){break la}v[e+256|0]=14;ja=e,ka=Bh(E(-j)),v[ja+96|0]=ka;b=y[Qb(e+256|0,e+96|0)|0];B[f+4>>2]=j+E(b>>>0);v[d+3|0]=22;c=b|-16;break ma}v[e+256|0]=15;ja=e,ka=Bh(j),v[ja+96|0]=ka;b=y[Qb(e+256|0,e+96|0)|0];B[f+4>>2]=j-E(b>>>0);v[d+3|0]=22;c=b<<4|15}v[d+5|0]=c}j=B[f+8>>2];qa:{if(j==E(0)){break qa}b=l&255;j=E(E(j*E(b>>>0))+B[f+12>>2]);B[f+12>>2]=j;ra:{if(!y[d+3|0]){sa:{ta:{if(b>>>0>=2){c=b-1|0;F=E(c|0);if(!(F<=j)){break ta}v[e+256|0]=223;ja=e,ka=Bh(E(j/F)),v[ja+96|0]=ka;b=y[Qb(e+256|0,e+96|0)|0];B[f+12>>2]=j-E(D(b,c)|0);v[d+3|0]=2;v[d+5|0]=b;break qa}if(!(j>=E(1))){break sa}break ra}if(j>=E(1)){break ra}if(!(E(1-b|0)>=j)){break sa}v[e+256|0]=223;ja=e,ka=Bh(E(E(-j)/F)),v[ja+96|0]=ka;b=y[Qb(e+256|0,e+96|0)|0];B[f+12>>2]=j+E(D(b,c)|0);v[d+3|0]=3;v[d+5|0]=b;break qa}if(!(j<=E(-1))){break qa}v[e+256|0]=14;ja=e,ka=Bh(E(-j)),v[ja+96|0]=ka;b=y[Qb(e+256|0,e+96|0)|0];B[f+12>>2]=j+E(b>>>0);v[d+3|0]=3;v[d+5|0]=b|240;break qa}if(y[d+2|0]|b>>>0<2){break qa}ea=E(j*E(.25));c=b-1|0;F=E(c|0);if(ea>=F){v[e+256|0]=9;ja=e,ka=Bh(E(j/F))>>>2|0,v[ja+96|0]=ka;b=y[Qb(e+256|0,e+96|0)|0];B[f+12>>2]=j-E(D(b,c)<<2);v[d+2|0]=12;v[d+4|0]=b;break qa}if(!(ea<=E(1-b|0))){break qa}v[e+256|0]=9;ja=e,ka=Bh(E(E(-j)/F))>>>2|0,v[ja+96|0]=ka;b=y[Qb(e+256|0,e+96|0)|0];B[f+12>>2]=j+E(D(b,c)<<2);v[d+2|0]=13;v[d+4|0]=b;break qa}v[e+256|0]=15;ja=e,ka=Bh(j),v[ja+96|0]=ka;b=y[Qb(e+256|0,e+96|0)|0];B[f+12>>2]=j-E(b>>>0);v[d+3|0]=2;v[d+5|0]=b|240}ua:{va:{wa:{xa:{ya:{za:{Aa:{b=y[d+3|0];switch(b|0){case 4:break ua;case 0:break Aa;default:break za}}Ba:{b=y[f+23|0];if(!b){b=y[f+24|0];if(b){break Ba}if(!z[f+32>>1]){break ua}c=f+32|0;break ya}v[d+3|0]=5;v[d+5|0]=b;if(!z[f+32>>1]){break ua}break xa}v[d+3|0]=8;v[d+5|0]=b;if(z[f+32>>1]){break xa}break ua}if(!z[f+32>>1]){break ua}c=f+32|0;if(b){break wa}}v[d+3|0]=4;break va}c=f+32|0}v[d+2|0]=11}w[e+256>>1]=D(y[f+27|0],(l&255)-1|0);ja=f,ka=z[f+32>>1]-z[Oc(c,e+256|0)>>1]|0,w[ja+32>>1]=ka}w[f+28>>1]=z[f+28>>1]+D(y[f+25|0],l&255)&1023;c=0;if(n&1){break X}b=y[f+18|0];if(!b){break X}g=x[k>>2];if(Sh(g,x[k+4>>2])>>>0<b>>>0){break X}g=jn(g,b-1|0);if(!(y[g+142|0]&4)){break X}b=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);v[o|0]=b;v[o+1|0]=b>>>8;v[o+2|0]=b>>>16;v[o+3|0]=b>>>24;b=y[d+4|0]|y[d+5|0]<<8;v[o+4|0]=b;v[o+5|0]=b>>>8;c=1;b=y[e+65|0];if(!b|y[g+132|0]!=1){break X}v[e+65|0]=b+1}n=n+1|0;b=z[a+480188>>1];continue}}break}Ae(c,Xh(Ve(Oe(e+256|0,16,Bb(y[i+14|0]|y[i+15|0]<<8)&255),0)))}b=dm(x[G>>2],x[G+4>>2]);ja=e,ka=Bb(y[i+4|0]|y[i+5|0]<<8),w[ja+256>>1]=ka;w[e+64>>1]=1;c=z[qe(e+256|0,e- -64|0)>>1];x[31609]=0;V(727,G|0,b|0,c|0,H&65535);b=x[31609];x[31609]=0;if((b|0)==1){break Q}b=ze((y[m+8|0]|y[m+9|0]<<8)<<16>>16);b=ze(ze((y[i+16|0]|y[i+17|0]<<8)<<16>>16)-b<<16>>16);v[i+16|0]=b;v[i+17|0]=b>>>8}Zq(e+40|0);continue}break}break M}d=ca&1;if(d){x[31609]=0;g=a+906300|0;b=$d(g,0);W(286,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break M}x[b+16>>2]=1299020115;x[b+20>>2]=1869112133;x[b+24>>2]=655376;x[b+28>>2]=0;x[e+256>>2]=0;f=b+48|0;c=e+256|0;k0(b+32|0,f,c);x[31609]=0;c=P(36,c|0,9587)|0;h=x[31609];x[31609]=0;if((h|0)==1){break M}wE(f,c);tb(c);x[31609]=0;c=P(36,e+76|0,9580)|0;f=x[31609];x[31609]=0;if((f|0)==1){break M}rw(b+80|0,c);tb(c);x[31609]=0;b=P(36,e- -64|0,9572)|0;c=x[31609];x[31609]=0;if((c|0)==1){break M}wE($d(g,1)+48|0,b);tb(b)}b=0;while(1){if(z[a+480188>>1]>b>>>0){bE(a,b&65535);c=(b<<5)+a|0;v[c+480288|0]=d;w[c+480284>>1]=b<<8&256;b=b+1|0;continue}break}x[31609]=0;b=P(1,e+52|0,12181)|0;c=x[31609];x[31609]=0;Ca:{Da:{Ea:{if((c|0)!=1){zb(a+1298344|0,b);tb(b);x[31609]=0;b=P(1,e+40|0,12399)|0;c=x[31609];x[31609]=0;if((c|0)==1){break M}zb(a+1298356|0,b);tb(b);if(Z){break Ea}x[31609]=0;b=P(1,e+28|0,12181)|0;c=x[31609];x[31609]=0;if((c|0)==1){break M}break Da}break M}if(Sh(x[k>>2],x[k+4>>2])>>>0<=128){x[31609]=0;b=P(1,e+28|0,9314)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break Da}break M}x[31609]=0;b=P(1,e+28|0,14888)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Ca}}zb(a+1298368|0,b);tb(b);ja=a+1298404|0,ka=x[Fc(e+100|0,28)>>2],x[ja>>2]=ka;nW(C);cW(t);bW(I);d=1;break m}}c=N()|0;nW(C);break j}Uo(e+52|0);continue}}c=N()|0;break a}c=N()|0;break a}tv(k);wc(u);ln(r);Si(q);break c}c=N()|0;break j}c=N()|0}cW(t);bW(I);break a}c=N()|0;tb(b);break a}c=N()|0;break a}ub(c);x[31609]=0;c=d&65535;d=U(728,a|0,c|0,m|0)|0;g=x[31609];x[31609]=0;Fa:{Ga:{Ha:{Ia:{if((g|0)==1){break Ia}if(d){break Fa}x[31609]=0;d=U(729,a|0,c|0,m|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break Ia}if(d){break Fa}x[31609]=0;d=U(730,a|0,c|0,m|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break Ia}if(d){break Fa}x[31609]=0;d=P(731,(D(c,104)+a|0)+484380|0,m|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break Ia}if(d){break Fa}x[31609]=0;d=P(1,e+420|0,16228)|0;g=x[31609];x[31609]=0;if((g|0)==1){break Ha}g=x[a+1298472>>2];x[31609]=0;S(385,g|0,2,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break Ga}tb(d);break Fa}c=N()|0;break e}c=N()|0;break e}c=N()|0;tb(d);break e}Ja:{Ka:{La:{C=D(c,104)+a|0;if(y[C+484414|0]&64){d=z[i>>1];if(pi(d)){break La}}d=x[k>>2];if(Sh(d,x[k+4>>2])>>>0<=c>>>0){break Ka}if(y[jn(d,c)+132|0]!=2){break Ka}c=z[i>>1];if(!pi(c)){break Ka}w[i>>1]=c+1;break Ka}c=d+1|0;w[a+480190>>1]=c;G=D(c&65535,104)+a|0;o=G+484380|0;h=C+484380|0;d=x[h>>2];g=x[h+20>>2];Ma:{if(!le(d,g)){break Ma}c=(h|0)==(o|0);f=z[h+34>>1];if(c|(_d(f)|0)!=2){break Ma}if(!(le(x[o>>2],x[o+20>>2])?c:1)){break Ma}le(x[h>>2],x[h+20>>2]);if(!c){g=pv(d,Kn(f))}f=x[h+20>>2];if(!(f?g:0)){if(!c){dC(g)}break Ma}Na:{Oa:{switch(Kn(z[h+34>>1])-1|0){case 1:d=g;c=f;n=x[h+20>>2];l=x[h>>2];while(1){if(l){w[d>>1]=z[n>>1];w[c>>1]=z[n+2>>1];n=n+4|0;c=c+2|0;d=d+2|0;l=l-1|0;continue}break};break Na;case 0:break Oa;default:break Na}}d=g;c=f;n=x[h+20>>2];l=x[h>>2];while(1){if(l){v[d|0]=y[n|0];v[c|0]=y[n+1|0];n=n+2|0;c=c+1|0;d=d+1|0;l=l-1|0;continue}break}}d=Wo(o,h);w[d+34>>1]=z[d+34>>1]&65471;x[o+20>>2]=g;g=Wo(h,h);w[g+34>>1]=z[g+34>>1]&65471;x[h+20>>2]=f;c=1074992;while(1){if((c|0)!=1298224){f=a+c|0;h=x[f+104>>2];if(!((h|0)!=(d|0)&(g|0)!=(h|0))){x[f+88>>2]=x[f+88>>2]&-65}c=c+872|0;continue}break}Jj(d,a);Jj(g,a)}x[31609]=0;c=P(36,e+408|0,6320)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Ja}Be(G+484423|0,c);tb(c);x[31609]=0;c=P(36,e+396|0,6223)|0;d=x[31609];x[31609]=0;if((d|0)==1){break f}Be(C+484423|0,c);tb(c)}ub(m);ec(t);g=0;continue}break}c=N()|0;break e}c=N()|0}ub(m)}ec(t);break a}fb=e+608|0;return d|0}c=N()|0}tv(k);wc(u);ln(r);Si(q);Q(c|0);p()}function Fv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,q=0,r=0,s=0,t=0,u=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,R=0,T=0,X=0,Y=0,Z=0,_=0,$=0,ba=0,ca=0,da=0,ea=0,fa=0,ia=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=E(0),ua=0,va=0,xa=0,ya=E(0);h=fb-192|0;fb=h;X=Nb(a);s=h+160|0;v[s+26|0]=0;w[s+24>>1]=0;x[s+16>>2]=0;x[s+20>>2]=-1;x[s+8>>2]=-1;x[s+12>>2]=-1;x[s>>2]=0;x[s+4>>2]=0;fa=x[d+16>>2];a=y[d+6|0];l=x[b+484360>>2];ka=(ua=a,va=y[b+484376|0],xa=Hj(l,x[b+484364>>2])>>>0>a>>>0,xa?ua:va);a=ka&255;K=Nj(l,a);x[31609]=0;t=P(603,h+128|0,b|0)|0;l=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{if((l|0)!=1){i=x[t+4>>2];x[31609]=0;J=U(604,h+92|0,b|0,a|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break f}pa=b+484360|0;ba=c&7;k=x[d>>2];a=z[d+4>>1];l=$c(x[K>>2],x[K+4>>2]);while(1){q=a&65535;if(q>>>0>=l>>>0){break e}if(Yi(K,q)){break e}a=a+1|0;k=0;continue}}a=N()|0;break c}a=N()|0;break d}x[d>>2]=k;w[d+4>>1]=a;x[i+52>>2]=k;x[i+48>>2]=k;x[s+16>>2]=k;w[i+74>>1]=a;w[i+72>>1]=a;w[s+24>>1]=a;la=Md(h+84|0);g:{if((ba|0)!=7){break g}a=fb-16|0;fb=a;l=a+8|0;Jb(l,la,1);ap(l);fb=a+16|0;if((fa|0)!=2){break g}a=x[K>>2];f=$c(a,x[K+4>>2]);l=z[d+12>>1];if(f>>>0<=l>>>0){break g}q=x[b+484344>>2];f=x[b+484348>>2];a=z[bc(a,l)>>1];if(!Je(q,f,a)){break g}l=Wb(q,a);q=x[d+8>>2];if(A[l+12>>2]<=q>>>0){break g}a=0;m=md(x[l>>2],x[x[l+48>>2]+12>>2],q,0);l=x[t+8>>2];q=z[b+480188>>1];f=z[b+480192>>1];while(1){if((a|0)==(q|0)){break g}h:{i:{j:{k:{e=y[m|0];switch(e-253|0){case 1:case 2:break i;case 0:break k;default:break j}}if(f){break i}}if(!Tc(e)|!y[m+1|0]){break h}if(Ll(y[m+2|0],y[m+3|0])){break h}}ua=Se(l,a),va=-1,x[ua>>2]=va}m=m+6|0;a=a+1|0;continue}}Y=c&1;if(Y){GT(i+223860|0)}M=i+74|0;L=i+48|0;qa=i+223872|0;R=i+80|0;ra=b+901692|0;sa=b+902204|0;ca=i+44|0;ia=i+223860|0;Z=i+20|0;I=b+1074312|0;ma=i+616|0;da=32768;na=(ba|0)!=7;a=0;l=0;l:{m:{n:{o:{p:{q:{r:{s:{t:while(1){G=a&1;u:while(1){oa=C[d+8>>3];o(+oa);q=j(1)|0;f=j(0)|0;g=x[d+16>>2];H=(g|0)!=3;v:{w:{x:{y:{while(1){FT(h+24|0,x[b+480180>>2],z[b+480188>>1],i,G);r=y[h+24|0];if(!H&C[t+24>>3]>=oa){break y}a=65535;e=x[K>>2];n=$c(e,x[K+4>>2]);k=z[i+72>>1];if(n>>>0>k>>>0){a=z[bc(e,k)>>1]}w[i+70>>1]=a;n=x[b+484344>>2];e=x[b+484348>>2];m=a&65535;if(!(Je(n,e,m)|(g|0)!=2|(m|0)==65535)&(k|0)==(q&65535)){break y}z:{while(1){_=Yj(n,e);u=x[K>>2];while(1){k=a&65535;if(k>>>0<_>>>0){break z}a=z[i+72>>1];A:{B:{if((k|0)!=65535){k=$c(u,x[K+4>>2]);if(a>>>0<k>>>0){break B}}m=z[K+28>>1];if((a|0)==(m|0)){break z}k=$c(u,x[K+4>>2]);break A}m=a+1|0}w[i+72>>1]=m;a=65535;F=k;k=m&65535;if(F>>>0>k>>>0){a=z[bc(u,k)>>1]}w[i+74>>1]=m;w[i+70>>1]=a;if(Je(n,e,a&65535)){continue}break}a=Iq(h+24|0,ma);x[31609]=0;a=ha(605,J|0,m&65535,0,a|0,(r|0)!=0|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break p}if(!a){e=x[b+484348>>2];n=x[b+484344>>2];a=z[i+70>>1];continue}break}if(fa>>>0<=1){a=z[i+72>>1];x[s+8>>2]=0;w[s+20>>1]=a}if(!g){break z}if(!Xu(J,M,L)){break z}C[s>>3]=C[t+24>>3];x[31609]=0;O(606,X|0,s|0);a=x[31609];x[31609]=0;if((a|0)==1){break q}x[s+16>>2]=x[L>>2];w[s+24>>1]=z[M>>1];x[31609]=0;W(607,t|0);a=x[31609];x[31609]=0;if((a|0)==1){break q}a=z[i+74>>1];w[i+72>>1]=a;ua=i,va=z[bc(x[K>>2],a)>>1],w[ua+70>>1]=va;x[i+52>>2]=x[i+48>>2]}if(z[M>>1]==65535){break m}a=x[b+484344>>2];e=z[i+70>>1];if(!Je(a,x[b+484348>>2],e)){a=z[i+72>>1];if((a|0)==z[K+28>>1]){if(!g){break n}if(!Xu(J,M,L)){break o}C[s>>3]=C[t+24>>3];x[31609]=0;O(606,X|0,s|0);a=x[31609];x[31609]=0;if((a|0)==1){break q}x[s+16>>2]=x[L>>2];w[s+24>>1]=z[M>>1];x[31609]=0;W(607,t|0);a=x[31609];x[31609]=0;if((a|0)==1){break q}x[i+52>>2]=x[i+48>>2];continue}w[M>>1]=a+1;continue}break}k=x[L>>2];if(k>>>0>=A[Wb(a,e)+12>>2]){x[L>>2]=0;k=0}if((g|0)!=2){break x}if(z[i+72>>1]!=(q&65535)|(f|0)!=(k|0)){break w}}g=1;v[s+26|0]=1;break m}a=0;if((g|0)==3){break v}}a=0;if(A[J+28>>2]<da>>>0){break v}x[t+24>>2]=0;x[t+28>>2]=2146435072;x[J+28>>2]=0;da=da>>>(da>>>0>256)|0;k=x[L>>2];a=1}q=z[i+72>>1];f=Iq(h+24|0,ma);x[31609]=0;q=ha(605,J|0,q|0,k|0,f|0,(r|0)!=0|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break s}if((a|q)==1){if(fa>>>0<=1){w[s+20>>1]=z[i+72>>1];x[s+8>>2]=x[i+48>>2]}if(!g){break n}if(!Xu(J,M,L)){break o}C[s>>3]=C[t+24>>3];x[31609]=0;O(606,X|0,s|0);a=x[31609];x[31609]=0;if((a|0)==1){break r}x[s+16>>2]=x[L>>2];w[s+24>>1]=z[M>>1];x[31609]=0;W(607,t|0);a=x[31609];x[31609]=0;if((a|0)==1){break r}x[i+52>>2]=x[i+48>>2];continue}w[s+22>>1]=z[i+72>>1];x[s+12>>2]=x[i+48>>2];ET(b,i,0);m=x[i+48>>2];q=Wb(x[b+484344>>2],z[i+70>>1]);if(m>>>0>=A[q+12>>2]){x[L>>2]=0;m=0}if(r){continue}a=0;m=md(x[q>>2],x[x[q+48>>2]+12>>2],m,0);Jb(h+24|0,I,77);n=Gb(x[x[h+24>>2]>>2],x[h+28>>2]);C:{while(1){if(z[b+480188>>1]>a>>>0){D:{E:{if(!AB(m)){if(!n|!(y[((a<<5)+b|0)+480281|0]&4)){break E}}Vo((i+D(a,872)|0)+1404|0);break D}if(Wg(y[m|0])){F:{if(!Id(y[i+223884|0])){break F}q=y[m+1|0];if(q-251>>>0<5|!q){break F}e=y[m+5|0];g=y[m+3|0];k=Dj(y[m+2|0],y[m+4|0]);f=h+24|0;v[f|0]=q-1;x[f+4>>2]=k&65535;x[31609]=0;q=P(608,qa|0,f|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break C}ua=q,ya=E(E(Dj(g,e)>>>0)/E(999)),B[ua>>2]=ya}Vo((i+D(a,872)|0)+1404|0);break D}q=i+D(a,872)|0;f=q+1408|0;e=y[m+4|0]|y[m+5|0]<<8;v[f|0]=e;v[f+1|0]=e>>>8;f=q+1404|0;e=y[m|0]|y[m+1|0]<<8|(y[m+2|0]<<16|y[m+3|0]<<24);v[f|0]=e;v[f+1|0]=e>>>8;v[f+2|0]=e>>>16;v[f+3|0]=e>>>24;G:{H:{I:{J:{switch(y[m+3|0]-16|0){case 0:e=y[m+5|0];break I;case 3:break G;case 4:break H;case 1:break J;default:break D}}Jb(h+24|0,I,5);if(!Gb(x[x[h+24>>2]>>2],x[h+28>>2])){break D}e=y[m+5|0];if(!e){break D}}CT(b,i,e&255);break D}f=q+1409|0;e=y[f|0];K:{if(!(e|!(x[b+480180>>2]&16777250))){v[f|0]=y[q+1449|0];break K}v[q+1449|0]=e}q=y[m+5|0];f=q&240;if((f|0)!=224){if((f|0)!=96){break D}x[i+24>>2]=x[i+24>>2]+(q&15);break D}if(x[Z>>2]){break D}q=q&15;if(q?0:y[b+480180|0]&2){break D}x[Z>>2]=q+1;break D}q=y[m+5|0];if((q&240)!=224){break D}x[Z>>2]=(q&15)+1}m=m+6|0;a=a+1|0;continue}break}q=Kl(i);x[h+24>>2]=1;a=x[bd(Z,h+24|0)>>2];w[i+68>>1]=65535;x[i+60>>2]=-1;x[i+64>>2]=-1;_=q-1|0;a=q-a|0;T=D(a,1e4);m=0;while(1){L:{M:{N:{O:{P:{if(z[b+480188>>1]<=m>>>0){if(x[b+480180>>2]!=4|x[i+40>>2]!=65535){break P}x[i+52>>2]=x[i+48>>2];w[i+74>>1]=z[i+72>>1];continue u}g=i+D(m,872)|0;k=g+1404|0;if(AB(k)){break L}r=g+616|0;ea=g+1409|0;e=y[ea|0];$=g+1407|0;u=y[$|0];if(!Y){break N}H=y[k|0];f=H;n=g+1405|0;F=y[n|0];if(F){v[g+1415|0]=0;v[g+1419|0]=F;ua=Se(x[t+8>>2],m),va=255,v[ua+5|0]=va;f=y[k|0]}Q:{if(!Tc(f)){break Q}v[g+1415|0]=H;nV(r);if(!na){if(x[Se(x[t+8>>2],m)>>2]!=-1){break Q}}F=g+1272|0;f=y[g+1419|0];f=x[(f?f>>>0>z[b+480192>>1]?F:((f<<2)+b|0)+900380|0:F)>>2];if(!f){break Q}F=y[f+21|0];if(vd(F)){ua=g+1453|0,va=Hh(F),v[ua|0]=va}f=y[f+22|0];if(!vd(f)){break Q}ua=g+1454|0,va=Hh(f),v[ua|0]=va}R:{if(!(Tc(y[k|0])|y[n|0])){break R}F=g+1419|0;n=y[F|0];S:{if(!n){n=0;break S}if(z[b+480192>>1]<n>>>0){break S}f=x[((n<<2)+b|0)+900380>>2];if(!f|!(v[f+15|0]&1)){break S}Rq(r,x[f+8>>2],b);n=y[F|0]}f=qr(b,H,n&255);if(!f){break R}f=D(f,104)+b|0;if(!(y[f+484414|0]&32)){break R}Rq(r,z[f+484408>>1],b)}T:{U:{V:{f=y[g+1406|0];switch(f-1|0){case 1:break N;case 2:case 3:break U;case 0:break V;default:break T}}ua=Se(x[t+8>>2],m),va=y[g+1408|0],v[ua+5|0]=va;break N}f=y[g+1408|0];if(!f){break N}v[g+1450|0]=f;break N}if((f|0)==11){break O}break N}x[i+32>>2]=x[b+480216>>2];a=Wb(x[b+484344>>2],z[i+70>>1]);f=x[a+16>>2];if(BT(f,x[a+20>>2])){x[i+32>>2]=f}f=AT(b,i);a=D(f,q);C[t+24>>3]=C[t+24>>3]+ +(a>>>0)/+A[b+24620>>2];x[i>>2]=a+x[i>>2];W:{X:{Y:{if(na){break Y}m=0;_=(l|0)!=0&(f|0)!=(l|0);while(1){if(z[b+480188>>1]<=m>>>0){break Y}G=Se(x[t+8>>2],m);Z:{if(x[G>>2]==-1){break Z}r=i+D(m,872)|0;H=r+1404|0;T=x[r+1316>>2];if(!T){if(AB(H)){break Z}}u=r+1409|0;k=y[u|0];e=Ll(y[H+2|0],y[H+3|0]);if(y[r+1405|0]){x[r+1276>>2]=0}g=r+616|0;a=k&15;n=0;_:{if(!Tc(y[H|0])){break _}if(e&y[G+4|0]!=0){yB(h+24|0,b,g,T,0);n=x[h+28>>2];x[r+624>>2]=x[h+24>>2];x[r+628>>2]=n}v[r+1418|0]=y[r+1415|0];T=r+1308|0;ea=x[T>>2];n=y[r+1419|0];if(n){Ko(b,g,n,e,1,1)}n=y[H|0];x[31609]=0;ga(609,b|0,g|0,n|0,e|0,1,0,65535);n=x[31609];x[31609]=0;if((n|0)==1){break X}k=k>>>4|0;zT(b,g);yT(x[b+480180>>2],z[b+480188>>1],i,m&65535);$=Se(x[t+8>>2],m);v[$+4|0]=1;G=y[r+1407|0];$:{if(!((y[u|0]&240)!=208|(G-19&255)>>>0>1)){n=a;if(a>>>0<q>>>0){break $}}n=(G|0)==33?k>>>0<q>>>0?k:0:0}F=x[Z>>2];if(!(!(x[b+480180>>2]&16777250)|(!n|F>>>0<2))){n=D(F-1|0,x[i+24>>2]+x[i+40>>2]|0)+n|0}if(!e){x[$>>2]=0}aa:{if((G|0)==9){break aa}ba:{if((G|0)!=19){if((G|0)!=20|(k|0)!=8){break ba}break aa}if((k|0)==8){break aa}}if(y[r+1406|0]!=2){break _}}x[T>>2]=ea}ca:{if(!Tc(y[H|0])){Jb(h+24|0,I,114);if(!Gb(x[x[h+24>>2]>>2],x[h+28>>2])){break ca}}da:{ea:{fa:{ga:{e=y[r+1407|0];switch(e-42|0){case 1:break da;case 0:break ea;case 2:break fa;default:break ga}}if((e|0)!=10){break da}e=z[i+70>>1];k=x[i+48>>2];x[31609]=0;aa(610,b|0,g|0,m&65535,k|0,e|0);e=x[31609];x[31609]=0;if((e|0)!=1){break ca}break W}k=Iua(y[u|0],0,x[r+692>>2],0);e=hb;G=e>>>8|0;Jo(b,g,Bc((e&255)<<24|k>>>8,G));break ca}if(!x[r+720>>2]){break da}x[31609]=0;V(611,t|0,m&65535,l|0,-1);e=x[31609];x[31609]=0;if((e|0)==1){break W}wT(g,y[u|0]);n=x[i+40>>2]-1|0;break ca}if(y[r+1406|0]!=15){break ca}k=x[r+720>>2];if(!k){break ca}e=y[r+1408|0];if(e>>>0>9){break ca}ha:{if(!e){e=x[r+1280>>2];break ha}e=x[yb(k+68|0,e-1|0)>>2];x[r+1280>>2]=e}Jo(b,g,e)}ia:{ja:{ka:{switch(y[H|0]-253|0){case 0:if(z[b+480192>>1]){break ja}break;case 1:case 2:break ja;default:break ka}}e=y[r+1407|0];if(!((y[u|0]&240)!=192|(e-19&255)>>>0>1)&a>>>0<q>>>0){break ja}G=e&255;if((G|0)==25){break ja}k=0;if(!((G|0)==33&(a|0)!=0&q>>>0>a+n>>>0)){break ia}}e=y[r+1407|0];k=1}G=r+1304|0;la:{ma:{na:{a=e&255;if((a|0)!=46){if((a|0)!=13){break na}F=y[u|0]<<2;break ma}F=y[u|0];break ma}if(y[r+1406|0]!=1){break la}F=y[r+1408|0]<<2}x[G>>2]=F}G=r+1407|0;oa:{pa:{qa:{if(k|(!x[r+720>>2]|a>>>0>46)){break qa}Jb(h+24|0,la,a);if(Gb(x[x[h+24>>2]>>2],x[h+28>>2])){break pa}e=y[G|0];if((e|0)!=19){break qa}a=y[u|0]&240;if((a|0)==16){break pa}e=19;if((a|0)==32){break pa}}if(!k){break oa}}oV(g);ua=Se(x[t+8>>2],m),va=0,x[ua>>2]=va;break Z}if(_){x[31609]=0;V(611,t|0,m&65535,l|0,-1);a=x[31609];x[31609]=0;if((a|0)==1){break W}e=y[G|0]}ra:{sa:{ta:{ua:{va:{a=e&255;if(a-6>>>0>=2){wa:{switch(a-19|0){case 1:break ua;case 0:break va;default:break wa}}if(a-35>>>0<2){break sa}if((a|0)==45){break ta}if((a|0)!=11){break ra}}if(!y[u|0]&x[b+480180>>2]==1){break ra}a=r+1467|0;e=0;while(1){if((e|0)==(q|0)){break ra}v[a|0]=!e|y[a|0]&254;Io(b,g,y[u|0]);e=e+1|0;continue}}e=y[u|0];a=e&15;if(!(a|x[b+480180>>2]&1048580)){break ra}k=r+1467|0;v[k|0]=y[k|0]|1;e=e&240;if((e|0)!=176){if((e|0)!=160){break ra}Ho(b,g,a,0);break ra}Go(b,g,a,0);break ra}xa:{ya:{za:{a=y[u|0];switch(a-158|0){case 1:break ya;case 0:break za;default:break xa}}x[31609]=0;V(611,t|0,m&65535,l|0,-1);a=x[31609];x[31609]=0;if((a|0)==1){break W}x[r+704>>2]=x[r+704>>2]&-129;break ra}x[31609]=0;V(611,t|0,m&65535,l|0,-1);a=x[31609];x[31609]=0;if((a|0)==1){break W}a=x[r+704>>2];x[r+704>>2]=a|128;if(x[g+4>>2]){break ra}e=x[r+692>>2];if(!e){break ra}if(!(ua=Tc(y[H|0]),va=1,xa=a&2,xa?ua:va)){break ra}x[g>>2]=-1;x[g+4>>2]=e-1;break ra}if((a&240)!=112|a>>>0<115){break ra}lV(g,a,x[b+480180>>2]);break ra}vT(g,y[u|0]);break ra}x[31609]=0;a=m&65535;V(611,t|0,a|0,l|0,-1);e=x[31609];x[31609]=0;if((e|0)==1){break W}ua=r+1390|0,va=uT(b,z[i+70>>1],x[i+48>>2],a),w[ua>>1]=va}k=r+1467|0;a=y[k|0]|1;v[k|0]=a;Aa:{Ba:{Ca:{Da:{Ea:{u=r+1406|0;switch(y[u|0]-3|0){case 11:break Ba;case 0:case 1:break Ca;case 3:break Da;case 2:break Ea;default:break Aa}}a=y[r+1408|0];Jb(h+24|0,I,41);Ho(b,g,a,Gb(x[x[h+24>>2]>>2],x[h+28>>2]));break Aa}a=y[r+1408|0];Jb(h+24|0,I,41);Go(b,g,a,Gb(x[x[h+24>>2]>>2],x[h+28>>2]));break Aa}e=y[r+1408|0];Fa:{if(e){break Fa}Jb(h+24|0,I,41);e=0;if(!Gb(x[x[h+24>>2]>>2],x[h+28>>2])){break Fa}e=y[r+1450|0];if(!e){break Aa}}a=0;e=(y[u|0]==3?e<<4:e)&255;while(1){if((a|0)==(q|0)){break Aa}v[k|0]=!a|y[k|0]&254;Io(b,g,e);a=a+1|0;continue}}e=y[r+1408|0];if(e>>>0>1){break Aa}v[k|0]=(a&247|e<<3)^8}if(y[k|0]&8){break Z}a=1;Ga:{Ha:{Ia:{e=y[H+3|0];if(e>>>0>28){break Ia}g=1<<e;if(g&92){break Ga}if(!(g&268959744)){break Ia}if((y[H+5|0]-16&255)>>>0<32){break Ga}break Ha}if(e-38>>>0<4){break Ga}}a=(y[H+2|0]-11&255)>>>0<3}if(a){e=Se(x[t+8>>2],m);a=x[e>>2];x[e>>2]=a+q;x[31609]=0;V(611,t|0,m&65535,f|0,a+n|0);a=x[31609];x[31609]=0;if((a|0)!=1){break Z}a=N()|0;break l}a=Se(x[t+8>>2],m);x[a>>2]=x[a>>2]+(q-n|0)}m=m+1|0;continue}}a=tT(b,i,K,0);l=f;continue t}a=N()|0;break l}a=N()|0;break l}f=y[g+1408|0];if(!f){break N}n=h+24|0;xB(n,b,y[k+3|0],f,0);w[g+1384>>1]=z[h+24>>1];if(y[_e(n)|0]){break M}}Ja:{Ka:{La:{Ma:{Na:{switch(u-12|0){case 0:sT(b,i,m&65535);break Ja;case 2:f=rT(b,i,m&65535,e);if((f|0)==-1){break Ja}x[i+60>>2]=f;break Ja;case 5:Jb(h+24|0,I,5);if(Gb(x[x[h+24>>2]>>2],x[h+28>>2])){break Ja}k=D(Fo(b,z[i+70>>1],x[i+48>>2],m&65535,0),1e4);x[h+56>>2]=k;Oa:{if(!Y|!(x[b+480180>>2]&16777250)){break Oa}if(k>>>0>=1e4){v[g+1451|0]=(k>>>0)/1e4;break Oa}k=D(y[g+1451|0],1e4);x[h+56>>2]=k}f=x[b+8>>2];if(k>>>0>=32e4){x[h+24>>2]=D(x[f+24>>2],1e4);ua=ca,va=x[Hb(h+56|0,h+24|0)>>2],x[ua>>2]=va;break Ja}n=x[ca>>2];H=(k>>>0)/1e4|0;F=D(T,H&15);k=n-F|0;x[ca>>2]=(H&48)==16?n+F|0:k>>>0<=n>>>0?k:0;n=x[f+20>>2];f=x[f+24>>2];Jb(h+24|0,I,8);Ep(ca,D(n,1e4),Gb(x[x[h+24>>2]>>2],x[h+28>>2])?255e4:D(f,1e4));break Ja;case 8:Pa:{switch(e-144>>>4|0){case 0:if(e>>>0>145){break Ja}x[g+704>>2]=x[g+704>>2]&-257|((e|0)==145)<<8;break Ja;case 1:v[g+1452|0]=e&15;break Ja;case 2:break Ma;case 6:break Pa;default:break Ja}}v[g+1460|0]=e&15;break Ja;case 1:case 3:case 4:case 6:break Ja;case 7:break Na;default:break Ka}}f=e&240;if((f|0)==240){break La}if((f|0)!=96){break Ja}}wB(b,i,m&65535,e&15);break Ja}v[g+1460|0]=e&15;break Ja}if((u|0)!=28|(e&240)!=160){break Ja}Jb(h+24|0,I,58);if(Gb(x[x[h+24>>2]>>2],x[h+28>>2])){break Ja}v[g+1452|0]=e&15}if(!Y){break L}Qa:{Ra:{Sa:{Ta:{Ua:{Va:{Wa:{Xa:{Ya:{switch(u-2|0){case 0:if(!e){break Qa}Jb(h+24|0,I,90);if(!Gb(x[x[h+24>>2]>>2],x[h+28>>2])){v[g+1428|0]=e}v[g+1427|0]=e;break M;case 1:if(!e){break Qa}Jb(h+24|0,I,90);if(!Gb(x[x[h+24>>2]>>2],x[h+28>>2])){v[g+1427|0]=e}v[g+1428|0]=e;break M;case 2:if(!e){break Qa}w[g+1384>>1]=e;break M;case 8:if(!e){break Qa}x[g+1280>>2]=e<<8;break M;case 4:case 9:if(!e){break Qa}v[g+1425|0]=e;break M;case 11:ua=Se(x[t+8>>2],m),va=e,v[ua+5|0]=va;break M;case 44:ua=Se(x[t+8>>2],m),va=e+3>>>2|0,v[ua+5|0]=va;break M;case 21:f=x[b+480180>>2];e=e<<(!(f&59593760)&e<<24>>24>=0);n=e&255;if(n>>>0<=128){x[R>>2]=n<<1;break M}if(f&16777250){break M}x[R>>2]=256;break M;case 22:Jb(h+24|0,I,9);Za:{if(Gb(x[x[h+24>>2]>>2],x[h+28>>2])){f=g+1433|0;if(e){v[f|0]=e;break Za}e=y[f|0];break Za}if(e){v[i+1433|0]=e;break Za}e=y[i+1433|0]}f=e&15;n=e&255;_a:{if(!((f|0)!=15|n>>>0<16)){e=(e&240)>>>4<<!(x[b+480180>>2]&59593760);f=x[R>>2]+(e<<1)|0;break _a}n=n&240;if(!(!f|(n|0)!=240)){e=f<<(x[b+480180>>2]&59593760?1:2);f=x[R>>2]-e|0;break _a}if(n){e=(e>>>3&30)<<!(x[b+480180>>2]&59593760);f=x[R>>2]+D(a,e)|0;break _a}e=e<<(x[b+480180>>2]&59593760?1:2);f=x[R>>2]-D(a,e&255)|0}x[R>>2]=f;He(R,0,256);break M;case 19:if(e>>>0>64){break M}x[g+1364>>2]=e;break M;case 20:f=g+1432|0;$a:{if(e){v[f|0]=e;break $a}e=y[f|0]}u=g+1364|0;f=x[u>>2];n=e&15;k=e&255;ab:{if(!((n|0)!=15|k>>>0<16)){x[h+24>>2]=f+(k>>>4|0);break ab}if(!(!n|(k&240)!=240)){x[h+24>>2]=f-n;break ab}if(n){x[h+24>>2]=f-D(a,n);break ab}x[h+24>>2]=f+D(a,k>>>4|0)}He(h+24|0,0,64);x[u>>2]=x[h+24>>2];break M;case 7:_m(b,r,e,8);break M;case 29:case 30:break Ra;case 25:break Sa;case 6:break Ta;case 24:break Ua;case 3:break Va;case 5:break Wa;case 18:break Xa;case 17:break Ya;default:break M}}if(e>>>0>15){break Xa}f=(e&1)<<14;n=z[b+480188>>1];k=0;while(1){if((k|0)==(n|0)){break Xa}u=i+D(k,872)|0;x[u+704>>2]=(f|x[u+704>>2]&-16385)^16384;k=k+1|0;continue}}if((e&240)!=128){break M}_m(b,r,e&15,4);break M}if(e){v[g+1425|0]=e}e=0}Il(r,e);break M}qT(b,r,e);break M}pT(r,e);break M}oT(r,e);break M}bb:{if(e<<24>>24>=0){f=Pe(ra,y[g+1460|0]);break bb}f=Pe(sa,e&127)}n=y[ea|0];x[31609]=0;ja(612,b|0,i|0,m&65535,0,f|0,n|0);f=x[31609];x[31609]=0;if((f|0)!=1){break M}a=N()|0;break l}e=0}cb:{db:{switch(y[g+1406|0]-2|0){case 0:_m(b,r,y[g+1408|0],6);break cb;case 5:Jb(h+24|0,I,53);f=y[g+1408|0];if(Gb(x[x[h+24>>2]>>2],x[h+28>>2])){v[g+1439|0]=f&15;break cb}Il(r,f<<4);break cb;case 6:break db;default:break cb}}Il(r,y[g+1408|0])}eb:{fb:{gb:{hb:{ib:{f=y[$|0];switch(f-5|0){case 1:break eb;case 3:break gb;case 0:case 2:break hb;default:break ib}}switch(f-26|0){case 1:break fb;case 0:break hb;default:break eb}}jb:{if(x[b+480180>>2]&16777248){f=q;if(!(y[b+480208|0]&4)){break jb}}f=a}n=y[g+1439|0];Jb(h+24|0,I,21);g=g+1435|0;k=y[g|0];f=D(f,n);ua=g,va=(Gb(x[x[h+24>>2]>>2],x[h+28>>2])?f<<2:f)+k|0,v[ua|0]=va;break eb}kb:{if(x[b+480180>>2]&16777248){f=q;if(!(y[b+480208|0]&4)){break kb}}f=a}n=y[g+1442|0];Jb(h+24|0,I,21);g=g+1436|0;k=y[g|0];f=D(f,n);ua=g,va=(Gb(x[x[h+24>>2]>>2],x[h+28>>2])?f<<2:f)+k|0,v[ua|0]=va;break eb}f=g+1437|0;v[f|0]=y[f|0]+D(_,y[g+1445|0]);mT(b,r)}Jb(h+24|0,I,78);if(!Gb(x[x[h+24>>2]>>2],x[h+28>>2])){break L}f=e&255;if(!f){break L}lT(r,f)}m=m+1|0;continue}}break}break}a=N()|0;break l}a=N()|0;break l}a=N()|0;break l}a=N()|0;break l}a=N()|0;break l}g=1;break m}g=0}lb:{if((ba|0)!=7){break lb}a=0;while(1){if(z[b+480188>>1]<=a>>>0){break lb}mb:{if(x[Se(x[t+8>>2],a)>>2]==-1){break mb}x[31609]=0;V(611,t|0,a&65535,l|0,-1);d=x[31609];x[31609]=0;if((d|0)!=1){break mb}a=N()|0;break l}a=a+1|0;continue}}if(y[s+26|0]){w[s+20>>1]=z[i+72>>1];x[s+8>>2]=x[i+48>>2]}C[s>>3]=C[t+24>>3];x[31609]=0;O(606,X|0,s|0);a=x[31609];x[31609]=0;nb:{ob:{pb:{qb:{if((a|0)!=1){if(!Y){break a}if(!(g?y[s+26|0]:1)){break pb}q=iB(h+56|0);if(Id(y[ia+24|0])){$S(q,ia)}uB(ia);a=zc(b+1074376|0,i,614);l=0;while(1){if((l|0)==256){An(a+223848|0,i+223848|0);d=a+223860|0;f=y[d+24|0];l=i+223860|0;rb:{if((Id(y[l+24|0])|0)==(f|0)){if(!f){break rb}f=gc(d);Mu(d,x[f>>2]);x[d>>2]=x[l>>2];x[d+4>>2]=x[l+4>>2];x[d+8>>2]=x[l+8>>2];sb:{if(!x[Ab(d)>>2]){x[d>>2]=f;break sb}x[x[f>>2]+8>>2]=f;f=gc(l);x[l>>2]=f;x[f>>2]=0;ua=Ab(l),va=0,x[ua>>2]=va}d=d+12|0;f=gc(d);Lu(d,x[f>>2]);l=l+12|0;x[d>>2]=x[l>>2];x[d+4>>2]=x[l+4>>2];x[d+8>>2]=x[l+8>>2];tb:{if(!x[Ab(d)>>2]){x[d>>2]=f;break tb}x[x[f>>2]+8>>2]=f;d=gc(l);x[l>>2]=d;x[d>>2]=0;ua=Ab(l),va=0,x[ua>>2]=va}break rb}if(f){uB(d);break rb}$S(d,l)}}else{d=D(l,872);Fq((d+a|0)+616|0,(d+i|0)+616|0);l=l+1|0;continue}break}tB(a);x[b+1074400>>2]=0;v[b+1074476|0]=1;a=b+1074392|0;x[a>>2]=-2;x[a+4>>2]=0;x[b+1074428>>2]=x[b+1074424>>2];a=x[b+1298300>>2];if(!Gj(a)){break qb}break ob}a=N()|0;break l}x[31609]=0;W(613,a|0);a=x[31609];x[31609]=0;if((a|0)!=1){break ob}break nb}if((c|0)==3){break b}x[b+1074416>>2]=x[b+480196>>2];x[b+1074420>>2]=x[b+480204>>2];x[b+1074456>>2]=x[b+480200>>2];break b}f=(ba|0)==7;a=0;while(1){if(z[b+480188>>1]<=a>>>0){d=IC(h+24|0);a=Vi(x[q+12>>2]);x[h+20>>2]=a;f=b+906300|0;n=Pf(q+12|0);while(1){if(!Zg(a,n)){ub:{a=250;l=d;vb:{while(1){if(a>>>0>=32){if(x[l>>2]){a=1;break vb}else{a=a-32|0;l=l+4|0;continue}}break}a=(x[d+28>>2]&67108863)!=0}if(!a){break ub}a=0;while(1){if((a|0)==250){break ub}Jb(h+12|0,d,a);wb:{if(!Gb(x[x[h+12>>2]>>2],x[h+16>>2])){break wb}l=x[$d(f,a)>>2];e=x[x[l>>2]+180>>2];x[31609]=0;W(e|0,l|0);l=x[31609];x[31609]=0;if((l|0)!=1){break wb}break nb}a=a+1|0;continue}}a=Vi(x[q>>2]);x[h+12>>2]=a;d=Pf(q);while(1)if(Zg(a,d)){a=ud(a);l=gc(a);ua=$d(f,y[a|0]),ya=B[l>>2],B[ua+144>>2]=ya;a=x[ah(h+12|0)>>2];continue}else{Gq(q);break b}}l=ud(a);g=Ab(l);xb:{e=y[l|0];a=x[$d(f,e)>>2];if(a){Jb(h+12|0,d,e);if(!Gb(x[x[h+12>>2]>>2],x[h+16>>2])){x[31609]=0;P(614,d|0,e|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break xb}e=x[x[a>>2]+176>>2];x[31609]=0;O(e|0,a|0,-1);e=x[31609];x[31609]=0;if((e|0)==1){break xb}}ta=B[g>>2];l=x[l+4>>2];e=x[x[a>>2]+44>>2];x[31609]=0;wa(e|0,a|0,l|0,E(ta));a=x[31609];x[31609]=0;if((a|0)==1){break xb}}a=x[ah(h+20|0)>>2];continue}break}break nb}d=D(a,872)+b|0;l=y[d+1075791|0];if(l){v[d+1075794|0]=l}l=Se(x[t+8>>2],a);if(!(y[l+5|0]==255|f)){v[h+24|0]=64;ua=d+1075680|0,va=y[Qb(l+5|0,h+24|0)|0]<<2,x[ua>>2]=va}yb:{zb:{if(x[d+1075080>>2]&67109888){break zb}l=x[d+1075096>>2];if(!l|!(y[l+35|0]&2)){break zb}e=x[b+1298300>>2];if(!Ed(e)){break zb}x[31609]=0;k=e;e=a&65535;S(615,k|0,e|0,l+68|0);l=x[31609];x[31609]=0;if((l|0)==1){break yb}l=x[b+1298300>>2];x[31609]=0;S(616,l|0,e|0,1);l=x[31609];x[31609]=0;if((l|0)==1){break yb}}x[d+1075008>>2]=0;a=a+1|0;continue}break}}a=N()|0;Gq(q)}Ru(J)}kT(t)}Si(X);Q(a|0);p()}a=ka&255;if((a|0)==y[b+484376|0]){break a}Wj(pa,a)}if(c&9){a=b+1298264|0;if(x[a>>2]){fU(a);b=x[a>>2];dl(a);Db(b);ua=Ab(a),va=0,x[ua>>2]=va;x[a>>2]=0;x[a+4>>2]=0}x[a>>2]=x[J>>2];x[a+4>>2]=x[J+4>>2];b=Ab(J);ua=Ab(a),va=x[b>>2],x[ua>>2]=va;x[b>>2]=0;x[J>>2]=0;x[J+4>>2]=0;a=a+12|0;c=gc(a);Lq(a,x[c>>2]);b=J+12|0;x[a>>2]=x[b>>2];x[a+4>>2]=x[b+4>>2];x[a+8>>2]=x[b+8>>2];Ab:{if(!x[Ab(a)>>2]){x[a>>2]=c;break Ab}x[x[c>>2]+8>>2]=c;a=gc(b);x[b>>2]=a;x[a>>2]=0;ua=Ab(b),va=0,x[ua>>2]=va}}Ru(J);kT(t);fb=h+192|0}function tY(a,b,c,d,e,f){var g=0,h=0,i=0,j=0,k=0,l=0,m=E(0),n=0,o=0,q=0,r=0,s=0,t=0,u=E(0),C=E(0),F=0,G=0,H=E(0),I=E(0),J=0,K=0,L=E(0),M=E(0),N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=E(0),X=E(0),Y=0,Z=0,$=0,aa=0,ba=E(0),ca=E(0),da=E(0),ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;aa=fb-16|0;fb=aa;a:{if(x[a+1420>>2]>=0){x[f>>2]=0;P=x[a+1420>>2];d=(P|0)>0?P:0;while(1){if((d|0)!=(h|0)){x[(D(h,20)+a|0)+1436>>2]=0;h=h+1|0;continue}break}b:{c:{d:{if((P|0)>3){break d}h=0;if((c|0)<4){break c}c=c-3|0;d=0;while(1){if((c|0)==(d|0)){break d}e:{f:{e=b+d|0;if(y[e|0]!=79|(y[e|0]|y[e+1|0]<<8|(y[e+2|0]<<16|y[e+3|0]<<24))!=(y[125468]|y[125469]<<8|(y[125470]<<16|y[125471]<<24))){break f}l=d+26|0;if((l|0)>=(c|0)){break e}g=d+27|0;n=b+l|0;f=y[n|0];if((g+f|0)>=(c|0)){break e}i=b+g|0;k=f+27|0;h=0;while(1)if((f|0)==(h|0)){h=0;g=0;while(1){f=22;if((h|0)!=22){g=gz(g,y[e+h|0]);h=h+1|0;continue}break}while(1){if((f|0)!=26){f=f+1|0;g=gz(g,0);continue}break}x[a+1420>>2]=P+1;f=D(P,20)+a|0;x[f+1432>>2]=g;x[f+1428>>2]=k-26;x[f+1424>>2]=y[e+22|0]|y[e+23|0]<<8|(y[e+24|0]<<16|y[e+25|0]<<24);g=-1;if(y[(i+y[n|0]|0)-1|0]!=255){g=y[e+6|0]|y[e+7|0]<<8|(y[e+8|0]<<16|y[e+9|0]<<24)}x[f+1436>>2]=l;x[f+1440>>2]=g;P=x[a+1420>>2];if((P|0)!=4){break f}P=4;break d}else{k=y[h+i|0]+k|0;h=h+1|0;continue}}d=d+1|0;continue}break}c=d}d=0;g:while(1){n=(d|0)>(P|0)?d:P;while(1){if((d|0)==(n|0)){break b}h=0;e=D(d,20)+a|0;j=e+1428|0;f=x[j>>2];k=x[e+1436>>2];i=c-k|0;l=(f|0)<(i|0)?f:i;o=(l|0)>0?l:0;s=b+k|0;Z=e+1432|0;g=x[Z>>2];while(1){if((h|0)!=(o|0)){g=gz(g,y[h+s|0]);h=h+1|0;continue}break}x[j>>2]=f-l;x[Z>>2]=g;if((f|0)<=(i|0)){e=e+1424|0;if(x[e>>2]==(g|0)){x[a+1380>>2]=-1;x[a+992>>2]=0;x[a+1420>>2]=-1;b=x[(D(d,20)+a|0)+1440>>2];x[a+1060>>2]=b;x[a+1064>>2]=(b|0)!=-1;h=k+l|0;break c}f=P-1|0;x[a+1420>>2]=f;f=D(f,20)+a|0;x[e+16>>2]=x[f+1440>>2];g=f+1432|0;h=x[g+4>>2];x[e+8>>2]=x[g>>2];x[e+12>>2]=h;f=f+1424|0;g=x[f+4>>2];x[e>>2]=x[f>>2];x[e+4>>2]=g;P=x[a+1420>>2];continue g}else{d=d+1|0;continue}}}}c=h}break a}x[a+100>>2]=0;x[a+32>>2]=b;x[a+40>>2]=b+c;if(!UL(a)){x[f>>2]=0;c=0;break a}ga=fb-16|0;fb=ga;ja=aa+4|0;x[a+1504>>2]=0;x[a+1508>>2]=0;h:{if(x[a+96>>2]){break h}i:{j:{k:{if(x[a+1380>>2]!=-1){break k}c=ff(a);if(x[a+96>>2]){break i}if((c|0)!=79){break j}if((ff(a)|0)!=103){break j}if((ff(a)|0)!=103){break j}if((ff(a)|0)!=83){break j}if(!SL(a)){break i}if(!(v[a+1375|0]&1)){break k}v[a+1376|0]=0;x[a+1384>>2]=0;fc(a,32);break i}h=dz(a);break i}fc(a,30)}if(!h){break h}if(sc(a,1)){fc(a,35);break h}l:{m:{if(!(x[a+84>>2]!=x[a+92>>2]?x[a+80>>2]:0)){c=sc(a,Km(x[a+408>>2]-1|0));if((c|0)==-1|(c|0)>=x[a+408>>2]){break h}x[ga+12>>2]=c;l=D(c,6)+a|0;if(!y[l+412|0]){g=x[a+112>>2];h=g>>1;break m}g=x[a+116>>2];h=g>>1;c=sc(a,1);k=(sc(a,1)|0)!=0;if(c|!y[l+412|0]){break m}x[ja>>2]=g-x[a+112>>2]>>2;c=x[a+112>>2]+g>>2;break l}_(6325,13274,3152,10779);p()}x[ja>>2]=0;c=h}x[ga+8>>2]=c;n:{if(!(!y[l+412|0]|k)){c=D(g,3);x[aa+8>>2]=c-x[a+112>>2]>>2;g=c+x[a+112>>2]>>2;break n}x[aa+8>>2]=h}x[ga+4>>2]=g;g=1}if(g){Z=x[ja>>2];ma=x[aa+8>>2];ka=x[ga+4>>2];Q=fb-2368|0;fb=Q;F=x[a+404>>2];pa=D(x[ga+12>>2],6)+a|0;r=y[pa+413|0];S=F+D(r,40)|0;T=x[((y[pa+412|0]<<2)+a|0)+104>>2];ea=T>>1;ra=0-ea|0;o:{while(1){c=x[a+4>>2];if((c|0)>(q|0)){c=y[(x[S+4>>2]+D(q,3)|0)+2|0];g=q<<2;t=g+(Q+1344|0)|0;x[t>>2]=0;h=y[(c+S|0)+9|0];if(z[((h<<1)+a|0)+132>>1]){l=x[a+260>>2];p:{q:{if(!sc(a,1)){break q}c=2;k=x[(a+g|0)+996>>2];l=l+D(h,1596)|0;j=x[(y[l+1588|0]<<2)+88876>>2];g=Km(j)-1|0;sa=k,ta=sc(a,g),w[sa>>1]=ta;sa=k,ta=sc(a,g),w[sa+2>>1]=ta;i=0;while(1){if(y[l|0]>i>>>0){O=y[(i+l|0)+1|0];g=O+l|0;s=y[g+49|0];n=-1<<s;o=y[g+33|0];r:{if(!s){h=0;break r}g=x[a+124>>2]+D(y[g+65|0],2096)|0;if(x[a+1396>>2]<=9){wl(a)}h=x[a+1392>>2];J=w[(g+((h&1023)<<1)|0)+36>>1];s:{if((J|0)>=0){G=h;J=J&65535;h=y[J+x[g+8>>2]|0];x[a+1392>>2]=G>>>h;h=x[a+1396>>2]-h|0;x[a+1396>>2]=(h|0)>0?h:0;h=(h|0)<0?-1:J;break s}h=Jm(a,g)}if(!y[g+23|0]){break r}h=x[x[g+2088>>2]+(h<<2)>>2]}J=n^-1;g=c+o|0;while(1){if((c|0)!=(g|0)){o=0;n=w[((l+(O<<4)|0)+((h&J)<<1)|0)+82>>1];t:{if((n|0)<0){break t}n=x[a+124>>2]+D(n&65535,2096)|0;if(x[a+1396>>2]<=9){wl(a)}o=x[a+1392>>2];R=w[(n+((o&1023)<<1)|0)+36>>1];u:{if((R|0)>=0){G=o;R=R&65535;o=y[R+x[n+8>>2]|0];x[a+1392>>2]=G>>>o;o=x[a+1396>>2]-o|0;x[a+1396>>2]=(o|0)>0?o:0;o=(o|0)<0?-1:R;break u}o=Jm(a,n)}if(!y[n+23|0]){break t}o=x[x[n+2088>>2]+(o<<2)>>2]}h=h>>s;w[k+(c<<1)>>1]=o;c=c+1|0;continue}break}i=i+1|0;c=g;continue}break}if(x[a+1396>>2]==-1){break q}w[Q+320>>1]=257;c=2;g=l+338|0;while(1){o=x[l+1592>>2];if((o|0)<=(c|0)){c=0;while(1){if((c|0)>=(o|0)){break p}if(!y[(Q+320|0)+c|0]){w[k+(c<<1)>>1]=65535;o=x[l+1592>>2]}c=c+1|0;continue}}else{h=c<<1;n=h+l|0;s=y[n+1088|0];o=s<<1;i=z[o+g>>1];t=y[n+1089|0];O=t<<1;J=w[k+o>>1];n=w[O+k>>1]-J|0;o=n>>31;i=(D((o^n)-o|0,z[g+h>>1]-i|0)|0)/(z[g+O>>1]-i|0)|0;o=J+((n|0)<0?0-i|0:i)|0;O=h+k|0;i=z[O>>1];v:{w:{if(i){h=Q+320|0;v[h+t|0]=1;v[h+s|0]=1;v[c+h|0]=1;h=i<<16>>16;n=j-o|0;if((h|0)>=((o|0)>(n|0)?n:o)<<1){if((o|0)<(n|0)){break v}o=j+(i^-1)|0;break w}if(h&1){o=o-(h+1>>>1|0)|0;break w}o=(h>>1)+o|0;break w}v[(Q+320|0)+c|0]=0}w[O>>1]=o}c=c+1|0;continue}}}x[t>>2]=1}q=q+1|0;continue}else{fc(a,21);c=0;break o}}break}if(!(x[a+84>>2]!=x[a+92>>2]?x[a+80>>2]:0)){zc(Q+320|0,Q+1344|0,c<<2);h=z[S>>1];c=0;while(1){if((c|0)==(h|0)){N=F+D(r,40)|0}else{l=x[S+4>>2]+D(c,3)|0;g=y[l+1|0];i=y[l|0]<<2;o=Q+1344|0;l=o;k=i+l|0;g=g<<2;if(!(x[l+g>>2]?x[k>>2]:0)){x[g+l>>2]=0;x[k>>2]=0}c=c+1|0;continue}break}h=0;while(1){x:{if(y[N+8|0]>h>>>0){o=0;c=x[a+4>>2];k=(c|0)>0?c:0;c=0;while(1){if((c|0)==(k|0)){break x}if(y[(x[S+4>>2]+D(c,3)|0)+2|0]==(h|0)){i=o+Q|0;l=c<<2;y:{if(x[l+(Q+1344|0)>>2]){l=0;g=1;break y}l=x[(a+l|0)+800>>2];g=0}v[i|0]=g;x[(Q+256|0)+(o<<2)>>2]=l;o=o+1|0}c=c+1|0;continue}}if(!(x[a+84>>2]!=x[a+92>>2]?x[a+80>>2]:0)){l=(ea|0)>0?ea:0;g=z[S>>1];h=a+800|0;z:while(1){if((g|0)<=0){O=ea<<2;o=0;c=0;while(1){h=x[a+4>>2];if((h|0)<=(c|0)){while(1){if((h|0)>(o|0)){O=y[pa+412|0];S=T>>1;g=S<<2;la=x[a+92>>2];q=T>>3;R=T>>2;k=x[((o<<2)+a|0)+800>>2];c=S<<2;t=k+c|0;A:{if(x[a+80>>2]){l=no(a,g);break A}l=Gd(g)}c=(l+c|0)-8|0;s=x[((O<<2)+a|0)+1068>>2];j=s;h=k;while(1){if((h|0)!=(t|0)){B[c+4>>2]=E(B[h>>2]*B[j>>2])-E(B[j+4>>2]*B[h+8>>2]);B[c>>2]=E(B[h>>2]*B[j+4>>2])+E(B[h+8>>2]*B[j>>2]);h=h+16|0;j=j+8|0;c=c-8|0;continue}break}h=t-12|0;while(1){if(c>>>0>=l>>>0){B[c+4>>2]=E(B[h>>2]*B[j+4>>2])-E(B[h+8>>2]*B[j>>2]);B[c>>2]=E(E(-B[h+8>>2])*B[j+4>>2])-E(B[j>>2]*B[h>>2]);h=h-16|0;j=j+8|0;c=c-8|0;continue}break}c=R<<2;h=c+k|0;j=c+l|0;g=s+(S<<2)|0;c=l;i=k;while(1){n=g-32|0;if(n>>>0>=s>>>0){m=B[c>>2];u=B[j>>2];C=B[j+4>>2];H=B[c+4>>2];B[h+4>>2]=C+H;B[h>>2]=B[j>>2]+B[c>>2];C=E(C-H);r=g-16|0;F=g-12|0;m=E(u-m);B[i+4>>2]=E(C*B[r>>2])-E(B[F>>2]*m);B[i>>2]=E(m*B[r>>2])+E(C*B[F>>2]);m=B[c+8>>2];u=B[j+8>>2];C=B[j+12>>2];H=B[c+12>>2];B[h+12>>2]=C+H;B[h+8>>2]=B[j+8>>2]+B[c+8>>2];C=E(C-H);g=g-28|0;m=E(u-m);B[i+12>>2]=E(C*B[n>>2])-E(B[g>>2]*m);B[i+8>>2]=E(m*B[n>>2])+E(C*B[g>>2]);c=c+16|0;j=j+16|0;i=i+16|0;h=h+16|0;g=n;continue}break}h=Km(T);c=T>>4;g=S-1|0;i=0-q|0;OL(c,k,g,i,s);OL(c,k,g-R|0,i,s);J=T>>5;c=0-c|0;gq(J,k,g,c,s,16);gq(J,k,g-q|0,c,s,16);gq(J,k,g-(q<<1)|0,c,s,16);gq(J,k,g+D(q,-3)|0,c,s,16);c=h-4>>1;q=(c|0)<=2?2:c;c=2;while(1){B:{C:{D:{if((c|0)==(q|0)){na=h-7|0;break D}j=0;i=2<<c;i=(i|0)>0?i:0;n=8<<c;r=T>>c+4;F=T>>c+2;Y=0-(F>>1)|0;while(1){if((i|0)==(j|0)){break C}gq(r,k,g-D(j,F)|0,Y,s,n);j=j+1|0;continue}}while(1){E:{if((q|0)<(na|0)){n=2<<q;Y=8<<q;j=T>>q+6;U=T>>q+2;fa=0-(U>>1)|0;V=32<<q<<2;c=g;h=s;while(1){if((j|0)<=0){break E}i=n;r=(c<<2)+k|0;F=r+(fa<<2)|0;$=D(Y,12)+h|0;m=B[$>>2];N=(Y<<3)+h|0;u=B[N>>2];G=(Y<<2)+h|0;C=B[G>>2];H=B[$+4>>2];L=B[N+4>>2];W=B[G+4>>2];X=B[h+4>>2];da=B[h>>2];$=0-U<<2;while(1){if((i|0)>0){N=F-4|0;M=B[N>>2];ba=B[r>>2];ca=B[F>>2];B[r>>2]=ba+ca;G=r-4|0;I=B[G>>2];B[G>>2]=I+B[N>>2];I=E(I-M);M=E(ba-ca);B[N>>2]=E(I*da)+E(X*M);B[F>>2]=E(M*da)-E(X*I);N=F-12|0;ba=B[N>>2];G=r-8|0;I=B[G>>2];K=G;G=F-8|0;ca=B[G>>2];B[K>>2]=I+ca;K=r-12|0;M=B[K>>2];B[K>>2]=M+B[N>>2];M=E(M-ba);I=E(I-ca);B[N>>2]=E(M*C)+E(W*I);B[G>>2]=E(I*C)-E(W*M);N=F-20|0;ba=B[N>>2];G=r-16|0;I=B[G>>2];K=G;G=F-16|0;ca=B[G>>2];B[K>>2]=I+ca;K=r-20|0;M=B[K>>2];B[K>>2]=M+B[N>>2];M=E(M-ba);I=E(I-ca);B[N>>2]=E(M*u)+E(L*I);B[G>>2]=E(I*u)-E(L*M);N=F-28|0;ba=B[N>>2];G=r-24|0;I=B[G>>2];K=G;G=F-24|0;ca=B[G>>2];B[K>>2]=I+ca;K=r-28|0;M=B[K>>2];B[K>>2]=M+B[N>>2];M=E(M-ba);I=E(I-ca);B[N>>2]=E(M*m)+E(H*I);B[G>>2]=E(I*m)-E(H*M);i=i-1|0;F=F+$|0;r=r+$|0;continue}break}j=j-1|0;c=c-8|0;h=h+V|0;continue}}c=(g<<2)+k|0;h=c-(J<<6)|0;m=B[s+(T>>3<<2)>>2];da=E(-m);while(1){if(c>>>0>h>>>0){L=B[c>>2];g=c-32|0;W=B[g>>2];B[c>>2]=L+W;i=c-4|0;u=B[i>>2];n=i;i=c-36|0;X=B[i>>2];B[n>>2]=u+X;n=c-8|0;C=B[n>>2];G=n;n=c-40|0;I=B[n>>2];B[G>>2]=C+I;j=c-12|0;H=B[j>>2];G=j;j=c-44|0;M=B[j>>2];B[G>>2]=H+M;B[g>>2]=L-W;B[i>>2]=u-X;i=c-16|0;u=B[i>>2];G=i;i=c-48|0;ba=B[i>>2];B[G>>2]=u+ba;C=E(C-I);H=E(H-M);B[n>>2]=m*E(C+H);B[j>>2]=m*E(H-C);n=c-28|0;C=B[n>>2];j=c-60|0;H=B[j>>2];s=c-24|0;L=B[s>>2];q=c-56|0;W=B[q>>2];r=c-20|0;X=B[r>>2];G=r;r=c-52|0;I=B[r>>2];B[G>>2]=X+I;B[s>>2]=L+W;B[n>>2]=C+H;B[i>>2]=X-I;B[r>>2]=-E(u-ba);u=E(C-H);C=E(L-W);B[q>>2]=m*E(u-C);B[j>>2]=E(C+u)*da;NL(c);NL(g);c=c+-64|0;continue}break}n=S-4|0;c=l+(n<<2)|0;j=(l+(R<<2)|0)-16|0;h=x[((O<<2)+a|0)+1100>>2];while(1){if(j>>>0>=l>>>0){g=(z[h>>1]<<2)+k|0;B[c+12>>2]=B[g>>2];B[c+8>>2]=B[g+4>>2];B[j+12>>2]=B[g+8>>2];B[j+8>>2]=B[g+12>>2];g=(z[h+2>>1]<<2)+k|0;B[c+4>>2]=B[g>>2];B[c>>2]=B[g+4>>2];B[j+4>>2]=B[g+8>>2];B[j>>2]=B[g+12>>2];h=h+4|0;c=c-16|0;j=j-16|0;continue}break}h=x[((O<<2)+a|0)+1084>>2];j=l;c=j+(S<<2)|0;g=c;while(1){i=g-16|0;if(i>>>0>j>>>0){m=B[j+4>>2];s=g-4|0;u=B[s>>2];C=E(m-u);H=B[h+4>>2];m=E(m+u);u=B[j>>2];q=g-8|0;L=B[q>>2];W=E(u-L);X=B[h>>2];da=E(E(H*m)-E(W*X));B[j+4>>2]=C+da;u=E(u+L);m=E(E(H*W)+E(m*X));B[j>>2]=u+m;B[s>>2]=da-C;B[q>>2]=u-m;m=B[j+8>>2];u=B[i>>2];C=E(m+u);H=B[h+12>>2];m=E(m-u);u=B[j+12>>2];g=g-12|0;L=B[g>>2];W=E(u+L);X=B[h+8>>2];da=E(E(H*m)+E(W*X));B[j+8>>2]=C+da;u=E(u-L);m=E(E(H*W)-E(m*X));B[j+12>>2]=u+m;B[i>>2]=C-da;B[g>>2]=m-u;j=j+16|0;h=h+16|0;g=i;continue}break}j=x[((O<<2)+a|0)+1076>>2]+(S<<2)|0;g=(T<<2)+k|0;h=(n<<2)+k|0;while(1){i=c-32|0;if(i>>>0>=l>>>0){m=B[c-8>>2];u=B[j-4>>2];C=B[j-8>>2];H=B[c-4>>2];L=E(E(m*u)-E(C*H));B[k>>2]=L;B[h+12>>2]=-L;m=E(E(C*E(-m))-E(u*H));B[t>>2]=m;B[g-4>>2]=m;m=B[c-16>>2];u=B[j-12>>2];C=B[j-16>>2];H=B[c-12>>2];L=E(E(m*u)-E(C*H));B[k+4>>2]=L;B[h+8>>2]=-L;m=E(E(C*E(-m))-E(u*H));B[t+4>>2]=m;B[g-8>>2]=m;m=B[c-24>>2];u=B[j-20>>2];C=B[j-24>>2];H=B[c-20>>2];L=E(E(m*u)-E(C*H));B[k+8>>2]=L;B[h+4>>2]=-L;m=E(E(C*E(-m))-E(u*H));B[t+8>>2]=m;B[g-12>>2]=m;m=B[i>>2];u=B[j-28>>2];j=j-32|0;C=B[j>>2];H=B[c-28>>2];L=E(E(m*u)-E(C*H));B[k+12>>2]=L;B[h>>2]=-L;m=E(E(C*E(-m))-E(u*H));B[t+12>>2]=m;g=g-16|0;B[g>>2]=m;h=h-16|0;t=t+16|0;k=k+16|0;c=i;continue}break}if(!x[a+80>>2]){Db(l)}x[a+92>>2]=la;break B}q=q+1|0;continue}}c=c+1|0;continue}break}o=o+1|0;h=x[a+4>>2];continue}break}}else{g=c<<2;h=g+a|0;n=x[h+800>>2];F:{if(x[g+(Q+320|0)>>2]){Rb(n,0,O);break F}t=x[h+996>>2];G:{g=y[(y[(x[S+4>>2]+D(c,3)|0)+2|0]+S|0)+9|0];if(!z[((g<<1)+a|0)+132>>1]){fc(a,21);break G}j=T>>1;s=x[a+260>>2]+D(g,1596)|0;h=D(y[s+1588|0],w[t>>1]);i=1;g=0;while(1){if(x[s+1592>>2]>(i|0)){l=y[(i+s|0)+838|0]<<1;k=w[l+t>>1];if((k|0)>=0){k=D(y[s+1588|0],k&65535);l=z[(l+s|0)+338>>1];if((l|0)!=(g|0)){q=k-h|0;r=l-g|0;F=(q|0)/(r|0)|0;H:{J=(j|0)>(l|0)?l:j;if((J|0)<=(g|0)){break H}G=q;q=q>>31;R=F>>31;R=((G^q)-q|0)-D(r,(R^F)-R|0)|0;Y=q|1;q=n+(g<<2)|0;B[q>>2]=B[((h&255)<<2)+88896>>2]*B[q>>2];J=J-1|0;q=0;while(1){if((g|0)==(J|0)){break H}g=g+1|0;$=n+(g<<2)|0;q=q+R|0;N=(q|0)<(r|0);h=(h+F|0)+(N?0:Y)|0;B[$>>2]=B[((h&255)<<2)+88896>>2]*B[$>>2];q=q-(N?0:r)|0;continue}}g=l}h=k}i=i+1|0;continue}break}if((g|0)>=(j|0)){break G}h=(h<<2)+88896|0;while(1){if((g|0)==(j|0)){break G}l=n+(g<<2)|0;B[l>>2]=B[h>>2]*B[l>>2];g=g+1|0;continue}}}c=c+1|0;continue}break}QL(a);I:{if(y[a+1377|0]){x[a+1060>>2]=ra;v[a+1377|0]=0;x[a+1064>>2]=1;x[a+1412>>2]=T-ka;break I}c=x[a+1412>>2];if(!c){break I}g=ma-Z|0;if((g|0)<=(c|0)){x[a+1412>>2]=c-g;x[ja>>2]=ma;Z=ma;break I}Z=c+Z|0;x[ja>>2]=Z;x[a+1412>>2]=0}c=x[a+1064>>2];J:{K:{L:{M:{if(x[a+1388>>2]==x[a+1404>>2]){N:{if(!c|!(y[a+1375|0]&4)){break N}c=x[a+1408>>2];g=x[a+1060>>2];if(c>>>0>=g+(ka-Z|0)>>>0){break N}g=c-g|0;c=(c>>>0>=g>>>0?g:0)+Z|0;c=(c|0)<(ka|0)?c:ka;x[aa+12>>2]=c;x[a+1060>>2]=c+x[a+1060>>2];break K}x[a+1064>>2]=1;c=x[a+1408>>2]+(Z-ea|0)|0;break M}if(!c){break L}c=x[a+1060>>2]}x[a+1060>>2]=c+(ma-Z|0)}if(x[a+84>>2]!=x[a+92>>2]?x[a+80>>2]:0){break J}x[aa+12>>2]=ka}c=1;break o}_(6325,13274,3451,5634);p()}g=g-1|0;c=x[S+4>>2]+D(g,3)|0;k=x[h+(y[c+1|0]<<2)>>2];i=x[h+(y[c|0]<<2)>>2];c=0;while(1){if((c|0)==(l|0)){continue z}n=c<<2;j=n+k|0;C=B[j>>2];n=i+n|0;m=B[n>>2];O:{if(m>E(0)){if(C>E(0)){u=E(m-C);break O}u=m;m=E(m+C);break O}if(C>E(0)){u=E(m+C);break O}u=m;m=E(m-C)}B[n>>2]=m;B[j>>2]=u;c=c+1|0;continue}}}_(6325,13274,3335,5634);p()}R=Q+256|0;F=fb-16|0;fb=F;j=x[a+4>>2];r=x[a+396>>2];k=y[(h+N|0)+24|0];s=r+D(k,24)|0;g=x[s+4>>2];la=z[((k<<1)+a|0)+268>>1];c=ea<<((la|0)==2);i=c>>>0>g>>>0?g:c;g=x[s>>2];O=(i-(c>>>0>g>>>0?g:c)>>>0)/A[s+8>>2]|0;l=O<<2;c=D(j,l+4|0);$=x[x[a+124>>2]+D(y[s+13|0],2096)>>2];G=x[a+92>>2];P:{if(x[a+80>>2]){g=no(a,c);j=x[a+4>>2];break P}g=Gd(c)}n=(o|0)>0?o:0;t=ea<<2;q=0;c=(j|0)>0?j:0;i=(j<<2)+g|0;while(1){if((c|0)!=(q|0)){x[(q<<2)+g>>2]=i;q=q+1|0;i=i+l|0;continue}break}l=g;c=0;while(1){if((c|0)!=(n|0)){if(!y[c+Q|0]){Rb(x[R+(c<<2)>>2],0,t)}c=c+1|0;continue}break}Q:{if(!((o|0)==1|(la|0)!=2)){c=0;while(1){R:{if((c|0)!=(n|0)){if(y[c+Q|0]){break R}}else{c=n}if((c|0)==(o|0)){break Q}n=r+D(k,24)|0;q=(o|0)!=2;r=(o|0)<3;j=0;while(1){if((j|0)==8){break Q}S:{if(!q){k=0;g=0;while(1){if((g|0)>=(O|0)){break S}c=x[s>>2]+D(x[s+8>>2],g)|0;x[F+12>>2]=c&1;x[F+8>>2]=c>>1;if(!j){i=x[a+124>>2]+D(y[s+13|0],2096)|0;if(x[a+1396>>2]<=9){wl(a)}c=x[a+1392>>2];t=w[(i+((c&1023)<<1)|0)+36>>1];T:{if((t|0)>=0){K=c;t=t&65535;c=y[t+x[i+8>>2]|0];x[a+1392>>2]=K>>>c;c=x[a+1396>>2]-c|0;x[a+1396>>2]=(c|0)>0?c:0;c=(c|0)<0?-1:t;break T}c=Jm(a,i)}c=y[i+23|0]?x[x[i+2088>>2]+(c<<2)>>2]:c;if((c|0)==-1){break Q}x[x[l>>2]+(k<<2)>>2]=x[x[n+16>>2]+(c<<2)>>2]}c=0;while(1){if(!((c|0)>=($|0)|(g|0)>=(O|0))){i=x[s+8>>2];t=w[(x[n+20>>2]+(y[x[x[l>>2]+(k<<2)>>2]+c|0]<<4)|0)+(j<<1)>>1];U:{if((t|0)>=0){if(!PL(a,x[a+124>>2]+D(t&65535,2096)|0,R,2,F+12|0,F+8|0,ea,i)){break Q}g=g+1|0;break U}g=g+1|0;i=x[s>>2]+D(i,g)|0;x[F+8>>2]=i>>1;x[F+12>>2]=i&1}c=c+1|0;continue}break}k=k+1|0;continue}}if(r){break S}k=0;g=0;while(1){if((g|0)>=(O|0)){break S}i=x[s>>2]+D(x[s+8>>2],g)|0;c=(i|0)/(o|0)|0;x[F+12>>2]=i-D(c,o);x[F+8>>2]=c;if(!j){i=x[a+124>>2]+D(y[s+13|0],2096)|0;if(x[a+1396>>2]<=9){wl(a)}c=x[a+1392>>2];t=w[(i+((c&1023)<<1)|0)+36>>1];V:{if((t|0)>=0){K=c;t=t&65535;c=y[t+x[i+8>>2]|0];x[a+1392>>2]=K>>>c;c=x[a+1396>>2]-c|0;x[a+1396>>2]=(c|0)>0?c:0;c=(c|0)<0?-1:t;break V}c=Jm(a,i)}c=y[i+23|0]?x[x[i+2088>>2]+(c<<2)>>2]:c;if((c|0)==-1){break Q}x[x[l>>2]+(k<<2)>>2]=x[x[n+16>>2]+(c<<2)>>2]}c=0;while(1){if(!((c|0)>=($|0)|(g|0)>=(O|0))){i=x[s+8>>2];t=w[(x[n+20>>2]+(y[x[x[l>>2]+(k<<2)>>2]+c|0]<<4)|0)+(j<<1)>>1];W:{if((t|0)>=0){if(!PL(a,x[a+124>>2]+D(t&65535,2096)|0,R,o,F+12|0,F+8|0,ea,i)){break Q}g=g+1|0;break W}g=g+1|0;i=x[s>>2]+D(i,g)|0;t=(i|0)/(o|0)|0;x[F+8>>2]=t;x[F+12>>2]=i-D(o,t)}c=c+1|0;continue}break}k=k+1|0;continue}}j=j+1|0;continue}}c=c+1|0;continue}}na=r+D(k,24)|0;j=0;while(1){if((j|0)==8){break Q}k=0;o=0;while(1){if((k|0)<(O|0)){X:{if(j){break X}c=0;while(1){if((c|0)==(n|0)){break X}if(!y[c+Q|0]){i=x[a+124>>2]+D(y[s+13|0],2096)|0;if(x[a+1396>>2]<=9){wl(a)}g=x[a+1392>>2];q=w[(i+((g&1023)<<1)|0)+36>>1];Y:{if((q|0)>=0){r=g;q=q&65535;g=y[q+x[i+8>>2]|0];x[a+1392>>2]=r>>>g;g=x[a+1396>>2]-g|0;x[a+1396>>2]=(g|0)>0?g:0;g=(g|0)<0?-1:q;break Y}g=Jm(a,i)}g=y[i+23|0]?x[x[i+2088>>2]+(g<<2)>>2]:g;if((g|0)==-1){break Q}x[x[l+(c<<2)>>2]+(o<<2)>>2]=x[x[na+16>>2]+(g<<2)>>2]}c=c+1|0;continue}}g=0;while(1){Z:{if((g|0)>=($|0)){break Z}c=0;if((k|0)>=(O|0)){break Z}while(1){if((c|0)!=(n|0)){_:{if(y[c+Q|0]){break _}i=c<<2;q=w[(x[na+20>>2]+(y[x[x[i+l>>2]+(o<<2)>>2]+g|0]<<4)|0)+(j<<1)>>1];if((q|0)<0){break _}t=x[a+124>>2]+D(q&65535,2096)|0;U=x[i+R>>2];Y=x[s+8>>2];J=x[s>>2]+D(Y,k)|0;$:{aa:{if(la){q=0;while(1){i=1;if((q|0)>=(Y|0)){break $}fa=U+(J<<2)|0;i=Y-q|0;r=0;m=E(0);ba:{K=ML(a,t);if((K|0)<0){break ba}V=x[t>>2];r=(i|0)>(V|0)?V:i;V=D(V,K);if(y[t+22|0]){i=0;K=(r|0)>0?r:0;r=1;while(1){if((i|0)==(K|0)){break ba}ha=i<<2;ia=ha+fa|0;m=E(m+B[ha+(x[t+28>>2]+(V<<2)|0)>>2]);B[ia>>2]=B[ia>>2]+m;m=E(m+B[t+12>>2]);i=i+1|0;continue}}i=0;K=(r|0)>0?r:0;r=1;while(1){if((i|0)==(K|0)){break ba}ha=i<<2;ia=ha+fa|0;B[ia>>2]=B[ia>>2]+E(B[ha+(x[t+28>>2]+(V<<2)|0)>>2]+E(0));i=i+1|0;continue}}if(!r){break aa}i=x[t>>2];J=i+J|0;q=i+q|0;continue}}q=0;fa=(Y|0)/x[t>>2]|0;K=(fa|0)>0?fa:0;ha=U+(J<<2)|0;i=1;while(1){if((q|0)==(K|0)){break $}r=q+J|0;U=q<<2;q=q+1|0;ia=U+ha|0;U=Y-r|0;V=0;m=E(0);ca:{oa=ML(a,t);if((oa|0)<0){break ca}r=0;V=x[t>>2];U=(U|0)>(V|0)?V:U;U=(U|0)>0?U:0;oa=D(V,oa)<<2;V=1;while(1){if((r|0)==(U|0)){break ca}qa=ia+(D(r,fa)<<2)|0;u=E(m+B[(oa+x[t+28>>2]|0)+(r<<2)>>2]);B[qa>>2]=B[qa>>2]+u;m=y[t+22|0]?u:m;r=r+1|0;continue}}if(V){continue}break}}i=0}if(!i){break Q}}c=c+1|0;continue}break}k=k+1|0;g=g+1|0;continue}break}o=o+1|0;continue}break}j=j+1|0;continue}}if(!x[a+80>>2]){Db(l)}x[a+92>>2]=G;fb=F+16|0;h=h+1|0;continue}}_(6325,13274,3302,5634);p()}fb=Q+2368|0}else{c=0}fb=ga+16|0;if(!c){da:{ea:{fa:{c=x[a+100>>2];switch(c-32|0){case 0:break ea;case 3:break fa;default:break da}}x[a+100>>2]=0;while(1){if((Oh(a)|0)!=-1&!x[a+96>>2]){continue}break}x[f>>2]=0;c=x[a+32>>2]-b|0;break a}if(x[a+992>>2]){break da}x[a+100>>2]=0;while(1){if((Oh(a)|0)!=-1&!x[a+96>>2]){continue}break}x[f>>2]=0;c=x[a+32>>2]-b|0;break a}x[a+1420>>2]=0;x[a+992>>2]=0;x[a+1504>>2]=0;x[a+1508>>2]=0;x[a+1412>>2]=0;x[a+1416>>2]=0;v[a+1377|0]=0;x[a+1064>>2]=0;x[a+100>>2]=c;x[f>>2]=0;c=1;break a}l=x[aa+12>>2];i=x[aa+4>>2];h=x[aa+8>>2];c=1;k=x[a+992>>2];ga:{if(k){g=k<<1;ha:{if((g|0)==x[a+112>>2]){c=a+1092|0}else{c=0;if((g|0)!=x[a+116>>2]){break ha}c=a+1096|0}c=x[c>>2]}g=0;if(!c){break ga}j=(k|0)>0?k:0;o=c+(k<<2)|0;while(1){if(x[a+4>>2]>(P|0)){k=(P<<2)+a|0;g=0;while(1){if((g|0)!=(j|0)){n=g<<2;s=(n+x[k+800>>2]|0)+(i<<2)|0;B[s>>2]=E(B[s>>2]*B[c+n>>2])+E(B[n+x[k+928>>2]>>2]*B[o+((g^-1)<<2)>>2]);g=g+1|0;continue}break}P=P+1|0;continue}break}c=!x[a+992>>2]}x[a+992>>2]=l-h;n=(h|0)>(l|0);j=(n?h:l)-h|0;P=0;while(1){if(x[a+4>>2]>(P|0)){k=(P<<2)+a|0;g=0;while(1){if((g|0)!=(j|0)){o=g<<2;B[o+x[k+928>>2]>>2]=B[(o+x[k+800>>2]|0)+(h<<2)>>2];g=g+1|0;continue}break}P=P+1|0;continue}break}g=0;if(!c){g=(n?l:h)-i|0;x[a+1416>>2]=g+x[a+1416>>2]}}c=0;h=x[a+4>>2];l=(h|0)>0?h:0;while(1){if((c|0)!=(l|0)){k=(c<<2)+a|0;x[k+864>>2]=x[k+800>>2]+(i<<2);c=c+1|0;continue}break}if(d){x[d>>2]=h}x[f>>2]=g;x[e>>2]=a+864;c=x[a+32>>2]-b|0}fb=aa+16|0;return c}function Spa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,B=0,C=0,E=0,F=0,G=0,H=0;e=fb-1728|0;fb=e;yc(b);d=fb-16|0;fb=d;g=e+1602|0;MX(d+8|0,g);h=x[d+12>>2];lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2]);i=x[d+4>>2];if((i|0)==(h|0)){Vb(b,x[d+12>>2])}fb=d+16|0;d=(h|0)==(i|0);if(!d){LX(g)}a:{b:{c:{d:{e:{f:{g:{if(!d){break g}if(!NX(g)){break g}if(!Mb(x[b>>2],x[b+8>>2],Bc(256,0))){break g}f=1;if((c|0)==64){break g}Dd(a,1048576);eg(a);d=fb-16|0;fb=d;f=e+1344|0;g=uc(d+4|0,4230);Uc(f,g);tb(g);fb=d+16|0;d=y[e+1610|0]|y[e+1611|0]<<8;x[e+144>>2]=d>>>8;x[31609]=0;x[e>>2]=d&255;g=e+68|0;O(444,g|0,e|0);d=x[31609];x[31609]=0;h:{i:{j:{k:{if((d|0)!=1){x[31609]=0;d=e+256|0;V(430,d|0,f|0,e+144|0,g|0);h=x[31609];x[31609]=0;if((h|0)==1){break k}zb(a+1298344|0,d);tb(d);tb(g);Eb(f);g=uc(d,15214);zb(a+1298356|0,g);tb(g);Te(f,2,e+1612|0);Dr(d,22,f);zb(a+1298368|0,d);tb(d);G=a+1298404|0,H=x[Fc(d,22)>>2],x[G>>2]=H;KC(f,2,e+1644|0);Cc(d,f);zb(a+1298308|0,d);tb(d);w[a+480188>>1]=y[e+1714|0]|y[e+1715|0]<<8;g=y[e+1718|0];x[a+480204>>2]=125e4;x[a+480208>>2]=32792;G=a,H=Ld(g,1,31),x[G+480196>>2]=H;w[a+480192>>1]=y[e+1724|0]|y[e+1725|0]<<8;w[a+480190>>1]=y[e+1726|0]|y[e+1727|0]<<8;g=Ld(y[e+1719|0],1,32);x[a+480216>>2]=g;x[a+480228>>2]=96;x[a+480232>>2]=48;x[a+480220>>2]=g<<2;Hw(b,f);g=a+484376|0;Pr(Xb(x[a+484360>>2],y[g|0]),f,y[e+1708|0]|y[e+1709|0]<<8,65535,65535);$e(Xb(x[a+484360>>2],y[g|0]),y[e+1710|0]|y[e+1711|0]<<8);s=gh(b);he(d,b,s?274:0);B=hc(e+1324|0,d);ub(d);x[31609]=0;f=R(151,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break i}x[31609]=0;S(185,d|0,b|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break i}u=hc(e+1304|0,d);ub(d);t=z[a+480188>>1];if(s){w[a+480188>>1]=t+8}r=c&1;if(!r){break h}x[31609]=0;O(223,a+484344|0,y[e+1712|0]|y[e+1713|0]<<8);d=x[31609];x[31609]=0;if((d|0)!=1){break h}h=N()|0;break c}h=N()|0;break j}h=N()|0;tb(e+68|0)}Eb(e+1344|0);break a}h=N()|0;break b}n=a+484344|0;h=0;while(1){l:{m:{n:{o:{p:{q:{if((y[e+1712|0]|y[e+1713|0]<<8)>>>0<=q>>>0){d=y[e+1716|0]|y[e+1717|0]<<8;if((d-2&65535)>>>0>=4998){break o}if(!(h&1)){break q}j=0;d=Gc(((d>>>1|0)+11025e5>>>0)/(d>>>0)|0,0);break p}x[31609]=0;d=R(189,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break d}x[e>>2]=d;x[31609]=0;f=R(151,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break e}x[31609]=0;d=e+68|0;S(185,d|0,b|0,f+1&-2);f=x[31609];x[31609]=0;if((f|0)==1){break e}k=hc(e+256|0,d);ub(d);xc(e,1024);if(!r){break m}m=x[e>>2];if(!m){break m}x[31609]=0;d=U(196,n|0,q&65535,m|0)|0;f=x[31609];x[31609]=0;if((f|0)!=1){if(!d){break m}i=0;f=0;if(v[e+1720|0]&1){break n}r:while(1){if((i|0)==(m|0)){break m}d=Wb(x[n>>2],q);af(e+68|0,x[d>>2],x[x[d+48>>2]+12>>2],i);f=0;while(1){if((f|0)==(t|0)){i=i+1|0;continue r}x[31609]=0;d=e+144|0;O(623,k|0,d|0);g=x[31609];x[31609]=0;if((g|0)!=1){h=KX(Yc(x[e+68>>2],f),d)|h;f=f+1|0;continue}break}break}break f}break f}j=2;d=Ye(2646e3/+(D(d,D(x[a+480216>>2],x[a+480196>>2]))>>>0)*1e4)}v[a+480224|0]=j;x[a+480204>>2]=d}d=z[a+480188>>1];x[31609]=0;v[e+256|0]=0;q=U(624,e+1292|0,d|0,e+256|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){j=a+1298320|0;k=a+1298332|0;o=0;s:{t:{u:{v:{w:{x:{while(1){d=x[u+8>>2];f=x[u>>2];x[31609]=0;d=U(150,f|0,d|0,8)|0;f=x[31609];x[31609]=0;y:{if((f|0)!=1){if(d){break y}g=a+906300|0;h=x[q>>2];i=0;while(1){f=z[a+480188>>1];if(f>>>0<=i>>>0){x[e+248>>2]=0;x[e+252>>2]=0;x[e+240>>2]=0;x[e+244>>2]=0;x[e+232>>2]=0;x[e+236>>2]=0;x[e+224>>2]=0;x[e+228>>2]=0;z:{A:{if(!s){break A}f=0;x[31609]=0;O(625,B|0,e+256|0);d=x[31609];x[31609]=0;if((d|0)==1){break z}while(1){if((f|0)==8){f=0;x[31609]=0;j=P(214,e+212|0,z[e+256>>1])|0;d=x[31609];x[31609]=0;if((d|0)!=1){B:{C:{D:{E:{while(1){if(z[e+256>>1]<=f>>>0){x[31609]=0;k=U(626,e+200|0,y[e+1712|0]|y[e+1713|0]<<8,25320)|0;d=x[31609];x[31609]=0;if((d|0)==1){break C}g=0;break D}x[31609]=0;g=R(189,b|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){x[31609]=0;d=e+144|0;S(185,d|0,b|0,g<<5);g=x[31609];x[31609]=0;if((g|0)==1){break E}g=hc(e+68|0,d);kd(ch(x[j>>2],f),g);ub(g);f=f+1|0;ub(d);continue}break}h=N()|0;break B}h=N()|0;break B}while(1){if((y[e+1708|0]|y[e+1709|0]<<8)>>>0<=g>>>0){od(k);Rc(j);break A}F:{h=e+g|0;f=y[h+274|0];if(f>>>0>=z[e+256>>1]){break F}d=z[bc(x[Xb(x[a+484360>>2],y[a+484376|0])>>2],g)>>1];if(d>>>0>=(y[e+1712|0]|y[e+1713|0]<<8)>>>0){break F}G:{i=bc(x[k>>2],d);m=z[i>>1];H:{if((m|0)==65535){w[i>>1]=f;break H}if((f|0)==(m|0)){break H}x[31609]=0;f=P(627,n|0,d|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break G}if((f|0)==65535){break H}G=bc(x[Xb(x[a+484360>>2],y[a+484376|0])>>2],g),H=f,w[G>>1]=H;d=f}if(!Je(x[a+484344>>2],x[a+484348>>2],d)){break F}m=ch(x[j>>2],y[h+274|0]);yc(m);f=x[m>>2];x[31609]=0;f=R(154,f|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break G}l=f>>>5|0;i=0;I:while(1){f=Wb(x[n>>2],d);if(A[f+12>>2]<=i>>>0){break F}h=0;f=md(x[f>>2],x[x[f+48>>2]+12>>2],i,z[a+480188>>1]-8&65535);s=i>>>0>=l>>>0;while(1){if((h|0)==8){i=i+1|0;continue I}v[f|0]=0;v[f+1|0]=0;v[f+2|0]=0;v[f+3|0]=0;v[f+4|0]=0;v[f+5|0]=0;J:{if(s){break J}x[31609]=0;P(628,m|0,e+68|0)|0;r=x[31609];x[31609]=0;if((r|0)==1){break G}if(v[e+68|0]>=0){break J}v[f|0]=61;v[f+1|0]=y[(e+240|0)+(h<<1)|0];r=y[e+68|0]&31;v[e+144|0]=r;if(r){Of(e+144|0,15);v[f+3|0]=20;v[f+5|0]=y[e+144|0]|208}v[f+2|0]=1;v[f+4|0]=y[e+69|0]+3>>>2}f=f+6|0;h=h+1|0;continue}}}h=N()|0;od(k);break B}g=g+1|0;continue}}h=N()|0}Rc(j);break s}h=N()|0;break s}g=f<<1;h=g+(e+240|0)|0;d=z[a+480192>>1]+1&65535;i=z[x[a+8>>2]+58>>1];while(1){K:{L:{j=d&65535;if(j>>>0<=i>>>0){if(x[((j<<2)+a|0)+900380>>2]){break L}}else{d=65535}d=d&65535;break K}d=d+1|0;continue}break}w[h>>1]=d;i=g+(e+224|0)|0;g=z[(e+g|0)+258>>1];w[i>>1]=g;M:{if((d|0)!=65535){x[31609]=0;d=U(251,a|0,d|0,g+1&65535)|0;g=x[31609];x[31609]=0;N:{O:{if((g|0)!=1){if(!d){break M}x[31609]=0;g=e+144|0;O(288,g|0,4475);h=x[31609];x[31609]=0;if((h|0)==1){break O}x[31609]=0;x[e>>2]=f+1;h=e+68|0;S(629,h|0,g|0,e|0);i=x[31609];x[31609]=0;if((i|0)==1){break N}Ac(d+492|0,h);tb(h);Eb(g);break M}h=N()|0;break s}h=N()|0;break s}h=N()|0;Eb(e+144|0);break s}w[h>>1]=0}f=f+1|0;continue}}P:{Q:{d=y[e+1720|0]|y[e+1721|0]<<8|(y[e+1722|0]<<16|y[e+1723|0]<<24);if(!(d&2)){break Q}d=(((d&8?z[a+480188>>1]:t)&65535)+((y[e+1610|0]|y[e+1611|0]<<8)>>>0>591?o:0)|0)+(d>>>4&1)|0;g=0;R:while(1){f=0;if((y[e+1712|0]|y[e+1713|0]<<8)>>>0<=g>>>0){break Q}while(1){S:{if((d|0)!=(f|0)){h=x[b+8>>2];i=x[b>>2];x[31609]=0;h=U(150,i|0,h|0,4)|0;i=x[31609];x[31609]=0;if((i|0)==1){break P}if(h){break S}}g=g+1|0;continue R}x[31609]=0;O(630,y[e+1610|0]|y[e+1611|0]<<8,b|0);h=x[31609];x[31609]=0;if((h|0)==1){break P}f=f+1|0;continue}}}x[31609]=0;k=P(214,e+188|0,255)|0;d=x[31609];x[31609]=0;if((d|0)!=1){g=0;while(1){T:{d=g;U:{if((d|0)==255){o=IC(e+68|0);n=IC(e+144|0);h=0;while(1){V:{W:{X:{if((h|0)==256){i=0;break X}x[31609]=0;f=e+256|0;O(631,b|0,f|0);d=x[31609];x[31609]=0;if((d|0)==1){break W}x[31609]=0;d=R(151,b|0)|0;g=x[31609];x[31609]=0;Y:{Z:{_:{if((g|0)!=1){x[31609]=0;S(185,e|0,b|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break _}i=hc(e+40|0,e);ub(e);if((y[e+1726|0]|y[e+1727|0]<<8)>>>0>h>>>0){g=e+28|0;Te(g,2,f);x[31609]=0;O(218,e|0,g|0);f=x[31609];x[31609]=0;if((f|0)==1){break Y}Ac(((h<<5)+a|0)+946336|0,e);tb(e)}if(!d){break V}if((y[e+1726|0]|y[e+1727|0]<<8)>>>0>h>>>0){break Z}break V}h=N()|0;break U}h=N()|0;break U}x[31609]=0;d=D(h+1|0,104)+a|0;f=d+484380|0;O(279,f|0,32);g=x[31609];x[31609]=0;$:{aa:{ba:{if((g|0)!=1){wp(f);x[31609]=0;O(632,i|0,e|0);g=x[31609];x[31609]=0;if((g|0)==1){break Y}g=x[e>>2];x[f>>2]=g;x[d+484404>>2]=x[e+4>>2];if(y[e+8|0]>=2){j=d+484414|0;w[j>>1]=z[j>>1]|1;g=g>>>1|0;x[f>>2]=g}if(y[e+9|0]>=2){j=d+484414|0;w[j>>1]=z[j>>1]|64;x[f>>2]=g>>>1}j=2;switch(y[e+11|0]-1|0){case 0:break aa;case 1:break ba;default:break $}}break Y}j=6}f=d+484414|0;w[f>>1]=z[f>>1]|j}x[d+484384>>2]=x[e+12>>2];x[d+484388>>2]=x[e+16>>2];w[d+484410>>1]=z[e+20>>1]>>>7;f=y[e+22|0];ca:{if((f|0)==128){f=d+484414|0;g=z[f>>1]|256;w[f>>1]=g;break ca}w[d+484408>>1]=(f<<24>>24)+128;g=z[d+484414>>1]}j=d+484414|0;w[j>>1]=g|32;v[d+484416|0]=y[e+23|0];f=y[e+10|0];if(f&2){d=e+28|0;Jb(d,n,h);ap(d);f=y[e+10|0]}if(f&5){w[j>>1]=z[j>>1]|16384}if(!(f&8)){break V}d=e+28|0;Jb(d,o,h);ap(d);f=0;while(1){if((f|0)==8){break V}d=f<<1;da:{if(z[d+(e+224|0)>>1]!=(h|0)){break da}d=x[((z[d+(e+240|0)>>1]<<2)+a|0)+900380>>2];if(!d){break da}v[d+14|0]=0}f=f+1|0;continue}}h=N()|0;ub(i);break U}while(1){ea:{fa:{if((y[e+1724|0]|y[e+1725|0]<<8)>>>0<=i>>>0){if(!(c&2)){break fa}h=0;ga:{ha:{ia:{ja:{ka:{la:{ma:{na:{while(1){if(z[a+480190>>1]<=h>>>0){break fa}h=h+1|0;d=D(h,104)+a|0;f=d+484380|0;c=d+484416|0;$l(f,(+(v[c|0]-49|0)+ +v[d+484417|0]*-.0078125)/-12);w[c>>1]=0;c=z[d+484414>>1];if(!(c&16384)){c=Zc(e+256|0,c&1?16:8,c&64?3:1,0,11);x[31609]=0;U(215,c|0,f|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){continue}h=N()|0;break U}x[31609]=0;f=R(151,b|0)|0;c=x[31609];x[31609]=0;oa:{if((c|0)==1){break oa}x[31609]=0;P(183,b|0,12)|0;c=x[31609];x[31609]=0;if((c|0)==1){break oa}c=Fb(e+256|0);x[31609]=0;S(270,b|0,c|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break na}Be(d+484423|0,c);x[31609]=0;d=e+40|0;O(383,d|0,16475);f=x[31609];x[31609]=0;if((f|0)==1){break ma}x[e+140>>2]=h;g=x[a+1298404>>2];x[31609]=0;f=e+28|0;S(633,f|0,g|0,c|0);g=x[31609];x[31609]=0;if((g|0)==1){break la}x[31609]=0;V(430,e|0,d|0,e+140|0,f|0);g=x[31609];x[31609]=0;if((g|0)==1){break ka}g=x[a+1298472>>2];x[31609]=0;S(385,g|0,2,e|0);g=x[31609];x[31609]=0;if((g|0)==1){break ja}tb(e);tb(f);Eb(d);tb(c);continue}break}h=N()|0;break U}h=N()|0;break ga}h=N()|0;break ga}h=N()|0;break ha}h=N()|0;break ia}h=N()|0;tb(e)}tb(e+28|0)}Eb(e+40|0)}tb(c);break U}d=x[ch(x[k>>2],i)>>2];x[31609]=0;d=R(154,d|0)|0;f=x[31609];x[31609]=0;pa:{qa:{if((f|0)!=1){if(!d){i=i+1|0;continue}d=ch(x[k>>2],i);yc(d);x[31609]=0;O(634,d|0,e+256|0);d=x[31609];x[31609]=0;if((d|0)==1){break qa}j=Nb(e);x[31609]=0;S(635,b|0,j|0,z[e+256>>1]);d=x[31609];x[31609]=0;if((d|0)==1){break pa}i=i+1|0;d=x[((i<<2)+a|0)+900380>>2];if(!d|y[d+34|0]){break ea}x[d+4>>2]=32;f=0;Ov(d,0);t=d+108|0;l=d+236|0;while(1){if((f|0)==96){break ea}g=y[(e+f|0)+258|0];ra:{if(g>>>0>=z[e+256>>1]){break ra}h=Se(x[j>>2],g);s=f+12|0;r=bc(l,s);g=y[h|0];m=g+1|0;w[r>>1]=m;if(g>>>0>=z[a+480190>>1]){break ra}g=D(m,104)+a|0;v[g+484418|0]=y[e+354|0]&3;v[g+484419|0]=y[e+355|0];v[g+484420|0]=y[e+356|0];v[g+484421|0]=y[e+357|0];w[g+484412>>1]=y[h+1|0]<<1;v[g+484417|0]=y[h+2|0];g=m-1|0;Jb(e+40|0,o,g);if(Gb(x[x[e+40>>2]>>2],x[e+44>>2])){v[d+14|0]=0}Jb(e+40|0,n,g);if(!Gb(x[x[e+40>>2]>>2],x[e+44>>2])){break ra}G=xb(t,s),H=61,v[G|0]=H}f=f+1|0;continue}}h=N()|0;break U}h=N()|0;break U}h=N()|0;Ce(j);break U}Rc(k);ec(q);ub(u);ub(B);f=1;break g}Ce(j);continue}}h=N()|0;break U}ub(i);h=h+1|0;continue}}x[31609]=0;O(631,b|0,e+144|0);f=x[31609];x[31609]=0;sa:{ta:{ua:{va:{if((f|0)!=1){x[31609]=0;f=R(151,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break va}x[31609]=0;h=e+68|0;f=(f|0)==32?428:f;i=f?(y[e+1610|0]|y[e+1611|0]<<8)>>>0>513?f+4|0:f:f;S(185,h|0,b|0,i|0);f=x[31609];x[31609]=0;if((f|0)==1){break ua}f=hc(e+256|0,h);j=Ie(e,kd(ch(x[k>>2],d),f));ub(f);g=d+1|0;ub(h);if(d>>>0>=(y[e+1724|0]|y[e+1725|0]<<8)>>>0){break T}x[31609]=0;d=g&65535;h=U(251,a|0,d|0,d|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break ta}break sa}h=N()|0;break U}h=N()|0;break U}h=N()|0;break U}if(!h){break T}f=e+68|0;Te(f,2,e+144|0);x[31609]=0;d=e+256|0;O(218,d|0,f|0);f=x[31609];x[31609]=0;wa:{if((f|0)!=1){Ac(h+492|0,d);tb(d);if(!i){break T}x[31609]=0;O(634,j|0,d|0);d=x[31609];x[31609]=0;xa:{if((d|0)!=1){n=3;i=0;if((y[e+1610|0]|y[e+1611|0]<<8)>>>0>=513){break xa}o=0;break wa}break sa}x[31609]=0;o=R(189,j|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break sa}if((y[e+1610|0]|y[e+1611|0]<<8)>>>0<514){break wa}x[31609]=0;n=R(151,j|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break wa}break sa}break sa}x[h>>2]=y[e+358|0]|y[e+359|0]<<8;v[e+40|0]=0;v[e+41|0]=1;v[e+42|0]=2;v[e+43|0]=3;v[e+28|0]=0;v[e+29|0]=1;v[e+30|0]=2;v[e+31|0]=3;v[e+140|0]=0;v[e+141|0]=2;v[e+142|0]=1;v[e+143|0]=2;v[h+16|0]=y[(e+40|0)+((y[e+360|0]|y[e+361|0]<<8)&3)|0];v[h+17|0]=y[(e+28|0)+(y[e+361|0]&3)|0];v[h+18|0]=y[(e+140|0)+((y[e+360|0]|y[e+361|0]<<8)>>>12&3)|0];while(1){ya:{za:{if((i|0)==4){if(!(v[h+60|0]&1|y[h+16|0]==3)){x[h>>2]=32767}dk(h,127,1);ck(h,0,1);if(!o){break T}x[31609]=0;O(636,j|0,e+68|0);d=x[31609];x[31609]=0;if((d|0)==1){break sa}if(o&2){dk(h,JD(x[a+480208>>2],+((y[e+70|0]|y[e+71|0]<<8)>>>0)),1);ck(h,y[e+72|0],1)}v[h+25|0]=y[e+69|0]==1;if(!(o&4)){break T}v[h+31|0]=y[e+75|0]+1;d=v[e+76|0];v[h+34|0]=d+1;if((d|0)<0){v[h+30|0]=y[e+83|0]+1}if(!y[e+80|0]){break za}i=h+108|0;f=0;while(1){if((f|0)==128){break za}d=f+1|0;x[e+64>>2]=d+v[e+80|0];IX(e- -64|0);G=xb(i,f),H=x[e+64>>2],v[G|0]=H;f=d;continue}}if(!(n&1)){break ya}x[31609]=0;O(637,j|0,e+68|0);d=x[31609];x[31609]=0;if((d|0)==1){break sa}v[e+64|0]=0;v[e+65|0]=1;v[e+66|0]=2;v[e+67|0]=2;d=Yh(h,y[(e- -64|0)+i|0]);f=y[e+68|0];m=f&1;v[d+12|0]=y[d+12|0]&232|((i|0)==3?0-m&16:0)|f<<1&4|f>>>1&2|m;v[e+63|0]=y[e+69|0];v[e+62|0]=16;f=y[Qb(e+63|0,e+62|0)|0];x[31609]=0;O(293,d|0,f|0);f=x[31609];x[31609]=0;if((f|0)!=1){f=y[e+70|0];v[d+15|0]=f;v[d+16|0]=f;v[d+13|0]=y[e+71|0];v[d+14|0]=y[e+72|0];f=0;m=x[d>>2];t=Sd(m,x[d+4>>2]);while(1){if((f|0)==(t|0)){break ya}l=yb(m,f);d=(e+68|0)+(f<<2)|0;w[l>>1]=y[d+8|0]|y[d+9|0]<<8;G=l,H=Ld(y[d+10|0]|y[d+11|0]<<8,0,64),v[G+2|0]=H;f=f+1|0;continue}}break sa}Ov(h,0);break T}i=i+1|0;n=n>>>1|0;continue}}h=N()|0;ub(j)}Rc(k);break s}ub(j);continue}}h=N()|0;break s}h=N()|0;break s}h=N()|0;break s}else{d=v[xb(h,i)|0];Aa:{if((d|0)<=(i|0)|(d|0)>=(f|0)){break Aa}d=y[((d<<5)+a|0)+480288|0];if(!d){break Aa}f=((i<<5)+a|0)+480288|0;j=y[f|0];if(!j){v[f|0]=d;break Aa}f=j-1|0;while(1){j=$d(g,f&255);f=Jn(x[j+28>>2]);if((f|0)!=255){continue}break}d=d-1&255;x[j+28>>2]=d>>>0<250?d+128|0:0}i=i+1|0;continue}}}h=N()|0;break s}x[31609]=0;g=R(151,u|0)|0;d=x[31609];x[31609]=0;Ba:{Ca:{Da:{Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{if((d|0)!=1){x[31609]=0;d=R(151,u|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Ja}x[31609]=0;f=e+256|0;S(185,f|0,u|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break Ja}d=hc(e+68|0,f);ub(f);if((g|0)==4674381){break Fa}if((g|0)==5068115){break Ea}if((g|0)==726487106){break Ia}if((g|0)==844387158){break Da}f=0;if((g|0)==1280004692){break Ha}if((g|0)==1314144592){break Ga}if((g|0)!=1397445204){break Ca}x[31609]=0;f=R(189,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break u}f=f>>>0<256?48:f>>>8|0;x[a+480228>>2]=f;x[a+480232>>2]=f>>>1;f=0;while(1){if(z[a+480188>>1]<=f>>>0){break Ca}x[31609]=0;g=P(638,d|0,e+256|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break x}if(g){w[((f<<5)+a|0)+480286>>1]=z[e+256>>1]>>>10;G=xb(x[q>>2],f),H=y[e+259|0],v[G|0]=H}f=f+1|0;continue}}h=N()|0;break s}h=N()|0;break s}if(h&1){break Ca}v[a+480224|0]=2;x[31609]=0;C=+ia(639,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break Ba}if(!(C>1e-8)){break Ca}G=a,H=Ye(2646e3/(C*+(D(x[a+480216>>2],x[a+480196>>2])>>>0))*1e4),x[G+480204>>2]=H;break Ca}while(1){Ka:{if(z[a+480188>>1]<=f>>>0){break Ca}g=x[d>>2];x[31609]=0;g=U(150,g|0,x[e+76>>2],1)|0;i=x[31609];x[31609]=0;if((i|0)==1){break w}if(!g){break Ca}g=Fb(e+256|0);x[31609]=0;S(358,d|0,g|0,-1);i=x[31609];x[31609]=0;if((i|0)!=1){ug(e,3,Kb(g),_c(x[e+260>>2],y[e+267|0]));x[31609]=0;i=e+144|0;O(218,i|0,e|0);m=x[31609];x[31609]=0;if((m|0)==1){break Ka}im(((f<<5)+a|0)+480289|0,i);tb(i);tb(g);f=f+1|0;continue}}break}h=N()|0;tb(g);break t}while(1){if((y[e+1712|0]|y[e+1713|0]<<8)>>>0<=f>>>0){break Ca}g=x[d>>2];x[31609]=0;g=U(150,g|0,x[e+76>>2],1)|0;i=x[31609];x[31609]=0;if((i|0)==1){break v}if(!g){break Ca}if(!Cn(x[a+484344>>2],x[a+484348>>2],f&65535)){break Ca}g=Fb(e+256|0);x[31609]=0;S(358,d|0,g|0,-1);i=x[31609];x[31609]=0;La:{if((i|0)==1){break La}i=x[n>>2];x[31609]=0;O(283,Wb(i,f)|0,g|0);i=x[31609];x[31609]=0;if((i|0)==1){break La}tb(g);f=f+1|0;continue}break}h=N()|0;tb(g);break t}x[31609]=0;P(183,d|0,1)|0;f=x[31609];x[31609]=0;if((f|0)==1){break u}x[31609]=0;f=R(202,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break u}x[31609]=0;V(336,k|0,d|0,f|0,2);f=x[31609];x[31609]=0;if((f|0)!=1){break Ca}break u}x[31609]=0;P(640,d|0,e|0)|0;f=x[31609];x[31609]=0;Ma:{if((f|0)!=1){f=Fb(e+256|0);x[31609]=0;S(358,d|0,f|0,-1);g=x[31609];x[31609]=0;if((g|0)==1){break Ma}if(!Nd(f,12698)){x[31609]=0;g=e+144|0;S(258,g|0,22,f|0);i=x[31609];x[31609]=0;if((i|0)==1){break Ma}zb(j,g);tb(g)}tb(f);break Ca}h=N()|0;break t}h=N()|0;tb(f);break t}x[31609]=0;o=R(151,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break u}}ub(d);continue}break}h=N()|0;break t}h=N()|0;break t}h=N()|0;break t}h=N()|0;break t}h=N()|0}ub(d)}ec(q);break c}h=N()|0;break c}while(1){d=x[k>>2];x[31609]=0;d=U(150,d|0,x[e+264>>2],1)|0;g=x[31609];x[31609]=0;Na:{if((g|0)!=1){if(!d){break m}x[31609]=0;j=R(197,k|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break f}o=0;if((j|0)!=255){break Na}x[31609]=0;o=R(197,k|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){x[31609]=0;j=R(197,k|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break Na}}break f}break f}if(j&127){d=Wb(x[n>>2],q);g=md(x[d>>2],x[x[d+48>>2]+12>>2],f,i&65535);GE(e+68|0);if(j&1){x[31609]=0;d=R(197,k|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break l}v[e+68|0]=d}if(j&2){x[31609]=0;d=R(197,k|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break l}v[e+69|0]=d}if(j&4){x[31609]=0;d=R(197,k|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break l}v[e+70|0]=d}if(j&8){x[31609]=0;d=R(197,k|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break l}v[e+71|0]=d}if(j&16){x[31609]=0;d=R(197,k|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break l}v[e+72|0]=d}if(j&32){x[31609]=0;d=R(197,k|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break l}v[e+73|0]=d}if(j&64){x[31609]=0;d=R(197,k|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break l}v[e+74|0]=d}E=KX(g,e+68|0);x[e+144>>2]=o;x[e+40>>2]=m+(f^-1);F=x[Hb(e+144|0,e+40|0)>>2];j=0;d=g;while(1){if((j|0)!=(F|0)){d=D(z[a+480188>>1],6)+d|0;l=y[g|0]|y[g+1|0]<<8|(y[g+2|0]<<16|y[g+3|0]<<24);v[d|0]=l;v[d+1|0]=l>>>8;v[d+2|0]=l>>>16;v[d+3|0]=l>>>24;l=y[g+4|0]|y[g+5|0]<<8;v[d+4|0]=l;v[d+5|0]=l>>>8;j=j+1|0;continue}break}h=h|E}f=(f+o|0)+1|0;while(1){if(f>>>0>=m>>>0){i=i+1|0;f=f-m|0;continue}break}if(t>>>0>(i&65535)>>>0){continue}break}}ub(k);q=q+1|0;continue}break}break f}fb=e+1728|0;return f|0}h=N()|0;ub(k);break c}h=N()|0;break c}h=N()|0}ub(u)}ub(B)}Q(h|0);p()}function Msa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,B=0,C=0,E=0;d=fb-1120|0;fb=d;yc(b);e=fb-16|0;fb=e;g=d+884|0;m_(e+8|0,g);n=x[e+12>>2];lc(e,x[b>>2],x[b+8>>2],x[e+8>>2],x[e+12>>2]);h=x[e+4>>2];if((h|0)==(n|0)){Vb(b,x[e+12>>2])}fb=e+16|0;e=(h|0)==(n|0);if(!e){l_(g)}a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{if(!e){break o}if(!o_(g)){break o}if(!Mb(x[b>>2],x[b+8>>2],Bc(n_(y[d+888|0]|y[d+889|0]<<8|(y[d+890|0]<<16|y[d+891|0]<<24)),hb))){break o}f=1;if((c|0)==64){break o}Dd(a,16777216);eg(a);x[a+480208>>2]=x[a+480208>>2]|16809984;e=d+448|0;rr(e,32);g=x[d+460>>2];f=a+1074320|0;x[f>>2]=x[d+456>>2];x[f+4>>2]=g;f=x[d+452>>2];x[a+1074312>>2]=x[d+448>>2];x[a+1074316>>2]=f;Lb(Lb(a+1074312|0,57,y[d+887|0]>5),114,1);f=jp(d+840|0);C=f,E=Ld(y[d+1084|0],1,31),x[C+8>>2]=E;C=f,E=Ld(y[d+1085|0],1,12),x[C+4>>2]=E;C=f,E=Bb(y[d+1086|0]|y[d+1087|0]<<8),x[C>>2]=E;nE(a+1298412|0,f);w[a+480188>>1]=32;f=d+36|0;k_(f,3,d+1088|0);Dr(e,1,f);zb(a+1298368|0,e);tb(e);p:{if(y[d+887|0]<=5){gg(f,3924);break p}e=fb-16|0;fb=e;f=uc(e+4|0,3993);Uc(d+36|0,f);tb(f);fb=e+16|0}x[31609]=0;e=d+448|0;f=d+36|0;S(370,e|0,f|0,y[d+887|0]);g=x[31609];x[31609]=0;q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{if((g|0)!=1){zb(a+1298344|0,e);tb(e);Eb(f);g=uc(e,15218);zb(a+1298356|0,g);tb(g);C=a+1298404|0,E=x[Fc(e,26)>>2],x[C>>2]=E;Te(f,3,d+892|0);Cc(e,f);zb(a+1298308|0,e);tb(e);x[a+480228>>2]=256;x[a+480200>>2]=384/(z[a+480188>>1]+3>>>0);G:{if(y[d+887|0]>5){break G}C=d,E=Bb(y[d+1112|0]|y[d+1113|0]<<8),w[C+448>>1]=E;w[d+36>>1]=1;C=a,E=z[qe(e,f)>>1],x[C+480196>>2]=E;C=d,E=Bb(y[d+1114|0]|y[d+1115|0]<<8),w[C+448>>1]=E;w[d+36>>1]=1;C=a,E=D(z[qe(e,f)>>1],1e4),x[C+480204>>2]=E;C=d,E=Bc(((Bb(y[d+1116|0]|y[d+1117|0]<<8)<<8)+2047>>>0)/4095|0,0),x[C+448>>2]=E;x[d+36>>2]=256;C=a,E=x[Hb(e,f)>>2],x[C+480200>>2]=E;C=d,E=Bb(y[d+1118|0]|y[d+1119|0]<<8),w[C+448>>1]=E;Hf(e,127);f=0;e=z[d+448>>1];while(1){if((e|0)==(f|0)){break G}C=d,E=Bc(((Qk(b)<<8)+2047>>>0)/4095|0,0),w[C+36>>1]=E;w[d+344>>1]=256;C=((f<<5)+a|0)+480284|0,E=z[Oc(d+36|0,d+344|0)>>1],w[C>>1]=E;f=f+1|0;continue}}dd(b,$b(y[d+888|0]|y[d+889|0]<<8|(y[d+890|0]<<16|y[d+891|0]<<24)));n=Ie(d+820|0,b);x[31609]=0;e=d+808|0;O(375,e|0,n|0);b=x[31609];x[31609]=0;H:{I:{J:{K:{L:{if((b|0)!=1){x[31609]=0;b=d+448|0;S(376,b|0,e|0,1346458707);f=x[31609];x[31609]=0;if((f|0)==1){break H}x[31609]=0;f=U(150,x[d+448>>2],x[d+456>>2],2)|0;g=x[31609];x[31609]=0;if((g|0)==1){break K}if(!f){break I}x[31609]=0;f=R(273,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break K}if((f-1&65535)>>>0>126){break I}w[a+480188>>1]=f;ub(b);x[31609]=0;S(376,b|0,e|0,1397706311);b=x[31609];x[31609]=0;if((b|0)!=1){break L}a=N()|0;break c}a=N()|0;break b}x[31609]=0;b=U(150,x[d+448>>2],x[d+456>>2],2)|0;e=x[31609];x[31609]=0;if((e|0)==1){break E}if(!b){break I}x[31609]=0;b=d+448|0;e=R(273,b|0)|0;f=x[31609];x[31609]=0;M:{if((f|0)==1){break M}w[d+36>>1]=e;e=y[a+484376|0];f=x[a+484360>>2];x[31609]=0;g=R(273,b|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break M}$e(Xb(f,e),g);x[31609]=0;e=R(202,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break M}Hf(d+36|0,cm(e>>>1|0));e=y[a+484376|0];f=x[a+484360>>2];x[31609]=0;S(276,Xb(f,e)|0,b|0,z[d+36>>1]);b=x[31609];x[31609]=0;if((b|0)!=1){break J}}break E}a=N()|0;ub(d+448|0);break c}b=d+448|0;ub(b);x[31609]=0;S(376,b|0,d+808|0,1480806221);b=x[31609];x[31609]=0;if((b|0)==1){break F}x[31609]=0;b=U(150,x[d+448>>2],x[d+456>>2],3)|0;e=x[31609];x[31609]=0;if((e|0)!=1){if(b){break D}f=160;while(1){N:{b=f;if(!b){b=0;break N}f=b-1|0;if(y[(f+d|0)+924|0]==32){continue}}break}x[31609]=0;V(343,a+1298332|0,d+924|0,b|0,4);b=x[31609];x[31609]=0;if((b|0)!=1){break C}break B}break B}ub(d+448|0);f=0;break q}a=N()|0;break c}a=N()|0;Eb(d+36|0);break a}a=N()|0;break c}a=N()|0;ub(d+448|0);break c}x[31609]=0;b=d+448|0;e=R(273,b|0)|0;f=x[31609];x[31609]=0;if((f|0)!=1){x[31609]=0;V(336,a+1298332|0,b|0,e|0,4);b=x[31609];x[31609]=0;if((b|0)!=1){break C}}break B}e=d+448|0;ub(e);x[31609]=0;S(376,e|0,d+808|0,1413697073);b=x[31609];x[31609]=0;if((b|0)==1){break A}x[31609]=0;b=R(197,e|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break y}if(b){break z}x[31609]=0;b=P(149,e|0,2648)|0;f=x[31609];x[31609]=0;if((f|0)==1){break y}if(!b){break z}b=0;x[31609]=0;e=R(281,e|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break y}while(1){if((b|0)==32){break z}f=((b<<5)+a|0)+480280|0;x[f>>2]=x[f>>2]&-1025|!(e>>>b&1)<<10;b=b+1|0;continue}}a=N()|0;ub(d+448|0);break c}a=N()|0;break c}e=d+448|0;ub(e);x[31609]=0;S(376,e|0,d+808|0,1413697074);b=x[31609];x[31609]=0;if((b|0)==1){break x}x[31609]=0;b=U(150,x[d+448>>2],x[d+456>>2],12)|0;f=x[31609];x[31609]=0;if((f|0)==1){break w}O:{if(!b){break O}x[31609]=0;b=d+36|0;O(377,b|0,e|0);f=x[31609];x[31609]=0;if((f|0)==1){break w}f=_e(b);g=gc(b);h=j_(b);l=Ab(b);k=i_(b);f=D(Ld(Bb(y[f|0]|y[f+1|0]<<8),32,999),1e4);g=Iua(Bb(y[g|0]|y[g+1|0]<<8),0,1e4,0);b=hb;g=g+32768|0;b=g>>>0<32768?b+1|0:b;C=a,E=((Bc((b&65535)<<16|g>>>16,b>>>16|0)>>>0)%1e4|0)+f|0,x[C+480204>>2]=E;C=a,E=Ld(Bb(y[h|0]|y[h+1|0]<<8),1,255),x[C+480196>>2]=E;b=16/(Ld(Bb(y[k|0]|y[k+1|0]<<8),1,16)>>>0)|0;x[a+480216>>2]=b;C=a,E=D(Ld(Bb(y[l|0]|y[l+1|0]<<8),1,16),b),x[C+480220>>2]=E;if(!Bb(z[d+36>>1])){break O}x[31609]=0;b=R(273,e|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break w}x[a+480208>>2]=x[a+480208>>2]&-17|!b<<4}b=d+448|0;ub(b);x[31609]=0;S(376,b|0,d+808|0,1414942540);e=x[31609];x[31609]=0;if((e|0)==1){break v}x[31609]=0;e=U(150,x[d+448>>2],x[d+456>>2],2)|0;f=x[31609];x[31609]=0;if((f|0)==1){break t}if(!e){break u}x[31609]=0;b=R(273,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break t}w[d+36>>1]=b;w[d+344>>1]=z[a+480188>>1];e=z[Oc(d+36|0,d+344|0)>>1];b=0;while(1){if((b|0)==(e|0)){break u}x[31609]=0;f=R(273,d+448|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break t}w[d+36>>1]=f;w[d+344>>1]=4096;C=((b<<5)+a|0)+480286|0,E=z[Oc(d+36|0,d+344|0)>>1]>>>6&255,w[C>>1]=E;b=b+1|0;continue}}a=N()|0;ub(d+448|0);break c}a=N()|0;break c}a=N()|0;ub(d+448|0);break c}a=N()|0;break c}b=d+448|0;ub(b);x[31609]=0;e=d+36|0;S(376,e|0,d+808|0,1296652368);f=x[31609];x[31609]=0;if((f|0)==1){break s}x[31609]=0;f=U(150,x[d+36>>2],x[d+44>>2],56)|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(!f){break r}x[31609]=0;O(378,e|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break d}if((Bb(y[d+482|0]|y[d+483|0]<<8)|0)!=4){break r}if((Bb(y[d+496|0]|y[d+497|0]<<8)|0)!=257){break r}C=d,E=Bb(y[d+488|0]|y[d+489|0]<<8),w[C+344>>1]=E;w[d+796>>1]=16384;b=z[Oc(d+344|0,d+796|0)>>1];f=b>>>24|0;b=(b<<8)+2048|0;f=b>>>0<2048?f+1|0:f;C=a,E=Bc((f&4095)<<20|b>>>12,f>>>12|0),x[C+480200>>2]=E;b=0;while(1){if(Bb(y[d+486|0]|y[d+487|0]<<8)>>>0<=(b&65535)>>>0){break r}x[31609]=0;O(379,d+36|0,d+344|0);e=x[31609];x[31609]=0;if((e|0)==1){break d}P:{if(y[d+344|0]){break P}e=Bb(y[d+346|0]|y[d+347|0]<<8);if(e>>>0>=z[a+480188>>1]){break P}e=(e<<5)+a|0;C=e+480284|0,E=Bc(((Bb(y[d+350|0]|y[d+351|0]<<8)<<8)+2047>>>0)/4095|0,0),w[C>>1]=E;i=e+480286|0;e=Bb(y[d+348|0]|y[d+349|0]<<8);f=e>>>26|0;g=(e<<6)+2048|0;f=g>>>0<2048?f+1|0:f;C=i,E=Bc((f&4095)<<20|g>>>12,f>>>12|0)&255,w[C>>1]=E}b=b+1|0;continue}}a=N()|0;ub(d+448|0);break c}a=N()|0;break c}b=d+36|0;ub(b);x[31609]=0;S(380,b|0,d+808|0,1396788530);b=x[31609];x[31609]=0;if((b|0)==1){break e}C=d,E=wb(x[d+36>>2]),x[C+760>>2]=E;f=c&2;l=d+450|0;k=wb(x[d+40>>2]);Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{while(1){e=x[d+760>>2];if(!Ib(e,k)){b=d+36|0;Rc(b);x[31609]=0;S(380,b|0,d+808|0,1396788560);b=x[31609];x[31609]=0;if((b|0)==1){break f}C=d,E=wb(x[d+36>>2]),x[C+784>>2]=E;g=d+450|0;h=wb(x[d+40>>2]);break Q}x[31609]=0;b=P(381,e|0,d+448|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break S}_:{$:{if(!b){break $}b=Bb(z[d+448>>1]);if((b-4e3&65535)>>>0<61537){break $}if(Bb(z[d+496>>1])>>>0>1){break $}if(Bb(z[d+478>>1])>>>0>1){break $}if(b>>>0>z[a+480190>>1]){w[a+480190>>1]=b}x[31609]=0;g=D(b,104)+a|0;h=g+484380|0;O(382,d+448|0,h|0);b=x[31609];x[31609]=0;aa:{ba:{ca:{if((b|0)==1){break ca}j=d+796|0;Xi(j,3,l);x[31609]=0;b=d+344|0;O(218,b|0,j|0);j=x[31609];x[31609]=0;if((j|0)==1){break ba}Ac(((Bb(z[d+448>>1])<<5)+a|0)+946304|0,b);tb(b);if(!f){break $}j=z[d+522>>1]|z[d+524>>1]<<16;x[31609]=0;j=P(149,e|0,$b(j)-8|0)|0;o=x[31609];x[31609]=0;if((o|0)==1){break ca}if(!j){break $}if(Bb(z[d+478>>1])){break aa}Zc(b,(Bb(y[d+480|0]|y[d+481|0]<<8)|0)==8?8:16,(Bb(y[d+484|0]|y[d+485|0]<<8)|0)==1?1:2,!Bb(y[d+482|0]|y[d+483|0]<<8),0);x[31609]=0;U(215,b|0,h|0,e|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break aa}a=N()|0;break R}a=N()|0;break R}a=N()|0;break R}b=Fb(d+344|0);h=z[d+498>>1];x[31609]=0;S(270,e|0,b|0,Bb(h)|0);e=x[31609];x[31609]=0;if((e|0)==1){break U}Be(g+484423|0,b);if((Bb(z[d+478>>1])|0)==1){x[31609]=0;e=d+784|0;O(383,e|0,16475);g=x[31609];x[31609]=0;if((g|0)==1){break _}x[31609]=0;g=d+772|0;S(258,g|0,0,b|0);h=x[31609];x[31609]=0;if((h|0)==1){break Z}x[31609]=0;h=d+796|0;V(384,h|0,e|0,z[d+448>>1],g|0);j=x[31609];x[31609]=0;if((j|0)==1){break Y}j=x[a+1298472>>2];x[31609]=0;S(385,j|0,2,h|0);j=x[31609];x[31609]=0;if((j|0)==1){break X}tb(h);tb(g);Eb(e)}tb(b)}Qf(d+760|0);continue}break}a=N()|0;break T}a=N()|0;break V}a=N()|0;break W}a=N()|0;tb(d+796|0)}tb(d+772|0)}Eb(d+784|0);break T}a=N()|0}tb(b);break R}a=N()|0}Rc(d+36|0);break c}da:{while(1){ea:{e=x[d+784>>2];if(!Ib(e,h)){Rc(d+36|0);x[31609]=0;S(380,d+796|0,d+808|0,1447382614);b=x[31609];x[31609]=0;if((b|0)!=1){break da}a=N()|0;break c}x[31609]=0;b=P(386,e|0,d+448|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break ea}fa:{ga:{if(!b){break ga}b=Bb(z[d+448>>1]);if((b-4e3&65535)>>>0<61537){break ga}if(Bb(z[d+502>>1])){break ga}if(b>>>0>z[a+480190>>1]){w[a+480190>>1]=b}x[31609]=0;l=(D(b,104)+a|0)+484380|0;O(387,d+448|0,l|0);b=x[31609];x[31609]=0;if((b|0)==1){break ea}k=d+796|0;Xi(k,3,g);x[31609]=0;b=d+344|0;O(218,b|0,k|0);k=x[31609];x[31609]=0;if((k|0)==1){break ea}Ac(((Bb(z[d+448>>1])<<5)+a|0)+946304|0,b);tb(b);if(!f){break ga}k=z[d+478>>1];Zc(b,(Bb(z[d+482>>1])|0)==8?8:16,Bb(k)&1?2:1,1,0);x[31609]=0;U(215,b|0,l|0,e|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break fa}}Qf(d+784|0);continue}}break}a=N()|0;Rc(d+36|0);break c}x[31609]=0;b=d+808|0;S(380,d+784|0,b|0,1413828182);e=x[31609];x[31609]=0;if((e|0)==1){break h}x[31609]=0;S(380,d+772|0,b|0,1346719318);e=x[31609];x[31609]=0;if((e|0)==1){break j}x[31609]=0;S(380,d+760|0,b|0,1229869908);b=x[31609];x[31609]=0;if((b|0)==1){break l}C=d,E=wb(x[d+760>>2]),x[C+12>>2]=E;l=d+394|0;k=d+346|0;j=d+450|0;o=wb(x[d+764>>2]);while(1){ha:{ia:{ja:{ka:{g=x[d+12>>2];if(!Ib(g,o)){Rc(d+760|0);x[31609]=0;S(380,d+344|0,d+808|0,1346458692);b=x[31609];x[31609]=0;if((b|0)!=1){break ka}a=N()|0;break k}x[31609]=0;b=P(388,g|0,d+448|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break n}if(!b){break ha}if(Bb(z[d+478>>1])){break ha}b=z[d+448>>1];x[31609]=0;e=U(251,a|0,Bb(b)|0,0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break n}if(!e){break ha}b=Bb(z[d+448>>1]);if(b>>>0>z[a+480192>>1]){w[a+480192>>1]=b}f=d+344|0;Xi(f,3,j);x[31609]=0;b=d+36|0;O(218,b|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break ja}Ac(e+492|0,b);tb(b);v[e+33|0]=2;if((ze(w[d+482>>1])|0)>0){v[e+15|0]=y[e+15|0]|1;b=ze(w[d+482>>1]);f=b>>>24|0;h=(b<<8&-256)+2047|0;b=f&255;C=e,E=Bc(Kua(h,h>>>0<2047?b+1|0:b,4095,0),hb),x[C+8>>2]=E}i=e+108|0;m=e+236|0;f=0;while(1){la:{x[d+36>>2]=128;x[d+344>>2]=128;b=f&255;h=d+36|0;if(b>>>0>=A[Hb(h,d+344|0)>>2]){x[31609]=0;O(389,h|0,e|0);b=x[31609];x[31609]=0;if((b|0)==1){break la}C=d,E=Vi(x[d+36>>2]),x[C+344>>2]=E;b=Pf(h);f=z[a+480190>>1];h=z[d+480>>1];while(1){i=x[d+344>>2];if(Ib(i,b)){i=z[cp(i)>>1];if(f>>>0>(i-1&65535)>>>0){C=(D(i,104)+a|0)+484410|0,E=Bb(h),w[C>>1]=E}ah(d+344|0);continue}break}Yv(d+36|0);dk(e,127,1);ck(e,0,1);b=Bb(z[d+498>>1]);if(!b){x[e>>2]=0;b=z[d+484>>1];x[31609]=0;V(390,e|0,0,Bb(b)|0,d+796|0);b=x[31609];x[31609]=0;if((b|0)==1){break n}b=z[d+488>>1];x[31609]=0;V(390,e|0,1,Bb(b)|0,d+772|0);b=x[31609];x[31609]=0;if((b|0)==1){break n}b=z[d+486>>1];x[31609]=0;V(390,e|0,2,Bb(b)|0,d+784|0);b=x[31609];x[31609]=0;if((b|0)!=1){break ha}break n}x[31609]=0;S(391,g|0,d+344|0,((b|0)==1?98:102)|0);b=x[31609];x[31609]=0;ma:{na:{oa:{if((b|0)!=1){b=Bb(z[d+344>>1]);h=b&1;if(!h){break ia}f=b&24;if(f){break oa}f=0;break na}a=N()|0;break m}if((f|0)!=8){break ma}f=1}v[e+25|0]=f}pa:{qa:{ra:{sa:{if(!(b&2)){break sa}x[31609]=0;b=U(392,d+332|0,k|0,24)|0;f=x[31609];x[31609]=0;if((f|0)==1){break ra}x[31609]=0;s=+ia(393,b|0);f=x[31609];x[31609]=0;if((f|0)==1){break qa}tb(b);if(!(s>20)){break sa}dk(e,JD(x[a+480208>>2],s),1)}if(Bb(z[d+344>>1])&4){break pa}break ia}a=N()|0;break m}a=N()|0;tb(b);break m}x[31609]=0;b=U(392,d+320|0,l|0,24)|0;f=x[31609];x[31609]=0;ta:{if((f|0)!=1){x[31609]=0;s=+ia(393,b|0);f=x[31609];x[31609]=0;if((f|0)==1){break ta}tb(b);ck(e,_l(s*127/24),1);break ia}a=N()|0;break m}a=N()|0;tb(b);break m}else{h=(d+448|0)+(b<<1)|0;C=bc(m,b),E=y[h+52|0],w[C>>1]=E;b=xb(i,b);C=b,E=iw(v[h+53|0]+y[b|0]|0),v[C|0]=E;f=f+1|0;continue}}break}a=N()|0;break m}b=x[d+348>>2];e=x[d+344>>2];x[31609]=0;h=a+484344|0;O(223,h|0,Sf(e,b)&65535);b=x[31609];x[31609]=0;ua:{if((b|0)!=1){x[d+32>>2]=x[a+480204>>2];x[d+28>>2]=x[a+480196>>2];C=d,E=wb(x[d+344>>2]),x[C+24>>2]=E;m=c&1;q=wb(x[d+348>>2]);while(1){va:{wa:{xa:{ya:{za:{Aa:{c=x[d+24>>2];if(!Ib(c,q)){x[31609]=0;S(376,d+36|0,d+808|0,1414414669);b=x[31609];x[31609]=0;if((b|0)!=1){break Aa}a=N()|0;break ua}if(!m){break va}b=x[c+8>>2];e=x[c>>2];x[31609]=0;b=U(150,e|0,b|0,24)|0;e=x[31609];x[31609]=0;if((e|0)==1){break za}if(!b){break va}x[31609]=0;l=R(273,c|0)|0;b=x[31609];x[31609]=0;Ba:{Ca:{Da:{Ea:{if((b|0)!=1){v[d+464|0]=0;x[d+456>>2]=0;x[d+460>>2]=0;x[d+448>>2]=0;x[d+452>>2]=0;x[31609]=0;b=d+448|0;O(394,c|0,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break Ea}x[31609]=0;o=R(273,c|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Da}x[31609]=0;k=R(273,c|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Ca}x[31609]=0;j=R(273,c|0)|0;e=x[31609];x[31609]=0;Fa:{if((e|0)==1){break Fa}e=x[c+8>>2];f=x[c>>2];x[31609]=0;e=U(150,f|0,e|0,D(D(j,k),5)|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Fa}if(!(e&o>>>0<2)){break va}x[31609]=0;e=U(196,h|0,l|0,k|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break Fa}if(!e){break va}e=x[h>>2];x[31609]=0;O(395,Wb(e,l)|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break Ba}}a=N()|0;break ua}a=N()|0;break ua}a=N()|0;break ua}a=N()|0;break ua}a=N()|0;break ua}v[d+12|0]=0;b=ee(d+36|0,0,d+12|0);x[31609]=0;e=U(371,d+760|0,j|0,b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break wa}g=0;Ga:while(1){if((g|0)==(k|0)){od(e);break va}b=Wb(x[h>>2],l);af(d+36|0,x[b>>2],x[x[b+48>>2]+12>>2],g);b=0;while(1){if((b|0)==(j|0)){g=g+1|0;continue Ga}f=Ng(d+12|0);if(z[a+480188>>1]>b>>>0){f=Yc(x[d+36>>2],b)}x[31609]=0;O(396,c|0,d|0);i=x[31609];x[31609]=0;Ha:{if((i|0)==1){break Ha}i=y[d|0];if((i-1&255)>>>0<=119){i=i+1|0;v[f|0]=i;C=bc(x[e>>2],b),E=i,v[C|0]=E}i=y[d+1|0];if(i){v[f+1|0]=i;C=bc(x[e>>2],b),E=i,v[C+1|0]=E}i=y[d+4|0];if(i){v[f+2|0]=1;v[f+4|0]=o?i-16|0:i>>>2|0}i=y[d+887|0];t=y[d+3|0];u=y[d+2|0];r=bc(x[e>>2],b);B=y[r+1|0];r=y[r|0];x[31609]=0;ya(373,a|0,f|0,u|0,t|0,i|0,r|0,B|0,d+32|0,d+28|0);f=x[31609];x[31609]=0;if((f|0)==1){break Ha}b=b+1|0;continue}break}break}a=N()|0;od(e);break ua}x[31609]=0;b=U(150,x[d+36>>2],x[d+44>>2],38)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(!b){break xa}x[31609]=0;e=R(273,d+36|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break ya}f=d+452|0;b=0;Ia:{while(1){if(e>>>0<=(b&65535)>>>0){break xa}x[31609]=0;c=U(150,x[d+36>>2],x[d+44>>2],36)|0;g=x[31609];x[31609]=0;Ja:{if((g|0)!=1){if(c){break Ja}break xa}break ya}x[31609]=0;O(397,d+36|0,d+448|0);c=x[31609];x[31609]=0;if((c|0)!=1){Ka:{if(Bb(z[d+448>>1])){break Ka}if(Bb(z[d+450>>1])>>>0>=z[a+480188>>1]){break Ka}Te(d,3,f);x[31609]=0;c=d+12|0;O(218,c|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break Ia}im(((Bb(z[d+450>>1])<<5)+a|0)+480289|0,c);tb(c)}b=b+1|0;continue}break}break ya}break ya}break ya}a=N()|0;break ua}a=N()|0;ub(d+36|0);break ua}ub(d+36|0);Rc(d+344|0);Rc(d+772|0);Rc(d+784|0);Rc(d+796|0);f=1;break q}a=N()|0;break ua}Qf(d+24|0);continue}}a=N()|0}Rc(d+344|0);break k}a=N()|0;break m}b=0;while(1){if(y[d+445|0]<=b>>>0){break ha}x[31609]=0;i=d+36|0;O(398,g|0,i|0);f=x[31609];x[31609]=0;La:{Ma:{if((f|0)!=1){v[d|0]=0;v[d+1|0]=2;v[d+2|0]=1;v[d+3|0]=2;C=d,E=(Bb(z[d+484>>1])|0)!=0,v[C+32|0]=E;C=d,E=(Bb(z[d+486>>1])|0)!=0,v[C+33|0]=E;C=d,E=(Bb(z[d+488>>1])|0)!=0,v[C+34|0]=E;C=d,E=h&(Bb(z[d+490>>1])|0)!=0,v[C+35|0]=E;if(!y[(d+32|0)+b|0]|b>>>0>3){break La}f=(b|0)!=3;if(!f&(v[e+100|0]&1)){break La}x[31609]=0;m=i;i=y[b+d|0];S(399,m|0,e|0,i|0);m=x[31609];x[31609]=0;if((m|0)==1){break Ma}if(!f){v[e+100|0]=y[e+100|0]|16}Na:{switch(i|0){case 0:if(Bb(y[d+48|0]|y[d+49|0]<<8)&1){f=Bb(y[d+46|0]|y[d+47|0]<<8)&32767}else{f=0}x[e>>2]=f;break La;case 2:break Na;default:break La}}if(!(Bb(y[d+48|0]|y[d+49|0]<<8)&2)){break La}C=d,E=Bb(y[d+42|0]|y[d+43|0]<<8),w[C+28>>1]=E;w[d+24>>1]=1;f=z[qe(d+28|0,d+24|0)>>1];i=ti(Bc(((Bb(y[d+38|0]|y[d+39|0]<<8)<<6|48)>>>0)/100|0,0));C=d,E=Bb(y[d+40|0]|y[d+41|0]<<8),w[C+28>>1]=E;w[d+24>>1]=1;m=Eh(256/z[qe(d+28|0,d+24|0)>>1]|0);q=z[d+448>>1];t=y[d+44|0]|y[d+45|0]<<8;x[31609]=0;r=Bb(q);q=Bb(t);ja(400,a|0,r|0,y[(q>>>0<6?q:0)+24992|0],255/(f>>>0)|0,i|0,m|0);f=x[31609];x[31609]=0;if((f|0)!=1){break La}a=N()|0;break m}a=N()|0;break m}a=N()|0;break m}b=b+1|0;continue}}Qf(d+12|0);continue}}ke(d+808|0);ub(n)}fb=d+1120|0;return f|0}a=N()|0}Rc(d+760|0);break k}a=N()|0}Rc(d+772|0);break i}a=N()|0}Rc(d+784|0);break g}a=N()|0}Rc(d+796|0);break c}a=N()|0;break c}a=N()|0;break c}a=N()|0;ub(d+36|0)}ke(d+808|0)}ub(n)}Q(a|0);p()}function sja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0;m=fb-1168|0;fb=m;yc(b);a:{b:{c:{d:{d=m+1144|0;e:{if(!ns(b,d)){break e}if(!vR(d)){break e}if((y[m+1152|0]|y[m+1153|0]<<8|(y[m+1154|0]<<16|y[m+1155|0]<<24))!=(Lh(x[b>>2])|0)){break e}if((y[m+1160|0]|y[m+1161|0]<<8|(y[m+1162|0]<<16|y[m+1163|0]<<24))!=(jf(b)|0)){break e}g=1;if((c|0)==64){break e}g=0;d=m+1088|0;Rb(d,0,56);e=-2;f:{if(!d){break f}x[d+44>>2]=0;x[d+48>>2]=0;x[d+52>>2]=0;x[d+20>>2]=0;x[d+24>>2]=0;x[d+8>>2]=0;h=x[d+32>>2];if(!h){x[d+32>>2]=1214;h=1214}if(!x[d+36>>2]){x[d+36>>2]=1215}h=ib[h|0](x[d+40>>2],1,43784)|0;e=-4;if(!h){break f}x[d+28>>2]=h;x[h+43780>>2]=1;x[h+10992>>2]=0;x[h+10996>>2]=0;x[h>>2]=0;x[h+11008>>2]=15;x[h+11e3>>2]=1;x[h+11004>>2]=0;e=0}if(e){break e}g=y[m+1160|0]|y[m+1161|0]<<8|(y[m+1162|0]<<16|y[m+1163|0]<<24);x[m+1084>>2]=g;K=y[m+1164|0]|y[m+1165|0]<<8|(y[m+1166|0]<<16|y[m+1167|0]<<24);T=NZ(m+1072|0,K);while(1){if(!(!K|!g|(f|0)==1)){x[m+32>>2]=1024;h=m+48|0;f=m+32|0;V=x[Hb(f,m+1084|0)>>2];d=Zb(m+40|0,h,V);g=x[d>>2];d=x[d+4>>2];x[31609]=0;Zn(159,f,b,g,d);f=x[31609];x[31609]=0;if((f|0)==1){break b}g=h;f=V;d=aa^-1;while(1){if(f>>>0<4){while(1){if(f){d=x[(((y[g|0]^d)&255)<<2)+79312>>2]^d>>>8;f=f-1|0;g=g+1|0;continue}break}aa=d^-1}else{d=x[(((y[g|0]^d)&255)<<2)+79312>>2]^d>>>8;d=d>>>8^x[(((d^y[g+1|0])&255)<<2)+79312>>2];d=d>>>8^x[(((d^y[g+2|0])&255)<<2)+79312>>2];d=d>>>8^x[(((d^y[g+3|0])&255)<<2)+79312>>2];f=f-4|0;g=g+4|0;continue}break}x[m+1092>>2]=V;x[m+1088>>2]=h;x[m+1104>>2]=K;x[m+1100>>2]=x[T>>2]+ba;C=fb-16|0;fb=C;d=-2;q=m+1088|0;g:{if(!q){break g}i=x[q+28>>2];if(!i){break g}da=x[q+4>>2];x[i+11e3>>2]=0;h:{if(x[i+43780>>2]<0){break h}if(x[i+11004>>2]){break g}g=x[i+11008>>2];d=0;x[i+11004>>2]=0;f=x[i+10996>>2];if(!f){X=(g|0)>0?11:10;J=i+11012|0;h=x[q+4>>2];g=x[i+10992>>2];while(1){x[C+12>>2]=h;x[C+8>>2]=32768-g;B=x[q>>2];h=0;E=0;F=0;G=0;L=0;W=0;M=0;Y=0;Z=fb-144|0;fb=Z;i:{j:{O=g+J|0;if(O>>>0>=J>>>0){H=x[C+8>>2]+O|0;I=H-J|0;$=(J^-1)+H|0;if(!(I&$)){break j}}x[C+8>>2]=0;x[C+12>>2]=0;l=-3;break i}k=x[C+12>>2];t=k+B|0;P=x[i+60>>2];s=x[i+40>>2];f=x[i+36>>2];r=x[i+32>>2];g=x[i+56>>2];e=x[i+4>>2];l=-1;n=O;j=B;o=-1;k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{u=x[i>>2];switch(u|0){case 10:case 17:case 21:case 35:case 36:case 37:case 39:break m;case 2:break s;case 53:break w;case 26:break y;case 25:break z;case 24:break A;case 23:break B;case 18:break C;case 16:break D;case 14:break E;case 51:break H;case 6:break I;case 3:break J;case 34:break K;case 42:break L;case 41:break M;case 32:break N;case 27:break O;case 11:break P;case 38:break Q;case 9:break R;case 52:break S;case 7:break T;case 5:break U;case 1:break V;case 0:break W;default:break l}}x[i+28>>2]=1;g=0;x[i+8>>2]=0;x[i+12>>2]=0;x[i+16>>2]=1;s=0;f=0;r=0;e=0;if(X&1){break V}break r}if((k|0)<=0){l=1;x[i>>2]=1;break k}x[i+8>>2]=y[B|0];j=B+1|0;break s}if((k|0)<=0){break t}W=e+8|0;j=B+1|0;g=y[B|0]<<e|g;d=2;break q}d=4;break q}M=g;break G}d=7;break q}d=8;break q}E=f;break F}F=g;break x}l=1;if((k|0)<=0){break u}e=e+8|0;j=B+1|0;break p}h=f;d=e;break v}k=2;break o}o=0;u=34;break m}d=1;break q}d=3;break q}d=5;break q}d=6;break q}d=9;break q}d=10;break q}d=11;break q}d=12;break q}d=13;break q}d=14;break q}d=15;break q}d=16;break q}d=17;break q}d=18;break q}k=1;break o}x[i>>2]=32;break k}x[i>>2]=5;l=1;break k}if(j>>>0>=t>>>0){x[i>>2]=2;l=1;break k}f=y[j|0];x[i+12>>2]=f;j=j+1|0;u=36;d=x[i+8>>2];h=256<<(d>>>4);if(h>>>0>32768|h>>>0>I>>>0|(((f|d<<8)>>>0)%31|f&32)){break n}f=0;if((d&15)!=8){break n}}d=0}X:while(1){Y:{Z:{_:{$:{aa:{ba:{ca:{da:{ea:{fa:{ga:{ha:{ia:{ja:{ka:{la:{ma:{na:{oa:{pa:{qa:{ra:{sa:{ta:{ua:{va:{wa:{xa:{ya:{za:{Aa:{Ba:{Ca:{Da:{switch(d|0){case 0:if(e>>>0>2){break Ca}d=1;continue;case 9:break ha;case 10:break ia;case 11:break ja;case 12:break ka;case 13:break la;case 14:break ma;case 15:break na;case 16:break oa;case 17:break pa;case 8:break va;case 7:break wa;case 6:break xa;case 5:break ya;case 4:break za;case 3:break Aa;case 2:break Ba;case 1:break Da;default:break qa}}while(1){if(j>>>0>=t>>>0){x[i>>2]=3;l=1;break k}g=y[j|0]<<e|g;j=j+1|0;e=e+8|0;if(e>>>0<3){continue}break}}d=g&7;x[i+20>>2]=d;h=d>>>1|0;x[i+24>>2]=h;e=e-3|0;g=g>>>3|0;if(d>>>0>=2){break ua}W=e;break ra}e=W&-8;g=g>>>(W&7)|0;f=0;d=0;break ta}while(1){if(j>>>0>=t>>>0){x[i>>2]=6;l=1;break k}g=y[j|0]<<e|g;d=e>>>0>4294967287;j=j+1|0;e=e+8|0;if(d){continue}break}d=1;break ta}if(j>>>0>=t>>>0){x[i>>2]=7;l=1;break k}v[(f+i|0)+10528|0]=y[j|0];j=j+1|0;d=2;break ta}while(1){if(j>>>0>=t>>>0){x[i>>2]=51;l=1;break k}g=y[j|0]<<e|g;d=e>>>0>4294967287;j=j+1|0;e=e+8|0;if(d){continue}break}break $}if(n>>>0<H>>>0){v[n|0]=r;f=f-1|0;n=n+1|0;g=M;break aa}o=2;u=52;g=M;break m}if(n>>>0<H>>>0){break sa}o=2;u=9;break m}if(j>>>0<t>>>0){d=H-n|0;h=t-j|0;d=d>>>0<h>>>0?d:h;d=d>>>0<f>>>0?d:f;f=f-d|0;n=zc(n,j,d)+d|0;j=d+j|0;break _}x[i>>2]=38;l=1;break k}o=-1;u=10;E=0;Ea:{switch(h-1|0){case 0:x[i+44>>2]=288;x[i+48>>2]=32;d=i+3552|0;x[d>>2]=84215045;x[d+4>>2]=84215045;d=i+3560|0;x[d>>2]=84215045;x[d+4>>2]=84215045;d=i+3568|0;x[d>>2]=84215045;x[d+4>>2]=84215045;d=i+3576|0;x[d>>2]=84215045;x[d+4>>2]=84215045;d=i- -64|0;h=0;while(1){k=144;if((h|0)==144){while(1){h=256;if((k|0)==256){while(1){k=280;if((h|0)==280){while(1){if((k|0)==288){break ea}v[d|0]=8;k=k+1|0;d=d+1|0;continue}}else{v[d|0]=7;h=h+1|0;d=d+1|0;continue}}}else{v[d|0]=9;k=k+1|0;d=d+1|0;continue}}}else{v[d|0]=8;h=h+1|0;d=d+1|0;continue}};case 2:break m;default:break Ea}}d=0;break ga}while(1){Fa:{Ga:{Ha:{Ia:{Ja:{Ka:{switch(d|0){case 0:if(f>>>0>3){break Ja}if(!e){e=0;break Ia}if(e>>>0>7){break Ga}d=3;continue X;case 1:v[(f+i|0)+10528|0]=g;e=e-8|0;g=g>>>8|0;break Fa;default:break Ka}}f=f+1|0;break Ha}f=z[i+10528>>1];if((f^z[i+10530>>1])==65535){break aa}u=39;o=-1;break m}d=4;continue X}d=0;continue}d=1;continue}d=2;continue}}d=8;continue}d=2;continue}if(n>>>0<H>>>0){v[n|0]=y[(P-r&$)+J|0];n=n+1|0;P=P+1|0;d=7;break ba}o=2;u=53;break m}while(1){if(j>>>0>=t>>>0){x[i>>2]=27;l=1;g=F;break k}F=y[j|0]<<e|F;j=j+1|0;e=e+8|0;if(s>>>0>e>>>0){continue}break}d=6;break ba}if(j>>>0>=t>>>0){x[i>>2]=26;l=1;break k}g=y[j|0]<<e|g;j=j+1|0;e=e+8|0;d=4;if(e>>>0<15){break ba}d=5;break ba}while(1){if(j>>>0>=t>>>0){x[i>>2]=25;l=1;break k}g=y[j|0]<<e|g;j=j+1|0;e=e+8|0;if(s>>>0>e>>>0){continue}break}d=3;break ba}if(n>>>0>=H>>>0){o=2;u=24;break m}v[n|0]=f;n=n+1|0;break ca}if(j>>>0>=t>>>0){x[i>>2]=23;l=1;break k}g=y[j|0]<<e|g;j=j+1|0;e=e+8|0;d=0;if(e>>>0<15){break ba}d=1;break ba}while(1){if(j>>>0>=t>>>0){x[i>>2]=18;l=1;break k}g=y[j|0]<<e|g;j=j+1|0;e=e+8|0;if(s>>>0>e>>>0){continue}break}Y=r-16|0;d=3;break da}if(j>>>0>=t>>>0){x[i>>2]=16;l=1;break k}g=y[j|0]<<e|g;j=j+1|0;e=e+8|0;d=1;if(e>>>0<15){break da}d=2;break da}while(1){if(j>>>0>=t>>>0){x[i>>2]=14;l=1;break k}g=y[j|0]<<e|g;j=j+1|0;e=e+8|0;if(e>>>0<3){continue}break}d=1;break fa}d=E+22273|0;while(1){if(j>>>0>=t>>>0){x[i>>2]=11;l=1;f=E;break k}g=y[j|0]<<e|g;j=j+1|0;e=e+8|0;L=v[d|0];if(e>>>0<L>>>0){continue}break}d=1}while(1){La:{Ma:{Na:{if(!d){if(E>>>0>2){break Na}L=v[E+22273|0];if(L>>>0<=e>>>0){break La}d=9;continue X}d=E<<2;x[(d+i|0)+44>>2]=x[d+80848>>2]+((-1<<L^-1)&g);E=E+1|0;e=e-L|0;g=g>>>L|0;break Ma}f=0;Rb(i+7040|0,0,288);d=0;break fa}d=0;continue}d=1;continue}}while(1){Oa:{Pa:{Qa:{if(!d){if(A[i+52>>2]<=f>>>0){break Qa}if(e>>>0>2){break Oa}d=10;continue X}v[(y[f+80864|0]+i|0)+7040|0]=g&7;f=f+1|0;e=e-3|0;g=g>>>3|0;break Pa}x[i+52>>2]=19;break ea}d=0;continue}d=1;continue}}G=x[i+24>>2];d=0}while(1){Ra:{Sa:{Ta:{Ua:{Va:{Wa:{Xa:{Ya:{Za:{switch(d|0){case 0:d=0;if((G|0)<0){break ca}I=Rb(Z,0,64);h=D(G,3488)+i|0;Rb(h+352|0,0,3200);ca=h- -64|0;R=x[i+24>>2];k=x[((R<<2)+i|0)+44>>2];while(1){if((d|0)!=(k|0)){h=(y[d+ca|0]<<2)+I|0;x[h>>2]=x[h>>2]+1;d=d+1|0;continue}break};x[I+64>>2]=0;x[I+68>>2]=0;l=0;d=1;h=0;while(1){if((d|0)!=16){o=d<<2;d=d+1|0;o=x[o+I>>2];h=o+h<<1;x[(I- -64|0)+(d<<2)>>2]=h;l=l+o|0;continue}break};S=0;o=-1;if((h|0)!=65536){u=35;if(l>>>0>1){break m}}while(1){if(k>>>0>S>>>0){l=y[S+ca|0];_a:{if(!l){break _a}d=(I- -64|0)+(l<<2)|0;h=x[d>>2];x[d>>2]=h+1;d=0;k=l;while(1){if(k){d=h&1|d<<1;h=h>>>1|0;k=k-1|0;continue}break}if(l>>>0<=10){h=1<<l;l=l<<9|S;while(1){if(d>>>0>1023){break _a}w[((D(G,3488)+i|0)+(d<<1)|0)+352>>1]=l;d=d+h|0;continue}}h=(D(G,3488)+i|0)+((d&1023)<<1)|0;k=w[h+352>>1];$a:{if(k){h=o;o=k;break $a}w[h+352>>1]=o;h=o-2|0}d=d>>>9|0;while(1){d=d>>>1|0;k=d&1;if(l>>>0>=12){k=((D(G,3488)+i|0)+(k+(o^-1)<<1)|0)+2400|0;o=w[k>>1];if(!o){w[k>>1]=h;o=h;h=h-2|0}l=l-1|0;continue}break}w[((D(G,3488)+i|0)+(k+(o^-1)<<1)|0)+2400>>1]=S;o=h}S=S+1|0;R=x[i+24>>2];k=x[((R<<2)+i|0)+44>>2];continue}break};d=0;if((R|0)!=2){break Sa}break Wa;case 1:d=w[(((g&1023)<<1)+i|0)+7328>>1];ab:{if((d|0)>=0){if(d>>>0<512|d>>>9>>>0>e>>>0){break ab}break Va}if(e>>>0<11){break ab}k=10;while(1){d=w[(((g>>>k&1)+(d^-1)<<1)+i|0)+9376>>1];if((d|0)<0){h=k+2|0;k=k+1|0;if(e>>>0>=h>>>0){continue}}break}if((d|0)>=0){break Va}}d=11;continue X;case 2:r=w[(((g&1023)<<1)+i|0)+7328>>1];if((r|0)>=0){break Ya}d=10;while(1){h=g>>>d|0;d=d+1|0;r=w[(((h&1)+(r^-1)<<1)+i|0)+9376>>1];if((r|0)<0){continue}break};break Xa;default:break Za}}d=v[Y+18468|0]+((-1<<s^-1)&g)|0;e=e-s|0;g=g>>>s|0;h=f+i|0;Rb(h+10532|0,(r|0)==16?y[h+10531|0]:0,d);d=d+f|0;break Wa}d=r>>>9|0;r=r&511}e=e-d|0;g=g>>>d|0;if(r>>>0>15){break Ua}v[(f+i|0)+10532|0]=r;d=f+1|0}h=x[i+48>>2];f=x[i+44>>2];l=h+f|0;if(l>>>0<=d>>>0){break Ta}if(e>>>0<=14){if((t-j|0)<=1){f=d;d=1;continue}g=y[j|0]<<e|y[j+1|0]<<e+8|g;j=j+2|0;e=e|16}f=d}d=2;continue}if(!((r|0)!=16|f)){f=0;u=17;r=16;o=-1;break m}Y=r-16|0;s=v[r+22253|0];if(s>>>0<=e>>>0){break Ra}d=12;continue X}if((d|0)!=(l|0)){u=21;f=d;o=-1;break m}l=i+10532|0;zc(i- -64|0,l,f);zc(i+3552|0,f+l|0,h);R=x[i+24>>2];f=d}G=R-1|0;x[i+24>>2]=G;d=0;continue}d=3;continue}}d=2}bb:while(1){cb:{db:{eb:{fb:{gb:{hb:{ib:{jb:{kb:{lb:{mb:{nb:{ob:{pb:{qb:{rb:{switch(d|0){case 0:d=w[(((g&1023)<<1)+i|0)+352>>1];sb:{if((d|0)>=0){if(d>>>0<512|d>>>9>>>0>e>>>0){break sb}break cb}if(e>>>0<11){break sb}k=10;while(1){d=w[(((g>>>k&1)+(d^-1)<<1)+i|0)+2400>>1];if((d|0)<0){h=k+2|0;k=k+1|0;if(e>>>0>=h>>>0){continue}}break}if((d|0)>=0){break cb}}d=13;continue X;case 1:f=w[(((g&1023)<<1)+i|0)+352>>1];if((f|0)>=0){break qb}d=10;while(1){h=g>>>d|0;d=d+1|0;f=w[(((h&1)+(f^-1)<<1)+i|0)+2400>>1];if((f|0)<0){continue}break};break pb;case 3:break fb;case 4:break gb;case 5:break lb;case 6:break mb;case 2:break rb;default:break nb}}while(1){d=t-j|0;if(!((H-n|0)>1&(d|0)>=4)){if(e>>>0>14){break cb}if((d|0)<=1){d=0;continue bb}g=y[j|0]<<e|y[j+1|0]<<e+8|g;e=e|16;j=j+2|0;break cb}if(!(e>>>0>14)){g=(y[j|0]|y[j+1|0]<<8)<<e|g;j=j+2|0;e=e|16}l=e;f=w[(((g&1023)<<1)+i|0)+352>>1];tb:{if((f|0)<0){d=10;while(1){h=g>>>d|0;d=d+1|0;f=w[(((h&1)+(f^-1)<<1)+i|0)+2400>>1];if((f|0)<0){continue}break}break tb}d=f>>>9|0}e=l-d|0;g=g>>>d|0;if(f&256){break ob}if(!(e>>>0>14)){g=(y[j|0]|y[j+1|0]<<8)<<e|g;j=j+2|0;e=e|16}l=e;k=w[(((g&1023)<<1)+i|0)+352>>1];ub:{if((k|0)<0){d=10;while(1){h=g>>>d|0;d=d+1|0;k=w[(((h&1)+(k^-1)<<1)+i|0)+2400>>1];if((k|0)<0){continue}break}break ub}d=k>>>9|0}v[n|0]=f;e=l-d|0;g=g>>>d|0;if(!(k&256)){v[n+1|0]=k;n=n+2|0;continue}break}n=n+1|0;f=k;break ob}d=f>>>9|0;f=f&511}e=e-d|0;g=g>>>d|0;if(f>>>0>255){break ob}d=14;continue X}h=f&511;f=256;if((h|0)==256){break Z}d=h-257<<2;f=x[d+80336>>2];s=0;if(h-285>>>0<4294967276){break eb}s=x[d+80464>>2];if(s>>>0>e>>>0){d=15;continue X}d=3;continue}if(!f){f=-1;break jb}f=f-1|0;d=18;continue X}e=e-s|0;g=F>>>s|0;r=((-1<<s^-1)&F)+r|0;break kb}d=w[(((g&1023)<<1)+i|0)+3840>>1];vb:{if((d|0)<0){k=10;while(1){h=g>>>k|0;k=k+1|0;d=w[(((h&1)+(d^-1)<<1)+i|0)+5888>>1];if((d|0)<0){continue}break}break vb}k=d>>>9|0;d=d&511}e=e-k|0;F=g>>>k|0;h=d<<2;r=x[h+80592>>2];s=0;if(d-30>>>0<4294967270){g=F;break kb}s=x[h+80720>>2];if(s>>>0<=e>>>0){break ib}d=17;continue X}P=n-J|0;d=(P-r&$)+J|0;if((d>>>0<n>>>0?n:d)+f>>>0>H>>>0){break hb}while(1){if(f>>>0>=3){v[n|0]=y[d|0];v[n+1|0]=y[d+1|0];v[n+2|0]=y[d+2|0];f=f-3|0;d=d+3|0;n=n+3|0;continue}break}if(!f){f=0;break jb}v[n|0]=y[d|0];if((f|0)!=1){v[n+1|0]=y[d+1|0]}n=f+n|0}d=2;continue}d=6;continue}d=7;continue}d=w[(((g&1023)<<1)+i|0)+3840>>1];wb:{if((d|0)>=0){if(d>>>0<512|d>>>9>>>0>e>>>0){break wb}break db}if(e>>>0<11){break wb}k=10;while(1){d=w[(((g>>>k&1)+(d^-1)<<1)+i|0)+5888>>1];if((d|0)<0){h=k+2|0;k=k+1|0;if(e>>>0>=h>>>0){continue}}break}if((d|0)>=0){break db}}d=16;continue X}e=e-s|0;f=((-1<<s^-1)&g)+f|0;g=g>>>s|0}if(e>>>0>14){break db}if((t-j|0)<=1){d=4;continue}g=y[j|0]<<e|y[j+1|0]<<e+8|g;e=e|16;j=j+2|0}d=5;continue}d=1;continue}}if(!f|!e){break _}if(e>>>0>7){break $}d=5;continue}e=e-8|0;M=g>>>8|0;r=g&255;d=6;continue}if(f){break Y}f=0}if(v[i+20|0]&1){break p}d=0;continue}d=7;continue}}g=0;d=e>>>3|0;h=j-B|0;h=h>>>0<=j>>>0?h:0;d=d>>>0<h>>>0?d:h;if((e&-8)==d<<3){j=j-d|0;u=34;h=0;d=0;e=0;o=0;if(!(X&1)){break m}k=0;break o}_(6874,13252,2797,6884);p()}while(1){xb:{yb:{zb:{Ab:{Bb:{switch(k|0){case 0:if(h>>>0>3){o=0;u=34;f=h;e=d;break m}e=0;if(!d){f=h;break xb}if(d>>>0>7){break Ab}k=1;continue;case 1:break Bb;default:break zb}}while(1){if(j>>>0>=t>>>0){x[i>>2]=41;l=1;f=h;e=d;break k}g=y[j|0]<<d|g;l=d>>>0>4294967287;j=j+1|0;d=d+8|0;if(l){continue}break}}k=g&255;g=g>>>8|0;d=d-8|0;break yb}if(j>>>0>=t>>>0){x[i>>2]=42;l=1;break k}k=y[j|0];j=j+1|0;h=f;d=e}x[i+16>>2]=x[i+16>>2]<<8|k;h=h+1|0;k=0;continue}k=2;continue}}f=1}x[i>>2]=u;l=o}d=e>>>3|0;h=j-B|0;h=h>>>0<=j>>>0?h:0;d=d>>>0<h>>>0?d:h;j=j-d|0;e=e-(d<<3)|0}x[i+4>>2]=e;x[i+60>>2]=P;x[i+40>>2]=s;x[i+36>>2]=f;x[i+32>>2]=r;x[i+56>>2]=(((e&63)>>>0<32?-1<<e:0)^-1)&g;x[C+12>>2]=j-B;e=n-O|0;x[C+8>>2]=e;if((l|0)<0){break i}j=(e>>>0)%5552|0;f=x[i+28>>2];g=f>>>16|0;k=f&65535;Cb:while(1){Db:{h=0;if(!e){break Db}d=O;while(1)if((h|7)>>>0>=j>>>0){h=j&8184;while(1){if((h|0)!=(j|0)){h=h+1|0;k=y[d|0]+k|0;g=k+g|0;d=d+1|0;continue}break}e=e-j|0;g=(g>>>0)%65521|0;k=(k>>>0)%65521|0;O=j+O|0;j=5552;continue Cb}else{f=y[d|0]+k|0;o=f+y[d+1|0]|0;F=o+y[d+2|0]|0;M=F+y[d+3|0]|0;E=M+y[d+4|0]|0;n=E+y[d+5|0]|0;B=n+y[d+6|0]|0;k=B+y[d+7|0]|0;g=k+(B+(n+(E+(M+(F+(o+(g+f|0)|0)|0)|0)|0)|0)|0)|0;d=d+8|0;h=h+8|0;continue}}break}f=g<<16|k;x[i+28>>2]=f;if(l){break i}l=0;if(!(X&1)){break i}l=(f|0)!=x[i+16>>2]?-2:0}fb=Z+144|0;x[i+43780>>2]=l;f=x[C+12>>2];x[q>>2]=f+x[q>>2];x[q+4>>2]=x[q+4>>2]-f;x[q+8>>2]=f+x[q+8>>2];x[q+48>>2]=x[i+28>>2];f=x[C+8>>2];x[i+10996>>2]=f;d=x[q+16>>2];f=d>>>0>f>>>0?f:d;zc(x[q+12>>2],x[i+10992>>2]+J|0,f);x[q+12>>2]=f+x[q+12>>2];x[q+16>>2]=x[q+16>>2]-f;x[q+20>>2]=f+x[q+20>>2];e=x[i+10996>>2];x[i+10996>>2]=e-f;g=f+x[i+10992>>2]&32767;x[i+10992>>2]=g;if((l|0)<0){break h}if(!((l|0)!=1|da)){d=-5;break g}if(l){d=0;h=x[q+4>>2];if(!h|!x[q+16>>2]){break g}if((e|0)==(f|0)){continue}break g}break}d=(e|0)==(f|0);break g}g=x[q+16>>2];f=g>>>0>f>>>0?f:g;zc(x[q+12>>2],(x[i+10992>>2]+i|0)+11012|0,f);x[q+12>>2]=f+x[q+12>>2];x[q+16>>2]=x[q+16>>2]-f;x[q+20>>2]=f+x[q+20>>2];g=x[i+10996>>2];x[i+10996>>2]=g-f;x[i+10992>>2]=f+x[i+10992>>2]&32767;if(x[i+43780>>2]){break g}d=(g|0)==(f|0);break g}d=-3}fb=C+16|0;f=d;g=x[m+1084>>2]-V|0;x[m+1084>>2]=g;d=K+ba|0;K=x[m+1104>>2];ba=d-K|0;continue}break}b=m+1088|0;Eb:{if(!b){break Eb}d=x[b+28>>2];if(!d){break Eb}ib[x[b+36>>2]](x[b+40>>2],d);x[b+28>>2]=0}g=0;if(!((y[m+1156|0]|y[m+1157|0]<<8|(y[m+1158|0]<<16|y[m+1159|0]<<24))!=(aa|0)|(f|0)!=1|K)){se(m+24|0,x[T>>2],x[T+4>>2]);b=Md(m+16|0);x[31609]=0;f=x[b+4>>2];x[m+8>>2]=x[b>>2];x[m+12>>2]=f;b=hg(555,m+48|0,x[m+24>>2],x[m+28>>2],m+8|0);f=x[31609];x[31609]=0;if((f|0)==1){break d}x[31609]=0;g=U(913,a|0,b|0,c|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}ub(b)}ec(T)}fb=m+1168|0;return g|0}a=N()|0;break a}a=N()|0;ub(b);break a}a=N()|0}ec(T);Q(a|0);p()}function rqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=E(0),A=0,C=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=E(0),O=E(0),P=0,S=0,V=0,W=0,Z=0,_=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=E(0),na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=E(0);s=fb-96|0;fb=s;yc(c);a:{while(1){b:{if(!Mb(x[c>>2],x[c+8>>2],4)){break b}h=s+76|0;d=fb-16|0;fb=d;c:{if(!Mb(x[c>>2],x[c+8>>2],3)){F=0;while(1){if((F|0)!=3){dh(h+F|0);F=F+1|0;continue}break}break c}ex(d+8|0,h);sd(d,c,x[d+8>>2],x[d+12>>2])}fb=d+16|0;d:{e:{if(!jd(h,15110,3)){h=s+32|0;d=fb-16|0;fb=d;f:{if(!Mb(x[c>>2],x[c+8>>2],7)){F=0;while(1){if((F|0)!=7){dh(h+F|0);F=F+1|0;continue}break}break f}Ir(d+8|0,h);sd(d,c,x[d+8>>2],x[d+12>>2])}fb=d+16|0;F=0;h=3;while(1){if((h|0)==7){break d}d=v[(s+32|0)+h|0];if((d|0)<0){break e}h=h+1|0;F=d&255|F<<7;continue}}g:{if(jd(s+76|0,14256,3)){break g}if(!cY(c,13691)){break g}Vb(c,Rg(c)+16|0);continue}d=s+76|0;if(!jd(d,28558,3)){continue}if(!jd(d,28562,3)){continue}if(!y[s+76|0]){Ih(c,2);continue}if(tV(s+76|0)){break b}}h=0;break a}Vb(c,F);continue}break}yc(c);d=s+76|0;wD(d,c);W=x[s+76>>2];c=Ze(d);P=Nb(s- -64|0);x[31609]=0;ca=R(592,s+60|0)|0;d=x[31609];x[31609]=0;h:{i:{j:{if((d|0)!=1){IB(Rb(x[ca>>2],0,6668));x[s+48>>2]=0;x[s+52>>2]=0;x[s+40>>2]=0;x[s+44>>2]=0;x[s+32>>2]=0;x[s+36>>2]=0;x[31609]=0;da=R(593,s+20|0)|0;d=x[31609];x[31609]=0;k:{if((d|0)!=1){F=0;while(1){G=x[ca>>2];g=Gc(W,aa);Z=x[da>>2];L=s+32|0;d=0;m=0;r=fb-17152|0;fb=r;x[r+17148>>2]=0;l:{m:{n:{if(y[G+6152|0]!=255|(g|0)<5){break n}if(!jq(G+6152|0,c)){break n}h=mz(y[c+1|0],y[c+2|0],x[G+6148>>2])+hq(c)|0;x[r+17148>>2]=h;if((g|0)==(h|0)){h=g;break m}o:{if((g|0)>=(h+4|0)){if(jq(c,c+h|0)){break o}}x[r+17148>>2]=0;break n}if(h){break m}}e=c;A=Rb(G,0,6668)+6148|0;q=r+17148|0;n=g-4|0;I=(n|0)>0?n:0;while(1){p:{q:{r:{s:{if((m|0)==(I|0)){m=g;break s}if(!ZL(e)){break q}k=mz(y[e+1|0],y[e+2|0],x[A>>2]);h=k+hq(e)|0;i=4;l=m+4|0;t:{while(1){if(!(i>>>0>2303|k)){if((n|0)<=((i<<1)+m|0)){break t}k=0;j=e+i|0;u:{if(!jq(e,j)){break u}f=i-hq(e)|0;o=hq(j)+f|0;if((g|0)<(o+(i+l|0)|0)){break u}if(!jq(e,j+o|0)){break u}x[A>>2]=f;k=f;h=i}i=i+1|0;continue}break}if(!k|(g|0)<(h+m|0)){break t}l=g-m|0;i=0;f=0;while(1){v:{w:{if((f|0)!=10){j=(f|0)!=0;K=i;i=e+i|0;i=(K+mz(y[i+1|0],y[i+2|0],k)|0)+hq(i)|0;if((l|0)<(i+4|0)){break v}if(jq(e,e+i|0)){break w}j=0}else{j=1}break v}f=f+1|0;continue}break}if(!j){break t}d=h;break s}if((g|0)!=(h|0)|m){break r}m=0;d=g}x[q>>2]=d;d=m;break p}x[A>>2]=0}e=e+1|0;m=m+1|0;continue}break}h=x[r+17148>>2];if((g|0)>=(d+h|0)?h:0){break m}x[L>>2]=d;o=0;break l}C=c+d|0;x[G+6152>>2]=y[C|0]|y[C+1|0]<<8|(y[C+2|0]<<16|y[C+3|0]<<24);x[L+4>>2]=d;x[L>>2]=d+h;x[L+8>>2]=y[C+3|0]>191?1:2;sa=L,ta=aM(y[C+1|0],y[C+2|0]),x[sa+12>>2]=ta;x[L+16>>2]=4-(y[C+1|0]>>>1&3);sa=L,ta=lz(y[C+1|0],y[C+2|0]),x[sa+20>>2]=ta;if(!Z){o=kz(y[C+1|0]);break l}d=r+17136|0;$L(d,C+4|0,h-4|0);if(!(v[C+1|0]&1)){ve(d,16)}x:{if(x[L+16>>2]==3){o=0;d=r+17136|0;ja=r+3728|0;e=ja;m=0;h=y[C+1|0];f=D((h>>>3&1)+(h>>>4&1)|0,3)+(y[C+2|0]>>>2&3)|0;f=f-((f|0)!=0)|0;i=y[C+3|0]>191?1:2;y:{if(h&8){j=ve(d,9);i=i<<1;m=ve(d,i+7|0);break y}j=ve(d,i|8)>>>i|0}h=D(f,40);A=h+81184|0;n=h+81504|0;q=D(f,23)+80992|0;h=-1;f=0;z:{while(1){g=y[C+3|0];I=ve(d,12);w[e+4>>1]=I;k=ve(d,9);w[e+6>>1]=k;if((k&65535)>>>0>288){break z}k=g>>>0>191?m<<4:m;sa=e,ta=ve(d,8),v[sa+10|0]=ta;g=ve(d,y[C+1|0]&8?4:9);v[e+13|0]=22;v[e+14|0]=0;x[e>>2]=q;w[e+8>>1]=g;A:{if(ve(d,1)){g=ve(d,2);v[e+11|0]=g;if(!(g&255)){break z}g=ve(d,1);w[e+18>>1]=65287;v[e+12|0]=g;if(y[e+11|0]==2){B:{if(!(g&255)){x[e>>2]=A;v[e+18|0]=8;m=0;g=39;break B}x[e>>2]=n;m=y[C+1|0]&8?8:6;g=30}v[e+14|0]=g;v[e+13|0]=m;k=k&3855}g=ve(d,10);sa=e,ta=ve(d,3),v[sa+21|0]=ta;sa=e,ta=ve(d,3),v[sa+22|0]=ta;sa=e,ta=ve(d,3),v[sa+23|0]=ta;m=g<<5;break A}v[e+11|0]=0;v[e+12|0]=0;m=ve(d,15);sa=e,ta=ve(d,4),v[sa+18|0]=ta;g=ve(d,3);v[e+20|0]=255;v[e+19|0]=g}v[e+17|0]=m&31;v[e+15|0]=m>>>10;v[e+16|0]=m>>>5&31;f=(I&65535)+f|0;C:{if(y[C+1|0]&8){g=ve(d,1);break C}g=z[e+8>>1]>499}v[e+24|0]=g;sa=e,ta=ve(d,1),v[sa+25|0]=ta;g=ve(d,1);v[e+27|0]=k>>>12&15;v[e+26|0]=g;e=e+28|0;m=k<<4;i=i-1|0;if(i){continue}break}h=(x[d+4>>2]+f|0)>(x[d+8>>2]+(j<<3)|0)?-1:j}if(!((h|0)<0|x[r+17140>>2]>x[r+17144>>2])){g=x[d+4>>2];m=x[d+8>>2];i=r+900|0;e=x[G+6144>>2];f=e-h|0;e=(e|0)<(h|0)?e:h;f=zc(i+12|0,(((f|0)>0?f:0)+G|0)+6156|0,e);k=x[d>>2]+(x[d+4>>2]/8|0)|0;d=(m-g|0)/8|0;zc(e+f|0,k,d);$L(i,f,d+e|0);D:{h=x[G+6144>>2]>=(h|0);if(!h){break D}na=G+2304|0;oa=r+8608|0;pa=r+3840|0;while(1){if((y[C+1|0]&8?2:1)>>>0<=o>>>0){break D}qa=Rb(pa,0,4608);e=x[L+8>>2];m=D(D(e,o),28)+ja|0;d=0;ka=(e|0)>0?e:0;A=r+900|0;I=A+7548|0;_=G+6152|0;while(1){if((d|0)!=(ka|0)){g=D(d,28)+m|0;K=z[g+4>>1];V=x[A+4>>2];t=(A+D(d,39)|0)+16156|0;e=I;n=d;f=fb-48|0;fb=f;d=g;J=y[d+25|0];H=D(!y[d+13|0]+(y[d+14|0]!=0)|0,28)+81824|0;E:{if(y[_+1|0]&8){j=y[d+27|0];g=y[z[d+8>>1]+81920|0];i=g&3;v[f+47|0]=i;v[f+46|0]=i;g=g>>>2|0;v[f+45|0]=g;v[f+44|0]=g;break E}g=(y[_+3|0]&16)>>>4&(n|0)!=0;l=g?12:0;q=z[d+8>>1]>>>g|0;while(1){if((q|0)>=0){j=3;i=1;while(1){if((j|0)>=0){g=y[(j+l|0)+81936|0];v[(f+44|0)+j|0]=((q>>>0)/(i>>>0)>>>0)%(g>>>0);j=j-1|0;i=D(g,i);continue}break}l=l+4|0;q=q-i|0;continue}break}H=l+H|0;j=-16}i=f;ea=f+44|0;q=0;while(1){F:{G:{H:{if((q|0)==4){break H}g=y[q+H|0];if(!g){break H}if(j&8){zc(i,t,g);break G}l=y[q+ea|0];if(!l){Rb(i,0,g);Rb(t,0,g);break G}fa=(j|0)>=0?-1:-1<<l^-1;k=0;while(1){if((g|0)==(k|0)){break G}S=ve(A,l);v[k+t|0]=(S|0)==(fa|0)?-1:S;v[i+k|0]=S;k=k+1|0;continue}}v[i+2|0]=0;v[i|0]=0;v[i+1|0]=0;break F}j=j<<1;q=q+1|0;i=g+i|0;t=g+t|0;continue}break}I:{i=y[d+14|0];if(i){g=2-J|0;k=y[d+23|0]<<g;q=y[d+22|0]<<g;l=y[d+21|0]<<g;t=y[d+13|0];j=0;while(1){if(j>>>0>=i>>>0){break I}g=f+(j+t|0)|0;v[g|0]=l+y[g|0];v[g+1|0]=q+y[g+1|0];v[g+2|0]=k+y[g+2|0];j=j+3|0;continue}}if(!y[d+24|0]){break I}j=0;while(1){if((j|0)==10){break I}g=f+j|0;v[g+11|0]=y[g+11|0]+y[j+81960|0];j=j+1|0;continue}}g=J+1|0;j=0;u=jz(E(2048),((((y[_+3|0]&224)==96)<<1)-y[d+10|0]|0)+258|0);while(1){if(y[d+13|0]+(i&255)>>>0>j>>>0){sa=e+(j<<2)|0,ua=jz(u,y[f+j|0]<<g),B[sa>>2]=ua;j=j+1|0;i=y[d+14|0];continue}break}fb=f+48|0;k=(A+D(n,2304)|0)+2940|0;j=e;ea=K+V|0;u=E(0);g=x[A+4>>2];e=x[A>>2]+((g|0)/8|0)|0;f=y[e|0]|y[e+1|0]<<8|(y[e+2|0]<<16|y[e+3|0]<<24);f=(f<<24|(f&65280)<<8|(f>>>8&65280|f>>>24))<<(g&7);l=g|-8;t=e+4|0;q=d;H=x[d>>2];J=z[d+6>>1];d=0;while(1){J:{K:{if((J|0)>0){g=d+1|0;e=d+q|0;d=y[e+15|0];fa=(w[(d<<1)+86384>>1]<<1)+82e3|0;S=y[e+18|0];if(d>>>0>=16){ga=y[d+86448|0];ra=32-ga|0;while(1){ha=y[H|0]>>>1|0;ia=(J|0)<(ha|0)?J:ha;u=B[j>>2];while(1){e=f>>>27|0;d=5;while(1){e=w[fa+(e<<1)>>1];if((e|0)<0){f=f<<d;i=e&7;e=(f>>>32-i|0)-(e>>3)|0;l=d+l|0;d=i;continue}break}d=e>>>8|0;l=d+l|0;f=f<<d;i=0;while(1){if((i|0)!=2){K=e&15;L:{if((K|0)==15){l=l+ga|0;d=f<<ga;while(1){if((l|0)>=0){d=y[t|0]<<l|d;t=t+1|0;l=l-8|0;continue}break}K=(f>>>ra|0)+15|0;f=K;M:{if((f|0)<=128){M=B[(f<<2)+86544>>2];break M}la=f>>>0<1024;f=la?f<<3:f;V=f<<1&64;O=E(E((f&63)-V|0)/E(V+(f&2147483584)|0));M=E((la?E(16):E(256))*E(E(E(O*E(E(O*E(.2222222238779068))+E(1.3333333730697632)))+E(1))*B[(f+V>>>4&268435452)+86544>>2]))}M=E(E(u*M)*E(d>>31|1));break L}d=f;M=E(u*B[(((d>>>27&16|K)^16)<<2)+86480>>2])}B[k>>2]=M;e=e>>>4|0;k=k+4|0;i=i+1|0;f=(K|0)!=0;l=f+l|0;f=d<<f;continue}break}while(1){if((l|0)>=0){f=y[t|0]<<l|f;t=t+1|0;l=l-8|0;continue}break}ia=ia-1|0;if(ia){continue}break}j=j+4|0;H=H+1|0;J=J-ha|0;if((J|0)<=0){break K}d=(S|0)>0;S=S-1|0;if(d){continue}break}break K}while(1){V=y[H|0]>>>1|0;K=(J|0)<(V|0)?J:V;u=B[j>>2];while(1){d=f>>>27|0;e=5;while(1){d=w[fa+(d<<1)>>1];if((d|0)<0){f=f<<e;i=d&7;d=(f>>>32-i|0)-(d>>3)|0;l=e+l|0;e=i;continue}break}e=d>>>8|0;l=e+l|0;f=f<<e;e=0;while(1){if((e|0)!=2){i=d&15;B[k>>2]=u*B[(((i|f>>>27&16)^16)<<2)+86480>>2];d=d>>>4|0;k=k+4|0;e=e+1|0;i=(i|0)!=0;l=i+l|0;f=f<<i;continue}break}while(1){if((l|0)>=0){f=y[t|0]<<l|f;t=t+1|0;l=l-8|0;continue}break}K=K-1|0;if(K){continue}break}j=j+4|0;H=H+1|0;J=J-V|0;if((J|0)<=0){break K}d=(S|0)>0;S=S-1|0;if(d){continue}break}break K}e=1-J|0;while(1){N:{g=y[q+26|0]?86368:86336;d=y[g+(f>>>28|0)|0];if(!(d&8)){d=y[g+(d>>>3|0)+(f<<4>>>32-(d&3))|0]}g=d&7;l=g+l|0;if(((l+(t-x[A>>2]<<3)|0)-24|0)>(ea|0)){break N}e=e-1|0;if(!e){e=y[H|0];if(e>>>0<2){break N}H=H+1|0;u=B[j>>2];j=j+4|0;e=e>>>1|0}f=f<<g;if(d>>>0>=128){B[k>>2]=(f|0)<0?E(-u):u;l=l+1|0;f=f<<1}if(d&64){B[k+4>>2]=(f|0)<0?E(-u):u;l=l+1|0;f=f<<1}e=e-1|0;if(!e){e=y[H|0];if(e>>>0<2){break N}H=H+1|0;u=B[j>>2];j=j+4|0;e=e>>>1|0}if(d&32){B[k+8>>2]=(f|0)<0?E(-u):u;l=l+1|0;f=f<<1}if(d&16){B[k+12>>2]=(f|0)<0?E(-u):u;l=l+1|0;f=f<<1}while(1){if((l|0)>=0){f=y[t|0]<<l|f;t=t+1|0;l=l-8|0;continue}break}k=k+16|0;continue}break}x[A+4>>2]=ea;break J}d=g;continue}break}d=n+1|0;continue}break}d=y[G+6155|0];O:{if(d&16){j=A+16195|0;d=0;g=fb-16|0;fb=g;i=A+2940|0;k=i+2304|0;I=x[m>>2];l=y[m+14|0];t=y[m+13|0];n=l+t|0;e=g+4|0;x[e+8>>2]=-1;x[e>>2]=-1;x[e+4>>2]=-1;while(1){if((d|0)!=(n|0)){H=d+I|0;q=y[H|0];f=0;P:{while(1){if(f>>>0>=q>>>0){break P}J=f<<2;if(B[J+k>>2]==E(0)){f=f+2|0;if(B[(J|4)+k>>2]==E(0)){continue}}break}x[e+((d>>>0)%3<<2)>>2]=d;q=y[H|0]}d=d+1|0;k=(q<<2)+k|0;continue}break}if(t){d=x[g+4>>2];e=x[g+8>>2];d=(d|0)>(e|0)?d:e;e=x[g+12>>2];d=(d|0)>(e|0)?d:e;x[g+12>>2]=d;x[g+8>>2]=d;x[g+4>>2]=d}e=l?3:1;k=n-e|0;d=0;while(1){if((d|0)!=(e|0)){n=d+k|0;f=n-e|0;if((f|0)<=x[(g+4|0)+(d<<2)>>2]){f=y[_+1|0]<<28>>31&3}else{f=y[f+j|0]}v[j+n|0]=f;d=d+1|0;continue}break}n=x[m>>2];q=g+4|0;I=w[m+36>>1]&1;k=0;l=y[_+1|0]&8?7:64;while(1){t=k+n|0;e=y[t|0];if(e){f=y[_+3|0]&32;Q:{R:{if(x[q+((k>>>0)%3<<2)>>2]>=(k|0)){break R}d=y[j+k|0];if(d>>>0>=l>>>0){break R}M=f?E(1.4142135381698608):E(1);S:{if(y[_+1|0]&8){d=d<<3;u=B[d+87076>>2];O=B[d+87072>>2];break S}O=jz(E(1),d+1>>>1<<I);d=d&1;u=d?E(1):O;O=d?O:E(1)}O=E(M*O);M=E(M*u);d=0;while(1){if((d|0)!=(e|0)){f=(d<<2)+i|0;u=B[f>>2];B[f+2304>>2]=u*M;B[f>>2]=u*O;d=d+1|0;continue}break}break Q}if(!f){break Q}YL(i,e)}k=k+1|0;i=(y[t|0]<<2)+i|0;continue}break}fb=g+16|0;break O}if((d&224)!=96){break O}YL(A+2940|0,576)}i=A+7708|0;d=0;while(1){if((d|0)!=(ka|0)){e=y[G+6153|0];e=(y[m+12|0]!=0)<<1<<((D((e>>>3&1)+(e>>>4&1)|0,3)+(y[G+6154|0]>>>2&3)|0)==2);f=A+D(d,2304)|0;k=f+2940|0;j=k;if(y[m+14|0]){q=x[m>>2]+y[m+13|0]|0;t=(f+D(e,72)|0)+2940|0;g=t;f=i;while(1){n=y[q|0];if(n){l=n<<1;I=0;while(1){if((n|0)!=(I|0)){B[f>>2]=B[g>>2];B[f+4>>2]=B[(n<<2)+g>>2];B[f+8>>2]=B[(l<<2)+g>>2];g=g+4|0;I=I+1|0;f=f+12|0;continue}break}q=q+3|0;g=(l<<2)+g|0;continue}break}zc(t,i,f-i|0);f=e-1|0}else{f=31}while(1){g=0;if((f|0)>0){while(1){if((g|0)!=8){n=g<<2;q=n+j|0;u=B[q+72>>2];O=B[n+87136>>2];M=B[n+87168>>2];n=(17-g<<2)+j|0;ma=B[n>>2];B[q+72>>2]=E(u*O)-E(M*ma);B[n>>2]=E(u*M)+E(ma*O);g=g+1|0;continue}break}j=j+72|0;f=f-1|0;continue}break}g=k;f=D(d,1152)+G|0;j=y[m+11|0];if(e){XL(g,f,87200,e);g=D(e,72)+g|0;f=D(e,36)+f|0}T:{if((j|0)==2){j=32-e|0;e=fb-80|0;fb=e;q=e|8;I=e|4;while(1){if((j|0)>0){n=zc(e,g,72);l=x[f+20>>2];x[g+16>>2]=x[f+16>>2];x[g+20>>2]=l;l=x[f+12>>2];x[g+8>>2]=x[f+8>>2];x[g+12>>2]=l;l=x[f+4>>2];x[g>>2]=x[f>>2];x[g+4>>2]=l;K=n;n=f+24|0;iz(K,g+24|0,n);iz(I,g+48|0,n);iz(q,f,n);g=g+72|0;f=f+36|0;j=j-1|0;continue}break}fb=e+80|0;break T}XL(g,f,D((j|0)==3,72)+87200|0,32-e|0)}e=0;k=k+72|0;while(1){g=1;if(e>>>0<=31){while(1){if(g>>>0<=17){f=(g<<2)+k|0;B[f>>2]=-B[f>>2];g=g+2|0;continue}break}k=k+144|0;e=e+2|0;continue}break}m=m+28|0;d=d+1|0;continue}break}_L(na,qa,18,x[L+8>>2],Z,oa);o=o+1|0;Z=D(x[L+8>>2],1152)+Z|0;continue}}e=r+900|0;g=x[e+8>>2]>>>3|0;m=x[e+4>>2]+7>>>3|0;d=g-m|0;f=(d|0)>=511?511:d;if((d|0)>0){gl(G+6156|0,(e+(d>>>0>511?g-511|0:m)|0)+12|0,f)}x[G+6144>>2]=f;break x}IB(G);break l}f=r+17136|0;o=0;m=0;k=0;g=r;d=0;U:{V:{W:{h=y[C+3|0];i=h>>>6|0;switch(i-1|0){case 2:break U;case 0:break W;default:break V}}d=(h>>>2&12)+4|0;break U}d=32}h=y[C+1|0];X:{if((h&6)==6){h=32;e=88604;break X}if(!(h&8)){h=30;e=88607;break X}j=y[C+2|0];e=j>>>2&3;h=lz(h,j)>>>((i|0)!=3)|0;h=h?h:192;if(h>>>0<=55){h=(e|0)==2?12:8;e=88628;break X}h=h>>>0<=95?27:(e|0)!=1?30:27;e=88616}v[g+768|0]=h;v[g+769|0]=(d|0)<(h|0)?d:h;h=e;i=88512;while(1){d=y[g+768|0];if(o>>>0>=d>>>0){o=0;while(1){e=d<<1&510;if(e>>>0>o>>>0){e=g+o|0;Y:{if(!y[e+770|0]){h=6;break Y}h=2;if((y[C+1|0]&6)==6){break Y}h=ve(f,2);d=y[g+768|0]}v[e+834|0]=h;o=o+1|0;continue}break}m=g+770|0;i=g+834|0;h=0;j=e;while(1){if((h|0)!=(j|0)){k=y[m|0];if(k){e=19>>>y[h+i|0]&3|4}else{e=0}m=m+1|0;k=D(k,3)-6|0;u=E(0);d=4;while(1){if(d){if(d&e){A=ve(f,6);n=(A|0)/3|0;u=E(B[(k+(D(n,-3)+A|0)<<2)+88640>>2]*E(2097152>>>n|0))}B[g>>2]=u;d=d>>>1|0;g=g+4|0;continue}break}h=h+1|0;continue}break}o=y[r+769|0];d=y[r+768|0];d=d>>>0<o>>>0?o:d;while(1){if((d|0)!=(o|0)){v[((o<<1)+r|0)+771|0]=0;o=o+1|0;continue}break}}else{if((k|0)==(o|0)){i=y[h|0]+88512|0;k=y[h+2|0]+o|0;m=y[h+1|0];h=h+3|0}e=o<<1;d=y[ve(f,m)+i|0];v[(e+g|0)+770|0]=d;j=y[g+769|0];if(o>>>0<j>>>0){d=y[ve(f,m)+i|0];j=y[g+769|0]}v[((e|1)+g|0)+770|0]=j?d:0;o=o+1|0;continue}break}h=0;g=Rb(r+3840|0,0,4608);I=G+2304|0;l=r+8608|0;o=0;Z:{while(1){if((o|0)==3){break Z}C=g+(h<<2)|0;n=r+17136|0;e=0;A=x[L+16>>2]|1;q=(A|0)>0?A:0;f=576;while(1){if((e|0)!=4){m=C+(D(e,A)<<2)|0;i=0;while(1){if(y[r+768|0]<<1>>>0>i>>>0){_:{j=y[(i+r|0)+770|0];if(!j){break _}if(j>>>0<=16){k=(-1<<j-1)+1|0;d=0;while(1){if((d|0)==(q|0)){break _}sa=(d<<2)+m|0,ua=E(ve(n,j)+k|0),B[sa>>2]=ua;d=d+1|0;continue}}d=2<<j-17;k=ve(n,(d-(d>>>3|0)|0)+3|0);t=d>>>1|0;j=d|1;d=0;while(1){if((d|0)==(q|0)){break _}K=k;k=(k>>>0)/(j>>>0)|0;B[(d<<2)+m>>2]=K-(t+D(j,k)|0)|0;d=d+1|0;continue}}i=i+1|0;m=(f<<2)+m|0;f=18-f|0;continue}break}e=e+1|0;continue}break}h=(A<<2)+h|0;if((h|0)==12){d=(o<<2)+r|0;h=g;e=y[r+769|0];f=g+D(e,72)|0;zc(f+2304|0,f,D(y[r+768|0]-e|0,72));m=0;while(1){if(y[r+768|0]>m>>>0){e=0;while(1){if((e|0)!=12){f=e<<2;i=f+h|0;B[i>>2]=B[d>>2]*B[i>>2];f=(f|2304)+h|0;B[f>>2]=B[d+12>>2]*B[f>>2];e=e+1|0;continue}break}d=d+24|0;h=h+72|0;m=m+1|0;continue}break}_L(I,g,12,x[L+8>>2],Z,l);Rb(g,0,4608);Z=D(x[L+8>>2],768)+Z|0;h=0}o=o+1|0;if(x[r+17140>>2]<=x[r+17144>>2]){continue}break}IB(G);o=0;break l}h=1}o=D(kz(y[G+6153|0]),h)}fb=r+17152|0;d=x[s+32>>2];if((d|0)<0|!d){break h}h=x[s+44>>2];if((h|0)!=(ba|0)?ba:0){break h}d=x[s+40>>2];if((d|0)!=(F|0)?F:0){break h}if(d-3>>>0<4294967294|(h|0)<=0){break i}x[s+16>>2]=0;sa=s,ta=Gc(W,aa),x[sa+12>>2]=ta;e=s+16|0;f=s+12|0;F=x[_j(L,e,f)>>2];x[s+16>>2]=0;sa=s,ta=Gc(W,aa),x[sa+12>>2]=ta;e=x[_j(L,e,f)>>2];g=e>>31;$:{if(!o){break $}f=x[da>>2];x[31609]=0;U(594,P|0,f|0,f+(D(d,o)<<1)|0)|0;f=x[31609];x[31609]=0;if((f|0)!=1){break $}c=T(124540)|0;if((gb|0)==($(124540)|0)){Y(c|0)|0;x[31609]=0;X(26);c=x[31609];x[31609]=0;F=d;ba=h;if((c|0)!=1){break h}c=N()|0}od(da);break k}if(($c(x[P>>2],x[P+4>>2])>>>0)/(d>>>0)>>>0>268435456){break i}c=c+F|0;ba=h;F=d;aa=aa-(g+(e>>>0>W>>>0)|0)|0;W=W-e|0;if(!!W&(aa|0)>=0|(aa|0)>0){continue}break}break h}c=N()|0}UT(ca);break j}c=N()|0}od(P);Kc(s+76|0);Q(c|0);p()}F=d;ba=h}h=0;aa:{if(!ba|!F){break aa}c=x[P>>2];d=x[P+4>>2];if(mc(c,d)){break aa}if(($c(c,d)>>>0)/(F>>>0)>>>0>268435456){break aa}Wu(a,b);b=D(b,104)+a|0;a=b+484380|0;sa=a,ta=($c(x[P>>2],x[P+4>>2])>>>0)/(F>>>0)|0,x[sa>>2]=ta;d=b+484414|0;c=z[d>>1];w[d>>1]=(F|0)==2?c|65:c&65470|1;Gh(a);b=b+484400|0;h=le(x[a>>2],x[b>>2]);if(!h){break aa}dV(wb(x[P>>2]),wb(x[P+4>>2]),x[b>>2]);h=le(x[a>>2],x[a+20>>2])}od(da);UT(ca);od(P);Kc(s+76|0)}fb=s+96|0;return h|0}function cD(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,C=0,G=0,H=0,I=E(0),K=E(0),L=0,M=0,N=0,O=E(0);C=fb-1520|0;fb=C;e=C+8|0;M=Rb(e,0,1512),N=-1,x[M+1420>>2]=N;v[C+56|0]=1;x[C+48>>2]=a+b;x[C+40>>2]=a;b=0;q=fb-1024|0;fb=q;v[e+1377|0]=1;a:{if(!Qt(e)){break a}f=y[e+1375|0];if(!(f&2)){fc(e,34);break a}if(f&4){fc(e,34);break a}if(f&1){fc(e,34);break a}if(x[e+1116>>2]!=1){fc(e,34);break a}f=y[e+1120|0];if((f|0)!=30){b:{if((f|0)!=64){break b}if(!ez(e,q+1018|0,6)|y[q+1018|0]!=102|(y[q+1019|0]!=105|y[q+1020|0]!=115)){break b}if(y[q+1021|0]!=104|y[q+1022|0]!=101|y[q+1023|0]!=97){break b}if((ff(e)|0)!=100){break b}if(ff(e)){break b}fc(e,38);break a}fc(e,34);break a}if((ff(e)|0)!=1){fc(e,34);break a}if(!ez(e,q+1018|0,6)){fc(e,10);break a}if(!cz(q+1018|0)){fc(e,34);break a}if(tj(e)){fc(e,34);break a}f=ff(e);x[e+4>>2]=f;if(!f){fc(e,34);break a}if(f>>>0>=17){fc(e,5);break a}f=tj(e);x[e>>2]=f;if(!f){fc(e,34);break a}tj(e);tj(e);tj(e);g=ff(e);f=g>>>4|0;x[e+116>>2]=1<<f;h=g&15;x[e+112>>2]=1<<h;if(h-14>>>0<=4294967287){fc(e,20);break a}if(g+32<<24>>24>=0){fc(e,20);break a}c:{if(f>>>0<h>>>0){fc(e,20);break c}if(!(ff(e)&1)){fc(e,34);break c}if(!Qt(e)){break a}if(!dz(e)){break a}if(!fz(e)){break a}d:{e:{if((Oh(e)|0)==3){while(1){if((b|0)!=6){M=(q+1018|0)+b|0,N=Oh(e),v[M|0]=N;b=b+1|0;continue}break}if(!cz(q+1018|0)){fc(e,20);break c}g=bz(e);b=ue(e,g+1|0);x[e+20>>2]=b;if(!b){break e}b=0;h=(g|0)>0?g:0;while(1){if((b|0)!=(h|0)){f=Oh(e);v[x[e+20>>2]+b|0]=f;b=b+1|0;continue}break}v[g+x[e+20>>2]|0]=0;b=bz(e);x[e+28>>2]=0;x[e+24>>2]=b;if((b|0)<=0){break d}b=ue(e,b<<2);x[e+28>>2]=b;if(b){break d}fc(e,3);break c}fc(e,20);break c}fc(e,3);break c}while(1){f:{g:{if(x[e+24>>2]>(m|0)){j=bz(e);b=ue(e,j+1|0);g=m<<2;x[g+x[e+28>>2]>>2]=b;if(!x[g+x[e+28>>2]>>2]){break g}b=0;h=(j|0)>0?j:0;while(1){if((b|0)==(h|0)){break f}f=Oh(e);v[x[g+x[e+28>>2]>>2]+b|0]=f;b=b+1|0;continue}}if(!(Oh(e)&1)){fc(e,20);break c}LL(e,y[e+1376|0]);v[e+1376|0]=0;while(1){b=fz(e);LL(e,b);v[e+1376|0]=0;if(b){continue}break}b=0;if(!dz(e)){break a}if(!UL(e)){if(x[e+100>>2]!=21){break a}x[e+100>>2]=20;break a}h=0;while(1){if((h|0)!=256){i=h<<24;f=0;while(1){if((f|0)!=8){i=i>>31&79764919^i<<1;f=f+1|0;continue}break}x[(h<<2)+495328>>2]=i;h=h+1|0;continue}break}if((Oh(e)|0)==5){while(1){if((b|0)!=6){M=(q+1018|0)+b|0,N=Oh(e),v[M|0]=N;b=b+1|0;continue}break}if(!cz(q+1018|0)){fc(e,20);break c}b=sc(e,8)+1|0;x[e+120>>2]=b;b=ue(e,D(b,2096));x[e+124>>2]=b;if(!b){fc(e,3);break c}Rb(b,0,D(x[e+120>>2],2096));h:{i:{while(1){j:{k:{if(x[e+120>>2]>(k|0)){b=x[e+124>>2];if((sc(e,8)&255)!=66){fc(e,20);break c}if((sc(e,8)&255)!=67){fc(e,20);break c}if((sc(e,8)&255)!=86){fc(e,20);break c}g=D(k,2096)+b|0;M=g,N=sc(e,8)&255|sc(e,8)<<8,x[M>>2]=N;M=g,N=sc(e,8)&255|(sc(e,8)<<8&65280|sc(e,8)<<16),x[M+4>>2]=N;t=g+4|0;b=0;f=sc(e,1);if(!f){b=sc(e,1)}v[g+23|0]=b;h=x[t>>2];if(!(x[g>>2]|!h)){fc(e,20);break c}l:{if(b&255){i=no(e,h);break l}i=ue(e,h);x[g+8>>2]=i}if(!i){fc(e,3);break c}r=0;if(f){break k}b=0;while(1){f=x[t>>2];if((f|0)<=(b|0)){break j}m:{n:{if(y[g+23|0]){if(!sc(e,1)){break n}}f=sc(e,5)+1|0;v[b+i|0]=f;if((f&255)!=32){r=r+1|0;break m}fc(e,20);break c}v[b+i|0]=255}b=b+1|0;continue}}f=sc(e,6)+1&255;b=0;o:{while(1){if((b|0)==(f|0)){break o}b=b+1|0;if(!sc(e,16)){continue}break}fc(e,20);break c}b=sc(e,6)+1|0;x[e+128>>2]=b;b=ue(e,D(b,1596));x[e+260>>2]=b;p:{q:{if(b){r=0;h=0;r:while(1){if(x[e+128>>2]<=(h|0)){break q}b=sc(e,16);w[((h<<1)+e|0)+132>>1]=b;b=b&65535;if(b>>>0>=2){fc(e,20);break c}if(!b){f=x[e+260>>2]+D(h,1596)|0;M=f,N=sc(e,8),v[M|0]=N;M=f,N=sc(e,16),w[M+2>>1]=N;M=f,N=sc(e,16),w[M+4>>1]=N;M=f,N=sc(e,6),v[M+6|0]=N;M=f,N=sc(e,8),v[M+7|0]=N;k=sc(e,4)+1|0;v[f+8|0]=k;b=0;while(1){if((k&255)>>>0>b>>>0){M=b+f|0,N=sc(e,8),v[M+9|0]=N;b=b+1|0;k=y[f+8|0];continue}break}fc(e,4);break c}n=x[e+260>>2]+D(h,1596)|0;f=sc(e,5);v[n|0]=f;i=0;k=-1;while(1)if((f&255)>>>0<=i>>>0){g=k+1|0;f=0;while(1){if((f|0)!=(g|0)){j=f+n|0;M=j,N=sc(e,3)+1|0,v[M+33|0]=N;b=sc(e,2);v[j+49|0]=b;if(b&255){b=sc(e,8);v[j+65|0]=b;if(x[e+120>>2]<=(b&255)){break p}}i=0;while(1){if(1<<y[j+49|0]>(i|0)){b=sc(e,8)-1|0;w[((n+(f<<4)|0)+(i<<1)|0)+82>>1]=b;i=i+1|0;if(x[e+120>>2]>b<<16>>16){continue}break p}break}f=f+1|0;continue}break}k=2;M=n,N=sc(e,2)+1|0,v[M+1588|0]=N;b=sc(e,4);x[n+1592>>2]=2;m=0;w[n+338>>1]=0;v[n+1589|0]=b;w[n+340>>1]=1<<b;G=n+338|0;l=0;while(1){if(y[n|0]>l>>>0){f=n+y[(l+n|0)+1|0]|0;i=0;while(1){if(y[f+33|0]>i>>>0){b=sc(e,y[n+1589|0]);w[(n+(x[n+1592>>2]<<1)|0)+338>>1]=b;k=x[n+1592>>2]+1|0;x[n+1592>>2]=k;i=i+1|0;continue}break}l=l+1|0;continue}break}while(1){if((k|0)>(m|0)){f=z[(n+(m<<1)|0)+338>>1];b=(q+16|0)+(m<<2)|0;w[b+2>>1]=m;w[b>>1]=f;m=m+1|0;k=x[n+1592>>2];continue}break}KL(q+16|0,k,1216);k=x[n+1592>>2];g=((k|0)<=1?1:k)-1|0;i=0;f=0;while(1){if((f|0)!=(g|0)){b=q+16|0;j=z[b+(f<<2)>>1];f=f+1|0;if((j|0)!=z[b+(f<<2)>>1]){continue}break p}break}while(1){if((i|0)<(k|0)){v[(i+n|0)+838|0]=y[((q+16|0)+(i<<2)|0)+2|0];i=i+1|0;k=x[n+1592>>2];continue}break}i=2;while(1){if((i|0)<(k|0)){x[q+12>>2]=0;x[q+8>>2]=0;f=0;b=(i|0)>0?i:0;o=G+(i<<1)|0;k=65536;j=-1;while(1){if((b|0)!=(f|0)){g=G+(f<<1)|0;l=z[g>>1];if(!((j|0)>=(l|0)|z[o>>1]<=l>>>0)){x[q+12>>2]=f;l=z[g>>1];j=l}if(!((k|0)<=(l|0)|z[o>>1]>=l>>>0)){x[q+8>>2]=f;k=z[g>>1]}f=f+1|0;continue}break}b=n+(i<<1)|0;v[b+1088|0]=x[q+12>>2];v[b+1089|0]=x[q+8>>2];i=i+1|0;k=x[n+1592>>2];continue}break}r=(k|0)>(r|0)?k:r;h=h+1|0;continue r}else{b=sc(e,4);v[(i+n|0)+1|0]=b;b=b&255;k=(b|0)>(k|0)?b:k;i=i+1|0;f=y[n|0];continue}}}fc(e,3);break c}b=sc(e,6)+1|0;x[e+264>>2]=b;b=ue(e,D(b,24));x[e+396>>2]=b;if(!b){fc(e,3);break c}f=0;Rb(b,0,D(x[e+264>>2],24));s:{t:{while(1){if(x[e+264>>2]>(f|0)){h=x[e+396>>2];b=sc(e,16);w[((f<<1)+e|0)+268>>1]=b;k=20;if((b&65535)>>>0>2){break s}o=D(f,24)+h|0;M=o,N=sc(e,24),x[M>>2]=N;b=sc(e,24);x[o+4>>2]=b;if(b>>>0<A[o>>2]){break s}M=o,N=sc(e,24)+1|0,x[M+8>>2]=N;M=o,N=sc(e,6)+1|0,v[M+12|0]=N;b=sc(e,8);v[o+13|0]=b;if(x[e+120>>2]<=(b&255)){break s}b=0;while(1){h=y[o+12|0];if(h>>>0>b>>>0){j=(q+16|0)+b|0;l=sc(e,3);if(sc(e,1)){h=sc(e,5)}else{h=0}v[j|0]=l+(h<<3);b=b+1|0;continue}break}b=ue(e,h<<4);x[o+20>>2]=b;if(!b){break t}h=0;while(1){if(y[o+12|0]>h>>>0){i=y[(q+16|0)+h|0];b=0;while(1){if((b|0)!=8){u:{if(i>>>b&1){l=sc(e,8);g=b<<1;j=h<<4;w[g+(j+x[o+20>>2]|0)>>1]=l;if(x[e+120>>2]<=w[g+(j+x[o+20>>2]|0)>>1]){break s}break u}w[(x[o+20>>2]+(h<<4)|0)+(b<<1)>>1]=65535}b=b+1|0;continue}break}h=h+1|0;continue}break}b=ue(e,x[(x[e+124>>2]+D(y[o+13|0],2096)|0)+4>>2]<<2);x[o+16>>2]=b;if(!b){break t}l=0;Rb(b,0,x[(x[e+124>>2]+D(y[o+13|0],2096)|0)+4>>2]<<2);while(1){b=x[e+124>>2]+D(y[o+13|0],2096)|0;if(x[b+4>>2]>(l|0)){b=x[b>>2];h=ue(e,b);g=l<<2;x[g+x[o+16>>2]>>2]=h;i=l;if(!x[g+x[o+16>>2]>>2]){break t}while(1){if((b|0)>0){b=b-1|0;v[b+x[g+x[o+16>>2]>>2]|0]=(i|0)%y[o+12|0];i=(i|0)/y[o+12|0]|0;continue}break}l=l+1|0;continue}break}f=f+1|0;continue}break}b=sc(e,6)+1|0;x[e+400>>2]=b;b=ue(e,D(b,40));x[e+404>>2]=b;if(!b){fc(e,3);break c}Rb(b,0,D(x[e+400>>2],40));h=0;while(1){v:{if(x[e+400>>2]>(h|0)){b=x[e+404>>2];if(sc(e,16)){fc(e,20);break c}f=D(h,40)+b|0;b=ue(e,D(x[e+4>>2],3));x[f+4>>2]=b;if(!b){fc(e,3);break c}if(sc(e,1)){b=sc(e,4)+1|0}else{b=1}v[f+8|0]=b;w:{if(sc(e,1)){g=sc(e,8)+1|0;w[f>>1]=g;b=0;k=x[e+4>>2];if((k|0)<(g&65535)){fc(e,20);break c}while(1){if(z[f>>1]<=b>>>0){break w}g=sc(e,Km(k-1|0));j=D(b,3);v[j+x[f+4>>2]|0]=g;g=sc(e,Km(x[e+4>>2]-1|0));v[(j+x[f+4>>2]|0)+1|0]=g;k=x[e+4>>2];g=j+x[f+4>>2]|0;j=y[g|0];if((k|0)<=(j|0)){fc(e,20);break c}g=y[g+1|0];if((g|0)>=(k|0)){fc(e,20);break c}b=b+1|0;if((g|0)!=(j|0)){continue}break}fc(e,20);break c}w[f>>1]=0}if(sc(e,2)){fc(e,20);break c}b=0;if(y[f+8|0]>=2){while(1){if(x[e+4>>2]<=(b|0)){break v}j=sc(e,4);g=D(b,3);v[(g+x[f+4>>2]|0)+2|0]=j;b=b+1|0;if(y[(g+x[f+4>>2]|0)+2|0]<y[f+8|0]){continue}break}fc(e,20);break c}while(1){if(x[e+4>>2]<=(b|0)){break v}v[(x[f+4>>2]+D(b,3)|0)+2|0]=0;b=b+1|0;continue}}M=e,N=sc(e,6)+1|0,x[M+408>>2]=N;f=e+412|0;i=0;x:{while(1){if(x[e+408>>2]<=(i|0)){break x}h=f+D(i,6)|0;M=h,N=sc(e,1),v[M|0]=N;M=h,N=sc(e,16),w[M+2>>1]=N;M=h,N=sc(e,16),w[M+4>>1]=N;b=sc(e,8);v[h+1|0]=b;if(z[h+2>>1]){fc(e,20);break c}if(z[h+4>>1]){fc(e,20);break c}i=i+1|0;if(x[e+400>>2]>(b&255)){continue}break}fc(e,20);break c}QL(e);x[e+992>>2]=0;g=r<<1;b=0;while(1){if(x[e+4>>2]>(b|0)){j=(b<<2)+e|0;M=j,N=ue(e,x[e+116>>2]<<2),x[M+800>>2]=N;M=j,N=ue(e,x[e+116>>2]<<1&2147483646),x[M+928>>2]=N;h=ue(e,g);x[j+996>>2]=h;f=x[j+800>>2];if(h?!f|!x[j+928>>2]:1){fc(e,3);break c}Rb(f,0,x[e+116>>2]<<2);b=b+1|0;continue}break}b=0;if(!JL(e,0,x[e+112>>2])){break a}if(!JL(e,1,x[e+116>>2])){break a}x[e+104>>2]=x[e+112>>2];j=x[e+116>>2];x[e+108>>2]=j;f=x[e+264>>2];h=(f|0)>0?f:0;l=(j|0)/2|0;k=0;while(1){if((b|0)!=(h|0)){g=x[e+396>>2]+D(b,24)|0;f=x[g+4>>2];i=f>>>0<l>>>0?f:l;f=x[g>>2];f=(i-(f>>>0<l>>>0?f:l)>>>0)/A[g+8>>2]|0;k=(f|0)>(k|0)?f:k;b=b+1|0;continue}break}f=j<<1&2147483646;b=D(x[e+4>>2],(k<<2)+4|0);f=b>>>0<f>>>0?f:b;x[e+12>>2]=f;y:{z:{if(!x[e+80>>2]){break z}b=x[e+92>>2];if((b|0)!=x[e+84>>2]){break y}if(b>>>0>=(f+x[e+88>>2]|0)+1512>>>0){break z}fc(e,3);break c}A:{if(x[e+1380>>2]==-1){x[e+52>>2]=y[e+48|0]?0:x[e+32>>2]-x[e+36>>2]|0;break A}x[e+52>>2]=0}b=1;break a}_(7344,13274,4196,8845);p()}b=0;B:{while(1){if(y[f+8|0]<=b>>>0){break B}sc(e,8);j=b+f|0;M=j,N=sc(e,8),v[M+9|0]=N;g=sc(e,8);v[j+24|0]=g;if(x[e+128>>2]<=y[j+9|0]){fc(e,20);break c}b=b+1|0;if(x[e+264>>2]>(g&255)){continue}break}fc(e,20);break c}h=h+1|0;continue}}k=3}fc(e,k);break c}fc(e,20);break c}m=sc(e,5);b=0;while(1){f=x[t>>2];if((f|0)<=(b|0)){break j}h=sc(e,Km(f-b|0));m=m+1|0;if((m|0)>=32){fc(e,20);break c}f=b+h|0;if((f|0)>x[t>>2]){fc(e,20);break c}else{Rb(b+i|0,m,h);b=f;continue}}}C:{D:{E:{F:{G:{H:{if(y[g+23|0]){if(f>>2>(r|0)){break H}if(x[e+16>>2]<(f|0)){x[e+16>>2]=f;f=x[t>>2]}b=ue(e,f);x[g+8>>2]=b;if(!b){fc(e,3);break c}zc(b,i,x[t>>2]);sj(e,i,x[t>>2]);i=x[g+8>>2];v[g+23|0]=0;f=x[t>>2]}m=0;h=(f|0)>0?f:0;b=0;while(1){if((b|0)==(h|0)){break G}m=((y[b+i|0]-11&255)>>>0<244)+m|0;b=b+1|0;continue}}x[g+2092>>2]=r;l=g+2092|0;if(r){break F}b=0;h=0;break E}x[g+2092>>2]=m;b=ue(e,f<<2);x[g+32>>2]=b;if(b){l=g+2092|0;b=0;break D}fc(e,3);break c}b=ue(e,r);x[g+8>>2]=b;if(!b){fc(e,3);break c}b=no(e,x[l>>2]<<2);x[g+32>>2]=b;if(!b){fc(e,3);break c}b=no(e,x[l>>2]<<2);if(!b){break C}f=x[t>>2];h=x[l>>2]}f=(h<<3)+f|0;if(f>>>0<=A[e+16>>2]){break D}x[e+16>>2]=f}s=x[t>>2];f=0;h=fb-128|0;fb=h;u=Rb(h,0,128);h=(s|0)>0?s:0;while(1){I:{J:{if((f|0)!=(h|0)){if(y[f+i|0]==255){break J}h=f}if((h|0)==(s|0)){f=1;if(!x[g+2092>>2]){break I}_(15796,13274,1103,7588);p()}j=h+i|0;f=y[j|0];if(f>>>0<32){HL(g,0,h,0,f,b);n=1;j=y[j|0]+1|0;f=1;K:{while(1){if((f|0)==(j|0)){L:while(1){M:{f=1;h=h+1|0;if((s|0)<=(h|0)){break I}G=h+i|0;j=y[G|0];if((j|0)==255){continue}f=j;if(f>>>0>=32){break M}while(1){if((f|0)<=0){f=0;break I}o=u+(f<<2)|0;r=x[o>>2];if(!r){f=f-1|0;continue}break}x[o>>2]=0;HL(g,Im(r),h,n,j,b);n=n+1|0;m=y[G|0];if((m|0)==(f|0)){continue}while(1){if((f|0)>=(m|0)){continue L}j=u+(m<<2)|0;if(x[j>>2]){break K}x[j>>2]=r+(1<<32-m);m=m-1|0;continue}}break}}else{x[u+(f<<2)>>2]=1<<32-f;f=f+1|0;continue}break}_(15329,13274,1118,7588);p()}_(15840,13274,1133,7588);p()}_(15336,13274,1104,7588);p()}f=f+1|0;continue}break}fb=u+128|0;if(!f){if(y[g+23|0]){sj(e,b,0)}fc(e,20);break c}f=x[l>>2];if(f){f=ue(e,(f<<2)+4|0);x[g+2084>>2]=f;if(!f){fc(e,3);break c}f=ue(e,(x[l>>2]<<2)+4|0);x[g+2088>>2]=f;if(!f){fc(e,3);break c}x[g+2088>>2]=f+4;x[f>>2]=-1;f=0;m=0;N:{O:{P:{if(y[g+23|0]){while(1){m=x[g+2092>>2];if((m|0)<=(f|0)){break P}h=f<<2;M=h+x[g+2084>>2]|0,N=Im(x[h+x[g+32>>2]>>2]),x[M>>2]=N;f=f+1|0;continue}}while(1){if(x[g+4>>2]>(f|0)){if(GL(y[g+23|0],y[f+i|0])){M=x[g+2084>>2]+(m<<2)|0,N=Im(x[x[g+32>>2]+(f<<2)>>2]),x[M>>2]=N;m=m+1|0}f=f+1|0;continue}break}if(x[g+2092>>2]!=(m|0)){break O}}KL(x[g+2084>>2],m,1217);x[x[g+2084>>2]+(x[g+2092>>2]<<2)>>2]=-1;h=0;f=x[g+(y[g+23|0]?2092:4)>>2];r=(f|0)>0?f:0;Q:{while(1){if((h|0)!=(r|0)){f=h;j=y[g+23|0];f=j?x[(f<<2)+b>>2]:f;G=y[f+i|0];R:{if(!GL(j,G)){break R}o=h<<2;s=Im(x[o+x[g+32>>2]>>2]);f=x[g+2092>>2];m=0;while(1){if((f|0)>=2){u=f>>>1|0;j=u+m|0;n=s>>>0<A[x[g+2084>>2]+(j<<2)>>2];f=n?u:f-u|0;m=n?m:j;continue}break}f=m<<2;if((s|0)!=x[f+x[g+2084>>2]>>2]){break Q}if(y[g+23|0]){x[f+x[g+2088>>2]>>2]=x[b+o>>2];v[x[g+8>>2]+m|0]=G;break R}x[f+x[g+2088>>2]>>2]=h}h=h+1|0;continue}break}break N}_(12315,13274,1230,9998);p()}_(7529,13274,1200,9998);p()}}if(y[g+23|0]){sj(e,b,x[l>>2]<<2);sj(e,x[g+32>>2],x[l>>2]<<2);sj(e,i,x[t>>2]);x[g+32>>2]=0}b=0;h=0;while(1){if((b|0)!=1024){w[(g+(b<<1)|0)+36>>1]=65535;b=b+1|0;continue}break}b=x[g+(y[g+23|0]?2092:4)>>2];b=(b|0)>=32767?32767:b;f=(b|0)>0?b:0;while(1){if((f|0)!=(h|0)){S:{if(y[x[g+8>>2]+h|0]>10){break S}T:{if(y[g+23|0]){b=Im(x[x[g+2084>>2]+(h<<2)>>2]);break T}b=x[x[g+32>>2]+(h<<2)>>2]}while(1){if(b>>>0>1023){break S}w[(g+(b<<1)|0)+36>>1]=h;b=(1<<y[x[g+8>>2]+h|0])+b|0;continue}}h=h+1|0;continue}break}b=sc(e,4);v[g+21|0]=b;b=b&255;if(b>>>0>=3){fc(e,20);break c}if(b){M=g,O=IL(sc(e,32)),B[M+12>>2]=O;M=g,O=IL(sc(e,32)),B[M+16>>2]=O;M=g,N=sc(e,4)+1|0,v[M+20|0]=N;M=g,N=sc(e,1),v[M+22|0]=N;f=x[g>>2];h=x[t>>2];U:{if(y[g+21|0]==1){H=J(Dt(+E(E(kq(+E(h|0)))/E(f|0))));V:{if(F(H)<2147483648){b=~~H;break V}b=-2147483648}L=+(f|0);H=J(ok(+E(E(b|0)+E(1)),L));W:{if(F(H)<2147483648){f=~~H;break W}f=-2147483648}b=((f|0)<=(h|0))+b|0;I=E(b|0);if(ok(+E(I+E(1)),L)<=+(h|0)){b=-1}else{H=J(ok(+I,L));X:{if(F(H)<2147483648){f=~~H;break X}f=-2147483648}b=(f|0)>(h|0)?-1:b}if((b|0)>=0){break U}fc(e,20);break c}b=D(f,h)}x[g+24>>2]=b;if(!b){fc(e,20);break c}s=no(e,b<<1);if(!s){break i}b=0;while(1){i=x[g+24>>2];if((i|0)>(b|0)){f=sc(e,y[g+20|0]);if((f|0)==-1){sj(e,s,x[g+24>>2]<<1);fc(e,20);break c}else{w[s+(b<<1)>>1]=f;b=b+1|0;continue}}break}Y:{Z:{if(y[g+21|0]==1){n=y[g+23|0];_:{if(n){b=x[l>>2];if(b){break _}break Y}b=x[t>>2]}b=ue(e,D(x[g>>2],b)<<2);x[g+28>>2]=b;if(!b){sj(e,s,x[g+24>>2]<<1);fc(e,3);break c}h=0;b=x[(n?l:t)>>2];r=(b|0)>0?b:0;G=g+2088|0;K=E(0);while(1){if((h|0)==(r|0)){break Z}f=h;f=n?x[x[G>>2]+(f<<2)>>2]:f;i=x[g>>2];b=0;l=1;while(1){if((b|0)<(i|0)){I=E(K+E(E(E(z[s+(((f>>>0)/(l>>>0)>>>0)%A[g+24>>2]<<1)>>1])*B[g+16>>2])+B[g+12>>2]));B[(x[g+28>>2]+(D(h,i)<<2)|0)+(b<<2)>>2]=I;K=y[g+22|0]?I:K;b=b+1|0;i=x[g>>2];if((b|0)>=(i|0)){continue}u=x[g+24>>2];Iua(u,0,l,0);if(hb){sj(e,s,u<<1);fc(e,20);break c}else{l=D(l,u);continue}}break}h=h+1|0;continue}}b=ue(e,i<<2);x[g+28>>2]=b;if(!b){break h}b=0;K=E(0);while(1){i=x[g+24>>2];if((i|0)<=(b|0)){break Y}I=E(K+E(E(E(z[s+(b<<1)>>1])*B[g+16>>2])+B[g+12>>2]));B[x[g+28>>2]+(b<<2)>>2]=I;K=y[g+22|0]?I:K;b=b+1|0;continue}}v[g+21|0]=2;i=x[g+24>>2]}sj(e,s,i<<1)}k=k+1|0;continue}break}fc(e,3);break c}fc(e,3);break c}sj(e,s,x[g+24>>2]<<1);fc(e,3);break c}fc(e,20);break c}fc(e,3);break c}v[j+x[g+x[e+28>>2]>>2]|0]=0;m=m+1|0;continue}}b=0}fb=q+1024|0;$:{aa:{if(!b){x[d>>2]=x[C+104>>2]?1:x[C+108>>2];hz(e);break aa}f=C+8|0;b=ue(f,1512);if(b){M=c,N=x[zc(b,f,1512)+32>>2]-a|0,x[M>>2]=N;x[d>>2]=0;break $}hz(C+8|0)}b=0}fb=C+1520|0;return b}function BI(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,r=0,s=0,t=0,u=0,w=0,z=0,B=0,C=0,F=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;p=fb-48|0;fb=p;a:{if(c>>>0<=2){c=c<<2;I=x[c+104892>>2];J=x[c+104880>>2];while(1){c=x[b+4>>2];b:{if((c|0)!=x[b+104>>2]){x[b+4>>2]=c+1;c=y[c|0];break b}c=td(b)}if(hl(c)){continue}break}u=1;c:{d:{switch(c-43|0){case 0:case 2:break d;default:break c}}u=(c|0)==45?-1:1;c=x[b+4>>2];if((c|0)!=x[b+104>>2]){x[b+4>>2]=c+1;c=y[c|0];break c}c=td(b)}e:{f:{while(1){if(v[f+4952|0]==(c|32)){g:{if(f>>>0>6){break g}c=x[b+4>>2];if((c|0)!=x[b+104>>2]){x[b+4>>2]=c+1;c=y[c|0];break g}c=td(b)}f=f+1|0;if((f|0)!=8){continue}break f}break}if((f|0)!=3){e=(f|0)==8;if(e){break f}if(!d|f>>>0<4){break e}if(e){break f}}c=x[b+116>>2];if((c|0)>=0|(c|0)>0){x[b+4>>2]=x[b+4>>2]-1}if(!d|f>>>0<4){break f}c=(c|0)<0;while(1){if(!c){x[b+4>>2]=x[b+4>>2]-1}f=f-1|0;if(f>>>0>3){continue}break}}i=fb-16|0;fb=i;k=(q(E(E(u|0)*E(Infinity))),j(2));b=k&2147483647;h:{if(b-8388608>>>0<=2130706431){c=b;b=b>>>7|0;c=c<<25;d=b+1065353216|0;break h}c=k<<25;d=k>>>7|2147418112;if(b>>>0>=2139095040){break h}c=0;d=0;if(!b){break h}c=b;b=G(b);$f(i,c,0,0,0,b+81|0);g=x[i>>2];h=x[i+4>>2];c=x[i+8>>2];d=x[i+12>>2]^65536|16265-b<<16}x[p>>2]=g;x[p+4>>2]=h;x[p+8>>2]=c;x[p+12>>2]=k&-2147483648|d;fb=i+16|0;g=x[p+8>>2];h=x[p+12>>2];k=x[p>>2];l=x[p+4>>2];break a}i:{j:{k:{if(f){break k}f=0;while(1){if(v[f+9994|0]!=(c|32)){break k}l:{if(f>>>0>1){break l}c=x[b+4>>2];if((c|0)!=x[b+104>>2]){x[b+4>>2]=c+1;c=y[c|0];break l}c=td(b)}f=f+1|0;if((f|0)!=3){continue}break}break j}m:{switch(f|0){case 0:n:{if((c|0)!=48){break n}f=x[b+4>>2];o:{if((f|0)!=x[b+104>>2]){x[b+4>>2]=f+1;f=y[f|0];break o}f=td(b)}if((f&-33)==88){e=fb-432|0;fb=e;c=x[b+4>>2];p:{if((c|0)!=x[b+104>>2]){x[b+4>>2]=c+1;c=y[c|0];break p}c=td(b)}q:{r:{while(1){if((c|0)!=48){s:{if((c|0)!=46){break q}c=x[b+4>>2];if((c|0)==x[b+104>>2]){break s}x[b+4>>2]=c+1;c=y[c|0];break r}}else{c=x[b+4>>2];if((c|0)!=x[b+104>>2]){H=1;x[b+4>>2]=c+1;c=y[c|0]}else{H=1;c=td(b)}continue}break}c=td(b)}t=1;if((c|0)!=48){break q}while(1){c=r;r=c-1|0;s=s-!c|0;c=x[b+4>>2];t:{if((c|0)!=x[b+104>>2]){x[b+4>>2]=c+1;c=y[c|0];break t}c=td(b)}if((c|0)==48){continue}break}H=1}l=1073676288;u:{while(1){v:{w:{x:{f=c;K=c-48|0;if(K>>>0<10){break x}M=(c|0)!=46;f=c|32;if(M&f-97>>>0>5){break u}if(M){break x}if(t){break v}t=1;r=g;s=h;break w}c=(c|0)>57?f-87|0:K;y:{if((h|0)<=0&g>>>0<=7|(h|0)<0){m=c+(m<<4)|0;break y}if(!h&g>>>0<=28){kh(e+48|0,c);Xd(e+32|0,C,F,k,l,0,0,0,1073414144);C=x[e+32>>2];F=x[e+36>>2];k=x[e+40>>2];l=x[e+44>>2];Xd(e+16|0,x[e+48>>2],x[e+52>>2],x[e+56>>2],x[e+60>>2],C,F,k,l);Ug(e,x[e+16>>2],x[e+20>>2],x[e+24>>2],x[e+28>>2],i,n,z,B);z=x[e+8>>2];B=x[e+12>>2];i=x[e>>2];n=x[e+4>>2];break y}if(!c|o){break y}Xd(e+80|0,C,F,k,l,0,0,0,1073610752);Ug(e- -64|0,x[e+80>>2],x[e+84>>2],x[e+88>>2],x[e+92>>2],i,n,z,B);z=x[e+72>>2];B=x[e+76>>2];o=1;i=x[e+64>>2];n=x[e+68>>2]}g=g+1|0;h=g?h:h+1|0;H=1}c=x[b+4>>2];if((c|0)!=x[b+104>>2]){x[b+4>>2]=c+1;c=y[c|0]}else{c=td(b)}continue}break}c=46}z:{if(!H){c=x[b+116>>2];if((c|0)>0){c=1}else{c=(c|0)>=0}A:{B:{if(c){c=x[b+4>>2];x[b+4>>2]=c-1;if(!d){break B}x[b+4>>2]=c-2;if(!t){break A}x[b+4>>2]=c-3;break A}if(d){break A}}Ci(b,0,0)}fj(e+96|0,+(u|0)*0);i=x[e+96>>2];n=x[e+100>>2];c=x[e+108>>2];b=x[e+104>>2];break z}if((h|0)<=0&g>>>0<=7|(h|0)<0){k=g;l=h;while(1){m=m<<4;k=k+1|0;l=k?l:l+1|0;if((k|0)!=8|l){continue}break}}C:{D:{E:{if((c&-33)==80){k=AI(b,d);c=hb;l=c;if(k|(c|0)!=-2147483648){break C}if(d){c=x[b+116>>2];if((c|0)>0){c=1}else{c=(c|0)>=0}if(c){break E}break D}i=0;n=0;Ci(b,0,0);c=0;b=0;break z}k=0;l=0;if(x[b+116>>2]<0){break C}}x[b+4>>2]=x[b+4>>2]-1}k=0;l=0}if(!m){fj(e+112|0,+(u|0)*0);i=x[e+112>>2];n=x[e+116>>2];c=x[e+124>>2];b=x[e+120>>2];break z}b=t?r:g;d=k+(b<<2)|0;b=l+((t?s:h)<<2|b>>>30)|0;g=d-32|0;c=0-I|0;h=(d>>>0<k>>>0?b+1|0:b)-(d>>>0<32)|0;b=h;if((b|0)>0){b=1}else{b=c>>>0<g>>>0&(b|0)>=0}if(b){x[31484]=68;kh(e+160|0,u);Xd(e+144|0,x[e+160>>2],x[e+164>>2],x[e+168>>2],x[e+172>>2],-1,-1,-1,2147418111);Xd(e+128|0,x[e+144>>2],x[e+148>>2],x[e+152>>2],x[e+156>>2],-1,-1,-1,2147418111);i=x[e+128>>2];n=x[e+132>>2];c=x[e+140>>2];b=x[e+136>>2];break z}b=I-226|0;c=b>>31;if((h|0)>=(c|0)&b>>>0<=g>>>0|(c|0)<(h|0)){if((m|0)>=0){while(1){Ug(e+416|0,i,n,z,B,0,0,0,-1073807360);b=qV(i,n,z,B,1073610752);c=(b|0)>=0;b=c;Ug(e+400|0,i,n,z,B,b?x[e+416>>2]:i,b?x[e+420>>2]:n,b?x[e+424>>2]:z,b?x[e+428>>2]:B);b=g;g=b-1|0;h=h-!b|0;z=x[e+408>>2];B=x[e+412>>2];i=x[e+400>>2];n=x[e+404>>2];m=c|m<<1;if((m|0)>=0){continue}break}}b=h-((I>>31)+(g>>>0<I>>>0)|0)|0;c=(g-I|0)+32|0;b=c>>>0<32?b+1|0:b;c=c>>>0<J>>>0&(b|0)<=0|(b|0)<0?(c|0)>0?c:0:J;F:{if((c|0)>=113){kh(e+384|0,u);r=x[e+392>>2];s=x[e+396>>2];C=x[e+384>>2];F=x[e+388>>2];k=0;b=0;break F}fj(e+352|0,kk(1,144-c|0));kh(e+336|0,u);C=x[e+336>>2];F=x[e+340>>2];r=x[e+344>>2];s=x[e+348>>2];yI(e+368|0,x[e+352>>2],x[e+356>>2],x[e+360>>2],x[e+364>>2],C,F,r,s);w=x[e+376>>2];L=x[e+380>>2];k=x[e+372>>2];b=x[e+368>>2]}d=!(m&1)&((fn(i,n,z,B,0,0,0,0)|0)!=0&(c|0)<32);Vn(e+320|0,d|m);Xd(e+304|0,C,F,r,s,x[e+320>>2],x[e+324>>2],x[e+328>>2],x[e+332>>2]);c=b;Ug(e+272|0,x[e+304>>2],x[e+308>>2],x[e+312>>2],x[e+316>>2],b,k,w,L);b=d;Xd(e+288|0,C,F,r,s,b?0:i,b?0:n,b?0:z,b?0:B);Ug(e+256|0,x[e+288>>2],x[e+292>>2],x[e+296>>2],x[e+300>>2],x[e+272>>2],x[e+276>>2],x[e+280>>2],x[e+284>>2]);zz(e+240|0,x[e+256>>2],x[e+260>>2],x[e+264>>2],x[e+268>>2],c,k,w,L);b=x[e+240>>2];d=x[e+244>>2];c=x[e+248>>2];k=x[e+252>>2];if(!fn(b,d,c,k,0,0,0,0)){x[31484]=68}xI(e+224|0,b,d,c,k,g);i=x[e+224>>2];n=x[e+228>>2];c=x[e+236>>2];b=x[e+232>>2];break z}x[31484]=68;kh(e+208|0,u);Xd(e+192|0,x[e+208>>2],x[e+212>>2],x[e+216>>2],x[e+220>>2],0,0,0,65536);Xd(e+176|0,x[e+192>>2],x[e+196>>2],x[e+200>>2],x[e+204>>2],0,0,0,65536);i=x[e+176>>2];n=x[e+180>>2];c=x[e+188>>2];b=x[e+184>>2]}x[p+16>>2]=i;x[p+20>>2]=n;x[p+24>>2]=b;x[p+28>>2]=c;fb=e+432|0;g=x[p+24>>2];h=x[p+28>>2];k=x[p+16>>2];l=x[p+20>>2];break a}if(x[b+116>>2]<0){break n}x[b+4>>2]=x[b+4>>2]-1}f=b;i=c;w=d;d=0;e=fb-8976|0;fb=e;K=0-I|0;L=K-J|0;G:{H:{while(1){if((i|0)!=48){I:{if((i|0)!=46){break G}b=x[f+4>>2];if((b|0)==x[f+104>>2]){break I}x[f+4>>2]=b+1;i=y[b|0];break H}}else{b=x[f+4>>2];if((b|0)!=x[f+104>>2]){x[f+4>>2]=b+1;i=y[b|0]}else{i=td(f)}d=1;continue}break}i=td(f)}H=1;if((i|0)!=48){break G}while(1){b=g;g=b-1|0;h=h-!b|0;b=x[f+4>>2];J:{if((b|0)!=x[f+104>>2]){x[f+4>>2]=b+1;i=y[b|0];break J}i=td(f)}if((i|0)==48){continue}break}d=1}x[e+784>>2]=0;K:{L:{b=(i|0)==46;c=i-48|0;M:{N:{O:{if(b|c>>>0<=9){while(1){P:{if(b&1){if(!H){g=k;h=l;H=1;break P}b=!d;break O}k=k+1|0;l=k?l:l+1|0;if((m|0)<=2044){t=(i|0)==48?t:k;b=(e+784|0)+(m<<2)|0;if(o){c=(D(x[b>>2],10)+i|0)-48|0}x[b>>2]=c;d=1;c=o+1|0;b=(c|0)==9;o=b?0:c;m=b+m|0;break P}if((i|0)==48){break P}x[e+8960>>2]=x[e+8960>>2]|1;t=18396}b=x[f+4>>2];Q:{if((b|0)!=x[f+104>>2]){x[f+4>>2]=b+1;i=y[b|0];break Q}i=td(f)}b=(i|0)==46;c=i-48|0;if(b|c>>>0<10){continue}break}}g=H?g:k;h=H?h:l;if(!(!d|(i&-33)!=69)){i=AI(f,w);b=hb;n=b;R:{if(i|(b|0)!=-2147483648){break R}if(!w){break M}i=0;n=0;if(x[f+116>>2]<0){break R}x[f+4>>2]=x[f+4>>2]-1}h=h+n|0;g=g+i|0;h=g>>>0<i>>>0?h+1|0:h;break L}b=!d;if((i|0)<0){break N}}if(x[f+116>>2]<0){break N}x[f+4>>2]=x[f+4>>2]-1}if(!b){break L}x[31484]=28}Ci(f,0,0);g=0;h=0;c=0;b=0;break K}b=x[e+784>>2];if(!b){fj(e,+(u|0)*0);g=x[e+8>>2];h=x[e+12>>2];c=x[e+4>>2];b=x[e>>2];break K}if(!((g|0)!=(k|0)|(h|0)!=(l|0)|(k>>>0>9&(l|0)>=0|(l|0)>0)|(b>>>J|0?(J|0)<=30:0))){kh(e+48|0,u);Vn(e+32|0,b);Xd(e+16|0,x[e+48>>2],x[e+52>>2],x[e+56>>2],x[e+60>>2],x[e+32>>2],x[e+36>>2],x[e+40>>2],x[e+44>>2]);g=x[e+24>>2];h=x[e+28>>2];c=x[e+20>>2];b=x[e+16>>2];break K}b=K>>>1|0;if(b>>>0<g>>>0&(h|0)>=0|(h|0)>0){x[31484]=68;kh(e+96|0,u);Xd(e+80|0,x[e+96>>2],x[e+100>>2],x[e+104>>2],x[e+108>>2],-1,-1,-1,2147418111);Xd(e- -64|0,x[e+80>>2],x[e+84>>2],x[e+88>>2],x[e+92>>2],-1,-1,-1,2147418111);g=x[e+72>>2];h=x[e+76>>2];c=x[e+68>>2];b=x[e+64>>2];break K}b=I-226|0;c=g>>>0<b>>>0;b=b>>31;if(c&(h|0)<=(b|0)|(b|0)>(h|0)){x[31484]=68;kh(e+144|0,u);Xd(e+128|0,x[e+144>>2],x[e+148>>2],x[e+152>>2],x[e+156>>2],0,0,0,65536);Xd(e+112|0,x[e+128>>2],x[e+132>>2],x[e+136>>2],x[e+140>>2],0,0,0,65536);g=x[e+120>>2];h=x[e+124>>2];c=x[e+116>>2];b=x[e+112>>2];break K}if(o){if((o|0)<=8){b=(e+784|0)+(m<<2)|0;f=x[b>>2];while(1){f=D(f,10);o=o+1|0;if((o|0)!=9){continue}break}x[b>>2]=f}m=m+1|0}o=g;S:{if((g|0)<(t|0)|(t|0)>=9|(g|0)>17){break S}if((g|0)==9){kh(e+192|0,u);Vn(e+176|0,x[e+784>>2]);Xd(e+160|0,x[e+192>>2],x[e+196>>2],x[e+200>>2],x[e+204>>2],x[e+176>>2],x[e+180>>2],x[e+184>>2],x[e+188>>2]);g=x[e+168>>2];h=x[e+172>>2];c=x[e+164>>2];b=x[e+160>>2];break K}if((o|0)<=8){kh(e+272|0,u);Vn(e+256|0,x[e+784>>2]);Xd(e+240|0,x[e+272>>2],x[e+276>>2],x[e+280>>2],x[e+284>>2],x[e+256>>2],x[e+260>>2],x[e+264>>2],x[e+268>>2]);kh(e+224|0,x[(0-o<<2)+104880>>2]);KR(e+208|0,x[e+240>>2],x[e+244>>2],x[e+248>>2],x[e+252>>2],x[e+224>>2],x[e+228>>2],x[e+232>>2],x[e+236>>2]);g=x[e+216>>2];h=x[e+220>>2];c=x[e+212>>2];b=x[e+208>>2];break K}b=(D(o,-3)+J|0)+27|0;c=x[e+784>>2];if(c>>>b|0?(b|0)<=30:0){break S}kh(e+352|0,u);Vn(e+336|0,c);Xd(e+320|0,x[e+352>>2],x[e+356>>2],x[e+360>>2],x[e+364>>2],x[e+336>>2],x[e+340>>2],x[e+344>>2],x[e+348>>2]);kh(e+304|0,x[(o<<2)+104808>>2]);Xd(e+288|0,x[e+320>>2],x[e+324>>2],x[e+328>>2],x[e+332>>2],x[e+304>>2],x[e+308>>2],x[e+312>>2],x[e+316>>2]);g=x[e+296>>2];h=x[e+300>>2];c=x[e+292>>2];b=x[e+288>>2];break K}while(1){b=m;m=b-1|0;if(!x[(e+784|0)+(m<<2)>>2]){continue}break}t=0;d=(o|0)%9|0;T:{if(!d){c=0;break T}c=0;d=(o|0)<0?d+9|0:d;U:{if(!b){b=0;break U}g=x[(0-d<<2)+104880>>2];h=1e9/(g|0)|0;i=0;f=0;while(1){k=i;l=e+784|0;i=l+(f<<2)|0;m=x[i>>2];w=(m>>>0)/(g>>>0)|0;k=k+w|0;x[i>>2]=k;k=!k&(c|0)==(f|0);c=k?c+1&2047:c;o=k?o-9|0:o;i=D(h,m-D(g,w)|0);f=f+1|0;if((f|0)!=(b|0)){continue}break}if(!i){break U}x[l+(b<<2)>>2]=i;b=b+1|0}o=(o-d|0)+9|0}while(1){f=(e+784|0)+(c<<2)|0;w=(o|0)<36;V:{while(1){W:{if(w){break W}if((o|0)!=36){break V}if(A[f>>2]<=10384592){break W}o=36;break V}m=b+2047|0;d=0;while(1){k=b;i=m&2047;m=(e+784|0)+(i<<2)|0;b=x[m>>2];l=b>>>3|0;g=d;d=b<<29;g=g+d|0;b=l;h=d>>>0>g>>>0?b+1|0:b;if(!h&g>>>0<1000000001){d=0}else{d=Kua(g,h,1e9,0);b=Iua(d,hb,-1e9,-1);g=b+g|0}x[m>>2]=g;b=(c|0)==(i|0)?k:g?k:i;g=k-1&2047;b=(g|0)!=(i|0)?k:b;m=i-1|0;if((c|0)!=(i|0)){continue}break}t=t-29|0;b=k;if(!d){continue}break}c=c-1&2047;if((c|0)==(b|0)){i=(b+2046&2047)<<2;b=e+784|0;k=i+b|0;x[k>>2]=x[k>>2]|x[b+(g<<2)>>2];b=g}o=o+9|0;x[(e+784|0)+(c<<2)>>2]=d;continue}break}X:{Y:while(1){g=b+1&2047;i=(e+784|0)+((b-1&2047)<<2)|0;while(1){k=(o|0)>45?9:1;h=(o|0)!=36;Z:{while(1){d=c;f=0;_:{while(1){$:{c=d+f&2047;if((c|0)==(b|0)){break $}c=x[(e+784|0)+(c<<2)>>2];l=x[(f<<2)+104832>>2];if(c>>>0<l>>>0){break $}if(c>>>0>l>>>0){break _}f=f+1|0;if((f|0)!=4){continue}}break}if(h){break _}f=0;g=0;h=0;k=0;l=0;while(1){c=d+f&2047;if((c|0)==(b|0)){b=b+1&2047;x[((b<<2)+e|0)+780>>2]=0}Vn(e+768|0,x[(e+784|0)+(c<<2)>>2]);Xd(e+752|0,g,h,k,l,0,0,1342177280,1075633366);Ug(e+736|0,x[e+752>>2],x[e+756>>2],x[e+760>>2],x[e+764>>2],x[e+768>>2],x[e+772>>2],x[e+776>>2],x[e+780>>2]);k=x[e+744>>2];l=x[e+748>>2];g=x[e+736>>2];h=x[e+740>>2];f=f+1|0;if((f|0)!=4){continue}break}kh(e+720|0,u);Xd(e+704|0,g,h,k,l,x[e+720>>2],x[e+724>>2],x[e+728>>2],x[e+732>>2]);k=x[e+712>>2];l=x[e+716>>2];g=0;h=0;i=x[e+704>>2];n=x[e+708>>2];w=t+113|0;f=w-I|0;o=(f|0)<(J|0);c=o?(f|0)>0?f:0:J;if((c|0)<=112){break Z}break X}t=k+t|0;c=b;if((b|0)==(d|0)){continue}break}l=1e9>>>k|0;m=-1<<k^-1;f=0;c=d;while(1){h=f;w=e+784|0;f=w+(d<<2)|0;n=x[f>>2];h=h+(n>>>k|0)|0;x[f>>2]=h;h=!h&(c|0)==(d|0);c=h?c+1&2047:c;o=h?o-9|0:o;f=D(l,n&m);d=d+1&2047;if((d|0)!=(b|0)){continue}break}if(!f){continue}if((c|0)!=(g|0)){x[w+(b<<2)>>2]=f;b=g;continue Y}x[i>>2]=x[i>>2]|1;continue}break}break}fj(e+656|0,kk(1,225-c|0));yI(e+688|0,x[e+656>>2],x[e+660>>2],x[e+664>>2],x[e+668>>2],i,n,k,l);C=x[e+696>>2];F=x[e+700>>2];z=x[e+688>>2];B=x[e+692>>2];fj(e+640|0,kk(1,113-c|0));iR(e+672|0,i,n,k,l,x[e+640>>2],x[e+644>>2],x[e+648>>2],x[e+652>>2]);g=x[e+672>>2];h=x[e+676>>2];r=x[e+680>>2];s=x[e+684>>2];zz(e+624|0,i,n,k,l,g,h,r,s);Ug(e+608|0,z,B,C,F,x[e+624>>2],x[e+628>>2],x[e+632>>2],x[e+636>>2]);k=x[e+616>>2];l=x[e+620>>2];i=x[e+608>>2];n=x[e+612>>2]}m=d+4&2047;aa:{if((m|0)==(b|0)){break aa}m=x[(e+784|0)+(m<<2)>>2];ba:{if(m>>>0<=499999999){if(!m&(d+5&2047)==(b|0)){break ba}fj(e+496|0,+(u|0)*.25);Ug(e+480|0,g,h,r,s,x[e+496>>2],x[e+500>>2],x[e+504>>2],x[e+508>>2]);r=x[e+488>>2];s=x[e+492>>2];g=x[e+480>>2];h=x[e+484>>2];break ba}if((m|0)!=5e8){fj(e+592|0,+(u|0)*.75);Ug(e+576|0,g,h,r,s,x[e+592>>2],x[e+596>>2],x[e+600>>2],x[e+604>>2]);r=x[e+584>>2];s=x[e+588>>2];g=x[e+576>>2];h=x[e+580>>2];break ba}N=+(u|0);if((d+5&2047)==(b|0)){fj(e+528|0,N*.5);Ug(e+512|0,g,h,r,s,x[e+528>>2],x[e+532>>2],x[e+536>>2],x[e+540>>2]);r=x[e+520>>2];s=x[e+524>>2];g=x[e+512>>2];h=x[e+516>>2];break ba}fj(e+560|0,N*.75);Ug(e+544|0,g,h,r,s,x[e+560>>2],x[e+564>>2],x[e+568>>2],x[e+572>>2]);r=x[e+552>>2];s=x[e+556>>2];g=x[e+544>>2];h=x[e+548>>2]}if((c|0)>111){break aa}iR(e+464|0,g,h,r,s,0,0,0,1073676288);if(fn(x[e+464>>2],x[e+468>>2],x[e+472>>2],x[e+476>>2],0,0,0,0)){break aa}Ug(e+448|0,g,h,r,s,0,0,0,1073676288);r=x[e+456>>2];s=x[e+460>>2];g=x[e+448>>2];h=x[e+452>>2]}Ug(e+432|0,i,n,k,l,g,h,r,s);zz(e+416|0,x[e+432>>2],x[e+436>>2],x[e+440>>2],x[e+444>>2],z,B,C,F);k=x[e+424>>2];l=x[e+428>>2];i=x[e+416>>2];n=x[e+420>>2];ca:{if((L-2|0)>=(w&2147483647)){break ca}x[e+408>>2]=k;x[e+412>>2]=l&2147483647;x[e+400>>2]=i;x[e+404>>2]=n;Xd(e+384|0,i,n,k,l,0,0,0,1073610752);d=qV(x[e+400>>2],x[e+404>>2],x[e+408>>2],x[e+412>>2],1081081856);b=(d|0)>=0;k=b?x[e+392>>2]:k;l=b?x[e+396>>2]:l;i=b?x[e+384>>2]:i;n=b?x[e+388>>2]:n;t=b+t|0;if(!(o&((c|0)!=(f|0)|(d|0)<0)&(fn(g,h,r,s,0,0,0,0)|0)!=0)&(t+110|0)<=(L|0)){break ca}x[31484]=68}xI(e+368|0,i,n,k,l,t);g=x[e+376>>2];h=x[e+380>>2];c=x[e+372>>2];b=x[e+368>>2]}x[p+40>>2]=g;x[p+44>>2]=h;x[p+32>>2]=b;x[p+36>>2]=c;fb=e+8976|0;g=x[p+40>>2];h=x[p+44>>2];k=x[p+32>>2];l=x[p+36>>2];break a;case 3:break j;default:break m}}c=x[b+116>>2];if((c|0)>0){c=1}else{c=(c|0)>=0}if(c){x[b+4>>2]=x[b+4>>2]-1}break i}da:{c=x[b+4>>2];ea:{if((c|0)!=x[b+104>>2]){x[b+4>>2]=c+1;c=y[c|0];break ea}c=td(b)}if((c|0)==40){f=1;break da}h=2147450880;if(x[b+116>>2]<0){break a}x[b+4>>2]=x[b+4>>2]-1;break a}while(1){c=x[b+4>>2];fa:{if((c|0)!=x[b+104>>2]){x[b+4>>2]=c+1;c=y[c|0];break fa}c=td(b)}if(!(!(c-48>>>0<10|c-65>>>0<26|(c|0)==95)&c-97>>>0>=26)){f=f+1|0;continue}break}h=2147450880;if((c|0)==41){break a}c=x[b+116>>2];if((c|0)>=0|(c|0)>0){x[b+4>>2]=x[b+4>>2]-1}ga:{if(d){if(f){break ga}break a}break i}while(1){if((c|0)>0|(c|0)>=0){x[b+4>>2]=x[b+4>>2]-1}f=f-1|0;if(f){continue}break}break a}x[31484]=28;Ci(b,0,0)}h=0}x[a>>2]=k;x[a+4>>2]=l;x[a+8>>2]=g;x[a+12>>2]=h;fb=p+48|0}function kra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0;e=fb-416|0;fb=e;yc(b);f=e+411|0;d=BE(b,f);if(!d){$Y(f)}a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if(!d){break j}if(!aZ(f)){break j}F=1;if((c|0)==64){break j}H=Ie(e+388|0,b);x[31609]=0;d=e+376|0;O(508,d|0,H|0);b=x[31609];x[31609]=0;k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{if((b|0)!=1){x[31609]=0;f=e+356|0;S(509,f|0,d|0,20041);b=x[31609];x[31609]=0;if((b|0)==1){break t}F=0;x[31609]=0;d=R(172,x[e+356>>2])|0;b=x[31609];x[31609]=0;if((b|0)==1){break l}if(!d){break k}x[31609]=0;d=P(510,f|0,e+265|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break l}if(!d){break k}x[31609]=0;O(246,a|0,16384);b=x[31609];x[31609]=0;if((b|0)==1){break l}x[a+480208>>2]=8;x[31609]=0;d=U(266,a+1074312|0,9,1)|0;b=x[31609];x[31609]=0;if((b|0)==1){break l}x[31609]=0;d=U(266,d|0,114,1)|0;b=x[31609];x[31609]=0;if((b|0)==1){break l}x[31609]=0;d=P(267,d|0,21)|0;b=x[31609];x[31609]=0;if((b|0)==1){break l}x[31609]=0;P(267,d|0,30)|0;b=x[31609];x[31609]=0;if((b|0)==1){break l}x[31609]=0;d=P(1,e+252|0,8280)|0;b=x[31609];x[31609]=0;if((b|0)==1){break q}zb(a+1298344|0,d);tb(d);x[31609]=0;d=P(1,e+240|0,10767)|0;b=x[31609];x[31609]=0;if((b|0)==1){break p}zb(a+1298356|0,d);tb(d);x[31609]=0;f=P(1,e+228|0,18149)|0;b=x[31609];x[31609]=0;if((b|0)==1){break o}d=15140;b=y[e+415|0];switch(b-16|0){case 1:break m;case 0:break s;default:break r}}h=N()|0;break a}h=N()|0;break b}d=15121;break m}if(!b){break n}d=22292;break m}h=N()|0;break c}h=N()|0;break c}h=N()|0;break c}d=13338}x[31609]=0;d=P(1,e+216|0,d|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break e}x[31609]=0;i=e+192|0;S(2,i|0,f|0,d|0);b=x[31609];x[31609]=0;if((b|0)==1){break f}zb(a+1298368|0,i);tb(i);tb(d);tb(f);I=a+1298404|0,J=x[Fc(i,4)>>2],x[I>>2]=J;d=e+84|0;Te(d,3,e+265|0);x[31609]=0;O(218,i|0,d|0);b=x[31609];x[31609]=0;if((b|0)==1){break g}zb(a+1298308|0,i);tb(i);qi(d,3,e+297|0);x[31609]=0;S(369,i|0,4,d|0);b=x[31609];x[31609]=0;if((b|0)==1){break h}zb(a+1298320|0,i);tb(i);x[a+480200>>2]=y[e+321|0]+1;I=a,J=Ld(y[e+322|0],1,255),x[I+480196>>2]=J;I=a,J=D(Ld(y[e+323|0],4,255),1e4),x[I+480204>>2]=J;d=y[a+484376|0];b=x[a+484360>>2];x[31609]=0;aa(348,Xb(b,d)|0,e+356|0,y[e+317|0]|y[e+318|0]<<8,65535,65535);b=x[31609];x[31609]=0;if((b|0)==1){break l}$e(Xb(x[a+484360>>2],y[a+484376|0]),y[e+319|0]|y[e+320|0]<<8);w[a+480188>>1]=0;b=0;while(1){if((b|0)==32){x[31609]=0;g=e+192|0;f=e+376|0;S(509,g|0,f|0,17741);b=x[31609];x[31609]=0;if((b|0)!=1){i=kd(e+356|0,g);ub(g);b=x[i>>2];x[31609]=0;d=R(154,b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break l}x[31609]=0;V(336,a+1298332|0,i|0,d|0,0);b=x[31609];x[31609]=0;if((b|0)==1){break l}x[31609]=0;S(509,g|0,f|0,21321);b=x[31609];x[31609]=0;if((b|0)!=1){k=kd(i,g);ub(g);b=x[k>>2];x[31609]=0;d=R(172,b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break l}u:{v:{if(d){x[31609]=0;S(509,g|0,f|0,16723);b=x[31609];x[31609]=0;if((b|0)==1){break u}x[31609]=0;g=R(197,k|0)|0;b=x[31609];x[31609]=0;w:{if((b|0)!=1){i=c&2;f=0;while(1){if(g>>>0<=(f&255)>>>0){break w}x[31609]=0;j=R(197,k|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break v}if(!j){break w}d=x[k+8>>2];b=x[k>>2];x[31609]=0;d=U(150,b|0,d|0,56)|0;b=x[31609];x[31609]=0;if((b|0)==1){break v}if(!d){break w}if(j>>>0>z[a+480190>>1]){w[a+480190>>1]=j}x[31609]=0;o=D(j,104)+a|0;m=o+484380|0;O(279,m|0,0);b=x[31609];x[31609]=0;if((b|0)==1){break v}fp(m);x[31609]=0;S(317,k|0,((j<<5)+a|0)+946304|0,32);b=x[31609];x[31609]=0;if((b|0)==1){break v}x[31609]=0;O(320,k|0,o+484423|0);b=x[31609];x[31609]=0;if((b|0)==1){break v}x:{if(y[e+415|0]<=15){x[31609]=0;h=R(189,k|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break x}break v}x[31609]=0;h=R(151,k|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break v}}x[o+484404>>2]=h<<1;x[31609]=0;d=R(151,k|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break v}x[m>>2]=d;x[31609]=0;d=R(151,k|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break v}C=o+484384|0;x[C>>2]=d;x[31609]=0;d=R(151,k|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break v}E=o+484388|0;x[E>>2]=d;if(d){b=o+484414|0;w[b>>1]=z[b>>1]|2;x[E>>2]=d+x[C>>2]}x[31609]=0;d=R(197,k|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break v}if(y[e+415|0]<=15){w[o+484410>>1]=d}x[31609]=0;j=R(197,k|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break v}b=o+484414|0;d=z[b>>1];q=8;if(j&1){d=d|1;w[b>>1]=d;x[m>>2]=x[m>>2]>>>1;x[C>>2]=x[C>>2]>>>1;x[E>>2]=x[E>>2]>>>1;q=16}w[b>>1]=d&65531|j<<1&4;b=Zc(e+84|0,q,1,0,((j&12)!=0)<<3);y:{if(!i){break y}x[31609]=0;U(215,b|0,m|0,e+192|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break y}break v}f=f+1|0;continue}}break v}ub(e+192|0)}x[31609]=0;d=e+192|0;f=e+376|0;S(509,d|0,f|0,18761);b=x[31609];x[31609]=0;z:{if((b|0)!=1){n=kd(k,d);ub(d);b=x[n>>2];x[31609]=0;d=R(172,b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break l}if(!d){break z}r=Nb(e+84|0);u=Nb(e+180|0);s=Nb(e+168|0);x[31609]=0;S(509,e+148|0,f|0,17750);b=x[31609];x[31609]=0;A:{if((b|0)==1){break A}b=x[e+160>>2];x[e+56>>2]=x[e+156>>2];x[e+60>>2]=b;x[e- -64>>2]=x[e+164>>2];x[31609]=0;b=x[e+152>>2];x[e+48>>2]=x[e+148>>2];x[e+52>>2]=b;O(511,e+48|0,r|0);b=x[31609];x[31609]=0;if((b|0)==1){break A}x[31609]=0;S(509,e+128|0,f|0,17744);b=x[31609];x[31609]=0;if((b|0)==1){break A}b=x[e+140>>2];x[e+32>>2]=x[e+136>>2];x[e+36>>2]=b;x[e+40>>2]=x[e+144>>2];x[31609]=0;b=x[e+132>>2];x[e+24>>2]=x[e+128>>2];x[e+28>>2]=b;O(511,e+24|0,u|0);b=x[31609];x[31609]=0;if((b|0)==1){break A}x[31609]=0;S(509,e+108|0,f|0,17734);b=x[31609];x[31609]=0;if((b|0)==1){break A}b=x[e+120>>2];x[e+8>>2]=x[e+116>>2];x[e+12>>2]=b;x[e+16>>2]=x[e+124>>2];x[31609]=0;b=x[e+112>>2];x[e>>2]=x[e+108>>2];x[e+4>>2]=b;O(511,e|0,s|0);b=x[31609];x[31609]=0;if((b|0)==1){break A}x[31609]=0;o=R(197,n|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break A}q=0;while(1){if(o>>>0<=(q&255)>>>0){Zo(s);Zo(u);Zo(r);break z}x[31609]=0;d=e+72|0;O(198,d|0,n|0);b=x[31609];x[31609]=0;B:{if((b|0)!=1){F=Jc(d);C:{D:{if(!y[e+72|0]){break D}f=x[n+8>>2];d=x[n>>2];b=y[F|0];x[31609]=0;d=U(150,d|0,f|0,D(b,14)+32|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break A}if(!d){break D}x[31609]=0;l=U(251,a|0,y[e+72|0],0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break A}if(l){break C}}b=y[F|0];x[31609]=0;P(183,n|0,D(b,14)+32|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break B}break A}x[31609]=0;S(317,n|0,l+492|0,32);b=x[31609];x[31609]=0;if((b|0)==1){break A}m=l+88|0;C=l+68|0;E=l+48|0;j=l+236|0;b=0;f=0;while(1){if(y[F|0]<=(f&255)>>>0){break B}x[31609]=0;O(512,n|0,e+192|0);d=x[31609];x[31609]=0;if((d|0)==1){break A}d=y[e+192|0];E:{if(!d|d>>>0>z[a+480190>>1]){break E}if(y[e+193|0]>=129){v[e+193|0]=128}while(1){d=b&255;g=y[e+193|0];if(d>>>0>g>>>0){d=x[r+4>>2];b=x[r>>2];x[31609]=0;V(513,E|0,y[e+195|0],b|0,d|0);b=x[31609];x[31609]=0;if((b|0)==1){break A}d=x[u+4>>2];b=x[u>>2];x[31609]=0;V(513,C|0,y[e+197|0],b|0,d|0);b=x[31609];x[31609]=0;if((b|0)==1){break A}d=x[s+4>>2];b=x[s>>2];x[31609]=0;V(513,m|0,y[e+205|0],b|0,d|0);b=x[31609];x[31609]=0;if((b|0)==1){break A}x[l>>2]=(y[e+198|0]|y[e+199|0]<<8)+1>>>1;d=y[e+192|0];F:{if(y[e+195|0]&64){w[(D(d,104)+a|0)+484410>>1]=y[e+194|0];break F}b=(D(d,104)+a|0)+484414|0;w[b>>1]=z[b>>1]|32768}w[e+106>>1]=y[e+196|0]<<1;w[e+104>>1]=254;t=D(d,104)+a|0;I=t+484408|0,J=z[Oc(e+106|0,e+104|0)>>1],w[I>>1]=J;v[t+484418|0]=y[(y[e+203|0]&3)+25060|0];d=t+484419|0;k=y[e+202|0];v[d|0]=k;i=y[e+201|0]+3>>>2|0;v[t+484420|0]=i;v[t+484421|0]=y[e+200|0];b=g+1|0;if(k){i=ti(Bc(((i<<8|k>>>1)>>>0)/(k>>>0)|0,0))}else{i=255}v[d|0]=i;if(!(y[e+197|0]&64)){break E}d=t+484414|0;w[d>>1]=z[d>>1]|32}else{I=bc(j,d),J=y[e+192|0],w[I>>1]=J;b=b+1|0;continue}break}}f=f+1|0;continue}}break A}q=q+1|0;continue}}h=N()|0;Zo(s);Zo(u);Zo(r);break c}h=N()|0;break c}F=1;G=Nb(e+180|0);G:{if(!(c&1)){break G}x[31609]=0;d=e+192|0;S(509,d|0,e+376|0,21076);b=x[31609];x[31609]=0;H:{I:{J:{K:{L:{M:{if((b|0)!=1){g=kd(n,d);b=x[g>>2];x[31609]=0;c=R(172,b|0)|0;b=x[31609];x[31609]=0;N:{O:{P:{if((b|0)!=1){ub(d);if(!c){break N}x[31609]=0;d=R(189,g|0)|0;c=x[31609];x[31609]=0;b=1;if((c|0)==1){break P}x[31609]=0;f=d+1|0;O(514,G|0,f|0);c=x[31609];x[31609]=0;if((c|0)==1){break P}while(1){if((b|0)==(f|0)){break N}x[31609]=0;d=R(189,g|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break O}x[31609]=0;i=e+84|0;S(185,i|0,g|0,d|0);c=x[31609];x[31609]=0;if((c|0)==1){break O}c=hc(e+192|0,i);kd(ch(x[G>>2],b),c);ub(c);b=b+1|0;ub(i);continue}}h=N()|0;ub(e+192|0);break H}h=N()|0;break H}h=N()|0;break H}x[31609]=0;d=e+192|0;S(509,d|0,e+376|0,16720);b=x[31609];x[31609]=0;if((b|0)==1){break J}B=kd(g,d);b=x[B>>2];x[31609]=0;c=R(172,b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break K}ub(d);if(!c){break M}x[31609]=0;k=R(197,B|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break I}l=0;Q:{R:{S:while(1){T:{if(k>>>0<=(l&65535)>>>0){x[31609]=0;P(149,B|0,1)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break T}break I}f=32;U:{if(y[e+415|0]<16){break U}x[31609]=0;O(515,B|0,e+192|0);b=x[31609];x[31609]=0;if((b|0)==1){break Q}f=y[e+192|0];if(f>>>0<=z[a+480188>>1]|f>>>0>32){break U}w[a+480188>>1]=f}b=0;while(1){i=b&65535;if(i>>>0>=f>>>0){l=l+1|0;continue S}x[31609]=0;d=R(189,B|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break R}if(!(!d|i>>>0>31|i>>>0<z[a+480188>>1])){w[a+480188>>1]=b+1}b=b+1|0;continue}}break}x[31609]=0;r=a+484344|0;O(223,r|0,k|0);b=x[31609];x[31609]=0;if((b|0)==1){break I}C=e+194|0;n=0;while(1){if((k|0)==(n|0)){break M}u=Fb(e+84|0);V:{if(y[e+415|0]<16){c=32;i=64;break V}x[31609]=0;O(515,B|0,e+192|0);b=x[31609];x[31609]=0;if((b|0)==1){break L}d=y[e+193|0];c=y[e+192|0];b=e+72|0;bf(b,C,16,3);x[31609]=0;f=e+168|0;O(218,f|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break L}zb(u,f);tb(f);i=d+1|0}x[31609]=0;d=U(196,r|0,n&65535,i|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break L}W:{if(!d){x[31609]=0;P(183,B|0,c<<1)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break W}break L}b=x[r>>2];x[31609]=0;O(283,Wb(b,n)|0,u|0);b=x[31609];x[31609]=0;if((b|0)==1){break L}E=i-1|0;o=0;while(1){s=o&65535;if(s>>>0>=c>>>0){break W}x[31609]=0;d=R(189,B|0)|0;b=x[31609];x[31609]=0;X:{if((b|0)!=1){if(!d){break X}b=x[G>>2];if(Sf(b,x[G+4>>2])>>>0<=d>>>0|s>>>0>=z[a+480188>>1]){break X}A=ch(b,d);yc(A);f=0;Y:while(1){d=f;if(i>>>0<=d>>>0){break X}g=x[A+8>>2];b=x[A>>2];x[31609]=0;g=U(150,b|0,g|0,1)|0;b=x[31609];x[31609]=0;Z:{_:{$:{aa:{ba:{if((b|0)!=1){if(!g){break X}b=Wb(x[r>>2],n);b=md(x[b>>2],x[x[b+48>>2]+12>>2],d,s);x[31609]=0;g=R(197,A|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break L}m=g<<24>>24;h=(m&252)>>>2|0;switch((m&3)-1|0){case 2:break _;case 1:break $;case 0:break aa;default:break ba}}break L}f=(d+h|0)+1|0;continue}f=0;if(!d){continue}f=Wb(x[r>>2],n);j=md(x[f>>2],x[x[f+48>>2]+12>>2],d-1|0,s);while(1){f=y[j|0]|y[j+1|0]<<8|(y[j+2|0]<<16|y[j+3|0]<<24);v[b|0]=f;v[b+1|0]=f>>>8;v[b+2|0]=f>>>16;v[b+3|0]=f>>>24;f=y[j+4|0]|y[j+5|0]<<8;v[b+4|0]=f;v[b+5|0]=f>>>8;f=d+1|0;if((d|0)==(E|0)){continue Y}b=D(z[a+480188>>1],6)+b|0;g=h&255;d=f;h=h-1|0;if(g){continue}break}continue}if(d>>>0<=h>>>0){break Z}f=Wb(x[r>>2],n);g=md(x[f>>2],x[x[f+48>>2]+12>>2],h,s);f=y[g|0]|y[g+1|0]<<8|(y[g+2|0]<<16|y[g+3|0]<<24);v[b|0]=f;v[b+1|0]=f>>>8;v[b+2|0]=f>>>16;v[b+3|0]=f>>>24;f=y[g+4|0]|y[g+5|0]<<8;v[b+4|0]=f;v[b+5|0]=f>>>8;break Z}if(h&1){x[31609]=0;g=R(197,A|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break L}v[b|0]=g>>>0>120?-1:g}if(h&2){x[31609]=0;g=R(197,A|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break L}v[b+1|0]=g}l=0;f=0;ca:{if(h&4){x[31609]=0;f=R(197,A|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break ca}}t=0;if(h&8){x[31609]=0;j=R(197,A|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break ca}l=j&15;t=j>>>4|0}q=0;j=0;if(h&16){x[31609]=0;j=R(197,A|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break ca}}if((m|0)<0){x[31609]=0;q=R(197,A|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break ca}}h=fb-16|0;fb=h;g=h+14|0;ZY(g,l,j);l=Jc(g);g=h+12|0;ZY(g,((t-1&255)>>>0<6?t+15|0:t)&255,q);m=Jc(g);da:{ea:{fa:{if(y[h+14|0]==10){j=y[m|0];g=y[l|0]&15;v[l|0]=g?-1:j;q=j|g<<8;g=y[h+12|0];if((g|0)!=10){break fa}g=0;v[h+12|0]=0;break fa}if(y[h+12|0]!=10){break ea}g=y[m|0]&15;v[m|0]=g?-1:0;q=g<<8;g=y[h+14|0]}if(q-256>>>0>4294967038){break ea}if(si(g)>>>0>=si(10)>>>0){break ea}v[b+5|0]=q;v[b+2|0]=15;v[b+3|0]=10;v[b+4|0]=q>>>8;break da}if(f){v[b+2|0]=1;v[b+4|0]=f+2>>>2}JE(h+14|0,l,h+12|0,m);j=y[h+14|0];g=y[h+12|0];if((j|0)==20|(g|0)!=(j|0)?j:0){if(!g){v[b+5|0]=y[l|0];v[b+3|0]=j;break da}if(!f){gm(h+10|0,b,j,y[l|0],g,y[m|0]);break da}if(si(j)>>>0>si(g)>>>0){v[b+5|0]=y[l|0];v[b+3|0]=j;break da}}v[b+5|0]=y[m|0];v[b+3|0]=g}fb=h+16|0;break Z}break L}f=d+1|0;continue}}break L}o=o+1|0;continue}}tb(u);n=n+1|0;continue}}h=N()|0;break H}h=N()|0;break H}h=N()|0;break H}x[31609]=0;d=e+192|0;S(509,d|0,e+376|0,20048);b=x[31609];x[31609]=0;ga:{ha:{if((b|0)!=1){f=kd(B,d);b=x[f>>2];x[31609]=0;c=R(172,b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break ha}ub(d);if(!c){break G}while(1){if(!Yj(x[a+484344>>2],x[a+484348>>2])){break G}c=x[f+8>>2];b=x[f>>2];x[31609]=0;c=U(150,b|0,c|0,16)|0;b=x[31609];x[31609]=0;if((b|0)==1){break ga}if(!c){break G}x[31609]=0;c=e+192|0;O(394,f|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){b=x[a+484344>>2];x[31609]=0;O(395,Wb(b,0)|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){continue}}break}h=N()|0;break H}h=N()|0;break H}h=N()|0;ub(e+192|0);break H}h=N()|0;break H}h=N()|0;tb(u);break H}h=N()|0;ub(e+192|0);break H}h=N()|0;break H}h=N()|0}Rc(G);break c}Rc(G);break k}h=N()|0;ub(e+192|0);break c}h=N()|0;break c}h=N()|0;break c}h=N()|0;break c}g=(b<<5)+a|0;i=g+480280|0;Ue(i);f=v[(b+e|0)+324|0];d=f<<1&254;w[g+480284>>1]=(d|0)==254?256:d;ia:{if((f|0)<0){x[i>>2]=x[i>>2]|1024;break ia}w[a+480188>>1]=b+1}x[31609]=0;O(516,e+356|0,g+480289|0);d=x[31609];x[31609]=0;if((d|0)==1){break i}b=b+1|0;continue}}h=N()|0;break c}ub(e+356|0);ke(e+376|0);ub(H)}fb=e+416|0;return F|0}h=N()|0;break c}h=N()|0;break c}h=N()|0;break c}h=N()|0;tb(d);break d}h=N()|0}tb(f)}ub(e+356|0)}ke(e+376|0)}ub(H);Q(h|0);p()}function nta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,B=0,C=0,E=0,F=0,G=0,H=0;e=fb-240|0;fb=e;yc(b);f=fb-16|0;fb=f;g=e+218|0;cw(f+8|0,g);h=x[f+12>>2];lc(f,x[b>>2],x[b+8>>2],x[f+8>>2],x[f+12>>2]);k=x[f+4>>2];if((k|0)==(h|0)){Vb(b,x[f+12>>2])}fb=f+16|0;f=(h|0)==(k|0);if(!f){V_(g)}a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if(!f){break n}if(!W_(g)){break n}d=1;if((c|0)==64){break n}Dd(a,1024);eg(a);x[a+480208>>2]=x[a+480208>>2]|12;bg(a+1074312|0,21);d=Bb(y[e+234|0]|y[e+235|0]<<8);if(d){x[a+480204>>2]=D(d,1e4)}d=Bb(y[e+232|0]|y[e+233|0]<<8);if(d){x[a+480196>>2]=d}if(!y[e+228|0]){Wh(a,1)}yE(b,a+1298308|0,$b(y[e+222|0]|y[e+223|0]<<8|(y[e+224|0]<<16|y[e+225|0]<<24))-14|0);d=e+112|0;b=Ie(d,b);x[31609]=0;f=e+204|0;O(346,f|0,b|0);g=x[31609];x[31609]=0;o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{if((g|0)!=1){ub(b);x[31609]=0;S(347,d|0,f|0,1395544366);b=x[31609];x[31609]=0;if((b|0)==1){break s}x[31609]=0;b=R(277,x[e+112>>2])|0;f=x[31609];x[31609]=0;if((f|0)==1){break y}if(!b){break r}x[31609]=0;b=R(273,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break y}x[31609]=0;f=R(273,d|0)|0;g=x[31609];x[31609]=0;A:{if((g|0)==1){break A}x[31609]=0;P(183,d|0,4)|0;g=x[31609];x[31609]=0;if((g|0)==1){break A}g=y[a+484376|0];h=x[a+484360>>2];x[31609]=0;aa(348,Xb(h,g)|0,d|0,b|0,65535,65535);b=x[31609];x[31609]=0;if((b|0)!=1){break z}}break y}d=N()|0;ub(b);break a}$e(Xb(x[a+484360>>2],y[a+484376|0]),f);f=e+112|0;ub(f);x[31609]=0;S(347,f|0,e+204|0,1346458708);b=x[31609];x[31609]=0;if((b|0)==1){break x}x[31609]=0;g=R(277,x[e+112>>2])|0;b=x[31609];x[31609]=0;if((b|0)==1){break w}d=0;b=0;if(!g){break t}x[31609]=0;g=R(273,f|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break w}w[a+480188>>1]=g;if((g-33&65535)>>>0<65504){break t}x[31609]=0;b=R(273,f|0)|0;m=x[31609];x[31609]=0;if((m|0)==1){break w}x[31609]=0;O(223,a+484344|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break w}b=0;x[31609]=0;m=R(281,f|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break w}switch(m-841887796|0){case 1:break t;case 0:case 2:break u;default:break v}}d=N()|0;ub(e+112|0);break b}d=N()|0;break b}d=N()|0;ub(e+112|0);break b}if(m){break t}}b=1}f=e+112|0;ub(f);if(!b){break o}x[31609]=0;d=e+184|0;S(347,d|0,e+204|0,1398157625);b=x[31609];x[31609]=0;if((b|0)==1){break d}x[31609]=0;b=R(277,x[e+184>>2])|0;g=x[31609];x[31609]=0;if((g|0)==1){break c}if(!b){break q}x[31609]=0;P(183,d|0,2)|0;b=x[31609];x[31609]=0;if((b|0)==1){break c}x[31609]=0;b=R(281,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break c}G=a,H=Ye((+(b>>>0)*2.3283064365386963e-10+ +(A[a+480204>>2]/1e4>>>0))*1e4),x[G+480204>>2]=H;b=0;x[31609]=0;P(349,d|0,f|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}f=z[a+480188>>1];while(1){if((b|0)!=32&(b|0)!=(f|0)){G=e,H=Bb(z[(e+112|0)+(b<<1)>>1]),x[G+48>>2]=H;x[e+32>>2]=180;d=x[Cd(e+48|0,e+32|0)>>2];h=d>>31<<7|d>>>25;d=d<<7;G=((b<<5)+a|0)+480284|0,H=Gc(Jua(d-11475|0,h-(d>>>0<11475)|0,90,0),hb)+128|0,w[G>>1]=H;b=b+1|0;continue}else{B:{x[31609]=0;P(183,e+184|0,16)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break B}break c}}break}x[31609]=0;b=U(150,x[e+184>>2],x[e+192>>2],2)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}C:{if(b){x[31609]=0;b=R(273,e+184|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break C}w[e+48>>1]=b;w[e+32>>1]=256;G=a,H=z[Oc(e+48|0,e+32|0)>>1],x[G+480200>>2]=H}x[31609]=0;b=e+184|0;P(183,b|0,128)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}x[31609]=0;b=P(349,b|0,e+48|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){if(!b){break q}d=z[a+480188>>1];b=0;while(1)if((b|0)!=32&(b|0)!=(d|0)){G=e,H=Bb(z[(e+48|0)+(b<<1)>>1]),x[G+32>>2]=H;x[e+20>>2]=128;G=((b<<5)+a|0)+480286|0,H=x[Cd(e+32|0,e+20|0)>>2]/2&255,w[G>>1]=H;b=b+1|0;continue}else{x[a+480228>>2]=x[a+480228>>2]<<1;break q}}break c}break c}d=N()|0;break b}ub(e+112|0);break p}ub(e+184|0);x[31609]=0;b=e+112|0;S(347,b|0,e+204|0,1413830740);d=x[31609];x[31609]=0;D:{E:{if((d|0)!=1){x[31609]=0;d=R(277,x[e+112>>2])|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}if(!d){break D}x[31609]=0;O(350,b|0,e+48|0);d=x[31609];x[31609]=0;if((d|0)==1){break e}if((Bb(y[e+58|0]|y[e+59|0]<<8)|0)!=65535){break E}x[31609]=0;P(183,b|0,1)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break E}break e}d=N()|0;break b}x[31609]=0;b=e+112|0;d=R(202,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}x[31609]=0;V(336,a+1298332|0,b|0,d|0,2);b=x[31609];x[31609]=0;if((b|0)==1){break e}}ub(e+112|0);x[31609]=0;b=e+48|0;S(347,b|0,e+204|0,1229869908);d=x[31609];x[31609]=0;if((d|0)==1){break h}x[31609]=0;d=R(277,x[e+48>>2])|0;f=x[31609];x[31609]=0;if((f|0)==1){break l}F:{if(!d){break F}x[31609]=0;b=R(273,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break i}G:{H:{b=b<<16>>16;f=b&32767;if(f>>>0>3999){break H}x[31609]=0;d=U(150,x[e+48>>2],x[e+56>>2],D(f,(b>>>14&2)+50|0)|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break g}if(!d){break H}w[a+480190>>1]=f;g=a+480190|0;h=e+130|0;k=(b|0)>=0;b=1;I:{J:{K:{L:{while(1){if(f>>>0<(b&65535)>>>0){x[31609]=0;b=R(273,e+48|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break I}break g}M:{if(k){j=b}else{x[31609]=0;d=R(273,e+48|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break M}j=d+1|0}w[e+20>>1]=j;x[31609]=0;d=e+112|0;O(351,e+48|0,d|0);i=x[31609];x[31609]=0;if((i|0)==1){break L}i=z[e+20>>1];if((i-4e3&65535)>>>0>=61537){G=a,H=z[qe(g,e+20|0)>>1],w[G+480190>>1]=H;l=y[e+236|0]|y[e+237|0]<<8|(y[e+238|0]<<16|y[e+239|0]<<24);x[31609]=0;V(352,d|0,(D(i,104)+a|0)+484380|0,$b(l)|0,m|0);d=x[31609];x[31609]=0;if((d|0)==1){break K}i=e+32|0;Sk(i,2,h);x[31609]=0;d=e+184|0;O(218,d|0,i|0);i=x[31609];x[31609]=0;if((i|0)==1){break J}Ac(((z[e+20>>1]<<5)+a|0)+946304|0,d);tb(d)}b=b+1|0;continue}break}d=N()|0;break f}d=N()|0;break f}d=N()|0;break f}d=N()|0;break f}if((b|0)!=4){break F}w[e+112>>1]=z[a+480190>>1];w[e+184>>1]=255;b=e+184|0;G=a,H=z[Oc(e+112|0,b)>>1],w[G+480192>>1]=H;x[31609]=0;S(347,b|0,e+204|0,1229278806);b=x[31609];x[31609]=0;if((b|0)==1){break j}N:while(1){O:{x[31609]=0;b=U(150,x[e+48>>2],x[e+56>>2],15)|0;d=x[31609];x[31609]=0;if((d|0)==1){break O}if(!b){break G}x[31609]=0;O(353,e+48|0,e+32|0);b=x[31609];x[31609]=0;if((b|0)==1){break k}b=Bb(z[e+32>>1]);if(b>>>0>=z[a+480192>>1]){continue}d=D(b,104)+a|0;v[d+484524|0]=y[e+40|0];f=y[e+39|0];v[d+484523|0]=255;v[d+484525|0]=f;x[31609]=0;b=b+1&65535;d=U(251,a|0,b|0,b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break k}if(!d){continue}G=e,H=Bb(y[e+37|0]|y[e+38|0]<<8),w[G+112>>1]=H;w[e+20>>1]=4095;b=e+112|0;f=e+20|0;G=d,H=z[Oc(b,f)>>1],x[G>>2]=H;g=y[e+35|0];if((g|0)==255){continue}x[31609]=0;h=e+184|0;g=P(149,h|0,D(g,34)+2|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break k}if(!g){continue}x[31609]=0;O(354,h|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break k}v[d+60|0]=y[d+60|0]|1;b=z[e+112>>1];x[e+24>>2]=16;x[e+28>>2]=240;G=e,H=Bb(b),x[G+20>>2]=H;b=vE(f);x[31609]=0;O(293,d+48|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break k}b=0;f=x[d+48>>2];h=x[d+52>>2];g=Sd(f,h);while(1)if(b>>>0>=g>>>0){b=y[e+36|0];if((b|0)!=255){v[d- -64|0]=b;v[d+63|0]=b;v[d+60|0]=y[d+60|0]|4}if(mc(f,h)){continue N}b=g-1|0;v[d+62|0]=b;v[d+61|0]=b;v[d+60|0]=y[d+60|0]|2;continue N}else{v[e+20|0]=64;k=(e+112|0)+(b<<1)|0;v[e+16|0]=y[k+2|0];i=Qb(e+20|0,e+16|0);l=yb(f,b);v[l+2|0]=y[i|0];w[l>>1]=y[k+3|0];b=b+1|0;continue}}break}break k}ub(e+48|0);break p}ub(e+184|0)}b=e+48|0;ub(b);x[31609]=0;S(355,e+184|0,e+204|0,1145131092);d=x[31609];x[31609]=0;if((d|0)==1){break m}G=e,H=wb(x[e+184>>2]),x[G+20>>2]=H;k=a+484344|0;t=c&1;q=b|4;u=wb(x[e+188>>2]);r=(m|0)!=841887798;B=(m|0)!=841887796;while(1){P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{_:{$:{aa:{f=x[e+20>>2];if(!Ib(f,u)){Rc(e+184|0);x[31609]=0;S(347,e+112|0,e+204|0,1346458702);b=x[31609];x[31609]=0;if((b|0)!=1){break aa}d=N()|0;break b}x[31609]=0;P(183,f|0,4)|0;b=x[31609];x[31609]=0;if((b|0)!=1){x[31609]=0;i=R(273,f|0)|0;b=x[31609];x[31609]=0;ba:{if((b|0)!=1){x[31609]=0;l=R(273,f|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break R}l=r?l:(l>>>0)/A[a+480196>>2]|0;if(!t|i>>>0>255){break P}x[31609]=0;b=U(196,k|0,i|0,l|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break R}if(b){break ba}break P}d=N()|0;break Q}if(!r){o=0;x[31609]=0;P(183,f|0,4)|0;b=x[31609];x[31609]=0;if((b|0)==1){break R}while(1){s=o&65535;if(s>>>0>=z[a+480188>>1]){break P}x[31609]=0;b=R(273,f|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break $}x[31609]=0;d=e+48|0;S(185,d|0,f|0,b+(b&1)&65535);b=x[31609];x[31609]=0;if((b|0)==1){break S}g=hc(e+112|0,d);ub(d);x[e+48>>2]=0;x[e+52>>2]=0;d=0;ca:{while(1){b=x[g>>2];x[31609]=0;b=U(150,b|0,x[e+120>>2],6)|0;h=x[31609];x[31609]=0;if((h|0)==1){break ca}j=b;b=x[e+48>>2];if(j&b>>>0<l>>>0){h=Wb(x[k>>2],i);b=md(x[h>>2],x[x[h+48>>2]+12>>2],b,s);x[31609]=0;h=e+32|0;O(356,h|0,g|0);j=x[31609];x[31609]=0;da:{ea:{if((j|0)!=1){j=Jc(h);C=_e(h);E=_i(h);F=gc(h);n=v[e+32|0];if((n-1&255)>>>0>95){break ea}v[b|0]=n+13;if(!x[e+52>>2]){break da}v[b+3|0]=19;x[e+16>>2]=15;G=b,H=y[Cd(q,e+16|0)|0]|208,v[G+5|0]=H;break da}break T}if((n|0)>=0){break da}if(x[e+52>>2]){v[b+3|0]=19;x[e+16>>2]=15;G=b,H=y[Cd(q,e+16|0)|0]|192,v[G+5|0]=H;break da}v[b|0]=254}if(y[j|0]){v[b+2|0]=1;v[e+16|0]=64;G=b,H=y[Qb(j,e+16|0)|0],v[G+4|0]=H}j=y[C|0];if(j){v[b+1|0]=j}j=y[E|0];n=y[F|0];if(j|n){Cf(b,j,n)}h=v[h+5|0];b=h&255;j=e+48|0;if((h|0)<0){x[31609]=0;h=R(197,g|0)|0;n=x[31609];x[31609]=0;if((n|0)==1){break T}b=h|b<<8&32512}d=b+d|0;hE(j,d,x[a+480196>>2]);continue}break}ub(g);o=o+1|0;continue}break}break T}b=Wb(x[k>>2],i);G=e,H=wb(x[b>>2]),x[G+48>>2]=H;l=wb(x[b+4>>2]);while(1){b=x[e+48>>2];if(!Ib(b,l)){break P}x[31609]=0;O(357,e+32|0,f|0);d=x[31609];x[31609]=0;if((d|0)!=1){v[e+15|0]=0;fa:{if(!B){d=x[e+32>>2];x[e+112>>2]=d;g=e+112|0;h=Jc(g);i=_e(g);g=_i(g);if(d<<24>>24>0){v[b|0]=(D((d&240)>>>4|0,12)+(d&15)|0)+12}d=y[h|0];if(d>>>0>=4){v[b+2|0]=1;v[b+4|0]=(d>>>2|0)-1;d=y[h|0]}v[b+1|0]=d<<4&48|y[i|0]>>>4;d=y[i|0]&15;v[e+15|0]=d;g=y[g|0];v[b+5|0]=g;break fa}d=x[e+32>>2];x[e+8>>2]=d;x[e+4>>2]=d;d=e+16|0;dp(d,e+4|0,b);g=e+112|0;ZD(g,e+15|0,b+5|0);YD(g,d);G=b,H=y[b+1|0]|y[xb(e+32|0,0)|0]&48,v[G+1|0]=H;g=y[b+5|0];d=y[e+15|0]}Cf(b,d&255,g);d=y[b+3|0];ga:{if(d>>>0>11){break ga}d=1<<d;ha:{if(!(d&2240)){if(!(d&12)){break ga}if(!y[b+5|0]){break ha}break ga}d=y[b+5|0];g=d&240;if(g){v[b+5|0]=g;break ga}if(d){break ga}}v[b+3|0]=0}tg(e+48|0);continue}break}d=N()|0;break Q}d=N()|0;break Q}x[31609]=0;b=R(277,x[e+112>>2])|0;d=x[31609];x[31609]=0;ia:{ja:{ka:{la:{ma:{if((d|0)!=1){if(b){f=Fb(e+48|0);b=0;na:{while(1){oa:{x[31609]=0;d=U(150,x[e+112>>2],x[e+120>>2],1)|0;g=x[31609];x[31609]=0;if((g|0)==1){break oa}if(!d){break na}if(Yj(x[a+484344>>2],x[a+484348>>2])>>>0<=b>>>0){break na}x[31609]=0;S(358,e+112|0,f|0,32);d=x[31609];x[31609]=0;if((d|0)==1){break oa}d=x[k>>2];x[31609]=0;O(283,Wb(d,b)|0,f|0);d=x[31609];x[31609]=0;if((d|0)==1){break oa}b=b+1|0;continue}break}d=N()|0;tb(f);break ma}tb(f)}b=e+112|0;ub(b);x[31609]=0;S(347,b|0,e+204|0,1414679374);b=x[31609];x[31609]=0;if((b|0)==1){break la}x[31609]=0;b=R(277,x[e+112>>2])|0;d=x[31609];x[31609]=0;if((d|0)==1){break V}if(!b){break ia}f=Fb(e+48|0);b=0;while(1){x[31609]=0;d=U(150,x[e+112>>2],x[e+120>>2],1)|0;g=x[31609];x[31609]=0;if((g|0)==1){break ka}if(!(z[a+480188>>1]>b>>>0&d)){break ja}x[31609]=0;S(358,e+112|0,f|0,32);d=x[31609];x[31609]=0;if((d|0)==1){break ka}im(((b<<5)+a|0)+480289|0,f);b=b+1|0;continue}}d=N()|0}ub(e+112|0);break b}d=N()|0;break b}d=N()|0;tb(f);break U}tb(f)}b=e+112|0;ub(b);x[31609]=0;S(355,b|0,e+204|0,1145129300);b=x[31609];x[31609]=0;if((b|0)==1){break W}G=e,H=wb(x[e+112>>2]),x[G+48>>2]=H;d=c&2;f=wb(x[e+116>>2]);pa:{qa:{ra:{sa:{ta:{ua:{while(1){b=x[e+48>>2];if(!Ib(b,f)){c=e+112|0;Rc(c);b=Fb(e+48|0);if((m|0)!=841887798){break ta}x[31609]=0;c=P(1,c|0,9506)|0;d=x[31609];x[31609]=0;if((d|0)==1){break ua}zb(b,c);tb(c);break sa}x[31609]=0;c=R(273,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break X}va:{if(!(!d|c>>>0>=z[a+480190>>1])){c=D(c,104)+a|0;g=z[c+484518>>1];g=Zc(e+184|0,g&1?16:8,g&64?2:1,1,0);x[31609]=0;U(215,g|0,c+484484|0,b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break va}}Qf(e+48|0);continue}break}break X}d=N()|0;break Y}x[31609]=0;c=e+112|0;S(347,c|0,e+204|0,1447383635);d=x[31609];x[31609]=0;wa:{xa:{ya:{za:{Aa:{if((d|0)!=1){x[31609]=0;d=R(277,x[e+112>>2])|0;f=x[31609];x[31609]=0;if((f|0)==1){break ra}if(!d){break xa}x[31609]=0;c=R(281,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break Aa}x[31609]=0;d=e+32|0;O(268,d|0,4292);f=x[31609];x[31609]=0;if((f|0)==1){break za}x[e+20>>2]=c>>>4;x[31609]=0;x[e+16>>2]=c&15;c=e+184|0;V(359,c|0,d|0,e+20|0,e+16|0);f=x[31609];x[31609]=0;if((f|0)==1){break ya}zb(b,c);tb(c);Eb(d);break wa}d=N()|0;break Y}d=N()|0;break Z}d=N()|0;break Z}d=N()|0;Eb(e+32|0);break Z}x[31609]=0;c=P(1,e+184|0,8509)|0;d=x[31609];x[31609]=0;if((d|0)==1){break _}zb(b,c);tb(c)}ub(e+112|0)}x[31609]=0;c=P(1,e+32|0,8509)|0;d=x[31609];x[31609]=0;if((d|0)==1){break qa}zb(a+1298344|0,c);tb(c);x[31609]=0;c=P(1,e+20|0,10149)|0;d=x[31609];x[31609]=0;if((d|0)==1){break pa}zb(a+1298356|0,c);tb(c);zb(a+1298368|0,b);G=a+1298404|0,H=x[Fc(e+16|0,28)>>2],x[G>>2]=H;tb(b);d=1;break o}d=N()|0;break Z}d=N()|0;break Y}d=N()|0;break Y}d=N()|0;break Q}d=N()|0}ub(e+112|0)}tb(b);break b}d=N()|0;Rc(e+112|0);break b}d=N()|0;break b}d=N()|0}ub(e+112|0);break b}d=N()|0;ub(g);break Q}d=N()|0;break Q}d=N()|0}Rc(e+184|0);break b}Qf(e+20|0);continue}}d=0}ke(e+204|0)}fb=e+240|0;return d|0}d=N()|0;break b}d=N()|0;break f}d=N()|0;ub(e+184|0);break f}d=N()|0;break f}d=N()|0;break f}d=N()|0;break b}d=N()|0}ub(e+48|0);break b}d=N()|0;ub(e+112|0);break b}d=N()|0;break b}d=N()|0;ub(e+184|0)}ke(e+204|0)}Q(d|0);p()}function lpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;d=fb-336|0;fb=d;yc(b);j=d+324|0;a:{if(!gp(b,j)){break a}if(!qX(j)){break a}q=Ie(d+304|0,b);n=Nb(d+292|0);b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{if((c|0)==64){x[31609]=0;e=d+40|0;O(664,e|0,q|0);b=x[31609];x[31609]=0;if((b|0)==1){break v}break x}x[31609]=0;e=d+40|0;O(665,e|0,q|0);b=x[31609];x[31609]=0;if((b|0)==1){break w}}Cv(n,e);ke(e);x[31609]=0;b=d+40|0;S(666,b|0,n|0,1413891155);e=x[31609];x[31609]=0;y:{z:{if((e|0)!=1){x[31609]=0;e=P(667,b|0,14199)|0;j=x[31609];x[31609]=0;if((j|0)==1){break z}ub(b);if((c|0)!=64&e){break y}break b}b=N()|0;break c}b=N()|0;ub(d+40|0);break c}x[31609]=0;O(246,a|0,4194304);b=x[31609];x[31609]=0;if((b|0)==1){break d}x[a+480208>>2]=12;x[31609]=0;b=d+272|0;S(666,b|0,n|0,1280592212);e=x[31609];x[31609]=0;if((e|0)==1){break e}x[31609]=0;e=R(154,x[d+272>>2])|0;j=x[31609];x[31609]=0;if((j|0)==1){break g}x[31609]=0;S(455,b|0,a+1298308|0,e|0);b=x[31609];x[31609]=0;if((b|0)==1){break g}Nc(Xb(x[a+484360>>2],y[a+484376|0]));j=Nb(d+260|0);v[d+259|0]=0;v[d+258|0]=0;x[31609]=0;S(668,d+244|0,n|0,1196314451);b=x[31609];x[31609]=0;if((b|0)==1){break i}m=a+484360|0;t=d,u=wb(x[d+244>>2]),x[t+240>>2]=u;l=d+228|0;i=wb(x[d+248>>2]);A:{while(1){b=x[d+240>>2];if(!Ib(b,i)){break A}k=Ie(d+40|0,b);x[31609]=0;e=d+28|0;g=P(669,k|0,e|0)|0;b=x[31609];x[31609]=0;B:{C:{if((b|0)!=1){b=1;if(!(g&y[d+37|0]==1)){break B}t=a,u=Ld(y[d+38|0],z[a+480188>>1],127),w[t+480188>>1]=u;x[31609]=0;g=R(670,d+184|0)|0;b=x[31609];x[31609]=0;D:{E:{F:{if((b|0)!=1){h=d+172|0;bf(h,e,9,1);x[31609]=0;b=d+136|0;O(218,b|0,h|0);e=x[31609];x[31609]=0;if((e|0)==1){break F}e=d+16|0;Zb(e,l,10);om(e,b);tb(b);b=Xb(x[a+484360>>2],y[a+484376|0]);if(mc(x[b>>2],x[b+4>>2])){break D}x[31609]=0;b=R(274,m|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break m}if((b|0)!=255){break E}b=2;break C}b=N()|0;break k}b=N()|0;break l}b=Xb(x[a+484360>>2],y[a+484376|0])}x[31609]=0;e=d+160|0;O(671,e|0,l|0);h=x[31609];x[31609]=0;if((h|0)==1){break m}op(b,e);tb(e);x[31609]=0;O(665,d+172|0,k|0);b=x[31609];x[31609]=0;if((b|0)!=1){t=d,u=wb(x[d+172>>2]),x[t+156>>2]=u;r=wb(x[d+176>>2]);while(1){G:{H:{I:{J:{K:{b=x[d+156>>2];if(Ib(b,r)){lp(d+136|0,b);ri(d+16|0,x[b>>2],x[b+4>>2]);e=x[d+16>>2];if((e|0)==1212960847){break K}b=0;if((e|0)!=1312903248){break G}while(1){e=b&65535;if(e>>>0>=z[a+480188>>1]){break G}x[31609]=0;h=U(150,x[d+136>>2],x[d+144>>2],2)|0;f=x[31609];x[31609]=0;if((f|0)==1){break I}if(!h){break G}x[31609]=0;h=d+8|0;O(198,h|0,d+136|0);f=x[31609];x[31609]=0;if((f|0)!=1){GC(g,e,y[d+8|0],y[Jc(h)|0],d+259|0,j);b=b+1|0;continue}break}break I}b=0;if(z[d+220>>1]==65535|z[d+222>>1]==65535){break J}b=y[a+484376|0];e=x[a+484360>>2];x[31609]=0;W(672,Xb(e,b)|0);b=x[31609];x[31609]=0;if((b|0)!=1){b=0;x[31609]=0;O(673,j|0,g|0);e=x[31609];x[31609]=0;if((e|0)!=1){break J}}b=N()|0;break H}if(A[d+20>>2]<9){break G}e=0;x[31609]=0;P(183,d+136|0,2)|0;b=x[31609];x[31609]=0;h=65535;L:{if((b|0)!=1){while(1){x[31609]=0;b=U(150,x[d+136>>2],x[d+144>>2],1)|0;f=x[31609];x[31609]=0;M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{if((f|0)!=1){if(!b){break G}x[31609]=0;f=R(197,d+136|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break I}b=4;switch(f|0){case 0:break G;case 14:break N;case 13:break O;case 12:break Q;case 8:break R;case 7:break S;case 2:break T;case 6:break U;case 5:break V;case 3:case 4:break W;case 1:break X;default:break P}}break I}b=Xb(x[a+484360>>2],y[a+484376|0]);if(z[d+220>>1]==65535){t=d,u=dm(x[b>>2],x[b+4>>2]),w[t+220>>1]=u}b=dm(x[b>>2],x[b+4>>2]);x[31609]=0;w[d+222>>1]=b;b=P(674,d+136|0,d+258|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break I}Y:{Z:{switch(b-254|0){case 1:b=65535;break Y;case 0:break Z;default:break Y}}b=65534}f=y[a+484376|0];o=x[a+484360>>2];x[31609]=0;O(537,Xb(o,f)|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break I}h=(h&65535)==65535?e:h;break M}x[31609]=0;b=R(189,d+136|0)|0;o=x[31609];x[31609]=0;if((o|0)!=1){_:{if(b>>>0<(h&65535)>>>0){b=z[d+224>>1];break _}b=b-h|0;w[d+224>>1]=b}$e(Xb(x[a+484360>>2],y[a+484376|0]),b&65535);if((f|0)!=3){break M}x[31609]=0;P(183,d+136|0,1)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break M}}break I}x[31609]=0;b=d+8|0;O(198,b|0,d+136|0);f=x[31609];x[31609]=0;if((f|0)!=1){GC(g,y[d+8|0],y[Jc(b)|0],-1,d+259|0,j);break M}break I}b=1}x[31609]=0;P(183,d+136|0,b|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break M}break I}x[31609]=0;b=R(197,d+136|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break I}v[d+227|0]=b;break M}x[31609]=0;b=R(197,d+136|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break I}v[d+226|0]=b;break M}x[31609]=0;b=P(640,d+136|0,d+8|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break I}if(y[d+8|0]|!b|(y[d+10|0]|y[d+9|0]!=255)){break P}if(y[d+11|0]|y[d+12|0]!=1){break P}if(!y[d+13|0]){break M}}ub(d+136|0);b=1;break J}x[31609]=0;b=d+8|0;O(549,b|0,d+136|0);f=x[31609];x[31609]=0;if((f|0)!=1){f=Jc(b);GC(g,y[d+8|0],y[_e(b)|0],y[f|0],d+259|0,j);break M}break I}x[31609]=0;b=d+8|0;O(198,b|0,d+136|0);f=x[31609];x[31609]=0;if((f|0)==1){break L}f=x[d+196>>2];s=Xc(f,x[d+200>>2]);o=y[d+8|0];if(s>>>0<=o>>>0){break M}b=Jc(b);t=xb(f,o),u=(y[b|0]>>>2|0)+1|0,v[t|0]=u}e=e+1|0;continue}}break I}break I}ke(d+172|0);break C}b=N()|0;ub(d+136|0)}ke(d+172|0);break l}ub(d+136|0);em(d+156|0);continue}}b=N()|0;break l}b=N()|0;break k}ar(g)}ub(k);if(!b){Qf(d+240|0);continue}break}e=0;if((b|0)!=2){break s}}e=0;Wj(m,0);b=x[j>>2];if(mc(b,x[j+4>>2])){break s}if(!(c&2)){break t}x[31609]=0;S(668,d+136|0,n|0,1347244868);b=x[31609];x[31609]=0;$:{if((b|0)!=1){t=d,u=wb(x[d+136>>2]),x[t+16>>2]=u;e=a+480190|0;h=d+53|0;k=d+57|0;m=wb(x[d+140>>2]);l=y[d+258|0];while(1){b=x[d+16>>2];if(!Ib(b,m)){Rc(d+136|0);b=x[j>>2];break t}aa:{ba:{ca:{if(!l){x[31609]=0;g=d+40|0;f=P(675,b|0,g|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break aa}if(!f){break ba}f=y[d+92|0]|y[d+93|0]<<8;i=f+1|0;w[d+8>>1]=i;if(f>>>0>3998){break ca}t=a,u=z[qe(e,d+8|0)>>1],w[t+480190>>1]=u;x[31609]=0;O(676,g|0,(D(i&65535,104)+a|0)+484380|0);g=x[31609];x[31609]=0;if((g|0)==1){break aa}f=d+28|0;pX(f,h);x[31609]=0;g=d+172|0;O(218,g|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break u}Ac(((z[d+8>>1]<<5)+a|0)+946304|0,g);tb(g);break ca}x[31609]=0;g=d+40|0;f=P(677,b|0,g|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break u}if(!f){break ba}f=y[d+96|0]|y[d+97|0]<<8;i=f+1|0;w[d+8>>1]=i;if(f>>>0>3998){break ca}t=a,u=z[qe(e,d+8|0)>>1],w[t+480190>>1]=u;x[31609]=0;O(678,g|0,(D(i&65535,104)+a|0)+484380|0);g=x[31609];x[31609]=0;if((g|0)==1){break u}f=d+28|0;pX(f,k);x[31609]=0;g=d+172|0;O(218,g|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break $}Ac(((z[d+8>>1]<<5)+a|0)+946304|0,g);tb(g)}g=z[d+8>>1];if((g-1&65535)>>>0>3998){break ba}f=Zc(d+40|0,8,1,0,2);x[31609]=0;U(215,f|0,(D(g,104)+a|0)+484380|0,b|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break ba}break u}Qf(d+16|0);continue}break}break u}b=N()|0;break j}break u}b=N()|0;break c}b=N()|0;break c}b=N()|0;Rc(d+136|0);break j}b=FC(b,0);x[a+480196>>2]=y[b+43|0];x[a+480204>>2]=D(y[b+42|0],1e4);$e(Xb(x[a+484360>>2],y[a+484376|0]),z[b+40>>1]);b=0;while(1){if(z[a+480188>>1]>b>>>0){e=(b<<5)+a|0;g=e+480280|0;Ue(g);h=FC(x[j>>2],0);t=e+480286|0,u=y[xb(x[h+12>>2],b)|0],w[t>>1]=u;t=e+480284|0,u=y[xb(x[h>>2],b)|0],w[t>>1]=u;Jb(d+40|0,x[h+24>>2],b);t=g,u=x[g>>2]&-257|(Gb(x[x[d+40>>2]>>2],x[d+44>>2])?256:0),x[t>>2]=u;b=b+1|0;continue}break}x[31609]=0;b=P(1,d+172|0,(y[d+258|0]?17182:17039)|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break n}zb(a+1298344|0,b);tb(b);x[31609]=0;b=P(1,d+28|0,10153)|0;e=x[31609];x[31609]=0;if((e|0)==1){break o}zb(a+1298356|0,b);tb(b);t=a+1298404|0,u=x[Fc(d+40|0,4)>>2],x[t>>2]=u;e=1;if(!(c&1)|!z[a+480188>>1]){break s}x[31609]=0;S(668,d+16|0,n|0,1146045008);b=x[31609];x[31609]=0;if((b|0)==1){break p}b=x[d+20>>2];c=x[d+16>>2];x[31609]=0;h=a+484344|0;O(223,h|0,Sf(c,b)&65535);b=x[31609];x[31609]=0;if((b|0)==1){break r}t=d,u=wb(x[d+16>>2]),x[t+240>>2]=u;f=wb(x[d+20>>2]);while(1){g=x[d+240>>2];if(!Ib(g,f)){da:{ea:{b=x[j>>2];e=x[j+4>>2];if(Bv(b,e)>>>0<2){break ea}m=y[d+259|0];c=0;while(1){if(Bv(b,e)>>>0<=c>>>0){break ea}f=x[a+484344>>2];i=x[a+484348>>2];k=Nj(x[a+484360>>2],c&255);o=x[k>>2];g=FC(b,c);l=z[g+36>>1];if(Je(f,i,z[bc(o,l)>>1])){x[31609]=0;e=P(368,k|0,l|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break da}fa:{if(!m){break fa}b=0;while(1){if(z[a+480188>>1]<=b>>>0){break fa}l=EC(x[g+24>>2],b);k=Wb(x[h>>2],e);ga:{if(l){Ae(k,Xh(hp(Ve(Oe(d+40|0,20,145),0),b&65535)));break ga}Ae(k,Xh(hp(Ve(Oe(d+40|0,9,y[xb(x[g>>2],b)|0]),0),b&65535)))}b=b+1|0;continue}}b=d+40|0;Ae(Wb(x[h>>2],e),Xh(Ve(Oe(b,16,y[g+43|0]),0)));Ae(Wb(x[h>>2],e),Xh(Ve(Oe(b,17,y[g+42|0]),0)));e=x[j+4>>2];b=x[j>>2]}c=c+1|0;continue}}Rc(d+16|0);e=1;break s}b=N()|0;break q}b=x[g>>2];x[31609]=0;b=R(154,b|0)|0;c=x[31609];x[31609]=0;ha:{ia:{ja:{ka:{la:{ma:{na:{if((c|0)==1){break na}x[31609]=0;c=R(151,g|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break na}if((b|0)!=(c|0)){break ha}b=x[g>>2];x[31609]=0;b=P(679,b|0,8)|0;c=x[31609];x[31609]=0;if((c|0)==1){break na}if(!b){break ha}x[31609]=0;m=P(674,g|0,d+258|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break ia}x[31609]=0;l=R(189,g|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break ja}x[31609]=0;b=U(196,h|0,m|0,l|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break ja}if(!b){break ha}k=0;while(1){if((k|0)==(l|0)){break ha}b=Wb(x[h>>2],m);af(d+8|0,x[b>>2],x[x[b+48>>2]+12>>2],k);x[31609]=0;b=R(189,g|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break ma}oa:{if(b>>>0>=3){x[31609]=0;c=d+136|0;S(185,c|0,g|0,b-2|0);b=x[31609];x[31609]=0;if((b|0)==1){break ka}e=hc(d+40|0,c);ub(c);while(1){b=x[e>>2];x[31609]=0;b=U(150,b|0,x[d+48>>2],3)|0;c=x[31609];x[31609]=0;if((c|0)==1){break oa}if(b){x[31609]=0;b=d+136|0;O(198,b|0,e|0);c=x[31609];x[31609]=0;pa:{qa:{ra:{sa:{if((c|0)!=1){w[d+156>>1]=z[a+480188>>1]-1;t=d,u=y[Jc(b)|0],w[t+6>>1]=u;c=Yc(x[d+8>>2],z[Oc(d+156|0,d+6|0)>>1]);b=v[d+136|0];if((b|0)>=0){break pa}x[31609]=0;b=R(197,e|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break la}if(y[d+258|0]){break ra}if((b|0)!=255){break sa}b=254;break qa}break la}if(b>>>0>128){break qa}b=(D(b>>>4|0,12)+(b&15)|0)+13|0;break qa}b=b>>>0<85?b+36|0:b}v[c|0]=b;b=y[d+136|0]}if(b&64){x[31609]=0;b=R(197,e|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break la}v[c+1|0]=b+1;b=y[d+136|0]}if(b&32){x[31609]=0;b=R(197,e|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break la}v[d+156|0]=b;v[d+6|0]=127;b=y[Qb(d+156|0,d+6|0)|0];v[c+2|0]=1;v[c+4|0]=b+1>>>1;b=y[d+136|0]}if(!(b&16)){continue}x[31609]=0;b=d+156|0;O(198,b|0,e|0);i=x[31609];x[31609]=0;ta:{ua:{va:{wa:{xa:{ya:{za:{Aa:{Ba:{Ca:{Da:{Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{Ka:{La:{Ma:{Na:{Oa:{Pa:{Qa:{Ra:{Sa:{Ta:{Ua:{Va:{Wa:{Xa:{Ya:{Za:{_a:{if((i|0)!=1){b=y[Jc(b)|0];v[c+5|0]=b;switch(y[d+156|0]-1|0){case 72:break ua;case 71:break va;case 70:break wa;case 61:break xa;case 60:break ya;case 53:break za;case 52:break Aa;case 51:break Ba;case 50:break Da;case 43:break Ea;case 42:break Fa;case 41:break Ga;case 40:break Ha;case 31:break Ia;case 30:break Ja;case 23:break Ka;case 22:break La;case 21:break Ma;case 20:break Na;case 18:break Oa;case 17:break Pa;case 15:break Qa;case 16:break Ra;case 14:break Sa;case 13:break Ta;case 12:break Ua;case 11:break Va;case 10:break Wa;case 3:break Xa;case 2:break Ya;case 1:break Za;case 0:break _a;default:break ta}}break la}v[c+3|0]=11;if(y[d+258|0]){v[c+5|0]=b<<4|15;continue}v[c+5|0]=b<<3|15;continue}v[c+3|0]=11;if(y[d+258|0]){v[c+5|0]=b<<4;continue}v[c+5|0]=b<<3&240;continue}v[c+3|0]=11;if(y[d+258|0]){v[c+5|0]=b|240;continue}v[c+5|0]=b>>>1|240;continue}v[c+3|0]=11;if(y[d+258|0]){v[c+5|0]=b&15;continue}if(b>>>0<=1){v[c+5|0]=b|240;continue}v[c+5|0]=b>>>1&15;continue}v[c+3|0]=2;t=c,u=Av(b,y[d+258|0])|240,v[t+5|0]=u;continue}v[c+3|0]=2;t=c,u=Av(b,y[d+258|0]),v[t+5|0]=u;continue}v[c+3|0]=3;t=c,u=Av(b,y[d+258|0])|240,v[t+5|0]=u;continue}v[c+3|0]=3;t=c,u=Av(b,y[d+258|0]),v[t+5|0]=u;continue}v[c+3|0]=4;if(y[d+258|0]){continue}v[c+5|0]=(b&252)>>>2;continue}v[c+3|0]=20;v[c+5|0]=b&1|16;continue}v[c+3|0]=6;v[c+5|0]=b&240;continue}v[c+3|0]=6;v[c+5|0]=(b&240)>>>4;continue}v[c+3|0]=20;continue}v[c+3|0]=5;continue}v[c+3|0]=20;v[c+5|0]=b&15|48;continue}v[c+3|0]=7;v[c+5|0]=b|240;continue}v[c+3|0]=7;continue}v[c+3|0]=8;continue}v[c+3|0]=20;v[c+5|0]=b&15|64;continue}v[c+3|0]=10;x[31609]=0;b=R(197,e|0)|0;i=x[31609];x[31609]=0;if((i|0)!=1){break Ca}break la}v[c+3|0]=15;continue}v[c+3|0]=20;v[c+5|0]=b&15|192;continue}v[c+3|0]=20;v[c+5|0]=b&15|208;continue}v[c+3|0]=12;b=(b&254)>>>1|0}v[c+5|0]=b;x[31609]=0;P(183,e|0,1)|0;b=x[31609];x[31609]=0;if((b|0)!=1){continue}break la}v[c+5|0]=0;v[c+3|0]=14;continue}v[c+3|0]=20;v[c+5|0]=b&15|176;continue}v[c+3|0]=20;v[c+5|0]=b&15|224;continue}v[c+3|0]=16;continue}v[c+3|0]=17;continue}v[c+3|0]=1;continue}v[c+3|0]=20;v[c+5|0]=b&15|32;continue}v[c+3|0]=20;v[c+5|0]=b&15|128;continue}v[c+3|0]=0;continue}break}ub(e)}k=k+1|0;continue}break}break la}b=N()|0;break q}b=N()|0;break q}b=N()|0;ub(e);break q}b=N()|0;break q}b=N()|0;break q}b=N()|0;break q}Qf(d+240|0);continue}}Rc(d+244|0);oX(j);ub(d+272|0);break b}b=N()|0}Rc(d+16|0);break j}b=N()|0;break j}b=N()|0;break j}b=N()|0;break j}b=N()|0}ar(g)}ub(k)}Rc(d+244|0);break h}b=N()|0}oX(j);break f}b=N()|0}ub(d+272|0);break c}b=N()|0;break c}b=N()|0}ke(n);ub(q);Q(b|0);p()}ke(n);ub(q)}fb=d+336|0;return e|0}function pua(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,A=0,B=0,C=0;d=fb-416|0;fb=d;yc(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{f=d+408|0;s:{if(!wi(b,f)){break s}if(!r0(f)){break s}o=1;if((c|0)==64){break s}q=Ie(d+388|0,b);x[31609]=0;f=d+376|0;O(263,f|0,q|0);b=x[31609];x[31609]=0;t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{if((b|0)!=1){x[31609]=0;b=d+208|0;S(264,b|0,f|0,1229866575);f=x[31609];x[31609]=0;if((f|0)==1){break K}x[31609]=0;o=P(265,b|0,d+366|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break M}ub(b);if(!o){break t}x[31609]=0;O(246,a|0,524288);f=x[31609];x[31609]=0;N:{if((f|0)==1){break N}eg(a);x[a+480208>>2]=12;B=a,C=Ld(Bb(z[d+374>>1]),1,127),w[B+480188>>1]=C;B=d,C=Bb(z[d+366>>1]),w[B+208>>1]=C;w[d+320>>1]=255;f=d+320|0;B=a,C=z[Oc(b,f)>>1],w[B+480192>>1]=C;B=d,C=Bb(z[d+368>>1]),w[B+208>>1]=C;w[d+320>>1]=3999;B=a,C=z[Oc(b,f)>>1],w[B+480190>>1]=C;x[31609]=0;b=U(266,a+1074312|0,6,1)|0;f=x[31609];x[31609]=0;if((f|0)==1){break N}x[31609]=0;b=P(267,b|0,21)|0;f=x[31609];x[31609]=0;if((f|0)==1){break N}x[31609]=0;P(267,b|0,13)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break L}}b=N()|0;break b}b=N()|0;break a}b=N()|0;ub(d+208|0);break b}x[31609]=0;b=P(1,d+352|0,9298)|0;f=x[31609];x[31609]=0;if((f|0)==1){break c}zb(a+1298344|0,b);tb(b);x[31609]=0;b=P(1,d+340|0,10333)|0;f=x[31609];x[31609]=0;if((f|0)==1){break d}zb(a+1298356|0,b);tb(b);x[31609]=0;b=d+320|0;O(268,b|0,4336);f=x[31609];x[31609]=0;if((f|0)==1){break e}x[31609]=0;f=d+300|0;O(269,f|0,d+412|0);e=x[31609];x[31609]=0;if((e|0)==1){break g}x[31609]=0;g=d+264|0;O(269,g|0,d+413|0);e=x[31609];x[31609]=0;if((e|0)==1){break i}x[31609]=0;e=d+208|0;V(89,e|0,b|0,f|0,g|0);h=x[31609];x[31609]=0;if((h|0)==1){break j}zb(a+1298368|0,e);tb(e);tb(g);tb(f);Eb(b);B=a+1298404|0,C=x[Fc(e,28)>>2],x[B>>2]=C;x[31609]=0;e=d+376|0;S(264,b|0,e|0,1312902469);g=x[31609];x[31609]=0;if((g|0)==1){break k}x[31609]=0;g=R(154,x[d+320>>2])|0;h=x[31609];x[31609]=0;if((h|0)==1){break m}x[31609]=0;h=a+1298308|0;S(270,b|0,h|0,g|0);b=x[31609];x[31609]=0;if((b|0)==1){break m}x[31609]=0;S(264,f|0,e|0,1397706311);b=x[31609];x[31609]=0;if((b|0)==1){break n}Nc(Xb(x[a+484360>>2],y[a+484376|0]));e=a+484360|0;j=Bb(z[d+370>>1]);f=0;O:{while(1){P:{if(j>>>0<=(f&65535)>>>0){break P}x[31609]=0;b=U(150,x[d+300>>2],x[d+308>>2],46)|0;g=x[31609];x[31609]=0;Q:{if((g|0)!=1){if(!b){break P}x[31609]=0;b=d+208|0;O(271,d+300|0,b|0);g=x[31609];x[31609]=0;if((g|0)!=1){if(!Ad(x[a+1298312>>2],y[a+1298319|0])){break Q}x[31609]=0;O(272,h|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break Q}}b=N()|0;break o}b=N()|0;break o}x[31609]=0;i=R(273,d+300|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break O}b=Xb(x[a+484360>>2],y[a+484376|0]);if(!mc(x[b>>2],x[b+4>>2])){x[31609]=0;b=R(274,e|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break O}if((b|0)==255){break P}b=Xb(x[a+484360>>2],y[a+484376|0])}x[31609]=0;g=d+288|0;O(275,g|0,d+208|0);k=x[31609];x[31609]=0;if((k|0)==1){break O}op(b,g);tb(g);b=y[a+484376|0];g=x[a+484360>>2];x[31609]=0;S(276,Xb(g,b)|0,d+300|0,i|0);b=x[31609];x[31609]=0;if((b|0)==1){break O}f=f+1|0;continue}break}Wj(e,0);x[31609]=0;S(264,d+264|0,d+376|0,1229869908);b=x[31609];x[31609]=0;if((b|0)!=1){x[31609]=0;b=R(277,x[d+264>>2])|0;f=x[31609];x[31609]=0;if((f|0)==1){break p}R:{S:{if(!b){break S}f=1;T:{while(1){b=f&65535;if(b>>>0>z[a+480192>>1]){x[31609]=0;S(264,d+188|0,d+376|0,1447382614);b=x[31609];x[31609]=0;if((b|0)!=1){break T}break p}x[31609]=0;h=d+208|0;O(278,d+264|0,h|0);e=x[31609];x[31609]=0;if((e|0)==1){break p}e=y[d+238|0]|y[d+239|0]<<8;x[31609]=0;b=U(251,a|0,b|0,Bb(e)|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break R}U:{V:{if(!b){break V}if(Bb(y[d+238|0]|y[d+239|0]<<8)>>>0>3999){break V}g=d+112|0;xE(g,2,h);x[31609]=0;e=d+136|0;O(218,e|0,g|0);j=x[31609];x[31609]=0;if((j|0)==1){break U}Ac(b+492|0,e);tb(e);xE(g,2,h);x[31609]=0;O(218,e|0,g|0);h=x[31609];x[31609]=0;if((h|0)==1){break p}Ac(((Bb(y[d+238|0]|y[d+239|0]<<8)<<5)+a|0)+946304|0,e);tb(e);x[b>>2]=0;B=b,C=ze((y[d+254|0]|y[d+255|0]<<8)<<16>>16)+128&65535,x[B+8>>2]=C;xc(b+8|0,256);v[b+15|0]=y[b+15|0]|1;b=y[d+238|0]|y[d+239|0]<<8;x[31609]=0;b=D(Bb(b),104)+a|0;O(279,b+484380|0,0);h=x[31609];x[31609]=0;if((h|0)==1){break p}B=d,C=Bb(y[d+240|0]|y[d+241|0]<<8),w[B+136>>1]=C;w[d+112>>1]=64;B=b+484410|0,C=z[Oc(e,g)>>1]<<2,w[B>>1]=C;g=b+484404|0;e=$b(y[d+242|0]|y[d+243|0]<<8|(y[d+244|0]<<16|y[d+245|0]<<24));h=Iua(e,e>>31,8303,0);e=hb;h=h+4181|0;e=h>>>0<4181?e+1|0:e;B=g,C=Gc(Jua(h,e,8363,0),hb),x[B>>2]=C;e=$b(y[d+250|0]|y[d+251|0]<<8|(y[d+252|0]<<16|y[d+253|0]<<24));if(!e){break V}g=Bb(y[d+256|0]|y[d+257|0]<<8);if(!(g&3)){break V}h=e;e=$b(y[d+246|0]|y[d+247|0]<<8|(y[d+248|0]<<16|y[d+249|0]<<24));x[b+484388>>2]=h+e;x[b+484384>>2]=e;b=b+484414|0;e=z[b>>1];w[b>>1]=e|2;if(!(g&2)){break V}w[b>>1]=e|6}f=f+1|0;continue}break}break p}b=x[d+200>>2];x[d+32>>2]=x[d+196>>2];x[d+36>>2]=b;x[d+40>>2]=x[d+204>>2];x[31609]=0;b=x[d+192>>2];x[d+24>>2]=x[d+188>>2];x[d+28>>2]=b;V(280,d+24|0,0,a|0,0);b=x[31609];x[31609]=0;if((b|0)==1){break p}x[31609]=0;S(264,d+168|0,d+376|0,1346719318);b=x[31609];x[31609]=0;if((b|0)==1){break p}b=x[d+180>>2];x[d+8>>2]=x[d+176>>2];x[d+12>>2]=b;x[d+16>>2]=x[d+184>>2];x[31609]=0;b=x[d+172>>2];x[d>>2]=x[d+168>>2];x[d+4>>2]=b;V(280,d|0,1,a|0,y[d+412|0]>2|0);b=x[31609];x[31609]=0;if((b|0)==1){break p}b=z[a+480192>>1]+1&65535;e=b>>>0<=1?1:b;b=1;while(1){if((b|0)==(e|0)){break S}f=x[((b<<2)+a|0)+900380>>2];if(!(!f|v[f+60|0]&1)){x[f>>2]=32767}b=b+1|0;continue}}b=d+264|0;ub(b);x[31609]=0;f=d+376|0;S(264,d+208|0,f|0,1346458708);e=x[31609];x[31609]=0;if((e|0)==1){break x}x[31609]=0;e=R(172,x[d+208>>2])|0;g=x[31609];x[31609]=0;if((g|0)==1){break y}if(!(c&1)|e^1){break J}x[31609]=0;S(264,b|0,f|0,1347305805);f=x[31609];x[31609]=0;if((f|0)==1){break z}x[31609]=0;P(183,b|0,1)|0;b=x[31609];x[31609]=0;if((b|0)==1){break B}b=z[d+372>>1];x[31609]=0;k=a+484344|0;O(223,k|0,Bb(b)|0);b=x[31609];x[31609]=0;if((b|0)==1){break B}j=Nb(d+156|0);i=0;W:{while(1){if(Bb(z[d+372>>1])>>>0<=i>>>0){od(j);ub(d+264|0);if(c&4){f=0;if(!t){break w}f=z[a+480188>>1];b=0;while(1)if((b|0)==(f|0)){f=1;break w}else{e=(b<<5)+a|0;v[e+480288|0]=1;e=e+480280|0;x[e>>2]=x[e>>2]|33554432;b=b+1|0;continue}}if(!r){break u}break v}x[31609]=0;f=d+208|0;b=R(273,f|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break D}x[31609]=0;g=R(281,f|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break E}x[31609]=0;e=d+112|0;S(185,e|0,f|0,g|0);f=x[31609];x[31609]=0;if((f|0)==1){break F}h=hc(d+136|0,e);ub(e);x[31609]=0;f=U(196,k|0,i&65535,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break H}X:{if(f){n=Fb(d+100|0);x[31609]=0;O(282,d+264|0,n|0);f=x[31609];x[31609]=0;if((f|0)==1){break I}f=x[k>>2];x[31609]=0;O(283,Wb(f,i)|0,n|0);f=x[31609];x[31609]=0;if((f|0)==1){break I}l=0;f=Wb(x[k>>2],i);af(d+88|0,x[f>>2],x[x[f+48>>2]+12>>2],0);Nc(j);u=(b>>>0<=1?1:b)-1|0;Y:while(1){b=x[h>>2];x[31609]=0;b=U(150,b|0,x[d+144>>2],1)|0;f=x[31609];x[31609]=0;if((f|0)==1){break X}Z:{if(!b){break Z}x[31609]=0;b=R(197,h|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break I}if(!b){B=d,C=wb(x[j>>2]),x[B+84>>2]=C;f=wb(x[j+4>>2]);while(1){b=x[d+84>>2];if(Ib(b,f)){Ae(Wb(x[k>>2],i),Ve(Oe(d+112|0,y[b|0],y[b+1|0]),l));ge(d+84|0);continue}else{Nc(j);if((l|0)==(u|0)){break Z}b=Wb(x[k>>2],i);l=l+1|0;af(d+112|0,x[b>>2],x[x[b+48>>2]+12>>2],l);b=x[d+116>>2];x[d+88>>2]=x[d+112>>2];x[d+92>>2]=b;continue Y}}}w[d+116>>1]=0;x[d+112>>2]=0;g=d+112|0;if(b>>>0<=z[a+480188>>1]){g=Yc(x[d+88>>2],b-1|0)}x[31609]=0;b=R(197,h|0)|0;f=x[31609];x[31609]=0;_:{$:{if((f|0)!=1){aa:{if(!(b&1)){break aa}x[31609]=0;f=R(197,h|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break I}if((f|0)!=31){if((f-1&255)>>>0>252){break aa}e=(D(f>>>4|0,12)+(f&15)|0)+13|0}else{e=255}v[g|0]=e}if(!(b&2)){break _}x[31609]=0;f=R(197,h|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break $}}break I}v[g+1|0]=f}if(!(b&60)){continue}f=0;m=0;if(b&4){x[31609]=0;m=R(197,h|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break I}}if(b&8){x[31609]=0;f=R(197,h|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break I}}s=0;e=0;if(b&16){x[31609]=0;e=R(197,h|0)|0;A=x[31609];x[31609]=0;if((A|0)==1){break I}}if(b&32){x[31609]=0;s=R(197,h|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break I}}b=d+84|0;o0(b,e,s);e=Jc(b);b=d+82|0;o0(b,m,f);f=Jc(b);b=y[d+82|0];ba:{if((b|0)!=13){if(b){break ba}b=0;if(y[d+84|0]==13){break ba}}rg(d+84|0,d+82|0);rg(e,f);b=y[d+82|0]}m=d+80|0;gm(m,g,y[d+84|0],y[e|0],b&255,y[f|0]);if(n0(y[d+80|0],y[d+81|0])){b=x[vb(d+76|0,wb(x[j>>2]))>>2];x[31609]=0;S(284,j|0,b|0,m|0);b=x[31609];x[31609]=0;if((b|0)==1){break W}}b=y[g+3|0];if((b|0)==43){t=1;continue}if((b|0)!=31){continue}r=1;continue}break}tb(n)}ub(h);i=i+1|0;continue}break}break I}break I}break p}b=N()|0;break o}b=N()|0;break o}b=N()|0;break b}f=0;if(c&4){break w}break u}b=N()|0;tb(n);break G}b=N()|0}ub(h);break C}b=N()|0;break C}b=N()|0;break C}b=N()|0}od(j);break A}b=N()|0}ub(d+264|0);break q}b=N()|0;break q}b=N()|0;break q}b=N()|0;break o}v[d+156|0]=0;v[d+157|0]=80;v[d+158|0]=0;v[d+159|0]=150;v[d+160|0]=0;v[d+161|0]=80;v[d+162|0]=0;v[d+163|0]=255;x[31609]=0;S(264,d+264|0,d+376|0,1146310725);b=x[31609];x[31609]=0;ca:{da:{if((b|0)!=1){x[31609]=0;b=R(277,x[d+264>>2])|0;e=x[31609];x[31609]=0;if((e|0)!=1){if(!b){e=f;break ca}x[31609]=0;h=R(273,d+264|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break da}b=0;e=f;while(1){if((b|0)==(h|0)){x[31609]=0;O(285,d+264|0,d+156|0);b=x[31609];x[31609]=0;if((b|0)!=1){break ca}break da}x[31609]=0;g=R(197,d+264|0)|0;j=x[31609];x[31609]=0;ea:{fa:{if((j|0)!=1){if(z[a+480188>>1]<=b>>>0){break ea}if(!f){break fa}j=((b<<5)+a|0)+480280|0;x[j>>2]=x[j>>2]&-33554433|((g|0)!=0)<<25;break ea}break da}if(g){break ea}e=1;v[((b<<5)+a|0)+480288|0]=1}b=b+1|0;continue}}break da}b=N()|0;break q}b=N()|0;ub(d+264|0);break q}f=d+264|0;ub(f);ga:{ha:{if(e&1){x[31609]=0;b=$d(a+906300|0,0);W(286,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break r}x[b+16>>2]=810369604;x[b+20>>2]=1869112133;x[b+24>>2]=655376;x[b+28>>2]=0;x[d+264>>2]=0;g=b+48|0;k0(b+32|0,g,f);x[31609]=0;e=P(36,d+136|0,9587)|0;h=x[31609];x[31609]=0;if((h|0)==1){break ha}wE(g,e);tb(e);x[31609]=0;e=P(36,d+112|0,9551)|0;g=x[31609];x[31609]=0;if((g|0)==1){break ga}rw(b+80|0,e);tb(e);x[31609]=0;O(287,b+4|0,8);e=x[31609];x[31609]=0;if((e|0)==1){break r}j0(f,y[d+157|0],y[d+159|0],y[d+161|0],y[d+163|0]);f=x[d+268>>2];b=x[b+4>>2];e=x[d+264>>2];v[b|0]=e;v[b+1|0]=e>>>8;v[b+2|0]=e>>>16;v[b+3|0]=e>>>24;v[b+4|0]=f;v[b+5|0]=f>>>8;v[b+6|0]=f>>>16;v[b+7|0]=f>>>24}if(r){break v}break u}b=N()|0;break q}b=N()|0;break q}h=a+902204|0;b=0;ia:{ja:{ka:{la:{ma:{na:{oa:{pa:{qa:{ra:{sa:{ta:{ua:{va:{wa:{while(1){if((b|0)==32){break u}x[d+88>>2]=D(b,127)>>>5;x[31609]=0;f=d+156|0;O(288,f|0,4093);e=x[31609];x[31609]=0;if((e|0)!=1){x[31609]=0;e=d+100|0;j=d+88|0;O(289,e|0,j|0);g=x[31609];x[31609]=0;if((g|0)==1){break wa}x[31609]=0;g=d+264|0;S(290,g|0,f|0,e|0);i=x[31609];x[31609]=0;if((i|0)==1){break va}fe(d+68|0,g);rf(Pe(h,b),x[d+68>>2],x[d+72>>2]);tb(g);tb(e);Eb(f);x[31609]=0;O(288,f|0,4075);i=x[31609];x[31609]=0;if((i|0)==1){break ta}x[31609]=0;O(289,e|0,j|0);i=x[31609];x[31609]=0;if((i|0)==1){break sa}x[31609]=0;S(290,g|0,f|0,e|0);i=x[31609];x[31609]=0;if((i|0)==1){break ra}fe(d+60|0,g);rf(Pe(h,b|32),x[d+60>>2],x[d+64>>2]);tb(g);tb(e);Eb(f);x[31609]=0;O(288,f|0,4066);i=x[31609];x[31609]=0;if((i|0)==1){break pa}x[31609]=0;O(289,e|0,j|0);i=x[31609];x[31609]=0;if((i|0)==1){break oa}x[31609]=0;S(290,g|0,f|0,e|0);i=x[31609];x[31609]=0;if((i|0)==1){break na}fe(d+52|0,g);rf(Pe(h,b|64),x[d+52>>2],x[d+56>>2]);tb(g);tb(e);Eb(f);x[31609]=0;O(288,f|0,4039);i=x[31609];x[31609]=0;if((i|0)==1){break la}x[31609]=0;O(289,e|0,j|0);j=x[31609];x[31609]=0;if((j|0)==1){break ka}x[31609]=0;S(290,g|0,f|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break ja}fe(d+44|0,g);rf(Pe(h,b|96),x[d+44>>2],x[d+48>>2]);b=b+1|0;tb(d+264|0);tb(d+100|0);Eb(f);continue}break}b=N()|0;break q}b=N()|0;break ua}b=N()|0;tb(d+100|0)}Eb(d+156|0);break q}b=N()|0;break q}b=N()|0;break qa}b=N()|0;tb(d+100|0)}Eb(d+156|0);break q}b=N()|0;break q}b=N()|0;break ma}b=N()|0;tb(d+100|0)}Eb(d+156|0);break q}b=N()|0;break q}b=N()|0;break ia}b=N()|0;tb(d+100|0)}Eb(d+156|0);break q}x[31609]=0;S(264,d+264|0,d+376|0,1397575756);b=x[31609];x[31609]=0;xa:{if((b|0)!=1){x[31609]=0;b=R(172,x[d+264>>2])|0;f=x[31609];x[31609]=0;if((f|0)!=1){ya:{f=1;if(!(c&2)|b^1){break xa}while(1){e=f&65535;if(e>>>0>z[a+480190>>1]){break xa}x[31609]=0;c=d+264|0;b=R(281,c|0)|0;g=x[31609];x[31609]=0;za:{if((g|0)!=1){x[31609]=0;g=R(281,c|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break ya}if(!(b&7)){break za}e=(D(e,104)+a|0)+484380|0;x[e>>2]=g;b=Zc(d+156|0,b&4?32:b&2?16:8,1,1,0);x[31609]=0;U(215,b|0,e|0,c|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break za}break ya}break ya}f=f+1|0;continue}}}b=N()|0;ub(d+264|0);break q}b=N()|0;break q}ub(d+264|0);ub(d+208|0);ub(d+300|0);ub(d+320|0)}ke(d+376|0);ub(q)}fb=d+416|0;return o|0}b=N()|0}ub(d+208|0);break o}b=N()|0;ub(d+264|0)}ub(d+300|0);break l}b=N()|0;break l}b=N()|0}ub(d+320|0);break b}b=N()|0;break b}b=N()|0;tb(d+264|0);break h}b=N()|0}tb(d+300|0);break f}b=N()|0}Eb(d+320|0);break b}b=N()|0;break b}b=N()|0;break b}b=N()|0}ke(d+376|0)}ub(q);Q(b|0);p()}function Toa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,A=0,B=0;e=fb-320|0;fb=e;yc(b);a:{b:{c:{f=e+224|0;if(!Dv(b,f)){break c}if(!ZW(f)){break c}if(!Mb(x[b>>2],x[b+8>>2],Bc(YW(f),hb))){break c}d=1;if((c|0)==64){break c}Dd(a,2);x[a+480260>>2]=64;x[a+480264>>2]=32767;j=Fb(e+212|0);d=y[e+264|0]|y[e+265|0]<<8;m=(d|0)==20479?y[e+278|0]|y[e+279|0]<<8:d-16464|0;d:{e:{f:{g:{h:{i:{switch(d>>>12|0){case 0:f=0;if((d|0)!=520){break d}x[31609]=0;d=P(1,e+200|0,12393)|0;g=x[31609];x[31609]=0;if((g|0)!=1){zb(j,d);break e}b=N()|0;break a;case 1:j:{if((d|0)!=4896){break j}d=y[e+286|0]|y[e+287|0]<<8;if(d){break j}if(!((y[e+262|0]|y[e+263|0]<<8)&65455|(y[e+276|0]|y[e+256|0]&15))){k:{if(v[e+275|0]<0){x[a+1074308>>2]=18219008;x[31609]=0;d=P(1,e+200|0,14821)|0;f=x[31609];x[31609]=0;if((f|0)!=1){break k}b=N()|0;break a}x[a+1074308>>2]=16777376;x[31609]=0;d=P(1,e+200|0,13461)|0;f=x[31609];x[31609]=0;if((f|0)==1){break h}}zb(j,d);tb(d);x[31609]=0;f=1;U(266,a+1074312|0,81,1)|0;d=x[31609];x[31609]=0;g=1;if((d|0)!=1){break d}break b}if(y[e+276|0]|d|(y[e+277|0]|(y[e+262|0]|y[e+263|0]<<8))){break j}f=0;x[31609]=0;d=P(1,e+200|0,9492)|0;g=x[31609];x[31609]=0;if((g|0)!=1){zb(j,d);break e}b=N()|0;break a}x[31609]=0;d=P(1,e+200|0,8494)|0;f=x[31609];x[31609]=0;i=1;if((f|0)!=1){zb(j,d);tb(d);break f}b=N()|0;break a;case 2:x[31609]=0;d=P(1,e+200|0,6808)|0;f=x[31609];x[31609]=0;g=1;if((f|0)!=1){zb(j,d);tb(d);break f}b=N()|0;break a;case 3:l:{m:{n:{o:{if(d>>>0<=12820){x[31609]=0;f=P(1,e+200|0,8573)|0;g=x[31609];x[31609]=0;if((g|0)!=1){zb(j,f);tb(f);break o}b=N()|0;break a}x[31609]=0;f=e+200|0;O(445,f|0,4015);g=x[31609];x[31609]=0;if((g|0)==1){break n}x[31609]=0;x[e+188>>2]=(y[e+264|0]|y[e+265|0]<<8)-12820;g=e+48|0;S(446,g|0,f|0,e+188|0);i=x[31609];x[31609]=0;if((i|0)==1){break m}zb(j,g);tb(g);Eb(f)}f=y[e+264|0]|y[e+265|0]<<8;if(f>>>0<12807){break g}g=y[e+280|0]|y[e+281|0]<<8|(y[e+282|0]<<16|y[e+283|0]<<24);if(g){break l}break g}b=N()|0;break a}b=N()|0;Eb(e+200|0);break a}f=HF(f,g);g=jp(e+48|0);x[g+32>>2]=f;x[31609]=0;O(447,a+1298412|0,g|0);f=x[31609];x[31609]=0;if((f|0)!=1){break g}b=N()|0;break a;case 4:if((d|0)==16640){f=0;x[31609]=0;d=P(1,e+200|0,8340)|0;h=x[31609];x[31609]=0;g=1;if((h|0)!=1){zb(j,d);tb(d);x[31609]=0;U(266,a+1074312|0,81,1)|0;d=x[31609];x[31609]=0;h=0;if((d|0)==1){break b}break d}b=N()|0;break a}x[31609]=0;f=e+48|0;S(442,f|0,d|0,y[e+278|0]|y[e+279|0]<<8);d=x[31609];x[31609]=0;p:{q:{r:{if((d|0)!=1){zb(j,f);tb(f);x[a+480260>>2]=1;if((m|0)<4201){break r}x[31609]=0;U(266,a+1074312|0,7,1)|0;d=x[31609];x[31609]=0;if((d|0)==1){break b}break q}b=N()|0;break a}if((m|0)<2386){break p}}x[31609]=0;U(266,a+1074312|0,38,1)|0;d=x[31609];x[31609]=0;if((d|0)==1){break b}}f=0;x[31609]=0;P(267,a+1074312|0,118)|0;d=x[31609];x[31609]=0;g=1;h=1;if((d|0)==1){break b}break d;case 5:if((d|0)!=21575){d=d&4095;x[a+1074308>>2]=d<<16|(d>>>0>296?y[e+278|0]|y[e+279|0]<<8:0)&65535;x[31609]=0;d=P(1,e+200|0,18262)|0;f=x[31609];x[31609]=0;s:{t:{u:{if((f|0)!=1){f=x[a+1074308>>2];x[31609]=0;g=e+188|0;O(134,g|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break u}f=0;x[31609]=0;h=e+48|0;S(2,h|0,d|0,g|0);i=x[31609];x[31609]=0;if((i|0)==1){break t}zb(j,h);tb(h);tb(g);break e}b=N()|0;break a}b=N()|0;break s}b=N()|0;tb(e+188|0)}tb(d);break a}f=0;x[31609]=0;d=P(1,e+200|0,8557)|0;g=x[31609];x[31609]=0;if((g|0)!=1){zb(j,d);break e}b=N()|0;break a;case 6:f=0;x[31609]=0;d=P(1,e+200|0,8340)|0;g=x[31609];x[31609]=0;if((g|0)!=1){zb(j,d);tb(d);x[31609]=0;U(266,a+1074312|0,81,1)|0;d=x[31609];x[31609]=0;g=0;if((d|0)==1){break b}break d}b=N()|0;break a;case 7:f=0;x[31609]=0;d=P(1,e+200|0,8352)|0;g=x[31609];x[31609]=0;if((g|0)!=1){zb(j,d);break e}b=N()|0;break a;default:break i}}f=0;if((d|0)!=51712){break d}x[31609]=0;d=P(1,e+200|0,9291)|0;g=x[31609];x[31609]=0;if((g|0)!=1){zb(j,d);break e}b=N()|0;break a}b=N()|0;break a}x[31609]=0;f=U(266,a+1074312|0,7,1)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}x[31609]=0;f=U(266,f|0,23,1)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}x[31609]=0;f=U(266,f|0,38,1)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}x[31609]=0;U(266,f|0,107,1)|0;f=x[31609];x[31609]=0;if((f|0)==1){break b}g=1;x[a+480260>>2]=1;i=0;f=0;if(d>>>0>12820){break d}}x[31609]=0;d=e+188|0;W(694,d|0);f=x[31609];x[31609]=0;v:{w:{x:{if((f|0)!=1){f=y[e+264|0]|y[e+265|0]<<8;x[e+164>>2]=f>>>8&15;x[31609]=0;x[e+148>>2]=f&255;h=e+176|0;O(444,h|0,e+148|0);f=x[31609];x[31609]=0;if((f|0)==1){break x}f=0;x[31609]=0;k=e+48|0;aa(695,k|0,d|0,j|0,e+164|0,h|0);o=x[31609];x[31609]=0;if((o|0)==1){break w}zb(j,k);tb(k);tb(h);Eb(d);h=0;break d}b=N()|0;break a}b=N()|0;break v}b=N()|0;tb(e+176|0)}Eb(e+188|0);break a}tb(d);g=0;i=0;h=0}x[31609]=0;d=P(1,e+188|0,15125)|0;k=x[31609];x[31609]=0;y:{z:{A:{B:{if((k|0)!=1){zb(a+1298344|0,d);tb(d);x[31609]=0;d=P(1,e+176|0,10490)|0;k=x[31609];x[31609]=0;if((k|0)==1){break B}zb(a+1298356|0,d);tb(d);k=zb(a+1298368|0,j);A=a+1298404|0,B=x[Fc(e+48|0,x[a+1074308>>2]?22:4)>>2],x[A>>2]=B;if(g){x[31609]=0;d=P(267,a+1074312|0,77)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}x[31609]=0;d=P(267,d|0,78)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}x[31609]=0;d=P(267,d|0,79)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}x[31609]=0;d=P(267,d|0,80)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}x[31609]=0;d=P(267,d|0,82)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}x[31609]=0;d=P(267,d|0,96)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}x[31609]=0;P(267,d|0,113)|0;d=x[31609];x[31609]=0;if((d|0)==1){break b}}d=y[e+264|0]|y[e+265|0]<<8;if(d>>>0<=4865){x[31609]=0;P(267,a+1074312|0,118)|0;d=x[31609];x[31609]=0;if((d|0)==1){break b}d=y[e+264|0]|y[e+265|0]<<8}g=d&61440;if(g>>>0>=4097){f=(g|0)!=12288|(d&65535)>>>0>12819|f}x[31609]=0;d=a+901404|0;W(696,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break b}if(!f){kr(d)}f=e+164|0;Xi(f,1,e+224|0);x[31609]=0;d=e+48|0;O(218,d|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break y}zb(a+1298308|0,d);tb(d);d=y[e+262|0]|y[e+263|0]<<8;if(d&16){x[a+480208>>2]=x[a+480208>>2]|65536}if(d&1){x[a+480208>>2]=x[a+480208>>2]|131072}f=y[e+264|0]|y[e+265|0]<<8;if(!(!(d&64)&(f|0)!=4864)){x[a+480208>>2]=x[a+480208>>2]|2}d=y[e+273|0];x[a+480196>>2]=d;if(!(!i|(d|0)!=255?d:0)){x[a+480196>>2]=6}d=y[e+274|0];x[a+480204>>2]=d>>>0<33?i?125e4:32e4:D(d,1e4);v[e+48|0]=y[e+272|0];v[e+164|0]=64;d=y[Qb(e+48|0,e+164|0)|0];x[a+480200>>2]=d<<2;if(!(d|f>>>0>4895)){x[a+480200>>2]=256}g=y[e+275|0];if((y[e+266|0]|y[e+267|0]<<8)!=1|g>>>0>7){break A}x[e+48>>2]=(g<<4)+16&240;x[e+164>>2]=127;d=x[Cd(e+48|0,e+164|0)>>2];break z}b=N()|0;break a}b=N()|0;break a}d=32;if((g|16)==18){break z}f=g&127;d=48;if(!f){break z}x[e+48>>2]=f;x[e+164>>2]=16;d=x[Xe(e+48|0,e+164|0)>>2]}f=d;x[a+480228>>2]=f;d=0;o=x[a+1074308>>2]!=0|g<<24>>24<0;if(!o){A=a,B=Bc(Kua(f<<3|5,f>>>29|0,11,0),hb),x[A+480228>>2]=B}w[a+480188>>1]=4;x[a+480232>>2]=h?(m|0)<3299?64:36:36;f=tc(e+160|0);while(1){if((d|0)==32){if(!z[a+480188>>1]){w[a+480188>>1]=1}d=y[a+484376|0];g=x[a+484360>>2];x[31609]=0;aa(348,Xb(g,d)|0,b|0,y[e+256|0]|y[e+257|0]<<8,255,254);d=x[31609];x[31609]=0;if((d|0)!=1){o=Nb(e+164|0);x[31609]=0;U(213,b|0,o|0,y[e+258|0]|y[e+259|0]<<8)|0;d=x[31609];x[31609]=0;C:{if((d|0)!=1){s=Nb(e+148|0);x[31609]=0;U(213,b|0,s|0,y[e+260|0]|y[e+261|0]<<8)|0;d=x[31609];x[31609]=0;D:{E:{F:{G:{H:{if((d|0)!=1){I:{if(y[e+277|0]!=252){break I}d=0;x[31609]=0;O(697,b|0,e+48|0);g=x[31609];x[31609]=0;if((g|0)==1){break E}g=0;J:{while(1){if((d|0)==32){K:{if(x[a+1074308>>2]!=18219008|z[a+480188>>1]>31){break I}if(!(g&1)){break J}x[31609]=0;d=P(1,e+136|0,14852)|0;f=x[31609];x[31609]=0;if((f|0)==1){break K}zb(k,d);tb(d);break I}}else{L:{M:{h=y[(e+48|0)+d|0];if(!(h&32)){break M}if(i){Qc(e+136|0,f,d);if(Gb(x[x[e+136>>2]>>2],x[e+140>>2])){break M}}w[((d<<5)+a|0)+480284>>1]=(((h&15)<<8|8)>>>0)/15;break L}g=h>>>0<16|g}d=d+1|0;continue}break}b=N()|0;break D}x[31609]=0;d=P(1,e+136|0,8541)|0;f=x[31609];x[31609]=0;if((f|0)==1){break H}zb(k,d);tb(d)}w[e+48>>1]=y[e+258|0]|y[e+259|0]<<8;w[e+36>>1]=3999;f=z[Oc(e+48|0,e+36|0)>>1];w[a+480190>>1]=f;t=c&2;u=e+96|0;d=0;h=0;g=0;m=0;N:{O:{P:{Q:{R:{S:{T:{while(1){if((f&65535)>>>0<=d>>>0){d=m&65535;if(!(d|!(h&i))&(y[e+264|0]|y[e+265|0]<<8)!=4864){break R}if(!i){break Q}x[31609]=0;f=U(266,a+1074312|0,79,d>>>0>1|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break O}x[31609]=0;h=f;f=d>>>0<2;h=U(266,h|0,107,f|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break O}x[31609]=0;U(266,h|0,38,f|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break O}x[31609]=0;P(127,k|0,(d>>>0>1?17226:17233)|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break O}if(f){break Q}x[a+480228>>2]=48;break Q}f=bc(x[o>>2],d);f=y[f|0]|y[f+1|0]<<8;x[31609]=0;f=P(149,b|0,f<<4)|0;l=x[31609];x[31609]=0;if((l|0)==1){break G}U:{V:{if(!f){break V}x[31609]=0;l=e+48|0;f=P(698,b|0,l|0)|0;n=x[31609];x[31609]=0;if((n|0)==1){break G}if(!f){break V}x[31609]=0;n=d+1|0;r=(D(n,104)+a|0)+484380|0;S(699,l|0,r|0,i|0);f=x[31609];x[31609]=0;if((f|0)==1){break G}q=e+24|0;Xi(q,1,u);x[31609]=0;f=e+36|0;O(218,f|0,q|0);q=x[31609];x[31609]=0;if((q|0)==1){break U}Ac(((n<<5)+a|0)+946304|0,f);tb(f);if(y[e+48|0]>1){break V}W:{if(!t|!(y[e+64|0]|y[e+65|0]<<8|(y[e+66|0]<<16|y[e+67|0]<<24))){break W}l=WW(l);x[31609]=0;l=P(149,b|0,l|0)|0;n=x[31609];x[31609]=0;if((n|0)==1){break T}if(!l){break W}VW(f,y[e+78|0],y[e+79|0],(y[e+266|0]|y[e+267|0]<<8)==1);x[31609]=0;U(215,f|0,r|0,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break S}g=y[e+39|0]==10|g;h=1}m=y[e+88|0]|y[e+89|0]<<8|m}d=d+1|0;f=z[a+480190>>1];continue}break}b=N()|0;break D}b=N()|0;break D}b=N()|0;break D}x[31609]=0;d=P(1,e+48|0,9766)|0;f=x[31609];x[31609]=0;if((f|0)==1){break P}zb(k,d);tb(d)}if(g&1){break N}break F}b=N()|0;break D}b=N()|0;break D}x[31609]=0;d=P(1,e+36|0,17166)|0;f=x[31609];x[31609]=0;X:{if((f|0)!=1){x[31609]=0;P(74,k|0,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break X}tb(d);break F}b=N()|0;break D}b=N()|0;tb(d);break D}b=N()|0;break D}b=N()|0;break D}b=N()|0;break D}Y:{if(!(c&1)){break Y}c=y[e+264|0]|y[e+265|0]<<8;w[e+24>>1]=y[e+260|0]|y[e+261|0]<<8;w[e+16>>1]=255;t=z[Oc(e+24|0,e+16|0)>>1];x[31609]=0;i=a+484344|0;O(223,i|0,t|0);d=x[31609];x[31609]=0;if((d|0)!=1){u=c>>>0<4896;h=0;k=0;l=0;Z:{_:{while(1){if((h|0)==(t|0)){if(!u){break Y}a=z[a+480188>>1];if((a|0)>(k+l|0)|(a|0)<=(k-l|0)){break Y}c=fb-16|0;fb=c;a=wb(x[i>>2]);x[c+12>>2]=a;d=wb(x[i+4>>2]);while(1){if(Ib(a,d)){b=wb(x[a>>2]);f=wb(x[a+4>>2]);a=fb-16|0;fb=a;x[a+12>>2]=b;while(1){if(Ib(b,f)){if(y[b+3|0]==31){v[b+3|0]=20;v[b+5|0]=y[b+5|0]|128}b=x[tg(a+12|0)>>2];continue}break}fb=a+16|0;a=x[Vl(c+12|0)>>2];continue}else{fb=c+16|0}break}break Y}x[31609]=0;c=U(196,i|0,h&65535,64)|0;d=x[31609];x[31609]=0;$:{if((d|0)==1){break $}aa:{if(!c){break aa}c=bc(x[s>>2],h);c=y[c|0]|y[c+1|0]<<8;if(!c){break aa}x[31609]=0;c=P(149,b|0,c<<4)|0;d=x[31609];x[31609]=0;if((d|0)==1){break $}if(!c){break aa}x[31609]=0;P(183,b|0,2)|0;c=x[31609];x[31609]=0;if((c|0)==1){break $}d=0;c=Wb(x[i>>2],h);af(e+24|0,x[c>>2],x[x[c+48>>2]+12>>2],0);while(1){if(d>>>0>63){break aa}f=d;x[31609]=0;c=R(197,b|0)|0;d=x[31609];x[31609]=0;ba:{if((d|0)!=1){d=c<<24>>24;if(d){break ba}d=64;if(f>>>0>62){continue}c=Wb(x[i>>2],h);d=f+1|0;af(e+16|0,x[c>>2],x[x[c+48>>2]+12>>2],d);c=x[e+20>>2];x[e+24>>2]=x[e+16>>2];x[e+28>>2]=c;continue}b=N()|0;break D}g=Ng(e+16|0);n=d&31;if(n>>>0<z[a+480188>>1]){g=Yc(x[e+24>>2],n)}r=d&255;if(r&32){x[31609]=0;c=e+14|0;O(198,c|0,b|0);q=x[31609];x[31609]=0;ca:{da:{ea:{if((q|0)!=1){q=Jc(c);c=y[e+14|0];if(c>>>0>239){break ea}c=TW((D(c>>>4|0,12)+(c&15)|0)+13|0);break da}b=N()|0;break D}fa:{switch(c-254|0){case 0:break da;case 1:break fa;default:break ca}}c=0}v[g|0]=c}v[g+1|0]=y[q|0]}if(r&64){x[31609]=0;c=R(197,b|0)|0;r=x[31609];x[31609]=0;if((r|0)==1){break _}c=c<<24>>24;v[e+14|0]=c;ga:{if((c|0)<=-64){v[g+2|0]=2;c=c&127;break ga}v[g+2|0]=1;v[e+13|0]=64;c=y[Qb(e+14|0,e+13|0)|0]}v[g+4|0]=c}ha:{if((d|0)>=0){break ha}x[31609]=0;c=e+14|0;O(198,c|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break Z}BD(g,y[e+14|0],y[Jc(c)|0],0);c=y[g+3|0];ia:{if((c|0)!=10){if((c|0)!=31){if((c|0)!=20){break ha}c=y[g+5|0];if((c&240)!=160|(y[e+264|0]|y[e+265|0]<<8)>>>0>4895){break ha}if((m&65535)>>>0>1){break ia}d=y[(e+n|0)+288|0]&127;if(d>>>0>=16){break ia}ja:{switch(c-160|0){case 0:case 2:v[g+5|0]=d&8?-116:-125;break ha;case 1:case 3:v[g+5|0]=d&8?-125:-116;break ha;default:break ja}}if(c>>>0>167){break ia}v[g+5|0]=136;break ha}c=y[g+5|0];if(c>>>0>15){u=0;break ha}if(c>>>0<=7){l=l+1|0;break ha}k=((c|0)!=8)+k|0;break ha}if(y[g+5|0]|(y[e+264|0]|y[e+265|0]<<8)>>>0>4865){break ha}}v[g+3|0]=37}d=f;continue}}h=h+1|0;continue}break}b=N()|0;break D}b=N()|0;break D}b=N()|0;break D}b=N()|0;break D}od(s);od(o);tb(j);d=1;break c}b=N()|0}od(s);break C}b=N()|0}od(o);break a}b=N()|0;break a}g=(d<<5)+a|0;m=g+480280|0;Ue(m);h=y[(d+e|0)+288|0];s=h&126;ka:{if((h|0)!=255){h=h<<24>>24;w[a+480188>>1]=d+1;if(o){w[g+480284>>1]=h&8?204:51}if((h|0)>=0){break ka}}x[m>>2]=1024}if((s-16&255)>>>0<=13){w[g+480284>>1]=128;g=e+48|0;Qc(g,f,d);ap(g)}d=d+1|0;continue}}b=N()|0;break a}fb=e+320|0;return d|0}b=N()|0}tb(j);Q(b|0);p()}function Ioa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,T=0,V=0;f=fb-480|0;fb=f;yc(b);d=fb-16|0;fb=d;l=f+276|0;EW(d+8|0,l);i=x[d+12>>2];lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2]);h=x[d+4>>2];if((h|0)==(i|0)){Vb(b,x[d+12>>2])}fb=d+16|0;d=(h|0)==(i|0);if(!d){DW(l)}a:{if(!d){break a}if(!FW(l)){break a}e=1;if((c|0)==64){break a}Dd(a,134217728);l=f+8|0;gg(l,3953);x[31609]=0;d=f+116|0;S(702,d|0,l|0,y[f+280|0]|y[f+281|0]<<8);i=x[31609];x[31609]=0;b:{c:{d:{if((i|0)!=1){zb(a+1298344|0,d);tb(d);Eb(l);l=uc(d,8990);zb(a+1298356|0,l);tb(l);T=a+1298404|0,V=x[Fc(d,28)>>2],x[T>>2]=V;x[a+480188>>2]=4;T=a,V=Bb(y[f+412|0]|y[f+413|0]<<8),x[T+480196>>2]=V;d=y[f+416|0]|y[f+417|0]<<8;x[a+480260>>2]=56;x[a+480264>>2]=13696;T=a,V=CW(Bb(d)),x[T+480204>>2]=V;ow(Xb(x[a+484360>>2],y[a+484376|0]),f+284|0,y[f+282|0]);n=a+480190|0;m=a+480188|0;o=Nb(f+264|0);B=Nb(f+252|0);e:{while(1){f:{g:{h:{i:{j:{k:{l:{if(Bb(y[f+476|0]|y[f+477|0]<<8)>>>0>(g&65535)>>>0){x[31609]=0;d=R(273,b|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break i}w[f+228>>1]=d;if((d-4e3&65535)>>>0<=61536){break c}e=Bb(y[f+478|0]|y[f+479|0]<<8);if((Bb(y[f+280|0]|y[f+281|0]<<8)|0)==2){x[31609]=0;d=R(281,b|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break j}e=d-2|0}x[31609]=0;d=f+8|0;S(185,d|0,b|0,e|0);l=x[31609];x[31609]=0;if((l|0)==1){break k}h=hc(f+116|0,d);ub(d);E=z[qe(n,f+228|0)>>1];w[a+480190>>1]=E;x[31609]=0;e=D(z[f+228>>1],104)+a|0;i=e+484380|0;O(279,i|0,1);d=x[31609];x[31609]=0;m:{n:{o:{if((d|0)==1){break o}if(Bb(y[f+280|0]|y[f+281|0]<<8)>>>0>1){break n}x[31609]=0;O(703,h|0,e+484423|0);d=x[31609];x[31609]=0;if((d|0)==1){break o}x[31609]=0;P(183,h|0,1)|0;d=x[31609];x[31609]=0;if((d|0)==1){break o}x[31609]=0;S(331,h|0,((z[f+228>>1]<<5)+a|0)+946304|0,30);d=x[31609];x[31609]=0;if((d|0)!=1){break m}}i=N()|0;break f}d=Fb(f+8|0);x[31609]=0;S(358,h|0,d|0,257);l=x[31609];x[31609]=0;p:{q:{if((l|0)==1){break q}Be(e+484423|0,d);x[31609]=0;P(183,h|0,1)|0;l=x[31609];x[31609]=0;if((l|0)==1){break q}x[31609]=0;S(358,h|0,d|0,31);l=x[31609];x[31609]=0;if((l|0)==1){break q}Ac(((z[f+228>>1]<<5)+a|0)+946304|0,d);if(!(v[f+124|0]&1)){break p}x[31609]=0;P(183,h|0,1)|0;l=x[31609];x[31609]=0;if((l|0)!=1){break p}}i=N()|0;tb(d);break f}tb(d)}x[31609]=0;O(704,h|0,f+8|0);d=x[31609];x[31609]=0;r:{if((d|0)==1){break r}k=fb-16|0;fb=k;l=$b(y[f+8|0]|y[f+9|0]<<8|(y[f+10|0]<<16|y[f+11|0]<<24));x[i>>2]=l;v[k+15|0]=y[f+12|0];v[k+14|0]=64;T=i,V=y[Qb(k+15|0,k+14|0)|0]<<2,w[T+30>>1]=V;j=$b(y[f+14|0]|y[f+15|0]<<8|(y[f+16|0]<<16|y[f+17|0]<<24));x[i+4>>2]=j;d=$b(y[f+14|0]|y[f+15|0]<<8|(y[f+16|0]<<16|y[f+17|0]<<24))+$b(y[f+18|0]|y[f+19|0]<<8|(y[f+20|0]<<16|y[f+21|0]<<24))|0;x[i+8>>2]=d;if(j>>>0>=l>>>0){j=l-1|0;x[i+4>>2]=j}if(d>>>0>l>>>0){x[i+8>>2]=l;d=l}s:{if(d>>>0<j>>>0){x[i+4>>2]=0;x[i+8>>2]=0;break s}if(d>>>0<=j>>>0){break s}w[i+34>>1]=z[i+34>>1]|2;T=yb(i+68|0,0),V=j,x[T>>2]=V}fb=k+16|0;t:{switch(Bb(y[f+280|0]|y[f+281|0]<<8)|0){case 2:v[e+484417|0]=y[f+26|0]<<3;break;case 0:break g;default:break t}}x[31609]=0;O(210,B|0,E|0);d=x[31609];x[31609]=0;if((d|0)==1){break r}x[31609]=0;O(705,o|0,E|0);d=x[31609];x[31609]=0;if((d|0)==1){break r}l=Vd(x[o>>2],z[f+228>>1]-1|0);Nc(l);x[31609]=0;d=R(273,b|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break l}i=x[b+8>>2];k=x[b>>2];x[31609]=0;i=U(150,k|0,i|0,d<<3)|0;k=x[31609];x[31609]=0;if((k|0)==1){break l}if(i){x[31609]=0;O(706,l|0,d|0);i=x[31609];x[31609]=0;if((i|0)==1){break l}x[f+248>>2]=0;if(!(y[e+484414|0]&2)|d){break h}d=x[e+484384>>2];x[f+240>>2]=d;i=x[e+484388>>2];x[31609]=0;x[f+244>>2]=i-d;O(707,l|0,f+240|0);d=x[31609];x[31609]=0;if((d|0)!=1){break g}i=N()|0;break f}ub(h);break c}i=N()|0;break f}u:{v:{w:{x:{if(Bb(y[f+280|0]|y[f+281|0]<<8)){C=y[f+283|0];w[f+238>>1]=4;F=128;break x}x[31609]=0;F=R(273,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){i=N()|0;break e}d=y[f+280|0]|y[f+281|0]<<8;C=y[f+283|0];w[f+238>>1]=4;if(!Bb(d)){break w}}l=x[b+8>>2];i=0;while(1){y:{if((i&65535)>>>0>=F>>>0){break y}x[31609]=0;d=R(273,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break v}if((d|0)==65535){break y}x[31609]=0;C=R(273,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break v}x[31609]=0;d=R(273,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break v}w[f+238>>1]=d;if(d>>>0>127){break c}T=m,V=z[qe(m,f+238|0)>>1],w[T>>1]=V;x[31609]=0;P(183,b|0,D(d,C)<<2)|0;d=x[31609];x[31609]=0;if((d|0)==1){break v}i=i+1|0;continue}break}x[31609]=0;P(149,b|0,l|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break u}}d=z[m>>1];x[31609]=0;G=P(708,f+240|0,d|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){J=a+484344|0;M=c&1;H=Bb(y[f+414|0]|y[f+415|0]<<8);d=0;l=0;while(1){z:{A:{B:{C:{if((d&65535)>>>0>=F>>>0){break C}D:{if(!Bb(y[f+280|0]|y[f+281|0]<<8)){e=z[f+238>>1];i=d;break D}x[31609]=0;i=R(273,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break z}if((i|0)==65535){break C}x[31609]=0;C=R(273,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break z}x[31609]=0;e=R(273,b|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break z}w[f+238>>1]=e}h=x[b+8>>2];g=x[b>>2];x[31609]=0;q=h;I=C&65535;h=I<<2;e=U(150,g|0,q|0,D(h,e&65535)|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break z}if(!e){break C}if(!M){break B}x[31609]=0;K=i&65535;i=U(196,J|0,K|0,I|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break z}if(!i){break B}s=0;E:while(1){if((s|0)==(I|0)){break A}i=Wb(x[J>>2],K);af(f+228|0,x[i>>2],x[x[i+48>>2]+12>>2],s);i=0;t=0;F:{G:{switch((H&3)-1|0){case 0:t=!(s&3);break F;case 1:t=!(s&1);break F;case 2:break G;default:break F}}t=(s&3)!=3}L=0;while(1){if(z[f+238>>1]<=i>>>0){s=s+1|0;continue E}g=x[G>>2];h=Yc(x[f+228>>2],i);x[31609]=0;e=f+224|0;O(357,e|0,b|0);k=x[31609];x[31609]=0;if((k|0)==1){break z}k=D(i,9)+g|0;g=Jc(e);r=_e(e);v[h+1|0]=y[f+224|0];j=y[g|0];v[h|0]=j;g=y[_i(e)|0];v[h+5|0]=g;m=h+5|0;if(j){v[h|0]=j+25;v[k+8|0]=0;v[k|0]=0;v[k+1|0]=0;v[k+2|0]=0;v[k+3|0]=0;v[k+4|0]=0;v[k+5|0]=0;v[k+6|0]=0;v[k+7|0]=0;g=y[h+5|0]}j=g&255;r=y[r|0];H:{I:{if(r>>>0>=240){e=j|(r&15)<<8;if(e){v[h+3|0]=17;T=h,V=_l(+(CW(e)>>>0)/1e4),v[T+5|0]=V;j=0;break H}break I}u=j>>>4|0;q=j<<4;e=u|q;J:{switch(r|0){case 0:if(g&255){v[h+3|0]=1;j=0;break H}break I;case 1:v[h+3|0]=2;j=0;break H;case 2:v[h+3|0]=3;j=0;break H;case 3:v[f+220|0]=15;T=k,V=y[Qb(m,f+220|0)|0]|16,v[T|0]=V;v[k+7|0]=0;v[k+1|0]=0;v[k+2|0]=0;break I;case 4:v[f+220|0]=15;T=k,V=y[Qb(m,f+220|0)|0]|32,v[T|0]=V;v[k+7|0]=0;v[k+1|0]=0;v[k+2|0]=0;break I;case 5:v[k+7|0]=0;v[k+2|0]=0;v[k+1|0]=g;v[k|0]=0;break I;case 6:v[k+7|0]=0;v[k+2|0]=g;v[k|0]=0;v[k+1|0]=0;break I;case 7:v[h+3|0]=23;j=0;l=0;break H;case 8:v[h+3|0]=0;j=1;l=e;break H;case 9:v[h+3|0]=19;v[f+220|0]=15;T=h,V=y[Qb(m,f+220|0)|0]|16,v[T+5|0]=V;j=0;break H;case 10:v[h+3|0]=19;v[f+220|0]=15;T=h,V=y[Qb(m,f+220|0)|0]|32,v[T+5|0]=V;j=0;break H;case 11:v[k+3|0]=e;break I;case 12:v[h+4|0]=g;j=1;v[h+2|0]=1;v[k+3|0]=0;v[h+3|0]=0;break H;case 13:e=g&255;K:{L:{if(e>>>0>=16){v[h+2|0]=4;g=(g&240)>>>4|0;break L}if(!e){break K}v[h+2|0]=3}v[h+4|0]=g}v[k+3|0]=0;break I;case 14:v[h+3|0]=19;v[h+5|0]=!(g&255);j=0;break H;case 15:v[h+3|0]=16;v[h+5|0]=(g&240)>>>4;H=g&15;j=0;break H;case 16:v[k+5|0]=0;v[k+4|0]=g;break I;case 17:v[k+6|0]=j&15?g:0;break I;case 18:v[h+3|0]=14;j=0;break H;case 19:v[k+8|0]=0;v[k+7|0]=g;v[k+2|0]=0;v[k|0]=0;v[k+1|0]=0;break I;case 20:v[h+3|0]=12;j=0;break H;case 22:e=y[h+1|0];M:{if(!e){break M}j=x[o>>2];if(Ud(j,x[o+4>>2])>>>0<e>>>0){break M}g=g-1|0;v[m|0]=g;x[31609]=0;R(709,f+116|0)|0;r=x[31609];x[31609]=0;if((r|0)==1){break z}x[f+220>>2]=9;e=Vd(j,e-1|0);T=f,V=Ud(x[e>>2],x[e+4>>2]),x[T+112>>2]=V;if(A[Hb(f+220|0,f+112|0)>>2]<=(g&255)>>>0){break M}v[h+2|0]=15;v[h+4|0]=y[h+5|0]}break I;case 23:e=y[h+1|0];N:{if(!e){break N}j=x[o>>2];if(Ud(j,x[o+4>>2])>>>0<e>>>0){break N}g=g-1|0;v[m|0]=g;e=Vd(j,e-1|0);j=x[e>>2];q=Ud(j,x[e+4>>2]);e=g&255;if(q>>>0<=e>>>0){break N}e=Vd(j,e);g=z[e+8>>1];O:{if(g){break O}g=0;j=z[n>>1];if(!pi(j)){break O}g=j+1|0;w[n>>1]=g;w[e+8>>1]=g}v[h+1|0]=g}break I;case 24:e=y[h+1|0];P:{if(!e){break P}j=x[o>>2];if(Ud(j,x[o+4>>2])>>>0<e>>>0){break P}g=g-1|0;v[m|0]=g;x[31609]=0;R(709,f+8|0)|0;r=x[31609];x[31609]=0;if((r|0)==1){break z}x[f+220>>2]=9;e=Vd(j,e-1|0);T=f,V=Ud(x[e>>2],x[e+4>>2]),x[T+112>>2]=V;if(A[Hb(f+220|0,f+112|0)>>2]>(g&255)>>>0){v[h+2|0]=15;v[h+4|0]=y[h+5|0]}e=bc(x[B>>2],y[h+1|0]-1|0);g=z[e>>1];Q:{if(g){break Q}g=0;j=z[n>>1];if(!pi(j)){break Q}g=j+1|0;w[n>>1]=g;w[e>>1]=g}v[h+1|0]=g}break I;case 25:e=y[h+1|0];R:{if(!e){break R}j=x[o>>2];if(Ud(j,x[o+4>>2])>>>0<e>>>0){break R}g=g-1|0;v[m|0]=g;e=Vd(j,e-1|0);j=x[e>>2];q=Ud(j,x[e+4>>2]);e=g&255;if(q>>>0<=e>>>0){break R}e=Vd(j,e);g=z[e+10>>1];S:{if(g){break S}g=0;j=z[n>>1];if(!pi(j)){break S}g=j+1|0;w[n>>1]=g;w[e+10>>1]=g}v[h+1|0]=g}break I;case 29:v[h+5|0]=e;v[h+3|0]=11;if(j&15){v[m|0]=q|15;j=0;break H}j=0;if((g&255)>>>0<16){break H}v[m|0]=u|240;break H;case 32:if((g&255)>>>0>=16){v[k+3|0]=u;break I}v[h+3|0]=19;v[h+5|0]=g|192;j=0;break H;case 33:v[h+3|0]=19;v[f+220|0]=15;T=h,V=y[Qb(m,f+220|0)|0]|208,v[T+5|0]=V;j=0;break H;case 34:v[h+3|0]=19;v[f+220|0]=15;T=h,V=y[Qb(m,f+220|0)|0]|144,v[T+5|0]=V;j=0;break H;case 73:v[h+3|0]=10;j=0;break H;case 78:if((g&112|128)==224){v[h+3|0]=19;j=0;break H}break I;case 79:if((g&255)>>>0<=31){v[h+3|0]=16;j=0;H=0;break H}v[h+3|0]=17;j=0;break H;default:break J}}}v[h+3|0]=0;j=1}r=0;e=y[k+3|0];if(!(y[h+2|0]|!e)){q=e;u=e>>>4|0;e=e>>>0<16;v[h+4|0]=e?q:u;v[h+2|0]=e?6:5;r=1}T:{if(!j){break T}g=y[k+1|0];U:{if(g){v[h+3|0]=2;break U}g=y[k+2|0];if(g){v[h+3|0]=3;break U}g=y[k|0];if(g){v[h+3|0]=19;break U}g=y[k+7|0];if(g){v[h+3|0]=4;v[k+8|0]=g;break U}g=y[k+4|0];if(g){v[h+3|0]=5;v[k+5|0]=g;break U}e=y[k+3|0];if(!(!e|r)){v[h+5|0]=e;v[h+3|0]=11;if(e&15){g=e|-16;break U}g=e|15;break U}g=y[k+6|0];if(g){v[h+3|0]=8;break U}if(t){v[h+3|0]=20;t=0;g=97;break U}t=0;if(!(l&255)|L){break T}v[h+5|0]=l;v[h+3|0]=24;g=l&15?l|-16:l|15;L=1}v[m|0]=g}i=i+1|0;continue}}}x[a+480228>>2]=256/z[a+480188>>1];j=1;Wh(a,1);if(Bb(y[f+280|0]|y[f+281|0]<<8)){V:{while(1){d=x[b+8>>2];l=x[b>>2];x[31609]=0;d=U(150,l|0,d|0,2)|0;l=x[31609];x[31609]=0;if((l|0)==1){break z}if(!d){break V}x[31609]=0;d=R(273,b|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break z}if((d|0)==65535){break V}x[31609]=0;P(183,b|0,2)|0;d=x[31609];x[31609]=0;if((d|0)==1){break z}x[31609]=0;d=R(281,b|0)|0;l=x[31609];x[31609]=0;if((l|0)!=1){x[31609]=0;P(183,b|0,d|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){continue}}break}break z}x[31609]=0;P(183,b|0,34)|0;d=x[31609];x[31609]=0;if((d|0)==1){break z}}W:{if(!(c&2)){break W}while(1){c=j&65535;if(c>>>0>E>>>0){break W}X:{i=(D(c,104)+a|0)+484380|0;if(!x[i>>2]){break X}d=Zc(f+228|0,8,1,0,0);x[31609]=0;U(215,d|0,i|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break z}d=x[o>>2];if(Ud(d,x[o+4>>2])>>>0<c>>>0){break X}k=c-1|0;h=Vd(d,k);c=0;d=0;m=fb-112|0;fb=m;Y:{g=x[i>>2];if(!le(g,x[i+20>>2])){break Y}s=x[h>>2];l=Ud(s,x[h+4>>2]);if(l>>>0<2){break Y}e=Wo(m+8|0,i);x[e+20>>2]=0;x[e>>2]=0;Z:{while(1){if((c|0)==(l|0)){break Z}_:{n=Vd(s,c);t=x[n>>2];if(t>>>0>=g>>>0){break _}n=x[n+4>>2];if(n>>>0>g-t>>>0|268435456-n>>>0<d>>>0){break _}d=d+n|0;x[e>>2]=d;c=c+1|0;continue}break}l=c}if(!Gh(e)){break Y}n=e+68|0;d=0;c=0;while(1){if((c|0)==(l|0)){on(i);c=Wo(i,e);x[c+4>>2]=0;x[c+8>>2]=x[c>>2];w[c+34>>1]=z[c+34>>1]|2;break Y}u=x[e+20>>2]+d|0;q=x[i+20>>2];g=Vd(x[h>>2],c);zc(u,q+x[g>>2]|0,x[g+4>>2]);x[g>>2]=d;if(c-10>>>0>=4294967287){T=yb(n,c-1|0),V=d,x[T>>2]=V}c=c+1|0;d=x[g+4>>2]+d|0;continue}}fb=m+112|0;c=z[bc(x[B>>2],k)>>1];if(c){zC(i,(D(c,104)+a|0)+484380|0,0,x[i>>2],0)}c=Vd(x[o>>2],k);T=f,V=wb(x[c>>2]),x[T+228>>2]=V;d=wb(x[c+4>>2]);while(1){c=x[f+228>>2];if(!Ib(c,d)){break X}l=z[c+8>>1];if(l){zC(i,(D(l,104)+a|0)+484380|0,x[c>>2],x[c+4>>2],1)}l=z[c+10>>1];if(l){zC(i,(D(l,104)+a|0)+484380|0,x[c>>2],x[c+4>>2],0)}ym(f+228|0);continue}}j=j+1|0;continue}}xv(G);e=1;break b}x[31609]=0;P(183,b|0,D(h,z[f+238>>1])|0)|0;i=x[31609];x[31609]=0;if((i|0)!=1){break A}break z}d=d+1|0;continue}break}i=N()|0;xv(G);break e}i=N()|0;break e}i=N()|0;break e}i=N()|0;break e}i=N()|0;break f}i=N()|0;break e}i=N()|0;break e}i=N()|0;break e}e=0;while(1){if(d>>>0<=(e&65535)>>>0){break g}x[31609]=0;i=R(281,b|0)|0;k=x[31609];x[31609]=0;$:{if((k|0)==1){break $}x[31609]=0;x[f+240>>2]=i;i=R(281,b|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break $}x[31609]=0;x[f+244>>2]=i;O(707,l|0,f+240|0);i=x[31609];x[31609]=0;if((i|0)==1){break $}e=e+1|0;continue}break}i=N()|0;break f}ub(h);g=g+1|0;continue}break}ub(h)}od(B);AW(o);break d}i=N()|0;Eb(f+8|0)}Q(i|0);p()}e=0}od(B);AW(o)}fb=f+480|0;return e|0}function Ona(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0;d=fb-576|0;fb=d;yc(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{g=d+496|0;l:{if(!CD(b,g)){break l}if(!FV(g)){break l}if(!Mb(x[b>>2],x[b+8>>2],Bc(EV(g),hb))){break l}e=1;if((c|0)==64){break l}Dd(a,4);eg(a);v[a+1074368|0]=4;l=Fb(d+484|0);k=d+534|0;m:{if(!(jd(k,18435,20)|(y[d+556|0]|y[d+557|0]<<8|(y[d+558|0]<<16|y[d+559|0]<<24))!=276)){r=41080;e=48;if((y[d+554|0]|y[d+555|0]<<8)>>>0<260){break m}e=qq(d+513|0,0,20)?1154:34;break m}r=41080;if(!jd(k,18414,20)){break m}e=d+104|0;qi(e,3,k);x[31609]=0;g=d+192|0;S(369,g|0,4,e|0);e=x[31609];x[31609]=0;n:{if((e|0)!=1){zb(l,g);tb(g);if((y[k|0]|y[k+1|0]<<8|(y[k+2|0]<<16|y[k+3|0]<<24))!=1852141647|(y[k+4|0]|y[k+5|0]<<8|(y[k+6|0]<<16|y[k+7|0]<<24))!=542396493){break n}e=1048;break m}b=N()|0;break a}if(!jd(k,18162,12)){e=16;if((y[d+546|0]|y[d+547|0]<<8|(y[d+548|0]<<16|y[d+549|0]<<24))==538976288&(y[d+550|0]|y[d+551|0]<<8|(y[d+552|0]<<16|y[d+553|0]<<24))==538976288){break m}v[a+1074368|0]=5;break m}if(!jd(k,11673,20)){e=48;break m}if(!jd(k,25456,15)){x[31609]=0;g=P(267,a+1074312|0,54)|0;e=x[31609];x[31609]=0;if((e|0)==1){break b}x[31609]=0;P(267,g|0,51)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}r=41072;e=16;break m}o:{if(jd(k,25472,14)){if(jd(k,25487,14)){break o}}x[31609]=0;g=P(267,a+1074312|0,57)|0;e=x[31609];x[31609]=0;if((e|0)==1){break b}x[31609]=0;P(267,g|0,51)|0;g=x[31609];x[31609]=0;e=16;if((g|0)!=1){break m}break b}e=jd(k,18250,11)?16:256}f=d+104|0;u=d+513|0;qi(f,3,u);x[31609]=0;g=d+192|0;O(218,g|0,f|0);n=x[31609];x[31609]=0;p:{q:{r:{s:{t:{if((n|0)!=1){zb(a+1298308|0,g);tb(g);x[a+480260>>2]=1;x[a+480264>>2]=31999;$e(Xb(x[a+484360>>2],y[a+484376|0]),y[d+562|0]|y[d+563|0]<<8);w[a+480188>>1]=y[d+564|0]|y[d+565|0]<<8;w[d+192>>1]=y[d+568|0]|y[d+569|0]<<8;w[d+104>>1]=255;H=a,I=z[Oc(g,f)>>1],w[H+480192>>1]=I;g=y[d+572|0]|y[d+573|0]<<8;if(g){x[a+480196>>2]=g}g=y[d+574|0]|y[d+575|0]<<8;if(g){g=D(g,1e4);g=g>>>0>=1e7?1e7:g;x[a+480204>>2]=g>>>0<=32e4?32e4:g}g=y[d+570|0]|y[d+571|0]<<8;x[a+480208>>2]=g<<4&16|g<<3&32768;f=x[a+484360>>2];n=y[a+484376|0];x[31609]=0;aa(348,Xb(f,n)|0,b|0,y[d+560|0]|y[d+561|0]<<8,65535,65535);f=x[31609];x[31609]=0;if((f|0)==1){break b}f=g>>>12&1?(e|0)==34?146:e:e;if(!(y[d+560|0]|y[d+561|0]<<8|f>>>0>1023)){g=y[a+484376|0];e=x[a+484360>>2];x[31609]=0;W(762,Xb(e,g)|0);g=x[31609];x[31609]=0;if((g|0)==1){break b}}x[31609]=0;P(149,b|0,(y[d+556|0]|y[d+557|0]<<8|(y[d+558|0]<<16|y[d+559|0]<<24))+60|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}if((y[d+554|0]|y[d+555|0]<<8)>>>0>=260){x[31609]=0;S(763,b|0,d+496|0,a|0);g=x[31609];x[31609]=0;if((g|0)==1){break b}}v[d+483|0]=0;B=c&2;F=d+122|0;o=d+225|0;n=Nb(d+468|0);s=1;g=-1;while(1){e=s&65535;if(e>>>0>z[a+480192>>1]){if(!(!(f&2)|t&255)){f=qq(u,0,20)?f|16:f}if((y[d+554|0]|y[d+555|0]<<8)>>>0>259){break r}if(c&3){x[31609]=0;S(763,b|0,d+496|0,a|0);c=x[31609];x[31609]=0;if((c|0)==1){break q}}if(!B){break r}e=1;while(1){c=e&65535;if(c>>>0>z[a+480190>>1]){break r}o=x[n>>2];x[31609]=0;U(215,yb(o,c-1|0)|0,(D(c,104)+a|0)+484380|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){e=e+1|0;continue}break}b=N()|0;break c}x[31609]=0;j=R(151,b|0)|0;i=x[31609];x[31609]=0;u:{v:{if((i|0)!=1){Ih(b,4);x[31609]=0;S(764,b|0,d+192|0,(j?j:263)|0);j=x[31609];x[31609]=0;if((j|0)==1){break s}w:{if((f|0)==1){j=x[d+192>>2];if((j|0)!=263){f=16;if((j|0)!=245){break w}x[a+1074308>>2]=16777381;x[31609]=0;f=P(1,d+180|0,13461)|0;j=x[31609];x[31609]=0;if((j|0)!=1){zb(l,f);tb(f);f=17;break w}b=N()|0;break c}x[a+1074308>>2]=16777395;x[31609]=0;f=P(1,d+168|0,13352)|0;j=x[31609];x[31609]=0;if((j|0)!=1){zb(l,f);tb(f);f=17;break w}b=N()|0;break c}if(y[d+219|0]|y[d+220|0]<<8){break w}j=x[d+192>>2];if(!(!(f&2)|(y[d+221|0]|y[d+222|0]<<8|(y[d+223|0]<<16|y[d+224|0]<<24))|(j|0)!=263)){f=f|16;break w}if(!(!(f&256)|(j|0)==29)){f=f&-257;break w}if(!(f&160)){break w}f=(j|0)==33?f:0}x[31609]=0;j=U(251,a|0,e|0,0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break s}if(!j){break u}j=((e<<2)+a|0)+900380|0;e=x[j>>2];x[31609]=0;O(765,d+192|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break s}e=y[d+218|0];x:{if((g|0)==-1){g=e;break x}if(!(f&32)|(e|0)==(g|0)){break x}f=f&-161|128}e=y[d+219|0]|y[d+220|0]<<8;if(!e){break u}x[31609]=0;i=y[d+439|0];h=y[d+435|0]|y[d+436|0]<<8;m=y[d+434|0];q=y[d+433|0];S(766,d+156|0,a|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break t}f=i|(h|(m|q))?f&-4:f;j=x[j>>2]+236|0;e=12;i=x[d+156>>2];h=$c(i,x[d+160>>2]);y:{while(1){z:{if((e|0)==108){if((y[d+554|0]|y[d+555|0]<<8)>>>0>259){Nc(n)}e=0;x[31609]=0;j=P(767,d+144|0,y[d+219|0]|y[d+220|0]<<8)|0;i=x[31609];x[31609]=0;if((i|0)!=1){break z}b=N()|0;break y}m=bc(j,e);if(h>>>0>z[m>>1]){H=m,I=z[bc(i,z[bc(j,e)>>1])>>1],w[H>>1]=I}e=e+1|0;continue}break}A:{B:{C:{D:{while(1){i=y[d+219|0]|y[d+220|0]<<8;if(e>>>0>=i>>>0){e=0;if((y[d+554|0]|y[d+555|0]<<8)>>>0<=259){break v}E:{while(1){if(e>>>0>=i>>>0){break v}m=y[yb(x[n>>2],e)+3|0];i=x[yb(x[j>>2],e)>>2];x[31609]=0;h=d+72|0;S(185,h|0,b|0,((m|0)==10?(i+1>>>1|0)+16|0:i)|0);i=x[31609];x[31609]=0;if((i|0)!=1){i=hc(d+104|0,h);ub(h);h=x[d+156>>2];if(!(!B|$c(h,x[d+160>>2])>>>0<=e>>>0)){m=z[bc(h,e)>>1];h=yb(x[n>>2],e);h=y[h|0]|y[h+1|0]<<8|(y[h+2|0]<<16|y[h+3|0]<<24);x[31609]=0;x[d+68>>2]=h;x[d+8>>2]=h;h=ba(768,(D(m,104)+a|0)+484380|0,d+8|0,i|0,d+483|0)|0;m=x[31609];x[31609]=0;if((m|0)==1){break E}C=h^1|C}ub(i);e=e+1|0;i=y[d+219|0]|y[d+220|0]<<8;continue}break}b=N()|0;break A}b=N()|0;ub(i);break A}x[31609]=0;q=d+104|0;O(769,b|0,q|0);i=x[31609];x[31609]=0;if((i|0)==1){break B}i=d+72|0;h=y[d+118|0];F:{if(!(h&48|y[d+121|0]!=173)){Zc(i,8,1,0,10);break F}Zc(i,h&16?16:8,h&32?3:1,0,2)}x[31609]=0;O(770,n|0,i|0);h=x[31609];x[31609]=0;if((h|0)!=1){H=yb(x[j>>2],e),I=x[d+104>>2],x[H>>2]=I;G=y[d+121|0];h=x[d+156>>2];if($c(h,x[d+160>>2])>>>0>e>>>0){m=z[bc(h,e)>>1];x[31609]=0;h=(D(m,104)+a|0)+484380|0;O(771,q|0,h|0);q=x[31609];x[31609]=0;if((q|0)==1){break D}v[h+38|0]=y[o+202|0];v[h+39|0]=y[o+203|0];v[h+40|0]=y[o+204|0];v[h+41|0]=y[o+205|0];h=d+92|0;Sk(h,3,F);x[31609]=0;O(218,i|0,h|0);h=x[31609];x[31609]=0;if((h|0)==1){break C}Ac(((m<<5)+a|0)+946304|0,i);tb(i);f=(y[d+118|0]&3)!=3?f:f&2?f|4:f}t=t|G;e=e+1|0;E=y[xf(x[n+4>>2])+3|0]==10|E;continue}break}b=N()|0;break A}b=N()|0;break A}b=N()|0;break A}b=N()|0}wc(j)}od(d+156|0);break c}b=N()|0;break c}wc(j);od(d+156|0)}s=s+1|0;continue}}b=N()|0;break a}b=N()|0;break c}b=N()|0;break c}G:{if(!(C&1)){break G}x[31609]=0;c=P(1,d+104|0,16687)|0;e=x[31609];x[31609]=0;H:{if((e|0)!=1){e=x[a+1298472>>2];x[31609]=0;S(385,e|0,2,c|0);e=x[31609];x[31609]=0;if((e|0)==1){break H}tb(c);break G}b=N()|0;break c}b=N()|0;tb(c);break c}x[31609]=0;c=P(412,b|0,5558)|0;e=x[31609];x[31609]=0;if((e|0)==1){break q}if(c){x[31609]=0;c=R(151,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break q}x[31609]=0;V(336,a+1298332|0,b|0,c|0,0);c=x[31609];x[31609]=0;if((c|0)==1){break q}f=f|16}x[31609]=0;o=P(412,b|0,14179)|0;c=x[31609];x[31609]=0;if((c|0)==1){break d}if(o){x[31609]=0;c=R(151,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break d}x[31609]=0;e=a+901404|0;S(772,b|0,e|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break d}DD(e);f=f|16}x[31609]=0;c=P(412,b|0,13951)|0;e=x[31609];x[31609]=0;if((e|0)==1){break d}if(!c){break p}x[31609]=0;c=R(151,b|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){w[d+192>>1]=c>>>5;H=d,I=Yj(x[a+484344>>2],x[a+484348>>2]),w[H+72>>1]=I;c=z[Oc(d+192|0,d+72|0)>>1];e=0;while(1){if((c|0)==(e|0)){f=f|16;break p}x[31609]=0;j=d+192|0;O(580,b|0,j|0);i=x[31609];x[31609]=0;I:{if((i|0)==1){break I}i=x[a+484344>>2];x[31609]=0;O(581,Wb(i,e)|0,j|0);j=x[31609];x[31609]=0;if((j|0)==1){break I}e=e+1|0;continue}break}b=N()|0;break c}b=N()|0;break c}b=N()|0;break c}x[31609]=0;c=P(412,b|0,13956)|0;e=x[31609];x[31609]=0;if((e|0)==1){break d}J:{if(!c){break J}x[31609]=0;c=R(151,b|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){w[d+192>>1]=(c>>>0)/20;w[d+72>>1]=z[a+480188>>1];c=z[Oc(d+192|0,d+72|0)>>1];e=0;while(1){if((c|0)==(e|0)){f=f|16;break J}x[31609]=0;S(424,b|0,((e<<5)+a|0)+480289|0,20);j=x[31609];x[31609]=0;if((j|0)!=1){e=e+1|0;continue}break}b=N()|0;break c}b=N()|0;break c}c=x[b+8>>2];e=x[b>>2];x[31609]=0;c=U(150,e|0,c|0,8)|0;e=x[31609];x[31609]=0;if((e|0)==1){break d}if(c){c=x[b+8>>2];x[31609]=0;S(425,d+192|0,a|0,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break h}f=(c|0)==x[b+8>>2]?f:f|16}K:{if(!(f&16)){break K}if(f&4){x[a+1074308>>2]=17367040;x[31609]=0;c=P(1,d+192|0,14729)|0;e=x[31609];x[31609]=0;if((e|0)!=1){zb(l,c);tb(c);break K}b=N()|0;break c}if(!(f&2)){break K}x[a+1074308>>2]=18219008;x[31609]=0;c=P(1,d+192|0,14944)|0;e=x[31609];x[31609]=0;if((e|0)==1){break g}zb(l,c);tb(c)}L:{M:{N:{O:{P:{Q:{R:{if((y[k|0]|y[k+1|0]<<8|(y[k+2|0]<<16|y[k+3|0]<<24))==1852141647&(y[k+4|0]|y[k+5|0]<<8|(y[k+6|0]<<16|y[k+7|0]<<24))==542396493){x[31609]=0;c=U(392,d+72|0,d+542|0,12)|0;e=x[31609];x[31609]=0;if((e|0)==1){break R}x[31609]=0;e=d+156|0;S(258,e|0,1,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break Q}x[31609]=0;f=R(773,e|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break P}x[a+1074308>>2]=f;tb(e);v[a+1074368|0]=A[a+1074308>>2]<19007257?4:5;tb(c);f=24}if(!(!x[a+1074308>>2]|f&8)){v[a+1074368|0]=0;Vv(a+1074312|0)}c=f&32;S:{if(!c){break S}v[a+1074368|0]=5;if(!o){kr(a+901404|0)}if((y[d+554|0]|y[d+555|0]<<8)>>>0<260){break S}x[31609]=0;U(266,a+1074312|0,4,1)|0;e=x[31609];x[31609]=0;if((e|0)==1){break d}}if(!Ad(x[l+4>>2],y[l+11|0])){break L}if(!(f&256)|t&255|g+1>>>0>1){break M}x[31609]=0;c=P(1,d+156|0,8292)|0;g=x[31609];x[31609]=0;if((g|0)==1){break N}zb(l,c);tb(c);break L}b=N()|0;break c}b=N()|0;break O}b=N()|0;tb(d+156|0)}tb(c);break c}b=N()|0;break c}if(c){x[31609]=0;c=P(1,d+156|0,12085)|0;g=x[31609];x[31609]=0;if((g|0)!=1){zb(l,c);tb(c);break L}b=N()|0;break c}x[31609]=0;c=P(1,d+156|0,9766)|0;g=x[31609];x[31609]=0;if((g|0)==1){break f}zb(l,c);tb(c)}v[d+67|0]=0;if(z[a+480192>>1]){x[31609]=0;c=P(435,a|0,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break i}v[d+67|0]=c}x[31609]=0;ba(436,a|0,b|0,1,d+67|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break i}e=x[a+1074308>>2];T:{U:{V:{W:{X:{Y:{Z:{_:{$:{aa:{ba:{ca:{da:{ea:{fa:{if(y[d+67|0]){if(e>>>0>18284543){break fa}x[a+1074308>>2]=18284544;break fa}if(e>>>0<18284544){break ea}}x[31609]=0;c=P(1,d+52|0,18262)|0;b=x[31609];x[31609]=0;if((b|0)==1){break da}g=x[a+1074308>>2];x[31609]=0;b=d+40|0;O(774,b|0,g|0);g=x[31609];x[31609]=0;if((g|0)==1){break ca}x[31609]=0;g=d+92|0;S(2,g|0,c|0,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break ba}zb(l,g);tb(g);tb(b);tb(c);e=x[a+1074308>>2]}ga:{if(e-1>>>0>19005952){break ga}b=x[a+484344>>2];f=x[a+484348>>2];if(!Je(b,f,254)){b=y[a+484376|0];c=x[a+484360>>2];x[31609]=0;W(775,Xb(c,b)|0);b=x[31609];x[31609]=0;if((b|0)==1){break i}f=x[a+484348>>2];b=x[a+484344>>2]}if(Je(b,f,255)){break ga}UC(Xb(x[a+484360>>2],y[a+484376|0]),255,65535)}x[31609]=0;c=d+40|0;O(776,c|0,4102);b=x[31609];x[31609]=0;if((b|0)==1){break $}b=y[d+554|0]|y[d+555|0]<<8;x[d+12>>2]=b>>>8;x[31609]=0;x[d+24>>2]=b&255;g=d+28|0;O(444,g|0,d+24|0);b=x[31609];x[31609]=0;if((b|0)==1){break _}x[31609]=0;b=d+92|0;V(430,b|0,c|0,d+12|0,g|0);e=x[31609];x[31609]=0;if((e|0)==1){break Z}e=zb(a+1298344|0,b);tb(b);tb(g);Eb(c);f=zb(a+1298368|0,l);H=a+1298404|0,I=x[Fc(b,x[(x[a+1074308>>2]?41072:r)>>2])>>2],x[H>>2]=I;if(!y[d+483|0]){break U}zb(a+1298380|0,e);x[31609]=0;b=P(1,b|0,15377)|0;k=x[31609];x[31609]=0;if((k|0)==1){break X}zb(e,b);tb(b);x[31609]=0;b=P(1,c|0,10117)|0;c=x[31609];x[31609]=0;if((c|0)==1){break W}zb(a+1298356|0,b);tb(b);x[31609]=0;b=P(1,g|0,10118)|0;c=x[31609];x[31609]=0;if((c|0)==1){break V}zb(a+1298392|0,b);break T}b=N()|0;break c}b=N()|0;break aa}b=N()|0;tb(d+40|0)}tb(c);break c}b=N()|0;break c}b=N()|0;break Y}b=N()|0;tb(d+28|0)}Eb(d+40|0);break c}b=N()|0;break c}b=N()|0;break c}b=N()|0;break c}x[31609]=0;b=P(1,d+92|0,10118)|0;c=x[31609];x[31609]=0;if((c|0)==1){break e}zb(a+1298356|0,b)}tb(b);e=1;if(E&1){x[31609]=0;a=P(1,d+12|0,17166)|0;b=x[31609];x[31609]=0;if((b|0)==1){break k}x[31609]=0;P(74,f|0,a|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break j}tb(a)}wc(n);tb(l)}fb=d+576|0;return e|0}b=N()|0;break c}b=N()|0;tb(a);break c}b=N()|0;break c}b=N()|0;break c}b=N()|0;break c}b=N()|0;break c}b=N()|0;break c}b=N()|0}wc(n);break a}b=N()|0}tb(l);Q(b|0);p()}function nR(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;l=fb-16|0;fb=l;a:{if(z[x[x[a+48>>2]+12>>2]+480188>>1]!=z[x[x[b+48>>2]+12>>2]+480188>>1]){break a}if((a|0)!=(b|0)){c=x[b>>2];g=x[b+4>>2];d=Ik(c,g);f=fb-16|0;fb=f;b:{if(hw(a)>>>0>=d>>>0){h=x[a>>2];i=Ik(h,x[a+4>>2]);if(i>>>0<d>>>0){e=fb-16|0;fb=e;x[e+12>>2]=c;x[e+12>>2]=x[e+12>>2]+D(i,6);fb=e+16|0;e=x[e+12>>2];uA(c,e,h);sA(a,e,g,d-Ik(x[a>>2],x[a+4>>2])|0);break b}sR(f+8|0,c,g,h);Jd(a,x[f+12>>2]);break b}oR(a);FZ(a,tD(a,d));sA(a,c,g,d)}fb=f+16|0}x[a+12>>2]=x[b+12>>2];x[a+16>>2]=x[b+16>>2];x[a+20>>2]=x[b+20>>2];mR(a+24|0,b+24|0);FE(a+36|0,b+36|0);if(x[x[x[a+48>>2]+12>>2]+480180>>2]==x[x[x[b+48>>2]+12>>2]+480180>>2]){break a}c=wb(x[a>>2]);x[l+12>>2]=c;m=wb(x[a+4>>2]);while(1){if(!Ib(c,m)){break a}d=0;g=fb-112|0;fb=g;k=x[x[a+48>>2]+12>>2];f=x[k+480180>>2];h=x[x[x[b+48>>2]+12>>2]+480180>>2];c:{if((f|0)==(h|0)){break c}e=y[c+3|0];d:{e:{if((f|0)!=16){break e}i=y[c+5|0];if(!((e|0)!=19|(i|0)!=144)){v[c+3|0]=0;f=1;break d}d=5;f=1;if((e|0)!=5){break e}v[c+5|0]=i>>>1&7|i&240;break d}if(!((h|0)==67108864|(e|0)!=45)){v[c+5|0]=159;d=20;v[c+3|0]=20;break d}if((e|0)!=46){d=e;break d}d=13;v[c+3|0]=13;v[c+5|0]=y[c+5|0]+3>>>2}n=(f|0)==32|(f|0)==16777216|(f|0)==2;f:{g:{h:{i:{j:{k:{if((h|0)==2){e=9;j=1;i=PD(2);if((d&255)!=9){break k}v[c+5|0]=y[c+5|0]+1>>>1;break h}j=(h|0)==32|(h|0)==16777216;e=9;i=PD(h);if((d&255)!=9){break k}if((f|0)!=2){break h}e=y[c+5|0];if((e|0)!=164){break j}v[c+5|0]=145;d=h&16777248?20:28;v[c+3|0]=d;break g}if((d&255)!=32){e=d;break h}d=x[i+84>>2];if(Wi(d,32)){break i}e=31;if(!Wi(d,31)){break i}v[c+3|0]=31;break h}o=c,p=ti(e<<1),v[o+5|0]=p;break g}e=32}l:{if((f|0)==16777216){d=y[c|0];m:{if(!Wg(d)){d=e;break m}j=x[i+84>>2];d=(d|0)==252?31:32;if(!Wi(j,d)){d=Wi(j,31)?31:0}w[g+4>>1]=999;o=g,p=Dj(e,y[c+5|0]),w[o+110>>1]=p;o=c,p=(D(z[Oc(g+4|0,g+110|0)>>1],127)>>>0)/999|0,v[o+5|0]=p;v[c+2|0]=0;v[c+3|0]=d;v[c|0]=0;v[c+1|0]=0}n:{o:{p:{e=d&255;switch(e-33|0){case 1:break g;case 2:case 3:break n;case 0:break o;default:break p}}if((e|0)!=20){break g}d=y[c+5|0];if((d&240)!=112|(d&15)>>>0<13){break l}v[c+5|0]=124;break l}d=20;v[c+3|0]=20;v[c+5|0]=y[c+5|0]>>>4|208;break g}q:{j=v[c+5|0];r:{if((j|0)>=0){v[c+3|0]=3;e=-128-j|0;d=3;break r}e=128;if((j|0)==-128){break q}v[c+3|0]=2;e=j&127;d=2}v[c+5|0]=e;if((e&255)>>>0>30){break q}v[c+5|0]=e+1>>>1|224;break g}v[g+4|0]=(e&255)+7>>>3;v[g+110|0]=15;o=c,p=y[Qb(g+4|0,g+110|0)|0]|240,v[o+5|0]=p;break g}d=e;s:{switch(f-1|0){case 0:case 3:break s;default:break g}}if(!j){break g}t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{d=d&255;switch(d-1|0){case 2:break x;case 1:break y;case 0:break B;default:break C}}D:{switch(d-25|0){case 1:case 2:break f;case 4:break u;case 0:break v;case 3:break w;default:break D}}if((d|0)==13){break z}if((d|0)==19){break A}if((d|0)!=37){break f}v[c+3|0]=0;break f}if(y[c+5|0]){break f}v[c+3|0]=0;break f}Kr(c);break f}E:{switch(y[c+2|0]){case 0:case 1:v[c+2|0]=1;v[c+3|0]=0;d=y[c+5|0];v[c+5|0]=0;v[c+4|0]=d>>>0>=64?64:d;break f;case 2:break E;default:break f}}rg(c+4|0,c+5|0);v[c+2|0]=1;if(y[c+4|0]>=65){v[c+4|0]=64}v[c+3|0]=20;v[c+5|0]=y[c+5|0]>>>2|128;break f}if(y[c+5|0]<224){break f}v[c+5|0]=223;break f}if(y[c+5|0]<224){break f}v[c+5|0]=223;break f}d=y[c+5|0];e=d-16>>>4|0;if(e>>>0>9){break f}if(!(1<<e&880)){if(!e){break t}if((e|0)!=1){break f}v[c+3|0]=3;v[c+5|0]=d&15|224;break f}v[c+3|0]=20;if(!(h&2)|(d|0)!=145){break f}v[c+5|0]=164;v[c+3|0]=9;break f}if(y[c|0]){break f}v[c+3|0]=20;v[c|0]=(h|0)==2?-2:-1;d=y[c+5|0];if(!d){v[c+1|0]=0}v[c+5|0]=d&15|208;break f}d=y[c+5|0];if(d>>>0>=16){v[g+4|0]=14;v[g+110|0]=d>>>4;o=c,p=y[Qb(g+4|0,g+110|0)|0]|240,v[o+5|0]=p;break f}v[g+4|0]=14;v[g+110|0]=d;o=c,p=y[Qb(g+4|0,g+110|0)|0]<<4|15,v[o+5|0]=p;break f}v[c+3|0]=2;v[c+5|0]=d&15|224;break f}d=20}F:{if(!n){break F}G:{switch(h-1|0){case 0:case 3:break G;default:break F}}H:{I:{switch(y[c|0]-253|0){case 1:v[c|0]=0;if(!(d&255?(h|0)==4:0)){v[c+5|0]=0;v[c+3|0]=13;break f}v[c+4|0]=0;v[c+2|0]=1;break H;case 0:break I;default:break H}}v[c|0]=255}J:{K:{L:{M:{N:{O:{P:{Q:{R:{e=d&255;switch(e-2|0){case 2:case 3:case 6:case 7:case 8:case 10:case 11:case 12:case 14:case 16:case 17:break f;case 13:break J;case 15:break L;case 1:break M;case 0:break N;case 9:break O;case 4:case 5:break P;case 18:break Q;default:break R}}if((e|0)!=29){break f}d=y[c+5|0];e=d&15;if((e|0)!=15|d>>>0<16){break K}v[c+5|0]=d>>>4;break f}S:{if(y[c+3|0]!=20){break S}v[c+3|0]=19;T:{U:{V:{W:{X:{Y:{Z:{_:{d=y[c+5|0];switch(d-16>>>4|0){case 4:case 5:case 8:case 9:break T;case 6:break U;case 10:break V;case 7:break W;case 3:break X;case 2:break Y;case 1:break Z;case 0:break _;default:break S}}v[c+5|0]=d&15|48;break S}v[c+5|0]=d&175^120;break S}v[c+5|0]=d&15|64;break S}v[c+5|0]=d&15|112;break S}v[c+3|0]=9;v[c+5|0]=D(d&15,17);break S}v[c+5|0]=d&15|96;break S}v[c+3|0]=0;break S}v[c+3|0]=28}break f}if(y[c+2|0]){break O}e=y[c+5|0];j=e&15;if(!((j|0)==15&e>>>0>=16)&(!j|(e&240)!=240)){break O}e=11;$:{switch((d&255)-6|0){case 1:e=8;case 0:v[c+2|0]=e;break;default:break $}}v[c+4|0]=0}d=y[c+5|0];e=d&15;if(!((e|0)!=15|d>>>0<16)){v[c+3|0]=19;v[c+5|0]=d>>>4|160;break f}if(!e|(d&240)!=240){break f}v[c+3|0]=19;v[c+5|0]=e|176;break f}d=y[c+5|0];if(d>>>0>=240){v[c+3|0]=19;v[c+5|0]=d&15|16;break f}if(d>>>0>=224){d=d&15;if((h|0)==4){v[c+3|0]=28;v[c+5|0]=d|16;break f}v[c+3|0]=19;v[c+5|0]=d+3>>>2|16;break f}v[c+3|0]=2;break f}d=y[c+5|0];if(d>>>0>=240){v[c+3|0]=19;v[c+5|0]=d&15|32;break f}if(d>>>0>=224){d=d&15;if((h|0)==4){v[c+3|0]=28;v[c+5|0]=d|32;break f}v[c+3|0]=19;v[c+5|0]=d+3>>>2|32;break f}v[c+3|0]=3;break f}if(y[c+5|0]>31){break f}v[c+3|0]=0;break f}if(!(!e|(d&240)!=240)){v[c+5|0]=d<<4;break f}if(e){v[c+5|0]=240;break f}if(d){v[c+5|0]=15;break f}v[c+5|0]=0;break f}d=y[c+5|0];if((d-1&255)>>>0>14){break f}v[c+5|0]=d|128;break f}if((f|0)!=16777216&(f|0)!=32|(h|0)!=2){break f}aa:{switch(y[c|0]-253|0){case 0:case 2:v[c|0]=254;break;default:break aa}}ba:{switch((d&255)-20|0){case 0:d=y[c+5|0];e=d&240;if((e|0)!=144){if((e|0)!=112){break f}v[c+3|0]=0;break f}ca:{switch(d-144|0){case 1:v[c+5|0]=164;v[c+3|0]=9;break f;case 0:break ca;default:break f}}v[c+5|0]=64;v[c+3|0]=9;break f;case 3:break ba;default:break f}}v[g+4|0]=128;o=c,p=y[Qb(g+4|0,c+5|0)|0]+1>>>1|0,v[o+5|0]=p}da:{ea:{fa:{ga:{ha:{ia:{ja:{if(!((f|0)!=16777216&(f|0)!=32)){if((h|0)!=4){break ja}d=y[c+3|0];if((d|0)==23){break ia}if((d|0)!=5){break ga}d=y[c+5|0];v[c+5|0]=(d&15)+1>>>1|d&240;break ha}if((f|0)!=4){break ja}ka:{la:{switch(h-1|0){default:if((h|0)==32|(h|0)==16777216){break ka}break;case 1:case 2:break la;case 0:case 3:break ha}}d=y[c+3|0];break ea}d=y[c+3|0];if((d|0)!=23){if((d|0)!=5){break ja}d=y[c+5|0];v[g+4|0]=d<<1&30;v[g+110|0]=15;o=c,p=y[Qb(g+4|0,g+110|0)|0]|d&240,v[o+5|0]=p;break ja}v[g+4|0]=64;o=c,p=y[Qb(g+4|0,c+5|0)|0]<<1,v[o+5|0]=p}ma:{switch(h-1|0){case 0:case 3:break ha;default:break ma}}d=y[c+3|0];break fa}v[g+4|0]=128;o=c,p=y[Qb(g+4|0,c+5|0)|0]+1>>>1|0,v[o+5|0]=p}d=y[c+3|0]}na:{switch((d&255)-16|0){case 0:v[g+4|0]=31;o=c,p=y[Qb(c+5|0,g+4|0)|0],v[o+5|0]=p;d=16;break fa;case 1:break na;default:break fa}}v[g+4|0]=32;o=c,p=y[cf(c+5|0,g+4|0)|0],v[o+5|0]=p;d=17}oa:{if((f|0)!=1){break oa}pa:{qa:{ra:{sa:{ta:{ua:{va:{e=d&255;switch(e-2|0){case 2:case 3:case 6:case 7:case 8:break oa;case 0:case 1:case 9:break sa;case 5:break ta;case 4:break ua;default:break va}}switch(e-19|0){case 1:break qa;case 0:break ra;default:break oa}}d=6;if(y[c+5|0]){break oa}e=4;break pa}d=7;if(y[c+5|0]){break oa}e=5;break pa}if(y[c+5|0]){break oa}e=0;break pa}d=19;j=y[c+5|0];e=(j<<4|(j<<24)+1610612736>>>28)&255;if(!(e>>>0>8|!(1<<e&387))){v[c+3|0]=0;d=0}e=0;if(j>>>0>239){break pa}break oa}d=20;e=0;if(y[c+5|0]<240){break oa}}v[c+3|0]=e;d=e}if((h|0)!=1){break ea}wa:{xa:{ya:{za:{Aa:{if(Gl(y[c|0])){v[c|0]=0;Ba:{Ca:{e=d&255;switch(e-15|0){case 1:case 2:case 3:break wa;case 0:break Aa;case 4:break Ba;default:break Ca}}if(e){break wa}v[c+5|0]=0;d=13;v[c+3|0]=13;break wa}f=y[c+5|0];if((f&240)!=208){break ya}v[c+5|0]=f&15|192;break wa}Da:{e=d&255;switch(e-15|0){case 1:case 2:case 3:break wa;case 4:break za;case 0:break Aa;default:break Da}}if(!e){break xa}break wa}d=19;v[c+3|0]=19;v[c+5|0]=y[c+5|0]&15|144;break wa}f=y[c+5|0]}if((f&255)>>>0<240){break wa}v[c+3|0]=0}d=0;Ea:{switch(y[c+2|0]-1|0){case 0:d=13;v[c+3|0]=13;v[c+5|0]=y[c+4|0];break wa;case 1:d=9;v[c+3|0]=9;e=y[c+4|0];v[c+5|0]=e>>>0>=64?-1:e<<2;break wa;case 3:d=11;v[c+3|0]=11;v[c+5|0]=y[c+4|0];break wa;case 2:d=11;v[c+3|0]=11;v[c+5|0]=y[c+4|0]<<4;break wa;case 5:d=19;v[c+3|0]=19;v[c+5|0]=y[c+4|0]|176;break wa;case 4:d=19;v[c+3|0]=19;v[c+5|0]=y[c+4|0]|160;break wa;case 12:d=3;v[c+3|0]=3;v[c+5|0]=y[c+4|0]<<2;break wa;case 11:d=2;v[c+3|0]=2;v[c+5|0]=y[c+4|0]<<2;break wa;case 10:d=4;v[c+3|0]=4;v[c+5|0]=y[c+4|0]<<2;break wa;case 7:d=5;v[c+3|0]=5;v[c+5|0]=y[c+4|0];break wa;case 6:break Ea;default:break wa}}d=5;v[c+3|0]=5;v[c+5|0]=y[c+4|0]<<4}v[c+2|0]=0;break da}if(!(d&255|(h|0)!=2)){d=0;Fa:{switch(y[c+2|0]-3|0){case 1:v[c+2|0]=0;v[c+3|0]=11;v[c+5|0]=y[c+4|0];d=11;break da;case 0:v[c+2|0]=0;v[c+3|0]=11;v[c+5|0]=y[c+4|0]<<4;d=11;break da;case 3:v[c+2|0]=0;v[c+3|0]=11;v[c+5|0]=y[c+4|0]|240;d=11;break da;case 2:v[c+2|0]=0;v[c+3|0]=11;v[c+5|0]=y[c+4|0]<<4|15;d=11;break da;case 10:v[c+2|0]=0;v[c+3|0]=3;v[c+5|0]=y[c+4|0]<<2;d=3;break da;case 9:v[c+2|0]=0;v[c+3|0]=2;d=2;v[c+5|0]=y[c+4|0]<<2;break da;case 8:v[c+2|0]=0;v[c+3|0]=4;v[c+5|0]=y[c+4|0]<<2;d=4;break da;case 5:v[c+2|0]=0;v[c+3|0]=5;v[c+5|0]=y[c+4|0];d=5;break da;case 4:v[c+2|0]=0;v[c+3|0]=5;v[c+5|0]=y[c+4|0]<<4;d=5;break da;case 6:v[c+2|0]=0;v[c+3|0]=29;v[c+5|0]=y[c+4|0]<<4;d=29;break da;case 7:break Fa;default:break da}}v[c+2|0]=0;v[c+3|0]=29;v[c+5|0]=y[c+4|0];d=29;break da}if((h|0)==4){f=y[c|0];if(!(f|(y[c+5|0]&240)!=208|(d&255)!=19)){f=0;v[c+5|0]=0;v[c+3|0]=0;d=0}Ga:{if(Gl(f)){v[c+1|0]=0;e=d&255;if(!e){break Ga}if((e|0)!=19){break da}d=19;e=y[c+5|0];if((e&240)!=208){break da}d=25;v[c+3|0]=25;v[c|0]=0;v[c+5|0]=e&15;break da}if(d&255){break da}}Ha:{switch(y[c+2|0]-11|0){case 2:v[c+2|0]=0;v[c+3|0]=3;v[c+5|0]=y[c+4|0]<<2;d=3;break da;case 1:v[c+2|0]=0;v[c+3|0]=2;d=2;v[c+5|0]=y[c+4|0]<<2;break da;case 0:break Ha;default:break da}}v[c+2|0]=0;v[c+3|0]=4;v[c+5|0]=y[(y[c+4|0]&15)+42144|0];d=4;break da}if((h|0)!=16777216&(h|0)!=32){break da}Ia:{if(d&255|((f|0)==32|(f|0)==16777216)){break Ia}d=0;Ja:{Ka:{switch(y[c+2|0]-7|0){case 2:v[c+3|0]=29;e=y[c+4|0]<<4;d=29;break Ja;case 3:v[c+3|0]=29;e=y[c+4|0];d=29;break Ja;case 0:v[c+3|0]=5;e=y[c+4|0]<<4;d=5;break Ja;case 4:break Ka;default:break Ia}}v[c+3|0]=4;e=y[c+4|0]<<4;d=4}v[c+2|0]=0;v[c+5|0]=e}e=y[c+2|0];if(e>>>0>15|!(1<<e&47480)){break da}v[g+4|0]=9;o=c,p=y[Qb(c+4|0,g+4|0)|0],v[o+4|0]=p}La:{if(y[c+2|0]!=15){break La}if($v(x[i+88>>2],15)){break La}e=d&255;if(!(!e|(e|0)==10)){if(Wi(x[i+84>>2],e)){break La}}v[c+2|0]=0;v[c+3|0]=10;Ma:{Na:{f=y[c+1|0];if(!f){break Na}d=y[c+5|0];if(z[k+480192>>1]>=f>>>0){h=y[c|0];Oa:{if(!Tc(h)){break Oa}j=x[((f<<2)+k|0)+900380>>2];if(!j){break Oa}f=z[bc(j+236|0,h-1|0)>>1]}if(!(f&65535)){break Na}}f=f&65535;if(f>>>0>z[k+480190>>1]){break Na}h=y[c+4|0];_v(g+4|0);if(h>>>0>9){break Na}d=(e|0)==10?d:0;e=oi(k,f);f=y[c+4|0];if(!f){e=Iua(x[e>>2],0,d&255,0);d=hb;e=e+32768|0;d=e>>>0<32768?d+1|0:d;d=ti(Bc((d&65535)<<16|e>>>16,d>>>16|0));break Ma}d=ti((x[yb(e+68|0,f-1|0)>>2]+((d&255)<<8)|0)+128>>>8|0);break Ma}d=y[c+4|0]<<3}v[c+5|0]=d;d=y[c+3|0]}Pa:{Qa:{e=d&255;switch(e-42|0){case 0:case 2:break Qa;default:break Pa}}if(Wi(x[i+84>>2],e)){break Pa}d=10;v[c+3|0]=10}f=y[c|0];Ra:{if(f>>>0>=y[i+8|0]){e=1;if(f>>>0<=y[i+9|0]){break Ra}}if(Gl(f)){Sa:{switch(f-253|0){case 1:e=y[i+70|0]!=0;break Ra;case 2:e=y[i+71|0]!=0;break Ra;case 0:e=y[i+72|0]!=0;break Ra;default:break Sa}}e=x[i>>2]==16777216;break Ra}e=!f}if(!e){v[c|0]=0}if(!Wi(x[i+84>>2],d&255)){v[c+3|0]=0}if($v(x[i+88>>2],y[c+2|0])){break c}v[c+2|0]=0}fb=g+112|0;c=x[tg(l+12|0)>>2];continue}}fb=l+16|0;return a}function ika(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,m=0,n=0,o=0,s=0,t=0,u=0,B=0,C=0,F=0,G=0,H=E(0),I=E(0),J=0,K=0;h=fb-32|0;fb=h;c=x[a+1074308>>2];if(!(c>>>0>18285125|(c|0)==18284544)){bg(a+1074312|0,0)}c=h+12|0;i=a+1074312|0;Jb(c,i,0);b=Gb(x[x[h+12>>2]>>2],x[h+16>>2]);d=x[a+480180>>2];Jb(c,i,0);n=(d&16777248)!=0&b;B=Gb(x[x[h+12>>2]>>2],x[h+16>>2]);C=x[a+480180>>2];a:{c=x[a+1074308>>2];if(c>>>0>18874367){break a}c=1;while(1){b:{b=c&65535;if(b>>>0<=z[a+480192>>1]){b=x[((b<<2)+a|0)+900380>>2];if(!b){break b}x[h+12>>2]=D(y[b+20|0],100)>>>6;x[h+24>>2]=100;J=b,K=x[Hb(h+12|0,h+24|0)>>2],v[J+20|0]=K;if(A[a+1074308>>2]>18350079&n){break b}d=v[b+26|0];v[b+26|0]=((d>>31|1)+d|0)/2;if(A[a+1074308>>2]>18285313&n){break b}ED(Yh(b,2),x[a+480180>>2]);d=x[a+1074308>>2];c:{if(d>>>0<18284544){break c}if(d>>>0>18285135){break b}if(!y[b+34|0]){break c}if(!Kj(y[b+31|0])){break c}Lb(i,2,1);if(A[a+1074308>>2]>18285135){break b}}if(!(y[b+24|0]|(y[b+23|0]|(y[b+19|0]|y[b+20|0])))){break b}Lb(i,1,1)}d:{if(!(x[a+480180>>2]&16777248)|A[a+1074308>>2]>18285313&n){break d}c=z[a+480190>>1]+1&65535;d=c>>>0<=1?1:c;b=1;while(1){if((b|0)==(d|0)){break d}c=D(b,104)+a|0;e=c+484419|0;if(!(y[e|0]|!(y[c+484421|0]|y[c+484420|0]))){v[e|0]=255}b=b+1|0;continue}}c=a+901404|0;d=c+288|0;b=vV(d);while(1){if((b|0)==(d|0)){e:{d=c+800|0;c=wC(d);while(1){if((d|0)==(c|0)){break e}uV(d);d=d+32|0;continue}}}else{uV(d);d=d+32|0;continue}break}c=x[a+1074308>>2];break a}c=c+1|0;continue}}f:{if(!(x[a+480180>>2]&16777252)|((c|0)==18874368|c>>>0>18874895)){break f}b=z[a+480192>>1]+1&65535;g=b>>>0<=1?1:b;d=0;b=1;while(1){if((b|0)==(g|0)){if(!d){break f}Lb(i,3,1);c=x[a+1074308>>2]}else{e=x[((b<<2)+a|0)+900380>>2];if(!(!e|!y[e+31|0])){v[e+33|0]=13;d=1}b=b+1|0;continue}break}}g:{if(!(x[a+480180>>2]&16777248)|((c|0)==19005440|c>>>0>19006225)){break g}Jb(h+12|0,i,0);if(!Gb(x[x[h+12>>2]>>2],x[h+16>>2])){Jb(h+24|0,i,1);if(!Gb(x[x[h+24>>2]>>2],x[h+28>>2])){break g}}c=z[a+480192>>1]+1&65535;d=c>>>0<=1?1:c;b=1;while(1){if((b|0)==(d|0)){break g}c=x[((b<<2)+a|0)+900380>>2];if(!(!c|!y[c+19|0]|!(v[c+80|0]&1))){v[c+19|0]=0}b=b+1|0;continue}}f=x[a+480180>>2];h:{i:{if(!(f&16777252)){break i}c=a+906300|0;e=vk(c);b=c;while(1){if((b|0)==(e|0)){break i}d=b;b=b+160|0;if(!Oi(y[d+16|0]|y[d+17|0]<<8|(y[d+18|0]<<16|y[d+19|0]<<24),y[d+20|0]|y[d+21|0]<<8|(y[d+22|0]<<16|y[d+23|0]<<24))){continue}break}s=1;d=x[a+1074308>>2];if(d>>>0>19007232){break h}while(1){if((c|0)!=(e|0)){d=h+12|0;b=fb-32|0;fb=b;g=b+8|0;k=c+80|0;cS(g,k);x[31609]=0;f=b+20|0;S(123,f|0,22,g|0);m=x[31609];x[31609]=0;j:{k:{l:{if((m|0)!=1){x[31609]=0;S(244,d|0,0,f|0);m=x[31609];x[31609]=0;if((m|0)==1){break l}Ub(f);tb(g);fb=b+32|0;break j}a=N()|0;break k}a=N()|0;Ub(b+20|0)}tb(b+8|0);Q(a|0);p()}rw(k,d);c=c+160|0;tb(d);continue}break}f=x[a+480180>>2]}d=x[a+1074308>>2]}m:{n:{o:{p:{q:{if((f|0)!=4){break q}if(d>>>0<19007257){break p}if(y[a+1074368|0]!=4|d>>>0>19071235){break q}SA(a,5);d=x[a+1074308>>2]}if(d>>>0>19202054){break o}c=19202048;if((d|0)==19202048){break n}}c=z[a+480192>>1]+1&65535;g=c>>>0<=1?1:c;c=1;while(1){if((c|0)==(g|0)){break o}e=x[((c<<2)+a|0)+900380>>2];r:{if(!e|!y[e+20|0]|!y[e+31|0]){break r}b=e+236|0;f=tr(b);while(1){if((b|0)!=(f|0)){k=z[b>>1];b=b+2|0;if(!k){continue}break r}break}v[e+20|0]=0}c=c+1|0;continue}}c=d;if(c>>>0>19267583){break m}}b=z[a+480192>>1]+1&65535;e=b>>>0<=1?1:b;b=1;while(1){if((b|0)==(e|0)){break m}d=x[((b<<2)+a|0)+900380>>2];s:{if(!d){break s}c=v[d+26|0];v[d+26|0]=((c>>31|1)+c|0)/2;c=x[a+1074308>>2];if(c>>>0>18350079&n){break s}v[d+19|0]=y[d+19|0]+3>>>2}b=b+1|0;continue}}t:{if(c>>>0>19398673){break t}d=z[a+480192>>1];b=1;while(1){e=b&65535;if(e>>>0>d>>>0){break t}e=x[((e<<2)+a|0)+900380>>2];if(!e|y[e+65|0]==255){b=b+1|0;continue}else{Lb(i,94,1);c=x[a+1074308>>2]}break}}u:{if(c>>>0>19399427){break u}d=z[a+480192>>1];b=1;while(1){e=b&65535;if(e>>>0>d>>>0){break u}e=x[((e<<2)+a|0)+900380>>2];if(!e|y[e+36|0]>1){b=b+1|0;continue}else{Lb(i,101,1);c=x[a+1074308>>2]}break}}v:{if(c>>>0>19923027){break v}d=z[a+480190>>1];b=1;while(1){c=b&65535;if(c>>>0>d>>>0){break v}c=D(c,104)+a|0;if(!le(x[c+484380>>2],x[c+484400>>2])|!(y[c+484414|0]&20)){b=b+1|0;continue}else{Lb(i,116,1)}break}}c=fb-16|0;fb=c;w[h+4>>1]=0;x[h>>2]=a;Jb(c+8|0,a+1074312|0,0);J=h,K=Gb(x[x[c+8>>2]>>2],x[c+12>>2]),v[J+6|0]=K;fb=c+16|0;c=x[h>>2];u=x[h+4>>2];e=fb-32|0;fb=e;b=a+484344|0;f=wb(x[b>>2]);x[e+28>>2]=f;F=wb(x[b+4>>2]);while(1){if(Ib(f,F)){b=wb(x[f>>2]);G=wb(x[f+4>>2]);x[e+16>>2]=c;x[e+20>>2]=u;x[e>>2]=c;x[e+4>>2]=u;m=fb-16|0;fb=m;x[m+12>>2]=b;while(1){if(Ib(b,G)){t=z[e+4>>1];d=t+1|0;w[e+4>>1]=d;f=x[e>>2];w[e+4>>1]=z[f+480188>>1]>(d&65535)>>>0?d:0;w:{if(Wg(y[b|0])){break w}g=x[f+1074308>>2];x:{k=x[f+480180>>2];y:{z:{if((k|0)==2){if(g>>>0>18415615){break z}if(y[b+3|0]!=23){break y}Of(b+5|0,64);break y}A:{if(k&16777248){B:{C:{if(g>>>0>=18285314){if(y[e+6|0]){break C}d=0;f=0;if(g>>>0>18874367){break B}}D:{switch(y[b+3|0]-20|0){case 3:Of(b+5|0,128);break C;case 0:break D;default:break C}}d=y[b+5|0];if((d|0)!=208){if((d|0)!=192){break C}v[b|0]=254;v[b+3|0]=0;break C}v[b+3|0]=0}E:{F:{G:{if(g>>>0>=18350080){if(y[e+6|0]){break G}d=0;f=0;if(g>>>0>18874367){break B}}f=y[b+3|0];if(f>>>0>29){break F}d=1;if(!(1<<f&536873152)){break F}break E}d=0;f=0;if(g>>>0>18874367){break B}f=y[b+3|0]}d=0}f=(f|0)==24|(f|0)==22}H:{if(!(d|f)){break H}f=y[b+5|0];d=f&15;if(!d|(d|0)==15){break H}f=f&240;if(!f|(f|0)==240){break H}v[b+5|0]=y[b+3|0]==24?f:d}I:{if((g|0)==19005440|g>>>0>19005699){break I}d=z[x[e>>2]+480192>>1];if(y[e+6|0]|(!d|d>>>0>=y[b+1|0])){break I}v[b+4|0]=0;v[b+2|0]=1}if(y[b+3|0]!=18|y[b+5|0]!=17){break z}if(g>>>0>19468801){break x}if(!Ob(x[e>>2]+1074312|0,22)|y[x[e>>2]+480208|0]&4){break z}d=b+5|0;break A}if((k|0)!=4){break z}d=!y[e+6|0];J:{if((d|g>>>0<18285314)&g>>>0<=18874367){break J}if(g>>>0>19137025){break x}if(y[b+3|0]!=23|y[b+5|0]<65){break J}v[b+3|0]=0}K:{L:{M:{if(!(!(d&g>>>0<18874368)&g>>>0>=18415616)){d=y[b+3|0];f=y[b+2|0];if((d|0)!=10|(f|0)!=11){break M}d=0;v[b+3|0]=0;break K}if(g>>>0>18874639){break L}d=y[b+3|0];f=y[b+2|0]}if((f|0)!=11|(d|0)!=4){break K}f=y[b+4|0];if(!(f|y[e+6|0])){d=4;break K}d=4;o=y[b+5|0];if(!o){break K}v[b+2|0]=0;J=b,K=ew(o+(f<<4)|0),v[J+5|0]=K;break K}if(g>>>0>19007240){break x}d=y[b+3|0]}if(y[b+5|0]|(d|0)!=16){break z}d=b+3|0}v[d|0]=0}if(g>>>0>18874367){break x}}d=y[b+3|0];f=y[b+5|0]&240;N:{O:{if((d|0)!=28|(f|0)!=96){o=0}else{if(!y[e+6|0]|(k|0)!=4){break O}o=g>>>0<18350080}if(!(o|(d|0)==20&(f|0)==96)){break N}}d=D(t,-6)+b|0;while(1){if(b>>>0>d>>>0){if(!((y[d+3|0]|8)!=28|(y[d+5|0]&240)!=96)){v[d+3|0]=0}d=d+6|0;continue}break}d=y[b+3|0]}if((d|0)!=20|(f|0)!=224){break x}d=D(t,-6)+b|0;while(1){if(b>>>0<=d>>>0){break x}if(!(y[d+3|0]!=20|(y[d+5|0]&240)!=224)){v[d+3|0]=0}d=d+6|0;continue}}d=y[b+2|0];if(!((d|0)!=8|g>>>0>19333174|(g|0)==19333120)){g=y[b+4|0];d=y[b+3|0];if(!(!g|(d|0)!=7)){v[b+3|0]=11;break w}P:{Q:{switch(d-5|0){default:if((d|0)!=26){break w}break;case 1:break w;case 2:break P;case 0:break Q}}f=y[b+5|0];if(!(f&15)){v[b+2|0]=0;v[b+3|0]=5;v[b+5|0]=f|g&15;break w}R:{switch(d-5|0){case 1:break w;case 0:case 2:break P;default:break R}}if((d|0)!=26){break w}}v[b+2|0]=0;break w}S:{if(!((k|0)==16777216|(d|0)!=15)){d=y[b+3|0];if(d){break S}v[b+2|0]=0;v[b+3|0]=10;v[b+5|0]=y[b+4|0]<<3;break w}if((d|0)!=15){break w}d=y[b+3|0]}if((d&255)!=10|g>>>0>19922963){break w}if(y[b+4|0]?y[b+5|0]:1){v[b+2|0]=0;break w}v[b+3|0]=0}b=x[tg(m+12|0)>>2];continue}break}b=x[e+4>>2];x[e+8>>2]=x[e>>2];x[e+12>>2]=b;fb=m+16|0;f=x[Vl(e+28|0)>>2];continue}else{fb=e+32|0}break}T:{c=A[a+1074308>>2]<19267584;if(c&n){b=0;while(1){if((b|0)==344){break T}c=x[a+1074308>>2];d=x[b+40244>>2];Lb(i,x[b+40240>>2],c>>>0>=d>>>0|(c|0)==(d&-65536));b=b+8|0;continue}}if(!(c&((C|0)==4&B))){break T}b=0;while(1){if((b|0)==240){break T}Lb(i,x[b+40592>>2],A[a+1074308>>2]>=A[b+40596>>2]);b=b+8|0;continue}}U:{c=x[a+480180>>2];if(c&16777248){b=0;while(1){if((b|0)==72){break U}c=x[a+1074308>>2];d=x[b+40836>>2];e=d&-65536;if(!(c>>>0>=e>>>0&(d>>>0<=c>>>0|c>>>0<=e>>>0))){bg(i,x[b+40832>>2])}b=b+8|0;continue}}b=0;V:{switch(c-2|0){case 2:while(1){if((b|0)==64){break U}if(A[a+1074308>>2]<A[b+40916>>2]){bg(i,x[b+40912>>2])}b=b+8|0;continue};case 0:break V;default:break U}}while(1){if((b|0)==96){break U}if(A[a+1074308>>2]<A[b+40980>>2]){bg(i,x[b+40976>>2])}b=b+8|0;continue}}b=x[a+1074308>>2];if(!(x[a+480180>>2]!=4|b>>>0>18415615)){Lb(i,98,1);b=x[a+1074308>>2]}if(b-19333159>>>0<=33){b=0;while(1){if((b|0)!=5){c=b+77|0;Jb(h+12|0,i,c);bg(Lb(i,b+86|0,Gb(x[x[h+12>>2]>>2],x[h+16>>2])),c);b=b+1|0;continue}break}b=x[a+1074308>>2]}c=8;W:{if(b>>>0>=18284544){if(b>>>0>18874627){break W}c=6;if((b|0)==18874368){break W}}Lb(i,c,1)}c=x[a+1074308>>2];X:{if(y[a+480208|0]&16){if(c>>>0<=19136511){bg(i,7);break X}if(!(x[a+480180>>2]&16777248)|c>>>0>19267583){break X}Lb(i,7,1);break X}if((c|0)==19922944|c>>>0>19922997){break X}bg(i,7)}Jb(h+12|0,i,31);Y:{if(!Gb(x[x[h+12>>2]>>2],x[h+16>>2])){break Y}c=x[a+1074308>>2];if(c>>>0<19071234|c>>>0>19398722){break Y}d=z[a+480192>>1];b=1;while(1){c=b&65535;if(c>>>0>d>>>0){break Y}Z:{c=x[((c<<2)+a|0)+900380>>2];if(!c){break Z}e=y[c+65|0];if(!(y[c+60|0]&4)|(e|0)==255|e>>>0<=y[c- -64|0]){break Z}Lb(i,97,1);break Y}b=b+1|0;continue}}c=x[a+480180>>2];_:{if(!(c&16777218)){break _}d=z[a+480190>>1];b=1;while(1){e=b&65535;if(e>>>0>d>>>0){break _}b=b+1|0;if(!(y[(D(e,104)+a|0)+484415|0]&2)){continue}break}$:{aa:{ba:{if(!(!z[a+480192>>1]|(c|0)!=16777216)){b=x[a+1074308>>2];if(b>>>0<19398688){break aa}if(b>>>0>19464277){break ba}Lb(i,109,1)}b=x[a+1074308>>2]}if((b|0)==19922944|b>>>0>19922996){break $}}bg(i,111);b=x[a+1074308>>2]}c=x[a+480180>>2];if(!((c|0)!=2|b>>>0>19464191)){Lb(i,108,1);break _}if((c|0)==2){break _}bg(i,108)}ca:{c=x[a+1074308>>2];if(c-19333186>>>0<=589827){if(!s){break ca}b=a+906300|0;c=vk(b);while(1){if((b|0)!=(c|0)){da:{if((y[b+16|0]|y[b+17|0]<<8|(y[b+18|0]<<16|y[b+19|0]<<24))!=1146637647|(y[b+20|0]|y[b+21|0]<<8|(y[b+22|0]<<16|y[b+23|0]<<24))!=-271958638){break da}if((Xc(x[b+4>>2],x[b+8>>2])|0)!=32){break da}d=Dc(h+12|0,16887);rw(b+80|0,d);tb(d)}b=b+160|0;continue}break}c=x[a+1074308>>2]}e=!s;ea:{if(e|c>>>0>19923027){break ea}g=z[a+480192>>1];b=1;while(1){d=b&65535;if(d>>>0>g>>>0){break ea}d=x[((d<<2)+a|0)+900380>>2];if(!d|y[d+30|0]!=1&z[d+28>>1]!=1){b=b+1|0;continue}else{Lb(i,121,1);c=x[a+1074308>>2]}break}}b=!s;if(!(e|c>>>0>19988488)){Lb(i,117,1);c=x[a+1074308>>2]}if(c-19333120>>>0>591359|b){break ca}a=a+906300|0;d=vk(a);while(1){if((a|0)==(d|0)){break ca}fa:{if((y[a+16|0]|y[a+17|0]<<8|(y[a+18|0]<<16|y[a+19|0]<<24))!=1146637647|(y[a+20|0]|y[a+21|0]<<8|(y[a+22|0]<<16|y[a+23|0]<<24))!=-281111764){break fa}c=x[a+4>>2];if((Xc(c,x[a+8>>2])|0)!=24){break fa}H=Pd(E(E(E((l(2,y[c+12|0]|y[c+13|0]<<8|(y[c+14|0]<<16|y[c+15|0]<<24)),r())*E(2e3))+E(-1))/E(1999)),E(0));I=Pd(E(E(E((l(2,y[c+16|0]|y[c+17|0]<<8|(y[c+18|0]<<16|y[c+19|0]<<24)),r())*E(2e3))+E(-1))/E(1999)),E(0));b=(q(H),j(2));v[c+12|0]=b;v[c+13|0]=b>>>8;v[c+14|0]=b>>>16;v[c+15|0]=b>>>24;c=x[a+4>>2];b=(q(I),j(2));v[c+16|0]=b;v[c+17|0]=b>>>8;v[c+18|0]=b>>>16;v[c+19|0]=b>>>24}a=a+160|0;continue}}fb=h+32|0}function BP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=fb-32|0;fb=j;a:{b:{c:{d:{e:{f:{if(Nd(b,22292)){Fb(a);break f}if(Nd(b,9909)){b=fb-96|0;fb=b;g=Fb(a);x[31609]=0;W(128,b- -64|0);a=x[31609];x[31609]=0;g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{if((a|0)!=1){x[31609]=0;x[b+40>>2]=0;a=b+52|0;c=b+40|0;O(1117,a|0,c|0);d=x[31609];x[31609]=0;if((d|0)==1){break C}x[31609]=0;d=P(838,g|0,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break B}tb(a);x[31609]=0;d=P(985,d|0,16806)|0;f=x[31609];x[31609]=0;if((f|0)==1){break A}x[31609]=0;x[b+40>>2]=8;O(1117,a|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break z}x[31609]=0;d=P(838,d|0,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break y}tb(a);x[31609]=0;d=P(985,d|0,16806)|0;f=x[31609];x[31609]=0;if((f|0)==1){break A}x[31609]=0;x[b+40>>2]=0;O(1117,a|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break x}x[31609]=0;d=P(838,d|0,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break w}tb(a);x[31609]=0;f=P(985,d|0,15114)|0;d=x[31609];x[31609]=0;if((d|0)==1){break A}d=Nb(a);a=x[b+76>>2];if(a){x[31609]=0;x[b+16>>2]=a;a=b+28|0;O(1117,a|0,b+16|0);h=x[31609];x[31609]=0;if((h|0)==1){break v}x[31609]=0;S(1011,c|0,8980,a|0);h=x[31609];x[31609]=0;if((h|0)==1){break u}x[31609]=0;O(178,d|0,c|0);h=x[31609];x[31609]=0;if((h|0)==1){break t}tb(c);tb(a)}if(!Id(y[b+80|0])){break p}x[31609]=0;c=P(36,b+40|0,12854)|0;a=x[31609];x[31609]=0;if((a|0)==1){break r}x[31609]=0;O(178,d|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break q}tb(c);break o}a=N()|0;break h}a=N()|0;break i}a=N()|0;tb(b+52|0);break i}a=N()|0;break i}a=N()|0;break i}a=N()|0;tb(b+52|0);break i}a=N()|0;break i}a=N()|0;tb(b+52|0);break i}a=N()|0;break j}a=N()|0;break s}a=N()|0;tb(b+40|0)}tb(b+28|0);break j}a=N()|0;break j}a=N()|0;tb(c);break j}if(!Id(y[b+81|0])){break o}x[31609]=0;c=P(36,b+40|0,12625)|0;a=x[31609];x[31609]=0;if((a|0)==1){break n}x[31609]=0;O(178,d|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break m}tb(c)}if(Id(y[b+82|0])){break l}break k}a=N()|0;break j}a=N()|0;tb(c);break j}x[31609]=0;c=P(36,b+28|0,11144)|0;a=x[31609];x[31609]=0;D:{if((a|0)!=1){x[31609]=0;O(178,d|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break D}tb(c);break k}a=N()|0;break j}a=N()|0;tb(c);break j}if(mc(x[d>>2],x[d+4>>2])){break g}x[31609]=0;f=P(985,f|0,16836)|0;a=x[31609];x[31609]=0;if((a|0)!=1){x[31609]=0;c=P(36,b+4|0,16806)|0;a=x[31609];x[31609]=0;E:{F:{G:{if((a|0)!=1){x[31609]=0;a=b+16|0;S(1118,a|0,d|0,c|0);h=x[31609];x[31609]=0;if((h|0)==1){break G}x[31609]=0;P(838,f|0,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break F}tb(a);tb(c);break g}a=N()|0;break j}a=N()|0;break E}a=N()|0;tb(b+16|0)}tb(c);break j}a=N()|0}Td(d)}xg(b- -64|0)}tb(g);break a}Td(d);xg(b- -64|0);fb=b+96|0;break f}if(Nd(b,8132)){x[j>>2]=0;br(a,j);break f}if(Nd(b,8110)){x[j>>2]=8;br(a,j);break f}if(Nd(b,10869)){x[j>>2]=0;br(a,j);break f}if(Nd(b,10641)){Dc(a,15114);break f}if(Nd(b,11419)){Dc(a,15869);break f}if(Nd(b,7412)){b=fb-48|0;fb=b;d=b+24|0;OG(d);x[31609]=0;c=b+12|0;W(145,c|0);g=x[31609];x[31609]=0;H:{I:{J:{K:{if((g|0)!=1){x[31609]=0;g=b+36|0;S(146,g|0,d|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break K}x[31609]=0;O(1059,a|0,g|0);a=x[31609];x[31609]=0;if((a|0)==1){break J}tb(g);tb(c);tb(d);fb=b+48|0;break f}a=N()|0;break H}a=N()|0;break I}a=N()|0;tb(b+36|0)}tb(b+12|0)}tb(b+24|0);break a}if(Nd(b,9925)){b=fb-16|0;fb=b;f=fb-16|0;fb=f;x[f+12>>2]=101;h=b+4|0;d=fb-96|0;fb=d;g=Nb(d+84|0);L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{_:{c=x[f+12>>2];if(c&1){x[31609]=0;c=d+52|0;O(134,c|0,20054022);e=x[31609];x[31609]=0;if((e|0)==1){break _}x[31609]=0;O(101,g|0,c|0);e=x[31609];x[31609]=0;if((e|0)==1){break Z}tb(c);c=x[f+12>>2]}if(!(c&4)){break X}x[31609]=0;c=ca(135)|0;e=x[31609];x[31609]=0;if((e|0)==1){break W}if(!c){break Y}break X}c=N()|0;break M}c=N()|0;tb(d+52|0);break M}x[31609]=0;c=d+52|0;W(136,c|0);e=x[31609];x[31609]=0;$:{if((e|0)!=1){x[31609]=0;O(101,g|0,c|0);e=x[31609];x[31609]=0;if((e|0)==1){break $}tb(c);break X}c=N()|0;break M}c=N()|0;tb(d+52|0);break M}aa:{c=x[f+12>>2];if(!(c&32)){break aa}x[31609]=0;e=d+52|0;W(128,e|0);c=x[31609];x[31609]=0;ba:{ca:{da:{ea:{fa:{ga:{ha:{ia:{ja:{ka:{la:{ma:{na:{oa:{pa:{qa:{ra:{sa:{ta:{if((c|0)!=1){x[31609]=0;c=d+40|0;O(137,c|0,e|0);i=x[31609];x[31609]=0;if((i|0)==1){break ca}i=Ad(x[d+44>>2],y[d+51|0]);tb(c);if(!i){x[31609]=0;i=d+28|0;W(138,i|0);k=x[31609];x[31609]=0;if((k|0)==1){break ta}x[31609]=0;k=d+16|0;O(137,k|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break sa}x[31609]=0;S(139,c|0,i|0,k|0);e=x[31609];x[31609]=0;if((e|0)==1){break ra}x[31609]=0;O(101,g|0,c|0);e=x[31609];x[31609]=0;if((e|0)==1){break qa}tb(c);tb(k);Eb(i)}c=Mp(d+52|0);if(!Ad(x[c+4>>2],y[c+11|0])){x[31609]=0;e=d+28|0;W(140,e|0);i=x[31609];x[31609]=0;if((i|0)==1){break na}x[31609]=0;i=d+40|0;S(141,i|0,e|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break ma}x[31609]=0;O(101,g|0,i|0);c=x[31609];x[31609]=0;if((c|0)==1){break la}tb(i);Eb(e)}x[31609]=0;c=d+40|0;k=d+52|0;O(142,c|0,k|0);e=x[31609];x[31609]=0;if((e|0)==1){break ja}e=Ad(x[d+44>>2],y[d+51|0]);tb(c);if(!e){x[31609]=0;e=d+28|0;W(138,e|0);i=x[31609];x[31609]=0;if((i|0)==1){break ia}x[31609]=0;i=d+16|0;O(142,i|0,k|0);k=x[31609];x[31609]=0;if((k|0)==1){break ha}x[31609]=0;S(139,c|0,e|0,i|0);k=x[31609];x[31609]=0;if((k|0)==1){break ga}x[31609]=0;O(101,g|0,c|0);k=x[31609];x[31609]=0;if((k|0)==1){break fa}tb(c);tb(i);Eb(e)}xg(d+52|0);c=x[f+12>>2];break aa}c=N()|0;break M}c=N()|0;break ba}c=N()|0;break oa}c=N()|0;break pa}c=N()|0;tb(d+40|0)}tb(d+16|0)}Eb(d+28|0);break ba}c=N()|0;break ba}c=N()|0;break ka}c=N()|0;tb(d+40|0)}Eb(d+28|0);break ba}c=N()|0;break ba}c=N()|0;break ba}c=N()|0;break da}c=N()|0;break ea}c=N()|0;tb(d+40|0)}tb(d+16|0)}Eb(d+28|0);break ba}c=N()|0}xg(d+52|0);break M}ua:{if(!(c&64)){break ua}x[31609]=0;c=ca(135)|0;e=x[31609];x[31609]=0;if((e|0)==1){break W}if(c){break ua}c=d+52|0;Fb(c);x[31609]=0;O(101,g|0,c|0);e=x[31609];x[31609]=0;if((e|0)==1){break N}tb(c)}if(y[f+12|0]&128){x[31609]=0;c=d+52|0;W(143,c|0);e=x[31609];x[31609]=0;if((e|0)==1){break V}x[31609]=0;O(101,g|0,c|0);e=x[31609];x[31609]=0;if((e|0)==1){break U}tb(c)}x[31609]=0;e=P(1,d+52|0,22292)|0;c=x[31609];x[31609]=0;if((c|0)==1){break T}x[31609]=0;c=d+4|0;S(144,c|0,g|0,e|0);i=x[31609];x[31609]=0;if((i|0)==1){break S}x[31609]=0;i=d+40|0;W(145,i|0);k=x[31609];x[31609]=0;if((k|0)==1){break R}x[31609]=0;S(146,h|0,c|0,i|0);k=x[31609];x[31609]=0;if((k|0)==1){break Q}tb(i);tb(c);tb(e);Td(g);fb=d+96|0;break L}c=N()|0;break M}c=N()|0;break M}c=N()|0;tb(d+52|0);break M}c=N()|0;break M}c=N()|0;break O}c=N()|0;break P}c=N()|0;tb(d+40|0)}tb(d+4|0)}tb(e);break M}c=N()|0;tb(d+52|0)}Td(g);Q(c|0);p()}fb=f+16|0;x[31609]=0;O(1059,a|0,h|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(h);fb=b+16|0;break f}break c}if(Nd(b,10541)){b=fb-48|0;fb=b;d=b+4|0;ss(d);x[31609]=0;c=b+36|0;O(137,c|0,d|0);g=x[31609];x[31609]=0;va:{wa:{if((g|0)!=1){x[31609]=0;O(1059,a|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break wa}tb(c);xg(d);fb=b+48|0;break f}a=N()|0;break va}a=N()|0;tb(b+36|0)}xg(b+4|0);break a}if(Nd(b,11382)){b=fb-32|0;fb=b;ss(b);x[31609]=0;O(1119,a|0,Mp(b)|0);a=x[31609];x[31609]=0;if((a|0)!=1){xg(b);fb=b+32|0;break f}a=N()|0;xg(b);break a}if(Nd(b,9938)){b=fb-48|0;fb=b;d=b+16|0;ss(d);c=x[b+28>>2];xa:{if(c){x[31609]=0;x[b+12>>2]=c;O(1117,a|0,b+12|0);a=x[31609];x[31609]=0;if((a|0)!=1){break xa}a=N()|0;xg(d);break a}Fb(a)}xg(b+16|0);fb=b+48|0;break f}if(Nd(b,12844)){ss(j);b=y[j+16|0];x[31609]=0;P(36,a|0,(Id(b)?15566:15869)|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}xg(j);break f}if(Nd(b,9954)){ss(j);b=y[j+17|0];x[31609]=0;P(36,a|0,(Id(b)?15566:15869)|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){xg(j);break f}break e}if(Nd(b,12297)){ss(j);b=y[j+18|0];x[31609]=0;P(36,a|0,(Id(b)?15566:15869)|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){xg(j);break f}break e}if(Nd(b,12599)){b=fb-16|0;fb=b;d=fb-32|0;fb=d;g=b+4|0;c=Fb(g);x[31609]=0;W(128,d|0);f=x[31609];x[31609]=0;ya:{za:{if((f|0)!=1){x[31609]=0;O(129,c|0,Mp(d)|0);f=x[31609];x[31609]=0;if((f|0)==1){break za}xg(d);fb=d+32|0;break ya}a=N()|0;break b}a=N()|0;xg(d);break b}x[31609]=0;O(1059,a|0,g|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(g);fb=b+16|0;break f}break c}if(Nd(b,8253)){b=fb-16|0;fb=b;d=fb-48|0;fb=d;g=b+4|0;c=Fb(g);x[31609]=0;f=d+24|0;O(131,f|0,4135);h=x[31609];x[31609]=0;Aa:{Ba:{Ca:{Da:{if((h|0)!=1){x[d+20>>2]=18;x[d+16>>2]=0;x[31609]=0;x[d+12>>2]=0;h=d+36|0;aa(132,h|0,f|0,d+20|0,d+16|0,d+12|0);e=x[31609];x[31609]=0;if((e|0)==1){break Da}x[31609]=0;P(74,c|0,h|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break Ca}tb(h);Eb(f);fb=d+48|0;break Aa}a=N()|0;break b}a=N()|0;break Ba}a=N()|0;tb(d+36|0)}Eb(d+24|0);break b}x[31609]=0;O(1059,a|0,g|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(g);fb=b+16|0;break f}break c}if(Nd(b,6857)){b=fb-16|0;fb=b;c=b+4|0;d=fb-32|0;fb=d;g=d+8|0;Dc(g,20215);x[31609]=0;f=d+20|0;S(123,f|0,0,g|0);h=x[31609];x[31609]=0;Ea:{Fa:{Ga:{if((h|0)!=1){x[31609]=0;O(12,c|0,f|0);h=x[31609];x[31609]=0;if((h|0)==1){break Ga}Ub(f);tb(g);fb=d+32|0;break Ea}a=N()|0;break Fa}a=N()|0;Ub(d+20|0)}tb(d+8|0);break a}x[31609]=0;O(1059,a|0,c|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(c);fb=b+16|0;break f}break c}if(Nd(b,6455)){b=fb-48|0;fb=b;d=uc(b+24|0,18299);x[31609]=0;c=b+12|0;O(1120,c|0,2);g=x[31609];x[31609]=0;Ha:{Ia:{Ja:{Ka:{if((g|0)!=1){x[31609]=0;g=b+36|0;S(2,g|0,d|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break Ka}x[31609]=0;O(1059,a|0,g|0);a=x[31609];x[31609]=0;if((a|0)==1){break Ja}tb(g);tb(c);tb(d);fb=b+48|0;break f}a=N()|0;break Ha}a=N()|0;break Ia}a=N()|0;tb(b+36|0)}tb(b+12|0)}tb(d);break a}if(Nd(b,11405)){b=fb-16|0;fb=b;d=fb-16|0;fb=d;Dc(d+4|0,18615);f=b+4|0;g=Fb(f);h=y[d+15|0];e=x[d+8>>2];x[31609]=0;O(93,g|0,yh(e,h)|0);h=x[31609];x[31609]=0;La:{if((h|0)!=1){Ma:{while(1){if(yh(x[d+8>>2],y[d+15|0])>>>0>c>>>0){h=y[dc(d+4|0,c)|0];x[31609]=0;O(95,g|0,h|0);h=x[31609];x[31609]=0;if((h|0)==1){break Ma}c=c+1|0;continue}break}tb(d+4|0);fb=d+16|0;break La}}a=N()|0;tb(g);tb(d+4|0);break a}x[31609]=0;O(1059,a|0,f|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(f);fb=b+16|0;break f}break c}if(Nd(b,10548)){b=fb-16|0;fb=b;d=b+4|0;os(d,0);x[31609]=0;O(1059,a|0,d|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(d);fb=b+16|0;break f}break c}if(Nd(b,10523)){b=fb-16|0;fb=b;d=b+4|0;os(d,2);x[31609]=0;O(1059,a|0,d|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(d);fb=b+16|0;break f}break c}if(Nd(b,10508)){b=fb-16|0;fb=b;d=b+4|0;os(d,3);x[31609]=0;O(1059,a|0,d|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(d);fb=b+16|0;break f}break c}Fb(a)}fb=j+32|0;break d}a=N()|0;xg(j);break a}return}a=N()|0;tb(b+4|0);break a}tb(c)}Q(a|0);p()}function yta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,A=0,B=0,C=0;e=fb-416|0;fb=e;yc(b);f=e+399|0;g=K0(b,f);if(!g){IE(f)}a:{b:{c:{d:{e:{f:{if(!g){break f}if(!h$(f)){break f}if(!Mb(x[b>>2],x[b+8>>2],Bc(72,0))){break f}d=1;if((c|0)==64){break f}Dd(a,1);x[a+480208>>2]=x[a+480208>>2]&-25231361|16842752;k=y[e+408|0];w[a+480190>>1]=63;w[a+480188>>1]=k;d=0;g:{h:{i:{while(1){if((k&65535)>>>0<=d>>>0){j:{Rb(e+320|0,0,64);d=1;k:{l:{m:{n:{while(1){o:{f=d&65535;if(f>>>0>z[a+480190>>1]){LE(b,a+1298308|0);i$(e+312|0,b);o=Nb(e+300|0);f=y[e+409|0]|y[e+410|0]<<8;if(f){d=Nb(e+212|0);x[31609]=0;f=U(326,b|0,d|0,D(f,y[e+408|0])<<1)|0;g=x[31609];x[31609]=0;if((g|0)==1){break k}if(!f){break j}se(e+272|0,x[d>>2],x[d+4>>2]);f=Md(e+264|0);x[31609]=0;g=x[f+4>>2];x[e+40>>2]=x[f>>2];x[e+44>>2]=g;f=hg(327,e+280|0,x[e+272>>2],x[e+276>>2],e+40|0);g=x[31609];x[31609]=0;if((g|0)==1){break o}g=x[d+4>>2];k=x[d>>2];x[31609]=0;U(213,f|0,o|0,Xc(k,g)>>>1|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break n}ub(f);ec(d)}m=Nb(e+252|0);x[31609]=0;O(328,m|0,(y[e+411|0]|y[e+412|0]<<8)<<8);d=x[31609];x[31609]=0;if((d|0)==1){break i}d=0;while(1){g=y[e+411|0]|y[e+412|0]<<8;f=d&65535;if(g>>>0<=f>>>0){break l}x[e+212>>2]=g-f;x[e+160>>2]=2e3;d=e+212|0;g=x[Cd(d,e+160|0)>>2];d=Nb(d);x[31609]=0;g=U(326,b|0,d|0,g<<8)|0;k=x[31609];x[31609]=0;if((k|0)==1){break d}if(!g){break m}g=vb(e+248|0,wb(x[m+4>>2]));k=wb(x[d>>2]);h=wb(x[e+216>>2]);g=x[g>>2];x[31609]=0;V(329,m|0,g|0,k|0,h|0);g=x[31609];x[31609]=0;if((g|0)==1){break d}ec(d);d=f+2e3|0;continue}}g=(D(f,104)+a|0)+484380|0;nd(g,1);i=f+(e+320|0)|0;f=Zd(b);v[i|0]=f;if(f<<24>>24>=0){B=g,C=e$(b)<<1,x[B>>2]=C}d=d+1|0;continue}break}a=N()|0;break b}a=N()|0;ub(f);break b}ec(d);d=0;break h}se(e+232|0,x[m>>2],x[m+4>>2]);lf(e+240|0,x[e+232>>2],x[e+236>>2]);d=y[a+484376|0];f=x[a+484360>>2];x[31609]=0;O(330,Xb(f,d)|0,y[e+409|0]|y[e+410|0]<<8);d=x[31609];x[31609]=0;if((d|0)==1){break e}q=a+484344|0;s=c&1;h=0;while(1){if((y[e+409|0]|y[e+410|0]<<8)>>>0<=h>>>0){g=c&2;k=1;p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{while(1){c=k&65535;if(c>>>0>z[a+480190>>1]){break w}x[31609]=0;d=y[c+(e+320|0)|0];S(331,b|0,((c<<5)+a|0)+946304|0,d&63);f=x[31609];x[31609]=0;if((f|0)==1){break u}B:{C:{if(d<<24>>24<0){break C}x[31609]=0;d=R(332,b|0)|0;f=x[31609];x[31609]=0;D:{E:{F:{G:{H:{I:{J:{K:{if((f|0)==1){break K}c=D(c,104)+a|0;f=c+484392|0;x[f>>2]=d<<1;x[31609]=0;d=R(332,b|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break J}if(d>>>0>=2){x[c+484396>>2]=x[f>>2]+(d<<1);d=c+484414|0;w[d>>1]=z[d>>1]|8}x[31609]=0;d=R(197,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break t}v[e+80|0]=d;v[e+180|0]=64;B=c+484410|0,C=y[Qb(e+80|0,e+180|0)|0]<<2,w[B>>1]=C;x[31609]=0;d=R(197,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break K}v[c+484417|0]=d<<4;c=c+484380|0;fp(c);if(!x[c>>2]){break C}x[31609]=0;f=R(197,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break E}d=0;switch(f|0){case 4:case 5:break D;case 2:case 3:break G;case 1:break H;case 0:break I;default:break h}}a=N()|0;break c}a=N()|0;break c}if(g){f=Nb(e+80|0);h=x[b+8>>2];i=x[b>>2];j=x[c>>2];x[31609]=0;h=U(150,i|0,h|0,j|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break s}if(!h){break x}d=x[c>>2];x[31609]=0;S(333,b|0,f|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break s}B=e,C=wb(x[f>>2]),x[B+180>>2]=C;h=wb(x[e+84>>2]);while(1){d=x[e+180>>2];if(Ib(d,h)){i=d;d=y[d|0];v[i|0]=d<<7|(d^-1)>>>1&127;we(e+180|0);continue}break}se(e+200|0,x[f>>2],x[e+84>>2]);d=Md(e+192|0);x[31609]=0;h=x[d+4>>2];x[e+16>>2]=x[d>>2];x[e+20>>2]=h;d=hg(327,e+212|0,x[e+200>>2],x[e+204>>2],e+16|0);h=x[31609];x[31609]=0;L:{if((h|0)!=1){h=Zc(e+180|0,16,1,0,16);x[31609]=0;U(215,h|0,c|0,d|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break L}ub(d);ec(f);break C}a=N()|0;break p}a=N()|0;ub(d);break p}c=x[c>>2];break F}f=Nb(e+80|0);h=x[c>>2];x[31609]=0;d=e+180|0;S(334,d|0,b|0,h|0);h=x[31609];x[31609]=0;M:{N:{O:{if((h|0)!=1){i=An(f,d);ec(d);if(g){se(e+152|0,x[i>>2],x[e+84>>2]);h=Md(e+144|0);x[31609]=0;j=x[h+4>>2];x[e+24>>2]=x[h>>2];x[e+28>>2]=j;h=hg(327,e+160|0,x[e+152>>2],x[e+156>>2],e+24|0);j=x[31609];x[31609]=0;if((j|0)==1){break O}d=Zc(d,8,1,0,2);x[31609]=0;U(215,d|0,c|0,h|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break N}ub(h)}ec(i);break C}a=T(28816)|0;if((gb|0)!=($(28816)|0)){break M}Y(a|0)|0;d=0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)!=1){break v}a=N()|0;break M}a=N()|0;break M}a=N()|0;ub(h)}ec(f);break c}if(g){d=Zc(e+80|0,(f|0)==2?8:16,1,0,0);x[31609]=0;U(215,d|0,c|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break C}a=N()|0;break c}c=D(x[c>>2],f-1|0)}x[31609]=0;P(183,b|0,c|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break C}}a=N()|0;break c}h=Nb(e+80|0);d=x[c>>2];x[31609]=0;i=e+180|0;S(335,i|0,b|0,d|0);d=x[31609];x[31609]=0;P:{Q:{if((d|0)!=1){d=An(h,i);ec(i);if(!g){break P}if((f|0)!=5){break Q}B=e,C=wb(x[d>>2]),x[B+180>>2]=C;j=wb(x[e+84>>2]);while(1){i=x[e+180>>2];if(!Ib(i,j)){break Q}l=i;i=y[i|0];v[l|0]=y[(i>>>7|0)+24753|0]^i;we(e+180|0);continue}}a=T(28816)|0;if((gb|0)!=($(28816)|0)){break y}Y(a|0)|0;d=0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)!=1){break B}a=N()|0;break y}se(e+112|0,x[d>>2],x[e+84>>2]);i=Md(e+104|0);x[31609]=0;j=x[i+4>>2];x[e+32>>2]=x[i>>2];x[e+36>>2]=j;i=hg(327,e+124|0,x[e+112>>2],x[e+116>>2],e+32|0);j=x[31609];x[31609]=0;if((j|0)==1){break A}f=(f|0)==5;f=Zc(e+180|0,f?16:8,1,0,f?16:1);x[31609]=0;U(215,f|0,c|0,i|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break z}ub(i)}ec(d)}k=k+1|0;continue}break}ec(h);break h}a=N()|0;break y}a=N()|0;ub(i)}ec(h);break c}ec(f);break h}d=0;v[e+182|0]=0;w[e+180>>1]=0;w[e+80>>1]=y[e+413|0]|y[e+414|0]<<8;v[e+82|0]=y[e+415|0];while(1){if((d|0)!=3){c=xb(e+80|0,d);B=xb(e+180|0,d),C=y[c|0],v[B|0]=C;d=d+1|0;continue}break}R:{S:{T:{U:{c=e+180|0;d=cg(c);if(d){c=Nb(c);x[31609]=0;b=U(326,b|0,c|0,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break r}if(!b){break S}se(e+72|0,x[c>>2],x[c+4>>2]);b=Md(e- -64|0);x[31609]=0;f=x[b+4>>2];x[e+8>>2]=x[b>>2];x[e+12>>2]=f;b=hg(327,e+80|0,x[e+72>>2],x[e+76>>2],e+8|0);f=x[31609];x[31609]=0;if((f|0)==1){break U}x[31609]=0;V(336,a+1298332|0,b|0,d|0,1);d=x[31609];x[31609]=0;if((d|0)==1){break T}ub(b);ec(c)}x[31609]=0;W(337,e+52|0);b=x[31609];x[31609]=0;if((b|0)!=1){break R}a=N()|0;break c}a=N()|0;break q}a=N()|0;ub(b);break q}ec(c);d=0;break h}x[31609]=0;b=e+180|0;c=e+52|0;S(338,b|0,c|0,y[e+407|0]);d=x[31609];x[31609]=0;V:{W:{if((d|0)!=1){zb(a+1298344|0,b);tb(b);Eb(c);x[31609]=0;b=P(1,b|0,10112)|0;d=x[31609];x[31609]=0;if((d|0)==1){break W}zb(a+1298356|0,b);tb(b);x[31609]=0;b=P(1,c|0,5101)|0;c=x[31609];x[31609]=0;if((c|0)==1){break V}zb(a+1298368|0,b);tb(b);B=a+1298404|0,C=x[Fc(e+48|0,24)>>2],x[B>>2]=C;d=1;break h}a=N()|0;Eb(e+52|0);break c}a=N()|0;break c}a=N()|0;break c}ec(f);break h}a=N()|0;break c}a=N()|0;break c}a=N()|0;break p}a=N()|0}ec(c);break c}ec(f);break c}B=bc(x[Xb(x[a+484360>>2],y[a+484376|0])>>2],h),C=h,w[B>>1]=C;X:{Y:{if(!s){break Y}x[31609]=0;r=h&65535;d=U(196,q|0,r|0,64)|0;f=x[31609];x[31609]=0;if((f|0)==1){break X}if(!d){break Y}f=z[a+480188>>1];i=0;while(1){d=f&65535;if(d>>>0<=i>>>0){break Y}d=bc(x[o>>2],D(d,h)+i|0);d=y[d|0]|y[d+1|0]<<8;Z:{if(d>>>0>=(y[e+411|0]|y[e+412|0]<<8)>>>0){break Z}k=0;t=d<<8;d=Wb(x[q>>2],h);d=md(x[d>>2],x[x[d+48>>2]+12>>2],0,i&65535);u=D(i,-6);while(1){if((k|0)==64){break Z}vr(e+212|0,x[e+240>>2],x[e+244>>2],k<<2|t,4);f=x[e+212>>2];g=xb(f,0);n=y[g|0]&63;v[d|0]=n?n+48|0:0;j=xb(f,1);v[d+1|0]=y[j|0]<<2&60|y[g|0]>>>6;l=y[j|0];g=xb(f,2);j=y[xb(f,3)|0];f=y[g|0];g=j<<4|f>>>4;w[e+80>>1]=g;A=l>>>6|0;l=f<<2&60;f=A|l;_:{if(!(y[xb(e+312|0,l>>>3|0)|0]>>>(f&7)&1)|!(f|g)){break _}v[d+5|0]=g;l=j>>>4|0;v[d+4|0]=l;$:{aa:{ba:{ca:{da:{ea:{fa:{ga:{ha:{ia:{ja:{ka:{switch(f|0){case 0:case 1:case 2:case 32:case 33:case 34:Cf(d,f&15,g&255);if(!y[d+4|0]){break _}v[d+2|0]=f>>>0<32?3:4;break _;case 9:v[d+3|0]=10;v[d+5|0]=g>>>1;if(g>>>0<512){break _}v[d+2|0]=15;v[d+4|0]=j>>>5;break _;case 10:case 42:if(g>>>0>254){break ja}f=f&15;break;case 50:break aa;case 48:break ba;case 43:break ca;case 47:break da;case 17:case 18:case 26:case 27:break ea;case 22:case 25:case 28:case 29:case 30:break fa;case 16:case 19:case 20:case 21:case 23:case 31:break ga;case 13:break ha;case 11:case 15:break ia;case 3:case 4:case 5:case 6:case 7:case 12:break ka;default:break $}}Cf(d,f,g&255);break _}v[d+3|0]=19;v[d+5|0]=l|(f>>>0<32?16:32);if(j&15){v[d+2|0]=3;v[d+4|0]=(g&240)>>>4;break _}v[d+4|0]=g;v[d+2|0]=4;break _}v[d+3|0]=(f|0)==11?12:16;B=d,C=ew(g),v[B+5|0]=C;break _}v[d+3|0]=14;if((g&255)>>>0<64){break _}v[d+5|0]=0;break _}v[d+3|0]=19;v[d+5|0]=g&15|f<<4;break _}v[d+3|0]=19;w[e+160>>1]=15;B=d,C=y[Oc(e+80|0,e+160|0)|0]|f<<4,v[B+5|0]=C;break _}v[d+3|0]=19;if(g&255){v[d+5|0]=g&15|((f|0)==17?16:(f|0)==26?16:32);if(j>>>0<16){break _}v[d+2|0]=f>>>0>25?6:5;break _}v[d+5|0]=l|(f>>>0>25?-80:-96);break _}if(!g){break $}v[d+3|0]=17;x[e+160>>2]=8;x[e+124>>2]=g+4;B=d,C=Eh(x[Xe(e+160|0,e+124|0)>>2]/8|0),v[B+5|0]=C;break _}v[d+3|0]=14;j=d+u|0;n=z[a+480188>>1];f=0;while(1){if((f|0)==(n|0)){break _}g=j+D(f,6)|0;if(!y[g+3|0]){v[g+3|0]=12;B=g,C=ew(r),v[B+5|0]=C}f=f+1|0;continue}}v[d+3|0]=9;f=g&7;if(f){v[d+5|0]=y[f+24745|0];break _}f=g>>>4|0;if((f|0)==128){break $}v[d+5|0]=f;if(g>>>0<=2047){v[d+5|0]=f|128;break _}v[d+5|0]=f^-1;break _}v[d+5|0]=0;v[d+3|0]=0;if(!n){v[d|0]=255;break _}v[d+3|0]=25;break _}v[d+3|0]=0}k=k+1|0;f=z[a+480188>>1];d=D(f,6)+d|0;continue}}i=i+1|0;continue}}h=h+1|0;continue}break}a=N()|0;break c}a=N()|0;break b}}else{bE(a,d&65535);w[((d<<5)+a|0)+480284>>1]=(d&3)-1>>>0<2?64:192;d=d+1|0;k=z[a+480188>>1];continue}break}ec(d);d=0;break g}a=N()|0;break c}ec(m)}od(o)}fb=e+416|0;return d|0}a=N()|0;break c}a=N()|0;ec(d)}ec(m);break a}ec(d)}od(o);Q(a|0);p()}function v1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;a:{n=bk(b,13930);if(!n){break a}b:while(1){if(!Mb(x[b>>2],x[b+8>>2],6)){break a}f=Rg(b);if(!(!((f|0)==(En(13780)|0)|!(f&1616928864)|f&-2139062144)&(f|0)!=70791730)){Ih(b,4);break a}l=1;c=gh(b);while(1){e=l&65535;if(e>>>0>z[a+480192>>1]){continue b}e=x[((e<<2)+a|0)+900380>>2];if(e){c:{g=0;if((En(16790)|0)==(f|0)){Vb(b,c);break c}h=fb-48|0;fb=h;d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{switch(f-1349079874|0){default:if((f|0)==1095062094){break t}if((f|0)==1095126087){break q}if((f|0)==1129524782){break z}if((f|0)==1145263150){break W}if((f|0)==1145979182){break V}if((f|0)==1179463214){break x}if((f|0)==1851469358){break D}if((f|0)==1179931728){break l}Z:{_:{$:{aa:{ba:{ca:{da:{ea:{fa:{ga:{ha:{if((f|0)!=1196830254){if((f|0)==1229341486){break S}if((f|0)==1229345326){break R}if((f|0)==1264266798){break E}if((f|0)==1296182830){break Q}if((f|0)==1296248366){break O}if((f|0)==1297100334){break P}if((f|0)==1297110852){break o}if((f|0)==1298747438){break B}if((f|0)==1313692462){break F}if((f|0)==1313751342){break X}if((f|0)==1345203758){break ha}if((f|0)==1346711086){break j}if((f|0)==1346720334){break u}if((f|0)==1346722606){break H}if((f|0)==1346784327){break r}if((f|0)==1347175726){break ba}if((f|0)==1347179310){break ca}if((f|0)==1347437358){break M}if((f|0)==1347441454){break N}if((f|0)==1347443502){break K}if((f|0)==1347628590){break U}if((f|0)==1347633710){break aa}if((f|0)==1347634478){break $}if((f|0)==1347703884){break m}if((f|0)==1347831112){break w}if((f|0)==1347833672){break v}if((f|0)==1349076270){break i}if((f|0)==1349076315){break G}if((f|0)==1349078085){break Z}if((f|0)==1349078099){break _}if((f|0)==1349079131){break J}if((f|0)==1378758190){break n}if((f|0)==1381183022){break y}if((f|0)==1447374382){break k}if((f|0)==1447383630){break s}if((f|0)==1447385902){break I}if((f|0)==1447447623){break p}if((f|0)==1447839022){break fa}if((f|0)==1447842606){break ga}if((f|0)==1448106798){break L}if((f|0)==1448226350){break A}if((f|0)==1448291886){break T}if((f|0)==1448297006){break ea}if((f|0)==1448297774){break da}if((f|0)!=1682320942){if((f|0)==1718508334){break C}if((f|0)!=1179594286|c>>>0>4){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Rw(b,c),x[o>>2]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+15|0]=q;break e}if(c>>>0>4){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Rw(b,c),x[o+4>>2]=q;break e}if(c>>>0>4){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Rw(b,c),x[o+8>>2]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+61|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+62|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+63|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e- -64|0,q=Kd(b,c),v[o|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+81|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+82|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+83|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+84|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+101|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+102|0]=q;break e;case 0:if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+103|0]=q;break e;case 3:break Y;case 1:case 2:break d}}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+104|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+16|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+17|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+18|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+19|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+20|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+21|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+22|0]=q;break e}if(c>>>0>2){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=GF(b,c),w[o+28>>1]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+30|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+31|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=FF(b,c),v[o+26|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+27|0]=q;break e}d=h+8|0;he(d,b,c);j=hc(h+28|0,d);ub(d);i=Yh(e,0);g=x[i>>2];d=0;while(1){if(Sd(g,x[i+4>>2])>>>0<=d>>>0){ub(j);break e}x[31609]=0;k=R(192,j|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break h}g=x[i>>2];o=yb(g,d),q=k,w[o>>1]=q;d=d+1|0;continue}}d=h+8|0;he(d,b,c);j=hc(h+28|0,d);ub(d);i=Yh(e,1);g=x[i>>2];d=0;while(1){if(Sd(g,x[i+4>>2])>>>0<=d>>>0){ub(j);break e}x[31609]=0;k=R(192,j|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){g=x[i>>2];o=yb(g,d),q=k,w[o>>1]=q;d=d+1|0;continue}break}d=N()|0;break g}d=h+8|0;he(d,b,c);j=hc(h+28|0,d);ub(d);i=Yh(e,2);g=x[i>>2];d=0;while(1){if(Sd(g,x[i+4>>2])>>>0<=d>>>0){ub(j);break e}x[31609]=0;k=R(192,j|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){g=x[i>>2];o=yb(g,d),q=k,w[o>>1]=q;d=d+1|0;continue}break}d=N()|0;break g}d=h+8|0;he(d,b,c);j=hc(h+28|0,d);ub(d);i=Yh(e,0);g=x[i>>2];d=0;while(1){if(Sd(g,x[i+4>>2])>>>0<=d>>>0){ub(j);break e}x[31609]=0;k=R(193,j|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){g=x[i>>2];o=yb(g,d),q=k,v[o+2|0]=q;d=d+1|0;continue}break}d=N()|0;break g}d=h+8|0;he(d,b,c);j=hc(h+28|0,d);ub(d);i=Yh(e,1);g=x[i>>2];d=0;while(1){if(Sd(g,x[i+4>>2])>>>0<=d>>>0){ub(j);break e}x[31609]=0;k=R(193,j|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){g=x[i>>2];o=yb(g,d),q=k,v[o+2|0]=q;d=d+1|0;continue}break}d=N()|0;break g}d=h+8|0;he(d,b,c);j=hc(h+28|0,d);ub(d);i=Yh(e,2);g=x[i>>2];d=0;while(1){if(Sd(g,x[i+4>>2])>>>0<=d>>>0){ub(j);break e}x[31609]=0;k=R(193,j|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){g=x[i>>2];o=yb(g,d),q=k,v[o+2|0]=q;d=d+1|0;continue}break}d=N()|0;break g}if(c>>>0>128){break d}g=e+108|0;d=h+8|0;he(d,b,c);j=hc(h+28|0,d);ub(d);d=0;while(1){if((d|0)==128){ub(j);break e}x[31609]=0;i=R(193,j|0)|0;k=x[31609];x[31609]=0;if((k|0)!=1){o=xb(g,d),q=i,v[o|0]=q;d=d+1|0;continue}break}d=N()|0;break g}if(c>>>0>256){break d}g=e+236|0;d=h+8|0;he(d,b,c);j=hc(h+28|0,d);ub(d);d=0;while(1){if((d|0)==128){ub(j);break e}x[31609]=0;i=R(192,j|0)|0;k=x[31609];x[31609]=0;if((k|0)!=1){o=bc(g,d),q=i,w[o>>1]=q;d=d+1|0;continue}break}d=N()|0;break g}if(c>>>0>32){break d}i=e+492|0;d=h+8|0;he(d,b,c);j=hc(h+28|0,d);ub(d);g=Fb(d);d=0;while(1){if((c|0)==(d|0)){break f}x[31609]=0;k=R(194,j|0)|0;m=x[31609];x[31609]=0;ia:{if((m|0)==1){break ia}x[31609]=0;P(195,g|0,k|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break ia}d=d+1|0;continue}break}d=N()|0;tb(g);break g}if(c>>>0>32){break d}i=e+524|0;d=h+8|0;he(d,b,c);j=hc(h+28|0,d);ub(d);g=Fb(d);d=0;ja:{while(1){if((c|0)!=(d|0)){x[31609]=0;k=R(194,j|0)|0;m=x[31609];x[31609]=0;if((m|0)==1){break ja}x[31609]=0;P(195,g|0,k|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break ja}d=d+1|0;continue}break}Ac(i,g);tb(g);ub(j);break e}d=N()|0;tb(g);break g}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+34|0]=q;break e}if(c>>>0>2){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=GF(b,c),w[o+12>>1]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+23|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+24|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+25|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+35|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+36|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+105|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+85|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+65|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+100|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+80|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=Kd(b,c),v[o+60|0]=q;break e}if(c>>>0>1){break d}if(!Mb(x[b>>2],x[b+8>>2],c)){break d}o=e,q=FF(b,c),v[o+33|0]=q;break e}g=1;d=up(b,c);if(!tp(d)){break d}v[e+14|0]=d;break d}o=e,q=D(Pw(b,c),1e4)+(A[e+40>>2]%1e4|0)|0,x[o+40>>2]=q;break e}g=(Pw(b,c)>>>0)%1e4|0;d=x[e+40>>2];x[e+40>>2]=g+d-(d>>>0)%1e4;break e}x[h+28>>2]=240;o=h,q=up(b,c),x[o+8>>2]=q;fh(e+48|0,x[Hb(h+28|0,h+8|0)>>2]);break e}x[h+28>>2]=240;o=h,q=up(b,c),x[o+8>>2]=q;fh(e+68|0,x[Hb(h+28|0,h+8|0)>>2]);break e}x[h+28>>2]=240;o=h,q=up(b,c),x[o+8>>2]=q;fh(e+88|0,x[Hb(h+28|0,h+8|0)>>2]);break e}d=N()|0}ub(j);Q(d|0);p()}Ac(i,g);tb(g);ub(j)}g=1}fb=h+48|0;if(!g){Vb(b,c);break c}if((En(16795)|0)==(f|0)){d=y[e+15|0];v[e+15|0]=0;v[e+100|0]=d>>>5&4|(y[e+100|0]&224|d>>>6&1);v[e+60|0]=d>>>1&2|(d<<1&4|(y[e+60|0]&240|d&1));v[e+80|0]=d>>>4&2|(d>>>2&4|(y[e+80|0]&240|d>>>3&1))}}}l=l+1|0;continue}}}return n|0}function Gd(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;l=fb-16|0;fb=l;a:{b:{c:{d:{e:{f:{g:{h:{i:{if(a>>>0<=244){g=x[31485];h=a>>>0<11?16:a+11&504;c=h>>>3|0;b=g>>>c|0;if(b&3){c=c+((b^-1)&1)|0;a=c<<3;b=a+125980|0;d=x[a+125988>>2];a=x[d+8>>2];j:{if((b|0)==(a|0)){m=125940,n=Lua(-2,c)&g,x[m>>2]=n;break j}x[a+12>>2]=b;x[b+8>>2]=a}a=d+8|0;b=c<<3;x[d+4>>2]=b|3;b=b+d|0;x[b+4>>2]=x[b+4>>2]|1;break a}k=x[31487];if(k>>>0>=h>>>0){break i}if(b){a=2<<c;d=Hua((0-a|a)&b<<c);a=d<<3;b=a+125980|0;e=x[a+125988>>2];a=x[e+8>>2];k:{if((b|0)==(a|0)){g=Lua(-2,d)&g;x[31485]=g;break k}x[a+12>>2]=b;x[b+8>>2]=a}x[e+4>>2]=h|3;c=e+h|0;a=d<<3;d=a-h|0;x[c+4>>2]=d|1;x[a+e>>2]=d;if(k){b=(k&-8)+125980|0;f=x[31490];a=1<<(k>>>3);l:{if(!(a&g)){x[31485]=a|g;a=b;break l}a=x[b+8>>2]}x[b+8>>2]=f;x[a+12>>2]=f;x[f+12>>2]=b;x[f+8>>2]=a}a=e+8|0;x[31490]=c;x[31487]=d;break a}j=x[31486];if(!j){break i}c=x[(Hua(j)<<2)+126244>>2];e=(x[c+4>>2]&-8)-h|0;b=c;while(1){m:{a=x[b+16>>2];if(!a){a=x[b+20>>2];if(!a){break m}}b=(x[a+4>>2]&-8)-h|0;d=b>>>0<e>>>0;e=d?b:e;c=d?a:c;b=a;continue}break}i=x[c+24>>2];d=x[c+12>>2];if((d|0)!=(c|0)){a=x[c+8>>2];x[a+12>>2]=d;x[d+8>>2]=a;break b}b=c+20|0;a=x[b>>2];if(!a){a=x[c+16>>2];if(!a){break h}b=c+16|0}while(1){f=b;d=a;b=a+20|0;a=x[b>>2];if(a){continue}b=d+16|0;a=x[d+16>>2];if(a){continue}break}x[f>>2]=0;break b}h=-1;if(a>>>0>4294967231){break i}a=a+11|0;h=a&-8;j=x[31486];if(!j){break i}e=0-h|0;g=0;n:{if(h>>>0<256){break n}g=31;if(h>>>0>16777215){break n}a=G(a>>>8|0);g=((h>>>38-a&1)-(a<<1)|0)+62|0}b=x[(g<<2)+126244>>2];o:{p:{q:{if(!b){a=0;break q}a=0;c=h<<((g|0)!=31?25-(g>>>1|0)|0:0);while(1){r:{f=(x[b+4>>2]&-8)-h|0;if(f>>>0>=e>>>0){break r}d=b;e=f;if(e){break r}e=0;a=b;break p}f=x[b+20>>2];b=x[((c>>>29&4)+b|0)+16>>2];a=f?(f|0)==(b|0)?a:f:a;c=c<<1;if(b){continue}break}}if(!(a|d)){d=0;a=2<<g;a=(0-a|a)&j;if(!a){break i}a=x[(Hua(a)<<2)+126244>>2]}if(!a){break o}}while(1){b=(x[a+4>>2]&-8)-h|0;c=b>>>0<e>>>0;e=c?b:e;d=c?a:d;b=x[a+16>>2];if(b){a=b}else{a=x[a+20>>2]}if(a){continue}break}}if(!d|x[31487]-h>>>0<=e>>>0){break i}g=x[d+24>>2];c=x[d+12>>2];if((d|0)!=(c|0)){a=x[d+8>>2];x[a+12>>2]=c;x[c+8>>2]=a;break c}b=d+20|0;a=x[b>>2];if(!a){a=x[d+16>>2];if(!a){break g}b=d+16|0}while(1){f=b;c=a;b=a+20|0;a=x[b>>2];if(a){continue}b=c+16|0;a=x[c+16>>2];if(a){continue}break}x[f>>2]=0;break c}a=x[31487];if(a>>>0>=h>>>0){d=x[31490];b=a-h|0;s:{if(b>>>0>=16){c=d+h|0;x[c+4>>2]=b|1;x[a+d>>2]=b;x[d+4>>2]=h|3;break s}x[d+4>>2]=a|3;a=a+d|0;x[a+4>>2]=x[a+4>>2]|1;c=0;b=0}x[31487]=b;x[31490]=c;a=d+8|0;break a}i=x[31488];if(i>>>0>h>>>0){b=i-h|0;x[31488]=b;c=x[31491];a=c+h|0;x[31491]=a;x[a+4>>2]=b|1;x[c+4>>2]=h|3;a=c+8|0;break a}a=0;e=h+47|0;if(x[31603]){c=x[31605]}else{x[31606]=-1;x[31607]=-1;x[31604]=4096;x[31605]=4096;x[31603]=l+12&-16^1431655768;x[31608]=0;x[31596]=0;c=4096}g=e+c|0;f=0-c|0;b=g&f;if(b>>>0<=h>>>0){break a}d=x[31595];if(d){c=x[31593];j=c+b|0;if(d>>>0<j>>>0|c>>>0>=j>>>0){break a}}t:{if(!(y[126384]&4)){u:{v:{w:{x:{d=x[31491];if(d){a=126388;while(1){c=x[a>>2];if(c>>>0<=d>>>0&d>>>0<c+x[a+4>>2]>>>0){break x}a=x[a+8>>2];if(a){continue}break}}c=ep(0);if((c|0)==-1){break u}g=b;d=x[31604];a=d-1|0;if(a&c){g=(b-c|0)+(a+c&0-d)|0}if(g>>>0<=h>>>0){break u}d=x[31595];if(d){a=x[31593];f=a+g|0;if(d>>>0<f>>>0|a>>>0>=f>>>0){break u}}a=ep(g);if((c|0)!=(a|0)){break w}break t}g=f&g-i;c=ep(g);if((c|0)==(x[a>>2]+x[a+4>>2]|0)){break v}a=c}if((a|0)==-1){break u}if(h+48>>>0<=g>>>0){c=a;break t}c=x[31605];c=c+(e-g|0)&0-c;if((ep(c)|0)==-1){break u}g=c+g|0;c=a;break t}if((c|0)!=-1){break t}}x[31596]=x[31596]|4}c=ep(b);a=ep(0);if((c|0)==-1|(a|0)==-1|a>>>0<=c>>>0){break d}g=a-c|0;if(g>>>0<=h+40>>>0){break d}}a=x[31593]+g|0;x[31593]=a;if(a>>>0>A[31594]){x[31594]=a}y:{e=x[31491];if(e){a=126388;while(1){d=x[a>>2];b=x[a+4>>2];if((d+b|0)==(c|0)){break y}a=x[a+8>>2];if(a){continue}break}break f}a=x[31489];if(!(a>>>0<=c>>>0?a:0)){x[31489]=c}a=0;x[31598]=g;x[31597]=c;x[31493]=-1;x[31494]=x[31603];x[31600]=0;while(1){d=a<<3;b=d+125980|0;x[d+125988>>2]=b;x[d+125992>>2]=b;a=a+1|0;if((a|0)!=32){continue}break}d=g-40|0;a=-8-c&7;b=d-a|0;x[31488]=b;a=a+c|0;x[31491]=a;x[a+4>>2]=b|1;x[(c+d|0)+4>>2]=40;x[31492]=x[31607];break e}if(x[a+12>>2]&8|(c>>>0<=e>>>0|d>>>0>e>>>0)){break f}x[a+4>>2]=b+g;a=-8-e&7;c=a+e|0;x[31491]=c;b=x[31488]+g|0;a=b-a|0;x[31488]=a;x[c+4>>2]=a|1;x[(b+e|0)+4>>2]=40;x[31492]=x[31607];break e}d=0;break b}c=0;break c}if(A[31489]>c>>>0){x[31489]=c}b=c+g|0;a=126388;z:{A:{B:{while(1){if((b|0)!=x[a>>2]){a=x[a+8>>2];if(a){continue}break B}break}if(!(y[a+12|0]&8)){break A}}a=126388;while(1){C:{b=x[a>>2];if(b>>>0<=e>>>0){f=b+x[a+4>>2]|0;if(f>>>0>e>>>0){break C}}a=x[a+8>>2];continue}break}d=g-40|0;a=-8-c&7;b=d-a|0;x[31488]=b;a=a+c|0;x[31491]=a;x[a+4>>2]=b|1;x[(c+d|0)+4>>2]=40;x[31492]=x[31607];a=(f+(39-f&7)|0)-47|0;d=a>>>0<e+16>>>0?e:a;x[d+4>>2]=27;a=x[31600];x[d+16>>2]=x[31599];x[d+20>>2]=a;a=x[31598];x[d+8>>2]=x[31597];x[d+12>>2]=a;x[31599]=d+8;x[31598]=g;x[31597]=c;x[31600]=0;a=d+24|0;while(1){x[a+4>>2]=7;b=a+8|0;a=a+4|0;if(b>>>0<f>>>0){continue}break}if((d|0)==(e|0)){break e}x[d+4>>2]=x[d+4>>2]&-2;f=d-e|0;x[e+4>>2]=f|1;x[d>>2]=f;if(f>>>0<=255){b=(f&-8)+125980|0;c=x[31485];a=1<<(f>>>3);D:{if(!(c&a)){x[31485]=a|c;a=b;break D}a=x[b+8>>2]}x[b+8>>2]=e;x[a+12>>2]=e;x[e+12>>2]=b;x[e+8>>2]=a;break e}a=31;if(f>>>0<=16777215){a=G(f>>>8|0);a=((f>>>38-a&1)-(a<<1)|0)+62|0}x[e+28>>2]=a;x[e+16>>2]=0;x[e+20>>2]=0;b=(a<<2)+126244|0;d=x[31486];c=1<<a;E:{if(!(d&c)){x[31486]=c|d;x[b>>2]=e;break E}a=f<<((a|0)!=31?25-(a>>>1|0)|0:0);d=x[b>>2];while(1){b=d;if((f|0)==(x[b+4>>2]&-8)){break z}c=a>>>29|0;a=a<<1;c=(c&4)+b|0;d=x[c+16>>2];if(d){continue}break}x[c+16>>2]=e}x[e+24>>2]=b;x[e+12>>2]=e;x[e+8>>2]=e;break e}x[a>>2]=c;x[a+4>>2]=x[a+4>>2]+g;j=(-8-c&7)+c|0;x[j+4>>2]=h|3;e=b+(-8-b&7)|0;i=h+j|0;g=e-i|0;F:{if(x[31491]==(e|0)){x[31491]=i;a=x[31488]+g|0;x[31488]=a;x[i+4>>2]=a|1;break F}if(x[31490]==(e|0)){x[31490]=i;a=x[31487]+g|0;x[31487]=a;x[i+4>>2]=a|1;x[a+i>>2]=a;break F}c=x[e+4>>2];if((c&3)==1){f=c&-8;G:{if(c>>>0<=255){b=x[e+12>>2];a=x[e+8>>2];if((b|0)==(a|0)){m=125940,n=x[31485]&Lua(-2,c>>>3|0),x[m>>2]=n;break G}x[a+12>>2]=b;x[b+8>>2]=a;break G}h=x[e+24>>2];a=x[e+12>>2];H:{if((e|0)!=(a|0)){b=x[e+8>>2];x[b+12>>2]=a;x[a+8>>2]=b;break H}I:{b=e+20|0;c=x[b>>2];if(!c){c=x[e+16>>2];if(!c){break I}b=e+16|0}while(1){d=b;a=c;b=a+20|0;c=x[b>>2];if(c){continue}b=a+16|0;c=x[a+16>>2];if(c){continue}break}x[d>>2]=0;break H}a=0}if(!h){break G}c=x[e+28>>2];b=(c<<2)+126244|0;J:{if(x[b>>2]==(e|0)){x[b>>2]=a;if(a){break J}m=125944,n=x[31486]&Lua(-2,c),x[m>>2]=n;break G}x[h+(x[h+16>>2]==(e|0)?16:20)>>2]=a;if(!a){break G}}x[a+24>>2]=h;b=x[e+16>>2];if(b){x[a+16>>2]=b;x[b+24>>2]=a}b=x[e+20>>2];if(!b){break G}x[a+20>>2]=b;x[b+24>>2]=a}g=f+g|0;e=e+f|0;c=x[e+4>>2]}x[e+4>>2]=c&-2;x[i+4>>2]=g|1;x[g+i>>2]=g;if(g>>>0<=255){b=(g&-8)+125980|0;c=x[31485];a=1<<(g>>>3);K:{if(!(c&a)){x[31485]=a|c;a=b;break K}a=x[b+8>>2]}x[b+8>>2]=i;x[a+12>>2]=i;x[i+12>>2]=b;x[i+8>>2]=a;break F}c=31;if(g>>>0<=16777215){a=G(g>>>8|0);c=((g>>>38-a&1)-(a<<1)|0)+62|0}x[i+28>>2]=c;x[i+16>>2]=0;x[i+20>>2]=0;b=(c<<2)+126244|0;L:{d=x[31486];a=1<<c;M:{if(!(d&a)){x[31486]=a|d;x[b>>2]=i;break M}c=g<<((c|0)!=31?25-(c>>>1|0)|0:0);a=x[b>>2];while(1){b=a;if((x[a+4>>2]&-8)==(g|0)){break L}d=c>>>29|0;c=c<<1;d=(d&4)+a|0;a=x[d+16>>2];if(a){continue}break}x[d+16>>2]=i}x[i+24>>2]=b;x[i+12>>2]=i;x[i+8>>2]=i;break F}a=x[b+8>>2];x[a+12>>2]=i;x[b+8>>2]=i;x[i+24>>2]=0;x[i+12>>2]=b;x[i+8>>2]=a}a=j+8|0;break a}a=x[b+8>>2];x[a+12>>2]=e;x[b+8>>2]=e;x[e+24>>2]=0;x[e+12>>2]=b;x[e+8>>2]=a}a=x[31488];if(a>>>0<=h>>>0){break d}b=a-h|0;x[31488]=b;c=x[31491];a=c+h|0;x[31491]=a;x[a+4>>2]=b|1;x[c+4>>2]=h|3;a=c+8|0;break a}x[31484]=48;a=0;break a}N:{if(!g){break N}b=x[d+28>>2];a=(b<<2)+126244|0;O:{if(x[a>>2]==(d|0)){x[a>>2]=c;if(c){break O}j=Lua(-2,b)&j;x[31486]=j;break N}x[g+(x[g+16>>2]==(d|0)?16:20)>>2]=c;if(!c){break N}}x[c+24>>2]=g;a=x[d+16>>2];if(a){x[c+16>>2]=a;x[a+24>>2]=c}a=x[d+20>>2];if(!a){break N}x[c+20>>2]=a;x[a+24>>2]=c}P:{if(e>>>0<=15){a=e+h|0;x[d+4>>2]=a|3;a=a+d|0;x[a+4>>2]=x[a+4>>2]|1;break P}x[d+4>>2]=h|3;f=d+h|0;x[f+4>>2]=e|1;x[e+f>>2]=e;if(e>>>0<=255){b=(e&-8)+125980|0;c=x[31485];a=1<<(e>>>3);Q:{if(!(c&a)){x[31485]=a|c;a=b;break Q}a=x[b+8>>2]}x[b+8>>2]=f;x[a+12>>2]=f;x[f+12>>2]=b;x[f+8>>2]=a;break P}a=31;if(e>>>0<=16777215){a=G(e>>>8|0);a=((e>>>38-a&1)-(a<<1)|0)+62|0}x[f+28>>2]=a;x[f+16>>2]=0;x[f+20>>2]=0;b=(a<<2)+126244|0;R:{c=1<<a;S:{if(!(c&j)){x[31486]=c|j;x[b>>2]=f;break S}a=e<<((a|0)!=31?25-(a>>>1|0)|0:0);h=x[b>>2];while(1){b=h;if((x[b+4>>2]&-8)==(e|0)){break R}c=a>>>29|0;a=a<<1;c=(c&4)+b|0;h=x[c+16>>2];if(h){continue}break}x[c+16>>2]=f}x[f+24>>2]=b;x[f+12>>2]=f;x[f+8>>2]=f;break P}a=x[b+8>>2];x[a+12>>2]=f;x[b+8>>2]=f;x[f+24>>2]=0;x[f+12>>2]=b;x[f+8>>2]=a}a=d+8|0;break a}T:{if(!i){break T}b=x[c+28>>2];a=(b<<2)+126244|0;U:{if(x[a>>2]==(c|0)){x[a>>2]=d;if(d){break U}m=125944,n=Lua(-2,b)&j,x[m>>2]=n;break T}x[i+(x[i+16>>2]==(c|0)?16:20)>>2]=d;if(!d){break T}}x[d+24>>2]=i;a=x[c+16>>2];if(a){x[d+16>>2]=a;x[a+24>>2]=d}a=x[c+20>>2];if(!a){break T}x[d+20>>2]=a;x[a+24>>2]=d}V:{if(e>>>0<=15){a=e+h|0;x[c+4>>2]=a|3;a=a+c|0;x[a+4>>2]=x[a+4>>2]|1;break V}x[c+4>>2]=h|3;d=c+h|0;x[d+4>>2]=e|1;x[d+e>>2]=e;if(k){b=(k&-8)+125980|0;f=x[31490];a=1<<(k>>>3);W:{if(!(a&g)){x[31485]=a|g;a=b;break W}a=x[b+8>>2]}x[b+8>>2]=f;x[a+12>>2]=f;x[f+12>>2]=b;x[f+8>>2]=a}x[31490]=d;x[31487]=e}a=c+8|0}fb=l+16|0;return a|0}function Eua(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;e=fb-272|0;fb=e;yc(b);a:{b:{c:{d:{if(Nr(b,18456)){n=Fb(e+260|0);x[31609]=0;g=P(230,b|0,n|0)|0;d=x[31609];x[31609]=0;e:{if((d|0)!=1){if(!g){break e}x[31609]=0;h=e+253|0;g=P(245,b|0,h|0)|0;d=x[31609];x[31609]=0;f:{if((d|0)==1){break f}if(!g){break e}if(!H0(y[e+253|0],y[e+254|0])){break e}h=Bc(G0(h),hb);g=x[b+8>>2];d=x[b>>2];x[31609]=0;g=U(150,d|0,g|0,h|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break f}if(!g){break e}f=1;if((c|0)==64){break e}x[31609]=0;O(246,a|0,4096);d=x[31609];x[31609]=0;if((d|0)==1){break f}x[31609]=0;O(247,a+1298308|0,n|0);d=x[31609];x[31609]=0;if((d|0)==1){break f}d=y[e+255|0];w[a+480188>>1]=32;w[a+480192>>1]=d;Wh(a,1);x[31609]=0;f=P(1,e+240|0,9492)|0;d=x[31609];x[31609]=0;g:{h:{i:{j:{k:{l:{m:{n:{o:{if((d|0)!=1){zb(a+1298344|0,f);tb(f);x[31609]=0;f=P(1,e+228|0,7105)|0;d=x[31609];x[31609]=0;if((d|0)==1){break o}zb(a+1298356|0,f);tb(f);x[31609]=0;g=e+32|0;W(248,g|0);d=x[31609];x[31609]=0;if((d|0)==1){break n}v[e+204|0]=y[e+254|0];x[31609]=0;v[e|0]=y[e+253|0];f=e+216|0;O(249,f|0,e|0);d=x[31609];x[31609]=0;if((d|0)==1){break m}x[31609]=0;h=e+80|0;V(250,h|0,g|0,e+204|0,f|0);d=x[31609];x[31609]=0;if((d|0)==1){break l}zb(a+1298368|0,h);tb(h);tb(f);Eb(g);r=a+1298404|0,s=x[Fc(h,4)>>2],x[r>>2]=s;if(y[e+253|0]<2){break h}w[e+80>>1]=8192;x[31609]=0;f=R(189,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break j}w[e+32>>1]=f;r=a,s=D(z[qe(h,g)>>1],1e4)>>>8|0,x[r+480204>>2]=s;x[31609]=0;v[e+80|0]=1;f=R(197,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break i}v[e+32|0]=f;r=a,s=y[cf(h,g)|0],x[r+480196>>2]=s;x[31609]=0;P(183,b|0,3)|0;d=x[31609];x[31609]=0;if((d|0)!=1){x[31609]=0;f=R(189,b|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break g}}b=N()|0;break a}b=N()|0;break a}b=N()|0;break a}b=N()|0;break a}b=N()|0;break k}b=N()|0;tb(e+216|0)}Eb(e+32|0);break a}b=N()|0;break a}b=N()|0;break a}v[e+80|0]=32;x[31609]=0;f=R(197,b|0)|0;d=x[31609];x[31609]=0;p:{if((d|0)!=1){v[e+32|0]=f;r=a,s=D(y[cf(e+80|0,e+32|0)|0],1e4),x[r+480204>>2]=s;x[31609]=0;v[e+80|0]=1;f=R(197,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break p}v[e+32|0]=f;r=a,s=y[cf(e+80|0,e+32|0)|0],x[r+480196>>2]=s;x[31609]=0;f=R(197,b|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break g}b=N()|0;break a}b=N()|0;break a}b=N()|0;break a}x[a+480208>>2]=f>>>2&16|12;l=Nb(e+216|0);j=e+80|12;m=Nb(e+204|0);o=1;while(1){q:{r:{d=o&65535;if(d>>>0>z[a+480192>>1]){break r}x[31609]=0;i=U(251,a|0,d|0,0)|0;d=x[31609];x[31609]=0;s:{if((d|0)==1){break s}if(!i){break r}x[31609]=0;f=P(240,b|0,i+492|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break s}if(!f){break r}x[31609]=0;q=R(197,b|0)|0;d=x[31609];x[31609]=0;t:{u:{v:{if((d|0)!=1){d=e+80|0;Rb(d,0,120);if(!q){break q}w:{if(y[e+253|0]){x[31609]=0;f=P(252,b|0,d|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break v}if(!f){break q}if(y[e+253|0]){break w}}d=Zb(e+72|0,j,96);f=x[d>>2];d=x[d+4>>2];x[31609]=0;Zn(159,e+32|0,b,f,d);d=x[31609];x[31609]=0;if((d|0)==1){break u}if(!x[e+36>>2]){break q}}d=i+236|0;f=0;break t}b=N()|0;break b}b=N()|0;break b}b=N()|0;break b}while(1){if((f|0)!=120){r=bc(d,f),s=(y[(e+80|0)+f|0]+z[a+480190>>1]|0)+1|0,w[r>>1]=s;f=f+1|0;continue}break}x[31609]=0;f=i+48|0;S(253,e|0,f|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break c}x[31609]=0;k=i+68|0;S(253,e+16|0,k|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break c}x[31609]=0;h=i+88|0;S(253,e- -64|0,h|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break c}x[31609]=0;O(254,b|0,e+56|0);d=x[31609];x[31609]=0;if((d|0)==1){break d}x[i>>2]=(y[e+57|0]|y[e+58|0]<<8)&4095;d=y[e+57|0]|y[e+58|0]<<8;CE(y[e+59|0]|y[e+60|0]<<8,f,0);CE(y[e+59|0]|y[e+60|0]<<8,k,1);CE(y[e+59|0]|y[e+60|0]<<8,h,2);r=e,s=wb(x[f>>2]),x[r+32>>2]=s;f=d>>>12|0;d=wb(x[i+52>>2]);while(1){g=x[e+32>>2];if(Ib(g,d)){v[e+28|0]=64;v[e+54|0]=((y[g+2|0]<<6)- -64>>>0)/127;r=g,s=y[Qb(e+28|0,e+54|0)|0],v[r+2|0]=s;We(e+32|0);continue}else{r=e,s=wb(x[k>>2]),x[r+32>>2]=s;d=wb(x[i+72>>2])}break}while(1){g=x[e+32>>2];if(Ib(g,d)){v[e+28|0]=64;v[e+54|0]=((y[g+2|0]<<6)+128>>>0)/255;r=g,s=y[Qb(e+28|0,e+54|0)|0],v[r+2|0]=s;We(e+32|0);continue}break}r=e,s=wb(x[h>>2]),x[r+32>>2]=s;k=f&3;h=wb(x[i+92>>2]);while(1){f=x[e+32>>2];if(Ib(f,h)){g=v[f+2|0];d=g>>31^-1;g=g^-128;i=k&31;if((k&63)>>>0>=32){d=g<<i;i=0}else{d=(1<<i)-1&g>>>32-i|d<<i;i=g<<i}x:{if((d|0)>=-1&i>>>0>=4294967292|(d|0)>=0){g=i+4|0;d=(((g>>>0<4?d+1|0:d)&7)<<29|g>>>3)&536870911;g=0;break x}g=0-((i>>>0>3)+d|0)|0;d=3-i|0;g=((g&7)<<29|d>>>3)&536870911;d=0-g|0;g=0-((g|0)!=0)|0}r=f,s=Gc(d,g)^128,v[r+2|0]=s;We(e+32|0);continue}else{d=z[a+480190>>1]+1|0;w[e+54>>1]=d;f=0;i=d&65535;d=4e3-i|0;k=d>>>0<=4e3?d:0;y:{z:{A:{while(1){if((f|0)==(q|0)){break z}if((f|0)==(k|0)){x[31609]=0;P(183,b|0,20)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break z}b=N()|0;break b}x[31609]=0;h=f+i|0;P(240,b|0,((h<<5)+a|0)+946304|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break y}x[31609]=0;g=e+32|0;O(255,b|0,g|0);d=x[31609];x[31609]=0;B:{if((d|0)==1){break B}x[31609]=0;O(256,g|0,(D(h,104)+a|0)+484380|0);d=x[31609];x[31609]=0;if((d|0)==1){break B}x[31609]=0;w[e+28>>1]=y[e+56|0]|f<<8&32512|((y[e+51|0]&3)!=0)<<15;O(257,m|0,e+28|0);d=x[31609];x[31609]=0;if((d|0)==1){break A}f=f+1|0;continue}break}b=N()|0;break b}b=N()|0;break b}x[31609]=0;O(257,l|0,e+54|0);d=x[31609];x[31609]=0;if((d|0)!=1){x[e+32>>2]=3999;x[e+28>>2]=q+z[a+480190>>1];r=a,s=x[Cd(e+32|0,e+28|0)>>2],w[r+480190>>1]=s;break q}b=N()|0;break b}b=N()|0;break b}}}b=N()|0;break b}g=Fb(e+80|0);x[31609]=0;f=P(230,b|0,g|0)|0;d=x[31609];x[31609]=0;C:{D:{E:{F:{G:{if((d|0)!=1){H:{if(f){x[31609]=0;f=e+32|0;S(258,f|0,21,g|0);d=x[31609];x[31609]=0;if((d|0)==1){break H}zb(a+1298320|0,f);tb(f)}tb(g);f=0;I:{while(1){if((f|0)==32){x[31609]=0;f=P(259,b|0,e+16|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break E}if(!f){break F}g=x[e+16>>2];if(g>>>0<12){break G}f=x[b+8>>2];d=x[b>>2];x[31609]=0;f=U(150,d|0,f|0,g-11|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break E}if(f){break I}break G}d=(f<<5)+a|0;Ue(d+480280|0);x[31609]=0;O(231,b|0,d+480289|0);d=x[31609];x[31609]=0;if((d|0)!=1){f=f+1|0;continue}break}b=N()|0;break b}d=x[e+16>>2]-11|0;x[e+64>>2]=d;i=Nb(e+80|0);x[31609]=0;S(234,b|0,i|0,d|0);d=x[31609];x[31609]=0;J:{if((d|0)!=1){x[e+32>>2]=50529027;d=e+32|0;r=e,s=D(x[Hb(e- -64|0,d)>>2],85),x[r+56>>2]=s;j=Fb(d);x[e>>2]=x[e+20>>2];d=x[Hb(e+56|0,e)>>2];x[31609]=0;O(114,j|0,d|0);d=x[31609];x[31609]=0;K:{if((d|0)==1){break K}f=0;L:{while(1){d=x[e+64>>2];if(d>>>0<=f>>>0){break L}k=x[i>>2];g=v[xb(k,f)|0];h=d;d=f+1|0;if(!((g|0)!=-1|h-d>>>0<2)){h=v[xb(k,d)|0];g=y[xb(k,f+2|0)|0];d=x[vb(e+12|0,Ef(j))>>2];x[31609]=0;V(237,j|0,d|0,g|0,h|0);d=x[31609];x[31609]=0;if((d|0)!=1){f=f+3|0;continue}break K}x[31609]=0;O(115,j|0,g|0);g=x[31609];x[31609]=0;f=d;if((g|0)!=1){continue}break}break K}x[31609]=0;S(235,e|0,21,j|0);d=x[31609];x[31609]=0;if((d|0)!=1){M:{h=zb(j,e);tb(e);g=Kb(h);f=y[h+11|0];d=x[h+4>>2];x[31609]=0;aa(236,a+1298332|0,g|0,_c(d,f)|0,74,0);d=x[31609];x[31609]=0;if((d|0)==1){break M}tb(h);ec(i);break G}}}b=N()|0;tb(j);break J}b=N()|0}ec(i);break b}}b=N()|0;tb(g);break b}f=y[a+484376|0];d=x[a+484360>>2];x[31609]=0;S(238,Xb(d,f)|0,b|0,y[e+258|0]|y[e+259|0]<<8);d=x[31609];x[31609]=0;if((d|0)==1){break E}h=c&1;if(h){x[31609]=0;O(223,a+484344|0,y[e+256|0]|y[e+257|0]<<8);d=x[31609];x[31609]=0;if((d|0)==1){break E}}k=a+484344|0;f=0;while(1){N:{if((y[e+256|0]|y[e+257|0]<<8)>>>0>f>>>0){g=x[b+8>>2];d=x[b>>2];x[31609]=0;g=U(150,d|0,g|0,4)|0;d=x[31609];x[31609]=0;if((d|0)==1){break C}if(g){break N}}if(!(c&2)){break F}f=0;while(1){c=z[a+480190>>1];if(f>>>0>=c>>>0){f=0;while(1){if(c>>>0<=f>>>0){break F}g=z[bc(x[m>>2],f)>>1];b=g&255;O:{if(!b){break O}d=x[l>>2];b=b-1&65535;if($c(d,x[l+4>>2])>>>0<=b>>>0){break O}b=z[bc(d,b)>>1]+(g>>>8&127)&65535;if(b>>>0>c>>>0){break O}c=D(b,104);b=c+a|0;h=b+484380|0;g=x[h>>2];if(!le(g,x[b+484400>>2])){break O}d=a+484380|0;c=d+c|0;b=z[c+34>>1];d=d+D(f+1|0,104)|0;x[d>>2]=g;w[d+34>>1]=z[d+34>>1]&65534|b&1;if(!Gh(d)){break O}zc(x[d+20>>2],x[c+20>>2],Rk(x[h>>2],z[h+34>>1]))}f=f+1|0;c=z[a+480190>>1];continue}}c=z[bc(x[m>>2],f)>>1];if(c&255){f=f+1|0;continue}f=f+1|0;d=D(f,104)+a|0;c=Zc(e+80|0,w[d+484414>>1]&1?16:8,1,0,c<<16>>16<0?6:0);x[31609]=0;U(215,c|0,d+484380|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){continue}break}b=N()|0;break b}x[31609]=0;g=R(151,b|0)|0;d=x[31609];x[31609]=0;P:{Q:{R:{S:{if((d|0)!=1){x[31609]=0;i=e+32|0;S(185,i|0,b|0,g|0);d=x[31609];x[31609]=0;if((d|0)==1){break S}j=hc(e+80|0,i);ub(i);if(!h){break Q}x[31609]=0;g=R(197,j|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break P}x[31609]=0;P(183,j|0,1)|0;d=x[31609];x[31609]=0;if((d|0)==1){break P}x[31609]=0;g=U(196,k|0,f&65535,g+1|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break P}if(!g){break Q}x[31609]=0;g=P(232,j|0,i|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break D}if(!g){break R}d=x[k>>2];x[31609]=0;O(233,Wb(d,f)|0,i|0);d=x[31609];x[31609]=0;if((d|0)!=1){break R}break D}b=N()|0;break b}b=N()|0;break b}d=x[k>>2];x[31609]=0;S(239,Wb(d,f)|0,1,j|0);d=x[31609];x[31609]=0;if((d|0)==1){break D}}ub(j);f=f+1|0;continue}break}break D}od(m);od(l);f=1;break e}b=N()|0;break b}b=N()|0;ub(j);break b}b=N()|0;break b}o=o+1|0;continue}}b=N()|0;break a}b=N()|0;break a}tb(n)}fb=e+272|0;return f|0}b=N()|0;break b}b=N()|0}od(m);od(l)}tb(n);Q(b|0);p()}function wK(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,z=0,A=0,F=0,G=0,H=E(0),I=0;e=fb-144|0;fb=e;d=Rb(e,0,144);x[d+76>>2]=-1;x[d+44>>2]=a;x[d+32>>2]=1251;x[d+84>>2]=a;u=c;a=0;j=fb-304|0;fb=j;a:{b:{if(!x[d+4>>2]){zt(d);if(!x[d+4>>2]){break b}}i=y[b|0];if(!i){break a}c:{d:{e:{f:{g:{while(1){h:{c=i&255;i:{if(hl(c)){while(1){i=b;b=b+1|0;if(hl(y[i+1|0])){continue}break}Ci(d,0,0);while(1){b=x[d+4>>2];j:{if((b|0)!=x[d+104>>2]){x[d+4>>2]=b+1;b=y[b|0];break j}b=td(d)}if(hl(b)){continue}break}b=x[d+4>>2];c=x[d+116>>2];if((c|0)>0){c=1}else{c=(c|0)>=0}if(c){b=b-1|0;x[d+4>>2]=b}b=b-x[d+44>>2]|0;c=b;h=o+x[d+124>>2]|0;e=b>>31;b=m+x[d+120>>2]|0;h=e+(b>>>0<m>>>0?h+1|0:h)|0;m=b+c|0;o=m>>>0<b>>>0?h+1|0:h;break i}k:{l:{m:{if((c|0)==37){c=y[b+1|0];if((c|0)==42){break m}if((c|0)!=37){break l}}Ci(d,0,0);n:{if(y[b|0]==37){while(1){c=x[d+4>>2];o:{if((c|0)!=x[d+104>>2]){x[d+4>>2]=c+1;i=y[c|0];break o}i=td(d)}if(hl(i)){continue}break}b=b+1|0;break n}c=x[d+4>>2];if((c|0)!=x[d+104>>2]){x[d+4>>2]=c+1;i=y[c|0];break n}i=td(d)}if(y[b|0]!=(i|0)){a=x[d+116>>2];if((a|0)>0){a=1}else{a=(a|0)>=0}if(a){x[d+4>>2]=x[d+4>>2]-1}if((i|0)>=0|t){break a}break b}c=x[d+4>>2]-x[d+44>>2]|0;f=c;i=c>>31;c=o+x[d+124>>2]|0;e=m+x[d+120>>2]|0;g=(e>>>0<m>>>0?c+1|0:c)+i|0;m=e+f|0;o=m>>>0<e>>>0?g+1|0:g;i=b;break i}l=0;b=b+2|0;break k}if(!(!Nh(c)|y[b+2|0]!=36)){e=fb-16|0;x[e+12>>2]=u;c=c-48|0;c=c>>>0>1?((c<<2)+u|0)-4|0:u;x[e+8>>2]=c+4;l=x[c>>2];b=b+3|0;break k}l=x[u>>2];u=u+4|0;b=b+1|0}c=0;while(1){f=y[b|0];if(Nh(f)){b=b+1|0;c=(D(c,10)+f|0)-48|0;continue}break}r=0;if((f|0)==109){n=0;r=(l|0)!=0;f=y[b+1|0];b=b+1|0;a=0}i=b+1|0;k=3;g=r;p:{q:{switch((f&255)-65|0){case 39:e=b+2|0;b=y[b+1|0]==104;i=b?e:i;k=b?-2:-1;break p;case 43:e=b+2|0;b=y[b+1|0]==108;i=b?e:i;k=b?3:1;break p;case 51:case 57:k=1;break p;case 11:k=2;break p;case 41:break p;case 0:case 2:case 4:case 5:case 6:case 18:case 23:case 26:case 32:case 34:case 35:case 36:case 37:case 38:case 40:case 45:case 46:case 47:case 50:case 52:case 55:break q;default:break d}}k=0;i=b}b=y[i|0];e=(b&47)==3;z=e?1:k;q=e?b|32:b;r:{if((q|0)==91){break r}s:{if((q|0)!=110){if((q|0)!=99){break s}c=(c|0)<=1?1:c;break r}CI(l,z,m,o);break i}Ci(d,0,0);while(1){b=x[d+4>>2];t:{if((b|0)!=x[d+104>>2]){x[d+4>>2]=b+1;b=y[b|0];break t}b=td(d)}if(hl(b)){continue}break}b=x[d+4>>2];e=x[d+116>>2];if((e|0)>0){e=1}else{e=(e|0)>=0}if(e){b=b-1|0;x[d+4>>2]=b}b=b-x[d+44>>2]|0;e=b;h=o+x[d+124>>2]|0;f=b>>31;b=m+x[d+120>>2]|0;o=f+(b>>>0<m>>>0?h+1|0:h)|0;m=b+e|0;o=m>>>0<b>>>0?o+1|0:o}s=c;p=c>>31;Ci(d,c,p);b=x[d+4>>2];u:{if((b|0)!=x[d+104>>2]){x[d+4>>2]=b+1;break u}if((td(d)|0)<0){break e}}b=x[d+116>>2];if((b|0)>0){b=1}else{b=(b|0)>=0}if(b){x[d+4>>2]=x[d+4>>2]-1}b=16;v:{w:{x:{y:{z:{switch(q-88|0){default:b=q-65|0;if(b>>>0>6|!(1<<b&113)){break v}case 9:case 13:case 14:case 15:BI(j+8|0,d,z,0);b=x[d+4>>2]-x[d+44>>2]|0;if(x[d+120>>2]!=(0-b|0)|x[d+124>>2]!=(0-((b>>31)+((b|0)!=0)|0)|0)){break x}break f;case 3:case 11:case 27:if((q|16)==115){Rb(j+32|0,-1,257);v[j+32|0]=0;if((q|0)!=115){break w}v[j+65|0]=0;v[j+46|0]=0;w[j+42>>1]=0;w[j+44>>1]=0;break w}e=y[i+1|0];f=(e|0)==94;Rb(j+32|0,f,257);v[j+32|0]=0;b=f?i+2|0:i+1|0;A:{B:{C:{f=y[(f?2:1)+i|0];if((f|0)!=45){if((f|0)==93){break C}k=(e|0)!=94;break A}k=(e|0)!=94;v[j+78|0]=k;break B}k=(e|0)!=94;v[j+126|0]=k}b=b+1|0}i=b;while(1){f=y[i|0];D:{if((f|0)!=45){if(!f){break e}if((f|0)==93){break w}break D}f=45;e=y[i+1|0];if(!e|(e|0)==93){break D}h=i+1|0;b=y[i-1|0];E:{if(e>>>0<=b>>>0){f=e;break E}while(1){b=b+1|0;v[b+(j+32|0)|0]=k;f=y[h|0];if(f>>>0>b>>>0){continue}break}}i=h}v[(f+j|0)+33|0]=k;i=i+1|0;continue};case 23:b=8;break y;case 12:case 29:b=10;break y;case 1:case 2:case 4:case 5:case 6:case 7:case 8:case 10:case 16:case 18:case 19:case 20:case 21:case 22:case 25:case 26:case 28:case 30:case 31:break v;case 0:case 24:case 32:break y;case 17:break z}}b=0}e=0;h=0;f=0;g=0;s=0;A=fb-16|0;fb=A;F:{if((b|0)==1){x[31484]=28;break F}while(1){c=x[d+4>>2];G:{if((c|0)!=x[d+104>>2]){x[d+4>>2]=c+1;c=y[c|0];break G}c=td(d)}if(hl(c)){continue}break}H:{I:{switch(c-43|0){case 0:case 2:break I;default:break H}}s=(c|0)==45?-1:0;c=x[d+4>>2];if((c|0)!=x[d+104>>2]){x[d+4>>2]=c+1;c=y[c|0];break H}c=td(d)}J:{K:{L:{M:{if(!((b|0)!=0&(b|0)!=16|(c|0)!=48)){c=x[d+4>>2];N:{if((c|0)!=x[d+104>>2]){x[d+4>>2]=c+1;c=y[c|0];break N}c=td(d)}if((c&-33)==88){b=16;c=x[d+4>>2];O:{if((c|0)!=x[d+104>>2]){x[d+4>>2]=c+1;c=y[c|0];break O}c=td(d)}if(y[c+104561|0]<16){break L}b=x[d+116>>2];if((b|0)>0){b=1}else{b=(b|0)>=0}if(b){x[d+4>>2]=x[d+4>>2]-1}Ci(d,0,0);break F}if(b){break M}b=8;break L}b=b?b:10;if(b>>>0>y[c+104561|0]){break M}b=x[d+116>>2];if((b|0)>0){b=1}else{b=(b|0)>=0}if(b){x[d+4>>2]=x[d+4>>2]-1}Ci(d,0,0);x[31484]=28;break F}if((b|0)!=10){break L}f=c-48|0;if(f>>>0<=9){c=0;while(1){c=D(c,10)+f|0;e=c>>>0<429496729;b=x[d+4>>2];P:{if((b|0)!=x[d+104>>2]){x[d+4>>2]=b+1;b=y[b|0];break P}b=td(d)}f=b-48|0;if(e&f>>>0<=9){continue}break}e=c}if(f>>>0>9){break J}b=Iua(e,0,10,0);k=hb;while(1){h=k;e=b+f|0;h=e>>>0<f>>>0?h+1|0:h;b=(h|0)==429496729&e>>>0<2576980378|h>>>0<429496729;c=x[d+4>>2];Q:{if((c|0)!=x[d+104>>2]){x[d+4>>2]=c+1;c=y[c|0];break Q}c=td(d)}g=c-48|0;if(!(b&g>>>0<=9)){b=10;if(g>>>0<=9){break K}break J}b=Iua(e,h,10,0);k=hb;f=g;if((k|0)==-1&(f^-1)>>>0>=b>>>0|(k|0)!=-1){continue}break}b=10;break K}if(b-1&b){g=y[c+104561|0];if(g>>>0<b>>>0){while(1){f=D(b,f)+g|0;e=f>>>0<119304647;c=x[d+4>>2];R:{if((c|0)!=x[d+104>>2]){x[d+4>>2]=c+1;c=y[c|0];break R}c=td(d)}g=y[c+104561|0];if(e&g>>>0<b>>>0){continue}break}e=f}if(b>>>0<=g>>>0){break K}while(1){f=Iua(e,h,b,0);k=hb;g=g&255;if((k|0)==-1&(g^-1)>>>0<f>>>0){break K}h=k;e=f+g|0;h=e>>>0<g>>>0?h+1|0:h;c=x[d+4>>2];S:{if((c|0)!=x[d+104>>2]){x[d+4>>2]=c+1;c=y[c|0];break S}c=td(d)}g=y[c+104561|0];if(b>>>0<=g>>>0){break K}Nf(A,b,0,0,0,e,h,0,0);if(!(x[A+8>>2]|x[A+12>>2])){continue}break}break K}k=v[(D(b,23)>>>5&7)+104817|0];f=y[c+104561|0];if(f>>>0<b>>>0){while(1){g=g<<k|f;e=g>>>0<134217728;c=x[d+4>>2];T:{if((c|0)!=x[d+104>>2]){x[d+4>>2]=c+1;c=y[c|0];break T}c=td(d)}f=y[c+104561|0];if(e&f>>>0<b>>>0){continue}break}e=g}if(b>>>0<=f>>>0){break K}p=k&31;if((k&63)>>>0>=32){g=0;p=-1>>>p|0}else{g=-1>>>p|0;p=g|(1<<p)-1<<32-p}if(!g&e>>>0>p>>>0){break K}while(1){F=f&255;f=e;c=k&31;if((k&63)>>>0>=32){h=e<<c;c=0}else{h=(1<<c)-1&f>>>32-c|h<<c;c=f<<c}e=F|c;c=x[d+4>>2];U:{if((c|0)!=x[d+104>>2]){x[d+4>>2]=c+1;c=y[c|0];break U}c=td(d)}f=y[c+104561|0];if(b>>>0<=f>>>0){break K}if((h|0)==(g|0)&e>>>0<=p>>>0|h>>>0<g>>>0){continue}break}}if(y[c+104561|0]>=b>>>0){break J}while(1){c=x[d+4>>2];V:{if((c|0)!=x[d+104>>2]){x[d+4>>2]=c+1;c=y[c|0];break V}c=td(d)}if(y[c+104561|0]<b>>>0){continue}break}x[31484]=68;e=-1;h=-1;s=0}b=x[d+116>>2];if((b|0)>0){b=1}else{b=(b|0)>=0}if(b){x[d+4>>2]=x[d+4>>2]-1}b=e^s;e=b-s|0;c=s>>31;h=(c^h)-((b>>>0<s>>>0)+c|0)|0}fb=A+16|0;b=x[d+4>>2]-x[d+44>>2]|0;if(x[d+120>>2]==(0-b|0)&x[d+124>>2]==(0-((b>>31)+((b|0)!=0)|0)|0)){break f}if(!(!l|(q|0)!=112)){x[l>>2]=e;break v}CI(l,z,e,h);break v}if(!l){break v}b=x[j+16>>2];e=x[j+20>>2];c=x[j+8>>2];f=x[j+12>>2];W:{switch(z|0){case 0:G=l,H=XG(c,f,b,e),B[G>>2]=H;break v;case 1:G=l,I=Ex(c,f,b,e),C[G>>3]=I;break v;case 2:break W;default:break v}}x[l>>2]=c;x[l+4>>2]=f;x[l+8>>2]=b;x[l+12>>2]=e;break v}h=(q|0)!=99;c=h?31:c+1|0;X:{if((z|0)==1){f=l;if(r){f=Gd(c<<2);if(!f){break g}}x[j+296>>2]=0;x[j+300>>2]=0;b=0;while(1){a=f;Y:{while(1){e=x[d+4>>2];Z:{if((e|0)!=x[d+104>>2]){x[d+4>>2]=e+1;e=y[e|0];break Z}e=td(d)}if(!y[(e+j|0)+33|0]){break Y}v[j+27|0]=e;e=eq(j+28|0,j+27|0,1,j+296|0);if((e|0)==-2){continue}if((e|0)==-1){n=0;break e}if(a){x[(b<<2)+a>>2]=x[j+28>>2];b=b+1|0}if(!r|(b|0)!=(c|0)){continue}break}g=1;n=0;b=c;c=b<<1|1;f=Qv(a,c<<2);if(f){continue}break d}break}n=0;c=a;e=j+296|0;if(e){e=x[e>>2]}else{e=0}if(e){break e}break X}if(r){b=0;f=Gd(c);if(!f){break g}while(1){a=f;while(1){e=x[d+4>>2];_:{if((e|0)!=x[d+104>>2]){x[d+4>>2]=e+1;e=y[e|0];break _}e=td(d)}if(!y[(e+j|0)+33|0]){c=0;n=a;break X}v[a+b|0]=e;b=b+1|0;if((c|0)!=(b|0)){continue}break}g=1;b=c;c=b<<1|1;f=Qv(a,c);if(f){continue}break}n=a;a=0;break d}b=0;if(l){while(1){a=x[d+4>>2];$:{if((a|0)!=x[d+104>>2]){x[d+4>>2]=a+1;a=y[a|0];break $}a=td(d)}if(y[(a+j|0)+33|0]){v[b+l|0]=a;b=b+1|0;continue}else{c=0;a=l;n=a;break X}}}while(1){a=x[d+4>>2];aa:{if((a|0)!=x[d+104>>2]){x[d+4>>2]=a+1;a=y[a|0];break aa}a=td(d)}if(y[(a+j|0)+33|0]){continue}break}a=0;n=0;c=0}f=x[d+4>>2];e=x[d+116>>2];if((e|0)>0){e=1}else{e=(e|0)>=0}if(e){f=f-1|0;x[d+4>>2]=f}f=f-x[d+44>>2]|0;e=f+x[d+120>>2]|0;g=x[d+124>>2]+(f>>31)|0;g=e>>>0<f>>>0?g+1|0:g;if(!(g|e)|!(h|(e|0)==(s|0)&(g|0)==(p|0))){break h}if(r){x[l>>2]=a}ba:{if((q|0)==99){break ba}if(c){x[(b<<2)+c>>2]=0}if(!n){n=0;break ba}v[b+n|0]=0}a=c}b=x[d+4>>2]-x[d+44>>2]|0;e=b;c=o+x[d+124>>2]|0;f=b>>31;b=m+x[d+120>>2]|0;h=f+(b>>>0<m>>>0?c+1|0:c)|0;m=b+e|0;o=m>>>0<b>>>0?h+1|0:h;t=((l|0)!=0)+t|0}b=i+1|0;i=y[i+1|0];if(i){continue}break a}break}a=c;break f}g=1;n=0;a=0;break d}g=r;break c}g=r}t=t?t:-1}if(!g){break a}Db(n);Db(a);break a}t=-1}fb=j+304|0;fb=d+144|0;return t}function qoa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=fb-192|0;fb=j;if(!qv(a)){e=j+40|0;iW(e,a);f=j+168|0;bf(f,e,128,2);e=j+180|0;Cc(e,f);Ac(b+492|0,e);tb(e)}w[c+34>>1]=z[c+34>>1]&65489;o=j+180|0;g=fb-32|0;fb=g;a:{b:{switch(y[a+128|0]-4|0){default:x[g+28>>2]=0;rn(o,0,g+28|0);break a;case 0:case 4:break b}}v[g+28|0]=y[a+129|0];v[g+24|0]=100;k=g+24|0;e=y[Qb(g+28|0,k)|0];v[g+24|0]=y[a+130|0];v[g+20|0]=100;l=g+20|0;m=y[Qb(k,l)|0];x[g+28>>2]=m;c:{if(y[a+140|0]&16){i=Bb(y[a+150|0]|y[a+151|0]<<8);h=Bb(y[a+152|0]|y[a+153|0]<<8);f=x[c>>2];s=+(f>>>0)/6553600;e=ur(s*+((i|e<<16)>>>0));x[g+24>>2]=f-e;t=g,u=ur(s*+((h|m<<16)>>>0)),x[t+20>>2]=u;t=g,u=x[Hb(k,l)>>2],x[t+28>>2]=u;break c}i=x[c>>2];l=x[c+20>>2];if(!le(i,l)){break c}f=i>>>7|0;e=D(f,(e<<7>>>0)/100|0);x[g+24>>2]=i-e;x[g+20>>2]=D(f,(m<<7>>>0)/100|0);f=x[Hb(g+24|0,g+20|0)>>2];h=z[c+34>>1];i=D(_d(h),i);d:{if(h&1){cc(g+12|0,l,i);l=x[g+12>>2];i=_d(z[c+34>>1]);h=l+(D(i,e+f|0)<<1)|0;m=w[l+(D(e,i)<<1)>>1];l=0-i<<1;while(1){e:{f:{if(f){i=w[h>>1]-m|0;k=i>>31;if((i^k)-k>>>0>=1536){break f}}else{f=0}break e}f=f-1|0;h=h+l|0;continue}break}break d}cc(g+4|0,l,i);l=x[g+4>>2];i=_d(z[c+34>>1]);m=0-i|0;h=l+D(i,e+f|0)|0;l=v[l+D(e,i)|0];while(1){g:{h:{if(f){i=v[h|0]-l|0;k=i>>31;if((i^k)-k>>>0>=6){break h}}else{f=0}break g}f=f-1|0;h=h+m|0;continue}break}}x[g+28>>2]=f}rn(o,e,g+28|0)}fb=g+32|0;r=gc(o);if(!(!x[r>>2]|y[a+128|0]!=4)){w[c+34>>1]=z[c+34>>1]|2;f=x[j+180>>2];x[c+4>>2]=f;x[c+8>>2]=f+x[r>>2]}f=j;e=y[a+134|0];if((e-1&255)>>>0<=198){v[f+40|0]=e;v[f+168|0]=100;e=(y[Qb(f+40|0,f+168|0)|0]<<7>>>0)/100|0}else{e=128}v[f+39|0]=e;v[j+40|0]=64;e=j+39|0;f=j+40|0;t=c,u=y[cf(e,f)|0]>>>1|0,w[t+32>>1]=u;v[j+40|0]=64;t=b,u=y[Qb(e,f)|0],x[t+4>>2]=u;x[c+24>>2]=40460;$l(c,+v[a+139|0]/12+ +(0-y[a+143|0]|0)+ +v[a+138|0]/1536);v[b+34|0]=y[a+142|0]&2?2:1;if(y[a+142|0]&2){dk(b,127,1);ck(b,0,1)}i:{if(!le(x[c>>2],x[c+20>>2])){break i}b=y[a+140|0];if(b&1){b=x[c>>2];g=x[c+20>>2];j:{if(!le(b,g)|b>>>0<2){break j}k:{l:{switch(_k(z[c+34>>1])-1|0){case 3:e=b>>>1|0;b=g+(b<<2)|0;f=0;while(1){if((e|0)!=(f|0)){Tb(g+(f<<2)|0,b+((f^-1)<<2)|0);f=f+1|0;continue}break};break k;case 1:e=b>>>1|0;b=g+(b<<1)|0;f=0;while(1){if((e|0)!=(f|0)){MR(g+(f<<1)|0,b+((f^-1)<<1)|0);f=f+1|0;continue}break};break k;case 0:break l;default:break j}}e=b+g|0;b=b>>>1|0;f=0;while(1){if((b|0)!=(f|0)){rg(f+g|0,e+(f^-1)|0);f=f+1|0;continue}break}}Jj(c,d)}b=y[a+140|0]}if(b&4){m:{f=x[c>>2];g=x[c+20>>2];if(!le(f,g)){break m}b=z[c+34>>1];f=D(_d(b),f);n:{o:{switch(Kn(b)-1|0){case 1:e=0;while(1){if((e|0)!=(f|0)){b=g+(e<<1)|0;w[b>>1]=z[b>>1]^-1;e=e+1|0;continue}break};break n;case 0:break o;default:break m}}e=0;while(1){if((e|0)!=(f|0)){b=e+g|0;v[b|0]=y[b|0]^-1;e=e+1|0;continue}break}}Jj(c,d)}}p=y[a+170|0]!=2|y[a+171|0]>100?p:y[a+172|0]<101;b=z[c+34>>1];if(!(!(p|y[a+160|0]!=0|y[a+141|0])|b&1)){f=pv(x[c>>2],_d(b)<<1&254);if(!f){break i}b=f;h=x[c>>2];e=z[c+34>>1];g=D(_d(e),h);k=x[c+20>>2];e=Rk(h,e);i=fb-16|0;fb=i;x[i+12>>2]=g;xc(i+12|0,e);h=x[i+12>>2];while(1){if(h){w[b>>1]=v[k|0]<<8;k=k+1|0;b=b+2|0;h=h-1|0;continue}break}fb=i+16|0;w[c+34>>1]=z[c+34>>1]|1;gW(c,f,x[c>>2],d);b=z[c+34>>1]}f=x[c>>2];e=x[c+20>>2];p:{if(v[a+141|0]>=0){break p}cc(j+40|0,e,D(_d(b),f));q:while(1){if((0-v[a+141|0]|0)<=(q|0)){f=x[c>>2];e=x[c+20>>2];b=z[c+34>>1];break p}b=x[j+40>>2];f=w[b>>1];t=j,u=wb(b),x[t+168>>2]=u;b=hn(x[j+40>>2],x[j+44>>2]);while(1){e=x[j+168>>2];if(Ib(e,b)){f=rd(w[e>>1]-rd(f,1)|0,1);w[e>>1]=f;ge(j+168|0);continue}else{q=q+1|0;continue q}}}}if(p){cc(j+40|0,e,D(_d(b),f));h=x[j+44>>2];b=(h|0)/2|0;e=b;f=e>>31;b=y[a+172|0];i=y[a+171|0];g=b-i|0;k=0-(b>>>0<i>>>0)<<24|g>>>8;b=g<<24;e=b+e|0;f=f+k|0;b=Gc(Jua(e,b>>>0>e>>>0?f+1|0:f,h,h>>31),hb);t=j,u=wb(x[j+40>>2]),x[t+168>>2]=u;g=b;l=b>>31;b=i<<24;f=b>>31;i=hn(x[j+40>>2],x[j+44>>2]);while(1){e=x[j+168>>2];if(Ib(e,i)){h=w[e>>1];h=Iua(b,f,h,h>>31);k=hb;h=h+838860800|0;k=h>>>0<838860800?k+1|0:k;t=e,u=Gc(Jua(h,k,1677721600,0),hb),w[t>>1]=u;f=f+l|0;b=b+g|0;f=b>>>0<g>>>0?f+1|0:f;ge(j+168|0);continue}break}f=x[c>>2];e=x[c+20>>2];b=z[c+34>>1]}if(y[a+160|0]){cc(j+168|0,e,D(_d(b),f));m=y[a+163|0];l=y[a+162|0];f=0;k=0;if(y[a+161|0]>=2){i=x[j+172>>2];b=(i|0)/2|0;h=b;g=b>>31;b=y[a+164|0];e=0-(b>>>0<l>>>0)|0;b=b-l|0;k=e<<23|b>>>9;b=b<<23;e=b+h|0;k=g+k|0;n=Gc(Jua(e,b>>>0>e>>>0?k+1|0:k,i,i>>31),hb);i=x[j+172>>2];b=(i|0)/2|0;h=b;g=b>>31;b=y[a+165|0];e=0-(b>>>0<m>>>0)|0;b=b-m|0;k=e<<23|b>>>9;b=b<<23;e=b+h|0;g=g+k|0;k=Gc(Jua(e,b>>>0>e>>>0?g+1|0:g,i,i>>31),hb)}e=m<<23;q=l<<23;g=y[a+160|0];b=wb(x[j+168>>2]);x[j+32>>2]=b;i=(j+40|0)+((g&2)<<2)|0;h=hn(x[j+168>>2],x[j+172>>2]);p=0;while(1){if(Ib(b,h)){g=(w[b>>1]>>1)-p|0;x[j+48>>2]=g;m=g;g=(q|0)/8388608|0;f=rd(D(m,g),8)+f|0;x[j+44>>2]=f;g=rd(D(f,g),6)+p|0;p=rd(rd(D(g,(e|0)/8388608|0),6)+g|0,2);x[j+40>>2]=p;t=b,u=gd(x[i>>2]),w[t>>1]=u;e=e+k|0;q=n+q|0;b=x[ge(j+32|0)>>2];continue}else{f=x[c>>2];e=x[c+20>>2];b=z[c+34>>1]}break}}r:{if(v[a+141|0]<=0){break r}cc(j+40|0,e,D(_d(b),f));q=0;s:while(1){if(v[a+141|0]<=(q|0)){f=x[c>>2];e=x[c+20>>2];b=z[c+34>>1];break r}b=x[j+40>>2];f=w[b>>1];t=j,u=wb(b),x[t+168>>2]=u;b=hn(x[j+40>>2],x[j+44>>2]);while(1){e=x[j+168>>2];if(Ib(e,b)){f=((w[e>>1]<<1)+f|0)/3|0;w[e>>1]=f;ge(j+168|0);continue}else{q=q+1|0;continue s}}}}f=D(_d(b),f);t:{if(b&1){cc(j+24|0,e,f);m=x[j+28>>2];b=fb-16|0;fb=b;k=x[j+24>>2];e=wb(k);q=hn(k,m);p=fb-16|0;fb=p;v[p+14|0]=0;o=fb-16|0;fb=o;x[o+12>>2]=e;Zb(o+4|0,p+15|0,p+14|0);l=b+8|0;f=o+12|0;h=rn(l,e,f);u:{if(mc(e,q)){break u}n=ge(f);g=x[n>>2];if(mc(g,q)){break u}e=x[h>>2];f=Sl(g,e);x[(f?0:4)+h>>2]=g;f=f?g:e;i=h+4|0;while(1){g=ge(n);e=x[g>>2];if(!Ib(e,q)){break u}g=x[ge(g)>>2];if(mc(g,q)){if(!Sl(e,f)){h=i;if(Sl(e,x[i>>2])){break u}}x[h>>2]=e;break u}v:{if(Sl(g,e)){if(Sl(g,f)){x[h>>2]=g;f=g}if(Sl(e,x[i>>2])){continue}break v}if(Sl(e,f)){x[h>>2]=e;f=e}e=g;if(Sl(e,x[i>>2])){continue}}x[i>>2]=e;continue}}fb=o+16|0;fb=p+16|0;x[b+4>>2]=0-w[x[b+8>>2]>>1];t=b,u=w[x[gc(l)>>2]>>1],x[t>>2]=u;w:{g=x[Xe(b+4|0,b)>>2];if((g|0)>32766|!g){break w}e=wb(k);x[b+4>>2]=e;f=hn(k,m);while(1){if(!Ib(e,f)){break w}w[e>>1]=(D(w[e>>1],32767)|0)/(g|0);e=x[ge(b+4|0)>>2];continue}}break t}cc(j+16|0,e,f);m=x[j+20>>2];b=fb-16|0;fb=b;k=x[j+16>>2];e=wb(k);q=Zj(k,m);p=fb-16|0;fb=p;v[p+14|0]=0;o=fb-16|0;fb=o;x[o+12>>2]=e;Zb(o+4|0,p+15|0,p+14|0);l=b+8|0;f=o+12|0;h=rn(l,e,f);x:{if(mc(e,q)){break x}n=we(f);g=x[n>>2];if(mc(g,q)){break x}e=x[h>>2];f=Tl(g,e);x[(f?0:4)+h>>2]=g;f=f?g:e;i=h+4|0;while(1){g=we(n);e=x[g>>2];if(!Ib(e,q)){break x}g=x[we(g)>>2];if(mc(g,q)){if(!Tl(e,f)){h=i;if(Tl(e,x[i>>2])){break x}}x[h>>2]=e;break x}y:{if(Tl(g,e)){if(Tl(g,f)){x[h>>2]=g;f=g}if(Tl(e,x[i>>2])){continue}break y}if(Tl(e,f)){x[h>>2]=e;f=e}e=g;if(Tl(e,x[i>>2])){continue}}x[i>>2]=e;continue}}fb=o+16|0;fb=p+16|0;x[b+4>>2]=0-v[x[b+8>>2]];t=b,u=v[x[gc(l)>>2]],x[t>>2]=u;z:{g=x[Xe(b+4|0,b)>>2];if((g|0)>126|!g){break z}e=wb(k);x[b+4>>2]=e;f=Zj(k,m);while(1){if(!Ib(e,f)){break z}v[e|0]=(D(v[e|0],127)|0)/(g|0);e=x[we(b+4|0)>>2];continue}}}fb=b+16|0;A:{if((y[a+134|0]-101&255)>>>0>98){break A}b=z[c+34>>1];f=D(x[c>>2],_d(b));e=x[c+20>>2];if(b&1){x[j+8>>2]=e;x[j+12>>2]=(e+(f<<1)|0)-e>>1;g=x[j+12>>2];f=y[a+134|0];h=fb-16|0;fb=h;b=x[j+8>>2];e=wb(b);x[h+12>>2]=e;n=(3276800-(f<<14)|0)/100|0;f=0-n|0;i=32768-n|0;b=hn(b,g);while(1){if(Ib(e,b)){g=w[e>>1];B:{if((g|0)>(n|0)){m=i+((D(n,g-n|0)|0)/(i|0)|0)|0;break B}m=((D(n,g+n|0)|0)/(i|0)|0)-i|0;if((f|0)>(g|0)){break B}m=(D(g,i)|0)/(n|0)|0}t=e,u=gd(m),w[t>>1]=u;e=x[ge(h+12|0)>>2];continue}break}fb=h+16|0;break A}b=xl(j,e,e+f|0);h=x[b>>2];g=x[b+4>>2];b=y[a+134|0];i=fb-16|0;fb=i;e=wb(h);x[i+12>>2]=e;l=(3276800-(b<<14)|0)/100|0;f=0-l|0;n=32768-l|0;b=Zj(h,g);while(1){if(Ib(e,b)){g=v[e|0]<<8;C:{if((g|0)>(l|0)){h=n+((D(l,g-l|0)|0)/(n|0)|0)|0;break C}h=((D(l,g+l|0)|0)/(n|0)|0)-n|0;if((f|0)>(g|0)){break C}h=(D(g,n)|0)/(l|0)|0}t=e,u=lY((h|0)/256|0),v[t|0]=u;e=x[we(i+12|0)>>2];continue}break}fb=i+16|0}fW(c);if(y[a+128|0]!=8){break i}f=y[a+131|0];if(!f){break i}b=x[r>>2];if(!b){break i}t=yb(c+68|0,0),u=x[j+180>>2]+D(b,f+1|0)|0,x[t>>2]=u;h=x[j+180>>2];x[c+12>>2]=h;x[c+16>>2]=h+x[r>>2];e=x[r>>2];g=y[a+131|0];if(e>>>0>268435456/(g>>>0)>>>0){break i}b=x[c>>2];f=D(e,g);if(b>>>0>268435456-f>>>0){break i}k=b+f|0;o=_k(z[c+34>>1]);b=pv(k,o);if(!b){break i}l=h+D(e,g+1|0)|0;x[c>>2]=k;n=x[c+20>>2];i=x[r>>2];h=x[j+180>>2];g=D(o,i+h|0);m=zc(b,n,g);e=D(i,o);f=n+D(h,o)|0;a=y[a+131|0];b=0;while(1){if((a|0)==(b|0)){zc(m+D(l,o)|0,g+n|0,D(o,k-l|0));gW(c,m,k,d)}else{b=b+1|0;zc(m+D(o,h+D(i,b)|0)|0,f,e);continue}break}}fb=j+192|0}function Ija(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;d=fb-720|0;fb=d;yc(b);a:{b:{c:{d:{if(!wi(b,d+712|0)){break d}if(!zR(x[d+712>>2],x[d+716>>2])){break d}if(!Or(b,d+708|0)){break d}f=x[d+708>>2];if(!yR(f)){break d}if((f|0)==1179012417){f=0}else{if((f|0)!=538987841){break d}f=1}e=f?2:1;g=f?1414090313:1313423693;n=Ie(d+688|0,b);k=Nb(d+676|0);e:{f:{g:{h:{i:{j:{k:{if((c|0)==64){x[31609]=0;b=d+112|0;V(894,b|0,n|0,e|0,g|0);e=x[31609];x[31609]=0;if((e|0)!=1){break k}a=N()|0;break a}x[31609]=0;b=d+112|0;S(895,b|0,n|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break j}}Cv(k,b);ke(b);x[31609]=0;b=d+656|0;S(896,b|0,k|0,g|0);e=x[31609];x[31609]=0;if((e|0)!=1){x[31609]=0;g=R(172,x[d+656>>2])|0;e=x[31609];x[31609]=0;if((e|0)==1){break i}e=0;if(!g){break e}x[31609]=0;j=d+583|0;b=P(897,b|0,j|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break i}if(!b){break e}b=y[d+648|0];if(!b){break e}x[31609]=0;e=U(150,x[d+656>>2],x[d+664>>2],b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break i}if(!((c|0)!=64&e)){break e}x[31609]=0;O(246,a|0,8388608);b=x[31609];x[31609]=0;if((b|0)==1){break i}x[a+480208>>2]=y[d+647|0]<<4&16^28;w[d+112>>1]=y[d+648|0];w[d+464>>1]=127;b=d+112|0;e=d+464|0;o=a,q=z[Oc(b,e)>>1],w[o+480188>>1]=q;x[a+480196>>2]=y[d+649|0];x[a+480204>>2]=D(y[d+650|0],1e4);x[a+480200>>2]=y[d+655|0]<<1;x[31609]=0;O(130,a+1298344|0,(f?16971:17005)|0);g=x[31609];x[31609]=0;if((g|0)==1){break i}x[31609]=0;g=P(1,d+568|0,13334)|0;m=x[31609];x[31609]=0;if((m|0)==1){break g}zb(a+1298356|0,g);tb(g);o=a+1298404|0,q=x[Fc(b,4)>>2],x[o>>2]=q;KC(e,2,j);x[31609]=0;O(218,b|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break h}zb(a+1298308|0,b);tb(b);b=0;while(1){l:{m:{n:{if(z[a+480188>>1]<=b>>>0){b=wb(x[k>>2]);g=wb(x[k+4>>2]);e=fb-16|0;fb=e;x[e+12>>2]=b;while(1){o:{if(!Ib(b,g)){break o}if(C$(1380209231,x[b>>2],x[b+4>>2])){break o}b=x[em(e+12|0)>>2];continue}break}fb=e+16|0;if(Ib(b,wb(x[k+4>>2]))){break n}break f}g=(b<<5)+a|0;j=g+480280|0;Ue(j);x[31609]=0;e=R(197,d+656|0)|0;m=x[31609];x[31609]=0;p:{q:{if((m|0)!=1){if(!f){break p}if(e>>>0<129){break q}break m}a=N()|0;break b}w[g+480284>>1]=e<<1;break l}if(e<<24>>24<0){break m}x[d+112>>2]=e<<2;x[d+464>>2]=256;o=g+480284|0,q=x[Cd(d+112|0,d+464|0)>>2],w[o>>1]=q;break l}x[31609]=0;b=d+112|0;S(896,b|0,k|0,1380209231);e=x[31609];x[31609]=0;r:{if((e|0)!=1){x[31609]=0;e=R(197,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break r}g=y[a+484376|0];j=x[a+484360>>2];x[31609]=0;aa(348,Xb(j,g)|0,b|0,e+1&255,255,254);e=x[31609];x[31609]=0;if((e|0)==1){break r}ub(b);break f}a=N()|0;break b}a=N()|0;ub(d+112|0);break b}x[j>>2]=1024}b=b+1|0;continue}}a=N()|0;break a}a=N()|0;break a}a=N()|0;break b}a=N()|0;break b}a=N()|0;break b}s:{if(!(c&1)){break s}w[d+48>>1]=0;x[31609]=0;S(898,d+528|0,k|0,1414807888);b=x[31609];x[31609]=0;if((b|0)==1){break c}b=x[d+532>>2];e=x[d+528>>2];x[31609]=0;j=a+484344|0;O(223,j|0,Sf(e,b)&65535);b=x[31609];x[31609]=0;t:{if((b|0)!=1){o=d,q=wb(x[d+528>>2]),x[o+76>>2]=q;m=wb(x[d+532>>2]);u:{v:{w:{x:{y:{while(1){b=x[d+76>>2];if(!Ib(b,m)){b=0;break u}b=Ie(d+112|0,b);x[31609]=0;e=R(197,b|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){x[31609]=0;w[d+452>>1]=e;e=R(151,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break y}x[31609]=0;g=d+464|0;S(185,g|0,b|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break x}e=hc(d+548|0,g);x[31609]=0;i=x[e+12>>2];x[d+8>>2]=x[e+8>>2];x[d+12>>2]=i;x[d+16>>2]=x[e+16>>2];i=x[e+4>>2];x[d>>2]=x[e>>2];x[d+4>>2]=i;V(899,d|0,z[d+452>>1],f|0,a|0);e=x[31609];x[31609]=0;if((e|0)==1){break w}ub(g);o=d,q=z[qe(d+48|0,d+452|0)>>1],w[o+48>>1]=q;ub(b);Qf(d+76|0);continue}break}a=N()|0;break v}a=N()|0;break v}a=N()|0;break v}a=N()|0;ub(d+464|0)}ub(b);break t}while(1){e=b&65535;if(e>>>0>=z[d+48>>1]){Rc(d+528|0);break s}z:{if(!Je(x[a+484344>>2],x[a+484348>>2],e)){x[31609]=0;U(196,j|0,e|0,64)|0;e=x[31609];x[31609]=0;if((e|0)==1){break z}}b=b+1|0;continue}break}a=N()|0;break t}a=N()|0}Rc(d+528|0);break b}A:{B:{C:{if(!f){x[31609]=0;S(898,d+76|0,k|0,1414745673);b=x[31609];x[31609]=0;if((b|0)==1){break B}o=d,q=wb(x[d+76>>2]),x[o+100>>2]=q;g=c&2;j=d+472|0;m=wb(x[d+80>>2]);while(1){b=x[d+100>>2];if(!Ib(b,m)){Rc(d+76|0);break A}c=Ie(d+528|0,b);x[31609]=0;e=d+112|0;b=P(900,c|0,e|0)|0;f=x[31609];x[31609]=0;if((f|0)!=1){D:{if(!b){break D}b=y[d+113|0];if((b|0)==255){break D}x[31609]=0;f=U(251,a|0,b+1|0,0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break C}if(!f){break D}i=z[a+480190>>1];b=0;x[31609]=0;S(901,e|0,f|0,i|0);f=x[31609];x[31609]=0;if((f|0)==1){break C}while(1){if(y[d+142|0]<=b>>>0){break D}E:{if(!pi(z[a+480190>>1])){break E}x[31609]=0;e=d+464|0;f=P(902,c|0,e|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break C}if(!f){break E}i=z[a+480190>>1]+1|0;w[a+480190>>1]=i;if(x[d+464>>2]!=1347240275){break E}h=d+452|0;Xi(h,2,j);x[31609]=0;f=d+48|0;O(218,f|0,h|0);h=x[31609];x[31609]=0;F:{if((h|0)!=1){i=i&65535;Ac(((i<<5)+a|0)+946304|0,f);tb(f);x[31609]=0;h=e;e=(D(i,104)+a|0)+484380|0;S(903,h|0,d+112|0,e|0);i=x[31609];x[31609]=0;if((i|0)==1){break C}if(!g){break F}xR(f,z[d+502>>1]);x[31609]=0;U(215,f|0,e|0,c|0)|0;f=x[31609];x[31609]=0;if((f|0)!=1){break E}break C}break C}f=z[e+34>>1];e=x[e>>2];x[31609]=0;P(183,c|0,Rk(e,f)|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break C}}b=b+1|0;continue}}ub(c);Qf(d+100|0);continue}break}break C}x[31609]=0;S(898,d+452|0,k|0,1179011410);b=x[31609];x[31609]=0;if((b|0)!=1){o=d,q=wb(x[d+452>>2]),x[o+448>>2]=q;g=c&2;j=d+468|0;m=wb(x[d+456>>2]);G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{while(1){b=x[d+448>>2];if(!Ib(b,m)){Rc(d+452|0);break A}c=Ie(d+528|0,b);x[31609]=0;b=R(151,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break P}Q:{R:{if((b|0)!=538986817){break R}x[31609]=0;b=P(904,c|0,d+440|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break O}if(!(x[d+440>>2]==1414745673&b)){break R}x[31609]=0;f=d+112|0;b=P(905,c|0,f|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break N}if(!b){break R}b=y[d+117|0];if((b|0)==255){break R}x[31609]=0;b=U(251,a|0,b+1|0,0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break M}if(!b){break R}e=z[a+480190>>1];x[31609]=0;S(906,f|0,b|0,e|0);b=x[31609];x[31609]=0;if((b|0)==1){break M}x[31609]=0;b=d+464|0;S(895,b|0,c|0,2);f=x[31609];x[31609]=0;if((f|0)==1){break Q}x[31609]=0;S(898,d+100|0,b|0,1179011410);f=x[31609];x[31609]=0;if((f|0)==1){break L}ke(b);o=d,q=wb(x[d+100>>2]),x[o+96>>2]=q;i=wb(x[d+104>>2]);S:{T:{while(1){b=x[d+96>>2];if(!Ib(b,i)){break S}b=Ie(d+76|0,b);x[31609]=0;f=R(151,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break K}U:{V:{if((f|0)!=538989377){break V}f=z[a+480190>>1];if(!pi(f)){break V}e=y[d+436|0]|y[d+437|0]<<8;h=e-1|0;v[d+436|0]=h;v[d+437|0]=h>>>8;if(!e){ub(b);break S}h=f+1|0;w[a+480190>>1]=h;x[31609]=0;f=P(904,b|0,d+68|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break J}if(!(x[d+68>>2]==1347240275&f)){break T}x[31609]=0;e=d+464|0;S(185,e|0,b|0,x[d+72>>2]);f=x[31609];x[31609]=0;W:{if((f|0)!=1){f=hc(d+48|0,e);ub(e);x[31609]=0;e=P(907,f|0,e|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break U}if(e){break W}ub(f);ub(b);break S}a=N()|0;break H}l=d+24|0;Te(l,2,j);x[31609]=0;e=d+36|0;O(218,e|0,l|0);l=x[31609];x[31609]=0;if((l|0)==1){break I}h=h&65535;Ac(((h<<5)+a|0)+946304|0,e);tb(e);x[31609]=0;h=(D(h,104)+a|0)+484380|0;S(908,d+464|0,d+112|0,h|0);l=x[31609];x[31609]=0;if((l|0)==1){break U}X:{if(!g){break X}x[31609]=0;P(149,f|0,x[d+464>>2]+4|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break U}xR(e,z[d+504>>1]);x[31609]=0;U(215,e|0,h|0,f|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break X}break I}ub(f)}ub(b);Qf(d+96|0);continue}break}break I}ub(b)}Rc(d+100|0)}ub(c);Qf(d+448|0);continue}break}a=N()|0;break G}a=N()|0;break G}a=N()|0;break G}a=N()|0;break G}a=N()|0;break G}a=N()|0;ke(d+464|0);break G}a=N()|0;break H}a=N()|0;break H}a=N()|0;ub(f)}ub(b);Rc(d+100|0)}ub(c);Rc(d+452|0);break b}a=N()|0;break b}a=N()|0;ub(c);Rc(d+76|0);break b}a=N()|0;break b}e=1}ub(d+656|0);ke(k);ub(n)}fb=d+720|0;return e|0}a=N()|0}ub(d+656|0)}ke(k);ub(n);Q(a|0);p()}function m1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,A=0,B=0;e=fb-208|0;fb=e;yc(b);d=e+204|0;a:{if(!Or(b,d)){break a}x[e+184>>2]=0;x[e+188>>2]=0;x[e+176>>2]=0;x[e+180>>2]=0;x[e+168>>2]=0;x[e+172>>2]=0;x[e+160>>2]=0;x[e+164>>2]=0;b:{c:{if(!eF(d)){break c}if(!Mb(x[b>>2],x[b+8>>2],32)){break c}Gw(b,e+160|0);break b}m=1;if(!dF(e+204|0)){break a}}j=e+155|0;f=cF(y[e+207|0]);d=fb-32|0;fb=d;x[d+28>>2]=f;x[d+8>>2]=5;g=x[b>>2];h=x[b+8>>2];f=x[Hb(d+28|0,d+8|0)>>2];if(!Mb(g,h,f)){f=jf(b)}l=d+8|0;$j(l,j);k=Zb(d+16|0,x[d+8>>2],f);h=x[k>>2];lc(d,x[b>>2],x[b+8>>2],h,x[k+4>>2]);$j(l,j);Rb(x[d+8>>2]+f|0,0,5-f|0);Vb(b,x[d+28>>2]);fb=d+32|0;if(!f){break a}if(!bF(j,y[e+207|0])){break a}n=1;if((c|0)==64){break a}j=e+207|0;Dd(a,2048);eg(a);d:{e:{f:{g:{h:{i:{j:{k:{if(m){d=fb-16|0;fb=d;f=e+4|0;l=uc(d+4|0,3893);Uc(f,l);tb(l);fb=d+16|0;x[31609]=0;d=e+72|0;S(209,d|0,f|0,j|0);j=x[31609];x[31609]=0;if((j|0)==1){break j}zb(a+1298344|0,d);tb(d);Eb(f);f=uc(d,11160);zb(a+1298356|0,f);break k}f=e+4|0;Te(f,2,e+160|0);d=e+72|0;Cc(d,f);zb(a+1298308|0,d);tb(d);l=fb-16|0;fb=l;k=uc(l+4|0,3944);Uc(f,k);tb(k);fb=l+16|0;x[31609]=0;S(209,d|0,f|0,j|0);j=x[31609];x[31609]=0;if((j|0)==1){break i}zb(a+1298344|0,d);tb(d);Eb(f);f=uc(d,11164);zb(a+1298356|0,f)}tb(f);A=a+1298404|0,B=x[Fc(e+72|0,4)>>2],x[A>>2]=B;w[a+480188>>1]=y[e+159|0];w[a+480190>>1]=y[e+155|0];l:{f=y[e+207|0];if(f>>>0>8){break l}w[a+480188>>1]=4;d=0;while(1){if((d|0)==4){break l}w[((d<<5)+a|0)+480284>>1]=d&1?192:64;d=d+1|0;continue}}m:{if(f>>>0>=11){f=(f|0)==11?16:32;d=0;while(1){if((d|0)==(f|0)){break m}j=Qw(b);n:{if((j|0)==100){x[((d<<5)+a|0)+480280>>2]=256;break n}x[e+72>>2]=(j<<1)+128;x[e+4>>2]=0;x[e+140>>2]=256;A=((d<<5)+a|0)+480284|0,B=x[_j(e+72|0,e+4|0,e+140|0)>>2],w[A>>1]=B}d=d+1|0;continue}}if(f>>>0<9){break m}Vb(b,16);d=0;while(1){if((d|0)==16){break m}w[((d<<5)+a|0)+480284>>1]=d&1?192:64;d=d+1|0;continue}}o:{if(y[e+207|0]>=13){d=e+72|0;Nw(d,b);f=Jc(d);d=y[e+72|0];if(d>>>0<=31){v[e+72|0]=125;d=125}x[a+480204>>2]=D(d,1e4);x[a+480196>>2]=y[f|0];break o}x[a+480196>>2]=6;x[a+480204>>2]=125e4}vg(Xb(x[a+484360>>2],y[a+484376|0]),y[e+156|0]);l=Nb(e+140|0);d=x[b+8>>2];f=y[e+207|0]>13;if(!f){break h}x[31609]=0;O(210,l|0,y[e+156|0]);j=x[31609];x[31609]=0;if((j|0)!=1){break h}d=N()|0;break g}d=N()|0;Eb(e+4|0);break f}d=N()|0;Eb(e+4|0);break f}s=d+(f<<1)|0;d=0;p:{q:{while(1){if(y[e+156|0]<=d>>>0){j=0;if(y[e+207|0]!=10){break p}h=x[b+8>>2];d=1;while(1){j=z[a+480190>>1]>=(d&65535)>>>0;if(!j){break q}x[31609]=0;f=P(211,b|0,e+72|0)|0;k=x[31609];x[31609]=0;if((k|0)!=1){if(f){f=0;r:{if(y[e+155|0]<(y[e+118|0]|y[e+119|0]<<8|(y[e+120|0]<<16|y[e+121|0]<<24))>>>0|y[e+72|0]>1){break r}k=y[e+122|0]|y[e+123|0]<<8|(y[e+124|0]<<16|y[e+125|0]<<24);if(k>>>0>1048576|y[e+128|0]>64|k>>>0<(y[e+129|0]|y[e+130|0]<<8|(y[e+131|0]<<16|y[e+132|0]<<24))>>>0){break r}f=k>>>0>=(y[e+133|0]|y[e+134|0]<<8|(y[e+135|0]<<16|y[e+136|0]<<24))>>>0}if(!f){break q}}d=d+1|0;continue}break}d=N()|0;break g}A=bc(x[Xb(x[a+484360>>2],y[a+484376|0])>>2],d),B=d,w[A>>1]=B;s:{if(y[e+207|0]>=14){x[31609]=0;f=R(189,b|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break s}A=bc(x[l>>2],d),B=f,w[A>>1]=B}f=z[a+480188>>1];x[31609]=0;P(183,b|0,f<<1)|0;f=x[31609];x[31609]=0;if((f|0)==1){break s}d=d+1|0;continue}break}d=N()|0;break g}x[31609]=0;P(149,b|0,h|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break p}d=N()|0;break g}d=z[a+480190>>1];x[31609]=0;x[e+72>>2]=0;k=U(212,e+60|0,d|0,e+72|0)|0;d=x[31609];x[31609]=0;t:{u:{v:{w:{if((d|0)!=1){n=j?59:65;h=e+73|0;d=1;x:{while(1){f=d&65535;if(f>>>0>z[a+480190>>1]){j=Nb(e+48|0);x[31609]=0;n=U(213,b|0,j|0,y[e+157|0]|y[e+158|0]<<8)|0;d=x[31609];x[31609]=0;y:{if((d|0)!=1){if(!n){break d}d=0;f=0;h=x[j>>2];if(!mc(h,x[j+4>>2])){f=wb(h);g=wb(x[j+4>>2]);h=fb-16|0;fb=h;z:{if(!Ib(f,g)){break z}x[h+12>>2]=f;while(1){i=x[ge(h+12|0)>>2];if(!Ib(i,g)){break z}f=Zk(y[f|0]|y[f+1|0]<<8,y[i|0]|y[i+1|0]<<8)?i:f;continue}}fb=h+16|0;f=y[f|0]|y[f+1|0]<<8}x[31609]=0;i=P(214,e+24|0,f|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break y}A:{while(1){if((d|0)==(f|0)){if(!(c&2)){break w}r=Zc(e+4|0,8,1,0,m?2:1);d=z[a+480190>>1];g=1;B:{C:{D:while(1){o=g&65535;if(o>>>0>(d&65535)>>>0){break w}d=x[b+8>>2];h=x[b>>2];x[31609]=0;d=U(150,h|0,d|0,1)|0;h=x[31609];x[31609]=0;if((h|0)==1){break B}if(!d){break w}t=x[b+8>>2];h=0;E:while(1){d=z[a+480190>>1];if(h>>>0>=d>>>0){g=g+1|0;continue D}if((o|0)!=x[yb(x[k>>2],h)>>2]){h=h+1|0;continue}x[31609]=0;P(149,b|0,t|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){x[31609]=0;h=h+1|0;d=D(h,104)+a|0;q=d+484380|0;U(215,r|0,q|0,b|0)|0;u=x[31609];x[31609]=0;if((u|0)==1){break C}if(!m){continue}cc(e+72|0,x[d+484400>>2],x[q>>2]);A=e,B=wb(x[e+72>>2]),x[A>>2]=B;q=Zj(x[e+72>>2],x[e+76>>2]);while(1){d=x[e>>2];if(!Ib(d,q)){continue E}v[d|0]=y[d|0]^128;we(e);continue}}break}break}d=N()|0;break v}d=N()|0;break v}d=N()|0;break v}x[31609]=0;h=R(189,b|0)|0;g=x[31609];x[31609]=0;F:{if((g|0)==1){break F}x[31609]=0;P(183,b|0,1)|0;g=x[31609];x[31609]=0;if((g|0)==1){break F}if(h){x[31609]=0;g=e+4|0;S(185,g|0,b|0,D(h,3)+(y[e+207|0]==1?3:0)|0);h=x[31609];x[31609]=0;if((h|0)==1){break A}h=hc(e+72|0,g);kd(ch(x[i>>2],d),h);ub(h);ub(g)}d=d+1|0;continue}break}d=N()|0;break v}d=N()|0;break v}d=N()|0;break u}d=N()|0;break u}G:{H:{if(y[e+207|0]<=9){x[31609]=0;i=e+72|0;O(216,b|0,i|0);g=x[31609];x[31609]=0;I:{J:{if((g|0)==1){break J}x[31609]=0;O(217,i|0,(D(f,104)+a|0)+484380|0);i=x[31609];x[31609]=0;if((i|0)==1){break J}g=e+48|0;Te(g,2,h);x[31609]=0;i=e+4|0;O(218,i|0,g|0);g=x[31609];x[31609]=0;if((g|0)==1){break I}Ac(((f<<5)+a|0)+946304|0,i);tb(i);A=yb(x[k>>2],f-1|0),B=y[e+118|0]|y[e+119|0]<<8|(y[e+120|0]<<16|y[e+121|0]<<24),x[A>>2]=B;break H}d=N()|0;break t}d=N()|0;break t}if(m){x[31609]=0;i=e+72|0;O(219,b|0,i|0);g=x[31609];x[31609]=0;K:{L:{if((g|0)==1){break L}x[31609]=0;O(220,i|0,(D(f,104)+a|0)+484380|0);i=x[31609];x[31609]=0;if((i|0)==1){break L}x[31609]=0;i=P(36,e+36|0,22292)|0;g=x[31609];x[31609]=0;if((g|0)==1){break K}Ac(((f<<5)+a|0)+946304|0,i);tb(i);A=yb(x[k>>2],f-1|0),B=y[e+74|0]|y[e+75|0]<<8|(y[e+76|0]<<16|y[e+77|0]<<24),x[A>>2]=B;break H}d=N()|0;break t}d=N()|0;break t}x[31609]=0;i=e+72|0;S(221,b|0,i|0,n|0);g=x[31609];x[31609]=0;if((g|0)==1){break G}x[31609]=0;S(222,i|0,(D(f,104)+a|0)+484380|0,j|0);i=x[31609];x[31609]=0;if((i|0)==1){break G}g=e+48|0;Te(g,2,h);x[31609]=0;i=e+4|0;O(218,i|0,g|0);g=x[31609];x[31609]=0;if((g|0)==1){break x}Ac(((f<<5)+a|0)+946304|0,i);tb(i);A=yb(x[k>>2],f-1|0),B=y[e+118|0]|y[e+119|0]<<8|(y[e+120|0]<<16|y[e+121|0]<<24),x[A>>2]=B}d=d+1|0;continue}break}d=N()|0;break t}d=N()|0;break t}d=N()|0;break g}if(!(c&1)){break e}x[31609]=0;m=a+484344|0;O(223,m|0,y[e+156|0]);c=x[31609];x[31609]=0;M:{if((c|0)!=1){c=0;while(1){N:{if(y[e+156|0]<=c>>>0){break e}d=64;h=x[l>>2];if($c(h,x[l+4>>2])>>>0>c>>>0){d=z[bc(h,c)>>1]}x[31609]=0;d=U(196,m|0,c&65535,d&65535)|0;h=x[31609];x[31609]=0;if((h|0)==1){break M}O:{if(d){d=z[a+480188>>1];x[31609]=0;P(149,b|0,D(((y[e+207|0]>13)<<1)+(d<<1)|0,c)+s|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break M}h=Nb(e+72|0);d=z[a+480188>>1];x[31609]=0;g=U(213,b|0,h|0,d|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break O}d=0;P:{if(!g){break P}while(1){if(z[a+480188>>1]<=d>>>0){break P}Q:{g=bc(x[h>>2],d);g=(y[g|0]|y[g+1|0]<<8)-1|0;if((g&65535)>>>0>=(y[e+157|0]|y[e+158|0]<<8)>>>0){break Q}g=bc(x[j>>2],g);g=(y[g|0]|y[g+1|0]<<8)-1&65535;if(g>>>0>=f>>>0){break Q}r=x[m>>2];o=x[i>>2];x[31609]=0;S(224,Wb(r,c)|0,d&65535,ch(o,g)|0);g=x[31609];x[31609]=0;if((g|0)!=1){break Q}break N}d=d+1|0;continue}}od(h)}c=c+1|0;continue}}break}d=N()|0;od(h);break v}d=N()|0;break v}d=N()|0}Rc(i)}od(j)}wc(k)}od(l)}Q(d|0);p()}Rc(i)}od(j);wc(k);od(l)}fb=e+208|0;return n|0}function w2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,w=0,B=0;e=fb-1456|0;fb=e;yc(b);Kp(a);a:{b:{c:{d=e+1432|0;if(!ns(b,d)){break c}if(!KG(d)){break c}if(!c){i=1;break c}if(!xm(x[b>>2],y[e+1450|0]|y[e+1451|0]<<8|(y[e+1452|0]<<16|y[e+1453|0]<<24))){break c}if(!xm(x[b>>2],(y[e+1450|0]|y[e+1451|0]<<8|(y[e+1452|0]<<16|y[e+1453|0]<<24))+((y[e+1444|0]|y[e+1445|0]<<8)<<2)|0)){break c}tx(a);w=e,B=sx(),x[w+68>>2]=B;c=e+68|0;rx(ej(x[a+4>>2])+32|0,c);ms(c);m=x[ej(x[a+4>>2])+32>>2];x[e+1428>>2]=y[e+1446|0]|y[e+1447|0]<<8|(y[e+1448|0]<<16|y[e+1449|0]<<24);w=e,B=Lh(x[b>>2]),x[w+1168>>2]=B;x[e+1136>>2]=214748364;d=e+1168|0;w=e,B=D(x[Hb(d,e+1136|0)>>2],20),x[w+68>>2]=B;so(m,x[Hb(e+1428|0,c)>>2]);Rb(d,0,256);s=Nb(e+1156|0);while(1){d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{i=(y[e+1444|0]|y[e+1445|0]<<8)>>>0<=t>>>0;if(!i){x[31609]=0;c=P(149,b|0,(y[e+1450|0]|y[e+1451|0]<<8|(y[e+1452|0]<<16|y[e+1453|0]<<24))+(t<<2)|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break r}if(!c){break h}c=x[b+8>>2];d=x[b>>2];x[31609]=0;c=U(150,d|0,c|0,4)|0;d=x[31609];x[31609]=0;if((d|0)==1){break r}if(!c){break h}x[31609]=0;c=R(151,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break q}x[31609]=0;d=P(149,b|0,c|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break q}if(!d){break h}x[31609]=0;d=P(152,b|0,e+1136|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break p}if(!d){break h}x[31609]=0;d=U(153,b|0,s|0,y[e+1148|0]|y[e+1149|0]<<8)|0;g=x[31609];x[31609]=0;if((g|0)==1){break p}if(!d){break h}g=x[s>>2];f=x[b>>2];x[31609]=0;d=y[e+1148|0]|y[e+1149|0]<<8;f=R(154,f|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break o}n=f;f=c+20|0;if(n>>>0<=f+(d<<3)>>>0){break h}c=d?g:0;g=y[e+1148|0]|y[e+1149|0]<<8;f=f+(g<<3)|0;d=0;j=y[e+1150|0]|y[e+1151|0]<<8;if(!(j&1)){while(1){if(d>>>0>=g>>>0){break d}if(!c){break h}g=y[c+4|0]|y[c+5|0]<<8|(y[c+6|0]<<16|y[c+7|0]<<24);j=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);x[31609]=0;g=ba(155,j|0,g|0,m|0,x[e+1428>>2])|0;j=x[31609];x[31609]=0;s:{if((j|0)==1){break s}if(!g){break h}x[31609]=0;g=P(149,b|0,f|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break s}if(!g){break h}g=Zb(e+1128|0,xb(x[m>>2],y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24)),y[c+4|0]|y[c+5|0]<<8|(y[c+6|0]<<16|y[c+7|0]<<24));j=x[g>>2];g=x[g+4>>2];x[31609]=0;Zn(156,e+68|0,b,j,g);g=x[31609];x[31609]=0;if((g|0)==1){break n}if(x[e+72>>2]!=(y[c+4|0]|y[c+5|0]<<8|(y[c+6|0]<<16|y[c+7|0]<<24))){break h}d=d+1|0;c=c+8|0;g=y[e+1148|0]|y[e+1149|0]<<8;continue}break}i=N()|0;break a}t:{if(j&4){if(!c){break h}d=y[c+4|0]|y[c+5|0]<<8|(y[c+6|0]<<16|y[c+7|0]<<24);g=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);x[31609]=0;d=ba(155,g|0,d|0,m|0,x[e+1428>>2])|0;g=x[31609];x[31609]=0;if((g|0)==1){break m}if(!d){break h}o=xb(x[m>>2],y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24));l=(y[c+4|0]|y[c+5|0]<<8|(y[c+6|0]<<16|y[c+7|0]<<24))&-2;if(!l){break h}x[31609]=0;g=y[e+1154|0]|y[e+1155|0]<<8;d=P(149,b|0,f+(y[e+1152|0]|y[e+1153|0]<<8)|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break l}if(!d){break h}d=x[b+8>>2];f=x[b>>2];x[31609]=0;d=U(150,f|0,d|0,(y[e+1140|0]|y[e+1141|0]<<8|(y[e+1142|0]<<16|y[e+1143|0]<<24))-(y[e+1152|0]|y[e+1153|0]<<8)|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break l}if(!d){break h}x[31609]=0;d=e+48|0;S(157,d|0,b|0,(y[e+1140|0]|y[e+1141|0]<<8|(y[e+1142|0]<<16|y[e+1143|0]<<24))-(y[e+1152|0]|y[e+1153|0]<<8)|0);f=x[31609];x[31609]=0;if((f|0)==1){break b}k=ls(e+68|0,d);ub(d);r=0;j=0;while(1){f=0;u:{while(1){if((j&65535)>>>0>=(y[e+1148|0]|y[e+1149|0]<<8)>>>0){break e}x[31609]=0;d=P(158,k|0,g+1|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break u}h=g&15;q=z[(h<<1)+24384>>1];v:{w:{if(q>>>0<=d>>>0){x[31609]=0;h=y[h+24432|0];n=P(158,k|0,h|0)|0;u=x[31609];x[31609]=0;if((u|0)==1){break u}d=n+(d-q<<h)|0;if((d|0)!=(g|0)){g=d&15;break v}x[31609]=0;d=P(158,k|0,4)|0;h=x[31609];x[31609]=0;if((h|0)==1){break u}if((d|0)==15){x[31609]=0;h=P(158,k|0,1)|0;d=x[31609];x[31609]=0;if((d|0)==1){break u}d=65535;if(!h){break w}break e}d=d+65520|0}if(d>>>0>65535){break v}}d=d&1?0-(d+1>>>1|0)|0:d>>>1|0;n=f+o|0;h=y[e+1150|0]|y[e+1151|0]<<8;x:{if(h&2){r=d+r|0;d=r;break x}d=h&512?d:d^32768}q=d>>>8|0;h=h&1024;v[n+1|0]=h?d:q;v[n|0]=h?q:d;f=f+2|0}if(f>>>0<l>>>0){continue}break}j=j+1|0;if(j>>>0>=(y[e+1148|0]|y[e+1149|0]<<8)>>>0){break e}d=(j<<3)+c|0;f=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);l=y[d+4|0]|y[d+5|0]<<8|(y[d+6|0]<<16|y[d+7|0]<<24);x[31609]=0;f=ba(155,f|0,l|0,m|0,x[e+1428>>2])|0;l=x[31609];x[31609]=0;if((l|0)==1){break u}if(!f){break t}l=(y[d+4|0]|y[d+5|0]<<8|(y[d+6|0]<<16|y[d+7|0]<<24))&-2;if(!l){break t}o=xb(x[m>>2],y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24));continue}break}i=T(28816)|0;if((gb|0)==($(28816)|0)){Y(i|0)|0;x[31609]=0;X(26);c=x[31609];x[31609]=0;if((c|0)!=1){break e}i=N()|0}ub(k);break a}if(!c){break h}d=y[c+4|0]|y[c+5|0]<<8|(y[c+6|0]<<16|y[c+7|0]<<24);g=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);x[31609]=0;d=ba(155,g|0,d|0,m|0,x[e+1428>>2])|0;g=x[31609];x[31609]=0;if((g|0)==1){break k}if(!d){break h}r=xb(x[m>>2],y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24));if((y[e+1152|0]|y[e+1153|0]<<8)>>>0>256){break h}o=y[c+4|0]|y[c+5|0]<<8|(y[c+6|0]<<16|y[c+7|0]<<24);g=y[e+1154|0]|y[e+1155|0]<<8;x[31609]=0;d=P(149,b|0,f|0)|0;f=x[31609];x[31609]=0;y:{z:{if((f|0)!=1){if(!d){break h}d=Zb(e+40|0,e+1168|0,y[e+1152|0]|y[e+1153|0]<<8);f=x[d>>2];d=x[d+4>>2];x[31609]=0;Zn(159,e+68|0,b,f,d);d=x[31609];x[31609]=0;if((d|0)==1){break z}d=y[e+1152|0]|y[e+1153|0]<<8;if(d>>>0>A[e+72>>2]){break h}f=x[b+8>>2];j=x[b>>2];x[31609]=0;d=U(150,j|0,f|0,(y[e+1140|0]|y[e+1141|0]<<8|(y[e+1142|0]<<16|y[e+1143|0]<<24))-d|0)|0;f=x[31609];x[31609]=0;if((f|0)!=1){break y}}i=N()|0;break a}i=N()|0;break a}if(!d){break h}x[31609]=0;d=e+48|0;S(157,d|0,b|0,(y[e+1140|0]|y[e+1141|0]<<8|(y[e+1142|0]<<16|y[e+1143|0]<<24))-(y[e+1152|0]|y[e+1153|0]<<8)|0);f=x[31609];x[31609]=0;if((f|0)==1){break f}k=ls(e+68|0,d);ub(d);l=0;j=0;while(1){f=0;A:{while(1){if((l&65535)>>>0>=(y[e+1148|0]|y[e+1149|0]<<8)>>>0){break g}x[31609]=0;d=P(158,k|0,g+1|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break A}h=g&7;q=y[h+24416|0];B:{C:{if(q>>>0<=d>>>0){x[31609]=0;h=y[h+24424|0];n=P(158,k|0,h|0)|0;u=x[31609];x[31609]=0;if((u|0)==1){break A}d=n+(d-q<<h)|0;if((d|0)!=(g|0)){g=d&7;break B}x[31609]=0;d=P(158,k|0,3)|0;h=x[31609];x[31609]=0;if((h|0)==1){break A}if((d|0)==7){x[31609]=0;h=P(158,k|0,1)|0;d=x[31609];x[31609]=0;if((d|0)==1){break A}d=255;if(!h){break C}break g}d=d+248|0}if(d>>>0>255){break B}}d=y[(e+1168|0)+d|0];h=d+j|0;n=d;d=(y[e+1150|0]|y[e+1151|0]<<8)&2;v[f+r|0]=d?h:n;j=d?h:j;f=f+1|0}if(f>>>0<o>>>0){continue}break}l=l+1|0;if(l>>>0>=(y[e+1148|0]|y[e+1149|0]<<8)>>>0){break g}d=(l<<3)+c|0;f=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);o=y[d+4|0]|y[d+5|0]<<8|(y[d+6|0]<<16|y[d+7|0]<<24);x[31609]=0;f=ba(155,f|0,o|0,m|0,x[e+1428>>2])|0;o=x[31609];x[31609]=0;if((o|0)==1){break A}if(!f){break j}o=y[d+4|0]|y[d+5|0]<<8|(y[d+6|0]<<16|y[d+7|0]<<24);r=xb(x[m>>2],y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24));continue}break}i=T(28816)|0;if((gb|0)==($(28816)|0)){Y(i|0)|0;x[31609]=0;X(26);c=x[31609];x[31609]=0;if((c|0)!=1){break g}i=N()|0}ub(k);break a}ub(k);break h}se(e+24|0,x[m>>2],x[m+4>>2]);lf(e+32|0,x[e+24>>2],x[e+28>>2]);b=Md(e+16|0);x[31609]=0;c=x[b+4>>2];x[e+8>>2]=x[b>>2];x[e+12>>2]=c;b=hg(160,e+68|0,x[e+32>>2],x[e+36>>2],e+8|0);c=x[31609];x[31609]=0;if((c|0)==1){break i}kd(ej(x[a+4>>2])+12|0,b);ub(b);break h}i=N()|0;break a}i=N()|0;break a}i=N()|0;break a}i=N()|0;break a}i=N()|0;break a}i=N()|0;break a}i=N()|0;break a}i=N()|0;break a}ub(k);break h}i=N()|0;break a}Ce(s);break c}ub(k);break d}i=N()|0;break a}ub(k)}t=t+1|0;continue}}fb=e+1456|0;return i|0}i=N()|0}Ce(s);Q(i|0);p()}function bqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,B=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,R=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;e=fb-368|0;fb=e;a:{if(!dd(b,1080)){break a}d=e+364|0;if(!jr(b,d)){break a}l=hY(e+344|0);if(!gY(d,l)){break a}i=z[l+10>>1];if(!i|i>>>0>127){break a}L=1;if((c|0)==64){break a}M=1;Dd(a,1);h=z[l+10>>1];w[a+480188>>1]=h;r=y[l+14|0];O=y[l+13|0];o=y[l+12|0];if(!oe(d,25274)){M=oe(d,25279)}if(y[l+15|0]){Lb(a+1074312|0,5,1);h=z[a+480188>>1]}d=e+364|0;t=oe(d,16780);m=1;if(!oe(d,17542)){m=oe(d,13702)}u=a+480188|0;B=(h&65535)==8&(O|0)!=0;dd(b,0);d=y[l+16|0];i=fb-16|0;fb=i;b:{h=e+324|0;if(!lx(b,h)|!d){break b}jx(i+8|0,h);d=0;while(1){if(d>>>0>=20){break b}k=x[i+8>>2];rg(xb(k,d),xb(k,d|1));d=d+2|0;continue}}fb=i+16|0;i=e+312|0;bf(i,h,20,3);d=e+180|0;Cc(d,i);zb(a+1298308|0,d);tb(d);w[a+480190>>1]=31;o=(o|0)!=0;h=1;d=t;while(1){if((h|0)==32){L=A[l+4>>2]>=f>>>0;if(!L){break a}}else{i=y[l+16|0];k=fb-16|0;fb=k;c:{n=e+180|0;if(!$X(b,n)|!i){break c}Gv(k+8|0,n);i=0;while(1){if(i>>>0>=30){break c}q=x[k+8>>2];rg(xb(q,i),xb(q,i|1));i=i+2|0;continue}}fb=k+16|0;k=D(h,104)+a|0;i=k+484380|0;n=YC(n,i,((h<<5)+a|0)+946304|0,z[a+480188>>1]==4);i=x[i>>2];d:{if(m){v[k+484417|0]=0-(y[e+204|0]<<3);break d}o=i>>>0<65536&o;E=i>>>0>65535|E}k=Bb(y[e+202|0]|y[e+203|0]<<8);e:{if(k){V=!Bb(y[e+208|0]|y[e+209|0]<<8)|V;break e}W=y[e+205|0]==64|W}q=d&1;d=0;f:{if(!q){break f}j=(k<<1)+j|0;q=y[e+204|0];d=!q;if(q|!k){break f}d=y[e+205|0]==64}f=f+n|0;g=g+i|0;h=h+1|0;continue}break}f=y[l+16|0];i=fb-16|0;fb=i;g:{h=e+180|0;if(!RC(b,h)|!f){break g}WC(i+8|0,h);f=0;while(1){if(f>>>0>=130){break g}h=x[i+8>>2];rg(xb(h,f),xb(h,f|1));f=f+2|0;continue}}fb=i+16|0;dd(b,z[l+8>>1]);i=y[e+181|0];f=128;ow(Xb(x[a+484360>>2],y[a+484376|0]),e+182|0,128);k=!i&d;m=k?j:0;i=y[e+180|0];h:{if(i>>>0>=129){d=y[a+484376|0];j=x[a+484360>>2];break h}d=y[a+484376|0];j=x[a+484360>>2];if(i){f=i;break h}i=x[Xb(j,d)>>2];h=128;while(1){f=h;if(f>>>0<2){f=1;break h}h=f-1|0;if(!z[bc(i,h)>>1]){continue}break}}i=eY(b,Xb(j,d),f&65535,g,u,m,0);G=1;i:{if(!(k&z[u>>1]==8)){G=(r|0)!=0;break i}x[l>>2]=11279}j:{if(!B){break j}d=Xb(x[a+484360>>2],y[a+484376|0]);ba=e,ca=wb(x[d>>2]),x[ba+312>>2]=ca;g=wb(x[d+4>>2]);while(1){d=x[e+312>>2];if(!Ib(d,g)){break j}w[d>>1]=z[d>>1]>>>1;ge(e+312|0);continue}}$e(Xb(x[a+484360>>2],y[a+484376|0]),y[e+181|0]);d=y[e+181|0];X=f-1|0;k:{if(d>>>0<=(X&65535)>>>0){h=z[u>>1];if((d|0)!=120|(h|0)!=4){break k}}$e(Xb(x[a+484360>>2],y[a+484376|0]),0);h=z[a+480188>>1]}x[a+480260>>2]=56;x[a+480264>>2]=13696;x[a+480204>>2]=125e4;x[a+480196>>2]=6;r=0;x[a+480208>>2]=0;ba=a,ca=Yb(256/((h&65535)>>>0)|0,32,128),x[ba+480228>>2]=ca;Wh(a,0);v[e+179|0]=0;l:{if(o&1){q=1;k=1;break l}q=1;m=0;o=0;j=t;m:while(1){s=o&65535;if(s>>>0<i>>>0){n=0;h=0;while(1)if((h|0)==256){o=o+1|0;continue m}else{d=Ng(e+312|0);dY(e+160|0,b,!s&y[l+16|0]!=0);g=x[e+160>>2];x[e+172>>2]=g;x[e+64>>2]=g;g=e+92|0;dp(g,e- -64|0,d);f=Jc(g);k=OD(y[d|0]);n:{o:{p:{q:{d=y[e+92|0];if((d-7&255)>>>0<3){j=0;break q}g=y[f|0];if(!((d|0)!=14|g>>>0<=1)){j=0;break p}if(!((d|0)!=15|(g&255)>>>0<=31)){j=0;break n}j=k?j:0;if((d|0)!=13){break q}n=n+1|0;j=(n&65535)>>>0<=1?j:0;break n}if((d|0)==8){break o}if((d|0)!=14){break n}g=y[f|0]}if((g&240)!=128){break n}v[e+80|0]=g<<4;ba=e,ca=y[cf(e+179|0,e+80|0)|0],v[ba+179|0]=ca;break n}ba=e,ca=y[cf(e+179|0,f)|0],v[ba+179|0]=ca;d=v[f|0];if((d|0)>=0){r=1;break n}m=(d|0)!=-92&d>>>0>4294967183|m}q=k&q;h=h+1|0;continue}}break}d=r^-1;r=0;r=(d|m)&1?r:y[e+179|0]>47;k=j&1}dd(b,z[l+8>>1]);d=z[a+480188>>1];F=a+484344|0;R=i+B&65535;Tf(F,R);Y=B?4:d;s=a+1074312|0;aa=c&1;m=0;o=0;i=E;r:{s:{t:{u:{while(1){if((m|0)==(R|0)){break t}v:{if(B){d=(m&65534)>>>1|0;g=m&1;if(!g){if(!Pg(F,d,64)){break t}}h=Wb(x[F>>2],d);d=g<<2;break v}if(!Pg(F,m&65535,64)){break t}h=Wb(x[F>>2],m);d=0}j=0;n=md(x[h>>2],x[x[h+48>>2]+12>>2],0,d);if(!aa){H=0;break s}d=z[u>>1];v[e+92|0]=0;g=d;d=e+92|0;I=kw(e+312|0,g,d);g=z[u>>1];x[31609]=0;v[e+92|0]=0;J=U(600,e+160|0,g|0,d|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){T=0;w:{x:while(1){y:{if((T|0)==64){break w}h=0;g=0;Z=0;while(1){if((h|0)==(Y|0)){T=T+1|0;i=g&Z|i;n=D(z[u>>1],6)+n|0;continue x}d=y[l+16|0];x[31609]=0;S(601,e+92|0,b|0,!m&(d|0)!=0);d=x[31609];x[31609]=0;if((d|0)!=1){d=x[e+92>>2];x[e+156>>2]=d;x[e+60>>2]=d;f=e+80|0;j=D(h,6)+n|0;dp(f,e+60|0,j);d=y[e+80|0];K=Jc(f);f=y[K|0];if(d|f){z:{if(!(!O|(d&255)!=14)){d=0;v[K|0]=0;v[e+80|0]=0;f=y[K|0];break z}if(!O|(d&255)!=15|(f&255)>>>0<32){break z}f=31;v[K|0]=31;d=y[e+80|0]}Cf(j,d&255,f&255)}d=1;A:{B:{C:{D:{E:{f=y[j+3|0];switch(f-14|0){case 2:break A;case 0:break D;case 3:break E;default:break C}}o=y[j+5|0]<100|o;Z=1;break B}if(!k){break B}v[j+5|0]=0;break B}if((f|0)==9&r){d=y[j+5|0];if((d|0)==164){v[j+3|0]=20;v[j+5|0]=145;break B}ba=j,ca=Eh(d<<1),v[ba+5|0]=ca;break B}if((f|0)!=19){break B}d=y[j+5|0];if(d>>>0>15){break B}f=!(d&1);d=(f^_)&1;_=d?f:_;H=d+H|0}d=g}F:{if(!y[j|0]){g=y[j+1|0];if(!g|B){break F}f=y[xb(x[I>>2],h)|0];if(!f|(f|0)==(g|0)){break F}f=xb(x[J>>2],h);g=y[f|0]+1|0;v[f|0]=g;if((g&255)>>>0<4){break F}x[31609]=0;U(266,s|0,85,1)|0;g=x[31609];x[31609]=0;if((g|0)!=1){break F}break y}ba=xb(x[J>>2],h),ca=0,v[ba|0]=ca}g=y[j+1|0];if(g){ba=xb(x[I>>2],h),ca=g,v[ba|0]=ca}h=h+1|0;g=d;continue}break}}break}d=N()|0;ec(J);break u}ec(J);ec(I);m=m+1|0;continue}break}d=N()|0}ec(I);break r}j=o;E=i}G:{H:{I:{g=q^1;if((g|V)&1){break I}d=e+364|0;J:{if(oe(d,16780)){break J}if(oe(d,17547)){break J}if(!oe(d,13697)){break I}}x[a+480208>>2]=x[a+480208>>2]|2162688;d=Lb(Lb(Lb(s,85,1),91,1),92,1);K:{if(y[e+179|0]>47){break K}d=Lb(d,84,1);if(y[e+181|0]==127){break K}Lb(d,83,1)}if(!((H|0)>6|G)){break H}break G}if(!(q&1)){if(!(y[e+181|0]==127&(X&65535)>>>0<129&t)){break G}x[l>>2]=8494;break G}if((H|0)>6|G){break G}}x[a+480208>>2]=x[a+480208>>2]|8388608}if((t|G)==1){Lb(s,89,1)}if(M){Lb(s,84,1)}n=0;L:{if(!(c&2)){break L}dd(b,z[l+8>>1]+(D(R,Y)<<8)|0);g=(g|t^1|W)&1;h=1;while(1){if((h|0)==32){break L}i=D(h,104)+a|0;c=i+484380|0;d=x[c>>2];if(d){f=2;if(!M){d=cY(b,13945);f=d?10:0;n=d|n;d=x[c>>2]}f=Zc(e+312|0,8,1,0,f);d=AD(f,d)+x[b+8>>2]|0;if(!g){ba=c,ca=x[bd(c,i+484388|0)>>2],x[ba>>2]=ca}dg(f,c,b);dd(b,d)}h=h+1|0;continue}}M:{N:{if(!t){if(!((oe(e+364|0,17547)&j^-1|E)&1)){break N}break M}if((j^-1|E)&1){break M}}b=bY(e+128|0,0);c=x[b+20>>2];x[e+48>>2]=x[b+16>>2];x[e+52>>2]=c;c=x[b+12>>2];x[e+40>>2]=x[b+8>>2];x[e+44>>2]=c;c=x[b+4>>2];x[e+32>>2]=x[b>>2];x[e+36>>2]=c;c=e+312|0;Fv(c,a,0,e+32|0);$=C[x[e+312>>2]>>3];Si(c);if(!($>=480)){break M}d=Lb(s,5,1);b=aY(e+104|0,$);g=x[b+20>>2];x[e+24>>2]=x[b+16>>2];x[e+28>>2]=g;g=x[b+12>>2];x[e+16>>2]=x[b+8>>2];x[e+20>>2]=g;g=x[b+4>>2];x[e+8>>2]=x[b>>2];x[e+12>>2]=g;Fv(c,a,0,e+8|0);b=y[x[e+312>>2]+26|0];Si(c);if(b){bg(d,5);break M}x[l>>2]=17114}g=e+364|0;d=g;b=gc(d);c=d;while(1){if((b|0)!=(d|0)){f=y[d|0];v[c|0]=f>>>0<=32?32:f;c=c+1|0;d=d+1|0;continue}break}d=e+92|0;gg(d,16867);x[31609]=0;b=U(44,e+68|0,g|0,b|0)|0;c=x[31609];x[31609]=0;O:{P:{Q:{R:{S:{if((c|0)!=1){x[31609]=0;g=e+80|0;S(602,g|0,1,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break S}x[31609]=0;c=e+312|0;S(139,c|0,d|0,g|0);f=x[31609];x[31609]=0;if((f|0)==1){break R}zb(a+1298344|0,c);tb(c);tb(g);tb(b);Eb(d);b=uc(c,12402);zb(a+1298356|0,b);tb(b);b=x[l>>2];if(b){$h(a+1298368|0,b)}b=e+312|0;ba=a+1298404|0,ca=x[Fc(b,28)>>2],x[ba>>2]=ca;if(!(n&1)){break a}b=uc(b,17166);x[31609]=0;P(74,a+1298368|0,b|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break O}tb(b);break a}d=N()|0;break P}d=N()|0;break Q}d=N()|0;tb(e+80|0)}tb(b)}Eb(e+92|0);break r}d=N()|0;tb(b)}Q(d|0);p()}fb=e+368|0;return L|0}function Jta(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0;e=fb+-64|0;fb=e;yc(a);a:{b:{if(b>>>0<=2){H=e,I=Zd(a),v[H+56|0]=I;Vb(a,2);b=gh(a);v[e+58|0]=b;v[e+59|0]=b>>>8;b=Rg(a);v[e+60|0]=b;v[e+61|0]=b>>>8;v[e+62|0]=b>>>16;v[e+63|0]=b>>>24;break b}ip(a,e+56|0);if(b>>>0>5){break a}}v[e+57|0]=0}c:{t=d+484344|0;F=Ld(y[e+58|0]|y[e+59|0]<<8,1,1024);q=jE(t,F);if((q|0)==65535){break c}b=Wb(x[d+484344>>2],q);h=md(x[b>>2],x[x[b+48>>2]+12>>2],0,0);f=z[d+480188>>1];w[e+12>>1]=f-1;w[e+44>>1]=y[e+56|0];G=z[Oc(e+12|0,e+44|0)>>1];g=G+1|0;b=g&65535;f=b>>>0<f>>>0?f:b;while(1)if((b|0)==(f|0)){v[c+13|0]=y[e+57|0]>>>4;b=y[c+12|0];v[e+12|0]=0;b=(b|0)!=0;B=kw(e+44|0,g,e+12|0);d:while(1){if((l|0)==(F|0)){ec(B);break c}e:{f:{g=xb(x[B>>2],0);f=y[g|0];g:{if(!f){x[31609]=0;g=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}h=g<<24>>24;if((h|0)<0){x[31609]=0;g=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}H=xb(x[B>>2],0),I=g,v[H|0]=I}v[e+12|0]=0;h:{i:{g=h&63;if(!g){break i}x[31609]=0;k=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break h}v[e+12|0]=k;j:{k:{switch(g-1|0){case 0:v[c+12|0]=0;v[e+40|0]=1;H=c,I=y[cf(e+40|0,e+12|0)|0],v[H+14|0]=I;v[c+15|0]=0;break j;case 1:if(!k){break i}v[c+15|0]=k;v[c+12|0]=1;b=y[c+13|0];if(!b){break j}v[c+14|0]=D(D(b,k),15);break j;case 2:v[c+13|0]=k>>>4;if(k>>>0>=16){b=y[c+12|0];k=0;x[e+40>>2]=0;x[e+36>>2]=0;u=0;if(b){break g}break f}k=0;v[c+12|0]=0;x[e+40>>2]=0;x[e+36>>2]=0;u=0;if(b&1){break g}break f;case 3:u=0;x[e+40>>2]=0;x[e+36>>2]=0;if(b&1){break g}break f;case 5:if(!k){break i}b=(y[c+12|0]?15:14)+c|0;f=y[b|0];v[b|0]=f>>>0>=256-k>>>0?-1:f+k|0;break j;case 6:break k;default:break i}}if(!k){break i}b=(y[c+12|0]?15:14)+c|0;f=y[b|0];v[b|0]=f>>>0<=k+1>>>0?1:f-k|0}k=0;x[e+40>>2]=0;x[e+36>>2]=0;break g}k=0;x[e+40>>2]=0;x[e+36>>2]=0;u=0;if(b&1){break g}break f}break e}v[g|0]=f-1;k=0;x[e+40>>2]=0;x[e+36>>2]=0;u=0;if(!(b&1)){break f}}f=y[c+13|0];b=y[c+12|0];if(b){u=0;if(!f){break f}}l:{if(b){x[e+12>>2]=1;x[e+32>>2]=D(f,y[c+15|0])<<1;f=x[Xe(e+12|0,e+32|0)>>2];break l}f=D(y[c+14|0],30)+30|0}b=255;g=0;s=0;while(1){m:{if(b){h=D(b,f);s=(h|0)/48|0;if(h-1536>>>0>=10752){break m}g=b}x[e+36>>2]=s;x[e+40>>2]=g;He(e+36|0,32,255);u=1;x[e+12>>2]=1;H=c,I=x[Xe(e+12|0,e+40|0)>>2],v[H+16|0]=I;break f}b=b-1|0;continue}}C=l-1|0;E=1;b=Wb(x[t>>2],q);b=md(x[b>>2],x[x[b+48>>2]+12>>2],l,1);while(1){i=E&65535;if(i>>>0>G>>>0){if(u){b=e+12|0;Ae(Wb(x[t>>2],q),Xh(hp(Ve(Oe(b,17,y[e+36|0]),l),0)));Ae(Wb(x[t>>2],q),Xh(Ve(Oe(b,16,y[e+40|0]),l)))}if(k>>>0>=16){Ae(Wb(x[t>>2],q),K$(Ve(Oe(e+12|0,20,k>>>4|224),l)))}b=k&15;if(b){Ae(Wb(x[t>>2],q),K$(Ve(Oe(e+12|0,20,Ld((D(b,y[c+16|0])>>>0)/15&255,1,15)|96),l)))}l=l+1|0;b=0;continue d}n:{o:{p:{q:{g=xb(x[B>>2],i);f=y[g|0];if(!f){x[31609]=0;g=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}h=g<<24>>24;if((h|0)<0){x[31609]=0;g=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}H=xb(x[B>>2],i),I=g,v[H|0]=I}s=1;m=h&255;if(m&64){x[31609]=0;g=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}v[b+1|0]=g;s=!g}if(!(m&32)){g=y[b|0];break q}x[31609]=0;g=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}v[b|0]=g;if((g-1&255)>>>0<=107){g=iE(g+24&255);v[b|0]=g;H=Yc(x[c>>2],i),I=g,v[H+1|0]=I;break q}if((g+127&255)>>>0<=107){f=iE((g&127)+24|0);H=Yc(x[c>>2],i),I=f,v[H|0]=I;v[b|0]=0;break p}if((g|0)!=255){break q}v[b|0]=254;break o}v[g|0]=f-1;break n}if(g&255){break o}}if(!y[b+1|0]){break o}f=y[Yc(x[c>>2],i)+1|0];v[b+1|0]=0;v[b|0]=f}if(Tc(y[b|0])){H=Yc(x[c>>2],i),I=0,v[H+5|0]=I}v[e+31|0]=0;v[e+30|0]=0;if(m&16){v[b+2|0]=1;x[31609]=0;g=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}v[b+4|0]=g+2>>>2}g=0;r=0;A=0;r:{if(!(m&8)){break r}x[31609]=0;h=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}x[31609]=0;A=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}s:{switch(h-1|0){case 0:v[b|0]=254;break r;case 1:v[b|0]=255;break r;case 2:f=Yc(x[c>>2],i);v[b|0]=y[f+1|0];v[f+5|0]=0;break r;case 3:f=jw(A,y[c+16|0]);A=f?f|-48:0;r=f?20:0;if(y[b|0]){break r}f=Yc(x[c>>2],i);v[b|0]=y[f+1|0];v[f+5|0]=0;break r;case 4:v[e+12|0]=1;H=e,I=jw(A,y[c+16|0]),v[H+32|0]=I;A=y[cf(e+12|0,e+32|0)|0];H=Yc(x[c>>2],i),I=0,v[H+5|0]=I;r=15;break r;case 5:case 6:case 7:case 8:r=x[c>>2];t:{if(!l){break t}if((h|0)==y[Yc(r,i)+4|0]){break t}f=Ae(Wb(x[t>>2],q),Bn(hp(Ve(Oe(e+12|0,20,(h+122|160)&255),C),i)));r=x[c>>2];if(!f){break t}H=Yc(r,i),I=h,v[H+4|0]=I}f=Yc(r,i);if(!y[b|0]){v[b|0]=y[f+1|0]}v[f+5|0]=0;r=10;break r;case 9:break s;default:break r}}f=Yc(x[c>>2],i);h=y[f+5|0];v[f+5|0]=h^1;A=h?-98:-97;r=20}u:{v:{w:{if(!(m&4)){break w}x[31609]=0;n=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}x[31609]=0;j=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}v[e+31|0]=j;h=1;g=1;x:{switch(n-1|0){case 0:hE(e+12|0,j<<24>>24<<3,128);f=y[b|0];if(Tc(f)){H=b,I=iw(f+x[e+12>>2]|0),v[H|0]=I}v[e+31|0]=y[e+16|0]^128;g=35;break w;case 1:f=jw(j,y[c+16|0]);v[e+31|0]=f;if(!f){break v}v[e+31|0]=f|208;g=20;break u;case 3:case 4:H=e,I=J$(j,y[c+16|0],1),v[H+31|0]=I;g=(n|0)==4?2:3;break u;case 5:if(!y[b|0]){H=b,I=y[Yc(x[c>>2],i)|0],v[H|0]=I}H=e,I=J$(j,y[c+16|0],0),v[H+31|0]=I;g=4;break u;case 6:H=b,I=iw(j+25|0),v[H|0]=I;v[e+31|0]=255;g=4;break u;case 7:case 8:case 9:y:{if(!l){break y}if((n|0)==y[Yc(x[c>>2],i)+2|0]){break y}if(!Ae(Wb(x[t>>2],q),Bn(hp(Ve(Oe(e+12|0,20,(n-8|48)&255),C),i)))){break y}H=Yc(x[c>>2],i),I=n,v[H+2|0]=I}H=e,I=gE(j,y[c+16|0]),v[H+31|0]=I;g=5;break u;case 10:H=e,I=I$(j,y[c+16|0]),v[H+31|0]=I;g=18;break u;case 11:f=jw(j,y[c+16|0]);v[e+31|0]=f;if(f){v[e+31|0]=f|192;g=20;break u}v[b|0]=254;break v;case 2:break u;default:break x}}g=0}h=0;break u}g=0}o=0;f=1;z:{if(m&2){x[31609]=0;m=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}x[31609]=0;n=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}v[e+30|0]=n;o=9;f=0;j=0;A:{switch(m-1|0){case 0:case 1:j=1;H=e,I=H$(n,y[c+16|0],(m|0)==1),v[H+30|0]=I;o=11;break z;case 2:H=e,I=I$(n,y[c+16|0]),v[H+30|0]=I;j=1;o=18;break z;case 3:case 4:case 5:B:{if(!l){break B}if((m|0)==y[Yc(x[c>>2],i)+3|0]){break B}if(!Ae(Wb(x[t>>2],q),Bn(hp(Ve(Oe(e+12|0,20,(m-4|64)&255),C),i)))){break B}H=Yc(x[c>>2],i),I=m,v[H+3|0]=I}H=e,I=gE(n,y[c+16|0]),v[H+30|0]=I;j=1;o=8;break z;case 7:case 8:H=e,I=H$(n,y[c+16|0],(m|0)==8),v[H+30|0]=I;j=1;o=29;break z;case 9:H=e,I=gE(n,y[c+16|0]),v[H+30|0]=I;j=1;o=27;break z;case 6:break z;default:break A}}o=0;f=1}j=0}if(h){G$(b,l,z[d+480188>>1],g,e+31|0)}if(j){G$(b,l,z[d+480188>>1],o,e+30|0)}C:{D:{E:{F:{G:{if(!s){break G}if(!Tc(y[b|0])){break G}if(!g){break F}if(!f|(g|0)==4){break G}v[e+30|0]=255;o=4}j=b+2|0;if(y[b+2|0]!=1){break C}if(g){break E}v[e+31|0]=y[b+4|0];g=13;break D}v[e+31|0]=255;j=b+2|0;g=4;if(y[b+2|0]!=1){break C}}if(o){break C}v[e+30|0]=y[b+4|0];o=13}v[j|0]=0}h=Ng(e+12|0);gm(e+32|0,h,g,y[e+31|0],o,y[e+30|0]);H:{if(y[j|0]){break H}f=y[e+14|0];if(!f){break H}v[b+2|0]=f;v[b+4|0]=y[e+16|0]}s=y[e+15|0];I:{if(r){gm(e+32|0,h,s&255,y[e+17|0],r,A&255);J:{if(y[j|0]){break J}f=y[e+14|0];if(!f){break J}v[b+2|0]=f;v[b+4|0]=y[e+16|0]}s=y[e+15|0];break I}if(!(s&255)){break n}}v[b+3|0]=s;v[b+5|0]=y[e+17|0]}b=b+6|0;E=E+1|0;continue}}break}a=N()|0;ec(B);Q(a|0);p()}else{v[h+D(b,6)|0]=254;b=b+1|0;continue}}fb=e- -64|0;return q|0}function KR(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=fb-336|0;fb=k;m=h;n=i&65535;o=d;p=e&65535;s=(e^i)&-2147483648;y=i>>>16&32767;u=e>>>16&32767;a:{b:{if(y-32767>>>0>4294934529&u-32767>>>0>=4294934530){break b}j=e&2147483647;if(!(!d&(j|0)==2147418112?!(b|c):j>>>0<2147418112)){r=d;s=e|32768;break a}e=i&2147483647;if(!(!h&(e|0)==2147418112?!(f|g):e>>>0<2147418112)){r=h;s=i|32768;b=f;c=g;break a}if(!(b|d|(j^2147418112|c))){if(!(f|h|(e^2147418112|g))){b=0;c=0;s=2147450880;break a}s=s|2147418112;b=0;c=0;break a}if(!(f|h|(e^2147418112|g))){b=0;c=0;break a}if(!(b|d|(c|j))){b=!(f|h|(e|g));r=b?0:r;s=b?2147450880:s;b=0;c=0;break a}if(!(f|h|(e|g))){s=s|2147418112;b=0;c=0;break a}if((j|0)==65535|j>>>0<65535){d=!(o|p);i=d;j=d?b:o;d=d<<6;i=G(i?c:p);d=d+((i|0)==32?G(j)+32|0:i)|0;$f(k+320|0,b,c,o,p,d-15|0);q=16-d|0;o=x[k+328>>2];p=x[k+332>>2];c=x[k+324>>2];b=x[k+320>>2]}if(e>>>0>65535){break b}d=!(n|m);h=d;i=d?f:m;d=d<<6;h=G(h?g:n);d=d+((h|0)==32?G(i)+32|0:h)|0;$f(k+304|0,f,g,m,n,d-15|0);q=(d+q|0)-16|0;m=x[k+312>>2];n=x[k+316>>2];f=x[k+304>>2];g=x[k+308>>2]}e=n|65536;z=e;B=m;d=m;j=e<<15|d>>>17;e=d<<15|g>>>17;d=e;i=0-d|0;h=j;j=1963258675-(j+((d|0)!=0)|0)|0;Nf(k+288|0,d,h,0,0,i,j,0,0);d=x[k+296>>2];Nf(k+272|0,0-d|0,0-(x[k+300>>2]+((d|0)!=0)|0)|0,0,0,i,j,0,0);d=x[k+280>>2];i=d<<1|x[k+276>>2]>>>31;d=x[k+284>>2]<<1|d>>>31;Nf(k+256|0,i,d,0,0,e,h,0,0);j=x[k+264>>2];Nf(k+240|0,i,d,0,0,0-j|0,0-(x[k+268>>2]+((j|0)!=0)|0)|0,0,0);i=x[k+248>>2];j=i<<1|x[k+244>>2]>>>31;d=x[k+252>>2]<<1|i>>>31;Nf(k+224|0,j,d,0,0,e,h,0,0);i=x[k+232>>2];Nf(k+208|0,j,d,0,0,0-i|0,0-(x[k+236>>2]+((i|0)!=0)|0)|0,0,0);d=x[k+216>>2];i=d<<1|x[k+212>>2]>>>31;d=x[k+220>>2]<<1|d>>>31;Nf(k+192|0,i,d,0,0,e,h,0,0);j=x[k+200>>2];Nf(k+176|0,i,d,0,0,0-j|0,0-(x[k+204>>2]+((j|0)!=0)|0)|0,0,0);i=e;e=x[k+184>>2];d=h;m=e<<1|x[k+180>>2]>>>31;h=m-1|0;e=(x[k+188>>2]<<1|e>>>31)-!m|0;Nf(k+160|0,i,d,0,0,h,e,0,0);d=h;Nf(k+144|0,f<<15,g<<15|f>>>17,0,0,d,e,0,0);v=k+112|0;C=x[k+168>>2];h=x[k+172>>2];m=x[k+160>>2];i=x[k+152>>2];l=m+i|0;n=x[k+164>>2];j=n+x[k+156>>2]|0;j=i>>>0>l>>>0?j+1|0:j;i=j;j=(n|0)==(j|0)&l>>>0<m>>>0|j>>>0<n>>>0;n=j+C|0;j=j>>>0>n>>>0?h+1|0:h;m=!i&l>>>0>1|(i|0)!=0;h=n+m|0;j=m>>>0>h>>>0?j+1|0:j;Nf(v,d,e,0,0,0-h|0,0-(((h|0)!=0)+j|0)|0,0,0);Nf(k+128|0,1-l|0,0-((l>>>0>1)+i|0)|0,0,0,d,e,0,0);M=(u-y|0)+q|0;e=x[k+116>>2];u=e;d=x[k+112>>2];j=e<<1|d>>>31;i=d<<1;n=j;d=j;h=x[k+140>>2];w=h;e=x[k+136>>2];j=h<<1|e>>>31;l=e<<1|x[k+132>>2]>>>31;h=l+i|0;d=d+j|0;d=h>>>0<l>>>0?d+1|0:d;e=d;d=d-(h>>>0<13927)|0;t=d;v=d;l=0;j=p|65536;N=j;O=o;d=o;j=j<<1|d>>>31;Q=d<<1;R=j;H=j;d=Iua(t,l,j,0);j=hb;D=d;E=j;J=b<<1;d=c<<1|b>>>31;y=d;C=d;j=0;q=j;m=h-13927|0;t=(e|0)==(t|0)&m>>>0<h>>>0|e>>>0>t>>>0;e=(e|0)==(n|0)&h>>>0<i>>>0|e>>>0<n>>>0;d=x[k+120>>2];h=x[k+124>>2]<<1|d>>>31;d=d<<1|u>>>31;l=w>>>31|0;d=l+d|0;j=h;j=d>>>0<l>>>0?j+1|0:j;h=d;d=d+e|0;j=h>>>0>d>>>0?j+1|0:j;e=d;d=d+t|0;l=e>>>0>d>>>0?j+1|0:j;e=d-1|0;F=l-!d|0;w=0;i=Iua(C,q,F,w);d=i+D|0;h=hb+E|0;h=d>>>0<i>>>0?h+1|0:h;n=(E|0)==(h|0)&d>>>0<D>>>0|h>>>0<E>>>0;D=e;P=c>>>31|0;I=P|o<<1;t=0;e=Iua(e,0,I,t);o=e+d|0;j=hb+h|0;l=0;j=e>>>0>o>>>0?j+1|0:j;p=j;d=(j|0)==(h|0)&d>>>0>o>>>0|h>>>0>j>>>0;e=d;d=d+n|0;l=e>>>0>d>>>0?1:l;e=Iua(H,q,F,w);d=e+d|0;j=hb+l|0;n=d;d=d>>>0<e>>>0?j+1|0:j;e=Iua(H,q,D,t);l=hb;h=e;e=Iua(I,t,F,w);i=h+e|0;j=hb+l|0;j=e>>>0>i>>>0?j+1|0:j;e=j;j=(l|0)==(j|0)&h>>>0>i>>>0|j>>>0<l>>>0;l=n+e|0;d=d+j|0;d=l>>>0<e>>>0?d+1|0:d;n=l;l=d;e=0;d=e+o|0;j=i+p|0;j=d>>>0<e>>>0?j+1|0:j;e=j;h=(j|0)==(p|0)&d>>>0<o>>>0|j>>>0<p>>>0;j=l;i=h;h=h+n|0;j=i>>>0>h>>>0?j+1|0:j;u=h;l=j;o=d;E=m;d=Iua(m,0,I,t);i=hb;h=d;m=Iua(v,r,C,r);d=d+m|0;j=hb+i|0;j=d>>>0<m>>>0?j+1|0:j;m=(i|0)==(j|0)&d>>>0<h>>>0|i>>>0>j>>>0;h=j;K=J&-2;i=Iua(D,t,K,0);p=i+d|0;j=hb+j|0;j=i>>>0>p>>>0?j+1|0:j;i=j;d=(j|0)==(h|0)&d>>>0>p>>>0|h>>>0>j>>>0;h=0;j=d+m|0;d=(j>>>0<d>>>0?1:h)+e|0;n=j+o|0;d=n>>>0<j>>>0?d+1|0:d;j=l;m=d;d=(d|0)==(e|0)&n>>>0<o>>>0|d>>>0<e>>>0;e=d;d=d+u|0;j=e>>>0>d>>>0?j+1|0:j;S=d;u=j;d=Iua(H,q,E,r);L=hb;H=d;e=Iua(F,w,K,r);d=d+e|0;j=hb+L|0;j=d>>>0<e>>>0?j+1|0:j;o=d;l=Iua(v,r,I,t);e=d+l|0;h=j;d=j+hb|0;d=e>>>0<l>>>0?d+1|0:d;q=e;j=Iua(C,r,D,t);e=e+j|0;l=hb+d|0;l=e>>>0<j>>>0?l+1|0:l;F=(d|0)==(l|0)&e>>>0<q>>>0|d>>>0>l>>>0;j=(h|0)==(L|0)&o>>>0<H>>>0|h>>>0<L>>>0;d=(d|0)==(h|0)&o>>>0>q>>>0|d>>>0<h>>>0;d=d+j|0;d=d+F|0;h=l;q=h+n|0;j=(d|w)+m|0;j=h>>>0>q>>>0?j+1|0:j;o=j;d=(m|0)==(j|0)&n>>>0>q>>>0|j>>>0<m>>>0;j=u;h=d;d=d+S|0;j=h>>>0>d>>>0?j+1|0:j;w=d;m=j;d=Iua(v,r,K,r);v=hb;n=d;h=Iua(C,r,E,r);d=d+h|0;j=hb+v|0;j=d>>>0<h>>>0?j+1|0:j;u=0;h=(j|0)==(v|0)&d>>>0<n>>>0|j>>>0<v>>>0;n=j;d=j+p|0;j=(h|u)+i|0;j=d>>>0<n>>>0?j+1|0:j;i=(i|0)==(j|0)&d>>>0<p>>>0|i>>>0>j>>>0;h=j;j=e;p=0;e=p+d|0;l=h+j|0;j=0;l=e>>>0<p>>>0?l+1|0:l;d=(h|0)==(l|0)&d>>>0>e>>>0|h>>>0>l>>>0;e=d;d=d+i|0;j=(e>>>0>d>>>0?1:j)+o|0;l=m;e=d;d=d+q|0;j=e>>>0>d>>>0?j+1|0:j;e=j;h=(o|0)==(j|0)&d>>>0<q>>>0|j>>>0<o>>>0;i=h;h=h+w|0;l=i>>>0>h>>>0?l+1|0:l;i=l;c:{if((l|0)==131071|l>>>0<131071){O=Q|P;N=t|R;Nf(k+80|0,d,j,h,l,f,g,B,z);l=x[k+84>>2];q=l;j=b<<17;o=0;p=x[k+88>>2];c=o-p|0;b=x[k+80>>2];l=(l|b)!=0;m=c-l|0;n=(j-(x[k+92>>2]+(o>>>0<p>>>0)|0)|0)-(c>>>0<l>>>0)|0;p=0-(((b|0)!=0)+q|0)|0;q=M+16382|0;o=0-b|0;break c}d=(e&1)<<31|d>>>1;e=h<<31|e>>>1;h=(i&1)<<31|h>>>1;i=i>>>1|0;Nf(k+96|0,d,e,h,i,f,g,B,z);m=x[k+100>>2];y=m;n=0;q=x[k+104>>2];o=n-q|0;l=x[k+96>>2];p=(m|l)!=0;m=o-p|0;n=((b<<16)-(x[k+108>>2]+(n>>>0<q>>>0)|0)|0)-(o>>>0<p>>>0)|0;p=0-(((l|0)!=0)+y|0)|0;J=b;y=c;q=M+16383|0;o=0-l|0}if((q|0)>=32767){s=s|2147418112;b=0;c=0;break a}d:{if((q|0)>0){b=m<<1|p>>>31;c=n<<1|m>>>31;m=h;n=i&65535|q<<16;l=p<<1|o>>>31;h=o<<1;break d}if((q|0)<=-113){b=0;c=0;break a}cn(k- -64|0,d,e,h,i,1-q|0);$f(k+48|0,J,y,O,N,q+112|0);d=x[k+64>>2];e=x[k+68>>2];m=x[k+72>>2];n=x[k+76>>2];Nf(k+32|0,f,g,B,z,d,e,m,n);b=x[k+40>>2];c=x[k+56>>2];i=x[k+36>>2];p=b<<1|i>>>31;l=c-p|0;p=x[k+60>>2]-((x[k+44>>2]<<1|b>>>31)+(c>>>0<p>>>0)|0)|0;c=x[k+52>>2];q=c;b=x[k+32>>2];h=i<<1|b>>>31;o=b<<1;b=o;j=x[k+48>>2];c=(c|0)==(h|0)&b>>>0>j>>>0|c>>>0<h>>>0;b=l-c|0;c=p-(c>>>0>l>>>0)|0;l=q-((j>>>0<o>>>0)+h|0)|0;h=j-o|0}Nf(k+16|0,f,g,B,z,3,0,0,0);Nf(k,f,g,B,z,5,0,0,0);o=d;p=d&1;i=p;d=h+i|0;j=0;h=j+l|0;h=d>>>0<i>>>0?h+1|0:h;i=d;g=(g|0)==(h|0)&d>>>0>f>>>0|g>>>0<h>>>0;l=c;d=(h|0)==(j|0)&d>>>0<p>>>0|h>>>0<j>>>0;f=b+d|0;l=d>>>0>f>>>0?l+1|0:l;j=e;b=(l|0)==(z|0);b=b&(f|0)==(B|0)?g:b&f>>>0>B>>>0|l>>>0>z>>>0;c=b;b=b+o|0;j=c>>>0>b>>>0?j+1|0:j;c=j;d=(e|0)==(j|0)&b>>>0<o>>>0|e>>>0>j>>>0;j=n;e=d;d=d+m|0;j=e>>>0>d>>>0?j+1|0:j;g=d;e=x[k+20>>2];m=(e|0)==(h|0)&A[k+16>>2]<i>>>0|e>>>0<h>>>0;e=x[k+28>>2];d=x[k+24>>2];e=j>>>0<2147418112&((d|0)==(f|0)&(e|0)==(l|0)?m:(e|0)==(l|0)&d>>>0<f>>>0|e>>>0<l>>>0);d=c;m=e;e=b+e|0;d=m>>>0>e>>>0?d+1|0:d;b=(c|0)==(d|0)&b>>>0>e>>>0|c>>>0>d>>>0;c=b;b=b+g|0;j=c>>>0>b>>>0?j+1|0:j;g=b;c=x[k+4>>2];h=(c|0)==(h|0)&A[k>>2]<i>>>0|c>>>0<h>>>0;c=x[k+12>>2];b=x[k+8>>2];b=j>>>0<2147418112&((b|0)==(f|0)&(c|0)==(l|0)?h:(c|0)==(l|0)&b>>>0<f>>>0|c>>>0<l>>>0);c=b;b=b+e|0;l=c>>>0>b>>>0?d+1|0:d;c=l;e=(d|0)==(l|0)&b>>>0<e>>>0|d>>>0>l>>>0;d=j;f=e;e=e+g|0;d=f>>>0>e>>>0?d+1|0:d;r=e|r;s=d|s}x[a>>2]=b;x[a+4>>2]=c;x[a+8>>2]=r;x[a+12>>2]=s;fb=k+336|0}function TO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=fb-32|0;fb=f;d=Dc(f+20|0,11616);e=oh(c,d);tb(d);a:{b:{c:{d:{e:{if(e){qo(a,x[b+24>>2]+1298356|0);break e}d=Dc(f+20|0,11021);e=oh(c,d);tb(d);if(e){qo(a,x[b+24>>2]+1298344|0);break e}d=Dc(f+20|0,11446);e=oh(c,d);tb(d);if(e){qo(a,x[b+24>>2]+1298392|0);break e}d=Dc(f+20|0,11013);e=oh(c,d);tb(d);if(e){qo(a,x[b+24>>2]+1298380|0);break e}d=f+20|0;e=Dc(d,8243);g=oh(c,e);tb(e);if(g){e=x[x[b+24>>2]+480184>>2];c=0;f:{g:{while(1){b=c;if((b|0)==48){break g}c=b+12|0;if((e|0)!=x[b+30992>>2]){continue}break}c=fb-32|0;fb=c;e=c+8|0;Xw(e,x[b+31e3>>2]);x[31609]=0;b=c+20|0;S(123,b|0,0,e|0);g=x[31609];x[31609]=0;h:{i:{j:{if((g|0)!=1){x[31609]=0;O(12,d|0,b|0);g=x[31609];x[31609]=0;if((g|0)==1){break j}Ub(b);tb(e);fb=c+32|0;break h}a=N()|0;break i}a=N()|0;Ub(c+20|0)}tb(c+8|0);Q(a|0);p()}break f}Fb(d)}x[31609]=0;O(1059,a|0,d|0);a=x[31609];x[31609]=0;if((a|0)==1){break d}tb(d);break e}g=f+20|0;d=Dc(g,10998);e=oh(c,d);tb(d);if(e){l=x[x[b+24>>2]+480184>>2];c=fb-48|0;fb=c;h=og(c+36|0);d=Fb(g);b=0;while(1){if((b|0)!=48){if(x[b+30992>>2]==(l|0)){x[31609]=0;e=P(1,c+24|0,x[b+30996>>2])|0;i=x[31609];x[31609]=0;k:{l:{m:{n:{o:{p:{if((i|0)!=1){x[31609]=0;S(888,c+16|0,h|0,e|0);i=x[31609];x[31609]=0;if((i|0)==1){break n}if(!y[c+20|0]){break k}if(!Ad(x[d+4>>2],y[d+11|0])){x[31609]=0;i=P(1,c+4|0,18410)|0;k=x[31609];x[31609]=0;if((k|0)==1){break p}x[31609]=0;P(74,d|0,i|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break o}tb(i)}x[31609]=0;P(74,d|0,e|0)|0;i=x[31609];x[31609]=0;if((i|0)!=1){break k}b=N()|0;break m}b=N()|0;break l}b=N()|0;break m}b=N()|0;tb(i);break m}b=N()|0}tb(e)}tb(d);HR(h);Q(b|0);p()}tb(e)}b=b+12|0;continue}break}HR(h);fb=c+48|0;x[31609]=0;O(1059,a|0,g|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(g);break e}c=N()|0;tb(f+20|0);break a}d=Dc(f+20|0,8309);e=oh(c,d);tb(d);if(e){qo(a,x[b+24>>2]+1298368|0);break e}d=Dc(f+20|0,5620);e=oh(c,d);tb(d);if(e){qo(a,x[b+24>>2]+1298320|0);break e}d=f+20|0;e=Dc(d,12020);g=oh(c,e);tb(e);if(g){jg(d,x[b+24>>2]+1298308|0);b=x[b+24>>2];x[31609]=0;S(1053,a|0,b|0,d|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(d);break e}c=N()|0;tb(f+20|0);break a}d=Dc(f+20|0,11389);e=oh(c,d);tb(d);if(e){d=eM(x[b+24>>2]);c=x[d+4>>2];q:{if(!mc(x[d>>2],c)){e=gw(c);d=fb-32|0;fb=d;x[d+8>>2]=0;x[d+12>>2]=0;x[d+16>>2]=0;x[d>>2]=0;x[d+4>>2]=0;x[d+24>>2]=0;x[d+28>>2]=0;c=fb-48|0;fb=c;IF(c+24|0,e,e+4|0,e+8|0,e+12|0,e+16|0,e+24|0);IF(c,d,d+4|0,d+8|0,d+12|0,d+16|0,d+24|0);e=x[c+28>>2];g=x[c+4>>2];fb=c+48|0;fb=d+32|0;if(x[e>>2]==x[g>>2]&x[x[c+24>>2]>>2]==x[x[c>>2]>>2]&x[x[c+32>>2]>>2]==x[x[c+8>>2]>>2]&x[x[c+36>>2]>>2]==x[x[c+12>>2]>>2]&x[x[c+40>>2]>>2]==x[x[c+16>>2]>>2]){e=x[c+44>>2];g=x[c+20>>2];c=x[e>>2]==x[g>>2]&x[e+4>>2]==x[g+4>>2]}else{c=0}if(!c){break q}}Fb(a);break e}g=f+20|0;b=x[b+24>>2];e=gw(x[eM(b)+4>>2]);h=x[b+1298408>>2];d=fb-512|0;fb=d;i=x[e+32>>2];r:{if(i){b=-1;j=Ge(+(i>>>0)/18.2);c=2147483647;s:{if(j>=0x8000000000000000){break s}b=0;c=-2147483648;if(j<=-0x8000000000000000){break s}if(F(j)<0x8000000000000000){b=~~j>>>0;if(F(j)>=1){c=~~(j>0?H(J(j*2.3283064365386963e-10),4294967295):K((j-+(~~j>>>0>>>0))*2.3283064365386963e-10))>>>0}else{c=0}break s}c=-2147483648}if((h|0)==1){h=x[e+28>>2];x[d+184>>2]=x[e+24>>2];x[d+188>>2]=h;h=x[e+20>>2];x[d+176>>2]=x[e+16>>2];x[d+180>>2]=h;h=x[e+12>>2];x[d+168>>2]=x[e+8>>2];x[d+172>>2]=h;h=x[e+4>>2];x[d+160>>2]=x[e>>2];x[d+164>>2]=h;Hu(d+480|0,d+160|0);e=x[d+508>>2];x[d+152>>2]=x[d+504>>2];x[d+156>>2]=e;e=x[d+500>>2];x[d+144>>2]=x[d+496>>2];x[d+148>>2]=e;e=x[d+492>>2];x[d+136>>2]=x[d+488>>2];x[d+140>>2]=e;e=x[d+484>>2];x[d+128>>2]=x[d+480>>2];x[d+132>>2]=e;e=d+448|0;h=_A(GS(d+128|0),hb);c=c+hb|0;i=b;b=b+h|0;c=i>>>0>b>>>0?c+1|0:c;ES(e,FS(b,c),hb);b=x[d+476>>2];x[d+120>>2]=x[d+472>>2];x[d+124>>2]=b;b=x[d+468>>2];x[d+112>>2]=x[d+464>>2];x[d+116>>2]=b;b=x[d+460>>2];x[d+104>>2]=x[d+456>>2];x[d+108>>2]=b;b=x[d+452>>2];x[d+96>>2]=x[d+448>>2];x[d+100>>2]=b;HN(g,d+96|0);break r}h=x[e+28>>2];x[d+312>>2]=x[e+24>>2];x[d+316>>2]=h;h=x[e+20>>2];x[d+304>>2]=x[e+16>>2];x[d+308>>2]=h;h=x[e+12>>2];x[d+296>>2]=x[e+8>>2];x[d+300>>2]=h;h=x[e+4>>2];x[d+288>>2]=x[e>>2];x[d+292>>2]=h;Hu(d+416|0,d+288|0);e=x[d+444>>2];x[d+280>>2]=x[d+440>>2];x[d+284>>2]=e;e=x[d+436>>2];x[d+272>>2]=x[d+432>>2];x[d+276>>2]=e;e=x[d+428>>2];x[d+264>>2]=x[d+424>>2];x[d+268>>2]=e;e=x[d+420>>2];x[d+256>>2]=x[d+416>>2];x[d+260>>2]=e;e=d+352|0;h=_A(GS(d+256|0),hb);c=c+hb|0;i=b;b=b+h|0;c=i>>>0>b>>>0?c+1|0:c;ES(e,FS(b,c),hb);b=x[d+380>>2];x[d+248>>2]=x[d+376>>2];x[d+252>>2]=b;b=x[d+372>>2];x[d+240>>2]=x[d+368>>2];x[d+244>>2]=b;b=x[d+364>>2];x[d+232>>2]=x[d+360>>2];x[d+236>>2]=b;b=x[d+356>>2];x[d+224>>2]=x[d+352>>2];x[d+228>>2]=b;Hu(d+384|0,d+224|0);b=x[d+412>>2];x[d+216>>2]=x[d+408>>2];x[d+220>>2]=b;b=x[d+404>>2];x[d+208>>2]=x[d+400>>2];x[d+212>>2]=b;b=x[d+396>>2];x[d+200>>2]=x[d+392>>2];x[d+204>>2]=b;b=x[d+388>>2];x[d+192>>2]=x[d+384>>2];x[d+196>>2]=b;JO(g,d+192|0);break r}if((h|0)==1){b=x[e+28>>2];x[d+56>>2]=x[e+24>>2];x[d+60>>2]=b;b=x[e+20>>2];x[d+48>>2]=x[e+16>>2];x[d+52>>2]=b;b=x[e+12>>2];x[d+40>>2]=x[e+8>>2];x[d+44>>2]=b;b=x[e+4>>2];x[d+32>>2]=x[e>>2];x[d+36>>2]=b;Hu(d+320|0,d+32|0);b=x[d+348>>2];x[d+24>>2]=x[d+344>>2];x[d+28>>2]=b;b=x[d+340>>2];x[d+16>>2]=x[d+336>>2];x[d+20>>2]=b;b=x[d+332>>2];x[d+8>>2]=x[d+328>>2];x[d+12>>2]=b;b=x[d+324>>2];x[d>>2]=x[d+320>>2];x[d+4>>2]=b;HN(g,d);break r}b=x[e+28>>2];x[d+88>>2]=x[e+24>>2];x[d+92>>2]=b;b=x[e+20>>2];x[d+80>>2]=x[e+16>>2];x[d+84>>2]=b;b=x[e+12>>2];x[d+72>>2]=x[e+8>>2];x[d+76>>2]=b;b=x[e+4>>2];x[d+64>>2]=x[e>>2];x[d+68>>2]=b;JO(g,d- -64|0)}fb=d+512|0;x[31609]=0;O(1059,a|0,g|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(g);break e}c=N()|0;tb(f+20|0);break a}d=f+20|0;e=Dc(d,12289);g=oh(c,e);tb(e);if(g){sV(d,x[b+24>>2]+1298332|0);t:{if(!Ad(x[f+24>>2],y[f+31|0])){break t}c=x[x[b+24>>2]+480180>>2];u:{v:{if((c|0)==33554432){break v}d=1;if((c|0)==32){break u}if((c|0)==16384){break v}if((c|0)==16777216){break u}}d=2}w:{switch(d-1|0){case 0:x[31609]=0;c=f+8|0;O(1060,c|0,b|0);d=x[31609];x[31609]=0;if((d|0)!=1){zb(f+20|0,c);tb(c);break t}break b;case 1:break w;default:break t}}x[31609]=0;c=f+8|0;O(1061,c|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break b}d=zb(f+20|0,c);tb(c);if(!Ad(x[f+24>>2],y[f+31|0])){break t}x[31609]=0;O(1060,c|0,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break b}zb(d,c);tb(c)}b=x[b+24>>2];x[31609]=0;c=a;a=f+20|0;S(1053,c|0,b|0,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){tb(a);break e}break b}d=f+20|0;e=Dc(d,5472);g=oh(c,e);tb(e);if(g){sV(d,x[b+24>>2]+1298332|0);b=x[b+24>>2];x[31609]=0;S(1053,a|0,b|0,d|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(d);break e}c=N()|0;tb(f+20|0);break a}i=c;c=Dc(f+20|0,7335);d=oh(i,c);tb(c);if(d){a=Fb(a);c=wb(x[b+68>>2]);x[f+20>>2]=c;d=wb(x[b+72>>2]);b=1;while(1){if(!Ib(c,d)){break e}if(!(b&1)){x[31609]=0;P(985,a|0,22267)|0;b=x[31609];x[31609]=0;if((b|0)==1){break c}}x[31609]=0;P(838,a|0,c|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break c}c=x[ym(f+20|0)>>2];b=0;continue}}Dc(a,22292)}fb=f+32|0;return}c=N()|0;tb(f+20|0);break a}c=N()|0;tb(a);break a}c=N()|0;tb(f+20|0)}Q(c|0);p()}function Cpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,A=0,B=0,C=0,E=0,F=0;d=fb-1328|0;fb=d;yc(b);e=fb-16|0;fb=e;h=d+220|0;DX(e+8|0,h);i=x[e+12>>2];lc(e,x[b>>2],x[b+8>>2],x[e+8>>2],x[e+12>>2]);f=x[e+4>>2];if((f|0)==(i|0)){Vb(b,x[e+12>>2])}fb=e+16|0;a:{if((f|0)!=(i|0)){break a}if(!FX(h)){break a}if(!Mb(x[b>>2],x[b+8>>2],Bc(EX(y[d+1324|0]|y[d+1325|0]<<8|(y[d+1326|0]<<16|y[d+1327|0]<<24)),hb))){break a}n=1;if((c|0)==64){break a}yc(b);b=Ie(d+220|0,b);x[31609]=0;e=d+208|0;O(642,e|0,b|0);i=x[31609];x[31609]=0;b:{c:{d:{e:{f:{g:{h:{i:{if((i|0)!=1){ub(b);x[31609]=0;S(643,d+196|0,e|0,1196314451);b=x[31609];x[31609]=0;if((b|0)==1){break i}n=0;x[31609]=0;S(643,d+184|0,e|0,1280331091);b=x[31609];x[31609]=0;if((b|0)==1){break h}if(mc(x[d+196>>2],x[d+200>>2])){break b}if(!mc(x[d+184>>2],x[d+188>>2])){break g}break b}c=N()|0;ub(b);break d}c=N()|0;break e}c=N()|0;break f}x[31609]=0;O(246,a|0,1);b=x[31609];x[31609]=0;j:{if((b|0)!=1){eg(a);x[a+480188>>2]=4;x[a+480208>>2]=25231360;E=d,F=wb(x[d+184>>2]),x[E+52>>2]=F;f=c&2;m=wb(x[d+188>>2]);k:{l:{while(1){e=x[d+52>>2];if(!Ib(e,m)){break l}b=z[a+480190>>1];if(!pi(b)){break l}b=b+1|0;w[a+480190>>1]=b;x[31609]=0;b=D(b&65535,104)+a|0;i=b+484380|0;O(279,i|0,1);h=x[31609];x[31609]=0;m:{n:{if((h|0)!=1){x[31609]=0;h=d+220|0;l=P(644,e|0,h|0)|0;n=x[31609];x[31609]=0;if((n|0)==1){break n}if(!l){break c}if(Ev(h)){break m}break c}c=N()|0;break j}c=N()|0;break j}x[31609]=0;h=P(36,d+172|0,d+220|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break k}Ac(((z[a+480190>>1]<<5)+a|0)+946304|0,h);tb(h);h=y[d+256|0]|y[d+257|0]<<8|(y[d+258|0]<<16|y[d+259|0]<<24);x[i>>2]=h;x[b+484388>>2]=h;x[b+484384>>2]=y[d+252|0]|y[d+253|0]<<8|(y[d+254|0]<<16|y[d+255|0]<<24);h=b+484414|0;w[h>>1]=z[h>>1]|2;w[b+484410>>1]=255;o:{if(f){b=Zc(d+24|0,8,1,0,0);x[31609]=0;U(215,b|0,i|0,e|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break o}}Qf(d+52|0);continue}break}c=N()|0;break j}E=d,F=wb(x[d+196>>2]),x[E+168>>2]=F;o=a+484344|0;q=c&1;r=a+484360|0;B=wb(x[d+200>>2]);s=a+484380|0;t=a+946304|0;c=1;n=1;while(1){p:{q:{r:{s:{t:{u:{v:{b=x[d+168>>2];if(!Ib(b,B)){break v}if(!(c&1)){x[31609]=0;c=R(274,r|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break u}if(!c){break v}}Nc(Xb(x[a+484360>>2],y[a+484376|0]));x[31609]=0;e=d+220|0;c=P(645,b|0,e|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break t}if(!(!(y[d+1306|0]|y[d+1307|0]<<8)&c)|(y[d+1308|0]|y[d+1309|0]<<8|(y[d+1310|0]<<16|y[d+1311|0]<<24))-5>>>0<4294967292){break c}i=y[a+484376|0];h=x[a+484360>>2];x[31609]=0;c=d+156|0;O(646,c|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break t}op(Xb(h,i),c);tb(c);w:{if(q){x[31609]=0;S(185,d+52|0,b|0,y[d+1316|0]|y[d+1317|0]<<8|(y[d+1318|0]<<16|y[d+1319|0]<<24));b=x[31609];x[31609]=0;if((b|0)!=1){break w}c=N()|0;break j}x[31609]=0;b=R(168,d+116|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break s}wG(d+52|0,b)}b=d+52|0;m=hc(d+136|0,b);ub(b);if(!q){ub(d+116|0)}Rb(d+52|0,0,64);l=1;x:{y:{z:{while(1){if((l|0)==32){break z}b=(D(l,34)+d|0)+186|0;c=b+32|0;Fn(d+8|0,c);A:{B:{if(Mj(y[x[d+8>>2]])){break B}e=y[b- -64|0];if(e>>>0>15){break y}b=y[b+65|0];if(b>>>0>64){break y}if(!Ev(c)){break y}i=b<<2;h=e<<4;c=0;b=1;while(1){f=b&65535;e=z[a+480190>>1];if(f>>>0<=e>>>0){x[31609]=0;k=d+24|0;S(647,k|0,x[d+8>>2],x[d+12>>2]);e=x[31609];x[31609]=0;if((e|0)==1){break A}e=fb-32|0;fb=e;fe(e+24|0,k);AX(e+16|0,((f<<5)+a|0)+946304|0);g=x[e+20>>2];x[e+8>>2]=x[e+16>>2];x[e+12>>2]=g;g=Ic(x[e+24>>2],x[e+28>>2],e+8|0);fb=e+32|0;tb(k);C:{if(g^1){break C}E=bc(d+52|0,l),F=b,w[E>>1]=F;e=D(f,104)+a|0;f=e+484410|0;k=z[f>>1];if((k|0)!=255){c=b;if(y[e+484417|0]!=(h&255)|(i|0)!=(k|0)){break C}}v[e+484417|0]=h;w[f>>1]=i;break B}b=b+1|0;continue}break}c=c&65535;if(!c){break B}if(!pi(e)){break B}b=e+1|0;w[a+480190>>1]=b;E=bc(d+52|0,l),F=b,w[E>>1]=F;b=D(z[a+480190>>1],104)+s|0;on(b);e=D(c,104)+s|0;f=Wo(b,e);w[b+30>>1]=i;v[b+37|0]=h;vY(f,e);c=(c<<5)+t|0;e=x[c+4>>2];b=(z[a+480190>>1]<<5)+t|0;x[b>>2]=x[c>>2];x[b+4>>2]=e;e=x[c+28>>2];x[b+24>>2]=x[c+24>>2];x[b+28>>2]=e;e=x[c+20>>2];x[b+16>>2]=x[c+16>>2];x[b+20>>2]=e;e=x[c+12>>2];x[b+8>>2]=x[c+8>>2];x[b+12>>2]=e}l=l+1|0;continue}break}break r}h=0;x[d+48>>2]=0;x[d+40>>2]=0;x[d+44>>2]=0;x[d+32>>2]=0;x[d+36>>2]=0;x[d+24>>2]=0;x[d+28>>2]=0;e=64;i=65535;C=y[d+1308|0]|y[d+1309|0]<<8;k=0;D:while(1){E:{if(k){break E}b=x[m>>2];x[31609]=0;b=U(150,b|0,x[d+144>>2],1)|0;c=x[31609];x[31609]=0;if((c|0)==1){break x}if(b){break E}c=i;b=e;break q}b=e+1|0;F:{if(e>>>0<63){e=b;break F}x[31609]=0;i=P(367,o|0,64)|0;c=x[31609];x[31609]=0;if((c|0)==1){break x}c=65535;if((i|0)==65535){break q}b=y[a+484376|0];c=x[a+484360>>2];e=0;x[31609]=0;O(537,Xb(c,b)|0,i|0);b=x[31609];x[31609]=0;if((b|0)==1){break x}}b=0;c=Wb(x[o>>2],i&65535);c=md(x[c>>2],x[x[c+48>>2]+12>>2],e,0);while(1){if((b|0)==(C|0)){continue D}f=(d+24|0)+D(b,7)|0;g=y[f+6|0];G:{if(g){v[f+6|0]=g-1;g=y[f+4|0]|y[f+5|0]<<8;v[c+4|0]=g;v[c+5|0]=g>>>8;f=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);v[c|0]=f;v[c+1|0]=f>>>8;v[c+2|0]=f>>>16;v[c+3|0]=f>>>24;k=k-1|0;break G}g=x[m>>2];x[31609]=0;g=U(150,g|0,x[d+144>>2],1)|0;j=x[31609];x[31609]=0;if((j|0)==1){break r}if(!g){break G}if(x[d+144>>2]==(y[d+1312|0]|y[d+1313|0]<<8|(y[d+1314|0]<<16|y[d+1315|0]<<24))){h=Xb(x[a+484360>>2],y[a+484376|0]);$e(h,mE(x[h>>2],x[h+4>>2]));h=e}x[31609]=0;g=R(197,m|0)|0;j=x[31609];x[31609]=0;H:{if((j|0)!=1){g=g<<24>>24;if((g|0)>=0){break H}g=g&127;v[f+6|0]=g;j=y[f+4|0]|y[f+5|0]<<8;v[c+4|0]=j;v[c+5|0]=j>>>8;f=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);v[c|0]=f;v[c+1|0]=f>>>8;v[c+2|0]=f>>>16;v[c+3|0]=f>>>24;k=g+k|0;break G}break r}if((g-1&255)>>>0<=35){v[c|0]=g+48}x[31609]=0;g=R(197,m|0)|0;j=x[31609];x[31609]=0;I:{J:{if((j|0)!=1){g=g<<24>>24;E=c,F=y[bc(d+52|0,g&31)|0],v[E+1|0]=F;if((g|0)>=0){break J}v[c+3|0]=y[f+3|0];v[c+5|0]=y[f+5|0];break I}break r}x[31609]=0;j=d+8|0;O(198,j|0,m|0);g=x[31609];x[31609]=0;K:{if((g|0)!=1){g=y[d+8|0];if(g>>>0>19){break I}u=g<<1;A=y[u+25328|0];v[c+3|0]=A;j=y[Jc(j)|0];v[c+5|0]=j;if((A|0)!=16|j>>>0<32){break K}v[c+3|0]=17;break I}break r}if(819137>>>g&1){break I}v[c+5|0]=y[u+25329|0]|j&15}g=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);v[f|0]=g;v[f+1|0]=g>>>8;v[f+2|0]=g>>>16;v[f+3|0]=g>>>24;g=y[c+4|0]|y[c+5|0]<<8;v[f+4|0]=g;v[f+5|0]=g>>>8}c=c+6|0;b=b+1|0;continue}}}n=0;break p}break r}Wj(r,0);x[31609]=0;b=P(1,d+220|0,6467)|0;c=x[31609];x[31609]=0;L:{if((c|0)!=1){zb(a+1298344|0,b);tb(b);x[31609]=0;b=P(1,d+52|0,6804)|0;c=x[31609];x[31609]=0;if((c|0)==1){break L}zb(a+1298356|0,b);tb(b);E=a+1298404|0,F=x[Fc(d+24|0,4)>>2],x[E>>2]=F;n=1;break b}c=N()|0;break j}c=N()|0;break j}c=N()|0;break j}c=N()|0;break j}c=N()|0;break j}c=N()|0;ub(m);break j}c=c&65535;if(!((h|0)!=0|b>>>0<63)|(c|0)==65535){break p}Ae(Wb(x[o>>2],c),Xh(Ve(Oe(d+8|0,14,h&255),b)))}ub(m);if((l|0)!=32){break b}Qf(d+168|0);c=0;continue}}c=N()|0;break j}c=N()|0}Rc(d+184|0)}Rc(d+196|0)}ke(d+208|0)}Q(c|0);p()}n=0}Rc(d+184|0);Rc(d+196|0);ke(d+208|0)}fb=d+1328|0;return n|0}function joa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;h=fb-256|0;fb=h;e=fb-112|0;fb=e;f=Ie(h+76|0,c);x[31609]=0;o=R(168,f+20|0)|0;c=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{if((c|0)!=1){x[31609]=0;r=R(168,f+40|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break B}x[31609]=0;s=R(168,f+60|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break A}x[31609]=0;i=R(168,f+80|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break z}x[31609]=0;q=R(168,f+100|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break y}x[31609]=0;m=R(168,f+120|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break x}j=Nb(f+140|0);yc(f);x[f+172>>2]=1873739776;w[f+176>>1]=0;x[31609]=0;d=P(806,f|0,e+100|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break w}if(!d){break n}d=x[e+100>>2];if((d|0)!=1414744396&(d|0)!=1179011410){break n}c=x[e+108>>2];if((c|0)!=1163280727&(c|0)!=1702257015){break n}v[f+176|0]=(d|0)==1414744396;x[31609]=0;g=e+88|0;S(807,g|0,f|0,2);c=x[31609];x[31609]=0;if((c|0)==1){break v}k=x[e+88>>2];C:{if(Gr(k,x[e+92>>2])>>>0<4){break C}l=e+36|0;c=yA(k,1);d=x[c>>2];c=x[c+4>>2];ri(l,d,c);if(x[e+36>>2]!=1635017060){break C}ri(e+60|0,d,c);if(!(v[e+64|0]&1)){break C}c=yA(k,2);ri(e+16|0,x[c>>2],x[c+4>>2]);if(y[e+20|0]|y[e+21|0]<<8|(y[e+22|0]<<16|y[e+23|0]<<24)){break C}c=yA(k,3);ri(e+80|0,x[c>>2],x[c+4>>2]);if(x[e+80>>2]){break C}x[31609]=0;P(149,f|0,12)|0;c=x[31609];x[31609]=0;if((c|0)==1){break u}x[31609]=0;S(807,l|0,f|0,1);c=x[31609];x[31609]=0;if((c|0)==1){break t}Cv(g,l);ke(l)}x[31609]=0;g=e+60|0;S(808,g|0,e+88|0,544501094);c=x[31609];x[31609]=0;if((c|0)==1){break s}x[31609]=0;d=P(809,g|0,f+156|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break k}if(!d){break o}d=z[f+156>>1];if((d|0)!=1){break q}x[31609]=0;d=R(202,g|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break r}break k}d=N()|0;break b}d=N()|0;break c}d=N()|0;break d}d=N()|0;break e}d=N()|0;break f}d=N()|0;break g}d=N()|0;break h}d=N()|0;break h}d=N()|0;break i}d=N()|0;break i}d=N()|0;break i}if((d|0)==4){x[31609]=0;g=R(192,e+60|0)|0;c=x[31609];x[31609]=0;D:{if((c|0)!=1){x[31609]=0;d=R(192,e+60|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break D}if((g|0)!=2|(d|0)!=1){break p}v[f+177|0]=1;break p}d=N()|0;break j}d=N()|0;break j}d=z[f+156>>1]}if((d&65535)!=65534){break p}x[31609]=0;d=P(810,e+60|0,e+36|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break l}if(!d){break o}c=y[e+56|0]|y[e+57|0]<<8|(y[e+58|0]<<16|y[e+59|0]<<24);x[e+8>>2]=y[e+52|0]|y[e+53|0]<<8|(y[e+54|0]<<16|y[e+55|0]<<24);x[e+12>>2]=c;c=y[e+48|0]|y[e+49|0]<<8|(y[e+50|0]<<16|y[e+51|0]<<24);x[e>>2]=y[e+44|0]|y[e+45|0]<<8|(y[e+46|0]<<16|y[e+47|0]<<24);x[e+4>>2]=c;c=e+16|0;x[c>>2]=y[e|0]|y[e+1|0]<<8|(y[e+2|0]<<16|y[e+3|0]<<24);w[c+4>>1]=y[e+4|0]|y[e+5|0]<<8;w[c+6>>1]=y[e+6|0]|y[e+7|0]<<8;t=c,u=pA(y[e+8|0]|y[e+9|0]<<8|(y[e+10|0]<<16|y[e+11|0]<<24),y[e+12|0]|y[e+13|0]<<8|(y[e+14|0]<<16|y[e+15|0]<<24)),x[t+8>>2]=u;x[c+12>>2]=hb;w[f+172>>1]=x[c>>2]}x[31609]=0;k=e+36|0;g=e+88|0;S(808,k|0,g|0,1635017060);c=x[31609];x[31609]=0;E:{F:{G:{H:{I:{J:{if((c|0)!=1){l=kd(o,k);ub(k);c=x[l>>2];x[31609]=0;d=R(172,c|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break k}if(!d){x[31609]=0;S(808,k|0,g|0,544039792);c=x[31609];x[31609]=0;if((c|0)==1){break J}kd(l,k);ub(k)}x[31609]=0;g=e+36|0;S(808,g|0,e+88|0,1952670054);c=x[31609];x[31609]=0;if((c|0)==1){break I}x[31609]=0;d=R(151,g|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break H}x[f+152>>2]=d;ub(g);if(x[f+152>>2]?z[f+156>>1]==17:0){break E}g=z[f+158>>1];d=CR(g,z[f+170>>1]);if(!d){break E}c=z[f+168>>1];if(c){if((c>>>0)/(g>>>0)>>>0<d<<1>>>0){break G}}c=x[l>>2];x[31609]=0;d=R(154,c|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break k}c=CR(z[f+158>>1],z[f+170>>1]);break F}d=N()|0;break j}d=N()|0;break j}d=N()|0;break j}d=N()|0;ub(e+36|0);break j}c=x[l>>2];x[31609]=0;d=R(154,c|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break k}c=z[f+168>>1]}x[f+152>>2]=(d>>>0)/((c&65535)>>>0)}x[31609]=0;g=e+88|0;d=P(811,f|0,g|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break k}w[f+174>>1]=d;x[31609]=0;O(812,f|0,g|0);c=x[31609];x[31609]=0;if((c|0)==1){break k}x[31609]=0;d=e+36|0;S(808,d|0,g|0,1886221175);c=x[31609];x[31609]=0;if((c|0)==1){break m}kd(q,d);ub(d)}ub(e+60|0);ke(e+88|0)}fb=e+112|0;break a}d=N()|0;break j}d=N()|0;break j}d=N()|0}ub(e+60|0)}ke(e+88|0)}ke(j);ub(m)}ub(q)}ub(i)}ub(s)}ub(r)}ub(o)}ub(f);Q(d|0);p()}c=x[f+20>>2];x[31609]=0;d=R(744,c|0)|0;c=x[31609];x[31609]=0;K:{L:{if((c|0)!=1){M:{if(!d|(z[f+158>>1]-3&65535)>>>0<65534){break M}N:{O:{c=z[f+170>>1];P:{if(!c){if((Dk(f)|0)==85){break P}break M}if(c>>>0>31){break O}}if((Dk(f)|0)!=3){break N}break M}if(c>>>0>64){break M}}d=Dk(f);c=28576;while(1){Q:{R:{if((c|0)!=28600){if((d|0)!=x[c>>2]){break R}}else{c=28600}break Q}c=c+4|0;continue}break}if((c|0)==28600){break M}Wu(a,b);x[31609]=0;g=P(36,h- -64|0,22292)|0;c=x[31609];x[31609]=0;S:{T:{U:{V:{W:{if((c|0)!=1){d=Ac(((b<<5)+a|0)+946304|0,g);tb(g);x[31609]=0;g=D(b,104)+a|0;i=g+484380|0;O(279,i|0,0);c=x[31609];x[31609]=0;if((c|0)==1){break W}x[i>>2]=x[f+152>>2];x[g+484404>>2]=x[f+160>>2];c=x[a+1298404>>2];x[31609]=0;V(745,f|0,i|0,c|0,d|0);c=x[31609];x[31609]=0;if((c|0)==1){break W}Ie(h+44|0,f+20|0);d=z[f+158>>1];j=Zc(h+40|0,8,d>>>0>1?2:1,0,0);c=Dk(f);if((c|0)!=17|d>>>0>2){break U}xc(i,268435456);b=g+484414|0;w[b>>1]=z[b>>1]&65470|((d|0)==2)<<6|1;if(Gh(i)){break V}break S}n=N()|0;break K}n=N()|0;break K}j=x[g+484400>>2];g=x[i>>2];m=Ie(h+20|0,h+44|0);d=z[f+158>>1];c=z[f+168>>1];x[31609]=0;b=x[m+12>>2];x[h+8>>2]=x[m+8>>2];x[h+12>>2]=b;x[h+16>>2]=x[m+16>>2];b=x[m+4>>2];x[h>>2]=x[m>>2];x[h+4>>2]=b;aa(746,j|0,g|0,h|0,c|0,d|0);b=x[31609];x[31609]=0;if((b|0)==1){break L}Jj(i,a);break T}if((c|0)==85){x[31609]=0;c=U(574,a|0,b|0,h+44|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break L}if(c){break T}break S}X:{Y:{Z:{if(IV(z[f+156>>1])){break Z}_:{if(!Id(y[f+177|0])){break _}if((Dk(f)|0)!=1|z[f+170>>1]!=32|z[f+168>>1]!=d<<2){break _}hd(j,32);b=12;break Y}if((Dk(f)|0)!=1|z[f+170>>1]!=24|z[f+168>>1]!=d<<2){break Z}hd(j,32);b=13;break Y}if((Dk(f)&65534)!=6){break X}hd(j,16);b=(Dk(f)|0)==6?17:16}wg(j,b);x[31609]=0;U(215,j|0,i|0,h+44|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break T}break L}d=z[f+170>>1];c=d-1|0;b=c&-8;g=b&31;if((b&63)>>>0>=32){b=1074268168>>>g|0}else{b=((1<<g)-1&1074268168)<<32-g|538447880>>>g}hd(j,(c>>>0>=64?8:b)&120);if(d>>>0<9){wg(j,1)}if((Dk(f)|0)==3){wg(j,3)}x[31609]=0;U(215,j|0,i|0,h+44|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break L}}eC(i,x[a+480180>>2]);Jj(i,a);n=1}ub(h+44|0)}HV(f);fb=h+256|0;return n|0}n=N()|0;break K}n=N()|0;ub(h+44|0)}HV(f);Q(n|0);p()}function yga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=E(0),f=E(0),g=E(0),h=E(0),i=E(0),j=E(0),k=E(0),l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=E(0),z=E(0),A=0,C=0,D=0,F=E(0),G=E(0),H=0,I=E(0);a:{if(!y[a+5046|0]){break a}g=B[a+4268>>2];WP(a);if(B[a+4268>>2]==g){break a}Tz(a)}b:{if(!y[a+5045|0]){break b}if(!ui(a+44|0)){break b}n=x[a+44>>2];q=Hc(n,0);r=Hc(n,1);n=x[a+56>>2];l=Hc(n,0);m=Hc(n,1);c:{if(!(!y[a+5044|0]|(!d|y[a+4264|0]&2))){B[l>>2]=B[a+5036>>2];B[m>>2]=B[a+5040>>2];v[a+5044|0]=0;r=r+4|0;q=q+4|0;m=m+4|0;l=l+4|0;p=d-1|0;break c}p=d}s=p;t=a+4888|0;u=a+4864|0;d:{while(1){if(!s){break d}g=B[q>>2];g=E(E(E(B[a+5008>>2]-g)*B[a+4276>>2])+g);B[a+5008>>2]=g;H=Pc(x[a+4864>>2],x[a+4868>>2],x[a+4880>>2]),I=g,B[H>>2]=I;g=B[r>>2];g=E(E(E(B[a+5012>>2]-g)*B[a+4276>>2])+g);B[a+5012>>2]=g;H=Pc(x[a+4888>>2],x[a+4892>>2],x[a+4904>>2]),I=g,B[H>>2]=I;g=E(E(E(E(E(ki(u,x[a+4356>>2])*E(.6800000071525574))+E(ki(u,x[a+4360>>2])*E(-.5)))-E(ki(u,x[a+4364>>2])*E(.6200000047683716)))+E(ki(u,x[a+4368>>2])*E(-.5)))-E(ki(u,x[a+4372>>2])*E(.6200000047683716)));if(v[a+4264|0]&1){e=g;g=E(B[Pc(x[a+4816>>2],x[a+4820>>2],x[a+4836>>2])>>2]+E(e*E(.6180340051651001)));H=Pc(x[a+4816>>2],x[a+4820>>2],x[a+4832>>2]),I=E(e-E(g*E(.6180340051651001))),B[H>>2]=I}w=B[a+4280>>2];H=a,I=E(ki(u,x[a+4352>>2])+B[a+5020>>2]),B[H+5020>>2]=I;e=E(ki(t,x[a+4376>>2])+B[a+5024>>2]);B[a+5024>>2]=e;f=B[a+5020>>2];h=E(E(E(B[a+4980>>2]-B[Pc(x[a+4624>>2],x[a+4628>>2],x[a+4644>>2])>>2])*B[a+4444>>2])+B[Pc(x[a+4624>>2],x[a+4628>>2],x[a+4644>>2])>>2]);B[a+4980>>2]=h;k=E(h*B[a+4440>>2]);j=E(e*E(.7070000171661377));i=E(f*E(-.7070000171661377));f=E(j+i);h=B[a+4272>>2];e=E(k+E(f*h));H=Pc(x[a+4624>>2],x[a+4628>>2],x[a+4640>>2]),I=E(f-E(h*e)),B[H>>2]=I;f=E(E(E(B[a+4976>>2]-B[Pc(x[a+4600>>2],x[a+4604>>2],x[a+4620>>2])>>2])*B[a+4436>>2])+B[Pc(x[a+4600>>2],x[a+4604>>2],x[a+4620>>2])>>2]);B[a+4976>>2]=f;h=B[a+4272>>2];f=E(E(f*B[a+4432>>2])+E(e*h));H=Pc(x[a+4600>>2],x[a+4604>>2],x[a+4616>>2]),I=E(e-E(h*f)),B[H>>2]=I;z=E(E(e*E(-.15000000596046448))+E(f*E(-.20000000298023224)));if(v[a+4264|0]&1){e=E(E(E(B[a+4972>>2]-B[Pc(x[a+4576>>2],x[a+4580>>2],x[a+4596>>2])>>2])*B[a+4428>>2])+B[Pc(x[a+4576>>2],x[a+4580>>2],x[a+4596>>2])>>2]);B[a+4972>>2]=e;h=B[a+4272>>2];e=E(E(e*B[a+4424>>2])+E(f*h));H=Pc(x[a+4576>>2],x[a+4580>>2],x[a+4592>>2]),I=E(f-E(h*e)),B[H>>2]=I;f=E(E(E(B[a+4968>>2]-B[Pc(x[a+4552>>2],x[a+4556>>2],x[a+4572>>2])>>2])*B[a+4420>>2])+B[Pc(x[a+4552>>2],x[a+4556>>2],x[a+4572>>2])>>2]);B[a+4968>>2]=f;h=B[a+4272>>2];f=E(E(f*B[a+4416>>2])+E(e*h));H=Pc(x[a+4552>>2],x[a+4556>>2],x[a+4568>>2]),I=E(e-E(h*f)),B[H>>2]=I;z=E(E(E(e*E(.3499999940395355))+z)+E(f*E(-.3799999952316284)))}H=Pc(x[a+4912>>2],x[a+4916>>2],x[a+4928>>2]),I=f,B[H>>2]=I;e=E(B[Pc(x[a+4912>>2],x[a+4916>>2],x[a+4932>>2])>>2]*B[a+4496>>2]);B[a+5028>>2]=E(E(B[a+5028>>2]-e)*B[a+4500>>2])+e;e=E(E(E(B[a+4964>>2]-B[Pc(x[a+4528>>2],x[a+4532>>2],x[a+4548>>2])>>2])*B[a+4412>>2])+B[Pc(x[a+4528>>2],x[a+4532>>2],x[a+4548>>2])>>2]);B[a+4964>>2]=e;f=B[a+5028>>2];k=B[a+4272>>2];h=E(E(f*k)+E(e*B[a+4408>>2]));H=Pc(x[a+4528>>2],x[a+4532>>2],x[a+4544>>2]),I=E(f-E(k*h)),B[H>>2]=I;e=E(E(E(B[a+4960>>2]-B[Pc(x[a+4504>>2],x[a+4508>>2],x[a+4524>>2])>>2])*B[a+4404>>2])+B[Pc(x[a+4504>>2],x[a+4508>>2],x[a+4524>>2])>>2]);B[a+4960>>2]=e;f=E(e*B[a+4400>>2]);e=B[a+4272>>2];k=E(f+E(h*e));H=Pc(x[a+4504>>2],x[a+4508>>2],x[a+4520>>2]),I=E(h-E(e*k)),B[H>>2]=I;B[a+5020>>2]=k;e=E(E(E(E(E(ki(t,x[a+4380>>2])*E(.7070000171661377))+E(ki(t,x[a+4384>>2])*E(-.6000000238418579)))-E(ki(t,x[a+4388>>2])*E(.5)))+E(ki(t,x[a+4392>>2])*E(-.6000000238418579)))-E(ki(t,x[a+4396>>2])*E(.5)));if(v[a+4264|0]&1){f=e;e=E(B[Pc(x[a+4840>>2],x[a+4844>>2],x[a+4860>>2])>>2]+E(e*E(.6180340051651001)));H=Pc(x[a+4840>>2],x[a+4844>>2],x[a+4856>>2]),I=E(f-E(e*E(.6180340051651001))),B[H>>2]=I}F=B[a+4280>>2];f=E(E(E(B[a+5004>>2]-B[Pc(x[a+4768>>2],x[a+4772>>2],x[a+4788>>2])>>2])*B[a+4492>>2])+B[Pc(x[a+4768>>2],x[a+4772>>2],x[a+4788>>2])>>2]);B[a+5004>>2]=f;G=E(f*B[a+4488>>2]);f=E(i-j);i=B[a+4272>>2];j=E(G+E(f*i));H=Pc(x[a+4768>>2],x[a+4772>>2],x[a+4784>>2]),I=E(f-E(i*j)),B[H>>2]=I;f=E(E(E(B[a+5e3>>2]-B[Pc(x[a+4744>>2],x[a+4748>>2],x[a+4764>>2])>>2])*B[a+4484>>2])+B[Pc(x[a+4744>>2],x[a+4748>>2],x[a+4764>>2])>>2]);B[a+5e3>>2]=f;i=B[a+4272>>2];f=E(E(f*B[a+4480>>2])+E(j*i));H=Pc(x[a+4744>>2],x[a+4748>>2],x[a+4760>>2]),I=E(j-E(i*f)),B[H>>2]=I;j=E(E(E(h*E(.3799999952316284))+E(j*E(-.15000000596046448)))+E(f*E(-.20000000298023224)));if(v[a+4264|0]&1){h=E(E(E(B[a+4996>>2]-B[Pc(x[a+4720>>2],x[a+4724>>2],x[a+4740>>2])>>2])*B[a+4476>>2])+B[Pc(x[a+4720>>2],x[a+4724>>2],x[a+4740>>2])>>2]);B[a+4996>>2]=h;i=B[a+4272>>2];h=E(E(h*B[a+4472>>2])+E(f*i));H=Pc(x[a+4720>>2],x[a+4724>>2],x[a+4736>>2]),I=E(f-E(i*h)),B[H>>2]=I;f=E(E(E(B[a+4992>>2]-B[Pc(x[a+4696>>2],x[a+4700>>2],x[a+4716>>2])>>2])*B[a+4468>>2])+B[Pc(x[a+4696>>2],x[a+4700>>2],x[a+4716>>2])>>2]);B[a+4992>>2]=f;i=B[a+4272>>2];f=E(E(f*B[a+4464>>2])+E(h*i));H=Pc(x[a+4696>>2],x[a+4700>>2],x[a+4712>>2]),I=E(h-E(i*f)),B[H>>2]=I;j=E(E(E(h*E(.3499999940395355))+j)+E(f*E(-.3799999952316284)))}n=r+4|0;p=q+4|0;h=E(g*w);z=E(z-E(k*E(.3799999952316284)));k=E(e*F);H=Pc(x[a+4936>>2],x[a+4940>>2],x[a+4952>>2]),I=f,B[H>>2]=I;g=E(B[Pc(x[a+4936>>2],x[a+4940>>2],x[a+4956>>2])>>2]*B[a+4496>>2]);B[a+5032>>2]=E(E(B[a+5032>>2]-g)*B[a+4500>>2])+g;g=E(E(E(B[a+4988>>2]-B[Pc(x[a+4672>>2],x[a+4676>>2],x[a+4692>>2])>>2])*B[a+4460>>2])+B[Pc(x[a+4672>>2],x[a+4676>>2],x[a+4692>>2])>>2]);B[a+4988>>2]=g;e=B[a+5032>>2];f=B[a+4272>>2];g=E(E(e*f)+E(g*B[a+4456>>2]));H=Pc(x[a+4672>>2],x[a+4676>>2],x[a+4688>>2]),I=E(e-E(f*g)),B[H>>2]=I;f=B[a+4284>>2];e=E(E(E(B[a+4984>>2]-B[Pc(x[a+4648>>2],x[a+4652>>2],x[a+4668>>2])>>2])*B[a+4452>>2])+B[Pc(x[a+4648>>2],x[a+4652>>2],x[a+4668>>2])>>2]);B[a+4984>>2]=e;w=B[a+4272>>2];e=E(E(e*B[a+4448>>2])+E(g*w));H=Pc(x[a+4648>>2],x[a+4652>>2],x[a+4664>>2]),I=E(g-E(w*e)),B[H>>2]=I;B[a+5024>>2]=e;e=E(-e);w=B[a+4288>>2];D=4504;e:{f:{while(1){if((D|0)==4960){g:{e=E(k+E(E(E(e*E(.3799999952316284))+j)*w));g=E(h+E(E(E(g*E(.3799999952316284))+z)*f));if(!(y[a+4264|0]&2)){break g}break f}}else{o=a+D|0;A=x[o+16>>2];C=A-1|0;x[o+16>>2]=C;if((A|0)<=0){x[o+16>>2]=C+x[o+12>>2]}C=x[o+20>>2];A=C-1|0;x[o+20>>2]=A;if((C|0)<=0){x[o+20>>2]=A+x[o+12>>2]}D=D+24|0;continue}break}B[l>>2]=E(g+B[a+5036>>2])*E(.5);B[m>>2]=E(e+B[a+5040>>2])*E(.5);B[a+5040>>2]=e;B[a+5036>>2]=g;if((s|0)==1){break e}s=s-1|0;m=m+4|0;l=l+4|0;n=r+8|0;p=q+8|0}q=p;r=n;B[l>>2]=g;B[m>>2]=e;s=s-1|0;m=m+4|0;l=l+4|0;continue}break}v[a+5044|0]=1}p=a;a=x[a+56>>2];Ki(p,b,c,Hc(a,0),Hc(a,1),d)}}function qpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,A=0,B=0,C=0,E=0,F=0;d=fb-288|0;fb=d;yc(b);a:{b:{c:{f=d+192|0;d:{if(!Dv(b,f)){break d}if(!vX(f)){break d}if(!Mb(x[b>>2],x[b+8>>2],Bc(uX(f),hb))){break d}j=1;if((c|0)==64){break d}j=0;if(!dd(b,y[d+196|0])){break d}Dd(a,268435456);eg(a);x[a+480208>>2]=4;Lb(a+1074312|0,114,1);f=d+84|0;i=uc(f,15411);zb(a+1298344|0,i);tb(i);i=uc(f,10298);zb(a+1298356|0,i);tb(i);E=a+1298404|0,F=x[Fc(f,4)>>2],x[E>>2]=F;i=d+16|0;bf(i,d+198|0,48,3);Cc(f,i);zb(a+1298308|0,f);tb(f);f=y[d+246|0];w[a+480188>>1]=f+1;x[a+480228>>2]=y[d+249|0];x[a+480204>>2]=D(y[d+250|0],1e4);x[a+480196>>2]=y[d+251|0];while(1){if((e|0)==(f|0)){e:{w[a+480190>>1]=y[d+284|0];e=y[d+286|0]|y[d+287|0]<<8;i=fb-16|0;fb=i;f=d+180|0;x[f>>2]=0;x[f+4>>2]=0;tc(f+8|0);Rd(i+8|0,x[vb(i+4|0,f)>>2]);f:{g:{if(e){x[31609]=0;O(662,f|0,e|0);g=x[31609];x[31609]=0;if((g|0)==1){break g}oD(f,e)}e=i+8|0;Qd(e);bh(e);fb=i+16|0;break f}a=N()|0;bh(i+8|0);Q(a|0);p()}x[31609]=0;i=f;S(657,b|0,f|0,y[d+286|0]|y[d+287|0]<<8);f=x[31609];x[31609]=0;if((f|0)==1){break b}u=Nb(d+168|0);r=Nb(d+156|0);x[31609]=0;U(420,b|0,u|0,y[d+285|0])|0;f=x[31609];x[31609]=0;if((f|0)==1){break c}x[31609]=0;U(420,b|0,r|0,y[d+284|0])|0;f=x[31609];x[31609]=0;if((f|0)==1){break c}s=c&2;t=d+122|0;q=d+90|0;f=0;h:{while(1){e=f;if(e>>>0>=y[d+284|0]){j=1;if(!(c&1)){break e}x[d+68>>2]=0;Nc(Xb(x[a+484360>>2],y[a+484376|0]));E=d,F=wb(x[i>>2]),x[E+64>>2]=F;s=a+484344|0;A=wb(x[i+4>>2]);break h}x[31609]=0;f=e+1|0;g=D(f,104)+a|0;k=g+484380|0;O(279,k|0,0);h=x[31609];x[31609]=0;i:{if((h|0)!=1){h=yb(x[r>>2],e);h=y[h|0]|y[h+1|0]<<8|(y[h+2|0]<<16|y[h+3|0]<<24);if(!h){continue}x[31609]=0;h=P(149,b|0,h|0)|0;j=x[31609];x[31609]=0;j:{if((j|0)==1){break j}if(!h){continue}x[31609]=0;h=P(658,b|0,d+84|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break j}if(!h){continue}j=d+72|0;Te(j,2,q);x[31609]=0;h=d+16|0;O(218,h|0,j|0);n=x[31609];x[31609]=0;if((n|0)==1){break c}Ac(((f<<5)+a|0)+946304|0,h);tb(h);Mk(j,2,t);x[31609]=0;O(218,h|0,j|0);j=x[31609];x[31609]=0;if((j|0)==1){break c}Be(g+484423|0,h);tb(h);h=y[d+134|0];if(h>>>0<=15){w[g+484408>>1]=D(h,17)&255;h=g+484414|0;w[h>>1]=z[h>>1]|32}v[d+16|0]=y[d+135|0];v[d+72|0]=64;E=g+484412|0,F=y[Qb(d+16|0,d+72|0)|0],w[E>>1]=F;x[g+484404>>2]=y[d+137|0]|y[d+138|0]<<8;n=g+484384|0;h=y[d+143|0]|y[d+144|0]<<8|(y[d+145|0]<<16|y[d+146|0]<<24);x[n>>2]=h;o=g+484388|0;j=y[d+147|0]|y[d+148|0]<<8|(y[d+149|0]<<16|y[d+150|0]<<24);x[o>>2]=j;l=y[d+151|0]|y[d+152|0]<<8|(y[d+153|0]<<16|y[d+154|0]<<24);x[k>>2]=l;m=y[d+136|0];if(m&1){h=h>>>1|0;x[n>>2]=h;j=j>>>1|0;x[o>>2]=j;x[k>>2]=l>>>1}k:{if(h>>>0>=j>>>0){break k}g=g+484414|0;h=z[g>>1];w[g>>1]=h|2;if(!(m&2)){break k}w[g>>1]=h|6}Vk(k);if(!s){continue}e=yb(x[r>>2],e);e=y[e|0]|y[e+1|0]<<8|(y[e+2|0]<<16|y[e+3|0]<<24);x[31609]=0;P(149,b|0,e+y[d+88|0]|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break i}}break c}break c}e=Zc(d+16|0,v[d+136|0]&1?16:8,1,0,1);x[31609]=0;U(215,e|0,k|0,b|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){continue}break}break c}while(1){k=x[d+64>>2];if(!Ib(k,A)){e=y[a+484376|0];f=x[a+484360>>2];l:{b=x[d+68>>2];c=b&63;m:{if(!c){break m}g=Xb(f,e);b=b>>>6&65535;if(!Yi(g,b)){break m}b=z[bc(x[g>>2],b)>>1];f=x[s>>2];x[31609]=0;O(659,Wb(f,b)|0,c|0);b=x[31609];x[31609]=0;if((b|0)==1){break l}e=y[a+484376|0];f=x[a+484360>>2]}a=Xb(f,e);e=wb(x[a>>2]);x[d+84>>2]=e;a=wb(x[a+4>>2]);g=65535;while(1){if(!Ib(e,a)){break e}if(z[e>>1]==65535){n:{if((g&65535)!=65535){break n}x[31609]=0;g=P(367,s|0,64)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break n}break c}w[e>>1]=g}e=x[ge(d+84|0)>>2];continue}}break c}o:{c=y[k+3|0];if(y[k+2|0]>y[d+246|0]|c>>>0>=y[d+285|0]){break o}c=yb(x[u>>2],c);c=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);x[31609]=0;c=P(149,b|0,c|0)|0;f=x[31609];x[31609]=0;p:{if((f|0)!=1){if(!c){break o}x[31609]=0;O(660,b|0,d+84|0);c=x[31609];x[31609]=0;if((c|0)==1){break c}e=y[d+88|0];if(!e){break o}c=y[k|0]|y[k+1|0]<<8;v[d+16|0]=y[d+89|0];v[d+72|0]=y[d+246|0]-y[k+2|0];t=y[Qb(d+16|0,d+72|0)|0];x[d+60>>2]=c+e;E=d,F=x[bd(d+68|0,d+60|0)>>2],x[E+68>>2]=F;x[d+40>>2]=0;x[d+44>>2]=0;x[d+32>>2]=0;x[d+36>>2]=0;x[d+24>>2]=0;x[d+28>>2]=0;x[d+16>>2]=0;x[d+20>>2]=0;g=c&63;q=c>>>6|0;n=0;while(1){if((e&255)>>>0<=n>>>0){break o}e=Xb(x[a+484360>>2],y[a+484376|0]);h=g>>>0>63;q=h+q|0;c=q&65535;if($c(x[e>>2],x[e+4>>2])>>>0<=c>>>0){x[31609]=0;O(330,e|0,q+1&65535);f=x[31609];x[31609]=0;if((f|0)==1){break p}x[31609]=0;f=P(367,s|0,64)|0;e=x[31609];x[31609]=0;if((e|0)==1){break p}e=Xb(x[a+484360>>2],y[a+484376|0]);E=bc(x[e>>2],c),F=f,w[E>>1]=F}l=x[a+484344>>2];f=x[a+484348>>2];o=z[bc(x[e>>2],c)>>1];if(!Je(l,f,o)){break o}f=0;c=Wb(l,o);l=h?0:g;e=md(x[c>>2],x[x[c+48>>2]+12>>2],l,y[k+2|0]);q:{while(1){if((f|0)==(t|0)){c=y[d+89|0];if(c>>>0<=t>>>0){break q}x[31609]=0;P(183,b|0,D(c-t|0,5)|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break q}break c}x[31609]=0;c=d+72|0;O(661,c|0,b|0);g=x[31609];x[31609]=0;if((g|0)!=1){h=Jc(c);B=_e(c);m=_i(c);C=gc(c);g=0;c=y[d+72|0];if((c-1&255)>>>0<=142){g=(D((c&240)>>>4|0,12)+(c&15)|0)+13|0;v[(d+16|0)+f|0]=g}v[e|0]=g;c=y[h|0];v[e+2|0]=1;v[e+1|0]=c;c=y[B|0];r:{if((c|0)!=255){v[e+4|0]=c;break r}v[e+2|0]=0}c=y[m|0];s:{if(c>>>0>22){break s}v[e+3|0]=y[c+25376|0];h=y[C|0];v[e+5|0]=h;c=e+5|0;t:{switch(y[m|0]-4|0){case 3:v[c|0]=h&3|64;break s;case 4:v[c|0]=h&3|48;break s;case 7:g=x[i>>2];if(oc(g,x[i+4>>2])>>>0<=h>>>0){break s}m=c;c=yb(g,h);c=y[c|0]|y[c+1|0]<<8;v[m|0]=c>>>6;g=Wb(x[a+484344>>2],o);g=md(x[g>>2],x[x[g+48>>2]+12>>2],l,z[a+480188>>1]-1&65535);v[g+5|0]=c&63;v[g+3|0]=14;break s;case 8:m=c;c=x[d+60>>2];v[m|0]=c>>>6;g=Wb(x[a+484344>>2],o);g=md(x[g>>2],x[x[g+48>>2]+12>>2],l,z[a+480188>>1]-1&65535);v[g+5|0]=c&63;v[g+3|0]=14;break s;case 10:v[c|0]=h&15|128;break s;case 12:v[d+15|0]=15;E=c,F=y[Qb(c,d+15|0)|0]|208,v[E|0]=F;break s;case 13:v[d+15|0]=15;E=c,F=y[Qb(c,d+15|0)|0]|192,v[E|0]=F;break s;case 14:v[d+15|0]=15;E=c,F=y[Qb(c,d+15|0)|0]|224,v[E|0]=F;break s;case 0:case 16:case 17:if(!(h&15)){break s}g=h&240;if(!g|(g|0)==240){break s}v[c|0]=h|15;break s;case 9:case 18:break t;default:break s}}if(g&255){break s}v[e|0]=y[(d+16|0)+f|0]}e=e+6|0;f=f+1|0;continue}break}break c}g=l+1|0;n=n+1|0;e=y[d+88|0];continue}}break c}break c}We(d- -64|0);continue}}}else{w[((e<<5)+a|0)+480284>>1]=D(y[(d+e|0)+252|0],17);e=e+1|0;continue}break}wc(r);wc(u);wc(i)}fb=d+288|0;return j|0}a=N()|0;wc(r);wc(u);break a}a=N()|0}wc(i);Q(a|0);p()}function Nta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;e=fb-272|0;fb=e;yc(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{h=e+206|0;m:{if(!M$(b,h)){break m}if(!N$(h)){break m}d=1;if((c|0)==64){break m}Dd(a,131072);d=fb-16|0;fb=d;h=e+120|0;f=uc(d+4|0,3910);Uc(h,f);tb(f);fb=d+16|0;x[31609]=0;d=e+160|0;S(209,d|0,h|0,e+210|0);f=x[31609];x[31609]=0;n:{o:{p:{if((f|0)!=1){zb(a+1298344|0,d);tb(d);Eb(h);f=uc(d,11160);zb(a+1298356|0,f);tb(f);o=a+1298404|0,q=x[Fc(d,4)>>2],x[o>>2]=q;xE(h,3,e+219|0);Cc(d,h);zb(a+1298308|0,d);tb(d);qi(h,3,e+249|0);Dr(d,4,h);zb(a+1298320|0,d);tb(d);d=jp(d);o=d,q=Ld(y[e+269|0],1,31),x[o+8>>2]=q;o=d,q=Ld(y[e+270|0],1,12),x[o+4>>2]=q;x[d>>2]=y[e+271|0]+1900;h=a+1298412|0;Nc(h);nE(h,d);g=e+128|0;h=Nb(e+148|0);q:{r:{s:{while(1){d=x[b+8>>2];f=x[b>>2];x[31609]=0;d=U(150,f|0,d|0,8)|0;f=x[31609];x[31609]=0;t:{u:{v:{w:{x:{if((f|0)!=1){if(!d){break q}x[31609]=0;O(310,b|0,e- -64|0);d=x[31609];x[31609]=0;if((d|0)==1){break x}d=x[e+68>>2];y:{k=y[e+210|0];switch(k-3|0){case 1:break w;case 0:break y;default:break v}}f=2;if(x[e+64>>2]!=1431389523){break u}break t}b=N()|0;break b}b=N()|0;break b}f=4;if(x[e+64>>2]!=1431389523){break u}break t}f=0;if(k>>>0>7){break t}}d=x[e+64>>2]==1146113363?-1:d;f=0}k=x[e+68>>2];x[e+120>>2]=x[e+64>>2];x[e+124>>2]=k;x[31609]=0;k=e+100|0;S(185,k|0,b|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break s}hc(g,k);x[31609]=0;d=e+120|0;O(311,h|0,d|0);i=x[31609];x[31609]=0;if((i|0)==1){break r}Hd(d);ub(k);x[31609]=0;P(183,b|0,f|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){continue}break}b=N()|0;break b}b=N()|0;break b}b=N()|0;Hd(e+120|0);ub(e+100|0);break b}x[31609]=0;k=R(168,e+120|0)|0;b=x[31609];x[31609]=0;z:{A:{B:{if((b|0)!=1){x[31609]=0;d=e+100|0;S(312,d|0,h|0,1431389523);b=x[31609];x[31609]=0;if((b|0)==1){break B}b=kd(k,d);ub(d);w[e+98>>1]=0;w[e+96>>1]=65534;if(y[e+210|0]<3){break z}x[31609]=0;d=R(189,b|0)|0;f=x[31609];x[31609]=0;if((f|0)!=1){break A}break d}b=N()|0;break b}b=N()|0;break c}w[e+98>>1]=d;if(y[e+210|0]<4){break z}x[31609]=0;d=R(189,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break d}w[e+96>>1]=y[e+210|0]==4?d?d:-2:d}d=y[a+484376|0];f=x[a+484360>>2];x[31609]=0;g=R(202,b|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break d}x[31609]=0;S(238,Xb(f,d)|0,b|0,g>>>1|0);d=x[31609];x[31609]=0;if((d|0)==1){break d}d=Xb(x[a+484360>>2],y[a+484376|0]);d=mE(x[d>>2],x[d+4>>2]);Hf(e+98|0,d);Hf(e+96|0,d);x[31609]=0;d=e+100|0;S(312,d|0,h|0,1414807888);f=x[31609];x[31609]=0;if((f|0)==1){break e}b=kd(b,d);ub(d);d=x[b>>2];x[31609]=0;d=R(172,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break d}if(!(c&1)|d^1){break n}x[31609]=0;O(313,b|0,e+8|0);d=x[31609];x[31609]=0;if((d|0)==1){break f}o=a,q=Ld(y[e+10|0],1,32)+1|0,w[o+480188>>1]=q;x[31609]=0;d=P(214,e+84|0,z[e+8>>1])|0;f=x[31609];x[31609]=0;if((f|0)==1){break g}o=e,q=wb(x[d>>2]),x[o+44>>2]=q;i=wb(x[d+4>>2]);C:{D:{E:{while(1){j=x[e+44>>2];if(!Ib(j,i)){f=z[a+480188>>1];x[31609]=0;f=P(314,e+100|0,f|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){break C}b=N()|0;break o}x[31609]=0;f=y[e+210|0]<3?9:8;P(183,b|0,f-4|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){x[31609]=0;l=R(151,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break E}Ih(b,f);x[31609]=0;g=e- -64|0;S(185,g|0,b|0,f+l|0);f=x[31609];x[31609]=0;if((f|0)==1){break D}f=hc(e+100|0,g);kd(j,f);ub(f);ub(g);Qf(e+44|0);continue}break}b=N()|0;break o}b=N()|0;break o}b=N()|0;break o}g=Xb(x[a+484360>>2],y[a+484376|0]);g=dm(x[g>>2],x[g+4>>2]);x[31609]=0;l=a+484344|0;O(223,l|0,g|0);g=x[31609];x[31609]=0;if((g|0)!=1){g=Xb(x[a+484360>>2],y[a+484376|0]);o=e,q=wb(x[g>>2]),x[o+64>>2]=q;i=wb(x[g+4>>2]);while(1){g=x[e+64>>2];if(!Ib(g,i)){g=Xb(x[a+484360>>2],y[a+484376|0]);i=z[e+96>>1];F:{if(!Yi(g,i)){break F}j=x[g>>2];m=z[e+98>>1];if(!m){if(mE(j,x[g+4>>2])>>>0<=i>>>0){break F}}g=Wb(x[l>>2],z[bc(j,i)>>1]);Ae(g,Bn(Ve(Oe(e- -64|0,12,m&255),x[g+12>>2]-1|0)))}Nk(f);Rc(d);break n}j=x[d>>2];n=Sf(j,x[d+4>>2]);m=z[g>>1];if(n>>>0>m>>>0){x[31609]=0;j=ba(315,ch(j,m)|0,y[e+210|0],f|0,a|0)|0;m=x[31609];x[31609]=0;if((m|0)==1){break p}w[g>>1]=j}ge(e- -64|0);continue}}break p}b=N()|0;Eb(e+120|0);break a}b=N()|0;Nk(f)}Rc(d);break c}x[31609]=0;d=e- -64|0;S(312,d|0,h|0,1196641603);f=x[31609];x[31609]=0;if((f|0)==1){break k}b=kd(b,d);ub(d);d=x[b>>2];x[31609]=0;d=R(172,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break d}if(d){x[31609]=0;P(183,b|0,1)|0;d=x[31609];x[31609]=0;if((d|0)==1){break d}x[31609]=0;d=R(202,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break d}x[31609]=0;aa(316,a+1298332|0,b|0,d|0,40,0);d=x[31609];x[31609]=0;if((d|0)==1){break d}}x[31609]=0;S(312,e- -64|0,h|0,1146113363);d=x[31609];x[31609]=0;if((d|0)==1){break h}x[31609]=0;d=e+44|0;S(312,d|0,h|0,1229999443);f=x[31609];x[31609]=0;if((f|0)==1){break l}b=kd(b,d);ub(d);x[31609]=0;d=R(197,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break j}w[a+480190>>1]=d;i=!(c&2);f=1;G:{while(1){H:{c=f&65535;if(c>>>0>(d&65535)>>>0){break G}d=30;I:{J:{K:{if(y[e+210|0]>=2){x[31609]=0;d=R(197,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break K}}x[31609]=0;S(317,b|0,((c<<5)+a|0)+946304|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break K}x[31609]=0;d=e+28|0;O(318,b|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break J}x[31609]=0;g=D(c,104)+a|0;j=g+484380|0;O(319,d|0,j|0);c=x[31609];x[31609]=0;if((c|0)==1){break J}d=y[e+210|0];if(d>>>0>=8){x[31609]=0;O(320,b|0,g+484423|0);c=x[31609];x[31609]=0;if((c|0)==1){break J}d=y[e+210|0]}x[31609]=0;P(183,b|0,((d&255)>>>0>1?6:2)|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break J}x[31609]=0;c=e- -64|0;d=R(151,c|0)|0;l=x[31609];x[31609]=0;if((l|0)!=1){x[31609]=0;S(185,e+8|0,c|0,d|0);c=x[31609];x[31609]=0;if((c|0)!=1){break I}}b=N()|0;break i}b=N()|0;break i}b=N()|0;break i}d=e+8|0;c=hc(e+44|0,d);ub(d);l=x[c>>2];x[31609]=0;l=R(172,l|0)|0;m=x[31609];x[31609]=0;if((m|0)!=1){L:{if(i|l^1){break L}d=Zc(d,w[g+484414>>1]&1?16:8,1,0,(y[e+43|0]&12)==4?7:0);x[31609]=0;U(215,d|0,j|0,c|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break L}break H}ub(c);f=f+1|0;d=z[a+480190>>1];continue}}break}b=N()|0;ub(c);break i}eg(a);x[a+480204>>2]=12e5;x[a+480208>>2]=24;x[a+480196>>2]=6;x[a+480200>>2]=256;x[a+480228>>2]=48;x[a+480232>>2]=48;x[31609]=0;d=1;U(266,a+1074312|0,114,1)|0;a=x[31609];x[31609]=0;if((a|0)==1){break j}ub(e- -64|0);ub(b);ke(h)}fb=e+272|0;return d|0}b=N()|0;break i}b=N()|0;break c}b=N()|0}ub(e- -64|0);break c}b=N()|0;break c}b=N()|0;break c}b=N()|0;break c}b=N()|0;break c}b=N()|0}ub(k)}ke(h)}Q(b|0);p()}function cM(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;i=fb-208|0;fb=i;a:{b:{if(g){qf(i+196|0,f,32);x[31609]=0;U(542,i+184|0,f|0,32)|0;h=x[31609];x[31609]=0;if((h|0)!=1){break b}f=N()|0;break a}Fb(i+196|0);Fb(i+184|0)}c:{d:{e:{f:{g:{h:{i:{j:{if(Ut(c)){h=x[b+24>>2];j=x[h+484344>>2];if(Je(j,x[h+484348>>2],c&65535)){break j}}x[31609]=0;S(1211,a|0,i+196|0,i+184|0);a=x[31609];x[31609]=0;if((a|0)!=1){break i}f=N()|0;break c}c=Wb(j,c);if(!(!((e|0)<0|x[c+12>>2]<=(d|0)|(d|0)<0)&z[h+480188>>1]>e>>>0)){x[31609]=0;S(1211,a|0,i+196|0,i+184|0);a=x[31609];x[31609]=0;if((a|0)!=1){break i}f=N()|0;break c}c=md(x[c>>2],x[x[c+48>>2]+12>>2],d,e&65535);sf(i+196|0);sf(i+184|0);k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{d=y[c|0];if(!Tc(d)){if(!Gl(d)){break A}}e=y[c+1|0];h=x[b+24>>2];x[31609]=0;j=i+160|0;V(1212,j|0,h|0,d|0,e|0);d=x[31609];x[31609]=0;e=1;if((d|0)==1){break y}x[31609]=0;O(1059,i+172|0,j|0);d=x[31609];x[31609]=0;if((d|0)!=1){break z}f=N()|0;break v}e=0;x[31609]=0;P(36,i+172|0,16800)|0;d=x[31609];x[31609]=0;if((d|0)==1){break x}}x[31609]=0;h=i+172|0;d=P(838,i+196|0,h|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break w}tb(h);if(e){tb(i+160|0)}e=9984;h=y[c|0];if(!Tc(h)){e=Gl(h)?10294:16800}x[31609]=0;h=P(36,i+172|0,e|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break u}x[31609]=0;e=P(838,i+184|0,h|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break t}tb(h);if(f-6>>>0>4294967290){break l}x[31609]=0;h=P(36,i+148|0,18454)|0;j=x[31609];x[31609]=0;if((j|0)==1){break s}x[31609]=0;j=P(838,d|0,h|0)|0;m=x[31609];x[31609]=0;if((m|0)==1){break r}tb(h);x[31609]=0;h=P(36,i+136|0,18454)|0;m=x[31609];x[31609]=0;if((m|0)==1){break q}x[31609]=0;m=P(838,e|0,h|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break p}tb(h);h=c+1|0;B:{if(y[c+1|0]){x[31609]=0;O(559,i+124|0,h|0);k=x[31609];x[31609]=0;if((k|0)!=1){break B}break d}x[31609]=0;P(36,i+124|0,16805)|0;k=x[31609];x[31609]=0;if((k|0)==1){break d}}x[31609]=0;k=j;j=i+124|0;k=P(838,k|0,j|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break o}tb(j);h=y[h|0];x[31609]=0;h=P(36,j|0,(h?10817:16805)|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break n}x[31609]=0;m=P(838,m|0,h|0)|0;j=x[31609];x[31609]=0;if((j|0)!=1){break m}f=N()|0;tb(h);break c}f=N()|0;break c}f=N()|0;break c}f=N()|0;tb(i+172|0);if(!e){break c}}tb(i+160|0);break c}f=N()|0;break c}f=N()|0;tb(h);break c}f=N()|0;break c}f=N()|0;tb(h);break c}f=N()|0;break c}f=N()|0;tb(h);break c}f=N()|0;tb(i+124|0);break c}f=N()|0;break c}tb(h);if(f-9>>>0>4294967287){break l}C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{j=Wg(y[c|0]);O:{if(j){x[31609]=0;l=P(36,i+100|0,18454)|0;h=x[31609];x[31609]=0;if((h|0)==1){break N}h=y[c+4|0];n=y[c+2|0];x[31609]=0;o=i,q=Dj(n,h)&255,x[o+76>>2]=q;n=i+88|0;O(558,n|0,i+76|0);h=x[31609];x[31609]=0;if((h|0)==1){break M}h=0;x[31609]=0;S(1015,i+112|0,l|0,n|0);l=x[31609];x[31609]=0;if((l|0)!=1){break O}f=N()|0;break G}h=y[c+2|0];if(h){h=uR(x[x[x[b+24>>2]+8>>2]+88>>2],h);x[31609]=0;h=U(542,i+100|0,1,h|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break E}x[31609]=0;l=i+88|0;O(559,l|0,c+4|0);n=x[31609];x[31609]=0;if((n|0)==1){break L}x[31609]=0;S(1015,i+112|0,h|0,l|0);l=x[31609];x[31609]=0;h=1;if((l|0)!=1){break O}f=N()|0;break J}h=0;x[31609]=0;P(36,i+112|0,16804)|0;l=x[31609];x[31609]=0;if((l|0)==1){break e}}x[31609]=0;l=k;k=i+112|0;l=P(838,l|0,k|0)|0;n=x[31609];x[31609]=0;if((n|0)==1){break K}tb(k);if(h){tb(i+88|0);tb(i+100|0)}if(j){tb(i+88|0);tb(i+100|0)}h=5488;if(!Wg(y[c|0])){h=y[c+2|0]?5484:16804}x[31609]=0;h=P(36,i+112|0,h|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break D}x[31609]=0;j=P(838,m|0,h|0)|0;m=x[31609];x[31609]=0;if((m|0)!=1){break C}f=N()|0;tb(h);break c}f=N()|0;break c}f=N()|0;break F}f=N()|0;break I}f=N()|0;tb(i+112|0);if(!h){break H}}tb(i+88|0)}tb(i+100|0)}if(!j){break c}}tb(i+88|0)}tb(i+100|0);break c}f=N()|0;break c}f=N()|0;break c}tb(h);if(f-13>>>0>4294967283){break l}x[31609]=0;h=P(36,i+76|0,18454)|0;m=x[31609];x[31609]=0;P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{if((m|0)!=1){x[31609]=0;m=P(838,l|0,h|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break Z}tb(h);x[31609]=0;h=P(36,i- -64|0,18454)|0;k=x[31609];x[31609]=0;if((k|0)==1){break Y}x[31609]=0;j=P(838,j|0,h|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break X}tb(h);_:{if(Wg(y[c|0])){h=y[c+5|0];k=y[c+3|0];b=0;x[31609]=0;o=i,q=Dj(k,h)&4095,x[o+16>>2]=q;O(1213,i+52|0,i+16|0);h=x[31609];x[31609]=0;if((h|0)!=1){break _}f=N()|0;break c}h=y[c+3|0];if(h){b=tR(x[x[x[b+24>>2]+8>>2]+84>>2],h);x[31609]=0;b=U(542,i+40|0,1,b|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break W}x[31609]=0;h=i+28|0;O(559,h|0,c+5|0);k=x[31609];x[31609]=0;if((k|0)==1){break V}x[31609]=0;S(1015,i+52|0,b|0,h|0);h=x[31609];x[31609]=0;b=1;if((h|0)!=1){break _}f=N()|0;break S}b=0;x[31609]=0;P(36,i+52|0,16800)|0;h=x[31609];x[31609]=0;if((h|0)==1){break U}}x[31609]=0;h=i+52|0;P(838,m|0,h|0)|0;m=x[31609];x[31609]=0;if((m|0)==1){break T}tb(h);if(b){tb(i+28|0);tb(i+40|0)}b=11177;if(!Wg(y[c|0])){b=y[c+3|0]?11177:16800}x[31609]=0;b=P(36,i+52|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break Q}x[31609]=0;P(838,j|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break P}f=N()|0;tb(b);break c}f=N()|0;break c}f=N()|0;tb(h);break c}f=N()|0;break c}f=N()|0;tb(h);break c}f=N()|0;break c}f=N()|0;break R}f=N()|0;break c}f=N()|0;tb(i+52|0);if(!b){break c}}tb(i+28|0)}tb(i+40|0);break c}f=N()|0;break c}tb(b);if(!f){break k}}$:{aa:{ba:{ca:{b=_c(x[d+4>>2],y[d+11|0]);da:{if(b>>>0>f>>>0){x[31609]=0;b=i+16|0;V(121,b|0,d|0,0,f|0);c=x[31609];x[31609]=0;if((c|0)!=1){zb(d,b);tb(b);break da}f=N()|0;break c}if(!g){break da}x[31609]=0;b=U(542,i+16|0,f-b|0,32)|0;c=x[31609];x[31609]=0;if((c|0)==1){break ca}x[31609]=0;P(838,d|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break ba}tb(b)}b=_c(x[e+4>>2],y[e+11|0]);if(b>>>0<=f>>>0){break $}x[31609]=0;b=i+4|0;V(121,b|0,e|0,0,f|0);c=x[31609];x[31609]=0;if((c|0)==1){break aa}zb(e,b);tb(b);break k}f=N()|0;break c}f=N()|0;tb(b);break c}f=N()|0;break c}if(!g){break k}x[31609]=0;b=U(542,i+4|0,f-b|0,32)|0;c=x[31609];x[31609]=0;if((c|0)==1){break h}x[31609]=0;P(838,e|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break g}tb(b)}x[31609]=0;S(1211,a|0,d|0,e|0);a=x[31609];x[31609]=0;if((a|0)==1){break f}}tb(i+184|0);tb(i+196|0);fb=i+208|0;return}f=N()|0;break c}f=N()|0;tb(b);break c}f=N()|0;break c}f=N()|0;break c}f=N()|0}tb(i+184|0)}tb(i+196|0);Q(f|0);p()}function Wsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;d=fb-256|0;fb=d;yc(b);f=fb-16|0;fb=f;i=d+99|0;z_(f+8|0,i);h=x[f+12>>2];lc(f,x[b>>2],x[b+8>>2],x[f+8>>2],x[f+12>>2]);j=x[f+4>>2];if((j|0)==(h|0)){Vb(b,x[f+12>>2])}fb=f+16|0;f=(h|0)==(j|0);if(!f){y_(i)}a:{if(!f){break a}if(!A_(i)){break a}e=1;if((c|0)==64){break a}Dd(a,x[((y[d+215|0]|y[d+216|0]<<8)<<2)+24784>>2]);x[a+480208>>2]=x[a+480208>>2]|16777216;e=d+36|0;f=uc(e,13187);zb(a+1298344|0,f);tb(f);f=uc(e,10329);zb(a+1298356|0,f);tb(f);i=fb-16|0;fb=i;f=d+4|0;h=uc(i+4|0,4389);Uc(f,h);tb(h);fb=i+16|0;x[31609]=0;V(229,e|0,f|0,y[d+178|0],d+175|0);i=x[31609];x[31609]=0;b:{if((i|0)!=1){zb(a+1298368|0,e);tb(e);Eb(f);$h(a+1298392|0,((y[d+215|0]|y[d+216|0]<<8)<<2)+24832|0);$h(a+1298380|0,x[((y[d+215|0]|y[d+216|0]<<8)<<2)+24880>>2]);t=a+1298404|0,u=x[Fc(e,4)>>2],x[t>>2]=u;Te(f,2,d+103|0);Cc(e,f);zb(a+1298308|0,e);tb(e);Te(f,2,d+135|0);Cc(e,f);c:{if(!Nd(e,9766)){x[31609]=0;S(258,f|0,4,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break c}zb(a+1298320|0,f);tb(f)}tb(d+36|0);w[a+480188>>1]=32;d:{while(1){if((g|0)!=32){f=(g<<5)+a|0;i=f+480280|0;Ue(i);e=y[(d+g|0)+180|0];e:{if(e>>>0<=15){x[d+36>>2]=(e<<4|8)&248;x[d+4>>2]=256;t=f+480284|0,u=x[Cd(d+36|0,d+4|0)>>2],w[t>>1]=u;break e}if((e|0)!=16){if((e|0)!=255){break e}w[a+480188>>1]=g;break d}w[f+480284>>1]=128;x[i>>2]=256}g=g+1|0;continue}break}g=z[a+480188>>1]}e=0;if(!(g&65535)){break a}x[d+36>>2]=y[d+212|0]<<2;x[d+4>>2]=256;t=a,u=x[Hb(d+36|0,d+4|0)>>2],x[t+480200>>2]=u;x[a+480196>>2]=y[d+213|0];x[a+480204>>2]=D(y[d+214|0],1e4);if(dd(b,y[d+217|0]|y[d+218|0]<<8|(y[d+219|0]<<16|y[d+220|0]<<24))){ak(Xb(x[a+484360>>2],y[a+484376|0]),b,y[d+221|0]+1|0,255,254)}if(!dd(b,y[d+227|0]|y[d+228|0]<<8|(y[d+229|0]<<16|y[d+230|0]<<24))){break a}g=y[d+235|0]+1|0;w[a+480190>>1]=g;l=d+68|0;i=1;while(1){f:{g:{j=i&65535;if(j>>>0>(g&65535)>>>0){break g}e=fb-16|0;fb=e;f=d+36|0;cc(e+8|0,f,62);g=x[e+12>>2];lc(e,x[b>>2],x[b+8>>2],x[e+8>>2],x[e+12>>2]);h=x[e+4>>2];if((h|0)==(g|0)){Vb(b,x[e+12>>2])}fb=e+16|0;e=(g|0)==(h|0);if(!e){Rb(f,0,62)}if(!e){break g}g=0;e=D(j,104)+a|0;k=e+484380|0;nd(k,0);h=d+24|0;Te(h,2,f);f=d+4|0;Cc(f,h);Ac(((j<<5)+a|0)+946304|0,f);tb(f);Mk(h,2,l);Cc(f,h);Be(e+484423|0,f);tb(f);f=y[d+94|0]|y[d+95|0]<<8;x[e+484404>>2]=f;if(!yn(x[a+480180>>2])){break f}while(1){if((g|0)==16){break f}if((f|0)==z[(g<<1)+24928>>1]){v[e+484417|0]=g<<4;break f}else{g=g+1|0;continue}}}h:{if(!(c&2)){break h}if(!dd(b,y[d+231|0]|y[d+232|0]<<8|(y[d+233|0]<<16|y[d+234|0]<<24))){break h}g=1;while(1){e=g&65535;if(e>>>0>z[a+480190>>1]){break h}e=D(e,104)+a|0;dg(Zc(d+36|0,w[e+484414>>1]&1?16:8,1,0,1),e+484380|0,b);g=g+1|0;continue}}n=a+484344|0;Tf(n,y[d+226|0]+1|0);j=PD(sr(a));dd(b,y[d+222|0]|y[d+223|0]<<8|(y[d+224|0]<<16|y[d+225|0]<<24));s=c&1;h=0;l=1;i:{j:{k:{while(1){if(y[d+226|0]<h>>>0){if(!(z[a+480188>>1]==4&l)|x[a+480180>>2]!=1){break k}c=x[a+480208>>2]|8454144;break j}l:{e=gh(b);if(e>>>0>=3){c=d+4|0;he(c,b,e-2|0);i=hc(d+36|0,c);ub(c);m:{if(!s){break m}c=x[i>>2];x[31609]=0;c=R(172,c|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break l}if(!c){break m}x[31609]=0;c=U(196,n|0,h&65535,64)|0;e=x[31609];x[31609]=0;if((e|0)==1){break l}k=0;if(!c){break m}while(1){if((k|0)==64){break m}c=Wb(x[n>>2],h);af(d+4|0,x[c>>2],x[x[c+48>>2]+12>>2],k);n:{o:while(1){x[31609]=0;c=R(197,i|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break i}if(!c){break n}e=c&31;if(e>>>0>=z[a+480188>>1]){break n}g=Yc(x[d+4>>2],e);if(c&32){x[31609]=0;e=d+24|0;O(198,e|0,i|0);f=x[31609];x[31609]=0;if((f|0)==1){break i}f=Jc(e);e=y[d+24|0];if(e){e=(e&127)-1|0;v[d+24|0]=e;e=(D((e&240)>>>4|0,12)+(e&15)|0)+13|0;v[g|0]=e;l=OD(e)&l}v[g+1|0]=y[f|0]}if(!(c&64)){continue}v[g+2|0]=0;v[g+3|0]=0;o=g+5|0;while(1){c=x[i>>2];x[31609]=0;c=U(150,c|0,x[d+44>>2],2)|0;e=x[31609];x[31609]=0;if((e|0)==1){break i}if(!c){continue o}q=y[g+5|0];c=y[g+3|0];x[31609]=0;e=d+24|0;O(198,e|0,i|0);f=x[31609];x[31609]=0;if((f|0)!=1){f=y[Jc(e)|0];v[g+5|0]=f;r=y[d+24|0];e=y[(r&31)+24960|0];v[g+3|0]=e;p:{q:{r:{s:{t:{switch(e-2|0){case 0:case 1:if(f>>>0<224){break p}m=223;if(x[a+480180>>2]!=1){break s}break p;case 11:v[d+3|0]=64;e=y[Qb(o,d+3|0)|0];v[o|0]=e;if(!$v(x[j+88>>2],1)){break p}v[g+4|0]=e;v[g+2|0]=1;v[g+5|0]=q;v[g+3|0]=c;e=c;break r;case 17:u:{switch(((f&240)>>>4|0)-8|0){case 0:v[g+3|0]=2;v[g+5|0]=f&15|224;break p;case 1:v[g+3|0]=3;v[g+5|0]=f&15|224;break p;default:break u}}if(Wi(x[j+84>>2],19)){break p}Kr(g);e=y[g+3|0];break r;case 13:c=x[j+84>>2];if(Wi(c,15)){break p}if(!Wi(c,19)){break p}v[g+3|0]=19;v[g+5|0]=f&15|144;break p;case 18:m=145;if((f|0)==1){break s}if((f&240)==128){if(Wi(x[j+84>>2],20)){break q}v[g+3|0]=19;break p}v[g+3|0]=0;break p;case 4:case 5:break t;default:break r}}m=f&240;if(!m){break p}}v[o|0]=m}if((e&255)!=20){break p}}e=y[g+5|0];if(y[g+2|0]|(e&240)!=128){break p}v[g+2|0]=2;v[g+5|0]=q;v[g+3|0]=c;v[g+4|0]=((e<<6&960|8)>>>0)/15}if(!(r&32)){continue o}continue}break}break}break i}k=k+1|0;continue}}ub(i)}h=h+1|0;continue}break}break i}c=x[a+480208>>2]&-8454145}x[a+480208>>2]=c;e=1;if(!(y[d+240|0]|y[d+241|0]<<8|(y[d+242|0]<<16|y[d+243|0]<<24))){break a}if(!dd(b,y[d+236|0]|y[d+237|0]<<8|(y[d+238|0]<<16|y[d+239|0]<<24))){break a}cE(a+1298332|0,b,y[d+240|0]|y[d+241|0]<<8|(y[d+242|0]<<16|y[d+243|0]<<24),4);break a}g=N()|0;ub(i);break b}w[e+484412>>1]=64;f=y[d+81|0]|y[d+82|0]<<8|(y[d+83|0]<<16|y[d+84|0]<<24);x[k>>2]=f;g=y[d+93|0];if(g&2){h=e+484414|0;w[h>>1]=z[h>>1]|1;x[k>>2]=f>>>1}x[e+484384>>2]=y[d+85|0]|y[d+86|0]<<8|(y[d+87|0]<<16|y[d+88|0]<<24);x[e+484388>>2]=(y[d+89|0]|y[d+90|0]<<8|(y[d+91|0]<<16|y[d+92|0]<<24))-1;if(g&1){f=e+484414|0;w[f>>1]=z[f>>1]|2}v:{w:{if(!(g&4)){break w}f=y[d+96|0];if((f|0)==255){break w}v[d+4|0]=f;v[d+24|0]=64;t=e+484410|0,u=y[Qb(d+4|0,d+24|0)|0]<<2,w[t>>1]=u;break v}f=e+484414|0;w[f>>1]=z[f>>1]|32768}x:{if(g&8){g=e+484414|0;f=z[g>>1]|32;w[g>>1]=f;j=e+484408|0;e=y[d+97|0];if(e>>>0<=15){x[d+24>>2]=256;x[d+4>>2]=(e<<4|8)&248;h=x[Cd(d+4|0,d+24|0)>>2]}else{h=128}w[j>>1]=h;w[g>>1]=f&65279|((e|0)==16)<<8;break x}w[e+484408>>1]=128}i=i+1|0;g=z[a+480190>>1];continue}}g=N()|0;tb(d+36|0);break b}g=N()|0;Eb(d+4|0)}Q(g|0);p()}fb=d+256|0;return e|0}function nT(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=E(0),s=0,t=0,u=0,C=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=E(0),R=E(0),S=0,T=0,U=E(0),V=0;j=fb-48|0;fb=j;Kk(b+223848|0,Pj(e,Hi(e,Ro(e),0))+1|0);se(j+40|0,x[b+223848>>2],x[b+223852>>2]);Zb(j+32|0,e,Pj(e,Hi(e,Ro(e),0)));F=x[j+32>>2];G=x[j+36>>2];g=fb-16|0;fb=g;H=a+906300|0;p=a+1074312|0;o=D(c,872)+b|0;I=o+1415|0;J=o+1304|0;K=o+1392|0;u=o+1368|0;s=o+1364|0;L=o+1336|0;M=o+1308|0;N=o+1300|0;O=o+1280|0;P=o+1402|0;m=o+1466|0;Q=E(y[m|0]);R=E(f>>>0);C=o+616|0;k=x[o+1272>>2];q=1;l=255;while(1){if((n|0)!=(G|0)&A[j+44>>2]>i>>>0){h=y[xb(F,n)|0];e=h-48|0;a:{b:{if((e&255)>>>0<=9){break b}if((h-65&255)>>>0<=5){e=h-55|0;break b}c:{d:{e:{switch(h-97|0){case 2:f:{e=pm(a,b,c,3,0)-1|0;if((e&255)>>>0>249){break f}e=x[$d(H,e)>>2];if(!e){break f}e=hB(e,45896,42952);if(!e){break f}e=ib[x[x[e>>2]+192>>2]](e,C,c)|0;h=(e|0)!=255;e=h?e:0;if(h|!k){break b}break c}if(k){break c}e=0;break b;case 21:g:{if(!Ob(p,28)){e=0;if(!Ob(p,1)){break g}}e=w[K>>1]}h=D(x[u>>2],x[s>>2]);e=D(x[a+1074456>>2],e+x[J>>2]|0);e=Yb((Gc(Jua(Iua(h,h>>31,e,e>>31),hb,1048576,0),hb)|0)/2|0,1,127);break d;case 20:e=D(x[u>>2],x[s>>2]);h=e;t=e>>31;e=D(x[a+1074456>>2],x[L>>2]);e=Yb((Gc(Jua(Iua(h,t,e,e>>31),hb,67108864,0),hb)|0)/2|0,1,127);break d;case 23:x[g>>2]=x[M>>2]/2;x[g+12>>2]=127;e=x[Cd(g,g+12|0)>>2];break d;case 24:x[g>>2]=x[N>>2]/2;x[g+12>>2]=127;e=x[Cd(g,g+12|0)>>2];break d;case 0:e=0;if(!k){break d}h=z[k+28>>1];if(!h){break d}e=h-1>>>7&127;break d;case 1:e=0;if(!k){break d}h=z[k+28>>1];if(!h){break d}e=h-1&127;break d;case 14:e=x[O>>2]>>>8|0;break d;case 7:e=(z[a+480188>>1]<=c>>>0?y[P|0]-1|0:c)&127;break d;case 12:e=y[o+704|0]>>>7|0;break d;case 15:e=0;if(!k){break d}h=y[k+30|0];if(!h){break d}e=h-1&127;break d;case 25:h:{if(!d|v[m|0]<0){break h}i:{if(i>>>0<3){break i}e=x[j+40>>2];if(y[xb(e,i-3|0)|0]!=240){break i}if(y[xb(e,i-2|0)|0]>239){break h}}r=Eq(b,Q,R);j:{if(r<E(4294967296)&r>=E(0)){e=~~r>>>0;break j}e=0}v[m|0]=e;l=128;break d}l=(l&255)==255?f:l;e=f;break d;case 18:k:{if(!i){e=0;break k}h=x[j+40>>2];e=i;while(1){e=e-1|0;t=xb(h,e);if(!e){break k}if(y[t|0]!=240){continue}break}}if(i-e>>>0<5){break a}t=x[j+40>>2];if(y[xb(t,e)|0]!=240){break a}e=e+5|0;h=0;while(1){if((e|0)!=(i|0)){h=y[xb(t,e)|0]+h|0;e=e+1|0;continue}break};e=0-h&127;break d;case 13:break e;default:break a}}e=y[I|0];e=Tc(e)?e-1|0:0}h=q^-1;q=1;i=(h&1)+i|0;S=xb(x[j+40>>2],i),T=e,v[S|0]=T;i=i+1|0;break a}e=z[C+786>>1];h=y[k+31|0];e=(e?e-1|0:c)&15;l:{if((h|0)==17){break l}e=Kj(h)?h-1&15:0}}h=xb(x[j+40>>2],i);v[h|0]=(q&1?0:y[h|0]<<4)|e;q=q^1;i=(q&1)+i|0}n=n+1|0;continue}else{if(l<<24>>24>=0){v[m|0]=l}cc(g,x[j+40>>2],((q^-1)&1)+i|0);e=x[g+4>>2];x[j+40>>2]=x[g>>2];x[j+44>>2]=e;fb=g+16|0}break}o=x[j+44>>2];i=0;m:while(1){q=0;while(1){k=q&255;e=i;n:{o:{p:{q:{while(1){if(A[j+44>>2]<=e>>>0){break n}f=x[j+40>>2];m=xb(f,e);g=y[m|0];if((g|0)==240){if(o-e>>>0>=4){i=4;if((y[xb(f,e+1|0)|0]&254)==240){break o}}i=e;r:{while(1){i=i+1|0;if(o>>>0<=i>>>0){break r}if(y[xb(f,i)|0]!=247){continue}break}i=(i-e|0)+1|0;if(i){break o}}S=xb(f,o),T=247,v[S|0]=T;o=o+1|0;i=o-e|0;break p}if(g<<24>>24<0){break q}if(k){e=e-1|0;S=xb(f,e),T=q,v[S|0]=T;continue}break}i=i+1|0;continue m}S=j,T=xV(g),x[S+20>>2]=T;x[j+28>>2]=o-e;i=x[Hb(j+20|0,j+28|0)>>2]}if(!i){break n}f=x[j+40>>2];m=xb(f,e)}u=y[m|0];vr(j+20|0,f,x[j+44>>2],e,i);f=Zb(j+12|0,x[j+20>>2],x[j+24>>2]);m=x[f+4>>2];x[j>>2]=x[f>>2];x[j+4>>2]=m;m=fb-32|0;fb=m;n=x[j+4>>2];s:{if(!n){break s}k=Id(y[b+223884|0]);t:{g=x[j>>2];h=xb(g,0);f=y[h|0]-250|0;if(f>>>0>5|!(1<<f&37)){break t}l=z[a+480188>>1];f=0;while(1){if((f|0)==(l|0)){break t}p=(D(f,872)+b|0)+1453|0;v[p|0]=127;v[p+1|0]=0;f=f+1|0;continue}}u:{if((n|0)!=4|y[h|0]!=240){break u}l=y[xb(g,1)|0];if((l&254)!=240){break u}n=D(c,872)+b|0;h=n+616|0;p=xb(g,2);s=y[xb(g,3)|0];f=s<<24>>24;C=(l|0)!=241&(f|0)>=0;p=y[p|0];if(!(!C|p)){g=n+1453|0;if(d){f=Bh(Eq(b,E(y[g|0]),E((f&255)>>>0)))}v[g|0]=f;v[n+1412|0]=0;f=Jq(a,h,!(x[n+704>>2]&32768),256);if((f|0)<0|!(y[n+705|0]&2)){break s}g=x[a+1298300>>2];if(k|Ed(g)^1){break s}Oq(g,c,f>>>2&255,1);break s}g=p<<24>>24;if(C&(g|0)==1){g=D(c,872)+b|0;k=g+1454|0;if(d){f=Bh(Eq(b,E(y[k|0]),E((f&255)>>>0)))}v[k|0]=f;v[g+1411|0]=0;Jq(a,h,!(x[g+704>>2]&32768),256);break s}if(!((l|0)==241|(g|0)!=2)){if(f>>>0>31){break s}g=D(c,872)+b|0;v[g+1461|0]=(f&240)>>>4;Jq(a,h,!(x[g+704>>2]&32768),256);break s}if(!((l|0)==241|(g|0)!=3)){h=(f|0)<0;f=pm(a,b,c,3,0)-1|0;if(h|(f&255)>>>0>249){break s}v[m+24|0]=f;g=$d(a+906300|0,f&255);f=x[g>>2];if(!f){break s}r=E(E(127-s|0)/E(127));if(k){l=0;g=fb-16|0;fb=g;S=g,T=Rj(m+24|0),x[S+4>>2]=T;f=fb-16|0;fb=f;k=b+223860|0;h=gB(k,f+12|0,y[m+24|0]);n=x[h>>2];if(!n){l=fb-16|0;fb=l;n=gc(k);p=Dh(f,Ec(24),Og(l+8|0,n));n=x[p>>2];s=y[x[g+4>>2]];x[n+20>>2]=0;v[n+16|0]=s;S=gc(p),T=1,v[S+4|0]=T;fb=l+16|0;$g(k,x[f+12>>2],h,x[f>>2]);n=ne(f);Jk(f);l=1}_g(g+8|0,x[vb(f,n)>>2],l);fb=f+16|0;f=ud(x[g+8>>2]);fb=g+16|0;B[f+4>>2]=r;break s}if(!d){Iu(x[f+20>>2],r);break s}Iu(x[f+20>>2],Eq(b,B[g+144>>2],r));break s}l=(l|0)!=241;if(l&(g|0)>=0){break s}n=pm(a,b,c,3,0)-1|0;if((f|0)<0|(n&255)>>>0>249){break s}g=x[$d(a+906300|0,n&255)>>2];if(!g){break s}l=l?p&127:p+128|0;r=E(E((f&255)>>>0)/E(127));if(k){S=DT(b+223872|0,VS(m+24|0,n,l)),U=r,B[S>>2]=U;break s}f=x[g>>2];if(!d){ib[x[f+44>>2]](g,l,r);break s}T=g,V=l,U=Eq(b,E(ib[x[f+48>>2]](g,l)),r),S=x[x[g>>2]+44>>2],ib[S](T|0,V|0,E(U));break s}if(k){break s}k=z[a+480188>>1];v:{if(k>>>0>c>>>0){f=c+1|0;break v}f=z[(D(c,872)+b|0)+1402>>1];if(!f){break s}}if(y[(D(c,872)+b|0)+707|0]&2|k>>>0<(f&65535)>>>0){break s}f=pm(a,b,c,3,0)-1|0;if(f>>>0>249){break s}f=x[$d(a+906300|0,f)>>2];if(!f){break s}k=y[h|0];if((k|0)==240){lf(m+16|0,x[j>>2],x[j+4>>2]);g=x[x[f>>2]+72>>2];k=x[m+20>>2];x[m>>2]=x[m+16>>2];x[m+4>>2]=k;ib[g|0](f,m)|0;break s}S=m,V=xV(k),x[S+24>>2]=V;x[m+12>>2]=n;k=m+24|0;l=x[Hb(k,m+12|0)>>2];x[m+24>>2]=0;zc(k,g,l);ib[x[x[f>>2]+68>>2]](f,x[m+24>>2])|0}fb=m+32|0;q=u>>>0<240?u:q;i=e+i|0;continue}break}break}fb=j+48|0}function u7(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,w=0,z=0,A=0,B=0,C=0,D=0;l=fb-528|0;fb=l;x[l+520>>2]=k;x[l+524>>2]=b;a:{b:{if(hi(a,l+524|0)){x[f>>2]=x[f>>2]|4;a=0;break b}x[l+72>>2]=1274;b=l+72|0;t=De(l+104|0,l+112|0,b);m=x[t>>2];x[l+100>>2]=m;x[l+96>>2]=m+400;u=Fb(b);q=Fb(l+60|0);n=Fb(l+48|0);o=Fb(l+36|0);s=Fb(l+24|0);b=x[d>>2];x[31609]=0;ka(1284,c|0,b|0,l+92|0,l+88|0,l+84|0,u|0,q|0,n|0,o|0,l+20|0);b=x[31609];x[31609]=0;if((b|0)!=1){x[j>>2]=x[i>>2];z=e&512;w=x[l+20>>2];e=0;while(1){c:{d:{e:{f:{g:{if((e|0)==4){break g}x[31609]=0;b=P(1257,a|0,l+524|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if(b){break g}h:{i:{j:{k:{l:{switch(v[(l+92|0)+e|0]){case 1:if((e|0)==3){break c}b=x[a>>2];x[31609]=0;b=R(1258,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;b=U(1285,h|0,1,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if(b){x[31609]=0;O(1286,l+12|0,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){x[31609]=0;O(35,s|0,x[l+12>>2]);b=x[31609];x[31609]=0;if((b|0)!=1){break k}}break a}x[f>>2]=x[f>>2]|4;a=0;break d;case 4:break h;case 2:break i;case 3:break j;case 0:break l;default:break c}}if((e|0)==3){break c}}while(1){x[31609]=0;b=P(1257,a|0,l+524|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if(b){break c}b=x[a>>2];x[31609]=0;b=R(1258,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;b=U(1285,h|0,1,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if(!b){break c}x[31609]=0;O(1286,l+12|0,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){x[31609]=0;O(35,s|0,x[l+12>>2]);b=x[31609];x[31609]=0;if((b|0)!=1){continue}}break}break a}m:{if(!Cb(x[n+4>>2],y[n+11|0])){break m}b=x[a>>2];x[31609]=0;b=R(1258,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if(x[Wd(n,0)>>2]!=(b|0)){break m}x[31609]=0;R(1260,a|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}v[g|0]=0;r=Cb(x[n+4>>2],y[n+11|0])>>>0>1?n:r;break c}n:{o:{k=x[o+4>>2];b=y[o+11|0];if(Cb(k,b)){b=x[a>>2];x[31609]=0;b=R(1258,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if(x[Wd(o,0)>>2]==(b|0)){break o}k=x[o+4>>2];b=y[o+11|0]}c=Cb(x[n+4>>2],y[n+11|0]);if(!c){break n}if(!Cb(k,b)){break n}x[f>>2]=x[f>>2]|4;a=0;break d}x[31609]=0;R(1260,a|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}v[g|0]=1;r=Cb(x[o+4>>2],y[o+11|0])>>>0>1?o:r;break c}b=Cb(k,b);if(!(b|c)){break c}v[g|0]=!b;break c}if(!((e|0)==2&y[l+95|0]!=0|(e>>>0<2|r|z))){r=0;break c}b=vb(l+12|0,zd(q));p:{if(!e|y[(e+l|0)+91|0]>1){break p}q:{while(1){c=ol(q);d=x[b>>2];if(!Ib(d,c)){break q}c=x[d>>2];x[31609]=0;c=U(1285,h|0,1,c|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){if(!c){break q}We(b);continue}break}break a}c=zd(q);c=Mv(x[b>>2],c);if(Cb(x[s+4>>2],y[s+11|0])>>>0>=c>>>0){c=Fk(ol(s),0-c|0);d=ol(s);if(!jd(c,zd(q),d-c&-4)){break p}}C=b,D=x[vb(l+8|0,zd(q))>>2],x[C>>2]=D}x[l+8>>2]=x[b>>2];r:{while(1){b=ol(q);if(!Ib(x[l+8>>2],b)){break r}x[31609]=0;b=P(1257,a|0,l+524|0)|0;c=x[31609];x[31609]=0;s:{if((c|0)==1){break s}if(b){break r}b=x[a>>2];x[31609]=0;b=R(1258,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break s}if(x[x[l+8>>2]>>2]!=(b|0)){break r}x[31609]=0;R(1260,a|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}We(l+8|0);continue}break}break a}if(!z){break c}b=ol(q);if(!Ib(x[l+8>>2],b)){break c}x[f>>2]=x[f>>2]|4;a=0;break d}b=0;A=x[l+84>>2];c=m;t:{while(1){u:{x[31609]=0;d=P(1257,a|0,l+524|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break u}if(d){break t}d=x[a>>2];x[31609]=0;k=R(1258,d|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}x[31609]=0;d=U(1285,h|0,64,k|0)|0;B=x[31609];x[31609]=0;if((B|0)==1){break a}v:{if(d){d=x[j>>2];if((d|0)==x[l+520>>2]){x[31609]=0;S(1287,i|0,j|0,l+520|0);d=x[31609];x[31609]=0;if((d|0)==1){break a}d=x[j>>2]}x[j>>2]=d+4;x[d>>2]=k;b=b+1|0;break v}if(!Cb(x[u+4>>2],y[u+11|0])|!b|(k|0)!=(A|0)){break t}if(x[l+96>>2]==(m|0)){x[31609]=0;S(1280,t|0,l+100|0,l+96|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}m=x[l+100>>2]}c=m+4|0;x[l+100>>2]=c;x[m>>2]=b;m=c;b=0}x[31609]=0;R(1260,a|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){continue}}break}break a}if(!b|x[t>>2]==(c|0)){break f}if(x[l+96>>2]==(c|0)){x[31609]=0;S(1280,t|0,l+100|0,l+96|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}c=x[l+100>>2]}m=c+4|0;x[l+100>>2]=m;x[c>>2]=b;break e}x[l+20>>2]=w;w:{if(!r){break w}k=1;while(1){if(Cb(x[r+4>>2],y[r+11|0])>>>0<=k>>>0){break w}x[31609]=0;b=P(1257,a|0,l+524|0)|0;c=x[31609];x[31609]=0;x:{if((c|0)==1){break x}y:{if(!b){b=x[a>>2];x[31609]=0;b=R(1258,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break x}if(x[Wd(r,k)>>2]==(b|0)){break y}}x[f>>2]=x[f>>2]|4;a=0;break d}x[31609]=0;R(1260,a|0)|0;b=x[31609];x[31609]=0;k=k+1|0;if((b|0)!=1){continue}}break}break a}a=1;b=x[t>>2];if((b|0)==(m|0)){break d}a=0;x[l+12>>2]=0;Vf(u,b,m,l+12|0);if(x[l+12>>2]){x[f>>2]=x[f>>2]|4;break d}a=1;break d}m=c}z:{if((w|0)<=0){break z}x[31609]=0;b=P(1257,a|0,l+524|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}A:{if(!b){b=x[a>>2];x[31609]=0;b=R(1258,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if(x[l+88>>2]==(b|0)){break A}}x[f>>2]=x[f>>2]|4;a=0;break d}x[31609]=0;b=R(1260,a|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}while(1){if((w|0)<=0){w=0;break z}x[31609]=0;c=P(1257,b|0,l+524|0)|0;d=x[31609];x[31609]=0;B:{if((d|0)==1){break B}C:{if(!c){c=x[b>>2];x[31609]=0;c=R(1258,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break B}x[31609]=0;c=U(1285,h|0,64,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break B}if(c){break C}}x[f>>2]=x[f>>2]|4;a=0;break d}if(x[j>>2]==x[l+520>>2]){x[31609]=0;S(1287,i|0,j|0,l+520|0);c=x[31609];x[31609]=0;if((c|0)==1){break B}}c=x[b>>2];x[31609]=0;c=R(1258,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break B}d=x[j>>2];x[j>>2]=d+4;x[d>>2]=c;x[31609]=0;R(1260,b|0)|0;c=x[31609];x[31609]=0;w=w-1|0;if((c|0)!=1){continue}}break}break a}if(x[j>>2]!=x[i>>2]){break c}x[f>>2]=x[f>>2]|4;a=0}Ub(s);Ub(o);Ub(n);Ub(q);tb(u);Lc(t);break b}e=e+1|0;continue}}break a}fb=l+528|0;return a|0}a=N()|0;Ub(s);Ub(o);Ub(n);Ub(q);tb(u);Lc(t);Q(a|0);p()}function _oa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=fb-272|0;fb=e;yc(b);d=fb-16|0;fb=d;f=e+126|0;dX(d+8|0,f);g=x[d+12>>2];lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2]);h=x[d+4>>2];if((h|0)==(g|0)){Vb(b,x[d+12>>2])}fb=d+16|0;d=(g|0)==(h|0);if(!d){cX(f)}a:{b:{c:{d:{if(!d){break d}if(!eX(f)){break d}k=1;if((c|0)==64){break d}Dd(a,4194304);d=e+40|0;f=uc(d,17073);zb(a+1298344|0,f);tb(f);f=uc(d,10153);zb(a+1298356|0,f);tb(f);n=a+1298404|0,o=x[Fc(d,4)>>2],x[n>>2]=o;n=a,o=Ld(y[e+204|0]|y[e+205|0]<<8,y[e+206|0]|y[e+207|0]<<8,127),w[n+480188>>1]=o;f=y[e+195|0];x[a+480228>>2]=(f|0)==255?48:f;x[a+480196>>2]=y[e+193|0];x[a+480204>>2]=D(y[e+194|0],1e4);f=e+104|0;bf(f,e+130|0,59,3);Cc(d,f);zb(a+1298308|0,d);tb(d);d=y[e+208|0]|y[e+209|0]<<8|(y[e+210|0]<<16|y[e+211|0]<<24);e:{if(d>>>0<5){break e}if(!dd(b,d-4|0)){break e}if(!bk(b,14294)){break e}ak(Xb(x[a+484360>>2],y[a+484376|0]),b,y[e+198|0]|y[e+199|0]<<8,65535,65535)}f:{d=y[e+212|0]|y[e+213|0]<<8|(y[e+214|0]<<16|y[e+215|0]<<24);if(d>>>0<5){break f}if(!dd(b,d-4|0)){break f}if(!bk(b,13904)){break f}d=0;while(1){if((d|0)==32){break f}f=(d<<5)+a|0;Ue(f+480280|0);n=f+480284|0,o=((((Zd(b)^-1)&15)<<8|8)>>>0)/15|0,w[n>>1]=o;d=d+1|0;continue}}d=y[e+220|0]|y[e+221|0]<<8|(y[e+222|0]<<16|y[e+223|0]<<24);g:{if(d>>>0<5){break g}if(!dd(b,d-4|0)){break g}if(!bk(b,14189)){break g}d=e+40|0;he(d,b,(y[e+202|0]|y[e+203|0]<<8)<<6);i=c&2;k=a+480190|0;f=hc(e+104|0,d);ub(d);m=e+53|0;d=0;h:{while(1){if((d&65535)>>>0>=(y[e+202|0]|y[e+203|0]<<8)>>>0){break h}x[31609]=0;h=e+40|0;g=P(689,f|0,h|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break b}if(!g){break h}g=y[e+85|0]|y[e+86|0]<<8;w[e+38>>1]=g;i:{j:{if((g-1&65535)>>>0>3998){break j}g=D(g,104)+a|0;j=g+484380|0;if(le(x[j>>2],x[g+484400>>2])){break j}n=k,o=z[qe(k,e+38|0)>>1],w[n>>1]=o;x[31609]=0;O(690,h|0,j|0);g=x[31609];x[31609]=0;if((g|0)==1){break i}h=e+12|0;k_(h,1,m);x[31609]=0;g=e+24|0;O(218,g|0,h|0);h=x[31609];x[31609]=0;if((h|0)==1){break b}Ac(((z[e+38>>1]<<5)+a|0)+946304|0,g);tb(g);if(!i){break j}x[31609]=0;P(149,b|0,y[e+77|0]|y[e+78|0]<<8|(y[e+79|0]<<16|y[e+80|0]<<24))|0;h=x[31609];x[31609]=0;if((h|0)==1){break i}j=1;h=y[e+87|0];l=Zc(g,h&4?16:8,1,0,0);k:{l:{if(h&8){break l}j=2;if(h&16){break l}if(h&103){break k}}wg(l,j)}x[31609]=0;U(215,g|0,(D(z[e+38>>1],104)+a|0)+484380|0,b|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){break j}break b}d=d+1|0;continue}break}break b}ub(f)}k=1;if(!(c&1)){break d}m:{c=y[e+216|0]|y[e+217|0]<<8|(y[e+218|0]<<16|y[e+219|0]<<24);if(c>>>0<5){break m}if(!dd(b,c-4|0)){break m}if(!bk(b,13775)){break m}j=a+484344|0;Tf(j,y[e+200|0]|y[e+201|0]<<8);g=0;while(1){if((y[e+200|0]|y[e+201|0]<<8)>>>0<=g>>>0){break m}if(!Or(b,e+24|0)){break m}n:{d=z[e+24>>1];if(d>>>0>3){c=e+104|0;he(c,b,(d+15&131056)-4|0);f=hc(e+40|0,c);ub(c);x[31609]=0;c=U(196,j|0,g&65535,y[e+26|0])|0;d=x[31609];x[31609]=0;if((d|0)==1){break n}h=0;o:{if(!c){break o}p:while(1){m=h&255;while(1){q:{c=x[f>>2];x[31609]=0;d=U(150,c|0,x[e+48>>2],1)|0;c=x[31609];x[31609]=0;r:{if((c|0)!=1){c=y[e+26|0];if(!(d&c>>>0>m>>>0)){break q}x[31609]=0;c=R(197,f|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}d=c<<24>>24;if(d){break r}h=h+1|0;continue p}break c}c=x[a+484344>>2];w[e+104>>1]=d&31;w[e+12>>1]=z[a+480188>>1]-1;c=Wb(c,g);i=e+104|0;c=md(x[c>>2],x[x[c+48>>2]+12>>2],h,z[Oc(i,e+12|0)>>1]);if((d|0)<0){x[31609]=0;O(198,i|0,f|0);l=x[31609];x[31609]=0;if((l|0)==1){break c}v[c|0]=y[e+104|0]+36;n=c,o=y[Jc(i)|0],v[n+1|0]=o}d=d&255;if(d&64){v[c+2|0]=1;x[31609]=0;i=R(197,f|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break c}v[e+104|0]=i;v[e+12|0]=64;n=c,o=y[Qb(e+104|0,e+12|0)|0],v[n+4|0]=o}if(!(d&32)){continue}x[31609]=0;d=e+104|0;O(198,d|0,f|0);i=x[31609];x[31609]=0;s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{if((i|0)!=1){d=y[Jc(d)|0];v[c+5|0]=d;X:{switch(y[e+104|0]-1|0){case 71:break t;case 70:break u;case 69:break v;case 60:break w;case 59:break x;case 52:break y;case 51:break z;case 50:break A;case 49:break B;case 42:break C;case 41:break D;case 40:break E;case 39:break F;case 30:break G;case 29:break H;case 22:break I;case 21:break J;case 20:break K;case 19:break L;case 16:break M;case 15:break N;case 14:break O;case 13:break P;case 12:break Q;case 11:break R;case 10:break S;case 9:break T;case 3:break U;case 2:break V;case 1:break W;case 0:break X;default:break s}}v[c+3|0]=11;v[c+5|0]=d<<4|15;continue}break c}v[c+3|0]=11;v[c+5|0]=d<<4;continue}v[c+3|0]=11;v[c+5|0]=d|240;continue}v[c+3|0]=11;v[c+5|0]=d&15;continue}v[c+3|0]=2;v[c+5|0]=d|240;continue}v[c+3|0]=2;continue}v[c+3|0]=3;v[c+5|0]=d|240;continue}v[c+3|0]=3;continue}v[c+3|0]=4;continue}v[c+3|0]=20;v[c+5|0]=d|16;continue}v[c+3|0]=6;v[c+5|0]=d<<4;continue}v[c+3|0]=6;v[c+5|0]=d&15;continue}v[c+3|0]=5;continue}v[c+3|0]=20;v[c+5|0]=d|48;continue}v[c+3|0]=7;v[c+5|0]=d<<4;continue}v[c+3|0]=7;v[c+5|0]=d&15;continue}v[c+3|0]=8;continue}v[c+3|0]=20;v[c+5|0]=d|64;continue}v[c+3|0]=10;x[31609]=0;d=R(197,f|0)|0;i=x[31609];x[31609]=0;if((i|0)!=1){v[c+5|0]=d;x[31609]=0;P(183,f|0,1)|0;c=x[31609];x[31609]=0;if((c|0)!=1){continue}}break c}v[c+3|0]=15;v[c+5|0]=d&15;continue}v[c+3|0]=20;v[c+5|0]=d|192;continue}v[c+3|0]=20;v[c+5|0]=d|208;continue}v[c+3|0]=12;continue}v[c+3|0]=14;continue}v[c+3|0]=20;v[c+5|0]=d|176;continue}v[c+3|0]=20;v[c+5|0]=d|224;continue}v[c+3|0]=16;continue}v[c+3|0]=17;continue}v[c+3|0]=1;continue}v[c+3|0]=20;v[c+5|0]=d&15|32;continue}v[c+3|0]=20;v[c+5|0]=d&15|128;continue}v[c+3|0]=0;continue}break}break}if((c|0)==64){break o}Ae(Wb(x[j>>2],g),Xh(Ve(Oe(e+104|0,14,0),c-1|0)))}ub(f)}g=g+1|0;continue}break}break c}c=y[e+224|0]|y[e+225|0]<<8|(y[e+226|0]<<16|y[e+227|0]<<24);if(!c){break d}dd(b,c);cE(a+1298332|0,b,gh(b),4)}fb=e+272|0;return k|0}a=N()|0;break a}a=N()|0}ub(f);Q(a|0);p()}function ioa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;d=fb-176|0;fb=d;yc(c);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{if(!gp(c,d+164|0)|(y[d+164|0]|y[d+165|0]<<8|(y[d+166|0]<<16|y[d+167|0]<<24))!=1297239878){break l}f=y[d+172|0]|y[d+173|0]<<8|(y[d+174|0]<<16|y[d+175|0]<<24);if((f|0)!=1179011393&(f|0)!=1128679745){break l}e=fb-32|0;fb=e;i=d+152|0;f=Nb(i);m:{n:{o:{p:{q:{while(1){g=x[c+8>>2];h=x[c>>2];x[31609]=0;g=U(150,h|0,g|0,8)|0;h=x[31609];x[31609]=0;if((h|0)==1){break o}if(!g){break p}x[31609]=0;g=e+4|0;O(825,g|0,c|0);h=x[31609];x[31609]=0;if((h|0)!=1){x[31609]=0;O(826,f|0,g|0);h=x[31609];x[31609]=0;if((h|0)==1){break q}Hd(g);continue}break}a=N()|0;break n}a=N()|0;Hd(e+4|0);break n}fb=e+32|0;break m}a=N()|0}ke(f);Q(a|0);p()}x[31609]=0;e=d+132|0;S(747,e|0,i|0,1129270605);c=x[31609];x[31609]=0;if((c|0)==1){break f}x[31609]=0;c=P(748,e|0,d+114|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break i}r:{if(!c){break r}if(!$b(z[d+116>>1]|z[d+118>>1]<<16)){break r}if((Bb(z[d+114>>1])-3&65535)>>>0<65534){break r}if((Bb(z[d+120>>1])-65&65535)>>>0<65472){break r}v[d+110|0]=78;v[d+111|0]=79;v[d+112|0]=78;v[d+113|0]=69;c=1;if((y[d+172|0]|y[d+173|0]<<8|(y[d+174|0]<<16|y[d+175|0]<<24))==1128679745){x[31609]=0;c=P(628,e|0,d+110|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break h}if(!c){break r}c=(y[d+110|0]|y[d+111|0]<<8|(y[d+112|0]<<16|y[d+113|0]<<24))!=1936684916}x[31609]=0;e=d+88|0;S(747,e|0,d+152|0,1397968452);f=x[31609];x[31609]=0;s:{t:{u:{if((f|0)!=1){x[31609]=0;l=P(749,e|0,d+80|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break j}if(!l){break s}f=(Bb(z[d+120>>1])-1|0)/8|0;g=f<<3;e=g&31;h=d+76|0;if((g&63)>>>0>=32){e=1074268168>>>e|0}else{e=((1<<e)-1&1074268168)<<32-e|538447880>>>e}g=Zc(h,(f>>>0>=8?8:e)&120,(Bb(z[d+114>>1])|0)==2?2:1,c,0);c=y[d+110|0]|y[d+111|0]<<8|(y[d+112|0]<<16|y[d+113|0]<<24);if(!((c|0)==842230886|(c|0)==842222662|(c|0)==875981926)){if((c|0)!=875973702){break u}}wg(g,3);break t}c=N()|0;break b}c=y[d+110|0]|y[d+111|0]<<8|(y[d+112|0]<<16|y[d+113|0]<<24);if(!((c|0)!=2002873441&(c|0)!=1463897153)){wg(g,17);hd(g,16);break t}c=y[d+110|0]|y[d+111|0]<<8|(y[d+112|0]<<16|y[d+113|0]<<24);if(!((c|0)!=2002873461&(c|0)!=1463897173)){wg(g,16);hd(g,16);break t}if((y[d+110|0]|y[d+111|0]<<8|(y[d+112|0]<<16|y[d+113|0]<<24))!=544694642){break t}wg(g,1)}c=x[d+80>>2];x[31609]=0;c=U(150,x[d+88>>2],x[d+96>>2],$b(c)|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break d}if(c){c=x[d+80>>2];x[31609]=0;P(183,d+88|0,$b(c)|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break d}}Wu(a,b);x[31609]=0;c=D(b,104)+a|0;i=c+484380|0;O(279,i|0,0);e=x[31609];x[31609]=0;v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{if((e|0)==1){break E}s=i,t=$b(z[d+116>>1]|z[d+118>>1]<<16),x[s>>2]=t;j=c+484404|0;c=y[d+124|0]|y[d+125|0]<<8|(y[d+126|0]<<16|y[d+127|0]<<24);f=c<<24|(c&65280)<<8|(c>>>8&65280|c>>>24);h=30-y[d+123|0]|0;e=0;while(1){c=f;if(h&255){f=c>>>1|0;h=h-1|0;e=c;continue}break}x[j>>2]=c+(e&1);x[31609]=0;U(215,g|0,i|0,d+88|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break E}x[31609]=0;e=d+56|0;f=d+152|0;S(747,e|0,f|0,1296126539);c=x[31609];x[31609]=0;if((c|0)==1){break D}x[31609]=0;c=R(172,x[d+56>>2])|0;g=x[31609];x[31609]=0;if((g|0)==1){break C}if(!c){break v}x[31609]=0;c=d+16|0;S(747,c|0,f|0,1229869908);f=x[31609];x[31609]=0;if((f|0)==1){break B}x[31609]=0;f=P(750,c|0,d+36|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break A}ub(c);if(!f){break v}x[31609]=0;f=R(273,e|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break z}e=Nb(c);x[31609]=0;O(751,e|0,f|0);c=x[31609];x[31609]=0;if((c|0)==1){break x}c=0;while(1){if((c|0)==(f|0)){break y}x[31609]=0;g=d+56|0;h=d+4|0;j=P(752,g|0,h|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break x}if(!j){break y}x[31609]=0;O(753,e|0,h|0);h=x[31609];x[31609]=0;if((h|0)==1){break x}x[31609]=0;P(183,g|0,y[d+10|0]|1)|0;g=x[31609];x[31609]=0;if((g|0)==1){break x}c=c+1|0;continue}}c=N()|0;break c}c=N()|0;break c}c=N()|0;break e}c=N()|0;break e}c=N()|0;ub(d+16|0);break e}c=N()|0;break e}c=Bb(y[d+44|0]|y[d+45|0]<<8);if(c){f=(D(b,104)+a|0)+484414|0;w[f>>1]=z[f>>1]&65511|((c|0)==2)<<4|8}c=Bb(y[d+50|0]|y[d+51|0]<<8);if(c){f=(D(b,104)+a|0)+484414|0;w[f>>1]=z[f>>1]&65529|((c|0)==2?4:2)|2}s=d,t=wb(x[e>>2]),x[s+4>>2]=t;c=D(b,104)+a|0;g=c+484388|0;h=c+484384|0;j=c+484396|0;k=c+484392|0;m=wb(x[e+4>>2]);n=y[d+46|0]|y[d+47|0]<<8;o=y[d+48|0]|y[d+49|0]<<8;q=y[d+52|0]|y[d+53|0]<<8;r=y[d+54|0]|y[d+55|0]<<8;while(1){c=x[d+4>>2];if(!Ib(c,m)){break w}f=Bb(y[c|0]|y[c+1|0]<<8);if((f|0)==(Bb(n)|0)){s=k,t=$b(y[c+2|0]|y[c+3|0]<<8|(y[c+4|0]<<16|y[c+5|0]<<24)),x[s>>2]=t;f=Bb(y[c|0]|y[c+1|0]<<8)}if((Bb(o)|0)==(f|0)){s=j,t=$b(y[c+2|0]|y[c+3|0]<<8|(y[c+4|0]<<16|y[c+5|0]<<24)),x[s>>2]=t;f=Bb(y[c|0]|y[c+1|0]<<8)}if((Bb(q)|0)==(f|0)){s=h,t=$b(y[c+2|0]|y[c+3|0]<<8|(y[c+4|0]<<16|y[c+5|0]<<24)),x[s>>2]=t;f=Bb(y[c|0]|y[c+1|0]<<8)}if((f|0)==(Bb(r)|0)){s=g,t=$b(y[c+2|0]|y[c+3|0]<<8|(y[c+4|0]<<16|y[c+5|0]<<24)),x[s>>2]=t}x[d+4>>2]=x[d+4>>2]+7;continue}}c=N()|0;RT(e);break e}Vk(i);RT(e)}x[31609]=0;c=d+16|0;S(747,c|0,d+152|0,1312902469);e=x[31609];x[31609]=0;if((e|0)==1){break g}x[31609]=0;e=R(172,x[d+16>>2])|0;f=x[31609];x[31609]=0;if((f|0)==1){break k}F:{if(e){x[31609]=0;e=R(154,x[d+16>>2])|0;f=x[31609];x[31609]=0;if((f|0)==1){break k}x[31609]=0;S(317,c|0,((b<<5)+a|0)+946304|0,e|0);b=x[31609];x[31609]=0;if((b|0)!=1){break F}break k}x[31609]=0;c=P(36,d+4|0,22292)|0;e=x[31609];x[31609]=0;if((e|0)==1){break k}Ac(((b<<5)+a|0)+946304|0,c);tb(c)}eC(i,x[a+480180>>2]);Jj(i,a);ub(d+16|0);ub(d+56|0)}ub(d+88|0)}ub(d+132|0);ke(d+152|0)}fb=d+176|0;return l|0}c=N()|0;ub(d+16|0);break e}c=N()|0;break c}c=N()|0;break b}c=N()|0;break b}c=N()|0;break e}c=N()|0;break a}ub(d+56|0);break c}c=N()|0}ub(d+88|0)}ub(d+132|0)}ke(d+152|0);Q(c|0);p()}function kka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;j=fb-48|0;fb=j;d=x[b>>2];x[31609]=0;f=R(172,d|0)|0;d=x[31609];x[31609]=0;a:{b:{c:{d:{if((d|0)==1){break d}e:{f:{if(f){d=0;h=Nb(j+36|0);g:{h:{i:{if(c&16){break i}x[31609]=0;e=(c|0)!=64;g=U(862,h|0,b|0,e|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}f=2;j:{if(g){break j}x[31609]=0;g=U(863,h|0,b|0,e|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}f=3;if(g){break j}x[31609]=0;g=U(864,h|0,b|0,e|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}f=4;if(g){break j}g=0;x[31609]=0;i=U(865,h|0,b|0,e|0)|0;e=x[31609];x[31609]=0;f=1;if((e|0)==1){break e}if(!i){break i}}if((c|0)==64){f=1;break h}g=x[h>>2];if(!mc(g,x[h+4>>2])){ax(b,g+12|0)}g=f}if(c&32){f=0;break h}k:{while(1){f=d;if((d|0)!=576){e=x[d+29896>>2];i=(e>>1)+a|0;d=x[d+29892>>2];d=e&1?x[x[i>>2]+d>>2]:d;x[31609]=0;e=U(d|0,i|0,b|0,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}d=f+12|0;if(!e){continue}break k}break}x[a+480180>>2]=0;x[a+480184>>2]=0}if((c|0)==64){f=(f|0)!=576;d=0;break h}if(!(x[a+480184>>2]|!g)){x[a+480184>>2]=g}x[31609]=0;d=1;O(801,a+1298264|0,1);g=x[31609];x[31609]=0;f=1;if((g|0)==1){break g}}hS(h);if(d){break f}break a}break c}x[31609]=0;O(246,a|0,0);d=x[31609];x[31609]=0;if((d|0)==1){break d}x[31609]=0;O(801,a+1298264|0,1);d=x[31609];x[31609]=0;if((d|0)==1){break d}x[a+1074304>>2]=20054022;x[a+1298408>>2]=0}f=0;while(1){if((f|0)==127){d=1;while(1){f=d&65535;if(f>>>0>z[a+480190>>1]){d=0;f=0;l:{while(1){g=f&65535;if(g>>>0>z[a+480192>>1]){m:{w[a+480192>>1]=d;d=a+480204|0;if(A[a+480204>>2]>=1e4){break m}x[d>>2]=125e4;break l}}else{e=x[((g<<2)+a|0)+900380>>2];if(e){g=x[a+480180>>2];xc(e,65536);xc(e+4|0,64);xc(e+8|0,256);Hf(e+28|0,16384);Of(e+30|0,128);Of(e+31|0,17);if(y[e+16|0]>=4){v[e+16|0]=0}if(y[e+17|0]>=5){v[e+17|0]=0}if(y[e+18|0]>=3){v[e+18|0]=0}Of(e+19|0,64);Of(e+20|0,100);k=224;d=v[e+26|0];n:{if((d|0)>=-32){k=32;if((d|0)<33){break n}}v[e+26|0]=k}Of(e+23|0,64);Of(e+24|0,64);gC(e+48|0,64);gC(e+68|0,64);gC(e+88|0,(g|0)==4096?255:64);g=e+108|0;k=0;while(1){o:{if((k|0)==128){if(!tp(y[e+14|0])){v[e+14|0]=5}if(y[e+34|0]>=251){v[e+34|0]=0}break o}d=xb(g,k);if((y[d|0]-121&255)>>>0<=135){v[d|0]=k+1}k=k+1|0;continue}break}d=f}f=f+1|0;continue}break}xc(d,65535e4)}if(!x[a+480196>>2]){x[a+480196>>2]=6}g=a+480216|0;f=a+480220|0;d=x[a+480216>>2];if(!(d|y[a+480224|0]!=2)){x[g>>2]=1;d=1}if(A[a+480220>>2]<d>>>0){x[f>>2]=d}xc(g,65536);xc(f,65536);xc(a+480200|0,256);p:{if(!mc(x[a+480248>>2],x[a+480252>>2])){d=x[g>>2];x[31609]=0;O(866,a+480248|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break p}}x[a+1074416>>2]=x[a+480196>>2];x[a+1074420>>2]=x[a+480204>>2];d=x[a+480220>>2];f=a+1074408|0;x[f>>2]=x[a+480216>>2];x[f+4>>2]=d;x[a+1074456>>2]=x[a+480200>>2];tB(a+1074376|0);d=a+1074446|0;w[d>>1]=0;w[d+2>>1]=0;w[d+4>>1]=0;w[d+6>>1]=65535;x[a+1074392>>2]=-2;d=a+1074384|0;x[d>>2]=0;x[d+4>>2]=0;x[a+1074380>>2]=0;d=a+1074424|0;x[d>>2]=0;x[d+4>>2]=0;x[a+1074432>>2]=0;d=a+1074396|0;x[d>>2]=0;x[d+4>>2]=0;if(yn(x[a+480180>>2])){x[31609]=0;P(267,a+1074312|0,7)|0;d=x[31609];x[31609]=0;if((d|0)==1){break p}}w[a+480276>>1]=0;Bq(a);l=j,m=wb(x[a+484360>>2]),x[l+36>>2]=m;f=wb(x[a+484364>>2]);q:{while(1){r:{g=x[j+36>>2];if(!Ib(g,f)){if(x[a+480180>>2]){break r}f=0;break a}x[31609]=0;W(867,g|0);d=x[31609];x[31609]=0;if((d|0)==1){break q}if($c(x[g>>2],x[g+4>>2])>>>0<=z[g+28>>1]){$e(g,0)}Zq(j+36|0);continue}break}Bu(a+8|0,sr(a));if(x[a+1074308>>2]){x[31609]=0;W(868,a|0);d=x[31609];x[31609]=0;if((d|0)==1){break p}}i=Nb(j+36|0);s:{t:{if((c&12)!=12){break t}g=a+906300|0;f=0;u:{v:{w:{x:{y:{z:{while(1){if((f|0)==250){break t}A:{h=$d(g,f);B:{if(!Oi(x[h+16>>2],x[h+20>>2])){break B}x[31609]=0;O(869,h|0,a|0);c=x[31609];x[31609]=0;C:{if((c|0)!=1){e=x[h>>2];if(!e){break C}d=x[h+148>>2];c=x[x[e>>2]+56>>2];x[31609]=0;O(c|0,e|0,d|0);c=x[31609];x[31609]=0;if((c|0)!=1){break B}}a=N()|0;break s}k=wb(x[i>>2]);c=wb(x[i+4>>2]);e=fb-16|0;fb=e;x[e+12>>2]=k;while(1){D:{if(!Ib(k,c)){break D}d=x[k>>2];if((y[d+4|0]|y[d+5|0]<<8|(y[d+6|0]<<16|y[d+7|0]<<24))==(y[h+20|0]|y[h+21|0]<<8|(y[h+22|0]<<16|y[h+23|0]<<24))){d=(y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24))==(y[h+16|0]|y[h+17|0]<<8|(y[h+18|0]<<16|y[h+19|0]<<24))}else{d=0}if(d){break D}k=x[We(e+12|0)>>2];continue}break}fb=e+16|0;if(Ib(k,wb(x[i+4>>2]))){break B}x[31609]=0;x[j+24>>2]=h+16;e=j+24|0;O(870,i|0,e|0);c=x[31609];x[31609]=0;if((c|0)==1){break A}x[31609]=0;d=P(1,j+12|0,18339)|0;c=x[31609];x[31609]=0;if((c|0)==1){break z}x[31609]=0;O(871,j|0,h|0);c=x[31609];x[31609]=0;if((c|0)==1){break y}x[31609]=0;S(2,e|0,d|0,j|0);c=x[31609];x[31609]=0;if((c|0)==1){break x}c=x[a+1298472>>2];x[31609]=0;S(385,c|0,2,e|0);c=x[31609];x[31609]=0;if((c|0)==1){break w}tb(e);tb(j);tb(d)}f=f+1|0;continue}break}a=N()|0;break s}a=N()|0;break s}a=N()|0;break u}a=N()|0;break v}a=N()|0;tb(j+24|0)}tb(j)}tb(d);break s}c=y[a+1074368|0];x[31609]=0;O(872,a|0,c|0);a=x[31609];x[31609]=0;f=1;if((a|0)!=1){wc(i);break a}a=N()|0}wc(i);break b}a=N()|0;break b}a=N()|0;break b}e=D(f,104)+a|0;i=e+484380|0;E:{if(le(x[i>>2],x[e+484400>>2])){Jj(i,a);break E}g=e+484414|0;f=z[g>>1];if(f&16384){break E}x[i>>2]=0;x[i+4>>2]=0;x[i+16>>2]=0;x[i+8>>2]=0;x[i+12>>2]=0;w[g>>1]=f&49121}f=e+484412|0;if(z[f>>1]>=65){w[f>>1]=64}F:{G:{if(!(y[e+484415|0]&2)){break G}if(!Gj(x[a+1298300>>2])){break G}x[31609]=0;W(873,a|0);f=x[31609];x[31609]=0;if((f|0)==1){break F}}d=d+1|0;continue}break}a=N()|0;break b}g=(f<<5)+a|0;Hf(g+480286|0,64);d=g+480284|0;if(z[d>>1]>=257){w[d>>1]=128}d=g+480288|0;if(y[d|0]>=251){v[d|0]=0}Po((D(f,872)+a|0)+1074992|0,a,f&65535,67108864);f=f+1|0;continue}}break c}a=N()|0;break b}a=N()|0;hS(h)}ub(b);Q(a|0);p()}ub(b);fb=j+48|0;return f|0}function B7(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,w=0,z=0,A=0,B=0,C=0,D=0,E=0;l=fb-528|0;fb=l;x[l+520>>2]=k;x[l+524>>2]=b;a:{b:{if(th(a,l+524|0)){x[f>>2]=x[f>>2]|4;a=0;break b}x[l+76>>2]=1274;b=l+76|0;t=De(l+104|0,l+112|0,b);m=x[t>>2];x[l+100>>2]=m;x[l+96>>2]=m+400;u=Fb(b);q=Fb(l- -64|0);n=Fb(l+52|0);o=Fb(l+40|0);s=Fb(l+28|0);b=x[d>>2];x[31609]=0;ka(1277,c|0,b|0,l+92|0,l+91|0,l+90|0,u|0,q|0,n|0,o|0,l+24|0);b=x[31609];x[31609]=0;if((b|0)!=1){x[j>>2]=x[i>>2];z=e&512;w=x[l+24>>2];A=y[l+95|0];B=y[l+91|0];C=y[l+90|0];d=m;e=0;while(1){c:{d:{e:{f:{if((e|0)==4){break f}x[31609]=0;b=P(1241,a|0,l+524|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if(b){break f}b=0;g:{h:{i:{j:{k:{switch(v[(l+92|0)+e|0]){case 1:if((e|0)==3){break c}b=x[a>>2];x[31609]=0;b=R(1242,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if(Jf(x[h+8>>2],1,b)){x[31609]=0;O(1278,l+16|0,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){x[31609]=0;O(115,s|0,v[l+16|0]);b=x[31609];x[31609]=0;if((b|0)!=1){break j}}break a}x[f>>2]=x[f>>2]|4;a=0;break d;case 4:break g;case 2:break h;case 3:break i;case 0:break k;default:break c}}if((e|0)==3){break c}}while(1){x[31609]=0;b=P(1241,a|0,l+524|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if(b){break c}b=x[a>>2];x[31609]=0;b=R(1242,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if(!Jf(x[h+8>>2],1,b)){break c}x[31609]=0;O(1278,l+16|0,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){x[31609]=0;O(115,s|0,v[l+16|0]);b=x[31609];x[31609]=0;if((b|0)!=1){continue}}break}break a}l:{if(!Cb(x[n+4>>2],y[n+11|0])){break l}b=x[a>>2];x[31609]=0;b=R(1242,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if(y[dc(n,0)|0]!=(b&255)){break l}x[31609]=0;R(1244,a|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}v[g|0]=0;r=Cb(x[n+4>>2],y[n+11|0])>>>0>1?n:r;break c}m:{n:{k=x[o+4>>2];b=y[o+11|0];if(Cb(k,b)){b=x[a>>2];x[31609]=0;b=R(1242,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if(y[dc(o,0)|0]==(b&255)){break n}k=x[o+4>>2];b=y[o+11|0]}c=Cb(x[n+4>>2],y[n+11|0]);if(!c){break m}if(!Cb(k,b)){break m}x[f>>2]=x[f>>2]|4;a=0;break d}x[31609]=0;R(1244,a|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}v[g|0]=1;r=Cb(x[o+4>>2],y[o+11|0])>>>0>1?o:r;break c}b=Cb(k,b);if(!(b|c)){break c}v[g|0]=!b;break c}if(!(e>>>0<2|r|((e|0)==2&(A|0)!=0|z))){r=0;break c}b=vb(l+16|0,zd(q));o:{if(!e|y[(e+l|0)+91|0]>1){break o}while(1){p:{c=Ef(q);k=x[b>>2];if(!Ib(k,c)){break p}if(!Jf(x[h+8>>2],1,v[k|0])){break p}we(b);continue}break}c=zd(q);c=Ak(x[b>>2],c);if(Cb(x[s+4>>2],y[s+11|0])>>>0>=c>>>0){if(x0(aD(Ef(s),c),Ef(s),zd(q))){break o}}D=b,E=x[vb(l+12|0,zd(q))>>2],x[D>>2]=E}x[l+12>>2]=x[b>>2];q:{while(1){b=Ef(q);if(!Ib(x[l+12>>2],b)){break q}x[31609]=0;b=P(1241,a|0,l+524|0)|0;c=x[31609];x[31609]=0;r:{if((c|0)==1){break r}if(b){break q}b=x[a>>2];x[31609]=0;b=R(1242,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break r}if(y[x[l+12>>2]]!=(b&255)){break q}x[31609]=0;R(1244,a|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}we(l+12|0);continue}break}break a}if(!z){break c}b=Ef(q);if(!Ib(x[l+12>>2],b)){break c}x[f>>2]=x[f>>2]|4;a=0;break d}s:{while(1){t:{x[31609]=0;c=P(1241,a|0,l+524|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break t}if(c){break s}c=x[a>>2];x[31609]=0;k=R(1242,c|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}u:{if(Jf(x[h+8>>2],64,k)){c=x[j>>2];if((c|0)==x[l+520>>2]){x[31609]=0;S(1279,i|0,j|0,l+520|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}c=x[j>>2]}x[j>>2]=c+1;v[c|0]=k;b=b+1|0;break u}if(!Cb(x[u+4>>2],y[u+11|0])|!b|(k&255)!=(C|0)){break s}if(x[l+96>>2]==(d|0)){x[31609]=0;S(1280,t|0,l+100|0,l+96|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}d=x[l+100>>2]}m=d+4|0;x[l+100>>2]=m;x[d>>2]=b;d=m;b=0}x[31609]=0;R(1244,a|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){continue}}break}break a}if(!(!b|x[t>>2]==(m|0))){if(x[l+96>>2]==(m|0)){x[31609]=0;S(1280,t|0,l+100|0,l+96|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}m=x[l+100>>2]}c=m+4|0;x[l+100>>2]=c;x[m>>2]=b;m=c}if((w|0)<=0){break e}x[31609]=0;b=P(1241,a|0,l+524|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}v:{if(!b){b=x[a>>2];x[31609]=0;b=R(1242,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}if((b&255)==(B|0)){break v}}x[f>>2]=x[f>>2]|4;a=0;break d}x[31609]=0;b=R(1244,a|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}while(1){if((w|0)<=0){w=0;break e}x[31609]=0;c=P(1241,b|0,l+524|0)|0;d=x[31609];x[31609]=0;w:{if((d|0)==1){break w}x:{if(!c){c=x[b>>2];x[31609]=0;c=R(1242,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break w}if(Jf(x[h+8>>2],64,c)){break x}}x[f>>2]=x[f>>2]|4;a=0;break d}if(x[j>>2]==x[l+520>>2]){x[31609]=0;S(1279,i|0,j|0,l+520|0);c=x[31609];x[31609]=0;if((c|0)==1){break w}}c=x[b>>2];x[31609]=0;c=R(1242,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break w}d=x[j>>2];x[j>>2]=d+1;v[d|0]=c;x[31609]=0;R(1244,b|0)|0;c=x[31609];x[31609]=0;w=w-1|0;if((c|0)!=1){continue}}break}break a}x[l+24>>2]=w;y:{if(!r){break y}k=1;while(1){if(Cb(x[r+4>>2],y[r+11|0])>>>0<=k>>>0){break y}x[31609]=0;b=P(1241,a|0,l+524|0)|0;c=x[31609];x[31609]=0;z:{if((c|0)==1){break z}A:{if(!b){b=x[a>>2];x[31609]=0;b=R(1242,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break z}if(y[dc(r,k)|0]==(b&255)){break A}}x[f>>2]=x[f>>2]|4;a=0;break d}x[31609]=0;R(1244,a|0)|0;b=x[31609];x[31609]=0;k=k+1|0;if((b|0)!=1){continue}}break}break a}a=1;b=x[t>>2];if((b|0)==(m|0)){break d}a=0;x[l+16>>2]=0;Vf(u,b,m,l+16|0);if(x[l+16>>2]){x[f>>2]=x[f>>2]|4;break d}a=1;break d}d=m;if(x[j>>2]!=x[i>>2]){break c}x[f>>2]=x[f>>2]|4;a=0}tb(s);tb(o);tb(n);tb(q);tb(u);Lc(t);break b}e=e+1|0;continue}}break a}fb=l+528|0;return a|0}a=N()|0;tb(s);tb(o);tb(n);tb(q);tb(u);Lc(t);Q(a|0);p()}function Su(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=fb-16|0;fb=n;x[n+12>>2]=c;a:{if((c|0)<=0){break a}i=x[b+104>>2];b:{c:{d:{e:{f:{g:{h:{i:{j:{j=x[b+656>>2];k:{if(!(!j|x[a+480180>>2]!=16777216)){l=x[j+44>>2]!=0;break k}if(!j){break j}}if((c|0)>128){break i}m=c-1|0;h=z[bc(j+236|0,m)>>1];l:{if((h-1&65535)>>>0<=3998){i=(D(h,104)+a|0)+484380|0;break l}if(!Ob(a+1074312|0,43)){break l}if(!Cj(x[b+656>>2])){break a}}m=y[xb(j+108|0,m)|0];x[n+12>>2]=m;if(m>>>0<=120){break h}c=m;break i}m=c;h=0;if(c>>>0<121){break g}}m:{if(!(x[a+480180>>2]&16777248?(c|0)!=255:0)){Eo(a,b);if(d){break m}if(!Ob(a+1074312|0,100)|!(y[a+480208|0]&4)|!y[b+789|0]){break m}x[b+88>>2]=x[b+88>>2]&-6145;break m}if(!z[a+480192>>1]){break m}x[b+88>>2]=x[b+88>>2]|4096}n:{if((c|0)!=254){break n}c=x[b+88>>2];if(!(!(c&512)|x[a+480180>>2]!=2)){x[b+88>>2]=c|2048;break n}x[b+88>>2]=c|2101248;o:{if(x[a+480180>>2]&16777248){if(!z[a+480192>>1]){break o}if(Ob(a+1074312|0,50)){break o}}x[b+688>>2]=0}if(Ob(a+1074312|0,50)){x[b+8>>2]=0;x[b+12>>2]=0}x[b+696>>2]=0}if(!Ob(a+1074312|0,20)){break a}v[b+797|0]=0;v[b+802|0]=0;break a}h=0;if(!l){break g}if(d){h=y[b+797|0];if(h){break f}}x[b+708>>2]=0;h=1}if(d){break e}if(!(!(x[a+480180>>2]&1048588)|!i)){w[b+770>>1]=v[i+36|0];w[b+772>>1]=v[i+37|0];break d}if(i){break d}i=0;p=1;break c}h=D((x[x[j+44>>2]+36>>2]<<16>>16)+1|0,(m<<16>>16)-(h<<16>>16)|0)-x[b+852>>2]|0;x[b+708>>2]=h;x[b+852>>2]=0-h;h=1}p=!i;l=1;if(Oi(x[b+8>>2],x[b+12>>2])){break b}p:{l=a+1074312|0;if(!Ob(l,54)){break p}if(Cj(x[b+656>>2])){if(!Ob(l,117)){break p}}x[b+700>>2]=0;break a}l=(Ob(l,39)^-1)&d;break b}if(!Ob(a+1074312|0,24)){break c}x[b+704>>2]=x[i+24>>2]}l=0}q:{if(yn(x[a+480180>>2])){x[n+12>>2]=w[b+770>>1]+m;He(n+12|0,12,131);break q}IX(n+12|0)}k=a+1074312|0;r:{if(Ob(k,34)){d=iE(c);break r}d=x[n+12>>2]}v[b+797|0]=d;v[b+851|0]=y[b+851|0]&183|64;if(!(x[a+480180>>2]&16777250?0:l)){v[b+803|0]=0}o=zh(a,x[n+12>>2],w[b+772>>1],x[b+704>>2]);v[b+831|0]=0;if(Ob(k,48)){iT(a,b,j,i)}s:{if(!Ob(k,115)|!j){break s}d=y[j+26|0];if(!d){break s}if(!z[b+784>>1]){w[b+784>>1]=z[b+692>>1]+1}hT(b+692|0,c,d,y[j+27|0])}t:{if(l|e^1){break t}x[b+776>>2]=0;x[b+780>>2]=0;if(!j){break t}if(Ob(k,29)){v[b+798|0]=y[j+16|0]}if(!(y[j+60|0]&8)){Bj(b+724|0)}if(!(y[j+80|0]&8)){Bj(b+732|0)}if(!(y[j+100|0]&8)){Bj(b+740|0)}if(y[j+20|0]){c=((D(Pu(Do(a)),y[j+20|0])<<16>>16)/64|0)+1<<16>>16;u:{if(Ob(k,28)){d=x[b+752>>2];break u}d=(x[b+688>>2]+1|0)/2|0}w[b+776>>1]=(D(d,c)|0)/199}v:{if(!y[j+19|0]){break v}r=b,s=(D(Pu(Do(a)),y[j+19|0])<<16>>16)/32|0,w[r+778>>1]=s;if(Ob(k,28)|z[b+784>>1]){break v}w[b+784>>1]=z[b+692>>1]+1}m=y[j+23|0];if(m){d=Pu(Do(a));c=y[b+837|0];v[b+796|0]=c+1;w[b+780>>1]=(D((D(m,d+1|0)<<16>>16)/128<<16>>16,c)+1|0)/128}m=y[j+24|0];if(!m){break t}d=Pu(Do(a));c=y[b+838|0];v[b+795|0]=c+1;w[b+782>>1]=(D(c,(D(m,d+1|0)<<16>>16)/128<<16>>16)+1|0)/128}if(p){break a}w:{x:{if(!o){d=0;break x}if(!(l&x[b+700>>2]!=0)){x[b+700>>2]=o}y:{z:{if(!h){if(!l){if(Ob(k,69)){break z}if(Ob(k,46)|x[a+480180>>2]==1){break z}}x[b+708>>2]=o;v[b+851|0]=y[b+851|0]&239}if(!l){break z}if(x[b+76>>2]|y[a+480180|0]&2){break y}}x[b+104>>2]=i;c=x[i>>2];x[b+84>>2]=c;x[b+76>>2]=c;x[b+80>>2]=0;x[b>>2]=0;x[b+4>>2]=0;A:{B:{C:{if(!(y[a+480210|0]&32)){if(!Ob(k,96)|y[b+789|0]){break B}q=x[b>>2];c=x[b+76>>2];break C}if(y[b+789|0]){break B}}x[n+8>>2]=c-1;c=x[Hb(b+660|0,n+8|0)>>2];x[b>>2]=q;x[b+4>>2]=c;break A}x[b+660>>2]=0}c=z[i+34>>1];h=c&1023;d=h|x[b+88>>2]&-525056;x[b+88>>2]=d;D:{E:{if(c&8){x[b+80>>2]=x[i+12>>2];c=x[i+16>>2];x[b+88>>2]=(h&16?d|4:d&-524311)|2;x[b+84>>2]=c;if(A[b+76>>2]>c>>>0){break E}break D}if(!(h&2)){break D}x[b+80>>2]=x[i+4>>2];c=x[i+8>>2];x[b+84>>2]=c;if(A[b+76>>2]<=c>>>0){break D}}x[b+76>>2]=c}F:{if(!(r=0,s=Ob(k,83),t=x[b+80>>2],t?r:s)){c=x[b+76>>2];break F}c=x[i>>2];x[b+84>>2]=c;x[b+76>>2]=c}d=x[b+88>>2];if(!(!(d&128)|!c)){x[b+4>>2]=c-1;x[b+88>>2]=d|128}G:{if(y[b+822|0]>3){break G}c=Ob(k,21);h=x[a+480180>>2];H:{I:{if(!(c|!(h&16777248))){d=16;if(y[a+480208|0]&4){break I}break H}d=32;if((h|0)==16){break H}}if(h&67633152){break G}d=0}v[b+819|0]=d}if(Ob(k,21)|y[b+825|0]>3){break y}v[b+820|0]=0}d=x[b>>2];if(A[b+76>>2]<=A[b+4>>2]){c=x[b+80>>2];x[b>>2]=d;x[b+4>>2]=c}d=0;if(!l){break x}d=1;if(!(x[a+480180>>2]&17301536)|(x[b+696>>2]?0:y[b+89|0]&16)){break x}c=1;if(!(y[a+480208|0]&8)){break w}c=1;if(!y[b+789|0]){break w}}if(!(x[b+696>>2]|(!(x[a+480180>>2]&17301536)|!(y[b+89|0]&16)))){Zm(b);if(!Ob(k,21)){v[b+818|0]=0;x[b+756>>2]=0}x[b+696>>2]=65536;x[b+88>>2]=x[b+88>>2]&-4097}J:{if(!d){i=y[b+789|0];break J}i=y[b+789|0];if(!(y[a+480208|0]&8)){break J}c=1;if(!(i&255)){break w}}if(!(i&255?0:x[a+480180>>2]&1048580)){x[b+696>>2]=65536;x[b+88>>2]=x[b+88>>2]&-4097}c=d}K:{if(!(!c|!Ob(k,40)|(y[b+789|0]?y[a+480208|0]&8:0))){d=x[b+88>>2]&-4194305;break K}d=x[b+88>>2]&-4196353}x[b+88>>2]=d;L:{if(c){break L}w[b+842>>1]=65535;v[b+851|0]=y[b+851|0]|2;x[b+88>>2]=d&-6324225|2097152;M:{if(Ob(k,23)){break M}if(Ob(k,22)){break M}if(Ob(k,52)){break M}if(Ob(k,71)){break M}v[b+839|0]=0;v[b+808|0]=0}if(e){v[b+818|0]=0;x[b+756>>2]=0}x[b+20>>2]=0;x[b+24>>2]=0;if(!(y[b+89|0]&2)){break L}if(!Ed(x[a+1298300>>2])|(g|0)==65535){break L}if(Ob(k,111)){zk(x[a+1298300>>2],g);break L}if(!Ob(k,110)){break L}TB(x[a+1298300>>2],g,0,1,0)}d=x[b+88>>2];N:{O:{P:{if(f){x[b+88>>2]=d&-1025;break P}if(!(d&1024)){break P}if(y[a+24618|0]&16){break O}}a=x[b+104>>2];if(!(!a|!(y[a+35|0]&4)|f)){break O}a=x[b+656>>2];if(!a|(!(y[a+15|0]&2)|f)){break N}}x[b+700>>2]=0}if(c){break a}w[b+136>>1]=0;x[b+132>>2]=4194304;x[b+112>>2]=0;x[b+116>>2]=0}fb=n+16|0}function H5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=xd(a,c);x[e>>2]=95212;f=KJ(e+8|0);x[31609]=0;b=P(71,e+152|0,b|0)|0;a=x[31609];x[31609]=0;a:{b:{c:{d:{e:{if((a|0)!=1){x[31609]=0;a=ca(104)|0;c=x[31609];x[31609]=0;if((c|0)==1){break e}a=x[a>>2];c=0;x[31609]=0;a=P(1329,f|0,a+8|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break e}while(1){f:{d=x[a>>2];if(oc(d,x[e+12>>2])>>>0<=c>>>0){x[31609]=0;c=R(852,12)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break f}break e}d=x[yb(d,c)>>2];if(d){qm(d)}c=c+1|0;continue}break}x[31609]=0;a=U(1330,c|0,b|0,0)|0;d=x[31609];x[31609]=0;g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{if((d|0)!=1){x[31609]=0;O(1331,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,12)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=U(1332,c|0,b|0,0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break t}x[31609]=0;O(1333,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,20)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=U(1334,c|0,b|0,0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break s}x[31609]=0;O(1335,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,12)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=U(1336,c|0,b|0,0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break r}x[31609]=0;O(1337,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=R(852,8)|0;c=x[31609];x[31609]=0;if((c|0)==1){break e}a=xd(a,0);x[a>>2]=97156;x[a>>2]=102768;x[31609]=0;O(1338,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,12)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=P(1339,c|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break q}x[31609]=0;O(1340,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=R(852,8)|0;c=x[31609];x[31609]=0;if((c|0)==1){break e}a=xd(a,0);x[a>>2]=97304;x[a>>2]=102976;x[31609]=0;O(1341,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=R(852,8)|0;c=x[31609];x[31609]=0;if((c|0)==1){break e}a=xd(a,0);x[a>>2]=97536;x[a>>2]=103080;x[31609]=0;O(1342,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=R(852,8)|0;c=x[31609];x[31609]=0;if((c|0)==1){break e}a=xd(a,0);x[a>>2]=97420;x[a>>2]=103184;x[31609]=0;O(1343,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=R(852,8)|0;c=x[31609];x[31609]=0;if((c|0)==1){break e}a=xd(a,0);x[a>>2]=97652;x[a>>2]=103288;x[31609]=0;O(1344,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,24)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=U(1345,c|0,b|0,0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break p}x[31609]=0;O(1346,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,28)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=U(1347,c|0,b|0,0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break o}x[31609]=0;O(1348,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,72)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=P(1349,c|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break n}x[31609]=0;O(1350,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,72)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=P(1351,c|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break m}x[31609]=0;O(1352,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,76)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=P(1353,c|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break l}x[31609]=0;O(1354,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,76)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=P(1355,c|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break k}x[31609]=0;O(1356,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,544)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=P(1357,c|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break j}x[31609]=0;O(1358,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,544)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=P(1359,c|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break i}x[31609]=0;O(1360,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,12)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=P(1361,c|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break h}x[31609]=0;O(1362,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;c=R(852,12)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=P(1363,c|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break g}x[31609]=0;O(1364,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=R(852,8)|0;c=x[31609];x[31609]=0;if((c|0)==1){break e}a=rJ(a,0);x[a>>2]=102616;x[31609]=0;O(1365,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=R(852,8)|0;c=x[31609];x[31609]=0;if((c|0)==1){break e}a=qJ(a,0);x[a>>2]=102692;x[31609]=0;O(1366,e|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}return e|0}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=T(0)|0;Db(c);break d}a=N()|0;break c}a=T(0)|0}Y(a|0)|0;c=0;while(1){a=x[f>>2];if(oc(a,x[e+12>>2])>>>0<=c>>>0){x[31609]=0;X(84);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;x[31609]=0;X(26);c=x[31609];x[31609]=0;if((c|0)==1){break b}tb(b);break c}a=x[yb(a,c)>>2];if(a){vm(a)}c=c+1|0;continue}}oy(f);Q(a|0);p()}T(0)|0;Sb()}p()}function G9(a,b,c,d,e,f){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,z=0,A=0,B=0,C=0,E=0;p=fb-560|0;fb=p;x[p+44>>2]=0;o(+b);g=j(1)|0;j(0)|0;a:{if((g|0)<0){w=1;B=5296;b=-b;o(+b);g=j(1)|0;j(0)|0;break a}if(e&2048){w=1;B=5299;break a}w=e&1;B=w?5302:5297;E=!w}b:{if((g&2146435072)==2146435072){g=w+3|0;Wf(a,32,c,g,e&-65537);Kf(a,B,w);d=f&32;Kf(a,b!=b?d?9994:13909:d?11148:14227,3);Wf(a,32,c,g,e^8192);n=(c|0)<(g|0)?g:c;break b}z=p+16|0;c:{d:{e:{b=uL(b,p+44|0);b=b+b;if(b!=0){g=x[p+44>>2];x[p+44>>2]=g-1;A=f|32;if((A|0)!=97){break e}break c}A=f|32;if((A|0)==97){break c}k=x[p+44>>2];m=(d|0)<0?6:d;break d}k=g-29|0;x[p+44>>2]=k;b=b*268435456;m=(d|0)<0?6:d}s=(p+48|0)+((k|0)>=0?288:0)|0;h=s;while(1){if(b<4294967296&b>=0){d=~~b>>>0}else{d=0}x[h>>2]=d;h=h+4|0;b=(b-+(d>>>0))*1e9;if(b!=0){continue}break}f:{if((k|0)<=0){d=k;g=h;i=s;break f}i=s;d=k;while(1){l=(d|0)>=29?29:d;g=h-4|0;g:{if(i>>>0>g>>>0){break g}q=0;while(1){d=x[g>>2];n=l&31;C=q;if((l&63)>>>0>=32){q=d<<n;d=0}else{q=(1<<n)-1&d>>>32-n;d=d<<n}n=C+d|0;q=q+r|0;q=Kua(n,d>>>0>n>>>0?q+1|0:q,1e9,0);d=Iua(q,hb,-1e9,0)+n|0;x[g>>2]=d;g=g-4|0;if(i>>>0<=g>>>0){continue}break}if(!q){break g}i=i-4|0;x[i>>2]=q}while(1){g=h;if(i>>>0<g>>>0){h=g-4|0;if(!x[h>>2]){continue}}break}d=x[p+44>>2]-l|0;x[p+44>>2]=d;h=g;if((d|0)>0){continue}break}}if((d|0)<0){u=((m+25>>>0)/9|0)+1|0;r=(A|0)==102;while(1){d=0-d|0;n=(d|0)>=9?9:d;h:{if(g>>>0<=i>>>0){h=x[i>>2];break h}q=1e9>>>n|0;l=-1<<n^-1;d=0;h=i;while(1){C=d;d=x[h>>2];x[h>>2]=C+(d>>>n|0);d=D(q,d&l);h=h+4|0;if(h>>>0<g>>>0){continue}break}h=x[i>>2];if(!d){break h}x[g>>2]=d;g=g+4|0}d=n+x[p+44>>2]|0;x[p+44>>2]=d;i=(!h<<2)+i|0;h=r?s:i;g=g-h>>2>(u|0)?h+(u<<2)|0:g;if((d|0)<0){continue}break}}d=0;i:{if(g>>>0<=i>>>0){break i}d=D(s-i>>2,9);h=10;l=x[i>>2];if(l>>>0<10){break i}while(1){d=d+1|0;h=D(h,10);if(l>>>0>=h>>>0){continue}break}}h=(m-((A|0)!=102?d:0)|0)-((A|0)==103&(m|0)!=0)|0;if((h|0)<(D(g-s>>2,9)-9|0)){q=h+9216|0;l=(q|0)/9|0;u=((p+48|0)+((k|0)<0?4:292)|0)+(l<<2)|0;k=u-4096|0;h=10;n=q+D(l,-9)|0;if((n|0)<=7){while(1){h=D(h,10);n=n+1|0;if((n|0)!=8){continue}break}}r=x[k>>2];q=(r>>>0)/(h>>>0)|0;n=D(q,h);l=u-4092|0;j:{if((n|0)==(r|0)&(l|0)==(g|0)){break j}r=r-n|0;k:{if(!(q&1)){b=9007199254740992;if(!(v[u-4100|0]&1)|((h|0)!=1e9|i>>>0>=k>>>0)){break k}}b=9007199254740994}t=(g|0)==(l|0)?1:1.5;l=h>>>1|0;t=l>>>0>r>>>0?.5:(l|0)==(r|0)?t:1.5;if(!(y[B|0]!=45|E)){t=-t;b=-b}x[k>>2]=n;if(b+t==b){break j}d=h+n|0;x[k>>2]=d;if(d>>>0>=1e9){while(1){x[k>>2]=0;k=k-4|0;if(k>>>0<i>>>0){i=i-4|0;x[i>>2]=0}d=x[k>>2]+1|0;x[k>>2]=d;if(d>>>0>999999999){continue}break}}d=D(s-i>>2,9);h=10;l=x[i>>2];if(l>>>0<10){break j}while(1){d=d+1|0;h=D(h,10);if(l>>>0>=h>>>0){continue}break}}h=k+4|0;g=g>>>0>h>>>0?h:g}while(1){l=g;q=g>>>0<=i>>>0;if(!q){g=g-4|0;if(!x[g>>2]){continue}}break}l:{if((A|0)!=103){k=e&8;break l}h=m?m:1;g=(h|0)>(d|0)&(d|0)>-5;m=(g?d^-1:-1)+h|0;f=(g?-1:-2)+f|0;k=e&8;if(k){break l}g=-9;m:{if(q){break m}k=x[l-4>>2];if(!k){break m}n=10;g=0;if((k>>>0)%10|0){break m}while(1){h=g;g=g+1|0;n=D(n,10);if(!((k>>>0)%(n>>>0)|0)){continue}break}g=h^-1}h=D(l-s>>2,9);if((f&-33)==70){k=0;g=(g+h|0)-9|0;g=(g|0)>0?g:0;m=(g|0)>(m|0)?m:g;break l}k=0;g=((d+h|0)+g|0)-9|0;g=(g|0)>0?g:0;m=(g|0)>(m|0)?m:g}n=-1;q=k|m;if(((q?2147483645:2147483646)|0)<(m|0)){break b}r=(((q|0)!=0)+m|0)+1|0;h=f&-33;n:{if((h|0)==70){if((r^2147483647)<(d|0)){break b}g=(d|0)>0?d:0;break n}g=d>>31;g=ko((g^d)-g|0,0,z);if((z-g|0)<=1){while(1){g=g-1|0;v[g|0]=48;if((z-g|0)<2){continue}break}}u=g-2|0;v[u|0]=f;v[g-1|0]=(d|0)<0?45:43;g=z-u|0;if((g|0)>(r^2147483647)){break b}}d=g+r|0;if((d|0)>(w^2147483647)){break b}r=d+w|0;Wf(a,32,c,r,e);Kf(a,B,w);Wf(a,48,c,r,e^65536);o:{p:{q:{if((h|0)==70){f=p+16|0;d=f|8;k=f|9;h=i>>>0>s>>>0?s:i;i=h;while(1){g=ko(x[i>>2],0,k);r:{if((h|0)!=(i|0)){if(p+16>>>0>=g>>>0){break r}while(1){g=g-1|0;v[g|0]=48;if(p+16>>>0<g>>>0){continue}break}break r}if((g|0)!=(k|0)){break r}v[p+24|0]=48;g=d}Kf(a,g,k-g|0);i=i+4|0;if(s>>>0>=i>>>0){continue}break}if(q){Kf(a,16806,1)}if((m|0)<=0|i>>>0>=l>>>0){break q}while(1){g=ko(x[i>>2],0,k);if(g>>>0>p+16>>>0){while(1){g=g-1|0;v[g|0]=48;if(p+16>>>0<g>>>0){continue}break}}Kf(a,g,(m|0)>=9?9:m);g=m-9|0;i=i+4|0;if(l>>>0<=i>>>0){break p}d=(m|0)>9;m=g;if(d){continue}break}break p}s:{if((m|0)<0){break s}s=i>>>0<l>>>0?l:i+4|0;f=p+16|0;d=f|8;l=f|9;h=i;while(1){g=ko(x[h>>2],0,l);if((l|0)==(g|0)){v[p+24|0]=48;g=d}t:{if((h|0)!=(i|0)){if(p+16>>>0>=g>>>0){break t}while(1){g=g-1|0;v[g|0]=48;if(p+16>>>0<g>>>0){continue}break}break t}Kf(a,g,1);g=g+1|0;if(!(k|m)){break t}Kf(a,16806,1)}f=l-g|0;Kf(a,g,(f|0)<(m|0)?f:m);m=m-f|0;h=h+4|0;if(s>>>0<=h>>>0){break s}if((m|0)>=0){continue}break}}Wf(a,48,m+18|0,18,0);Kf(a,u,z-u|0);break o}g=m}Wf(a,48,g+9|0,9,0)}Wf(a,32,c,r,e^8192);n=(c|0)<(r|0)?r:c;break b}k=(f<<26>>31&9)+B|0;u:{if(d>>>0>11){break u}g=12-d|0;t=16;while(1){t=t*16;g=g-1|0;if(g){continue}break}if(y[k|0]==45){b=-(t+(-b-t));break u}b=b+t-t}s=w|2;i=f&32;h=x[p+44>>2];g=h>>31;g=ko((g^h)-g|0,0,z);if((z|0)==(g|0)){v[p+15|0]=48;g=p+15|0}m=g-2|0;v[m|0]=f+15;v[g-1|0]=(h|0)<0?45:43;g=e&8;h=p+16|0;while(1){f=h;if(F(b)<2147483648){l=~~b}else{l=-2147483648}v[h|0]=i|y[l+93232|0];b=(b-+(l|0))*16;h=f+1|0;if(!(!(g|(d|0)>0)&b==0|(h-(p+16|0)|0)!=1)){v[f+1|0]=46;h=f+2|0}if(b!=0){continue}break}n=-1;g=z-m|0;f=g+s|0;if((2147483645-f|0)<(d|0)){break b}l=f;f=p+16|0;i=h-f|0;d=d?(i-2|0)<(d|0)?d+2|0:i:i;h=l+d|0;Wf(a,32,c,h,e);Kf(a,k,s);Wf(a,48,c,h,e^65536);Kf(a,f,i);Wf(a,48,d-i|0,0,0);Kf(a,m,g);Wf(a,32,c,h,e^8192);n=(c|0)<(h|0)?h:c}fb=p+560|0;return n|0}function Psa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=fb-128|0;fb=j;v[j+127|0]=d;a:{if(!c|(e|0)<0&c>>>0>=176){break a}v[b+5|0]=d;v[j+8|0]=15;l=j+127|0;p=j+8|0;k=p;o=y[Qb(l,k)|0];v[j+8|0]=14;l=y[Qb(l,k)|0];x[j+8>>2]=d+31>>>5;x[j+120>>2]=14;r=j+120|0;n=x[Cd(k,r)>>2];x[j+8>>2]=d+127>>>7;x[j+120>>2]=14;q=c&15;k=q<<8|d;p=Cd(p,r);b:{switch((c>>>4|0)-2|0){case 0:v[b+2|0]=1;x[j+8>>2]=k>>>2;x[j+120>>2]=64;s=b,t=x[Cd(j+8|0,j+120|0)>>2],v[s+4|0]=t;break a;case 1:v[b+2|0]=1;if(!k){v[b+4|0]=0;break a}s=j,t=MD(k)>>>2|0,x[s+8>>2]=t;x[j+120>>2]=64;s=b,t=x[Cd(j+8|0,j+120|0)>>2],v[s+4|0]=t;break a;case 2:v[b+3|0]=9;v[b+5|0]=k>>>4;break a;case 3:v[b+3|0]=23;v[b+5|0]=k+1>>>5;break a;case 4:v[b+3|0]=23;if(k){a=Eh(MD(k)>>>5|0)}else{a=0}v[b+5|0]=a;break a;case 5:v[b+5|0]=q;v[b+3|0]=15;break a;case 6:v[b+3|0]=15;if((e|0)>=0){if(y[b+2|0]){break a}v[b+2|0]=2;s=b,t=Gc(((q<<6|7)>>>0)/15|0,0),v[s+4|0]=t;break a}v[b+2|0]=1;v[b+5|0]=q;v[b+4|0]=d+3>>>2;break a;case 7:v[b+3|0]=10;c:{if((e|0)>5){break c}if(!k){v[b+5|0]=1;break a}c=qr(a,f,g);if(!c){break c}a=oi(a,c);c=z[a+34>>1];if(c&1){k=k>>>1|0;x[j+120>>2]=k}if(!(c&2)){break c}c=x[a>>2];if(c>>>0>=k<<8>>>0){break c}x[j+120>>2]=x[a+4>>2]+8>>>8;xc(j+120|0,c-1>>>8|0);k=x[j+120>>2]}v[b+5|0]=k;if(y[b+2|0]|k>>>0<256){break a}v[b+2|0]=15;x[j+116>>2]=k>>>8;_v(j+8|0);x[j+112>>2]=9;s=b,t=x[Hb(j+116|0,j+112|0)>>2],v[s+4|0]=t;break a;default:break b}}k=x[p>>2];d:{switch(c-160|0){default:e:{switch(c-1|0){case 0:case 1:case 2:case 3:case 6:case 10:case 14:Cf(b,c,d);f:{switch(y[b+3|0]-16|0){case 1:x[h>>2]=D(y[b+5|0],1e4);break a;case 0:break f;default:break a}}a=y[b+5|0];if(!a){break a}x[i>>2]=a;break a;case 4:v[b+3|0]=4;if(y[b+2|0]){break a}v[b+4|0]=0;v[b+2|0]=8;break a;case 5:v[b+3|0]=5;if(y[b+2|0]){break a}v[b+4|0]=0;v[b+2|0]=11;break a;case 7:if(!Tc(y[b|0])|!d){break a}v[b+3|0]=35;v[b+5|0]=(d>>>1&120|128)-(d<<3&120);if(z[a+480192>>1]){break a}w[j+8>>1]=255;c=z[Oc(a+480190|0,j+8|0)>>1];w[a+480192>>1]=c;b=1;while(1){d=b&65535;if(d>>>0>(c&65535)>>>0){break a}c=DE(a,d,d);if(c){v[c+33|0]=2;d=(d<<5)+a|0;e=d+946304|0;f=x[e+4>>2];x[c+492>>2]=x[e>>2];x[c+496>>2]=f;e=d+946312|0;f=x[e+4>>2];x[c+500>>2]=x[e>>2];x[c+504>>2]=f;e=d+946320|0;f=x[e+4>>2];x[c+508>>2]=x[e>>2];x[c+512>>2]=f;d=d+946328|0;e=x[d+4>>2];x[c+516>>2]=x[d>>2];x[c+520>>2]=e;dk(c,127,1);ck(c,0,1)}b=b+1|0;c=z[a+480192>>1];continue};case 8:v[b+3|0]=19;v[b+5|0]=o|208;break a;case 9:v[b+3|0]=25;break a;case 11:if(d>>>0>2){break a}v[b+3|0]=19;v[b+5|0]=d|64;break a;case 12:v[b+3|0]=14;break a;case 13:if(d>>>0>2){break a}v[b+3|0]=19;v[b+5|0]=d|112;break a;case 15:v[b+3|0]=1;break a;case 16:case 17:v[b+3|0]=19;v[b+5|0]=l|c<<4;break a;case 18:v[b+3|0]=15;break a;case 19:v[b+3|0]=11;v[b+5|0]=l<<4;break a;case 20:v[b+5|0]=l;v[b+3|0]=11;break a;case 23:v[b+3|0]=6;v[b+5|0]=l<<4;break a;case 24:v[b+5|0]=l;v[b+3|0]=6;break a;case 27:v[b+3|0]=7;v[b+5|0]=l<<4;break a;case 28:break e;default:break a}}v[b+5|0]=l;v[b+3|0]=7;break a;case 0:if(!d){break a}v[b+3|0]=24;v[b+5|0]=n<<4;break a;case 1:if(!d){break a}v[b+5|0]=n;v[b+3|0]=24;break a;case 4:v[b+3|0]=11;v[b+5|0]=l<<4|15;break a;case 5:v[b+3|0]=11;v[b+5|0]=l|240;break a;case 6:if(!d){break a}v[b+3|0]=24;v[b+5|0]=n<<4|15;break a;case 7:if(!d){break a}v[b+3|0]=24;v[b+5|0]=n|240;break a;case 8:if(!d){break a}v[b+3|0]=16;x[i>>2]=d;break a;case 9:if((e|0)>5){break a}a=x[h>>2];if(a>>>0<1e4){break a}v[b+3|0]=17;m=122925/(+(a>>>0)/1e4)+ +((d<<1)-256|0);s=b,t=_l(245850/(m+m)),v[s+5|0]=t;break a;case 10:v[b+3|0]=19;v[b+5|0]=o|224;break a;case 12:v[b+3|0]=28;v[b+5|0]=o|16;break a;case 13:v[b+3|0]=28;v[b+5|0]=o|32;break a;case 14:v[b+3|0]=29;v[b+5|0]=l<<3&240;break a;case 15:v[b+3|0]=29;v[b+5|0]=(l&254)>>>1;break a;case 16:v[b+3|0]=18;break a;case 17:v[b+3|0]=19;v[b+5|0]=o|176;break a;case 18:case 19:v[b+3|0]=20;v[b+5|0]=d?120:119;break a;case 20:v[b+3|0]=20;v[b+5|0]=d?125:123;break a;case 21:v[b+3|0]=20;v[b+5|0]=d?122:121;break a;case 22:v[b+3|0]=20;v[b+5|0]=d?126:123;break a;case 26:v[b+3|0]=10;v[b+5|0]=d+15>>>4;break a;case 27:v[b+5|0]=1;v[b+3|0]=10;break a;case 30:case 31:if(!d|(!g|!f)){break a}o=x[h>>2];if(o>>>0<1e4){break a}l=x[i>>2];if(!l){break a}i=qr(a,f,g);if(!i){break a}k=oi(a,i);n=z[k+34>>1];g:{if(!(n&2)){i=x[k>>2];break g}i=x[k+8>>2]-((e|0)<6?x[k+4>>2]:0)|0;if(!(n&4)){break g}i=i<<((e|0)>5)}if(!i|(e|0)<6&i>>>0<1024){break a}n=x[k+24>>2];if(!n){break a}h:{if(z[a+480192>>1]<g>>>0){break h}a=x[((g<<2)+a|0)+900380>>2];if(!a){break h}m=+(y[xb(a+108|0,f-1|0)|0]-f|0)}a=(c|0)==190;m=zi(m/12+(a?(e|0)<6?+v[k+37|0]/-1536:-0:-0))*+(n>>>0);if(a){v[b+3|0]=17;a=_l(m*.5*(+(D(d,l)>>>0)*2.5)/+(i>>>0));v[b+5|0]=a;x[h>>2]=D(a,1e4);break a}m=Zv(RL(+(i>>>0)/m/(+(D(d,l)>>>0)*2.5/(+(o>>>0)/1e4)))*12+61,1,120);i:{if(m<4294967296&m>=0){a=~~m>>>0;break i}a=0}c=Tc(y[b|0]);v[b|0]=a;m=(m-J(m))*64+128;j:{if(m<4294967296&m>=0){a=~~m>>>0;break j}a=0}v[b+5|0]=a;if((a|0)!=128){v[b+3|0]=35}if(c){break a}if(!y[b+2|0]){v[b+4|0]=9;v[b+2|0]=11;break a}v[b+5|0]=255;v[b+3|0]=4;break a;case 32:a=d>>>4|0;if(a-1>>>0>1){break a}v[b+3|0]=20;v[b+5|0]=a-99;break a;case 34:v[b+3|0]=21;v[b+5|0]=d<<2;break a;case 35:v[b+3|0]=21;s=b,t=Eh(MD(d<<4)>>>6|0),v[s+5|0]=t;break a;case 36:case 38:v[b+3|0]=22;v[b+5|0]=k<<4;break a;case 37:case 39:v[b+5|0]=k;v[b+3|0]=22;break a;case 40:v[b+3|0]=22;v[b+5|0]=l<<4|15;break a;case 2:case 3:case 11:case 23:case 24:case 25:case 28:case 29:case 33:break a;case 41:break d}}v[b+3|0]=22;v[b+5|0]=l|240}fb=j+128|0}function Ko(a,b,c,d,e,f){var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,B=0,C=0,E=0;h=z[a+480192>>1]>=c>>>0?x[((c<<2)+a|0)+900380>>2]:h;r=x[b+752>>2];a:{j=y[b+802|0];b:{if(!j){if(Ob(a+1074312|0,11)){break b}}c:{d:{if(!h){break d}if(!Tc(j)){break d}e:{j=j-1|0;g=bc(h+236|0,j);if(z[g>>1]){break e}if(!Ob(a+1074312|0,43)){break e}if(Kj(y[h+31|0])){break e}x[b+656>>2]=h;return}if(y[xb(h+108|0,j)|0]>120){break b}j=z[g>>1];k=(j-1&65535)>>>0<3999?(D(j,104)+a|0)+484380|0:0;break c}if(!z[a+480192>>1]){k=(D(c,104)+a|0)+484380|0;break c}if(j>>>0>250){break b}if(!Ob(a+1074312|0,43)){break c}if(h){if(Kj(y[h+31|0])){break c}}v[b+803|0]=0;x[b+656>>2]=0;return}j=x[b+104>>2];m=(j|0)!=0&(j|0)!=(k|0);i=x[b+656>>2];p=!h|x[a+480180>>2]!=16777216?p:x[h+44>>2]!=0;n=d^1;g=(h|0)!=(i|0);if((n|g|m)==1){w[b+774>>1]=0}l=!m;if(!(l|(!(d&p)|g))){break b}f:{if(l|n){break f}q=a+1074312|0;if(!(!Ob(q,32)|!(y[a+480208|0]&8))){k=x[b+8>>2]|x[b+12>>2]?x[b+104>>2]:k}j=x[a+480180>>2];g:{h:{i:{j:{if(!g){if((h|0)!=0&(j&1048580)!=0|(j|0)==268435456){break h}if((j|0)!=1){break i}break j}if((j|0)==1){break j}if((j|0)==268435456){break h}break i}if(Oi(x[b+8>>2],x[b+12>>2])){break h}}if(!Ob(q,79)){break g}if(!Oi(x[b+8>>2],x[b+12>>2])){break g}}o=1}if(!Ob(q,119)|z[a+480192>>1]){break f}v[b+851|0]=y[b+851|0]|2}k:{if(!x[b+16>>2]|(l|(!z[a+480192>>1]|g))){break k}if(!Ob(a+1074312|0,87)){break k}o=Tc(y[b+788|0])^1|o}l=(h|0)!=(i|0);l:{if(Oi(x[b+8>>2],x[b+12>>2])|!(x[a+480180>>2]&16777248)){break l}if(h){if(Kj(y[h+31|0])){break l}}l=1}m:{n:{if(!(m|l)|!d){break n}if(!Ob(a+1074312|0,61)){break n}i=x[b+656>>2];g=x[b+104>>2];j=0;if(i|g){break m}}x[b+656>>2]=h;g=k;i=h;j=l}o:{p:{q:{if(!e){break q}r:{if(y[a+480180|0]&3){if(g){if(le(x[g>>2],x[g+20>>2])){break r}}if(!Cj(i)){break q}}if(!g){break p}}if(w[g+34>>1]<0){break q}x[b+688>>2]=z[g+30>>1]}h=(g|0)!=0;if(!(m&o)|!g){break o}if(Ob(a+1074312|0,85)){w[b+772>>1]=v[g+37|0]}h=1;if(x[a+480180>>2]!=2){break o}if(!le(x[g>>2],x[g+20>>2])){break o}x[b+704>>2]=x[g+24>>2];break o}if(!(!i|!y[i+34|0])){h=x[b+688>>2];if(i){h=x[i+4>>2]<<2}x[b+688>>2]=h;h=0;break o}h=0;x[b+688>>2]=0}if(o){break b}v[b+803|0]=0;s:{if(!i){break s}if(s=(B=Ob(a+1074312|0,29),C=1,E=g,E?B:C),t=0,u=!y[i+34|0]&(j^-1),u?s:t){break s}v[b+798|0]=y[i+16|0]}k=64;x[b+752>>2]=64;if(g){k=z[g+32>>1];x[b+752>>2]=k}if(i){x[b+752>>2]=D(x[i+4>>2],k)>>>6}t:{if(!(x[a+480180>>2]&1048580?e:1)){break t}if(Ob(a+1074312|0,48)){break t}iT(a,b,i,g)}u:{v:{w:{if(!f){break w}x:{y:{z:{A:{B:{C:{D:{E:{f=a+1074312|0;if(Ob(f,19)){if(!x[b+76>>2]){e=1;break D}if(!(!c|n)){e=(y[a+480208|0]&8)>>>3|0;if(e){break D}break E}e=0;if(c){break E}break D}F:{c=x[a+480180>>2]&17301536;e=1;G:{if(!d|!c){break G}c=1;e=1;if(y[a+480208|0]&8){break G}e=1;if(!x[b+76>>2]){break G}if(!(y[b+89|0]&16)){break F}e=!x[b+696>>2]}if(j|(!i|!c)){break B}if(!e){break x}c=x[b+88>>2];x[b+88>>2]=c|2097152;if(c&6144){break A}break C}if((j|!i)!=1){break x}break y}if(d){break D}if(!(y[b+89|0]&24)){e=0;break D}e=(y[a+480208|0]&4)>>>2|0}if(j|!x[b+696>>2]){break B}if(!e){break y}c=x[b+88>>2];x[b+88>>2]=c|2097152;if(!i){break z}if(c&2048){break A}}if(!(y[i+60|0]&8)){Bj(b+724|0)}if(!(y[i+80|0]&8)){Bj(b+732|0)}if(y[i+100|0]&8){break z}Bj(b+740|0);break z}if(!e){break y}x[b+88>>2]=x[b+88>>2]|2097152;if(!i){break z}}Zm(b)}if(Ob(f,21)){break w}v[b+818|0]=0;x[b+756>>2]=0;break w}if(!i){break v}}if(v[i+60|0]&1){break w}if(Ob(f,32)){Bj(b+724|0);break w}Zm(b)}c=0;if(g){break u}if(!i){break a}c=1;if(Kj(y[i+31|0])){break u}break a}c=0;if(!g){break a}}H:{if(!(!d|(h^1|x[b+104>>2]!=(g|0)))){e=x[a+480180>>2];if(x[b+76>>2]?e&16777250:0){break b}I:{J:{if((e|0)!=4){break J}if(!Ob(a+1074312|0,40)|y[b+789|0]){break J}e=x[b+88>>2];break I}e=x[b+88>>2]&-6145}x[b+88>>2]=e&-640;break H}x[b+88>>2]=x[b+88>>2]&-6145;e=a+1074312|0;K:{L:{if(!Ob(e,18)){h=-640;if(j|(x[a+480180>>2]&16777248|x[b+104>>2]!=(g|0))){break L}break K}h=-640;if((j^-1)&x[b+104>>2]==(g|0)){break K}}h=-768}x[b+88>>2]=x[b+88>>2]&h;if(!i){break H}v[b+730|0]=y[i+60|0];v[b+738|0]=y[i+80|0];f=y[i+100|0];v[b+746|0]=f;M:{if((f&17)!=17){break M}if(Ob(e,36)|y[b+837|0]){break M}v[b+837|0]=127}e=y[i+21|0];if(vd(e)){s=b,t=Hh(e),v[s+837|0]=t}e=y[i+22|0];if(!vd(e)){break H}s=b,t=Hh(e),v[s+838|0]=t}if(c){x[b+76>>2]=0;x[b+104>>2]=0;return}N:{if(x[b+76>>2]|!d){break N}c=a+1074312|0;if(!Ob(c,54)){if(!Ob(c,39)){break N}}x[b+8>>2]=0;x[b+12>>2]=0}O:{if(y[b+788|0]!=255){break O}if(!Ob(a+1074312|0,100)|!(y[a+480208|0]>>>2&m)){break O}c=x[b+104>>2];if(c){x[b+88>>2]=x[b+88>>2]|z[c+34>>1]&1023}x[b+752>>2]=r;x[b+688>>2]=z[g+30>>1];if(!(y[g+34|0]&32)){break b}Rq(b,z[g+28>>1],a);return}x[b+104>>2]=g;x[b+76>>2]=x[g>>2];x[b+80>>2]=x[g+4>>2];x[b+84>>2]=x[g+8>>2];c=a+1074312|0;if(!(!Ob(c,83)|x[b+80>>2])){x[b+84>>2]=x[g>>2]}x[b+88>>2]=x[b+88>>2]|z[g+34>>1]&1023;if(Ob(c,21)){v[b+818|0]=0;x[b+756>>2]=0}P:{Q:{if(p){x[b+704>>2]=x[g+24>>2];v[b+851|0]=y[b+851|0]|64;d=0;break Q}if(!(m|n)){d=x[a+480180>>2];if(d&5){break P}}x[b+704>>2]=x[g+24>>2];d=v[g+37|0]}w[b+772>>1]=d;d=x[a+480180>>2]}if(yn(d)){d=v[g+36|0]}else{d=0}w[b+770>>1]=d;if(!(Ob(c,69)|x[a+480180>>2]==1)){x[b+708>>2]=0}x[b+852>>2]=0;h=x[b+88>>2];if(h&8){x[b+80>>2]=x[g+12>>2];x[b+84>>2]=x[g+16>>2];h=h>>>2&4|h|2;x[b+88>>2]=h}c=x[b+76>>2];R:{if(!(h&2)){break R}d=x[b+84>>2];if(d>>>0>=c>>>0){break R}x[b+76>>2]=d;c=d}if(!(x[a+480180>>2]&16777248)|A[b+4>>2]<c>>>0){break b}x[b>>2]=0;x[b+4>>2]=0}return}x[b+752>>2]=0;x[b+104>>2]=0}
function Koa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;d=fb-224|0;fb=d;yc(b);f=d+160|0;a:{if(!xr(b,f)){break a}if(!HW(f)){break a}if(!Mb(x[b>>2],x[b+8>>2],Bc(GW(f),hb))){break a}e=1;if((c|0)==64){break a}Dd(a,256);i=d+148|0;qi(i,2,f);e=d+56|0;Cc(e,i);zb(a+1298308|0,e);tb(e);f=y[d+210|0]|y[d+211|0]<<8;x[a+480260>>2]=64;x[a+480264>>2]=32767;w[a+480188>>1]=4;w[a+480190>>1]=f;Lb(a+1074312|0,107,1);f=y[d+203|0];f=f?f:96;i=AC(f);x[a+480196>>2]=f>>>4;x[a+480204>>2]=i;v[d+56|0]=64;q=a,r=y[Qb(d+202|0,e)|0]<<2,x[q+480200>>2]=r;e=0;b:{c:{d:{e:{f:{g:{while(1){if((e|0)==4){h:{i=Nb(d+148|0);m=Nb(d+136|0);x[31609]=0;P(149,b|0,(y[d+192|0]|y[d+193|0]<<8)<<4)|0;e=x[31609];x[31609]=0;i:{if((e|0)==1){break i}x[31609]=0;U(213,b|0,i|0,y[d+208|0]|y[d+209|0]<<8)|0;e=x[31609];x[31609]=0;if((e|0)==1){break i}x[31609]=0;P(149,b|0,(y[d+194|0]|y[d+195|0]<<8)<<4)|0;e=x[31609];x[31609]=0;if((e|0)==1){break i}x[31609]=0;U(213,b|0,m|0,y[d+210|0]|y[d+211|0]<<8)|0;e=x[31609];x[31609]=0;if((e|0)==1){break i}x[31609]=0;P(149,b|0,((y[d+196|0]|y[d+197|0]<<8)<<4)+32|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break i}e=y[a+484376|0];f=x[a+484360>>2];x[31609]=0;O(330,Xb(f,e)|0,y[d+212|0]|y[d+213|0]<<8);e=x[31609];x[31609]=0;if((e|0)==1){break i}e=Xb(x[a+484360>>2],y[a+484376|0]);q=d,r=wb(x[e>>2]),x[q+56>>2]=r;e=wb(x[e+4>>2]);j:{while(1){f=x[d+56>>2];if(!Ib(f,e)){e=0;if(!JW(Xb(x[a+484360>>2],y[a+484376|0]))){break b}k=c&2;n=d+57|0;e=1;break j}x[31609]=0;g=R(197,b|0)|0;h=x[31609];x[31609]=0;k:{if((h|0)==1){break k}w[f>>1]=g;x[31609]=0;P(183,b|0,4)|0;f=x[31609];x[31609]=0;if((f|0)==1){break k}ge(d+56|0);continue}break}b=N()|0;break c}l:{m:{n:{o:{while(1){g=e&65535;if(g>>>0>(y[d+210|0]|y[d+211|0]<<8)>>>0){break l}f=bc(x[m>>2],g-1|0);f=y[f|0]|y[f+1|0]<<8;x[31609]=0;f=P(149,b|0,f<<4)|0;h=x[31609];x[31609]=0;p:{if((h|0)!=1){if(f){break p}e=0;break b}b=N()|0;break c}x[31609]=0;h=d+56|0;P(698,b|0,h|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break o}x[31609]=0;l=(D(g,104)+a|0)+484380|0;S(699,h|0,l|0,0);f=x[31609];x[31609]=0;if((f|0)==1){break o}j=d+28|0;Mk(j,2,n);x[31609]=0;f=d+40|0;O(218,f|0,j|0);j=x[31609];x[31609]=0;if((j|0)==1){break n}Ac(((g<<5)+a|0)+946304|0,f);tb(f);q:{r:{if(!k|!(y[d+72|0]|y[d+73|0]<<8|(y[d+74|0]<<16|y[d+75|0]<<24))){break r}g=WW(h);x[31609]=0;g=P(149,b|0,g|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break m}if(!g){break r}VW(f,y[d+86|0],y[d+87|0],1);x[31609]=0;U(215,f|0,l|0,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break q}}e=e+1|0;continue}break}b=N()|0;break c}b=N()|0;break c}b=N()|0;break c}b=N()|0;break c}v[d+27|0]=1;n=0;e=x[i>>2];s:{if(mc(e,x[i+4>>2])|(y[d+188|0]|y[d+189|0]<<8)==26){break s}f=y[e|0]|y[e+1|0]<<8;e=0;x[31609]=0;f=P(149,b|0,f<<4)|0;g=x[31609];x[31609]=0;if((g|0)==1){break h}if(!f){break b}x[31609]=0;e=R(189,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break h}if((y[d+188|0]|y[d+189|0]<<8)!=(e|0)){break s}v[d+27|0]=0;n=1}l=c&1;if(l){x[31609]=0;O(223,a+484344|0,y[d+208|0]|y[d+209|0]<<8);c=x[31609];x[31609]=0;if((c|0)==1){break h}}h=a+484344|0;f=0;while(1){t:{if(!l|(y[d+208|0]|y[d+209|0]<<8)>>>0<=f>>>0){break t}x[31609]=0;c=U(196,h|0,f&65535,64)|0;e=x[31609];x[31609]=0;if((e|0)==1){break g}if(!c){break t}c=bc(x[i>>2],f);c=y[c|0]|y[c+1|0]<<8;x[31609]=0;c=P(149,b|0,c<<4)|0;e=x[31609];x[31609]=0;if((e|0)==1){break g}e=0;if(!c){break b}if(n){x[31609]=0;c=R(189,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break g}if(c>>>0>2112){break b}}w[d+12>>1]=65535;x[d+28>>2]=63;c=Wb(x[h>>2],f);af(d+40|0,x[c>>2],x[x[c+48>>2]+12>>2],0);u:while(1){c=e;while(1){if(c>>>0<=63){x[31609]=0;e=R(197,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break f}k=e<<24>>24;if(!k){e=64;if(c>>>0>62){continue u}e=Wb(x[h>>2],f);g=x[e>>2];j=x[x[e+48>>2]+12>>2];e=c+1|0;af(d+56|0,g,j,e);c=x[d+60>>2];x[d+40>>2]=x[d+56>>2];x[d+44>>2]=c;continue u}e=Ng(d+56|0);g=k&31;if(g>>>0<z[a+480188>>1]){e=Yc(x[d+40>>2],g)}j=k&255;if(j&32){x[31609]=0;g=d+25|0;O(198,g|0,b|0);o=x[31609];x[31609]=0;v:{w:{x:{if((o|0)!=1){o=Jc(g);g=y[d+25|0];if(g>>>0>239){break x}g=TW((D(g>>>4|0,12)+(g&15)|0)+37|0);break w}b=N()|0;break c}y:{switch(g-254|0){case 0:break w;case 1:break y;default:break v}}g=0}v[e|0]=g}v[e+1|0]=y[o|0]}if(j&64){x[31609]=0;g=R(197,b|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break e}v[d+25|0]=g;v[e+2|0]=1;v[d+24|0]=64;q=e,r=y[Qb(d+25|0,d+24|0)|0],v[q+4|0]=r}if((k|0)>=0){continue}x[31609]=0;g=d+25|0;O(198,g|0,b|0);k=x[31609];x[31609]=0;if((k|0)==1){break d}q=e,r=y[Jc(g)|0],v[q+5|0]=r;IW(e,y[d+25|0],c,255,d+12|0,d+28|0);continue}break}break}c=z[d+12>>1];if((c|0)!=65535){Ae(Wb(x[h>>2],f),Bn(Ve(Oe(d+56|0,12,c&255),x[d+28>>2])))}f=f+1|0;continue}break}x[31609]=0;b=P(1,d+56|0,6088)|0;c=x[31609];x[31609]=0;z:{A:{B:{if((c|0)!=1){zb(a+1298344|0,b);tb(b);x[31609]=0;b=P(1,d+40|0,5274)|0;c=x[31609];x[31609]=0;if((c|0)==1){break B}zb(a+1298356|0,b);tb(b);b=d+28|0;q=a+1298404|0,r=x[Fc(b,4)>>2],x[q>>2]=r;x[31609]=0;c=d+12|0;O(701,c|0,4405);e=x[31609];x[31609]=0;if((e|0)==1){break A}x[31609]=0;S(209,b|0,c|0,d+27|0);e=x[31609];x[31609]=0;if((e|0)==1){break z}zb(a+1298368|0,b);tb(b);Eb(c);e=1;break b}b=N()|0;break c}b=N()|0;break c}b=N()|0;break c}b=N()|0;Eb(d+12|0);break c}b=N()|0;break c}}else{f=(e<<5)+a|0;Ue(f+480280|0);w[f+480284>>1]=e&1?64:192;e=e+1|0;continue}break}b=N()|0;break c}b=N()|0;break c}b=N()|0;break c}b=N()|0;break c}b=N()|0}od(m);od(i);Q(b|0);p()}od(m);od(i)}fb=d+224|0;return e|0}function psa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,B=0,C=0;e=fb-1344|0;fb=e;yc(b);f=fb-16|0;fb=f;d=e+768|0;UZ(f+8|0,d);g=x[f+12>>2];lc(f,x[b>>2],x[b+8>>2],x[f+8>>2],x[f+12>>2]);i=x[f+4>>2];if((i|0)==(g|0)){Vb(b,x[f+12>>2])}fb=f+16|0;f=(g|0)==(i|0);if(!f){TZ(d)}a:{b:{c:{if(!f){break c}if(!WZ(d)){break c}if(!Mb(x[b>>2],x[b+8>>2],Bc(VZ(y[e+802|0]|y[e+803|0]<<8,y[e+804|0]|y[e+805|0]<<8),hb))){break c}s=1;if((c|0)==64){break c}o=tc(e+764|0);f=0;while(1){s=(j|0)==32;if(!s){d=(j<<5)+a|0;g=d+480280|0;Ue(g);i=(e+768|0)+(j<<4)|0;w[d+480284>>1]=((y[i+78|0]<<8&65280)>>>0)/255;l=e+496|0;Mk(l,1,i- -64|0);h=e+108|0;Cc(h,l);im(d+480289|0,h);tb(h);d:{e:{switch(y[i+79|0]){case 0:k=f+1|0;break d;case 1:x[g>>2]=1024;k=j+1|0;break d;case 2:break e;default:break c}}x[g>>2]=1024;d=e+108|0;Qc(d,o,j);ap(d)}f=f+1|0;j=j+1|0;continue}break}Dd(a,33554432);w[a+480188>>1]=k&255;f=e+108|0;d=uc(f,6808);zb(a+1298344|0,d);tb(d);d=uc(f,11156);zb(a+1298356|0,d);tb(d);B=a+1298404|0,C=x[Fc(f,4)>>2],x[B>>2]=C;f:{if(y[e+847|0]){break f}j=1;f=1;while(1){if((j|0)==16){while(1){if((f|0)==16){break f}d=((f<<5)+a|0)+480280|0;x[d>>2]=x[d>>2]&-1025;f=f+1|0;continue}}d=j<<4;j=j+1|0;if(y[(e+d|0)+847|0]==1){continue}break}}f=e+496|0;Te(f,1,e+768|0);d=e+108|0;Cc(d,f);zb(a+1298308|0,d);tb(d);x[a+480208>>2]=x[a+480208>>2]&-17|(y[e+806|0]|y[e+807|0]<<8)<<4&16;x[a+480196>>2]=y[e+816|0];x[a+480204>>2]=D(y[e+817|0],1e4);x[a+480200>>2]=y[e+818|0]<<2;x[a+480228>>2]=y[e+819|0];d=y[e+804|0]|y[e+805|0]<<8;w[a+480190>>1]=0;w[a+480192>>1]=d;Hw(b,f);Pr(Xb(x[a+484360>>2],y[a+484376|0]),f,y[e+800|0]|y[e+801|0]<<8,65535,255);t=c&1;if(t){Tf(a+484344|0,y[e+802|0]|y[e+803|0]<<8)}m=a+484344|0;j=0;g:{while(1){if((y[e+802|0]|y[e+803|0]<<8)>>>0<=j>>>0){l=c&2;f=1;c=0;h:while(1){if(z[a+480192>>1]<=(c&65535)>>>0){break c}c=c+1|0;g=DE(a,c&65535,0);i=!g;d=fb-16|0;fb=d;j=e+108|0;cc(d+8|0,j,384);k=x[d+12>>2];lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2]);h=x[d+4>>2];if((h|0)==(k|0)){Vb(b,x[d+12>>2])}fb=d+16|0;d=(h|0)==(k|0);if(!d){Rb(j,0,384)}if(!d|i){continue}i=f&65535;k=fb-32|0;fb=k;h=k+8|0;Te(h,1,j);d=k+20|0;Cc(d,h);Ac(g+492|0,d);tb(d);i:{if(!(y[j+378|0]|y[j+379|0]<<8)){break i}h=g+236|0;d=0;while(1){x[k+20>>2]=120;x[k+8>>2]=116;if(A[Hb(k+20|0,k+8|0)>>2]<=d>>>0){break i}B=bc(h,d+12|0),C=i+y[(d+j|0)+32|0]|0,w[B>>1]=C;d=d+1|0;continue}}d=y[j+376|0]|y[j+377|0]<<8;v[g+33|0]=1;x[g>>2]=d;FD(j,g+48|0,0);FD(j,g+68|0,1);FD(j,g+88|0,2);d=y[g+100|0];if(d&1){v[g+100|0]=d|16}if(!(x[g>>2]|v[g+60|0]&1)){x[g>>2]=32767}fb=k+32|0;j=0;while(1){d=y[e+486|0]|y[e+487|0]<<8;if(d>>>0<=j>>>0){f=d+f|0;continue h}p$(b,e+44|0);j:{d=f+j|0;i=d&65535;k:{if(i>>>0>=4e3){Vb(b,y[e+60|0]|y[e+61|0]<<8|(y[e+62|0]<<16|y[e+63|0]<<24));break k}w[a+480190>>1]=d;k=fb-32|0;fb=k;h=D(i,104)+a|0;o=h+484380|0;g=o;nd(g,0);m=k+8|0;ek(m,1,e+44|0);d=k+20|0;Cc(d,m);Be(g+43|0,d);tb(d);m=y[e+60|0]|y[e+61|0]<<8|(y[e+62|0]<<16|y[e+63|0]<<24);x[g>>2]=m;q=y[e+64|0]|y[e+65|0]<<8|(y[e+66|0]<<16|y[e+67|0]<<24);x[g+4>>2]=q;n=y[e+68|0]|y[e+69|0]<<8|(y[e+70|0]<<16|y[e+71|0]<<24);x[g+8>>2]=n;x[g+24>>2]=y[e+72|0]|y[e+73|0]<<8|(y[e+74|0]<<16|y[e+75|0]<<24);w[g+30>>1]=y[e+76|0]<<2;w[g+28>>1]=y[e+77|0];d=y[e+92|0];if(d&1){w[g+34>>1]=z[g+34>>1]|2;d=y[e+92|0]}if(d&2){w[g+34>>1]=z[g+34>>1]|4;d=y[e+92|0]}if(d&4){x[g+8>>2]=n>>>1;x[g+4>>2]=q>>>1;x[g>>2]=m>>>1;w[g+34>>1]=z[g+34>>1]|1;d=y[e+92|0]}if(d&8){w[g+34>>1]=z[g+34>>1]|32}fb=k+32|0;d=fb-16|0;fb=d;Uw(d+8|0,h+484423|0);g=e+24|0;yp(g,x[d+8>>2],x[d+12>>2]);fb=d+16|0;Ac(((i<<5)+a|0)+946304|0,g);tb(g);k=y[e+60|0]|y[e+61|0]<<8|(y[e+62|0]<<16|y[e+63|0]<<24);if(!k){break k}d=e+4|0;he(d,b,k);k=hc(g,d);ub(d);if(l){d=Zc(d,w[h+484414>>1]&1?16:8,1,0,0);x[31609]=0;U(215,d|0,o|0,k|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break j}}ub(k)}j=j+1|0;continue}break}break}a=N()|0;break a}d=gh(b);q=gh(b);f=e+44|0;he(f,b,d-4|0);k=hc(e+108|0,f);ub(f);l:{m:{if(!t){break m}x[31609]=0;f=U(196,m|0,j&65535,q|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break l}if(!f){break m}d=0;g=Ng(e+24|0);n:while(1){u=d>>>0>=q>>>0;while(1){if(u){break m}x[31609]=0;i=R(197,k|0)|0;f=x[31609];x[31609]=0;o:{if((f|0)!=1){if(i){break o}d=d+1|0;continue n}break b}f=g;n=i&31;if(n>>>0<z[a+480188>>1]){f=Wb(x[m>>2],j);f=md(x[f>>2],x[x[f+48>>2]+12>>2],d,n)}if(i&32){x[31609]=0;l=e+44|0;O(198,l|0,k|0);h=x[31609];x[31609]=0;if((h|0)==1){break g}h=y[e+44|0];v[f|0]=h;B=f,C=y[Jc(l)|0],v[B+1|0]=C;l=255;p:{if((h|0)==160){break p}l=0;if((h|0)==255){break p}h=(D(h>>>4|0,12)+(h&15)|0)+13|0;l=SZ(h)?h:0}v[f|0]=l}i=i&192;q:{if(!i){break q}if((i|0)==192){x[31609]=0;i=e+44|0;O(357,i|0,k|0);h=x[31609];x[31609]=0;if((h|0)!=1){h=Jc(i);l=_e(i);i=_i(i);r=e+4|0;GD(r,y[e+44|0],y[h|0]);h=Jc(r);r=e+494|0;GD(r,y[l|0],y[i|0]);gm(e+492|0,f,y[e+4|0],y[h|0],y[e+494|0],y[Jc(r)|0]);break q}break b}x[31609]=0;i=e+44|0;O(198,i|0,k|0);h=x[31609];x[31609]=0;r:{s:{if((h|0)!=1){h=e+4|0;GD(h,y[e+44|0],y[Jc(i)|0]);h=y[Jc(h)|0];i=y[e+4|0];if((i|0)!=13){break s}v[f+2|0]=1;i=f+4|0;break r}break b}v[f+3|0]=i;i=f+5|0}v[i|0]=h}Qc(e+44|0,o,n);if(!Gb(x[x[e+44>>2]>>2],x[e+48>>2])){continue}if(!n0(y[f+3|0],y[f+5|0])){continue}v[f+3|0]=0;continue}}}ub(k);j=j+1|0;continue}break}break b}break b}fb=e+1344|0;return s|0}a=N()|0}ub(k);Q(a|0);p()}function _pa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=fb-1824|0;fb=e;yc(b);d=fb-16|0;fb=d;f=e+1224|0;YX(d+8|0,f);i=x[d+12>>2];lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2]);m=x[d+4>>2];if((m|0)==(i|0)){Vb(b,x[d+12>>2])}fb=d+16|0;d=(i|0)==(m|0);if(!d){XX(f)}a:{if(!d){break a}if(!_X(f)){break a}if(!VC(b,16,0)){break a}d=e+1240|0;x[e+1216>>2]=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);d=y[e+1228|0]|y[e+1229|0]<<8|(y[e+1230|0]<<16|y[e+1231|0]<<24);x[e+1200>>2]=y[e+1224|0]|y[e+1225|0]<<8|(y[e+1226|0]<<16|y[e+1227|0]<<24);x[e+1204>>2]=d;d=e+1232|0;f=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);d=y[d+4|0]|y[d+5|0]<<8|(y[d+6|0]<<16|y[d+7|0]<<24);x[e+1208>>2]=f;x[e+1212>>2]=d;Dd(a,1);Lb(Lb(bg(a+1074312|0,83),84,1),85,1);w[a+480188>>1]=4;x[e+1196>>2]=0;w[a+480190>>1]=15;dd(b,20);l=a+480188|0;g=1;f=1;b:{while(1){c:{if((g|0)==16){d=e+1064|0;if(!RC(b,d)){MC(d)}d=a+484376|0;ow(Xb(x[a+484360>>2],y[d|0]),e+1066|0,128);m=eY(b,Xb(x[a+484360>>2],y[d|0]),y[e+1064|0],h,l,0,1);if(!(y[e+1065|0]|m>>>0>1)){g=0;if(!y[e+1064|0]){break a}}d=(m<<10)+h|0;x[e+1060>>2]=d;x[e+24>>2]=65536;g=0;if(!Mb(x[b>>2],x[b+8>>2],d-x[Hb(e+1060|0,e+24|0)>>2]|0)){break a}g=1;if((c|0)==64){break a}g=y[e+1065|0];if(!g){v[e+1065|0]=120;g=120}if(jd(e+1200|0,15019,6)){break c}v[e+1065|0]=120;x[a+480204>>2]=125e4;break b}d=e+24|0;PC(b,d);n=d;i=D(g,104)+a|0;m=i+484380|0;d=((g<<5)+a|0)+946304|0;YC(n,m,d,1);k=x[m>>2];d:{if(!y[xb(d,0)|0]){break d}e:{if(jd(d,16808,3)){if(jd(d,16812,3)){break e}}if(y[xb(d,5)|0]==58){break d}}f=0}d=Bb(y[e+52|0]|y[e+53|0]<<8);if(d>>>0>=2){n=d<<1;d=Bb(y[e+50|0]|y[e+51|0]<<8);x[i+484388>>2]=n+d;x[i+484384>>2]=d;Vk(m)}f:{if(Bb(y[e+46|0]|y[e+47|0]<<8)>>>0<=4999){if(Bb(y[e+50|0]|y[e+51|0]<<8)>>>0<1e4){break f}}x[e+1064>>2]=5;t=e,u=x[Xe(e+1196|0,e+1064|0)>>2],x[t+1196>>2]=u}h=h+k|0;g=g+1|0;continue}break}x[a+480204>>2]=125e4;if((g|0)==120){break b}t=a,u=Ye(1773447.5/(+(240-g|0)*122)*1e4),x[t+480204>>2]=u;if(x[e+1196>>2]>=2){x[e+24>>2]=f?4:5;t=e,u=x[Xe(e+1196|0,e+24|0)>>2],x[t+1196>>2]=u;break b}x[e+24>>2]=f?1:2;t=e,u=x[Xe(e+1196|0,e+24|0)>>2],x[t+1196>>2]=u}x[a+480228>>2]=64;x[a+480260>>2]=452;x[a+480264>>2]=3424;x[a+480208>>2]=x[a+480208>>2]|2097152;g=e+1048|0;qi(g,3,e+1200|0);d=e+24|0;Cc(d,g);zb(a+1298308|0,d);tb(d);Wh(a,0);n=x[b+8>>2];while(1){g:{if(m>>>0>(j&65535)>>>0){d=Xb(x[a+484360>>2],y[a+484376|0]);d=Ib(NC(wb(x[d>>2]),wb(x[d+4>>2]),j),wb(x[d+4>>2]));g=e+24|0;WX(b,g);h:{if(d){q=TC(g,0)+q|0;if(q>>>0>512){break h}}o=0;d=x[e+1196>>2];h=0;i=0;i:while(1){if((i|0)==64){break g}g=0;s=Yd(e+24|0,i);while(1)if((g|0)==4){i=i+1|0;continue i}else{k=yb(s,g);p=y[xb(k,2)|0]&15;l=y[xb(k,3)|0];j:{if(!(!(h&255)|(y[k|0]|y[k+1|0]<<8|(y[k+2|0]<<16|y[k+3|0]<<24)))){h=h+1|0;if((h&255)>>>0<33){break j}d=6;x[e+1196>>2]=6;break j}h=0}k:{l:{m:{n:{switch(p-1|0){case 0:case 1:if((d|0)==1&l>>>0>=32){break l}k=(p|0)!=1;if(!(k|!l|l>>>0>2)){x[e+1048>>2]=2;d=x[Xe(e+1196|0,e+1048|0)>>2];break m}if(k|(l|0)!=55&(l|0)!=71){break k}if((d|0)<=2){break l}break k;case 10:d=6;break m;case 11:case 12:case 13:x[e+1048>>2]=2;d=x[Xe(e+1196|0,e+1048|0)>>2];x[e+1196>>2]=d;if((p|0)!=13){break k}o=((i|l)!=0)+o|0;h=1;break k;case 14:break n;default:break k}}x[e+1048>>2]=3;d=x[Xe(e+1196|0,e+1048|0)>>2]}x[e+1196>>2]=d;break k}x[e+1196>>2]=f;d=f}g=g+1|0;continue}}}g=0;break a}if(!(x[e+1196>>2]!=6|m+32>>>0>=r>>>0)){x[e+1196>>2]=5}dd(b,n);p=c&1;if(p){Tf(a+484344|0,m)}o=a+484344|0;l=0;while(1)if((l|0)==(m|0)){g=22292;d=x[e+1196>>2];if(d>>>0<7){g=x[(d<<2)+25292>>2]}d=e+24|0;f=uc(d,8304);zb(a+1298344|0,f);tb(f);f=uc(d,10801);zb(a+1298356|0,f);tb(f);$h(a+1298368|0,g);t=a+1298404|0,u=x[Fc(d,28)>>2],x[t>>2]=u;g=1;if(!(c&2)){break a}while(1)if((g|0)==16){g=1;break a}else{c=D(g,104)+a|0;d=c+484384|0;Vb(b,x[d>>2]);f=x[d>>2];x[d>>2]=0;d=c+484380|0;x[d>>2]=x[d>>2]-f;c=c+484388|0;x[c>>2]=x[c>>2]-f;c=e+24|0;Zc(c,8,1,1,0);dg(c,d,b);g=g+1|0;continue}}else{WX(b,e+24|0);o:{if(!p){break o}if(!Pg(o,l&65535,64)){break o}i=0;x[e+20>>2]=0;p:while(1){if((i|0)==64){break o}d=Wb(x[o>>2],l);af(e+1048|0,x[d>>2],x[x[d+48>>2]+12>>2],i);g=0;r=Yd(e+24|0,i);while(1)if((g|0)==4){i=i+1|0;continue p}else{d=Yc(x[e+1048>>2],g);f=yb(r,g);f=y[f|0]|y[f+1|0]<<8|(y[f+2|0]<<16|y[f+3|0]<<24);x[e+8>>2]=f;x[e+12>>2]=f;f=e+18|0;dp(f,e+8|0,d);k=(e+20|0)+g|0;h=y[e+18|0];f=Jc(f);j=y[f|0];q:{r:{if(!((h|0)!=14?j:0)){v[k|0]=0;if(h|j){break r}break q}j=y[k|0];if(!j){break r}n=j;q=j>>>4|0;j=j>>>0<16;v[d+4|0]=j?n:q;v[d+2|0]=j?4:3}s:{t:{u:{v:{w:{switch(h-12|0){case 1:h=x[e+1196>>2];if((h|0)!=6){v[e+18|0]=10;break u}v[f|0]=0;break v;case 0:v[f|0]=y[f|0]&127;break v;case 2:h=y[f|0];if(h>>>0<=1){j=14;if(x[e+1196>>2]>3){break t}}v[e+18|0]=10;v[k|0]=y[f|0];break v;case 3:break w;default:break v}}v[f|0]=y[f|0]&15}h=x[e+1196>>2]}if((h|0)<2){break s}h=y[f|0];j=y[e+18|0]}Cf(d,j,h&255);break q}f=y[f|0];v[d+5|0]=f;x:{y:{z:{switch(y[e+18|0]){case 0:if(f>>>0>2){break y}break;case 2:break x;case 1:break y;default:break z}}v[d+3|0]=0;break q}v[d+3|0]=1;break q}h=f&15;if(h){v[d+5|0]=h;v[d+3|0]=2;break q}if(!f){break q}v[d+3|0]=3;v[d+5|0]=(f&240)>>>4}g=g+1|0;continue}}}l=l+1|0;continue}}if((o-1&255)>>>0<2){x[e+1196>>2]=6}j=j+1|0;r=(o&255)+r|0;continue}}fb=e+1824|0;return g|0}function xL(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,z=0,A=0,B=0,E=0,F=0,G=0,H=0;j=fb-80|0;fb=j;x[j+76>>2]=b;B=e-192|0;E=d-384|0;G=j+55|0;r=j+56|0;a:{b:{c:{d:{e:while(1){h=0;f:while(1){k=b;if((o^2147483647)<(h|0)){break d}o=h+o|0;g:{h:{i:{h=b;i=y[h|0];if(i){while(1){j:{b=i&255;k:{if(!b){b=h;break k}if((b|0)!=37){break j}i=h;while(1){if(y[i+1|0]!=37){b=i;break k}h=h+1|0;l=y[i+2|0];b=i+2|0;i=b;if((l|0)==37){continue}break}}h=h-k|0;F=o^2147483647;if((h|0)>(F|0)){break d}if(a){Kf(a,k,h)}if(h){continue f}x[j+76>>2]=b;h=b+1|0;q=-1;l=v[b+1|0];if(!(!Nh(l)|y[b+2|0]!=36)){q=l-48|0;s=1;h=b+3|0}x[j+76>>2]=h;n=0;i=v[h|0];b=i-32|0;l:{if(b>>>0>31){l=h;break l}l=h;b=1<<b;if(!(b&75913)){break l}while(1){l=h+1|0;x[j+76>>2]=l;n=b|n;i=v[h+1|0];b=i-32|0;if(b>>>0>=32){break l}h=l;b=1<<b;if(b&75913){continue}break}}m:{if((i|0)==42){b=v[l+1|0];n:{if(!(!Nh(b)|y[l+2|0]!=36)){o:{if(!a){x[(b<<2)+B>>2]=10;p=0;break o}p=x[(b<<3)+E>>2]}b=l+3|0;s=1;break n}if(s){break i}b=l+1|0;if(!a){x[j+76>>2]=b;s=0;p=0;break m}h=x[c>>2];x[c>>2]=h+4;p=x[h>>2];s=0}x[j+76>>2]=b;if((p|0)>=0){break m}p=0-p|0;n=n|8192;break m}p=wL(j+76|0);if((p|0)<0){break d}b=x[j+76>>2]}h=0;m=-1;i=0;p:{if(y[b|0]!=46){break p}if(y[b+1|0]==42){l=v[b+2|0];q:{if(!(!Nh(l)|y[b+3|0]!=36)){b=b+4|0;r:{if(!a){x[(l<<2)+B>>2]=10;m=0;break r}m=x[(l<<3)+E>>2]}break q}if(s){break i}b=b+2|0;m=0;if(!a){break q}l=x[c>>2];x[c>>2]=l+4;m=x[l>>2]}x[j+76>>2]=b;i=(m|0)>=0;break p}x[j+76>>2]=b+1;m=wL(j+76|0);b=x[j+76>>2];i=1}u=i;while(1){t=h;l=28;z=b;i=v[b|0];if(i-123>>>0<4294967238){break c}b=b+1|0;h=y[(i+D(h,58)|0)+92703|0];if(h-1>>>0<8){continue}break}x[j+76>>2]=b;s:{if((h|0)!=27){if(!h){break c}if((q|0)>=0){if(!a){x[(q<<2)+e>>2]=h;continue e}h=(q<<3)+d|0;l=x[h+4>>2];x[j+64>>2]=x[h>>2];x[j+68>>2]=l;break s}if(!a){break g}vL(j- -64|0,h,c,g);break s}if((q|0)>=0){break c}h=0;if(!a){continue f}}if(y[a|0]&32){break b}i=n&-65537;n=n&8192?i:n;q=0;A=5286;l=r;t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{h=v[z|0];h=t?(h&15)==3?h&-45:h:h;switch(h-88|0){case 11:break t;case 9:case 13:case 14:case 15:break u;case 27:break z;case 12:case 17:break C;case 23:break D;case 0:case 32:break E;case 24:break F;case 22:break G;case 29:break H;case 1:case 2:case 3:case 4:case 5:case 6:case 7:case 8:case 10:case 16:case 18:case 19:case 20:case 21:case 25:case 26:case 28:case 30:case 31:break h;default:break I}}J:{switch(h-65|0){case 0:case 4:case 5:case 6:break u;case 2:break x;case 1:case 3:break h;default:break J}}if((h|0)==83){break y}break h}k=x[j+64>>2];i=x[j+68>>2];b=5286;break B}h=0;K:{switch(t&255){case 0:x[x[j+64>>2]>>2]=o;continue f;case 1:x[x[j+64>>2]>>2]=o;continue f;case 2:k=x[j+64>>2];x[k>>2]=o;x[k+4>>2]=o>>31;continue f;case 3:w[x[j+64>>2]>>1]=o;continue f;case 4:v[x[j+64>>2]]=o;continue f;case 6:x[x[j+64>>2]>>2]=o;continue f;case 7:break K;default:continue f}}k=x[j+64>>2];x[k>>2]=o;x[k+4>>2]=o>>31;continue f}m=m>>>0<=8?8:m;n=n|8;h=120}b=r;z=h&32;k=x[j+64>>2];i=x[j+68>>2];if(k|i){while(1){b=b-1|0;v[b|0]=z|y[(k&15)+93232|0];H=!i&k>>>0>15|(i|0)!=0;t=i;i=i>>>4|0;k=(t&15)<<28|k>>>4;if(H){continue}break}}k=b;if(!(n&8)|!(x[j+64>>2]|x[j+68>>2])){break A}A=(h>>>4|0)+5286|0;q=2;break A}b=r;h=x[j+68>>2];i=h;k=x[j+64>>2];if(h|k){while(1){b=b-1|0;v[b|0]=k&7|48;t=!i&k>>>0>7|(i|0)!=0;h=i;i=h>>>3|0;k=(h&7)<<29|k>>>3;if(t){continue}break}}k=b;if(!(n&8)){break A}b=r-b|0;m=(b|0)<(m|0)?m:b+1|0;break A}k=x[j+64>>2];b=x[j+68>>2];i=b;if((b|0)<0){h=0-(b+((k|0)!=0)|0)|0;i=h;k=0-k|0;x[j+64>>2]=k;x[j+68>>2]=h;q=1;b=5286;break B}if(n&2048){q=1;b=5287;break B}q=n&1;b=q?5288:5286}A=b;k=ko(k,i,r)}if((m|0)<0&u){break d}n=u?n&-65537:n;b=x[j+64>>2];h=x[j+68>>2];if(!((b|h)!=0|m)){k=r;m=0;break h}b=!(b|h)+(r-k|0)|0;m=(b|0)<(m|0)?m:b;break h}b=x[j+64>>2];k=b?b:17107;b=k;h=m>>>0>=2147483647?2147483647:m;l=Mz(b,0,h);b=l?l-b|0:h;l=b+k|0;if((m|0)>=0){n=i;m=b;break h}n=i;m=b;if(y[l|0]){break d}break h}if(m){i=x[j+64>>2];break w}h=0;Wf(a,32,p,0,n);break v}x[j+12>>2]=0;x[j+8>>2]=x[j+64>>2];i=j+8|0;x[j+64>>2]=i;m=-1}h=0;while(1){L:{k=x[i>>2];if(!k){break L}k=Kt(j+4|0,k);if((k|0)<0){break b}if(k>>>0>m-h>>>0){break L}i=i+4|0;h=h+k|0;if(m>>>0>h>>>0){continue}}break}l=61;if((h|0)<0){break c}Wf(a,32,p,h,n);if(!h){h=0;break v}l=0;i=x[j+64>>2];while(1){k=x[i>>2];if(!k){break v}m=j+4|0;k=Kt(m,k);l=k+l|0;if(l>>>0>h>>>0){break v}Kf(a,m,k);i=i+4|0;if(h>>>0>l>>>0){continue}break}}Wf(a,32,p,h,n^8192);h=(h|0)<(p|0)?p:h;continue f}if((m|0)<0&u){break d}l=61;h=ib[f|0](a,C[j+64>>3],p,m,n,h)|0;if((h|0)>=0){continue f}break c}v[j+55|0]=x[j+64>>2];m=1;k=G;n=i;break h}i=y[h+1|0];h=h+1|0;continue}}if(a){break a}if(!s){break g}h=1;while(1){a=x[(h<<2)+e>>2];if(a){vL((h<<3)+d|0,a,c,g);o=1;h=h+1|0;if((h|0)!=10){continue}break a}break}o=1;if(h>>>0>=10){break a}while(1){if(x[(h<<2)+e>>2]){break i}h=h+1|0;if((h|0)!=10){continue}break}break a}l=28;break c}i=l-k|0;m=(i|0)<(m|0)?m:i;if((m|0)>(q^2147483647)){break d}l=61;b=m+q|0;h=(b|0)<(p|0)?p:b;if((F|0)<(h|0)){break c}Wf(a,32,h,b,n);Kf(a,A,q);Wf(a,48,h,b,n^65536);Wf(a,48,m,i,0);Kf(a,k,i);Wf(a,32,h,b,n^8192);b=x[j+76>>2];continue}break}break}o=0;break a}l=61}x[31484]=l}o=-1}fb=j+80|0;return o}function Tra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,B=0,C=0,E=0,F=0,G=0,H=0;g=fb-192|0;fb=g;n=bk(b,13935);if(n){if(d){v[d|0]=1}k=a+480204|0;o=a+480216|0;q=a+480220|0;r=a+480224|0;l=a+1074368|0;u=a+480228|0;B=a+480232|0;s=a+480200|0;m=a+480268|0;C=a+1298320|0;E=a+480248|0;F=Vv(a+1074312|0);a:{b:{c:{d:{e:{f:{g:{h:{while(1){if(!Mb(x[b>>2],x[b+8>>2],7)){break a}e=Rg(b);f=gh(b);if((e|0)==70791730){Ih(b,6);break a}if(!(e&1616928864)|e&-2139062144){break a}if(!Mb(x[b>>2],x[b+8>>2],f)){break a}i=g+152|0;he(i,b,f);h=hc(g+172|0,i);ub(i);i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{if((e|0)!=1127099950){if((e|0)==1129797166){break v}if((e|0)==1130917459){break o}if((e|0)==1145525806){break t}d=B;if((e|0)==1448301654){break s}if((e|0)==1196316499){break m}if((e|0)==1213486401){break p}if((e|0)==1280530262){break u}if((e|0)==1297303086){break l}if((e|0)==1347243310){break w}if((e|0)==1347244882){break q}if((e|0)!=1380340804){if((e|0)==1380986414){break r}d=o;if((e|0)==1380991534){break s}d=q;if((e|0)==1380994350){break s}if((e|0)==1397052739){break n}d=u;if((e|0)==1397768494){break s}if((e|0)==1414344238){break k}if((e|0)!=1146367534){break j}x[31609]=0;S(451,h|0,f|0,i|0);d=x[31609];x[31609]=0;if((d|0)==1){break i}x[k>>2]=D(x[g+152>>2],1e4)+(A[k>>2]%1e4|0);break j}x[31609]=0;S(451,h|0,f|0,g+152|0);d=x[31609];x[31609]=0;if((d|0)!=1){d=x[k>>2];x[k>>2]=d-((d>>>0)%1e4|0)+A[g+152>>2]%1e4;break j}e=N()|0;break b}if(c){break j}x[31609]=0;w[g+152>>1]=0;S(452,h|0,f|0,g+152|0);d=x[31609];x[31609]=0;if((d|0)!=1){G=a,H=Ld(z[g+152>>1],z[a+480188>>1],127),w[G+480188>>1]=H;break j}e=N()|0;break b}x[31609]=0;S(453,h|0,f|0,l|0);d=x[31609];x[31609]=0;if((d|0)!=1){break j}break c}x[31609]=0;x[g+152>>2]=0;S(451,h|0,f|0,g+152|0);d=x[31609];x[31609]=0;if((d|0)!=1){x[a+1074304>>2]=x[g+152>>2];break j}e=N()|0;break b}x[31609]=0;x[g+152>>2]=0;S(451,h|0,f|0,g+152|0);d=x[31609];x[31609]=0;if((d|0)==1){break h}d=x[g+152>>2];if(!d){break j}x[a+1074308>>2]=d;break j}d=s}x[31609]=0;S(451,h|0,f|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break c}break j}if(x[a+480180>>2]==4){break j}x[31609]=0;S(452,h|0,f|0,g+152|0);d=x[31609];x[31609]=0;if((d|0)!=1){$e(Xb(x[a+484360>>2],y[a+484376|0]),z[g+152>>1]);break j}e=N()|0;break b}x[31609]=0;S(454,h|0,f|0,m|0);d=x[31609];x[31609]=0;if((d|0)==1){break c}if(tp(y[m|0])){break j}v[m|0]=5;break j}d=Fb(g+152|0);e=x[h>>2];x[31609]=0;e=R(154,e|0)|0;f=x[31609];x[31609]=0;x:{if((f|0)==1){break x}x[31609]=0;S(455,h|0,d|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break x}x[31609]=0;e=g+140|0;S(258,e|0,0,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break x}zb(C,e);tb(e);tb(d);break j}e=N()|0;tb(d);break b}if(f&1|f>>>0>126){break j}d=64;w[g+152>>1]=f>>>1|64;w[g+140>>1]=127;e=z[Oc(g+152|0,g+140|0)>>1];i=e>>>0<=64?64:e;while(1){if((d|0)==(i|0)){break j}x[31609]=0;f=g+152|0;O(198,f|0,h|0);e=x[31609];x[31609]=0;if((e|0)==1){break g}e=y[g+152|0];y:{if((e|0)==255){break y}j=y[Jc(f)|0];f=(d<<5)+a|0;t=f+480284|0;w[t>>1]=128;w[f+480286>>1]=j;f=f+480280|0;j=(e&128)<<3;x[f>>2]=j;e=e&127;if(e>>>0<65){w[t>>1]=e<<2;break y}if((e|0)!=100){break y}x[f>>2]=j|256}d=d+1|0;continue}}if(f>>>0<3){break j}x[31609]=0;d=R(189,h|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break f}if(z[a+480190>>1]<=(d-1&65535)>>>0){break j}d=(D(d,104)+a|0)+484448|0;f=KZ(d);while(1){if((d|0)==(f|0)){break j}e=x[h>>2];x[31609]=0;i=U(150,e|0,x[g+180>>2],4)|0;e=x[31609];x[31609]=0;z:{if((e|0)!=1){e=268435456;if(!i){break z}x[31609]=0;e=R(151,h|0)|0;i=x[31609];x[31609]=0;if((i|0)!=1){break z}}e=N()|0;break b}x[d>>2]=e;d=d+4|0;continue}}if(f>>>0<3){break j}x[31609]=0;f=g+140|0;O(456,f|0,h|0);d=x[31609];x[31609]=0;A:{B:{C:{D:{if((d|0)!=1){x[31609]=0;e=g+152|0;S(457,e|0,x[g+140>>2],x[g+144>>2]);d=x[31609];x[31609]=0;if((d|0)==1){break D}x[31609]=0;d=P(103,g|0,e|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break C}tb(e);ec(f);e=x[h>>2];x[31609]=0;R(154,e|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break A}x[31609]=0;S(458,d|0,E|0,d|0);e=x[31609];x[31609]=0;if((e|0)==1){break A}Gf(d);break j}e=N()|0;break b}e=N()|0;break B}e=N()|0;tb(g+152|0)}ec(g+140|0);break b}e=N()|0;Gf(d);break b}e=0;f=Vv(F);E:while(1){d=x[h>>2];x[31609]=0;d=U(150,d|0,x[g+180>>2],1)|0;i=x[31609];x[31609]=0;if((i|0)==1){break d}if(!(e>>>0<122&d)){break j}x[31609]=0;i=R(197,h|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break e}d=0;while(1){if((d|0)==8){continue E}F:{if(!(i>>>d&1)|e>>>0>121){break F}x[31609]=0;U(266,f|0,e|0,1)|0;j=x[31609];x[31609]=0;if((j|0)!=1){break F}e=N()|0;break b}e=e+1|0;d=d+1|0;continue}}}x[31609]=0;S(459,h|0,f|0,r|0);d=x[31609];x[31609]=0;if((d|0)==1){break c}}ub(h);continue}break}e=N()|0;break b}e=N()|0;break b}e=N()|0;break b}e=N()|0;break b}e=N()|0;break b}e=N()|0;break b}e=N()|0}ub(h);Q(e|0);p()}b=x[a+8>>2];Ep(k,D(x[b+20>>2],1e4),D(x[b+24>>2],1e4));if(y[a+480224|0]>=3){v[r|0]=0}if(y[l|0]>=6){v[l|0]=0}xc(s,256);xc(o,65536);xc(q,65536)}fb=g+192|0;return n|0}function Ooa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;d=fb-352|0;fb=d;a:{b:{c:{if(!dd(b,60)){break c}e=d+332|0;if(!Lp(b,e)){break c}f=15;if(yv(e,15)){break b}}e=0;if(!dd(b,124)){break a}g=d+332|0;if(!Lp(b,g)){break a}f=31;if(!yv(g,31)){break a}}Dd(a,536870912);w[a+480190>>1]=f;yc(b);e=0;d:{while(1){if(z[a+480190>>1]>e>>>0){g=np(b);x[(d+208|0)+(e<<2)>>2]=g;e=e+1|0;if(g>>>0<=131072){continue}break d}break}Vb(b,20);f=0;w[a+480192>>1]=0;w[a+480188>>1]=4;e=y[d+336|0]|y[d+337|0]<<8;x[a+480260>>2]=56;x[a+480264>>2]=13696;x[a+480196>>2]=6;o=a,q=Ye(1776930/+(Bb(e)>>>0)*1e4),x[o+480204>>2]=q;x[a+480228>>2]=64;Wh(a,1);m=1;e:while(1){l=m&65535;if(l>>>0<=z[a+480190>>1]){PC(b,d+52|0);e=x[((l<<2)+d|0)+204>>2];h=fb-16|0;fb=h;i=(D(l,104)+a|0)+484380|0;nd(i,1);x[i>>2]=e;v[i+37|0]=y[d+76|0]<<4;v[h+15|0]=y[d+77|0];v[h+14|0]=64;o=i,q=y[Qb(h+15|0,h+14|0)|0]<<2,w[o+30>>1]=q;f:{if(!e){break f}g=Bb(y[d+80|0]|y[d+81|0]<<8);k=Bb(y[d+78|0]|y[d+79|0]<<8);x[i+4>>2]=k;g=(g<<1)+k|0;x[i+8>>2]=g;if(e>>>0<=k>>>0){k=e-1|0;x[i+4>>2]=k}if(e>>>0<g>>>0){x[i+8>>2]=e;g=e}if(!(!(g>>>0<4|g>>>0<k>>>0)&g-k>>>0>3)){x[i+4>>2]=0;x[i+8>>2]=0;break f}if(g>>>0<=k>>>0){break f}w[i+34>>1]=z[i+34>>1]|2}fb=h+16|0;e=0;while(1)if((e|0)==22){if(f>>>0>=128){break d}g=d+184|0;Sk(g,3,d+52|0);e=d+196|0;Cc(e,g);Ac(((l<<5)+a|0)+946304|0,e);m=m+1|0;tb(e);continue e}else{g=(d+52|0)+e|0;if((y[g|0]-1&255)>>>0<=30){v[g|0]=32;f=f+1|0}e=e+1|0;continue}}break}m=1;g:{h:{f=a+946336|0;e=Dc(d+52|0,14097);if(!PW(f,e)){x[31609]=0;g=P(36,d+196|0,14108)|0;i=x[31609];x[31609]=0;if((i|0)==1){break h}m=PW(f,g);tb(g)}tb(e);e=0;g=d+52|0;f=RC(b,g);if(!f){MC(g)}if(!f){break a}g=y[d+52|0];if(!RW(g)){break a}e=1;if((c|0)==64){break a}e=0;w[d+50>>1]=0;while(1)if((e|0)==(g|0)){e=a+484376|0;h=Xb(x[a+484360>>2],y[e|0]);f=y[d+53|0];$e(h,g>>>0>f>>>0?f:0);Kw(Xb(x[a+484360>>2],y[e|0]),d+54|0,y[d+52|0],65535,65535);if(z[a+480190>>1]==31){Vb(b,4)}x[d+44>>2]=0;x[d+40>>2]=0;x[d+36>>2]=0;v[d+35|0]=0;n=c&1;if(n){Tf(a+484344|0,z[d+50>>1])}l=a+484344|0;i=0;while(1){i:{j:{k:{if(z[d+50>>1]<=i>>>0){if(!(c&2)){break k}e=1;while(1){f=z[a+480190>>1];c=e&65535;if(f>>>0<c>>>0){break j}c=(D(c,104)+a|0)+484380|0;if(x[c>>2]){dg(Zc(d+184|0,8,1,0,0),c,b)}e=e+1|0;continue}}l:{if(n){k=0;if(Pg(l,i&65535,64)){break l}}Vb(b,1024);break i}m:while(1){if((k|0)==64){break i}e=Wb(x[l>>2],i);af(d+184|0,x[e>>2],x[x[e+48>>2]+12>>2],k);e=0;while(1)if((e|0)==4){k=k+1|0;continue m}else{g=Yc(x[d+184>>2],e);f=d+12|0;mm(f,b);n:{o:{p:{q:{if(y[xb(f,0)|0]!=255){break q}v[(d+44|0)+e|0]=0;v[(d+36|0)+e|0]=0;f=xb(f,1);h=y[f|0];if((h|0)==252&m){v[f|0]=254;break o}switch(h-252|0){case 1:break n;case 2:break o;case 0:break p;default:break q}}f=x[d+12>>2];x[d+28>>2]=f;x[d+8>>2]=f;f=d+33|0;dp(f,d+8|0,g);h=Jc(f);f=y[g|0];r:{if(!f){break r}v[(d+36|0)+e|0]=0;v[(d+44|0)+e|0]=f;if(f>>>0>48){break r}v[d+27|0]=8;o=d,q=y[cf(d+35|0,d+27|0)|0],v[o+35|0]=q}j=y[d+33|0];f=y[h|0];s:{if(j|f){v[g+5|0]=f;t:{u:{v:{switch(j-1|0){case 0:v[g+3|0]=1;break n;case 1:if(f>>>0>=16){v[g+3|0]=3;v[g+5|0]=(f&240)>>>4;break n}if(!f){break u}v[g+5|0]=f;v[g+3|0]=2;break n;case 2:if(y[(d+36|0)+e|0]){break u}v[g+5|0]=0;v[g+3|0]=19;break n;case 3:if(y[(d+36|0)+e|0]){break u}v[g+5|0]=1;v[g+3|0]=19;break n;case 4:h=y[g+1|0];if(!h){break u}v[d+27|0]=63;v[d+26|0]=f+(z[(D(h,104)+a|0)+484410>>1]>>>2|0);f=y[Qb(d+27|0,d+26|0)|0];v[g+5|0]=f;v[g+3|0]=13;if(!y[(d+36|0)+e|0]){break n}h=g+3|0;v[g+4|0]=f;v[g+2|0]=1;break t;case 5:h=g+3|0;j=y[g+1|0];if(!j){break t}v[g+3|0]=13;j=z[(D(j,104)+a|0)+484410>>1]>>>2|0;f=f>>>0<=j>>>0?j-f|0:0;v[g+5|0]=f;if(!y[(d+36|0)+e|0]){break n}v[g+4|0]=f;v[g+2|0]=1;break t;case 6:h=f&15;v[(d+36|0)+e|0]=h;j=y[(d+44|0)+e|0];f=j-((f&240)>>>4|0)|0;v[(d+40|0)+e|0]=f;o=g,q=OW(h,f&255,j),v[o+5|0]=q;v[g+3|0]=3;break n;case 7:h=f&15;v[(d+36|0)+e|0]=h;j=(f&240)>>>4|0;f=y[(d+44|0)+e|0];j=j+f|0;v[(d+40|0)+e|0]=j;o=g,q=OW(h,f,j&255),v[o+5|0]=q;v[g+3|0]=2;break n;case 8:break v;default:break u}}v[d+27|0]=8;o=d,q=y[cf(d+35|0,d+27|0)|0],v[o+35|0]=q}h=g+3|0}v[h|0]=0;break s}if(y[g+3|0]){break n}}h=y[(d+36|0)+e|0];if(!h){break n}j=(d+40|0)+e|0;f=y[j|0];if(f){v[(d+44|0)+e|0]=f;v[g+5|0]=h;v[g|0]=f;v[j|0]=0}v[g+3|0]=4;break n}v[g+3|0]=14;v[d+35|0]=9;break n}v[g+3|0]=13}e=e+1|0;continue}}}f=z[a+480190>>1]}w:{x:{if((f&65535)==15){b=d+12|0;gg(b,4418);x[31609]=0;S(209,d+184|0,b|0,d+35|0);c=x[31609];x[31609]=0;if((c|0)!=1){break x}f=N()|0;Eb(b);break g}x[31609]=0;P(1,d+184|0,12406)|0;b=x[31609];x[31609]=0;if((b|0)==1){break w}}b=d+184|0;zb(a+1298344|0,b);tb(b);if((f&65535)==15){Eb(d+12|0)}$h(a+1298356|0,z[a+480190>>1]==15?5282:15209);o=a+1298404|0,q=x[Fc(d+184|0,28)>>2],x[o>>2]=q;e=1;break a}f=N()|0;break g}i=i+1|0;continue}}else{w[d+184>>1]=y[(d+e|0)+54|0]+1;o=d,q=z[qe(d+50|0,d+184|0)>>1],w[o+50>>1]=q;e=e+1|0;continue}}f=N()|0;tb(e)}Q(f|0);p()}e=0}fb=d+352|0;return e|0}function Epa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;f=fb-272|0;fb=f;yc(b);a:{b:{c:{e=f+206|0;if(!M$(b,e)){break c}if(!HX(e)){break c}if(!Mb(x[b>>2],x[b+8>>2],Bc(GX(e),hb))){break c}d=1;if((c|0)==64){break c}Dd(a,16);e=f+44|0;qi(e,2,f+210|0);d=f- -64|0;Cc(d,e);zb(a+1298308|0,d);tb(d);w[a+480190>>1]=y[f+236|0];w[a+480188>>1]=y[f+239|0];g=uc(d,8365);zb(a+1298344|0,g);tb(g);g=uc(d,10145);zb(a+1298356|0,g);tb(g);gg(e,4211);g=y[f+209|0];x[f+24>>2]=g>>>4;x[31609]=0;x[f+12>>2]=g&15;V(307,d|0,e|0,f+24|0,f+12|0);g=x[31609];x[31609]=0;if((g|0)!=1){zb(a+1298368|0,d);tb(d);Eb(e);t=a+1298404|0,u=x[Fc(d,4)>>2],x[t>>2]=u;d=1;while(1){h=d&65535;if(h>>>0>z[a+480190>>1]){d=0;while(1)if(z[a+480188>>1]<=d>>>0){e=f- -64|0;d=fb-16|0;fb=d;k=b;d:{if(!Mb(x[b>>2],x[b+8>>2],128)){b=0;while(1){if((b|0)!=128){dh(b+e|0);b=b+1|0;continue}break}break d}hZ(d+8|0,e);sd(d,k,x[d+8>>2],x[d+12>>2])}fb=d+16|0;Kw(Xb(x[a+484360>>2],y[a+484376|0]),e,y[f+233|0]+1|0,255,254);b=y[f+238|0];d=f+24|0;he(d,k,D(y[f+230|0]|y[f+231|0]<<8,192));l=hc(f+44|0,d);ub(d);e:{o=c&1;if(!o){break e}x[31609]=0;O(223,a+484344|0,y[f+232|0]+1|0);d=x[31609];x[31609]=0;if((d|0)!=1){break e}break b}q=b?b:64;r=a+484344|0;b=0;while(1){f:{g:{h:{if(y[f+232|0]<m>>>0){if(!(b&s)){break g}t=f,u=wb(x[a+484344>>2]),x[t+12>>2]=u;j=wb(x[a+484348>>2]);break h}i:{if(o){x[31609]=0;d=U(196,r|0,m&65535,q|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break b}n=0;if(d){break i}}x[31609]=0;P(183,k|0,64)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break f}break b}while(1){d=n&65535;if(d>>>0>31){break f}x[31609]=0;e=R(189,k|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}j:{if((e-1&65535)>>>0>=(y[f+230|0]|y[f+231|0]<<8)>>>0|d>>>0>=z[a+480188>>1]){break j}x[31609]=0;P(149,l|0,D(e,192)-192|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break b}e=0;g=Wb(x[r>>2],m);d=md(x[g>>2],x[x[g+48>>2]+12>>2],0,d);while(1){if((e|0)==(q|0)){break j}j=b;x[31609]=0;b=f+24|0;O(549,b|0,l|0);g=x[31609];x[31609]=0;k:{l:{m:{n:{o:{if((g|0)!=1){h=Jc(b);g=_e(b);b=y[f+24|0];if(b>>>0>=4){v[d|0]=(b>>>2|0)+37;b=y[f+24|0]}v[d+1|0]=b<<4&48|y[h|0]>>>4;b=v[g|0];g=0;i=0;p:{q:{h=y[h|0]&15;switch(h-8|0){case 0:break n;case 2:break p;case 6:break q;default:break o}}h=14;if(!(435>>>((b+16&240)>>>4)&1)|(b|0)<=-17){break m}break n}g=b&-16;b=g?g:b;h=10;break m}break b}g=h;i=b}h=g;b=i;if(!(g|b)){break l}}Cf(d,h,b&255);b=1;r:{switch(y[d+3|0]-16|0){case 0:break k;case 1:break r;default:break l}}s=1}b=j}e=e+1|0;d=D(z[a+480188>>1],6)+d|0;continue}}n=n+1|0;continue}}while(1){s:{b=x[f+12>>2];if(Ib(b,j)){g=0;t:while(1){if(A[b+12>>2]<=g>>>0){break s}af(f+24|0,x[b>>2],x[x[b+48>>2]+12>>2],g);t=f,u=wb(x[f+24>>2]),x[t+20>>2]=u;e=0;h=nw(x[f+24>>2],x[f+28>>2]);i=0;while(1){m=x[f+20>>2];if(Ib(m,h)){d=1;u:{switch(y[m+3|0]-16|0){case 1:i=1;default:d=e;break;case 0:break u}}tg(f+20|0);e=d;continue}else{g=g+1|0;if(!(e&i&1)){continue t}break g}}}}h=wb(x[a+484344>>2]);x[f+20>>2]=h;b=wb(x[a+484348>>2]);v:while(1){if(!Ib(h,b)){break g}e=0;w:while(1){if(A[h+12>>2]<=e>>>0){h=x[Vl(f+20|0)>>2];continue v}af(f+12|0,x[h>>2],x[x[h+48>>2]+12>>2],e);t=f,u=wb(x[f+12>>2]),x[t+8>>2]=u;d=nw(x[f+12>>2],x[f+16>>2]);while(1){x:{g=x[f+8>>2];if(Ib(g,d)){g=y[g+3|0];if((g&254)!=16){break x}d=(g|0)==16;Ae(h,Ve(Oe(f+24|0,d?17:16,d?125:6),e))}e=e+1|0;continue w}tg(f+8|0);continue}}}}Vl(f+12|0);continue}}y:{b=y[f+234|0]|y[f+235|0]<<8;if(!b){break y}x[31609]=0;aa(316,a+1298332|0,k|0,b|0,39,1);b=x[31609];x[31609]=0;if((b|0)!=1){break y}break b}z:{if(!(c&2)){break z}d=1;while(1){b=d&65535;if(b>>>0>z[a+480190>>1]){break z}b=D(b,104)+a|0;c=Zc(f+24|0,w[b+484414>>1]&1?16:8,1,0,1);x[31609]=0;U(215,c|0,b+484380|0,k|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){d=d+1|0;continue}break}break b}x[a+480260>>2]=64;x[a+480264>>2]=32767;ub(l);d=1;break c}m=m+1|0;continue}}else{e=(d<<5)+a|0;Ue(e+480280|0);w[e+480284>>1]=(y[(d+f|0)+240|0]<<4|8)&248;d=d+1|0;continue}}else{i=f- -64|0;gF(b,i);j=fb-16|0;fb=j;e=(D(h,104)+a|0)+484380|0;nd(e,0);w[j+14>>1]=y[i+35|0]<<2;w[j+12>>1]=256;t=e,u=z[Oc(j+14|0,j+12|0)>>1],w[t+30>>1]=u;g=y[i+22|0]|y[i+23|0]<<8|(y[i+24|0]<<16|y[i+25|0]<<24);A:{if(g>>>0<3){break A}x[e>>2]=g;x[e+4>>2]=y[i+26|0]|y[i+27|0]<<8|(y[i+28|0]<<16|y[i+29|0]<<24);x[j+8>>2]=y[i+30|0]|y[i+31|0]<<8|(y[i+32|0]<<16|y[i+33|0]<<24);x[j+4>>2]=1;t=e,u=x[bd(j+8|0,j+4|0)>>2]-1|0,x[t+8>>2]=u;xc(e+8|0,g);g=x[e+8>>2];k=x[e+4>>2];B:{if(g>>>0<=k+4>>>0){x[e+4>>2]=0;x[e+8>>2]=0;g=0;k=0;break B}if(g>>>0<3){break B}w[e+34>>1]=z[e+34>>1]|2}l=v[i+34|0];v[e+37|0]=l;t=e,u=xw(0,l<<4),x[t+24>>2]=u;if(!(v[i+36|0]&1)){break A}x[e+8>>2]=g>>>1;x[e+4>>2]=k>>>1;w[e+34>>1]=z[e+34>>1]|1;x[e>>2]=x[e>>2]>>>1}fb=j+16|0;g=f+24|0;Sk(g,2,i);e=f+44|0;Cc(e,g);Ac(((h<<5)+a|0)+946304|0,e);d=d+1|0;tb(e);continue}}}d=N()|0;Eb(f+44|0);break a}fb=f+272|0;return d|0}d=N()|0;ub(l)}Q(d|0);p()}function _L(a,b,c,d,e,f){var g=0,h=E(0),i=0,j=E(0),k=0,l=E(0),m=E(0),n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,x=0,y=0,z=0,A=E(0),C=E(0),F=0,G=0,H=E(0),I=E(0),J=E(0),K=E(0),L=E(0),M=E(0),N=E(0),O=E(0),P=0,Q=0;F=(d|0)>0?d:0;while(1){if((s|0)!=(F|0)){G=D(s,2304)+b|0;t=0;q=(c|0)>0?c:0;k=fb-128|0;x=k+96|0;y=k- -64|0;g=k+32|0;while(1){if((q|0)!=(t|0)){n=G+(t<<2)|0;v=0;i=k;p=i;o=0;while(1){if((o|0)!=8){j=B[D(o^15,72)+n>>2];z=D(o,72)+n|0;h=B[z+1152>>2];l=E(j+h);m=B[z>>2];A=B[D(o^31,72)+n>>2];C=E(m+A);B[p>>2]=l+C;z=D(o,12);j=E(E(j-h)*B[z+87456>>2]);h=E(E(m-A)*B[z+87460>>2]);B[p+64>>2]=j+h;m=E(C-l);l=B[z+87464>>2];B[p+32>>2]=m*l;B[p+96>>2]=l*E(h-j);p=p+4|0;o=o+1|0;continue}break}while(1){if((v|0)!=4){l=B[i+8>>2];m=B[i+20>>2];h=E(l+m);A=B[i+4>>2];C=B[i+24>>2];H=E(A+C);j=E(h+H);I=B[i+12>>2];J=B[i+16>>2];K=E(I+J);L=B[i>>2];M=B[i+28>>2];N=E(L+M);O=E(K+N);B[i>>2]=j+O;B[i+16>>2]=E(O-j)*E(.7071067690849304);j=E(N-K);h=E(E(j+E(H-h))*E(.7071067690849304));B[i+24>>2]=E(j-h)*E(1.3065630197525024);B[i+8>>2]=E(j+h)*E(.5411961078643799);j=E(L-M);h=E(l-m);l=E(A-C);m=E(E(h+l)*E(.7071067690849304));A=E(j+m);C=E(E(I-J)+h);h=E(l+j);l=E(C-E(h*E(.1989123672246933)));h=E(E(l*E(.3826834261417389))+h);B[i+28>>2]=E(A-h)*E(2.562915563583374);B[i+4>>2]=E(A+h)*E(.509795606136322);j=E(j-m);h=E(l-E(h*E(.1989123672246933)));B[i+20>>2]=E(j+h)*E(.8999761939048767);B[i+12>>2]=E(j-h)*E(.601344883441925);i=i+32|0;v=v+1|0;continue}break}i=0;while(1){if((i|0)!=7){p=i<<2;B[n>>2]=B[p+k>>2];j=B[p+x>>2];i=i+1|0;o=i<<2;h=B[o+x>>2];B[n+72>>2]=E(B[p+y>>2]+j)+h;B[n+144>>2]=B[g+p>>2]+B[g+o>>2];B[n+216>>2]=h+E(j+B[o+y>>2]);n=n+288|0;continue}break}B[n>>2]=B[k+28>>2];j=B[k+124>>2];B[n+72>>2]=B[k+92>>2]+j;h=B[k+60>>2];B[n+216>>2]=j;B[n+144>>2]=h;t=t+1|0;continue}break}s=s+1|0;continue}break}z=zc(f,a,3840);F=d<<5;s=0;while(1){if((c|0)>(s|0)){i=fb-32|0;fb=i;o=z+(s<<8)|0;t=(s<<2)+b|0;B[o+4080>>2]=B[t+1152>>2];f=d-1|0;v=t+D(f,2304)|0;B[o+4084>>2]=B[v+1152>>2];B[o+4088>>2]=B[t>>2];B[o+4092>>2]=B[v>>2];B[o+4336>>2]=B[t+1156>>2];B[o+4340>>2]=B[v+1156>>2];B[o+4344>>2]=B[t+4>>2];B[o+4348>>2]=B[v+4>>2];x=(D(s,F)<<1)+e|0;y=x+(f<<1)|0;St(y,d,o+244|0);f=d<<6;St(f+y|0,d,o+500|0);St(x,d,o+240|0);St(f+x|0,d,o+496|0);G=o+3840|0;p=14;n=87552;while(1){if((p|0)>=0){g=p<<4;k=g+G|0;f=D(31-p|0,72);B[k>>2]=B[f+t>>2];B[k+4>>2]=B[f+v>>2];f=f|4;B[k+8>>2]=B[f+t>>2];B[k+12>>2]=B[f+v>>2];f=D(p,72);q=f+76|0;B[k+256>>2]=B[q+t>>2];B[k+260>>2]=B[q+v>>2];f=f+72|0;B[k-248>>2]=B[f+t>>2];B[k-244>>2]=B[f+v>>2];q=g+o|0;j=B[n+4>>2];h=B[n>>2];f=0;while(1){if((f|0)!=4){g=f<<2;l=B[g+k>>2];m=B[g+q>>2];B[g+(i+16|0)>>2]=E(l*h)-E(j*m);B[i+g>>2]=E(l*j)+E(h*m);f=f+1|0;continue}break}q=k-3584|0;u=k-256|0;j=B[n+12>>2];h=B[n+8>>2];f=0;while(1){if((f|0)!=4){g=f<<2;r=g+i|0;l=B[g+u>>2];m=B[g+q>>2];B[r>>2]=B[r>>2]+E(E(l*j)+E(h*m));g=g+(i+16|0)|0;B[g>>2]=E(E(m*j)-E(h*l))+B[g>>2];f=f+1|0;continue}break}q=k-3328|0;u=k-512|0;j=B[n+20>>2];h=B[n+16>>2];f=0;while(1){if((f|0)!=4){g=f<<2;r=g+i|0;l=B[g+u>>2];m=B[g+q>>2];B[r>>2]=B[r>>2]+E(E(l*j)+E(h*m));g=g+(i+16|0)|0;B[g>>2]=E(E(l*h)-E(j*m))+B[g>>2];f=f+1|0;continue}break}q=k-3072|0;u=k-768|0;j=B[n+28>>2];h=B[n+24>>2];f=0;while(1){if((f|0)!=4){g=f<<2;r=g+i|0;l=B[g+u>>2];m=B[g+q>>2];B[r>>2]=B[r>>2]+E(E(l*j)+E(h*m));g=g+(i+16|0)|0;B[g>>2]=E(E(m*j)-E(h*l))+B[g>>2];f=f+1|0;continue}break}q=k-2816|0;u=k-1024|0;j=B[n+36>>2];h=B[n+32>>2];f=0;while(1){if((f|0)!=4){g=f<<2;r=g+i|0;l=B[g+u>>2];m=B[g+q>>2];B[r>>2]=B[r>>2]+E(E(l*j)+E(h*m));g=g+(i+16|0)|0;B[g>>2]=E(E(l*h)-E(j*m))+B[g>>2];f=f+1|0;continue}break}q=k-2560|0;u=k-1280|0;j=B[n+44>>2];h=B[n+40>>2];f=0;while(1){if((f|0)!=4){g=f<<2;r=g+i|0;l=B[g+u>>2];m=B[g+q>>2];B[r>>2]=B[r>>2]+E(E(l*j)+E(h*m));g=g+(i+16|0)|0;B[g>>2]=E(E(m*j)-E(h*l))+B[g>>2];f=f+1|0;continue}break}q=k-2304|0;u=k-1536|0;j=B[n+52>>2];h=B[n+48>>2];f=0;while(1){if((f|0)!=4){g=f<<2;r=g+i|0;l=B[g+u>>2];m=B[g+q>>2];B[r>>2]=B[r>>2]+E(E(l*j)+E(h*m));g=g+(i+16|0)|0;B[g>>2]=E(E(l*h)-E(j*m))+B[g>>2];f=f+1|0;continue}break}g=k-2048|0;q=k-1792|0;j=B[n+60>>2];h=B[n+56>>2];f=0;while(1){if((f|0)!=4){k=f<<2;u=k+i|0;l=B[k+q>>2];m=B[g+k>>2];B[u>>2]=B[u>>2]+E(E(l*j)+E(h*m));k=k+(i+16|0)|0;B[k>>2]=E(E(m*j)-E(h*l))+B[k>>2];f=f+1|0;continue}break}f=D(15-p|0,d)<<1;P=f+y|0,Q=uj(B[i+20>>2]),w[P>>1]=Q;k=D(p+17|0,d)<<1;P=k+y|0,Q=uj(B[i+4>>2]),w[P>>1]=Q;P=f+x|0,Q=uj(B[i+16>>2]),w[P>>1]=Q;P=k+x|0,Q=uj(B[i>>2]),w[P>>1]=Q;f=D(47-p|0,d)<<1;P=f+y|0,Q=uj(B[i+28>>2]),w[P>>1]=Q;k=D(p+49|0,d)<<1;P=k+y|0,Q=uj(B[i+12>>2]),w[P>>1]=Q;P=f+x|0,Q=uj(B[i+24>>2]),w[P>>1]=Q;P=k+x|0,Q=uj(B[i+8>>2]),w[P>>1]=Q;p=p-1|0;n=n- -64|0;continue}break}fb=i+32|0;s=s+2|0;continue}break}b=z+(c<<8)|0;a:{if((d|0)==1){s=0;while(1){if(s>>>0>959){break a}c=s<<2;B[c+a>>2]=B[b+c>>2];s=s+2|0;continue}}zc(a,b,3840)}}function Tsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;f=fb-272|0;fb=f;yc(b);e=fb-16|0;fb=e;g=f+66|0;t_(e+8|0,g);i=x[e+12>>2];lc(e,x[b>>2],x[b+8>>2],x[e+8>>2],x[e+12>>2]);j=x[e+4>>2];if((j|0)==(i|0)){Vb(b,x[e+12>>2])}fb=e+16|0;e=(i|0)==(j|0);if(!e){s_(g)}a:{if(!e){break a}if(!v_(g)){break a}if(!Mb(x[b>>2],x[b+8>>2],Bc(u_(g),hb))){break a}d=1;if((c|0)==64){break a}Dd(a,16777216);eg(a);x[a+480208>>2]=x[a+480208>>2]|16777216;d=f+44|0;rr(d,32);g=x[f+56>>2];e=a+1074320|0;x[e>>2]=x[f+52>>2];x[e+4>>2]=g;e=x[f+48>>2];x[a+1074312>>2]=x[f+44>>2];x[a+1074316>>2]=e;Lb(a+1074312|0,114,1);r=a,s=Bb(y[f+266|0]|y[f+267|0]<<8),w[r+480188>>1]=s;Wh(a,1);e=uc(d,8557);zb(a+1298368|0,e);tb(e);e=f+24|0;gg(e,3924);x[31609]=0;S(370,d|0,e|0,y[f+69|0]);g=x[31609];x[31609]=0;b:{c:{d:{e:{if((g|0)!=1){zb(a+1298344|0,d);tb(d);Eb(e);g=uc(d,10805);zb(a+1298356|0,g);tb(g);r=a+1298404|0,s=x[Fc(d,26)>>2],x[r>>2]=s;Te(e,3,f+70|0);Cc(d,e);zb(a+1298308|0,d);tb(d);e=160;while(1){f:{d=e;if(!d){d=0;break f}e=d-1|0;if(y[(f+e|0)+102|0]==32){continue}}break}r_(a+1298332|0,f+102|0,d,4);d=Bb(y[f+262|0]|y[f+263|0]<<8);w[a+480190>>1]=d;i=1;while(1){g:{e=d&65535;d=i&65535;if(e>>>0<d>>>0){e=a+484376|0;$e(Xb(x[a+484360>>2],y[e|0]),Bb(y[f+270|0]|y[f+271|0]<<8));d=f+24|0;he(d,b,512);j=hc(f+44|0,d);ub(d);d=y[e|0];e=x[a+484360>>2];g=y[f+268|0]|y[f+269|0]<<8;x[31609]=0;S(276,Xb(e,d)|0,j|0,Bb(g)|0);d=x[31609];x[31609]=0;if((d|0)!=1){break g}d=N()|0;break d}j=D(d,104)+a|0;m=j+484380|0;nd(m,1);fp(m);L$(b,((d<<5)+a|0)+946304|0,y[f+69|0]==1?32:28);n=1;d=y[f+69|0];if(d>>>0>=3){Vb(b,14);d=ND(b);if((d|0)>=0){e=j+484414|0;w[e>>1]=z[e>>1]|32;r=j+484408|0,s=Bc((((d&65535)<<8)+2047>>>0)/4095|0,0),w[r>>1]=s}d=y[f+69|0]}if((d&255)>>>0>=2){n=Qk(b);r=j+484404|0,s=Qk(b),x[r>>2]=s}e=f+44|0;g=fb-16|0;fb=g;h:{if(!Mb(x[b>>2],x[b+8>>2],12)){x[g>>2]=0;d=e;h=3;while(1){if(h){l=y[g|0]|y[g+1|0]<<8|(y[g+2|0]<<16|y[g+3|0]<<24);v[d|0]=l;v[d+1|0]=l>>>8;v[d+2|0]=l>>>16;v[d+3|0]=l>>>24;h=h-1|0;d=d+4|0;continue}break}break h}yr(g+8|0,e);sd(g,b,x[g+8>>2],x[g+12>>2])}fb=g+16|0;g=gc(e);d=Ab(e);h=$b(x[f+44>>2]);x[m>>2]=h;l=j+484384|0;e=$b(y[g|0]|y[g+1|0]<<8|(y[g+2|0]<<16|y[g+3|0]<<24));x[l>>2]=e;k=j+484388|0;o=$b(y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24))+e|0;x[k>>2]=o;g=j+484414|0;i:{j:{if(!e){if($b(y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24))>>>0<3){break j}}d=z[g>>1]|2;break i}d=z[g>>1]&-3}w[g>>1]=d;if((n|0)==2){w[g>>1]=d|1;x[m>>2]=h>>>1;x[l>>2]=e>>>1;x[k>>2]=o>>>1}r=j+484410|0,s=Qk(b),w[r>>1]=s;d=ND(b);if(d){$l(m,+(d|0)/96)}v[j+484417|0]=d<<4;i=i+1|0;d=z[a+480190>>1];continue}break}d=wb(x[Xb(x[a+484360>>2],y[a+484376|0])>>2]);g=wb(x[Xb(x[a+484360>>2],y[a+484376|0])+4>>2]);e=fb-16|0;fb=e;k:{if(!Ib(d,g)){break k}x[e+12>>2]=d;while(1){i=x[ge(e+12|0)>>2];if(!Ib(i,g)){break k}d=Zk(z[d>>1],z[i>>1])?i:d;continue}}fb=e+16|0;d=z[d>>1];x[31609]=0;l=a+484344|0;o=d+1&65535;O(223,l|0,o|0);d=x[31609];x[31609]=0;if((d|0)==1){break e}d=y[f+69|0];x[f+20>>2]=x[a+480204>>2];x[f+16>>2]=x[a+480196>>2];n=d>>>0<4?4:5;q=c&1;i=0;while(1){if((i|0)==(o|0)){if(!(c&2)){break b}d=1;while(1){c=d&65535;if(c>>>0>z[a+480190>>1]){break b}c=D(c,104)+a|0;e=Zc(f+8|0,w[c+484414>>1]&1?16:8,1,1,0);x[31609]=0;U(215,e|0,c+484380|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){d=d+1|0;continue}break}d=N()|0;break d}l:{if(!q){break l}d=y[f+264|0]|y[f+265|0]<<8;e=x[b+8>>2];g=x[b>>2];h=z[a+480188>>1];x[31609]=0;d=U(150,g|0,e|0,D(h,D(Bb(d),n))|0)|0;e=x[31609];x[31609]=0;m:{n:{if((e|0)==1){break n}if(!d){break l}d=y[f+264|0]|y[f+265|0]<<8;x[31609]=0;d=U(196,l|0,i&65535,Bb(d)|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break n}if(!d){break l}d=z[a+480188>>1];v[f|0]=0;e=ee(f+8|0,0,f);x[31609]=0;m=U(371,f+24|0,d|0,e|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break m}e=0;o:while(1){if(Bb(y[f+264|0]|y[f+265|0]<<8)>>>0<=e>>>0){od(m);break l}d=Wb(x[l>>2],i);af(f+8|0,x[d>>2],x[x[d+48>>2]+12>>2],e);d=0;while(1){if(z[a+480188>>1]<=d>>>0){e=e+1|0;continue o}g=Yc(x[f+8>>2],d);v[f+4|0]=0;x[31609]=0;x[f>>2]=0;S(372,b|0,f|0,n|0);h=x[31609];x[31609]=0;p:{if((h|0)==1){break p}h=x[m>>2];k=y[f|0];if((k-24&255)>>>0<=59){k=k+13|0;v[g|0]=k;r=bc(h,d),s=k,v[r|0]=s}k=y[f+1|0];q:{if(!k){h=bc(h,d);break q}v[g+1|0]=k;h=bc(h,d);v[h+1|0]=k}k=y[h+1|0];h=y[h|0];x[31609]=0;ya(373,a|0,g|0,y[f+2|0],y[f+3|0],0-y[f+69|0]|0,h|0,k|0,f+20|0,f+16|0);h=x[31609];x[31609]=0;if((h|0)==1){break p}h=y[f+4|0];if(h){v[g+2|0]=1;v[g+4|0]=h+1>>>2}d=d+1|0;continue}break}break}d=N()|0;od(m);break d}d=N()|0;break d}d=N()|0;break d}i=i+1|0;continue}}d=N()|0;Eb(f+24|0);break c}d=N()|0}ub(j)}Q(d|0);p()}ub(j);d=1}fb=f+272|0;return d|0}function Xna(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,A=0,B=0;h=fb-176|0;fb=h;yc(b);a:{d=h+128|0;if(!SD(b,d)){break a}if(!OV(d)){break a}g=1;if((c|0)==64){break a}g=0;if(!Mb(x[b>>2],x[b+8>>2],Bc(NV(y[h+175|0]),hb))){break a}Dd(a,128);g=h+112|0;Te(g,2,h+143|0);d=h+32|0;Cc(d,g);zb(a+1298308|0,d);tb(d);x[h+124>>2]=14993;x[h+120>>2]=15050;x[h+116>>2]=15079;x[h+112>>2]=15078;g=uc(d,8453);zb(a+1298344|0,g);tb(g);g=uc(d,6056);zb(a+1298356|0,g);tb(g);g=uc(h+100|0,18188);x[31609]=0;S(756,d|0,g|0,x[((y[h+142|0]<<2)+h|0)-84>>2]);e=x[31609];x[31609]=0;b:{if((e|0)!=1){zb(a+1298368|0,d);tb(d);tb(g);A=a+1298404|0,B=x[Fc(d,4)>>2],x[A>>2]=B;x[a+480208>>2]=12;lE(a+1298332|0,b,y[h+175|0]<<5,32,0);i=Zd(b);w[a+480190>>1]=i;g=1;while(1){k=g&65535;if(k>>>0>(i&65535)>>>0){ak(Xb(x[a+484360>>2],y[a+484376|0]),b,256,255,254);g=0;d=Zd(b);if(d>>>0>=127){break a}w[a+480188>>1]=d+1&255;d=Zd(b);while(1)if(z[a+480188>>1]<=g>>>0){o=a+484344|0;r=d+1|0;Tf(o,r);g=0;while(1){e=g&65535;if(e>>>0>d>>>0){c:while(1){t=s&65535;g=z[a+480188>>1];if(t>>>0>=g>>>0){d=So(h);v[d+16|0]=0;w[d+14>>1]=0;w[d+12>>1]=g;x[31609]=0;O(758,d|0,g|0);g=x[31609];x[31609]=0;if((g|0)==1){a=N()|0;tf(d);Q(a|0);p()}x[31609]=0;O(757,o|0,d|0);e=x[31609];x[31609]=0;g=1;if((e|0)!=1){tf(d);if(!(c&2)){break a}while(1){c=g&65535;if(c>>>0>z[a+480190>>1]){g=1;break a}else{c=D(c,104)+a|0;dg(Zc(h+32|0,w[c+484414>>1]&1?16:8,1,0,0),c+484380|0,b);g=g+1|0;continue}}}i=N()|0;tf(d);break b}m=0;e=Ng(h+32|0);d:while(1){e:{if((m|0)!=(r|0)){if(Mb(x[b>>2],x[b+8>>2],5)){break e}}s=s+1|0;continue c}i=0;d=Wb(x[o>>2],m);g=md(x[d>>2],x[x[d+48>>2]+12>>2],0,t);while(1){f:{g:{if(i>>>0>63){break g}j=y[h+142|0];f=fb-16|0;fb=f;q=1;d=Zd(b);if((d|0)==252){q=Zd(b);d=Zd(b)}v[e|0]=(d-1&255)>>>0<60?d+36|0:0;d=f+12|0;mm(d,b);k=Jc(d);l=_e(d);d=_i(d);v[e+1|0]=y[f+12|0];n=f+10|0;u=y[k|0];LV(n,u&15,y[l|0],j);k=Jc(n);l=f+8|0;LV(l,u>>>4|0,y[d|0],j);j=Jc(l);l=y[f+10|0];n=(l|0)!=10;d=y[f+8|0];h:{if(!(n|(d|0)!=10)){k=y[k|0];d=y[j|0];v[e+3|0]=10;k=k|d<<8;v[e+5|0]=k>>>6;if(k>>>0<16384){break h}v[e+2|0]=15;v[e+4|0]=d>>>6;break h}i:{j:{k:{l:{m:{if(!n){l=y[k|0];n=l<<2;A=k,B=ti(n),v[A|0]=B;if(l>>>0<64){break m}if(si(d)>>>0>=si(10)>>>0){break l}v[e+5|0]=n;v[e+2|0]=15;v[e+3|0]=10;v[e+4|0]=l>>>6;break h}if((d|0)==10){d=y[j|0];l=d<<2;A=j,B=ti(l),v[A|0]=B;if(d>>>0<64){break m}if(si(y[f+10|0])>>>0>=si(10)>>>0){break m}v[e+5|0]=l;v[e+2|0]=15;v[e+3|0]=10;v[e+4|0]=d>>>6;break h}if((d|0)!=(l|0)){break m}v[f+8|0]=0;break k}d=y[f+8|0]}if((d|0)==13){break j}if(d){break i}l=y[f+10|0]}if((l|0)==13){break i}}rg(f+10|0,f+8|0);rg(k,j)}JE(f+8|0,j,f+10|0,k);gm(f+6|0,e,y[f+10|0],y[k|0],y[f+8|0],y[j|0])}fb=f+16|0;f=i+q|0;i=f>>>0>64?64-i|0:q;if(!i){break g}while(1){if(!i){break f}d=y[e|0]|y[e+1|0]<<8|(y[e+2|0]<<16|y[e+3|0]<<24);v[g|0]=d;v[g+1|0]=d>>>8;v[g+2|0]=d>>>16;v[g+3|0]=d>>>24;d=y[e+4|0]|y[e+5|0]<<8;v[g+4|0]=d;v[g+5|0]=d>>>8;i=i-1|0;g=D(z[a+480188>>1],6)+g|0;continue}}m=m+1|0;continue d}i=f>>>0>=64?64:f;continue}}}}g=g+1|0;if(Pg(o,e,64)){continue}break}g=0;break a}else{e=(g<<5)+a|0;Ue(e+480280|0);f=e+480284|0;n:{if(y[h+142|0]>=51){e=(Zd(b)<<4|8)&248;break n}e=g&1?192:64}w[f>>1]=e;g=g+1|0;continue}}else{o:{if(y[h+142|0]>=52){d=h+32|0;if(!t$(b,d)){oE(d)}break o}f=h+32|0;d=fb-32|0;fb=d;x[d+28>>2]=64;x[d+8>>2]=66;i=x[b>>2];j=x[b+8>>2];e=x[Hb(d+28|0,d+8|0)>>2];if(!Mb(i,j,e)){e=jf(b)}i=d+8|0;lw(i,f);j=Zb(d+16|0,x[d+8>>2],e);m=x[j>>2];lc(d,x[b>>2],x[b+8>>2],m,x[j+4>>2]);lw(i,f);Rb(x[d+8>>2]+e|0,0,66-e|0);Vb(b,x[d+28>>2]);fb=d+32|0;d=y[h+94|0]|y[h+95|0]<<8;v[h+96|0]=d;v[h+97|0]=d>>>8;v[h+94|0]=171;v[h+95|0]=32}i=fb-32|0;fb=i;f=(D(k,104)+a|0)+484380|0;nd(f,0);fp(f);j=i+8|0;e=h+32|0;Mk(j,2,e+32|0);d=i+20|0;Cc(d,j);Be(f+43|0,d);tb(d);j=y[e+56|0]|y[e+57|0]<<8|(y[e+58|0]<<16|y[e+59|0]<<24);m=y[e+52|0]|y[e+53|0]<<8|(y[e+54|0]<<16|y[e+55|0]<<24);p:{if(j>>>0<=m>>>0){break p}x[f>>2]=j-m;x[f+12>>2]=y[e+44|0]|y[e+45|0]<<8|(y[e+46|0]<<16|y[e+47|0]<<24);x[i+20>>2]=y[e+48|0]|y[e+49|0]<<8|(y[e+50|0]<<16|y[e+51|0]<<24);A=f,B=x[Hb(d,f)>>2],x[A+16>>2]=B;w[f+30>>1]=y[e+60|0];x[f+24>>2]=y[e+62|0]|y[e+63|0]<<8;d=y[e+64|0]|y[e+65|0]<<8;if(d){$l(f,+(d<<16>>16)/393216)}d=y[e+61|0];if(d&8){w[f+34>>1]=z[f+34>>1]|8;d=y[e+61|0]}if(d&16){w[f+34>>1]=z[f+34>>1]|16;d=y[e+61|0]}if(!(d&4)){break p}w[f+34>>1]=z[f+34>>1]|1;x[f+12>>2]=x[f+12>>2]>>>1;x[f+16>>2]=x[f+16>>2]>>>1}fb=i+32|0;f=h+20|0;Te(f,2,e);d=h+100|0;Cc(d,f);Ac(((k<<5)+a|0)+946304|0,d);g=g+1|0;tb(d);i=z[a+480190>>1];continue}}}i=N()|0;tb(g)}Q(i|0);p()}fb=h+176|0;return g|0}function koa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;e=fb-112|0;fb=e;yc(c);a:{b:{c:{d:{if(!gp(c,e+100|0)|(y[e+100|0]|y[e+101|0]<<8|(y[e+102|0]<<16|y[e+103|0]<<24))!=1297239878){break d}d=y[e+108|0]|y[e+109|0]<<8|(y[e+110|0]<<16|y[e+111|0]<<24);if(!((d|0)==1482052408|(d|0)==1448293937)&(d|0)!=1146437965){break d}d=fb-32|0;fb=d;f=e+88|0;l=Nb(f);e:{f:{g:{h:{i:{while(1){j=x[c+8>>2];g=x[c>>2];x[31609]=0;j=U(150,g|0,j|0,8)|0;g=x[31609];x[31609]=0;if((g|0)==1){break g}if(!j){break h}x[31609]=0;j=d+4|0;O(829,j|0,c|0);g=x[31609];x[31609]=0;if((g|0)!=1){x[31609]=0;O(830,l|0,j|0);g=x[31609];x[31609]=0;if((g|0)==1){break i}Hd(j);continue}break}a=N()|0;break f}a=N()|0;Hd(d+4|0);break f}fb=d+32|0;break e}a=N()|0}ke(l);Q(a|0);p()}x[31609]=0;j=R(168,e+68|0)|0;c=x[31609];x[31609]=0;j:{k:{l:{m:{n:{o:{p:{if((c|0)!=1){l=Zc(e- -64|0,8,1,1,0);if((y[e+108|0]|y[e+109|0]<<8|(y[e+110|0]<<16|y[e+111|0]<<24))!=1146437965){break n}x[31609]=0;d=e+44|0;S(741,d|0,f|0,1296581714);c=x[31609];x[31609]=0;if((c|0)==1){break m}x[31609]=0;c=e+24|0;S(741,c|0,f|0,1296318804);f=x[31609];x[31609]=0;if((f|0)==1){break l}f=kd(j,c);ub(c);c=0;x[31609]=0;i=R(742,d|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break l}h=0;if(!i){break o}f=x[f>>2];x[31609]=0;f=R(172,f|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break l}if(!f){break o}x[31609]=0;h=R(281,d|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break l}x[31609]=0;i=R(273,d|0)|0;c=x[31609];x[31609]=0;q:{if((c|0)==1){break q}x[31609]=0;P(183,d|0,2)|0;c=x[31609];x[31609]=0;if((c|0)==1){break q}x[31609]=0;c=R(281,d|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break p}}break l}f=N()|0;break a}x[31609]=0;f=e+24|0;O(653,f|0,e+44|0);d=x[31609];x[31609]=0;if((d|0)==1){break l}d=j_(f);g=Bb(z[e+24>>1]);if(!g){break o}c=(c>>>0)/(g>>>0)|0;g=gc(f);f=_e(f);g=Bb(y[g|0]|y[g+1|0]<<8);if((g|0)!=(Bb(y[f|0]|y[f+1|0]<<8)+1|0)){break o}if((g|0)==2){vp(l,2)}r:{if((i|0)!=16){if((i|0)!=8){break o}s:{switch(Bb(y[d|0]|y[d+1|0]<<8)|0){case 0:k=1;wg(l,1);break o;case 2:wg(l,17);break r;case 3:break s;default:break o}}wg(l,16);break r}if(Bb(y[d|0]|y[d+1|0]<<8)){break o}hd(l,16)}k=1}ub(e+44|0);d=0;i=0;f=0;if(!k){break j}break k}x[31609]=0;o=e+44|0;c=e+88|0;S(741,o|0,c|0,1447576658);d=x[31609];x[31609]=0;t:{u:{v:{if((d|0)!=1){x[31609]=0;r=e+24|0;S(741,r|0,c|0,1128808782);d=x[31609];x[31609]=0;if((d|0)==1){break v}x[31609]=0;g=e+4|0;S(741,g|0,c|0,1112491097);c=x[31609];x[31609]=0;if((c|0)==1){break u}q=kd(j,g);ub(g);c=x[q>>2];x[31609]=0;d=R(172,c|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break u}f=0;c=0;m=0;w:{if(!d){break w}x[31609]=0;d=R(172,x[e+44>>2])|0;c=x[31609];x[31609]=0;if((c|0)==1){break u}c=0;m=0;if(!d){break w}x[31609]=0;g=P(743,o|0,g|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break u}c=0;m=0;if(!g){break w}d=y[e+108|0]|y[e+109|0]<<8|(y[e+110|0]<<16|y[e+111|0]<<24);x[31609]=0;c=R(281,r|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break u}i=(d|0)!=1482052408;if(i){hd(l,16)}if((c|0)==6){vp(l,3)}g=$b(x[e+4>>2]);d=x[e+8>>2];k=x[e+12>>2];h=$b(k);x:{if(h>>>0<33){break x}n=$b(d);if(n>>>0<=h>>>0){break x}d=(n>>>0)%(h>>>0)|0?d:k}h=x[q>>2];x[31609]=0;n=x[e+20>>2];q=z[e+16>>1];h=R(154,h|0)|0;o=x[31609];x[31609]=0;k=1;if((o|0)==1){break u}m=g;g=i+((c|0)==6)|0;i=m>>>g|0;h=h>>>g|0;n=$b(n);c=Bb(q);m=$b(d)>>>g|0}d=m;ub(e+24|0);ub(e+44|0);if(k){break k}break j}f=N()|0;break b}f=N()|0;break t}f=N()|0;ub(e+24|0)}ub(e+44|0);break b}f=N()|0;break b}f=N()|0;ub(e+44|0);break b}Wu(a,b);x[31609]=0;f=D(b,104)+a|0;k=f+484380|0;O(279,k|0,0);g=x[31609];x[31609]=0;y:{if((g|0)!=1){x[k>>2]=h;d=d+i|0;x[f+484388>>2]=d;x[f+484384>>2]=i;if(!(d>>>0<=i+4>>>0|d>>>0>h>>>0)){d=f+484414|0;w[d>>1]=z[d>>1]|2}d=D(b,104)+a|0;x[d+484404>>2]=c>>>0<2?22050:c;g=d+484410|0;c=n+128|0;d=c>>>8|0;w[g>>1]=(c&16776960)>>>0>65536?256:d&65535?d:256;eC(k,x[a+480180>>2]);x[31609]=0;c=e+44|0;S(741,c|0,e+88|0,1312902469);d=x[31609];x[31609]=0;if((d|0)==1){break y}x[31609]=0;d=R(172,x[e+44>>2])|0;f=x[31609];x[31609]=0;if((f|0)==1){break c}z:{A:{if(d){x[31609]=0;d=R(154,x[e+44>>2])|0;f=x[31609];x[31609]=0;if((f|0)==1){break c}x[31609]=0;S(331,c|0,((b<<5)+a|0)+946304|0,d|0);b=x[31609];x[31609]=0;if((b|0)!=1){break A}break c}x[31609]=0;c=P(36,e+24|0,22292)|0;d=x[31609];x[31609]=0;if((d|0)==1){break z}Ac(((b<<5)+a|0)+946304|0,c);tb(c)}x[31609]=0;U(215,l|0,k|0,j|0)|0;b=x[31609];x[31609]=0;f=1;if((b|0)==1){break c}Jj(k,a);ub(e+44|0);break j}break c}f=N()|0;break b}f=N()|0;break b}ub(j);ke(e+88|0)}fb=e+112|0;return f|0}f=N()|0;ub(e+44|0)}ub(j)}ke(e+88|0);Q(f|0);p()}function Xd(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=fb-96|0;fb=k;u=i&65535;o=(e^i)&-2147483648;r=e&65535;z=r;R=i>>>16&32767;S=e>>>16&32767;a:{b:{if(R-32767>>>0>4294934529&S-32767>>>0>=4294934530){break b}s=e&2147483647;q=s;j=d;if(!(!d&(q|0)==2147418112?!(b|c):q>>>0<2147418112)){m=d;o=e|32768;break a}s=i&2147483647;p=s;e=h;if(!(!e&(p|0)==2147418112?!(f|g):p>>>0<2147418112)){m=e;o=i|32768;b=f;c=g;break a}if(!(b|j|(q^2147418112|c))){if(!(e|f|(g|p))){o=2147450880;b=0;c=0;break a}o=o|2147418112;b=0;c=0;break a}if(!(e|f|(p^2147418112|g))){e=b|j;d=c|q;b=0;c=0;if(!(d|e)){o=2147450880;break a}o=o|2147418112;break a}if(!(b|j|(c|q))){b=0;c=0;break a}if(!(e|f|(g|p))){b=0;c=0;break a}if((q|0)==65535|q>>>0<65535){j=!(d|r);i=j?b:d;s=j<<6;e=G(i)+32|0;i=G(j?c:r);i=s+((i|0)==32?e:i)|0;$f(k+80|0,b,c,d,r,i-15|0);t=16-i|0;d=x[k+88>>2];z=x[k+92>>2];c=x[k+84>>2];b=x[k+80>>2]}if(p>>>0>65535){break b}i=!(h|u);e=i?f:h;r=i<<6;j=G(e)+32|0;e=G(i?g:u);e=r+((e|0)==32?j:e)|0;$f(k- -64|0,f,g,h,u,e-15|0);t=(t-e|0)+16|0;h=x[k+72>>2];u=x[k+76>>2];f=x[k+64>>2];g=x[k+68>>2]}e=f;f=g<<15|f>>>17;i=e<<15;e=0;v=i&-32768;L=c;s=Iua(v,e,c,0);e=hb;A=e;M=f;q=b;c=Iua(f,0,b,0);b=c+s|0;f=hb+e|0;i=b;c=b>>>0<c>>>0?f+1|0:f;f=b;j=0;b=Iua(q,l,v,l);p=j+b|0;e=hb+f|0;e=b>>>0>p>>>0?e+1|0:e;r=e;N=(f|0)==(e|0)&j>>>0>p>>>0|e>>>0<f>>>0;O=d;w=Iua(v,l,d,0);P=hb;b=Iua(L,l,M,l);y=b+w|0;j=hb+P|0;j=b>>>0>y>>>0?j+1|0:j;b=u<<15|h>>>17;B=h<<15|g>>>17;d=Iua(B,0,q,l);C=d+y|0;f=hb+j|0;f=d>>>0>C>>>0?f+1|0:f;D=f;d=(c|0)==(A|0)&i>>>0<s>>>0|c>>>0<A>>>0;E=c+C|0;f=d+f|0;f=c>>>0>E>>>0?f+1|0:f;u=f;g=E;c=f;F=z|65536;z=Iua(v,l,F,n);Q=hb;d=Iua(O,m,M,l);H=d+z|0;e=hb+Q|0;e=d>>>0>H>>>0?e+1|0:e;i=e;I=b|-2147483648;b=Iua(I,0,q,l);J=b+H|0;f=hb+e|0;f=b>>>0>J>>>0?f+1|0:f;d=Iua(B,m,L,l);b=d+J|0;K=f;f=f+hb|0;A=b;s=b>>>0<d>>>0?f+1|0:f;f=b;b=0;q=b+g|0;e=c+f|0;e=b>>>0>q>>>0?e+1|0:e;v=e;f=e;b=q+N|0;c=b>>>0<q>>>0?f+1|0:f;t=((S+R|0)+t|0)-16383|0;d=Iua(I,m,L,l);h=hb;e=Iua(F,m,M,l);g=e+d|0;f=hb+h|0;f=e>>>0>g>>>0?f+1|0:f;n=(h|0)==(f|0)&d>>>0>g>>>0|f>>>0<h>>>0;h=f;e=Iua(B,m,O,m);d=e+g|0;f=hb+f|0;f=d>>>0<e>>>0?f+1|0:f;e=f;g=(f|0)==(h|0)&d>>>0<g>>>0|f>>>0<h>>>0;f=0;h=g;g=g+n|0;f=h>>>0>g>>>0?1:f;h=g;g=Iua(I,m,F,m);h=h+g|0;f=hb+f|0;N=h;g=g>>>0>h>>>0?f+1|0:f;h=d;l=e;e=(j|0)==(P|0)&w>>>0>y>>>0|j>>>0<P>>>0;f=0;j=(j|0)==(D|0)&y>>>0>C>>>0|j>>>0>D>>>0;n=j;j=e+j|0;e=(n>>>0>j>>>0?1:f)+l|0;f=g;d=d+j|0;e=d>>>0<j>>>0?e+1|0:e;n=e;w=d;d=(e|0)==(l|0)&d>>>0<h>>>0|e>>>0<l>>>0;e=d;d=d+N|0;f=e>>>0>d>>>0?f+1|0:f;j=d;h=f;e=Iua(B,m,F,m);l=hb;g=Iua(I,m,O,m);d=g+e|0;f=hb+l|0;f=d>>>0<g>>>0?f+1|0:f;g=f;f=(l|0)==(f|0)&d>>>0<e>>>0|f>>>0<l>>>0;y=g+j|0;e=f+h|0;e=g>>>0>y>>>0?e+1|0:e;l=y;h=e;j=d;e=0;d=e+w|0;f=j+n|0;f=d>>>0<e>>>0?f+1|0:f;e=f;g=(n|0)==(f|0)&d>>>0<w>>>0|f>>>0<n>>>0;f=h;h=g;g=g+l|0;f=h>>>0>g>>>0?f+1|0:f;w=g;g=f;h=d;j=e;e=(s|0)==(K|0)&A>>>0<J>>>0|s>>>0<K>>>0;d=(i|0)==(Q|0)&z>>>0>H>>>0|i>>>0<Q>>>0;i=(i|0)==(K|0)&H>>>0>J>>>0|i>>>0>K>>>0;d=d+i|0;d=d+e|0;n=s;i=n+h|0;e=d+j|0;f=g;d=i;e=d>>>0<n>>>0?e+1|0:e;h=(e|0)==(j|0)&h>>>0>d>>>0|e>>>0<j>>>0;g=h+w|0;f=h>>>0>g>>>0?f+1|0:f;j=g;g=f;h=d;f=0;i=e;n=(u|0)==(v|0)&q>>>0<E>>>0|u>>>0>v>>>0;l=n;n=n+((u|0)==(D|0)&C>>>0>E>>>0|u>>>0<D>>>0)|0;e=e+(l>>>0>n>>>0?1:f)|0;f=g;d=d+n|0;e=d>>>0<n>>>0?e+1|0:e;h=(e|0)==(i|0)&d>>>0<h>>>0|e>>>0<i>>>0;g=h;h=h+j|0;f=g>>>0>h>>>0?f+1|0:f;i=f;c:{if(f&65536){t=t+1|0;break c}j=r>>>31|0;g=0;f=i<<1|h>>>31;h=h<<1|e>>>31;i=f;f=e<<1|d>>>31;d=d<<1|c>>>31;e=f;f=r<<1|p>>>31;p=p<<1;r=f;f=c<<1|b>>>31;b=b<<1|j;c=f|g}if((t|0)>=32767){o=o|2147418112;b=0;c=0;break a}d:{if((t|0)<=0){g=1-t|0;if(g>>>0<=127){f=t+127|0;$f(k+48|0,p,r,b,c,f);$f(k+32|0,d,e,h,i,f);cn(k+16|0,p,r,b,c,g);cn(k,d,e,h,i,g);p=x[k+32>>2]|x[k+16>>2]|(x[k+48>>2]|x[k+56>>2]|(x[k+52>>2]|x[k+60>>2]))!=0;r=x[k+36>>2]|x[k+20>>2];b=x[k+40>>2]|x[k+24>>2];c=x[k+44>>2]|x[k+28>>2];d=x[k>>2];e=x[k+4>>2];g=x[k+8>>2];f=x[k+12>>2];break d}b=0;c=0;break a}g=h;f=i&65535|t<<16}m=g|m;o=f|o;if(!(!b&(c|0)==-2147483648?!(p|r):(c|0)>0|(c|0)>=0)){b=d+1|0;j=b?e:e+1|0;e=o;c=j;d=!(j|b);m=d+m|0;o=d>>>0>m>>>0?e+1|0:e;break a}if(b|p|(c^-2147483648|r)){b=d;c=e;break a}f=e;b=d&1;c=b;b=b+d|0;f=c>>>0>b>>>0?f+1|0:f;c=f;d=(e|0)==(f|0)&b>>>0<d>>>0|e>>>0>f>>>0;f=o;m=d+m|0;o=m>>>0<d>>>0?f+1|0:f}x[a>>2]=b;x[a+4>>2]=c;x[a+8>>2]=m;x[a+12>>2]=o;fb=k+96|0}function wpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;g=fb-128|0;fb=g;yc(b);a:{b:{c:{d:{e:{if(!zX(b,14208)){break e}k=Nb(g+116|0);j=Nb(g+104|0);x[31609]=0;x[g+96>>2]=0;x[g+100>>2]=0;O(246,a|0,32768);d=x[31609];x[31609]=0;if((d|0)==1){break b}x[31609]=0;d=P(1,g+84|0,8169)|0;i=x[31609];x[31609]=0;if((i|0)==1){break c}zb(a+1298344|0,d);tb(d);x[31609]=0;d=P(1,g+72|0,6060)|0;i=x[31609];x[31609]=0;if((i|0)==1){break d}zb(a+1298356|0,d);tb(d);o=a+1298404|0,q=x[Fc(g+44|0,28)>>2],x[o>>2]=q;m=(c|0)==64;i=a+480280|0;while(1){d=x[b+8>>2];f=x[b>>2];x[31609]=0;d=U(150,f|0,d|0,8)|0;f=x[31609];x[31609]=0;f:{g:{h:{if((f|0)!=1){i:{j:{k:{l:{m:{n:{if(!d){break n}x[31609]=0;d=P(652,b|0,g- -64|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break m}if(!d){break n}f=x[g+68>>2];x[31609]=0;d=g+24|0;S(185,d|0,b|0,$b(f)|0);f=x[31609];x[31609]=0;if((f|0)==1){break l}f=hc(g+44|0,d);ub(d);d=x[f>>2];x[31609]=0;d=R(172,d|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break j}if(d){break k}ub(f)}if(z[a+480188>>1]){break i}i=0;break g}a=N()|0;break a}a=N()|0;break a}o:{p:{q:{r:{s:{t:{u:{d=$b(x[g+64>>2]);if((d|0)!=1397769541){if((d|0)==1346458708){break t}if((d|0)==1346522948){break s}if((d|0)==1347175758){break u}if((d|0)!=1396788560){if((d|0)==1396854596){break r}if((d|0)==1397507406){break f}if((d|0)!=1129140036){break p}if(z[a+480188>>1]){break f}d=x[f>>2];x[31609]=0;d=R(154,d|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break j}if(d>>>0<8){break f}d=0;x[31609]=0;O(653,g+24|0,f|0);e=x[31609];x[31609]=0;if((e|0)==1){break j}while(1)if((d|0)==4){if(!m){break f}i=1;break o}else{e=z[a+480188>>1];h=bc(g+24|0,d);v:{if(!Bb(y[h|0]|y[h+1|0]<<8)){h=d-1|0;break v}h=g+96|0;o=xb(h,e),q=1,v[o|0]=q;o=xb(h,z[a+480188>>1]+1|0),q=255,v[o|0]=q;Ue(i+(z[a+480188>>1]<<5)|0);h=z[a+480188>>1];e=h+1|0;w[a+480188>>1]=e;l=i+(h<<5)|0;h=d-1|0;w[l+4>>1]=(h&65535)>>>0<2?192:64}Ue(i+((e&65535)<<5)|0);e=z[a+480188>>1];w[a+480188>>1]=e+1;w[(i+(e<<5)|0)+4>>1]=(h&65535)>>>0<2?192:64;d=d+1|0;continue}}if(z[a+480190>>1]){break f}x[31609]=0;O(654,f|0,a|0);d=x[31609];x[31609]=0;if((d|0)!=1){break f}break j}d=x[f>>2];x[31609]=0;d=R(154,d|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break j}if(d>>>0<2){break f}x[31609]=0;d=R(273,f|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break j}o=a,q=Ld(d,1,255),x[o+480196>>2]=q;break f}d=x[f>>2];x[31609]=0;d=R(154,d|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break j}if(d>>>0<2){break f}x[31609]=0;n=R(273,f|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break f}break j}d=y[a+484376|0];e=x[a+484360>>2];h=x[f>>2];x[31609]=0;h=R(154,h|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break j}x[31609]=0;aa(348,Xb(e,d)|0,f|0,h|0,255,254);d=x[31609];x[31609]=0;if((d|0)==1){break j}break f}d=k;if(Sf(x[d>>2],x[d+4>>2])>>>0>=256){break f}break q}if(Sf(x[j>>2],x[j+4>>2])>>>0>3998){break f}d=x[f>>2];x[31609]=0;e=R(154,d|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break j}d=j;if(!e){break f}}x[31609]=0;O(655,d|0,f|0);d=x[31609];x[31609]=0;if((d|0)!=1){break f}break j}if(!(d&-2139062144)){break f}i=0}ub(f);break g}a=N()|0;ub(f);break a}x[a+480200>>2]=256;x[a+480204>>2]=125e4;x[a+480260>>2]=452;x[a+480264>>2]=3424;x[a+480228>>2]=48;x[a+480232>>2]=48;b=x[a+484360>>2];d=y[a+484376|0];x[31609]=0;O(330,Xb(b,d)|0,n&65535);b=x[31609];x[31609]=0;if((b|0)==1){break b}w:{if(!(c&1)){break w}b=x[k+4>>2];i=x[k>>2];d=0;x[31609]=0;O(223,a+484344|0,Sf(i,b)&65535);b=x[31609];x[31609]=0;if((b|0)==1){break b}while(1){e=x[k>>2];b=d&65535;if(Sf(e,x[k+4>>2])>>>0<=b>>>0){break w}x[31609]=0;i=x[g+100>>2];f=x[g+96>>2];x[g+16>>2]=f;x[g+20>>2]=i;x[g+8>>2]=f;x[g+12>>2]=i;V(656,ch(e,b)|0,b|0,a|0,g+8|0);b=x[31609];x[31609]=0;if((b|0)!=1){d=d+1|0;continue}break}a=N()|0;break a}f=c&2;i=1;d=1;b=0;while(1){if(z[a+480190>>1]<=d>>>0){break g}if(!f|Sf(x[j>>2],x[j+4>>2])>>>0<=b>>>0){break g}c=(D(d,104)+a|0)+484380|0;wp(c);x:{if(x[c>>2]){e=x[ch(x[j>>2],b)>>2];x[31609]=0;e=R(154,e|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break h}xc(c,e);e=Zc(g+44|0,8,1,1,0);h=x[j>>2];x[31609]=0;U(215,e|0,c|0,ch(h,b)|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break x}b=b+1|0}d=d+1|0;continue}break}a=N()|0;break a}a=N()|0;break a}a=N()|0;break a}Rc(j);Rc(k);break e}ub(f);continue}}fb=g+128|0;return i|0}a=N()|0;break a}a=N()|0;break a}a=N()|0}Rc(j);Rc(k);Q(a|0);p()}function NS(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=fb-16|0;fb=h;a:{if(!Tc(d&255)){break a}m=a+1074376|0;g=D(b,872);j=(m+g|0)+616|0;b:{f=z[a+480192>>1];if(!(!(x[a+480180>>2]&17825824)|!f|e)){break b}if(Cj(x[j+656>>2])){break b}c=a+g|0;d=c+1075068|0;if(!x[d>>2]){break a}e=x[c+1075080>>2];if(e&1024){break a}g=c+1075012|0;c=c+1075016|0;if(!(x[g>>2]|x[c>>2])){break a}c:{if(!(e&512)){break c}e=x[a+1298300>>2];if(!Ed(e)){break c}Fj(e,b,0);break a}e=eB(a,b);if((e|0)==65535){break a}i=D(e,872);e=a+1074992|0;a=i+e|0;Fq(a,j);v[a+831|0]=0;v[a+805|0]=0;w[a+786>>1]=b+1;x[a+88>>2]=x[a+88>>2]&-918529;Vo(a+788|0);x[a+696>>2]=0;x[a+88>>2]=x[a+88>>2]|2101248;x[d>>2]=0;x[j>>2]=0;x[j+4>>2]=0;a=e+D(b,872)|0;x[a+92>>2]=0;x[a+96>>2]=0;x[g>>2]=0;x[c>>2]=0;break a}e=D(b,872)+a|0;l=x[e+1075096>>2];c=c>>>0<=f>>>0?c:0;g=x[(c?((c<<2)+a|0)+900380|0:e+1075648|0)>>2];d:{if(!g){break d}k=d-1|0;c=z[bc(g+236|0,k)>>1];f=a+1074312|0;Jb(h+8|0,f,104);e:{if(Gb(x[x[h+8>>2]>>2],x[h+12>>2])){Jb(h,f,34);if(Gb(x[x[h>>2]>>2],x[h+4>>2])){break e}}d=y[xb(g+108|0,k)|0]}if((c-1&65535)>>>0<=3998){l=(D(c,104)+a|0)+484380|0;break d}Jb(h+8|0,f,43);if(!Gb(x[x[h+8>>2]>>2],x[h+12>>2])){break d}if(!Kj(y[g+31|0])){break a}}if(y[e+1075081|0]&4){break a}o=b>>>0<=256?256:b;k=a+1074312|0;p=b+1|0;c=b;f:{g:{while(1){if((c|0)==(o|0)){h:{c=0;if(Cj(x[j+656>>2])){break h}break g}}else{f=(b|0)==(c|0);i:{if(!f&z[a+480188>>1]>c>>>0){break i}e=D(c,872)+a|0;if(!f&z[e+1075778>>1]!=(p|0)){break i}n=e+1075648|0;f=x[n>>2];if(!f){break i}j:{k:{l:{m:{n:{o:{p:{switch(y[f+17|0]-1|0){case 0:if(!d){break i}i=(f|0)==(g|0)&y[e+1075789|0]==(d|0);if(!g){break o}if(i){break l}break i;case 1:if(!l|x[e+1075096>>2]!=(l|0)){break i}if((f|0)==(g|0)){break j}Jb(h+8|0,k,104);if(!Gb(x[x[h+8>>2]>>2],x[h+12>>2])){break j}break i;case 3:break n;case 2:break p;default:break i}}if(g){break m}i=(f|0)==(g|0)}if(i){break j}break i}if(!g){break i}i=y[g+34|0];if(!i){break i}if((i|0)==y[f+34|0]){break k}break i}if((f|0)!=(g|0)){break i}}if(!y[g+34|0]){break j}}if(!y[e+1075789|0]|y[f+18|0]>2){break j}f=e+1075793|0;i=y[f|0];if(!i){break j}Ym(a,c&65535,i|256,0);v[f|0]=0}f=e+1074992|0;q:{r:{switch(y[x[n>>2]+18|0]){case 0:Eo(a,f);x[e+1075680>>2]=0;if(!(y[e+1075081|0]&2)){break q}f=x[a+1298300>>2];if(!Ed(f)){break q}Fj(f,c&65535,1);break q;case 1:Eo(a,f);if(!(y[e+1075081|0]&2)){break q}f=x[a+1298300>>2];if(!Ed(f)){break q}zk(f,c&65535);break q;case 2:break r;default:break q}}i=e+1075080|0;f=x[i>>2];x[i>>2]=f|4096;if(!(f&512)){break q}if(!Ed(x[a+1298300>>2])){break q}Jb(h+8|0,k,105);if(Gb(x[x[h+8>>2]>>2],x[h+12>>2])){break q}zk(x[a+1298300>>2],c&65535)}if(x[e+1075680>>2]){break i}x[e+1075688>>2]=0;e=e+1075080|0;x[e>>2]=x[e>>2]|2101248}c=c+1|0;continue}break}g=D(b,872)+a|0;if(!Tc(y[g+1075789|0])){break g}d=pm(a,m,b,2,1)-1|0;if((d&255)>>>0>249){break g}d=x[$d(a+906300|0,d)>>2];if(!d){break g}e=1;g=y[g+1075793|0];if(!g){break f}c=ib[x[x[d>>2]+104>>2]](d,g,b)|0;break f}e=0}if(!(Oi(x[j+8>>2],x[j+12>>2])|c)){break a}s:{if(!(c&e)){break s}c=D(b,872)+a|0;d=y[c+1075790|0];if(d>>>0>3|(d|0)==1){break s}Ym(a,b,255,0);w[c+1075792>>1]=0}c=eB(a,b);if((c|0)==65535){break a}f=D(c,872);e=f+a|0;d=e+1075080|0;g=e+1074992|0;t:{if(!(y[e+1075081|0]&2)){break t}e=x[a+1298300>>2];if(!Ed(e)){break t}Fj(e,c,1)}l=Fq(g,j);e=x[d>>2];g=e&-917505;x[d>>2]=g;i=a+1074992|0;f=i+f|0;v[f+831|0]=0;m=z[a+480188>>1];v[f+805|0]=0;w[f+786>>1]=b>>>0<m>>>0?b+1|0:0;u:{v:{switch(y[(i+D(b,872)|0)+798|0]){case 2:Eo(a,l);if(!(y[d+1|0]&2)){break u}e=x[a+1298300>>2];if(!Ed(e)){break u}zk(e,b);Jb(h+8|0,k,105);if(!Gb(x[x[h+8>>2]>>2],x[h+12>>2])){break u}UB(x[a+1298300>>2],b,c);break u;case 0:x[(D(c,872)+a|0)+1075688>>2]=0;x[d>>2]=g|4096;if(!(e&512)){break u}e=x[a+1298300>>2];if(!Ed(e)){break u}Fj(e,b,1);break u;case 3:x[d>>2]=g|4096;if(!(e&512)){break u}if(!Ed(x[a+1298300>>2])){break u}Jb(h+8|0,k,105);e=x[a+1298300>>2];if(Gb(x[x[h+8>>2]>>2],x[h+12>>2])){UB(e,b,c);break u}zk(e,b);break u;case 1:break v;default:break u}}if(!(e&512)){break u}e=x[a+1298300>>2];if(!Ed(e)){break u}UB(e,b,c)}c=D(c,872)+a|0;if(!x[c+1075680>>2]){x[c+1075688>>2]=0;x[d>>2]=x[d>>2]|2101248}a=D(b,872)+a|0;x[a+1075068>>2]=0;x[j>>2]=0;x[j+4>>2]=0;a=a+1075084|0;x[a>>2]=0;x[a+4>>2]=0}fb=h+16|0}function $0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=fb-80|0;fb=g;yc(b);a:{if(!Nr(b,11790)){break a}i=g+69|0;if(!zw(b,i)){break a}if(!OE(y[g+70|0])){break a}if(!Mb(x[b>>2],x[b+8>>2],Bc(NE(i),hb))){break a}if(!Vb(b,y[g+78|0]|y[g+79|0]<<8)){break a}d=1;if((c|0)==64){break a}Dd(a,4096);x[a+480208>>2]=12;w[a+480188>>1]=(y[g+71|0]&31)+1;w[a+480190>>1]=y[g+72|0];Wh(a,1);d=g+20|0;e=uc(d,8476);zb(a+1298344|0,e);tb(e);e=uc(d,7105);zb(a+1298356|0,e);tb(e);e=fb-16|0;fb=e;f=uc(e+4|0,4247);Uc(g,f);tb(f);fb=e+16|0;x[31609]=0;V(229,d|0,g|0,y[g+70|0],i|0);i=x[31609];x[31609]=0;b:{if((i|0)!=1){zb(a+1298368|0,d);tb(d);Eb(g);l=a+1298404|0,m=x[Fc(d,4)>>2],x[l>>2]=m;d=y[g+72|0];i=g+56|0;x[i>>2]=0;x[i+4>>2]=0;Fc(i+8|0,0);if(d){Vr(i,d);MF(i,d,0)}d=1;c:{while(1){e=d&65535;if(e>>>0>z[a+480190>>1]){x[31609]=0;P(230,b|0,a+1298308|0)|0;e=x[31609];x[31609]=0;d=1;d:{if((e|0)==1){break d}while(1){e=d&65535;if(e>>>0>z[a+480190>>1]){d=0;e:{while(1){if(z[a+480188>>1]<=d>>>0){d=0;x[31609]=0;e=a+484344|0;O(223,e|0,y[g+73|0]|y[g+74|0]<<8);f=x[31609];x[31609]=0;if((f|0)==1){break d}break e}e=(d<<5)+a|0;Ue(e+480280|0);x[31609]=0;O(231,b|0,e+480289|0);e=x[31609];x[31609]=0;if((e|0)!=1){d=d+1|0;continue}break}b=N()|0;break c}f:{g:{h:{i:{while(1){if((y[g+73|0]|y[g+74|0]<<8)>>>0<=d>>>0){x[31609]=0;f=R(189,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break g}if(!f){break h}d=x[b+8>>2];e=x[b>>2];x[31609]=0;d=U(150,e|0,d|0,f|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break g}if(d){break i}break h}x[31609]=0;f=g+20|0;h=P(232,b|0,f|0)|0;j=x[31609];x[31609]=0;j:{if((j|0)==1){break j}x[31609]=0;j=U(196,e|0,d&65535,64)|0;k=x[31609];x[31609]=0;if((k|0)==1){break j}if((h&j)==1){h=x[e>>2];x[31609]=0;O(233,Wb(h,d)|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break j}}d=d+1|0;continue}break}b=N()|0;break c}e=Nb(g+20|0);x[31609]=0;S(234,b|0,e|0,f|0);d=x[31609];x[31609]=0;k:{if((d|0)!=1){d=Fb(g);x[31609]=0;O(114,d|0,f|0);f=x[31609];x[31609]=0;l:{if((f|0)==1){break l}l=g,m=wb(x[e>>2]),x[l+40>>2]=m;h=wb(x[e+4>>2]);while(1){m:{f=x[g+40>>2];if(!Ib(f,h)){x[31609]=0;h=g+40|0;S(235,h|0,20,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break m}f=zb(d,h);tb(h);h=Kb(f);j=y[f+11|0];k=x[f+4>>2];x[31609]=0;aa(236,a+1298332|0,h|0,_c(k,j)|0,76,0);h=x[31609];x[31609]=0;if((h|0)==1){break l}tb(f);ec(e);break h}n:{f=v[f|0];if((f|0)<0){j=x[vb(g+52|0,Ef(d))>>2];x[31609]=0;V(237,d|0,j|0,f&127,32);f=x[31609];x[31609]=0;if((f|0)!=1){break n}break l}x[31609]=0;O(115,d|0,f|0);f=x[31609];x[31609]=0;if((f|0)!=1){break n}break l}we(g+40|0);continue}break}}b=N()|0;tb(d);break k}b=N()|0}ec(e);break c}d=y[a+484376|0];e=x[a+484360>>2];x[31609]=0;S(238,Xb(e,d)|0,b|0,y[g+75|0]|y[g+76|0]<<8);d=x[31609];x[31609]=0;if((d|0)==1){break g}f=c&1;d=0;while(1){o:{p:{if((y[g+73|0]|y[g+74|0]<<8)>>>0>d>>>0){e=x[b+8>>2];h=x[b>>2];x[31609]=0;e=U(150,h|0,e|0,4)|0;h=x[31609];x[31609]=0;if((h|0)==1){break o}if(e){break p}}if(!(c&2)){break f}d=1;while(1){c=d&65535;if(c>>>0>z[a+480190>>1]){break f}e=D(c,104)+a|0;f=z[e+484414>>1];Jb(g+20|0,x[i>>2],c-1|0);c=Zc(g,f&1?16:8,1,0,Gb(x[x[g+20>>2]>>2],x[g+24>>2])?6:0);x[31609]=0;U(215,c|0,e+484380|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){d=d+1|0;continue}break}b=N()|0;break c}x[31609]=0;e=R(151,b|0)|0;h=x[31609];x[31609]=0;q:{r:{if((h|0)!=1){x[31609]=0;S(185,g|0,b|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break r}e=hc(g+20|0,g);ub(g);if(!f){break q}h=x[a+484344>>2];if(!Je(h,x[a+484348>>2],d&65535)){break q}x[31609]=0;S(239,Wb(h,d)|0,0,e|0);h=x[31609];x[31609]=0;if((h|0)!=1){break q}b=N()|0;ub(e);break c}b=N()|0;break c}b=N()|0;break c}ub(e);d=d+1|0;continue}break}b=N()|0;break c}b=N()|0;break c}tf(i);d=1;break a}x[31609]=0;P(240,b|0,((e<<5)+a|0)+946304|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){d=d+1|0;continue}break}b=N()|0;break c}b=N()|0;break c}x[31609]=0;f=g+20|0;O(241,b|0,f|0);h=x[31609];x[31609]=0;s:{if((h|0)==1){break s}x[31609]=0;O(242,f|0,(D(e,104)+a|0)+484380|0);f=x[31609];x[31609]=0;if((f|0)==1){break s}f=y[g+36|0];Jb(g,x[i>>2],e-1|0);kf(g,(f&3)!=0);d=d+1|0;continue}break}b=N()|0}tf(i);break b}b=N()|0;Eb(g)}Q(b|0);p()}fb=g+80|0;return d|0}function Via(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=E(0),m=0,n=0,o=0,q=0,r=0;d=fb-80|0;fb=d;h=-1;a:{b:{c:{d:{if(x[(x[x[b>>2]-12>>2]+b|0)+16>>2]){break d}ae(d- -64|0,b);e=x[d+72>>2];g=x[d+76>>2];f=d+56|0;al(f);b=wj(b,f,8);if((y[d+56|0]|y[d+57|0]<<8|(y[d+58|0]<<16|y[d+59|0]<<24))!=1414681667|(y[d+60|0]|y[d+61|0]<<8|(y[d+62|0]<<16|y[d+63|0]<<24))!=776101705){Di(b,e,g,0);break d}w[d+54>>1]=0;ng(b,d+54|0);k=w[d+54>>1];if((k-4&65535)>>>0<65534){break d}e=d+46|0;al(e);e=wj(b,e,8);if((y[d+46|0]|y[d+47|0]<<8|(y[d+48|0]<<16|y[d+49|0]<<24))!=1933333571|(y[d+50|0]|y[d+51|0]<<8|(y[d+52|0]<<16|y[d+53|0]<<24))!=1111389030){break d}w[d+44>>1]=0;ng(e,d+44|0);g=w[d+44>>1];if((g-5&65535)>>>0<65534){break d}e:{f:{g:{h:{i:{j:{if(g>>>0<=3){b=Fb(d- -64|0);x[31609]=0;f=U(495,e|0,b|0,65535)|0;i=x[31609];x[31609]=0;if((i|0)==1){break b}if(!f){break i}x[31609]=0;f=d+32|0;S(496,f|0,c|0,b|0);i=x[31609];x[31609]=0;if((i|0)!=1){break j}break b}b=Fb(d- -64|0);x[31609]=0;f=P(498,e|0,b|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break c}if(!f){break h}x[31609]=0;f=d+32|0;S(496,f|0,c|0,b|0);i=x[31609];x[31609]=0;if((i|0)==1){break c}}zb(a+40|0,f);tb(f);tb(b);w[d+30>>1]=0;ng(e,d+30|0);w[d+28>>1]=0;ng(e,d+28|0);w[a>>1]=z[d+28>>1];w[d+26>>1]=0;k:{if((g|0)<=3){x[d+64>>2]=0;Hk(e,d- -64|0);b=x[d+64>>2];if(b>>>0>65535){break d}b=cm(b);w[d+26>>1]=b;break k}ng(e,d+26|0);b=z[d+26>>1]}i=a+52|0;m=b&65535;n=(g|0)>3;b=0;l:{m:{while(1){if((b&65535)>>>0>=m>>>0){break l}g=Fb(d- -64|0);x[31609]=0;w[d+8>>1]=0;O(934,e|0,d+8|0);f=x[31609];x[31609]=0;if((f|0)==1){break g}n:{if(!n){x[31609]=0;f=U(495,e|0,g|0,65535)|0;j=x[31609];x[31609]=0;if((j|0)==1){break g}if(f){break n}break e}x[31609]=0;f=P(498,e|0,g|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break g}if(!f){break e}}x[31609]=0;f=d+32|0;S(496,f|0,c|0,g|0);j=x[31609];x[31609]=0;if((j|0)!=1){x[31609]=0;j=P(931,i|0,d+8|0)|0;o=x[31609];x[31609]=0;if((o|0)==1){break m}zb(j,f);tb(f);tb(g);b=b+1|0;continue}break}h=N()|0;break f}h=N()|0;tb(d+32|0);break f}b=d+32|0;al(b);b=wj(e,b,8);if((y[d+32|0]|y[d+33|0]<<8|(y[d+34|0]<<16|y[d+35|0]<<24))!=1933333571|(y[d+36|0]|y[d+37|0]<<8|(y[d+38|0]<<16|y[d+39|0]<<24))!=1161720678){break d}c=z[a>>1];if(c>>>0>3|(c|0)==2){break d}c=a+4|0;o:{if((k|0)<=2){if(VQ(b,c)){break o}break d}if(!UQ(b,c)){break d}}q=d,r=wb(x[a+4>>2]),x[q+64>>2]=r;c=wb(x[a+8>>2]);while(1){e=x[d+64>>2];if(Ib(e,c)){if(!Vm(B[e>>2])){break d}We(d- -64|0);continue}break}c=a+16|0;p:{if((k|0)<=2){if(VQ(b,c)){break p}break d}if(!UQ(b,c)){break d}}q=d,r=wb(x[a+16>>2]),x[q+64>>2]=r;c=wb(x[a+20>>2]);while(1){e=x[d+64>>2];if(Ib(e,c)){if(!Vm(B[e>>2])){break d}We(d- -64|0);continue}break}q=a,r=oc(x[a+16>>2],x[a+20>>2]),x[q+36>>2]=r;w[d+24>>1]=0;ng(b,d+24|0);c=z[d+24>>1];w[a+28>>1]=c;if((c-201&65535)>>>0<65135){break d}w[d+22>>1]=0;ng(b,d+22|0);c=w[d+22>>1];w[a+30>>1]=c;if((c|0)<0){break d}x[d+16>>2]=0;vq(b,d+16|0);l=XQ(B[d+16>>2]);B[a+32>>2]=l;if(!Vm(l)){break d}x[d+8>>2]=0;x[d+12>>2]=0;c=fb-32|0;fb=c;e=d+8|0;$k(c+16|0,e);Om(c+24|0,b,x[c+16>>2],x[c+20>>2]);$k(c+8|0,e);fb=c+32|0;if(x[d+8>>2]!=1414681667|x[d+12>>2]!=776298313){break d}b=oc(x[a+4>>2],x[a+8>>2]);if(b>>>0>32767){break d}c=w[a+30>>1];e=z[a>>1];if(!(e?!(B[a+32>>2]<=E(0))&(c|0)>0:1)){break d}q:{switch(e-1|0){case 0:case 2:if(b>>>0<c>>>0){break d}break;default:break q}}b=0;c=x[a+36>>2];if(c){b=c-1|0;x[a+36>>2]=b}q=d,r=uh(b),x[q+64>>2]=r;x[d+4>>2]=0;b=d- -64|0;q=a,r=x[_j(b,d+4|0,42224)>>2],x[q+36>>2]=r;wq(a);h=1;if(z[a>>1]!=3){break d}c=w[a+30>>1];if((c-w[a+28>>1]|0)>(cR(oc(x[a+4>>2],x[a+8>>2]))|0)){break d}h=a+32|0;e=Nb(b);b=0;while(1){r:{if(c<<16>>16<=(b|0)){b=z[a+28>>1];w[d+4>>1]=b;q=d,r=(oc(x[a+4>>2],x[a+8>>2])+b|0)-1|0,w[q+6>>1]=r;x[31609]=0;w[d+2>>1]=0;ha(929,a|0,e|0,h|0,d+4|0,d+2|0)|0;a=x[31609];x[31609]=0;h=1;if((a|0)==1){break r}wc(e);break d}c=w[a+28>>1];g=x[a+4>>2];x[31609]=0;O(935,e|0,yb(g,b-c|0)|0);c=x[31609];x[31609]=0;if((c|0)!=1){b=b+1|0;c=z[a+30>>1];continue}}break}h=N()|0;wc(e);break a}tb(b);break d}tb(b);break d}h=N()|0}tb(g);break a}tb(g)}fb=d+80|0;return h|0}h=N()|0;tb(b);break a}h=N()|0;tb(b)}Q(h|0);p()}function at(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=fb-592|0;fb=e;x[e+572>>2]=6;x[e+576>>2]=364;x[e+564>>2]=11;x[e+568>>2]=161;x[e+556>>2]=23;x[e+560>>2]=31;x[e+548>>2]=59;x[e+552>>2]=55;x[e+584>>2]=0;x[e+588>>2]=0;x[e+580>>2]=-1;v[e+446|0]=c;v[e+445|0]=37;v[e+447|0]=0;h=e+448|0;fa(h|0,100,e+445|0,e+548|0,x[b>>2])|0;f=e+32|0;x[e+28>>2]=f;x[e+16>>2]=0;x[e+20>>2]=0;x[e+12>>2]=h;h=Ei(f,e+12|0,100,e+16|0,x[b>>2]);if((h|0)!=-1){l=b+484|0;i=b+460|0;j=b+172|0;k=b+4|0;h=(h<<2)+f|0;g=Fb(a);m=(c|0)!=120;a:while(1){b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{if((f|0)!=(h|0)){a=x[f>>2];x[31609]=0;a=U(1285,d|0,1,a|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}if(a){x[31609]=0;O(35,g|0,32);a=x[31609];x[31609]=0;if((a|0)==1){break c}while(1){f=f+4|0;if((h|0)==(f|0)){f=h;break b}a=x[f>>2];x[31609]=0;a=U(1285,d|0,1,a|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}if(a){continue}break}break b}x[e+8>>2]=f;x[31609]=0;x[e+4>>2]=0;a=ea(1380,e+8|0,h|0,k|0,j|0,d|0,e+4|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}p:{a=a-k|0;q:{if((a|0)<=167){x[31609]=0;O(35,g|0,37);c=x[31609];x[31609]=0;if((c|0)==1){break c}x[31609]=0;O(35,g|0,((a|0)<84?65:97)|0);a=x[31609];x[31609]=0;if((a|0)!=1){break q}break c}x[31609]=0;x[e+8>>2]=f;a=ea(1380,e+8|0,h|0,j|0,i|0,d|0,e+4|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}a=a-j|0;c=(a|0)/12|0;if((a|0)<=287){x[31609]=0;O(35,g|0,37);f=x[31609];x[31609]=0;if((f|0)==1){break c}x[31609]=0;O(35,g|0,((a|0)<144?66:98)|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}if(m){break q}a=x[Wd((D(c,12)+b|0)+172|0,0)>>2];x[31609]=0;a=U(1285,d|0,64,a|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}if(!a){break q}n=(Kb(g)+(Cb(x[g+4>>2],y[g+11|0])<<2)|0)-4|0,o=109,x[n>>2]=o;break q}if((Cb(x[b+464>>2],y[b+471|0])|0)==(0-Cb(x[b+476>>2],y[b+483|0])|0)){break p}x[31609]=0;x[e+8>>2]=f;a=ea(1380,e+8|0,h|0,i|0,l|0,d|0,e+4|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}if((a-i|0)>23){break p}x[31609]=0;O(35,g|0,37);a=x[31609];x[31609]=0;if((a|0)==1){break c}x[31609]=0;O(35,g|0,112);a=x[31609];x[31609]=0;if((a|0)==1){break c}}f=x[e+8>>2];break b}x[e+8>>2]=f;a=x[f>>2];x[31609]=0;a=U(1285,d|0,64,a|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}if(a){x[31609]=0;a=ba(1381,e+28|0,h|0,e+4|0,d|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}r:{s:{switch(a-6|0){case 2:case 3:case 4:break r;case 0:break e;case 1:break f;case 5:break g;case 6:break h;default:break s}}t:{switch(a-55|0){case 0:break k;case 4:break l;case 6:break m;case 1:case 2:case 3:case 5:break r;default:break t}}if((a|0)==23){break i}if((a|0)==31){break j}if((a|0)==364){break n}if((a|0)==2061){break o}}a=x[e+28>>2];while(1){if((a|0)==(f|0)){f=a;continue a}c=x[f>>2];x[31609]=0;O(35,g|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break c}f=f+4|0;continue}}a=x[f>>2];x[31609]=0;a=P(1382,d|0,a|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}u:{if((a|0)==37){x[31609]=0;O(35,g|0,37);a=x[31609];x[31609]=0;if((a|0)==1){break c}x[31609]=0;O(35,g|0,37);break u}a=x[f>>2];x[31609]=0;O(35,g|0,a|0)}a=x[31609];x[31609]=0;if((a|0)==1){break c}f=f+4|0;break b}fb=e+592|0;return}x[31609]=0;O(35,g|0,37);a=x[31609];x[31609]=0;c=89;break d}x[31609]=0;O(35,g|0,37);a=x[31609];x[31609]=0;c=106;break d}x[31609]=0;O(35,g|0,37);a=x[31609];x[31609]=0;c=121;break d}x[31609]=0;O(35,g|0,37);a=x[31609];x[31609]=0;c=83;break d}x[31609]=0;O(35,g|0,37);a=x[31609];x[31609]=0;c=77;break d}x[31609]=0;O(35,g|0,37);a=x[31609];x[31609]=0;c=100;break d}x[31609]=0;O(35,g|0,37);a=x[31609];x[31609]=0;c=72;break d}x[31609]=0;O(35,g|0,37);a=x[31609];x[31609]=0;c=109;break d}x[31609]=0;O(35,g|0,37);a=x[31609];x[31609]=0;c=73;break d}x[31609]=0;O(35,g|0,37);a=x[31609];x[31609]=0;c=117;break d}x[31609]=0;O(35,g|0,37);a=x[31609];x[31609]=0;c=119}if((a|0)==1){break c}x[31609]=0;O(35,g|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}f=x[e+28>>2];continue}a=N()|0;Ub(g);Q(a|0);p()}x[e+28>>2]=f;continue}}fo(12677);p()}function $ia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=E(0),j=0,k=0,l=0;d=fb-304|0;fb=d;e=-1;a:{b:{c:{if(!pk(x[(x[x[b>>2]-12>>2]+b|0)+16>>2])){f=Lm(d+192|0,b);x[31609]=0;b=P(461,d+180|0,14062)|0;e=x[31609];x[31609]=0;d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{if((e|0)!=1){x[31609]=0;x[d+160>>2]=83886084;x[d+164>>2]=0;e=d+160|0;S(462,f|0,b|0,e|0);g=x[31609];x[31609]=0;if((g|0)==1){break A}Eb(b);v[d+179|0]=0;x[31609]=0;b=P(461,e|0,14778)|0;e=x[31609];x[31609]=0;if((e|0)==1){break z}x[31609]=0;S(463,f|0,d+179|0,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break y}Eb(b);c=Fc(d+156|0,y[d+179|0]?0:c);x[31609]=0;b=P(461,d+144|0,15869)|0;e=x[31609];x[31609]=0;if((e|0)==1){break x}e=x[c>>2];x[31609]=0;V(923,f|0,a+40|0,b|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break w}Eb(b);w[d+142>>1]=65535;x[31609]=0;b=P(461,d+128|0,15566)|0;e=x[31609];x[31609]=0;if((e|0)==1){break v}x[31609]=0;U(491,f|0,d+142|0,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break u}Eb(b);w[d+126>>1]=0;x[31609]=0;b=P(461,d+112|0,15467)|0;e=x[31609];x[31609]=0;if((e|0)==1){break t}x[31609]=0;U(491,f|0,d+126|0,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break s}Eb(b);w[a>>1]=z[d+126>>1];x[31609]=0;b=P(461,d+100|0,15140)|0;e=x[31609];x[31609]=0;if((e|0)==1){break r}c=x[c>>2];x[31609]=0;V(924,f|0,a+52|0,b|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break q}Eb(b);x[31609]=0;b=P(461,d+88|0,15081)|0;c=x[31609];x[31609]=0;if((c|0)==1){break p}x[31609]=0;S(915,f|0,a+36|0,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break o}Eb(b);x[31609]=0;b=P(461,d+76|0,15568)|0;c=x[31609];x[31609]=0;if((c|0)==1){break n}x[31609]=0;h=a+4|0;S(925,f|0,h|0,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break m}Eb(b);x[31609]=0;b=P(461,d- -64|0,15469)|0;c=x[31609];x[31609]=0;if((c|0)==1){break l}x[31609]=0;c=a+28|0;S(926,f|0,c|0,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break k}Eb(b);x[31609]=0;b=P(461,d+52|0,15324)|0;e=x[31609];x[31609]=0;if((e|0)==1){break j}x[31609]=0;S(926,f|0,a+30|0,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break i}Eb(b);x[31609]=0;b=P(461,d+40|0,15105)|0;e=x[31609];x[31609]=0;if((e|0)==1){break h}x[31609]=0;S(927,f|0,a+32|0,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break g}Eb(b);w[d+38>>1]=0;x[31609]=0;b=P(461,d+24|0,15054)|0;e=x[31609];x[31609]=0;if((e|0)==1){break c}x[31609]=0;U(491,f|0,d+38|0,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break f}Eb(b);i=XQ(B[a+32>>2]);B[a+32>>2]=i;e=-1;if(!Vm(i)){break d}b=wb(x[a+4>>2]);x[d+20>>2]=b;g=wb(x[a+8>>2]);while(1){if(!Ib(b,g)){break e}if(!Vm(B[b>>2])){break d}b=x[We(d+20|0)>>2];continue}}a=N()|0;break a}a=N()|0;Eb(b);break a}a=N()|0;break a}a=N()|0;Eb(b);break a}a=N()|0;break a}a=N()|0;Eb(b);break a}a=N()|0;break a}a=N()|0;Eb(b);break a}a=N()|0;break a}a=N()|0;Eb(b);break a}a=N()|0;break a}a=N()|0;Eb(b);break a}a=N()|0;break a}a=N()|0;Eb(b);break a}a=N()|0;break a}a=N()|0;Eb(b);break a}a=N()|0;break a}a=N()|0;Eb(b);break a}a=N()|0;break a}a=N()|0;Eb(b);break a}a=N()|0;break a}a=N()|0;Eb(b);break a}a=N()|0;Eb(b);break a}if(rl(y[f|0])){break d}b=z[c>>1];if((b-301&65535)>>>0<64935){break d}g=z[a>>1];if(g>>>0>3|(g|0)==2){break d}j=w[a+30>>1];if((j|0)<0){break d}k=d,l=uh(x[a+36>>2]),x[k+20>>2]=l;x[d+16>>2]=0;k=a,l=x[_j(d+20|0,d+16|0,42224)>>2],x[k+36>>2]=l;if(oc(x[a+4>>2],x[a+8>>2])>>>0>32767){break d}B:{C:{switch(g-1|0){case 2:c=w[d+38>>1];if((c|0)<=0){break d}w[d+14>>1]=j;B[d+20>>2]=B[a+32>>2];x[31609]=0;w[d+16>>1]=b;w[d+18>>1]=(b+c|0)-1;a=ba(928,a|0,d+14|0,d+20|0,d+16|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){if(a){break B}break d}a=N()|0;break a;case 0:g=w[d+38>>1];if((g|0)<=0){break d}B[d+20>>2]=B[a+32>>2];x[31609]=0;w[d+16>>1]=b;w[d+18>>1]=(b+g|0)-1;a=ha(929,a|0,h|0,d+20|0,d+16|0,c|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){if(a){break B}break d}a=N()|0;break a;default:break C}}x[31609]=0;W(930,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}}e=1}Ch(f)}fb=d+304|0;return e|0}a=N()|0;break a}a=N()|0}Ch(f);Q(a|0);p()}function zL(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;i=fb-560|0;fb=i;g=c;c=(c-3|0)/24|0;t=(c|0)>0?c:0;k=g+D(t,-24)|0;n=x[(e<<2)+89920>>2];j=d-1|0;if((n+j|0)>=0){g=d+n|0;c=t-j|0;while(1){C[(i+320|0)+(h<<3)>>3]=(c|0)<0?0:+x[(c<<2)+89936>>2];c=c+1|0;h=h+1|0;if((g|0)!=(h|0)){continue}break}}q=k-24|0;g=0;h=(n|0)>0?n:0;m=(d|0)<=0;while(1){a:{if(m){f=0;break a}r=g+j|0;c=0;f=0;while(1){f=C[(c<<3)+a>>3]*C[(i+320|0)+(r-c<<3)>>3]+f;c=c+1|0;if((d|0)!=(c|0)){continue}break}}C[(g<<3)+i>>3]=f;c=(g|0)==(h|0);g=g+1|0;if(!c){continue}break}y=47-k|0;r=48-k|0;u=(k|0)<25;z=k-25|0;g=n;while(1){f=C[(g<<3)+i>>3];c=0;h=g;o=(g|0)<=0;if(!o){while(1){m=(i+480|0)+(c<<2)|0;l=f*5.960464477539063e-8;b:{if(F(l)<2147483648){j=~~l;break b}j=-2147483648}l=+(j|0);f=l*-16777216+f;c:{if(F(f)<2147483648){j=~~f;break c}j=-2147483648}x[m>>2]=j;h=h-1|0;f=C[(h<<3)+i>>3]+l;c=c+1|0;if((g|0)!=(c|0)){continue}break}}f=kk(f,q);f=f+J(f*.125)*-8;d:{if(F(f)<2147483648){m=~~f;break d}m=-2147483648}f=f-+(m|0);e:{f:{g:{h:{if(!u){h=(g<<2)+i|0;j=x[h+476>>2];c=j>>r;s=h;h=j-(c<<r)|0;x[s+476>>2]=h;m=c+m|0;j=h>>y;break h}if(q){break g}j=x[((g<<2)+i|0)+476>>2]>>23}if((j|0)<=0){break e}break f}j=2;if(f>=.5){break f}j=0;break e}c=0;h=0;if(!o){while(1){s=(i+480|0)+(c<<2)|0;o=x[s>>2];v=16777215;i:{j:{if(h){break j}v=16777216;if(o){break j}h=0;break i}x[s>>2]=v-o;h=1}c=c+1|0;if((g|0)!=(c|0)){continue}break}}k:{if(u){break k}c=8388607;l:{switch(z|0){case 1:c=4194303;break;case 0:break l;default:break k}}o=(g<<2)+i|0;x[o+476>>2]=x[o+476>>2]&c}m=m+1|0;if((j|0)!=2){break e}f=1-f;j=2;if(!h){break e}f=f-kk(1,q)}m:{n:{if(f==0){h=0;c=g;if((c|0)<=(n|0)){break m}while(1){c=c-1|0;h=x[(i+480|0)+(c<<2)>>2]|h;if((c|0)>(n|0)){continue}break}if(!h){break m}k=q;while(1){k=k-24|0;g=g-1|0;if(!x[(i+480|0)+(g<<2)>>2]){continue}break}break n}f=kk(f,24-k|0);o:{if(f>=16777216){d=(i+480|0)+(g<<2)|0;l=f*5.960464477539063e-8;p:{if(F(l)<2147483648){c=~~l;break p}c=-2147483648}f=+(c|0)*-16777216+f;q:{if(F(f)<2147483648){a=~~f;break q}a=-2147483648}x[d>>2]=a;g=g+1|0;break o}if(F(f)<2147483648){c=~~f}else{c=-2147483648}k=q}x[(i+480|0)+(g<<2)>>2]=c}f=kk(1,k);if((g|0)>=0){d=g;while(1){a=d;C[(a<<3)+i>>3]=f*+x[(i+480|0)+(a<<2)>>2];d=a-1|0;f=f*5.960464477539063e-8;if(a){continue}break}h=g;while(1){f=0;c=0;a=g-h|0;d=(a|0)>(n|0)?n:a;if((d|0)>=0){while(1){f=C[(c<<3)+92704>>3]*C[(c+h<<3)+i>>3]+f;k=(c|0)!=(d|0);c=c+1|0;if(k){continue}break}}C[(i+160|0)+(a<<3)>>3]=f;a=(h|0)>0;h=h-1|0;if(a){continue}break}}r:{s:{t:{switch(e|0){case 3:u:{if((g|0)<=0){break u}d=(i+160|0)+(g<<3)|0;f=C[d>>3];c=g;while(1){l=f;e=i+160|0;a=c-1|0;h=e+(a<<3)|0;w=C[h>>3];f=w+f;C[e+(c<<3)>>3]=l+(w-f);C[h>>3]=f;e=c>>>0>1;c=a;if(e){continue}break}if((g|0)<2){break u}f=C[d>>3];c=g;while(1){l=f;d=i+160|0;a=c-1|0;e=d+(a<<3)|0;p=C[e>>3];f=p+f;C[d+(c<<3)>>3]=l+(p-f);C[e>>3]=f;d=c>>>0>2;c=a;if(d){continue}break}p=0;while(1){p=p+C[(i+160|0)+(g<<3)>>3];a=(g|0)>2;g=g-1|0;if(a){continue}break}}f=C[i+160>>3];if(j){break s}C[b>>3]=f;f=C[i+168>>3];C[b+16>>3]=p;C[b+8>>3]=f;break r;case 0:f=0;if((g|0)>=0){while(1){a=g;g=g-1|0;f=f+C[(i+160|0)+(a<<3)>>3];if(a){continue}break}}C[b>>3]=j?-f:f;break r;case 1:case 2:break t;default:break r}}f=0;if((g|0)>=0){d=g;while(1){a=d;d=a-1|0;f=f+C[(i+160|0)+(a<<3)>>3];if(a){continue}break}}C[b>>3]=j?-f:f;f=C[i+160>>3]-f;c=1;if((g|0)>0){while(1){f=f+C[(i+160|0)+(c<<3)>>3];a=(c|0)!=(g|0);c=c+1|0;if(a){continue}break}}C[b+8>>3]=j?-f:f;break r}C[b>>3]=-f;f=C[i+168>>3];C[b+16>>3]=-p;C[b+8>>3]=-f}fb=i+560|0;return m&7}c=1;while(1){h=c;c=c+1|0;if(!x[(i+480|0)+(n-h<<2)>>2]){continue}break}h=g+h|0;while(1){j=d+g|0;g=g+1|0;C[(i+320|0)+(j<<3)>>3]=x[(t+g<<2)+89936>>2];c=0;f=0;if((d|0)>0){while(1){f=C[(c<<3)+a>>3]*C[(i+320|0)+(j-c<<3)>>3]+f;c=c+1|0;if((d|0)!=(c|0)){continue}break}}C[(g<<3)+i>>3]=f;if((g|0)<(h|0)){continue}break}g=h;continue}}function Xoa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,A=0,B=0,C=0,E=0;e=fb-736|0;fb=e;yc(b);d=fb-16|0;fb=d;f=e+128|0;$W(d+8|0,f);g=x[d+12>>2];lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2]);i=x[d+4>>2];if((i|0)==(g|0)){Vb(b,x[d+12>>2])}fb=d+16|0;d=(g|0)==(i|0);if(!d){_W(f)}a:{if(!d){break a}if(!bX(f)){break a}if(!Mb(x[b>>2],x[b+8>>2],Bc(aX(y[e+162|0]|y[e+163|0]<<8),hb))){break a}s=1;if((c|0)==64){break a}Dd(a,262144);g=e+92|0;Xi(g,2,f);d=e+12|0;Cc(d,g);zb(a+1298308|0,d);tb(d);f=uc(d,8317);zb(a+1298344|0,f);tb(f);f=uc(d,10141);zb(a+1298356|0,f);tb(f);f=fb-16|0;fb=f;i=uc(f+4|0,4193);Uc(g,i);tb(i);fb=f+16|0;v[e|0]=y[e+158|0];x[31609]=0;v[e+115|0]=y[e+157|0];f=e+116|0;O(691,f|0,e+115|0);i=x[31609];x[31609]=0;b:{c:{d:{if((i|0)!=1){x[31609]=0;V(250,d|0,g|0,e|0,f|0);i=x[31609];x[31609]=0;if((i|0)!=1){zb(a+1298368|0,d);tb(d);tb(f);Eb(g);C=a+1298404|0,E=x[Fc(d,4)>>2],x[C>>2]=E;x[a+480208>>2]=12;w[a+480188>>1]=y[e+166|0]|y[e+167|0]<<8;w[e+12>>1]=y[e+162|0]|y[e+163|0]<<8;w[e+92>>1]=3999;C=a,E=z[Oc(d,g)>>1],w[C+480190>>1]=E;H_(Xb(x[a+484360>>2],y[a+484376|0]),e+224|0,y[e+160|0]|y[e+161|0]<<8);d=0;while(1)if(z[a+480188>>1]<=d>>>0){d=e+12|0;he(d,b,D(y[e+162|0]|y[e+163|0]<<8,80));l=c&2;i=hc(e+92|0,d);ub(d);m=e+60|0;d=0;e:{f:{while(1){if(z[a+480190>>1]<=d>>>0){if(c&1){break f}break b}x[31609]=0;f=e+12|0;O(692,i|0,f|0);g=x[31609];x[31609]=0;if((g|0)==1){break e}Xi(e,2,m);x[31609]=0;g=e+116|0;O(218,g|0,e|0);j=x[31609];x[31609]=0;if((j|0)==1){break e}d=d+1|0;Ac(((d<<5)+a|0)+946304|0,g);tb(g);x[31609]=0;h=f;f=(D(d,104)+a|0)+484380|0;S(693,g|0,h|0,f|0);j=x[31609];x[31609]=0;g:{if((j|0)==1){break g}if(!l|!x[f>>2]){continue}x[31609]=0;j=P(149,b|0,y[e+30|0]|y[e+31|0]<<8|(y[e+32|0]<<16|y[e+33|0]<<24))|0;k=x[31609];x[31609]=0;if((k|0)==1){break g}if(!j){continue}x[31609]=0;U(215,g|0,f|0,b|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){continue}}break}break e}x[31609]=0;o=a+484344|0;O(223,o|0,y[e+164|0]|y[e+165|0]<<8);c=x[31609];x[31609]=0;if((c|0)==1){break e}q=e+16|0;t=e+14|0;r=e+15|0;u=e+17|0;A=e+13|0;c=0;while(1){if((y[e+164|0]|y[e+165|0]<<8)>>>0<=c>>>0){break b}x[31609]=0;d=U(196,o|0,c&65535,64)|0;g=x[31609];x[31609]=0;if((g|0)==1){break e}h:{if(!d){break h}d=(c<<1)+e|0;d=y[d+480|0]|y[d+481|0]<<8;if(!d){break h}x[31609]=0;d=P(149,b|0,d<<4)|0;g=x[31609];x[31609]=0;if((g|0)==1){break e}if(!d){break h}l=0;d=Wb(x[o>>2],c);m=md(x[d>>2],x[x[d+48>>2]+12>>2],0,0);i:while(1){B=l>>>0>63;while(1){if(B){break h}d=x[b+8>>2];g=x[b>>2];x[31609]=0;d=U(150,g|0,d|0,1)|0;g=x[31609];x[31609]=0;j:{if((g|0)!=1){if(!d){break h}x[31609]=0;d=R(197,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break e}j=d<<24>>24;if(j){break j}l=l+1|0;m=D(z[a+480188>>1],6)+m|0;continue i}break e}w[q>>1]=0;x[e+12>>2]=0;g=j&31;d=D(g,6)+m|0;f=Ng(e+12|0);g=g>>>0<z[a+480188>>1];k=g?d:f;h=j&255;k:{if(!(h&32)){break k}x[31609]=0;n=e+116|0;O(198,n|0,b|0);f=x[31609];x[31609]=0;if((f|0)==1){break e}f=y[e+116|0];v[k|0]=f;C=g?d+1|0:A,E=y[Jc(n)|0],v[C|0]=E;l:{if(f){if((f|0)==254){break l}if(f>>>0<121){break k}}f=0}v[k|0]=f}m:{if(!(h&64)){break m}x[31609]=0;h=e+116|0;O(198,h|0,b|0);f=x[31609];x[31609]=0;if((f|0)==1){break e}f=g?d+5|0:u;n=y[Jc(h)|0];v[f|0]=n;h=y[e+116|0];n:{if(h>>>0<=15){Cf(k,h,n);break n}v[(g?d+3|0:r)|0]=h>>>0<=23?y[h+25383|0]:0}k=g?d+3|0:r;h=y[k|0];if((h|0)!=23){if((h|0)!=9){break m}v[k|0]=20;v[e|0]=y[f|0]>>>3;v[e+115|0]=1;C=f,E=y[cf(e,e+115|0)|0]-1&15|128,v[C|0]=E;break m}v[e|0]=64;C=f,E=y[Qb(f,e)|0]<<1,v[C|0]=E}if((j|0)>=0){continue}v[(g?d+2|0:t)|0]=1;x[31609]=0;f=R(197,b|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break e}v[(g?d+4|0:q)|0]=f;continue}}}c=c+1|0;continue}}b=N()|0;ub(i);break c}else{g=(d<<5)+a|0;Ue(g+480280|0);w[g+480284>>1]=(y[(e+d|0)+192|0]<<4|4)&244;d=d+1|0;continue}}b=N()|0;tb(e+116|0);break d}b=N()|0}Eb(e+92|0)}Q(b|0);p()}ub(i)}fb=e+736|0;return s|0}function t1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;f=fb-864|0;fb=f;yc(b);e=fb-16|0;fb=e;d=f+92|0;yF(e+8|0,d);i=x[e+12>>2];lc(e,x[b>>2],x[b+8>>2],x[e+8>>2],x[e+12>>2]);g=x[e+4>>2];if((g|0)==(i|0)){Vb(b,x[e+12>>2])}fb=e+16|0;e=(g|0)==(i|0);if(!e){xF(d)}a:{if(!e){break a}if(!AF(d)){break a}if(!Mb(x[b>>2],x[b+8>>2],zF(y[f+607|0]))){break a}k=1;if((c|0)==64){break a}Dd(a,2);x[a+480204>>2]=15e5;x[a+480208>>2]=x[a+480208>>2]|16777216;e=y[f+606|0];x[a+480188>>2]=4194322;x[a+480196>>2]=e;e=a+484376|0;ak(Xb(x[a+484360>>2],y[e|0]),b,y[f+607|0],65535,65535);e=Xb(x[a+484360>>2],y[e|0]);o=f,q=wb(x[e>>2]),x[o+40>>2]=q;e=wb(x[e+4>>2]);b:{while(1){d=x[f+40>>2];if(Ib(d,e)){if(z[d>>1]>127){break b}ge(f+40|0);continue}break}eg(a);while(1){i=k&65535;if(i>>>0>z[a+480190>>1]){c:{k=1;d:{e:{f:{if(!(c&1)){break f}n=x[b+8>>2];i=a+484344|0;Tf(i,128);c=0;g:{while(1){if((c|0)==128){break g}d=f+16|0;e=(c<<1)+f|0;wF(d,b,(y[e+608|0]|y[e+609|0]<<8)+n|0,4674);e=hc(f+40|0,d);ub(d);g=x[e>>2];x[31609]=0;g=R(172,g|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}h:{if(!g){break h}x[31609]=0;g=U(196,i|0,c&65535,32)|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(!g){break h}g=0;j=d;d=Wb(x[i>>2],c);af(j,x[d>>2],x[x[d+48>>2]+12>>2],0);while(1){i:{d=x[e>>2];x[31609]=0;d=U(150,d|0,x[f+48>>2],1)|0;h=x[31609];x[31609]=0;j:{k:{l:{m:{n:{if((h|0)!=1){if(!d){break i}x[31609]=0;d=R(197,e|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break c}o:{switch(d-251|0){case 0:break k;case 1:break l;case 2:break m;case 3:break n;case 4:break o;default:break j}}x[31609]=0;d=R(197,e|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break c}if(!d){break i}g=d+g|0;if(g>>>0>=32){break i}d=Wb(x[i>>2],c);af(f- -64|0,x[d>>2],x[x[d+48>>2]+12>>2],g);d=x[f+68>>2];x[f+16>>2]=x[f+64>>2];x[f+20>>2]=d;continue}break c}x[31609]=0;d=f- -64|0;O(198,d|0,e|0);h=x[31609];x[31609]=0;if((h|0)==1){break c}j=z[a+480188>>1];h=y[xb(d,0)|0];if(j>>>0<=h>>>0){break e}d=y[xb(d,1)|0];if(d>>>0>63){break e}o=Yc(x[f+16>>2],h),q=d+1|0,v[o+1|0]=q;continue}x[31609]=0;d=f- -64|0;O(198,d|0,e|0);h=x[31609];x[31609]=0;if((h|0)==1){break c}j=z[a+480188>>1];h=y[xb(d,0)|0];if(j>>>0<=h>>>0){break e}d=y[xb(d,1)|0];if(d>>>0>63){break e}h=Yc(x[f+16>>2],h);v[h+4|0]=d^63;v[h+2|0]=1;continue}x[31609]=0;d=R(197,e|0)|0;h=x[31609];x[31609]=0;if((h|0)!=1){h=Yc(x[f+16>>2],0);v[h+5|0]=d;v[h+3|0]=12;continue}break c}d=Yc(x[f+16>>2],0);v[d+5|0]=0;v[d+3|0]=14;continue}if(d>>>0>=z[a+480188>>1]){break e}x[31609]=0;h=R(197,e|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break c}if(h>>>0>=124){break e}o=Yc(x[f+16>>2],d),q=(D(h>>>4|0,12)+(h&15)|0)+13|0,v[o|0]=q;l=d|l;m=!(d&1)|m;continue}break}ub(e);c=c+1|0;continue}break}ub(e)}if(!(l&m&1)){break f}c=z[a+480188>>1];b=0;while(1){if((b|0)==(c|0)){break f}w[((b<<5)+a|0)+480284>>1]=b<<8&256;b=b+1|0;continue}}$h(a+1298344|0,14799);$h(a+1298356|0,14808);$h(a+1298368|0,14799);o=a+1298404|0,q=x[Fc(f+40|0,4)>>2],x[o>>2]=q;break a}ub(e);break b}}}else{e=f+81|0;d=fb-16|0;fb=d;p:{if(!Mb(x[b>>2],x[b+8>>2],11)){v[d|0]=0;Uh(e,11,d);break p}Mw(d+8|0,e);sd(d,b,x[d+8>>2],x[d+12>>2])}fb=d+16|0;x[f+48>>2]=0;x[f+40>>2]=0;x[f+44>>2]=0;g=xb(e,1);d=f+40|0;o=xb(d,0),q=y[g|0],v[o|0]=q;g=xb(e,6);o=xb(d,1),q=y[g|0],v[o|0]=q;g=xb(e,2);o=xb(d,2),q=y[g|0],v[o|0]=q;g=xb(e,7);o=xb(d,3),q=y[g|0],v[o|0]=q;g=xb(e,3);o=xb(d,4),q=y[g|0],v[o|0]=q;g=xb(e,8);o=xb(d,5),q=y[g|0],v[o|0]=q;g=xb(e,4);o=xb(d,6),q=y[g|0],v[o|0]=q;g=xb(e,9);o=xb(d,7),q=y[g|0],v[o|0]=q;g=xb(e,5);o=xb(d,8),q=y[g|0],v[o|0]=q;g=xb(e,10);o=xb(d,9),q=y[g|0],v[o|0]=q;e=xb(e,0);o=xb(d,10),q=y[e|0],v[o|0]=q;e=(D(i,104)+a|0)+484380|0;nd(e,2);x[f+8>>2]=x[f+48>>2];d=x[f+44>>2];x[f>>2]=x[f+40>>2];x[f+4>>2]=d;Tk(e,1,f);d=f- -64|0;uF(d,((i<<3)+f|0)+86|0);e=f+16|0;Cc(e,d);Ac(((i<<5)+a|0)+946304|0,e);k=k+1|0;tb(e);continue}break}a=N()|0;ub(e);Q(a|0);p()}k=0}fb=f+864|0;return k|0}function rua(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;g=fb-3056|0;fb=g;yc(b);e=fb-16|0;fb=e;f=g+1102|0;w0(e+8|0,f);i=x[e+12>>2];lc(e,x[b>>2],x[b+8>>2],x[e+8>>2],x[e+12>>2]);h=x[e+4>>2];if((h|0)==(i|0)){Vb(b,x[e+12>>2])}fb=e+16|0;e=(h|0)==(i|0);if(!e){v0(f)}a:{if(!e){break a}if(!y0(f)){break a}d=1;if((c|0)==64){break a}d=0;if(!Mb(x[b>>2],x[b+8>>2],Bc(1024,0))){break a}u0(b,g+576|0);u0(b,g- -64|0);e=0;while(1){if((e|0)!=128){f=e<<2;i=x[f+(g+576|0)>>2];if(i>>>0>16777215){break a}f=x[f+(g- -64|0)>>2];if(f-4097>>>0<4294963202){break a}e=e+1|0;if(xm(x[b>>2],(f+i|0)+2978|0)){continue}break a}break}Dd(a,2);eg(a);d=g+40|0;e=uc(d,13940);zb(a+1298344|0,e);tb(e);e=uc(d,14795);zb(a+1298356|0,e);tb(e);e=uc(d,15584);zb(a+1298368|0,e);tb(e);q=a+1298404|0,r=x[Fc(d,4)>>2],x[q>>2]=r;d=y[g+1102|0];x[a+480204>>2]=143e4;x[a+480196>>2]=d;$e(Xb(x[a+484360>>2],y[a+484376|0]),y[g+1103|0]);x[a+480188>>2]=4194317;Lb(a+1074312|0,95,1);x[a+480208>>2]=x[a+480208>>2]|16777216;d=0;e=0;while(1){if((e|0)==4){b:{while(1){c:{if((d|0)==32){e=0;break c}e=d+1|0;f=D(e,104)+a|0;h=f+484380|0;nd(h,2);j=g+20|0;t0(j,(D(d,13)+g|0)+1104|0);i=g+40|0;Cc(i,j);Ac(((e<<5)+a|0)+946304|0,i);tb(i);d=(g+1102|0)+(d<<4)|0;i=y[d+422|0]|y[d+423|0]<<8|(y[d+424|0]<<16|y[d+425|0]<<24);x[h>>2]=i;m=i;i=y[d+430|0]|y[d+431|0]<<8|(y[d+432|0]<<16|y[d+433|0]<<24);if(m>>>0>=i>>>0){d=y[d+426|0]|y[d+427|0]<<8|(y[d+428|0]<<16|y[d+429|0]<<24);w[f+484414>>1]=2;x[f+484388>>2]=i;x[f+484384>>2]=d}x[f+484404>>2]=8287;d=e;continue}break}while(1){if((e|0)!=32){f=e+33|0;i=(D(f,104)+a|0)+484380|0;nd(i,2);h=g+20|0;t0(h,(D(e,13)+g|0)+2032|0);d=g+40|0;Cc(d,h);Ac(((f<<5)+a|0)+946304|0,d);tb(d);x[g+48>>2]=0;x[g+40>>2]=0;x[g+44>>2]=0;f=(D(e,11)+g|0)+2448|0;h=xb(f,1);q=xb(d,0),r=y[h|0],v[q|0]=r;h=xb(f,6);q=xb(d,1),r=y[h|0],v[q|0]=r;h=xb(f,2);q=xb(d,2),r=y[h|0],v[q|0]=r;h=xb(f,7);q=xb(d,3),r=y[h|0],v[q|0]=r;h=xb(f,3);q=xb(d,4),r=y[h|0],v[q|0]=r;h=xb(f,8);q=xb(d,5),r=y[h|0],v[q|0]=r;h=xb(f,4);q=xb(d,6),r=y[h|0],v[q|0]=r;h=xb(f,9);q=xb(d,7),r=y[h|0],v[q|0]=r;h=xb(f,5);q=xb(d,8),r=y[h|0],v[q|0]=r;h=xb(f,10);q=xb(d,9),r=y[h|0],v[q|0]=r;f=xb(f,0);q=xb(d,10),r=y[f|0],v[q|0]=r;x[g+16>>2]=x[g+48>>2];d=x[g+44>>2];x[g+8>>2]=x[g+40>>2];x[g+12>>2]=d;Tk(i,1,g+8|0);e=e+1|0;continue}break}Pr(Xb(x[a+484360>>2],y[a+484376|0]),g+2800|0,256,255,65535);n=a+484344|0;Tf(n,128);o=c&1;i=0;while(1){d:{e:{if((i|0)!=128){d=i<<2;dd(b,x[d+(g+576|0)>>2]+2978|0);e=g+20|0;he(e,b,x[d+(g- -64|0)>>2]);d=hc(g+40|0,e);ub(e);if(!o){break d}x[31609]=0;e=U(196,n|0,i&65535,64)|0;f=x[31609];x[31609]=0;if((f|0)==1){break b}if(!e){break d}e=0;h=Wb(x[n>>2],i);while(1){m=e>>>0>63;while(1){if(m){break d}f=x[d>>2];x[31609]=0;f=U(150,f|0,x[g+48>>2],1)|0;j=x[31609];x[31609]=0;f:{if((j|0)!=1){if(!f){break d}x[31609]=0;f=R(197,d|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break b}if(f>>>0>12){break f}j=md(x[h>>2],x[x[h+48>>2]+12>>2],e,f);x[31609]=0;k=g+20|0;O(198,k|0,d|0);l=x[31609];x[31609]=0;if((l|0)==1){break b}l=y[g+20|0];f=f>>>0>3;v[j|0]=((l&15)+(f?13:37)|0)+D(l>>>4&7,12);k=Jc(k);v[j+1|0]=((y[k|0]>>>4|0)+(f?33:1)|0)+(y[g+20|0]>>>3&16);s0(j,y[k|0],f);continue}break b}j=f-32|0;if((j&255)>>>0<=12){j=md(x[h>>2],x[x[h+48>>2]+12>>2],e,j&65535);x[31609]=0;k=R(197,d|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break b}s0(j,k,f>>>0>35);continue}break}if((f|0)!=64){if((f|0)!=96){break e}if(!e){break d}q=md(x[h>>2],x[x[h+48>>2]+12>>2],e-1|0,0),r=14,v[q+3|0]=r;break d}x[31609]=0;f=R(197,d|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break b}e=e+f|0;continue}}d=1;if(!(c&2)){break a}while(1)if((d|0)==33){d=1;break a}else{dg(Zc(g+40|0,8,1,0,1),(D(d,104)+a|0)+484380|0,b);d=d+1|0;continue}}ub(d);d=0;break a}ub(d);i=i+1|0;continue}}}else{w[((e<<5)+a|0)+480284>>1]=e&1?192:64;e=e+1|0;continue}break}a=N()|0;ub(d);Q(a|0);p()}fb=g+3056|0;return d|0}function Wpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=fb-192|0;fb=d;yc(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{g=d+180|0;l:{if(!gp(b,g)){break l}if(!OX(g)){break l}g=_h(d+160|0);h=Fb(d+148|0);fw(d+84|0);x[31609]=0;f=P(617,b|0,d+76|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break h}m:{if(!f){break m}n=d,o=$b($b(x[d+80>>2])-4|0),x[n+80>>2]=o;j=(c|0)!=64;while(1){f=$b($b(x[d+80>>2])-8|0);x[d+80>>2]=f;n:{if(j){break n}if(($b(x[d+76>>2])|0)!=1347699796){break n}k=1;break m}x[31609]=0;e=d+56|0;S(185,e|0,b|0,$b(f)|0);f=x[31609];x[31609]=0;if((f|0)==1){break d}f=hc(d,e);ub(e);e=x[f>>2];x[31609]=0;i=R(172,e|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break b}o:{if(!i){break o}p:{e=$b(x[d+76>>2]);if((e|0)!=1129139796){if((e|0)!=1229866575){if((e|0)==1347699796){break p}if((e|0)!=1447383635){break o}x[31609]=0;P(183,f|0,4)|0;e=x[31609];x[31609]=0;if((e|0)==1){break b}x[31609]=0;e=R(618,f|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break b}if(!e){break o}e=$b(x[d+80>>2]);if(e>>>0<7){break o}l=x[Fc(d+52|0,28)>>2];x[31609]=0;V(619,f|0,h|0,l|0,e-6|0);e=x[31609];x[31609]=0;if((e|0)==1){break b}break o}x[31609]=0;m=P(620,f|0,d+84|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break o}break b}ax(g,f);break o}x[31609]=0;k=U(621,a|0,f|0,c|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break b}}ub(f);if(i){x[31609]=0;f=P(617,b|0,d+76|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break i}if(f){continue}}break}if(Ad(x[h+4>>2],y[h+11|0])){x[31609]=0;b=P(1,d+56|0,14972)|0;c=x[31609];x[31609]=0;if((c|0)==1){break g}zb(h,b);tb(b)}q:{if(!(k&m&1)){break q}b=y[d+126|0]|y[d+127|0]<<8;x[31609]=0;b=Bb(b)&256;U(266,a+1074312|0,5,!b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break f}c=Bb(y[d+122|0]|y[d+123|0]<<8);if(c){w[d>>1]=64;w[d+40>>1]=c;n=a,o=z[Oc(d,d+40|0)>>1],x[n+480228>>2]=o}c=!b;b=Bb(y[d+124|0]|y[d+125|0]<<8);if(!(c|!b)){x[a+480204>>2]=D(b,1e4)}if(y[d+84|0]){b=d+40|0;Te(b,2,d+84|0);x[31609]=0;O(218,d|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break e}zb(a+1298308|0,d);tb(d)}c=y[d+130|0]|y[d+131|0]<<8;if(!er(c,1,12)){break q}f=y[d+128|0]|y[d+129|0]<<8;if(!er(f,1,31)){break q}e=y[d+134|0]|y[d+135|0]<<8;if(!er(e,0,23)){break q}i=y[d+136|0]|y[d+137|0]<<8;if(!er(i,0,59)){break q}j=y[d+138|0]|y[d+139|0]<<8;if(!er(j,0,59)){break q}x[a+1298408>>2]=0;b=jp(d);n=b,o=Bb(y[d+132|0]|y[d+133|0]<<8)+1900|0,x[n>>2]=o;n=b,o=Bb(c),x[n+4>>2]=o;n=b,o=Bb(f),x[n+8>>2]=o;n=b,o=Bb(e),x[n+12>>2]=o;n=b,o=Bb(i),x[n+16>>2]=o;n=b,o=Bb(j),x[n+24>>2]=o;x[b+28>>2]=0;x[31609]=0;O(447,a+1298412|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break q}a=N()|0;break a}if(k&1){b=x[g>>2];x[31609]=0;b=R(172,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break h}if(b){b=Fb(d);x[31609]=0;S(270,g|0,b|0,32);c=x[31609];x[31609]=0;if((c|0)==1){break c}if(!Nd(b,13859)){x[31609]=0;c=d+40|0;S(258,c|0,28,b|0);f=x[31609];x[31609]=0;if((f|0)==1){break c}zb(a+1298320|0,c);tb(c)}c=x[g+8>>2];f=x[g>>2];x[31609]=0;c=P(622,f|0,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break c}if(!c){x[31609]=0;c=R(202,g|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break c}x[31609]=0;aa(316,a+1298332|0,g|0,c|0,40,0);c=x[31609];x[31609]=0;if((c|0)==1){break c}}tb(b)}x[31609]=0;b=P(1,d+40|0,18176)|0;c=x[31609];x[31609]=0;if((c|0)==1){break k}x[31609]=0;S(489,d|0,b|0,h|0);c=x[31609];x[31609]=0;if((c|0)==1){break j}zb(a+1298368|0,d);tb(d);tb(b)}x[a+480208>>2]=x[a+480208>>2]|2097152;x[31609]=0;a=U(266,a+1074312|0,84,1)|0;b=x[31609];x[31609]=0;if((b|0)==1){break h}x[31609]=0;a=U(266,a|0,83,1)|0;b=x[31609];x[31609]=0;if((b|0)==1){break h}x[31609]=0;P(267,a|0,85)|0;a=x[31609];x[31609]=0;if((a|0)==1){break h}}tb(h);ub(g)}fb=d+192|0;return k&1}a=N()|0;break a}a=N()|0;tb(b);break a}a=N()|0;break a}a=N()|0;break a}a=N()|0;break a}a=N()|0;break a}a=N()|0;break a}a=N()|0;break a}a=N()|0;tb(b);break a}a=N()|0;ub(f)}tb(h);ub(g);Q(a|0);p()}function Iz(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;l=fb-48|0;fb=l;x[l+44>>2]=0;a:{if(d|g|h|i){j=g?l+44|0:0;b:{if(!j){break b}k=x[j>>2];if(!k){break b}Db(k);x[j>>2]=0}x[31609]=0;X(84);k=x[31609];x[31609]=0;c:{d:{if((k|0)==1){m=Va(124540,47392,47448,48428,124728,124832,124780,124672,124660,124976,124944,124912,124900,125124,0)|0;e:{f:{n=gb;if((n|0)==($(124540)|0)){k=Y(m|0)|0;x[31609]=0;O(1098,j|0,k|0);j=x[31609];x[31609]=0;k=277;if((j|0)==1){break f}break c}if(($(47392)|0)==(n|0)){k=Y(m|0)|0;x[31609]=0;O(1098,j|0,k|0);j=x[31609];x[31609]=0;k=358;if((j|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break e}if(($(47448)|0)==(n|0)){k=Y(m|0)|0;x[31609]=0;O(1098,j|0,k|0);j=x[31609];x[31609]=0;k=359;if((j|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break e}if(($(48428)|0)==(n|0)){k=Y(m|0)|0;x[31609]=0;O(1098,j|0,k|0);j=x[31609];x[31609]=0;k=357;if((j|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break e}if(($(124728)|0)==(n|0)){k=Y(m|0)|0;x[31609]=0;O(1098,j|0,k|0);j=x[31609];x[31609]=0;k=300;if((j|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break e}if(($(124832)|0)==(n|0)){k=Y(m|0)|0;x[31609]=0;O(1098,j|0,k|0);j=x[31609];x[31609]=0;k=299;if((j|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break e}if(($(124780)|0)==(n|0)){k=Y(m|0)|0;x[31609]=0;O(1098,j|0,k|0);j=x[31609];x[31609]=0;k=298;if((j|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break e}if(($(124672)|0)==(n|0)){k=Y(m|0)|0;x[31609]=0;O(1098,j|0,k|0);j=x[31609];x[31609]=0;k=297;if((j|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break e}if(($(124660)|0)==(n|0)){k=Y(m|0)|0;x[31609]=0;O(1098,j|0,k|0);j=x[31609];x[31609]=0;k=296;if((j|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break e}if(($(124976)|0)==(n|0)){k=Y(m|0)|0;x[31609]=0;O(1098,j|0,k|0);j=x[31609];x[31609]=0;k=289;if((j|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break e}if(($(124944)|0)==(n|0)){k=Y(m|0)|0;x[31609]=0;O(1098,j|0,k|0);j=x[31609];x[31609]=0;k=288;if((j|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break e}if(($(124912)|0)==(n|0)){k=Y(m|0)|0;x[31609]=0;O(1098,j|0,k|0);j=x[31609];x[31609]=0;k=287;if((j|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break e}if(($(124900)|0)==(n|0)){k=Y(m|0)|0;x[31609]=0;O(1098,j|0,k|0);j=x[31609];x[31609]=0;k=286;if((j|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break e}o=$(125124)|0;k=257;m=Y(m|0)|0;if((n|0)!=(o|0)){break c}x[31609]=0;O(1098,j|0,m|0);j=x[31609];x[31609]=0;k=267;if((j|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){break e}break d}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break d}}T(0)|0;Sb()}p()}Q(a|0);p()}Z();m=!g;if(d){j=ib[d|0](k,e)|0}else{j=3}if(!(m|!(j&2))){x[g+16>>2]=k;m=g;g=x[l+44>>2];q=m,r=Cg(g?g:22292),x[q+20>>2]=r}if(h){x[h>>2]=k}g=x[l+44>>2];if(i){q=i,r=Cg(g?g:22292),x[q>>2]=r;g=x[l+44>>2]}if(g){Db(g);x[l+44>>2]=0}if(!(j&1)){break a}}x[31609]=0;g=l+32|0;O(1096,g|0,a|0);h=x[31609];x[31609]=0;g:{h:{if((h|0)!=1){i:{if(f){h=x[f+24>>2];x[31609]=0;O(1097,h|0,g|0);g=x[31609];x[31609]=0;if((g|0)!=1){break i}break h}g=Kb(l+32|0);if(b){x[31609]=0;O(b|0,g|0,c|0);g=x[31609];x[31609]=0;if((g|0)==1){break h}break i}ju(g,l)}tb(l+32|0);break a}g=T(0)|0;break g}g=T(0)|0;tb(l+32|0)}Y(g|0)|0;x[l+28>>2]=f;x[l+24>>2]=e;x[l+20>>2]=d;x[l+16>>2]=c;x[l+12>>2]=b;x[l+8>>2]=a?a:22292;x[l+4>>2]=254;x[l>>2]=9190;xP(18485,l);iu(125480);Z()}fb=l+48|0}function Lo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,A=0,B=0;f=fb+-64|0;fb=f;r=NB(x[a+24>>2],y[a+32|0]);t=Ij(r);c=t;e=x[a>>2];d=Ud(e,x[a+4>>2]);a:{if(c>>>0>d>>>0){k=fb-32|0;fb=k;c=c-d|0;d=x[Ab(a)>>2];e=x[a+4>>2];b:{if(c>>>0<=(d-e|0)/12>>>0){e=fb-16|0;fb=e;c=vv(e+4|0,a,c);d=x[c+4>>2];g=x[c+8>>2];while(1){if((d|0)==(g|0)){kc(c);fb=e+16|0}else{_T(d);d=d+12|0;x[c+4>>2]=d;continue}break}break b}d=Ab(a);d=zm(k+12|0,Pp(a,Ud(x[a>>2],e)+c|0),Ud(x[a>>2],x[a+4>>2]),d);g=fb-16|0;fb=g;c=tW(g+4|0,d+8|0,c);e=x[c>>2];while(1){if(x[c+4>>2]!=(e|0)){_T(e);e=x[c>>2]+12|0;x[c>>2]=e;continue}break}je(c);fb=g+16|0;g=fb-16|0;fb=g;h=Ab(a);c=vb(g+12|0,x[a+4>>2]);i=vb(g+8|0,x[a>>2]);j=vb(g+4|0,x[d+4>>2]);e=x[c>>2];i=x[i>>2];c=fb+-64|0;fb=c;j=x[j>>2];x[c+56>>2]=j;x[c+60>>2]=e;x[c+52>>2]=j;h=Ag(c+24|0,h,c+52|0,c+56|0);x[c+16>>2]=x[h+8>>2];j=x[h+4>>2];x[c+8>>2]=x[h>>2];x[c+12>>2]=j;zg(c+36|0,c+8|0);while(1){if(Fd(e,i)){DC(Op(x[c+56>>2]),cl(e));e=lk(c+60|0);lk(c+56|0);e=x[e>>2];continue}break}yg(c+36|0);j=x[c+56>>2];if(!y[c+48|0]){h=fb-16|0;fb=h;e=vb(h+12|0,x[x[c+44>>2]>>2]);n=x[vb(h+8|0,x[x[c+40>>2]>>2])>>2];i=fb-16|0;fb=i;e=x[e>>2];x[i+12>>2]=e;while(1){if(xi(e,n)){tf(Ax(e));e=x[ym(i+12|0)>>2];continue}break}fb=i+16|0;fb=h+16|0}fb=c- -64|0;x[d+4>>2]=j;Tb(a,d+4|0);Tb(a+4|0,d+8|0);Tb(Ab(a),nc(d));x[d>>2]=x[d+4>>2];fb=g+16|0;c=x[d+4>>2];while(1){e=x[d+8>>2];if((e|0)!=(c|0)){e=e-12|0;x[d+8>>2]=e;tf(e);continue}break}c=x[d>>2];if(c){ts(d);Db(c)}}fb=k+32|0;break a}if(c>>>0<d>>>0){eU(a,e+D(c,12)|0)}}if(b){c=a+12|0;Lq(c,de(c));A=Ab(c),B=0,x[A>>2]=B;d=c;c=gc(c);x[d>>2]=c;x[c>>2]=0;x[a+28>>2]=0}h=Nb(f+52|0);c=x[a+24>>2];c=Zu(x[c+484344>>2],x[c+484348>>2]);x[31609]=0;i=U(626,f+40|0,c|0,28556)|0;c=x[31609];x[31609]=0;c:{if((c|0)!=1){g=a+12|0;while(1){if((l|0)==(t|0)){od(i);ec(h);fb=f- -64|0;return}c=x[a+24>>2];d=x[c+484344>>2];c=x[c+484348>>2];j=z[bc(x[r>>2],l)>>1];d=jU(d,c,j);x[f+36>>2]=d;c=Vd(x[a>>2],l);d:{e:{f:{if(b){x[31609]=0;v[f+20|0]=0;S(802,c|0,d|0,f+20|0);d=x[31609];x[31609]=0;if((d|0)!=1){break f}d=N()|0;break e}x[31609]=0;O(758,c|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){break f}d=N()|0;break e}if(!Yi(r,l&65535)){break d}x[f+20>>2]=b?0:x[c+4>>2];c=f+20|0;s=x[Hb(c,f+36|0)>>2];n=Pf(g);d=z[bc(x[i>>2],j)>>1];if((d|0)!=65535){d=hU(g,z[dn(c,d,s)>>1],x[f+24>>2]);g:{if(Zg(d,Pf(g))){c=hU(g,z[dn(c,z[bc(x[i>>2],j)>>1],x[f+36>>2])>>1],x[f+24>>2]);break g}c=Pf(g)}x[f+32>>2]=d;while(1){h:{if(!Zg(d,c)){break d}e=Nb(f+20|0);d=Tn(ud(d)+8|0);x[31609]=0;O(803,e|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){d=Fc(f+12|0,n);k=dn(f+4|0,l,x[ud(x[f+32>>2])+4>>2]);d=x[d>>2];x[31609]=0;d=ba(804,g|0,d|0,k|0,e|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break h}x[f+16>>2]=d;n=x[ah(f+16|0)>>2];Ce(e);d=x[ah(f+32|0)>>2];continue}}break}d=N()|0;Ce(e);break e}q=Wb(x[x[a+24>>2]+484344>>2],j);c=z[x[x[q+48>>2]+12>>2]+480188>>1];x[31609]=0;v[f+20|0]=0;S(779,h|0,c|0,f+20|0);c=x[31609];x[31609]=0;if((c|0)!=1){o=x[f+36>>2];i:while(1){j:{if((o|0)==(s|0)){if(s){break d}A=bc(x[i>>2],j),B=l,w[A>>1]=B;break d}c=1;k=0;e=x[x[q+48>>2]+12>>2];o=o-1|0;d=md(x[q>>2],e,o,0);while(1){if(c>>>0<16&z[e+480188>>1]>k>>>0){u=xb(x[h>>2],k);e=y[u|0];k:{l:{m:{switch(y[d+3|0]-19|0){case 1:m=y[d+5|0];if((m&240)==176){break l}break k;case 0:break m;default:break k}}m=y[d+5|0];if((m&240)!=96){break k}}v[u|0]=m&15;m=y[xb(x[h>>2],k)|0];e=m?m:e}d=d+6|0;k=k+1|0;c=D((e&255)+1|0,c);e=x[x[q+48>>2]+12>>2];continue}else{n:{if(c>>>0<=1){continue i}e=Nb(f+20|0);x[31609]=0;O(803,e|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break n}c=Fc(f,n);d=dn(f+4|0,l,o);c=x[c>>2];x[31609]=0;n=ba(804,g|0,c|0,d|0,e|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break j}Ce(e);continue i}}break}}break}d=N()|0;Ce(e);break e}d=N()|0}od(i);break c}l=l+1|0;continue}}d=N()|0}ec(h);Q(d|0);p()}function F7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;h=fb-48|0;fb=h;x[h+44>>2]=b;x[e>>2]=0;cd(h,x[d+28>>2]);x[31609]=0;i=R(1252,x[h>>2])|0;j=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{if((j|0)!=1){_b(h);switch(g-65|0){case 54:break j;case 19:break k;case 18:break l;case 17:break m;case 49:break n;case 47:break o;case 45:case 51:break p;case 12:break q;case 44:break r;case 41:break s;case 8:break t;case 7:break u;case 5:break v;case 3:break w;case 35:case 36:break x;case 34:break y;case 1:case 33:case 39:break z;case 0:case 32:break A;case 2:case 4:case 6:case 9:case 10:case 11:case 13:case 14:case 15:case 16:case 20:case 21:case 22:case 25:case 26:case 27:case 28:case 29:case 30:case 31:case 37:case 38:case 40:case 42:case 43:case 46:case 48:case 50:case 52:case 53:break d;case 24:break f;case 56:break g;case 23:break h;case 55:break i;default:break e}}a=N()|0;_b(h);Q(a|0);p()}mK(a,f+24|0,h+44|0,c,e,i);break b}lK(a,f+16|0,h+44|0,c,e,i);break b}b=ib[x[x[a+8>>2]+12>>2]](a+8|0)|0;g=a;i=x[h+44>>2];a=Kb(b);k=h,l=rk(g,i,c,d,e,f,a,a+(Cb(x[b+4>>2],y[b+11|0])<<2)|0),x[k+44>>2]=l;break b}a=ij(h+44|0,c,e,i,2);b=x[e>>2];B:{if(!(b&4|a-1>>>0>30)){x[f+12>>2]=a;break B}x[e>>2]=b|4}break b}x[h+24>>2]=37;x[h+28>>2]=121;x[h+16>>2]=100;x[h+20>>2]=47;x[h+8>>2]=47;x[h+12>>2]=37;x[h>>2]=37;x[h+4>>2]=109;k=h,l=rk(a,b,c,d,e,f,h,h+32|0),x[k+44>>2]=l;break b}x[h+24>>2]=37;x[h+28>>2]=100;x[h+16>>2]=109;x[h+20>>2]=45;x[h+8>>2]=45;x[h+12>>2]=37;x[h>>2]=37;x[h+4>>2]=89;k=h,l=rk(a,b,c,d,e,f,h,h+32|0),x[k+44>>2]=l;break b}a=ij(h+44|0,c,e,i,2);b=x[e>>2];C:{if(!(b&4|(a|0)>23)){x[f+8>>2]=a;break C}x[e>>2]=b|4}break b}a=ij(h+44|0,c,e,i,2);b=x[e>>2];D:{if(!(b&4|a-1>>>0>11)){x[f+8>>2]=a;break D}x[e>>2]=b|4}break b}a=ij(h+44|0,c,e,i,3);b=x[e>>2];E:{if(!(b&4|(a|0)>365)){x[f+28>>2]=a;break E}x[e>>2]=b|4}break b}a=ij(h+44|0,c,e,i,2);b=x[e>>2];a=a-1|0;F:{if(!(b&4|a>>>0>11)){x[f+16>>2]=a;break F}x[e>>2]=b|4}break b}a=ij(h+44|0,c,e,i,2);b=x[e>>2];G:{if(!(b&4|(a|0)>59)){x[f+4>>2]=a;break G}x[e>>2]=b|4}break b}a=h+44|0;b=fb-16|0;fb=b;x[b+12>>2]=c;while(1){H:{if(hi(a,b+12|0)){break H}if(!rj(i,1,tl(x[a>>2]))){break H}io(a);continue}break}if(hi(a,b+12|0)){x[e>>2]=x[e>>2]|2}fb=b+16|0;break b}b=h+44|0;a=ib[x[x[a+8>>2]+8>>2]](a+8|0)|0;I:{if((Cb(x[a+4>>2],y[a+11|0])|0)==(0-Cb(x[a+16>>2],y[a+23|0])|0)){x[e>>2]=x[e>>2]|4;break I}c=st(b,c,a,a+24|0,i,e,0);b=x[f+8>>2];if(!((c|0)!=(a|0)|(b|0)!=12)){x[f+8>>2]=0;break I}if(!((c-a|0)!=12|(b|0)>11)){x[f+8>>2]=b+12}}break b}x[h+40>>2]=112;x[h+32>>2]=32;x[h+36>>2]=37;x[h+24>>2]=37;x[h+28>>2]=83;x[h+16>>2]=77;x[h+20>>2]=58;x[h+8>>2]=58;x[h+12>>2]=37;x[h>>2]=37;x[h+4>>2]=73;k=h,l=rk(a,b,c,d,e,f,h,h+44|0),x[k+44>>2]=l;break b}x[h+16>>2]=77;x[h+8>>2]=58;x[h+12>>2]=37;x[h>>2]=37;x[h+4>>2]=72;k=h,l=rk(a,b,c,d,e,f,h,h+20|0),x[k+44>>2]=l;break b}a=ij(h+44|0,c,e,i,2);b=x[e>>2];J:{if(!(b&4|(a|0)>60)){x[f>>2]=a;break J}x[e>>2]=b|4}break b}x[h+24>>2]=37;x[h+28>>2]=83;x[h+16>>2]=77;x[h+20>>2]=58;x[h+8>>2]=58;x[h+12>>2]=37;x[h>>2]=37;x[h+4>>2]=72;k=h,l=rk(a,b,c,d,e,f,h,h+32|0),x[k+44>>2]=l;break b}a=ij(h+44|0,c,e,i,1);b=x[e>>2];K:{if(!(b&4|(a|0)>6)){x[f+24>>2]=a;break K}x[e>>2]=b|4}break b}a=ib[x[x[a>>2]+20>>2]](a,b,c,d,e,f)|0;break a}b=ib[x[x[a+8>>2]+24>>2]](a+8|0)|0;g=a;i=x[h+44>>2];a=Kb(b);k=h,l=rk(g,i,c,d,e,f,a,a+(Cb(x[b+4>>2],y[b+11|0])<<2)|0),x[k+44>>2]=l;break b}kK(f+20|0,h+44|0,c,e,i);break b}a=ij(h+44|0,c,e,i,4);if(!(y[e|0]&4)){x[f+20>>2]=a-1900}break b}if((g|0)==37){break c}}x[e>>2]=x[e>>2]|4;break b}a=fb-16|0;fb=a;x[a+12>>2]=c;b=6;c=h+44|0;d=a+12|0;L:{M:{if(hi(c,d)){break M}b=4;if((qk(i,tl(x[c>>2]))|0)!=37){break M}b=2;if(!hi(io(c),d)){break L}}x[e>>2]=x[e>>2]|b}fb=a+16|0}a=x[h+44>>2]}fb=h+48|0;return a|0}function osa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;j=fb-720|0;fb=j;a:{b:{if(d>>>0<=511){d=fb-16|0;fb=d;a=j+46|0;cc(d+8|0,a,554);e=x[d+12>>2];lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2]);f=x[d+4>>2];if((f|0)==(e|0)){Vb(b,x[d+12>>2])}fb=d+16|0;b=(e|0)==(f|0);if(!b){Rb(a,0,554)}if(!b){break b}d=fb-32|0;fb=d;c:{if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=1229999433){break c}e=d+8|0;Wr(e,a+32|0);b=d+20|0;Cc(b,e);Ac(c+492|0,b);tb(b);ek(e,1,a+4|0);Cc(b,e);Ac(c+524|0,b);tb(b);b=y[a+24|0]|y[a+25|0]<<8;x[c+4>>2]=64;x[c+8>>2]=128;x[c>>2]=b<<6;v[c+16|0]=y[a+26|0];v[c+17|0]=y[a+27|0];f=c+108|0;k=c+236|0;b=0;while(1)if((b|0)==120){b=y[c+60|0]&-2|v[a+17|0]&1;v[c+60|0]=b;b=b&-3|y[a+17|0]&2;v[c+60|0]=b;v[c+60|0]=b&251|y[a+17|0]&4;k=c+61|0;v[k|0]=y[a+18|0];g=c+62|0;v[g|0]=y[a+19|0];h=c+63|0;v[h|0]=y[a+20|0];i=c- -64|0;v[i|0]=y[a+21|0];f=c+48|0;fh(f,25);e=x[c+48>>2];b=0;while(1){d:{if((b|0)!=25){l=yb(e,b);m=b<<1;n=y[(a+m|0)+504|0];w[l>>1]=n;if((n|0)!=255){break d}fh(f,b);e=x[f>>2]}b=cf(k,g);a=Sd(e,x[c+52>>2]);if(a>>>0<=y[b|0]){v[c+60|0]=y[c+60|0]&253}if(a>>>0>y[cf(h,i)|0]){break c}v[c+60|0]=y[c+60|0]&251;break c}v[l+2|0]=y[(a+(m|1)|0)+504|0];b=b+1|0;continue}}else{g=a+(b<<1)|0;e=y[g- -64|0];o=bc(k,b),q=y[g+65|0],w[o>>1]=q;o=xb(f,b),q=(e>>>0<120?e:b)+1|0,v[o|0]=q;b=b+1|0;continue}}fb=d+32|0;break b}k=x[b+8>>2];d=fb-32|0;fb=d;x[d+28>>2]=674;x[d+8>>2]=674;e=x[b>>2];g=x[b+8>>2];f=x[Hb(d+28|0,d+8|0)>>2];if(!Mb(e,g,f)){f=jf(b)}g=d+8|0;e=j+46|0;RZ(g,e);h=Zb(d+16|0,x[d+8>>2],f);i=x[h>>2];lc(d,x[b>>2],x[b+8>>2],i,x[h+4>>2]);RZ(g,e);Rb(x[d+8>>2]+f|0,0,674-f|0);Vb(b,x[d+28>>2]);fb=d+32|0;g=x[a+480180>>2];a=0;d=fb-32|0;fb=d;if((y[e|0]|y[e+1|0]<<8|(y[e+2|0]<<16|y[e+3|0]<<24))==1229999433){f=d+8|0;Wr(f,e+32|0);a=d+20|0;Cc(a,f);Ac(c+492|0,a);tb(a);ek(f,1,e+4|0);Cc(a,f);Ac(c+524|0,a);tb(a);x[c>>2]=(y[e+20|0]|y[e+21|0]<<8)<<5;x[c+4>>2]=y[e+24|0]>>>1;xc(c+4|0,64);h=y[e+25|0]&127;x[c+8>>2]=h>>>0>64?128:h<<2;v[c+15|0]=y[c+15|0]&254|((y[e+25|0]^-1)&128)>>>7;v[d+20|0]=y[e+26|0];v[d+8|0]=100;o=c,q=y[Qb(a,f)|0],v[o+20|0]=q;v[d+20|0]=y[e+27|0];v[d+8|0]=64;o=c,q=y[Qb(a,f)|0],v[o+19|0]=q;v[c+16|0]=y[e+17|0];v[c+17|0]=y[e+18|0];v[c+18|0]=y[e+19|0];v[c+26|0]=y[e+22|0];v[c+27|0]=y[e+23|0];a=y[e+58|0];dk(c,a&127,a>>>7|0);a=y[e+59|0];ck(c,a&127,a>>>7|0);e:{f:{g:{h:{i:{j:{a=y[e+28|0]|y[e+29|0]<<8;switch(a-529|0){case 1:case 2:break h;case 0:case 3:break i;default:break j}}if((a|0)==544){break i}if((a|0)!=514){break h}}a=y[e+61|0];if((a|0)==255){break g}if(a>>>0<=128){v[c+30|0]=a}a=y[e+62|0]|y[e+63|0]<<8;if(a>>>0<129){break f}break e}a=v[e+61|0];if((a|0)<0){break g}v[c+30|0]=a+1}a=v[e+62|0];a=((a|0)>=0?a+1|0:0)&255;f=v[e+63|0];if((f|0)<0){break f}a=((f&255)<<7)+a|0}w[c+28>>1]=a}a=v[e+60|0];v[c+31|0]=a;if((a|0)<0){v[c+31|0]=0;v[c+34|0]=a&127}a=0;f=g&16777216?240:25;Yw(e+304|0,c+48|0,0,f);Yw(e+386|0,c+68|0,32,f);Yw(e+468|0,c+88|0,32,f);v[c+100|0]=y[c+100|0]&239|y[e+468|0]>>>3&16;g=c+108|0;h=c+236|0;while(1){if((a|0)!=120){i=e+(a<<1)|0;f=y[i- -64|0];o=bc(h,a),q=y[i+65|0],w[o>>1]=q;o=xb(g,a),q=(f>>>0<120?f:a)+1|0,v[o|0]=q;a=a+1|0;continue}break}a=554}fb=d+32|0;d=0;k:{if(!a){break k}d=y[e+550|0]|y[e+551|0]<<8|(y[e+552|0]<<16|y[e+553|0]<<24);if(!((d|0)!=1481920589&(d|0)!=1297110104)){d=c+236|0;a=0;while(1){if((a|0)!=120){f=bc(d,a);w[f>>1]=z[f>>1]|y[(a+e|0)+554|0]<<8;a=a+1|0;continue}break}a=674}d=a}dd(b,d+k|0);if(!bk(b,14092)){break b}d=j+4|0;he(d,b,Rg(b));a=hc(j+24|0,d);ub(d);b=x[a>>2];x[31609]=0;R(154,b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}x[31609]=0;b=P(412,a|0,13874)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}if(b){x[31609]=0;b=R(197,a|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}v[c+34|0]=b>>>0<=250?b:0}ub(a)}fb=j+720|0;return}b=N()|0;ub(a);Q(b|0);p()}function Dta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;d=fb-320|0;fb=d;yc(b);a:{e=d+308|0;if(!gp(b,e)){break a}if(!r$(e)){break a}if((y[d+308|0]|y[d+309|0]<<8|(y[d+310|0]<<16|y[d+311|0]<<24))==1179472708){Vb(b,4)}if(!wi(b,d+300|0)|(y[d+300|0]|y[d+301|0]<<8|(y[d+302|0]<<16|y[d+303|0]<<24))!=1196314451){break a}i=1;if((c|0)==64){break a}f=d+108|0;C0(b,f,y[d+304|0]|y[d+305|0]<<8|(y[d+306|0]<<16|y[d+307|0]<<24));i=0;if((y[d+144|0]|y[d+145|0]<<8)>>>0>128|(y[d+150|0]|y[d+151|0]<<8)>>>0>16|((y[d+148|0]|y[d+149|0]<<8)>>>0>256|(y[d+142|0]|y[d+143|0]<<8)>>>0>128)){break a}Dd(a,8192);e=d+24|0;g=uc(e,6574);zb(a+1298344|0,g);tb(g);g=uc(e,10157);zb(a+1298356|0,g);tb(g);r=a+1298404|0,s=x[Fc(e,4)>>2],x[r>>2]=s;g=d+88|0;Xi(g,2,f);Cc(e,g);zb(a+1298308|0,e);tb(e);w[d+24>>1]=y[d+150|0]|y[d+151|0]<<8;w[d+88>>1]=1;f=z[qe(e,g)>>1];w[a+480188>>1]=f;x[a+480196>>2]=y[d+154|0];x[a+480204>>2]=D(y[d+155|0],1e4);v[d+24|0]=y[d+152|0];v[d+88|0]=64;e=y[Qb(e,g)|0];x[a+480200>>2]=e<<2;if(!e){x[a+480200>>2]=256}e=y[d+153|0];b:{if((e|0)==128){x[d+24>>2]=256/(f>>>0);x[d+88>>2]=128;e=x[Hb(d+24|0,d+88|0)>>2];break b}e=e&127}x[a+480228>>2]=e;e=0;while(1){if((e|0)==16){f=Xb(x[a+484360>>2],y[a+484376|0]);h=d+172|0;g=fb-16|0;fb=g;x[g+12>>2]=y[d+144|0]|y[d+145|0]<<8;e=g+12|0;xc(e,128);xc(e,65535);j=z[g+12>>1];vg(f,j);e=0;while(1){if((e|0)==(j|0)){fb=g+16|0}else{i=y[e+h|0];r=Qr(x[f>>2],x[f+4>>2],e),s=(i|0)==255?-1:(i|0)==254?-2:i,w[r>>1]=s;e=e+1|0;continue}break}e=y[d+142|0]|y[d+143|0]<<8;if(e>>>0<(y[d+144|0]|y[d+145|0]<<8)>>>0){$e(Xb(x[a+484360>>2],y[a+484376|0]),e)}n=c&2;j=a+484344|0;i=1;o=c&1;q=d+60|0;while(1){if(!wi(b,d+300|0)){break a}e=d+24|0;he(e,b,y[d+304|0]|y[d+305|0]<<8|(y[d+306|0]<<16|y[d+307|0]<<24));c=hc(d+88|0,e);ub(e);c:{d:{if(!(!o|(y[d+300|0]|y[d+301|0]<<8|(y[d+302|0]<<16|y[d+303|0]<<24))!=1414807888)){x[31609]=0;k=m&65535;e=U(196,j|0,k|0,64)|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(!e){break c}x[31609]=0;P(183,c|0,2)|0;e=x[31609];x[31609]=0;if((e|0)==1){break d}g=0;e:{while(1){e=x[c>>2];x[31609]=0;e=U(150,e|0,x[d+96>>2],1)|0;f=x[31609];x[31609]=0;f:{if((f|0)!=1){if(!(e&g>>>0<64)){break e}x[31609]=0;e=R(197,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break d}h=e<<24>>24;if(h){break f}g=g+1|0;continue}break d}e=d+24|0;f=h&15;if(f>>>0<z[a+480188>>1]){e=Wb(x[j>>2],k);e=md(x[e>>2],x[x[e+48>>2]+12>>2],g,f)}g:{if((h|0)>=0){break g}x[31609]=0;f=R(197,c|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break d}if(!f){break g}v[e|0]=f>>>0<109?f+12|0:f}f=h&255;if(f&64){x[31609]=0;h=R(197,c|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break d}v[e+1|0]=h}if(f&32){v[e+2|0]=1;x[31609]=0;h=R(197,c|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break d}v[d+12|0]=h;v[d|0]=64;r=e,s=y[Qb(d+12|0,d)|0],v[r+4|0]=s}if(!(f&16)){continue}x[31609]=0;f=d+12|0;O(198,f|0,c|0);h=x[31609];x[31609]=0;if((h|0)!=1){Cf(e,y[d+12|0],y[Jc(f)|0]);continue}break}break d}m=m+1|0;break c}if((y[d+300|0]|y[d+301|0]<<8|(y[d+302|0]<<16|y[d+303|0]<<24))!=1414745673){break c}e=z[a+480190>>1];if(!pi(e)){break c}e=e+1|0;w[a+480190>>1]=e;x[31609]=0;g=d+24|0;O(324,c|0,g|0);f=x[31609];x[31609]=0;h:{if((f|0)==1){break h}x[31609]=0;k=(D(e&65535,104)+a|0)+484380|0;O(325,g|0,k|0);e=x[31609];x[31609]=0;if((e|0)==1){break h}Xi(d,2,q);x[31609]=0;e=d+12|0;O(218,e|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break h}Ac(((z[a+480190>>1]<<5)+a|0)+946304|0,e);tb(e);if(!n){break c}g=y[d+37|0]|y[d+38|0]<<8;f=2;h=Zc(e,8,1,0,1);i:{if(!(g&64)){f=0;if(!(g&2)){break i}}wg(h,f)}if(g&4){hd(h,16)}x[31609]=0;U(215,e|0,k|0,c|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break c}}}a=N()|0;ub(c);Q(a|0);p()}ub(c);continue}}g=(e<<5)+a|0;Ue(g+480280|0);f=y[(d+e|0)+156|0];if(f>>>0<=128){w[g+480284>>1]=f<<1}e=e+1|0;continue}}fb=d+320|0;return i|0}function L7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;h=fb-16|0;fb=h;x[h+12>>2]=b;x[e>>2]=0;cd(h,x[d+28>>2]);x[31609]=0;i=R(28,x[h>>2])|0;j=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{if((j|0)!=1){_b(h);switch(g-65|0){case 54:break j;case 19:break k;case 18:break l;case 17:break m;case 49:break n;case 47:break o;case 45:case 51:break p;case 12:break q;case 44:break r;case 41:break s;case 8:break t;case 7:break u;case 5:break v;case 3:break w;case 35:case 36:break x;case 34:break y;case 1:case 33:case 39:break z;case 0:case 32:break A;case 2:case 4:case 6:case 9:case 10:case 11:case 13:case 14:case 15:case 16:case 20:case 21:case 22:case 25:case 26:case 27:case 28:case 29:case 30:case 31:case 37:case 38:case 40:case 42:case 43:case 46:case 48:case 50:case 52:case 53:break d;case 24:break f;case 56:break g;case 23:break h;case 55:break i;default:break e}}a=N()|0;_b(h);Q(a|0);p()}qK(a,f+24|0,h+12|0,c,e,i);break b}pK(a,f+16|0,h+12|0,c,e,i);break b}b=ib[x[x[a+8>>2]+12>>2]](a+8|0)|0;g=a;i=x[h+12>>2];a=Kb(b);k=h,l=sk(g,i,c,d,e,f,a,Cb(x[b+4>>2],y[b+11|0])+a|0),x[k+12>>2]=l;break b}a=jj(h+12|0,c,e,i,2);b=x[e>>2];B:{if(!(b&4|a-1>>>0>30)){x[f+12>>2]=a;break B}x[e>>2]=b|4}break b}v[h|0]=37;v[h+1|0]=109;v[h+2|0]=47;v[h+3|0]=37;v[h+4|0]=100;v[h+5|0]=47;v[h+6|0]=37;v[h+7|0]=121;k=h,l=sk(a,b,c,d,e,f,h,h+8|0),x[k+12>>2]=l;break b}v[h|0]=37;v[h+1|0]=89;v[h+2|0]=45;v[h+3|0]=37;v[h+4|0]=109;v[h+5|0]=45;v[h+6|0]=37;v[h+7|0]=100;k=h,l=sk(a,b,c,d,e,f,h,h+8|0),x[k+12>>2]=l;break b}a=jj(h+12|0,c,e,i,2);b=x[e>>2];C:{if(!(b&4|(a|0)>23)){x[f+8>>2]=a;break C}x[e>>2]=b|4}break b}a=jj(h+12|0,c,e,i,2);b=x[e>>2];D:{if(!(b&4|a-1>>>0>11)){x[f+8>>2]=a;break D}x[e>>2]=b|4}break b}a=jj(h+12|0,c,e,i,3);b=x[e>>2];E:{if(!(b&4|(a|0)>365)){x[f+28>>2]=a;break E}x[e>>2]=b|4}break b}a=jj(h+12|0,c,e,i,2);b=x[e>>2];a=a-1|0;F:{if(!(b&4|a>>>0>11)){x[f+16>>2]=a;break F}x[e>>2]=b|4}break b}a=jj(h+12|0,c,e,i,2);b=x[e>>2];G:{if(!(b&4|(a|0)>59)){x[f+4>>2]=a;break G}x[e>>2]=b|4}break b}a=h+12|0;b=fb-16|0;fb=b;x[b+12>>2]=c;while(1){H:{if(th(a,b+12|0)){break H}c=ul(x[a>>2]);if(!Jf(x[i+8>>2],1,c)){break H}Gm(a);continue}break}if(th(a,b+12|0)){x[e>>2]=x[e>>2]|2}fb=b+16|0;break b}b=h+12|0;a=ib[x[x[a+8>>2]+8>>2]](a+8|0)|0;I:{if((Cb(x[a+4>>2],y[a+11|0])|0)==(0-Cb(x[a+16>>2],y[a+23|0])|0)){x[e>>2]=x[e>>2]|4;break I}c=xt(b,c,a,a+24|0,i,e,0);b=x[f+8>>2];if(!((c|0)!=(a|0)|(b|0)!=12)){x[f+8>>2]=0;break I}if(!((c-a|0)!=12|(b|0)>11)){x[f+8>>2]=b+12}}break b}v[h+10|0]=112;v[h+8|0]=32;v[h+9|0]=37;v[h|0]=37;v[h+1|0]=73;v[h+2|0]=58;v[h+3|0]=37;v[h+4|0]=77;v[h+5|0]=58;v[h+6|0]=37;v[h+7|0]=83;k=h,l=sk(a,b,c,d,e,f,h,h+11|0),x[k+12>>2]=l;break b}v[h+4|0]=77;v[h|0]=37;v[h+1|0]=72;v[h+2|0]=58;v[h+3|0]=37;k=h,l=sk(a,b,c,d,e,f,h,h+5|0),x[k+12>>2]=l;break b}a=jj(h+12|0,c,e,i,2);b=x[e>>2];J:{if(!(b&4|(a|0)>60)){x[f>>2]=a;break J}x[e>>2]=b|4}break b}v[h|0]=37;v[h+1|0]=72;v[h+2|0]=58;v[h+3|0]=37;v[h+4|0]=77;v[h+5|0]=58;v[h+6|0]=37;v[h+7|0]=83;k=h,l=sk(a,b,c,d,e,f,h,h+8|0),x[k+12>>2]=l;break b}a=jj(h+12|0,c,e,i,1);b=x[e>>2];K:{if(!(b&4|(a|0)>6)){x[f+24>>2]=a;break K}x[e>>2]=b|4}break b}a=ib[x[x[a>>2]+20>>2]](a,b,c,d,e,f)|0;break a}b=ib[x[x[a+8>>2]+24>>2]](a+8|0)|0;g=a;i=x[h+12>>2];a=Kb(b);k=h,l=sk(g,i,c,d,e,f,a,Cb(x[b+4>>2],y[b+11|0])+a|0),x[k+12>>2]=l;break b}oK(f+20|0,h+12|0,c,e,i);break b}a=jj(h+12|0,c,e,i,4);if(!(y[e|0]&4)){x[f+20>>2]=a-1900}break b}if((g|0)==37){break c}}x[e>>2]=x[e>>2]|4;break b}a=fb-16|0;fb=a;x[a+12>>2]=c;b=6;c=h+12|0;d=a+12|0;L:{M:{if(th(c,d)){break M}b=4;if((nl(i,ul(x[c>>2]))|0)!=37){break M}b=2;if(!th(Gm(c),d)){break L}}x[e>>2]=x[e>>2]|b}fb=a+16|0}a=x[h+12>>2]}fb=h+16|0;return a|0}function Bsa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,A=0;g=fb-32|0;fb=g;a:{b:{if(!c){break b}f=Yh(a,b);a=wb(x[d>>2]);x[g+28>>2]=a;d=wb(x[d+4>>2]);while(1){if(!Ib(a,d)){break b}yc(a);c:{if((Qk(a)|0)==(c|0)){Vb(a,20);d=Qk(a);l=og(g+16|0);c=Zl(g+12|0,0,b?32:64);x[31609]=0;O(402,f|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break c}o=(b|0)==2?4096:(b|0)==1?2048:16384;c=24;d=d+24|0;q=1;m=1;d:{while(1){i=o;while(1){e=x[a+8>>2];h=x[a>>2];x[31609]=0;e=U(150,h|0,e|0,1)|0;h=x[31609];x[31609]=0;e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{if((h|0)!=1){if(!e){break d}e=x[f+4>>2];h=x[f>>2];j=x[a+8>>2];x[31609]=0;x[g+12>>2]=j;j=P(403,l|0,g+12|0)|0;r=x[31609];x[31609]=0;if((r|0)==1){break a}u=j,A=Sd(h,e),x[u>>2]=A;x[31609]=0;e=R(197,a|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break a}q:{switch(e-128|0){case 5:case 6:case 9:case 10:break h;case 2:break i;case 1:break j;case 0:break k;case 3:case 4:case 7:case 8:break e;default:break q}}r:{switch(e|0){case 0:break g;case 5:break l;case 4:break m;case 3:break n;case 2:break o;case 1:break p;default:break r}}s:{switch(e-160|0){case 5:case 6:break h;case 2:break i;case 1:break j;case 0:break k;case 3:case 4:break e;default:break s}}switch(e-192|0){case 2:break i;case 1:break j;case 0:break k;default:break e}}break a}if(y[f+12|0]&4){break e}x[31609]=0;e=R(273,a|0)|0;h=x[31609];x[31609]=0;t:{if((h|0)==1){break t}x[31609]=0;x[g+12>>2]=e;e=P(403,l|0,g+12|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break t}v[f+15|0]=x[e>>2];u=f,A=Sd(x[f>>2],x[f+4>>2])-1|0,v[u+16|0]=A;v[f+12|0]=y[f+12|0]|4;break e}break a}x[31609]=0;e=R(273,a|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break a}w[g+12>>1]=e;w[g+10>>1]=1;h=g+12|0;j=g+10|0;e=z[qe(h,j)>>1];i=D(e,D(s<<16>>16,m))+i|0;u:{if(e>>>0<2){break u}u=g,A=cm((e+z[xf(x[f+4>>2])>>1]|0)-1|0),w[u+12>>1]=A;e=Xv(b,i);x[31609]=0;v[g+10|0]=e;S(404,f|0,h|0,j|0);e=x[31609];x[31609]=0;if((e|0)!=1){break u}break a}u=g,A=cm(z[xf(x[f+4>>2])>>1]+1|0),w[u+12>>1]=A;e=Xv(b,i);x[31609]=0;v[g+10|0]=e;S(404,f|0,g+12|0,g+10|0);e=x[31609];x[31609]=0;if((e|0)!=1){break e}break a}x[31609]=0;k=R(197,a|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break a}t=x[a+8>>2];break e}x[31609]=0;e=R(273,a|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break a}e=c+e|0;x[g+12>>2]=e;if(!(!(k&255)|e>>>0<t>>>0)){k=k-1|0;if(!(k&255)){break f}x[31609]=0;P(149,a|0,e|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break e}break a}if(!(k&255)){break f}x[31609]=0;e=P(405,l|0,g+12|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break a}v[f+13|0]=x[e>>2];u=f,A=Sd(x[f>>2],x[f+4>>2])-1|0,v[u+14|0]=A;v[f+12|0]=y[f+12|0]|2;break e}q=0;n=1;break e}x[31609]=0;i=R(273,a|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break a}e=Xv(b,i);u=xf(x[f+4>>2]),A=e,v[u+2|0]=A;break e}x[31609]=0;s=R(406,a|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break e}break a}x[31609]=0;e=R(197,a|0)|0;m=x[31609];x[31609]=0;if((m|0)!=1){v[g+12|0]=e;v[g+10|0]=1;m=y[cf(g+12|0,g+10|0)|0];break e}break a}x[31609]=0;P(183,a|0,1)|0;e=x[31609];x[31609]=0;if((e|0)==1){break a}break e}n=1;if(c>>>0<d>>>0){break e}break d}k=0}if(!n|c>>>0>=d>>>0){continue}break}x[31609]=0;c=P(149,a|0,d|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break a}if(!c){break d}c=x[a+8>>2];i=x[a>>2];x[31609]=0;c=U(150,i|0,c|0,2)|0;i=x[31609];x[31609]=0;if((i|0)==1){break a}if(!c){break d}c=x[f+4>>2];i=y[f+12|0];if(!(i&4)&q){e=x[f>>2];v[f+12|0]=i|4;i=Sd(e,c)-1|0;v[f+15|0]=i;v[f+16|0]=i}u=g,A=cm(z[xf(c)>>1]+1|0),w[u+12>>1]=A;c=Xv(b,o);x[31609]=0;v[g+10|0]=c;S(404,f|0,g+12|0,g+10|0);c=x[31609];x[31609]=0;if((c|0)!=1){n=1;v[f+17|0]=y[f+16|0]+1;c=d;continue}break}break a}v[f+12|0]=y[f+12|0]|1;b_(l);break b}a=x[Qf(g+28|0)>>2];continue}break}break a}fb=g+32|0;return}a=N()|0;b_(l);Q(a|0);p()}function Nz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=fb-256|0;fb=f;g=x[b+4>>2];a:{if(!g){i=x[b>>2];break a}i=x[b>>2];h=y[Al(i,g)|0];if((h|0)==33){e=1}else{if((h|0)!=63){break a}e=0}Nl(f+96|0,i,g,g-1|0);g=x[f+100>>2];i=x[f+96>>2];x[b>>2]=i;x[b+4>>2]=g}j=f+96|0;ie(j);h=x[f+96>>2];k=f+236|0;ie(k);h=zl(h,x[f+240>>2],b);ie(j);b:{c:{d:{e:{if(x[f+100>>2]==(h|0)){h=qc(f+248|0,22292);a=x[h+4>>2];x[f+8>>2]=x[h>>2];x[f+12>>2]=a;if(Ic(i,g,f+8|0)){e=ac(8);x[31609]=0;c=bi(k,c,d);a=x[31609];x[31609]=0;f:{g:{h:{if((a|0)!=1){x[31609]=0;S(1011,j|0,18271,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break h}pc(e,j);a=0;x[31609]=0;S(97,e|0,48428,1e3);b=x[31609];x[31609]=0;if((b|0)!=1){break b}g=N()|0;tb(j);break g}g=N()|0;break f}g=N()|0;a=1}tb(c);if(!a){break c}}ic(e);break c}if(!e){break e}h=ac(8);e=x[b>>2];a=x[b+4>>2];x[31609]=0;i=bi(f+212|0,e,a);a=x[31609];x[31609]=0;i:{j:{k:{l:{m:{n:{o:{p:{q:{if((a|0)!=1){x[31609]=0;b=f+224|0;S(1011,b|0,18307,i|0);a=x[31609];x[31609]=0;if((a|0)==1){break q}x[31609]=0;e=f+236|0;O(1013,e|0,b|0);b=x[31609];x[31609]=0;a=1;if((b|0)==1){break p}x[31609]=0;d=bi(f+200|0,c,d);a=x[31609];x[31609]=0;if((a|0)==1){break o}x[31609]=0;c=f+96|0;S(1015,c|0,e|0,d|0);b=x[31609];x[31609]=0;a=1;if((b|0)==1){break n}pc(h,c);x[31609]=0;S(97,h|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}g=N()|0;tb(c);a=0;break m}g=N()|0;break i}g=N()|0;a=1;break j}g=N()|0;break k}g=N()|0;a=1;break l}g=N()|0}tb(d)}tb(f+236|0)}tb(f+224|0)}tb(i);if(!a){break c}}ic(h);break c}e=qc(f+192|0,22292);b=x[e+4>>2];x[f+88>>2]=x[e>>2];x[f+92>>2]=b;if(Ic(i,g,f+88|0)){e=ac(8);x[31609]=0;d=bi(f+236|0,c,d);a=x[31609];x[31609]=0;r:{s:{t:{if((a|0)!=1){x[31609]=0;c=f+96|0;S(1011,c|0,18271,d|0);a=x[31609];x[31609]=0;if((a|0)==1){break t}pc(e,c);a=0;x[31609]=0;S(97,e|0,48428,1e3);b=x[31609];x[31609]=0;if((b|0)!=1){break b}g=N()|0;tb(c);break s}g=N()|0;break r}g=N()|0;a=1}tb(d);if(!a){break c}}ic(e);break c}e=qc(f+184|0,12437);b=x[e+4>>2];x[f+80>>2]=x[e>>2];x[f+84>>2]=b;if(Ic(i,g,f+80|0)){e=qc(f+176|0,5601);b=x[e+4>>2];x[f+32>>2]=x[e>>2];x[f+36>>2]=b;if(Ic(c,d,f+32|0)){x[a+52>>2]=0;break e}e=qc(f+168|0,11301);b=x[e+4>>2];x[f+24>>2]=x[e>>2];x[f+28>>2]=b;if(Ic(c,d,f+24|0)){x[a+52>>2]=1;break e}e=qc(f+160|0,9222);b=x[e+4>>2];x[f+16>>2]=x[e>>2];x[f+20>>2]=b;if(Ic(c,d,f+16|0)){x[a+52>>2]=2;break e}e=ac(8);x[31609]=0;d=bi(f+236|0,c,d);a=x[31609];x[31609]=0;u:{v:{w:{if((a|0)!=1){x[31609]=0;c=f+96|0;S(1011,c|0,14667,d|0);a=x[31609];x[31609]=0;if((a|0)==1){break w}pc(e,c);a=0;x[31609]=0;S(97,e|0,48428,1e3);b=x[31609];x[31609]=0;if((b|0)!=1){break b}g=N()|0;tb(c);break v}g=N()|0;break u}g=N()|0;a=1}tb(d);if(!a){break c}}ic(e);break c}e=qc(f+152|0,11538);b=x[e+4>>2];x[f+72>>2]=x[e>>2];x[f+76>>2]=b;if(!Ic(i,g,f+72|0)){break e}e=qc(f+144|0,15659);b=x[e+4>>2];x[f+64>>2]=x[e>>2];x[f+68>>2]=b;b=0;x:{if(Ic(c,d,f- -64|0)){break x}e=qc(f+136|0,15664);b=x[e+4>>2];x[f+56>>2]=x[e>>2];x[f+60>>2]=b;b=1;if(Ic(c,d,f+56|0)){break x}e=qc(f+128|0,12711);b=x[e+4>>2];x[f+48>>2]=x[e>>2];x[f+52>>2]=b;b=2;if(Ic(c,d,f+48|0)){break x}e=qc(f+120|0,9286);b=x[e+4>>2];x[f+40>>2]=x[e>>2];x[f+44>>2]=b;b=3;if(Ic(c,d,f+40|0)){break x}c=ac(8);x[31609]=0;b=P(36,f+96|0,11574)|0;a=x[31609];x[31609]=0;if((a|0)==1){break d}pc(c,b);x[31609]=0;S(97,c|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}g=N()|0;tb(b);break c}x[a+56>>2]=b;d=x[a+24>>2];if(!x[d+24668>>2]){break e}c=d+24664|0;a=x[c+4>>2];x[f+112>>2]=x[c>>2];x[f+116>>2]=a;c=d+24656|0;a=x[c+4>>2];x[f+104>>2]=x[c>>2];x[f+108>>2]=a;a=x[d+24652>>2];x[f+96>>2]=x[d+24648>>2];x[f+100>>2]=a;l=f,m=XM(b),x[l+116>>2]=m;a=f+96|0;if(!Az(a,d+24648|0)){break e}LA(d,a)}fb=f+256|0;return}g=N()|0;ic(c)}Q(g|0)}p()}function ok(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,m=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;i=1;o(+b);e=j(1)|0;a:{b:{f=j(0)|0;p=e&2147483647;c:{if(!(f|p)){break c}o(+a);c=j(1)|0;g=j(0)|0;if(!g&(c|0)==1072693248){break c}t=g;r=c&2147483647;if(!(!(r>>>0>2146435072|(r|0)==2146435072&(g|0)!=0|p>>>0>2146435072)&(!f|(p|0)!=2146435072))){return a+b}g=0;d:{e:{f:{g:{h:{q=c;if((c|0)>0){q=1}else{q=(q|0)>=0}i:{if(q){break i}g=2;if(p>>>0>1128267775){break i}g=0;if(p>>>0<1072693248){break i}q=p>>>20|0;if(p>>>0<1094713344){break h}m=1075-q|0;q=f>>>m|0;if((f|0)!=q<<m){break i}g=2-(q&1)|0}m=g;if(f){break f}if((p|0)!=2146435072){break g}if(!(r-1072693248|t)){break c}if(r>>>0<1072693248){break e}return(e|0)>0|(e|0)>=0?b:0}if(f){break f}g=1043-q|0;f=p>>>g|0;if((p|0)!=f<<g){break g}m=2-(f&1)|0}if((p|0)==1072693248){if((e|0)>0|(e|0)>=0){return a}return 1/a}if((e|0)==1073741824){return a*a}if((e|0)!=1071644672|(c|0)<0){break f}return M(a)}d=F(a);if(t){break d}j:{if((c|0)<0){if((c|0)==-2147483648|(c|0)==-1074790400|(c|0)==-1048576){break j}break d}if(!c|(c|0)==2146435072){break j}if((c|0)!=1072693248){break d}}i=(e|0)<0?1/d:d;if((c|0)>0|(c|0)>=0){break c}if(!(r-1072693248|m)){a=i-i;return a/a}return(m|0)==1?-i:i}return(e|0)>0|(e|0)>=0?0:-b}k:{if((c|0)>0|(c|0)>=0){break k}l:{switch(m|0){case 0:a=a-a;return a/a;case 1:break l;default:break k}}i=-1}m:{if(p>>>0>=1105199105){if(p>>>0>=1139802113){if(r>>>0<=1072693247){return(e|0)<0?Infinity:0}return(e|0)>0?Infinity:0}if(r>>>0<=1072693246){return(e|0)<0?i*1e300*1e300:i*1e-300*1e-300}if(r>>>0>=1072693249){return(e|0)>0?i*1e300*1e300:i*1e-300*1e-300}a=d+-1;d=a*1.9259629911266175e-8+a*a*(.5-a*(a*-.25+.3333333333333333))*-1.4426950408889634;h=d;d=a*1.4426950216293335;o(+(h+d));c=j(1)|0;j(0)|0;l(0,0);l(1,c|0);a=+n();d=h-(a-d);break m}a=d*9007199254740992;f=r>>>0<1048576;d=f?a:d;o(+a);c=j(1)|0;j(0)|0;m=f?c:r;g=m&1048575;c=g|1072693248;m=(m>>20)+(f?-1076:-1023)|0;f=0;n:{if(g>>>0<235663){break n}if(g>>>0<767610){f=1;break n}c=g|1071644672;m=m+1|0}g=((f<<18)+(c>>>1|0)|0)+537395200|0;f=f<<3;w=C[f+3536>>3];o(+d);j(1)|0;q=0;l(0,j(0)|q);l(1,c|0);k=+n();s=C[f+3520>>3];h=k-s;u=1/(s+k);d=h*u;o(+d);c=j(1)|0;j(0)|0;l(0,0);l(1,c|0);a=+n();x=a;l(0,q|0);l(1,g|0);v=a*a;y=h;h=+n();k=u*(y-a*h-a*(k-(h-s)));h=k*(d+a);a=d*d;s=h+a*a*(a*(a*(a*(a*(a*.20697501780033842+.23066074577556175)+.272728123808534)+.33333332981837743)+.4285714285785502)+.5999999999999946);o(+(v+3+s));c=j(1)|0;j(0)|0;l(0,0);l(1,c|0);a=+n();h=x*a;d=k*a+d*(s-(a+-3-v));o(+(h+d));c=j(1)|0;j(0)|0;l(0,0);l(1,c|0);a=+n();d=w+(a*-7.028461650952758e-9+(d-(a-h))*.9617966939259756);h=d;k=C[f+3552>>3];d=a*.9617967009544373;s=+(m|0);o(+(k+(h+d)+s));c=j(1)|0;j(0)|0;l(0,0);l(1,c|0);a=+n();d=h-(a-s-k-d)}l(0,0);l(1,e|0);k=+n();d=(b-k)*a+d*b;b=a*k;a=d+b;o(+a);e=j(1)|0;c=j(0)|0;o:{if((e|0)>=1083179008){if(c|e-1083179008){break b}if(!(d+8008566259537294e-32>a-b)){break o}break b}if((e&2147482624)>>>0<1083231232){break o}if(c|e+1064252416){break a}if(!(d<=a-b)){break o}break a}f=0;g=e&2147483647;if(g>>>0>=1071644673){c=e+(1048576>>>(g>>>20|0)-1022|0)|0;g=c>>>20&2047;f=(c&1048575|1048576)>>>1043-g|0;f=(e|0)<0?0-f|0:f;l(0,0);l(1,c&-1048576>>g-1023);b=b-+n();o(+(d+b));e=j(1)|0;j(0)|0}l(0,0);l(1,e|0);a=+n();k=a*.6931471824645996;d=(d-(a-b))*.6931471805599453+a*-1.904654299957768e-9;a=k+d;b=a*a;b=a-b*(b*(b*(b*(b*4.1381367970572385e-8+-16533902205465252e-22)+6613756321437934e-20)+-.0027777777777015593)+.16666666666666602);h=a*b/(b+-2);b=a;a=d-(a-k);a=b-(h-(b*a+a))+1;o(+a);e=j(1)|0;c=j(0)|0;e=(f<<20)+e|0;p:{if((e|0)<=1048575){a=kk(a,f);break p}l(0,c|0);l(1,e|0);a=+n()}i=i*a}return i}return i*1e300*1e300}return i*1e-300*1e-300}function Hna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=fb-176|0;fb=e;a:{b:{if(Mb(x[c>>2],x[c+8>>2],8)){Vb(c,4);while(1){if(Tv(x[c>>2],x[c+8>>2])){break b}m=fb-288|0;fb=m;f=EU(m+6|0);i=fb-368|0;fb=i;l=zc(f,EU(i+80|0),282);f=0;g=fb-32|0;fb=g;x[g+28>>2]=0;j=Zb(g+8|0,g+28|0,4);h=x[j>>2];lc(g+20|0,x[c>>2],x[c+8>>2],h,x[j+4>>2]);j=x[g+24>>2]==4&x[g+28>>2]==1399285583;if(j){Vb(c,4)}fb=g+32|0;c:{d:{e:{f:{g:{if(j){FU(c,4);j=i0(i+60|0,c);x[31609]=0;g=P(789,j|0,l|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break g}h:{if(!g){break h}g=x[j+8>>2];h=x[j>>2];k=y[l+26|0];x[31609]=0;g=U(790,h|0,g|0,k|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break g}if(!g){break h}g=0;i:{while(1){if(y[l+26|0]<=f>>>0){h=x[j+8>>2];k=x[j>>2];f=0;x[31609]=0;n=h;h=g&65535;g=U(790,k|0,n|0,h|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break e}if(!g){break h}x[31609]=0;O(791,j|0,h|0);f=x[31609];x[31609]=0;if((f|0)==1){break e}FU(j,GU(l));g=tc(i+56|0);f=i+80|0;QB(f);x[31609]=0;O(792,j|0,f|0);k=x[31609];x[31609]=0;if((k|0)!=1){w[i+102>>1]=0;w[i+104>>1]=0;f=DU(g,f,i+107|0);g=y[l+26|0];x[31609]=0;O(791,j|0,g|0);g=x[31609];x[31609]=0;if((g|0)!=1){break i}}f=N()|0;break d}x[31609]=0;h=R(793,j|0)|0;k=x[31609];x[31609]=0;if((k|0)!=1){v[(f+l|0)+27|0]=h;f=f+1|0;g=g+h|0;continue}break}f=N()|0;break d}n=f;f=l+27|0;g=DU(n,f,f+y[l+26|0]|0);x[31609]=0;k=i+36|0;S(794,k|0,j|0,h|0);f=x[31609];x[31609]=0;if((f|0)==1){break f}f=0;x[31609]=0;O(575,i+16|0,k|0);h=x[31609];x[31609]=0;if((h|0)==1){f=N()|0;ub(k);break d}n=i+16|0;fG(i+8|0,n);h=wb(x[i+8>>2]);o=Zj(x[i+8>>2],x[i+12>>2]);k=fb-16|0;fb=k;x[k+12>>2]=h;while(1){if(Ib(h,o)){AU(g,y[h|0]);h=x[we(k+12|0)>>2];continue}else{fb=k+16|0}break}Kc(n);ub(i+36|0);if(x[g>>2]!=(y[l+22|0]|y[l+23|0]<<8|(y[l+24|0]<<16|y[l+25|0]<<24))){break h}f=GU(l);x[31609]=0;O(791,c|0,f|0);g=x[31609];x[31609]=0;f=1;if((g|0)==1){break e}}ub(j)}fb=i+368|0;break c}f=N()|0;break d}f=N()|0;break d}f=N()|0}ub(j);Q(f|0);p()}fb=m+288|0;if(f){continue}break}}yc(c);dg(b,a,c);a=1;break a}v[d|0]=1;yc(c);f=Rg(c);d=e+136|0;he(d,c,jf(c));g=hc(e+156|0,d);ub(d);c=z[a+34>>1]&-66|y[b|0]>15;b=y[b+1|0]!=1;c=c|b<<6;w[a+34>>1]=c;x[a>>2]=f>>>(c&1)>>>b;x[e+132>>2]=0;x[e+128>>2]=0;x[31609]=0;O(575,d|0,g|0);b=x[31609];x[31609]=0;j:{k:{l:{m:{if((b|0)!=1){c=Ze(d);d=x[e+136>>2];i=cD(c,uh(d),e+132|0,e+128|0);x[31609]=0;b=x[e+132>>2];P(183,g|0,b|0)|0;f=x[31609];x[31609]=0;if((f|0)!=1){if(!i){break j}Gh(a);l=b+c|0;d=d-b|0;b=x[e+128>>2];c=0;while(1){n:{if(b){if(!d|(b|0)!=1){break k}b=x[a>>2];if(c>>>0<b>>>0){break n}break k}b=x[a>>2];if(c>>>0>=b>>>0){break k}}if(!le(b,x[a+20>>2])){break k}x[e+124>>2]=0;x[e+120>>2]=0;b=e+120|0;j=tY(i,l,uh(d),e+124|0,e+116|0,b);x[31609]=0;P(183,g|0,j|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break m}vi(b,uh(x[a>>2]-c|0));b=x[e+120>>2];o:{if((b|0)<=0){break o}f=x[e+124>>2];m=z[a+34>>1];if((_d(m)|0)!=(f|0)){break o}h=D(c,f);k=x[a+20>>2];if(m&1){x[e+112>>2]=b;x[e+100>>2]=b;x[e- -64>>2]=b;x[e+48>>2]=b;x[e+96>>2]=f;x[e+92>>2]=x[e+116>>2];x[e+108>>2]=f;x[e+104>>2]=k+(h<<1);x[31609]=0;f=x[e+96>>2];x[e+40>>2]=x[e+92>>2];x[e+44>>2]=f;f=x[e+108>>2];x[e+56>>2]=x[e+104>>2];x[e+60>>2]=f;O(576,e+56|0,e+40|0);f=x[31609];x[31609]=0;if((f|0)!=1){break o}break m}x[e+88>>2]=b;x[e+76>>2]=b;x[e+32>>2]=b;x[e+16>>2]=b;x[e+72>>2]=f;x[e+68>>2]=x[e+116>>2];x[e+84>>2]=f;x[e+80>>2]=h+k;x[31609]=0;f=x[e+72>>2];x[e+8>>2]=x[e+68>>2];x[e+12>>2]=f;f=x[e+84>>2];x[e+24>>2]=x[e+80>>2];x[e+28>>2]=f;O(577,e+24|0,e+8|0);f=x[31609];x[31609]=0;if((f|0)==1){break m}}d=d-j|0;l=j+l|0;c=b+c|0;b=sY(i);continue}}break m}c=N()|0;break l}c=N()|0;Kc(e+136|0)}ub(g);Q(c|0);p()}rY(i)}Kc(e+136|0);ub(g);a=(i|0)!=0}fb=e+176|0;return a|0}function yy(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=fb-32|0;fb=e;j=a+32|0;Qc(e+8|0,j,11);a:{b:{c:{if(Gb(x[x[e+8>>2]>>2],x[e+12>>2])|x[a+8>>2]){b=x[a+76>>2]+x[a+20>>2]|0;f=x[a+16>>2];c=f+x[a+72>>2]|0;Di(x[a+36>>2],c,c>>>0<f>>>0?b+1|0:b,0);b=x[a+36>>2];if(pk(x[(x[x[b>>2]-12>>2]+b|0)+16>>2])){Ph(a,2,256);break a}b=x[a+104>>2];c=a+52|0;f=x[c>>2];d=hj(f,x[c+4>>2]);d:{if(b>>>0>d>>>0){n=fb-32|0;fb=n;f=b-d|0;d=x[Ab(c)>>2];g=x[c+4>>2];e:{if(f>>>0<=(d-g|0)/24>>>0){d=fb-16|0;fb=d;c=HJ(d+4|0,c,f);b=x[c+4>>2];f=x[c+8>>2];while(1){if((b|0)==(f|0)){kc(c);fb=d+16|0}else{DJ(b);b=b+24|0;x[c+4>>2]=b;continue}break}break e}b=Ab(c);d=LJ(n+12|0,OJ(c,hj(x[c>>2],g)+f|0),hj(x[c>>2],x[c+4>>2]),b);g=fb-16|0;fb=g;h=x[d+8>>2];b=g+4|0;x[b+8>>2]=d+8;x[b>>2]=h;x[b+4>>2]=h+D(f,24);f=x[b>>2];while(1){if(x[b+4>>2]!=(f|0)){DJ(f);f=x[b>>2]+24|0;x[b>>2]=f;continue}break}je(b);fb=g+16|0;k=fb-16|0;fb=k;b=vb(k+12|0,x[c+4>>2]);g=vb(k+8|0,x[c>>2]);h=x[vb(k+4|0,x[d+4>>2])>>2];m=fb-16|0;fb=m;p=m+8|0;f=fb-32|0;fb=f;fd(f+24|0,x[b>>2],x[g>>2]);q=f+16|0;b=x[f+24>>2];r=x[f+28>>2];g=fb-16|0;fb=g;x[g+8>>2]=h;x[g+12>>2]=b;while(1){if(Fd(b,r)){b=jl(b);h=jl(x[g+8>>2]);l=z[b+18>>1]|z[b+20>>1]<<16;o=z[b+14>>1]|z[b+16>>1]<<16;w[h+14>>1]=o;w[h+16>>1]=o>>>16;w[h+18>>1]=l;w[h+20>>1]=l>>>16;l=x[b+12>>2];x[h+8>>2]=x[b+8>>2];x[h+12>>2]=l;l=x[b+4>>2];x[h>>2]=x[b>>2];x[h+4>>2]=l;b=ft(g+12|0);ft(g+8|0);b=x[b>>2];continue}break}rc(q,b,g+8|0);fb=g+16|0;b=x[f+16>>2];x[f+12>>2]=x[f+20>>2];rc(p,b,f+12|0);fb=f+32|0;fb=m+16|0;x[d+4>>2]=x[m+12>>2];Tb(c,d+4|0);Tb(c+4|0,d+8|0);Tb(Ab(c),nc(d));x[d>>2]=x[d+4>>2];fb=k+16|0;IJ(d)}fb=n+32|0;break d}if(b>>>0<d>>>0){Jd(c,f+D(b,24)|0)}}f=a+40|0;so(f,x[a+104>>2]<<2);while(1){if(A[a+104>>2]>i>>>0){c=x[a+36>>2];if(pk(x[(x[x[c>>2]-12>>2]+c|0)+16>>2])){Ph(a,2,1024);break a}b=z[a+24>>1];w[e>>1]=b;if((b|0)==65535){By(c,e);b=z[e>>1]}c=Xc(x[a+40>>2],x[a+44>>2]);d=b&65535;f:{if(!d){b=0;break f}if(d>>>0>(c^-1)>>>0){break f}Kk(f,c+d|0);wj(x[a+36>>2],xb(x[a+40>>2],c),d)}d=wf(x[a+52>>2],i);x[d>>2]=c;w[d+20>>1]=b;b=e+8|0;Qc(b,j,6);if(Gb(x[x[e+8>>2]>>2],x[e+12>>2])){pl(x[a+36>>2],b);b=x[e+8>>2];c=x[e+12>>2];if(!zy(b,c)){break c}d=wf(x[a+52>>2],i);x[d+8>>2]=b;x[d+12>>2]=c}c=x[a+8>>2];g:{if(c){b=wf(x[a+52>>2],i);x[b+16>>2]=c;break g}Qc(e+8|0,j,7);if(!Gb(x[x[e+8>>2]>>2],x[e+12>>2])){b=wf(x[a+52>>2],i);break g}pl(x[a+36>>2],e+8|0);c=x[e+8>>2];if(!zy(c,x[e+12>>2])){break b}b=wf(x[a+52>>2],i);x[b+16>>2]=c}h:{if(x[b+16>>2]==-1){break h}Qc(e+8|0,j,6);if(Gb(x[x[e+8>>2]>>2],x[e+12>>2])){break h}i:{if(!i){c=0;d=wf(x[a+52>>2],0);b=0;break i}d=x[a+52>>2];b=wf(d,i-1|0);g=x[b+16>>2];c=x[b+8>>2]+g|0;b=x[b+12>>2];d=wf(d,i);b=c>>>0<g>>>0?b+1|0:b}x[d+8>>2]=c;x[d+12>>2]=b}b=e+8|0;Qc(b,j,8);if(Gb(x[x[e+8>>2]>>2],x[e+12>>2])){w[e+30>>1]=0;By(x[a+36>>2],e+30|0);Qc(b,j,9);Pm(x[a+36>>2],z[e+30>>1]<<Gb(x[x[e+8>>2]>>2],x[e+12>>2]))}i=i+1|0;continue}break}ae(e+8|0,x[a+36>>2]);b=x[e+20>>2];x[a+80>>2]=x[e+16>>2];x[a+84>>2]=b}d=e+8|0;Qc(d,j,4);kf(d,1);f=x[a+80>>2];g=x[a+84>>2];b=x[a+96>>2];h=x[a+16>>2];i=b+h|0;k=x[a+100>>2];c=k+x[a+20>>2]|0;c=i>>>0<h>>>0?c+1|0:c;h=i;i=(b|0)==x[a+72>>2]&(k|0)==x[a+76>>2];b=i?f:h;x[a+88>>2]=b;c=i?g:c;x[a+92>>2]=c;Di(x[a+36>>2],b,c,0);Qc(d,j,6);if(Gb(x[x[e+8>>2]>>2],x[e+12>>2])){break a}Qc(e,j,7);if(!(Gb(x[x[e>>2]>>2],x[e+4>>2])|x[a+8>>2])){break a}c=x[a+88>>2];d=x[a+16>>2];b=c-d|0;f=x[a+92>>2]-(x[a+20>>2]+(c>>>0<d>>>0)|0)|0;j=x[a+52>>2];g=x[a+104>>2];a=0;while(1){if((a|0)==(g|0)){break a}c=wf(j,a);d=c;h=x[c+8>>2];i=h+b|0;c=x[c+12>>2]+f|0;x[d+8>>2]=i;x[d+12>>2]=i>>>0<h>>>0?c+1|0:c;a=a+1|0;continue}}Ph(a,2,2048);break a}Ph(a,2,2048)}fb=e+32|0}function Zsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;f=fb-320|0;fb=f;yc(b);d=fb-16|0;fb=d;h=f+102|0;C_(d+8|0,h);g=x[d+12>>2];lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2]);i=x[d+4>>2];if((i|0)==(g|0)){Vb(b,x[d+12>>2])}fb=d+16|0;a:{b:{c:{if((g|0)!=(i|0)){break c}if(!E_(h)){break c}if(!Mb(x[b>>2],x[b+8>>2],Bc(D_(y[f+318|0],y[f+319|0]),hb))){break c}e=1;if((c|0)==64){break c}Dd(a,2);eg(a);x[a+480188>>2]=524296;t=a,u=Ye(455e3),x[t+480204>>2]=u;Lb(a+1074312|0,110,1);x[a+480208>>2]=x[a+480208>>2]|16777216;d=f+72|0;Te(d,2,f+133|0);e=f+88|0;Cc(e,d);zb(a+1298308|0,e);tb(e);e=0;d:{e:{while(1){if((e|0)==8){f:{d=Xb(x[a+484360>>2],y[a+484376|0]);o=y[f+318|0];m=o+1|0;ak(d,b,m,65535,65535);d=Nb(f+88|0);x[31609]=0;S(234,b|0,d|0,m|0);e=x[31609];x[31609]=0;if((e|0)==1){break f}t=f,u=wb(x[d>>2]),x[t+72>>2]=u;e=wb(x[d+4>>2]);while(1){g=x[f+72>>2];q=Ib(g,e);if(q){if((y[g|0]-1&255)>>>0>7){break d}we(f+72|0);continue}break}t=a,u=y[xb(x[d>>2],0)|0],x[t+480196>>2]=u;e=y[f+317|0];h=y[f+319|0];g=Nb(f+72|0);x[31609]=0;n=h+1|0;S(234,b|0,g|0,n|0);h=x[31609];x[31609]=0;g:{if((h|0)==1){break g}x[31609]=0;h=a+484344|0;O(223,h|0,n|0);i=x[31609];x[31609]=0;if((i|0)==1){break g}r=e+1|0;if(!(c&1)){break e}c=0;while(1){if((c|0)==(n|0)){break e}e=y[xb(x[g>>2],c)|0];x[31609]=0;e=U(196,h|0,e|0,r|0)|0;i=x[31609];x[31609]=0;h:{if((i|0)!=1){if(!e){break e}i=0;l=Wb(x[h>>2],y[xb(x[g>>2],c)|0]);i:while(1){s=i&65535;if(s>>>0>7){break h}i=i+1|0;e=0;while(1){if(A[l+12>>2]<=e>>>0){continue i}x[31609]=0;j=R(197,b|0)|0;k=x[31609];x[31609]=0;j:{k:{if((k|0)!=1){j=j<<24>>24;if((j|0)>=0){break k}e=(j&127)+e|0;break j}break b}k=md(x[l>>2],x[x[l+48>>2]+12>>2],e,s);if((j|0)==1){v[k|0]=254;break j}if((j-1&255)>>>0>96){break j}v[k+1|0]=i;v[k|0]=j+12}e=e+1|0;continue}}}break b}c=c+1|0;continue}}break b}}else{h=f+88|0;d=(f+102|0)+D(e,19)|0;RD(h,d+63|0);g=f+72|0;Cc(g,h);im(((e<<5)+a|0)+480289|0,g);tb(g);e=e+1|0;i=D(e,104)+a|0;j=i+484380|0;nd(j,2);v[f+83|0]=0;g=y[d+78|0]|y[d+79|0]<<8|(y[d+80|0]<<16|y[d+81|0]<<24);v[f+79|0]=g;v[f+80|0]=g>>>8;v[f+81|0]=g>>>16;v[f+82|0]=g>>>24;g=y[d+75|0]|y[d+76|0]<<8|(y[d+77|0]<<16|y[d+78|0]<<24);d=y[d+71|0]|y[d+72|0]<<8|(y[d+73|0]<<16|y[d+74|0]<<24);x[f+16>>2]=x[f+80>>2];x[f+72>>2]=d;x[f+76>>2]=g;d=x[f+76>>2];x[f+8>>2]=x[f+72>>2];x[f+12>>2]=d;Tk(j,1,f+8|0);x[i+484404>>2]=8215;d=f+60|0;Cc(d,h);Ac(((e<<5)+a|0)+946304|0,d);tb(d);continue}break}e=N()|0;break a}i=o+1|0;e=0;while(1){l:{if((e|0)==(i|0)){x[31609]=0;b=P(1,f+60|0,8632)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break l}break b}b=Xb(x[a+484360>>2],y[a+484376|0]);j=e&65535;m:{if(!Yi(b,j)){x[31609]=0;c=P(367,h|0,r|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break b}if((c|0)==65535){break m}b=Xb(x[a+484360>>2],y[a+484376|0]);t=bc(x[b>>2],e),u=c,w[t>>1]=u}b=QD(wb(x[Wb(x[h>>2],z[bc(x[b>>2],e)>>1])+4>>2]),1);c=y[b+5|0];l=y[xb(x[d>>2],(e+1>>>0)%(m>>>0)|0)|0];if((c|0)==(l|0)){break m}n:{if(y[b+3|0]!=16){break n}c=y[a+484376|0];k=x[a+484360>>2];x[31609]=0;c=P(368,Xb(k,c)|0,j|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break b}if((c|0)==65535){break n}b=QD(wb(x[Wb(x[h>>2],c)+4>>2]),1)}v[b+5|0]=l;v[b+3|0]=16}e=e+1|0;continue}break}zb(a+1298344|0,b);tb(b);x[31609]=0;b=P(1,f+48|0,6049)|0;c=x[31609];x[31609]=0;if((c|0)==1){break b}zb(a+1298356|0,b);tb(b);c=f+24|0;qi(c,2,f+113|0);x[31609]=0;b=f+36|0;S(369,b|0,4,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}zb(a+1298368|0,b);tb(b);t=a+1298404|0,u=x[Fc(b,4)>>2],x[t>>2]=u;ec(g)}ec(d);e=q^1}fb=f+320|0;return e|0}e=N()|0;ec(g)}ec(d);Q(e|0);p()}function HS(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=fb-16|0;fb=f;g=a+1074376|0;h=D(b,872);e=(g+h|0)+616|0;d=c&15;a:{b:{switch(c-16>>>4|0){case 0:a=(a+h|0)+1075080|0;x[a>>2]=x[a>>2]&-1048577|((d|0)!=0)<<20;break a;case 1:if(!(y[a+480209|0]&16)){break a}if(Lj(x[e+656>>2])){a=D(b,872)+a|0;w[a+1075764>>1]=d-8;a=a+1075843|0;v[a|0]=y[a|0]|64;break a}if(x[a+480180>>2]!=64){b=D(b,872)+a|0;c=d<<28>>24;w[b+1075764>>1]=c;e=z[(d<<1)+31648>>1];x[b+1075696>>2]=e;d=b+1075692|0;if(!x[d>>2]){break a}l=d,m=zh(a,y[b+1075789|0],c,e),x[l>>2]=m;break a}a=D(b,872)+a|0;b=x[a+1075096>>2];if(!b){break a}x[a+1075696>>2]=x[b+24>>2]+D(d,80);break a;case 2:if(x[a+480180>>2]==2){v[(D(b,872)+a|0)+1075814|0]=c&3;break a}Jb(f+8|0,a+1074312|0,21);if(Gb(x[x[f+8>>2]>>2],x[f+12>>2])){v[(D(b,872)+a|0)+1075814|0]=d>>>0<4?d:0;break a}v[(D(b,872)+a|0)+1075814|0]=c&7;break a;case 3:if(x[a+480180>>2]==2){v[(D(b,872)+a|0)+1075817|0]=c&3;break a}Jb(f+8|0,a+1074312|0,21);if(Gb(x[x[f+8>>2]>>2],x[f+12>>2])){v[(D(b,872)+a|0)+1075817|0]=d>>>0<4?d:0;break a}v[(D(b,872)+a|0)+1075817|0]=c&7;break a;case 4:Jb(f+8|0,a+1074312|0,21);if(Gb(x[x[f+8>>2]>>2],x[f+12>>2])){a=D(b,872)+a|0;v[a+1075813|0]=0;v[a+1075820|0]=d>>>0<4?d:0;break a}v[(D(b,872)+a|0)+1075820|0]=c&7;break a;case 5:if(x[a+1074392>>2]|!(y[a+480209|0]&16)){break a}a=a+1074400|0;x[a>>2]=x[a>>2]+d;break a;case 6:if(!(y[a+480209|0]&16)){break a}if(d>>>0<=2){c=z[a+480188>>1];h=c>>>0<=256?256:c;i=a+906300|0;j=b+1|0;k=d-1|0;while(1){if((c|0)==(h|0)){break a}e=D(c,872)+a|0;c:{if((j|0)!=z[e+1075778>>1]){break c}d:{e:{switch(k|0){case 0:Eo(a,e+1074992|0);if(!(y[e+1075081|0]&2)){break d}d=x[a+1298300>>2];if(!Ed(d)){break d}zk(d,c&65535);break d;case 1:g=e+1075080|0;d=x[g>>2];x[g>>2]=d|4096;if(!(d&512)){break d}d=x[a+1298300>>2];if(!Ed(d)){break d}zk(d,c&65535);break d;default:break e}}x[e+1075688>>2]=0;g=e+1075080|0;d=x[g>>2];x[g>>2]=d|4096;if(!(d&512)){break d}d=x[a+1298300>>2];if(!Ed(d)){break d}Fj(d,c&65535,1)}d=x[e+1075648>>2];if(!d){break c}g=y[d+34|0];if(!g){break c}g=x[$d(i,g-1|0)>>2];if(!g){break c}ib[x[x[g>>2]+96>>2]](g,d,y[e+1075789|0]|256,0,b)}c=c+1|0;continue}}lV(e,d,x[a+480180>>2]);break a;case 7:if(!(y[a+480209|0]&16)){break a}_m(a,e,d,4);break a;case 8:b=x[a+480208>>2];f:{if(!(b&4096)){break f}g:{switch(d|0){case 0:x[e+88>>2]=x[e+88>>2]&-257;break f;case 1:x[e+692>>2]=128;x[e+88>>2]=x[e+88>>2]|256;break f;case 8:x[e+88>>2]=x[e+88>>2]&-25165825|16777216;break f;case 9:x[e+88>>2]=x[e+88>>2]&-25165825|8388608;break f;case 10:x[a+480208>>2]=b&-16385;break f;case 11:x[a+480208>>2]=b|16384;break f;case 12:x[a+480208>>2]=b&-8193;break f;case 13:x[a+480208>>2]=b|8192;break f;case 14:x[e+88>>2]=x[e+88>>2]&-129;break f;case 15:break g;default:break f}}h:{if(x[e>>2]|x[e+4>>2]){break h}a=x[e+76>>2];if(!a){break h}if(!(l=Tc(y[e+788|0]),m=1,n=y[e+88|0]&2,n?l:m)){break h}x[e>>2]=-1;x[e+4>>2]=a-1}x[e+88>>2]=x[e+88>>2]|128}break a;case 9:if(!(y[a+480209|0]&16)){break a}b=D(b,872)+a|0;v[b+1075828|0]=d;Jb(f+8|0,a+1074312|0,35);if(Gb(x[x[f+8>>2]>>2],x[f+12>>2])){break a}if(!Tc(y[b+1075780|0])){break a}a=d<<16;if(a>>>0>=A[b+1075068>>2]){break a}x[e+4>>2]=a;break a;case 10:if(!(y[a+480209|0]&16)){break a}wB(a,g,b,d);break a;case 11:i:{if(d){break i}d=1;c=x[a+480180>>2];if(c&16777248){break i}d=0;if((c|0)==2){break a}}Jb(f+8|0,a+1074312|0,30);dB(a,b,d,Gb(x[x[f+8>>2]>>2],x[f+12>>2])|x[a+480180>>2]==2);break a;case 14:break b;default:break a}}if(x[a+480180>>2]==2){break a}v[(D(b,872)+a|0)+1075836|0]=d}fb=f+16|0}function XR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;j=fb-16|0;fb=j;a:{b:{c:{if(!Tc(c)|!d|x[b+480180>>2]!=16777216|z[b+480192>>1]<d>>>0){break c}d=x[((d<<2)+b|0)+900380>>2];if(!d){break c}d=x[d+44>>2];if(!d){break c}w[j+14>>1]=c-61;b=fb+-64|0;fb=b;d:{e:{e=w[d+28>>1];i=j+14|0;c=w[i>>1];if((e|0)<=(c|0)){if((c|0)<=(oc(x[d+4>>2],x[d+8>>2])+e|0)-1<<16>>16){break e}}Fb(a);break d}f:{e=w[d+30>>1];if(!e){c=d+52|0;d=jA(c,i);if(!Zg(d,Pf(c))){break f}wm(a,ud(d)+4|0);break d}e=iA(c,e);w[b+62>>1]=e;c=Fb(a);g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{a=d+52|0;f=jA(a,b+62|0);t:{if(Zg(f,Pf(a))){x[31609]=0;O(129,c|0,ud(f)+4|0);a=x[31609];x[31609]=0;if((a|0)==1){break t}a=w[d+30>>1];d=w[i>>1];x[31609]=0;n=b,o=hA(d,a)+5|0,x[n+36>>2]=o;a=b+48|0;O(126,a|0,b+36|0);d=x[31609];x[31609]=0;u:{if((d|0)!=1){x[31609]=0;P(74,c|0,a|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break u}tb(a);break d}a=N()|0;break g}a=N()|0;tb(b+48|0);break g}if(w[d+30>>1]>26){break q}x[31609]=0;e=U(542,b+36|0,1,e+65<<24>>24)|0;a=x[31609];x[31609]=0;if((a|0)==1){break s}x[31609]=0;a=b+48|0;S(602,a|0,0,e|0);f=x[31609];x[31609]=0;if((f|0)==1){break r}f=zb(c,a);tb(a);tb(e);x[31609]=0;P(127,f|0,14690)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break p}}a=N()|0;break g}a=N()|0;break g}a=N()|0;tb(e);break g}x[31609]=0;g=e<<16>>16;a=(g|0)/16|0;x[b+32>>2]=e-(a<<4)<<16>>16;e=b+36|0;O(880,e|0,b+32|0);f=x[31609];x[31609]=0;if((f|0)==1){break o}x[31609]=0;x[b+16>>2]=(a<<16>>16)%16;a=b+20|0;O(880,a|0,b+16|0);f=x[31609];x[31609]=0;if((f|0)==1){break n}x[31609]=0;f=b+48|0;S(2,f|0,e|0,a|0);h=x[31609];x[31609]=0;if((h|0)==1){break m}k=zb(c,f);tb(f);tb(a);tb(e);if((g|0)<256){break p}x[31609]=0;g=b+4|0;O(881,g|0,k|0);a=x[31609];x[31609]=0;if((a|0)==1){break k}h=zd(g);l=Ef(g);m=zd(g);a=fb-16|0;fb=a;x[a+8>>2]=m;x[a+12>>2]=h;while(1){if(Ib(h,l)){n=x[a+8>>2],o=Kq(v[h|0]),v[n|0]=o;h=we(a+12|0);we(a+8|0);h=x[h>>2];continue}break}fb=a+16|0;Uc(e,g);x[31609]=0;S(602,f|0,0,e|0);a=x[31609];x[31609]=0;if((a|0)==1){break j}zb(k,f);tb(f);tb(e);tb(g)}a=w[d+30>>1];d=w[i>>1];x[31609]=0;n=b,o=hA(d,a)+5|0,x[n+20>>2]=o;a=b+48|0;O(126,a|0,b+20|0);d=x[31609];x[31609]=0;if((d|0)==1){break i}x[31609]=0;P(74,c|0,a|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break h}tb(a);break d}a=N()|0;break g}a=N()|0;break l}a=N()|0;tb(b+20|0)}tb(b+36|0);break g}a=N()|0;break g}a=N()|0;tb(b+36|0);tb(b+4|0);break g}a=N()|0;break g}a=N()|0;tb(b+48|0)}tb(c);Q(a|0);p()}f=fb-16|0;fb=f;e=f+4|0;c=fb-32|0;fb=c;d=qf(c+20|0,1,0);v:{while(1){g=Kb(d);rs(c+12|0,g,Cb(x[d+4>>2],y[d+11|0])+g|0,w[i>>1]);if(!x[c+16>>2]){break v}g=mi(Cb(x[d+4>>2],y[d+11|0]));x[31609]=0;O(45,d|0,g|0);g=x[31609];x[31609]=0;if((g|0)!=1){continue}break}break a}g=x[c+12>>2];i=Kb(d);x[31609]=0;O(46,d|0,g-i|0);g=x[31609];x[31609]=0;w:{if((g|0)!=1){x[31609]=0;O(47,e|0,d|0);g=x[31609];x[31609]=0;if((g|0)!=1){break w}break a}break a}tb(d);fb=c+32|0;Rh(a,e);tb(e);fb=f+16|0}fb=b- -64|0;break b}e=x[b>>2];b=fb-32|0;fb=b;x:{if(Gl(c)){x[b+16>>2]=4013373;x[b+8>>2]=8289918;x[b+12>>2]=6184542;x[b>>2]=7553872;x[b+4>>2]=2114384;uc(a,(b+(c<<2)|0)-1004|0);break x}if(Tc(c)){d=Fb(b);x[31609]=0;c=c-1|0;f=(c|0)/12|0;c=P(882,d|0,e+(D(f,-12)+c<<16>>16<<2)|0)|0;e=x[31609];x[31609]=0;y:{if((e|0)==1){break y}x[31609]=0;c=P(883,c|0,f+48&255)|0;e=x[31609];x[31609]=0;if((e|0)==1){break y}x[31609]=0;P(3,a|0,c|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break y}tb(c);break x}break a}if(!c){uc(a,16800);break x}uc(a,14661)}fb=b+32|0}fb=j+16|0;return}a=N()|0;tb(d);Q(a|0);p()}function $sa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;f=fb-960|0;fb=f;yc(b);d=fb-16|0;fb=d;e=f+862|0;K_(d+8|0,e);g=x[d+12>>2];lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2]);h=x[d+4>>2];if((h|0)==(g|0)){Vb(b,x[d+12>>2])}fb=d+16|0;d=(g|0)==(h|0);if(!d){J_(e)}a:{if(!d){break a}if(!M_(e)){break a}if(!Mb(x[b>>2],x[b+8>>2],Bc(L_(y[f+909|0]|y[f+910|0]<<8),hb))){break a}l=1;if((c|0)==64){break a}Dd(a,512);x[a+480228>>2]=32;w[a+480188>>1]=16;x[a+480196>>2]=y[f+937|0];x[a+480208>>2]=16;x[a+480200>>2]=256;x[a+480204>>2]=8e5;Lb(a+1074312|0,7,1);d=f+88|0;e=uc(d,8224);zb(a+1298344|0,e);tb(e);e=uc(d,8928);zb(a+1298356|0,e);tb(e);t=a+1298404|0,u=x[Fc(d,4)>>2],x[t>>2]=u;e=f+12|0;I_(e,f+866|0);Cc(d,e);zb(a+1298308|0,d);tb(d);d=0;while(1){if((d|0)==16){b:{d=y[f+958|0]|y[f+959|0]<<8;if(d){lE(a+1298332|0,b,d,132,0)}d=fb-16|0;fb=d;e=f+88|0;cc(d+8|0,e,771);g=x[d+12>>2];lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2]);h=x[d+4>>2];if((h|0)==(g|0)){Vb(b,x[d+12>>2])}fb=d+16|0;l=(g|0)==(h|0);if(!l){Rb(e,0,771)}if(!l){break a}d=a+484376|0;H_(Xb(x[a+484360>>2],y[d|0]),e,y[f+345|0]);$e(Xb(x[a+484360>>2],y[d|0]),y[f+346|0]);dd(b,y[f+909|0]|y[f+910|0]<<8);j=a+484344|0;q=c&1;e=0;while(1){c:{if((e|0)==256){if(!(c&2)){break a}m0(b,f+60|0);d=0;while(1){if((d|0)==64){break a}if(!(y[f+60+(d>>>3)|0]>>>(d&7)&1)){d=d+1|0;continue}c=f+12|0;if(!SD(b,c)){break a}d=d+1|0;w[a+480190>>1]=d;Te(f,1,c);h=f+68|0;Cc(h,f);Ac(((z[a+480190>>1]<<5)+a|0)+946304|0,h);tb(h);e=(D(d,104)+a|0)+484380|0;nd(e,0);j=y[c+32|0]|y[c+33|0]<<8|(y[c+34|0]<<16|y[c+35|0]<<24);x[e>>2]=j;g=y[c+38|0]|y[c+39|0]<<8|(y[c+40|0]<<16|y[c+41|0]<<24);x[e+4>>2]=g;i=y[c+42|0]|y[c+43|0]<<8|(y[c+44|0]<<16|y[c+45|0]<<24);x[e+24>>2]=16726;x[e+8>>2]=i;w[e+30>>1]=y[c+37|0]<<4;if(v[c+46|0]&1){i=i>>>1|0;x[e+8>>2]=i;g=g>>>1|0;x[e+4>>2]=g;x[e>>2]=j>>>1}if(!(!(y[c+47|0]&8)|g>>>0>=i>>>0)){w[e+34>>1]=z[e+34>>1]|2}Zc(h,v[f+58|0]&1?16:8,1,0,0);dg(h,e,b);continue}}d:{d=(e<<1)+f|0;h=y[d+347|0]|y[d+348|0]<<8;if(h){g=f+68|0;he(g,b,h);i=hc(f+12|0,g);ub(g);n=((y[d+347|0]|y[d+348|0]<<8)-2|0)/64|0;e:{if(!q){break e}x[31609]=0;d=U(196,j|0,e&65535,n|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(!d){break e}x[31609]=0;d=R(197,i|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}x[31609]=0;P(183,i|0,1)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}r=d?d>>>0>=n-2>>>0?-1:d+1|0:-1;g=0;f:while(1){if((g|0)!=(n|0)){d=Wb(x[j>>2],e);af(f+68|0,x[d>>2],x[x[d+48>>2]+12>>2],g);t=f,u=wb(x[f+68>>2]),x[t>>2]=u;s=nw(x[f+68>>2],x[f+72>>2]);while(1){d=x[f>>2];if(!Ib(d,s)){g=g+1|0;continue f}x[31609]=0;h=f+60|0;O(357,h|0,i|0);k=x[31609];x[31609]=0;if((k|0)==1){break c}m=_e(h);k=_i(h);o=y[f+60|0];if((o-1&255)>>>0<=71){v[d|0]=o+36;t=d,u=y[Jc(h)|0]+1|0,v[t+1|0]=u}h=y[m|0];if((h-1&255)>>>0<=15){v[d+2|0]=1;v[d+4|0]=(((h<<6)+-64&65472)>>>0)/15}m=y[k|0];h=m&15;v[d+5|0]=h;g:{h:{switch((y[k|0]>>>4|0)-1|0){case 0:case 1:v[d+5|0]=m|240;break g;case 2:v[d+5|0]=h<<2;break g;case 3:v[d+5|0]=(6/(h+1>>>0)|0)+1;break g;case 5:case 6:v[d+5|0]=h<<3;break g;case 9:v[d+2|0]=1;v[d+4|0]=(h<<2)+4;break g;case 10:v[d+5|0]=h|128;break g;case 11:break h;default:break g}}v[d+5|0]=(6/(h+1>>>0)|0)+1|13}v[d+3|0]=y[(y[k|0]>>>4|0)+24768|0];tg(f);continue}}break}Ae(Wb(x[j>>2],e),Xh(Ve(Oe(f+68|0,14,0),r)))}ub(i)}e=e+1|0;continue}}break}}}else{e=(d<<5)+a|0;g=e+480280|0;Ue(g);h=g;g=(f+862|0)+d|0;x[h>>2]=!y[g+50|0]<<10;w[e+480284>>1]=(y[g+76|0]<<4|8)&248;d=d+1|0;continue}break}a=N()|0;ub(i);Q(a|0);p()}fb=f+960|0;return l|0}function q1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=fb-560|0;fb=f;yc(b);d=fb-16|0;fb=d;g=f+63|0;pF(d+8|0,g);e=x[d+12>>2];lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2]);h=x[d+4>>2];if((h|0)==(e|0)){Vb(b,x[d+12>>2])}fb=d+16|0;d=(e|0)==(h|0);if(!d){oF(g)}a:{b:{if(!d){break b}if(!rF(g)){break b}d=1;if((c|0)==64){break a}if(!Mb(x[b>>2],x[b+8>>2],Bc(qF(y[f+173|0],y[f+174|0]),hb))){break b}Dd(a,64);x[a+480204>>2]=78e4;x[a+480260>>2]=112;x[a+480264>>2]=13696;x[a+480196>>2]=4;w[a+480188>>1]=8;Lb(a+1074312|0,7,1);d=f+36|0;g=uc(d,14692);zb(a+1298344|0,g);tb(g);g=uc(d,14725);zb(a+1298356|0,g);tb(g);$h(a+1298368|0,(y[f+63|0]|y[f+64|0]<<8)==26217?14692:14720);o=a+1298404|0,p=x[Fc(d,4)>>2],x[o>>2]=p;e=y[f+173|0];w[a+480190>>1]=e;g=1;while(1){h=g&65535;if(h>>>0<=e>>>0){e=fb-16|0;fb=e;d=f+36|0;cc(e+8|0,d,25);i=x[e+12>>2];lc(e,x[b>>2],x[b+8>>2],x[e+8>>2],x[e+12>>2]);j=x[e+4>>2];if((j|0)==(i|0)){Vb(b,x[e+12>>2])}fb=e+16|0;if((i|0)!=(j|0)){v[d|0]=0;v[d+1|0]=0;v[d+2|0]=0;v[d+3|0]=0;v[d+4|0]=0;v[d+5|0]=0;v[d+6|0]=0;v[d+7|0]=0;v[d+24|0]=0;v[d+16|0]=0;v[d+17|0]=0;v[d+18|0]=0;v[d+19|0]=0;v[d+20|0]=0;v[d+21|0]=0;v[d+22|0]=0;v[d+23|0]=0;v[d+8|0]=0;v[d+9|0]=0;v[d+10|0]=0;v[d+11|0]=0;v[d+12|0]=0;v[d+13|0]=0;v[d+14|0]=0;v[d+15|0]=0}if((y[f+49|0]|y[f+50|0]<<8|(y[f+51|0]<<16|y[f+52|0]<<24))>>>0>67108863){break b}e=(D(h,104)+a|0)+484380|0;nd(e,0);x[e+24>>2]=8363;j=y[d+13|0]|y[d+14|0]<<8|(y[d+15|0]<<16|y[d+16|0]<<24);x[e>>2]=j;k=y[d+17|0]|y[d+18|0]<<8|(y[d+19|0]<<16|y[d+20|0]<<24);x[e+4>>2]=k;i=y[d+21|0]|y[d+22|0]<<8|(y[d+23|0]<<16|y[d+24|0]<<24);x[e+8>>2]=i;c:{if(!(k|i>>>0<=j>>>0)){x[e+8>>2]=0;break c}if(i){w[e+34>>1]=2;Vk(e)}}e=f+12|0;ek(e,2,d);d=f+24|0;Cc(d,e);Ac(((h<<5)+a|0)+946304|0,d);g=g+1|0;tb(d);e=z[a+480190>>1];continue}break}g=f+24|0;e=f+65|0;ug(g,3,e,36);d=f+36|0;Cc(d,g);zb(a+1298308|0,d);tb(d);g=0;nF(a+1298332|0,e,108,36,0);d=a+484376|0;Kw(Xb(x[a+484360>>2],y[d|0]),f+176|0,128,255,254);d=Xb(x[a+484360>>2],y[d|0]);e=y[f+175|0];if(z[bc(x[d>>2],e)>>1]<y[f+174|0]){$e(d,e)}while(1)if((g|0)==8){i=a+484344|0;Tf(i,y[f+174|0]);n=c&1;h=0;while(1){d:{e:{if(y[f+174|0]<=h>>>0){d=1;if(!(c&2)){break a}c=Zc(f+36|0,8,1,0,1);g=1;break e}f:{if(n){if(Pg(i,h&65535,64)){break f}}Vb(b,1536);break d}x[f+24>>2]=-1;x[f+28>>2]=-1;j=0;g:while(1){if((j|0)==64){d=x[i>>2];g=(f+63|0)+h|0;e=y[g+369|0];if(e>>>0<63){Ae(Wb(d,h),Xh(Ve(Oe(f+36|0,14,0),e)));d=x[i>>2]}Ae(Wb(d,h),Xh(Oe(f+36|0,16,y[g+241|0])));break d}g=0;d=Wb(x[i>>2],h);e=md(x[d>>2],x[x[d+48>>2]+12>>2],j,0);while(1){if((g|0)==8){j=j+1|0;continue g}d=f+36|0;Rr(d,b);k=Jc(d);l=_e(d);k=y[k|0];d=y[f+36|0];if(d>>>0<=253){v[e|0]=(d>>>2|0)+37;v[e+1|0]=(d<<4&48|k>>>4)+1;v[(f+24|0)+g|0]=255;d=y[f+36|0]}if((d&255)!=255){v[e+2|0]=1;v[e+4|0]=(((k&15)<<6|8)>>>0)/15}d=y[l|0];if((d|0)!=255){v[(f+24|0)+g|0]=d}k=(f+24|0)+g|0;h:{i:{if(!(d&15)&(d|0)!=48){break i}l=y[k|0];if((l|0)==255){break h}m=l<<24>>24;d=m&15;v[e+5|0]=d;j:{if((m|0)<0){break j}l=l>>>4|0;v[e+3|0]=y[l+24568|0];k:{switch(l-3|0){case 0:v[e+5|0]=d|32;break i;case 1:v[e+5|0]=d|m<<4;break h;case 2:break i;case 3:break k;default:break h}}l:{switch(d|0){case 0:v[e+5|0]=79;break h;case 1:break l;default:break j}}v[e+5|0]=244;break h}v[e+3|0]=0;break h}v[k|0]=255}e=e+6|0;g=g+1|0;continue}}}while(1){d=g&65535;if(d>>>0<=z[a+480190>>1]){dg(c,(D(d,104)+a|0)+484380|0,b);g=g+1|0;continue}break}d=1;break a}h=h+1|0;continue}}else{d=(g<<5)+a|0;Ue(d+480280|0);w[d+480284>>1]=g&1?208:48;g=g+1|0;continue}}d=0}fb=f+560|0;return d|0}function aB(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,B=0;f=fb-16|0;fb=f;g=D(b,872)+a|0;o=g;m=g+1075800|0;j=y[m|0];k=a+1074312|0;Jb(f+8|0,k,23);h=c&15;a:{b:{c:{d:{e:{f:{g:{h:{i:{if(Gb(x[x[f+8>>2]>>2],x[f+12>>2])){if(!(x[a+1074392>>2]|!y[g+1075780|0])){v[m|0]=h;break i}e=y[m|0];if(e){g=e-1|0;v[m|0]=g;e=0;if(g&255){break c}}v[m|0]=h;e=1;break c}Jb(f+8|0,k,52);g=c&256;if(!(!g|!Gb(x[x[f+8>>2]>>2],x[f+12>>2]))){g=x[a+480208>>2]&4096;if(!g){break e}e=D(b,872)+a|0;if(y[e+1075781|0]){j=SZ(y[e+1075780|0])?1:j}i=D(b,872)+a|0;if(y[i+1075784|0]?y[e+1075782|0]==1:0){break b}e=0;if(h>>>0>j>>>0){break c}if(!g){break d}if(Tc(y[i+1075780|0])){break c}break d}i=x[a+480180>>2];if(i&16777250){if(j){g=(j>>>0)%((h>>>0<=1?1:h)>>>0)|0}else{g=1}e=!g;j=j+1|0;break c}if((i|0)==16){break g}if((i|0)!=1){break f}e=A[a+1074392>>2]%A[a+1074416>>2]|0;if(!e){if(Tc(y[(D(b,872)+a|0)+1075780|0])){break a}}if(h){break h}}e=0;break c}e=!((e>>>0)%(h>>>0)|0);break c}e=x[a+1074392>>2]==(h|0)&(h|0)!=0;break c}j:{if(!g){break j}e=D(b,872)+a|0;if(y[e+1075782|0]!=1){break j}h=(y[e+1075785|0]>15)+h|0}k:{if(x[a+480208>>2]&4096?g:1){h=h>>>0<=1?1:h;e=0;if(!(!x[a+1074416>>2]|g)){e=!(A[a+1074392>>2]%(h>>>0)|0)}j=j+1|0;break k}e=0;j=i&1048580?0:j}l:{if((j&255)>>>0<h>>>0){break l}if(!x[a+1074392>>2]){if(y[(D(b,872)+a|0)+1075780|0]|!g){break l}}e=1}Jb(f+8|0,k,52);if(!Gb(x[x[f+8>>2]>>2],x[f+12>>2])|c){break c}e=!x[a+1074392>>2];break c}if(h>>>0>j>>>0){break c}}j=0;e=1}h=o+1074992|0;q=(D(b,872)+a|0)+1075068|0;m:{if(x[q>>2]){break m}Jb(f+8|0,k,38);if(!Gb(x[x[f+8>>2]>>2],x[f+12>>2])){break m}if(!Cj(x[h+656>>2])){break a}}Jb(f+8|0,k,106);if(Gb(x[x[f+8>>2]>>2],x[f+12>>2])){if(!x[(D(b,872)+a|0)+1075688>>2]){break a}}if(e){i=D(b,872)+a|0;r=i+1075680|0;g=x[r>>2];x[f+4>>2]=g;e=c>>>4&15;n:{if(!e){e=x[i+1075080>>2];break n}Jb(f+8|0,k,52);o:{if(Gb(x[x[f+8>>2]>>2],x[f+12>>2])){if(y[(D(b,872)+a|0)+1075782|0]==1){break o}}if(!(16191>>>e&1)){x[f+4>>2]=(D(g,v[e+32064|0])|0)/16;break o}x[f+4>>2]=g+(v[e+32080|0]<<2)}He(f+4|0,0,256);g=(D(b,872)+a|0)+1075080|0;e=x[g>>2]|2097152;x[g>>2]=e}l=D(b,872)+a|0;s=l+1075692|0;t=x[s>>2];g=y[l+1075794|0];i=0;if(e&512){Jb(f+8|0,k,108);i=Gb(x[x[f+8>>2]>>2],x[f+12>>2])}if(!((i^-1)&x[a+480180>>2]==2|(!x[q>>2]|(g-1&255)>>>0>119))){NS(a,b,0,g,1)}p:{if(!(x[a+480180>>2]&1048580)){o=0;break p}o=(c|0)<256;if((c|0)>255){break p}e=y[(D(b,872)+a|0)+1075781|0];if(!e){break p}o=1;Ko(a,h,e,0,0,1)}l=l+1075080|0;Jb(f+8|0,k,85);q:{if(!Gb(x[x[f+8>>2]>>2],x[f+12>>2])){break q}e=D(b,872)+a|0;n=y[e+1075781|0];if(!n){break q}e=e+1075764|0;p=z[e>>1];Ko(a,h,n,0,0,1);w[e>>1]=p}n=D(b,872)+a|0;p=n+1075652|0;u=x[p>>2];B=x[l>>2];x[p>>2]=0;Jb(f+8|0,k,23);e=1;r:{if(Gb(x[x[f+8>>2]>>2],x[f+12>>2])){break r}e=0;if(x[a+480180>>2]!=2){break r}e=(i^1)&x[q>>2]!=0}Su(a,h,g,e,o,0,b);if(!y[n+1075781|0]){x[p>>2]=u}if(!(!(B&4096)|x[a+480180>>2]!=4)){x[l>>2]=x[l>>2]|4096}i=n+1075780|0;x[r>>2]=x[f+4>>2];if(z[a+480192>>1]){v[i|0]=g;LS(a,b)}g=x[a+480180>>2];if(!(!(g&16777248)|(y[i|0]|!t))){x[s>>2]=t}if(e){x[h>>2]=0;x[h+4>>2]=0}e=g&16777250;s:{if(d-11>>>0<4294967286){break s}g=D(b,872)+a|0;i=x[g+1075096>>2];if(!i){break s}t:{if((d|0)==1){b=x[g+1075656>>2];break t}g=(D(b,872)+a|0)+1075656|0;b=x[yb(i+68|0,d-2|0)>>2];x[g>>2]=b}Jo(a,h,b)}j=e?j:0}a=f+8|0;Jb(a,k,52);b=x[x[f+8>>2]>>2];d=x[f+12>>2];Jb(a,k,23);if(Gb(x[x[f+8>>2]>>2],x[f+12>>2])){break a}j=(Gb(b,d)&c>>>8)+j|0}v[m|0]=j}fb=f+16|0}function _s(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=fb-160|0;fb=e;x[e+148>>2]=-1;x[e+140>>2]=6;x[e+144>>2]=364;x[e+132>>2]=11;x[e+136>>2]=161;x[e+124>>2]=23;x[e+128>>2]=31;x[e+116>>2]=59;x[e+120>>2]=55;x[e+152>>2]=0;x[e+156>>2]=0;v[e+14|0]=c;v[e+13|0]=37;v[e+15|0]=0;l=b+484|0;i=b+460|0;j=b+172|0;k=b+4|0;f=e+16|0;h=f+(fa(f|0,100,e+13|0,e+116|0,x[b>>2])|0)|0;x[e+8>>2]=f;g=Fb(a);m=(c|0)!=120;a:while(1){b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{if((f|0)!=(h|0)){if(Jf(x[d+8>>2],1,v[f|0])){x[31609]=0;O(115,g|0,32);a=x[31609];x[31609]=0;if((a|0)==1){break c}a=x[d+8>>2];while(1){f=f+1|0;if((h|0)==(f|0)){f=h;break b}if(Jf(a,1,v[f|0])){continue}break}break b}x[e+4>>2]=f;x[31609]=0;x[e>>2]=0;a=ea(1383,e+4|0,h|0,k|0,j|0,d|0,e|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}p:{a=a-k|0;q:{if((a|0)<=167){x[31609]=0;O(115,g|0,37);c=x[31609];x[31609]=0;if((c|0)==1){break c}x[31609]=0;O(115,g|0,((a|0)<84?65:97)|0);a=x[31609];x[31609]=0;if((a|0)!=1){break q}break c}x[31609]=0;x[e+4>>2]=f;a=ea(1383,e+4|0,h|0,j|0,i|0,d|0,e|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}a=a-j|0;c=(a|0)/12|0;if((a|0)<=287){x[31609]=0;O(115,g|0,37);f=x[31609];x[31609]=0;if((f|0)==1){break c}x[31609]=0;O(115,g|0,((a|0)<144?66:98)|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}if(m){break q}if(!Jf(x[d+8>>2],64,v[dc((D(c,12)+b|0)+172|0,0)|0])){break q}n=yz(g),o=109,v[n|0]=o;break q}if((Cb(x[b+464>>2],y[b+471|0])|0)==(0-Cb(x[b+476>>2],y[b+483|0])|0)){break p}x[31609]=0;x[e+4>>2]=f;a=ea(1383,e+4|0,h|0,i|0,l|0,d|0,e|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}if((a-i|0)>23){break p}x[31609]=0;O(115,g|0,37);a=x[31609];x[31609]=0;if((a|0)==1){break c}x[31609]=0;O(115,g|0,112);a=x[31609];x[31609]=0;if((a|0)==1){break c}}f=x[e+4>>2];break b}x[e+4>>2]=f;a=v[f|0];if(Jf(x[d+8>>2],64,a)){x[31609]=0;a=ba(1384,e+8|0,h|0,e|0,d|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}r:{s:{switch(a-6|0){case 2:case 3:case 4:break r;case 0:break e;case 1:break f;case 5:break g;case 6:break h;default:break s}}t:{switch(a-55|0){case 0:break k;case 4:break l;case 6:break m;case 1:case 2:case 3:case 5:break r;default:break t}}if((a|0)==23){break i}if((a|0)==31){break j}if((a|0)==364){break n}if((a|0)==2061){break o}}a=x[e+8>>2];while(1){if((a|0)==(f|0)){f=a;continue a}c=v[f|0];x[31609]=0;O(115,g|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break c}f=f+1|0;continue}}u:{if((a|0)==37){x[31609]=0;O(115,g|0,37);a=x[31609];x[31609]=0;if((a|0)==1){break c}x[31609]=0;O(115,g|0,37);break u}x[31609]=0;O(115,g|0,a|0)}a=x[31609];x[31609]=0;if((a|0)==1){break c}f=f+1|0;break b}fb=e+160|0;return}x[31609]=0;O(115,g|0,37);a=x[31609];x[31609]=0;c=89;break d}x[31609]=0;O(115,g|0,37);a=x[31609];x[31609]=0;c=106;break d}x[31609]=0;O(115,g|0,37);a=x[31609];x[31609]=0;c=121;break d}x[31609]=0;O(115,g|0,37);a=x[31609];x[31609]=0;c=83;break d}x[31609]=0;O(115,g|0,37);a=x[31609];x[31609]=0;c=77;break d}x[31609]=0;O(115,g|0,37);a=x[31609];x[31609]=0;c=100;break d}x[31609]=0;O(115,g|0,37);a=x[31609];x[31609]=0;c=72;break d}x[31609]=0;O(115,g|0,37);a=x[31609];x[31609]=0;c=109;break d}x[31609]=0;O(115,g|0,37);a=x[31609];x[31609]=0;c=73;break d}x[31609]=0;O(115,g|0,37);a=x[31609];x[31609]=0;c=117;break d}x[31609]=0;O(115,g|0,37);a=x[31609];x[31609]=0;c=119}if((a|0)==1){break c}x[31609]=0;O(115,g|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}f=x[e+8>>2];continue}a=N()|0;tb(g);Q(a|0);p()}x[e+8>>2]=f;continue}}function yna(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=fb-48|0;fb=h;yc(b);a:{m=Zd(b);if((m-5&255)>>>0<253){break a}if(!Mb(x[b>>2],x[b+8>>2],4355)){break a}f=1;while(1){if((f&65535)>>>0<=256){k=h+32|0;kE(b,k);if(!AV(k,m)){break a}j=0;g=fb-32|0;fb=g;i=y[k+11|0];l=y[k+9|0]|y[k+10|0]<<8;v[g+14|0]=0;v[g+26|0]=i;w[g+24>>1]=l;w[g+12>>1]=0;while(1){if((j|0)!=3){i=xb(g+24|0,j);o=xb(g+12|0,j),p=y[i|0],v[o|0]=p;j=j+1|0;continue}break}i=cg(g+12|0);l=y[k+8|0];k=y[k+6|0]|y[k+7|0]<<8;j=0;v[g+10|0]=0;v[g+18|0]=l;w[g+16>>1]=k;w[g+8>>1]=0;while(1){if((j|0)!=3){k=xb(g+16|0,j);o=xb(g+8|0,j),p=y[k|0],v[o|0]=p;j=j+1|0;continue}break}j=cg(g+8|0);fb=g+32|0;d=i>>>0>j>>>0?f:d;f=f+1|0;continue}break}if(!(d&65535)){break a}e=1;if((c|0)==64){break a}Dd(a,1);w[a+480190>>1]=d;x[a+480228>>2]=(m|0)==3?192:48;x[a+480208>>2]=x[a+480208>>2]&-25165825|16777216;dd(b,1);k=d+1|0;j=k&65535;f=1;while(1)if((f|0)==(j|0)){dd(b,4097);ak(Xb(x[a+484360>>2],y[a+484376|0]),b,256,255,65535);e=0;f=Zd(b);if(f>>>0>31){break a}w[a+480188>>1]=f+1&255;f=Zd(b);d=z[a+480188>>1];g=f+1|0;if(!Mb(x[b>>2],x[b+8>>2],D(D(d,g),384)+d|0)){break a}while(1)if(z[a+480188>>1]<=e>>>0){j=a+484344|0;Tf(j,g);i=c&1;e=0;while(1){b:{if((e|0)!=(g|0)){c:{if(i){if(Pg(j,e&65535,64)){break c}}Vb(b,D(z[a+480188>>1],384));break b}l=Ng(h+32|0);f=Wb(x[j>>2],e);o=h,p=wb(x[f>>2]),x[o+16>>2]=p;n=wb(x[f+4>>2]);while(1){f=x[h+16>>2];if(!Ib(f,n)){break b}d=h+20|0;T_(d,b);d=y[xb(d,0)|0];if((d-1&255)>>>0<=76){v[f|0]=d+36}d=h+20|0;o=f,p=y[xb(d,1)|0],v[o+1|0]=p;d:{if(!zV(f,y[xb(d,2)|0],y[xb(d,5)|0],m)){break d}if(!zV(l,y[xb(d,3)|0],y[xb(d,4)|0],m)){break d}d=y[h+35|0];if(d){gm(h+14|0,f,y[f+3|0],y[f+5|0],d,y[h+37|0])}tg(h+16|0);continue}break}e=0;break a}e:{if(!(c&2)){break e}c=k&65535;f=1;while(1){if((c|0)==(f|0)){break e}d=D(f,104)+a|0;dg(Zc(h+32|0,w[d+484414>>1]&1?16:8,1,0,0),d+484380|0,b);f=f+1|0;continue}}$h(a+1298344|0,14231);$h(a+1298356|0,11152);sf(a+1298368|0);o=a+1298404|0,p=x[Fc(h+32|0,4)>>2],x[o>>2]=p;e=1;break a}e=e+1|0;continue}}else{f=(e<<5)+a|0;Ue(f+480280|0);o=f+480284|0,p=D(Zd(b),17),w[o>>1]=p;e=e+1|0;continue}}else{kE(b,h+32|0);e=0;d=fb-16|0;fb=d;g=(D(f,104)+a|0)+484380|0;nd(g,1);i=y[h+43|0];l=y[h+41|0]|y[h+42|0]<<8;v[d+6|0]=0;v[d+10|0]=i;w[d+8>>1]=l;w[d+4>>1]=0;while(1){if((e|0)!=3){i=xb(d+8|0,e);o=xb(d+4|0,e),p=y[i|0],v[o|0]=p;e=e+1|0;continue}break}i=cg(d+4|0);l=y[h+40|0];n=y[h+38|0]|y[h+39|0]<<8;e=0;v[d+2|0]=0;v[d+10|0]=l;w[d+8>>1]=n;w[d>>1]=0;while(1){if((e|0)!=3){l=xb(d+8|0,e);o=xb(d,e),p=y[l|0],v[o|0]=p;e=e+1|0;continue}break}o=g,p=i-cg(d)|0,x[o>>2]=p;i=y[h+34|0];l=y[h+32|0]|y[h+33|0]<<8;e=0;v[d+6|0]=0;v[d+10|0]=i;w[d+8>>1]=l;w[d+4>>1]=0;while(1){if((e|0)!=3){i=xb(d+8|0,e);o=xb(d+4|0,e),p=y[i|0],v[o|0]=p;e=e+1|0;continue}break}o=g,p=cg(d+4|0)+1|0,x[o+4>>2]=p;i=y[h+37|0];l=y[h+35|0]|y[h+36|0]<<8;e=0;v[d+6|0]=0;v[d+10|0]=i;w[d+8>>1]=l;w[d+4>>1]=0;while(1){if((e|0)!=3){i=xb(d+8|0,e);o=xb(d+4|0,e),p=y[i|0],v[o|0]=p;e=e+1|0;continue}break}o=g,p=cg(d+4|0)+1|0,x[o+8>>2]=p;e=y[h+45|0];i=e>>>2|0;i=z[g+34>>1]&-7|i&2|i&4;w[g+34>>1]=i;if(e&4){w[g+34>>1]=i|1;x[g>>2]=x[g>>2]>>>1}w[g+30>>1]=y[h+44|0];if((m|0)!=2){x[g+24>>2]=y[h+46|0]|y[h+47|0]<<8}yV(g);fb=d+16|0;d=Dc(h+20|0,22292);Ac(((f<<5)+a|0)+946304|0,d);tb(d);f=f+1|0;continue}}fb=h+48|0;return e|0}function Zka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=fb-96|0;fb=e;h=e+76|0;i=a+140|0;Uj(h,i,1296125513);x[31609]=0;f=R(172,x[e+76>>2])|0;g=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{if((g|0)!=1){if(f){f=Fb(e+28|0);x[31609]=0;g=R(154,x[e+76>>2])|0;j=x[31609];x[31609]=0;if((j|0)==1){break p}x[31609]=0;S(813,h|0,f|0,g|0);h=x[31609];x[31609]=0;if((h|0)==1){break p}g=z[a+174>>1];x[31609]=0;h=e- -64|0;S(814,h|0,g|0,f|0);g=x[31609];x[31609]=0;if((g|0)==1){break o}x[31609]=0;g=e+4|0;S(815,g|0,c|0,h|0);c=x[31609];x[31609]=0;if((c|0)==1){break n}Ac(d,g);tb(g);tb(h);tb(f)}if(y[a+176|0]){x[31609]=0;c=e+28|0;O(816,c|0,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break e}Be(b+43|0,c);tb(c)}x[31609]=0;c=e+28|0;S(808,c|0,i|0,1413894985);f=x[31609];x[31609]=0;if((f|0)==1){break l}x[31609]=0;h=R(817,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break k}ub(c);f=a+40|0;yc(f);x[31609]=0;c=P(818,f|0,c|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break j}if(c){q:{if((y[e+56|0]|y[e+57|0]<<8|(y[e+58|0]<<16|y[e+59|0]<<24))>>>0<2){break q}x[31609]=0;c=e+4|0;g=P(819,f|0,c|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break i}if(!g){break q}BR(c,b+12|0,b+16|0,x[b>>2],b+34|0,8,16,h)}x[31609]=0;c=e+4|0;f=P(819,f|0,c|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break i}if(f){BR(c,b+4|0,b+8|0,x[b>>2],b+34|0,2,4,h)}c=y[e+40|0]|y[e+41|0]<<8|(y[e+42|0]<<16|y[e+43|0]<<24);v[b+42|0]=c&128?0:c+1|0;Vk(b)}r:{if(y[b+42|0]){break r}c=x[a+60>>2];x[31609]=0;c=P(679,c|0,7)|0;f=x[31609];x[31609]=0;if((f|0)==1){break j}if(!c){break r}c=a+60|0;yc(c);x[31609]=0;c=P(820,c|0,e+4|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break d}if(!c){break r}c=v[e+4|0];v[b+42|0]=(c|0)>=0?c+1|0:0}c=x[a+120>>2];x[31609]=0;c=R(172,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break j}if(!c){break f}x[31609]=0;g=a+120|0;c=R(151,g|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break c}x[e+64>>2]=c;xc(e- -64|0,9);f=b+68|0;h=x[e+64>>2];c=0;while(1){if((c|0)==(h|0)){break g}x[31609]=0;O(821,g|0,e+4|0);i=x[31609];x[31609]=0;if((i|0)==1){break h}k=yb(f,c),l=y[e+8|0]|y[e+9|0]<<8|(y[e+10|0]<<16|y[e+11|0]<<24),x[k>>2]=l;c=c+1|0;continue}}a=N()|0;break a}a=N()|0;break m}a=N()|0;break m}a=N()|0;tb(e- -64|0)}tb(f);break a}a=N()|0;break a}a=N()|0;ub(e+28|0);break a}a=N()|0;break a}a=N()|0;break a}a=N()|0;break a}Yz(f+(h<<2)|0,KZ(f),41076)}c=a+80|0;yc(c);x[31609]=0;f=P(822,c|0,e+4|0)|0;h=x[31609];x[31609]=0;s:{if((h|0)==1){break s}if(!f){break b}if(y[e+4|0]&32){w[b+34>>1]=z[b+34>>1]|32}w[e+64>>1]=z[e+8>>1];w[e+2>>1]=256;k=b,l=z[Oc(e- -64|0,e+2|0)>>1],w[k+28>>1]=l;w[e+64>>1]=z[e+10>>1];w[e+2>>1]=256;k=b,l=z[Oc(e- -64|0,e+2|0)>>1],w[k+30>>1]=l;w[e+64>>1]=z[e+12>>1];w[e+2>>1]=64;k=b,l=z[Oc(e- -64|0,e+2|0)>>1],w[k+32>>1]=l;v[b+38|0]=y[e+16|0];v[b+39|0]=y[e+17|0];v[b+40|0]=y[e+18|0];v[b+41|0]=y[e+19|0];f=x[a+88>>2];a=x[a+80>>2];x[31609]=0;a=U(150,a|0,f|0,32)|0;f=x[31609];x[31609]=0;if((f|0)==1){break s}if(!a){break b}x[31609]=0;O(823,c|0,d|0);a=x[31609];x[31609]=0;if((a|0)==1){break s}x[31609]=0;a=R(202,c|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break s}x[31609]=0;S(824,c|0,b+43|0,a|0);a=x[31609];x[31609]=0;if((a|0)!=1){break b}}a=N()|0;break a}a=N()|0;break a}a=N()|0;break a}a=N()|0;break a}ub(e+76|0);fb=e+96|0;return}ub(e+76|0);Q(a|0);p()}function Moa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;f=fb-176|0;fb=f;yc(b);d=f+128|0;a:{if(!SD(b,d)){break a}if(!MW(d)){break a}if(!Mb(x[b>>2],x[b+8>>2],Bc(LW(y[f+159|0],y[f+161|0]),hb))){break a}e=1;if((c|0)==64){break a}Dd(a,256);g=f+16|0;qi(g,2,d);d=f+48|0;Cc(d,g);zb(a+1298308|0,d);tb(d);e=uc(d,15430);zb(a+1298344|0,e);tb(e);e=uc(d,10136);zb(a+1298356|0,e);tb(e);gg(g,4271);x[31609]=0;e=f+116|0;O(249,e|0,f+159|0);h=x[31609];x[31609]=0;b:{c:{if((h|0)!=1){x[31609]=0;V(700,d|0,g|0,f+158|0,e|0);h=x[31609];x[31609]=0;if((h|0)!=1){zb(a+1298368|0,d);tb(d);tb(e);Eb(g);o=a+1298404|0,q=x[Fc(d,4)>>2],x[o>>2]=q;d=Lb(a+1074312|0,107,1);x[a+480260>>2]=64;x[a+480264>>2]=32767;x[a+480188>>2]=2031620;Lb(d,107,1);e=y[f+160|0];d=y[f+159|0];if(d>>>0<=20){g=((e&255)>>>0)/10|0;e=g<<4|D(g,-10)+e}g=(e&255?e:96)&255;e=AC(g);x[a+480196>>2]=g>>>4;x[a+480204>>2]=e;if(d>>>0>=11){v[f+48|0]=64;o=a,q=y[Qb(f+162|0,f+48|0)|0]<<2,x[o+480200>>2]=q}e=0;while(1)if((e|0)==4){e=1;while(1){if((e|0)!=32){d=f+16|0;wr(b,d);g=y[f+28|0];if(g?(g|0)!=46:0){break b}h=fb-32|0;fb=h;g=(D(e,104)+a|0)+484380|0;nd(g,0);j=h+8|0;Mk(j,2,d);i=h+20|0;Cc(i,j);Be(g+43|0,i);tb(i);x[g+24>>2]=y[d+24|0]|y[d+25|0]<<8;v[h+20|0]=y[d+22|0];v[h+8|0]=64;o=g,q=y[Qb(i,j)|0]<<2,w[o+30>>1]=q;i=y[d+16|0]|y[d+17|0]<<8;x[g>>2]=i;j=y[d+18|0]|y[d+19|0]<<8;x[g+4>>2]=j;k=y[d+20|0]|y[d+21|0]<<8;x[g+8>>2]=k;d:{if(i>>>0<=1){x[g>>2]=0;break d}if((k|0)==65535|i>>>0<=j>>>0|j>>>0>=k>>>0){break d}w[g+34>>1]=2;o=g,q=x[Hb(g+8|0,g)>>2],x[o+8>>2]=q}fb=h+32|0;g=f+4|0;Mk(g,2,d);d=f+116|0;Cc(d,g);Ac(((e<<5)+a|0)+946304|0,d);tb(d);w[((e<<1)+f|0)+46>>1]=y[f+30|0]|y[f+31|0]<<8;e=e+1|0;continue}break}d=a+484376|0;ak(Xb(x[a+484360>>2],y[d|0]),b,y[f+159|0]?128:64,65535,65535);e=0;if(!JW(Xb(x[a+484360>>2],y[d|0]))){break a}m=c&1;if(m){Tf(a+484344|0,y[f+161|0])}j=a+484344|0;h=0;while(1)if(y[f+161|0]<=h>>>0){e=1;if(!(c&2)){break a}c=Zc(f+16|0,8,1,0,0);while(1)if((e|0)==32){e=1;break a}else{d=D(e,104)+a|0;g=d+484380|0;e:{if(!x[g>>2]|!z[d+484410>>1]){break e}d=z[((e<<1)+f|0)+46>>1];if(d>>>0<4){break e}if(!dd(b,d<<4)){break e}dg(c,g,b)}e=e+1|0;continue}}else{f:{g:{if(m){if(Pg(j,h&65535,64)){break g}}e=0;while(1){if((e|0)==256){break f}if((Zd(b)+2&255)>>>0<=252){Vb(b,3)}e=e+1|0;continue}}o=f,q=wb(x[Wb(x[j>>2],h)>>2]),x[o+116>>2]=q;w[f+2>>1]=65535;x[f+4>>2]=63;i=0;h:while(1){e=0;if((i|0)==64){d=z[f+2>>1];if((d|0)==65535){break f}Ae(Wb(x[j>>2],h),Bn(Ve(Oe(f+16|0,12,d&255),x[f+4>>2])));break f}while(1){i:{j:{k:{if((e&65535)>>>0<=3){d=0;k=0;l=0;n=0;l:{m:{n:{o:{g=Zd(b);switch(g-251|0){case 1:break i;case 0:break m;case 2:break o;default:break n}}v[x[f+116>>2]]=254;break i}d=f+16|0;Rr(d,b);k=y[xb(d,0)|0];l=y[xb(d,1)|0];n=y[xb(d,2)|0];d=254;if((g|0)==254){break l}if(g>>>0>=96){break k}d=g}d=(D(d>>>4|0,12)+(d&15)|0)+37|0}g=d;d=x[f+116>>2];v[d|0]=g;break j}i=i+1|0;continue h}d=x[f+116>>2]}v[d+1|0]=(k&248)>>>3;g=l>>>1&120|k&7;if(g>>>0<=64){v[d+4|0]=g;v[d+2|0]=1}v[d+5|0]=n;IW(d,l&15,i,y[f+159|0],f+2|0,f+4|0)}e=e+1|0;LC(f+116|0);continue}}}h=h+1|0;continue}}else{d=(e<<5)+a|0;Ue(d+480280|0);w[d+480284>>1]=e&1?64:192;e=e+1|0;continue}}e=N()|0;tb(f+116|0);break c}e=N()|0}Eb(f+16|0);Q(e|0);p()}e=0}fb=f+176|0;return e|0}function Bka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,A=0,B=0,C=0,F=0,G=0,H=0,I=0;l=fb-32|0;fb=l;s=x[a+4>>2];k=Se(x[a+8>>2],b);t=x[k>>2];a:{if(t+1>>>0<2){break a}h=D(b,872)+s|0;i=h+616|0;if(!(Oi(x[i+8>>2],x[i+12>>2])|y[k+4|0])|!x[h+720>>2]){break a}j=x[h+704>>2]&2;f=x[(j?h+700|0:h+692|0)>>2];n=x[h+700>>2];e=x[h+696>>2];u=Ob(x[a>>2]+1074312|0,31);g=vf(x[h+624>>2],x[h+628>>2],c);m=y[h+704|0]&128;k=m?0-g|0:g;o=hb;m=m?0-(o+((g|0)!=0)|0)|0:o;g=0;o=f;f=j;w=f?g:0;r=f?e:0;n=n-e|0;B=n<<1;C=h+1316|0;p=h+1467|0;A=h+1362|0;F=(y[A|0]&17)!=1;b:{c:{while(1){if((q|0)!=(t|0)){d:{if(d>>>0>q>>>0){f=(y[A|0]&17)==1;break d}x[x[a+4>>2]+16>>2]=q-d;v[p|0]=y[p|0]&254|(d|0)==(q|0);f=x[a>>2];j=x[a+4>>2];e=Wb(x[f+484344>>2],z[j+70>>1]);e=md(x[e>>2],x[x[e+48>>2]+12>>2],x[j+48>>2],b);g=y[e+3|0];e:{f:{switch(y[e+2|0]-11|0){case 0:j=l+8|0;xB(j,f,g,y[e+4|0],0);j=_e(j);Ou(x[a>>2],x[a+4>>2],b,z[l+8>>1]);f=1;if(!y[j|0]){break e}break d;case 1:qB(f,j,b,y[e+4|0]<<2&252,Ob(f+1074312|0,12));break e;case 2:break f;default:break e}}pB(f,j,b,y[e+4|0]<<2&252,Ob(f+1074312|0,12))}f=1;g:{h:{i:{j:{k:{switch(g-2|0){default:if(g-38>>>0<4){break h}if((g|0)==19){break j}if((g|0)!=28){break g}e=y[e+5|0];f=e&240;if((f|0)==32){break i}if((f|0)!=16){break g}oB(x[a>>2],i,e&15);break g;case 2:Ou(x[a>>2],x[a+4>>2],b,y[e+5|0]);break g;case 4:Ou(x[a>>2],x[a+4>>2],b,0);break g;case 0:e=y[e+5|0];g=x[a>>2];if(!e&(v[g+480180|0]&1)){break d}qB(g,x[a+4>>2],b,e,0);break g;case 1:break k;case 3:break d}}e=y[e+5|0];g=x[a>>2];if(!e&(v[g+480180|0]&1)){break d}pB(g,x[a+4>>2],b,e,0);break g}f=y[e+5|0];e=f&15;if(!(e|x[x[a>>2]+480180>>2]&1048580)){break g}f=f&240;if((f|0)!=32){if((f|0)!=16){break g}nB(x[a>>2],i,e);break g}mB(x[a>>2],i,e);break g}lB(x[a>>2],i,e&15);break g}gT(x[a>>2],i,y[e+5|0],(g|0)==38|(g|0)==40,(g&254)==40)}f=1}x[l+28>>2]=x[C>>2];if(u){Nu(x[a>>2],i)}if(!F){fT(x[a>>2],i,l+28|0);f=1}if(!u){Nu(x[a>>2],i)}x[l+24>>2]=0;eT(i,l+24|0);l:{if(y[h+705|0]&2){break l}m:{if(!f){if(!y[Se(x[a+8>>2],b)+4|0]){break m}}if(y[p|0]&96){mV(i,E(1),0,x[a>>2]);k=y[p|0];v[p|0]=(k&64?-65:-97)&k}yB(l+8|0,x[a>>2],i,x[l+28>>2],0);e=x[l+12>>2];k=x[l+8>>2];x[h+624>>2]=k;x[h+628>>2]=e;H=Se(x[a+8>>2],b),I=0,v[H+4|0]=I;e=vf(k,e,c);f=y[h+704|0]&128;k=f?0-e|0:e;g=hb;m=f?0-(g+((e|0)!=0)|0)|0:g}Pb(i,k,m);g=x[i>>2];e=x[i+4>>2];if((g>>>0<G>>>0&(e|0)<=(o|0)|(e|0)<(o|0))&((e|0)>=(r|0)&g>>>0>=w>>>0|(e|0)>(r|0)|((m|0)>0|(m|0)>=0))){break l}f=x[h+704>>2];if(!(f&2)){break c}if(f&4){j=x[h+696>>2];if(g>>>0<w>>>0&(e|0)<=(r|0)|(e|0)<(r|0)){H=i,I=hh(0,j<<1,g,e),x[H>>2]=I;e=hb;x[i+4>>2]=e;x[h+704>>2]=f^128;f=k;k=0-f|0;m=0-(((f|0)!=0)+m|0)|0}e=(e-j>>>0)%(B-Ob(x[a>>2]+1074312|0,33)>>>0)|0;n:{if(e>>>0<n>>>0){f=e+x[h+696>>2]|0;break n}f=x[h+700>>2]+(n-e|0)|0}x[i+4>>2]=f;f=x[h+704>>2];if((f&128)>>>7^e>>>0<n>>>0){break l}x[h+704>>2]=f^128;e=k;k=0-e|0;m=0-(((e|0)!=0)+m|0)|0;break l}f=e;j=x[h+700>>2];if(e>>>0>=j+n>>>0){f=j+((e-j>>>0)%(n>>>0)|0)|0}while(1){e=f;f=e-n|0;if(e>>>0>=j>>>0){continue}break}x[i>>2]=g;x[i+4>>2]=e}q=q+1|0;continue}break}x[x[a+4>>2]+16>>2]=0;break b}x[x[a+4>>2]+16>>2]=0;oV(i);x[(D(b,872)+s|0)+1324>>2]=0}H=Se(x[a+8>>2],b),I=0,x[H>>2]=I}fb=l+32|0}function WP(a){var b=0,c=E(0),d=E(0),e=E(0),f=E(0),g=E(0),h=0,i=0,j=0,k=0,l=E(0),m=E(0),n=0,o=E(0),p=0,q=E(0),r=E(0),s=E(0),t=0,u=E(0);j=fb-16|0;fb=j;b=a+4208|0;i=Ck(E(B[yb(b,12)>>2]*E(3)));x[a+4264>>2]=i;d=E(x[x[a+16>>2]+24620>>2]>>>((i^-1)>>>1&1)>>>0);B[a+4268>>2]=d;t=a,u=E(E(B[yb(b,9)>>2]*E(100))*E(.0061803399585187435)),B[t+4272>>2]=u;t=j,u=Ee(E(10),E(E(VP(a)+E(E(B[yb(b,5)>>2]*E(11e3))+E(-1e4)))/E(2e3))),B[t+12>>2]=u;x[j+8>>2]=1065353216;t=a,u=E(B[Sm(j+12|0,j+8|0)>>2]*E(.7609999775886536)),B[t+4280>>2]=u;c=Ee(E(10),E(E(E(E(B[yb(b,1)>>2]*E(1e4))+E(-1e4))/E(100))/E(10)));if(c!=E(1)){d=tq(E(E(UP(a)*E(6.2831854820251465))/d));f=E(c+c);e=E(c*c);c=CB(E(E(E(E(d*f)+E(-2))+E(M(E(E(E(E(d*E(E(d*e)*E(4)))+E(c*E(8)))-E(e*E(4)))-E(E(d*c)*E(8))))))/E(f+E(-2))),E(0),E(1))}else{c=E(0)}B[a+4276>>2]=c;i=fb-16|0;fb=i;c=B[a+4268>>2];b=a+4208|0;d=E(B[yb(b,6)>>2]*E(.30000001192092896));t=i,u=E(B[yb(b,8)>>2]*E(.10000000149011612)),B[t+12>>2]=u;x[i+8>>2]=1000593162;f=B[Xz(i+12|0,i+8|0)>>2];e=E(c*E(E(d+f)+E(.007000000216066837)));a:{if(E(F(e))<E(2147483648)){b=~~e;break a}b=-2147483648}x[a+4352>>2]=b;b=1;while(1){if((b|0)==12){t=i,u=E(E(E(E(B[yb(a+4208|0,10)>>2]*E(100))/E(100))+E(.10000000149011612))*E(.9090999960899353)),B[t+12>>2]=u;x[i+8>>2]=1065353216;d=B[Sm(i+12|0,i+8|0)>>2];f=E(c*E(E(d*E(75))/E(1e3)));d=E(c*E(E(d*E(67))/E(1e3)));b=0;while(1){if((b|0)==6){h=a+4348|0;d=E(c*E(.0035299998708069324));b:{if(E(F(d))<E(2147483648)){b=~~d;break b}b=-2147483648}x[h>>2]=b;h=a+4344|0;d=E(c*E(.0032500000670552254));c:{if(E(F(d))<E(2147483648)){b=~~d;break c}b=-2147483648}x[h>>2]=b;h=a+4340|0;c=E(c*E(.009999999776482582));d:{if(E(F(c))<E(2147483648)){b=~~c;break d}b=-2147483648}x[h>>2]=b}else{h=(b<<2)+a|0;p=h+4316|0;n=b+n|0;e=Ee(E(.9300000071525574),E(n|0));g=E(f*e);e:{if(E(F(g))<E(2147483648)){k=~~g;break e}k=-2147483648}x[p>>2]=k;k=h+4292|0;e=E(d*e);f:{if(E(F(e))<E(2147483648)){h=~~e;break f}h=-2147483648}x[k>>2]=h;b=b+1|0;continue}break}b=0;while(1){if((b|0)!=15){YP((D(b,24)+a|0)+4504|0,x[((b<<2)+a|0)+4292>>2]);b=b+1|0;continue}break}fb=i+16|0}else{k=((D(b&1,24)+a|0)+(b<<1&-4)|0)+4352|0;e=E(c*E(E(f*B[(b<<2)+45344>>2])+d));g:{if(E(F(e))<E(2147483648)){h=~~e;break g}h=-2147483648}x[k>>2]=h;b=b+1|0;continue}break}b=fb-16|0;fb=b;d=Qh(a,5);e=Qh(a,11);c=E(d*Qh(a,4));d=E(E(c*E(.03999999910593033))+E(E(d*E(.02250000089406967))+E(0)));f=E(e*Qh(a,10));e=E(E(f*E(.03999999910593033))+E(E(e*E(.02250000089406967))+E(0)));if(v[a+4264|0]&1){g=Qh(a,3);l=Qh(a,9);g=E(c*g);c=E(g*Qh(a,2));d=E(E(c*E(.1444000005722046))+E(E(g*E(.12250000238418579))+d));g=E(f*l);f=E(g*Qh(a,8));e=E(E(f*E(.1444000005722046))+E(E(g*E(.12250000238418579))+e))}Qh(a,12);g=B[a+4496>>2];l=Qh(a,1);m=Qh(a,7);q=Qh(a,0);r=Qh(a,6);t=b,u=Ee(E(10),E(E(VP(a)+E(E(B[yb(a+4208|0,7)>>2]*E(12e3))+E(-1e4)))/E(2e3))),B[t+12>>2]=u;x[b+8>>2]=1065353216;o=B[Sm(b+12|0,b+8|0)>>2];s=c;c=E(g*g);g=E(l*E(s*c));l=E(q*g);c=E(m*E(f*c));f=E(r*c);m=E(E(E(l+f)*E(-.5))+E(1));B[a+4284>>2]=o*E(M(E(m/E(E(l*E(.1444000005722046))+E(E(c*E(.1444000005722046))+d)))));B[a+4288>>2]=o*E(M(E(m/E(E(f*E(.1444000005722046))+E(E(g*E(.1444000005722046))+e)))));fb=b+16|0;v[a+5046|0]=0;fb=j+16|0}function cH(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=fb-32|0;fb=g;d=x[b+28>>2];x[g+24>>2]=x[b+24>>2];x[g+28>>2]=d;d=x[b+20>>2];x[g+16>>2]=x[b+16>>2];x[g+20>>2]=d;d=x[b+12>>2];x[g+8>>2]=x[b+8>>2];x[g+12>>2]=d;d=x[b+4>>2];x[g>>2]=x[b>>2];x[g+4>>2]=d;d=fb-144|0;fb=d;k=Fb(d+132|0);n=Fb(d+120|0);x[31609]=0;b=P(1,d+108|0,c|0)|0;c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)!=1){c=zb(n,b);tb(b);if(!x[g>>2]){break b}x[31609]=0;b=d+96|0;O(73,b|0,g|0);e=x[31609];x[31609]=0;d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{if((e|0)!=1){x[31609]=0;i=P(74,k|0,b|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break q}tb(b);x[31609]=0;e=P(1,d+84|0,16834)|0;f=x[31609];x[31609]=0;if((f|0)==1){break p}x[31609]=0;f=d+72|0;O(75,f|0,g+4|0);h=x[31609];x[31609]=0;if((h|0)==1){break o}x[31609]=0;S(2,b|0,e|0,f|0);h=x[31609];x[31609]=0;if((h|0)==1){break n}x[31609]=0;i=P(74,i|0,b|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break m}tb(b);tb(f);tb(e);x[31609]=0;e=P(1,f|0,16834)|0;f=x[31609];x[31609]=0;if((f|0)==1){break j}x[31609]=0;f=d+60|0;O(75,f|0,g+8|0);h=x[31609];x[31609]=0;if((h|0)==1){break i}x[31609]=0;S(2,b|0,e|0,f|0);h=x[31609];x[31609]=0;if((h|0)==1){break h}x[31609]=0;i=P(74,i|0,b|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break g}tb(b);tb(f);tb(e);e=x[g+28>>2];o=e;b=x[g+24>>2];if(x[g+12>>2]|(x[g+16>>2]|!(e|b))){break d}break b}a=N()|0;break c}a=N()|0;tb(d+96|0);break c}a=N()|0;break c}a=N()|0;break k}a=N()|0;break l}a=N()|0;tb(d+96|0)}tb(d+72|0)}tb(e);break c}a=N()|0;break c}a=N()|0;break e}a=N()|0;break f}a=N()|0;tb(d+96|0)}tb(d+60|0)}tb(e);break c}x[31609]=0;e=P(1,d+96|0,13778)|0;f=x[31609];x[31609]=0;r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{if((f|0)!=1){x[31609]=0;l=P(74,i|0,e|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break J}tb(e);x[31609]=0;f=d+36|0;O(76,f|0,g+12|0);e=x[31609];x[31609]=0;if((e|0)==1){break I}x[31609]=0;e=P(1,d+24|0,14690)|0;i=x[31609];x[31609]=0;if((i|0)==1){break H}x[31609]=0;i=d+48|0;S(2,i|0,f|0,e|0);h=x[31609];x[31609]=0;if((h|0)==1){break G}x[31609]=0;h=d+12|0;O(76,h|0,g+16|0);j=x[31609];x[31609]=0;if((j|0)==1){break F}x[31609]=0;j=d+60|0;S(2,j|0,i|0,h|0);m=x[31609];x[31609]=0;if((m|0)==1){break E}x[31609]=0;l=P(74,l|0,j|0)|0;m=x[31609];x[31609]=0;if((m|0)==1){break D}tb(j);tb(h);tb(i);tb(e);tb(f);if(b|o){break y}x[31609]=0;S(77,a|0,l|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break x}break a}a=N()|0;break c}a=N()|0;tb(e);break c}a=N()|0;break c}a=N()|0;break z}a=N()|0;break A}a=N()|0;break B}a=N()|0;break C}a=N()|0;tb(d+60|0)}tb(d+12|0)}tb(d+48|0)}tb(e)}tb(d+36|0);break c}x[31609]=0;b=P(1,d+48|0,14690)|0;e=x[31609];x[31609]=0;if((e|0)==1){break w}x[31609]=0;e=d+36|0;O(78,e|0,g+24|0);f=x[31609];x[31609]=0;if((f|0)==1){break v}x[31609]=0;f=d+60|0;S(2,f|0,b|0,e|0);i=x[31609];x[31609]=0;if((i|0)==1){break u}x[31609]=0;i=P(74,l|0,f|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break t}tb(f);tb(e);tb(b);x[31609]=0;P(74,i|0,c|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break b}}a=N()|0;break c}a=N()|0;break c}a=N()|0;break r}a=N()|0;break s}a=N()|0;tb(d+60|0)}tb(d+36|0)}tb(b);break c}a=N()|0}tb(n);tb(k);Q(a|0);p()}Uc(a,k)}tb(c);tb(k);fb=d+144|0;fb=g+32|0}function Qz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=fb-240|0;fb=e;v[e+239|0]=c;g=x[b+4>>2];a:{if(!g){f=x[b>>2];break a}f=x[b>>2];h=y[Al(f,g)|0];if((h|0)==33){d=1}else{if((h|0)!=63){break a}d=0}Nl(e+80|0,f,g,g-1|0);g=x[e+84>>2];f=x[e+80>>2];x[b>>2]=f;x[b+4>>2]=g}h=e+80|0;ie(h);i=x[e+80>>2];j=e+216|0;ie(j);i=zl(i,x[e+220>>2],b);ie(h);b:{c:{d:{e:{f:{g:{h:{if(x[e+84>>2]==(i|0)){a=qc(e+228|0,22292);c=x[a+4>>2];x[e>>2]=x[a>>2];x[e+4>>2]=c;if(Ic(f,g,e)){g=ac(8);x[31609]=0;O(1004,j|0,e+239|0);a=x[31609];x[31609]=0;if((a|0)==1){break g}x[31609]=0;S(1011,h|0,18271,j|0);a=x[31609];x[31609]=0;if((a|0)==1){break f}pc(g,h);f=0;x[31609]=0;S(97,g|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(h);break e}if(!d){break h}g=ac(8);a=x[b>>2];b=x[b+4>>2];x[31609]=0;a=bi(e+192|0,a,b);b=x[31609];x[31609]=0;i:{j:{k:{l:{m:{n:{o:{p:{if((b|0)!=1){x[31609]=0;b=e+204|0;S(1011,b|0,18307,a|0);c=x[31609];x[31609]=0;if((c|0)==1){break p}x[31609]=0;f=e+216|0;O(1013,f|0,b|0);b=x[31609];x[31609]=0;c=1;if((b|0)==1){break o}x[31609]=0;b=e+180|0;O(1004,b|0,e+239|0);c=x[31609];x[31609]=0;if((c|0)==1){break n}x[31609]=0;d=e+80|0;S(1015,d|0,f|0,b|0);b=x[31609];x[31609]=0;c=1;if((b|0)==1){break m}pc(g,d);x[31609]=0;S(97,g|0,48428,1e3);b=x[31609];x[31609]=0;if((b|0)!=1){break b}b=N()|0;tb(d);c=0;break l}b=N()|0;break d}b=N()|0;c=1;break i}b=N()|0;break j}b=N()|0;c=1;break k}b=N()|0}tb(e+180|0)}tb(e+216|0)}tb(e+204|0)}tb(a);if(c){break d}break c}b=qc(e+172|0,22292);d=x[b+4>>2];x[e+72>>2]=x[b>>2];x[e+76>>2]=d;if(Ic(f,g,e+72|0)){g=ac(8);x[31609]=0;b=e+216|0;O(1004,b|0,e+239|0);a=x[31609];x[31609]=0;q:{r:{if((a|0)!=1){x[31609]=0;a=e+80|0;S(1011,a|0,18271,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break r}pc(g,a);f=0;x[31609]=0;S(97,g|0,48428,1e3);b=x[31609];x[31609]=0;if((b|0)!=1){break b}b=N()|0;tb(a);break q}b=N()|0;break d}b=N()|0;f=1}tb(e+216|0);if(f){break d}break c}b=qc(e+164|0,7462);d=x[b+4>>2];x[e+64>>2]=x[b>>2];x[e+68>>2]=d;s:{if(!Ic(f,g,e- -64|0)){b=qc(e+156|0,7444);d=x[b+4>>2];x[e+56>>2]=x[b>>2];x[e+60>>2]=d;if(!Ic(f,g,e+56|0)){break s}}v[a+60|0]=c;break h}b=qc(e+148|0,6989);d=x[b+4>>2];x[e+48>>2]=x[b>>2];x[e+52>>2]=d;t:{if(!Ic(f,g,e+48|0)){b=qc(e+140|0,6970);d=x[b+4>>2];x[e+40>>2]=x[b>>2];x[e+44>>2]=d;if(!Ic(f,g,e+40|0)){break t}}v[a+61|0]=c;break h}b=qc(e+132|0,7073);d=x[b+4>>2];x[e+32>>2]=x[b>>2];x[e+36>>2]=d;if(Ic(f,g,e+32|0)){v[a+62|0]=c;break h}b=qc(e+124|0,6064);d=x[b+4>>2];x[e+24>>2]=x[b>>2];x[e+28>>2]=d;if(Ic(f,g,e+24|0)){v[a+63|0]=c;break h}b=qc(e+116|0,7511);d=x[b+4>>2];x[e+16>>2]=x[b>>2];x[e+20>>2]=d;if(Ic(f,g,e+16|0)){v[a+64|0]=c;break h}b=qc(e+108|0,13525);d=x[b+4>>2];x[e+8>>2]=x[b>>2];x[e+12>>2]=d;if(!Ic(f,g,e+8|0)){break h}b=x[a+24>>2];d=b+24664|0;f=x[d+4>>2];x[e+96>>2]=x[d>>2];x[e+100>>2]=f;d=b+24656|0;f=x[d+4>>2];x[e+88>>2]=x[d>>2];x[e+92>>2]=f;d=x[b+24652>>2];x[e+80>>2]=x[b+24648>>2];x[e+84>>2]=d;if(c){a=XM(x[a+56>>2])}else{a=0}x[e+100>>2]=a;a=e+80|0;if(!Az(a,b+24648|0)){break h}LA(b,a)}fb=e+240|0;return}b=N()|0;break d}b=N()|0;f=1}tb(e+216|0);if(!f){break c}}ic(g)}Q(b|0)}p()}function Ata(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=fb-128|0;fb=f;yc(b);a:{d=f- -64|0;if(!xr(b,d)){break a}if(!l$(d)){break a}if(!Mb(x[b>>2],x[b+8>>2],k$(d))){break a}j=1;if((c|0)==64){break a}Dd(a,1);x[a+480208>>2]=x[a+480208>>2]|16777216;w[a+480188>>1]=y[f+109|0];w[a+480190>>1]=y[f+110|0];n=a,o=Bc((((y[f+113|0]<<8|48)&65328)>>>0)/100|0,0),x[n+480200>>2]=o;e=f+52|0;qi(e,3,f+69|0);d=f+16|0;Cc(d,e);zb(a+1298308|0,d);tb(d);qi(e,3,f+89|0);Dr(d,4,e);zb(a+1298320|0,d);tb(d);d=0;while(1)if(z[a+480188>>1]<=d>>>0){d=a+484376|0;ak(Xb(x[a+484360>>2],y[d|0]),b,y[f+111|0],65535,65535);w[f+50>>1]=0;d=Xb(x[a+484360>>2],y[d|0]);n=f,o=wb(x[d>>2]),x[n+16>>2]=o;d=wb(x[d+4>>2]);while(1){e=x[f+16>>2];if(Ib(e,d)){w[f+52>>1]=z[e>>1];n=f,o=z[qe(f+52|0,f+50|0)>>1],w[n+50>>1]=o;ge(f+16|0);continue}else{d=z[f+50>>1]+1|0;w[f+50>>1]=d;j=Mb(x[b>>2],x[b+8>>2],D(D(z[a+480188>>1],d&65535),264)+(z[a+480190>>1]<<5)|0);if(!j){break a}d=0;while(1){e=z[a+480188>>1];if(e>>>0<=d>>>0){Vb(b,D(e,z[f+50>>1]-1|0)<<3);d=1;while(1){i=d&65535;if(i>>>0>z[a+480190>>1]){k=a+484344|0;Tf(k,z[f+50>>1]);l=c&1;h=0;while(1){b:{c:{if(z[f+50>>1]<=h>>>0){if(!(c&2)){break c}d=1;while(1){c=d&65535;if(c>>>0>A[a+480228>>2]){break c}c=D(c,104)+a|0;dg(Zc(f+16|0,w[c+484414>>1]&1?16:8,1,0,0),c+484380|0,b);d=d+1|0;continue}}d:{if(l){if(Pg(k,h&65535,64)){break d}}Vb(b,z[a+480188>>1]<<8);break b}d=Wb(x[k>>2],h);n=f,o=wb(x[d>>2]),x[n+16>>2]=o;m=wb(x[d+4>>2]);while(1){d=x[f+16>>2];if(!Ib(d,m)){break b}e=f+52|0;mm(e,b);e=y[xb(e,1)|0];if((e-1&255)>>>0<=167){v[d|0]=((e&254)>>>1|0)+36}g=f+52|0;n=d,o=y[xb(g,0)|0],v[n+1|0]=o;e=y[xb(g,3)|0];v[d+5|0]=e;e:{f:{i=xb(g,2);g=y[i|0];if((g|0)!=19){if((g|0)!=8){break f}g:{switch(e>>>4|0){case 0:v[d+3|0]=19;v[d+5|0]=e|128;break e;case 1:v[d+3|0]=11;v[d+5|0]=e<<4;break e;case 2:v[d+3|0]=19;v[d+5|0]=e|160;break e;case 3:case 4:break g;default:break e}}v[d+3|0]=19;v[d+5|0]=e-32;break e}v[d+3|0]=9;i=e<<1&254;g=i+128|0;h:{if(e>>>0<=64){break h}g=384-i|0;if(e<<24>>24>=0){break h}g=128-i|0;if(e>>>0<=191){break h}g=i-128|0}n=d,o=ti(g),v[n+5|0]=o;break e}if((g&240)==32){v[d+3|0]=10;e=y[i|0];v[d+2|0]=1;v[d+4|0]=(e<<2&60)+4;break e}if((g-17&255)>>>0>1&g>>>0>=16){break e}Cf(d,g&15,e)}tg(f+16|0);continue}}b=f+16|0;c=uc(b,9526);zb(a+1298344|0,c);tb(c);c=uc(b,10157);zb(a+1298356|0,c);tb(c);n=a+1298404|0,o=x[Fc(b,4)>>2],x[n>>2]=o;break a}h=h+1|0;continue}}else{e=f+16|0;wr(b,e);g=fb-16|0;fb=g;v[g+15|0]=64;h=(D(i,104)+a|0)+484380|0;n=h,o=y[Qb(e+26|0,g+15|0)|0]<<2,w[n+30>>1]=o;v[h+37|0]=y[e+25|0]<<4;x[h>>2]=y[e+23|0]|y[e+24|0]<<8;x[h+4>>2]=y[e+27|0]|y[e+28|0]<<8;x[h+8>>2]=(y[e+29|0]|y[e+30|0]<<8)+(y[e+27|0]|y[e+28|0]<<8);w[h+34>>1]=z[h+34>>1]&65532|((y[e+29|0]|y[e+30|0]<<8)>>>0>2)<<1|y[e+22|0]==16;fb=g+16|0;h=f+4|0;Sk(h,3,e);e=f+52|0;Cc(e,h);Ac(((i<<5)+a|0)+946304|0,e);d=d+1|0;tb(e);continue}}}else{e=f+4|0;i$(e,b);h=f+52|0;uF(h,e);e=f+16|0;Cc(e,h);im(((d<<5)+a|0)+480289|0,e);d=d+1|0;tb(e);continue}}}}}else{e=(d<<5)+a|0;Ue(e+480280|0);n=e+480284|0,o=D(Zd(b)&15,17),w[n>>1]=o;d=d+1|0;continue}}fb=f+128|0;return j|0}function oH(){var a=0,b=0,c=0,d=0;if(y[499800]){return x[124949]}b=xd(501432,1);x[b>>2]=95212;c=KJ(b+8|0);x[31609]=0;d=P(36,b+152|0,14337)|0;a=x[31609];x[31609]=0;a:{b:{c:{if((a|0)!=1){Nc(c);EJ(501104,1);x[31609]=0;W(1294,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}CJ(501112,1);x[31609]=0;W(1295,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}BJ(501120,1);x[31609]=0;W(1296,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}AJ(501136,1);x[31609]=0;W(1297,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xd(501144,1);x[125286]=97156;x[31609]=0;W(1298,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}x[31609]=0;X(1299);a=x[31609];x[31609]=0;if((a|0)==1){break c}x[31609]=0;W(1300,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xd(501168,1);x[125292]=97304;x[31609]=0;W(1301,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xd(501176,1);x[125294]=97536;x[31609]=0;W(1302,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xd(501184,1);x[125296]=97420;x[31609]=0;W(1303,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xd(501192,1);x[125298]=97652;x[31609]=0;W(1304,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}zJ(501200,1);x[31609]=0;W(1305,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}yJ(501224,1);x[31609]=0;W(1306,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xd(501256,1);x[125314]=98372;x[31609]=0;W(1307,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xd(501264,1);x[125316]=98616;x[31609]=0;W(1308,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xd(501272,1);x[125318]=98828;x[31609]=0;W(1309,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xd(501280,1);x[125320]=99060;x[31609]=0;W(1310,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xJ(501288,1);x[31609]=0;W(1311,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}wJ(501296,1);x[31609]=0;W(1312,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}vJ(501304,1);x[31609]=0;W(1313,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}uJ(501312,1);x[31609]=0;W(1314,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xd(501320,1);x[125330]=101752;x[31609]=0;W(1315,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xd(501328,1);x[125332]=101916;x[31609]=0;W(1316,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xd(501336,1);x[125334]=102080;x[31609]=0;W(1317,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}xd(501344,1);x[125336]=102244;x[31609]=0;W(1318,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}tJ(501352,1);x[31609]=0;W(1319,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}sJ(501368,1);x[31609]=0;W(1320,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}x[31609]=0;X(1321);a=x[31609];x[31609]=0;if((a|0)==1){break c}x[31609]=0;W(1322,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}x[31609]=0;X(1323);a=x[31609];x[31609]=0;if((a|0)==1){break c}x[31609]=0;W(1324,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}rJ(501416,1);x[31609]=0;W(1325,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}qJ(501424,1);x[31609]=0;W(1326,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}break a}b=N()|0;break b}b=N()|0;tb(d)}oy(c);Q(b|0);p()}x[124948]=501432;v[499800]=1;x[124949]=499792;return 499792}function uS(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,z=0,A=0,B=0,D=0;if(b){j=a+327720|0;c=fb-352|0;fb=c;m=c+340|0;zU(m,8);x[31609]=0;n=c+328|0;la(795,n|0,9);k=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{if((k|0)!=1){x[31609]=0;k=P(796,c+312|0,14)|0;f=x[31609];x[31609]=0;if((f|0)==1){break l}x[31609]=0;O(797,m|0,k|0);f=x[31609];x[31609]=0;if((f|0)==1){break k}x[31609]=0;O(797,n|0,k|0);f=x[31609];x[31609]=0;if((f|0)==1){break k}g=c+240|0;yU(g,4900);l=c+168|0;yU(l,32e3);s=c+96|0;qU(s,8377175819504598e-21,16754351639009197e-21,8377175819504598e-21,-1.991112714669597,.9911462233728751);x[31609]=0;i=P(798,c+72|0,m|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break j}f=c+84|0;av(f,g,i);Ce(i);x[31609]=0;g=P(798,c+48|0,n|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break i}i=c+60|0;av(i,l,g);Ce(g);x[31609]=0;g=P(798,c+24|0,f|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break h}l=c+36|0;av(l,s,g);Ce(g);x[31609]=0;g=P(798,c|0,i|0)|0;o=x[31609];x[31609]=0;if((o|0)==1){break g}o=c+12|0;av(o,s,g);Ce(g);Nq(f);Nq(l);Nq(i);Nq(o);Nq(n);Mq(x[c+84>>2],x[c+88>>2],Mo(j,0));Mq(x[c+36>>2],x[c+40>>2],Mo(j,1));Mq(x[c+60>>2],x[c+64>>2],Mo(j,2));Mq(x[c+12>>2],x[c+16>>2],Mo(j,3));Mq(x[c+328>>2],x[c+332>>2],Mo(j,4));Ce(o);Ce(l);Ce(i);Ce(f);ln(k);Ce(n);Ce(m);fb=c+352|0;break a}a=N()|0;break b}a=N()|0;break c}a=N()|0;break d}a=N()|0;break d}a=N()|0;break e}a=N()|0;break f}a=N()|0;Ce(c+36|0)}Ce(c+60|0)}Ce(c+84|0)}ln(k)}Ce(c+328|0)}Ce(c+340|0);Q(a|0);p()}BA(a+131112|0,9.6377,.97);BA(a+196648|0,8.5,.5);BA(a+262184|0,7,.425)}c=a+368680|0;if(!(A=0,B=ER(c,a),D=b,D?A:B)){k=a+24|0;v=C[a+8>>3];m=y[a+16|0];j=fb+-64|0;fb=j;m:while(1){if((r|0)!=8193){z=+(r-4096|0)*.0001220703125;b=0;t=0;while(1)if((b|0)==8){d=1/t;f=r<<3;b=0;while(1)if((b|0)==8){r=r+1|0;continue m}else{i=k+((b|f)<<1)|0;h=J(C[j+(b<<3)>>3]*32768*d+.5);h=h<-32768?-32768:h>32768?32768:h;n:{if(F(h)<2147483648){g=~~h;break n}g=-2147483648}w[i>>1]=g;b=b+1|0;continue}}else{h=v;e=1;d=+(b|0)-z;u=d+-3.5;if(!(F(u)<1e-8)){o:{p:{switch(m|0){case 0:e=hf(d*.8975979010256552)*-.5+.5;break o;case 1:e=hf(d*.8975979010256552)*-.46+.54;break o;case 2:e=hf(d*1.7951958020513104)*.08+(hf(d*.8975979010256552)*-.5+.42);break o;case 3:e=hf(d*1.7951958020513104)*.05677+(hf(d*.8975979010256552)*-.49364+.44959);break o;case 4:e=hf(d*1.7951958020513104)*.07922+(hf(d*.8975979010256552)*-.49755+.42323);break o;case 5:e=hf(d*1.7951958020513104);q=hf(d*.8975979010256552);e=hf(d*2.6927937030769655)*-.01168+(e*.14128+(q*-.48829+.35875));break o;case 6:e=hf(d*1.7951958020513104);q=hf(d*.8975979010256552);e=hf(d*2.6927937030769655)*-.00183+(e*.09392+(q*-.49703+.40217));break o;case 7:break p;default:break o}}e=hf(d*1.7951958020513104);q=hf(d*.8975979010256552);e=hf(d*2.6927937030769655)*-.00122+(e*.09831+(q*-.49804+.40243))}d=u*3.141592653589793;h=Ri(d*h)/d}h=e*h;C[j+(b<<3)>>3]=h;t=t+h;b=b+1|0;continue}}break}fb=j- -64|0;b=x[a+20>>2];x[c+16>>2]=x[a+16>>2];x[c+20>>2]=b;b=x[a+12>>2];x[c+8>>2]=x[a+8>>2];x[c+12>>2]=b;b=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=b}}function yra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=fb-192|0;fb=g;l=g+80|0;ae(l,b);i=x[g+88>>2];m=x[g+92>>2];e=fb-32|0;fb=e;x[e+28>>2]=0;Hk(b,e+28|0);a:{b:{c:{if(x[e+28>>2]!=(En(14184)|0)){break c}x[e+24>>2]=0;h=fb-32|0;fb=h;x[h+28>>2]=0;cy(h+8|0,h+28|0);j=h+20|0;Om(j,b,x[h+8>>2],x[h+12>>2]);Mm(j,x[h+28>>2]);x[e+24>>2]=x[h+20>>2];fb=h+32|0;h=-1;f=x[e+24>>2];if(f-3>>>0<4294967294){break c}d:{e:{f:{if(f>>>0<=1){f=Fb(e+12|0);x[31609]=0;j=U(495,b|0,f|0,256)|0;k=x[31609];x[31609]=0;if((k|0)==1){break b}if(!j){break e}x[31609]=0;S(496,e|0,d|0,f|0);j=x[31609];x[31609]=0;if((j|0)!=1){break f}break b}f=Fb(e+12|0);x[31609]=0;j=P(498,b|0,f|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break b}if(!j){break d}x[31609]=0;S(496,e|0,d|0,f|0);j=x[31609];x[31609]=0;if((j|0)==1){break b}}zb(c,e);tb(e);tb(f);ng(b,e);f=0;x[e+12>>2]=0;Hk(b,e+12|0);j=x[e+12>>2];if(j>>>0>50){break c}g:{while(1){if((f|0)==(j|0)){break g}f=f+1|0;if(TQ(a,b,d)){continue}break}break c}x[e+12>>2]=0;Hk(b,e+12|0);h=x[e+12>>2]==(En(14222)|0)?1:-1;break c}tb(f);break c}tb(f)}fb=e+32|0;break a}a=N()|0;tb(f);Q(a|0);p()}h:{if(h){break h}ig(x[x[b>>2]-12>>2]+b|0,0);b=Lm(l,Di(b,i,m,0));x[31609]=0;h=P(461,g+68|0,14333)|0;i=x[31609];x[31609]=0;i:{if((i|0)!=1){x[31609]=0;x[g+48>>2]=3;x[g+52>>2]=0;i=g+48|0;S(462,b|0,h|0,i|0);e=x[31609];x[31609]=0;if((e|0)!=1){Eb(h);v[g+67|0]=0;x[31609]=0;h=P(461,i|0,14778)|0;i=x[31609];x[31609]=0;if((i|0)!=1){x[31609]=0;S(463,b|0,g+67|0,h|0);i=x[31609];x[31609]=0;if((i|0)!=1){Eb(h);h=Fc(g+44|0,y[g+67|0]?0:d);x[31609]=0;d=R(476,b|0)|0;i=x[31609];x[31609]=0;if((i|0)!=1){x[31609]=0;i=R(477,b|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){x[g+40>>2]=d;j:{k:{l:{m:{while(1){if(!Ib(d,i)){a=rl(y[b|0]);Ch(b);h=a?-1:1;break h}x[31609]=0;d=P(461,g+24|0,15869)|0;e=x[31609];x[31609]=0;if((e|0)==1){break l}e=x[b+44>>2];f=x[b+40>>2];x[31609]=0;e=ba(478,f|0,e|0,x[g+40>>2],d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break k}Eb(d);n:{o:{if(e){d=x[h>>2];x[31609]=0;V(479,b|0,g+40|0,c|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){break o}break j}x[31609]=0;d=P(461,g+12|0,15566)|0;e=x[31609];x[31609]=0;p:{q:{if((e|0)!=1){e=x[b+44>>2];f=x[b+40>>2];x[31609]=0;e=ba(478,f|0,e|0,x[g+40>>2],d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break q}Eb(d);if(!e){break p}x[31609]=0;S(480,b|0,g+40|0,g+38|0);d=x[31609];x[31609]=0;if((d|0)==1){break j}break o}a=N()|0;break i}a=N()|0;Eb(d);break i}x[31609]=0;d=P(461,g|0,15467)|0;e=x[31609];x[31609]=0;if((e|0)==1){break n}e=x[b+44>>2];f=x[b+40>>2];x[31609]=0;e=ba(478,f|0,e|0,x[g+40>>2],d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break m}Eb(d);if(!e){break o}d=x[h>>2];x[31609]=0;V(481,b|0,g+40|0,a|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break j}}fA(g+40|0);d=x[g+40>>2];continue}break}a=N()|0;break i}a=N()|0;Eb(d);break i}a=N()|0;break i}a=N()|0;Eb(d);break i}a=N()|0;break i}a=N()|0;break i}a=N()|0;break i}a=N()|0;Eb(h);break i}a=N()|0;break i}a=N()|0;Eb(h);break i}a=N()|0}Ch(b);Q(a|0);p()}fb=g+192|0;return h|0}function dM(a,b,c,d,e,f){var g=0,h=0,i=0,j=0;g=fb-48|0;fb=g;a:{b:{if(Ut(c)){h=x[b+484344>>2];if(Je(h,x[b+484348>>2],c&65535)){break b}}c=a;a=Fb(g+36|0);b=Fb(g+24|0);Fi(c,a,b);tb(b);tb(a);break a}c=Wb(h,c);if(!(x[c+12>>2]>(d|0)&(d|0)>=0)){c=a;a=Fb(g+36|0);b=Fb(g+24|0);Fi(c,a,b);tb(b);tb(a);break a}if(!(z[b+480188>>1]>e>>>0&(e|0)>=0)){c=a;a=Fb(g+36|0);b=Fb(g+24|0);Fi(c,a,b);tb(b);tb(a);break a}if(f>>>0>=6){c=a;a=Fb(g+36|0);b=Fb(g+24|0);Fi(c,a,b);tb(b);tb(a);break a}c=md(x[c>>2],x[x[c+48>>2]+12>>2],d,e&65535);c:{d:{e:{f:{switch(f|0){case 0:g:{h:{i:{j:{k:{d=y[c|0];if(!Tc(d)){if(!Gl(d)){break k}}e=g+24|0;XR(e,b,d,y[c+1|0]);x[31609]=0;O(1059,g+36|0,e|0);b=x[31609];x[31609]=0;d=1;if((b|0)!=1){break j}c=N()|0;break g}d=0;x[31609]=0;P(36,g+36|0,16800)|0;b=x[31609];x[31609]=0;if((b|0)==1){break i}}b=9984;c=y[c|0];if(!Tc(c)){b=Gl(c)?10294:16800}x[31609]=0;b=P(36,g+12|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break h}c=a;a=g+36|0;Fi(c,a,b);tb(b);tb(a);if(!d){break a}tb(g+24|0);break a}c=N()|0;break d}c=N()|0;tb(g+36|0);if(!d){break d}}tb(g+24|0);break d;case 1:b=c+1|0;l:{if(y[c+1|0]){Jv(g+36|0,b);break l}Dc(g+36|0,16805)}b=y[b|0];x[31609]=0;b=P(36,g+24|0,(b?10817:16805)|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break e}c=a;a=g+36|0;Fi(c,a,b);tb(b);tb(a);break a;case 2:m:{if(Wg(y[c|0])){Dc(g+36|0,18454);break m}d=y[c+2|0];if(d){qf(g+36|0,1,uR(x[x[b+8>>2]+88>>2],d));break m}Dc(g+36|0,18454)}b=18454;if(!Wg(y[c|0])){b=y[c+2|0]?5505:18454}x[31609]=0;b=P(36,g+24|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){c=a;a=g+36|0;Fi(c,a,b);tb(b);tb(a);break a}c=N()|0;tb(g+36|0);break d;case 4:n:{if(Wg(y[c|0])){i=g,j=Dj(y[c+2|0],y[c+4|0])&255,x[i+12>>2]=j;dD(g+36|0,g+12|0);break n}if(y[c+2|0]){Jv(g+36|0,c+4|0);break n}Dc(g+36|0,16805)}b=5489;if(!Wg(y[c|0])){b=y[c+2|0]?5489:16805}x[31609]=0;b=P(36,g+24|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){c=a;a=g+36|0;Fi(c,a,b);tb(b);tb(a);break a}c=N()|0;tb(g+36|0);break d;case 3:o:{if(Wg(y[c|0])){i=g,j=(Dj(y[c+3|0],y[c+5|0])&3840)!=0,v[i+12|0]=j;b=fb-32|0;fb=b;x[b+12>>2]=-1;x[b+16>>2]=0;x[b+4>>2]=0;Fb(b+20|0);x[31609]=0;x[b+4>>2]=x[b+4>>2]&-1332|1058;x[b+8>>2]=1;d=b+4|0;S(1209,g+36|0,g+12|0,d|0);e=x[31609];x[31609]=0;p:{if((e|0)!=1){Jh(d);fb=b+32|0;break p}a=N()|0;Jh(b+4|0);Q(a|0);p()}break o}d=y[c+3|0];if(d){qf(g+36|0,1,tR(x[x[b+8>>2]+84>>2],d));break o}Dc(g+36|0,16806)}b=12391;if(!Wg(y[c|0])){b=y[c+3|0]?12391:16806}x[31609]=0;b=P(36,g+24|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){c=a;a=g+36|0;Fi(c,a,b);tb(b);tb(a);break a}c=N()|0;tb(g+36|0);break d;case 5:break f;default:break c}}q:{if(Wg(y[c|0])){i=g,j=Dj(y[c+3|0],y[c+5|0])&255,x[i+12>>2]=j;dD(g+36|0,g+12|0);break q}if(y[c+3|0]){Jv(g+36|0,c+5|0);break q}Dc(g+36|0,16805)}b=11178;if(!Wg(y[c|0])){b=y[c+3|0]?11178:16805}x[31609]=0;b=P(36,g+24|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){c=a;a=g+36|0;Fi(c,a,b);tb(b);tb(a);break a}c=N()|0;tb(g+36|0);break d}c=N()|0;tb(g+36|0)}Q(c|0);p()}c=a;a=Fb(g+36|0);b=Fb(g+24|0);Fi(c,a,b);tb(b);tb(a)}fb=g+48|0}function Pz(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=fb-160|0;fb=e;C[e+152>>3]=c;f=x[b+4>>2];a:{if(!f){g=x[b>>2];break a}g=x[b>>2];h=y[Al(g,f)|0];if((h|0)==33){d=1}else{if((h|0)!=63){break a}d=0}Nl(e+128|0,g,f,f-1|0);f=x[e+132>>2];g=x[e+128>>2];x[b>>2]=g;x[b+4>>2]=f}j=e+128|0;ie(j);h=x[e+128>>2];i=e+116|0;ie(i);h=zl(h,x[e+120>>2],b);ie(j);b:{c:{d:{e:{if(x[e+132>>2]==(h|0)){h=qc(e+144|0,22292);a=x[h+4>>2];x[e+8>>2]=x[h>>2];x[e+12>>2]=a;if(Ic(g,f,e+8|0)){b=ac(8);x[31609]=0;O(1008,i|0,e+152|0);a=x[31609];x[31609]=0;f:{g:{h:{if((a|0)!=1){x[31609]=0;S(1011,j|0,18271,i|0);a=x[31609];x[31609]=0;if((a|0)==1){break h}pc(b,j);g=0;x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}f=N()|0;tb(j);break g}f=N()|0;break f}f=N()|0;g=1}tb(e+116|0);if(!g){break c}}ic(b);break c}if(!d){break e}i=ac(8);d=x[b>>2];a=x[b+4>>2];x[31609]=0;h=bi(e+92|0,d,a);a=x[31609];x[31609]=0;i:{j:{k:{l:{m:{n:{o:{p:{q:{if((a|0)!=1){x[31609]=0;b=e+104|0;S(1011,b|0,18307,h|0);a=x[31609];x[31609]=0;if((a|0)==1){break q}x[31609]=0;d=e+116|0;O(1013,d|0,b|0);b=x[31609];x[31609]=0;a=1;if((b|0)==1){break p}x[31609]=0;b=e+80|0;O(1008,b|0,e+152|0);a=x[31609];x[31609]=0;if((a|0)==1){break o}x[31609]=0;g=e+128|0;S(1015,g|0,d|0,b|0);b=x[31609];x[31609]=0;a=1;if((b|0)==1){break n}pc(i,g);x[31609]=0;S(97,i|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}f=N()|0;tb(g);a=0;break m}f=N()|0;break i}f=N()|0;a=1;break j}f=N()|0;break k}f=N()|0;a=1;break l}f=N()|0}tb(e+80|0)}tb(e+116|0)}tb(e+104|0)}tb(h);if(!a){break c}}ic(i);break c}d=qc(e+72|0,22292);b=x[d+4>>2];x[e+40>>2]=x[d>>2];x[e+44>>2]=b;if(Ic(g,f,e+40|0)){h=ac(8);x[31609]=0;b=e+116|0;O(1008,b|0,e+152|0);a=x[31609];x[31609]=0;r:{s:{t:{if((a|0)!=1){x[31609]=0;d=e+128|0;S(1011,d|0,18271,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break t}pc(h,d);g=0;x[31609]=0;S(97,h|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}f=N()|0;tb(d);break s}f=N()|0;break r}f=N()|0;g=1}tb(e+116|0);if(!g){break c}}ic(h);break c}d=qc(e- -64|0,7759);b=x[d+4>>2];x[e+32>>2]=x[d>>2];x[e+36>>2]=b;if(Ic(g,f,e+32|0)){if(!Id(y[a+28|0])){break e}if(c<=0|c>4){d=ac(8);x[31609]=0;b=P(36,e+128|0,7854)|0;a=x[31609];x[31609]=0;if((a|0)==1){break d}pc(d,b);x[31609]=0;S(97,d|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}f=N()|0;tb(b);break c}a=x[a+24>>2];k=a,l=Ye(65536/c),x[k+480244>>2]=l;Bq(a);break e}d=qc(e+56|0,7811);b=x[d+4>>2];x[e+24>>2]=x[d>>2];x[e+28>>2]=b;if(Ic(g,f,e+24|0)){if(!Id(y[a+28|0])){break e}if(c<=0|c>4){d=ac(8);x[31609]=0;b=P(36,e+128|0,7875)|0;a=x[31609];x[31609]=0;if((a|0)!=1){pc(d,b);x[31609]=0;S(97,d|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}f=N()|0;tb(b);break c}f=N()|0;ic(d);break c}a=x[a+24>>2];k=a,l=Ye(c*65536),x[k+480240>>2]=l;Bq(a);break e}d=qc(e+48|0,7829);b=x[d+4>>2];x[e+16>>2]=x[d>>2];x[e+20>>2]=b;if(!Ic(g,f,e+16|0)){break e}k=x[a+24>>2],l=Ui(c*65536),x[k+480236>>2]=l}fb=e+160|0;return}f=N()|0;ic(d)}Q(f|0)}p()}function Ug(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=fb-112|0;fb=k;j=i&2147483647;a:{b:{m=e&2147483647;l=2147418112;n=!(b|c);if(!(d|m?m-l>>>0<2147549184:n)){q=j-l|0;if(!h&(q|0)==-2147418112?f|g:(q|0)==-2147418112&(h|0)!=0|q>>>0>2147549184){break b}}if(!(!d&(m|0)==2147418112?n:m>>>0<2147418112)){h=d;i=e|32768;f=b;g=c;break a}if(!(!h&(j|0)==2147418112?!(f|g):j>>>0<2147418112)){i=i|32768;break a}if(!(b|d|(m^2147418112|c))){j=d;d=!(b^f|d^h|(c^g|e^i^-2147483648));h=d?0:j;i=d?2147450880:e;f=d?0:b;g=d?0:c;break a}l=f|h;if(!(l|(j^2147418112|g))){break a}if(!(b|d|(c|m))){if(g|j|l){break a}f=b&f;g=c&g;h=d&h;i=e&i;break a}if(f|h|(g|j)){break b}f=b;g=c;h=d;i=e;break a}l=(j|0)==(m|0);p=l&(d|0)==(h|0)?(c|0)==(g|0)&b>>>0<f>>>0|c>>>0<g>>>0:l&d>>>0<h>>>0|j>>>0>m>>>0;n=p;m=n?f:b;q=n?g:c;l=n?i:e;s=l;n=n?h:d;r=l&65535;j=p?d:h;l=p?e:i;d=l;l=d>>>16&32767;o=s>>>16&32767;if(!o){o=!(n|r);h=o;o=h<<6;t=G(h?m:n)+32|0;h=G(h?q:r);o=o+((h|0)==32?t:h)|0;$f(k+96|0,m,q,n,r,o-15|0);n=x[k+104>>2];r=x[k+108>>2];q=x[k+100>>2];o=16-o|0;m=x[k+96>>2]}f=p?b:f;g=p?c:g;b=j;c=d&65535;if(!l){j=!(b|c);p=j;d=j?f:b;j=j<<6;p=G(p?g:c);j=j+((p|0)==32?G(d)+32|0:p)|0;$f(k+80|0,f,g,b,c,j-15|0);l=16-j|0;f=x[k+80>>2];g=x[k+84>>2];b=x[k+88>>2];c=x[k+92>>2]}d=c<<3;c=b;b=d|b>>>29;j=c<<3;c=b;b=g>>>29|j;c=c|524288;j=r<<3|n>>>29;r=n<<3|q>>>29;p=j;h=e^i;j=g<<3|f>>>29;d=f<<3;c:{if((l|0)==(o|0)){break c}e=o-l|0;if(e>>>0>127){b=0;c=0;j=0;d=1;break c}$f(k- -64|0,d,j,b,c,128-e|0);cn(k+48|0,d,j,b,c,e);b=x[k+56>>2];c=x[k+60>>2];j=x[k+52>>2];d=x[k+48>>2]|(x[k+64>>2]|x[k+72>>2]|(x[k+68>>2]|x[k+76>>2]))!=0}n=d;l=j;p=p|524288;j=q<<3|m>>>29;m=m<<3;d:{if((h|0)<0){f=0;g=0;h=0;i=0;if(!(m^n|b^r|(j^l|c^p))){break a}d=m-n|0;e=j-((m>>>0<n>>>0)+l|0)|0;f=r-b|0;g=(j|0)==(l|0)&m>>>0<n>>>0|j>>>0<l>>>0;h=f-g|0;b=(p-((b>>>0>r>>>0)+c|0)|0)-(f>>>0<g>>>0)|0;i=b;if(b>>>0>524287){break d}c=!(b|h);g=c;i=c?d:h;c=c<<6;g=G(g?e:b);c=c+((g|0)==32?G(i)+32|0:g)|0;f=b;b=c-12|0;$f(k+32|0,d,e,h,f,b);o=o-b|0;h=x[k+40>>2];i=x[k+44>>2];d=x[k+32>>2];e=x[k+36>>2];break d}j=j+l|0;d=m+n|0;e=d>>>0<m>>>0?j+1|0:j;f=(l|0)==(e|0)&d>>>0<n>>>0|e>>>0<l>>>0;j=c+p|0;b=b+r|0;j=b>>>0<r>>>0?j+1|0:j;h=b+f|0;i=h>>>0<b>>>0?j+1|0:j;if(!(i&1048576)){break d}d=n&1|((e&1)<<31|d>>>1);e=h<<31|e>>>1;o=o+1|0;h=(i&1)<<31|h>>>1;i=i>>>1|0}c=0;b=s&-2147483648;q=b;if((o|0)>=32767){h=c;i=b|2147418112;f=0;g=0;break a}l=0;e:{if((o|0)>0){l=o;break e}$f(k+16|0,d,e,h,i,o+127|0);cn(k,d,e,h,i,1-o|0);d=x[k>>2]|(x[k+16>>2]|x[k+24>>2]|(x[k+20>>2]|x[k+28>>2]))!=0;e=x[k+4>>2];h=x[k+8>>2];i=x[k+12>>2]}m=d&7;d=(e&7)<<29|d>>>3;f=(m>>>0>4)+d|0;b=h<<29|e>>>3;g=d>>>0>f>>>0?b+1|0:b;d=(b|0)==(g|0)&d>>>0>f>>>0|b>>>0>g>>>0;b=c|((i&7)<<29|h>>>3);h=d+b|0;i=q|(i>>>3&65535|l<<16);i=b>>>0>h>>>0?i+1|0:i;f:{if((m|0)==4){b=0;j=g+b|0;d=f;c=f&1;f=f+c|0;g=d>>>0>f>>>0?j+1|0:j;b=(b|0)==(g|0)&c>>>0>f>>>0|b>>>0>g>>>0;h=b+h|0;i=b>>>0>h>>>0?i+1|0:i;break f}if(!m){break a}}}x[a>>2]=f;x[a+4>>2]=g;x[a+8>>2]=h;x[a+12>>2]=i;fb=k+112|0}function Sta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=fb-720|0;fb=e;yc(b);f=fb-16|0;fb=f;g=e+110|0;S$(f+8|0,g);h=x[f+12>>2];lc(f,x[b>>2],x[b+8>>2],x[f+8>>2],x[f+12>>2]);i=x[f+4>>2];if((i|0)==(h|0)){Vb(b,x[f+12>>2])}fb=f+16|0;f=(h|0)==(i|0);if(!f){R$(g)}a:{b:{c:{d:{if(!f){break d}if(!T$(g)){break d}d=1;if((c|0)==64){break d}Dd(a,67108864);eg(a);d=y[e+135|0];w[a+480190>>1]=31;w[a+480188>>1]=d;x[a+480228>>2]=256/(d>>>0);d=uc(e,8179);zb(a+1298344|0,d);tb(d);d=uc(e,10820);zb(a+1298356|0,d);tb(d);f=e+84|0;gg(f,4174);g=y[e+134|0];x[e+64>>2]=g>>>4;d=0;x[31609]=0;x[e+104>>2]=g&15;V(307,e|0,f|0,e- -64|0,e+104|0);g=x[31609];x[31609]=0;if((g|0)==1){break c}zb(a+1298368|0,e);tb(e);Eb(f);n=a+1298404|0,o=x[Fc(e,28)>>2],x[n>>2]=o;ow(Xb(x[a+484360>>2],y[a+484376|0]),e+158|0,y[e+157|0]+1|0);while(1){e:{if((d|0)==31){yE(b,a+1298308|0,32);d=1;break e}f=d+1|0;h=D(f,104)+a|0;i=h+484380|0;nd(i,1);g=(e+110|0)+(d<<2)|0;n=i,o=$b(y[g+176|0]|y[g+177|0]<<8|(y[g+178|0]<<16|y[g+179|0]<<24)),x[n>>2]=o;k=$b(y[g+300|0]|y[g+301|0]<<8|(y[g+302|0]<<16|y[g+303|0]<<24));x[h+484384>>2]=k;g=$b(y[g+424|0]|y[g+425|0]<<8|(y[g+426|0]<<16|y[g+427|0]<<24));x[h+484388>>2]=g+k;if(g){g=h+484414|0;w[g>>1]=z[g>>1]|2}Vk(i);d=(e+110|0)+d|0;v[e|0]=y[d+548|0];v[e+84|0]=64;n=h+484410|0,o=y[Qb(e,e+84|0)|0]<<2,w[n>>1]=o;v[h+484417|0]=y[d+579|0]<<4;d=f;continue}break}while(1){if((d|0)!=32){Q$(b,((d<<5)+a|0)+946304|0,30);d=d+1|0;continue}break}k=c&1;if(k){Tf(a+484344|0,y[e+156|0]+1|0)}i=a+484344|0;g=0;f:{while(1){if(y[e+156|0]<g>>>0){d=1;if(!(c&2)){break d}c=Zc(e,8,1,1,0);break f}h=_h(e+84|0);g:{h:{if(y[e+136|0]){x[31609]=0;f=R(273,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break g}x[31609]=0;d=e- -64|0;S(185,d|0,b|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break g}break h}f=z[a+480188>>1];x[31609]=0;d=e- -64|0;S(185,d|0,b|0,f<<8);f=x[31609];x[31609]=0;if((f|0)==1){break b}}f=hc(e,d);kd(h,f);ub(f);ub(d);i:{if(!k){break i}x[31609]=0;d=U(196,i|0,g&65535,64)|0;f=x[31609];x[31609]=0;if((f|0)==1){break b}if(!d){break i}f=0;if(y[e+136|0]){x[31609]=0;O(308,h|0,e|0);d=x[31609];x[31609]=0;if((d|0)==1){break b}j:while(1){if((f|0)==64){break i}d=Wb(x[i>>2],g);af(e- -64|0,x[d>>2],x[x[d+48>>2]+12>>2],f);n=e,o=wb(x[e+64>>2]),x[n+104>>2]=o;l=e+f|0;d=128;j=nw(x[e+64>>2],x[e+68>>2]);while(1){m=x[e+104>>2];if(!Ib(m,j)){f=f+1|0;continue j}k:{if(!(y[l|0]&d)){break k}x[31609]=0;O(309,h|0,m|0);m=x[31609];x[31609]=0;if((m|0)!=1){break k}break b}d=d>>>1|0;tg(e+104|0);continue}}}l:while(1){d=0;l=f&65535;if(l>>>0>=z[a+480188>>1]){break i}while(1){if((d|0)==64){f=f+1|0;continue l}j=Wb(x[i>>2],g);j=md(x[j>>2],x[x[j+48>>2]+12>>2],d,l);x[31609]=0;O(309,h|0,j|0);j=x[31609];x[31609]=0;if((j|0)!=1){d=d+1|0;continue}break}break}break b}ub(h);g=g+1|0;continue}break}break b}while(1){if((d|0)!=32){dg(c,(D(d,104)+a|0)+484380|0,b);d=d+1|0;continue}break}d=1}fb=e+720|0;return d|0}d=N()|0;Eb(e+84|0);break a}d=N()|0;ub(h)}Q(d|0);p()}function Lra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=fb-368|0;fb=e;g=fb-32|0;fb=g;d=g+12|0;wD(d,b);Nn(g+4|0,d);x[31609]=0;f=e+216|0;S(475,f|0,x[g+4>>2],x[g+8>>2]);b=x[31609];x[31609]=0;a:{if((b|0)!=1){Kc(d);fb=g+32|0;break a}a=N()|0;Kc(g+12|0);Q(a|0);p()}x[31609]=0;b=e+104|0;S(457,b|0,x[e+216>>2],x[e+220>>2]);g=x[31609];x[31609]=0;b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{if((g|0)!=1){x[31609]=0;g=P(103,e+228|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break z}tb(b);ec(f);if(c>>>0<2189){break g}b=Lm(b,g);x[31609]=0;c=P(461,f|0,10140)|0;d=x[31609];x[31609]=0;if((d|0)==1){break x}x[31609]=0;x[e+88>>2]=20054022;x[e+92>>2]=0;d=e+88|0;S(462,b|0,c|0,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break w}Eb(c);v[e+103|0]=0;x[31609]=0;c=P(461,d|0,11063)|0;d=x[31609];x[31609]=0;if((d|0)==1){break v}x[31609]=0;S(463,b|0,e+103|0,c|0);d=x[31609];x[31609]=0;if((d|0)==1){break u}Eb(c);d=Fc(e+84|0,y[e+103|0]?0:x[a+1298404>>2]);f=x[a+4>>2];x[31609]=0;c=P(461,e+72|0,15869)|0;h=x[31609];x[31609]=0;if((h|0)==1){break i}h=x[d>>2];x[31609]=0;V(464,b|0,f|0,c|0,h|0);f=x[31609];x[31609]=0;if((f|0)==1){break t}Eb(c);x[31609]=0;c=P(461,e+60|0,15566)|0;f=x[31609];x[31609]=0;if((f|0)==1){break s}d=x[d>>2];x[31609]=0;V(465,b|0,a|0,c|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break r}Eb(c);x[31609]=0;c=P(461,e+48|0,15467)|0;d=x[31609];x[31609]=0;if((d|0)==1){break q}x[31609]=0;d=a+484360|0;S(466,b|0,d|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break p}Eb(c);x[31609]=0;c=P(461,e+36|0,25046)|0;f=x[31609];x[31609]=0;if((f|0)==1){break o}x[31609]=0;S(467,b|0,a+484344|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break n}Eb(c);f=x[a+1298404>>2];x[31609]=0;c=P(461,e+24|0,25052)|0;h=x[31609];x[31609]=0;if((h|0)==1){break m}x[31609]=0;V(468,b|0,d|0,c|0,f|0);d=x[31609];x[31609]=0;if((d|0)==1){break l}Eb(c);if(rl(y[b|0])){x[31609]=0;c=P(1,e+12|0,16343)|0;d=x[31609];x[31609]=0;if((d|0)==1){break k}a=x[a+1298472>>2];x[31609]=0;S(385,a|0,1,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break j}tb(c)}Ch(b);break f}a=N()|0;break y}a=N()|0;tb(e+104|0)}ec(e+216|0);break b}a=N()|0;break h}a=N()|0;Eb(c);break h}a=N()|0;break h}a=N()|0;Eb(c);break h}a=N()|0;Eb(c);break h}a=N()|0;break h}a=N()|0;Eb(c);break h}a=N()|0;break h}a=N()|0;Eb(c);break h}a=N()|0;break h}a=N()|0;Eb(c);break h}a=N()|0;break h}a=N()|0;Eb(c);break h}a=N()|0;break h}a=N()|0;tb(c);break h}a=N()|0}Ch(b);break c}b=Fb(e+104|0);d=x[a+1298404>>2];f=x[a+4>>2];x[31609]=0;d=ba(469,f|0,g|0,b|0,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}A:{if((d|0)!=1){x[31609]=0;c=P(1,e+216|0,16649)|0;d=x[31609];x[31609]=0;B:{if((d|0)!=1){a=x[a+1298472>>2];x[31609]=0;S(385,a|0,1,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break B}tb(c);break A}a=N()|0;break d}a=N()|0;tb(c);break d}d=x[a+1298404>>2];x[31609]=0;V(470,g|0,a|0,d|0,c>>>0<2188|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}}tb(b)}Gf(g);fb=e+368|0;return}a=N()|0}tb(b)}Gf(g)}Q(a|0);p()}function Db(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{if(!a){break a}d=a-8|0;b=x[a-4>>2];a=b&-8;f=d+a|0;b:{if(b&1){break b}if(!(b&2)){break a}b=x[d>>2];d=d-b|0;if(d>>>0<A[31489]){break a}a=a+b|0;c:{d:{if(x[31490]!=(d|0)){if(b>>>0<=255){e=b>>>3|0;b=x[d+12>>2];c=x[d+8>>2];if((b|0)==(c|0)){i=125940,j=x[31485]&Lua(-2,e),x[i>>2]=j;break b}x[c+12>>2]=b;x[b+8>>2]=c;break b}h=x[d+24>>2];b=x[d+12>>2];if((d|0)!=(b|0)){c=x[d+8>>2];x[c+12>>2]=b;x[b+8>>2]=c;break c}e=d+20|0;c=x[e>>2];if(!c){c=x[d+16>>2];if(!c){break d}e=d+16|0}while(1){g=e;b=c;e=b+20|0;c=x[e>>2];if(c){continue}e=b+16|0;c=x[b+16>>2];if(c){continue}break}x[g>>2]=0;break c}b=x[f+4>>2];if((b&3)!=3){break b}x[31487]=a;x[f+4>>2]=b&-2;x[d+4>>2]=a|1;x[f>>2]=a;return}b=0}if(!h){break b}c=x[d+28>>2];e=(c<<2)+126244|0;e:{if(x[e>>2]==(d|0)){x[e>>2]=b;if(b){break e}i=125944,j=x[31486]&Lua(-2,c),x[i>>2]=j;break b}x[h+(x[h+16>>2]==(d|0)?16:20)>>2]=b;if(!b){break b}}x[b+24>>2]=h;c=x[d+16>>2];if(c){x[b+16>>2]=c;x[c+24>>2]=b}c=x[d+20>>2];if(!c){break b}x[b+20>>2]=c;x[c+24>>2]=b}if(d>>>0>=f>>>0){break a}b=x[f+4>>2];if(!(b&1)){break a}f:{g:{h:{i:{if(!(b&2)){if(x[31491]==(f|0)){x[31491]=d;a=x[31488]+a|0;x[31488]=a;x[d+4>>2]=a|1;if(x[31490]!=(d|0)){break a}x[31487]=0;x[31490]=0;return}if(x[31490]==(f|0)){x[31490]=d;a=x[31487]+a|0;x[31487]=a;x[d+4>>2]=a|1;x[a+d>>2]=a;return}a=(b&-8)+a|0;if(b>>>0<=255){e=b>>>3|0;b=x[f+12>>2];c=x[f+8>>2];if((b|0)==(c|0)){i=125940,j=x[31485]&Lua(-2,e),x[i>>2]=j;break g}x[c+12>>2]=b;x[b+8>>2]=c;break g}h=x[f+24>>2];b=x[f+12>>2];if((f|0)!=(b|0)){c=x[f+8>>2];x[c+12>>2]=b;x[b+8>>2]=c;break h}e=f+20|0;c=x[e>>2];if(!c){c=x[f+16>>2];if(!c){break i}e=f+16|0}while(1){g=e;b=c;e=b+20|0;c=x[e>>2];if(c){continue}e=b+16|0;c=x[b+16>>2];if(c){continue}break}x[g>>2]=0;break h}x[f+4>>2]=b&-2;x[d+4>>2]=a|1;x[a+d>>2]=a;break f}b=0}if(!h){break g}c=x[f+28>>2];e=(c<<2)+126244|0;j:{if(x[e>>2]==(f|0)){x[e>>2]=b;if(b){break j}i=125944,j=x[31486]&Lua(-2,c),x[i>>2]=j;break g}x[h+(x[h+16>>2]==(f|0)?16:20)>>2]=b;if(!b){break g}}x[b+24>>2]=h;c=x[f+16>>2];if(c){x[b+16>>2]=c;x[c+24>>2]=b}c=x[f+20>>2];if(!c){break g}x[b+20>>2]=c;x[c+24>>2]=b}x[d+4>>2]=a|1;x[a+d>>2]=a;if(x[31490]!=(d|0)){break f}x[31487]=a;return}if(a>>>0<=255){b=(a&-8)+125980|0;c=x[31485];a=1<<(a>>>3);k:{if(!(c&a)){x[31485]=a|c;a=b;break k}a=x[b+8>>2]}x[b+8>>2]=d;x[a+12>>2]=d;x[d+12>>2]=b;x[d+8>>2]=a;return}c=31;if(a>>>0<=16777215){b=G(a>>>8|0);c=((a>>>38-b&1)-(b<<1)|0)+62|0}x[d+28>>2]=c;x[d+16>>2]=0;x[d+20>>2]=0;b=(c<<2)+126244|0;l:{m:{e=x[31486];g=1<<c;n:{if(!(e&g)){x[31486]=e|g;x[b>>2]=d;x[d+24>>2]=b;break n}c=a<<((c|0)!=31?25-(c>>>1|0)|0:0);b=x[b>>2];while(1){e=b;if((x[b+4>>2]&-8)==(a|0)){break m}g=c>>>29|0;c=c<<1;g=b+(g&4)|0;b=x[g+16>>2];if(b){continue}break}x[g+16>>2]=d;x[d+24>>2]=e}x[d+12>>2]=d;x[d+8>>2]=d;break l}a=x[e+8>>2];x[a+12>>2]=d;x[e+8>>2]=d;x[d+24>>2]=0;x[d+12>>2]=e;x[d+8>>2]=a}a=x[31493]-1|0;x[31493]=a?a:-1}}function UR(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=E(0),j=0,k=0,l=E(0),m=E(0),n=0,o=0,p=0,q=0,r=0,s=0,t=E(0),u=0;if(b){MA(a);c=a+24596|0;x[c>>2]=0;x[c+4>>2]=0;x[a+24588>>2]=0;x[a+24592>>2]=0;ZR(a)}TR(a+24648|0);o=x[a+24620>>2];f=fb-144|0;fb=f;d=!b;e=a+397456|0;c=x[e+4>>2];if(c>>>0>=29){x[e+4>>2]=0;c=0}g=D(c,44)+45920|0;if(!((g|0)==x[e+8>>2]&d)){x[e+8>>2]=g;m=E(o>>>0);c=f+12|0;d=x[g+24>>2];x[c>>2]=d;j=x[g+16>>2];x[c+4>>2]=j;x[c+8>>2]=x[g+4>>2];k=(d|0)>(j|0)?d:j;if((k|0)<=-601){h=j;j=k+600|0;x[c+4>>2]=h-j;x[c>>2]=d-j}i=E(B[g+36>>2]*E(79.30999755859375));a:{if(E(F(i))<E(2147483648)){d=~~i;break a}d=-2147483648}x[c+16>>2]=d- -8192;i=E(E(E(B[g+32>>2]*E(.0036000001709908247))+E(.15000000596046448))*E(32767));b:{if(E(F(i))<E(2147483648)){d=~~i;break b}d=-2147483648}x[c+20>>2]=(d|0)>=32512?32512:d;j=0;i=B[g+8>>2];l=B[g+20>>2];l=E((l>E(.10000000149011612)?E(.10000000149011612):l)*m);c:{if(E(F(l))<E(2147483648)){d=~~l;break c}d=-2147483648}k=(d|0)<=96?96:d;h=k-7500|0;n=k>>>0>=h>>>0?h:0;l=E(B[g+28>>2]*m);d:{if(E(F(l))<E(2147483648)){h=~~l;break d}h=-2147483648}d=n+(h+((d|0)<96?d-96|0:0)|0)|0;h=(d|0)<=128?128:d;p=h>>>0>=3800?3800:h;x[c+24>>2]=p;n=(d|0)<128?d-128|0:0;i=E(i*m);e:{if(E(F(i))<E(2147483648)){q=~~i;break e}q=-2147483648}d=h-3800|0;h=(q+n|0)+(d>>>0<=h>>>0?d:0)|0;x[c+32>>2]=h;n=k>>>0>=7500?7500:k;while(1){if((j|0)==8){i=E(h|0);l=E(Ee(E(.0010000000474974513),(h|0)<4721?E(1):E(E(4720)/i))*E(32768));f:{if(E(F(l))<E(2147483648)){d=~~l;break f}d=-2147483648}x[c+12>>2]=d;i=E(B[g+12>>2]*i);s=c,t=Ee(E(.0010000000474974513),i<=E(4720)?E(1):E(E(4720)/i)),B[s+28>>2]=t}else{d=D(j,12);k=d+c|0;w[k+42>>1]=z[d+47210>>1];w[k+36>>1]=z[d+47204>>1];w[k+40>>1]=z[d+47208>>1];w[k+38>>1]=z[d+47206>>1];x[k+44>>2]=n+((D(x[d+47200>>2],p)+50|0)/100|0);j=j+1|0;continue}break}x[e+20>>2]=x[f+44>>2];r=+m;c=LP(MP(x[f+20>>2]),r);w[e+86>>1]=c;w[e+84>>1]=c;c=z[f+28>>1]<<1;w[e+94>>1]=c;w[e+92>>1]=c;c=0;while(1){if((c|0)==8){x[e+49892>>2]=x[f+36>>2];c=x[f+16>>2];if((c|0)>-9e3){c=KP(c)}else{c=0}x[e+80>>2]=c;d=e+49948|0;c=x[f+12>>2];if((c|0)>=-8999){c=KP(c)}else{c=0}x[d>>2]=c;c=x[f+32>>2];d=e+49932|0;x[d>>2]=268464128;x[d+4>>2]=1879052288;c=c>>>0>=32512?32512:c;w[e+49906>>1]=c;w[e+49904>>1]=c;w[e+49902>>1]=c;w[e+49900>>1]=c;x[f+8>>2]=x[f+24>>2];He(f+8|0,0,32752);c=z[f+8>>1];w[e+49914>>1]=c;w[e+49910>>1]=0;w[e+49912>>1]=0;w[e+49908>>1]=c;m=B[f+40>>2];s=f,u=LP(+E(m*m),r),x[s+4>>2]=u;He(f+4|0,256,32512);c=z[f+4>>1];w[e+49922>>1]=c;w[e+49918>>1]=0;w[e+49920>>1]=0;w[e+49916>>1]=c}else{d=(c<<4)+e|0;g=(f+12|0)+D(c,12)|0;j=x[g+44>>2];x[d+100>>2]=j;x[d+104>>2]=j;w[d+108>>1]=z[g+36>>1];w[d+110>>1]=z[g+42>>1];w[d+112>>1]=z[g+40>>1];w[d+114>>1]=z[g+38>>1];c=c+1|0;continue}break}}if(b){x[e+16>>2]=0;OP(e,a+397448|0,a+397452|0)}b=D(o,5);if(b>>>0>A[e+20>>2]){x[e+20>>2]=b}fb=f+144|0;b=x[a+1298300>>2];if(Ed(b)){KU(b,x[a+24620>>2])}}function Nfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=fb-112|0;fb=e;g=x[b+4>>2];h=y[b+11|0];a:{if(Ad(g,h)){break a}f=y[yz(b)|0];if((f|0)==33){d=1}else{if((f|0)!=63){break a}d=0}f=e+100|0;zx(f,b,0,_c(g,h)-1|0);zb(b,f);tb(f)}f=e+100|0;ie(f);g=x[e+100>>2];ie(e+88|0);g=YM(g,x[e+92>>2],b);ie(f);b:{c:{d:{e:{if((g|0)==x[e+104>>2]){if(Nd(b,22292)){a=ac(8);x[31609]=0;S(1002,f|0,18271,c|0);b=x[31609];x[31609]=0;if((b|0)==1){break d}pc(a,f);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(f);break c}if(!d){break e}a=ac(8);x[31609]=0;d=e+76|0;S(1002,d|0,18307,b|0);b=x[31609];x[31609]=0;f:{g:{h:{i:{j:{if((b|0)!=1){x[31609]=0;b=e+88|0;O(1013,b|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break j}x[31609]=0;f=e+100|0;S(544,f|0,b|0,c|0);b=x[31609];x[31609]=0;d=1;if((b|0)==1){break i}pc(a,f);x[31609]=0;S(97,a|0,48428,1e3);b=x[31609];x[31609]=0;if((b|0)!=1){break b}b=N()|0;tb(f);d=0;break h}b=N()|0;break f}b=N()|0;d=1;break g}b=N()|0}tb(e+88|0)}tb(e+76|0);if(!d){break c}}ic(a);break c}k:{switch(x[g+4>>2]){case 0:fe(e+68|0,b);b=fb-176|0;fb=b;g=b+12|0;Uf(g,c);x[31609]=0;f=b+24|0;O(124,f|0,g|0);c=x[31609];x[31609]=0;l:{m:{n:{o:{p:{if((c|0)!=1){x[31609]=0;c=P(103,b+36|0,f|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break p}tb(f);tb(g);g=x[x[c>>2]-12>>2];x[31609]=0;h=ca(104)|0;i=x[31609];x[31609]=0;if((i|0)==1){break n}x[31609]=0;i=b+8|0;S(105,i|0,c+g|0,h|0);g=x[31609];x[31609]=0;if((g|0)==1){break n}_b(i);x[31609]=0;f=P(125,c|0,f|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break n}c=pk(x[(f+x[x[f>>2]-12>>2]|0)+16>>2]);g=x[b+24>>2];Gf(f);fb=b+176|0;b=(c^-1)&(g|0)!=0;break l}a=N()|0;break o}a=N()|0;tb(b+24|0)}tb(b+12|0);break m}a=N()|0;Gf(c)}Q(a|0);p()}c=x[e+72>>2];x[e>>2]=x[e+68>>2];x[e+4>>2]=c;Qz(a,e,b,d);break e;case 1:fe(e+60|0,b);b=fb-176|0;fb=b;g=b+12|0;Uf(g,c);x[31609]=0;f=b+24|0;O(124,f|0,g|0);c=x[31609];x[31609]=0;q:{r:{s:{t:{u:{if((c|0)!=1){x[31609]=0;c=P(103,b+36|0,f|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break u}tb(f);tb(g);g=x[x[c>>2]-12>>2];x[31609]=0;h=ca(104)|0;i=x[31609];x[31609]=0;if((i|0)==1){break s}x[31609]=0;i=b+8|0;S(105,i|0,c+g|0,h|0);g=x[31609];x[31609]=0;if((g|0)==1){break s}_b(i);x[31609]=0;x[b+24>>2]=0;x[b+28>>2]=0;f=P(1129,c|0,f|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break s}c=pk(x[(f+x[x[f>>2]-12>>2]|0)+16>>2]);g=x[b+24>>2];h=x[b+28>>2];Gf(f);fb=b+176|0;b=c?0:g;c=c?0:h;break q}a=N()|0;break t}a=N()|0;tb(b+24|0)}tb(b+12|0);break r}a=N()|0;Gf(c)}Q(a|0);p()}f=x[e+64>>2];x[e+8>>2]=x[e+60>>2];x[e+12>>2]=f;Oz(a,e+8|0,b,c,d);break e;case 2:fe(e+52|0,b);j=g_(c);b=x[e+56>>2];x[e+16>>2]=x[e+52>>2];x[e+20>>2]=b;Pz(a,e+16|0,j,d);break e;case 3:break k;default:break e}}fe(e+44|0,b);fe(e+32|0,c);b=x[e+48>>2];x[e+24>>2]=x[e+44>>2];x[e+28>>2]=b;Nz(a,e+24|0,x[e+32>>2],x[e+36>>2],d)}fb=e+112|0;return}b=N()|0;ic(a)}Q(b|0)}p()}function soa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,B=0,C=0,D=0;h=fb-4128|0;fb=h;i=Bb(y[a+14|0]|y[a+15|0]<<8);if(!(!i|i>>>0>20|z[b+480190>>1]<=y[a+23|0])){nd(d,32);w[d+34>>1]=1;j=h+12|0;g=j;i=a+20|0;x[g>>2]=i;x[g+4>>2]=(i+80|0)-i>>2;lW(h+4120|0,x[h+12>>2],x[h+16>>2],Bb(y[a+14|0]|y[a+15|0]<<8));f=x[h+4120>>2];i=y[yb(f,0)+3|0];x[h+12>>2]=1;g=x[bd(oi(b,i+1|0)+24|0,g)>>2];i=x[h+4124>>2];lW(j,f,i,c?i:1);C=h,D=wb(x[h+12>>2]),x[C+4108>>2]=D;r=1/+(g>>>0);i=fb-16|0;fb=i;o=x[vb(i+12|0,x[h+12>>2]+(x[h+16>>2]<<2)|0)>>2];fb=i+16|0;f=x[d>>2];q=x[h+4120>>2];l=z[b+480190>>1];while(1){g=x[h+4108>>2];if(Ib(g,o)){i=y[g+3|0];a:{if(i>>>0>=l>>>0){break a}j=v[g+1|0];if((j|0)<0){break a}g=oi(b,i+1|0);i=x[g>>2];f=Ye(r*(zi(+((j&255)-v[yb(q,0)+1|0]|0)/-12)*+(i>>>0)*+A[g+24>>2]))+f|0;x[d>>2]=f}We(h+4108|0);continue}else{b:{s=Gh(d);if(!s){break b}i=(e<<12>>>0)/1e4|0;g=x[h+4124>>2];f=fb-16|0;fb=f;k=h+4108|0;x[k>>2]=0;x[k+4>>2]=0;tc(k+8|0);Rd(f+8|0,x[vb(f+4|0,k)>>2]);c:{if(!g){break c}x[31609]=0;O(754,k|0,g|0);e=x[31609];x[31609]=0;if((e|0)!=1){x[31609]=0;_V(k,g);e=x[31609];x[31609]=0;if((e|0)!=1){break c}}a=N()|0;wv(f+8|0);Q(a|0);p()}e=f+8|0;Qd(e);wv(e);fb=f+16|0;o=x[k>>2];t=x[h+4120>>2];q=x[h+4124>>2];f=0;while(1){if((f|0)==(q|0)){i=b+24648|0}else{g=yb(t,f);e=kW(o,f);l=y[g+3|0];d:{if(l>>>0>=z[b+480190>>1]){break d}j=v[g+1|0];if((j|0)<0){break d}u=0;g=y[g+2|0];if((g+14&255)>>>0<=5){u=v[g+25182|0]}n=oi(b,l+1|0);g=x[n+24>>2];B=r*(zi(+(u<<24>>24)/96+ +((j&255)-v[yb(t,0)+1|0]|0)/12)*+(g>>>0));if(B<=0){break d}l=jW(B);x[e+8>>2]=l;j=hb;x[e+12>>2]=j;x[e+16>>2]=x[n+20>>2];g=x[n>>2];x[e+76>>2]=g;x[e+88>>2]=z[n+34>>1]&1023;e:{if(c){x[e+664>>2]=m;m=Ye(+(g>>>0)/vC(l,j))+m|0;g=i;break e}g=(i>>>0)/(Bb(y[a+14|0]|y[a+15|0]<<8)>>>0)|0}x[e+20>>2]=g;x[e+24>>2]=g}f=f+1|0;continue}break}b=0;while(1){f:{a=x[d>>2];if(a>>>0>b>>>0){Rb(h+12|0,0,4096);x[h+8>>2]=512;x[h+4>>2]=a-b;j=x[Hb(h+8|0,h+4|0)>>2];C=h,D=wb(x[k>>2]),x[C+8>>2]=D;c=wb(x[k+4>>2]);while(1){f=x[h+8>>2];if(!Ib(f,c)){break f}g:{h:{if(!x[f+16>>2]){break h}g=x[f+664>>2];if(g>>>0>=j>>>0){x[f+664>>2]=g-j;break h}e=x[f+88>>2];x[h+4>>2]=j-g;C=h,D=Ye((+A[f+76>>2]-vC(x[f>>2],x[f+4>>2]))/vC(x[f+8>>2],x[f+12>>2])),x[C>>2]=D;a=x[Hb(h+4|0,h)>>2];x[31609]=0;V(x[((e&1|(e&64?18:16))<<2)+25760>>2],f|0,i|0,(h+12|0)+(g<<3)|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break g}x[f+664>>2]=0;if(A[f+76>>2]>A[f+4>>2]){break h}x[f+16>>2]=0}x[h+8>>2]=x[h+8>>2]+872;continue}break}a=N()|0;xv(k);Q(a|0);p()}xv(k);break b}e=x[d+20>>2]+(b<<1)|0;f=h+12|0;c=fb-16|0;fb=c;x[c+12>>2]=j;xc(c+12|0,512);m=x[c+12>>2];while(1){if(m){a=rd(x[f>>2]+2048|0,12);a=(a|0)>=32767?32767:a;w[e>>1]=(a|0)<=-32768?-32768:a;f=f+8|0;e=e+2|0;m=m-1|0;continue}break}fb=c+16|0;b=b+j|0;continue}}f=(s|0)!=0}break}}fb=h+4128|0;return f|0}function EZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=fb-128|0;fb=f;i=og(f+116|0);a:{b:{c:{if(d){x[31609]=0;S(482,a|0,i|0,c|0);c=x[31609];x[31609]=0;if((c|0)!=1){break c}break b}x[31609]=0;S(483,a|0,i|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}}m=Nb(f+104|0);c=1;while(1){d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{g=c&65535;if(g>>>0<=z[b+480192>>1]){x[31609]=0;w[f+102>>1]=0;O(484,a|0,f+102|0);d=x[31609];x[31609]=0;t:{u:{v:{w:{if((d|0)!=1){h=fb-16|0;fb=h;l=z[f+102>>1];d=de(i);e=gc(i);j=fb-16|0;fb=j;while(1){if(d){k=_o(z[d+16>>1],l);e=k?e:d;d=x[(k?d+4|0:d)>>2];continue}break}d=x[vb(j+12|0,e)>>2];fb=j+16|0;x:{if(Ib(d,pg(i))){if(!_o(z[f+102>>1],z[ud(d)>>1])){break x}}d=pg(i)}d=vb(h+12|0,d);fb=h+16|0;j=((g<<2)+b|0)+900380|0;if(!x[j>>2]){break d}d=x[d>>2];if(!Zg(d,Pf(i))){break u}x[31609]=0;h=P(3,f+88|0,ud(d)+4|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break t}x[31609]=0;d=P(1,f+76|0,16816)|0;e=x[31609];x[31609]=0;if((e|0)==1){break v}e=hr(h,d);tb(d);if(e){break p}d=x[b+4>>2];x[31609]=0;d=P(485,d|0,h|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break r}x[x[j>>2]+44>>2]=d;if(!x[x[j>>2]+44>>2]){break w}break e}c=N()|0;break f}x[31609]=0;d=P(1,f- -64|0,13559)|0;e=x[31609];x[31609]=0;y:{z:{A:{if((e|0)!=1){B:{if(!hr(h,d)){x[31609]=0;e=P(1,f+52|0,13764)|0;g=x[31609];x[31609]=0;if((g|0)==1){break A}g=hr(h,e);tb(e);tb(d);if(g){break B}break s}tb(d)}x[31609]=0;d=R(486,h|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break z}x[f+36>>2]=d;d=x[b+4>>2];e=f+36|0;g=x[re(f+48|0,e)>>2];x[31609]=0;d=P(487,d|0,g|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break y}mg(e);if(d){break e}break s}c=N()|0;break g}c=N()|0;tb(d);break g}c=N()|0;break g}c=N()|0;mg(f+36|0);break g}c=N()|0;break g}d=x[j>>2];if(!d){break d}x[d+44>>2]=0;break d}c=N()|0;break f}Td(m);CZ(i);fb=f+128|0;return}d=wb(x[m>>2]);g=d;e=wb(x[m+4>>2]);while(1){C:{D:{if((d|0)!=(e|0)){if(!hr(d,h)){break D}}else{d=e}break C}d=d+12|0;continue}break}e=fb-16|0;fb=e;x[e+12>>2]=g;x[e+12>>2]=x[e+12>>2]+D((d-g|0)/12|0,12);fb=e+16|0;if(Ib(x[e+12>>2],wb(x[m+4>>2]))){break p}x[31609]=0;O(488,m|0,h|0);d=x[31609];x[31609]=0;if((d|0)!=1){break q}}c=N()|0;break g}x[31609]=0;d=P(1,f+12|0,17533)|0;e=x[31609];x[31609]=0;if((e|0)==1){break o}x[31609]=0;g=f+24|0;S(489,g|0,d|0,h|0);e=x[31609];x[31609]=0;if((e|0)==1){break n}x[31609]=0;e=P(1,f|0,16392)|0;l=x[31609];x[31609]=0;if((l|0)==1){break m}x[31609]=0;l=f+36|0;S(2,l|0,g|0,e|0);k=x[31609];x[31609]=0;if((k|0)==1){break l}k=x[b+1298472>>2];x[31609]=0;S(385,k|0,2,l|0);k=x[31609];x[31609]=0;if((k|0)==1){break k}tb(l);tb(e);tb(g);tb(d)}x[x[j>>2]+44>>2]=0;break e}c=N()|0;break g}c=N()|0;break h}c=N()|0;break i}c=N()|0;break j}c=N()|0;tb(f+36|0)}tb(e)}tb(f+24|0)}tb(d)}tb(h)}Td(m);break a}tb(h)}c=c+1|0;continue}}c=N()|0}CZ(i);Q(c|0);p()}function Iv(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=a+b|0;c=x[a+4>>2];a:{b:{if(c&1){break b}if(!(c&2)){break a}c=x[a>>2];b=c+b|0;c:{d:{e:{a=a-c|0;if((a|0)!=x[31490]){if(c>>>0<=255){d=x[a+8>>2];e=x[a+12>>2];if((d|0)!=(e|0)){break e}i=125940,j=x[31485]&Lua(-2,c>>>3|0),x[i>>2]=j;break b}h=x[a+24>>2];c=x[a+12>>2];if((c|0)!=(a|0)){d=x[a+8>>2];x[d+12>>2]=c;x[c+8>>2]=d;break c}e=a+20|0;d=x[e>>2];if(!d){d=x[a+16>>2];if(!d){break d}e=a+16|0}while(1){g=e;c=d;e=c+20|0;d=x[e>>2];if(d){continue}e=c+16|0;d=x[c+16>>2];if(d){continue}break}x[g>>2]=0;break c}c=x[f+4>>2];if((c&3)!=3){break b}x[31487]=b;x[f+4>>2]=c&-2;x[a+4>>2]=b|1;x[f>>2]=b;return}x[d+12>>2]=e;x[e+8>>2]=d;break b}c=0}if(!h){break b}d=x[a+28>>2];e=(d<<2)+126244|0;f:{if(x[e>>2]==(a|0)){x[e>>2]=c;if(c){break f}i=125944,j=x[31486]&Lua(-2,d),x[i>>2]=j;break b}x[h+(x[h+16>>2]==(a|0)?16:20)>>2]=c;if(!c){break b}}x[c+24>>2]=h;d=x[a+16>>2];if(d){x[c+16>>2]=d;x[d+24>>2]=c}d=x[a+20>>2];if(!d){break b}x[c+20>>2]=d;x[d+24>>2]=c}g:{h:{i:{j:{c=x[f+4>>2];if(!(c&2)){if(x[31491]==(f|0)){x[31491]=a;b=x[31488]+b|0;x[31488]=b;x[a+4>>2]=b|1;if(x[31490]!=(a|0)){break a}x[31487]=0;x[31490]=0;return}if(x[31490]==(f|0)){x[31490]=a;b=x[31487]+b|0;x[31487]=b;x[a+4>>2]=b|1;x[a+b>>2]=b;return}b=(c&-8)+b|0;if(c>>>0<=255){e=c>>>3|0;c=x[f+12>>2];d=x[f+8>>2];if((c|0)==(d|0)){i=125940,j=x[31485]&Lua(-2,e),x[i>>2]=j;break h}x[d+12>>2]=c;x[c+8>>2]=d;break h}h=x[f+24>>2];c=x[f+12>>2];if((f|0)!=(c|0)){d=x[f+8>>2];x[d+12>>2]=c;x[c+8>>2]=d;break i}e=f+20|0;d=x[e>>2];if(!d){d=x[f+16>>2];if(!d){break j}e=f+16|0}while(1){g=e;c=d;e=c+20|0;d=x[e>>2];if(d){continue}e=c+16|0;d=x[c+16>>2];if(d){continue}break}x[g>>2]=0;break i}x[f+4>>2]=c&-2;x[a+4>>2]=b|1;x[a+b>>2]=b;break g}c=0}if(!h){break h}d=x[f+28>>2];e=(d<<2)+126244|0;k:{if(x[e>>2]==(f|0)){x[e>>2]=c;if(c){break k}i=125944,j=x[31486]&Lua(-2,d),x[i>>2]=j;break h}x[h+(x[h+16>>2]==(f|0)?16:20)>>2]=c;if(!c){break h}}x[c+24>>2]=h;d=x[f+16>>2];if(d){x[c+16>>2]=d;x[d+24>>2]=c}d=x[f+20>>2];if(!d){break h}x[c+20>>2]=d;x[d+24>>2]=c}x[a+4>>2]=b|1;x[a+b>>2]=b;if(x[31490]!=(a|0)){break g}x[31487]=b;return}if(b>>>0<=255){c=(b&-8)+125980|0;d=x[31485];b=1<<(b>>>3);l:{if(!(d&b)){x[31485]=b|d;b=c;break l}b=x[c+8>>2]}x[c+8>>2]=a;x[b+12>>2]=a;x[a+12>>2]=c;x[a+8>>2]=b;return}d=31;if(b>>>0<=16777215){c=G(b>>>8|0);d=((b>>>38-c&1)-(c<<1)|0)+62|0}x[a+28>>2]=d;x[a+16>>2]=0;x[a+20>>2]=0;c=(d<<2)+126244|0;m:{e=x[31486];g=1<<d;n:{if(!(e&g)){x[31486]=e|g;x[c>>2]=a;x[a+24>>2]=c;break n}d=b<<((d|0)!=31?25-(d>>>1|0)|0:0);c=x[c>>2];while(1){e=c;if((x[c+4>>2]&-8)==(b|0)){break m}g=d>>>29|0;d=d<<1;g=c+(g&4)|0;c=x[g+16>>2];if(c){continue}break}x[g+16>>2]=a;x[a+24>>2]=e}x[a+12>>2]=a;x[a+8>>2]=a;return}b=x[e+8>>2];x[b+12>>2]=a;x[e+8>>2]=a;x[a+24>>2]=0;x[a+12>>2]=e;x[a+8>>2]=b}}function G1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,w=0;e=fb-32|0;fb=e;a:{if((d|0)<=0){break a}x[e+8>>2]=d;x[e+20>>2]=b;x[e+16>>2]=214748364;u=e,w=D(x[Hb(e+20|0,e+16|0)>>2],20),x[u+24>>2]=w;so(c,x[Hb(e+8|0,e+24|0)>>2]);x[e+12>>2]=b;x[e+8>>2]=a;while(1){b:{c:{d:{e:{if((d|0)<=0){break e}g=Kh(a,b,i);h=Kh(a,b,i+4|0);f=Kh(a,b,i+5|0);u=e,w=Kh(a,b,i+6|0)<<8|Kh(a,b,i+7|0),x[u+28>>2]=w;o=h<<8|f;t=i+8|0;f:{g:{switch(g|0){case 0:i=0;if(d>>>0<o>>>0){i=ac(8);x[31609]=0;a=R(188,i|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break f}break d}while(1){if((i|0)!=(o|0)){u=e,w=Kh(a,b,i+t|0),v[u+24|0]=w;ro(c,e+24|0);i=i+1|0;continue}break};s=o;break b;case 1:break g;default:break e}}vi(e+28|0,d);s=x[e+28>>2];q=Kh(a,b,i+10|0);v[e+24|0]=q;ro(c,e+24|0);j=i+11|0;o=o+3&65532;i=s-1|0;h=0;l=0;r=0;n=0;while(1){if((i|0)<=0){break c}f=Qg(j,h,1,e+8|0);h:{i:{j:{k:{l:{if((l|0)<=7){if(f){g=h;break i}g=h+1|0;n=8;break l}g=h+1|0;m:{if(!f){m=e+8|0;if(!Qg(j,g,1,m)){break i}k=2;n:{o:{f=h+2|0;if(!Qg(j,f,1,m)){break o}k=3;f=h+3|0;if(!Qg(j,f,1,m)){break o}k=Qg(j,f,3,m);g=h+6|0;break n}g=f+1|0}f=4;p:{q:{r:{h=((n<<3)+k|0)-17|0;s:{if((h|0)<0){a=ac(8);x[31609]=0;b=R(188,a|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break r}break s}if(h>>>0<56){break p}a=ac(8);x[31609]=0;b=R(188,a|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break q}}b=N()|0;ic(a);Q(b|0);p()}da(b|0,24472,162);p()}da(b|0,24472,162);p()}n=y[h+24512|0];if((n|0)!=8){break k}break m}f=4;if((n|0)!=8){break k}}n=8;f=1;if((r|0)>19){break k}}f=0;break j}r=r+8|0}while(1){if(!((f|0)<0|(i|0)<=0)){k=(g|0)/8|0;h=k+j|0;m=Kh(x[e+8>>2],x[e+12>>2],h);q=q-rd((Kh(x[e+8>>2],x[e+12>>2],h+1|0)<<8|m<<16|Kh(x[e+8>>2],x[e+12>>2],h+2|0))<<(g-(k<<3)|0)+8,32-n|0)|0;v[e+24|0]=q;ro(c,e+24|0);f=f-1|0;i=i-1|0;g=g+n|0;continue}break}l=(l|0)==31?31:l+1|0;h=g;break h}t:{u:{v:{f=g+1|0;if(!Qg(j,f,1,e+8|0)){h=2;break v}f=g+2|0;if(!Qg(j,f,1,e+8|0)){h=4;break v}f=g+3|0;if(!Qg(j,f,1,e+8|0)){h=6;break v}f=g+5|0;h=e+8|0;if(!Qg(j,g+4|0,1,h)){g=g+8|0;f=Qg(j,f,3,h)+8|0;break t}g=g+10|0;h=16;f=Qg(j,f,5,e+8|0);break u}g=f+2|0;f=Qg(j,f+1|0,1,e+8|0)}f=f+h|0}w:{if(Qg(j,g,1,e+8|0)){k=-256;h=12;break w}g=g+1|0;h=Qg(j,g,1,e+8|0);k=h?-4352:0;h=h?14:8}m=g+1|0;g=Qg(j,m,h,e+8|0);if(f>>>0>=3){l=l-((f|0)!=3)|0;l=((l|0)<=1?1:l)-1|0}k=(g^-1)+k|0;g=Xc(x[c>>2],x[c+4>>2])+k|0;if(g>>>0<k>>>0){h=h+m|0;while(1){if((f|0)<=0|(i|0)<=0){break h}q=y[xb(x[c>>2],g)|0];v[e+24|0]=q;ro(c,e+24|0);i=i-1|0;g=g+1|0;f=f-1|0;continue}}i=ac(8);x[31609]=0;a=R(188,i|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break d}da(a|0,24472,162);p()}r=r-(r>>3)|0;continue}}da(a|0,24472,162);p()}i=mc(x[c>>2],x[c+4>>2])^1;break a}a=N()|0;ic(i);Q(a|0);p()}x[e+28>>2]=i}d=d-s|0;i=o+t|0;continue}}fb=e+32|0;return i|0}function N1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=fb-144|0;fb=d;yc(b);Kp(a);a:{f=d+108|0;if(!dx(b,f)){break a}if(!dG(f)){break a}n=x[b+8>>2];b:{if(!dd(b,y[f+16|0]|y[f+17|0]<<8|(y[f+18|0]<<16|y[f+19|0]<<24))){break b}while(1){if((y[f+12|0]|y[f+13|0]<<8|(y[f+14|0]<<16|y[f+15|0]<<24))>>>0<=j>>>0){break b}if(!Mb(x[b>>2],x[b+8>>2],5)){break b}c:{if((y[f+4|0]|y[f+5|0]<<8)>>>0>=64){if((Mi(b)|0)<=0){break c}}g=0;e=1;while(1){l=Zd(b);if(l){m=g>>>0>4;h=m&e;if(!((e^1)&1|m)){h=(Kq(l<<24>>24)&255)==y[g+13181|0]}e=h;g=g+1|0;continue}break}Vb(b,4);i=(g|0)==5&e|i}j=j+1|0;continue}}dd(b,n);if(!(i&1)){break a}if(!Mb(x[b>>2],x[b+8>>2],cG(f))){break a}if(!c){k=1;break a}h=fb-16|0;fb=h;c=d+108|0;dd(b,y[c+16|0]|y[c+17|0]<<8|(y[c+18|0]<<16|y[c+19|0]<<24));j=d+96|0;f=Nb(j);e=y[c+12|0]|y[c+13|0]<<8|(y[c+14|0]<<16|y[c+15|0]<<24);x[31609]=0;O(176,f|0,e|0);e=x[31609];x[31609]=0;d:{e:{f:{if((e|0)!=1){e=0;g:{h:{while(1){if((y[c+12|0]|y[c+13|0]<<8|(y[c+14|0]<<16|y[c+15|0]<<24))>>>0<=e>>>0){break g}g=x[b+8>>2];i=x[b>>2];x[31609]=0;g=U(150,i|0,g|0,5)|0;i=x[31609];x[31609]=0;if((i|0)==1){break f}if(!g){break g}i=y[c+4|0]|y[c+5|0]<<8;x[31609]=0;g=h+4|0;S(177,g|0,b|0,i|0);i=x[31609];x[31609]=0;if((i|0)!=1){x[31609]=0;O(178,f|0,g|0);i=x[31609];x[31609]=0;if((i|0)==1){break h}e=e+1|0;tb(g);continue}break}a=N()|0;break e}a=N()|0;tb(h+4|0);break e}fb=h+16|0;break d}a=N()|0;break e}a=N()|0}Td(f);Q(a|0);p()}x[31609]=0;V(170,d+84|0,b|0,c|0,j|0);c=x[31609];x[31609]=0;i:{if((c|0)!=1){x[31609]=0;P(149,b|0,y[d+132|0]|y[d+133|0]<<8|(y[d+134|0]<<16|y[d+135|0]<<24))|0;c=x[31609];x[31609]=0;j:{if((c|0)!=1){f=d+36|0;k:{l:{m:{n:{while(1){o:{p:{if((y[d+128|0]|y[d+129|0]<<8|(y[d+130|0]<<16|y[d+131|0]<<24))>>>0>k>>>0){c=x[b+8>>2];e=x[b>>2];x[31609]=0;c=U(150,e|0,c|0,8)|0;e=x[31609];x[31609]=0;if((e|0)==1){break p}if(c){break o}}k=mc(x[a>>2],x[a+4>>2])^1;wc(d+84|0);Td(d+96|0);break a}b=N()|0;break j}x[31609]=0;c=d+60|0;aa(171,c|0,b|0,d+108|0,d+84|0,d+96|0);e=x[31609];x[31609]=0;if((e|0)!=1){e=Mp(c);x[31609]=0;c=R(172,x[d+60>>2])|0;h=x[31609];x[31609]=0;if((h|0)==1){break n}if(c){x[31609]=0;c=R(173,d+24|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break m}e=x[e>>2];q:{if((e|0)<0){break q}g=x[d+96>>2];if(Ud(g,x[d+100>>2])>>>0<=e>>>0){break q}x[31609]=0;h=d+12|0;O(174,h|0,Vd(g,e)|0);e=x[31609];x[31609]=0;if((e|0)==1){break l}zb(c,h);tb(h)}ax(f,d+60|0);x[31609]=0;O(175,a|0,c|0);e=x[31609];x[31609]=0;if((e|0)==1){break l}Gp(c)}k=k+1|0;ub(d+60|0);continue}break}b=N()|0;break j}b=N()|0;break k}b=N()|0;break k}b=N()|0;Gp(c)}ub(d+60|0);break j}b=N()|0}wc(d+84|0);break i}b=N()|0}Td(d+96|0);Q(b|0);p()}fb=d+144|0;return k|0}function MG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=fb-144|0;fb=d;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{if((b|0)<=5){h=d+108|0;ux(h,b);x[31609]=0;e=P(1,d+96|0,18407)|0;b=x[31609];x[31609]=0;if((b|0)==1){break E}x[31609]=0;i=d+120|0;S(2,i|0,h|0,e|0);b=x[31609];x[31609]=0;if((b|0)==1){break D}x[31609]=0;f=P(3,d+72|0,c|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break C}x[31609]=0;g=P(1,d+60|0,20212)|0;b=x[31609];x[31609]=0;if((b|0)==1){break B}x[31609]=0;c=d+84|0;S(4,c|0,f|0,g|0);b=x[31609];x[31609]=0;if((b|0)==1){break A}x[31609]=0;j=d+132|0;S(2,j|0,i|0,c|0);b=x[31609];x[31609]=0;if((b|0)==1){break z}tb(c);tb(g);tb(f);tb(i);tb(e);tb(h);b=x[a>>2];x[31609]=0;O(5,i|0,(b?b:22292)|0);b=x[31609];x[31609]=0;if((b|0)==1){break t}b=x[a+4>>2];x[31609]=0;O(5,h|0,(b?b:22292)|0);b=x[31609];x[31609]=0;if((b|0)==1){break s}a=x[a+8>>2];x[31609]=0;x[d+48>>2]=a;e=d+48|0;O(6,c|0,e|0);a=x[31609];x[31609]=0;if((a|0)==1){break r}x[31609]=0;P(7,497012,18286)|0;a=x[31609];x[31609]=0;if((a|0)==1){break q}x[31609]=0;O(8,e|0,i|0);a=x[31609];x[31609]=0;if((a|0)==1){break p}x[31609]=0;P(9,497012,e|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break o}x[31609]=0;P(7,497012,17493)|0;a=x[31609];x[31609]=0;if((a|0)==1){break o}x[31609]=0;f=d+36|0;O(8,f|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break n}x[31609]=0;P(9,497012,f|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break m}x[31609]=0;P(7,497012,17491)|0;a=x[31609];x[31609]=0;if((a|0)==1){break m}x[31609]=0;P(7,497012,18407)|0;a=x[31609];x[31609]=0;if((a|0)==1){break m}x[31609]=0;g=d+24|0;O(8,g|0,j|0);a=x[31609];x[31609]=0;if((a|0)==1){break l}x[31609]=0;P(9,497012,g|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break k}x[31609]=0;P(7,497012,13585)|0;a=x[31609];x[31609]=0;if((a|0)==1){break k}x[31609]=0;b=d+12|0;O(8,b|0,h|0);a=x[31609];x[31609]=0;if((a|0)==1){break j}x[31609]=0;P(9,497012,b|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break i}x[31609]=0;P(7,497012,13583)|0;a=x[31609];x[31609]=0;if((a|0)==1){break i}x[31609]=0;R(10,497012)|0;a=x[31609];x[31609]=0;if((a|0)==1){break i}tb(b);tb(g);tb(f);tb(e);tb(c);tb(h);tb(i);tb(j)}fb=d+144|0;return}a=N()|0;break u}a=N()|0;break v}a=N()|0;break w}a=N()|0;break x}a=N()|0;break y}a=N()|0;tb(d+84|0)}tb(g)}tb(f)}tb(d+120|0)}tb(e)}tb(d+108|0);break a}a=N()|0;break b}a=N()|0;break c}a=N()|0;break d}a=N()|0;break e}a=N()|0;break e}a=N()|0;break f}a=N()|0;break f}a=N()|0;break g}a=N()|0;break g}a=N()|0;break h}a=N()|0;break h}a=N()|0;tb(d+12|0)}tb(d+24|0)}tb(d+36|0)}tb(d+48|0)}tb(d+84|0)}tb(d+108|0)}tb(d+120|0)}tb(d+132|0)}Q(a|0);p()}function TP(a){var b=E(0),c=E(0),d=0,e=E(0),f=E(0),g=0,h=0,i=E(0),k=0,m=E(0),p=E(0),s=E(0),t=0,u=0,v=E(0),w=E(0);d=a+4208|0;BB(yb(d,0),B[a+4272>>2]);b=E(B[yb(d,0)>>2]*E(15920));s=Ee(E(10),E(E(E(B[yb(d,2)>>2]+E(-.5))*E(30))/E(40)));c=E(E(E(b+E(80))/E(A[x[a+16>>2]+24620>>2]))*E(6.2831854820251465));b=iQ(c);v=tq(c);w=b;f=E(E(c*E(E(E(B[yb(d,1)>>2]*E(35))+E(1))*E(.02888113260269165)))/b);m=(l(2,(q(f),j(2))&-2147483648|1056964608),r());c=E(F(f));k=(q(c),j(2));a:{if(k>>>0<=1118925334){b:{c:{d:{e:{f:{g:{h=(q(c),j(2));d=h&2147483647;if(d>>>0>=1100331076){if(d>>>0>2139095040){break c}b=E(-1);if((h|0)<0){break b}if(d>>>0<1118925336){break g}b=E(c*E(17014118346046923e22));break b}if(d>>>0<1051816473){break e}if(d>>>0>1065686417){break g}if((h|0)>=0){d=1;e=E(905800061445916e-20);b=E(c+E(-.6931381225585938));break f}d=-1;e=E(-905800061445916e-20);b=E(c+E(.6931381225585938));break f}b=E(E(c*E(1.4426950216293335))+(l(2,(q(c),j(2))&-2147483648|1056964608),r()));h:{if(E(F(b))<E(2147483648)){d=~~b;break h}d=-2147483648}b=E(d|0);e=E(b*E(905800061445916e-20));b=E(c+E(b*E(-.6931381225585938)))}c=E(b-e);e=E(E(b-c)-e);break d}if(d>>>0<855638016){break c}d=0}b=E(c*E(.5));i=E(c*b);p=E(E(i*E(E(i*E(.0015807170420885086))+E(-.03333321213722229)))+E(1));b=E(E(3)-E(p*b));p=E(i*E(E(p-b)/E(E(6)-E(c*b))));b=E(c-E(E(c*p)-i));if(!d){break b}e=E(E(E(c*E(p-e))-e)-i);i:{switch(d+1|0){case 0:b=E(E(E(c-e)*E(.5))+E(-.5));break b;case 2:b=E(E(e-E(c+E(.5)))*E(-2));if(c<E(-.25)){break b}b=E(c-e);b=E(E(b+b)+E(1));break b;default:break i}}h=d<<23;b=(l(2,h+1065353216|0),r());if(d>>>0>=57){c=E(E(c-e)+E(1));b=E(((d|0)==128?E(E(c+c)*E(17014118346046923e22)):E(c*b))+E(-1));break b}i=(l(2,h^1065353216),r());c=E((d>>>0<=22?E(E(E(1)-i)+E(c-e)):E(E(c-E(e+i))+E(1)))*b)}b=c}if(k>>>0<=1065353215){if(k>>>0<964689920){break a}f=E(m*E(E(b+b)-E(E(b*b)/E(b+E(1)))));break a}f=E(m*E(b+E(b/E(b+E(1)))));break a}m=E(E(m+m)*E(1661534994731145e20));b=E(c+E(-162.88958740234375));d=$y(b)&2047;j:{k:{if($y(E(88))>>>0>d>>>0){break k}c=E(0);if(((q(b),j(2))|0)==-8388608){break j}c=E(b+b);if($y(E(Infinity))>>>0<=d>>>0){break j}if(b>E(88.72283172607422)){c=BG(0);break j}if(!(b<E(-103.97207641601562))){break k}c=$F(0);break j}g=C[165]*+b;t=C[164];u=g+t;g=g-(u-t);g=(C[166]*g+C[167])*(g*g)+(C[168]*g+1);o(+u);j(1)|0;d=j(0)|0;h=d<<15;d=((d&31)<<3)+1024|0;k=x[d>>2];d=x[d+4>>2]+h|0;l(0,k|0);l(1,(k>>>0<k>>>0?d+1|0:d)|0);c=E(g*+n())}f=E(E(m*c)*E(1661534994731145e20))}c=E(w*f);f=E(c/s);b=E(f+E(1));B[a+4236>>2]=E(E(1)-f)/b;f=E(E(v*E(-2))/b);B[a+4232>>2]=f;c=E(c*s);B[a+4228>>2]=E(E(1)-c)/b;B[a+4224>>2]=f;B[a+4220>>2]=E(c+E(1))/b}function S8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=fb-336|0;fb=d;e=fb-16|0;fb=e;x[a+4>>2]=0;v[a|0]=0;f=a+40|0;so(f,32);v[e+15|0]=0;ro(f,e+15|0);fb=e+16|0;e=x[a+36>>2];a:{if(x[(x[x[e>>2]-12>>2]+e|0)+16>>2]){Ph(a,2,16777216);break a}ae(d+72|0,e);e=x[d+84>>2];x[a+16>>2]=x[d+80>>2];x[a+20>>2]=e;x[d+72>>2]=3;f=x[a+36>>2];e=0;while(1){if(A[d+72>>2]>e>>>0){Gi(f,d+e|0);e=e+1|0;continue}break}if(jd(d,24376,3)){Ph(a,2,512);break a}v[d+335|0]=0;Gi(x[a+36>>2],d+335|0);f=d+72|0;Rb(f,0,256);e=y[d+335|0];if(e){wj(x[a+36>>2],f,e)}f=b;b=sl(d,d+72|0,e);e=Jy(f,b);Eb(b);if(!e){Ph(a,2,4096)}if(rl(y[a|0])){break a}Gi(x[a+36>>2],d+71|0);b=y[d+71|0];e=b&3;w[a+24>>1]=(e|0)==3?4:e;if(mj(b,6)){Qc(d,a+32|0,9);kf(d,1)}x[d+64>>2]=0;uK(x[a+36>>2],d- -64|0);e=x[d+64>>2];v[d+63|0]=0;if(e>>>0>=2){Gi(x[a+36>>2],d+71|0);f=-1;if(!y[d+71|0]){Gi(x[a+36>>2],d+63|0);f=-2}Pm(x[a+36>>2],e+f|0)}x[d+48>>2]=0;x[d+52>>2]=0;b:{if(!mj(b,4)){break b}pl(x[a+36>>2],d+48|0);e=x[d+52>>2];f=x[d+48>>2];x[a+64>>2]=f;x[a+68>>2]=e;g=x[c+4>>2];if((g|0)==(e|0)&A[c>>2]>=f>>>0|e>>>0<g>>>0){break b}Ph(a,1,4)}if(mj(b,5)){Gi(x[a+36>>2],d+71|0);Pm(x[a+36>>2],y[d+71|0])}c=y[d+63|0];c:{if(!mj(c,0)){break c}Gi(x[a+36>>2],d+71|0);e=y[d+71|0];e=e&1?-1:e>>>1|0;w[a+24>>1]=e;if(e){break c}Ph(a,1,2)}x[a+8>>2]=0;f=1;if(mj(c,1)){uK(x[a+36>>2],a+8|0)}g=mj(b,2);e=a+32|0;Qc(d,e,6);kf(d,g);g=mj(b,3);Qc(d,e,7);kf(d,g);g=z[a+24>>1];Qc(d,e,5);kf(d,(g|0)!=0);b=mj(b,7);Qc(d,e,8);kf(d,b);Qc(d,e,5);d:{if(Gb(x[x[d>>2]>>2],x[d+4>>2])){break d}Qc(d+40|0,e,6);if(Gb(x[x[d+40>>2]>>2],x[d+44>>2])){break d}Qc(d+32|0,e,7);if(Gb(x[x[d+32>>2]>>2],x[d+36>>2])){break d}Qc(d+24|0,e,8);f=Gb(x[x[d+24>>2]>>2],x[d+28>>2])}b=d+16|0;Qc(b,e,11);kf(b,f);Qc(d,e,11);if(mj(c,2)){w[d+40>>1]=0;By(x[a+36>>2],d+40|0);b=x[a+36>>2];f=z[d+40>>1];Qc(d,e,9);Pm(b,f<<Gb(x[x[d>>2]>>2],x[d+4>>2]))}if(mj(c,3)){Pm(x[a+36>>2],5)}pl(x[a+36>>2],d+48|0);c=x[d+52>>2];f=c;b=x[d+48>>2];if(!c&b>>>0>=16001|c){Ph(a,2,8192);break a}x[a+104>>2]=b;if(!b){Ph(a,1,1)}Qc(d,e,11);e:{if(!Gb(x[x[d>>2]>>2],x[d+4>>2])){break e}pl(x[a+36>>2],d+48|0);c=x[d+52>>2];f=c;b=x[d+48>>2];if(zy(b,c)){break e}Ph(a,2,2048);break a}ae(d,x[a+36>>2]);g=x[d+8>>2];h=x[a+16>>2];c=g-h|0;g=x[d+12>>2]-(x[a+20>>2]+(g>>>0<h>>>0)|0)|0;if((g|0)<0){Ph(a,2,16384);break a}x[a+96>>2]=c;x[a+100>>2]=g;Qc(d,e,11);c=x[a+100>>2];g=b;h=x[a+96>>2];b=Gb(x[x[d>>2]>>2],x[d+4>>2]);x[a+72>>2]=b?g:h;x[a+76>>2]=b?f:c;Qc(d,e,11);if(!Gb(x[x[d>>2]>>2],x[d+4>>2])){b=x[a+100>>2]+x[a+20>>2]|0;f=x[a+16>>2];c=f+x[a+96>>2]|0;x[a+80>>2]=c;x[a+84>>2]=c>>>0<f>>>0?b+1|0:b}Qc(d,e,10);kf(d,1)}fb=d+336|0}function spa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=fb-16|0;fb=g;a:{if(!Mb(x[a>>2],x[a+8>>2],2)){Pg(c+484344|0,b,64);break a}m=c+484344|0;n=Ld(Qk(a),1,1024);if(!Pg(m,b,n)){break a}p=z[c+480188>>1];b:while(1){if((k|0)==(n|0)){break a}e=Wb(x[m>>2],b);af(g+8|0,x[e>>2],x[x[e+48>>2]+12>>2],k);i=0;while(1)if((i|0)==(p|0)){k=k+1|0;continue b}else{e=Yc(x[g+8>>2],i);q=y[e+5|0];l=y[e+3|0];h=g+4|0;mm(h,a);r=_e(h);f=_i(h);j=y[g+4|0];c:{if((j-1&255)>>>0>35){break c}v[e|0]=j+48;o=y[Jc(h)|0];h=o+1|0;v[e+1|0]=h;j=h;h=h&255;if((j|0)!=(h|0)|h>>>0>z[c+480190>>1]){break c}h=oi(c,h);j=xb(d,i);if(!(!y[j|0]|z[h+30>>1]>255)){v[e+4|0]=64;v[e+2|0]=1}h=x[yb(h+68|0,0)>>2];if(!(y[j|0]|h?y[j|0]?(h|0)==1:0:1)){break c}v[e+1|0]=o+101}d:{e:{switch(y[r|0]-1|0){case 0:if(!y[f|0]){break d}v[e+3|0]=2;v[e+5|0]=y[f|0];break d;case 1:if(!y[f|0]){break d}v[e+3|0]=3;v[e+5|0]=y[f|0];break d;case 9:if(!y[f|0]){break d}v[e+3|0]=1;f=y[f|0];s=e,t=yX(f>>>4|0)<<4|f&15,v[s+5|0]=t;break d;case 10:if(!y[f|0]){break d}v[e+3|0]=1;f=y[f|0];s=e,t=f&240|yX(f&15),v[s+5|0]=t;break d;case 11:if(!y[f|0]){break d}v[e+3|0]=1;v[e+5|0]=y[f|0];break d;case 12:if(!y[f|0]){break d}v[e+3|0]=39;v[g|0]=15;s=e,t=y[Qb(g,f)|0]|16,v[s+5|0]=t;break d;case 29:if(!y[f|0]){break d}v[e+3|0]=38;v[g|0]=15;s=e,t=y[Qb(g,f)|0]|16,v[s+5|0]=t;break d;case 20:if(!y[f|0]){break d}v[e+3|0]=39;v[g|0]=15;s=e,t=y[Qb(g,f)|0]|80,v[s+5|0]=t;break d;case 16:if(!y[f|0]){break d}v[e+3|0]=38;v[g|0]=15;s=e,t=y[Qb(g,f)|0]|80,v[s+5|0]=t;break d;case 14:v[e+3|0]=19;v[e+5|0]=y[f|0]!=0;break d;case 24:v[e+3|0]=12;v[e+5|0]=y[f|0];break d;case 26:Vo(e);v[e|0]=255;break d;case 27:if(y[f|0]>31){break d}v[e+3|0]=16;v[e+5|0]=y[f|0];break d;case 30:break e;default:break d}}h=y[f|0];if(h&15){s=e,t=y[xb(d,i)|0]?22:11,v[s+3|0]=t;v[e+5|0]=y[f|0]&15;h=y[f|0]}f:{g:{switch(h>>>4|0){case 4:if((h|0)!=64){break f}case 0:case 1:case 2:case 3:if(y[xb(d,i)|0]){v[e+3|0]=21;v[e+5|0]=y[f|0];break f}v[e+2|0]=1;f=y[f|0];v[e+3|0]=0;v[e+4|0]=f;break f;case 5:v[e+5|0]=y[e+5|0]<<4;break f;case 6:v[g|0]=y[e+5|0];v[g+3|0]=14;s=e,t=y[Qb(g,g+3|0)|0]|240,v[s+5|0]=t;break f;case 7:v[g|0]=y[e+5|0];v[g+3|0]=14;s=e,t=y[Qb(g,g+3|0)|0]<<4|15,v[s+5|0]=t;break f;default:break g}}v[e+3|0]=0}if((y[e+3|0]-21&255)>>>0>1){break d}f=Yc(x[g+8>>2],v[xb(d,i)|0]+i|0);uw(g,y[f+3|0],y[f+5|0],1);if(y[g|0]){h=z[g>>1];v[f+2|0]=h;v[f+4|0]=h>>>8}v[f+3|0]=y[e+3|0];v[f+5|0]=y[e+5|0]}h:{if(!l){break h}f=y[e+3|0];if((f|0)==(l|0)){break h}gm(g,e,f,y[e+5|0],l,q)}i=i+1|0;continue}}}fb=g+16|0}function mja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=fb-32|0;fb=c;a:{b:{if(!Ib(x[b>>2],x[b+4>>2])){break b}l=a+16|0;m=x[b+12>>2];k=z[x[x[b+48>>2]+12>>2]+480188>>1];d=k;e=fb-16|0;fb=e;g=c+20|0;x[g>>2]=0;x[g+4>>2]=0;tc(g+8|0);Rd(e+8|0,x[vb(e+4|0,g)>>2]);c:{d:{if(d){x[31609]=0;O(460,g|0,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break d}h=fb-16|0;fb=h;f=Br(h+4|0,g,d);d=x[f+4>>2];i=x[f+8>>2];while(1){if((d|0)==(i|0)){kc(f);fb=h+16|0}else{v[d|0]=0;v[d+1|0]=0;v[d+2|0]=0;v[d+3|0]=0;v[d+4|0]=0;v[d+5|0]=0;Ng(d);d=d+6|0;x[f+4>>2]=d;continue}break}}d=e+8|0;Qd(d);bm(d);fb=e+16|0;break c}a=N()|0;bm(e+8|0);Q(a|0);p()}while(1){e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{if(!(x[x[x[a>>2]-12>>2]+l>>2]|j>>>0>=m>>>0)){x[31609]=0;v[c+19|0]=0;P(918,a|0,c+19|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}d=v[c+19|0];if(!d){j=j+1|0;continue}v[c+18|0]=0;t:{if((d|0)>=0){break t}x[31609]=0;P(918,a|0,c+18|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break t}break a}v[c+17|0]=0;w[c+12>>1]=0;x[c+8>>2]=0;u:{d=d&127;f=(d?d-1|0:0)&65535;i=f>>>0>=k>>>0;v:{w:{if(!i){h=md(x[b>>2],x[x[b+48>>2]+12>>2],j,f);d=y[c+18|0];if(d&1){break w}e=Yc(x[g>>2],f);break v}h=c+8|0;d=y[c+18|0];if(!(d&1)){break u}}x[31609]=0;P(918,a|0,c+17|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break a}if(i){break u}e=Yc(x[g>>2],f);v[e|0]=y[c+17|0]}v[h|0]=y[e|0];d=y[c+18|0];if(!(d&2)){break r}break s}if(d&2){break s}break q}Nk(g);break b}x[31609]=0;P(918,a|0,c+17|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break a}if(i){break q}e=Yc(x[g>>2],f);v[e+1|0]=y[c+17|0]}v[h+1|0]=y[e+1|0];if(d&4){break p}break o}if(!(d&4)){break n}}x[31609]=0;P(918,a|0,c+17|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break a}if(i){break n}e=Yc(x[g>>2],f);v[e+2|0]=y[c+17|0]}v[h+2|0]=y[e+2|0];if(!(d&8)){break l}break m}if(!(d&8)){break k}}x[31609]=0;P(918,a|0,c+17|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break a}if(i){break k}e=Yc(x[g>>2],f);v[e+4|0]=y[c+17|0]}v[h+4|0]=y[e+4|0];if(d&16){break j}break i}if(!(d&16)){break h}}x[31609]=0;P(918,a|0,c+17|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break a}if(i){break h}e=Yc(x[g>>2],f);v[e+3|0]=y[c+17|0]}v[h+3|0]=y[e+3|0];if(!(d&32)){break f}break g}if(!(d&32)){break e}}x[31609]=0;P(918,a|0,c+17|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break a}if(i){break e}e=Yc(x[g>>2],f);v[e+5|0]=y[c+17|0]}v[h+5|0]=y[e+5|0]}if(!(d&64)){continue}x[31609]=0;P(918,a|0,c+7|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){x[31609]=0;P(919,a|0,y[c+7|0])|0;d=x[31609];x[31609]=0;if((d|0)!=1){continue}}break}break a}fb=c+32|0;return}a=N()|0;Nk(g);Q(a|0);p()}function Oz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=fb-144|0;fb=f;x[f+136>>2]=c;x[f+140>>2]=d;g=x[b+4>>2];a:{if(!g){h=x[b>>2];break a}h=x[b>>2];i=y[Al(h,g)|0];if((i|0)==33){e=1}else{if((i|0)!=63){break a}e=0}Nl(f+112|0,h,g,g-1|0);g=x[f+116>>2];h=x[f+112>>2];x[b>>2]=h;x[b+4>>2]=g}j=f+112|0;ie(j);i=x[f+112>>2];k=f+100|0;ie(k);i=zl(i,x[f+104>>2],b);ie(j);b:{c:{d:{e:{f:{g:{h:{if(x[f+116>>2]==(i|0)){c=qc(f+128|0,22292);a=x[c+4>>2];x[f+8>>2]=x[c>>2];x[f+12>>2]=a;if(Ic(h,g,f+8|0)){g=ac(8);x[31609]=0;O(1006,k|0,f+136|0);a=x[31609];x[31609]=0;if((a|0)==1){break g}x[31609]=0;S(1011,j|0,18271,k|0);a=x[31609];x[31609]=0;if((a|0)==1){break f}pc(g,j);h=0;x[31609]=0;S(97,g|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(j);break e}if(!e){break h}g=ac(8);c=x[b>>2];a=x[b+4>>2];x[31609]=0;e=bi(f+76|0,c,a);a=x[31609];x[31609]=0;i:{j:{k:{l:{m:{n:{o:{p:{if((a|0)!=1){x[31609]=0;b=f+88|0;S(1011,b|0,18307,e|0);a=x[31609];x[31609]=0;if((a|0)==1){break p}x[31609]=0;c=f+100|0;O(1013,c|0,b|0);b=x[31609];x[31609]=0;a=1;if((b|0)==1){break o}x[31609]=0;b=f- -64|0;O(1006,b|0,f+136|0);a=x[31609];x[31609]=0;if((a|0)==1){break n}x[31609]=0;d=f+112|0;S(1015,d|0,c|0,b|0);b=x[31609];x[31609]=0;a=1;if((b|0)==1){break m}pc(g,d);x[31609]=0;S(97,g|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(d);a=0;break l}b=N()|0;break d}b=N()|0;a=1;break i}b=N()|0;break j}b=N()|0;a=1;break k}b=N()|0}tb(f- -64|0)}tb(f+100|0)}tb(f+88|0)}tb(e);if(a){break d}break c}e=qc(f+56|0,22292);b=x[e+4>>2];x[f+32>>2]=x[e>>2];x[f+36>>2]=b;if(Ic(h,g,f+32|0)){g=ac(8);x[31609]=0;b=f+100|0;O(1006,b|0,f+136|0);a=x[31609];x[31609]=0;q:{r:{if((a|0)!=1){x[31609]=0;c=f+112|0;S(1011,c|0,18271,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break r}pc(g,c);h=0;x[31609]=0;S(97,g|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break q}b=N()|0;break d}b=N()|0;h=1}tb(f+100|0);if(h){break d}break c}e=qc(f+48|0,10990);b=x[e+4>>2];x[f+24>>2]=x[e>>2];x[f+28>>2]=b;if(Ic(h,g,f+24|0)){Lz(a,Gc(c,d));break h}e=qc(f+40|0,8643);b=x[e+4>>2];x[f+16>>2]=x[e>>2];x[f+20>>2]=b;if(!Ic(h,g,f+16|0)){break h}e=x[a+32>>2];a=Tu(c,d);a=a>>>0>=4?1:a;b=fb-16|0;fb=b;s:{if((tk(y[e+140|0])|0)==(a|0)){a=e+120|0;au(y[a+20|0]);c=fb-16|0;fb=c;x[c+12>>2]=b+15;d=fb-16|0;fb=d;x[d+12>>2]=1146;x[d+8>>2]=1147;x[d+4>>2]=1148;x[d>>2]=1149;ib[x[lq(d,tk(y[a+20|0]))>>2]](c+12|0,a);fb=d+16|0;fb=c+16|0;break s}VM(e,a,WM(e))}fb=b+16|0}fb=f+144|0;return}b=N()|0;break d}b=N()|0;h=1}tb(f+100|0);if(!h){break c}}ic(g)}Q(b|0)}p()}function Hka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;f=fb-16|0;fb=f;e=fb-16|0;fb=e;d=EB(f+8|0);a:{b:{c:{d:{switch(b-850|0){default:e:{f:{if((b|0)!=437){if((b|0)==737){break f}if((b|0)==775){break e}if((b|0)==1252){break c}g:{h:{if((b|0)!=20127){if((b|0)==28591){break h}if((b|0)==28605){break g}if((b|0)!=65001){break b}b=mf(e+8|0,0);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a}b=mf(e+8|0,1);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a}b=mf(e+8|0,2);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a}b=mf(e+8|0,3);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a}b=mf(e+8|0,4);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a}b=mf(e+8|0,5);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a}b=mf(e+8|0,6);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a;case 0:b=mf(e+8|0,7);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a;case 2:b=mf(e+8|0,8);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a;case 5:b=mf(e+8|0,9);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a;case 7:b=mf(e+8|0,10);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a;case 10:b=mf(e+8|0,11);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a;case 11:b=mf(e+8|0,12);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a;case 12:b=mf(e+8|0,13);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a;case 13:b=mf(e+8|0,14);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a;case 14:b=mf(e+8|0,15);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a;case 15:b=mf(e+8|0,16);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a;case 16:b=mf(e+8|0,17);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a;case 19:b=mf(e+8|0,18);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a;case 1:case 3:case 4:case 6:case 8:case 9:case 17:case 18:case 20:case 21:case 22:case 23:break b;case 24:break d}}b=mf(e+8|0,19);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a}b=mf(e+8|0,20);x[d>>2]=x[b>>2];v[d+4|0]=y[b+4|0];break a}if(y[d+4|0]){v[d+4|0]=0}}fb=e+16|0;i:{if(Id(y[f+12|0])){if(!Id(y[f+12|0])){a=ac(4);x[a>>2]=0;a=Ej(a);x[a>>2]=121028;da(a|0,121064,840);p()}b=fb-32|0;fb=b;j:{k:{l:{m:{e=x[f+8>>2];if(!e){Uf(b+20|0,c);c=0;a=Fb(a);d=y[b+31|0];e=x[b+24>>2];x[31609]=0;O(93,a|0,yh(e,d)|0);d=x[31609];x[31609]=0;if((d|0)!=1){while(1){if(yh(x[b+24>>2],y[b+31|0])>>>0<=c>>>0){break m}d=y[dc(b+20|0,c)|0];x[31609]=0;O(95,a|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break k}c=c+1|0;continue}}break k}d=b+8|0;Uf(d,c);x[31609]=0;c=b+20|0;S(11,c|0,e|0,d|0);e=x[31609];x[31609]=0;n:{o:{if((e|0)!=1){x[31609]=0;O(12,a|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break o}Ub(c);tb(d);break l}c=N()|0;break n}c=N()|0;Ub(b+20|0)}tb(b+8|0);break j}tb(b+20|0)}fb=b+32|0;break i}c=N()|0;tb(a);tb(b+20|0)}Q(c|0);p()}A0(a,22,c)}fb=f+16|0}function kI(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,m=0,p=0;i=fb-48|0;fb=i;o(+a);e=j(1)|0;d=j(0)|0;a:{b:{h=e&2147483647;c:{if(h>>>0<=1074752122){if((e&1048575)==598523){break c}if(h>>>0<=1073928572){if((e|0)>0|(e|0)>=0){a=a+-1.5707963267341256;c=a+-6077100506506192e-26;C[b>>3]=c;C[b+8>>3]=a-c+-6077100506506192e-26;d=1;break a}a=a+1.5707963267341256;c=a+6077100506506192e-26;C[b>>3]=c;C[b+8>>3]=a-c+6077100506506192e-26;d=-1;break a}if((e|0)>0|(e|0)>=0){a=a+-3.1415926534682512;c=a+-1.2154201013012384e-10;C[b>>3]=c;C[b+8>>3]=a-c+-1.2154201013012384e-10;d=2;break a}a=a+3.1415926534682512;c=a+1.2154201013012384e-10;C[b>>3]=c;C[b+8>>3]=a-c+1.2154201013012384e-10;d=-2;break a}if(h>>>0<=1075594811){if(h>>>0<=1075183036){if((h|0)==1074977148){break c}if((e|0)>0|(e|0)>=0){a=a+-4.712388980202377;c=a+-1.8231301519518578e-10;C[b>>3]=c;C[b+8>>3]=a-c+-1.8231301519518578e-10;d=3;break a}a=a+4.712388980202377;c=a+1.8231301519518578e-10;C[b>>3]=c;C[b+8>>3]=a-c+1.8231301519518578e-10;d=-3;break a}if((h|0)==1075388923){break c}if((e|0)>0|(e|0)>=0){a=a+-6.2831853069365025;c=a+-2.430840202602477e-10;C[b>>3]=c;C[b+8>>3]=a-c+-2.430840202602477e-10;d=4;break a}a=a+6.2831853069365025;c=a+2.430840202602477e-10;C[b>>3]=c;C[b+8>>3]=a-c+2.430840202602477e-10;d=-4;break a}if(h>>>0>1094263290){break b}}f=a*.6366197723675814+6755399441055744+-6755399441055744;c=a+f*-1.5707963267341256;g=f*6077100506506192e-26;p=c-g;e=p<-.7853981633974483;if(F(f)<2147483648){d=~~f}else{d=-2147483648}d:{if(e){d=d-1|0;f=f+-1;g=f*6077100506506192e-26;c=a+f*-1.5707963267341256;break d}if(!(p>.7853981633974483)){break d}d=d+1|0;f=f+1;g=f*6077100506506192e-26;c=a+f*-1.5707963267341256}a=c-g;C[b>>3]=a;o(+a);e=j(1)|0;j(0)|0;k=h>>>20|0;e:{if((k-(e>>>20&2047)|0)<17){break e}g=c;a=f*6077100506303966e-26;c=c-a;g=f*20222662487959506e-37-(g-c-a);a=c-g;C[b>>3]=a;o(+a);e=j(1)|0;j(0)|0;if((k-(e>>>20&2047)|0)<50){break e}g=c;a=f*20222662487111665e-37;c=c-a;g=f*84784276603689e-45-(g-c-a);a=c-g;C[b>>3]=a}C[b+8>>3]=c-a-g;break a}if(h>>>0>=2146435072){a=a-a;C[b>>3]=a;C[b+8>>3]=a;d=0;break a}l(0,d|0);l(1,e&1048575|1096810496);a=+n();d=0;k=1;while(1){m=(i+16|0)+(d<<3)|0;if(F(a)<2147483648){d=~~a}else{d=-2147483648}c=+(d|0);C[m>>3]=c;a=(a-c)*16777216;d=1;m=k;k=0;if(m){continue}break}C[i+32>>3]=a;d=2;while(1){k=d;d=d-1|0;m=i+16|0;if(C[m+(k<<3)>>3]==0){continue}break}d=zL(m,i,(h>>>20|0)-1046|0,k+1|0,1);a=C[i>>3];if((e|0)<0){C[b>>3]=-a;C[b+8>>3]=-C[i+8>>3];d=0-d|0;break a}C[b>>3]=a;C[b+8>>3]=C[i+8>>3]}fb=i+48|0;return d}function Ypa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=fb-560|0;fb=f;a:{if(!dd(b,1464)){break a}d=f+556|0;if(!jr(b,d)){break a}Dd(a,1);Lb(Lb(bg(a+1074312|0,83),84,1),85,1);b:{if(oe(d,25284)){e=f+32|0;d=uc(e,8430);zb(a+1298344|0,d);tb(d);d=uc(e,14911);zb(a+1298356|0,d);tb(d);d=uc(e,14976);zb(a+1298368|0,d);break b}if(!oe(f+556|0,15612)){break a}e=f+32|0;d=uc(e,8620);zb(a+1298344|0,d);tb(d);d=uc(e,12356);zb(a+1298356|0,d);tb(d);d=uc(e,15529);zb(a+1298368|0,d)}tb(d);r=a+1298404|0,s=x[Fc(e,28)>>2],x[r>>2]=s;e=0;dd(b,0);LZ(b,a+1298308|0,20);w[a+480190>>1]=31;d=1;while(1)if((d|0)==32){if(e>>>0>40){break a}d=f+554|0;Nw(d,b);m=Jc(d);if(y[f+554|0]>128){break a}e=f+32|0;d=fb-16|0;fb=d;c:{if(!Mb(x[b>>2],x[b+8>>2],512)){PX(e);break c}zE(d+8|0,e);sd(d,b,x[d+8>>2],x[d+12>>2])}fb=d+16|0;d=0;e=y[m|0];while(1){n=(d|0)==512;if(!n){g=(f+32|0)+d|0;d=d+1|0;if(e>>>0>=y[g|0]){continue}break a}break}if((c|0)==64){break a}x[a+480260>>2]=56;x[a+480264>>2]=13696;x[a+480204>>2]=125e4;x[a+480196>>2]=6;w[a+480192>>1]=0;w[a+480188>>1]=4;x[a+480228>>2]=64;x[a+480208>>2]=x[a+480208>>2]|18874368;Wh(a,0);vg(Xb(x[a+484360>>2],y[a+484376|0]),y[f+554|0]);l=a+484344|0;Tf(l,y[f+554|0]);g=0;while(1)if(y[f+554|0]<=g>>>0){if(!(c&2)){break a}dd(b,(y[m|0]<<8)+1468|0);d=1;while(1){if((d|0)==32){break a}c=(D(d,104)+a|0)+484380|0;if(x[c>>2]){dg(Zc(f+8|0,8,1,0,0),c,b)}d=d+1|0;continue}}else{r=bc(x[Xb(x[a+484360>>2],y[a+484376|0])>>2],g),s=g,w[r>>1]=s;d:{if(!Pg(l,g&65535,64)){break d}q=g<<2;i=0;e:while(1){if((i|0)==4){r=f,s=wb(x[Wb(x[l>>2],g)>>2]),x[r+24>>2]=s;i=0;while(1){if((i|0)==64){break d}d=0;f:{while(1){if((d&65535)>>>0>=4){g:{v[f+30|0]=o;v[f+31|0]=p;d=h&255;if(d){break g}h=0;break f}}else{e=x[f+24>>2];h:{if((y[e+3|0]&254)!=16){break h}v[e+3|0]=16;h=0;j=y[e+5|0];if(j>>>0<16){break h}h=j>>>4|0;v[e+5|0]=h;k=h;e=j&15;h=(e|0)!=(h|0)&(e|0)!=0;o=h?k:o;p=h?e:p}d=d+1|0;LC(f+24|0);continue}break}Ae(Wb(x[l>>2],g),Ve(Oe(f+8|0,16,y[(d+f|0)+29|0]),i));h=h+1|0;h=(h&255)==3?1:h}i=i+1|0;continue}}dd(b,(y[(f+32|0)+(i|q)|0]<<8)+1468|0);e=0;d=Wb(x[l>>2],g);d=md(x[d>>2],x[x[d+48>>2]+12>>2],0,i&65535);while(1)if((e|0)==64){i=i+1|0;continue e}else{k=f+8|0;P$(k,b,d);j=y[f+8|0];k=y[Jc(k)|0];i:{if(!(!(j|k)|(j-5&255)>>>0<5|(j|0)==14&k>>>0>15)){Cf(d,j,k);break i}v[d+3|0]=0}d=d+24|0;e=e+1|0;continue}}}g=g+1|0;continue}}else{g=f+32|0;PC(b,g);e=YC(g,(D(d,104)+a|0)+484380|0,((d<<5)+a|0)+946304|0,1)+e|0;d=d+1|0;continue}}fb=f+560|0;return n|0}function Una(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;g=fb-80|0;fb=g;a:{d=x[a+4>>2];b:{if(d>>>0<b>>>0){q=Md(g+72|0);o=b-d|0;c=hv(a);c:{if(!(o>>>0>c>>>0|d>>>0>c-o>>>0)){$q(g+60|0,x[a>>2],d);Zb(q,x[g+60>>2],x[g+64>>2]);x[a+4>>2]=x[a+4>>2]+o;break c}m=So(g+60|0);x[31609]=0;b=P(759,a|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}x[31609]=0;O(760,m|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}x[m+4>>2]=x[a+4>>2]+o;nn(g+44|0,x[a>>2]);$q(g+32|0,x[a>>2],x[a+4>>2]);nn(g+24|0,x[m>>2]);b=x[g+48>>2];x[g+8>>2]=x[g+44>>2];x[g+12>>2]=b;d=g+52|0;b=x[g+32>>2];c=x[g+36>>2];f=x[g+24>>2];r=fb-16|0;fb=r;h=x[g+8>>2];e=x[g+28>>2];i=x[g+12>>2];d:{if((e|0)==(i|0)){f=Zb(r+8|0,f,e);k=fb-16|0;fb=k;b=gv(b,c,h,e);x[k+12>>2]=b;c=x[f>>2];e:{if((b|0)<=0){break e}if(e){i=32-e|0;x[k+8>>2]=i;j=b;b=x[Cd(k+8|0,k+12|0)>>2];x[k+12>>2]=j-b;e=-1<<e&-1>>>i-b;x[c>>2]=x[c>>2]&(e^-1)|e&x[h>>2];b=b+x[f+4>>2]|0;x[f+4>>2]=b&31;c=(b>>>3&536870908)+c|0;x[f>>2]=c;h=h+4|0;b=x[k+12>>2]}e=(b|0)/32|0;bZ(h,e,c);b=b-(e<<5)|0;x[k+12>>2]=b;e=e<<2;c=e+x[f>>2]|0;x[f>>2]=c;if((b|0)<=0){break e}b=-1>>>32-b|0;x[c>>2]=x[c>>2]&(b^-1)|b&x[e+h>>2];x[f+4>>2]=x[k+12>>2]}Zb(d,c,x[f+4>>2]);fb=k+16|0;break d}k=d;e=Zb(r,f,e);f=fb-16|0;fb=f;c=gv(b,c,h,i);x[f+12>>2]=c;f:{if((c|0)<=0){b=x[e+4>>2];d=x[e>>2];break f}g:{if(!i){b=x[e+4>>2];break g}l=32-i|0;x[f+8>>2]=l;b=c;c=f+8|0;d=x[Cd(c,f+12|0)>>2];x[f+12>>2]=b-d;b=x[e+4>>2];n=x[h>>2];x[f+8>>2]=d;s=32-b|0;x[f+4>>2]=s;j=x[e>>2];t=x[j>>2];c=x[Hb(c,f+4|0)>>2];l=n&(-1<<i&-1>>>l-d);x[j>>2]=(-1<<b&-1>>>s-c^-1)&t|(b>>>0>i>>>0?l<<b-i:l>>>i-b|0);n=b+c|0;b=n&31;x[e+4>>2]=b;j=j+(n>>>3&536870908)|0;x[e>>2]=j;d=d-c|0;if((d|0)>0){x[j>>2]=x[j>>2]&(-1>>>32-d^-1)|l>>>c+i;x[e+4>>2]=d;b=d}h=h+4|0;c=x[f+12>>2]}i=32-b|0;j=-1<<b;l=j^-1;while(1){if((c|0)>=32){d=x[e>>2];c=x[h>>2];x[d>>2]=l&x[d>>2]|c<<b;x[e>>2]=d+4;x[d+4>>2]=j&x[d+4>>2]|c>>>i;c=x[f+12>>2]-32|0;x[f+12>>2]=c;h=h+4|0;continue}break}d=x[e>>2];if((c|0)<=0){break f}l=x[h>>2];x[f+8>>2]=i;n=x[d>>2];h=x[Cd(f+12|0,f+8|0)>>2];j=n&(j&-1>>>i-h^-1);i=l&-1>>>32-c;x[d>>2]=j|i<<b;c=b+h|0;b=c&31;x[e+4>>2]=b;d=(c>>>3&536870908)+d|0;x[e>>2]=d;c=x[f+12>>2]-h|0;x[f+12>>2]=c;if((c|0)<=0){break f}x[d>>2]=x[d>>2]&(-1>>>32-c^-1)|i>>>h;b=x[f+12>>2];x[e+4>>2]=b}Zb(k,d,b);fb=f+16|0}fb=r+16|0;Zb(q,x[g+52>>2],x[g+56>>2]);lC(a,m);tf(m)}a=Zb(g+16|0,x[q>>2],x[q+4>>2]);Vw(x[a>>2],x[a+4>>2],o,0);break b}x[a+4>>2]=b}fb=g+80|0;return}a=N()|0;tf(m);Q(a|0);p()}function te(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{b:{c:{switch(b|0){case 1:b=Fb(a);d=y[c+11|0];e=x[c+4>>2];a=0;x[31609]=0;O(114,b|0,_c(e,d)|0);d=x[31609];x[31609]=0;d:{if((d|0)!=1){e:{while(1){if(_c(x[c+4>>2],y[c+11|0])>>>0>a>>>0){d=x[Wd(c,a)>>2];x[31609]=0;O(115,b|0,(d>>>0>=128?63:d)<<24>>24);d=x[31609];x[31609]=0;if((d|0)==1){break e}a=a+1|0;continue}break}break d}}break a}return;case 2:b=Fb(a);d=y[c+11|0];e=x[c+4>>2];a=0;x[31609]=0;O(114,b|0,_c(e,d)|0);d=x[31609];x[31609]=0;f:{if((d|0)!=1){g:{while(1){if(_c(x[c+4>>2],y[c+11|0])>>>0>a>>>0){d=x[Wd(c,a)>>2];x[31609]=0;O(115,b|0,(d>>>0>=256?63:d)<<24>>24);d=x[31609];x[31609]=0;if((d|0)==1){break g}a=a+1|0;continue}break}break f}}break a}return;case 3:df(a,c,48864);return;case 4:df(a,c,49888);return;case 5:df(a,c,50912);return;case 6:df(a,c,51936);return;case 7:df(a,c,52960);return;case 8:df(a,c,53984);return;case 9:df(a,c,55008);return;case 10:df(a,c,56032);return;case 11:df(a,c,57056);return;case 12:df(a,c,58080);return;case 13:df(a,c,59104);return;case 14:df(a,c,60128);return;case 15:df(a,c,61152);return;case 16:df(a,c,62176);return;case 17:df(a,c,63200);return;case 18:df(a,c,64224);return;case 19:df(a,c,65248);return;case 20:df(a,c,66272);return;case 21:df(a,c,67296);return;case 22:df(a,c,68320);return;case 23:df(a,c,69344);return;case 24:Dx(a,c,70368);return;case 25:Dx(a,c,48864);return;case 26:Dx(a,c,67296);return;default:a=ac(8);x[31609]=0;b=P(16,a|0,11122)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break b}b=N()|0;ic(a);Q(b|0);p();case 0:break c}}e=fb-16|0;fb=e;f=Fb(a);h:{while(1){i:{j:{k:{if(_c(x[c+4>>2],y[c+11|0])>>>0>g>>>0){b=x[Wd(c,g)>>2];if(b>>>0>=2097152){x[31609]=0;O(115,f|0,63);a=x[31609];x[31609]=0;if((a|0)!=1){break j}break i}a=0;while(1){if((a|0)==6){b=7;a=6;break k}d=b&63;v[(e+10|0)+a|0]=d;if(b>>>0>=64){a=a+1|0;b=b>>>6|0;continue}break}if(a){b=a+1|0;if((b|0)!=2){break k}a=1;b=2;if((d|0)!=1){break k}a=y[e+10|0]|64}else{a=y[e+10|0]}x[31609]=0;O(115,f|0,a<<24>>24);a=x[31609];x[31609]=0;if((a|0)!=1){break j}break i}fb=e+16|0;break h}i=(2<<a)+255<<7-a;d=b-1|0;j=d+(e+10|0)|0;a=b;while(1){if(!a){break j}l:{if((a|0)==(b|0)){a=y[j|0];x[31609]=0;O(115,f|0,(a|i)<<24>>24);h=x[31609];x[31609]=0;a=d;break l}x[31609]=0;a=a-1|0;O(115,f|0,v[a+(e+10|0)|0]|-128);h=x[31609];x[31609]=0}if((h|0)!=1){continue}break}break i}g=g+1|0;continue}break}a=N()|0;tb(f);Q(a|0);p()}return}da(b|0,124672,17);p()}a=N()|0;tb(b);Q(a|0);p()}function kn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=fb+-64|0;fb=e;h=Nb(a);x[31609]=0;a=R(281,b|0)|0;d=x[31609];x[31609]=0;a:{b:{c:{d:{e:{if((d|0)==1){break e}d=x[b+8>>2];c=x[b>>2];x[31609]=0;d=U(150,c|0,d|0,a|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break e}if(d){break d}x[31609]=0;a=R(202,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break e}x[31609]=0;P(183,b|0,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break c}}a=N()|0;break a}x[31609]=0;c=e+24|0;S(185,c|0,b|0,a|0);b=x[31609];x[31609]=0;f:{g:{h:{if((b|0)!=1){d=hc(e+44|0,c);ub(c);if(a>>>0<10){break g}x[31609]=0;b=R(736,d|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break b}if(!b){break g}x[31609]=0;b=R(281,d|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break b}x[e+20>>2]=b;a=a-10|0;xc(e+20|0,a>>>0>25264513?-1:D(a,170));x[31609]=0;c=x[e+20>>2];O(287,h|0,c|0);a=x[31609];x[31609]=0;if((a|0)!=1){break h}break b}a=N()|0;break a}b=0;i:while(1){f=0;j:{k:{while(1){if(f){break j}a=x[d+8>>2];f=x[d>>2];x[31609]=0;a=P(737,f|0,a|0)|0;f=x[31609];x[31609]=0;l:{m:{n:{o:{if((f|0)!=1){if(a){break j}x[31609]=0;a=R(534,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break b}f=1;switch(a|0){case 3:break l;case 2:break m;case 1:break n;case 0:break o;default:continue}}break b}x[31609]=0;a=R(197,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}if(a>>>0>c>>>0){continue}g=x[d+8>>2];i=x[d>>2];x[31609]=0;g=U(150,i|0,g|0,a|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break b}if(!g){continue}se(e+24|0,x[h>>2],x[h+4>>2]);vr(e+8|0,x[e+24>>2],x[e+28>>2],b,a);x[31609]=0;Zn(471,e,d,x[e+8>>2],x[e+12>>2]);f=x[31609];x[31609]=0;if((f|0)!=1){c=c-a|0;b=a+b|0;continue i}break b}x[31609]=0;a=R(197,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}g=a<<2;if(g>>>0>c>>>0){continue}x[31609]=0;i=P(738,d|0,e+16|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break b}if(!i){continue}while(1){if(!(a&255)){break k}f=e+16|0;i=gc(f);rv(f,i,uf(wb(x[h>>2]),b));b=b+4|0;a=a-1|0;continue}}if(c>>>0<8){continue}x[31609]=0;a=e+16|0;g=P(738,d|0,a|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break b}if(!g){continue}f=gc(a);rv(a,f,uf(wb(x[h>>2]),b));rv(a,f,uf(uf(wb(x[h>>2]),b),4));c=c-8|0;b=b+8|0;continue i}x[31609]=0;a=R(197,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}if(a>>>0>c>>>0){continue}break}c=c-a|0;b=a+b|0;continue}c=c-g|0;continue}break}if(!c){break f}Nb(ec(h));break f}x[31609]=0;S(333,d|0,h|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}}ub(d)}fb=e- -64|0;return}a=N()|0;ub(d)}ec(h);Q(a|0);p()}function qP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=fb-192|0;fb=d;f=x[b+4>>2];a:{if(!f){break a}e=x[b>>2];g=y[Al(e,f)|0];if((g|0)==33){c=1}else{if((g|0)!=63){break a}c=0}Nl(d+168|0,e,f,f-1|0);f=x[d+172>>2];e=x[d+168>>2];x[b>>2]=e;x[b+4>>2]=f}e=d+168|0;ie(e);g=x[d+168>>2];ie(d+156|0);g=zl(g,x[d+160>>2],b);ie(e);b:{c:{d:{e:{if((g|0)==x[d+172>>2]){a=x[b>>2];g=qc(d+184|0,22292);h=x[g+4>>2];x[d>>2]=x[g>>2];x[d+4>>2]=h;if(Ic(a,f,d)){a=ac(8);x[31609]=0;c=P(36,e|0,10498)|0;b=x[31609];x[31609]=0;if((b|0)==1){break d}pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break c}e=0;if(!c){break e}a=ac(8);c=x[b+4>>2];b=x[b>>2];x[31609]=0;f=bi(d+156|0,b,c);b=x[31609];x[31609]=0;f:{g:{h:{if((b|0)!=1){x[31609]=0;e=d+168|0;S(1011,e|0,18307,f|0);b=x[31609];x[31609]=0;if((b|0)==1){break h}pc(a,e);c=0;x[31609]=0;S(97,a|0,48428,1e3);b=x[31609];x[31609]=0;if((b|0)!=1){break b}b=N()|0;tb(e);break g}b=N()|0;break f}b=N()|0;c=1}tb(f);if(!c){break c}}ic(a);break c}if(x[g+4>>2]){a=ac(8);x[31609]=0;c=P(36,d+168|0,11600)|0;b=x[31609];x[31609]=0;if((b|0)!=1){pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break c}b=N()|0;ic(a);break c}b=x[b>>2];c=qc(d+148|0,22292);e=x[c+4>>2];x[d+72>>2]=x[c>>2];x[d+76>>2]=e;if(Ic(b,f,d+72|0)){a=ac(8);x[31609]=0;c=P(36,d+168|0,10498)|0;b=x[31609];x[31609]=0;if((b|0)!=1){pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break c}b=N()|0;ic(a);break c}c=qc(d+140|0,7462);e=x[c+4>>2];x[d+64>>2]=x[c>>2];x[d+68>>2]=e;i:{if(!Ic(b,f,d- -64|0)){c=qc(d+132|0,7444);e=x[c+4>>2];x[d+56>>2]=x[c>>2];x[d+60>>2]=e;if(!Ic(b,f,d+56|0)){break i}}e=y[a+60|0]!=0;break e}c=qc(d+124|0,6989);e=x[c+4>>2];x[d+48>>2]=x[c>>2];x[d+52>>2]=e;j:{if(!Ic(b,f,d+48|0)){c=qc(d+116|0,6970);e=x[c+4>>2];x[d+40>>2]=x[c>>2];x[d+44>>2]=e;if(!Ic(b,f,d+40|0)){break j}}e=y[a+61|0]!=0;break e}c=qc(d+108|0,7073);e=x[c+4>>2];x[d+32>>2]=x[c>>2];x[d+36>>2]=e;if(Ic(b,f,d+32|0)){e=y[a+62|0]!=0;break e}c=qc(d+100|0,6064);e=x[c+4>>2];x[d+24>>2]=x[c>>2];x[d+28>>2]=e;if(Ic(b,f,d+24|0)){e=y[a+63|0]!=0;break e}c=qc(d+92|0,7511);e=x[c+4>>2];x[d+16>>2]=x[c>>2];x[d+20>>2]=e;if(Ic(b,f,d+16|0)){e=y[a+64|0]!=0;break e}c=qc(d+84|0,13525);e=x[c+4>>2];x[d+8>>2]=x[c>>2];x[d+12>>2]=e;e=0;if(!Ic(b,f,d+8|0)){break e}e=x[x[a+24>>2]+24668>>2]!=0}fb=d+192|0;return e|0}b=N()|0;ic(a)}Q(b|0)}p()}function qka(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;x[a+24588>>2]=0;x[a+24592>>2]=0;x[a+8>>2]=41968;x[a+4>>2]=0;x[a>>2]=30512;b=a+24596|0;x[b>>2]=0;x[b+4>>2]=0;Tq(a+24604|0);zS(a+24648|0,0);x[a+397448>>2]=0;x[a+397452>>2]=0;b=a+397456|0;x[b>>2]=8;x[b+4>>2]=0;x[b+16>>2]=0;x[b+20>>2]=0;v[b+12|0]=0;x[b+8>>2]=0;w[b+24>>1]=0;Rb(b+28|0,0,40);Rb(b+68|0,0,49824);Rb(b+49892|0,0,32832);v[a+480224|0]=0;w[a+480212>>1]=0;x[a+480204>>2]=0;x[a+480208>>2]=0;x[a+480180>>2]=0;x[a+480184>>2]=0;b=a+480186|0;w[b>>1]=0;w[b+2>>1]=0;w[b+4>>1]=0;w[b+6>>1]=0;x[a+480240>>2]=65536;x[a+480244>>2]=65536;f=Nb(a+480248|0);x[a+480272>>2]=0;c=480280;while(1){b=a+c|0;v[b+8|0]=0;x[b>>2]=0;x[b+4>>2]=4194432;lF(b+9|0);c=c+32|0;if((c|0)!=484344){continue}break}d=Nb(a+484344|0);x[d+12>>2]=a;x[31609]=0;g=P(848,a+484360|0,a|0)|0;b=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((b|0)!=1){c=484380;while(1){x[31609]=0;R(709,a+c|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break i}c=c+104|0;if((c|0)!=900380){continue}break}x[31609]=0;R(849,a+901404|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break h}e=a+906300|0;c=0;while(1){tS(c+e|0);c=c+160|0;if((c|0)!=4e4){continue}break}x[a+946300>>2]=0;c=946304;while(1){ev(a+c|0);c=c+32|0;if((c|0)!=1074304){continue}break}x[a+1074304>>2]=0;x[a+1074308>>2]=0;bs(a+1074312|0);x[31609]=0;X(850);b=x[31609];x[31609]=0;if((b|0)==1){break g}r=a,s=sS(),x[r+1074328>>2]=s;b=a+1074332|0;x[b+12>>2]=1065353216;jS(b,4);x[31609]=0;c=R(851,a+1074376|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break g}x[31609]=0;h=U(604,a+1298264|0,a|0,255)|0;b=x[31609];x[31609]=0;if((b|0)==1){break f}i=tc(a+1298300|0);j=tc(a+1298304|0);k=Fb(a+1298308|0);l=Fb(a+1298320|0);m=Fb(a+1298332|0);n=yS(a+1298344|0);o=Nb(a+1298412|0);v[a+1298424|0]=0;b=a+1298432|0;x[b>>2]=0;x[b+4>>2]=0;x[b+32>>2]=0;x[b+36>>2]=1072693248;x[b+24>>2]=0;x[b+28>>2]=0;x[b+16>>2]=0;x[b+20>>2]=0;x[b+8>>2]=0;x[b+12>>2]=0;x[a+1298472>>2]=0;Cq(a+12|0);VA(a+8204|0);VA(a+12300|0);b=a+1074408|0;x[b>>2]=4;x[b+4>>2]=16;x[a+480216>>2]=4;x[a+480220>>2]=16;Rb(a+900380|0,0,1024);rS(a+946304|0);x[31609]=0;b=R(852,12)|0;q=x[31609];x[31609]=0;if((q|0)==1){break e}x[b>>2]=0;x[b+4>>2]=0;x[b+8>>2]=0;r=a,s=Nb(b),x[r+4>>2]=s;return a|0}a=N()|0;break a}a=N()|0;break b}a=N()|0;break b}a=N()|0;break c}a=N()|0;break d}a=N()|0;xS(o);YA(n);tb(m);tb(l);tb(k);XA(j);WA(i);Ru(h)}kB(c)}wS(e)}$B(g)}oS(d);wc(f);Q(a|0);p()}function zaa(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=fb-160|0;fb=d;x[d+156>>2]=c;a:{b:{c:{if(b>=.8){x[31609]=0;c=ca(1194)|0;e=x[31609];x[31609]=0;d:{e:{f:{if((e|0)!=1){x[d+72>>2]=c;x[31609]=0;e=R(1195,x[d+156>>2])|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}x[d+152>>2]=e;uo(c,e);a=Ie(d+132|0,a);x[31609]=0;e=x[a+12>>2];x[d+56>>2]=x[a+8>>2];x[d+60>>2]=e;x[d- -64>>2]=x[a+16>>2];e=x[a+4>>2];x[d+48>>2]=x[a>>2];x[d+52>>2]=e;a=U(1155,c|0,d+48|0,15)|0;c=x[31609];x[31609]=0;if((c|0)==1){break f}if(a){x[31609]=0;W(853,x[d+72>>2]);a=x[31609];x[31609]=0;g=1;if((a|0)==1){break f}}vh(d+152|0);wh(d+72|0);break b}c=T(0)|0;break c}c=T(0)|0;vh(d+152|0);break d}c=T(0)|0}wh(d+72|0);break c}if(b>=.6){x[31609]=0;c=ca(1194)|0;e=x[31609];x[31609]=0;g:{h:{i:{if((e|0)!=1){x[d+72>>2]=c;x[31609]=0;e=R(1195,x[d+156>>2])|0;f=x[31609];x[31609]=0;if((f|0)==1){break h}x[d+152>>2]=e;uo(c,e);a=Ie(d+112|0,a);x[31609]=0;e=x[a+12>>2];x[d+32>>2]=x[a+8>>2];x[d+36>>2]=e;x[d+40>>2]=x[a+16>>2];e=x[a+4>>2];x[d+24>>2]=x[a>>2];x[d+28>>2]=e;a=U(1155,c|0,d+24|0,2)|0;c=x[31609];x[31609]=0;if((c|0)==1){break i}if(a){x[31609]=0;W(853,x[d+72>>2]);a=x[31609];x[31609]=0;g=.8;if((a|0)==1){break i}}vh(d+152|0);wh(d+72|0);break b}c=T(0)|0;break c}c=T(0)|0;vh(d+152|0);break g}c=T(0)|0}wh(d+72|0);break c}g=.2;if(b>=.2){x[31609]=0;c=ca(1194)|0;e=x[31609];x[31609]=0;j:{k:{l:{if((e|0)!=1){x[d+72>>2]=c;x[31609]=0;e=R(1195,x[d+156>>2])|0;f=x[31609];x[31609]=0;if((f|0)==1){break k}x[d+152>>2]=e;uo(c,e);a=Ie(d+92|0,a);x[31609]=0;e=x[a+12>>2];x[d+8>>2]=x[a+8>>2];x[d+12>>2]=e;x[d+16>>2]=x[a+16>>2];e=x[a+4>>2];x[d>>2]=x[a>>2];x[d+4>>2]=e;a=U(1155,c|0,d|0,64)|0;c=x[31609];x[31609]=0;if((c|0)==1){break l}g=0;if(a){x[31609]=0;W(853,x[d+72>>2]);a=x[31609];x[31609]=0;g=.6;if((a|0)==1){break l}}vh(d+152|0);wh(d+72|0);break b}c=T(0)|0;break c}c=T(0)|0;vh(d+152|0);break j}c=T(0)|0}wh(d+72|0);break c}if(!(b>=.1)){break b}x[31609]=0;c=d+72|0;S(186,c|0,a|0,2048);e=x[31609];x[31609]=0;if((e|0)!=1){e=Ze(c);a=x[a>>2];x[31609]=0;f=x[d+72>>2];a=R(154,a|0)|0;h=x[31609];x[31609]=0;m:{if((h|0)==1){break m}x[31609]=0;a=eI(1196,3,0,e,f,a,0);e=x[31609];x[31609]=0;if((e|0)==1){break m}g=C[(a<<3)+79272>>3];Kc(c);break b}c=T(0)|0;Kc(d+72|0);break c}c=T(0)|0}Y(c|0)|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;g=0;if((a|0)==1){break a}}Wc(d+156|0);fb=d+160|0;return+g}a=N()|0;Wc(d+156|0);Q(a|0);p()}function ES(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=fb-48|0;fb=h;j=fb-16|0;fb=j;x[j>>2]=b;x[j+4>>2]=c;g=fb-16|0;fb=g;e=fb-16|0;fb=e;d=vb(e+12|0,Jua(x[j>>2],x[j+4>>2],500654080,20));fb=e+16|0;e=fb-16|0;fb=e;k=x[d>>2];f=BS(e+8|0,k);fb=e+16|0;e=x[j>>2];d=x[f>>2];i=x[j+4>>2];f=x[f+4>>2];if(((d|0)!=(e|0)|(f|0)!=(i|0)?e>>>0>d>>>0&(i|0)>=(f|0)|(f|0)<(i|0)?-1:1:0)<<24>>24>0){d=x[vb(g+12|0,1)>>2];e=fb-16|0;fb=e;k=x[vb(e+12|0,k-d|0)>>2];fb=e+16|0}fb=g+16|0;l=x[vb(j+12|0,k)>>2];fb=j+16|0;k=fb-16|0;fb=k;j=fb-16|0;fb=j;d=l+719468|0;e=(((l|0)>-719469?d:l+573372|0)|0)/146097|0;i=D(e,-146097)+d|0;d=((i>>>0)/36524|0)+i-(((i>>>0)/146096|0)+((i>>>0)/1460|0))|0;f=(d>>>0)/365|0;i=((i-((d>>>0)/1460|0)|0)+((d>>>0)/36500|0)|0)+D(f,-365)|0;d=D(i,5)+2|0;g=(d>>>0)/153|0;d=g+(d>>>0<1530?3:-9)|0;f=Lw(j+14|0,(f+D(e,400)|0)+(d>>>0<3)|0);e=iq(j+13|0,d);d=iq(j+12|0,(i-((D(g,153)+2>>>0)/5|0)|0)+1|0);AS(k+12|0,z[f>>1],e,d);fb=j+16|0;d=x[k+12>>2];w[h+44>>1]=d;w[h+46>>1]=d>>>16;fb=k+16|0;f=fb-16|0;fb=f;e=BS(f,l);d=x[e>>2];c=ye(f+8|0,b-d|0,c-(x[e+4>>2]+(b>>>0<d>>>0)|0)|0);b=x[c>>2];fb=f+16|0;i=fb-16|0;fb=i;c=x[c+4>>2];d=ZA(i+8|0,0);m=h,n=vd(CS(b,c,x[d>>2],x[d+4>>2])),v[m+8|0]=n;f=fb-16|0;fb=f;e=ye(f+8|0,0,0);d=x[e>>2];fb=f+16|0;if(CS(b,c,d,x[e+4>>2])<<24>>24<0){d=fb-16|0;fb=d;c=ye(d+8|0,0-b|0,0-(((b|0)!=0)+c|0)|0);b=x[c>>2];fb=d+16|0;c=x[c+4>>2]}d=fb-16|0;fb=d;e=x[vb(d+12|0,Jua(b,c,-694967296,0))>>2];fb=d+16|0;x[h+12>>2]=e;g=fb-16|0;fb=g;f=fb-16|0;fb=f;d=ye(f+8|0,Iua(e,e>>31,-694967296,0),hb);e=x[d>>2];d=x[d+4>>2];fb=f+16|0;x[g>>2]=e;x[g+4>>2]=d;d=x[g>>2];b=ye(g+8|0,b-d|0,c-(x[g+4>>2]+(b>>>0<d>>>0)|0)|0);f=x[b>>2];b=x[b+4>>2];d=b;fb=g+16|0;c=fb-16|0;fb=c;b=x[vb(c+12|0,Jua(f,b,6e7,0))>>2];fb=c+16|0;x[h+16>>2]=b;g=fb-16|0;fb=g;e=fb-16|0;fb=e;b=ye(e+8|0,Iua(b,b>>31,6e7,0),hb);c=x[b>>2];b=x[b+4>>2];fb=e+16|0;x[g>>2]=c;x[g+4>>2]=b;b=x[g>>2];b=ye(g+8|0,f-b|0,d-(x[g+4>>2]+(b>>>0>f>>>0)|0)|0);f=x[b>>2];b=x[b+4>>2];d=b;fb=g+16|0;c=_A(f,b);x[h+24>>2]=c;b=hb;x[h+28>>2]=b;e=fb-16|0;fb=e;c=Gu(e,c,b);b=x[c>>2];c=ye(e+8|0,f-b|0,d-(x[c+4>>2]+(b>>>0>f>>>0)|0)|0);b=x[c>>2];fb=e+16|0;m=h,n=$Q(b,x[c+4>>2]),x[m+32>>2]=n;x[h+36>>2]=hb;fb=i+16|0;b=DS(a);x[b>>2]=z[h+44>>1]<<16>>16;m=b,n=zf(y[h+46|0]),x[m+4>>2]=n;m=b,n=zf(y[h+47|0]),x[m+8>>2]=n;x[b+12>>2]=x[h+12>>2];x[b+16>>2]=x[h+16>>2];a=x[h+28>>2];x[b+24>>2]=x[h+24>>2];x[b+28>>2]=a;fb=h+48|0}function Jna(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=fb+-64|0;fb=d;w[d+62>>1]=c;Hf(d+62|0,32);j=Nb(a);x[31609]=0;n=z[d+62>>1];O(538,j|0,n|0);a=x[31609];x[31609]=0;a:{b:{if((a|0)!=1){while(1){c:{d:{if((o&65535)>>>0<n>>>0){f=1;c=z[b+480190>>1];a=c+1|0;w[d+60>>1]=a;if((a&65535)>>>0<4e3){break d}e:{while(1){g=f&65535;if(g>>>0>c>>>0){break e}f:{e=oi(b,g);if(!le(x[e>>2],x[e+20>>2])){if(!Ib(NC(wb(x[j>>2]),wb(x[j+4>>2]),f),wb(x[j+4>>2]))){break f}c=z[b+480190>>1]}f=f+1|0;continue}break}w[d+60>>1]=f;a=1;while(1){c=a&65535;if(c>>>0>z[b+480192>>1]){a=f}else{g:{c=x[((c<<2)+b|0)+900380>>2];if(!c){break g}c=c+236|0;e=tr(c);while(1){if((c|0)==(e|0)){break g}if((g|0)==z[c>>1]){w[c>>1]=0}c=c+2|0;continue}}a=a+1|0;continue}break}}if((a&65535)>>>0<4e3){break d}f=So(d+48|0);x[31609]=0;a=P(777,b|0,f|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break b}if(a){x[31609]=0;O(778,b|0,f|0);c=x[31609];x[31609]=0;a=1;if((c|0)==1){break b}while(1){c=a&65535;if(c>>>0<=z[b+480192>>1]){h:{c=x[((c<<2)+b|0)+900380>>2];if(!c){break h}c=c+236|0;g=tr(c);while(1){if((c|0)==(g|0)){break h}e=z[c>>1];i:{if(e>>>0>=A[d+52>>2]){break i}Jb(d+40|0,x[f>>2],e);if(Gb(x[x[d+40>>2]>>2],x[d+44>>2])){break i}w[c>>1]=0}c=c+2|0;continue}}a=a+1|0;continue}break}nn(d+24|0,x[f>>2]);DV(d+32|0,x[d+24>>2],x[d+28>>2],1);$q(d+16|0,x[f>>2],x[d+52>>2]);l=fb-16|0;fb=l;g=d+40|0;e=Zb(l,x[d+32>>2],x[d+36>>2]);a=gv(x[d+16>>2],x[d+20>>2],x[d+32>>2],x[d+36>>2]);c=fb-16|0;fb=c;x[c+12>>2]=a;h=x[e+4>>2];j:{if(h){i=32-h|0;x[c+8>>2]=i;m=x[Hb(c+8|0,c+12|0)>>2];k=-1<<h&-1>>>i-m;i=x[e>>2];k=k&(x[i>>2]^-1);if(k){Zb(g,i,Hua(k));break j}if((a|0)==(m|0)){DV(g,i,h,a);break j}a=a-m|0;x[c+12>>2]=a;x[e>>2]=i+4}while(1){if(a>>>0>=32){h=x[e>>2];i=x[h>>2];if((i|0)!=-1){Zb(g,h,Hua(i^-1));break j}else{x[e>>2]=h+4;a=a-32|0;x[c+12>>2]=a;continue}}break}e=x[e>>2];if(!a){Zb(g,e,0);break j}h=(x[e>>2]^-1)&-1>>>32-a;if(!h){Zb(g,e,a);break j}Zb(g,e,Hua(h))}fb=c+16|0;fb=l+16|0;nn(d+8|0,x[f>>2]);a=gv(x[d+40>>2],x[d+44>>2],x[d+8>>2],x[d+12>>2]);w[d+60>>1]=a;tf(f);if((a&65535)>>>0<4e3){break d}break c}tf(f)}fb=d- -64|0;return}x[31609]=0;O(257,j|0,d+60|0);c=x[31609];x[31609]=0;if((c|0)!=1){if(z[b+480190>>1]>=(a&65535)>>>0){break c}w[b+480190>>1]=a;break c}c=N()|0;break a}o=o+1|0;continue}}c=N()|0;break a}c=N()|0;tf(f)}od(j);Q(c|0);p()}function AV(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=fb-32|0;fb=c;e=y[a+13|0];a:{if(e&227|(e&24)==16){break a}e=y[a+8|0];f=y[a+6|0]|y[a+7|0]<<8;v[c+22|0]=0;v[c+26|0]=e;w[c+24>>1]=f;w[c+20>>1]=0;while(1){if((d|0)!=3){e=xb(c+24|0,d);h=xb(c+20|0,d),i=y[e|0],v[h|0]=i;d=d+1|0;continue}break}e=cg(c+20|0);f=y[a+11|0];g=y[a+9|0]|y[a+10|0]<<8;d=0;v[c+18|0]=0;v[c+26|0]=f;w[c+24>>1]=g;w[c+16>>1]=0;while(1){if((d|0)!=3){f=xb(c+24|0,d);h=xb(c+16|0,d),i=y[f|0],v[h|0]=i;d=d+1|0;continue}break}d=0;if(cg(c+16|0)>>>0<e>>>0){break a}e=a+6|0;d=a+9|0;f=y[d+2|0];g=y[d|0]|y[d+1|0]<<8;d=0;v[c+22|0]=0;v[c+26|0]=f;w[c+24>>1]=g;w[c+20>>1]=0;while(1){if((d|0)!=3){f=xb(c+24|0,d);h=xb(c+20|0,d),i=y[f|0],v[h|0]=i;d=d+1|0;continue}break}f=cg(c+20|0);g=y[e+2|0];e=y[e|0]|y[e+1|0]<<8;d=0;v[c+18|0]=0;v[c+26|0]=g;w[c+24>>1]=e;w[c+16>>1]=0;while(1){if((d|0)!=3){e=xb(c+24|0,d);h=xb(c+16|0,d),i=y[e|0],v[h|0]=i;d=d+1|0;continue}break}e=cg(c+16|0);b:{if(!((b|0)==2|(e|0)==(f|0))){d=0;if((y[a+14|0]|y[a+15|0]<<8)>>>0>=100){break b}break a}if((e|0)==(f|0)|(b|0)!=2){break b}d=0;if((y[a+14|0]|y[a+15|0]<<8)<<16>>16<0){break a}}b=y[a+13|0];e=f-e|0;if(e&1){d=0;if(b&4){break a}}c:{if(b&8){b=y[a+5|0];f=y[a+3|0]|y[a+4|0]<<8;d=0;v[c+22|0]=0;w[c+24>>1]=f;v[c+26|0]=b;w[c+20>>1]=0;while(1){if((d|0)!=3){b=xb(c+24|0,d);h=xb(c+20|0,d),i=y[b|0],v[h|0]=i;d=d+1|0;continue}break}if(!cg(c+20|0)){break c}}b=y[a+5|0];f=y[a+3|0]|y[a+4|0]<<8;d=0;v[c+22|0]=0;v[c+26|0]=b;w[c+24>>1]=f;w[c+20>>1]=0;while(1){if((d|0)!=3){b=xb(c+24|0,d);h=xb(c+20|0,d),i=y[b|0],v[h|0]=i;d=d+1|0;continue}break}if(cg(c+20|0)){b=a+3|0;f=y[b+2|0];g=y[b|0]|y[b+1|0]<<8;d=0;v[c+18|0]=0;w[c+24>>1]=g;v[c+26|0]=f;w[c+16>>1]=0;while(1){if((d|0)!=3){f=xb(c+24|0,d);h=xb(c+16|0,d),i=y[f|0],v[h|0]=i;d=d+1|0;continue}break}if(cg(c+16|0)>>>0>=e>>>0){break c}e=y[a+2|0];a=y[a|0]|y[a+1|0]<<8;d=0;v[c+14|0]=0;w[c+24>>1]=a;v[c+26|0]=e;w[c+12>>1]=0;while(1){if((d|0)!=3){a=xb(c+24|0,d);h=xb(c+12|0,d),i=y[a|0],v[h|0]=i;d=d+1|0;continue}break}a=cg(c+12|0);e=y[b+2|0];b=y[b|0]|y[b+1|0]<<8;d=0;v[c+10|0]=0;v[c+26|0]=e;w[c+24>>1]=b;w[c+8>>1]=0;while(1){if((d|0)!=3){b=xb(c+24|0,d);h=xb(c+8|0,d),i=y[b|0],v[h|0]=i;d=d+1|0;continue}break}d=0;if(cg(c+8|0)>>>0<=a>>>0){break a}}d=1;break a}d=0}fb=c+32|0;return d}function q_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;g=fb-80|0;fb=g;a:{b:{c:{d:{e:{f:{g:{if(Ad(x[b+4>>2],y[b+11|0])){Fb(a);break g}k=Nb(g+68|0);x[g+56>>2]=0;x[g+60>>2]=0;h=x[c>>2];x[31609]=0;n=R(38,h|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break b}h=Kb(b);i=Cb(x[b+4>>2],y[b+11|0]);j=Lk(n);f=fb-16|0;fb=f;x[f+12>>2]=j;x[f+8>>2]=0;j=x[Xe(f+8|0,f+12|0)>>2];fb=f+16|0;x[31609]=0;O(39,k|0,D(i,j+1|0)|0);f=x[31609];x[31609]=0;if((f|0)==1){break c}o=(i<<2)+h|0;i=x[k>>2];m=i+Xc(i,x[k+4>>2])|0;q=(d|0)!=2;h:{while(1){i:{j:{k:{l:{if(!q){while(1){x[g+48>>2]=0;x[g+52>>2]=0;x[31609]=0;f=h+4|0;j=za(40,n|0,g+56|0,h|0,f|0,g+52|0,i|0,m|0,g+48|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break f}if((j|0)!=1){break l}if((f|0)!=x[g+52>>2]){l=1;break k}else{i=x[g+48>>2];h=f;continue}}}x[g+48>>2]=0;x[g+52>>2]=0;x[31609]=0;j=za(40,n|0,g+56|0,h|0,o|0,g+52|0,i|0,m|0,g+48|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break d}l=1;if((j|0)==1){break k}}l=2;f=x[g+48>>2];if((j|0)!=2|(m|0)!=(f|0)){break j}}h=x[k+4>>2];f=x[k>>2];x[31609]=0;O(39,k|0,Xc(f,h)<<1);h=x[31609];x[31609]=0;if((h|0)==1){break d}h=x[k>>2];f=x[g+48>>2];i=h+(f-i|0)|0;m=Xc(h,x[k+4>>2])+h|0;j=l;break i}m:{n:{o:{p:{q:{switch(d|0){case 0:if(x[g+52>>2]!=(h|0)|(f|0)!=(i|0)|(j|0)!=2){break p}x[31609]=0;v[g+47|0]=1;h=P(41,g+8|0,22296)|0;f=x[31609];x[31609]=0;r:{s:{t:{if((f|0)!=1){x[31609]=0;f=g+20|0;S(42,f|0,h|0,b|0);i=x[31609];x[31609]=0;if((i|0)==1){break t}x[31609]=0;i=g+32|0;aa(43,i|0,f|0,c|0,1,g+47|0);l=x[31609];x[31609]=0;if((l|0)==1){break s}tb(i);Ub(f);Ub(h);if(y[g+47|0]){break o}x[31609]=0;aa(43,a|0,b|0,c|0,2,0);a=x[31609];x[31609]=0;if((a|0)!=1){break h}f=N()|0;break a}f=N()|0;break a}f=N()|0;break r}f=N()|0;Ub(g+20|0)}Ub(h);break a;case 1:break q;default:break p}}v[e|0]=(j|0)!=2|x[g+52>>2]!=(h|0)|(f|0)!=(i|0);Fb(a);break h}if((j|0)==2){break n}break m}f=x[g+48>>2]}x[g+52>>2]=x[g+52>>2]+4;v[f|0]=63;f=x[g+48>>2]+1|0;x[g+48>>2]=f}i=f}h=x[g+52>>2];l=o>>>0>h>>>0;if(l&f>>>0<m>>>0&(j|0)==2|l&(d|0)==2){continue}break}b=x[k>>2];x[31609]=0;U(44,a|0,b|0,f|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}}ec(k)}fb=g+80|0;return}f=N()|0;break a}f=N()|0;break a}f=N()|0;break a}f=N()|0;break a}f=N()|0}ec(k);Q(f|0);p()}function o1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=fb-368|0;fb=e;yc(b);d=fb-16|0;fb=d;g=e+330|0;iF(d+8|0,g);h=x[d+12>>2];lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2]);i=x[d+4>>2];if((i|0)==(h|0)){Vb(b,x[d+12>>2])}fb=d+16|0;d=(h|0)==(i|0);if(!d){hF(g)}a:{if(!d){break a}if(!kF(g)){break a}if(!Mb(x[b>>2],x[b+8>>2],Bc(jF(y[e+365|0]),hb))){break a}f=1;if((c|0)==64){break a}Dd(a,2097152);eg(a);Wh(a,1);w[a+480188>>1]=8;x[a+480196>>2]=y[e+362|0];x[a+480204>>2]=D(y[e+363|0],1e4);w[a+480190>>1]=y[e+364|0];d=y[e+367|0];if(d>>>0<y[e+366|0]){$e(Xb(x[a+484360>>2],y[a+484376|0]),d)}d=e- -64|0;f=uc(d,6554);zb(a+1298344|0,f);tb(f);f=uc(d,11164);zb(a+1298356|0,f);tb(f);n=a+1298404|0,o=x[Fc(d,4)>>2],x[n>>2]=o;Hw(b,d);Pr(Xb(x[a+484360>>2],y[a+484376|0]),d,y[e+366|0],65535,65535);f=1;while(1){i=f&65535;if(i>>>0>z[a+480190>>1]){Vb(b,D(64-y[e+364|0]|0,37));h=a+484344|0;Tf(h,y[e+365|0]);i=c&1;f=0;while(1){b:{c:{if(y[e+365|0]<=f>>>0){if(!(c&2)){break c}c=Zc(e+24|0,8,1,0,0);f=1;while(1){d=f&65535;if(d>>>0>z[a+480190>>1]){break c}dg(c,(D(d,104)+a|0)+484380|0,b);f=f+1|0;continue}}d:{if(i){if(Pg(h,f&65535,64)){break d}}Vb(b,2048);break b}d=Wb(x[h>>2],f);n=e,o=wb(x[d>>2]),x[n+24>>2]=o;j=wb(x[d+4>>2]);while(1){d=x[e+24>>2];if(!Ib(d,j)){break b}g=e+12|0;mm(g,b);l=Jc(g);m=_e(g);g=_i(g);k=y[e+12|0];if((k-1&255)>>>0<=106){v[d|0]=k+13}v[d+1|0]=y[l|0];Cf(d,y[m|0],y[g|0]);tg(e+24|0);continue}}f=1;break a}f=f+1|0;continue}}else{d=e+24|0;gF(b,d);h=fb-16|0;fb=h;g=(D(i,104)+a|0)+484380|0;nd(g,0);v[g+37|0]=y[d+22|0]<<4;v[h+15|0]=y[d+23|0];v[h+14|0]=64;n=g,o=y[Qb(h+15|0,h+14|0)|0]<<2,w[n+30>>1]=o;v[g+36|0]=y[d+24|0];x[g>>2]=y[d+25|0]|y[d+26|0]<<8|(y[d+27|0]<<16|y[d+28|0]<<24);j=y[d+33|0]|y[d+34|0]<<8|(y[d+35|0]<<16|y[d+36|0]<<24);if(!(j>>>0<3|j+(y[d+29|0]|y[d+30|0]<<8|(y[d+31|0]<<16|y[d+32|0]<<24))>>>0>(y[d+25|0]|y[d+26|0]<<8|(y[d+27|0]<<16|y[d+28|0]<<24))>>>0)){w[g+34>>1]=z[g+34>>1]|2;x[g+4>>2]=y[d+29|0]|y[d+30|0]<<8|(y[d+31|0]<<16|y[d+32|0]<<24);x[g+8>>2]=(y[d+33|0]|y[d+34|0]<<8|(y[d+35|0]<<16|y[d+36|0]<<24))+(y[d+29|0]|y[d+30|0]<<8|(y[d+31|0]<<16|y[d+32|0]<<24))}fb=h+16|0;Sk(e,2,d);d=e+12|0;Cc(d,e);Ac(((i<<5)+a|0)+946304|0,d);f=f+1|0;tb(d);continue}}}fb=e+368|0;return f|0}function Yu(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=fb-16|0;fb=i;g=x[a+24>>2];h=NB(g,y[a+32|0]);k=x[h>>2];a:{if($c(k,x[h+4>>2])>>>0<=b>>>0){break a}if(jU(x[g+484344>>2],x[g+484348>>2],z[bc(k,b)>>1])>>>0<=c>>>0){break a}h=x[a>>2];b:{if(Ud(h,x[a+4>>2])>>>0>b>>>0){if(A[Vd(h,b)+4>>2]>c>>>0){break b}}Lo(a,0);if(Ud(x[a>>2],x[a+4>>2])>>>0<=b>>>0){break a}g=x[a+24>>2]}cc(i,x[d>>2],z[g+480188>>1]);h=i+8|0;l=x[i>>2];d=e?-2046629010:-2078137563;k=e?-1352371636:-873292572;e=x[i+4>>2];while(1){if(!f&(e|0)==(j|0)){x[h>>2]=d;x[h+4>>2]=k}else{g=y[kW(l,j)+841|0];m=g^Iua(d^j,f^k,435,256);g=!g;d=(q=d,r=Iua(m,hb,435,256),s=g,s?q:r);k=g?k:hb;j=j+1|0;f=j?f:f+1|0;continue}break}g=0;d=dn(i,b,c);f=fb-16|0;fb=f;k=a+12|0;e=k;j=$T(z[d>>1],x[d+4>>2],de(e),gc(e));c:{if(Ib(j,pg(e))){m=z[d>>1];l=x[d+4>>2];d=ud(j);if(!Pl(m,l,z[d>>1],x[d+4>>2])){break c}}j=pg(e)}d=x[vb(f+12|0,j)>>2];fb=f+16|0;if(Zg(d,Pf(k))){e=ud(d);g=mc(x[e+8>>2],x[e+12>>2])^1}l=x[h>>2]!=-2078137563|x[h+4>>2]!=-873292572;Jb(i,x[Vd(x[a>>2],b)>>2],c);j=1;o=Gb(x[x[i>>2]>>2],x[i+4>>2])^1;e=g|l;if(!(o|e)){break a}d:{e:{f:{g:{if(g){n=ud(d);d=wb(x[n+8>>2]);m=d;e=wb(x[n+12>>2]);f=x[h>>2];p=x[h+4>>2];while(1){h:{i:{if((d|0)!=(e|0)){if(!ao(x[d>>2],x[d+4>>2],f,p)){break i}}else{d=e}break h}d=d+8|0;continue}break}e=fb-16|0;fb=e;x[e+12>>2]=m;x[e+12>>2]=x[e+12>>2]+(d-m&-8);fb=e+16|0;if(Ib(x[e+12>>2],wb(x[n+12>>2]))){break a}if(!l){break e}break g}if(l){break g}if(!e){break d}break f}x[a+28>>2]=x[a+28>>2]+1}if(g|o){break e}d=ZT(k,dn(i,b,c));j:{if(A[d+4>>2]<A[Ab(d)>>2]){e=fb-16|0;fb=e;d=YT(e+4|0,d);VT(x[d+4>>2]);x[d+4>>2]=x[d+4>>2]+8;kc(d);fb=e+16|0;break j}f=fb-32|0;fb=f;e=Ab(d);e=hs(f+12|0,is(d,ih(x[d>>2],x[d+4>>2])+1|0),ih(x[d>>2],x[d+4>>2]),e);VT(x[e+8>>2]);x[e+8>>2]=x[e+8>>2]+8;MB(d,e);gs(e);fb=f+32|0}}d=ZT(k,dn(i,b,c));k:{if(A[d+4>>2]<A[Ab(d)>>2]){e=fb-16|0;fb=e;d=YT(e+4|0,d);XT(x[d+4>>2],x[h>>2],x[h+4>>2]);x[d+4>>2]=x[d+4>>2]+8;kc(d);fb=e+16|0;break k}f=fb-32|0;fb=f;e=Ab(d);e=hs(f+12|0,is(d,ih(x[d>>2],x[d+4>>2])+1|0),ih(x[d>>2],x[d+4>>2]),e);XT(x[e+8>>2],x[h>>2],x[h+4>>2]);x[e+8>>2]=x[e+8>>2]+8;MB(d,e);gs(e);fb=f+32|0}}Jb(i,x[Vd(x[a>>2],b)>>2],c);kf(i,1);j=0}fb=i+16|0;return j|0}function goa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=fb-16|0;fb=k;e=x[b>>2];d=Mg(e,x[b+4>>2]);a:{if(d>>>0<c>>>0){n=fb-32|0;fb=n;d=c-d|0;f=x[Ab(b)>>2];e=x[b+4>>2];b:{if(d>>>0<=f-e>>5>>>0){h=fb-16|0;fb=h;e=mC(h+4|0,b,d);d=x[e+4>>2];g=x[e+8>>2];while(1){if((d|0)==(g|0)){kc(e);fb=h+16|0}else{PV(d);d=d+32|0;x[e+4>>2]=d;continue}break}break b}h=Ab(b);h=iv(n+12|0,Vq(b,Mg(x[b>>2],e)+d|0),Mg(x[b>>2],x[b+4>>2]),h);g=fb-16|0;fb=g;d=QV(g+4|0,h+8|0,d);e=x[d>>2];while(1){if(x[d+4>>2]!=(e|0)){PV(e);e=x[d>>2]+32|0;x[d>>2]=e;continue}break}je(d);fb=g+16|0;l=fb-16|0;fb=l;d=vb(l+12|0,x[b+4>>2]);e=vb(l+8|0,x[b>>2]);f=x[vb(l+4|0,x[h+4>>2])>>2];m=fb-16|0;fb=m;o=m+8|0;g=fb-32|0;fb=g;fd(g+24|0,x[d>>2],x[e>>2]);p=g+16|0;d=x[g+24>>2];q=x[g+28>>2];j=fb-16|0;fb=j;x[j+8>>2]=f;x[j+12>>2]=d;while(1){if(Fd(d,q)){d=gn(d);e=gn(x[j+8>>2]);f=y[d+28|0]|y[d+29|0]<<8|(y[d+30|0]<<16|y[d+31|0]<<24);i=y[d+24|0]|y[d+25|0]<<8|(y[d+26|0]<<16|y[d+27|0]<<24);v[e+24|0]=i;v[e+25|0]=i>>>8;v[e+26|0]=i>>>16;v[e+27|0]=i>>>24;v[e+28|0]=f;v[e+29|0]=f>>>8;v[e+30|0]=f>>>16;v[e+31|0]=f>>>24;f=y[d+20|0]|y[d+21|0]<<8|(y[d+22|0]<<16|y[d+23|0]<<24);i=y[d+16|0]|y[d+17|0]<<8|(y[d+18|0]<<16|y[d+19|0]<<24);v[e+16|0]=i;v[e+17|0]=i>>>8;v[e+18|0]=i>>>16;v[e+19|0]=i>>>24;v[e+20|0]=f;v[e+21|0]=f>>>8;v[e+22|0]=f>>>16;v[e+23|0]=f>>>24;f=y[d+12|0]|y[d+13|0]<<8|(y[d+14|0]<<16|y[d+15|0]<<24);i=y[d+8|0]|y[d+9|0]<<8|(y[d+10|0]<<16|y[d+11|0]<<24);v[e+8|0]=i;v[e+9|0]=i>>>8;v[e+10|0]=i>>>16;v[e+11|0]=i>>>24;v[e+12|0]=f;v[e+13|0]=f>>>8;v[e+14|0]=f>>>16;v[e+15|0]=f>>>24;f=y[d+4|0]|y[d+5|0]<<8|(y[d+6|0]<<16|y[d+7|0]<<24);d=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);v[e|0]=d;v[e+1|0]=d>>>8;v[e+2|0]=d>>>16;v[e+3|0]=d>>>24;v[e+4|0]=f;v[e+5|0]=f>>>8;v[e+6|0]=f>>>16;v[e+7|0]=f>>>24;d=To(j+12|0);To(j+8|0);d=x[d>>2];continue}break}rc(p,d,j+8|0);fb=j+16|0;d=x[g+16>>2];x[g+12>>2]=x[g+20>>2];rc(o,d,g+12|0);fb=g+32|0;fb=m+16|0;x[h+4>>2]=x[m+12>>2];Tb(b,h+4|0);Tb(b+4|0,h+8|0);Tb(Ab(b),nc(h));x[h>>2]=x[h+4>>2];fb=l+16|0;SV(h)}fb=n+32|0;break a}if(c>>>0<d>>>0){Jd(b,e+(c<<5)|0)}}if(Mb(x[a>>2],x[a+8>>2],c<<5)){c=x[b>>2];cc(k+8|0,c,Mg(c,x[b+4>>2])<<5);sd(k,a,x[k+8>>2],x[k+12>>2])}fb=k+16|0}function Xaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=fb-144|0;fb=d;i=OM(d+128|0);x[i>>2]=48636;Nb(i+4|0);uo(x[a+24>>2],i);e=x[a+24>>2];f=y[a+62|0];g=y[a+61|0];h=y[a+60|0];b=Ie(d+108|0,b);x[31609]=0;k=x[b+12>>2];x[d+8>>2]=x[b+8>>2];x[d+12>>2]=k;x[d+16>>2]=x[b+16>>2];k=x[b+4>>2];x[d>>2]=x[b>>2];x[d+4>>2]=k;b=h?13:15;b=g?b&14:b;b=U(1155,e|0,d|0,(f?b&3:b)|0)|0;e=x[31609];x[31609]=0;a:{b:{c:{d:{e:{if((e|0)==1){break e}if(!b){b=ac(8);x[31609]=0;c=P(36,d+96|0,12026)|0;a=x[31609];x[31609]=0;if((a|0)!=1){pc(b,c);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(c);break b}a=N()|0;ic(b);break b}if(!y[a+63|0]){x[31609]=0;O(1156,a|0,a+36|0);b=x[31609];x[31609]=0;if((b|0)==1){break e}}v[a+28|0]=1;uo(x[a+24>>2],x[a+4>>2]);x[31609]=0;O(1157,d+96|0,i|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}m=d,n=wb(x[d+96>>2]),x[m+92>>2]=n;k=a+68|0;l=wb(x[d+100>>2]);f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{while(1){b=x[d+92>>2];if(!Ib(b,l)){b=Vi(x[c>>2]);x[d+80>>2]=b;c=Pf(c);while(1){if(!Zg(b,c)){break d}x[31609]=0;e=ud(b);b=P(71,d+20|0,e|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break h}x[31609]=0;V(1012,a|0,b|0,e+12|0,0);e=x[31609];x[31609]=0;if((e|0)==1){break g}tb(b);b=x[ah(d+80|0)>>2];continue}}e=x[a+24>>2];f=x[b>>2];x[31609]=0;j=b+4|0;S(1158,e|0,f|0,j|0);e=x[31609];x[31609]=0;if((e|0)!=1){b=x[b>>2];x[31609]=0;e=d+44|0;O(1159,e|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break r}x[31609]=0;f=d+56|0;O(1059,f|0,e|0);b=x[31609];x[31609]=0;if((b|0)==1){break q}x[31609]=0;b=P(36,d+32|0,18407)|0;g=x[31609];x[31609]=0;if((g|0)==1){break p}x[31609]=0;g=d+68|0;S(1015,g|0,f|0,b|0);h=x[31609];x[31609]=0;if((h|0)==1){break o}x[31609]=0;h=d+80|0;S(544,h|0,g|0,j|0);j=x[31609];x[31609]=0;if((j|0)==1){break n}x[31609]=0;O(178,k|0,h|0);j=x[31609];x[31609]=0;if((j|0)==1){break m}tb(h);tb(g);tb(b);tb(f);tb(e);Uo(d+92|0);continue}break}a=N()|0;break f}a=N()|0;break f}a=N()|0;break i}a=N()|0;break j}a=N()|0;break k}a=N()|0;break l}a=N()|0;tb(d+80|0)}tb(d+68|0)}tb(b)}tb(d+56|0)}tb(d+44|0);break f}a=N()|0;break f}a=N()|0;tb(b)}vz(d+96|0);break b}a=N()|0;break b}vz(d+96|0);_t(i);fb=d+144|0;return}a=N()|0}_t(i);Q(a|0)}p()}function gda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;m=fb-32|0;fb=m;j=qf(m+20|0,1,0);a:{b:{while(1){e=Kb(j);i=e+Cb(x[j+4>>2],y[j+11|0])|0;g=x[b>>2];d=x[b+4>>2];if(!((d|0)>=0|(d|0)>0|(e|0)==(i|0))){v[e|0]=45;e=e+1|0;g=XN(g,d);d=hb}k=m+12|0;c:{d:{switch(c<<31|c-2>>>1){case 4:QN(k,e,i,g,d);break c;case 0:f=64-du(g|1,d)|0;if((f|0)<=(i-e|0)){i=e+f|0;e=i;while(1){if(!d&g>>>0<17){while(1){e=e-1|0;v[e|0]=y[(g&1)+15515|0];h=!d&g>>>0>1|(d|0)!=0;f=d;d=d>>>1|0;g=(f&1)<<31|g>>>1;if(h){continue}break}}else{e=e-4|0;$m((g<<2&60)+78560|0,4,e);f=d;d=d>>>4|0;g=(f&15)<<28|g>>>4;continue}break}f=0}else{f=61}x[k+4>>2]=f;x[k>>2]=i;break c;case 3:f=(66-du(g|1,d)>>>0)/3|0;if((f|0)<=(i-e|0)){i=e+f|0;e=i;while(1){if(!d&g>>>0<65){while(1){e=e-1|0;v[e|0]=y[(g&7)+14812|0];h=!d&g>>>0>7|(d|0)!=0;f=d;d=d>>>3|0;g=(f&7)<<29|g>>>3;if(h){continue}break}}else{e=e-2|0;$m((g<<1&126)+78624|0,2,e);f=d;d=d>>>6|0;g=(f&63)<<26|g>>>6;continue}break}f=0}else{f=61}x[k+4>>2]=f;x[k>>2]=i;break c;case 7:f=67-du(g|1,d)>>>2|0;if((f|0)<=(i-e|0)){i=e+f|0;e=i;while(1){if(!d&g>>>0<257){while(1){e=e-1|0;v[e|0]=y[(g&15)+11181|0];h=!d&g>>>0>15|(d|0)!=0;f=d;d=d>>>4|0;g=(f&15)<<28|g>>>4;if(h){continue}break}}else{e=e-2|0;$m((g<<1&510)+78752|0,2,e);f=d;d=d>>>8|0;g=(f&255)<<24|g>>>8;continue}break}f=0}else{f=61}x[k+4>>2]=f;x[k>>2]=i;break c;default:break d}}f=g;h=d;n=D(c,c);q=D(n,c);r=D(n,n);o=0;e:{while(1){l=o|1;if(!h&c>>>0>f>>>0){break e}l=o|2;if(!h&f>>>0<n>>>0){break e}l=o|3;if(!h&f>>>0<q>>>0){break e}if(!h&f>>>0<r>>>0){l=o+4|0}else{o=o+4|0;f=Kua(f,h,r,0);h=hb;continue}break}}h=l;if((h|0)>(i-e|0)){x[k+4>>2]=61;x[k>>2]=i;break c}q=e+h|0;e=q;while(1){e=e-1|0;h=Kua(g,d,c,0);f=hb;s=e,t=y[(g-Iua(h,f,c,0)|0)+4895|0],v[s|0]=t;n=!d&c>>>0<=g>>>0|(d|0)!=0;g=h;d=f;if(n){continue}break}x[k+4>>2]=0;x[k>>2]=q}if(!x[m+16>>2]){break b}d=mi(Cb(x[j+4>>2],y[j+11|0]));x[31609]=0;O(45,j|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){continue}break}break a}c=x[m+12>>2];b=Kb(j);x[31609]=0;O(46,j|0,c-b|0);b=x[31609];x[31609]=0;f:{if((b|0)!=1){x[31609]=0;O(47,a|0,j|0);a=x[31609];x[31609]=0;if((a|0)!=1){break f}break a}break a}tb(j);fb=m+32|0;return}a=N()|0;tb(j);Q(a|0);p()}function Dja(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=fb-16|0;fb=h;f=x[a+8>>2];e=x[a>>2];x[31609]=0;f=P(622,e|0,f|0)|0;e=x[31609];x[31609]=0;a:{b:{if((e|0)!=1){if(f){break b}x[31609]=0;f=R(197,a|0)|0;e=x[31609];x[31609]=0;c:{if((e|0)==1){break c}x[31609]=0;j=d+484344|0;k=Ld(f+1|0,1,1024);f=U(196,j|0,b|0,k|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break c}if(!f){break b}d=z[d+480188>>1];if(!d){break b}l=d-1|0;d=0;while(1){if(d>>>0>=k>>>0){break b}f=x[a+8>>2];e=x[a>>2];x[31609]=0;f=U(150,e|0,f|0,1)|0;e=x[31609];x[31609]=0;d:{if((e|0)!=1){if(!f){break b}x[31609]=0;i=R(197,a|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break a}if(i){break d}d=d+1|0;continue}break a}e=x[j>>2];w[h+14>>1]=i&31;w[h+12>>1]=l;e=Wb(e,b);e=md(x[e>>2],x[x[e+48>>2]+12>>2],d,z[Oc(h+14|0,h+12|0)>>1]);if(i>>>0<32){continue}e:{if(i<<24>>24>=0){break e}x[31609]=0;g=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break a}v[e+5|0]=g;x[31609]=0;g=R(197,a|0)|0;f=x[31609];x[31609]=0;f:{g:{if((f|0)!=1){if(g>>>0<26){break g}break f}break a}f=y[g+41088|0];v[e+3|0]=f;h:{switch(f-1|0){case 0:if(!y[e+5|0]){break f}break e;case 12:if(y[e+2|0]){break e}v[e+2|0]=1;f=y[e+5|0];v[e+5|0]=0;v[e+3|0]=0;m=e,n=Ld(f,0,64),v[m+4|0]=n;break e;case 5:case 6:case 10:case 23:case 28:f=y[e+5|0]&240;if(!f){break e}v[e+5|0]=f;break e;case 8:f=y[e+5|0];if(f>>>0<=128){m=e,n=Eh(f<<1),v[m+5|0]=n;break e}if((f|0)!=164){break e}v[e+5|0]=145;v[e+3|0]=20;break e;case 13:f=y[e+5|0];v[e+5|0]=D(f>>>4|0,10)+(f&15);break e;case 18:Kr(e);break e;case 16:if(y[e+5|0]>31){break e}v[e+3|0]=16;break e;case 27:break h;default:break e}}g=y[e+5|0];f=g&240;i:{if((f|0)==16){f=2}else{if((f|0)!=32){break i}f=3}v[e+3|0]=f}v[e+5|0]=g&15|224;break e}v[e+3|0]=0}j:{k:{if(!(i&64)){break k}x[31609]=0;g=h+10|0;O(198,g|0,a|0);f=x[31609];x[31609]=0;if((f|0)==1){break j}v[e+1|0]=y[h+10|0];g=y[Jc(g)|0];v[e|0]=g;f=255;if((g|0)!=128){f=253;if(g>>>0<129){break k}}v[e|0]=f}if(!(i&32)){continue}v[e+2|0]=1;x[31609]=0;g=R(197,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break a}v[e+4|0]=g;if(!c){continue}v[e+4|0]=(g<<6>>>0)/127;continue}break}break a}break a}break a}ub(a);fb=h+16|0;return}b=N()|0;ub(a);Q(b|0);p()}function Hla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0;f=fb-48|0;fb=f;y=x[a+16>>2];z=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);b=0;r=x[a+128>>2];if(r){k=x[a+8>>2];g=x[a+12>>2];s=Hg(k,g,r);t=hb;h=x[a+76>>2];fg(x[a>>2],x[a+4>>2],vf(k,g,d),hb);q=hb>>>0>h>>>0?d:0}else{q=0}j=a+112|0;while(1){if((b|0)!=2){g=b<<3;h=g+(f+20|0)|0;g=a+g|0;x[h+4>>2]=x[g+44>>2];x[h+8>>2]=x[g+48>>2];b=b+1|0;continue}break}o=x[a+40>>2];p=x[a+36>>2];b=x[a+4>>2];x[f+8>>2]=x[a>>2];x[f+12>>2]=b;A=x[a+8>>2];B=x[a+12>>2];while(1){if(d){d=d-1|0;g=x[f+12>>2];b=x[f+8>>2];x[f+40>>2]=b;x[f+44>>2]=0;q=q-1|0;h=q;s=h?s:0;t=h?t:0;k=(((g&2147483647)<<1|b>>>31)&-2)+y|0;g=r;a:{b:while(1){c:{if((g|0)<=0){Pb(j,x[a+120>>2],x[a+124>>2]);h=x[a+116>>2];if(!h){break a}b=x[f+40>>2];g=((x[f+44>>2]&2147483647)<<1|b>>>31)&-2;i=0;b=0;break c}b=x[f+40>>2];h=((x[f+44>>2]&2147483647)<<1|b>>>31)&-2;b=0;i=0;while(1)if((b|0)==2){ce(j,i>>>3<<16>>16);be(j,4);Pb(f+40|0,s,t);g=g-1|0;continue b}else{i=(v[k+(b|h)|0]<<8)+i|0;b=b+1|0;continue}}break}while(1){if((b|0)!=2){i=(v[k+(b|g)|0]<<8)+i|0;b=b+1|0;continue}break}ce(j,i>>>3<<16>>16);be(j,h);x[j>>2]=x[j>>2];x[j+4>>2]=0}b=Fg(j,z);x[f+4>>2]=b;x[f>>2]=b;C=x[a+72>>2];i=x[a+68>>2];E=i>>31;k=x[a+64>>2];F=k>>31;h=x[a+60>>2];G=h>>31;b=0;while(1){if((b|0)!=2){u=(b<<2)+f|0;e=x[u>>2];g=(f+20|0)+(b<<3)|0;H=x[g+8>>2];l=x[g+4>>2];x[g+8>>2]=l;w=e<<8;e=w;e=Iua(e,e>>31,h,G);m=hb;n=e;e=Yb(l,-16777216,16776704);e=Iua(k,F,e,e>>31);l=n+e|0;n=hb+m|0;n=e>>>0>l>>>0?n+1|0:n;e=Yb(H,-16777216,16776704);m=Iua(i,E,e,e>>31);l=m+l|0;e=hb+n|0;e=l>>>0<m>>>0?e+1|0:e;m=l+8388608|0;e=m>>>0<8388608?e+1|0:e;e=Sc(m,e,24);x[g+4>>2]=e-(C&w);x[u>>2]=(e|0)/256;b=b+1|0;continue}break}b=x[a+32>>2];p=x[a+28>>2]+p|0;x[c>>2]=x[c>>2]+D(x[f>>2],p>>12);o=b+o|0;x[c+4>>2]=x[c+4>>2]+D(x[f+4>>2],o>>12);Pb(f+8|0,A,B);c=c+8|0;continue}break}b=x[f+12>>2];x[a>>2]=x[f+8>>2];x[a+4>>2]=b;x[a+40>>2]=o;x[a+20>>2]=p>>12;x[a+36>>2]=p;x[a+24>>2]=o>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+20|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function Qda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=Fb(a);x[31609]=0;X(84);c=x[31609];x[31609]=0;a:{b:{if((c|0)==1){c=Ua(48428,124540,125124,0)|0;d=gb;c:{d:{e:{if(($(48428)|0)==(d|0)){c=Y(c|0)|0;x[31609]=0;b=P(985,a|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break e}x[31609]=0;b=P(985,b|0,18407)|0;d=x[31609];x[31609]=0;if((d|0)==1){break e}x[31609]=0;d=P(985,b|0,18383)|0;b=x[31609];x[31609]=0;if((b|0)==1){break e}b=ib[x[x[c>>2]+8>>2]](c)|0;x[31609]=0;P(985,d|0,(b?b:22292)|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break e}x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break b}b=N()|0;break a}f:{if(($(124540)|0)==(d|0)){c=Y(c|0)|0;x[31609]=0;b=P(985,a|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break f}x[31609]=0;b=P(985,b|0,18407)|0;d=x[31609];x[31609]=0;if((d|0)==1){break f}x[31609]=0;d=P(985,b|0,18358)|0;b=x[31609];x[31609]=0;if((b|0)==1){break f}b=ib[x[x[c>>2]+8>>2]](c)|0;x[31609]=0;P(985,d|0,(b?b:22292)|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break f}x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break b}b=N()|0;break a}e=$(125124)|0;c=Y(c|0)|0;g:{if((d|0)==(e|0)){x[31609]=0;b=P(985,a|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break g}x[31609]=0;b=P(985,b|0,18407)|0;d=x[31609];x[31609]=0;if((d|0)==1){break g}x[31609]=0;d=P(985,b|0,18374)|0;b=x[31609];x[31609]=0;if((b|0)==1){break g}b=ib[x[x[c>>2]+8>>2]](c)|0;x[31609]=0;P(985,d|0,(b?b:22292)|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break g}x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break b}b=N()|0;break a}x[31609]=0;b=P(985,a|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break d}x[31609]=0;b=P(985,b|0,18407)|0;c=x[31609];x[31609]=0;if((c|0)==1){break d}x[31609]=0;P(985,b|0,13836)|0;b=x[31609];x[31609]=0;if((b|0)==1){break d}x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break b}b=N()|0;break a}b=N()|0;x[31609]=0;X(26);c=x[31609];x[31609]=0;if((c|0)!=1){break a}break c}b=N()|0;x[31609]=0;X(26);c=x[31609];x[31609]=0;if((c|0)!=1){break a}break c}b=N()|0;x[31609]=0;X(26);c=x[31609];x[31609]=0;if((c|0)==1){break c}break a}b=N()|0;x[31609]=0;X(26);c=x[31609];x[31609]=0;if((c|0)!=1){break a}}T(0)|0;Sb()}p()}return}tb(a);Q(b|0);p()}function U0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=fb-48|0;fb=f;l=f+29|0;m=f+27|0;n=Ng(f+42|0);while(1){a:{if(A[a+12>>2]>j>>>0){af(f+32|0,x[a>>2],x[x[a+48>>2]+12>>2],j);b:while(1){if(!Mb(x[c>>2],x[c+8>>2],1)){break a}e=Zd(c);if((e|0)==255){break a}g=n;k=e<<24>>24;e=k&31;if(e>>>0<z[x[x[a+48>>2]+12>>2]+480188>>1]){g=Yc(x[f+32>>2],e)}d=1;if(!(k&64)){e=Zd(c);i=e<<24>>24;d=255;e=e&127;c:{d:{if((e|0)==1){break d}d=e-1|0;if(b?d>>>0<=120:0){break d}if((e-109&255)>>>0<159|b){break c}d=e+13|0}v[g|0]=d}q=g,r=Zd(c),v[q+1|0]=r;d=(i|0)<0}i=g+3|0;e=g+5|0;while(1){e:{f:{g:{if(d&1){w[f+28>>1]=y[g+4|0]|y[g+5|0]<<8;x[f+24>>2]=y[g|0]|y[g+1|0]<<8|(y[g+2|0]<<16|y[g+3|0]<<24);d=Zd(c);h=d&63;o=d<<24>>24;if(d&64){v[g+4|0]=h;v[g+2|0]=1;break e}d=Zd(c);v[e|0]=d;if(h>>>0<=15){Cf(g,h,d);h:{i:{j:{d=y[g+3|0];switch(d-9|0){case 1:case 2:case 3:break f;case 4:break i;case 0:break j;default:break h}}v[i|0]=9;v[e|0]=D(y[e|0]&15,17);break f}v[g+2|0]=1;v[g+3|0]=0;x[f+20>>2]=y[g+5|0]+1>>>1;x[f+16>>2]=64;q=g,r=x[Cd(f+20|0,f+16|0)>>2],v[q+4|0]=r;break f}if((d|0)!=19){break f}if(y[e|0]==128){break g}Kr(g);break f}if(h>>>0>44){break f}v[i|0]=y[h+24624|0];k:{switch(h-16|0){case 0:if(d>>>0>1){break g}v[e|0]=d|158;break f;case 1:case 2:v[f+20|0]=15;q=e,r=y[Qb(f+20|0,e)|0]|224,v[q|0]=r;break f;case 5:case 6:x[f+20>>2]=16;x[f+16>>2]=d+1;q=e,r=x[Cd(f+20|0,f+16|0)>>2]/2|240,v[q|0]=r;break f;case 14:l:{m:{n:{o:{p:{h=d>>>4|0;switch(h-1|0){case 1:break n;case 0:break o;default:break p}}switch(h-10|0){case 1:break l;case 0:break m;default:break g}}v[i|0]=2;v[e|0]=d|240;break f}v[i|0]=3;v[e|0]=d|240;break f}v[i|0]=11;v[e|0]=(d<<3&120)+8|15;break f}v[i|0]=11;v[e|0]=(d&15)+1>>>1|240;break f;case 12:break k;default:break f}}x[f+20>>2]=d+1>>>1;x[f+16>>2]=64;q=e,r=x[Cd(f+20|0,f+16|0)>>2],v[q|0]=r;break f}if((k|0)>=0){continue b}break a}v[i|0]=0}JE(i,e,m,l);d=y[f+27|0];p=si(d);h=y[i|0];if(p>>>0<=si(h)>>>0){break e}if(!y[g+2|0]){uw(f+14|0,h,y[g+5|0],1);h=y[f+14|0];v[g+4|0]=y[f+15|0];v[g+2|0]=h}v[i|0]=d;v[e|0]=y[f+29|0]}d=(o|0)<0;continue}}}fb=f+48|0;return}j=j+1|0;continue}}function Tz(a){a=a|0;var b=0,c=0,d=E(0),e=0;Rb(a+4960|0,0,76);v[a+5044|0]=0;x[a+5036>>2]=0;x[a+5040>>2]=0;b=x[a+4292>>2];d=B[a+4268>>2];x[31609]=0;e=a+4504|0;if(d<E(4294967296)&d>=E(0)){c=~~d>>>0}else{c=0}aa(973,e|0,67,5,c|0,b|0);b=x[31609];x[31609]=0;a:{if((b|0)==1){break a}b=x[a+4296>>2];x[31609]=0;aa(973,a+4528|0,62,5,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=x[a+4300>>2];x[31609]=0;aa(973,a+4552|0,53,5,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=x[a+4304>>2];x[31609]=0;aa(973,a+4576|0,43,5,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=x[a+4308>>2];x[31609]=0;aa(973,a+4600|0,32,5,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=x[a+4312>>2];x[31609]=0;aa(973,a+4624|0,22,5,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=x[a+4316>>2];x[31609]=0;aa(973,a+4648|0,75,5,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=x[a+4320>>2];x[31609]=0;aa(973,a+4672|0,69,5,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=x[a+4324>>2];x[31609]=0;aa(973,a+4696|0,60,5,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=x[a+4328>>2];x[31609]=0;aa(973,a+4720|0,48,5,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=x[a+4332>>2];x[31609]=0;aa(973,a+4744|0,36,5,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=x[a+4336>>2];x[31609]=0;aa(973,a+4768|0,25,5,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}x[31609]=0;aa(973,a+4792|0,0,0,0,0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=x[a+4344>>2];x[31609]=0;aa(973,a+4816|0,3,0,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=x[a+4348>>2];x[31609]=0;aa(973,a+4840|0,3,0,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}x[31609]=0;aa(973,a+4864|0,407,1,c|0,0);b=x[31609];x[31609]=0;if((b|0)==1){break a}x[31609]=0;aa(973,a+4888|0,400,1,c|0,0);b=x[31609];x[31609]=0;if((b|0)==1){break a}x[31609]=0;aa(973,a+4912|0,10,0,c|0,-1);b=x[31609];x[31609]=0;if((b|0)==1){break a}x[31609]=0;aa(973,a+4936|0,10,0,c|0,-1);c=x[31609];x[31609]=0;if((c|0)==1){break a}v[a+5045|0]=1;return}c=T(124540)|0;if((gb|0)==($(124540)|0)){Y(c|0)|0;v[a+5045|0]=0;Z();return}Q(c|0);p()}function kma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0;f=fb-48|0;fb=f;g=x[a+8>>2];s=g;h=x[a+12>>2];n=h;a:{b:{c:{d:{if((h|0)<=1&g>>>0<=805306368|(h|0)<=0){g=h;if((g|0)>-2){e=1}else{e=(g|0)>=-2&s>>>0>=3489660928}if(e){break c}if((n|0)==-2&s>>>0>2147483647|(n|0)==-1){break d}break b}if((n|0)==1&s>>>0>2147483648|n>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}z=b;A=x[a+16>>2];b=0;while(1){if((b|0)!=2){g=b<<3;h=g+(f+28|0)|0;g=a+g|0;x[h+4>>2]=x[g+44>>2];x[h+8>>2]=x[g+48>>2];b=b+1|0;continue}break}o=x[a+40>>2];p=x[a+36>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;B=x[a+32>>2];C=x[a+28>>2];E=x[a+72>>2];y=x[a+68>>2];F=y>>31;h=x[a+64>>2];G=h>>31;g=x[a+60>>2];H=g>>31;while(1){if(d){b=x[f+16>>2];i=((((x[f+20>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+A|0;b=(b>>>16&65520)+z|0;m=w[b+14>>1];t=w[b+12>>1];v=w[b+10>>1];j=w[b+8>>1];u=w[b+6>>1];k=w[b+4>>1];e=w[b+2>>1];b=w[b>>1];q=0;r=0;while(1){if((r|0)!=2){l=r<<1;x[(f+8|0)+(r<<2)>>2]=(((((((D(w[i+(l|-8)>>1],e)+D(w[i+(l|-12)>>1],b)|0)+D(w[i+(l|-4)>>1],k)|0)+D(w[i+l>>1],u)|0)+D(w[i+(l|4)>>1],j)|0)+D(w[i+(l|8)>>1],v)|0)+D(t,w[i+(l|12)>>1])|0)+D(m,w[i+(l|16)>>1])|0)/32768;r=r+1|0;continue}break}while(1){if((q|0)!=2){t=(f+8|0)+(q<<2)|0;e=x[t>>2];b=(f+28|0)+(q<<3)|0;v=x[b+8>>2];j=x[b+4>>2];x[b+8>>2]=j;u=e<<8;e=u;e=Iua(e,e>>31,g,H);k=hb;i=e;e=Yb(j,-16777216,16776704);e=Iua(h,G,e,e>>31);j=i+e|0;m=hb+k|0;m=e>>>0>j>>>0?m+1|0:m;e=Yb(v,-16777216,16776704);k=Iua(y,F,e,e>>31);j=k+j|0;e=hb+m|0;e=j>>>0<k>>>0?e+1|0:e;k=j+8388608|0;e=k>>>0<8388608?e+1|0:e;e=Sc(k,e,24);x[b+4>>2]=e-(u&E);x[t>>2]=(e|0)/256;q=q+1|0;continue}break}p=p+C|0;x[c>>2]=x[c>>2]+D(x[f+8>>2],p>>12);o=o+B|0;x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],o>>12);Pb(f+16|0,s,n);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;x[a+40>>2]=o;x[a+20>>2]=p>>12;x[a+36>>2]=p;x[a+24>>2]=o>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function zha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=E(0),g=E(0),h=E(0),i=0,j=0,k=E(0),l=0,m=0,n=E(0),o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=E(0),w=0,z=0,A=0,C=0,D=0,G=0,H=E(0),I=0,J=0,K=0,L=0,M=0,N=E(0),O=0,P=E(0);a:{if(!x[a+4316>>2]){break a}if(!ui(a+44|0)){break a}D=a+4300|0;G=a+4288|0;I=a+4264|0;J=a+4276|0;e=x[a+44>>2];r=Hc(e,0);s=Hc(e,1);e=x[a+56>>2];t=Hc(e,0);u=Hc(e,1);K=ib[x[x[a>>2]+196>>2]](a)|0;v=E(E(ib[x[x[a>>2]+204>>2]](a))/E(100));H=E(ib[x[x[a>>2]+192>>2]](a));w=ib[x[x[a>>2]+216>>2]](a)|0;L=w&1;o=x[a+4324>>2];l=x[a+4320>>2];m=x[a+4328>>2];j=x[a+4312>>2];M=x[a+4276>>2];p=x[a+4264>>2];z=x[a+4256>>2];A=y[a+4260|0];C=d;while(1){if(C){h=B[s>>2];k=B[r>>2];i=x[a+4316>>2];e=xo(i,j+z|0);i=xo(i,j);b:{if(A){O=yb(G,m),P=k,B[O>>2]=P;O=yb(D,m),P=h,B[O>>2]=P;q=yb(p,e);O=yb(p,i),P=E(E(B[q>>2]*v)+k),B[O>>2]=P;g=E(E(B[yb(M,e)>>2]*v)+h);e=J;break b}g=E(E(B[yb(p,e)>>2]*v)+E(E(k+h)*E(.5)));e=I}O=yb(x[e>>2],i),P=g,B[O>>2]=P;c:{if(K){f=B[a+4244>>2];g=E(f+B[a+4236>>2]);B[a+4236>>2]=g;f=E(f+B[a+4240>>2]);B[a+4240>>2]=f;if(g>E(1)){g=E(g+E(-2));B[a+4236>>2]=g}if(f>E(1)){f=E(f+E(-2));B[a+4240>>2]=f}g=E(F(g));g=E(E(g+g)+E(-1));f=E(F(f));f=E(E(f+f)+E(-1));break c}f=B[a+4240>>2];n=B[a+4244>>2];g=E(E(f*n)+B[a+4236>>2]);B[a+4236>>2]=g;f=E(f-E(g*n));B[a+4240>>2]=f}if(A){e=(m+2|0)%3|0;k=B[yb(G,e)>>2];h=B[yb(D,e)>>2]}e=x[a+4316>>2];i=yb(p,xo(e,j+l|0));q=e;e=j+4096|0;N=B[yb(p,xo(q,e+l|0))>>2];n=B[i>>2];B[t>>2]=E(E(E(E(E(N-n)*E(E(l&4095)*E(.000244140625)))+n)-k)*H)+k;l=x[(A?4276:4264)+a>>2];i=x[a+4316>>2];q=yb(l,xo(i,j+o|0));n=B[yb(l,xo(i,e+o|0))>>2];k=B[q>>2];B[u>>2]=E(E(E(E(E(n-k)*E(E(o&4095)*E(.000244140625)))+k)-h)*H)+h;m=((m|0)<=0?m+3|0:m)-1|0;x[a+4328>>2]=m;j=(((j|0)<=0?x[a+4316>>2]<<12:0)+j|0)-4096|0;x[a+4312>>2]=j;h=L?f:g;f=B[a+4248>>2];h=E(h*f);d:{if(E(F(h))<E(2147483648)){e=~~h;break d}e=-2147483648}o=(w>>>0>1?e:0-e|0)+z|0;x[a+4324>>2]=o;s=s+4|0;r=r+4|0;g=E(g*f);e:{if(E(F(g))<E(2147483648)){e=~~g;break e}e=-2147483648}l=(w>>>0<4?e:0-e|0)+z|0;x[a+4320>>2]=l;C=C-1|0;u=u+4|0;t=t+4|0;continue}else{e=a;a=x[a+56>>2];Ki(e,b,c,Hc(a,0),Hc(a,1),d)}break}}}function Gla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0;f=fb-48|0;fb=f;y=x[a+16>>2];z=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);b=0;q=x[a+128>>2];if(q){i=x[a+8>>2];g=x[a+12>>2];r=Hg(i,g,q);s=hb;h=x[a+76>>2];fg(x[a>>2],x[a+4>>2],vf(i,g,d),hb);p=hb>>>0>h>>>0?d:0}else{p=0}j=a+112|0;while(1){if((b|0)!=2){g=b<<3;h=g+(f+20|0)|0;g=a+g|0;x[h+4>>2]=x[g+44>>2];x[h+8>>2]=x[g+48>>2];b=b+1|0;continue}break}n=x[a+40>>2];o=x[a+36>>2];b=x[a+4>>2];x[f+8>>2]=x[a>>2];x[f+12>>2]=b;A=x[a+8>>2];B=x[a+12>>2];a:while(1){if(d){d=d-1|0;g=x[f+12>>2];b=x[f+8>>2];x[f+40>>2]=b;x[f+44>>2]=0;p=p-1|0;h=p;r=h?r:0;s=h?s:0;i=((((g&2147483647)<<1|b>>>31)&2147483646)<<1)+y|0;b=q;while(1)if((b|0)<=0){Pb(j,x[a+120>>2],x[a+124>>2]);h=x[a+116>>2];if(h){b=x[f+40>>2];b=(x[f+44>>2]&2147483647)<<1|b>>>31;ce(j,(w[((b&2147483646)<<1)+i>>1]+w[i+(b<<1|2)>>1]|0)/8<<16>>16);be(j,h);x[j>>2]=x[j>>2];x[j+4>>2]=0}b=Fg(j,z);x[f+4>>2]=b;x[f>>2]=b;C=x[a+72>>2];t=x[a+68>>2];E=t>>31;i=x[a+64>>2];F=i>>31;h=x[a+60>>2];G=h>>31;b=0;while(1){if((b|0)!=2){u=(b<<2)+f|0;e=x[u>>2];g=(f+20|0)+(b<<3)|0;H=x[g+8>>2];k=x[g+4>>2];x[g+8>>2]=k;v=e<<8;e=v;e=Iua(e,e>>31,h,G);l=hb;m=e;e=Yb(k,-16777216,16776704);e=Iua(i,F,e,e>>31);k=m+e|0;m=hb+l|0;m=e>>>0>k>>>0?m+1|0:m;e=Yb(H,-16777216,16776704);l=Iua(t,E,e,e>>31);k=l+k|0;e=hb+m|0;e=k>>>0<l>>>0?e+1|0:e;l=k+8388608|0;e=l>>>0<8388608?e+1|0:e;e=Sc(l,e,24);x[g+4>>2]=e-(C&v);x[u>>2]=(e|0)/256;b=b+1|0;continue}break}b=x[a+32>>2];o=x[a+28>>2]+o|0;x[c>>2]=x[c>>2]+D(x[f>>2],o>>12);n=b+n|0;x[c+4>>2]=x[c+4>>2]+D(x[f+4>>2],n>>12);Pb(f+8|0,A,B);c=c+8|0;continue a}else{g=x[f+40>>2];g=(x[f+44>>2]&2147483647)<<1|g>>>31;ce(j,(w[((g&2147483646)<<1)+i>>1]+w[i+(g<<1|2)>>1]|0)/8<<16>>16);be(j,4);Pb(f+40|0,r,s);b=b-1|0;continue}}break}b=x[f+12>>2];x[a>>2]=x[f+8>>2];x[a+4>>2]=b;x[a+40>>2]=n;x[a+20>>2]=o>>12;x[a+36>>2]=o;x[a+24>>2]=n>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+20|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function jga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=E(0),f=0,g=0,h=0,i=0,j=E(0),k=0,l=E(0),m=E(0),n=E(0),o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=E(0),A=0,C=0,D=0,F=0,G=E(0),H=0,I=0,J=0,K=0,L=0,M=0,N=E(0),O=E(0),P=E(0),Q=E(0),R=E(0),S=0,T=E(0);if(ui(a+44|0)){f=x[a+44>>2];A=Hc(f,0);C=Hc(f,1);f=x[a+56>>2];D=Hc(f,0);F=Hc(f,1);t=x[a+4296>>2];g=t+1|0;k=a+4304|0;f=a+4272|0;u=g+x[yb(f,0)>>2]&4095;o=k+(u<<4)|0;v=g+x[yb(f,1)>>2]&4095;p=((v<<4)+k|0)+4|0;w=g+x[yb(f,2)>>2]&4095;q=((w<<4)+k|0)+8|0;h=yb(f,3);i=x[yb(f,4)>>2];r=x[a+4300>>2];i=i+r|0;y=g+x[h>>2]&4095;s=((y<<4)+k|0)+12|0;h=x[yb(f,5)>>2]+r|0;g=a+4232|0;I=a+69840|0;J=a+78032|0;f=d;while(1){if(f){N=B[s>>2];O=B[q>>2];P=B[p>>2];Q=B[o>>2];z=B[C>>2];R=B[A>>2];K=i&1023;i=(K<<3)+I|0;j=B[i+4>>2];u=u-1&4095;o=(u<<4)+k|0;e=B[o>>2];s=r<<3;q=s+I|0;v=v-1&4095;p=((v<<4)+k|0)+4|0;l=B[p>>2];m=l;n=E(l*E(.6180340051651001));G=B[i>>2];l=B[yb(g,0)>>2];n=E(n+E(G*l));B[q+4>>2]=m+E(n*E(-.6180340051651001));m=e;e=E(E(j*l)+E(e*E(-.6180340051651001)));B[q>>2]=m+E(e*E(.6180340051651001));B[o>>2]=n;B[p>>2]=e;L=h&1023;h=(L<<3)+J|0;l=B[h+4>>2];w=w-1&4095;H=(w<<4)+k|0;q=H+8|0;e=B[q>>2];M=s+J|0;y=y-1&4095;i=(y<<4)+k|0;s=i+12|0;j=B[s>>2];m=j;G=B[h>>2];n=B[yb(g,1)>>2];j=E(E(j*E(.6180340051651001))+E(G*n));B[M+4>>2]=m+E(j*E(-.6180340051651001));m=e;e=E(E(l*n)+E(e*E(-.6180340051651001)));B[M>>2]=m+E(e*E(.6180340051651001));B[H+8>>2]=j;B[i+12>>2]=e;e=E(R+E(1.0000000031710769e-30));B[D>>2]=j+E(E(e*B[a+4224>>2])+B[o>>2]);j=E(z+E(1.0000000031710769e-30));B[F>>2]=E(E(j*B[a+4224>>2])+B[p>>2])+B[i+12>>2];h=(t<<4)+k|0;l=e;e=B[a+4228>>2];z=E(l*e);S=h,T=E(z+E(E(B[o>>2]*B[yb(g,2)>>2])+E(Q*B[yb(g,3)>>2]))),B[S>>2]=T;e=E(j*e);S=h,T=E(e+E(E(B[p>>2]*B[yb(g,4)>>2])+E(P*B[yb(g,5)>>2]))),B[S+4>>2]=T;S=h,T=E(E(E(B[H+8>>2]*B[yb(g,6)>>2])+E(O*B[yb(g,7)>>2]))-e),B[S+8>>2]=T;S=h,T=E(z+E(E(B[i+12>>2]*B[yb(g,8)>>2])+E(N*B[yb(g,9)>>2]))),B[S+12>>2]=T;f=f-1|0;F=F+4|0;D=D+4|0;C=C+4|0;A=A+4|0;h=L-1|0;i=K-1|0;r=r-1&1023;t=t-1&4095;continue}else{x[a+4300>>2]=r;x[a+4296>>2]=t;f=a;a=x[a+56>>2];Ki(f,b,c,Hc(a,0),Hc(a,1),d)}break}}}function iR(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=fb-128|0;fb=j;a:{b:{c:{if(!fn(f,g,h,i,0,0,0,0)){break c}k=i&65535;n=i>>>16&32767;d:{e:{if((n|0)!=32767){l=4;if(n){break e}l=f|h|(g|k)?3:2;break d}l=!(f|h|(g|k))}}s=e>>>16|0;o=s&32767;if((o|0)==32767){break c}if(l){break b}}Xd(j+16|0,b,c,d,e,f,g,h,i);b=x[j+16>>2];d=x[j+20>>2];e=x[j+24>>2];c=x[j+28>>2];KR(j,b,d,e,c,b,d,e,c);d=x[j+8>>2];e=x[j+12>>2];h=x[j>>2];i=x[j+4>>2];break a}l=d;p=e&2147483647;k=p;n=h;m=i&2147483647;if((fn(b,c,l,k,f,g,h,m)|0)<=0){if(fn(b,c,l,k,f,g,h,m)){h=b;i=c;break a}Xd(j+112|0,b,c,d,e,0,0,0,0);d=x[j+120>>2];e=x[j+124>>2];h=x[j+112>>2];i=x[j+116>>2];break a}q=i>>>16&32767;if(o){i=c;h=b}else{Xd(j+96|0,b,c,l,p,0,0,0,1081540608);l=x[j+104>>2];h=x[j+108>>2];p=h;o=(h>>>16|0)-120|0;i=x[j+100>>2];h=x[j+96>>2]}if(!q){Xd(j+80|0,f,g,n,m,0,0,0,1081540608);n=x[j+88>>2];f=x[j+92>>2];m=f;q=(f>>>16|0)-120|0;g=x[j+84>>2];f=x[j+80>>2]}r=n;t=m&65535|65536;p=p&65535|65536;if((o|0)>(q|0)){while(1){m=l-r|0;k=(g|0)==(i|0)&f>>>0>h>>>0|g>>>0>i>>>0;n=m-k|0;k=(p-((l>>>0<r>>>0)+t|0)|0)-(k>>>0>m>>>0)|0;f:{if((k|0)>=0|(k|0)>0){l=h;h=h-f|0;i=i-((f>>>0>l>>>0)+g|0)|0;if(!(h|n|(i|k))){Xd(j+32|0,b,c,d,e,0,0,0,0);d=x[j+40>>2];e=x[j+44>>2];h=x[j+32>>2];i=x[j+36>>2];break a}k=k<<1|n>>>31;l=n<<1|i>>>31;break f}k=p<<1|l>>>31;l=l<<1|i>>>31}p=k;k=i<<1|h>>>31;h=h<<1;i=k;o=o-1|0;if((o|0)>(q|0)){continue}break}o=q}m=l-r|0;k=(g|0)==(i|0)&f>>>0>h>>>0|g>>>0>i>>>0;n=m-k|0;k=(p-((l>>>0<r>>>0)+t|0)|0)-(k>>>0>m>>>0)|0;m=k;g:{if((k|0)<0){n=l;m=p;break g}l=h;h=h-f|0;i=i-((f>>>0>l>>>0)+g|0)|0;if(h|n|(i|m)){break g}Xd(j+48|0,b,c,d,e,0,0,0,0);d=x[j+56>>2];e=x[j+60>>2];h=x[j+48>>2];i=x[j+52>>2];break a}if((m|0)==65535|m>>>0<65535){while(1){b=i>>>31|0;o=o-1|0;p=i<<1|h>>>31;h=h<<1;i=p;c=b;b=m<<1|n>>>31;n=c|n<<1;m=b;if(b>>>0<65536){continue}break}}b=s&32768;if((o|0)<=0){Xd(j- -64|0,h,i,n,m&65535|(b|o+120)<<16,0,0,0,1065811968);d=x[j+72>>2];e=x[j+76>>2];h=x[j+64>>2];i=x[j+68>>2];break a}d=n;e=m&65535|(b|o)<<16}x[a>>2]=h;x[a+4>>2]=i;x[a+8>>2]=d;x[a+12>>2]=e;fb=j+128|0}function Lla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0;f=fb-48|0;fb=f;u=x[a+16>>2];w=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);b=0;p=x[a+128>>2];if(p){k=x[a+8>>2];g=x[a+12>>2];q=Hg(k,g,p);r=hb;h=x[a+76>>2];fg(x[a>>2],x[a+4>>2],vf(k,g,d),hb);o=hb>>>0>h>>>0?d:0}else{o=0}j=a+112|0;while(1){if((b|0)!=2){g=b<<3;h=g+(f+20|0)|0;g=a+g|0;x[h+4>>2]=x[g+44>>2];x[h+8>>2]=x[g+48>>2];b=b+1|0;continue}break}y=x[a+24>>2];z=x[a+20>>2];b=x[a+4>>2];x[f+8>>2]=x[a>>2];x[f+12>>2]=b;A=x[a+8>>2];B=x[a+12>>2];while(1){if(d){d=d-1|0;g=x[f+12>>2];b=x[f+8>>2];x[f+40>>2]=b;x[f+44>>2]=0;o=o-1|0;h=o;q=h?q:0;r=h?r:0;k=(((g&2147483647)<<1|b>>>31)&-2)+u|0;g=p;a:{b:while(1){c:{if((g|0)<=0){Pb(j,x[a+120>>2],x[a+124>>2]);h=x[a+116>>2];if(!h){break a}b=x[f+40>>2];g=((x[f+44>>2]&2147483647)<<1|b>>>31)&-2;i=0;b=0;break c}b=x[f+40>>2];h=((x[f+44>>2]&2147483647)<<1|b>>>31)&-2;b=0;i=0;while(1)if((b|0)==2){ce(j,i>>>3<<16>>16);be(j,4);Pb(f+40|0,q,r);g=g-1|0;continue b}else{i=(v[k+(b|h)|0]<<8)+i|0;b=b+1|0;continue}}break}while(1){if((b|0)!=2){i=(v[k+(b|g)|0]<<8)+i|0;b=b+1|0;continue}break}ce(j,i>>>3<<16>>16);be(j,h);x[j>>2]=x[j>>2];x[j+4>>2]=0}b=Fg(j,w);x[f+4>>2]=b;x[f>>2]=b;C=x[a+72>>2];i=x[a+68>>2];E=i>>31;k=x[a+64>>2];F=k>>31;h=x[a+60>>2];G=h>>31;b=0;while(1){if((b|0)!=2){s=(b<<2)+f|0;e=x[s>>2];g=(f+20|0)+(b<<3)|0;H=x[g+8>>2];l=x[g+4>>2];x[g+8>>2]=l;t=e<<8;e=t;e=Iua(e,e>>31,h,G);m=hb;n=e;e=Yb(l,-16777216,16776704);e=Iua(k,F,e,e>>31);l=n+e|0;n=hb+m|0;n=e>>>0>l>>>0?n+1|0:n;e=Yb(H,-16777216,16776704);m=Iua(i,E,e,e>>31);l=m+l|0;e=hb+n|0;e=l>>>0<m>>>0?e+1|0:e;m=l+8388608|0;e=m>>>0<8388608?e+1|0:e;e=Sc(m,e,24);x[g+4>>2]=e-(C&t);x[s>>2]=(e|0)/256;b=b+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[f>>2],z);x[c+4>>2]=x[c+4>>2]+D(x[f+4>>2],y);Pb(f+8|0,A,B);c=c+8|0;continue}break}b=x[f+12>>2];x[a>>2]=x[f+8>>2];x[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+20|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function lma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0;f=fb-48|0;fb=f;g=x[a+8>>2];q=g;h=x[a+12>>2];m=h;a:{b:{c:{d:{if((h|0)<=1&g>>>0<=805306368|(h|0)<=0){g=h;if((g|0)>-2){e=1}else{e=(g|0)>=-2&q>>>0>=3489660928}if(e){break c}if((m|0)==-2&q>>>0>2147483647|(m|0)==-1){break d}break b}if((m|0)==1&q>>>0>2147483648|m>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}y=b;z=x[a+16>>2];b=0;while(1){if((b|0)!=2){g=b<<3;h=g+(f+28|0)|0;g=a+g|0;x[h+4>>2]=x[g+44>>2];x[h+8>>2]=x[g+48>>2];b=b+1|0;continue}break}n=x[a+40>>2];o=x[a+36>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;A=x[a+32>>2];B=x[a+28>>2];C=x[a+72>>2];u=x[a+68>>2];E=u>>31;h=x[a+64>>2];F=h>>31;g=x[a+60>>2];G=g>>31;while(1){if(d){b=x[f+16>>2];i=(((x[f+20>>2]&2147483647)<<1|b>>>31)&-2)+z|0;b=(b>>>16&65520)+y|0;H=w[b+14>>1];l=w[b+12>>1];r=w[b+10>>1];t=w[b+8>>1];j=w[b+6>>1];s=w[b+4>>1];k=w[b+2>>1];e=w[b>>1];p=0;b=0;while(1){if((b|0)!=2){x[(f+8|0)+(b<<2)>>2]=(((((((D(v[i+(b|-4)|0],k)+D(v[i+(b|-6)|0],e)|0)+D(v[i+(b|-2)|0],s)|0)+D(v[b+i|0],j)|0)+D(v[i+(b|2)|0],t)|0)+D(r,v[i+(b|4)|0])|0)+D(l,v[i+(b|6)|0])|0)+D(H,v[i+(b|8)|0])<<8)/32768;b=b+1|0;continue}break}while(1){if((p|0)!=2){r=(f+8|0)+(p<<2)|0;e=x[r>>2];b=(f+28|0)+(p<<3)|0;t=x[b+8>>2];j=x[b+4>>2];x[b+8>>2]=j;s=e<<8;e=s;e=Iua(e,e>>31,g,G);k=hb;i=e;e=Yb(j,-16777216,16776704);e=Iua(h,F,e,e>>31);j=i+e|0;l=hb+k|0;l=e>>>0>j>>>0?l+1|0:l;e=Yb(t,-16777216,16776704);k=Iua(u,E,e,e>>31);j=k+j|0;e=hb+l|0;e=j>>>0<k>>>0?e+1|0:e;k=j+8388608|0;e=k>>>0<8388608?e+1|0:e;e=Sc(k,e,24);x[b+4>>2]=e-(s&C);x[r>>2]=(e|0)/256;p=p+1|0;continue}break}o=o+B|0;x[c>>2]=x[c>>2]+D(x[f+8>>2],o>>12);n=n+A|0;x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],n>>12);Pb(f+16|0,q,m);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;x[a+40>>2]=n;x[a+20>>2]=o>>12;x[a+36>>2]=o;x[a+24>>2]=n>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function Jqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=fb-16|0;fb=f;a:{b:{if(!c){break b}n=f,o=Zd(a),v[n+8|0]=o;ro(b,f+8|0);j=c-1|0;while(1){e=1;if(!j){break a}c:{c=g<<1&254;d:{if(!c){if(!Bf(a,f+8|0)){break b}d=y[f+8|0]<<1|1;c=d&255;if(d>>>0<256){break d}break c}if((g&65535)>>>0>127){break c}}d=f+8|0;if(!Bf(a,d)){break b}b$(b,d);j=j-1|0;g=c;continue}e=1;while(1){e:{f:{g:{g=c<<1&254;if(g){c=(c&65535)>>>0>127}else{if(!Bf(a,f+8|0)){break g}c=y[f+8|0]<<1|1;g=c&255;c=c>>>0>255}e=gr(e,1)+c|0;c=g<<1&254;if(c){break f}if(!Bf(a,f+8|0)){break g}d=y[f+8|0]<<1|1;c=d&255;if(d>>>0>255){continue}break e}c=0;break e}if(g>>>0>127){continue}}break}h:{if((e|0)<=2){h=0;d=e-2|0;break h}if(!Bf(a,f+8|0)){break b}d=gr(e-3|0,8)|y[f+8|0];h=((d|0)>1279?2:1)+((d|0)>31999)|0;l=d^-1;d=0}e=c<<1&254;if(e){c=c>>>0>127}else{if(!Bf(a,f+8|0)){break b}c=y[f+8|0]<<1|1;e=c&255;c=c>>>0>255}i=gr(d,1);g=e<<1&254;if(g){d=e>>>0>127}else{if(!Bf(a,f+8|0)){break b}d=y[f+8|0]<<1|1;g=d&255;d=d>>>0>255}e=1;c=gr(c+i|0,1)+d|0;if(!c){while(1){i:{j:{k:{c=g<<1&254;if(c){d=(g&65535)>>>0>127}else{if(!Bf(a,f+8|0)){break k}d=y[f+8|0]<<1|1;c=d&255;d=d>>>0>255}e=gr(e,1)+d|0;g=c<<1&254;if(g){break j}if(!Bf(a,f+8|0)){break k}c=y[f+8|0]<<1|1;g=c&255;if(c>>>0>255){continue}break i}g=0;break i}if(c>>>0>127){continue}}break}c=e+2|0}d=c+h|0;e=0;if(d>>>0>j>>>0|(d|0)<=0|(l|0)>=0){break a}c=x[b+4>>2];e=0;if((0-Xc(x[b>>2],c)|0)>(l|0)){break a}c=vb(f+12|0,wb(c));v[f+8|0]=0;i=f+8|0;m=fb-32|0;fb=m;e=x[c>>2];c=x[b>>2];h=Ak(e,wb(c))+c|0;c=x[Ab(b)>>2];k=x[b+4>>2];l:{if(d>>>0<=c-k>>>0){c=d;e=k-h|0;if(c>>>0>e>>>0){zp(b,c-e|0,i);c=e;if(!c){break l}}__(b,h,k,d+h|0);Uh(h,c,i+(h>>>0<=i>>>0?i>>>0<A[b+4>>2]?d:0:0)|0);break l}c=Ab(b);c=qn(m+12|0,Wl(b,Xc(x[b>>2],k)+d|0),h-x[b>>2]|0,c);lZ(c,d,i);h=Z_(b,c,h);pn(c)}wb(h);fb=m+32|0;n=f,o=uf(aD(wb(x[b+4>>2]),d),l),x[n+8>>2]=o;n=f,o=aD(wb(x[b+4>>2]),d),x[n+4>>2]=o;c=d;while(1){e=y[pY(f+8|0)|0];n=pY(f+4|0),o=e,v[n|0]=o;e=c>>>0>1;c=c-1|0;if(e){continue}break}j=j-d|0;continue}}e=0}fb=f+16|0;return e|0}
function pP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=fb-112|0;fb=d;f=x[b+4>>2];a:{if(!f){break a}e=x[b>>2];h=y[Al(e,f)|0];if((h|0)==33){c=1}else{if((h|0)!=63){break a}c=0}Nl(d+88|0,e,f,f-1|0);f=x[d+92>>2];e=x[d+88>>2];x[b>>2]=e;x[b+4>>2]=f}e=d+88|0;ie(e);h=x[d+88>>2];ie(d+76|0);h=zl(h,x[d+80>>2],b);ie(e);b:{c:{d:{e:{if((h|0)==x[d+92>>2]){a=x[b>>2];h=qc(d+104|0,22292);i=x[h+4>>2];x[d>>2]=x[h>>2];x[d+4>>2]=i;if(Ic(a,f,d)){a=ac(8);x[31609]=0;c=P(36,e|0,10498)|0;b=x[31609];x[31609]=0;if((b|0)==1){break d}pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break c}g=0;if(!c){break e}c=ac(8);a=x[b+4>>2];b=x[b>>2];x[31609]=0;f=bi(d+76|0,b,a);a=x[31609];x[31609]=0;f:{g:{h:{if((a|0)!=1){x[31609]=0;e=d+88|0;S(1011,e|0,18307,f|0);a=x[31609];x[31609]=0;if((a|0)==1){break h}pc(c,e);a=0;x[31609]=0;S(97,c|0,48428,1e3);b=x[31609];x[31609]=0;if((b|0)!=1){break b}b=N()|0;tb(e);break g}b=N()|0;break f}b=N()|0;a=1}tb(f);if(!a){break c}}ic(c);break c}if(x[h+4>>2]!=2){a=ac(8);x[31609]=0;c=P(36,d+88|0,11600)|0;b=x[31609];x[31609]=0;if((b|0)!=1){pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break c}b=N()|0;ic(a);break c}b=x[b>>2];c=qc(d+68|0,22292);e=x[c+4>>2];x[d+32>>2]=x[c>>2];x[d+36>>2]=e;if(Ic(b,f,d+32|0)){a=ac(8);x[31609]=0;c=P(36,d+88|0,10498)|0;b=x[31609];x[31609]=0;if((b|0)!=1){pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break c}b=N()|0;ic(a);break c}c=qc(d+60|0,7759);e=x[c+4>>2];x[d+24>>2]=x[c>>2];x[d+28>>2]=e;if(Ic(b,f,d+24|0)){g=1;if(!Id(y[a+28|0])){break e}g=65536/+A[x[a+24>>2]+480244>>2];break e}c=qc(d+52|0,7811);e=x[c+4>>2];x[d+16>>2]=x[c>>2];x[d+20>>2]=e;if(Ic(b,f,d+16|0)){g=1;if(!Id(y[a+28|0])){break e}g=+A[x[a+24>>2]+480240>>2]*152587890625e-16;break e}c=qc(d+44|0,7829);e=x[c+4>>2];x[d+8>>2]=x[c>>2];x[d+12>>2]=e;g=0;if(!Ic(b,f,d+8|0)){break e}g=+A[x[a+24>>2]+480236>>2]*152587890625e-16}fb=d+112|0;return+g}b=N()|0;ic(a)}Q(b|0)}p()}function gpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if(x[a+4>>2]!=x[Ab(a)>>2]){e=fb-16|0;fb=e;c=e+4|0;x[c>>2]=a;a=x[a+4>>2];x[c+4>>2]=a;x[c+8>>2]=a+56;a=x[c+4>>2];x[31609]=0;O(683,a|0,b|0);a=x[31609];x[31609]=0;a:{if((a|0)!=1){x[c+4>>2]=x[c+4>>2]+56;kc(c);fb=e+16|0;break a}a=N()|0;kc(c);Q(a|0);p()}return}k=fb-32|0;fb=k;i=Ab(a);c=k+12|0;d=Bv(x[a>>2],x[a+4>>2])+1|0;h=fb-16|0;fb=h;x[h+12>>2]=d;f=fb-16|0;fb=f;x[f+12>>2]=76695844;x[f+8>>2]=2147483647;e=x[Hb(f+12|0,f+8|0)>>2];fb=f+16|0;b:{if(e>>>0>=d>>>0){d=lX(a);if(d>>>0<e>>>1>>>0){x[h+8>>2]=d<<1;e=x[bd(h+8|0,h+12|0)>>2]}fb=h+16|0;break b}ed();p()}f=Bv(x[a>>2],x[a+4>>2]);h=fb-16|0;fb=h;Lg(c+12|0,i);c:{if(!e){i=0;e=0;break c}if(e>>>0>=76695845){Tj();p()}d=Ec(D(e,56));x[h+12>>2]=e;x[h+8>>2]=d;i=x[h+12>>2];e=x[h+8>>2]}x[c>>2]=e;d=e+D(f,56)|0;x[c+8>>2]=d;x[c+4>>2]=d;l=nc(c),m=e+D(i,56)|0,x[l>>2]=m;fb=h+16|0;e=x[c+8>>2];x[31609]=0;O(683,e|0,b|0);b=x[31609];x[31609]=0;d:{if((b|0)!=1){x[c+8>>2]=x[c+8>>2]+56;h=fb-16|0;fb=h;f=Ab(a);d=vb(h+12|0,x[a+4>>2]);e=vb(h+8|0,x[a>>2]);b=vb(h+4|0,x[c+4>>2]);i=x[d>>2];e=x[e>>2];g=fb+-64|0;fb=g;b=x[b>>2];x[g+56>>2]=b;x[g+60>>2]=i;x[g+52>>2]=b;d=Ag(g+24|0,f,g+52|0,g+56|0);x[g+16>>2]=x[d+8>>2];b=x[d+4>>2];x[g+8>>2]=x[d>>2];x[g+12>>2]=b;zg(g+36|0,g+8|0);while(1){if(Fd(i,e)){b=iX(x[g+56>>2]);f=mX(i);d=Ul(b,f);Ul(d+12|0,f+12|0);DC(d+24|0,f+24|0);w[d+52>>1]=z[f+52>>1];b=x[f+48>>2];x[d+44>>2]=x[f+44>>2];x[d+48>>2]=b;b=x[f+40>>2];x[d+36>>2]=x[f+36>>2];x[d+40>>2]=b;b=jX(g+60|0);jX(g+56|0);i=x[b>>2];continue}break}yg(g+36|0);d=x[g+56>>2];if(!y[g+48|0]){i=fb-16|0;fb=i;b=vb(i+12|0,x[x[g+44>>2]>>2]);e=x[vb(i+8|0,x[x[g+40>>2]>>2])>>2];f=fb-16|0;fb=f;b=x[b>>2];x[f+12>>2]=b;while(1){if(xi(b,e)){j=fb-16|0;fb=j;x[j+12>>2]=b;x[j+12>>2]=x[j+12>>2]+56;fb=j+16|0;ar(iX(x[j+12>>2]));b=f+12|0;x[b>>2]=x[b>>2]+56;b=x[b>>2];continue}break}fb=f+16|0;fb=i+16|0}fb=g- -64|0;x[c+4>>2]=d;Tb(a,c+4|0);Tb(a+4|0,c+8|0);Tb(Ab(a),nc(c));x[c>>2]=x[c+4>>2];fb=h+16|0;kX(c);fb=k+32|0;break d}a=N()|0;kX(c);Q(a|0);p()}}function moa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=fb-112|0;fb=d;a:{b:{c:{d:{switch(y[a|0]-23|0){case 0:e=v[a+1|0];i=d,j=JD(c,+y[a+2|0]*1e4/240),v[i+12|0]=j;x[d+88>>2]=127;x[d+76>>2]=(D(y[a+3|0],127)>>>0)/185;i=d,j=x[Cd(d+88|0,d+76|0)>>2],v[i+111|0]=j;e:{switch(((e>>>0)%5|0)-1|0){case 0:a=d+76|0;qw(a,15670);x[31609]=0;c=d- -64|0;O(559,c|0,d+12|0);e=x[31609];x[31609]=0;f:{g:{h:{i:{if((e|0)!=1){x[31609]=0;e=d+52|0;O(559,e|0,d+111|0);f=x[31609];x[31609]=0;if((f|0)==1){break i}x[31609]=0;f=d+88|0;V(560,f|0,a|0,c|0,e|0);g=x[31609];x[31609]=0;if((g|0)==1){break h}fe(d+100|0,f);rf(b,x[d+100>>2],x[d+104>>2]);tb(f);tb(e);tb(c);Eb(a);break b}a=N()|0;break f}a=N()|0;break g}a=N()|0;tb(d+52|0)}tb(d- -64|0)}break c;case 1:a=d+76|0;qw(a,15617);x[31609]=0;c=d- -64|0;O(559,c|0,d+12|0);e=x[31609];x[31609]=0;j:{k:{l:{m:{if((e|0)!=1){x[31609]=0;e=d+52|0;O(559,e|0,d+111|0);f=x[31609];x[31609]=0;if((f|0)==1){break m}x[31609]=0;f=d+88|0;V(560,f|0,a|0,c|0,e|0);g=x[31609];x[31609]=0;if((g|0)==1){break l}fe(d+44|0,f);rf(b,x[d+44>>2],x[d+48>>2]);tb(f);tb(e);tb(c);Eb(a);break b}a=N()|0;break j}a=N()|0;break k}a=N()|0;tb(d+52|0)}tb(d- -64|0)}break c;default:break e}}a=qc(d+36|0,15697);rf(b,x[a>>2],x[a+4>>2]);break b;case 1:break d;default:break a}}c=v[a+1|0];v[d+111|0]=(c|0)<5?c:0;c=v[a+2|0];v[d+35|0]=(c|0)<0?127:c;a=v[a+3|0];v[d+34|0]=(a|0)<0?127:a;a=fb-16|0;fb=a;c=d+76|0;e=Dc(a+4|0,4048);Uc(c,e);tb(e);fb=a+16|0;x[31609]=0;a=d- -64|0;O(559,a|0,d+111|0);e=x[31609];x[31609]=0;n:{o:{p:{q:{r:{s:{if((e|0)!=1){x[31609]=0;e=d+52|0;O(559,e|0,d+35|0);f=x[31609];x[31609]=0;if((f|0)==1){break s}x[31609]=0;f=d+12|0;O(559,f|0,d+34|0);g=x[31609];x[31609]=0;if((g|0)==1){break r}x[31609]=0;g=d+88|0;aa(740,g|0,c|0,a|0,e|0,f|0);h=x[31609];x[31609]=0;if((h|0)==1){break q}fe(d+24|0,g);rf(b,x[d+24>>2],x[d+28>>2]);tb(g);tb(f);tb(e);tb(a);Eb(c);break b}a=N()|0;break n}a=N()|0;break o}a=N()|0;break p}a=N()|0;tb(d+12|0)}tb(d+52|0)}tb(d- -64|0)}}Eb(d+76|0);Q(a|0);p()}e=1}fb=d+112|0;return e|0}function dua(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;l=fb-32|0;fb=l;d=b;b=x[a>>2];b=(kp(d,wb(b))<<1)+b|0;e=x[a+4>>2];a:{b:{if(e>>>0<A[Ab(a)>>2]){if((b|0)!=(e|0)){break b}d=fb-16|0;fb=d;a=dj(d+4|0,a,1);bj(x[a+4>>2],y[c|0]|y[c+1|0]<<8);x[a+4>>2]=x[a+4>>2]+2;kc(a);fb=d+16|0;break a}d=Ab(a);g=fk(l+12|0,gk(a,$c(x[a>>2],e)+1|0),b-x[a>>2]>>1,d);x[31609]=0;O(294,g|0,c|0);c=x[31609];x[31609]=0;if((c|0)!=1){h=fb-16|0;fb=h;c=x[g+4>>2];j=Ab(a);d=vb(h+12|0,b);f=vb(h+8|0,x[a>>2]);i=vb(h+4|0,x[g+4>>2]);e=x[d>>2];m=x[f>>2];d=fb+-64|0;fb=d;f=x[i>>2];x[d+56>>2]=f;x[d+60>>2]=e;x[d+52>>2]=f;f=Ag(d+24|0,j,d+52|0,d+56|0);x[d+16>>2]=x[f+8>>2];i=x[f+4>>2];x[d+8>>2]=x[f>>2];x[d+12>>2]=i;zg(d+36|0,d+8|0);while(1){if(Fd(e,m)){f=fb-16|0;fb=f;x[f+12>>2]=x[d+56>>2];$$(f+12|0,-1);fb=f+16|0;k=x[f+12>>2];e=Hn(e);bj(k,y[e|0]|y[e+1|0]<<8);e=Xk(d+60|0);Xk(d+56|0);e=x[e>>2];continue}break}e=d+36|0;yg(e);f=x[d+56>>2];a0(e);fb=d- -64|0;x[g+4>>2]=f;f=x[a+4>>2];d=fb-48|0;fb=d;e=x[g+8>>2];x[d+44>>2]=e;x[d+40>>2]=e;e=Ag(d+12|0,j,d+40|0,d+44|0);x[d+8>>2]=x[e+8>>2];j=x[e+4>>2];x[d>>2]=x[e>>2];x[d+4>>2]=j;zg(d+24|0,d);while(1){if((b|0)!=(f|0)){bj(x[d+44>>2],y[b|0]|y[b+1|0]<<8);x[d+44>>2]=x[d+44>>2]+2;b=b+2|0;continue}break}b=d+24|0;yg(b);e=x[d+44>>2];a0(b);fb=d+48|0;x[g+8>>2]=e;Tb(a,g+4|0);Tb(a+4|0,g+8|0);Tb(Ab(a),nc(g));x[g>>2]=x[g+4>>2];fb=h+16|0;b=c;cj(g);break a}a=N()|0;cj(g);Q(a|0);p()}j=fb-16|0;fb=j;h=x[a+4>>2];g=(h-(b+2|0)|0)+b|0;i=dj(j+4|0,a,e-g>>1);f=x[i+4>>2];d=g;while(1){if(d>>>0>=e>>>0){kc(i);f=fb-16|0;fb=f;i=f+8|0;d=h;h=fb-32|0;fb=h;fd(h+24|0,b,g);m=h+16|0;n=x[h+24>>2];g=fb-16|0;fb=g;k=x[h+28>>2];e=k;while(1){if((e|0)!=(n|0)){e=e-2|0;d=_$(d-2|0,e);continue}break}x[g+12>>2]=d;rc(m,k,g+12|0);fb=g+16|0;d=x[h+16>>2];x[h+12>>2]=x[h+20>>2];rc(i,d,h+12|0);fb=h+32|0;fb=f+16|0;fb=j+16|0}else{bj(f,y[d|0]|y[d+1|0]<<8);f=f+2|0;x[i+4>>2]=f;d=d+2|0;continue}break}a=((b>>>0<=c>>>0&A[a+4>>2]>c>>>0)<<1)+c|0;c=y[a|0];v[b+1|0]=y[a+1|0];v[b|0]=c}wb(b);fb=l+32|0}function Ae(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=fb-16|0;fb=h;e=x[a>>2];a:{if(mc(e,x[a+4>>2])){break a}f=x[b+4>>2];if(f>>>0>=A[a+12>>2]){break a}i=z[b+8>>1];j=x[x[a+48>>2]+12>>2];c=z[j+480188>>1];if(i>>>0>=c>>>0&(i|0)!=65535){break a}d=c-1|0;c=(i|0)==65535;l=c?d:i;c=c?0:i;e=md(e,j,f,c);g=y[b+12|0];k=g&4;b:{c:{if(g&2){break c}i=y[b+10|0];f=e;d=c;while(1){if((d&65535)>>>0>(l&65535)>>>0){break c}d:{if(!k){if((i|0)!=y[f+3|0]){break d}break b}if((i|0)==y[f+2|0]){break b}}f=f+6|0;d=d+1|0;continue}}i=l&65535;d=e;f=c;while(1){if(i>>>0>=(f&65535)>>>0){e:{if(!k){if(y[d+3|0]){break e}v[d+3|0]=y[b+10|0];v[d+5|0]=y[b+11|0];break b}if(y[d+2|0]){break e}v[d+2|0]=y[b+10|0];v[d+4|0]=y[b+11|0];break b}d=d+6|0;f=f+1|0;continue}break}f:{if(!(g&1)){break f}d=x[j+480180>>2]&2;g:{h:{i:{if(!k){while(1){if((c&65535)>>>0<=(l&65535)>>>0){j:{k:{switch(y[e+3|0]-9|0){case 4:if(!$v(x[x[j+8>>2]+88>>2],1)){break j}d=1;v[e+2|0]=1;v[e+4|0]=y[e+5|0];v[e+3|0]=y[b+10|0];v[e+5|0]=y[b+11|0];break a;case 0:break k;default:break j}}l:{if(d){f=y[e+5|0];if(f>>>0>128){break j}v[e+2|0]=2;v[e+3|0]=y[b+10|0];a=1;break l}v[e+2|0]=2;v[e+3|0]=y[b+10|0];f=y[e+5|0];a=2}v[e+4|0]=a+(f&255)>>>a;v[e+5|0]=y[b+11|0];break b}e=e+6|0;c=c+1|0;continue}break}if(!k){break i}}f=y[b+11|0];c=13;m:{switch(y[b+10|0]-1|0){case 1:c=9;f=ti(f<<(d?1:2));break;case 0:break m;default:break g}}v[b+11|0]=f;v[b+10|0]=c;g=g&254;break h}v[h+15|0]=0;v[h+14|0]=0;e=b;c=y[b+10|0];n:{if(!(!d|(c|0)!=9)){c=y[b+11|0];if(c>>>0>128){break g}d=2;c=c>>>1|0;break n}f=h+12|0;uw(f,c,y[b+11|0],1);c=h+4|0;ZD(c,h+15|0,h+14|0);YD(c,f);g=y[b+12|0];d=y[h+15|0];if(!d){break g}c=y[h+14|0]}v[e+11|0]=c;v[b+10|0]=d;g=g&254}v[b+12|0]=g}d=1;if(g&1){break f}v[b+12|0]=g^4;if(Ae(a,b)){break a}}d=0;o:{p:{switch(x[b>>2]-1|0){case 0:c=x[b+4>>2]+1|0;if(c>>>0>=A[a+12>>2]){break a}x[b+4>>2]=c;break o;case 1:break p;default:break a}}c=x[b+4>>2];if(!c){break a}x[b+4>>2]=c-1}v[b+12|0]=y[b+12|0]|1;d=Ae(a,b);break a}d=1}fb=h+16|0;return d}function tU(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;c=fb-176|0;fb=c;i=1;p=2;d=x[a+12>>2];q=1<<d;m=q;a:while(1){if(d>>>0>=p>>>0){m=m>>>2|0;v=D(i,3);w=i<<1;h=0;b:while(1){if((h|0)==(m|0)){p=p+2|0;i=i<<2;d=x[a+12>>2];continue a}d=x[a>>2];e=Yd(d,h<<1);DR(c+160|0,C[e>>3],C[e+8>>3]);d=Yd(d,h);DR(c+144|0,C[d>>3],C[d+8>>3]);Ni(c+128|0,C[c+144>>3],C[c+152>>3],C[c+160>>3],C[c+168>>3]);d=h<<p;e=i+d|0;y=d>>>0>e>>>0?d:e;while(1)if((d|0)==(y|0)){h=h+1|0;continue b}else{f=x[b>>2];e=Yd(f,d);g=e+8|0;j=x[g+4>>2];x[c+120>>2]=x[g>>2];x[c+124>>2]=j;g=x[e+4>>2];x[c+112>>2]=x[e>>2];x[c+116>>2]=g;k=d+i|0;g=Yd(f,k);n=C[g+8>>3];o=C[g>>3];r=d+w|0;g=Yd(f,r);j=x[g+12>>2];x[c+104>>2]=x[g+8>>2];x[c+108>>2]=j;j=x[g+4>>2];x[c+96>>2]=x[g>>2];x[c+100>>2]=j;s=d+v|0;f=Yd(f,s);t=C[f+8>>3];u=C[f>>3];g=c+80|0;f=c+112|0;El(g,f,o,n);j=c- -64|0;zj(j,f,o,n);l=c+96|0;El(c+48|0,l,u,t);f=c+16|0;zj(f,l,u,t);Ni(c+32|0,0,1,C[c+16>>3],C[c+24>>3]);El(f,g,C[c+48>>3],C[c+56>>3]);l=x[c+28>>2];x[e+8>>2]=x[c+24>>2];x[e+12>>2]=l;l=x[c+20>>2];x[e>>2]=x[c+16>>2];x[e+4>>2]=l;El(c,j,C[c+32>>3],C[c+40>>3]);Ni(f,C[c+160>>3],C[c+168>>3],C[c>>3],C[c+8>>3]);e=Yd(x[b>>2],k);k=x[c+28>>2];x[e+8>>2]=x[c+24>>2];x[e+12>>2]=k;k=x[c+20>>2];x[e>>2]=x[c+16>>2];x[e+4>>2]=k;zj(c,g,C[c+48>>3],C[c+56>>3]);Ni(f,C[c+144>>3],C[c+152>>3],C[c>>3],C[c+8>>3]);e=Yd(x[b>>2],r);g=x[c+28>>2];x[e+8>>2]=x[c+24>>2];x[e+12>>2]=g;g=x[c+20>>2];x[e>>2]=x[c+16>>2];x[e+4>>2]=g;zj(c,j,C[c+32>>3],C[c+40>>3]);Ni(f,C[c+128>>3],C[c+136>>3],C[c>>3],C[c+8>>3]);e=Yd(x[b>>2],s);f=x[c+28>>2];x[e+8>>2]=x[c+24>>2];x[e+12>>2]=f;f=x[c+20>>2];x[e>>2]=x[c+16>>2];x[e+4>>2]=f;d=d+1|0;continue}}}break}c:{if(!(d&1)){break c}i=q>>>1|0;d=0;while(1){if((d|0)==(i|0)){break c}h=x[b>>2];a=Yd(h,d+i|0);m=Yd(h,d);n=C[a>>3];o=C[a+8>>3];zj(c+160|0,m,n,o);h=x[c+172>>2];x[a+8>>2]=x[c+168>>2];x[a+12>>2]=h;h=x[c+164>>2];x[a>>2]=x[c+160>>2];x[a+4>>2]=h;zA(Yd(x[b>>2],d),n,o);d=d+1|0;continue}}fb=c+176|0}function Kla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0;f=fb-48|0;fb=f;u=x[a+16>>2];v=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);b=0;o=x[a+128>>2];if(o){i=x[a+8>>2];g=x[a+12>>2];p=Hg(i,g,o);q=hb;h=x[a+76>>2];fg(x[a>>2],x[a+4>>2],vf(i,g,d),hb);n=hb>>>0>h>>>0?d:0}else{n=0}j=a+112|0;while(1){if((b|0)!=2){g=b<<3;h=g+(f+20|0)|0;g=a+g|0;x[h+4>>2]=x[g+44>>2];x[h+8>>2]=x[g+48>>2];b=b+1|0;continue}break}y=x[a+24>>2];z=x[a+20>>2];b=x[a+4>>2];x[f+8>>2]=x[a>>2];x[f+12>>2]=b;A=x[a+8>>2];B=x[a+12>>2];a:while(1){if(d){d=d-1|0;g=x[f+12>>2];b=x[f+8>>2];x[f+40>>2]=b;x[f+44>>2]=0;n=n-1|0;h=n;p=h?p:0;q=h?q:0;i=((((g&2147483647)<<1|b>>>31)&2147483646)<<1)+u|0;b=o;while(1)if((b|0)<=0){Pb(j,x[a+120>>2],x[a+124>>2]);h=x[a+116>>2];if(h){b=x[f+40>>2];b=(x[f+44>>2]&2147483647)<<1|b>>>31;ce(j,(w[((b&2147483646)<<1)+i>>1]+w[i+(b<<1|2)>>1]|0)/8<<16>>16);be(j,h);x[j>>2]=x[j>>2];x[j+4>>2]=0}b=Fg(j,v);x[f+4>>2]=b;x[f>>2]=b;C=x[a+72>>2];r=x[a+68>>2];E=r>>31;i=x[a+64>>2];F=i>>31;h=x[a+60>>2];G=h>>31;b=0;while(1){if((b|0)!=2){s=(b<<2)+f|0;e=x[s>>2];g=(f+20|0)+(b<<3)|0;H=x[g+8>>2];k=x[g+4>>2];x[g+8>>2]=k;t=e<<8;e=t;e=Iua(e,e>>31,h,G);l=hb;m=e;e=Yb(k,-16777216,16776704);e=Iua(i,F,e,e>>31);k=m+e|0;m=hb+l|0;m=e>>>0>k>>>0?m+1|0:m;e=Yb(H,-16777216,16776704);l=Iua(r,E,e,e>>31);k=l+k|0;e=hb+m|0;e=k>>>0<l>>>0?e+1|0:e;l=k+8388608|0;e=l>>>0<8388608?e+1|0:e;e=Sc(l,e,24);x[g+4>>2]=e-(C&t);x[s>>2]=(e|0)/256;b=b+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[f>>2],z);x[c+4>>2]=x[c+4>>2]+D(y,x[f+4>>2]);Pb(f+8|0,A,B);c=c+8|0;continue a}else{g=x[f+40>>2];g=(x[f+44>>2]&2147483647)<<1|g>>>31;ce(j,(w[((g&2147483646)<<1)+i>>1]+w[i+(g<<1|2)>>1]|0)/8<<16>>16);be(j,4);Pb(f+40|0,p,q);b=b-1|0;continue}}break}b=x[f+12>>2];x[a>>2]=x[f+8>>2];x[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+20|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function pma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0;f=fb-48|0;fb=f;g=x[a+8>>2];q=g;h=x[a+12>>2];n=h;a:{b:{c:{d:{if((h|0)<=1&g>>>0<=805306368|(h|0)<=0){g=h;if((g|0)>-2){e=1}else{e=(g|0)>=-2&q>>>0>=3489660928}if(e){break c}if((n|0)==-2&q>>>0>2147483647|(n|0)==-1){break d}break b}if((n|0)==1&q>>>0>2147483648|n>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}v=b;y=x[a+16>>2];b=0;while(1){if((b|0)!=2){g=b<<3;h=g+(f+28|0)|0;g=a+g|0;x[h+4>>2]=x[g+44>>2];x[h+8>>2]=x[g+48>>2];b=b+1|0;continue}break}z=x[a+24>>2];A=x[a+20>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;B=x[a+72>>2];u=x[a+68>>2];C=u>>31;h=x[a+64>>2];E=h>>31;g=x[a+60>>2];F=g>>31;while(1){if(d){b=x[f+16>>2];i=((((x[f+20>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+y|0;b=(b>>>16&65520)+v|0;m=w[b+14>>1];r=w[b+12>>1];t=w[b+10>>1];j=w[b+8>>1];s=w[b+6>>1];k=w[b+4>>1];e=w[b+2>>1];b=w[b>>1];o=0;p=0;while(1){if((p|0)!=2){l=p<<1;x[(f+8|0)+(p<<2)>>2]=(((((((D(w[i+(l|-8)>>1],e)+D(w[i+(l|-12)>>1],b)|0)+D(w[i+(l|-4)>>1],k)|0)+D(w[i+l>>1],s)|0)+D(w[i+(l|4)>>1],j)|0)+D(w[i+(l|8)>>1],t)|0)+D(r,w[i+(l|12)>>1])|0)+D(m,w[i+(l|16)>>1])|0)/32768;p=p+1|0;continue}break}while(1){if((o|0)!=2){r=(f+8|0)+(o<<2)|0;e=x[r>>2];b=(f+28|0)+(o<<3)|0;t=x[b+8>>2];j=x[b+4>>2];x[b+8>>2]=j;s=e<<8;e=s;e=Iua(e,e>>31,g,F);k=hb;i=e;e=Yb(j,-16777216,16776704);e=Iua(h,E,e,e>>31);j=i+e|0;m=hb+k|0;m=e>>>0>j>>>0?m+1|0:m;e=Yb(t,-16777216,16776704);k=Iua(u,C,e,e>>31);j=k+j|0;e=hb+m|0;e=j>>>0<k>>>0?e+1|0:e;k=j+8388608|0;e=k>>>0<8388608?e+1|0:e;e=Sc(k,e,24);x[b+4>>2]=e-(s&B);x[r>>2]=(e|0)/256;o=o+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[f+8>>2],A);x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],z);Pb(f+16|0,q,n);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function T7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;j=fb-16|0;fb=j;k=Ry(x[g>>2]);o=Fy(x[g>>2]);sh(j+4|0,o);x[f>>2]=d;a:{b:{c:{i=a;g=y[i|0];switch(g-43|0){case 0:case 2:break c;default:break b}}x[31609]=0;g=P(1270,k|0,g<<24>>24)|0;i=x[31609];x[31609]=0;if((i|0)==1){break a}i=x[f>>2];x[f>>2]=i+4;x[i>>2]=g;i=a+1|0}d:{g=i;if(!((c-g|0)<=1|y[g|0]!=48|(y[g+1|0]|32)!=120)){x[31609]=0;i=P(1270,k|0,48)|0;h=x[31609];x[31609]=0;if((h|0)==1){break a}h=x[f>>2];x[f>>2]=h+4;x[h>>2]=i;i=v[g+1|0];x[31609]=0;i=P(1270,k|0,i|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break a}h=x[f>>2];x[f>>2]=h+4;x[h>>2]=i;i=g+2|0;g=i;while(1){if(c>>>0<=g>>>0){break d}h=v[g|0];Od();if(!DI(h)){break d}g=g+1|0;continue}}while(1){if(c>>>0<=g>>>0){break d}h=v[g|0];Od();if(!Nh(h)){break d}g=g+1|0;continue}}e:{if(Ad(x[j+8>>2],y[j+15|0])){h=x[f>>2];x[31609]=0;V(1263,k|0,i|0,g|0,h|0);h=x[31609];x[31609]=0;if((h|0)==1){break a}x[f>>2]=x[f>>2]+(g-i<<2);break e}Em(i,g);x[31609]=0;r=R(1261,o|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break a}h=i;while(1){if(g>>>0<=h>>>0){ut((i-a<<2)+d|0,x[f>>2]);break e}f:{if(v[dc(j+4|0,l)|0]<=0){break f}if(v[dc(j+4|0,l)|0]!=(m|0)){break f}m=x[f>>2];x[f>>2]=m+4;x[m>>2]=r;l=(Cb(x[j+8>>2],y[j+15|0])-1>>>0>l>>>0)+l|0;m=0}q=v[h|0];x[31609]=0;q=P(1270,k|0,q|0)|0;n=x[31609];x[31609]=0;if((n|0)!=1){n=x[f>>2];x[f>>2]=n+4;x[n>>2]=q;h=h+1|0;m=m+1|0;continue}break}break a}g:{while(1){if(c>>>0>g>>>0){i=v[g|0];if((i|0)==46){x[31609]=0;i=R(1264,o|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break a}l=x[f>>2];h=l+4|0;x[f>>2]=h;x[l>>2]=i;g=g+1|0;break g}x[31609]=0;i=P(1270,k|0,i|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break a}h=x[f>>2];x[f>>2]=h+4;x[h>>2]=i;g=g+1|0;continue}break}h=x[f>>2]}x[31609]=0;V(1263,k|0,g|0,c|0,h|0);i=x[31609];x[31609]=0;if((i|0)==1){break a}i=f;f=x[f>>2]+(c-g<<2)|0;x[i>>2]=f;x[e>>2]=(b|0)==(c|0)?f:(b-a<<2)+d|0;tb(j+4|0);fb=j+16|0;return}a=N()|0;tb(j+4|0);Q(a|0);p()}function iK(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;e=x[b>>2];a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{if(!d){break l}g=x[d>>2];if(!g){break l}if(!a){d=c;break j}x[d>>2]=0;d=c;break k}m:{if(!x[x[124115]>>2]){if(!a){break m}if(!c){break a}g=c;while(1){d=v[e|0];if(d){x[a>>2]=d&57343;a=a+4|0;e=e+1|0;g=g-1|0;if(g){continue}break a}break}x[a>>2]=0;x[b>>2]=0;return c-g|0}d=c;if(!a){break i}break g}return Df(e)}f=1;break g}f=0;break h}f=1}while(1){if(!f){f=y[e|0]>>>3|0;if((f-16|f+(g>>26))>>>0>7){break f}f=e+1|0;n:{if(!(g&33554432)){break n}if((y[f|0]&192)!=128){e=e-1|0;break d}f=e+2|0;if(!(g&524288)){break n}if((y[f|0]&192)!=128){e=e-1|0;break d}f=e+3|0}e=f;d=d-1|0;f=1;continue}while(1){g=y[e|0];o:{if(e&3|g-1>>>0>126){break o}g=x[e>>2];if((g|g-16843009)&-2139062144){break o}while(1){d=d-4|0;g=x[e+4>>2];e=e+4|0;if(!((g-16843009|g)&-2139062144)){continue}break}}f=g&255;if(f-1>>>0<=126){d=d-1|0;e=e+1|0;continue}break}f=f-194|0;if(f>>>0>50){break e}e=e+1|0;g=x[(f<<2)+120704>>2];f=0;continue}}while(1){if(!f){if(!d){break a}while(1){p:{f=y[e|0];h=f-1|0;q:{r:{if(h>>>0>126){g=f;break r}if(e&3|d>>>0<5){break q}s:{while(1){g=x[e>>2];if((g|g-16843009)&-2139062144){break s}x[a>>2]=g&255;x[a+4>>2]=y[e+1|0];x[a+8>>2]=y[e+2|0];x[a+12>>2]=y[e+3|0];a=a+16|0;e=e+4|0;d=d-4|0;if(d>>>0>4){continue}break}g=y[e|0]}f=g&255;h=f-1|0}if(h>>>0>126){break p}}x[a>>2]=f;a=a+4|0;e=e+1|0;d=d-1|0;if(d){continue}break a}break}f=f-194|0;if(f>>>0>50){break e}e=e+1|0;g=x[(f<<2)+120704>>2];f=1;continue}i=y[e|0];f=i>>>3|0;if((f-16|f+(g>>26))>>>0>7){break f}t:{u:{h=e+1|0;f=i-128|g<<6;v:{if((f|0)>=0){break v}h=y[h|0]-128|0;if(h>>>0>63){break u}i=f<<6;f=h|i;h=e+2|0;if((i|0)>=0){break v}h=y[h|0]-128|0;if(h>>>0>63){break u}f=h|f<<6;h=e+3|0}e=h;x[a>>2]=f;d=d-1|0;a=a+4|0;break t}x[31484]=25;e=e-1|0;break c}f=0;continue}}e=e-1|0;if(g){break d}g=y[e|0]}if(g&255){break d}if(a){x[a>>2]=0;x[b>>2]=0}return c-d|0}x[31484]=25;if(!a){break b}}x[b>>2]=e}return-1}x[b>>2]=e;return c}function Sna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=fb-32|0;fb=h;a:{b:{if(hv(a)>>>0<b>>>0){if((b|0)<0){break b}j=So(h+20|0);x[31609]=0;O(761,j|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}nn(h+12|0,x[a>>2]);$q(h+4|0,x[a>>2],x[a+4>>2]);g=x[h+12>>2];f=x[h+16>>2];k=fb-48|0;fb=k;b=x[j+4>>2];c=b+x[a+4>>2]|0;x[j+4>>2]=c;c:{d:{if(!b){i=c-1|0;break d}i=c-1|0;if((i^b-1)>>>0<32){break c}}x[x[j>>2]+((c>>>0>=33?i>>>5|0:0)<<2)>>2]=0}c=Zb(k+40|0,g,f);g=Zb(k+32|0,x[h+4>>2],x[h+8>>2]);xp(k+24|0,x[j>>2],b);i=fb-32|0;fb=i;b=Zb(i+24|0,x[c>>2],x[c+4>>2]);c=Zb(i+16|0,x[g>>2],x[g+4>>2]);m=Zb(i+8|0,x[k+24>>2],x[k+28>>2]);g=fb-32|0;fb=g;q=k+8|0;f=Zb(g+24|0,x[b>>2],x[b+4>>2]);c=Zb(g+16|0,x[c>>2],x[c+4>>2]);m=Zb(g+8|0,x[m>>2],x[m+4>>2]);b=fb-128|0;fb=b;e=Zb(b+104|0,x[f>>2],x[f+4>>2]);c=Zb(b+96|0,x[c>>2],x[c+4>>2]);d=fb-16|0;fb=d;e=Zb(d+8|0,x[e>>2],x[e+4>>2]);l=Zb(d,x[c>>2],x[c+4>>2]);c=fb-32|0;fb=c;e=Zb(c+16|0,x[e>>2],x[e+4>>2]);mn(c+24|0,x[e>>2],x[e+4>>2]);e=c+8|0;l=Zb(c,x[l>>2],x[l+4>>2]);mn(e,x[l>>2],x[l+4>>2]);JV(b+112|0,x[c+24>>2],x[c+28>>2],e);fb=c+32|0;fb=d+16|0;e=Zb(b+72|0,x[b+112>>2],x[b+116>>2]);l=Zb(b- -64|0,x[b+120>>2],x[b+124>>2]);d=b+56|0;c=Zb(b+48|0,x[m>>2],x[m+4>>2]);mn(d,x[c>>2],x[c+4>>2]);r=b+80|0;c=fb-16|0;fb=c;while(1){n=x[e>>2];o=x[e+4>>2];if(fX(n,o,x[l>>2],x[l+4>>2])){Nt(c+8|0,n,o);Nt(c,x[d>>2],x[d+4>>2]);kf(c,Gb(x[x[c+8>>2]>>2],x[c+12>>2]));zv(e);zv(d);continue}break}KV(r,n,o,d);fb=c+16|0;f=Zb(b+32|0,x[f>>2],x[f+4>>2]);d=Zb(b+24|0,x[b+80>>2],x[b+84>>2]);c=fb-16|0;fb=c;e=Zb(c+8|0,x[f>>2],x[f+4>>2]);d=Zb(c,x[d>>2],x[d+4>>2]);f=fb-16|0;fb=f;Zb(f+8|0,x[e>>2],x[e+4>>2]);d=Zb(f,x[d>>2],x[d+4>>2]);mn(b+40|0,x[d>>2],x[d+4>>2]);fb=f+16|0;fb=c+16|0;Zb(b+8|0,x[m>>2],x[m+4>>2]);c=b+16|0;f=Zb(b,x[b+88>>2],x[b+92>>2]);mn(c,x[f>>2],x[f+4>>2]);KV(q,x[b+40>>2],x[b+44>>2],c);fb=b+128|0;fb=g+32|0;fb=i+32|0;fb=k+48|0;lC(a,j);tf(j)}fb=h+32|0;return}ed();p()}a=N()|0;tf(j);Q(a|0);p()}function Ki(a,b,c,d,e,f){var g=0,h=0,i=0,j=E(0),k=E(0),l=0,m=0,n=E(0),o=E(0),p=E(0),q=0,r=E(0);m=ib[x[x[a>>2]+140>>2]](a)|0;g=x[a+20>>2];h=m?h:y[g+25|0];j=B[g+144>>2];k=E(1);if(!(ib[x[x[a>>2]+140>>2]](a)|0)){k=B[x[a+20>>2]+144>>2]}j=E(E(1)-j);a:{if((ib[x[x[a>>2]+156>>2]](a)|0)<=0){break a}if(!vQ(y[x[a+20>>2]+24|0])){break a}j=E(E(j+j)+E(-1));k=E(-j)}n=B[a+4196>>2];k=E(k*n);j=E(j*n);g=0;l=x[a+44>>2];m=Hc(l,0);l=Hc(l,1);b:{c:{d:{e:{f:{g:{h:{h=h&255;switch(h|0){case 0:break h;case 5:break c;case 4:break d;case 3:break e;case 2:break f;case 1:break g;default:break b}}while(1){if((f|0)==(h|0)){break b}g=h<<2;i=g+b|0;B[i>>2]=B[i>>2]+E(E(B[d+g>>2]*j)+E(k*B[g+m>>2]));i=c+g|0;B[i>>2]=B[i>>2]+E(E(B[e+g>>2]*j)+E(k*B[g+l>>2]));h=h+1|0;continue}}while(1){if((f|0)==(g|0)){break b}h=g<<2;i=h+b|0;B[i>>2]=B[i>>2]+E(B[h+m>>2]-E(B[d+h>>2]*j));i=c+h|0;B[i>>2]=B[i>>2]+E(B[h+l>>2]-E(B[e+h>>2]*j));g=g+1|0;continue}}while(1){if((f|0)==(g|0)){break b}h=g<<2;i=h+b|0;B[i>>2]=B[i>>2]+E(B[d+h>>2]-E(B[h+m>>2]*k));i=c+h|0;B[i>>2]=B[i>>2]+E(B[e+h>>2]-E(B[h+l>>2]*k));g=g+1|0;continue}}while(1){if((f|0)==(g|0)){break b}h=g<<2;i=h+b|0;B[i>>2]=B[i>>2]-E(B[d+h>>2]-E(B[h+m>>2]*j));i=c+h|0;B[i>>2]=B[i>>2]-E(B[e+h>>2]-E(B[h+l>>2]*j));g=g+1|0;continue}}while(1){if((f|0)==(g|0)){break b}h=g<<2;i=h+b|0;k=B[i>>2];q=i;r=k;n=B[h+m>>2];i=c+h|0;o=B[i>>2];p=B[h+l>>2];k=E(E(E(E(k+n)+o)+p)*E(.5));B[q>>2]=r-E(E(k+E(k-E(B[d+h>>2]*j)))-n);B[i>>2]=o-E(E(k+E(k-E(B[e+h>>2]*j)))-p);g=g+1|0;continue}}g=vQ(y[x[a+20>>2]+24|0]);j=g?E(j*E(.5)):j;k=g?E(k*E(.5)):k;h=0;while(1){if((f|0)==(h|0)){break b}g=h<<2;i=g+b|0;n=E(B[d+g>>2]-B[g+m>>2]);o=E(B[g+l>>2]-B[e+g>>2]);B[i>>2]=B[i>>2]+E(E(j*n)+E(k*o));g=c+g|0;B[g>>2]=B[g>>2]+E(E(k*n)+E(j*o));h=h+1|0;continue}}i:{if(!((y[x[a+20>>2]+24|0]&4)>>>2|0)){break i}if(ib[x[x[a>>2]+140>>2]](a)|0){break i}g=0;while(1){if((f|0)==(g|0)){break i}a=g<<2;d=a+b|0;B[d>>2]=B[a+m>>2]+B[d>>2];d=a+c|0;B[d>>2]=B[a+l>>2]+B[d>>2];g=g+1|0;continue}}}function Kra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=E(0),i=0,j=E(0);e=fb-96|0;fb=e;d=fb-16|0;fb=d;c=b+16|0;hZ(d+8|0,c);g=x[d+12>>2];lc(d,x[a>>2],x[a+8>>2],x[d+8>>2],x[d+12>>2]);f=x[d+4>>2];if((f|0)==(g|0)){Vb(a,x[d+12>>2])}fb=d+16|0;if((f|0)!=(g|0)){Rb(c,0,128)}v[b+79|0]=0;v[b+143|0]=0;x[b+152>>2]=-2147483648;x[b+156>>2]=-2147483648;d=e+56|0;he(d,a,Rg(a));g=hc(e+76|0,d);ub(d);x[31609]=0;c=R(202,g|0)|0;f=x[31609];x[31609]=0;a:{b:{if((f|0)==1){break b}x[31609]=0;O(287,b+4|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}se(e+48|0,x[b+4>>2],x[b+8>>2]);x[31609]=0;Zn(471,d,g,x[e+48>>2],x[e+52>>2]);c=x[31609];x[31609]=0;if((c|0)!=1){x[31609]=0;f=R(151,a|0)|0;c=x[31609];x[31609]=0;c:{if((c|0)==1){break c}x[31609]=0;c=e+28|0;S(185,c|0,a|0,f|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}d=hc(d,c);ub(c);a=x[d>>2];x[31609]=0;a=R(172,a|0)|0;c=x[31609];x[31609]=0;d:{if((c|0)!=1){e:{f:{g:{if(!a){break g}while(1){a=x[d+8>>2];c=x[d>>2];x[31609]=0;a=U(150,c|0,a|0,5)|0;c=x[31609];x[31609]=0;if((c|0)==1){break f}if(!a){break g}x[31609]=0;P(472,d|0,e+24|0)|0;a=x[31609];x[31609]=0;h:{if((a|0)!=1){a=4;c=y[e+24|0]|y[e+25|0]<<8|(y[e+26|0]<<16|y[e+27|0]<<24);if((c|0)==1414682436|(c|0)==1196380752){break h}x[31609]=0;a=R(151,d|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break h}a=N()|0;break d}a=N()|0;break d}x[31609]=0;f=e+4|0;S(185,f|0,d|0,a|0);a=x[31609];x[31609]=0;i:{j:{if((a|0)!=1){c=hc(e+28|0,f);ub(f);if((y[e+24|0]|y[e+25|0]<<8|(y[e+26|0]<<16|y[e+27|0]<<24))!=1414682436){break j}x[31609]=0;h=E(xa(473,c|0));a=x[31609];x[31609]=0;if((a|0)==1){break e}i=b,j=Pd(h,E(0)),B[i+144>>2]=j;break i}a=N()|0;break d}if((y[e+24|0]|y[e+25|0]<<8|(y[e+26|0]<<16|y[e+27|0]<<24))!=1196380752){break i}x[31609]=0;a=R(151,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}x[b+148>>2]=a}ub(c);continue}}ub(d);ub(g);fb=e+96|0;return}a=N()|0;break d}a=N()|0;ub(c);break d}a=N()|0}ub(d);break a}a=N()|0;break a}a=N()|0;break a}a=N()|0}ub(g);Q(a|0);p()}function qma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0;f=fb-48|0;fb=f;g=x[a+8>>2];o=g;h=x[a+12>>2];m=h;a:{b:{c:{d:{if((h|0)<=1&g>>>0<=805306368|(h|0)<=0){g=h;if((g|0)>-2){e=1}else{e=(g|0)>=-2&o>>>0>=3489660928}if(e){break c}if((m|0)==-2&o>>>0>2147483647|(m|0)==-1){break d}break b}if((m|0)==1&o>>>0>2147483648|m>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}t=b;u=x[a+16>>2];b=0;while(1){if((b|0)!=2){g=b<<3;h=g+(f+28|0)|0;g=a+g|0;x[h+4>>2]=x[g+44>>2];x[h+8>>2]=x[g+48>>2];b=b+1|0;continue}break}y=x[a+24>>2];z=x[a+20>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;A=x[a+72>>2];s=x[a+68>>2];B=s>>31;h=x[a+64>>2];C=h>>31;g=x[a+60>>2];E=g>>31;while(1){if(d){b=x[f+16>>2];i=(((x[f+20>>2]&2147483647)<<1|b>>>31)&-2)+u|0;b=(b>>>16&65520)+t|0;F=w[b+14>>1];l=w[b+12>>1];p=w[b+10>>1];r=w[b+8>>1];j=w[b+6>>1];q=w[b+4>>1];k=w[b+2>>1];e=w[b>>1];n=0;b=0;while(1){if((b|0)!=2){x[(f+8|0)+(b<<2)>>2]=(((((((D(v[i+(b|-4)|0],k)+D(v[i+(b|-6)|0],e)|0)+D(v[i+(b|-2)|0],q)|0)+D(v[b+i|0],j)|0)+D(v[i+(b|2)|0],r)|0)+D(p,v[i+(b|4)|0])|0)+D(l,v[i+(b|6)|0])|0)+D(F,v[i+(b|8)|0])<<8)/32768;b=b+1|0;continue}break}while(1){if((n|0)!=2){p=(f+8|0)+(n<<2)|0;e=x[p>>2];b=(f+28|0)+(n<<3)|0;r=x[b+8>>2];j=x[b+4>>2];x[b+8>>2]=j;q=e<<8;e=q;e=Iua(e,e>>31,g,E);k=hb;i=e;e=Yb(j,-16777216,16776704);e=Iua(h,C,e,e>>31);j=i+e|0;l=hb+k|0;l=e>>>0>j>>>0?l+1|0:l;e=Yb(r,-16777216,16776704);k=Iua(s,B,e,e>>31);j=k+j|0;e=hb+l|0;e=j>>>0<k>>>0?e+1|0:e;k=j+8388608|0;e=k>>>0<8388608?e+1|0:e;e=Sc(k,e,24);x[b+4>>2]=e-(q&A);x[p>>2]=(e|0)/256;n=n+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[f+8>>2],z);x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],y);Pb(f+16|0,o,m);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function b8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;j=fb-16|0;fb=j;k=Fw(x[g>>2]);o=Ly(x[g>>2]);sh(j+4|0,o);x[f>>2]=d;a:{b:{c:{h=a;g=y[h|0];switch(g-43|0){case 0:case 2:break c;default:break b}}x[31609]=0;g=P(29,k|0,g<<24>>24)|0;h=x[31609];x[31609]=0;if((h|0)==1){break a}h=x[f>>2];x[f>>2]=h+1;v[h|0]=g;h=a+1|0}d:{g=h;if(!((c-g|0)<=1|y[g|0]!=48|(y[g+1|0]|32)!=120)){x[31609]=0;h=P(29,k|0,48)|0;i=x[31609];x[31609]=0;if((i|0)==1){break a}i=x[f>>2];x[f>>2]=i+1;v[i|0]=h;h=v[g+1|0];x[31609]=0;h=P(29,k|0,h|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break a}i=x[f>>2];x[f>>2]=i+1;v[i|0]=h;h=g+2|0;g=h;while(1){if(c>>>0<=g>>>0){break d}i=v[g|0];Od();if(!DI(i)){break d}g=g+1|0;continue}}while(1){if(c>>>0<=g>>>0){break d}i=v[g|0];Od();if(!Nh(i)){break d}g=g+1|0;continue}}e:{if(Ad(x[j+8>>2],y[j+15|0])){i=x[f>>2];x[31609]=0;V(1249,k|0,h|0,g|0,i|0);i=x[31609];x[31609]=0;if((i|0)==1){break a}x[f>>2]=x[f>>2]+(g-h|0);break e}Em(h,g);x[31609]=0;r=R(1247,o|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break a}i=h;while(1){if(g>>>0<=i>>>0){Em((h-a|0)+d|0,x[f>>2]);break e}f:{if(v[dc(j+4|0,m)|0]<=0){break f}if(v[dc(j+4|0,m)|0]!=(l|0)){break f}l=x[f>>2];x[f>>2]=l+1;v[l|0]=r;m=(Cb(x[j+8>>2],y[j+15|0])-1>>>0>m>>>0)+m|0;l=0}q=v[i|0];x[31609]=0;q=P(29,k|0,q|0)|0;n=x[31609];x[31609]=0;if((n|0)!=1){n=x[f>>2];x[f>>2]=n+1;v[n|0]=q;i=i+1|0;l=l+1|0;continue}break}break a}while(1){g:{if(c>>>0>g>>>0){h=v[g|0];if((h|0)!=46){break g}x[31609]=0;h=R(1250,o|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break a}i=x[f>>2];x[f>>2]=i+1;v[i|0]=h;g=g+1|0}h=x[f>>2];x[31609]=0;V(1249,k|0,g|0,c|0,h|0);h=x[31609];x[31609]=0;if((h|0)==1){break a}h=f;f=x[f>>2]+(c-g|0)|0;x[h>>2]=f;x[e>>2]=(b|0)==(c|0)?f:(b-a|0)+d|0;tb(j+4|0);fb=j+16|0;return}x[31609]=0;h=P(29,k|0,h|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break a}i=x[f>>2];x[f>>2]=i+1;v[i|0]=h;g=g+1|0;continue}}a=N()|0;tb(j+4|0);Q(a|0);p()}function Efa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=fb-80|0;fb=j;a:{b:{c:{k=dr(1,32);d:{e:{if(!k){a=un(ac(4));x[31609]=0;S(97,a|0,124540,34);a=x[31609];x[31609]=0;if((a|0)!=1){break a}i=T(0)|0;break e}x[k+12>>2]=f;x[k+8>>2]=e;x[k+4>>2]=d;f=c?c:977;x[k>>2]=f;c=og(j+68|0);f:{g:{h:{if(!i){break h}while(1){e=x[i>>2];if(!e){break h}l=x[i+4>>2];i:{if(l){x[31609]=0;e=P(36,j+56|0,e|0)|0;m=x[31609];x[31609]=0;j:{if((m|0)!=1){x[31609]=0;m=P(988,c|0,e|0)|0;n=x[31609];x[31609]=0;if((n|0)==1){break j}x[31609]=0;O(272,m|0,l|0);l=x[31609];x[31609]=0;if((l|0)==1){break j}break i}i=T(0)|0;break f}i=T(0)|0;tb(e);break f}x[31609]=0;e=P(36,j+44|0,e|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break g}hu(c,e)}tb(e);i=i+8|0;continue}}e=x[a+8>>2];i=x[a+4>>2];l=x[a>>2];x[31609]=0;a=R(852,104)|0;m=x[31609];x[31609]=0;k:{l:{m:{if((m|0)!=1){x[j+40>>2]=e;x[j+36>>2]=i;x[j+32>>2]=l;x[j+28>>2]=b;x[31609]=0;b=P(989,f|0,d|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break m}x[j+20>>2]=b;d=j+20|0;b=x[re(j+24|0,d)>>2];e=x[j+40>>2];x[j+8>>2]=x[j+36>>2];x[j+12>>2]=e;x[31609]=0;e=x[j+32>>2];x[j>>2]=x[j+28>>2];x[j+4>>2]=e;b=ba(1019,a|0,j|0,b|0,c|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break k}i=T(0)|0;Wc(d);break l}i=T(0)|0;break f}i=T(0)|0}Db(a);break f}x[k+28>>2]=b;Wc(j+20|0);x[k+24>>2]=b+8;Ol(c);break d}i=T(0)|0}Ol(c);Y(i|0)|0;x[31609]=0;V(983,11356,k|0,g|0,h|0);a=x[31609];x[31609]=0;if((a|0)!=1){x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)!=1){a=x[k+28>>2];if(a){ib[x[x[a>>2]+4>>2]](a)}x[k+24>>2]=0;x[k+28>>2]=0;a=x[k+20>>2];if(a){Db(a);x[k+20>>2]=0}Db(k);k=0;break d}i=T(0)|0;break e}i=T(0)|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)==1){break b}}Y(i|0)|0;k=0;x[31609]=0;V(983,11356,0,g|0,h|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Z()}fb=j+80|0;return k|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){break b}Q(a|0);p()}T(0)|0;Sb()}p()}function Q1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;d=fb-112|0;fb=d;yc(b);Kp(a);f=d+104|0;a:{if(!wi(b,f)){break a}if(!hG(f)){break a}b:{if(!c){break b}if(!Mb(x[b>>2],x[b+8>>2],4)){break a}tx(a);q=d,r=sx(),x[q+84>>2]=r;c=d+84|0;rx(ej(x[a+4>>2])+32|0,c);ms(c);l=x[ej(x[a+4>>2])+32>>2];c=Lh(x[b>>2]);if(c&1){break a}e=c-4|0;dd(b,e);f=fb-16|0;fb=f;c=f+13|0;fx(c,b);i=y[xb(c,0)|0];j=y[xb(c,1)|0];c=xb(c,2);fb=f+16|0;i=y[c|0]|(j<<8|i<<16);if(!i){break a}x[31609]=0;O(39,l|0,i|0);c=x[31609];x[31609]=0;c:{if((c|0)==1){b=T(124540)|0;if((gb|0)!=($(124540)|0)){break c}Y(b|0)|0;Z();break a}dd(b,4);k=d+84|0;gG(k,b,e);Nn(d- -64|0,k);lf(d+76|0,x[d+64>>2],x[d+68>>2]);c=x[d+80>>2];j=x[l>>2];e=fb-32|0;fb=e;b=x[d+76>>2];q=e,r=y[xb(b,0)|0],v[q+28|0]=r;q=e,r=y[xb(b,1)|0],v[q+29|0]=r;q=e,r=y[xb(b,2)|0],v[q+30|0]=r;q=e,r=y[xb(b,3)|0],v[q+31|0]=r;f=bs(e+12|0);c=b+c|0;x[f+12>>2]=c-4;x[f+8>>2]=b;jk(f,y[c-1|0]);m=j-1|0;c=i;d:while(1){e:{f:{g:{if(!c){break g}if(jk(f,1)){break f}b=1;while(1){g=jk(f,2);b=g+b|0;if((g|0)==3){continue}break}x[e+8>>2]=b;xc(e+8|0,c);b=0;g=x[e+8>>2];while(1)if((b|0)==(g|0)){if(!c){break g}break f}else{c=c-1|0;q=j+c|0,r=jk(f,8),v[q|0]=r;b=b+1|0;continue}}fb=e+32|0;break e}g=jk(f,2);b=g+2|0;x[e+8>>2]=b;h:{if((g|0)==3){i:{if(!jk(f,1)){b=5;g=7;break i}g=y[xb(e+28|0,3)|0]}g=jk(f,g);while(1){h=jk(f,3);b=h+b|0;if((h|0)==7){continue}break}x[e+8>>2]=b;break h}g=jk(f,y[xb(e+28|0,g)|0])}xc(e+8|0,c);b=0;n=x[e+8>>2];while(1){if((b|0)==(n|0)){continue d}o=c+m|0;h=c+g|0;if(i>>>0>h>>>0){h=y[j+h|0]}else{h=0}v[o|0]=h;b=b+1|0;c=c-1|0;continue}}break}se(d+24|0,x[l>>2],x[l+4>>2]);lf(d+32|0,x[d+24>>2],x[d+28>>2]);b=Md(d+16|0);x[31609]=0;c=x[b+4>>2];x[d+8>>2]=x[b>>2];x[d+12>>2]=c;b=hg(160,d+44|0,x[d+32>>2],x[d+36>>2],d+8|0);c=x[31609];x[31609]=0;if((c|0)!=1){kd(ej(x[a+4>>2])+12|0,b);ub(b);Kc(k);break b}b=N()|0;Kc(d+84|0)}Q(b|0);p()}k=1}fb=d+112|0;return k|0}function Qv(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if(!a){return Gd(b)}if(b>>>0>=4294967232){x[31484]=48;return 0}f=b>>>0<11?16:b+11&-8;e=a-8|0;i=x[e+4>>2];d=i&-8;a:{if(!(i&3)){if(f>>>0<256){break a}if(d>>>0>=f+4>>>0){c=e;if(d-f>>>0<=x[31605]<<1>>>0){break a}}c=0;break a}g=d+e|0;b:{if(d>>>0>=f>>>0){c=d-f|0;if(c>>>0<16){break b}x[e+4>>2]=i&1|f|2;d=e+f|0;x[d+4>>2]=c|3;x[g+4>>2]=x[g+4>>2]|1;Iv(d,c);break b}if(x[31491]==(g|0)){d=d+x[31488]|0;if(d>>>0<=f>>>0){break a}x[e+4>>2]=i&1|f|2;c=e+f|0;d=d-f|0;x[c+4>>2]=d|1;x[31488]=d;x[31491]=c;break b}if(x[31490]==(g|0)){d=d+x[31487]|0;if(d>>>0<f>>>0){break a}c=d-f|0;c:{if(c>>>0>=16){x[e+4>>2]=i&1|f|2;h=e+f|0;x[h+4>>2]=c|1;d=d+e|0;x[d>>2]=c;x[d+4>>2]=x[d+4>>2]&-2;break c}x[e+4>>2]=d|i&1|2;c=d+e|0;x[c+4>>2]=x[c+4>>2]|1;c=0}x[31490]=h;x[31487]=c;break b}h=x[g+4>>2];if(h&2){break a}j=d+(h&-8)|0;if(j>>>0<f>>>0){break a}l=j-f|0;d:{if(h>>>0<=255){c=x[g+12>>2];d=x[g+8>>2];if((c|0)==(d|0)){n=125940,o=x[31485]&Lua(-2,h>>>3|0),x[n>>2]=o;break d}x[d+12>>2]=c;x[c+8>>2]=d;break d}k=x[g+24>>2];d=x[g+12>>2];e:{if((g|0)!=(d|0)){c=x[g+8>>2];x[c+12>>2]=d;x[d+8>>2]=c;break e}f:{c=g+20|0;h=x[c>>2];if(!h){h=x[g+16>>2];if(!h){break f}c=g+16|0}while(1){m=c;d=h;c=d+20|0;h=x[c>>2];if(h){continue}c=d+16|0;h=x[d+16>>2];if(h){continue}break}x[m>>2]=0;break e}d=0}if(!k){break d}c=x[g+28>>2];h=(c<<2)+126244|0;g:{if(x[h>>2]==(g|0)){x[h>>2]=d;if(d){break g}n=125944,o=x[31486]&Lua(-2,c),x[n>>2]=o;break d}x[(x[k+16>>2]==(g|0)?16:20)+k>>2]=d;if(!d){break d}}x[d+24>>2]=k;c=x[g+16>>2];if(c){x[d+16>>2]=c;x[c+24>>2]=d}c=x[g+20>>2];if(!c){break d}x[d+20>>2]=c;x[c+24>>2]=d}if(l>>>0<=15){x[e+4>>2]=i&1|j|2;c=e+j|0;x[c+4>>2]=x[c+4>>2]|1;break b}x[e+4>>2]=i&1|f|2;c=e+f|0;x[c+4>>2]=l|3;d=e+j|0;x[d+4>>2]=x[d+4>>2]|1;Iv(c,l)}c=e}if(c){return c+8|0}c=Gd(b);if(!c){return 0}e=x[a-4>>2];e=(e&3?-4:-8)+(e&-8)|0;zc(c,a,b>>>0>e>>>0?e:b);Db(a);return c}function wP(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=fb-80|0;fb=j;a:{b:{c:{d:{e:{f:{k=dr(1,28);if(!k){a=un(ac(4));x[31609]=0;S(97,a|0,124540,34);a=x[31609];x[31609]=0;if((a|0)!=1){break a}break f}x[k+12>>2]=f;x[k+8>>2]=e;x[k+4>>2]=d;f=c?c:977;x[k>>2]=f;c=og(j+68|0);g:{h:{i:{if(!i){break i}while(1){e=x[i>>2];if(!e){break i}l=x[i+4>>2];j:{if(l){x[31609]=0;e=P(36,j+56|0,e|0)|0;m=x[31609];x[31609]=0;k:{if((m|0)!=1){x[31609]=0;m=P(988,c|0,e|0)|0;n=x[31609];x[31609]=0;if((n|0)==1){break k}x[31609]=0;O(272,m|0,l|0);l=x[31609];x[31609]=0;if((l|0)==1){break k}break j}i=T(0)|0;break g}i=T(0)|0;tb(e);break g}x[31609]=0;e=P(36,j+44|0,e|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break h}hu(c,e)}tb(e);i=i+8|0;continue}}e=x[a+8>>2];i=x[a+4>>2];l=x[a>>2];x[31609]=0;a=R(852,80)|0;m=x[31609];x[31609]=0;l:{m:{n:{if((m|0)!=1){x[j+40>>2]=e;x[j+36>>2]=i;x[j+32>>2]=l;x[j+28>>2]=b;x[31609]=0;b=P(989,f|0,d|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break n}x[j+20>>2]=b;b=j+20|0;d=x[re(j+24|0,b)>>2];e=x[j+40>>2];x[j+8>>2]=x[j+36>>2];x[j+12>>2]=e;x[31609]=0;e=x[j+32>>2];x[j>>2]=x[j+28>>2];x[j+4>>2]=e;d=ba(990,a|0,j|0,d|0,c|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break l}i=T(0)|0;Wc(b);break m}i=T(0)|0;break g}i=T(0)|0}Db(a);break g}x[k+24>>2]=d;Wc(j+20|0);Ol(c);i=k;break d}i=T(0)|0}Ol(c);Y(i|0)|0;x[31609]=0;V(983,15275,k|0,g|0,h|0);a=x[31609];x[31609]=0;if((a|0)!=1){x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)==1){break f}a=x[k+24>>2];if(a){Db(sq(a))}i=0;x[k+24>>2]=0;a=x[k+20>>2];if(a){Db(a);x[k+20>>2]=0}Db(k);break d}i=T(0)|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)!=1){break e}break b}i=T(0)|0}Y(i|0)|0;i=0;x[31609]=0;V(983,15275,0,g|0,h|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Z()}fb=j+80|0;return i|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){break b}Q(a|0);p()}T(0)|0;Sb()}p()}function Ou(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=D(c,872)+b|0;g=e+704|0;x[g>>2]=x[g>>2]|524288;a:{b:{if(!(y[a+480208|0]&8)){if(Ob(a+1074312|0,15)|x[a+480180>>2]==268435456){break b}break a}if(x[a+480180>>2]!=268435456){break a}}f=D(c,872)+b|0;d=d?d:y[(D(c,872)+b|0)+1427|0];v[f+1427|0]=d;v[f+1428|0]=d}if(d){w[(D(c,872)+b|0)+1384>>1]=d}c:{h=e+616|0;i=x[h+656>>2];if(Lj(i)){d=D(c,872)+b|0;a=z[d+1384>>1];if(!a){break c}e=0;f=x[b+16>>2];e=f?x[d+1472>>2]:e;k=+(f>>>0)+1;j=0-a|0;d=a;h=D(c,872)+b|0;f=h+1324|0;a=x[f>>2];k=k*+(((a|0)<0?j:d)|0)/+A[b+40>>2];d:{if(F(k)<2147483648){d=~~k;break d}d=-2147483648}h=h+1472|0;x[h>>2]=d;if(y[g+2|0]&16){d=D(x[x[i+44>>2]+36>>2]+1|0,d);x[h>>2]=d}d=d-e|0;g=d>>31;e=a>>31;if((e^a)-e>>>0<=(d^g)-g>>>0){if(!a){break c}b=D(c,872)+b|0;c=b+1468|0;x[c>>2]=a+x[c>>2];x[f>>2]=0;a=b+1467|0;v[a|0]=y[a|0]|64;return 0}b=D(c,872)+b|0;c=b+1468|0;x[c>>2]=d+x[c>>2];x[f>>2]=a-d;a=b+1467|0;v[a|0]=y[a|0]|64;break c}f=a+1074312|0;e:{if(!(!Ob(f,118)|!(y[g+1|0]&2))){d=0;if(Tc(y[(D(c,872)+b|0)+1404|0])){break e}}g=1;i=D(c,872)+b|0;e=i+1467|0;f:{if(!(v[e|0]&1)){break f}d=x[a+480180>>2];if(d&524352){break f}if(x[b+40>>2]==1){if(Ob(f,6)){break f}d=x[a+480180>>2]}g=0;if((d|0)!=8){break f}g=(y[a+480208|0]&2)>>>1|0}j=x[a+480180>>2];d=z[i+1384>>1];if(!((j|0)!=268435456|d>>>0<240)){g=v[e|0]&1;d=d-240|0}d=d<<((j|0)==64?1:2);i=D(c,872)+b|0;b=i+1316|0;g:{if(!x[b>>2]){break g}c=i+1324|0;if(!(x[c>>2]!=0&g)){break g}j=Aj(a)?d:0-d|0;l=x[b>>2];m=x[c>>2];if(!(!(y[e|0]&16)&(l|0)>=(m|0))){xk(a,h,b,j,1);c=x[c>>2];if((c|0)>=x[b>>2]){break g}x[b>>2]=c;break g}if((l|0)<=(m|0)){break g}xk(a,h,b,0-j|0,1);h=x[b>>2];c=x[c>>2];h:{if((h|0)<(c|0)){x[b>>2]=c;break h}if((c|0)!=(h|0)){break g}}if(!Ob(f,112)){break g}v[e|0]=y[e|0]|16}c=x[b>>2];b=i+1324|0;i:{if((c|0)!=x[b>>2]){break i}if(!Ob(f,25)&x[a+480180>>2]!=1){break i}x[b>>2]=0}d=g?d:0}return d}return 0}function eoa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=fb-16|0;fb=j;e=x[b>>2];d=Ek(e,x[b+4>>2]);a:{if(d>>>0<c>>>0){n=fb-32|0;fb=n;e=c-d|0;d=x[Ab(b)>>2];f=x[b+4>>2];b:{if(e>>>0<=d-f>>4>>>0){f=fb-16|0;fb=f;e=jv(f+4|0,b,e);d=x[e+4>>2];g=x[e+8>>2];while(1){if((d|0)==(g|0)){kc(e);fb=f+16|0}else{Cr(d);d=d+16|0;x[e+4>>2]=d;continue}break}break b}d=Ab(b);f=UV(n+12|0,VV(b,Ek(x[b>>2],f)+e|0),Ek(x[b>>2],x[b+4>>2]),d);g=fb-16|0;fb=g;h=x[f+8>>2];d=g+4|0;x[d+8>>2]=f+8;x[d>>2]=h;x[d+4>>2]=h+(e<<4);e=x[d>>2];while(1){if(x[d+4>>2]!=(e|0)){Cr(e);e=x[d>>2]+16|0;x[d>>2]=e;continue}break}je(d);fb=g+16|0;k=fb-16|0;fb=k;d=vb(k+12|0,x[b+4>>2]);e=vb(k+8|0,x[b>>2]);i=x[vb(k+4|0,x[f+4>>2])>>2];l=fb-16|0;fb=l;o=l+8|0;g=fb-32|0;fb=g;fd(g+24|0,x[d>>2],x[e>>2]);p=g+16|0;d=x[g+24>>2];q=x[g+28>>2];h=fb-16|0;fb=h;x[h+8>>2]=i;x[h+12>>2]=d;while(1){if(Fd(d,q)){e=nC(d);d=nC(x[h+8>>2]);i=y[e+12|0]|y[e+13|0]<<8|(y[e+14|0]<<16|y[e+15|0]<<24);m=y[e+8|0]|y[e+9|0]<<8|(y[e+10|0]<<16|y[e+11|0]<<24);v[d+8|0]=m;v[d+9|0]=m>>>8;v[d+10|0]=m>>>16;v[d+11|0]=m>>>24;v[d+12|0]=i;v[d+13|0]=i>>>8;v[d+14|0]=i>>>16;v[d+15|0]=i>>>24;i=y[e+4|0]|y[e+5|0]<<8|(y[e+6|0]<<16|y[e+7|0]<<24);e=y[e|0]|y[e+1|0]<<8|(y[e+2|0]<<16|y[e+3|0]<<24);v[d|0]=e;v[d+1|0]=e>>>8;v[d+2|0]=e>>>16;v[d+3|0]=e>>>24;v[d+4|0]=i;v[d+5|0]=i>>>8;v[d+6|0]=i>>>16;v[d+7|0]=i>>>24;d=Wq(h+12|0);Wq(h+8|0);d=x[d>>2];continue}break}rc(p,d,h+8|0);fb=h+16|0;d=x[g+16>>2];x[g+12>>2]=x[g+20>>2];rc(o,d,g+12|0);fb=g+32|0;fb=l+16|0;x[f+4>>2]=x[l+12>>2];Tb(b,f+4|0);Tb(b+4|0,f+8|0);Tb(Ab(b),nc(f));x[f>>2]=x[f+4>>2];fb=k+16|0;d=x[f+4>>2];e=x[f+8>>2];while(1){if((d|0)!=(e|0)){e=e-16|0;x[f+8>>2]=e;continue}break}d=x[f>>2];if(d){ts(f);Db(d)}}fb=n+32|0;break a}if(c>>>0<d>>>0){Jd(b,e+(c<<4)|0)}}if(Mb(x[a>>2],x[a+8>>2],c<<4)){c=x[b>>2];cc(j+8|0,c,Ek(c,x[b+4>>2])<<4);sd(j,a,x[j+8>>2],x[j+12>>2])}fb=j+16|0}function rla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=fb-16|0;fb=j;c=If(a,c);ae(j,x[a+36>>2]);a:{if(!c){Qc(j,a+32|0,5);f=0;if(Gb(x[x[j>>2]>>2],x[j+4>>2])){break a}}f=fb-240|0;fb=f;h=Lm(f+128|0,x[a+36>>2]);x[31609]=0;g=P(461,f+116|0,26168)|0;e=x[31609];x[31609]=0;b:{c:{d:{e:{if((e|0)!=1){x[31609]=0;x[f+96>>2]=20054022;x[f+100>>2]=0;S(462,h|0,g|0,f+96|0);e=x[31609];x[31609]=0;if((e|0)==1){break e}Eb(g);if(!rl(y[h|0])){break d}break b}a=N()|0;break c}a=N()|0;Eb(g);break c}v[f+115|0]=0;x[31609]=0;g=P(461,f+96|0,5505)|0;e=x[31609];x[31609]=0;f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{if((e|0)!=1){x[31609]=0;S(463,h|0,f+115|0,g|0);e=x[31609];x[31609]=0;if((e|0)==1){break p}Eb(g);g=Fb(f+84|0);x[31609]=0;e=P(461,f+72|0,10110)|0;i=x[31609];x[31609]=0;if((i|0)==1){break o}x[31609]=0;S(786,h|0,g|0,e|0);i=x[31609];x[31609]=0;if((i|0)==1){break n}Eb(e);x[31609]=0;e=f+60|0;S(258,e|0,(y[f+115|0]?0:d)|0,g|0);d=x[31609];x[31609]=0;if((d|0)==1){break m}op(b,e);tb(e);w[f+58>>1]=0;x[31609]=0;d=P(461,f+44|0,10799)|0;e=x[31609];x[31609]=0;if((e|0)==1){break g}x[31609]=0;e=f+58|0;U(491,h|0,e|0,d|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break l}Eb(d);Hf(e,4e3);x[31609]=0;d=P(461,f+32|0,13557)|0;e=x[31609];x[31609]=0;if((e|0)==1){break k}i=z[f+58>>1];e=x[vb(f+28|0,i)>>2];x[31609]=0;V(787,h|0,b|0,d|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break j}Eb(d);w[f+26>>1]=65535;x[31609]=0;d=P(461,f+12|0,8980)|0;e=x[31609];x[31609]=0;if((e|0)==1){break i}x[31609]=0;k=U(491,h|0,f+26|0,d|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break h}e=z[f+26>>1];Eb(d);if(e>>>0<i>>>0&k){$e(b,e)}tb(g);break b}a=N()|0;break c}a=N()|0;Eb(g);break c}a=N()|0;break f}a=N()|0;Eb(e);break f}a=N()|0;break f}a=N()|0;Eb(d);break f}a=N()|0;break f}a=N()|0;Eb(d);break f}a=N()|0;break f}a=N()|0;Eb(d);break f}a=N()|0}tb(g)}Ch(h);Q(a|0);p()}Ch(h);fb=f+240|0;f=c}ef(a,f);fb=j+16|0}function uta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;d=fb-1104|0;fb=d;x[d+1100>>2]=c;i=eE(d+40|0,b);r=zr(i);f=Nb(a);x[31609]=0;a=R(202,b|0)|0;c=x[31609];x[31609]=0;a:{if((c|0)!=1){x[d+12>>2]=a;x[d+36>>2]=85899345;a=d+12|0;t=d,u=D(x[Hb(a,d+36|0)>>2],50),x[t+24>>2]=u;c=d+24|0;e=x[Hb(d+1100|0,c)>>2];x[31609]=0;O(328,f|0,e|0);e=x[31609];x[31609]=0;if((e|0)!=1){x[31609]=0;h=R(340,c|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){x[31609]=0;g=P(341,a|0,8192)|0;a=x[31609];x[31609]=0;b:{if((a|0)!=1){a=x[h>>2];c=0;while(1){if((c|0)!=256){e=yb(a,c);v[e+2|0]=c;w[e>>1]=8192;c=c+1|0;continue}break}m=9;c:{d:while(1){e=0;n=257;while(1){s=m&255;e:{while(1){j=n&65535;while(1){x[31609]=0;o=P(158,i|0,s|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}k=o&65535;if((k|0)==257|j>>>0<k>>>0){break e}if(Xc(x[f>>2],x[f+4>>2])>>>0>=A[d+1100>>2]){break e}if((k|0)==256){m=9;continue d}c=j>>>0>k>>>0?o:e;a=x[h>>2];l=8192;while(1){c=c&65535;a=yb(a,c);l=l-1|0;q=l&65535;t=xb(x[g>>2],q),u=y[a+2|0],v[t|0]=u;a=x[h>>2];c=z[yb(a,c)>>1];if(c>>>0<8192){continue}break}a=vb(d+8|0,wb(x[f+4>>2]));c=uf(wb(x[g>>2]),q);l=wb(x[g+4>>2]);a=x[a>>2];x[31609]=0;V(329,f|0,a|0,c|0,l|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}f:{if((j|0)!=(k|0)){break f}a=x[g>>2];x[31609]=0;O(342,f|0,xb(a,q)|0);a=x[31609];x[31609]=0;if((a|0)!=1){break f}break c}if(j>>>0>=8192){e=o;continue}if(Xc(x[f>>2],x[f+4>>2])>>>0>=A[d+1100>>2]){continue}break}a=y[xb(x[g>>2],q)|0];c=yb(x[h>>2],j);w[c>>1]=e;v[c+2|0]=a;a=n+1|0;n=8192;e=o;c=a&65535;if((c|0)==8192){continue}break}m=((c|0)==1<<s)+m|0;n=a;continue}break}break}a=zr(i);x[31609]=0;P(149,b|0,((a-r|0)+3&-4)+r|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}ec(g);wc(h);ub(i);fb=d+1104|0;return}c=N()|0;ec(g);break b}c=N()|0}wc(h);break a}c=N()|0;break a}c=N()|0;break a}c=N()|0}ec(f);ub(i);Q(c|0);p()}function uU(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;c=fb-176|0;fb=c;e=x[a+12>>2];j=1<<e;a:{if(!(e&1)){h=j>>>2|0;l=1;break a}l=j>>>1|0;e=0;while(1){if((e|0)==(l|0)){h=j>>>3|0;l=2;e=x[a+12>>2]}else{i=x[b>>2];h=Yd(i,e+l|0);d=Yd(i,e);o=C[h>>3];p=C[h+8>>3];zj(c+160|0,d,o,p);i=x[c+172>>2];x[h+8>>2]=x[c+168>>2];x[h+12>>2]=i;i=x[c+164>>2];x[h>>2]=x[c+160>>2];x[h+4>>2]=i;zA(Yd(x[b>>2],e),o,p);e=e+1|0;continue}break}}i=e&-2;b:while(1){if(i){w=D(h,3);y=h<<1;j=0;c:while(1){if((j|0)==(l|0)){i=i-2|0;h=h>>>2|0;l=l<<2;continue b}d=x[a>>2];e=Yd(d,j<<1);d=Yd(d,j);o=C[d>>3];p=C[d+8>>3];r=C[e>>3];s=C[e+8>>3];Ni(c+160|0,o,p,r,s);e=j<<i;d=h+e|0;z=d>>>0<e>>>0?e:d;while(1)if((e|0)==(z|0)){j=j+1|0;continue c}else{f=x[b>>2];d=Yd(f,e);g=x[d+12>>2];x[c+152>>2]=x[d+8>>2];x[c+156>>2]=g;g=x[d+4>>2];x[c+144>>2]=x[d>>2];x[c+148>>2]=g;g=c+128|0;t=e+h|0;k=Yd(f,t);Ni(g,r,s,C[k>>3],C[k+8>>3]);u=e+y|0;k=Yd(f,u);Ni(c+112|0,o,p,C[k>>3],C[k+8>>3]);m=C[c+160>>3];n=C[c+168>>3];v=e+w|0;f=Yd(f,v);Ni(c+96|0,m,n,C[f>>3],C[f+8>>3]);k=c+80|0;f=c+144|0;m=C[c+112>>3];n=C[c+120>>3];El(k,f,m,n);q=c- -64|0;zj(q,f,m,n);m=C[c+96>>3];n=C[c+104>>3];El(c+48|0,g,m,n);f=c+16|0;Ql(f,-0,-1);zj(c,g,m,n);Ni(c+32|0,C[c+16>>3],C[c+24>>3],C[c>>3],C[c+8>>3]);El(f,k,C[c+48>>3],C[c+56>>3]);g=x[c+28>>2];x[d+8>>2]=x[c+24>>2];x[d+12>>2]=g;g=x[c+20>>2];x[d>>2]=x[c+16>>2];x[d+4>>2]=g;zj(f,k,C[c+48>>3],C[c+56>>3]);d=Yd(x[b>>2],t);g=x[c+28>>2];x[d+8>>2]=x[c+24>>2];x[d+12>>2]=g;g=x[c+20>>2];x[d>>2]=x[c+16>>2];x[d+4>>2]=g;El(f,q,C[c+32>>3],C[c+40>>3]);d=Yd(x[b>>2],u);g=x[c+28>>2];x[d+8>>2]=x[c+24>>2];x[d+12>>2]=g;g=x[c+20>>2];x[d>>2]=x[c+16>>2];x[d+4>>2]=g;zj(f,q,C[c+32>>3],C[c+40>>3]);d=Yd(x[b>>2],v);f=x[c+28>>2];x[d+8>>2]=x[c+24>>2];x[d+12>>2]=f;f=x[c+20>>2];x[d>>2]=x[c+16>>2];x[d+4>>2]=f;e=e+1|0;continue}}}break}fb=c+176|0}function KO(a,b,c){a=a|0;b=E(b);c=c|0;var d=0,e=E(0),f=E(0),g=E(0),h=E(0),i=E(0),k=E(0),m=0,n=0,o=0;d=fb-16|0;fb=d;a:{b:{c:{d:{switch(c-1|0){case 0:a=(q(b),j(2));e:{f:{g:{if((a|0)<=8388607){e=E(E(-1)/E(b*b));if(!((q(b),j(2))&2147483647)){break e}e=E(E(b-b)/E(0));if((a|0)<0){break e}a=(q(E(b*E(33554432))),j(2));c=-152;break g}if(a>>>0>2139095039){break f}c=-127;b=E(0);if((a|0)==1065353216){break f}}a=a+4913933|0;k=E((a>>>23|0)+c|0);b=E((l(2,(a&8388607)+1060439283|0),r())+E(-1));f=E(b*E(b*E(.5)));g=E(b/E(b+E(2)));h=E(g*g);i=E(h*h);e=b;b=(l(2,(q(E(b-f)),j(2))&-4096),r());f=E(E(g*E(f+E(E(h*E(E(i*E(.2849878668785095))+E(.6666666269302368)))+E(i*E(E(i*E(.24279078841209412))+E(.40000972151756287))))))+E(E(e-b)-f));b=E(E(k*E(.3010292053222656))+E(E(b*E(.434326171875))+E(E(f*E(.434326171875))+E(E(k*E(7.903415166765626e-7))+E(E(f+b)*E(-3168997136526741e-20))))))}e=b}b=E(e*E(2e3));if(!(E(F(b))<E(2147483648))){break c}a=~~b;break b;case 1:a=(D(x[a+24604>>2],100)|0)/128|0;break b;case 2:c=fb-16|0;fb=c;h:{i:{j:{k:{a=y[a+24648|0];if(a>>>0>=6){a=ac(8);x[31609]=0;c=P(36,c+4|0,5123)|0;d=x[31609];x[31609]=0;if((d|0)==1){break k}pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break i}d=N()|0;tb(c);break j}fb=c+16|0;a=x[(a<<2)+79288>>2];break h}d=N()|0;ic(a)}Q(d|0)}p()}break b;case 3:x[d+4>>2]=0;m=x[a+24640>>2];c=fb-80|0;fb=c;a=x[a+24636>>2];x[c+40>>2]=a;x[c>>2]=m;n=c+40|0;o=x[Xe(n,c)>>2];l:{if((a|0)==x[Tq(n)+32>>2]){a=-1;if(x[Tq(c)+36>>2]==(m|0)){break l}}a=0;if((o|0)<=0){break l}a=(o+500>>>0)/1e3|0}x[d+4>>2]=a;fb=c+80|0;a=x[d+4>>2];break b;default:break d}}c=ac(8);x[31609]=0;d=P(36,d+4|0,10401)|0;a=x[31609];x[31609]=0;m:{if((a|0)!=1){pc(c,d);x[31609]=0;S(97,c|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(d);break m}a=N()|0;ic(c)}Q(a|0);p()}a=-2147483648}fb=d+16|0;return a|0}p()}function Wla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0;f=fb-48|0;fb=f;v=x[a+16>>2];while(1){if((g|0)!=2){j=g<<3;n=j+(f+28|0)|0;j=a+j|0;x[n+4>>2]=x[j+44>>2];x[n+8>>2]=x[j+48>>2];g=g+1|0;continue}break}o=x[a+40>>2];p=x[a+36>>2];j=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=j;y=b+24|0;z=x[a+32>>2];A=x[a+28>>2];B=x[a+72>>2];u=x[a+68>>2];C=u>>31;g=x[a+64>>2];E=g>>31;n=x[a+60>>2];F=n>>31;j=x[a+8>>2];G=x[a+12>>2];while(1){if(d){b=x[f+16>>2];h=((((x[f+20>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+v|0;b=(((b>>>16|0)+4&131064)<<1)+y|0;H=w[b+14>>1];m=w[b+12>>1];r=w[b+10>>1];t=w[b+8>>1];i=w[b+6>>1];s=w[b+4>>1];k=w[b+2>>1];e=w[b>>1];q=0;b=0;while(1){if((b|0)!=2){l=b<<1;x[(f+8|0)+(b<<2)>>2]=(((((D(w[h+(l|8)>>1],r)+D(w[h+(l|4)>>1],t)|0)+D(m,w[h+(l|12)>>1])|0)+D(H,w[h+(l|16)>>1])|0)/2|0)+((((D(w[h+(l|-8)>>1],k)+D(w[h+(l|-12)>>1],e)|0)+D(w[h+(l|-4)>>1],s)|0)+D(w[h+l>>1],i)|0)/2|0)|0)/16384;b=b+1|0;continue}break}while(1){if((q|0)!=2){r=(f+8|0)+(q<<2)|0;e=x[r>>2];b=(f+28|0)+(q<<3)|0;t=x[b+8>>2];i=x[b+4>>2];x[b+8>>2]=i;s=e<<8;e=s;e=Iua(e,e>>31,n,F);k=hb;h=e;e=Yb(i,-16777216,16776704);e=Iua(g,E,e,e>>31);i=h+e|0;m=hb+k|0;m=e>>>0>i>>>0?m+1|0:m;e=Yb(t,-16777216,16776704);k=Iua(u,C,e,e>>31);i=k+i|0;e=hb+m|0;e=i>>>0<k>>>0?e+1|0:e;k=i+8388608|0;e=k>>>0<8388608?e+1|0:e;e=Sc(k,e,24);x[b+4>>2]=e-(s&B);x[r>>2]=(e|0)/256;q=q+1|0;continue}break}p=p+A|0;x[c>>2]=x[c>>2]+D(x[f+8>>2],p>>12);o=o+z|0;x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],o>>12);Pb(f+16|0,j,G);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;x[a+40>>2]=o;x[a+20>>2]=p>>12;x[a+36>>2]=p;x[a+24>>2]=o>>12;g=0;while(1){if((g|0)!=2){b=g<<3;c=b+a|0;b=b+(f+28|0)|0;x[c+44>>2]=x[b+4>>2];x[c+48>>2]=x[b+8>>2];g=g+1|0;continue}break}fb=f+48|0}function oP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=fb-96|0;fb=d;g=x[b+4>>2];a:{if(!g){break a}e=x[b>>2];f=y[Al(e,g)|0];if((f|0)==33){c=1}else{if((f|0)!=63){break a}c=0}Nl(d+72|0,e,g,g-1|0);g=x[d+76>>2];e=x[d+72>>2];x[b>>2]=e;x[b+4>>2]=g}e=d+72|0;ie(e);f=x[d+72>>2];ie(d+60|0);f=zl(f,x[d+64>>2],b);ie(e);b:{c:{d:{e:{if((f|0)==x[d+76>>2]){a=x[b>>2];f=qc(d+88|0,22292);h=x[f+4>>2];x[d>>2]=x[f>>2];x[d+4>>2]=h;if(Ic(a,g,d)){a=ac(8);x[31609]=0;c=P(36,e|0,10498)|0;b=x[31609];x[31609]=0;if((b|0)==1){break d}pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break c}e=0;f=0;if(!c){break e}a=ac(8);c=x[b+4>>2];b=x[b>>2];x[31609]=0;e=bi(d+60|0,b,c);b=x[31609];x[31609]=0;f:{g:{h:{if((b|0)!=1){x[31609]=0;g=d+72|0;S(1011,g|0,18307,e|0);b=x[31609];x[31609]=0;if((b|0)==1){break h}pc(a,g);c=0;x[31609]=0;S(97,a|0,48428,1e3);b=x[31609];x[31609]=0;if((b|0)!=1){break b}b=N()|0;tb(g);break g}b=N()|0;break f}b=N()|0;c=1}tb(e);if(!c){break c}}ic(a);break c}if(x[f+4>>2]!=1){a=ac(8);x[31609]=0;c=P(36,d+72|0,11600)|0;b=x[31609];x[31609]=0;if((b|0)!=1){pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break c}b=N()|0;ic(a);break c}b=x[b>>2];c=qc(d+52|0,22292);e=x[c+4>>2];x[d+24>>2]=x[c>>2];x[d+28>>2]=e;if(Ic(b,g,d+24|0)){a=ac(8);x[31609]=0;c=P(36,d+72|0,10498)|0;b=x[31609];x[31609]=0;if((b|0)!=1){pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break c}b=N()|0;ic(a);break c}c=qc(d+44|0,10990);e=x[c+4>>2];x[d+16>>2]=x[c>>2];x[d+20>>2]=e;if(Ic(b,g,d+16|0)){e=x[a+8>>2];f=e>>31;break e}c=qc(d+36|0,8643);e=x[c+4>>2];x[d+8>>2]=x[c>>2];x[d+12>>2]=e;e=0;f=0;if(!Ic(b,g,d+8|0)){break e}e=tk(y[x[a+32>>2]+140|0]);f=0}fb=d+96|0;hb=f;return e|0}b=N()|0;ic(a)}Q(b|0)}p()}function l7(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;a=fb-1056|0;fb=a;x[a+16>>2]=f;x[a+20>>2]=g;x[a+24>>2]=h;x[a+28>>2]=i;k=a+944|0;x[a+940>>2]=k;j=sy(k,100,11198,a+16|0);x[a+48>>2]=1239;l=a+48|0;o=De(a+520|0,0,l);x[a+48>>2]=1239;l=De(a+512|0,0,l);a:{b:{c:{d:{if(j>>>0<100){h=a+528|0;break d}j=Od();x[a>>2]=f;x[a+4>>2]=g;x[a+8>>2]=h;x[a+12>>2]=i;j=kj(a+940|0,j,11198,a);if((j|0)!=-1){k=x[a+940>>2];Qe(o,k);Qe(l,Gd(j<<2));h=x[l>>2];if(!Gj(h)){break d}}x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)!=1){break a}j=N()|0;break c}cd(a+508|0,x[d+28>>2]);x[31609]=0;r=R(1252,x[a+508>>2])|0;f=x[31609];x[31609]=0;e:{f:{g:{h:{i:{j:{if((f|0)==1){break j}x[31609]=0;V(1263,r|0,k|0,j+k|0,h|0);f=x[31609];x[31609]=0;if((f|0)==1){break j}q=(j|0)>0?y[x[a+940>>2]]==45:q;i=Fb(a+484|0);f=Fb(a+472|0);g=Fb(a+460|0);x[31609]=0;ka(1292,c|0,q|0,x[a+508>>2],a+504|0,a+500|0,a+496|0,i|0,f|0,g|0,a+456|0);c=x[31609];x[31609]=0;if((c|0)==1){break i}x[a+36>>2]=1239;c=De(a+40|0,0,a+36|0);k=a+48|0;n=x[a+456>>2];k:{if((n|0)<(j|0)){m=((Cb(x[g+4>>2],y[g+11|0])+(j-n<<1)|0)+Cb(x[f+4>>2],y[f+11|0])|0)+1|0;break k}m=(Cb(x[g+4>>2],y[g+11|0])+Cb(x[f+4>>2],y[f+11|0])|0)+2|0}m=m+n|0;if(m>>>0<101){break h}Qe(c,Gd(m<<2));k=x[c>>2];if(k){break h}x[31609]=0;X(1240);b=x[31609];x[31609]=0;if((b|0)!=1){break a}break g}j=N()|0;break e}j=N()|0;break f}m=x[d+4>>2];x[31609]=0;ma(1293,k|0,a+36|0,a+32|0,m|0,h|0,(j<<2)+h|0,r|0,q|0,a+504|0,x[a+500>>2],x[a+496>>2],i|0,f|0,g|0,n|0);h=x[31609];x[31609]=0;if((h|0)!=1){x[31609]=0;b=ea(1273,b|0,k|0,x[a+36>>2],x[a+32>>2],d|0,e|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break b}}}j=N()|0;Lc(c)}Ub(g);Ub(f);tb(i)}_b(a+508|0)}Lc(l);Lc(o);Q(j|0);p()}Lc(c);Ub(g);Ub(f);tb(i);_b(a+508|0);Lc(l);Lc(o);fb=a+1056|0;return b|0}p()}function nP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=fb-96|0;fb=e;f=x[c+4>>2];a:{if(!f){g=x[c>>2];break a}g=x[c>>2];h=y[Al(g,f)|0];if((h|0)==33){d=1}else{if((h|0)!=63){break a}d=0}Nl(e+72|0,g,f,f-1|0);f=x[e+76>>2];g=x[e+72>>2];x[c>>2]=g;x[c+4>>2]=f}i=e+72|0;ie(i);h=x[e+72>>2];ie(e+60|0);h=zl(h,x[e+64>>2],c);ie(i);b:{c:{d:{e:{if(x[e+76>>2]==(h|0)){h=qc(e+88|0,22292);b=x[h+4>>2];x[e>>2]=x[h>>2];x[e+4>>2]=b;if(Ic(g,f,e)){c=ac(8);x[31609]=0;b=P(36,i|0,10498)|0;a=x[31609];x[31609]=0;if((a|0)==1){break d}pc(c,b);x[31609]=0;S(97,c|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}f=N()|0;tb(b);break c}if(d){g=ac(8);b=x[c>>2];a=x[c+4>>2];x[31609]=0;d=bi(e+60|0,b,a);a=x[31609];x[31609]=0;f:{g:{h:{if((a|0)!=1){x[31609]=0;b=e+72|0;S(1011,b|0,18307,d|0);a=x[31609];x[31609]=0;if((a|0)==1){break h}pc(g,b);c=0;x[31609]=0;S(97,g|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}f=N()|0;tb(b);break g}f=N()|0;break f}f=N()|0;c=1}tb(d);if(!c){break c}}ic(g);break c}Fb(a);break e}d=qc(e+52|0,22292);c=x[d+4>>2];x[e+24>>2]=x[d>>2];x[e+28>>2]=c;if(Ic(g,f,e+24|0)){c=ac(8);x[31609]=0;b=P(36,e+72|0,10498)|0;a=x[31609];x[31609]=0;if((a|0)!=1){pc(c,b);x[31609]=0;S(97,c|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}f=N()|0;tb(b);break c}f=N()|0;ic(c);break c}d=qc(e+44|0,12437);c=x[d+4>>2];x[e+16>>2]=x[d>>2];x[e+20>>2]=c;if(Ic(g,f,e+16|0)){i:{switch(x[b+52>>2]){case 0:Dc(a,5601);break e;case 1:Dc(a,11301);break e;case 2:Dc(a,9222);break e;default:break i}}Fb(a);break e}d=qc(e+36|0,11538);c=x[d+4>>2];x[e+8>>2]=x[d>>2];x[e+12>>2]=c;if(Ic(g,f,e+8|0)){j:{switch(x[b+56>>2]){case 0:Dc(a,15659);break e;case 1:Dc(a,15664);break e;case 2:Dc(a,12711);break e;case 3:Dc(a,9286);break e;default:break j}}Fb(a);break e}Fb(a)}fb=e+96|0;return}f=N()|0;ic(c)}Q(f|0)}p()}function Sfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=fb-96|0;fb=d;f=1;g=x[c+4>>2];h=y[c+11|0];a:{if(Ad(g,h)){break a}e=y[yz(c)|0];if((e|0)!=33){if((e|0)!=63){break a}f=0}e=d+84|0;zx(e,c,0,_c(g,h)-1|0);zb(c,e);tb(e)}e=d+84|0;ie(e);g=x[d+84>>2];ie(d+72|0);g=YM(g,x[d+76>>2],c);ie(e);b:{c:{d:{e:{f:{if((g|0)==x[d+88>>2]){if(Nd(c,22292)){a=ac(8);x[31609]=0;b=P(36,e|0,10498)|0;c=x[31609];x[31609]=0;if((c|0)==1){break d}pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}c=N()|0;tb(b);break c}if(!f){break f}a=ac(8);x[31609]=0;b=d+84|0;S(1002,b|0,18307,c|0);c=x[31609];x[31609]=0;if((c|0)!=1){pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}c=N()|0;tb(b);break c}c=N()|0;ic(a);break c}e=Fb(d+84|0);g:{h:{i:{j:{switch(x[g+4>>2]){case 0:fe(d- -64|0,c);x[31609]=0;c=x[d+68>>2];x[d+8>>2]=x[d+64>>2];x[d+12>>2]=c;b=U(1003,b|0,d+8|0,f|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){x[31609]=0;v[d+72|0]=b;O(1004,a|0,d+72|0);a=x[31609];x[31609]=0;if((a|0)!=1){break g}}break i;case 1:fe(d+56|0,c);x[31609]=0;c=x[d+60>>2];x[d+16>>2]=x[d+56>>2];x[d+20>>2]=c;b=fI(b,d+16|0,f);c=hb;f=x[31609];x[31609]=0;if((f|0)!=1){x[31609]=0;x[d+72>>2]=b;x[d+76>>2]=c;O(1006,a|0,d+72|0);a=x[31609];x[31609]=0;if((a|0)!=1){break g}}break i;case 2:fe(d+48|0,c);x[31609]=0;c=x[d+52>>2];x[d+24>>2]=x[d+48>>2];x[d+28>>2]=c;i=+oa(1007,b|0,d+24|0,f|0);b=x[31609];x[31609]=0;if((b|0)!=1){x[31609]=0;C[d+72>>3]=i;O(1008,a|0,d+72|0);a=x[31609];x[31609]=0;if((a|0)!=1){break g}}break i;case 3:break j;default:break h}}fe(d+40|0,c);x[31609]=0;c=x[d+44>>2];x[d+32>>2]=x[d+40>>2];x[d+36>>2]=c;V(1009,a|0,b|0,d+32|0,f|0);a=x[31609];x[31609]=0;if((a|0)!=1){break g}}c=N()|0;tb(e);break c}Uc(a,e)}tb(e);break e}Fb(a)}fb=d+96|0;return}c=N()|0;ic(a)}Q(c|0)}p()}function ara(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=x[a>>2];b=Pv(e,x[a+4>>2]);if(b>>>0<=63){h=fb-32|0;fb=h;g=64-b|0;b=x[Ab(a)>>2];c=x[a+4>>2];a:{if(g>>>0<=(b-c|0)/33>>>0){e=fb-16|0;fb=e;b=e+4|0;x[b>>2]=a;a=x[a+4>>2];x[b+4>>2]=a;x[b+8>>2]=a+D(g,33);c=x[b+4>>2];a=x[b+8>>2];while(1){if((a|0)==(c|0)){kc(b);fb=e+16|0}else{SY(c);c=c+33|0;x[b+4>>2]=c;continue}break}break a}i=Ab(a);e=h+12|0;f=Pv(x[a>>2],c)+g|0;c=fb-16|0;fb=c;x[c+12>>2]=f;d=fb-16|0;fb=d;x[d+12>>2]=130150524;x[d+8>>2]=2147483647;b=x[Hb(d+12|0,d+8|0)>>2];fb=d+16|0;b:{if(b>>>0>=f>>>0){d=VY(a);if(d>>>0<b>>>1>>>0){x[c+8>>2]=d<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;break b}ed();p()}f=Pv(x[a>>2],x[a+4>>2]);d=fb-16|0;fb=d;Lg(e+12|0,i);c:{if(!b){c=0;b=0;break c}if(b>>>0>=130150525){Tj();p()}c=Ec(D(b,33));x[d+12>>2]=b;x[d+8>>2]=c;c=x[d+12>>2];b=x[d+8>>2]}x[e>>2]=b;f=b+D(f,33)|0;x[e+8>>2]=f;x[e+4>>2]=f;l=nc(e),m=b+D(c,33)|0,x[l>>2]=m;fb=d+16|0;d=fb-16|0;fb=d;c=x[e+8>>2];b=d+4|0;x[b+8>>2]=e+8;x[b>>2]=c;x[b+4>>2]=c+D(g,33);c=x[b>>2];while(1){if(x[b+4>>2]!=(c|0)){SY(c);c=x[b>>2]+33|0;x[b>>2]=c;continue}break}je(b);fb=d+16|0;g=fb-16|0;fb=g;b=vb(g+12|0,x[a+4>>2]);d=vb(g+8|0,x[a>>2]);i=x[vb(g+4|0,x[e+4>>2])>>2];f=fb-16|0;fb=f;c=fb-32|0;fb=c;fd(c+24|0,x[b>>2],x[d>>2]);j=c+16|0;b=x[c+24>>2];k=x[c+28>>2];d=fb-16|0;fb=d;x[d+8>>2]=i;x[d+12>>2]=b;while(1){if(Fd(b,k)){b=UY(b);zc(UY(x[d+8>>2]),b,33);b=TY(d+12|0);TY(d+8|0);b=x[b>>2];continue}break}rc(j,b,d+8|0);fb=d+16|0;b=x[c+16>>2];x[c+12>>2]=x[c+20>>2];rc(f+8|0,b,c+12|0);fb=c+32|0;fb=f+16|0;x[e+4>>2]=x[f+12>>2];Tb(a,e+4|0);Tb(a+4|0,e+8|0);Tb(Ab(a),nc(e));x[e>>2]=x[e+4>>2];fb=g+16|0;b=x[e+4>>2];a=x[e+8>>2];while(1){if((a|0)!=(b|0)){a=a-33|0;x[e+8>>2]=a;continue}break}a=x[e>>2];if(a){nc(e);Db(a)}}fb=h+32|0;return}if((b|0)!=64){Jd(a,e+2112|0)}}function pW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=x[a>>2];e=Sh(c,x[a+4>>2]);if(e>>>0<b>>>0){h=fb-32|0;fb=h;g=b-e|0;b=x[Ab(a)>>2];c=x[a+4>>2];a:{if(g>>>0<=b-c>>8>>>0){e=fb-16|0;fb=e;b=e+4|0;x[b>>2]=a;a=x[a+4>>2];x[b+4>>2]=a;x[b+8>>2]=a+(g<<8);a=x[b+4>>2];c=x[b+8>>2];while(1){if((a|0)==(c|0)){kc(b);fb=e+16|0}else{WV(a);a=a+256|0;x[b+4>>2]=a;continue}break}break a}i=Ab(a);e=h+12|0;f=Sh(x[a>>2],c)+g|0;c=fb-16|0;fb=c;x[c+12>>2]=f;d=fb-16|0;fb=d;x[d+12>>2]=16777215;x[d+8>>2]=2147483647;b=x[Hb(d+12|0,d+8|0)>>2];fb=d+16|0;b:{if(b>>>0>=f>>>0){d=pC(a);if(d>>>0<b>>>1>>>0){x[c+8>>2]=d<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;break b}ed();p()}f=Sh(x[a>>2],x[a+4>>2]);d=fb-16|0;fb=d;Lg(e+12|0,i);c:{if(!b){c=0;b=0;break c}if(b>>>0>=16777216){Tj();p()}c=Ec(b<<8);x[d+12>>2]=b;x[d+8>>2]=c;c=x[d+8>>2];b=x[d+12>>2]}x[e>>2]=c;f=c+(f<<8)|0;x[e+8>>2]=f;x[e+4>>2]=f;l=nc(e),m=c+(b<<8)|0,x[l>>2]=m;fb=d+16|0;d=fb-16|0;fb=d;b=x[e+8>>2];c=d+4|0;x[c+8>>2]=e+8;x[c>>2]=b;x[c+4>>2]=b+(g<<8);b=x[c>>2];while(1){if(x[c+4>>2]!=(b|0)){WV(b);b=x[c>>2]+256|0;x[c>>2]=b;continue}break}je(c);fb=d+16|0;g=fb-16|0;fb=g;c=vb(g+12|0,x[a+4>>2]);d=vb(g+8|0,x[a>>2]);i=x[vb(g+4|0,x[e+4>>2])>>2];f=fb-16|0;fb=f;b=fb-32|0;fb=b;fd(b+24|0,x[c>>2],x[d>>2]);j=b+16|0;d=x[b+24>>2];k=x[b+28>>2];c=fb-16|0;fb=c;x[c+8>>2]=i;x[c+12>>2]=d;while(1){if(Fd(d,k)){d=YV(d);zc(YV(x[c+8>>2]),d,256);d=XV(c+12|0);XV(c+8|0);d=x[d>>2];continue}break}rc(j,d,c+8|0);fb=c+16|0;c=x[b+16>>2];x[b+12>>2]=x[b+20>>2];rc(f+8|0,c,b+12|0);fb=b+32|0;fb=f+16|0;x[e+4>>2]=x[f+12>>2];Tb(a,e+4|0);Tb(a+4|0,e+8|0);Tb(Ab(a),nc(e));x[e>>2]=x[e+4>>2];fb=g+16|0;b=x[e+4>>2];a=x[e+8>>2];while(1){if((a|0)!=(b|0)){a=a-256|0;x[e+8>>2]=a;continue}break}a=x[e>>2];if(a){nc(e);Db(a)}}fb=h+32|0;return}if(b>>>0<e>>>0){Jd(a,c+(b<<8)|0)}}function p7(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;a=fb-448|0;fb=a;x[a+16>>2]=f;x[a+20>>2]=g;x[a+24>>2]=h;x[a+28>>2]=i;k=a+336|0;x[a+332>>2]=k;j=sy(k,100,11198,a+16|0);x[a+48>>2]=1239;l=a+48|0;o=De(a+216|0,0,l);x[a+48>>2]=1239;l=De(a+208|0,0,l);a:{b:{c:{d:{if(j>>>0<100){h=a+224|0;break d}j=Od();x[a>>2]=f;x[a+4>>2]=g;x[a+8>>2]=h;x[a+12>>2]=i;j=kj(a+332|0,j,11198,a);if((j|0)!=-1){k=x[a+332>>2];Qe(o,k);Qe(l,Gd(j));h=x[l>>2];if(!Gj(h)){break d}}x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)!=1){break a}j=N()|0;break c}cd(a+204|0,x[d+28>>2]);x[31609]=0;r=R(28,x[a+204>>2])|0;f=x[31609];x[31609]=0;e:{f:{g:{h:{i:{j:{if((f|0)==1){break j}x[31609]=0;V(1249,r|0,k|0,j+k|0,h|0);f=x[31609];x[31609]=0;if((f|0)==1){break j}q=(j|0)>0?y[x[a+332>>2]]==45:q;i=Fb(a+184|0);f=Fb(a+172|0);g=Fb(a+160|0);x[31609]=0;ka(1290,c|0,q|0,x[a+204>>2],a+200|0,a+199|0,a+198|0,i|0,f|0,g|0,a+156|0);c=x[31609];x[31609]=0;if((c|0)==1){break i}x[a+36>>2]=1239;c=De(a+40|0,0,a+36|0);k=a+48|0;n=x[a+156>>2];k:{if((n|0)<(j|0)){m=((Cb(x[g+4>>2],y[g+11|0])+(j-n<<1)|0)+Cb(x[f+4>>2],y[f+11|0])|0)+1|0;break k}m=(Cb(x[g+4>>2],y[g+11|0])+Cb(x[f+4>>2],y[f+11|0])|0)+2|0}m=m+n|0;if(m>>>0<101){break h}Qe(c,Gd(m));k=x[c>>2];if(k){break h}x[31609]=0;X(1240);b=x[31609];x[31609]=0;if((b|0)!=1){break a}break g}j=N()|0;break e}j=N()|0;break f}m=x[d+4>>2];x[31609]=0;ma(1291,k|0,a+36|0,a+32|0,m|0,h|0,h+j|0,r|0,q|0,a+200|0,v[a+199|0],v[a+198|0],i|0,f|0,g|0,n|0);h=x[31609];x[31609]=0;if((h|0)!=1){x[31609]=0;b=ea(23,b|0,k|0,x[a+36>>2],x[a+32>>2],d|0,e|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break b}}}j=N()|0;Lc(c)}tb(g);tb(f);tb(i)}_b(a+204|0)}Lc(l);Lc(o);Q(j|0);p()}Lc(c);tb(g);tb(f);tb(i);_b(a+204|0);Lc(l);Lc(o);fb=a+448|0;return b|0}p()}function Xla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0;g=fb-48|0;fb=g;y=x[a+16>>2];while(1){if((f|0)!=2){i=f<<3;m=i+(g+28|0)|0;i=a+i|0;x[m+4>>2]=x[i+44>>2];x[m+8>>2]=x[i+48>>2];f=f+1|0;continue}break}n=x[a+40>>2];o=x[a+36>>2];i=x[a+4>>2];x[g+16>>2]=x[a>>2];x[g+20>>2]=i;z=b+24|0;A=x[a+32>>2];B=x[a+28>>2];C=x[a+72>>2];t=x[a+68>>2];E=t>>31;u=x[a+64>>2];F=u>>31;m=x[a+60>>2];G=m>>31;i=x[a+8>>2];H=x[a+12>>2];while(1){if(d){b=x[g+16>>2];k=(((x[g+20>>2]&2147483647)<<1|b>>>31)&-2)+y|0;b=(((b>>>16|0)+4&131064)<<1)+z|0;l=w[b+14>>1];q=w[b+12>>1];s=w[b+10>>1];h=w[b+8>>1];r=w[b+6>>1];j=w[b+4>>1];e=w[b+2>>1];b=w[b>>1];p=0;f=0;while(1){if((f|0)!=2){x[(g+8|0)+(f<<2)>>2]=((((D(s,v[k+(f|4)|0])+D(v[k+(f|2)|0],h)|0)+D(q,v[k+(f|6)|0])|0)+D(l,v[k+(f|8)|0])<<8>>1)+(((D(v[k+(f|-4)|0],e)+D(v[k+(f|-6)|0],b)|0)+D(v[k+(f|-2)|0],j)|0)+D(v[f+k|0],r)<<8>>1)|0)/16384;f=f+1|0;continue}break}while(1){if((p|0)!=2){q=(g+8|0)+(p<<2)|0;e=x[q>>2];b=(g+28|0)+(p<<3)|0;s=x[b+8>>2];h=x[b+4>>2];x[b+8>>2]=h;r=e<<8;e=r;e=Iua(e,e>>31,m,G);j=hb;f=e;e=Yb(h,-16777216,16776704);e=Iua(u,F,e,e>>31);h=f+e|0;l=hb+j|0;l=e>>>0>h>>>0?l+1|0:l;e=Yb(s,-16777216,16776704);j=Iua(t,E,e,e>>31);h=j+h|0;e=hb+l|0;e=h>>>0<j>>>0?e+1|0:e;j=h+8388608|0;e=j>>>0<8388608?e+1|0:e;e=Sc(j,e,24);x[b+4>>2]=e-(r&C);x[q>>2]=(e|0)/256;p=p+1|0;continue}break}o=o+B|0;x[c>>2]=x[c>>2]+D(x[g+8>>2],o>>12);n=n+A|0;x[c+4>>2]=x[c+4>>2]+D(x[g+12>>2],n>>12);Pb(g+16|0,i,H);c=c+8|0;d=d-1|0;continue}break}b=x[g+20>>2];x[a>>2]=x[g+16>>2];x[a+4>>2]=b;x[a+40>>2]=n;x[a+20>>2]=o>>12;x[a+36>>2]=o;x[a+24>>2]=n>>12;f=0;while(1){if((f|0)!=2){b=f<<3;c=b+a|0;b=b+(g+28|0)|0;x[c+44>>2]=x[b+4>>2];x[c+48>>2]=x[b+8>>2];f=f+1|0;continue}break}fb=g+48|0}function Cfa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;k=fb-48|0;fb=k;a:{b:{c:{j=dr(1,32);d:{e:{if(!j){a=un(ac(4));x[31609]=0;S(97,a|0,124540,34);a=x[31609];x[31609]=0;if((a|0)!=1){break a}i=T(0)|0;break e}x[j+12>>2]=f;x[j+8>>2]=e;x[j+4>>2]=d;f=c?c:977;x[j>>2]=f;c=og(k+36|0);f:{g:{h:{if(!i){break h}while(1){e=x[i>>2];if(!e){break h}l=x[i+4>>2];i:{if(l){x[31609]=0;e=P(36,k+24|0,e|0)|0;m=x[31609];x[31609]=0;j:{if((m|0)!=1){x[31609]=0;m=P(988,c|0,e|0)|0;n=x[31609];x[31609]=0;if((n|0)==1){break j}x[31609]=0;O(272,m|0,l|0);l=x[31609];x[31609]=0;if((l|0)==1){break j}break i}i=T(0)|0;break f}i=T(0)|0;tb(e);break f}x[31609]=0;e=P(36,k+12|0,e|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break g}hu(c,e)}tb(e);i=i+8|0;continue}}x[31609]=0;e=R(852,104)|0;i=x[31609];x[31609]=0;k:{l:{m:{if((i|0)!=1){x[31609]=0;d=P(989,f|0,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break m}x[k+4>>2]=d;d=k+4|0;f=x[re(k+8|0,d)>>2];x[31609]=0;a=ha(1020,e|0,a|0,b|0,f|0,c|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break k}i=T(0)|0;Wc(d);break l}i=T(0)|0;break f}i=T(0)|0}Db(e);break f}x[j+28>>2]=a;Wc(k+4|0);x[j+24>>2]=a+8;Ol(c);break d}i=T(0)|0}Ol(c);Y(i|0)|0;x[31609]=0;V(983,4973,j|0,g|0,h|0);a=x[31609];x[31609]=0;if((a|0)!=1){x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)!=1){a=x[j+28>>2];if(a){ib[x[x[a>>2]+4>>2]](a)}x[j+24>>2]=0;x[j+28>>2]=0;a=x[j+20>>2];if(a){Db(a);x[j+20>>2]=0}Db(j);j=0;break d}i=T(0)|0;break e}i=T(0)|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)==1){break b}}Y(i|0)|0;j=0;x[31609]=0;V(983,4973,0,g|0,h|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Z()}fb=k+48|0;return j|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){break b}Q(a|0);p()}T(0)|0;Sb()}p()}function d7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;q=fb-16|0;fb=q;i=c;while(1){a:{if((d|0)==(i|0)){i=d;break a}if(!y[i|0]){break a}i=i+1|0;continue}break}x[h>>2]=f;x[e>>2]=c;while(1){b:{c:{d:{if((c|0)==(d|0)|(f|0)==(g|0)){break d}k=x[b+4>>2];x[q+8>>2]=x[b>>2];x[q+12>>2]=k;r=fb-16|0;fb=r;u=rh(r+12|0,x[a+8>>2]);o=i-c|0;l=0;n=fb-1040|0;fb=n;k=x[e>>2];x[n+12>>2]=k;p=f?f:n+16|0;m=f?g-f>>2:256;e:{f:{g:{if(!(!k|!m)){while(1){j=o>>>2|0;if(!(o>>>0>131|j>>>0>=m>>>0)){j=k;break f}s=iK(p,n+12|0,j>>>0<m>>>0?j:m,b);j=x[n+12>>2];if((s|0)==-1){m=0;l=-1;break g}t=(n+16|0)!=(p|0)?s:0;m=m-t|0;p=(t<<2)+p|0;o=j?(k+o|0)-j|0:0;l=l+s|0;if(!j){break g}k=j;if(m){continue}break g}}j=k}if(!j){break e}}if(!m|!o){break e}k=l;while(1){h:{l=eq(p,j,o,b);i:{if(l+2>>>0<=2){j:{switch(l+1|0){case 1:x[n+12>>2]=0;break i;case 0:break e;default:break j}}x[b>>2]=0;break i}j=x[n+12>>2]+l|0;x[n+12>>2]=j;k=k+1|0;m=m-1|0;if(m){break h}}l=k;break e}p=p+4|0;o=o-l|0;l=k;if(o){continue}break}}if(f){x[e>>2]=x[n+12>>2]}fb=n+1040|0;qh(u);fb=r+16|0;k:{l:{m:{n:{if((l|0)==-1){while(1){o:{x[h>>2]=f;if(x[e>>2]==(c|0)){break o}g=1;p:{q:{r:{b=py(f,c,i-c|0,q+8|0,x[a+8>>2]);switch(b+2|0){case 0:break l;case 2:break p;case 1:break r;default:break q}}x[e>>2]=c;break n}g=b}c=c+g|0;f=x[h>>2]+4|0;continue}break}x[e>>2]=c;break d}f=x[h>>2]+(l<<2)|0;x[h>>2]=f;if((f|0)==(g|0)){break k}c=x[e>>2];if((d|0)==(i|0)){i=d;continue}if(!py(f,c,1,b,x[a+8>>2])){break m}}a=2;break c}x[h>>2]=x[h>>2]+4;c=x[e>>2]+1|0;x[e>>2]=c;i=c;while(1){if((d|0)==(i|0)){i=d;break b}if(!y[i|0]){break b}i=i+1|0;continue}}x[e>>2]=c;a=1;break c}c=x[e>>2]}a=(c|0)!=(d|0)}fb=q+16|0;return a|0}f=x[h>>2];continue}}function RR(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=fb-16|0;fb=f;e=D(b,872)+a|0;j=e+1074992|0;a:{b:{i=x[e+1075080>>2];if(i&131072){e=x[a+480180>>2];i=1;c:{d:{e:{h=x[a+480208>>2];if(h&4096){if(!(e&16777248)){break e}i=!(h&4)}if((e|0)!=64){break d}break b}if((e|0)==64){break b}h=a+480180|0;i=0;break c}h=a+480180|0;if(!i){break c}Jb(f+8|0,a+1074312|0,21);if(!Gb(x[x[f+8>>2]>>2],x[f+12>>2])){break c}e=D(b,872)+a|0;g=e+1075811|0;v[g|0]=y[g|0]+(y[e+1075815|0]<<2)}g=D(b,872)+a|0;k=g+1075814|0;l=g+1075811|0;e=KA(a,y[k|0],y[l|0]);f:{if(Lj(x[j+656>>2])){B[d>>2]=B[d>>2]+E(E(E(D(y[g+1075816|0],e)|0)*E(.05000000074505806))/E(7680));c=g+1075843|0;d=y[c|0];v[c|0]=d&159|64;if(x[a+1074416>>2]!=(x[a+1074392>>2]+1|0)){break f}v[c|0]=d|96;break f}d=x[a+480208>>2];if((d&2101248)==2101248){break a}g=x[h>>2];if(d&4096?g&67633152:0){break a}if(g&5){e=(y[k|0]&3)==1?0-e|0:e}k=a+1074312|0;Jb(f+8|0,k,21);g=x[a+480208>>2];g:{if(Gb(x[x[f+8>>2]>>2],x[f+12>>2])){d=g&4;e=d?e:0-e|0;d=d?5:6;break g}d=5;h:{if(g&131072){break h}h=x[h>>2];d=8;if((h|0)==1024){break h}d=7;if(h&524304){break h}d=h&16777248?g&4?6:7:6}Jb(f+8|0,k,80);if(!Gb(x[x[f+8>>2]>>2],x[f+12>>2])){break g}d=y[(D(b,872)+a|0)+1075783|0]==26?d+2|0:d}d=0-((D(y[(D(b,872)+a|0)+1075816|0],e)|0)/(1<<d)|0)|0;xk(a,j,c,d,0);e=x[j+656>>2];c=Dq(a,x[j+88>>2],e);if(!c){break f}ib[x[x[c>>2]+92>>2]](c,d,(e?v[e+33|0]:2)<<24>>24,b)}if(!i){break a}Jb(f+8|0,a+1074312|0,21);if(Gb(x[x[f+8>>2]>>2],x[f+12>>2])){break a}v[l|0]=y[l|0]+y[(D(b,872)+a|0)+1075815|0];break a}if(!(y[e+1075662|0]&2)){break a}a=Dq(a,i,x[j+656>>2]);if(!a){break a}ib[x[x[a>>2]+92>>2]](a,0,0,b);break a}a=D(b,872)+a|0;b=a+1075811|0;d=y[b|0];if(d&1){x[c>>2]=x[c>>2]+D(y[a+1075816|0],167)}v[b|0]=d+1}fb=f+16|0}function KX(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;f=fb-16|0;fb=f;v[a|0]=0;c=y[b|0];if(c){v[a|0]=c>>>0>96?-1:c+12|0}v[a+1|0]=y[b+1|0];c=y[b+2|0];a:{b:{if((c-16&255)>>>0<=128){v[a+2|0]=1;c=c+496>>>1|0;break b}c:{switch((c+96&240)>>>4|0){case 0:v[a+2|0]=4;c=c&15;break b;case 1:v[a+2|0]=3;c=c&15;break b;case 2:v[a+2|0]=6;c=c&15;break b;case 3:break c;default:break a}}v[a+2|0]=5;c=c&15}v[a+4|0]=c}c=y[b+6|0];d=y[b+5|0];e=y[b+4|0];d:{if(!(c|(d|e))){break d}e:{f:{g:{h:{i:{j:{switch(e|0){default:k:{switch(e-29|0){case 7:break f;case 5:break g;case 3:break h;case 0:break i;case 1:case 2:case 4:case 6:break d;default:break k}}if((e|0)==128){break e}if((e|0)!=157){break d}v[a+2|0]=15;v[a+3|0]=20;v[a+4|0]=c>>>3;v[f+15|0]=15;h=a,i=y[Qb(b+5|0,f+15|0)|0]|208,v[h+5|0]=i;break d;case 0:Cf(a,c,d);g=y[b+6|0]==15;break d;case 1:v[a+3|0]=2;h=a,i=Eh(c<<4|(d&240)>>>4),v[h+5|0]=i;break d;case 2:v[a+3|0]=3;h=a,i=Eh(c<<4|(d&240)>>>4),v[h+5|0]=i;break d;case 3:v[a+3|0]=4;h=a,i=Eh(c<<4|(d&240)>>>4),v[h+5|0]=i;break d;case 4:v[a+3|0]=5;v[a+5|0]=c&240|(d&240)>>>4;break d;case 8:if(d){v[a+5|0]=d;v[a+3|0]=9;break d}if((c-1&255)>>>0>1){break d}v[a+5|0]=145;v[a+3|0]=20;break d;case 12:v[a+3|0]=13;v[a+5|0]=c>>>1;break d;case 15:if(c){v[a+5|0]=c;v[a+3|0]=17;break d}v[a+3|0]=16;v[a+5|0]=d&15;break d;case 16:break j;case 5:case 6:case 7:case 9:case 10:case 11:case 13:case 14:break d}}BD(a,c,d,1);g=(y[a+3|0]&254)==16;break d}v[a+5|0]=d;v[a+3|0]=18;break d}v[a+3|0]=31;v[a+5|0]=c>>>1;break d}v[a+3|0]=31;v[a+5|0]=c>>>1&120;break d}v[a+5|0]=159;v[a+3|0]=20;break d}v[a+3|0]=21;v[a+5|0]=c>>>2}b=y[b+3|0];l:{if(!b){break l}if(!y[a+3|0]){v[a+5|0]=b;v[a+3|0]=9;break l}if(y[a+2|0]){break l}v[a+2|0]=2;v[a+4|0]=b>>>2}fb=f+16|0;return g}function uP(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;k=fb-48|0;fb=k;a:{b:{c:{d:{e:{f:{j=dr(1,28);if(!j){a=un(ac(4));x[31609]=0;S(97,a|0,124540,34);a=x[31609];x[31609]=0;if((a|0)!=1){break a}break f}x[j+12>>2]=f;x[j+8>>2]=e;x[j+4>>2]=d;f=c?c:977;x[j>>2]=f;c=og(k+36|0);g:{h:{i:{if(!i){break i}while(1){e=x[i>>2];if(!e){break i}l=x[i+4>>2];j:{if(l){x[31609]=0;e=P(36,k+24|0,e|0)|0;m=x[31609];x[31609]=0;k:{if((m|0)!=1){x[31609]=0;m=P(988,c|0,e|0)|0;n=x[31609];x[31609]=0;if((n|0)==1){break k}x[31609]=0;O(272,m|0,l|0);l=x[31609];x[31609]=0;if((l|0)==1){break k}break j}i=T(0)|0;break g}i=T(0)|0;tb(e);break g}x[31609]=0;e=P(36,k+12|0,e|0)|0;l=x[31609];x[31609]=0;if((l|0)==1){break h}hu(c,e)}tb(e);i=i+8|0;continue}}x[31609]=0;e=R(852,80)|0;i=x[31609];x[31609]=0;l:{m:{n:{if((i|0)!=1){x[31609]=0;d=P(989,f|0,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break n}x[k+4>>2]=d;d=k+4|0;f=x[re(k+8|0,d)>>2];x[31609]=0;a=ha(994,e|0,a|0,b|0,f|0,c|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break l}i=T(0)|0;Wc(d);break m}i=T(0)|0;break g}i=T(0)|0}Db(e);break g}x[j+24>>2]=a;Wc(k+4|0);Ol(c);i=j;break d}i=T(0)|0}Ol(c);Y(i|0)|0;x[31609]=0;V(983,15174,j|0,g|0,h|0);a=x[31609];x[31609]=0;if((a|0)!=1){x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)==1){break f}a=x[j+24>>2];if(a){Db(sq(a))}i=0;x[j+24>>2]=0;a=x[j+20>>2];if(a){Db(a);x[j+20>>2]=0}Db(j);break d}i=T(0)|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)!=1){break e}break b}i=T(0)|0}Y(i|0)|0;i=0;x[31609]=0;V(983,15174,0,g|0,h|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Z()}fb=k+48|0;return i|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){break b}Q(a|0);p()}T(0)|0;Sb()}p()}function _la(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0;f=fb-48|0;fb=f;t=x[a+16>>2];while(1){if((g|0)!=2){j=g<<3;n=j+(f+28|0)|0;j=a+j|0;x[n+4>>2]=x[j+44>>2];x[n+8>>2]=x[j+48>>2];g=g+1|0;continue}break}u=x[a+24>>2];v=x[a+20>>2];j=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=j;y=b+24|0;z=x[a+72>>2];s=x[a+68>>2];A=s>>31;g=x[a+64>>2];B=g>>31;n=x[a+60>>2];C=n>>31;j=x[a+8>>2];E=x[a+12>>2];while(1){if(d){b=x[f+16>>2];h=((((x[f+20>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+t|0;b=(((b>>>16|0)+4&131064)<<1)+y|0;F=w[b+14>>1];m=w[b+12>>1];p=w[b+10>>1];r=w[b+8>>1];i=w[b+6>>1];q=w[b+4>>1];k=w[b+2>>1];e=w[b>>1];o=0;b=0;while(1){if((b|0)!=2){l=b<<1;x[(f+8|0)+(b<<2)>>2]=(((((D(w[h+(l|8)>>1],p)+D(w[h+(l|4)>>1],r)|0)+D(m,w[h+(l|12)>>1])|0)+D(F,w[h+(l|16)>>1])|0)/2|0)+((((D(w[h+(l|-8)>>1],k)+D(w[h+(l|-12)>>1],e)|0)+D(w[h+(l|-4)>>1],q)|0)+D(w[h+l>>1],i)|0)/2|0)|0)/16384;b=b+1|0;continue}break}while(1){if((o|0)!=2){p=(f+8|0)+(o<<2)|0;e=x[p>>2];b=(f+28|0)+(o<<3)|0;r=x[b+8>>2];i=x[b+4>>2];x[b+8>>2]=i;q=e<<8;e=q;e=Iua(e,e>>31,n,C);k=hb;h=e;e=Yb(i,-16777216,16776704);e=Iua(g,B,e,e>>31);i=h+e|0;m=hb+k|0;m=e>>>0>i>>>0?m+1|0:m;e=Yb(r,-16777216,16776704);k=Iua(s,A,e,e>>31);i=k+i|0;e=hb+m|0;e=i>>>0<k>>>0?e+1|0:e;k=i+8388608|0;e=k>>>0<8388608?e+1|0:e;e=Sc(k,e,24);x[b+4>>2]=e-(q&z);x[p>>2]=(e|0)/256;o=o+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[f+8>>2],v);x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],u);Pb(f+16|0,j,E);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;g=0;while(1){if((g|0)!=2){b=g<<3;c=b+a|0;b=b+(f+28|0)|0;x[c+44>>2]=x[b+4>>2];x[c+48>>2]=x[b+8>>2];g=g+1|0;continue}break}fb=f+48|0}function Eg(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0;i=x[a+8>>2]+(D(z[a+14>>1],(y[a+80|0]?c:0)+b|0)>>>1|0)|0;x[a+8>>2]=i;g=y[a+79|0]?z[x[a>>2]+3836>>1]:g;c=z[a+20>>1];h=z[a+22>>1];k=z[a+70>>1];a:{b:{c:{d:{switch(x[a+16>>2]){case 1:b=z[x[a>>2]+3832>>1];f=c+(b&z[a+46>>1]?0:z[a+26>>1]?z[a+48>>1]>>>z[x[a+52>>2]+((b>>>z[a+44>>1]&7)<<1)>>1]|0:0)|0;w[a+20>>1]=f;b=2;j=z[a+28>>1];if((j|0)<=f<<16>>16){break c}break b;case 2:if(y[a+78|0]){break b}case 3:b=0;f=z[x[a>>2]+3832>>1];f=c+(f&z[a+58>>1]?0:z[a+30>>1]?z[a+60>>1]>>>z[x[a+64>>2]+((f>>>z[a+56>>1]&7)<<1)>>1]|0:0)|0;w[a+20>>1]=f;if(f<<16>>16<511){break b}x[a+16>>2]=-1;w[a+20>>1]=511;x[a+72>>2]=0;break a;default:b=0;x[a+72>>2]=0;break a;case 0:break d}}b=1;f=z[x[a>>2]+3832>>1];f=c+(f&z[a+34>>1]?0:z[a+24>>1]?D((c^-1)<<16>>16,z[a+36>>1]>>>z[x[a+40>>2]+((f>>>z[a+32>>1]&7)<<1)>>1]|0)>>>3|0:0)|0;w[a+20>>1]=f;if(f<<16>>16>0){break b}}x[a+16>>2]=b;w[a+20>>1]=j}h=((c+h|0)+k|0)+g<<3;if(e){d=(w[a+74>>1]+w[a+72>>1]>>e)+d|0}d=(i>>>10|0)+d|0;c=d&255;b=d&65535;e:{f:{switch(z[a+12>>1]){case 0:g=(b&512)>>>9|0;b=z[((b&256?c^255:c)<<1)+26768>>1];break e;case 1:g=0;b=z[((b&512?0:b&256?c^255:c)<<1)+26768>>1];break e;case 2:g=0;b=z[((b&256?c^255:c)<<1)+26768>>1];break e;case 3:g=0;b=z[((b&256?0:c)<<1)+26768>>1];break e;case 4:g=0;if(b&512){b=0}else{g=(d&256)>>>8|0;b=(c<<1^b<<24>>31)&254}b=z[(b<<1)+26768>>1];break e;case 5:g=0;if(b&512){b=0}else{c=c<<1&254;b=b&128?c^255:c}b=z[(b<<1)+26768>>1];break e;case 6:g=(d&512)>>>9|0;b=0;break e;default:break f}}c=d<<3&4088;g=(b&512)>>>9|0;b=g?c^4088:c}w[a+74>>1]=z[a+72>>1];c=a;a=b+h&65535;a=a>>>0>=8191?8191:a;b=0-(g&1)^z[((a&255)<<1)+26256>>1]+1024>>>(a>>>8)<<1;w[c+72>>1]=b}return b<<16>>16}function LS(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=fb-16|0;fb=c;d=a+1074376|0;e=D(b,872);a:{if(x[(d+e|0)+704>>2]&67109888){break a}f=a+e|0;g=x[f+1075648>>2];if(!Cj(g)|y[g+15|0]&2){break a}d=pm(a,d,b,2,1)-1|0;if((d&255)>>>0>249){break a}h=x[$d(a+906300|0,d)>>2];if(!h){break a}d=f;j=d+1075780|0;e=y[j|0];b:{if(y[d+1075782|0]==1){v[c+8|0]=64;d=y[Qb(d+1075784|0,c+8|0)|0];break b}f=y[d+1075783|0];if((f|0)!=46){d=255;if((f|0)!=13){break b}v[c+8|0]=64;d=y[Qb((D(b,872)+a|0)+1075785|0,c+8|0)|0];break b}d=y[(D(b,872)+a|0)+1075785|0]+3>>>2|0}i=a+1074312|0;Jb(c+8|0,i,2);if(Gb(x[x[c+8>>2]>>2],x[c+12>>2])){if(e){if(Tc(e)){e=y[xb(g+108|0,e-1|0)|0]}Ym(a,b,e&255,z[(D(b,872)+a|0)+1075680>>1]);break a}if((d|0)==255){break a}ib[x[x[h>>2]+76>>2]](h,39,d,b);break a}k=x[g+4>>2];c:{if(!e){break c}f=y[g+35|0]?k<<2:x[(D(b,872)+a|0)+1075680>>2];l=w[(D(b,872)+a|0)+1075768>>1];Jb(c+8|0,i,28);m=c,n=f+(Gb(x[x[c+8>>2]>>2],x[c+12>>2])?l<<2:l)|0,x[m+4>>2]=n;He(c+4|0,0,256);f=e;if(Tc(e)){f=y[xb(g+108|0,e-1|0)|0]}Jb(c+8|0,i,117);if(!Gb(x[x[c+8>>2]>>2],x[c+12>>2])){if(Ll(y[j+2|0],y[j+3|0])){break c}}Ym(a,b,f&255,z[c+4>>1])}a=y[g+35|0];Jb(c+8|0,i,101);a=(a|0)==1;f=(d|0)!=255;if(!Gb(x[x[c+8>>2]>>2],x[c+12>>2])){e=Tc(e)}if(((e?a:f)|0)!=1){break a}d:{switch(y[g+36|0]){case 1:a=x[h+20>>2];if((d|0)!=255){Iu(a,E(E(E(d<<1)/E(-127))+E(1)));break a}Iu(a,E(E(E(k<<1>>>0)/E(-127))+E(1)));break a;case 0:break d;default:break a}}if((d|0)!=255){v[c+8|0]=127;v[c+4|0]=d<<1;n=h,o=7,p=y[Qb(c+8|0,c+4|0)|0],q=b,m=x[x[h>>2]+76>>2],ib[m](n|0,o|0,p|0,q|0);break a}x[c+8>>2]=127;x[c+4>>2]=k<<1;q=h,p=7,o=y[Hb(c+8|0,c+4|0)|0],n=b,m=x[x[h>>2]+76>>2],ib[m](q|0,p|0,o|0,n|0)}fb=c+16|0}function $la(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0;g=fb-48|0;fb=g;t=x[a+16>>2];while(1){if((f|0)!=2){i=f<<3;m=i+(g+28|0)|0;i=a+i|0;x[m+4>>2]=x[i+44>>2];x[m+8>>2]=x[i+48>>2];f=f+1|0;continue}break}u=x[a+24>>2];y=x[a+20>>2];i=x[a+4>>2];x[g+16>>2]=x[a>>2];x[g+20>>2]=i;z=b+24|0;A=x[a+72>>2];r=x[a+68>>2];B=r>>31;s=x[a+64>>2];C=s>>31;m=x[a+60>>2];E=m>>31;i=x[a+8>>2];F=x[a+12>>2];while(1){if(d){b=x[g+16>>2];k=(((x[g+20>>2]&2147483647)<<1|b>>>31)&-2)+t|0;b=(((b>>>16|0)+4&131064)<<1)+z|0;l=w[b+14>>1];o=w[b+12>>1];q=w[b+10>>1];h=w[b+8>>1];p=w[b+6>>1];j=w[b+4>>1];e=w[b+2>>1];b=w[b>>1];n=0;f=0;while(1){if((f|0)!=2){x[(g+8|0)+(f<<2)>>2]=((((D(q,v[k+(f|4)|0])+D(v[k+(f|2)|0],h)|0)+D(o,v[k+(f|6)|0])|0)+D(l,v[k+(f|8)|0])<<8>>1)+(((D(v[k+(f|-4)|0],e)+D(v[k+(f|-6)|0],b)|0)+D(v[k+(f|-2)|0],j)|0)+D(v[f+k|0],p)<<8>>1)|0)/16384;f=f+1|0;continue}break}while(1){if((n|0)!=2){o=(g+8|0)+(n<<2)|0;e=x[o>>2];b=(g+28|0)+(n<<3)|0;q=x[b+8>>2];h=x[b+4>>2];x[b+8>>2]=h;p=e<<8;e=p;e=Iua(e,e>>31,m,E);j=hb;f=e;e=Yb(h,-16777216,16776704);e=Iua(s,C,e,e>>31);h=f+e|0;l=hb+j|0;l=e>>>0>h>>>0?l+1|0:l;e=Yb(q,-16777216,16776704);j=Iua(r,B,e,e>>31);h=j+h|0;e=hb+l|0;e=h>>>0<j>>>0?e+1|0:e;j=h+8388608|0;e=j>>>0<8388608?e+1|0:e;e=Sc(j,e,24);x[b+4>>2]=e-(p&A);x[o>>2]=(e|0)/256;n=n+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[g+8>>2],y);x[c+4>>2]=x[c+4>>2]+D(u,x[g+12>>2]);Pb(g+16|0,i,F);c=c+8|0;d=d-1|0;continue}break}b=x[g+20>>2];x[a>>2]=x[g+16>>2];x[a+4>>2]=b;f=0;while(1){if((f|0)!=2){b=f<<3;c=b+a|0;b=b+(g+28|0)|0;x[c+44>>2]=x[b+4>>2];x[c+48>>2]=x[b+8>>2];f=f+1|0;continue}break}fb=g+48|0}function Ah(a,b,c,d,e){var f=0,g=0,h=0;if(!b){c=fb-16|0;fb=c;a:{if((d|0)==189){v[a+3843|0]=e>>>7;v[a+3844|0]=e>>>6&1;break a}b=d&224;if(!b){if((d|0)!=260){break a}b=0;d=1;while(1){if((b|0)==6){break a}f=D(b>>>0<3?b:b+6|0,44)+a|0;g=f+148|0;f=f+16|0;h=d&e;b:{if(h){No(f,g);break b}No(f,0)}v[g+40|0]=!h;b=b+1|0;d=d<<1&510;continue}}if(b-160>>>0<=32){b=d&15;if(b>>>0>8){break a}a=D(d&256?b+9|0:b,44)+a|0;x[c+8>>2]=a+16;b=x[a+52>>2];x[c+12>>2]=b;g=b?2:1;c:{b=d&240;if((b|0)!=160){if((b|0)==192){break c}if((b|0)!=176){break a}f=e&3;h=e>>>2&7;b=0;d=(e&32)!=0;while(1){if((b|0)==(g|0)){break a}a=x[(c+8|0)+(b<<2)>>2];LU(x[a>>2],d);LU(x[a+4>>2],d);w[a+22>>1]=h;VB(a);NU(a);v[a+21|0]=f;VB(a);NU(a);b=b+1|0;continue}}b=0;while(1){if((b|0)==(g|0)){break a}a=x[(c+8|0)+(b<<2)>>2];w[a+20>>1]=z[a+20>>1]&768|e&255;VB(a);b=b+1|0;continue}}v[a+58|0]=(e&32)>>>5;v[a+57|0]=(e&16)>>>4;b=e>>>1&7;w[a+46>>1]=b?9-b|0:0;w[a+48>>1]=e&1;break a}if((b|0)!=224&b>>>0>=129|-4144960>>>d&1){break a}f=a;a=v[(d&31)+27360|0];a=(f+D(d&256?a+18|0:a,84)|0)+808|0;d:{switch(b-32>>>5|0){case 0:v[a+79|0]=e>>>7;v[a+80|0]=(e&64)>>>6;v[a+78|0]=(e&32)>>>5;v[a+77|0]=(e&16)>>>4;Oo(a);b=fb-32|0;x[b+24>>2]=1572888;x[b+28>>2]=1966110;x[b+16>>2]=1179664;x[b+20>>2]=1310740;x[b+8>>2]=655368;x[b+12>>2]=917516;x[b>>2]=131073;x[b+4>>2]=393220;w[a+14>>1]=z[b+((e&15)<<1)>>1];break a;case 1:w[a+68>>1]=y[(e>>>6|0)+22277|0];MU(a);w[a+22>>1]=(e&63)<<2;break a;case 2:w[a+24>>1]=e>>>4;Oo(a);w[a+26>>1]=e&15;Oo(a);break a;case 3:b=e>>>4|0;w[a+28>>1]=b>>>0>=15?496:b<<4;w[a+30>>1]=e&15;Oo(a);break a;case 6:break d;default:break a}}w[a+12>>1]=e&7}fb=c+16|0;return}ib[x[x[b>>2]>>2]](b,c,d,e)}function st(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;i=fb-128|0;fb=i;x[i+124>>2]=b;k=wt(c,d);x[i+4>>2]=1239;n=vt(i+8|0,i+4|0);j=i+16|0;a:{b:{if(k>>>0>=101){j=Gd(k);if(!j){x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)!=1){break a}break b}Qe(n,j)}h=j;b=c;c:{d:{while(1){if((b|0)==(d|0)){e:while(1){f:{x[31609]=0;h=P(1257,a|0,i+124|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break f}if((!k|h)==1){x[31609]=0;b=P(1257,a|0,i+124|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}if(!b){break d}x[f>>2]=x[f>>2]|2;break d}b=x[a>>2];x[31609]=0;o=R(1258,b|0)|0;b=x[31609];x[31609]=0;g:{if((b|0)!=1){if(g){break g}x[31609]=0;o=P(1259,e|0,o|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break g}}break b}l=q+1|0;s=0;h=j;b=c;while(1){if((b|0)==(d|0)){q=l;if(!s){continue e}x[31609]=0;R(1260,a|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){h=j;b=c;if(k+m>>>0<2){continue e}while(1){if((b|0)==(d|0)){continue e}h:{if(y[h|0]!=2){break h}if((Cb(x[b+4>>2],y[b+11|0])|0)==(q|0)){break h}v[h|0]=0;m=m-1|0}h=h+1|0;b=b+12|0;continue}}break b}i:{if(y[h|0]!=1){break i}r=x[Wd(b,q)>>2];j:{if(g){break j}x[31609]=0;r=P(1259,e|0,r|0)|0;t=x[31609];x[31609]=0;if((t|0)!=1){break j}break b}k:{if((o|0)==(r|0)){s=1;if((Cb(x[b+4>>2],y[b+11|0])|0)!=(l|0)){break i}v[h|0]=2;m=m+1|0;break k}v[h|0]=0}k=k-1|0}h=h+1|0;b=b+12|0;continue}}break}}else{l=Ad(x[b+4>>2],y[b+11|0]);v[h|0]=l?2:1;m=m+l|0;k=k-l|0;h=h+1|0;b=b+12|0;continue}break}break b}l:{m:{while(1){if((c|0)==(d|0)){break m}if(y[j|0]!=2){j=j+1|0;c=c+12|0;continue}break}d=c;break l}x[f>>2]=x[f>>2]|4}Lc(n);fb=i+128|0;return d|0}}a=N()|0;Lc(n);Q(a|0)}p()}function xt(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;i=fb-128|0;fb=i;x[i+124>>2]=b;k=wt(c,d);x[i+4>>2]=1239;n=vt(i+8|0,i+4|0);j=i+16|0;a:{b:{if(k>>>0>=101){j=Gd(k);if(!j){x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)!=1){break a}break b}Qe(n,j)}h=j;b=c;c:{d:{while(1){if((b|0)==(d|0)){e:while(1){f:{x[31609]=0;h=P(1241,a|0,i+124|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break f}if((!k|h)==1){x[31609]=0;b=P(1241,a|0,i+124|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}if(!b){break d}x[f>>2]=x[f>>2]|2;break d}b=x[a>>2];x[31609]=0;o=R(1242,b|0)|0;b=x[31609];x[31609]=0;g:{if((b|0)!=1){if(g){break g}x[31609]=0;o=P(1243,e|0,o|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break g}}break b}l=q+1|0;s=0;h=j;b=c;while(1){if((b|0)==(d|0)){q=l;if(!s){continue e}x[31609]=0;R(1244,a|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){h=j;b=c;if(k+m>>>0<2){continue e}while(1){if((b|0)==(d|0)){continue e}h:{if(y[h|0]!=2){break h}if((Cb(x[b+4>>2],y[b+11|0])|0)==(q|0)){break h}v[h|0]=0;m=m-1|0}h=h+1|0;b=b+12|0;continue}}break b}i:{if(y[h|0]!=1){break i}r=v[dc(b,q)|0];j:{if(g){break j}x[31609]=0;r=P(1243,e|0,r|0)|0;t=x[31609];x[31609]=0;if((t|0)!=1){break j}break b}k:{if((o|0)==(r|0)){s=1;if((Cb(x[b+4>>2],y[b+11|0])|0)!=(l|0)){break i}v[h|0]=2;m=m+1|0;break k}v[h|0]=0}k=k-1|0}h=h+1|0;b=b+12|0;continue}}break}}else{l=Ad(x[b+4>>2],y[b+11|0]);v[h|0]=l?2:1;m=m+l|0;k=k-l|0;h=h+1|0;b=b+12|0;continue}break}break b}l:{m:{while(1){if((c|0)==(d|0)){break m}if(y[j|0]!=2){j=j+1|0;c=c+12|0;continue}break}d=c;break l}x[f>>2]=x[f>>2]|4}Lc(n);fb=i+128|0;return d|0}}a=N()|0;Lc(n);Q(a|0)}p()}function Mna(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=fb-48|0;fb=h;k=c+484344|0;Tf(k,y[b+70|0]|y[b+71|0]<<8);a:{b:{while(1){if((y[b+70|0]|y[b+71|0]<<8)>>>0<=j>>>0){break b}f=x[a+8>>2];e=Rg(a);Vb(a,1);c:{if((y[b+58|0]|y[b+59|0]<<8)==258){c=Zd(a)+1|0;break c}c=gh(a)}d=gh(a);dd(a,e+f|0);e=h+8|0;he(e,a,d);f=hc(h+28|0,e);ub(e);x[31609]=0;c=U(196,k|0,j&65535,(c?c>>>0>=1024?1024:c:64)|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){d:{if(!(c&(d|0)!=0)){break d}c=Wb(x[k>>2],j);m=h,n=wb(x[c>>2]),x[m+8>>2]=n;l=wb(x[c+4>>2]);while(1){c=x[h+8>>2];if(!Ib(c,l)){break d}x[31609]=0;d=R(197,f|0)|0;e=x[31609];x[31609]=0;e:{f:{g:{if((e|0)!=1){e=d<<24>>24;if((e|0)>=0){break g}if(e&1){x[31609]=0;d=R(197,f|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break a}v[c|0]=d}d=e&255;if(e&2){break f}break e}break a}v[c|0]=e;d=255}x[31609]=0;e=R(197,f|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break a}v[c+1|0]=e}i=0;e=0;if(d&4){x[31609]=0;e=R(197,f|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break a}}if(d&8){x[31609]=0;i=R(197,f|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break a}}if(d&16){x[31609]=0;d=R(197,f|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break a}v[c+5|0]=d}h:{i:{d=y[c|0];if(!d){break i}g=255;if((d|0)==97){break h}if(d>>>0>96){break i}g=d+12|0;break h}g=0}v[c|0]=g;d=y[c+5|0];j:{if((d|i)&255){Cf(c,i,d);break j}v[c+3|0]=0}if(y[c+1|0]==255){v[c+1|0]=0}d=e-16|0;k:{if((d&255)>>>0<=64){v[c+4|0]=d;v[c+2|0]=1;break k}if(e>>>0<96){break k}d=e&15;v[c+4|0]=d;e=e-96>>>4|0;v[c+2|0]=y[e+25502|0];if((e|0)!=6){break k}v[c+4|0]=d<<2}tg(h+8|0);continue}}ub(f);j=j+1|0;continue}break}break a}fb=h+48|0;return}a=N()|0;ub(f);Q(a|0);p()}function Bma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0,C=0;f=fb-48|0;fb=f;t=x[a+16>>2];b=0;while(1){if((b|0)!=2){h=b<<3;o=h+(f+28|0)|0;h=a+h|0;x[o+4>>2]=x[h+44>>2];x[o+8>>2]=x[h+48>>2];b=b+1|0;continue}break}m=x[a+40>>2];n=x[a+36>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;u=x[a+32>>2];v=x[a+28>>2];y=x[a+72>>2];q=x[a+68>>2];z=q>>31;r=x[a+64>>2];A=r>>31;s=x[a+60>>2];B=s>>31;o=x[a+8>>2];C=x[a+12>>2];while(1){if(d){b=x[f+16>>2];k=((((x[f+20>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+t|0;b=b>>>21&2040;p=w[b+38086>>1];i=w[b+38084>>1];e=w[b+38082>>1];h=w[b+38080>>1];b=0;j=0;while(1){if((j|0)!=2){g=j<<1;x[(f+8|0)+(j<<2)>>2]=(((D(w[g+k>>1],e)+D(w[k+(g|-4)>>1],h)|0)+D(i,w[k+(g|4)>>1])|0)+D(p,w[k+(g|8)>>1])|0)/16384;j=j+1|0;continue}break}while(1){if((b|0)!=2){j=(f+8|0)+(b<<2)|0;e=x[j>>2];h=(f+28|0)+(b<<3)|0;k=x[h+8>>2];g=x[h+4>>2];x[h+8>>2]=g;p=e<<8;e=p;e=Iua(e,e>>31,s,B);i=hb;l=e;e=Yb(g,-16777216,16776704);e=Iua(r,A,e,e>>31);g=l+e|0;l=hb+i|0;l=e>>>0>g>>>0?l+1|0:l;e=Yb(k,-16777216,16776704);i=Iua(q,z,e,e>>31);g=i+g|0;e=hb+l|0;e=g>>>0<i>>>0?e+1|0:e;i=g+8388608|0;e=i>>>0<8388608?e+1|0:e;e=Sc(i,e,24);x[h+4>>2]=e-(p&y);x[j>>2]=(e|0)/256;b=b+1|0;continue}break}n=n+v|0;x[c>>2]=x[c>>2]+D(x[f+8>>2],n>>12);m=m+u|0;x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],m>>12);Pb(f+16|0,o,C);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;x[a+40>>2]=m;x[a+20>>2]=n>>12;x[a+36>>2]=n;x[a+24>>2]=m>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function O4(a){a=a|0;var b=0,c=0,d=0;a=a+12|0;d=a+508|0;c=Cb(x[a+512>>2],y[a+519|0]);while(1){a:{if((b|0)==(c|0)){b=c;break a}if(x[Wd(d,b)>>2]==37){break a}b=b+1|0;continue}break}b:{c:{d:{e:{f:{a=x[Wd(d,b+1|0)>>2];if((a|0)!=121){if((a|0)==100){break f}if((a|0)==109){break e}if((a|0)!=89){break c}}b=b+2|0;a=b>>>0<c>>>0?c:b;while(1){g:{if(b>>>0<c>>>0){if(x[Wd(d,b)>>2]!=37){break g}a=b}if((a|0)==(c|0)){break c}b=x[Wd(d,a+1|0)>>2];if((b|0)==100){break d}if((b|0)!=109){break c}b=a+2|0;a=b>>>0<c>>>0?c:b;while(1){h:{if(b>>>0<c>>>0){if(x[Wd(d,b)>>2]!=37){break h}a=b}if((a|0)==(c|0)){break c}b=3;if(x[Wd(d,a+1|0)>>2]!=100){break c}break b}b=b+1|0;continue}}b=b+1|0;continue}}b=b+2|0;a=b>>>0<c>>>0?c:b;while(1){i:{if(b>>>0<c>>>0){if(x[Wd(d,b)>>2]!=37){break i}a=b}if((a|0)==(c|0)){break c}if(x[Wd(d,a+1|0)>>2]!=109){break c}b=a+2|0;a=b>>>0<c>>>0?c:b;while(1){j:{if(b>>>0<c>>>0){if(x[Wd(d,b)>>2]!=37){break j}a=b}if((a|0)==(c|0)){break c}b=1;a=a+1|0;if(x[Wd(d,a)>>2]==121){break b}if(x[Wd(d,a)>>2]==89){break b}break c}b=b+1|0;continue}}b=b+1|0;continue}}b=b+2|0;a=b>>>0<c>>>0?c:b;while(1){k:{if(b>>>0<c>>>0){if(x[Wd(d,b)>>2]!=37){break k}a=b}if((a|0)==(c|0)){break c}if(x[Wd(d,a+1|0)>>2]!=100){break c}b=a+2|0;a=b>>>0<c>>>0?c:b;while(1){l:{if(b>>>0<c>>>0){if(x[Wd(d,b)>>2]!=37){break l}a=b}if((a|0)==(c|0)){break c}b=2;a=a+1|0;if(x[Wd(d,a)>>2]==121){break b}if(x[Wd(d,a)>>2]!=89){break c}break b}b=b+1|0;continue}}b=b+1|0;continue}}b=a+2|0;a=b>>>0<c>>>0?c:b;while(1){m:{if(b>>>0<c>>>0){if(x[Wd(d,b)>>2]!=37){break m}a=b}if((a|0)==(c|0)){break c}b=4;if(x[Wd(d,a+1|0)>>2]!=109){break c}break b}b=b+1|0;continue}}b=0}return b|0}function oja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;c=fb-192|0;fb=c;e=Lm(c+80|0,a);x[31609]=0;d=P(461,c+68|0,42207)|0;a=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if((a|0)!=1){x[31609]=0;x[c+56>>2]=20054022;x[c+60>>2]=0;a=c+56|0;S(462,e|0,d|0,a|0);f=x[31609];x[31609]=0;if((f|0)==1){break n}Eb(d);if(rl(y[e|0])){break e}x[31609]=0;d=P(461,a|0,13450)|0;a=x[31609];x[31609]=0;if((a|0)==1){break m}x[31609]=0;V(493,e|0,b|0,d|0,914);a=x[31609];x[31609]=0;if((a|0)==1){break l}Eb(d);x[c+52>>2]=0;x[c+48>>2]=0;x[31609]=0;d=P(461,c+36|0,16785)|0;a=x[31609];x[31609]=0;if((a|0)==1){break k}x[31609]=0;S(915,e|0,c+52|0,d|0);a=x[31609];x[31609]=0;if((a|0)==1){break j}Eb(d);x[31609]=0;d=P(461,c+24|0,16775)|0;a=x[31609];x[31609]=0;if((a|0)==1){break i}x[31609]=0;S(915,e|0,c+48|0,d|0);a=x[31609];x[31609]=0;if((a|0)==1){break h}Eb(d);a=x[c+52>>2];d=x[c+48>>2];o:{if(!a|d>>>0<a>>>0){break o}f=x[x[x[x[b+48>>2]+12>>2]+8>>2]+40>>2];if(f>>>0<a>>>0|d>>>0>f>>>0){break o}x[b+20>>2]=d;x[b+16>>2]=a}d=Nb(c+12|0);x[31609]=0;f=P(461,c|0,14194)|0;a=x[31609];x[31609]=0;if((a|0)==1){break d}x[31609]=0;S(916,e|0,d|0,f|0);a=x[31609];x[31609]=0;if((a|0)==1){break g}Eb(f);if(mc(x[d>>2],x[d+4>>2])){break f}a=x[b+16>>2];x[31609]=0;O(866,d|0,a|0);a=x[31609];x[31609]=0;if((a|0)!=1){break f}break c}a=N()|0;break a}a=N()|0;Eb(d);break a}a=N()|0;break a}a=N()|0;Eb(d);break a}a=N()|0;break a}a=N()|0;Eb(d);break a}a=N()|0;break a}a=N()|0;Eb(d);break a}a=N()|0;Eb(f);break b}x[31609]=0;O(917,b|0,d|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}wc(d)}Ch(e);fb=c+192|0;return}a=N()|0;break b}a=N()|0}wc(d)}Ch(e);Q(a|0);p()}function ED(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;l=fb-16|0;fb=l;a:{if(b&4){break a}e=y[a+14|0];b:{if(e>>>0>=y[a+15|0]){break b}c=y[a+12|0];if(!(c&2)){break b}v[a+12|0]=c&251}if(!(y[a+12|0]&2)|e>>>0<=y[a+13|0]){break a}c=x[a>>2];d=x[a+4>>2];if(Sd(c,d)>>>0<=e>>>0){break a}c=z[Pc(c,d,e)>>1];d=Pc(x[a>>2],x[a+4>>2],y[a+14|0]-1|0);e=y[a+14|0];if(z[d>>1]<(c-1|0)){e=z[Pc(x[a>>2],x[a+4>>2],e)>>1]-1&65535;c=Qq(a,e,64,64);d=vb(l+12|0,Fk(wb(x[a>>2]),y[a+14|0]));h=Zl(l+8|0,e,c&255);n=fb-32|0;fb=n;e=x[a>>2];e=(Mv(x[d>>2],wb(e))<<2)+e|0;f=x[a+4>>2];c:{d:{if(f>>>0<A[Ab(a)>>2]){if((e|0)!=(f|0)){break d}WY(a,h);break c}c=Ab(a);d=Zf(n+12|0,Mf(a,oc(x[a>>2],f)+1|0),e-x[a>>2]>>2,c);x[31609]=0;O(780,d|0,h|0);c=x[31609];x[31609]=0;if((c|0)!=1){f=fb-16|0;fb=f;c=x[d+4>>2];h=vb(f+12|0,e);g=vb(f+8|0,x[a>>2]);j=vb(f+4|0,x[d+4>>2]);o=d,q=NF(x[h>>2],x[g>>2],x[j>>2]),x[o+4>>2]=q;o=d,q=yY(e,x[a+4>>2],x[d+8>>2]),x[o+8>>2]=q;Tb(a,d+4|0);Tb(a+4|0,d+8|0);Tb(Ab(a),nc(d));x[d>>2]=x[d+4>>2];fb=f+16|0;e=c;Yf(d);break c}a=N()|0;Yf(d);Q(a|0);p()}j=fb-16|0;fb=j;k=x[a+4>>2];d=(k-(e+4|0)|0)+e|0;i=xh(j+4|0,a,f-d>>2);g=x[i+4>>2];c=d;while(1){if(c>>>0>=f>>>0){kc(i);f=fb-16|0;fb=f;c=fb-32|0;fb=c;fd(c+24|0,e,d);d=fb-16|0;fb=d;m=k;g=x[c+28>>2];i=x[c+24>>2];k=g-i|0;m=m-k|0;x[d+12>>2]=m;AY(m,i,k>>2);rc(c+16|0,g,d+12|0);fb=d+16|0;d=x[c+16>>2];x[c+12>>2]=x[c+20>>2];rc(f+8|0,d,c+12|0);fb=c+32|0;fb=f+16|0;fb=j+16|0}else{bp(g,z[c>>1]|z[c+2>>1]<<16);g=g+4|0;x[i+4>>2]=g;c=c+4|0;continue}break}v[e+2|0]=y[h+2|0];w[e>>1]=z[h>>1]}wb(e);fb=n+32|0;break a}v[a+14|0]=e-1}if((b|0)!=16777216){v[a+17|0]=255}fb=l+16|0}function zra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;g=fb-16|0;fb=g;j=If(a,c);ae(g,x[a+36>>2]);k=a;a:{if(!j){Qc(g,a+32|0,5);c=0;if(Gb(x[x[g>>2]>>2],x[g+4>>2])){break a}}e=fb-192|0;fb=e;f=Lm(e+80|0,x[a+36>>2]);x[31609]=0;a=P(461,e+68|0,26175)|0;c=x[31609];x[31609]=0;b:{c:{d:{e:{if((c|0)!=1){x[31609]=0;x[e+8>>2]=20054022;x[e+12>>2]=0;S(462,f|0,a|0,e+8|0);c=x[31609];x[31609]=0;if((c|0)==1){break e}Eb(a);if(!rl(y[f|0])){break d}break b}c=N()|0;break c}c=N()|0;Eb(a);break c}v[e+67|0]=0;v[e+66|0]=0;x[31609]=0;a=P(461,e+52|0,10110)|0;c=x[31609];x[31609]=0;f:{g:{h:{i:{if((c|0)!=1){x[31609]=0;c=e+67|0;S(503,f|0,c|0,a|0);h=x[31609];x[31609]=0;if((h|0)==1){break i}Eb(a);if(!y[e+67|0]){break b}Of(c,50);x[31609]=0;a=P(461,e+40|0,13304)|0;c=x[31609];x[31609]=0;if((c|0)==1){break f}x[31609]=0;S(503,f|0,e+66|0,a|0);c=x[31609];x[31609]=0;if((c|0)==1){break g}Eb(a);a=x[b>>2];c=Hj(a,x[b+4>>2]);h=y[e+67|0];if(c>>>0<h>>>0){a=cC(e+8|0,x[b+12>>2]);x[31609]=0;S(504,b|0,h|0,a|0);c=x[31609];x[31609]=0;if((c|0)==1){break h}Bk(a);a=x[b>>2]}l=z[Nj(a,0)+28>>1];c=0;j:{while(1){a=c&255;if(a>>>0>=h>>>0){a=y[e+66|0];o=b,q=Hj(x[b>>2],x[b+4>>2])>>>0>a>>>0?a:0,v[o+16|0]=q;break b}$e(Nj(x[b>>2],a),l);m=x[b>>2];x[31609]=0;i=e+8|0;O(505,i|0,c|0);n=x[31609];x[31609]=0;if((n|0)!=1){x[31609]=0;V(506,f|0,Nj(m,a)|0,i|0,d|0);a=x[31609];x[31609]=0;if((a|0)==1){break j}c=c+1|0;Eb(i);continue}break}c=N()|0;break c}c=N()|0;Eb(e+8|0);break c}c=N()|0;break c}c=N()|0;Eb(a);break c}c=N()|0;Bk(a);break c}c=N()|0;Eb(a);break c}c=N()|0}Ch(f);Q(c|0);p()}Ch(f);fb=e+192|0;c=j}ef(k,c);fb=g+16|0}function t4(a){a=a|0;var b=0,c=0,d=0;a=a+12|0;d=a+508|0;c=Cb(x[a+512>>2],y[a+519|0]);while(1){a:{if((b|0)==(c|0)){b=c;break a}if(y[dc(d,b)|0]==37){break a}b=b+1|0;continue}break}b:{c:{d:{e:{f:{a=v[dc(d,b+1|0)|0];if((a|0)!=121){if((a|0)==100){break f}if((a|0)==109){break e}if((a|0)!=89){break c}}b=b+2|0;a=b>>>0<c>>>0?c:b;while(1){g:{if(b>>>0<c>>>0){if(y[dc(d,b)|0]!=37){break g}a=b}if((a|0)==(c|0)){break c}b=v[dc(d,a+1|0)|0];if((b|0)==100){break d}if((b|0)!=109){break c}b=a+2|0;a=b>>>0<c>>>0?c:b;while(1){h:{if(b>>>0<c>>>0){if(y[dc(d,b)|0]!=37){break h}a=b}if((a|0)==(c|0)){break c}b=3;if(y[dc(d,a+1|0)|0]!=100){break c}break b}b=b+1|0;continue}}b=b+1|0;continue}}b=b+2|0;a=b>>>0<c>>>0?c:b;while(1){i:{if(b>>>0<c>>>0){if(y[dc(d,b)|0]!=37){break i}a=b}if((a|0)==(c|0)){break c}if(y[dc(d,a+1|0)|0]!=109){break c}b=a+2|0;a=b>>>0<c>>>0?c:b;while(1){j:{if(b>>>0<c>>>0){if(y[dc(d,b)|0]!=37){break j}a=b}if((a|0)==(c|0)){break c}b=1;a=a+1|0;if(y[dc(d,a)|0]==121){break b}if(y[dc(d,a)|0]==89){break b}break c}b=b+1|0;continue}}b=b+1|0;continue}}b=b+2|0;a=b>>>0<c>>>0?c:b;while(1){k:{if(b>>>0<c>>>0){if(y[dc(d,b)|0]!=37){break k}a=b}if((a|0)==(c|0)){break c}if(y[dc(d,a+1|0)|0]!=100){break c}b=a+2|0;a=b>>>0<c>>>0?c:b;while(1){l:{if(b>>>0<c>>>0){if(y[dc(d,b)|0]!=37){break l}a=b}if((a|0)==(c|0)){break c}b=2;a=a+1|0;if(y[dc(d,a)|0]==121){break b}if(y[dc(d,a)|0]!=89){break c}break b}b=b+1|0;continue}}b=b+1|0;continue}}b=a+2|0;a=b>>>0<c>>>0?c:b;while(1){m:{if(b>>>0<c>>>0){if(y[dc(d,b)|0]!=37){break m}a=b}if((a|0)==(c|0)){break c}b=4;if(y[dc(d,a+1|0)|0]!=109){break c}break b}b=b+1|0;continue}}b=0}return b|0}function Cma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0,z=0,A=0,B=0,C=0,E=0;f=fb-48|0;fb=f;t=x[a+16>>2];b=0;while(1){if((b|0)!=2){i=b<<3;l=i+(f+28|0)|0;i=a+i|0;x[l+4>>2]=x[i+44>>2];x[l+8>>2]=x[i+48>>2];b=b+1|0;continue}break}m=x[a+40>>2];n=x[a+36>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;u=x[a+32>>2];y=x[a+28>>2];z=x[a+72>>2];q=x[a+68>>2];A=q>>31;r=x[a+64>>2];B=r>>31;l=x[a+60>>2];C=l>>31;i=x[a+8>>2];E=x[a+12>>2];while(1){if(d){b=x[f+16>>2];j=(((x[f+20>>2]&2147483647)<<1|b>>>31)&-2)+t|0;b=b>>>21&2040;g=w[b+38086>>1];p=w[b+38084>>1];h=w[b+38082>>1];e=w[b+38080>>1];o=0;b=0;while(1){if((b|0)!=2){x[(f+8|0)+(b<<2)>>2]=(((D(h,v[b+j|0])+D(v[j+(b|-2)|0],e)|0)+D(p,v[j+(b|2)|0])|0)+D(g,v[j+(b|4)|0])<<8)/16384;b=b+1|0;continue}break}while(1){if((o|0)!=2){s=(f+8|0)+(o<<2)|0;e=x[s>>2];b=(f+28|0)+(o<<3)|0;j=x[b+8>>2];g=x[b+4>>2];x[b+8>>2]=g;p=e<<8;e=p;e=Iua(e,e>>31,l,C);h=hb;k=e;e=Yb(g,-16777216,16776704);e=Iua(r,B,e,e>>31);g=k+e|0;k=hb+h|0;k=e>>>0>g>>>0?k+1|0:k;e=Yb(j,-16777216,16776704);h=Iua(q,A,e,e>>31);g=h+g|0;e=hb+k|0;e=g>>>0<h>>>0?e+1|0:e;h=g+8388608|0;e=h>>>0<8388608?e+1|0:e;e=Sc(h,e,24);x[b+4>>2]=e-(p&z);x[s>>2]=(e|0)/256;o=o+1|0;continue}break}n=n+y|0;x[c>>2]=x[c>>2]+D(x[f+8>>2],n>>12);m=m+u|0;x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],m>>12);Pb(f+16|0,i,E);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;x[a+40>>2]=m;x[a+20>>2]=n>>12;x[a+36>>2]=n;x[a+24>>2]=m>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function uw(a,b,c,d){var e=0,f=0;e=fb-16|0;fb=e;v[e+15|0]=c;a:{b:{c:{d:{e:{switch(b-2|0){case 11:v[e+14|0]=64;ee(a,1,Qb(e+15|0,e+14|0));break a;case 0:if(!(c&3|c>>>0>223?d:1)){break b}v[e+14|0]=c>>>2;ee(a,12,e+14|0);break a;case 1:if(!(c&3|c>>>0>223?d:1)){break b}v[e+14|0]=c>>>2;ee(a,13,e+14|0);break a;case 2:if(c>>>0>=240){v[e+14|0]=9;ee(a,11,e+14|0);break a}b=0;while(1){if((b|0)==10){break b}f=y[b+42144|0];f:{if(d){if(c>>>0>f>>>0){break f}break d}if((c|0)==(f|0)){break d}}b=b+1|0;continue};case 3:g:{if(d){v[e+14|0]=c&15;v[e+13|0]=9;c=y[Qb(e+14|0,e+13|0)|0];break g}if(c>>>0>15|(c&14)>>>0>9){break b}}v[e+14|0]=c&15;ee(a,8,e+14|0);break a;case 24:h:{if(d){v[e+15|0]=0;break h}if(c){break b}}ee(a,8,e+15|0);break a;case 7:v[e+15|0]=(c|0)==255?64:c>>>2|0;ee(a,2,e+15|0);break a;case 9:if(!c){break b}b=c&15;if(!b){v[e+14|0]=c>>>4;ee(a,3,e+14|0);break a}d=c&240;if(!d){ee(a,4,e+15|0);break a}if((b|0)==15){v[e+14|0]=c>>>4;ee(a,5,e+14|0);break a}if((d|0)!=240){break b}v[e+14|0]=c&15;ee(a,6,e+14|0);break a;case 18:if((c&240)!=128){break b}v[e+14|0]=c<<2|2;ee(a,2,e+14|0);break a;case 17:i:{switch((c>>>4|0)-8|0){case 0:v[e+14|0]=c<<2&60|2;ee(a,2,e+14|0);break a;case 2:v[e+14|0]=c&15;ee(a,5,e+14|0);break a;case 3:break i;default:break b}}v[e+14|0]=c&15;ee(a,6,e+14|0);break a;case 4:case 5:case 6:case 8:case 10:case 12:case 13:case 14:case 15:case 16:case 19:case 20:case 21:case 22:case 23:break b;default:break e}}if((b|0)==46){break c}break b}v[e+14|0]=b;ee(a,11,e+14|0);break a}if(d?0:c&3){break b}v[e+14|0]=c+3>>>2;ee(a,1,e+14|0);break a}v[e+14|0]=0;ee(a,0,e+14|0)}fb=e+16|0}function iV(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{b:{d=b;e=x[b>>2];if(e){if(!x[b+4>>2]){break b}g=x[b+4>>2];c:{if(!g){while(1){g=Th(d);d=x[d+8>>2];if(!g){continue}break}break c}d=$Z(g)}e=x[d>>2];if(e){break b}}e=x[d+4>>2];if(e){break b}e=0;g=1;break a}x[e+8>>2]=x[d+8>>2];g=0}d:{e:{if(Th(d)){c=x[d+8>>2];x[c>>2]=e;if((a|0)==(d|0)){a=e;c=0;break d}c=c+4|0;break e}c=x[d+8>>2];x[c+4>>2]=e}c=x[c>>2]}h=!y[d+12|0];if((b|0)!=(d|0)){f=x[b+8>>2];x[d+8>>2]=f;i=f+(Th(b)?0:4)|0,j=d,x[i>>2]=j;f=x[b>>2];x[d>>2]=f;xn(f,d);f=x[b+4>>2];x[d+4>>2]=f;if(f){xn(f,d)}v[d+12|0]=y[b+12|0];a=(a|0)==(b|0)?d:a}if(!(h|!a)){if(g){while(1){b=y[c+12|0];f:{g:{if(!Th(c)){if(!b){v[c+12|0]=1;b=x[c+8>>2];v[b+12|0]=0;or(b);b=x[c>>2];a=(b|0)==(a|0)?c:a;c=x[b+4>>2]}b=x[c>>2];h:{if(!(y[b+12|0]?0:b)){b=x[c+4>>2];if(y[b+12|0]?0:b){break h}v[c+12|0]=0;i:{b=x[c+8>>2];if((b|0)!=(a|0)){if(y[b+12|0]){break i}a=b}v[a+12|0]=1;return}if(!Th(b)){break g}b=x[b+8>>2]+4|0;break f}a=x[c+4>>2];if(y[a+12|0]?0:a){break h}v[b+12|0]=1;v[c+12|0]=0;nr(c);c=x[c+8>>2]}a=x[c+8>>2];v[c+12|0]=y[a+12|0];v[a+12|0]=1;v[x[c+4>>2]+12|0]=1;or(a);return}if(!b){v[c+12|0]=1;b=x[c+8>>2];v[b+12|0]=0;nr(b);b=x[c+4>>2];a=(b|0)==(a|0)?c:a;c=x[b>>2]}d=x[c>>2];j:{if(y[d+12|0]?0:d){break j}b=x[c+4>>2];if(!(y[b+12|0]?0:b)){v[c+12|0]=0;b=x[c+8>>2];if(!((a|0)!=(b|0)?y[b+12|0]:0)){v[b+12|0]=1;return}if(Th(b)){b=x[b+8>>2]+4|0;break f}b=x[b+8>>2];break f}if(y[d+12|0]?0:d){break j}v[b+12|0]=1;v[c+12|0]=0;or(c);c=x[c+8>>2];d=x[c>>2]}a=x[c+8>>2];v[c+12|0]=y[a+12|0];v[a+12|0]=1;v[d+12|0]=1;nr(a);return}b=x[b+8>>2]}c=x[b>>2];continue}}v[e+12|0]=1}}function EQ(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;l=fb-16|0;fb=l;a:{if((b|0)==(c|0)){break a}x[l+12>>2]=-1953789045;Yz(b,c,l+12|0);c=c-b>>2;x[l+8>>2]=c;i=oc(x[a>>2],x[a+4>>2]);j=i+1|0;x[l+4>>2]=j;m=x[bd(l+4|0,l+8|0)>>2];d=11;b:{if(c>>>0>622){break b}d=7;if(c>>>0>67){break b}d=5;if(c>>>0>38){break b}d=3;if(c>>>0>6){break b}d=c-1>>>1|0}e=c-d>>>1|0;h=(e<<2)+b|0;g=x[h>>2];f=D(ou(g^(x[b>>2]^x[((c<<2)+b|0)-4>>2])),1664525);x[h>>2]=f+g;h=d+e|0;d=(h<<2)+b|0;g=d;k=x[d>>2];d=f+i|0;x[g>>2]=k+d;x[b>>2]=d;g=j>>>0<=1?1:j;d=c-1|0;e=(e>>>0)%(c>>>0)|0;f=(h>>>0)%(c>>>0)|0;k=x[a>>2];i=1;a=0;while(1)if((i|0)==(g|0)){while(1)if(j>>>0>=m>>>0){j=c+m|0;i=j>>>0<m>>>0?m:j;while(1){if((i|0)==(m|0)){break a}d=d+1|0;d=(c|0)!=(d|0)?d:0;e=e+1|0;e=(c|0)!=(e|0)?e:0;g=(e<<2)+b|0;k=x[g>>2];a=a+1|0;a=(a|0)!=(c|0)?a:0;h=(a<<2)+b|0;j=D(ou(x[(d<<2)+b>>2]+(k+x[h>>2]|0)|0),1566083941);x[g>>2]=j^k;f=f+1|0;f=(c|0)!=(f|0)?f:0;g=(f<<2)+b|0;j=j-a|0;x[g>>2]=j^x[g>>2];x[h>>2]=j;m=m+1|0;continue}}else{e=e+1|0;e=(c|0)!=(e|0)?e:0;g=(e<<2)+b|0;k=x[g>>2];a=a+1|0;a=(a|0)!=(c|0)?a:0;h=(a<<2)+b|0;d=d+1|0;d=(c|0)!=(d|0)?d:0;i=D(ou(k^(x[h>>2]^x[(d<<2)+b>>2])),1664525);x[g>>2]=i+k;f=f+1|0;f=(c|0)!=(f|0)?f:0;g=(f<<2)+b|0;i=a+i|0;x[g>>2]=i+x[g>>2];x[h>>2]=i;j=j+1|0;continue}}else{e=e+1|0;e=(c|0)!=(e|0)?e:0;n=(e<<2)+b|0;o=x[n>>2];a=a+1|0;a=(a|0)!=(c|0)?a:0;p=(a<<2)+b|0;d=d+1|0;d=(c|0)!=(d|0)?d:0;h=D(ou(o^(x[p>>2]^x[(d<<2)+b>>2])),1664525);x[n>>2]=h+o;h=x[yb(k,i-1|0)>>2]+(a+h|0)|0;f=f+1|0;f=(c|0)!=(f|0)?f:0;n=(f<<2)+b|0;x[n>>2]=h+x[n>>2];x[p>>2]=h;i=i+1|0;continue}}fb=l+16|0}function fja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=x[a>>2];d=jm(e,x[a+4>>2]);if(d>>>0<b>>>0){i=fb-32|0;fb=i;a:{b:{h=b-d|0;b=x[Ab(a)>>2];e=x[a+4>>2];c:{if(h>>>0<=(b-e|0)/52>>>0){qA(a,h,c);break c}f=Ab(a);d=kR(a,jm(x[a>>2],e)+h|0);g=jm(x[a>>2],x[a+4>>2]);e=fb-16|0;fb=e;b=i+12|0;Lg(b+12|0,f);d:{if(!d){f=0;d=0;break d}jR(e+8|0,d);f=x[e+12>>2];d=x[e+8>>2]}x[b>>2]=d;g=d+D(g,52)|0;x[b+8>>2]=g;x[b+4>>2]=g;l=nc(b),m=d+D(f,52)|0,x[l>>2]=m;fb=e+16|0;x[31609]=0;S(922,b|0,h|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}h=fb-16|0;fb=h;e=Ab(a);c=vb(h+12|0,x[a+4>>2]);d=vb(h+8|0,x[a>>2]);f=vb(h+4|0,x[b+4>>2]);c=x[c>>2];g=x[d>>2];d=fb+-64|0;fb=d;f=x[f>>2];x[d+56>>2]=f;x[d+60>>2]=c;x[d+52>>2]=f;e=Ag(d+24|0,e,d+52|0,d+56|0);x[d+16>>2]=x[e+8>>2];f=x[e+4>>2];x[d+8>>2]=x[e>>2];x[d+12>>2]=f;zg(d+36|0,d+8|0);while(1){if(Fd(c,g)){c=c-52|0;e=Ul(fR(x[d+56>>2]),c);x[e+20>>2]=x[c+20>>2];f=x[c+16>>2];x[e+12>>2]=x[c+12>>2];x[e+16>>2]=f;sW(e+24|0,c+24|0);Uc(e+36|0,c+36|0);x[e+48>>2]=x[c+48>>2];c=gR(d+60|0);gR(d+56|0);c=x[c>>2];continue}break}yg(d+36|0);j=x[d+56>>2];if(!y[d+48|0]){f=fb-16|0;fb=f;c=vb(f+12|0,x[x[d+44>>2]>>2]);k=x[vb(f+8|0,x[x[d+40>>2]>>2])>>2];g=fb-16|0;fb=g;c=x[c>>2];x[g+12>>2]=c;while(1){if(xi(c,k)){e=fb-16|0;fb=e;x[e+12>>2]=c;x[e+12>>2]=x[e+12>>2]+52;fb=e+16|0;wk(fR(x[e+12>>2]));c=x[Vl(g+12|0)>>2];continue}break}fb=g+16|0;fb=f+16|0}fb=d- -64|0;x[b+4>>2]=j;Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=h+16|0;hR(b)}fb=i+32|0;break a}a=N()|0;hR(b);Q(a|0);p()}return}if(b>>>0<d>>>0){lR(a,e+D(b,52)|0)}}function j7(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,w=0,z=0,A=0,B=0,C=0;x[c>>2]=a;w=d&512;z=h<<2;while(1){if((u|0)==4){if(Cb(x[n+4>>2],y[n+11|0])>>>0>1){B=c,C=QJ(Fk(zd(n),1),ol(n),x[c>>2]),x[B>>2]=C}d=d&176;if((d|0)!=16){if((d|0)==32){a=x[c>>2]}x[b>>2]=a}}else{a:{b:{switch(v[i+u|0]){case 0:x[b>>2]=x[c>>2];break a;case 1:x[b>>2]=x[c>>2];h=At(g,32);p=x[c>>2];x[c>>2]=p+4;x[p>>2]=h;break a;case 3:if(Ad(x[n+4>>2],y[n+11|0])){break a}h=x[Wd(n,0)>>2];p=x[c>>2];x[c>>2]=p+4;x[p>>2]=h;break a;case 2:if(Ad(x[m+4>>2],y[m+11|0])|!w){break a}B=c,C=QJ(zd(m),ol(m),x[c>>2]),x[B>>2]=C;break a;case 4:break b;default:break a}}A=x[c>>2];e=e+z|0;h=e;while(1){c:{if(f>>>0<=h>>>0){break c}if(!rj(g,64,x[h>>2])){break c}h=h+4|0;continue}break}if((o|0)>0){p=x[c>>2];q=o;while(1){if(!(!q|e>>>0>=h>>>0)){q=q-1|0;h=h-4|0;s=x[h>>2];r=p+4|0;x[c>>2]=r;x[p>>2]=s;p=r;continue}break}d:{if(!q){s=0;break d}s=At(g,48);p=x[c>>2]}while(1){r=p+4|0;if((q|0)>0){x[p>>2]=s;q=q-1|0;p=r;continue}break}x[c>>2]=r;x[p>>2]=j}e:{if((e|0)==(h|0)){p=At(g,48);q=x[c>>2];h=q+4|0;x[c>>2]=h;x[q>>2]=p;break e}s=-1;if(!Ad(x[l+4>>2],y[l+11|0])){s=v[dc(l,0)|0]}q=0;t=0;while(1){if((e|0)!=(h|0)){r=x[c>>2];f:{if((q|0)!=(s|0)){p=r;r=q;break f}p=r+4|0;x[c>>2]=p;x[r>>2]=k;r=0;t=t+1|0;if(Cb(x[l+4>>2],y[l+11|0])>>>0<=t>>>0){s=q;break f}s=-1;if(y[dc(l,t)|0]==127){break f}s=v[dc(l,t)|0]}h=h-4|0;q=x[h>>2];x[c>>2]=p+4;x[p>>2]=q;q=r+1|0;continue}break}h=x[c>>2]}ut(A,h)}u=u+1|0;continue}break}}function pe(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{b:{c:{switch(b|0){case 1:b=Fb(a);d=y[c+11|0];e=x[c+4>>2];a=0;x[31609]=0;O(53,b|0,_c(e,d)|0);d=x[31609];x[31609]=0;d:{if((d|0)!=1){e:{while(1){if(_c(x[c+4>>2],y[c+11|0])>>>0>a>>>0){d=v[dc(c,a)|0];x[31609]=0;O(35,b|0,((d|0)<0?65533:d&255)|0);d=x[31609];x[31609]=0;if((d|0)==1){break e}a=a+1|0;continue}break}break d}}break a}return;case 2:b=Fb(a);d=y[c+11|0];e=x[c+4>>2];a=0;x[31609]=0;O(53,b|0,_c(e,d)|0);d=x[31609];x[31609]=0;f:{if((d|0)!=1){while(1){if(_c(x[c+4>>2],y[c+11|0])>>>0<=a>>>0){break f}d=y[dc(c,a)|0];x[31609]=0;O(35,b|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){a=a+1|0;continue}break}}break a}return;case 3:gf(a,c,48864);return;case 4:gf(a,c,49888);return;case 5:gf(a,c,50912);return;case 6:gf(a,c,51936);return;case 7:gf(a,c,52960);return;case 8:gf(a,c,53984);return;case 9:gf(a,c,55008);return;case 10:gf(a,c,56032);return;case 11:gf(a,c,57056);return;case 12:gf(a,c,58080);return;case 13:gf(a,c,59104);return;case 14:gf(a,c,60128);return;case 15:gf(a,c,61152);return;case 16:gf(a,c,62176);return;case 17:gf(a,c,63200);return;case 18:gf(a,c,64224);return;case 19:gf(a,c,65248);return;case 20:gf(a,c,66272);return;case 21:gf(a,c,67296);return;case 22:gf(a,c,68320);return;case 23:gf(a,c,69344);return;case 24:$A(a,c,70368);return;case 25:$A(a,c,48864);return;case 26:$A(a,c,67296);return;default:a=ac(8);x[31609]=0;b=P(16,a|0,11122)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break b}b=N()|0;ic(a);Q(b|0);p();case 0:break c}}x_(a,c);return}da(b|0,124672,17);p()}a=N()|0;Ub(b);Q(a|0);p()}function _ja(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=fb-32|0;fb=c;a:{b:{c:{d:{e:{f:{if(Ed(x[a+24>>2])){break f}i=_c(x[a+8>>2],y[a+15|0]);f=fb-16|0;fb=f;h=f+8|0;x[h>>2]=-1;x[h+4>>2]=-1;x[31609]=0;g=dI(65);d=x[31609];x[31609]=0;b=hb;if((d|0)==1){T(0)|0;Sb();p()}e=fb-16|0;fb=e;d=ye(e+8|0,Iua(g,b,1e3,0),hb);b=x[d>>2];fb=e+16|0;j=f,k=pA(b,x[d+4>>2]),x[j>>2]=k;x[f+4>>2]=hb;e=dR(h,f,Ab(f));x[31609]=0;g=dI(66);d=x[31609];x[31609]=0;b=hb;if((d|0)==1){T(0)|0;Sb();p()}h=a+24|0;j=f,k=pA($Q(g,b),hb),x[j>>2]=k;x[f+4>>2]=hb;b=dR(e,f,Ab(f));g=x[b>>2];b=x[b+4>>2];fb=f+16|0;if(i){e=Nb(c+20|0);x[31609]=0;x[c+8>>2]=b;d=c+8|0;O(59,e|0,d|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}x[31609]=0;x[c+8>>2]=g;O(59,e|0,d|0);b=x[31609];x[31609]=0;if((b|0)==1){break d}d=a+4|0;g=0;g:{while(1){if(_c(x[a+8>>2],y[a+15|0])>>>0<=g>>>0){b=wb(x[e>>2]);a=wb(x[e+4>>2]);x[31609]=0;d=U(60,c+8|0,b|0,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break g}a=N()|0;break b}b=y[dc(d,g)|0];x[31609]=0;x[c+8>>2]=b;O(59,e|0,c+8|0);b=x[31609];x[31609]=0;if((b|0)!=1){g=g+1|0;continue}break}a=N()|0;break b}x[31609]=0;b=R(61,d|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){x[c+4>>2]=b;a=c+4|0;vA(h,a);Hl(a);Xm(d);wc(e);break f}a=N()|0;Xm(d);break b}hb=g;x[c+8>>2]=b;x[c+12>>2]=hb;b=Nb(c+20|0);x[31609]=0;S(64,b|0,c+8|0,c+16|0);a=x[31609];x[31609]=0;if((a|0)==1){a=N()|0;wc(b);Q(a|0);p()}x[31609]=0;d=R(61,b|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[c+4>>2]=d;a=c+4|0;vA(h,a);Hl(a);Xm(b)}fb=c+32|0;return}a=N()|0;Xm(b);break a}a=N()|0;break b}a=N()|0}wc(e)}Q(a|0);p()}function Rma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0,C=0;f=fb-48|0;fb=f;s=x[a+16>>2];b=0;while(1){if((b|0)!=2){g=b<<3;n=g+(f+28|0)|0;g=a+g|0;x[n+4>>2]=x[g+44>>2];x[n+8>>2]=x[g+48>>2];b=b+1|0;continue}break}k=x[a+40>>2];l=x[a+36>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;t=x[a+32>>2];u=x[a+28>>2];v=x[a+72>>2];o=x[a+68>>2];y=o>>31;p=x[a+64>>2];z=p>>31;q=x[a+60>>2];A=q>>31;n=x[a+8>>2];B=x[a+12>>2];while(1){if(d){g=x[f+16>>2];e=g>>>18|0;m=((((x[f+20>>2]&2147483647)<<1|g>>>31)&2147483646)<<1)+s|0;b=0;h=0;while(1){if((h|0)!=2){g=h<<1;i=w[g+m>>1];x[(f+8|0)+(h<<2)>>2]=i+((D(e,w[m+(g|4)>>1]-i|0)|0)/16384|0);h=h+1|0;continue}break}while(1){if((b|0)!=2){r=(f+8|0)+(b<<2)|0;e=x[r>>2];g=(f+28|0)+(b<<3)|0;C=x[g+8>>2];h=x[g+4>>2];x[g+8>>2]=h;m=e<<8;e=m;e=Iua(e,e>>31,q,A);i=hb;j=e;e=Yb(h,-16777216,16776704);e=Iua(p,z,e,e>>31);h=j+e|0;j=hb+i|0;j=e>>>0>h>>>0?j+1|0:j;e=Yb(C,-16777216,16776704);i=Iua(o,y,e,e>>31);h=i+h|0;e=hb+j|0;e=h>>>0<i>>>0?e+1|0:e;i=h+8388608|0;e=i>>>0<8388608?e+1|0:e;e=Sc(i,e,24);x[g+4>>2]=e-(m&v);x[r>>2]=(e|0)/256;b=b+1|0;continue}break}l=l+u|0;x[c>>2]=x[c>>2]+D(x[f+8>>2],l>>12);k=k+t|0;x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],k>>12);Pb(f+16|0,n,B);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;x[a+40>>2]=k;x[a+20>>2]=l>>12;x[a+36>>2]=l;x[a+24>>2]=k>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function ila(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0;g=fb-32|0;fb=g;e=wU(g+20|0,1<<x[b+12>>2]);f=x[e>>2];while(1){d=x[a>>2];if(ih(d,x[a+4>>2])>>>0>c>>>0){d=Se(d,c);vU(Yd(f,c),C[d>>3]);c=c+1|0;continue}break}uU(b,e);c=wb(x[e>>2]);x[g>>2]=c;q=wb(x[e+4>>2]);while(1){if(Ib(c,q)){h=fb-32|0;fb=h;p=F(C[c+8>>3]);k=F(C[c>>3]);o(+k);n=j(1)|0;f=j(0)|0;o(+p);l=j(1)|0;d=j(0)|0;l=(l|0)==(n|0)&d>>>0>f>>>0|l>>>0>n>>>0;i=l?k:p;o(+i);d=j(1)|0;f=j(0)|0;n=d>>>20|0;a:{if((n|0)==2047){break a}m=l?p:k;b:{if(!(d|f)){break b}o(+m);d=j(1)|0;j(0)|0;d=d>>>20|0;if((d|0)==2047){break b}if((d-n|0)>=65){i=k+p;break a}c:{if(d>>>0>=1534){i=i*190109156629516e-225;m=m*190109156629516e-225;k=5.260135901548374e210;break c}k=1;if(n>>>0>572){break c}i=i*5.260135901548374e210;m=m*5.260135901548374e210;k=190109156629516e-225}EL(h+24|0,h+16|0,m);EL(h+8|0,h,i);i=k*M(C[h>>3]+C[h+16>>3]+C[h+8>>3]+C[h+24>>3]);break a}i=m}fb=h+32|0;vU(c,kq(i));c=x[Uo(g)>>2];continue}break}tU(b,e);sU(e);l=x[e>>2];f=Ek(l,x[e+4>>2])>>>1|0;d=f>>>0<=1?1:f;c=1;while(1){if((c|0)!=(d|0)){PB(Yd(l,c),2);PB(Yd(l,c+f|0),0);c=c+1|0;continue}break}uU(b,e);c=wb(x[e>>2]);x[g+16>>2]=c;f=wb(x[e+4>>2]);while(1){if(Ib(c,f)){rU(g,C[c>>3],C[c+8>>3]);d=x[g+12>>2];x[c+8>>2]=x[g+8>>2];x[c+12>>2]=d;d=x[g+4>>2];x[c>>2]=x[g>>2];x[c+4>>2]=d;c=x[Uo(g+16|0)>>2];continue}break}tU(b,e);sU(e);f=x[a>>2];d=ih(f,x[a+4>>2]);b=x[e>>2];c=0;while(1){if((c|0)==(d|0)){ln(e);fb=g+32|0}else{a=Yd(b,c);r=Se(f,c),s=C[a>>3],C[r>>3]=s;c=c+1|0;continue}break}}function BH(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;d=fb-432|0;fb=d;a:{f=Zs(d+428|0,b);e=x[f>>2];b:{if(!Ed(e)){x[31609]=0;b=P(36,d+416|0,b|0)|0;a=x[31609];x[31609]=0;c:{d:{e:{if((a|0)!=1){x[31609]=0;a=d+16|0;S(1011,a|0,17716,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break e}x[31609]=0;W(1367,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break d}break a}a=N()|0;break b}a=N()|0;break c}a=N()|0;tb(d+16|0)}tb(b);break b}Ys(e);if(!Zp(a+8|0,22292,x[f>>2])){x[a+8>>2]=2147483647}if(!Zp(a+12|0,22292,x[f>>2])){x[a+12>>2]=2147483647}x[31609]=0;O(272,a+16|0,22292);b=x[31609];x[31609]=0;f:{g:{if((b|0)!=1){x[d+8>>2]=0;x[d+12>>2]=0;x[d+4>>2]=22292;e=Ei(d+16|0,d+4|0,100,d+8|0,x[f>>2]);if((e|0)==-1){x[31609]=0;W(1276,12677);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;break b}x[31609]=0;b=d+16|0;e=U(1374,a+28|0,b|0,b+(e<<2)|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break f}x[a+64>>2]=0;x[d+4>>2]=22292;x[d+8>>2]=0;x[d+12>>2]=0;h:{g=d+4|0;i=d+8|0;h=Ei(b,g,100,i,x[f>>2]);if((h|0)!=-1){x[31609]=0;U(1374,a+40|0,b|0,b+(h<<2)|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break f}x[d+4>>2]=22292;x[d+8>>2]=0;x[d+12>>2]=0;b=Ei(b,g,100,i,x[f>>2]);if((b|0)!=-1){break h}}x[31609]=0;W(1276,12677);a=x[31609];x[31609]=0;if((a|0)!=1){break a}break f}x[31609]=0;g=d+16|0;U(1374,a+52|0,g|0,g+(b<<2)|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break f}x[31609]=0;b=P(1375,d+416|0,e|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){break g}a=N()|0;break b}a=N()|0;break b}di(a+68|0,c);di(a+72|0,c);Ub(b);il(f);fb=d+432|0;return}a=N()|0}il(f);Q(a|0);p()}p()}function gna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0;f=fb-48|0;fb=f;t=x[a+16>>2];n=kg(1,2);b=hb;u=b;Pb(a,n,b);b=0;while(1){if((b|0)!=2){g=b<<3;m=g+(f+28|0)|0;g=a+g|0;x[m+4>>2]=x[g+44>>2];x[m+8>>2]=x[g+48>>2];b=b+1|0;continue}break}k=x[a+40>>2];l=x[a+36>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;v=x[a+32>>2];y=x[a+28>>2];z=x[a+72>>2];o=x[a+68>>2];A=o>>31;p=x[a+64>>2];B=p>>31;q=x[a+60>>2];C=q>>31;m=x[a+8>>2];E=x[a+12>>2];while(1){if(d){d=d-1|0;b=x[f+16>>2];g=((((x[f+20>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+t|0;b=0;e=0;while(1){if((e|0)!=2){x[(f+8|0)+(e<<2)>>2]=w[g+(e<<1)>>1];e=e+1|0;continue}break}while(1){if((b|0)!=2){r=(f+8|0)+(b<<2)|0;e=x[r>>2];g=(f+28|0)+(b<<3)|0;F=x[g+8>>2];h=x[g+4>>2];x[g+8>>2]=h;s=e<<8;e=s;e=Iua(e,e>>31,q,C);i=hb;j=e;e=Yb(h,-16777216,16776704);e=Iua(p,B,e,e>>31);h=j+e|0;j=hb+i|0;j=e>>>0>h>>>0?j+1|0:j;e=Yb(F,-16777216,16776704);i=Iua(o,A,e,e>>31);h=i+h|0;e=hb+j|0;e=h>>>0<i>>>0?e+1|0:e;i=h+8388608|0;e=i>>>0<8388608?e+1|0:e;e=Sc(i,e,24);x[g+4>>2]=e-(z&s);x[r>>2]=(e|0)/256;b=b+1|0;continue}break}l=l+y|0;x[c>>2]=x[c>>2]+D(x[f+8>>2],l>>12);k=k+v|0;x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],k>>12);Pb(f+16|0,m,E);c=c+8|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;x[a+40>>2]=k;x[a+20>>2]=l>>12;x[a+36>>2]=l;x[a+24>>2]=k>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}Ig(a,n,u);fb=f+48|0}function mma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0;h=fb-16|0;fb=h;f=x[a+8>>2];l=f;e=x[a+12>>2];i=e;a:{b:{c:{d:{if((e|0)<=1&f>>>0<=805306368|(e|0)<=0){f=e;if((e|0)>-2){f=1}else{f=(f|0)>=-2&l>>>0>=3489660928}if(f){break c}if((i|0)==-2&l>>>0>2147483647|(i|0)==-1){break d}break b}if((i|0)==1&l>>>0>2147483648|i>>>0>1){break b}}p=b+196648|0;break a}p=b+131112|0;break a}p=b+262184|0}t=x[a+16>>2];e=x[a+48>>2];j=x[a+40>>2];k=x[a+36>>2];b=x[a+44>>2];f=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=f;u=x[a+32>>2];v=x[a+28>>2];y=x[a+72>>2];q=x[a+68>>2];z=q>>31;r=x[a+64>>2];A=r>>31;s=x[a+60>>2];B=s>>31;while(1){f=b;if(d){b=Yb(b,-16777216,16776704);m=Iua(r,A,b,b>>31);n=hb;b=x[h+8>>2];g=(x[h+12>>2]<<1)+t|0;b=(b>>>16&65520)+p|0;g=(((((((D(w[g-4>>1],w[b+2>>1])+D(w[g-6>>1],w[b>>1])|0)+D(w[g-2>>1],w[b+4>>1])|0)+D(w[g>>1],w[b+6>>1])|0)+D(w[g+2>>1],w[b+8>>1])|0)+D(w[g+4>>1],w[b+10>>1])|0)+D(w[g+6>>1],w[b+12>>1])|0)+D(w[g+8>>1],w[b+14>>1])|0)/32768<<8;b=g;b=Iua(b,b>>31,s,B);m=b+m|0;o=hb+n|0;o=b>>>0>m>>>0?o+1|0:o;b=Yb(e,-16777216,16776704);e=Iua(q,z,b,b>>31);n=e+m|0;b=hb+o|0;b=e>>>0>n>>>0?b+1|0:b;e=n+8388608|0;b=e>>>0<8388608?b+1|0:b;e=Sc(e,b,24);b=(e|0)/256|0;k=k+v|0;x[c>>2]=D(b,k>>12)+x[c>>2];j=j+u|0;x[c+4>>2]=x[c+4>>2]+D(b,j>>12);Pb(h+8|0,l,i);b=e-(g&y)|0;c=c+8|0;d=d-1|0;e=f;continue}break}b=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=b;x[a+40>>2]=j;x[a+20>>2]=k>>12;x[a+36>>2]=k;x[a+48>>2]=e;x[a+44>>2]=f;x[a+24>>2]=j>>12;fb=h+16|0}function Jq(a,b,c,d){var e=E(0),f=E(0),g=E(0),h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=E(0),p=0;h=fb-16|0;fb=h;x[h+12>>2]=w[b+780>>1]+y[b+837|0];x[h+8>>2]=w[b+782>>1]+(y[b+838|0]&127);He(h+12|0,0,127);He(h+8|0,0,127);k=a+1074312|0;j=Ob(k,1);i=x[h+8>>2];l=x[h+12>>2];if(!j){v[b+838|0]=i;v[b+837|0]=l;x[b+780>>2]=0}m=D(d+256|0,l);j=(m|0)/256|0;a:{if(!(i|!Ob(k,36)|(m|0)<65024)){j=-1;if(!(y[b+851|0]&2)){break a}x[b+88>>2]=x[b+88>>2]&-32769;break a}x[b+88>>2]=x[b+88>>2]|32768;e=Ee(E(10),E(E(0-i|0)*E(.00937500037252903)));i=fb-16|0;fb=i;g=E(D(d+256|0,l)>>>0);b:{if(x[a+480180>>2]!=33554432){f=E(110);g=E(E(g/(y[a+480209|0]&128?E(10240):E(12288)))+E(.25));break b}f=E(125);g=E(E(g*E(6))/E(65024))}n=i,o=E(Ee(E(2),g)*f),B[n+12>>2]=o;d=i+12|0;HT(d,E(120),E(2e4));BB(d,E(E(A[a+24620>>2])*E(.5)));fb=i+16|0;g=E(B[i+12>>2]*E(6.2831854820251465));c:{if(!(!Ob(k,36)|y[a+480209|0]&128)){f=E(E(A[a+24620>>2])/g);g=E(E(E(e*f)+e)+E(-1));e=E(f*f);break c}f=E(e+e);e=E(g/E(A[a+24620>>2]));B[h+4>>2]=E(E(1)-f)*e;BB(h+4|0,E(2));g=E(E(f-B[h+4>>2])/e);e=E(E(1)/E(e*e))}f=E(e+E(g+E(1)));g=E(E(e+E(e+g))/f);e=E(E(-e)/f);f=E(E(1)/f);d:{if(y[b+845|0]==1){n=b,p=Ml(E(E(E(1)-f)*E(16777216))),x[n+60>>2]=p;n=b,p=Ml(E(g*E(16777216))),x[n+64>>2]=p;n=b,p=Ml(E(e*E(16777216))),x[n+68>>2]=p;a=-1;break d}d=Ml(E(f*E(16777216)));x[b+60>>2]=d;n=b,p=Ml(E(g*E(16777216))),x[n+64>>2]=p;n=b,p=Ml(E(e*E(16777216))),x[n+68>>2]=p;a=0;if(d){break d}x[b+60>>2]=1}x[b+72>>2]=a;if(!c){break a}x[b+44>>2]=0;x[b+48>>2]=0;x[b+52>>2]=0;x[b+56>>2]=0}fb=h+16|0;return j}function n7(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,w=0,z=0,A=0,B=0,C=0;x[c>>2]=a;z=d&512;while(1){if((u|0)==4){if(Cb(x[n+4>>2],y[n+11|0])>>>0>1){B=c,C=RJ(uf(zd(n),1),Ef(n),x[c>>2]),x[B>>2]=C}d=d&176;if((d|0)!=16){if((d|0)==32){a=x[c>>2]}x[b>>2]=a}}else{a:{b:{switch(v[i+u|0]){case 0:x[b>>2]=x[c>>2];break a;case 1:x[b>>2]=x[c>>2];p=km(g,32);q=x[c>>2];x[c>>2]=q+1;v[q|0]=p;break a;case 3:if(Ad(x[n+4>>2],y[n+11|0])){break a}p=y[dc(n,0)|0];q=x[c>>2];x[c>>2]=q+1;v[q|0]=p;break a;case 2:if(Ad(x[m+4>>2],y[m+11|0])|!z){break a}B=c,C=RJ(zd(m),Ef(m),x[c>>2]),x[B>>2]=C;break a;case 4:break b;default:break a}}p=x[g+8>>2];A=x[c>>2];e=e+h|0;r=e;while(1){c:{if(f>>>0<=r>>>0){break c}if(!Jf(p,64,v[r|0])){break c}r=r+1|0;continue}break}p=o;if((p|0)>0){while(1){if(!(!p|e>>>0>=r>>>0)){p=p-1|0;r=r-1|0;q=y[r|0];s=x[c>>2];x[c>>2]=s+1;v[s|0]=q;continue}break}if(p){q=km(g,48)}else{q=0}while(1){s=x[c>>2];x[c>>2]=s+1;if((p|0)>0){v[s|0]=q;p=p-1|0;continue}break}v[s|0]=j}d:{if((e|0)==(r|0)){p=km(g,48);q=x[c>>2];x[c>>2]=q+1;v[q|0]=p;break d}q=-1;if(!Ad(x[l+4>>2],y[l+11|0])){q=v[dc(l,0)|0]}p=0;t=0;while(1){if((e|0)==(r|0)){break d}e:{if((p|0)!=(q|0)){s=p;break e}q=x[c>>2];x[c>>2]=q+1;v[q|0]=k;s=0;t=t+1|0;if(Cb(x[l+4>>2],y[l+11|0])>>>0<=t>>>0){q=p;break e}q=-1;if(y[dc(l,t)|0]==127){break e}q=v[dc(l,t)|0]}r=r-1|0;p=y[r|0];w=x[c>>2];x[c>>2]=w+1;v[w|0]=p;p=s+1|0;continue}}Em(A,x[c>>2])}u=u+1|0;continue}break}}function Tma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,y=0,z=0,A=0,B=0,C=0;f=fb-48|0;fb=f;s=x[a+16>>2];b=0;while(1){if((b|0)!=2){i=b<<3;k=i+(f+28|0)|0;i=a+i|0;x[k+4>>2]=x[i+44>>2];x[k+8>>2]=x[i+48>>2];b=b+1|0;continue}break}l=x[a+40>>2];m=x[a+36>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;t=x[a+32>>2];u=x[a+28>>2];w=x[a+72>>2];p=x[a+68>>2];y=p>>31;q=x[a+64>>2];z=q>>31;k=x[a+60>>2];A=k>>31;i=x[a+8>>2];B=x[a+12>>2];while(1){if(d){e=x[f+16>>2];g=e>>>10&4194048;n=(((x[f+20>>2]&2147483647)<<1|e>>>31)&-2)+s|0;o=0;b=0;while(1){if((b|0)!=2){e=v[b+n|0];x[(f+8|0)+(b<<2)>>2]=((D(g,v[n+(b|2)|0]-e|0)|0)/16384|0)+(e<<8);b=b+1|0;continue}break}while(1){if((o|0)!=2){r=(f+8|0)+(o<<2)|0;e=x[r>>2];b=(f+28|0)+(o<<3)|0;C=x[b+8>>2];h=x[b+4>>2];x[b+8>>2]=h;n=e<<8;e=n;e=Iua(e,e>>31,k,A);g=hb;j=e;e=Yb(h,-16777216,16776704);e=Iua(q,z,e,e>>31);h=j+e|0;j=hb+g|0;j=e>>>0>h>>>0?j+1|0:j;e=Yb(C,-16777216,16776704);g=Iua(p,y,e,e>>31);h=g+h|0;e=hb+j|0;e=g>>>0>h>>>0?e+1|0:e;g=h+8388608|0;e=g>>>0<8388608?e+1|0:e;e=Sc(g,e,24);x[b+4>>2]=e-(n&w);x[r>>2]=(e|0)/256;o=o+1|0;continue}break}m=m+u|0;x[c>>2]=x[c>>2]+D(x[f+8>>2],m>>12);l=l+t|0;x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],l>>12);Pb(f+16|0,i,B);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;x[a+40>>2]=l;x[a+20>>2]=m>>12;x[a+36>>2]=m;x[a+24>>2]=l>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function Fma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0;f=fb-48|0;fb=f;r=x[a+16>>2];b=0;while(1){if((b|0)!=2){h=b<<3;m=h+(f+28|0)|0;h=a+h|0;x[m+4>>2]=x[h+44>>2];x[m+8>>2]=x[h+48>>2];b=b+1|0;continue}break}s=x[a+24>>2];t=x[a+20>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;u=x[a+72>>2];o=x[a+68>>2];v=o>>31;p=x[a+64>>2];y=p>>31;q=x[a+60>>2];z=q>>31;m=x[a+8>>2];A=x[a+12>>2];while(1){if(d){b=x[f+16>>2];k=((((x[f+20>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+r|0;b=b>>>21&2040;n=w[b+38086>>1];i=w[b+38084>>1];e=w[b+38082>>1];h=w[b+38080>>1];b=0;j=0;while(1){if((j|0)!=2){g=j<<1;x[(f+8|0)+(j<<2)>>2]=(((D(w[g+k>>1],e)+D(w[k+(g|-4)>>1],h)|0)+D(i,w[k+(g|4)>>1])|0)+D(n,w[k+(g|8)>>1])|0)/16384;j=j+1|0;continue}break}while(1){if((b|0)!=2){j=(f+8|0)+(b<<2)|0;e=x[j>>2];h=(f+28|0)+(b<<3)|0;k=x[h+8>>2];g=x[h+4>>2];x[h+8>>2]=g;n=e<<8;e=n;e=Iua(e,e>>31,q,z);i=hb;l=e;e=Yb(g,-16777216,16776704);e=Iua(p,y,e,e>>31);g=l+e|0;l=hb+i|0;l=e>>>0>g>>>0?l+1|0:l;e=Yb(k,-16777216,16776704);i=Iua(o,v,e,e>>31);g=i+g|0;e=hb+l|0;e=g>>>0<i>>>0?e+1|0:e;i=g+8388608|0;e=i>>>0<8388608?e+1|0:e;e=Sc(i,e,24);x[h+4>>2]=e-(n&u);x[j>>2]=(e|0)/256;b=b+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[f+8>>2],t);x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],s);Pb(f+16|0,m,A);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function ooa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=fb-16|0;fb=f;k=f,l=Rj(b),x[k+4>>2]=l;e=fb-16|0;fb=e;h=a;c=de(a);a:{if(c){g=gc(a);while(1){a=c;c=a+14|0;if(mv(b,c)){g=a;c=x[a>>2];if(c){continue}break a}if(!mv(c,b)){break a}g=a+4|0;c=x[a+4>>2];if(c){continue}break}break a}a=gc(h);g=a}x[e+12>>2]=a;b=x[g>>2];if(!b){i=fb-16|0;fb=i;a=gc(h);j=Dh(e,Ec(48),Og(i+8|0,a));a=x[j>>2];b=x[f+4>>2];c=y[b+4|0]|y[b+5|0]<<8|(y[b+6|0]<<16|y[b+7|0]<<24);d=y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24);v[a+14|0]=d;v[a+15|0]=d>>>8;v[a+16|0]=d>>>16;v[a+17|0]=d>>>24;v[a+18|0]=c;v[a+19|0]=c>>>8;v[a+20|0]=c>>>16;v[a+21|0]=c>>>24;c=y[b+28|0]|y[b+29|0]<<8|(y[b+30|0]<<16|y[b+31|0]<<24);d=y[b+24|0]|y[b+25|0]<<8|(y[b+26|0]<<16|y[b+27|0]<<24);v[a+38|0]=d;v[a+39|0]=d>>>8;v[a+40|0]=d>>>16;v[a+41|0]=d>>>24;v[a+42|0]=c;v[a+43|0]=c>>>8;v[a+44|0]=c>>>16;v[a+45|0]=c>>>24;c=y[b+20|0]|y[b+21|0]<<8|(y[b+22|0]<<16|y[b+23|0]<<24);d=y[b+16|0]|y[b+17|0]<<8|(y[b+18|0]<<16|y[b+19|0]<<24);v[a+30|0]=d;v[a+31|0]=d>>>8;v[a+32|0]=d>>>16;v[a+33|0]=d>>>24;v[a+34|0]=c;v[a+35|0]=c>>>8;v[a+36|0]=c>>>16;v[a+37|0]=c>>>24;c=y[b+12|0]|y[b+13|0]<<8|(y[b+14|0]<<16|y[b+15|0]<<24);b=y[b+8|0]|y[b+9|0]<<8|(y[b+10|0]<<16|y[b+11|0]<<24);v[a+22|0]=b;v[a+23|0]=b>>>8;v[a+24|0]=b>>>16;v[a+25|0]=b>>>24;v[a+26|0]=c;v[a+27|0]=c>>>8;v[a+28|0]=c>>>16;v[a+29|0]=c>>>24;w[a+46>>1]=0;k=gc(j),l=1,v[k+4|0]=l;fb=i+16|0;$g(h,x[e+12>>2],g,x[e>>2]);b=ne(e);Jk(e);d=1}_g(f+8|0,x[vb(e,b)>>2],d);fb=e+16|0;a=cp(x[f+8>>2]);fb=f+16|0;return a+32|0}function oma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0,z=0,A=0,B=0;h=fb-16|0;fb=h;g=x[a+8>>2];l=g;e=x[a+12>>2];i=e;a:{b:{c:{d:{if((e|0)<=1&g>>>0<=805306368|(e|0)<=0){g=e;if((e|0)>-2){g=1}else{g=(g|0)>=-2&l>>>0>=3489660928}if(g){break c}if((i|0)==-2&l>>>0>2147483647|(i|0)==-1){break d}break b}if((i|0)==1&l>>>0>2147483648|i>>>0>1){break b}}n=b+196648|0;break a}n=b+131112|0;break a}n=b+262184|0}s=x[a+16>>2];b=x[a+48>>2];j=x[a+40>>2];k=x[a+36>>2];e=x[a+44>>2];g=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=g;t=x[a+32>>2];u=x[a+28>>2];y=x[a+72>>2];o=x[a+68>>2];z=o>>31;p=x[a+64>>2];A=p>>31;q=x[a+60>>2];B=q>>31;while(1){g=e;if(d){e=Yb(e,-16777216,16776704);f=Iua(p,A,e,e>>31);e=hb;b=Yb(b,-16777216,16776704);b=Iua(o,z,b,b>>31);f=b+f|0;e=hb+e|0;e=b>>>0>f>>>0?e+1|0:e;b=x[h+8>>2];m=f;f=x[h+12>>2]+s|0;b=(b>>>16&65520)+n|0;r=(((((((D(v[f-2|0],w[b+2>>1])+D(v[f-3|0],w[b>>1])|0)+D(v[f-1|0],w[b+4>>1])|0)+D(v[f|0],w[b+6>>1])|0)+D(v[f+1|0],w[b+8>>1])|0)+D(v[f+2|0],w[b+10>>1])|0)+D(v[f+3|0],w[b+12>>1])|0)+D(v[f+4|0],w[b+14>>1])<<8)/32768<<8;b=r;f=Iua(b,b>>31,q,B);m=m+f|0;b=hb+e|0;b=f>>>0>m>>>0?b+1|0:b;e=m+8388608|0;b=e>>>0<8388608?b+1|0:b;e=Sc(e,b,24);b=(e|0)/256|0;k=k+u|0;x[c>>2]=D(b,k>>12)+x[c>>2];j=j+t|0;x[c+4>>2]=x[c+4>>2]+D(j>>12,b);Pb(h+8|0,l,i);e=e-(y&r)|0;c=c+8|0;d=d-1|0;b=g;continue}break}c=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=c;x[a+40>>2]=j;x[a+20>>2]=k>>12;x[a+36>>2]=k;x[a+48>>2]=b;x[a+44>>2]=g;x[a+24>>2]=j>>12;fb=h+16|0}function Q4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=fb-576|0;fb=c;Rb(c+532|0,0,44);x[c+24>>2]=0;x[c+28>>2]=0;while(1){a:{if((d|0)==7){d=0;while(1){b:{if((d|0)==12){x[c+540>>2]=1;d=c+432|0;fa(d|0,100,9278,c+532|0,x[a>>2])|0;x[c+24>>2]=0;x[c+28>>2]=0;x[c+20>>2]=d;e=Ei(c+32|0,c+20|0,100,c+24|0,x[a>>2]);if((e|0)!=-1){break b}break a}x[c+548>>2]=d;e=c+432|0;g=c+532|0;fa(e|0,100,14339,g|0,x[a>>2])|0;x[c+24>>2]=0;x[c+28>>2]=0;x[c+8>>2]=e;f=c+32|0;h=c+8|0;i=c+24|0;j=Ei(f,h,100,i,x[a>>2]);if(j+1>>>0<=1){break a}k=D(d,12)+a|0;Dm(k+172|0,f,f+(j<<2)|0);fa(e|0,100,13349,g|0,x[a>>2])|0;x[c+24>>2]=0;x[c+28>>2]=0;x[c+8>>2]=e;e=Ei(f,h,100,i,x[a>>2]);if(e+1>>>0<=1){break a}Dm(k+316|0,f,(e<<2)+f|0);d=d+1|0;continue}break}d=c+32|0;Dm(a+460|0,d,d+(e<<2)|0);x[c+540>>2]=13;e=c+432|0;fa(e|0,100,9278,c+532|0,x[a>>2])|0;x[c+24>>2]=0;x[c+28>>2]=0;x[c+20>>2]=e;e=Ei(d,c+20|0,100,c+24|0,x[a>>2]);if((e|0)!=-1){Dm(a+472|0,d,(e<<2)+d|0);d=c+8|0;at(d,a,99,b);nh(a+484|0,d);Ub(d);at(d,a,114,b);nh(a+496|0,d);Ub(d);at(d,a,120,b);nh(a+508|0,d);Ub(c+8|0);at(d,a,88,b);nh(a+520|0,d);Ub(c+8|0);fb=c+576|0;return}break a}x[c+556>>2]=d;e=c+432|0;g=c+532|0;fa(e|0,100,14352,g|0,x[a>>2])|0;x[c+24>>2]=0;x[c+28>>2]=0;x[c+8>>2]=e;f=c+32|0;h=c+8|0;i=c+24|0;j=Ei(f,h,100,i,x[a>>2]);if(j+1>>>0>1){k=D(d,12)+a|0;Dm(k+4|0,f,f+(j<<2)|0);fa(e|0,100,13556,g|0,x[a>>2])|0;x[c+24>>2]=0;x[c+28>>2]=0;x[c+8>>2]=e;e=Ei(f,h,100,i,x[a>>2]);if(e+1>>>0<=1){break a}Dm(k+88|0,f,(e<<2)+f|0);d=d+1|0;continue}}break}fo(12677);p()}function L1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=fb-48|0;fb=f;g=Mi(b)^-1;a:{if(oc(x[d>>2],x[d+4>>2])>>>0<=g>>>0){xu(a);break a}Mi(b);if((y[c+4|0]|y[c+5|0]<<8)>>>0>=60){Vb(b,4)}j=f,k=Mi(b),x[j+44>>2]=k;Vb(b,4);h=Mi(b);i=Mi(b);if(!((h|0)>0&(i|0)>36)){xu(a);break a}if(!Nd(Vd(x[e>>2],x[yb(x[d>>2],g)>>2]),13181)){xu(a);break a}e=f+4|0;wF(e,b,i,h);d=hc(f+24|0,e);ub(e);b=x[d>>2];x[31609]=0;b=R(172,b|0)|0;e=x[31609];x[31609]=0;b:{if((e|0)==1){break b}c:{d:{if(!b){x[31609]=0;R(182,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break d}break b}b=y[c+4|0]|y[c+5|0]<<8;if(b>>>0<=39){x[31609]=0;P(183,d|0,8)|0;b=x[31609];x[31609]=0;if((b|0)==1){break b}b=y[c+4|0]|y[c+5|0]<<8}if((b&65535)>>>0<=59){x[31609]=0;P(183,d|0,16)|0;b=x[31609];x[31609]=0;if((b|0)==1){break b}}x[31609]=0;R(184,d|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break b}e:{f:{b=y[c+4|0]|y[c+5|0]<<8;g:{if(b>>>0>=120){x[31609]=0;R(184,d|0)|0;c=x[31609];x[31609]=0;b=8;break g}h:{if(b>>>0>=100){x[31609]=0;P(183,d|0,4)|0;b=x[31609];x[31609]=0;if((b|0)==1){break b}break h}if(b>>>0<62){break f}}x[31609]=0;R(184,d|0)|0;c=x[31609];x[31609]=0;b=4}if((c|0)==1){break b}x[31609]=0;P(183,d|0,b|0)|0;break e}x[31609]=0;R(184,d|0)|0}b=x[31609];x[31609]=0;if((b|0)==1){break b}x[31609]=0;c=R(184,d|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break c}x[31609]=0;b=f+4|0;S(185,b|0,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break c}j=hc(a,b),k=x[f+44>>2],x[j+20>>2]=k;ub(b)}ub(d);break a}}a=N()|0;ub(d);Q(a|0);p()}fb=f+48|0}function hna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0;f=fb-48|0;fb=f;t=x[a+16>>2];n=kg(1,2);b=hb;u=b;Pb(a,n,b);b=0;while(1){if((b|0)!=2){g=b<<3;m=g+(f+28|0)|0;g=a+g|0;x[m+4>>2]=x[g+44>>2];x[m+8>>2]=x[g+48>>2];b=b+1|0;continue}break}k=x[a+40>>2];l=x[a+36>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;w=x[a+32>>2];y=x[a+28>>2];z=x[a+72>>2];o=x[a+68>>2];A=o>>31;p=x[a+64>>2];B=p>>31;q=x[a+60>>2];C=q>>31;m=x[a+8>>2];E=x[a+12>>2];while(1){if(d){d=d-1|0;b=x[f+16>>2];g=(((x[f+20>>2]&2147483647)<<1|b>>>31)&-2)+t|0;b=0;e=0;while(1){if((e|0)!=2){x[(f+8|0)+(e<<2)>>2]=v[e+g|0]<<8;e=e+1|0;continue}break}while(1){if((b|0)!=2){r=(f+8|0)+(b<<2)|0;e=x[r>>2];g=(f+28|0)+(b<<3)|0;F=x[g+8>>2];h=x[g+4>>2];x[g+8>>2]=h;s=e<<8;e=s;e=Iua(e,e>>31,q,C);i=hb;j=e;e=Yb(h,-16777216,16776704);e=Iua(p,B,e,e>>31);h=j+e|0;j=hb+i|0;j=e>>>0>h>>>0?j+1|0:j;e=Yb(F,-16777216,16776704);i=Iua(o,A,e,e>>31);h=i+h|0;e=hb+j|0;e=h>>>0<i>>>0?e+1|0:e;i=h+8388608|0;e=i>>>0<8388608?e+1|0:e;e=Sc(i,e,24);x[g+4>>2]=e-(z&s);x[r>>2]=(e|0)/256;b=b+1|0;continue}break}l=l+y|0;x[c>>2]=x[c>>2]+D(x[f+8>>2],l>>12);k=k+w|0;x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],k>>12);Pb(f+16|0,m,E);c=c+8|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;x[a+40>>2]=k;x[a+20>>2]=l>>12;x[a+36>>2]=l;x[a+24>>2]=k>>12;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}Ig(a,n,u);fb=f+48|0}function cQ(a){var b=E(0),c=E(0),d=0,e=0,f=0,g=0,h=0,i=0,k=E(0),l=0,m=E(0);d=fb-16|0;fb=d;f=a+4208|0;c=Vz(B[yb(f,2)>>2]);b=E(A[x[a+16>>2]+24620>>2]);B[d+12>>2]=c/b;x[d+8>>2]=1056964608;c=tq(E(B[Sm(d+12|0,d+8|0)>>2]*E(6.2831854820251465)));c=E(M(E(E(E(c+c)+E(3))/E(5))));B[a+4236>>2]=c;B[a+4240>>2]=M(E(E(1)-E(c*c)));c=E(E(B[yb(f,1)>>2]*E(29))+E(2));a:{if(c<E(4294967296)&c>=E(0)){i=~~c>>>0;break a}i=0}v[a+4272|0]=i;e=i;while(1){if(e&255){g=g+1|0;e=(e&254)>>>1|0;continue}break}v[a+4273|0]=g;k=Ee(E(10),E(E(E(B[a+4208>>2]*E(60))+E(-60))/E(20)));l=d,m=E(Vz(B[yb(f,3)>>2])/b),B[l+12>>2]=m;x[d+8>>2]=1056964608;c=B[Sm(d+12|0,d+8|0)>>2];l=d,m=E(Vz(B[yb(f,4)>>2])/b),B[l+12>>2]=m;x[d+8>>2]=1056964608;b=E(E(B[Sm(d+12|0,d+8|0)>>2]*E(6.2831854820251465))*E(.5));g=fb-16|0;fb=g;f=(q(b),j(2));e=f&2147483647;b:{if(e>>>0<=1061752794){if(e>>>0<964689920){break b}b=lo(+b,0);break b}if(e>>>0<=1081824209){h=+b;if(e>>>0<=1075235811){b=lo(((f|0)<0?1.5707963267948966:-1.5707963267948966)+h,1);break b}b=lo(((f|0)<0?3.141592653589793:-3.141592653589793)+h,0);break b}if(e>>>0<=1088565717){h=+b;if(e>>>0<=1085271519){b=lo(((f|0)<0?4.71238898038469:-4.71238898038469)+h,1);break b}b=lo(((f|0)<0?6.283185307179586:-6.283185307179586)+h,0);break b}if(e>>>0>=2139095040){b=E(b-b);break b}e=Zy(b,g+8|0);b=lo(C[g+8>>3],e&1)}fb=g+16|0;b=E(E(E(1)-b)/E(b+E(1)));B[a+4268>>2]=b;c=tq(E(c*E(6.2831854820251465)));B[a+4264>>2]=-c;B[a+4260>>2]=E(E(k*E(M(E(E(1)-E(c*c)))))*E(M(E(E(1)-E(b*b)))))*B[(i<<2)+44e3>>2];fb=d+16|0}function v7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;a=fb-624|0;fb=a;x[a+616>>2]=c;x[a+620>>2]=b;x[a+16>>2]=1274;b=a+16|0;h=De(a+200|0,a+208|0,b);i=a+192|0;cd(i,x[e+28>>2]);x[31609]=0;j=R(1252,x[a+192>>2])|0;k=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{g:{if((k|0)!=1){v[a+191|0]=0;e=x[e+4>>2];x[31609]=0;c=na(1283,a+620|0,c|0,d|0,i|0,e|0,f|0,a+191|0,j|0,h|0,a+196|0,a+608|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break d}if(!c){break e}v[a+190|0]=0;v[a+188|0]=56;v[a+189|0]=57;v[a+180|0]=48;v[a+181|0]=49;v[a+182|0]=50;v[a+183|0]=51;v[a+184|0]=52;v[a+185|0]=53;v[a+186|0]=54;v[a+187|0]=55;x[31609]=0;V(1263,j|0,a+180|0,a+190|0,a+128|0);c=x[31609];x[31609]=0;if((c|0)==1){break g}x[a+4>>2]=1239;d=De(a+8|0,0,a+4|0);e=b;b=x[a+196>>2];c=b-x[h>>2]|0;if((c|0)<393){break f}Qe(d,Gd((c>>>2|0)+2|0));e=x[d>>2];if(e){break f}x[31609]=0;X(1240);b=x[31609];x[31609]=0;if((b|0)==1){break c}break a}c=N()|0;break b}c=N()|0;break b}if(y[a+191|0]){v[e|0]=45;e=e+1|0}c=x[h>>2];while(1){if(b>>>0<=c>>>0){v[e|0]=0;x[a>>2]=g;if((YJ(a+16|0,a)|0)!=1){x[31609]=0;W(1276,8e3);b=x[31609];x[31609]=0;if((b|0)!=1){break a}break c}Lc(d)}else{b=a+128|0;l=e,m=y[(a+180|0)+(Ey(b,b+40|0,x[c>>2])-b>>2)|0],v[l|0]=m;e=e+1|0;c=c+4|0;b=x[a+196>>2];continue}break}}x[31609]=0;b=P(1257,a+620|0,a+616|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break d}if(b){x[f>>2]=x[f>>2]|2}b=x[a+620>>2];_b(a+192|0);Lc(h);fb=a+624|0;return b|0}c=N()|0;break b}c=N()|0;Lc(d)}_b(a+192|0);Lc(h);Q(c|0);p()}p()}function Au(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=fb-128|0;fb=f;a:{b:{c:{d:{e:{f:{g:{if(!c){break g}d=x[c+4>>2];if(!d&A[c>>2]>=A[b+4>>2]|d){break g}a=ac(8);x[31609]=0;b=P(51,a|0,22292)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break f}e=N()|0;ic(a);break a}if(!x[b>>2]){a=ac(8);x[31609]=0;b=R(855,a|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break e}e=N()|0;ic(a);break a}d=x[b>>2];k=x[b+4>>2];b=fb-16|0;fb=b;lf(b+8|0,d,k);h=x[b+8>>2];d=f+108|0;CG(d,h,x[b+12>>2]);x[d+12>>2]=0;fb=b+16|0;h:{i:{if(a&2){b=Mn(f+88|0,d);x[31609]=0;g=R(856,b|0)|0;i=x[31609];x[31609]=0;b=1;if((i|0)==1){break h}if((g|0)==1){break i}b=Mn(f+68|0,d);x[31609]=0;i=R(857,b|0)|0;h=x[31609];x[31609]=0;b=1;if((h|0)==1){break d}if((i|0)==1){break i}b=Mn(f+48|0,d);x[31609]=0;h=P(858,b|0,c|0)|0;j=x[31609];x[31609]=0;b=1;if((j|0)==1){break c}if((h|0)==1){break i}b=Mn(f+28|0,d);x[31609]=0;j=P(859,b|0,c|0)|0;l=x[31609];x[31609]=0;b=1;if((l|0)==1){break b}if((j|0)==1){break i}g=0-((g|0)==-1|(i|0)==-1|(h|0)==-1|(j|0)==-1)|0}j:{if(!(a&1)){break j}while(1){if((e|0)==576){break j}a=x[e+29888>>2];if(a){b=Mn(f+8|0,d);x[31609]=0;a=P(a|0,b|0,c|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){e=N()|0;break a}b=1;if((a|0)==1){break i}g=(a|0)==-1?-1:g}e=e+12|0;continue}}a=k;if(c){b=0;if((g|0)!=-1){break i}b=Bc(x[c>>2],x[c+4>>2])>>>0>a>>>0?-1:0;break i}b=0;if((g|0)!=-1){break i}b=a>>>0>2047?1:-1}fb=f+128|0;return b}e=N()|0;break a}da(b|0,124832,17);p()}da(b|0,124728,17);p()}e=N()|0;break a}e=N()|0;break a}e=N()|0}Q(e|0);p()}function S7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;m=b;i=fb-416|0;fb=i;v[i+412|0]=0;v[i+413|0]=0;v[i+414|0]=0;v[i+415|0]=0;v[i+409|0]=0;v[i+410|0]=0;v[i+411|0]=0;v[i+412|0]=0;v[i+408|0]=37;l=pt(i+409|0,13966,x[c+4>>2]);b=i+368|0;x[i+364>>2]=b;a=Od();a:{if(l){j=x[c+8>>2];k=i- -64|0;x[k>>2]=g;x[k+4>>2]=h;x[i+56>>2]=e;x[i+60>>2]=f;x[i+48>>2]=j;j=ph(b,30,a,i+408|0,i+48|0);break a}x[i+80>>2]=e;x[i+84>>2]=f;x[i+88>>2]=g;x[i+92>>2]=h;j=ph(i+368|0,30,a,i+408|0,i+80|0)}x[i+128>>2]=1239;k=De(i+356|0,0,i+128|0);b=i+368|0;a=b;b:{c:{d:{e:{if((j|0)>=30){a=Od();f:{if(l){j=x[c+8>>2];x[i+16>>2]=g;x[i+20>>2]=h;x[i+8>>2]=e;x[i+12>>2]=f;x[i>>2]=j;j=kj(i+364|0,a,i+408|0,i);break f}x[i+32>>2]=e;x[i+36>>2]=f;x[i+40>>2]=g;x[i+44>>2]=h;j=kj(i+364|0,a,i+408|0,i+32|0)}if((j|0)==-1){x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)==1){break d}break e}a=x[i+364>>2];Qe(k,a)}f=a+j|0;g=lj(a,f,x[c+4>>2]);x[i+116>>2]=1239;e=De(i+120|0,0,i+116|0);g:{h:{if((i+368|0)==(a|0)){j=i+128|0;break h}j=Gd(j<<3);if(!j){x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)!=1){break e}a=N()|0;break g}Qe(e,j);b=a}a=i+108|0;cd(a,x[c+28>>2]);x[31609]=0;ga(1272,b|0,g|0,f|0,j|0,i+116|0,i+112|0,a|0);b=x[31609];x[31609]=0;i:{if((b|0)!=1){_b(a);x[31609]=0;a=ea(1273,m|0,j|0,x[i+116>>2],x[i+112>>2],c|0,d|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break i}Lc(e);Lc(k);fb=i+416|0;break b}a=N()|0;_b(i+108|0);break g}a=N()|0}Lc(e);break c}p()}a=N()|0}Lc(k);Q(a|0);p()}return a|0}function a8(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;m=b;i=fb-256|0;fb=i;v[i+252|0]=0;v[i+253|0]=0;v[i+254|0]=0;v[i+255|0]=0;v[i+249|0]=0;v[i+250|0]=0;v[i+251|0]=0;v[i+252|0]=0;v[i+248|0]=37;l=pt(i+249|0,13966,x[c+4>>2]);b=i+208|0;x[i+204>>2]=b;a=Od();a:{if(l){j=x[c+8>>2];k=i- -64|0;x[k>>2]=g;x[k+4>>2]=h;x[i+56>>2]=e;x[i+60>>2]=f;x[i+48>>2]=j;j=ph(b,30,a,i+248|0,i+48|0);break a}x[i+80>>2]=e;x[i+84>>2]=f;x[i+88>>2]=g;x[i+92>>2]=h;j=ph(i+208|0,30,a,i+248|0,i+80|0)}x[i+128>>2]=1239;k=De(i+196|0,0,i+128|0);b=i+208|0;a=b;b:{c:{d:{e:{if((j|0)>=30){a=Od();f:{if(l){j=x[c+8>>2];x[i+16>>2]=g;x[i+20>>2]=h;x[i+8>>2]=e;x[i+12>>2]=f;x[i>>2]=j;j=kj(i+204|0,a,i+248|0,i);break f}x[i+32>>2]=e;x[i+36>>2]=f;x[i+40>>2]=g;x[i+44>>2]=h;j=kj(i+204|0,a,i+248|0,i+32|0)}if((j|0)==-1){x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)==1){break d}break e}a=x[i+204>>2];Qe(k,a)}f=a+j|0;g=lj(a,f,x[c+4>>2]);x[i+116>>2]=1239;e=De(i+120|0,0,i+116|0);g:{h:{if((i+208|0)==(a|0)){j=i+128|0;break h}j=Gd(j<<1);if(!j){x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)!=1){break e}a=N()|0;break g}Qe(e,j);b=a}a=i+108|0;cd(a,x[c+28>>2]);x[31609]=0;ga(1267,b|0,g|0,f|0,j|0,i+116|0,i+112|0,a|0);b=x[31609];x[31609]=0;i:{if((b|0)!=1){_b(a);x[31609]=0;a=ea(23,m|0,j|0,x[i+116>>2],x[i+112>>2],c|0,d|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break i}Lc(e);Lc(k);fb=i+256|0;break b}a=N()|0;_b(i+108|0);break g}a=N()|0}Lc(e);break c}p()}a=N()|0}Lc(k);Q(a|0);p()}return a|0}function Gma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0,z=0,A=0,B=0;f=fb-48|0;fb=f;r=x[a+16>>2];b=0;while(1){if((b|0)!=2){i=b<<3;l=i+(f+28|0)|0;i=a+i|0;x[l+4>>2]=x[i+44>>2];x[l+8>>2]=x[i+48>>2];b=b+1|0;continue}break}s=x[a+24>>2];t=x[a+20>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;u=x[a+72>>2];o=x[a+68>>2];y=o>>31;p=x[a+64>>2];z=p>>31;l=x[a+60>>2];A=l>>31;i=x[a+8>>2];B=x[a+12>>2];while(1){if(d){b=x[f+16>>2];j=(((x[f+20>>2]&2147483647)<<1|b>>>31)&-2)+r|0;b=b>>>21&2040;g=w[b+38086>>1];n=w[b+38084>>1];h=w[b+38082>>1];e=w[b+38080>>1];m=0;b=0;while(1){if((b|0)!=2){x[(f+8|0)+(b<<2)>>2]=(((D(h,v[b+j|0])+D(v[j+(b|-2)|0],e)|0)+D(n,v[j+(b|2)|0])|0)+D(g,v[j+(b|4)|0])<<8)/16384;b=b+1|0;continue}break}while(1){if((m|0)!=2){q=(f+8|0)+(m<<2)|0;e=x[q>>2];b=(f+28|0)+(m<<3)|0;j=x[b+8>>2];g=x[b+4>>2];x[b+8>>2]=g;n=e<<8;e=n;e=Iua(e,e>>31,l,A);h=hb;k=e;e=Yb(g,-16777216,16776704);e=Iua(p,z,e,e>>31);g=k+e|0;k=hb+h|0;k=e>>>0>g>>>0?k+1|0:k;e=Yb(j,-16777216,16776704);h=Iua(o,y,e,e>>31);g=h+g|0;e=hb+k|0;e=g>>>0<h>>>0?e+1|0:e;h=g+8388608|0;e=h>>>0<8388608?e+1|0:e;e=Sc(h,e,24);x[b+4>>2]=e-(n&u);x[q>>2]=(e|0)/256;m=m+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[f+8>>2],t);x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],s);Pb(f+16|0,i,B);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function C7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;a=fb-272|0;fb=a;x[a+264>>2]=c;x[a+268>>2]=b;x[a+16>>2]=1274;b=a+16|0;h=De(a+152|0,a+160|0,b);j=a+144|0;cd(j,x[e+28>>2]);x[31609]=0;i=R(28,x[a+144>>2])|0;k=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{g:{if((k|0)!=1){v[a+143|0]=0;e=x[e+4>>2];x[31609]=0;c=na(1275,a+268|0,c|0,d|0,j|0,e|0,f|0,a+143|0,i|0,h|0,a+148|0,a+260|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break d}if(!c){break e}v[a+142|0]=0;v[a+140|0]=56;v[a+141|0]=57;v[a+132|0]=48;v[a+133|0]=49;v[a+134|0]=50;v[a+135|0]=51;v[a+136|0]=52;v[a+137|0]=53;v[a+138|0]=54;v[a+139|0]=55;x[31609]=0;V(1249,i|0,a+132|0,a+142|0,a+122|0);c=x[31609];x[31609]=0;if((c|0)==1){break g}x[a+4>>2]=1239;d=De(a+8|0,0,a+4|0);e=b;b=x[a+148>>2];c=b-x[h>>2]|0;if((c|0)<99){break f}Qe(d,Gd(c+2|0));e=x[d>>2];if(e){break f}x[31609]=0;X(1240);b=x[31609];x[31609]=0;if((b|0)==1){break c}break a}c=N()|0;break b}c=N()|0;break b}if(y[a+143|0]){v[e|0]=45;e=e+1|0}c=x[h>>2];while(1){if(b>>>0<=c>>>0){v[e|0]=0;x[a>>2]=g;if((YJ(a+16|0,a)|0)!=1){x[31609]=0;W(1276,8e3);b=x[31609];x[31609]=0;if((b|0)!=1){break a}break c}Lc(d)}else{b=a+122|0;i=i_(b);l=e,m=y[((Hi(b,i,y[c|0])-a|0)+a|0)+10|0],v[l|0]=m;e=e+1|0;c=c+1|0;b=x[a+148>>2];continue}break}}x[31609]=0;b=P(1241,a+268|0,a+264|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break d}if(b){x[f>>2]=x[f>>2]|2}b=x[a+268>>2];_b(a+144|0);Lc(h);fb=a+272|0;return b|0}c=N()|0;break b}c=N()|0;Lc(d)}_b(a+144|0);Lc(h);Q(c|0);p()}p()}function Kz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=E(0);e=fb-48|0;fb=e;a:{b:{c:{d:{e:{switch(b-1|0){case 1:b=(c<<7)/100|0;d=x[a+24>>2];if((b|0)==x[d+24604>>2]){break d}a=e+8|0;zc(a,d+24604|0,40);x[e+8>>2]=b;NA(d,a);break d;case 2:f=x[a+24>>2];d=f+24664|0;b=x[d+4>>2];x[e+24>>2]=x[d>>2];x[e+28>>2]=b;d=f+24656|0;b=x[d+4>>2];x[e+16>>2]=x[d>>2];x[e+20>>2]=b;b=x[f+24652>>2];x[e+8>>2]=x[f+24648>>2];x[e+12>>2]=b;d=fb-16|0;fb=d;b=3;f:{g:{h:{if(!c|(c|0)>7){break h}b=2;if((c|0)>2){break h}b=1;if((c|0)==2){break h}b=0;if((c|0)>0){break h}c=ac(8);x[31609]=0;b=P(36,d+4|0,10846)|0;a=x[31609];x[31609]=0;i:{if((a|0)!=1){pc(c,b);x[31609]=0;S(97,c|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break g}a=N()|0;tb(b);break i}a=N()|0;ic(c)}Q(a|0);p()}fb=d+16|0;break f}p()}v[e+8|0]=b;b=e+8|0;a=x[a+24>>2];if(!Az(b,a+24648|0)){break d}LA(a,b);break d;case 3:f=e+8|0;d=x[a+24>>2];zc(f,d+24604|0,40);b=fb-48|0;fb=b;j:{if((c|0)==-1){bu(f,x[Tq(b+8|0)+32>>2]);No(f,x[Tq(b+8|0)+36>>2]);break j}if((c|0)<=0){bu(f,0);No(f,0);break j}a=D(c,1e3);bu(f,a);No(f,a)}fb=b+48|0;if(x[d+24636>>2]==x[e+40>>2]&x[d+24640>>2]==x[e+44>>2]){break d}NA(d,e+8|0);break d;default:d=ac(8);x[31609]=0;c=P(36,e+8|0,10401)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}pc(d,c);x[31609]=0;S(97,d|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}b=N()|0;tb(c);break b;case 0:break e}}g=a,h=Ee(E(10),E(E(E(c|0)*E(.0010000000474974513))*E(.5))),B[g+48>>2]=h}fb=e+48|0;return}b=N()|0;ic(d)}Q(b|0)}p()}function xk(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0;i=fb-16|0;fb=i;a:{if(!d){break a}g=x[c>>2];if(!g){break a}b:{c:{d:{e:{f=x[a+480180>>2];if((f|0)!=512){if((f|0)!=64){break e}f=D(d,20)+g|0;break d}f=((D(d,36318)|0)/1024|0)+g|0;break d}f:{g:{if(y[a+480208|0]&16){if((f|0)==4){break g}f=d>>31;x[i+12>>2]=(f^d)-f;xc(i+12|0,1020);h=x[i+12>>2];f=c;h:{if((d|0)>0){if(h>>>0<=15){h=x[(h<<2)+(Ob(a+1074312|0,7)?35376:35440)>>2];break h}h=x[(h&-4)+(Ob(a+1074312|0,7)?35504:36528)>>2];break h}if(h>>>0<=15){h=x[(h<<2)+(Ob(a+1074312|0,7)?35440:35376)>>2];break h}h=x[(h&-4)+(Ob(a+1074312|0,7)?36528:35504)>>2]}j=Iua(h,h>>31,g,g>>31);h=hb;j=j+32768|0;h=j>>>0<32768?h+1|0:h;k=f;f=Gc(Jua(j,h,65536,0),hb);x[k>>2]=f;if((g|0)!=(f|0)){break c}f=Ob(a+1074312|0,7);g=x[c>>2];if(!((d|0)>0^f)){f=2147483647;d=1;if((g|0)==2147483647){break c}break f}d=-1;if((g|0)>=2){break f}f=g;break c}f=Ob(a+1074312|0,7);g=x[c>>2];if(!f){break g}if((d|0)<0){f=Iua(g,0,14317456,0);h=hb;g=Iua(g,0,0-d|0,0);d=hb;g=g+14317456|0;d=g>>>0<14317456?d+1|0:d;f=WS(Kua(f,h,g,d),hb);break d}d=Iua(g,g>>31,d,0);f=hb;if((f|0)>=0&d>>>0>=14317456|(f|0)>0){if(e){x[c>>2]=2147483647;break a}x[c>>2]=0;x[b+696>>2]=0;x[b+88>>2]=x[b+88>>2]|2101248;break a}d=WS(Kua(Iua(g,0,14317456,0),hb,14317456-d|0,0-(f+(d>>>0>14317456)|0)|0),hb);x[c>>2]=d;if((d|0)<=0){break b}break a}f=g-d|0;break d}f=d+g|0}x[c>>2]=f}if((f|0)>0){break a}}x[c>>2]=1;if(x[a+480180>>2]!=2|e){break a}x[b+696>>2]=0;x[b+88>>2]=x[b+88>>2]|2101248}fb=i+16|0}function Q0(){var a=0,b=0,c=0;if(!y[497532]){a=fb-16|0;fb=a;Pt(497180);x[124307]=-1;x[124305]=497236;x[124303]=125632;x[124295]=94380;v[497232]=0;b=a+12|0;cd(b,x[124296]);c=x[x[124295]+8>>2];x[31609]=0;O(c|0,497180,b|0);c=x[31609];x[31609]=0;a:{if((c|0)!=1){_b(b);fb=a+16|0;break a}b=N()|0;_b(a+12|0);go(497180);Q(b|0);p()}Tt(496508);x[124127]=94512;x[124125]=94492;x[124126]=0;oo(496508,497180);XK(497244,125776,497292);Oy(496676,497244);XK(497300,125480,497348);Oy(496844,497300);Oy(497012,x[x[x[124211]-12>>2]+496868>>2]);WK(x[x[124125]-12>>2]+496500|0);TK(x[x[124211]-12>>2]+496844|0);WK(x[x[124211]-12>>2]+496844|0);a=fb-16|0;fb=a;gL(497356);x[124351]=-1;x[124349]=497412;x[124347]=125632;x[124339]=94772;v[497408]=0;b=a+12|0;cd(b,x[124340]);c=x[x[124339]+8>>2];x[31609]=0;O(c|0,497356,b|0);c=x[31609];x[31609]=0;b:{if((c|0)!=1){_b(b);fb=a+16|0;break b}b=N()|0;_b(a+12|0);Ct(497356);Q(b|0);p()}SK(496596);x[124149]=94904;x[124147]=94884;x[124148]=0;oo(496596,497356);VK(497420,125776,497468);Ny(496760,497420);VK(497476,125480,497524);Ny(496928,497476);Ny(497096,x[x[x[124232]-12>>2]+496952>>2]);UK(x[x[124147]-12>>2]+496588|0);TK(x[x[124232]-12>>2]+496928|0);UK(x[x[124232]-12>>2]+496928|0);v[497532]=1}a=fb-16|0;fb=a;c:{if(bb(a+12|0,a+8|0)|0){break c}b=Gd((x[a+12>>2]<<2)+4|0);x[125414]=b;if(!b){break c}b=Gd(x[a+8>>2]);if(b){c=x[125414];x[c+(x[a+12>>2]<<2)>>2]=0;if(!(ab(c|0,b|0)|0)){break c}}x[125414]=0}fb=a+16|0;x[124097]=42;x[124115]=501692}function k8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;d=x[d+28>>2];a=fb-384|0;fb=a;x[a+376>>2]=c;x[a+380>>2]=b;Dy(a+220|0,d,a+240|0,a+236|0,a+232|0);d=Fb(a+208|0);b=Mc(d);x[31609]=0;O(46,d|0,b|0);b=x[31609];x[31609]=0;a:{b:{c:{if((b|0)!=1){c=dc(d,0);x[a+204>>2]=c;x[a+28>>2]=a+32;x[a+24>>2]=0;v[a+23|0]=1;v[a+22|0]=69;h=x[a+232>>2];i=x[a+236>>2];while(1){d:{x[31609]=0;b=P(1257,a+380|0,a+376|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(b){break c}g=x[a+204>>2];b=Cb(x[d+4>>2],y[d+11|0]);if((g|0)==(b+c|0)){x[31609]=0;O(46,d|0,b<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+204>>2]=b+c}x[31609]=0;b=R(1258,x[a+380>>2])|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(Cy(b,a+23|0,a+22|0,c,a+204|0,i,h,a+220|0,a+32|0,a+28|0,a+24|0,a+240|0)){break c}x[31609]=0;R(1260,a+380|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+224>>2],y[a+231|0])|!y[a+23|0]){break e}b=x[a+28>>2];if((b-(a+32|0)|0)>159){break e}x[a+28>>2]=b+4;x[b>>2]=x[a+24>>2]}yK(a,c,x[a+204>>2],e);b=x[a>>2];c=x[a+4>>2];h=x[a+12>>2];x[f+8>>2]=x[a+8>>2];x[f+12>>2]=h;x[f>>2]=b;x[f+4>>2]=c;Vf(a+220|0,a+32|0,x[a+28>>2],e);x[31609]=0;b=P(1257,a+380|0,a+376|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+380>>2];tb(d);tb(a+220|0);fb=a+384|0;break a}}b=N()|0;tb(d);tb(a+220|0);Q(b|0);p()}return b|0}function Yka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,z=0,A=0,B=0;f=fb-48|0;fb=f;a:{b:{c:{d:{e:{f:{g:{if(!a){break g}l=e<<2;if(l>>>0>d>>>0){break g}t=l-4|0;o=D(b,e);u=o-8|0;h:while(1){b=x[c+8>>2];g=x[c>>2];x[31609]=0;b=U(150,g|0,b|0,l|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}if(!(n>>>0<o>>>0&b)){break g}x[31609]=0;b=f+8|0;S(185,b|0,c|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break c}g=hc(f+28|0,b);ub(b);x[31609]=0;O(575,b|0,g|0);j=x[31609];x[31609]=0;if((j|0)==1){break e}z=Ze(b);q=x[f+8>>2];A=q-4|0;j=0;while(1){if((e|0)==(j|0)){Kc(f+8|0);ub(g);n=(q-l<<1)+n|0;continue h}x[31609]=0;h=R(568,g|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){x[31609]=0;b=R(197,g|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break f}x[f>>2]=b;He(f,0,89);x[31609]=0;P(183,g|0,1)|0;b=x[31609];x[31609]=0;if((b|0)==1){break f}k=j+n|0;b=e+j<<2;i:while(1){j:{if(k>>>0>u>>>0){break j}m=0;if(b>>>0>A>>>0){break j}while(1)if((m|0)==8){b=b+t|0;continue i}else{r=x[f>>2];i=y[b+z|0];s=m&1;i=s?i>>>4|0:i&15;x[f>>2]=r+v[(i&7)+28600|0];B=h;h=w[(r<<1)+28608>>1];h=(((0-(i&1)&h>>2)+(h>>3)|0)+(i<<30>>31&h>>1)|0)+(h&i<<29>>31)|0;x[f+4>>2]=B+(i>>>0<8?h:0-h|0);He(f,0,88);He(f+4|0,-32768,32767);h=x[f+4>>2];w[(k<<1)+a>>1]=h;m=m+1|0;k=e+k|0;b=b+s|0;continue}}break}j=j+1|0;continue}break}break}break f}ub(c);fb=f+48|0;return}b=N()|0;Kc(f+8|0);break d}b=N()|0}ub(g);break a}b=N()|0;break a}b=N()|0}ub(c);Q(b|0);p()}function t8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;d=x[d+28>>2];a=fb-272|0;fb=a;x[a+264>>2]=c;x[a+268>>2]=b;Hy(a+208|0,d,a+224|0,a+223|0,a+222|0);d=Fb(a+196|0);b=Mc(d);x[31609]=0;O(46,d|0,b|0);b=x[31609];x[31609]=0;a:{b:{c:{if((b|0)!=1){c=dc(d,0);x[a+192>>2]=c;x[a+28>>2]=a+32;x[a+24>>2]=0;v[a+23|0]=1;v[a+22|0]=69;h=v[a+222|0];i=v[a+223|0];while(1){d:{x[31609]=0;b=P(1241,a+268|0,a+264|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(b){break c}g=x[a+192>>2];b=Cb(x[d+4>>2],y[d+11|0]);if((g|0)==(b+c|0)){x[31609]=0;O(46,d|0,b<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+192>>2]=b+c}x[31609]=0;b=R(1242,x[a+268>>2])|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(Gy(b,a+23|0,a+22|0,c,a+192|0,i,h,a+208|0,a+32|0,a+28|0,a+24|0,a+224|0)){break c}x[31609]=0;R(1244,a+268|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+212>>2],y[a+219|0])|!y[a+23|0]){break e}b=x[a+28>>2];if((b-(a+32|0)|0)>159){break e}x[a+28>>2]=b+4;x[b>>2]=x[a+24>>2]}yK(a,c,x[a+192>>2],e);b=x[a>>2];c=x[a+4>>2];h=x[a+12>>2];x[f+8>>2]=x[a+8>>2];x[f+12>>2]=h;x[f>>2]=b;x[f+4>>2]=c;Vf(a+208|0,a+32|0,x[a+28>>2],e);x[31609]=0;b=P(1241,a+268|0,a+264|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+268>>2];tb(d);tb(a+208|0);fb=a+272|0;break a}}b=N()|0;tb(d);tb(a+208|0);Q(b|0);p()}return b|0}function Foa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=x[a>>2];d=Ud(c,x[a+4>>2]);if(d>>>0<b>>>0){i=fb-32|0;fb=i;b=b-d|0;d=x[Ab(a)>>2];c=x[a+4>>2];a:{if(b>>>0<=(d-c|0)/12>>>0){d=fb-16|0;fb=d;b=vv(d+4|0,a,b);a=x[b+4>>2];c=x[b+8>>2];while(1){if((a|0)==(c|0)){kc(b);fb=d+16|0}else{uW(a);a=a+12|0;x[b+4>>2]=a;continue}break}break a}d=Ab(a);d=zm(i+12|0,Pp(a,Ud(x[a>>2],c)+b|0),Ud(x[a>>2],x[a+4>>2]),d);f=fb-16|0;fb=f;b=tW(f+4|0,d+8|0,b);c=x[b>>2];while(1){if(x[b+4>>2]!=(c|0)){uW(c);c=x[b>>2]+12|0;x[b>>2]=c;continue}break}je(b);fb=f+16|0;f=fb-16|0;fb=f;e=Ab(a);b=vb(f+12|0,x[a+4>>2]);g=vb(f+8|0,x[a>>2]);h=vb(f+4|0,x[d+4>>2]);c=x[b>>2];g=x[g>>2];b=fb+-64|0;fb=b;h=x[h>>2];x[b+56>>2]=h;x[b+60>>2]=c;x[b+52>>2]=h;e=Ag(b+24|0,e,b+52|0,b+56|0);x[b+16>>2]=x[e+8>>2];h=x[e+4>>2];x[b+8>>2]=x[e>>2];x[b+12>>2]=h;zg(b+36|0,b+8|0);while(1){if(Fd(c,g)){sW(Op(x[b+56>>2]),cl(c));c=lk(b+60|0);lk(b+56|0);c=x[c>>2];continue}break}yg(b+36|0);h=x[b+56>>2];if(!y[b+48|0]){e=fb-16|0;fb=e;c=vb(e+12|0,x[x[b+44>>2]>>2]);j=x[vb(e+8|0,x[x[b+40>>2]>>2])>>2];g=fb-16|0;fb=g;c=x[c>>2];x[g+12>>2]=c;while(1){if(xi(c,j)){yC(Ax(c));c=x[ym(g+12|0)>>2];continue}break}fb=g+16|0;fb=e+16|0}fb=b- -64|0;x[d+4>>2]=h;Tb(a,d+4|0);Tb(a+4|0,d+8|0);Tb(Ab(a),nc(d));x[d>>2]=x[d+4>>2];fb=f+16|0;a=x[d+4>>2];while(1){b=x[d+8>>2];if((b|0)!=(a|0)){b=b-12|0;x[d+8>>2]=b;yC(b);continue}break}a=x[d>>2];if(a){ts(d);Db(a)}}fb=i+32|0;return}if(b>>>0<d>>>0){vW(a,c+D(b,12)|0)}}function Rja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=fb-96|0;fb=c;Uj(c+76|0,b,1413829443);x[31609]=0;b=R(172,x[c+76>>2])|0;d=x[31609];x[31609]=0;a:{b:{c:{if((d|0)==1){break c}if(!b){x[31609]=0;d=c+56|0;S(808,d|0,a+140|0,1413894985);a=x[31609];x[31609]=0;d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{if((a|0)!=1){x[31609]=0;a=P(891,d|0,13752)|0;b=x[31609];x[31609]=0;if((b|0)==1){break e}b=28591;if(a){b=Fb(c+44|0);x[31609]=0;a=R(202,d|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break m}x[31609]=0;S(270,d|0,b|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break m}x[31609]=0;d=P(71,c+20|0,b|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break l}x[31609]=0;e=c+8|0;W(892,e|0);a=x[31609];x[31609]=0;if((a|0)==1){break k}x[31609]=0;a=c+32|0;S(893,a|0,d|0,e|0);f=x[31609];x[31609]=0;if((f|0)==1){break j}f=zb(b,a);tb(a);tb(e);tb(d);x[31609]=0;S(258,a|0,2,f|0);d=x[31609];x[31609]=0;if((d|0)==1){break h}x[31609]=0;d=R(773,a|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break g}tb(a);tb(f);b=d-1>>>0<19398657?1252:28591}ub(c+56|0);break a}a=N()|0;break b}a=N()|0;break f}a=N()|0;break f}a=N()|0;break i}a=N()|0;tb(c+8|0)}tb(d);break f}a=N()|0;break f}a=N()|0;tb(c+32|0)}tb(b);break d}a=N()|0}ub(c+56|0);break b}x[31609]=0;a=U(150,x[c+76>>2],x[c+84>>2],2)|0;b=x[31609];x[31609]=0;if((b|0)==1){break c}b=28591;if(!a){break a}x[31609]=0;b=R(189,c+76|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;break b}a=N()|0}ub(c+76|0);Q(a|0);p()}ub(c+76|0);fb=c+96|0;return b|0}function Cna(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=fb-32|0;fb=e;w[e+30>>1]=254;d=Ij(a);c=fb-16|0;fb=c;f=e+16|0;x[f>>2]=0;x[f+4>>2]=0;tc(f+8|0);Rd(c+8|0,x[vb(c+4|0,f)>>2]);a:{b:{if(d){x[31609]=0;O(641,f|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break b}RE(f,d)}g=c+8|0;Qd(g);Sj(g);fb=c+16|0;break a}a=N()|0;Sj(c+8|0);Q(a|0);p()}c=x[a>>2];g=x[f>>2];while(1){if((b|0)==(d|0)){c:{if(!(h&65535)){break c}c=wb(c);d=wb(x[a+4>>2]);b=fb-16|0;fb=b;c=NC(c,d,z[e+30>>1]);x[b+12>>2]=c;if(Ib(c,d)){x[b+8>>2]=c;while(1){c=x[ge(b+8|0)>>2];if(Ib(c,d)){c=z[c>>1];if((c|0)==z[e+30>>1]){continue}w[x[b+12>>2]>>1]=c;ge(b+12|0);continue}break}c=x[b+12>>2]}fb=b+16|0;b=vb(e+12|0,c);c=x[vb(e+8|0,wb(x[a+4>>2]))>>2];d=x[b>>2];b=x[a>>2];b=(kp(d,wb(b))<<1)+b|0;if(Ib(d,c)){Jd(a,aC(b+(kp(c,d)<<1)|0,x[a+4>>2],b))}wb(b);b=wb(x[a>>2]);x[e+4>>2]=b;d=wb(x[a+4>>2]);while(1){if(Ib(b,d)){d:{c=x[a+24>>2];h=x[c+484344>>2];b=z[b>>1];if(!Je(h,x[c+484348>>2],b)){break d}b=Wb(h,b);k=e,l=wb(x[b>>2]),x[k>>2]=l;h=wb(x[b+4>>2]);g=x[f+4>>2];c=x[f>>2];while(1){b=x[e>>2];if(!Ib(b,h)){break d}e:{if(y[b+3|0]!=12){break e}j=$c(c,g);i=y[b+5|0];if(j>>>0<=i>>>0){break e}k=b,l=y[bc(c,i)|0],v[k+5|0]=l}tg(e);continue}}b=x[ge(e+4|0)>>2];continue}else{b=x[f>>2];d=$c(b,x[f+4>>2]);c=z[a+28>>1];if(d>>>0<=c>>>0){break c}k=a,l=z[bc(b,c)>>1],w[k+28>>1]=l}break}}}else{k=bc(g,b),l=b-h|0,w[k>>1]=l;h=(z[bc(c,b)>>1]==254)+h|0;b=b+1|0;continue}break}od(f);fb=e+32|0}function Ila(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0;g=fb-16|0;fb=g;t=x[a+16>>2];u=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);m=x[a+8>>2];n=x[a+12>>2];h=x[a>>2];e=x[a+4>>2];o=x[a+128>>2];if(o){p=Hg(m,n,o);q=hb;b=x[a+76>>2];fg(h,e,vf(m,n,d),hb);r=hb>>>0>b>>>0?d:0}i=a+112|0;f=x[a+48>>2];k=x[a+40>>2];l=x[a+36>>2];b=x[a+44>>2];x[g>>2]=h;x[g+4>>2]=e;a:while(1){b:{s=b;if(!d){break b}d=d-1|0;x[g+8>>2]=h;x[g+12>>2]=0;r=r-1|0;b=r;p=b?p:0;q=b?q:0;h=(e<<1)+t|0;b=o;while(1)if((b|0)<=0){Pb(i,x[a+120>>2],x[a+124>>2]);b=x[a+116>>2];if(b){ce(i,w[h+(x[g+12>>2]<<1)>>1]/4<<16>>16);be(i,b);x[i>>2]=x[i>>2];x[i+4>>2]=0}v=x[a+72>>2];y=x[a+32>>2];l=x[a+28>>2]+l|0;h=Fg(i,u)<<8;b=h;j=b>>31;b=x[a+60>>2];b=Iua(h,j,b,b>>31);z=hb;e=b;b=x[a+64>>2];j=b;A=b>>31;b=Yb(s,-16777216,16776704);j=Iua(j,A,b,b>>31);e=e+j|0;b=hb+z|0;b=e>>>0<j>>>0?b+1|0:b;j=e;e=x[a+68>>2];f=Yb(f,-16777216,16776704);e=Iua(e,e>>31,f,f>>31);f=j+e|0;b=hb+b|0;b=e>>>0>f>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=Sc(f,b,24);f=(b|0)/256|0;x[c>>2]=D(l>>12,f)+x[c>>2];k=k+y|0;x[c+4>>2]=x[c+4>>2]+D(k>>12,f);Pb(g,m,n);b=b-(h&v)|0;c=c+8|0;h=x[g>>2];e=x[g+4>>2];f=s;continue a}else{ce(i,w[h+(x[g+12>>2]<<1)>>1]/4<<16>>16);be(i,4);Pb(g+8|0,p,q);b=b-1|0;continue}}break}x[a>>2]=h;x[a+4>>2]=e;x[a+40>>2]=k;x[a+20>>2]=l>>12;x[a+36>>2]=l;x[a+48>>2]=f;x[a+44>>2]=s;x[a+24>>2]=k>>12;fb=g+16|0}function GO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=fb-32|0;fb=d;g=Nb(a);a:{b:{c:{a=x[b+36>>2];c=x[b+40>>2];d:{if(Ib(a,c)){tc(d+28|0);break d}x[31609]=0;a=d+16|0;O(1072,a|0,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}x[31609]=0;c=R(1056,a|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break c}x[d+28>>2]=c;nf(a);c=x[b+40>>2];a=x[b+36>>2]}e:{if(Ib(a,c)){c=b+36|0;break e}c=x[d+28>>2];a=x[c>>2]}e=x[c+4>>2];x[31609]=0;O(176,g|0,hj(a,e)|0);a=x[31609];x[31609]=0;f:{if((a|0)!=1){a=wb(x[c>>2]);x[d+12>>2]=a;h=wb(x[c+4>>2]);g:{h:{i:{j:{k:{while(1){if(!Ib(a,h)){yl(d+28|0);fb=d+32|0;return}c=y[a+16|0];e=x[x[b+24>>2]+484360>>2];x[31609]=0;e=Nj(e,c);O(1073,d|0,e|0);c=x[31609];x[31609]=0;if((c|0)==1){break g}x[31609]=0;c=d+16|0;O(1059,c|0,d|0);f=x[31609];x[31609]=0;if((f|0)!=1){x[31609]=0;O(178,g|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break k}tb(c);tb(d);f=cl(x[g+4>>2]);l:{if(!Ad(x[f+4>>2],y[f+11|0])){break l}a=x[a+12>>2];if(!Yi(e,a&255)){break l}f=x[b+24>>2];i=x[f+1298404>>2];a=z[bc(x[e>>2],a)>>1];e=x[f+484344>>2];x[31609]=0;O(1066,d|0,Wb(e,a)|0);a=x[31609];x[31609]=0;if((a|0)==1){break i}x[31609]=0;S(1074,c|0,i|0,d|0);a=x[31609];x[31609]=0;if((a|0)==1){break h}zb(cl(x[g+4>>2]),c);tb(c);tb(d)}a=x[fA(d+12|0)>>2];continue}break}a=N()|0;break j}a=N()|0;tb(d+16|0)}tb(d);break f}a=N()|0;break f}a=N()|0;tb(d);break f}a=N()|0;break f}a=N()|0}yl(d+28|0);break a}a=N()|0;nf(d+16|0);break a}a=N()|0}Td(g);Q(a|0);p()}function Wma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0;f=fb-48|0;fb=f;q=x[a+16>>2];b=0;while(1){if((b|0)!=2){g=b<<3;l=g+(f+28|0)|0;g=a+g|0;x[l+4>>2]=x[g+44>>2];x[l+8>>2]=x[g+48>>2];b=b+1|0;continue}break}r=x[a+24>>2];s=x[a+20>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;t=x[a+72>>2];m=x[a+68>>2];u=m>>31;n=x[a+64>>2];v=n>>31;o=x[a+60>>2];y=o>>31;l=x[a+8>>2];z=x[a+12>>2];while(1){if(d){g=x[f+16>>2];e=g>>>18|0;k=((((x[f+20>>2]&2147483647)<<1|g>>>31)&2147483646)<<1)+q|0;b=0;h=0;while(1){if((h|0)!=2){g=h<<1;i=w[g+k>>1];x[(f+8|0)+(h<<2)>>2]=i+((D(e,w[k+(g|4)>>1]-i|0)|0)/16384|0);h=h+1|0;continue}break}while(1){if((b|0)!=2){p=(f+8|0)+(b<<2)|0;e=x[p>>2];g=(f+28|0)+(b<<3)|0;A=x[g+8>>2];h=x[g+4>>2];x[g+8>>2]=h;k=e<<8;e=k;e=Iua(e,e>>31,o,y);i=hb;j=e;e=Yb(h,-16777216,16776704);e=Iua(n,v,e,e>>31);h=j+e|0;j=hb+i|0;j=e>>>0>h>>>0?j+1|0:j;e=Yb(A,-16777216,16776704);i=Iua(m,u,e,e>>31);h=i+h|0;e=hb+j|0;e=h>>>0<i>>>0?e+1|0:e;i=h+8388608|0;e=i>>>0<8388608?e+1|0:e;e=Sc(i,e,24);x[g+4>>2]=e-(k&t);x[p>>2]=(e|0)/256;b=b+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[f+8>>2],s);x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],r);Pb(f+16|0,l,z);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function j8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=fb-320|0;fb=a;x[a+312>>2]=c;x[a+316>>2]=b;h=Fb(a+196|0);g=a+16|0;cd(g,x[d+28>>2]);x[31609]=0;b=R(1252,x[a+16>>2])|0;c=x[31609];x[31609]=0;a:{b:{if((c|0)==1){break b}x[31609]=0;V(1263,b|0,95168,95194,a+208|0);b=x[31609];x[31609]=0;if((b|0)==1){break b}_b(g);c=Fb(a+184|0);b=Mc(c);x[31609]=0;O(46,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){c:{b=dc(c,0);x[a+180>>2]=b;x[a+12>>2]=g;x[a+8>>2]=0;while(1){d:{x[31609]=0;g=P(1257,a+316|0,a+312|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break d}d=x[a+180>>2];e:{if(!g){g=d;d=Cb(x[c+4>>2],y[c+11|0]);if((g|0)==(d+b|0)){x[31609]=0;O(46,c|0,d<<1);b=x[31609];x[31609]=0;if((b|0)==1){break c}b=Mc(c);x[31609]=0;O(46,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}b=dc(c,0);x[a+180>>2]=d+b}x[31609]=0;d=R(1258,x[a+316>>2])|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(!bo(d,16,b,a+180|0,a+8|0,0,x[h+4>>2],y[h+11|0],a+16|0,a+12|0,a+208|0)){break e}d=x[a+180>>2]}x[31609]=0;O(46,c|0,d-b|0);b=x[31609];x[31609]=0;if((b|0)==1){break d}b=Kb(c);d=Od();x[a>>2]=f;if((xK(b,d,a)|0)!=1){x[e>>2]=4}x[31609]=0;b=P(1257,a+316|0,a+312|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break d}if(b){x[e>>2]=x[e>>2]|2}b=x[a+316>>2];tb(c);tb(h);fb=a+320|0;return b|0}x[31609]=0;R(1260,a+316|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){continue}}break}}}b=N()|0;tb(c);break a}b=N()|0;_b(a+16|0)}tb(h);Q(b|0);p()}function s8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=fb-256|0;fb=a;x[a+248>>2]=c;x[a+252>>2]=b;h=Fb(a+196|0);g=a+16|0;cd(g,x[d+28>>2]);x[31609]=0;b=R(28,x[a+16>>2])|0;c=x[31609];x[31609]=0;a:{b:{if((c|0)==1){break b}x[31609]=0;V(1249,b|0,95168,95194,a+208|0);b=x[31609];x[31609]=0;if((b|0)==1){break b}_b(g);c=Fb(a+184|0);b=Mc(c);x[31609]=0;O(46,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){c:{b=dc(c,0);x[a+180>>2]=b;x[a+12>>2]=g;x[a+8>>2]=0;while(1){d:{x[31609]=0;g=P(1241,a+252|0,a+248|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break d}d=x[a+180>>2];e:{if(!g){g=d;d=Cb(x[c+4>>2],y[c+11|0]);if((g|0)==(d+b|0)){x[31609]=0;O(46,c|0,d<<1);b=x[31609];x[31609]=0;if((b|0)==1){break c}b=Mc(c);x[31609]=0;O(46,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}b=dc(c,0);x[a+180>>2]=d+b}x[31609]=0;d=R(1242,x[a+252>>2])|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(!co(d,16,b,a+180|0,a+8|0,0,x[h+4>>2],y[h+11|0],a+16|0,a+12|0,a+208|0)){break e}d=x[a+180>>2]}x[31609]=0;O(46,c|0,d-b|0);b=x[31609];x[31609]=0;if((b|0)==1){break d}b=Kb(c);d=Od();x[a>>2]=f;if((xK(b,d,a)|0)!=1){x[e>>2]=4}x[31609]=0;b=P(1241,a+252|0,a+248|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break d}if(b){x[e>>2]=x[e>>2]|2}b=x[a+252>>2];tb(c);tb(h);fb=a+256|0;return b|0}x[31609]=0;R(1244,a+252|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){continue}}break}}}b=N()|0;tb(c);break a}b=N()|0;_b(a+16|0)}tb(h);Q(b|0);p()}function Jla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,y=0,z=0,A=0;g=fb-16|0;fb=g;t=x[a+16>>2];u=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);m=x[a+8>>2];n=x[a+12>>2];h=x[a>>2];e=x[a+4>>2];o=x[a+128>>2];if(o){p=Hg(m,n,o);q=hb;b=x[a+76>>2];fg(h,e,vf(m,n,d),hb);r=hb>>>0>b>>>0?d:0}i=a+112|0;f=x[a+48>>2];k=x[a+40>>2];l=x[a+36>>2];b=x[a+44>>2];x[g>>2]=h;x[g+4>>2]=e;a:while(1){b:{s=b;if(!d){break b}d=d-1|0;x[g+8>>2]=h;x[g+12>>2]=0;r=r-1|0;b=r;p=b?p:0;q=b?q:0;h=e+t|0;b=o;while(1)if((b|0)<=0){Pb(i,x[a+120>>2],x[a+124>>2]);b=x[a+116>>2];if(b){ce(i,v[h+x[g+12>>2]|0]<<6);be(i,b);x[i>>2]=x[i>>2];x[i+4>>2]=0}w=x[a+72>>2];y=x[a+32>>2];l=x[a+28>>2]+l|0;h=Fg(i,u)<<8;b=h;j=b>>31;b=x[a+60>>2];b=Iua(h,j,b,b>>31);z=hb;e=b;b=x[a+64>>2];j=b;A=b>>31;b=Yb(s,-16777216,16776704);j=Iua(j,A,b,b>>31);e=e+j|0;b=hb+z|0;b=e>>>0<j>>>0?b+1|0:b;j=e;e=x[a+68>>2];f=Yb(f,-16777216,16776704);e=Iua(e,e>>31,f,f>>31);f=j+e|0;b=hb+b|0;b=e>>>0>f>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=Sc(f,b,24);f=(b|0)/256|0;x[c>>2]=D(l>>12,f)+x[c>>2];k=k+y|0;x[c+4>>2]=x[c+4>>2]+D(k>>12,f);Pb(g,m,n);b=b-(h&w)|0;c=c+8|0;h=x[g>>2];e=x[g+4>>2];f=s;continue a}else{ce(i,v[h+x[g+12>>2]|0]<<6);be(i,4);Pb(g+8|0,p,q);b=b-1|0;continue}}break}x[a>>2]=h;x[a+4>>2]=e;x[a+40>>2]=k;x[a+20>>2]=l>>12;x[a+36>>2]=l;x[a+48>>2]=f;x[a+44>>2]=s;x[a+24>>2]=k>>12;fb=g+16|0}function kna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0,C=0;f=fb-48|0;fb=f;r=x[a+16>>2];l=kg(1,2);b=hb;s=b;Pb(a,l,b);b=0;while(1){if((b|0)!=2){g=b<<3;k=g+(f+28|0)|0;g=a+g|0;x[k+4>>2]=x[g+44>>2];x[k+8>>2]=x[g+48>>2];b=b+1|0;continue}break}t=x[a+24>>2];u=x[a+20>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;v=x[a+72>>2];m=x[a+68>>2];y=m>>31;n=x[a+64>>2];z=n>>31;o=x[a+60>>2];A=o>>31;k=x[a+8>>2];B=x[a+12>>2];while(1){if(d){d=d-1|0;b=x[f+16>>2];g=((((x[f+20>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+r|0;b=0;e=0;while(1){if((e|0)!=2){x[(f+8|0)+(e<<2)>>2]=w[g+(e<<1)>>1];e=e+1|0;continue}break}while(1){if((b|0)!=2){p=(f+8|0)+(b<<2)|0;e=x[p>>2];g=(f+28|0)+(b<<3)|0;C=x[g+8>>2];h=x[g+4>>2];x[g+8>>2]=h;q=e<<8;e=q;e=Iua(e,e>>31,o,A);i=hb;j=e;e=Yb(h,-16777216,16776704);e=Iua(n,z,e,e>>31);h=j+e|0;j=hb+i|0;j=e>>>0>h>>>0?j+1|0:j;e=Yb(C,-16777216,16776704);i=Iua(m,y,e,e>>31);h=i+h|0;e=hb+j|0;e=h>>>0<i>>>0?e+1|0:e;i=h+8388608|0;e=i>>>0<8388608?e+1|0:e;e=Sc(i,e,24);x[g+4>>2]=e-(v&q);x[p>>2]=(e|0)/256;b=b+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[f+8>>2],u);x[c+4>>2]=x[c+4>>2]+D(t,x[f+12>>2]);Pb(f+16|0,k,B);c=c+8|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}Ig(a,l,s);fb=f+48|0}function rma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0;h=fb-16|0;fb=h;f=x[a+8>>2];j=f;e=x[a+12>>2];i=e;a:{b:{c:{d:{if((e|0)<=1&f>>>0<=805306368|(e|0)<=0){f=e;if((e|0)>-2){f=1}else{f=(f|0)>=-2&j>>>0>=3489660928}if(f){break c}if((i|0)==-2&j>>>0>2147483647|(i|0)==-1){break d}break b}if((i|0)==1&j>>>0>2147483648|i>>>0>1){break b}}n=b+196648|0;break a}n=b+131112|0;break a}n=b+262184|0}r=x[a+16>>2];e=x[a+48>>2];s=x[a+24>>2];t=x[a+20>>2];b=x[a+44>>2];f=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=f;u=x[a+72>>2];o=x[a+68>>2];v=o>>31;p=x[a+64>>2];y=p>>31;q=x[a+60>>2];z=q>>31;while(1){f=b;if(d){b=Yb(b,-16777216,16776704);k=Iua(p,y,b,b>>31);l=hb;b=x[h+8>>2];g=(x[h+12>>2]<<1)+r|0;b=(b>>>16&65520)+n|0;g=(((((((D(w[g-4>>1],w[b+2>>1])+D(w[g-6>>1],w[b>>1])|0)+D(w[g-2>>1],w[b+4>>1])|0)+D(w[g>>1],w[b+6>>1])|0)+D(w[g+2>>1],w[b+8>>1])|0)+D(w[g+4>>1],w[b+10>>1])|0)+D(w[g+6>>1],w[b+12>>1])|0)+D(w[g+8>>1],w[b+14>>1])|0)/32768<<8;b=g;b=Iua(b,b>>31,q,z);k=b+k|0;m=hb+l|0;m=b>>>0>k>>>0?m+1|0:m;b=Yb(e,-16777216,16776704);e=Iua(o,v,b,b>>31);l=e+k|0;b=hb+m|0;b=e>>>0>l>>>0?b+1|0:b;e=l+8388608|0;b=e>>>0<8388608?b+1|0:b;e=Sc(e,b,24);b=(e|0)/256|0;x[c>>2]=D(b,t)+x[c>>2];x[c+4>>2]=x[c+4>>2]+D(b,s);Pb(h+8|0,j,i);b=e-(g&u)|0;c=c+8|0;d=d-1|0;e=f;continue}break}b=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=b;x[a+48>>2]=e;x[a+44>>2]=f;fb=h+16|0}function Xma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,y=0,z=0,A=0;f=fb-48|0;fb=f;q=x[a+16>>2];b=0;while(1){if((b|0)!=2){i=b<<3;k=i+(f+28|0)|0;i=a+i|0;x[k+4>>2]=x[i+44>>2];x[k+8>>2]=x[i+48>>2];b=b+1|0;continue}break}r=x[a+24>>2];s=x[a+20>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;t=x[a+72>>2];n=x[a+68>>2];u=n>>31;o=x[a+64>>2];w=o>>31;k=x[a+60>>2];y=k>>31;i=x[a+8>>2];z=x[a+12>>2];while(1){if(d){e=x[f+16>>2];g=e>>>10&4194048;l=(((x[f+20>>2]&2147483647)<<1|e>>>31)&-2)+q|0;m=0;b=0;while(1){if((b|0)!=2){e=v[b+l|0];x[(f+8|0)+(b<<2)>>2]=((D(g,v[l+(b|2)|0]-e|0)|0)/16384|0)+(e<<8);b=b+1|0;continue}break}while(1){if((m|0)!=2){p=(f+8|0)+(m<<2)|0;e=x[p>>2];b=(f+28|0)+(m<<3)|0;A=x[b+8>>2];h=x[b+4>>2];x[b+8>>2]=h;l=e<<8;e=l;e=Iua(e,e>>31,k,y);g=hb;j=e;e=Yb(h,-16777216,16776704);e=Iua(o,w,e,e>>31);h=j+e|0;j=hb+g|0;j=e>>>0>h>>>0?j+1|0:j;e=Yb(A,-16777216,16776704);g=Iua(n,u,e,e>>31);h=g+h|0;e=hb+j|0;e=g>>>0>h>>>0?e+1|0:e;g=h+8388608|0;e=g>>>0<8388608?e+1|0:e;e=Sc(g,e,24);x[b+4>>2]=e-(l&t);x[p>>2]=(e|0)/256;m=m+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[f+8>>2],s);x[c+4>>2]=x[c+4>>2]+D(x[f+12>>2],r);Pb(f+16|0,i,z);c=c+8|0;d=d-1|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}fb=f+48|0}function RA(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=89;i=92;j=91;k=85;l=84;m=83;n=5;o=118;p=113;q=111;r=107;s=106;t=96;c=88;u=82;v=80;w=78;x=79;y=77;z=57;A=47;d=10;e=8;f=7;a=bs(a);a:{b:{c:{d:{switch(b-1|0){default:c=(b|0)==16777216;if(!c&(b|0)!=32){break c}Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(a,0,1),7,1),8,1),9,1),10,1),11,1),12,1),13,1),14,1),15,1),16,1),17,1),18,1),19,1),20,1),21,1),22,1),23,1),24,1),25,1),26,1),27,1),28,1),29,1),30,1),31,1),32,1),33,1),34,1),35,1),36,1),37,1),38,1),39,1),40,1),41,1),42,1),43,1),44,1),45,1),46,1),47,1),48,1),103,1),50,1),87,1),88,1),100,1),102,1),104,1),115,1),119,1),120,1);if(!c){break a}d=111;e=105;f=99;break b;case 3:Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(a,0,1),4,1),8,1),9,1),10,1),17,1),40,1),51,1),52,1),53,1),54,1),55,1),56,1),57,1),58,1),59,1),60,1),61,1),62,1),63,1),64,1),65,1),66,1);o=112;p=98;q=93;r=90;s=89;t=88;c=86;u=76;v=75;w=74;x=73;y=72;z=71;A=70;d=69;e=68;g=67;case 1:Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(a,g,1),e,1),d,1),A,1),z,1),y,1),x,1),w,1),v,1);n=u;m=c;l=t;k=s;j=r;i=q;c=p;h=o;break;case 2:break c;case 0:break d}}Lb(Lb(Lb(Lb(a,n,1),m,1),l,1),k,1);g=j;f=i;e=c;d=h}Lb(a,g,1)}Lb(Lb(Lb(a,f,1),e,1),d,1)}}function m3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=fb-2096|0;fb=d;uu(d+48|0);a:{b:{c:{if(Dp(x[(x[x[c>>2]-12>>2]+c|0)+16>>2])){a=ac(8);x[31609]=0;c=P(36,d+36|0,10469)|0;b=x[31609];x[31609]=0;if((b|0)!=1){pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break c}b=N()|0;ic(a);break c}g=oM(c);if(g){b=mM(c)}else{b=0}x[d+24>>2]=b;x[d+28>>2]=0;h=c+16|0;b=2048;d:{while(1){e:{if(!b){break e}if(!nM(x[x[x[c>>2]-12>>2]+h>>2])){break e}e=x[x[x[wj(c,(d+48|0)+f|0,b)>>2]-12>>2]+h>>2];if(Dp(e)){a=ac(8);x[31609]=0;c=P(36,d+36|0,10469)|0;b=x[31609];x[31609]=0;if((b|0)==1){break d}pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break c}f:{if(UF(e)){break f}if(!pk(e)){break f}a=ac(8);x[31609]=0;c=P(36,d+36|0,10469)|0;b=x[31609];x[31609]=0;if((b|0)!=1){pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break c}b=N()|0;ic(a);break c}e=x[c+4>>2];b=b-e|0;f=e+f|0;continue}break}b=Zb(d+16|0,d+48|0,f);c=x[b+4>>2];x[d+8>>2]=x[b>>2];x[d+12>>2]=c;a=Au(a,d+8|0,g?d+24|0:0);if(a+1>>>0>=3){a=ac(8);x[31609]=0;c=P(36,d+36|0,8057)|0;b=x[31609];x[31609]=0;if((b|0)!=1){pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}b=N()|0;tb(c);break c}b=N()|0;ic(a);break c}fb=d+2096|0;break a}b=N()|0;ic(a)}Q(b|0)}p()}return a|0}function sma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0,z=0;h=fb-16|0;fb=h;g=x[a+8>>2];j=g;e=x[a+12>>2];i=e;a:{b:{c:{d:{if((e|0)<=1&g>>>0<=805306368|(e|0)<=0){g=e;if((e|0)>-2){g=1}else{g=(g|0)>=-2&j>>>0>=3489660928}if(g){break c}if((i|0)==-2&j>>>0>2147483647|(i|0)==-1){break d}break b}if((i|0)==1&j>>>0>2147483648|i>>>0>1){break b}}l=b+196648|0;break a}l=b+131112|0;break a}l=b+262184|0}q=x[a+16>>2];b=x[a+48>>2];r=x[a+24>>2];s=x[a+20>>2];e=x[a+44>>2];g=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=g;t=x[a+72>>2];m=x[a+68>>2];u=m>>31;n=x[a+64>>2];y=n>>31;o=x[a+60>>2];z=o>>31;while(1){g=e;if(d){e=Yb(e,-16777216,16776704);f=Iua(n,y,e,e>>31);e=hb;b=Yb(b,-16777216,16776704);b=Iua(m,u,b,b>>31);f=b+f|0;e=hb+e|0;e=b>>>0>f>>>0?e+1|0:e;b=x[h+8>>2];k=f;f=x[h+12>>2]+q|0;b=(b>>>16&65520)+l|0;p=(((((((D(v[f-2|0],w[b+2>>1])+D(v[f-3|0],w[b>>1])|0)+D(v[f-1|0],w[b+4>>1])|0)+D(v[f|0],w[b+6>>1])|0)+D(v[f+1|0],w[b+8>>1])|0)+D(v[f+2|0],w[b+10>>1])|0)+D(v[f+3|0],w[b+12>>1])|0)+D(v[f+4|0],w[b+14>>1])<<8)/32768<<8;b=p;f=Iua(b,b>>31,o,z);k=k+f|0;b=hb+e|0;b=f>>>0>k>>>0?b+1|0:b;e=k+8388608|0;b=e>>>0<8388608?b+1|0:b;e=Sc(e,b,24);b=(e|0)/256|0;x[c>>2]=D(b,s)+x[c>>2];x[c+4>>2]=x[c+4>>2]+D(b,r);Pb(h+8|0,j,i);e=e-(t&p)|0;c=c+8|0;d=d-1|0;b=g;continue}break}c=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=c;x[a+48>>2]=b;x[a+44>>2]=g;fb=h+16|0}function d1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=fb-16|0;fb=f;yc(c);while(1){a:{if(!Mb(x[c>>2],x[c+8>>2],3)){break a}d=f+13|0;Rr(d,c);i=Jc(d);h=_e(d);d=y[f+13|0];if(d>>>0>=A[a+12>>2]){break a}g=md(x[a>>2],x[x[a+48>>2]+12>>2],d,b);d=y[i|0];if(d>>>0<=126){if(!(d|y[h|0])){v[g|0]=254;continue}v[g|0]=d+1;if(y[h|0]==255){continue}v[g+2|0]=1;v[g+4|0]=y[h|0];continue}b:{switch(d-127|0){case 1:v[g+1|0]=y[h|0]+1;continue;case 0:continue;default:break b}}e=v[h|0];v[f+12|0]=e;h=0;j=y[i|0];d=j&127;if(d>>>0<=23){h=y[d+24608|0]}c:{d:{e:{f:{g:{switch(d-2|0){case 0:case 8:case 9:if((e|0)>=0){break f}d=0-e&15;break e;case 1:v[f+8|0]=64;e=y[Qb(f+12|0,f+8|0)|0];if(y[g+2|0]>1){break d}v[g+4|0]=e;v[g+2|0]=1;continue;case 2:d=3;if((e|0)>=0){break c}d=0-e&127;break e;case 15:if(!e){continue}d=0-e|-16;if((e|0)<0){break e}d=e<<4|15;break e;case 16:case 20:if(!e){continue}d=(e|0)>=0;if(!d){e=0-e&15;v[f+12|0]=e;j=y[i|0]}d=d?3:2;e=((j|0)==22?-32:-16)|e;v[f+12|0]=e;break c;case 17:d=e&15|-48;break e;case 18:d=e&15|-64;break e;case 21:break g;default:break d}}d=164;if((e|0)==100){break e}x[f+8>>2]=e- -64;x[f+4>>2]=0;x[f>>2]=128;e=x[_j(f+8|0,f+4|0,f)>>2];if(!y[g+3|0]){break d}h:{switch(y[g+2|0]){case 0:case 2:break h;default:continue}}v[g+2|0]=2;v[g+4|0]=(e&254)>>>1;continue}d=e<<4}e=d;v[f+12|0]=e}d=h;if(!d){continue}}v[g+5|0]=e;v[g+3|0]=d;continue}break}fb=f+16|0}function GS(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0;f=fb-48|0;fb=f;b=Lw(f+30|0,x[a>>2]);c=iq(f+29|0,x[a+4>>2]);CY(f+32|0,z[b>>1],c);c=iq(f+28|0,x[a+8>>2]);d=z[f+32>>1];b=fb-16|0;fb=b;v[b+15|0]=y[f+34|0];AS(f+36|0,d,b+15|0,c);fb=b+16|0;c=fb-16|0;fb=c;d=fb-16|0;fb=d;h=z[f+36>>1]<<16>>16;g=y[f+38|0];b=zf(g);e=zf(2);g=zf(g);b=h-(((b|0)!=(e|0)?b>>>0<e>>>0?-1:1:0)<<24>>24<=0)|0;e=(((b|0)<0?b-399|0:b)|0)/400|0;b=D(e,-400)+b|0;b=x[vb(d+12|0,((((zf(y[f+39|0])+D(e,146097)|0)+((D(g+(g>>>0>2?-3:9)|0,153)+2>>>0)/5|0)+(b>>>2)|0)+D(b,365)|0)-((b>>>0)/100|0)|0)-719469|0)>>2];fb=d+16|0;e=x[vb(c+12|0,b)>>2];fb=c+16|0;g=vb(f+24|0,x[a+12>>2]);c=fb-16|0;fb=c;b=fb-16|0;fb=b;d=fb-16|0;fb=d;e=x[vb(d+12|0,D(e,24))>>2];fb=d+16|0;x[b+8>>2]=e;d=x[vb(b+12|0,x[g>>2]+x[b+8>>2]|0)>>2];fb=b+16|0;e=x[vb(c+12|0,d)>>2];fb=c+16|0;g=vb(f+20|0,x[a+16>>2]);c=fb-16|0;fb=c;b=fb-16|0;fb=b;d=fb-16|0;fb=d;e=x[vb(d+12|0,D(e,60))>>2];fb=d+16|0;x[b+8>>2]=e;d=x[vb(b+12|0,x[g>>2]+x[b+8>>2]|0)>>2];fb=b+16|0;b=x[vb(c+12|0,d)>>2];fb=c+16|0;c=ye(f+8|0,x[a+24>>2],x[a+28>>2]);d=fb-16|0;fb=d;a=fb-16|0;fb=a;e=fb-16|0;fb=e;b=ye(e+8|0,Iua(b,b>>31,60,0),hb);g=x[b>>2];b=x[b+4>>2];fb=e+16|0;x[a>>2]=g;x[a+4>>2]=b;b=x[a>>2];e=b+x[c>>2]|0;c=x[c+4>>2]+x[a+4>>2]|0;b=ye(a+8|0,e,b>>>0>e>>>0?c+1|0:c);c=x[b>>2];fb=a+16|0;a=ye(d+8|0,c,x[b+4>>2]);b=x[a>>2];fb=d+16|0;a=Gu(f+40|0,b,x[a+4>>2]);b=x[a>>2];fb=f+48|0;hb=x[a+4>>2];return b}function lna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,y=0,z=0,A=0,B=0,C=0;f=fb-48|0;fb=f;r=x[a+16>>2];l=kg(1,2);b=hb;s=b;Pb(a,l,b);b=0;while(1){if((b|0)!=2){g=b<<3;k=g+(f+28|0)|0;g=a+g|0;x[k+4>>2]=x[g+44>>2];x[k+8>>2]=x[g+48>>2];b=b+1|0;continue}break}t=x[a+24>>2];u=x[a+20>>2];b=x[a+4>>2];x[f+16>>2]=x[a>>2];x[f+20>>2]=b;w=x[a+72>>2];m=x[a+68>>2];y=m>>31;n=x[a+64>>2];z=n>>31;o=x[a+60>>2];A=o>>31;k=x[a+8>>2];B=x[a+12>>2];while(1){if(d){d=d-1|0;b=x[f+16>>2];g=(((x[f+20>>2]&2147483647)<<1|b>>>31)&-2)+r|0;b=0;e=0;while(1){if((e|0)!=2){x[(f+8|0)+(e<<2)>>2]=v[e+g|0]<<8;e=e+1|0;continue}break}while(1){if((b|0)!=2){p=(f+8|0)+(b<<2)|0;e=x[p>>2];g=(f+28|0)+(b<<3)|0;C=x[g+8>>2];h=x[g+4>>2];x[g+8>>2]=h;q=e<<8;e=q;e=Iua(e,e>>31,o,A);i=hb;j=e;e=Yb(h,-16777216,16776704);e=Iua(n,z,e,e>>31);h=j+e|0;j=hb+i|0;j=e>>>0>h>>>0?j+1|0:j;e=Yb(C,-16777216,16776704);i=Iua(m,y,e,e>>31);h=i+h|0;e=hb+j|0;e=h>>>0<i>>>0?e+1|0:e;i=h+8388608|0;e=i>>>0<8388608?e+1|0:e;e=Sc(i,e,24);x[g+4>>2]=e-(w&q);x[p>>2]=(e|0)/256;b=b+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[f+8>>2],u);x[c+4>>2]=x[c+4>>2]+D(t,x[f+12>>2]);Pb(f+16|0,k,B);c=c+8|0;continue}break}b=x[f+20>>2];x[a>>2]=x[f+16>>2];x[a+4>>2]=b;b=0;while(1){if((b|0)!=2){c=b<<3;d=c+a|0;c=c+(f+28|0)|0;x[d+44>>2]=x[c+4>>2];x[d+48>>2]=x[c+8>>2];b=b+1|0;continue}break}Ig(a,l,s);fb=f+48|0}function OO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;e=fb+-64|0;fb=e;g=Nb(a);a=0;c=x[b+24>>2];h=Ij(Xb(x[c+484360>>2],y[c+484376|0]));x[31609]=0;O(176,g|0,h|0);c=x[31609];x[31609]=0;a:{if((c|0)!=1){while(1){b:{if((a|0)!=(h|0)){c=x[b+24>>2];f=x[c+484344>>2];d=x[c+484348>>2];c=z[bc(x[Xb(x[c+484360>>2],y[c+484376|0])>>2],a)>>1];if(Cn(f,d,c)){x[31609]=0;d=e+40|0;O(1066,d|0,Wb(f,c)|0);c=x[31609];x[31609]=0;c:{d:{e:{if((c|0)!=1){f=x[b+24>>2];x[31609]=0;c=e+52|0;S(1053,c|0,f|0,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break e}x[31609]=0;O(178,g|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break d}tb(c);tb(d);break b}a=N()|0;break a}a=N()|0;break c}a=N()|0;tb(e+52|0)}tb(e+40|0);break a}f:{switch(c-65534|0){case 0:x[31609]=0;c=P(36,e+28|0,9256)|0;d=x[31609];x[31609]=0;g:{if((d|0)!=1){x[31609]=0;O(178,g|0,c|0);d=x[31609];x[31609]=0;if((d|0)==1){break g}tb(c);break b}a=N()|0;break a}a=N()|0;tb(c);break a;case 1:x[31609]=0;c=P(36,e+16|0,9218)|0;d=x[31609];x[31609]=0;h:{if((d|0)!=1){x[31609]=0;O(178,g|0,c|0);d=x[31609];x[31609]=0;if((d|0)==1){break h}tb(c);break b}a=N()|0;break a}a=N()|0;tb(c);break a;default:break f}}x[31609]=0;c=P(36,e+4|0,14661)|0;d=x[31609];x[31609]=0;i:{if((d|0)!=1){x[31609]=0;O(178,g|0,c|0);d=x[31609];x[31609]=0;if((d|0)==1){break i}tb(c);break b}a=N()|0;break a}a=N()|0;tb(c);break a}fb=e- -64|0;return}a=a+1|0;continue}}a=N()|0}Td(g);Q(a|0);p()}function qja(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;m=fb-32|0;fb=m;e=b;b=x[a>>2];g=D(wu(e,wb(b)),6)+b|0;a:{if(!c){break a}b=x[Ab(a)>>2];i=x[a+4>>2];if((b-i|0)/6>>>0>=c>>>0){b=c;e=(i-g|0)/6|0;if(e>>>0<c>>>0){xD(a,c-e|0,d);b=e;if((g|0)==(i|0)){break a}}n=fb-16|0;fb=n;o=x[a+4>>2];h=D((o-(D(c,6)+g|0)|0)/6|0,6)+g|0;f=Br(n+4|0,a,(i-h|0)/6|0);k=x[f+4>>2];e=h;while(1){if(e>>>0>=i>>>0){kc(f);i=fb-16|0;fb=i;j=fb-32|0;fb=j;fd(j+24|0,g,h);l=fb-16|0;fb=l;k=x[j+28>>2];f=x[j+24>>2];h=(k-f|0)/6|0;e=D(h,-6)+o|0;x[l+12>>2]=e;qR(e,f,h);rc(j+16|0,k,l+12|0);fb=l+16|0;e=rR(g,x[j+16>>2]);p=j,q=vu(o,x[j+20>>2]),x[p+12>>2]=q;rc(i+8|0,e,j+12|0);fb=j+32|0;fb=i+16|0;fb=n+16|0}else{sD(k,e);k=k+6|0;x[f+4>>2]=k;e=e+6|0;continue}break}e=g;c=D(e>>>0<=d>>>0?A[a+4>>2]>d>>>0?c:0:0,6)+d|0;while(1){if(b){a=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);v[e|0]=a;v[e+1|0]=a>>>8;v[e+2|0]=a>>>16;v[e+3|0]=a>>>24;a=y[c+4|0]|y[c+5|0]<<8;v[e+4|0]=a;v[e+5|0]=a>>>8;b=b-1|0;e=e+6|0;continue}break}break a}b=Ab(a);f=sZ(m+12|0,tD(a,Ik(x[a>>2],i)+c|0),(g-x[a>>2]|0)/6|0,b);rZ(f,c,d);h=fb-16|0;fb=h;b=x[f+4>>2];e=vb(h+12|0,g);d=vb(h+8|0,x[a>>2]);c=vb(h+4|0,x[f+4>>2]);p=f,q=oZ(x[e>>2],x[d>>2],x[c>>2]),x[p+4>>2]=q;p=f,q=pR(g,x[a+4>>2],x[f+8>>2]),x[p+8>>2]=q;Tb(a,f+4|0);Tb(a+4|0,f+8|0);Tb(Ab(a),nc(f));x[f>>2]=x[f+4>>2];fb=h+16|0;g=b;qZ(f)}wb(g);fb=m+32|0}function m8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=E(0);d=x[d+28>>2];a=fb-368|0;fb=a;x[a+360>>2]=c;x[a+364>>2]=b;Dy(a+204|0,d,a+224|0,a+220|0,a+216|0);d=Fb(a+192|0);b=Mc(d);x[31609]=0;O(46,d|0,b|0);b=x[31609];x[31609]=0;a:{b:{c:{if((b|0)!=1){c=dc(d,0);x[a+188>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;v[a+7|0]=1;v[a+6|0]=69;h=x[a+216>>2];i=x[a+220>>2];while(1){d:{x[31609]=0;b=P(1257,a+364|0,a+360|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(b){break c}g=x[a+188>>2];b=Cb(x[d+4>>2],y[d+11|0]);if((g|0)==(b+c|0)){x[31609]=0;O(46,d|0,b<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+188>>2]=b+c}x[31609]=0;b=R(1258,x[a+364>>2])|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(Cy(b,a+7|0,a+6|0,c,a+188|0,i,h,a+204|0,a+16|0,a+12|0,a+8|0,a+224|0)){break c}x[31609]=0;R(1260,a+364|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+208>>2],y[a+215|0])|!y[a+7|0]){break e}b=x[a+12>>2];if((b-(a+16|0)|0)>159){break e}x[a+12>>2]=b+4;x[b>>2]=x[a+8>>2]}j=f,k=BK(c,x[a+188>>2],e),B[j>>2]=k;Vf(a+204|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1257,a+364|0,a+360|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+364>>2];tb(d);tb(a+204|0);fb=a+368|0;break a}}b=N()|0;tb(d);tb(a+204|0);Q(b|0);p()}return b|0}function RB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a:{e=a;b:{c:{h=a+62|0;f=xb(h,b);a=v[f|0];if((a|0)==-1){break c}if((a|0)>=0){break b}a=a&127;d=bc(e+26|0,a);g=z[d>>1];if((g|0)!=65535&(b|0)!=(g|0)){break c}w[d>>1]=b;v[f|0]=a;break b}l=e+8|0;i=e+26|0;d=255;a=0;g=255;d:{while(1){if((a|0)==18){break d}j=bc(i,a);k=z[j>>1];if((k|0)!=65535){if(!(y[xb(l,a)|0]&32)){g=v[xb(h,k)|0]<0?a:g;d=a}a=a+1|0;continue}break}w[j>>1]=b;v[f|0]=a;break b}if((d&255)!=255){a=(g&255)==255?d:g;d=bc(i,a&255);m=xb(h,z[d>>1]),n=255,v[m|0]=n;w[d>>1]=b;v[f|0]=a}a=Rl(e,b)}g=a&255;if((g|0)==255){break a}if(Gj(x[e>>2])){break a}d=Vd(e+318|0,g);a=y[c+8|0]|y[c+9|0]<<8|(y[c+10|0]<<16|y[c+11|0]<<24);v[d+8|0]=a;v[d+9|0]=a>>>8;v[d+10|0]=a>>>16;v[d+11|0]=a>>>24;a=y[c+4|0]|y[c+5|0]<<8|(y[c+6|0]<<16|y[c+7|0]<<24);f=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);v[d|0]=f;v[d+1|0]=f>>>8;v[d+2|0]=f>>>16;v[d+3|0]=f>>>24;v[d+4|0]=a;v[d+5|0]=a>>>8;v[d+6|0]=a>>>16;v[d+7|0]=a>>>24;f=IU(g);h=f+3|0;a=0;while(1){if((a|0)==2){Ah(x[e>>2],x[e+4>>2],b,bv(g)|192,y[xb(c,10)|0])}else{d=a?h:f;Ah(x[e>>2],x[e+4>>2],b,(d|32)&65535,y[xb(c,a)|0]);Ah(x[e>>2],x[e+4>>2],b,(d|64)&65535,y[xb(c,a|2)|0]);Ah(x[e>>2],x[e+4>>2],b,(d|96)&65535,y[xb(c,a|4)|0]);Ah(x[e>>2],x[e+4>>2],b,(d|128)&65535,y[xb(c,a|6)|0]);Ah(x[e>>2],x[e+4>>2],b,(d|224)&65535,y[xb(c,a|8)|0]);a=a+1|0;continue}break}}}function v8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=E(0);d=x[d+28>>2];a=fb-256|0;fb=a;x[a+248>>2]=c;x[a+252>>2]=b;Hy(a+192|0,d,a+208|0,a+207|0,a+206|0);d=Fb(a+180|0);b=Mc(d);x[31609]=0;O(46,d|0,b|0);b=x[31609];x[31609]=0;a:{b:{c:{if((b|0)!=1){c=dc(d,0);x[a+176>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;v[a+7|0]=1;v[a+6|0]=69;h=v[a+206|0];i=v[a+207|0];while(1){d:{x[31609]=0;b=P(1241,a+252|0,a+248|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(b){break c}g=x[a+176>>2];b=Cb(x[d+4>>2],y[d+11|0]);if((g|0)==(b+c|0)){x[31609]=0;O(46,d|0,b<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+176>>2]=b+c}x[31609]=0;b=R(1242,x[a+252>>2])|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(Gy(b,a+7|0,a+6|0,c,a+176|0,i,h,a+192|0,a+16|0,a+12|0,a+8|0,a+208|0)){break c}x[31609]=0;R(1244,a+252|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+196>>2],y[a+203|0])|!y[a+7|0]){break e}b=x[a+12>>2];if((b-(a+16|0)|0)>159){break e}x[a+12>>2]=b+4;x[b>>2]=x[a+8>>2]}j=f,k=BK(c,x[a+176>>2],e),B[j>>2]=k;Vf(a+192|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1241,a+252|0,a+248|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+252>>2];tb(d);tb(a+192|0);fb=a+256|0;break a}}b=N()|0;tb(d);tb(a+192|0);Q(b|0);p()}return b|0}function hX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=fb-16|0;fb=f;x[a>>2]=0;x[a+4>>2]=0;Fc(a+8|0,0);d=x[b+4>>2];if(d){Vr(a,d);nn(f+8|0,x[b>>2]);$q(f,x[b>>2],x[b+4>>2]);d=x[f+8>>2];k=x[f+12>>2];e=x[f>>2];l=x[f+4>>2];j=fb-32|0;fb=j;c=x[b+4>>2];b=x[a+4>>2];c=c+b|0;x[a+4>>2]=c;a:{b:{if(!b){g=c-1|0;break b}g=c-1|0;if((g^b-1)>>>0>31){break b}h=x[a>>2];break a}h=x[a>>2];x[h+((c>>>0>=33?g>>>5|0:0)<<2)>>2]=0}xp(j+24|0,h,b);h=fb-16|0;fb=h;b=Zb(h+8|0,x[j+24>>2],x[j+28>>2]);m=fb-16|0;fb=m;n=j+8|0;g=Zb(m+8|0,x[b>>2],x[b+4>>2]);b=fb-96|0;fb=b;c=fb-16|0;fb=c;mr(c+8|0,d,k);mr(c,e,l);d=x[c+12>>2];x[b+80>>2]=x[c+8>>2];x[b+84>>2]=d;d=x[c+4>>2];x[b+88>>2]=x[c>>2];x[b+92>>2]=d;fb=c+16|0;d=x[b+84>>2];x[b+56>>2]=x[b+80>>2];x[b+60>>2]=d;k=x[b+92>>2];l=x[b+88>>2];d=b+48|0;e=Zb(b+40|0,x[g>>2],x[g+4>>2]);mn(d,x[e>>2],x[e+4>>2]);e=x[b+60>>2];x[b>>2]=x[b+56>>2];x[b+4>>2]=e;o=b- -64|0;e=fb-16|0;fb=e;while(1){i=x[b+4>>2];if(fX(x[b>>2],i,l,k)){c=fb-16|0;fb=c;i=Zb(c+8|0,x[b>>2],1<<i);i=Gb(x[x[i>>2]>>2],x[i+4>>2]);fb=c+16|0;c=e+8|0;Nt(c,x[d>>2],x[d+4>>2]);kf(c,i);zv(b);zv(d);continue}break}gX(o,x[b>>2],x[b+4>>2],d);fb=e+16|0;mr(b+32|0,x[b+64>>2],x[b+68>>2]);Zb(b+16|0,x[g>>2],x[g+4>>2]);d=b+24|0;e=Zb(b+8|0,x[b+72>>2],x[b+76>>2]);mn(d,x[e>>2],x[e+4>>2]);gX(n,x[b+32>>2],x[b+36>>2],d);fb=b+96|0;fb=m+16|0;fb=h+16|0;fb=j+32|0}fb=f+16|0;return a|0}function l8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;d=x[d+28>>2];a=fb-368|0;fb=a;x[a+360>>2]=c;x[a+364>>2]=b;Dy(a+204|0,d,a+224|0,a+220|0,a+216|0);d=Fb(a+192|0);b=Mc(d);x[31609]=0;O(46,d|0,b|0);b=x[31609];x[31609]=0;a:{b:{c:{if((b|0)!=1){c=dc(d,0);x[a+188>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;v[a+7|0]=1;v[a+6|0]=69;h=x[a+216>>2];i=x[a+220>>2];while(1){d:{x[31609]=0;b=P(1257,a+364|0,a+360|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(b){break c}g=x[a+188>>2];b=Cb(x[d+4>>2],y[d+11|0]);if((g|0)==(b+c|0)){x[31609]=0;O(46,d|0,b<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+188>>2]=b+c}x[31609]=0;b=R(1258,x[a+364>>2])|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(Cy(b,a+7|0,a+6|0,c,a+188|0,i,h,a+204|0,a+16|0,a+12|0,a+8|0,a+224|0)){break c}x[31609]=0;R(1260,a+364|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+208>>2],y[a+215|0])|!y[a+7|0]){break e}b=x[a+12>>2];if((b-(a+16|0)|0)>159){break e}x[a+12>>2]=b+4;x[b>>2]=x[a+8>>2]}j=f,k=zK(c,x[a+188>>2],e),C[j>>3]=k;Vf(a+204|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1257,a+364|0,a+360|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+364>>2];tb(d);tb(a+204|0);fb=a+368|0;break a}}b=N()|0;tb(d);tb(a+204|0);Q(b|0);p()}return b|0}function u8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;d=x[d+28>>2];a=fb-256|0;fb=a;x[a+248>>2]=c;x[a+252>>2]=b;Hy(a+192|0,d,a+208|0,a+207|0,a+206|0);d=Fb(a+180|0);b=Mc(d);x[31609]=0;O(46,d|0,b|0);b=x[31609];x[31609]=0;a:{b:{c:{if((b|0)!=1){c=dc(d,0);x[a+176>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;v[a+7|0]=1;v[a+6|0]=69;h=v[a+206|0];i=v[a+207|0];while(1){d:{x[31609]=0;b=P(1241,a+252|0,a+248|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(b){break c}g=x[a+176>>2];b=Cb(x[d+4>>2],y[d+11|0]);if((g|0)==(b+c|0)){x[31609]=0;O(46,d|0,b<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+176>>2]=b+c}x[31609]=0;b=R(1242,x[a+252>>2])|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}if(Gy(b,a+7|0,a+6|0,c,a+176|0,i,h,a+192|0,a+16|0,a+12|0,a+8|0,a+208|0)){break c}x[31609]=0;R(1244,a+252|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+196>>2],y[a+203|0])|!y[a+7|0]){break e}b=x[a+12>>2];if((b-(a+16|0)|0)>159){break e}x[a+12>>2]=b+4;x[b>>2]=x[a+8>>2]}j=f,k=zK(c,x[a+176>>2],e),C[j>>3]=k;Vf(a+192|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1241,a+252|0,a+248|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+252>>2];tb(d);tb(a+192|0);fb=a+256|0;break a}}b=N()|0;tb(d);tb(a+192|0);Q(b|0);p()}return b|0}function i7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=fb-480|0;fb=a;cd(a+476|0,x[d+28>>2]);x[31609]=0;n=R(1252,x[a+476>>2])|0;g=x[31609];x[31609]=0;a:{b:{c:{d:{e:{if((g|0)!=1){if(Cb(x[f+4>>2],y[f+11|0])){g=x[Wd(f,0)>>2];x[31609]=0;h=P(1270,n|0,45)|0;j=x[31609];x[31609]=0;if((j|0)==1){break e}o=(g|0)==(h|0)}j=Fb(a+452|0);g=Fb(a+440|0);h=Fb(a+428|0);x[31609]=0;ka(1292,c|0,o|0,x[a+476>>2],a+472|0,a+468|0,a+464|0,j|0,g|0,h|0,a+424|0);c=x[31609];x[31609]=0;if((c|0)==1){break d}x[a+4>>2]=1239;c=De(a+8|0,0,a+4|0);k=a+16|0;l=Cb(x[f+4>>2],y[f+11|0]);m=x[a+424>>2];f:{if((l|0)>(m|0)){i=((Cb(x[h+4>>2],y[h+11|0])+(l-m<<1)|0)+Cb(x[g+4>>2],y[g+11|0])|0)+1|0;break f}i=(Cb(x[h+4>>2],y[h+11|0])+Cb(x[g+4>>2],y[g+11|0])|0)+2|0}g:{i=i+m|0;if(i>>>0>=101){Qe(c,Gd(i<<2));k=x[c>>2];if(!k){break g}l=Cb(x[f+4>>2],y[f+11|0])}i=x[d+4>>2];f=Kb(f);x[31609]=0;ma(1293,k|0,a+4|0,a|0,i|0,f|0,f+(l<<2)|0,n|0,o|0,a+472|0,x[a+468>>2],x[a+464>>2],j|0,g|0,h|0,m|0);f=x[31609];x[31609]=0;if((f|0)==1){break c}x[31609]=0;b=ea(1273,b|0,k|0,x[a+4>>2],x[a>>2],d|0,e|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}Lc(c);Ub(h);Ub(g);tb(j);_b(a+476|0);fb=a+480|0;return b|0}x[31609]=0;X(1240);b=x[31609];x[31609]=0;if((b|0)==1){break c}p()}f=N()|0;break a}f=N()|0;break a}f=N()|0;break b}f=N()|0;Lc(c)}Ub(h);Ub(g);tb(j)}_b(a+476|0);Q(f|0);p()}function e7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;n=fb-16|0;fb=n;b=c;while(1){a:{if((b|0)==(d|0)){b=d;break a}if(!x[b>>2]){break a}b=b+4|0;continue}break}x[h>>2]=f;x[e>>2]=c;while(1){b:{c:{if(!((c|0)==(d|0)|(f|0)==(g|0))){q=1;r=fb-16|0;fb=r;s=rh(r+12|0,x[a+8>>2]);i=f;j=g-f|0;m=0;o=fb-16|0;fb=o;k=x[e>>2];p=b-c>>2;d:{if(!k|!p){break d}j=f?j:0;while(1){l=Jt(j>>>0<4?o+12|0:i,x[k>>2]);if((l|0)==-1){m=-1;break d}if(i){if(j>>>0<=3){if(j>>>0<l>>>0){break d}zc(i,o+12|0,l)}j=j-l|0;i=i+l|0}else{i=0}if(!x[k>>2]){k=0;break d}m=m+l|0;k=k+4|0;p=p-1|0;if(p){continue}break}}if(i){x[e>>2]=k}fb=o+16|0;qh(s);fb=r+16|0;e:{f:{g:{h:{switch(m+1|0){case 0:x[h>>2]=f;while(1){i:{if(x[e>>2]==(c|0)){break i}b=qy(f,x[c>>2],x[a+8>>2]);if((b|0)==-1){break i}f=b+x[h>>2]|0;x[h>>2]=f;c=c+4|0;continue}break};x[e>>2]=c;break g;case 1:break c;default:break h}}f=x[h>>2]+m|0;x[h>>2]=f;if((f|0)==(g|0)){break e}if((b|0)==(d|0)){c=x[e>>2];b=d;continue}b=qy(n+12|0,0,x[a+8>>2]);if((b|0)!=-1){break f}}q=2;break c}c=n+12|0;if(g-x[h>>2]>>>0<b>>>0){break c}while(1){if(b){f=y[c|0];i=x[h>>2];x[h>>2]=i+1;v[i|0]=f;b=b-1|0;c=c+1|0;continue}break}c=x[e>>2]+4|0;x[e>>2]=c;b=c;while(1){if((b|0)==(d|0)){b=d;break b}if(!x[b>>2]){break b}b=b+4|0;continue}}c=x[e>>2]}q=(c|0)!=(d|0)}fb=n+16|0;return q|0}f=x[h>>2];continue}}function uG(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=x[a>>2];e=ih(c,x[a+4>>2]);if(e>>>0<b>>>0){j=fb-32|0;fb=j;c=b-e|0;b=x[Ab(a)>>2];d=x[a+4>>2];a:{if(c>>>0<=b-d>>3>>>0){e=fb-16|0;fb=e;b=fs(e+4|0,a,c);a=x[b+4>>2];c=x[b+8>>2];while(1){if((a|0)==(c|0)){kc(b);fb=e+16|0}else{al(a);a=a+8|0;x[b+4>>2]=a;continue}break}break a}b=Ab(a);e=hs(j+12|0,is(a,ih(x[a>>2],d)+c|0),ih(x[a>>2],x[a+4>>2]),b);d=fb-16|0;fb=d;f=x[e+8>>2];b=d+4|0;x[b+8>>2]=e+8;x[b>>2]=f;x[b+4>>2]=f+(c<<3);c=x[b>>2];while(1){if(x[b+4>>2]!=(c|0)){al(c);c=x[b>>2]+8|0;x[b>>2]=c;continue}break}je(b);fb=d+16|0;h=fb-16|0;fb=h;b=vb(h+12|0,x[a+4>>2]);d=vb(h+8|0,x[a>>2]);g=x[vb(h+4|0,x[e+4>>2])>>2];i=fb-16|0;fb=i;c=fb-32|0;fb=c;fd(c+24|0,x[b>>2],x[d>>2]);k=c+16|0;b=x[c+24>>2];l=x[c+28>>2];f=fb-16|0;fb=f;x[f+8>>2]=g;x[f+12>>2]=b;while(1){if(Fd(b,l)){d=Hp(b);g=Hp(x[f+8>>2]);b=y[d+4|0]|y[d+5|0]<<8|(y[d+6|0]<<16|y[d+7|0]<<24);d=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);v[g|0]=d;v[g+1|0]=d>>>8;v[g+2|0]=d>>>16;v[g+3|0]=d>>>24;v[g+4|0]=b;v[g+5|0]=b>>>8;v[g+6|0]=b>>>16;v[g+7|0]=b>>>24;b=es(f+12|0);es(f+8|0);b=x[b>>2];continue}break}rc(k,b,f+8|0);fb=f+16|0;b=x[c+16>>2];x[c+12>>2]=x[c+20>>2];rc(i+8|0,b,c+12|0);fb=c+32|0;fb=i+16|0;x[e+4>>2]=x[i+12>>2];Tb(a,e+4|0);Tb(a+4|0,e+8|0);Tb(Ab(a),nc(e));x[e>>2]=x[e+4>>2];fb=h+16|0;gs(e)}fb=j+32|0;return}if(b>>>0<e>>>0){Jd(a,c+(b<<3)|0)}}function roa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=fb-16|0;fb=i;nd(d,32);h=i+8|0;hW(h,y[a+24|0]|y[a+25|0]<<8|(y[a+26|0]<<16|y[a+27|0]<<24),y[a+28|0]|y[a+29|0]<<8|(y[a+30|0]<<16|y[a+31|0]<<24),x[b>>2]);h=gc(h);hW(i,y[a+40|0]|y[a+41|0]<<8|(y[a+42|0]<<16|y[a+43|0]<<24),y[a+44|0]|y[a+45|0]<<8|(y[a+46|0]<<16|y[a+47|0]<<24),x[c>>2]);a=0;a:{h=x[h>>2];if(h-838861>>>0<4294128436){break a}e=x[gc(i)>>2];x[d>>2]=D(h,320);w[d+34>>1]=1;if(!Gh(d)){break a}k=h<<2;f=+(k>>>0);o=+(e>>>0)/f;p=+(h>>>0)/f;q=1/+A[d>>2];r=+A[i>>2];s=+A[i+8>>2];h=0;b:while(1){if((h|0)==(k|0)){a=1;break a}l=+(h>>>0);m=0;n=0;e=x[b+20>>2];if(le(x[b>>2],e)){f=l*p+s;c:{if(f<4294967296&f>=0){g=~~f>>>0;break c}g=0}a=g;f=f-+(a>>>0);j=z[b+34>>1];a=_d(j);g=D(g,a);d:{if(j&1){e=e+(g<<1)|0;a=z[e+(a<<1)>>1];e=z[e>>1];break d}g=e+g|0;e=y[g|0]<<8;a=y[a+g|0]<<8}n=+(e<<16>>16)*(1-f)+f*+(a<<16>>16)}e=x[c+20>>2];if(le(x[c>>2],e)){f=l*o+r;e:{if(f<4294967296&f>=0){g=~~f>>>0;break e}g=0}a=g;f=f-+(a>>>0);j=z[c+34>>1];a=_d(j);g=D(g,a);f:{if(j&1){e=e+(g<<1)|0;a=z[e+(a<<1)>>1];e=z[e>>1];break f}g=e+g|0;e=y[g|0]<<8;a=y[a+g|0]<<8}m=+(e<<16>>16)*(1-f)+f*+(a<<16>>16)}e=0;a=h;while(1)if((e|0)==80){h=h+1|0;continue b}else{f=q*+(a>>>0);t=x[d+20>>2]+(a<<1)|0,u=uC(n*(1-f)+m*f),w[t>>1]=u;a=a+k|0;e=e+1|0;continue}}}fb=i+16|0;return a|0}function p8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a=fb-336|0;fb=a;x[a+328>>2]=c;x[a+332>>2]=b;b=pj(x[d+4>>2]);i=bq(x[d+28>>2],a+208|0);aq(a+196|0,x[d+28>>2],a+324|0);d=Fb(a+184|0);c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)!=1){c=dc(d,0);x[a+180>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;while(1){d:{x[31609]=0;g=P(1257,a+332|0,a+328|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(g){break c}h=x[a+180>>2];g=Cb(x[d+4>>2],y[d+11|0]);if((h|0)==(g+c|0)){x[31609]=0;O(46,d|0,g<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+180>>2]=g+c}x[31609]=0;g=R(1258,x[a+332>>2])|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(bo(g,b,c,a+180|0,a+8|0,x[a+324>>2],x[a+200>>2],y[a+207|0],a+16|0,a+12|0,i)){break c}x[31609]=0;R(1260,a+332|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+200>>2],y[a+207|0])){break e}g=x[a+12>>2];if((g-(a+16|0)|0)>159){break e}x[a+12>>2]=g+4;x[g>>2]=x[a+8>>2]}j=f,k=GK(c,x[a+180>>2],e,b),x[j>>2]=k;x[f+4>>2]=hb;Vf(a+196|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1257,a+332|0,a+328|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+332>>2];tb(d);tb(a+196|0);fb=a+336|0;break a}}b=N()|0;tb(d);tb(a+196|0);Q(b|0);p()}return b|0}function n8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a=fb-336|0;fb=a;x[a+328>>2]=c;x[a+332>>2]=b;b=pj(x[d+4>>2]);i=bq(x[d+28>>2],a+208|0);aq(a+196|0,x[d+28>>2],a+324|0);d=Fb(a+184|0);c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)!=1){c=dc(d,0);x[a+180>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;while(1){d:{x[31609]=0;g=P(1257,a+332|0,a+328|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(g){break c}h=x[a+180>>2];g=Cb(x[d+4>>2],y[d+11|0]);if((h|0)==(g+c|0)){x[31609]=0;O(46,d|0,g<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+180>>2]=g+c}x[31609]=0;g=R(1258,x[a+332>>2])|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(bo(g,b,c,a+180|0,a+8|0,x[a+324>>2],x[a+200>>2],y[a+207|0],a+16|0,a+12|0,i)){break c}x[31609]=0;R(1260,a+332|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+200>>2],y[a+207|0])){break e}g=x[a+12>>2];if((g-(a+16|0)|0)>159){break e}x[a+12>>2]=g+4;x[g>>2]=x[a+8>>2]}j=f,k=CK(c,x[a+180>>2],e,b),x[j>>2]=k;x[f+4>>2]=hb;Vf(a+196|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1257,a+332|0,a+328|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+332>>2];tb(d);tb(a+196|0);fb=a+336|0;break a}}b=N()|0;tb(d);tb(a+196|0);Q(b|0);p()}return b|0}function m7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=fb-176|0;fb=a;cd(a+172|0,x[d+28>>2]);x[31609]=0;n=R(28,x[a+172>>2])|0;g=x[31609];x[31609]=0;a:{b:{c:{d:{e:{if((g|0)!=1){if(Cb(x[f+4>>2],y[f+11|0])){g=y[dc(f,0)|0];x[31609]=0;h=P(29,n|0,45)|0;j=x[31609];x[31609]=0;if((j|0)==1){break e}o=(h&255)==(g|0)}j=Fb(a+152|0);g=Fb(a+140|0);h=Fb(a+128|0);x[31609]=0;ka(1290,c|0,o|0,x[a+172>>2],a+168|0,a+167|0,a+166|0,j|0,g|0,h|0,a+124|0);c=x[31609];x[31609]=0;if((c|0)==1){break d}x[a+4>>2]=1239;c=De(a+8|0,0,a+4|0);k=a+16|0;l=Cb(x[f+4>>2],y[f+11|0]);m=x[a+124>>2];f:{if((l|0)>(m|0)){i=((Cb(x[h+4>>2],y[h+11|0])+(l-m<<1)|0)+Cb(x[g+4>>2],y[g+11|0])|0)+1|0;break f}i=(Cb(x[h+4>>2],y[h+11|0])+Cb(x[g+4>>2],y[g+11|0])|0)+2|0}g:{i=i+m|0;if(i>>>0>=101){Qe(c,Gd(i));k=x[c>>2];if(!k){break g}l=Cb(x[f+4>>2],y[f+11|0])}i=x[d+4>>2];f=Kb(f);x[31609]=0;ma(1291,k|0,a+4|0,a|0,i|0,f|0,f+l|0,n|0,o|0,a+168|0,v[a+167|0],v[a+166|0],j|0,g|0,h|0,m|0);f=x[31609];x[31609]=0;if((f|0)==1){break c}x[31609]=0;b=ea(23,b|0,k|0,x[a+4>>2],x[a>>2],d|0,e|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}Lc(c);tb(h);tb(g);tb(j);_b(a+172|0);fb=a+176|0;return b|0}x[31609]=0;X(1240);b=x[31609];x[31609]=0;if((b|0)==1){break c}p()}f=N()|0;break a}f=N()|0;break a}f=N()|0;break b}f=N()|0;Lc(c)}tb(h);tb(g);tb(j)}_b(a+172|0);Q(f|0);p()}function gY(a,b){var c=0;a:{b:{c:{if(oe(a,16780)){break c}if(oe(a,17547)){break c}if(oe(a,13697)){break c}if(oe(a,13822)){break c}if(!oe(a,14304)){break b}}w[b+10>>1]=4;x[b>>2]=12052;break a}d:{e:{if(oe(a,17542)){break e}if(oe(a,13702)){break e}if(!oe(a,16770)){break d}}v[b+15|0]=1;v[b+12|0]=1;x[b>>2]=8391;w[b+10>>1]=4;break a}f:{if(!oe(a,14342)){if(!oe(a,14347)){break f}}w[b+10>>1]=8;x[b>>2]=8169;break a}g:{if(!oe(a,15474)){if(!oe(a,15479)){break g}}x[b>>2]=17134;w[b+10>>1]=v[a+2|0]-48;break a}h:{if(!oe(a,25274)){if(!oe(a,25279)){break h}}x[b+4>>2]=1;x[b>>2]=16940;w[b+10>>1]=y[a|0]==56?8:4;break a}if(!(jd(a,15573,3)|(y[a+3|0]-52&255)>>>0>4)){x[b>>2]=8509;a=v[a+3|0];w[b+8>>1]=1088;w[b+10>>1]=a-48;break a}i:{j:{if(jd(a,13760,3)){if(jd(a,13879,3)){break j}}if((y[a+3|0]-52&255)>>>0>5){break j}v[b+15|0]=1;v[b+13|0]=1;x[b>>2]=8268;break i}k:{if((y[a|0]-49&255)>>>0>8){break k}if(!jd(a+1|0,13900,3)){v[b+14|0]=1;x[b>>2]=8589;w[b+10>>1]=v[a|0]-48;break a}c=y[a+2|0]|y[a+3|0]<<8;if((c|0)!=18499&(c|0)!=20035|(y[a+1|0]-48&255)>>>0>9){break k}v[b+14|0]=1;x[b>>2]=8589;w[b+10>>1]=(v[a+1|0]+D(v[a|0],10)|0)-528;break a}if(!(jd(a,13588,3)|(y[a+3|0]-49&255)>>>0>8)){x[b>>2]=8418;break i}if(oe(a,13972)){v[b+16|0]=1;w[b+10>>1]=4;break a}if(oe(a,14299)){v[b+14|0]=1;x[b>>2]=8589;w[b+10>>1]=8;a=1}else{a=0}return a}w[b+10>>1]=v[a+3|0]-48}return 1}function Bqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;a:{if((c|0)!=4){g=b+236|0;h=b+108|0;while(1){if((d|0)==120){break a}f=(d<<2)+a|0;i=xb(h,d),j=y[f+4|0]+1|0,v[i|0]=j;i=bc(g,d),j=(y[f+6|0]|y[f+7|0]<<8)+1|0,w[i>>1]=j;d=d+1|0;continue}}f=b+236|0;while(1){if((d|0)==96){break a}g=(d<<2)+a|0;i=bc(f,d+12|0),j=(y[g+6|0]|y[g+7|0]<<8)+1|0,w[i>>1]=j;d=d+1|0;continue}}$C(a+484|0,b+48|0,0,c);$C(a+590|0,b+68|0,0,c);$C(a+696|0,b+88|0,5,c);x[b>>2]=y[a+806|0]|y[a+807|0]<<8;d=v[a+808|0];b:{if((d|0)<0){v[b+34|0]=d-127;break b}if(d>>>0>16){break b}if(v[a|0]&1){v[b+31|0]=d+1;break b}if(!d){break b}v[b+31|0]=d+1}if(y[b+31|0]){c:{d:{if((c|0)==4){d=y[a+810|0];break d}d=v[a+809|0];if((d|0)>=0){w[b+28>>1]=d+1&255}d=v[a+810|0];if((d|0)<0){break c}}v[b+30|0]=d+1}v[b+33|0]=y[a+811|0]}if((c|0)==32){v[e+15|0]=y[a+812|0];v[e+14|0]=128;i=b,j=y[Qb(e+15|0,e+14|0)|0]>>>1|0,x[i+4>>2]=j}c=y[a+813|0]|y[a+814|0]<<8;if(c>>>0<=256){x[b+8>>2]=c;v[b+15|0]=y[b+15|0]|1}v[b+16|0]=y[a+815|0];v[b+26|0]=y[a+816|0];v[b+27|0]=y[a+817|0];v[b+17|0]=y[a+818|0];v[b+18|0]=y[a+819|0];w[e+12>>1]=y[a+820|0]|y[a+821|0]<<8;w[e+10>>1]=100;i=b,j=y[Oc(e+12|0,e+10|0)|0],v[i+20|0]=j;w[e+8>>1]=y[a+822|0]|y[a+823|0]<<8;w[e+6>>1]=256;i=b,j=z[Oc(e+8|0,e+6|0)>>1]>>>2|0,v[i+19|0]=j;c=y[a+824|0];dk(b,c&127,c>>>7|0);a=y[a+825|0];ck(b,a&127,a>>>7|0);fb=e+16|0}function Qoa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=fb-48|0;fb=e;nd(b,2);f=e+24|0;Mk(f,2,a+1|0);d=e+36|0;Cc(d,f);Be(b+43|0,d);tb(d);a:{b:{c:{d:{switch(y[a|0]){case 0:f=x[b+4>>2];d=x[b+8>>2];break c;case 2:break b;case 1:break d;default:break a}}d=y[a+16|0]|y[a+17|0]<<8|(y[a+18|0]<<16|y[a+19|0]<<24);x[b>>2]=d;x[e+36>>2]=y[a+20|0]|y[a+21|0]<<8|(y[a+22|0]<<16|y[a+23|0]<<24);x[e+24>>2]=d-1;d=e+36|0;f=x[Hb(d,e+24|0)>>2];x[b+4>>2]=f;x[e+36>>2]=y[a+24|0]|y[a+25|0]<<8|(y[a+26|0]<<16|y[a+27|0]<<24);d=x[Hb(d,b)>>2];x[b+8>>2]=d;w[b+34>>1]=z[b+34>>1]&65533|y[a+31|0]<<1&2}if(d>>>0>f>>>0&d>>>0>=2){break a}w[b+34>>1]=0;x[b+4>>2]=0;x[b+8>>2]=0;break a}f=e+24|0;mh(f,a+16|0);d=x[e+24>>2];x[e+36>>2]=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);mh(f,a+20|0);d=x[e+24>>2];x[e+40>>2]=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);mh(f,a+24|0);d=x[e+24>>2];d=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);x[e+44>>2]=d;x[e+16>>2]=d;d=x[e+40>>2];x[e+8>>2]=x[e+36>>2];x[e+12>>2]=d;Tk(b,1,e+8|0)}v[e+36|0]=y[a+28|0];v[e+24|0]=64;g=b,h=y[Qb(e+36|0,e+24|0)|0]<<2,w[g+30>>1]=h;d=y[a+32|0]|y[a+33|0]<<8|(y[a+34|0]<<16|y[a+35|0]<<24);x[b+24>>2]=d;b=b+24|0;e:{if(!c){break e}if(y[a|0]==2){d=d&65535;x[b>>2]=d;break e}if(A[b>>2]>=65536){x[b>>2]=65535}d=x[b>>2]}f:{g:{if(!d){a=8363;break g}a=1024;if(d>>>0>1023){break f}}x[b>>2]=a}fb=e+48|0}function sK(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a=fb-336|0;fb=a;x[a+328>>2]=c;x[a+332>>2]=b;b=pj(x[d+4>>2]);i=bq(x[d+28>>2],a+208|0);aq(a+196|0,x[d+28>>2],a+324|0);d=Fb(a+184|0);c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)!=1){c=dc(d,0);x[a+180>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;while(1){d:{x[31609]=0;g=P(1257,a+332|0,a+328|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(g){break c}h=x[a+180>>2];g=Cb(x[d+4>>2],y[d+11|0]);if((h|0)==(g+c|0)){x[31609]=0;O(46,d|0,g<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+180>>2]=g+c}x[31609]=0;g=R(1258,x[a+332>>2])|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(bo(g,b,c,a+180|0,a+8|0,x[a+324>>2],x[a+200>>2],y[a+207|0],a+16|0,a+12|0,i)){break c}x[31609]=0;R(1260,a+332|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+200>>2],y[a+207|0])){break e}g=x[a+12>>2];if((g-(a+16|0)|0)>159){break e}x[a+12>>2]=g+4;x[g>>2]=x[a+8>>2]}j=f,k=DK(c,x[a+180>>2],e,b),x[j>>2]=k;Vf(a+196|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1257,a+332|0,a+328|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+332>>2];tb(d);tb(a+196|0);fb=a+336|0;break a}}b=N()|0;tb(d);tb(a+196|0);Q(b|0);p()}return b|0}function q8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a=fb-336|0;fb=a;x[a+328>>2]=c;x[a+332>>2]=b;b=pj(x[d+4>>2]);i=bq(x[d+28>>2],a+208|0);aq(a+196|0,x[d+28>>2],a+324|0);d=Fb(a+184|0);c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)!=1){c=dc(d,0);x[a+180>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;while(1){d:{x[31609]=0;g=P(1257,a+332|0,a+328|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(g){break c}h=x[a+180>>2];g=Cb(x[d+4>>2],y[d+11|0]);if((h|0)==(g+c|0)){x[31609]=0;O(46,d|0,g<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+180>>2]=g+c}x[31609]=0;g=R(1258,x[a+332>>2])|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(bo(g,b,c,a+180|0,a+8|0,x[a+324>>2],x[a+200>>2],y[a+207|0],a+16|0,a+12|0,i)){break c}x[31609]=0;R(1260,a+332|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+200>>2],y[a+207|0])){break e}g=x[a+12>>2];if((g-(a+16|0)|0)>159){break e}x[a+12>>2]=g+4;x[g>>2]=x[a+8>>2]}j=f,k=IK(c,x[a+180>>2],e,b),x[j>>2]=k;Vf(a+196|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1257,a+332|0,a+328|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+332>>2];tb(d);tb(a+196|0);fb=a+336|0;break a}}b=N()|0;tb(d);tb(a+196|0);Q(b|0);p()}return b|0}function o8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a=fb-336|0;fb=a;x[a+328>>2]=c;x[a+332>>2]=b;b=pj(x[d+4>>2]);i=bq(x[d+28>>2],a+208|0);aq(a+196|0,x[d+28>>2],a+324|0);d=Fb(a+184|0);c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)!=1){c=dc(d,0);x[a+180>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;while(1){d:{x[31609]=0;g=P(1257,a+332|0,a+328|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(g){break c}h=x[a+180>>2];g=Cb(x[d+4>>2],y[d+11|0]);if((h|0)==(g+c|0)){x[31609]=0;O(46,d|0,g<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+180>>2]=g+c}x[31609]=0;g=R(1258,x[a+332>>2])|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(bo(g,b,c,a+180|0,a+8|0,x[a+324>>2],x[a+200>>2],y[a+207|0],a+16|0,a+12|0,i)){break c}x[31609]=0;R(1260,a+332|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+200>>2],y[a+207|0])){break e}g=x[a+12>>2];if((g-(a+16|0)|0)>159){break e}x[a+12>>2]=g+4;x[g>>2]=x[a+8>>2]}j=f,k=FK(c,x[a+180>>2],e,b),w[j>>1]=k;Vf(a+196|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1257,a+332|0,a+328|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+332>>2];tb(d);tb(a+196|0);fb=a+336|0;break a}}b=N()|0;tb(d);tb(a+196|0);Q(b|0);p()}return b|0}function KU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=fb-16|0;fb=g;c=x[a>>2];a:{if(Gj(c)){h=fb-16|0;fb=h;f=Ec(3848);c=16;while(1){d=c+f|0;x[d+16>>2]=0;x[d+20>>2]=0;x[d+36>>2]=0;v[d+42|0]=1;w[d+40>>1]=257;x[d+24>>2]=0;x[d+28>>2]=0;w[d+32>>1]=0;d=808;c=c+44|0;if((c|0)!=808){continue}break}while(1){c=d+f|0;x[c>>2]=0;x[c+4>>2]=0;x[c+68>>2]=0;x[c+72>>2]=0;x[c+24>>2]=0;x[c+28>>2]=0;w[c+20>>1]=511;x[c+16>>2]=-1;w[c+14>>1]=1;w[c+6>>1]=0;w[c+8>>1]=0;w[c+10>>1]=0;w[c+12>>1]=0;v[c+73|0]=0;v[c+74|0]=0;v[c+75|0]=0;v[c+76|0]=0;v[c+77|0]=0;v[c+78|0]=0;v[c+79|0]=0;v[c+80|0]=0;d=d+84|0;if((d|0)!=3832){continue}break}d=0;c=0;x[f+3832>>2]=0;x[f+3836>>2]=0;e=f+3837|0;v[e|0]=0;v[e+1|0]=0;v[e+2|0]=0;v[e+3|0]=0;v[e+4|0]=0;v[e+5|0]=0;v[e+6|0]=0;v[e+7|0]=0;while(1){if((c|0)==36){while(1){if((d|0)==18){b:{d=0;c=0;while(1)if((d|0)==18){while(1){if((c|0)==36){break b}Oo((D(c,84)+f|0)+808|0);c=c+1|0;continue}}else{e=(D(d,44)+f|0)+16|0;j=x[(d<<2)+27280>>2];c:{if(!(!(1<<d&3591)|d>>>0>11)){i=e;e=D(j,84)+f|0;PU(i,e+808|0,e+1060|0,e+1312|0,e+1564|0);break c}i=e;e=D(j,84)+f|0;PU(i,e+808|0,e+1060|0,0,0)}d=d+1|0;continue}}}else{x[(D(d,44)+f|0)+32>>2]=f;d=d+1|0;continue}break}OU(f,b)}else{yd((D(c,84)+f|0)+808|0,f);c=c+1|0;continue}break}b=x[yf(h+12|0,f)>>2];fb=h+16|0;x[g+12>>2]=b;b=g+12|0;vA(a,b);Hl(b);break a}OU(c,b)}JU(a);fb=g+16|0}function fJ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0;a=fb-16|0;fb=a;x[a+12>>2]=c;x[a+8>>2]=f;x[a+12>>2]=c;x[a+8>>2]=f;a:{b:{c:{while(1){c=x[a+12>>2];if(!(c>>>0>=d>>>0|f>>>0>=g>>>0)){i=v[c|0];j=i&255;d:{if((i|0)>=0){w[f>>1]=j;b=c+1|0;break d}b=2;if(i>>>0<4294967234){break b}if(i>>>0<=4294967263){if((d-c|0)<2){break c}i=y[c+1|0];if((i&192)!=128){break a}w[f>>1]=i&63|j<<6&1984;b=c+2|0;break d}if(i>>>0<=4294967279){if((d-c|0)<3){break c}k=y[c+2|0];i=y[c+1|0];e:{f:{if((j|0)!=237){if((j|0)!=224){break f}if((i&224)==160){break e}break a}if((i&224)==128){break e}break a}if((i&192)!=128){break a}}if((k&192)!=128){break a}w[f>>1]=k&63|((i&63)<<6|j<<12);b=c+3|0;break d}if(i>>>0>4294967284){break b}b=1;if((d-c|0)<4){break a}k=y[c+3|0];i=y[c+2|0];c=y[c+1|0];g:{h:{switch(j-240|0){case 0:if((c+112&255)>>>0>=48){break b}break g;case 4:if((c&240)!=128){break b}break g;default:break h}}if((c&192)!=128){break b}}if((i&192)!=128|(k&192)!=128){break b}if((g-f|0)<4){break a}b=2;j=j&7;if((c<<12&196608|j<<18)>>>0>1114111){break a}b=c<<2;w[f>>1]=(i>>>4&3|(b&192|j<<8|b&60))+16320|55296;x[a+8>>2]=f+2;w[f+2>>1]=i<<6&960|k&63|56320;b=x[a+12>>2]+4|0}x[a+12>>2]=b;f=x[a+8>>2]+2|0;x[a+8>>2]=f;continue}break}b=c>>>0<d>>>0;break a}b=1;break a}b=2}x[e>>2]=x[a+12>>2];x[h>>2]=x[a+8>>2];fb=a+16|0;return b|0}function Zta(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;h=Fb(a);a=y[b+11|0];g=x[b+4>>2];x[31609]=0;k=yh(g,a);O(110,h|0,k|0);a=x[31609];x[31609]=0;a:{b:{if((a|0)!=1){g=0;a=0;while(1){c:{if((a|0)==(k|0)){a=!f;if(!(l?a&(m^-1):a)){break c}return}e=y[dc(b,a)|0];d:{e:{f:{g:{switch(f+1|0){case 1:f=1;h:{switch(e-123|0){case 2:break h;case 0:break d;default:break f}}f=3;break d;case 2:i:{switch(e-123|0){case 2:m=1;e=g+1|0;f=0;if(d>>>0<=g>>>0){g=e;break d}x[31609]=0;O(302,h|0,Vd(c,g)|0);j=x[31609];x[31609]=0;g=e;if((j|0)!=1){break d}a=N()|0;break b;case 0:break f;default:break i}}f=-1;e=e-48&255;if(e>>>0>9){break d}l=1;f=2;i=e;break d;case 3:f=-1;j:{switch(e-123|0){case 2:f=0;if(d>>>0<=i>>>0){break d}x[31609]=0;O(302,h|0,Vd(c,i)|0);e=x[31609];x[31609]=0;if((e|0)!=1){break d}a=N()|0;break b;case 0:break d;default:break j}}e=e-48&255;if(e>>>0>9){break d}i=e+D(i,10)|0;l=1;f=2;break d;case 4:break g;case 0:break e;default:break d}}j=(e|0)!=125;f=-1;e=125;if(j){break d}}f=0;x[31609]=0;O(111,h|0,e<<24>>24);e=x[31609];x[31609]=0;if((e|0)!=1){break d}a=N()|0;break b}f=-1}a=a+1|0;continue}break}b=ac(8);x[31609]=0;a=R(96,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){x[31609]=0;S(97,a|0,40180,17);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;break b}a=N()|0;ic(b);break b}a=N()|0}tb(h);Q(a|0)}p()}function y8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=x[d+4>>2];d=x[d+28>>2];a=fb-224|0;fb=a;x[a+216>>2]=c;x[a+220>>2]=b;b=pj(g);cq(a+200|0,d,a+215|0);d=Fb(a+188|0);c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)!=1){c=dc(d,0);x[a+184>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;while(1){d:{x[31609]=0;g=P(1241,a+220|0,a+216|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(g){break c}h=x[a+184>>2];g=Cb(x[d+4>>2],y[d+11|0]);if((h|0)==(g+c|0)){x[31609]=0;O(46,d|0,g<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+184>>2]=g+c}x[31609]=0;g=R(1242,x[a+220>>2])|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(co(g,b,c,a+184|0,a+8|0,v[a+215|0],x[a+204>>2],y[a+211|0],a+16|0,a+12|0,95168)){break c}x[31609]=0;R(1244,a+220|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+204>>2],y[a+211|0])){break e}g=x[a+12>>2];if((g-(a+16|0)|0)>159){break e}x[a+12>>2]=g+4;x[g>>2]=x[a+8>>2]}i=f,j=GK(c,x[a+184>>2],e,b),x[i>>2]=j;x[f+4>>2]=hb;Vf(a+200|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1241,a+220|0,a+216|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+220>>2];tb(d);tb(a+200|0);fb=a+224|0;break a}}b=N()|0;tb(d);tb(a+200|0);Q(b|0);p()}return b|0}function w8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=x[d+4>>2];d=x[d+28>>2];a=fb-224|0;fb=a;x[a+216>>2]=c;x[a+220>>2]=b;b=pj(g);cq(a+200|0,d,a+215|0);d=Fb(a+188|0);c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)!=1){c=dc(d,0);x[a+184>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;while(1){d:{x[31609]=0;g=P(1241,a+220|0,a+216|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(g){break c}h=x[a+184>>2];g=Cb(x[d+4>>2],y[d+11|0]);if((h|0)==(g+c|0)){x[31609]=0;O(46,d|0,g<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+184>>2]=g+c}x[31609]=0;g=R(1242,x[a+220>>2])|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(co(g,b,c,a+184|0,a+8|0,v[a+215|0],x[a+204>>2],y[a+211|0],a+16|0,a+12|0,95168)){break c}x[31609]=0;R(1244,a+220|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+204>>2],y[a+211|0])){break e}g=x[a+12>>2];if((g-(a+16|0)|0)>159){break e}x[a+12>>2]=g+4;x[g>>2]=x[a+8>>2]}i=f,j=CK(c,x[a+184>>2],e,b),x[i>>2]=j;x[f+4>>2]=hb;Vf(a+200|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1241,a+220|0,a+216|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+220>>2];tb(d);tb(a+200|0);fb=a+224|0;break a}}b=N()|0;tb(d);tb(a+200|0);Q(b|0);p()}return b|0}function Mla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0;g=fb-16|0;fb=g;r=x[a+16>>2];s=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);k=x[a+8>>2];l=x[a+12>>2];h=x[a>>2];e=x[a+4>>2];m=x[a+128>>2];if(m){n=Hg(k,l,m);o=hb;b=x[a+76>>2];fg(h,e,vf(k,l,d),hb);p=hb>>>0>b>>>0?d:0}i=a+112|0;f=x[a+48>>2];t=x[a+24>>2];u=x[a+20>>2];b=x[a+44>>2];x[g>>2]=h;x[g+4>>2]=e;a:while(1){b:{q=b;if(!d){break b}d=d-1|0;x[g+8>>2]=h;x[g+12>>2]=0;p=p-1|0;b=p;n=b?n:0;o=b?o:0;h=(e<<1)+r|0;b=m;while(1)if((b|0)<=0){Pb(i,x[a+120>>2],x[a+124>>2]);b=x[a+116>>2];if(b){ce(i,w[h+(x[g+12>>2]<<1)>>1]/4<<16>>16);be(i,b);x[i>>2]=x[i>>2];x[i+4>>2]=0}v=x[a+72>>2];y=x[c>>2];h=Fg(i,s)<<8;b=h;j=b>>31;b=x[a+60>>2];b=Iua(h,j,b,b>>31);z=hb;e=b;b=x[a+64>>2];j=b;A=b>>31;b=Yb(q,-16777216,16776704);j=Iua(j,A,b,b>>31);e=e+j|0;b=hb+z|0;b=e>>>0<j>>>0?b+1|0:b;j=e;e=x[a+68>>2];f=Yb(f,-16777216,16776704);e=Iua(e,e>>31,f,f>>31);f=j+e|0;b=hb+b|0;b=e>>>0>f>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=Sc(f,b,24);f=(b|0)/256|0;x[c>>2]=D(f,u)+y;x[c+4>>2]=x[c+4>>2]+D(f,t);Pb(g,k,l);b=b-(h&v)|0;c=c+8|0;h=x[g>>2];e=x[g+4>>2];f=q;continue a}else{ce(i,w[h+(x[g+12>>2]<<1)>>1]/4<<16>>16);be(i,4);Pb(g+8|0,n,o);b=b-1|0;continue}}break}x[a>>2]=h;x[a+4>>2]=e;x[a+48>>2]=f;x[a+44>>2]=q;fb=g+16|0}function $3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;h=Fb(a);a=y[b+11|0];g=x[b+4>>2];x[31609]=0;k=yh(g,a);O(93,h|0,k|0);a=x[31609];x[31609]=0;a:{b:{if((a|0)!=1){g=0;a=0;while(1){c:{if((a|0)==(k|0)){a=!f;if(!(l?a&(m^-1):a)){break c}return}e=y[dc(b,a)|0];d:{e:{f:{g:{switch(f+1|0){case 1:f=1;h:{switch(e-123|0){case 2:break h;case 0:break d;default:break f}}f=3;break d;case 2:i:{switch(e-123|0){case 2:m=1;e=g+1|0;f=0;if(d>>>0<=g>>>0){g=e;break d}x[31609]=0;O(94,h|0,Vd(c,g)|0);j=x[31609];x[31609]=0;g=e;if((j|0)!=1){break d}a=N()|0;break b;case 0:break f;default:break i}}f=-1;e=e-48|0;if((e&255)>>>0>9){break d}l=1;f=2;i=e;break d;case 3:f=-1;j:{switch(e-123|0){case 2:f=0;if(d>>>0<=i>>>0){break d}x[31609]=0;O(94,h|0,Vd(c,i)|0);e=x[31609];x[31609]=0;if((e|0)!=1){break d}a=N()|0;break b;case 0:break d;default:break j}}if((e-48&255)>>>0>9){break d}i=(D(i,10)+e|0)-48|0;l=1;f=2;break d;case 4:break g;case 0:break e;default:break d}}j=(e|0)!=125;f=-1;e=125;if(j){break d}}f=0;x[31609]=0;O(95,h|0,e|0);e=x[31609];x[31609]=0;if((e|0)!=1){break d}a=N()|0;break b}f=-1}a=a+1|0;continue}break}b=ac(8);x[31609]=0;a=R(96,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){x[31609]=0;S(97,a|0,40180,17);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;break b}a=N()|0;ic(b);break b}a=N()|0}tb(h);Q(a|0)}p()}function hz(a){var b=0,c=0,d=0,e=0;Ke(x[a+80>>2],x[a+20>>2]);while(1){c=x[a+28>>2];if((b|0)<x[a+24>>2]){Ke(x[a+80>>2],x[c+(b<<2)>>2]);b=b+1|0;continue}break}Ke(x[a+80>>2],c);a:{if(!x[a+396>>2]){break a}c=0;while(1){if(x[a+264>>2]<=(c|0)){break a}e=x[a+396>>2]+D(c,24)|0;d=x[e+16>>2];if(d){b=0;while(1){if((b|0)<x[(x[a+124>>2]+D(y[e+13|0],2096)|0)+4>>2]){Ke(x[a+80>>2],x[(b<<2)+d>>2]);b=b+1|0;d=x[e+16>>2];continue}break}Ke(x[a+80>>2],d)}Ke(x[a+80>>2],x[e+20>>2]);c=c+1|0;continue}}d=x[a+124>>2];if(d){c=0;while(1){if((c|0)<x[a+120>>2]){b=D(c,2096)+d|0;Ke(x[a+80>>2],x[b+8>>2]);Ke(x[a+80>>2],x[b+28>>2]);Ke(x[a+80>>2],x[b+32>>2]);Ke(x[a+80>>2],x[b+2084>>2]);b=x[b+2088>>2];Ke(x[a+80>>2],b?b-4|0:0);c=c+1|0;d=x[a+124>>2];continue}break}Ke(x[a+80>>2],d)}Ke(x[a+80>>2],x[a+260>>2]);Ke(x[a+80>>2],x[a+396>>2]);c=x[a+404>>2];if(c){b=0;while(1){if((b|0)<x[a+400>>2]){Ke(x[a+80>>2],x[(D(b,40)+c|0)+4>>2]);b=b+1|0;c=x[a+404>>2];continue}break}Ke(x[a+80>>2],c)}c=0;b=0;while(1){if(!(x[a+4>>2]<=(b|0)|b>>>0>15)){d=(b<<2)+a|0;Ke(x[a+80>>2],x[d+800>>2]);Ke(x[a+80>>2],x[d+928>>2]);Ke(x[a+80>>2],x[d+996>>2]);b=b+1|0;continue}break}while(1){if((c|0)!=2){b=(c<<2)+a|0;Ke(x[a+80>>2],x[b+1068>>2]);Ke(x[a+80>>2],x[b+1076>>2]);Ke(x[a+80>>2],x[b+1084>>2]);Ke(x[a+80>>2],x[b+1092>>2]);Ke(x[a+80>>2],x[b+1100>>2]);c=c+1|0;continue}break}}function Y7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;k=fb-16|0;fb=k;l=Ry(x[g>>2]);g=Fy(x[g>>2]);sh(k+4|0,g);a:{b:{if(Ad(x[k+8>>2],y[k+15|0])){x[31609]=0;V(1263,l|0,a|0,c|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break b}g=(c-a<<2)+d|0;x[f>>2]=g;break a}x[f>>2]=d;c:{d:{j=a;h=y[j|0];switch(h-43|0){case 0:case 2:break d;default:break c}}x[31609]=0;j=P(1270,l|0,h<<24>>24)|0;h=x[31609];x[31609]=0;if((h|0)==1){break b}h=x[f>>2];x[f>>2]=h+4;x[h>>2]=j;j=a+1|0}if(!(y[j|0]!=48|(c-j|0)<2|(y[j+1|0]|32)!=120)){x[31609]=0;h=P(1270,l|0,48)|0;i=x[31609];x[31609]=0;if((i|0)==1){break b}i=x[f>>2];x[f>>2]=i+4;x[i>>2]=h;h=v[j+1|0];x[31609]=0;h=P(1270,l|0,h|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break b}i=x[f>>2];x[f>>2]=i+4;x[i>>2]=h;j=j+2|0}Em(j,c);i=0;x[31609]=0;o=R(1261,g|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}h=0;g=j;while(1){if(c>>>0<=g>>>0){ut((j-a<<2)+d|0,x[f>>2]);g=x[f>>2];break a}e:{if(!y[dc(k+4|0,h)|0]){break e}if(v[dc(k+4|0,h)|0]!=(i|0)){break e}i=x[f>>2];x[f>>2]=i+4;x[i>>2]=o;h=(Cb(x[k+8>>2],y[k+15|0])-1>>>0>h>>>0)+h|0;i=0}n=v[g|0];x[31609]=0;n=P(1270,l|0,n|0)|0;m=x[31609];x[31609]=0;if((m|0)!=1){m=x[f>>2];x[f>>2]=m+4;x[m>>2]=n;g=g+1|0;i=i+1|0;continue}break}}a=N()|0;tb(k+4|0);Q(a|0);p()}x[e>>2]=(b|0)==(c|0)?g:(b-a<<2)+d|0;tb(k+4|0);fb=k+16|0}function nsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=fb+-64|0;fb=d;b=b&4095;w[d+62>>1]=b;a:{b:{c:{d:{if(b>>>0>=81){e=((b|0)==4095?c:b-80|0)+734016|0;c=Iua(e,e>>31,1e4,0);b=hb;c=c+14780|0;b=c>>>0<14780?b+1|0:b;b=Jua(c,b,3652425,0);c=(((e+((b|0)/-4|0)|0)+D(b,-365)|0)+((b|0)/100|0)|0)+((b|0)/-400|0)|0;if((c|0)<0){b=b-1|0;c=(((e+((b|0)/-4|0)|0)+D(b,-365)|0)+((b|0)/100|0)|0)+((b|0)/-400|0)|0}e=fb-16|0;fb=e;h=d+48|0;f=uc(e+4|0,4451);Uc(h,f);tb(f);fb=e+16|0;x[31609]=0;f=(D(c,100)+52|0)/3060|0;e=f+2|0;g=(e|0)/12|0;x[d+32>>2]=g+b;b=d+36|0;O(73,b|0,d+32|0);i=x[31609];x[31609]=0;e:{f:{g:{h:{i:{j:{if((i|0)!=1){x[31609]=0;x[d+16>>2]=(e+D(g,-12)|0)+1;e=d+20|0;O(76,e|0,d+16|0);g=x[31609];x[31609]=0;if((g|0)==1){break j}x[31609]=0;x[d>>2]=(((D(f,306)+5|0)/-10|0)+c|0)+1;c=d+4|0;O(76,c|0,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break i}x[31609]=0;aa(413,a|0,h|0,b|0,e|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break h}tb(c);tb(e);tb(b);Eb(h);break d}b=N()|0;break e}b=N()|0;break f}b=N()|0;break g}b=N()|0;tb(d+4|0)}tb(d+20|0)}tb(d+36|0)}break a}b=d+48|0;gg(b,4431);x[31609]=0;c=d+36|0;O(414,c|0,d+62|0);e=x[31609];x[31609]=0;if((e|0)==1){break c}x[31609]=0;S(139,a|0,b|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}tb(c);Eb(b)}fb=d- -64|0;return}b=N()|0;break a}b=N()|0;tb(d+36|0)}Eb(d+48|0);Q(b|0);p()}function ZE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=fb-16|0;fb=h;d=x[b>>2];e=$c(d,x[b+4>>2]);a:{if(e>>>0<c>>>0){l=fb-32|0;fb=l;d=c-e|0;e=x[Ab(b)>>2];f=x[b+4>>2];b:{if(d>>>0<=e-f>>1>>>0){f=fb-16|0;fb=f;d=dj(f+4|0,b,d);e=x[d+4>>2];g=x[d+8>>2];while(1){if((e|0)==(g|0)){kc(d);fb=f+16|0}else{qp(e);e=e+2|0;x[d+4>>2]=e;continue}break}break b}e=Ab(b);e=fk(l+12|0,gk(b,$c(x[b>>2],f)+d|0),$c(x[b>>2],x[b+4>>2]),e);g=fb-16|0;fb=g;d=Ap(g+4|0,e+8|0,d);f=x[d>>2];while(1){if(x[d+4>>2]!=(f|0)){qp(f);f=x[d>>2]+2|0;x[d>>2]=f;continue}break}je(d);fb=g+16|0;i=fb-16|0;fb=i;f=vb(i+12|0,x[b+4>>2]);g=vb(i+8|0,x[b>>2]);j=x[vb(i+4|0,x[e+4>>2])>>2];k=fb-16|0;fb=k;m=k+8|0;d=fb-32|0;fb=d;fd(d+24|0,x[f>>2],x[g>>2]);n=d+16|0;g=x[d+24>>2];o=x[d+28>>2];f=fb-16|0;fb=f;x[f+8>>2]=j;x[f+12>>2]=g;while(1){if(Fd(g,o)){g=Hn(g);j=Hn(x[f+8>>2]);g=y[g|0]|y[g+1|0]<<8;v[j|0]=g;v[j+1|0]=g>>>8;g=Xk(f+12|0);Xk(f+8|0);g=x[g>>2];continue}break}rc(n,g,f+8|0);fb=f+16|0;f=x[d+16>>2];x[d+12>>2]=x[d+20>>2];rc(m,f,d+12|0);fb=d+32|0;fb=k+16|0;x[e+4>>2]=x[k+12>>2];Tb(b,e+4|0);Tb(b+4|0,e+8|0);Tb(Ab(b),nc(e));x[e>>2]=x[e+4>>2];fb=i+16|0;cj(e)}fb=l+32|0;break a}if(c>>>0<e>>>0){Jd(b,d+(c<<1)|0)}}c=Mb(x[a>>2],x[a+8>>2],c<<1);if(c){e=x[b>>2];cc(h+8|0,e,$c(e,x[b+4>>2])<<1);sd(h,a,x[h+8>>2],x[h+12>>2])}fb=h+16|0;return c|0}function gta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;h=fb-288|0;fb=h;sf(b);a:{if(!Mb(x[a>>2],x[a+8>>2],1)){break a}while(1){i=h+32|0;xl(h+8|0,i,tr(i));lc(h+20|0,x[a>>2],x[a+8>>2],x[h+8>>2],x[h+12>>2]);x[h+28>>2]=x[h+24>>2];o=h,q=c-_c(x[b+4>>2],y[b+11|0])|0,x[o+4>>2]=q;d=x[Hb(h+28|0,h+4|0)>>2];if(!d){break a}m=d+i|0;k=Hi(i,m,0);d=x[vb(h,Ef(b))>>2];f=Pj(i,k);l=fb-16|0;fb=l;j=Ak(d,zd(b));b:{c:{d:{if(!f){zd(b);break d}if(!R_(b,i)){d=i;e=Cb(x[b+4>>2],y[b+11|0]);g=Mc(b);e:{if(g-e>>>0>=f>>>0){g=Kb(b);if((e|0)==(j|0)){break e}n=g+j|0;Pi(n+f|0,n,e-j|0);break e}bn(b,g,(e+f|0)-g|0,e,j,0,f);g=x[b>>2]}f=e+f|0;lg(b,f);hd(f+g|0,0);f=g+j|0;while(1){if((d|0)!=(k|0)){hd(f,y[d|0]);d=d+1|0;f=f+1|0;continue}break}uf(zd(b),j);break d}d=i;e=l+4|0;wx(e);f:{while(1){if((d|0)==(k|0)){break f}g=v[d|0];x[31609]=0;O(115,e|0,g|0);g=x[31609];x[31609]=0;if((g|0)!=1){d=d+1|0;continue}break}Y(T(0)|0)|0;if(vd(y[e+11|0])){Db(x[e>>2])}x[31609]=0;X(84);a=x[31609];x[31609]=0;g:{if((a|0)==1){a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break g}T(0)|0;Sb()}p()}Q(a|0);p()}d=zd(e);g=Ef(e);x[31609]=0;ha(364,b|0,f|0,j|0,d|0,g|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}tb(e)}fb=l+16|0;break b}a=N()|0;tb(e);Q(a|0);p()}Vb(a,k-i|0);if(k>>>0>=m>>>0){continue}break}Vb(a,1)}fb=h+288|0}function JP(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=fb-240|0;fb=e;if(!y[126600]){if(!y[126472]){b=fb-16|0;fb=b;Fb(126448);x[31615]=0;v[126464]=0;x[31617]=0;x[31609]=0;a=ca(55)|0;c=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{if((c|0)!=1){x[b+12>>2]=a;a=b+12|0;HA(126460,ne(a));Hl(a);v[126464]=0;break f}a=ta(124540,125124)|0;c=gb;if(($(124540)|0)==(c|0)){Y(a|0)|0;x[31609]=0;X(56);b=x[31609];x[31609]=0;if((b|0)==1){break d}p()}if(($(125124)|0)!=(c|0)){break c}Y(a|0)|0;x[31609]=0;v[126464]=0;X(26);a=x[31609];x[31609]=0;if((a|0)==1){a=N()|0;break c}if(y[126464]){break e}}x[31609]=0;W(57,126444);a=x[31609];x[31609]=0;if((a|0)!=1){break e}a=N()|0;break c}fb=b+16|0;break a}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){break b}}Hl(126468);Hl(126460);tb(126448);Q(a|0);p()}T(0)|0;Sb();p()}v[126472]=1}c=fb+-64|0;fb=c;b=c+16|0;g=fb-16|0;fb=g;h=rP(g+8|0);j=e+120|0;l=c+4|0;while(1){if((i|0)==12){fb=g+16|0}else{f=fb-48|0;fb=f;a=x[h+4>>2];d=x[h>>2];g:{if((a|0)==(d|0)){break g}a=(a-d|0)+1|0;if(!a){a=lP(mP(f+12|0,32));break g}d=G(a);d=mP(f+12|0,(a<<d&2147483647?32:31)-d|0);while(1){k=lP(d);if(a>>>0<=k>>>0){continue}break}a=x[h>>2]+k|0}fb=f+48|0;m=yb(b,i),n=a,x[m>>2]=n;i=i+1|0;continue}break}b=AP(l,b,FP(b));vP(j,b);Xm(b);fb=c- -64|0;zc(126480,zc(e,j,120),116);v[126600]=1}fb=e+240|0}function z8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=x[d+4>>2];d=x[d+28>>2];a=fb-224|0;fb=a;x[a+216>>2]=c;x[a+220>>2]=b;b=pj(g);cq(a+200|0,d,a+215|0);d=Fb(a+188|0);c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)!=1){c=dc(d,0);x[a+184>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;while(1){d:{x[31609]=0;g=P(1241,a+220|0,a+216|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(g){break c}h=x[a+184>>2];g=Cb(x[d+4>>2],y[d+11|0]);if((h|0)==(g+c|0)){x[31609]=0;O(46,d|0,g<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+184>>2]=g+c}x[31609]=0;g=R(1242,x[a+220>>2])|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(co(g,b,c,a+184|0,a+8|0,v[a+215|0],x[a+204>>2],y[a+211|0],a+16|0,a+12|0,95168)){break c}x[31609]=0;R(1244,a+220|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+204>>2],y[a+211|0])){break e}g=x[a+12>>2];if((g-(a+16|0)|0)>159){break e}x[a+12>>2]=g+4;x[g>>2]=x[a+8>>2]}i=f,j=IK(c,x[a+184>>2],e,b),x[i>>2]=j;Vf(a+200|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1241,a+220|0,a+216|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+220>>2];tb(d);tb(a+200|0);fb=a+224|0;break a}}b=N()|0;tb(d);tb(a+200|0);Q(b|0);p()}return b|0}function x8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=x[d+4>>2];d=x[d+28>>2];a=fb-224|0;fb=a;x[a+216>>2]=c;x[a+220>>2]=b;b=pj(g);cq(a+200|0,d,a+215|0);d=Fb(a+188|0);c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)!=1){c=dc(d,0);x[a+184>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;while(1){d:{x[31609]=0;g=P(1241,a+220|0,a+216|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(g){break c}h=x[a+184>>2];g=Cb(x[d+4>>2],y[d+11|0]);if((h|0)==(g+c|0)){x[31609]=0;O(46,d|0,g<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+184>>2]=g+c}x[31609]=0;g=R(1242,x[a+220>>2])|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(co(g,b,c,a+184|0,a+8|0,v[a+215|0],x[a+204>>2],y[a+211|0],a+16|0,a+12|0,95168)){break c}x[31609]=0;R(1244,a+220|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+204>>2],y[a+211|0])){break e}g=x[a+12>>2];if((g-(a+16|0)|0)>159){break e}x[a+12>>2]=g+4;x[g>>2]=x[a+8>>2]}i=f,j=FK(c,x[a+184>>2],e,b),w[i>>1]=j;Vf(a+200|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1241,a+220|0,a+216|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+220>>2];tb(d);tb(a+200|0);fb=a+224|0;break a}}b=N()|0;tb(d);tb(a+200|0);Q(b|0);p()}return b|0}function EK(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=x[d+4>>2];d=x[d+28>>2];a=fb-224|0;fb=a;x[a+216>>2]=c;x[a+220>>2]=b;b=pj(g);cq(a+200|0,d,a+215|0);d=Fb(a+188|0);c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)!=1){c=dc(d,0);x[a+184>>2]=c;x[a+12>>2]=a+16;x[a+8>>2]=0;while(1){d:{x[31609]=0;g=P(1241,a+220|0,a+216|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(g){break c}h=x[a+184>>2];g=Cb(x[d+4>>2],y[d+11|0]);if((h|0)==(g+c|0)){x[31609]=0;O(46,d|0,g<<1);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=Mc(d);x[31609]=0;O(46,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}c=dc(d,0);x[a+184>>2]=g+c}x[31609]=0;g=R(1242,x[a+220>>2])|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}if(co(g,b,c,a+184|0,a+8|0,v[a+215|0],x[a+204>>2],y[a+211|0],a+16|0,a+12|0,95168)){break c}x[31609]=0;R(1244,a+220|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Cb(x[a+204>>2],y[a+211|0])){break e}g=x[a+12>>2];if((g-(a+16|0)|0)>159){break e}x[a+12>>2]=g+4;x[g>>2]=x[a+8>>2]}i=f,j=DK(c,x[a+184>>2],e,b),x[i>>2]=j;Vf(a+200|0,a+16|0,x[a+12>>2],e);x[31609]=0;b=P(1241,a+220|0,a+216|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if(b){x[e>>2]=x[e>>2]|2}b=x[a+220>>2];tb(d);tb(a+200|0);fb=a+224|0;break a}}b=N()|0;tb(d);tb(a+200|0);Q(b|0);p()}return b|0}function YI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=fb-80|0;fb=c;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if(!b){uc(a,9766);break j}f=b>>>24|0;if(!(b&65535)){d=fb-16|0;fb=d;g=c+68|0;e=uc(d+4|0,4399);Uc(g,e);tb(e);fb=d+16|0;x[31609]=0;x[c+24>>2]=f;f=c+56|0;O(87,f|0,c+24|0);d=x[31609];x[31609]=0;k:{l:{m:{n:{if((d|0)!=1){x[31609]=0;x[c+8>>2]=b>>>16&255;b=c+44|0;O(88,b|0,c+8|0);d=x[31609];x[31609]=0;if((d|0)==1){break n}x[31609]=0;V(89,a|0,g|0,f|0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break m}tb(b);tb(f);Eb(g);break j}b=N()|0;break k}b=N()|0;break l}b=N()|0;tb(c+44|0)}tb(c+56|0)}break a}d=fb-16|0;fb=d;g=c+68|0;e=uc(d+4|0,4123);Uc(g,e);tb(e);fb=d+16|0;x[31609]=0;x[c+40>>2]=f;f=c+56|0;O(87,f|0,c+40|0);d=x[31609];x[31609]=0;if((d|0)==1){break i}x[31609]=0;x[c+36>>2]=b>>>16&255;d=c+44|0;O(88,d|0,c+36|0);e=x[31609];x[31609]=0;if((e|0)==1){break h}x[31609]=0;x[c+20>>2]=b>>>8&255;e=c+24|0;O(88,e|0,c+20|0);h=x[31609];x[31609]=0;if((h|0)==1){break g}x[31609]=0;x[c+4>>2]=b&255;b=c+8|0;O(88,b|0,c+4|0);h=x[31609];x[31609]=0;if((h|0)==1){break f}x[31609]=0;ja(90,a|0,g|0,f|0,d|0,e|0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}tb(b);tb(e);tb(d);tb(f);Eb(g)}fb=c+80|0;return}b=N()|0;break a}b=N()|0;break b}b=N()|0;break c}b=N()|0;break d}b=N()|0;tb(c+8|0)}tb(c+24|0)}tb(c+44|0)}tb(c+56|0)}Eb(c+68|0);Q(b|0);p()}function xU(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0;a:{b:{switch(e<<31|e-2>>>1){case 4:DB(a,b,c,d);return;case 0:e=32-G(d|1)|0;if((e|0)<=(c-b|0)){c=b+e|0;b=c;while(1){if(d>>>0<17){while(1){b=b-1|0;v[b|0]=y[(d&1)+15515|0];e=d>>>0>1;d=d>>>1|0;if(e){continue}break}}else{b=b-4|0;$m((d<<2&60)+78560|0,4,b);d=d>>>4|0;continue}break}b=0}else{b=61}x[a+4>>2]=b;break a;case 3:e=(34-G(d|1)>>>0)/3|0;if((e|0)<=(c-b|0)){c=b+e|0;b=c;while(1){if(d>>>0<65){while(1){b=b-1|0;v[b|0]=y[(d&7)+14812|0];e=d>>>0>7;d=d>>>3|0;if(e){continue}break}}else{b=b-2|0;$m((d<<1&126)+78624|0,2,b);d=d>>>6|0;continue}break}b=0}else{b=61}x[a+4>>2]=b;break a;case 7:e=35-G(d|1)>>>2|0;if((e|0)<=(c-b|0)){c=b+e|0;b=c;while(1){if(d>>>0<257){while(1){b=b-1|0;v[b|0]=y[(d&15)+11181|0];e=d>>>0>15;d=d>>>4|0;if(e){continue}break}}else{b=b-2|0;$m((d<<1&510)+78752|0,2,b);d=d>>>8|0;continue}break}b=0}else{b=61}x[a+4>>2]=b;break a;default:break b}}g=d;i=D(e,e);k=D(i,e);j=D(i,i);c:{while(1){h=f|1;if(e>>>0>g>>>0){break c}h=f|2;if(g>>>0<i>>>0){break c}h=f|3;if(g>>>0<k>>>0){break c}if(g>>>0<j>>>0){h=f+4|0}else{f=f+4|0;g=(g>>>0)/(j>>>0)|0;continue}break}}f=h;if((f|0)>(c-b|0)){x[a+4>>2]=61;break a}f=b+f|0;c=f;while(1){c=c-1|0;b=(d>>>0)/(e>>>0)|0;v[c|0]=y[(d-D(b,e)|0)+4895|0];g=d>>>0>=e>>>0;d=b;if(g){continue}break}x[a+4>>2]=0;x[a>>2]=f;return}x[a>>2]=c}function g8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;k=fb-16|0;fb=k;l=Fw(x[g>>2]);g=Ly(x[g>>2]);sh(k+4|0,g);a:{b:{if(Ad(x[k+8>>2],y[k+15|0])){x[31609]=0;V(1249,l|0,a|0,c|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break b}g=(c-a|0)+d|0;x[f>>2]=g;break a}x[f>>2]=d;c:{d:{j=a;h=y[j|0];switch(h-43|0){case 0:case 2:break d;default:break c}}x[31609]=0;j=P(29,l|0,h<<24>>24)|0;h=x[31609];x[31609]=0;if((h|0)==1){break b}h=x[f>>2];x[f>>2]=h+1;v[h|0]=j;j=a+1|0}if(!(y[j|0]!=48|(c-j|0)<2|(y[j+1|0]|32)!=120)){x[31609]=0;h=P(29,l|0,48)|0;i=x[31609];x[31609]=0;if((i|0)==1){break b}i=x[f>>2];x[f>>2]=i+1;v[i|0]=h;h=v[j+1|0];x[31609]=0;h=P(29,l|0,h|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break b}i=x[f>>2];x[f>>2]=i+1;v[i|0]=h;j=j+2|0}Em(j,c);i=0;x[31609]=0;o=R(1247,g|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break b}h=0;g=j;while(1){if(c>>>0<=g>>>0){Em((j-a|0)+d|0,x[f>>2]);g=x[f>>2];break a}e:{if(!y[dc(k+4|0,h)|0]){break e}if(v[dc(k+4|0,h)|0]!=(i|0)){break e}i=x[f>>2];x[f>>2]=i+1;v[i|0]=o;h=(Cb(x[k+8>>2],y[k+15|0])-1>>>0>h>>>0)+h|0;i=0}n=v[g|0];x[31609]=0;n=P(29,l|0,n|0)|0;m=x[31609];x[31609]=0;if((m|0)!=1){m=x[f>>2];x[f>>2]=m+1;v[m|0]=n;g=g+1|0;i=i+1|0;continue}break}}a=N()|0;tb(k+4|0);Q(a|0);p()}x[e>>2]=(b|0)==(c|0)?g:(b-a|0)+d|0;tb(k+4|0);fb=k+16|0}function yB(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=fb-16|0;fb=h;f=x[c+656>>2];a:{if(!Lj(f)){i=x[c+704>>2];f=fb-16|0;fb=f;x[f+12>>2]=d;g=0;b:{if(!d){break b}j=x[b+480180>>2];if(j&20){e=b+1074312|0;d=Ob(e,73)?d&65535:d;if(y[b+480208|0]&16){e=Ob(e,73)?14-((9983-d>>>0)/768|0)&31:((d>>>0)/768|0)+2|0;g=x[((d>>>0)%768<<2)+32304>>2]<<6>>>e|0;break b}g=229079296/((d>>>0<=1?1:d)>>>0)|0;break b}g=227001280/(d>>>0)|0;if(yn(j)){break b}g=(d+i<<4)-133808|0;if((j|0)==64){break b}xc(f+12|0,16777215);if(j&17408){g=Bc(Kua(Iua(i?i:8363,0,3506176,0),hb,(x[f+12>>2]<<8)+e|0,0),hb);break b}if(Aj(b)){d=x[f+12>>2];i=d>>>24|0;j=d<<8;d=j+e|0;e=i+(e>>31)|0;g=((d>>>0<j>>>0?e+1|0:e)&15)<<28|d>>>4;break b}if(y[b+480208|0]&16){g=Bc(Kua(Iua(i?i:8363,0,7012352,0),hb,(x[f+12>>2]<<8)+e|0,0),hb);break b}g=Bc(Kua(-1485242368,13,(x[f+12>>2]<<8)+e|0,0),hb)}e=g;fb=f+16|0;f=x[c+656>>2];break a}e=x[c+700>>2]}x[h+12>>2]=e;c=w[c+774>>1];c:{if(!c){break c}c=f?D(v[f+33|0],c):c;if(!c){break c}e=Ye(zi(+(c|0)/393216)*+(e>>>0));x[h+12>>2]=e}d:{if(!f){break d}c=x[f+40>>2];if(!c){break d}d=(c|0)/2|0;f=x[b+1074420>>2];e=Iua(f,f>>31,e,e>>31);f=d+e|0;d=hb+(d>>31)|0;k=h,l=Gc(Jua(f,e>>>0>f>>>0?d+1|0:d,c,c>>31),hb),x[k+12>>2]=l}xc(h+12|0,2147483647);c=x[h+12>>2];b=kg(c,x[b+24620>>2]<<4);x[a+8>>2]=c;x[a>>2]=b;x[a+4>>2]=hb;fb=h+16|0}function U7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;k=b;f=fb-368|0;fb=f;v[f+364|0]=0;v[f+365|0]=0;v[f+366|0]=0;v[f+367|0]=0;v[f+361|0]=0;v[f+362|0]=0;v[f+363|0]=0;v[f+364|0]=0;v[f+360|0]=37;h=pt(f+361|0,22292,x[c+4>>2]);b=f+320|0;x[f+316>>2]=b;a=Od();a:{if(h){g=x[c+8>>2];C[f+40>>3]=e;x[f+32>>2]=g;g=ph(b,30,a,f+360|0,f+32|0);break a}C[f+48>>3]=e;g=ph(f+320|0,30,a,f+360|0,f+48|0)}x[f+80>>2]=1239;i=De(f+308|0,0,f+80|0);b=f+320|0;a=b;b:{c:{d:{e:{if((g|0)>=30){a=Od();f:{if(h){g=x[c+8>>2];C[f+8>>3]=e;x[f>>2]=g;g=kj(f+316|0,a,f+360|0,f);break f}C[f+16>>3]=e;g=kj(f+316|0,a,f+360|0,f+16|0)}if((g|0)==-1){x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)==1){break d}break e}a=x[f+316>>2];Qe(i,a)}j=a+g|0;l=lj(a,j,x[c+4>>2]);x[f+68>>2]=1239;h=De(f+72|0,0,f+68|0);g:{h:{if((f+320|0)==(a|0)){g=f+80|0;break h}g=Gd(g<<3);if(!g){x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)!=1){break e}a=N()|0;break g}Qe(h,g);b=a}a=f+60|0;cd(a,x[c+28>>2]);x[31609]=0;ga(1272,b|0,l|0,j|0,g|0,f+68|0,f- -64|0,a|0);b=x[31609];x[31609]=0;i:{if((b|0)!=1){_b(a);x[31609]=0;a=ea(1273,k|0,g|0,x[f+68>>2],x[f+64>>2],c|0,d|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break i}Lc(h);Lc(i);fb=f+368|0;break b}a=N()|0;_b(f+60|0);break g}a=N()|0}Lc(h);break c}p()}a=N()|0}Lc(i);Q(a|0);p()}return a|0}function JA(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;i=QR(b,c);a:{if(!x[b+656>>2]|!(v[i+6|0]&1)){break a}e=x[i>>2];j=a+1074312|0;f=Ob(j,31);d=Ow(x[b+656>>2],c);if(mc(x[d>>2],x[d+4>>2])){break a}f=(f^1)+e|0;g=Ob(j,31);e=y[d+12|0];b:{c:{if(!g){d:{if(!(e&2)){break d}h=y[d+14|0];k=!(x[a+480180>>2]&1048580)+z[yb(x[d>>2],h)>>1]|0;g=0;if(!(!(y[b+89|0]&8)|(!(e&4)|(h|0)!=y[d+16|0]))){g=Ob(j,70)}if(g|(f|0)!=(k|0)){break d}f=z[yb(x[d>>2],y[d+13|0])>>1]}if(!(!(y[d+12|0]&4)|y[b+89|0]&8)){a=x[d>>2];if((z[yb(a,y[d+16|0])>>1]+1|0)!=(f|0)){break b}f=z[yb(a,y[d+15|0])>>1];if(!Ob(j,93)|(c|0)!=1|y[b+89|0]&8){break b}v[i+6|0]=y[i+6|0]&254;break b}h=0;e=z[xf(x[d+4>>2])>>1];if(f>>>0>e>>>0){break c}break b}e:{f:{if(!(!(e&4)|y[b+669|0]&8)){if(z[i+4>>1]==65535){break f}if(Ob(j,97)){break f}e=y[d+12|0]}if(e&2){g=x[d>>2];e=z[yb(g,y[d+13|0])>>1];h=1;g=z[yb(g,y[d+14|0])>>1]+1|0;break e}e=z[xf(x[d+4>>2])>>1];h=f>>>0<=e>>>0;g=e;break e}g=x[d>>2];e=z[yb(g,y[d+15|0])>>1];h=1;g=z[yb(g,y[d+16|0])>>1]+1|0}e=f>>>0<g>>>0?f:e}g:{if(c|h){break g}f=x[a+480180>>2];c=x[b+88>>2];if(!(!(f&16777248)&(!(c&2048)|(f|0)==16384))){c=c|4096;x[b+88>>2]=c}if(y[xf(x[d+4>>2])+2|0]|!(z[b+786>>1]|x[a+480180>>2]&16777248)){break g}x[b+696>>2]=0;x[b+720>>2]=0;x[b+680>>2]=0;x[b+88>>2]=c|4096}f=e}l=i,m=Ob(j,31)+f|0,x[l>>2]=m}}function Nla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,y=0,z=0,A=0;g=fb-16|0;fb=g;r=x[a+16>>2];s=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);k=x[a+8>>2];l=x[a+12>>2];h=x[a>>2];e=x[a+4>>2];m=x[a+128>>2];if(m){n=Hg(k,l,m);o=hb;b=x[a+76>>2];fg(h,e,vf(k,l,d),hb);p=hb>>>0>b>>>0?d:0}i=a+112|0;f=x[a+48>>2];t=x[a+24>>2];u=x[a+20>>2];b=x[a+44>>2];x[g>>2]=h;x[g+4>>2]=e;a:while(1){b:{q=b;if(!d){break b}d=d-1|0;x[g+8>>2]=h;x[g+12>>2]=0;p=p-1|0;b=p;n=b?n:0;o=b?o:0;h=e+r|0;b=m;while(1)if((b|0)<=0){Pb(i,x[a+120>>2],x[a+124>>2]);b=x[a+116>>2];if(b){ce(i,v[h+x[g+12>>2]|0]<<6);be(i,b);x[i>>2]=x[i>>2];x[i+4>>2]=0}w=x[a+72>>2];y=x[c>>2];h=Fg(i,s)<<8;b=h;j=b>>31;b=x[a+60>>2];b=Iua(h,j,b,b>>31);z=hb;e=b;b=x[a+64>>2];j=b;A=b>>31;b=Yb(q,-16777216,16776704);j=Iua(j,A,b,b>>31);e=e+j|0;b=hb+z|0;b=e>>>0<j>>>0?b+1|0:b;j=e;e=x[a+68>>2];f=Yb(f,-16777216,16776704);e=Iua(e,e>>31,f,f>>31);f=j+e|0;b=hb+b|0;b=e>>>0>f>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=Sc(f,b,24);f=(b|0)/256|0;x[c>>2]=D(f,u)+y;x[c+4>>2]=x[c+4>>2]+D(f,t);Pb(g,k,l);b=b-(h&w)|0;c=c+8|0;h=x[g>>2];e=x[g+4>>2];f=q;continue a}else{ce(i,v[h+x[g+12>>2]|0]<<6);be(i,4);Pb(g+8|0,n,o);b=b-1|0;continue}}break}x[a>>2]=h;x[a+4>>2]=e;x[a+48>>2]=f;x[a+44>>2]=q;fb=g+16|0}function c8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;k=b;f=fb-208|0;fb=f;v[f+204|0]=0;v[f+205|0]=0;v[f+206|0]=0;v[f+207|0]=0;v[f+201|0]=0;v[f+202|0]=0;v[f+203|0]=0;v[f+204|0]=0;v[f+200|0]=37;h=pt(f+201|0,22292,x[c+4>>2]);b=f+160|0;x[f+156>>2]=b;a=Od();a:{if(h){g=x[c+8>>2];C[f+40>>3]=e;x[f+32>>2]=g;g=ph(b,30,a,f+200|0,f+32|0);break a}C[f+48>>3]=e;g=ph(f+160|0,30,a,f+200|0,f+48|0)}x[f+80>>2]=1239;i=De(f+148|0,0,f+80|0);b=f+160|0;a=b;b:{c:{d:{e:{if((g|0)>=30){a=Od();f:{if(h){g=x[c+8>>2];C[f+8>>3]=e;x[f>>2]=g;g=kj(f+156|0,a,f+200|0,f);break f}C[f+16>>3]=e;g=kj(f+156|0,a,f+200|0,f+16|0)}if((g|0)==-1){x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)==1){break d}break e}a=x[f+156>>2];Qe(i,a)}j=a+g|0;l=lj(a,j,x[c+4>>2]);x[f+68>>2]=1239;h=De(f+72|0,0,f+68|0);g:{h:{if((f+160|0)==(a|0)){g=f+80|0;break h}g=Gd(g<<1);if(!g){x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)!=1){break e}a=N()|0;break g}Qe(h,g);b=a}a=f+60|0;cd(a,x[c+28>>2]);x[31609]=0;ga(1267,b|0,l|0,j|0,g|0,f+68|0,f- -64|0,a|0);b=x[31609];x[31609]=0;i:{if((b|0)!=1){_b(a);x[31609]=0;a=ea(23,k|0,g|0,x[f+68>>2],x[f+64>>2],c|0,d|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break i}Lc(h);Lc(i);fb=f+208|0;break b}a=N()|0;_b(f+60|0);break g}a=N()|0}Lc(h);break c}p()}a=N()|0}Lc(i);Q(a|0);p()}return a|0}function ac(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=KY(a+24|0);a=h;i=a>>>0<=1?1:a;a=i;f=fb-16|0;fb=f;c=a+15&-16;a=a>>>0<c>>>0?c:a;if(!(a&15)){if(a>>>0>4294967216){a=48}else{a:{if(a>>>0>=4294967216){x[31484]=48;b=0;break a}c=a>>>0<11?16:a+11&-8;a=Gd(c+28|0);b=0;if(!a){break a}b=a-8|0;b:{if(!(a&15)){a=b;break b}g=a-4|0;j=x[g>>2];a=(a+15&-16)-8|0;a=(a-b>>>0<=15?16:0)+a|0;d=a-b|0;e=(j&-8)-d|0;if(!(j&3)){b=x[b>>2];x[a+4>>2]=e;x[a>>2]=b+d;break b}x[a+4>>2]=e|x[a+4>>2]&1|2;e=a+e|0;x[e+4>>2]=x[e+4>>2]|1;x[g>>2]=d|x[g>>2]&1|2;e=b+d|0;x[e+4>>2]=x[e+4>>2]|1;Iv(b,d)}b=x[a+4>>2];c:{if(!(b&3)){break c}d=b&-8;if(d>>>0<=c+16>>>0){break c}x[a+4>>2]=c|b&1|2;b=a+c|0;c=d-c|0;x[b+4>>2]=c|3;d=a+d|0;x[d+4>>2]=x[d+4>>2]|1;Iv(b,c)}b=a+8|0}if(b){x[f+12>>2]=b;a=0}else{a=48}}b=a?0:x[f+12>>2]}fb=f+16|0;a=b;if(!a){d:{b=0;a=x[125432];if(!a){x[125432]=501756;w[250879]=125;k=501756,l=Xx(502256),w[k>>1]=l;a=x[125432]}c=(i+3>>>2|0)+1|0;while(1){e:{if(!a|(a|0)==502256){a=0}else{d=z[a+2>>1];f=c+(c>>>0<d>>>0?d-c&3:0)|0;if(d>>>0>f>>>0){b=d-f|0;w[a+2>>1]=b;a=((b&65535)<<2)+a|0;w[a+2>>1]=f;w[a>>1]=0;a=a+4|0;break d}if(c>>>0>d>>>0){break e}c=z[a>>1];f:{if(!b){k=501728,l=Yx(c),x[k>>2]=l;break f}w[b>>1]=c}w[a>>1]=0;a=a+4|0}break d}b=a;a=Yx(z[a>>1]);continue}}}if(!a){Sb();p()}return VR(Rb(a,0,h))}function y4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;k=fb-128|0;fb=k;j=wt(c,d);x[k+4>>2]=1239;n=vt(k+8|0,k+4|0);i=k+16|0;a:{b:{c:{if(j>>>0>=101){i=Gd(j);if(!i){x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break a}Qe(n,i)}h=i;g=c;while(1)if((d|0)==(g|0)){d:while(1){g=x[a>>2];h=(g|0)==(b|0);if(j?h:1){if(h){x[f>>2]=x[f>>2]|2}break b}g=x[g>>2];x[31609]=0;s=P(1259,e|0,g|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break a}l=o+1|0;r=0;h=i;g=c;while(1){if((d|0)==(g|0)){o=l;if(!r){continue d}x[a>>2]=x[a>>2]+4;h=i;g=c;if(j+m>>>0<2){continue d}while(1){if((d|0)==(g|0)){continue d}e:{if(y[h|0]!=2){break e}if((Cb(x[g+4>>2],y[g+11|0])|0)==(o|0)){break e}v[h|0]=0;m=m-1|0}h=h+1|0;g=g+12|0;continue}}f:{if(y[h|0]!=1){break f}q=x[Wd(g,o)>>2];x[31609]=0;q=P(1259,e|0,q|0)|0;t=x[31609];x[31609]=0;if((t|0)==1){break a}g:{if((q|0)==(s|0)){r=1;if((Cb(x[g+4>>2],y[g+11|0])|0)!=(l|0)){break f}v[h|0]=2;m=m+1|0;break g}v[h|0]=0}j=j-1|0}h=h+1|0;g=g+12|0;continue}}}else{l=Ad(x[g+4>>2],y[g+11|0]);v[h|0]=l?2:1;m=m+l|0;j=j-l|0;h=h+1|0;g=g+12|0;continue}}p()}h:{i:{while(1){if((c|0)==(d|0)){break i}if(y[i|0]!=2){i=i+1|0;c=c+12|0;continue}break}d=c;break h}x[f>>2]=x[f>>2]|4}Lc(n);fb=k+128|0;return d|0}a=N()|0;Lc(n);Q(a|0);p()}function n4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;k=fb-128|0;fb=k;j=wt(c,d);x[k+4>>2]=1239;n=vt(k+8|0,k+4|0);i=k+16|0;a:{b:{c:{if(j>>>0>=101){i=Gd(j);if(!i){x[31609]=0;X(1240);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break a}Qe(n,i)}h=i;g=c;while(1)if((d|0)==(g|0)){d:while(1){g=x[a>>2];h=(g|0)==(b|0);if(j?h:1){if(h){x[f>>2]=x[f>>2]|2}break b}g=v[g|0];x[31609]=0;s=P(1243,e|0,g|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break a}l=o+1|0;r=0;h=i;g=c;while(1){if((d|0)==(g|0)){o=l;if(!r){continue d}x[a>>2]=x[a>>2]+1;h=i;g=c;if(j+m>>>0<2){continue d}while(1){if((d|0)==(g|0)){continue d}e:{if(y[h|0]!=2){break e}if((Cb(x[g+4>>2],y[g+11|0])|0)==(o|0)){break e}v[h|0]=0;m=m-1|0}h=h+1|0;g=g+12|0;continue}}f:{if(y[h|0]!=1){break f}q=v[dc(g,o)|0];x[31609]=0;q=P(1243,e|0,q|0)|0;t=x[31609];x[31609]=0;if((t|0)==1){break a}g:{if((q|0)==(s|0)){r=1;if((Cb(x[g+4>>2],y[g+11|0])|0)!=(l|0)){break f}v[h|0]=2;m=m+1|0;break g}v[h|0]=0}j=j-1|0}h=h+1|0;g=g+12|0;continue}}}else{l=Ad(x[g+4>>2],y[g+11|0]);v[h|0]=l?2:1;m=m+l|0;j=j-l|0;h=h+1|0;g=g+12|0;continue}}p()}h:{i:{while(1){if((c|0)==(d|0)){break i}if(y[i|0]!=2){i=i+1|0;c=c+12|0;continue}break}d=c;break h}x[f>>2]=x[f>>2]|4}Lc(n);fb=k+128|0;return d|0}a=N()|0;Lc(n);Q(a|0);p()}function Bna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=fb-32|0;fb=e;c=z[a+480190>>1];v[e+20|0]=0;f=c+1|0;c=e+20|0;iU(b,f,c);if(z[a+480192>>1]){g=Nb(c);m=e,n=wb(x[a+484344>>2]),x[m+16>>2]=n;l=wb(x[a+484348>>2]);while(1){f=x[e+16>>2];if(Ib(f,l)){a:{if(!Ib(x[f>>2],x[f+4>>2])){break a}c=z[a+480188>>1];x[31609]=0;v[e+4|0]=0;S(779,g|0,c|0,e+4|0);c=x[31609];x[31609]=0;if((c|0)!=1){m=e,n=wb(x[f>>2]),x[m+12>>2]=n;j=0;b:while(1){h=0;if(A[f+12>>2]<=j>>>0){break a}while(1)if(z[a+480188>>1]<=h>>>0){j=j+1|0;continue b}else{c:{c=x[e+12>>2];if(!Tc(y[c|0])){break c}d:{e:{c=y[c+1|0];if(c){d=z[a+480192>>1];break e}d=z[a+480192>>1];c=y[xb(x[g>>2],h)|0];if(c){break e}c=1;break d}m=xb(x[g>>2],h),n=c,v[m|0]=n;d=d&65535;i=d>>>0<c>>>0;d=i?d:c;c=i?1:c}i=d&65535;while(1){d=c&65535;if(d>>>0>i>>>0){break c}d=x[((d<<2)+a|0)+900380>>2];f:{if(!d){break f}d=z[bc(d+236|0,y[x[e+12>>2]]-1|0)>>1];if(d>>>0>z[a+480190>>1]){break f}k=e+4|0;Jb(k,x[b>>2],d);kf(k,1)}c=c+1|0;continue}}h=h+1|0;LC(e+12|0);continue}}}a=N()|0;ec(g);Q(a|0);p()}Vl(e+16|0);continue}else{c=z[a+480190>>1];d=0;while(1){if(c){Jb(e+4|0,x[b>>2],c);if(!Gb(x[x[e+4>>2]>>2],x[e+8>>2])){f=d;d=D(c,104)+a|0;d=f+le(x[d+484380>>2],x[d+484400>>2])|0}c=c-1|0;continue}else{ec(g)}break}}break}}fb=e+32|0;return d&65535}function SO(a){a=a|0;var b=0,c=0,d=0,e=0;e=fb-160|0;fb=e;d=Dc(e+4|0,11616);x[31609]=0;b=d+12|0;P(36,b|0,11021)|0;c=x[31609];x[31609]=0;a:{if((c|0)==1){break a}x[31609]=0;b=d+24|0;P(36,b|0,11446)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;b=d+36|0;P(36,b|0,11013)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;b=d+48|0;P(36,b|0,8243)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;b=d+60|0;P(36,b|0,10998)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;b=d+72|0;P(36,b|0,8309)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;b=d+84|0;P(36,b|0,5620)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;b=d+96|0;P(36,b|0,12020)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;b=d+108|0;P(36,b|0,11389)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;b=d+120|0;P(36,b|0,12289)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;b=d+132|0;P(36,b|0,5472)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;b=d+144|0;P(36,b|0,7335)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;U(1063,a|0,d|0,13)|0;a=x[31609];x[31609]=0;if((a|0)!=1){b=d+156|0;while(1){b=tb(b-12|0);if((d|0)!=(b|0)){continue}break}fb=e+160|0;return}b=d+156|0}a=N()|0;while(1){b=tb(b-12|0);if((d|0)!=(b|0)){continue}break}Q(a|0);p()}function gJ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0;a=fb-16|0;fb=a;x[a+12>>2]=c;x[a+8>>2]=f;x[a+12>>2]=c;x[a+8>>2]=f;c=x[a+12>>2];a:{while(1){if(c>>>0>=d>>>0){f=0;break a}b:{b=z[c>>1];c:{if(b>>>0<=127){f=1;c=x[a+8>>2];if((g-c|0)<=0){break a}x[a+8>>2]=c+1;v[c|0]=b;break c}if(b>>>0<=2047){c=x[a+8>>2];if((g-c|0)<2){break b}x[a+8>>2]=c+1;v[c|0]=b>>>6|192;c=x[a+8>>2];x[a+8>>2]=c+1;v[c|0]=b&63|128;break c}if(b>>>0<=55295){c=x[a+8>>2];if((g-c|0)<3){break b}x[a+8>>2]=c+1;v[c|0]=b>>>12|224;c=x[a+8>>2];x[a+8>>2]=c+1;v[c|0]=b>>>6&63|128;c=x[a+8>>2];x[a+8>>2]=c+1;v[c|0]=b&63|128;break c}d:{e:{if(b>>>0<=56319){f=1;if((d-c|0)<4){break a}i=z[c+2>>1];if((i&64512)!=56320){break e}if((g-x[a+8>>2]|0)<4){break a}x[a+12>>2]=c+2;c=x[a+8>>2];x[a+8>>2]=c+1;f=c;c=(b>>>6&15)+1|0;v[f|0]=c>>>2|240;f=x[a+8>>2];x[a+8>>2]=f+1;v[f|0]=c<<4&48|b>>>2&15|128;c=x[a+8>>2];x[a+8>>2]=c+1;v[c|0]=i>>>6&15|b<<4&48|128;b=x[a+8>>2];x[a+8>>2]=b+1;v[b|0]=i&63|128;break c}if(b>>>0>=57344){break d}}f=2;break a}c=x[a+8>>2];if((g-c|0)<3){break b}x[a+8>>2]=c+1;v[c|0]=b>>>12|224;c=x[a+8>>2];x[a+8>>2]=c+1;v[c|0]=b>>>6&63|128;c=x[a+8>>2];x[a+8>>2]=c+1;v[c|0]=b&63|128}c=x[a+12>>2]+2|0;x[a+12>>2]=c;continue}break}f=1}x[e>>2]=x[a+12>>2];x[h>>2]=x[a+8>>2];fb=a+16|0;return f|0}function Ara(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=fb-16|0;fb=e;i=If(a,c);ae(e,x[a+36>>2]);j=a;a:{if(!i){Qc(e,a+32|0,5);c=0;if(Gb(x[x[e>>2]>>2],x[e+4>>2])){break a}}d=fb-160|0;fb=d;f=Lm(d+48|0,x[a+36>>2]);x[31609]=0;a=P(461,d+36|0,42212)|0;c=x[31609];x[31609]=0;b:{c:{d:{e:{if((c|0)!=1){x[31609]=0;x[d+16>>2]=20054022;x[d+20>>2]=0;S(462,f|0,a|0,d+16|0);c=x[31609];x[31609]=0;if((c|0)==1){break e}Eb(a);if(!rl(y[f|0])){break d}break b}c=N()|0;break c}c=N()|0;Eb(a);break c}l=d,m=Yj(x[b>>2],x[b+4>>2]),w[l+34>>1]=m;w[d+32>>1]=65535;x[31609]=0;a=P(461,d+16|0,10121)|0;c=x[31609];x[31609]=0;f:{if((c|0)!=1){x[31609]=0;c=U(491,f|0,d+32|0,a|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break f}Eb(a);if(c){w[d+34>>1]=z[d+32>>1]}Hf(d+34|0,4e3);a=z[d+34>>1];g:{if(Yj(x[b>>2],x[b+4>>2])>>>0>=a>>>0){break g}x[31609]=0;O(223,b|0,a|0);c=x[31609];x[31609]=0;if((c|0)!=1){break g}c=N()|0;break c}c=0;h:{while(1){if((a|0)==(c|0)){break b}h=x[b>>2];x[31609]=0;g=d+4|0;O(492,g|0,c|0);k=x[31609];x[31609]=0;if((k|0)!=1){x[31609]=0;V(493,f|0,Wb(h,c)|0,g|0,494);h=x[31609];x[31609]=0;if((h|0)==1){break h}c=c+1|0;Eb(g);continue}break}c=N()|0;break c}c=N()|0;Eb(d+4|0);break c}c=N()|0;break c}c=N()|0;Eb(a)}Ch(f);Q(c|0);p()}Ch(f);fb=d+160|0;c=i}ef(j,c);fb=e+16|0}function AI(a,b){var c=0,d=0,e=0,f=0,g=0;a:{b:{c:{d:{e:{f:{c=x[a+4>>2];g:{if((c|0)!=x[a+104>>2]){x[a+4>>2]=c+1;c=y[c|0];break g}c=td(a)}switch(c-43|0){case 0:case 2:break f;default:break e}}d=(c|0)==45;f=!b;c=x[a+4>>2];h:{if((c|0)!=x[a+104>>2]){x[a+4>>2]=c+1;c=y[c|0];break h}c=td(a)}b=c-58|0;if(f|b>>>0>4294967285){break d}b=x[a+116>>2];if((b|0)>0){b=1}else{b=(b|0)>=0}if(b){break c}break a}b=c-58|0}f=d;if(b>>>0<=4294967285){if(x[a+116>>2]<0){break a}break b}i:{if(c-48>>>0>=10){break i}while(1){e=(D(e,10)+c|0)-48|0;d=(e|0)<214748364;c=x[a+4>>2];j:{if((c|0)!=x[a+104>>2]){x[a+4>>2]=c+1;c=y[c|0];break j}c=td(a)}b=c-48|0;if(d&b>>>0<=9){continue}break}g=e>>31;if(b>>>0>=10){break i}while(1){b=c;c=Iua(e,g,10,0);d=b+c|0;b=hb;e=d-48|0;d=(c>>>0>d>>>0?b+1|0:b)-(d>>>0<48)|0;g=d;d=e>>>0<2061584302&(d|0)<=21474836|(d|0)<21474836;c=x[a+4>>2];k:{if((c|0)!=x[a+104>>2]){x[a+4>>2]=c+1;c=y[c|0];break k}c=td(a)}b=c-48|0;if(d&b>>>0<=9){continue}break}if(b>>>0>=10){break i}while(1){b=x[a+4>>2];l:{if((b|0)!=x[a+104>>2]){x[a+4>>2]=b+1;b=y[b|0];break l}b=td(a)}if(b-48>>>0<10){continue}break}}b=x[a+116>>2];if((b|0)>0){b=1}else{b=(b|0)>=0}if(b){x[a+4>>2]=x[a+4>>2]-1}hb=f?0-(((e|0)!=0)+g|0)|0:g;return f?0-e|0:e}x[a+4>>2]=x[a+4>>2]-1}x[a+4>>2]=x[a+4>>2]-1}hb=-2147483648;return 0}function Ee(a,b){var c=0,d=0,e=0,f=0,g=0,h=E(0),i=0,k=0;d=(q(b),j(2));c=jI(d);a:{b:{c:{d:{e=(q(a),j(2));e:{if(e-2139095040>>>0>=2164260864){if(c){break e}break c}if(!c){break d}}h=E(1);if((e|0)==1065353216){break b}c=d<<1;if(!c){break b}i=c>>>0<4278190081;c=e<<1;a=E(a+b);if(!(i&c>>>0<=4278190080)){break a}if((c|0)==2130706432){break b}a=(d|0)<0^c>>>0<2130706432?E(0):E(b*b);break a}if(jI(e)){h=E(a*a);if((e|0)<0){h=(iI(d)|0)==1?E(-h):h}if((d|0)>=0){break b}a=Gx(E(E(1)/h));break a}if((e|0)<0){c=iI(d);if(!c){a=MI(a);break a}e=(q(a),j(2))&2147483647;i=((c|0)==1)<<16}if(e>>>0>8388607){break c}e=((q(E(a*E(8388608))),j(2))&2147483647)-192937984|0}d=e-1060306944|0;c=d>>>15&240;f=+(l(2,e-(d&-8388608)|0),r())*C[c+125168>>3]+-1;g=f*f;f=((f*.288457581109214+-.36092606229713164)*(g*g)+((f*.480898481472577+-.7213474675006291)*g+(f*1.4426950408774342+(C[c+125176>>3]+ +(d>>23)))))*+b;o(+f);c=j(1)|0;j(0)|0;f:{c=c&2147450880;if((c|0)==1079967744|c>>>0<1079967744){break f}if(f>127.99999995700433){a=BG(i);break a}if(!(f<=-150)){break f}a=$F(i);break a}k=f;g=C[160];f=g+f;g=k-(f-g);g=(C[161]*g+C[162])*(g*g)+(C[163]*g+1);o(+f);j(1)|0;e=j(0)|0;d=i+e|0;i=d<<15;d=((e&31)<<3)+1024|0;c=x[d>>2];d=x[d+4>>2]+i|0;l(0,c|0);l(1,(c>>>0>c>>>0?d+1|0:d)|0);h=E(g*+n())}a=h}return a}function BM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0;c=fb+-64|0;fb=c;d=x[a>>2];a=x[d>>2];f=x[a+4>>2];x[c+40>>2]=x[a+20>>2];g=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=g;Xf(c+48|0,c+32|0,f);a=x[d+4>>2];f=x[a+8>>2];g=x[a+4>>2];d=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=d;d=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=d;x[c+8>>2]=x[a+8>>2];d=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=d;a=fb-32|0;fb=a;a:{b:{c:{d:{k=x[c+4>>2];if(k>>>0>=g>>>0){l=x[c+20>>2];if(l>>>0<g>>>0){break d}if(f>>>0>A[c+8>>2]){break c}m=x[c+28>>2];if(f>>>0>x[c+24>>2]-m>>>0){break b}n=b+12|0;o=x[c+16>>2];q=x[c>>2];e:while(1){if((f|0)==(h|0)){break a}r=(D(h,k)<<3)+q|0;s=(D(h+m|0,l)<<1)+o|0;d=0;while(1)if((d|0)==(g|0)){h=h+1|0;continue e}else{e=yb(x[b>>2],d);i=Ge(Jg(C[(d<<3)+r>>3])*134217728);j=e;e=(x[e>>2]>>1)+wn(i)|0;t=e;e=Zt(n)+e&-4096;x[j>>2]=t-e;C[a+24>>3]=+(e|0)*7.450580596923828e-9;x[a+16>>2]=0;x[a+20>>2]=-1074790400;x[a+8>>2]=0;x[a+12>>2]=1072693248;j=(d<<1)+s|0;i=Ge(C[Yg(a+24|0,a+16|0,a+8|0)>>3]*32768);f:{if(F(i)<2147483648){e=~~i;break f}e=-2147483648}u=j,v=gd(e),w[u>>1]=v;d=d+1|0;continue}}}_(7244,9061,77,8741);p()}_(7209,9061,78,8741);p()}_(5897,9061,79,8741);p()}_(5867,9061,80,8741);p()}fb=a+32|0;fb=c- -64|0}function Yla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0;h=fb-16|0;fb=h;e=x[a+48>>2];i=x[a+40>>2];j=x[a+36>>2];f=x[a+44>>2];q=x[a+16>>2];l=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=l;r=b+24|0;s=x[a+32>>2];t=x[a+28>>2];u=x[a+72>>2];m=x[a+68>>2];v=m>>31;n=x[a+64>>2];y=n>>31;o=x[a+60>>2];z=o>>31;l=x[a+8>>2];A=x[a+12>>2];while(1){b=f;if(d){f=Yb(f,-16777216,16776704);g=Iua(n,y,f,f>>31);f=hb;e=Yb(e,-16777216,16776704);e=Iua(m,v,e,e>>31);g=e+g|0;f=hb+f|0;f=e>>>0>g>>>0?f+1|0:f;e=x[h+8>>2];k=g;g=(x[h+12>>2]<<1)+q|0;e=(((e>>>16|0)+4&131064)<<1)+r|0;p=(((((D(w[g+4>>1],w[e+10>>1])+D(w[g+2>>1],w[e+8>>1])|0)+D(w[g+6>>1],w[e+12>>1])|0)+D(w[g+8>>1],w[e+14>>1])|0)/2|0)+((((D(w[g-4>>1],w[e+2>>1])+D(w[g-6>>1],w[e>>1])|0)+D(w[g-2>>1],w[e+4>>1])|0)+D(w[g>>1],w[e+6>>1])|0)/2|0)|0)/16384<<8;e=p;g=Iua(e,e>>31,o,z);k=k+g|0;e=hb+f|0;e=g>>>0>k>>>0?e+1|0:e;f=k+8388608|0;e=f>>>0<8388608?e+1|0:e;f=Sc(f,e,24);e=(f|0)/256|0;j=j+t|0;x[c>>2]=D(e,j>>12)+x[c>>2];i=i+s|0;x[c+4>>2]=x[c+4>>2]+D(i>>12,e);Pb(h+8|0,l,A);f=f-(u&p)|0;c=c+8|0;d=d-1|0;e=b;continue}break}c=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=c;x[a+40>>2]=i;x[a+20>>2]=j>>12;x[a+36>>2]=j;x[a+48>>2]=e;x[a+44>>2]=b;x[a+24>>2]=i>>12;fb=h+16|0}function JL(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=E(0),k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=E(0);d=(b<<2)+a|0;h=d+1068|0;k=c<<1&-4;p=h,q=ue(a,k),x[p>>2]=q;g=d+1076|0;p=g,q=ue(a,k),x[p>>2]=q;i=ue(a,c&-4);x[d+1084>>2]=i;a:{h=x[h>>2];if(!h){break a}g=x[g>>2];if(!g|!i){break a}d=c>>2;o=(d|0)>0?d:0;j=E(c|0);d=0;while(1){if((e|0)==(o|0)){d=0;e=c>>3;h=(e|0)>0?e:0;e=0;while(1){if((d|0)!=(h|0)){g=e|1;f=+E(E(E(g<<1)*E(3.1415927410125732))/j);p=i+(e<<2)|0,r=E(hf(f)),B[p>>2]=r;p=i+(g<<2)|0,r=E(-E(Ri(f))),B[p>>2]=r;e=e+2|0;d=d+1|0;continue}break}}else{l=d<<2;f=+E(E(E(e<<2)*E(3.1415927410125732))/j);p=h+l|0,r=E(hf(f)),B[p>>2]=r;m=d|1;n=m<<2;p=h+n|0,r=E(-E(Ri(f))),B[p>>2]=r;f=+E(E(E(E(m|0)*E(3.1415927410125732))/j)*E(.5));p=g+l|0,r=E(E(hf(f))*E(.5)),B[p>>2]=r;p=g+n|0,r=E(E(Ri(f))*E(.5)),B[p>>2]=r;d=d+2|0;e=e+1|0;continue}break}i=(b<<2)+a|0;d=ue(a,k);x[i+1092>>2]=d;if(!d){break a}b=0;e=c>>1;k=(e|0)>0?e:0;f=+(e|0);while(1){if((b|0)!=(k|0)){j=E(Ri((+(b|0)+.5)/f*.5*3.1415927410125732));p=d+(b<<2)|0,r=E(Ri(+E(j*j)*1.5707963705062866)),B[p>>2]=r;b=b+1|0;continue}break}b=ue(a,c>>2&-2);x[i+1100>>2]=b;if(!b){break a}a=0;d=c>>3;d=(d|0)>0?d:0;c=36-Km(c)|0;while(1){if((a|0)!=(d|0)){p=b+(a<<1)|0,q=Im(a)>>>c<<2,w[p>>1]=q;a=a+1|0;continue}break}return 1}fc(a,3);return 0}function Jj(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;a:{if(!le(x[a>>2],x[a+20>>2])){break a}Vk(a);b:{switch(Kn(z[a+34>>1])-1|0){case 1:h=fb-48|0;fb=h;g=x[a+20>>2];d=x[a>>2];c=_d(z[a+34>>1]);e=g+(D(d,c)<<1)|0;while(1){c:{d:{if((f|0)!=16){j=e+(D(c,f)<<1)|0;k=g+(D(c,f^-1)<<1)|0;d=0;break d}f=e+(c<<5)|0;d=z[a+34>>1];if(d&2){e=x[a+4>>2];i=x[a+8>>2]-e|0;hV(h+28|0,f,g+(D(c,e)<<1)|0,i,c,(d&4)>>>2|0,Ob(b+1074312|0,33));d=z[a+34>>1]}if(d&8){e=x[a+16>>2];a=x[a+12>>2];e=e-a|0;hV(h+8|0,f+(c<<7)|0,g+(D(a,c)<<1)|0,e,c,(d&16)>>>4|0,Ob(b+1074312|0,33))}fb=h+48|0;break c}while(1){if((c|0)!=(d|0)){i=d<<1;w[i+j>>1]=z[e+(d-c<<1)>>1];w[i+k>>1]=z[g+i>>1];d=d+1|0;continue}break}f=f+1|0;continue}break};return;case 0:break b;default:break a}}h=fb-48|0;fb=h;g=x[a+20>>2];c=x[a>>2];d=_d(z[a+34>>1]);e=g+D(c,d)|0;while(1){e:{f:{if((f|0)!=16){i=e+D(d,f)|0;j=g+D(d,f^-1)|0;c=0;break f}f=e+(d<<4)|0;c=z[a+34>>1];if(c&2){e=x[a+4>>2];i=x[a+8>>2]-e|0;gV(h+28|0,f,g+D(d,e)|0,i,d,(c&4)>>>2|0,Ob(b+1074312|0,33));c=z[a+34>>1]}if(c&8){e=x[a+16>>2];a=x[a+12>>2];e=e-a|0;gV(h+8|0,f+(d<<6)|0,g+D(a,d)|0,e,d,(c&16)>>>4|0,Ob(b+1074312|0,33))}fb=h+48|0;break e}while(1){if((c|0)!=(d|0)){v[c+i|0]=y[e+(c-d|0)|0];v[c+j|0]=y[c+g|0];c=c+1|0;continue}break}f=f+1|0;continue}break}}}function qN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;i=fb-16|0;fb=i;g=x[a+32>>2];f=pq(g);if(!f){f=oq(g)}a:{b:{c:{if(b>>>0>=f>>>0){b=ac(8);x[31609]=0;c=P(36,i+4|0,6e3)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}pc(b,c);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(c);break b}if(c>>>0>=120){b=ac(8);x[31609]=0;c=P(36,i+4|0,11334)|0;a=x[31609];x[31609]=0;if((a|0)!=1){pc(b,c);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(c);break b}a=N()|0;ic(b);break b}f=eB(g,65535);j=(f|0)==65535?255:f;w[i+4>>1]=j;f=g+D(j,872)|0;h=f+1074992|0;Po(h,g,65535,1024);c=c+1|0;v[f+1075794|0]=c;v[f+1075791|0]=c;w[f+1075778>>1]=0;Zm(h);Ko(x[a+32>>2],h,b+1|0,0,1,1);x[f+1075688>>2]=65536;Su(x[a+32>>2],h,c,0,1,1,65535);l=f+1075684|0,m=Ui(Zv(e*128,-128,128)+128),x[l>>2]=m;l=f+1075680|0,m=Ui(Zv(d*256,0,256)),x[l>>2]=m;d:{b=x[a+32>>2];h=b+1074478|0;c=h;c=c+(z[b+480212>>1]<<1)|0;g=z[i+4>>1];b=VX(h,c,g);if((b|0)==(c|0)){break d}f=b;while(1){while(1){f=f+2|0;if((f|0)==(c|0)){c=b;break d}k=z[f>>1];if((k|0)==(g|0)){continue}break}w[b>>1]=k;b=b+2|0;g=z[i+4>>1];continue}}l=x[a+32>>2],m=TT(h,c),w[l+480212>>1]=m;fb=i+16|0;return j|0}a=N()|0;ic(b)}Q(a|0)}p()}function Pla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=fb-16|0;fb=f;s=x[a+16>>2];t=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);k=x[a+8>>2];l=x[a+12>>2];b=x[a>>2];g=x[a+4>>2];m=x[a+128>>2];if(m){n=Hg(k,l,m);o=hb;h=x[a+76>>2];fg(b,g,vf(k,l,d),hb);p=hb>>>0>h>>>0?d:0}h=a+112|0;i=x[a+40>>2];j=x[a+36>>2];x[f>>2]=b;x[f+4>>2]=g;while(1){if(d){d=d-1|0;x[f+8>>2]=b;x[f+12>>2]=0;p=p-1|0;e=p;n=e?n:0;o=e?o:0;r=(((g&2147483647)<<1|b>>>31)&-2)+s|0;g=m;a:{b:while(1){c:{if((g|0)<=0){Pb(h,x[a+120>>2],x[a+124>>2]);g=x[a+116>>2];if(!g){break a}e=x[f+8>>2];q=((x[f+12>>2]&2147483647)<<1|e>>>31)&-2;e=0;b=0;break c}e=x[f+8>>2];q=((x[f+12>>2]&2147483647)<<1|e>>>31)&-2;b=0;e=0;while(1)if((b|0)==2){ce(h,e>>>3<<16>>16);be(h,4);Pb(f+8|0,n,o);g=g-1|0;continue b}else{e=(v[(b|q)+r|0]<<8)+e|0;b=b+1|0;continue}}break}while(1){if((b|0)!=2){e=(v[(b|q)+r|0]<<8)+e|0;b=b+1|0;continue}break}ce(h,e>>>3<<16>>16);be(h,g);x[h>>2]=x[h>>2];x[h+4>>2]=0}g=x[a+32>>2];e=x[c>>2];b=Fg(h,t);j=x[a+28>>2]+j|0;x[c>>2]=D(b,j>>12)+e;i=g+i|0;x[c+4>>2]=x[c+4>>2]+D(b,i>>12);Pb(f,k,l);c=c+8|0;b=x[f>>2];g=x[f+4>>2];continue}break}x[a>>2]=b;x[a+4>>2]=g;x[a+40>>2]=i;x[a+20>>2]=j>>12;x[a+36>>2]=j;x[a+24>>2]=i>>12;fb=f+16|0}function HM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;c=fb+-64|0;fb=c;d=x[a>>2];a=x[d>>2];f=x[a+4>>2];x[c+40>>2]=x[a+20>>2];g=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=g;Xf(c+48|0,c+32|0,f);a=x[d+4>>2];f=x[a+8>>2];g=x[a+4>>2];d=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=d;d=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=d;x[c+8>>2]=x[a+8>>2];d=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=d;a=fb-32|0;fb=a;a:{b:{c:{d:{k=x[c+4>>2];if(k>>>0>=g>>>0){if(A[c+20>>2]<g>>>0){break d}if(f>>>0>A[c+8>>2]){break c}l=x[c+28>>2];if(f>>>0>x[c+24>>2]-l>>>0){break b}m=b+12|0;n=x[c+16>>2];o=x[c>>2];e:while(1){if((f|0)==(h|0)){break a}q=(D(h,k)<<3)+o|0;d=0;while(1)if((d|0)==(g|0)){h=h+1|0;continue e}else{e=yb(x[b>>2],d);i=Ge(Jg(C[(d<<3)+q>>3])*134217728);j=e;e=(x[e>>2]>>1)+wn(i)|0;r=e;e=Zt(m)+e&-4096;x[j>>2]=r-e;C[a+24>>3]=+(e|0)*7.450580596923828e-9;x[a+16>>2]=0;x[a+20>>2]=-1074790400;x[a+8>>2]=0;x[a+12>>2]=1072693248;j=(d<<2)+n|0;i=Ge(C[Yg(a+24|0,a+16|0,a+8|0)>>3]*32768);f:{if(F(i)<2147483648){e=~~i;break f}e=-2147483648}s=(x[j>>2]+(l<<1)|0)+(h<<1)|0,t=gd(e),w[s>>1]=t;d=d+1|0;continue}}}_(7244,9061,77,8741);p()}_(7209,9061,78,8741);p()}_(5897,9061,79,8741);p()}_(5867,9061,80,8741);p()}fb=a+32|0;fb=c- -64|0}function E1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;g=fb-1088|0;fb=g;e=_h(a);Rb(e+20|0,0,1040);x[e+1064>>2]=0;x[e+1068>>2]=0;x[e+1060>>2]=c;v[e+1084|0]=d;a=e+1072|0;x[a>>2]=0;x[a+4>>2]=0;x[e+1080>>2]=0;i=e+1064|0;a=c;d=0;a:{b:{c:while(1){if(_d(z[a+34>>1])>>>0<=d>>>0){break a}x[e+1064>>2]=0;x[e+1068>>2]=0;a=0;while(1){d:{e:{f:{g:{h:{i:{j:{if(A[c>>2]<=a>>>0){break j}a=x[b+8>>2];f=x[b>>2];x[31609]=0;a=U(150,f|0,a|0,2)|0;f=x[31609];x[31609]=0;if((f|0)==1){break i}if(!a){break j}x[31609]=0;a=R(189,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break h}if(!a){break e}x[31609]=0;f=g+8|0;S(185,f|0,b|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break g}a=ls(g+28|0,f);h=kd(e,a);zc(h+20|0,a+20|0,1040);ub(a);ub(f);x[e+1076>>2]=0;x[e+1080>>2]=0;f=x[e+1060>>2];a=x[f+20>>2];if(Kn(z[f+34>>1])>>>0>=2){x[31609]=0;O(190,h|0,a+(d<<1)|0);a=x[31609];x[31609]=0;if((a|0)!=1){break e}break f}x[31609]=0;O(191,h|0,a+d|0);a=x[31609];x[31609]=0;if((a|0)==1){break f}break e}d=d+1|0;a=x[e+1060>>2];continue c}a=N()|0;break b}a=N()|0;break b}a=N()|0;break b}a=T(28816)|0;if((gb|0)!=($(28816)|0)){break b}Y(a|0)|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)==1){break d}}a=x[i>>2];continue}break}break}a=N()|0}ub(e);Q(a|0);p()}fb=g+1088|0;return e|0}function tma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0;e=fb-16|0;fb=e;a:{b:{c:{f=x[a+12>>2];h=x[a+8>>2];d:{if((f|0)<=1&h>>>0<=805306368|(f|0)<=0){if((f|0)>=-2&h>>>0>=3489660928|(f|0)>-2){break c}if((f|0)==-2&h>>>0>2147483647|(f|0)==-1){break d}break b}if((f|0)==1&h>>>0>2147483648|f>>>0>1){break b}}l=b+196648|0;break a}l=b+131112|0;break a}l=b+262184|0}m=x[a+16>>2];i=x[a+40>>2];j=x[a+36>>2];b=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=b;n=x[a+32>>2];o=x[a+28>>2];while(1){if(d){b=x[e+8>>2];g=((((x[e+12>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+m|0;b=(b>>>16&65520)+l|0;p=w[b+14>>1];q=w[b+12>>1];r=w[b+10>>1];s=w[b+8>>1];t=w[b+6>>1];u=w[b+4>>1];v=w[b+2>>1];y=w[b>>1];k=0;while(1){if((k|0)!=2){b=k<<1;x[(k<<2)+e>>2]=(((((((D(w[g+(b|-8)>>1],v)+D(w[g+(b|-12)>>1],y)|0)+D(w[g+(b|-4)>>1],u)|0)+D(w[b+g>>1],t)|0)+D(w[g+(b|4)>>1],s)|0)+D(w[g+(b|8)>>1],r)|0)+D(w[g+(b|12)>>1],q)|0)+D(w[g+(b|16)>>1],p)|0)/32768;k=k+1|0;continue}break}j=j+o|0;x[c>>2]=x[c>>2]+D(x[e>>2],j>>12);i=i+n|0;x[c+4>>2]=x[c+4>>2]+D(x[e+4>>2],i>>12);Pb(e+8|0,h,f);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;x[a+40>>2]=i;x[a+20>>2]=j>>12;x[a+36>>2]=j;x[a+24>>2]=i>>12;fb=e+16|0}function zh(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;f=fb-16|0;fb=f;x[f+12>>2]=d;e=0;a:{if(b-251>>>0<4294967046){break a}e=b-1|0;g=x[a+480180>>2];if(!yn(g)){if(g&17408){a=((e&255)>>>0)/12|0;e=z[((D(a,-12)+e&255)<<1)+31616>>1]<<4>>>a|0;break a}if(!d){x[f+12>>2]=8363;d=8363}if(Aj(a)){a=((e&255)>>>0)/12|0;b=Iua(x[(D(a,-12)+e<<6&960)+35504>>2]<<a,0,d,0);a=hb;c=a>>>21|0;h=f,i=Bc((a&2097151)<<11|b>>>21,c),x[h+8>>2]=i;xc(f+8|0,2147483647);e=x[f+8>>2];break a}if(y[a+480208|0]&16){a=e&255;e=z[((a>>>0)%12<<1)+31616>>1]<<5>>>(a>>>0)/12|0;break a}a=((e&255)>>>0)/12|0;xc(f+12|0,-1>>>a|0);e=Bc(Kua(Iua(z[((D(a,-12)+e&255)<<1)+31616>>1],0,267616,0),hb,x[f+12>>2]<<a,0),hb);break a}if(g&20){d=e>>>0>12;if((g|0)==16){b=c<<4}else{b=Ob(a+1074312|0,76)?c&-8:c}c=d?e:12;if(y[a+480208|0]&16){a=((b|0)/-2|0)-(c<<6)|0;e=((a|0)<=-8447?-8447:a)+8448|0;break a}a=c-12|0;c=((a&255)>>>0)/12|0;d=((b|0)/16|0)+(D(c,-12)+a<<3&248)|0;x[f+4>>2]=d+8;He(f+4|0,0,103);a=b>>31;b=(a^b)-a&15;a=d+(a|1)|0;a=(a|0)<=-8?-8:a;e=D(b,z[(((a|0)>=95?95:a)<<1)+32112>>1])+D(z[(x[f+4>>2]<<1)+32096>>1],16-b|0)<<1>>>c|0;break a}if(!(!(c&240|e>>>0<24)&e>>>0<108)){a=((e&255)>>>0)/12|0;e=z[(D(c>>>4&15,12)+(D(a,-12)+e&255)<<1)+31216>>1]<<5>>>a|0;break a}e=z[(b<<1)+30990>>1]<<2}fb=f+16|0;return e}function nba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;if(A[a+4>>2]<A[Ab(a)>>2]){c=fb-16|0;fb=c;a=jv(c+4|0,a,1);Bz(x[a+4>>2],b);x[a+4>>2]=x[a+4>>2]+16;kc(a);fb=c+16|0;return}i=fb-32|0;fb=i;c=Ab(a);d=UV(i+12|0,VV(a,Ek(x[a>>2],x[a+4>>2])+1|0),Ek(x[a>>2],x[a+4>>2]),c);Bz(x[d+8>>2],b);x[d+8>>2]=x[d+8>>2]+16;h=fb-16|0;fb=h;e=Ab(a);b=vb(h+12|0,x[a+4>>2]);c=vb(h+8|0,x[a>>2]);f=vb(h+4|0,x[d+4>>2]);b=x[b>>2];g=x[c>>2];c=fb+-64|0;fb=c;f=x[f>>2];x[c+56>>2]=f;x[c+60>>2]=b;x[c+52>>2]=f;e=Ag(c+24|0,e,c+52|0,c+56|0);x[c+16>>2]=x[e+8>>2];f=x[e+4>>2];x[c+8>>2]=x[e>>2];x[c+12>>2]=f;zg(c+36|0,c+8|0);while(1){if(Fd(b,g)){Bz(Cz(x[c+56>>2]),nC(b));b=Wq(c+60|0);Wq(c+56|0);b=x[b>>2];continue}break}yg(c+36|0);j=x[c+56>>2];if(!y[c+48|0]){f=fb-16|0;fb=f;b=vb(f+12|0,x[x[c+44>>2]>>2]);k=x[vb(f+8|0,x[x[c+40>>2]>>2])>>2];g=fb-16|0;fb=g;b=x[b>>2];x[g+12>>2]=b;while(1){if(xi(b,k)){e=fb-16|0;fb=e;x[e+12>>2]=b;x[e+12>>2]=x[e+12>>2]+16;fb=e+16|0;Qj(Cz(x[e+12>>2]));b=x[Uo(g+12|0)>>2];continue}break}fb=g+16|0;fb=f+16|0}fb=c- -64|0;x[d+4>>2]=j;Tb(a,d+4|0);Tb(a+4|0,d+8|0);Tb(Ab(a),nc(d));x[d>>2]=x[d+4>>2];fb=h+16|0;a=x[d+4>>2];while(1){b=x[d+8>>2];if((b|0)!=(a|0)){b=b-16|0;x[d+8>>2]=b;Qj(b);continue}break}a=x[d>>2];if(a){ts(d);Db(a)}fb=i+32|0}function Zla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0,z=0,A=0,B=0;h=fb-16|0;fb=h;e=x[a+48>>2];i=x[a+40>>2];j=x[a+36>>2];f=x[a+44>>2];q=x[a+16>>2];l=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=l;r=b+24|0;s=x[a+32>>2];t=x[a+28>>2];u=x[a+72>>2];m=x[a+68>>2];y=m>>31;n=x[a+64>>2];z=n>>31;o=x[a+60>>2];A=o>>31;l=x[a+8>>2];B=x[a+12>>2];while(1){b=f;if(d){f=Yb(f,-16777216,16776704);g=Iua(n,z,f,f>>31);f=hb;e=Yb(e,-16777216,16776704);e=Iua(m,y,e,e>>31);g=e+g|0;f=hb+f|0;f=e>>>0>g>>>0?f+1|0:f;e=x[h+8>>2];k=g;g=x[h+12>>2]+q|0;e=(((e>>>16|0)+4&131064)<<1)+r|0;p=((((D(v[g+2|0],w[e+10>>1])+D(v[g+1|0],w[e+8>>1])|0)+D(v[g+3|0],w[e+12>>1])|0)+D(v[g+4|0],w[e+14>>1])<<8>>1)+(((D(v[g-2|0],w[e+2>>1])+D(v[g-3|0],w[e>>1])|0)+D(v[g-1|0],w[e+4>>1])|0)+D(v[g|0],w[e+6>>1])<<8>>1)|0)/16384<<8;e=p;g=Iua(e,e>>31,o,A);k=k+g|0;e=hb+f|0;e=g>>>0>k>>>0?e+1|0:e;f=k+8388608|0;e=f>>>0<8388608?e+1|0:e;f=Sc(f,e,24);e=(f|0)/256|0;j=j+t|0;x[c>>2]=D(e,j>>12)+x[c>>2];i=i+s|0;x[c+4>>2]=x[c+4>>2]+D(i>>12,e);Pb(h+8|0,l,B);f=f-(u&p)|0;c=c+8|0;d=d-1|0;e=b;continue}break}c=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=c;x[a+40>>2]=i;x[a+20>>2]=j>>12;x[a+36>>2]=j;x[a+48>>2]=e;x[a+44>>2]=b;x[a+24>>2]=i>>12;fb=h+16|0}function gQ(a){var b=0,c=E(0),d=0,e=0,f=0,g=E(0),h=0,i=0,k=E(0),m=0,n=0,o=E(0);d=fb-16|0;fb=d;b=x[x[a+16>>2]+24620>>2];e=a+4208|0;n=a,o=Ee(E(10),E(E(E(B[yb(e,0)>>2]*E(120))+E(-60))/E(20))),B[n+4232>>2]=o;k=E(E(b>>>0)/E(1e3));n=a,o=Ee(E(10),E(E(-1)/E(k*E(E(B[yb(e,1)>>2]*E(499.989990234375))+E(.009999999776482582))))),B[n+4236>>2]=o;n=a,o=Ee(E(10),E(E(-1)/E(k*E(E(B[yb(e,2)>>2]*E(2950))+E(50))))),B[n+4240>>2]=o;x[d+12>>2]=1325400064;c=E(Ee(E(10),E(E(E(B[yb(e,3)>>2]*E(60))+E(-60))/E(20)))*E(2147483648));b=(q(c),j(2));g=E(0);a:{if((b|0)==1065353216){break a}b:{if(b-2139095040>>>0<=2164260863){f=b<<1;if(!f){g=E(Gx(E(-1))/E(0));break a}if((b|0)==2139095040){break b}if(!(f>>>0<4278190080&(b|0)>=0)){g=MI(c);break a}b=(q(E(c*E(8388608))),j(2))-192937984|0}f=b-1060306944|0;h=f>>>15&240;i=+(l(2,b-(f&-8388608)|0),r())*C[h+3568>>3]+-1;m=i*i;c=E((C[479]*m+(C[480]*i+C[481]))*m+(+(f>>23)*C[478]+C[h+3576>>3]+i))}g=c}B[d+8>>2]=E(E(g*E(67108864))/E(.6931471824645996))+E(67108864);n=a,o=E(B[Sm(d+12|0,d+8|0)>>2]*E(4.656612873077393e-10)),B[n+4244>>2]=o;n=a,o=E(E(E(-1)/E(E(B[yb(e,4)>>2]*E(99))+E(1)))+E(1)),B[n+4248>>2]=o;c=E(E(E(B[yb(e,5)>>2]*E(4))*k)+E(2));c:{if(E(F(c))<E(2147483648)){h=~~c;break c}h=-2147483648}x[a+4252>>2]=h;fb=d+16|0}function ela(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;l=fb-16|0;fb=l;j=fb-32|0;fb=j;f=j+28|0;e=j+24|0;k=c;g=fb-16|0;fb=g;a:{b:{c=b;if(!mc(b,x[vb(g+12|0,pg(a))>>2])){b=z[k>>1];h=x[k+4>>2];i=ud(c);m=z[i>>1];i=x[i+4>>2];if(!Pl(b,h,m,i)){break b}}x[g+12>>2]=c;c:{if(!mc(c,x[vb(g+8|0,wb(x[a>>2]))>>2])){b=x[LB(g+12|0)>>2];e=ud(b);i=z[e>>1];m=x[e+4>>2];e=z[k>>1];h=x[k+4>>2];if(Pl(i,m,e,h)){break c}c=KB(a,f,e,h);break a}b=c}if(!x[c>>2]){x[f>>2]=c;break a}x[f>>2]=b;c=b+4|0;break a}if(Pl(m,i,b,h)){d:{b=JB(c);if(!mc(b,x[vb(g+12|0,pg(a))>>2])){e=z[k>>1];h=x[k+4>>2];i=ud(b);if(!Pl(e,h,z[i>>1],x[i+4>>2])){break d}}if(!x[c+4>>2]){x[f>>2]=c;c=c+4|0;break a}x[f>>2]=b;c=b;break a}c=KB(a,f,e,h);break a}x[f>>2]=c;x[e>>2]=c;c=e}fb=g+16|0;b=x[c>>2];if(!b){b=fb-16|0;fb=b;f=gc(a);e=j+12|0;g=Dh(e,Ec(36),Og(b+8|0,f));f=x[g>>2]+16|0;h=x[k+4>>2];x[f>>2]=x[k>>2];x[f+4>>2]=h;Ul(f+8|0,d);o=gc(g),p=1,v[o+4|0]=p;fb=b+16|0;$g(a,x[j+28>>2],c,x[j+12>>2]);b=ne(e);cU(e);n=1}a=l+4|0;_g(a,x[vb(j+12|0,b)>>2],n);fb=j+32|0;if(!y[gc(a)|0]){a=ud(x[l+4>>2])+8|0;bU(a);x[a>>2]=x[d>>2];x[a+4>>2]=x[d+4>>2];b=Ab(d);o=Ab(a),p=x[b>>2],x[o>>2]=p;x[b>>2]=0;x[d>>2]=0;x[d+4>>2]=0}a=vb(l+12|0,x[l+4>>2]);fb=l+16|0;return x[a>>2]}function Lia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;if(A[a+4>>2]<A[Ab(a)>>2]){c=fb-16|0;fb=c;a=kC(c+4|0,a);eA(x[a+4>>2],b);x[a+4>>2]=x[a+4>>2]+4;kc(a);fb=c+16|0;return}i=fb-32|0;fb=i;c=Ab(a);d=Zf(i+12|0,Mf(a,oc(x[a>>2],x[a+4>>2])+1|0),oc(x[a>>2],x[a+4>>2]),c);eA(x[d+8>>2],b);x[d+8>>2]=x[d+8>>2]+4;h=fb-16|0;fb=h;e=Ab(a);b=vb(h+12|0,x[a+4>>2]);c=vb(h+8|0,x[a>>2]);f=vb(h+4|0,x[d+4>>2]);b=x[b>>2];g=x[c>>2];c=fb+-64|0;fb=c;f=x[f>>2];x[c+56>>2]=f;x[c+60>>2]=b;x[c+52>>2]=f;e=Ag(c+24|0,e,c+52|0,c+56|0);x[c+16>>2]=x[e+8>>2];f=x[e+4>>2];x[c+8>>2]=x[e>>2];x[c+12>>2]=f;zg(c+36|0,c+8|0);while(1){if(Fd(b,g)){eA(RQ(x[c+56>>2]),xf(b));b=xj(c+60|0);xj(c+56|0);b=x[b>>2];continue}break}yg(c+36|0);j=x[c+56>>2];if(!y[c+48|0]){f=fb-16|0;fb=f;b=vb(f+12|0,x[x[c+44>>2]>>2]);k=x[vb(f+8|0,x[x[c+40>>2]>>2])>>2];g=fb-16|0;fb=g;b=x[b>>2];x[g+12>>2]=b;while(1){if(xi(b,k)){e=fb-16|0;fb=e;x[e+12>>2]=b;x[e+12>>2]=x[e+12>>2]+4;fb=e+16|0;mg(RQ(x[e+12>>2]));b=x[We(g+12|0)>>2];continue}break}fb=g+16|0;fb=f+16|0}fb=c- -64|0;x[d+4>>2]=j;Tb(a,d+4|0);Tb(a+4|0,d+8|0);Tb(Ab(a),nc(d));x[d>>2]=x[d+4>>2];fb=h+16|0;a=x[d+4>>2];while(1){b=x[d+8>>2];if((b|0)!=(a|0)){b=b-4|0;x[d+8>>2]=b;mg(b);continue}break}a=x[d>>2];if(a){Uz(d);Db(a)}fb=i+32|0}function Dd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=fb-80|0;fb=e;x[a+480180>>2]=b;c=sr(a);rr(e+12|0,c);f=x[e+24>>2];d=a+1074320|0;x[d>>2]=x[e+20>>2];x[d+4>>2]=f;d=x[e+16>>2];x[a+1074312>>2]=x[e+12>>2];x[a+1074316>>2]=d;if(!((b|0)==32|(c|0)!=32)){bg(a+1074312|0,120)}Bu(a+8|0,c);b=1;while(1){c=b&65535;if(c>>>0>z[a+480192>>1]){x[a+480184>>2]=0;x[a+480188>>2]=0;x[a+480236>>2]=65536;x[a+480228>>2]=48;x[a+480232>>2]=48;v[a+480268|0]=5;x[a+480260>>2]=16;x[a+480264>>2]=32767;x[a+480204>>2]=125e4;x[a+480208>>2]=0;x[a+480196>>2]=6;x[a+480200>>2]=256;x[a+1074304>>2]=0;x[a+1074308>>2]=0;w[a+480192>>1]=0;SA(a,4);d=fb+-64|0;fb=d;b=a+484344|0;Eu(b);f=jm(x[b>>2],x[b+4>>2]);c=rA(d+12|0,b);x[31609]=0;S(854,b|0,f|0,c|0);b=x[31609];x[31609]=0;a:{if((b|0)!=1){wk(c);fb=d- -64|0;break a}a=N()|0;wk(c);Q(a|0);p()}WU(a+484360|0);sf(a+1298308|0);sf(a+1298320|0);sf(a+1298332|0);b=e+12|0;Rb(b,0,68);b=yS(b);c=zb(a+1298344|0,b);zb(c+12|0,b+12|0);zb(c+24|0,b+24|0);zb(c+36|0,b+36|0);zb(c+48|0,b+48|0);d=x[b+64>>2];x[c+60>>2]=x[b+60>>2];x[c+64>>2]=d;YA(b);Nc(a+1298412|0);Nc(a+480248|0);if(x[a+480180>>2]&738230281){x[a+480208>>2]=x[a+480208>>2]|8388608}fb=e+80|0;return}c=((c<<2)+a|0)+900380|0;d=x[c>>2];if(d){Db(Nv(d))}x[c>>2]=0;b=b+1|0;continue}}function D3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;if(lh(a,x[b+8>>2],e)){Vx(b,c,d);return}a:{if(lh(a,x[b>>2],e)){if(!(x[b+16>>2]!=(c|0)&x[b+20>>2]!=(c|0))){if((d|0)!=1){break a}x[b+32>>2]=1;return}x[b+32>>2]=d;b:{if(x[b+44>>2]==4){break b}f=a+16|0;h=f+(x[a+12>>2]<<3)|0;d=0;c:{while(1){d:{if(f>>>0>=h>>>0){break d}w[b+52>>1]=0;Sx(x[f>>2],x[f+4>>2],b,c,c,1,e);if(y[b+54|0]){break d}e:{if(!y[b+53|0]){break e}if(y[b+52|0]){if(x[b+24>>2]!=1){d=1;g=1;if(y[a+8|0]&2){break e}}x[b+44>>2]=3;return}d=1;if(!(v[a+8|0]&1)){break c}}f=f+8|0;continue}break}x[b+44>>2]=d?3:4;if(!g){break b}break a}x[b+44>>2]=3;if(g){break a}}x[b+20>>2]=c;x[b+40>>2]=x[b+40>>2]+1;if(x[b+36>>2]!=1|x[b+24>>2]!=2){break a}v[b+54|0]=1;return}f=x[a+12>>2];g=a+16|0;Ns(x[g>>2],x[a+20>>2],b,c,d,e);if((f|0)<2){break a}g=g+(f<<3)|0;f=a+24|0;a=x[a+8>>2];if(!(!(a&2)&x[b+36>>2]!=1)){while(1){if(y[b+54|0]){break a}Ns(x[f>>2],x[f+4>>2],b,c,d,e);f=f+8|0;if(g>>>0>f>>>0){continue}break}break a}if(!(a&1)){while(1){if(y[b+54|0]|x[b+36>>2]==1){break a}Ns(x[f>>2],x[f+4>>2],b,c,d,e);f=f+8|0;if(g>>>0>f>>>0){continue}break a}}while(1){if(y[b+54|0]|x[b+36>>2]==1&x[b+24>>2]==1){break a}Ns(x[f>>2],x[f+4>>2],b,c,d,e);f=f+8|0;if(g>>>0>f>>>0){continue}break}}}function y1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=fb-32|0;fb=d;if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))==1397771593){nd(b,32);wp(b);c=d+8|0;ek(c,1,a+4|0);e=d+20|0;Cc(e,c);Be(b+43|0,e);tb(e);w[b+30>>1]=y[a+19|0]<<2;Hf(b+30|0,256);w[b+32>>1]=y[a+17|0];Hf(b+32|0,64);w[b+28>>1]=(y[a+47|0]&127)<<2;Hf(b+28|0,256);if(v[a+47|0]<0){w[b+34>>1]=z[b+34>>1]|32}c=y[a+18|0];if(c&16){w[b+34>>1]=z[b+34>>1]|2;c=y[a+18|0]}if(c&32){w[b+34>>1]=z[b+34>>1]|8;c=y[a+18|0]}if(c&64){w[b+34>>1]=z[b+34>>1]|4;c=y[a+18|0]}if(c<<24>>24<0){w[b+34>>1]=z[b+34>>1]|16}c=y[a+60|0]|y[a+61|0]<<8|(y[a+62|0]<<16|y[a+63|0]<<24);x[b+24>>2]=c?c>>>0<=256?256:c:8363;x[b>>2]=y[a+48|0]|y[a+49|0]<<8|(y[a+50|0]<<16|y[a+51|0]<<24);x[b+4>>2]=y[a+52|0]|y[a+53|0]<<8|(y[a+54|0]<<16|y[a+55|0]<<24);x[b+8>>2]=y[a+56|0]|y[a+57|0]<<8|(y[a+58|0]<<16|y[a+59|0]<<24);x[b+12>>2]=y[a+64|0]|y[a+65|0]<<8|(y[a+66|0]<<16|y[a+67|0]<<24);x[b+16>>2]=y[a+68|0]|y[a+69|0]<<8|(y[a+70|0]<<16|y[a+71|0]<<24);Vk(b);v[b+38|0]=y[(y[a+79|0]&7)+38064|0];v[b+41|0]=y[a+76|0];v[b+40|0]=y[a+77|0]&127;v[b+39|0]=y[a+78|0];c=y[a+46|0];a:{if((c|0)==64){c=512}else{if((c|0)!=128){break a}c=16384}w[b+34>>1]=c|z[b+34>>1]}c=y[a+72|0]|y[a+73|0]<<8|(y[a+74|0]<<16|y[a+75|0]<<24)}fb=d+32|0;return c|0}function sO(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=fb+-64|0;fb=e;a:{b:{c:{d:{g=x[a+36>>2];c=x[a+40>>2];e:{if(Ib(g,c)){tc(e+60|0);break e}f=e+24|0;vo(f,a);x[31609]=0;c=R(1056,f|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break d}x[e+60>>2]=c;nf(f);c=x[a+40>>2];g=x[a+36>>2]}f=(k=a+36|0,l=x[e+60>>2],m=Ib(g,c),m?k:l);d=x[a+8>>2];if((d|0)==-1){c=x[f+4>>2];d=jl(c);g=0;h=x[f>>2];f=hj(h,c);while(1){if((f|0)==(g|0)){c=d;break c}c=wf(h,g);j=i+C[c>>3];if(j>b){break c}g=g+1|0;i=j;continue}}c=wf(x[f>>2],d);break b}g=N()|0;nf(e+24|0);break a}b=b-i}f=z[c+12>>1];d=x[a+24>>2];x[31609]=0;O(1090,d|0,f|0);d=x[31609];x[31609]=0;if((d|0)!=1){f:{h=x[a+24>>2];f=y[a+64|0];c=WR(aY(e+24|0,b),y[c+16|0],z[c+12>>1],x[c+8>>2]);x[31609]=0;d=x[c+12>>2];x[e+8>>2]=x[c+8>>2];x[e+12>>2]=d;d=x[c+20>>2];x[e+16>>2]=x[c+16>>2];x[e+20>>2]=d;d=x[c+4>>2];x[e>>2]=x[c>>2];x[e+4>>2]=d;c=e+48|0;V(1091,c|0,h|0,(f?7:1)|0,e|0);d=x[31609];x[31609]=0;if((d|0)==1){break f}h=gn(x[e+52>>2]);f=v[h+26|0]&1;d=x[(f?h+8|0:h+12|0)>>2];f=z[(f?h+20|0:h+22|0)>>1];b=C[h>>3];Si(c);c=x[a+24>>2];w[c+1074450>>1]=f;w[c+1074448>>1]=f;x[c+1074428>>2]=d;x[c+1074392>>2]=-2;b=i+b;C[a+16>>3]=b;yl(e+60|0);fb=e- -64|0;return+b}}g=N()|0;yl(e+60|0)}Q(g|0);p()}function _ra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=fb-48|0;fb=d;l=b+8|0;m=b+906300|0;while(1){a:{b:{c:{if(Mb(x[c>>2],x[c+8>>2],9)){jr(c,d+43|0);f=Rg(c);d:{e=y[d+43|0]|y[d+44|0]<<8|(y[d+45|0]<<16|y[d+46|0]<<24);if(!((e|0)==1229999433|(e|0)==1397771593|((e|0)==1297110104|(e|0)==1297110099))){if(Mb(x[c>>2],x[c+8>>2],f)){break d}}v[d+47|0]=j;Ih(c,8);break c}he(d,c,f);f=hc(d+20|0,d);ub(d);e:{if((y[d+43|0]|y[d+44|0]<<8|(y[d+45|0]<<16|y[d+46|0]<<24))==1481001027){g=480280;while(1){if((g|0)==484344){g=1;break a}x[31609]=0;e=R(151,f|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break e}v[g+l|0]=e;g=g+32|0;continue}}if(y[d+43|0]!=70){break b}h=y[d+44|0];k=(h|0)==88;f:{if(!k){if((h-48&255)>>>0>9){break b}e=v[d+45|0];if((e|0)>47){break f}break b}e=v[d+45|0];if((e|0)<48){break b}}if(e>>>0>57){break b}i=v[d+46|0];if((i|0)<48|(i|0)>57){break b}g=1;e=((i&255)+(k?-528:D(h,100)-5328|0)|0)+D(e&255,10)&65535;if(e>>>0>249){break a}x[31609]=0;O(450,f|0,$d(m,e)|0);e=x[31609];x[31609]=0;if((e|0)!=1){break a}}a=N()|0;ub(f);Q(a|0);p()}v[d+47|0]=j}zD(a,g,d+47|0);fb=d+48|0;return}if((y[d+43|0]|y[d+44|0]<<8|(y[d+45|0]<<16|y[d+46|0]<<24))!=1430540109){break a}x[b+1074308>>2]=0;j=1}ub(f);continue}}function uma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0;e=fb-16|0;fb=e;a:{b:{c:{f=x[a+12>>2];h=x[a+8>>2];d:{if((f|0)<=1&h>>>0<=805306368|(f|0)<=0){if((f|0)>=-2&h>>>0>=3489660928|(f|0)>-2){break c}if((f|0)==-2&h>>>0>2147483647|(f|0)==-1){break d}break b}if((f|0)==1&h>>>0>2147483648|f>>>0>1){break b}}k=b+196648|0;break a}k=b+131112|0;break a}k=b+262184|0}l=x[a+16>>2];i=x[a+40>>2];j=x[a+36>>2];b=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=b;m=x[a+32>>2];n=x[a+28>>2];while(1){if(d){b=x[e+8>>2];g=(((x[e+12>>2]&2147483647)<<1|b>>>31)&-2)+l|0;b=(b>>>16&65520)+k|0;o=w[b+14>>1];p=w[b+12>>1];q=w[b+10>>1];r=w[b+8>>1];s=w[b+6>>1];t=w[b+4>>1];u=w[b+2>>1];y=w[b>>1];b=0;while(1){if((b|0)!=2){x[(b<<2)+e>>2]=(((((((D(v[(b|-4)+g|0],u)+D(v[(b|-6)+g|0],y)|0)+D(v[(b|-2)+g|0],t)|0)+D(v[b+g|0],s)|0)+D(v[(b|2)+g|0],r)|0)+D(v[(b|4)+g|0],q)|0)+D(v[(b|6)+g|0],p)|0)+D(v[(b|8)+g|0],o)<<8)/32768;b=b+1|0;continue}break}j=j+n|0;x[c>>2]=x[c>>2]+D(x[e>>2],j>>12);i=i+m|0;x[c+4>>2]=x[c+4>>2]+D(x[e+4>>2],i>>12);Pb(e+8|0,h,f);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;x[a+40>>2]=i;x[a+20>>2]=j>>12;x[a+36>>2]=j;x[a+24>>2]=i>>12;fb=e+16|0}function Iaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;c=fb+-64|0;fb=c;d=x[a>>2];a=x[d>>2];e=x[a+4>>2];x[c+40>>2]=x[a+20>>2];f=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=f;Xf(c+48|0,c+32|0,e);a=x[d+4>>2];e=x[a+8>>2];f=x[a+4>>2];d=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=d;d=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=d;x[c+8>>2]=x[a+8>>2];d=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=d;a=fb-32|0;fb=a;a:{b:{c:{d:{g=x[c+4>>2];if(g>>>0>=f>>>0){h=x[c+20>>2];if(h>>>0<f>>>0){break d}if(e>>>0>A[c+8>>2]){break c}i=x[c+28>>2];if(e>>>0>x[c+24>>2]-i>>>0){break b}l=b+12|0;m=x[c+16>>2];n=x[c>>2];b=0;e:while(1){if((b|0)==(e|0)){break a}o=(D(b,g)<<3)+n|0;q=(D(b+i|0,h)<<1)+m|0;d=0;while(1)if((d|0)==(f|0)){b=b+1|0;continue e}else{s=a,t=+(wn(Ge(Jg(C[(d<<3)+o>>3])*134217728))+rd(Yt(l),21)|0)*7.450580596923828e-9,C[s+24>>3]=t;x[a+16>>2]=0;x[a+20>>2]=-1074790400;x[a+8>>2]=0;x[a+12>>2]=1072693248;r=(d<<1)+q|0;j=Ge(C[Yg(a+24|0,a+16|0,a+8|0)>>3]*32768);f:{if(F(j)<2147483648){k=~~j;break f}k=-2147483648}s=r,u=gd(k),w[s>>1]=u;d=d+1|0;continue}}}_(7244,9061,77,8741);p()}_(7209,9061,78,8741);p()}_(5897,9061,79,8741);p()}_(5867,9061,80,8741);p()}fb=a+32|0;fb=c- -64|0}function bja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=E(0),m=0,n=0,o=E(0);g=w[d>>1];h=w[d+2>>1];a:{if((g|0)>(h|0)){break a}k=x[b>>2];i=oc(k,x[b+4>>2]);if(!i){break a}j=w[e>>1];if((g|0)>(j|0)|(h|0)<(j|0)|(i-1&65535)>>>0>(h-j&65535)>>>0|A[a+36>>2]>65535){break a}b:{while(1){if((f|0)==(i|0)){break b}j=yb(k,f);f=f+1|0;if(!(B[j>>2]<E(0))){continue}break}return 0}f=0;l=B[c>>2];if(l<=E(0)){break a}w[a+28>>1]=g;w[a>>1]=1;m=a,n=cR(i),w[m+30>>1]=n;B[a+32>>2]=F(l);Dl(a+4|0,(h-g|0)+1|0);c=wb(x[b>>2]);h=wb(x[b+4>>2]);f=Fk(wb(x[a+4>>2]),w[e>>1]-w[d>>1]|0);g=fb-16|0;fb=g;b=fb-32|0;fb=b;fd(b+24|0,c,h);bD(b+16|0,x[b+24>>2],x[b+28>>2],f);c=lA(c,x[b+16>>2]);m=b,n=bR(f,x[b+20>>2]),x[m+12>>2]=n;rc(g+8|0,c,b+12|0);fb=b+32|0;fb=g+16|0;c=x[a+4>>2];g=w[a+30>>1];h=w[a+28>>1];b=w[e>>1];f=b;while(1){if((b&65535)!=32768&(f|0)>(h|0)){f=f-1|0;b=f-h|0;i=yb(c,b+g|0);m=yb(c,b),o=E(B[i>>2]/B[a+32>>2]),B[m>>2]=o;b=w[e>>1];continue}else{c=w[a+30>>1];e=w[a+28>>1];h=c+e|0;f=g;g=b<<16>>16;f=f+g|0;b=x[a+4>>2];d=w[d+2>>1];c=(g|0)<=(32767-c|0);while(1){if(c&(d|0)>=(f|0)){g=yb(b,f-h|0);m=yb(b,f-e|0),o=E(B[a+32>>2]*B[g>>2]),B[m>>2]=o;f=f+1|0;continue}else{wq(a)}break}}break}f=1}return f|0}function Raa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;c=fb+-64|0;fb=c;d=x[a>>2];a=x[d>>2];e=x[a+4>>2];x[c+40>>2]=x[a+20>>2];f=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=f;Xf(c+48|0,c+32|0,e);a=x[d+4>>2];e=x[a+8>>2];f=x[a+4>>2];d=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=d;d=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=d;x[c+8>>2]=x[a+8>>2];d=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=d;a=fb-32|0;fb=a;a:{b:{c:{d:{g=x[c+4>>2];if(g>>>0>=f>>>0){if(A[c+20>>2]<f>>>0){break d}if(e>>>0>A[c+8>>2]){break c}h=x[c+28>>2];if(e>>>0>x[c+24>>2]-h>>>0){break b}k=b+12|0;l=x[c+16>>2];m=x[c>>2];b=0;e:while(1){if((b|0)==(e|0)){break a}n=(D(b,g)<<3)+m|0;d=0;while(1)if((d|0)==(f|0)){b=b+1|0;continue e}else{q=a,r=+(wn(Ge(Jg(C[(d<<3)+n>>3])*134217728))+rd(Yt(k),21)|0)*7.450580596923828e-9,C[q+24>>3]=r;x[a+16>>2]=0;x[a+20>>2]=-1074790400;x[a+8>>2]=0;x[a+12>>2]=1072693248;o=(d<<2)+l|0;i=Ge(C[Yg(a+24|0,a+16|0,a+8|0)>>3]*32768);f:{if(F(i)<2147483648){j=~~i;break f}j=-2147483648}q=(x[o>>2]+(h<<1)|0)+(b<<1)|0,s=gd(j),w[q>>1]=s;d=d+1|0;continue}}}_(7244,9061,77,8741);p()}_(7209,9061,78,8741);p()}_(5897,9061,79,8741);p()}_(5867,9061,80,8741);p()}fb=a+32|0;fb=c- -64|0}function Vna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;g=fb-48|0;fb=g;c=wb(x[a>>2]);x[g+44>>2]=c;k=wb(x[a+4>>2]);while(1){if(Ib(c,k)){i=g+24|0;a=wb(x[c>>2]);l=wb(x[c+4>>2]);c=hX(g+4|0,b);v[c+16|0]=y[b+16|0];x[c+12>>2]=x[b+12>>2];h=fb-16|0;fb=h;x[h+12>>2]=a;while(1){if(Ib(a,l)){f=fb-16|0;fb=f;if(!(y[a+5|0]|y[a+3|0]!=4)){e=f+8|0;Jb(e,x[c>>2],z[c+14>>1]);kf(e,0);v[a+3|0]=0}e=y[a+2|0];if(!(y[a+4|0]|(e|0)!=11)){d=f+8|0;Jb(d,x[c>>2],z[c+14>>1]);kf(d,0);v[a+2|0]=0;e=0}a:{b:{if(!y[a|0]){Jb(f+8|0,x[c>>2],z[c+14>>1]);e=y[a+2|0];d=y[a+3|0];if(!Gb(x[x[f+8>>2]>>2],x[f+12>>2])){break b}if(!((e|0)==11|d)){v[a+5|0]=0;d=4;v[a+3|0]=4;break a}if((d|0)==4|e){break a}v[a+4|0]=0;v[a+2|0]=11;break a}d=y[a+3|0]}j=f+8|0;Jb(j,x[c>>2],z[c+14>>1]);kf(j,(d|0)==4|(e|0)==11);d=y[a+3|0]}c:{d:{e:{if(!(!y[c+16|0]|d)){v[a+3|0]=17;d=125;e=0;break e}e=0;f:{switch(d-16|0){case 1:break d;case 0:break f;default:break c}}if(y[a+5|0]){break c}d=6;e=1}v[a+5|0]=d}v[c+16|0]=e}a=z[c+14>>1]+1|0;w[c+14>>1]=z[c+12>>1]>(a&65535)>>>0?a:0;fb=f+16|0;a=x[tg(h+12|0)>>2];continue}break}a=DC(i,c);v[a+16|0]=y[c+16|0];x[a+12>>2]=x[c+12>>2];fb=h+16|0;tf(i);tf(c);c=x[Vl(g+44|0)>>2];continue}else{fb=g+48|0}break}}function hka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;i=fb-16|0;fb=i;d=x[b+1298304>>2];if(!Ed(d)){c=fb-16|0;fb=c;d=Ec(12);x[31609]=0;g=R(951,d|0)|0;e=x[31609];x[31609]=0;a:{if((e|0)!=1){d=yf(c+12|0,g);fb=c+16|0;c=x[d>>2];break a}a=N()|0;Db(d);Q(a|0);p()}x[i+12>>2]=c;c=b+1298304|0;d=i+12|0;qS(c,ne(d));XA(d);d=x[c>>2]}g=fb-32|0;fb=g;c=g+8|0;eS(c,a);x[31609]=0;O(952,g+20|0,c|0);e=x[31609];x[31609]=0;b:{c:{if((e|0)!=1){tb(c);e=wb(x[d>>2]);x[g+4>>2]=e;l=wb(x[d+4>>2]);d=0;while(1){d:{if(!Ib(e,l)){e:{if(!d){break e}f=x[d+4>>2];if(!f){break e}x[31609]=0;b=U(f|0,d|0,b|0,a|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break d}if(b){f=x[d>>2];x[b+4>>2]=f;if(f){x[f+8>>2]=b}x[d>>2]=b}x[a>>2]=b}tb(g+20|0);fb=g+32|0;break b}j=0;c=x[e>>2];if(x[c+32>>2]==x[a+16>>2]){j=x[c+36>>2]==x[a+20>>2]}x[31609]=0;k=g+8|0;O(953,k|0,c+8|0);c=x[31609];x[31609]=0;if((c|0)!=1){h=fb-16|0;fb=h;fe(h+8|0,k);fe(h,g+20|0);c=IR(x[h+8>>2],x[h+12>>2],x[h>>2],x[h+4>>2]);fb=h+16|0;tb(k);f:{if(!(!j|(c|0)!=0)){d=x[e>>2];f=3;break f}if((f|0)<2&j){d=x[e>>2];f=2;break f}c=!c&(f|0)<=0;d=c?x[e>>2]:d;f=c?1:f}e=x[We(g+4|0)>>2];continue}}break}e=N()|0;tb(g+20|0);break c}e=N()|0;tb(g+8|0)}Q(e|0);p()}fb=i+16|0}
function iJ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;a=fb-16|0;fb=a;x[a+12>>2]=c;x[a+8>>2]=f;x[a+12>>2]=c;x[a+8>>2]=f;a:{b:{while(1){b=x[a+12>>2];if(!(d>>>0<=b>>>0|f>>>0>=g>>>0)){i=v[b|0];c=i&255;c:{if((i|0)>=0){i=1;break c}k=2;if(i>>>0<4294967234){break a}if(i>>>0<=4294967263){if((d-b|0)<2){break b}i=y[b+1|0];if((i&192)!=128){break a}c=i&63|c<<6&1984;i=2;break c}if(i>>>0<=4294967279){if((d-b|0)<3){break b}j=y[b+2|0];i=y[b+1|0];d:{e:{if((c|0)!=237){if((c|0)!=224){break e}if((i&224)==160){break d}break a}if((i&224)==128){break d}break a}if((i&192)!=128){break a}}if((j&192)!=128){break a}c=j&63|(c<<12&61440|(i&63)<<6);i=3;break c}if(i>>>0>4294967284){break a}if((d-b|0)<4){break b}l=y[b+3|0];m=y[b+2|0];j=y[b+1|0];f:{g:{switch(c-240|0){case 0:if((j+112&255)>>>0<48){break f}break a;case 4:if((j&240)==128){break f}break a;default:break g}}if((j&192)!=128){break a}}if((m&192)!=128|(l&192)!=128){break a}i=4;c=l&63|(m<<6&4032|(c<<18&1835008|(j&63)<<12));if(c>>>0>1114111){break a}}x[f>>2]=c;x[a+12>>2]=b+i;f=x[a+8>>2]+4|0;x[a+8>>2]=f;continue}break}k=b>>>0<d>>>0;break a}k=1}x[e>>2]=x[a+12>>2];x[h>>2]=x[a+8>>2];fb=a+16|0;return k|0}function yqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;nd(b,0);wp(b);f=y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24);a:{if(c&34){if(d){x[b+24>>2]=f;break a}g=b,h=Ye(zi(+(f+1408|0)/1536)*8363),x[g+24>>2]=h;break a}v[b+37|0]=(c|0)==16?f:f^128;v[b+36|0]=y[a+4|0]}v[e+15|0]=y[a+5|0];v[e+14|0]=64;g=b,h=y[Qb(e+15|0,e+14|0)|0]<<2,w[g+30>>1]=h;d=y[a+6|0]|y[a+7|0]<<8;if(d>>>0<=256){w[b+28>>1]=d;w[b+34>>1]=z[b+34>>1]|32}x[b>>2]=y[a+8|0]|y[a+9|0]<<8|(y[a+10|0]<<16|y[a+11|0]<<24);x[b+4>>2]=y[a+12|0]|y[a+13|0]<<8|(y[a+14|0]<<16|y[a+15|0]<<24);x[b+8>>2]=y[a+16|0]|y[a+17|0]<<8|(y[a+18|0]<<16|y[a+19|0]<<24);d=y[a+20|0]|y[a+21|0]<<8;if(d&16){w[b+34>>1]=z[b+34>>1]|2;d=y[a+20|0]|y[a+21|0]<<8}if(d&32){w[b+34>>1]=z[b+34>>1]|4;d=y[a+20|0]|y[a+21|0]<<8}if(d&256){w[b+34>>1]=z[b+34>>1]|8;d=y[a+20|0]|y[a+21|0]<<8}if(d&512){w[b+34>>1]=z[b+34>>1]|16}v[b+38|0]=y[(y[a+22|0]&7)+38064|0];v[b+39|0]=y[a+23|0];v[b+40|0]=y[a+24|0];v[b+41|0]=y[a+25|0];if((c|0)==32){v[e+13|0]=y[a+26|0];v[e+12|0]=64;g=b,h=y[Qb(e+13|0,e+12|0)|0],w[g+32>>1]=h}x[b+12>>2]=y[a+27|0]|y[a+28|0]<<8|(y[a+29|0]<<16|y[a+30|0]<<24);x[b+16>>2]=y[a+31|0]|y[a+32|0]<<8|(y[a+33|0]<<16|y[a+34|0]<<24);fb=e+16|0}function ska(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=fb-16|0;fb=l;x[l+12>>2]=b;q=Pf(a);while(1){if(Zg(b,c)){e=x[vb(l+8|0,q)>>2];j=ud(b);o=fb-16|0;fb=o;p=0;m=fb-16|0;fb=m;h=fb-32|0;fb=h;f=h+28|0;d=h+24|0;k=fb-16|0;fb=k;a:{b:{b=e;if(!mc(b,x[vb(k+12|0,pg(a))>>2])){e=y[j|0];i=x[j+4>>2];g=ud(b);n=y[g|0];g=x[g+4>>2];if(!Ao(e,i,n,g)){break b}}x[k+12>>2]=b;c:{if(!mc(b,x[vb(k+8|0,wb(x[a>>2]))>>2])){d=x[LB(k+12|0)>>2];e=ud(d);g=y[e|0];n=x[e+4>>2];e=y[j|0];i=x[j+4>>2];if(Ao(g,n,e,i)){break c}b=fB(a,f,e,i);break a}d=b}if(!x[b>>2]){x[f>>2]=b;break a}x[f>>2]=d;b=d+4|0;break a}if(Ao(n,g,e,i)){d:{d=JB(b);if(!mc(d,x[vb(k+12|0,pg(a))>>2])){e=y[j|0];i=x[j+4>>2];g=ud(d);if(!Ao(e,i,y[g|0],x[g+4>>2])){break d}}if(!x[b+4>>2]){x[f>>2]=b;b=b+4|0;break a}x[f>>2]=d;b=d;break a}b=fB(a,f,e,i);break a}x[f>>2]=b;x[d>>2]=b;b=d}fb=k+16|0;d=x[b>>2];if(!d){d=fb-16|0;fb=d;f=gc(a);e=h+12|0;f=Dh(e,Ec(28),Og(d+8|0,f));xC(x[f>>2]+16|0,j);r=gc(f),s=1,v[r+4|0]=s;fb=d+16|0;$g(a,x[h+28>>2],b,x[h+12>>2]);d=ne(e);Jk(e);p=1}_g(m+8|0,x[vb(h+12|0,d)>>2],p);fb=h+32|0;fb=m+16|0;vb(o+12|0,x[m+8>>2]);fb=o+16|0;b=x[ah(l+12|0)>>2];continue}else{fb=l+16|0}break}}function Kga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=E(0),q=E(0),r=0,s=0,t=0,u=E(0),v=0;i=fb-16|0;fb=i;if(ui(a+44|0)){n=x[a+44>>2];j=Hc(n,0);k=Hc(n,1);n=x[a+56>>2];t=Hc(n,0);n=Hc(n,1);u=B[yb(a+4208|0,1)>>2];x[i+12>>2]=d;s=x[a+4220>>2];q=E(E(1)/E(s>>>0));v=x[a+4216>>2];o=d;f=n;g=t;while(1){if(o){h=x[a+4224>>2];a:{if(s>>>0>h>>>0){x[i+8>>2]=s-h;r=x[Hb(i+12|0,i+8|0)>>2];m=0;b:{if(u<E(1)){l=h+r|0;e=h>>>0>l>>>0?h:l;while(1){if((h|0)==(e|0)){break b}p=E(h>>>0);B[g>>2]=q*E(B[j>>2]*p);B[f>>2]=q*E(B[k>>2]*p);h=h+1|0;f=f+4|0;k=k+4|0;g=g+4|0;j=j+4|0;continue}}while(1){if((m|0)!=(r|0)){B[g>>2]=B[j>>2];B[f>>2]=B[k>>2];m=m+1|0;f=f+4|0;k=k+4|0;g=g+4|0;j=j+4|0;continue}break}l=h+r|0}o=o-r|0;x[i+12>>2]=o;break a}m=v-h|0;x[i+4>>2]=m;l=x[Hb(i+12|0,i+4|0)>>2];e=0;c:{if(u<E(1)){e=m-l|0;while(1){if(e>>>0>=m>>>0){break c}p=E(m>>>0);B[g>>2]=q*E(B[j>>2]*p);B[f>>2]=q*E(B[k>>2]*p);m=m-1|0;f=f+4|0;k=k+4|0;g=g+4|0;j=j+4|0;continue}}while(1){if((e|0)!=(l|0)){x[g>>2]=0;x[f>>2]=0;e=e+1|0;f=f+4|0;g=g+4|0;continue}break}e=l<<2;k=e+k|0;j=j+e|0}o=o-l|0;x[i+12>>2]=o;e=h+l|0;l=e>>>0<v>>>0?e:0}x[a+4224>>2]=l;continue}else{Ki(a,b,c,t,n,d)}break}}fb=i+16|0}function sqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;g=fb-48|0;fb=g;w[a>>1]=0;w[a+2>>1]=0;w[a+4>>1]=0;x[g+44>>2]=0;d=g+44|0;c=fb-16|0;fb=c;a:{if(!Mb(x[b>>2],x[b+8>>2],4)){qD(d);break a}mh(c+8|0,d);sd(c,b,x[c+8>>2],x[c+12>>2])}fb=c+16|0;b:{if(!tV(d)){break b}e=y[g+46|0];f=y[g+47|0];d=y[g+45|0];v[a+4|0]=1;h=d>>>3&3;c=(h|0)!=3;d=(d^-1)>>>1&3;f=f>>>0<192;w[a+2>>1]=z[(D(c,6)+(d<<1)|0)+25736>>1]<<f;i=D(D(y[(d+D(c,3)|0)+25512|0],z[((D(c,90)+D(d,30)|0)+(e>>>3&30)|0)+25520>>1]),1e3);e=e>>>1|0;e=((i>>>0)/z[(D(h,6)+(e&6)|0)+25712>>1]|0)+(e&1)<<(!d<<1);w[a>>1]=e;d=y[(f|c<<1)+25748|0];if(d+8>>>0>(e&65535)>>>0){break b}e=Rb(g,0,36);c=fb-32|0;fb=c;x[c+28>>2]=d+4;x[c+8>>2]=36;h=x[b>>2];i=x[b+8>>2];f=x[Hb(c+28|0,c+8|0)>>2];if(!Mb(h,i,f)){f=jf(b)}h=c+8|0;$r(h,e);i=Zb(c+16|0,x[c+8>>2],f);lc(c,x[b>>2],x[b+8>>2],x[i>>2],x[i+4>>2]);$r(h,e);Rb(x[c+8>>2]+f|0,0,36-f|0);Vb(b,x[c+28>>2]);fb=c+32|0;b=2;c=d>>>0<=2?2:d;while(1){if((b|0)!=(c|0)){f=b+e|0;b=b+1|0;if(!y[f|0]){continue}break b}break}b=d+e|0;if((y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24))==1868983881){b=1}else{b=(y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24))==1735289176}v[a+5|0]=b}fb=g+48|0;return a|0}function Rda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;b=fb-2160|0;fb=b;uu(b+112|0);a:{b:{c:{f=x[c+4>>2];if(!f){a=ac(8);x[31609]=0;b=P(36,b+100|0,10469)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}c=N()|0;tb(b);break b}g=x[c>>2];d=x[c+12>>2];e=x[c+8>>2];x[b+92>>2]=e;x[b+96>>2]=d;c=x[b+96>>2];x[b+40>>2]=x[b+92>>2];x[b+44>>2]=c;x[b+88>>2]=f;x[b+84>>2]=g;c=x[b+88>>2];x[b+32>>2]=x[b+84>>2];x[b+36>>2]=c;h=xM(b+32|0);if(h){c=b- -64|0;x[c>>2]=e;x[b+68>>2]=d;d=x[c+4>>2];x[b+24>>2]=x[c>>2];x[b+28>>2]=d;x[b+60>>2]=f;x[b+56>>2]=g;c=x[b+60>>2];x[b+16>>2]=x[b+56>>2];x[b+20>>2]=c;c=qM(b+16|0)}else{c=0}x[b+72>>2]=c;x[b+76>>2]=0;d=0;c=2048;while(1){if(c){e=ib[f|0](g,(b+112|0)+d|0,c)|0;c=c-e|0;d=d+e|0;if(e){continue}}break}c=Zb(b+48|0,b+112|0,d);d=x[c+4>>2];x[b+8>>2]=x[c>>2];x[b+12>>2]=d;a=Au(a,b+8|0,h?b+72|0:0);if(a+1>>>0>=3){a=ac(8);x[31609]=0;b=P(36,b+100|0,8057)|0;c=x[31609];x[31609]=0;if((c|0)!=1){pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}c=N()|0;tb(b);break b}c=N()|0;ic(a);break b}fb=b+2160|0;return a|0}c=N()|0;ic(a)}Q(c|0)}p()}function bS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=fb-16|0;fb=e;c=Xb(x[a+484360>>2],y[a+484376|0]);d=$c(x[c>>2],x[c+4>>2]);a:{while(1){f=b&65535;if(f>>>0>=d>>>0){break a}if(!Yi(c,f)){b=b+1|0;continue}break}f=a+1074312|0;d=1074992;b:{while(1){c:{if((d|0)==1298224){aS(a);if(b&65535){break c}b=0;while(1){if((b|0)==256){Lo(a+1298264|0,1);x[a+1074456>>2]=x[a+480200>>2];x[a+1074416>>2]=x[a+480196>>2];x[a+1074420>>2]=x[a+480204>>2];x[a+480208>>2]=x[a+480208>>2]&-769;tB(a+1074376|0);w[a+1074450>>1]=0;x[a+1074392>>2]=-2;b=a+1074428|0;x[b>>2]=0;x[b+4>>2]=0;b=a+1074396|0;x[b>>2]=0;x[b+4>>2]=0;x[a+1074376>>2]=0;x[a+1074380>>2]=0}else{Po((D(b,872)+a|0)+1074992|0,a,b&65535,67108864);b=b+1|0;continue}break}break b}c=a+d|0;v[c+797|0]=0;x[c+700>>2]=0;v[c+841|0]=0;v[c+805|0]=0;x[c+708>>2]=0;v[c+821|0]=0;x[c+764>>2]=0;v[c+819|0]=0;v[c+820|0]=0;Jb(e+8|0,f,23);if(Gb(x[x[e+8>>2]>>2],x[e+12>>2])){v[c+807|0]=1;v[c+808|0]=0}v[c+839|0]=0;d=d+872|0;continue}break}w[a+1074450>>1]=b;w[a+1074446>>1]=0;b=a+1074424|0;x[b>>2]=0;x[b+4>>2]=0;x[a+1074392>>2]=-2;x[a+1074432>>2]=0;b=a+1074396|0;x[b>>2]=0;x[b+4>>2]=0;x[a+1074380>>2]=0}x[a+480208>>2]=x[a+480208>>2]&-769}fb=e+16|0}function Tla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=fb-16|0;fb=e;q=x[a+16>>2];r=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);i=x[a+8>>2];j=x[a+12>>2];b=x[a>>2];g=x[a+4>>2];k=x[a+128>>2];if(k){l=Hg(i,j,k);m=hb;h=x[a+76>>2];fg(b,g,vf(i,j,d),hb);n=hb>>>0>h>>>0?d:0}h=a+112|0;s=x[a+24>>2];t=x[a+20>>2];x[e>>2]=b;x[e+4>>2]=g;while(1){if(d){g=x[e+4>>2];b=x[e>>2];x[e+8>>2]=b;x[e+12>>2]=0;n=n-1|0;f=n;l=f?l:0;m=f?m:0;d=d-1|0;p=(((g&2147483647)<<1|b>>>31)&-2)+q|0;g=k;a:{b:while(1){c:{if((g|0)<=0){Pb(h,x[a+120>>2],x[a+124>>2]);g=x[a+116>>2];if(!g){break a}f=x[e+8>>2];o=((x[e+12>>2]&2147483647)<<1|f>>>31)&-2;f=0;b=0;break c}f=x[e+8>>2];o=((x[e+12>>2]&2147483647)<<1|f>>>31)&-2;b=0;f=0;while(1)if((b|0)==2){ce(h,f>>>3<<16>>16);be(h,4);Pb(e+8|0,l,m);g=g-1|0;continue b}else{f=(v[(b|o)+p|0]<<8)+f|0;b=b+1|0;continue}}break}while(1){if((b|0)!=2){f=(v[(b|o)+p|0]<<8)+f|0;b=b+1|0;continue}break}ce(h,f>>>3<<16>>16);be(h,g);x[h>>2]=x[h>>2];x[h+4>>2]=0}f=x[c>>2];b=Fg(h,r);x[c>>2]=f+D(b,t);x[c+4>>2]=x[c+4>>2]+D(b,s);Pb(e,i,j);c=c+8|0;continue}break}b=x[e+4>>2];x[a>>2]=x[e>>2];x[a+4>>2]=b;fb=e+16|0}function Ola(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=fb-16|0;fb=e;q=x[a+16>>2];r=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);l=x[a+8>>2];m=x[a+12>>2];b=x[a>>2];f=x[a+4>>2];n=x[a+128>>2];if(n){o=Hg(l,m,n);p=hb;g=x[a+76>>2];fg(b,f,vf(l,m,d),hb);k=hb>>>0>g>>>0?d:0}g=a+112|0;i=x[a+40>>2];j=x[a+36>>2];x[e>>2]=b;x[e+4>>2]=f;a:while(1){if(d){d=d-1|0;x[e+8>>2]=b;x[e+12>>2]=0;k=k-1|0;o=k?o:0;p=k?p:0;f=((((f&2147483647)<<1|b>>>31)&2147483646)<<1)+q|0;b=n;while(1)if((b|0)<=0){Pb(g,x[a+120>>2],x[a+124>>2]);b=x[a+116>>2];if(b){h=x[e+8>>2];h=(x[e+12>>2]&2147483647)<<1|h>>>31;ce(g,(w[((h&2147483646)<<1)+f>>1]+w[f+(h<<1|2)>>1]|0)/8<<16>>16);be(g,b);x[g>>2]=x[g>>2];x[g+4>>2]=0}f=x[a+32>>2];h=x[c>>2];b=Fg(g,r);j=x[a+28>>2]+j|0;x[c>>2]=D(b,j>>12)+h;i=f+i|0;x[c+4>>2]=x[c+4>>2]+D(b,i>>12);Pb(e,l,m);c=c+8|0;b=x[e>>2];f=x[e+4>>2];continue a}else{h=x[e+8>>2];h=(x[e+12>>2]&2147483647)<<1|h>>>31;ce(g,(w[((h&2147483646)<<1)+f>>1]+w[f+(h<<1|2)>>1]|0)/8<<16>>16);be(g,4);Pb(e+8|0,o,p);b=b-1|0;continue}}break}x[a>>2]=b;x[a+4>>2]=f;x[a+40>>2]=i;x[a+20>>2]=j>>12;x[a+36>>2]=j;x[a+24>>2]=i>>12;fb=e+16|0}function oM(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;f=fb-16|0;fb=f;d=f+8|0;xz(d,a);b=fb-96|0;fb=b;a=x[d+4>>2];ig(x[x[a>>2]-12>>2]+a|0,0);ae(b+80|0,x[d+4>>2]);a:{b:{e=x[d+4>>2];a=x[x[e>>2]-12>>2]+e|0;if(!pk(x[a+16>>2])){c=ci(b- -64|0,-1,-1);if(!ao(x[b+88>>2],x[b+92>>2],x[c+8>>2],x[c+12>>2])){break b}}ig(a,0);break a}Di(e,0,0,0);c=x[d+4>>2];a=x[x[c>>2]-12>>2]+c|0;if(pk(x[a+16>>2])){ig(a,0);c=x[d+4>>2];a=x[b+92>>2];x[b+8>>2]=x[b+88>>2];x[b+12>>2]=a;a=x[b+84>>2];x[b>>2]=x[b+80>>2];x[b+4>>2]=a;Um(c,b);a=x[d+4>>2];ig(x[x[a>>2]-12>>2]+a|0,0);break a}Di(c,0,0,2);c=x[d+4>>2];a=x[x[c>>2]-12>>2]+c|0;if(pk(x[a+16>>2])){ig(a,0);c=x[d+4>>2];a=x[b+92>>2];x[b+24>>2]=x[b+88>>2];x[b+28>>2]=a;a=x[b+84>>2];x[b+16>>2]=x[b+80>>2];x[b+20>>2]=a;Um(c,b+16|0);a=x[d+4>>2];ig(x[x[a>>2]-12>>2]+a|0,0);break a}ae(b- -64|0,c);e=x[d+4>>2];a=e+x[x[e>>2]-12>>2]|0;c:{if(!pk(x[a+16>>2])){c=ci(b+48|0,-1,-1);g=1;if(!ao(x[b+72>>2],x[b+76>>2],x[c+8>>2],x[c+12>>2])){break c}}ig(a,0);e=x[d+4>>2];g=0}a=x[b+92>>2];x[b+40>>2]=x[b+88>>2];x[b+44>>2]=a;a=x[b+84>>2];x[b+32>>2]=x[b+80>>2];x[b+36>>2]=a;Um(e,b+32|0);a=x[d+4>>2];ig(x[x[a>>2]-12>>2]+a|0,0)}fb=b+96|0;fb=f+16|0;return g|0}function ama(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0;h=fb-16|0;fb=h;e=x[a+48>>2];o=x[a+24>>2];p=x[a+20>>2];f=x[a+44>>2];q=x[a+16>>2];j=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=j;r=b+24|0;s=x[a+72>>2];k=x[a+68>>2];t=k>>31;l=x[a+64>>2];u=l>>31;m=x[a+60>>2];v=m>>31;j=x[a+8>>2];y=x[a+12>>2];while(1){b=f;if(d){f=Yb(f,-16777216,16776704);g=Iua(l,u,f,f>>31);f=hb;e=Yb(e,-16777216,16776704);e=Iua(k,t,e,e>>31);g=e+g|0;f=hb+f|0;f=e>>>0>g>>>0?f+1|0:f;e=x[h+8>>2];i=g;g=(x[h+12>>2]<<1)+q|0;e=(((e>>>16|0)+4&131064)<<1)+r|0;n=(((((D(w[g+4>>1],w[e+10>>1])+D(w[g+2>>1],w[e+8>>1])|0)+D(w[g+6>>1],w[e+12>>1])|0)+D(w[g+8>>1],w[e+14>>1])|0)/2|0)+((((D(w[g-4>>1],w[e+2>>1])+D(w[g-6>>1],w[e>>1])|0)+D(w[g-2>>1],w[e+4>>1])|0)+D(w[g>>1],w[e+6>>1])|0)/2|0)|0)/16384<<8;e=n;g=Iua(e,e>>31,m,v);i=i+g|0;e=hb+f|0;e=g>>>0>i>>>0?e+1|0:e;f=i+8388608|0;e=f>>>0<8388608?e+1|0:e;f=Sc(f,e,24);e=(f|0)/256|0;x[c>>2]=D(e,p)+x[c>>2];x[c+4>>2]=x[c+4>>2]+D(e,o);Pb(h+8|0,j,y);f=f-(s&n)|0;c=c+8|0;d=d-1|0;e=b;continue}break}c=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=c;x[a+48>>2]=e;x[a+44>>2]=b;fb=h+16|0}function Dsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;nd(b,32);fp(b);f=b,g=ze((y[a+50|0]|y[a+51|0]<<8)<<16>>16)>>>2|0,w[f+32>>1]=g;if((ze((y[a+32|0]|y[a+33|0]<<8)<<16>>16)|0)>0){w[b+34>>1]=z[b+34>>1]|32;c=ze((y[a+32|0]|y[a+33|0]<<8)<<16>>16);e=c>>>24|0;d=(c<<8&-256)+2047|0;c=e&255;f=b,g=Bc(Kua(d,d>>>0<2047?c+1|0:c,4095,0),hb),w[f+28>>1]=g}c=$b(y[a+38|0]|y[a+39|0]<<8|(y[a+40|0]<<16|y[a+41|0]<<24));x[b>>2]=c;d=$b(y[a+42|0]|y[a+43|0]<<8|(y[a+44|0]<<16|y[a+45|0]<<24));x[b+4>>2]=d;e=$b(y[a+42|0]|y[a+43|0]<<8|(y[a+44|0]<<16|y[a+45|0]<<24))+$b(y[a+46|0]|y[a+47|0]<<8|(y[a+48|0]<<16|y[a+49|0]<<24))|0;x[b+8>>2]=e;if((Bb(y[a+34|0]|y[a+35|0]<<8)|0)==16){x[b+8>>2]=e>>>1;x[b+4>>2]=d>>>1;x[b>>2]=c>>>1}a:{b:{c:{if($b(y[a+42|0]|y[a+43|0]<<8|(y[a+44|0]<<16|y[a+45|0]<<24))){c=z[b+34>>1];break c}c=z[b+34>>1];if($b(y[a+46|0]|y[a+47|0]<<8|(y[a+48|0]<<16|y[a+49|0]<<24))>>>0<3){break b}}c=c|2;break a}c=c&65533}w[b+34>>1]=c;f=b,g=c&65531|Bb(y[a+30|0]|y[a+31|0]<<8)<<1&4,w[f+34>>1]=g;f=b,g=Bb(y[a+36|0]|y[a+37|0]<<8)<<1,x[f+24>>2]=g;c=ze((y[a+52|0]|y[a+53|0]<<8)<<16>>16);if(c){$l(b,+(c|0)/96);c=ze((y[a+52|0]|y[a+53|0]<<8)<<16>>16)}v[b+37|0]=c<<4}function Dka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;if(x[a+4>>2]!=x[Ab(a)>>2]){d=fb-16|0;fb=d;c=d+4|0;x[c>>2]=a;a=x[a+4>>2];x[c+4>>2]=a;x[c+8>>2]=a+32;QS(x[c+4>>2],b);x[c+4>>2]=x[c+4>>2]+32;kc(c);fb=d+16|0;return}j=fb-32|0;fb=j;c=Ab(a);c=iv(j+12|0,Vq(a,Mg(x[a>>2],x[a+4>>2])+1|0),Mg(x[a>>2],x[a+4>>2]),c);QS(x[c+8>>2],b);x[c+8>>2]=x[c+8>>2]+32;h=fb-16|0;fb=h;b=vb(h+12|0,x[a+4>>2]);e=vb(h+8|0,x[a>>2]);f=x[vb(h+4|0,x[c+4>>2])>>2];i=fb-16|0;fb=i;d=fb-32|0;fb=d;fd(d+24|0,x[b>>2],x[e>>2]);k=d+16|0;b=x[d+24>>2];l=x[d+28>>2];g=fb-16|0;fb=g;x[g+8>>2]=f;x[g+12>>2]=b;while(1){if(Fd(b,l)){b=gn(b);e=gn(x[g+8>>2]);f=y[b+23|0]|y[b+24|0]<<8|(y[b+25|0]<<16|y[b+26|0]<<24);v[e+23|0]=f;v[e+24|0]=f>>>8;v[e+25|0]=f>>>16;v[e+26|0]=f>>>24;f=x[b+20>>2];x[e+16>>2]=x[b+16>>2];x[e+20>>2]=f;f=x[b+12>>2];x[e+8>>2]=x[b+8>>2];x[e+12>>2]=f;f=x[b+4>>2];x[e>>2]=x[b>>2];x[e+4>>2]=f;b=To(g+12|0);To(g+8|0);b=x[b>>2];continue}break}rc(k,b,g+8|0);fb=g+16|0;b=x[d+16>>2];x[d+12>>2]=x[d+20>>2];rc(i+8|0,b,d+12|0);fb=d+32|0;fb=i+16|0;x[c+4>>2]=x[i+12>>2];Tb(a,c+4|0);Tb(a+4|0,c+8|0);Tb(Ab(a),nc(c));x[c>>2]=x[c+4>>2];fb=h+16|0;SV(c);fb=j+32|0}function kia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=fb-16|0;fb=h;if(!y[a+4242|0]){_z(a);a:{if(!y[a+4240|0]){break a}e=PA(x[a+16>>2]);if(e==C[a+4288>>3]){break a}C[a+4288>>3]=e;pu(a)}f=a+4256|0;b:{if(y[a+4244|0]){if(C[f>>3]>1){x[f>>2]=0;x[f+4>>2]=1072693248}break b}i=(x[a+4232>>2]&-2)!=4;e=C[f>>3];c:{if(F(e)<2147483648){g=~~e;break c}g=-2147483648}if(!(i|(g|0)<=0)){Zz(a);e=C[a+4256>>3]}C[f>>3]=e-+(g|0)}e=0;d:{e:{switch(x[a+4232>>2]){case 0:e=Ri(C[f>>3]*6.283185307179586);break d;case 1:e=F(C[f>>3]+-.5)*-4+1;break d;case 2:e=C[f>>3];e=e+e+-1;break d;case 3:e=C[f>>3]<.5?-1:1;break d;case 4:e=C[a+4272>>3];break d;case 5:break e;default:break d}}e=C[a+4256>>3];e=e*(e*e)*(e*(e*6+-15)+10);e=C[a+4280>>3]*e+C[a+4272>>3]*(1-e)}C[h+8>>3]=(y[a+4241|0]?-e:e)*+B[a+4220>>2]+ +B[a+4224>>2];IT(h+8|0,1);g=yj(a);f:{if(!g){break f}f=x[a+4236>>2];if(y[a+4243|0]){k=g,l=(f>>>8&15|176)&191|(f&127)<<8|_l(C[h+8>>3]*127)<<16,j=x[x[g>>2]+68>>2],ib[j](k|0,l|0)|0;break f}ib[x[x[g>>2]+44>>2]](g,f,E(C[h+8>>3]))}C[a+4256>>3]=C[a+4264>>3]*+(d>>>0)+C[a+4256>>3]}g=a;a=x[a+44>>2];Ki(g,b,c,Hc(a,0),Hc(a,1),d);fb=h+16|0}function ZY(a,b,c){var d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;v[d+15|0]=c;a:{if(b>>>0>=22){v[d+14|0]=0;ee(a,0,d+14|0);break a}e=y[b+25072|0];b:{c:{switch(b-8|0){case 0:v[d+15|0]=c<<1;break b;case 4:v[d+15|0]=c+1>>>1;break b;case 5:v[d+15|0]=D(c>>>4|0,10)+(c&15);break b;case 6:d:{switch((c>>>4|0)-1|0){default:e=0;break b;case 0:v[d+13|0]=c&15;v[d+12|0]=14;f=d,g=y[Qb(d+13|0,d+12|0)|0]<<4|15,v[f+15|0]=g;e=29;break b;case 1:v[d+11|0]=c&15;v[d+10|0]=14;f=d,g=y[Qb(d+11|0,d+10|0)|0]|240,v[f+15|0]=g;e=29;break b;case 3:v[d+15|0]=c&15|48;break b;case 4:v[d+15|0]=c<<4^128;e=35;break b;case 5:v[d+15|0]=c&15|176;break b;case 6:v[d+15|0]=c&15|64;break b;case 8:e=15;v[d+15|0]=c&15;break b;case 9:v[d+15|0]=(c<<3&120)+8&240;e=24;break b;case 10:v[d+15|0]=(c&15)+1>>>1;e=24;break b;case 14:break d;case 11:case 12:case 13:break b}}e=10;break b;case 8:if(c>>>0<=223){b=c>>>2|0;v[d+15|0]=(b>>>0>=15?15:b)<<4;break b}if(c>>>0<=239){v[d+15|0]=c<<2&48|15;break b}v[d+15|0]=c<<4|15;break b;case 9:break c;default:break b}}if(c>>>0<=223){b=c>>>2|0;v[d+15|0]=b>>>0>=15?15:b;break b}if(c>>>0>239){break b}v[d+15|0]=c>>>2&3|240}ee(a,e,d+15|0)}fb=d+16|0}function xma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=fb-16|0;fb=e;a:{b:{c:{f=x[a+12>>2];h=x[a+8>>2];d:{if((f|0)<=1&h>>>0<=805306368|(f|0)<=0){if((f|0)>=-2&h>>>0>=3489660928|(f|0)>-2){break c}if((f|0)==-2&h>>>0>2147483647|(f|0)==-1){break d}break b}if((f|0)==1&h>>>0>2147483648|f>>>0>1){break b}}j=b+196648|0;break a}j=b+131112|0;break a}j=b+262184|0}k=x[a+16>>2];l=x[a+24>>2];m=x[a+20>>2];b=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=b;while(1){if(d){b=x[e+8>>2];g=((((x[e+12>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+k|0;b=(b>>>16&65520)+j|0;n=w[b+14>>1];o=w[b+12>>1];p=w[b+10>>1];q=w[b+8>>1];r=w[b+6>>1];s=w[b+4>>1];t=w[b+2>>1];u=w[b>>1];i=0;while(1){if((i|0)!=2){b=i<<1;x[(i<<2)+e>>2]=(((((((D(w[g+(b|-8)>>1],t)+D(w[g+(b|-12)>>1],u)|0)+D(w[g+(b|-4)>>1],s)|0)+D(w[b+g>>1],r)|0)+D(w[g+(b|4)>>1],q)|0)+D(w[g+(b|8)>>1],p)|0)+D(w[g+(b|12)>>1],o)|0)+D(w[g+(b|16)>>1],n)|0)/32768;i=i+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[e>>2],m);x[c+4>>2]=x[c+4>>2]+D(x[e+4>>2],l);Pb(e+8|0,h,f);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;fb=e+16|0}function r7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;a=fb-448|0;fb=a;x[a+440>>2]=c;x[a+444>>2]=b;x[a+20>>2]=1274;i=a+20|0;b=De(a+24|0,a+32|0,i);j=a+16|0;cd(j,x[e+28>>2]);x[31609]=0;h=R(1252,x[a+16>>2])|0;k=x[31609];x[31609]=0;if((k|0)!=1){a:{v[a+15|0]=0;e=x[e+4>>2];x[31609]=0;c=na(1283,a+444|0,c|0,d|0,j|0,e|0,f|0,a+15|0,h|0,b|0,i|0,a+432|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}b:{c:{if(!c){break c}d:{if(vd(y[g+11|0])){yd(x[g>>2],0);Bd(g,0);break d}yd(g,0);Ne(g,0)}if(y[a+15|0]){x[31609]=0;c=P(1270,h|0,45)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}x[31609]=0;O(35,g|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}}x[31609]=0;d=P(1270,h|0,48)|0;c=x[31609];x[31609]=0;if((c|0)==1){break b}e=x[a+20>>2];h=e-4|0;c=x[b>>2];while(1){if(!((d|0)!=x[c>>2]|c>>>0>=h>>>0)){c=c+4|0;continue}break}x[31609]=0;U(1288,g|0,c|0,e|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break c}break a}x[31609]=0;c=P(1257,a+444|0,a+440|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}if(c){x[f>>2]=x[f>>2]|2}c=x[a+444>>2];_b(a+16|0);Lc(b);fb=a+448|0;return c|0}}}c=N()|0;_b(a+16|0);Lc(b);Q(c|0);p()}function bma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0,z=0;h=fb-16|0;fb=h;e=x[a+48>>2];o=x[a+24>>2];p=x[a+20>>2];f=x[a+44>>2];q=x[a+16>>2];j=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=j;r=b+24|0;s=x[a+72>>2];k=x[a+68>>2];t=k>>31;l=x[a+64>>2];u=l>>31;m=x[a+60>>2];y=m>>31;j=x[a+8>>2];z=x[a+12>>2];while(1){b=f;if(d){f=Yb(f,-16777216,16776704);g=Iua(l,u,f,f>>31);f=hb;e=Yb(e,-16777216,16776704);e=Iua(k,t,e,e>>31);g=e+g|0;f=hb+f|0;f=e>>>0>g>>>0?f+1|0:f;e=x[h+8>>2];i=g;g=x[h+12>>2]+q|0;e=(((e>>>16|0)+4&131064)<<1)+r|0;n=((((D(v[g+2|0],w[e+10>>1])+D(v[g+1|0],w[e+8>>1])|0)+D(v[g+3|0],w[e+12>>1])|0)+D(v[g+4|0],w[e+14>>1])<<8>>1)+(((D(v[g-2|0],w[e+2>>1])+D(v[g-3|0],w[e>>1])|0)+D(v[g-1|0],w[e+4>>1])|0)+D(v[g|0],w[e+6>>1])<<8>>1)|0)/16384<<8;e=n;g=Iua(e,e>>31,m,y);i=i+g|0;e=hb+f|0;e=g>>>0>i>>>0?e+1|0:e;f=i+8388608|0;e=f>>>0<8388608?e+1|0:e;f=Sc(f,e,24);e=(f|0)/256|0;x[c>>2]=D(e,p)+x[c>>2];x[c+4>>2]=x[c+4>>2]+D(e,o);Pb(h+8|0,j,z);f=f-(s&n)|0;c=c+8|0;d=d-1|0;e=b;continue}break}c=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=c;x[a+48>>2]=e;x[a+44>>2]=b;fb=h+16|0}function Dma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0;g=fb-16|0;fb=g;f=x[a+48>>2];i=x[a+40>>2];j=x[a+36>>2];e=x[a+44>>2];q=x[a+16>>2];b=x[a+4>>2];x[g+8>>2]=x[a>>2];x[g+12>>2]=b;r=x[a+32>>2];s=x[a+28>>2];t=x[a+72>>2];n=x[a+68>>2];u=n>>31;o=x[a+64>>2];v=o>>31;p=x[a+60>>2];y=p>>31;z=x[a+8>>2];A=x[a+12>>2];while(1){b=e;if(d){e=Yb(e,-16777216,16776704);k=Iua(o,v,e,e>>31);l=hb;e=x[g+8>>2];h=(x[g+12>>2]<<1)+q|0;e=e>>>21&2040;h=(((D(w[h>>1],w[e+38082>>1])+D(w[h-2>>1],w[e+38080>>1])|0)+D(w[h+2>>1],w[e+38084>>1])|0)+D(w[h+4>>1],w[e+38086>>1])|0)/16384<<8;e=h;e=Iua(e,e>>31,p,y);k=e+k|0;m=hb+l|0;m=e>>>0>k>>>0?m+1|0:m;f=Yb(f,-16777216,16776704);e=Iua(n,u,f,f>>31);l=e+k|0;f=hb+m|0;f=e>>>0>l>>>0?f+1|0:f;e=l+8388608|0;f=e>>>0<8388608?f+1|0:f;e=Sc(e,f,24);f=(e|0)/256|0;j=j+s|0;x[c>>2]=D(f,j>>12)+x[c>>2];i=i+r|0;x[c+4>>2]=x[c+4>>2]+D(f,i>>12);Pb(g+8|0,z,A);e=e-(h&t)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=x[g+12>>2];x[a>>2]=x[g+8>>2];x[a+4>>2]=c;x[a+40>>2]=i;x[a+20>>2]=j>>12;x[a+36>>2]=j;x[a+48>>2]=f;x[a+44>>2]=b;x[a+24>>2]=i>>12;fb=g+16|0}function Haa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;b=fb+-64|0;fb=b;c=x[a>>2];a=x[c>>2];d=x[a+4>>2];x[b+40>>2]=x[a+20>>2];e=x[a+16>>2];x[b+32>>2]=x[a+12>>2];x[b+36>>2]=e;Xf(b+48|0,b+32|0,d);a=x[c+4>>2];d=x[a+8>>2];e=x[a+4>>2];c=x[b+60>>2];x[b+24>>2]=x[b+56>>2];x[b+28>>2]=c;c=x[b+52>>2];x[b+16>>2]=x[b+48>>2];x[b+20>>2]=c;x[b+8>>2]=x[a+8>>2];c=x[a+4>>2];x[b>>2]=x[a>>2];x[b+4>>2]=c;a=fb-32|0;fb=a;a:{b:{c:{d:{g=x[b+4>>2];if(g>>>0>=e>>>0){h=x[b+20>>2];if(h>>>0<e>>>0){break d}if(d>>>0>A[b+8>>2]){break c}i=x[b+28>>2];if(d>>>0>x[b+24>>2]-i>>>0){break b}l=x[b+16>>2];m=x[b>>2];e:while(1){if((d|0)==(f|0)){break a}n=(D(f,g)<<3)+m|0;o=(D(f+i|0,h)<<1)+l|0;c=0;while(1)if((c|0)==(e|0)){f=f+1|0;continue e}else{C[a+24>>3]=C[(c<<3)+n>>3];x[a+16>>2]=0;x[a+20>>2]=-1074790400;x[a+8>>2]=0;x[a+12>>2]=1072693248;q=(c<<1)+o|0;j=Ge(C[Yg(a+24|0,a+16|0,a+8|0)>>3]*32768);f:{if(F(j)<2147483648){k=~~j;break f}k=-2147483648}r=q,s=gd(k),w[r>>1]=s;c=c+1|0;continue}}}_(7244,9061,77,8741);p()}_(7209,9061,78,8741);p()}_(5897,9061,79,8741);p()}_(5867,9061,80,8741);p()}fb=a+32|0;fb=b- -64|0}function Ema(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0,z=0,A=0;h=fb-16|0;fb=h;e=x[a+48>>2];i=x[a+40>>2];j=x[a+36>>2];f=x[a+44>>2];p=x[a+16>>2];b=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=b;q=x[a+32>>2];r=x[a+28>>2];s=x[a+72>>2];l=x[a+68>>2];t=l>>31;m=x[a+64>>2];u=m>>31;n=x[a+60>>2];y=n>>31;z=x[a+8>>2];A=x[a+12>>2];while(1){b=f;if(d){f=Yb(f,-16777216,16776704);g=Iua(m,u,f,f>>31);f=hb;e=Yb(e,-16777216,16776704);e=Iua(l,t,e,e>>31);g=e+g|0;f=hb+f|0;f=e>>>0>g>>>0?f+1|0:f;e=x[h+8>>2];k=g;g=x[h+12>>2]+p|0;e=e>>>21&2040;o=(((D(v[g|0],w[e+38082>>1])+D(v[g-1|0],w[e+38080>>1])|0)+D(v[g+1|0],w[e+38084>>1])|0)+D(v[g+2|0],w[e+38086>>1])<<8)/16384<<8;e=o;g=Iua(e,e>>31,n,y);k=k+g|0;e=hb+f|0;e=g>>>0>k>>>0?e+1|0:e;f=k+8388608|0;e=f>>>0<8388608?e+1|0:e;f=Sc(f,e,24);e=(f|0)/256|0;j=j+r|0;x[c>>2]=D(e,j>>12)+x[c>>2];i=i+q|0;x[c+4>>2]=x[c+4>>2]+D(i>>12,e);Pb(h+8|0,z,A);f=f-(s&o)|0;c=c+8|0;d=d-1|0;e=b;continue}break}c=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=c;x[a+40>>2]=i;x[a+20>>2]=j>>12;x[a+36>>2]=j;x[a+48>>2]=e;x[a+44>>2]=b;x[a+24>>2]=i>>12;fb=h+16|0}function sI(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;l=fb-16|0;fb=l;g=y[a|0];a:{if(!g){f=a;break a}f=a;b:{while(1){if(!hl(g<<24>>24)){break b}g=y[f+1|0];f=f+1|0;if(g){continue}break}break a}c:{h=g&255;switch(h-43|0){case 0:case 2:break c;default:break a}}j=(h|0)==45?-1:0;f=f+1|0}d:{if(!((c|16)!=16|y[f|0]!=48)){n=1;if((y[f+1|0]&223)==88){f=f+2|0;m=16;break d}f=f+1|0;m=c?c:8;break d}m=c?c:10}c=0;while(1){e:{h=y[f|0];g=h-48|0;f:{if((g&255)>>>0<10){break f}if((h-97&255)>>>0<=25){g=h-87|0;break f}if((h-65&255)>>>0>25){break e}g=h-55|0}g=g&255;if((g|0)>=(m|0)){break e}Nf(l,m,0,0,0,k,i,0,0);h=1;g:{if(x[l+8>>2]|x[l+12>>2]){break g}o=Iua(k,i,m,0);p=hb;if((p|0)==-1&(g^-1)>>>0<o>>>0){break g}i=p;k=g+o|0;i=k>>>0<g>>>0?i+1|0:i;n=1;h=c}f=f+1|0;c=h;continue}break}if(b){x[b>>2]=n?f:a}h:{i:{j:{if(c){x[31484]=68;a=d&1;j=a?0:j;k=d;i=e;break j}if((e|0)==(i|0)&d>>>0>k>>>0|e>>>0>i>>>0){break i}a=d&1}if(!(a|j)){x[31484]=68;a=d;d=a-1|0;e=e-!a|0;break h}if((e|0)==(i|0)&d>>>0>=k>>>0|e>>>0>i>>>0){break i}x[31484]=68;break h}a=j^k;d=a-j|0;b=j>>31;e=(b^i)-((a>>>0<j>>>0)+b|0)|0}fb=l+16|0;hb=e;return d}function Qaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;b=fb+-64|0;fb=b;c=x[a>>2];a=x[c>>2];d=x[a+4>>2];x[b+40>>2]=x[a+20>>2];e=x[a+16>>2];x[b+32>>2]=x[a+12>>2];x[b+36>>2]=e;Xf(b+48|0,b+32|0,d);a=x[c+4>>2];d=x[a+8>>2];e=x[a+4>>2];c=x[b+60>>2];x[b+24>>2]=x[b+56>>2];x[b+28>>2]=c;c=x[b+52>>2];x[b+16>>2]=x[b+48>>2];x[b+20>>2]=c;x[b+8>>2]=x[a+8>>2];c=x[a+4>>2];x[b>>2]=x[a>>2];x[b+4>>2]=c;a=fb-32|0;fb=a;a:{b:{c:{d:{g=x[b+4>>2];if(g>>>0>=e>>>0){if(A[b+20>>2]<e>>>0){break d}if(d>>>0>A[b+8>>2]){break c}h=x[b+28>>2];if(d>>>0>x[b+24>>2]-h>>>0){break b}k=x[b+16>>2];l=x[b>>2];e:while(1){if((d|0)==(f|0)){break a}m=(D(f,g)<<3)+l|0;c=0;while(1)if((c|0)==(e|0)){f=f+1|0;continue e}else{C[a+24>>3]=C[(c<<3)+m>>3];x[a+16>>2]=0;x[a+20>>2]=-1074790400;x[a+8>>2]=0;x[a+12>>2]=1072693248;n=(c<<2)+k|0;i=Ge(C[Yg(a+24|0,a+16|0,a+8|0)>>3]*32768);f:{if(F(i)<2147483648){j=~~i;break f}j=-2147483648}o=(x[n>>2]+(h<<1)|0)+(f<<1)|0,q=gd(j),w[o>>1]=q;c=c+1|0;continue}}}_(7244,9061,77,8741);p()}_(7209,9061,78,8741);p()}_(5897,9061,79,8741);p()}_(5867,9061,80,8741);p()}fb=a+32|0;fb=b- -64|0}function tT(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;e=x[b+64>>2];a:{b:{g=x[b+60>>2];f=z[b+68>>1];if(!((g|0)==-1&(f|0)==65535)){c:{d:{if((e|0)==-1){break d}e=a+1074312|0;if(Ob(e,68)){break d}f=(f|0)!=65535;if(h=Ob(e,103),i=0,j=f,j?h:i){break c}if(h=Ob(e,49),i=0,j=f,j?h:i){break c}e=x[b+64>>2];break b}if((f|0)!=65535){break c}w[b+68>>1]=z[b+72>>1]+1}if((g|0)==-1){x[b+60>>2]=0}f=$c(x[c>>2],x[c+4>>2]);e=z[b+68>>1];if(f>>>0<=e>>>0){e=z[c+28>>1];w[b+68>>1]=e}e:{if(z[b+72>>1]==(e&65535)){break e}c=a+1074312|0;if(Ob(c,26)){break e}if(Ob(c,68)|x[a+480180>>2]==1){break e}c=z[a+480188>>1];e=0;while(1){if((c|0)==(e|0)){break e}v[(D(e,872)+b|0)+1457|0]=0;e=e+1|0;continue}}x[b+52>>2]=x[b+60>>2];if(d){e=1;if(y[a+480208|0]&32){break a}}w[b+74>>1]=z[b+68>>1];return 1}if((e|0)!=-1){break b}e=0;break a}x[b+52>>2]=e;w[b+74>>1]=z[b+72>>1];f:{if(!x[b+20>>2]){break f}c=x[a+480180>>2];if((c|0)==32){if(Ob(a+1074312|0,103)){break f}c=x[a+480180>>2]}if((c|0)==2){break f}x[b+52>>2]=x[b+52>>2]+1}e=0;if(A[b+64>>2]<A[Wb(x[a+484344>>2],z[b+70>>1])+12>>2]){break a}x[b+52>>2]=0;w[b+74>>1]=z[b+74>>1]+1;return 0}return e}function Jo(a,b,c){var d=0,e=0,f=0,g=0;f=a+1074312|0;d=Ob(f,96);x[b+660>>2]=(d?0:x[b+660>>2])+c;e=x[a+480180>>2];d=x[b+84>>2];if(!(!(e&18)|d>>>0>c>>>0|(!(y[b+88|0]&2)|!d))){g=c;c=x[b+80>>2];c=((g-c>>>0)%(d-c>>>0)|0)+c|0}c=c>>>(x[b+88>>2]&(e|0)==16384)|0;a:{b:{if(!Tc(y[b+788|0])){if(!Ob(f,114)){break b}}d=x[b+656>>2];c:{if(!d){break c}e=y[b+788|0];if(!Tc(e)){break c}if((z[bc(d+236|0,e-1|0)>>1]-1&65535)>>>0>=z[a+480190>>1]){break a}}if(y[a+480210|0]&32){d=c;c=x[b+660>>2];x[b+660>>2]=d+c}x[b>>2]=0;x[b+4>>2]=c;if((!(y[b+88|0]&2)|A[b+84>>2]>c>>>0)&A[b+76>>2]>c>>>0){break a}d:{if(!Ob(f,57)){c=x[a+480180>>2];if((c|0)!=16){break d}}x[b+700>>2]=0;x[b+88>>2]=x[b+88>>2]|2097152;return}if(!(c&1048581)){if(Ob(f,27)){if(y[a+480208|0]&4){c=x[b+76>>2];x[b>>2]=0;x[b+4>>2]=c;return}x[b>>2]=0;x[b+4>>2]=0;return}c=x[b+80>>2];d=0;x[b>>2]=d;x[b+4>>2]=c;if(!(y[a+480208|0]&4)){break a}a=x[b+76>>2];if(a>>>0<5){break a}x[b>>2]=d;x[b+4>>2]=a-2;return}if(!(y[b+88|0]&2)|(c|0)!=1){break a}a=x[b+80>>2];x[b>>2]=0;x[b+4>>2]=a;return}if(!(x[a+480180>>2]&268582928)|A[b+76>>2]<=c>>>0){break a}x[b>>2]=0;x[b+4>>2]=c}}function yma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=fb-16|0;fb=e;a:{b:{c:{f=x[a+12>>2];h=x[a+8>>2];d:{if((f|0)<=1&h>>>0<=805306368|(f|0)<=0){if((f|0)>=-2&h>>>0>=3489660928|(f|0)>-2){break c}if((f|0)==-2&h>>>0>2147483647|(f|0)==-1){break d}break b}if((f|0)==1&h>>>0>2147483648|f>>>0>1){break b}}i=b+196648|0;break a}i=b+131112|0;break a}i=b+262184|0}j=x[a+16>>2];k=x[a+24>>2];l=x[a+20>>2];b=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=b;while(1){if(d){b=x[e+8>>2];g=(((x[e+12>>2]&2147483647)<<1|b>>>31)&-2)+j|0;b=(b>>>16&65520)+i|0;m=w[b+14>>1];n=w[b+12>>1];o=w[b+10>>1];p=w[b+8>>1];q=w[b+6>>1];r=w[b+4>>1];s=w[b+2>>1];t=w[b>>1];b=0;while(1){if((b|0)!=2){x[(b<<2)+e>>2]=(((((((D(v[(b|-4)+g|0],s)+D(v[(b|-6)+g|0],t)|0)+D(v[(b|-2)+g|0],r)|0)+D(v[b+g|0],q)|0)+D(v[(b|2)+g|0],p)|0)+D(v[(b|4)+g|0],o)|0)+D(v[(b|6)+g|0],n)|0)+D(v[(b|8)+g|0],m)<<8)/32768;b=b+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[e>>2],l);x[c+4>>2]=x[c+4>>2]+D(x[e+4>>2],k);Pb(e+8|0,h,f);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;fb=e+16|0}function tka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=fb-16|0;fb=i;x[i+12>>2]=b;o=Pf(a);while(1){if(Zg(b,c)){e=x[vb(i+8|0,o)>>2];j=ud(b);m=fb-16|0;fb=m;n=0;k=fb-16|0;fb=k;g=fb-32|0;fb=g;f=g+28|0;d=g+24|0;h=fb-16|0;fb=h;a:{b:{b=e;if(!mc(b,x[vb(h+12|0,pg(a))>>2])){e=y[j|0];l=y[ud(b)|0];if(!Bo(e,l)){break b}}x[h+12>>2]=b;c:{if(!mc(b,x[vb(h+8|0,wb(x[a>>2]))>>2])){d=x[LB(h+12|0)>>2];l=y[ud(d)|0];e=y[j|0];if(Bo(l,e)){break c}b=gB(a,f,e);break a}d=b}if(!x[b>>2]){x[f>>2]=b;break a}x[f>>2]=d;b=d+4|0;break a}if(Bo(l,e)){d:{d=JB(b);if(!mc(d,x[vb(h+12|0,pg(a))>>2])){e=y[j|0];if(!Bo(e,y[ud(d)|0])){break d}}if(!x[b+4>>2]){x[f>>2]=b;b=b+4|0;break a}x[f>>2]=d;b=d;break a}b=gB(a,f,e);break a}x[f>>2]=b;x[d>>2]=b;b=d}fb=h+16|0;d=x[b>>2];if(!d){d=fb-16|0;fb=d;f=gc(a);e=g+12|0;f=Dh(e,Ec(24),Og(d+8|0,f));RS(x[f>>2]+16|0,x[j>>2],x[j+4>>2]);p=gc(f),q=1,v[p+4|0]=q;fb=d+16|0;$g(a,x[g+28>>2],b,x[g+12>>2]);d=ne(e);Jk(e);n=1}_g(k+8|0,x[vb(g+12|0,d)>>2],n);fb=g+32|0;fb=k+16|0;vb(m+12|0,x[k+8>>2]);fb=m+16|0;b=x[ah(i+12|0)>>2];continue}else{fb=i+16|0}break}}function tua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=fb-32|0;fb=g;v[g+16|0]=0;m=z0(g+20|0,d,g+16|0);f=x[m>>2];x[g+16>>2]=d;h=d;while(1){if(!(!b|!h)){a:{i=b-1|0;k=y[a|0];if(!(!i|(k|0)!=(e&255))){x[g+12>>2]=y[a+1|0];i=a+2|0;j=Hb(g+12|0,g+16|0);b:{k=b-2|0;if(!k){break b}j=x[j>>2];if(!(j&255)){break b}i=y[i|0];while(1){if(!(j&255)){break a}v[f|0]=i;h=x[g+16>>2]-1|0;x[g+16>>2]=h;f=f+1|0;j=j-1|0;continue}}v[f|0]=e;h=x[g+16>>2]-1|0;x[g+16>>2]=h;f=f+1|0;b=k;a=i;continue}a=a+1|0;v[f|0]=k;h=x[g+16>>2]-1|0;x[g+16>>2]=h;f=f+1|0;b=i;continue}b=b-3|0;a=a+3|0;continue}break}e=d-h|0;a=x[m>>2];k=0;f=128;b=0;i=0;c:while(1){if((e|0)==(i|0)){while(1){if(e){d=k<<24>>24;b=v[c|0];a=128;d:{if((b|0)==-128){break d}a=b;if((b|0)>=0){break d}a=0-(b&127)|0}k=d-(a&255)|0;v[c|0]=k;e=e-1|0;c=c+1|0;continue}break}ec(m);fb=g+32|0;return}n=y[a|0];h=0;j=0;while(1)if((j&65535)>>>0>=8){f=f&65535;f=(f<<8|f)>>>h&255;i=i+1|0;a=a+1|0;continue c}else{l=b+c|0;v[l|0]=y[l|0]|D(f&n,257)>>>(h-j&7);b=b+1|0;l=b>>>0>=d>>>0;b=l?0:b;j=j+1|0;h=h+l|0;f=(f<<8|f)>>>1&255;continue}}}function eC(a,b){var c=0,d=0,e=0,f=0,g=0;d=fb-32|0;fb=d;w[a+34>>1]=z[a+34>>1]&65407;if(b&5){if((b|0)==1){e=Iua(x[a+24>>2],0,8363,0);c=hb;e=e+4143|0;c=e>>>0<4143?c+1|0:c;f=a,g=Bc(Kua(e,c,8287,0),hb),x[f+24>>2]=g}yV(a)}if(b&3){w[a+38>>1]=0;w[a+40>>1]=0;v[a+36|0]=0;w[a+34>>1]=z[a+34>>1]&65499}if(b&7){w[a+32>>1]=64;c=z[a+34>>1];if(c&8){e=x[a+16>>2];x[a+4>>2]=x[a+12>>2];x[a+8>>2]=e;c=c&16?c|6:c&65513|2}x[a+12>>2]=0;x[a+16>>2]=0;w[a+34>>1]=c&65511}a:{if(!(b&4)){break a}c=z[a+34>>1];if(!(c&32)){w[a+28>>1]=128;w[a+34>>1]=c|32}Of(a+40|0,15);Of(a+41|0,63);if(!y[a+41|0]){break a}e=y[a+40|0];if(!e){break a}c=y[a+39|0];if(c){c=ti(Bc(((e<<8|c>>>1)>>>0)/(c>>>0)|0,0))}else{c=255}v[a+39|0]=c}b:{c:{if((b|0)!=4){if((b|0)==16777216){break b}if((b|0)!=32|y[a+38|0]!=2){break c}v[a+38|0]=3;break c}if(y[a+38|0]!=4){break c}v[a+38|0]=0}w[a+34>>1]=z[a+34>>1]&49151}d:{if(!(!(y[a+35|0]&2)|b&16777218)){x[d+24>>2]=0;x[d+8>>2]=0;x[d+16>>2]=0;x[d+20>>2]=0;x[d>>2]=0;x[d+4>>2]=0;Tk(a,0,d);break d}if(!(y[a+35|0]&2)|(b|0)!=2){break d}a=a+68|0;b=xb(a,8);v[b|0]=y[b|0]&3;a=xb(a,9);v[a|0]=y[a|0]&3}fb=d+32|0}function tta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;d=fb-1072|0;fb=d;x[d+1068>>2]=c;o=d,q=Zd(b),v[o+8|0]=q;v[d+4|0]=1;c=d+8|0;e=d+4|0;h=y[cf(c,e)|0];f=eE(c,b);l=zr(f);x[31609]=0;c=R(202,b|0)|0;g=x[31609];x[31609]=0;a:{if((g|0)!=1){x[d+4>>2]=c;x[d>>2]=536870911;xc(d+1068|0,x[Hb(e,d)>>2]<<3);x[31609]=0;m=x[d+1068>>2];k=P(341,a|0,m|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){x[31609]=0;c=8;i=P(158,f|0,8)|0;a=x[31609];x[31609]=0;b:{if((a|0)!=1){c:{o=xb(x[k>>2],0),q=i,v[o|0]=q;g=1;a=h;while(1){c=c&255;n=c>>>0<=9?9:c;e=a;d:{e:{while(1){if(g>>>0>=m>>>0){break d}x[31609]=0;j=P(158,f|0,c|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){if(j){break e}if((c|0)==(n|0)){break d}c=c+1|0;e=h;continue}break}break c}a=j>>>1|0;i=(j&1?0-a|0:a)+i|0;o=xb(x[k>>2],g),q=i,v[o|0]=q;g=g+1|0;a=h;if(j>>>c-1|0){continue}a=e-1|0;e=a&255;a=e?a:h;c=c-(!e&(c&255)>>>0>1)|0;continue}break}a=zr(f);x[31609]=0;P(149,b|0,((a-l|0)+3&-4)+l|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break b}}}c=N()|0;ec(k);break a}ub(f);fb=d+1072|0;return}c=N()|0;break a}c=N()|0}ub(f);Q(c|0);p()}function nY(a,b,c,d,e){var f=0,g=0;f=fb-16|0;fb=f;g=z[c>>1];a:{if((d&255)>>>0<=4){while(1){d=g<<1;w[c>>1]=d;v[b|0]=(d&65534)>>>0>255;d=y[c|0];w[c>>1]=d;if(!d){if(!Bf(a,f+15|0)){break a}d=y[f+15|0];w[c>>1]=d<<1|1;v[b|0]=d>>>7;w[c>>1]=y[c|0]}w[e>>1]=v[b|0]+(z[e>>1]<<1);d=z[c>>1]<<1;w[c>>1]=d;v[b|0]=(d&65534)>>>0>255;d=y[c|0];w[c>>1]=d;if(!d){if(!Bf(a,f+14|0)){break a}d=y[f+14|0];w[c>>1]=d<<1|1;v[b|0]=d>>>7;w[c>>1]=y[c|0]}w[e>>1]=v[b|0]+(z[e>>1]<<1);d=z[c>>1]<<1;w[c>>1]=d;v[b|0]=(d&65534)>>>0>255;g=y[c|0];w[c>>1]=g;if(!g){if(!Bf(a,f+13|0)){break a}d=y[f+13|0];w[c>>1]=d<<1|1;v[b|0]=d>>>7;g=y[c|0];w[c>>1]=g;if(y[b|0]){continue}break a}if(y[b|0]){continue}break a}}while(1){d=g<<1;w[c>>1]=d;v[b|0]=(d&65534)>>>0>255;d=y[c|0];w[c>>1]=d;if(!d){if(!Bf(a,f+12|0)){break a}d=y[f+12|0];w[c>>1]=d<<1|1;v[b|0]=d>>>7;w[c>>1]=y[c|0]}w[e>>1]=v[b|0]+(z[e>>1]<<1);d=z[c>>1]<<1;w[c>>1]=d;v[b|0]=(d&65534)>>>0>255;g=y[c|0];w[c>>1]=g;if(!g){if(!Bf(a,f+11|0)){break a}d=y[f+11|0];w[c>>1]=d<<1|1;v[b|0]=d>>>7;g=y[c|0];w[c>>1]=g;if(y[b|0]){continue}break a}if(y[b|0]){continue}break}}fb=f+16|0}function Vha(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=fb+-64|0;fb=c;g=Nb(a);x[31609]=0;W(954,g|0);a=x[31609];x[31609]=0;a:{if((a|0)!=1){b:{c:{d:{e:{f:{g:{h:{i:{j:{while(1){if((b|0)==312){fb=c- -64|0;return g|0}k:{h=zu(44);if(h){x[31609]=0;d=P(36,c+36|0,x[b+42980>>2])|0;a=x[31609];x[31609]=0;if((a|0)==1){break k}a=x[b+42976>>2];x[31609]=0;i=c+48|0;O(955,i|0,d|0);e=x[31609];x[31609]=0;if((e|0)==1){break j}x[31609]=0;e=P(36,c+12|0,x[b+42984>>2])|0;f=x[31609];x[31609]=0;if((f|0)==1){break i}x[31609]=0;f=c+24|0;O(955,f|0,e|0);j=x[31609];x[31609]=0;if((j|0)==1){break h}x[31609]=0;a=ba(956,h|0,a|0,i|0,f|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break g}Eb(f);tb(e);Eb(i);tb(d);x[c+60>>2]=a;x[31609]=0;O(957,g|0,c+60|0);d=x[31609];x[31609]=0;if((d|0)==1){break b}v[a+40|0]=y[b+42996|0];d=b+42988|0;e=x[d+4>>2];x[a+32>>2]=x[d>>2];x[a+36>>2]=e;v[a+41|0]=y[a+41|0]&253|y[b+42997|0]<<1}b=b+24|0;continue}break}b=N()|0;break c}b=N()|0;break d}b=N()|0;break e}b=N()|0;break f}b=N()|0;Eb(c+24|0)}tb(e)}Eb(c+48|0)}tb(d)}Db(h);break a}b=N()|0;break a}b=N()|0}wc(g);Q(b|0);p()}function zQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=E(0);c=fb-80|0;fb=c;d=x[b>>2];b=x[b+4>>2];e=Md(c+52|0);f=x[e+4>>2];x[c+8>>2]=x[e>>2];x[c+12>>2]=f;b=qx(c+60|0,d,b,c+8|0);x[31609]=0;d=R(202,b|0)|0;e=x[31609];x[31609]=0;a:{if((e|0)==1){break a}x[31609]=0;d=U(949,b|0,c+19|0,d|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break a}if(!(!d|(y[c+23|0]|y[c+24|0]<<8|(y[c+25|0]<<16|y[c+26|0]<<24)|(y[c+19|0]|y[c+20|0]<<8|(y[c+21|0]<<16|y[c+22|0]<<24))!=542066252))){g=a,h=Pd((l(2,y[c+27|0]|y[c+28|0]<<8|(y[c+29|0]<<16|y[c+30|0]<<24)),r()),E(0)),B[g+4220>>2]=h;g=a,h=Pd((l(2,y[c+31|0]|y[c+32|0]<<8|(y[c+33|0]<<16|y[c+34|0]<<24)),r()),E(0)),B[g+4224>>2]=h;g=a,h=Pd((l(2,y[c+35|0]|y[c+36|0]<<8|(y[c+37|0]<<16|y[c+38|0]<<24)),r()),E(0)),B[g+4228>>2]=h;d=y[c+39|0]|y[c+40|0]<<8|(y[c+41|0]<<16|y[c+42|0]<<24);if(d>>>0<=5){x[a+4232>>2]=d}x[a+4236>>2]=y[c+43|0]|y[c+44|0]<<8|(y[c+45|0]<<16|y[c+46|0]<<24);v[a+4240|0]=y[c+47|0]!=0;v[a+4241|0]=y[c+48|0]!=0;v[a+4242|0]=y[c+49|0]!=0;v[a+4243|0]=y[c+50|0]!=0;v[a+4244|0]=y[c+51|0]!=0;qu(a)}ub(b);fb=c+80|0;return}a=N()|0;ub(b);Q(a|0);p()}function Hha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=E(0),g=0,h=0,i=0,j=0,k=0,l=0,m=E(0),n=0,o=0,p=E(0),q=E(0),r=E(0),s=E(0),t=E(0),u=0,v=0,w=0,z=E(0);h=x[a+44>>2];g=Hc(h,0);h=Hc(h,1);j=x[a+56>>2];n=Hc(j,0);j=Hc(j,1);e=oc(x[a+4208>>2],x[a+4212>>2]);o=D(x[x[a+16>>2]+1074404>>2],y[a+4233|0]);k=o<<1;if(e>>>0<k>>>0){Dl(a+4208|0,k)}l=y[a+4232|0];a:{if(l){e=x[a+4220>>2];k=x[a+4208>>2];u=l-1|0;l=0;while(1){if((d|0)==(l|0)){break a}r=B[h>>2];e=e>>>0<o>>>0?e:0;i=e-o|0;i=((i|0)<0?e:i)<<1;v=yb(k,i);f=B[yb(k,i|1)>>2];s=B[g>>2];t=B[v>>2];p=E(s+t);B[n>>2]=p;q=E(r+f);B[j>>2]=q;f=E(0);m=E(0);b:{c:{switch(u|0){case 0:f=B[a+4224>>2];m=E(q*f);f=E(p*f);break b;case 1:case 2:f=B[a+4224>>2];m=E(p*f);f=E(q*f);break b;case 3:break c;default:break b}}f=E(E(E(E(s+r)*E(.5))+t)*B[a+4224>>2]);m=f}j=j+4|0;n=n+4|0;h=h+4|0;g=g+4|0;i=e<<1;w=yb(k,i),z=E(F(f))<E(10000000195414814e-40)?E(0):f,B[w>>2]=z;w=yb(k,i|1),z=E(F(m))<E(10000000195414814e-40)?E(0):m,B[w>>2]=z;e=e+1|0;x[a+4220>>2]=e;l=l+1|0;continue}}e=g;g=d<<2;eD(e,e+g|0,n);eD(h,h+g|0,j)}g=a;a=x[a+56>>2];Ki(g,b,c,Hc(a,0),Hc(a,1),d)}function PL(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0,n=0,o=E(0),q=0;a:{if(y[b+21|0]){q=D(d,g);j=x[e>>2];l=x[f>>2];m=x[b>>2];b:{while(1){if((h|0)>0){if(x[a+1396>>2]<=9){wl(a)}g=x[a+1392>>2];k=w[(((g&1023)<<1)+b|0)+36>>1];c:{if((k|0)>=0){i=g;k=k&65535;g=y[k+x[b+8>>2]|0];x[a+1392>>2]=i>>>g;g=x[a+1396>>2]-g|0;x[a+1396>>2]=(g|0)>0?g:0;k=(g|0)<0?-1:k;break c}k=Jm(a,b)}if((k|0)>=x[b+2092>>2]?y[b+23|0]:0){break a}if((k|0)<0){if(!y[a+1376|0]){b=0;if(x[a+1384>>2]){break b}}fc(a,21);return 0}else{g=0;n=D(d,l);m=((m+n|0)+j|0)>(q|0)?(q-n|0)+j|0:m;n=(m|0)>0?m:0;k=D(k,x[b>>2]);o=E(0);d:{if(y[b+22|0]){while(1){if((g|0)==(n|0)){break d}o=E(o+B[(x[b+28>>2]+(k<<2)|0)+(g<<2)>>2]);i=x[(j<<2)+c>>2];if(i){i=i+(l<<2)|0;B[i>>2]=o+B[i>>2]}j=j+1|0;i=(j|0)==(d|0);j=i?0:j;g=g+1|0;l=i+l|0;continue}}while(1){if((g|0)==(n|0)){break d}i=x[(j<<2)+c>>2];if(i){i=i+(l<<2)|0;B[i>>2]=B[i>>2]+E(B[(x[b+28>>2]+(k<<2)|0)+(g<<2)>>2]+E(0))}j=j+1|0;i=(j|0)==(d|0);j=i?0:j;g=g+1|0;l=i+l|0;continue}}h=h-m|0;continue}}break}x[e>>2]=j;x[f>>2]=l;b=1}return b}fc(a,21);return 0}_(7552,13274,1887,6586);p()}function BD(a,b,c,d){v[a+5|0]=c;a:{b:{switch((b|64)+-64|0){case 0:v[a+3|0]=c?37:0;return;case 1:v[a+3|0]=16;return;case 2:v[a+3|0]=12;return;case 3:v[a+3|0]=14;if(d){break a}v[a+5|0]=D(c>>>4|0,10)+(c&15);return;case 4:v[a+3|0]=11;return;case 5:v[a+3|0]=3;return;case 6:v[a+3|0]=2;return;case 7:v[a+3|0]=4;return;case 8:v[a+3|0]=5;return;case 9:v[a+3|0]=18;return;case 10:v[a+3|0]=1;return;case 11:v[a+3|0]=7;return;case 12:v[a+3|0]=6;return;case 13:v[a+3|0]=21;return;case 14:v[a+3|0]=22;return;case 15:v[a+3|0]=10;return;case 16:v[a+3|0]=29;return;case 17:v[a+3|0]=15;return;case 18:v[a+3|0]=8;return;case 19:v[a+3|0]=20;return;case 20:v[a+3|0]=17;return;case 21:v[a+3|0]=26;return;case 22:v[a+3|0]=23;return;case 23:v[a+3|0]=24;return;case 24:v[a+3|0]=9;return;case 25:v[a+3|0]=27;return;case 26:v[a+3|0]=31;return;case 28:v[a+3|0]=d?32:31;return;case 29:v[a+3|0]=d?33:0;return;case 27:v[a+3|0]=d?34:0;return;case 30:v[a+3|0]=d?35:0;return;case 31:v[a+3|0]=d?36:0;return;case 50:v[a+3|0]=d?25:0;return;case 51:v[a+3|0]=d?30:0;return;default:break b}}v[a+3|0]=0}}function x7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;a=fb-144|0;fb=a;x[a+136>>2]=c;x[a+140>>2]=b;x[a+20>>2]=1274;i=a+20|0;b=De(a+24|0,a+32|0,i);j=a+16|0;cd(j,x[e+28>>2]);x[31609]=0;h=R(28,x[a+16>>2])|0;k=x[31609];x[31609]=0;if((k|0)!=1){a:{v[a+15|0]=0;e=x[e+4>>2];x[31609]=0;c=na(1275,a+140|0,c|0,d|0,j|0,e|0,f|0,a+15|0,h|0,b|0,i|0,a+132|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}b:{c:{if(!c){break c}sf(g);if(y[a+15|0]){x[31609]=0;c=P(29,h|0,45)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}x[31609]=0;O(115,g|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}}x[31609]=0;d=P(29,h|0,48)|0;c=x[31609];x[31609]=0;if((c|0)==1){break b}e=x[a+20>>2];h=e-1|0;c=x[b>>2];d=d&255;while(1){if(!((d|0)!=y[c|0]|c>>>0>=h>>>0)){c=c+1|0;continue}break}x[31609]=0;U(1281,g|0,c|0,e|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break c}break a}x[31609]=0;c=P(1241,a+140|0,a+136|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}if(c){x[f>>2]=x[f>>2]|2}c=x[a+140>>2];_b(a+16|0);Lc(b);fb=a+144|0;return c|0}}}c=N()|0;_b(a+16|0);Lc(b);Q(c|0);p()}function Sla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=fb-16|0;fb=e;o=x[a+16>>2];p=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);j=x[a+8>>2];k=x[a+12>>2];b=x[a>>2];f=x[a+4>>2];l=x[a+128>>2];if(l){m=Hg(j,k,l);n=hb;g=x[a+76>>2];fg(b,f,vf(j,k,d),hb);i=hb>>>0>g>>>0?d:0}g=a+112|0;q=x[a+24>>2];r=x[a+20>>2];x[e>>2]=b;x[e+4>>2]=f;a:while(1){if(d){f=x[e+4>>2];b=x[e>>2];x[e+8>>2]=b;x[e+12>>2]=0;i=i-1|0;m=i?m:0;n=i?n:0;d=d-1|0;f=((((f&2147483647)<<1|b>>>31)&2147483646)<<1)+o|0;b=l;while(1)if((b|0)<=0){Pb(g,x[a+120>>2],x[a+124>>2]);b=x[a+116>>2];if(b){h=x[e+8>>2];h=(x[e+12>>2]&2147483647)<<1|h>>>31;ce(g,(w[((h&2147483646)<<1)+f>>1]+w[(h<<1|2)+f>>1]|0)/8<<16>>16);be(g,b);x[g>>2]=x[g>>2];x[g+4>>2]=0}f=x[c>>2];b=Fg(g,p);x[c>>2]=f+D(b,r);x[c+4>>2]=x[c+4>>2]+D(b,q);Pb(e,j,k);c=c+8|0;continue a}else{h=x[e+8>>2];h=(x[e+12>>2]&2147483647)<<1|h>>>31;ce(g,(w[((h&2147483646)<<1)+f>>1]+w[(h<<1|2)+f>>1]|0)/8<<16>>16);be(g,4);Pb(e+8|0,m,n);b=b-1|0;continue}}break}b=x[e+4>>2];x[a>>2]=x[e>>2];x[a+4>>2]=b;fb=e+16|0}function H1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=fb-96|0;fb=d;yc(b);Kp(a);e=d+60|0;a:{if(!dx(b,e)){break a}if(!ZF(e)){break a}b:{if(!c){break b}if(!Mb(x[b>>2],x[b+8>>2],$b(y[d+64|0]|y[d+65|0]<<8|(y[d+66|0]<<16|y[d+67|0]<<24))-28|0)){break a}tx(a);g=d,h=sx(),x[g+40>>2]=h;c=d+40|0;rx(ej(x[a+4>>2])+32|0,c);ms(c);e=x[ej(x[a+4>>2])+32>>2];f=y[d+64|0]|y[d+65|0]<<8|(y[d+66|0]<<16|y[d+67|0]<<24);x[31609]=0;S(186,c|0,b|0,$b(f)-28|0);b=x[31609];x[31609]=0;c:{d:{if((b|0)!=1){Nn(d+32|0,c);b=y[d+72|0]|y[d+73|0]<<8|(y[d+74|0]<<16|y[d+75|0]<<24);x[31609]=0;b=ba(187,x[d+32>>2],x[d+36>>2],e|0,$b(b)|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break d}Kc(c);f=0;if(!b){break a}se(d+16|0,x[e>>2],x[e+4>>2]);lf(d+24|0,x[d+16>>2],x[d+20>>2]);b=Md(d+8|0);e=x[b+4>>2];x[d>>2]=x[b>>2];x[d+4>>2]=e;b=qx(c,x[d+24>>2],x[d+28>>2],d);kd(ej(x[a+4>>2])+12|0,b);ub(b);break b}a=ta(124540,24472)|0;b=gb;break c}a=ta(124540,24472)|0;b=gb;Kc(d+40|0)}e:{if(($(124540)|0)==(b|0)){break e}if(($(24472)|0)==(b|0)){break e}Q(a|0);p()}Y(a|0)|0;Z();f=0;break a}f=1}fb=d+96|0;return f|0}function mha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=E(0),f=0,g=E(0),h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=E(0),t=0,u=0,v=0,w=0,y=0,z=E(0);a:{j=x[a+4272>>2];if(!j){break a}if(!ui(a+44|0)){break a}f=x[a+44>>2];l=Hc(f,0);m=Hc(f,1);u=x[a+4252>>2]-1|0;i=x[a+4268>>2];k=x[a+4256>>2];n=d;f=x[a+56>>2];q=Hc(f,0);o=q;r=Hc(f,1);p=r;while(1){if(n){e=B[m>>2];f=i<<1;h=yb(k,f);g=B[l>>2];B[h>>2]=g;y=yb(k,f|1),z=e,B[y>>2]=z;s=B[a+4276>>2];e=E(E(F(fQ(E(E(E(F(g))+E(F(e)))*E(536870912)),31,5)))*E(4.656612873077393e-10));e=E(E(E(s-e)*B[(e>=s?4236:4240)+a>>2])+e);B[a+4276>>2]=e;g=B[a+4244>>2];e=E(E(E(E(g-(e<g?g:e))*B[a+4248>>2])+E(.9999998807907104))*E(2147483648));b:{if(e<E(4294967296)&e>=E(0)){f=~~e>>>0;break b}f=0}t=((((i<<12)+u|0)+j|0)/4096|0)%(j|0)<<1;g=B[yb(k,t)>>2];h=f<<5;v=h;w=h|-2147483648;h=f>>>0<67108864;e=E(B[a+4232>>2]*E(E((h?v:w)>>>(h?31:32-(f>>>26|0)|0)>>>0)*E(4.656612873077393e-10)));B[o>>2]=g*e;y=p,z=E(B[yb(k,t|1)>>2]*e),B[y>>2]=z;i=((i?0:j)+i|0)-1|0;x[a+4268>>2]=i;n=n-1|0;p=p+4|0;o=o+4|0;m=m+4|0;l=l+4|0;continue}else{Ki(a,b,c,q,r,d)}break}}}function vo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=fb-80|0;fb=c;g=Nb(a);a=x[b+24>>2];a:{b:{if(Hj(x[a+484360>>2],x[a+484364>>2])){c:{d:{e:while(1){if(Hj(x[a+484360>>2],x[a+484364>>2])>>>0<=f>>>0){break d}d=WR(bY(c+40|0,1),f&255,0,0);x[31609]=0;e=x[d+12>>2];x[c+16>>2]=x[d+8>>2];x[c+20>>2]=e;e=x[d+20>>2];x[c+24>>2]=x[d+16>>2];x[c+28>>2]=e;e=x[d+4>>2];x[c+8>>2]=x[d>>2];x[c+12>>2]=e;V(1091,c+68|0,a|0,0,c+8|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}j=c,k=wb(x[c+68>>2]),x[j+36>>2]=k;d=wb(x[c+72>>2]);while(1){a=x[c+36>>2];if(!Ib(a,d)){f=f+1|0;Si(c+68|0);a=x[b+24>>2];continue e}h=C[a>>3];e=x[a+16>>2];i=z[a+24>>1];a=c+40|0;x[a+16>>2]=f;x[a+12>>2]=i;x[a+8>>2]=e;C[a>>3]=h;x[31609]=0;O(1126,g|0,a|0);a=x[31609];x[31609]=0;if((a|0)!=1){Zq(c+36|0);continue}break}break}a=N()|0;Si(c+68|0);break b}fb=c+80|0;return}a=N()|0;break b}b=ac(8);x[31609]=0;d=P(36,c+40|0,7310)|0;a=x[31609];x[31609]=0;if((a|0)!=1){pc(b,d);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(d);break b}a=N()|0;ic(b)}nf(g);Q(a|0)}p()}function Po(a,b,c,d){var e=0,f=0;e=b+1074312|0;f=Ob(e,120);v[a+797|0]=f;v[a+802|0]=f;w[a+800>>1]=0;v[a+803|0]=0;v[a+804|0]=0;v[a+841|0]=0;v[a+805|0]=0;x[a+708>>2]=0;x[a+656>>2]=0;x[a+104>>2]=0;x[a+764>>2]=0;x[a+696>>2]=0;x[a+668>>2]=0;x[a+88>>2]=x[a+88>>2]|6144;if(Ob(e,23)){v[a+807|0]=1;v[a+808|0]=0}v[a+846|0]=0;v[a+839|0]=0;w[a+774>>1]=0;v[a+850|0]=255;x[a+660>>2]=0;v[a+851|0]=y[a+851|0]&224;Vo(a+788|0);x[a+84>>2]=0;x[a+76>>2]=0;x[a+80>>2]=0;x[a+700>>2]=0;x[a+656>>2]=0;x[a+104>>2]=0;x[a+92>>2]=0;x[a+96>>2]=0;x[a>>2]=0;x[a+4>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;v[a+845|0]=0;v[a+838|0]=0;v[a+821|0]=0;x[a+688>>2]=0;x[a+672>>2]=0;x[a+676>>2]=0;w[a+836>>1]=32512;v[a+819|0]=0;v[a+820|0]=0;w[a+842>>1]=0;x[a+28>>2]=0;x[a+32>>2]=0;x[a+20>>2]=0;x[a+24>>2]=0;x[a+852>>2]=0;x[a+856>>2]=0;v[a+851|0]=y[a+851|0]&159;a:{if(c>>>0<=126){b=(c<<5)+b|0;c=x[b+480280>>2];x[a+88>>2]=c;x[a+692>>2]=z[b+480284>>1];x[a+748>>2]=z[b+480286>>1];if(!(c&1024)){break a}x[a+88>>2]=c&-1025|d;break a}x[a+748>>2]=64;x[a+692>>2]=128;x[a+88>>2]=0}w[a+784>>1]=0;v[a+795|0]=0;v[a+796|0]=0}function QK(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=fb-32|0;fb=d;a:{if(y[a+52|0]){f=x[a+48>>2];if(!b){break a}v[a+52|0]=0;x[a+48>>2]=-1;break a}if(y[a+53|0]){f=-1;c=x[a+32>>2];b:{if(x[c+76>>2]<0){c=MK(c);break b}c=MK(c)}if((c|0)!=-1){x[d+24>>2]=c}if((c|0)==-1){break a}c=x[d+24>>2];c:{if(!b){if(PK(c,x[a+32>>2])){break c}break a}x[a+48>>2]=c}f=c;break a}x[d+24>>2]=1;e=x[Xe(d+24|0,a+44|0)>>2];g=(e|0)>0?e:0;while(1){if((g|0)!=(h|0)){f=-1;c=_q(x[a+32>>2]);if((c|0)==-1){break a}v[(d+24|0)+h|0]=c;h=h+1|0;continue}break}k=d+24|0;d:{while(1){e:{i=x[a+40>>2];c=x[i>>2];h=x[i+4>>2];f=-1;g=d+24|0;j=g+e|0;f:{switch(bL(x[a+36>>2],i,g,j,d+16|0,d+20|0,k,d+12|0)-1|0){case 1:break a;case 2:break e;case 0:break f;default:break d}}g=x[a+40>>2];x[g>>2]=c;x[g+4>>2]=h;if((e|0)==8){break a}c=_q(x[a+32>>2]);if((c|0)==-1){break a}v[j|0]=c;e=e+1|0;continue}break}x[d+20>>2]=v[d+24|0]}g:{if(!b){while(1){if((e|0)<=0){break g}e=e-1|0;if((eo(v[e+(d+24|0)|0],x[a+32>>2])|0)!=-1){continue}break a}}f=x[d+20>>2];x[a+48>>2]=f;break a}f=x[d+20>>2]}fb=d+32|0;return f}function rS(a){var b=0,c=0,d=0,e=0,f=0,g=0;while(1){if((f|0)!=128e3){g=fb-32|0;fb=g;b=ev(g);d=y[b+4|0]|y[b+5|0]<<8|(y[b+6|0]<<16|y[b+7|0]<<24);c=a+f|0;e=y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24);v[c|0]=e;v[c+1|0]=e>>>8;v[c+2|0]=e>>>16;v[c+3|0]=e>>>24;v[c+4|0]=d;v[c+5|0]=d>>>8;v[c+6|0]=d>>>16;v[c+7|0]=d>>>24;d=y[b+28|0]|y[b+29|0]<<8|(y[b+30|0]<<16|y[b+31|0]<<24);e=y[b+24|0]|y[b+25|0]<<8|(y[b+26|0]<<16|y[b+27|0]<<24);v[c+24|0]=e;v[c+25|0]=e>>>8;v[c+26|0]=e>>>16;v[c+27|0]=e>>>24;v[c+28|0]=d;v[c+29|0]=d>>>8;v[c+30|0]=d>>>16;v[c+31|0]=d>>>24;d=y[b+20|0]|y[b+21|0]<<8|(y[b+22|0]<<16|y[b+23|0]<<24);e=y[b+16|0]|y[b+17|0]<<8|(y[b+18|0]<<16|y[b+19|0]<<24);v[c+16|0]=e;v[c+17|0]=e>>>8;v[c+18|0]=e>>>16;v[c+19|0]=e>>>24;v[c+20|0]=d;v[c+21|0]=d>>>8;v[c+22|0]=d>>>16;v[c+23|0]=d>>>24;d=y[b+12|0]|y[b+13|0]<<8|(y[b+14|0]<<16|y[b+15|0]<<24);b=y[b+8|0]|y[b+9|0]<<8|(y[b+10|0]<<16|y[b+11|0]<<24);v[c+8|0]=b;v[c+9|0]=b>>>8;v[c+10|0]=b>>>16;v[c+11|0]=b>>>24;v[c+12|0]=d;v[c+13|0]=d>>>8;v[c+14|0]=d>>>16;v[c+15|0]=d>>>24;fb=g+32|0;f=f+32|0;continue}break}}function Vma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,y=0,z=0;h=fb-16|0;fb=h;f=x[a+48>>2];j=x[a+40>>2];k=x[a+36>>2];e=x[a+44>>2];o=x[a+16>>2];b=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=b;p=x[a+32>>2];q=x[a+28>>2];r=x[a+72>>2];l=x[a+68>>2];s=l>>31;m=x[a+64>>2];t=m>>31;n=x[a+60>>2];u=n>>31;w=x[a+8>>2];y=x[a+12>>2];while(1){b=e;if(d){e=Yb(e,-16777216,16776704);e=Iua(m,t,e,e>>31);i=hb;g=e;f=Yb(f,-16777216,16776704);e=Iua(l,s,f,f>>31);g=g+e|0;f=hb+i|0;f=e>>>0>g>>>0?f+1|0:f;z=g;e=x[h+8>>2];i=e>>>10&4194048;e=x[h+12>>2]+o|0;g=v[e|0];i=((D(v[e+1|0]-g|0,i)|0)/16384<<8)+(g<<16)|0;e=i;e=Iua(e,e>>31,n,u);g=e+z|0;f=hb+f|0;f=e>>>0>g>>>0?f+1|0:f;e=g+8388608|0;f=e>>>0<8388608?f+1|0:f;e=Sc(e,f,24);f=(e|0)/256|0;k=k+q|0;x[c>>2]=D(f,k>>12)+x[c>>2];j=j+p|0;x[c+4>>2]=x[c+4>>2]+D(j>>12,f);Pb(h+8|0,w,y);e=e-(i&r)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=c;x[a+40>>2]=j;x[a+20>>2]=k>>12;x[a+36>>2]=k;x[a+48>>2]=f;x[a+44>>2]=b;x[a+24>>2]=j>>12;fb=h+16|0}function zfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;x[31609]=0;W(1021,a|0);e=x[31609];x[31609]=0;a:{b:{c:{d:{e:{if((e|0)==1){break e}x[31609]=0;W(997,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break e}e=0;x[31609]=0;W(1022,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break e}a=Rb(c,0,d);if(!y[b|0]){break b}if(ji(b,47296)|(d|0)!=8){break d}x[a+4>>2]=1023;x[a>>2]=1024;break c}Y(T(0)|0)|0;x[31609]=0;V(983,12360,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();return 0}if(!(ji(b,47308)|(d|0)!=64)){x[a+60>>2]=1025;x[a+56>>2]=1026;x[a+52>>2]=1027;x[a+48>>2]=1028;x[a+44>>2]=1029;x[a+40>>2]=1030;x[a+36>>2]=1031;x[a+32>>2]=1032;x[a+28>>2]=1033;x[a+24>>2]=1034;x[a+20>>2]=1035;x[a+16>>2]=1036;x[a+12>>2]=1037;x[a+8>>2]=1038;x[a+4>>2]=1039;x[a>>2]=1040;break c}if(!(ji(b,47320)|(d|0)!=24)){x[a+20>>2]=1041;x[a+16>>2]=1042;x[a+12>>2]=1043;x[a+8>>2]=1044;x[a+4>>2]=1045;x[a>>2]=1046;break c}if(ji(b,47333)|(d|0)!=4){break b}x[a>>2]=1047}e=1}return e|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Zha(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=E(0),j=0,k=0;c=fb-32|0;fb=c;a:{b=x[a+20>>2];b:{if(!b){break b}x[b+148>>2]=-1;j=c,k=ib[x[x[a>>2]+40>>2]](a)|0,x[j+16>>2]=k;x[c+8>>2]=1073741822;b=c+16|0;d=c+8|0;g=x[Hb(b,d)>>2];e=g<<2;if(!e){break b}h=x[a+20>>2];x[31609]=0;O(287,h+4|0,e+4|0);e=x[31609];x[31609]=0;c:{d:{if((e|0)!=1){e=d;d=x[a+20>>2];se(e,x[d+4>>2],x[d+8>>2]);x[c>>2]=0;x[c+4>>2]=0;d=x[c+12>>2];x[b>>2]=x[c+8>>2];x[b+4>>2]=d;d=x[c+4>>2];x[b+8>>2]=x[c>>2];x[b+12>>2]=d;d=fb-16|0;fb=d;x[d+12>>2]=0;wQ(b,d+12|0);fb=d+16|0;b=x[x[a>>2]+184>>2];x[31609]=0;O(b|0,a|0,-1);b=x[31609];x[31609]=0;if((b|0)==1){break d}while(1){if((f|0)==(g|0)){b=x[x[a>>2]+188>>2];x[31609]=0;W(b|0,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}break d}b=x[x[a>>2]+48>>2];x[31609]=0;i=E(_a(b|0,a|0,f|0));b=x[31609];x[31609]=0;if((b|0)!=1){B[c+8>>2]=i;f=f+1|0;wQ(c+16|0,c+8|0);continue}break}b=T(124540)|0;break c}b=T(124540)|0;break c}b=T(124540)|0}if((gb|0)!=($(124540)|0)){break a}Y(b|0)|0;Nc(x[a+20>>2]+4|0);Z()}fb=c+32|0;return}Q(b|0);p()}function KL(a,b,c){var d=0,e=0,f=0,g=0,h=0;g=a;d=fb-208|0;fb=d;x[d+8>>2]=1;x[d+12>>2]=0;h=b<<2;a:{if(!h){break a}x[d+16>>2]=4;x[d+20>>2]=4;b=4;f=4;e=2;while(1){a=b;b=(b+f|0)+4|0;x[(d+16|0)+(e<<2)>>2]=b;e=e+1|0;f=a;if(b>>>0<h>>>0){continue}break}a=(g+h|0)-4|0;b:{if(a>>>0<=g>>>0){e=1;b=1;a=0;break b}e=1;b=1;while(1){c:{if((e&3)==3){az(g,c,b,d+16|0);Ot(d+8|0,2);b=b+2|0;break c}h=d+16|0;f=b-1|0;d:{if(A[h+(f<<2)>>2]>=a-g>>>0){Mt(g,c,e,x[d+12>>2],b,0,h);break d}az(g,c,b,d+16|0)}if((b|0)==1){Lt(d+8|0,1);b=0;break c}Lt(d+8|0,f);b=1}e=x[d+8>>2]|1;x[d+8>>2]=e;g=g+4|0;if(a>>>0>g>>>0){continue}break}a=x[d+12>>2]}Mt(g,c,e,a,b,0,d+16|0);f=x[d+12>>2];e=x[d+8>>2];if(!(f|((b|0)!=1|(e|0)!=1))){break a}while(1){e:{if((b|0)<=1){a=DL(e,f);Ot(d+8|0,a);a=a+b|0;break e}f=d+8|0;Lt(f,2);x[d+8>>2]=x[d+8>>2]^7;Ot(f,1);h=g-4|0;e=d+16|0;a=b-2|0;Mt(h-x[e+(a<<2)>>2]|0,c,x[d+8>>2],x[d+12>>2],b-1|0,1,e);Lt(f,1);b=x[d+8>>2]|1;x[d+8>>2]=b;Mt(h,c,b,x[d+12>>2],a,1,e)}b=a;g=g-4|0;f=x[d+12>>2];e=x[d+8>>2];if(f|((b|0)!=1|(e|0)!=1)){continue}break}}fb=d+208|0}function AT(a,b){var c=0,d=0,e=0,f=0;d=fb-16|0;fb=d;c=x[a+24620>>2];a:{b:{switch(y[a+480224|0]-1|0){default:x[d+12>>2]=1;x[d+8>>2]=x[b+44>>2]<<1;c=Iua(c,c>>31,5e4,0);e=hb;b=x[bd(d+12|0,d+8|0)>>2];c=Gc(Jua(c,e,b,b>>31),hb);break a;case 0:x[d+12>>2]=1;x[d+8>>2]=x[b+44>>2];c=Iua(c,c>>31,1e4,0);e=hb;b=x[bd(d+12|0,d+8|0)>>2];c=Gc(Jua(c,e,b,b>>31),hb);break a;case 1:break b}}f=60/(+A[b+44>>2]/1e4*(+(Iua(x[b+32>>2],0,x[b+40>>2],0)>>>0)+ +(hb>>>0)*4294967296))*+(c>>>0);c:{d:{c=x[a+484344>>2];e=z[b+70>>1];if(!Je(c,x[a+484348>>2],e)){break d}c=Wb(c,e);if(!Ib(x[c+24>>2],x[c+28>>2])){break d}c=VR(c);break c}c=a+480248|0}e=x[c>>2];c=x[c+4>>2];if(!mc(e,c)){f=f*+A[yb(e,A[b+48>>2]%(oc(e,c)>>>0)|0)>>2]*5.960464477539063e-8}e:{if(F(f)<2147483648){c=~~f;break e}c=-2147483648}f=C[b+8>>3]+(f-+(c>>>0));C[b+8>>3]=f;if(f>=1){C[b+8>>3]=f+-1;c=c+1|0;break a}if(!(C[a+1074384>>3]<=-1)){break a}C[b+8>>3]=f+1;c=c-1|0}b=Iua(x[a+480244>>2],0,c,0);a=hb;b=b+32768|0;a=b>>>0<32768?a+1|0:a;a=Bc((a&65535)<<16|b>>>16,a>>>16|0);fb=d+16|0;return a>>>0<=1?1:a}function AM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;c=fb+-64|0;fb=c;f=x[a>>2];a=x[f>>2];g=x[a+4>>2];x[c+40>>2]=x[a+20>>2];e=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=e;Xf(c+48|0,c+32|0,g);a=x[f+4>>2];f=x[a+8>>2];g=x[a+4>>2];e=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=e;e=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=e;x[c+8>>2]=x[a+8>>2];e=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=e;a:{b:{c:{d:{e=x[c+4>>2];if(g>>>0<=e>>>0){i=x[c+20>>2];if(g>>>0>i>>>0){break d}if(f>>>0>A[c+8>>2]){break c}j=x[c+28>>2];if(f>>>0>x[c+24>>2]-j>>>0){break b}k=b+12|0;l=x[c+16>>2];m=x[c>>2];e:while(1){if((f|0)==(h|0)){break a}n=(D(e,h)<<2)+m|0;o=(D(h+j|0,i)<<1)+l|0;a=0;while(1)if((a|0)==(g|0)){h=h+1|0;continue e}else{d=yb(x[b>>2],a);q=d;d=x[(a<<2)+n>>2]+(x[d>>2]>>1)|0;r=d;d=Zt(k)+d&-4096;x[q>>2]=r-d;d=rd(d|2048,12);d=(d|0)>=32767?32767:d;w[(a<<1)+o>>1]=(d|0)<=-32768?-32768:d;a=a+1|0;continue}}}_(7244,9061,33,8774);p()}_(7209,9061,34,8774);p()}_(5897,9061,35,8774);p()}_(5867,9061,36,8774);p()}fb=c- -64|0}function XW(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;c=fb-80|0;fb=c;x[c+72>>2]=0;x[c+76>>2]=0;b=c- -64|0;x[b>>2]=0;x[b+4>>2]=0;x[c+56>>2]=0;x[c+60>>2]=0;x[c+48>>2]=0;x[c+52>>2]=0;iC(a,wV(a),c+48|0);b=qc(c+40|0,14253);rf(Pe(a,0),x[b>>2],x[b+4>>2]);b=qc(c+32|0,14336);rf(Pe(a,1),x[b>>2],x[b+4>>2]);b=qc(c+24|0,5496);rf(Pe(a,3),x[b>>2],x[b+4>>2]);b=qc(c+16|0,15769);rf(Pe(a,4),x[b>>2],x[b+4>>2]);b=qc(c+8|0,9281);rf(Pe(a,8),x[b>>2],x[b+4>>2]);d=Pe(a+288|0,0);b=fb-16|0;fb=b;e=d;d=qc(b+8|0,4932);rf(e,x[d>>2],x[d+4>>2]);fb=b+16|0;d=a+800|0;b=0;a=fb+-64|0;fb=a;a:{b:{while(1){if((b|0)==128){break a}x[a+60>>2]=b<<3;c:{d:{if(b>>>0<=15){e=a+28|0;qw(e,4084);x[31609]=0;g=a+16|0;O(289,g|0,a+60|0);f=x[31609];x[31609]=0;if((f|0)==1){break c}x[31609]=0;f=a+40|0;S(290,f|0,e|0,g|0);h=x[31609];x[31609]=0;if((h|0)!=1){fe(a+52|0,f);rf(Pe(d,b),x[a+52>>2],x[a+56>>2]);tb(f);tb(g);Eb(e);break d}b=N()|0;tb(a+16|0);break b}e=qc(a+8|0,22292);rf(Pe(d,b),x[e>>2],x[a+12>>2])}b=b+1|0;continue}break}b=N()|0}Eb(a+28|0);Q(b|0);p()}fb=a- -64|0;fb=c+80|0}function Uma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0;h=fb-16|0;fb=h;e=x[a+48>>2];i=x[a+40>>2];j=x[a+36>>2];f=x[a+44>>2];p=x[a+16>>2];b=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=b;q=x[a+32>>2];r=x[a+28>>2];s=x[a+72>>2];m=x[a+68>>2];t=m>>31;n=x[a+64>>2];u=n>>31;o=x[a+60>>2];v=o>>31;y=x[a+8>>2];z=x[a+12>>2];while(1){b=f;if(d){f=Yb(f,-16777216,16776704);g=Iua(n,u,f,f>>31);f=hb;e=Yb(e,-16777216,16776704);e=Iua(m,t,e,e>>31);g=e+g|0;f=hb+f|0;f=e>>>0>g>>>0?f+1|0:f;l=g;g=(x[h+12>>2]<<1)+p|0;k=w[g>>1];k=k+((D(w[g+2>>1]-k|0,x[h+8>>2]>>>18|0)|0)/16384|0)<<8;e=k;g=Iua(e,e>>31,o,v);l=g+l|0;e=hb+f|0;e=g>>>0>l>>>0?e+1|0:e;f=l+8388608|0;e=f>>>0<8388608?e+1|0:e;f=Sc(f,e,24);e=(f|0)/256|0;j=j+r|0;x[c>>2]=D(e,j>>12)+x[c>>2];i=i+q|0;x[c+4>>2]=x[c+4>>2]+D(i>>12,e);Pb(h+8|0,y,z);f=f-(k&s)|0;c=c+8|0;d=d-1|0;e=b;continue}break}c=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=c;x[a+40>>2]=i;x[a+20>>2]=j>>12;x[a+36>>2]=j;x[a+48>>2]=e;x[a+44>>2]=b;x[a+24>>2]=i>>12;fb=h+16|0}function GM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;c=fb+-64|0;fb=c;d=x[a>>2];a=x[d>>2];f=x[a+4>>2];x[c+40>>2]=x[a+20>>2];g=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=g;Xf(c+48|0,c+32|0,f);a=x[d+4>>2];f=x[a+8>>2];g=x[a+4>>2];d=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=d;d=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=d;x[c+8>>2]=x[a+8>>2];d=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=d;a:{b:{c:{d:{i=x[c+4>>2];if(i>>>0>=g>>>0){if(A[c+20>>2]<g>>>0){break d}if(f>>>0>A[c+8>>2]){break c}j=x[c+28>>2];if(f>>>0>x[c+24>>2]-j>>>0){break b}l=b+12|0;m=x[c+16>>2];n=x[c>>2];a=0;e:while(1){if((a|0)==(f|0)){break a}o=(D(a,i)<<2)+n|0;d=0;while(1)if((d|0)==(g|0)){a=a+1|0;continue e}else{e=yb(x[b>>2],d);h=e;k=d<<2;e=x[k+o>>2]+(x[e>>2]>>1)|0;q=e;e=Zt(l)+e&-4096;x[h>>2]=q-e;h=(x[m+k>>2]+(j<<1)|0)+(a<<1)|0;e=rd(e|2048,12);e=(e|0)>=32767?32767:e;w[h>>1]=(e|0)<=-32768?-32768:e;d=d+1|0;continue}}}_(7244,9061,33,8774);p()}_(7209,9061,34,8774);p()}_(5897,9061,35,8774);p()}_(5867,9061,36,8774);p()}fb=c- -64|0}function wja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=fb-16|0;fb=d;nd(c,0);w[d+14>>1]=y[a+36|0]|y[a+37|0]<<8;w[d+12>>1]=32767;g=c,h=(z[Oc(d+14|0,d+12|0)>>1]<<8>>>0)/32767|0,w[g+28>>1]=h;w[d+10>>1]=y[a+38|0]|y[a+39|0]<<8;w[d+8>>1]=32767;g=c,h=(z[Oc(d+10|0,d+8|0)>>1]<<8>>>0)/32767|0,w[g+30>>1]=h;w[c+32>>1]=64;x[c>>2]=y[a+44|0]|y[a+45|0]<<8|(y[a+46|0]<<16|y[a+47|0]<<24);x[c+4>>2]=y[a+48|0]|y[a+49|0]<<8|(y[a+50|0]<<16|y[a+51|0]<<24);x[c+8>>2]=y[a+52|0]|y[a+53|0]<<8|(y[a+54|0]<<16|y[a+55|0]<<24);x[c+24>>2]=y[a+56|0]|y[a+57|0]<<8|(y[a+58|0]<<16|y[a+59|0]<<24);e=y[b+166|0];if(e>>>0<=4){v[c+38|0]=y[e+41114|0]}e=y[b+167|0]|y[b+168|0]<<8;v[c+39|0]=e;f=(y[b+171|0]|y[b+172|0]<<8)>>>4|0;v[c+41|0]=f;b=(y[b+169|0]|y[b+170|0]<<8)>>>2|0;v[c+40|0]=b;if((b|f)&255){v[c+39|0]=e^-1}b=y[a+40|0]|y[a+41|0]<<8;if(b&4){w[c+34>>1]=z[c+34>>1]|1;b=y[a+40|0]|y[a+41|0]<<8}if(b&8){w[c+34>>1]=z[c+34>>1]|2;b=y[a+40|0]|y[a+41|0]<<8}if(b&16){w[c+34>>1]=z[c+34>>1]|4;b=y[a+40|0]|y[a+41|0]<<8}if(b&32){w[c+34>>1]=z[c+34>>1]|32}fb=d+16|0}function Kua(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{if(b){if(!c){break k}if(!d){break j}e=G(d)-G(b)|0;if(e>>>0<=31){break i}break c}if((d|0)==1|d>>>0>1){break c}hb=0;a=(a>>>0)/(c>>>0)|0;break a}if(!a){break h}if(!d|d-1&d){break g}a=b>>>Hua(d)|0;hb=0;break a}if(!(c-1&c)){break f}h=(G(c)+33|0)-G(b)|0;g=0-h|0;break d}h=e+1|0;g=63-e|0;break d}hb=0;a=(b>>>0)/(d>>>0)|0;break a}e=G(d)-G(b)|0;if(e>>>0<31){break e}break c}if((c|0)==1){break b}d=Hua(c);c=d&31;if((d&63)>>>0>=32){a=b>>>c|0}else{e=b>>>c|0;a=((1<<c)-1&b)<<32-c|a>>>c}hb=e;break a}h=e+1|0;g=63-e|0}e=h&63;f=e&31;if(e>>>0>=32){e=0;i=b>>>f|0}else{e=b>>>f|0;i=((1<<f)-1&b)<<32-f|a>>>f}g=g&63;f=g&31;if(g>>>0>=32){b=a<<f;a=0}else{b=(1<<f)-1&a>>>32-f|b<<f;a=a<<f}if(h){f=d-1|0;g=c-1|0;m=(g|0)!=-1?f+1|0:f;while(1){j=e<<1|i>>>31;e=i<<1|b>>>31;f=m-(j+(e>>>0>g>>>0)|0)>>31;k=c&f;i=e-k|0;e=j-((d&f)+(e>>>0<k>>>0)|0)|0;b=b<<1|a>>>31;a=l|a<<1;l=f&1;h=h-1|0;if(h){continue}break}}hb=b<<1|a>>>31;a=l|a<<1;break a}a=0;b=0}hb=b}return a}function OK(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=fb-32|0;fb=c;a:{if(y[a+52|0]){f=x[a+48>>2];if(!b){break a}v[a+52|0]=0;x[a+48>>2]=-1;break a}if(y[a+53|0]){f=-1;d=_q(x[a+32>>2]);if((d|0)!=-1){v[c+24|0]=d}if((d|0)==-1){break a}d=zf(v[c+24|0]);b:{if(!b){if(NK(d,x[a+32>>2])){break b}break a}x[a+48>>2]=d}f=d;break a}x[c+24>>2]=1;e=x[Xe(c+24|0,a+44|0)>>2];g=(e|0)>0?e:0;while(1){if((g|0)!=(h|0)){f=-1;d=_q(x[a+32>>2]);if((d|0)==-1){break a}v[(c+24|0)+h|0]=d;h=h+1|0;continue}break}k=c+24|0;c:{while(1){d:{i=x[a+40>>2];d=x[i>>2];h=x[i+4>>2];f=-1;g=c+24|0;j=g+e|0;e:{switch(bL(x[a+36>>2],i,g,j,c+16|0,c+23|0,k,c+12|0)-1|0){case 1:break a;case 2:break d;case 0:break e;default:break c}}g=x[a+40>>2];x[g>>2]=d;x[g+4>>2]=h;if((e|0)==8){break a}d=_q(x[a+32>>2]);if((d|0)==-1){break a}v[j|0]=d;e=e+1|0;continue}break}v[c+23|0]=y[c+24|0]}f:{if(!b){while(1){if((e|0)<=0){break f}e=e-1|0;if((eo(zf(v[e+(c+24|0)|0]),x[a+32>>2])|0)!=-1){continue}break a}}f=zf(v[c+23|0]);x[a+48>>2]=f;break a}f=zf(v[c+23|0])}fb=c+32|0;return f}function vma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=fb-16|0;fb=e;a:{b:{c:{f=x[a+12>>2];h=x[a+8>>2];d:{if((f|0)<=1&h>>>0<=805306368|(f|0)<=0){if((f|0)>=-2&h>>>0>=3489660928|(f|0)>-2){break c}if((f|0)==-2&h>>>0>2147483647|(f|0)==-1){break d}break b}if((f|0)==1&h>>>0>2147483648|f>>>0>1){break b}}k=b+196648|0;break a}k=b+131112|0;break a}k=b+262184|0}l=x[a+16>>2];i=x[a+40>>2];j=x[a+36>>2];b=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=b;m=x[a+32>>2];n=x[a+28>>2];while(1){if(d){b=x[e+8>>2];g=(x[e+12>>2]<<1)+l|0;b=(b>>>16&65520)+k|0;b=(((((((D(w[g-4>>1],w[b+2>>1])+D(w[g-6>>1],w[b>>1])|0)+D(w[g-2>>1],w[b+4>>1])|0)+D(w[g>>1],w[b+6>>1])|0)+D(w[g+2>>1],w[b+8>>1])|0)+D(w[g+4>>1],w[b+10>>1])|0)+D(w[g+6>>1],w[b+12>>1])|0)+D(w[g+8>>1],w[b+14>>1])|0)/32768|0;j=j+n|0;x[c>>2]=x[c>>2]+D(b,j>>12);i=i+m|0;x[c+4>>2]=x[c+4>>2]+D(b,i>>12);Pb(e+8|0,h,f);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;x[a+40>>2]=i;x[a+20>>2]=j>>12;x[a+36>>2]=j;x[a+24>>2]=i>>12;fb=e+16|0}function ina(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0,B=0,C=0;g=fb-16|0;fb=g;r=x[a+16>>2];l=kg(1,2);b=hb;s=b;Pb(a,l,b);f=x[a+48>>2];i=x[a+40>>2];j=x[a+36>>2];e=x[a+44>>2];b=x[a+4>>2];x[g+8>>2]=x[a>>2];x[g+12>>2]=b;t=x[a+32>>2];u=x[a+28>>2];v=x[a+72>>2];m=x[a+68>>2];y=m>>31;n=x[a+64>>2];z=n>>31;o=x[a+60>>2];A=o>>31;B=x[a+8>>2];C=x[a+12>>2];while(1){b=e;if(d){p=w[(x[g+12>>2]<<1)+r>>1]<<8;e=p;e=Iua(e,e>>31,o,A);k=hb;h=e;e=Yb(b,-16777216,16776704);e=Iua(n,z,e,e>>31);q=h+e|0;h=hb+k|0;h=e>>>0>q>>>0?h+1|0:h;f=Yb(f,-16777216,16776704);e=Iua(m,y,f,f>>31);k=e+q|0;f=hb+h|0;f=e>>>0>k>>>0?f+1|0:f;e=k+8388608|0;f=e>>>0<8388608?f+1|0:f;e=Sc(e,f,24);f=(e|0)/256|0;j=j+u|0;x[c>>2]=D(f,j>>12)+x[c>>2];i=i+t|0;x[c+4>>2]=x[c+4>>2]+D(i>>12,f);Pb(g+8|0,B,C);e=e-(v&p)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=x[g+12>>2];x[a>>2]=x[g+8>>2];x[a+4>>2]=c;x[a+40>>2]=i;x[a+20>>2]=j>>12;x[a+36>>2]=j;x[a+48>>2]=f;x[a+44>>2]=b;x[a+24>>2]=i>>12;Ig(a,l,s);fb=g+16|0}function _K(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;n=fb-1040|0;fb=n;r=x[31484];a:{b:{j=n+16|0;q=z[((b>>>0<=153?b:0)<<1)+123424>>1]+121504|0;d=x[x[124115]+20>>2];if(d){k=x[d+4>>2];d=x[d>>2];e=x[d>>2]+1794895138|0;f=Cm(x[d+8>>2],e);g=Cm(x[d+12>>2],e);h=Cm(x[d+16>>2],e);c:{if(k>>>2>>>0<=f>>>0){break c}l=k-(f<<2)|0;if((g|h)&3|(l>>>0<=g>>>0|h>>>0>=l>>>0)){break c}s=h>>>2|0;t=d+(g&-4)|0;g=0;while(1){h=f>>>1|0;l=h+g|0;m=(l<<3)+t|0;i=Cm(x[m>>2],e);m=Cm(x[m+4>>2],e);if(m>>>0>=k>>>0|i>>>0>=k-m>>>0){break c}o=i;i=d+m|0;if(y[o+i|0]){break c}i=ji(q,i);if(!i){g=(d+(s<<2)|0)+(l<<3)|0;f=Cm(x[g>>2],e);e=Cm(x[g+4>>2],e);if(e>>>0>=k>>>0|f>>>0>=k-e>>>0){break c}c=d+e|0;c=y[c+f|0]?0:c;break c}if((f|0)==1){break c}o=h;f=f-h|0;h=(i|0)<0;f=h?o:f;g=h?g:l;continue}}}c=c?c:q;d=Df(c);d:{if(d>>>0>=1024){zc(j,c,1023);v[j+1023|0]=0;c=68;break d}zc(j,c,d+1|0);c=0}if(c){if((c|0)!=28){break b}c=22292}else{c=j}break a}va();p()}if(!y[c|0]){x[n>>2]=b;sy(j,1024,13091,n);c=j}x[31484]=r;Dc(a,c);fb=n+1040|0}function cma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0;e=fb-16|0;fb=e;h=x[a+40>>2];i=x[a+36>>2];l=x[a+16>>2];k=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=k;m=b+24|0;n=x[a+32>>2];o=x[a+28>>2];k=x[a+8>>2];p=x[a+12>>2];while(1){if(d){b=x[e+8>>2];f=((((x[e+12>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+l|0;b=(((b>>>16|0)+4&131064)<<1)+m|0;q=w[b+14>>1];r=w[b+12>>1];s=w[b+10>>1];t=w[b+8>>1];u=w[b+6>>1];v=w[b+4>>1];y=w[b+2>>1];b=w[b>>1];j=0;while(1){if((j|0)!=2){g=j<<1;x[(j<<2)+e>>2]=(((((D(w[f+(g|8)>>1],s)+D(w[f+(g|4)>>1],t)|0)+D(w[f+(g|12)>>1],r)|0)+D(w[f+(g|16)>>1],q)|0)/2|0)+((((D(w[f+(g|-8)>>1],y)+D(w[f+(g|-12)>>1],b)|0)+D(w[f+(g|-4)>>1],v)|0)+D(w[f+g>>1],u)|0)/2|0)|0)/16384;j=j+1|0;continue}break}i=i+o|0;x[c>>2]=x[c>>2]+D(x[e>>2],i>>12);h=h+n|0;x[c+4>>2]=x[c+4>>2]+D(x[e+4>>2],h>>12);Pb(e+8|0,k,p);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;x[a+40>>2]=h;x[a+20>>2]=i>>12;x[a+36>>2]=i;x[a+24>>2]=h>>12;fb=e+16|0}function jna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,y=0,z=0,A=0,B=0,C=0;g=fb-16|0;fb=g;r=x[a+16>>2];l=kg(1,2);b=hb;s=b;Pb(a,l,b);f=x[a+48>>2];i=x[a+40>>2];j=x[a+36>>2];e=x[a+44>>2];b=x[a+4>>2];x[g+8>>2]=x[a>>2];x[g+12>>2]=b;t=x[a+32>>2];u=x[a+28>>2];w=x[a+72>>2];m=x[a+68>>2];y=m>>31;n=x[a+64>>2];z=n>>31;o=x[a+60>>2];A=o>>31;B=x[a+8>>2];C=x[a+12>>2];while(1){b=e;if(d){p=v[x[g+12>>2]+r|0]<<16;e=p;e=Iua(e,e>>31,o,A);k=hb;h=e;e=Yb(b,-16777216,16776704);e=Iua(n,z,e,e>>31);q=h+e|0;h=hb+k|0;h=e>>>0>q>>>0?h+1|0:h;f=Yb(f,-16777216,16776704);e=Iua(m,y,f,f>>31);k=e+q|0;f=hb+h|0;f=e>>>0>k>>>0?f+1|0:f;e=k+8388608|0;f=e>>>0<8388608?f+1|0:f;e=Sc(e,f,24);f=(e|0)/256|0;j=j+u|0;x[c>>2]=D(f,j>>12)+x[c>>2];i=i+t|0;x[c+4>>2]=x[c+4>>2]+D(i>>12,f);Pb(g+8|0,B,C);e=e-(w&p)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=x[g+12>>2];x[a>>2]=x[g+8>>2];x[a+4>>2]=c;x[a+40>>2]=i;x[a+20>>2]=j>>12;x[a+36>>2]=j;x[a+48>>2]=f;x[a+44>>2]=b;x[a+24>>2]=i>>12;Ig(a,l,s);fb=g+16|0}function OL(a,b,c,d,e){var f=E(0),g=0,h=E(0),i=0,j=E(0),k=E(0);if(!(a&3)){c=(c<<2)+b|0;d=c+(d<<2)|0;a=a>>2;while(1){if((a|0)>0){b=d-4|0;h=B[b>>2];j=B[c>>2];k=B[d>>2];B[c>>2]=j+k;g=c-4|0;f=B[g>>2];B[g>>2]=f+B[b>>2];j=E(j-k);f=E(f-h);B[d>>2]=E(j*B[e>>2])-E(B[e+4>>2]*f);B[b>>2]=E(f*B[e>>2])+E(j*B[e+4>>2]);b=d-12|0;j=B[b>>2];g=c-8|0;f=B[g>>2];i=g;g=d-8|0;k=B[g>>2];B[i>>2]=f+k;i=c-12|0;h=B[i>>2];B[i>>2]=h+B[b>>2];f=E(f-k);h=E(h-j);B[g>>2]=E(f*B[e+32>>2])-E(B[e+36>>2]*h);B[b>>2]=E(h*B[e+32>>2])+E(f*B[e+36>>2]);b=d-20|0;j=B[b>>2];g=c-16|0;f=B[g>>2];i=g;g=d-16|0;k=B[g>>2];B[i>>2]=f+k;i=c-20|0;h=B[i>>2];B[i>>2]=h+B[b>>2];f=E(f-k);h=E(h-j);B[g>>2]=E(f*B[e+64>>2])-E(B[e+68>>2]*h);B[b>>2]=E(h*B[e+64>>2])+E(f*B[e+68>>2]);b=d-28|0;j=B[b>>2];g=c-24|0;f=B[g>>2];i=g;g=d-24|0;k=B[g>>2];B[i>>2]=f+k;i=c-28|0;h=B[i>>2];B[i>>2]=h+B[b>>2];f=E(f-k);h=E(h-j);B[g>>2]=E(f*B[e+96>>2])-E(B[e+100>>2]*h);B[b>>2]=E(h*B[e+96>>2])+E(f*B[e+100>>2]);a=a-1|0;d=d-32|0;c=c-32|0;e=e+128|0;continue}break}return}_(15858,13274,2423,9227);p()}function wsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=fb-16|0;fb=e;d=Yh(b,c);n=e,o=Bb(y[a|0]|y[a+1|0]<<8),w[n+14>>1]=o;w[e+12>>1]=64;fh(d,z[Oc(e+14|0,e+12|0)>>1]);n=d,o=Bb(y[a+14|0]|y[a+15|0]<<8),v[n+13|0]=o;n=d,o=Bb(y[a+16|0]|y[a+17|0]<<8),v[n+14|0]=o;n=d,o=Bb(y[a+20|0]|y[a+21|0]<<8),v[n+15|0]=o;n=d,o=Bb(y[a+22|0]|y[a+23|0]<<8),v[n+16|0]=o;i=x[d>>2];f=x[d+4>>2];b=y[d+12|0]&-2|mc(i,f)^1;v[d+12|0]=b;b=b&-3|Bb(y[a+12|0]|y[a+13|0]<<8)>>>3&2;v[d+12|0]=b;n=d,o=b&251|Bb(y[a+12|0]|y[a+13|0]<<8)>>>3&4,v[n+12|0]=o;b=4096;a:{b:{switch(c-1|0){case 0:j=-128;b=127;break a;case 1:break b;default:break a}}j=-1616;b=1616}d=b-j|0;k=d>>>1|0;m=Sd(i,f);b=0;while(1){if(b>>>0>=m>>>0){fb=e+16|0}else{f=yb(i,b);w[f>>1]=l;g=(b<<2)+a|0;c=ze((y[g+28|0]|y[g+29|0]<<8)<<16>>16)+j|0;h=c;c=c>>31<<6|c>>>26;h=k+(h<<6)|0;c=h>>>0<k>>>0?c+1|0:c;n=f,o=Eh(Gc(Jua(h,c,d,0),hb)),v[n+2|0]=o;n=e,o=Bb(y[g+26|0]|y[g+27|0]<<8),w[n+10>>1]=o;w[e+8>>1]=1;b=b+1|0;l=z[qe(e+10|0,e+8|0)>>1]+l|0;continue}break}}function $ta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=fb-32|0;fb=g;i=a+8|0;c=x[a+8>>2];h=nc(a);a:{if((c|0)!=x[h>>2]){break a}k=a+4|0;d=x[a+4>>2];e=x[a>>2];if(d>>>0>e>>>0){f=fb-16|0;fb=f;l=f+8|0;a=fb-32|0;fb=a;fd(a+24|0,d,c);m=a+16|0;c=x[a+24>>2];h=x[a+28>>2];j=((d-e>>1)+1|0)/-2<<1;d=d+j|0;e=fb-16|0;fb=e;while(1){if((c|0)!=(h|0)){d=_$(d,c)+2|0;c=c+2|0;continue}break}x[e+12>>2]=d;rc(m,h,e+12|0);fb=e+16|0;c=x[a+16>>2];x[a+12>>2]=x[a+20>>2];rc(l,c,a+12|0);fb=a+32|0;fb=f+16|0;c=x[f+12>>2];x[i>>2]=c;x[k>>2]=x[k>>2]+j;break a}x[g+8>>2]=c-e;x[g+28>>2]=1;d=g+8|0;c=x[bd(d,g+28|0)>>2];c=fk(d,c,c>>>2|0,x[a+16>>2]);d=vb(g+4|0,x[a+4>>2]);f=vb(g,x[a+8>>2]);d=x[d>>2];e=rE(d,x[f>>2]);f=fb-16|0;fb=f;x[f+12>>2]=d;e=Ap(f,c+8|0,e);d=x[e>>2];while(1){if(x[e+4>>2]!=(d|0)){j=d;d=x[f+12>>2];bj(j,y[d|0]|y[d+1|0]<<8);d=x[e>>2]+2|0;x[e>>2]=d;ge(f+12|0);continue}break}je(e);fb=f+16|0;Tb(a,c);Tb(k,c+4|0);Tb(i,c+8|0);Tb(h,nc(c));cj(c);c=x[a+8>>2]}bj(c,y[b|0]|y[b+1|0]<<8);x[i>>2]=x[i>>2]+2;fb=g+32|0}function wma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=fb-16|0;fb=e;a:{b:{c:{f=x[a+12>>2];h=x[a+8>>2];d:{if((f|0)<=1&h>>>0<=805306368|(f|0)<=0){if((f|0)>=-2&h>>>0>=3489660928|(f|0)>-2){break c}if((f|0)==-2&h>>>0>2147483647|(f|0)==-1){break d}break b}if((f|0)==1&h>>>0>2147483648|f>>>0>1){break b}}k=b+196648|0;break a}k=b+131112|0;break a}k=b+262184|0}l=x[a+16>>2];i=x[a+40>>2];j=x[a+36>>2];b=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=b;m=x[a+32>>2];n=x[a+28>>2];while(1){if(d){b=x[e+8>>2];g=x[e+12>>2]+l|0;b=(b>>>16&65520)+k|0;b=(((((((D(v[g-2|0],w[b+2>>1])+D(v[g-3|0],w[b>>1])|0)+D(v[g-1|0],w[b+4>>1])|0)+D(v[g|0],w[b+6>>1])|0)+D(v[g+1|0],w[b+8>>1])|0)+D(v[g+2|0],w[b+10>>1])|0)+D(v[g+3|0],w[b+12>>1])|0)+D(v[g+4|0],w[b+14>>1])<<8)/32768|0;j=j+n|0;x[c>>2]=x[c>>2]+D(b,j>>12);i=i+m|0;x[c+4>>2]=x[c+4>>2]+D(b,i>>12);Pb(e+8|0,h,f);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;x[a+40>>2]=i;x[a+20>>2]=j>>12;x[a+36>>2]=j;x[a+24>>2]=i>>12;fb=e+16|0}function iC(a,b,c){var d=0,e=0;b=b-a>>5;while(1){if((b|0)>0){d=y[c+4|0]|y[c+5|0]<<8|(y[c+6|0]<<16|y[c+7|0]<<24);e=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);v[a|0]=e;v[a+1|0]=e>>>8;v[a+2|0]=e>>>16;v[a+3|0]=e>>>24;v[a+4|0]=d;v[a+5|0]=d>>>8;v[a+6|0]=d>>>16;v[a+7|0]=d>>>24;d=y[c+28|0]|y[c+29|0]<<8|(y[c+30|0]<<16|y[c+31|0]<<24);e=y[c+24|0]|y[c+25|0]<<8|(y[c+26|0]<<16|y[c+27|0]<<24);v[a+24|0]=e;v[a+25|0]=e>>>8;v[a+26|0]=e>>>16;v[a+27|0]=e>>>24;v[a+28|0]=d;v[a+29|0]=d>>>8;v[a+30|0]=d>>>16;v[a+31|0]=d>>>24;d=y[c+20|0]|y[c+21|0]<<8|(y[c+22|0]<<16|y[c+23|0]<<24);e=y[c+16|0]|y[c+17|0]<<8|(y[c+18|0]<<16|y[c+19|0]<<24);v[a+16|0]=e;v[a+17|0]=e>>>8;v[a+18|0]=e>>>16;v[a+19|0]=e>>>24;v[a+20|0]=d;v[a+21|0]=d>>>8;v[a+22|0]=d>>>16;v[a+23|0]=d>>>24;d=y[c+12|0]|y[c+13|0]<<8|(y[c+14|0]<<16|y[c+15|0]<<24);e=y[c+8|0]|y[c+9|0]<<8|(y[c+10|0]<<16|y[c+11|0]<<24);v[a+8|0]=e;v[a+9|0]=e>>>8;v[a+10|0]=e>>>16;v[a+11|0]=e>>>24;v[a+12|0]=d;v[a+13|0]=d>>>8;v[a+14|0]=d>>>16;v[a+15|0]=d>>>24;b=b-1|0;a=a+32|0;continue}break}}function baa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=fb-32|0;fb=h;p=b+20|0;k=x[d+4>>2];m=x[d>>2];l=m;while(1){a:{if(!k){break a}g=0;e=fb-32|0;fb=e;i=b+20|0;f=b+212|0;j=c&-4096;b:{c:{while(1){if((g|0)==16){break c}d=x[yb(f,g)>>2];n=Vd(i,d);if(!((j|0)==x[n>>2]?y[n+8|0]:0)){g=g+1|0;continue}break}g=f+(g<<2)|0;jM(f,g,g+4|0);q=yb(f,0),r=d,x[q>>2]=r;break b}d=x[yb(f,15)>>2];jM(f,b+272|0,b+276|0);q=yb(f,0),r=d,x[q>>2]=r;f=Vd(i,d);x[f>>2]=j;oz(e+16|0,x[b+8>>2],d);g=x[x[b>>2]+44>>2];i=x[e+20>>2];x[e+8>>2]=x[e+16>>2];x[e+12>>2]=i;ib[g|0](e+24|0,b,j,e+8|0);x[f+4>>2]=x[e+28>>2];v[f+8|0]=1}fb=e+32|0;e=Vd(p,d);f=c-x[e>>2]|0;x[h+16>>2]=4096-f;x[h+8>>2]=k;g=h+16|0;j=h+8|0;q=h,r=x[Hb(g,j)>>2],x[q+28>>2]=r;e=x[e+4>>2];i=e-f|0;x[h+24>>2]=e>>>0>=i>>>0?i:0;e=x[Hb(h+28|0,h+24|0)>>2];oz(g,x[b+8>>2],d);g=x[h+16>>2];oz(j,x[b+8>>2],d);yk(f+g|0,e+(f+x[h+8>>2]|0)|0,l);o=e+o|0;if(e>>>0<A[h+28>>2]){break a}c=c+e|0;l=e+l|0;k=k-e|0;continue}break}cc(a,m,o);fb=h+32|0}function era(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=Pv(c,d);d=b&63;if(e>>>0>d>>>0){c=_Y(c,d);d=0;g=fb-16|0;fb=g;v[a+12|0]=0;Nc(a);e=fb-32|0;fb=e;a:{b:{if(Vg(a)>>>0<=14){if(uh(1073741823)>>>0<=14){break b}f=Ab(a);f=Zf(e+12|0,15,oc(x[a>>2],x[a+4>>2]),f);Xr(a,f);Yf(f)}fb=e+32|0;break a}ed();p()}h=0-y[c+1|0]|0;while(1){c:{if((d|0)==15){break c}e=c+(d<<1)|0;f=y[e+1|0];if(!f){break c}v[g+11|0]=64;h=f+(h<<16>>16)|0;f=Zl(g+12|0,h&65535,y[Qb(e+2|0,g+11|0)|0]);d:{if(A[a+4>>2]<A[Ab(a)>>2]){WY(a,f);break d}i=fb-32|0;fb=i;e=Ab(a);e=Zf(i+12|0,Mf(a,oc(x[a>>2],x[a+4>>2])+1|0),oc(x[a>>2],x[a+4>>2]),e);bp(x[e+8>>2],z[f>>1]|z[f+2>>1]<<16);x[e+8>>2]=x[e+8>>2]+4;Xr(a,e);Yf(e);fb=i+32|0}d=d+1|0;continue}break}d=y[c+32|0];v[a+14|0]=d>>>4;v[a+13|0]=d&15;c=y[c+31|0];d=c&15;v[a+15|0]=d;v[a+16|0]=d;if(c&16){v[a+12|0]=y[a+12|0]|4}if(c&32){v[a+12|0]=y[a+12|0]|2}fb=g+16|0}e:{f:{if(b<<24>>24>=0){b=a+12|0;break f}b=a+12|0;if(mc(x[a>>2],x[a+4>>2])){break f}a=y[a+12|0]|1;break e}a=y[b|0]&-2}v[b|0]=a}function Hma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0;g=fb-16|0;fb=g;f=x[a+48>>2];o=x[a+24>>2];p=x[a+20>>2];e=x[a+44>>2];q=x[a+16>>2];b=x[a+4>>2];x[g+8>>2]=x[a>>2];x[g+12>>2]=b;r=x[a+72>>2];l=x[a+68>>2];s=l>>31;m=x[a+64>>2];t=m>>31;n=x[a+60>>2];u=n>>31;v=x[a+8>>2];y=x[a+12>>2];while(1){b=e;if(d){e=Yb(e,-16777216,16776704);i=Iua(m,t,e,e>>31);j=hb;e=x[g+8>>2];h=(x[g+12>>2]<<1)+q|0;e=e>>>21&2040;h=(((D(w[h>>1],w[e+38082>>1])+D(w[h-2>>1],w[e+38080>>1])|0)+D(w[h+2>>1],w[e+38084>>1])|0)+D(w[h+4>>1],w[e+38086>>1])|0)/16384<<8;e=h;e=Iua(e,e>>31,n,u);i=e+i|0;k=hb+j|0;k=e>>>0>i>>>0?k+1|0:k;f=Yb(f,-16777216,16776704);e=Iua(l,s,f,f>>31);j=e+i|0;f=hb+k|0;f=e>>>0>j>>>0?f+1|0:f;e=j+8388608|0;f=e>>>0<8388608?f+1|0:f;e=Sc(e,f,24);f=(e|0)/256|0;x[c>>2]=D(f,p)+x[c>>2];x[c+4>>2]=x[c+4>>2]+D(f,o);Pb(g+8|0,v,y);e=e-(h&r)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=x[g+12>>2];x[a>>2]=x[g+8>>2];x[a+4>>2]=c;x[a+48>>2]=f;x[a+44>>2]=b;fb=g+16|0}function GD(a,b,c){var d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;v[d+15|0]=c;e=a;a:{b:{c:{switch(b-14|0){case 0:b=14;if(!c){break b}d:{if((c|0)!=15){if((c|0)!=240){break d}v[d+15|0]=239;break b}v[d+15|0]=254;break b}if(c>>>0>=16){v[d+15|0]=c|15;break b}v[d+15|0]=c|240;break b;case 1:v[d+15|0]=c^128;b=15;break b;case 6:case 7:if(c>>>0>=16){v[d+15|0]=c>>>4|240;break b}v[d+15|0]=c|224;break b;case 8:v[d+15|0]=((c^-1)&254)>>>1;b=22;break b;case 9:v[d+15|0]=c&15|128;b=23;break b;case 17:f=d,g=Eh(c<<1),v[f+15|0]=g;b=31;break b;case 19:a=32;b=33;e:{f:{switch(c>>>4|0){default:b=0;break b;case 8:a=64;break e;case 10:a=176;break e;case 11:a=224;break e;case 12:case 13:b=c?33:0;break b;case 14:g:{switch(c&15){case 0:v[d+15|0]=119;break b;case 1:v[d+15|0]=119;break b;case 2:v[d+15|0]=121;break b;case 3:break g;default:break b}}v[d+15|0]=123;break b;case 3:break e;case 5:break f;case 0:break b}}a=48}v[d+15|0]=c&15|a;break b;default:break c}}a=0;if(b>>>0>35){break a}}a=y[b+25008|0]}ee(e,a,d+15|0);fb=d+16|0}function gua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=fb-144|0;fb=f;x[31609]=0;l=R(273,a|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){while(1){a:{if((j&65535)>>>0>=l>>>0){ub(a);fb=f+144|0;return}x[31609]=0;O(292,a|0,f+8|0);e=x[31609];x[31609]=0;if((e|0)!=1){b:{e=Bb(z[f+8>>1]);if((e-1&65535)>>>0>=z[c+480192>>1]){break b}e=x[((e<<2)+c|0)+900380>>2];if(!e){break b}e=Yh(e,b);g=y[f+11|0];c:{if(!g){break c}h=y[f+10|0];if(h&1){v[e+12|0]=y[e+12|0]|1}if(h&2){v[e+12|0]=y[e+12|0]|4}if(!(h&4)){break c}v[e+12|0]=y[e+12|0]|2}v[f+4|0]=g;v[f+7|0]=31;h=y[Qb(f+4|0,f+7|0)|0];x[31609]=0;h=h+1&255;O(293,e|0,h|0);g=x[31609];x[31609]=0;if((g|0)==1){break a}v[e+13|0]=y[f+13|0];v[e+14|0]=y[f+14|0];g=y[f+12|0];v[e+15|0]=g;v[e+16|0]=g;g=x[e>>2];e=0;while(1){if((e|0)==(h|0)){break b}i=(f+8|0)+(e<<2)|0;m=Bb(z[i+8>>1]);k=yb(g,e);w[k>>1]=m;i=Bb(z[i+10>>1]);w[f+4>>1]=d?i+128>>>2|0:i;Hf(f+4|0,64);v[k+2|0]=y[f+4|0];e=e+1|0;continue}}j=j+1|0;continue}}break}}b=N()|0;ub(a);Q(b|0);p()}function jba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;if(A[a+4>>2]<A[Ab(a)>>2]){d=fb-16|0;fb=d;c=d+4|0;x[c>>2]=a;a=x[a+4>>2];x[c+4>>2]=a;x[c+8>>2]=a+24;dN(x[c+4>>2],b);x[c+4>>2]=x[c+4>>2]+24;kc(c);fb=d+16|0;return}i=fb-32|0;fb=i;c=Ab(a);c=LJ(i+12|0,OJ(a,hj(x[a>>2],x[a+4>>2])+1|0),hj(x[a>>2],x[a+4>>2]),c);dN(x[c+8>>2],b);x[c+8>>2]=x[c+8>>2]+24;g=fb-16|0;fb=g;d=vb(g+12|0,x[a+4>>2]);e=vb(g+8|0,x[a>>2]);f=x[vb(g+4|0,x[c+4>>2])>>2];h=fb-16|0;fb=h;b=fb-32|0;fb=b;fd(b+24|0,x[d>>2],x[e>>2]);k=b+16|0;e=x[b+24>>2];l=x[b+28>>2];d=fb-16|0;fb=d;x[d+8>>2]=f;x[d+12>>2]=e;while(1){if(Fd(e,l)){e=jl(e);f=jl(x[d+8>>2]);x[f+16>>2]=x[e+16>>2];j=x[e+12>>2];x[f+8>>2]=x[e+8>>2];x[f+12>>2]=j;j=x[e+4>>2];x[f>>2]=x[e>>2];x[f+4>>2]=j;e=ft(d+12|0);ft(d+8|0);e=x[e>>2];continue}break}rc(k,e,d+8|0);fb=d+16|0;d=x[b+16>>2];x[b+12>>2]=x[b+20>>2];rc(h+8|0,d,b+12|0);fb=b+32|0;fb=h+16|0;x[c+4>>2]=x[h+12>>2];Tb(a,c+4|0);Tb(a+4|0,c+8|0);Tb(Ab(a),nc(c));x[c>>2]=x[c+4>>2];fb=g+16|0;IJ(c);fb=i+32|0}function Ima(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0;h=fb-16|0;fb=h;e=x[a+48>>2];n=x[a+24>>2];o=x[a+20>>2];f=x[a+44>>2];p=x[a+16>>2];b=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=b;q=x[a+72>>2];j=x[a+68>>2];r=j>>31;k=x[a+64>>2];s=k>>31;l=x[a+60>>2];t=l>>31;u=x[a+8>>2];y=x[a+12>>2];while(1){b=f;if(d){f=Yb(f,-16777216,16776704);g=Iua(k,s,f,f>>31);f=hb;e=Yb(e,-16777216,16776704);e=Iua(j,r,e,e>>31);g=e+g|0;f=hb+f|0;f=e>>>0>g>>>0?f+1|0:f;e=x[h+8>>2];i=g;g=x[h+12>>2]+p|0;e=e>>>21&2040;m=(((D(v[g|0],w[e+38082>>1])+D(v[g-1|0],w[e+38080>>1])|0)+D(v[g+1|0],w[e+38084>>1])|0)+D(v[g+2|0],w[e+38086>>1])<<8)/16384<<8;e=m;g=Iua(e,e>>31,l,t);i=i+g|0;e=hb+f|0;e=g>>>0>i>>>0?e+1|0:e;f=i+8388608|0;e=f>>>0<8388608?e+1|0:e;f=Sc(f,e,24);e=(f|0)/256|0;x[c>>2]=D(e,o)+x[c>>2];x[c+4>>2]=x[c+4>>2]+D(e,n);Pb(h+8|0,u,y);f=f-(q&m)|0;c=c+8|0;d=d-1|0;e=b;continue}break}c=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=c;x[a+48>>2]=e;x[a+44>>2]=b;fb=h+16|0}function r8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=fb-32|0;fb=g;x[g+28>>2]=b;a:{b:{if(!(v[d+4|0]&1)){x[g>>2]=-1;b=ib[x[x[a>>2]+16>>2]](a,b,c,d,e,g)|0;c:{switch(x[g>>2]){case 1:v[f|0]=1;break a;case 0:break b;default:break c}}v[f|0]=1;x[e>>2]=4;break a}cd(g,x[d+28>>2]);x[31609]=0;b=R(1252,x[g>>2])|0;a=x[31609];x[31609]=0;d:{e:{f:{g:{if((a|0)!=1){_b(g);cd(g,x[d+28>>2]);x[31609]=0;a=R(1253,x[g>>2])|0;d=x[31609];x[31609]=0;if((d|0)==1){break g}_b(g);x[31609]=0;O(1254,g|0,a|0);d=x[31609];x[31609]=0;if((d|0)==1){b=N()|0;break d}x[31609]=0;O(1255,g|12,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break f}x[31609]=0;d=g+24|0;a=sa(1256,g+28|0,c|0,g|0,d|0,b|0,e|0,1)|0;b=x[31609];x[31609]=0;if((b|0)==1){break e}v[f|0]=(a|0)==(g|0);b=x[g+28>>2];while(1){d=Ub(d-12|0);if((g|0)!=(d|0)){continue}break}break a}b=N()|0;_b(g);break d}b=N()|0;_b(g);break d}b=N()|0;Ub(g);break d}b=N()|0;while(1){d=Ub(d-12|0);if((g|0)!=(d|0)){continue}break}}Q(b|0);p()}v[f|0]=0}fb=g+32|0;return b|0}function C8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=fb-32|0;fb=g;x[g+28>>2]=b;a:{b:{if(!(v[d+4|0]&1)){x[g>>2]=-1;b=ib[x[x[a>>2]+16>>2]](a,b,c,d,e,g)|0;c:{switch(x[g>>2]){case 1:v[f|0]=1;break a;case 0:break b;default:break c}}v[f|0]=1;x[e>>2]=4;break a}cd(g,x[d+28>>2]);x[31609]=0;b=R(28,x[g>>2])|0;a=x[31609];x[31609]=0;d:{e:{f:{g:{if((a|0)!=1){_b(g);cd(g,x[d+28>>2]);x[31609]=0;a=R(1235,x[g>>2])|0;d=x[31609];x[31609]=0;if((d|0)==1){break g}_b(g);x[31609]=0;O(1236,g|0,a|0);d=x[31609];x[31609]=0;if((d|0)==1){b=N()|0;break d}x[31609]=0;O(1237,g|12,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break f}x[31609]=0;d=g+24|0;a=sa(1238,g+28|0,c|0,g|0,d|0,b|0,e|0,1)|0;b=x[31609];x[31609]=0;if((b|0)==1){break e}v[f|0]=(a|0)==(g|0);b=x[g+28>>2];while(1){d=tb(d-12|0);if((g|0)!=(d|0)){continue}break}break a}b=N()|0;_b(g);break d}b=N()|0;_b(g);break d}b=N()|0;tb(g);break d}b=N()|0;while(1){d=tb(d-12|0);if((g|0)!=(d|0)){continue}break}}Q(b|0);p()}v[f|0]=0}fb=g+32|0;return b|0}function sk(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0;i=fb-16|0;fb=i;x[i+8>>2]=c;x[i+12>>2]=b;b=i+4|0;cd(b,x[d+28>>2]);c=0;x[31609]=0;j=R(28,x[i+4>>2])|0;k=x[31609];x[31609]=0;if((k|0)!=1){_b(b);x[e>>2]=0;a:{while(1){if((g|0)==(h|0)|c){break a}b:{if(th(i+12|0,i+8|0)){break b}c:{if((nl(j,v[g|0])|0)==37){if((g+1|0)==(h|0)){break b}c=nl(j,v[g+1|0]);d:{if(!((c|0)==69|(c&255)==48)){b=0;k=1;break d}if((g+2|0)==(h|0)){break b}b=c;c=nl(j,v[g+2|0]);k=2}l=i,m=ib[x[x[a>>2]+36>>2]](a,x[i+12>>2],x[i+8>>2],d,e,f,c,b)|0,x[l+12>>2]=m;g=(g+k|0)+1|0;break c}b=x[j+8>>2];if(Jf(b,1,v[g|0])){while(1){e:{g=g+1|0;if((h|0)==(g|0)){g=h;break e}if(Jf(b,1,v[g|0])){continue}}break}while(1){b=i+12|0;if(th(b,i+8|0)){break c}c=ul(x[i+12>>2]);if(!Jf(x[j+8>>2],1,c)){break c}Gm(b);continue}}if((Ky(j,ul(x[i+12>>2]))|0)==(Ky(j,v[g|0])|0)){g=g+1|0;Gm(i+12|0);break c}x[e>>2]=4}c=x[e>>2];continue}break}x[e>>2]=4}if(th(i+12|0,i+8|0)){x[e>>2]=x[e>>2]|2}fb=i+16|0;return x[i+12>>2]}a=N()|0;_b(i+4|0);Q(a|0);p()}function Paa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=fb+-64|0;fb=c;f=x[a>>2];a=x[f>>2];g=x[a+4>>2];x[c+40>>2]=x[a+20>>2];d=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=d;Xf(c+48|0,c+32|0,g);a=x[f+4>>2];f=x[a+8>>2];g=x[a+4>>2];d=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=d;d=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=d;x[c+8>>2]=x[a+8>>2];d=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=d;a:{b:{c:{d:{d=x[c+4>>2];if(g>>>0<=d>>>0){if(g>>>0>A[c+20>>2]){break d}if(f>>>0>A[c+8>>2]){break c}h=x[c+28>>2];if(f>>>0>x[c+24>>2]-h>>>0){break b}i=b+12|0;j=x[c+16>>2];k=x[c>>2];b=0;e:while(1){if((b|0)==(f|0)){break a}l=(D(b,d)<<2)+k|0;a=0;while(1)if((a|0)==(g|0)){b=b+1|0;continue e}else{e=a<<2;m=x[e+l>>2];n=Yt(i);o=(x[e+j>>2]+(h<<1)|0)+(b<<1)|0;e=rd((rd(n,21)+m|0)+2048|0,12);e=(e|0)>=32767?32767:e;w[o>>1]=(e|0)<=-32768?-32768:e;a=a+1|0;continue}}}_(7244,9061,33,8774);p()}_(7209,9061,34,8774);p()}_(5897,9061,35,8774);p()}_(5867,9061,36,8774);p()}fb=c- -64|0}function dma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,y=0;e=fb-16|0;fb=e;g=x[a+40>>2];h=x[a+36>>2];j=x[a+16>>2];i=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=i;k=b+24|0;l=x[a+32>>2];m=x[a+28>>2];i=x[a+8>>2];n=x[a+12>>2];while(1){if(d){b=x[e+8>>2];f=(((x[e+12>>2]&2147483647)<<1|b>>>31)&-2)+j|0;b=(((b>>>16|0)+4&131064)<<1)+k|0;o=w[b+14>>1];p=w[b+12>>1];q=w[b+10>>1];r=w[b+8>>1];s=w[b+6>>1];t=w[b+4>>1];u=w[b+2>>1];y=w[b>>1];b=0;while(1){if((b|0)!=2){x[(b<<2)+e>>2]=((((D(v[(b|4)+f|0],q)+D(v[(b|2)+f|0],r)|0)+D(v[(b|6)+f|0],p)|0)+D(v[(b|8)+f|0],o)<<8>>1)+(((D(v[(b|-4)+f|0],u)+D(v[(b|-6)+f|0],y)|0)+D(v[(b|-2)+f|0],t)|0)+D(v[b+f|0],s)<<8>>1)|0)/16384;b=b+1|0;continue}break}h=h+m|0;x[c>>2]=x[c>>2]+D(x[e>>2],h>>12);g=g+l|0;x[c+4>>2]=x[c+4>>2]+D(x[e+4>>2],g>>12);Pb(e+8|0,i,n);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;x[a+40>>2]=g;x[a+20>>2]=h>>12;x[a+36>>2]=h;x[a+24>>2]=g>>12;fb=e+16|0}function Ex(a,b,c,d){var e=0,f=0,g=0,h=0;g=fb-32|0;fb=g;e=d&2147483647;h=e;f=e-1006698496|0;e=e-1140785152|0;a:{if((f|0)==(e|0)&0|e>>>0>f>>>0){e=c<<4|b>>>28;c=d<<4|c>>>28;b=b&268435455;if((b|0)==134217728&(a|0)!=0|b>>>0>134217728){f=c+1073741824|0;e=e+1|0;f=e?f:f+1|0;break a}f=c+1073741824|0;if(a|(b|0)!=134217728){break a}a=e&1;e=a+e|0;f=a>>>0>e>>>0?f+1|0:f;break a}if(!(!c&(h|0)==2147418112?!(a|b):h>>>0<2147418112)){a=d<<4|c>>>28;e=c<<4|b>>>28;f=a&524287|2146959360;break a}e=0;f=2146435072;if(h>>>0>1140785151){break a}f=0;h=h>>>16|0;if(h>>>0<15249){break a}e=d&65535|65536;$f(g+16|0,a,b,c,e,h-15233|0);cn(g,a,b,c,e,15361-h|0);b=x[g+8>>2];e=b<<4;b=x[g+12>>2]<<4|b>>>28;c=x[g>>2];f=x[g+4>>2];h=f;e=f>>>28|e;f=b;a=h&268435455;b=c|(x[g+16>>2]|x[g+24>>2]|(x[g+20>>2]|x[g+28>>2]))!=0;if((a|0)==134217728&(b|0)!=0|a>>>0>134217728){e=e+1|0;f=e?f:f+1|0;break a}if(b|(a|0)!=134217728){break a}a=e;e=e+(e&1)|0;f=a>>>0>e>>>0?f+1|0:f}fb=g+32|0;l(0,e|0);l(1,d&-2147483648|f);return+n()}function If(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=fb-32|0;fb=d;c=x[a+36>>2];ig(x[x[c>>2]-12>>2]+c|0,0);c=a+32|0;Qc(d+12|0,c,4);if(!Gb(x[x[d+12>>2]>>2],x[d+16>>2])){yy(a)}a:{if(!x[a+8>>2]){break a}Qc(d+12|0,c,6);if(Gb(x[x[d+12>>2]>>2],x[d+16>>2])){break a}Qc(d+24|0,c,7);if(Gb(x[x[d+24>>2]>>2],x[d+28>>2])){break a}f=x[a+36>>2];e=x[a+92>>2];g=D(x[a+28>>2],x[a+8>>2]);h=g;g=g+x[a+88>>2]|0;e=h>>>0>g>>>0?e+1|0:e;Di(f,g,e,0)}Qc(d+12|0,c,5);c=0;b:{if(!Gb(x[x[d+12>>2]>>2],x[d+16>>2])){break b}e=hj(x[a+52>>2],x[a+56>>2]);while(1){if((e|0)==(i|0)){break b}c:{g=(x[a+108>>2]+i>>>0)%(e>>>0)|0;f=wf(x[a+52>>2],g);h=x[f>>2];j=x[a+40>>2];if(h>>>0>=Xc(j,x[a+44>>2])>>>0){break c}f=sl(d+12|0,xb(j,h),z[f+20>>1]);h=Jy(b,f);Eb(f);if(!h){break c}b=g+1|0;x[a+108>>2]=(b|0)!=(e|0)?b:0;c=wf(x[a+52>>2],g);b=x[c+8>>2];e=x[c+12>>2];if(!(b|e)){break b}f=x[a+16>>2];c=f+b|0;b=x[a+20>>2]+e|0;Di(x[a+36>>2],c,c>>>0<f>>>0?b+1|0:b,0);c=wf(x[a+52>>2],g);break b}i=i+1|0;continue}}fb=d+32|0;return c}function CH(a,b,c){var d=0,e=0,f=0;e=fb-32|0;fb=e;a:{f=Zs(e+28|0,b);d=x[f>>2];if(!Ed(d)){x[31609]=0;b=P(36,e+4|0,b|0)|0;a=x[31609];x[31609]=0;b:{c:{d:{if((a|0)!=1){x[31609]=0;a=e+16|0;S(1011,a|0,17716,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break d}x[31609]=0;W(1367,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}p()}a=N()|0;break a}a=N()|0;break b}a=N()|0;tb(e+16|0)}tb(b);break a}Ys(d);if(!Xs(a+8|0,22292,x[f>>2])){v[a+8|0]=127}if(!Xs(a+9|0,22292,x[f>>2])){v[a+9|0]=127}x[31609]=0;O(272,a+12|0,22292);b=x[31609];x[31609]=0;e:{f:{if((b|0)==1){break f}x[31609]=0;b=a+24|0;O(272,b|0,22292);d=x[31609];x[31609]=0;if((d|0)==1){break f}x[a+60>>2]=0;x[31609]=0;O(272,a+36|0,22292);d=x[31609];x[31609]=0;if((d|0)==1){break f}x[31609]=0;O(272,a+48|0,22292);d=x[31609];x[31609]=0;if((d|0)==1){break f}x[31609]=0;b=P(71,e+16|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break e}a=N()|0;break a}a=N()|0;break a}di(a- -64|0,c);di(a+68|0,c);tb(b);il(f);fb=e+32|0;return}il(f);Q(a|0);p()}function gq(a,b,c,d,e,f){var g=E(0),h=0,i=E(0),j=0,k=E(0),l=E(0);c=(c<<2)+b|0;d=c+(d<<2)|0;a=a>>2;b=f<<2;while(1){if((a|0)>0){f=d-4|0;i=B[f>>2];k=B[c>>2];l=B[d>>2];B[c>>2]=k+l;h=c-4|0;g=B[h>>2];B[h>>2]=g+B[f>>2];k=E(k-l);g=E(g-i);B[d>>2]=E(k*B[e>>2])-E(B[e+4>>2]*g);B[f>>2]=E(g*B[e>>2])+E(k*B[e+4>>2]);f=d-12|0;k=B[f>>2];h=c-8|0;g=B[h>>2];j=h;h=d-8|0;l=B[h>>2];B[j>>2]=g+l;j=c-12|0;i=B[j>>2];B[j>>2]=i+B[f>>2];g=E(g-l);e=b+e|0;i=E(i-k);B[h>>2]=E(g*B[e>>2])-E(B[e+4>>2]*i);B[f>>2]=E(i*B[e>>2])+E(g*B[e+4>>2]);f=d-20|0;k=B[f>>2];h=c-16|0;g=B[h>>2];j=h;h=d-16|0;l=B[h>>2];B[j>>2]=g+l;j=c-20|0;i=B[j>>2];B[j>>2]=i+B[f>>2];g=E(g-l);e=b+e|0;i=E(i-k);B[h>>2]=E(g*B[e>>2])-E(B[e+4>>2]*i);B[f>>2]=E(i*B[e>>2])+E(g*B[e+4>>2]);f=d-28|0;k=B[f>>2];h=c-24|0;g=B[h>>2];j=h;h=d-24|0;l=B[h>>2];B[j>>2]=g+l;j=c-28|0;i=B[j>>2];B[j>>2]=i+B[f>>2];g=E(g-l);e=b+e|0;i=E(i-k);B[h>>2]=E(g*B[e>>2])-E(B[e+4>>2]*i);B[f>>2]=E(i*B[e>>2])+E(g*B[e+4>>2]);e=b+e|0;a=a-1|0;d=d-32|0;c=c-32|0;continue}break}}function zi(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;f=qj(a)&2047;c=qj(5551115123125783e-32);a:{if(f-c>>>0>=qj(512)-c>>>0){if(c>>>0>f>>>0){return a+1}o(+a);c=j(1)|0;e=j(0)|0;b:{if(qj(1024)>>>0>f>>>0){break b}b=0;if(!e&(c|0)==-1048576){break a}if(qj(Infinity)>>>0<=f>>>0){return a+1}if((c|0)>0|(c|0)>=0){return Ms(3105036184601418e216)}if(c>>>0<3230714880){break b}return Ms(12882297539194267e-247)}c=c<<1|e>>>31;f=!(e<<1)&(c|0)==-2129002496|c>>>0<2165964800?f:0}b=C[177];g=b+a;a=a-(g-b);b=a*a;h=b*b*(a*C[182]+C[181]);b=b*(a*C[180]+C[179]);a=a*C[178];o(+g);j(1)|0;c=j(0)|0;d=c<<4&2032;a=h+(b+(a+C[d+1464>>3]));d=d+1472|0;e=0+x[d>>2]|0;d=x[d+4>>2]+(c<<13)|0;d=e>>>0<i>>>0?d+1|0:d;if(!f){c:{if(!(c&-2147483648)){l(0,e|0);l(1,d+-1048576|0);b=+n();a=b*a+b;a=a+a;break c}l(0,e|0);l(1,d+1071644672|0);b=+n();g=b*a;a=g+b;if(a<1){JJ(nK()*22250738585072014e-324);h=a+1;a=h+(g+(b-a)+(a+(1-h)))+-1;a=a==0?0:a}a=a*22250738585072014e-324}return a}l(0,e|0);l(1,d|0);b=+n();b=b*a+b}return b}function Gaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=fb+-64|0;fb=c;e=x[a>>2];a=x[e>>2];f=x[a+4>>2];x[c+40>>2]=x[a+20>>2];d=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=d;Xf(c+48|0,c+32|0,f);a=x[e+4>>2];e=x[a+8>>2];f=x[a+4>>2];d=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=d;d=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=d;x[c+8>>2]=x[a+8>>2];d=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=d;a:{b:{c:{d:{d=x[c+4>>2];if(f>>>0<=d>>>0){h=x[c+20>>2];if(f>>>0>h>>>0){break d}if(e>>>0>A[c+8>>2]){break c}i=x[c+28>>2];if(e>>>0>x[c+24>>2]-i>>>0){break b}j=b+12|0;k=x[c+16>>2];l=x[c>>2];b=0;e:while(1){if((b|0)==(e|0)){break a}m=(D(b,d)<<2)+l|0;n=(D(b+i|0,h)<<1)+k|0;a=0;while(1)if((a|0)==(f|0)){b=b+1|0;continue e}else{g=rd((x[(a<<2)+m>>2]+rd(Yt(j),21)|0)+2048|0,12);g=(g|0)>=32767?32767:g;w[(a<<1)+n>>1]=(g|0)<=-32768?-32768:g;a=a+1|0;continue}}}_(7244,9061,33,8774);p()}_(7209,9061,34,8774);p()}_(5897,9061,35,8774);p()}_(5867,9061,36,8774);p()}fb=c- -64|0}function rk(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0;i=fb-16|0;fb=i;x[i+8>>2]=c;x[i+12>>2]=b;c=i+4|0;cd(c,x[d+28>>2]);b=0;x[31609]=0;j=R(1252,x[i+4>>2])|0;k=x[31609];x[31609]=0;if((k|0)!=1){_b(c);x[e>>2]=0;a:{while(1){if((g|0)==(h|0)|b){break a}b:{if(hi(i+12|0,i+8|0)){break b}c:{if((qk(j,x[g>>2])|0)==37){if((g+4|0)==(h|0)){break b}b=qk(j,x[g+4>>2]);d:{if(!((b|0)==69|(b&255)==48)){c=0;k=1;break d}if((g+8|0)==(h|0)){break b}c=b;b=qk(j,x[g+8>>2]);k=2}l=i,m=ib[x[x[a>>2]+36>>2]](a,x[i+12>>2],x[i+8>>2],d,e,f,b,c)|0,x[l+12>>2]=m;g=((k<<2)+g|0)+4|0;break c}if(rj(j,1,x[g>>2])){while(1){e:{g=g+4|0;if((h|0)==(g|0)){g=h;break e}if(rj(j,1,x[g>>2])){continue}}break}while(1){b=i+12|0;if(hi(b,i+8|0)){break c}if(!rj(j,1,tl(x[i+12>>2]))){break c}io(b);continue}}if((km(j,tl(x[i+12>>2]))|0)==(km(j,x[g>>2])|0)){g=g+4|0;io(i+12|0);break c}x[e>>2]=4}b=x[e>>2];continue}break}x[e>>2]=4}if(hi(i+12|0,i+8|0)){x[e>>2]=x[e>>2]|2}fb=i+16|0;return x[i+12>>2]}a=N()|0;_b(i+4|0);Q(a|0);p()}function Qla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=fb-16|0;fb=e;p=x[a+16>>2];q=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);j=x[a+8>>2];k=x[a+12>>2];b=x[a>>2];g=x[a+4>>2];l=x[a+128>>2];if(l){m=Hg(j,k,l);n=hb;f=x[a+76>>2];fg(b,g,vf(j,k,d),hb);o=hb>>>0>f>>>0?d:0}f=a+112|0;h=x[a+40>>2];i=x[a+36>>2];x[e>>2]=b;x[e+4>>2]=g;a:while(1){if(d){d=d-1|0;x[e+8>>2]=b;x[e+12>>2]=0;o=o-1|0;b=o;m=b?m:0;n=b?n:0;g=(g<<1)+p|0;b=l;while(1)if((b|0)<=0){Pb(f,x[a+120>>2],x[a+124>>2]);b=x[a+116>>2];if(b){ce(f,w[g+(x[e+12>>2]<<1)>>1]/4<<16>>16);be(f,b);x[f>>2]=x[f>>2];x[f+4>>2]=0}g=x[a+32>>2];r=x[c>>2];b=Fg(f,q);i=x[a+28>>2]+i|0;x[c>>2]=D(b,i>>12)+r;h=g+h|0;x[c+4>>2]=x[c+4>>2]+D(b,h>>12);Pb(e,j,k);c=c+8|0;b=x[e>>2];g=x[e+4>>2];continue a}else{ce(f,w[g+(x[e+12>>2]<<1)>>1]/4<<16>>16);be(f,4);Pb(e+8|0,m,n);b=b-1|0;continue}}break}x[a>>2]=b;x[a+4>>2]=g;x[a+40>>2]=h;x[a+20>>2]=i>>12;x[a+36>>2]=i;x[a+24>>2]=h>>12;fb=e+16|0}function bA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=E(0);c=fb-48|0;fb=c;a:{b=x[a+20>>2];b:{if(!b){break b}d=x[b+4>>2];b=x[b+8>>2];if(Xc(d,b)>>>0<4){break b}se(c+16|0,d,b);b=Md(c+8|0);d=x[b+4>>2];x[c>>2]=x[b>>2];x[c+4>>2]=d;d=g$(c+28|0,x[c+16>>2],x[c+20>>2],c);x[31609]=0;b=R(151,d|0)|0;f=x[31609];x[31609]=0;c:{if((f|0)!=1){if(b){break c}b=x[x[a>>2]+40>>2];x[31609]=0;f=R(b|0,a|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}b=x[a+20>>2];if(Xc(x[b+4>>2],x[b+8>>2])-4>>>0<f<<2>>>0){break c}e=x[x[a>>2]+176>>2];b=0;x[31609]=0;O(e|0,a|0,-1);e=x[31609];x[31609]=0;if((e|0)==1){break a}while(1){if((b|0)==(f|0)){b=x[x[a>>2]+180>>2];x[31609]=0;W(b|0,a|0);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break a}x[31609]=0;g=E(xa(473,d|0));e=x[31609];x[31609]=0;d:{if((e|0)==1){break d}e=x[x[a>>2]+44>>2];x[31609]=0;wa(e|0,a|0,b|0,E(Vm(g)?g:E(0)));e=x[31609];x[31609]=0;if((e|0)==1){break d}b=b+1|0;continue}break}break a}break a}ub(d)}fb=c+48|0;return}a=N()|0;ub(d);Q(a|0);p()}function Lz(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=fb-16|0;fb=d;a:{b:{c:{d:{e:{f:{g:{e=x[a+36>>2];c=x[a+40>>2];h:{if(Ib(e,c)){tc(d+12|0);break h}vo(d,a);x[31609]=0;c=R(1056,d|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break g}x[d+12>>2]=c;nf(d);c=x[a+40>>2];e=x[a+36>>2]}e=(h=a+36|0,i=x[d+12>>2],j=Ib(e,c),j?h:i);if((b|0)==-1){f=x[e>>2];c=0;g=4194304;break e}if((b|0)>=0){c=b;f=x[e>>2];if((hj(f,x[e+4>>2])|0)>(b|0)){break e}}b=ac(8);x[31609]=0;c=P(36,d|0,10982)|0;a=x[31609];x[31609]=0;if((a|0)==1){break f}pc(b,c);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}a=N()|0;tb(c);break d}a=N()|0;nf(d);break c}a=N()|0;ic(b);break d}x[a+8>>2]=b;b=x[a+24>>2];x[b+480208>>2]=x[b+480208>>2]&-4194305|g;Wj(b+484360|0,y[wf(f,c)+16|0]);b=wf(x[e>>2],c);c=x[b+8>>2];b=x[b+12>>2];x[31609]=0;+oa(1088,a|0,b|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}a=N()|0}yl(d+12|0)}Q(a|0)}p()}x[a+16>>2]=0;x[a+20>>2]=0;yl(d+12|0);fb=d+16|0}function Fta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=fb-2608|0;fb=f;d=eE(f+4|0,a);x[d+1060>>2]=0;x[d+1064>>2]=0;a=1068;while(1){e=a+d|0;v[e+4|0]=0;w[e>>1]=0;w[e+2>>1]=0;a=a+6|0;if((a|0)!=2604){continue}break}x[31609]=0;W(323,d|0);a=x[31609];x[31609]=0;a:{b:{if((a|0)!=1){if((w[d+1068>>1]|w[d+1070>>1])<0){break a}c:{while(1){if((c|0)==(g|0)){break a}x[31609]=0;j=P(158,d|0,1)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}a=0;d:{while(1){x[31609]=0;k=P(158,d|0,1)|0;e=x[31609];x[31609]=0;if((e|0)==1){break d}a=w[(d+D(a,6)|0)+(k?1070:1068)>>1];e:{if((a|0)>255){break e}e=d+D(a,6)|0;h=y[e+1072|0];if(w[e+1068>>1]<0){break e}if(w[e+1070>>1]>=0){continue}}break}h=(j?-1:0)^h;i=(i&255)+(h&255)|0;v[b+g|0]=i;g=g+1|0;continue}break}a=T(28816)|0;break b}a=T(28816)|0;break b}a=T(28816)|0}if((gb|0)==($(28816)|0)){Y(a|0)|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0}ub(d);Q(a|0);p()}a=zr(d);ub(d);fb=f+2608|0;return a|0}function mV(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=E(0),l=0,m=0,n=0;if(Lj(x[a+656>>2])){e=y[a+797|0];e=(l=e,m=y[a+799|0],n=Tc(e),n?l:m);f=Ob(d+1074312|0,34);d=x[a+656>>2];a:{if(!f){break a}f=e&255;if(!f|f>>>0>120){break a}e=y[xb(d+108|0,f-1|0)|0]}k=E(E(x[a+704>>2])*b);d=x[d+44>>2];g=((e&255)+c|0)-61<<16>>16;b:{c:{c=x[a+852>>2]+w[a+772>>1]|0;if(c){h=x[d+36>>2];if(h){break c}}b=Wm(d,c+g<<16>>16);break b}j=h+1|0;i=hA(c,j);e=iA(c,j);b=E(1);f=w[d+28>>1];c=g+i<<16>>16;d:{if((f|0)>(c|0)){break d}g=x[d+4>>2];if((c|0)>(oc(g,x[d+8>>2])+f|0)-1<<16>>16){break d}if(!e){b=B[yb(g,c-f|0)>>2];break b}e:{f:{g:{switch(z[d>>1]-1|0){case 2:h=x[d+16>>2];if(!oc(h,x[d+20>>2])){break f}b=B[yb(h,e-1|0)>>2];break e;case 0:break g;default:break f}}i=x[d+16>>2];if(!oc(i,x[d+20>>2])){break f}b=B[yb(i,(e+D(h,mA(c,z[d+30>>1])<<16>>16)|0)-1|0)>>2];break e}b=Ee(E(Wm(d,c+1<<16>>16)/Wm(d,c)),E(E(e|0)/E(j|0)))}b=E(b*B[yb(g,c-f|0)>>2])}}l=a,m=Ck(E(E(k*b)*E(16))),x[l+700>>2]=m}}function jJ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;a=fb-16|0;fb=a;x[a+12>>2]=c;x[a+8>>2]=f;x[a+12>>2]=c;x[a+8>>2]=f;b=x[a+12>>2];a:{while(1){if(b>>>0>=d>>>0){c=0;break a}c=2;b=x[b>>2];if(b>>>0>1114111|(b&-2048)==55296){break a}b:{c:{if(b>>>0<=127){c=1;f=x[a+8>>2];if((g-f|0)<=0){break a}x[a+8>>2]=f+1;v[f|0]=b;break c}if(b>>>0<=2047){c=x[a+8>>2];if((g-c|0)<2){break b}x[a+8>>2]=c+1;v[c|0]=b>>>6|192;c=x[a+8>>2];x[a+8>>2]=c+1;v[c|0]=b&63|128;break c}c=x[a+8>>2];f=g-c|0;if(b>>>0<=65535){if((f|0)<3){break b}x[a+8>>2]=c+1;v[c|0]=b>>>12|224;c=x[a+8>>2];x[a+8>>2]=c+1;v[c|0]=b>>>6&63|128;c=x[a+8>>2];x[a+8>>2]=c+1;v[c|0]=b&63|128;break c}if((f|0)<4){break b}x[a+8>>2]=c+1;v[c|0]=b>>>18|240;c=x[a+8>>2];x[a+8>>2]=c+1;v[c|0]=b>>>12&63|128;c=x[a+8>>2];x[a+8>>2]=c+1;v[c|0]=b>>>6&63|128;c=x[a+8>>2];x[a+8>>2]=c+1;v[c|0]=b&63|128}b=x[a+12>>2]+4|0;x[a+12>>2]=b;continue}break}c=1}x[e>>2]=x[a+12>>2];x[h>>2]=x[a+8>>2];fb=a+16|0;return c|0}function jta(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;nd(b,32);g=b,h=$b(y[a+4|0]|y[a+5|0]<<8|(y[a+6|0]<<16|y[a+7|0]<<24)),x[g>>2]=h;f=$b(y[a+10|0]|y[a+11|0]<<8|(y[a+12|0]<<16|y[a+13|0]<<24));x[b+4>>2]=f;g=b,h=$b(y[a+14|0]|y[a+15|0]<<8|(y[a+16|0]<<16|y[a+17|0]<<24))+f|0,x[g+8>>2]=h;if(!(d?0:c)){c=$b(y[a+46|0]|y[a+47|0]<<8|(y[a+48|0]<<16|y[a+49|0]<<24))}x[b+24>>2]=c;c=y[a+8|0]<<28>>24;a:{if((d|0)!=841887798){break a}d=Bb(y[a+42|0]|y[a+43|0]<<8);if(!d|(d|0)==48){break a}c=(c-(d<<7)|0)+6144|0}$l(b,+(c|0)*.0006510416666666666);v[e+15|0]=y[a+9|0];v[e+14|0]=64;g=b,h=y[Qb(e+15|0,e+14|0)|0]<<2,w[g+30>>1]=h;c=x[b+4>>2];d=x[b+8>>2];if(v[a+40|0]&1){d=d>>>1|0;x[b+8>>2]=d;c=c>>>1|0;x[b+4>>2]=c;w[b+34>>1]=z[b+34>>1]|64;x[b>>2]=x[b>>2]>>>1}if(y[a+41|0]>=9){d=d>>>1|0;x[b+8>>2]=d;c=c>>>1|0;x[b+4>>2]=c;w[b+34>>1]=z[b+34>>1]|1;x[b>>2]=x[b>>2]>>>1}b:{if(c+1>>>0<d>>>0){w[b+34>>1]=z[b+34>>1]|2;break b}x[b+4>>2]=0;x[b+8>>2]=0}fb=e+16|0}function Cy(a,b,c,d,e,f,g,h,i,j,k,l){var m=0,n=0;a:{b:{if((a|0)==(f|0)){if(!y[b|0]){break a}f=0;v[b|0]=0;a=x[e>>2];x[e>>2]=a+1;v[a|0]=46;if(!Cb(x[h+4>>2],y[h+11|0])){break b}a=x[j>>2];if((a-i|0)>159){break b}b=x[k>>2];x[j>>2]=a+4;x[a>>2]=b;return 0}c:{if((a|0)!=(g|0)){break c}if(!Cb(x[h+4>>2],y[h+11|0])){break c}if(!y[b|0]){break a}f=0;a=x[j>>2];if((a-i|0)>159){break b}b=x[k>>2];x[j>>2]=a+4;x[a>>2]=b;x[k>>2]=0;return 0}f=-1;l=Ey(l,l+128|0,a)-l|0;g=l>>2;if((g|0)>31){break b}a=v[g+95168|0];d:{e:{f=l&-5;if((f|0)!=88){if((f|0)!=96){break e}b=x[e>>2];if((b|0)!=(d|0)){f=-1;if((ql(v[b-1|0])|0)!=(ql(v[c|0])|0)){break b}}x[e>>2]=b+1;v[b|0]=a;return 0}v[c|0]=80;break d}d=ql(a);if((d|0)!=v[c|0]){break d}m=c,n=tt(d),v[m|0]=n;if(!y[b|0]){break d}v[b|0]=0;if(!Cb(x[h+4>>2],y[h+11|0])){break d}b=x[j>>2];if((b-i|0)>159){break d}c=x[k>>2];x[j>>2]=b+4;x[b>>2]=c}b=x[e>>2];x[e>>2]=b+1;v[b|0]=a;f=0;if((g|0)>21){break b}x[k>>2]=x[k>>2]+1}return f}return-1}function qz(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=E(0);c=fb+-64|0;fb=c;b=x[a>>2];a=x[b>>2];d=x[a+4>>2];x[c+40>>2]=x[a+20>>2];e=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=e;Xf(c+48|0,c+32|0,d);a=x[b+4>>2];d=x[a+8>>2];e=x[a+4>>2];b=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=b;b=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=b;x[c+8>>2]=x[a+8>>2];b=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=b;a:{b:{c:{d:{f=x[c+4>>2];if(f>>>0>=e>>>0){g=x[c+20>>2];if(g>>>0<e>>>0){break d}if(d>>>0>A[c+8>>2]){break c}h=x[c+28>>2];if(d>>>0>x[c+24>>2]-h>>>0){break b}i=x[c+16>>2];j=x[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}k=(D(b,f)<<3)+j|0;l=(D(b+h|0,g)<<2)+i|0;a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{m=(a<<2)+l|0,n=E(+(wn(Ge(Jg(C[(a<<3)+k>>3])*134217728))|0)*7.450580596923828e-9),B[m>>2]=n;a=a+1|0;continue}}}_(7244,9061,77,8741);p()}_(7209,9061,78,8741);p()}_(5897,9061,79,8741);p()}_(5867,9061,80,8741);p()}fb=c- -64|0}function Cla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=fb-16|0;fb=g;x[g+12>>2]=1;a:{if(Yo(a)){c=x[a>>2];m=Mg(c,x[a+4>>2]);x[g+8>>2]=m;j=x[Hb(g+12|0,g+8|0)>>2];while(1){if(j){j=j-1|0;if((b|0)!=(c|0)){d=wb(x[b>>2]);f=d;e=wb(x[b+4>>2]);k=e;d=rE(d,e);h=fb-16|0;fb=h;b:{if(In(c)>>>0>=d>>>0){l=x[c>>2];i=$c(l,x[c+4>>2]);if(i>>>0<d>>>0){e=fb-16|0;fb=e;x[e+12>>2]=f;SX(e+12|0,i);fb=e+16|0;i=f;f=x[e+12>>2];dV(i,f,l);dv(c,f,k,d-$c(x[c>>2],x[c+4>>2])|0);break b}cV(h+8|0,f,k,l);Jd(c,x[h+12>>2]);break b}bV(c);JC(c,gk(c,d));dv(c,f,k,d)}fb=h+16|0;ps(c+12|0,b+12|0);w[c+28>>1]=z[b+28>>1]}c=c+32|0;continue}break}if(!m){_B(a,1,b);break a}TU(a,x[a>>2]+32|0);break a}if(x[a>>2]){VU(a);c=x[a>>2];Yo(a);Db(c);n=Ab(a),o=0,x[n>>2]=o;x[a>>2]=0;x[a+4>>2]=0}d=Vq(a,1);c=fb-16|0;fb=c;if(uh(134217727)>>>0<d>>>0){ed();p()}RV(c+8|0,d);d=x[c+8>>2];x[a+4>>2]=d;x[a>>2]=d;n=Ab(a),o=d+(x[c+12>>2]<<5)|0,x[n>>2]=o;fb=c+16|0;_B(a,1,b)}fb=g+16|0}function Gy(a,b,c,d,e,f,g,h,i,j,k,l){var m=0,n=0;a:{b:{if((a|0)==(f|0)){if(!y[b|0]){break a}f=0;v[b|0]=0;a=x[e>>2];x[e>>2]=a+1;v[a|0]=46;if(!Cb(x[h+4>>2],y[h+11|0])){break b}a=x[j>>2];if((a-i|0)>159){break b}b=x[k>>2];x[j>>2]=a+4;x[a>>2]=b;return 0}c:{if((a|0)!=(g|0)){break c}if(!Cb(x[h+4>>2],y[h+11|0])){break c}if(!y[b|0]){break a}f=0;a=x[j>>2];if((a-i|0)>159){break b}b=x[k>>2];x[j>>2]=a+4;x[a>>2]=b;x[k>>2]=0;return 0}f=-1;a=Hi(l,l+32|0,a)-l|0;if((a|0)>31){break b}g=v[a+95168|0];d:{e:{switch((a&-2)-22|0){case 2:a=x[e>>2];if((a|0)!=(d|0)){if((ql(v[a-1|0])|0)!=(ql(v[c|0])|0)){break b}}x[e>>2]=a+1;v[a|0]=g;return 0;case 0:v[c|0]=80;break d;default:break e}}d=ql(g);if((d|0)!=v[c|0]){break d}m=c,n=tt(d),v[m|0]=n;if(!y[b|0]){break d}v[b|0]=0;if(!Cb(x[h+4>>2],y[h+11|0])){break d}b=x[j>>2];if((b-i|0)>159){break d}c=x[k>>2];x[j>>2]=b+4;x[b>>2]=c}b=x[e>>2];x[e>>2]=b+1;v[b|0]=g;f=0;if((a|0)>21){break b}x[k>>2]=x[k>>2]+1}return f}return-1}function Faa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=fb+-64|0;fb=c;b=x[a>>2];a=x[b>>2];d=x[a+4>>2];x[c+40>>2]=x[a+20>>2];e=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=e;Xf(c+48|0,c+32|0,d);a=x[b+4>>2];d=x[a+8>>2];e=x[a+4>>2];b=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=b;b=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=b;x[c+8>>2]=x[a+8>>2];b=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=b;a:{b:{c:{d:{g=x[c+4>>2];if(g>>>0>=e>>>0){h=x[c+20>>2];if(h>>>0<e>>>0){break d}if(d>>>0>A[c+8>>2]){break c}i=x[c+28>>2];if(d>>>0>x[c+24>>2]-i>>>0){break b}j=x[c+16>>2];k=x[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}l=(D(b,g)<<2)+k|0;m=(D(b+i|0,h)<<1)+j|0;a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{f=rd(x[(a<<2)+l>>2]+2048|0,12);f=(f|0)>=32767?32767:f;w[(a<<1)+m>>1]=(f|0)<=-32768?-32768:f;a=a+1|0;continue}}}_(7244,9061,33,8774);p()}_(7209,9061,34,8774);p()}_(5897,9061,35,8774);p()}_(5867,9061,36,8774);p()}fb=c- -64|0}function y0(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=fb-16|0;fb=d;a:{if((y[a|0]-16&255)>>>0<241){break a}c=1698;while(1){if((c|0)==1954){c=0;while(1){if((c|0)==32){g=f;break a}g=0;e=D(c,13)+a|0;if(y[nc(e+2|0)|0]){break a}b=(c<<4)+a|0;if(y[b+418|0]|y[b+419|0]<<8|(y[b+420|0]<<16|y[b+421|0]<<24)){break a}h=y[b+422|0]|y[b+423|0]<<8|(y[b+424|0]<<16|y[b+425|0]<<24);if(h>>>0>1048575){break a}if(y[nc(e+930|0)|0]){break a}e=(D(c,11)+a|0)+1346|0;if(y[xb(e,0)|0]>15){break a}if(y[xb(e,5)|0]>3){break a}if(y[xb(e,10)|0]>3){break a}b:{c:{d:{if(h){i=y[b+430|0]|y[b+431|0]<<8|(y[b+432|0]<<16|y[b+433|0]<<24);if(i>>>0<=1048574){if(h>>>0<i>>>0|(y[b+426|0]|y[b+427|0]<<8|(y[b+428|0]<<16|y[b+429|0]<<24))>>>0>i>>>0){break a}}if(f|h){break c}break d}if(f){break c}}v[d+7|0]=0;v[d+8|0]=0;v[d+9|0]=0;v[d+10|0]=0;x[d>>2]=0;x[d+4>>2]=0;f=0;if(x0(e,e+11|0,d)){break b}}f=1}c=c+1|0;continue}}g=a+c|0;c=c+1|0;if(v[g|0]>-2){continue}break}g=0}fb=d+16|0;return g&1}function sz(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=E(0);c=fb+-64|0;fb=c;b=x[a>>2];a=x[b>>2];d=x[a+4>>2];x[c+40>>2]=x[a+20>>2];e=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=e;Xf(c+48|0,c+32|0,d);a=x[b+4>>2];d=x[a+8>>2];e=x[a+4>>2];b=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=b;b=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=b;x[c+8>>2]=x[a+8>>2];b=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=b;a:{b:{c:{d:{f=x[c+4>>2];if(f>>>0>=e>>>0){if(A[c+20>>2]<e>>>0){break d}if(d>>>0>A[c+8>>2]){break c}g=x[c+28>>2];if(d>>>0>x[c+24>>2]-g>>>0){break b}h=x[c+16>>2];i=x[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}j=(D(b,f)<<3)+i|0;a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{k=Ge(Jg(C[(a<<3)+j>>3])*134217728);l=(x[(a<<2)+h>>2]+(g<<2)|0)+(b<<2)|0,m=E(+(wn(k)|0)*7.450580596923828e-9),B[l>>2]=m;a=a+1|0;continue}}}_(7244,9061,77,8741);p()}_(7209,9061,78,8741);p()}_(5897,9061,79,8741);p()}_(5867,9061,80,8741);p()}fb=c- -64|0}function sr(a){var b=0,c=0,d=0,e=0,f=0;e=fb-16|0;fb=e;a:{b:{c:{d:{e:{f:{g:{h:{b=x[a+480180>>2];switch(b-1|0){case 7:break e;case 0:case 1:case 3:break f;case 2:case 4:case 5:case 6:break g;default:break h}}if((b|0)==16){break b}if((b|0)==32){break f}if((b|0)==64|(b|0)==256|((b|0)==512|(b|0)==2048)|(b|0)==8192){break b}if((b|0)==65536){break d}d=1;if((b|0)==2097152){break a}if((b|0)==4194304){break c}if((b|0)==536870912|(b|0)==67108864|(b|0)==134217728){break a}d=b;if((b|0)==16777216){break a}}d=32;break a}d=b;break a}d=4;if(z[a+480192>>1]){break a}c=wb(x[a+484344>>2]);x[e+12>>2]=c;a=wb(x[a+484348>>2]);while(1){if(!Ib(c,a)){d=1;break a}if(!(!Ib(x[c>>2],x[c+4>>2])|x[c+12>>2]==64)){break a}c=x[Vl(e+12|0)>>2];continue}}d=16777216;break a}d=32;f=z[a+480188>>1];if(f>>>0>16){break a}while(1){if((c|0)==(f|0)){break b}b=(c<<5)+a|0;if(v[b+480281|0]&1){break a}c=c+1|0;if(z[b+480286>>1]==64){continue}break}break a}d=2}fb=e+16|0;return d}function cba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=fb-16|0;fb=g;h=g+4|0;f=fb-160|0;fb=f;d=f+24|0;c=d+56|0;e=Tt(c);x[d>>2]=93900;x[e>>2]=93920;x[d+56>>2]=93960;x[d>>2]=93940;i=c;c=d+4|0;oo(i,c);x[d>>2]=93900;x[e>>2]=93920;c=Pt(c);x[c>>2]=93384;Fb(c+32|0);x[c+44>>2]=0;x[c+48>>2]=16;j=x[x[d>>2]-12>>2];x[31609]=0;i=ca(104)|0;c=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{if((c|0)==1){break f}x[31609]=0;e=f+20|0;S(105,e|0,d+j|0,i|0);c=x[31609];x[31609]=0;if((c|0)==1){break f}_b(e);c=fb-16|0;fb=c;x[c+12>>2]=17;fb=c+16|0;xn(d+x[x[d>>2]-12>>2]|0,x[c+12>>2]);k=C[b>>3];x[31609]=0;e=Sa(1130,d|0,+k)|0;b=x[31609];x[31609]=0;if((b|0)==1){break e}x[31609]=0;c=f+8|0;O(1131,c|0,e|0);b=x[31609];x[31609]=0;if((b|0)==1){break d}x[31609]=0;O(303,h|0,c|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}tb(c);fq(e);fb=f+160|0;break a}a=N()|0;break b}a=N()|0;break b}a=N()|0;break b}a=N()|0;tb(f+8|0)}fq(d);Q(a|0);p()}Rh(a,h);tb(h);fb=g+16|0}function Rla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=fb-16|0;fb=e;p=x[a+16>>2];q=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);j=x[a+8>>2];k=x[a+12>>2];b=x[a>>2];g=x[a+4>>2];l=x[a+128>>2];if(l){m=Hg(j,k,l);n=hb;f=x[a+76>>2];fg(b,g,vf(j,k,d),hb);o=hb>>>0>f>>>0?d:0}f=a+112|0;h=x[a+40>>2];i=x[a+36>>2];x[e>>2]=b;x[e+4>>2]=g;a:while(1){if(d){d=d-1|0;x[e+8>>2]=b;x[e+12>>2]=0;o=o-1|0;b=o;m=b?m:0;n=b?n:0;g=g+p|0;b=l;while(1)if((b|0)<=0){Pb(f,x[a+120>>2],x[a+124>>2]);b=x[a+116>>2];if(b){ce(f,v[g+x[e+12>>2]|0]<<6);be(f,b);x[f>>2]=x[f>>2];x[f+4>>2]=0}g=x[a+32>>2];r=x[c>>2];b=Fg(f,q);i=x[a+28>>2]+i|0;x[c>>2]=D(b,i>>12)+r;h=g+h|0;x[c+4>>2]=x[c+4>>2]+D(b,h>>12);Pb(e,j,k);c=c+8|0;b=x[e>>2];g=x[e+4>>2];continue a}else{ce(f,v[g+x[e+12>>2]|0]<<6);be(f,4);Pb(e+8|0,m,n);b=b-1|0;continue}}break}x[a>>2]=b;x[a+4>>2]=g;x[a+40>>2]=h;x[a+20>>2]=i>>12;x[a+36>>2]=i;x[a+24>>2]=h>>12;fb=e+16|0}function Hia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=x[a>>2];c=hk(d,x[a+4>>2]);if(c>>>0<b>>>0){h=fb-32|0;fb=h;f=b-c|0;d=x[Ab(a)>>2];b=x[a+4>>2];a:{if(f>>>0<=d-b>>11>>>0){c=fb-16|0;fb=c;b=c+4|0;x[b>>2]=a;a=x[a+4>>2];x[b+4>>2]=a;x[b+8>>2]=a+(f<<11);a=x[b+4>>2];d=x[b+8>>2];while(1){if((a|0)==(d|0)){kc(b);fb=c+16|0}else{uu(a);a=a+2048|0;x[b+4>>2]=a;continue}break}break a}g=Ab(a);i=h+12|0;e=hk(x[a>>2],b)+f|0;c=fb-16|0;fb=c;x[c+12>>2]=e;d=fb-16|0;fb=d;x[d+12>>2]=2097151;x[d+8>>2]=2147483647;b=x[Hb(d+12|0,d+8|0)>>2];fb=d+16|0;b:{if(b>>>0>=e>>>0){d=dA(a);if(d>>>0<b>>>1>>>0){x[c+8>>2]=d<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;break b}ed();p()}d=NQ(i,b,hk(x[a>>2],x[a+4>>2]),g);c=d;e=fb-16|0;fb=e;g=x[c+8>>2];b=e+4|0;x[b+8>>2]=c+8;x[b>>2]=g;x[b+4>>2]=g+(f<<11);c=x[b>>2];while(1){if(x[b+4>>2]!=(c|0)){uu(c);c=x[b>>2]+2048|0;x[b>>2]=c;continue}break}je(b);fb=e+16|0;MQ(a,d);LQ(d)}fb=h+32|0;return}if(b>>>0<c>>>0){Jd(a,d+(b<<11)|0)}}function F2(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;c=fb-48|0;fb=c;f=Fb(a);x[31609]=0;a=ca(117)|0;b=x[31609];x[31609]=0;a:{b:{if((b|0)==1){break b}c:{d:{if(!a){break d}x[31609]=0;b=P(1,c+24|0,8979)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}x[31609]=0;a=ca(117)|0;d=x[31609];x[31609]=0;e:{f:{g:{h:{if((d|0)==1){break h}x[31609]=0;x[c+8>>2]=a;a=c+12|0;O(126,a|0,c+8|0);d=x[31609];x[31609]=0;if((d|0)==1){break h}x[31609]=0;d=c+36|0;S(2,d|0,b|0,a|0);e=x[31609];x[31609]=0;if((e|0)==1){break g}e=zb(f,d);tb(d);tb(a);tb(b);x[31609]=0;a=ca(119)|0;b=x[31609];x[31609]=0;if((b|0)==1){break b}if(!a){break e}x[31609]=0;P(127,e|0,17550)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break e}break b}a=N()|0;break f}a=N()|0;tb(c+12|0)}tb(b);break a}x[31609]=0;a=ca(118)|0;b=x[31609];x[31609]=0;if((b|0)==1){break b}if(!a){break d}x[31609]=0;P(127,e|0,16836)|0;a=x[31609];x[31609]=0;if((a|0)==1){break b}}fb=c+48|0;return}a=N()|0;break a}a=N()|0}tb(f);Q(a|0);p()}function Cc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;a:{c=x[b>>2];f=fb-48|0;fb=f;e=x[b+4>>2];b=y[b+8|0];d=e-(((b|0)==1|(b|0)==4)&(e|0)!=0)|0;e=Fb(a);b:{c:{d:{e:{f:{g:{h:{if((b-1&255)>>>0<=1){a=Hi(c,c+d|0,0);x[31609]=0;U(70,e|0,c|0,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break h}a=N()|0;break b}if((b-3&255)>>>0>1){break h}x[31609]=0;b=U(70,e|0,c|0,c+d|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break g}c=zd(b);d=Ef(b);g=zd(b);a=fb-16|0;fb=a;x[a+8>>2]=g;x[a+12>>2]=c;while(1){if(Ib(c,d)){c=v[c|0];v[x[a+8>>2]]=c?c:32;c=we(a+12|0);we(a+8|0);c=x[c>>2];continue}break}fb=a+16|0;x[31609]=0;c=P(71,f+24|0,b|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break f}x[31609]=0;d=P(36,f+12|0,18454)|0;a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;a=f+36|0;S(72,a|0,c|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break d}zb(b,a);tb(a);tb(d);tb(c)}fb=f+48|0;break a}a=N()|0;break b}a=N()|0;break b}a=N()|0;break c}a=N()|0;tb(d)}tb(c)}tb(e);Q(a|0);p()}}function wA(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=fb-16|0;fb=e;d=y[a+2|0];if(!(!d|(d|0)==255)){x[e+12>>2]=d+1;x[e+8>>2]=10;fh(b,x[Cd(e+12|0,e+8|0)>>2]);i=y[a+3|0];v[b+15|0]=i;v[b+16|0]=i;j=y[a+4|0];v[b+13|0]=j;l=y[a+5|0];v[b+14|0]=l;g=511;d=0;a:{b:{switch(c-1|0){case 1:d=4096;g=128;break a;case 0:break b;default:break a}}d=32768;g=1024}o=g>>>1|d;c=x[b>>2];k=Sd(c,x[b+4>>2]);d=0;while(1){if((d|0)==(k|0)){c=y[b+12|0]&-2|v[a|0]&1;v[b+12|0]=c;c=c&-5|(y[a|0]|y[a+1|0]<<8)<<1&(k>>>0>=i>>>0)<<2;v[b+12|0]=c;v[b+12|0]=c&253|(y[a|0]|y[a+1|0]<<8)>>>1&(j>>>0<=l>>>0?(k>>>0>=j>>>0)<<1:0)}else{m=yb(c,d);h=(d<<2)+a|0;f=(y[h+6|0]|y[h+7|0]<<8)>>>4|0;w[m>>1]=f;c:{if(d){n=z[yb(c,d-1|0)>>1];if(f>>>0>=n>>>0){break c}f=n+1|0}else{f=0}p=yb(c,d),q=f,w[p>>1]=q}x[e+12>>2]=(((y[h+8|0]|y[h+9|0]<<8)<<16>>16)+o|0)/(g|0);x[e+8>>2]=0;x[e+4>>2]=64;p=m,q=x[_j(e+12|0,e+8|0,e+4|0)>>2],v[p+2|0]=q;d=d+1|0;continue}break}}fb=e+16|0}function Oaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=fb+-64|0;fb=c;b=x[a>>2];a=x[b>>2];e=x[a+4>>2];x[c+40>>2]=x[a+20>>2];f=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=f;Xf(c+48|0,c+32|0,e);a=x[b+4>>2];e=x[a+8>>2];f=x[a+4>>2];b=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=b;b=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=b;x[c+8>>2]=x[a+8>>2];b=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=b;a:{b:{c:{d:{g=x[c+4>>2];if(g>>>0>=f>>>0){if(A[c+20>>2]<f>>>0){break d}if(e>>>0>A[c+8>>2]){break c}h=x[c+28>>2];if(e>>>0>x[c+24>>2]-h>>>0){break b}i=x[c+16>>2];j=x[c>>2];b=0;e:while(1){if((b|0)==(e|0)){break a}k=(D(b,g)<<2)+j|0;a=0;while(1)if((a|0)==(f|0)){b=b+1|0;continue e}else{d=a<<2;l=(x[d+i>>2]+(h<<1)|0)+(b<<1)|0;d=rd(x[d+k>>2]+2048|0,12);d=(d|0)>=32767?32767:d;w[l>>1]=(d|0)<=-32768?-32768:d;a=a+1|0;continue}}}_(7244,9061,33,8774);p()}_(7209,9061,34,8774);p()}_(5897,9061,35,8774);p()}_(5867,9061,36,8774);p()}fb=c- -64|0}function Cf(a,b,c){v[a+5|0]=c;a:{switch(b|0){case 0:v[a+3|0]=(c|0)!=0;return;case 1:v[a+3|0]=2;return;case 2:v[a+3|0]=3;return;case 3:v[a+3|0]=4;return;case 4:v[a+3|0]=5;return;case 5:v[a+3|0]=6;return;case 6:v[a+3|0]=7;return;case 7:v[a+3|0]=8;return;case 8:v[a+3|0]=9;return;case 9:v[a+3|0]=10;return;case 10:v[a+3|0]=11;return;case 11:v[a+3|0]=12;return;case 12:v[a+3|0]=13;return;case 13:v[a+3|0]=14;v[a+5|0]=D(c>>>4|0,10)+(c&15);return;case 14:v[a+3|0]=19;return;case 15:if(c>>>0<=31){v[a+3|0]=16;return}v[a+3|0]=17;return;case 16:v[a+3|0]=23;return;case 17:v[a+3|0]=24;return;case 20:v[a+3|0]=25;return;case 21:v[a+3|0]=30;return;case 25:v[a+3|0]=29;return;case 27:v[a+3|0]=15;return;case 29:v[a+3|0]=18;return;case 32:v[a+3|0]=37;return;case 33:v[a+3|0]=28;return;case 34:v[a+3|0]=27;return;case 35:v[a+3|0]=31;return;case 36:v[a+3|0]=32;return;case 37:v[a+3|0]=32;return;case 38:v[a+3|0]=34;return;default:break a}}v[a+3|0]=0}function Zma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0;h=fb-16|0;fb=h;f=x[a+48>>2];m=x[a+24>>2];n=x[a+20>>2];e=x[a+44>>2];o=x[a+16>>2];b=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=b;p=x[a+72>>2];j=x[a+68>>2];q=j>>31;k=x[a+64>>2];r=k>>31;l=x[a+60>>2];s=l>>31;t=x[a+8>>2];u=x[a+12>>2];while(1){b=e;if(d){e=Yb(e,-16777216,16776704);e=Iua(k,r,e,e>>31);i=hb;g=e;f=Yb(f,-16777216,16776704);e=Iua(j,q,f,f>>31);g=g+e|0;f=hb+i|0;f=e>>>0>g>>>0?f+1|0:f;w=g;e=x[h+8>>2];i=e>>>10&4194048;e=x[h+12>>2]+o|0;g=v[e|0];i=((D(v[e+1|0]-g|0,i)|0)/16384<<8)+(g<<16)|0;e=i;e=Iua(e,e>>31,l,s);g=e+w|0;f=hb+f|0;f=e>>>0>g>>>0?f+1|0:f;e=g+8388608|0;f=e>>>0<8388608?f+1|0:f;e=Sc(e,f,24);f=(e|0)/256|0;x[c>>2]=D(f,n)+x[c>>2];x[c+4>>2]=x[c+4>>2]+D(f,m);Pb(h+8|0,t,u);e=e-(i&p)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=c;x[a+48>>2]=f;x[a+44>>2]=b;fb=h+16|0}function Hsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;nd(b,32);fp(b);f=b,g=Bb(y[a+40|0]|y[a+41|0]<<8)>>>2|0,w[f+32>>1]=g;d=z[b+34>>1];if((ze((y[a+38|0]|y[a+39|0]<<8)<<16>>16)|0)>0){d=d|32;w[b+34>>1]=d;c=ze((y[a+38|0]|y[a+39|0]<<8)<<16>>16);e=(c<<8&-256)+2047|0;c=c>>>24|0;f=b,g=Bc(Kua(e,e>>>0<2047?c+1|0:c,4095,0),hb),w[f+28>>1]=g}f=b,g=$b(y[a+58|0]|y[a+59|0]<<8|(y[a+60|0]<<16|y[a+61|0]<<24)),x[f>>2]=g;f=b,g=$b(y[a+62|0]|y[a+63|0]<<8|(y[a+64|0]<<16|y[a+65|0]<<24)),x[f+4>>2]=g;f=b,g=$b(y[a+62|0]|y[a+63|0]<<8|(y[a+64|0]<<16|y[a+65|0]<<24))+$b(y[a+66|0]|y[a+67|0]<<8|(y[a+68|0]<<16|y[a+69|0]<<24))|0,x[f+8>>2]=g;c=d&-3|((Bb(y[a+44|0]|y[a+45|0]<<8)|0)!=0)<<1;w[b+34>>1]=c;f=b,g=c&65531|Bb(y[a+44|0]|y[a+45|0]<<8)<<1&4,w[f+34>>1]=g;f=b,g=$b(y[a+54|0]|y[a+55|0]<<8|(y[a+56|0]<<16|y[a+57|0]<<24))<<1,x[f+24>>2]=g;c=ze((y[a+42|0]|y[a+43|0]<<8)<<16>>16);if(c){$l(b,+(c|0)/96);c=ze((y[a+42|0]|y[a+43|0]<<8)<<16>>16)}v[b+37|0]=c<<4}function hB(a,b,c){var d=0,e=0,f=0;d=fb-112|0;fb=d;f=x[a>>2];e=x[f-4>>2];f=x[f-8>>2];x[d+76>>2]=0;x[d+80>>2]=0;x[d+84>>2]=0;x[d+88>>2]=0;x[d+92>>2]=0;x[d+96>>2]=0;x[d+100>>2]=0;x[d+104>>2]=0;v[d+107|0]=0;v[d+108|0]=0;v[d+109|0]=0;v[d+110|0]=0;x[d+68>>2]=0;x[d+72>>2]=0;x[d+64>>2]=b;x[d+60>>2]=a;x[d+56>>2]=c;a:{if(lh(e,c,0)){a=f?0:a;break a}b=a+f|0;if((b|0)<=(a|0)){x[d+44>>2]=0;x[d+48>>2]=0;v[d+51|0]=0;v[d+52|0]=0;v[d+53|0]=0;v[d+54|0]=0;x[d+20>>2]=0;x[d+24>>2]=0;x[d+28>>2]=0;x[d+32>>2]=0;x[d+36>>2]=0;x[d+40>>2]=0;x[d+12>>2]=0;x[d+16>>2]=0;x[d+8>>2]=c;x[d+4>>2]=a;x[d>>2]=e;x[d+48>>2]=1;ib[x[x[e>>2]+20>>2]](e,d,b,b,1,0);if(x[d+24>>2]){break a}}a=0;ib[x[x[e>>2]+24>>2]](e,d+56|0,b,1,0);b:{switch(x[d+92>>2]){case 0:a=x[d+96>>2]==1?x[d+84>>2]==1?x[d+88>>2]==1?x[d+76>>2]:0:0:0;break a;case 1:break b;default:break a}}if(x[d+80>>2]!=1){if(x[d+96>>2]|x[d+84>>2]!=1|x[d+88>>2]!=1){break a}}a=x[d+72>>2]}fb=d+112|0;return a}function wq(a){a=a|0;var b=0,c=0,d=0,e=0,f=E(0),g=E(0),h=0,i=0,j=0,k=0,l=0,m=E(0),n=0,o=E(0);b=x[a+36>>2];if(!b){Nc(a+16|0);return}a:{b:{switch(z[a>>1]){case 3:c=a+16|0;if(b>>>0>=1001){Nc(c);return}Dl(c,b);b=x[a+36>>2]+1|0;c=b>>>0<=1?1:b;e=w[a+28>>1];g=Ee(E(Wm(a,e+1<<16>>16)/Wm(a,e)),E(E(1)/E(b>>>0)));a=x[a+16>>2];b=1;while(1){if((b|0)==(c|0)){break a}f=Ee(g,E(b>>>0));n=yb(a,b-1|0),o=f,B[n>>2]=o;b=b+1|0;continue};case 1:c=a+16|0;e=z[a+30>>1];if(e>>>0>1e3/(b>>>0)>>>0){Nc(c);return}Dl(c,D(b,e));h=z[a+30>>1];j=mA(w[a+28>>1],h);i=x[a+36>>2];g=E(E(1)/E(i+1>>>0));c=0;c:while(1){if(e>>>0<=(c&65535)>>>0){break a}b=1;d=mA(c+j<<16>>16,h);f=Wm(a,d+1<<16>>16);d=d<<16>>16;f=Ee(E(f/Wm(a,d)),g);k=D(d,x[a+36>>2]);l=x[a+16>>2];while(1){d=b&65535;if(d>>>0>i>>>0){c=c+1|0;continue c}else{m=Ee(f,E(d>>>0));n=yb(l,(d+k|0)-1|0),o=m,B[n>>2]=o;b=b+1|0;continue}}};case 0:Nc(a+16|0);return;default:break b}}Nc(a+16|0);x[a+36>>2]=0}}function Dt(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;a:{b:{e=qj(a)&2047;d=qj(5551115123125783e-32);if(e-d>>>0<qj(512)-d>>>0){h=e;break b}if(d>>>0>e>>>0){return a+1}if(qj(1024)>>>0>e>>>0){break b}o(+a);d=j(1)|0;b=0;if(!(j(0)|0)&(d|0)==-1048576){break a}if(qj(Infinity)>>>0<=e>>>0){return a+1}if((d|0)<0){return Ms(12882297539194267e-247)}return Ms(3105036184601418e216)}b=C[170];f=C[169]*a+b;b=f-b;a=b*C[172]+(b*C[171]+a);b=a*a;g=b*b*(a*C[176]+C[175]);b=b*(a*C[174]+C[173]);o(+f);j(1)|0;e=j(0)|0;c=e<<4&2032;a=g+(b+(C[c+1464>>3]+a));c=c+1472|0;d=0+x[c>>2]|0;c=x[c+4>>2]+(e<<13)|0;c=d>>>0<i>>>0?c+1|0:c;if(!h){c:{if(!(e&-2147483648)){l(0,d|0);l(1,c-1058013184|0);b=+n();a=(b*a+b)*5486124068793689e288;break c}l(0,d|0);l(1,c+1071644672|0);b=+n();f=b*a;a=f+b;if(a<1){JJ(nK()*22250738585072014e-324);g=a+1;a=g+(f+(b-a)+(a+(1-g)))+-1;a=a==0?0:a}a=a*22250738585072014e-324}return a}l(0,d|0);l(1,c|0);b=+n();b=b*a+b}return b}function Q2(){var a=0,b=0,c=0,d=0;d=fb-32|0;fb=d;a:{a=Dc(d+20|0,15059);if(!_c(x[a+4>>2],y[a+11|0])){break a}b:{if((Tg(a,14690)|0)!=-1){b=Tg(a,14690);x[31609]=0;c=d+8|0;V(121,c|0,a|0,b+1|0,-1);b=x[31609];x[31609]=0;if((b|0)==1){break b}zb(a,c);tb(c)}if((Tg(a,16834)|0)!=-1){b=Tg(a,16834);x[31609]=0;c=d+8|0;V(121,c|0,a|0,b+1|0,-1);b=x[31609];x[31609]=0;if((b|0)==1){break b}zb(a,c);tb(c)}if((Tg(a,13959)|0)!=-1){b=Tg(a,13959);x[31609]=0;c=d+8|0;V(121,c|0,a|0,0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break b}zb(a,c);tb(c)}if((Tg(a,13834)|0)!=-1){b=Tg(a,13834);x[31609]=0;c=d+8|0;V(121,c|0,a|0,0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break b}zb(a,c);tb(c)}if((Tg(a,13877)|0)!=-1){b=Tg(a,13877);x[31609]=0;c=d+8|0;V(121,c|0,a|0,0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break b}zb(a,c);tb(c)}x[31609]=0;c=R(122,a|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break a}}d=N()|0;tb(a);Q(d|0);p()}tb(a);fb=d+32|0;return c|0}function Vfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=fb-80|0;fb=e;x[e+76>>2]=c;c=e+76|0;a=re(a,c);g=tc(a+4|0);h=tc(a+24|0);i=tc(a+32|0);j=Nb(a+36|0);x[a+56>>2]=3;k=Nb(a+68|0);x[31609]=0;O(991,a|0,d|0);f=x[31609];x[31609]=0;a:{b:{c:{d:{if((f|0)!=1){f=x[b>>2];l=x[b+4>>2];m=x[b+12>>2];x[e+48>>2]=x[b+8>>2];x[e+52>>2]=m;x[e+40>>2]=f;x[e+44>>2]=l;b=Md(e+32|0);f=x[e+52>>2];x[e+24>>2]=x[e+48>>2];x[e+28>>2]=f;x[31609]=0;f=x[e+44>>2];x[e+16>>2]=x[e+40>>2];x[e+20>>2]=f;f=x[b+4>>2];x[e+8>>2]=x[b>>2];x[e+12>>2]=f;b=e+56|0;S(980,b|0,e+16|0,e+8|0);f=x[31609];x[31609]=0;if((f|0)==1){break d}x[31609]=0;S(992,a|0,b|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break c}ub(b);x[31609]=0;W(993,a|0);b=x[31609];x[31609]=0;if((b|0)==1){break b}Wc(c);fb=e+80|0;return a|0}d=N()|0;break a}d=N()|0;break a}d=N()|0;ub(e+56|0);break a}d=N()|0}Td(k);nf(j);Bl(i);wh(h);vh(g);Wc(a);Wc(e+76|0);Q(d|0);p()}function UL(a){var b=0,c=0,d=0,e=0,f=0,g=0;b=x[a+32>>2];a:{b:{c:{d=x[a+1380>>2];if((d|0)==-1){c=1;break c}f=x[a+1116>>2];e=(d|0)>(f|0)?d:f;c=d;while(1){d:{if((c|0)!=(e|0)){g=y[(a+c|0)+1120|0];b=g+b|0;if((g|0)==255){break d}e=c}if(A[a+40>>2]<b>>>0){fc(a,1);break b}c=(e|0)==-1|(e|0)==(f|0);break c}c=c+1|0;continue}}d=(d|0)!=-1;while(1){e=1;if(!(c&1)){break a}e=x[a+40>>2];if(e>>>0<=b+26>>>0){fc(a,1);break b}if((y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24))!=(y[125468]|y[125469]<<8|(y[125470]<<16|y[125471]<<24))){fc(a,21);break b}if(y[b+4|0]){fc(a,21);break b}e:{if(!d){if(!x[a+992>>2]|!(v[b+5|0]&1)){break e}fc(a,21);break b}if(v[b+5|0]&1){break e}fc(a,21);break b}c=0;f=b+27|0;d=y[b+26|0];b=f+d|0;if(e>>>0<b>>>0){fc(a,1);break b}while(1){f:{if((c|0)==(d|0)){c=d;break f}g=y[c+f|0];b=g+b|0;if((g|0)!=255){break f}c=c+1|0;continue}break}c=(c|0)==(d|0);d=1;if(b>>>0<=e>>>0){continue}break}fc(a,1)}e=0}return e}function Yma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=fb-16|0;fb=h;e=x[a+48>>2];n=x[a+24>>2];o=x[a+20>>2];f=x[a+44>>2];p=x[a+16>>2];b=x[a+4>>2];x[h+8>>2]=x[a>>2];x[h+12>>2]=b;q=x[a+72>>2];k=x[a+68>>2];r=k>>31;l=x[a+64>>2];s=l>>31;m=x[a+60>>2];t=m>>31;u=x[a+8>>2];v=x[a+12>>2];while(1){b=f;if(d){f=Yb(f,-16777216,16776704);g=Iua(l,s,f,f>>31);f=hb;e=Yb(e,-16777216,16776704);e=Iua(k,r,e,e>>31);g=e+g|0;f=hb+f|0;f=e>>>0>g>>>0?f+1|0:f;j=g;g=(x[h+12>>2]<<1)+p|0;i=w[g>>1];i=i+((D(w[g+2>>1]-i|0,x[h+8>>2]>>>18|0)|0)/16384|0)<<8;e=i;g=Iua(e,e>>31,m,t);j=g+j|0;e=hb+f|0;e=g>>>0>j>>>0?e+1|0:e;f=j+8388608|0;e=f>>>0<8388608?e+1|0:e;f=Sc(f,e,24);e=(f|0)/256|0;x[c>>2]=D(e,o)+x[c>>2];x[c+4>>2]=x[c+4>>2]+D(e,n);Pb(h+8|0,u,v);f=f-(i&q)|0;c=c+8|0;d=d-1|0;e=b;continue}break}c=x[h+12>>2];x[a>>2]=x[h+8>>2];x[a+4>>2]=c;x[a+48>>2]=e;x[a+44>>2]=b;fb=h+16|0}function wqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=fb-16|0;fb=f;w[f+12>>1]=0;x[f+8>>2]=0;j=8;n=D(c,d)<<1;a:while(1){if((d|0)!=(l|0)){i=(l<<1)+b|0;o=n+i|0;while(1){b:{c:{if(i>>>0<o>>>0){w[f+6>>1]=0;nY(a,f+15|0,f+12|0,j,f+6|0);g=z[f+6>>1];e=z[f+12>>1];c=j;while(1){if(c&255){h=e<<1;e=h&254;d:{if(e){h=(h&65534)>>>0>255;break d}if(!Bf(a,f+5|0)){break c}e=y[f+5|0];h=e>>>7|0;e=e<<1&254|1}c=c-1|0;g=g<<1|h;continue}break}w[f+12>>1]=e;break b}l=l+1|0;continue a}w[f+12>>1]=0}c=1;h=g&65535;e:{if(h>>>0<4){break e}e=15;while(1){c=e;m=e&255;if(m>>>0<2){break e}e=e-1|0;if(!(h&1<<m)){continue}break}}e=g&1;v[f+15|0]=e;g=e-1^(g&65534)>>>1;e=g+z[f+8>>1]|0;w[f+6>>1]=e;w[i>>1]=e;x[f+8>>2]=((g>>1)-(k<<16>>16)|0)+(e<<16>>16<<1);i=(d<<1)+i|0;j=(c+j&254)>>>1|0;c=-32768;k=x[f+8>>2];f:{if((k|0)>=-32768){c=32767;if((k|0)<32768){break f}}x[f+8>>2]=c}k=e;continue}}break}fb=f+16|0}function O1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=fb-32|0;fb=h;e=Mn(h+12|0,a);i=fb-48|0;fb=i;j=-1;c=i+12|0;a:{if(!_F(e,c)){break a}j=0;if(!dG(c)){break a}k=Df(13181);if(k){o=x[e+12>>2];b:{if(!Xl(e,y[c+16|0]|y[c+17|0]<<8|(y[c+18|0]<<16|y[c+19|0]<<24))){break b}while(1){if((y[c+12|0]|y[c+13|0]<<8|(y[c+14|0]<<16|y[c+15|0]<<24))>>>0<=l>>>0){break b}if(!jh(e,5)){break b}c:{if((y[c+4|0]|y[c+5|0]<<8)>>>0>=64){a=Jr(e);d=a&63;g=a<<24>>24;d:{if(!(a&64)){break d}a=6;while(1){f=Jr(e);d=(f&127)<<a|d;if(f<<24>>24>=0){break d}f=a>>>0<25;a=a+7|0;if(f){continue}break}}if((((g|0)<0?(d|0)<0?-2147483648:0-d|0:d)|0)<=0){break c}}d=0;a=1;while(1){f=Jr(e);if(f){m=d>>>0>=k>>>0;g=m&a;if(!((a^1)&1|m)){g=(Kq(f<<24>>24)&255)==y[d+13181|0]}a=g;d=d+1|0;continue}break}id(e,4);n=(d|0)==(k|0)&a|n}l=l+1|0;continue}}Xl(e,o)}if(!(n&1)){break a}j=xe(e,b,cG(c),0)}fb=i+48|0;fb=h+32|0;return j|0}function Bia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=E(0),j=0,k=0,l=0,m=0,n=E(0),o=E(0),p=E(0),q=E(0),r=0,s=0,t=0,u=E(0),v=E(0),w=E(0),y=E(0),z=0,A=0,C=0,D=E(0);r=x[a+4220>>2];if(r){f=x[a+44>>2];k=Hc(f,0);l=Hc(f,1);g=x[a+56>>2];s=Hc(g,0);j=x[a+4208>>2];z=x[a+4228>>2];f=d;t=Hc(g,1);m=t;g=s;while(1){if(f){h=x[a+4224>>2];e=h-z|0;e=(x[a+4220>>2]&e>>31)+e<<1;A=yb(j,e);n=B[yb(j,e|1)>>2];u=B[a+4244>>2];o=B[A>>2];v=B[a+4252>>2];p=B[l>>2];w=B[a+4248>>2];q=B[k>>2];y=B[a+4256>>2];i=E(E(n*u)+E(E(o*v)+E(E(p*w)+E(q*y))));e=h<<1;C=yb(j,e),D=E(F(i))<E(10000000195414814e-40)?E(0):i,B[C>>2]=D;i=E(E(o*u)+E(E(n*v)+E(E(q*w)+E(p*y))));C=yb(j,e|1),D=E(F(i))<E(10000000195414814e-40)?E(0):i,B[C>>2]=D;h=h+1|0;x[a+4224>>2]=(h|0)!=(r|0)?h:0;B[g>>2]=E(q*B[a+4240>>2])+E(o*B[a+4236>>2]);B[m>>2]=E(p*B[a+4240>>2])+E(n*B[a+4236>>2]);f=f-1|0;m=m+4|0;g=g+4|0;l=l+4|0;k=k+4|0;continue}else{Ki(a,b,c,s,t,d)}break}}}function VM(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;e=fb-16|0;fb=e;x[e+12>>2]=c;a:{b:{if(!b){a=a+120|0;to(a);c=x[e+12>>2];b=fb-16|0;fb=b;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(b+8|0,x[vb(b+4|0,a)>>2]);c:{if(c){x[31609]=0;O(1141,a|0,c|0);d=x[31609];x[31609]=0;if((d|0)==1){break a}RM(a,c)}c=b+8|0;Qd(c);Zi(c);fb=b+16|0;break c}v[a+20|0]=0;break b}d=fb-16|0;fb=d;x[d+12>>2]=c;d:{if((b|0)==1){b=a+120|0;to(b);h=wz(b,a,x[d+12>>2]),i=1,v[h+20|0]=i;break d}f=fb-16|0;fb=f;x[f+12>>2]=c;e:{if((b|0)==2){a=a+120|0;to(a);c=x[f+12>>2];b=fb-16|0;fb=b;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(b+8|0,x[vb(b+4|0,a)>>2]);f:{if(c){x[31609]=0;O(1140,a|0,c|0);g=x[31609];x[31609]=0;if((g|0)==1){break a}RM(a,c)}c=b+8|0;Qd(c);Zi(c);fb=b+16|0;break f}Md(a+12|0);v[a+20|0]=2;break e}b=fb-16|0;fb=b;x[b+12>>2]=c;c=a+120|0;to(c);h=wz(c,a,x[b+12>>2]),i=3,v[h+20|0]=i;fb=b+16|0}fb=f+16|0}fb=d+16|0}fb=e+16|0;return}a=N()|0;Zi(b+8|0);Q(a|0);p()}function zma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=fb-16|0;fb=e;a:{b:{c:{f=x[a+12>>2];h=x[a+8>>2];d:{if((f|0)<=1&h>>>0<=805306368|(f|0)<=0){if((f|0)>=-2&h>>>0>=3489660928|(f|0)>-2){break c}if((f|0)==-2&h>>>0>2147483647|(f|0)==-1){break d}break b}if((f|0)==1&h>>>0>2147483648|f>>>0>1){break b}}i=b+196648|0;break a}i=b+131112|0;break a}i=b+262184|0}j=x[a+16>>2];k=x[a+24>>2];l=x[a+20>>2];b=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=b;while(1){if(d){b=x[e+8>>2];g=(x[e+12>>2]<<1)+j|0;b=(b>>>16&65520)+i|0;b=(((((((D(w[g-4>>1],w[b+2>>1])+D(w[g-6>>1],w[b>>1])|0)+D(w[g-2>>1],w[b+4>>1])|0)+D(w[g>>1],w[b+6>>1])|0)+D(w[g+2>>1],w[b+8>>1])|0)+D(w[g+4>>1],w[b+10>>1])|0)+D(w[g+6>>1],w[b+12>>1])|0)+D(w[g+8>>1],w[b+14>>1])|0)/32768|0;x[c>>2]=x[c>>2]+D(b,l);x[c+4>>2]=x[c+4>>2]+D(b,k);Pb(e+8|0,h,f);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;fb=e+16|0}function mna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,y=0,z=0,A=0;g=fb-16|0;fb=g;p=x[a+16>>2];j=kg(1,2);b=hb;q=b;Pb(a,j,b);f=x[a+48>>2];r=x[a+24>>2];s=x[a+20>>2];e=x[a+44>>2];b=x[a+4>>2];x[g+8>>2]=x[a>>2];x[g+12>>2]=b;t=x[a+72>>2];k=x[a+68>>2];u=k>>31;l=x[a+64>>2];v=l>>31;m=x[a+60>>2];y=m>>31;z=x[a+8>>2];A=x[a+12>>2];while(1){b=e;if(d){n=w[(x[g+12>>2]<<1)+p>>1]<<8;e=n;e=Iua(e,e>>31,m,y);i=hb;h=e;e=Yb(b,-16777216,16776704);e=Iua(l,v,e,e>>31);o=h+e|0;h=hb+i|0;h=e>>>0>o>>>0?h+1|0:h;f=Yb(f,-16777216,16776704);e=Iua(k,u,f,f>>31);i=e+o|0;f=hb+h|0;f=e>>>0>i>>>0?f+1|0:f;e=i+8388608|0;f=e>>>0<8388608?f+1|0:f;e=Sc(e,f,24);f=(e|0)/256|0;x[c>>2]=D(f,s)+x[c>>2];x[c+4>>2]=x[c+4>>2]+D(f,r);Pb(g+8|0,z,A);e=e-(t&n)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=x[g+12>>2];x[a>>2]=x[g+8>>2];x[a+4>>2]=c;x[a+48>>2]=f;x[a+44>>2]=b;Ig(a,j,q);fb=g+16|0}function bba(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=fb-16|0;fb=d;x[31609]=0;f=P(21,d+8|0,a|0)|0;c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)!=1){d:{if(!Id(y[f|0])){break d}c=d+4|0;cd(c,x[(x[x[a>>2]-12>>2]+a|0)+28>>2]);x[31609]=0;g=R(1132,x[d+4>>2])|0;e=x[31609];x[31609]=0;e:{f:{if((e|0)!=1){_b(c);c=pp(d,a);e=x[x[a>>2]-12>>2];x[31609]=0;e=a+e|0;h=R(22,e|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break f}c=x[c>>2];x[31609]=0;c=Ra(1133,g|0,c|0,e|0,h|0,+b)|0;g=x[31609];x[31609]=0;if((g|0)==1){break f}if(c){break d}c=x[x[a>>2]-12>>2];x[31609]=0;O(24,a+c|0,5);c=x[31609];x[31609]=0;if((c|0)!=1){break d}c=T(0)|0;break e}c=T(0)|0;_b(d+4|0);break e}c=T(0)|0}hm(f);break c}hm(f);break b}c=T(0)|0}Y(c|0)|0;c=x[x[a>>2]-12>>2];x[31609]=0;W(25,a+c|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}Z()}fb=d+16|0;return a|0}a=N()|0;x[31609]=0;X(26);d=x[31609];x[31609]=0;if((d|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Vt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=fb+-64|0;fb=c;b=x[a>>2];a=x[b>>2];d=x[a+4>>2];x[c+40>>2]=x[a+20>>2];e=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=e;Xf(c+48|0,c+32|0,d);a=x[b+4>>2];d=x[a+8>>2];e=x[a+4>>2];b=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=b;b=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=b;x[c+8>>2]=x[a+8>>2];b=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=b;a:{b:{c:{d:{f=x[c+4>>2];if(f>>>0>=e>>>0){g=x[c+20>>2];if(g>>>0<e>>>0){break d}if(d>>>0>A[c+8>>2]){break c}h=x[c+28>>2];if(d>>>0>x[c+24>>2]-h>>>0){break b}j=x[c+16>>2];k=x[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}l=(D(b,f)<<2)+k|0;m=(D(b+h|0,g)<<2)+j|0;a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{i=a<<2;B[i+m>>2]=E(x[l+i>>2])*E(7.450580596923828e-9);a=a+1|0;continue}}}_(7244,9061,33,8774);p()}_(7209,9061,34,8774);p()}_(5897,9061,35,8774);p()}_(5867,9061,36,8774);p()}fb=c- -64|0}function Kr(a){var b=0,c=0,d=0,e=0;c=fb-16|0;fb=c;a:{if(y[a+3|0]!=19){break a}v[a+3|0]=20;b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{b=y[a+5|0];switch(b>>>4|0){case 4:break j;case 3:break k;case 2:break l;case 1:break m;case 0:break n;case 13:break b;case 12:break c;case 11:break d;case 10:break e;case 9:break f;case 7:break g;case 6:break h;case 5:break i;default:break a}}v[a+3|0]=0;break a}v[a+3|0]=2;v[a+5|0]=b|240;break a}v[a+3|0]=3;v[a+5|0]=b|240;break a}v[a+5|0]=b&15|16;break a}v[a+5|0]=b&3|48;break a}v[a+5|0]=b&223^120;break a}v[a+5|0]=b&15|176;break a}v[a+5|0]=b&3|64;break a}v[a+3|0]=15;v[a+5|0]=b&15;break a}if(b&15){v[a+3|0]=11;v[a+5|0]=b<<4|15;break a}v[a+3|0]=0;break a}b=b&15;if(b){v[a+3|0]=11;x[c+12>>2]=b;x[c+8>>2]=14;d=a,e=y[Cd(c+12|0,c+8|0)|0]|240,v[d+5|0]=e;break a}v[a+3|0]=0;break a}if((b|0)!=192){break a}v[a|0]=254;v[a+3|0]=0;break a}if((b|0)!=208){break a}v[a+3|0]=0}fb=c+16|0}function Pha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{f=b;c=fb-16|0;fb=c;d=Fb(a);while(1){b:{c:{d:{if(_c(x[f+4>>2],y[f+11|0])>>>0>g>>>0){b=x[Wd(f,g)>>2];if(b>>>0>=2097152){x[31609]=0;O(963,d|0,63);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break b}a=0;while(1){if((a|0)==6){b=7;a=6;break d}e=b&63;v[(c+10|0)+a|0]=e;if(b>>>0>=64){a=a+1|0;b=b>>>6|0;continue}break}if(a){b=a+1|0;if((b|0)!=2){break d}a=1;b=2;if((e|0)!=1){break d}a=y[c+10|0]|64}else{a=y[c+10|0]}x[31609]=0;O(963,d|0,a<<24>>24);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break b}fb=c+16|0;break a}i=(2<<a)+255<<7-a;e=b-1|0;j=e+(c+10|0)|0;a=b;while(1){if(!a){break c}e:{if((a|0)==(b|0)){a=y[j|0];x[31609]=0;O(963,d|0,(a|i)<<24>>24);h=x[31609];x[31609]=0;a=e;break e}x[31609]=0;a=a-1|0;O(963,d|0,v[a+(c+10|0)|0]|-128);h=x[31609];x[31609]=0}if((h|0)!=1){continue}break}break b}g=g+1|0;continue}break}a=N()|0;tb(d);Q(a|0);p()}}function gma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=fb-16|0;fb=e;j=x[a+24>>2];k=x[a+20>>2];l=x[a+16>>2];i=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=i;m=b+24|0;i=x[a+8>>2];n=x[a+12>>2];while(1){if(d){b=x[e+8>>2];f=((((x[e+12>>2]&2147483647)<<1|b>>>31)&2147483646)<<1)+l|0;b=(((b>>>16|0)+4&131064)<<1)+m|0;o=w[b+14>>1];p=w[b+12>>1];q=w[b+10>>1];r=w[b+8>>1];s=w[b+6>>1];t=w[b+4>>1];u=w[b+2>>1];b=w[b>>1];h=0;while(1){if((h|0)!=2){g=h<<1;x[(h<<2)+e>>2]=(((((D(w[f+(g|8)>>1],q)+D(w[f+(g|4)>>1],r)|0)+D(w[f+(g|12)>>1],p)|0)+D(w[f+(g|16)>>1],o)|0)/2|0)+((((D(w[f+(g|-8)>>1],u)+D(w[f+(g|-12)>>1],b)|0)+D(w[f+(g|-4)>>1],t)|0)+D(w[f+g>>1],s)|0)/2|0)|0)/16384;h=h+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[e>>2],k);x[c+4>>2]=x[c+4>>2]+D(x[e+4>>2],j);Pb(e+8|0,i,n);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;fb=e+16|0}function eJ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;b=0;a=c;while(1){a:{if(a>>>0>=d>>>0|b>>>0>=e>>>0){break a}g=1;f=v[a|0];b:{if((f|0)>=0){break b}if(f>>>0<4294967234){break a}if(f>>>0<=4294967263){if((d-a|0)<2){break a}g=2;if((y[a+1|0]&192)!=128){break a}break b}g=f&255;if(f>>>0<=4294967279){if((d-a|0)<3){break a}h=y[a+2|0];f=y[a+1|0];c:{d:{if((g|0)!=237){if((g|0)!=224){break d}if((f&224)==160){break c}break a}if((f&224)!=128){break a}break c}if((f&192)!=128){break a}}g=3;if((h&192)!=128){break a}break b}if((d-a|0)<4|f>>>0>4294967284|e-b>>>0<2){break a}h=y[a+3|0];i=y[a+2|0];f=y[a+1|0];e:{f:{switch(g-240|0){case 0:if((f+112&255)>>>0>=48){break a}break e;case 4:if((f&240)!=128){break a}break e;default:break f}}if((f&192)!=128){break a}}if((i&192)!=128|(h&192)!=128|(g<<18&1835008|(f&48)<<12)>>>0>1114111){break a}b=b+1|0;g=4}b=b+1|0;a=a+g|0;continue}break}return a-c|0}function nna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,y=0,z=0,A=0;g=fb-16|0;fb=g;p=x[a+16>>2];j=kg(1,2);b=hb;q=b;Pb(a,j,b);f=x[a+48>>2];r=x[a+24>>2];s=x[a+20>>2];e=x[a+44>>2];b=x[a+4>>2];x[g+8>>2]=x[a>>2];x[g+12>>2]=b;t=x[a+72>>2];k=x[a+68>>2];u=k>>31;l=x[a+64>>2];w=l>>31;m=x[a+60>>2];y=m>>31;z=x[a+8>>2];A=x[a+12>>2];while(1){b=e;if(d){n=v[x[g+12>>2]+p|0]<<16;e=n;e=Iua(e,e>>31,m,y);i=hb;h=e;e=Yb(b,-16777216,16776704);e=Iua(l,w,e,e>>31);o=h+e|0;h=hb+i|0;h=e>>>0>o>>>0?h+1|0:h;f=Yb(f,-16777216,16776704);e=Iua(k,u,f,f>>31);i=e+o|0;f=hb+h|0;f=e>>>0>i>>>0?f+1|0:f;e=i+8388608|0;f=e>>>0<8388608?f+1|0:f;e=Sc(e,f,24);f=(e|0)/256|0;x[c>>2]=D(f,s)+x[c>>2];x[c+4>>2]=x[c+4>>2]+D(f,r);Pb(g+8|0,z,A);e=e-(t&n)|0;c=c+8|0;d=d-1|0;f=b;continue}break}c=x[g+12>>2];x[a>>2]=x[g+8>>2];x[a+4>>2]=c;x[a+48>>2]=f;x[a+44>>2]=b;Ig(a,j,q);fb=g+16|0}function LV(a,b,c,d){var e=0,f=0;e=fb-16|0;fb=e;v[e+15|0]=c;f=b&15;b=y[f+25440|0];a:{b:{switch(f|0){case 0:b=c?d>>>0>=51?b:0:0;break a;case 5:c:{d:{f=c&15;e:{if(!((f|0)!=2&(c&240)!=32)){c=159;v[e+15|0]=159;b=20;break e}if((f|0)==12){break d}}if(d>>>0<51){break a}if((c&240)==192){break c}break a}if(d>>>0<51){break a}}v[e+15|0]=0;b=25;break a;case 7:b=d>>>0>=52?b:0;break a;case 10:c=c&240;if(!c){break a}v[e+15|0]=c;break a;case 11:v[e+15|0]=D(c&15,17);break a;case 13:v[e+15|0]=D(c>>>4|0,10)+(c&15);break a;case 14:f:{switch((c>>>4|0)-1|0){case 0:v[e+15|0]=c|240;b=2;break a;case 1:v[e+15|0]=c|240;b=3;break a;case 7:if(d>>>0<52){break a}v[e+15|0]=c&15|96;case 11:case 12:b=20;break a;case 8:b=15;v[e+15|0]=c&15;break a;case 9:v[e+15|0]=c<<4|15;b=11;break a;case 10:break f;default:break a}}v[e+15|0]=c|240;b=11;break a;case 15:break b;default:break a}}b=c>>>0>47?17:b}ee(a,b,e+15|0);fb=e+16|0}function Zga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=E(0),n=0,o=0,p=0,q=0,r=0,s=E(0),t=E(0),u=E(0),v=E(0),w=0,z=0,A=0,C=0,D=0,G=E(0);g=fb-16|0;fb=g;l=x[a+4240>>2];a:{if(!l){break a}if(!ui(a+44|0)){break a}m=B[a+4220>>2];e=x[a+44>>2];C=g,D=Hc(e,0),x[C+8>>2]=D;C=g,D=Hc(e,1),x[C+12>>2]=D;e=x[a+56>>2];n=Hc(e,0);x[g>>2]=n;o=Hc(e,1);x[g+4>>2]=o;v=E(E(1)-m);p=x[a+4208>>2];w=y[a+4264|0];e=d;b:while(1){if(e){k=x[a+4244>>2];z=k<<1;f=0;while(1)if((f|0)==2){f=k+1|0;x[a+4244>>2]=(f|0)!=(l|0)?f:0;e=e-1|0;continue b}else{h=(f^w)&255;j=x[((h<<2)+a|0)+4248>>2];A=x[a+4240>>2];q=f<<2;r=q+(g+8|0)|0;i=x[r>>2];x[r>>2]=i+4;j=k-j|0;s=B[yb(p,h|(j>>31&A)+j<<1)>>2];t=B[i>>2];u=E(E(s*B[a+4224>>2])+E(t*B[a+4260>>2]));C=yb(p,f|z),G=E(F(u))<E(10000000195414814e-40)?E(0):u,B[C>>2]=G;h=g+q|0;i=x[h>>2];x[h>>2]=i+4;B[i>>2]=E(t*v)+E(m*s);f=f+1|0;continue}}break}Ki(a,b,c,n,o,d)}fb=g+16|0}function hJ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;a=c;while(1){a:{if(e>>>0<=i>>>0|a>>>0>=d>>>0){break a}f=1;b=v[a|0];b:{if((b|0)>=0){break b}if(b>>>0<4294967234){break a}if(b>>>0<=4294967263){if((d-a|0)<2){break a}f=2;if((y[a+1|0]&192)!=128){break a}break b}g=b&255;if(b>>>0<=4294967279){if((d-a|0)<3){break a}h=y[a+2|0];b=y[a+1|0];c:{d:{if((g|0)!=237){if((g|0)!=224){break d}if((b&224)==160){break c}break a}if((b&224)!=128){break a}break c}if((b&192)!=128){break a}}f=3;if((h&192)!=128){break a}break b}if((d-a|0)<4|b>>>0>4294967284){break a}f=y[a+3|0];h=y[a+2|0];b=y[a+1|0];e:{f:{switch(g-240|0){case 0:if((b+112&255)>>>0>=48){break a}break e;case 4:if((b&240)!=128){break a}break e;default:break f}}if((b&192)!=128){break a}}if((h&192)!=128|(f&192)!=128){break a}f=4;if((g<<18&1835008|(b&48)<<12)>>>0>1114111){break a}}i=i+1|0;a=a+f|0;continue}break}return a-c|0}function Ama(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=fb-16|0;fb=e;a:{b:{c:{f=x[a+12>>2];h=x[a+8>>2];d:{if((f|0)<=1&h>>>0<=805306368|(f|0)<=0){if((f|0)>=-2&h>>>0>=3489660928|(f|0)>-2){break c}if((f|0)==-2&h>>>0>2147483647|(f|0)==-1){break d}break b}if((f|0)==1&h>>>0>2147483648|f>>>0>1){break b}}i=b+196648|0;break a}i=b+131112|0;break a}i=b+262184|0}j=x[a+16>>2];k=x[a+24>>2];l=x[a+20>>2];b=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=b;while(1){if(d){b=x[e+8>>2];g=x[e+12>>2]+j|0;b=(b>>>16&65520)+i|0;b=(((((((D(v[g-2|0],w[b+2>>1])+D(v[g-3|0],w[b>>1])|0)+D(v[g-1|0],w[b+4>>1])|0)+D(v[g|0],w[b+6>>1])|0)+D(v[g+1|0],w[b+8>>1])|0)+D(v[g+2|0],w[b+10>>1])|0)+D(v[g+3|0],w[b+12>>1])|0)+D(v[g+4|0],w[b+14>>1])<<8)/32768|0;x[c>>2]=x[c>>2]+D(b,l);x[c+4>>2]=x[c+4>>2]+D(b,k);Pb(e+8|0,h,f);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;fb=e+16|0}function Wt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=fb+-64|0;fb=c;b=x[a>>2];a=x[b>>2];d=x[a+4>>2];x[c+40>>2]=x[a+20>>2];e=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=e;Xf(c+48|0,c+32|0,d);a=x[b+4>>2];d=x[a+8>>2];e=x[a+4>>2];b=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=b;b=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=b;x[c+8>>2]=x[a+8>>2];b=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=b;a:{b:{c:{d:{f=x[c+4>>2];if(f>>>0>=e>>>0){if(A[c+20>>2]<e>>>0){break d}if(d>>>0>A[c+8>>2]){break c}g=x[c+28>>2];if(d>>>0>x[c+24>>2]-g>>>0){break b}i=x[c+16>>2];j=x[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}k=(D(b,f)<<2)+j|0;a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{h=a<<2;B[(x[h+i>>2]+(g<<2)|0)+(b<<2)>>2]=E(x[k+h>>2])*E(7.450580596923828e-9);a=a+1|0;continue}}}_(7244,9061,33,8774);p()}_(7209,9061,34,8774);p()}_(5897,9061,35,8774);p()}_(5867,9061,36,8774);p()}fb=c- -64|0}function DE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;f=fb-560|0;fb=f;w[f+558>>1]=b;a:{if((b-256&65535)>>>0<65281){break a}e=((b<<2)+a|0)+900380|0;b=x[e>>2];b:{if(b){c=kV(f,c);d=x[c+4>>2];x[b>>2]=x[c>>2];x[b+4>>2]=d;d=y[c+11|0]|y[c+12|0]<<8|(y[c+13|0]<<16|y[c+14|0]<<24);e=y[c+7|0]|y[c+8|0]<<8|(y[c+9|0]<<16|y[c+10|0]<<24);v[b+7|0]=e;v[b+8|0]=e>>>8;v[b+9|0]=e>>>16;v[b+10|0]=e>>>24;v[b+11|0]=d;v[b+12|0]=d>>>8;v[b+13|0]=d>>>16;v[b+14|0]=d>>>24;v[b+15|0]=y[c+15|0];d=x[c+44>>2];x[b+40>>2]=x[c+40>>2];x[b+44>>2]=d;d=x[c+36>>2];x[b+32>>2]=x[c+32>>2];x[b+36>>2]=d;d=x[c+28>>2];x[b+24>>2]=x[c+24>>2];x[b+28>>2]=d;d=x[c+20>>2];x[b+16>>2]=x[c+16>>2];x[b+20>>2]=d;OA(b+48|0,c+48|0);OA(b+68|0,c+68|0);OA(b+88|0,c+88|0);zc(b+108|0,c+108|0,448);d=b;Nv(c);break b}b=zu(556);if(!b){x[e>>2]=0;break a}d=kV(b,c);x[e>>2]=d}g=a,h=z[qe(a+480192|0,f+558|0)>>1],w[g+480192>>1]=h}fb=f+560|0;return d|0}function z1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{f=b;c=fb-16|0;fb=c;d=Fb(a);while(1){b:{c:{d:{if(_c(x[f+4>>2],y[f+11|0])>>>0>g>>>0){b=x[Wd(f,g)>>2];if(b>>>0>=2097152){x[31609]=0;O(50,d|0,63);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break b}a=0;while(1){if((a|0)==6){b=7;a=6;break d}e=b&63;v[(c+10|0)+a|0]=e;if(b>>>0>=64){a=a+1|0;b=b>>>6|0;continue}break}if(a){b=a+1|0;if((b|0)!=2){break d}a=1;b=2;if((e|0)!=1){break d}a=y[c+10|0]|64}else{a=y[c+10|0]}x[31609]=0;O(50,d|0,a&255);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break b}fb=c+16|0;break a}e=b-1|0;i=e+(c+10|0)|0;j=(2<<a)+255<<7-a&255;a=b;while(1){if(!a){break c}e:{if((a|0)==(b|0)){a=y[i|0];x[31609]=0;O(50,d|0,a|j);h=x[31609];x[31609]=0;a=e;break e}x[31609]=0;a=a-1|0;O(50,d|0,y[a+(c+10|0)|0]|128);h=x[31609];x[31609]=0}if((h|0)!=1){continue}break}break b}g=g+1|0;continue}break}a=N()|0;tb(d);Q(a|0);p()}}function loa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=fb-16|0;fb=e;w[e+12>>1]=c;w[e+14>>1]=b;w[e+10>>1]=d;g=z[x[x[a+24>>2]+8>>2]+12>>1];a:{if(g>>>0<=b>>>0){break a}if(!c|Ij(a)>>>0>=g>>>0){break a}Hf(e+12|0,g-b&65535);k=e,l=dm(x[a>>2],x[a+4>>2]),w[k+8>>1]=l;d=z[e+12>>1];GY(a,d+z[qe(e+14|0,e+8|0)>>1]|0);f=e+4|0;c=a;a=x[a>>2];if($c(a,x[c+4>>2])>>>0<b>>>0){vg(c,b);a=x[c>>2]}a=vb(f,TX(wb(a),b));h=e+10|0;j=fb-32|0;fb=j;b=x[a>>2];a=x[c>>2];f=(kp(b,wb(a))<<1)+a|0;a=d;b:{if(!a){break b}b=x[Ab(c)>>2];i=x[c+4>>2];if(a>>>0<=b-i>>1>>>0){b=a;d=i-f>>1;if(d>>>0<a>>>0){sp(c,a-d|0,h);b=d;if((f|0)==(i|0)){break b}}YU(c,f,i,(a<<1)+f|0);Kv(f,b,((f>>>0<=h>>>0?A[c+4>>2]>h>>>0?a:0:0)<<1)+h|0);break b}b=Ab(c);b=fk(j+12|0,gk(c,$c(x[c>>2],i)+a|0),f-x[c>>2]>>1,b);sF(b,a,h);f=XU(c,b,f);cj(b)}wb(f);fb=j+32|0;if($c(x[c>>2],x[c+4>>2])>>>0<=g>>>0){break a}vg(c,g)}fb=e+16|0}function Vqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=fb-432|0;fb=d;yc(b);jD(b,d+380|0,d+300|0,d+16|0);k=d,l=Eh((m=y[d+431|0]+1|0,n=1,o=$b(y[d+412|0]|y[d+413|0]<<8|(y[d+414|0]<<16|y[d+415|0]<<24)),o?m:n)),v[k+12|0]=l;i=y[Qb(25200,d+12|0)|0];v[d+15|0]=i;w[d+12>>1]=4;a:{b:{while(1){if((h&255)>>>0>=i>>>0){break b}e=Bb(z[d+16>>1])<<16>>16;if(!((e|0)<0|y[d+299|0]>63)){e=e&65535;f=0;while(1){if((f|0)==(e|0)){c:{e=g;g=$b(x[d+300>>2]);if(e>>>0<g>>>0){if(dd(b,g)){break c}}v[d+15|0]=h+1;break b}}else{d:{if(!dd(b,$b(y[d+396|0]|y[d+397|0]<<8|(y[d+398|0]<<16|y[d+399|0]<<24))+(f<<2)|0)){break d}if(!dd(b,np(b))){break d}e:{if(!c){j=Zd(b);break e}j=Qk(b)}w[d+10>>1]=j;k=d,l=z[qe(d+12|0,d+10|0)>>1],w[k+12>>1]=l}f=f+1|0;continue}break}g=$b(x[d+300>>2]);jD(b,d+380|0,d+300|0,d+16|0);h=h+1|0;continue}break}Ww(a);break a}CY(a,z[d+12>>1],d+15|0)}fb=d+432|0}function tra(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;e=fb-16|0;fb=e;b=fb-16|0;fb=b;x[b+4>>2]=1073741824;w[b+10>>1]=12;c=Ec(64);x[31609]=0;d=R(875,c|0)|0;f=x[31609];x[31609]=0;a:{b:{c:{if((f|0)!=1){c=yf(b,d);d=x[c>>2];x[31609]=0;O(876,d|0,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}a=x[c>>2];x[31609]=0;a=U(877,a|0,b+10|0,b+4|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}d:{if(!a){tc(b+12|0);break d}a=x[c>>2];x[31609]=0;O(878,a|0,15);a=x[31609];x[31609]=0;if((a|0)==1){break c}re(b+12|0,c)}mg(c);fb=b+16|0;b=x[b+12>>2];break a}a=N()|0;Db(c);break b}a=N()|0;mg(c)}Q(a|0);p()}x[e+12>>2]=b;a=0;e:{f:{g:{while(1){if((a|0)==12){break e}x[31609]=0;c=P(1,e|0,(a<<2)+30512|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){x[31609]=0;S(499,b|0,a|0,c|0);d=x[31609];x[31609]=0;if((d|0)==1){break g}tb(c);a=a+1|0;continue}break}a=N()|0;break f}a=N()|0;tb(c)}mg(e+12|0);Q(a|0);p()}fb=e+16|0;return b|0}function Caa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=fb+-64|0;fb=c;b=x[a>>2];a=x[b>>2];d=x[a+4>>2];x[c+40>>2]=x[a+20>>2];e=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=e;Xf(c+48|0,c+32|0,d);a=x[b+4>>2];d=x[a+8>>2];e=x[a+4>>2];b=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=b;b=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=b;x[c+8>>2]=x[a+8>>2];b=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=b;a:{b:{c:{d:{f=x[c+4>>2];if(f>>>0>=e>>>0){g=x[c+20>>2];if(g>>>0<e>>>0){break d}if(d>>>0>A[c+8>>2]){break c}h=x[c+28>>2];if(d>>>0>x[c+24>>2]-h>>>0){break b}i=x[c+16>>2];j=x[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}k=(D(b,f)<<3)+j|0;l=(D(b+h|0,g)<<2)+i|0;a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{B[(a<<2)+l>>2]=C[(a<<3)+k>>3];a=a+1|0;continue}}}_(7244,9061,77,8741);p()}_(7209,9061,78,8741);p()}_(5897,9061,79,8741);p()}_(5867,9061,80,8741);p()}fb=c- -64|0}function tqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=fb-16|0;fb=f;w[f+12>>1]=0;x[f+8>>2]=0;n=D(c,d);k=4;a:while(1){if((d|0)!=(l|0)){i=b+l|0;o=n+i|0;while(1){b:{c:{if(i>>>0<o>>>0){v[f+7|0]=0;mY(a,f+15|0,f+12|0,f+7|0);g=y[f+7|0];e=z[f+12>>1];c=k;while(1){if(c&255){h=e<<1;e=h&254;d:{if(e){h=(h&65534)>>>0>255;break d}if(!Bf(a,f+6|0)){break c}e=y[f+6|0];h=e>>>7|0;e=e<<1&254|1}c=c-1|0;g=g<<1|h;continue}break}w[f+12>>1]=e;break b}l=l+1|0;continue a}w[f+12>>1]=0}c=1;h=g&255;e:{if(h>>>0<4){break e}e=7;while(1){c=e;m=e&255;if(m>>>0<2){break e}e=e-1|0;if(!(h&1<<m)){continue}break}}e=g&1;v[f+15|0]=e;g=e-1^(g&254)>>>1;e=g+y[f+8|0]|0;v[f+7|0]=e;v[i|0]=e;x[f+8>>2]=((g>>1)-(j<<24>>24)|0)+(e<<24>>24<<1);i=d+i|0;k=(c+k&254)>>>1|0;c=-128;j=x[f+8>>2];f:{if((j|0)>=-128){c=127;if((j|0)<128){break f}}x[f+8>>2]=c}j=e;continue}}break}fb=f+16|0}function XG(a,b,c,d){var e=0,f=0,g=0,h=0;g=fb-32|0;fb=g;f=d&2147483647;e=f-1065418752|0;h=f-1082064896|0;a:{if((e|0)==(h|0)&0|e>>>0<h>>>0){f=(d&33554431)<<7|c>>>25;e=0;h=e;c=c&33554431;if(!(!e&(c|0)==16777216?!(a|b):!e&c>>>0<16777216)){e=f+1073741825|0;break a}e=f+1073741824|0;if(c^16777216|a|(b|h)){break a}e=(f&1)+e|0;break a}if(!(!c&(f|0)==2147418112?!(a|b):f>>>0<2147418112)){e=((d&33554431)<<7|c>>>25)&4194303|2143289344;break a}e=2139095040;if(f>>>0>1082064895){break a}e=0;f=f>>>16|0;if(f>>>0<16145){break a}e=d&65535|65536;$f(g+16|0,a,b,c,e,f-16129|0);cn(g,a,b,c,e,16257-f|0);a=x[g+8>>2];e=(x[g+12>>2]&33554431)<<7|a>>>25;c=x[g>>2]|(x[g+16>>2]|x[g+24>>2]|(x[g+20>>2]|x[g+28>>2]))!=0;f=x[g+4>>2];b=0;a=a&33554431;if(!(!b&(a|0)==16777216?!(c|f):!b&a>>>0<16777216)){e=e+1|0;break a}if(a^16777216|c|(b|f)){break a}e=(e&1)+e|0}fb=g+32|0;return l(2,d&-2147483648|e),r()}function rga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=E(0),m=0,n=0,o=E(0),p=E(0),q=E(0),r=E(0),s=E(0),t=E(0),u=E(0),v=E(0),w=E(0);h=fb-16|0;fb=h;if(ui(a+44|0)){f=x[a+44>>2];g=Hc(f,0);x[h+8>>2]=g;f=Hc(f,1);x[h+12>>2]=f;j=x[a+56>>2];m=Hc(j,0);x[h>>2]=m;j=Hc(j,1);x[h+4>>2]=j;a:{if(B[yb(a+4208|0,2)>>2]!=E(.5)){f=d;b:while(1){g=0;if(!f){break a}while(1)if((g|0)==2){f=f-1|0;continue b}else{k=g<<2;e=k+(h+8|0)|0;i=x[e>>2];x[e>>2]=i+4;e=a+k|0;n=e+4248|0;q=B[n>>2];l=B[i>>2];r=B[a+4236>>2];s=B[a+4232>>2];t=B[a+4228>>2];u=B[a+4220>>2];v=B[a+4224>>2];i=e+4240|0;o=B[i>>2];B[n>>2]=o;B[i>>2]=l;i=e+4264|0;w=B[i>>2];e=e+4256|0;p=B[e>>2];B[i>>2]=p;l=E(E(E(E(t*q)+E(E(u*l)+E(v*o)))-E(s*p))-E(r*w));B[e>>2]=l;k=h+k|0;e=x[k>>2];x[k>>2]=e+4;B[e>>2]=l;g=g+1|0;continue}}}e=g;g=d<<2;zc(m,e,g);zc(j,f,g);f=x[a+56>>2];m=Hc(f,0);j=Hc(f,1)}Ki(a,b,c,m,j,d)}fb=h+16|0}function Ula(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=fb-16|0;fb=e;n=x[a+16>>2];o=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);i=x[a+8>>2];j=x[a+12>>2];b=x[a>>2];g=x[a+4>>2];k=x[a+128>>2];if(k){l=Hg(i,j,k);m=hb;f=x[a+76>>2];fg(b,g,vf(i,j,d),hb);h=hb>>>0>f>>>0?d:0}f=a+112|0;p=x[a+24>>2];q=x[a+20>>2];x[e>>2]=b;x[e+4>>2]=g;a:while(1){if(d){g=x[e+4>>2];x[e+8>>2]=x[e>>2];x[e+12>>2]=0;h=h-1|0;l=h?l:0;m=h?m:0;d=d-1|0;g=(g<<1)+n|0;b=k;while(1)if((b|0)<=0){Pb(f,x[a+120>>2],x[a+124>>2]);b=x[a+116>>2];if(b){ce(f,w[(x[e+12>>2]<<1)+g>>1]/4<<16>>16);be(f,b);x[f>>2]=x[f>>2];x[f+4>>2]=0}g=x[c>>2];b=Fg(f,o);x[c>>2]=g+D(b,q);x[c+4>>2]=x[c+4>>2]+D(b,p);Pb(e,i,j);c=c+8|0;continue a}else{ce(f,w[(x[e+12>>2]<<1)+g>>1]/4<<16>>16);be(f,4);Pb(e+8|0,l,m);b=b-1|0;continue}}break}b=x[e+4>>2];x[a>>2]=x[e>>2];x[a+4>>2]=b;fb=e+16|0}function pB(a,b,c,d,e){var f=0,g=0,h=0;g=D(c,872)+b|0;a:{if(d){if(!Ob(a+1074312|0,90)){v[g+1427|0]=d}v[(D(c,872)+b|0)+1428|0]=d;break a}d=y[g+1428|0]}f=x[a+480180>>2];if(!e){h=Ju(f)}g=g+616|0;b:{if((f|0)!=268435456){if((f|0)!=16777216){break b}f=x[(D(c,872)+b|0)+1272>>2];if(!f|!x[f+44>>2]){break b}a=d&255;if(!(a>>>0<240|e)){ZS(b,c,240-a|0);return}if(!(a>>>0<224|e)){YS(g,224-a|0);return}XS(g,0-a|0);return}x[(D(c,872)+b|0)+1324>>2]=65535}e=d&255;c:{d:{if(!(e>>>0>223&h)){break d}e:{f=e&15;if(!f){break e}d=d&240;if((d|0)!=224){if((d|0)!=240){break e}mB(a,g,f);return}if(x[a+480180>>2]==524288){break d}lB(a,g,f);return}if(x[a+480180>>2]!=524288){break c}}b=D(c,872)+b|0;f:{if(!(v[b+1467|0]&1)){break f}if(x[a+1074416>>2]==1){if(Ob(a+1074312|0,6)){break f}}c=x[a+480180>>2];if(c&32832){break f}if(!(y[a+480208|0]&2)|(c|0)!=8){break c}}xk(a,g,b+1316|0,0-(e<<2)|0,0)}}function YC(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;i=fb-32|0;fb=i;h=fb-16|0;fb=h;nd(b,1);g=Bb(y[a+22|0]|y[a+23|0]<<8)<<1;x[b>>2]=g;v[b+37|0]=y[a+24|0]<<4;v[h+15|0]=y[a+25|0];v[h+14|0]=64;l=b,m=y[Qb(h+15|0,h+14|0)|0]<<2,w[l+30>>1]=m;f=Bb(y[a+26|0]|y[a+27|0]<<8);e=f<<1;k=Bb(y[a+28|0]|y[a+29|0]<<8);j=k<<1;e=k>>>0>=2?e+j>>>0<=g>>>0?e:f+j>>>0>g>>>0?e:f:e;a:{b:{switch(g|0){case 2:x[b>>2]=0;break a;case 0:break a;default:break b}}x[b+4>>2]=e;f=e+j|0;x[b+8>>2]=f;if(e>>>0>=g>>>0){e=g-1|0;x[b+4>>2]=e}if(!(!(f>>>0<4|e>>>0>f>>>0)&f-e>>>0>3)){x[b+4>>2]=0;x[b+8>>2]=0;f=0;e=0}if(!(f>>>0>8|f>>>0>=g>>>0|(!d|e))){x[b+8>>2]=0;break a}if(e>>>0>=f>>>0){break a}w[b+34>>1]=z[b+34>>1]|2}fb=h+16|0;d=i+8|0;Sk(d,3,a);b=i+20|0;Cc(b,d);c=Ac(c,b);tb(b);d=0;while(1){if((d|0)!=32){b=c+d|0;if((y[b|0]-1&255)>>>0<=30){v[b|0]=32}d=d+1|0;continue}break}a=_C(a);fb=i+32|0;return a}function MH(a,b,c,d,e,f,g,h){var i=0,j=0,k=E(0);i=fb-96|0;fb=i;MA(x[a+24>>2]);v[x[a+24>>2]+1298424|0]=x[a+52>>2]!=0;x[i+92>>2]=f;x[i+88>>2]=e;x[i+84>>2]=d;x[i+80>>2]=c;a:{d=i+80|0;c=0;while(1){b:{if((c|0)!=4){if(x[(c<<2)+d>>2]){break b}}else{c=4}break a}c=c+1|0;continue}}x[i+44>>2]=b;x[i+40>>2]=c;x[i+36>>2]=d;e=x[a+32>>2];k=B[a+48>>2];x[i+8>>2]=b;c=x[i+40>>2];x[i>>2]=x[i+36>>2];x[i+4>>2]=c;d=fb-16|0;fb=d;x[d+8>>2]=x[i+8>>2];c=x[i+4>>2];x[d>>2]=x[i>>2];x[d+4>>2]=c;c=KM(i+48|0);x[c+8>>2]=e;x[c+4>>2]=0;x[c>>2]=h;e=x[d+4>>2];x[c+12>>2]=x[d>>2];x[c+16>>2]=e;x[c+20>>2]=x[d+8>>2];C[c+24>>3]=k;x[c>>2]=g;fb=d+16|0;while(1){if(b){d=x[a+24>>2];x[i+24>>2]=b;x[i+28>>2]=0;x[i+16>>2]=134217727;x[i+20>>2]=0;d=LM(d,x[Ur(i+24|0,i+16|0)>>2],c);j=d+j|0;b=b-d|0;if(d){continue}}break}if(!(x[a+52>>2]!=1|j)){a=x[a+24>>2];x[a+480208>>2]=x[a+480208>>2]&-513}fb=i+96|0;return j}function Laa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=fb+-64|0;fb=c;b=x[a>>2];a=x[b>>2];d=x[a+4>>2];x[c+40>>2]=x[a+20>>2];e=x[a+16>>2];x[c+32>>2]=x[a+12>>2];x[c+36>>2]=e;Xf(c+48|0,c+32|0,d);a=x[b+4>>2];d=x[a+8>>2];e=x[a+4>>2];b=x[c+60>>2];x[c+24>>2]=x[c+56>>2];x[c+28>>2]=b;b=x[c+52>>2];x[c+16>>2]=x[c+48>>2];x[c+20>>2]=b;x[c+8>>2]=x[a+8>>2];b=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=b;a:{b:{c:{d:{f=x[c+4>>2];if(f>>>0>=e>>>0){if(A[c+20>>2]<e>>>0){break d}if(d>>>0>A[c+8>>2]){break c}g=x[c+28>>2];if(d>>>0>x[c+24>>2]-g>>>0){break b}h=x[c+16>>2];i=x[c>>2];b=0;e:while(1){if((b|0)==(d|0)){break a}j=(D(b,f)<<3)+i|0;a=0;while(1)if((a|0)==(e|0)){b=b+1|0;continue e}else{B[(x[(a<<2)+h>>2]+(g<<2)|0)+(b<<2)>>2]=C[(a<<3)+j>>3];a=a+1|0;continue}}}_(7244,9061,77,8741);p()}_(7209,9061,78,8741);p()}_(5897,9061,79,8741);p()}_(5867,9061,80,8741);p()}fb=c- -64|0}function nG(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=fb-16|0;fb=h;d=Ab(a);c=vb(h+12|0,x[a+4>>2]);g=vb(h+8|0,x[a>>2]);f=vb(h+4|0,x[b+4>>2]);e=x[c>>2];g=x[g>>2];c=fb+-64|0;fb=c;f=x[f>>2];x[c+56>>2]=f;x[c+60>>2]=e;x[c+52>>2]=f;d=Ag(c+24|0,d,c+52|0,c+56|0);x[c+16>>2]=x[d+8>>2];f=x[d+4>>2];x[c+8>>2]=x[d>>2];x[c+12>>2]=f;zg(c+36|0,c+8|0);while(1){if(Fd(e,g)){gx(kG(x[c+56>>2]),ej(e));e=lG(c+60|0);lG(c+56|0);e=x[e>>2];continue}break}yg(c+36|0);i=x[c+56>>2];if(!y[c+48|0]){g=fb-16|0;fb=g;d=vb(g+12|0,x[x[c+44>>2]>>2]);j=x[vb(g+8|0,x[x[c+40>>2]>>2])>>2];e=fb-16|0;fb=e;f=x[d>>2];x[e+12>>2]=f;while(1){if(xi(f,j)){d=fb-16|0;fb=d;x[d+12>>2]=f;x[d+12>>2]=x[d+12>>2]+36;fb=d+16|0;Gp(kG(x[d+12>>2]));x[e+12>>2]=x[e+12>>2]+36;f=x[e+12>>2];continue}break}fb=e+16|0;fb=g+16|0}fb=c- -64|0;x[b+4>>2]=i;Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=h+16|0}function hma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=fb-16|0;fb=e;h=x[a+24>>2];i=x[a+20>>2];j=x[a+16>>2];g=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=g;k=b+24|0;g=x[a+8>>2];l=x[a+12>>2];while(1){if(d){b=x[e+8>>2];f=(((x[e+12>>2]&2147483647)<<1|b>>>31)&-2)+j|0;b=(((b>>>16|0)+4&131064)<<1)+k|0;m=w[b+14>>1];n=w[b+12>>1];o=w[b+10>>1];p=w[b+8>>1];q=w[b+6>>1];r=w[b+4>>1];s=w[b+2>>1];t=w[b>>1];b=0;while(1){if((b|0)!=2){x[(b<<2)+e>>2]=((((D(v[(b|4)+f|0],o)+D(v[(b|2)+f|0],p)|0)+D(v[(b|6)+f|0],n)|0)+D(v[(b|8)+f|0],m)<<8>>1)+(((D(v[(b|-4)+f|0],s)+D(v[(b|-6)+f|0],t)|0)+D(v[(b|-2)+f|0],r)|0)+D(v[b+f|0],q)<<8>>1)|0)/16384;b=b+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[e>>2],i);x[c+4>>2]=x[c+4>>2]+D(x[e+4>>2],h);Pb(e+8|0,g,l);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;fb=e+16|0}function Pm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=fb-16|0;fb=e;x[a+4>>2]=0;if(Id(y[Hm(e+15|0,a,1)|0])){a:{b:{c:{if((b|0)==2147483647){b=a+24|0;while(1){c=x[b+x[x[a>>2]-12>>2]>>2];x[31609]=0;c=R(83,c|0)|0;d=x[31609];x[31609]=0;d:{if((d|0)!=1){if(!mc(c,-1)){break d}break b}break c}x[a+4>>2]=x[a+4>>2]+1;continue}}if(x[a+4>>2]>=(b|0)){break a}c=a+24|0;e:{while(1){d=x[c+x[x[a>>2]-12>>2]>>2];x[31609]=0;d=R(83,d|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}if(mc(d,-1)){break b}d=x[a+4>>2]+1|0;x[a+4>>2]=d;if((b|0)>(d|0)){continue}break}c=0;break a}}Y(T(0)|0)|0;c=1;Fm(x[x[a>>2]-12>>2]+a|0,1);f:{g:{if(x[(x[x[a>>2]-12>>2]+a|0)+20>>2]&1){x[31609]=0;X(84);a=x[31609];x[31609]=0;if((a|0)!=1){break f}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){break g}Q(a|0);p()}Z();break a}T(0)|0;Sb()}p()}c=2}Xj(x[x[a>>2]-12>>2]+a|0,c)}fb=e+16|0;return a|0}function Jm(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;wl(a);a:{b:{c:{f=x[b+32>>2];d:{if(!f){e=x[b+2084>>2];if(e){break d}break b}c=x[b+4>>2];if((c|0)<9){break c}e=x[b+2084>>2];if(!e){break c}}h=x[a+1392>>2];j=Im(h);d=x[b+2092>>2];c=0;while(1){if((d|0)>=2){f=d>>>1|0;i=f+c|0;g=A[(i<<2)+e>>2]>j>>>0;d=g?f:d-f|0;c=g?c:i;continue}break}d=x[a+1396>>2];c=y[b+23|0]?c:x[x[b+2088>>2]+(c<<2)>>2];b=y[c+x[b+8>>2]|0];e:{if((d|0)<(b|0)){c=-1;b=0;break e}x[a+1392>>2]=h>>>b;b=d-b|0}x[a+1396>>2]=b;return c}if(y[b+23|0]){break a}e=(c|0)>0?c:0;while(1){if((d|0)!=(e|0)){f:{c=y[x[b+8>>2]+d|0];if((c|0)==255){break f}g=x[a+1392>>2];if(x[f+(d<<2)>>2]!=(g&(-1<<c^-1))){break f}e=x[a+1396>>2];if((e|0)>=(c|0)){x[a+1392>>2]=g>>>c;x[a+1396>>2]=e-y[x[b+8>>2]+d|0];return d}x[a+1396>>2]=0;break b}d=d+1|0;continue}break}fc(a,21);x[a+1396>>2]=0}return-1}_(11394,13274,1705,5445);p()}function o0(a,b,c){var d=0,e=0;e=fb-16|0;fb=e;v[e+15|0]=c;a:{if(b>>>0>35){break a}b:{c:{d:{e:{f:{g:{h:{d=y[b+24688|0];switch(d-6|0){case 2:case 3:case 4:case 6:case 7:case 9:case 10:case 12:break a;case 11:break c;case 13:break d;case 0:case 1:case 5:break f;case 8:break g;default:break h}}if((d|0)==31){break b}if((d|0)==23){break e}if((d|0)!=1){break a}d=(c|0)!=0;break a}v[e+15|0]=D(c>>>4|0,10)+(c&15);d=14;break a}b=c&240;if(!b|(b|0)==240|(c&15)==15){break a}v[e+15|0]=b;break a}if(c>>>0<=64){v[e+15|0]=c<<1;d=23;break a}v[e+15|0]=128;d=23;break a}d=19;i:{switch(c-48>>>4|0){case 0:v[e+15|0]=159;d=20;break a;case 1:v[e+15|0]=192;d=20;break a;case 2:if(c&14){break a}v[e+15|0]=((c|0)!=80)<<6;d=21;break a;case 4:break i;default:break a}}v[e+15|0]=c&15|160;d=20;break a}d=c>>>0<32?16:17;break a}v[e+15|0]=(b<<5|c>>>3)^128;d=31}ee(a,d,e+15|0);fb=e+16|0}function fpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=fb-16|0;fb=c;d=c+11|0;nX(a,d);if((y[c+11|0]|y[c+12|0]<<8|(y[c+13|0]<<16|y[c+14|0]<<24))==1414807888){nX(a,d);v[b|0]=1;b=0}else{b=1}a=fb-176|0;fb=a;e=a+12|0;Xw(e,(c+11|0)+b|0);x[31609]=0;d=a+24|0;O(124,d|0,e|0);b=x[31609];x[31609]=0;a:{b:{c:{d:{e:{if((b|0)!=1){x[31609]=0;b=P(103,a+36|0,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break e}tb(d);tb(e);e=x[x[b>>2]-12>>2];x[31609]=0;g=ca(104)|0;f=x[31609];x[31609]=0;if((f|0)==1){break c}x[31609]=0;f=a+8|0;S(105,f|0,b+e|0,g|0);e=x[31609];x[31609]=0;if((e|0)==1){break c}_b(f);x[31609]=0;w[a+24>>1]=0;d=P(686,b|0,d|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break c}b=pk(x[(d+x[x[d>>2]-12>>2]|0)+16>>2]);e=z[a+24>>1];Gf(d);fb=a+176|0;a=(b?0:e)&65535;break a}c=N()|0;break d}c=N()|0;tb(a+24|0)}tb(a+12|0);break b}c=N()|0;Gf(b)}Q(c|0);p()}fb=c+16|0;return a|0}function qB(a,b,c,d,e){var f=0,g=0,h=0;g=D(c,872)+b|0;a:{if(d){if(!Ob(a+1074312|0,90)){v[g+1428|0]=d}v[(D(c,872)+b|0)+1427|0]=d;break a}d=y[g+1427|0]}f=x[a+480180>>2];if(!e){h=Ju(f)}g=g+616|0;b:{if((f|0)!=268435456){if((f|0)!=16777216){break b}f=x[(D(c,872)+b|0)+1272>>2];if(!f|!x[f+44>>2]){break b}a=d&255;if(!(a>>>0<240|e)){ZS(b,c,a-240|0);return}if(!(a>>>0<224|e)){YS(g,a-224|0);return}XS(g,a);return}x[(D(c,872)+b|0)+1324>>2]=1}e=d&255;c:{d:{if(!(e>>>0>223&h)){break d}e:{f=e&15;if(!f){break e}d=d&240;if((d|0)!=224){if((d|0)!=240){break e}nB(a,g,f);return}if(x[a+480180>>2]==524288){break d}oB(a,g,f);return}if(x[a+480180>>2]!=524288){break c}}b=D(c,872)+b|0;f:{if(!(v[b+1467|0]&1)){break f}if(x[a+1074416>>2]==1){if(Ob(a+1074312|0,6)){break f}}c=x[a+480180>>2];if(c&32832){break f}if(!(y[a+480208|0]&2)|(c|0)!=8){break c}}xk(a,g,b+1316|0,e<<2,0)}}function lP(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;g=fb-16|0;fb=g;b=x[a>>2];vb(g+12|0,b);a:{b:{c:{d:{e:{if(Ed(x[b+16>>2])){while(1){if(c>>>0>31){break e}x[31609]=0;d=ca(69)|0;e=x[31609];x[31609]=0;if((e|0)!=1){f=d|f;c=c+32|0;continue}break}c=T(125124)|0;if((gb|0)!=($(125124)|0)){break c}Y(c|0)|0;v[b+20|0]=0;x[31609]=0;W(57,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break d}Z();break e}v[b+20|0]=0}if(!y[b+20|0]){d=x[b+24>>2];b=0;c=1;while(1){if(c){c=0;b=x[d+2496>>2];e=(b<<2)+d|0;i=x[((b+397>>>0)%624<<2)+d>>2];h=(b+1>>>0)%624|0;b=x[(h<<2)+d>>2];b=i^(b&2147483647|x[e>>2]&-2147483648)>>>1^0-(b&1)&-1727483681;x[e>>2]=b;x[d+2496>>2]=h;b=b^b>>>11;b=b<<7&-1658038656^b;b=b<<15&-272236544^b;b=b>>>18^b;continue}break}f=b^f}fb=g+16|0;break a}c=N()|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)==1){break b}}Q(c|0);p()}T(0)|0;Sb();p()}return x[a+28>>2]&f}function Kna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=fb-32|0;fb=g;e=fb-16|0;fb=e;c=a+33|0;x[b>>2]=y[c+206|0]|y[c+207|0]<<8;AR(c,b+48|0,y[c+192|0],y[c+200|0],y[c+194|0],y[c+195|0],y[c+196|0],0);AR(c,b+68|0,y[c+193|0],y[c+201|0],y[c+197|0],y[c+198|0],y[c+199|0],1);f=b+236|0;while(1){if((d|0)==96){if(y[c+208|0]){v[b+31|0]=y[c+209|0]+1;f=y[b+31|0];a:{b:{if(!f){d=1;break b}d=16;if(f>>>0<17){break a}}v[b+31|0]=d}w[e+14>>1]=y[c+210|0]|y[c+211|0]<<8;w[e+12>>1]=127;i=b,j=y[Oc(e+14|0,e+12|0)|0]+1|0,v[i+30|0]=j}v[b+33|0]=y[c+212|0];fb=e+16|0}else{i=bc(f,d+12|0),j=y[c+d|0],w[i>>1]=j;d=d+1|0;continue}break}d=b+236|0;while(1){if((h|0)!=96){f=bc(d,h+12|0);e=y[c+h|0];w[f>>1]=e>>>0<(y[a+27|0]|y[a+28|0]<<8)>>>0?e:0;h=h+1|0;continue}break}d=g+8|0;Sk(d,3,a+4|0);c=g+20|0;Cc(c,d);Ac(b+492|0,c);tb(c);if(!y[a+241|0]){v[b+30|0]=y[a+26|0]}fb=g+32|0}function QG(a,b,c){a=a|0;b=b|0;c=c|0;a:{b:{switch(b|0){case 0:pe(a,0,c);break a;case 1:pe(a,1,c);break a;case 2:pe(a,2,c);break a;case 3:pe(a,3,c);break a;case 4:pe(a,4,c);break a;case 5:pe(a,5,c);break a;case 6:pe(a,6,c);break a;case 7:pe(a,7,c);break a;case 8:pe(a,8,c);break a;case 9:pe(a,9,c);break a;case 10:pe(a,10,c);break a;case 11:pe(a,11,c);break a;case 12:pe(a,12,c);break a;case 13:pe(a,13,c);break a;case 14:pe(a,14,c);break a;case 15:pe(a,15,c);break a;case 16:pe(a,16,c);break a;case 17:pe(a,17,c);break a;case 18:pe(a,18,c);break a;case 19:pe(a,19,c);break a;case 20:PG(a,71392,c);break a;case 21:PG(a,72416,c);break a;case 22:pe(a,20,c);break a;case 23:pe(a,21,c);break a;case 24:pe(a,22,c);break a;case 25:pe(a,23,c);break a;case 26:pe(a,24,c);break a;case 27:pe(a,25,c);break a;case 28:pe(a,26,c);break a;default:break b}}Fb(a)}}function P0(a,b,c){a=a|0;b=b|0;c=c|0;a:{b:{switch(b|0){case 0:te(a,0,c);break a;case 1:te(a,1,c);break a;case 2:te(a,2,c);break a;case 3:te(a,3,c);break a;case 4:te(a,4,c);break a;case 5:te(a,5,c);break a;case 6:te(a,6,c);break a;case 7:te(a,7,c);break a;case 8:te(a,8,c);break a;case 9:te(a,9,c);break a;case 10:te(a,10,c);break a;case 11:te(a,11,c);break a;case 12:te(a,12,c);break a;case 13:te(a,13,c);break a;case 14:te(a,14,c);break a;case 15:te(a,15,c);break a;case 16:te(a,16,c);break a;case 17:te(a,17,c);break a;case 18:te(a,18,c);break a;case 19:te(a,19,c);break a;case 20:O0(a,71392,c);break a;case 21:O0(a,72416,c);break a;case 22:te(a,20,c);break a;case 23:te(a,21,c);break a;case 24:te(a,22,c);break a;case 25:te(a,23,c);break a;case 26:te(a,24,c);break a;case 27:te(a,25,c);break a;case 28:te(a,26,c);break a;default:break b}}Fb(a)}}function TD(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=fb-16|0;fb=h;e=Ab(a);c=vb(h+12|0,x[a+4>>2]);g=vb(h+8|0,x[a>>2]);f=vb(h+4|0,x[b+4>>2]);d=x[c>>2];g=x[g>>2];c=fb+-64|0;fb=c;f=x[f>>2];x[c+56>>2]=f;x[c+60>>2]=d;x[c+52>>2]=f;e=Ag(c+24|0,e,c+52|0,c+56|0);x[c+16>>2]=x[e+8>>2];f=x[e+4>>2];x[c+8>>2]=x[e>>2];x[c+12>>2]=f;zg(c+36|0,c+8|0);while(1){if(Fd(d,g)){WD(N_(x[c+56>>2]),d-20|0);d=O_(c+60|0);O_(c+56|0);d=x[d>>2];continue}break}yg(c+36|0);i=x[c+56>>2];if(!y[c+48|0]){g=fb-16|0;fb=g;d=vb(g+12|0,x[x[c+44>>2]>>2]);j=x[vb(g+8|0,x[x[c+40>>2]>>2])>>2];f=fb-16|0;fb=f;d=x[d>>2];x[f+12>>2]=d;while(1){if(xi(d,j)){e=fb-16|0;fb=e;x[e+12>>2]=d;x[e+12>>2]=x[e+12>>2]+20;fb=e+16|0;ub(N_(x[e+12>>2]));d=x[Qf(f+12|0)>>2];continue}break}fb=f+16|0;fb=g+16|0}fb=c- -64|0;x[b+4>>2]=i;Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=h+16|0}function SU(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=fb-16|0;fb=h;e=Ab(a);c=vb(h+12|0,x[a+4>>2]);g=vb(h+8|0,x[a>>2]);f=vb(h+4|0,x[b+4>>2]);d=x[c>>2];g=x[g>>2];c=fb+-64|0;fb=c;f=x[f>>2];x[c+56>>2]=f;x[c+60>>2]=d;x[c+52>>2]=f;e=Ag(c+24|0,e,c+52|0,c+56|0);x[c+16>>2]=x[e+8>>2];f=x[e+4>>2];x[c+8>>2]=x[e>>2];x[c+12>>2]=f;zg(c+36|0,c+8|0);while(1){if(Fd(d,g)){XB(RU(x[c+56>>2]),gn(d));d=To(c+60|0);To(c+56|0);d=x[d>>2];continue}break}yg(c+36|0);i=x[c+56>>2];if(!y[c+48|0]){g=fb-16|0;fb=g;d=vb(g+12|0,x[x[c+44>>2]>>2]);j=x[vb(g+8|0,x[x[c+40>>2]>>2])>>2];f=fb-16|0;fb=f;d=x[d>>2];x[f+12>>2]=d;while(1){if(xi(d,j)){e=fb-16|0;fb=e;x[e+12>>2]=d;x[e+12>>2]=x[e+12>>2]+32;fb=e+16|0;Bk(RU(x[e+12>>2]));d=x[Zq(f+12|0)>>2];continue}break}fb=f+16|0;fb=g+16|0}fb=c- -64|0;x[b+4>>2]=i;Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=h+16|0}function r_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;g=b-1|0;while(1){a:{if(!c){c=0;break a}if(y[c+g|0]){break a}c=c-1|0;continue}break}b:{if((d|0)!=4){break b}g=0;while(1){if((c|0)==(e|0)){if((f|0)==(g|0)){d=2;if((f|0)==(h|0)){break b}}if(f){d=0;if(!g){break b}}d=f?3:g?1:3}else{c:{d:{e:{d=b+e|0;i=y[d|0];switch(i-10|0){case 0:break d;case 3:break e;default:break c}}f=f+1|0;break c}g=g+1|0}if(e){h=((i|0)==10&y[d-1|0]==13)+h|0}e=e+1|0;continue}break}}f=0;g=(d|0)==2;e=0;while(1){if(c>>>0>e>>>0){e=((g&y[b+e|0]==13)+e|0)+1|0;f=f+1|0;continue}break}sf(a);xs(a,f);g=(d|0)==1?32:13;h=d&-3?13:32;d=(d|0)==2;e=0;while(1){if(c>>>0>e>>>0){f:{g:{h:{i:{f=v[b+e|0];switch(f-10|0){case 1:case 2:break f;case 0:break g;case 3:break h;default:break i}}if(f){break f}f=32;break f}e=d+e|0;f=g;break f}f=h}Qp(a,f);e=e+1|0;continue}break}}function RL(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,m=0,p=0,q=0;o(+a);b=j(1)|0;e=j(0)|0;a:{b:{c:{if(!(((b|0)>0|(b|0)>=0)&b>>>0>1048575)){o(+a);c=j(1)|0;if(!(j(0)|c&2147483647)){return-1/(a*a)}if((b|0)>0|(b|0)>=0){break c}return(a-a)/0}if(b>>>0>2146435071){break a}c=1072693248;k=-1023;if((b|0)!=1072693248){c=b;break b}if(e){break b}return 0}o(+(a*0x40000000000000));b=j(1)|0;e=j(0)|0;c=b;k=-1077}l(0,e|0);c=c+614242|0;l(1,(c&1048575)+1072079006|0);d=+n()+-1;f=d*(d*.5);g=d/(d+2);h=g*g;a=h*h;o(+(d-f));b=j(1)|0;j(0)|0;l(0,0);l(1,b|0);i=+n();m=i*1.4426950407214463;p=+((c>>>20|0)+k|0);q=m+p;a=g*(f+(a*(a*(a*.15313837699209373+.22222198432149784)+.3999999999940942)+h*(a*(a*(a*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)))+(d-i-f);a=q+(m+(p-q)+((a+i)*1.6751713164886512e-10+a*1.4426950407214463))}return a}function Cka(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;f=fb-16|0;fb=f;b=x[a+4>>2];if(Id(y[b+223884|0])){GT(b+223860|0);b=x[a+4>>2]}x[a+24>>2]=0;x[a+28>>2]=0;x[b>>2]=0;c=x[a>>2];x[b+40>>2]=x[c+480196>>2];x[b+44>>2]=x[c+480204>>2];x[b+80>>2]=x[c+480200>>2];c=z[c+480188>>1];x[f+8>>2]=0;x[f+12>>2]=0;d=f+8|0;w[d+4>>1]=65280;x[d>>2]=0;e=fb-16|0;fb=e;x[e+12>>2]=c;b=a+8|0;a:{if(Tn(b)>>>0>=c>>>0){g=x[b>>2];h=ih(g,x[b+4>>2]);x[e+8>>2]=h;i=x[Hb(e+12|0,e+8|0)>>2];while(1){if(i){x[g>>2]=x[d>>2];w[g+4>>1]=z[d+4>>1];i=i-1|0;g=g+8|0;continue}break}if(c>>>0>h>>>0){SS(b,c-h|0,d);break a}Jd(b,x[b>>2]+(c<<3)|0);break a}bU(b);oU(b,is(b,c));SS(b,c,d)}fb=e+16|0;b=0;while(1){c=x[a>>2];if(z[c+480188>>1]<=b>>>0){fb=f+16|0}else{d=D(b,872);Po((d+x[a+4>>2]|0)+616|0,c,b&65535,67108864);c=d+x[a+4>>2]|0;w[c+1432>>1]=0;v[c+1415|0]=0;b=b+1|0;continue}break}}function Vla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=fb-16|0;fb=e;n=x[a+16>>2];o=Gg(b+327720|0,x[b+20>>2],(x[a+88>>2]&16384)>>>14|0);i=x[a+8>>2];j=x[a+12>>2];b=x[a>>2];g=x[a+4>>2];k=x[a+128>>2];if(k){l=Hg(i,j,k);m=hb;f=x[a+76>>2];fg(b,g,vf(i,j,d),hb);h=hb>>>0>f>>>0?d:0}f=a+112|0;p=x[a+24>>2];q=x[a+20>>2];x[e>>2]=b;x[e+4>>2]=g;a:while(1){if(d){g=x[e+4>>2];x[e+8>>2]=x[e>>2];x[e+12>>2]=0;h=h-1|0;l=h?l:0;m=h?m:0;d=d-1|0;g=g+n|0;b=k;while(1)if((b|0)<=0){Pb(f,x[a+120>>2],x[a+124>>2]);b=x[a+116>>2];if(b){ce(f,v[x[e+12>>2]+g|0]<<6);be(f,b);x[f>>2]=x[f>>2];x[f+4>>2]=0}g=x[c>>2];b=Fg(f,o);x[c>>2]=g+D(b,q);x[c+4>>2]=x[c+4>>2]+D(b,p);Pb(e,i,j);c=c+8|0;continue a}else{ce(f,v[x[e+12>>2]+g|0]<<6);be(f,4);Pb(e+8|0,l,m);b=b-1|0;continue}}break}b=x[e+4>>2];x[a>>2]=x[e>>2];x[a+4>>2]=b;fb=e+16|0}function Yqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;if(A[a+4>>2]<A[Ab(a)>>2]){c=fb-16|0;fb=c;a=Z$(c+4|0,a);mD(x[a+4>>2],b);x[a+4>>2]=x[a+4>>2]+28;kc(a);fb=c+16|0;return}h=fb-32|0;fb=h;c=Ab(a);c=X$(h+12|0,Y$(a,Gr(x[a>>2],x[a+4>>2])+1|0),Gr(x[a>>2],x[a+4>>2]),c);mD(x[c+8>>2],b);x[c+8>>2]=x[c+8>>2]+28;g=fb-16|0;fb=g;e=Ab(a);b=vb(g+12|0,x[a+4>>2]);i=vb(g+8|0,x[a>>2]);f=vb(g+4|0,x[c+4>>2]);d=x[b>>2];i=x[i>>2];b=fb+-64|0;fb=b;f=x[f>>2];x[b+56>>2]=f;x[b+60>>2]=d;x[b+52>>2]=f;e=Ag(b+24|0,e,b+52|0,b+56|0);x[b+16>>2]=x[e+8>>2];f=x[e+4>>2];x[b+8>>2]=x[e>>2];x[b+12>>2]=f;zg(b+36|0,b+8|0);while(1){if(Fd(d,i)){mD(pE(x[b+56>>2]),Er(d));d=pw(b+60|0);pw(b+56|0);d=x[d>>2];continue}break}d=b+36|0;yg(d);e=x[b+56>>2];U$(d);fb=b- -64|0;x[c+4>>2]=e;Tb(a,c+4|0);Tb(a+4|0,c+8|0);Tb(Ab(a),nc(c));x[c>>2]=x[c+4>>2];fb=g+16|0;V$(c);fb=h+32|0}function Vja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=fb-32|0;fb=d;e=Fb(d+20|0);a:{b:{c:{if(c>>>0<=63){break c}x[31609]=0;c=R(184,b|0)|0;f=x[31609];x[31609]=0;d:{if((f|0)!=1){x[d+16>>2]=c;if((c|0)>0){break d}x[31609]=0;P(36,a|0,22292)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break b}}break a}x[31609]=0;c=R(202,b|0)|0;f=x[31609];x[31609]=0;if((f|0)!=1){g=d,h=uh(c),x[g+12>>2]=h;c=x[Cd(d+16|0,d+12|0)>>2];x[31609]=0;O(114,e|0,c|0);c=x[31609];x[31609]=0;if((c|0)!=1){break c}}break a}e:{while(1){f:{x[31609]=0;c=R(197,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break f}if(!c){break e}x[31609]=0;U(890,e|0,1,((c-65&255)>>>0<26?c|32:c)<<24>>24)|0;c=x[31609];x[31609]=0;if((c|0)!=1){continue}}break}break a}x[31609]=0;P(183,b|0,4)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}Uc(a,e)}tb(e);fb=d+32|0;return}a=N()|0;tb(e);Q(a|0);p()}function Vj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;if(A[a+4>>2]<A[Ab(a)>>2]){c=fb-16|0;fb=c;a=Z$(c+4|0,a);qE(x[a+4>>2],b);x[a+4>>2]=x[a+4>>2]+28;kc(a);fb=c+16|0;return}h=fb-32|0;fb=h;c=Ab(a);c=X$(h+12|0,Y$(a,Gr(x[a>>2],x[a+4>>2])+1|0),Gr(x[a>>2],x[a+4>>2]),c);qE(x[c+8>>2],b);x[c+8>>2]=x[c+8>>2]+28;g=fb-16|0;fb=g;e=Ab(a);b=vb(g+12|0,x[a+4>>2]);i=vb(g+8|0,x[a>>2]);f=vb(g+4|0,x[c+4>>2]);d=x[b>>2];i=x[i>>2];b=fb+-64|0;fb=b;f=x[f>>2];x[b+56>>2]=f;x[b+60>>2]=d;x[b+52>>2]=f;e=Ag(b+24|0,e,b+52|0,b+56|0);x[b+16>>2]=x[e+8>>2];f=x[e+4>>2];x[b+8>>2]=x[e>>2];x[b+12>>2]=f;zg(b+36|0,b+8|0);while(1){if(Fd(d,i)){qE(pE(x[b+56>>2]),Er(d));d=pw(b+60|0);pw(b+56|0);d=x[d>>2];continue}break}d=b+36|0;yg(d);e=x[b+56>>2];U$(d);fb=b- -64|0;x[c+4>>2]=e;Tb(a,c+4|0);Tb(a+4|0,c+8|0);Tb(Ab(a),nc(c));x[c>>2]=x[c+4>>2];fb=g+16|0;V$(c);fb=h+32|0}function Vw(a,b,c,d){var e=0,f=0,g=0,h=0;g=fb-16|0;fb=g;a:{if(!c){break a}if(d){b=Zb(g+8|0,a,b);a=fb-16|0;fb=a;x[a+12>>2]=c;d=x[b+4>>2];b:{if(!d){d=x[b>>2];break b}c=32-d|0;x[a+8>>2]=c;e=x[b>>2];h=c;c=x[Hb(a+8|0,a+12|0)>>2];x[e>>2]=-1<<d&-1>>>h-c|x[e>>2];c=x[a+12>>2]-c|0;x[a+12>>2]=c;d=e+4|0;x[b>>2]=d}x[a+4>>2]=-1;e=d;d=c>>>5|0;KF(e,d,a+4|0);e=x[a+12>>2];c=c&-32;f=e-c|0;x[a+12>>2]=f;if((c|0)!=(e|0)){c=b;b=x[b>>2]+(d<<2)|0;x[c>>2]=b;x[b>>2]=x[b>>2]|-1>>>32-f}fb=a+16|0;break a}b=Zb(g,a,b);a=fb-16|0;fb=a;x[a+12>>2]=c;d=x[b+4>>2];c:{if(!d){d=x[b>>2];break c}e=32-d|0;x[a+8>>2]=e;c=x[b>>2];f=x[c>>2];h=e;e=x[Hb(a+8|0,a+12|0)>>2];x[c>>2]=(-1<<d&-1>>>h-e^-1)&f;f=x[a+12>>2];d=c+4|0;x[b>>2]=d;c=f-e|0}e=d;d=c>>>5|0;JF(e,d);c=c&31;x[a+12>>2]=c;if(c){e=b;b=x[b>>2]+(d<<2)|0;x[e>>2]=b;x[b>>2]=x[b>>2]&(-1>>>32-c^-1)}fb=a+16|0}fb=g+16|0}function by(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;b=a;a:{if(b&3){while(1){c=y[b|0];if(!c|(c|0)==61){break a}b=b+1|0;if(b&3){continue}break}}c=x[b>>2];b:{if((c^-1)&c-16843009&-2139062144){break b}while(1){if((c^1027423549)-16843009&(c^-1)&-2139062144){break b}c=x[b+4>>2];b=b+4|0;if(!(c-16843009&(c^-1)&-2139062144)){continue}break}}while(1){c=b;d=y[b|0];if((d|0)!=61){b=b+1|0;if(d){continue}}break}b=c}if((a|0)==(b|0)){return 0}f=b-a|0;c:{if(y[f+a|0]){break c}e=x[125414];if(!e){break c}b=x[e>>2];if(!b){break c}while(1){d:{g=a;c=b;h=f;d=0;e:{if(!f){break e}d=y[a|0];if(d){f:{while(1){i=y[c|0];if((i|0)!=(d|0)|!i){break f}h=h-1|0;if(!h){break f}c=c+1|0;d=y[g+1|0];g=g+1|0;if(d){continue}break}d=0}}else{d=0}d=d-y[c|0]|0}if(!d){b=b+f|0;if(y[b|0]==61){break d}}b=x[e+4>>2];e=e+4|0;if(b){continue}break c}break}j=b+1|0}return j}function xua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;nd(b,0);x[b>>2]=y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24);c=Mr(a+4|0,a);d=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);x[b+4>>2]=d;c=Mr(a+8|0,a);f=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);x[b+8>>2]=f;c=(y[a+15|0]|y[a+16|0]<<8)<<1;x[b+24>>2]=c;c=y[a+15|0]|y[a+16|0]<<8?c:16726;x[b+24>>2]=c;g=b,h=(D(xw(v[a+17|0],y[a+14|0]<<28>>24),c)>>>0)/8363|0,x[g+24>>2]=h;v[e+15|0]=y[a+18|0];v[e+14|0]=127;g=b,h=(((y[Qb(e+15|0,e+14|0)|0]<<8|64)&65344)>>>0)/127|0,w[g+30>>1]=h;c=y[a+14|0];if(c>>>0>=16){w[b+34>>1]=32;w[b+28>>1]=c&240}c=y[a+19|0];if(c&4){w[b+34>>1]=z[b+34>>1]|1;c=y[a+19|0]}a:{if(!(c&8)|d>>>0>=f>>>0){break a}f=z[b+34>>1];d=f|2;w[b+34>>1]=d;c=y[a+19|0];if(c&16){d=f|6;w[b+34>>1]=d;c=y[a+19|0]}if(!(c&64)){break a}w[b+34>>1]=d|128}fb=e+16|0}function rka(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=fb-880|0;fb=b;c=Rb(a,0,76);x[c+84>>2]=0;x[c+88>>2]=0;x[c+80>>2]=256;v[c+78|0]=0;w[c+76>>1]=65535;x[c+92>>2]=0;x[c+96>>2]=0;v[c+100|0]=1;a=616;while(1){ZV(a+c|0);a=a+872|0;if((a|0)!=223848){continue}break}e=Nb(c+223848|0);g=iB(c+223860|0);f=b+8|0;Rb(f,0,108);rC(b+120|0,48e3);Rb(b+664|0,0,72);v[b+754|0]=0;w[b+752>>1]=65535;v[b+746|0]=0;w[b+744>>1]=65535;v[b+738|0]=0;w[b+736>>1]=65535;x[b+748>>2]=0;x[b+740>>2]=0;Rb(b+756|0,0,103);x[b+868>>2]=0;x[b+872>>2]=0;v[b+875|0]=0;v[b+876|0]=0;v[b+877|0]=0;v[b+878|0]=0;x[b+860>>2]=0;x[b+864>>2]=0;v[b+859|0]=y[b+859|0]&128;a=c+616|0;d=((a+223232|0)-a|0)/872|0;while(1){if((d|0)>0){d=d-1|0;a=Fq(a,f)+872|0;continue}break}x[31609]=0;O(553,e|0,32);a=x[31609];x[31609]=0;if((a|0)!=1){fb=b+880|0;return c|0}a=N()|0;Gq(g);ec(e);Q(a|0);p()}function Jma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=fb-16|0;fb=b;f=x[a+40>>2];g=x[a+36>>2];k=x[a+16>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;l=x[a+32>>2];m=x[a+28>>2];n=x[a+8>>2];o=x[a+12>>2];while(1){if(d){e=x[b+8>>2];i=((((x[b+12>>2]&2147483647)<<1|e>>>31)&2147483646)<<1)+k|0;e=e>>>21&2040;p=w[e+38086>>1];q=w[e+38084>>1];r=w[e+38082>>1];e=w[e+38080>>1];h=0;while(1){if((h|0)!=2){j=h<<1;x[(h<<2)+b>>2]=(((D(w[j+i>>1],r)+D(w[(j|-4)+i>>1],e)|0)+D(w[(j|4)+i>>1],q)|0)+D(w[(j|8)+i>>1],p)|0)/16384;h=h+1|0;continue}break}g=g+m|0;x[c>>2]=x[c>>2]+D(x[b>>2],g>>12);f=f+l|0;x[c+4>>2]=x[c+4>>2]+D(x[b+4>>2],f>>12);Pb(b+8|0,n,o);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;x[a+40>>2]=f;x[a+20>>2]=g>>12;x[a+36>>2]=g;x[a+24>>2]=f>>12;fb=b+16|0}function XL(a,b,c,d){var e=0,f=E(0),g=0,h=E(0),i=0,j=0,k=0,l=E(0),m=E(0),n=E(0),o=0;e=fb-96|0;fb=e;o=(d|0)>0?d:0;while(1){if((j|0)!=(o|0)){B[e+48>>2]=-B[a>>2];B[e>>2]=B[a+68>>2];d=0;while(1){if((d|0)!=4){i=d<<3;k=i+(e+48|0)|0;g=(d<<4)+a|0;h=B[g+4>>2];f=B[g+8>>2];B[k+4>>2]=h+f;B[(8-(d<<1)<<2)+e>>2]=h-f;h=B[g+16>>2];f=B[g+12>>2];B[(i^28)+e>>2]=h-f;B[k+8>>2]=-E(h+f);d=d+1|0;continue}break}WL(e+48|0);WL(e);B[e+4>>2]=-B[e+4>>2];B[e+12>>2]=-B[e+12>>2];B[e+20>>2]=-B[e+20>>2];B[e+28>>2]=-B[e+28>>2];g=0;while(1){if((g|0)!=9){d=g<<2;i=d+b|0;h=B[i>>2];f=B[d+(e+48|0)>>2];l=B[d+87344>>2];m=B[d+87380>>2];n=B[d+e>>2];B[i>>2]=E(f*l)-E(m*n);i=a+d|0;d=c+d|0;f=E(E(f*m)+E(n*l));B[i>>2]=E(h*B[d>>2])-E(B[d+36>>2]*f);B[(17-g<<2)+a>>2]=E(h*B[d+36>>2])+E(f*B[d>>2]);g=g+1|0;continue}break}b=b+36|0;a=a+72|0;j=j+1|0;continue}break}fb=e+96|0}function RP(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=E(0),k=0,l=E(0),m=0,n=0,o=0,p=E(0);d=a+4208|0;j=E(E(B[yb(d,2)>>2]*E(2999.9990234375))+E(.0010000000474974513));l=E(B[yb(d,3)>>2]*E(.9980000257492065));f=-3e3/(+A[x[a+16>>2]+24620>>2]*+j);h=a+4272|0;c=ok(10,f*+A[yb(h,4)>>2]);d=a+4232|0;o=yb(d,0),p=E(c),B[o>>2]=p;c=ok(10,f*+A[yb(h,5)>>2]);o=yb(d,1),p=E(c),B[o>>2]=p;m=f*(1/+E(l+E(.0010000000474974513))+-1);c=0;while(1){if((e|0)==4){e=a+4208|0;f=ok(10,+PP(B[yb(e,0)>>2])*.05);b=4/M(c)*f;c=ok(10,+PP(B[yb(e,1)>>2])*.1);B[a+4228>>2]=b*M(c);B[a+4224>>2]=f*M(1-c)}else{g=yb(h,e);k=e>>>1|0;n=x[yb(h,k|4)>>2];g=x[g>>2];i=ok(10,m*+(n+g>>>0));b=ok(10,f*+(g>>>0));j=B[yb(d,k)>>2];g=e<<1;i=(1-i)*.5;o=yb(d,g+2|0),p=E(b*(1-i)),B[o>>2]=p;o=yb(d,g+3|0),p=E(b*i),B[o>>2]=p;b=b*+j;b=b*(b*(b*(b+1)+1)+1)+1;c=b*b+c;e=e+1|0;continue}break}}function tO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=fb+-64|0;fb=e;a:{b:{if((b|0)>=0){d=x[a+24>>2];if(Ij(Xb(x[d+484360>>2],y[d+484376|0]))>>>0>b>>>0){break b}}a=a+16|0;break a}d=0;c:{f=x[a+24>>2];g=x[f+484344>>2];i=x[f+484348>>2];h=z[bc(x[Xb(x[f+484360>>2],y[f+484376|0])>>2],b)>>1];if(!Cn(g,i,h)){break c}if((c|0)>=0){d=c;if((d|0)<x[Wb(g,h)+12>>2]){break c}}a=a+16|0;break a}w[f+1074448>>1]=b;c=f;f=b&65535;bS(c,f);c=x[a+24>>2];x[c+1074392>>2]=-2;x[c+1074428>>2]=d;g=y[a+64|0];b=e+24|0;w[b+4>>1]=0;v[b+6|0]=255;x[b+16>>2]=2;x[b>>2]=0;w[b+12>>1]=f;x[b+8>>2]=d;d=x[b+20>>2];x[e+16>>2]=x[b+16>>2];x[e+20>>2]=d;d=x[b+12>>2];x[e+8>>2]=x[b+8>>2];x[e+12>>2]=d;d=x[b+4>>2];x[e>>2]=x[b>>2];x[e+4>>2]=d;b=e+52|0;Fv(b,c,g?7:1,e);j=a,k=C[gn(x[e+56>>2])>>3],C[j+16>>3]=k;Si(b);a=a+16|0}fb=e- -64|0;return+C[a>>3]}function d5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=sJ(a,0);f=fb-16|0;fb=f;c=4;a=_I(e+12|0,b);while(1){Fb(a+c|0);d=172;c=c+12|0;if((c|0)!=172){continue}break}while(1){Fb(a+d|0);c=460;d=d+12|0;if((d|0)!=460){continue}break}while(1){Fb(a+c|0);c=c+12|0;if((c|0)!=484){continue}break}c=Fb(a+484|0);d=Fb(a+496|0);h=Fb(a+508|0);i=Fb(a+520|0);x[31609]=0;b=P(1378,f+4|0,b|0)|0;g=x[31609];x[31609]=0;a:{b:{c:{if((g|0)!=1){x[31609]=0;O(1379,a|0,b|0);g=x[31609];x[31609]=0;if((g|0)==1){break c}ct(b);fb=f+16|0;break a}e=N()|0;break b}e=N()|0;ct(b)}Ub(i);Ub(h);Ub(d);Ub(c);d=484;while(1){d=d-12|0;Ub(a+d|0);c=460;if((d|0)!=460){continue}break}while(1){c=c-12|0;Ub(a+c|0);d=172;if((c|0)!=172){continue}break}while(1){d=d-12|0;Ub(a+d|0);if((d|0)!=4){continue}break}bt(a);Q(e|0);p()}x[e+8>>2]=100132;x[e>>2]=100056;return e|0}function f5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=tJ(a,0);f=fb-32|0;fb=f;c=4;a=_I(e+12|0,b);while(1){Fb(a+c|0);d=172;c=c+12|0;if((c|0)!=172){continue}break}while(1){Fb(a+d|0);c=460;d=d+12|0;if((d|0)!=460){continue}break}while(1){Fb(a+c|0);c=c+12|0;if((c|0)!=484){continue}break}c=Fb(a+484|0);d=Fb(a+496|0);h=Fb(a+508|0);i=Fb(a+520|0);x[31609]=0;b=P(1376,f+12|0,b|0)|0;g=x[31609];x[31609]=0;a:{b:{c:{if((g|0)!=1){x[31609]=0;O(1377,a|0,b|0);g=x[31609];x[31609]=0;if((g|0)==1){break c}$s(b);fb=f+32|0;break a}e=N()|0;break b}e=N()|0;$s(b)}tb(i);tb(h);tb(d);tb(c);d=484;while(1){d=d-12|0;tb(a+d|0);c=460;if((d|0)!=460){continue}break}while(1){c=c-12|0;tb(a+c|0);d=172;if((c|0)!=172){continue}break}while(1){d=d-12|0;tb(a+d|0);if((d|0)!=4){continue}break}bt(a);Q(e|0);p()}x[e+8>>2]=99836;x[e>>2]=99760;return e|0}function AR(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;k=fb-16|0;fb=k;v[k+15|0]=c;v[k+14|0]=12;fh(b,y[Qb(k+15|0,k+14|0)|0]);c=0;l=x[b>>2];m=x[b+4>>2];p=Sd(l,m);while(1){if((c|0)==(p|0)){c=0;v[b+12|0]=0;a:{if(!(d&1)){break a}if(mc(l,m)){break a}c=1;v[b+12|0]=1}if(e>>>0<=11){if(d&2){c=c|4;v[b+12|0]=c}v[b+15|0]=e;v[b+16|0]=e}if(!(g>>>0>11|f>>>0>g>>>0)){if(d&4){v[b+12|0]=c|2}v[b+14|0]=g;v[b+13|0]=f}fb=k+16|0}else{b:{c:{d:{switch(h|0){case 0:j=yb(l,c);i=(c<<2)+a|0;w[j>>1]=y[i+96|0]|y[i+97|0]<<8;i=i+98|0;break c;case 1:break d;default:break b}}j=yb(l,c);i=(c<<2)+a|0;w[j>>1]=y[i+144|0]|y[i+145|0]<<8;i=i+146|0}v[j+2|0]=y[i|0]}e:{if(!c){break e}i=yb(l,c);j=z[i>>1];n=yb(l,c-1|0);o=z[n>>1];if(j>>>0>255|j>>>0>=o>>>0){break e}j=j|o&65280;w[i>>1]=j;if(j>>>0>=z[n>>1]){break e}w[i>>1]=j+256}c=c+1|0;continue}break}}function Aja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;nd(c,0);w[c+28>>1]=y[a+36|0]<<2;d=y[a+37|0];w[c+32>>1]=64;w[c+30>>1]=d<<2;x[c>>2]=y[a+40|0]|y[a+41|0]<<8|(y[a+42|0]<<16|y[a+43|0]<<24);x[c+4>>2]=y[a+44|0]|y[a+45|0]<<8|(y[a+46|0]<<16|y[a+47|0]<<24);x[c+8>>2]=y[a+48|0]|y[a+49|0]<<8|(y[a+50|0]<<16|y[a+51|0]<<24);x[c+24>>2]=y[a+52|0]|y[a+53|0]<<8|(y[a+54|0]<<16|y[a+55|0]<<24);d=y[b+151|0];if(d>>>0<=4){v[c+38|0]=y[d+41114|0]}d=y[b+152|0]|y[b+153|0]<<8;v[c+39|0]=d;e=(y[b+156|0]|y[b+157|0]<<8)>>>4|0;v[c+41|0]=e;b=(y[b+154|0]|y[b+155|0]<<8)>>>2|0;v[c+40|0]=b;if((b|e)&255){v[c+39|0]=d^-1}b=y[a+38|0]|y[a+39|0]<<8;if(b&4){w[c+34>>1]=z[c+34>>1]|1;b=y[a+38|0]|y[a+39|0]<<8}if(b&8){w[c+34>>1]=z[c+34>>1]|2;b=y[a+38|0]|y[a+39|0]<<8}if(b&16){w[c+34>>1]=z[c+34>>1]|4;b=y[a+38|0]|y[a+39|0]<<8}if(b&32){w[c+34>>1]=z[c+34>>1]|32}}function k7(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=fb-16|0;fb=k;a:{if(a){a=TJ(c);b:{if(b){b=k+4|0;ml(b,a);c=x[k+4>>2];v[d|0]=c;v[d+1|0]=c>>>8;v[d+2|0]=c>>>16;v[d+3|0]=c>>>24;ll(b,a);break b}b=k+4|0;jt(b,a);c=x[k+4>>2];v[d|0]=c;v[d+1|0]=c>>>8;v[d+2|0]=c>>>16;v[d+3|0]=c>>>24;fi(b,a)}nh(i,b);Ub(b);l=e,m=nj(a),x[l>>2]=m;l=f,m=oj(a),x[l>>2]=m;b=k+4|0;sh(b,a);zb(g,b);tb(b);gi(b,a);nh(h,b);Ub(b);a=Lk(a);break a}a=SJ(c);c:{if(b){b=k+4|0;ml(b,a);c=x[k+4>>2];v[d|0]=c;v[d+1|0]=c>>>8;v[d+2|0]=c>>>16;v[d+3|0]=c>>>24;ll(b,a);break c}b=k+4|0;jt(b,a);c=x[k+4>>2];v[d|0]=c;v[d+1|0]=c>>>8;v[d+2|0]=c>>>16;v[d+3|0]=c>>>24;fi(b,a)}nh(i,b);Ub(b);l=e,m=nj(a),x[l>>2]=m;l=f,m=oj(a),x[l>>2]=m;b=k+4|0;sh(b,a);zb(g,b);tb(b);gi(b,a);nh(h,b);Ub(b);a=Lk(a)}x[j>>2]=a;fb=k+16|0}function yK(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=fb-32|0;fb=i;a:{b:{c:{if((b|0)!=(c|0)){k=x[31484];x[31484]=0;g=fb-16|0;fb=g;Od();f=fb-16|0;fb=f;e=fb-16|0;fb=e;_x(e,b,i+28|0,2);h=x[e>>2];j=x[e+4>>2];b=f;f=x[e+12>>2];x[b+8>>2]=x[e+8>>2];x[b+12>>2]=f;x[b>>2]=h;x[b+4>>2]=j;fb=e+16|0;f=x[b>>2];h=x[b+4>>2];e=g;g=x[b+12>>2];x[e+8>>2]=x[b+8>>2];x[e+12>>2]=g;x[e>>2]=f;x[e+4>>2]=h;fb=b+16|0;g=x[e>>2];f=x[e+4>>2];h=x[e+12>>2];b=i;x[b+16>>2]=x[e+8>>2];x[b+20>>2]=h;x[b+8>>2]=g;x[b+12>>2]=f;fb=e+16|0;e=x[b+16>>2];f=x[b+20>>2];g=x[b+8>>2];h=x[b+12>>2];j=x[31484];if(!j){break c}if(x[b+28>>2]!=(c|0)){break b}l=g;m=h;n=e;o=f;if((j|0)!=68){break a}break b}x[d>>2]=4;break a}x[31484]=k;if(x[i+28>>2]==(c|0)){break a}}x[d>>2]=4;g=l;h=m;e=n;f=o}x[a>>2]=g;x[a+4>>2]=h;x[a+8>>2]=e;x[a+12>>2]=f;fb=i+32|0}function o7(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=fb-16|0;fb=k;a:{if(a){a=WJ(c);b:{if(b){b=k+4|0;ml(b,a);c=x[k+4>>2];v[d|0]=c;v[d+1|0]=c>>>8;v[d+2|0]=c>>>16;v[d+3|0]=c>>>24;ll(b,a);break b}b=k+4|0;jt(b,a);c=x[k+4>>2];v[d|0]=c;v[d+1|0]=c>>>8;v[d+2|0]=c>>>16;v[d+3|0]=c>>>24;fi(b,a)}zb(i,b);tb(b);l=e,m=nj(a),v[l|0]=m;l=f,m=oj(a),v[l|0]=m;b=k+4|0;sh(b,a);zb(g,b);tb(b);gi(b,a);zb(h,b);tb(b);a=Lk(a);break a}a=VJ(c);c:{if(b){b=k+4|0;ml(b,a);c=x[k+4>>2];v[d|0]=c;v[d+1|0]=c>>>8;v[d+2|0]=c>>>16;v[d+3|0]=c>>>24;ll(b,a);break c}b=k+4|0;jt(b,a);c=x[k+4>>2];v[d|0]=c;v[d+1|0]=c>>>8;v[d+2|0]=c>>>16;v[d+3|0]=c>>>24;fi(b,a)}zb(i,b);tb(b);l=e,m=nj(a),v[l|0]=m;l=f,m=oj(a),v[l|0]=m;b=k+4|0;sh(b,a);zb(g,b);tb(b);gi(b,a);zb(h,b);tb(b);a=Lk(a)}x[j>>2]=a;fb=k+16|0}function Bq(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0;c=fb-16|0;fb=c;b=x[a+24620>>2];a:{b:{switch(y[a+480224|0]-1|0){default:x[c+8>>2]=1;x[c>>2]=x[a+1074420>>2]<<1;d=Iua(b,b>>31,5e4,0);e=hb;b=x[bd(c+8|0,c)>>2];b=Gc(Jua(d,e,b,b>>31),hb);x[a+1074404>>2]=b;break a;case 1:x[c+8>>2]=1;x[c+12>>2]=0;g=c,h=Iua(x[a+1074420>>2],0,Iua(x[a+1074408>>2],0,x[a+1074416>>2],0),hb),x[g>>2]=h;x[c+4>>2]=hb;b=Iua(b,0,6e5,0);f=c+8|0;e=b;d=hb;b=Sw(x[f>>2],x[f+4>>2],x[c>>2],x[c+4>>2])?c:f;b=Kua(e,d,x[b>>2],x[b+4>>2]);x[a+1074404>>2]=b;break a;case 0:break b}}x[c+8>>2]=1;x[c>>2]=x[a+1074420>>2];d=Iua(b,b>>31,1e4,0);e=hb;b=x[bd(c+8|0,c)>>2];b=Gc(Jua(d,e,b,b>>31),hb);x[a+1074404>>2]=b}f=a+1074404|0;a=x[a+480244>>2];b=Iua(a,a>>31,b,b>>31);a=hb;b=b+32768|0;a=b>>>0<32768?a+1|0:a;a=Gc(Jua(b,a,65536,0),hb);x[f>>2]=a>>>0<=1?1:a;fb=c+16|0}function Zja(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;b=fb-48|0;fb=b;e=Nb(a);a=0;a:{while(1){b:{if((a|0)==432){a=0;break b}c=a+30564|0;g=qc(b+40|0,x[c>>2]);d=x[b+44>>2];c:{if(!d){break c}f=x[e+4>>2];if(!mc(x[e>>2],f)){g=x[g>>2];f=qc(b+32|0,x[xf(f)>>2]);h=x[f+4>>2];x[b+8>>2]=x[f>>2];x[b+12>>2]=h;if(Ic(g,d,b+8|0)){break c}}x[31609]=0;O(886,e|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}}a=a+8|0;continue}break}d:{while(1){if((a|0)==48){break d}c=qc(b+40|0,x[a+31e3>>2]);e:{g=x[b+44>>2];f:{if(!g){break f}d=x[e+4>>2];if(!mc(x[e>>2],d)){f=x[c>>2];d=qc(b+24|0,x[xf(d)>>2]);h=x[d+4>>2];x[b>>2]=x[d>>2];x[b+4>>2]=h;if(Ic(f,g,b)){break f}}c=x[c>>2];x[31609]=0;x[b+20>>2]=c;O(887,e|0,b+20|0);c=x[31609];x[31609]=0;if((c|0)==1){break e}}a=a+12|0;continue}break}break a}fb=b+48|0;return}a=N()|0;wc(e);Q(a|0);p()}function p3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;f=Nb(a);a=0;a:{b:{c:{while(1){if((Rx(b,c,a)|0)==-1){break b}g=Rx(b,c,a);x[31609]=0;e=d+4|0;V(100,e|0,b|0,a|0,g-a|0);g=x[31609];x[31609]=0;if((g|0)!=1){x[31609]=0;O(101,f|0,e|0);g=x[31609];x[31609]=0;if((g|0)==1){break c}tb(e);a=Rx(b,c,a)+_c(x[c+4>>2],y[c+11|0])|0;continue}break}a=N()|0;break a}a=N()|0;tb(d+4|0);break a}d:{e:{f:{g:{if(mc(x[f>>2],x[f+4>>2])){x[31609]=0;c=d+4|0;V(100,c|0,b|0,a|0,-1);e=x[31609];x[31609]=0;if((e|0)==1){break f}e=_c(x[d+8>>2],y[d+15|0]);tb(c);if(!e){break g}}x[31609]=0;c=d+4|0;V(100,c|0,b|0,a|0,-1);a=x[31609];x[31609]=0;if((a|0)==1){break e}x[31609]=0;O(101,f|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break d}tb(c)}fb=d+16|0;return}a=N()|0;break a}a=N()|0;break a}a=N()|0;tb(d+4|0)}Td(f);Q(a|0);p()}function Bra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=fb-16|0;fb=f;c=If(a,c);ae(f,x[a+36>>2]);j=a;a:{if(!c){Qc(f,a+32|0,5);d=0;if(Gb(x[x[f>>2]>>2],x[f+4>>2])){break a}}d=fb-32|0;fb=d;h=x[a+36>>2];e=d+30|0;ng(h,e);b:{c:{d:{e:{a=z[d+30>>1];if(a>>>0>=4001){k=x[b+12>>2];a=fb-16|0;fb=a;g=d+4|0;i=uc(a+4|0,15994);Uc(g,i);tb(i);fb=a+16|0;x[31609]=0;a=d+16|0;S(490,a|0,g|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break e}e=x[k+1298472>>2];x[31609]=0;S(385,e|0,2,a|0);e=x[31609];x[31609]=0;if((e|0)==1){break d}tb(a);Eb(g);a=4e3}vg(Nj(x[b>>2],0),a);a=Nj(x[b>>2],0);b=wb(x[a>>2]);x[d+16>>2]=b;a=wb(x[a+4>>2]);break b}b=N()|0;break c}b=N()|0;tb(d+16|0)}Eb(d+4|0);Q(b|0);p()}while(1){if(Ib(b,a)){ng(h,d+4|0);w[b>>1]=z[d+4>>1];b=x[ge(d+16|0)>>2];continue}break}fb=d+32|0;d=c}ef(j,d);fb=f+16|0}function Ofa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=fb-32|0;fb=e;x[31609]=0;W(996,a|0);d=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{g:{if((d|0)==1){break g}x[31609]=0;W(997,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break g}x[31609]=0;W(997,c|0);d=x[31609];x[31609]=0;if((d|0)==1){break g}f=x[a+24>>2];x[31609]=0;d=P(36,e+20|0,b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break g}x[31609]=0;c=P(36,e+8|0,c|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break f}x[31609]=0;V(1012,f|0,d|0,c|0,1);b=x[31609];x[31609]=0;if((b|0)==1){break e}tb(c);tb(d);b=1;break b}b=T(0)|0;break c}b=T(0)|0;break d}b=T(0)|0;tb(c)}tb(d)}Y(b|0)|0;b=0;x[31609]=0;V(983,6409,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z()}fb=e+32|0;return b|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Kma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=fb-16|0;fb=b;g=x[a+40>>2];h=x[a+36>>2];j=x[a+16>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;k=x[a+32>>2];l=x[a+28>>2];m=x[a+8>>2];n=x[a+12>>2];while(1){if(d){e=x[b+8>>2];i=(((x[b+12>>2]&2147483647)<<1|e>>>31)&-2)+j|0;e=e>>>21&2040;o=w[e+38086>>1];p=w[e+38084>>1];q=w[e+38082>>1];e=w[e+38080>>1];f=0;while(1){if((f|0)!=2){x[(f<<2)+b>>2]=(((D(v[f+i|0],q)+D(v[(f|-2)+i|0],e)|0)+D(v[(f|2)+i|0],p)|0)+D(v[(f|4)+i|0],o)<<8)/16384;f=f+1|0;continue}break}h=h+l|0;x[c>>2]=x[c>>2]+D(x[b>>2],h>>12);g=g+k|0;x[c+4>>2]=x[c+4>>2]+D(x[b+4>>2],g>>12);Pb(b+8|0,m,n);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;x[a+40>>2]=g;x[a+20>>2]=h>>12;x[a+36>>2]=h;x[a+24>>2]=g>>12;fb=b+16|0}function gW(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=fb-16|0;fb=g;n=x[a+20>>2];h=z[a+34>>1]&65;x[g+12>>2]=h;x[g+8>>2]=h^65;h=b;i=1074992;k=Aj(d);o=a+4|0;p=a+12|0;q=a+8|0;r=a+16|0;while(1){if((i|0)!=1298224){e=d+i|0;if(x[e+104>>2]==(a|0)){if(x[e+16>>2]){x[e+16>>2]=h}if(A[e+4>>2]>c>>>0){x[e>>2]=0;x[e+4>>2]=0}b=a;if(x[e+76>>2]){xc(e+76|0,c);b=x[e+104>>2]}f=x[e+88>>2];b=VF(f,b);j=x[(b?p:o)>>2];x[e+84>>2]=x[(b?r:q)>>2];x[e+80>>2]=j;b=f|x[g+12>>2];x[e+88>>2]=b;x[e+88>>2]=b&(x[g+8>>2]^-1);f=x[e+704>>2];b=x[a+24>>2];a:{if(!f|!b){break a}if(yn(x[d+480180>>2])){break a}j=Iua(x[e+700>>2],0,k?b:f,0);f=k?f:b;l=j+(f>>>1|0)|0;m=hb;s=e,t=Bc(Kua(l,j>>>0>l>>>0?m+1|0:m,f,0),hb),x[s+700>>2]=t}x[e+704>>2]=b}i=i+872|0;continue}break}x[a>>2]=c;x[a+20>>2]=h;dC(n);fb=g+16|0}function ema(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=fb-16|0;fb=e;g=x[a+40>>2];h=x[a+36>>2];j=x[a+16>>2];i=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=i;k=b+24|0;l=x[a+32>>2];m=x[a+28>>2];i=x[a+8>>2];n=x[a+12>>2];while(1){if(d){b=x[e+8>>2];f=(x[e+12>>2]<<1)+j|0;b=(((b>>>16|0)+4&131064)<<1)+k|0;b=(((((D(w[f+4>>1],w[b+10>>1])+D(w[f+2>>1],w[b+8>>1])|0)+D(w[f+6>>1],w[b+12>>1])|0)+D(w[f+8>>1],w[b+14>>1])|0)/2|0)+((((D(w[f-4>>1],w[b+2>>1])+D(w[f-6>>1],w[b>>1])|0)+D(w[f-2>>1],w[b+4>>1])|0)+D(w[f>>1],w[b+6>>1])|0)/2|0)|0)/16384|0;h=h+m|0;x[c>>2]=x[c>>2]+D(b,h>>12);g=g+l|0;x[c+4>>2]=x[c+4>>2]+D(b,g>>12);Pb(e+8|0,i,n);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;x[a+40>>2]=g;x[a+20>>2]=h>>12;x[a+36>>2]=h;x[a+24>>2]=g>>12;fb=e+16|0}function Fga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;b=Li(a,b,c,d);x[b+4260>>2]=0;x[b>>2]=45148;d=4504;while(1){Nb(b+d|0);d=d+24|0;if((d|0)!=4960){continue}break}v[b+5046|0]=1;w[b+5044>>1]=0;a=b+4208|0;e=yb(a,0),f=1063675494,x[e>>2]=f;e=yb(a,1),f=1065185444,x[e>>2]=f;e=yb(a,2),f=0,x[e>>2]=f;e=yb(a,3),f=1032805417,x[e>>2]=f;e=yb(a,4),f=1053079357,x[e>>2]=f;e=yb(a,5),f=1059859440,x[e>>2]=f;e=yb(a,6),f=1047457519,x[e>>2]=f;e=yb(a,7),f=1062836634,x[e>>2]=f;e=yb(a,8),f=1038174126,x[e>>2]=f;e=yb(a,9),f=1065353216,x[e>>2]=f;e=yb(a,10),f=1065353216,x[e>>2]=f;e=yb(a,11),f=1048525618,x[e>>2]=f;e=yb(a,12),f=1059760811,x[e>>2]=f;x[31609]=0;O(941,b+44|0,2);a=x[31609];x[31609]=0;if((a|0)==1){a=N()|0;d=4960;while(1){d=d-24|0;wc(b+d|0);if((d|0)!=4504){continue}break}_f(b);Q(a|0);p()}return b|0}function Yn(a,b,c,d){var e=0,f=0;f=fb-16|0;fb=f;x[31609]=0;W(996,a|0);e=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((e|0)!=1){e=x[a+24>>2];x[31609]=0;O(d|0,f+4|0,e|0);d=x[31609];x[31609]=0;if((d|0)==1){break i}d=x[f+4>>2];e=Ud(d,x[f+8>>2]);if(e>>>0<2147483647){break h}d=ac(8);x[31609]=0;b=P(1051,d|0,7429)|0;e=x[31609];x[31609]=0;if((e|0)==1){break g}x[31609]=0;S(97,b|0,124900,162);b=x[31609];x[31609]=0;if((b|0)!=1){break b}b=T(0)|0;break f}b=T(0)|0;break e}b=T(0)|0;break e}j:{if(b>>>0>=e>>>0){b=Cg(22292);break j}b=Cg(Kb(Vd(d,b)))}Td(f+4|0);break d}b=T(0)|0;ic(d)}Td(f+4|0)}Y(b|0)|0;b=0;x[31609]=0;V(983,c|0,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Z()}fb=f+16|0;return b}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break a}T(0)|0;Sb()}p()}Q(a|0);p()}function rr(a,b){var c=0;c=fb-16|0;fb=c;a=bs(a);a:{b:{c:{switch(b-1|0){default:if((b|0)!=16777216){break b}Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(Lb(a,7,1),9,1),10,1),13,1),15,1),16,1),17,1),18,1),20,1),21,1),24,1),25,1),26,1),28,1),30,1),31,1),33,1),34,1),39,1),41,1),44,1),46,1),45,1),47,1),48,1),50,1),99,1),102,1),104,1),105,1),115,1);break a;case 1:RA(c,2);b=x[c+12>>2];x[a+8>>2]=x[c+8>>2];x[a+12>>2]=b;b=x[c+4>>2];x[a>>2]=x[c>>2];x[a+4>>2]=b;bg(a,107);break a;case 3:RA(c,4);b=x[c+12>>2];x[a+8>>2]=x[c+8>>2];x[a+12>>2]=b;b=x[c+4>>2];x[a>>2]=x[c>>2];x[a+4>>2]=b;bg(a,4);break a;case 2:break b;case 0:break c}}Lb(a,88,1);break a}RA(c,b);b=x[c+12>>2];x[a+8>>2]=x[c+8>>2];x[a+12>>2]=b;b=x[c+4>>2];x[a>>2]=x[c>>2];x[a+4>>2]=b}fb=c+16|0}function eB(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;d=z[a+480188>>1];h=d>>>0<=256?256:d;f=x[a+1298300>>2];c=d;a:{while(1){if((c|0)!=(h|0)){e=D(c,872)+a|0;if(!x[e+1075068>>2]){if(!Cj(x[e+1075648>>2])|y[e+1075081|0]&24){break a}}if(y[e+1075081|0]&2){if(!Ed(f)){break a}if(!OS(f,c&65535)){break a}}c=c+1|0;continue}break}g=8388608;if(b>>>0<=255){b=D(b,872)+a|0;if(!x[b+1075688>>2]){c=65535;if(x[b+1075068>>2]){break a}}g=x[b+1075680>>2]|x[b+1075672>>2]<<9}e=0;c=65535;while(1){if((d|0)==(h|0)){break a}b=D(d,872)+a|0;if(!(x[b+1075688>>2]?0:x[b+1075068>>2])){f=(x[b+1075680>>2]|x[b+1075672>>2]<<9)>>>(x[b+1075080>>2]>>>1&1)|0;b:{c:{if(f>>>0<g>>>0){b=x[b+1075716>>2];break c}if((f|0)!=(g|0)){break b}b=x[b+1075716>>2];if(e>>>0>=b>>>0){break b}}g=f;c=d;e=b}d=d+1|0;continue}break}c=d}return c&65535}function Iia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;a:{b:{if((hk(x[a>>2],x[a+4>>2])|0)==2){if((hk(x[a+12>>2],x[a+16>>2])|0)==(b|0)){break b}}x[31609]=0;O(943,a|0,2);c=x[31609];x[31609]=0;c:{if((c|0)==1){break c}x[31609]=0;O(943,a+12|0,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break c}x[31609]=0;O(944,a+24|0,2);c=x[31609];x[31609]=0;if((c|0)==1){break c}x[31609]=0;O(944,a+36|0,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break c}c=a;while(1)if((d|0)==2){a=0;while(1){if((a|0)==(b|0)){break b}d=_r(x[c+12>>2],a);f=yb(x[c+36>>2],a),g=d,x[f>>2]=g;a=a+1|0;continue}}else{e=_r(x[a>>2],d);f=yb(x[a+24>>2],d),g=e,x[f>>2]=g;d=d+1|0;continue}}b=T(124540)|0;if((gb|0)!=($(124540)|0)){break a}Y(b|0)|0;Nc(a);PQ(a);b=a+12|0;Nc(b);PQ(b);b=a+24|0;Nc(b);OQ(b);a=a+36|0;Nc(a);OQ(a);Z()}return}Q(b|0);p()}function td(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;b=x[a+112>>2];d=x[a+116>>2];i=!!(b|d);h=b;e=x[a+4>>2];f=x[a+44>>2];b=e-f|0;g=b;c=b+x[a+120>>2]|0;b=x[a+124>>2]+(b>>31)|0;a:{b=c>>>0<g>>>0?b+1|0:b;if(!(((b|0)>=(d|0)&c>>>0>=h>>>0|(b|0)>(d|0))&i)){i=yt(a);if((i|0)>=0){break a}e=x[a+4>>2];f=x[a+44>>2]}x[a+112>>2]=-1;x[a+116>>2]=-1;x[a+104>>2]=e;g=c;c=f-e|0;d=g+c|0;b=(c>>31)+b|0;x[a+120>>2]=d;x[a+124>>2]=c>>>0>d>>>0?b+1|0:b;return-1}d=c+1|0;b=d?b:b+1|0;h=x[a+4>>2];f=x[a+8>>2];c=x[a+116>>2];g=c;e=x[a+112>>2];b:{if(!(c|e)){break b}c=e-d|0;e=g-(b+(d>>>0>e>>>0)|0)|0;j=f-h|0;g=j>>31;if((e|0)>=(g|0)&c>>>0>=j>>>0|(e|0)>(g|0)){break b}f=c+h|0}x[a+104>>2]=f;c=x[a+44>>2];f=c-h|0;d=f+d|0;b=(f>>31)+b|0;x[a+120>>2]=d;x[a+124>>2]=d>>>0<f>>>0?b+1|0:b;if(c>>>0>=h>>>0){v[h-1|0]=i}return i}function Zia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=fb-16|0;fb=f;l=If(a,c);ae(f,x[a+36>>2]);m=a;a:{if(!l){Qc(f,a+32|0,5);c=0;if(Gb(x[x[f>>2]>>2],x[f+4>>2])){break a}}e=fb-48|0;fb=e;j=x[a+36>>2];pl(j,e+40|0);h=x[e+44>>2];if(!h&A[e+40>>2]>=257|h){x[e+40>>2]=256;x[e+44>>2]=0}h=x[e+40>>2];n=x[e+44>>2];c=0;b:{c:{d:{e:{while(1){if(!n&c>>>0>=h>>>0){break b}i=e+38|0;ng(j,i);a=Fb(e+24|0);x[31609]=0;P(498,j|0,a|0)|0;g=x[31609];x[31609]=0;if((g|0)!=1){x[31609]=0;g=e+12|0;S(496,g|0,d|0,a|0);k=x[31609];x[31609]=0;if((k|0)==1){break e}x[31609]=0;i=P(931,b|0,i|0)|0;k=x[31609];x[31609]=0;if((k|0)==1){break d}zb(i,g);tb(g);tb(a);c=c+1|0;continue}break}c=N()|0;break c}c=N()|0;break c}c=N()|0;tb(e+12|0)}tb(a);Q(c|0);p()}fb=e+48|0;c=l}ef(m,c);fb=f+16|0}function Yha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=E(0);c=fb-4112|0;fb=c;h=ib[x[x[a>>2]+120>>2]](a)|0;if(!h){ib[x[x[a>>2]+124>>2]](a)}x[c+12>>2]=0;f=fb-16|0;fb=f;while(1){d=x[a+44>>2];if(hk(d,x[a+48>>2])>>>0<=e>>>0){fb=f+16|0}else{x[f+12>>2]=0;d=_r(d,e);g=(d+2048|0)-d>>2;while(1){if((g|0)>0){B[d>>2]=B[f+12>>2];g=g-1|0;d=d+4|0;continue}break}e=e+1|0;continue}break}f=c+2064|0;a:while(1){if(b){x[c+8>>2]=b;xc(c+8|0,512);e=c+16|0;VA(e);d=x[c+8>>2];ib[x[x[a>>2]+60>>2]](a,e,f,d);e=0;while(1)if((e|0)==(d|0)){b=b-d|0;continue a}else{g=(c+16|0)+(e<<2)|0;B[c+4>>2]=F(B[g>>2]);i=c,j=B[Xz(c+12|0,c+4|0)>>2],B[i+12>>2]=j;B[c+4>>2]=F(B[g+2048>>2]);i=c,j=B[Xz(c+12|0,c+4|0)>>2],B[i+12>>2]=j;e=e+1|0;continue}}break}if(!h){ib[x[x[a>>2]+128>>2]](a)}fb=c+4112|0;return E(B[c+12>>2])}function upa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=fb+-64|0;fb=c;i=c,j=jf(a)>>>5|0,w[i+32>>1]=j;w[c+20>>1]=3999;d=z[Oc(c+32|0,c+20|0)>>1];w[b+480190>>1]=d;g=1;while(1){f=g&65535;if(f>>>0<=d>>>0){d=oi(b,f);e=c+32|0;wr(a,e);nd(d,0);h=c+8|0;qi(h,2,e);e=c+20|0;Cc(e,h);Ac(((f<<5)+b|0)+946304|0,e);tb(e);x[d+24>>2]=8287;i=c,j=Bb(y[c+60|0]|y[c+61|0]<<8),w[i+20>>1]=j;w[c+8>>1]=64;i=d,j=z[Oc(e,h)>>1]<<2,w[i+30>>1]=j;i=d,j=$b(y[c+52|0]|y[c+53|0]<<8|(y[c+54|0]<<16|y[c+55|0]<<24))&-2,x[i>>2]=j;e=Bb(y[c+62|0]|y[c+63|0]<<8);i=yb(d+68|0,0),j=e,x[i>>2]=j;e=Bb(y[c+56|0]|y[c+57|0]<<8);f=Bb(y[c+58|0]|y[c+59|0]<<8);a:{if(f>>>0<2){break a}f=e+f<<1;if(f>>>0>A[d>>2]){break a}x[d+16>>2]=f;x[d+12>>2]=e<<1;w[d+34>>1]=z[d+34>>1]|8}g=g+1|0;d=z[b+480190>>1];continue}break}fb=c- -64|0}function PT(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;g=fb-16|0;fb=g;c=vb(g+12|0,x[a+4>>2]);d=vb(g+8|0,x[a>>2]);e=x[vb(g+4|0,x[b+4>>2])>>2];h=fb-16|0;fb=h;j=h+8|0;f=fb-32|0;fb=f;fd(f+24|0,x[c>>2],x[d>>2]);k=f+16|0;c=x[f+24>>2];l=x[f+28>>2];d=fb-16|0;fb=d;x[d+8>>2]=e;x[d+12>>2]=c;while(1){if(Fd(c,l)){c=MT(c);e=MT(x[d+8>>2]);i=y[c+3|0]|y[c+4|0]<<8|(y[c+5|0]<<16|y[c+6|0]<<24);v[e+3|0]=i;v[e+4|0]=i>>>8;v[e+5|0]=i>>>16;v[e+6|0]=i>>>24;c=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);v[e|0]=c;v[e+1|0]=c>>>8;v[e+2|0]=c>>>16;v[e+3|0]=c>>>24;c=LT(d+12|0);LT(d+8|0);c=x[c>>2];continue}break}rc(k,c,d+8|0);fb=d+16|0;c=x[f+16>>2];x[f+12>>2]=x[f+20>>2];rc(j,c,f+12|0);fb=f+32|0;fb=h+16|0;x[b+4>>2]=x[h+12>>2];Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=g+16|0}function fma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=fb-16|0;fb=e;g=x[a+40>>2];h=x[a+36>>2];j=x[a+16>>2];i=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=i;k=b+24|0;l=x[a+32>>2];m=x[a+28>>2];i=x[a+8>>2];n=x[a+12>>2];while(1){if(d){b=x[e+8>>2];f=x[e+12>>2]+j|0;b=(((b>>>16|0)+4&131064)<<1)+k|0;b=((((D(v[f+2|0],w[b+10>>1])+D(v[f+1|0],w[b+8>>1])|0)+D(v[f+3|0],w[b+12>>1])|0)+D(v[f+4|0],w[b+14>>1])<<8>>1)+(((D(v[f-2|0],w[b+2>>1])+D(v[f-3|0],w[b>>1])|0)+D(v[f-1|0],w[b+4>>1])|0)+D(v[f|0],w[b+6>>1])<<8>>1)|0)/16384|0;h=h+m|0;x[c>>2]=x[c>>2]+D(b,h>>12);g=g+l|0;x[c+4>>2]=x[c+4>>2]+D(b,g>>12);Pb(e+8|0,i,n);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;x[a+40>>2]=g;x[a+20>>2]=h>>12;x[a+36>>2]=h;x[a+24>>2]=g>>12;fb=e+16|0}function KK(a,b){var c=0,d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;g=x[124115];if(x[b+72>>2]<=0){My(b)}x[124115]=x[b+136>>2];a:{b:{c:{if(a>>>0<=127){d:{if(x[b+80>>2]==(a|0)){break d}c=x[b+20>>2];if((c|0)==x[b+16>>2]){break d}x[b+20>>2]=c+1;v[c|0]=a;break a}d=fb-16|0;fb=d;v[d+15|0]=a;c=x[b+16>>2];e:{if(!c){c=-1;if(Jw(b)){break e}c=x[b+16>>2]}f:{f=x[b+20>>2];if((c|0)==(f|0)){break f}c=a&255;if((c|0)==x[b+80>>2]){break f}x[b+20>>2]=f+1;v[f|0]=a;break e}c=-1;if((ib[x[b+36>>2]](b,d+15|0,1)|0)!=1){break e}c=y[d+15|0]}fb=d+16|0;a=c;break c}c=x[b+20>>2];if(A[b+16>>2]>c+4>>>0){c=Kt(c,a);if((c|0)<0){break b}x[b+20>>2]=c+x[b+20>>2];break c}d=e+12|0;c=Kt(d,a);if((c|0)<0){break b}if(vw(d,c,b)>>>0<c>>>0){break b}}if((a|0)!=-1){break a}}x[b>>2]=x[b>>2]|32;a=-1}x[124115]=g;fb=e+16|0;return a}function eha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=E(0),g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=E(0),o=E(0),p=0,q=0,r=0,s=0;h=fb-16|0;fb=h;if(ui(a+44|0)){g=x[a+44>>2];r=h,s=Hc(g,0),x[r+8>>2]=s;r=h,s=Hc(g,1),x[r+12>>2]=s;g=x[a+56>>2];l=Hc(g,0);x[h>>2]=l;m=Hc(g,1);x[h+4>>2]=m;p=y[a+4273|0];q=y[a+4272|0];g=d;while(1){k=0;if(g){while(1){if((k|0)!=2){j=k<<2;i=j+(h+8|0)|0;e=x[i>>2];x[i>>2]=e+4;f=E(B[e>>2]*B[a+4240>>2]);e=a+j|0;i=e+4228|0;f=E(f+E(B[i>>2]*B[a+4236>>2]));B[i>>2]=f;f=fQ(E(f*E(1073741824)),q,p);i=e+4244|0;e=e+4252|0;n=B[e>>2];o=B[a+4264>>2];f=E(E(E(f*B[a+4260>>2])-E(B[a+4268>>2]*B[i>>2]))-E(n*o));B[e>>2]=f;B[i>>2]=n+E(f*o);e=h+j|0;j=x[e>>2];x[e>>2]=j+4;B[j>>2]=f*E(9.313225746154785e-10);k=k+1|0;continue}break}g=g-1|0;continue}else{Ki(a,b,c,l,m,d)}break}}fb=h+16|0}function Xca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=fb+-64|0;fb=e;x[e+60>>2]=c;a=re(a,e+60|0);c=tc(a+4|0);g=tc(a+24|0);h=tc(a+32|0);i=Nb(a+36|0);x[a+56>>2]=3;j=Nb(a+68|0);x[31609]=0;O(991,a|0,d|0);f=x[31609];x[31609]=0;a:{b:{c:{d:{if((f|0)!=1){se(e+24|0,x[b>>2],x[b+4>>2]);lf(e+32|0,x[e+24>>2],x[e+28>>2]);b=Md(e+16|0);x[31609]=0;f=x[b+4>>2];x[e+8>>2]=x[b>>2];x[e+12>>2]=f;b=e+40|0;Ks(995,b,x[e+32>>2],x[e+36>>2],e+8|0);f=x[31609];x[31609]=0;if((f|0)==1){break d}x[31609]=0;S(992,a|0,b|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break c}ub(b);x[31609]=0;W(993,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}}d=N()|0;break b}d=N()|0;break b}d=N()|0;ub(e+40|0)}Td(j);nf(i);Bl(h);wh(g);vh(c);Wc(a);Wc(e+60|0);Q(d|0);p()}Wc(e+60|0);fb=e- -64|0;return a|0}function yaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=fb-96|0;fb=d;x[31609]=0;e=x[b+12>>2];x[d+40>>2]=x[b+8>>2];x[d+44>>2]=e;e=x[b+4>>2];x[d+32>>2]=x[b>>2];x[d+36>>2]=e;e=R(1197,d+32|0)|0;f=x[31609];x[31609]=0;if((f|0)!=1){a:{b:{if(e){x[31609]=0;e=d+72|0;O(1198,e|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){b=d+80|0;Ip(b,e);f=Ff(d+88|0,b);g=Ff(d- -64|0,c);h=x[f+4>>2];x[d+8>>2]=x[f>>2];x[d+12>>2]=h;f=x[g+4>>2];x[d>>2]=x[g>>2];x[d+4>>2]=f;Jp(a,d+8|0,d);break b}break a}x[31609]=0;e=d+72|0;O(1199,e|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=d+80|0;Ip(b,e);f=Ff(d+56|0,b);g=Ff(d+48|0,c);h=x[f+4>>2];x[d+24>>2]=x[f>>2];x[d+28>>2]=h;f=x[g+4>>2];x[d+16>>2]=x[g>>2];x[d+20>>2]=f;Jp(a,d+24|0,d+16|0)}me(b);me(e);me(c);fb=d+96|0;return}}a=N()|0;me(c);Q(a|0);p()}function TQ(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;e=fb-16|0;fb=e;if(!(oc(x[a>>2],x[a+4>>2])>>>0>511|x[(x[x[b>>2]-12>>2]+b|0)+16>>2])){d=fb-16|0;fb=d;f=Ec(64);x[31609]=0;g=R(875,f|0)|0;h=x[31609];x[31609]=0;a:{b:{if((h|0)!=1){f=yf(d+8|0,g);g=x[f>>2];x[31609]=0;g=U(938,g|0,b|0,c|0)|0;h=x[31609];x[31609]=0;c:{d:{if((h|0)!=1){if((g|0)==1){break d}tc(d+12|0);break c}a=N()|0;mg(f);break b}re(d+12|0,f)}mg(f);fb=d+16|0;d=x[d+12>>2];break a}a=N()|0;Db(f)}Q(a|0);p()}x[e+12>>2]=d;e:{f:{if(!Ed(d)){x[31609]=0;b=P(936,b|0,c|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break f}x[e+8>>2]=b;b=e+8|0;BZ(e+12|0,ne(b));mg(b);d=x[e+12>>2]}if(!Ed(d)){break e}x[31609]=0;O(500,a|0,e+12|0);a=x[31609];x[31609]=0;i=d;if((a|0)!=1){break e}}a=N()|0;mg(e+12|0);Q(a|0);p()}mg(e+12|0)}fb=e+16|0;return i}function Eo(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=x[b+88>>2];d=c|2048;x[b+88>>2]=d;f=x[b+656>>2];if(!(!f|v[b+730|0]&1)){d=c|6144;x[b+88>>2]=d}a:{if(!x[b+76>>2]){break a}b:{if(!(d&8)|c&2048){break b}c=x[b+104>>2];if(!c){break b}e=z[c+34>>1];if(e&2){d=(e&4?d|4:d&-135)|2;x[b+88>>2]=d;e=x[c>>2];x[b+76>>2]=e;g=x[c+4>>2];x[b+80>>2]=g;c=x[c+8>>2];x[b+84>>2]=c;if(c>>>0<e>>>0){x[b+76>>2]=c;h=c}else{h=e}e=x[b+4>>2];if(h>>>0>=e>>>0){break b}x[b>>2]=0;x[b+4>>2]=((e-g>>>0)%(c-g>>>0)|0)+g;break b}d=d&-135;x[b+88>>2]=d;x[b+76>>2]=x[c>>2]}if(!f){break a}if(!(!(y[f+60|0]&2|x[a+480180>>2]&1064964)|!x[f>>2])){x[b+88>>2]=d|4096}if(y[f+65|0]==255|z[b+728>>1]!=65535){break a}i=b,j=gd(Qq(f+48|0,x[b+724>>2],256,64)),w[i+728>>1]=j;i=b,j=z[yb(x[f+48>>2],y[f+65|0])>>1],x[i+724>>2]=j}}function Qq(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=fb-16|0;fb=h;a:{e=x[a>>2];f=x[a+4>>2];if(mc(e,f)){break a}i=Sd(e,f)-1|0;while(1){b:{if(Sd(e,f)-1>>>0>g>>>0){j=Pc(e,f,g);f=x[a+4>>2];e=x[a>>2];if(z[j>>1]<(b|0)){break b}i=g}g=z[Pc(e,f,i)>>1];f=0;x[h+12>>2]=0;c:{if((b|0)>=(g|0)){k=h,l=(y[Pc(x[a>>2],x[a+4>>2],i)+2|0]<<16>>>0)/(d>>>0)|0,x[k+12>>2]=l;break c}e=0;if(i){e=i-1|0;f=(y[Pc(x[a>>2],x[a+4>>2],e)+2|0]<<16>>>0)/(d>>>0)|0;x[h+12>>2]=f;e=z[Pc(x[a>>2],x[a+4>>2],e)>>1]}if((b|0)<=(e|0)|e>>>0>=g>>>0){break c}a=((y[Pc(x[a>>2],x[a+4>>2],i)+2|0]<<16>>>0)/(d>>>0)|0)-f|0;d=a;i=a>>31;a=b-e|0;b=Iua(d,i,a,a>>31);a=g-e|0;k=h,l=Gc(Jua(b,hb,a,a>>31),hb)+f|0,x[k+12>>2]=l}He(h+12|0,0,65536);g=(D(x[h+12>>2],c)+32768|0)/65536|0;break a}g=g+1|0;continue}}fb=h+16|0;return g}function XH(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;d=fb-32|0;fb=d;x[31609]=0;W(996,a|0);e=x[31609];x[31609]=0;a:{b:{c:{if((e|0)!=1){e=Fb(d+20|0);x[31609]=0;W(c|0,d+8|0);c=x[31609];x[31609]=0;d:{e:{if((c|0)!=1){h=d,i=wb(x[d+8>>2]),x[h+4>>2]=i;f=1;while(1){g=wb(x[d+12>>2]);c=x[d+4>>2];if(!Ib(c,g)){c=Cg(Kb(e));Td(d+8|0);tb(e);break b}if(!f){x[31609]=0;P(985,e|0,14665)|0;c=x[31609];x[31609]=0;if((c|0)==1){break e}c=x[d+4>>2]}x[31609]=0;P(838,e|0,c|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break e}ym(d+4|0);f=0;continue}}c=T(0)|0;break d}c=T(0)|0;Td(d+8|0)}tb(e);break c}c=T(0)|0}Y(c|0)|0;c=0;x[31609]=0;V(983,b|0,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z()}fb=d+32|0;return c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){T(0)|0;Sb();p()}Q(a|0);p()}function N2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=fb-32|0;fb=c;x[c+28>>2]=0;if(Id(y[Hm(c+27|0,a,0)|0])){cd(c+16|0,x[(x[x[a>>2]-12>>2]+a|0)+28>>2]);x[31609]=0;e=R(1223,x[c+16>>2])|0;d=x[31609];x[31609]=0;a:{b:{if((d|0)!=1){d=pp(c+12|0,a);f=tc(c+8|0);g=x[x[a>>2]-12>>2];f=x[f>>2];d=x[d>>2];x[31609]=0;ja(1225,e|0,d|0,f|0,a+g|0,c+28|0,c+20|0);e=x[31609];x[31609]=0;if((e|0)!=1){break b}}b=T(0)|0;_b(c+16|0);Y(b|0)|0;b=x[c+28>>2]|1;x[c+28>>2]=b;Fm(x[x[a>>2]-12>>2]+a|0,b);c:{d:{if(x[(x[x[a>>2]-12>>2]+a|0)+20>>2]&1){x[31609]=0;X(84);a=x[31609];x[31609]=0;if((a|0)!=1){break c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){break d}Q(a|0);p()}Z();break a}T(0)|0;Sb()}p()}_b(c+16|0);x[b>>2]=x[c+20>>2]}Xj(x[x[a>>2]-12>>2]+a|0,x[c+28>>2])}fb=c+32|0;return a|0}function BF(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;x[31609]=0;f=P(21,e+8|0,a|0)|0;d=x[31609];x[31609]=0;a:{b:{c:{if((d|0)!=1){d:{e:{if(!Id(y[f|0])){break e}g=pp(e+4|0,a);d=x[x[a>>2]-12>>2]+a|0;h=x[d+4>>2];x[31609]=0;i=R(22,d|0)|0;j=x[31609];x[31609]=0;if((j|0)==1){break d}g=x[g>>2];x[31609]=0;c=b+c|0;b=ea(23,g|0,b|0,((h&176)==32?c:b)|0,c|0,d|0,i|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break d}if(b){break e}b=x[x[a>>2]-12>>2];x[31609]=0;O(24,a+b|0,5);b=x[31609];x[31609]=0;if((b|0)!=1){break e}break d}hm(f);break b}b=T(0)|0;hm(f);break c}b=T(0)|0}Y(b|0)|0;b=x[x[a>>2]-12>>2];x[31609]=0;W(25,a+b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}Z()}fb=e+16|0;return a}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){T(0)|0;Sb();p()}Q(a|0);p()}function _ca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=fb+-64|0;fb=f;x[f+60>>2]=d;a=re(a,f+60|0);d=tc(a+4|0);g=tc(a+24|0);h=tc(a+32|0);i=Nb(a+36|0);x[a+56>>2]=3;j=Nb(a+68|0);x[31609]=0;O(991,a|0,e|0);k=x[31609];x[31609]=0;a:{b:{c:{d:{if((k|0)!=1){cc(f+24|0,b,c);lf(f+32|0,x[f+24>>2],x[f+28>>2]);b=Md(f+16|0);x[31609]=0;c=x[b+4>>2];x[f+8>>2]=x[b>>2];x[f+12>>2]=c;b=f+40|0;Ks(995,b,x[f+32>>2],x[f+36>>2],f+8|0);c=x[31609];x[31609]=0;if((c|0)==1){break d}x[31609]=0;S(992,a|0,b|0,e|0);c=x[31609];x[31609]=0;if((c|0)==1){break c}ub(b);x[31609]=0;W(993,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}}e=N()|0;break b}e=N()|0;break b}e=N()|0;ub(f+40|0)}Td(j);nf(i);Bl(h);wh(g);vh(d);Wc(a);Wc(f+60|0);Q(e|0);p()}Wc(f+60|0);fb=f- -64|0;return a|0}function M1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;g=fb-16|0;fb=g;dd(b,y[c+32|0]|y[c+33|0]<<8|(y[c+34|0]<<16|y[c+35|0]<<24));h=Nb(a);a=y[c+28|0]|y[c+29|0]<<8|(y[c+30|0]<<16|y[c+31|0]<<24);x[31609]=0;O(179,h|0,a|0);a=x[31609];x[31609]=0;if((a|0)!=1){a:{a=0;while(1){b:{if((y[c+28|0]|y[c+29|0]<<8|(y[c+30|0]<<16|y[c+31|0]<<24))>>>0<=a>>>0){break b}e=x[b+8>>2];f=x[b>>2];x[31609]=0;e=U(150,f|0,e|0,4)|0;f=x[31609];x[31609]=0;if((f|0)==1){break a}if(!e){break b}e=y[c+4|0]|y[c+5|0]<<8;x[31609]=0;e=P(180,b|0,e|0)|0;f=x[31609];x[31609]=0;c:{if((f|0)!=1){x[g+12>>2]=e;if(Ud(x[d>>2],x[d+4>>2])>>>0<=e>>>0){break c}x[31609]=0;O(181,h|0,g+12|0);e=x[31609];x[31609]=0;if((e|0)!=1){break c}}break a}a=a+1|0;continue}break}fb=g+16|0;return}}a=N()|0;wc(h);Q(a|0);p()}function HP(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=fb-48|0;fb=j;k=x[a+4>>2];l=x[a>>2];a=x[a+8>>2];x[j+32>>2]=b;x[j+44>>2]=a;x[j+36>>2]=l;x[j+40>>2]=k;x[31609]=0;a=P(976,(d?d:977)|0,e|0)|0;b=x[31609];x[31609]=0;a:{b:{c:{d:{if((b|0)!=1){x[j+24>>2]=a;a=j+24|0;b=x[re(j+28|0,a)>>2];k=x[j+44>>2];x[j+16>>2]=x[j+40>>2];x[j+20>>2]=k;x[31609]=0;k=x[j+36>>2];x[j+8>>2]=x[j+32>>2];x[j+12>>2]=k;c=+pa(978,j+8|0,+c,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break d}Wc(a);break b}a=T(0)|0;break c}a=T(0)|0;Wc(j+24|0)}Y(a|0)|0;x[31609]=0;ga(979,15142,d|0,e|0,f|0,g|0,h|0,i|0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();c=0}fb=j+48|0;return+c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function BQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=fb-16|0;fb=c;e=x[b+4220>>2];f=x[b+4224>>2];g=x[b+4228>>2];h=x[b+4232>>2];i=x[b+4240>>2];j=x[b+4236>>2];k=y[b+4244|0];Kk(b+4208|0,33);d=x[b+4208>>2];v[d+32|0]=k;v[d+24|0]=j;v[d+25|0]=j>>>8;v[d+26|0]=j>>>16;v[d+27|0]=j>>>24;v[d+28|0]=i;v[d+29|0]=i>>>8;v[d+30|0]=i>>>16;v[d+31|0]=i>>>24;v[d+16|0]=g;v[d+17|0]=g>>>8;v[d+18|0]=g>>>16;v[d+19|0]=g>>>24;v[d+20|0]=h;v[d+21|0]=h>>>8;v[d+22|0]=h>>>16;v[d+23|0]=h>>>24;v[d+8|0]=e;v[d+9|0]=e>>>8;v[d+10|0]=e>>>16;v[d+11|0]=e>>>24;v[d+12|0]=f;v[d+13|0]=f>>>8;v[d+14|0]=f>>>16;v[d+15|0]=f>>>24;v[d|0]=76;v[d+1|0]=70;v[d+2|0]=79;v[d+3|0]=32;v[d+4|0]=0;v[d+5|0]=0;v[d+6|0]=0;v[d+7|0]=0;se(c+8|0,x[b+4208>>2],x[b+4212>>2]);Zb(a,x[c+8>>2],x[c+12>>2]);fb=c+16|0}function v4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=fb-160|0;fb=d;Rb(d+116|0,0,44);while(1){if((c|0)==7){a:{c=0;while(1){if((c|0)==12){break a}x[d+132>>2]=c;e=d+16|0;f=d+116|0;fa(e|0,100,14339,f|0,x[a>>2])|0;g=D(c,12)+a|0;ld(g+172|0,e);fa(e|0,100,13349,f|0,x[a>>2])|0;ld(g+316|0,e);c=c+1|0;continue}}}else{x[d+140>>2]=c;e=d+16|0;f=d+116|0;fa(e|0,100,14352,f|0,x[a>>2])|0;g=D(c,12)+a|0;ld(g+4|0,e);fa(e|0,100,13556,f|0,x[a>>2])|0;ld(g+88|0,e);c=c+1|0;continue}break}x[d+124>>2]=1;c=d+16|0;e=d+116|0;fa(c|0,100,9278,e|0,x[a>>2])|0;ld(a+460|0,c);x[d+124>>2]=13;fa(c|0,100,9278,e|0,x[a>>2])|0;ld(a+472|0,c);c=d+4|0;_s(c,a,99,b);zb(a+484|0,c);tb(c);_s(c,a,114,b);zb(a+496|0,c);tb(c);_s(c,a,120,b);zb(a+508|0,c);tb(d+4|0);_s(c,a,88,b);zb(a+520|0,c);tb(d+4|0);fb=d+160|0}function Bx(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;h=fb-16|0;fb=h;e=Ab(a);c=vb(h+12|0,x[a+4>>2]);f=vb(h+8|0,x[a>>2]);g=vb(h+4|0,x[b+4>>2]);d=x[c>>2];f=x[f>>2];c=fb+-64|0;fb=c;g=x[g>>2];x[c+56>>2]=g;x[c+60>>2]=d;x[c+52>>2]=g;e=Ag(c+24|0,e,c+52|0,c+56|0);x[c+16>>2]=x[e+8>>2];g=x[e+4>>2];x[c+8>>2]=x[e>>2];x[c+12>>2]=g;zg(c+36|0,c+8|0);while(1){if(Fd(d,f)){vs(Op(x[c+56>>2]),cl(d));d=lk(c+60|0);lk(c+56|0);d=x[d>>2];continue}break}yg(c+36|0);g=x[c+56>>2];if(!y[c+48|0]){e=fb-16|0;fb=e;d=vb(e+12|0,x[x[c+44>>2]>>2]);i=x[vb(e+8|0,x[x[c+40>>2]>>2])>>2];f=fb-16|0;fb=f;d=x[d>>2];x[f+12>>2]=d;while(1){if(xi(d,i)){Eb(Ax(d));d=x[ym(f+12|0)>>2];continue}break}fb=f+16|0;fb=e+16|0}fb=c- -64|0;x[b+4>>2]=g;Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=h+16|0}function pja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;e=fb-32|0;fb=e;c=z[x[x[a+48>>2]+12>>2]+480188>>1];a:{if(!b){break a}c=D(b,c);b:{if(x[a+12>>2]!=(b|0)){break b}if((Ik(x[a>>2],x[a+4>>2])|0)!=(c|0)){break b}b=fb-16|0;fb=b;d=wb(x[a>>2]);a=wb(x[a+4>>2]);w[b+12>>1]=0;x[b+8>>2]=0;f=wu(a,d);c=fb-16|0;fb=c;x[c+12>>2]=d;while(1){if((f|0)>0){a=x[c+12>>2];d=y[b+8|0]|y[b+9|0]<<8|(y[b+10|0]<<16|y[b+11|0]<<24);v[a|0]=d;v[a+1|0]=d>>>8;v[a+2|0]=d>>>16;v[a+3|0]=d>>>24;d=y[b+12|0]|y[b+13|0]<<8;v[a+4|0]=d;v[a+5|0]=d>>>8;f=f-1|0;tg(c+12|0);continue}break}fb=c+16|0;fb=b+16|0;break a}w[e+16>>1]=0;x[e+12>>2]=0;c=MZ(e+20|0,c,e+12|0);oR(a);x[a>>2]=x[c>>2];x[a+4>>2]=x[c+4>>2];f=Ab(c);g=Ab(a),h=x[f>>2],x[g>>2]=h;x[f>>2]=0;x[c>>2]=0;x[c+4>>2]=0;Nk(c);x[a+12>>2]=b}fb=e+32|0}function hba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=fb-16|0;fb=d;j=d,k=cN(),x[j+12>>2]=k;h=a+24|0;f=d+12|0;aN(h,ne(f));wh(f);w[a+28>>1]=0;JP();g=fb-16|0;fb=g;i=Ec(144);x[31609]=0;c=P(1128,i|0,4)|0;e=x[31609];x[31609]=0;a:{if((e|0)!=1){e=yf(g+12|0,c);fb=g+16|0;e=x[e>>2];break a}a=N()|0;Db(i);Q(a|0);p()}x[d+12>>2]=e;_M(a+32|0,ne(f));Bl(f);j=d,k=bN(x[a>>2]),x[j+12>>2]=k;ZM(a+4|0,ne(f));vh(f);uo(x[h>>2],x[a+4>>2]);v[a+64|0]=1;x[a+60>>2]=0;x[a+48>>2]=1065353216;x[a+52>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;c=Vi(x[b>>2]);x[d+12>>2]=c;e=Pf(b);b:{while(1){if(!Zg(c,e)){break b}b=ud(c);c=jg(d,b);x[31609]=0;V(1012,a|0,c|0,b+12|0,0);b=x[31609];x[31609]=0;if((b|0)!=1){tb(c);c=x[ah(d+12|0)>>2];continue}break}a=N()|0;tb(c);Q(a|0);p()}fb=d+16|0}function vqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=fb-16|0;fb=e;v[e+15|0]=0;w[e+12>>1]=0;j=8;n=D(c,d)<<1;a:while(1){if((d|0)!=(k|0)){h=(k<<1)+b|0;o=n+h|0;while(1){b:{c:{if(h>>>0<o>>>0){w[e+10>>1]=0;nY(a,e+15|0,e+12|0,j,e+10|0);i=z[e+10>>1];f=z[e+12>>1];c=j;while(1){if(c&255){g=f<<1;f=g&254;d:{if(f){g=(g&65534)>>>0>255;break d}if(!Bf(a,e+9|0)){break c}f=y[e+9|0];g=f>>>7|0;f=f<<1&254|1}c=c-1|0;i=i<<1|g;continue}break}w[e+12>>1]=f;break b}k=k+1|0;continue a}w[e+12>>1]=0}c=1;g=i&65535;e:{if(g>>>0<4){break e}f=15;while(1){c=f;m=f&255;if(m>>>0<2){break e}f=f-1|0;if(!(g&1<<m)){continue}break}}f=i&1;v[e+15|0]=f;l=(f-1^(i&65534)>>>1)+l|0;w[e+10>>1]=l;w[h>>1]=l;h=(d<<1)+h|0;j=(c+j&254)>>>1|0;continue}}break}fb=e+16|0}function WL(a){var b=E(0),c=E(0),d=E(0),e=E(0),f=E(0),g=E(0),h=E(0),i=E(0),j=E(0),k=E(0),l=E(0),m=E(0),n=E(0),o=E(0);f=B[a>>2];i=B[a+24>>2];c=E(f-i);d=B[a+16>>2];b=B[a+32>>2];g=B[a+8>>2];e=E(d+E(b-g));B[a+16>>2]=c+e;j=E(c-E(e*E(.5)));c=B[a+4>>2];e=B[a+20>>2];h=B[a+28>>2];k=E(E(E(c-e)-h)*E(.8660253882408142));B[a+4>>2]=j+k;l=E(E(d-b)*E(.1736481785774231));f=E(f+E(i*E(.5)));i=E(E(g+b)*E(.7660444378852844));m=E(l+E(f-i));n=E(E(c+e)*E(.9848077297210693));b=E(B[a+12>>2]*E(.8660253882408142));c=E(E(c+h)*E(.6427876353263855));o=E(E(n-b)-c);B[a+12>>2]=m+o;B[a+20>>2]=m-o;B[a+28>>2]=j-k;d=E(E(g+d)*E(.9396926164627075));g=E(E(f+d)-l);e=E(E(e-h)*E(.3420201539993286));h=E(E(e-b)-n);B[a+32>>2]=g+h;d=E(E(f-d)+i);b=E(E(b+e)-c);B[a+24>>2]=d+b;B[a+8>>2]=d-b;B[a>>2]=g-h}function As(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;d=fb-32|0;fb=d;x[d+28>>2]=0;a:{b:{c:{if(Id(y[Hm(d+27|0,a,0)|0])){g=d+20|0;cd(g,x[(x[x[a>>2]-12>>2]+a|0)+28>>2]);x[31609]=0;h=R(1223,x[d+20>>2])|0;e=x[31609];x[31609]=0;d:{e:{if((e|0)==1){break e}e=pp(d+16|0,a);f=tc(d+12|0);i=x[x[a>>2]-12>>2];f=x[f>>2];e=x[e>>2];x[31609]=0;ja(c|0,h|0,e|0,f|0,a+i|0,d+28|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break e}_b(g);break d}b=T(0)|0;_b(d+20|0);Y(b|0)|0;b=x[d+28>>2]|1;x[d+28>>2]=b;Fm(x[x[a>>2]-12>>2]+a|0,b);if(x[(x[x[a>>2]-12>>2]+a|0)+20>>2]&1){x[31609]=0;X(84);a=x[31609];x[31609]=0;if((a|0)!=1){break b}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){break c}Q(a|0);p()}Z()}Xj(x[x[a>>2]-12>>2]+a|0,x[d+28>>2])}fb=d+32|0;break a}T(0)|0;Sb()}p()}return a}function wB(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;a:{f=a+1074312|0;if(j=Ob(f,77),k=0,l=x[(D(c,872)+b|0)+704>>2]&67109888,l?j:k){break a}g=x[a+480180>>2]!=2?c:0;e=D(g,872);if(!d){x[(b+e|0)+1380>>2]=x[b+48>>2];return}h=(b+e|0)+1457|0;c=y[h|0];b:{if(c){c=c-1|0;v[h|0]=c;if(c&255){break b}if(!Ob(f,16)&x[a+480180>>2]!=2){break a}x[(D(g,872)+b|0)+1380>>2]=x[b+48>>2]+1;return}c:{if(Ob(f,17)|y[a+480180|0]&3){break c}c=b+616|0;i=e+c|0;e=0;a=z[a+480188>>1];while(1){if(a>>>0<=(e&65535)>>>0){break c}if(y[c+841|0]?(c|0)!=(i|0):0){break a}c=c+872|0;e=e+1|0;continue}}v[h|0]=d}a=x[(D(g,872)+b|0)+1380>>2];x[b+56>>2]=a;if((a|0)==-1){break a}d:{if(x[b+60>>2]==-1){break d}if(!Ob(f,68)){break d}x[b+60>>2]=a}x[b+64>>2]=a;if(!Ob(f,103)){break a}w[b+68>>1]=65535}}function tq(a){var b=E(0),c=0,d=0,e=0,f=0;f=fb-16|0;fb=f;e=(q(a),j(2));c=e&2147483647;a:{if(c>>>0<=1061752794){b=E(1);if(c>>>0<964689920){break a}b=Ai(+a);break a}if(c>>>0<=1081824209){if(c>>>0>=1075235812){b=E(-Ai(((e|0)<0?3.141592653589793:-3.141592653589793)+ +a));break a}d=+a;if((e|0)<0){b=Bi(d+1.5707963267948966);break a}b=Bi(1.5707963267948966-d);break a}if(c>>>0<=1088565717){if(c>>>0>=1085271520){b=Ai(((e|0)<0?6.283185307179586:-6.283185307179586)+ +a);break a}if((e|0)<0){b=Bi(-4.71238898038469-+a);break a}b=Bi(+a+-4.71238898038469);break a}b=E(a-a);if(c>>>0>=2139095040){break a}c=Zy(a,f+8|0);d=C[f+8>>3];b:{switch(c&3){case 0:b=Ai(d);break a;case 1:b=Bi(-d);break a;case 2:b=E(-Ai(d));break a;default:break b}}b=Bi(d)}a=b;fb=f+16|0;return a}function kq(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,m=0;o(+a);b=j(1)|0;f=j(0)|0;a:{b:{c:{if(!(((b|0)>0|(b|0)>=0)&b>>>0>1048575)){o(+a);d=j(1)|0;if(!(j(0)|d&2147483647)){return-1/(a*a)}if((b|0)>0|(b|0)>=0){break c}return(a-a)/0}if(b>>>0>2146435071){break a}d=1072693248;g=-1023;if((b|0)!=1072693248){d=b;break b}if(f){break b}return 0}o(+(a*0x40000000000000));b=j(1)|0;f=j(0)|0;d=b;g=-1077}b=d+614242|0;h=+((b>>>20|0)+g|0);e=h*.6931471803691238;l(0,f|0);l(1,(b&1048575)+1072079006|0);a=+n()+-1;c=a/(a+2);i=e;k=a;m=c;e=a*(a*.5);c=c*c;a=c*c;a=i+(k+(m*(e+(a*(a*(a*.15313837699209373+.22222198432149784)+.3999999999940942)+c*(a*(a*(a*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)))+h*1.9082149292705877e-10-e))}return a}function iQ(a){var b=0,c=0,d=0,e=0;e=fb-16|0;fb=e;d=(q(a),j(2));c=d&2147483647;a:{if(c>>>0<=1061752794){if(c>>>0<964689920){break a}a=Bi(+a);break a}if(c>>>0<=1081824209){b=+a;if(c>>>0<=1075235811){if((d|0)<0){a=E(-Ai(b+1.5707963267948966));break a}a=Ai(b+-1.5707963267948966);break a}a=Bi(-(((d|0)>=0?-3.141592653589793:3.141592653589793)+b));break a}if(c>>>0<=1088565717){if(c>>>0<=1085271519){b=+a;if((d|0)<0){a=Ai(b+4.71238898038469);break a}a=E(-Ai(b+-4.71238898038469));break a}a=Bi(((d|0)<0?6.283185307179586:-6.283185307179586)+ +a);break a}if(c>>>0>=2139095040){a=E(a-a);break a}c=Zy(a,e+8|0);b=C[e+8>>3];b:{switch(c&3){case 0:a=Bi(b);break a;case 1:a=Ai(b);break a;case 2:a=Bi(-b);break a;default:break b}}a=E(-Ai(b))}fb=e+16|0;return a}function Fo(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0;h=fb-16|0;fb=h;if(e){x[e>>2]=0}a:{i=x[a+484344>>2];if(!Je(i,x[a+484348>>2],b)){break a}g=Wb(i,b);k=x[x[g+48>>2]+12>>2];b=md(x[g>>2],k,c,d);f=y[b+5|0];b:{c:{d:{e:{j=y[b+3|0];switch(j-10|0){case 1:case 3:case 5:case 6:break a;case 0:break c;case 2:case 4:case 7:break d;default:break e}}if(j-35>>>0>=2){break a}}x[h+12>>2]=1;i=0;if((j|0)!=17){break b}i=x[a+480180>>2]==4;break b}x[h+12>>2]=2;i=0}x[h+8>>2]=x[g+12>>2]+(c^-1);d=0;a=x[Hb(h+8|0,h+12|0)>>2];c=a;while(1){f:{if(c){b=D(z[k+480188>>1],6)+b|0;if(y[b+3|0]==34){break f}a=d}f=(j-37&255)>>>0<254?f:a?f:f<<8;if(!e){break a}x[e>>2]=a;break a}g=f<<8;f=y[b+5|0]|(i?f>>>0>31?f>>>0<256?g+-8192|0:g:g:g);d=d+1|0;c=c-1|0;continue}}fb=h+16|0;return f}function x_(a,b){var c=0,d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;d=Fb(a);a=zd(b);x[e+12>>2]=a;f=Ef(b);b=0;a:{while(1){b:{if(!Ib(a,f)){if(!b){break b}x[31609]=0;O(35,d|0,65533);a=x[31609];x[31609]=0;if((a|0)!=1){break b}break a}a=y[a|0];c:{d:{if(!b){if(a<<24>>24>=0){b=0;x[31609]=0;O(35,d|0,a|0);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break a}if((a&224)==192){c=a&31;b=1;break c}if((a&240)==224){c=a&15;b=2;break c}c=65533;if((a&248)!=240){break d}c=a&7;b=3;break c}if((a&192)!=128){c=0;x[31609]=0;O(35,d|0,65533);g=x[31609];x[31609]=0;b=0;if((g|0)==1){break a}}c=a&63|c<<6;b=b-1|0;if(b){break c}}b=0;x[31609]=0;O(35,d|0,c|0);a=x[31609];x[31609]=0;c=0;if((a|0)==1){break a}}a=x[we(e+12|0)>>2];continue}break}fb=e+16|0;return}a=N()|0;Ub(d);Q(a|0);p()}function uqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=fb-16|0;fb=e;v[e+15|0]=0;w[e+12>>1]=0;n=D(c,d);j=4;a:while(1){if((d|0)!=(k|0)){h=b+k|0;o=n+h|0;while(1){b:{c:{if(h>>>0<o>>>0){v[e+11|0]=0;mY(a,e+15|0,e+12|0,e+11|0);i=y[e+11|0];f=z[e+12>>1];c=j;while(1){if(c&255){g=f<<1;f=g&254;d:{if(f){g=(g&65534)>>>0>255;break d}if(!Bf(a,e+10|0)){break c}f=y[e+10|0];g=f>>>7|0;f=f<<1&254|1}c=c-1|0;i=i<<1|g;continue}break}w[e+12>>1]=f;break b}k=k+1|0;continue a}w[e+12>>1]=0}c=1;g=i&255;e:{if(g>>>0<4){break e}f=7;while(1){c=f;m=f&255;if(m>>>0<2){break e}f=f-1|0;if(!(g&1<<m)){continue}break}}f=i&1;v[e+15|0]=f;l=(f-1^(i&254)>>>1)+l|0;v[e+11|0]=l;v[h|0]=l;h=d+h|0;j=(c+j&254)>>>1|0;continue}}break}fb=e+16|0}function Cl(a,b,c){var d=0,e=0,f=0,g=0;e=fb-48|0;fb=e;d=x[a+24>>2];g=x[d+24620>>2];a:{if(!((g|0)!=(b|0)|x[d+24624>>2]!=(c|0))){if(y[a+29|0]){break a}UR(d,1);break a}f=e+8|0;zc(f,d+24604|0,40);x[e+28>>2]=c;x[e+24>>2]=b;c=x[e+44>>2];bu(f,x[e+40>>2]);No(f,c);NA(d,f);if((b|0)==(g|0)){break a}c=x[a+24>>2]+906300|0;d=vk(c);while(1){if((c|0)!=(d|0)){b=x[c>>2];b:{if(!b){break b}if(!(ib[x[x[b>>2]+120>>2]](b)|0)){break b}ib[x[x[b>>2]+112>>2]](b,0);ib[x[x[b>>2]+100>>2]](b);ib[x[x[b>>2]+128>>2]](b)}c=c+160|0;continue}break}c=x[a+24>>2]+906300|0;d=vk(c);while(1){if((c|0)!=(d|0)){b=x[c>>2];c:{if(!b){break c}if(ib[x[x[b>>2]+120>>2]](b)|0){break c}ib[x[x[b>>2]+112>>2]](b,1);ib[x[x[b>>2]+124>>2]](b)}c=c+160|0;continue}break}}v[a+29|0]=1;fb=e+48|0}function nk(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=fb-32|0;fb=d;a:{b:{while(1){f=d+8|0;e=c<<2;h=f+e|0;g=1<<c&2147483647;if(g|1){e=vI(c,g?a:22292)}else{e=x[e>>2]}x[h>>2]=e;if((e|0)==-1){break b}c=c+1|0;if((c|0)!=6){continue}break}if(!wI(0)){b=104904;if(!jd(f,104904,24)){break a}b=104928;if(!jd(f,104928,24)){break a}c=0;if(!y[501648]){while(1){i=(c<<2)+501600|0,j=vI(c,22292),x[i>>2]=j;c=c+1|0;if((c|0)!=6){continue}break}v[501648]=1;x[125406]=x[125400]}b=501600;a=d+8|0;if(!jd(a,501600,24)){break a}b=501624;if(!jd(a,501624,24)){break a}b=Gd(24);if(!b){break b}}a=x[d+12>>2];x[b>>2]=x[d+8>>2];x[b+4>>2]=a;a=x[d+28>>2];x[b+16>>2]=x[d+24>>2];x[b+20>>2]=a;a=x[d+20>>2];x[b+8>>2]=x[d+16>>2];x[b+12>>2]=a;break a}b=0}fb=d+32|0;return b}function jS(a,b){var c=E(0),d=E(0),e=E(0);a:{b:{c:{switch(b|0){case 0:Aq(a,E(1));uk(a,E(3.725290298461914e-9));zq(a,E(268435456));yq(a,0);break b;case 1:Aq(a,E(32));uk(a,E(4.656612873077393e-10));zq(a,E(2147483648));yq(a,0);break b;case 2:Aq(a,E(2));uk(a,E(7.450580596923828e-9));zq(a,E(134217728));yq(a,1);break b;default:Aq(a,E(1));uk(a,E(7.450580596923828e-9));zq(a,E(134217728));yq(a,1);GA(a,0);FA(a,1);EA(a,1);d=E(256);c=E(128);e=E(128);b=0;break a;case 4:case 5:break c}}Aq(a,E(.75));uk(a,E(7.450580596923828e-9));zq(a,E(134217728));yq(a,1);GA(a,0);b=(b|0)==4;FA(a,b?2:3);EA(a,1);d=E(256);c=b?E(256):E(192);e=c;b=1;break a}GA(a,1);FA(a,0);EA(a,0);d=E(128);e=E(100);c=E(256);b=4}B[a+16>>2]=c;B[a+20>>2]=e;B[a+24>>2]=d;x[a+28>>2]=b}function vL(a,b,c,d){a:{switch(b-9|0){case 0:b=x[c>>2];x[c>>2]=b+4;x[a>>2]=x[b>>2];return;case 6:b=x[c>>2];x[c>>2]=b+4;b=w[b>>1];x[a>>2]=b;x[a+4>>2]=b>>31;return;case 7:b=x[c>>2];x[c>>2]=b+4;x[a>>2]=z[b>>1];x[a+4>>2]=0;return;case 8:b=x[c>>2];x[c>>2]=b+4;b=v[b|0];x[a>>2]=b;x[a+4>>2]=b>>31;return;case 9:b=x[c>>2];x[c>>2]=b+4;x[a>>2]=y[b|0];x[a+4>>2]=0;return;case 16:b=x[c>>2]+7&-8;x[c>>2]=b+8;C[a>>3]=C[b>>3];return;case 17:ib[d|0](a,c);default:return;case 1:case 4:case 14:b=x[c>>2];x[c>>2]=b+4;b=x[b>>2];x[a>>2]=b;x[a+4>>2]=b>>31;return;case 2:case 5:case 11:case 15:b=x[c>>2];x[c>>2]=b+4;x[a>>2]=x[b>>2];x[a+4>>2]=0;return;case 3:case 10:case 12:case 13:break a}}b=x[c>>2]+7&-8;x[c>>2]=b+8;c=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=c}function eY(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;o=x[b>>2];while(1){if((i|0)==128){vg(b,c);c=x[a+8>>2];d=c+d|0;i=z[e>>1];a:{b:{c:{if(!f){break c}j=f;f=h&65535;if((c+(j+(f<<11)|0)|0)!=(Lh(x[a>>2])&-2)){break c}dd(a,c+(f<<10)|0);if(!VC(a,16,1)){break b}w[e>>1]=8;break b}if((h&65535)==(k&65535)){h=k;break a}f=k<<8&16776960;if(!g){if((Lh(x[a>>2])|0)!=(d+D(f,i)|0)){break a}}dd(a,c+D(f,z[e>>1])|0);h=VC(a,64,1)?h:k}dd(a,c)}c=l&65535;d:{if(c>>>0>(h&65535)>>>0){if((d+(D(c,z[e>>1])<<8)|0)==(Lh(x[a>>2])|0)){break d}}if(c>>>0>=255){UC(b,254,65534);UC(b,255,65535)}l=h}a=l&65535}else{j=z[bc(o,i)>>1];m=j+1|0;n=(h&65535)>>>0>j>>>0|j>>>0>127;k=n?k:c>>>0>i>>>0?m:k;l=(l&65535)>>>0>j>>>0?l:m;h=n?h:m;i=i+1|0;continue}break}return a}function hla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);c=x[b+4>>2];f=c;d=x[b>>2];b=ih(d,c);c=fb-16|0;fb=c;Rd(c+8|0,x[vb(c+4|0,a)>>2]);a:{b:{if(b){x[31609]=0;O(799,a|0,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break b}g=fb-16|0;fb=g;h=fs(g+4|0,a,b);i=x[h+4>>2];e=fb-16|0;fb=e;fd(e+8|0,d,f);f=fb-16|0;fb=f;n=f+8|0;b=fb-32|0;fb=b;fd(b+24|0,x[e+8>>2],x[e+12>>2]);d=fb-16|0;fb=d;j=x[b+28>>2];k=x[b+24>>2];l=j-k|0;m=l>>3;if(m){gl(i,k,m<<3)}x[d+12>>2]=i+l;rc(b+16|0,j,d+12|0);fb=d+16|0;d=x[b+16>>2];x[b+12>>2]=x[b+20>>2];rc(n,d,b+12|0);fb=b+32|0;fb=f+16|0;fb=e+16|0;x[h+4>>2]=x[f+12>>2];kc(h);fb=g+16|0}b=c+8|0;Qd(b);_u(b);fb=c+16|0;break a}a=N()|0;_u(c+8|0);Q(a|0);p()}return a|0}function Fla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=fb-32|0;fb=g;h=a+8|0;c=x[a+8>>2];j=nc(a);a:{if((c|0)!=x[j>>2]){break a}i=a+4|0;d=x[a+4>>2];e=x[a>>2];if(d>>>0>e>>>0){a=((d-e>>2)+1|0)/-2<<2;c=Lv(d,c,a+d|0);x[h>>2]=c;x[i>>2]=a+x[i>>2];break a}x[g+8>>2]=c-e>>1;x[g+28>>2]=1;d=g+8|0;c=x[bd(d,g+28|0)>>2];c=Zf(d,c,c>>>2|0,x[a+16>>2]);d=vb(g+4|0,x[a+4>>2]);f=x[vb(g,x[a+8>>2])>>2];e=x[d>>2];f=Mv(f,e);d=fb-16|0;fb=d;x[d+12>>2]=e;e=Gn(d,c+8|0,f);f=x[e>>2];while(1){if(x[e+4>>2]!=(f|0)){k=f;f=x[d+12>>2];bp(k,z[f>>1]|z[f+2>>1]<<16);f=x[e>>2]+4|0;x[e>>2]=f;We(d+12|0);continue}break}je(e);fb=d+16|0;Tb(a,c);Tb(i,c+4|0);Tb(h,c+8|0);Tb(j,nc(c));Yf(c);c=x[a+8>>2]}bp(c,z[b>>1]|z[b+2>>1]<<16);x[h>>2]=x[h>>2]+4;fb=g+32|0}function fT(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=fb-16|0;fb=e;i=-1;a:{if(!IA(a,b,2)){break a}f=x[b+656>>2];d=a+1074312|0;g=Ob(d,31);h=x[b+740>>2];if(h?0:g){break a}h=h-Ob(d,31)|0;g=x[a+480180>>2];d=(g|0)==4096;j=f+88|0;f=d?64:(g|0)==16384?192:512;d=Qq(j,h,f,d?255:64)-(f>>>1|0)|0;if(y[b+746|0]&16){i=Jq(a,b,!(x[b+88>>2]&32768),d);break a}if(Lj(x[b+656>>2])){if((d|0)==w[b+772>>1]){break a}k=b,l=gd(d),w[k+772>>1]=l;v[b+851|0]=y[b+851|0]|64;break a}a=Aj(a);x[e+12>>2]=d;b:{if((d|0)<0){x[e+12>>2]=0-d;vi(e+12|0,255);a=(x[e+12>>2]<<2)+(a?36528:35504)|0;break b}vi(e+12|0,255);a=(x[e+12>>2]<<2)+(a?35504:36528)|0}a=x[a>>2];b=a;d=a>>31;a=x[c>>2];k=c,l=Gc(Jua(Iua(b,d,a,a>>31),hb,65536,0),hb),x[k>>2]=l}fb=e+16|0;return i}function Rea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=fb-16|0;fb=h;g=Kb(b);e=Cb(x[b+4>>2],y[b+11|0]);i=Kb(c);f=Cb(x[c+4>>2],y[c+11|0]);d=e+g|0;e=-1;a:{while(1){if((d|0)==(g|0)){break a}d=d-1|0;if(rq(i,f,y[d|0])){continue}break}e=d-g|0}b:{c:{if((e|0)!=-1){f=vb(h+12|0,uf(uf(zd(b),e),1));c=vb(h+8|0,Ef(b));Yr(b,x[f>>2],x[c>>2]);break c}if(!_c(x[b+4>>2],y[b+11|0])){break c}i=Kb(b);e=Cb(x[b+4>>2],y[b+11|0]);f=Kb(c);d=Cb(x[c+4>>2],y[c+11|0]);if(!e|!d){c=-1}else{c=i;e=e+c|0;j=d+f|0;while(1){d:{d=f;e:{if((c|0)!=(e|0)){while(1){if((d|0)==(j|0)){break e}g=v[d|0];d=d+1|0;if(!mc(v[c|0],g)){continue}break}}else{c=e}break d}c=c+1|0;continue}break}c=(c|0)==(e|0)?-1:c-i|0}if(c){break c}Fb(a);break b}Uc(a,b)}fb=h+16|0}function p2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=fb-16|0;fb=h;g=Kb(b);e=Cb(x[b+4>>2],y[b+11|0]);i=Kb(c);f=Cb(x[c+4>>2],y[c+11|0]);d=e+g|0;e=-1;a:{while(1){if((d|0)==(g|0)){break a}d=d-1|0;if(Cu(i,f,y[d|0])){continue}break}e=d-g|0}b:{c:{if((e|0)!=-1){f=vb(h+12|0,uf(uf(zd(b),e),1));c=vb(h+8|0,Ef(b));Yr(b,x[f>>2],x[c>>2]);break c}if(!_c(x[b+4>>2],y[b+11|0])){break c}i=Kb(b);e=Cb(x[b+4>>2],y[b+11|0]);f=Kb(c);d=Cb(x[c+4>>2],y[c+11|0]);if(!e|!d){c=-1}else{c=i;e=e+c|0;j=d+f|0;while(1){d:{d=f;e:{if((c|0)!=(e|0)){while(1){if((d|0)==(j|0)){break e}g=y[d|0];d=d+1|0;if(!mc(y[c|0],g)){continue}break}}else{c=e}break d}c=c+1|0;continue}break}c=(c|0)==(e|0)?-1:c-i|0}if(c){break c}Fb(a);break b}Uc(a,b)}fb=h+16|0}function b3(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;d=fb-176|0;fb=d;b=d+12|0;Uk(b,a);x[31609]=0;c=d+24|0;O(102,c|0,b|0);a=x[31609];x[31609]=0;a:{b:{c:{d:{if((a|0)!=1){x[31609]=0;a=P(103,d+36|0,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break d}tb(c);tb(b);b=x[x[a>>2]-12>>2];x[31609]=0;f=ca(104)|0;e=x[31609];x[31609]=0;if((e|0)==1){break b}x[31609]=0;e=d+8|0;S(105,e|0,a+b|0,f|0);b=x[31609];x[31609]=0;if((b|0)==1){break b}_b(e);b=a+x[x[a>>2]-12>>2]|0;x[b+4>>2]=x[b+4>>2]&-75;x[b+4>>2]=x[b+4>>2]|8;x[31609]=0;c=P(106,a|0,c|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break b}a=pk(x[(c+x[x[c>>2]-12>>2]|0)+16>>2]);b=x[d+24>>2];Gf(c);fb=d+176|0;return(a?0:b)|0}c=N()|0;break c}c=N()|0;tb(d+24|0)}tb(d+12|0);break a}c=N()|0;Gf(a)}Q(c|0);p()}function xI(a,b,c,d,e,f){var g=0;g=fb-80|0;fb=g;a:{if((f|0)>=16384){Xd(g+32|0,b,c,d,e,0,0,0,2147352576);d=x[g+40>>2];e=x[g+44>>2];b=x[g+32>>2];c=x[g+36>>2];if(f>>>0<32767){f=f-16383|0;break a}Xd(g+16|0,b,c,d,e,0,0,0,2147352576);f=((f|0)>=49149?49149:f)-32766|0;d=x[g+24>>2];e=x[g+28>>2];b=x[g+16>>2];c=x[g+20>>2];break a}if((f|0)>-16383){break a}Xd(g- -64|0,b,c,d,e,0,0,0,7471104);d=x[g+72>>2];e=x[g+76>>2];b=x[g+64>>2];c=x[g+68>>2];if(f>>>0>4294934644){f=f+16269|0;break a}Xd(g+48|0,b,c,d,e,0,0,0,7471104);f=((f|0)<=-48920?-48920:f)+32538|0;d=x[g+56>>2];e=x[g+60>>2];b=x[g+48>>2];c=x[g+52>>2]}Xd(g,b,c,d,e,0,0,0,f+16383<<16);b=x[g+12>>2];x[a+8>>2]=x[g+8>>2];x[a+12>>2]=b;b=x[g+4>>2];x[a>>2]=x[g>>2];x[a+4>>2]=b;fb=g+80|0}function TB(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0;h=fb-16|0;fb=h;i=Rl(a,b);a:{if((i|0)==255){break a}if(Gj(x[a>>2])){break a}b:{if(c>>>0>6208431){j=7168;c=1023;break b}f=7;c:{if(c>>>0>3104215){break c}f=6;if(c>>>0>1552107){break c}f=5;if(c>>>0>776053){break c}f=4;if(c>>>0>388026){break c}f=3;if(c>>>0>194013){break c}f=2;if(c>>>0>97006){break c}f=c>>>0>48503}j=f<<10;f=20-f|0;g=f&31;if((f&63)>>>0>=32){f=c<<g;c=0}else{f=(1<<g)-1&c>>>32-g;c=c<<g}g=c+24858e3|0;c=f;c=Bc(Kua(g,g>>>0<24858e3?c+1|0:c,49716e3,0),hb)}if(e){w[h+14>>1]=(b&3)+c;w[h+12>>1]=1023;c=z[Oc(h+14|0,h+12|0)>>1]}e=bv(i);f=xb(a+8|0,i);v[f|0]=(c|j)>>>8|(d?0:32);Ah(x[a>>2],x[a+4>>2],b,e|160,c&255);Ah(x[a>>2],x[a+4>>2],b,e|176,y[f|0]);v[a+534|0]=1}fb=h+16|0}function $ka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=fb-16|0;fb=i;e=x[vb(i+12|0,wb(x[a+4>>2]))>>2];f=TT(b,c);h=fb-32|0;fb=h;d=e;e=x[a>>2];e=(kp(d,wb(e))<<1)+e|0;a:{if((f|0)<=0){break a}d=x[Ab(a)>>2];g=x[a+4>>2];if((f|0)<=d-g>>1){d=fb-16|0;fb=d;x[d+12>>2]=b;ST(d+12|0,f);j=x[d+12>>2];fb=d+16|0;d=g-e>>1;if((d|0)<(f|0)){x[h+12>>2]=b;ST(h+12|0,d);j=x[h+12>>2];dv(a,j,c,f-d|0);if((d|0)<=0){break a}}YU(a,e,g,(f<<1)+e|0);aC(b,j,e);break a}c=Ab(a);d=fk(h+12|0,gk(a,$c(x[a>>2],g)+f|0),e-x[a>>2]>>1,c);g=fb-16|0;fb=g;c=Ap(g+4|0,d+8|0,f);f=x[c>>2];while(1){if(x[c+4>>2]!=(f|0)){nm(f,z[b>>1]);f=x[c>>2]+2|0;x[c>>2]=f;b=b+2|0;continue}break}je(c);fb=g+16|0;e=XU(a,d,e);cj(d)}wb(e);fb=h+32|0;fb=i+16|0;return a|0}function wla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=fb-16|0;fb=f;c=If(a,c);ae(f,x[a+36>>2]);i=a;a:{if(!c){Qc(f,a+32|0,5);d=0;if(Gb(x[x[f>>2]>>2],x[f+4>>2])){break a}}g=x[a+36>>2];a=fb-16|0;fb=a;x[a+12>>2]=0;FN(g,a+12|0,1);e=x[a+12>>2];d=e>>>2&3;v[a+11|0]=d;if(d){v[a+4|0]=3;h=a+4|0;d=y[Qb(h,a+11|0)|0];v[a+4|0]=0;v[a|0]=0;v[a+10|0]=0;b:{if(!d){break b}Gi(g,h);if((d|0)==1){break b}Gi(g,a);if(d>>>0<3){break b}Gi(g,a+10|0);j=y[a+10|0]<<24}e=e&255|(y[a+4|0]<<8|y[a|0]<<16|j)}d=e>>>4|0;x[a+4>>2]=d;x[a>>2]=1e6;hC(b,x[Hb(a+4|0,a)>>2]);e=0;while(1){h=Cb(x[b+4>>2],y[b+11|0]);if(h>>>0<=e>>>0){if((d|0)!=(h|0)){Pm(g,d-h|0)}fb=a+16|0}else{wj(g,dc(b,e),1);e=e+1|0;continue}break}d=c}ef(i,d);fb=f+16|0}function _ma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=fb-16|0;fb=b;f=x[a+40>>2];g=x[a+36>>2];l=x[a+16>>2];h=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=h;m=x[a+32>>2];n=x[a+28>>2];h=x[a+8>>2];o=x[a+12>>2];while(1){if(d){e=x[b+8>>2];p=e>>>18|0;i=((((x[b+12>>2]&2147483647)<<1|e>>>31)&2147483646)<<1)+l|0;e=0;while(1){if((e|0)!=2){j=e<<1;k=w[j+i>>1];x[(e<<2)+b>>2]=k+((D(w[(j|4)+i>>1]-k|0,p)|0)/16384|0);e=e+1|0;continue}break}g=g+n|0;x[c>>2]=x[c>>2]+D(x[b>>2],g>>12);f=f+m|0;x[c+4>>2]=x[c+4>>2]+D(x[b+4>>2],f>>12);Pb(b+8|0,h,o);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;x[a+40>>2]=f;x[a+20>>2]=g>>12;x[a+36>>2]=g;x[a+24>>2]=f>>12;fb=b+16|0}function Zy(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=fb-16|0;fb=e;g=(q(a),j(2));c=g&2147483647;a:{if(c>>>0<=1305022426){h=+a;f=h*.6366197723675814+6755399441055744+-6755399441055744;d=h+f*-1.5707963109016418+f*-1.5893254773528196e-8;C[b>>3]=d;g=d<-.7853981852531433;if(F(f)<2147483648){c=~~f}else{c=-2147483648}if(g){d=f+-1;C[b>>3]=h+d*-1.5707963109016418+d*-1.5893254773528196e-8;c=c-1|0;break a}if(!(d>.7853981852531433)){break a}d=f+1;C[b>>3]=h+d*-1.5707963109016418+d*-1.5893254773528196e-8;c=c+1|0;break a}if(c>>>0>=2139095040){C[b>>3]=E(a-a);c=0;break a}i=c;c=(c>>>23|0)-150|0;C[e+8>>3]=(l(2,i-(c<<23)|0),r());c=zL(e+8|0,e,c,1,0);d=C[e>>3];if((g|0)<0){C[b>>3]=-d;c=0-c|0;break a}C[b>>3]=d}fb=e+16|0;return c}function Nma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=fb-16|0;fb=b;i=x[a+24>>2];j=x[a+20>>2];k=x[a+16>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;l=x[a+8>>2];m=x[a+12>>2];while(1){if(d){e=x[b+8>>2];g=((((x[b+12>>2]&2147483647)<<1|e>>>31)&2147483646)<<1)+k|0;e=e>>>21&2040;n=w[e+38086>>1];o=w[e+38084>>1];p=w[e+38082>>1];e=w[e+38080>>1];f=0;while(1){if((f|0)!=2){h=f<<1;x[(f<<2)+b>>2]=(((D(w[h+g>>1],p)+D(w[(h|-4)+g>>1],e)|0)+D(w[(h|4)+g>>1],o)|0)+D(w[(h|8)+g>>1],n)|0)/16384;f=f+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[b>>2],j);x[c+4>>2]=x[c+4>>2]+D(x[b+4>>2],i);Pb(b+8|0,l,m);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;fb=b+16|0}function Zaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=fb+-64|0;fb=d;a=x[a+4>>2];g=d+16|0;ux(g,b);x[31609]=0;b=P(1,d+4|0,18407)|0;e=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{g:{h:{if((e|0)!=1){x[31609]=0;e=d+28|0;S(2,e|0,g|0,b|0);f=x[31609];x[31609]=0;if((f|0)==1){break h}x[31609]=0;f=d+40|0;S(489,f|0,e|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break g}x[31609]=0;c=d+52|0;O(1059,c|0,f|0);h=x[31609];x[31609]=0;if((h|0)==1){break f}h=x[x[a>>2]+8>>2];x[31609]=0;O(h|0,a|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}tb(c);tb(f);tb(e);tb(b);tb(g);fb=d- -64|0;return}a=N()|0;break a}a=N()|0;break b}a=N()|0;break c}a=N()|0;break d}a=N()|0;tb(d+52|0)}tb(d+40|0)}tb(d+28|0)}tb(b)}tb(d+16|0);Q(a|0);p()}function $C(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=fb-16|0;fb=f;e=y[a|0];if(e&1){v[b+12|0]=y[b+12|0]|1;e=y[a|0]}if(e&2){v[b+12|0]=y[b+12|0]|4;e=y[a|0]}if(e&4){v[b+12|0]=y[b+12|0]|2;e=y[a|0]}if(e&16){v[b+12|0]=y[b+12|0]|16;e=y[a|0]}if(e&32){v[b+12|0]=y[b+12|0]|8}v[f+15|0]=y[a+1|0];v[f+14|0]=25;fh(b,y[Qb(f+15|0,f+14|0)|0]);e=y[a+2|0];v[b+15|0]=e;v[b+16|0]=(d|0)==4?e:y[a+3|0];v[b+13|0]=y[a+4|0];v[b+14|0]=y[a+5|0];h=x[b>>2];e=Sd(h,x[b+4>>2]);b=0;while(1){if((b|0)!=(e|0)){i=yb(h,b);g=(b<<2)+a|0;d=y[g+6|0]|y[g+7|0]<<8;w[i>>1]=d;a:{if(!b){break a}j=d;d=z[yb(h,b-1|0)>>1];if(j>>>0>=d>>>0){break a}w[i>>1]=d+1}k=i,l=Yb((y[g+8|0]|y[g+9|0]<<8)<<16>>16>>c,0,64),v[k+2|0]=l;b=b+1|0;continue}break}fb=f+16|0}function WX(a,b){var c=0,d=0,e=0;c=fb-32|0;fb=c;a:{if(!Mb(x[a>>2],x[a+8>>2],1024)){x[c+24>>2]=0;x[c+28>>2]=0;x[c+16>>2]=0;x[c+20>>2]=0;a=64;while(1){if(a){d=y[c+20|0]|y[c+21|0]<<8|(y[c+22|0]<<16|y[c+23|0]<<24);e=y[c+16|0]|y[c+17|0]<<8|(y[c+18|0]<<16|y[c+19|0]<<24);v[b|0]=e;v[b+1|0]=e>>>8;v[b+2|0]=e>>>16;v[b+3|0]=e>>>24;v[b+4|0]=d;v[b+5|0]=d>>>8;v[b+6|0]=d>>>16;v[b+7|0]=d>>>24;d=y[c+28|0]|y[c+29|0]<<8|(y[c+30|0]<<16|y[c+31|0]<<24);e=y[c+24|0]|y[c+25|0]<<8|(y[c+26|0]<<16|y[c+27|0]<<24);v[b+8|0]=e;v[b+9|0]=e>>>8;v[b+10|0]=e>>>16;v[b+11|0]=e>>>24;v[b+12|0]=d;v[b+13|0]=d>>>8;v[b+14|0]=d>>>16;v[b+15|0]=d>>>24;a=a-1|0;b=b+16|0;continue}break}break a}SC(c+8|0,b);sd(c+16|0,a,x[c+8>>2],x[c+12>>2])}fb=c+32|0}function KH(a,b,c,d,e,f){var g=0,h=0,i=E(0),j=0;g=fb-80|0;fb=g;MA(x[a+24>>2]);v[x[a+24>>2]+1298424|0]=x[a+52>>2]!=0;x[g+44>>2]=b;x[g+40>>2]=c;x[g+36>>2]=d;i=B[a+48>>2];j=x[a+32>>2];x[g+8>>2]=b;c=x[g+40>>2];x[g>>2]=x[g+36>>2];x[g+4>>2]=c;d=fb-16|0;fb=d;x[d+8>>2]=x[g+8>>2];c=x[g+4>>2];x[d>>2]=x[g>>2];x[d+4>>2]=c;c=KM(g+48|0);x[c+8>>2]=j;x[c+4>>2]=0;x[c>>2]=f;f=x[d+4>>2];x[c+12>>2]=x[d>>2];x[c+16>>2]=f;x[c+20>>2]=x[d+8>>2];C[c+24>>3]=i;x[c>>2]=e;fb=d+16|0;while(1){if(b){d=x[a+24>>2];x[g+24>>2]=b;x[g+28>>2]=0;x[g+16>>2]=134217727;x[g+20>>2]=0;d=LM(d,x[Ur(g+24|0,g+16|0)>>2],c);h=d+h|0;b=b-d|0;if(d){continue}}break}if(!(x[a+52>>2]!=1|h)){a=x[a+24>>2];x[a+480208>>2]=x[a+480208>>2]&-513}fb=g+80|0;return h}function Rka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;g=fb-80|0;fb=g;e=Rf(g+52|0);x[31609]=0;d=P(831,b|0,e|0)|0;c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)!=1){if(d){break c}x[a>>2]=0;x[a+4>>2]=0;x[a+24>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;x[31609]=0;R(832,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break b}}break a}c=x[e+4>>2];f=x[e>>2];x[31609]=0;d=g+12|0;c=$b(c);d:{if(!c){h=-1;if(($b(f)|0)==1112491097){break d}}h=c}c=h;S(185,d|0,b|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break a}f=hc(g+32|0,d);kd(e+8|0,f);ub(f);ub(d);e:{d=c&1;if(!d){break e}x[31609]=0;P(183,b|0,2-d|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break e}break a}Pk(a,e)}Hd(e);fb=g+80|0;return}a=N()|0;Hd(e);Q(a|0);p()}function Voa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=fb-32|0;fb=f;nd(c,2);v[f+20|0]=y[b+13|0];v[f+8|0]=64;d=f+20|0;e=f+8|0;i=c,j=y[Qb(d,e)|0]<<2,w[i+30>>1]=j;x[c+24>>2]=(y[b+14|0]|y[b+15|0]<<8)<<1;Mk(e,2,b+1|0);Cc(d,e);Be(c+43|0,d);tb(d);d=Zc(a,8,1,0,2);a:{if((y[b|0]&3)!=1){break a}g=y[b+22|0]|y[b+23|0]<<8|(y[b+24|0]<<16|y[b+25|0]<<24);x[c>>2]=g;e=y[b+26|0]|y[b+27|0]<<8|(y[b+28|0]<<16|y[b+29|0]<<24);x[c+4>>2]=e;a=y[b+30|0]|y[b+31|0]<<8|(y[b+32|0]<<16|y[b+33|0]<<24);h=a-(a>>>0>e>>>0)|0;x[c+8>>2]=h;a=y[b|0];if(a&4){w[c+34>>1]=z[c+34>>1]|2;a=y[b|0]}if(a&8){w[c+34>>1]=z[c+34>>1]|4;a=y[b|0]}if(!(a&16)){break a}hd(d,16);wg(d,9);x[c+8>>2]=h>>>1;x[c+4>>2]=e>>>1;x[c>>2]=g>>>1}fb=f+32|0}function PH(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0;f=fb-48|0;fb=f;x[f+44>>2]=c;a=re(a,f+44|0);c=tc(a+4|0);h=tc(a+24|0);i=tc(a+32|0);j=Nb(a+36|0);x[a+56>>2]=3;k=Nb(a+68|0);x[31609]=0;O(991,a|0,d|0);g=x[31609];x[31609]=0;a:{b:{c:{d:{if((g|0)!=1){se(f+16|0,x[b>>2],x[b+4>>2]);b=Md(f+8|0);x[31609]=0;g=x[b+4>>2];x[f>>2]=x[b>>2];x[f+4>>2]=g;b=f+24|0;Ks(e,b,x[f+16>>2],x[f+20>>2],f);e=x[31609];x[31609]=0;if((e|0)==1){break d}x[31609]=0;S(992,a|0,b|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break c}ub(b);x[31609]=0;W(993,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}}d=N()|0;break b}d=N()|0;break b}d=N()|0;ub(f+24|0)}Td(k);nf(j);Bl(i);wh(h);vh(c);Wc(a);Wc(f+44|0);Q(d|0);p()}Wc(f+44|0);fb=f+48|0;return a}function Dx(a,b,c){var d=0,e=0,f=0,g=0;d=Fb(a);a=y[b+11|0];e=x[b+4>>2];x[31609]=0;O(114,d|0,_c(e,a)|0);a=x[31609];x[31609]=0;if((a|0)!=1){a:{while(1){if(_c(x[b+4>>2],y[b+11|0])>>>0>f>>>0){a=32;e=x[Wd(b,f)>>2];g=(e&-32)==128;b:{while(1){c:{if((a|0)==256){a=0;break c}if((e|0)!=x[(a<<2)+c>>2]|g){a=a+1|0;continue}else{x[31609]=0;O(115,d|0,a<<24>>24);a=x[31609];x[31609]=0;if((a|0)!=1){break b}break a}}break}d:{while(1){if((a|0)==32){break d}if((e|0)!=x[(a<<2)+c>>2]){a=a+1|0;continue}break}x[31609]=0;O(115,d|0,a<<24>>24);a=x[31609];x[31609]=0;if((a|0)!=1){break b}break a}x[31609]=0;O(115,d|0,63);a=x[31609];x[31609]=0;if((a|0)!=1){break b}break a}f=f+1|0;continue}break}return}}a=N()|0;tb(d);Q(a|0);p()}function Um(a,b){var c=0,d=0,e=0,f=0;c=fb+-64|0;fb=c;d=x[x[a>>2]-12>>2]+a|0;e=x[d+16>>2]&-3;ig(d,e);a:{b:{if(Id(y[Hm(c+63|0,a,1)|0])){d=x[(x[x[a>>2]-12>>2]+a|0)+24>>2];x[31609]=0;f=x[b+12>>2];x[c+16>>2]=x[b+8>>2];x[c+20>>2]=f;f=x[b+4>>2];x[c+8>>2]=x[b>>2];x[c+12>>2]=f;S(937,c+40|0,d|0,c+8|0);b=x[31609];x[31609]=0;c:{if((b|0)!=1){b=ci(c+24|0,-1,-1);b=ao(x[c+48>>2],x[c+52>>2],x[b+8>>2],x[b+12>>2])?e|4:e;break c}Y(T(0)|0)|0;b=e|1;Fm(x[x[a>>2]-12>>2]+a|0,b);if(x[(x[x[a>>2]-12>>2]+a|0)+20>>2]&1){x[31609]=0;X(84);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){break b}Q(a|0);p()}Z()}Xj(x[x[a>>2]-12>>2]+a|0,b)}fb=c- -64|0;return}T(0)|0;Sb()}p()}function g_(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;c=fb-176|0;fb=c;d=c+12|0;Uf(d,a);x[31609]=0;b=c+24|0;O(124,b|0,d|0);a=x[31609];x[31609]=0;a:{b:{c:{d:{e:{if((a|0)!=1){x[31609]=0;a=P(103,c+36|0,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}tb(b);tb(d);d=x[x[a>>2]-12>>2];x[31609]=0;f=ca(104)|0;e=x[31609];x[31609]=0;if((e|0)==1){break c}x[31609]=0;e=c+8|0;S(105,e|0,a+d|0,f|0);d=x[31609];x[31609]=0;if((d|0)==1){break c}_b(e);x[31609]=0;x[c+24>>2]=0;x[c+28>>2]=0;b=P(409,a|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}a=pk(x[(b+x[x[b>>2]-12>>2]|0)+16>>2]);g=C[c+24>>3];Gf(b);fb=c+176|0;g=a?0:g;break a}b=N()|0;break d}b=N()|0;tb(c+24|0)}tb(c+12|0);break b}b=N()|0;Gf(a)}Q(b|0);p()}return+g}function Zpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;b=fb-528|0;fb=b;e=-1;a:{if(!jh(a,1468)){break a}Xl(a,1464);c=b+524|0;iY(a,c);if(!oe(c,25284)){e=0;if(!oe(c,15612)){break a}}Xl(a,20);c=1;b:{while(1){if((c&65535)>>>0>31){break b}e=fY(a,b);if(!e){RX(b)}if(e){c=c+1|0;d=_C(b)+d|0;continue}break}e=-1;break a}e=0;if(d>>>0>40){break a}d=b+522|0;c=fb-16|0;fb=c;c:{if(!jh(a,2)){v[c|0]=0;tF(d,c);break c}Bp(c+8|0,d);ZC(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0;if(y[b+522|0]>128){break a}d=Jc(d);c=fb-16|0;fb=c;d:{if(!jh(a,512)){PX(b);break d}zE(c+8|0,b);ZC(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0;c=0;e=1;a=y[d|0];while(1){if((c|0)==512){break a}d=b+c|0;c=c+1|0;if(a>>>0>=y[d|0]){continue}break}e=0}fb=b+528|0;return e|0}function Qh(a,b){var c=E(0),d=E(0),e=E(0),f=E(0),g=E(0),h=0;f=UP(a);h=a+4208|0;c=E(E(B[yb(h,4)>>2]*E(1.899999976158142))+E(.10000000149011612));g=B[a+4268>>2];d=Ee(E(10),E(E(E(E(E(x[((b<<2)+a|0)+4292>>2])/g)*E(-60))/E(E(B[yb(h,3)>>2]*E(19.899999618530273))+E(.10000000149011612)))/E(20)));c=E(E(Ee(d,E(E(2)-E(E(2)/c)))+E(-1))/E(E(1)-tq(c>E(1)?E(3.1415927410125732):E(f*E(E(6.2831854820251465)/g)))));a:{if(c==E(0)){break a}if(!Vm(c)){break a}g=E(c+c);f=E(E(-2)-g);c=E(E(f*f)+E(E(c*c)*E(-4)));if(c>E(0)){e=E(M(c))}c=E(E(e-f)/g);if(E(F(c))>E(1)){c=E(E(E(-f)-e)/g)}e=ag(c)}b=(b<<3)+a|0;B[b+4404>>2]=e;B[b+4400>>2]=d;c=B[a+4272>>2];c=E(c*c);e=E(E(1)-c);d=E(d*d);return E(E(E(e*E(d/E(E(1)-E(c*d))))*e)+c)}function Vca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=fb-48|0;fb=e;x[e+44>>2]=c;a=re(a,e+44|0);f=tc(a+4|0);g=tc(a+24|0);h=tc(a+32|0);i=Nb(a+36|0);x[a+56>>2]=3;j=Nb(a+68|0);x[31609]=0;O(991,a|0,d|0);c=x[31609];x[31609]=0;a:{b:{c:{d:{if((c|0)!=1){c=Md(e+16|0);x[31609]=0;k=x[c+4>>2];x[e+8>>2]=x[c>>2];x[e+12>>2]=k;c=e+24|0;S(1115,c|0,b|0,e+8|0);b=x[31609];x[31609]=0;if((b|0)==1){break d}x[31609]=0;S(992,a|0,c|0,d|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}ub(c);x[31609]=0;W(993,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}}d=N()|0;break b}d=N()|0;break b}d=N()|0;ub(e+24|0)}Td(j);nf(i);Bl(h);wh(g);vh(f);Wc(a);Wc(e+44|0);Q(d|0);p()}Wc(e+44|0);fb=e+48|0;return a|0}function vI(a,b){var c=0,d=0,e=0;a:{if(y[b|0]){break a}b=by(13961);if(y[b|0]?b:0){break a}b=by(D(a,12)+104960|0);if(y[b|0]?b:0){break a}b=by(14217);if(y[b|0]?b:0){break a}b=14787}b:{while(1){d=y[b+c|0];if(!(!d|(d|0)==47)){d=23;c=c+1|0;if((c|0)!=23){continue}break b}break}d=c}e=14787;c:{d:{c=y[b|0];e:{f:{if(!(y[b+d|0]|(c|0)==46)){e=b;if((c|0)!=67){break f}}if(!y[e+1|0]){break e}}if(!ji(e,14787)){break e}if(ji(e,13654)){break d}}if(!a){c=105032;if(y[e+1|0]==46){break c}}return 0}c=x[125413];if(c){while(1){if(!ji(e,c+8|0)){break c}c=x[c+32>>2];if(c){continue}break}}c=Gd(36);if(c){x[c+4>>2]=20;x[c>>2]=95136;b=c+8|0;zc(b,e,d);v[b+d|0]=0;x[c+32>>2]=x[125413];x[125413]=c}c=a|c?c:105032}return c}function $ma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=fb-16|0;fb=b;f=x[a+40>>2];g=x[a+36>>2];k=x[a+16>>2];h=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=h;l=x[a+32>>2];m=x[a+28>>2];h=x[a+8>>2];n=x[a+12>>2];while(1){if(d){e=x[b+8>>2];o=e>>>10&4194048;i=(((x[b+12>>2]&2147483647)<<1|e>>>31)&-2)+k|0;e=0;while(1){if((e|0)!=2){j=v[e+i|0];x[(e<<2)+b>>2]=((D(v[(e|2)+i|0]-j|0,o)|0)/16384|0)+(j<<8);e=e+1|0;continue}break}g=g+m|0;x[c>>2]=x[c>>2]+D(x[b>>2],g>>12);f=f+l|0;x[c+4>>2]=x[c+4>>2]+D(x[b+4>>2],f>>12);Pb(b+8|0,h,n);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;x[a+40>>2]=f;x[a+20>>2]=g>>12;x[a+36>>2]=g;x[a+24>>2]=f>>12;fb=b+16|0}function Zfa(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0;b=fb-32|0;fb=b;c=Fb(b+20|0);x[31609]=0;W(984,b+8|0);a=x[31609];x[31609]=0;a:{b:{c:{d:{if((a|0)!=1){f=b,g=wb(x[b+8>>2]),x[f+4>>2]=g;d=1;while(1){e=wb(x[b+12>>2]);a=x[b+4>>2];if(!Ib(a,e)){a=Cg(Kb(c));Td(b+8|0);tb(c);break b}if(!d){x[31609]=0;P(985,c|0,14665)|0;a=x[31609];x[31609]=0;if((a|0)==1){break d}a=x[b+4>>2]}x[31609]=0;P(838,c|0,a|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break d}ym(b+4|0);d=0;continue}}a=T(0)|0;break c}a=T(0)|0;Td(b+8|0)}tb(c);Y(a|0)|0;a=0;x[31609]=0;V(983,7040,0,0,0);c=x[31609];x[31609]=0;if((c|0)==1){break a}Z()}fb=b+32|0;return a|0}b=N()|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)==1){T(0)|0;Sb();p()}Q(b|0);p()}function ona(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=fb-16|0;fb=b;k=x[a+16>>2];j=kg(1,2);e=hb;l=e;Pb(a,j,e);f=x[a+40>>2];g=x[a+36>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;m=x[a+32>>2];n=x[a+28>>2];e=x[a+8>>2];o=x[a+12>>2];while(1){if(d){d=d-1|0;i=x[b+8>>2];i=((((x[b+12>>2]&2147483647)<<1|i>>>31)&2147483646)<<1)+k|0;h=0;while(1){if((h|0)!=2){x[(h<<2)+b>>2]=w[(h<<1)+i>>1];h=h+1|0;continue}break}g=g+n|0;x[c>>2]=x[c>>2]+D(x[b>>2],g>>12);f=f+m|0;x[c+4>>2]=x[c+4>>2]+D(x[b+4>>2],f>>12);Pb(b+8|0,e,o);c=c+8|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;x[a+40>>2]=f;x[a+20>>2]=g>>12;x[a+36>>2]=g;x[a+24>>2]=f>>12;Ig(a,j,l);fb=b+16|0}function i9(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=x[b+44>>2];i=x[b+24>>2];if(h>>>0<i>>>0){x[b+44>>2]=i;h=i}m=-1;n=-1;o=f&24;a:{if(!o|(e|0)==1&(o|0)==24){break a}if(h){j=h-Kb(b+32|0)|0;k=j>>31}b:{c:{switch(e|0){case 1:if(f&8){g=x[b+12>>2]-x[b+8>>2]|0;l=g>>31;break b}g=i-x[b+20>>2]|0;l=g>>31;break b;case 0:break b;case 2:break c;default:break a}}g=j;l=k}d=d+l|0;c=c+g|0;d=g>>>0>c>>>0?d+1|0:d;if((d|0)<0|(c>>>0>j>>>0&(d|0)>=(k|0)|(d|0)>(k|0))){break a}e=f&8;d:{if(!(c|d)){break d}if(x[b+12>>2]?0:e){break a}if(!(f&16)){break d}if(!i){break a}}if(e){e=x[b+8>>2];Wn(b,e,c+e|0,h)}if(f&16){Fx(b,x[b+20>>2],x[b+28>>2]);ys(b,c)}m=c;n=d}ci(a,m,n)}function aI(a,b,c,d,e,f){var g=0,h=0,i=0,j=0,k=0,l=0;g=fb-48|0;fb=g;x[g+44>>2]=d;a=re(a,g+44|0);d=tc(a+4|0);h=tc(a+24|0);i=tc(a+32|0);j=Nb(a+36|0);x[a+56>>2]=3;k=Nb(a+68|0);x[31609]=0;O(991,a|0,e|0);l=x[31609];x[31609]=0;a:{b:{c:{d:{if((l|0)!=1){cc(g+16|0,b,c);b=Md(g+8|0);x[31609]=0;c=x[b+4>>2];x[g>>2]=x[b>>2];x[g+4>>2]=c;b=g+24|0;Ks(f,b,x[g+16>>2],x[g+20>>2],g);c=x[31609];x[31609]=0;if((c|0)==1){break d}x[31609]=0;S(992,a|0,b|0,e|0);c=x[31609];x[31609]=0;if((c|0)==1){break c}ub(b);x[31609]=0;W(993,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}}e=N()|0;break b}e=N()|0;break b}e=N()|0;ub(g+24|0)}Td(k);nf(j);Bl(i);wh(h);vh(d);Wc(a);Wc(g+44|0);Q(e|0);p()}Wc(g+44|0);fb=g+48|0;return a}function Io(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;a:{if(c){v[b+809|0]=c;break a}c=y[b+809|0]}e=x[a+480180>>2];d=e&202376205?c&240?c&-16:c:c;c=x[b+688>>2];b:{if(e&69206029){break b}g=d&255;f=d&15;if((f|0)==15){if(g>>>0>=16){Ho(a,b,(d&240)>>>4|0,0);return}if(!(v[b+851|0]&1)){break b}c=y[a+480208|0]&2?c:c-60|0;break b}if((g&240)!=240){break b}if(f){Go(a,b,f,0);return}if(!(v[b+851|0]&1)){break b}c=y[a+480208|0]&2?c:c+60|0}c:{if(!(!(v[b+851|0]&1)|y[a+480208|0]&2)){if(x[a+1074416>>2]!=1|(e|0)!=524288){break c}}a=d&15;d:{if(a){if((d&255)>>>0>15?e&16777248:0){break c}c=c-(a<<2)|0;break d}c=((d&255)>>>2|0)+c|0}if((e|0)!=1){break c}x[b+88>>2]=x[b+88>>2]|2097152}h=b,i=Yb(c,0,256),x[h+688>>2]=i}function poa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(e+8|0,x[vb(e+4|0,a)>>2]);a:{if(b){x[31609]=0;O(739,a|0,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}f=fb-16|0;fb=f;d=f+4|0;x[d>>2]=a;c=x[a+4>>2];x[d+4>>2]=c;x[d+8>>2]=c+D(b,36);b=x[d+4>>2];g=x[d+8>>2];while(1){if((b|0)==(g|0)){kc(d);fb=f+16|0}else{c=Rb(b,0,36);x[c>>2]=0;x[c+4>>2]=0;w[c+22>>1]=0;w[c+24>>1]=0;w[c+26>>1]=0;w[c+28>>1]=0;v[c+21|0]=64;v[c+19|0]=64;v[c+20|0]=100;v[c+15|0]=0;v[c+16|0]=0;v[c+17|0]=0;v[c+18|0]=0;x[c+8>>2]=0;x[c+12>>2]=0;w[c+30>>1]=0;w[c+32>>1]=0;b=b+36|0;x[d+4>>2]=b;continue}break}}b=e+8|0;Qd(b);eW(b);fb=e+16|0;return a|0}a=N()|0;eW(e+8|0);Q(a|0);p()}function R0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;nd(b,0);x[b>>2]=y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24);c=Mr(a+4|0,a);f=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);x[b+4>>2]=f;c=Mr(a+8|0,a);c=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);x[b+8>>2]=c;v[e+15|0]=127;v[e+14|0]=y[a+15|0];g=b,h=(((y[Qb(e+15|0,e+14|0)|0]<<8|64)&65344)>>>0)/127|0,w[g+30>>1]=h;d=y[a+12|0];if(d>>>0>=16){w[b+34>>1]=32;w[b+28>>1]=d&240}d=(y[a+13|0]|y[a+14|0]<<8)<<1;x[b+24>>2]=d;d=y[a+13|0]|y[a+14|0]<<8?d:16726;x[b+24>>2]=d;g=b,h=(D(xw(0,y[a+12|0]<<28>>24),d)>>>0)/8363|0,x[g+24>>2]=h;if(c>>>0>f>>>0){w[b+34>>1]=z[b+34>>1]|2}if(y[a+16|0]&132){w[b+34>>1]=z[b+34>>1]|1}fb=e+16|0}function xs(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;d=fb-16|0;fb=d;x[d+12>>2]=b;if(b>>>0<2147483632){a:{if(Mc(a)>>>0>=b>>>0){break a}k=d,l=Cb(x[a+4>>2],y[a+11|0]),x[k+8>>2]=l;b=Fh(x[bd(d+12|0,d+8|0)>>2]);if((Mc(a)|0)==(b|0)){break a}e=fb-16|0;fb=e;f=Cb(x[a+4>>2],y[a+11|0]);b:{c:{h=Ok(b);d:{if(h){i=1;j=b+1|0;g=x[a>>2];b=a;c=f;break d}c=b+1|0;e:{if(Mc(a)>>>0<b>>>0){qg(e+8|0,c);break e}x[31609]=0;O(116,e+8|0,c|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}}j=x[e+12>>2];b=x[e+8>>2];c=y[a+11|0];i=vd(c);g=Kb(a);c=Cb(x[a+4>>2],c)}b=Dg(b,g,c+1|0);if(i){Db(g)}if(!h){of(a,j);Bd(a,f);yd(a,b);break b}Ne(a,f);break b}Y(T(0)|0)|0;Z()}fb=e+16|0}fb=d+16|0;return}pf();p()}function O2(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;d=fb-176|0;fb=d;c=d+12|0;Uf(c,a);x[31609]=0;b=d+24|0;O(124,b|0,c|0);a=x[31609];x[31609]=0;a:{b:{c:{d:{e:{if((a|0)!=1){x[31609]=0;a=P(103,d+36|0,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break e}tb(b);tb(c);c=x[x[a>>2]-12>>2];x[31609]=0;f=ca(104)|0;e=x[31609];x[31609]=0;if((e|0)==1){break c}x[31609]=0;e=d+8|0;S(105,e|0,a+c|0,f|0);c=x[31609];x[31609]=0;if((c|0)==1){break c}_b(e);x[31609]=0;x[d+24>>2]=0;b=P(125,a|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}a=pk(x[(b+x[x[b>>2]-12>>2]|0)+16>>2]);c=x[d+24>>2];Gf(b);fb=d+176|0;a=a?0:c;break a}b=N()|0;break d}b=N()|0;tb(d+24|0)}tb(d+12|0);break b}b=N()|0;Gf(a)}Q(b|0);p()}return a|0}function lU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;d=fb-16|0;fb=d;x[d+12>>2]=b;if(b>>>0<2147483632){a:{if(Mc(a)>>>0>=b>>>0){break a}k=d,l=Cb(x[a+4>>2],y[a+11|0]),x[k+8>>2]=l;b=Fh(x[bd(d+12|0,d+8|0)>>2]);if((Mc(a)|0)==(b|0)){break a}e=fb-16|0;fb=e;f=Cb(x[a+4>>2],y[a+11|0]);b:{c:{h=Ok(b);d:{if(h){i=1;j=b+1|0;g=x[a>>2];b=a;c=f;break d}c=b+1|0;e:{if(Mc(a)>>>0<b>>>0){qg(e+8|0,c);break e}x[31609]=0;O(52,e+8|0,c|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}}j=x[e+12>>2];b=x[e+8>>2];c=y[a+11|0];i=vd(c);g=Kb(a);c=Cb(x[a+4>>2],c)}b=Xg(b,g,c+1|0);if(i){Db(g)}if(!h){of(a,j);Bd(a,f);yd(a,b);break b}Ne(a,f);break b}Y(T(0)|0)|0;Z()}fb=e+16|0}fb=d+16|0;return}pf();p()}function Li(a,b,c,d){var e=0,f=0,g=0;x[a+20>>2]=d;x[a+16>>2]=c;x[a+12>>2]=b;x[a+4>>2]=0;x[a+8>>2]=0;x[a>>2]=42712;c=a+24|0;x[c>>2]=0;x[c+4>>2]=0;x[c+16>>2]=0;x[c+8>>2]=0;x[c+12>>2]=0;b=Nb(a+44|0);d=Nb(b+12|0);e=Nb(b+24|0);f=Nb(b+36|0);x[31609]=0;O(941,b|0,0);g=x[31609];x[31609]=0;if((g|0)==1){a=N()|0;wc(f);wc(e);nu(d);nu(b);Q(a|0);p()}w[a+4204>>1]=0;x[a+4196>>2]=1065353216;x[a+4200>>2]=0;d=x[a+16>>2];x[d+946300>>2]=x[d+946300>>2]+1;x[31609]=0;d=R(942,a+92|0)|0;e=x[31609];x[31609]=0;a:{if((e|0)!=1){b=a+4200|0;x[c>>2]=d;c=x[a+16>>2]+906300|0;d=y[a+4200|0];e=x[a+20>>2];while(1){if(($d(c,d)|0)==(e|0)|d>>>0>248){break a}d=d+1|0;v[b|0]=d;continue}}a=N()|0;xQ(b);Q(a|0);p()}return a}function df(a,b,c){var d=0,e=0,f=0;d=Fb(a);a=y[b+11|0];e=x[b+4>>2];x[31609]=0;O(114,d|0,_c(e,a)|0);a=x[31609];x[31609]=0;if((a|0)!=1){a:{while(1){if(_c(x[b+4>>2],y[b+11|0])>>>0>f>>>0){e=x[Wd(b,f)>>2];a=32;b:{while(1){c:{if((a|0)==256){a=0;break c}if((e|0)==x[(a<<2)+c>>2]){x[31609]=0;O(115,d|0,a<<24>>24);a=x[31609];x[31609]=0;if((a|0)!=1){break b}break a}else{a=a+1|0;continue}}break}d:{while(1){if((a|0)==32){break d}if((e|0)!=x[(a<<2)+c>>2]){a=a+1|0;continue}break}x[31609]=0;O(115,d|0,a<<24>>24);a=x[31609];x[31609]=0;if((a|0)!=1){break b}break a}x[31609]=0;O(115,d|0,63);a=x[31609];x[31609]=0;if((a|0)!=1){break b}break a}f=f+1|0;continue}break}return}}a=N()|0;tb(d);Q(a|0);p()}function Oma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=fb-16|0;fb=b;h=x[a+24>>2];i=x[a+20>>2];j=x[a+16>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;k=x[a+8>>2];l=x[a+12>>2];while(1){if(d){e=x[b+8>>2];g=(((x[b+12>>2]&2147483647)<<1|e>>>31)&-2)+j|0;e=e>>>21&2040;m=w[e+38086>>1];n=w[e+38084>>1];o=w[e+38082>>1];e=w[e+38080>>1];f=0;while(1){if((f|0)!=2){x[(f<<2)+b>>2]=(((D(v[f+g|0],o)+D(v[(f|-2)+g|0],e)|0)+D(v[(f|2)+g|0],n)|0)+D(v[(f|4)+g|0],m)<<8)/16384;f=f+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[b>>2],i);x[c+4>>2]=x[c+4>>2]+D(x[b+4>>2],h);Pb(b+8|0,k,l);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;fb=b+16|0}function pka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;d=fb-16|0;fb=d;x[d+12>>2]=b;if(b>>>0<1073741808){a:{if(tn(a)>>>0>=b>>>0){break a}k=d,l=Cb(x[a+4>>2],y[a+11|0]),x[k+8>>2]=l;b=sn(x[bd(d+12|0,d+8|0)>>2]);if((tn(a)|0)==(b|0)){break a}e=fb-16|0;fb=e;i=1;f=b+1|0;c=tn(a);g=Cb(x[a+4>>2],y[a+11|0]);b:{c:{j=fr(b);d:{if(j){h=x[a>>2];b=a;c=g;break d}e:{if(b>>>0>c>>>0){Oj(e+8|0,f);break e}x[31609]=0;O(54,e+8|0,f|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}}f=x[e+12>>2];b=x[e+8>>2];c=y[a+11|0];i=vd(c);h=Kb(a);c=Cb(x[a+4>>2],c)}b=Ti(b,h,c+1|0);if(i){Db(h)}if(!j){of(a,f);Bd(a,g);yd(a,b);break b}Ne(a,g);break b}Y(T(0)|0)|0;Z()}fb=e+16|0}fb=d+16|0;return}pf();p()}function jaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=fb-80|0;fb=d;x[31609]=0;f=R(1201,b|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){a:{b:{if(f){x[31609]=0;f=d+56|0;O(1202,f|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){b=d- -64|0;Ip(b,f);e=Ff(d+72|0,b);g=Ff(d+48|0,c);h=x[e+4>>2];x[d+8>>2]=x[e>>2];x[d+12>>2]=h;e=x[g+4>>2];x[d>>2]=x[g>>2];x[d+4>>2]=e;Jp(a,d+8|0,d);break b}break a}x[31609]=0;f=d+56|0;O(1203,f|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}b=d- -64|0;Ip(b,f);e=Ff(d+40|0,b);g=Ff(d+32|0,c);h=x[e+4>>2];x[d+24>>2]=x[e>>2];x[d+28>>2]=h;e=x[g+4>>2];x[d+16>>2]=x[g>>2];x[d+20>>2]=e;Jp(a,d+24|0,d+16|0)}me(b);me(f);me(c);fb=d+80|0;return}}a=N()|0;me(c);Q(a|0);p()}function Ena(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;g=fb-16|0;fb=g;nd(b,4);w[b+30>>1]=y[a+12|0]<<2;Hf(b+30|0,256);e=y[a+15|0];w[b+34>>1]=32;w[b+28>>1]=e;v[b+37|0]=y[a+13|0];v[b+36|0]=y[a+16|0];f=y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24);x[b>>2]=f;c=y[a+4|0]|y[a+5|0]<<8|(y[a+6|0]<<16|y[a+7|0]<<24);x[b+4>>2]=c;d=(y[a+8|0]|y[a+9|0]<<8|(y[a+10|0]<<16|y[a+11|0]<<24))+c|0;x[b+8>>2]=d;e=y[a+14|0];if(e&16){d=d>>>1|0;x[b+8>>2]=d;c=c>>>1|0;x[b+4>>2]=c;f=f>>>1|0;x[b>>2]=f;e=y[a+14|0]}if(e&32){d=d>>>1|0;x[b+8>>2]=d;c=c>>>1|0;x[b+4>>2]=c;x[b>>2]=f>>>1;e=y[a+14|0]}if(!(!(e&3)|c>>>0>=d>>>0)){w[b+34>>1]=34;w[b+34>>1]=y[a+14|0]&2?38:34}a=Dc(g+4|0,22292);Be(b+43|0,a);tb(a);fb=g+16|0}function uN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=fb-16|0;fb=f;a:{b:{c:{d:{e:{if((b|0)>=0){e=x[a+32>>2];if((wo(e)|0)>(b|0)){break e}}a=ac(8);x[31609]=0;b=P(36,f+4|0,10751)|0;c=x[31609];x[31609]=0;if((c|0)==1){break d}pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break b}c=N()|0;tb(b);break c}d=(e+(b<<5)|0)+480280|0;g=c?67109888:0;x[d>>2]=g|x[d>>2]&-67109889;c=(e+D(b,872)|0)+1075080|0;x[c>>2]=x[c>>2]&-67109889|g;c=z[e+480188>>1];e=c>>>0<=256?256:c;b=b+1|0;a=x[a+32>>2];while(1){if((c|0)==(e|0)){break a}d=a+D(c,872)|0;if((b|0)==z[d+1075778>>1]){d=d+1075080|0;x[d>>2]=x[d>>2]&-67109889|g}c=c+1|0;continue}}c=N()|0;ic(a)}Q(c|0)}p()}fb=f+16|0}function dba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=fb-16|0;fb=g;h=g+4|0;e=fb-32|0;fb=e;d=qf(e+20|0,1,0);a:{b:{c:{while(1){c=Kb(d);j=Cb(x[d+4>>2],y[d+11|0])+c|0;i=x[b>>2];k=e+12|0;f=x[b+4>>2];if(!((c|0)==(j|0)|((f|0)>=0|(f|0)>0))){v[c|0]=45;i=XN(i,f);f=hb;c=c+1|0}QN(k,c,j,i,f);if(!x[e+16>>2]){break c}c=mi(Cb(x[d+4>>2],y[d+11|0]));x[31609]=0;O(45,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)!=1){continue}break}break b}b=x[e+12>>2];c=Kb(d);x[31609]=0;O(46,d|0,b-c|0);b=x[31609];x[31609]=0;d:{if((b|0)!=1){x[31609]=0;O(303,h|0,d|0);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break b}break b}tb(d);fb=e+32|0;break a}a=N()|0;tb(d);Q(a|0);p()}Rh(a,h);tb(h);fb=g+16|0}function WQ(a,b,c){var d=0,e=0,f=0,g=0,h=0;a:{f=fb-48|0;fb=f;d=Fb(f+36|0);x[31609]=0;O(932,b|0,f+24|0);g=x[31609];x[31609]=0;if((g|0)!=1){b:{g=x[f+28>>2];e=x[f+24>>2];sf(d);x[31609]=0;g=!g&e>>>0>=255|g?255:e;O(46,d|0,g|0);e=x[31609];x[31609]=0;if((e|0)==1){break b}c:{while(1){if((g|0)==(h|0)){b=e0(Kb(d),Cb(x[d+4>>2],y[d+11|0]));if((b|0)==-1){break c}x[31609]=0;O(46,d|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break c}break b}e=dc(d,h);x[31609]=0;P(933,b|0,e|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){h=h+1|0;continue}break}break b}x[31609]=0;b=f+12|0;S(496,b|0,a|0,d|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}zb(c,b);tb(b);tb(d);fb=f+48|0;break a}}a=N()|0;tb(d);Q(a|0);p()}}function Pg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=fb+-64|0;fb=f;a:{b:{if((b|0)==65535|c-1025>>>0<4294966272){break b}d=x[a>>2];e=x[a+4>>2];if(Je(d,e,b)){break b}c:{d:{if(jm(d,e)>>>0<=b>>>0){d=rA(f+12|0,a);x[31609]=0;S(199,a|0,b+1|0,d|0);e=x[31609];x[31609]=0;if((e|0)==1){break d}wk(d);d=x[a>>2]}x[31609]=0;O(200,aj(d,b)|0,c|0);c=x[31609];x[31609]=0;e:{if((c|0)!=1){c=aj(x[a>>2],b);x[c+16>>2]=0;x[c+20>>2]=0;c=x[a>>2];x[31609]=0;W(201,aj(c,b)|0);c=x[31609];x[31609]=0;if((c|0)!=1){break e}}b=T(124540)|0;a=gb;break c}a=aj(x[a>>2],b);g=Ib(x[a>>2],x[a+4>>2]);break b}b=T(124540)|0;a=gb;wk(d)}if(($(124540)|0)!=(a|0)){break a}Y(b|0)|0;Z()}fb=f- -64|0;return g|0}Q(b|0);p()}function xT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=fb-112|0;fb=f;x[f+108>>2]=0;e=Fo(a,e&65535,d,c,f+108|0);c=y[b+790|0];if(!x[f+108>>2]){d=(c|0)==15;h=d&!y[b+792|0];e=e<<8;a:{if(e){x[b+664>>2]=e;break a}e=0;if(d){break a}e=x[b+664>>2]}h=h?0:y[b+836|0]<<16}if((c|0)==15){c=y[b+792|0];b:{if(!c){c=x[b+76>>2];x[f+4>>2]=1;g=x[bd(f+4|0,f+108|0)>>2]<<3;e=Iua(c,0,e,0);d=(256<<g>>>1|0)+e|0;c=hb;c=d>>>0<e>>>0?c+1|0:c;e=g+8|0;g=d;d=e&31;if((e&63)>>>0>=32){e=0;c=c>>>d|0}else{e=c>>>d|0;c=((1<<d)-1&c)<<32-d|g>>>d}e=Bc(c,e);break b}_v(f+4|0);if(c>>>0>9){break b}c=x[b+104>>2];if(!c){break b}e=x[yb(c+68|0,y[b+792|0]-1|0)>>2]+e|0}x[b+664>>2]=e}Jo(a,b,e+h|0);fb=f+112|0}function pna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=fb-16|0;fb=b;k=x[a+16>>2];j=kg(1,2);e=hb;l=e;Pb(a,j,e);f=x[a+40>>2];g=x[a+36>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;m=x[a+32>>2];n=x[a+28>>2];e=x[a+8>>2];o=x[a+12>>2];while(1){if(d){d=d-1|0;i=x[b+8>>2];i=(((x[b+12>>2]&2147483647)<<1|i>>>31)&-2)+k|0;h=0;while(1){if((h|0)!=2){x[(h<<2)+b>>2]=v[h+i|0]<<8;h=h+1|0;continue}break}g=g+n|0;x[c>>2]=x[c>>2]+D(x[b>>2],g>>12);f=f+m|0;x[c+4>>2]=x[c+4>>2]+D(x[b+4>>2],f>>12);Pb(b+8|0,e,o);c=c+8|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;x[a+40>>2]=f;x[a+20>>2]=g>>12;x[a+36>>2]=g;x[a+24>>2]=f>>12;Ig(a,j,l);fb=b+16|0}function I9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=fb-32|0;fb=d;e=x[a+28>>2];x[d+16>>2]=e;f=x[a+20>>2];x[d+28>>2]=c;x[d+24>>2]=b;b=f-e|0;x[d+20>>2]=b;f=b+c|0;i=2;b=d+16|0;a:{while(1){b:{c:{d:{if(!_y(Aa(x[a+60>>2],b|0,i|0,d+12|0)|0)){g=x[d+12>>2];if((g|0)==(f|0)){break d}if((g|0)>=0){break c}break b}if((f|0)!=-1){break b}}b=x[a+44>>2];x[a+28>>2]=b;x[a+20>>2]=b;x[a+16>>2]=b+x[a+48>>2];a=c;break a}h=x[b+4>>2];j=h>>>0<g>>>0;e=(j<<3)+b|0;h=g-(j?h:0)|0;x[e>>2]=h+x[e>>2];b=(j?12:4)+b|0;x[b>>2]=x[b>>2]-h;f=f-g|0;i=i-j|0;b=e;continue}break}x[a+28>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a>>2]=x[a>>2]|32;a=0;if((i|0)==2){break a}a=c-x[b+4>>2]|0}fb=d+32|0;return a|0}function ima(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=fb-16|0;fb=e;h=x[a+24>>2];i=x[a+20>>2];j=x[a+16>>2];g=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=g;k=b+24|0;g=x[a+8>>2];l=x[a+12>>2];while(1){if(d){b=x[e+8>>2];f=(x[e+12>>2]<<1)+j|0;b=(((b>>>16|0)+4&131064)<<1)+k|0;b=(((((D(w[f+4>>1],w[b+10>>1])+D(w[f+2>>1],w[b+8>>1])|0)+D(w[f+6>>1],w[b+12>>1])|0)+D(w[f+8>>1],w[b+14>>1])|0)/2|0)+((((D(w[f-4>>1],w[b+2>>1])+D(w[f-6>>1],w[b>>1])|0)+D(w[f-2>>1],w[b+4>>1])|0)+D(w[f>>1],w[b+6>>1])|0)/2|0)|0)/16384|0;x[c>>2]=x[c>>2]+D(b,i);x[c+4>>2]=x[c+4>>2]+D(b,h);Pb(e+8|0,g,l);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;fb=e+16|0}function dG(a){var b=0,c=0,d=0,e=0,f=0,g=0;a:{if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=-1641380927){break a}b=y[a+16|0]|y[a+17|0]<<8|(y[a+18|0]<<16|y[a+19|0]<<24);if(b>>>0<36){break a}c=y[a+24|0]|y[a+25|0]<<8|(y[a+26|0]<<16|y[a+27|0]<<24);if(c>>>0<36){break a}d=y[a+32|0]|y[a+33|0]<<8|(y[a+34|0]<<16|y[a+35|0]<<24);if(d>>>0<36){break a}e=y[a+12|0]|y[a+13|0]<<8|(y[a+14|0]<<16|y[a+15|0]<<24);if(e-1>>>0>858993458){break a}f=y[a+20|0]|y[a+21|0]<<8|(y[a+22|0]<<16|y[a+23|0]<<24);if(f-1>>>0>536870910){break a}a=y[a+28|0]|y[a+29|0]<<8|(y[a+30|0]<<16|y[a+31|0]<<24);if(D(e,-5)-1>>>0<b>>>0|a-1>>>0>1073741822|(f<<3^-1)>>>0<c>>>0){break a}g=(a<<2^-1)>>>0>=d>>>0}return g}function bB(a,b,c,d){var e=0,f=0,g=0,h=0;a:{if(!d){break a}if(c){v[b+815|0]=c;break a}c=y[b+815|0]}f=x[a+480180>>2];d=f&1048580;c=d?c&240?c&-16:c:c;b:{c:{d:{if(!d){d=c&240;e:{f:{g:{h:{e=c&15;if((e|0)==15){a=x[a+480208>>2]&4096;if(!d){break h}if(!a){break b}c=0-(d>>>2|0)|0;break d}a=x[a+480208>>2]&4096;if(!e|(d|0)!=240){break g}if(!a){break b}c=e<<2;break c}d=0;if(!a){break f}break b}if(a){break b}if(!e){break e}}c=e<<2;if(!d|!(f&16777248)){break c}break b}c=0-((c&255)>>>2|0)|0;break d}if(y[a+480209|0]&16){break b}d=c&240;c=d?d>>>2|0:0-((c&255)<<2)|0;if(!Ob(a+1074312|0,56)){break d}c=c>>2}if(!c){break b}}a=x[b+692>>2];w[b+784>>1]=0;g=b,h=Yb(a+c|0,0,256),x[g+692>>2]=h}}function aR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=E(0),j=E(0),k=0,l=E(0);g=fb-16|0;fb=g;e=w[d>>1];f=w[d+2>>1];if(!(!z[b>>1]|(e|0)>(f|0)|(!(B[c>>2]>E(0))|(f-e|0)>32766))){w[a>>1]=3;f=a+4|0;Nc(f);w[a+28>>1]=65472;x[g+12>>2]=1065353216;eR(f,g+12|0);x[a+32>>2]=0;w[a+30>>1]=0;Nc(a+16|0);h=w[d>>1];w[a+28>>1]=h;e=fb-16|0;fb=e;w[e+14>>1]=z[b>>1];w[e+12>>1]=32767;b=w[Oc(e+14|0,e+12|0)>>1];fb=e+16|0;w[a+30>>1]=b;i=E(F(B[c>>2]));B[a+32>>2]=i;i=Ee(i,E(E(1)/E(b|0)));Dl(f,(w[d+2>>1]-h|0)+1|0);b=x[a+4>>2];c=w[a+28>>1];e=w[d+2>>1];d=w[d>>1];while(1){if((d|0)>(e|0)){wq(a)}else{j=Ee(i,E(d|0));k=yb(b,d-c|0),l=j,B[k>>2]=l;d=d+1|0;continue}break}h=1}fb=g+16|0;return h|0}function MO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-32|0;fb=e;g=Nb(a);a=0;c=x[b+24>>2];c=Zu(x[c+484344>>2],x[c+484348>>2]);x[31609]=0;O(176,g|0,c|0);c=x[31609];x[31609]=0;a:{if((c|0)!=1){b:{c:{d:{e:{while(1){c=x[b+24>>2];d=x[c+484344>>2];if(Zu(d,x[c+484348>>2])>>>0<=a>>>0){break b}x[31609]=0;c=e+8|0;O(1066,c|0,Wb(d,a)|0);d=x[31609];x[31609]=0;if((d|0)!=1){f=x[b+24>>2];x[31609]=0;d=e+20|0;S(1053,d|0,f|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break e}x[31609]=0;O(178,g|0,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break d}a=a+1|0;tb(d);tb(c);continue}break}a=N()|0;break a}a=N()|0;break c}a=N()|0;tb(e+20|0)}tb(e+8|0);break a}fb=e+32|0;return}a=N()|0}Td(g);Q(a|0);p()}function noa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;i=e,j=Rj(b),x[i+4>>2]=j;d=fb-16|0;fb=d;h=a;c=de(a);a:{if(c){f=gc(a);while(1){a=c;c=a+13|0;if(ov(b,c)){f=a;c=x[a>>2];if(c){continue}break a}if(!ov(c,b)){break a}f=a+4|0;c=x[a+4>>2];if(c){continue}break}break a}a=gc(h);f=a}x[d+12>>2]=a;b=x[f>>2];if(!b){c=fb-16|0;fb=c;a=gc(h);g=Dh(d,Ec(20),Og(c+8|0,a));b=x[g>>2];a=x[e+4>>2];a=y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24);v[b+17|0]=0;v[b+13|0]=a;v[b+14|0]=a>>>8;v[b+15|0]=a>>>16;v[b+16|0]=a>>>24;i=gc(g),j=1,v[i+4|0]=j;fb=c+16|0;$g(h,x[d+12>>2],f,x[d>>2]);b=ne(d);Jk(d);g=1}_g(e+8|0,x[vb(d,b)>>2],g);fb=d+16|0;fb=e+16|0;return x[e+8>>2]+17|0}function Kfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=fb-32|0;fb=d;x[31609]=0;W(996,a|0);e=x[31609];x[31609]=0;a:{b:{c:{if((e|0)==1){break c}x[31609]=0;W(997,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break c}x[31609]=0;W(997,c|0);f=x[31609];x[31609]=0;e=1;if((f|0)==1){break c}f=x[a+24>>2];b=qc(d+24|0,b);c=qc(d+16|0,c);g=x[c>>2];c=x[c+4>>2];x[31609]=0;h=x[b+4>>2];x[d+8>>2]=x[b>>2];x[d+12>>2]=h;Ls(1018,f,d+8|0,g,c,1);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,5507,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();e=0}fb=d+32|0;return e|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function zU(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;j=$u(b);e=fb-16|0;fb=e;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);h=e+8|0;Rd(h,x[vb(e+4|0,a)>>2]);x[31609]=0;O(799,a|0,2048);d=x[31609];x[31609]=0;a:{if((d|0)!=1){i=fb-16|0;fb=i;g=fs(i+4|0,a,2048);d=x[g+4>>2];k=x[g+8>>2];while(1){if((d|0)==(k|0)){kc(g);fb=i+16|0}else{x[d>>2]=0;x[d+4>>2]=0;d=d+8|0;x[g+4>>2]=d;continue}break}Qd(h);_u(h);fb=e+16|0;break a}a=N()|0;_u(e+8|0);Q(a|0);p()}while(1){b:{c=1;if((f|0)!=1024){if((f|0)==2048){break b}c=+(f-1024|0);l=$u(M(c*c*-9.5367431640625e-7+1)*b);c=c*.0372006759294457;c=l*Ri(c)/(j*c)}m=Se(x[a>>2],f),n=c*.011841342921061943,C[m>>3]=n;f=f+1|0;continue}break}}function _X(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=fb-16|0;fb=c;x[c+12>>2]=20;x[c+8>>2]=a;e=ZX(x[c+8>>2],x[c+12>>2]);a:{if(e>>>0>5){break a}while(1){if((d|0)!=15){x[c+4>>2]=22;b=D(d,30)+a|0;x[c>>2]=b+20;e=ZX(x[c>>2],x[c+4>>2])+e|0;if(e>>>0>48){break a}g=y[b+45|0];if(y[b+44|0]|g>>>0>64){break a}b=Bb(y[b+42|0]|y[b+43|0]<<8);if(b>>>0>32768){break a}d=d+1|0;f=f|g;h=b+h|0;continue}break}if(!h|!(f&255)){break a}e=y[a+470|0];if(e>>>0>128){break a}f=y[a+471|0];if(f>>>0>220){break a}a=a+472|0;b=QC(a);b:{if((a|0)==(b|0)){break b}d=a;while(1){d=d+1|0;if((b|0)==(d|0)){break b}a=Xt(y[a|0],y[d|0])?d:a;continue}}a=y[a|0];if(a>>>0>63){break a}i=(f|(a|e))!=0}fb=c+16|0;return i}function dZ(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=fb-16|0;fb=g;d=vb(g+12|0,x[a+4>>2]);c=vb(g+8|0,x[a>>2]);f=x[vb(g+4|0,x[b+4>>2])>>2];h=fb-16|0;fb=h;i=h+8|0;e=fb-32|0;fb=e;fd(e+24|0,x[d>>2],x[c>>2]);j=e+16|0;c=x[e+24>>2];k=x[e+28>>2];d=fb-16|0;fb=d;x[d+8>>2]=f;x[d+12>>2]=c;while(1){if(Fd(c,k)){c=xf(c);f=xf(x[d+8>>2]);c=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);v[f|0]=c;v[f+1|0]=c>>>8;v[f+2|0]=c>>>16;v[f+3|0]=c>>>24;c=xj(d+12|0);xj(d+8|0);c=x[c>>2];continue}break}rc(j,c,d+8|0);fb=d+16|0;d=x[e+16>>2];x[e+12>>2]=x[e+20>>2];rc(i,d,e+12|0);fb=e+32|0;fb=h+16|0;x[b+4>>2]=x[h+12>>2];Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=g+16|0}function mv(a,b){var c=0,d=0,e=0;e=fb-48|0;fb=e;d=e+28|0;$V(d,a+8|0,a+10|0,a+12|0,a+16|0,a+14|0);a=e+8|0;$V(a,b+8|0,b+10|0,b+12|0,b+16|0,b+14|0);b=x[d>>2];c=y[b|0]|y[b+1|0]<<8;b=x[a>>2];b=lv(c,y[b|0]|y[b+1|0]<<8);a:{if(!Mj(b)){break a}b=x[d+4>>2];c=y[b|0]|y[b+1|0]<<8;b=x[a+4>>2];b=lv(c,y[b|0]|y[b+1|0]<<8);if(!Mj(b)){break a}b=x[d+8>>2];c=y[b|0]|y[b+1|0]<<8;b=x[a+8>>2];b=lv(c,y[b|0]|y[b+1|0]<<8);if(!Mj(b)){break a}b=x[a+12>>2];b=(y[b|0]|y[b+1|0]<<8)<<16>>16;c=x[d+12>>2];c=ze((y[c|0]|y[c+1|0]<<8)<<16>>16);b=ze(b);b=(b|0)!=(c|0)?(c|0)<(b|0)?-1:1:0;if(!Mj(b)){break a}b=x[d+16>>2];a=x[a+16>>2];b=lv(y[b|0]|y[b+1|0]<<8,y[a|0]|y[a+1|0]<<8)}a=vd(b);fb=e+48|0;return a}function MK(a){var b=0,c=0,d=0,e=0,f=0;f=x[124115];if(x[a+72>>2]<=0){My(a)}x[124115]=x[a+136>>2];c=fb-32|0;fb=c;a:{b:{c:{b=x[a+4>>2];d=x[a+8>>2];if((b|0)==(d|0)){break c}b=LK(c+28|0,b,d-b|0);if((b|0)==-1){break c}x[a+4>>2]=!b+(b+x[a+4>>2]|0);break b}x[c+16>>2]=0;x[c+20>>2]=0;b=0;while(1){d=b;d:{b=x[a+4>>2];if((b|0)!=x[a+8>>2]){x[a+4>>2]=b+1;v[c+15|0]=y[b|0];break d}b=yt(a);v[c+15|0]=b;if((b|0)>=0){break d}b=-1;if(!(d&1)){break a}x[a>>2]=x[a>>2]|32;x[31484]=25;break a}b=1;e=eq(c+28|0,c+15|0,1,c+16|0);if((e|0)==-2){continue}break}b=-1;if((e|0)!=-1){break b}if(!(d&1)){break a}x[a>>2]=x[a>>2]|32;eo(y[c+15|0],a);break a}b=x[c+28>>2]}fb=c+32|0;x[124115]=f;return b}function D7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=fb-416|0;fb=h;d=h+416|0;x[h+12>>2]=d;c=fb-144|0;fb=c;x[c+28>>2]=c+132;i=c+32|0;jK(x[a+8>>2],i,c+28|0,e,f,g);x[c+16>>2]=0;x[c+20>>2]=0;x[c+12>>2]=i;e=h+16|0;f=oc(e,x[h+12>>2]);a=Ei(e,c+12|0,f,c+16|0,x[a+8>>2]);if((a|0)==-1){fo(12677);p()}x[h+12>>2]=e+(a<<2);fb=c+144|0;f=fb-16|0;fb=f;i=f+8|0;a=fb-32|0;fb=a;fd(a+24|0,e,x[h+12>>2]);h=a+16|0;e=x[a+24>>2];g=x[a+28>>2];c=fb-16|0;fb=c;x[c+12>>2]=b;while(1){if((e|0)!=(g|0)){cL(c+12|0,x[e>>2]);e=e+4|0;continue}break}rc(h,g,c+12|0);fb=c+16|0;b=x[a+16>>2];x[a+12>>2]=x[a+20>>2];rc(i,b,a+12|0);fb=a+32|0;fb=f+16|0;fb=d;return x[f+12>>2]}function jma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=fb-16|0;fb=e;h=x[a+24>>2];i=x[a+20>>2];j=x[a+16>>2];g=x[a+4>>2];x[e+8>>2]=x[a>>2];x[e+12>>2]=g;k=b+24|0;g=x[a+8>>2];l=x[a+12>>2];while(1){if(d){b=x[e+8>>2];f=x[e+12>>2]+j|0;b=(((b>>>16|0)+4&131064)<<1)+k|0;b=((((D(v[f+2|0],w[b+10>>1])+D(v[f+1|0],w[b+8>>1])|0)+D(v[f+3|0],w[b+12>>1])|0)+D(v[f+4|0],w[b+14>>1])<<8>>1)+(((D(v[f-2|0],w[b+2>>1])+D(v[f-3|0],w[b>>1])|0)+D(v[f-1|0],w[b+4>>1])|0)+D(v[f|0],w[b+6>>1])<<8>>1)|0)/16384|0;x[c>>2]=x[c>>2]+D(b,i);x[c+4>>2]=x[c+4>>2]+D(b,h);Pb(e+8|0,g,l);c=c+8|0;d=d-1|0;continue}break}b=x[e+12>>2];x[a>>2]=x[e+8>>2];x[a+4>>2]=b;fb=e+16|0}function j9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=fb-16|0;fb=f;a:{b:{if(!mc(b,-1)){i=x[a+8>>2];j=x[a+12>>2];d=x[a+24>>2];if((d|0)==x[a+28>>2]){c=-1;if(!(y[a+48|0]&16)){break a}k=x[a+44>>2];h=x[a+20>>2];x[31609]=0;g=a+32|0;O(115,g|0,0);e=x[31609];x[31609]=0;if((e|0)==1){break b}e=Mc(g);x[31609]=0;O(46,g|0,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break b}c=Kb(g);Fx(a,c,Cb(x[a+36>>2],y[a+43|0])+c|0);ys(a,d-h|0);x[a+44>>2]=x[a+20>>2]+(k-h|0);d=x[a+24>>2]}x[f+12>>2]=d+1;d=x[bd(f+12|0,a+44|0)>>2];x[a+44>>2]=d;if(y[a+48|0]&8){c=Kb(a+32|0);Wn(a,c,c+(j-i|0)|0,d)}c=kL(a,b<<24>>24);break a}c=Qy(b);break a}Y(T(0)|0)|0;Z()}fb=f+16|0;return c|0}function co(a,b,c,d,e,f,g,h,i,j,k){var l=0,m=0,n=0;a:{b:{l=x[d>>2];if((l|0)!=(c|0)){break b}m=43;n=a&255;if((n|0)!=y[k+24|0]){m=45;if(y[k+25|0]!=(n|0)){break b}}x[d>>2]=c+1;v[c|0]=m;break a}c:{if(!(!Cb(g,h)|(a|0)!=(f|0))){h=0;a=x[j>>2];if((a-i|0)>159){break c}b=x[e>>2];x[j>>2]=a+4;x[a>>2]=b;break a}h=-1;a=Hi(k,k+26|0,a)-k|0;if((a|0)>23){break c}d:{e:{switch(b-8|0){case 0:case 2:if((a|0)<(b|0)){break d}break c;case 1:break d;default:break e}}if((b|0)!=16|(a|0)<22){break d}if((c|0)==(l|0)|(l-c|0)>2|y[l-1|0]!=48){break c}x[e>>2]=0;x[d>>2]=l+1;v[l|0]=y[a+95168|0];return 0}x[d>>2]=l+1;v[l|0]=y[a+95168|0];x[e>>2]=x[e>>2]+1;h=0}return h}x[e>>2]=0;return 0}function Poa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-160|0;fb=e;b=-1;a:{if(!xm(a,80)){break a}b:{c:{if(!Xl(a,60)){break c}d=e+140|0;if(!SW(a,d)){break c}c=15;if(yv(d,15)){break b}}if(!xm(a,144)){break a}b=0;if(!Xl(a,124)){break a}d=e+140|0;if(!SW(a,d)){break a}c=31;if(!yv(d,31)){break a}}uE(a);b=0;d:{while(1){if((b&65535)>>>0>=c>>>0){break d}b=b+1|0;if(QW(a)>>>0<=131072){continue}break}b=0;break a}b=-1;if(!id(a,D(c,30)|20)){break a}c=fb-16|0;fb=c;f=e+10|0;WC(c+8|0,f);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((d|0)==(g|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(g|0);if(!a){MC(f)}if(!a){break a}b=RW(y[e+10|0])}fb=e+160|0;return b|0}function Lma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=fb-16|0;fb=b;f=x[a+40>>2];g=x[a+36>>2];i=x[a+16>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;j=x[a+32>>2];k=x[a+28>>2];l=x[a+8>>2];m=x[a+12>>2];while(1){if(d){e=x[b+8>>2];h=(x[b+12>>2]<<1)+i|0;e=e>>>21&2040;e=(((D(w[h>>1],w[e+38082>>1])+D(w[h-2>>1],w[e+38080>>1])|0)+D(w[h+2>>1],w[e+38084>>1])|0)+D(w[h+4>>1],w[e+38086>>1])|0)/16384|0;g=g+k|0;x[c>>2]=x[c>>2]+D(e,g>>12);f=f+j|0;x[c+4>>2]=x[c+4>>2]+D(e,f>>12);Pb(b+8|0,l,m);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;x[a+40>>2]=f;x[a+20>>2]=g>>12;x[a+36>>2]=g;x[a+24>>2]=f>>12;fb=b+16|0}function ss(a){var b=0,c=0,d=0,e=0;b=fb-32|0;fb=b;c=b+8|0;Dc(c,13707);x[31609]=0;d=b+20|0;S(123,d|0,1,c|0);e=x[31609];x[31609]=0;a:{b:{c:{if((e|0)!=1){x[31609]=0;O(12,a|0,d|0);e=x[31609];x[31609]=0;if((e|0)==1){break c}Ub(d);tb(c);fb=b+32|0;break a}a=N()|0;break b}a=N()|0;Ub(b+20|0)}tb(b+8|0);Q(a|0);p()}x[31609]=0;b=ca(117)|0;c=x[31609];x[31609]=0;d:{if((c|0)==1){break d}x[a+12>>2]=b;x[31609]=0;b=ca(118)|0;c=x[31609];x[31609]=0;if((c|0)==1){break d}v[a+16|0]=b;x[31609]=0;b=ca(119)|0;c=x[31609];x[31609]=0;if((c|0)==1){break d}v[a+18|0]=0;v[a+17|0]=b;x[31609]=0;W(120,a+20|0);b=x[31609];x[31609]=0;if((b|0)==1){break d}return}b=N()|0;tb(a);Q(b|0);p()}function K8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=fb-32|0;fb=c;a:{if(mc(b,-1)){e=b;if(y[a+52|0]){break a}e=x[a+48>>2];f=a,g=mc(e,-1)^1,v[f+52|0]=g;break a}b:{e=y[a+52|0];if(!(!y[a+53|0]|!e)){e=-1;if(!NK(x[a+48>>2],x[a+32>>2])){break a}break b}if(!e){break b}v[c+19|0]=x[a+48>>2]<<24>>24;e=-1;c:{d:{d=c+20|0;switch(lr(x[a+36>>2],x[a+40>>2],c+19|0,d,c+12|0,c+24|0,c+32|0,d)-1|0){case 0:case 1:break a;case 2:break d;default:break c}}d=x[a+48>>2];x[c+20>>2]=c+25;v[c+24|0]=d}while(1){d=x[c+20>>2];if(d>>>0<=c+24>>>0){break b}d=d-1|0;x[c+20>>2]=d;if((eo(v[d|0],x[a+32>>2])|0)!=-1){continue}break}break a}v[a+52|0]=1;x[a+48>>2]=b;e=b}fb=c+32|0;return e|0}function wra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=fb-32|0;fb=d;x[d+28>>2]=0;Hk(a,d+28|0);a:{b:{i=x[d+28>>2];c:{if(i>>>0>500){break c}d:{e:{while(1){if((f|0)==(i|0)){break c}h=Fb(d+16|0);x[31609]=0;w[d+14>>1]=0;g=U(495,a|0,h|0,255)|0;e=x[31609];x[31609]=0;if((e|0)==1){break b}if(!g){break d}x[31609]=0;g=d+14|0;O(484,a|0,g|0);e=x[31609];x[31609]=0;if((e|0)==1){break b}x[31609]=0;S(496,d|0,c|0,h|0);e=x[31609];x[31609]=0;if((e|0)!=1){x[31609]=0;g=P(497,b|0,g|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break e}zb(g,d);tb(d);tb(h);f=f+1|0;continue}break}f=N()|0;break a}f=N()|0;tb(d);break a}tb(h)}fb=d+32|0;return}f=N()|0}tb(h);Q(f|0);p()}function Pka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=fb-80|0;fb=e;d=Rf(e+52|0);x[31609]=0;g=P(835,b|0,d|0)|0;f=x[31609];x[31609]=0;a:{b:{c:{if((f|0)!=1){if(g){break c}x[a>>2]=0;x[a+4>>2]=0;x[a+24>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;x[31609]=0;R(836,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break b}}break a}g=x[d+4>>2];x[31609]=0;f=e+12|0;S(185,f|0,b|0,g|0);h=x[31609];x[31609]=0;if((h|0)==1){break a}h=hc(e+32|0,f);kd(d+8|0,h);ub(h);ub(f);d:{if(c>>>0<2){break d}c=g&1;if(!c){break d}x[31609]=0;P(183,b|0,2-c|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break d}break a}Pk(a,d)}Hd(d);fb=e+80|0;return}a=N()|0;Hd(d);Q(a|0);p()}function Yra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=b;c=fb-48|0;fb=c;d=a;a:{if(Tv(x[d>>2],x[d+8>>2])){x[g>>2]=0;break a}kZ(c+16|0,c+32|0);lc(c+24|0,x[d>>2],x[d+8>>2],x[c+16>>2],x[c+20>>2]);h=x[c+28>>2];i=y[c+32|0];f=i&127;x[g>>2]=f;a=f;b=0;while(1){if(a){b=b+1|0;a=a>>>1|0;continue}break}a=b;e=1;while(1){b=(D(h,7)+a|0)+D(e,-7)|0;b:{while(1){if(i<<24>>24>=0|e>>>0>=h>>>0){break b}j=c+32|0;i=y[j+e|0];f=i&127|f<<7;x[g>>2]=f;a=a+7|0;e=e+1|0;if((h|0)!=(e|0)){continue}break}Vb(d,h);kZ(c+8|0,j);lc(c+24|0,x[d>>2],x[d+8>>2],x[c+8>>2],x[c+12>>2]);h=x[c+28>>2];f=x[g>>2];e=0;a=b;continue}break}Vb(d,e);if(a>>>0<33){break a}x[g>>2]=-1}fb=c+48|0}function mG(a){a=a|0;var b=0,c=0,d=0,e=0;b=mF(x[(x[x[a>>2]-12>>2]+a|0)+28>>2],10);d=fb-16|0;fb=d;x[31609]=0;c=P(21,d+8|0,a|0)|0;e=x[31609];x[31609]=0;a:{b:{c:{d:{if((e|0)!=1){e:{if(!Id(y[c|0])){break e}e=pp(d+4|0,a);x[31609]=0;b=P(30,e|0,b|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){if(x[b>>2]){break e}b=x[x[a>>2]-12>>2];x[31609]=0;O(24,a+b|0,1);b=x[31609];x[31609]=0;if((b|0)!=1){break e}}b=T(0)|0;hm(c);break d}hm(c);break c}b=T(0)|0}Y(b|0)|0;c=x[x[a>>2]-12>>2];x[31609]=0;W(25,a+c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}Z()}fb=d+16|0;break a}a=N()|0;x[31609]=0;X(26);d=x[31609];x[31609]=0;if((d|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}return rp(a)|0}function gT(a,b,c,d,e){var f=0,g=0,h=0,i=0;a:{b:{c:{if(v[b+851|0]&1){f=y[b+848|0];g=c&240;if(g){f=f&15|g;v[b+848|0]=f}c=c&15;if(c){f=c|f&-16;v[b+848|0]=f}v[b+849|0]=(f&240)>>>4;if(x[a+480180>>2]!=32768){break a}break c}if(x[a+480180>>2]==32768){break c}c=y[b+849|0]-1|0;v[b+849|0]=c;if(c&255){break a}f=y[b+848|0];break b}f=y[b+848|0];if((f&240)==16){break b}if(!(y[a+480209|0]&16)){break a}}v[b+849|0]=(f&240)>>>4;c=f&15;c=d?c:0-c|0;d=x[b+656>>2];d:{if(Lj(d)){x[b+852>>2]=x[b+852>>2]+D(c,x[x[d+44>>2]+36>>2]);break d}h=b,i=zh(a,Ku(a,x[b+700>>2],w[b+772>>1],x[b+704>>2])+c|0,w[b+772>>1],x[b+704>>2]),x[h+700>>2]=i}if(!e){break a}x[b>>2]=0;x[b+4>>2]=0}}function rp(a){var b=0,c=0,d=0,e=0;d=fb-16|0;fb=d;a:{b:{if(!x[(x[x[a>>2]-12>>2]+a|0)+24>>2]){break b}x[31609]=0;c=P(21,d+8|0,a|0)|0;b=x[31609];x[31609]=0;c:{if((b|0)!=1){d:{if(!Id(y[c|0])){break d}b=x[(x[x[a>>2]-12>>2]+a|0)+24>>2];x[31609]=0;b=R(31,b|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){if((b|0)!=-1){break d}b=x[x[a>>2]-12>>2];x[31609]=0;O(24,a+b|0,1);b=x[31609];x[31609]=0;if((b|0)!=1){break d}}b=T(0)|0;hm(c);break c}hm(c);break b}b=T(0)|0}Y(b|0)|0;c=x[x[a>>2]-12>>2];x[31609]=0;W(25,a+c|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}Z()}fb=d+16|0;return a}a=N()|0;x[31609]=0;X(26);c=x[31609];x[31609]=0;if((c|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function vra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=fb-32|0;fb=d;w[d+30>>1]=0;ng(a,d+30|0);a:{b:{i=z[d+30>>1];c:{if(i>>>0>500){break c}d:{e:{while(1){if((f|0)==(i|0)){break c}h=Fb(d+16|0);x[31609]=0;w[d+14>>1]=0;g=P(498,a|0,h|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break b}if(!g){break d}x[31609]=0;g=d+14|0;O(484,a|0,g|0);e=x[31609];x[31609]=0;if((e|0)==1){break b}x[31609]=0;S(496,d|0,c|0,h|0);e=x[31609];x[31609]=0;if((e|0)!=1){x[31609]=0;g=P(497,b|0,g|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break e}zb(g,d);tb(d);tb(h);f=f+1|0;continue}break}f=N()|0;break a}f=N()|0;tb(d);break a}tb(h)}fb=d+32|0;return}f=N()|0}tb(h);Q(f|0);p()}function bo(a,b,c,d,e,f,g,h,i,j,k){var l=0,m=0;a:{b:{l=x[d>>2];if((l|0)!=(c|0)){break b}m=43;if(x[k+96>>2]!=(a|0)){m=45;if(x[k+100>>2]!=(a|0)){break b}}x[d>>2]=c+1;v[c|0]=m;break a}c:{if(!(!Cb(g,h)|(a|0)!=(f|0))){h=0;a=x[j>>2];if((a-i|0)>159){break c}b=x[e>>2];x[j>>2]=a+4;x[a>>2]=b;break a}h=-1;a=Ey(k,k+104|0,a)-k>>2;if((a|0)>23){break c}d:{e:{switch(b-8|0){case 0:case 2:if((a|0)<(b|0)){break d}break c;case 1:break d;default:break e}}if((b|0)!=16|(a|0)<22){break d}if((c|0)==(l|0)|(l-c|0)>2|y[l-1|0]!=48){break c}x[e>>2]=0;x[d>>2]=l+1;v[l|0]=y[a+95168|0];return 0}x[d>>2]=l+1;v[l|0]=y[a+95168|0];x[e>>2]=x[e>>2]+1;h=0}return h}x[e>>2]=0;return 0}function Hra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=fb-32|0;fb=c;e=c+12|0;g=Nb(e+8|0);x[31609]=0;d=R(202,b|0)|0;f=x[31609];x[31609]=0;a:{b:{if((f|0)==1){break b}c:{if(!vZ(d)){x[31609]=0;X(507);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break b}x[31609]=0;d=R(202,b|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break b}x[31609]=0;S(169,e|0,b|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break b}d=x[e>>2];x[31609]=0;P(183,b|0,d|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break b}break a}p()}a=N()|0;ec(g);Q(a|0);p()}Nn(c+4|0,e);x[31609]=0;S(475,a|0,x[c+4>>2],x[c+8>>2]);a=x[31609];x[31609]=0;if((a|0)!=1){Kc(e);fb=c+32|0;return}a=N()|0;Kc(c+12|0);Q(a|0);p()}function $H(a,b,c,d){var e=0,f=0,g=0;f=fb-32|0;fb=f;x[31609]=0;W(996,a|0);e=x[31609];x[31609]=0;a:{b:{c:{d:{e:{f:{if((e|0)==1){break f}x[31609]=0;W(997,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break f}g=x[a+24>>2];x[31609]=0;e=P(36,f+8|0,b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break e}x[31609]=0;b=d;d=f+20|0;S(b|0,d|0,g|0,e|0);b=x[31609];x[31609]=0;if((b|0)==1){break d}b=Cg(Kb(d));tb(d);tb(e);break b}b=T(0)|0;break c}b=T(0)|0;break c}b=T(0)|0;tb(e)}Y(b|0)|0;b=0;x[31609]=0;V(983,c|0,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z()}fb=f+32|0;return b}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Mma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=fb-16|0;fb=b;f=x[a+40>>2];g=x[a+36>>2];i=x[a+16>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;j=x[a+32>>2];k=x[a+28>>2];l=x[a+8>>2];m=x[a+12>>2];while(1){if(d){e=x[b+8>>2];h=x[b+12>>2]+i|0;e=e>>>21&2040;e=(((D(v[h|0],w[e+38082>>1])+D(v[h-1|0],w[e+38080>>1])|0)+D(v[h+1|0],w[e+38084>>1])|0)+D(v[h+2|0],w[e+38086>>1])<<8)/16384|0;g=g+k|0;x[c>>2]=x[c>>2]+D(e,g>>12);f=f+j|0;x[c+4>>2]=x[c+4>>2]+D(e,f>>12);Pb(b+8|0,l,m);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;x[a+40>>2]=f;x[a+20>>2]=g>>12;x[a+36>>2]=g;x[a+24>>2]=f>>12;fb=b+16|0}function V9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=fb-32|0;fb=d;h=Fb(a);f=Fb(d+20|0);a=1;a:{b:{c:{while(1){e=a&65535;c=x[b+24>>2];if(e>>>0>z[c+480192>>1]){if(!(i&1)){break c}x[31609]=0;O(247,h|0,f|0);a=x[31609];x[31609]=0;if((a|0)!=1){break c}a=N()|0;break a}c=_R(c,e);x[31609]=0;c=P(36,d+8|0,c|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break b}e=Ad(x[d+12>>2],y[d+19|0]);x[31609]=0;g=P(838,f|0,c|0)|0;j=x[31609];x[31609]=0;d:{if((j|0)==1){break d}x[31609]=0;P(985,g|0,22267)|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}i=e^1|i;tb(c);a=a+1|0;continue}break}a=N()|0;tb(c);break a}tb(f);fb=d+32|0;return}a=N()|0}tb(f);tb(h);Q(a|0);p()}function Sz(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;c=fb-16|0;fb=c;x[c>>2]=a;x[c+4>>2]=b;x[c+8>>2]=a;x[c+12>>2]=b;b=fb+-64|0;fb=b;a:{if(!x[c+4>>2]){break a}a=x[c>>2];h=x[c+4>>2];while(1){if((e|0)==432){while(1){e=(g|0)!=48;if((g|0)==48){break a}x[b+40>>2]=a;x[b+44>>2]=h;f=qc(b+32|0,x[g+31e3>>2]);d=x[b+44>>2];x[b+8>>2]=x[b+40>>2];x[b+12>>2]=d;d=x[f+4>>2];x[b>>2]=x[f>>2];x[b+4>>2]=d;g=g+12|0;if(!JR(b+8|0,b)){continue}break a}}x[b+56>>2]=a;x[b+60>>2]=h;f=qc(b+48|0,x[e+30564>>2]);d=x[b+60>>2];x[b+24>>2]=x[b+56>>2];x[b+28>>2]=d;d=x[f+4>>2];x[b+16>>2]=x[f>>2];x[b+20>>2]=d;e=e+8|0;if(!JR(b+24|0,b+16|0)){continue}break}e=1}fb=b- -64|0;fb=c+16|0;return e}function g1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=fb-32|0;fb=c;nd(b,0);e=c+16|0;f=qf(e,1,v[a+1|0]);Be(b+43|0,f);tb(f);x[b>>2]=y[a+6|0]|y[a+7|0]<<8|(y[a+8|0]<<16|y[a+9|0]<<24);x[b+24>>2]=y[a+10|0]|y[a+11|0]<<8;v[c+16|0]=y[a+12|0];v[c+12|0]=64;g=b,h=y[Qb(e,c+12|0)|0]<<2,w[g+30>>1]=h;x[b+4>>2]=y[a+13|0]|y[a+14|0]<<8|(y[a+15|0]<<16|y[a+16|0]<<24);e=y[a+19|0];f=y[a+17|0]|y[a+18|0]<<8;v[c+14|0]=0;v[c+18|0]=e;w[c+16>>1]=f;w[c+12>>1]=0;while(1){if((d|0)!=3){e=xb(c+16|0,d);g=xb(c+12|0,d),h=y[e|0],v[g|0]=h;d=d+1|0;continue}break}d=cg(c+12|0);x[b+8>>2]=d;if(!(!y[a|0]|d>>>0<=x[b+4>>2]+2>>>0|d>>>0>A[b>>2])){w[b+34>>1]=z[b+34>>1]|2}fb=c+32|0}function A7(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=fb-16|0;fb=k;l=j;a:{if(a){a=k+4|0;b=WJ(b);ml(a,b);j=x[k+4>>2];v[c|0]=j;v[c+1|0]=j>>>8;v[c+2|0]=j>>>16;v[c+3|0]=j>>>24;ll(a,b);zb(i,a);tb(a);fi(a,b);zb(h,a);tb(a);m=d,n=nj(b),v[m|0]=n;m=e,n=oj(b),v[m|0]=n;sh(a,b);zb(f,a);tb(k+4|0);gi(a,b);zb(g,a);tb(k+4|0);a=Lk(b);break a}a=k+4|0;b=VJ(b);ml(a,b);j=x[k+4>>2];v[c|0]=j;v[c+1|0]=j>>>8;v[c+2|0]=j>>>16;v[c+3|0]=j>>>24;ll(a,b);zb(i,a);tb(a);fi(a,b);zb(h,a);tb(a);m=d,n=nj(b),v[m|0]=n;m=e,n=oj(b),v[m|0]=n;sh(a,b);zb(f,a);tb(k+4|0);gi(a,b);zb(g,a);tb(k+4|0);a=Lk(b)}x[l>>2]=a;fb=k+16|0}function bsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=x[a>>2];d=Ar(c,x[a+4>>2]);if(d>>>0<b>>>0){f=fb-32|0;fb=f;c=b-d|0;b=x[Ab(a)>>2];e=x[a+4>>2];a:{if(c>>>0<=(b-e|0)/40>>>0){d=fb-16|0;fb=d;b=B$(d+4|0,a,c);a=x[b+4>>2];c=x[b+8>>2];while(1){if((a|0)==(c|0)){kc(b);fb=d+16|0}else{gZ(a);a=a+40|0;x[b+4>>2]=a;continue}break}break a}b=Ab(a);d=y$(f+12|0,z$(a,Ar(x[a>>2],e)+c|0),Ar(x[a>>2],x[a+4>>2]),b);e=fb-16|0;fb=e;g=x[d+8>>2];b=e+4|0;x[b+8>>2]=d+8;x[b>>2]=g;x[b+4>>2]=D(c,40)+g;c=x[b>>2];while(1){if(x[b+4>>2]!=(c|0)){gZ(c);c=x[b>>2]+40|0;x[b>>2]=c;continue}break}je(b);fb=e+16|0;x$(a,d);w$(d)}fb=f+32|0;return}if(b>>>0<d>>>0){Jd(a,c+D(b,40)|0)}}function U9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=fb-32|0;fb=c;h=Fb(a);f=Fb(c+20|0);a=1;a:{b:{c:{while(1){d=a&65535;e=x[b+24>>2];if(d>>>0>z[e+480190>>1]){if(!(i&1)){break c}x[31609]=0;O(247,h|0,f|0);a=x[31609];x[31609]=0;if((a|0)!=1){break c}a=N()|0;break a}x[31609]=0;e=P(36,c+8|0,$R(e,d)|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break b}d=Ad(x[c+12>>2],y[c+19|0]);x[31609]=0;g=P(838,f|0,e|0)|0;j=x[31609];x[31609]=0;d:{if((j|0)==1){break d}x[31609]=0;P(985,g|0,22267)|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}i=d^1|i;tb(e);a=a+1|0;continue}break}a=N()|0;tb(e);break a}tb(f);fb=c+32|0;return}a=N()|0}tb(f);tb(h);Q(a|0);p()}function R8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=fb-32|0;fb=c;a:{if(jo(b)){e=b;if(y[a+52|0]){break a}e=x[a+48>>2];f=a,g=jo(e)^1,v[f+52|0]=g;break a}b:{e=y[a+52|0];if(!(!y[a+53|0]|!e)){e=-1;if(!PK(x[a+48>>2],x[a+32>>2])){break a}break b}if(!e){break b}x[c+16>>2]=x[a+48>>2];e=-1;c:{d:{d=c+20|0;switch(lr(x[a+36>>2],x[a+40>>2],c+16|0,d,c+12|0,c+24|0,c+32|0,d)-1|0){case 0:case 1:break a;case 2:break d;default:break c}}d=x[a+48>>2];x[c+20>>2]=c+25;v[c+24|0]=d}while(1){d=x[c+20>>2];if(d>>>0<=c+24>>>0){break b}d=d-1|0;x[c+20>>2]=d;if((eo(v[d|0],x[a+32>>2])|0)!=-1){continue}break}break a}v[a+52|0]=1;x[a+48>>2]=b;e=b}fb=c+32|0;return e|0}function t7(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=fb-16|0;fb=k;l=j;a:{if(a){a=k+4|0;b=TJ(b);ml(a,b);j=x[k+4>>2];v[c|0]=j;v[c+1|0]=j>>>8;v[c+2|0]=j>>>16;v[c+3|0]=j>>>24;ll(a,b);nh(i,a);Ub(a);fi(a,b);nh(h,a);Ub(a);m=d,n=nj(b),x[m>>2]=n;m=e,n=oj(b),x[m>>2]=n;sh(a,b);zb(f,a);tb(a);gi(a,b);nh(g,a);Ub(k+4|0);a=Lk(b);break a}a=k+4|0;b=SJ(b);ml(a,b);j=x[k+4>>2];v[c|0]=j;v[c+1|0]=j>>>8;v[c+2|0]=j>>>16;v[c+3|0]=j>>>24;ll(a,b);nh(i,a);Ub(a);fi(a,b);nh(h,a);Ub(a);m=d,n=nj(b),x[m>>2]=n;m=e,n=oj(b),x[m>>2]=n;sh(a,b);zb(f,a);tb(a);gi(a,b);nh(g,a);Ub(k+4|0);a=Lk(b)}x[l>>2]=a;fb=k+16|0}function Mka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=fb-16|0;fb=g;e=Kb(b);d=Cb(x[b+4>>2],y[b+11|0]);i=Kb(c);j=Cb(x[c+4>>2],y[c+11|0]);f=-1;a:{if(!d){break a}h=d+e|0;d=e;while(1){if((d|0)==(h|0)){break a}if(rq(i,j,y[d|0])){d=d+1|0;continue}break}f=d-e|0}b:{c:{if((f|0)!=-1){c=vb(g+12|0,zd(b));d=vb(g+8|0,uf(zd(b),f));Yr(b,x[c>>2],x[d>>2]);break c}f=_c(x[b+4>>2],y[b+11|0]);if(!f){break c}e=Kb(b);i=Cb(x[b+4>>2],y[b+11|0]);j=Kb(c);d=-1;h=Cb(x[c+4>>2],y[c+11|0]);if(h){c=e+i|0;d:{while(1){if((c|0)==(e|0)){break d}c=c-1|0;if(!rq(j,h,y[c|0])){continue}break}d=c-e|0}}if((f-1|0)!=(d|0)){break c}Fb(a);break b}Uc(a,b)}fb=g+16|0}function GC(a,b,c,d,e,f){var g=0,h=0,i=0,j=0;g=fb-16|0;fb=g;h=x[a>>2];a:{if(Xc(h,x[a+4>>2])>>>0<=b>>>0){break a}b:{c:{switch(c|0){case 0:if((d|0)>=0){i=xb(h,b),j=d^128,v[i|0]=j}c=g+8|0;Jb(c,x[a+24>>2],b);kf(c,0);break b;case 2:i=xb(h,b),j=128,v[i|0]=j;c=g+8|0;Jb(c,x[a+24>>2],b);kf(c,1);break b;case 4:break c;default:break b}}i=xb(h,b),j=128,v[i|0]=j;c=g+8|0;Jb(c,x[a+24>>2],b);kf(c,0)}if(y[e|0]){break a}c=x[f+4>>2];if(mc(x[f>>2],c)){break a}c=mX(c);if(y[xb(x[c>>2],b)|0]==y[xb(x[a>>2],b)|0]){Jb(g+8|0,x[c+24>>2],b);c=Gb(x[x[g+8>>2]>>2],x[g+12>>2]);Jb(g,x[a+24>>2],b);if((Gb(x[x[g>>2]>>2],x[g+4>>2])|0)==(c|0)){break a}}v[e|0]=1}fb=g+16|0}function y2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=fb-16|0;fb=g;e=Kb(b);d=Cb(x[b+4>>2],y[b+11|0]);i=Kb(c);j=Cb(x[c+4>>2],y[c+11|0]);f=-1;a:{if(!d){break a}h=d+e|0;d=e;while(1){if((d|0)==(h|0)){break a}if(Cu(i,j,y[d|0])){d=d+1|0;continue}break}f=d-e|0}b:{c:{if((f|0)!=-1){c=vb(g+12|0,zd(b));d=vb(g+8|0,uf(zd(b),f));Yr(b,x[c>>2],x[d>>2]);break c}f=_c(x[b+4>>2],y[b+11|0]);if(!f){break c}e=Kb(b);i=Cb(x[b+4>>2],y[b+11|0]);j=Kb(c);d=-1;h=Cb(x[c+4>>2],y[c+11|0]);if(h){c=e+i|0;d:{while(1){if((c|0)==(e|0)){break d}c=c-1|0;if(!Cu(j,h,y[c|0])){continue}break}d=c-e|0}}if((f-1|0)!=(d|0)){break c}Fb(a);break b}Uc(a,b)}fb=g+16|0}function qqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=E(0),g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=fb-16|0;fb=c;a:{b:{d=x[b+8>>2];if((d|0)==x[a+8>>2]){e=x[b+4>>2];if((e|0)!=x[a+4>>2]){break b}x[c+12>>2]=d;x[c+8>>2]=d;d=x[Hb(c+12|0,c+8|0)>>2];x[c+12>>2]=e;x[c+8>>2]=e;h=x[Hb(c+12|0,c+8|0)>>2];i=x[a>>2];j=x[b>>2];b=0;c:while(1){if((b|0)==(d|0)){break a}k=(D(b,e)<<1)+i|0;a=0;while(1)if((a|0)==(h|0)){b=b+1|0;continue c}else{l=(a<<1)+k|0;f=ni(E(Pd(B[x[(a<<2)+j>>2]+(b<<2)>>2],E(-1))*E(32768)));d:{if(E(F(f))<E(2147483648)){g=~~f;break d}g=-2147483648}m=l,n=gd(g),w[m>>1]=n;a=a+1|0;continue}}}_(17387,8999,27,9541);p()}_(17337,8999,28,9541);p()}fb=c+16|0}function uja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=fb-80|0;fb=e;d=Rf(e+52|0);x[31609]=0;g=P(911,b|0,d|0)|0;f=x[31609];x[31609]=0;a:{b:{c:{if((f|0)!=1){if(g){break c}x[a>>2]=0;x[a+4>>2]=0;x[a+24>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;x[31609]=0;R(912,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break b}}break a}g=x[d+4>>2];x[31609]=0;f=e+12|0;S(185,f|0,b|0,g|0);h=x[31609];x[31609]=0;if((h|0)==1){break a}h=hc(e+32|0,f);kd(d+8|0,h);ub(h);ub(f);d:{if(!(g&1)|c>>>0<2){break d}x[31609]=0;P(183,b|0,1)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break d}break a}Pk(a,d)}Hd(d);fb=e+80|0;return}a=N()|0;Hd(d);Q(a|0);p()}function g4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;a:{b:{c:{if(ji(b,14337)){d=Zs(c+28|0,b);e=x[d>>2];if(!Ed(e)){x[31609]=0;b=P(36,c+4|0,b|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}x[31609]=0;a=c+16|0;S(1011,a|0,17826,b|0);e=x[31609];x[31609]=0;d:{e:{if((e|0)!=1){x[31609]=0;W(1367,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break e}p()}a=N()|0;break d}a=N()|0;tb(c+16|0)}tb(b);break a}Ys(e);if(!Xs(a+8|0,16806,x[d>>2])){v[a+8|0]=v[a+8|0]}if(!Xs(a+9|0,22292,x[d>>2])){v[a+9|0]=v[a+9|0]}x[31609]=0;O(272,a+12|0,22292);a=x[31609];x[31609]=0;if((a|0)==1){break b}il(d)}fb=c+32|0;return}a=N()|0;break a}a=N()|0}il(d);Q(a|0);p()}function jla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=fb+-64|0;fb=c;f=wU(a,1<<b-1);x[f+12>>2]=b;l(0,1413754136-0|0);l(1,-1072094725-((b<<20)+(d>>>0>1413754136)|0)|0);h=+n();a=1;g=1<<b>>>2|0;b=g;while(1){if(b){e=x[10057];d=c+32|0;x[d+8>>2]=x[10056];x[d+12>>2]=e;e=x[10055];x[d>>2]=x[10054];x[d+4>>2]=e;PB(d,h*+(b>>>0));rU(c+48|0,C[c+32>>3],C[c+40>>3]);d=Yd(x[f>>2],a);e=x[c+60>>2];x[d+8>>2]=x[c+56>>2];x[d+12>>2]=e;e=x[c+52>>2];x[d>>2]=x[c+48>>2];x[d+4>>2]=e;b=b>>>1|0;a=a<<1;continue}break}a=Ql(c+16|0,1,0);b=x[a+12>>2];x[c+8>>2]=x[a+8>>2];x[c+12>>2]=b;b=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=b;AA(f,0,g,c);fb=c- -64|0;return f|0}function Tka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=fb-80|0;fb=f;d=Rf(f+52|0);x[31609]=0;c=P(827,b|0,d|0)|0;e=x[31609];x[31609]=0;a:{b:{c:{if((e|0)!=1){if(c){break c}x[a>>2]=0;x[a+4>>2]=0;x[a+24>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;x[31609]=0;R(828,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break b}}break a}e=x[d+4>>2];x[31609]=0;c=f+12|0;e=$b(e);S(185,c|0,b|0,e|0);g=x[31609];x[31609]=0;if((g|0)==1){break a}g=hc(f+32|0,c);kd(d+8|0,g);ub(g);ub(c);d:{c=e&1;if(!c){break d}x[31609]=0;P(183,b|0,2-c|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break d}break a}Pk(a,d)}Hd(d);fb=f+80|0;return}a=N()|0;Hd(d);Q(a|0);p()}function hja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;a:{x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);c=x[b>>2];e=c;d=x[b+4>>2];f=d;d=Ik(c,d);c=fb-16|0;fb=c;Rd(c+8|0,x[vb(c+4|0,a)>>2]);b:{c:{if(d){x[31609]=0;O(460,a|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break c}sA(a,e,f,d)}d=c+8|0;Qd(d);bm(d);fb=c+16|0;break b}a=N()|0;bm(c+8|0);Q(a|0);p()}x[a+20>>2]=x[b+20>>2];c=x[b+16>>2];x[a+12>>2]=x[b+12>>2];x[a+16>>2]=c;x[31609]=0;c=P(921,a+24|0,b+24|0)|0;d=x[31609];x[31609]=0;d:{e:{if((d|0)!=1){x[31609]=0;P(71,a+36|0,b+36|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break e}x[a+48>>2]=x[b+48>>2];break a}b=N()|0;break d}b=N()|0;wc(c)}Nk(a);Q(b|0);p()}}function gba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=fb+-64|0;fb=f;d=f+16|0;h=fb-16|0;fb=h;i=rP(h+8|0);l=f+4|0;while(1){if((j|0)==12){fb=h+16|0}else{g=fb+-64|0;fb=g;c=x[i+4>>2];e=x[i>>2];a:{if((c|0)==(e|0)){break a}c=(c-e|0)+1|0;if(!c){c=MM(NM(g+8|0,32));break a}e=G(c);e=NM(g+8|0,(c<<e&2147483647?32:31)-e|0);while(1){k=MM(e);if(c>>>0<=k>>>0){continue}break}c=x[i>>2]+k|0}fb=g- -64|0;m=yb(d,j),n=c,x[m>>2]=n;j=j+1|0;continue}break}d=AP(l,d,FP(d));vP(a,d);Xm(d);fb=f- -64|0;d=wz(a+120|0,a,b);v[d+20|0]=1;x[31609]=0;O(1150,a|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){a=N()|0;to(d);Q(a|0);p()}return a|0}function wta(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=d$(c,d);g=fb-32|0;fb=g;f=b;b=x[a>>2];b=Ak(f,wb(b))+b|0;a:{if((e|0)<=0){break a}h=x[Ab(a)>>2];f=x[a+4>>2];if((e|0)<=(h-f|0)){i=g,j=a$(c,e),x[i+12>>2]=j;h=f-b|0;if((e|0)>(h|0)){x[g+12>>2]=c;$_(g+12|0,h);zn(a,x[g+12>>2],d,e-h|0);if((h|0)<=0){break a}}__(a,b,f,b+e|0);aE(c,x[g+12>>2],b);break a}d=Ab(a);f=qn(g+12|0,Wl(a,Xc(x[a>>2],f)+e|0),b-x[a>>2]|0,d);d=fb-16|0;fb=d;x[d+12>>2]=c;c=BC(d,f+8|0,e);e=x[c>>2];while(1){if(x[c+4>>2]!=(e|0)){po(e,y[x[d+12>>2]]);e=x[c>>2]+1|0;x[c>>2]=e;we(d+12|0);continue}break}je(c);fb=d+16|0;b=Z_(a,f,b);pn(f)}wb(b);fb=g+32|0}function UO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-32|0;fb=e;g=Nb(a);a=z[x[b+24>>2]+480192>>1];x[31609]=0;O(176,g|0,a|0);c=x[31609];x[31609]=0;a=1;a:{if((c|0)!=1){b:{c:{d:{e:{while(1){d=a&65535;c=x[b+24>>2];if(d>>>0>z[c+480192>>1]){break b}c=_R(c,d);x[31609]=0;c=P(36,e+8|0,c|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){f=x[b+24>>2];x[31609]=0;d=e+20|0;S(1053,d|0,f|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break e}x[31609]=0;O(178,g|0,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break d}tb(d);tb(c);a=a+1|0;continue}break}a=N()|0;break a}a=N()|0;break c}a=N()|0;tb(e+20|0)}tb(c);break a}fb=e+32|0;return}a=N()|0}Td(g);Q(a|0);p()}function Yw(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=fb-16|0;fb=f;v[f+15|0]=d;v[b+12|0]=y[b+12|0]&240|y[a|0]&15;i=a+1|0;e=f+15|0;fh(b,y[Qb(i,e)|0]);g=y[Qb(a+2|0,e)|0];v[b+13|0]=g;k=b,l=Ld(y[a+3|0],g,d),v[k+14|0]=l;e=y[Qb(a+4|0,e)|0];v[b+15|0]=e;k=b,l=Ld(y[a+5|0],e,d),v[k+16|0]=l;g=x[b>>2];b=0;while(1){v[f+14|0]=25;if(b>>>0<y[Qb(f+14|0,i)|0]){e=D(b,3)+a|0;h=Yb(y[e+6|0]+c<<24>>24,0,64);d=yb(g,b);v[d+2|0]=h;e=y[e+7|0]|y[e+8|0]<<8;w[d>>1]=e;a:{if(!b){break a}h=yb(g,b-1|0);j=z[h>>1];if(e>>>0>255|e>>>0>=j>>>0){break a}e=e|j&65280;w[d>>1]=e;if(z[h>>1]<=(e&65535)>>>0){break a}w[d>>1]=e+256}b=b+1|0;continue}break}fb=f+16|0}function zW(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=fb-16|0;fb=f;d=vb(f+12|0,x[a+4>>2]);c=vb(f+8|0,x[a>>2]);g=x[vb(f+4|0,x[b+4>>2])>>2];h=fb-16|0;fb=h;i=h+8|0;e=fb-32|0;fb=e;fd(e+24|0,x[d>>2],x[c>>2]);j=e+16|0;c=x[e+24>>2];k=x[e+28>>2];d=fb-16|0;fb=d;x[d+8>>2]=g;x[d+12>>2]=c;while(1){if(Fd(c,k)){c=cl(c);g=cl(x[d+8>>2]);x[g+8>>2]=x[c+8>>2];l=x[c+4>>2];x[g>>2]=x[c>>2];x[g+4>>2]=l;c=lk(d+12|0);lk(d+8|0);c=x[c>>2];continue}break}rc(j,c,d+8|0);fb=d+16|0;d=x[e+16>>2];x[e+12>>2]=x[e+20>>2];rc(i,d,e+12|0);fb=e+32|0;fb=h+16|0;x[b+4>>2]=x[h+12>>2];Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=f+16|0}function pqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=E(0),g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=fb-16|0;fb=c;a:{b:{d=x[b+8>>2];if((d|0)==x[a+8>>2]){e=x[b+4>>2];if((e|0)!=x[a+4>>2]){break b}x[c+12>>2]=d;x[c+8>>2]=d;d=x[Hb(c+12|0,c+8|0)>>2];x[c+12>>2]=e;x[c+8>>2]=e;h=x[Hb(c+12|0,c+8|0)>>2];i=x[a>>2];j=x[b>>2];b=0;c:while(1){if((b|0)==(d|0)){break a}k=D(b,e)+i|0;a=0;while(1)if((a|0)==(h|0)){b=b+1|0;continue c}else{l=a+k|0;f=ni(E(Pd(B[x[(a<<2)+j>>2]+(b<<2)>>2],E(-1))*E(128)));d:{if(E(F(f))<E(2147483648)){g=~~f;break d}g=-2147483648}m=l,n=lY(g),v[m|0]=n;a=a+1|0;continue}}}_(17387,8999,27,9541);p()}_(17337,8999,28,9541);p()}fb=c+16|0}function wN(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;d=fb-16|0;fb=d;a:{b:{c:{d:{if((b|0)>=0){a=x[a+32>>2];if((wo(a)|0)>(b|0)){break d}}a=ac(8);x[31609]=0;d=P(36,d+4|0,10751)|0;b=x[31609];x[31609]=0;if((b|0)==1){break c}pc(a,d);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}b=N()|0;tb(d);break b}if(c<0|c>1){a=ac(8);x[31609]=0;d=P(36,d+4|0,11768)|0;b=x[31609];x[31609]=0;if((b|0)!=1){pc(a,d);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}b=N()|0;tb(d);break b}b=N()|0;ic(a);break b}e=(a+D(b,872)|0)+1075740|0,f=Ui(c*64),x[e>>2]=f;fb=d+16|0;return}b=N()|0;ic(a)}Q(b|0)}p()}function Wfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;i=e,j=Rj(b),x[i+4>>2]=j;c=fb-16|0;fb=c;g=a;d=de(a);a:{if(d){f=gc(a);while(1){a=d;d=a+16|0;if(Uu(b,d)){f=a;d=x[a>>2];if(d){continue}break a}if(!Uu(d,b)){break a}f=a+4|0;d=x[a+4>>2];if(d){continue}break}break a}a=gc(g);f=a}x[c+12>>2]=a;b=x[f>>2];if(!b){a=fb-16|0;fb=a;b=gc(g);b=Dh(c,Ec(40),Og(a+8|0,b));Fb(Uc(x[b>>2]+16|0,x[e+4>>2])+12|0);i=gc(b),j=1,v[i+4|0]=j;fb=a+16|0;$g(g,x[c+12>>2],f,x[c>>2]);b=ne(c);a=x[c>>2];x[c>>2]=0;if(a){if(y[gc(c)+4|0]){an(a+16|0)}Db(a)}h=1}_g(e+8|0,x[vb(c,b)>>2],h);fb=c+16|0;a=ud(x[e+8>>2]);fb=e+16|0;return a+12|0}function HO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-32|0;fb=e;g=Nb(a);a=z[x[b+24>>2]+480190>>1];x[31609]=0;O(176,g|0,a|0);c=x[31609];x[31609]=0;a=1;a:{if((c|0)!=1){b:{c:{d:{e:{while(1){d=a&65535;c=x[b+24>>2];if(d>>>0>z[c+480190>>1]){break b}x[31609]=0;c=P(36,e+8|0,$R(c,d)|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){f=x[b+24>>2];x[31609]=0;d=e+20|0;S(1053,d|0,f|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break e}x[31609]=0;O(178,g|0,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break d}tb(d);tb(c);a=a+1|0;continue}break}a=N()|0;break a}a=N()|0;break c}a=N()|0;tb(e+20|0)}tb(c);break a}fb=e+32|0;return}a=N()|0}Td(g);Q(a|0);p()}function OY(a){var b=0,c=0,d=0,e=0,f=0;b=fb-32|0;fb=b;e=b,f=$b(y[a+8|0]|y[a+9|0]<<8|(y[a+10|0]<<16|y[a+11|0]<<24))+788|0,x[e>>2]=f;x[b+4>>2]=0;e=b,f=$b(y[a+16|0]|y[a+17|0]<<8|(y[a+18|0]<<16|y[a+19|0]<<24)),x[e+8>>2]=f;x[b+12>>2]=0;c=$b(y[a+24|0]|y[a+25|0]<<8|(y[a+26|0]<<16|y[a+27|0]<<24));x[b+16>>2]=c?c:52;x[b+20>>2]=0;e=b,f=$b(y[a+32|0]|y[a+33|0]<<8|(y[a+34|0]<<16|y[a+35|0]<<24))+80|0,x[e+24>>2]=f;x[b+28>>2]=0;a=b;d=Se(a,4);a:{if((a|0)==(d|0)){break a}c=a;while(1){c=c+8|0;if((d|0)==(c|0)){break a}a=Sw(x[a>>2],x[a+4>>2],x[c>>2],x[c+4>>2])?c:a;continue}}fb=b+32|0;c=x[a>>2];b=c-52|0;hb=x[a+4>>2]-(c>>>0<52)|0;return b}function Zoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=fb-32|0;fb=d;nd(b,0);f=d+8|0;ek(f,1,a);c=d+20|0;Cc(c,f);Be(b+43|0,c);tb(c);x[b>>2]=y[a+48|0]|y[a+49|0]<<8|(y[a+50|0]<<16|y[a+51|0]<<24);x[b+4>>2]=y[a+52|0]|y[a+53|0]<<8|(y[a+54|0]<<16|y[a+55|0]<<24);x[b+8>>2]=y[a+56|0]|y[a+57|0]<<8|(y[a+58|0]<<16|y[a+59|0]<<24);x[b+24>>2]=y[a+62|0]|y[a+63|0]<<8;$l(b,+((y[a+60|0]^8)-120|0)/192);v[d+20|0]=y[a+61|0];v[d+8|0]=64;g=b,h=y[Qb(c,f)|0]<<2,w[g+30>>1]=h;w[b+34>>1]=0;c=y[a+47|0];if(c&4){w[b+34>>1]=1;x[b>>2]=x[b>>2]>>>1;e=1;c=y[a+47|0]}if(c&32){e=e|4;w[b+34>>1]=e;c=y[a+47|0]}if(c<<24>>24<0){w[b+34>>1]=e|2}fb=d+32|0}
function Rna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;g=fb-16|0;fb=g;a:{if(!(c&1024)){break a}i=g,j=zd(b),x[i+12>>2]=j;c=_c(x[b+4>>2],y[b+11|0]);b:{if(!c){break b}if(y[dc(b,0)|0]!=43){if(y[dc(b,0)|0]!=45){break b}}d=d+1|0;pV(g+12|0)}if(c>>>0>=d>>>0){break a}e=x[vb(g+8|0,x[g+12>>2])>>2];c=d-_c(x[b+4>>2],y[b+11|0])|0;c:{e=Ak(e,zd(b));d=Cb(x[b+4>>2],y[b+11|0]);if(e>>>0<=d>>>0){if(c){f=Mc(b);d:{if(c>>>0<=f-d>>>0){f=Kb(b);if((d|0)==(e|0)){break d}h=e+f|0;Pi(c+h|0,h,d-e|0);break d}SB(b,f,(c+d|0)-f|0,d,e,c);f=x[b>>2]}am(e+f|0,c,48);c=c+d|0;lg(b,c);hd(c+f|0,0)}break c}en();p()}zd(b)}Uc(a,b);fb=g+16|0}function zua(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=fb-208|0;fb=d;D0(c,a);C0(c,d+16|0,D(y[a+4|0],3));a:{if(y[a+4|0]<2){break a}c=fb-16|0;fb=c;x[c+12>>2]=64;x[c+8>>2]=255;e=y[Hb(c+12|0,c+8|0)|0];fb=c+16|0;v[d+12|0]=e;fh(b,y[Qb(a+4|0,d+12|0)|0]);v[b+13|0]=y[a+2|0];v[b+14|0]=y[a+3|0];a=y[a+1|0];v[b+15|0]=a;v[b+16|0]=a;e=x[b>>2];f=Sd(e,x[b+4>>2]);a=0;while(1){if((a|0)==(f|0)){break a}b:{if(!a){b=y[d+18|0];c=yb(e,0);break b}g=z[yb(e,a-1|0)>>1];x[d+12>>2]=1;b=(d+16|0)+D(a,3)|0;x[d+8>>2]=(v[b+1|0]&1)<<8|y[b|0];h=Xe(d+12|0,d+8|0);c=yb(e,a);w[c>>1]=z[h>>1]+g;b=y[b+2|0]}v[c+2|0]=b;a=a+1|0;continue}}fb=d+208|0}function lV(a,b,c){a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{b=b&15;switch(b-3|0){case 2:break j;case 1:break k;case 0:break l;case 10:case 11:break b;case 9:break c;case 8:break d;case 7:break e;case 6:break f;case 5:break g;case 4:break h;case 3:break i;default:break a}}v[a+798|0]=0;return}v[a+798|0]=1;return}v[a+798|0]=2;return}v[a+798|0]=3;return}v[a+730|0]=y[a+730|0]&254;return}v[a+730|0]=y[a+730|0]|1;return}v[a+738|0]=y[a+738|0]&254;return}v[a+738|0]=y[a+738|0]|1;return}v[a+746|0]=y[a+746|0]&254;return}v[a+746|0]=y[a+746|0]|1;return}if((c|0)!=16777216){break a}c=a;a=y[a+746|0];v[c+746|0]=(b|0)==13?a&238|1:a|17}}function fn(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0;j=1;i=d&2147483647;k=i;l=(i|0)==2147418112;a:{if(l&!c?a|b:l&(c|0)!=0|i>>>0>2147418112){break a}i=h&2147483647;if(!g&(i|0)==2147418112?e|f:(i|0)==2147418112&(g|0)!=0|i>>>0>2147418112){break a}if(!(a|e|(c|g)|(b|f|(i|k)))){return 0}j=d&h;if((j|0)>0){k=1}else{k=(j|0)>=0}if(k){j=-1;if((c|0)==(g|0)&(d|0)==(h|0)?(b|0)==(f|0)&a>>>0<e>>>0|b>>>0<f>>>0:c>>>0<g>>>0&(d|0)<=(h|0)|(d|0)<(h|0)){break a}return(a^e|c^g|(b^f|d^h))!=0}j=-1;if((c|0)==(g|0)&(d|0)==(h|0)?(b|0)==(f|0)&a>>>0>e>>>0|b>>>0>f>>>0:c>>>0>g>>>0&(d|0)>=(h|0)|(d|0)>(h|0)){break a}j=(a^e|c^g|(b^f|d^h))!=0}return j}function LK(a,b,c){var d=0,e=0;if(!b){return 0}a:{b:{if(!c){break b}d=y[b|0];e=d<<24>>24;if((e|0)>=0){if(a){x[a>>2]=d}return(e|0)!=0}if(!x[x[124115]>>2]){b=1;if(!a){break a}x[a>>2]=e&57343;return 1}d=d-194|0;if(d>>>0>50){break b}d=x[(d<<2)+120704>>2];if(d<<D(c,6)-6<0&c>>>0<=3){break b}c=y[b+1|0];e=c>>>3|0;if((e-16|e+(d>>26))>>>0>7){break b}c=c-128|d<<6;if((c|0)>=0){b=2;if(!a){break a}x[a>>2]=c;return 2}d=y[b+2|0]-128|0;if(d>>>0>63){break b}e=d;d=c<<6;c=e|d;if((d|0)>=0){b=3;if(!a){break a}x[a>>2]=c;return 3}d=y[b+3|0]-128|0;if(d>>>0>63){break b}b=4;if(!a){break a}x[a>>2]=d|c<<6;return 4}x[31484]=25;b=-1}return b}function FD(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=fb-16|0;fb=e;d=(c<<3)+a|0;f=y[d+356|0];v[b+12|0]=y[b+12|0]&248|f&1|f<<1&4|f>>>1&2;fh(b,Ld(y[d+352|0],2,16));v[b+13|0]=y[d+354|0];v[b+14|0]=y[d+355|0];d=y[d+353|0];v[b+15|0]=d;v[b+16|0]=d;d=0;w[e+14>>1]=0;f=((c|0)!=0)<<1;h=x[b>>2];j=Sd(h,x[b+4>>2]);k=(c<<6)+a|0;c=((c|0)==2?-1:0)&255;while(1){if((d|0)==(j|0)){ED(b,32);fb=e+16|0}else{a=k+(d<<2)|0;w[e+12>>1]=y[a+160|0]|y[a+161|0]<<8;g=qe(e+14|0,e+12|0);i=yb(h,d);g=z[g>>1];w[i>>1]=g;w[e+14>>1]=g+1;v[e+11|0]=(c^y[a+162|0])>>>f;v[e+10|0]=64;l=i,m=y[Qb(e+11|0,e+10|0)|0],v[l+2|0]=m;d=d+1|0;continue}break}}function B3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;if(lh(a,x[b+8>>2],f)){Wx(b,c,d,e);return}h=y[b+53|0];g=x[a+12>>2];v[b+53|0]=0;i=y[b+52|0];v[b+52|0]=0;j=a+16|0;Sx(x[j>>2],x[a+20>>2],b,c,d,e,f);k=y[b+52|0];i=(i|k)!=0;l=y[b+53|0];h=(h|l)!=0;a:{if((g|0)<2){break a}j=j+(g<<3)|0;g=a+24|0;while(1){if(y[b+54|0]){break a}b:{if(k){if(x[b+24>>2]==1){break a}if(y[a+8|0]&2){break b}break a}if(!l){break b}if(!(v[a+8|0]&1)){break a}}w[b+52>>1]=0;Sx(x[g>>2],x[g+4>>2],b,c,d,e,f);l=y[b+53|0];h=(l|h)!=0;k=y[b+52|0];i=(k|i)!=0;g=g+8|0;if(j>>>0>g>>>0){continue}break}}v[b+53|0]=h;v[b+52|0]=i}function rsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=fb-80|0;fb=d;e=Rf(d+52|0);x[31609]=0;c=P(410,b|0,e|0)|0;f=x[31609];x[31609]=0;a:{b:{c:{d:{if((f|0)!=1){if(c){break d}x[a>>2]=0;x[a+4>>2]=0;x[a+24>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;x[31609]=0;R(411,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break a}}break c}c=fb-16|0;fb=c;g=c,h=$b(x[e+4>>2]),x[g+12>>2]=h;x[c+8>>2]=8;f=bd(c+12|0,c+8|0);fb=c+16|0;c=x[f>>2]-8|0;x[31609]=0;S(185,d+12|0,b|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}a=N()|0;Hd(e);Q(a|0);p()}b=d+12|0;c=hc(d+32|0,b);kd(e+8|0,c);ub(c);ub(b);Pk(a,e)}Hd(e);fb=d+80|0}function Xja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=fb-16|0;fb=g;f=c;e=fb-16|0;fb=e;h=b;d=de(b);a:{if(d){c=gc(b);while(1){b=d;d=b+16|0;if(GR(f,d)){c=b;d=x[b>>2];if(d){continue}break a}if(!GR(d,f)){break a}c=b+4|0;d=x[b+4>>2];if(d){continue}break}break a}b=gc(h);c=b}x[e+12>>2]=b;b=x[c>>2];if(!b){b=fb-16|0;fb=b;d=gc(h);d=Dh(e,Ec(28),Og(b+8|0,d));i=x[d>>2];x[31609]=0;O(889,i+16|0,f|0);f=x[31609];x[31609]=0;b:{if((f|0)!=1){j=gc(d),k=1,v[j+4|0]=k;fb=b+16|0;break b}a=N()|0;FR(d);Q(a|0);p()}$g(h,x[e+12>>2],c,x[e>>2]);b=ne(e);FR(e);i=1}c=g+8|0;_g(c,x[vb(e,b)>>2],i);fb=e+16|0;jV(a,c);fb=g+16|0}function eq(a,b,c,d){var e=0,f=0,g=0,h=0;g=d?d:497536;d=x[g>>2];a:{b:{c:{if(!b){if(d){break c}return 0}e=-2;if(!c){break b}d:{if(d){e=c;break d}d=y[b|0];f=d<<24>>24;if((f|0)>=0){if(a){x[a>>2]=d}return(f|0)!=0}if(!x[x[124115]>>2]){e=1;if(!a){break b}x[a>>2]=f&57343;return 1}d=d-194|0;if(d>>>0>50){break c}d=x[(d<<2)+120704>>2];e=c-1|0;if(!e){break a}b=b+1|0}f=y[b|0];h=f>>>3|0;if((h-16|(d>>26)+h)>>>0>7){break c}while(1){e=e-1|0;d=f-128|d<<6;if((d|0)>=0){x[g>>2]=0;if(a){x[a>>2]=d}return c-e|0}if(!e){break a}b=b+1|0;f=y[b|0];if((f&192)==128){continue}break}}x[g>>2]=0;x[31484]=25;e=-1}return e}x[g>>2]=d;return-2}function wQ(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=fb-16|0;fb=e;mh(e+8|0,b);f=fb-16|0;fb=f;lf(f+8|0,x[e+8>>2],x[e+12>>2]);g=x[f+8>>2];b=x[f+12>>2];h=fb-16|0;fb=h;l=h,m=wb(a),x[l+12>>2]=m;a=b;b=fb-16|0;fb=b;i=x[h+12>>2];c=i;d=x[c+8>>2];c=x[c+12>>2];a:{if((c|0)<0){break a}j=x[i+4>>2];k=d>>>0>j>>>0;if(k&!c|c){break a}x[b+8>>2]=j-d;x[b+12>>2]=0-(c+k|0);x[b>>2]=a;x[b+4>>2]=0;c=B0(b+8|0,b);if((Tu(x[c>>2],x[c+4>>2])|0)!=(a|0)){break a}yk(g,a+g|0,d+x[i>>2]|0);d=x[h+12>>2];g=d;c=x[d+8>>2];d=x[d+12>>2];i=a;a=a+c|0;d=i>>>0>a>>>0?d+1|0:d;x[g+8>>2]=a;x[g+12>>2]=d}fb=b+16|0;fb=h+16|0;fb=f+16|0;fb=e+16|0}function QA(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;b=x[a>>2];if(!mc(b,x[a+4>>2])){b=wb(b);x[e+12>>2]=b;f=wb(x[a+4>>2]);while(1){if(Ib(b,f)){Ep(b,4194304,67108864);b=x[b>>2];d=b+d|0;c=b>>>0>d>>>0?c+1|0:c;b=x[We(e+12|0)>>2];continue}else{b=x[a>>2];f=oc(b,x[a+4>>2]);b=wb(b);x[e+8>>2]=b;g=f<<24;d=Kua(d,c,f,0);h=((hb&1)<<31|d>>>1)&2147483647;i=wb(x[a+4>>2]);while(1){if(Ib(b,i)){f=b;b=x[b>>2];c=b>>>8|0;b=h+(b<<24)|0;c=c+j|0;c=Bc(Kua(b,b>>>0<h>>>0?c+1|0:c,d,j),hb);x[f>>2]=c;g=g-c|0;b=x[We(e+8|0)>>2];continue}else{c=x[a>>2];if(!oc(c,x[a+4>>2])){Iw();p()}x[c>>2]=x[c>>2]+g}break}}break}}fb=e+16|0}function O8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=fb-32|0;fb=c;a:{b:{c:{if(mc(b,-1)){break c}e=b<<24>>24;v[c+23|0]=e;if(y[a+44|0]){d=-1;f=x[a+32>>2];a=fb-16|0;fb=a;v[a+15|0]=e;e=fm(a+15|0,1,1,f);fb=a+16|0;if((e|0)==1){break c}break a}f=c+24|0;x[c+16>>2]=f;h=c+32|0;d=c+23|0;while(1){e=lr(x[a+36>>2],x[a+40>>2],d,f,c+12|0,c+24|0,h,c+16|0);if(x[c+12>>2]==(d|0)){break b}if((e|0)==3){if((fm(d,1,1,x[a+32>>2])|0)==1){break c}break b}if(e>>>0>1){break b}g=c+24|0;d=x[c+16>>2]-g|0;if((fm(g,1,d,x[a+32>>2])|0)!=(d|0)){break b}d=x[c+12>>2];if((e|0)==1){continue}break}}d=Qy(b);break a}d=-1}fb=c+32|0;return d|0}function Ni(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;j=c*d;k=b*e;h=j+k;l=b*d;m=c*e;i=l-m;a:{if(!Qi(i)){break a}if(!Qi(h)){break a}f=Af(b);g=Af(c);n=f|g;b:{if((n|0)!=1){break b}b=li(f?1:0,b);c=li(g?1:0,c);if(Qi(d)){d=li(0,d)}if(!Qi(e)){break b}e=li(0,e)}f=Af(d);g=Af(e);c:{if(f|g){d=li(f?1:0,d);e=li(g?1:0,e);if(Qi(b)){b=li(0,b)}if(!Qi(c)){break c}c=li(0,c);break c}if(n){break c}d:{if(Af(l)){break d}if(Af(m)){break d}if(Af(k)){break d}if(!Af(j)){break a}}if(Qi(b)){b=li(0,b)}if(Qi(c)){c=li(0,c)}if(Qi(d)){d=li(0,d)}if(!Qi(e)){break c}e=li(0,e)}h=(b*e+d*c)*Infinity;i=(b*d-e*c)*Infinity}Ql(a,i,h)}function MB(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=fb-16|0;fb=f;c=vb(f+12|0,x[a+4>>2]);d=vb(f+8|0,x[a>>2]);g=x[vb(f+4|0,x[b+4>>2])>>2];h=fb-16|0;fb=h;i=h+8|0;e=fb-32|0;fb=e;fd(e+24|0,x[c>>2],x[d>>2]);j=e+16|0;d=x[e+24>>2];k=x[e+28>>2];c=fb-16|0;fb=c;x[c+8>>2]=g;x[c+12>>2]=d;while(1){if(Fd(d,k)){d=Hp(d);g=Hp(x[c+8>>2]);l=x[d+4>>2];x[g>>2]=x[d>>2];x[g+4>>2]=l;d=es(c+12|0);es(c+8|0);d=x[d>>2];continue}break}rc(j,d,c+8|0);fb=c+16|0;c=x[e+16>>2];x[e+12>>2]=x[e+20>>2];rc(i,c,e+12|0);fb=e+32|0;fb=h+16|0;x[b+4>>2]=x[h+12>>2];Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=f+16|0}function Di(a,b,c,d){var e=0,f=0,g=0;e=fb-48|0;fb=e;f=x[x[a>>2]-12>>2]+a|0;g=x[f+16>>2]&-3;ig(f,g);a:{b:{if(Id(y[Hm(e+47|0,a,1)|0])){f=x[(x[x[a>>2]-12>>2]+a|0)+24>>2];x[31609]=0;Ls(86,e+24|0,f,b,c,d);b=x[31609];x[31609]=0;c:{if((b|0)!=1){b=ci(e+8|0,-1,-1);d=ao(x[e+32>>2],x[e+36>>2],x[b+8>>2],x[b+12>>2])?g|4:g;break c}Y(T(0)|0)|0;d=g|1;Fm(x[x[a>>2]-12>>2]+a|0,d);if(x[(x[x[a>>2]-12>>2]+a|0)+20>>2]&1){x[31609]=0;X(84);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){break b}Q(a|0);p()}Z()}Xj(x[x[a>>2]-12>>2]+a|0,d)}fb=e+48|0;return a}T(0)|0;Sb()}p()}function Nqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;i=e,j=Rj(b),x[i+4>>2]=j;f=z[b>>1];d=fb-16|0;fb=d;g=a;c=de(a);a:{if(c){b=gc(a);while(1){a=c;c=z[a+14>>1];if(_o(f,c)){b=a;c=x[a>>2];if(c){continue}break a}if(!_o(c,f)){break a}b=a+4|0;c=x[a+4>>2];if(c){continue}break}break a}a=gc(g);b=a}x[d+12>>2]=a;a=x[b>>2];if(!a){a=fb-16|0;fb=a;c=gc(g);f=Dh(d,Ec(20),Og(a+8|0,c));c=x[f>>2];h=z[x[e+4>>2]>>1];w[c+16>>1]=0;w[c+14>>1]=h;i=gc(f),j=1,v[i+4|0]=j;fb=a+16|0;$g(g,x[d+12>>2],b,x[d>>2]);a=ne(d);Jk(d);h=1}_g(e+8|0,x[vb(d,a)>>2],h);fb=d+16|0;a=cp(x[e+8>>2]);fb=e+16|0;return a+2|0}function yL(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=fb-208|0;fb=f;x[f+204>>2]=c;c=f+160|0;Rb(c,0,40);x[f+200>>2]=x[f+204>>2];a:{if((xL(0,b,f+200|0,f+80|0,c,d,e)|0)<0){e=-1;break a}i=x[a+76>>2]<0;g=x[a>>2];x[a>>2]=g&-33;b:{c:{d:{if(!x[a+48>>2]){x[a+48>>2]=80;x[a+28>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;h=x[a+44>>2];x[a+44>>2]=f;break d}if(x[a+16>>2]){break c}}c=-1;if(Jw(a)){break b}}c=xL(a,b,f+200|0,f+80|0,f+160|0,d,e)}if(h){ib[x[a+36>>2]](a,0,0)|0;x[a+48>>2]=0;x[a+44>>2]=h;x[a+28>>2]=0;b=x[a+20>>2];x[a+16>>2]=0;x[a+20>>2]=0;c=b?c:-1}b=a;a=x[a>>2];x[b>>2]=a|g&32;e=a&32?-1:c;if(i){break a}}fb=f+208|0;return e}function e_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;i=e,j=Rj(b),x[i+4>>2]=j;f=x[b>>2];d=fb-16|0;fb=d;g=a;c=de(a);a:{if(c){b=gc(a);while(1){a=c;c=x[a+16>>2];if(sE(f,c)){b=a;c=x[a>>2];if(c){continue}break a}if(!sE(c,f)){break a}b=a+4|0;c=x[a+4>>2];if(c){continue}break}break a}a=gc(g);b=a}x[d+12>>2]=a;a=x[b>>2];if(!a){a=fb-16|0;fb=a;c=gc(g);f=Dh(d,Ec(24),Og(a+8|0,c));c=x[f>>2];h=x[x[e+4>>2]>>2];x[c+20>>2]=0;x[c+16>>2]=h;i=gc(f),j=1,v[i+4|0]=j;fb=a+16|0;$g(g,x[d+12>>2],b,x[d>>2]);a=ne(d);Jk(d);h=1}_g(e+8|0,x[vb(d,a)>>2],h);fb=d+16|0;a=ud(x[e+8>>2]);fb=e+16|0;return a+4|0}function St(a,b,c){var d=0,e=0;d=a,e=uj(E(E(B[c+1792>>2]*E(75038))+E(E(E(B[c+2048>>2]-B[c+1536>>2])*E(37489))+E(E(E(B[c+1280>>2]+B[c+2304>>2])*E(6574))+E(E(E(B[c+2560>>2]-B[c+1024>>2])*E(5153))+E(E(E(B[c+768>>2]+B[c+2816>>2])*E(2037))+E(E(E(B[c+3072>>2]-B[c+512>>2])*E(459))+E(E(E(B[c+256>>2]+B[c+3328>>2])*E(213))+E(E(B[c+3584>>2]-B[c>>2])*E(29)))))))))),w[d>>1]=e;d=(b<<5)+a|0,e=uj(E(E(B[c+8>>2]*E(-5))+E(E(B[c+520>>2]*E(146))+E(E(B[c+1032>>2]*E(-45))+E(E(B[c+1544>>2]*E(-9975))+E(E(B[c+2056>>2]*E(64019))+E(E(B[c+2568>>2]*E(9727))+E(E(B[c+3080>>2]*E(1567))+E(B[c+3592>>2]*E(104)))))))))),w[d>>1]=e}function MS(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;d=fb-16|0;fb=d;a:{if(x[a+480180>>2]!=1){break a}c=y[b+846|0];if(!c){break a}e=x[b+104>>2];if(!e){break a}if(!le(x[e>>2],x[e+20>>2])){break a}f=z[e+34>>1];if(!(f&10)){break a}c=y[b+847|0]+y[(c&15)+31600|0]|0;v[b+847|0]=c;if(c<<24>>24>=0){break a}v[b+847|0]=0;h=f&2;c=x[(h?4:12)+e>>2];g=b;b=x[b+760>>2]+1|0;b=b>>>0<x[(h?8:16)+e>>2]-c>>>0?b:0;x[g+760>>2]=b;g=x[e+20>>2];c=b+c|0;b=_k(f);cc(d+8|0,g+D(c,b)|0,b);b=wb(x[d+8>>2]);x[d+4>>2]=b;f=Zj(x[d+8>>2],x[d+12>>2]);while(1){if(Ib(b,f)){v[b|0]=y[b|0]^-1;b=x[we(d+4|0)>>2];continue}else{Jj(e,a)}break}}fb=d+16|0}function oka(a){a=a|0;var b=0,c=0,d=0;b=1074992;while(1){if((b|0)==1298224){Eu(a+484344|0);sf(a+1298308|0);sf(a+1298320|0);sf(a+1298332|0);Nc(a+1298412|0);c=484380;while(1){a:{b=900380;if((c|0)==900380){while(1){if((b|0)==901404){b=a+906300|0;c=vk(b);while(1){if((b|0)==(c|0)){break a}l0(b);b=b+160|0;continue}}c=a+b|0;d=x[c>>2];if(d){Db(Nv(d))}x[c>>2]=0;b=b+4|0;continue}}else{on(a+c|0);c=c+104|0;continue}}break}x[a+480180>>2]=0;x[a+480184>>2]=0;a=a+480186|0;w[a>>1]=0;w[a+2>>1]=0;w[a+4>>1]=0;w[a+6>>1]=0}else{c=a+b|0;x[c+104>>2]=0;x[c+656>>2]=0;x[c+76>>2]=0;x[c+16>>2]=0;b=b+872|0;continue}break}}function hga(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0;d=fb-80|0;fb=d;x[d+76>>2]=c;c=x[a>>2];e=x[a+4>>2];f=x[a+12>>2];x[d+48>>2]=x[a+8>>2];x[d+52>>2]=f;x[d+40>>2]=c;x[d+44>>2]=e;a=Md(d+32|0);c=x[d+52>>2];x[d+16>>2]=x[d+48>>2];x[d+20>>2]=c;x[31609]=0;c=x[d+44>>2];x[d+8>>2]=x[d+40>>2];x[d+12>>2]=c;c=x[a+4>>2];x[d>>2]=x[a>>2];x[d+4>>2]=c;a=d+56|0;S(980,a|0,d+8|0,d|0);c=x[31609];x[31609]=0;a:{b:{if((c|0)!=1){c=d+76|0;e=x[re(d+28|0,c)>>2];x[31609]=0;b=+pa(981,a|0,+b,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break b}ub(a);Wc(c);fb=d+80|0;return+b}a=N()|0;break a}a=N()|0;ub(d+56|0)}Wc(d+76|0);Q(a|0);p()}function opa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=fb-32|0;fb=e;a:{c=x[a+12>>2];b:{if((c|0)==(b|0)){break b}f=b>>>0>c>>>0;c=D(z[x[x[a+48>>2]+12>>2]+480188>>1],f?b-c|0:c-b|0);d=wb(x[a+4>>2]);c:{if(f){d=vb(e+28|0,d);w[e+24>>1]=0;x[e+20>>2]=0;d=x[d>>2];x[31609]=0;V(663,a|0,d|0,c|0,e+20|0);c=x[31609];x[31609]=0;if((c|0)!=1){break c}a=T(124540)|0;if((gb|0)!=($(124540)|0)){break a}Y(a|0)|0;Z();break b}c=vb(e+16|0,QD(d,c));d=x[vb(e+12|0,wb(x[a+4>>2]))>>2];f=x[c>>2];c=x[a>>2];c=D(wu(f,wb(c)),6)+c|0;if(Ib(f,d)){Jd(a,uA(c+D(wu(d,f),6)|0,x[a+4>>2],c))}wb(c)}x[a+12>>2]=b}fb=e+32|0;return}Q(a|0);p()}function W8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=fb-32|0;fb=c;a:{b:{c:{if(jo(b)){break c}x[c+20>>2]=b;if(y[a+44|0]){d=-1;a=x[a+32>>2];d:{if(x[a+76>>2]<0){a=KK(b,a);break d}a=KK(b,a)}if((a|0)!=-1){break c}break a}f=c+24|0;x[c+16>>2]=f;h=c+32|0;d=c+20|0;while(1){e=lr(x[a+36>>2],x[a+40>>2],d,f,c+12|0,c+24|0,h,c+16|0);if(x[c+12>>2]==(d|0)){break b}if((e|0)==3){if((fm(d,1,1,x[a+32>>2])|0)==1){break c}break b}if(e>>>0>1){break b}g=c+24|0;d=x[c+16>>2]-g|0;if((fm(g,1,d,x[a+32>>2])|0)!=(d|0)){break b}d=x[c+12>>2];if((e|0)==1){continue}break}}d=jo(b)?0:b;break a}d=-1}fb=c+32|0;return d|0}function nA(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=E(0);f=fb-16|0;fb=f;c=vb(f+12|0,x[a+4>>2]);d=vb(f+8|0,x[a>>2]);h=x[vb(f+4|0,x[b+4>>2])>>2];g=fb-16|0;fb=g;i=g+8|0;e=fb-32|0;fb=e;fd(e+24|0,x[c>>2],x[d>>2]);j=e+16|0;d=x[e+24>>2];k=x[e+28>>2];c=fb-16|0;fb=c;x[c+8>>2]=h;x[c+12>>2]=d;while(1){if(Fd(d,k)){d=xf(d);l=xf(x[c+8>>2]),m=B[d>>2],B[l>>2]=m;d=xj(c+12|0);xj(c+8|0);d=x[d>>2];continue}break}rc(j,d,c+8|0);fb=c+16|0;c=x[e+16>>2];x[e+12>>2]=x[e+20>>2];rc(i,c,e+12|0);fb=e+32|0;fb=g+16|0;x[b+4>>2]=x[g+12>>2];Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=f+16|0}function cna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=fb-16|0;fb=b;j=x[a+24>>2];k=x[a+20>>2];l=x[a+16>>2];f=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=f;f=x[a+8>>2];m=x[a+12>>2];while(1){if(d){e=x[b+8>>2];n=e>>>18|0;g=((((x[b+12>>2]&2147483647)<<1|e>>>31)&2147483646)<<1)+l|0;e=0;while(1){if((e|0)!=2){h=e<<1;i=w[h+g>>1];x[(e<<2)+b>>2]=i+((D(w[(h|4)+g>>1]-i|0,n)|0)/16384|0);e=e+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[b>>2],k);x[c+4>>2]=x[c+4>>2]+D(x[b+4>>2],j);Pb(b+8|0,f,m);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;fb=b+16|0}function _7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=fb-32|0;fb=f;x[f+28>>2]=b;a:{if(!(v[c+4|0]&1)){c=ib[x[x[a>>2]+24>>2]](a,b,c,d,e)|0;break a}a=f+16|0;cd(a,x[c+28>>2]);x[31609]=0;b=R(1253,x[f+16>>2])|0;c=x[31609];x[31609]=0;b:{if((c|0)!=1){_b(a);c:{if(e){gi(a,b);break c}fi(f+16|0,b)}g=f,h=zd(f+16|0),x[g+12>>2]=h;while(1){a=f+16|0;b=ol(a);c=x[f+12>>2];if(!Ib(c,b)){c=x[f+28>>2];Ub(a);break a}a=x[c>>2];x[31609]=0;P(1268,f+28|0,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){We(f+12|0);continue}break}c=N()|0;Ub(f+16|0);break b}c=N()|0;_b(f+16|0)}Q(c|0);p()}fb=f+32|0;return c|0}function rH(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=fb-16|0;fb=g;e=g+4|0;v[e+8|0]=1;x[e+4>>2]=c;x[e>>2]=a;h=y[e+8|0];a=x[e>>2];i=x[e+4>>2];j=Kb(b);b=Cb(x[b+4>>2],y[b+11|0]);d=fb-16|0;fb=d;x[d+8>>2]=b;x[d+12>>2]=i;b=a;e=x[Hb(d+12|0,d+8|0)>>2];f=e;while(1){a:{if(!f){f=0;break a}c=y[j|0];v[b|0]=c;if(!c){break a}j=j+1|0;b=b+1|0;f=f-1|0;continue}break}b:{if((h-1&255)>>>0<=1){v[d+7|0]=0;Rm(b,((b+i|0)-e|0)+f|0,d+7|0);break b}if((h-3&255)>>>0>1){break b}v[d+6|0]=32;Rm(b,((b+i|0)-e|0)+f|0,d+6|0)}c:{switch(h-1|0){case 0:case 3:v[(x[d+12>>2]+a|0)-1|0]=0;break;default:break c}}fb=d+16|0;fb=g+16|0}function Dy(a,b,c,d,e){var f=0,g=0,h=0;f=fb-16|0;fb=f;h=f+12|0;cd(h,b);x[31609]=0;b=R(1252,x[f+12>>2])|0;g=x[31609];x[31609]=0;a:{if((g|0)==1){break a}x[31609]=0;V(1263,b|0,95168,95200,c|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}x[31609]=0;b=R(1253,x[f+12>>2])|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;c=R(1264,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break a}x[d>>2]=c;x[31609]=0;c=R(1261,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}x[e>>2]=c;x[31609]=0;O(1262,a|0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break a}_b(h);fb=f+16|0;return}a=N()|0;_b(f+12|0);Q(a|0);p()}function i8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=fb-32|0;fb=f;x[f+28>>2]=b;a:{if(!(v[c+4|0]&1)){c=ib[x[x[a>>2]+24>>2]](a,b,c,d,e)|0;break a}a=f+16|0;cd(a,x[c+28>>2]);x[31609]=0;b=R(1235,x[f+16>>2])|0;c=x[31609];x[31609]=0;b:{if((c|0)!=1){_b(a);c:{if(e){gi(a,b);break c}fi(f+16|0,b)}g=f,h=zd(f+16|0),x[g+12>>2]=h;while(1){a=f+16|0;b=Ef(a);c=x[f+12>>2];if(!Ib(c,b)){c=x[f+28>>2];tb(a);break a}a=v[c|0];x[31609]=0;P(30,f+28|0,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){we(f+12|0);continue}break}c=N()|0;tb(f+16|0);break b}c=N()|0;_b(f+16|0)}Q(c|0);p()}fb=f+32|0;return c|0}function Tm(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=fb-16|0;fb=f;c=vb(f+12|0,x[a+4>>2]);d=vb(f+8|0,x[a>>2]);h=x[vb(f+4|0,x[b+4>>2])>>2];g=fb-16|0;fb=g;i=g+8|0;e=fb-32|0;fb=e;fd(e+24|0,x[c>>2],x[d>>2]);j=e+16|0;d=x[e+24>>2];k=x[e+28>>2];c=fb-16|0;fb=c;x[c+8>>2]=h;x[c+12>>2]=d;while(1){if(Fd(d,k)){d=xf(d);l=xf(x[c+8>>2]),m=x[d>>2],x[l>>2]=m;d=xj(c+12|0);xj(c+8|0);d=x[d>>2];continue}break}rc(j,d,c+8|0);fb=c+16|0;c=x[e+16>>2];x[e+12>>2]=x[e+20>>2];rc(i,c,e+12|0);fb=e+32|0;fb=g+16|0;x[b+4>>2]=x[g+12>>2];Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=f+16|0}function $g(a,b,c,d){var e=0,f=0;x[d+8>>2]=b;x[d>>2]=0;x[d+4>>2]=0;x[c>>2]=d;b=x[x[a>>2]>>2];if(b){x[a>>2]=b;d=x[c>>2]}f=x[gc(a)>>2];v[d+12|0]=(f|0)==(d|0);while(1){a:{if((d|0)==(f|0)){break a}c=x[d+8>>2];if(y[c+12|0]){break a}b:{if(Th(c)){b=x[c+8>>2];e=x[b+4>>2];if(!(!e|y[e+12|0])){break b}if(!Th(d)){or(c);c=x[c+8>>2]}v[c+12|0]=1;b=x[c+8>>2];v[b+12|0]=0;nr(b);break a}b=x[c+8>>2];e=x[b>>2];if(!(!e|y[e+12|0])){break b}if(Th(d)){nr(c);c=x[c+8>>2]}v[c+12|0]=1;b=x[c+8>>2];v[b+12|0]=0;or(b);break a}v[c+12|0]=1;d=b;v[d+12|0]=(d|0)==(f|0);v[e+12|0]=1;continue}break}a=Ab(a);x[a>>2]=x[a>>2]+1}function h4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;a:{b:{if(ji(b,14337)){d=Zs(c+28|0,b);e=x[d>>2];if(!Ed(e)){x[31609]=0;b=P(36,c+4|0,b|0)|0;a=x[31609];x[31609]=0;c:{d:{e:{if((a|0)!=1){x[31609]=0;a=c+16|0;S(1011,a|0,17759,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break e}x[31609]=0;W(1367,a|0);a=x[31609];x[31609]=0;if((a|0)==1){break d}p()}a=N()|0;break a}a=N()|0;break c}a=N()|0;tb(c+16|0)}tb(b);break a}Ys(e);Zp(a+8|0,16806,x[d>>2]);Zp(a+12|0,22292,x[d>>2]);x[31609]=0;O(272,a+16|0,22292);a=x[31609];x[31609]=0;if((a|0)==1){break b}il(d)}fb=c+32|0;return}a=N()|0}il(d);Q(a|0);p()}function Hy(a,b,c,d,e){var f=0,g=0,h=0;f=fb-16|0;fb=f;h=f+12|0;cd(h,b);x[31609]=0;b=R(28,x[f+12>>2])|0;g=x[31609];x[31609]=0;a:{if((g|0)==1){break a}x[31609]=0;V(1249,b|0,95168,95200,c|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}x[31609]=0;b=R(1235,x[f+12>>2])|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;c=R(1250,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break a}v[d|0]=c;x[31609]=0;c=R(1247,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}v[e|0]=c;x[31609]=0;O(1248,a|0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break a}_b(h);fb=f+16|0;return}a=N()|0;_b(f+12|0);Q(a|0);p()}function fh(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=x[a>>2];c=oc(d,x[a+4>>2]);if(c>>>0<b>>>0){e=fb-32|0;fb=e;b=b-c|0;c=x[Ab(a)>>2];d=x[a+4>>2];a:{if(b>>>0<=c-d>>2>>>0){c=fb-16|0;fb=c;b=xh(c+4|0,a,b);a=x[b+4>>2];d=x[b+8>>2];while(1){if((a|0)==(d|0)){kc(b);fb=c+16|0}else{Ww(a);a=a+4|0;x[b+4>>2]=a;continue}break}break a}c=Ab(a);c=Zf(e+12|0,Mf(a,oc(x[a>>2],d)+b|0),oc(x[a>>2],x[a+4>>2]),c);f=fb-16|0;fb=f;b=Gn(f+4|0,c+8|0,b);d=x[b>>2];while(1){if(x[b+4>>2]!=(d|0)){Ww(d);d=x[b>>2]+4|0;x[b>>2]=d;continue}break}je(b);fb=f+16|0;Xr(a,c);Yf(c)}fb=e+32|0;return}if(b>>>0<c>>>0){Jd(a,d+(b<<2)|0)}}function q3(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=fb-32|0;fb=k;m=x[c>>2];l=x[c+8>>2];c=x[c+4>>2];x[k+8>>2]=c;x[k+12>>2]=l;x[k+24>>2]=c;x[k+28>>2]=l;x[k+20>>2]=m;x[k+16>>2]=d;x[31609]=0;c=x[k+20>>2];x[k>>2]=x[k+16>>2];x[k+4>>2]=c;a=Ia(1094,a|0,b|0,k|0)|0;b=x[31609];x[31609]=0;a:{b:{if((b|0)==1){Y(T(0)|0)|0;x[31609]=0;ga(979,10431,e|0,f|0,g|0,h|0,i|0,j|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}Z();a=-255}fb=k+32|0;break a}b=N()|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)!=1){Q(b|0);p()}T(0)|0;Sb();p()}return a|0}function SL(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0;if(ff(a)){fc(a,31);return 0}g=a,h=ff(a),v[g+1375|0]=h;d=tj(a);b=tj(a);tj(a);g=a,h=tj(a),x[g+1112>>2]=h;tj(a);c=ff(a);x[a+1116>>2]=c;if(!ez(a,a+1120|0,c)){fc(a,10);return 0}x[a+1404>>2]=-2;a:{if((b&d)==-1){break a}b=x[a+1116>>2];while(1){if((b|0)<=0){break a}b=b-1|0;if(y[(b+a|0)+1120|0]==255){continue}break}x[a+1408>>2]=d;x[a+1404>>2]=b}if(y[a+1377|0]){b=0;e=x[a+1116>>2];f=(e|0)>0?e:0;c=0;while(1){if((b|0)!=(f|0)){c=y[(a+b|0)+1120|0]+c|0;b=b+1|0;continue}break}x[a- -64>>2]=d;x[a+60>>2]=(x[a+56>>2]+(c+e|0)|0)+27}x[a+1380>>2]=0;return 1}function Hm(a,b,c){var d=0,e=0,f=0,g=0;f=fb-16|0;fb=f;v[a|0]=0;a:{d=x[b>>2];e=x[d-12>>2]+b|0;b:{if(!x[e+16>>2]){e=x[e+72>>2];if(e){rp(e);d=x[b>>2]}c:{if(c){break c}c=x[d-12>>2]+b|0;if(!(y[c+5|0]&16)){break c}d=f+12|0;cd(d,x[c+28>>2]);x[31609]=0;e=R(28,x[f+12>>2])|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}_b(d);c=pp(f+8|0,b);d=tc(f+4|0);while(1){d:{if(th(c,d)){break d}g=ul(x[c>>2]);if(!Jf(x[e+8>>2],1,g)){break d}Gm(c);continue}break}if(th(c,d)){Xj(x[x[b>>2]-12>>2]+b|0,6)}d=x[b>>2]}v[a|0]=!x[(x[d-12>>2]+b|0)+16>>2];break b}Xj(e,4)}fb=f+16|0;return a}a=N()|0;_b(f+12|0);Q(a|0);p()}function bl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;f=a+36|0;c=x[a+32>>2];a:{b:{while(1){if((b|0)<=(c|0)){break b}c:{d=x[a+20>>2];if(d>>>0>=A[a+24>>2]){xl(e,f,AG(f));sd(e+8|0,a,x[e>>2],x[e+4>>2]);c=x[e+12>>2];x[a+24>>2]=c;x[a+20>>2]=0;if(!c){break c}d=0;c=x[a+32>>2]}x[a+20>>2]=d+1;g=y[(a+d|0)+36|0];d=c+8|0;x[a+32>>2]=d;x[a+28>>2]=x[a+28>>2]|g<<c;c=d;continue}break}a=ac(8);x[31609]=0;b=R(161,a|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break a}b=N()|0;ic(a);Q(b|0);p()}x[a+32>>2]=c-b;d=a;a=x[a+28>>2];x[d+28>>2]=a>>>b;fb=e+16|0;return a&(-1<<b^-1)}da(b|0,28816,162);p()}function FL(a,b){var c=0,d=0,e=0,f=0,g=0;if(!y[496352]){f=496353,g=Qa()|0,v[f|0]=g;v[496352]=1}a:{b:{c:{d:{switch(a|0){case 0:break b;case 1:case 4:break d;default:break c}}if(!y[496353]){break c}d=+Ga();break a}x[31484]=28;return-1}d=+Xa()}c=d/1e3;e:{if(F(c)<0x8000000000000000){e=~~c>>>0;if(F(c)>=1){a=~~(c>0?H(J(c*2.3283064365386963e-10),4294967295):K((c-+(~~c>>>0>>>0))*2.3283064365386963e-10))>>>0}else{a=0}break e}a=-2147483648}x[b>>2]=e;x[b+4>>2]=a;c=(d-(+(Iua(e,a,1e3,0)>>>0)+ +(hb|0)*4294967296))*1e3*1e3;f:{if(F(c)<2147483648){a=~~c;break f}a=-2147483648}x[b+8>>2]=a;return 0}function Kta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(c+8|0,x[vb(c+4|0,a)>>2]);a:{b:{if(b){x[31609]=0;O(321,a|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break b}e=fb-16|0;fb=e;d=Br(e+4|0,a,b);b=x[d+4>>2];f=x[d+8>>2];while(1){if((b|0)==(f|0)){kc(d);fb=e+16|0}else{v[b|0]=0;v[b+1|0]=0;v[b+2|0]=0;v[b+3|0]=0;v[b+4|0]=0;v[b+5|0]=0;v[b+4|0]=6;v[b+5|0]=0;v[b|0]=0;v[b+1|0]=0;v[b+2|0]=8;v[b+3|0]=4;b=b+6|0;x[d+4>>2]=b;continue}break}}b=c+8|0;Qd(b);bm(b);fb=c+16|0;break a}a=N()|0;bm(c+8|0);Q(a|0);p()}v[a+16|0]=6;x[a+12>>2]=2015363072;return a|0}function ae(a,b){var c=0,d=0,e=0;c=fb-32|0;fb=c;a=ci(a,-1,-1);a:{b:{if(Id(y[Hm(c+31|0,b,1)|0])){d=x[(x[x[b>>2]-12>>2]+b|0)+24>>2];x[31609]=0;Ls(86,c+8|0,d,0,0,1);d=x[31609];x[31609]=0;c:{if((d|0)!=1){d=x[c+12>>2];x[a>>2]=x[c+8>>2];x[a+4>>2]=d;d=x[c+20>>2];x[a+8>>2]=x[c+16>>2];x[a+12>>2]=d;break c}Y(T(0)|0)|0;e=1;Fm(x[x[b>>2]-12>>2]+b|0,1);if(x[(x[x[b>>2]-12>>2]+b|0)+20>>2]&1){x[31609]=0;X(84);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){break b}Q(a|0);p()}Z()}Xj(x[x[b>>2]-12>>2]+b|0,e)}fb=c+32|0;return}T(0)|0;Sb()}p()}function G$(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0;a:{if(!d){break a}i=y[e|0];if(!i){break a}j=2240>>>d&d>>>0<12;g=D(c,-6);k=(d-2&255)>>>0>2;while(1){if(!b){break a}c=a;a=c+g|0;f=y[a+3|0];b:{c:{if(!((f-2&255)>>>0>2|k)){f=1;if(y[(c+g|0)+5|0]<224){break c}break a}f=!(1<<f&2240)|(!j|f>>>0>11)?(d|0)==(f|0):1;if(k){break b}}h=c+g|0;if((y[h+2|0]-11&255)>>>0>2){break b}if(y[h+4|0]){break a}}d:{if(!j){break d}h=c+g|0;if((y[h+2|0]-3&255)>>>0>3){break d}if(y[h+4|0]){break a}}b=b-1|0;if(!f){continue}c=y[(c+g|0)+5|0];if(c?(c|0)!=(i|0):0){break a}if((c|0)!=(i|0)){continue}break}v[e|0]=0}}function s4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a:{g=fb+-64|0;fb=g;h=g+16|0;$n(h,c);x[31609]=0;c=g+28|0;O(91,c|0,d|0);d=x[31609];x[31609]=0;b:{c:{d:{if((d|0)==1){break d}x[31609]=0;c=g+40|0;O(91,c|0,e|0);d=x[31609];x[31609]=0;if((d|0)==1){break d}x[31609]=0;c=g+52|0;O(91,c|0,f|0);d=x[31609];x[31609]=0;if((d|0)==1){break d}cy(g+8|0,h);x[31609]=0;V(92,a|0,b|0,x[g+8>>2],x[g+12>>2]);a=x[31609];x[31609]=0;if((a|0)==1){break c}zI(h);fb=g- -64|0;break a}a=N()|0;while(1){c=tb(c-12|0);if((c|0)!=(g+16|0)){continue}break}break b}a=N()|0;zI(g+16|0)}Q(a|0);p()}}
function aN(a,b){var c=0,d=0,e=0,f=0,g=0;c=x[a>>2];x[a>>2]=b;if(c){x[31609]=0;W(853,c|0);a=x[31609];x[31609]=0;a:{if((a|0)!=1){d=x[c+4>>2];if(d){e=fb-16|0;fb=e;f=vb(e+12|0,d);a=x[f>>2];if(x[a>>2]){g=x[a>>2];b=x[a+4>>2];while(1){if((b|0)!=(g|0)){b=b-4|0;mg(b);continue}break}x[a+4>>2]=g;a=x[f>>2];b=x[a>>2];Vg(a);Db(b)}fb=e+16|0;Db(d)}x[c+4>>2]=0;xS(c+1298412|0);YA(c+1298344|0);tb(c+1298332|0);tb(c+1298320|0);tb(c+1298308|0);XA(c+1298304|0);WA(c+1298300|0);Ru(c+1298264|0);kB(c+1074376|0);wS(c+906300|0);$B(c+484360|0);oS(c+484344|0);wc(c+480248|0);break a}T(0)|0;Sb();p()}Db(c)}}function Pfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=fb-32|0;fb=d;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)==1){break c}x[31609]=0;W(997,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break c}e=x[a+24>>2];b=qc(d+12|0,b);x[31609]=0;c=x[b+4>>2];x[d>>2]=x[b>>2];x[d+4>>2]=c;c=d+20|0;V(1009,c|0,e|0,d|0,1);b=x[31609];x[31609]=0;if((b|0)==1){break c}b=Cg(Kb(c));tb(c);break b}Y(T(0)|0)|0;b=0;x[31609]=0;V(983,5535,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z()}fb=d+32|0;return b|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Ysa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=fb-16|0;fb=g;c=65535;e=x[a>>2];a:{if($c(e,x[a+4>>2])>>>0<=b>>>0){break a}e=z[bc(e,b)>>1];b:{if(!Yi(a,b)){break b}c=x[a+24>>2];d=wb(x[c+484360>>2]);x[g+12>>2]=d;h=wb(x[c+484364>>2]);while(1){if(!Ib(d,h)){break b}f=0;i=dm(x[d>>2],x[d+4>>2]);while(1){if((f|0)!=(i|0)){c:{if(!((a|0)!=(d|0)|(b|0)!=(f|0))|(e|0)!=z[bc(x[d>>2],f)>>1]){break c}c=JX(x[a+24>>2]+484344|0,e);if((c|0)==65535){break c}j=bc(x[a>>2],b),k=c,w[j>>1]=k;break a}f=f+1|0;continue}break}d=x[Zq(g+12|0)>>2];continue}}c=e}fb=g+16|0;return c&65535}function dna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=fb-16|0;fb=b;i=x[a+24>>2];j=x[a+20>>2];k=x[a+16>>2];f=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=f;f=x[a+8>>2];l=x[a+12>>2];while(1){if(d){e=x[b+8>>2];m=e>>>10&4194048;g=(((x[b+12>>2]&2147483647)<<1|e>>>31)&-2)+k|0;e=0;while(1){if((e|0)!=2){h=v[e+g|0];x[(e<<2)+b>>2]=((D(v[(e|2)+g|0]-h|0,m)|0)/16384|0)+(h<<8);e=e+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[b>>2],j);x[c+4>>2]=x[c+4>>2]+D(x[b+4>>2],i);Pb(b+8|0,f,l);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;fb=b+16|0}function cG(a){var b=0,c=0,d=0;b=fb-16|0;fb=b;x[b+4>>2]=D(y[a+12|0]|y[a+13|0]<<8|(y[a+14|0]<<16|y[a+15|0]<<24),5)+(y[a+16|0]|y[a+17|0]<<8|(y[a+18|0]<<16|y[a+19|0]<<24));x[b+8>>2]=(y[a+24|0]|y[a+25|0]<<8|(y[a+26|0]<<16|y[a+27|0]<<24))+((y[a+20|0]|y[a+21|0]<<8|(y[a+22|0]<<16|y[a+23|0]<<24))<<3);x[b+12>>2]=(y[a+32|0]|y[a+33|0]<<8|(y[a+34|0]<<16|y[a+35|0]<<24))+((y[a+28|0]|y[a+29|0]<<8|(y[a+30|0]<<16|y[a+31|0]<<24))<<2);a=b+4|0;d=yb(a,3);a:{if((a|0)==(d|0)){break a}c=a;while(1){c=c+4|0;if((d|0)==(c|0)){break a}a=Gk(x[a>>2],x[c>>2])?c:a;continue}}fb=b+16|0;return x[a>>2]-36|0}function n3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;f=c;c=fb-16|0;fb=c;x[31609]=0;W(996,a|0);e=x[31609];x[31609]=0;a:{b:{c:{d:{if((e|0)==1){break d}x[31609]=0;W(997,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break d}e=x[a+24>>2];b=qc(c+8|0,b);x[31609]=0;g=x[b+4>>2];x[c>>2]=x[b>>2];x[c+4>>2]=g;Ls(1017,e,c,f,d,1);d=x[31609];x[31609]=0;b=1;if((d|0)!=1){break c}}Y(T(0)|0)|0;x[31609]=0;V(983,8658,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break b}Z();b=0}fb=c+16|0;break a}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}return b|0}function wr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;QE(c+8|0,b);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;if((d|0)!=(e|0)){v[b|0]=0;v[b+1|0]=0;v[b+2|0]=0;v[b+3|0]=0;v[b+4|0]=0;v[b+5|0]=0;v[b+6|0]=0;v[b+7|0]=0;v[b+24|0]=0;v[b+25|0]=0;v[b+26|0]=0;v[b+27|0]=0;v[b+28|0]=0;v[b+29|0]=0;v[b+30|0]=0;v[b+31|0]=0;v[b+16|0]=0;v[b+17|0]=0;v[b+18|0]=0;v[b+19|0]=0;v[b+20|0]=0;v[b+21|0]=0;v[b+22|0]=0;v[b+23|0]=0;v[b+8|0]=0;v[b+9|0]=0;v[b+10|0]=0;v[b+11|0]=0;v[b+12|0]=0;v[b+13|0]=0;v[b+14|0]=0;v[b+15|0]=0}}function sna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=fb-16|0;fb=b;i=x[a+16>>2];h=kg(1,2);e=hb;j=e;Pb(a,h,e);k=x[a+24>>2];l=x[a+20>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;e=x[a+8>>2];m=x[a+12>>2];while(1){if(d){d=d-1|0;g=x[b+8>>2];g=((((x[b+12>>2]&2147483647)<<1|g>>>31)&2147483646)<<1)+i|0;f=0;while(1){if((f|0)!=2){x[(f<<2)+b>>2]=w[(f<<1)+g>>1];f=f+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[b>>2],l);x[c+4>>2]=x[c+4>>2]+D(x[b+4>>2],k);Pb(b+8|0,e,m);c=c+8|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;Ig(a,h,j);fb=b+16|0}function xha(a){a=a|0;var b=0,c=0,d=0;c=fb-16|0;fb=c;b=x[x[a+16>>2]+24620>>2];b=Gc(Jua(Iua(b,b>>31,3840,0),hb,1e3,0),hb);x[a+4316>>2]=b;x[31609]=0;x[c+12>>2]=0;d=b;b=c+12|0;S(947,a+4264|0,d|0,b|0);d=x[31609];x[31609]=0;a:{b:{c:{if((d|0)!=1){d:{if(!y[a+4260|0]){break d}d=x[a+4316>>2];x[31609]=0;x[c+12>>2]=0;S(947,a+4276|0,d|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break d}b=T(124540)|0;break c}x[c+12>>2]=0;b=c+12|0;nQ(a+4288|0,b);x[c+12>>2]=0;nQ(a+4300|0,b);break b}b=T(124540)|0}if((gb|0)!=($(124540)|0)){break a}Y(b|0)|0;x[a+4316>>2]=0;Z()}fb=c+16|0;return}Q(b|0);p()}function MQ(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=fb-16|0;fb=f;c=vb(f+12|0,x[a+4>>2]);d=vb(f+8|0,x[a>>2]);h=x[vb(f+4|0,x[b+4>>2])>>2];g=fb-16|0;fb=g;i=g+8|0;e=fb-32|0;fb=e;fd(e+24|0,x[c>>2],x[d>>2]);j=e+16|0;d=x[e+24>>2];k=x[e+28>>2];c=fb-16|0;fb=c;x[c+8>>2]=h;x[c+12>>2]=d;while(1){if(Fd(d,k)){d=KQ(d);zc(KQ(x[c+8>>2]),d,2048);d=JQ(c+12|0);JQ(c+8|0);d=x[d>>2];continue}break}rc(j,d,c+8|0);fb=c+16|0;c=x[e+16>>2];x[e+12>>2]=x[e+20>>2];rc(i,c,e+12|0);fb=e+32|0;fb=g+16|0;x[b+4>>2]=x[g+12>>2];Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=f+16|0}function bna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=fb-16|0;fb=b;e=x[a+40>>2];f=x[a+36>>2];j=x[a+16>>2];h=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=h;k=x[a+32>>2];l=x[a+28>>2];h=x[a+8>>2];m=x[a+12>>2];while(1){if(d){i=x[b+12>>2]+j|0;g=v[i|0];g=((D(v[i+1|0]-g|0,x[b+8>>2]>>>10&4194048)|0)/16384|0)+(g<<8)|0;f=f+l|0;x[c>>2]=x[c>>2]+D(g,f>>12);e=e+k|0;x[c+4>>2]=x[c+4>>2]+D(g,e>>12);Pb(b+8|0,h,m);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;x[a+40>>2]=e;x[a+20>>2]=f>>12;x[a+36>>2]=f;x[a+24>>2]=e>>12;fb=b+16|0}function x$(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=fb-16|0;fb=f;c=vb(f+12|0,x[a+4>>2]);d=vb(f+8|0,x[a>>2]);h=x[vb(f+4|0,x[b+4>>2])>>2];g=fb-16|0;fb=g;i=g+8|0;e=fb-32|0;fb=e;fd(e+24|0,x[c>>2],x[d>>2]);j=e+16|0;d=x[e+24>>2];k=x[e+28>>2];c=fb-16|0;fb=c;x[c+8>>2]=h;x[c+12>>2]=d;while(1){if(Fd(d,k)){d=gw(d);zc(gw(x[c+8>>2]),d,36);d=u$(c+12|0);u$(c+8|0);d=x[d>>2];continue}break}rc(j,d,c+8|0);fb=c+16|0;c=x[e+16>>2];x[e+12>>2]=x[e+20>>2];rc(i,c,e+12|0);fb=e+32|0;fb=g+16|0;x[b+4>>2]=x[g+12>>2];Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=f+16|0}function t6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=x[a>>2];d=oc(c,x[a+4>>2]);if(d>>>0<b>>>0){h=fb-32|0;fb=h;e=b-d|0;b=x[Ab(a)>>2];c=x[a+4>>2];a:{if(e>>>0<=b-c>>2>>>0){Uq(a,e);break a}f=ht(a);d=Mf(a,oc(x[a>>2],c)+e|0);g=oc(x[a>>2],x[a+4>>2]);c=fb-16|0;fb=c;b=h+12|0;Lg(b+12|0,f);b:{if(!d){f=0;d=0;break b}nJ(c+8|0,x[b+16>>2],d);f=x[c+12>>2];d=x[c+8>>2]}x[b>>2]=d;g=d+(g<<2)|0;x[b+8>>2]=g;x[b+4>>2]=g;i=nc(b),j=d+(f<<2)|0,x[i>>2]=j;fb=c+16|0;kA(b,e);Tm(a,b);_P(b);a=x[b>>2];if(a){ny(x[b+16>>2],a,Uz(b))}}fb=h+32|0;return}if(b>>>0<d>>>0){Jd(a,c+(b<<2)|0)}}function ija(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;f=fb-16|0;fb=f;x[f+12>>2]=b;a:{if(Du(a)>>>0>=b>>>0){e=x[a>>2];g=jm(e,x[a+4>>2]);x[f+8>>2]=g;d=x[Hb(f+12|0,f+8|0)>>2];while(1){if(d){d=d-1|0;e=nR(e,c)+52|0;continue}break}if(b>>>0>g>>>0){qA(a,b-g|0,c);break a}lR(a,x[a>>2]+D(b,52)|0);break a}if(x[a>>2]){Eu(a);d=x[a>>2];Du(a);Db(d);h=Ab(a),i=0,x[h>>2]=i;x[a>>2]=0;x[a+4>>2]=0}e=kR(a,b);d=fb-16|0;fb=d;if(uh(82595524)>>>0<e>>>0){ed();p()}jR(d+8|0,e);e=x[d+8>>2];x[a+4>>2]=e;x[a>>2]=e;h=Ab(a),i=e+D(x[d+12>>2],52)|0,x[h>>2]=i;fb=d+16|0;qA(a,b,c)}fb=f+16|0}function gm(a,b,c,d,e,f){var g=0;g=fb-16|0;fb=g;v[g+14|0]=d;v[g+15|0]=c;v[g+13|0]=e;v[g+12|0]=f;d=0;a:{b:{while(1){c=d&255;if(c>>>0>3){break b}e=y[g+15|0];uw(g+10|0,e,y[g+14|0],c>>>0>1);if(!(y[g+10|0]|!e)){d=d+1|0;rg(g+15|0,g+13|0);rg(g+14|0,g+12|0);continue}break}c=z[g+10>>1];v[b+2|0]=c;v[b+4|0]=c>>>8;c=y[g+13|0];v[b+5|0]=y[g+12|0];v[b+3|0]=c;v[g+9|0]=0;ee(a,0,g+9|0);break a}d=y[g+15|0];e=si(d);c=y[g+13|0];if(e>>>0>si(c)>>>0){rg(g+15|0,g+13|0);rg(g+14|0,g+12|0);d=y[g+15|0];c=y[g+13|0]}v[b+4|0]=0;v[b+2|0]=0;v[b+5|0]=y[g+12|0];v[b+3|0]=c;ee(a,d,g+14|0)}fb=g+16|0}function bga(a){a=a|0;var b=0;b=8016;a:{b:{c:{switch(a-277|0){default:if((a|0)==357){break b}d:{if((a|0)!=257){if((a|0)==267){break d}if(a){break a}b=22292;break a}b=8049;break a}b=18202;break a;case 0:b=5011;break a;case 9:b=8072;break a;case 10:b=8086;break a;case 11:b=5388;break a;case 12:b=5408;break a;case 19:b=8098;break a;case 20:b=8030;break a;case 21:b=12914;break a;case 22:b=12237;break a;case 1:case 2:case 3:case 4:case 5:case 6:case 7:case 8:case 13:case 14:case 15:case 16:case 17:case 18:break a;case 23:break c}}b=6019;break a}b=7983}return Cg(b)|0}function rQ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a=Li(a,b,c,d);v[a+4260|0]=e;x[a>>2]=44684;c=Nb(a+4264|0);d=Nb(a+4276|0);x[a+4328>>2]=0;b=a+4320|0;x[b>>2]=0;x[b+4>>2]=0;x[a+4312>>2]=0;x[a+4316>>2]=0;b=a+4208|0;f=yb(b,0),g=1056964608,x[f>>2]=g;f=yb(b,1),g=1036831949,x[f>>2]=g;f=yb(b,2),g=1038174126,x[f>>2]=g;f=yb(b,3),g=1065353216,x[f>>2]=g;f=yb(b,4),g=1061158912,x[f>>2]=g;f=yb(b,5),g=1059082943,x[f>>2]=g;f=yb(b,6),g=1061997773,x[f>>2]=g;x[31609]=0;O(941,a+44|0,2);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}b=N()|0;wc(d);wc(c);_f(a);Q(b|0);p()}function ana(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=fb-16|0;fb=b;f=x[a+40>>2];g=x[a+36>>2];i=x[a+16>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;j=x[a+32>>2];k=x[a+28>>2];l=x[a+8>>2];m=x[a+12>>2];while(1){if(d){e=(x[b+12>>2]<<1)+i|0;h=w[e>>1];e=h+((D(w[e+2>>1]-h|0,x[b+8>>2]>>>18|0)|0)/16384|0)|0;g=g+k|0;x[c>>2]=x[c>>2]+D(e,g>>12);f=f+j|0;x[c+4>>2]=x[c+4>>2]+D(e,f>>12);Pb(b+8|0,l,m);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;x[a+40>>2]=f;x[a+20>>2]=g>>12;x[a+36>>2]=g;x[a+24>>2]=f>>12;fb=b+16|0}function Mfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-16|0;fb=d;x[31609]=0;W(996,a|0);e=x[31609];x[31609]=0;a:{b:{c:{if((e|0)==1){break c}x[31609]=0;W(997,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break c}e=x[a+24>>2];b=qc(d+8|0,b);x[31609]=0;f=x[b+4>>2];x[d>>2]=x[b>>2];x[d+4>>2]=f;V(1014,e|0,d|0,(c|0)!=0|0,1);c=x[31609];x[31609]=0;b=1;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,10021,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();b=0}fb=d+16|0;return b|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function tI(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;a:{if(a>>>0>131071){break a}f=a&255;c=(f>>>0)/3|0;g=x[((D(c,-3)+a&255)<<2)+108232>>2];e=c;c=a>>>8|0;d=x[(((D(g,y[(e+D(y[c+109616|0],86)|0)+109616|0])>>>11>>>0)%6|0)+y[c+112288|0]<<2)+108256>>2];c=d>>8;d=d&255;if(d>>>0<=1){return(c&0-(b^d))+a|0}d=c&255;if(!d){break a}c=c>>>8|0;while(1){h=d>>>1|0;e=h+c|0;i=y[(e<<1)+109216|0];if((i|0)==(f|0)){c=x[(y[(e<<1)+109217|0]<<2)+108256>>2];d=c&255;if(d>>>0<=1){return(0-(b^d)&c>>8)+a|0}return(b?-1:1)+a|0}g=e;e=f>>>0<i>>>0;c=e?c:g;d=e?h:d-h|0;if(d){continue}break}}return a}function o3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=fb-16|0;fb=d;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;a:{b:{c:{d:{if((c|0)==1){break d}x[31609]=0;W(997,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break d}c=x[a+24>>2];b=qc(d+8|0,b);x[31609]=0;e=x[b+4>>2];x[d>>2]=x[b>>2];x[d+4>>2]=e;b=fI(c,d,1);e=x[31609];x[31609]=0;c=hb;if((e|0)!=1){break c}}Y(T(0)|0)|0;x[31609]=0;V(983,8689,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break b}Z();b=0;c=0}fb=d+16|0;a=c;break a}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}gb=a;return b|0}function gra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-48|0;fb=e;c=x[a+8>>2];d=x[a>>2];x[31609]=0;c=U(150,d|0,c|0,1)|0;d=x[31609];x[31609]=0;a:{if((d|0)==1){break a}b:{if(!c){break b}x[31609]=0;W(517,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;c=R(197,a|0)|0;d=x[31609];x[31609]=0;c:{if((d|0)!=1){while(1){if(!(c&255)){break b}x[31609]=0;d=e+15|0;f=P(518,a|0,d|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break c}g=f;f=y[e+15|0];if(g&f>>>0<64){zc(_Y(x[b>>2],f),d,33)}c=c-1|0;continue}}break a}break a}ub(a);fb=e+48|0;return}b=N()|0;ub(a);Q(b|0);p()}function eba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=fb-16|0;fb=f;g=f+4|0;e=fb-32|0;fb=e;c=qf(e+20|0,1,0);a:{b:{c:{while(1){d=Kb(c);rs(e+12|0,d,Cb(x[c+4>>2],y[c+11|0])+d|0,y[b|0]);if(!x[e+16>>2]){break c}d=mi(Cb(x[c+4>>2],y[c+11|0]));x[31609]=0;O(45,c|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){continue}break}break b}b=x[e+12>>2];d=Kb(c);x[31609]=0;O(46,c|0,b-d|0);b=x[31609];x[31609]=0;d:{if((b|0)!=1){x[31609]=0;O(303,g|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break b}break b}tb(c);fb=e+32|0;break a}a=N()|0;tb(c);Q(a|0);p()}Rh(a,g);tb(g);fb=f+16|0}function br(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=fb-16|0;fb=f;g=f+4|0;e=fb-32|0;fb=e;c=qf(e+20|0,1,0);a:{b:{c:{while(1){d=Kb(c);rs(e+12|0,d,Cb(x[c+4>>2],y[c+11|0])+d|0,x[b>>2]);if(!x[e+16>>2]){break c}d=mi(Cb(x[c+4>>2],y[c+11|0]));x[31609]=0;O(45,c|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){continue}break}break b}b=x[e+12>>2];d=Kb(c);x[31609]=0;O(46,c|0,b-d|0);b=x[31609];x[31609]=0;d:{if((b|0)!=1){x[31609]=0;O(303,g|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break b}break b}tb(c);fb=e+32|0;break a}a=N()|0;tb(c);Q(a|0);p()}Rh(a,g);tb(g);fb=f+16|0}function FX(a){var b=0,c=0,d=0;a:{if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=1196314451){break a}c=y[a+4|0]|y[a+5|0]<<8|(y[a+6|0]<<16|y[a+7|0]<<24);if(c>>>0<1108){break a}b=a+1104|0;if((c-1108|0)!=(y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24))|c>>>0>262144){break a}b=a+1094|0;if(y[b|0]|y[b+1|0]<<8){break a}b=a+1096|0;if((y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24))-5>>>0<4294967292){break a}if(!Ev(a+8|0)){break a}b=40;while(1){d=(b|0)==1094;if(d){break a}c=a+b|0;if(y[c+32|0]>15|y[c+33|0]>64){break a}b=b+34|0;if(Ev(c)){continue}break}}return d}function wR(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=fb-16|0;fb=h;v[h+15|0]=b;v[h+14|0]=10;fh(g,y[Qb(h+15|0,h+14|0)|0]);v[g+15|0]=c;v[g+16|0]=c;v[g+14|0]=e;v[g+13|0]=d;j=x[g>>2];k=Sd(j,x[g+4>>2]);b=0;while(1){if((b|0)!=(k|0)){m=yb(j,b);l=D(b,3)+f|0;i=(y[l|0]|y[l+1|0]<<8)>>>4|0;w[m>>1]=i;a:{if(b){n=z[yb(j,b-1|0)>>1];if(i>>>0>=n>>>0){break a}i=n+1|0}else{i=0}o=yb(j,b),p=i,w[o>>1]=p}o=m,p=Ld(y[l+2|0],0,64),v[o+2|0]=p;b=b+1|0;continue}break}v[g+12|0]=a>>>1&(d>>>0<=e>>>0?(d>>>0<=k>>>0)<<1:0)|(a<<1&(c>>>0<=k>>>0)<<2|(y[g+12|0]&248|a&1));fb=h+16|0}function Wv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=fb-16|0;fb=f;g=f+4|0;e=fb-32|0;fb=e;c=qf(e+20|0,1,0);a:{b:{c:{while(1){d=Kb(c);Aw(e+12|0,d,Cb(x[c+4>>2],y[c+11|0])+d|0,z[b>>1]);if(!x[e+16>>2]){break c}d=mi(Cb(x[c+4>>2],y[c+11|0]));x[31609]=0;O(45,c|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){continue}break}break b}b=x[e+12>>2];d=Kb(c);x[31609]=0;O(46,c|0,b-d|0);b=x[31609];x[31609]=0;d:{if((b|0)!=1){x[31609]=0;O(47,g|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break b}break b}tb(c);fb=e+32|0;break a}a=N()|0;tb(c);Q(a|0);p()}Rh(a,g);tb(g);fb=f+16|0}function S_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=fb-16|0;fb=f;g=f+4|0;e=fb-32|0;fb=e;c=qf(e+20|0,1,0);a:{b:{c:{while(1){d=Kb(c);Aw(e+12|0,d,Cb(x[c+4>>2],y[c+11|0])+d|0,x[b>>2]);if(!x[e+16>>2]){break c}d=mi(Cb(x[c+4>>2],y[c+11|0]));x[31609]=0;O(45,c|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){continue}break}break b}b=x[e+12>>2];d=Kb(c);x[31609]=0;O(46,c|0,b-d|0);b=x[31609];x[31609]=0;d:{if((b|0)!=1){x[31609]=0;O(47,g|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break b}break b}tb(c);fb=e+32|0;break a}a=N()|0;tb(c);Q(a|0);p()}Rh(a,g);tb(g);fb=f+16|0}function Np(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=fb-16|0;fb=f;g=f+4|0;e=fb-32|0;fb=e;c=qf(e+20|0,1,0);a:{b:{c:{while(1){d=Kb(c);rs(e+12|0,d,Cb(x[c+4>>2],y[c+11|0])+d|0,x[b>>2]);if(!x[e+16>>2]){break c}d=mi(Cb(x[c+4>>2],y[c+11|0]));x[31609]=0;O(45,c|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){continue}break}break b}b=x[e+12>>2];d=Kb(c);x[31609]=0;O(46,c|0,b-d|0);b=x[31609];x[31609]=0;d:{if((b|0)!=1){x[31609]=0;O(47,g|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break b}break b}tb(c);fb=e+32|0;break a}a=N()|0;tb(c);Q(a|0);p()}Rh(a,g);tb(g);fb=f+16|0}function Mt(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0,m=0;h=fb-240|0;fb=h;x[h+236>>2]=d;x[h+232>>2]=c;x[h>>2]=a;m=!f;a:{b:{c:{d:{if((c|0)!=1){i=a;j=1;break d}i=a;j=1;if(d){break d}f=a;break c}while(1){k=(e<<2)+g|0;f=i-x[k>>2]|0;if((mo(f,a,b)|0)<=0){f=i;break c}l=m^-1;m=1;e:{if(!((l|(e|0)<2)&1)){k=x[k-8>>2];l=i-4|0;if((mo(l,f,b)|0)>=0){break e}if((mo(l-k|0,f,b)|0)>=0){break e}}x[(j<<2)+h>>2]=f;c=DL(c,d);Ot(h+232|0,c);j=j+1|0;e=c+e|0;i=f;d=x[h+236>>2];c=x[h+232>>2];if(d|(c|0)!=1){continue}break b}break}f=i;break b}if(!m){break a}}CL(h,j);az(f,b,e,g)}fb=h+240|0}function wz(a,b,c){var d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(e+8|0,x[vb(e+4|0,a)>>2]);a:{b:{if(c){x[31609]=0;O(1139,a|0,c|0);d=x[31609];x[31609]=0;if((d|0)==1){break b}f=fb-16|0;fb=f;d=xh(f+4|0,a,c);c=x[d+4>>2];g=x[d+8>>2];while(1){if((c|0)==(g|0)){kc(d);fb=f+16|0}else{x[c>>2]=0;tc(c);c=c+4|0;x[d+4>>2]=c;continue}break}}c=e+8|0;Qd(c);bh(c);fb=e+16|0;break a}a=N()|0;bh(e+8|0);Q(a|0);p()}e=a;a=0;c=0;d=fb-16|0;fb=d;f=d+12|0;while(1){if(a>>>0<32){a=a+48|0;c=mS(b);continue}break}x[f>>2]=c;Co(f);fb=d+16|0;x[e+12>>2]=x[f>>2];return e}function os(a,b){a=a|0;b=b|0;var c=0,d=0;d=fb-16|0;fb=d;a=Fb(a);a:{b:{c:{switch(b|0){case 0:x[31609]=0;b=P(1,d+4|0,15924)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}zb(a,b);tb(b);break b;case 1:x[31609]=0;b=P(1,d+4|0,15949)|0;c=x[31609];x[31609]=0;if((c|0)!=1){zb(a,b);tb(b);break b}break a;case 2:x[31609]=0;b=P(1,d+4|0,15897)|0;c=x[31609];x[31609]=0;if((c|0)!=1){zb(a,b);tb(b);break b}break a;case 3:break c;default:break b}}x[31609]=0;b=P(1,d+4|0,15871)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}zb(a,b);tb(b)}fb=d+16|0;return}b=N()|0;tb(a);Q(b|0);p()}function tna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=fb-16|0;fb=b;i=x[a+16>>2];h=kg(1,2);e=hb;j=e;Pb(a,h,e);k=x[a+24>>2];l=x[a+20>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;e=x[a+8>>2];m=x[a+12>>2];while(1){if(d){d=d-1|0;g=x[b+8>>2];g=(((x[b+12>>2]&2147483647)<<1|g>>>31)&-2)+i|0;f=0;while(1){if((f|0)!=2){x[(f<<2)+b>>2]=v[f+g|0]<<8;f=f+1|0;continue}break}x[c>>2]=x[c>>2]+D(x[b>>2],l);x[c+4>>2]=x[c+4>>2]+D(x[b+4>>2],k);Pb(b+8|0,e,m);c=c+8|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;Ig(a,h,j);fb=b+16|0}function kV(a,b){var c=0,d=0;v[a+15|0]=0;v[a+16|0]=0;v[a+17|0]=0;v[a+18|0]=0;v[a+19|0]=0;v[a+20|0]=0;v[a+21|0]=0;v[a+22|0]=0;v[a+14|0]=5;w[a+12>>1]=0;x[a+8>>2]=128;x[a>>2]=256;x[a+4>>2]=64;x[a+28>>2]=0;v[a+27|0]=60;x[a+40>>2]=0;x[a+44>>2]=0;v[a+33|0]=2;v[a+34|0]=0;v[a+35|0]=0;v[a+36|0]=2;v[a+23|0]=0;v[a+24|0]=0;v[a+25|0]=255;v[a+26|0]=0;v[a+32|0]=0;fC(a+48|0);fC(a+68|0);fC(a+88|0);ev(a+492|0);ev(a+524|0);dk(a,0,0);ck(a,0,0);x[a+40>>2]=0;x[a+44>>2]=0;Ov(a,b);b=a+108|0;d=QC(b);c=1;while(1){if((b|0)!=(d|0)){v[b|0]=c;c=c+1|0;b=b+1|0;continue}break}return a}function Lfa(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;e=fb-16|0;fb=e;x[31609]=0;W(996,a|0);d=x[31609];x[31609]=0;a:{b:{c:{if((d|0)==1){break c}x[31609]=0;W(997,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break c}d=x[a+24>>2];b=qc(e+8|0,b);x[31609]=0;f=x[b+4>>2];x[e>>2]=x[b>>2];x[e+4>>2]=f;Za(1016,d|0,e|0,+c,1);d=x[31609];x[31609]=0;b=1;if((d|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,5926,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();b=0}fb=e+16|0;return b|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function r6(a){a=a|0;if(y[499928]){return x[124981]}if(!y[501024]){v[501024]=1}wd(500736,103724);wd(500748,103756);wd(500760,103792);wd(500772,103816);wd(500784,103840);wd(500796,103856);wd(500808,103876);wd(500820,103896);wd(500832,103924);wd(500844,103964);wd(500856,103996);wd(500868,104032);wd(500880,104068);wd(500892,104084);wd(500904,104100);wd(500916,104116);wd(500928,103840);wd(500940,104132);wd(500952,104148);wd(500964,104164);wd(500976,104180);wd(500988,104196);wd(501e3,104212);wd(501012,104228);v[499928]=1;x[124981]=500736;return 500736}function Coa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=fb-16|0;fb=d;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(d+8|0,x[vb(d+4|0,a)>>2]);a:{if(b){x[31609]=0;O(710,a|0,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}f=fb-16|0;fb=f;c=f+4|0;x[c>>2]=a;e=x[a+4>>2];x[c+4>>2]=e;x[c+8>>2]=e+D(b,9);b=x[c+4>>2];e=x[c+8>>2];while(1){if((b|0)==(e|0)){kc(c);fb=f+16|0}else{v[b|0]=0;v[b+1|0]=0;v[b+2|0]=0;v[b+3|0]=0;v[b+4|0]=0;v[b+5|0]=0;v[b+6|0]=0;v[b+7|0]=0;v[b+8|0]=0;b=b+9|0;x[c+4>>2]=b;continue}break}}b=d+8|0;Qd(b);wv(b);fb=d+16|0;return a|0}a=N()|0;wv(d+8|0);Q(a|0);p()}function AD(a,b){var c=0,d=0;a:{b:{c:{d:{e:{f:{g:{h:{d=y[a+3|0];switch(d|0){case 9:break d;case 10:break e;case 16:case 17:break g;case 0:case 1:case 2:case 3:case 11:case 12:case 13:case 14:case 15:break h;default:break a}}if(!y[a|0]){break a}switch(d|0){case 9:break d;case 10:break e;case 0:case 1:case 2:case 3:case 11:case 12:case 13:case 14:case 15:break f;case 16:case 17:break g;default:break c}}c=8;break c}c=y[a|0];if(!(c&7)){break c}}c=b+1>>>1|0;b=((d|0)==10)<<4;break b}c=16}c=D(c>>>3|0,b);b=((d|0)==10)<<4}c=b+D(ir(y[a+1|0]),c)|0}return c}function Wia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=fb-16|0;fb=e;h=If(a,c);ae(e,x[a+36>>2]);a:{b:{if(!h){Qc(e,a+32|0,5);c=-1;if(!Gb(x[x[e>>2]>>2],x[e+4>>2])){break b}break a}c=x[h+16>>2]}f=x[a+36>>2];c:{if(!((c|0)!=4&(c|0)!=-1)){d=fb-16|0;fb=d;x[d+12>>2]=0;vq(f,d+12|0);B[b>>2]=B[d+12>>2];break c}d=fb-16|0;fb=d;x[d+12>>2]=c;x[d+8>>2]=4;c=x[Hb(d+12|0,d+8|0)>>2];g=fb-16|0;fb=g;xz(g+8|0,f);f=x[g+12>>2];if(dt(-1,2147483647,c,0)^1){i=dt(c,0,0,-2147483648)^1}else{i=0}if(i){Di(f,c,0,1)}fb=g+16|0;x[b>>2]=0}fb=d+16|0;d=h}ef(a,d);fb=e+16|0}function Qja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=fb-48|0;fb=d;c=d+28|0;Uj(c,b,1819307379);kd(a+40|0,c);ub(c);Uj(c,b,1953721961);kd(a+60|0,c);ub(c);Uj(c,b,543520099);kd(a+120|0,c);ub(c);Uj(c,b,1414744396);x[31609]=0;e=P(412,c|0,13891)|0;f=x[31609];x[31609]=0;a:{if((f|0)!=1){b:{if(e){x[31609]=0;e=d+8|0;S(807,e|0,c|0,2);c=x[31609];x[31609]=0;if((c|0)==1){break b}Cv(a+140|0,e);ke(e)}x[31609]=0;S(808,d+8|0,b|0,1634890872);b=x[31609];x[31609]=0;if((b|0)!=1){break a}}}a=N()|0;ub(d+28|0);Q(a|0);p()}b=a+80|0;a=d+8|0;kd(b,a);ub(a);ub(d+28|0);fb=d+48|0}function qna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=fb-16|0;fb=b;j=x[a+16>>2];h=kg(1,2);e=hb;k=e;Pb(a,h,e);f=x[a+40>>2];g=x[a+36>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;l=x[a+32>>2];m=x[a+28>>2];e=x[a+8>>2];n=x[a+12>>2];while(1){if(d){i=w[(x[b+12>>2]<<1)+j>>1];g=g+m|0;x[c>>2]=x[c>>2]+D(i,g>>12);f=f+l|0;x[c+4>>2]=x[c+4>>2]+D(f>>12,i);Pb(b+8|0,e,n);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;x[a+40>>2]=f;x[a+20>>2]=g>>12;x[a+36>>2]=g;x[a+24>>2]=f>>12;Ig(a,h,k);fb=b+16|0}function Bw(a,b){var c=0,d=0,e=0,f=0,g=0;f=fb-16|0;fb=f;g=f+4|0;e=fb-32|0;fb=e;c=qf(e+20|0,1,0);a:{b:{c:{while(1){d=Kb(c);Aw(e+12|0,d,Cb(x[c+4>>2],y[c+11|0])+d|0,y[b|0]);if(!x[e+16>>2]){break c}d=mi(Cb(x[c+4>>2],y[c+11|0]));x[31609]=0;O(45,c|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){continue}break}break b}b=x[e+12>>2];d=Kb(c);x[31609]=0;O(46,c|0,b-d|0);b=x[31609];x[31609]=0;d:{if((b|0)!=1){x[31609]=0;O(47,g|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){break d}break b}break b}tb(c);fb=e+32|0;break a}a=N()|0;tb(c);Q(a|0);p()}Rh(a,g);tb(g);fb=f+16|0}function Ela(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=fb-16|0;fb=f;h=z[c>>1];i=c;e=fb-16|0;fb=e;g=b;d=de(b);a:{if(d){c=gc(b);while(1){b=d;d=z[b+14>>1];if(Zk(h,d)){c=b;d=x[b>>2];if(d){continue}break a}if(!Zk(d,h)){break a}c=b+4|0;d=x[b+4>>2];if(d){continue}break}break a}b=gc(g);c=b}x[e+12>>2]=b;b=x[c>>2];if(!b){b=fb-16|0;fb=b;d=gc(g);d=Dh(e,Ec(16),Og(b+8|0,d));nm(x[d>>2]+14|0,z[i>>1]);k=gc(d),l=1,v[k+4|0]=l;fb=b+16|0;$g(g,x[e+12>>2],c,x[e>>2]);b=ne(e);Jk(e);j=1}c=f+8|0;_g(c,x[vb(e,b)>>2],j);fb=e+16|0;jV(a,c);fb=f+16|0}function nF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=fb-16|0;fb=f;x[f+8>>2]=e;x[f+12>>2]=d;sf(a);xs(a,c);d=0;e=0;a:while(1){if(c>>>0>d>>>0){i=c-d|0;x[f+4>>2]=i;g=x[Hb(f+12|0,f+4|0)>>2];h=g+e|0;l=e>>>0>h>>>0?e:h;j=ws(Ht(a,b+d|0,g),1,13);while(1)if((e|0)==(l|0)){x[f+4>>2]=i-g;e=h+1|0;d=x[Hb(f+8|0,f+4|0)>>2]+(d+g|0)|0;continue a}else{b:{c:{d:{k=v[dc(j,e)|0];switch(k-10|0){case 1:case 2:break b;case 0:case 3:break c;default:break d}}if(k){break b}}m=dc(j,e),n=32,v[m|0]=n}e=e+1|0;continue}}break}fb=f+16|0}function Qfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;x[31609]=0;W(996,a|0);d=x[31609];x[31609]=0;a:{b:{c:{if((d|0)==1){break c}x[31609]=0;W(997,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break c}d=x[a+24>>2];b=qc(c+8|0,b);x[31609]=0;f=x[b+4>>2];x[c>>2]=x[b>>2];x[c+4>>2]=f;e=+oa(1007,d|0,c|0,1);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,5963,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();e=0}fb=c+16|0;return+e}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function rna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=fb-16|0;fb=b;j=x[a+16>>2];h=kg(1,2);e=hb;k=e;Pb(a,h,e);f=x[a+40>>2];g=x[a+36>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;l=x[a+32>>2];m=x[a+28>>2];e=x[a+8>>2];n=x[a+12>>2];while(1){if(d){i=v[x[b+12>>2]+j|0]<<8;g=g+m|0;x[c>>2]=x[c>>2]+D(i,g>>12);f=f+l|0;x[c+4>>2]=x[c+4>>2]+D(f>>12,i);Pb(b+8|0,e,n);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;x[a+40>>2]=f;x[a+20>>2]=g>>12;x[a+36>>2]=g;x[a+24>>2]=f>>12;Ig(a,h,k);fb=b+16|0}function Rfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=fb-16|0;fb=d;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;a:{b:{c:{if((c|0)==1){break c}x[31609]=0;W(997,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break c}c=x[a+24>>2];b=qc(d+8|0,b);x[31609]=0;e=x[b+4>>2];x[d>>2]=x[b>>2];x[d+4>>2]=e;b=U(1003,c|0,d|0,1)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,10052,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();b=0}fb=d+16|0;return b|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function zT(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;f=-1;a:{if(!(y[b+851|0]&2)){break a}d=!(y[a+480209|0]&32);b:{c:{d:{c=x[b+656>>2];e:{if(c){e=y[c+22|0];if(vd(e)){g=b,h=Hh(e),v[g+838|0]=h;d=1}e=y[c+21|0];f:{if(vd(e)){g=b,h=Hh(e),v[g+837|0]=h;break f}if(!d){break d}}d=1;c=y[c+25|0];if((c|0)==255){break e}v[b+845|0]=c;break e}x[b+776>>2]=0;x[b+780>>2]=0}c=b+837|0;if(y[b+837|0]>=127){break c}if(d){break b}break a}if(y[b+837|0]<127){break a}d=0;c=b+837|0}if(!d|!Ob(a+1074312|0,36)){break a}}f=Jq(a,b,1,256);if((f|0)<0){break a}f=y[c|0]>>>1|0}return f}function mka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=fb-208|0;fb=e;w[a+480212>>1]=0;x[a+480240>>2]=65536;x[a+480244>>2]=65536;rS(a+946304|0);f=a+906300|0;g=vk(f);d=e+48|0;Rb(d,0,160);d=tS(d);x[31609]=0;S(860,f|0,g|0,d|0);f=x[31609];x[31609]=0;a:{if((f|0)!=1){UA(d);d=Ie(e+28|0,b);x[31609]=0;f=x[d+12>>2];x[e+16>>2]=x[d+8>>2];x[e+20>>2]=f;x[e+24>>2]=x[d+16>>2];f=x[d+4>>2];x[e+8>>2]=x[d>>2];x[e+12>>2]=f;a=U(861,a|0,e+8|0,c|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){a=N()|0;break a}ub(b);fb=e+208|0;return a|0}a=N()|0;UA(d)}ub(b);Q(a|0);p()}function iz(a,b,c){var d=0,e=0,f=E(0),g=E(0),h=E(0),i=E(0),j=0,k=E(0),l=E(0),m=E(0);e=fb-32|0;fb=e;g=B[a+24>>2];f=B[a+12>>2];h=B[a+48>>2];i=B[a+36>>2];VL(E(-B[a>>2]),E(g+f),E(h+i),e+20|0);VL(B[a+60>>2],E(h-i),E(g-f),e+8|0);B[e+12>>2]=-B[e+12>>2];a=0;while(1){if((a|0)!=3){d=a<<2;j=d+c|0;g=B[j>>2];f=B[d+(e+20|0)>>2];h=B[d+87424>>2];i=B[d+87436>>2];k=B[d+(e+8|0)>>2];B[j>>2]=E(f*h)-E(i*k);j=b+d|0;l=B[(0-a<<2)+87432>>2];d=5-a<<2;m=B[d+87424>>2];f=E(E(f*i)+E(k*h));B[j>>2]=E(g*l)-E(m*f);B[b+d>>2]=E(g*m)+E(f*l);a=a+1|0;continue}break}fb=e+32|0}function px(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-48|0;fb=e;f=x[b>>2];g=ib[x[x[f>>2]+36>>2]](f,c,d)|0;a:{if(!g){_h(a);break a}rm(e+32|0,x[b>>2],x[b+4>>2]);b=x[e+36>>2];x[e+16>>2]=x[e+32>>2];x[e+20>>2]=b;b=fb-16|0;fb=b;d=e+16|0;f=rm(b+8|0,x[d>>2],x[d+4>>2]);x[31609]=0;h=x[f+4>>2];x[b>>2]=x[f>>2];x[b+4>>2]=h;V(166,e+40|0,b|0,c|0,g|0);c=x[31609];x[31609]=0;b:{if((c|0)!=1){me(d);fb=b+16|0;break b}a=N()|0;me(d);Q(a|0);p()}b=Md(e+24|0);c=x[e+44>>2];x[e+8>>2]=x[e+40>>2];x[e+12>>2]=c;c=x[b+4>>2];x[e>>2]=x[b>>2];x[e+4>>2]=c;Jp(a,e+8|0,e)}fb=e+48|0}function gC(a,b){var c=0,d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;c=x[a>>2];a:{if(!mc(c,x[a+4>>2])){w[c>>1]=0;Of(c+2|0,b);f=d,g=Fk(wb(x[a>>2]),1),x[f+12>>2]=g;while(1){e=wb(x[a+4>>2]);c=x[d+12>>2];if(Ib(c,e)){f=c,g=z[qe(c,Fk(c,-1))>>1],w[f>>1]=g;Of(c+2|0,b);oW(d+12|0);continue}else{Of(a+14|0,Sd(x[a>>2],x[a+4>>2])-1&255);Of(a+13|0,y[a+14|0]);Of(a+16|0,Sd(x[a>>2],x[a+4>>2])-1&255);Of(a+15|0,y[a+16|0]);if(y[a+17|0]==255){break a}Of(a+17|0,Sd(x[a>>2],x[a+4>>2])-1&255);break a}}}v[a+17|0]=255;v[a+13|0]=0;v[a+14|0]=0;v[a+15|0]=0;v[a+16|0]=0}fb=d+16|0}function zo(a,b,c,d){var e=0,f=0;e=fb-16|0;fb=e;a:{b:{c:{if(!d){break c}f=c>>31;d=f;d=(d^c)-d|0;if(d>>>0<224){break c}Jb(e+8|0,a+1074312|0,3);if(Gb(x[x[e+8>>2]>>2],x[e+12>>2])){break c}if(!(v[(D(b,872)+a|0)+1075843|0]&1)){break a}c=D(d&15,(c|0)!=0|f);c=d>>>0>239?c<<2:c;break b}if(v[(D(b,872)+a|0)+1075843|0]&1){Jb(e+8|0,a+1074312|0,3);if(!Gb(x[x[e+8>>2]>>2],x[e+12>>2])){break a}}c=c<<2}if(!c){break a}f=D(b,872)+a|0;d=x[f+1075648>>2];a=Dq(a,x[f+1075080>>2],d);if(!a){break a}ib[x[x[a>>2]+84>>2]](a,c,(d?y[d+33|0]:13)<<24>>24,b)}fb=e+16|0}function Bs(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-80|0;fb=e;f=x[c>>2];g=e+52|0;kH(g,c,71);x[31609]=0;c=e+4|0;S(d|0,c|0,b|0,(f&2?16:10)|0);b=x[31609];x[31609]=0;a:{b:{c:{d:{if((b|0)!=1){b=e+16|0;MV(b,c,x[e+52>>2]);x[31609]=0;d=e+28|0;V(299,d|0,b|0,x[e+52>>2],x[e+56>>2]);f=x[31609];x[31609]=0;if((f|0)==1){break d}x[31609]=0;f=e+40|0;S(300,f|0,d|0,g|0);h=x[31609];x[31609]=0;if((h|0)==1){break c}Rh(a,f);tb(f);tb(d);tb(b);tb(c);Jh(g);fb=e+80|0;return}c=N()|0;break a}c=N()|0;break b}c=N()|0;tb(e+28|0)}tb(e+16|0);tb(e+4|0)}Jh(e+52|0);Q(c|0);p()}function lka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=(b-a|0)/160|0;while(1){if((b|0)>0){b=b-1|0;x[a>>2]=x[c>>2];d=a+4|0;if((d|0)!=(c+4|0)){f=x[c+4>>2];h=x[c+8>>2];g=Pj(f,h);i=fb-16|0;fb=i;a:{if($o(d)>>>0>=g>>>0){j=x[d>>2];k=Xc(j,x[d+4>>2]);if(k>>>0<g>>>0){e=fb-16|0;fb=e;x[e+12>>2]=f;x[e+12>>2]=x[e+12>>2]+k;fb=e+16|0;e=x[e+12>>2];yk(f,e,j);zn(d,e,h,g-Xc(x[d>>2],x[d+4>>2])|0);break a}ZB(i+8|0,f,h,j);Jd(d,x[i+12>>2]);break a}dw(d);Wk(d,Wl(d,g));zn(d,f,h,g)}fb=i+16|0}zc(a+16|0,c+16|0,144);a=a+160|0;continue}break}}function Pra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=x[a>>2];d=Ik(e,x[a+4>>2]);if(d>>>0<b>>>0){e=fb-32|0;fb=e;d=b-d|0;b=x[Ab(a)>>2];f=x[a+4>>2];a:{if(d>>>0<=(b-f|0)/6>>>0){xD(a,d,c);break a}b=Ab(a);b=sZ(e+12|0,tD(a,Ik(x[a>>2],f)+d|0),Ik(x[a>>2],x[a+4>>2]),b);rZ(b,d,c);c=fb-16|0;fb=c;d=vb(c+12|0,x[a+4>>2]);f=vb(c+8|0,x[a>>2]);g=vb(c+4|0,x[b+4>>2]);h=b,i=oZ(x[d>>2],x[f>>2],x[g>>2]),x[h+4>>2]=i;Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=c+16|0;qZ(b)}fb=e+32|0;return}if(b>>>0<d>>>0){Jd(a,e+D(b,6)|0)}}function Pma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=fb-16|0;fb=b;g=x[a+24>>2];h=x[a+20>>2];i=x[a+16>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;j=x[a+8>>2];k=x[a+12>>2];while(1){if(d){e=x[b+8>>2];f=(x[b+12>>2]<<1)+i|0;e=e>>>21&2040;e=(((D(w[f>>1],w[e+38082>>1])+D(w[f-2>>1],w[e+38080>>1])|0)+D(w[f+2>>1],w[e+38084>>1])|0)+D(w[f+4>>1],w[e+38086>>1])|0)/16384|0;x[c>>2]=x[c>>2]+D(e,h);x[c+4>>2]=x[c+4>>2]+D(e,g);Pb(b+8|0,j,k);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;fb=b+16|0}function q7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;g=fb-16|0;fb=g;e=Cb(x[a+4>>2],y[a+11|0]);d=tn(a);f=Sd(b,c);a:{if(!f){break a}b:{h=Kb(a);if(!Q_(h,((Cb(x[a+4>>2],y[a+11|0])<<2)+h|0)+4|0,b)){if(d-e>>>0<f>>>0){oC(a,d,(e-d|0)+f|0,e,e,0)}d=Kb(a)+(e<<2)|0;while(1){if((b|0)==(c|0)){break b}yd(d,x[b>>2]);b=b+4|0;d=d+4|0;continue}}b=dq(g+4|0,b,c);c=Kb(b);e=y[b+11|0];d=x[b+4>>2];x[31609]=0;U(1289,a|0,c|0,Cb(d,e)|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){Ub(b);break a}a=N()|0;Ub(b);Q(a|0);p()}yd(d,0);lg(a,e+f|0)}fb=g+16|0;return a|0}function Vp(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-80|0;fb=e;f=x[c>>2];g=e+52|0;kH(g,c,3);x[31609]=0;c=e+4|0;S(d|0,c|0,b|0,(f&2?16:10)|0);b=x[31609];x[31609]=0;a:{b:{c:{d:{if((b|0)!=1){b=e+16|0;MV(b,c,x[e+52>>2]);x[31609]=0;d=e+28|0;V(19,d|0,b|0,x[e+52>>2],x[e+56>>2]);f=x[31609];x[31609]=0;if((f|0)==1){break d}x[31609]=0;f=e+40|0;S(20,f|0,d|0,g|0);h=x[31609];x[31609]=0;if((h|0)==1){break c}Rh(a,f);tb(f);tb(d);tb(b);tb(c);Jh(g);fb=e+80|0;return}c=N()|0;break a}c=N()|0;break b}c=N()|0;tb(e+28|0)}tb(e+16|0);tb(e+4|0)}Jh(e+52|0);Q(c|0);p()}function Oha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;a:{b:{c=y[a+11|0];c:{d:{if(vd(c)){c=x[a+4>>2];d=$i(x[a+8>>2])-1|0;if((c|0)==(d|0)){break d}break c}d=10;c=Hh(c);if((c|0)!=10){break b}}c=fb-16|0;fb=c;e:{if((d|0)!=2147483631){f=Kb(a);e=c+4|0;if(d>>>0<=1073741798){x[c+12>>2]=d<<1;x[c+4>>2]=d+1;g=Fh(x[bd(e,c+12|0)>>2])+1|0}else{g=2147483631}qg(e,g);e=x[c+4>>2];if(d){Dg(e,f,d)}if((d|0)!=10){Db(f)}yd(a,e);of(a,x[c+8>>2]);fb=c+16|0;break e}pf();p()}Bd(a,d);c=d}d=x[a>>2];Bd(a,c+1|0);break a}Ne(a,c+1|0);d=a}a=c+d|0;hd(a,b);hd(a+1|0,0)}function wj(a,b,c){var d=0,e=0;e=fb-16|0;fb=e;x[a+4>>2]=0;d=4;a:{b:{c:{if(!Id(y[Hm(e+15|0,a,1)|0])){break c}d=x[(x[x[a>>2]-12>>2]+a|0)+24>>2];x[31609]=0;b=U(85,d|0,b|0,c|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){x[a+4>>2]=b;d=(b|0)!=(c|0)?6:0;break c}Y(T(0)|0)|0;d=1;Fm(x[x[a>>2]-12>>2]+a|0,1);if(x[(x[x[a>>2]-12>>2]+a|0)+20>>2]&1){x[31609]=0;X(84);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)==1){break b}Q(a|0);p()}Z()}Xj(x[x[a>>2]-12>>2]+a|0,d);fb=e+16|0;return a}T(0)|0;Sb()}p()}function gS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;x[e+12>>2]=16777216;h=e+12|0;d=x[a>>2];c=oc(d,x[a+4>>2]);a:{if(c>>>0<b>>>0){f=fb-32|0;fb=f;b=b-c|0;c=x[Ab(a)>>2];d=x[a+4>>2];b:{if(b>>>0<=c-d>>2>>>0){YE(a,b,h);break b}c=Ab(a);c=Zf(f+12|0,Mf(a,oc(x[a>>2],d)+b|0),oc(x[a>>2],x[a+4>>2]),c);g=fb-16|0;fb=g;b=Gn(g+4|0,c+8|0,b);d=x[b>>2];while(1){if(x[b+4>>2]!=(d|0)){uq(d,x[h>>2]);d=x[b>>2]+4|0;x[b>>2]=d;continue}break}je(b);fb=g+16|0;Tm(a,c);Yf(c)}fb=f+32|0;break a}if(b>>>0<c>>>0){Jd(a,d+(b<<2)|0)}}QA(a);fb=e+16|0}function e1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=fb-32|0;fb=e;nd(b,0);f=e+8|0;ek(f,1,a+33|0);d=e+20|0;Cc(d,f);Be(b+43|0,d);tb(d);g=y[a+50|0]|y[a+51|0]<<8|(y[a+52|0]<<16|y[a+53|0]<<24);x[b>>2]=g;x[b+24>>2]=y[a+54|0]|y[a+55|0]<<8;v[e+20|0]=y[a+56|0];v[e+8|0]=64;h=b,i=y[Qb(d,f)|0]<<2,w[h+30>>1]=i;d=y[a+57|0]|y[a+58|0]<<8|(y[a+59|0]<<16|y[a+60|0]<<24);x[b+4>>2]=d;f=y[a+61|0]|y[a+62|0]<<8|(y[a+63|0]<<16|y[a+64|0]<<24);c=c?d?g:f:f;x[b+8>>2]=c;if(!(!y[a|0]|c>>>0<=d+2>>>0|c>>>0>g>>>0)){w[b+34>>1]=z[b+34>>1]|2}fb=e+32|0}function Hja(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;a:{g=fb-32|0;fb=g;a=Nb(a);b:{c:{d:{e:{while(1){e=x[b+8>>2];f=x[b>>2];x[31609]=0;e=U(150,f|0,e|0,8)|0;f=x[31609];x[31609]=0;if((f|0)==1){break c}if(e){x[31609]=0;e=g+4|0;S(909,e|0,b|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break e}x[31609]=0;O(910,a|0,e|0);f=x[31609];x[31609]=0;if((f|0)==1){break d}Hd(e);f=e;e=Er(x[a+4>>2]);ri(f,x[e>>2],x[e+4>>2]);if(x[g+4>>2]!=(d|0)){continue}}break}fb=g+32|0;break a}b=N()|0;break b}b=N()|0;Hd(g+4|0);break b}b=N()|0}ke(a);Q(b|0);p()}}function ypa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=fb-80|0;fb=d;e=Rf(d+52|0);x[31609]=0;c=P(650,b|0,e|0)|0;f=x[31609];x[31609]=0;a:{b:{c:{d:{if((f|0)!=1){if(c){break d}x[a>>2]=0;x[a+4>>2]=0;x[a+24>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;x[31609]=0;R(651,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break a}}break c}c=x[e+4>>2];x[31609]=0;S(185,d+12|0,b|0,(c>>>0>=9?c-8|0:0)|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}a=N()|0;Hd(e);Q(a|0);p()}b=d+12|0;c=hc(d+32|0,b);kd(e+8|0,c);ub(c);ub(b);Pk(a,e)}Hd(e);fb=d+80|0}function oZ(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;e=fb-16|0;fb=e;g=e+8|0;d=fb-32|0;fb=d;fd(d+24|0,a,b);h=d+16|0;b=x[d+24>>2];i=x[d+28>>2];a=fb-16|0;fb=a;x[a+8>>2]=c;x[a+12>>2]=b;while(1){if(Fd(b,i)){b=nZ(b);c=nZ(x[a+8>>2]);f=y[b+4|0]|y[b+5|0]<<8;v[c+4|0]=f;v[c+5|0]=f>>>8;b=y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24);v[c|0]=b;v[c+1|0]=b>>>8;v[c+2|0]=b>>>16;v[c+3|0]=b>>>24;b=mZ(a+12|0);mZ(a+8|0);b=x[b>>2];continue}break}rc(h,b,a+8|0);fb=a+16|0;a=x[d+16>>2];x[d+12>>2]=x[d+20>>2];rc(g,a,d+12|0);fb=d+32|0;fb=e+16|0;return x[e+12>>2]}function CQ(a,b,c){a=a|0;b=b|0;c=E(c);var d=0,e=0,f=0;_z(a);c=Pd(c,E(0));a:{switch(b|0){case 0:B[a+4220>>2]=c;return;case 1:B[a+4224>>2]=c;return;case 2:B[a+4228>>2]=c;qu(a);return;case 3:v[a+4240|0]=c>=E(.5);qu(a);return;case 4:b=fb-16|0;fb=b;e=b,f=Ml(E(c*E(32))),x[e+12>>2]=f;x[b+8>>2]=0;x[b+4>>2]=5;d=_j(b+12|0,b+8|0,b+4|0);fb=b+16|0;x[a+4232>>2]=x[d>>2];return;case 5:v[a+4241|0]=c>=E(.5);return;case 6:v[a+4242|0]=c>=E(.5);return;case 7:v[a+4244|0]=c>=E(.5);return;case 8:if(c==E(0)){Zz(a)}C[a+4256>>3]=c;break;default:break a}}}function Uka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;if(x[a+4>>2]!=x[Ab(a)>>2]){d=fb-16|0;fb=d;c=d+4|0;x[c>>2]=a;a=x[a+4>>2];x[c+4>>2]=a;x[c+8>>2]=a+7;NT(x[c+4>>2],b);x[c+4>>2]=x[c+4>>2]+7;kc(c);fb=d+16|0;return}f=fb-32|0;fb=f;g=Ab(a);h=f+12|0;e=GB(x[a>>2],x[a+4>>2])+1|0;c=fb-16|0;fb=c;x[c+12>>2]=e;a:{d=uh(613566756);if(e>>>0<=d>>>0){e=HB(a);if(e>>>0<d>>>1>>>0){x[c+8>>2]=e<<1;d=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;break a}ed();p()}c=QT(h,d,GB(x[a>>2],x[a+4>>2]),g);NT(x[c+8>>2],b);x[c+8>>2]=x[c+8>>2]+7;PT(a,c);OT(c);fb=f+32|0}function D1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;x[c+12>>2]=x[x[a+1060>>2]>>2]-x[a+1064>>2];x[c+8>>2]=16384;d=x[Hb(c+12|0,c+8|0)>>2];x[a+1072>>2]=d;x[c+4>>2]=17;while(1){a:{if(!d){break a}e=x[c+4>>2];if((e|0)>17){break a}f=1<<e-1;d=bl(a,e);b:{c:{d:{if((e|0)<=6){if((d|0)!=(f|0)){break d}Zr(c+4|0,bl(a,4));break b}if(e>>>0>16){break c}e=f-8|0;if((e|0)>(d|0)|(d|0)>(f+7|0)){break d}Zr(c+4|0,d-e|0);break b}RF(a,d,f,b);break b}e=d&(f^-1);if(d&f){x[c+4>>2]=e+1;break b}RF(a,e,0,b)}d=x[a+1072>>2];continue}break}fb=c+16|0}function Zqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=fb-80|0;fb=d;c=Rf(d+52|0);x[31609]=0;e=P(522,b|0,c|0)|0;f=x[31609];x[31609]=0;a:{b:{c:{d:{if((f|0)!=1){if(e){break d}x[a>>2]=0;x[a+4>>2]=0;x[a+24>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;x[31609]=0;R(523,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break a}}break c}e=z[c+2>>1]|z[c+4>>1]<<16;x[31609]=0;S(185,d+12|0,b|0,e|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}a=N()|0;Hd(c);Q(a|0);p()}b=d+12|0;e=hc(d+32|0,b);kd(c+8|0,e);ub(e);ub(b);QY(a,c)}Hd(c);fb=d+80|0}function Qma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=fb-16|0;fb=b;g=x[a+24>>2];h=x[a+20>>2];i=x[a+16>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;j=x[a+8>>2];k=x[a+12>>2];while(1){if(d){e=x[b+8>>2];f=x[b+12>>2]+i|0;e=e>>>21&2040;e=(((D(v[f|0],w[e+38082>>1])+D(v[f-1|0],w[e+38080>>1])|0)+D(v[f+1|0],w[e+38084>>1])|0)+D(v[f+2|0],w[e+38086>>1])<<8)/16384|0;x[c>>2]=x[c>>2]+D(e,h);x[c+4>>2]=x[c+4>>2]+D(e,g);Pb(b+8|0,j,k);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;fb=b+16|0}function HW(a){var b=0,c=0;a:{if((y[a+60|0]|y[a+61|0]<<8|(y[a+62|0]<<16|y[a+63|0]<<24))!=1297236819){break a}b=y[a+28|0]|y[a+29|0]<<8;b:{if(b>>>0<=63){if((b|0)==26){break b}break a}if(b>>>0>2112){break a}}b=y[a+42|0];if(b>>>0>64&(b|0)!=88|(y[a+48|0]|y[a+49|0]<<8)>>>0>64|(y[a+50|0]|y[a+51|0]<<8)>>>0>96){break a}b=y[a+52|0]|y[a+53|0]<<8;if(b>>>0>129&(b|0)!=257|(y[a+30|0]|y[a+31|0]<<8)|(y[a+38|0]|y[a+39|0]<<8|(y[a+40|0]<<16|y[a+41|0]<<24)|(y[a+44|0]|y[a+45|0]<<8|(y[a+46|0]<<16|y[a+47|0]<<24))!=1)){break a}c=KW(a+20|0)}return c}function C1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;x[c+12>>2]=x[x[a+1060>>2]>>2]-x[a+1064>>2];x[c+8>>2]=32768;d=x[Hb(c+12|0,c+8|0)>>2];x[a+1072>>2]=d;x[c+4>>2]=9;while(1){a:{if(!d){break a}e=x[c+4>>2];if((e|0)>9){break a}f=1<<e-1;d=bl(a,e);b:{c:{d:{if((e|0)<=6){if((d|0)!=(f|0)){break d}Zr(c+4|0,bl(a,3));break b}if(e>>>0>8){break c}e=f-4|0;if((e|0)>(d|0)|(d|0)>(f+3|0)){break d}Zr(c+4|0,d-e|0);break b}QF(a,d,f,b);break b}e=d&(f^-1);if(d&f){x[c+4>>2]=e+1;break b}QF(a,e,0,b)}d=x[a+1072>>2];continue}break}fb=c+16|0}function Lsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{e=fb-32|0;fb=e;a=Nb(a);b:{c:{d:{e:{while(1){c=x[b+8>>2];d=x[b>>2];x[31609]=0;c=U(150,d|0,c|0,8)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}if(c){x[31609]=0;c=e+4|0;O(407,c|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break e}x[31609]=0;O(408,a|0,c|0);d=x[31609];x[31609]=0;if((d|0)==1){break d}Hd(c);d=c;c=Er(x[a+4>>2]);ri(d,x[c>>2],x[c+4>>2]);if(($b(x[e+4>>2])|0)!=1162757187){continue}}break}fb=e+32|0;break a}b=N()|0;break b}b=N()|0;Hd(e+4|0);break b}b=N()|0}ke(a);Q(b|0);p()}}function hP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=fb-32|0;fb=d;g=Nb(a);a=0;a:{b:{c:{d:{e:{while(1){c=x[b+24>>2];if(z[c+480188>>1]<=a>>>0){break a}x[31609]=0;f=d+8|0;O(1052,f|0,(c+(a<<5)|0)+480289|0);c=x[31609];x[31609]=0;if((c|0)!=1){e=x[b+24>>2];x[31609]=0;c=d+20|0;S(1053,c|0,e|0,f|0);e=x[31609];x[31609]=0;if((e|0)==1){break e}x[31609]=0;O(178,g|0,c|0);e=x[31609];x[31609]=0;if((e|0)==1){break d}a=a+1|0;tb(c);tb(f);continue}break}a=N()|0;break b}a=N()|0;break c}a=N()|0;tb(d+20|0)}tb(d+8|0)}Td(g);Q(a|0);p()}fb=d+32|0}function X9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=fb-16|0;fb=e;fd(e+8|0,b,c);c=x[e+8>>2];f=x[e+12>>2];b=fb-48|0;fb=b;x[b+44>>2]=d;x[b+40>>2]=d;a=Ag(b+12|0,a,b+40|0,b+44|0);x[b+8>>2]=x[a+8>>2];g=x[a+4>>2];x[b>>2]=x[a>>2];x[b+4>>2]=g;zg(b+24|0,b);a:{while(1){if((c|0)==(f|0)){break a}x[31609]=0;O(1208,x[b+44>>2],c|0);a=x[31609];x[31609]=0;if((a|0)!=1){x[b+44>>2]=x[b+44>>2]+12;c=c+12|0;continue}break}a=N()|0;fM(b+24|0);Q(a|0);p()}a=b+24|0;yg(a);c=x[b+44>>2];fM(a);fb=b+48|0;fb=e+16|0;return D((c-d|0)/12|0,12)+d|0}function Ita(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;nd(b,0);g=y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24);x[b>>2]=g;e=y[a+4|0]|y[a+5|0]<<8|(y[a+6|0]<<16|y[a+7|0]<<24);x[b+12>>2]=e;f=y[a+8|0]|y[a+9|0]<<8|(y[a+10|0]<<16|y[a+11|0]<<24);x[b+16>>2]=f;c=y[a+12|0]|y[a+13|0]<<8;w[b+32>>1]=64;x[b+24>>2]=c;c=y[a+14|0];w[b+30>>1]=c?c+1|0:256;d=z[b+34>>1]&32767|!y[a+14|0]<<15;w[b+34>>1]=d;c=y[a+15|0];if(!(!(c&1)|e>>>0>=f>>>0)){d=d|8;w[b+34>>1]=d;c=y[a+15|0]}if(c&2){x[b+16>>2]=f>>>1;x[b+12>>2]=e>>>1;x[b>>2]=g>>>1;w[b+34>>1]=d|1}}function Vc(a){var b=0,c=0,d=0;d=fb-16|0;fb=d;b=d+4|0;x[b+4>>2]=1245;x[b>>2]=a;x[b+8>>2]=0;c=fb-16|0;fb=c;if(x[a>>2]!=-1){a:{b=vb(c+8|0,yf(c+12|0,b));while(1){if(x[a>>2]==1){continue}break}b:{if(!x[a>>2]){yd(a,1);b=x[x[b>>2]>>2];x[31609]=0;W(1246,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break b}x[a>>2]=-1}break a}Y(T(0)|0)|0;yd(a,0);x[31609]=0;X(84);a=x[31609];x[31609]=0;c:{if((a|0)==1){a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){break c}T(0)|0;Sb()}p()}Q(a|0);p()}}fb=c+16|0;fb=d+16|0;return x[a+4>>2]-1|0}function sN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=fb-16|0;fb=d;a:{b:{c:{a=x[a+32>>2];e=pq(a);d:{if(!e){if(oq(a)>>>0<=b>>>0){break d}a=oi(a,b+1&65535);w[a+34>>1]=z[a+34>>1]&64511|(c?1024:0);break b}if(b>>>0<e>>>0){break c}}a=ac(8);x[31609]=0;b=P(36,d+4|0,6e3)|0;c=x[31609];x[31609]=0;e:{if((c|0)!=1){pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}c=N()|0;tb(b);break e}c=N()|0;ic(a)}Q(c|0);p()}a=x[(a+(b<<2)|0)+900384>>2];if(!a){break b}v[a+15|0]=y[a+15|0]&253|(c?2:0)}fb=d+16|0;return}p()}function fj(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=fb-16|0;fb=e;o(+b);g=j(1)|0;c=j(0)|0;d=g&2147483647;f=d+-1048576|0;a:{if((f|0)==2145386495|f>>>0<2145386495){h=c<<28;c=(d&15)<<28|c>>>4;d=(d>>>4|0)+1006632960|0;break a}if((d|0)==2146435072|d>>>0>2146435072){h=c<<28;c=(g&15)<<28|c>>>4;d=g>>>4|2147418112;break a}if(!(c|d)){c=0;d=0;break a}f=c;c=d?G(d):G(c)+32|0;$f(e,f,d,0,0,c+49|0);i=x[e>>2];h=x[e+4>>2];f=15372-c<<16;c=x[e+8>>2];d=f|x[e+12>>2]^65536}x[a>>2]=i;x[a+4>>2]=h;x[a+8>>2]=c;x[a+12>>2]=g&-2147483648|d;fb=e+16|0}function rF(a){var b=0,c=0,d=0,e=0,f=0;a:{b=y[a|0]|y[a+1|0]<<8;b:{if((b|0)!=26217){if((b|0)!=20042){break a}if(y[a+110|0]<=64){break b}break a}if(y[a+110|0]>64){break a}}if(v[a+112|0]<0|y[a+111|0]>128){break a}b=2;while(1){if((b|0)==110){b=0;while(1){d=(b|0)==128;if(d){break a}c=a+b|0;e=v[c+113|0];if((e|0)<-2){break a}f=y[c+241|0];if(!f&(e|0)>=0|f>>>0>15){break a}b=b+1|0;if(y[c+369|0]<64){continue}break}break a}e=(y[a+b|0]-32&255)>>>0<225;c=d+1|0;if(e|(c&255)>>>0<=40){d=e?d:c;b=b+1|0;continue}else{return 0}}}return d}function FH(a,b,c,d,e,f){var g=0,h=0,i=0;g=fb-256|0;fb=g;v[g+252|0]=0;v[g+253|0]=0;v[g+254|0]=0;v[g+255|0]=0;v[g+249|0]=0;v[g+250|0]=0;v[g+251|0]=0;v[g+252|0]=0;v[g+248|0]=37;rt(g+249|0,10632,f,x[b+4>>2]);f=Od();x[g>>2]=d;x[g+4>>2]=e;d=g+224|0;e=ph(d,24,f,g+248|0,g)+d|0;h=lj(d,e,x[b+4>>2]);f=g+20|0;cd(f,x[b+28>>2]);x[31609]=0;i=d;d=g+32|0;ga(1269,i|0,h|0,e|0,d|0,g+28|0,g+24|0,f|0);e=x[31609];x[31609]=0;a:{if((e|0)!=1){_b(f);a=ot(a,d,x[g+28>>2],x[g+24>>2],b,c);fb=g+256|0;break a}a=N()|0;_b(g+20|0);Q(a|0);p()}return a}function HH(a,b,c,d,e,f){var g=0,h=0,i=0;g=fb-112|0;fb=g;v[g+108|0]=0;v[g+109|0]=0;v[g+110|0]=0;v[g+111|0]=0;v[g+105|0]=0;v[g+106|0]=0;v[g+107|0]=0;v[g+108|0]=0;v[g+104|0]=37;rt(g+105|0,10632,f,x[b+4>>2]);f=Od();x[g>>2]=d;x[g+4>>2]=e;d=g+80|0;e=ph(d,24,f,g+104|0,g)+d|0;h=lj(d,e,x[b+4>>2]);f=g+20|0;cd(f,x[b+28>>2]);x[31609]=0;i=d;d=g+32|0;ga(1265,i|0,h|0,e|0,d|0,g+28|0,g+24|0,f|0);e=x[31609];x[31609]=0;a:{if((e|0)!=1){_b(f);a=tw(a,d,x[g+28>>2],x[g+24>>2],b,c);fb=g+112|0;break a}a=N()|0;_b(g+20|0);Q(a|0);p()}return a}function kpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{e=fb-32|0;fb=e;a=Nb(a);b:{c:{d:{e:{while(1){c=x[b+8>>2];d=x[b>>2];x[31609]=0;c=U(150,d|0,c|0,8)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}if(c){x[31609]=0;c=e+4|0;O(681,c|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break e}x[31609]=0;O(682,a|0,c|0);d=x[31609];x[31609]=0;if((d|0)==1){break d}Hd(c);d=c;c=Er(x[a+4>>2]);ri(d,x[c>>2],x[c+4>>2]);if(x[e+4>>2]!=1413891155){continue}}break}fb=e+32|0;break a}b=N()|0;break b}b=N()|0;Hd(e+4|0);break b}b=N()|0}ke(a);Q(b|0);p()}}function iga(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;v[a+4202|0]=1;c=Ck(E(E(A[x[a+16>>2]+24620>>2])*E(.04500000178813934)));d=Ck(E(E(c>>>0)*E(1.1892070770263672)));e=Ck(E(E(d>>>0)*E(1.1892070770263672)));h=Ck(E(E(e>>>0)*E(1.1892070770263672)));f=Ck(E(E(c+e>>>0)*E(.11546666920185089)));g=Ck(E(E(d+h>>>0)*E(.11546666920185089)));b=a+4272|0;i=yb(b,0),j=c-f|0,x[i>>2]=j;i=yb(b,1),j=e-f|0,x[i>>2]=j;i=yb(b,2),j=d-g|0,x[i>>2]=j;i=yb(b,3),j=h-g|0,x[i>>2]=j;i=yb(b,4),j=f,x[i>>2]=j;i=yb(b,5),j=g,x[i>>2]=j;RP(a);QP(a)}function $pa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=fb-608|0;fb=b;c=fb-16|0;fb=c;d=b+8|0;YX(c+8|0,d);e=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);f=x[c+4>>2];if((f|0)==(e|0)){id(a,x[c+12>>2])}fb=c+16|0;e=(e|0)==(f|0);if(!e){XX(d)}c=-1;a:{if(!e){break a}c=0;if(!_X(d)){break a}c=-1;if(!jh(a,1024)){break a}c=0;e=fb-1024|0;fb=e;d=fb-16|0;fb=d;SC(d+8|0,e);f=x[d+12>>2];qd(d,a,x[d+8>>2],x[d+12>>2]);g=x[d+4>>2];if((f|0)==(g|0)){id(a,x[d+12>>2])}fb=d+16|0;if((f|0)==(g|0)){c=TC(e,0)>>>0<17}fb=e+1024|0}fb=b+608|0;return c|0}function zB(a,b){var c=0;if(b>>>0<=999999){if(b>>>0<=9999){if(b>>>0<=99){if(b>>>0<=9){return Hq(a,b)}return Jl(a,b)}if(b>>>0<=999){c=a;a=(b>>>0)/100|0;return Jl(Hq(c,a),D(a,-100)+b|0)}return vB(a,b)}if(b>>>0<=99999){c=a;a=(b>>>0)/1e4|0;return vB(Hq(c,a),D(a,-1e4)+b|0)}return sB(a,b)}if(b>>>0<=99999999){if(b>>>0<=9999999){c=a;a=(b>>>0)/1e6|0;return sB(Hq(c,a),D(a,-1e6)+b|0)}return Qu(a,b)}if(b>>>0<=999999999){c=a;a=(b>>>0)/1e8|0;return Qu(Hq(c,a),D(a,-1e8)+b|0)}c=a;a=(b>>>0)/1e8|0;return Qu(Jl(c,a),D(a,-1e8)+b|0)}function apa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=fb-80|0;fb=c;d=Rf(c+52|0);x[31609]=0;e=P(687,b|0,d|0)|0;f=x[31609];x[31609]=0;a:{b:{c:{d:{if((f|0)!=1){if(e){break d}x[a>>2]=0;x[a+4>>2]=0;x[a+24>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;x[31609]=0;R(688,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break a}}break c}e=x[d+4>>2];x[31609]=0;S(185,c+12|0,b|0,e|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}a=N()|0;Hd(d);Q(a|0);p()}b=c+12|0;e=hc(c+32|0,b);kd(d+8|0,e);ub(e);ub(b);Pk(a,d)}Hd(d);fb=c+80|0}function Cta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=fb-32|0;fb=c;nd(b,0);e=c+8|0;ek(e,1,a);d=c+20|0;Cc(d,e);Be(b+43|0,d);tb(d);x[b+24>>2]=y[a+32|0]|y[a+33|0]<<8|(y[a+34|0]<<16|y[a+35|0]<<24);w[b+34>>1]=z[b+34>>1]&65533|(y[a+13|0]|y[a+14|0]<<8)<<1&2;x[b>>2]=y[a+16|0]|y[a+17|0]<<8|(y[a+18|0]<<16|y[a+19|0]<<24);x[b+4>>2]=y[a+20|0]|y[a+21|0]<<8|(y[a+22|0]<<16|y[a+23|0]<<24);x[b+8>>2]=y[a+24|0]|y[a+25|0]<<8|(y[a+26|0]<<16|y[a+27|0]<<24);v[c+20|0]=y[a+15|0];v[c+8|0]=64;f=b,g=y[Qb(d,e)|0]<<2,w[f+30>>1]=g;fb=c+32|0}function isa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=fb-32|0;fb=e;d=qf(e+20|0,1,0);a:{b:{while(1){f=Kb(d);jC(e+12|0,f,Cb(x[d+4>>2],y[d+11|0])+f|0,z[b>>1],c);if(!x[e+16>>2]){break b}f=mi(Cb(x[d+4>>2],y[d+11|0]));x[31609]=0;O(45,d|0,f|0);f=x[31609];x[31609]=0;if((f|0)!=1){continue}break}break a}b=x[e+12>>2];c=Kb(d);x[31609]=0;O(46,d|0,b-c|0);b=x[31609];x[31609]=0;c:{if((b|0)!=1){x[31609]=0;O(47,a|0,d|0);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break a}break a}tb(d);fb=e+32|0;return}a=N()|0;tb(d);Q(a|0);p()}function IS(a,b,c){var d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;a:{if(b){v[c|0]=b;break a}b=y[c|0]}c=b&240;e=x[a+480180>>2];b=e&1048580?c?c:b:b;c=b&15;b=b&255;b:{c:{d:{if(!((c|0)!=15|b>>>0<16)){if(!(y[a+480209|0]&16)){break b}b=b>>>3&30;break d}f=x[a+480208>>2]&4096;g=b&240;if(!(!c|(g|0)!=240)){if(!f){break b}b=0-(c<<1)|0;break c}if(f){break b}if(g){if(e&59314208?c:0){break b}b=b>>>3&30;break d}b=0-(b<<1)|0}if(!b){break b}}a=a+1074456|0;x[d+12>>2]=x[a>>2]+(b<<!(e&59314208));He(d+12|0,0,256);x[a>>2]=x[d+12>>2]}fb=d+16|0}function k6(a){a=a|0;if(y[499920]){return x[124979]}if(!y[500720]){v[500720]=1}ld(500432,5034);ld(500444,5025);ld(500456,10891);ld(500468,10635);ld(500480,5261);ld(500492,11668);ld(500504,5118);ld(500516,5609);ld(500528,8902);ld(500540,8885);ld(500552,8893);ld(500564,8912);ld(500576,10089);ld(500588,13330);ld(500600,8975);ld(500612,7714);ld(500624,5261);ld(500636,9778);ld(500648,10494);ld(500660,10903);ld(500672,9265);ld(500684,6463);ld(500696,5492);ld(500708,13248);v[499920]=1;x[124979]=500432;return 500432}function P9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=fb-32|0;fb=e;d=qf(e+20|0,1,0);a:{b:{while(1){f=Kb(d);JN(e+12|0,f,Cb(x[d+4>>2],y[d+11|0])+f|0,y[b|0],c);if(!x[e+16>>2]){break b}f=mi(Cb(x[d+4>>2],y[d+11|0]));x[31609]=0;O(45,d|0,f|0);f=x[31609];x[31609]=0;if((f|0)!=1){continue}break}break a}b=x[e+12>>2];c=Kb(d);x[31609]=0;O(46,d|0,b-c|0);b=x[31609];x[31609]=0;c:{if((b|0)!=1){x[31609]=0;O(303,a|0,d|0);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break a}break a}tb(d);fb=e+32|0;return}a=N()|0;tb(d);Q(a|0);p()}function n1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=fb-16|0;fb=b;c=-1;d=b+12|0;a:{if(!fF(a,d)){break a}b:{if(eF(d)){if(id(a,32)){break b}break a}c=0;if(!dF(b+12|0)){break a}}e=b+7|0;d=cF(y[b+15|0]);c=fb-32|0;fb=c;x[c+28>>2]=d;x[c+8>>2]=5;d=x[Hb(c+28|0,c+8|0)>>2];if(!jh(a,d)){d=(ib[x[x[a>>2]+24>>2]](a)|0)-x[a+12>>2]|0}f=c+8|0;$j(f,e);g=Zb(c+16|0,x[c+8>>2],d);qd(c,a,x[g>>2],x[g+4>>2]);$j(f,e);Rb(x[c+8>>2]+d|0,0,5-d|0);id(a,x[c+28>>2]);fb=c+32|0;if(!d){c=-1;break a}c=bF(b+7|0,y[b+15|0])}fb=b+16|0;return c|0}function eV(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=b?33:32;c=y[a+16|0];l=c?-1:1;m=c?1:-1;e=x[a+8>>2]-1|0;n=c?e-(y[a+17|0]!=0&(e|0)!=0)|0:0;f=x[a+12>>2];o=(f|0)>0?f:0;p=c?0:e;h=x[a>>2]+D(f,62)|0;d=b?1:-1;q=D(f,d)<<1;c=e;a:while(1){if((i|0)!=(k|0)){g=x[a+4>>2]+(D(c,f)<<1)|0;b=0;while(1)if((b|0)==(o|0)){b:{if((c|0)==(e|0)){b=n;g=l;if((d|0)>0){break b}}b=c+d|0;c=!c&(d|0)<0;b=c?p:b;g=c?m:d}h=h+q|0;i=i+1|0;c=b;d=g;continue a}else{j=b<<1;w[j+h>>1]=z[g+j>>1];b=b+1|0;continue}}break}}function H3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;if(lh(a,x[b+8>>2],e)){Vx(b,c,d);return}a:{if(lh(a,x[b>>2],e)){if(!(x[b+16>>2]!=(c|0)&x[b+20>>2]!=(c|0))){if((d|0)!=1){break a}x[b+32>>2]=1;return}x[b+32>>2]=d;b:{if(x[b+44>>2]==4){break b}w[b+52>>1]=0;a=x[a+8>>2];ib[x[x[a>>2]+20>>2]](a,b,c,c,1,e);if(y[b+53|0]){x[b+44>>2]=3;if(!y[b+52|0]){break b}break a}x[b+44>>2]=4}x[b+20>>2]=c;x[b+40>>2]=x[b+40>>2]+1;if(x[b+36>>2]!=1|x[b+24>>2]!=2){break a}v[b+54|0]=1;return}a=x[a+8>>2];ib[x[x[a>>2]+24>>2]](a,b,c,d,e)}}function IK(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;a:{b:{if((a|0)!=(b|0)){c:{h=x[31484];x[31484]=0;Od();f=HK(a,e+12|0,d);a=f;d=hb;d:{g=x[31484];if(g){if(x[e+12>>2]!=(b|0)){break c}if((g|0)!=68){break d}x[c>>2]=4;a=2147483647;if(!!f&(d|0)>=0|(d|0)>0){break a}break b}x[31484]=h;if(x[e+12>>2]==(b|0)){break d}break c}if((d|0)<0&a>>>0<=2147483647|(d|0)<-1){x[c>>2]=4;break b}if((d|0)>=0&a>>>0>=2147483648|(d|0)>0){x[c>>2]=4;a=2147483647;break a}break a}}x[c>>2]=4;a=0;break a}a=-2147483648}fb=e+16|0;return a}function Vv(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=fb-16|0;fb=g;x[g+12>>2]=0;x[g+8>>2]=a;h=fb-16|0;fb=h;c=Zb(h+8|0,x[g+8>>2],x[g+12>>2]);f=fb-16|0;fb=f;b=122;x[f+12>>2]=122;d=x[c+4>>2];a:{if(!d){d=x[c>>2];break a}e=32-d|0;x[f+8>>2]=e;b=x[c>>2];i=x[b>>2];j=e;e=x[Hb(f+8|0,f+12|0)>>2];x[b>>2]=(-1<<d&-1>>>j-e^-1)&i;i=x[f+12>>2];d=b+4|0;x[c>>2]=d;b=i-e|0}e=d;d=b>>>5|0;JF(e,d);b=b&31;x[f+12>>2]=b;if(b){e=c;c=x[c>>2]+(d<<2)|0;x[e>>2]=c;x[c>>2]=x[c>>2]&(-1>>>32-b^-1)}fb=f+16|0;fb=h+16|0;fb=g+16|0;return a}function qH(a,b,c,d){var e=0,f=0,g=0;e=fb-80|0;fb=e;f=Rf(e+52|0);x[31609]=0;d=P(d|0,b|0,f|0)|0;g=x[31609];x[31609]=0;a:{b:{c:{d:{if((g|0)!=1){if(d){break d}x[a>>2]=0;x[a+4>>2]=0;x[a+24>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;x[31609]=0;R(c|0,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break a}}break c}c=x[f+4>>2];x[31609]=0;S(185,e+12|0,b|0,$b(c)|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}a=N()|0;Hd(f);Q(a|0);p()}b=e+12|0;c=hc(e+32|0,b);kd(f+8|0,c);ub(c);ub(b);Pk(a,f)}Hd(f);fb=e+80|0}function cI(a,b,c,d,e){var f=0,g=0,h=0,i=0;g=fb-16|0;fb=g;h=Fb(a);a=0;a:{b:{c:{d:{while(1){f=x[b>>2];if(Ud(f,x[b+4>>2])>>>0<=a>>>0){break c}e:{if(!a){f=Vd(f,0);break e}x[31609]=0;P(d|0,h|0,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break b}f=Vd(x[b>>2],a)}x[31609]=0;i=g+4|0;O(e|0,i|0,f|0);f=x[31609];x[31609]=0;if((f|0)!=1){x[31609]=0;P(d|0,h|0,i|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break d}a=a+1|0;tb(i);continue}break}a=N()|0;break a}a=N()|0;tb(g+4|0);break a}fb=g+16|0;return}a=N()|0}tb(h);Q(a|0);p()}function VO(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;b=fb-16|0;fb=b;a:{c=x[a+36>>2];d=x[a+40>>2];b:{if(Ib(c,d)){tc(b+12|0);break b}vo(b,a);x[31609]=0;c=R(1056,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}x[b+12>>2]=c;nf(b);d=x[a+40>>2];c=x[a+36>>2]}c=(f=a+36|0,g=x[b+12>>2],h=Ib(c,d),h?f:g);a=x[a+8>>2];c:{if((a|0)==-1){a=wb(x[c>>2]);x[b>>2]=a;c=wb(x[c+4>>2]);while(1){if(!Ib(a,c)){break c}e=e+C[a>>3];a=x[fA(b)>>2];continue}}e=C[wf(x[c>>2],a)>>3]}yl(b+12|0);fb=b+16|0;return+e}a=N()|0;nf(b);Q(a|0);p()}function Mpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;cc(c+8|0,b,26);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;if((d|0)!=(e|0)){v[b|0]=0;v[b+1|0]=0;v[b+2|0]=0;v[b+3|0]=0;v[b+4|0]=0;v[b+5|0]=0;v[b+6|0]=0;v[b+7|0]=0;v[b+24|0]=0;v[b+25|0]=0;v[b+16|0]=0;v[b+17|0]=0;v[b+18|0]=0;v[b+19|0]=0;v[b+20|0]=0;v[b+21|0]=0;v[b+22|0]=0;v[b+23|0]=0;v[b+8|0]=0;v[b+9|0]=0;v[b+10|0]=0;v[b+11|0]=0;v[b+12|0]=0;v[b+13|0]=0;v[b+14|0]=0;v[b+15|0]=0}}function GH(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=fb-144|0;fb=f;v[f+140|0]=0;v[f+141|0]=0;v[f+142|0]=0;v[f+143|0]=0;v[f+137|0]=0;v[f+138|0]=0;v[f+139|0]=0;v[f+140|0]=0;v[f+136|0]=37;rt(f+137|0,10799,e,x[b+4>>2]);e=Od();x[f>>2]=d;d=f+123|0;e=ph(d,13,e,f+136|0,f)+d|0;h=lj(d,e,x[b+4>>2]);g=f+4|0;cd(g,x[b+28>>2]);x[31609]=0;i=d;d=f+16|0;ga(1269,i|0,h|0,e|0,d|0,f+12|0,f+8|0,g|0);e=x[31609];x[31609]=0;a:{if((e|0)!=1){_b(g);a=ot(a,d,x[f+12>>2],x[f+8>>2],b,c);fb=f+144|0;break a}a=N()|0;_b(f+4|0);Q(a|0);p()}return a}function _m(a,b,c,d){var e=0;a:{e=a+1074312|0;if(Ob(e,84)){break a}b:{if(y[a+480209|0]&64){break b}if((d|0)!=8){if(!Ob(e,10)){break b}}x[b+88>>2]=x[b+88>>2]&-257}c:{d:{e:{switch(d-4|0){case 0:c=((c<<8|8)>>>0)/15|0;break d;case 2:c=(c>>>0>=64?64:c)<<2;break d;default:break e}}if(!(x[a+480180>>2]&2107410)){break d}if(c>>>0<=128){c=c<<1;break d}if((c|0)!=164){break c}x[b+88>>2]=x[b+88>>2]|256;c=128}x[b+692>>2]=c}w[b+784>>1]=0;x[b+88>>2]=x[b+88>>2]|2097152;if(!Ob(e,10)){break a}v[b+831|0]=0;w[b+778>>1]=0}}function IW(a,b,c,d,e,f){b=y[(b&15)+25408|0];v[a+3|0]=b;a:{b:{switch(b-11|0){case 0:b=y[a+5|0]&15;if(!b){break a}v[a+5|0]=b;return;case 3:b=y[a+5|0];b=D(b&240,10)|b&15;v[a+5|0]=b;d=b&255;b=z[e>>1];if(!(d|(b|0)==65535)){v[a+5|0]=b;v[a+3|0]=12;w[e>>1]=65535}xc(f,c);return;case 1:w[e>>1]=y[a+5|0];x[f>>2]=63;v[a+3|0]=0;return;case 5:b=y[a+5|0];if(d>>>0<=20){c=((b&255)>>>0)/10|0;b=c<<4|D(c,-10)+b;v[a+5|0]=b}if(b&255){break a}v[a+3|0]=0;return;case 7:break a;default:break b}}if(y[a+5|0]){break a}v[a+3|0]=0}}function rra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(x[a+4>>2]!=x[Ab(a)>>2]){c=fb-16|0;fb=c;a=Cx(c+4|0,a);d=x[a+4>>2];x[31609]=0;O(501,d|0,b|0);b=x[31609];x[31609]=0;a:{if((b|0)!=1){x[a+4>>2]=x[a+4>>2]+12;kc(a);fb=c+16|0;break a}b=N()|0;kc(a);Q(b|0);p()}return}d=fb-32|0;fb=d;c=Ab(a);c=zm(d+12|0,Pp(a,Ud(x[a>>2],x[a+4>>2])+1|0),Ud(x[a>>2],x[a+4>>2]),c);e=x[c+8>>2];x[31609]=0;O(501,e|0,b|0);b=x[31609];x[31609]=0;b:{if((b|0)!=1){x[c+8>>2]=x[c+8>>2]+12;Bx(a,c);us(c);fb=d+32|0;break b}a=N()|0;us(c);Q(a|0);p()}}function qba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=fb-16|0;fb=e;fd(e+8|0,b,c);c=x[e+8>>2];f=x[e+12>>2];b=fb-48|0;fb=b;x[b+44>>2]=d;x[b+40>>2]=d;a=Ag(b+12|0,a,b+40|0,b+44|0);x[b+8>>2]=x[a+8>>2];d=x[a+4>>2];x[b>>2]=x[a>>2];x[b+4>>2]=d;zg(b+24|0,b);a:{while(1){if((c|0)==(f|0)){break a}x[31609]=0;O(1124,x[b+44>>2],c|0);a=x[31609];x[31609]=0;if((a|0)!=1){x[b+44>>2]=x[b+44>>2]+16;c=c+16|0;continue}break}a=N()|0;fN(b+24|0);Q(a|0);p()}a=b+24|0;yg(a);c=x[b+44>>2];fN(a);fb=b+48|0;fb=e+16|0;return c|0}function J4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=b&512;f=b&256;g=b&128;h=b&64;i=b&32;j=b&16;k=b&8;l=b&4;m=b&2;b=b&1;a:{while(1){if((c|0)==(d|0)){break a}a=x[c>>2];b:{c:{if(b){if(Ws(a)){break c}}if(m){if(Vs(a)){break c}}if(l){if(Us(a)){break c}}if(k){if(Ts(a)){break c}}if(j){if(Ss(a)){break c}}if(i){if(Rs(a)){break c}}if(h){if(Nh(a)){break c}}if(g){if(Qs(a)){break c}}if(f){if(Ps(a)){break c}}if(!e){break b}if(!Os(a)){break b}}c=c+4|0;continue}break}d=c}return d|0}function rea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=E(0);x[31609]=0;W(996,a|0);d=x[31609];x[31609]=0;a:{if((d|0)==1){break a}x[31609]=0;W(1068,c|0);d=x[31609];x[31609]=0;if((d|0)==1){break a}d=x[a+24>>2];e=B[d+48>>2];d=x[d+24>>2];x[31609]=0;b=Ya(1069,d|0,E(e),b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}x[c>>2]=b;return 1}Y(T(0)|0)|0;x[31609]=0;V(983,10369,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function epa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=fb-32|0;fb=e;nd(b,0);d=e+8|0;RD(d,a+1|0);c=e+20|0;Cc(c,d);Be(b+43|0,c);tb(c);x[b+24>>2]=y[a+73|0]|y[a+74|0]<<8|(y[a+75|0]<<16|y[a+76|0]<<24);c=y[a+54|0]|y[a+55|0]<<8|(y[a+56|0]<<16|y[a+57|0]<<24);x[b>>2]=c;x[b+4>>2]=y[a+58|0]|y[a+59|0]<<8|(y[a+60|0]<<16|y[a+61|0]<<24);d=y[a+62|0]|y[a+63|0]<<8|(y[a+64|0]<<16|y[a+65|0]<<24);if(d){x[b+8>>2]=d+1}w[b+30>>1]=(y[a+68|0]<<1)+2;w[b+34>>1]=z[b+34>>1]&65533|y[a|0]>>>6&2;xc(b+8|0,c);xc(b+4|0,x[b+8>>2]);fb=e+32|0}function cn(a,b,c,d,e,f){var g=0,h=0,i=0,j=0;a:{if(f&64){c=f+-64|0;b=c&31;if((c&63)>>>0>=32){c=0;b=e>>>b|0}else{c=e>>>b|0;b=((1<<b)-1&e)<<32-b|d>>>b}d=0;e=0;break a}if(!f){break a}i=d;h=64-f|0;g=h&31;if((h&63)>>>0>=32){h=d<<g;j=0}else{h=(1<<g)-1&i>>>32-g|e<<g;j=i<<g}i=b;b=f&31;if((f&63)>>>0>=32){g=0;b=c>>>b|0}else{g=c>>>b|0;b=((1<<b)-1&c)<<32-b|i>>>b}b=j|b;c=g|h;g=d;d=f&31;if((f&63)>>>0>=32){h=0;d=e>>>d|0}else{h=e>>>d|0;d=((1<<d)-1&e)<<32-d|g>>>d}e=h}x[a>>2]=b;x[a+4>>2]=c;x[a+8>>2]=d;x[a+12>>2]=e}function jH(a,b,c,d){var e=0,f=0,g=0;f=fb-32|0;fb=f;e=qf(f+20|0,1,0);a:{b:{while(1){g=Kb(e);jC(f+12|0,g,Cb(x[e+4>>2],y[e+11|0])+g|0,x[b>>2],c);if(!x[f+16>>2]){break b}g=mi(Cb(x[e+4>>2],y[e+11|0]));x[31609]=0;O(45,e|0,g|0);g=x[31609];x[31609]=0;if((g|0)!=1){continue}break}break a}b=x[f+12>>2];c=Kb(e);x[31609]=0;O(46,e|0,b-c|0);b=x[31609];x[31609]=0;c:{if((b|0)!=1){x[31609]=0;O(d|0,a|0,e|0);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break a}break a}tb(e);fb=f+32|0;return}a=N()|0;tb(e);Q(a|0);p()}function aH(a,b,c,d){var e=0,f=0,g=0;f=fb-32|0;fb=f;e=qf(f+20|0,1,0);a:{b:{while(1){g=Kb(e);JN(f+12|0,g,Cb(x[e+4>>2],y[e+11|0])+g|0,x[b>>2],c);if(!x[f+16>>2]){break b}g=mi(Cb(x[e+4>>2],y[e+11|0]));x[31609]=0;O(45,e|0,g|0);g=x[31609];x[31609]=0;if((g|0)!=1){continue}break}break a}b=x[f+12>>2];c=Kb(e);x[31609]=0;O(46,e|0,b-c|0);b=x[31609];x[31609]=0;c:{if((b|0)!=1){x[31609]=0;O(d|0,a|0,e|0);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break a}break a}tb(e);fb=f+32|0;return}a=N()|0;tb(e);Q(a|0);p()}function uH(a,b,c,d){var e=0,f=0,g=0;f=fb-32|0;fb=f;e=qf(f+20|0,1,0);a:{b:{while(1){g=Kb(e);jC(f+12|0,g,Cb(x[e+4>>2],y[e+11|0])+g|0,y[b|0],c);if(!x[f+16>>2]){break b}g=mi(Cb(x[e+4>>2],y[e+11|0]));x[31609]=0;O(45,e|0,g|0);g=x[31609];x[31609]=0;if((g|0)!=1){continue}break}break a}b=x[f+12>>2];c=Kb(e);x[31609]=0;O(46,e|0,b-c|0);b=x[31609];x[31609]=0;c:{if((b|0)!=1){x[31609]=0;O(d|0,a|0,e|0);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break a}break a}tb(e);fb=f+32|0;return}a=N()|0;tb(e);Q(a|0);p()}function aga(a){a=a|0;var b=0,c=0,d=0;b=fb-32|0;fb=b;a:{b:{if(!a){a=Cg(22292);break b}x[31609]=0;c=P(36,b+8|0,a|0)|0;a=x[31609];x[31609]=0;c:{d:{if((a|0)!=1){x[31609]=0;d=b+20|0;O(982,d|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break d}a=Cg(Kb(d));tb(d);tb(c);break b}a=T(0)|0;break c}a=T(0)|0;tb(c)}Y(a|0)|0;a=0;x[31609]=0;V(983,11031,0,0,0);c=x[31609];x[31609]=0;if((c|0)==1){break a}Z()}fb=b+32|0;return a|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Hs(a,b,c,d,e,f){var g=0,h=0,i=0;g=fb-16|0;fb=g;a=kO(a);x[a+8>>2]=0;x[a>>2]=47628;x[31609]=0;i=R(852,104)|0;h=x[31609];x[31609]=0;a:{b:{c:{d:{if((h|0)!=1){x[31609]=0;d=R(1099,d|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break d}x[g+8>>2]=d;d=g+8|0;h=x[re(g+12|0,d)>>2];x[31609]=0;b=ha(f|0,i|0,b|0,c|0,h|0,e|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}x[a+8>>2]=b;Wc(d);b=x[a+8>>2];Bd(a,b?b+8|0:0);fb=g+16|0;return a}b=N()|0;break a}b=N()|0;break b}b=N()|0;Wc(g+8|0)}Db(i)}Qm(a);Q(b|0);p()}function XF(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;f=x[b+16>>2];x[a+4>>2]=0;x[a>>2]=f;a:{if(!f){break a}c=b+80|0;d=x[b+84>>2];if(d>>>0<=15){d=x[c>>2]}else{x[e+12>>2]=d-16;d=x[bd(c,e+12|0)>>2]}x[a+8>>2]=d;c=x[b+88>>2];if(!(c&2)){break a}d=c;c=x[b+104>>2];b:{c:{if(!VF(d,c)){d=x[b+84>>2];break c}d=x[b+84>>2];if(x[b+80>>2]!=x[c+12>>2]){break c}b=1;if(x[c+16>>2]==(d|0)){break b}}b=0;if(x[c+8>>2]!=(d|0)){break a}}g=a,h=D((x[c>>2]-d|0)+(b?112:48)|0,_k(z[c+34>>1]))+f|0,x[g+4>>2]=h}fb=e+16|0}function IH(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=fb+-64|0;fb=f;v[f+60|0]=0;v[f+61|0]=0;v[f+62|0]=0;v[f+63|0]=0;v[f+57|0]=0;v[f+58|0]=0;v[f+59|0]=0;v[f+60|0]=0;v[f+56|0]=37;rt(f+57|0,10799,e,x[b+4>>2]);e=Od();x[f>>2]=d;d=f+43|0;e=ph(d,13,e,f+56|0,f)+d|0;h=lj(d,e,x[b+4>>2]);g=f+4|0;cd(g,x[b+28>>2]);x[31609]=0;i=d;d=f+16|0;ga(1265,i|0,h|0,e|0,d|0,f+12|0,f+8|0,g|0);e=x[31609];x[31609]=0;a:{if((e|0)!=1){_b(g);a=tw(a,d,x[f+12>>2],x[f+8>>2],b,c);fb=f- -64|0;break a}a=N()|0;_b(f+4|0);Q(a|0);p()}return a}function Oo(a){var b=0,c=0,d=0,e=0;d=z[x[a+4>>2]+28>>1]>>>(!y[a+77|0]<<1)|0;b=((d&3)<<4)+26192|0;x[a+40>>2]=b;e=z[a+24>>1];d=d>>>2|0;c=e+d|0;w[a+36>>1]=c>>>0<12?1:1<<c-12;c=12-c|0;c=c>>>0<=12?c:0;w[a+32>>1]=c;w[a+34>>1]=-1<<c^-1;if((e|0)==15){w[a+36>>1]=4095}x[a+52>>2]=b;x[a+64>>2]=b;b=d+z[a+26>>1]|0;w[a+48>>1]=b>>>0<12?1:1<<b-12;b=12-b|0;c=b>>>0<=12?b:0;w[a+44>>1]=c;b=d+z[a+30>>1]|0;w[a+60>>1]=b>>>0<12?1:1<<b-12;b=12-b|0;b=b>>>0<=12?b:0;w[a+56>>1]=b;w[a+46>>1]=-1<<c^-1;w[a+58>>1]=-1<<b^-1}function $na(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a:{f=fb-48|0;fb=f;g=f+12|0;Fr(g,c);x[31609]=0;c=f+24|0;O(597,c|0,d|0);d=x[31609];x[31609]=0;b:{c:{d:{if((d|0)==1){break d}x[31609]=0;c=f+36|0;O(597,c|0,e|0);d=x[31609];x[31609]=0;if((d|0)==1){break d}xx(f+4|0,g);x[31609]=0;V(301,a|0,b|0,x[f+4>>2],x[f+8>>2]);a=x[31609];x[31609]=0;if((a|0)==1){break c}Un(g);fb=f+48|0;break a}a=N()|0;while(1){c=tb(c-12|0);if((c|0)!=(f+12|0)){continue}break}break b}a=N()|0;Un(f+12|0)}Q(a|0);p()}}function rN(a,b){a=a|0;b=b|0;var c=0,d=0;d=fb-16|0;fb=d;a:{b:{c:{a=x[a+32>>2];c=pq(a);d:{if(!c){if(oq(a)>>>0<=b>>>0){break d}c=(y[oi(a,b+1&65535)+35|0]&4)>>>2|0;break b}if(b>>>0<c>>>0){break c}}a=ac(8);x[31609]=0;b=P(36,d+4|0,6e3)|0;c=x[31609];x[31609]=0;e:{if((c|0)!=1){pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}c=N()|0;tb(b);break e}c=N()|0;ic(a)}Q(c|0);p()}a=x[(a+(b<<2)|0)+900384>>2];c=1;if(!a){break b}c=(y[a+15|0]&2)>>>1|0}fb=d+16|0;return c|0}p()}function gP(a){a=a|0;var b=0,c=0,d=0,e=0;c=fb-32|0;fb=c;e=Nb(a);ie(c+24|0);a=0;b=x[c+28>>2];d=x[c+24>>2];x[31609]=0;O(176,e|0,bM(d,b)|0);b=x[31609];x[31609]=0;a:{if((b|0)!=1){b:{while(1){b=x[c+24>>2];if((bM(b,x[c+28>>2])|0)<=(a|0)){fb=c+32|0;return}b=x[b+(a<<3)>>2];x[31609]=0;b=P(36,c+12|0,b|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){x[31609]=0;O(178,e|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break b}tb(b);a=a+1|0;continue}break}a=N()|0;break a}a=N()|0;tb(b);break a}a=N()|0}Td(e);Q(a|0);p()}function M2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=fb-32|0;fb=d;a:{b:{c:{d:{if(g=Ad(x[b+4>>2],y[b+11|0]),h=1,i=x[b+12>>2],i?g:h){Fb(a);break d}c=Cb(x[b+4>>2],y[b+11|0]);e=d+20|0;f=cs(14355);am(Xg(Xg(Kb(Hz(e,c+f|0)),Kb(b),c)+c|0,14355,f)+f|0,1,0);x[31609]=0;c=d+8|0;O(126,c|0,b+12|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}x[31609]=0;S(2,a|0,e|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}tb(c);tb(e)}fb=d+32|0;return}b=N()|0;break a}b=N()|0;tb(d+8|0)}tb(d+20|0);Q(b|0);p()}function G2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a:{f=fb-48|0;fb=f;g=f+12|0;Np(g,c);x[31609]=0;c=f+24|0;O(133,c|0,d|0);d=x[31609];x[31609]=0;b:{c:{d:{if((d|0)==1){break d}x[31609]=0;c=f+36|0;O(133,c|0,e|0);d=x[31609];x[31609]=0;if((d|0)==1){break d}xx(f+4|0,g);x[31609]=0;V(92,a|0,b|0,x[f+4>>2],x[f+8>>2]);a=x[31609];x[31609]=0;if((a|0)==1){break c}Un(g);fb=f+48|0;break a}a=N()|0;while(1){c=tb(c-12|0);if((c|0)!=(f+12|0)){continue}break}break b}a=N()|0;Un(f+12|0)}Q(a|0);p()}}function Yia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=E(0);e=fb-16|0;fb=e;f=If(a,c);ae(e,x[a+36>>2]);h=a;a:{if(!f){Qc(e,a+32|0,5);c=0;if(Gb(x[x[e>>2]>>2],x[e+4>>2])){break a}}c=0;d=fb-16|0;fb=d;g=x[a+36>>2];pl(g,d+8|0);i=d,j=Bc(x[d+8>>2],x[d+12>>2]),x[i+4>>2]=j;x[d>>2]=256;Dl(b,x[Hb(d+4|0,d)>>2]);a=x[b>>2];while(1){if(oc(a,x[b+4>>2])>>>0<=c>>>0){fb=d+16|0}else{x[d+4>>2]=0;vq(g,d+4|0);a=x[b>>2];i=yb(a,c),k=B[d+4>>2],B[i>>2]=k;c=c+1|0;continue}break}c=f}ef(h,c);fb=e+16|0}function K4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=b&512;f=b&256;g=b&128;h=b&64;i=b&32;j=b&16;k=b&8;l=b&4;m=b&2;b=b&1;a:{while(1){if((c|0)==(d|0)){break a}a=x[c>>2];b:{if(b){if(Ws(a)){break b}}if(m){if(Vs(a)){break b}}if(l){if(Us(a)){break b}}if(k){if(Ts(a)){break b}}if(j){if(Ss(a)){break b}}if(i){if(Rs(a)){break b}}if(h){if(Nh(a)){break b}}if(g){if(Qs(a)){break b}}if(f){if(Ps(a)){break b}}if(e){if(Os(a)){break b}}c=c+4|0;continue}break}d=c}return d|0}function Gs(a,b,c,d,e){var f=0,g=0,h=0;f=fb-16|0;fb=f;a=kO(a);x[a+8>>2]=0;x[a>>2]=47628;x[31609]=0;h=R(852,104)|0;g=x[31609];x[31609]=0;a:{b:{c:{d:{if((g|0)!=1){x[31609]=0;c=R(1099,c|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break d}x[f+8>>2]=c;c=f+8|0;g=x[re(f+12|0,c)>>2];x[31609]=0;b=ba(e|0,h|0,b|0,g|0,d|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}x[a+8>>2]=b;Wc(c);b=x[a+8>>2];Bd(a,b?b+8|0:0);fb=f+16|0;return a}b=N()|0;break a}b=N()|0;break b}b=N()|0;Wc(f+8|0)}Db(h)}Qm(a);Q(b|0);p()}function mN(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;d=fb-32|0;fb=d;C[d+24>>3]=c;a:{b:{c:{if(b>>>0>=256){b=ac(8);x[31609]=0;d=P(36,d+8|0,10751)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}pc(b,d);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(d);break b}a=x[a+32>>2];x[d+8>>2]=0;x[d+12>>2]=-1074790400;x[d>>2]=0;x[d+4>>2]=1072693248;e=(D(b,872)+a|0)+1075684|0,f=Ui(C[Yg(d+24|0,d+8|0,d)>>3]*128+128),x[e>>2]=f;fb=d+32|0;return}a=N()|0;ic(b)}Q(a|0)}p()}function MM(a){var b=0,c=0,d=0,e=0,f=0;while(1){d=x[a+16>>2];if(d>>>0<=e>>>0){while(1){if(!(A[a+12>>2]<=d>>>0)){while(1){f=TA(x[a>>2]);e=hb;c=x[a+36>>2];if((e|0)==(c|0)&A[a+32>>2]<=f>>>0|e>>>0>c>>>0){continue}break}c=b;b=x[a+8>>2];b=(f&x[a+48>>2])+(b>>>0<31?c<<b+1:0)|0;d=d+1|0;continue}break}}else{while(1){f=TA(x[a>>2]);d=hb;c=x[a+28>>2];if((d|0)==(c|0)&A[a+24>>2]<=f>>>0|d>>>0>c>>>0){continue}break}c=b;b=x[a+8>>2];b=(f&x[a+40>>2])+(b>>>0<32?c<<b:0)|0;e=e+1|0;continue}break}return b}function fV(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;i=b?33:32;c=x[a+8>>2]-1|0;e=x[a+12>>2];f=x[a>>2]+D(e,31)|0;g=b?1:-1;d=g;a:while(1){b:{b=0;if((h|0)==(i|0)){break b}while(1)if((b|0)>=(e|0)){b=x[a+8>>2]-1|0;c:{if(!((b|0)!=(c|0)|(d|0)<=0)){if(!y[a+16|0]){d=1;c=0;break c}d=-1;c=c-(y[a+17|0]!=0&(c|0)!=0)|0;break c}if(!((d|0)>=0|c)){c=y[a+16|0];d=c?1:-1;c=c?0:b;break c}c=c+d|0}f=D(e,g)+f|0;h=h+1|0;continue a}else{v[b+f|0]=y[(x[a+4>>2]+D(c,e)|0)+b|0];b=b+1|0;e=x[a+12>>2];continue}}break}}function $f(a,b,c,d,e,f){var g=0,h=0,i=0;a:{if(f&64){e=f+-64|0;f=b;d=e&31;if((e&63)>>>0>=32){e=f<<d;d=0}else{e=(1<<d)-1&f>>>32-d|c<<d;d=f<<d}b=0;c=0;break a}if(!f){break a}h=d;g=f&31;if((f&63)>>>0>=32){i=d<<g;h=0}else{i=(1<<g)-1&h>>>32-g|e<<g;h=h<<g}g=b;e=64-f|0;d=e&31;if((e&63)>>>0>=32){e=0;d=c>>>d|0}else{e=c>>>d|0;d=((1<<d)-1&c)<<32-d|g>>>d}d=h|d;e=e|i;h=b;g=f&31;if((f&63)>>>0>=32){i=b<<g;b=0}else{i=(1<<g)-1&h>>>32-g|c<<g;b=h<<g}c=i}x[a>>2]=b;x[a+4>>2]=c;x[a+8>>2]=d;x[a+12>>2]=e}function zX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;a:{if(!y[b+8|0]){while(1){if((d|0)==8){x[c+24>>2]=0;x[c+28>>2]=0;d=Zb(c+8|0,c+24|0,8);e=x[d>>2];lc(c+16|0,x[a>>2],x[a+8>>2],e,x[d+4>>2]);d=0;if(!(x[c+24>>2]!=(y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24))|x[c+28>>2]!=(y[b+4|0]|y[b+5|0]<<8|(y[b+6|0]<<16|y[b+7|0]<<24))|x[c+20>>2]!=8)){Vb(a,8);d=1}fb=c+32|0;break a}e=b+d|0;d=d+1|0;if(y[e|0]){continue}break}_(17516,9095,602,13238);p()}_(17495,9095,600,13238);p()}return d|0}function w7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;g=fb-16|0;fb=g;e=Cb(x[a+4>>2],y[a+11|0]);d=Mc(a);f=Pj(b,c);a:{if(!f){break a}b:{if(!R_(a,b)){if(d-e>>>0<f>>>0){bn(a,d,(e-d|0)+f|0,e,e,0,0)}d=Kb(a)+e|0;while(1){if((b|0)==(c|0)){break b}hd(d,y[b|0]);b=b+1|0;d=d+1|0;continue}}b=Yl(g+4|0,b,c);c=Kb(b);e=y[b+11|0];d=x[b+4>>2];x[31609]=0;U(1282,a|0,c|0,Cb(d,e)|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){tb(b);break a}a=N()|0;tb(b);Q(a|0);p()}hd(d,0);lg(a,e+f|0)}fb=g+16|0;return a|0}function tx(a){var b=0,c=0,d=0;if(A[a+4>>2]<A[Ab(a)>>2]){b=fb-16|0;fb=b;a=qG(b+4|0,a);c=x[a+4>>2];x[31609]=0;W(164,c|0);c=x[31609];x[31609]=0;a:{if((c|0)!=1){x[a+4>>2]=x[a+4>>2]+36;kc(a);fb=b+16|0;break a}b=N()|0;kc(a);Q(b|0);p()}return}c=fb-32|0;fb=c;b=Ab(a);b=oG(c+12|0,pG(a,ds(x[a>>2],x[a+4>>2])+1|0),ds(x[a>>2],x[a+4>>2]),b);d=x[b+8>>2];x[31609]=0;W(164,d|0);d=x[31609];x[31609]=0;b:{if((d|0)!=1){x[b+8>>2]=x[b+8>>2]+36;nG(a,b);ix(b);fb=c+32|0;break b}a=N()|0;ix(b);Q(a|0);p()}}function h1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=fb-32|0;fb=d;nd(b,0);e=d+8|0;ek(e,1,a+33|0);c=d+20|0;Cc(c,e);Be(b+43|0,c);tb(c);f=y[a+50|0]|y[a+51|0]<<8;x[b>>2]=f;x[b+24>>2]=y[a+52|0]|y[a+53|0]<<8;v[d+20|0]=y[a+54|0];v[d+8|0]=64;g=b,h=y[Qb(c,e)|0]<<2,w[g+30>>1]=h;e=y[a+55|0]|y[a+56|0]<<8;x[b+4>>2]=e;c=y[a+57|0]|y[a+58|0]<<8;x[b+8>>2]=c;a:{if((c|0)==65535){x[b+4>>2]=0;x[b+8>>2]=0;break a}if(!y[a|0]|c>>>0<=e+2>>>0|c>>>0>f>>>0){break a}w[b+34>>1]=z[b+34>>1]|2}fb=d+32|0}function dp(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=fb-16|0;fb=g;h=xb(b,0);f=(y[h|0]&15)<<8|y[xb(b,1)|0];d=0;a:{if(!f){break a}d=0;if((f|0)==4095){break a}while(1){d=108;if((e|0)==84){break a}b:{i=e<<1;d=z[i+31040>>1];if(d>>>0<=f>>>0){if(!e|(f|0)==(d|0)|(z[i+31038>>1]-f|0)>=(f-d|0)){break b}d=e+24|0;break a}e=e+1|0;continue}break}d=e+25|0}v[c|0]=d;e=xb(b,2);d=y[e|0];f=y[h|0];v[c+3|0]=0;v[c+1|0]=f&16|d>>>4;c=y[e|0];j=g,k=y[xb(b,3)|0],v[j+15|0]=k;ee(a,c&15,g+15|0);fb=g+16|0}function YR(a,b){var c=0,d=0,e=0,f=0,g=0;c=fb-32|0;fb=c;a:{g=b-1&65535;if(g>>>0>3998){break a}d=D(b,104)+a|0;e=d+484380|0;if(!le(x[e>>2],x[d+484400>>2])){break a}d=1074992;while(1){if((d|0)==1298224){on(e);x[e>>2]=0;a=(D(b,104)+a|0)+484414|0;w[a>>1]=z[a>>1]&65470;x[c+24>>2]=0;x[c+8>>2]=0;x[c+16>>2]=0;x[c+20>>2]=0;x[c>>2]=0;x[c+4>>2]=0;Tk(e,0,c);break a}f=a+d|0;if(x[f+104>>2]==(e|0)){x[f+76>>2]=0;x[f>>2]=0;x[f+4>>2]=0;x[f+16>>2]=0}d=d+872|0;continue}}fb=c+32|0;return g>>>0<3999}function lS(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=x[a+104>>2];d=(g<<3)+a|0;b=((g+7>>>0)%12<<3)+a|0;f=x[b>>2];e=x[b+4>>2];b=x[a+100>>2];j=b;h=x[a+96>>2];a:{if(!(b|h)){c=x[d+4>>2];b=x[d>>2];i=(c|0)==(e|0)&b>>>0>f>>>0|e>>>0<c>>>0;break a}c=x[d+4>>2];b=x[d>>2];i=!(e|f)|((c|0)==(e|0)&b>>>0>=f>>>0|e>>>0<c>>>0)}c=c+j|0;b=b+h|0;c=b>>>0<h>>>0?c+1|0:c;x[d>>2]=f-b;x[d+4>>2]=e-(c+(b>>>0>f>>>0)|0)&65535;x[a+104>>2]=(g+1>>>0)%12;x[a+96>>2]=i;x[a+100>>2]=0;hb=x[d+4>>2];return x[d>>2]}function Taa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=fb-16|0;fb=c;a:{d=Ui(C[a+24>>3]*65536);if((d|0)==65536){break a}j=d>>31;k=x[b>>2];h=x[b+4>>2];l=x[b+8>>2];b:while(1){if((g|0)==(l|0)){break a}m=(D(g,h)<<2)+k|0;e=0;while(1)if((e|0)==(h|0)){g=g+1|0;continue b}else{i=(e<<2)+m|0;f=x[i>>2];f=Jua(Iua(f,f>>31,d,j),hb,65536,0);n=i,o=Gc(f,hb),x[n>>2]=o;e=e+1|0;continue}}}x[c+8>>2]=x[b+8>>2];d=x[b+4>>2];x[c>>2]=x[b>>2];x[c+4>>2]=d;JM(a,c);fb=c+16|0}function Kaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=fb-16|0;fb=c;a:{d=Ui(C[a+24>>3]*65536);if((d|0)==65536){break a}j=d>>31;k=x[b>>2];h=x[b+4>>2];l=x[b+8>>2];b:while(1){if((g|0)==(l|0)){break a}m=(D(g,h)<<2)+k|0;e=0;while(1)if((e|0)==(h|0)){g=g+1|0;continue b}else{i=(e<<2)+m|0;f=x[i>>2];f=Jua(Iua(f,f>>31,d,j),hb,65536,0);n=i,o=Gc(f,hb),x[n>>2]=o;e=e+1|0;continue}}}x[c+8>>2]=x[b+8>>2];d=x[b+4>>2];x[c>>2]=x[b>>2];x[c+4>>2]=d;DM(a,c);fb=c+16|0}function Bja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=fb-32|0;fb=d;e=d+8|0;Xi(e,2,a+2|0);f=d+20|0;Cc(f,e);Ac(b+492|0,f);e=b+236|0;g=c+1|0;tb(f);c=0;while(1){if((c|0)==120){x[b>>2]=(y[a+223|0]|y[a+224|0]<<8)<<5;a=a+158|0;wR(y[a|0]&15,y[a+1|0]&15,y[a+2|0]&15,y[a+3|0]&15,y[a+4|0]&15,a+5|0,b+48|0);wR(y[a|0]>>>4|0,y[a+1|0]>>>4|0,y[a+2|0]>>>4|0,y[a+3|0]>>>4|0,y[a+4|0]>>>4|0,a+35|0,b+68|0);fb=d+32|0}else{h=bc(e,c),i=y[(a+c|0)+31|0]+g|0,w[h>>1]=i;c=c+1|0;continue}break}}function pra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;i=e,j=Rj(b),x[i+4>>2]=j;g=z[b>>1];c=fb-16|0;fb=c;f=a;d=de(a);a:{if(d){b=gc(a);while(1){a=d;d=z[a+16>>1];if(_o(g,d)){b=a;d=x[a>>2];if(d){continue}break a}if(!_o(d,g)){break a}b=a+4|0;d=x[a+4>>2];if(d){continue}break}break a}a=gc(f);b=a}x[c+12>>2]=a;a=x[b>>2];if(!a){yZ(c,f,e+4|0);$g(f,x[c+12>>2],b,x[c>>2]);a=ne(c);xZ(c);h=1}_g(e+8|0,x[vb(c,a)>>2],h);fb=c+16|0;a=ud(x[e+8>>2]);fb=e+16|0;return a+4|0}function Tk(a,b,c){var d=0;d=z[a+34>>1];if(!b){if(d&512){wp(a);d=z[a+34>>1]}w[a+34>>1]=d&65023;return}x[a>>2]=4;w[a+34>>1]=d&64958|512;Gh(a);b=y[c+8|0]|y[c+9|0]<<8|(y[c+10|0]<<16|y[c+11|0]<<24);v[a+76|0]=b;v[a+77|0]=b>>>8;v[a+78|0]=b>>>16;v[a+79|0]=b>>>24;b=y[c+4|0]|y[c+5|0]<<8|(y[c+6|0]<<16|y[c+7|0]<<24);c=y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24);v[a+68|0]=c;v[a+69|0]=c>>>8;v[a+70|0]=c>>>16;v[a+71|0]=c>>>24;v[a+72|0]=b;v[a+73|0]=b>>>8;v[a+74|0]=b>>>16;v[a+75|0]=b>>>24}function AA(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-48|0;fb=e;a:{if(!c){b=Yd(x[a>>2],b);a=x[d+12>>2];x[b+8>>2]=x[d+8>>2];x[b+12>>2]=a;a=x[d+4>>2];x[b>>2]=x[d>>2];x[b+4>>2]=a;break a}f=x[d+12>>2];x[e+24>>2]=x[d+8>>2];x[e+28>>2]=f;f=x[d+4>>2];x[e+16>>2]=x[d>>2];x[e+20>>2]=f;f=c>>>1|0;AA(a,b,f,e+16|0);g=C[d>>3];h=C[d+8>>3];d=Yd(x[a>>2],c);Ni(e+32|0,g,h,C[d>>3],C[d+8>>3]);d=x[e+44>>2];x[e+8>>2]=x[e+40>>2];x[e+12>>2]=d;d=x[e+36>>2];x[e>>2]=x[e+32>>2];x[e+4>>2]=d;AA(a,b|c,f,e)}fb=e+48|0}function _Q(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;i=e,j=Rj(b),x[i+4>>2]=j;g=z[b>>1];c=fb-16|0;fb=c;f=a;d=de(a);a:{if(d){b=gc(a);while(1){a=d;d=z[a+16>>1];if(Xq(g,d)){b=a;d=x[a>>2];if(d){continue}break a}if(!Xq(d,g)){break a}b=a+4|0;d=x[a+4>>2];if(d){continue}break}break a}a=gc(f);b=a}x[c+12>>2]=a;a=x[b>>2];if(!a){yZ(c,f,e+4|0);$g(f,x[c+12>>2],b,x[c>>2]);a=ne(c);xZ(c);h=1}_g(e+8|0,x[vb(c,a)>>2],h);fb=c+16|0;a=ud(x[e+8>>2]);fb=e+16|0;return a+4|0}function Bla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;a:{x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);c=x[b>>2];e=c;d=x[b+4>>2];f=d;d=$c(c,d);c=fb-16|0;fb=c;Rd(c+8|0,x[vb(c+4|0,a)>>2]);b:{c:{if(d){x[31609]=0;O(641,a|0,d|0);g=x[31609];x[31609]=0;if((g|0)==1){break c}dv(a,e,f,d)}d=c+8|0;Qd(d);Sj(d);fb=c+16|0;break b}a=N()|0;Sj(c+8|0);Q(a|0);p()}x[31609]=0;P(3,a+12|0,b+12|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){x[a+24>>2]=x[b+24>>2];w[a+28>>1]=z[b+28>>1];break a}b=N()|0;od(a);Q(b|0);p()}}function Oia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;f=fb-48|0;fb=f;d=x[a+36>>2];ig(x[x[d>>2]-12>>2]+d|0,0);d=x[b>>2];g=x[d+8>>2];e=x[d+12>>2];if(g|e){h=x[a+36>>2];e=x[a+20>>2]+e|0;d=x[a+16>>2];g=g+d|0;e=ci(f+32|0,g,d>>>0>g>>>0?e+1|0:e);d=x[e+12>>2];x[f+8>>2]=x[e+8>>2];x[f+12>>2]=d;d=x[e+4>>2];x[f>>2]=x[e>>2];x[f+4>>2]=d;Um(h,f)}d=f+16|0;ae(d,x[a+36>>2]);WB(x[a+36>>2],c,x[x[b>>2]+16>>2]);c=x[b>>2];b=sl(d,xb(x[a+40>>2],x[c>>2]),z[c+20>>1]);ef(a,c);Eb(b);fb=f+48|0}function cqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=fb+-64|0;fb=d;b=-1;a:{if(!xm(a,1084)){break a}Xl(a,1080);c=d+60|0;iY(a,c);f=hY(d+40|0);b=0;if(!gY(c,f)){break a}Xl(a,20);b=1;while(1){if((b&65535)>>>0>=32){b=A[f+4>>2]>=h>>>0}else{c=y[f+16|0];e=fb-16|0;fb=e;b:{g=d+10|0;if(!fY(a,g)|!c){break b}Gv(e+8|0,g);c=0;while(1){if(c>>>0>=30){break b}i=x[e+8>>2];rg(xb(i,c),xb(i,c|1));c=c+2|0;continue}}fb=e+16|0;b=b+1|0;h=_C(g)+h|0;continue}break}}fb=d- -64|0;return b|0}function ZH(a,b,c,d,e,f,g,h){var i=0,j=0,k=0;i=fb-16|0;fb=i;x[31609]=0;W(996,a|0);j=x[31609];x[31609]=0;a:{b:{if((j|0)!=1){c:{j=x[a+24>>2];x[31609]=0;k=h;h=i+4|0;ga(k|0,h|0,j|0,b|0,c|0,d|0,e|0,(f|0)!=0|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}b=Cg(Kb(h));tb(h);break b}}Y(T(0)|0)|0;b=0;x[31609]=0;V(983,g|0,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z()}fb=i+16|0;return b}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function ot(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;i=fb-16|0;fb=i;a:{b:{if(!a){break b}g=x[e+12>>2];h=c-b>>2;if((h|0)>0){if((mp(a,b,h)|0)!=(h|0)){break b}}b=d-b>>2;b=(b|0)<(g|0)?g-b|0:0;if((b|0)>0){f=Ay(i+4|0,b,f);g=Kb(f);x[31609]=0;g=U(1271,a|0,g|0,b|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break a}Ub(f);if((b|0)!=(g|0)){break b}}b=d-c>>2;if((b|0)>0){if((mp(a,c,b)|0)!=(b|0)){break b}}uE(e);j=a}fb=i+16|0;return j|0}a=N()|0;Ub(f);Q(a|0);p()}function QN(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0;f=c-b|0;a:{if((f|0)<=19){i=D(64-du(d|1,e)|0,1233)>>>12|0;j=(i<<3)+121344|0;g=f;f=x[j+4>>2];h=61;if((g|0)<(((e|0)==(f|0)&d>>>0>=A[j>>2]|e>>>0>f>>>0)+i|0)){break a}}b:{if(!e){c=zB(b,d);break b}if((e|0)==2&d>>>0>=1410065408|e>>>0>2){c=Kua(d,e,1410065408,2);f=Iua(c,hb,-1410065408,-3);e=e+hb|0;g=d;d=d+f|0;e=g>>>0>d>>>0?e+1|0:e;b=zB(b,c)}c=Kua(d,e,1e8,0);e=hb;b=Jl(b,c);c=Iua(c,e,-1e8,0)+d|0;c=Qu(b,c)}h=0}x[a+4>>2]=h;x[a>>2]=c}function ps(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((a|0)!=(b|0)){if(!vd(y[a+11|0])){c=y[b+11|0];if(!vd(c)){d=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=d;x[a+8>>2]=x[b+8>>2];return}d=Kb(b);b=Cb(x[b+4>>2],c);a:{if(b>>>0<=10){Ne(a,b);hd(Xg(a,d,b)+b|0,0);break a}e=a;a=Hh(y[a+11|0]);Sq(e,10,b-10|0,a,0,a,b,d)}return}d=Kb(b);b=Cb(x[b+4>>2],y[b+11|0]);c=$i(x[a+8>>2]);b:{if(b>>>0<c>>>0){c=x[a>>2];Bd(a,b);hd(Xg(c,d,b)+b|0,0);break b}e=a;a=x[a+4>>2];Sq(e,c-1|0,(b-c|0)+1|0,a,0,a,b,d)}}}function YH(a,b,c,d,e,f,g){var h=0,i=0,j=0;h=fb-16|0;fb=h;x[31609]=0;W(996,a|0);i=x[31609];x[31609]=0;a:{b:{if((i|0)!=1){c:{i=x[x[a+24>>2]+24>>2];x[31609]=0;j=g;g=h+4|0;ja(j|0,g|0,i|0,b|0,c|0,d|0,e|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}b=Cg(Kb(g));tb(g);break b}}Y(T(0)|0)|0;b=0;x[31609]=0;V(983,f|0,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z()}fb=h+16|0;return b}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Iha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;b=fb-16|0;fb=b;d=x[a+20>>2];c=x[d+4>>2];a:{if(!((Xc(c,x[d+8>>2])|0)!=7|(y[c|0]|y[c+1|0]<<8|(y[c+2|0]<<16|y[c+3|0]<<24))!=1869112133)){d=wb(c);g=wb(x[x[a+20>>2]+8>>2]);Ir(b+8|0,a+4228|0);f=wb(x[b+8>>2]);e=fb-16|0;fb=e;c=fb-32|0;fb=c;fd(c+24|0,d,g);cv(c+16|0,x[c+24>>2],x[c+28>>2],f);d=X_(d,x[c+16>>2]);h=c,i=_D(f,x[c+20>>2]),x[h+12>>2]=i;rc(e+8|0,d,c+12|0);fb=c+32|0;fb=e+16|0;break a}bA(a,a)}lu(a);fb=b+16|0}function FE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((a|0)!=(b|0)){if(!vd(y[a+11|0])){c=y[b+11|0];if(!vd(c)){d=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=d;x[a+8>>2]=x[b+8>>2];return}d=Kb(b);b=Cb(x[b+4>>2],c);a:{if(b>>>0<=10){Ne(a,b);hd(Dg(a,d,b)+b|0,0);break a}e=a;a=Hh(y[a+11|0]);Yp(e,10,b-10|0,a,0,a,b,d)}return}d=Kb(b);b=Cb(x[b+4>>2],y[b+11|0]);c=$i(x[a+8>>2]);b:{if(b>>>0<c>>>0){c=x[a>>2];Bd(a,b);hd(Dg(c,d,b)+b|0,0);break b}e=a;a=x[a+4>>2];Yp(e,c-1|0,(b-c|0)+1|0,a,0,a,b,d)}}}function mY(a,b,c,d){var e=0,f=0;f=fb-16|0;fb=f;e=z[c>>1];while(1){a:{e=e<<1;w[c>>1]=e;v[b|0]=(e&65534)>>>0>255;e=y[c|0];w[c>>1]=e;if(!e){if(!Bf(a,f+15|0)){break a}e=y[f+15|0];w[c>>1]=e<<1|1;v[b|0]=e>>>7;w[c>>1]=y[c|0]}v[d|0]=y[b|0]+(y[d|0]<<1);e=z[c>>1]<<1;w[c>>1]=e;v[b|0]=(e&65534)>>>0>255;e=y[c|0];w[c>>1]=e;if(!e){if(!Bf(a,f+14|0)){break a}e=y[f+14|0];w[c>>1]=e<<1|1;v[b|0]=e>>>7;e=y[c|0];w[c>>1]=e;if(y[b|0]){continue}break a}if(y[b|0]){continue}}break}fb=f+16|0}function Pia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;g=fb-48|0;fb=g;e=x[a+36>>2];ig(x[x[e>>2]-12>>2]+e|0,0);e=x[b>>2];h=x[e+8>>2];f=x[e+12>>2];if(h|f){i=x[a+36>>2];f=x[a+20>>2]+f|0;e=x[a+16>>2];h=h+e|0;f=ci(g+32|0,h,e>>>0>h>>>0?f+1|0:f);e=x[f+12>>2];x[g+8>>2]=x[f+8>>2];x[g+12>>2]=e;e=x[f+4>>2];x[g>>2]=x[f>>2];x[g+4>>2]=e;Um(i,g)}e=g+16|0;ae(e,x[a+36>>2]);WQ(d,x[a+36>>2],c);c=x[b>>2];b=sl(e,xb(x[a+40>>2],x[c>>2]),z[c+20>>1]);ef(a,c);Eb(b);fb=g+48|0}function Nia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;g=fb-48|0;fb=g;e=x[a+36>>2];ig(x[x[e>>2]-12>>2]+e|0,0);e=x[b>>2];h=x[e+8>>2];f=x[e+12>>2];if(h|f){i=x[a+36>>2];f=x[a+20>>2]+f|0;e=x[a+16>>2];h=h+e|0;f=ci(g+32|0,h,e>>>0>h>>>0?f+1|0:f);e=x[f+12>>2];x[g+8>>2]=x[f+8>>2];x[g+12>>2]=e;e=x[f+4>>2];x[g>>2]=x[f>>2];x[g+4>>2]=e;Um(i,g)}e=g+16|0;ae(e,x[a+36>>2]);TQ(c,x[a+36>>2],d);c=x[b>>2];b=sl(e,xb(x[a+40>>2],x[c>>2]),z[c+20>>1]);ef(a,c);Eb(b);fb=g+48|0}function tw(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;i=fb-16|0;fb=i;a:{b:{if(!a){break b}g=x[e+12>>2];h=c-b|0;if((h|0)>0){if((mp(a,b,h)|0)!=(h|0)){break b}}b=d-b|0;b=(b|0)<(g|0)?g-b|0:0;if((b|0)>0){f=qf(i+4|0,b,f);g=Kb(f);x[31609]=0;g=U(32,a|0,g|0,b|0)|0;h=x[31609];x[31609]=0;if((h|0)==1){break a}tb(f);if((b|0)!=(g|0)){break b}}b=d-c|0;if((b|0)>0){if((mp(a,c,b)|0)!=(b|0)){break b}}uE(e);j=a}fb=i+16|0;return j|0}a=N()|0;tb(f);Q(a|0);p()}function E7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;c=fb-128|0;fb=c;x[c+12>>2]=c+116;d=c+16|0;jK(x[a+8>>2],d,c+12|0,e,f,g);f=fb-16|0;fb=f;h=f+8|0;a=fb-32|0;fb=a;fd(a+24|0,d,x[c+12>>2]);i=a+16|0;e=x[a+24>>2];g=x[a+28>>2];d=fb-16|0;fb=d;x[d+12>>2]=b;while(1){if((e|0)!=(g|0)){hL(d+12|0,v[e|0]);e=e+1|0;continue}break}rc(i,g,d+12|0);fb=d+16|0;b=x[a+16>>2];x[a+12>>2]=x[a+20>>2];rc(h,b,a+12|0);fb=a+32|0;fb=f+16|0;fb=c+128|0;return x[f+12>>2]}function Vta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=fb-16|0;fb=d;a:{g=x[c+12>>2];if(!g){break a}e=jg(d+4|0,c+16|0);f=_c(x[b+4>>2],y[b+11|0]);h=f-1|0;c=0;while(1){if((c|0)==(f|0)){tb(e);break a}b:{c:{if(!c|(c>>>0)%(g>>>0)){break c}if((c|0)==(h|0)){if(y[dc(b,0)|0]==43){break c}if(y[dc(b,0)|0]==45){break c}}x[31609]=0;U(304,b|0,f-c|0,e|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break b}}c=c+1|0;continue}break}a=N()|0;tb(e);Q(a|0);p()}Uc(a,b);fb=d+16|0}function Mz(a,b,c){var d=0,e=0;d=(c|0)!=0;a:{b:{c:{if(!(a&3)|!c){break c}e=b&255;while(1){if((e|0)==y[a|0]){break b}c=c-1|0;d=(c|0)!=0;a=a+1|0;if(!(a&3)){break c}if(c){continue}break}}if(!d){break a}d=b&255;if(!((d|0)==y[a|0]|c>>>0<4)){d=D(d,16843009);while(1){e=d^x[a>>2];if((e^-1)&e-16843009&-2139062144){break b}a=a+4|0;c=c-4|0;if(c>>>0>3){continue}break}}if(!c){break a}}b=b&255;while(1){if((b|0)==y[a|0]){return a}a=a+1|0;c=c-1|0;if(c){continue}break}}return 0}function FK(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;a:{b:{if((a|0)!=(b|0)){c:{d:{f=y[a|0];if((f|0)!=45){break d}a=a+1|0;if((b|0)!=(a|0)){break d}break c}h=x[31484];x[31484]=0;Od();a=Iy(a,e+12|0,d);d=hb;g=x[31484];e:{if(g){if(x[e+12>>2]!=(b|0)){break c}if(!d&a>>>0>65535|d|(g|0)==68){break e}break b}x[31484]=h;if(x[e+12>>2]!=(b|0)){break c}if(!d&a>>>0<65536){break b}}x[c>>2]=4;a=65535;break a}}x[c>>2]=4;a=0;break a}a=(f|0)==45?0-a|0:a}fb=e+16|0;return a&65535}function ria(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a=Li(a,b,c,d);x[a>>2]=42476;b=Nb(a+4208|0);x[a+4236>>2]=-1;x[a+4240>>2]=0;x[a+4228>>2]=1049926264;x[a+4232>>2]=0;x[a+4220>>2]=1056964608;x[a+4224>>2]=1056964608;v[a+4244|0]=0;Rb(a+4248|0,0,48);x[31609]=0;X(850);c=x[31609];x[31609]=0;a:{if((c|0)==1){break a}e=a,f=sS(),x[e+4296>>2]=f;qu(a);pu(a);x[31609]=0;O(941,a+44|0,2);c=x[31609];x[31609]=0;if((c|0)==1){break a}return a|0}c=N()|0;ec(b);_f(a);Q(c|0);p()}function hm(a){var b=0,c=0;a:{b=x[a+4>>2];b=x[x[b>>2]-12>>2]+b|0;b:{if(!x[b+24>>2]|x[b+16>>2]|!(y[b+5|0]&32)){break b}if((db()|0)>0){break b}b=x[a+4>>2];b=x[(x[x[b>>2]-12>>2]+b|0)+24>>2];x[31609]=0;b=R(31,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){if((b|0)!=-1){break b}a=x[a+4>>2];b=x[x[a>>2]-12>>2];x[31609]=0;O(24,a+b|0,1);a=x[31609];x[31609]=0;if((a|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)==1){break a}}return}T(0)|0;Sb();p()}function Pna(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=fb-16|0;fb=d;a:{g=x[c+12>>2];if(!g){break a}e=wm(d+4|0,c+16|0);f=_c(x[b+4>>2],y[b+11|0]);h=f-1|0;c=0;while(1){if((c|0)==(f|0)){tb(e);break a}b:{c:{if(!c|(c>>>0)%(g>>>0)){break c}if((c|0)==(h|0)){if(y[dc(b,0)|0]==43){break c}if(y[dc(b,0)|0]==45){break c}}x[31609]=0;U(48,b|0,f-c|0,e|0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break b}}c=c+1|0;continue}break}a=N()|0;tb(e);Q(a|0);p()}Uc(a,b);fb=d+16|0}function mT(a,b){var c=0,d=0,e=0,f=0,g=0;a:{if(y[b+791|0]!=27){a=v[b+831|0];break a}e=a+1074312|0;c=Ob(e,21);d=a;a=y[b+821|0];a=KA(d,y[b+828|0],c?a:a+16>>>2|0);b:{if(!(!Ob(e,45)|y[b+828|0]!=3)){c=y[b+821|0];c:{if(!(!c|c>>>0>=y[b+829|0])){a=y[b+832|0];d=c+1|0;break c}v[b+832|0]=a;d=1}v[b+821|0]=d;a=a<<24>>24;break b}v[b+821|0]=y[b+821|0]+y[b+829|0]}if(!Ob(e,47)){break a}v[b+831|0]=a}if(a){f=b,g=Yb(x[b+684>>2]+((D(y[b+830|0],a)+2|0)/8|0)|0,0,256),x[f+684>>2]=g}}function fH(a,b,c,d,e,f){var g=0,h=0;a:{g=fb-48|0;fb=g;h=g+12|0;$n(h,c);x[31609]=0;c=g+24|0;O(f|0,c|0,d|0);d=x[31609];x[31609]=0;b:{c:{d:{if((d|0)==1){break d}x[31609]=0;c=g+36|0;O(91,c|0,e|0);d=x[31609];x[31609]=0;if((d|0)==1){break d}xx(g+4|0,h);x[31609]=0;V(92,a|0,b|0,x[g+4>>2],x[g+8>>2]);a=x[31609];x[31609]=0;if((a|0)==1){break c}Un(h);fb=g+48|0;break a}a=N()|0;while(1){c=tb(c-12|0);if((c|0)!=(g+12|0)){continue}break}break b}a=N()|0;Un(g+12|0)}Q(a|0);p()}}function eR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=x[a>>2];c=oc(d,x[a+4>>2]);if(c>>>0<=127){f=fb-32|0;fb=f;c=128-c|0;e=x[Ab(a)>>2];d=x[a+4>>2];a:{if(c>>>0<=e-d>>2>>>0){oA(a,c,b);break a}e=Ab(a);d=Zf(f+12|0,Mf(a,oc(x[a>>2],d)+c|0),oc(x[a>>2],x[a+4>>2]),e);g=fb-16|0;fb=g;c=Gn(g+4|0,d+8|0,c);e=x[c>>2];while(1){if(x[c+4>>2]!=(e|0)){uk(e,B[b>>2]);e=x[c>>2]+4|0;x[c>>2]=e;continue}break}je(c);fb=g+16|0;nA(a,d);Yf(d)}fb=f+32|0;return}if((c|0)!=128){Jd(a,d+512|0)}}function NR(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;a:{if((c|0)<2){break a}i=c-2>>>1|0;e=d-a|0;if((i|0)<e>>1){break a}g=e+1|0;f=(g<<1)+a|0;e=e+2|0;if((e|0)<(c|0)){h=e;e=Fl(b,z[f>>1],z[f+2>>1]);g=e?h:g;f=e?f+2|0:f}if(Fl(b,z[f>>1],z[d>>1])){break a}j=z[d>>1];while(1){b:{e=d;d=f;w[e>>1]=z[f>>1];if((g|0)>(i|0)){break b}e=g<<1;g=e|1;f=(g<<1)+a|0;e=e+2|0;if((e|0)<(c|0)){h=e;e=Fl(b,z[f>>1],z[f+2>>1]);g=e?h:g;f=e?f+2|0:f}if(!Fl(b,z[f>>1],j)){continue}}break}w[d>>1]=j}}function yoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb+-64|0;fb=c;kn(c+52|0,b);se(c+24|0,x[c+52>>2],x[c+56>>2]);b=Md(c+16|0);x[31609]=0;d=x[b+4>>2];x[c+8>>2]=x[b>>2];x[c+12>>2]=d;b=hg(160,c+32|0,x[c+24>>2],x[c+28>>2],c+8|0);d=x[31609];x[31609]=0;a:{if((d|0)!=1){d=Nb(a);a=x[c+56>>2];e=x[c+52>>2];x[31609]=0;S(732,b|0,d|0,Xc(e,a)>>>5|0);a=x[31609];x[31609]=0;if((a|0)==1){a=N()|0;Si(d);ub(b);break a}ub(b);ec(c+52|0);fb=c- -64|0;return}a=N()|0}ec(c+52|0);Q(a|0);p()}function voa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb+-64|0;fb=c;kn(c+52|0,b);se(c+24|0,x[c+52>>2],x[c+56>>2]);b=Md(c+16|0);x[31609]=0;d=x[b+4>>2];x[c+8>>2]=x[b>>2];x[c+12>>2]=d;b=hg(160,c+32|0,x[c+24>>2],x[c+28>>2],c+8|0);d=x[31609];x[31609]=0;a:{if((d|0)!=1){d=Nb(a);a=x[c+56>>2];e=x[c+52>>2];x[31609]=0;S(733,b|0,d|0,Xc(e,a)>>>2|0);a=x[31609];x[31609]=0;if((a|0)==1){a=N()|0;wc(d);ub(b);break a}ub(b);ec(c+52|0);fb=c- -64|0;return}a=N()|0}ec(c+52|0);Q(a|0);p()}function uoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb+-64|0;fb=c;kn(c+52|0,b);se(c+24|0,x[c+52>>2],x[c+56>>2]);b=Md(c+16|0);x[31609]=0;d=x[b+4>>2];x[c+8>>2]=x[b>>2];x[c+12>>2]=d;b=hg(160,c+32|0,x[c+24>>2],x[c+28>>2],c+8|0);d=x[31609];x[31609]=0;a:{if((d|0)!=1){d=Nb(a);a=x[c+56>>2];e=x[c+52>>2];x[31609]=0;S(734,b|0,d|0,Xc(e,a)>>>8|0);a=x[31609];x[31609]=0;if((a|0)==1){a=N()|0;tv(d);ub(b);break a}ub(b);ec(c+52|0);fb=c- -64|0;return}a=N()|0}ec(c+52|0);Q(a|0);p()}function toa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb+-64|0;fb=c;kn(c+52|0,b);se(c+24|0,x[c+52>>2],x[c+56>>2]);b=Md(c+16|0);x[31609]=0;d=x[b+4>>2];x[c+8>>2]=x[b>>2];x[c+12>>2]=d;b=hg(160,c+32|0,x[c+24>>2],x[c+28>>2],c+8|0);d=x[31609];x[31609]=0;a:{if((d|0)!=1){d=Nb(a);a=x[c+56>>2];e=x[c+52>>2];x[31609]=0;S(735,b|0,d|0,Xc(e,a)>>>4|0);a=x[31609];x[31609]=0;if((a|0)==1){a=N()|0;ln(d);ub(b);break a}ub(b);ec(c+52|0);fb=c- -64|0;return}a=N()|0}ec(c+52|0);Q(a|0);p()}function dpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=fb-32|0;fb=d;nd(b,0);e=d+8|0;RD(e,a+1|0);c=d+20|0;Cc(c,e);Be(b+43|0,c);tb(c);x[b+24>>2]=y[a+78|0]|y[a+79|0]<<8;c=y[a+58|0]|y[a+59|0]<<8|(y[a+60|0]<<16|y[a+61|0]<<24);x[b>>2]=c;x[b+4>>2]=y[a+62|0]|y[a+63|0]<<8|(y[a+64|0]<<16|y[a+65|0]<<24);x[b+8>>2]=y[a+66|0]|y[a+67|0]<<8|(y[a+68|0]<<16|y[a+69|0]<<24);w[b+30>>1]=(y[a+73|0]<<1)+2;w[b+34>>1]=z[b+34>>1]&65533|y[a|0]>>>6&2;xc(b+8|0,c);xc(b+4|0,x[b+8>>2]);fb=d+32|0}function s1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=fb-16|0;fb=e;c=e+12|0;f=fb-16|0;fb=f;h=Ec(168);x[31609]=0;g=P(36,f+4|0,22292)|0;d=x[31609];x[31609]=0;a:{b:{c:{if((d|0)!=1){x[31609]=0;d=U(37,h|0,g|0,0)|0;i=x[31609];x[31609]=0;if((i|0)==1){break c}tb(g);x[c>>2]=d;qm(d);fb=f+16|0;break a}a=N()|0;break b}a=N()|0;tb(g)}Db(h);Q(a|0);p()}x[31609]=0;S(27,a|0,c|0,b|0);a=x[31609];x[31609]=0;if((a|0)!=1){_b(c);fb=e+16|0;return}a=N()|0;_b(c);Q(a|0);p()}function ira(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=wb(x[b>>2]);h=wb(x[b+4>>2]);g=fb-16|0;fb=g;x[g+12>>2]=d;while(1){a:{if(!Ib(d,h)){break a}e=fb-16|0;fb=e;f=y[d|0]|y[d+1|0]<<8|(y[d+2|0]<<16|y[d+3|0]<<24);v[e+10|0]=f;v[e+11|0]=f>>>8;v[e+12|0]=f>>>16;v[e+13|0]=f>>>24;f=y[d+4|0]|y[d+5|0]<<8;v[e+14|0]=f;v[e+15|0]=f>>>8;fb=e+16|0;if(z[e+10>>1]==(c|0)){break a}d=x[em(g+12|0)>>2];continue}break}fb=g+16|0;if(mc(d,wb(x[b+4>>2]))){_h(a);return}lp(a,d)}function Rha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;e=d+4|0;c=fb-32|0;fb=c;f=c+8|0;Uf(f,b);x[31609]=0;b=c+20|0;S(11,b|0,0,f|0);g=x[31609];x[31609]=0;a:{b:{c:{if((g|0)!=1){x[31609]=0;O(962,e|0,b|0);g=x[31609];x[31609]=0;if((g|0)==1){break c}Ub(b);tb(f);fb=c+32|0;break a}a=N()|0;break b}a=N()|0;Ub(c+20|0)}tb(c+8|0);Q(a|0);p()}x[31609]=0;P(960,a|0,e|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){tb(e);fb=d+16|0;return}a=N()|0;tb(d+4|0);Q(a|0);p()}function DT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=fb-16|0;fb=d;j=d,k=Rj(b),x[j+4>>2]=k;c=fb-16|0;fb=c;g=fB(a,c+12|0,y[b|0],x[b+4>>2]);b=x[g>>2];if(!b){e=fb-16|0;fb=e;b=gc(a);h=Dh(c,Ec(28),Og(e+8|0,b));b=x[h>>2];f=x[d+4>>2];i=x[f>>2];f=x[f+4>>2];x[b+24>>2]=0;x[b+16>>2]=i;x[b+20>>2]=f;j=gc(h),k=1,v[j+4|0]=k;fb=e+16|0;$g(a,x[c+12>>2],g,x[c>>2]);b=ne(c);Jk(c);e=1}_g(d+8|0,x[vb(c,b)>>2],e);fb=c+16|0;a=ud(x[d+8>>2]);fb=d+16|0;return a+8|0}function CK(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;a:{if((a|0)!=(b|0)){b:{c:{f=y[a|0];if((f|0)!=45){break c}a=a+1|0;if((b|0)!=(a|0)){break c}break b}h=x[31484];x[31484]=0;Od();a=Iy(a,e+12|0,d);d=hb;d:{g=x[31484];if(g){if(x[e+12>>2]!=(b|0)){break b}if((g|0)!=68){break d}x[c>>2]=4;a=-1;b=-1;break a}x[31484]=h;if(x[e+12>>2]==(b|0)){break d}break b}b=a;c=(f|0)==45;a=c?0-b|0:b;b=c?0-(d+((b|0)!=0)|0)|0:d;break a}}x[c>>2]=4;a=0;b=0}fb=e+16|0;hb=b;return a}function YU(a,b,c,d){var e=0,f=0,g=0,h=0;h=fb-16|0;fb=h;g=x[a+4>>2];e=(g-d|0)+b|0;f=dj(h+4|0,a,c-e>>1);d=x[f+4>>2];a=e;while(1){if(a>>>0>=c>>>0){kc(f);c=fb-16|0;fb=c;a=fb-32|0;fb=a;fd(a+24|0,b,e);b=fb-16|0;fb=b;d=x[a+28>>2];e=x[a+24>>2];f=d-e|0;g=g-f|0;x[b+12>>2]=g;$U(g,e,f>>1);rc(a+16|0,d,b+12|0);fb=b+16|0;b=x[a+16>>2];x[a+12>>2]=x[a+20>>2];rc(c+8|0,b,a+12|0);fb=a+32|0;fb=c+16|0;fb=h+16|0}else{nm(d,z[a>>1]);d=d+2|0;x[f+4>>2]=d;a=a+2|0;continue}break}}function rI(a,b,c,d,e,f,g,h){var i=0,j=0,k=0;i=fb-16|0;fb=i;if(1073741806-b>>>0>=c>>>0){k=Kb(a);j=i+4|0;if(b>>>0<=536870886){x[i+12>>2]=b<<1;x[i+4>>2]=b+c;c=sn(x[bd(j,i+12|0)>>2])+1|0}else{c=1073741807}Oj(j,c);c=x[i+4>>2];if(e){Ti(c,k,e)}if(g){Ti(c+(e<<2)|0,h,g)}j=e+f|0;h=d-j|0;if((d|0)!=(j|0)){d=e<<2;Ti((d+c|0)+(g<<2)|0,(d+k|0)+(f<<2)|0,h)}if((b|0)!=1){Db(k)}yd(a,c);of(a,x[i+8>>2]);b=a;a=h+(e+g|0)|0;Bd(b,a);yd(c+(a<<2)|0,0);fb=i+16|0;return}pf();p()}function D9(){var a=0,b=0,c=0,d=0,e=0,f=0;c=fb-48|0;fb=c;if(FL(1,c+24|0)){It(x[31484],12795);p()}b=ye(c+16|0,x[c+24>>2],x[c+28>>2]);f=ZA(c+8|0,x[c+32>>2]);d=fb-16|0;fb=d;e=fb-16|0;fb=e;a=ye(e+8|0,Iua(x[b>>2],x[b+4>>2],1e9,0),hb);b=x[a>>2];a=x[a+4>>2];fb=e+16|0;x[d>>2]=b;x[d+4>>2]=a;a=x[d>>2];e=a+x[f>>2]|0;f=x[f+4>>2]+x[d+4>>2]|0;b=ye(d+8|0,e,a>>>0>e>>>0?f+1|0:f);a=x[b>>2];fb=d+16|0;b=ye(c+40|0,a,x[b+4>>2]);a=x[b>>2];fb=c+48|0;hb=x[b+4>>2];return a|0}function fna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=fb-16|0;fb=b;h=x[a+24>>2];i=x[a+20>>2];j=x[a+16>>2];f=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=f;f=x[a+8>>2];k=x[a+12>>2];while(1){if(d){g=x[b+12>>2]+j|0;e=v[g|0];e=((D(v[g+1|0]-e|0,x[b+8>>2]>>>10&4194048)|0)/16384|0)+(e<<8)|0;x[c>>2]=x[c>>2]+D(e,i);x[c+4>>2]=x[c+4>>2]+D(e,h);Pb(b+8|0,f,k);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;fb=b+16|0}function _E(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=x[a>>2];c=$c(d,x[a+4>>2]);if(c>>>0<b>>>0){e=fb-32|0;fb=e;b=b-c|0;c=x[Ab(a)>>2];d=x[a+4>>2];a:{if(b>>>0<=c-d>>1>>>0){RE(a,b);break a}c=Ab(a);c=fk(e+12|0,gk(a,$c(x[a>>2],d)+b|0),$c(x[a>>2],x[a+4>>2]),c);f=fb-16|0;fb=f;b=Ap(f+4|0,c+8|0,b);d=x[b>>2];while(1){if(x[b+4>>2]!=(d|0)){_w(d);d=x[b>>2]+2|0;x[b>>2]=d;continue}break}je(b);fb=f+16|0;Sr(a,c);cj(c)}fb=e+32|0;return}if(b>>>0<c>>>0){Jd(a,d+(b<<1)|0)}}function Baa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;f=fb-16|0;fb=f;d=fb-32|0;fb=d;fd(d+24|0,a,b);h=d+16|0;e=x[d+24>>2];g=x[d+28>>2];b=fb-16|0;fb=b;x[b+12>>2]=c;a:{while(1){if((e|0)==(g|0)){break a}c=Dc(b,x[e>>2]);x[31609]=0;P(1193,b+12|0,c|0)|0;i=x[31609];x[31609]=0;if((i|0)!=1){tb(c);e=e+4|0;continue}break}a=N()|0;tb(c);Q(a|0);p()}rc(h,g,b+12|0);fb=b+16|0;b=x[d+16>>2];x[d+12>>2]=x[d+20>>2];rc(f+8|0,lA(a,b),d+12|0);fb=d+32|0;fb=f+16|0}function qV(a,b,c,d,e){var f=0,g=0,h=0;h=-1;g=d&2147483647;f=(g|0)==2147418112;a:{if(f&!c?a|b:f&(c|0)!=0|g>>>0>2147418112){break a}f=e&2147483647;if(((f|0)==2147418112&0|f>>>0>2147418112)&(f|0)!=2147418112){break a}if(!(a|c|(f|g|b))){return 0}f=d&e;if((f|0)>0){f=1}else{f=(f|0)>=0}if(f){if(((c|0)!=0|(d|0)!=(e|0))&(d|0)<(e|0)){break a}return(a|c|(d^e|b))!=0}if(!c&(d|0)==(e|0)?a|b:(c|0)!=0&(d|0)>=(e|0)|(d|0)>(e|0)){break a}h=(a|c|(d^e|b))!=0}return h}function rta(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);f=d+8|0;Rd(f,x[vb(d+4|0,a)>>2]);x[31609]=0;W(344,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){g=fb-16|0;fb=g;b=g+4|0;x[b>>2]=a;e=x[a+4>>2];x[b+4>>2]=e;x[b+8>>2]=e+32768;c=x[b+4>>2];e=x[b+8>>2];while(1){if((c|0)==(e|0)){kc(b);fb=g+16|0}else{w[c>>1]=0;w[c+2>>1]=0;c=c+4|0;x[b+4>>2]=c;continue}break}Qd(f);bh(f);fb=d+16|0;return a|0}a=N()|0;bh(d+8|0);Q(a|0);p()}function aaa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;g=fb-32|0;fb=g;e=x[b+276>>2];ig(x[x[e>>2]-12>>2]+e|0,0);ae(g+16|0,x[b+276>>2]);f=ci(g,-1,-1);e=x[g+24>>2];h=x[g+28>>2];a:{if(!ao(e,h,x[f+8>>2],x[f+12>>2])){b:{if((c|0)!=(e|0)|h){break b}break a}}Di(x[b+276>>2],c,0,0)}e=x[d>>2];d=x[d+4>>2];c=0;while(1){if(d){f=x[b+276>>2];h=uh(d);wj(f,c+e|0,h);f=x[x[b+276>>2]+4>>2];d=d-f|0;c=c+f|0;if((f|0)==(h|0)){continue}}break}cc(a,e,c);fb=g+32|0}function __(a,b,c,d){var e=0,f=0,g=0,h=0;h=fb-16|0;fb=h;g=x[a+4>>2];e=(g-d|0)+b|0;f=Xo(h+4|0,a,c-e|0);d=x[f+4>>2];a=e;while(1){if(a>>>0>=c>>>0){kc(f);c=fb-16|0;fb=c;a=fb-32|0;fb=a;fd(a+24|0,b,e);b=fb-16|0;fb=b;d=x[a+28>>2];e=x[a+24>>2];f=d-e|0;g=g-f|0;x[b+12>>2]=g;bC(g,e,f);rc(a+16|0,d,b+12|0);fb=b+16|0;b=x[a+16>>2];x[a+12>>2]=x[a+20>>2];rc(c+8|0,b,a+12|0);fb=a+32|0;fb=c+16|0;fb=h+16|0}else{po(d,y[a|0]);d=d+1|0;x[f+4>>2]=d;a=a+1|0;continue}break}}function b9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=fb-32|0;fb=d;x[d+16>>2]=b;e=x[a+48>>2];x[d+20>>2]=c-((e|0)!=0);g=x[a+44>>2];x[d+28>>2]=e;x[d+24>>2]=g;a:{b:{if(_y(cb(x[a+60>>2],d+16|0,2,d+12|0)|0)){b=32}else{e=x[d+12>>2];if((e|0)>0){break b}b=e?32:16}x[a>>2]=b|x[a>>2];break a}f=e;g=x[d+20>>2];if(g>>>0>=e>>>0){break a}f=x[a+44>>2];x[a+4>>2]=f;x[a+8>>2]=f+(e-g|0);if(x[a+48>>2]){x[a+4>>2]=f+1;v[(b+c|0)-1|0]=y[f|0]}f=c}fb=d+32|0;return f|0}function Fua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;a:{b:{if(!jh(a,7)){break b}c=0;if(!PE(a,18456)){break a}if(!jh(a,1)){break b}c=-1;if(!id(a,Jr(a))){break a}c=fb-16|0;fb=c;f=d+9|0;Ir(c+8|0,f);e=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(e|0)){id(a,x[c+12>>2])}fb=c+16|0;e=(e|0)==(g|0);if(!e){GE(f)}c=-1;if(!e){break a}c=0;if(!H0(y[d+9|0],y[d+10|0])){break a}c=xe(a,b,G0(f),hb);break a}c=-1}fb=d+16|0;return c|0}function ena(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=fb-16|0;fb=b;g=x[a+24>>2];h=x[a+20>>2];i=x[a+16>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;j=x[a+8>>2];k=x[a+12>>2];while(1){if(d){e=(x[b+12>>2]<<1)+i|0;f=w[e>>1];e=f+((D(w[e+2>>1]-f|0,x[b+8>>2]>>>18|0)|0)/16384|0)|0;x[c>>2]=x[c>>2]+D(e,h);x[c+4>>2]=x[c+4>>2]+D(e,g);Pb(b+8|0,j,k);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;fb=b+16|0}function eka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;d=w[a+30>>1];if(d){b=iA(b<<16>>16,d)}w[e+14>>1]=b;a=a+52|0;a:{if(!Ad(x[c+4>>2],y[c+11|0])){ps(_Q(a,e+14|0),c);break a}b=jA(a,e+14|0);if(!Zg(b,Pf(a))){break a}c=fb-16|0;fb=c;b=x[vb(c+8|0,b)>>2];d=fb-16|0;fb=d;f=ah(vb(d+12|0,b));if((b|0)==x[a>>2]){x[a>>2]=x[f>>2]}g=Ab(a);x[g>>2]=x[g>>2]-1;iV(x[gc(a)>>2],b);a=x[f>>2];fb=d+16|0;Qj(ud(b));Db(b);vb(c+12|0,a);fb=c+16|0}fb=e+16|0}function _G(a,b,c,d,e){var f=0,g=0,h=0;a:{g=fb-32|0;fb=g;h=Nb(a);b:{c:{d:{e:{while(1){a=x[b+8>>2];f=x[b>>2];x[31609]=0;a=U(150,f|0,a|0,8)|0;f=x[31609];x[31609]=0;if((f|0)==1){break c}if(!a){break d}x[31609]=0;a=g+4|0;S(e|0,a|0,b|0,c|0);f=x[31609];x[31609]=0;if((f|0)!=1){x[31609]=0;O(d|0,h|0,a|0);f=x[31609];x[31609]=0;if((f|0)==1){break e}Hd(a);continue}break}a=N()|0;break b}a=N()|0;Hd(g+4|0);break b}fb=g+32|0;break a}a=N()|0}ke(h);Q(a|0);p()}}function Dfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=fb-32|0;fb=e;x[e+28>>2]=c;c=e+28|0;f=x[re(e+24|0,c)>>2];x[31609]=0;g=x[b+12>>2];x[e+16>>2]=x[b+8>>2];x[e+20>>2]=g;g=x[b+4>>2];x[e+8>>2]=x[b>>2];x[e+12>>2]=g;ba(990,a+8|0,e+8|0,f|0,d|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){a=Gz(a);b=Fz(a+88|0);d=Ez(a+92|0);f=Dz(a+96|0);x[a>>2]=47708;x[b>>2]=47824;x[d>>2]=47904;x[f>>2]=47944;Wc(c);fb=e+32|0;return a|0}a=N()|0;Wc(e+28|0);Q(a|0);p()}function e4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=fb-32|0;fb=f;g=dq(f+20|0,b,c);x[31609]=0;e=U(1385,f+8|0,d|0,e|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){c=Kb(g);d=Kb(e);a=x[d>>2];b=x[c>>2];a:{if(!a|!b|(a|0)!=(b|0)){break a}while(1){a=x[d+4>>2];b=x[c+4>>2];if(!a|!b){break a}d=d+4|0;c=c+4|0;if((a|0)==(b|0)){continue}break}}Ub(e);Ub(g);fb=f+32|0;a=(a|0)>(b|0)?-1:(a|0)<(b|0);return((a|0)<0?-1:(a|0)!=0)|0}a=N()|0;Ub(g);Q(a|0);p()}function Up(a,b,c,d,e){var f=0,g=0,h=0;a:{g=fb-32|0;fb=g;h=Nb(a);b:{c:{d:{e:{while(1){a=x[b+8>>2];f=x[b>>2];x[31609]=0;a=U(150,f|0,a|0,e|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break c}if(!a){break d}x[31609]=0;a=g+4|0;O(d|0,a|0,b|0);f=x[31609];x[31609]=0;if((f|0)!=1){x[31609]=0;O(c|0,h|0,a|0);f=x[31609];x[31609]=0;if((f|0)==1){break e}Hd(a);continue}break}a=N()|0;break b}a=N()|0;Hd(g+4|0);break b}fb=g+32|0;break a}a=N()|0}ke(h);Q(a|0);p()}}function Kk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=x[a>>2];c=Xc(d,x[a+4>>2]);if(c>>>0<b>>>0){e=fb-32|0;fb=e;b=b-c|0;c=x[Ab(a)>>2];d=x[a+4>>2];a:{if(b>>>0<=c-d>>>0){QX(a,b);break a}c=Ab(a);c=qn(e+12|0,Wl(a,Xc(x[a>>2],d)+b|0),Xc(x[a>>2],x[a+4>>2]),c);f=fb-16|0;fb=f;b=BC(f+4|0,c+8|0,b);d=x[b>>2];while(1){if(x[b+4>>2]!=(d|0)){tX(d);d=x[b>>2]+1|0;x[b>>2]=d;continue}break}je(b);fb=f+16|0;cr(a,c);pn(c)}fb=e+32|0;return}if(b>>>0<c>>>0){Jd(a,b+d|0)}}function K2(a,b){a=a|0;b=b|0;var c=0;a=Fb(a);a:{if(y[b+16|0]){x[31609]=0;P(127,a|0,4945)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}}if(y[b+17|0]){x[31609]=0;P(127,a|0,12624)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}}if(Ad(x[a+4>>2],y[a+11|0])){x[31609]=0;P(127,a|0,10083)|0;c=x[31609];x[31609]=0;if((c|0)==1){break a}}if(y[b+18|0]){x[31609]=0;P(127,a|0,11143)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}}return}b=N()|0;tb(a);Q(b|0);p()}function sc(a,b){var c=0,d=0,e=0;c=x[a+1396>>2];if((c|0)>=0){a:{b:{if((b|0)<=(c|0)){break b}if((b|0)>24){return sc(a,24)+(sc(a,b-24|0)<<24)|0}if(!c){x[a+1392>>2]=0}while(1){if((b|0)<=(c|0)){break b}c=-1;e=Rt(a);d=0;if((e|0)==-1){break a}d=x[a+1396>>2];c=d+8|0;x[a+1396>>2]=c;x[a+1392>>2]=x[a+1392>>2]+(e<<d);continue}}if((b|0)>(c|0)){_(10093,13274,1632,6865);p()}d=x[a+1392>>2];x[a+1392>>2]=d>>>b;c=c-b|0;d=d&(-1<<b^-1)}x[a+1396>>2]=c}return d}function iu(a){var b=0,c=0,d=0,e=0;a:{while(1){if(!a){b=0;if(x[31480]){b=iu(x[31480])}if(!x[31406]){break a}c=b|c;a=x[31406];continue}break}d=x[a+76>>2]<0;b:{c:{if(x[a+20>>2]==x[a+28>>2]){break c}ib[x[a+36>>2]](a,0,0)|0;if(x[a+20>>2]){break c}b=-1;if(!d){break b}break a}b=x[a+8>>2];e=x[a+4>>2];if((b|0)!=(e|0)){b=e-b|0;ib[x[a+40>>2]](a,b,b>>31,1)|0}b=0;x[a+28>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+4>>2]=0;x[a+8>>2]=0;if(d){break a}}}return b|c}function Rsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(d+8|0,x[vb(d+4|0,a)>>2]);a:{if(b){x[31609]=0;O(374,a|0,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break a}f=fb-16|0;fb=f;e=dj(f+4|0,a,b);b=x[e+4>>2];g=x[e+8>>2];while(1){if((b|0)==(g|0)){kc(e);fb=f+16|0}else{bj(b,y[c|0]|y[c+1|0]<<8);b=b+2|0;x[e+4>>2]=b;continue}break}}b=d+8|0;Qd(b);Sj(b);fb=d+16|0;return a|0}a=N()|0;Sj(d+8|0);Q(a|0);p()}function BR(a,b,c,d,e,f,g,h){var i=0,j=0;i=fb-16|0;fb=i;x[i+12>>2]=d;a:{if(!(y[a+12|0]|y[a+13|0]<<8|(y[a+14|0]<<16|y[a+15|0]<<24))){break a}x[i+8>>2]=y[a+8|0]|y[a+9|0]<<8|(y[a+10|0]<<16|y[a+11|0]<<24);j=b;b=x[Hb(i+8|0,i+12|0)>>2];x[j>>2]=b;b=Ld(y[a+12|0]|y[a+13|0]<<8|(y[a+14|0]<<16|y[a+15|0]<<24),b,d);x[c>>2]=((h^1)&b>>>0<d>>>0)+b;b=z[e>>1]|f;w[e>>1]=b;if((y[a+4|0]|y[a+5|0]<<8|(y[a+6|0]<<16|y[a+7|0]<<24))!=1){break a}w[e>>1]=b|g}fb=i+16|0}function Jt(a,b){a:{if(a){if(b>>>0<=127){break a}b:{if(!x[x[124115]>>2]){if((b&-128)==57216){break a}break b}if(b>>>0<=2047){v[a+1|0]=b&63|128;v[a|0]=b>>>6|192;return 2}if(!((b&-8192)!=57344&b>>>0>=55296)){v[a+2|0]=b&63|128;v[a|0]=b>>>12|224;v[a+1|0]=b>>>6&63|128;return 3}if(b-65536>>>0<=1048575){v[a+3|0]=b&63|128;v[a|0]=b>>>18|240;v[a+2|0]=b>>>6&63|128;v[a+1|0]=b>>>12&63|128;return 4}}x[31484]=25;a=-1}else{a=1}return a}v[a|0]=b;return 1}function hoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=fb-16|0;fb=c;d=Zc(c+12|0,16,1,1,0);x[c+8>>2]=0;nd(a,0);yc(b);a:{b:{if(Nr(b,13883)){dd(b,12);if(!np(b)){vp(d,2)}dd(b,24);break b}if(bk(b,13770)){yc(b);x[c+8>>2]=4;e=1;break a}hd(d,8)}e=0}f=a,g=(jf(b)>>>0)/(D(y[d|0],ir(y[d+1|0]))>>>3>>>0)|0,x[f>>2]=g;b=dg(d,a,b);if(!(!b|!e)){d=x[a+20>>2];f=c,g=Rk(x[a>>2],z[a+34>>1]),x[f+4>>2]=g;Rb(d,0,x[Hb(c+8|0,c+4|0)>>2])}fb=c+16|0;return(b|0)!=0|0}function fZ(a,b){var c=0,d=0,e=0,f=0;d=x[a>>2];c=oc(d,x[a+4>>2]);if(c>>>0<b>>>0){e=fb-32|0;fb=e;b=b-c|0;c=x[Ab(a)>>2];d=x[a+4>>2];a:{if(b>>>0<=c-d>>2>>>0){oD(a,b);break a}c=Ab(a);c=Zf(e+12|0,Mf(a,oc(x[a>>2],d)+b|0),oc(x[a>>2],x[a+4>>2]),c);f=fb-16|0;fb=f;b=Gn(f+4|0,c+8|0,b);d=x[b>>2];while(1){if(x[b+4>>2]!=(d|0)){Dn(d);d=x[b>>2]+4|0;x[b>>2]=d;continue}break}je(b);fb=f+16|0;dZ(a,c);Yf(c)}fb=e+32|0;return}if(b>>>0<c>>>0){Jd(a,d+(b<<2)|0)}}function ZT(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=fb-16|0;fb=e;j=e,k=Rj(b),x[j+4>>2]=k;c=fb-16|0;fb=c;f=KB(a,c+12|0,z[b>>1],x[b+4>>2]);b=x[f>>2];if(!b){b=fb-16|0;fb=b;d=gc(a);g=Dh(c,Ec(36),Og(b+8|0,d));d=x[g>>2]+16|0;h=x[e+4>>2];i=x[h+4>>2];x[d>>2]=x[h>>2];x[d+4>>2]=i;Nb(d+8|0);j=gc(g),k=1,v[j+4|0]=k;fb=b+16|0;$g(a,x[c+12>>2],f,x[c>>2]);b=ne(c);cU(c);d=1}_g(e+8|0,x[vb(c,b)>>2],d);fb=c+16|0;a=ud(x[e+8>>2]);fb=e+16|0;return a+8|0}function ufa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0;x[31609]=0;W(1021,a|0);f=x[31609];x[31609]=0;a:{b:{if((f|0)!=1){f=x[a+28>>2];g=x[x[f>>2]+72>>2];x[31609]=0;b=Ta(g|0,f|0,b|0,c|0,+d,+e)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,11314,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();b=-1}return b|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function G5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;if((a|0)!=(b|0)){c=x[b>>2];d=x[b+4>>2];b=Sd(c,d);e=fb-16|0;fb=e;a:{if(Vg(a)>>>0>=b>>>0){f=x[a>>2];g=oc(f,x[a+4>>2]);if(b>>>0>g>>>0){h=c;c=fD(c,g);tA(h,c,f);xq(a,c,d,b-oc(x[a>>2],x[a+4>>2])|0);break a}Hv(e+8|0,c,d,f);Jd(a,x[e+12>>2]);break a}if(x[a>>2]){Nc(a);ny(ht(a),x[a>>2],Vg(a));i=Ab(a),j=0,x[i>>2]=j;x[a>>2]=0;x[a+4>>2]=0}GJ(a,Mf(a,b));xq(a,c,d,b)}fb=e+16|0}return a|0}function waa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;f=fb-16|0;fb=f;e=f+4|0;x[e+4>>2]=1;h=e,i=Ec(56),x[h+8>>2]=i;c=tm(x[e+8>>2]);x[c>>2]=77232;g=nc(c);c=fb-16|0;fb=c;d=x[b+12>>2];x[c+8>>2]=x[b+8>>2];x[c+12>>2]=d;d=x[b+4>>2];x[c>>2]=x[b>>2];x[c+4>>2]=d;d=wM(g);x[d>>2]=77396;b=x[c+4>>2];x[d+24>>2]=x[c>>2];x[d+28>>2]=b;b=x[c+12>>2];x[d+32>>2]=x[c+8>>2];x[d+36>>2]=b;v[d+40|0]=0;fb=c+16|0;b=a;a=Sn(e);Rn(b,nc(a),a);um(e);fb=f+16|0}function pl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=fb-16|0;fb=e;x[b>>2]=0;x[b+4>>2]=0;v[e+15|0]=0;ii(a,e+15|0);c=y[e+15|0];f=(c&252)>>>2|0;i=-1<<(c&3)^-1;while(1){x[b>>2]=f;x[b+4>>2]=d;if(!h&(g|0)==(i|0)){fb=e+16|0}else{v[e+15|0]=0;ii(a,e+15|0);d=x[b>>2];j=x[b+4>>2];f=y[e+15|0];c=h;g=g+1|0;h=g?c:c+1|0;k=d;c=(g<<3)-2|0;d=c&31;if((c&63)>>>0>=32){c=f<<d;d=0}else{c=(1<<d)-1&f>>>32-d;d=f<<d}f=k|d;d=c|j;continue}break}}function Xu(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=NB(x[a+24>>2],y[a+32|0]);g=Ij(i);j=65535;a:{while(1){if((d|0)==(g|0)){d=g;a=-1;break a}b:{c:{if(!Yi(i,d&65535)){break c}e=x[a>>2];if(Ud(e,x[a+4>>2])>>>0<=d>>>0){break b}f=0;h=Vd(e,d);while(1){d:{e=x[h+4>>2];if(e>>>0>f>>>0){if(!EC(x[h>>2],f)){break d}e=x[h+4>>2]}if((f|0)==(e|0)){break b}break c}f=f+1|0;continue}}d=d+1|0;continue}break}j=d;a=0}w[b>>1]=j;x[c>>2]=a;return d>>>0<g>>>0}function Ala(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=x[a>>2];d=Mg(e,x[a+4>>2]);if(d>>>0<b>>>0){e=fb-32|0;fb=e;a:{b:{d=b-d|0;b=x[Ab(a)>>2];f=x[a+4>>2];c:{if(d>>>0<=b-f>>5>>>0){_B(a,d,c);break c}b=Ab(a);b=iv(e+12|0,Vq(a,Mg(x[a>>2],f)+d|0),Mg(x[a>>2],x[a+4>>2]),b);x[31609]=0;S(785,b|0,d|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}SU(a,b);YB(b)}fb=e+32|0;break a}a=N()|0;YB(b);Q(a|0);p()}return}if(b>>>0<d>>>0){TU(a,e+(b<<5)|0)}}function Nf(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0;i=Iua(b,c,h,i);h=hb;e=Iua(d,e,f,g);i=e+i|0;d=hb+h|0;h=e>>>0>i>>>0?d+1|0:d;j=g;e=0;k=c;d=0;c=Iua(g,e,c,d);g=c+i|0;i=hb+h|0;l=g;c=c>>>0>g>>>0?i+1|0:i;g=Iua(f,0,b,0);h=hb;i=0;d=Iua(f,i,k,d);h=h+d|0;f=hb+i|0;f=d>>>0>h>>>0?f+1|0:f;i=f+l|0;d=c;f=f>>>0>i>>>0?d+1|0:d;b=Iua(b,m,j,e)+h|0;e=hb;e=b>>>0<h>>>0?e+1|0:e;h=e+i|0;i=f;x[a+8>>2]=h;x[a+12>>2]=e>>>0>h>>>0?i+1|0:i;x[a>>2]=g;x[a+4>>2]=b}function Jz(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;b=fb-48|0;fb=b;x[b+40>>2]=e;x[b+44>>2]=f;c=Zb(b+32|0,c,d);d=x[c+4>>2];x[b+8>>2]=x[c>>2];x[b+12>>2]=d;a:{a=Au(a,b+8|0,b+40|0);if(a+1>>>0>=3){a=ac(8);x[31609]=0;b=P(36,b+20|0,8057)|0;c=x[31609];x[31609]=0;b:{if((c|0)!=1){pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}c=N()|0;tb(b);break b}c=N()|0;ic(a)}Q(c|0);p()}fb=b+48|0;return a|0}p()}function una(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;b=fb-16|0;fb=b;h=x[a+16>>2];f=kg(1,2);e=hb;i=e;Pb(a,f,e);j=x[a+24>>2];k=x[a+20>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;e=x[a+8>>2];l=x[a+12>>2];while(1){if(d){g=w[(x[b+12>>2]<<1)+h>>1];x[c>>2]=x[c>>2]+D(g,k);x[c+4>>2]=x[c+4>>2]+D(j,g);Pb(b+8|0,e,l);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;Ig(a,f,i);fb=b+16|0}function s$(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=x[a+1064>>2];a:{while(1){if((b|0)>255){break a}f=(D(b,6)+a|0)+1072|0,g=bl(a,7),v[f|0]=g;d=bl(a,1);e=bl(a,1);c=x[a+1060>>2];if((c|0)>255){break a}b=x[a+1064>>2]+1|0;x[a+1060>>2]=b;x[a+1064>>2]=b;b:{if(d){w[(D(c,6)+a|0)+1068>>1]=b;s$(a);b=x[a+1064>>2];break b}w[(D(c,6)+a|0)+1068>>1]=65535}x[a+1060>>2]=b;if(e){w[(D(c,6)+a|0)+1070>>1]=b;continue}break}w[(D(c,6)+a|0)+1070>>1]=65535}}function yfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;x[31609]=0;W(1021,a|0);e=x[31609];x[31609]=0;a:{b:{if((e|0)!=1){e=x[a+28>>2];f=x[x[e>>2]+12>>2];x[31609]=0;b=ba(f|0,e|0,b|0,c|0,d|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,11459,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();b=-1}return b|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function woa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=fb-4096|0;fb=d;kn(a,b);while(1){if(Xc(x[a>>2],x[a+4>>2])>>>12>>>0>f>>>0){g=f<<12;b=0;c=0;e=0;while(1){if((c|0)!=2048){h=xb(x[a>>2],c|g);i=xb(d,c<<1|1);e=y[h|0]+e|0;v[i|0]=e;c=c+1|0;continue}break}while(1){if((b|0)!=2048){c=xb(x[a>>2],b|g|2048);h=xb(d,b<<1);e=y[c|0]+e|0;v[h|0]=e;b=b+1|0;continue}break}rv(d,wC(d),uf(wb(x[a>>2]),g));f=f+1|0;continue}break}fb=d+4096|0}function hu(a,b){var c=0,d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;c=de(a);d=gc(a);f=fb-16|0;fb=f;while(1){if(c){g=Uu(c+16|0,b);d=g?d:c;c=x[(g?c+4|0:c)>>2];continue}break}c=x[vb(f+12|0,d)>>2];fb=f+16|0;a:{if(Ib(c,pg(a))){if(!Uu(b,ud(c))){break a}}c=pg(a)}if(!mc(c,pg(a))){b=x[vb(e+12|0,c)>>2];c=fb-16|0;fb=c;d=ah(vb(c+12|0,b));if((b|0)==x[a>>2]){x[a>>2]=x[d>>2]}d=Ab(a);x[d>>2]=x[d>>2]-1;iV(x[gc(a)>>2],b);fb=c+16|0;an(ud(b));Db(b)}fb=e+16|0}function xfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;x[31609]=0;W(1021,a|0);e=x[31609];x[31609]=0;a:{b:{if((e|0)!=1){e=x[a+28>>2];f=x[x[e>>2]+8>>2];x[31609]=0;b=ba(f|0,e|0,b|0,c|0,d|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,11495,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();b=-1}return b|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Yp(a,b,c,d,e,f,g,h){var i=0,j=0,k=0;i=fb-16|0;fb=i;if(2147483630-b>>>0>=c>>>0){k=Kb(a);j=i+4|0;if(b>>>0<=1073741798){x[i+12>>2]=b<<1;x[i+4>>2]=b+c;c=Fh(x[bd(j,i+12|0)>>2])+1|0}else{c=2147483631}qg(j,c);c=x[i+4>>2];if(e){Dg(c,k,e)}if(g){Dg(c+e|0,h,g)}j=e+f|0;h=d-j|0;if((d|0)!=(j|0)){Dg((c+e|0)+g|0,(e+k|0)+f|0,h)}if((b|0)!=10){Db(k)}yd(a,c);of(a,x[i+8>>2]);b=a;a=h+(e+g|0)|0;Bd(b,a);hd(a+c|0,0);fb=i+16|0;return}pf();p()}function Sq(a,b,c,d,e,f,g,h){var i=0,j=0,k=0;i=fb-16|0;fb=i;if(2147483630-b>>>0>=c>>>0){k=Kb(a);j=i+4|0;if(b>>>0<=1073741798){x[i+12>>2]=b<<1;x[i+4>>2]=b+c;c=Fh(x[bd(j,i+12|0)>>2])+1|0}else{c=2147483631}qg(j,c);c=x[i+4>>2];if(e){Xg(c,k,e)}if(g){Xg(c+e|0,h,g)}j=e+f|0;h=d-j|0;if((d|0)!=(j|0)){Xg((c+e|0)+g|0,(e+k|0)+f|0,h)}if((b|0)!=10){Db(k)}yd(a,c);of(a,x[i+8>>2]);b=a;a=h+(e+g|0)|0;Bd(b,a);hd(a+c|0,0);fb=i+16|0;return}pf();p()}function Nr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=fb-32|0;fb=c;a:{if(!y[b+7|0]){while(1){if((d|0)==7){d=0;v[c+27|0]=0;v[c+28|0]=0;v[c+29|0]=0;v[c+30|0]=0;x[c+24>>2]=0;e=c+24|0;f=Zb(c+8|0,e,7);lc(c+16|0,x[a>>2],x[a+8>>2],x[f>>2],x[f+4>>2]);b:{if(x[c+20>>2]!=7){break b}if(jd(e,b,7)){break b}Vb(a,7);d=1}fb=c+32|0;break a}e=b+d|0;d=d+1|0;if(y[e|0]){continue}break}_(17516,9095,602,13238);p()}_(17495,9095,600,13238);p()}return d|0}function DK(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;a:{b:{if((a|0)!=(b|0)){c:{d:{f=y[a|0];if((f|0)!=45){break d}a=a+1|0;if((b|0)!=(a|0)){break d}break c}h=x[31484];x[31484]=0;Od();a=Iy(a,e+12|0,d);d=hb;g=x[31484];e:{if(g){if(x[e+12>>2]!=(b|0)){break c}if((g|0)==68|d){break e}break b}x[31484]=h;if(x[e+12>>2]!=(b|0)){break c}if(!d){break b}}x[c>>2]=4;a=-1;break a}}x[c>>2]=4;a=0;break a}a=(f|0)==45?0-a|0:a}fb=e+16|0;return a}function vna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;b=fb-16|0;fb=b;h=x[a+16>>2];f=kg(1,2);e=hb;i=e;Pb(a,f,e);j=x[a+24>>2];k=x[a+20>>2];e=x[a+4>>2];x[b+8>>2]=x[a>>2];x[b+12>>2]=e;e=x[a+8>>2];l=x[a+12>>2];while(1){if(d){g=v[x[b+12>>2]+h|0]<<8;x[c>>2]=x[c>>2]+D(g,k);x[c+4>>2]=x[c+4>>2]+D(j,g);Pb(b+8|0,e,l);c=c+8|0;d=d-1|0;continue}break}c=x[b+12>>2];x[a>>2]=x[b+8>>2];x[a+4>>2]=c;Ig(a,f,i);fb=b+16|0}function ic(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0;a:{d=jl(a);a=d;if(a>>>0<502256&a>>>0>=501744){b=a-4|0;e=x[125432];c=e;while(1){a=c;if(!(!a|(a|0)==502256)){if((nI(a)|0)==(b|0)){w[a+2>>1]=z[d-2>>1]+z[a+2>>1];break a}if((nI(b)|0)==(a|0)){c=d-2|0;w[c>>1]=z[a+2>>1]+z[c>>1];if(!f){x[125432]=b;w[b>>1]=z[a>>1];break a}g=f,h=Xx(b),w[g>>1]=h;break a}else{c=Yx(z[a>>1]);f=a;continue}}break}g=b,h=Xx(e),w[g>>1]=h;x[125432]=b;break a}Db(d)}}function PK(a,b){var c=0,d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;g=x[124115];if(x[b+72>>2]<=0){My(b)}x[124115]=x[b+136>>2];c=-1;if(x[b+4>>2]){d=0}else{zt(b);d=!x[b+4>>2]}a:{if(d|(a|0)==-1){break a}d=Jt(e+12|0,a);if((d|0)<0){break a}f=x[b+4>>2];if(f>>>0<(x[b+44>>2]+d|0)-8>>>0){break a}b:{if(a>>>0<=127){c=f-1|0;x[b+4>>2]=c;v[c|0]=a;break b}c=f-d|0;x[b+4>>2]=c;zc(c,e+12|0,d)}x[b>>2]=x[b>>2]&-17;c=a}x[124115]=g;fb=e+16|0;return(c|0)!=-1}function GW(a){var b=0,c=0,d=0;b=fb-16|0;fb=b;x[b+4>>2]=((y[a+48|0]|y[a+49|0]<<8)<<1)+((y[a+32|0]|y[a+33|0]<<8)<<4);x[b+8>>2]=((y[a+50|0]|y[a+51|0]<<8)<<1)+((y[a+34|0]|y[a+35|0]<<8)<<4);x[b+12>>2]=(D(y[a+52|0]|y[a+53|0]<<8,5)+((y[a+36|0]|y[a+37|0]<<8)<<4)|0)+32;a=b+4|0;d=yb(a,3);a:{if((a|0)==(d|0)){break a}c=a;while(1){c=c+4|0;if((d|0)==(c|0)){break a}a=Yq(x[a>>2],x[c>>2])?c:a;continue}}fb=b+16|0;a=x[a>>2];hb=a>>31;return a}function sfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;x[31609]=0;W(1021,a|0);d=x[31609];x[31609]=0;e=1;a:{b:{if((d|0)!=1){d=x[a+28>>2];f=x[x[d>>2]+64>>2];x[31609]=0;S(f|0,d|0,b|0,(c|0)!=0|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,6695,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();e=0}return e|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function qfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;x[31609]=0;W(1021,a|0);d=x[31609];x[31609]=0;e=1;a:{b:{if((d|0)!=1){d=x[a+28>>2];f=x[x[d>>2]+56>>2];x[31609]=0;S(f|0,d|0,b|0,(c|0)!=0|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,6749,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();e=0}return e|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function naa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=tm(a);x[e>>2]=76732;d=nc(e);a=fb-16|0;fb=a;c=x[b+12>>2];x[a+8>>2]=x[b+8>>2];x[a+12>>2]=c;c=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=c;b=fb-16|0;fb=b;c=x[a+12>>2];x[b+8>>2]=x[a+8>>2];x[b+12>>2]=c;c=x[a+4>>2];x[b>>2]=x[a>>2];x[b+4>>2]=c;d=pM(d,qM(b));x[d>>2]=76896;c=x[a+4>>2];x[d+8>>2]=x[a>>2];x[d+12>>2]=c;c=x[a+12>>2];x[d+16>>2]=x[a+8>>2];x[d+20>>2]=c;fb=b+16|0;fb=a+16|0;return e|0}function dra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=x[a>>2];c=Sf(d,x[a+4>>2]);if(c>>>0<b>>>0){d=fb-32|0;fb=d;a:{b:{c=b-c|0;b=x[Ab(a)>>2];e=x[a+4>>2];c:{if(c>>>0<=(b-e|0)/20>>>0){XE(a,c);break c}b=Ab(a);b=UD(d+12|0,VD(a,Sf(x[a>>2],e)+c|0),Sf(x[a>>2],x[a+4>>2]),b);x[31609]=0;O(521,b|0,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}TD(a,b);bw(b)}fb=d+32|0;break a}a=N()|0;bw(b);Q(a|0);p()}return}if(b>>>0<c>>>0){TE(a,d+D(b,20)|0)}}function zV(a,b,c,d){var e=0,f=0,g=0;a:{b:{if(!((c|0)==255|(b|0)!=11)){e=c+1|0;f=11;break b}if((b&254)==16){e=c&15|b<<4|-128;f=14;break b}if((b|0)==18){break b}e=c;f=b;if(b>>>0>18){break a}}Cf(a,f,e&255);b=y[a+3|0];c:{d:{if(!((d|0)!=4|(b|0)!=13)){b=y[a+5|0];if(b&3?(b|0)!=255:0){break d}v[a+5|0]=b+3>>>2;return 1}if((b&255)!=13){break c}}b=46;v[a+3|0]=46}g=1;if((d|0)==4|(b&255)!=17|y[a+5|0]!=32){break a}v[a+3|0]=16}return g}function vg(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;w[d+12>>1]=65535;w[d+14>>1]=b;f=d+12|0;b=z[Oc(41356,d+14|0)>>1];e=x[a>>2];c=$c(e,x[a+4>>2]);a:{if(b>>>0>c>>>0){e=fb-32|0;fb=e;b=b-c|0;c=x[Ab(a)>>2];g=x[a+4>>2];b:{if(b>>>0<=c-g>>1>>>0){sp(a,b,f);break b}c=Ab(a);c=fk(e+12|0,gk(a,$c(x[a>>2],g)+b|0),$c(x[a>>2],x[a+4>>2]),c);sF(c,b,f);Sr(a,c);cj(c)}fb=e+32|0;break a}if(b>>>0<c>>>0){Jd(a,e+(b<<1)|0)}}fb=d+16|0}function xe(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;f=Lh(a);a:{b:{if(!b){i=e,j=Lh(a),x[i+8>>2]=j;x[e+12>>2]=0;break b}g=x[b>>2];b=x[b+4>>2];h=b;x[e+8>>2]=g;x[e+12>>2]=b;a=x[a+12>>2];x[e>>2]=2048;x[e+4>>2]=0;b=a+c|0;d=a>>>0>b>>>0?d+1|0:d;a=Ur(e+8|0,e);c=x[a>>2];a=x[a+4>>2];if(!a&c>>>0>f>>>0|a){a=-1;if(!d&b>>>0<=f>>>0){break b}break a}a=0;if((d|0)==(h|0)&b>>>0>g>>>0|d>>>0>h>>>0){break a}}a=1}fb=e+16|0;return a}function s3(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0;x[31609]=0;m=a;a=0;a=eI(1093,m|a,b,c,d,a|e,f);b=x[31609];x[31609]=0;a:{b:{if((b|0)==1){Y(T(0)|0)|0;x[31609]=0;ga(979,8859,g|0,h|0,i|0,j|0,k|0,l|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}Z();a=-255}break a}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}return a|0}function ru(a){var b=0,c=0,d=0;b=y[a+4266|0];B[a+4236>>2]=E(b>>>0)*E(.00390625);B[a+4240>>2]=E(256-b|0)*E(.00390625);c=y[a+4267|0];b=y[a+4265|0];B[a+4244>>2]=E(D(c,b)|0)*E(152587890625e-16);d=c|-256;B[a+4256>>2]=E(D(d,b|-256)|0)*E(152587890625e-16);B[a+4252>>2]=E(D(b,d)|0)*E(152587890625e-16);B[a+4248>>2]=E(D(256-b|0,c)|0)*E(152587890625e-16);b=a;c=x[a+4232>>2];a=y[a+4264|0];x[b+4228>>2]=(D(c,(a?a:-89)&255)+250>>>0)/500}function vsa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=fb-16|0;fb=g;a:{if(z[a+480192>>1]<b>>>0){break a}b=x[((b<<2)+a|0)+900380>>2];if(!b){break a}h=g+4|0;h_(h,b);b=wb(x[g+4>>2]);x[g>>2]=b;h=pg(h);i=z[a+480190>>1];while(1){if(!Ib(b,h)){Yv(g+4|0);break a}b=z[cp(b)>>1];if(b>>>0<=i>>>0){b=D(b,104)+a|0;v[b+484421|0]=f;v[b+484418|0]=c;v[b+484420|0]=e;v[b+484419|0]=d}b=x[ah(g)>>2];continue}}fb=g+16|0}function NL(a){var b=0,c=E(0),d=E(0),e=E(0),f=E(0),g=E(0),h=E(0),i=0,j=0,k=0,l=E(0),m=E(0),n=E(0),o=E(0),p=0;c=B[a>>2];i=a-16|0;d=B[i>>2];e=E(c+d);b=a-8|0;f=B[b>>2];j=a-24|0;g=B[j>>2];h=E(f+g);B[a>>2]=e+h;B[b>>2]=e-h;b=a-12|0;h=B[b>>2];k=a-28|0;l=B[k>>2];e=E(h+l);p=b;b=a-4|0;m=B[b>>2];a=a-20|0;n=B[a>>2];o=E(m+n);B[p>>2]=o-e;f=E(f-g);g=E(m-n);B[k>>2]=f+g;c=E(c-d);d=E(h-l);B[i>>2]=c+d;B[j>>2]=c-d;B[b>>2]=e+o;B[a>>2]=g-f}function p9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;while(1){a:{if((c|0)<=(g|0)){break a}d=x[a+12>>2];f=x[a+16>>2];b:{if(d>>>0<f>>>0){x[e+12>>2]=2147483647;x[e+8>>2]=f-d>>2;x[e+4>>2]=c-g;f=d;d=x[Cd(e+12|0,Cd(e+8|0,e+4|0))>>2];b=Ti(b,f,d);f=d<<2;x[a+12>>2]=f+x[a+12>>2];b=b+f|0;break b}d=ib[x[x[a>>2]+40>>2]](a)|0;if((d|0)==-1){break a}x[b>>2]=d;d=1;b=b+4|0}g=d+g|0;continue}break}fb=e+16|0;return g|0}function gu(a,b,c,d,e){var f=0,g=0;a:{if(!Ut(b)){break a}f=x[a+484344>>2];if(!Je(f,x[a+484348>>2],b&65535)){break a}b=Wb(f,b);if(x[b+12>>2]<=(c|0)|e>>>0>5|z[a+480188>>1]<=d>>>0|(c|d)<0){break a}b=md(x[b>>2],x[x[b+48>>2]+12>>2],c,d&65535);b:{c:{switch(e|0){case 1:b=b+1|0;break b;case 2:b=b+2|0;break b;case 3:b=b+3|0;break b;case 4:b=b+4|0;break b;case 0:break b;case 5:break c;default:break a}}b=b+5|0}g=y[b|0]}return g}function Eaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=E(0),j=0,k=0;c=fb-16|0;fb=c;h=x[a+4>>2];x[c+8>>2]=x[b+8>>2];d=x[b+4>>2];x[c>>2]=x[b>>2];x[c+4>>2]=d;zM(a,c);a:{f=C[a+24>>3];if(f==1){break a}i=E(f);d=x[b+4>>2];j=x[b+8>>2];b:while(1){if((e|0)==(j|0)){break a}k=x[a+12>>2]+(D(x[a+16>>2],e+h|0)<<2)|0;b=0;while(1)if((b|0)==(d|0)){e=e+1|0;continue b}else{g=(b<<2)+k|0;B[g>>2]=B[g>>2]*i;b=b+1|0;continue}}}fb=c+16|0}function vO(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=fb-16|0;fb=h;a:{b:{c:{if(g?!f|(!d|!e):1){a=ac(8);x[31609]=0;b=P(36,h+4|0,8200)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}d=N()|0;tb(b);break b}Cl(a,b,4);c=uz(a,c,d,e,f,g);C[a+16>>3]=C[a+16>>3]+ +(c>>>0)/+(b|0);fb=h+16|0;return c|0}d=N()|0;ic(a)}Q(d|0)}p()}function ofa(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;x[31609]=0;W(1021,a|0);d=x[31609];x[31609]=0;e=1;a:{b:{if((d|0)!=1){d=x[a+28>>2];f=x[x[d>>2]+48>>2];x[31609]=0;ra(f|0,d|0,b|0,+c);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,11694,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();e=0}return e|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function efa(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;x[31609]=0;W(1021,a|0);d=x[31609];x[31609]=0;e=1;a:{b:{if((d|0)!=1){d=x[a+28>>2];f=x[x[d>>2]+96>>2];x[31609]=0;ra(f|0,d|0,b|0,+c);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,11632,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();e=0}return e|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function cfa(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;x[31609]=0;W(1021,a|0);d=x[31609];x[31609]=0;e=1;a:{b:{if((d|0)!=1){d=x[a+28>>2];f=x[x[d>>2]+88>>2];x[31609]=0;ra(f|0,d|0,b|0,+c);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,11082,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();e=0}return e|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Y0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=fb-16|0;fb=c;x[c+12>>2]=-1;if(eh(a,c+11|0)){x[c+4>>2]=y[c+11|0];g=x[Hb(c+4|0,c+12|0)>>2];d=fb+-64|0;fb=d;f=d+44|0;sg(f,a,g);h=x[d+44>>2];a=d+20|0;ug(a,3,Ze(f),h);x[31609]=0;e=d+32|0;O(218,e|0,a|0);a=x[31609];x[31609]=0;a:{if((a|0)!=1){a=d+12|0;Zb(a,b,11);om(a,e);tb(e);Kc(f);fb=d- -64|0;e=!g|(h|0)!=0;break a}a=N()|0;Kc(d+44|0);Q(a|0);p()}}fb=c+16|0;return e|0}function Naa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=E(0),j=0,k=0;c=fb-16|0;fb=c;d=x[a+4>>2];x[c+8>>2]=x[b+8>>2];e=x[b+4>>2];x[c>>2]=x[b>>2];x[c+4>>2]=e;FM(a,c);a:{g=C[a+24>>3];if(g==1){break a}i=E(g);e=x[b+4>>2];j=x[b+8>>2];d=d<<2;b:while(1){if((f|0)==(j|0)){break a}k=x[a+12>>2];b=0;while(1)if((b|0)==(e|0)){f=f+1|0;continue b}else{h=(d+x[(b<<2)+k>>2]|0)+(f<<2)|0;B[h>>2]=B[h>>2]*i;b=b+1|0;continue}}}fb=c+16|0}function CO(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=fb-16|0;fb=h;a:{b:{c:{if(g?!f|(!d|!e):1){a=ac(8);x[31609]=0;b=P(36,h+4|0,8200)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}d=N()|0;tb(b);break b}Cl(a,b,4);c=tz(a,c,d,e,f,g);C[a+16>>3]=C[a+16>>3]+ +(c>>>0)/+(b|0);fb=h+16|0;return c|0}d=N()|0;ic(a)}Q(d|0)}p()}function t3(a){a=a|0;var b=0,c=0,d=0,e=0;c=fb-32|0;fb=c;b=uc(c+8|0,16806);x[31609]=0;S(98,c+20|0,a|0,b|0);a=x[31609];x[31609]=0;a:{if((a|0)!=1){tb(b);a=0;b=0;while(1){d=x[c+20>>2];if(!(b>>>0<=3&Ud(d,x[c+24>>2])>>>0>b>>>0)){Td(c+20|0);fb=c+32|0;return a|0}x[31609]=0;d=R(99,Vd(d,b)|0)|0;e=x[31609];x[31609]=0;if((e|0)!=1){a=(d&255)<<24-(b<<3)|a;b=b+1|0;continue}break}a=N()|0;Td(c+20|0);break a}a=N()|0;tb(b)}Q(a|0);p()}function l0(a){a=a|0;var b=0,c=0,d=0;b=x[a>>2];if(b){uQ(x[b+12>>2],b);b=x[a>>2];ib[x[x[b>>2]+8>>2]](b);x[a>>2]=0}a=a+4|0;Nc(a);b=fb-32|0;fb=b;a:{b:{d=$o(a);c=Xc(x[a>>2],x[a+4>>2]);c:{if(d>>>0<=c>>>0){break c}x[31609]=0;c=ba(950,b+12|0,c|0,c|0,Ab(a)|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){cr(a,c);pn(c);break c}Y(T(0)|0)|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)==1){break b}}fb=b+32|0;break a}T(0)|0;Sb();p()}}function R7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;a=fb-208|0;fb=a;g=Od();x[a>>2]=e;e=a+176|0;h=ph(e,20,g,9278,a);g=h+e|0;i=lj(e,g,x[c+4>>2]);f=a+12|0;cd(f,x[c+28>>2]);x[31609]=0;j=R(1252,x[a+12>>2])|0;k=x[31609];x[31609]=0;if((k|0)!=1){_b(f);f=e;e=a+16|0;tK(j,f,g,e);f=b;b=e+(h<<2)|0;b=ot(f,e,(g|0)==(i|0)?b:((i-a<<2)+a|0)-688|0,b,c,d);fb=a+208|0;return b|0}b=N()|0;_b(a+12|0);Q(b|0);p()}function C9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;while(1){a:{if((c|0)<=(f|0)){break a}g=x[a+16>>2];d=x[a+12>>2];b:{if(g>>>0>d>>>0){x[e+12>>2]=2147483647;x[e+8>>2]=g-d;x[e+4>>2]=c-f;g=d;d=x[Cd(e+12|0,Cd(e+8|0,e+4|0))>>2];b=Dg(b,g,d);x[a+12>>2]=x[a+12>>2]+d;b=b+d|0;break b}d=ib[x[x[a>>2]+40>>2]](a)|0;if((d|0)==-1){break a}v[b|0]=d<<24>>24;d=1;b=b+1|0}f=d+f|0;continue}break}fb=e+16|0;return f|0}function sha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a=Li(a,b,c,d);x[a>>2]=43556;c=Nb(a+4256|0);b=a+4208|0;e=yb(b,0),f=1056964608,x[e>>2]=f;e=yb(b,1),f=1017370378,x[e>>2]=f;e=yb(b,2),f=1028670828,x[e>>2]=f;e=yb(b,3),f=1059760811,x[e>>2]=f;e=yb(b,4),f=1017370378,x[e>>2]=f;e=yb(b,5),f=1065353216,x[e>>2]=f;x[31609]=0;O(941,a+44|0,2);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}b=N()|0;wc(c);_f(a);Q(b|0);p()}function iU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=fb-32|0;fb=d;x[a+4>>2]=0;a:{if(b){b:{if(hv(a)>>>0>=b>>>0){x[a+4>>2]=b;break b}e=So(d+20|0);x[31609]=0;f=P(759,a|0,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break a}x[31609]=0;O(760,e|0,f|0);f=x[31609];x[31609]=0;if((f|0)==1){break a}x[e+4>>2]=b;lC(a,e);tf(e)}nn(d+12|0,x[a>>2]);Vw(x[d+12>>2],x[d+16>>2],b,y[c|0])}fb=d+32|0;return}a=N()|0;tf(e);Q(a|0);p()}function g2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=fb-16|0;fb=g;f=g+4|0;x[f+4>>2]=1;j=f,k=Ec(32),x[j+8>>2]=k;e=tm(x[f+8>>2]);x[e>>2]=41368;h=nc(e);e=fb-16|0;fb=e;b=rm(e+8|0,x[b>>2],x[b+4>>2]);d=x[d>>2];c=x[c>>2];i=x[b+4>>2];x[e>>2]=x[b>>2];x[e+4>>2]=i;b=Qn(h);x[b>>2]=41504;rm(b+4|0,x[e>>2],x[e+4>>2]);x[b+16>>2]=d;x[b+12>>2]=c;me(e);fb=e+16|0;b=a;a=Sn(f);Rn(b,nc(a),a);um(f);fb=g+16|0}function ML(a,b){var c=0,d=0,e=0;if(!y[b+21|0]){fc(a,21);return-1}if(x[a+1396>>2]<=9){wl(a)}d=x[a+1392>>2];c=w[(((d&1023)<<1)+b|0)+36>>1];a:{if((c|0)>=0){e=d;d=c&65535;c=y[d+x[b+8>>2]|0];x[a+1392>>2]=e>>>c;c=x[a+1396>>2]-c|0;x[a+1396>>2]=(c|0)>0?c:0;c=(c|0)<0?-1:d;break a}c=Jm(a,b)}if(!((c|0)>=x[b+2092>>2]?y[b+23|0]:0)){if(!(!(x[a+1384>>2]?y[a+1376|0]:1)|(c|0)>=0)){fc(a,21)}return c}_(7566,13274,1793,5750);p()}function KA(a,b,c){if(Ob(a+1074312|0,21)){c=c&255;a:{switch((b&3)-1|0){default:return v[c+31808|0];case 0:return 64-(c+1>>>1|0)|0;case 1:return(c>>>0<128)<<6;case 2:break a}}return PR(Do(a))+-64|0}if(z[a+480182>>1]&1032){return v[(c>>>1&31)+30464|0]}a=c&63;b:{switch((b&3)-1|0){default:return v[a+31680|0];case 0:return(a>>>0>=32?255:0)-(a<<2)|0;case 1:return a>>>0<32?127:-127;case 2:break b}}return v[a+31744|0]}function fz(a){var b=0,c=0,d=0;a:{b:{if(!x[a+1384>>2]){b=x[a+1380>>2];if((b|0)==-1){x[a+1388>>2]=x[a+1116>>2]-1;if(!Qt(a)){x[a+1384>>2]=1;return 0}if(!(v[a+1375|0]&1)){break b}b=x[a+1380>>2]}d=b+1|0;x[a+1380>>2]=d;c=y[(a+b|0)+1120|0];if((c|0)!=255){x[a+1388>>2]=b;x[a+1384>>2]=1}if(x[a+1116>>2]<=(d|0)){x[a+1380>>2]=-1}if(y[a+1376|0]){break a}v[a+1376|0]=c}return c}fc(a,32);return 0}_(15819,13274,1564,6036);p()}function yja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=fb-32|0;fb=e;d=e+8|0;Te(d,2,a+6|0);f=e+20|0;Cc(f,d);Ac(b+492|0,f);d=b+236|0;g=c+1|0;tb(f);c=0;while(1){if((c|0)==128){x[b>>2]=(y[a+226|0]|y[a+227|0]<<8)<<5;wA(a+180|0,b+48|0,0);wA(a+228|0,b+88|0,2);wA(a+276|0,b+68|0,1);if(!(y[a+324|0]|y[a+325|0]<<8)){Rb(d,0,256)}fb=e+32|0}else{h=bc(d,c),i=y[(a+c|0)+38|0]+g|0,w[h>>1]=i;c=c+1|0;continue}break}}function yD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=c;c=0;a:{if(!b){break a}if(!Mb(x[a>>2],x[a+8>>2],b)){break a}if(b>>>0<=3){c=fb-16|0;fb=c;if(Mb(x[a>>2],x[a+8>>2],b)){while(1){if((d|0)==4){Mm(c+4|0,x[c+12>>2]);d=x[c+4>>2]}else{v[c+11|0]=0;b:{if(b>>>0>d>>>0){eh(a,c+11|0);e=v[c+11|0];g=e>>>31|0;break b}e=0-g|0}v[(c+12|0)+d|0]=e;d=d+1|0;continue}break}}fb=c+16|0;c=d;break a}c=Rg(a);Vb(a,b-4|0)}v[f|0]=c}function ipa(a){a=a|0;var b=0,c=0,d=0;b=fb-16|0;fb=b;v[b+15|0]=128;a=kw(a,127,b+15|0);x[31609]=0;v[b+14|0]=64;d=U(600,a+12|0,127,b+14|0)|0;c=x[31609];x[31609]=0;a:{b:{if((c|0)!=1){x[31609]=0;v[b+13|0]=0;P(680,a+24|0,b+13|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break b}x[a+44>>2]=0;x[a+48>>2]=0;x[a+36>>2]=-1;x[a+40>>2]=108855296;w[a+52>>1]=0;fb=b+16|0;return a|0}b=N()|0;break a}b=N()|0;ec(d)}ec(a);Q(b|0);p()}function cta(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=fb-16|0;fb=h;x[h+12>>2]=d;g=Cb(x[a+4>>2],y[a+11|0]);f=Mc(a);a:{if(f-g>>>0>=b>>>0){f=Kb(a);if((c|0)==(g|0)){break a}i=c+f|0;Pi(i+b|0,i,g-c|0);break a}bn(a,f,(b+g|0)-f|0,g,c,0,b);f=x[a>>2]}b=b+g|0;lg(a,b);hd(b+f|0,0);b=c+f|0;while(1){if(Ib(d,e)){hd(b,y[d|0]);b=b+1|0;d=x[we(h+12|0)>>2];continue}break}a=uf(zd(a),c);fb=h+16|0;return a|0}function NF(a,b,c){var d=0,e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;f=e+8|0;d=fb-32|0;fb=d;fd(d+24|0,a,b);g=d+16|0;b=x[d+24>>2];h=x[d+28>>2];a=fb-16|0;fb=a;x[a+8>>2]=c;x[a+12>>2]=b;while(1){if(Fd(b,h)){b=xf(b);c=xf(x[a+8>>2]);v[c+2|0]=y[b+2|0];w[c>>1]=z[b>>1];b=xj(a+12|0);xj(a+8|0);b=x[b>>2];continue}break}rc(g,b,a+8|0);fb=a+16|0;a=x[d+16>>2];x[d+12>>2]=x[d+20>>2];rc(f,a,d+12|0);fb=d+32|0;fb=e+16|0;return x[e+12>>2]}function vfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;d=1;a:{b:{if((c|0)!=1){c=x[a+28>>2];e=x[x[c>>2]+76>>2];x[31609]=0;O(e|0,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,11324,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();d=0}return d|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function gfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;d=1;a:{b:{if((c|0)!=1){c=x[a+28>>2];e=x[x[c>>2]+16>>2];x[31609]=0;O(e|0,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,12863,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();d=0}return d|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function bfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;d=1;a:{b:{if((c|0)!=1){c=x[a+28>>2];e=x[x[c>>2]+84>>2];x[31609]=0;O(e|0,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,12346,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();d=0}return d|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function afa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;d=1;a:{b:{if((c|0)!=1){c=x[a+28>>2];e=x[x[c>>2]+80>>2];x[31609]=0;O(e|0,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,11168,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();d=0}return d|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function $ea(a,b){a=a|0;b=+b;var c=0,d=0,e=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;d=1;a:{b:{if((c|0)!=1){c=x[a+28>>2];e=x[x[c>>2]+104>>2];x[31609]=0;la(e|0,c|0,+b);c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,15222,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();d=0}return d|0}a=N()|0;x[31609]=0;X(26);d=x[31609];x[31609]=0;if((d|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function $7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;a=fb-96|0;fb=a;g=Od();x[a>>2]=e;e=a- -64|0;h=ph(e,20,g,9278,a);g=h+e|0;i=lj(e,g,x[c+4>>2]);f=a+12|0;cd(f,x[c+28>>2]);x[31609]=0;j=R(28,x[a+12>>2])|0;k=x[31609];x[31609]=0;if((k|0)!=1){_b(f);f=e;e=a+16|0;AK(j,f,g,e);f=b;b=e+h|0;b=tw(f,e,(g|0)==(i|0)?b:((i-a|0)+a|0)-48|0,b,c,d);fb=a+96|0;return b|0}b=N()|0;_b(a+12|0);Q(b|0);p()}function mfa(a,b){a=a|0;b=+b;var c=0,d=0,e=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;d=1;a:{b:{if((c|0)!=1){c=x[a+28>>2];e=x[x[c>>2]+40>>2];x[31609]=0;la(e|0,c|0,+b);c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,11732,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();d=0}return d|0}a=N()|0;x[31609]=0;X(26);d=x[31609];x[31609]=0;if((d|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function hfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;d=1;a:{b:{if((c|0)!=1){c=x[a+28>>2];e=x[x[c>>2]+20>>2];x[31609]=0;O(e|0,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,9328,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();d=0}return d|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function ffa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;a:{b:{if((c|0)!=1){c=x[a+28>>2];e=x[x[c>>2]+100>>2];x[31609]=0;d=+qa(e|0,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,11650,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();d=0}return+d}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function wU(a,b){var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(c+8|0,x[vb(c+4|0,a)>>2]);a:{if(b){x[31609]=0;O(800,a|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break a}e=fb-16|0;fb=e;d=jv(e+4|0,a,b);b=x[d+4>>2];f=x[d+8>>2];while(1){if((b|0)==(f|0)){kc(d);fb=e+16|0}else{Ql(b,0,0);b=b+16|0;x[d+4>>2]=b;continue}break}}b=c+8|0;Qd(b);mU(b);fb=c+16|0;return a}a=N()|0;mU(c+8|0);Q(a|0);p()}function pfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;a:{b:{if((c|0)!=1){c=x[a+28>>2];e=x[x[c>>2]+52>>2];x[31609]=0;d=+qa(e|0,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,11713,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();d=0}return+d}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function kfa(a,b){a=a|0;b=+b;var c=0,d=0,e=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;d=1;a:{b:{if((c|0)!=1){c=x[a+28>>2];e=x[x[c>>2]+32>>2];x[31609]=0;la(e|0,c|0,+b);c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,7777,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();d=0}return d|0}a=N()|0;x[31609]=0;X(26);d=x[31609];x[31609]=0;if((d|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function ifa(a,b){a=a|0;b=+b;var c=0,d=0,e=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;d=1;a:{b:{if((c|0)!=1){c=x[a+28>>2];e=x[x[c>>2]+24>>2];x[31609]=0;la(e|0,c|0,+b);c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,7725,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();d=0}return d|0}a=N()|0;x[31609]=0;X(26);d=x[31609];x[31609]=0;if((d|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function dfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;a:{b:{if((c|0)!=1){c=x[a+28>>2];e=x[x[c>>2]+92>>2];x[31609]=0;d=+qa(e|0,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,11102,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();d=0}return+d}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Rx(a,b,c){var d=0,e=0,f=0,g=0;e=Kb(a);a=Cb(x[a+4>>2],y[a+11|0]);d=Kb(b);b=Cb(x[b+4>>2],y[b+11|0]);a:{if(a>>>0>=c>>>0){if(!b){break a}c=c+e|0;a=a+e|0;b=b+d|0;b:{if((b|0)==(d|0)){break b}c:{b=b-d|0;if((b|0)>(a-c|0)){break c}g=y[d|0];while(1){f=a-c|0;if((f|0)<(b|0)){break c}c=Cu(c,(f-b|0)+1|0,g);if(!c){break c}if(!UG(c,d,b)){break b}c=c+1|0;continue}}c=a}c=(a|0)==(c|0)?-1:c-e|0}else{c=-1}}return c}function AF(a){var b=0,c=0,d=0,e=0,f=0;a:{if((y[a|0]|y[a+1|0]<<8)!=26215|(y[a+514|0]-16&255)>>>0<241|y[a+515|0]>128){break a}b=2;while(1){if((b|0)==514){c=516;b=-1;while(1){f=(c|0)==772;if(f){break a}d=b;b=a+c|0;b=y[b|0]|y[b+1|0]<<8;e=(d|0)<(b|0);c=c+2|0;if(e){continue}break}break a}c=a+b|0;e=Ab(c);while(1){if((c|0)!=(e|0)){d=y[c|0];c=c+1|0;if(d>>>0>31){continue}break a}break}b=b+8|0;continue}}return f}function xda(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0;d=fb-48|0;fb=d;x[d+44>>2]=c;c=Md(d+16|0);x[31609]=0;e=x[c+4>>2];x[d>>2]=x[c>>2];x[d+4>>2]=e;c=d+24|0;S(1115,c|0,a|0,d|0);a=x[31609];x[31609]=0;a:{b:{if((a|0)!=1){a=d+44|0;e=x[re(d+12|0,a)>>2];x[31609]=0;b=+pa(981,c|0,+b,e|0);e=x[31609];x[31609]=0;if((e|0)==1){break b}ub(c);Wc(a);fb=d+48|0;return+b}c=N()|0;break a}c=N()|0;ub(d+24|0)}Wc(d+44|0);Q(c|0);p()}function tfa(a,b){a=a|0;b=b|0;var c=0,d=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;a:{b:{if((c|0)!=1){c=x[a+28>>2];d=x[x[c>>2]+68>>2];x[31609]=0;b=P(d|0,c|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,6722,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();b=-1}return b|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function rfa(a,b){a=a|0;b=b|0;var c=0,d=0;x[31609]=0;W(1021,a|0);c=x[31609];x[31609]=0;a:{b:{if((c|0)!=1){c=x[a+28>>2];d=x[x[c>>2]+60>>2];x[31609]=0;b=P(d|0,c|0,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,6773,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();b=-1}return b|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function mB(a,b,c){var d=0;d=x[a+480180>>2];a:{if((d|0)!=1048576){if((d|0)!=4){break a}d=y[b+813|0];if(c){v[b+813|0]=d&240|c&15;break a}c=d&15;break a}if(c){v[b+813|0]=c;break a}c=y[b+813|0]}b:{if(!(v[b+851|0]&1)|!x[b+700>>2]){break b}c=c&255;if(!c){break b}xk(a,b,b+700|0,0-(c<<2)|0,0);if(x[b+700>>2]<65536){break b}if(Ob(a+1074312|0,7)|(x[a+480180>>2]!=4?y[a+480208|0]&16:0)){break b}x[b+700>>2]=65535}}function bk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;a:{if(!y[b+4|0]){while(1){if((d|0)==4){d=0;x[c+28>>2]=0;e=Zb(c+8|0,c+28|0,4);lc(c+20|0,x[a>>2],x[a+8>>2],x[e>>2],x[e+4>>2]);if(!(x[c+24>>2]!=4|x[c+28>>2]!=(y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24)))){Vb(a,4);d=1}fb=c+32|0;break a}e=b+d|0;d=d+1|0;if(y[e|0]){continue}break}_(17516,9095,602,13238);p()}_(17495,9095,600,13238);p()}return d|0}function z9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;while(1){a:{if((c|0)<=(f|0)){break a}g=x[a+28>>2];d=x[a+24>>2];if(g>>>0<=d>>>0){if(((i=a,j=zf(v[b|0]),h=x[x[a>>2]+52>>2],ib[h](i|0,j|0)|0)|0)==-1){break a}f=f+1|0;b=b+1|0}else{x[e+12>>2]=g-d;x[e+8>>2]=c-f;g=d;d=x[Cd(e+12|0,e+8|0)>>2];Dg(g,b,d);x[a+24>>2]=d+x[a+24>>2];f=f+d|0;b=b+d|0}continue}break}fb=e+16|0;return f|0}function OF(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;f=e+8|0;d=fb-32|0;fb=d;fd(d+24|0,a,b);g=d+16|0;b=x[d+24>>2];h=x[d+28>>2];a=fb-16|0;fb=a;x[a+8>>2]=c;x[a+12>>2]=b;while(1){if(Fd(b,h)){b=Hn(b);i=Hn(x[a+8>>2]),j=z[b>>1],w[i>>1]=j;b=Xk(a+12|0);Xk(a+8|0);b=x[b>>2];continue}break}rc(g,b,a+8|0);fb=a+16|0;a=x[d+16>>2];x[d+12>>2]=x[d+20>>2];rc(f,a,d+12|0);fb=d+32|0;fb=e+16|0;return x[e+12>>2]}function cB(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=fb-16|0;fb=d;f=Ou(a,a+1074376|0,b,c);a:{if(!f){break a}Jb(d+8|0,a+1074312|0,117);if(Gb(x[x[d+8>>2]>>2],x[d+12>>2])){break a}c=D(b,872)+a|0;e=x[c+1075648>>2];if(!e){break a}g=v[e+33|0];if(!g){break a}h=a;a=c+1074992|0;c=Dq(h,x[a+88>>2],e);if(!c){break a}a=y[a+799|0];if(!(!e|(!a|a>>>0>128))){a=y[xb(e+108|0,a-1|0)|0]}ib[x[x[c>>2]+88>>2]](c,f,a,g,b)}fb=d+16|0}function ak(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=fb-16|0;fb=f;x[f+12>>2]=c;a:{if(!Mb(x[b>>2],x[b+8>>2],c)){break a}xc(f+12|0,65535);vg(a,z[f+12>>1]);c=wb(x[a>>2]);x[f+4>>2]=c;h=wb(x[a+4>>2]);while(1){if(!Ib(c,h)){break a}a=f+11|0;if(!eh(b,a)){dh(a)}a=y[f+11|0];w[c>>1]=a;g=65535;b:{if((a|0)!=(d|0)){g=65534;if((a|0)!=(e|0)){break b}}w[c>>1]=g}c=x[ge(f+4|0)>>2];continue}}fb=f+16|0}function oO(a,b){var c=0;a:{b:{if((a^b)&3){c=y[b|0];break b}if(b&3){while(1){c=y[b|0];v[a|0]=c;if(!c){break a}a=a+1|0;b=b+1|0;if(b&3){continue}break}}c=x[b>>2];if((c^-1)&c-16843009&-2139062144){break b}while(1){x[a>>2]=c;c=x[b+4>>2];a=a+4|0;b=b+4|0;if(!(c-16843009&(c^-1)&-2139062144)){continue}break}}v[a|0]=c;if(!(c&255)){break a}while(1){c=y[b+1|0];v[a+1|0]=c;a=a+1|0;b=b+1|0;if(c){continue}break}}}function UW(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;f=e+8|0;d=fb-32|0;fb=d;fd(d+24|0,a,b);g=d+16|0;b=x[d+24>>2];h=x[d+28>>2];a=fb-16|0;fb=a;x[a+8>>2]=c;x[a+12>>2]=b;while(1){if(Fd(b,h)){b=BW(b);i=BW(x[a+8>>2]),j=y[b|0],v[i|0]=j;b=xW(a+12|0);xW(a+8|0);b=x[b>>2];continue}break}rc(g,b,a+8|0);fb=a+16|0;a=x[d+16>>2];x[d+12>>2]=x[d+20>>2];rc(f,a,d+12|0);fb=d+32|0;fb=e+16|0;return x[e+12>>2]}function NM(a,b){var c=0,d=0;x[a+4>>2]=b;x[a>>2]=126480;x[a+24>>2]=0;x[a+28>>2]=65536;x[a+8>>2]=b;x[a+32>>2]=0;x[a+36>>2]=65536;c=(b|0)!=0;x[a+12>>2]=c;x[a+16>>2]=c;d=b^63;c=d&31;if((d&63)>>>0>=32){d=0;c=-1>>>c|0}else{d=-1>>>c|0;c=d|(1<<c)-1<<32-c}x[a+48>>2]=c;x[a+52>>2]=d;d=64-b|0;c=d&31;if((d&63)>>>0>=32){d=0;c=-1>>>c|0}else{d=-1>>>c|0;c=d|(1<<c)-1<<32-c}x[a+40>>2]=b?c:0;x[a+44>>2]=b?d:0;return a}function Fna(a,b){a=a|0;b=b|0;var c=0,d=0;if(A[a+4>>2]<A[Ab(a)>>2]){c=fb-16|0;fb=c;a=kC(c+4|0,a);Mm(x[a+4>>2],y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24));x[a+4>>2]=x[a+4>>2]+4;kc(a);fb=c+16|0;return}d=fb-32|0;fb=d;c=Ab(a);c=Zf(d+12|0,Mf(a,oc(x[a>>2],x[a+4>>2])+1|0),oc(x[a>>2],x[a+4>>2]),c);Mm(x[c+8>>2],y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24));x[c+8>>2]=x[c+8>>2]+4;dZ(a,c);Yf(c);fb=d+32|0}function av(a,b,c){var d=0,e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;x[b+40>>2]=0;x[b+44>>2]=0;f=b- -64|0;x[f>>2]=0;x[f+4>>2]=0;x[b+56>>2]=0;x[b+60>>2]=0;x[b+48>>2]=0;x[b+52>>2]=0;while(1){if((d|0)==1e4){a:{d=wb(x[c>>2]);x[e+12>>2]=d;f=wb(x[c+4>>2]);while(1){if(!Ib(d,f)){break a}g=d,h=pU(b,C[d>>3]),C[g>>3]=h;d=x[OB(e+12|0)>>2];continue}}}else{pU(b,C[Se(x[c>>2],0)>>3]);d=d+1|0;continue}break}Ul(a,c);fb=e+16|0}function vba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;Qo(c+4|0,b);b=0;a=Fb(a);d=y[c+15|0];e=x[c+8>>2];x[31609]=0;O(110,a|0,yh(e,d)|0);d=x[31609];x[31609]=0;if((d|0)!=1){a:{while(1){if(yh(x[c+8>>2],y[c+15|0])>>>0>b>>>0){d=v[dc(c+4|0,b)|0];x[31609]=0;O(111,a|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break a}b=b+1|0;continue}break}tb(c+4|0);fb=c+16|0;return}}b=N()|0;tb(a);tb(c+4|0);Q(b|0);p()}function qS(a,b){var c=0,d=0,e=0,f=0;c=x[a>>2];x[a>>2]=b;if(c){b=fb-16|0;fb=b;d=wb(x[c>>2]);x[b+12>>2]=d;f=wb(x[c+4>>2]);while(1){a:{b:{if(Ib(d,f)){while(1){a=x[d>>2];e=x[a>>2];if(!e){break b}uQ(a,e);a=x[x[e>>2]+8>>2];x[31609]=0;W(a|0,e|0);a=x[31609];x[31609]=0;if((a|0)!=1){continue}break}T(0)|0;Sb();p()}a=wc(c);fb=b+16|0;break a}Eb(a+20|0);Eb(a+8|0);Db(a);d=x[We(b+12|0)>>2];continue}break}Db(a)}}function lB(a,b,c){var d=0;d=x[a+480180>>2];a:{if((d|0)!=1048576){if((d|0)!=4){break a}d=y[b+814|0];if(c){v[b+814|0]=d&240|c&15;break a}c=d&15;break a}if(c){v[b+813|0]=c;break a}c=y[b+813|0]}b:{if(!(v[b+851|0]&1)|!x[b+700>>2]){break b}c=c&255;if(!c){break b}xk(a,b,b+700|0,0-c|0,0);if(x[b+700>>2]<65536){break b}if(Ob(a+1074312|0,7)|(x[a+480180>>2]!=4?y[a+480208|0]&16:0)){break b}x[b+700>>2]=65535}}function SA(a,b){a=a|0;b=b|0;var c=E(0),d=0,e=0,f=0;v[a+1074368|0]=b;jS(a+1074332|0,b);a=a+906300|0;f=vk(a);while(1){if((a|0)!=(f|0)){b=x[a>>2];if(b){c=E(1);d=x[b+20>>2];if(d){c=E(E(y[d+26|0])*E(.10000000149011612))}c=c<E(.10000000149011612)?E(1):c;if(ib[x[x[b>>2]+140>>2]](b)|0){d=x[b+16>>2];e=d+1074332|0;c=E(E(c/B[e+8>>2])*E(E(A[d+480232>>2])/B[e+20>>2]))}B[b+4196>>2]=c}a=a+160|0;continue}break}}function PE(a,b){var c=0,d=0,e=0,f=0;c=fb-32|0;fb=c;a:{if(!y[b+7|0]){while(1){if((d|0)==7){d=0;v[c+27|0]=0;v[c+28|0]=0;v[c+29|0]=0;v[c+30|0]=0;x[c+24>>2]=0;e=c+24|0;f=Zb(c+8|0,e,7);qd(c+16|0,a,x[f>>2],x[f+4>>2]);b:{if(x[c+20>>2]!=7){break b}if(jd(e,b,7)){break b}id(a,7);d=1}fb=c+32|0;break a}e=b+d|0;d=d+1|0;if(y[e|0]){continue}break}_(17516,9095,602,13238);p()}_(17495,9095,600,13238);p()}return d}function Era(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=fb-16|0;fb=e;c=If(a,c);ae(e,x[a+36>>2]);a:{b:{if(!c){Qc(e,a+32|0,5);d=-1;if(!Gb(x[x[e>>2]>>2],x[e+4>>2])){break b}break a}d=x[c+16>>2]}f=x[a+36>>2];c:{d:{switch(d+1|0){case 0:case 2:d=fb-32|0;fb=d;v[d+31|0]=0;vj(d+8|0,d+31|0);Om(d+20|0,f,x[d+8>>2],x[d+12>>2]);v[b|0]=y[d+31|0];fb=d+32|0;break c;default:break d}}wZ(f,b,d)}f=c}ef(a,f);fb=e+16|0}function qo(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;Uk(c+4|0,b);b=0;a=Fb(a);d=y[c+15|0];e=x[c+8>>2];x[31609]=0;O(110,a|0,yh(e,d)|0);d=x[31609];x[31609]=0;if((d|0)!=1){a:{b:{while(1){if(yh(x[c+8>>2],y[c+15|0])>>>0<=b>>>0){break b}d=v[dc(c+4|0,b)|0];x[31609]=0;O(111,a|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){b=b+1|0;continue}break}break a}tb(c+4|0);fb=c+16|0;return}}b=N()|0;tb(a);tb(c+4|0);Q(b|0);p()}function UH(a,b,c,d,e,f,g,h,i){var j=0;x[31609]=0;W(996,a|0);j=x[31609];x[31609]=0;a:{b:{if((j|0)!=1){j=x[a+24>>2];x[31609]=0;b=sa(i|0,j|0,b|0,c|0,d|0,e|0,f|0,g|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,h|0,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();b=0}return b}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Hx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;Uk(c+4|0,b);b=0;a=Fb(a);d=y[c+15|0];e=x[c+8>>2];x[31609]=0;O(110,a|0,yh(e,d)|0);d=x[31609];x[31609]=0;if((d|0)!=1){a:{while(1){if(yh(x[c+8>>2],y[c+15|0])>>>0>b>>>0){d=v[dc(c+4|0,b)|0];x[31609]=0;O(111,a|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break a}b=b+1|0;continue}break}tb(c+4|0);fb=c+16|0;return}}b=N()|0;tb(a);tb(c+4|0);Q(b|0);p()}function zna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;b=fb-16|0;fb=b;d=-1;a:{if(!jh(a,1)){break a}e=Jr(a);if((e-5&255)>>>0>=253){while(1){if((f|0)==127){d=1;break a}c=fb-16|0;fb=c;fE(c+8|0,b);g=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);h=x[c+4>>2];if((h|0)==(g|0)){id(a,x[c+12>>2])}fb=c+16|0;c=(g|0)==(h|0);if(!c){Cr(b)}if(!c){break a}f=f+1|0;if(AV(b,e)){continue}break}}d=0}fb=b+16|0;return d|0}function xpa(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;b=-1;a:{if(!jh(a,8)){break a}b=fb-32|0;fb=b;x[b+24>>2]=0;x[b+28>>2]=0;d=Zb(b+8|0,b+24|0,8);qd(b+16|0,a,x[d>>2],x[d+4>>2]);d=x[b+24>>2]==1096043343&x[b+28>>2]==1196314451&x[b+20>>2]==8;if(d){id(a,8)}fb=b+32|0;b=0;if(!d){break a}b=-1;if(!ik(a,c+8|0)){break a}b=0;if(!$b(x[c+12>>2])){break a}b=!($b(x[c+8>>2])&-2139062144)}fb=c+16|0;return b|0}function vw(a,b,c){var d=0,e=0,f=0;d=x[c+16>>2];a:{if(!d){if(Jw(c)){break a}d=x[c+16>>2]}e=x[c+20>>2];if(d-e>>>0<b>>>0){return ib[x[c+36>>2]](c,a,b)|0}b:{c:{if(!b|x[c+80>>2]<0){break c}d=b;while(1){f=a+d|0;if(y[f-1|0]!=10){d=d-1|0;if(d){continue}break c}break}e=ib[x[c+36>>2]](c,a,d)|0;if(e>>>0<d>>>0){break a}b=b-d|0;e=x[c+20>>2];break b}f=a;d=0}zc(e,f,b);x[c+20>>2]=x[c+20>>2]+b;e=b+d|0}return e}function uO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=fb-16|0;fb=f;a:{b:{c:{if(!(e?d:0)){a=ac(8);x[31609]=0;b=P(36,f+4|0,8200)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}e=N()|0;tb(b);break b}Cl(a,b,2);c=uz(a,c,d,e,0,0);C[a+16>>3]=C[a+16>>3]+ +(c>>>0)/+(b|0);fb=f+16|0;return c|0}e=N()|0;ic(a)}Q(e|0)}p()}function bI(a,b,c){a=Fb(a);x[31609]=0;O(c|0,a|0,4);c=x[31609];x[31609]=0;a:{b:{if((c|0)==1){break b}x[31609]=0;O(b|0,a|0,32);c=x[31609];x[31609]=0;if((c|0)==1){break b}x[31609]=0;O(b|0,a|0,10);c=x[31609];x[31609]=0;if((c|0)==1){break b}x[31609]=0;O(b|0,a|0,13);c=x[31609];x[31609]=0;if((c|0)==1){break b}x[31609]=0;O(b|0,a|0,9);b=x[31609];x[31609]=0;if((b|0)!=1){break a}}b=N()|0;tb(a);Q(b|0);p()}}function WZ(a){var b=0,c=0,d=0,e=0;a:{if((y[a+60|0]|y[a+61|0]<<8|(y[a+62|0]<<16|y[a+63|0]<<24))!=808537417|(y[a+32|0]|y[a+33|0]<<8)>>>0>256|(y[a+49|0]<32|(y[a+36|0]|y[a+37|0]<<8)>>>0>255)){break a}if(v[a+51|0]<4|y[a+50|0]>64){break a}d=a+15|0;a=64;while(1){if((a|0)==576){e=b;break a}c=1;b:{switch(y[a+d|0]){case 2:c=b;break;case 0:case 1:break b;default:break a}}a=a+16|0;b=c;continue}}return e&1}function Uda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;x[31609]=0;W(996,a|0);d=x[31609];x[31609]=0;e=1;a:{b:{if((d|0)!=1){d=x[a+24>>2];x[31609]=0;S(1092,d|0,b|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,10337,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();e=0}return e|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function BO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=fb-16|0;fb=f;a:{b:{c:{if(!(e?d:0)){a=ac(8);x[31609]=0;b=P(36,f+4|0,8200)|0;c=x[31609];x[31609]=0;if((c|0)==1){break c}pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}e=N()|0;tb(b);break b}Cl(a,b,2);c=tz(a,c,d,e,0,0);C[a+16>>3]=C[a+16>>3]+ +(c>>>0)/+(b|0);fb=f+16|0;return c|0}e=N()|0;ic(a)}Q(e|0)}p()}function eN(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;Uf(c+4|0,b);b=0;a=Fb(a);d=y[c+15|0];e=x[c+8>>2];x[31609]=0;O(93,a|0,yh(e,d)|0);d=x[31609];x[31609]=0;if((d|0)!=1){a:{b:{while(1){if(yh(x[c+8>>2],y[c+15|0])>>>0<=b>>>0){break b}d=y[dc(c+4|0,b)|0];x[31609]=0;O(95,a|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){b=b+1|0;continue}break}break a}tb(c+4|0);fb=c+16|0;return}}b=N()|0;tb(a);tb(c+4|0);Q(b|0);p()}function wD(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{e=Nb(a+8|0);x[31609]=0;c=R(202,b|0)|0;d=x[31609];x[31609]=0;b:{if((d|0)==1){break b}c:{if(!vZ(c)){x[31609]=0;X(507);a=x[31609];x[31609]=0;if((a|0)!=1){break c}break b}x[31609]=0;c=R(202,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break b}x[31609]=0;S(169,a|0,b|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}break a}p()}a=N()|0;ec(e);Q(a|0);p()}}function r3(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;x[31609]=0;a=Ha(1095,a|0,b|0,c|0,d|0)|0;b=x[31609];x[31609]=0;a:{b:{if((b|0)==1){Y(T(0)|0)|0;x[31609]=0;ga(979,11208,e|0,f|0,g|0,h|0,i|0,j|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}Z();a=-255}break a}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}return a|0}function nfa(a){a=a|0;var b=0,c=0,d=0;x[31609]=0;W(1021,a|0);b=x[31609];x[31609]=0;a:{b:{if((b|0)!=1){b=x[a+28>>2];d=x[x[b>>2]+44>>2];x[31609]=0;c=+ia(d|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,11750,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();c=0}return+c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Wda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;x[31609]=0;W(996,a|0);d=x[31609];x[31609]=0;a:{b:{if((d|0)!=1){d=x[a+24>>2];x[31609]=0;e=+oa(1088,d|0,b|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,5350,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();e=0}return+e}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Nna(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=fb-16|0;fb=b;w[b+12>>1]=0;w[b+14>>1]=1;Hf(b+14|0,z[x[x[a+24>>2]+8>>2]+12>>1]);e=b+12|0;d=fb-16|0;fb=d;c=z[b+14>>1];x[d+12>>2]=c;a:{if(In(a)>>>0>=c>>>0){g=x[a>>2];f=$c(g,x[a+4>>2]);x[d+8>>2]=f;Kv(g,x[Hb(d+12|0,d+8|0)>>2],e);if(c>>>0>f>>>0){sp(a,c-f|0,e);break a}Jd(a,x[a>>2]+(c<<1)|0);break a}bV(a);JC(a,gk(a,c));sp(a,c,e)}fb=d+16|0;fb=b+16|0}
function lfa(a){a=a|0;var b=0,c=0,d=0;x[31609]=0;W(1021,a|0);b=x[31609];x[31609]=0;a:{b:{if((b|0)!=1){b=x[a+28>>2];d=x[x[b>>2]+36>>2];x[31609]=0;c=+ia(d|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,7794,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();c=0}return+c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function jfa(a){a=a|0;var b=0,c=0,d=0;x[31609]=0;W(1021,a|0);b=x[31609];x[31609]=0;a:{b:{if((b|0)!=1){b=x[a+28>>2];d=x[x[b>>2]+28>>2];x[31609]=0;c=+ia(d|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,7742,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();c=0}return+c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function ala(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;c=fb-16|0;fb=c;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);e=c+8|0;Rd(e,x[vb(c+4|0,a)>>2]);x[31609]=0;W(805,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){f=fb-16|0;fb=f;d=dj(f+4|0,a,2304);b=x[d+4>>2];g=x[d+8>>2];while(1){if((b|0)==(g|0)){kc(d);fb=f+16|0}else{_w(b);b=b+2|0;x[d+4>>2]=b;continue}break}Qd(e);Sj(e);fb=c+16|0;return a|0}a=N()|0;Sj(c+8|0);Q(a|0);p()}function PY(a){var b=0;a:{if(jd(a,14321,3)|(y[a+3|0]-52&255)>>>0<252){break a}if($b(y[a+8|0]|y[a+9|0]<<8|(y[a+10|0]<<16|y[a+11|0]<<24))+788>>>0<840){break a}if($b(y[a+16|0]|y[a+17|0]<<8|(y[a+18|0]<<16|y[a+19|0]<<24))>>>0<52){break a}if($b(y[a+24|0]|y[a+25|0]<<8|(y[a+26|0]<<16|y[a+27|0]<<24))-1>>>0<51){break a}b=$b(y[a+32|0]|y[a+33|0]<<8|(y[a+34|0]<<16|y[a+35|0]<<24))>>>0<4294967216}return b}function tN(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{b:{c:{d:{if((b|0)>=0){a=x[a+32>>2];if((wo(a)|0)>(b|0)){break d}}b=ac(8);x[31609]=0;c=P(36,c+4|0,10751)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}pc(b,c);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(c);break b}fb=c+16|0;return(x[(a+D(b,872)|0)+1075080>>2]&67109888)!=0|0}a=N()|0;ic(b)}Q(a|0)}p()}function xta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=fb-16|0;fb=e;a:{f=Zd(a);b:{if(f>>>0>1){break b}c:{if(f){x[31609]=0;d=e+4|0;S(334,d|0,a|0,c|0);a=x[31609];x[31609]=0;if((a|0)!=1){An(b,d);ec(d);break c}a=T(28816)|0;if((gb|0)!=($(28816)|0)){break a}Y(a|0)|0;Z();d=0;break b}if(!Mb(x[a>>2],x[a+8>>2],c)){break b}yw(a,b,c)}d=Xc(x[b>>2],x[b+4>>2])>>>0>=c>>>0}fb=e+16|0;return d|0}Q(a|0);p()}function Xv(a,b){var c=0;c=fb-16|0;fb=c;x[c+12>>2]=b;a:{b:{switch(a|0){case 0:a=b>>31<<6|b>>>26;b=b<<6;a=Gc(Jua(b- -8192|0,a-((b>>>0<4294959104)-1|0)|0,16384,0),hb);break a;case 1:a=b>>31<<6|b>>>26;b=(b<<6)+2048|0;a=b>>>0<2048?a+1|0:a;a=Gc(Jua(b,a,4096,0),hb);break a;default:break b}}x[c+8>>2]=1;a=Ui(RL(8192/+x[Xe(c+12|0,c+8|0)>>2])*24+8)}fb=c+16|0;a=(a|0)>=64?64:a;return((a|0)>0?a:0)&255}function P1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-16|0;fb=d;x[a>>2]=0;x[a+4>>2]=0;if(!Mb(x[b>>2],x[b+8>>2],c)){c=jf(b)}x[a>>2]=c;c=x[b>>2];a:{if(ib[x[x[c>>2]+16>>2]](c)|0){c=a;a=x[b>>2];e=c,f=(ib[x[x[a>>2]+20>>2]](a)|0)+x[b+8>>2]|0,x[e+4>>2]=f;break a}Kk(a+8|0,x[a>>2]);c=x[a+8>>2];a=x[a+12>>2];if(mc(c,a)){break a}se(d+8|0,c,a);lc(d,x[b>>2],x[b+8>>2],x[d+8>>2],x[d+12>>2])}fb=d+16|0}function pz(a,b,c){var d=0,e=0;d=fb-32|0;fb=d;a:{if(y[a+20|0]){break a}b=b+c|0;b=b>>>0<c>>>0?-1:b;c=x[a+16>>2];if(b>>>0<=c>>>0){break a}b=sM(b,4096);rM(a,b-c|0);c=x[a+16>>2];b=Zb(d+16|0,xb(x[a+4>>2],c),b-c|0);c=x[x[a>>2]+44>>2];e=x[b+4>>2];x[d+8>>2]=x[b>>2];x[d+12>>2]=e;ib[c|0](d+24|0,a,d+8|0);x[a+16>>2]=x[a+16>>2]+x[d+28>>2];if(!(ib[x[x[a>>2]+40>>2]](a)|0)){break a}v[a+20|0]=1}fb=d+32|0}function vN(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{b:{c:{d:{if((b|0)>=0){a=x[a+32>>2];if((wo(a)|0)>(b|0)){break d}}b=ac(8);x[31609]=0;c=P(36,c+4|0,10751)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}pc(b,c);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(c);break b}fb=c+16|0;return+(+x[(a+D(b,872)|0)+1075740>>2]*.015625)}a=N()|0;ic(b)}Q(a|0)}p()}function nma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;f=Kb(c);c=Cb(x[c+4>>2],y[c+11|0]);a:{d=Cb(x[a+4>>2],y[a+11|0]);if(d>>>0>=b>>>0){e=Mc(a);if(c>>>0<=e-d>>>0){if(!c){break a}e=Kb(a);h=e+b|0;if((b|0)!=(d|0)){g=b+e|0;Pi(c+g|0,g,d-b|0);f=(f>>>0>=g>>>0?d+e>>>0>f>>>0?c:0:0)+f|0}Pi(h,f,c);b=c+d|0;lg(a,b);hd(b+e|0,0);break a}Sq(a,e,(c+d|0)-e|0,d,b,0,c,f);break a}en();p()}return a|0}function bn(a,b,c,d,e,f,g){var h=0,i=0,j=0;h=fb-16|0;fb=h;a:{if(2147483631-b>>>0>=c>>>0){j=Kb(a);i=h+4|0;if(b>>>0<=1073741798){x[h+12>>2]=b<<1;x[h+4>>2]=b+c;c=Fh(x[bd(i,h+12|0)>>2])+1|0}else{c=2147483631}qg(i,c);c=x[h+4>>2];if(e){Dg(c,j,e)}i=e+f|0;if((i|0)!=(d|0)){Dg((c+e|0)+g|0,(e+j|0)+f|0,d-i|0)}if((b|0)!=10){Db(j)}yd(a,c);of(a,x[h+8>>2]);fb=h+16|0;break a}pf();p()}Bd(a,(d-f|0)+g|0)}function Saa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=fb-16|0;fb=c;a:{if(C[a+24>>3]==1){break a}h=x[b>>2];f=x[b+4>>2];i=x[b+8>>2];b:while(1){if((e|0)==(i|0)){break a}j=(D(e,f)<<3)+h|0;d=0;while(1)if((d|0)==(f|0)){e=e+1|0;continue b}else{g=(d<<3)+j|0;C[g>>3]=C[a+24>>3]*C[g>>3];d=d+1|0;continue}}}x[c+8>>2]=x[b+8>>2];d=x[b+4>>2];x[c>>2]=x[b>>2];x[c+4>>2]=d;IM(a,c);fb=c+16|0}function Maa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=fb-16|0;fb=c;a:{if(C[a+24>>3]==1){break a}h=x[b>>2];f=x[b+4>>2];i=x[b+8>>2];b:while(1){if((e|0)==(i|0)){break a}j=(D(e,f)<<3)+h|0;d=0;while(1)if((d|0)==(f|0)){e=e+1|0;continue b}else{g=(d<<3)+j|0;C[g>>3]=C[a+24>>3]*C[g>>3];d=d+1|0;continue}}}x[c+8>>2]=x[b+8>>2];d=x[b+4>>2];x[c>>2]=x[b>>2];x[c+4>>2]=d;EM(a,c);fb=c+16|0}function Jaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=fb-16|0;fb=c;a:{if(C[a+24>>3]==1){break a}h=x[b>>2];f=x[b+4>>2];i=x[b+8>>2];b:while(1){if((e|0)==(i|0)){break a}j=(D(e,f)<<3)+h|0;d=0;while(1)if((d|0)==(f|0)){e=e+1|0;continue b}else{g=(d<<3)+j|0;C[g>>3]=C[a+24>>3]*C[g>>3];d=d+1|0;continue}}}x[c+8>>2]=x[b+8>>2];d=x[b+4>>2];x[c>>2]=x[b>>2];x[c+4>>2]=d;CM(a,c);fb=c+16|0}function Daa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=fb-16|0;fb=c;a:{if(C[a+24>>3]==1){break a}h=x[b>>2];f=x[b+4>>2];i=x[b+8>>2];b:while(1){if((e|0)==(i|0)){break a}j=(D(e,f)<<3)+h|0;d=0;while(1)if((d|0)==(f|0)){e=e+1|0;continue b}else{g=(d<<3)+j|0;C[g>>3]=C[a+24>>3]*C[g>>3];d=d+1|0;continue}}}x[c+8>>2]=x[b+8>>2];d=x[b+4>>2];x[c>>2]=x[b>>2];x[c+4>>2]=d;yM(a,c);fb=c+16|0}function ita(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;cc(c+8|0,b,15);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;if((d|0)!=(e|0)){v[b|0]=0;v[b+1|0]=0;v[b+2|0]=0;v[b+3|0]=0;v[b+4|0]=0;v[b+5|0]=0;v[b+6|0]=0;v[b+7|0]=0;v[b+7|0]=0;v[b+8|0]=0;v[b+9|0]=0;v[b+10|0]=0;v[b+11|0]=0;v[b+12|0]=0;v[b+13|0]=0;v[b+14|0]=0}}function TH(a,b,c,d,e,f,g){var h=0;x[31609]=0;W(996,a|0);h=x[31609];x[31609]=0;a:{b:{if((h|0)!=1){h=x[a+24>>2];x[31609]=0;b=ha(g|0,h|0,b|0,c|0,d|0,e|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,f|0,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();b=0}return b}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function RX(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;v[a+6|0]=0;v[a+7|0]=0;v[a+22|0]=0;v[a+23|0]=0;v[a+24|0]=0;v[a+25|0]=0;v[a+26|0]=0;v[a+27|0]=0;v[a+28|0]=0;v[a+29|0]=0;v[a+16|0]=0;v[a+17|0]=0;v[a+18|0]=0;v[a+19|0]=0;v[a+20|0]=0;v[a+21|0]=0;v[a+22|0]=0;v[a+23|0]=0;v[a+8|0]=0;v[a+9|0]=0;v[a+10|0]=0;v[a+11|0]=0;v[a+12|0]=0;v[a+13|0]=0;v[a+14|0]=0;v[a+15|0]=0}function PV(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;v[a+6|0]=0;v[a+7|0]=0;v[a+24|0]=0;v[a+25|0]=0;v[a+26|0]=0;v[a+27|0]=0;v[a+28|0]=0;v[a+29|0]=0;v[a+30|0]=0;v[a+31|0]=0;v[a+16|0]=0;v[a+17|0]=0;v[a+18|0]=0;v[a+19|0]=0;v[a+20|0]=0;v[a+21|0]=0;v[a+22|0]=0;v[a+23|0]=0;v[a+8|0]=0;v[a+9|0]=0;v[a+10|0]=0;v[a+11|0]=0;v[a+12|0]=0;v[a+13|0]=0;v[a+14|0]=0;v[a+15|0]=0}function BK(a,b,c){var d=0,e=0,f=E(0),g=0,h=E(0);e=fb-16|0;fb=e;a:{b:{c:{if((a|0)!=(b|0)){g=x[31484];x[31484]=0;Od();d=fb-16|0;fb=d;_x(d,a,e+12|0,0);f=XG(x[d>>2],x[d+4>>2],x[d+8>>2],x[d+12>>2]);fb=d+16|0;a=x[31484];if(!a){break c}if(x[e+12>>2]!=(b|0)){break b}h=f;if((a|0)!=68){break a}break b}x[c>>2]=4;break a}x[31484]=g;if(x[e+12>>2]==(b|0)){break a}}x[c>>2]=4;f=h}fb=e+16|0;return f}function fra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;cc(c+8|0,b,14);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;if((d|0)!=(e|0)){v[b|0]=0;v[b+1|0]=0;v[b+2|0]=0;v[b+3|0]=0;v[b+4|0]=0;v[b+5|0]=0;v[b+6|0]=0;v[b+7|0]=0;v[b+6|0]=0;v[b+7|0]=0;v[b+8|0]=0;v[b+9|0]=0;v[b+10|0]=0;v[b+11|0]=0;v[b+12|0]=0;v[b+13|0]=0}}function Zda(a,b){a=a|0;b=b|0;var c=0,d=0;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;d=1;a:{b:{if((c|0)!=1){c=x[a+24>>2];x[31609]=0;O(1087,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,10916,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();d=0}return d|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function sba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);c=x[b+4>>2];d=c;b=x[b+8>>2];e=b;c=Ek(c,b);b=fb-16|0;fb=b;Rd(b+8|0,x[vb(b+4|0,a)>>2]);a:{if(!c){break a}x[31609]=0;O(1121,a|0,c|0);f=x[31609];x[31609]=0;if((f|0)!=1){x[31609]=0;V(1122,a|0,d|0,e|0,c|0);a=x[31609];x[31609]=0;if((a|0)!=1){break a}}a=N()|0;hN(b+8|0);Q(a|0);p()}a=b+8|0;Qd(a);hN(a);fb=b+16|0}function m4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=x[a>>2];f=6;a:{b:{if((e|0)==(b|0)){break b}e=v[e|0];f=4;if(!Jf(x[d+8>>2],64,e)){break b}f=4;g=nl(d,e);while(1){c:{e=x[a>>2]+1|0;x[a>>2]=e;g=g-48|0;if((b|0)==(e|0)|f>>>0<2){break c}e=v[e|0];if(!Jf(x[d+8>>2],64,e)){break a}f=f-1|0;g=nl(d,e)+D(g,10)|0;continue}break}if((b|0)!=(e|0)){break a}f=2}x[c>>2]=f|x[c>>2]}return g|0}function jj(a,b,c,d,e){var f=0,g=0,h=0;f=fb-16|0;fb=f;x[f+12>>2]=b;b=0;g=6;a:{b:{if(th(a,f+12|0)){break b}h=ul(x[a>>2]);g=4;if(!Jf(x[d+8>>2],64,h)){break b}b=nl(d,h);while(1){c:{b=b-48|0;h=Gm(a);if(th(h,f+12|0)|(e|0)<2){break c}g=ul(x[h>>2]);if(!Jf(x[d+8>>2],64,g)){break a}e=e-1|0;b=nl(d,g)+D(b,10)|0;continue}break}g=2;if(!th(h,f+12|0)){break a}}x[c>>2]=x[c>>2]|g}fb=f+16|0;return b}function Dia(a){a=a|0;var b=0,c=0;b=x[a+20>>2];x[b+148>>2]=-1;x[31609]=0;O(287,b+4|0,8);b=x[31609];x[31609]=0;if((b|0)!=1){b=x[a+4264>>2];c=x[x[a+20>>2]+4>>2];a=x[a+4260>>2];v[c|0]=a;v[c+1|0]=a>>>8;v[c+2|0]=a>>>16;v[c+3|0]=a>>>24;v[c+4|0]=b;v[c+5|0]=b>>>8;v[c+6|0]=b>>>16;v[c+7|0]=b>>>24;return}b=T(124540)|0;if((gb|0)==($(124540)|0)){Y(b|0)|0;Nc(x[a+20>>2]+4|0);Z();return}Q(b|0);p()}function wO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=fb-16|0;fb=e;a:{b:{c:{if(!d){a=ac(8);x[31609]=0;c=P(36,e+4|0,8200)|0;b=x[31609];x[31609]=0;if((b|0)==1){break c}pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}b=N()|0;tb(c);break b}Cl(a,b,1);c=uz(a,c,d,0,0,0);C[a+16>>3]=C[a+16>>3]+ +(c>>>0)/+(b|0);fb=e+16|0;return c|0}b=N()|0;ic(a)}Q(b|0)}p()}function oC(a,b,c,d,e,f){var g=0,h=0,i=0;g=fb-16|0;fb=g;a:{if(1073741807-b>>>0>=c>>>0){i=Kb(a);h=g+4|0;if(b>>>0<=536870886){x[g+12>>2]=b<<1;x[g+4>>2]=b+c;c=sn(x[bd(h,g+12|0)>>2])+1|0}else{c=1073741807}Oj(h,c);c=x[g+4>>2];if(e){Ti(c,i,e)}h=e+f|0;if((h|0)!=(d|0)){e=e<<2;Ti(e+c|0,(e+i|0)+(f<<2)|0,d-h|0)}if((b|0)!=1){Db(i)}yd(a,c);of(a,x[g+8>>2]);fb=g+16|0;break a}pf();p()}Bd(a,d-f|0)}function DO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=fb-16|0;fb=e;a:{b:{c:{if(!d){a=ac(8);x[31609]=0;c=P(36,e+4|0,8200)|0;b=x[31609];x[31609]=0;if((b|0)==1){break c}pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}b=N()|0;tb(c);break b}Cl(a,b,1);c=tz(a,c,d,0,0,0);C[a+16>>3]=C[a+16>>3]+ +(c>>>0)/+(b|0);fb=e+16|0;return c|0}b=N()|0;ic(a)}Q(b|0)}p()}function cpa(a,b){a=a|0;b=b|0;var c=0,d=0;a:{a=CC(a,b);x[31609]=0;c=P(684,a+12|0,b+12|0)|0;d=x[31609];x[31609]=0;b:{c:{if((d|0)!=1){x[31609]=0;P(685,a+24|0,b+24|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}c=x[b+40>>2];x[a+36>>2]=x[b+36>>2];x[a+40>>2]=c;w[a+52>>1]=z[b+52>>1];c=x[b+48>>2];x[a+44>>2]=x[b+44>>2];x[a+48>>2]=c;break a}b=N()|0;break b}b=N()|0;ec(c)}ec(a);Q(b|0);p()}}function bha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=Li(a,b,c,d);x[a>>2]=44176;b=Nb(a+4208|0);x[a+4240>>2]=0;x[a+4244>>2]=0;c=x[c+24620>>2];x[a+4260>>2]=0;x[a+4256>>2]=c;x[a+4236>>2]=0;c=a+4228|0;x[c>>2]=1048550822;x[c+4>>2]=1048550822;x[a+4220>>2]=1056964608;x[a+4224>>2]=1056964608;x[31609]=0;O(941,a+44|0,2);c=x[31609];x[31609]=0;if((c|0)!=1){return a|0}c=N()|0;wc(b);_f(a);Q(c|0);p()}function Afa(a){a=a|0;var b=0;x[31609]=0;W(1021,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){x[a+24>>2]=0;b=x[a+28>>2];if(b){ib[x[x[b>>2]+4>>2]](b)}x[a+28>>2]=0;b=x[a+20>>2];if(b){Db(b);x[a+20>>2]=0}Db(a);return}Y(T(0)|0)|0;x[31609]=0;V(983,5051,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function zK(a,b,c){var d=0,e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;a:{b:{c:{if((a|0)!=(b|0)){g=x[31484];x[31484]=0;Od();d=fb-16|0;fb=d;_x(d,a,e+12|0,1);f=Ex(x[d>>2],x[d+4>>2],x[d+8>>2],x[d+12>>2]);fb=d+16|0;a=x[31484];if(!a){break c}if(x[e+12>>2]!=(b|0)){break b}h=f;if((a|0)!=68){break a}break b}x[c>>2]=4;break a}x[31484]=g;if(x[e+12>>2]==(b|0)){break a}}x[c>>2]=4;f=h}fb=e+16|0;return f}function kN(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;d=fb-16|0;fb=d;a:{b:{c:{if(b>>>0>=256){b=ac(8);x[31609]=0;d=P(36,d+4|0,10751)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}pc(b,d);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(d);break b}e=(x[a+32>>2]+D(b,872)|0)+1075766|0,f=uC(c*32768),w[e>>1]=f;fb=d+16|0;return}a=N()|0;ic(b)}Q(a|0)}p()}function Xn(a,b,c,d,e,f){var g=0;x[31609]=0;W(996,a|0);g=x[31609];x[31609]=0;a:{b:{if((g|0)!=1){g=x[a+24>>2];x[31609]=0;b=ba(f|0,g|0,b|0,c|0,d|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,e|0,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();b=0}return b}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function pO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=fb-32|0;fb=b;c=Zb(b+24|0,c,d);d=x[c+4>>2];x[b>>2]=x[c>>2];x[b+4>>2]=d;a:{a=Au(a,b,0);if(a+1>>>0>=3){a=ac(8);x[31609]=0;b=P(36,b+12|0,8057)|0;c=x[31609];x[31609]=0;b:{if((c|0)!=1){pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}c=N()|0;tb(b);break b}c=N()|0;ic(a)}Q(c|0);p()}fb=b+32|0;return a|0}p()}function cY(a,b){var c=0,d=0,e=0,f=0;c=fb-32|0;fb=c;a:{if(!y[b+5|0]){while(1){if((d|0)==5){d=0;v[c+28|0]=0;x[c+24>>2]=0;e=c+24|0;f=Zb(c+8|0,e,5);lc(c+16|0,x[a>>2],x[a+8>>2],x[f>>2],x[f+4>>2]);b:{if(x[c+20>>2]!=5){break b}if(jd(e,b,5)){break b}Vb(a,5);d=1}fb=c+32|0;break a}e=b+d|0;d=d+1|0;if(y[e|0]){continue}break}_(17516,9095,602,13238);p()}_(17495,9095,600,13238);p()}return d}function ZK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-32|0;fb=d;e=Dc(d+8|0,c);x[31609]=0;c=d+20|0;S(1230,c|0,b|0,e|0);f=x[31609];x[31609]=0;a:{b:{if((f|0)!=1){x[31609]=0;a=P(1231,a|0,c|0)|0;f=x[31609];x[31609]=0;if((f|0)==1){break b}tb(c);tb(e);x[a>>2]=123812;c=x[b+4>>2];x[a+8>>2]=x[b>>2];x[a+12>>2]=c;fb=d+32|0;return a|0}c=N()|0;break a}c=N()|0;tb(d+20|0)}tb(e);Q(c|0);p()}function n9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=fb-16|0;fb=f;while(1){a:{if((c|0)<=(g|0)){break a}d=x[a+24>>2];e=x[a+28>>2];if(d>>>0>=e>>>0){if((ib[x[x[a>>2]+52>>2]](a,x[b>>2])|0)==-1){break a}g=g+1|0;b=b+4|0}else{x[f+12>>2]=e-d>>2;x[f+8>>2]=c-g;e=d;d=x[Cd(f+12|0,f+8|0)>>2];Ti(e,b,d);e=d<<2;x[a+24>>2]=e+x[a+24>>2];g=g+d|0;b=b+e|0}continue}break}fb=f+16|0;return g|0}function vja(a){a=a|0;var b=0,c=0,d=0,e=0;e=fb-16|0;fb=e;b=Ec(2500);c=fb-2496|0;fb=c;EQ(a,c,c+2496|0);a=0;while(1){if((a|0)==624){x[b+2496>>2]=0;a:{if(x[b>>2]<0){break a}a=1;while(1){if((a|0)!=624){d=a<<2;a=a+1|0;if(!x[b+d>>2]){continue}break a}break}x[b>>2]=-2147483648}fb=c+2496|0}else{d=a<<2;x[d+b>>2]=x[c+d>>2];a=a+1|0;continue}break}a=yf(e+12|0,b);fb=e+16|0;return x[a>>2]}function Ana(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=fb-16|0;fb=d;a:{c=x[b+4>>2];if(!c){break a}w[d>>1]=z[a+480190>>1];w[d+14>>1]=c-1;c=z[Oc(d,d+14|0)>>1];while(1){if(!c){break a}b:{if(EC(x[b>>2],c)){break b}if(YR(a,c&65535)){e=Dc(d,22292);Ac(((c<<5)+a|0)+946304|0,e);tb(e)}if(c>>>0<2){break b}e=z[a+480190>>1];if((e|0)!=(c|0)){break b}w[a+480190>>1]=e-1}c=c-1|0;continue}}fb=d+16|0}function a1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;c=-1;a:{if(!jh(a,7)){break a}c=0;if(!PE(a,11790)){break a}c=fb-16|0;fb=c;f=e+5|0;Mw(c+8|0,f);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;d=(d|0)==(g|0);if(!d){ME(f)}c=-1;if(!d){break a}c=0;if(!OE(y[e+6|0])){break a}c=xe(a,b,NE(f),hb)}fb=e+16|0;return c|0}function Vda(a,b){a=a|0;b=+b;var c=0;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;a:{b:{if((c|0)!=1){c=x[a+24>>2];x[31609]=0;b=+Wa(1089,c|0,+b);c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,7606,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();b=0}return+b}a=N()|0;x[31609]=0;X(26);c=x[31609];x[31609]=0;if((c|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Ox(a,b,c,d,e,f){var g=0,h=0,i=0;g=fb-16|0;fb=g;x[a+4>>2]=0;x[a>>2]=47588;i=Ec(80);x[31609]=0;d=R(1099,d|0)|0;h=x[31609];x[31609]=0;a:{b:{if((h|0)!=1){x[g+8>>2]=d;d=g+8|0;h=x[re(g+12|0,d)>>2];x[31609]=0;b=ha(f|0,i|0,b|0,c-b|0,h|0,e|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break b}x[a+4>>2]=b;Wc(d);fb=g+16|0;return a}a=N()|0;break a}a=N()|0;Wc(g+8|0)}Db(i);Q(a|0);p()}function nia(a,b){a=a|0;b=b|0;var c=E(0);a:{switch(b|0){case 0:return E(B[a+4220>>2]);case 1:return E(B[a+4224>>2]);case 2:return E(B[a+4228>>2]);case 3:return E(y[a+4240|0]?E(1):E(0));case 4:return E(E(E(x[a+4232>>2])*E(.03125)));case 5:return E(y[a+4241|0]?E(1):E(0));case 6:return E(y[a+4242|0]?E(1):E(0));case 7:c=y[a+4244|0]?E(1):E(0);break;default:break a}}return E(c)}function s6(a){a=a|0;if(y[499912]){return x[124977]}if(!y[500424]){v[500424]=1}wd(500256,103384);wd(500268,103412);wd(500280,103440);wd(500292,103472);wd(500304,103512);wd(500316,103548);wd(500328,103576);wd(500340,103612);wd(500352,103628);wd(500364,103644);wd(500376,103660);wd(500388,103676);wd(500400,103692);wd(500412,103708);v[499912]=1;x[124977]=500256;return 500256}function Es(a,b,c,d,e,f){var g=0,h=0,i=0;g=fb-16|0;fb=g;x[a+4>>2]=0;x[a>>2]=47588;i=Ec(80);x[31609]=0;d=R(1099,d|0)|0;h=x[31609];x[31609]=0;a:{b:{if((h|0)!=1){x[g+8>>2]=d;d=g+8|0;h=x[re(g+12|0,d)>>2];x[31609]=0;b=ha(f|0,i|0,b|0,c|0,h|0,e|0)|0;c=x[31609];x[31609]=0;if((c|0)==1){break b}x[a+4>>2]=b;Wc(d);fb=g+16|0;return a}a=N()|0;break a}a=N()|0;Wc(g+8|0)}Db(i);Q(a|0);p()}function yea(a){a=a|0;var b=0,c=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;a:{b:{if((b|0)!=1){b=x[a+24>>2];x[31609]=0;b=R(1064,b|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,7278,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();b=0}return b|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function U_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-32|0;fb=d;e=Nb(a);a=wb(x[b>>2]);x[d+28>>2]=a;f=wb(x[b+4>>2]);a:{while(1){if(Ib(a,f)){b=d+8|0;ri(b,x[a>>2],x[a+4>>2]);if(($b(x[d+8>>2])|0)==(c|0)){lp(b,a);x[31609]=0;O(360,e|0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break a}ub(b)}a=x[em(d+28|0)>>2];continue}break}fb=d+32|0;return}a=N()|0;ub(d+8|0);Rc(e);Q(a|0);p()}function T2(a){a=a|0;var b=0,c=0,d=0,e=0;x[a+44>>2]=0;e=a+32|0;c=Kb(e);b=Cb(x[a+36>>2],y[a+43|0]);d=x[a+48>>2];if(d&8){d=b+c|0;x[a+44>>2]=d;Wn(a,c,c,d);d=x[a+48>>2]}a:{if(!(d&16)){break a}x[a+44>>2]=b+c;hC(e,Mc(e));Fx(a,c,Cb(x[a+36>>2],y[a+43|0])+c|0);if(!(y[a+48|0]&3)){break a}while(1){if((b|0)<0){ys(a,2147483647);b=b-2147483647|0;continue}break}if(!b){break a}ys(a,b)}}function E9(){var a=0,b=0,c=0,d=0,e=0,f=0;b=fb-48|0;fb=b;if(FL(0,b+24|0)){It(x[31484],12758);p()}a=ye(b+16|0,x[b+24>>2],x[b+28>>2]);d=ZA(b+8|0,x[b+32>>2]/1e3|0);c=fb-16|0;fb=c;a=Gu(c,x[a>>2],x[a+4>>2]);e=x[a>>2];f=e+x[d>>2]|0;a=x[d+4>>2]+x[a+4>>2]|0;a=ye(c+8|0,f,f>>>0<e>>>0?a+1|0:a);d=x[a>>2];fb=c+16|0;c=ye(b+40|0,d,x[a+4>>2]);a=x[c>>2];fb=b+48|0;hb=x[c+4>>2];return a|0}function o_(a){var b=0,c=0;a:{if(jd(a,15320,3)){break a}c=y[a+3|0];if(c>>>0>9){break a}if((Bb(y[a+202|0]|y[a+203|0]<<8)-1e4&65535)>>>0<57516){break a}b=1;b:{if(c>>>0>5){break b}if(!Bb(y[a+228|0]|y[a+229|0]<<8)){break a}if(!Bb(y[a+230|0]|y[a+231|0]<<8)){break a}b=0;if(Bb(y[a+232|0]|y[a+233|0]<<8)>>>0>4095){break b}b=Bb(y[a+234|0]|y[a+235|0]<<8)>>>0<100}return b}return 0}function aQ(a){var b=E(0),c=0,d=E(0);b=B[a+4224>>2];B[a+4260>>2]=M(E(E(1)-E(b*b)));v[a+4264|0]=B[a+4236>>2]>E(.5);d=E(A[a+4256>>2]);b=E(E(E(E(B[a+4228>>2]*E(1999))+E(1))/E(1e3))*d);a:{if(b<E(4294967296)&b>=E(0)){c=~~b>>>0;break a}c=0}x[a+4248>>2]=c;c=a+4252|0;b=E(E(E(E(B[a+4232>>2]*E(1999))+E(1))/E(1e3))*d);b:{if(b<E(4294967296)&b>=E(0)){a=~~b>>>0;break b}a=0}x[c>>2]=a}function $A(a,b,c){var d=0,e=0,f=0;f=Fb(a);d=y[b+11|0];e=x[b+4>>2];a=0;x[31609]=0;O(53,f|0,_c(e,d)|0);d=x[31609];x[31609]=0;if((d|0)!=1){a:{while(1){if(_c(x[b+4>>2],y[b+11|0])>>>0>a>>>0){d=65533;e=v[dc(b,a)|0];if((e|0)>=-96){d=x[((e&255)<<2)+c>>2]}x[31609]=0;O(35,f|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break a}a=a+1|0;continue}break}return}}a=N()|0;Ub(f);Q(a|0);p()}function x4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=x[a>>2];f=6;a:{b:{if((e|0)==(b|0)){break b}e=x[e>>2];f=4;if(!rj(d,64,e)){break b}g=qk(d,e);f=4;while(1){c:{e=x[a>>2]+4|0;x[a>>2]=e;g=g-48|0;if((b|0)==(e|0)|f>>>0<2){break c}e=x[e>>2];if(!rj(d,64,e)){break a}f=f-1|0;g=qk(d,e)+D(g,10)|0;continue}break}if((b|0)!=(e|0)){break a}f=2}x[c>>2]=f|x[c>>2]}return g|0}function Mia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=fb-16|0;fb=d;c=Ec(64);x[31609]=0;e=R(875,c|0)|0;f=x[31609];x[31609]=0;a:{if((f|0)!=1){c=yf(d+8|0,e);e=x[c>>2];x[31609]=0;a=U(939,e|0,a|0,b|0)|0;b=x[31609];x[31609]=0;b:{c:{if((b|0)!=1){if((a|0)==1){break c}tc(d+12|0);break b}a=N()|0;mg(c);break a}re(d+12|0,c)}mg(c);fb=d+16|0;return x[d+12>>2]}a=N()|0;Db(c)}Q(a|0);p()}function Hea(a){a=a|0;var b=0,c=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;a:{b:{if((b|0)!=1){b=x[a+24>>2];x[31609]=0;c=+ia(1055,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break b}}Y(T(0)|0)|0;x[31609]=0;V(983,7678,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();c=0}return+c}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function y5(a,b){a=a|0;b=b|0;var c=0,d=0;c=Kb(b);b=fb-32|0;fb=b;a=xd(a,0);x[a>>2]=96496;d=nk(c);x[a+8>>2]=d;if(!d){a=Dc(b+8|0,c);x[31609]=0;c=b+20|0;S(1011,c|0,17552,a|0);d=x[31609];x[31609]=0;a:{b:{if((d|0)!=1){x[31609]=0;W(1367,c|0);c=x[31609];x[31609]=0;if((c|0)==1){break b}p()}c=N()|0;break a}c=N()|0;tb(b+20|0)}tb(a);Q(c|0);p()}fb=b+32|0;x[a>>2]=102872;return a|0}function sV(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;d=Fb(a);a=y[b+11|0];e=x[b+4>>2];x[31609]=0;O(114,d|0,_c(e,a)|0);a=x[31609];x[31609]=0;a:{if((a|0)!=1){a=zd(b);x[c+12>>2]=a;b=Ef(b);while(1){if(!Ib(a,b)){break a}a=y[a|0];x[31609]=0;O(115,d|0,((a|0)==13?10:a)<<24>>24);a=x[31609];x[31609]=0;if((a|0)!=1){a=x[we(c+12|0)>>2];continue}break}}a=N()|0;tb(d);Q(a|0);p()}fb=c+16|0}function Wz(a){var b=E(0),c=E(0),d=0,e=E(0),f=0;b=E(A[x[a+16>>2]+24620>>2]);c=E(E(E(ib[x[x[a>>2]+208>>2]](a))*b)/E(1e3));d=a,e=E(E(c*E(ib[x[x[a>>2]+200>>2]](a)))*E(2048)),B[d+4248>>2]=e;d=a,f=Ml(E(E(c+E(2))*E(4096))),x[d+4256>>2]=f;c=E(ib[x[x[a>>2]+212>>2]](a));B[a+4252>>2]=c;b=E(c/b);if(!(ib[x[x[a>>2]+196>>2]](a)|0)){b=iQ(E(b*E(3.1415927410125732)))}B[a+4244>>2]=b+b}function ij(a,b,c,d,e){var f=0,g=0,h=0;f=fb-16|0;fb=f;x[f+12>>2]=b;b=0;g=6;a:{b:{if(hi(a,f+12|0)){break b}g=4;h=tl(x[a>>2]);if(!rj(d,64,h)){break b}b=qk(d,h);while(1){c:{b=b-48|0;h=io(a);if(hi(h,f+12|0)|(e|0)<2){break c}g=tl(x[h>>2]);if(!rj(d,64,g)){break a}e=e-1|0;b=qk(d,g)+D(b,10)|0;continue}break}g=2;if(!hi(h,f+12|0)){break a}}x[c>>2]=x[c>>2]|g}fb=f+16|0;return b}function hf(a){var b=0,c=0,d=0;d=fb-16|0;fb=d;o(+a);c=j(1)|0;j(0)|0;c=c&2147483647;a:{if(c>>>0<=1072243195){b=1;if(c>>>0<1044816030){break a}b=Wp(a,0);break a}b=a-a;if(c>>>0>=2146435072){break a}c=kI(a,d);a=C[d+8>>3];b=C[d>>3];b:{switch(c&3){case 0:b=Wp(b,a);break a;case 1:b=-Xp(b,a,1);break a;case 2:b=-Wp(b,a);break a;default:break b}}b=Xp(b,a,1)}fb=d+16|0;return b}function SH(a,b,c,d,e){var f=0;f=fb-16|0;fb=f;a:{b:{c:{if(!d){a=ac(8);x[31609]=0;c=P(36,f+4|0,8200)|0;b=x[31609];x[31609]=0;if((b|0)==1){break c}pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}b=N()|0;tb(c);break b}Cl(a,b,e);c=KH(a,c,e,d,75936,76708);C[a+16>>3]=C[a+16>>3]+ +(c>>>0)/+(b|0);fb=f+16|0;return c}b=N()|0;ic(a)}Q(b|0)}p()}function RH(a,b,c,d,e){var f=0;f=fb-16|0;fb=f;a:{b:{c:{if(!d){a=ac(8);x[31609]=0;c=P(36,f+4|0,8200)|0;b=x[31609];x[31609]=0;if((b|0)==1){break c}pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}b=N()|0;tb(c);break b}Cl(a,b,e);c=KH(a,c,e,d,75140,75912);C[a+16>>3]=C[a+16>>3]+ +(c>>>0)/+(b|0);fb=f+16|0;return c}b=N()|0;ic(a)}Q(b|0)}p()}function PO(a){a=a|0;var b=0,c=0,d=0;b=fb-16|0;fb=b;a:{c=x[a+36>>2];d=x[a+40>>2];b:{if(Ib(c,d)){tc(b+12|0);break b}vo(b,a);x[31609]=0;c=R(1056,b|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break a}x[b+12>>2]=c;nf(b);d=x[a+40>>2];c=x[a+36>>2]}c:{if(Ib(c,d)){a=a+36|0;break c}a=x[b+12>>2];c=x[a>>2]}a=hj(c,x[a+4>>2]);yl(b+12|0);fb=b+16|0;return a|0}a=N()|0;nf(b);Q(a|0);p()}function Km(a){if((a|0)>=0){if(a>>>0<=16383){if(a>>>0<=15){return v[a+88864|0]}if(a>>>0<=511){return v[(a>>>5|0)+88864|0]+5|0}return v[(a>>>10|0)+88864|0]+10|0}if(a>>>0<=16777215){if(a>>>0<=524287){return v[(a>>>15|0)+88864|0]+15|0}return v[(a>>>20|0)+88864|0]+20|0}if(a>>>0<=536870911){return v[(a>>>25|0)+88864|0]+25|0}a=v[(a>>>30|0)+88864|0]+30|0}else{a=0}return a}function Ds(a,b,c,d,e){var f=0,g=0,h=0;f=fb-16|0;fb=f;x[a+4>>2]=0;x[a>>2]=47588;h=Ec(80);x[31609]=0;c=R(1099,c|0)|0;g=x[31609];x[31609]=0;a:{b:{if((g|0)!=1){x[f+8>>2]=c;c=f+8|0;g=x[re(f+12|0,c)>>2];x[31609]=0;b=ba(e|0,h|0,b|0,g|0,d|0)|0;d=x[31609];x[31609]=0;if((d|0)==1){break b}x[a+4>>2]=b;Wc(c);fb=f+16|0;return a}a=N()|0;break a}a=N()|0;Wc(f+8|0)}Db(h);Q(a|0);p()}function CN(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;a:{b:{c:{if(b<=0|b>4){a=ac(8);x[31609]=0;c=P(36,c+4|0,7854)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}d=N()|0;tb(c);break b}a=x[a+32>>2];e=a,f=Ye(65536/b),x[e+480244>>2]=f;Bq(a);fb=c+16|0;return}d=N()|0;ic(a)}Q(d|0)}p()}function AN(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;a:{b:{c:{if(b<=0|b>4){a=ac(8);x[31609]=0;c=P(36,c+4|0,7875)|0;d=x[31609];x[31609]=0;if((d|0)==1){break c}pc(a,c);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}d=N()|0;tb(c);break b}a=x[a+32>>2];e=a,f=Ye(b*65536),x[e+480240>>2]=f;Bq(a);fb=c+16|0;return}d=N()|0;ic(a)}Q(d|0)}p()}function Ri(a){var b=0,c=0,d=0;c=fb-16|0;fb=c;o(+a);b=j(1)|0;j(0)|0;b=b&2147483647;a:{if(b>>>0<=1072243195){if(b>>>0<1045430272){break a}a=Xp(a,0,0);break a}if(b>>>0>=2146435072){a=a-a;break a}b=kI(a,c);a=C[c+8>>3];d=C[c>>3];b:{switch(b&3){case 0:a=Xp(d,a,1);break a;case 1:a=Wp(d,a);break a;case 2:a=-Xp(d,a,1);break a;default:break b}}a=-Wp(d,a)}fb=c+16|0;return a}function Pta(a,b){a=a|0;b=b|0;var c=0,d=0;d=fb-16|0;fb=d;c=d+14|0;P$(c,a,b);Cf(b,y[d+14|0],y[Jc(c)|0]);a=y[b+3|0];a:{if((a|0)!=9){if((a|0)!=19){break a}a=y[b+5|0];c=a&240;if((c|0)!=128){if((c|0)!=64){if((c|0)!=48){break a}v[b+3|0]=45;v[b+5|0]=a&15;break a}if((a|0)!=64){break a}v[b+3|0]=0;v[b|0]=254;break a}v[b+3|0]=20;v[b+5|0]=a&15|160;break a}v[b+3|0]=0}fb=d+16|0}function Nsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=fb-240|0;fb=d;c=fb-16|0;fb=c;f=d+4|0;m_(c+8|0,f);e=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(e|0)){id(a,x[c+12>>2])}fb=c+16|0;e=(e|0)==(g|0);if(!e){l_(f)}c=-1;a:{if(!e){break a}c=0;if(!o_(f)){break a}c=xe(a,b,n_(y[d+8|0]|y[d+9|0]<<8|(y[d+10|0]<<16|y[d+11|0]<<24)),hb)}fb=d+240|0;return c|0}function wm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(!vd(y[b+11|0])){c=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=c;x[a+8>>2]=x[b+8>>2];return a|0}c=a;f=x[b>>2];e=fb-16|0;fb=e;a:{b:{d=x[b+4>>2];c:{if(Ok(d)){Ne(a,d);break c}if(d>>>0>=2147483632){break b}qg(e+8|0,Fh(d)+1|0);b=x[e+8>>2];yd(c,b);of(c,x[e+12>>2]);Bd(c,d);c=b}Xg(c,f,d+1|0);fb=e+16|0;break a}pf();p()}return a|0}function pt(a,b,c){var d=0,e=0;if(c&2048){v[a|0]=43;a=a+1|0}if(c&1024){v[a|0]=35;a=a+1|0}d=c&260;if((d|0)!=260){v[a|0]=46;v[a+1|0]=42;a=a+2|0}c=c&16384;while(1){e=y[b|0];if(e){v[a|0]=e;a=a+1|0;b=b+1|0;continue}break}a:{b:{if((d|0)!=256){if((d|0)!=4){break b}b=c?70:102;break a}b=c?69:101;break a}b=c?65:97;if((d|0)==260){break a}b=c?71:103}v[a|0]=b;return(d|0)!=260}function pN(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{b:{c:{if(b>>>0>=256){b=ac(8);x[31609]=0;c=P(36,c+4|0,10751)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}pc(b,c);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(c);break b}a=x[a+32>>2]+D(b,872)|0;x[a+1075008>>2]=0;x[a+1075068>>2]=0;fb=c+16|0;return}a=N()|0;ic(b)}Q(a|0)}p()}function jg(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(!vd(y[b+11|0])){c=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=c;x[a+8>>2]=x[b+8>>2];return a|0}c=a;f=x[b>>2];e=fb-16|0;fb=e;a:{b:{d=x[b+4>>2];c:{if(Ok(d)){Ne(a,d);break c}if(d>>>0>=2147483632){break b}qg(e+8|0,Fh(d)+1|0);b=x[e+8>>2];yd(c,b);of(c,x[e+12>>2]);Bd(c,d);c=b}Dg(c,f,d+1|0);fb=e+16|0;break a}pf();p()}return a|0}function d0(a,b){var c=0,d=0;b=!x[a+24>>2]|b;x[a+16>>2]=b;if(b&x[a+20>>2]){a=fb-16|0;fb=a;c=ac(16);b=fb-16|0;fb=b;if(!y[496496]){v[496496]=1}Zb(b+8|0,1,125628);d=x[b+12>>2];x[a+8>>2]=x[b+8>>2];x[a+12>>2]=d;fb=b+16|0;b=x[a+12>>2];a=x[a+8>>2];x[31609]=0;a=Ca(1232,c|0,8959,a|0,b|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){da(a|0,94316,1233);p()}a=N()|0;ic(c);Q(a|0);p()}}function SB(a,b,c,d,e,f){var g=0,h=0,i=0;g=fb-16|0;fb=g;a:{if(2147483631-b>>>0>=c>>>0){h=Kb(a);i=g+4|0;if(b>>>0<=1073741798){x[g+12>>2]=b<<1;x[g+4>>2]=b+c;c=Fh(x[bd(i,g+12|0)>>2])+1|0}else{c=2147483631}qg(i,c);c=x[g+4>>2];if(e){Xg(c,h,e)}if((d|0)!=(e|0)){Xg((c+e|0)+f|0,e+h|0,d-e|0)}if((b|0)!=10){Db(h)}yd(a,c);of(a,x[g+8>>2]);fb=g+16|0;break a}pf();p()}Bd(a,d+f|0)}function $p(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(!vd(y[b+11|0])){c=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=c;x[a+8>>2]=x[b+8>>2];return a|0}c=a;f=x[b>>2];e=fb-16|0;fb=e;a:{b:{d=x[b+4>>2];c:{if(fr(d)){Ne(a,d);break c}if(d>>>0>=1073741808){break b}Oj(e+8|0,sn(d)+1|0);b=x[e+8>>2];yd(c,b);of(c,x[e+12>>2]);Bd(c,d);c=b}Ti(c,f,d+1|0);fb=e+16|0;break a}pf();p()}return a|0}function HC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-32|0;fb=d;e=Nb(a);a=wb(x[b>>2]);x[d+28>>2]=a;f=wb(x[b+4>>2]);a:{while(1){if(Ib(a,f)){b=d+8|0;ri(b,x[a>>2],x[a+4>>2]);if(x[d+8>>2]==(c|0)){lp(b,a);x[31609]=0;O(360,e|0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break a}ub(b)}a=x[em(d+28|0)>>2];continue}break}fb=d+32|0;return}a=N()|0;ub(d+8|0);Rc(e);Q(a|0);p()}function lN(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{b:{c:{if(b>>>0>=256){b=ac(8);x[31609]=0;c=P(36,c+4|0,10751)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}pc(b,c);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(c);break b}fb=c+16|0;return+(+(x[(x[a+32>>2]+D(b,872)|0)+1075684>>2]-128|0)*.0078125)}a=N()|0;ic(b)}Q(a|0)}p()}function W0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;b:{c:{d:{e:{if((b|0)==4){Uf(a,c);break e}e=d+8|0;Uf(e,c);x[31609]=0;c=d+20|0;S(123,c|0,b|0,e|0);b=x[31609];x[31609]=0;if((b|0)==1){break d}x[31609]=0;S(244,a|0,4,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(c);tb(e)}fb=d+32|0;break a}a=N()|0;break b}a=N()|0;Ub(d+20|0)}tb(d+8|0);Q(a|0);p()}}function VQ(a,b){var c=0,d=0,e=0,f=0,g=0,h=E(0);c=fb-16|0;fb=c;d=0;a:{if(x[(x[x[a>>2]-12>>2]+a|0)+16>>2]){break a}x[c+12>>2]=0;Hk(a,c+12|0);e=x[c+12>>2];d=0;if(e>>>0>65535){break a}Dl(b,e);while(1){if((f|0)==(e|0)){d=!x[(x[x[a>>2]-12>>2]+a|0)+16>>2]}else{x[c+8>>2]=0;vq(a,c+8|0);g=yb(x[b>>2],f),h=B[c+8>>2],B[g>>2]=h;f=f+1|0;continue}break}}a=d;fb=c+16|0;return a}function Dra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;f=fb-16|0;fb=f;c=If(a,c);ae(f,x[a+36>>2]);a:{if(!c){Qc(f,a+32|0,5);e=0;if(Gb(x[x[f>>2]>>2],x[f+4>>2])){break a}}h=x[a+36>>2];g=fb-16|0;fb=g;e=Fb(g+4|0);x[31609]=0;ba(469,b|0,h|0,e|0,d|0)|0;b=x[31609];x[31609]=0;b:{if((b|0)!=1){tb(e);fb=g+16|0;break b}a=N()|0;tb(e);Q(a|0);p()}e=c}ef(a,e);fb=f+16|0}function jN(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{b:{c:{if(b>>>0>=256){b=ac(8);x[31609]=0;c=P(36,c+4|0,10751)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}pc(b,c);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(c);break b}fb=c+16|0;return+(+w[(x[a+32>>2]+D(b,872)|0)+1075766>>1]*30517578125e-15)}a=N()|0;ic(b)}Q(a|0)}p()}function SR(a,b){var c=0,d=0,e=0,f=0;a:{if(z[a+480188>>1]<=b>>>0){break a}b:{c:{c=D(b,872)+a|0;d=y[c+1075783|0];switch(d-31|0){case 1:break b;case 0:break c;default:break a}}if(!(y[a+480209|0]&16)){break a}}e=a+1074376|0;f=(d|0)==32;c=v[c+1075785|0];d:{if((c|0)>=0){d=Pe(a+901692|0,y[(D(b,872)+a|0)+1075836|0]);break d}d=Pe(a+902204|0,c&127)}nT(a,e,b,f,d,c&255)}}function eX(a){var b=0,c=0;a:{if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=-28486832|y[a+63|0]!=26){break a}b=y[a+65|0];if(y[a+66|0]|(b|0)!=16&(b|0)!=1|(y[a+64|0]&3|(y[a+78|0]|y[a+79|0]<<8)>>>0>127)){break a}if((y[a+80|0]|y[a+81|0]<<8)>>>0>127){break a}b=a+80|0;a=a+78|0;a=Zk(y[a|0]|y[a+1|0]<<8,y[b|0]|y[b+1|0]<<8)?b:a;c=(y[a|0]|y[a+1|0]<<8)!=0}return c}function bX(a){var b=0;a:{if((y[a+44|0]|y[a+45|0]<<8|(y[a+46|0]<<16|y[a+47|0]<<24))!=1179472976|y[a+28|0]!=26|(y[a+40|0]|y[a+41|0]<<8|y[a+30|0]>2)){break a}if(((y[a+38|0]|y[a+39|0]<<8)-33&65535)>>>0<65504|((y[a+32|0]|y[a+33|0]<<8)-257&65535)>>>0<65280|((y[a+34|0]|y[a+35|0]<<8)-256&65535)>>>0<65281){break a}b=((y[a+36|0]|y[a+37|0]<<8)-1&65535)>>>0<128}return b}function L4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;while(1){if((b|0)!=(c|0)){a=x[b>>2];a:{b:{if(a>>>0<=127){a=x[(a<<2)+95344>>2];break b}e=(Ws(a)|0)!=0;e=Vs(a)?e|2:e;e=Us(a)?e|4:e;e=Ts(a)?e|8:e;e=Ss(a)?e|16:e;e=Rs(a)?e|32:e;e=Nh(a)?e|64:e;e=Qs(a)?e|128:e;e=Ps(a)?e|256:e;x[d>>2]=e;if(!Os(a)){break a}a=e|512}x[d>>2]=a}d=d+4|0;b=b+4|0;continue}break}return c|0}function Ho(a,b,c,d){a:{if(x[a+480180>>2]==4){if(c){v[b+810|0]=y[b+810|0]&15|c<<4;break a}c=y[b+810|0]>>>4|0;break a}if(d){if(c){v[b+834|0]=c;break a}c=y[b+834|0];break a}if(c){v[b+810|0]=c;break a}c=y[b+810|0]}b:{if(!(v[b+851|0]&1)){break b}c=x[b+688>>2]+((c&255)<<2)|0;x[b+688>>2]=(c|0)>=256?256:c;if(!(v[a+480180|0]&1)){break b}x[b+88>>2]=x[b+88>>2]|2097152}}function Dpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=fb-1120|0;fb=d;c=fb-16|0;fb=c;e=d+12|0;DX(c+8|0,e);f=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(f|0)){id(a,x[c+12>>2])}fb=c+16|0;c=-1;a:{if((f|0)!=(g|0)){break a}c=0;if(!FX(e)){break a}c=xe(a,b,EX(y[d+1116|0]|y[d+1117|0]<<8|(y[d+1118|0]<<16|y[d+1119|0]<<24)),hb)}fb=d+1120|0;return c|0}function jha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a=Li(a,b,c,d);x[a>>2]=43796;b=a+4208|0;e=yb(b,0),f=1060320051,x[e>>2]=f;e=yb(b,1),f=1041865114,x[e>>2]=f;e=yb(b,2),f=1065353216,x[e>>2]=f;e=yb(b,3),f=1049951732,x[e>>2]=f;e=yb(b,4),f=1049951732,x[e>>2]=f;x[31609]=0;O(941,a+44|0,2);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}b=N()|0;_f(a);Q(b|0);p()}function _9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=fb-16|0;fb=d;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(d+8|0,x[vb(d+4|0,a)>>2]);a:{if(!c){break a}x[31609]=0;O(1205,a|0,c|0);e=x[31609];x[31609]=0;if((e|0)!=1){x[31609]=0;V(1206,a|0,b|0,Vd(b,c)|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}}a=N()|0;hM(d+8|0);Q(a|0);p()}b=d+8|0;Qd(b);hM(b);fb=d+16|0;return a|0}function ov(a,b){var c=0,d=0;c=fb-32|0;fb=c;d=c+16|0;aW(d,a,a+1|0,a+2|0,a+3|0);aW(c,b,b+1|0,b+2|0,b+3|0);a=nv(y[x[d>>2]],y[x[c>>2]]);a:{if(!Mj(a)){break a}a=y[x[d+4>>2]];b=y[x[c+4>>2]];a=(a|0)!=(b|0)?a<<24>>24<b<<24>>24?-1:1:0;if(!Mj(a)){break a}a=nv(y[x[d+8>>2]],y[x[c+8>>2]]);if(!Mj(a)){break a}a=nv(y[x[d+12>>2]],y[x[c+12>>2]])}a=vd(a);fb=c+32|0;return a}function Sma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=Fb(a);c=y[b+11|0];e=x[b+4>>2];a=0;x[31609]=0;O(49,d|0,_c(e,c)|0);c=x[31609];x[31609]=0;if((c|0)!=1){a:{b:{while(1){if(_c(x[b+4>>2],y[b+11|0])>>>0<=a>>>0){break b}c=v[dc(b,a)|0];x[31609]=0;O(50,d|0,zf(zf(c))|0);c=x[31609];x[31609]=0;if((c|0)!=1){a=a+1|0;continue}break}break a}return}}a=N()|0;tb(d);Q(a|0);p()}function Jfa(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){b=x[a+24>>2];if(b){Db(sq(b))}x[a+24>>2]=0;b=x[a+20>>2];if(b){Db(b);x[a+20>>2]=0}Db(a);return}Y(T(0)|0)|0;x[31609]=0;V(983,5078,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Tg(a,b){var c=0,d=0,e=0,f=0,g=0;e=Kb(a);d=Cb(x[a+4>>2],y[a+11|0]);c=Df(b);a=0;a:{if(!c){break a}a=e;d=d+a|0;c=b+c|0;b:{if((c|0)==(b|0)){break b}c:{c=c-b|0;if((c|0)>(d-a|0)){break c}g=y[b|0];while(1){f=d-a|0;if((c|0)>(f|0)){break c}a=rq(a,(f-c|0)+1|0,g);if(!a){break c}if(!nt(a,b,c)){break b}a=a+1|0;continue}}a=d}a=(a|0)==(d|0)?-1:a-e|0}return a}function GK(a,b,c,d){var e=0,f=0,g=0;e=fb-16|0;fb=e;a:{if((a|0)!=(b|0)){g=x[31484];x[31484]=0;Od();a=HK(a,e+12|0,d);d=hb;f=x[31484];b:{if(f){if(x[e+12>>2]!=(b|0)){break b}if((f|0)!=68){break a}x[c>>2]=4;b=!!a&(d|0)>=0|(d|0)>0;a=b?-1:0;d=b?2147483647:-2147483648;break a}x[31484]=g;if(x[e+12>>2]==(b|0)){break a}}}x[c>>2]=4;a=0;d=0}fb=e+16|0;hb=d;return a}function Eka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;x[a>>2]=b;c=fb-16|0;fb=c;d=Ec(223888);x[31609]=0;b=P(842,d|0,b+1074376|0)|0;e=x[31609];x[31609]=0;a:{if((e|0)!=1){b=yf(c+12|0,b);fb=c+16|0;b=x[b>>2];break a}a=N()|0;Db(d);Q(a|0);p()}x[a+4>>2]=b;b=Nb(a+8|0);x[31609]=0;W(607,a|0);c=x[31609];x[31609]=0;if((c|0)!=1){return a|0}c=N()|0;Ce(b);cT(a+4|0);Q(c|0);p()}function aq(a,b,c){var d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;f=d+12|0;cd(f,b);x[31609]=0;b=R(1253,x[d+12>>2])|0;e=x[31609];x[31609]=0;a:{if((e|0)==1){break a}x[31609]=0;e=R(1261,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break a}x[c>>2]=e;x[31609]=0;O(1262,a|0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break a}_b(f);fb=d+16|0;return}a=N()|0;_b(d+12|0);Q(a|0);p()}function dB(a,b,c,d){a:{if(x[a+1074392>>2]!=(c|0)){break a}b:{if(d){c=D(b,872)+a|0;x[c+1075688>>2]=0;d=c+1075e3|0;x[d>>2]=0;x[d+4>>2]=0;c=x[c+1075080>>2]|4096;break b}c=D(b,872)+a|0;x[c+1075680>>2]=0;c=x[c+1075080>>2]}d=D(b,872)+a|0;x[d+1075080>>2]=c|2097152;Ym(a,b,255,0);if(!(y[d+1075081|0]&2)){break a}a=x[a+1298300>>2];if(!Ed(a)){break a}Fj(a,b,0)}}function cq(a,b,c){var d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;f=d+12|0;cd(f,b);x[31609]=0;b=R(1235,x[d+12>>2])|0;e=x[31609];x[31609]=0;a:{if((e|0)==1){break a}x[31609]=0;e=R(1247,b|0)|0;g=x[31609];x[31609]=0;if((g|0)==1){break a}v[c|0]=e;x[31609]=0;O(1248,a|0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break a}_b(f);fb=d+16|0;return}a=N()|0;_b(d+12|0);Q(a|0);p()}function Yr(a,b,c){var d=0,e=0,f=0,g=0;a:{d=Ak(b,zd(a));b=Ak(c,b);if(Cb(x[a+4>>2],y[a+11|0])>>>0>=d>>>0){if((b|0)==-1){WT(a,d);break a}c=a;e=fb-16|0;fb=e;x[e+12>>2]=b;if(b){f=Cb(x[a+4>>2],y[a+11|0]);g=Kb(a);b=f-d|0;x[e+8>>2]=b;a=x[Hb(e+12|0,e+8|0)>>2];b:{if((b|0)==(a|0)){a=b;break b}d=d+g|0;Pi(d,a+d|0,b-a|0)}Vu(c,g,f-a|0)}fb=e+16|0;break a}en();p()}}function Ffa(a,b){a=a|0;b=b|0;var c=0;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;a:{b:{if((c|0)!=1){x[a+16>>2]=b;b=x[a+20>>2];if(!b){break b}Db(b);x[a+20>>2]=0;return}Y(T(0)|0)|0;x[31609]=0;V(983,5660,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z()}return}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Y3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=x[a+84>>2];f=x[e>>2];d=x[e+4>>2];h=x[a+28>>2];g=x[a+20>>2]-h|0;g=d>>>0<g>>>0?d:g;if(g){zc(f,h,g);f=g+x[e>>2]|0;x[e>>2]=f;d=x[e+4>>2]-g|0;x[e+4>>2]=d}d=c>>>0>d>>>0?d:c;if(d){zc(f,b,d);f=d+x[e>>2]|0;x[e>>2]=f;x[e+4>>2]=x[e+4>>2]-d}v[f|0]=0;b=x[a+44>>2];x[a+28>>2]=b;x[a+20>>2]=b;return c|0}function Wga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;b=rQ(a,b,c,d,e^1);x[b>>2]=44408;a=b+4208|0;f=yb(a,0),g=1056964608,x[f>>2]=g;f=yb(a,1),g=1065353216,x[f>>2]=g;f=yb(a,2),g=1020054733,x[f>>2]=g;f=yb(a,3),g=1065353216,x[f>>2]=g;f=yb(a,4),g=1056964608,x[f>>2]=g;f=yb(a,5),g=1048406533,x[f>>2]=g;f=yb(a,6),g=1056964608,x[f>>2]=g;return b|0}function qsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=fb-576|0;fb=d;c=fb-16|0;fb=c;UZ(c+8|0,d);e=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);f=x[c+4>>2];if((f|0)==(e|0)){id(a,x[c+12>>2])}fb=c+16|0;e=(e|0)==(f|0);if(!e){TZ(d)}c=-1;a:{if(!e){break a}c=0;if(!WZ(d)){break a}c=xe(a,b,VZ(y[d+34|0]|y[d+35|0]<<8,y[d+36|0]|y[d+37|0]<<8),hb)}fb=d+576|0;return c|0}function NH(a,b,c){var d=0;d=fb-16|0;fb=d;a:{b:{c:{if(b>>>0>=256){b=ac(8);x[31609]=0;c=P(36,d+4|0,10751)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}pc(b,c);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(c);break b}a=(x[a+32>>2]+D(b,872)|0)+1075080|0;x[a>>2]=x[a>>2]|c;fb=d+16|0;return}a=N()|0;ic(b)}Q(a|0)}p()}function DN(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{b:{c:{if(b-513>>>0<=4294966814){b=ac(8);x[31609]=0;c=P(36,c+4|0,9379)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}pc(b,c);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(c);break b}x[x[a+32>>2]+1074420>>2]=D(b,1e4);fb=c+16|0;return}a=N()|0;ic(b)}Q(a|0)}p()}function l6(a){a=a|0;if(y[499904]){return x[124975]}if(!y[500248]){v[500248]=1}ld(500080,5240);ld(500092,5247);ld(500104,5213);ld(500116,5221);ld(500128,5204);ld(500140,5254);ld(500152,5231);ld(500164,9774);ld(500176,9980);ld(500188,11310);ld(500200,12946);ld(500212,5503);ld(500224,10813);ld(500236,6622);v[499904]=1;x[124975]=500080;return 500080}function v_(a){var b=0,c=0;a:{if(jd(a,13968,3)|(y[a+3|0]-1&255)>>>0>3){break a}if(Bb(y[a+196|0]|y[a+197|0]<<8)>>>0>255){break a}if((Bb(y[a+198|0]|y[a+199|0]<<8)-1&65535)>>>0>255){break a}if((Bb(y[a+200|0]|y[a+201|0]<<8)-1&65535)>>>0>31){break a}b=Bb(y[a+202|0]|y[a+203|0]<<8);if(b>>>0>256){break a}c=Bb(y[a+204|0]|y[a+205|0]<<8)>>>0<b>>>0}return c}function vR(a){var b=0,c=0;a:{if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=1163089229){break a}b=y[a+4|0]|y[a+5|0]<<8|(y[a+6|0]<<16|y[a+7|0]<<24);if((b|0)!=-1095062050&(b|0)!=-1346458146){break a}b=y[a+16|0]|y[a+17|0]<<8|(y[a+18|0]<<16|y[a+19|0]<<24);if(!b){break a}c=(b+24|0)==(y[a+8|0]|y[a+9|0]<<8|(y[a+10|0]<<16|y[a+11|0]<<24))}return c}function tsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;if(A[a+4>>2]<A[Ab(a)>>2]){d=fb-16|0;fb=d;a=xh(d+4|0,a,1);a_(x[a+4>>2],z[b>>1],y[c|0]);x[a+4>>2]=x[a+4>>2]+4;kc(a);fb=d+16|0;return}e=fb-32|0;fb=e;d=Ab(a);d=Zf(e+12|0,Mf(a,oc(x[a>>2],x[a+4>>2])+1|0),oc(x[a>>2],x[a+4>>2]),d);a_(x[d+8>>2],z[b>>1],y[c|0]);x[d+8>>2]=x[d+8>>2]+4;Xr(a,d);Yf(d);fb=e+32|0}function Wta(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=fb-16|0;fb=e;a:{if(!(c&1024)){break a}f=e,g=zd(b),x[f+12>>2]=g;c=_c(x[b+4>>2],y[b+11|0]);b:{if(!c){break b}if(y[dc(b,0)|0]!=43){if(y[dc(b,0)|0]!=45){break b}}d=d+1|0;pV(e+12|0)}if(c>>>0>=d>>>0){break a}KE(b,x[vb(e+8|0,x[e+12>>2])>>2],d-_c(x[b+4>>2],y[b+11|0])|0,48)}Uc(a,b);fb=e+16|0}function Go(a,b,c,d){a:{if(x[a+480180>>2]==4){d=y[b+810|0];if(c){v[b+810|0]=d&240|c;break a}c=d&15;break a}if(d){if(c){v[b+834|0]=c;break a}c=y[b+834|0];break a}if(c){v[b+810|0]=c;break a}c=y[b+810|0]}b:{if(!(v[b+851|0]&1)){break b}c=x[b+688>>2]-((c&255)<<2)|0;x[b+688>>2]=(c|0)>0?c:0;if(!(v[a+480180|0]&1)){break b}x[b+88>>2]=x[b+88>>2]|2097152}}function Wx(a,b,c,d){v[a+53|0]=1;a:{if(x[a+4>>2]!=(c|0)){break a}v[a+52|0]=1;c=x[a+16>>2];b:{if(!c){x[a+36>>2]=1;x[a+24>>2]=d;x[a+16>>2]=b;if((d|0)!=1){break a}if(x[a+48>>2]==1){break b}break a}if((b|0)==(c|0)){c=x[a+24>>2];if((c|0)==2){x[a+24>>2]=d;c=d}if(x[a+48>>2]!=1){break a}if((c|0)==1){break b}break a}x[a+36>>2]=x[a+36>>2]+1}v[a+54|0]=1}}function JE(a,b,c,d){var e=0,f=0;a:{e=y[a|0];f=y[c|0];b:{if(!(y[d|0]|((e|0)!=11|(f-5&255)>>>0>1))){v[a|0]=(f|0)==5?7:6;break b}if(!(y[b|0]|((f|0)!=11|(e-5&255)>>>0>1))){v[a|0]=(e|0)==5?7:6;v[b|0]=y[d|0];break b}if(!((e|0)!=10|(f|0)!=20|y[d|0]!=159)){v[a|0]=42;break b}if((f|0)!=10|(e|0)!=20|y[b|0]!=159){break a}v[a|0]=42;v[b|0]=y[d|0]}v[c|0]=0}}function qM(a){var b=0,c=0,d=0,e=0,f=0,g=0;a:{b=x[a>>2];b:{if(!b){break b}c=x[a+8>>2];if(!c){break b}d=x[a+12>>2];if(!d){break b}a=ib[d|0](b)|0;e=hb;if((e|0)<0){break b}if((ib[c|0](b,0,0,0)|0)<0){break a}if((ib[c|0](b,0,0,2)|0)<0){break a}d=ib[d|0](b)|0;f=hb;ib[c|0](b,a,e,0)|0;if((f|0)<0){break b}g=Tu(d,f)}return g}ib[c|0](b,a,e,0)|0;return 0}function Vf(a,b,c,d){var e=0,f=0,g=0;a:{if(!Cb(x[a+4>>2],y[a+11|0])|(c-b|0)<5){break a}ut(b,c);e=c-4|0;c=Kb(a);g=c+Cb(x[a+4>>2],y[a+11|0])|0;b:{while(1){c:{a=y[c|0];f=a-127|0;if(b>>>0>=e>>>0){break c}if((a|0)!=x[b>>2]&(f&255)>>>0>=130){break b}b=b+4|0;c=((g-c|0)>1)+c|0;continue}break}if((f&255)>>>0<130|a>>>0>x[e>>2]-1>>>0){break a}}x[d>>2]=4}}function J3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=fb+-64|0;fb=d;e=1;a:{if(lh(a,b,0)){break a}e=0;if(!b){break a}b=hB(b,124148,124196);e=0;if(!b){break a}Rb(d+12|0,0,52);x[d+56>>2]=1;x[d+20>>2]=-1;x[d+16>>2]=a;x[d+8>>2]=b;ib[x[x[b>>2]+28>>2]](b,d+8|0,x[c>>2],1);a=x[d+32>>2];if((a|0)==1){x[c>>2]=x[d+24>>2]}e=(a|0)==1}a=e;fb=d- -64|0;return a|0}function EN(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{b:{c:{if(b-65536>>>0<=4294901760){b=ac(8);x[31609]=0;c=P(36,c+4|0,5848)|0;a=x[31609];x[31609]=0;if((a|0)==1){break c}pc(b,c);x[31609]=0;S(97,b|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(c);break b}x[x[a+32>>2]+1074416>>2]=b;fb=c+16|0;return}a=N()|0;ic(b)}Q(a|0)}p()}function CF(a,b){var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;a:{if(b>>>0<3){if(!b){break a}if(!Mb(x[a>>2],x[a+8>>2],b)){break a}while(1)if((d|0)==2){bj(c+10|0,z[c+14>>1]);d=z[c+10>>1];break a}else{v[c+13|0]=0;f=(c+14|0)+d|0;if(b>>>0>d>>>0){eh(a,c+13|0);e=y[c+13|0]}else{e=0}v[f|0]=e;d=d+1|0;continue}}_(11251,9095,325,14260);p()}fb=c+16|0;return d&65535}function _0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a:{e=fb-32|0;fb=e;f=e+8|0;HE(f,c);c=y[d|0];x[31609]=0;O(243,e+20|0,c|0);c=x[31609];x[31609]=0;b:{c:{if((c|0)!=1){mk(e,f);x[31609]=0;V(92,a|0,b|0,x[e>>2],x[e+4>>2]);a=x[31609];x[31609]=0;if((a|0)==1){break c}Bg(f);fb=e+32|0;break a}a=N()|0;tb(e+8|0);break b}a=N()|0;Bg(e+8|0)}Q(a|0);p()}}function OH(a,b,c,d,e,f,g){var h=0,i=0,j=0;h=fb-16|0;fb=h;a:{b:{c:{if(b<g|b>f){a=ac(8);x[31609]=0;d=P(36,h+4|0,e|0)|0;e=x[31609];x[31609]=0;if((e|0)==1){break c}pc(a,d);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}e=N()|0;tb(d);break b}i=x[a+32>>2]+d|0,j=Ye(b*c),x[i>>2]=j;fb=h+16|0;return}e=N()|0;ic(a)}Q(e|0)}p()}function Ifa(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;a:{b:{if((b|0)!=1){x[a+16>>2]=0;b=x[a+20>>2];if(!b){break b}Db(b);x[a+20>>2]=0;return}Y(T(0)|0)|0;x[31609]=0;V(983,8932,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z()}return}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function bJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;a=BJ(a,c);x[a>>2]=96376;c=nk(Kb(b));x[a+16>>2]=c;a:{b:{c:{if(!c){x[31609]=0;c=d+4|0;S(1002,c|0,18013,b|0);b=x[31609];x[31609]=0;if((b|0)==1){break c}x[31609]=0;W(1367,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}b=N()|0;tb(c);break b}fb=d+16|0;return a|0}b=N()|0}et(a);Q(b|0)}p()}function Yaa(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;a:{b:{if((tk(y[a+140|0])|0)!=1){break b}if((WM(a)|0)!=(b|0)){break b}d=a+120|0;au(y[d+20|0]);b=fb-16|0;fb=b;x[b+12>>2]=c+15;a=fb-16|0;fb=a;x[a+12>>2]=1151;x[a+8>>2]=1152;x[a+4>>2]=1153;x[a>>2]=1154;ib[x[lq(a,tk(y[d+20|0]))>>2]](b+12|0,d);fb=a+16|0;fb=b+16|0;break a}VM(a,1,b)}fb=c+16|0}function Gfa(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;a:{b:{if((b|0)!=1){a=x[a+20>>2];if(!a){break b}return Cg(a)|0}Y(T(0)|0)|0;x[31609]=0;V(983,12259,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();return 0}return Cg(22292)|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function q2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=fb-16|0;fb=d;x[d>>2]=b;x[d+4>>2]=c;x[d+8>>2]=b;x[d+12>>2]=c;f=fb-16|0;fb=f;g=fb-16|0;fb=g;e=g+4|0;x[e+4>>2]=1;h=e,i=Ec(24),x[h+8>>2]=i;b=tm(x[e+8>>2]);x[b>>2]=78312;CG(nc(b),x[d>>2],x[d+4>>2]);c=f+8|0;b=Sn(e);Rn(c,nc(b),b);um(e);fb=g+16|0;Ff(a,c);me(c);fb=f+16|0;fb=d+16|0}function pv(a,b){var c=0,d=0;if(a-268435457>>>0>=4026531840){a=a+208|0;c=D(a,b);Iua(b,0,a,0);a=hb?0:c}else{a=0}a:{if(!a){break a}x[31609]=0;b=R(781,a|0)|0;c=x[31609];x[31609]=0;b:{c:{if((c|0)==1){Y(T(0)|0)|0;x[31609]=0;X(26);c=x[31609];x[31609]=0;b=0;if((c|0)==1){break c}}break b}T(0)|0;Sb();p()}if(!b){break a}d=Rb(b,0,a)- -64|0}return d}function lba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=x[b+1298404>>2];b=fb-32|0;fb=b;e=b+8|0;Uf(e,c);x[31609]=0;c=b+20|0;S(502,c|0,d|0,e|0);d=x[31609];x[31609]=0;b:{c:{if((d|0)!=1){x[31609]=0;S(244,a|0,0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(c);tb(e);fb=b+32|0;break a}a=N()|0;break b}a=N()|0;Ub(b+20|0)}tb(b+8|0);Q(a|0);p()}}function kk(a,b){a:{if((b|0)>=1024){a=a*898846567431158e293;if(b>>>0<2047){b=b-1023|0;break a}a=a*898846567431158e293;b=((b|0)>=3069?3069:b)-2046|0;break a}if((b|0)>-1023){break a}a=a*2004168360008973e-307;if(b>>>0>4294965304){b=b+969|0;break a}a=a*2004168360008973e-307;b=((b|0)<=-2960?-2960:b)+1938|0}l(0,0);l(1,b+1023<<20);return a*+n()}function ata(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=fb-112|0;fb=d;c=fb-16|0;fb=c;f=d+14|0;K_(c+8|0,f);e=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(e|0)){id(a,x[c+12>>2])}fb=c+16|0;e=(e|0)==(g|0);if(!e){J_(f)}c=-1;a:{if(!e){break a}c=0;if(!M_(f)){break a}c=xe(a,b,L_(y[d+61|0]|y[d+62|0]<<8),hb)}fb=d+112|0;return c|0}function KG(a){var b=0;if(!((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=1129474426|(y[a+4|0]|y[a+5|0]<<8|(y[a+6|0]<<16|y[a+7|0]<<24))!=1634291279|(y[a+8|0]|y[a+9|0]<<8)!=14|(!(y[a+12|0]|y[a+13|0]<<8)|(y[a+14|0]|y[a+15|0]<<8|(y[a+16|0]<<16|y[a+17|0]<<24))<=0))){b=(y[a+18|0]|y[a+19|0]<<8|(y[a+20|0]<<16|y[a+21|0]<<24))>>>0>23}return b}function FT(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=fb-16|0;fb=f;i=x[d+20>>2];h=x[d+52>>2];g=!h|e;v[f+15|0]=g;a:{if(!g|(b|0)!=2){break a}g=c&65535;c=0;while(1){if((c|0)==(g|0)){break a}x[(D(c,872)+d|0)+1380>>2]=0;c=c+1|0;continue}}x[d+24>>2]=0;x[d+16>>2]=0;x[d+20>>2]=0;x[d+48>>2]=h;w[d+72>>1]=z[d+74>>1];ee(a,i>>>0>1&e&(b|0)==1,f+15|0);fb=f+16|0}function tea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;x[31609]=0;W(996,a|0);f=x[31609];x[31609]=0;if((f|0)!=1){return gu(x[x[a+24>>2]+24>>2],b,c,d,e)|0}Y(T(0)|0)|0;x[31609]=0;V(983,12502,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function gf(a,b,c){var d=0,e=0,f=0;e=Fb(a);d=y[b+11|0];f=x[b+4>>2];a=0;x[31609]=0;O(53,e|0,_c(f,d)|0);d=x[31609];x[31609]=0;if((d|0)!=1){a:{while(1){if(_c(x[b+4>>2],y[b+11|0])>>>0>a>>>0){d=x[(y[dc(b,a)|0]<<2)+c>>2];x[31609]=0;O(35,e|0,d|0);d=x[31609];x[31609]=0;if((d|0)==1){break a}a=a+1|0;continue}break}return}}a=N()|0;Ub(e);Q(a|0);p()}function a7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;while(1){a:{if((c|0)==(d|0)|e>>>0<=h>>>0){break a}f=1;g=fb-16|0;fb=g;k=rh(g+12|0,x[a+8>>2]);i=eq(0,c,d-c|0,b?b:501716);qh(k);fb=g+16|0;b:{switch(i+2|0){default:f=i;break;case 0:case 1:break a;case 2:break b}}h=h+1|0;j=f+j|0;c=c+f|0;continue}break}return j|0}function QB(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;v[a+6|0]=0;v[a+7|0]=0;v[a+23|0]=0;v[a+24|0]=0;v[a+25|0]=0;v[a+26|0]=0;v[a+16|0]=0;v[a+17|0]=0;v[a+18|0]=0;v[a+19|0]=0;v[a+20|0]=0;v[a+21|0]=0;v[a+22|0]=0;v[a+23|0]=0;v[a+8|0]=0;v[a+9|0]=0;v[a+10|0]=0;v[a+11|0]=0;v[a+12|0]=0;v[a+13|0]=0;v[a+14|0]=0;v[a+15|0]=0}function r1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=fb-512|0;fb=d;c=fb-16|0;fb=c;f=d+15|0;pF(c+8|0,f);e=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(e|0)){id(a,x[c+12>>2])}fb=c+16|0;e=(e|0)==(g|0);if(!e){oF(f)}c=-1;a:{if(!e){break a}c=0;if(!rF(f)){break a}c=xe(a,b,qF(y[d+125|0],y[d+126|0]),hb)}fb=d+512|0;return c|0}function XJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=fb-16|0;fb=d;i=x[b>>2];h=x[a>>2];e=x[gc(a)>>2]==1274;f=x[c>>2];g=f-h|0;f=g>>>0>=2147483647?-1:(h|0)==(f|0)?4:g<<1;g=Qv(e?0:h,f);if(g){if(!e){ne(a)}x[d+4>>2]=1239;e=De(d+8|0,g,d+4|0);a=UJ(a,e);Lc(e);x[b>>2]=x[a>>2]+(i-h|0);x[c>>2]=x[a>>2]+(f&-4);fb=d+16|0;return}Uv();p()}function RK(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=fb-16|0;fb=b;e=b+16|0;a:{while(1){d=x[a+36>>2];c=b+8|0;f=ib[x[x[d>>2]+20>>2]](d,x[a+40>>2],c,e,b+4|0)|0;d=-1;g=c;c=x[b+4>>2]-c|0;if((fm(g,1,c,x[a+32>>2])|0)!=(c|0)){break a}b:{switch(f-1|0){case 1:break a;case 0:continue;default:break b}}break}d=iu(x[a+32>>2])?-1:0}fb=b+16|0;return d|0}function $1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=fb-32|0;fb=e;f=x[b+16>>2];a:{if(f>>>0<=c>>>0){cc(a,x[d>>2],0);break a}g=x[b+12>>2];b=x[b+4>>2];x[e+20>>2]=x[d+4>>2];x[e+16>>2]=f-c;cc(e+24|0,x[d>>2],x[Hb(e+20|0,e+16|0)>>2]);d=x[x[b>>2]+28>>2];f=x[e+28>>2];x[e+8>>2]=x[e+24>>2];x[e+12>>2]=f;ib[d|0](a,b,c+g|0,e+8|0)}fb=e+32|0}function mR(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;if((a|0)!=(b|0)){c=x[b>>2];d=x[b+4>>2];b=Sd(c,d);e=fb-16|0;fb=e;a:{if(Vg(a)>>>0>=b>>>0){f=x[a>>2];g=oc(f,x[a+4>>2]);if(b>>>0>g>>>0){h=c;c=fD(c,g);tA(h,c,f);xq(a,c,d,b-oc(x[a>>2],x[a+4>>2])|0);break a}Hv(e+8|0,c,d,f);Jd(a,x[e+12>>2]);break a}pr(a);lm(a,Mf(a,b));xq(a,c,d,b)}fb=e+16|0}return a}function ZS(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;d=x[a+16>>2];e=d?y[(D(b,872)+a|0)+1429|0]:e;f=x[a+40>>2];b=D(b,872)+a|0;a=b+1467|0;v[a|0]=y[a|0]|64;a=b+1468|0;h=a;i=x[a>>2];g=(+(d>>>0)+1)*+(c|0)/+(f>>>0);a:{if(F(g)<2147483648){a=~~g;break a}a=-2147483648}x[h>>2]=i+(a+((c|0)<0?e:0-e|0)|0);c=(d+1|0)==(f|0)?c:a;a=c>>31;v[b+1429|0]=(a^c)-a}function Nja(a){a=a|0;var b=0,c=0,d=0;b=fb-32|0;fb=b;v[b+23|0]=0;v[b+24|0]=0;v[b+25|0]=0;v[b+26|0]=0;v[b+27|0]=0;v[b+28|0]=0;v[b+29|0]=0;v[b+30|0]=0;x[b+16>>2]=0;x[b+20>>2]=0;d=b+16|0;c=Zb(b,d,15);lc(b+8|0,x[a>>2],x[a+8>>2],x[c>>2],x[c+4>>2]);c=0;a:{if(x[b+12>>2]!=15){break a}if(jd(d,8525,15)){break a}Vb(a,15);c=1}fb=b+32|0;return c|0}function Fqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a:{e=fb-32|0;fb=e;f=e+8|0;Fr(f,c);x[31609]=0;O(597,e+20|0,d|0);c=x[31609];x[31609]=0;b:{c:{if((c|0)!=1){mk(e,f);x[31609]=0;V(301,a|0,b|0,x[e>>2],x[e+4>>2]);a=x[31609];x[31609]=0;if((a|0)==1){break c}Bg(f);fb=e+32|0;break a}a=N()|0;tb(e+8|0);break b}a=N()|0;Bg(e+8|0)}Q(a|0);p()}}function Eta(a,b){a=a|0;b=b|0;var c=0,d=0;b=fb-32|0;fb=b;d=b+20|0;c=-1;a:{if(!dE(a,d)){break a}c=0;if(!r$(d)){break a}if((y[b+20|0]|y[b+21|0]<<8|(y[b+22|0]<<16|y[b+23|0]<<24))==1179472708){c=-1;if(!id(a,4)){break a}}c=-1;if(!ik(a,b+12|0)){break a}c=(y[b+12|0]|y[b+13|0]<<8|(y[b+14|0]<<16|y[b+15|0]<<24))==1196314451}fb=b+32|0;return c|0}function DF(a,b){var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;a:{if(b>>>0<5){if(!b){break a}if(!Mb(x[a>>2],x[a+8>>2],b)){break a}while(1)if((d|0)==4){Mm(c+4|0,x[c+12>>2]);d=x[c+4>>2];break a}else{v[c+11|0]=0;f=(c+12|0)+d|0;if(b>>>0>d>>>0){eh(a,c+11|0);e=y[c+11|0]}else{e=0}v[f|0]=e;d=d+1|0;continue}}_(11251,9095,325,14260);p()}fb=c+16|0;return d}function taa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=fb-16|0;fb=e;g=x[d+4>>2];pz(b,c,g);f=x[b+16>>2];a:{if(f>>>0<=c>>>0){cc(a,x[d>>2],0);break a}x[e+12>>2]=f-c;x[e+8>>2]=g;d=x[d>>2];f=x[Hb(e+12|0,e+8|0)>>2];vr(e,d,g,0,f);h=x[e>>2];i=x[e+4>>2];aE(uf(wb(x[b+4>>2]),c),uf(wb(x[b+4>>2]),c+i|0),h);vr(a,d,g,0,f)}fb=e+16|0}function gja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);c=x[b>>2];d=c;b=x[b+4>>2];e=b;c=oc(c,b);b=fb-16|0;fb=b;Rd(b+8|0,x[vb(b+4|0,a)>>2]);a:{b:{if(c){x[31609]=0;O(225,a|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break b}xq(a,d,e,c)}c=b+8|0;Qd(c);bh(c);fb=b+16|0;break a}a=N()|0;bh(b+8|0);Q(a|0);p()}return a|0}function Aqa(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(c+8|0,x[vb(c+4|0,a)>>2]);a:{if(!b){break a}x[31609]=0;O(590,a|0,b|0);d=x[31609];x[31609]=0;if((d|0)!=1){x[31609]=0;O(591,a|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}}a=N()|0;oY(c+8|0);Q(a|0);p()}b=c+8|0;Qd(b);oY(b);fb=c+16|0;return a|0}function j1(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(c+8|0,x[vb(c+4|0,a)>>2]);a:{if(!b){break a}x[31609]=0;O(226,a|0,b|0);d=x[31609];x[31609]=0;if((d|0)!=1){x[31609]=0;O(227,a|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}}a=N()|0;WE(c+8|0);Q(a|0);p()}b=c+8|0;Qd(b);WE(b);fb=c+16|0;return a|0}function Hr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=wb(x[b>>2]);g=wb(x[b+4>>2]);e=fb-16|0;fb=e;x[e+12>>2]=d;while(1){a:{if(!Ib(d,g)){break a}f=fb-16|0;fb=f;ri(f+8|0,x[d>>2],x[d+4>>2]);h=$b(x[f+8>>2]);fb=f+16|0;if((c|0)==(h|0)){break a}d=x[em(e+12|0)>>2];continue}break}fb=e+16|0;if(mc(d,wb(x[b+4>>2]))){_h(a);return}lp(a,d)}function Gsa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a:{e=fb-32|0;fb=e;f=e+8|0;YZ(f,c);x[31609]=0;O(91,e+20|0,d|0);c=x[31609];x[31609]=0;b:{c:{if((c|0)!=1){mk(e,f);x[31609]=0;V(92,a|0,b|0,x[e>>2],x[e+4>>2]);a=x[31609];x[31609]=0;if((a|0)==1){break c}Bg(f);fb=e+32|0;break a}a=N()|0;tb(e+8|0);break b}a=N()|0;Bg(e+8|0)}Q(a|0);p()}}function CC(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);c=x[b>>2];d=c;b=x[b+4>>2];e=b;c=Xc(c,b);b=fb-16|0;fb=b;Rd(b+8|0,x[vb(b+4|0,a)>>2]);a:{b:{if(c){x[31609]=0;O(322,a|0,c|0);f=x[31609];x[31609]=0;if((f|0)==1){break b}zn(a,d,e,c)}c=b+8|0;Qd(c);Zi(c);fb=b+16|0;break a}a=N()|0;Zi(b+8|0);Q(a|0);p()}return a|0}function zP(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=fb-16|0;fb=b;a=Nb(a);x[31609]=0;c=b+4|0;W(986,c|0);d=x[31609];x[31609]=0;a:{b:{if((d|0)!=1){d=wb(x[b+4>>2]);e=wb(x[b+8>>2]);f=x[vb(b,a)>>2];x[31609]=0;S(987,d|0,e|0,f|0);d=x[31609];x[31609]=0;if((d|0)==1){break b}wc(c);fb=b+16|0;return}c=N()|0;break a}c=N()|0;wc(b+4|0)}Td(a);Q(c|0);p()}function z4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a:{e=fb-32|0;fb=e;f=e+8|0;$n(f,c);x[31609]=0;O(91,e+20|0,d|0);c=x[31609];x[31609]=0;b:{c:{if((c|0)!=1){mk(e,f);x[31609]=0;V(92,a|0,b|0,x[e>>2],x[e+4>>2]);a=x[31609];x[31609]=0;if((a|0)==1){break c}Bg(f);fb=e+32|0;break a}a=N()|0;tb(e+8|0);break b}a=N()|0;Bg(e+8|0)}Q(a|0);p()}}function ad(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=fb-16|0;fb=d;qm(b);e=a+8|0;f=yf(d+12|0,b);a:{b=x[a+8>>2];if(oc(b,x[a+12>>2])>>>0<=c>>>0){x[31609]=0;O(1328,e|0,c+1|0);a=x[31609];x[31609]=0;if((a|0)==1){break a}b=x[e>>2]}a=yb(b,c);b=x[a>>2];if(b){vm(b);a=yb(x[e>>2],c)}g=a,h=ne(f),x[g>>2]=h;oJ(f);fb=d+16|0;return}a=N()|0;oJ(f);Q(a|0);p()}function _na(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;c=fb-16|0;fb=c;x[c+12>>2]=4925421;x[c+8>>2]=2147483647;e=Hb(c+12|0,c+8|0);fb=c+16|0;if(A[e>>2]<b>>>0){ed();p()}if(b>>>0>=4925422){Tj();p()}c=Ec(D(b,872));x[d+12>>2]=b;x[d+8>>2]=c;b=x[d+8>>2];x[a+4>>2]=b;x[a>>2]=b;f=Ab(a),g=b+D(x[d+12>>2],872)|0,x[f>>2]=g;fb=d+16|0}function Jha(a){a=a|0;var b=0,c=0,d=0,e=0;b=fb-16|0;fb=b;x[x[a+20>>2]+148>>2]=-1;Ir(b+8|0,a+4228|0);c=x[a+20>>2];d=wb(x[b+8>>2]);e=Zj(x[b+8>>2],x[b+12>>2]);x[31609]=0;S(965,c+4|0,d|0,e|0);c=x[31609];x[31609]=0;a:{if((c|0)==1){c=T(124540)|0;if((gb|0)!=($(124540)|0)){break a}Y(c|0)|0;Nc(x[a+20>>2]+4|0);Z()}fb=b+16|0;return}Q(c|0);p()}function EE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a:{e=fb-32|0;fb=e;f=e+8|0;Bw(f,c);x[31609]=0;O(91,e+20|0,d|0);c=x[31609];x[31609]=0;b:{c:{if((c|0)!=1){mk(e,f);x[31609]=0;V(92,a|0,b|0,x[e>>2],x[e+4>>2]);a=x[31609];x[31609]=0;if((a|0)==1){break c}Bg(f);fb=e+32|0;break a}a=N()|0;tb(e+8|0);break b}a=N()|0;Bg(e+8|0)}Q(a|0);p()}}function nd(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;on(a);x[a+16>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;x[a>>2]=0;x[a+4>>2]=0;w[a+32>>1]=64;x[a+24>>2]=8363;x[a+28>>2]=16777344;x[a+36>>2]=0;v[a+39|0]=0;v[a+40|0]=0;v[a+41|0]=0;v[a+42|0]=0;d=z[a+34>>1]&-25279;w[a+34>>1]=(b|0)==4?d|32:d;b=Dc(c+4|0,22292);Be(a+43|0,b);tb(b);fW(a);fb=c+16|0}function mua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;cc(c+8|0,b,10);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){v[b|0]=0;v[b+1|0]=0;v[b+2|0]=0;v[b+3|0]=0;v[b+4|0]=0;v[b+5|0]=0;v[b+6|0]=0;v[b+7|0]=0;v[b+8|0]=0;v[b+9|0]=0}return a|0}function xla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+8|0;Wv(e,c);x[31609]=0;O(474,d+20|0,41612);c=x[31609];x[31609]=0;b:{c:{if((c|0)!=1){mk(d,e);x[31609]=0;V(92,a|0,b|0,x[d>>2],x[d+4>>2]);a=x[31609];x[31609]=0;if((a|0)==1){break c}Bg(e);fb=d+32|0;break a}a=N()|0;tb(d+8|0);break b}a=N()|0;Bg(d+8|0)}Q(a|0);p()}}function xM(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;c=x[a>>2];a:{if(!c){break a}d=x[a+8>>2];if(!d){break a}e=x[a+12>>2];if(!e){break a}a=ib[e|0](c)|0;f=hb;if((f|0)<0){break a}b=0;b:{if((ib[d|0](c,0,0,0)|0)<0){break b}b=0;if((ib[d|0](c,0,0,2)|0)<0){break b}ib[e|0](c)|0;b=hb;if((b|0)>0){b=1}else{b=(b|0)>=0}}ib[d|0](c,a,f,0)|0}return b|0}function eQ(a){a=a|0;var b=0,c=0;c=fb-16|0;fb=c;b=x[x[a+16>>2]+24620>>2]/5|0;b=Gc(b,b>>31);x[a+4272>>2]=b;x[31609]=0;x[c+12>>2]=0;S(947,a+4256|0,b<<1,c+12|0);b=x[31609];x[31609]=0;a:{if((b|0)==1){b=T(124540)|0;if((gb|0)!=($(124540)|0)){break a}Y(b|0)|0;x[a+4272>>2]=0;Z()}x[a+4276>>2]=0;x[a+4268>>2]=0;fb=c+16|0;return}Q(b|0);p()}function Nq(a){var b=0,c=0,d=0,e=0,f=0;d=fb-16|0;fb=d;b=wb(x[a>>2]);f=wb(x[a+4>>2]);e=fb-16|0;fb=e;x[e+12>>2]=b;while(1){if(Ib(b,f)){c=c+C[b>>3];b=x[OB(e+12|0)>>2];continue}break}fb=e+16|0;b=wb(x[a>>2]);x[d+12>>2]=b;c=-c;a=wb(x[a+4>>2]);while(1){if(Ib(b,a)){c=c+C[b>>3];C[b>>3]=c;b=x[OB(d+12|0)>>2];continue}else{fb=d+16|0}break}}function Mha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=Li(a,b,c,d);x[a>>2]=43296;c=Nb(a+4208|0);x[a+4220>>2]=0;x[a+4224>>2]=1056964608;b=a+4228|0;v[b+4|0]=0;v[b+5|0]=4;v[b|0]=69;v[b+1|0]=99;v[b+2|0]=104;v[b+3|0]=111;v[b+6|0]=1;x[31609]=0;O(941,a+44|0,2);b=x[31609];x[31609]=0;if((b|0)!=1){lu(a);return a|0}b=N()|0;wc(c);_f(a);Q(b|0);p()}function Is(a,b,c,d,e,f){var g=0,h=0;g=fb-16|0;fb=g;x[g+12>>2]=d;d=g+12|0;h=x[re(g+8|0,d)>>2];x[31609]=0;ha(f|0,a+8|0,b|0,c|0,h|0,e|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){a=Gz(a);b=Fz(a+88|0);c=Ez(a+92|0);e=Dz(a+96|0);x[a>>2]=47708;x[b>>2]=47824;x[c>>2]=47904;x[e>>2]=47944;Wc(d);fb=g+16|0;return a}a=N()|0;Wc(g+12|0);Q(a|0);p()}function y7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=fb-16|0;fb=d;i=x[b>>2];h=x[a>>2];e=x[gc(a)>>2]==1274;f=x[c>>2]-h|0;g=f<<1;f=f>>>0>=2147483647?-1:g>>>0<=1?1:g;g=Qv(e?0:h,f);if(g){if(!e){ne(a)}x[d+4>>2]=1239;e=De(d+8|0,g,d+4|0);a=UJ(a,e);Lc(e);x[b>>2]=x[a>>2]+(i-h|0);x[c>>2]=f+x[a>>2];fb=d+16|0;return}Uv();p()}function dsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-16|0;fb=d;x[d+12>>2]=c;a:{e=Mb(x[b>>2],x[b+8>>2],c<<2);if(!e){break a}xc(d+12|0,65535);vg(a,z[d+12>>1]);c=wb(x[a>>2]);x[d+4>>2]=c;a=wb(x[a+4>>2]);while(1){if(!Ib(c,a)){break a}f=d+8|0;if(!On(b,f)){Dn(f)}w[c>>1]=x[d+8>>2];c=x[ge(d+4|0)>>2];continue}}fb=d+16|0;return e|0}function k9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=x[a+44>>2];c=x[a+24>>2];if(e>>>0<c>>>0){x[a+44>>2]=c;e=c}g=x[a+8>>2];f=x[a+12>>2];d=-1;a:{if(g>>>0>=f>>>0){break a}if(mc(b,-1)){Wn(a,g,f-1|0,e);return Qy(b)|0}c=b<<24>>24;if(!(x[a+48>>2]&16)){d=-1;if(!mc(c,v[f-1|0])){break a}}Wn(a,g,f-1|0,e);v[x[a+12>>2]]=c;d=b}return d|0}function IR(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;a:{b:{while(1){x[e+12>>2]=b;x[e+8>>2]=d;if(A[Hb(e+12|0,e+8|0)>>2]<=f>>>0){break b}g=Kq(v[xb(a,f)|0]);h=Kq(v[xb(c,f)|0]);if((g|0)!=(h|0)){a=g>>>0<h>>>0?-1:1;break a}f=f+1|0;if(g){continue}break}a=0;break a}a=0;if((b|0)==(d|0)){break a}a=b>>>0<d>>>0?-1:1}fb=e+16|0;return a}function ula(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=fb-32|0;fb=e;x[e+28>>2]=d;c=If(a,c);d=e+8|0;ae(d,x[a+36>>2]);f=a;a:{if(!c){Qc(d,a+32|0,5);d=0;if(Gb(x[x[e+8>>2]>>2],x[e+12>>2])){break a}}d=x[a+36>>2];a=0;_E(b,x[e+28>>2]);while(1){if(A[e+28>>2]>a>>>0){QU(d,bc(x[b>>2],a));a=a+1|0;continue}break}d=c}ef(f,d);fb=e+32|0}function fka(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;if(!Ed(x[a+1298300>>2])){b=x[a+24620>>2];d=fb-16|0;fb=d;e=Ec(536);x[31609]=0;f=P(874,e|0,b|0)|0;b=x[31609];x[31609]=0;a:{if((b|0)!=1){b=yf(d+12|0,f);fb=d+16|0;b=x[b>>2];break a}a=N()|0;Db(e);Q(a|0);p()}x[c+12>>2]=b;b=a+1298300|0;a=c+12|0;pS(b,ne(a));WA(a)}fb=c+16|0}function Yoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=fb-608|0;fb=d;c=fb-16|0;fb=c;$W(c+8|0,d);e=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);f=x[c+4>>2];if((f|0)==(e|0)){id(a,x[c+12>>2])}fb=c+16|0;e=(e|0)==(f|0);if(!e){_W(d)}c=-1;a:{if(!e){break a}c=0;if(!bX(d)){break a}c=xe(a,b,aX(y[d+34|0]|y[d+35|0]<<8),hb)}fb=d+608|0;return c|0}function Uia(a,b){a=a|0;b=b|0;var c=0,d=0;if(x[a+4>>2]!=x[Ab(a)>>2]){c=fb-16|0;fb=c;a=xh(c+4|0,a,1);uk(x[a+4>>2],B[b>>2]);x[a+4>>2]=x[a+4>>2]+4;kc(a);fb=c+16|0;return}d=fb-32|0;fb=d;c=Ab(a);c=Zf(d+12|0,Mf(a,oc(x[a>>2],x[a+4>>2])+1|0),oc(x[a>>2],x[a+4>>2]),c);uk(x[c+8>>2],B[b>>2]);x[c+8>>2]=x[c+8>>2]+4;nA(a,c);Yf(c);fb=d+32|0}function KE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=Ak(b,zd(a));a:{f=Cb(x[a+4>>2],y[a+11|0]);if(b>>>0<=f>>>0){if(c){e=Mc(a);b:{if(e-f>>>0>=c>>>0){e=Kb(a);if((b|0)==(f|0)){break b}g=b+e|0;Pi(g+c|0,g,f-b|0);break b}bn(a,e,(c+f|0)-e|0,f,b,0,c);e=x[a>>2]}am(b+e|0,c,d);b=c+f|0;lg(a,b);hd(b+e|0,0)}break a}en();p()}zd(a)}function u1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-784|0;fb=e;c=fb-16|0;fb=c;f=e+12|0;yF(c+8|0,f);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;d=(d|0)==(g|0);if(!d){xF(f)}c=-1;a:{if(!d){break a}c=0;if(!AF(f)){break a}c=xe(a,b,zF(y[e+527|0]),0)}fb=e+784|0;return c|0}function dja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=fb-16|0;fb=e;f=x[a+8>>2];d=e+4|0;x[d+8>>2]=a+8;x[d>>2]=f;x[d+4>>2]=D(b,52)+f;b=x[d>>2];a:{while(1){if(x[d+4>>2]==(b|0)){break a}x[31609]=0;O(920,b|0,c|0);a=x[31609];x[31609]=0;if((a|0)!=1){b=x[d>>2]+52|0;x[d>>2]=b;continue}break}a=N()|0;je(d);Q(a|0);p()}je(d);fb=e+16|0}function Ura(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=x[a>>2];d=Xc(e,x[a+4>>2]);if(d>>>0<b>>>0){e=fb-32|0;fb=e;b=b-d|0;d=x[Ab(a)>>2];f=x[a+4>>2];a:{if(b>>>0<=d-f>>>0){zp(a,b,c);break a}d=Ab(a);d=qn(e+12|0,Wl(a,Xc(x[a>>2],f)+b|0),Xc(x[a>>2],x[a+4>>2]),d);lZ(d,b,c);cr(a,d);pn(d)}fb=e+32|0;return}if(b>>>0<d>>>0){Jd(a,b+e|0)}}function E0(a,b){a=a|0;b=b|0;var c=0,d=0;if(x[a+4>>2]!=x[Ab(a)>>2]){c=fb-16|0;fb=c;a=dj(c+4|0,a,1);nm(x[a+4>>2],z[b>>1]);x[a+4>>2]=x[a+4>>2]+2;kc(a);fb=c+16|0;return}d=fb-32|0;fb=d;c=Ab(a);c=fk(d+12|0,gk(a,$c(x[a>>2],x[a+4>>2])+1|0),$c(x[a>>2],x[a+4>>2]),c);nm(x[c+8>>2],z[b>>1]);x[c+8>>2]=x[c+8>>2]+2;Sr(a,c);cj(c);fb=d+32|0}function dq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=a;e=Sd(b,c);f=fb-16|0;fb=f;a:{if(e>>>0<1073741808){b:{if(fr(e)){Ne(d,e);break b}Oj(f+8|0,sn(e)+1|0);g=x[f+8>>2];yd(d,g);of(d,x[f+12>>2]);Bd(d,e);d=g}while(1){if((b|0)!=(c|0)){yd(d,x[b>>2]);d=d+4|0;b=b+4|0;continue}break}yd(d,0);fb=f+16|0;break a}pf();p()}return a|0}function Yda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;x[31609]=0;W(996,a|0);d=x[31609];x[31609]=0;if((d|0)!=1){x[a+16>>2]=0;x[a+12>>2]=c;x[a+8>>2]=b;return}Y(T(0)|0)|0;x[31609]=0;V(983,13123,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function p1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-48|0;fb=e;c=fb-16|0;fb=c;f=e+10|0;iF(c+8|0,f);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;d=(d|0)==(g|0);if(!d){hF(f)}c=-1;a:{if(!d){break a}c=0;if(!kF(f)){break a}c=xe(a,b,jF(y[e+45|0]),hb)}fb=e+48|0;return c|0}function b0(a,b,c,d){var e=0,f=0,g=0,h=0;e=Cb(x[a+4>>2],y[a+11|0]);if(e>>>0>=b>>>0){f=Mc(a);a:{if(f-e>>>0>=d>>>0){if(!d){break a}f=Kb(a);h=f+b|0;if((b|0)!=(e|0)){g=b+f|0;Pi(g+d|0,g,e-b|0);c=(c>>>0>=g>>>0?e+f>>>0>c>>>0?d:0:0)+c|0}Pi(h,c,d);b=d+e|0;lg(a,b);hd(b+f|0,0);return a}Yp(a,f,(d+e|0)-f|0,e,b,0,d,c)}return a}en();p()}function Yl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=a;e=Pj(b,c);f=fb-16|0;fb=f;a:{if(e>>>0<2147483632){b:{if(Ok(e)){Ne(d,e);break b}qg(f+8|0,Fh(e)+1|0);g=x[f+8>>2];yd(d,g);of(d,x[f+12>>2]);Bd(d,e);d=g}while(1){if((b|0)!=(c|0)){hd(d,y[b|0]);d=d+1|0;b=b+1|0;continue}break}hd(d,0);fb=f+16|0;break a}pf();p()}return a|0}function Y2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=fb-16|0;fb=e;cd(a,x[b+28>>2]);x[31609]=0;d=e+12|0;S(108,d|0,b|0,c|0);f=x[31609];x[31609]=0;a:{if((f|0)==1){break a}_b(d);b=x[b+24>>2];if(b){x[31609]=0;d=e+8|0;S(109,d|0,b|0,c|0);b=x[31609];x[31609]=0;if((b|0)==1){break a}_b(d)}fb=e+16|0;return}b=N()|0;_b(a);Q(b|0);p()}function U$(a){var b=0,c=0,d=0,e=0;if(!y[a+12|0]){c=fb-16|0;fb=c;b=vb(c+12|0,x[x[a+8>>2]>>2]);e=x[vb(c+8|0,x[x[a+4>>2]>>2])>>2];d=fb-16|0;fb=d;a=x[b>>2];x[d+12>>2]=a;while(1){if(xi(a,e)){b=fb-16|0;fb=b;x[b+12>>2]=a;x[b+12>>2]=x[b+12>>2]+28;fb=b+16|0;Hd(pE(x[b+12>>2]));a=x[em(d+12|0)>>2];continue}break}fb=d+16|0;fb=c+16|0}}function Ij(a){var b=0,c=0,d=0,e=0,f=0;b=x[a+4>>2];if(mc(x[a>>2],b)){a=0}else{b=Vi(b);e=Vi(x[a>>2]);c=fb-16|0;fb=c;x[c+12>>2]=b;while(1){a:{if(!Zg(b,e)){break a}d=fb-16|0;fb=d;x[d+12>>2]=b;f=Xk(d+12|0);fb=d+16|0;if(z[x[f>>2]>>1]!=65535){break a}b=x[Xk(c+12|0)>>2];continue}break}fb=c+16|0;a=rE(wb(x[a>>2]),b)}return a&65535}function Fs(a,b,c,d,e){var f=0,g=0;f=fb-16|0;fb=f;x[f+12>>2]=c;c=f+12|0;g=x[re(f+8|0,c)>>2];x[31609]=0;ba(e|0,a+8|0,b|0,g|0,d|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){a=Gz(a);b=Fz(a+88|0);d=Ez(a+92|0);e=Dz(a+96|0);x[a>>2]=47708;x[b>>2]=47824;x[d>>2]=47904;x[e>>2]=47944;Wc(c);fb=f+16|0;return a}a=N()|0;Wc(f+12|0);Q(a|0);p()}function usa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;x[c+12>>2]=1;a:{if(Vg(a)){d=x[a>>2];f=oc(d,x[a+4>>2]);x[c+8>>2]=f;e=x[Hb(c+12|0,c+8|0)>>2];while(1){if(e){w[d>>1]=z[b>>1];v[d+2|0]=y[b+2|0];e=e-1|0;d=d+4|0;continue}break}if(!f){c_(a,b);break a}Jd(a,x[a>>2]+4|0);break a}pr(a);lm(a,Mf(a,1));c_(a,b)}fb=c+16|0}function Oja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;a:{d=fb-32|0;fb=d;e=d+8|0;Qo(e,c);x[31609]=0;c=d+20|0;O(14,c|0,e|0);f=x[31609];x[31609]=0;b:{c:{if((f|0)!=1){x[31609]=0;S(841,a|0,b|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(c);tb(e);fb=d+32|0;break a}a=N()|0;break b}a=N()|0;Ub(d+20|0)}tb(d+8|0);Q(a|0);p()}}function ZF(a){var b=0,c=0;a:{if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=1179340888|(y[a+8|0]|y[a+9|0]<<8|(y[a+10|0]<<16|y[a+11|0]<<24))!=1213419859){break a}b=$b(y[a+4|0]|y[a+5|0]<<8|(y[a+6|0]<<16|y[a+7|0]<<24));if(!b){break a}c=($b(y[a+12|0]|y[a+13|0]<<8|(y[a+14|0]<<16|y[a+15|0]<<24))|0)!=0&b>>>0>27}return c}function Gia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=x[a>>2];c=oc(d,x[a+4>>2]);if(c>>>0<b>>>0){d=fb-32|0;fb=d;b=b-c|0;c=x[Ab(a)>>2];e=x[a+4>>2];a:{if(b>>>0<=c-e>>2>>>0){Uq(a,b);break a}c=Ab(a);c=Zf(d+12|0,Mf(a,oc(x[a>>2],e)+b|0),oc(x[a>>2],x[a+4>>2]),c);kA(c,b);Tm(a,c);Yf(c)}fb=d+32|0;return}if(b>>>0<c>>>0){Jd(a,d+(b<<2)|0)}}function S9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+8|0;Qo(e,c);x[31609]=0;c=d+20|0;S(502,c|0,b|0,e|0);b=x[31609];x[31609]=0;b:{c:{if((b|0)!=1){x[31609]=0;S(244,a|0,0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(c);tb(e);fb=d+32|0;break a}a=N()|0;break b}a=N()|0;Ub(d+20|0)}tb(d+8|0);Q(a|0);p()}}function O3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-16|0;fb=d;a:{e=x[b>>2];if(Ed(e)){f=d+4|0;if(!Ad(x[c+4>>2],y[c+11|0])){yP(c,18407);e=x[b>>2]}b=x[b+4>>2];ib[x[x[b>>2]+24>>2]](f,b,e);x[31609]=0;P(838,c|0,f|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}tb(f)}Uc(a,c);fb=d+16|0;return}a=N()|0;tb(d+4|0);Q(a|0);p()}function NX(a){var b=0;a:{if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=808604749|((y[a+8|0]|y[a+9|0]<<8)-768&65535)>>>0<65280|(((y[a+112|0]|y[a+113|0]<<8)-65&65535)>>>0<65472|(y[a+106|0]|y[a+107|0]<<8)>>>0>256)){break a}if((y[a+122|0]|y[a+123|0]<<8)>>>0>255){break a}b=(y[a+124|0]|y[a+125|0]<<8)>>>0<4e3}return b}function $ha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-32|0;fb=d;x[d+28>>2]=c;x[d+8>>2]=33;e=x[a>>2];f=x[a+8>>2];c=x[Hb(d+28|0,d+8|0)>>2];if(!Mb(e,f,c)){c=jf(a)}e=d+8|0;nD(e,b);f=Zb(d+16|0,x[d+8>>2],c);lc(d,x[a>>2],x[a+8>>2],x[f>>2],x[f+4>>2]);nD(e,b);Rb(x[d+8>>2]+c|0,0,33-c|0);Vb(a,x[d+28>>2]);fb=d+32|0;return c|0}function _sa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=fb-224|0;fb=d;c=fb-16|0;fb=c;e=d+6|0;C_(c+8|0,e);f=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(f|0)){id(a,x[c+12>>2])}fb=c+16|0;c=-1;a:{if((f|0)!=(g|0)){break a}c=0;if(!E_(e)){break a}c=xe(a,b,D_(y[d+222|0],y[d+223|0]),hb)}fb=d+224|0;return c|0}function Xqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=fb+-64|0;fb=f;c=fb-16|0;fb=c;e=f+12|0;NY(c+8|0,e);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;d=(d|0)==(g|0);if(!d){MY(e)}c=-1;a:{if(!d){break a}c=0;if(!PY(e)){break a}c=xe(a,b,OY(e),hb)}fb=f- -64|0;return c|0}function Sqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;c=yb(b,c);e=c;c=Sd(b,c);d=fb-16|0;fb=d;a:{if(Vg(a)>>>0>=c>>>0){f=x[a>>2];g=oc(f,x[a+4>>2]);if(c>>>0>g>>>0){h=b;b=fD(b,g);Lv(h,b,f);zY(a,b,e,c-oc(x[a>>2],x[a+4>>2])|0);break a}BY(d+8|0,b,e,f);Jd(a,x[d+12>>2]);break a}pr(a);lm(a,Mf(a,c));zY(a,b,e,c)}fb=d+16|0}function Oqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+8|0;yp(e,b,c);x[31609]=0;b=d+20|0;S(123,b|0,28,e|0);c=x[31609];x[31609]=0;b:{c:{if((c|0)!=1){x[31609]=0;O(12,a|0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(b);tb(e);fb=d+32|0;break a}a=N()|0;break b}a=N()|0;Ub(d+20|0)}tb(d+8|0);Q(a|0);p()}}function tM(a){var b=0,c=0,d=0,e=0;b=fb-32|0;fb=b;if(!y[a+20|0]){while(1){if(!(ib[x[x[a>>2]+40>>2]](a)|0)){rM(a,65536);c=Zb(b+16|0,xb(x[a+4>>2],x[a+16>>2]),65536);d=x[x[a>>2]+44>>2];e=x[c+4>>2];x[b+8>>2]=x[c>>2];x[b+12>>2]=e;ib[d|0](b+24|0,a,b+8|0);x[a+16>>2]=x[a+16>>2]+x[b+28>>2];continue}break}v[a+20|0]=1}fb=b+32|0}function sua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-1968|0;fb=e;c=fb-16|0;fb=c;f=e+14|0;w0(c+8|0,f);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;d=(d|0)==(g|0);if(!d){v0(f)}c=-1;a:{if(!d){break a}c=0;if(!y0(f)){break a}c=xe(a,b,1024,0)}fb=e+1968|0;return c|0}function dka(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=fb-16|0;fb=b;w[a>>1]=0;c=Nb(a+4|0);d=Nb(a+16|0);x[a+32>>2]=0;x[a+36>>2]=0;x[a+28>>2]=65472;e=Fb(a+40|0);f=og(a+52|0);x[31609]=0;x[b+12>>2]=1065353216;O(879,c|0,b+12|0);g=x[31609];x[31609]=0;if((g|0)!=1){fb=b+16|0;return a|0}a=N()|0;AZ(f);tb(e);wc(d);wc(c);Q(a|0);p()}function aqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+8|0;Qo(e,c);x[31609]=0;c=d+20|0;S(123,c|0,b|0,e|0);b=x[31609];x[31609]=0;b:{c:{if((b|0)!=1){x[31609]=0;O(12,a|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(c);tb(e);fb=d+32|0;break a}a=N()|0;break b}a=N()|0;Ub(d+20|0)}tb(d+8|0);Q(a|0);p()}}function JU(a){a=a|0;var b=0,c=0,d=0;b=fb-16|0;fb=b;if(y[a+534|0]){while(1){d=c&65535;if(d>>>0>=256){v[a+534|0]=0}else{Fj(a,d,1);c=c+1|0;continue}break}}v[b+15|0]=0;Uh(a+8|0,18,b+15|0);Kv(a+26|0,18,27530);v[b+14|0]=255;Uh(a+62|0,256,b+14|0);Ah(x[a>>2],x[a+4>>2],65535,261,1);Ah(x[a>>2],x[a+4>>2],65535,260,0);fb=b+16|0}function C3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;if(lh(a,x[b+8>>2],e)){Vx(b,c,d);return}a:{if(!lh(a,x[b>>2],e)){break a}if(!(x[b+16>>2]!=(c|0)&x[b+20>>2]!=(c|0))){if((d|0)!=1){break a}x[b+32>>2]=1;return}x[b+20>>2]=c;x[b+32>>2]=d;x[b+40>>2]=x[b+40>>2]+1;if(!(x[b+36>>2]!=1|x[b+24>>2]!=2)){v[b+54|0]=1}x[b+44>>2]=4}}function vga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a=Li(a,b,c,d);x[a+4272>>2]=1065353216;x[a>>2]=45440;b=a+4208|0;e=yb(b,0),f=1056880300,x[e>>2]=f;e=yb(b,1),f=1050733080,x[e>>2]=f;e=yb(b,2),f=1056964608,x[e>>2]=f;x[31609]=0;O(941,a+44|0,2);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}b=N()|0;_f(a);Q(b|0);p()}function oga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a=Li(a,b,c,d);x[a>>2]=45676;b=a+4208|0;e=yb(b,0),f=1065353216,x[e>>2]=f;e=yb(b,1),f=1065353216,x[e>>2]=f;e=yb(b,2),f=1051372203,x[e>>2]=f;e=yb(b,3),f=0,x[e>>2]=f;x[31609]=0;O(941,a+44|0,2);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}b=N()|0;_f(a);Q(b|0);p()}function az(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;g=fb-240|0;fb=g;x[g>>2]=a;h=1;a:{if((c|0)<2){break a}e=a;while(1){e=e-4|0;i=c-2|0;f=e-x[(i<<2)+d>>2]|0;if((mo(a,f,b)|0)>=0){if((mo(a,e,b)|0)>=0){break a}}j=f;f=(mo(f,e,b)|0)>=0;e=f?j:e;x[(h<<2)+g>>2]=e;h=h+1|0;c=f?c-1|0:i;if((c|0)>1){continue}break}}CL(g,h);fb=g+240|0}function Usa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;f=fb-208|0;fb=f;c=fb-16|0;fb=c;e=f+2|0;t_(c+8|0,e);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;d=(d|0)==(g|0);if(!d){s_(e)}c=-1;a:{if(!d){break a}c=0;if(!v_(e)){break a}c=xe(a,b,u_(e),hb)}fb=f+208|0;return c|0}function PQ(a){var b=0,c=0,d=0;c=fb-32|0;fb=c;a:{d=dA(a);b=hk(x[a>>2],x[a+4>>2]);b:{if(d>>>0<=b>>>0){break b}x[31609]=0;b=ba(945,c+12|0,b|0,b|0,Ab(a)|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){MQ(a,b);LQ(b);break b}Y(T(0)|0)|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)==1){break a}}fb=c+32|0;return}T(0)|0;Sb();p()}function OQ(a){var b=0,c=0,d=0;c=fb-32|0;fb=c;a:{d=Vg(a);b=oc(x[a>>2],x[a+4>>2]);b:{if(d>>>0<=b>>>0){break b}x[31609]=0;b=ba(946,c+12|0,b|0,b|0,Ab(a)|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){Tm(a,b);Yf(b);break b}Y(T(0)|0)|0;x[31609]=0;X(26);a=x[31609];x[31609]=0;if((a|0)==1){break a}}fb=c+32|0;return}T(0)|0;Sb();p()}function DZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+8|0;Uf(e,c);x[31609]=0;c=d+20|0;S(502,c|0,b|0,e|0);b=x[31609];x[31609]=0;b:{c:{if((b|0)!=1){x[31609]=0;O(12,a|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(c);tb(e);fb=d+32|0;break a}a=N()|0;break b}a=N()|0;Ub(d+20|0)}tb(d+8|0);Q(a|0);p()}}function tpa(a,b){a=a|0;b=b|0;var c=0,d=0;if(x[a+4>>2]!=x[Ab(a)>>2]){c=fb-16|0;fb=c;a=Dw(c+4|0,a,1);xX(x[a+4>>2],b);x[a+4>>2]=x[a+4>>2]+20;kc(a);fb=c+16|0;return}d=fb-32|0;fb=d;c=Ab(a);c=UD(d+12|0,VD(a,Sf(x[a>>2],x[a+4>>2])+1|0),Sf(x[a>>2],x[a+4>>2]),c);xX(x[c+8>>2],b);x[c+8>>2]=x[c+8>>2]+20;TD(a,c);bw(c);fb=d+32|0}function eS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=fb-32|0;fb=c;d=c+8|0;cS(d,b+80|0);x[31609]=0;b=c+20|0;S(123,b|0,0,d|0);e=x[31609];x[31609]=0;b:{c:{if((e|0)!=1){x[31609]=0;O(12,a|0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(b);tb(d);fb=c+32|0;break a}a=N()|0;break b}a=N()|0;Ub(c+20|0)}tb(c+8|0);Q(a|0);p()}}function yla(a,b){a=a|0;b=b|0;var c=0,d=0;if(A[a+4>>2]<A[Ab(a)>>2]){c=fb-16|0;fb=c;a=mC(c+4|0,a,1);XB(x[a+4>>2],b);x[a+4>>2]=x[a+4>>2]+32;kc(a);fb=c+16|0;return}d=fb-32|0;fb=d;c=Ab(a);c=iv(d+12|0,Vq(a,Mg(x[a>>2],x[a+4>>2])+1|0),Mg(x[a>>2],x[a+4>>2]),c);XB(x[c+8>>2],b);x[c+8>>2]=x[c+8>>2]+32;SU(a,c);YB(c);fb=d+32|0}function nE(a,b){a=a|0;b=b|0;var c=0,d=0;if(x[a+4>>2]!=x[Ab(a)>>2]){c=fb-16|0;fb=c;a=B$(c+4|0,a,1);A$(x[a+4>>2],b);x[a+4>>2]=x[a+4>>2]+40;kc(a);fb=c+16|0;return}d=fb-32|0;fb=d;c=Ab(a);c=y$(d+12|0,z$(a,Ar(x[a>>2],x[a+4>>2])+1|0),Ar(x[a>>2],x[a+4>>2]),c);A$(x[c+8>>2],b);x[c+8>>2]=x[c+8>>2]+40;x$(a,c);w$(c);fb=d+32|0}function eta(a,b){a=a|0;b=b|0;var c=0,d=0;if(A[a+4>>2]<A[Ab(a)>>2]){c=fb-16|0;fb=c;a=Dw(c+4|0,a,1);WD(x[a+4>>2],b);x[a+4>>2]=x[a+4>>2]+20;kc(a);fb=c+16|0;return}d=fb-32|0;fb=d;c=Ab(a);c=UD(d+12|0,VD(a,Sf(x[a>>2],x[a+4>>2])+1|0),Sf(x[a>>2],x[a+4>>2]),c);WD(x[c+8>>2],b);x[c+8>>2]=x[c+8>>2]+20;TD(a,c);bw(c);fb=d+32|0}function Nka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-32|0;fb=d;b=jg(d+8|0,b);x[31609]=0;e=d+20|0;S(837,e|0,b|0,c|0);f=x[31609];x[31609]=0;a:{b:{if((f|0)!=1){x[31609]=0;S(72,a|0,e|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}tb(e);tb(b);fb=d+32|0;return}c=N()|0;break a}c=N()|0;tb(d+20|0)}tb(b);Q(c|0);p()}function Xda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;x[31609]=0;W(996,a|0);d=x[31609];x[31609]=0;if((d|0)!=1){x[a+4>>2]=c;x[a>>2]=b?b:977;return}Y(T(0)|0)|0;x[31609]=0;V(983,13153,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Vea(a,b){a=a|0;b=b|0;var c=0;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;if((c|0)!=1){return E(fP(x[x[a+24>>2]+24>>2],b))}Y(T(0)|0)|0;x[31609]=0;V(983,6229,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return E(E(0))}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Uea(a,b){a=a|0;b=b|0;var c=0;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;if((c|0)!=1){return E(eP(x[x[a+24>>2]+24>>2],b))}Y(T(0)|0)|0;x[31609]=0;V(983,9393,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return E(E(0))}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Tpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-128|0;fb=e;c=fb-16|0;fb=c;f=e+2|0;MX(c+8|0,f);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;d=(d|0)==(g|0);if(!d){LX(f)}c=-1;a:{if(!d){break a}c=0;if(!NX(f)){break a}c=xe(a,b,256,0)}fb=e+128|0;return c|0}function Tea(a,b){a=a|0;b=b|0;var c=0;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;if((c|0)!=1){return E(dP(x[x[a+24>>2]+24>>2],b))}Y(T(0)|0)|0;x[31609]=0;V(983,6272,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return E(E(0))}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Sea(a,b){a=a|0;b=b|0;var c=0;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;if((c|0)!=1){return E(cP(x[x[a+24>>2]+24>>2],b))}Y(T(0)|0)|0;x[31609]=0;V(983,6174,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return E(E(0))}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Qea(a,b){a=a|0;b=b|0;var c=0;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;if((c|0)!=1){return E(bP(x[x[a+24>>2]+24>>2],b))}Y(T(0)|0)|0;x[31609]=0;V(983,6130,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return E(E(0))}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function NE(a){var b=0,c=0,d=0,e=0;c=y[a+9|0]|y[a+10|0]<<8;d=Iua(y[a+3|0],0,18,0);c=c+d|0;b=hb;e=d>>>0>c>>>0?b+1|0:b;d=y[a+6|0]|y[a+7|0]<<8;b=d>>>31|0;d=d<<1;c=d+c|0;b=b+e|0;d=d>>>0>c>>>0?b+1|0:b;a=y[a+4|0]|y[a+5|0]<<8;b=a>>>30|0;e=c;c=a<<2;e=e+c|0;a=b+d|0;a=c>>>0>e>>>0?a+1|0:a;b=e+3|0;hb=b>>>0<3?a+1|0:a;return b}function Doa(a,b){a=a|0;b=b|0;var c=0,d=0;if(x[a+4>>2]!=x[Ab(a)>>2]){c=fb-16|0;fb=c;a=Cx(c+4|0,a);xC(x[a+4>>2],b);x[a+4>>2]=x[a+4>>2]+12;kc(a);fb=c+16|0;return}d=fb-32|0;fb=d;c=Ab(a);c=zm(d+12|0,Pp(a,Ud(x[a>>2],x[a+4>>2])+1|0),Ud(x[a>>2],x[a+4>>2]),c);xC(x[c+8>>2],b);x[c+8>>2]=x[c+8>>2]+12;zW(a,c);yW(c);fb=d+32|0}function BA(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=c>=.999?.999:c;h=c*3.141592653589793;i=$u(b);while(1){if((e|0)!=32768){f=(e<<12&28672|e>>>3)^28672;if((f|0)!=16384){d=+(f-16384|0)*.000244140625;g=h*d;d=Ri(g)*$u(M(d*d*-.0625+1)*b)/(i*g)}else{d=1}j=a,k=uC(c*d*32768),w[j>>1]=k;e=e+1|0;a=a+2|0;continue}break}}function jA(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;d=fb-16|0;fb=d;h=z[b>>1];c=de(a);e=gc(a);f=fb-16|0;fb=f;while(1){if(c){g=Xq(z[c+16>>1],h);e=g?e:c;c=x[(g?c+4|0:c)>>2];continue}break}c=x[vb(f+12|0,e)>>2];fb=f+16|0;a:{if(Ib(c,pg(a))){if(!Xq(z[b>>1],z[ud(c)>>1])){break a}}c=pg(a)}a=vb(d+12|0,c);fb=d+16|0;return x[a>>2]}function _qa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=fb-16|0;fb=d;e=x[a+8>>2];c=d+4|0;x[c+8>>2]=a+8;x[c>>2]=e;x[c+4>>2]=D(b,20)+e;b=x[c>>2];a:{while(1){if(x[c+4>>2]==(b|0)){break a}x[31609]=0;W(228,b|0);a=x[31609];x[31609]=0;if((a|0)!=1){b=x[c>>2]+20|0;x[c>>2]=b;continue}break}a=N()|0;je(c);Q(a|0);p()}je(c);fb=d+16|0}function Uha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=fb-32|0;fb=c;d=c+8|0;Uf(d,b);x[31609]=0;b=c+20|0;O(958,b|0,d|0);e=x[31609];x[31609]=0;b:{c:{if((e|0)!=1){x[31609]=0;S(959,a|0,0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(b);tb(d);fb=c+32|0;break a}a=N()|0;break b}a=N()|0;Ub(c+20|0)}tb(c+8|0);Q(a|0);p()}}function Dna(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-32|0;fb=d;x[d+28>>2]=c;x[d+8>>2]=4896;e=x[a>>2];f=x[a+8>>2];c=x[Hb(d+28|0,d+8|0)>>2];if(!Mb(e,f,c)){c=jf(a)}e=d+8|0;pD(e,b);f=Zb(d+16|0,x[d+8>>2],c);lc(d,x[a>>2],x[a+8>>2],x[f>>2],x[f+4>>2]);pD(e,b);Rb(x[d+8>>2]+c|0,0,4896-c|0);Vb(a,x[d+28>>2]);fb=d+32|0}function A2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-32|0;fb=d;b=wm(d+8|0,b);x[31609]=0;e=d+20|0;S(148,e|0,b|0,c|0);f=x[31609];x[31609]=0;a:{b:{if((f|0)!=1){x[31609]=0;S(4,a|0,e|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}tb(e);tb(b);fb=d+32|0;return}c=N()|0;break a}c=N()|0;tb(d+20|0)}tb(b);Q(c|0);p()}function zta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-32|0;fb=e;c=fb-16|0;fb=c;f=e+15|0;J0(c+8|0,f);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;d=(d|0)==(g|0);if(!d){IE(f)}c=-1;a:{if(!d){break a}c=0;if(!h$(f)){break a}c=xe(a,b,72,0)}fb=e+32|0;return c|0}function rja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=fb-32|0;fb=c;d=c+8|0;Uk(d,b);x[31609]=0;b=c+20|0;O(14,b|0,d|0);e=x[31609];x[31609]=0;b:{c:{if((e|0)!=1){x[31609]=0;S(244,a|0,0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(b);tb(d);fb=c+32|0;break a}a=N()|0;break b}a=N()|0;Ub(c+20|0)}tb(c+8|0);Q(a|0);p()}}function pH(a,b,c,d,e){var f=0,g=0;a:{f=fb-32|0;fb=f;g=f+8|0;Np(g,c);x[31609]=0;O(e|0,f+20|0,d|0);c=x[31609];x[31609]=0;b:{c:{if((c|0)!=1){mk(f,g);x[31609]=0;V(92,a|0,b|0,x[f>>2],x[f+4>>2]);a=x[31609];x[31609]=0;if((a|0)==1){break c}Bg(g);fb=f+32|0;break a}a=N()|0;tb(f+8|0);break b}a=N()|0;Bg(f+8|0)}Q(a|0);p()}}function hua(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-16|0;fb=d;x[d+12>>2]=c;a:{if(!Mb(x[b>>2],x[b+8>>2],c<<1)){break a}xc(d+12|0,65535);vg(a,z[d+12>>1]);c=wb(x[a>>2]);x[d+4>>2]=c;a=wb(x[a+4>>2]);while(1){if(!Ib(c,a)){break a}ww(b,d+10|0);e=c,f=Bb(z[d+10>>1]),w[e>>1]=f;c=x[ge(d+4|0)>>2];continue}}fb=d+16|0}function hH(a,b,c,d,e){var f=0,g=0;a:{f=fb-32|0;fb=f;g=f+8|0;S_(g,c);x[31609]=0;O(e|0,f+20|0,d|0);c=x[31609];x[31609]=0;b:{c:{if((c|0)!=1){mk(f,g);x[31609]=0;V(92,a|0,b|0,x[f>>2],x[f+4>>2]);a=x[31609];x[31609]=0;if((a|0)==1){break c}Bg(g);fb=f+32|0;break a}a=N()|0;tb(f+8|0);break b}a=N()|0;Bg(f+8|0)}Q(a|0);p()}}function Kja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=fb-32|0;fb=c;d=c+8|0;Qo(d,b);x[31609]=0;b=c+20|0;O(14,b|0,d|0);e=x[31609];x[31609]=0;b:{c:{if((e|0)!=1){x[31609]=0;S(244,a|0,0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(b);tb(d);fb=c+32|0;break a}a=N()|0;break b}a=N()|0;Ub(c+20|0)}tb(c+8|0);Q(a|0);p()}}function K1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=fb-32|0;fb=c;d=c+8|0;Uf(d,b);x[31609]=0;b=c+20|0;S(123,b|0,22,d|0);e=x[31609];x[31609]=0;b:{c:{if((e|0)!=1){x[31609]=0;O(12,a|0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(b);tb(d);fb=c+32|0;break a}a=N()|0;break b}a=N()|0;Ub(c+20|0)}tb(c+8|0);Q(a|0);p()}}function J1(a,b){a=a|0;b=b|0;var c=0,d=0;if(A[a+4>>2]<A[Ab(a)>>2]){c=fb-16|0;fb=c;a=qG(c+4|0,a);gx(x[a+4>>2],b);x[a+4>>2]=x[a+4>>2]+36;kc(a);fb=c+16|0;return}d=fb-32|0;fb=d;c=Ab(a);c=oG(d+12|0,pG(a,ds(x[a>>2],x[a+4>>2])+1|0),ds(x[a>>2],x[a+4>>2]),c);gx(x[c+8>>2],b);x[c+8>>2]=x[c+8>>2]+36;nG(a,c);ix(c);fb=d+32|0}function xra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);c=b+c|0;e=c;d=Pj(b,c);c=fb-16|0;fb=c;Rd(c+8|0,x[vb(c+4|0,a)>>2]);a:{b:{if(d){x[31609]=0;O(345,a|0,d|0);f=x[31609];x[31609]=0;if((f|0)==1){break b}zn(a,b,e,d)}a=c+8|0;Qd(a);Zi(a);fb=c+16|0;break a}a=N()|0;Zi(c+8|0);Q(a|0);p()}}function P2(a){a=a|0;var b=0,c=0,d=0,e=0;a:{b=fb-32|0;fb=b;c=b+8|0;Dc(c,13592);x[31609]=0;d=b+20|0;S(123,d|0,1,c|0);e=x[31609];x[31609]=0;b:{c:{if((e|0)!=1){x[31609]=0;O(12,a|0,d|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(d);tb(c);fb=b+32|0;break a}a=N()|0;break b}a=N()|0;Ub(b+20|0)}tb(b+8|0);Q(a|0);p()}}function Lna(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-32|0;fb=d;x[d+28>>2]=c;x[d+8>>2]=263;e=x[a>>2];f=x[a+8>>2];c=x[Hb(d+28|0,d+8|0)>>2];if(!Mb(e,f,c)){c=jf(a)}e=d+8|0;BV(e,b);f=Zb(d+16|0,x[d+8>>2],c);lc(d,x[a>>2],x[a+8>>2],x[f>>2],x[f+4>>2]);BV(e,b);Rb(x[d+8>>2]+c|0,0,263-c|0);Vb(a,x[d+28>>2]);fb=d+32|0}function GX(a){var b=0,c=0,d=0,e=0,f=0;f=y[a+28|0]|y[a+29|0]<<8;c=Iua(y[a+30|0],0,37,0);d=hb;b=Iua(y[a+24|0]|y[a+25|0]<<8,0,192,0);c=b+c|0;d=hb+d|0;b=b>>>0>c>>>0?d+1|0:d;a=y[a+26|0];d=a>>>26|0;e=c;c=a<<6;e=e+c|0;a=b+d|0;a=c>>>0>e>>>0?a+1|0:a;b=e+f|0;a=b>>>0<e>>>0?a+1|0:a;b=b+192|0;hb=b>>>0<192?a+1|0:a;return b}function Asa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-32|0;fb=d;x[d+28>>2]=c;x[d+8>>2]=102;e=x[a>>2];f=x[a+8>>2];c=x[Hb(d+28|0,d+8|0)>>2];if(!Mb(e,f,c)){c=jf(a)}e=d+8|0;d_(e,b);f=Zb(d+16|0,x[d+8>>2],c);lc(d,x[a>>2],x[a+8>>2],x[f>>2],x[f+4>>2]);d_(e,b);Rb(x[d+8>>2]+c|0,0,102-c|0);Vb(a,x[d+28>>2]);fb=d+32|0}function qA(a,b,c){var d=0,e=0,f=0;e=fb-16|0;fb=e;d=e+4|0;x[d>>2]=a;a=x[a+4>>2];x[d+4>>2]=a;x[d+8>>2]=a+D(b,52);b=x[d+4>>2];f=x[d+8>>2];a:{while(1){if((b|0)==(f|0)){break a}x[31609]=0;O(920,b|0,c|0);a=x[31609];x[31609]=0;if((a|0)!=1){b=b+52|0;x[d+4>>2]=b;continue}break}a=N()|0;kc(d);Q(a|0);p()}kc(d);fb=e+16|0}function Tqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-32|0;fb=d;x[d+28>>2]=c;x[d+8>>2]=22;e=x[a>>2];f=x[a+8>>2];c=x[Hb(d+28|0,d+8|0)>>2];if(!Mb(e,f,c)){c=jf(a)}e=d+8|0;cw(e,b);f=Zb(d+16|0,x[d+8>>2],c);lc(d,x[a>>2],x[a+8>>2],x[f>>2],x[f+4>>2]);cw(e,b);Rb(x[d+8>>2]+c|0,0,22-c|0);Vb(a,x[d+28>>2]);fb=d+32|0}function Rqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-32|0;fb=d;x[d+28>>2]=c;x[d+8>>2]=40;e=x[a>>2];f=x[a+8>>2];c=x[Hb(d+28|0,d+8|0)>>2];if(!Mb(e,f,c)){c=jf(a)}e=d+8|0;gD(e,b);f=Zb(d+16|0,x[d+8>>2],c);lc(d,x[a>>2],x[a+8>>2],x[f>>2],x[f+4>>2]);gD(e,b);Rb(x[d+8>>2]+c|0,0,40-c|0);Vb(a,x[d+28>>2]);fb=d+32|0}function f1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-32|0;fb=d;x[d+28>>2]=c;x[d+8>>2]=65;e=x[a>>2];f=x[a+8>>2];c=x[Hb(d+28|0,d+8|0)>>2];if(!Mb(e,f,c)){c=jf(a)}e=d+8|0;Cw(e,b);f=Zb(d+16|0,x[d+8>>2],c);lc(d,x[a>>2],x[a+8>>2],x[f>>2],x[f+4>>2]);Cw(e,b);Rb(x[d+8>>2]+c|0,0,65-c|0);Vb(a,x[d+28>>2]);fb=d+32|0}function el(a,b,c,d,e,f){var g=0,h=0,i=0,j=0;h=fb-16|0;fb=h;x[h+8>>2]=a;x[h+12>>2]=b;j=x[a+8>>2]+120|0;au(y[j+20|0]);i=fb-16|0;fb=i;x[i+12>>2]=h+8;g=fb-16|0;fb=g;x[g+12>>2]=f;x[g+8>>2]=e;x[g+4>>2]=d;x[g>>2]=c;ib[x[lq(g,tk(y[j+20|0]))>>2]](i+12|0,j);fb=g+16|0;fb=i+16|0;x[a+4>>2]=x[a+4>>2]+x[b+8>>2];fb=h+16|0}function ZP(a){var b=0,c=E(0),d=0,e=0;e=x[x[a+16>>2]+24620>>2];b=fb-16|0;fb=b;x[b+12>>2]=0;x[b+8>>2]=1065353216;c=ni(E(B[Sv(a+4208|0,b+12|0,b+8|0)>>2]*E(999)));a:{if(c<E(4294967296)&c>=E(0)){d=~~c>>>0;break a}d=0}fb=b+16|0;b=(e>>>0)/(d+1>>>0)|0;b=b>>>0<=2?2:b;x[a+4216>>2]=b;x[a+4220>>2]=b>>>1;xc(a+4224|0,b)}function M4(a,b,c){a=a|0;b=b|0;c=c|0;a=0;if(b&1){a=(Ws(c)|0)!=0}if(b&2){a=(Vs(c)|0)!=0|a}if(b&4){a=(Us(c)|0)!=0|a}if(b&8){a=(Ts(c)|0)!=0|a}if(b&16){a=(Ss(c)|0)!=0|a}if(b&32){a=(Rs(c)|0)!=0|a}if(b&64){a=(Nh(c)|0)!=0|a}if(b&128){a=(Qs(c)|0)!=0|a}if(b&256){a=(Ps(c)|0)!=0|a}if(b&512){a=(Os(c)|0)!=0|a}return a|0}function Dl(a,b){var c=0,d=0,e=0;d=x[a>>2];c=oc(d,x[a+4>>2]);if(c>>>0<b>>>0){d=fb-32|0;fb=d;b=b-c|0;c=x[Ab(a)>>2];e=x[a+4>>2];a:{if(b>>>0<=c-e>>2>>>0){Uq(a,b);break a}c=Ab(a);c=Zf(d+12|0,Mf(a,oc(x[a>>2],e)+b|0),oc(x[a>>2],x[a+4>>2]),c);kA(c,b);nA(a,c);Yf(c)}fb=d+32|0;return}if(b>>>0<c>>>0){Jd(a,d+(b<<2)|0)}}function yQ(a){a=a|0;var b=0,c=0,d=0;b=C[a+4264>>3]*+A[x[a+16>>2]+1074376>>2];a:{if(F(b)<0x8000000000000000){d=~~b>>>0;if(F(b)>=1){c=~~(b>0?H(J(b*2.3283064365386963e-10),4294967295):K((b-+(~~b>>>0>>>0))*2.3283064365386963e-10))>>>0}else{c=0}break a}c=-2147483648}C[a+4256>>3]=b-(+(d>>>0)+ +(c|0)*4294967296)}function uea(a,b){a=a|0;b=b|0;var c=0;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;if((c|0)!=1){return LO(x[x[a+24>>2]+24>>2],b)|0}Y(T(0)|0)|0;x[31609]=0;V(983,6659,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function UQ(a,b){var c=0,d=0,e=0,f=0,g=E(0);c=fb-16|0;fb=c;if(!x[(x[x[a>>2]-12>>2]+a|0)+16>>2]){w[c+14>>1]=0;ng(a,c+14|0);e=z[c+14>>1];Dl(b,e);while(1){if((d|0)!=(e|0)){x[c+8>>2]=0;vq(a,c+8|0);f=yb(x[b>>2],d),g=B[c+8>>2],B[f>>2]=g;d=d+1|0;continue}break}d=!x[(x[x[a>>2]-12>>2]+a|0)+16>>2]}fb=c+16|0;return d}function Sda(a,b){a=a|0;b=b|0;var c=0;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;if((c|0)!=1){rO(x[x[a+24>>2]+24>>2],b);return 1}Y(T(0)|0)|0;x[31609]=0;V(983,5784,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Qsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-32|0;fb=d;x[d+28>>2]=c;x[d+8>>2]=5;e=x[a>>2];f=x[a+8>>2];c=x[Hb(d+28|0,d+8|0)>>2];if(!Mb(e,f,c)){c=jf(a)}e=d+8|0;$j(e,b);f=Zb(d+16|0,x[d+8>>2],c);lc(d,x[a>>2],x[a+8>>2],x[f>>2],x[f+4>>2]);$j(e,b);Rb(x[d+8>>2]+c|0,0,5-c|0);Vb(a,x[d+28>>2]);fb=d+32|0}function c7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;g=fb-16|0;fb=g;x[e>>2]=c;b=g+12|0;a=qy(b,0,x[a+8>>2]);f=2;a:{if(a+1>>>0<2){break a}c=a-1|0;f=1;if(c>>>0>d-x[e>>2]>>>0){break a}while(1){if(c){a=y[b|0];d=x[e>>2];x[e>>2]=d+1;v[d|0]=a;c=c-1|0;b=b+1|0;continue}break}f=0}a=f;fb=g+16|0;return a|0}function Ln(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;a:{e=x[d>>2];if(e|x[c>>2]){while(1){if((b|0)==(g|0)){break a}f=x[c>>2];h=c,i=f-rd((rd(0-f|0,31)&255)+f|0,8)|0,x[h>>2]=i;h=d,i=x[d>>2]-rd((rd(0-e|0,31)&255)+e|0,8)|0,x[h>>2]=i;e=(g<<3)+a|0;x[e>>2]=x[c>>2];f=e;e=x[d>>2];x[f+4>>2]=e;g=g+1|0;continue}}Rb(a,0,b<<3)}}function FQ(a){a=a|0;var b=0,c=0;c=fb-16|0;fb=c;b=x[a+4232>>2];b=(b>>>1)+(b>>>6)|0;x[a+4220>>2]=b;x[31609]=0;x[c+12>>2]=0;S(947,a+4208|0,b<<1,c+12|0);b=x[31609];x[31609]=0;a:{if((b|0)==1){b=T(124540)|0;if((gb|0)!=($(124540)|0)){break a}Y(b|0)|0;x[a+4220>>2]=0;Z()}x[a+4224>>2]=0;fb=c+16|0;return}Q(b|0);p()}function qu(a){var b=0,c=0,d=0;b=zi(+B[a+4228>>2]*8)*.25+-.25;C[a+4248>>3]=b;if(y[a+4240|0]){if(b>45e-5){c=kq(b)/.6931471805599453;b=c-J(c);d=c-b;c=0;a:{if(b<.2075187496394219){break a}c=.4150374992788438;if(b<.5){break a}c=b<.792481250360578?.5849625007211562:1}b=zi(d+c)*.5}else{b=0}C[a+4248>>3]=b}pu(a)}function pm(a,b,c,d,e){var f=0;a:{if(c>>>0>255){break a}b:{switch(d-2|0){case 0:d=D(c,872)+b|0;f=US(x[d+720>>2],x[d+1272>>2],e);if((f+5&255)>>>0>5){break a}return TS(a,b,c,e);case 1:break b;default:break a}}f=TS(a,b,c,e);if((f+5&255)>>>0>5){break a}a=D(c,872)+b|0;f=US(x[a+720>>2],x[a+1272>>2],e)}return f}function hsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=fb-192|0;fb=d;c=fb-16|0;fb=c;sw(c+8|0,d);e=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);f=x[c+4>>2];if((f|0)==(e|0)){id(a,x[c+12>>2])}fb=c+16|0;e=(e|0)==(f|0);if(!e){OZ(d)}c=-1;a:{if(!e){break a}c=0;if(!QZ(d)){break a}c=xe(a,b,PZ(d),hb)}fb=d+192|0;return c|0}function Z_(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=fb-16|0;fb=d;e=x[b+4>>2];f=vb(d+12|0,c);g=vb(d+8|0,x[a>>2]);h=vb(d+4|0,x[b+4>>2]);i=b,j=UW(x[f>>2],x[g>>2],x[h>>2]),x[i+4>>2]=j;i=b,j=Y_(c,x[a+4>>2],x[b+8>>2]),x[i+8>>2]=j;Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=d+16|0;return e}function XU(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=fb-16|0;fb=d;e=x[b+4>>2];f=vb(d+12|0,c);g=vb(d+8|0,x[a>>2]);h=vb(d+4|0,x[b+4>>2]);i=b,j=OF(x[f>>2],x[g>>2],x[h>>2]),x[i+4>>2]=j;i=b,j=_U(c,x[a+4>>2],x[b+8>>2]),x[i+8>>2]=j;Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=d+16|0;return e}function NQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=fb-16|0;fb=e;Lg(a+12|0,d);a:{if(!b){d=0;b=0;break a}if(b>>>0>=2097152){Tj();p()}d=Ec(b<<11);x[e+12>>2]=b;x[e+8>>2]=d;d=x[e+12>>2];b=x[e+8>>2]}x[a>>2]=b;c=b+(c<<11)|0;x[a+8>>2]=c;x[a+4>>2]=c;f=nc(a),g=b+(d<<11)|0,x[f>>2]=g;fb=e+16|0;return a|0}function AQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=d$(b,c);e=fb-16|0;fb=e;a:{if($o(a)>>>0>=d>>>0){f=x[a>>2];g=Xc(f,x[a+4>>2]);if(g>>>0<d>>>0){h=b;b=a$(b,g);aE(h,b,f);zn(a,b,c,d-Xc(x[a>>2],x[a+4>>2])|0);break a}$D(e+8|0,b,c,f);Jd(a,x[e+12>>2]);break a}dw(a);Wk(a,Wl(a,d));zn(a,b,c,d)}fb=e+16|0}function rt(a,b,c,d){var e=0;a:{if(!(d&2048)){break a}e=d&74;if(!c|((e|0)==8|(e|0)==64)){break a}v[a|0]=43;a=a+1|0}if(d&512){v[a|0]=35;a=a+1|0}while(1){e=y[b|0];if(e){v[a|0]=e;a=a+1|0;b=b+1|0;continue}break}e=d&74;b=111;b:{if((e|0)==64){break b}b=d&16384?88:120;if((e|0)==8){break b}b=c?100:117}v[a|0]=b}function U1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;d=c+8|0;Uk(d,b);x[31609]=0;b=c+20|0;O(14,b|0,d|0);e=x[31609];x[31609]=0;a:{b:{if((e|0)!=1){x[31609]=0;O(15,a|0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}Ub(b);tb(d);fb=c+32|0;return}b=N()|0;break a}b=N()|0;Ub(c+20|0)}tb(c+8|0);Q(b|0);p()}function Qna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=fb-80|0;fb=d;c=fb-16|0;fb=c;iZ(c+8|0,d);e=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);f=x[c+4>>2];if((f|0)==(e|0)){id(a,x[c+12>>2])}fb=c+16|0;e=(e|0)==(f|0);if(!e){rD(d)}c=-1;a:{if(!e){break a}c=0;if(!FV(d)){break a}c=xe(a,b,EV(d),hb)}fb=d+80|0;return c|0}function Boa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;c=fb-16|0;fb=c;x[c+12>>2]=477218588;x[c+8>>2]=2147483647;e=Hb(c+12|0,c+8|0);fb=c+16|0;if(A[e>>2]<b>>>0){ed();p()}c=Ec(D(b,9));x[d+12>>2]=b;x[d+8>>2]=c;b=x[d+8>>2];x[a+4>>2]=b;x[a>>2]=b;f=Ab(a),g=b+D(x[d+12>>2],9)|0,x[f>>2]=g;fb=d+16|0}function tla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-16|0;fb=d;c=If(a,c);ae(d,x[a+36>>2]);a:{b:{if(!c){Qc(d,a+32|0,5);e=-1;if(!Gb(x[x[d>>2]>>2],x[d+4>>2])){break b}break a}e=x[c+16>>2]}f=x[a+36>>2];c:{d:{switch(e+1|0){case 0:case 2:Gi(f,b);break c;default:break d}}wZ(f,b,e)}f=c}ef(a,f);fb=d+16|0}function rU(a,b,c){var d=0,e=0,f=0,g=0;if(c==0){e=a;b=Dt(b);o(0);a=j(1)|0;f=j(0)|0;o(+c);d=j(1)|0;j(0)|0;l(0,f|0);l(1,a&2147483647|d&-2147483648);Ql(e,b,+n());return}a:{if(!Af(b)){break a}d=F(c)<Infinity;if(b<0){c=d?c:1;break a}if(d){break a}Ql(a,b,Af(c)?NaN:c);return}b=Dt(b);g=Ri(c);Ql(a,b*hf(c),g*b)}function yV(a){var b=0,c=0,d=0,e=0;c=fb-16|0;fb=c;e=c+14|0;b=fb-16|0;fb=b;d=x[a+24>>2];a:{if(!d){qp(e);break a}hE(b+8|0,Yb(Ui(kq(+(d>>>0)*.00011957431543704412)*2215.9795828054475),-16384,16383),128);d=x[b+8>>2];v[b+7|0]=x[b+12>>2];ee(e,d,b+7|0)}fb=b+16|0;b=c+4|0;ZD(b,a+36|0,a+37|0);YD(b,e);fb=c+16|0}function mH(a,b,c,d){var e=0,f=0;a:{e=fb-32|0;fb=e;f=e+8|0;Cc(f,c);x[31609]=0;c=e+20|0;S(d|0,c|0,b|0,f|0);b=x[31609];x[31609]=0;b:{c:{if((b|0)!=1){x[31609]=0;O(12,a|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(c);tb(f);fb=e+32|0;break a}a=N()|0;break b}a=N()|0;Ub(e+20|0)}tb(e+8|0);Q(a|0);p()}}function _q(a){var b=0,c=0;b=x[a+76>>2];a:{if(!((b|0)>=0&(!b|x[124097]!=(b&1073741823)))){b=x[a+4>>2];if((b|0)!=x[a+8>>2]){x[a+4>>2]=b+1;a=y[b|0];break a}a=yt(a);break a}b=a+76|0;c=x[b>>2];x[b>>2]=c?c:1073741823;c=x[a+4>>2];b:{if((c|0)!=x[a+8>>2]){x[a+4>>2]=c+1;a=y[c|0];break b}a=yt(a)}ne(b)}return a}function Ay(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=a;f=fb-16|0;fb=f;a:{if(b>>>0<1073741808){b:{if(fr(b)){Ne(d,b);break b}Oj(f+8|0,sn(b)+1|0);e=x[f+8>>2];yd(d,e);of(d,x[f+12>>2]);Bd(d,b);d=e}e=fb-16|0;fb=e;x[e+12>>2]=c;KF(d,b,e+12|0);fb=e+16|0;yd((b<<2)+d|0,0);fb=f+16|0;break a}pf();p()}return a|0}function qt(a,b,c,d){var e=0,f=0,g=0;e=fb-160|0;fb=e;f=b?a:e+158|0;x[e+148>>2]=f;a=-1;g=b-1|0;x[e+152>>2]=b>>>0>=g>>>0?g:0;e=Rb(e,0,144);x[e+76>>2]=-1;x[e+36>>2]=1266;x[e+80>>2]=-1;x[e+44>>2]=e+159;x[e+84>>2]=e+148;a:{if((b|0)<0){x[31484]=61;break a}v[f|0]=0;a=yL(e,c,d,1218,1219)}fb=e+160|0;return a}function ZI(a){a=a|0;var b=0,c=0,d=0;c=a+12|0;Ub(c+520|0);Ub(c+508|0);Ub(c+496|0);b=484;Ub(c+484|0);while(1){b=b-12|0;Ub(b+c|0);d=460;if((b|0)!=460){continue}break}while(1){d=d-12|0;Ub(d+c|0);b=172;if((d|0)!=172){continue}break}while(1){b=b-12|0;Ub(b+c|0);if((b|0)!=4){continue}break}bt(c);return a|0}function OI(a){a=a|0;var b=0,c=0,d=0;c=a+12|0;tb(c+520|0);tb(c+508|0);tb(c+496|0);b=484;tb(c+484|0);while(1){b=b-12|0;tb(b+c|0);d=460;if((b|0)!=460){continue}break}while(1){d=d-12|0;tb(d+c|0);b=172;if((d|0)!=172){continue}break}while(1){b=b-12|0;tb(b+c|0);if((b|0)!=4){continue}break}bt(c);return a|0}function sH(a,b,c){var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+8|0;Dc(e,b);x[31609]=0;b=d+20|0;S(123,b|0,c|0,e|0);c=x[31609];x[31609]=0;b:{c:{if((c|0)!=1){x[31609]=0;O(12,a|0,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break c}Ub(b);tb(e);fb=d+32|0;break a}a=N()|0;break b}a=N()|0;Ub(d+20|0)}tb(d+8|0);Q(a|0);p()}}function jua(a){a=a|0;var b=0,c=0,d=0;c=fb-32|0;fb=c;b=255;a:{if(Hj(x[a>>2],x[a+4>>2])>>>0<=49){b=cC(c,x[a+12>>2]);x[31609]=0;O(291,a|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break a}Bk(b);Wj(a,Hj(x[a>>2],x[a+4>>2])-1&255);b=Hj(x[a>>2],x[a+4>>2])-1|0}fb=c+32|0;return b&255}a=N()|0;Bk(b);Q(a|0);p()}function Uga(a,b,c){a=a|0;b=b|0;c=E(c);var d=0,e=E(0);if(b>>>0<=6){c=Pd(c,E(0));a:{b:{switch(b-1|0){case 0:c=ni(c);if(c==B[yb(a+4208|0,1)>>2]){break a}x[a+4236>>2]=0;B[a+4240>>2]=E(c*E(.5))+E(.5);break a;case 3:break b;default:break a}}c=E(ni(E(c*E(4)))*E(.25))}d=yb(a+4208|0,b),e=c,B[d>>2]=e;Wz(a)}}function Bha(a,b,c){a=a|0;b=b|0;c=E(c);var d=0,e=E(0);if(b>>>0<=6){c=Pd(c,E(0));a:{b:{switch(b-3|0){case 0:c=ni(c);if(c==B[yb(a+4208|0,3)>>2]){break a}x[a+4236>>2]=0;B[a+4240>>2]=E(c*E(.5))+E(.5);break a;case 1:break b;default:break a}}c=E(ni(E(c*E(4)))*E(.25))}d=yb(a+4208|0,b),e=c,B[d>>2]=e;Wz(a)}}function A_(a){var b=0;a:{if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=-28490681|y[a+68|0]!=13|(y[a+69|0]!=10|y[a+70|0]!=26)){break a}if(y[a+76|0]|((y[a+71|0]|y[a+72|0]<<8|(y[a+73|0]<<16|y[a+74|0]<<24))!=1397116231|y[a+75|0]!=1)){break a}b=((y[a+116|0]|y[a+117|0]<<8)-1&65535)>>>0<9}return b}function yG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;e=c+8|0;Xw(e,b);x[31609]=0;d=c+20|0;S(11,d|0,1,e|0);b=x[31609];x[31609]=0;a:{if((b|0)!=1){x[31609]=0;O(12,a|0,d|0);a=x[31609];x[31609]=0;if((a|0)==1){b=N()|0;Ub(d);break a}Ub(c+20|0);tb(c+8|0);fb=c+32|0;return}b=N()|0}tb(c+8|0);Q(b|0);p()}function wea(a,b){a=a|0;b=b|0;var c=0;x[31609]=0;W(996,a|0);c=x[31609];x[31609]=0;if((c|0)!=1){return NO(x[a+24>>2],b)|0}Y(T(0)|0)|0;x[31609]=0;V(983,9817,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Kea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return YO(x[x[a+24>>2]+24>>2])|0}Y(T(0)|0)|0;x[31609]=0;V(983,12881,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function zea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return oq(x[x[a+24>>2]+24>>2])|0}Y(T(0)|0)|0;x[31609]=0;V(983,7480,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function qea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return IO(x[x[a+24>>2]+24>>2])|0}Y(T(0)|0)|0;x[31609]=0;V(983,5816,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function om(a,b){var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;d=Kb(b);e=c,f=_c(x[b+4>>2],y[b+11|0]),x[e+12>>2]=f;x[c+8>>2]=x[a+4>>2]-1;yk(d,d+x[Hb(c+12|0,c+8|0)>>2]|0,x[a>>2]);d=x[a>>2];e=c,f=_c(x[b+4>>2],y[b+11|0]),x[e+12>>2]=f;a=x[a+4>>2];x[c+8>>2]=a-1;Rm(d+x[Hb(c+12|0,c+8|0)>>2]|0,a+d|0,78544);fb=c+16|0}function laa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;a:{if(!x[b+12>>2]){c=x[d>>2];break a}e=ib[x[b+16>>2]](x[b+8>>2],c,0,0)|0;c=x[d>>2];if((e|0)<0){break a}d=x[d+4>>2];e=c;while(1){if(!d){break a}f=ib[x[b+12>>2]](x[b+8>>2],e,d)|0;if(!f){break a}g=f+g|0;d=d-f|0;e=e+f|0;continue}}cc(a,c,g)}function kr(a){var b=0,c=0;b=fb-32|0;fb=b;x[b+24>>2]=0;x[b+28>>2]=0;x[b+16>>2]=0;x[b+20>>2]=0;x[b+8>>2]=0;x[b+12>>2]=0;x[b>>2]=0;x[b+4>>2]=0;c=a+288|0;iC(c,vV(c),b);x[b+24>>2]=0;x[b+28>>2]=0;x[b+16>>2]=0;x[b+20>>2]=0;x[b+8>>2]=0;x[b+12>>2]=0;x[b>>2]=0;x[b+4>>2]=0;a=a+800|0;iC(a,wC(a),b);fb=b+32|0}function Oea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return aP(x[x[a+24>>2]+24>>2])|0}Y(T(0)|0)|0;x[31609]=0;V(983,8812,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Mea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return _O(x[x[a+24>>2]+24>>2])|0}Y(T(0)|0)|0;x[31609]=0;V(983,7165,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Lea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return ZO(x[x[a+24>>2]+24>>2])|0}Y(T(0)|0)|0;x[31609]=0;V(983,5319,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Jea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return XO(x[x[a+24>>2]+24>>2])|0}Y(T(0)|0)|0;x[31609]=0;V(983,9346,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Dea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return wo(x[x[a+24>>2]+24>>2])|0}Y(T(0)|0)|0;x[31609]=0;V(983,7133,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Cea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return pq(x[x[a+24>>2]+24>>2])|0}Y(T(0)|0)|0;x[31609]=0;V(983,6822,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Bea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return RO(x[x[a+24>>2]+24>>2])|0}Y(T(0)|0)|0;x[31609]=0;V(983,6940,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Aea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return QO(x[x[a+24>>2]+24>>2])|0}Y(T(0)|0)|0;x[31609]=0;V(983,7008,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function xka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=zc(a,b,614);e=c+616|0;a=0;while(1){d=D(a,872);Fq(d+e|0,(b+d|0)+616|0);a=a+1|0;if((a|0)!=256){continue}break}a=CC(c+223848|0,b+223848|0);x[31609]=0;P(843,c+223860|0,b+223860|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){return c|0}b=N()|0;ec(a);Q(b|0);p()}function Pea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return+PA(x[x[a+24>>2]+24>>2])}Y(T(0)|0)|0;x[31609]=0;V(983,10165,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function Iea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return+WO(x[x[a+24>>2]+24>>2])}Y(T(0)|0)|0;x[31609]=0;V(983,15241,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function lE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=fb-32|0;fb=f;x[f+8>>2]=c;g=f,h=jf(b),x[g+28>>2]=h;c=f+8|0;sg(c,b,x[Hb(c,f+28|0)>>2]);b=Ze(c);x[31609]=0;aa(236,a|0,b|0,x[f+8>>2],d|0,e|0);a=x[31609];x[31609]=0;if((a|0)!=1){Kc(c);fb=f+32|0;return}a=N()|0;Kc(f+8|0);Q(a|0);p()}function XK(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=fb-16|0;fb=d;a=Pt(a);x[a+32>>2]=b;x[a>>2]=94604;e=d+12|0;cd(e,x[a+4>>2]);x[31609]=0;b=R(1234,x[d+12>>2])|0;f=x[31609];x[31609]=0;if((f|0)!=1){_b(e);x[a+40>>2]=c;x[a+36>>2]=b;g=a,h=ho(b),v[g+44|0]=h;fb=d+16|0;return}b=N()|0;_b(d+12|0);go(a);Q(b|0);p()}function Df(a){var b=0,c=0,d=0;a:{b:{b=a;if(!(b&3)){break b}if(!y[b|0]){return 0}while(1){b=b+1|0;if(!(b&3)){break b}if(y[b|0]){continue}break}break a}while(1){c=b;b=b+4|0;d=x[c>>2];if(!((d^-1)&d-16843009&-2139062144)){continue}break}while(1){b=c;c=b+1|0;if(y[b|0]){continue}break}}return b-a|0}function A0(a,b,c){var d=0,e=0;d=fb-32|0;fb=d;e=d+8|0;Uf(e,c);x[31609]=0;c=d+20|0;S(123,c|0,b|0,e|0);b=x[31609];x[31609]=0;a:{b:{if((b|0)!=1){x[31609]=0;O(12,a|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}Ub(c);tb(e);fb=d+32|0;return}c=N()|0;break a}c=N()|0;Ub(d+20|0)}tb(d+8|0);Q(c|0);p()}function kh(a,b){var c=0,d=0,e=0,f=0;d=fb-16|0;fb=d;a:{if(!b){b=0;break a}c=b>>31;e=(c^b)-c|0;c=G(e);$f(d,e,0,0,0,c+81|0);e=0+x[d+8>>2]|0;c=(x[d+12>>2]^65536)+(16414-c<<16)|0;c=e>>>0<f>>>0?c+1|0:c;f=b&-2147483648|c;c=x[d+4>>2];b=x[d>>2]}x[a>>2]=b;x[a+4>>2]=c;x[a+8>>2]=e;x[a+12>>2]=f;fb=d+16|0}function VK(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=fb-16|0;fb=d;a=gL(a);x[a+32>>2]=b;x[a>>2]=94972;e=d+12|0;cd(e,x[a+4>>2]);x[31609]=0;b=R(38,x[d+12>>2])|0;f=x[31609];x[31609]=0;if((f|0)!=1){_b(e);x[a+40>>2]=c;x[a+36>>2]=b;g=a,h=ho(b),v[g+44|0]=h;fb=d+16|0;return}b=N()|0;_b(d+12|0);Ct(a);Q(b|0);p()}function FW(a){var b=0;a:{if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=860902483){break a}if(Bb(y[a+4|0]|y[a+5|0]<<8)>>>0>2|y[a+6|0]>128){break a}if(Bb(y[a+200|0]|y[a+201|0]<<8)>>>0>3999){break a}if(!Bb(y[a+140|0]|y[a+141|0]<<8)){break a}b=(Bb(y[a+148|0]|y[a+149|0]<<8)|0)==50}return b}function bq(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;d=c+12|0;cd(d,a);x[31609]=0;a=R(1252,x[c+12>>2])|0;e=x[31609];x[31609]=0;a:{b:{if((e|0)==1){break b}x[31609]=0;V(1263,a|0,95168,95194,b|0);a=x[31609];x[31609]=0;if((a|0)==1){break b}_b(d);fb=c+16|0;break a}a=N()|0;_b(c+12|0);Q(a|0);p()}return b}function C0(a,b,c){var d=0,e=0,f=0;d=fb-32|0;fb=d;x[d+28>>2]=c;x[d+8>>2]=192;e=x[a>>2];f=x[a+8>>2];c=x[Hb(d+28|0,d+8|0)>>2];if(!Mb(e,f,c)){c=jf(a)}e=d+8|0;sw(e,b);f=Zb(d+16|0,x[d+8>>2],c);lc(d,x[a>>2],x[a+8>>2],x[f>>2],x[f+4>>2]);sw(e,b);Rb(x[d+8>>2]+c|0,0,192-c|0);Vb(a,x[d+28>>2]);fb=d+32|0}function sea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return+C[x[a+24>>2]+16>>3]}Y(T(0)|0)|0;x[31609]=0;V(983,7642,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function oea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return x[x[a+24>>2]+8>>2]}Y(T(0)|0)|0;x[31609]=0;V(983,10946,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return-1}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function hW(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;e=fb-16|0;fb=e;x[e+12>>2]=6553600;i=e,j=$b(b),x[i+8>>2]=j;f=+(d>>>0)/6553600;g=e+12|0;b=e+8|0;h=ur(f*+A[Hb(g,b)>>2]);x[e+8>>2]=6553600;i=e,j=$b(c),x[i+4>>2]=j;i=e,j=ur(f*+A[Hb(b,e+4|0)>>2]),x[i+12>>2]=j;x[e+8>>2]=d-h;rn(a,h,Hb(b,g));fb=e+16|0}function V0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;x[d+12>>2]=c;a:{if(!Mb(x[b>>2],x[b+8>>2],c<<1)){break a}xc(d+12|0,65535);vg(a,z[d+12>>1]);c=wb(x[a>>2]);x[d+4>>2]=c;a=wb(x[a+4>>2]);while(1){if(!Ib(c,a)){break a}ww(b,d+10|0);w[c>>1]=z[d+10>>1];c=x[ge(d+4|0)>>2];continue}}fb=d+16|0}function Jia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=Li(a,b,c,d);x[a>>2]=42236;b=Nb(a+4208|0);x[a+4228>>2]=0;x[a+4220>>2]=0;x[a+4224>>2]=0;x[a+4232>>2]=x[c+24620>>2];j0(a+4260|0,80,150,80,255);x[31609]=0;O(941,a+44|0,2);c=x[31609];x[31609]=0;if((c|0)!=1){return a|0}c=N()|0;wc(b);_f(a);Q(c|0);p()}function E3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;if(lh(a,x[b+8>>2],0)){Ux(b,c,d);return}e=x[a+12>>2];f=a+16|0;mI(x[f>>2],x[a+20>>2],b,c,d);a:{if((e|0)<2){break a}e=(e<<3)+f|0;a=a+24|0;while(1){mI(x[a>>2],x[a+4>>2],b,c,d);if(y[b+54|0]){break a}a=a+8|0;if(e>>>0>a>>>0){continue}break}}}function vx(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;v[a+6|0]=0;v[a+7|0]=0;v[a+16|0]=0;v[a+17|0]=0;v[a+18|0]=0;v[a+19|0]=0;v[a+20|0]=0;v[a+21|0]=0;v[a+22|0]=0;v[a+23|0]=0;v[a+8|0]=0;v[a+9|0]=0;v[a+10|0]=0;v[a+11|0]=0;v[a+12|0]=0;v[a+13|0]=0;v[a+14|0]=0;v[a+15|0]=0}function _x(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-160|0;fb=e;x[e+60>>2]=b;x[e+20>>2]=b;x[e+24>>2]=-1;f=e+16|0;Ci(f,0,0);BI(e,f,d,1);d=x[e+8>>2];g=x[e+12>>2];f=x[e>>2];h=x[e+4>>2];if(c){x[c>>2]=x[e+136>>2]+((x[e+20>>2]-x[e+60>>2]|0)+b|0)}x[a+8>>2]=d;x[a+12>>2]=g;x[a>>2]=f;x[a+4>>2]=h;fb=e+160|0}function V_(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;v[a+6|0]=0;v[a+7|0]=0;v[a+14|0]=0;v[a+15|0]=0;v[a+16|0]=0;v[a+17|0]=0;v[a+18|0]=0;v[a+19|0]=0;v[a+20|0]=0;v[a+21|0]=0;v[a+8|0]=0;v[a+9|0]=0;v[a+10|0]=0;v[a+11|0]=0;v[a+12|0]=0;v[a+13|0]=0;v[a+14|0]=0;v[a+15|0]=0}function nB(a,b,c){var d=0;d=x[a+480180>>2];a:{if((d|0)!=1048576){if((d|0)!=4){break a}d=y[b+813|0];if(c){v[b+813|0]=d&15|c<<4;break a}c=(d&240)>>>4|0;break a}if(c){v[b+813|0]=c;break a}c=y[b+813|0]}b:{if(!(v[b+851|0]&1)|!x[b+700>>2]){break b}c=c&255;if(!c){break b}xk(a,b,b+700|0,c<<2,0)}}function YF(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=x[a+92>>2];e=x[a+96>>2];if(d|e){while(1){if((c|0)==(g|0)){x[a+96>>2]=e;x[a+92>>2]=d}else{f=(g<<3)+b|0;h=x[f>>2];d=d-rd((rd(0-d|0,31)&255)+d|0,8)|0;x[f>>2]=h+d;h=x[f+4>>2];e=e-rd((rd(0-e|0,31)&255)+e|0,8)|0;x[f+4>>2]=h+e;g=g+1|0;continue}break}}}function Cia(a,b){a=a|0;b=b|0;var c=0,d=0;a:{b:{c=x[a+20>>2];b=x[c+4>>2];if((Xc(b,x[c+8>>2])|0)!=8){break b}d=y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24);if((d|0)!=1869112133){break b}c=y[b+4|0]|y[b+5|0]<<8|(y[b+6|0]<<16|y[b+7|0]<<24);x[a+4260>>2]=d;x[a+4264>>2]=c;break a}bA(a,a)}ru(a)}function $P(a){a=a|0;var b=0,c=0;c=fb-16|0;fb=c;b=x[a+4256>>2];x[a+4240>>2]=b<<1;x[31609]=0;x[c+12>>2]=0;S(947,a+4208|0,b<<2,c+12|0);b=x[31609];x[31609]=0;a:{if((b|0)==1){b=T(124540)|0;if((gb|0)!=($(124540)|0)){break a}Y(b|0)|0;x[a+4240>>2]=0;Z()}x[a+4244>>2]=0;fb=c+16|0;return}Q(b|0);p()}function qra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-16|0;fb=d;sf(b);x[d+12>>2]=0;a:{if(!Hk(a,d+12|0)){break a}f=c;c=x[d+12>>2];if(f>>>0<c>>>0){break a}while(1){if((c|0)==(e|0)){e=1;break a}v[d+11|0]=0;if(ii(a,d+11|0)){Qp(b,v[d+11|0]);e=e+1|0;continue}break}e=0}fb=d+16|0;return e|0}function cO(a,b){a=a|0;b=b|0;var c=0;b=fb-16|0;fb=b;x[a+4>>2]=0;x[a>>2]=47588;a=ac(8);x[31609]=0;b=P(36,b+4|0,12149)|0;c=x[31609];x[31609]=0;a:{b:{if((c|0)!=1){pc(a,b);x[31609]=0;S(97,a|0,48428,1e3);a=x[31609];x[31609]=0;if((a|0)!=1){break a}c=N()|0;tb(b);break b}c=N()|0;ic(a)}Q(c|0)}p()}function Nea(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return $O(x[a+24>>2])|0}Y(T(0)|0)|0;x[31609]=0;V(983,9782,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return 0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function h_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;a=og(a);b=b+236|0;e=tr(b);a:{while(1){if((b|0)!=(e|0)){d=z[b>>1];w[c+14>>1]=d;if(d){x[31609]=0;S(401,c+4|0,a|0,c+14|0);d=x[31609];x[31609]=0;if((d|0)==1){break a}}b=b+2|0;continue}break}fb=c+16|0;return}b=N()|0;Yv(a);Q(b|0);p()}function vka(a,b){a=a|0;b=b|0;var c=0,d=0;a:{if(Id(y[b+24|0])){a=og(a);c=Vi(x[b>>2]);d=Pf(b);x[31609]=0;S(846,a|0,c|0,d|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}x[31609]=0;P(845,a+12|0,b+12|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}v[a+24|0]=1}return}b=N()|0;aT(a);Q(b|0);p()}function oB(a,b,c){var d=0;d=x[a+480180>>2];a:{if((d|0)!=1048576){if((d|0)!=4){break a}d=y[b+814|0];if(c){v[b+814|0]=d&15|c<<4;break a}c=(d&240)>>>4|0;break a}if(c){v[b+813|0]=c;break a}c=y[b+813|0]}b:{if(!(v[b+851|0]&1)|!x[b+700>>2]){break b}c=c&255;if(!c){break b}xk(a,b,b+700|0,c,0)}}function zC(a,b,c,d,e){var f=0;a:{f=x[a>>2];if(!le(f,x[a+20>>2])|c>>>0>=f>>>0|f-c>>>0<d>>>0){break a}on(b);b=Wo(b,a);x[b+20>>2]=0;x[b>>2]=d;if(!Gh(b)){break a}if(x[a>>2]!=(d|0)){as(b+68|0)}zc(x[b+20>>2],x[a+20>>2]+c|0,d);x[b+8>>2]=e?d:0;x[b+4>>2]=0;w[b+34>>1]=z[b+34>>1]&65533|(e?2:0)}}function kH(a,b,c){var d=0,e=0;d=fb-32|0;fb=d;e=Fb(a+16|0);x[a>>2]=x[b>>2];x[a+4>>2]=x[b+4>>2];x[a+8>>2]=x[b+8>>2];x[a+12>>2]=x[b+12>>2];x[31609]=0;b=P(c|0,d+8|0,b+16|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){a=d+20|0;Rh(a,b);zb(e,a);tb(a);tb(b);fb=d+32|0;return}b=N()|0;Jh(a);Q(b|0);p()}function jk(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=x[a+4>>2];e=x[a+12>>2];i=x[a+8>>2];d=x[a>>2];while(1){if((b|0)!=(f|0)){if(!d){x[a>>2]=8;c=i;if((e|0)!=(c|0)){c=e-1|0;x[a+12>>2]=c}d=8;e=c;c=y[c|0]}g=c;d=d-1|0;x[a>>2]=d;c=g>>>1|0;x[a+4>>2]=c;h=g&1|h<<1;f=f+1|0;continue}break}return h}function iba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=fb-16|0;fb=d;c=d+4|0;vo(c,a);if(x[b>>2]){Nc(b);a=x[b>>2];it(b);Db(a);e=Ab(b),f=0,x[e>>2]=f;x[b>>2]=0;x[b+4>>2]=0}x[b>>2]=x[c>>2];x[b+4>>2]=x[c+4>>2];a=Ab(c);e=Ab(b),f=x[a>>2],x[e>>2]=f;x[a>>2]=0;x[c>>2]=0;x[c+4>>2]=0;nf(c);fb=d+16|0}function ZQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-16|0;fb=d;x[d+12>>2]=b;a:{if(Vg(a)>>>0>=b>>>0){f=x[a>>2];e=oc(f,x[a+4>>2]);x[d+8>>2]=e;YQ(f,x[Hb(d+12|0,d+8|0)>>2],c);if(b>>>0>e>>>0){oA(a,b-e|0,c);break a}Jd(a,x[a>>2]+(b<<2)|0);break a}pr(a);lm(a,Mf(a,b));oA(a,b,c)}fb=d+16|0}function _h(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0;d=fb-16|0;fb=d;e=fb-16|0;fb=e;c=e+4|0;x[c+4>>2]=1;g=c,h=Ec(16),x[g+8>>2]=h;b=tm(x[c+8>>2]);x[b>>2]=41128;g=Qn(nc(b)),h=41260,x[g>>2]=h;b=d+8|0;f=Sn(c);Rn(b,nc(f),f);um(c);fb=e+16|0;Ff(a,b);me(b);fb=d+16|0;x[a+8>>2]=0;Md(a+12|0);return a}function _ea(a){a=a|0;var b=0;x[31609]=0;W(1021,a|0);b=x[31609];x[31609]=0;a:{if((b|0)==1){Y(T(0)|0)|0;x[31609]=0;V(983,11990,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)==1){break a}Z();a=0}return a|0}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function daa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=tm(a);x[d>>2]=77652;a=pM(nc(d),mM(b));x[a>>2]=77984;c$(a+8|0,65536);c=20;Rb(a+20|0,0,192);while(1){e=a+c|0;x[e>>2]=0;x[e+4>>2]=0;v[e+8|0]=0;c=c+12|0;if((c|0)!=212){continue}break}Rb(a+212|0,0,64);x[a+276>>2]=b;x[a>>2]=77796;return d|0}function cE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=fb-32|0;fb=e;x[e+8>>2]=c;f=e,g=jf(b),x[f+28>>2]=g;c=e+8|0;sg(c,b,x[Hb(c,e+28|0)>>2]);b=Ze(c);x[31609]=0;V(343,a|0,b|0,x[e+8>>2],d|0);a=x[31609];x[31609]=0;if((a|0)!=1){Kc(c);fb=e+32|0;return}a=N()|0;Kc(e+8|0);Q(a|0);p()}function Ppa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=fb-16|0;fb=d;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(d+8|0,x[vb(d+4|0,a)>>2]);a:{if(b){x[31609]=0;O(641,a|0,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break a}sp(a,b,c)}b=d+8|0;Qd(b);Sj(b);fb=d+16|0;return a|0}a=N()|0;Sj(d+8|0);Q(a|0);p()}function I7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=fb-16|0;fb=g;x[g+12>>2]=b;b=g+8|0;cd(b,x[d+28>>2]);x[31609]=0;d=R(1252,x[g+8>>2])|0;h=x[31609];x[31609]=0;if((h|0)!=1){_b(b);mK(a,f+24|0,g+12|0,c,e,d);fb=g+16|0;return x[g+12>>2]}a=N()|0;_b(g+8|0);Q(a|0);p()}function Hfa(a){a=a|0;var b=0;x[31609]=0;W(996,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return x[a+16>>2]}Y(T(0)|0)|0;x[31609]=0;V(983,5690,a|0,0,0);a=x[31609];x[31609]=0;if((a|0)!=1){Z();return-1}a=N()|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;if((b|0)!=1){Q(a|0);p()}T(0)|0;Sb();p()}function H7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=fb-16|0;fb=g;x[g+12>>2]=b;b=g+8|0;cd(b,x[d+28>>2]);x[31609]=0;d=R(1252,x[g+8>>2])|0;h=x[31609];x[31609]=0;if((h|0)!=1){_b(b);lK(a,f+16|0,g+12|0,c,e,d);fb=g+16|0;return x[g+12>>2]}a=N()|0;_b(g+8|0);Q(a|0);p()}function sR(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;e=fb-32|0;fb=e;fd(e+24|0,b,c);c=fb-16|0;fb=c;f=x[e+28>>2];g=x[e+24>>2];h=(f-g|0)/6|0;i=c,j=qR(d,g,h)+D(h,6)|0,x[i+12>>2]=j;rc(e+16|0,f,c+12|0);fb=c+16|0;b=rR(b,x[e+16>>2]);i=e,j=vu(d,x[e+20>>2]),x[i+12>>2]=j;rc(a,b,e+12|0);fb=e+32|0}function k1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=fb-16|0;fb=d;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(d+8|0,x[vb(d+4|0,a)>>2]);a:{if(b){x[31609]=0;O(225,a|0,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break a}YE(a,b,c)}b=d+8|0;Qd(b);bh(b);fb=d+16|0;return a|0}a=N()|0;bh(d+8|0);Q(a|0);p()}function OP(a,b,c){v[a+12|0]=0;x[c>>2]=0;x[b>>2]=0;x[a+28>>2]=0;x[a+32>>2]=0;w[a+24>>1]=0;x[a+36>>2]=0;x[a+40>>2]=0;x[a+44>>2]=0;x[a+48>>2]=0;NP(a+60|0);NP(a+52|0);Cq(a+49956|0);Cq(a+58148|0);Cq(a+66340|0);Cq(a+74532|0);Rb(a+228|0,0,32768);Rb(a+32996|0,0,512);Rb(a+33508|0,0,16384)}function MZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=fb-16|0;fb=d;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(d+8|0,x[vb(d+4|0,a)>>2]);a:{if(b){x[31609]=0;O(460,a|0,b|0);e=x[31609];x[31609]=0;if((e|0)==1){break a}xD(a,b,c)}b=d+8|0;Qd(b);bm(b);fb=d+16|0;return a|0}a=N()|0;bm(d+8|0);Q(a|0);p()}function sra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;x[c+12>>2]=b;a:{if(oc(x[a>>2],x[a+4>>2])>>>0>511){break a}if(!Ed(b)){break a}x[31609]=0;d=a;a=c+12|0;O(500,d|0,a|0);e=x[31609];x[31609]=0;d=b;if((e|0)!=1){break a}b=N()|0;mg(a);Q(b|0);p()}mg(c+12|0);fb=c+16|0;return d|0}function lja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-16|0;fb=d;c=If(a,c);ae(d,x[a+36>>2]);a:{b:{if(!c){Qc(d,a+32|0,5);e=-1;if(!Gb(x[x[d>>2]>>2],x[d+4>>2])){break b}break a}e=x[c+16>>2]}f=x[a+36>>2];c:{if(!((e|0)!=4&(e|0)!=-1)){Hk(f,b);break c}FN(f,b,e)}f=c}ef(a,f);fb=d+16|0}function kj(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;x[e+12>>2]=d;g=rh(e+8|0,b);b=fb-16|0;fb=b;d=x[e+12>>2];x[b+12>>2]=d;x[b+8>>2]=d;f=-1;d=qt(0,0,c,d);a:{if((d|0)<0){break a}h=a;d=d+1|0;a=Gd(d);x[h>>2]=a;if(!a){break a}f=qt(a,d,c,x[b+12>>2])}fb=b+16|0;qh(g);fb=e+16|0;return f}function cla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-16|0;fb=d;x[d+12>>2]=b;a:{if($o(a)>>>0>=b>>>0){f=x[a>>2];e=Xc(f,x[a+4>>2]);x[d+8>>2]=e;Uh(f,x[Hb(d+12|0,d+8|0)>>2],c);if(b>>>0>e>>>0){zp(a,b-e|0,c);break a}Jd(a,x[a>>2]+b|0);break a}dw(a);Wk(a,Wl(a,b));zp(a,b,c)}fb=d+16|0}function Sp(a,b,c,d,e,f){var g=0,h=0,i=0;g=fb-16|0;fb=g;Lg(a+12|0,d);a:{if(!b){d=0;b=0;break a}if(b>>>0>=f>>>0){Tj();p()}d=Ec(D(b,e));x[g+12>>2]=b;x[g+8>>2]=d;d=x[g+12>>2];b=x[g+8>>2]}x[a>>2]=b;c=b+D(c,e)|0;x[a+8>>2]=c;x[a+4>>2]=c;h=nc(a),i=b+D(d,e)|0,x[h>>2]=i;fb=g+16|0;return a}function O7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=fb-16|0;fb=g;x[g+12>>2]=b;b=g+8|0;cd(b,x[d+28>>2]);x[31609]=0;d=R(28,x[g+8>>2])|0;h=x[31609];x[31609]=0;if((h|0)!=1){_b(b);qK(a,f+24|0,g+12|0,c,e,d);fb=g+16|0;return x[g+12>>2]}a=N()|0;_b(g+8|0);Q(a|0);p()}function N7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=fb-16|0;fb=g;x[g+12>>2]=b;b=g+8|0;cd(b,x[d+28>>2]);x[31609]=0;d=R(28,x[g+8>>2])|0;h=x[31609];x[31609]=0;if((h|0)!=1){_b(b);pK(a,f+16|0,g+12|0,c,e,d);fb=g+16|0;return x[g+12>>2]}a=N()|0;_b(g+8|0);Q(a|0);p()}function Ku(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0;a:{if(!b){break a}i=Ob(a+1074312|0,73)?c- -64|0:c;c=120;g=Aj(a);j=g^-1;e=1;while(1){if(!c){break a}k=c;c=c>>>1|0;h=e+c|0;f=zh(a,h,i,d);if(!(f>>>0>b>>>0&j)&(!(!f|g)|b>>>0<=f>>>0)){continue}e=h+1|0;c=(c^-1)+k|0;continue}}return e}function ni(a){var b=E(0),c=0,d=0;c=(q(a),j(2));d=c>>>23&255;if(d>>>0<=149){if(d>>>0<=125){return E(a*E(0))}a=(c|0)>=0?a:E(-a);b=E(E(E(a+E(8388608))+E(-8388608))-a);a:{if(b>E(.5)){a=E(E(a+b)+E(-1));break a}a=E(a+b);if(!(b<=E(-.5))){break a}a=E(a+E(1))}a=(c|0)>=0?a:E(-a)}return a}function Z2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+60|0;d=Tt(c);x[a>>2]=94064;x[d>>2]=94084;x[a+60>>2]=94124;x[a>>2]=94104;x[a+4>>2]=0;e=c;c=a+8|0;oo(e,c);x[a>>2]=94064;x[d>>2]=94084;x[31609]=0;P(107,c|0,b|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}a=N()|0;vl(d);Q(a|0);p()}function Xs(a,b,c){var d=0,e=0,f=0;e=fb-16|0;fb=e;d=y[b|0];a:{if(!d){d=0;break a}b:{if(!y[b+1|0]){v[a|0]=d;break b}d=0;if(!Zp(e+12|0,b,c)){break a}f=x[e+12>>2];b=dy(f,c);c:{if((b|0)!=-1){break c}b=32;if((f|0)==8239){break c}if((f|0)!=160){break a}}v[a|0]=b}d=1}fb=e+16|0;return d}function HZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=fb+-64|0;fb=c;e=c+44|0;sg(e,a,32);a=x[c+44>>2];d=c+20|0;ug(d,2,Ze(e),a);x[31609]=0;a=c+32|0;O(218,a|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){d=c+12|0;Fn(d,b);om(d,a);tb(a);Kc(e);fb=c- -64|0;break a}a=N()|0;Kc(c+44|0);Q(a|0);p()}}function vP(a,b){var c=0,d=0,e=0,f=0;c=fb-96|0;fb=c;EQ(b,c,c+96|0);b=0;while(1){if((b|0)==12){x[a+104>>2]=0;x[a+96>>2]=!(x[a+88>>2]|x[a+92>>2]);x[a+100>>2]=0;fb=c+96|0}else{d=b<<3;e=d+a|0;f=c+d|0;d=x[f+4>>2];x[e>>2]=x[f>>2];x[e+4>>2]=d&65535;b=b+1|0;continue}break}x[a+112>>2]=0}function RF(a,b,c,d){var e=0,f=0,g=0;b=x[a+1076>>2]+(b-(b&c?c<<1:0)|0)|0;x[a+1076>>2]=b;c=b+x[a+1080>>2]|0;x[a+1080>>2]=c;e=d;d=x[a+1068>>2];w[e+(d<<1)>>1]=y[a+1084|0]?c:b;x[a+1064>>2]=x[a+1064>>2]+1;f=a,g=_d(z[x[a+1060>>2]+34>>1])+d|0,x[f+1068>>2]=g;x[a+1072>>2]=x[a+1072>>2]-1}function aja(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-32|0;fb=c;x[c+12>>2]=-1;x[c+16>>2]=0;x[c+4>>2]=0;Fb(c+20|0);x[31609]=0;x[c+4>>2]=x[c+4>>2]&-1332|1058;x[c+8>>2]=1;d=a;a=c+4|0;S(79,d|0,b|0,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){Jh(a);fb=c+32|0;return}a=N()|0;Jh(c+4|0);Q(a|0);p()}function FY(a,b,c,d){var e=0,f=0;e=fb-16|0;fb=e;x[e+12>>2]=a;a:{if(!(!c|b)){a=Ye(+(D(a,d)>>>0)*.25*1e4);break a}if(!(!a|!b)){xc(e+12|0,10);a=D(y[x[e+12>>2]+25200|0],1e4);break a}f=+(a>>>0);if(a-1>>>0<=9){a=Ye(733.8401379310345/f*1e4);break a}a=Ye(f/.264*1e4)}fb=e+16|0;return a}function Ue(a){var b=0,c=0;b=fb-32|0;fb=b;v[b+8|0]=0;x[b>>2]=0;x[b+4>>2]=4194432;lF(b+9|0);x[a>>2]=x[b>>2];c=x[b+8>>2];x[a+4>>2]=x[b+4>>2];x[a+8>>2]=c;c=x[b+16>>2];x[a+12>>2]=x[b+12>>2];x[a+16>>2]=c;c=x[b+24>>2];x[a+20>>2]=x[b+20>>2];x[a+24>>2]=c;v[a+28|0]=y[b+28|0];fb=b+32|0}function QZ(a){var b=0,c=0;b=y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24);a:{b:{if((b|0)!=1297108297){if((b|0)!=778924148){break a}if((y[a+34|0]|y[a+35|0]<<8)>>>0<=255){break b}break a}if((y[a+34|0]|y[a+35|0]<<8)>>>0>255){break a}}c=(y[a+36|0]|y[a+37|0]<<8)>>>0<4e3}return c}function G7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;a=fb-16|0;fb=a;x[a+12>>2]=b;b=a+8|0;cd(b,x[d+28>>2]);x[31609]=0;d=R(1252,x[a+8>>2])|0;g=x[31609];x[31609]=0;if((g|0)!=1){_b(b);kK(f+20|0,a+12|0,c,e,d);fb=a+16|0;return x[a+12>>2]}b=N()|0;_b(a+8|0);Q(b|0);p()}function Ym(a,b,c,d){var e=0,f=0,g=0;a:{f=D(b,872)+a|0;e=x[f+1075648>>2];if(!e){break a}if(!Kj(y[e+31|0])){break a}g=y[e+34|0]-1|0;if((g&255)>>>0>249){break a}a=x[$d(a+906300|0,g)>>2];if(!a){break a}ib[x[x[a>>2]+96>>2]](a,e,c,d,b);if(c>>>0>250){break a}w[f+1075834>>1]=65535}}function It(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;d=ac(16);if(!y[501721]){v[501721]=1}a=Zb(c+8|0,a,125928);x[31609]=0;e=x[a+4>>2];x[c>>2]=x[a>>2];x[c+4>>2]=e;a=U(1220,d|0,c|0,b|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){da(a|0,123848,1221);p()}a=N()|0;ic(d);Q(a|0);p()}function wH(a,b,c,d,e,f){var g=0,h=0,i=0,j=0;g=fb-16|0;fb=g;x[g+12>>2]=c;c=g+12|0;xc(c,f);xc(c,65535);h=z[g+12>>1];vg(a,h);c=0;while(1){if((c|0)==(h|0)){fb=g+16|0}else{f=y[b+c|0];i=Qr(x[a>>2],x[a+4>>2],c),j=(d|0)==(f|0)?-1:(e|0)==(f|0)?-2:f,w[i>>1]=j;c=c+1|0;continue}break}}function sQ(a){a=a|0;var b=0,c=0;c=fb-16|0;fb=c;b=x[x[a+16>>2]+1074404>>2];x[31609]=0;x[c+12>>2]=0;S(947,a+4208|0,D(b,254)|0,c+12|0);b=x[31609];x[31609]=0;a:{if((b|0)==1){b=T(124540)|0;if((gb|0)!=($(124540)|0)){break a}Y(b|0)|0;Z()}x[a+4220>>2]=0;fb=c+16|0;return}Q(b|0);p()}function jM(a,b,c){var d=0,e=0,f=0,g=0;f=fb-16|0;fb=f;d=fb-32|0;fb=d;fd(d+24|0,a,b);a=fb-16|0;fb=a;e=c;b=x[d+28>>2];c=x[d+24>>2];g=b-c|0;e=e-g|0;x[a+12>>2]=e;XC(e,c,g>>2);rc(d+16|0,b,a+12|0);fb=a+16|0;a=x[d+16>>2];x[d+12>>2]=x[d+20>>2];rc(f+8|0,a,d+12|0);fb=d+32|0;fb=f+16|0}function M7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;a=fb-16|0;fb=a;x[a+12>>2]=b;b=a+8|0;cd(b,x[d+28>>2]);x[31609]=0;d=R(28,x[a+8>>2])|0;g=x[31609];x[31609]=0;if((g|0)!=1){_b(b);oK(f+20|0,a+12|0,c,e,d);fb=a+16|0;return x[a+12>>2]}b=N()|0;_b(a+8|0);Q(b|0);p()}function zla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;a=QV(d+4|0,a+8|0,b);b=x[a>>2];a:{while(1){if(x[a+4>>2]==(b|0)){break a}x[31609]=0;O(784,b|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){b=x[a>>2]+32|0;x[a>>2]=b;continue}break}b=N()|0;je(a);Q(b|0);p()}je(a);fb=d+16|0}function z$(a,b){var c=0,d=0,e=0;d=fb-16|0;fb=d;x[d+12>>2]=b;c=fb-16|0;fb=c;x[c+12>>2]=107374182;x[c+8>>2]=2147483647;e=Hb(c+12|0,c+8|0);fb=c+16|0;c=b;b=x[e>>2];if(c>>>0<=b>>>0){a=v$(a);if(a>>>0<b>>>1>>>0){x[d+8>>2]=a<<1;b=x[bd(d+8|0,d+12|0)>>2]}fb=d+16|0;return b}ed();p()}function boa(a,b){a=a|0;b=b|0;var c=0,d=0;a:{b:{c=y[a+11|0];c:{d:{if(vd(c)){c=x[a+4>>2];d=$i(x[a+8>>2])-1|0;if((c|0)==(d|0)){break d}break c}d=1;c=Hh(c);if((c|0)!=1){break b}}oC(a,d,1,d,d,0);c=d}d=x[a>>2];Bd(a,c+1|0);break a}Ne(a,c+1|0);d=a}a=(c<<2)+d|0;yd(a,b);yd(a+4|0,0)}function Y$(a,b){var c=0,d=0,e=0;d=fb-16|0;fb=d;x[d+12>>2]=b;c=fb-16|0;fb=c;x[c+12>>2]=153391689;x[c+8>>2]=2147483647;e=Hb(c+12|0,c+8|0);fb=c+16|0;c=b;b=x[e>>2];if(c>>>0<=b>>>0){a=tE(a);if(a>>>0<b>>>1>>>0){x[d+8>>2]=a<<1;b=x[bd(d+8|0,d+12|0)>>2]}fb=d+16|0;return b}ed();p()}function vY(a,b){var c=0,d=0;a:{c=x[b>>2];d=x[b+20>>2];if(!le(c,d)){break a}if(x[a+20>>2]==(d|0)){x[a+20>>2]=0;c=x[b>>2]}xc(a,c);c=z[a+34>>1]&-2|w[b+34>>1]&1;w[a+34>>1]=c;w[a+34>>1]=c&65471|z[b+34>>1]&64;if(!Gh(a)){break a}zc(x[a+20>>2],x[b+20>>2],Rk(x[a>>2],z[a+34>>1]))}}function sd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=fb-32|0;fb=e;g=x[b+8>>2];f=x[b>>2];lf(e+16|0,c,d);c=x[x[f>>2]+28>>2];d=x[e+20>>2];x[e+8>>2]=x[e+16>>2];x[e+12>>2]=d;ib[c|0](e+24|0,f,g,e+8|0);lf(a,x[e+24>>2],x[e+28>>2]);x[b+8>>2]=x[b+8>>2]+x[a+4>>2];fb=e+32|0}function iM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=fb-32|0;fb=e;lf(e+24|0,b,c);b=Ff(e+16|0,d);x[31609]=0;c=x[b+4>>2];x[e+8>>2]=x[b>>2];x[e+12>>2]=c;hg(163,a,x[e+24>>2],x[e+28>>2],e+8|0);a=x[31609];x[31609]=0;if((a|0)!=1){me(d);fb=e+32|0;return}a=N()|0;me(d);Q(a|0);p()}function Tta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=fb-624|0;fb=b;e=-1;c=fb-16|0;fb=c;d=b+14|0;S$(c+8|0,d);f=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(f|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(f|0)==(g|0);if(!a){R$(d)}if(a){e=T$(d)}fb=b+624|0;return e|0}function Ina(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(c+8|0,x[vb(c+4|0,a)>>2]);a:{if(b){x[31609]=0;O(225,a|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break a}Uq(a,b)}b=c+8|0;Qd(b);bh(b);fb=c+16|0;return a|0}a=N()|0;bh(c+8|0);Q(a|0);p()}function Dqa(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(c+8|0,x[vb(c+4|0,a)>>2]);a:{if(b){x[31609]=0;O(589,a|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break a}oD(a,b)}b=c+8|0;Qd(b);bh(b);fb=c+16|0;return a|0}a=N()|0;bh(c+8|0);Q(a|0);p()}function $oa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=fb-160|0;fb=b;e=-1;c=fb-16|0;fb=c;d=b+14|0;dX(c+8|0,d);f=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(f|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(f|0)==(g|0);if(!a){cX(d)}if(a){e=eX(d)}fb=b+160|0;return e|0}function ko(a,b,c){var d=0,e=0,f=0;a:{if(!b){d=a;break a}while(1){d=Kua(a,b,10,0);e=hb;a=Iua(d,e,246,0)+a|0;c=c-1|0;v[c|0]=a|48;f=b>>>0>9;a=d;b=e;if(f){continue}break}}if(d){while(1){c=c-1|0;a=(d>>>0)/10|0;v[c|0]=D(a,246)+d|48;b=d>>>0>9;d=a;if(b){continue}break}}return c}function hqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;a=HJ(c+4|0,a,b);b=x[a+4>>2];d=x[a+8>>2];a:{while(1){if((b|0)==(d|0)){break a}x[31609]=0;W(598,b|0);e=x[31609];x[31609]=0;if((e|0)!=1){b=b+24|0;x[a+4>>2]=b;continue}break}b=N()|0;kc(a);Q(b|0);p()}kc(a);fb=c+16|0}function Xsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=fb-160|0;fb=b;e=-1;c=fb-16|0;fb=c;d=b+3|0;z_(c+8|0,d);f=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(f|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(f|0)==(g|0);if(!a){y_(d)}if(a){e=A_(d)}fb=b+160|0;return e|0}function Qp(a,b){a=a|0;b=b|0;var c=0,d=0;a:{b:{c=y[a+11|0];c:{d:{if(vd(c)){c=x[a+4>>2];d=$i(x[a+8>>2])-1|0;if((c|0)==(d|0)){break d}break c}d=10;c=Hh(c);if((c|0)!=10){break b}}bn(a,d,1,d,d,0,0);c=d}d=x[a>>2];Bd(a,c+1|0);break a}Ne(a,c+1|0);d=a}a=c+d|0;hd(a,b);hd(a+1|0,0)}function QF(a,b,c,d){var e=0,f=0;b=x[a+1076>>2]+(b-(b&c?c<<1:0)|0)|0;x[a+1076>>2]=b;c=b+x[a+1080>>2]|0;x[a+1080>>2]=c;v[x[a+1068>>2]+d|0]=y[a+1084|0]?c:b;x[a+1064>>2]=x[a+1064>>2]+1;e=a,f=x[a+1068>>2]+_d(z[x[a+1060>>2]+34>>1])|0,x[e+1068>>2]=f;x[a+1072>>2]=x[a+1072>>2]-1}function Joa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=fb-208|0;fb=b;e=-1;c=fb-16|0;fb=c;d=b+4|0;EW(c+8|0,d);f=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(f|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(f|0)==(g|0);if(!a){DW(d)}if(a){e=FW(d)}fb=b+208|0;return e|0}function I8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=(e-d|0)+b|0;a:{while(1){if((d|0)!=(e|0)){a=-1;if((b|0)==(c|0)){break a}f=v[b|0];g=v[d|0];if((f|0)<(g|0)){break a}if((f|0)>(g|0)){return 1}else{d=d+1|0;b=b+1|0;continue}}break}a=(c|0)!=(h|0)}return a|0}function pta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=fb-32|0;fb=b;e=-1;c=fb-16|0;fb=c;d=b+10|0;cw(c+8|0,d);f=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(f|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(f|0)==(g|0);if(!a){V_(d)}if(a){e=W_(d)}fb=b+32|0;return e|0}function lra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=fb-16|0;fb=b;e=-1;c=fb-16|0;fb=c;d=b+11|0;$j(c+8|0,d);f=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);g=x[c+4>>2];if((g|0)==(f|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(f|0)==(g|0);if(!a){$Y(d)}if(a){e=aZ(d)}fb=b+16|0;return e|0}function dla(a,b){a=a|0;b=b|0;var c=0,d=0;a:{b:{c=y[a+11|0];c:{d:{if(vd(c)){c=x[a+4>>2];d=$i(x[a+8>>2])-1|0;if((c|0)==(d|0)){break d}break c}d=10;c=Hh(c);if((c|0)!=10){break b}}SB(a,d,1,d,d,0);c=d}d=x[a>>2];Bd(a,c+1|0);break a}Ne(a,c+1|0);d=a}a=c+d|0;hd(a,b);hd(a+1|0,0)}function XE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;a=Dw(c+4|0,a,b);b=x[a+4>>2];d=x[a+8>>2];a:{while(1){if((b|0)==(d|0)){break a}x[31609]=0;W(228,b|0);e=x[31609];x[31609]=0;if((e|0)!=1){b=b+20|0;x[a+4>>2]=b;continue}break}b=N()|0;kc(a);Q(b|0);p()}kc(a);fb=c+16|0}function Lx(a,b,c,d,e){var f=0,g=0;a:{f=fb+-64|0;fb=f;g=f+44|0;sg(g,a,e);a=x[f+44>>2];e=f+20|0;ug(e,d,Ze(g),a);x[31609]=0;a=f+32|0;O(218,a|0,e|0);d=x[31609];x[31609]=0;if((d|0)!=1){d=f+12|0;Zb(d,b,c);om(d,a);tb(a);Kc(g);fb=f- -64|0;break a}a=N()|0;Kc(f+44|0);Q(a|0);p()}}function H_(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=fb-16|0;fb=d;x[d+12>>2]=c;c=d+12|0;xc(c,256);xc(c,65535);f=z[d+12>>1];vg(a,f);c=0;while(1){if((c|0)==(f|0)){fb=d+16|0}else{e=y[b+c|0];g=Qr(x[a>>2],x[a+4>>2],c),h=(e|0)==255?-1:(e|0)==254?-2:e,w[g>>1]=h;c=c+1|0;continue}break}}function Ge(a){var b=0,c=0,d=0;o(+a);b=j(1)|0;j(0)|0;d=b>>>20&2047;if(d>>>0<=1074){if(d>>>0<=1021){return a*0}a=(b|0)>0|(b|0)>=0?a:-a;c=a+4503599627370496+-4503599627370496-a;a:{if(c>.5){a=a+c+-1;break a}a=a+c;if(!(c<=-.5)){break a}a=a+1}a=(b|0)>0|(b|0)>=0?a:-a}return a}function mF(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;d=c+12|0;cd(d,a);x[31609]=0;a=R(28,x[c+12>>2])|0;e=x[31609];x[31609]=0;a:{if((e|0)==1){break a}x[31609]=0;a=P(29,a|0,b|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}_b(d);fb=c+16|0;return a}a=N()|0;_b(c+12|0);Q(a|0);p()}function lu(a){var b=0,c=0,d=E(0);c=y[a+4232|0];if(c>>>0>=5){v[a+4232|0]=0;c=0}if(v[a+4233|0]<0){v[a+4233|0]=127}b=v[a+4234|0];if((b|0)<0){v[a+4234|0]=127;b=127}a:{if((c|0)==3){d=E(E(1)-Ee(E(2),E(-E((b+1&255)>>>0))));break a}d=Ee(E(2),E(-E((b&255)>>>0)))}B[a+4224>>2]=d}function _ha(a){a=a|0;var b=0,c=0,d=0,e=0;b=fb-16|0;fb=b;x[b+12>>2]=a;x[b+8>>2]=4104;a=0;d=x[b+8>>2];a:{if(d>>>0<4096){break a}c=x[b+12>>2];e=c+7&-8;c=e-c|0;if(c>>>0>d-4096>>>0){break a}x[b+12>>2]=e;x[b+8>>2]=d-c;a=e}if(!a){_(6053,9030,88,7400);p()}fb=b+16|0;return a|0}function JW(a){var b=0,c=0,d=0,e=0;c=fb-16|0;fb=c;b=wb(x[a>>2]);x[c+12>>2]=b;e=wb(x[a+4>>2]);while(1){a:{d=Ib(b,e);if(!d){break a}a=z[b>>1];b:{if(!((a|0)!=255&(a|0)!=99)){w[b>>1]=65535;break b}if(a>>>0>63){break a}}b=x[ge(c+12|0)>>2];continue}break}fb=c+16|0;return d^1}function A9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=fb-16|0;fb=d;e=d+8|0;c=x[b+52>>2];a:{if(c&16){c=x[b+48>>2];f=x[b+28>>2];if(c>>>0<f>>>0){x[b+48>>2]=f;c=f}xl(e,x[b+24>>2],c);break a}if(c&8){xl(e,x[b+12>>2],x[b+20>>2]);break a}Md(e)}rK(a,x[d+8>>2],x[d+12>>2]);fb=d+16|0}function Uj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=wb(x[b>>2]);f=wb(x[b+4>>2]);e=fb-16|0;fb=e;x[e+12>>2]=d;while(1){a:{if(!Ib(d,f)){break a}if(C$(c,x[d>>2],x[d+4>>2])){break a}d=x[em(e+12|0)>>2];continue}break}fb=e+16|0;if(mc(d,wb(x[b+4>>2]))){_h(a);return}lp(a,d)}function Pja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-48|0;fb=d;sf(b);e=d+28|0;sg(e,a,c);a=x[d+28>>2];c=d+4|0;ug(c,1,Ze(e),a);x[31609]=0;a=d+16|0;O(218,a|0,c|0);c=x[31609];x[31609]=0;if((c|0)!=1){zb(b,a);tb(a);Kc(e);fb=d+48|0;break a}a=N()|0;Kc(d+28|0);Q(a|0);p()}}function paa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;a:{if(y[b+40|0]){break a}b:{if(!x[b+28>>2]){break b}d=x[c+4>>2];f=x[c>>2];while(1){if(!d){break a}e=ib[x[b+28>>2]](x[b+24>>2],f,d)|0;if(!e){break b}g=e+g|0;d=d-e|0;f=f+e|0;continue}}v[b+40|0]=1}cc(a,x[c>>2],g)}function MF(a,b,c){var d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;e=x[a+4>>2];f=e+b|0;x[a+4>>2]=f;a:{b:{if(!e){g=f-1|0;break b}g=f-1|0;if((g^e-1)>>>0>31){break b}a=x[a>>2];break a}a=x[a>>2];x[a+((f>>>0>=33?g>>>5|0:0)<<2)>>2]=0}xp(d+8|0,a,e);Vw(x[d+8>>2],x[d+12>>2],b,c);fb=d+16|0}function n0(a,b){var c=0,d=0;a:{b:{a=a-12|0;c:{if(a>>>0>31){break c}d=1<<a;c=1;if(d&-2145904587){break a}if(d&65792){break b}if((a|0)!=7){break c}b=b&240;c=1;if(!b|(b|0)==96|(b|0)==224){break a}}return 0}b=b-96|0;c=0;if(b>>>0>=144){break a}c=297>>>(b>>>4)&1}return c}function mM(a){var b=0,c=0,d=0;b=fb-48|0;fb=b;ig(x[x[a>>2]-12>>2]+a|0,0);ae(b+32|0,a);a=Di(a,0,0,2);ae(b+16|0,a);c=x[b+44>>2];x[b+8>>2]=x[b+40>>2];x[b+12>>2]=c;c=x[b+36>>2];x[b>>2]=x[b+32>>2];x[b+4>>2]=c;c=x[b+28>>2];d=x[b+24>>2];Um(a,b);a=Tu(d,c);fb=b+48|0;return a}function h$(a){var b=0;if(!((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=320012546|(y[a+4|0]|y[a+5|0]<<8|(y[a+6|0]<<16|y[a+7|0]<<24))!=184619540|y[a+8|0]>1|((y[a+9|0]-1&255)>>>0>7|(y[a+10|0]|y[a+11|0]<<8)>>>0>4096))){b=(y[a+12|0]|y[a+13|0]<<8)>>>0<4097}return b}function Xp(a,b,c){var d=0,e=0,f=0;d=a*a;f=d*(d*d)*(d*1.58969099521155e-10+-2.5050760253406863e-8)+(d*(d*27557313707070068e-22+-.0001984126982985795)+.00833333333332249);e=d*a;if(!c){return e*(d*f+-.16666666666666632)+a}return a-(d*(b*.5-f*e)-b+e*.16666666666666632)}function P8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;a:{if(!y[a+44|0]){c=(c|0)>0?c:0;while(1){if((c|0)==(d|0)){break a}if(((f=a,g=zf(v[b|0]),e=x[x[a>>2]+52>>2],ib[e](f|0,g|0)|0)|0)==-1){return d|0}else{b=b+1|0;d=d+1|0;continue}}}c=fm(b,1,c,x[a+32>>2])}return c|0}function KJ(a){var b=0,c=0,d=0,e=0,f=0;b=fb-16|0;fb=b;x[a>>2]=0;x[a+4>>2]=0;e=tc(a+8|0),f=0,v[e+128|0]=f;c=b+8|0;Rd(c,x[vb(b+4|0,a)>>2]);x[31609]=0;O(1327,a|0,30);d=x[31609];x[31609]=0;if((d|0)!=1){Uq(a,30);Qd(c);FJ(c);fb=b+16|0;return a}a=N()|0;FJ(b+8|0);Q(a|0);p()}function H$(a,b,c){var d=0,e=0;d=fb-16|0;fb=d;v[d+15|0]=1;v[d+14|0]=a>>>2;a=y[cf(d+15|0,d+14|0)|0];e=b>>>0<2|a>>>0<15;if(!e){v[d+13|0]=1;v[d+12|0]=(((a+b|0)-2&65535)>>>0)/((b-1&65535)>>>0);a=y[cf(d+13|0,d+12|0)|0]}fb=d+16|0;return(c?a<<4|(e?15:0):a&15|(e?-16:0))&255}function uia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{if(x[b+4>>2]!=8){break a}b=x[b>>2];d=y[b+1|0]<<8;e=y[b+2|0]<<16|y[b+3|0]<<24;if((y[b|0]|d|e)!=1869112133){break a}c=y[b+4|0]|y[b+5|0]<<8|(y[b+6|0]<<16|y[b+7|0]<<24);x[a+4260>>2]=e|(d|y[b|0]);x[a+4264>>2]=c;ru(a)}}function Vn(a,b){var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;a:{if(!b){b=0;break a}d=b;b=G(b);$f(c,d,0,0,0,112-(b^31)|0);d=0+x[c+8>>2]|0;b=(x[c+12>>2]^65536)+(16414-b<<16)|0;f=e>>>0>d>>>0?b+1|0:b;e=x[c+4>>2];b=x[c>>2]}x[a>>2]=b;x[a+4>>2]=e;x[a+8>>2]=d;x[a+12>>2]=f;fb=c+16|0}function Oq(a,b,c,d){var e=0,f=0,g=0;a:{e=Rl(a,b);if((e|0)==255){break a}g=x[a>>2];if(Gj(g)){break a}f=Vd(a+318|0,e);e=IU(e);if(v[xb(f,10)|0]&1|d){Ah(g,x[a+4>>2],b,e- -64&65535,HU(c,y[xb(f,2)|0]))}if(d){break a}Ah(x[a>>2],x[a+4>>2],b,e+67&65535,HU(c,y[xb(f,3)|0]))}}function Eha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{if(x[b+4>>2]!=8){break a}b=x[b>>2];d=y[b+1|0]<<8;e=y[b+2|0]<<16|y[b+3|0]<<24;if((y[b|0]|d|e)!=1869112133){break a}c=y[b+4|0]|y[b+5|0]<<8|(y[b+6|0]<<16|y[b+7|0]<<24);x[a+4228>>2]=e|(d|y[b|0]);x[a+4232>>2]=c;lu(a)}}function yv(a,b){a:{b:{if((b|0)!=31){if((b|0)!=15){break b}b=0;if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))==1196314451){break b}break a}b=0;if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=825446227){break a}}b=Bb(y[a+4|0]|y[a+5|0]<<8)>>>0>177}return b}function _B(a,b,c){var d=0,e=0,f=0;d=fb-16|0;fb=d;a=mC(d+4|0,a,b);b=x[a+4>>2];e=x[a+8>>2];a:{while(1){if((b|0)==(e|0)){break a}x[31609]=0;O(784,b|0,c|0);f=x[31609];x[31609]=0;if((f|0)!=1){b=b+32|0;x[a+4>>2]=b;continue}break}b=N()|0;kc(a);Q(b|0);p()}kc(a);fb=d+16|0}function Wh(a,b){var c=0,d=0,e=0;a:{if(!(v[a+480180|0]&1|b)){break a}e=x[a+24616>>2]&524288;b=0;while(1){if((b|0)==127){break a}c=(b<<5)+a|0;w[c+480286>>1]=64;d=c+480280|0;x[d>>2]=x[d>>2]&-257;d=c+480284|0;c=(b&3)-1>>>0<2;w[d>>1]=e?c<<8:c?192:64;b=b+1|0;continue}}}function mP(a,b){var c=0,d=0;x[a+4>>2]=b;x[a>>2]=126444;x[a+20>>2]=0;x[a+24>>2]=0;c=(b>>>5|0)+((b&31)!=0)|0;x[a+12>>2]=c;d=(b>>>0)/(c>>>0)|0;x[a+8>>2]=d;x[a+32>>2]=d>>>0>=31?-1:-1>>>(d^31)|0;x[a+28>>2]=b>>>0>=c>>>0?-1>>>32-d|0:0;x[a+16>>2]=(D(c,d)-b|0)+c;return a}function l9(a){a=a|0;var b=0,c=0,d=0;c=x[a+44>>2];b=x[a+24>>2];if(c>>>0<b>>>0){x[a+44>>2]=b;c=b}d=-1;a:{if(!(y[a+48|0]&8)){break a}b=x[a+16>>2];if(b>>>0<c>>>0){Wn(a,x[a+8>>2],x[a+12>>2],c);b=x[a+16>>2]}a=x[a+12>>2];if(a>>>0>=b>>>0){break a}d=zf(v[a|0])}return d|0}function I0(a,b,c){var d=0,e=0,f=0,g=0;d=fb-48|0;fb=d;sf(b);f=d+28|0;sg(f,a,c);a=x[d+28>>2];e=d+4|0;ug(e,3,Ze(f),a);x[31609]=0;g=d+16|0;O(218,g|0,e|0);e=x[31609];x[31609]=0;if((e|0)!=1){zb(b,g);tb(g);Kc(f);fb=d+48|0;return!c|(a|0)!=0}a=N()|0;Kc(d+28|0);Q(a|0);p()}function Mh(a,b,c,d,e,f){var g=0;g=fb-32|0;fb=g;x[g+12>>2]=-1;x[g+16>>2]=0;x[g+4>>2]=0;Fb(g+20|0);x[g+8>>2]=f;x[31609]=0;x[g+4>>2]=x[g+4>>2]&e|d;d=a;a=g+4|0;S(c|0,d|0,b|0,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){Jh(a);fb=g+32|0;return}a=N()|0;Jh(g+4|0);Q(a|0);p()}function Lja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-48|0;fb=d;e=d+28|0;sg(e,a,c);a=x[d+28>>2];c=d+4|0;ug(c,1,Ze(e),a);x[31609]=0;a=d+16|0;O(218,a|0,c|0);c=x[31609];x[31609]=0;if((c|0)!=1){Be(b,a);tb(a);Kc(e);fb=d+48|0;break a}a=N()|0;Kc(d+28|0);Q(a|0);p()}}function $ra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-48|0;fb=d;e=d+28|0;sg(e,a,c);a=x[d+28>>2];c=d+4|0;ug(c,2,Ze(e),a);x[31609]=0;a=d+16|0;O(218,a|0,c|0);c=x[31609];x[31609]=0;if((c|0)!=1){im(b,a);tb(a);Kc(e);fb=d+48|0;break a}a=N()|0;Kc(d+28|0);Q(a|0);p()}}function h2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=fb-32|0;fb=e;x[e+24>>2]=d;x[e+28>>2]=c;x[31609]=0;c=e+8|0;V(167,c|0,b|0,e+28|0,e+24|0);d=x[31609];x[31609]=0;if((d|0)!=1){d=e+16|0;Ip(d,c);Ff(a,d);me(d);me(c);me(b);fb=e+32|0;return}a=N()|0;me(b);Q(a|0);p()}function eo(a,b){var c=0,d=0,e=0;d=-1;a:{if((a|0)==-1){break a}e=x[b+76>>2]<0;b:{c=x[b+4>>2];c:{if(!c){zt(b);c=x[b+4>>2];if(!c){break c}}if(x[b+44>>2]-8>>>0<c>>>0){break b}}if(e){break a}return-1}c=c-1|0;x[b+4>>2]=c;v[c|0]=a;x[b>>2]=x[b>>2]&-17;d=a&255}return d}function Q$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-48|0;fb=d;e=d+28|0;sg(e,a,c);a=x[d+28>>2];c=d+4|0;ug(c,2,Ze(e),a);x[31609]=0;a=d+16|0;O(218,a|0,c|0);c=x[31609];x[31609]=0;if((c|0)!=1){Ac(b,a);tb(a);Kc(e);fb=d+48|0;break a}a=N()|0;Kc(d+28|0);Q(a|0);p()}}function wl(a){var b=0,c=0;a:{b=x[a+1396>>2];if((b|0)>24){break a}if(!b){x[a+1392>>2]=0}while(1){if(y[a+1376|0]?0:x[a+1384>>2]){break a}c=Rt(a);if((c|0)==-1){break a}b=x[a+1396>>2];x[a+1396>>2]=b+8;x[a+1392>>2]=x[a+1392>>2]+(c<<b);if((b|0)<17){continue}break}}}function vn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=a;c=OC(b);e=fb-16|0;fb=e;a:{if(c>>>0<1073741808){b:{if(fr(c)){Ne(d,c);break b}Oj(e+8|0,sn(c)+1|0);f=x[e+8>>2];yd(d,f);of(d,x[e+12>>2]);Bd(d,c);d=f}yd(Ti(d,b,c)+(c<<2)|0,0);fb=e+16|0;break a}pf();p()}return a|0}function Qha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;x[a+4>>2]=b;x[a>>2]=0;b=mu(a+8|0,d);x[31609]=0;P(961,a+20|0,c|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){x[a+32>>2]=0;x[a+36>>2]=0;v[a+42|0]=0;v[a+40|0]=0;v[a+41|0]=y[a+41|0]&224|25;return a|0}a=N()|0;Eb(b);Q(a|0);p()}function Jx(a,b,c,d,e){var f=0;f=fb-32|0;fb=f;x[f+12>>2]=-1;x[f+16>>2]=0;x[f+4>>2]=0;x[f+8>>2]=0;Fb(f+20|0);x[31609]=0;x[f+4>>2]=x[f+4>>2]&e|d;d=a;a=f+4|0;S(c|0,d|0,b|0,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){Jh(a);fb=f+32|0;return}a=N()|0;Jh(f+4|0);Q(a|0);p()}function tH(a,b,c,d){var e=0;e=fb-16|0;fb=e;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(e+8|0,x[vb(e+4|0,a)>>2]);a:{if(b){x[31609]=0;O(d|0,a|0,b|0);d=x[31609];x[31609]=0;if((d|0)==1){break a}zp(a,b,c)}b=e+8|0;Qd(b);Zi(b);fb=e+16|0;return a}a=N()|0;Zi(e+8|0);Q(a|0);p()}function d4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=fb-16|0;fb=e;b=dq(e+4|0,c,d);c=GI(0,Kb(b),0);x[31609]=0;a=U(1386,a|0,c|0,0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){GI(Kb(a),Kb(b),Cb(x[a+4>>2],y[a+11|0])+1|0);Ub(b);fb=e+16|0;return}a=N()|0;Ub(b);Q(a|0);p()}function VC(a,b,c){var d=0,e=0,f=0,g=0,h=0;e=fb-1024|0;fb=e;d=fb-16|0;fb=d;SC(d+8|0,e);f=x[d+12>>2];lc(d,x[a>>2],x[a+8>>2],x[d+8>>2],x[d+12>>2]);g=x[d+4>>2];if((g|0)==(f|0)){Vb(a,x[d+12>>2])}fb=d+16|0;if((f|0)==(g|0)){h=TC(e,c)>>>0<=b>>>0}fb=e+1024|0;return h}function PZ(a){var b=0,c=0,d=0,e=0;d=y[a+32|0]|y[a+33|0]<<8;e=y[a+38|0]|y[a+39|0]<<8;c=y[a+34|0]|y[a+35|0]<<8;b=c+(y[a+36|0]|y[a+37|0]<<8)|0;a=0;a=b>>>0<c>>>0?1:a;c=b;b=b+e|0;a=(c>>>0>b>>>0?a+1|0:a)<<2|b>>>30;c=d;d=b<<2;b=c+d|0;hb=b>>>0<d>>>0?a+1|0:a;return b}function Oka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=fb-48|0;fb=c;e=c+28|0;sg(e,a,32);a=x[c+28>>2];d=c+4|0;ug(d,1,Ze(e),a);x[31609]=0;a=c+16|0;O(218,a|0,d|0);d=x[31609];x[31609]=0;if((d|0)!=1){Ac(b,a);tb(a);Kc(e);fb=c+48|0;break a}a=N()|0;Kc(c+28|0);Q(a|0);p()}}function a4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=fb-16|0;fb=e;b=Yl(e+4|0,c,d);c=EI(0,Kb(b),0);x[31609]=0;a=U(542,a|0,c|0,0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){EI(Kb(a),Kb(b),Cb(x[a+4>>2],y[a+11|0])+1|0);tb(b);fb=e+16|0;return}a=N()|0;tb(b);Q(a|0);p()}function KB(a,b,c,d){var e=0,f=0,g=0;e=de(a);a:{if(e){f=gc(a);while(1){a=e;e=z[a+16>>1];g=x[a+20>>2];if(Pl(c,d,e,g)){f=a;e=x[a>>2];if(e){continue}break a}if(!Pl(e,g,c,d)){break a}f=a+4|0;e=x[a+4>>2];if(e){continue}break}break a}a=gc(a);f=a}x[b>>2]=a;return f}function I1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-48|0;fb=c;d=-1;e=a;a=c+12|0;a:{if(!_F(e,a)){break a}d=0;if(!ZF(a)){break a}if(b){a=x[b>>2];if(!x[b+4>>2]&a>>>0<$b(y[c+16|0]|y[c+17|0]<<8|(y[c+18|0]<<16|y[c+19|0]<<24))-8>>>0){break a}}d=1}fb=c+48|0;return d|0}function fB(a,b,c,d){var e=0,f=0,g=0;e=de(a);a:{if(e){f=gc(a);while(1){a=e;e=y[a+16|0];g=x[a+20>>2];if(Ao(c,d,e,g)){f=a;e=x[a>>2];if(e){continue}break a}if(!Ao(e,g,c,d)){break a}f=a+4|0;e=x[a+4>>2];if(e){continue}break}break a}a=gc(a);f=a}x[b>>2]=a;return f}function dH(a,b,c,d,e){var f=0,g=0;a:{f=fb-48|0;fb=f;sf(b);g=f+28|0;sg(g,a,d);a=x[f+28>>2];d=f+4|0;ug(d,e,Ze(g),a);x[31609]=0;a=f+16|0;S(599,a|0,c|0,d|0);c=x[31609];x[31609]=0;if((c|0)!=1){zb(b,a);tb(a);Kc(g);fb=f+48|0;break a}a=N()|0;Kc(f+28|0);Q(a|0);p()}}function WM(a){var b=0,c=0,d=0;d=fb-16|0;fb=d;b=a+120|0;au(y[b+20|0]);c=fb-16|0;fb=c;x[c+12>>2]=d+15;a=fb-16|0;fb=a;x[a+12>>2]=1142;x[a+8>>2]=1143;x[a+4>>2]=1144;x[a>>2]=1145;b=ib[x[lq(a,tk(y[b+20|0]))>>2]](c+12|0,b)|0;fb=a+16|0;fb=c+16|0;fb=d+16|0;return b}function L0(a,b,c){var d=0,e=0,f=0,g=0;d=fb-48|0;fb=d;f=d+28|0;sg(f,a,c);a=x[d+28>>2];e=d+4|0;ug(e,3,Ze(f),a);x[31609]=0;g=d+16|0;O(218,g|0,e|0);e=x[31609];x[31609]=0;if((e|0)!=1){Ac(b,g);tb(g);Kc(f);fb=d+48|0;return!c|(a|0)!=0}a=N()|0;Kc(d+28|0);Q(a|0);p()}function ora(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;sf(b);v[c+15|0]=0;a:{if(!ii(a,c+15|0)){break a}f=y[c+15|0];d=1;while(1){if((e&255)==(f|0)){break a}v[c+14|0]=0;if(ii(a,c+14|0)){Qp(b,v[c+14|0]);e=e+1|0;continue}break}d=0}fb=c+16|0;return d|0}function iH(a,b,c){var d=0;d=fb-16|0;fb=d;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);Rd(d+8|0,x[vb(d+4|0,a)>>2]);a:{if(b){x[31609]=0;O(c|0,a|0,b|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}QX(a,b)}b=d+8|0;Qd(b);Zi(b);fb=d+16|0;return a}a=N()|0;Zi(d+8|0);Q(a|0);p()}function aJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;a=AJ(a,c);x[a>>2]=96428;c=nk(Kb(b));x[a+8>>2]=c;a:{if(!c){a=d+4|0;Nm(a,17952,b);x[31609]=0;W(1367,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}b=N()|0;tb(a);Q(b|0);p()}fb=d+16|0;return a|0}p()}function F8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a:{while(1){if((d|0)!=(e|0)){a=-1;if((b|0)==(c|0)){break a}f=x[b>>2];g=x[d>>2];if((f|0)<(g|0)){break a}if((f|0)>(g|0)){return 1}else{d=d+4|0;b=b+4|0;continue}}break}a=(b|0)!=(c|0)}return a|0}function F5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;a=EJ(a,c);x[a>>2]=95232;c=nk(Kb(b));x[a+8>>2]=c;a:{if(!c){a=d+4|0;Nm(a,17890,b);x[31609]=0;W(1367,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}b=N()|0;tb(a);Q(b|0);p()}fb=d+16|0;return a|0}p()}function D5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;a=CJ(a,c);x[a>>2]=95264;c=nk(Kb(b));x[a+8>>2]=c;a:{if(!c){a=d+4|0;Nm(a,18071,b);x[31609]=0;W(1367,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}b=N()|0;tb(a);Q(b|0);p()}fb=d+16|0;return a|0}p()}function $O(a){var b=0,c=0;b=x[a+24>>2];c=z[b+1074448>>1];if(c>>>0>=Ij(Xb(x[b+484360>>2],y[b+484376|0]))>>>0){return z[x[a+24>>2]+1074446>>1]}a=x[a+24>>2];b=z[bc(x[Xb(x[a+484360>>2],y[a+484376|0])>>2],c)>>1];return Cn(x[a+484344>>2],x[a+484348>>2],b)?b:-1}function vla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=b;d=fb-16|0;fb=d;b=If(a,c);ae(d,x[a+36>>2]);a:{b:{if(!b){Qc(d,a+32|0,5);c=-1;if(!Gb(x[x[d>>2]>>2],x[d+4>>2])){break b}break a}c=x[b+16>>2]}WB(x[a+36>>2],e,c);f=1;g=b}ef(a,g);fb=d+16|0;return f|0}function zt(a){var b=0,c=0;b=x[a+72>>2];x[a+72>>2]=b-1|b;if(x[a+20>>2]!=x[a+28>>2]){ib[x[a+36>>2]](a,0,0)|0}x[a+28>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;b=x[a>>2];if(b&4){x[a>>2]=b|32;return-1}c=x[a+44>>2]+x[a+48>>2]|0;x[a+8>>2]=c;x[a+4>>2]=c;return b<<27>>31}function JH(a,b,c,d){var e=0,f=0,g=0,h=0;a:{f=fb-16|0;fb=f;e=f+4|0;x[e+4>>2]=1;g=e,h=Ec(d),x[g+8>>2]=h;d=x[e+8>>2];x[31609]=0;P(c|0,d|0,b|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){b=a;a=Sn(e);Rn(b,nc(a),a);um(e);fb=f+16|0;break a}a=N()|0;um(e);Q(a|0);p()}}function J$(a,b,c){var d=0,e=0;d=fb-16|0;fb=d;e=0;a:{if(!a){break a}b:{c:{if(a>>>0<=15){if(b>>>0<2|c){break c}break b}if(b>>>0>1){break b}}e=a|-16;break a}v[d+15|0]=1;v[d+14|0]=(a>>>0)/((b-1&255)>>>0);e=y[cf(d+15|0,d+14|0)|0]}a=e;fb=d+16|0;return a&255}function qf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=a;e=fb-16|0;fb=e;a:{if(b>>>0<2147483632){b:{if(Ok(b)){Ne(d,b);break b}qg(e+8|0,Fh(b)+1|0);f=x[e+8>>2];yd(d,f);of(d,x[e+12>>2]);Bd(d,b);d=f}hd(am(d,b,c)+b|0,0);fb=e+16|0;break a}pf();p()}return a|0}function kP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=Pj(b,c);d=Mc(a);if(e>>>0>d>>>0){f=d;g=e-d|0;d=Cb(x[a+4>>2],y[a+11|0]);bn(a,f,g,d,0,d,0)}d=Kb(a);while(1){if((b|0)!=(c|0)){hd(d,y[b|0]);b=b+1|0;d=d+1|0;continue}break}hd(d,0);lg(a,e);return a|0}function jD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;LY(a,b);dd(a,$b(y[b+8|0]|y[b+9|0]<<8|(y[b+10|0]<<16|y[b+11|0]<<24))+504|0);JY(a,d);a:{b=$b(y[b+32|0]|y[b+33|0]<<8|(y[b+34|0]<<16|y[b+35|0]<<24));if(!b){break a}if(!dd(a,b)){break a}lD(a,c);return}Rb(c,0,80)}function g0(a){var b=0,c=0,d=0,e=0,f=0,g=0;b=fb-16|0;fb=b;f=xb(a,31),g=0,v[f|0]=g;c=Hi(a,Ro(a),0);v[b+15|0]=0;c=Pj(a,c);Rm(c+a|0,Ro(a),b+15|0);while(1){if((c|0)!=(d|0)){e=xb(a,d);if((y[e|0]-127&255)>>>0<=160){v[e|0]=32}d=d+1|0;continue}break}fb=b+16|0}function fN(a){var b=0,c=0,d=0,e=0;if(!y[a+12|0]){b=fb-16|0;fb=b;d=vb(b+12|0,x[x[a+8>>2]>>2]);e=x[vb(b+8|0,x[x[a+4>>2]>>2])>>2];c=fb-16|0;fb=c;a=x[d>>2];x[c+12>>2]=a;while(1){if(Fd(a,e)){Qj(Cz(a));a=x[Wq(c+12|0)>>2];continue}break}fb=c+16|0;fb=b+16|0}}function fM(a){var b=0,c=0,d=0,e=0;if(!y[a+12|0]){b=fb-16|0;fb=b;d=vb(b+12|0,x[x[a+8>>2]>>2]);e=x[vb(b+8|0,x[x[a+4>>2]>>2])>>2];c=fb-16|0;fb=c;a=x[d>>2];x[c+12>>2]=a;while(1){if(Fd(a,e)){Eb(Op(a));a=x[lk(c+12|0)>>2];continue}break}fb=c+16|0;fb=b+16|0}}function b4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=fb-32|0;fb=a;b=Yl(a+20|0,b,c);x[31609]=0;c=U(1387,a+8|0,d|0,e|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){d=ji(Kb(b),Kb(c));tb(c);tb(b);fb=a+32|0;return((d|0)<0?-1:(d|0)!=0)|0}a=N()|0;tb(b);Q(a|0);p()}function Uaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=x[b>>2];e=x[b+8>>2];f=x[b+4>>2];a=0;a:while(1){if((a|0)!=(f|0)){g=(a<<2)+d|0;b=0;while(1)if((b|0)==(e|0)){a=a+1|0;continue a}else{c=x[g>>2]+(b<<3)|0;x[c>>2]=0;x[c+4>>2]=0;b=b+1|0;continue}}break}}function RG(){var a=0,b=0,c=0;b=fb-16|0;fb=b;a=Dc(b+4|0,15059);a:{if(!_c(x[a+4>>2],y[a+11|0])){break a}c=1;if((Tg(a,14690)|0)!=-1){break a}if((Tg(a,16834)|0)!=-1){break a}if((Tg(a,13834)|0)!=-1){break a}c=(Tg(a,13877)|0)!=-1}tb(a);fb=b+16|0;return c|0}function Oga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a=Li(a,b,c,d);x[a>>2]=44912;b=a+4208|0;e=yb(b,0),f=1017370378,x[e>>2]=f;e=yb(b,1),f=0,x[e>>2]=f;x[31609]=0;O(941,a+44|0,2);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}b=N()|0;_f(a);Q(b|0);p()}function Zf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=fb-16|0;fb=e;Lg(a+12|0,d);a:{if(!b){d=0;b=0;break a}Oj(e+8|0,b);d=x[e+12>>2];b=x[e+8>>2]}x[a>>2]=b;c=b+(c<<2)|0;x[a+8>>2]=c;x[a+4>>2]=c;f=nc(a),g=b+(d<<2)|0,x[f>>2]=g;fb=e+16|0;return a|0}function Dm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=Sd(b,c);d=tn(a);if(e>>>0>d>>>0){f=d;g=e-d|0;d=Cb(x[a+4>>2],y[a+11|0]);oC(a,f,g,d,0,d)}d=Kb(a);while(1){if((b|0)!=(c|0)){yd(d,x[b>>2]);b=b+4|0;d=d+4|0;continue}break}yd(d,0);lg(a,e);return a|0}function o5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;a=xJ(a,0);x[a>>2]=101336;c=Fb(a+12|0);d=Fb(a+24|0);e=Fb(a+36|0);f=Fb(a+48|0);b=Kb(b);x[31609]=0;O(1370,a|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}a=N()|0;tb(f);tb(e);tb(d);tb(c);Q(a|0);p()}function m5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;a=wJ(a,0);x[a>>2]=101440;c=Fb(a+12|0);d=Fb(a+24|0);e=Fb(a+36|0);f=Fb(a+48|0);b=Kb(b);x[31609]=0;O(1371,a|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}a=N()|0;tb(f);tb(e);tb(d);tb(c);Q(a|0);p()}function j5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;a=vJ(a,0);x[a>>2]=101544;c=Fb(a+16|0);d=Fb(a+28|0);e=Fb(a+40|0);f=Fb(a+52|0);b=Kb(b);x[31609]=0;O(1372,a|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}a=N()|0;Ub(f);Ub(e);Ub(d);tb(c);Q(a|0);p()}function h5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;a=uJ(a,0);x[a>>2]=101648;c=Fb(a+16|0);d=Fb(a+28|0);e=Fb(a+40|0);f=Fb(a+52|0);b=Kb(b);x[31609]=0;O(1373,a|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}a=N()|0;Ub(f);Ub(e);Ub(d);tb(c);Q(a|0);p()}function BY(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;e=fb-32|0;fb=e;fd(e+24|0,b,c);b=fb-16|0;fb=b;f=x[e+28>>2];g=x[e+24>>2];c=f-g|0;h=b,i=AY(d,g,c>>2)+c|0,x[h+12>>2]=i;rc(e+16|0,f,b+12|0);fb=b+16|0;b=x[e+16>>2];x[e+12>>2]=x[e+20>>2];rc(a,b,e+12|0);fb=e+32|0}function uK(a,b){var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;x[b>>2]=0;v[c+15|0]=0;ii(a,c+15|0);d=y[c+15|0];e=d>>>2|0;f=d&3;d=0;while(1){x[b>>2]=e;if((d|0)==(f|0)){fb=c+16|0}else{v[c+15|0]=0;ii(a,c+15|0);d=d+1|0;e=x[b>>2]|y[c+15|0]<<(d<<3)-2;continue}break}}function fQ(a,b,c){var d=0,e=0;if(E(F(a))<E(0x8000000000000000)){e=~~a>>>0}else{e=0}d=e>>31;d=(e^d)-d|0;while(1){if(!((d|0)<0|(b|0)<=0)){b=b-1|0;d=d<<1;continue}break}b=(d>>>31|0)+b<<31-c|(d&2147483647)>>>c;return E(((e|0)<0?b^-1|-2147483648:b)|0)}function uL(a,b){var c=0,d=0,e=0;o(+a);d=j(1)|0;e=j(0)|0;c=d>>>20&2047;if((c|0)!=2047){if(!c){if(a==0){c=0}else{a=uL(a*0x10000000000000000,b);c=x[b>>2]+-64|0}x[b>>2]=c;return a}x[b>>2]=c-1022;l(0,e|0);l(1,d&-2146435073|1071644672);a=+n()}return a}function iT(a,b,c,d){var e=0;e=-2147483648;e=!c|!(v[c+15|0]&1)?e:x[c+8>>2];a:{b:{if(!(!d|!(y[d+34|0]&32))){e=z[d+28>>1];break b}if((e|0)==-2147483648){break a}}Rq(b,e,a);if(!Ob(a+1074312|0,10)|y[a+480209|0]&64){break a}x[b+88>>2]=x[b+88>>2]&-257}}function $N(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;f=d,g=jO(c),x[f+8>>2]=g;c=d+8|0;e=x[re(d+12|0,c)>>2];x[31609]=0;b=+pa(1114,a|0,+b,e|0);a=x[31609];x[31609]=0;if((a|0)!=1){Wc(c);fb=d+16|0;return+b}a=N()|0;Wc(d+8|0);Q(a|0);p()}function ura(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;while(1){a:{c=x[a>>2];if(oc(c,x[a+4>>2])>>>0>d>>>0){f=e+4|0;wm(f,x[yb(c,d)>>2]+40|0);c=hr(f,b);tb(f);if(!c){break a}g=x[yb(x[a>>2],d)>>2]}fb=e+16|0;return g|0}d=d+1|0;continue}}function lH(a,b,c,d){var e=0,f=0;a:{e=fb-48|0;fb=e;f=e+28|0;sg(f,a,d);a=x[e+28>>2];d=e+4|0;ug(d,c,Ze(f),a);x[31609]=0;a=e+16|0;O(218,a|0,d|0);c=x[31609];x[31609]=0;if((c|0)!=1){Be(b,a);tb(a);Kc(f);fb=e+48|0;break a}a=N()|0;Kc(e+28|0);Q(a|0);p()}}function K7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=fb-32|0;fb=g;x[g+24>>2]=37;x[g+28>>2]=83;x[g+16>>2]=77;x[g+20>>2]=58;x[g+8>>2]=58;x[g+12>>2]=37;x[g>>2]=37;x[g+4>>2]=72;h=b;b=g+32|0;a=rk(a,h,c,d,e,f,g,b);fb=b;return a|0}function oba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=fb-32|0;fb=d;e=d+4|0;Hx(e,c);c=d+16|0;x[c>>2]=b;Uc(c+4|0,e);x[31609]=0;O(1125,a+4|0,c|0);a=x[31609];x[31609]=0;if((a|0)!=1){Qj(c);tb(e);fb=d+32|0;return}a=N()|0;Qj(d+16|0);tb(d+4|0);Q(a|0);p()}function nja(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=fb-16|0;fb=e;c=If(a,c);ae(e,x[a+36>>2]);a:{b:{if(!c){Qc(e,a+32|0,5);f=-1;if(!Gb(x[x[e>>2]>>2],x[e+4>>2])){break b}break a}f=x[c+16>>2]}ib[d|0](x[a+36>>2],b,f);g=c}ef(a,g);fb=e+16|0}function h0(a,b,c){var d=0,e=0;d=fb-48|0;fb=d;sf(b);e=d+28|0;sg(e,a,c);a=x[d+28>>2];c=d+4|0;ug(c,2,Ze(e),a);x[31609]=0;a=d+16|0;O(218,a|0,c|0);c=x[31609];x[31609]=0;if((c|0)!=1){zb(b,a);tb(a);Kc(e);fb=d+48|0;return}a=N()|0;Kc(d+28|0);Q(a|0);p()}function Q7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=fb-16|0;fb=g;v[g+8|0]=37;v[g+9|0]=72;v[g+10|0]=58;v[g+11|0]=37;v[g+12|0]=77;v[g+13|0]=58;v[g+14|0]=37;v[g+15|0]=83;h=a;a=g+16|0;b=sk(h,b,c,d,e,f,g+8|0,a);fb=a;return b|0}function vT(a,b){var c=0,d=0;a:{if(!(v[a+851|0]&1)){break a}c=x[a+104>>2];if(!c){break a}d=x[c>>2];if(!d){break a}x[a+76>>2]=d;x[a>>2]=0;x[a+4>>2]=d-1;c=x[a+88>>2];if(!b){x[a+88>>2]=c&-135|128;return}x[a+84>>2]=d;x[a+80>>2]=0;x[a+88>>2]=c|134}}function _V(a,b){a=a|0;b=b|0;var c=0,d=0;d=fb-16|0;fb=d;c=d+4|0;x[c>>2]=a;a=x[a+4>>2];x[c+4>>2]=a;x[c+8>>2]=a+D(b,872);b=x[c+4>>2];a=x[c+8>>2];while(1){if((a|0)==(b|0)){kc(c);fb=d+16|0}else{ZV(Rb(b,0,872));b=b+872|0;x[c+4>>2]=b;continue}break}}function UC(a,b,c){var d=0;d=fb-16|0;fb=d;w[d+12>>1]=c;w[d+14>>1]=b;b=wb(x[a>>2]);c=wb(x[a+4>>2]);a=fb-16|0;fb=a;x[a+12>>2]=b;while(1){if(Ib(b,c)){if(z[b>>1]==z[d+14>>1]){w[b>>1]=z[d+12>>1]}b=x[ge(a+12|0)>>2];continue}break}fb=a+16|0;fb=d+16|0}function zl(a,b,c){var d=0,e=0,f=0,g=0,h=0;while(1){a:{if((a|0)!=(b|0)){e=x[c>>2];g=x[c+4>>2];d=fb-16|0;fb=d;f=qc(d+8|0,x[a>>2]);h=x[f+4>>2];x[d>>2]=x[f>>2];x[d+4>>2]=h;e=Ic(e,g,d);fb=d+16|0;if(!e){break a}}else{a=b}return a}a=a+8|0;continue}}function tja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;d=-1;e=a;a=c+8|0;a:{if(!LG(e,a)){break a}d=0;if(!vR(a)){break a}if(b){if(x[b>>2]!=(y[c+16|0]|y[c+17|0]<<8|(y[c+18|0]<<16|y[c+19|0]<<24))|x[b+4>>2]){break a}}d=1}fb=c+32|0;return d|0}function kx(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;v[a+6|0]=0;v[a+7|0]=0;v[a+16|0]=0;v[a+17|0]=0;v[a+18|0]=0;v[a+19|0]=0;v[a+8|0]=0;v[a+9|0]=0;v[a+10|0]=0;v[a+11|0]=0;v[a+12|0]=0;v[a+13|0]=0;v[a+14|0]=0;v[a+15|0]=0}function cr(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;c=fb-16|0;fb=c;d=vb(c+12|0,x[a+4>>2]);e=vb(c+8|0,x[a>>2]);f=vb(c+4|0,x[b+4>>2]);g=b,h=UW(x[d>>2],x[e>>2],x[f>>2]),x[g+4>>2]=h;Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=c+16|0}function Xr(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;c=fb-16|0;fb=c;d=vb(c+12|0,x[a+4>>2]);e=vb(c+8|0,x[a>>2]);f=vb(c+4|0,x[b+4>>2]);g=b,h=NF(x[d>>2],x[e>>2],x[f>>2]),x[g+4>>2]=h;Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=c+16|0}function Tca(a,b){a=a|0;b=b|0;var c=0;a:{if((a|0)==(b|0)){break a}c=x[a+4>>2];if(c){Db(c);x[a+4>>2]=0}if(ib[x[x[b>>2]+8>>2]](b)|0){b=ib[x[x[b>>2]+8>>2]](b)|0}else{b=22292}c=Gd(Df(b)+1|0);x[a+4>>2]=c;if(!c){break a}zc(c,b,Df(b)+1|0)}return a|0}function Sr(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;c=fb-16|0;fb=c;d=vb(c+12|0,x[a+4>>2]);e=vb(c+8|0,x[a>>2]);f=vb(c+4|0,x[b+4>>2]);g=b,h=OF(x[d>>2],x[e>>2],x[f>>2]),x[g+4>>2]=h;Tb(a,b+4|0);Tb(a+4|0,b+8|0);Tb(Ab(a),nc(b));x[b>>2]=x[b+4>>2];fb=c+16|0}function esa(a){a=a|0;var b=0,c=0,d=0,e=0;b=fb-32|0;fb=b;v[b+30|0]=0;w[b+28>>1]=0;c=b+28|0;d=Zb(b+8|0,c,3);lc(b+20|0,x[a>>2],x[a+8>>2],x[d>>2],x[d+4>>2]);a:{if(x[b+24>>2]!=3){break a}if(jd(c,14783,3)){break a}Vb(a,3);e=1}fb=b+32|0;return e|0}function doa(a){a=a|0;var b=0,c=0,d=0,e=0;b=fb-32|0;fb=b;w[b+28>>1]=0;x[b+24>>2]=0;c=b+24|0;d=Zb(b+8|0,c,6);lc(b+16|0,x[a>>2],x[a+8>>2],x[d>>2],x[d+4>>2]);a:{if(x[b+20>>2]!=6){break a}if(jd(c,3856,6)){break a}Vb(a,6);e=1}fb=b+32|0;return e|0}function Wp(a,b){var c=0,d=0,e=0,f=0;c=a*a;d=c*.5;e=1-d;f=1-e-d;d=c*c;return e+(f+(c*(c*(c*(c*2480158728947673e-20+-.001388888888887411)+.0416666666666666)+d*d*(c*(c*-11359647557788195e-27+2.087572321298175e-9)+-2.7557314351390663e-7))-a*b))}function Sb(){var a=0;a=x[31483];x[31609]=0;X(a|0);a=x[31609];x[31609]=0;a:{if((a|0)!=1){x[31609]=0;X(1388);a=x[31609];x[31609]=0;if((a|0)!=1){break a}}Y(T(0)|0)|0;x[31609]=0;X(1388);a=x[31609];x[31609]=0;if((a|0)!=1){break a}T(0)|0;Sb()}p()}function zS(a,b){a=vS(a);vS(a+368680|0);if(b){uS(a,1);return}if(!y[495312]){zS(126608,1);v[495312]=1}yu(257720,323256,a+131112|0);yu(323256,388792,a+196648|0);yu(388792,454328,a+262184|0);yu(126632,257720,a+24|0);zc(a+327720|0,454328,40960)}function wT(a,b){var c=0,d=0;d=fb-16|0;fb=d;c=x[a+104>>2];a:{if(!c){break a}c=x[c>>2];if(!c){break a}x[a+76>>2]=c;x[a+88>>2]=x[a+88>>2]&-131|128;x[d+12>>2]=b<<8;x[d+8>>2]=c-1;b=c+(x[Hb(d+12|0,d+8|0)>>2]^-1)|0;x[a>>2]=0;x[a+4>>2]=b}fb=d+16|0}function qn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=fb-16|0;fb=e;Lg(a+12|0,d);a:{if(!b){d=0;b=0;break a}qg(e+8|0,b);d=x[e+12>>2];b=x[e+8>>2]}x[a>>2]=b;c=b+c|0;x[a+8>>2]=c;x[a+4>>2]=c;f=nc(a),g=b+d|0,x[f>>2]=g;fb=e+16|0;return a|0}function rba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=fb-16|0;fb=e;d=jv(e+4|0,a,d);f=x[d+4>>2];x[31609]=0;a=ba(1123,Ab(a)|0,b|0,c|0,f|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){x[d+4>>2]=a;kc(d);fb=e+16|0;return}a=N()|0;kc(d);Q(a|0);p()}function oh(a,b){var c=0,d=0,e=0;d=y[a+11|0];c=Cb(x[a+4>>2],d);a:{if((c|0)!=(Cb(x[b+4>>2],y[b+11|0])|0)){break a}a=Kb(a);b=Kb(b);if(!vd(d)){while(1){e=!c;if(!c|y[a|0]!=y[b|0]){break a}b=b+1|0;a=a+1|0;c=c-1|0;continue}}e=!nt(a,b,c)}return e}function jW(a){var b=0,c=0;a=a*4294967296;if(F(a)<0x8000000000000000){c=~~a>>>0;if(F(a)>=1){b=~~(a>0?H(J(a*2.3283064365386963e-10),4294967295):K((a-+(~~a>>>0>>>0))*2.3283064365386963e-10))>>>0}else{b=0}hb=b;return c}hb=-2147483648;return 0}function ve(a,b){var c=0,d=0;c=x[a+4>>2];d=c+b|0;x[a+4>>2]=d;if(x[a+8>>2]>=(d|0)){d=x[a>>2]+(c>>3)|0;a=c&7;c=y[d|0]&255>>>a;a=a+b|0;b=0;while(1){if((a|0)>=9){a=a-8|0;b=c<<a|b;c=y[d+1|0];d=d+1|0;continue}break}a=c>>>8-a|b}else{a=0}return a}function nH(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;x[e+12>>2]=c;c=e+12|0;xc(c,d);xc(c,65535);d=z[e+12>>1];vg(a,d);c=0;while(1){if((c|0)==(d|0)){fb=e+16|0}else{f=y[b+c|0];g=Qr(x[a>>2],x[a+4>>2],c),h=f,w[g>>1]=h;c=c+1|0;continue}break}}function Y9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=fb-16|0;fb=e;d=vv(e+4|0,a,d);f=x[d+4>>2];x[31609]=0;a=ba(1207,Ab(a)|0,b|0,c|0,f|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){x[d+4>>2]=a;kc(d);fb=e+16|0;return}a=N()|0;kc(d);Q(a|0);p()}function NT(a,b){var c=0;c=y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24);v[a|0]=c;v[a+1|0]=c>>>8;v[a+2|0]=c>>>16;v[a+3|0]=c>>>24;b=y[b+3|0]|y[b+4|0]<<8|(y[b+5|0]<<16|y[b+6|0]<<24);v[a+3|0]=b;v[a+4|0]=b>>>8;v[a+5|0]=b>>>16;v[a+6|0]=b>>>24}function N0(a,b,c){var d=0,e=0;d=fb-48|0;fb=d;e=d+28|0;sg(e,a,c);a=x[d+28>>2];c=d+4|0;ug(c,3,Ze(e),a);x[31609]=0;a=d+16|0;O(218,a|0,c|0);c=x[31609];x[31609]=0;if((c|0)!=1){im(b,a);tb(a);Kc(e);fb=d+48|0;return}a=N()|0;Kc(d+28|0);Q(a|0);p()}function MW(a){var b=0,c=0;a:{if(y[a+29|0]!=2){break a}b=y[a+28|0];if((b|0)!=26&(b|0)!=2|y[a+30|0]!=2){break a}b=y[a+31|0];if(b>>>0>21|!(1<<b&3146753)|y[a+33|0]>64){break a}b=y[a+34|0];if(b>>>0>=65&(b|0)!=88){break a}c=KW(a+20|0)}return c}function nx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=fb-16|0;fb=e;lf(e+8|0,b,c);x[31609]=0;Ma(165,a|0,x[e+8>>2],x[e+12>>2]);b=x[31609];x[31609]=0;if((b|0)!=1){x[a+8>>2]=0;Ff(a+12|0,d);me(d);fb=e+16|0;return a|0}a=N()|0;me(d);Q(a|0);p()}function ZC(a,b,c,d){var e=0,f=0;e=fb-32|0;fb=e;f=x[b+12>>2];lf(e+16|0,c,d);c=x[x[b>>2]+28>>2];d=x[e+20>>2];x[e+8>>2]=x[e+16>>2];x[e+12>>2]=d;ib[c|0](e+24|0,b,f,e+8|0);lf(a,x[e+24>>2],x[e+28>>2]);x[b+12>>2]=x[b+12>>2]+x[a+4>>2];fb=e+32|0}function WB(a,b,c){var d=0;a:{switch(c+1|0){case 0:case 3:QU(a,b);return;default:break a}}d=fb-32|0;fb=d;x[d+28>>2]=c;w[d+26>>1]=0;x[d+12>>2]=2;c=d+16|0;rz(c,a,d+26|0,x[Hb(d+28|0,d+12|0)>>2]);bj(c,z[d+26>>1]);w[b>>1]=z[d+16>>1];fb=d+32|0}function By(a,b){var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;w[b>>1]=0;v[c+15|0]=0;ii(a,c+15|0);d=y[c+15|0];e=d>>>1|0;f=d&1;d=0;while(1){w[b>>1]=e;if(d>>>0>=f>>>0){fb=c+16|0}else{v[c+15|0]=0;ii(a,c+15|0);e=z[b>>1]|y[c+15|0]<<7;d=1;continue}break}}function sU(a){var b=0,c=0,d=0,e=0;c=fb-16|0;fb=c;b=x[a>>2];e=Ek(b,x[a+4>>2]);b=wb(b);x[c+12>>2]=b;d=+(e>>>0);a=wb(x[a+4>>2]);while(1){if(Ib(b,a)){C[b>>3]=C[b>>3]/d;C[b+8>>3]=C[b+8>>3]/d;b=x[Uo(c+12|0)>>2];continue}else{fb=c+16|0}break}}function pA(a,b){var c=0,d=0,e=0,f=0;c=a&16711680;d=c>>>8|0;e=c<<24;c=a&-16777216;f=c>>>24|0;c=e|c<<8;e=d|f|(a<<24|(a&65280)<<8);d=0;hb=e|(d|d);return((b&255)<<24|a>>>8)&-16777216|((b&16777215)<<8|a>>>24)&16711680|(b>>>8&65280|b>>>24)|c}function eT(a,b){var c=0,d=0;a:{if(!(y[a+89|0]&16)){break a}c=x[a+656>>2];if(!c){break a}c=x[c>>2];b:{if(c){d=a;a=x[a+696>>2]-(c<<1)|0;a=(a|0)>0?a:0;x[d+696>>2]=a;a=(D(a,x[b>>2])|0)/65536|0;break b}if(x[a+696>>2]){break a}a=0}x[b>>2]=a}}function G0(a){var b=0,c=0,d=0,e=0;c=y[a+2|0];b=c+(y[a+5|0]|y[a+6|0]<<8)|0;c=(b>>>0<c>>>0?1:d)<<1|b>>>31;d=b<<1;b=c;a=y[a+3|0]|y[a+4|0]<<8;c=a>>>30|0;e=d;d=a<<2;e=e+d|0;a=b+c|0;a=d>>>0>e>>>0?a+1|0:a;b=e+47|0;hb=b>>>0<47?a+1|0:a;return b}function qv(a){var b=0;a:{if(y[a+4|0]|(y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=1414687062){break a}if(Bb(y[a+6|0]|y[a+7|0]<<8)>>>0>1){break a}if(Bb(y[a+12|0]|y[a+13|0]<<8)){break a}b=(Bb(y[a+16|0]|y[a+17|0]<<8)|0)==20}return b}function bua(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+20|0;Fr(e,c);vj(d+12|0,e);x[31609]=0;V(301,a|0,b|0,x[d+12>>2],x[d+16>>2]);a=x[31609];x[31609]=0;if((a|0)!=1){Eb(e);fb=d+32|0;break a}a=N()|0;Eb(d+20|0);Q(a|0);p()}}function Xia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=b;d=fb-16|0;fb=d;b=If(a,c);ae(d,x[a+36>>2]);a:{b:{if(!b){Qc(d,a+32|0,5);c=-1;if(!Gb(x[x[d>>2]>>2],x[d+4>>2])){break b}break a}c=x[b+16>>2]}WB(x[a+36>>2],e,c);f=b}ef(a,f);fb=d+16|0}function Opa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+20|0;br(e,c);vj(d+12|0,e);x[31609]=0;V(301,a|0,b|0,x[d+12>>2],x[d+16>>2]);a=x[31609];x[31609]=0;if((a|0)!=1){Eb(e);fb=d+32|0;break a}a=N()|0;Eb(d+20|0);Q(a|0);p()}}function Lta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;ex(c+8|0,b);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;if((d|0)!=(e|0)){v[b+2|0]=0;v[b|0]=0;v[b+1|0]=0}}function Ci(a,b,c){var d=0,e=0,f=0,g=0;x[a+112>>2]=b;x[a+116>>2]=c;e=x[a+4>>2];d=x[a+44>>2]-e|0;x[a+120>>2]=d;x[a+124>>2]=d>>31;d=a;a=x[a+8>>2];f=a-e|0;g=f>>31;if(!(!(b|c)|((c|0)>=(g|0)&b>>>0>=f>>>0|(c|0)>(g|0)))){a=b+e|0}x[d+104>>2]=a}function Rra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+20|0;Wv(e,c);vj(d+12|0,e);x[31609]=0;V(92,a|0,b|0,x[d+12>>2],x[d+16>>2]);a=x[31609];x[31609]=0;if((a|0)!=1){Eb(e);fb=d+32|0;break a}a=N()|0;Eb(d+20|0);Q(a|0);p()}}function Mra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+20|0;Np(e,c);vj(d+12|0,e);x[31609]=0;V(92,a|0,b|0,x[d+12>>2],x[d+16>>2]);a=x[31609];x[31609]=0;if((a|0)!=1){Eb(e);fb=d+32|0;break a}a=N()|0;Eb(d+20|0);Q(a|0);p()}}function Hoa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+20|0;YZ(e,c);vj(d+12|0,e);x[31609]=0;V(92,a|0,b|0,x[d+12>>2],x[d+16>>2]);a=x[31609];x[31609]=0;if((a|0)!=1){Eb(e);fb=d+32|0;break a}a=N()|0;Eb(d+20|0);Q(a|0);p()}}function CE(a,b,c){var d=0,e=0;d=(a&65535)>>>D(c,3)|0;a=y[b+12|0]&-4|d>>>2&1;e=a|d<<1&2;a:{b:{if(d&2){a=e;break b}v[b+12|0]=e&251;if(!(d&1)|!(d>>>9-(c<<1)&1)){break a}c=y[b+13|0]|y[b+14|0]<<8;v[b+15|0]=c;v[b+16|0]=c>>>8}v[b+12|0]=a|4}}function uV(a){var b=0,c=0,d=0;d=Ro(a);while(1){if((a|0)!=(d|0)){b=y[a|0];a:{b:{if((b-97&255)>>>0<=5){c=b-32|0;break b}if(!(b-88>>>0<2|b-120>>>0<2)){c=99;if((b|0)==75|(b|0)==107){break b}break a}c=122}v[a|0]=c}a=a+1|0;continue}break}}function f$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+20|0;HE(e,c);vj(d+12|0,e);x[31609]=0;V(92,a|0,b|0,x[d+12>>2],x[d+16>>2]);a=x[31609];x[31609]=0;if((a|0)!=1){Eb(e);fb=d+32|0;break a}a=N()|0;Eb(d+20|0);Q(a|0);p()}}function NG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+20|0;$n(e,c);vj(d+12|0,e);x[31609]=0;V(92,a|0,b|0,x[d+12>>2],x[d+16>>2]);a=x[31609];x[31609]=0;if((a|0)!=1){Eb(e);fb=d+32|0;break a}a=N()|0;Eb(d+20|0);Q(a|0);p()}}function $E(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=fb-32|0;fb=d;e=d+20|0;Bw(e,c);vj(d+12|0,e);x[31609]=0;V(92,a|0,b|0,x[d+12>>2],x[d+16>>2]);a=x[31609];x[31609]=0;if((a|0)!=1){Eb(e);fb=d+32|0;break a}a=N()|0;Eb(d+20|0);Q(a|0);p()}}function sg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Nb(a+8|0);x[31609]=0;S(169,a|0,b|0,c|0);c=x[31609];x[31609]=0;a:{if((c|0)!=1){a=x[a>>2];x[31609]=0;P(183,b|0,a|0)|0;a=x[31609];x[31609]=0;if((a|0)!=1){break a}}a=N()|0;ec(d);Q(a|0);p()}}function asa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;pD(c+8|0,b);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){Rb(b,0,4896)}return a|0}function ET(a,b,c){var d=0;d=x[b+48>>2]+1|0;x[b+52>>2]=d;a:{if(A[Wb(x[a+484344>>2],z[b+70>>1])+12>>2]>d>>>0){break a}if(!c){w[b+74>>1]=z[b+72>>1]+1}x[b+52>>2]=0;if(!Ob(a+1074312|0,63)){break a}a=x[b+56>>2];x[b+56>>2]=0;x[b+52>>2]=a}}function tZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=tn(a);e=Cb(x[a+4>>2],y[a+11|0]);a:{if(d-e>>>0>=c>>>0){if(!c){break a}d=Kb(a);Ti(d+(e<<2)|0,b,c);b=c+e|0;lg(a,b);yd(d+(b<<2)|0,0);return a|0}rI(a,d,(c-d|0)+e|0,e,e,0,c,b)}return a|0}function Xf(a,b,c){var d=0;a:{if(A[b+8>>2]<c>>>0){x[31609]=0;V(1164,17433,9126,435,6381);a=x[31609];x[31609]=0;if((a|0)==1){break a}p()}d=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=d;x[a+8>>2]=x[b+8>>2];x[a+12>>2]=c;return}T(0)|0;Sb();p()}function X8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{if(!y[a+44|0]){c=(c|0)>0?c:0;while(1){if((c|0)==(d|0)){break a}if((ib[x[x[a>>2]+52>>2]](a,x[b>>2])|0)==-1){return d|0}else{b=b+4|0;d=d+1|0;continue}}}c=fm(b,4,c,x[a+32>>2])}return c|0}function rC(a,b){var c=0,d=0,e=0,f=0;w[a+24>>1]=0;x[a+20>>2]=0;x[a>>2]=0;x[a+4>>2]=0;c=3546895/+(b>>>0);d=c*.25;a:{if(F(d)<2147483648){b=~~d;break a}b=-2147483648}x[a+16>>2]=b;e=a,f=jW(c-+(b<<2)),x[e+8>>2]=f;x[a+12>>2]=hb;return a}function gB(a,b,c){var d=0,e=0;d=de(a);a:{if(d){e=gc(a);while(1){a=d;d=y[a+16|0];if(Bo(c,d)){e=a;d=x[a>>2];if(d){continue}break a}if(!Bo(d,c)){break a}e=a+4|0;d=x[a+4>>2];if(d){continue}break}break a}a=gc(a);e=a}x[b>>2]=a;return e}function $qa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;nD(c+8|0,b);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){Rb(b,0,33)}return a|0}function l1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;Cw(c+8|0,b);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){Rb(b,0,65)}return a|0}function Vaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=x[b>>2];d=x[b+8>>2];e=x[b+4>>2];a=0;a:while(1){if((a|0)!=(e|0)){f=(a<<2)+c|0;b=0;while(1)if((b|0)==(d|0)){a=a+1|0;continue a}else{x[x[f>>2]+(b<<2)>>2]=0;b=b+1|0;continue}}break}}function Aua(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;d=Mb(x[a>>2],x[a+8>>2],120);a:{if(!d){a=0;while(1){if((a|0)!=120){dh(a+b|0);a=a+1|0;continue}break}break a}cc(c+8|0,b,120);sd(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0;return d|0}function dR(a,b,c){var d=0,e=0,f=0,g=0;while(1){if((b|0)!=(c|0)){d=x[a>>2];e=x[a+4>>2];f=e>>>8|0;g=(e&255)<<24|d>>>8;d=(((y[b|0]^d)&255)<<3)+22328|0;e=x[d>>2];d=x[d+4>>2]^f;x[a>>2]=e^g;x[a+4>>2]=d;b=b+1|0;continue}break}return a}function Mi(a){var b=0,c=0,d=0,e=0;b=Zd(a);c=b&63;e=b<<24>>24;a:{if(!(b&64)){break a}b=6;while(1){d=Zd(a);c=(d&127)<<b|c;if(d<<24>>24>=0){break a}d=b>>>0<25;b=b+7|0;if(d){continue}break}}return(e|0)<0?(c|0)<0?-2147483648:0-c|0:c}function Fg(a,b){var c=0,d=0,e=0,f=0;d=z[a+22>>1];e=d+z[a+20>>1]|0;c=z[a+24>>1]<<17;while(1){if((d|0)==(e|0)){a=(c|0)/32768|0}else{f=c;c=((d&127)<<2)+a|0;c=f-D(x[yb(b,z[c+28>>1])>>2],w[c+26>>1])|0;d=d+1|0;continue}break}return a}function n2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;f=x[d>>2];g=x[b+8>>2];if(g>>>0>c>>>0){x[e+12>>2]=g-c;x[e+8>>2]=x[d+4>>2];b=x[b+4>>2]+c|0;h=x[Hb(e+12|0,e+8|0)>>2];yk(b,b+h|0,f)}cc(a,f,h);fb=e+16|0}function zm(a,b,c,d){var e=0,f=0,g=0;e=fb-16|0;fb=e;Lg(a+12|0,d);a:{if(!b){d=0;b=0;break a}WG(e+8|0,b);d=x[e+12>>2];b=x[e+8>>2]}x[a>>2]=b;c=b+D(c,12)|0;x[a+8>>2]=c;x[a+4>>2]=c;f=nc(a),g=b+D(d,12)|0,x[f>>2]=g;fb=e+16|0;return a}function jE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=x[a>>2];f=jm(e,x[a+4>>2]);while(1){a:{c=d&65535;if(c>>>0>=f>>>0){break a}c=aj(e,c);if(!Ib(x[c>>2],x[c+4>>2])){break a}d=d+1|0;continue}break}return(Pg(a,d&65535,b)?d:-1)&65535}function UD(a,b,c,d){var e=0,f=0,g=0;e=fb-16|0;fb=e;Lg(a+12|0,d);a:{if(!b){d=0;b=0;break a}SE(e+8|0,b);d=x[e+12>>2];b=x[e+8>>2]}x[a>>2]=b;c=b+D(c,20)|0;x[a+8>>2]=c;x[a+4>>2]=c;f=nc(a),g=b+D(d,20)|0,x[f>>2]=g;fb=e+16|0;return a}function LR(a,b,c){var d=0,e=0,f=0,g=0,h=0;g=c;h=c>>31;c=0;while(1){if((b|0)!=(c|0)){d=x[a>>2];e=x[a+4>>2];f=(d+e|0)/2|0;d=d-e|0;d=Gc(Jua(Iua(d,d>>31,g,h),hb,256,0),hb);x[a+4>>2]=f-d;x[a>>2]=d+f;c=c+1|0;a=a+8|0;continue}break}}function Jr(a){var b=0,c=0,d=0,e=0;c=fb-16|0;fb=c;b=fb-16|0;fb=b;Tr(b+8|0,c+15|0);d=x[b+12>>2];qd(b,a,x[b+8>>2],x[b+12>>2]);e=x[b+4>>2];if((e|0)==(d|0)){id(a,x[b+12>>2])}fb=b+16|0;fb=c+16|0;return((d|0)==(e|0)?y[c+15|0]:0)&255}function mpa(a,b){a=a|0;b=b|0;var c=0,d=0;b=fb-32|0;fb=b;d=b+20|0;c=-1;a:{if(!dE(a,d)){break a}c=0;if(!qX(d)){break a}c=-1;if(!ik(a,b+12|0)){break a}c=0;if(!x[b+16>>2]){break a}c=!(x[b+12>>2]&-2139062144)}fb=b+32|0;return c|0}function mla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;BU(c+8|0,b);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){QB(b)}return a|0}function iqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;if(uh(178956970)>>>0<b>>>0){ed();p()}d=Ec(D(b,24));x[c+12>>2]=b;x[c+8>>2]=d;b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;e=Ab(a),f=b+D(x[c+12>>2],24)|0,x[e>>2]=f;fb=c+16|0}function aoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;if(uh(119304647)>>>0<b>>>0){ed();p()}d=Ec(D(b,36));x[c+12>>2]=b;x[c+8>>2]=d;b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;e=Ab(a),f=b+D(x[c+12>>2],36)|0,x[e>>2]=f;fb=c+16|0}function Jua(a,b,c,d){var e=0,f=0,g=0,h=0;f=b^d;g=f>>31;e=b>>31;a=a^e;h=a-e|0;e=(b^e)-((a>>>0<e>>>0)+e|0)|0;a=d>>31;b=c^a;f=f>>31;a=Kua(h,e,b-a|0,(a^d)-((a>>>0>b>>>0)+a|0)|0)^f;b=a-f|0;hb=(g^hb)-((a>>>0<f>>>0)+g|0)|0;return b}function CT(a,b,c){var d=0,e=0,f=0;d=fb-16|0;fb=d;a:{if(!c){break a}x[b+40>>2]=c;if(!c|x[a+480180>>2]!=256){break a}x[d+12>>2]=c>>>4;x[d+8>>2]=1;e=b,f=x[bd(d+12|0,d+8|0)>>2],x[e+40>>2]=f;e=b,f=AC(c&255),x[e+44>>2]=f}fb=d+16|0}function zw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;Mw(c+8|0,b);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){ME(b)}return a|0}function sZ(a,b,c,d){var e=0,f=0,g=0;e=fb-16|0;fb=e;Lg(a+12|0,d);a:{if(!b){d=0;b=0;break a}pZ(e+8|0,b);d=x[e+12>>2];b=x[e+8>>2]}x[a>>2]=b;c=b+D(c,6)|0;x[a+8>>2]=c;x[a+4>>2]=c;f=nc(a),g=b+D(d,6)|0,x[f>>2]=g;fb=e+16|0;return a}function lj(a,b,c){c=c&176;if((c|0)==32){return b}a:{if((c|0)!=16){break a}b:{c:{c=y[a|0];switch(c-43|0){case 0:case 2:break c;default:break b}}return a+1|0}if((c|0)!=48|(b-a|0)<2|(y[a+1|0]|32)!=120){break a}a=a+2|0}return a}function iv(a,b,c,d){var e=0,f=0,g=0;e=fb-16|0;fb=e;Lg(a+12|0,d);a:{if(!b){d=0;b=0;break a}RV(e+8|0,b);d=x[e+12>>2];b=x[e+8>>2]}x[a>>2]=b;c=b+(c<<5)|0;x[a+8>>2]=c;x[a+4>>2]=c;f=nc(a),g=b+(d<<5)|0,x[f>>2]=g;fb=e+16|0;return a}function hs(a,b,c,d){var e=0,f=0,g=0;e=fb-16|0;fb=e;Lg(a+12|0,d);a:{if(!b){d=0;b=0;break a}sG(e+8|0,b);d=x[e+12>>2];b=x[e+8>>2]}x[a>>2]=b;c=b+(c<<3)|0;x[a+8>>2]=c;x[a+4>>2]=c;f=nc(a),g=b+(d<<3)|0,x[f>>2]=g;fb=e+16|0;return a}function haa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;c=e+4|0;x[c+4>>2]=1;f=c,g=Ec(40),x[f+8>>2]=g;d=tm(x[c+8>>2]);x[d>>2]=78040;d=wM(nc(d));x[d+24>>2]=b;x[d>>2]=78188;b=a;a=Sn(c);Rn(b,nc(a),a);um(c);fb=e+16|0}function fk(a,b,c,d){var e=0,f=0,g=0;e=fb-16|0;fb=e;Lg(a+12|0,d);a:{if(!b){d=0;b=0;break a}Zw(e+8|0,b);d=x[e+12>>2];b=x[e+8>>2]}x[a>>2]=b;c=b+(c<<1)|0;x[a+8>>2]=c;x[a+4>>2]=c;f=nc(a),g=b+(d<<1)|0,x[f>>2]=g;fb=e+16|0;return a}function UV(a,b,c,d){var e=0,f=0,g=0;e=fb-16|0;fb=e;Lg(a+12|0,d);a:{if(!b){d=0;b=0;break a}TV(e+8|0,b);d=x[e+12>>2];b=x[e+8>>2]}x[a>>2]=b;c=b+(c<<4)|0;x[a+8>>2]=c;x[a+4>>2]=c;f=nc(a),g=b+(d<<4)|0,x[f>>2]=g;fb=e+16|0;return a}function Mq(a,b,c){var d=0,e=0,f=0,g=0,h=0;f=131072/(C[Hp(b)>>3]-C[a>>3]);b=0;while(1){if((b|0)!=2048){d=-Ge(f*C[Se(a,b)>>3]);a:{if(F(d)<2147483648){e=~~d;break a}e=-2147483648}g=yb(c,b),h=e,x[g>>2]=h;b=b+1|0;continue}break}}function Dv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;rX(c+8|0,b);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){sX(b)}return a|0}function r$(a){if(!((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=1179011410|(y[a+8|0]|y[a+9|0]<<8|(y[a+10|0]<<16|y[a+11|0]<<24))!=1179472708)){return 1}return(y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))==1179472708}function lta(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;d=Mb(x[a>>2],x[a+8>>2],64);a:{if(!d){a=0;while(1){if((a|0)!=64){qp(a+b|0);a=a+2|0;continue}break}break a}mw(c+8|0,b);sd(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0;return d|0}function fsa(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;x[a+480180>>2]=b;rr(c,sr(a));d=x[c+12>>2];b=a+1074320|0;x[b>>2]=x[c+8>>2];x[b+4>>2]=d;b=x[c+4>>2];x[a+1074312>>2]=x[c>>2];x[a+1074316>>2]=b;Bu(a+8|0,sr(a));fb=c+16|0}
function be(a,b){var c=0,d=0,e=0,f=0,g=0;d=z[a+22>>1];g=d+z[a+20>>1]|0;c=d;while(1){a:{if((c|0)!=(g|0)){e=((c&127)<<2)+a|0;f=z[e+28>>1]+b|0;w[e+28>>1]=f;if((f&65535)>>>0<2048){break a}w[a+20>>1]=c-d}return}c=c+1|0;continue}}function Gta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;if(uh(715827882)>>>0<b>>>0){ed();p()}d=Ec(D(b,6));x[c+12>>2]=b;x[c+8>>2]=d;b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;e=Ab(a),f=b+D(x[c+12>>2],6)|0,x[e>>2]=f;fb=c+16|0}function Gka(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;d=Mb(x[a>>2],x[a+8>>2],16);a:{if(!d){a=0;while(1){if((a|0)!=16){dh(a+b|0);a=a+1|0;continue}break}break a}fE(c+8|0,b);sd(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0;return d|0}function Bu(a,b){var c=0;a:{b:{c:{switch(b-2|0){default:c=42220;if((b|0)==16777216){break a}if((b|0)!=32){break b}c=42072;break a;case 2:c=42068;break a;case 1:break b;case 0:break c}}c=42064;break a}c=42060}x[a>>2]=x[c>>2]}function u_(a){var b=0,c=0,d=0;c=y[a+3|0];b=Iua(c>>>0<3?48:64,0,Bb(y[a+196|0]|y[a+197|0]<<8),0);d=b;b=Iua(Iua(Bb(y[a+198|0]|y[a+199|0]<<8),0,c>>>0<4?4:5,0),hb,Bb(y[a+200|0]|y[a+201|0]<<8),0);a=d+b|0;a=a+512|0;hb=0;return a}function hr(a,b){var c=0,d=0;c=fb-32|0;fb=c;fe(c+24|0,a);fe(c+16|0,b);a=x[c+20>>2];x[c+8>>2]=x[c+16>>2];x[c+12>>2]=a;a=x[c+24>>2];b=x[c+28>>2];d=x[c+12>>2];if((b|0)==(d|0)){a=zZ(a,b,x[c+8>>2],d)}else{a=1}fb=c+32|0;return!a}function ZR(a){var b=0,c=0,d=0;c=fb-544|0;fb=c;a:{if(!(y[a+480210|0]&128)|!x[a+24668>>2]){break a}d=a+112|0;b=1074992;a=rC(c,x[a+24620>>2]);while(1){if((b|0)==1298224){break a}zc(b+d|0,a,538);b=b+872|0;continue}}fb=c+544|0}function Osa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=fb-16|0;fb=c;if(uh(2147483647)>>>0<b>>>0){ed();p()}d=Ec(b<<1);x[c+12>>2]=b;x[c+8>>2]=d;b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;e=Ab(a),f=b+(x[c+12>>2]<<1)|0,x[e>>2]=f;fb=c+16|0}function MV(a,b,c){var d=0,e=0,f=0;d=fb-16|0;fb=d;a:{if(!(c&32)){break a}c=zd(b);x[d+12>>2]=c;f=Ef(b);while(1){if(!Ib(c,f)){break a}e=y[c|0];if((e-97&255)>>>0<=25){v[c|0]=e-32}c=x[we(d+12|0)>>2];continue}}Uc(a,b);fb=d+16|0}function vH(a,b,c,d,e){var f=0;f=fb-32|0;fb=f;x[f+24>>2]=a;x[f+28>>2]=b;x[f+16>>2]=d;x[f+20>>2]=e;x[f+8>>2]=c;x[f+12>>2]=0;a=B0(f+24|0,f+8|0);b=f+16|0;a=dt(x[b>>2],x[b+4>>2],x[a>>2],x[a+4>>2])?a:b;fb=f+32|0;return x[a>>2]}function Ht(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Mc(a);e=Cb(x[a+4>>2],y[a+11|0]);a:{if(d-e>>>0>=c>>>0){if(!c){break a}d=Kb(a);Dg(d+e|0,b,c);b=c+e|0;lg(a,b);hd(b+d|0,0);return a|0}Yp(a,d,(c-d|0)+e|0,e,e,0,c,b)}return a|0}function Gpa(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;d=Mb(x[a>>2],x[a+8>>2],6);a:{if(!d){a=0;while(1){if((a|0)!=6){dh(a+b|0);a=a+1|0;continue}break}break a}XD(c+8|0,b);sd(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0;return d|0}function Cv(a,b){var c=0,d=0,e=0;if(x[a>>2]){f0(a);c=x[a>>2];tE(a);Db(c);d=Ab(a),e=0,x[d>>2]=e;x[a>>2]=0;x[a+4>>2]=0}x[a>>2]=x[b>>2];x[a+4>>2]=x[b+4>>2];c=Ab(b);d=Ab(a),e=x[c>>2],x[d>>2]=e;x[c>>2]=0;x[b>>2]=0;x[b+4>>2]=0}function $t(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=fb-16|0;fb=c;d=x[b>>2];b=oc(d,x[b+4>>2]);a=0;while(1){if((a|0)==(b|0)){fb=c+16|0}else{x[c+12>>2]=0;e=tc(c+12|0);f=yb(d,a),g=x[e>>2],x[f>>2]=g;a=a+1|0;continue}break}}function yha(a){a=a|0;var b=0;ib[x[x[a>>2]+132>>2]](a);Wz(a);x[a+4236>>2]=0;v[a+4202|0]=1;b=ib[x[x[a>>2]+196>>2]](a)|0;x[a+4328>>2]=0;x[a+4312>>2]=0;B[a+4240>>2]=b?E(.5):E(1);b=x[a+4256>>2];x[a+4324>>2]=b;x[a+4320>>2]=b}function _S(a,b){var c=0,d=0,e=0,f=0;x[a>>2]=x[b>>2];x[a+4>>2]=x[b+4>>2];x[a+8>>2]=x[b+8>>2];d=Ab(a);c=gc(a);a:{if(!x[d>>2]){x[a>>2]=c;break a}x[x[c>>2]+8>>2]=c;c=gc(b);x[b>>2]=c;x[c>>2]=0;e=Ab(b),f=0,x[e>>2]=f}return a}function Qx(a,b,c,d,e){var f=0,g=0,h=0;f=fb-16|0;fb=f;g=Ff(f+8|0,d);x[31609]=0;h=x[g+4>>2];x[f>>2]=x[g>>2];x[f+4>>2]=h;a=hg(e,a,b,c,f);b=x[31609];x[31609]=0;if((b|0)!=1){me(d);fb=f+16|0;return a}a=N()|0;me(d);Q(a|0);p()}function OW(a,b,c){var d=0;d=fb-16|0;fb=d;v[d+15|0]=a;a=0;if(!(c>>>0<25|b>>>0<25|(b>>>0>108|b>>>0>=c>>>0)|c>>>0>108)){v[d+14|0]=(z[(b<<1)+30990>>1]-z[(c<<1)+30990>>1]|0)/5;a=y[Qb(d+15|0,d+14|0)|0]}fb=d+16|0;return a&255}function NA(a,b){var c=0;c=x[b+24>>2];c=c>>>0<=1?1:c;x[a+24628>>2]=c>>>0>=512?512:c;a:{if(!(x[b+16>>2]!=x[a+24620>>2]|x[b+20>>2]!=x[a+24624>>2])){c=0;if(x[b+12>>2]==x[a+24616>>2]){break a}}c=1}zc(a+24604|0,b,40);UR(a,c)}function qta(a){a=a|0;var b=0,c=0,d=0,e=0;b=fb-16|0;fb=b;if(uh(1073741823)>>>0<=8191){ed();p()}c=Ec(32768);x[b+12>>2]=8192;x[b+8>>2]=c;c=x[b+8>>2];x[a+4>>2]=c;x[a>>2]=c;d=Ab(a),e=c+(x[b+12>>2]<<2)|0,x[d>>2]=e;fb=b+16|0}function oX(a){var b=0,c=0,d=0,e=0;c=fb-16|0;fb=c;d=vb(c+12|0,a);a=x[d>>2];if(x[a>>2]){e=x[a>>2];b=x[a+4>>2];while(1){if((b|0)!=(e|0)){b=b-56|0;ar(b);continue}break}x[a+4>>2]=e;a=x[d>>2];b=x[a>>2];lX(a);Db(b)}fb=c+16|0}function mra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=fb-16|0;fb=d;c=-1;a:{if(!ik(a,d+8|0)){break a}e=x[d+12>>2];c=0;if(!(x[d+8>>2]==(En(8994)|0)&e>>>0>255&e>>>0<260)){break a}c=xe(a,b,e>>>0<259?80:76,0)}fb=d+16|0;return c|0}function ai(a,b,c){var d=0,e=0,f=0;d=fb-16|0;fb=d;cc(d+8|0,b,c);e=x[d+12>>2];lc(d,x[a>>2],x[a+8>>2],x[d+8>>2],x[d+12>>2]);f=x[d+4>>2];if((f|0)==(e|0)){Vb(a,x[d+12>>2])}fb=d+16|0;a=(e|0)==(f|0);if(!a){Rb(b,0,c)}return a}function XY(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;v[a+6|0]=0;v[a+7|0]=0;v[a+16|0]=0;v[a+17|0]=0;v[a+8|0]=0;v[a+9|0]=0;v[a+10|0]=0;v[a+11|0]=0;v[a+12|0]=0;v[a+13|0]=0;v[a+14|0]=0;v[a+15|0]=0}function W_(a){var b=0;a:{if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=777268804){break a}if($b(y[a+4|0]|y[a+5|0]<<8|(y[a+6|0]<<16|y[a+7|0]<<24))-257>>>0<4294967053){break a}b=!Bb(y[a+8|0]|y[a+9|0]<<8)}return b}function Rt(a){var b=0;a:{b=y[a+1376|0];b:{if(!b){b=-1;if(x[a+1384>>2]){break b}if(!fz(a)){break b}b=y[a+1376|0];if(!b){break a}}v[a+1376|0]=b-1;x[a+1400>>2]=x[a+1400>>2]+1;b=ff(a)}return b}_(15776,13274,1578,5429);p()}function Hda(a,b){a=a|0;b=b|0;var c=0;a=x[a+8>>2];a:{if(Ad(x[b+4>>2],y[b+11|0])){c=0}else{c=a;if(Nd(b,47296)){break a}c=a+88|0;if(Nd(b,47308)){break a}c=a+92|0;if(Nd(b,47320)){break a}c=Nd(b,47333)?a+96|0:0}}return c|0}function xB(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0;f=x[b+480180>>2];if(f&64671904){b=y[(d&15)+42144|0];v[a+2|0]=0;w[a>>1]=b;return}g=a;a=(c&255)==4&(f|0)==4;c=(d&255)<<a<<4;Zl(g,(h=Ob(b+1074312|0,66)?0:c,i=c,j=e,j?h:i),a)}function LU(a,b){a:{if(y[a+76|0]==(b|0)){break a}v[a+76|0]=b;if(b){b=0;if(z[a+24>>1]==15){w[a+20>>1]=0;b=1}x[a+8>>2]=0;x[a+16>>2]=b;return}b:{switch(x[a+16>>2]+1|0){case 0:case 4:break a;default:break b}}x[a+16>>2]=3}}function FF(a,b){var c=0,d=0;c=fb-16|0;fb=c;a:{if(b>>>0<2){b:{if(!b){break b}if(!Mb(x[a>>2],x[a+8>>2],1)){break b}v[c+15|0]=0;eh(a,c+15|0);d=v[c+15|0]}fb=c+16|0;a=d<<24>>24;break a}_(11251,9095,325,14260);p()}return a}function qr(a,b,c){var d=0,e=0;e=z[a+480192>>1];a:{if(e){if(!Tc(b)|c>>>0>e>>>0){break a}c=x[((c<<2)+a|0)+900380>>2];if(!c){break a}d=z[bc(c+236|0,b-1|0)>>1];break a}d=c}return(z[a+480190>>1]>=(d&65535)>>>0?d:0)&65535}function Iua(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;e=c>>>16|0;f=a>>>16|0;j=D(e,f);g=c&65535;h=a&65535;i=D(g,h);f=(i>>>16|0)+D(f,g)|0;e=(f&65535)+D(e,h)|0;hb=(D(b,c)+j|0)+D(a,d)+(f>>>16)+(e>>>16)|0;return i&65535|e<<16}function rZ(a,b,c){var d=0,e=0,f=0;e=fb-16|0;fb=e;f=x[a+8>>2];d=e+4|0;x[d+8>>2]=a+8;x[d>>2]=f;x[d+4>>2]=D(b,6)+f;b=x[d>>2];while(1){if(x[d+4>>2]!=(b|0)){sD(b,c);b=x[d>>2]+6|0;x[d>>2]=b;continue}break}je(d);fb=e+16|0}function mba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=fb-16|0;fb=d;e=d+4|0;eN(e,c);a=x[a+1298472>>2];x[31609]=0;S(385,a|0,b|0,e|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(e);fb=d+16|0;return}a=N()|0;tb(d+4|0);Q(a|0);p()}function dz(a){var b=0;a:{b:{while(1){if(x[a+1380>>2]!=-1){break b}b=0;if(!Qt(a)){break a}if(!(v[a+1375|0]&1)){continue}break}fc(a,32);return 0}x[a+1396>>2]=0;x[a+1400>>2]=0;x[a+1384>>2]=0;v[a+1376|0]=0;b=1}return b}function CL(a,b){var c=0,d=0,e=0;c=fb-256|0;fb=c;if((b|0)>=2){x[(b<<2)+a>>2]=c;zc(c,x[a>>2],4);while(1){e=(d<<2)+a|0;d=d+1|0;zc(x[e>>2],x[(d<<2)+a>>2],4);x[e>>2]=x[e>>2]+4;if((b|0)!=(d|0)){continue}break}}fb=c+256|0}function pU(a,b){var c=0,d=0,e=0,f=0;e=C[a+48>>3];c=C[a+40>>3];C[a+48>>3]=c;f=C[a+64>>3];d=C[a+56>>3];C[a+64>>3]=d;C[a+40>>3]=b;b=e*C[a+16>>3]+(C[a>>3]*b+c*C[a+8>>3])-d*C[a+24>>3]-f*C[a+32>>3];C[a+56>>3]=b;return b}function nV(a){var b=0;b=w[a+784>>1];if(b){x[a+692>>2]=(b&32767)-1;if((b|0)<0){x[a+88>>2]=x[a+88>>2]|256}w[a+784>>1]=0}b=y[a+795|0];if(b){v[a+795|0]=0;v[a+838|0]=b-1}b=y[a+796|0];if(b){v[a+796|0]=0;v[a+837|0]=b-1}}function lo(a,b){var c=0,d=0,e=0;c=a*a;d=c*a;e=c*c;a=d*e*(e*(c*.009465647849436732+.002974357433599673)+(c*.024528318116654728+.05338123784456704))+(d*(c*.13339200271297674+.3333313950307914)+a);return E(b?-1/a:a)}function Fq(a,b){a=zc(a,b,88);x[a+88>>2]=x[b+88>>2];zc(a+92|0,b+92|0,576);x[a+668>>2]=x[b+668>>2];zc(a+672|0,b+672|0,52);jB(a+724|0,b+724|0);jB(a+732|0,b+732|0);jB(a+740|0,b+740|0);zc(a+748|0,b+748|0,123);return a}function $I(a,b){var c=0,d=0;c=fb-16|0;fb=c;d=a;a=nk(Kb(b));x[d>>2]=a;a:{if(!a){a=c+4|0;Nm(a,17634,b);x[31609]=0;W(1367,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}b=N()|0;tb(a);Q(b|0);p()}fb=c+16|0;return}p()}function Cra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=fb-16|0;fb=e;c=If(a,c);ae(e,x[a+36>>2]);a:{if(!c){Qc(e,a+32|0,5);f=0;if(Gb(x[x[e>>2]>>2],x[e+4>>2])){break a}}EZ(x[a+36>>2],b,d,0);f=c}ef(a,f);fb=e+16|0}function _I(a,b){var c=0,d=0;c=fb-16|0;fb=c;d=nk(Kb(b));x[a>>2]=d;a:{if(!d){a=c+4|0;Nm(a,17675,b);x[31609]=0;W(1367,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){break a}b=N()|0;tb(a);Q(b|0);p()}fb=c+16|0;return a}p()}function Sja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;a:{if(Vg(a)>>>0<b>>>0){if(uh(1073741823)>>>0<b>>>0){break a}d=Ab(a);e=a;a=Zf(c+12|0,b,oc(x[a>>2],x[a+4>>2]),d);Tm(e,a);Yf(a)}fb=c+32|0;return}ed();p()}function fla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;a:{if(Tn(a)>>>0<b>>>0){if(uh(536870911)>>>0<b>>>0){break a}d=Ab(a);e=a;a=hs(c+12|0,b,ih(x[a>>2],x[a+4>>2]),d);MB(e,a);gs(a)}fb=c+32|0;return}ed();p()}function eG(a,b,c){var d=0,e=0;d=fb-16|0;fb=d;if(c>>>0<2147483632){a:{if(Ok(c)){Ne(a,c);break a}qg(d+8|0,Fh(c)+1|0);e=x[d+8>>2];yd(a,e);of(a,x[d+12>>2]);Bd(a,c);a=e}hd(Xg(a,b,c)+c|0,0);fb=d+16|0;return}pf();p()}function _ia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=fb-16|0;fb=e;c=If(a,c);ae(e,x[a+36>>2]);a:{if(!c){Qc(e,a+32|0,5);f=0;if(Gb(x[x[e>>2]>>2],x[e+4>>2])){break a}}WQ(d,x[a+36>>2],b);f=c}ef(a,f);fb=e+16|0}function Wm(a,b){var c=E(0),d=0,e=0;c=E(1);d=w[a+28>>1];a:{if((d|0)>(b|0)){break a}e=x[a+4>>2];if((oc(e,x[a+8>>2])+d|0)-1<<16>>16<(b|0)){break a}c=B[yb(e,b-d|0)>>2];c=c<=E(10000000036274937e-31)?E(1):c}return c}function Wka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;a:{if(HB(a)>>>0<b>>>0){if(uh(613566756)>>>0<b>>>0){break a}d=Ab(a);e=a;a=QT(c+12|0,b,GB(x[a>>2],x[a+4>>2]),d);PT(e,a);OT(a)}fb=c+32|0;return}ed();p()}function Vk(a){xc(a+16|0,x[a>>2]);xc(a+8|0,x[a>>2]);if(A[a+12>>2]>=A[a+16>>2]){x[a+12>>2]=0;x[a+16>>2]=0;w[a+34>>1]=z[a+34>>1]&65511}if(A[a+4>>2]>=A[a+8>>2]){x[a+4>>2]=0;x[a+8>>2]=0;w[a+34>>1]=z[a+34>>1]&65529}}function Uja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;a:{if(dl(a)>>>0<b>>>0){if(uh(357913941)>>>0<b>>>0){break a}d=Ab(a);e=a;a=zm(c+12|0,b,Ud(x[a>>2],x[a+4>>2]),d);Bx(e,a);us(a)}fb=c+32|0;return}ed();p()}function SD(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;F_(c+8|0,b);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){G_(b)}return a}function LY(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;NY(c+8|0,b);d=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){MY(b)}return a}function GY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;a:{if(In(a)>>>0<b>>>0){if(uh(2147483647)>>>0<b>>>0){break a}d=Ab(a);e=a;a=fk(c+12|0,b,$c(x[a>>2],x[a+4>>2]),d);Sr(e,a);cj(a)}fb=c+32|0;return}ed();p()}function Fu(a,b,c){var d=0,e=0;d=fb-16|0;fb=d;if(c>>>0<2147483632){a:{if(Ok(c)){Ne(a,c);break a}qg(d+8|0,Fh(c)+1|0);e=x[d+8>>2];yd(a,e);of(a,x[d+12>>2]);Bd(a,c);a=e}hd(Dg(a,b,c)+c|0,0);fb=d+16|0;return}pf();p()}function Eoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;a:{if(dl(a)>>>0<b>>>0){if(uh(357913941)>>>0<b>>>0){break a}d=Ab(a);e=a;a=zm(c+12|0,b,Ud(x[a>>2],x[a+4>>2]),d);zW(e,a);yW(a)}fb=c+32|0;return}ed();p()}function iia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;d=yj(a);if(d){e=x[b+4>>2];b=x[b>>2];x[c+8>>2]=b;x[c+12>>2]=e;a=x[x[d>>2]+72>>2];x[c>>2]=b;x[c+4>>2]=e;a=ib[a|0](d,c)|0}else{a=1}fb=c+16|0;return a|0}function faa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=x[c>>2];c=x[c+4>>2];while(1){if(c){d=x[b+24>>2];g=uh(c);wj(d,e+f|0,g);d=x[x[b+24>>2]+4>>2];c=c-d|0;e=e+d|0;if((d|0)==(g|0)){continue}}break}cc(a,f,e)}function cL(a,b){a=a|0;b=b|0;var c=0,d=0;c=x[a>>2];a:{if(!c){break a}d=x[c+24>>2];b:{if((d|0)==x[c+28>>2]){b=ib[x[x[c>>2]+52>>2]](c,b)|0;break b}x[c+24>>2]=d+4;x[d>>2]=b}if(!jo(b)){break a}x[a>>2]=0}return a|0}function LA(a,b){var c=0,d=0;c=x[b+4>>2];x[a+24648>>2]=x[b>>2];x[a+24652>>2]=c;d=x[b+20>>2];c=a+24664|0;x[c>>2]=x[b+16>>2];x[c+4>>2]=d;d=x[b+12>>2];c=a+24656|0;x[c>>2]=x[b+8>>2];x[c+4>>2]=d;TR(a+24648|0);ZR(a)}function $M(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;f=e+8|0;xz(f,b);while(1){if(d){b=x[f+4>>2];h=uh(d);wj(b,c+g|0,h);b=x[x[f+4>>2]+4>>2];d=d-b|0;g=b+g|0;if((b|0)==(h|0)){continue}}break}cc(a,c,g);fb=e+16|0}function Ux(a,b,c){var d=0;d=x[a+16>>2];if(!d){x[a+36>>2]=1;x[a+24>>2]=c;x[a+16>>2]=b;return}a:{if((b|0)==(d|0)){if(x[a+24>>2]!=2){break a}x[a+24>>2]=c;return}v[a+54|0]=1;x[a+24>>2]=2;x[a+36>>2]=x[a+36>>2]+1}}function QJ(a,b,c){var d=0,e=0;e=fb-16|0;fb=e;d=fb-32|0;fb=d;fd(d+24|0,a,b);bD(d+16|0,x[d+24>>2],x[d+28>>2],c);a=lA(a,x[d+16>>2]);x[d+12>>2]=x[d+20>>2];rc(e+8|0,a,d+12|0);fb=d+32|0;fb=e+16|0;return x[e+12>>2]}function lga(a){a=a|0;var b=0;b=fb-16|0;fb=b;a:{if(!Nd(a,10281)){b=b+4|0;Nm(b,18221,a);a=Kb(b);x[31609]=0;O(67,44,a|0);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;tb(b);Q(a|0);p()}fb=b+16|0;return}p()}function TC(a,b){var c=0,d=0,e=0,f=0;d=b?224:240;e=AG(a);a:while(1){if((a|0)!=(e|0)){f=ud(a);b=a;while(1)if((b|0)==(f|0)){a=a+16|0;continue a}else{c=((y[xb(b,0)|0]&d)!=0)+c|0;b=b+4|0;continue}}break}return c}function IA(a,b,c){var d=0,e=0;d=x[b+656>>2];if(!d){return 0}d=Ow(d,c);a=a+1074312|0;if(!Ob(a,31)){e=Ob(a,93)^1}a:{if(!(v[OR(b,c)+6|0]&1)){a=0;if(!(v[d+12|0]&1)|e){break a}}a=mc(x[d>>2],x[d+4>>2])^1}return a}function xoa(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;kn(a,b);b=wb(x[a>>2]);x[c+12>>2]=b;a=wb(x[a+4>>2]);while(1){if(Ib(b,a)){d=y[b|0]+(d&255)|0;v[b|0]=d;b=x[we(c+12|0)>>2];continue}else{fb=c+16|0}break}}function rv(a,b,c){var d=0,e=0,f=0,g=0;e=fb-16|0;fb=e;d=fb-32|0;fb=d;fd(d+24|0,a,b);cv(d+16|0,x[d+24>>2],x[d+28>>2],c);a=x[d+16>>2];f=d,g=_D(c,x[d+20>>2]),x[f+12>>2]=g;rc(e+8|0,a,d+12|0);fb=d+32|0;fb=e+16|0}function TS(a,b,c,d){var e=0,f=0;b=D(c,872)+b|0;e=x[b+704>>2];a:{if(!(!(e&67109888)|(d|0)!=1)|e&33554432){break a}b=z[b+1402>>1];b=(b?b-1|0:c)&65535;if(b>>>0>126){break a}f=y[((b<<5)+a|0)+480288|0]}return f}function QS(a,b){var c=0;c=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=c;c=x[b+28>>2];x[a+24>>2]=x[b+24>>2];x[a+28>>2]=c;c=x[b+20>>2];x[a+16>>2]=x[b+16>>2];x[a+20>>2]=c;c=x[b+12>>2];x[a+8>>2]=x[b+8>>2];x[a+12>>2]=c}function IE(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;v[a+6|0]=0;v[a+7|0]=0;v[a+16|0]=0;v[a+8|0]=0;v[a+9|0]=0;v[a+10|0]=0;v[a+11|0]=0;v[a+12|0]=0;v[a+13|0]=0;v[a+14|0]=0;v[a+15|0]=0}function yi(a,b,c){var d=0,e=0,f=0;d=fb-16|0;fb=d;cc(d+8|0,b,c);e=x[d+12>>2];lc(d,x[a>>2],x[a+8>>2],x[d+8>>2],x[d+12>>2]);f=x[d+4>>2];if((f|0)==(e|0)){Vb(a,x[d+12>>2])}fb=d+16|0;if((e|0)!=(f|0)){Rb(b,0,c)}}function qd(a,b,c,d){var e=0,f=0;e=fb-32|0;fb=e;f=x[b+12>>2];lf(e+16|0,c,d);c=x[x[b>>2]+28>>2];d=x[e+20>>2];x[e+8>>2]=x[e+16>>2];x[e+12>>2]=d;ib[c|0](e+24|0,b,f,e+8|0);lf(a,x[e+24>>2],x[e+28>>2]);fb=e+32|0}function gla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=Nb(a);d=og(a+12|0);v[a+32|0]=c;x[a+28>>2]=0;x[a+24>>2]=b;x[31609]=0;O(801,a|0,1);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}b=N()|0;gU(d);kU(a);Q(b|0);p()}function Vpa(a){a=a|0;var b=0,c=0,d=0;b=fb-32|0;fb=b;w[b+30>>1]=0;c=Zb(b+8|0,b+30|0,2);lc(b+20|0,x[a>>2],x[a+8>>2],x[c>>2],x[c+4>>2]);if(!(x[b+24>>2]!=2|z[b+30>>1]!=21584)){Vb(a,2);d=1}fb=b+32|0;return d|0}function Pda(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;d=c+4|0;eN(d,b);a=x[a+1298472>>2];x[31609]=0;S(385,a|0,1,d|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(d);fb=c+16|0;return}a=N()|0;tb(c+4|0);Q(a|0);p()}function Kd(a,b){var c=0,d=0;c=fb-16|0;fb=c;a:{if(b>>>0<2){b:{if(!b){break b}if(!Mb(x[a>>2],x[a+8>>2],1)){break b}v[c+15|0]=0;eh(a,c+15|0);d=y[c+15|0]}fb=c+16|0;break a}_(11251,9095,325,14260);p()}return d}function lla(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[a>>2],x[a+8>>2],27)){a=0;while(1){if((a|0)!=27){dh(a+b|0);a=a+1|0;continue}break}break a}BU(c+8|0,b);sd(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function Qta(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[a>>2],x[a+8>>2],64)){a=0;while(1){if((a|0)!=64){dh(a+b|0);a=a+1|0;continue}break}break a}mw(c+8|0,b);sd(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function NU(a){var b=0,c=0,d=0;b=z[a+20>>1];w[a+28>>1]=z[a+22>>1]<<1|(y[x[a+16>>2]+3842|0]?b>>>9|0:b>>>8&1);b=0;while(1){if((b|0)!=4){c=(b<<2)+a|0;d=x[c>>2];if(d){Oo(d);MU(x[c>>2])}b=b+1|0;continue}break}}function NO(a,b){var c=0,d=0;c=-1;a:{if((b|0)<0){break a}d=x[a+24>>2];if(Ij(Xb(x[d+484360>>2],y[d+484376|0]))>>>0<=b>>>0){break a}a=x[a+24>>2];c=z[bc(x[Xb(x[a+484360>>2],y[a+484376|0])>>2],b)>>1]}return c}function hG(a){var b=0;if(!((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=808603728|(y[a+4|0]-16&255)>>>0<249|((y[a+5|0]-16&255)>>>0<249|(y[a+6|0]-16&255)>>>0<249))){b=(y[a+7|0]-9&255)>>>0<7}return b}function Wf(a,b,c,d,e){var f=0;f=fb-256|0;fb=f;if(!(e&73728|(c|0)<=(d|0))){d=c-d|0;c=d>>>0<256;Rb(f,b&255,c?d:256);if(!c){while(1){Kf(a,f,256);d=d-256|0;if(d>>>0>255){continue}break}}Kf(a,f,d)}fb=f+256|0}function L3(a){a=a|0;var b=0;a:{b:{if(!a){break b}b=jl(a);if(pI(b,-1)|y[b+13|0]){break b}b=x[b+8>>2];if(b){x[31609]=0;R(b|0,a|0)|0;b=x[31609];x[31609]=0;if((b|0)==1){break a}}ic(a)}return}T(0)|0;Sb();p()}function Hga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=fb-16|0;fb=f;b=Gc(Jua(Iua(d,d>>31,b,0),hb,1e3,0),hb);x[a+16>>2]=0;x[a+12>>2]=b+c;YP(a,e);b=x[a+12>>2];x[f+12>>2]=0;ZQ(a,b,f+12|0);fb=f+16|0}function Gw(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[a>>2],x[a+8>>2],32)){a=0;while(1){if((a|0)!=32){dh(a+b|0);a=a+1|0;continue}break}break a}QE(c+8|0,b);sd(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function ue(a,b){var c=0,d=0,e=0;b=b+7&-8;x[a+8>>2]=b+x[a+8>>2];d=x[a+80>>2];a:{if(d){c=b;b=x[a+88>>2];e=c+b|0;c=0;if((e|0)>x[a+92>>2]){break a}x[a+88>>2]=e;return b+d|0}if(!b){return 0}c=Gd(b)}return c}function so(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-32|0;fb=c;a:{if($o(a)>>>0<b>>>0){if(uh(-1)>>>0<b>>>0){break a}d=Ab(a);e=a;a=qn(c+12|0,b,Xc(x[a>>2],x[a+4>>2]),d);cr(e,a);pn(a)}fb=c+32|0;return}ed();p()}function kja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=fb-16|0;fb=d;c=If(a,c);ae(d,x[a+36>>2]);a:{if(!c){Qc(d,a+32|0,5);e=0;if(Gb(x[x[d>>2]>>2],x[d+4>>2])){break a}}IZ(x[a+36>>2],b,a);e=c}ef(a,e);fb=d+16|0}function Zh(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;$k(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)|0}function ZX(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;d=wb(a);x[c+12>>2]=d;b=Zj(a,b);a=0;while(1){if(Ib(d,b)){e=a;a=v[d|0];a=e+((a&255)!=0&(a|0)<32)|0;d=x[we(c+12|0)>>2];continue}else{fb=c+16|0}break}return a}function Tna(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;if((b|0)>=0){d=2147483647;a=hv(a);if(a>>>0<=1073741822){x[c+12>>2]=a<<1;x[c+8>>2]=b+31&-32;d=x[bd(c+12|0,c+8|0)>>2]}fb=c+16|0;return d|0}ed();p()}function RY(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;XD(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)|0}function LN(a,b){a=a|0;b=b|0;var c=0;a=Ej(a);x[a+4>>2]=0;x[a>>2]=47568;if(ib[x[x[b>>2]+8>>2]](b)|0){b=ib[x[x[b>>2]+8>>2]](b)|0}else{b=22292}c=Gd(Df(b)+1|0);x[a+4>>2]=c;if(c){zc(c,b,Df(b)+1|0)}return a|0}function $ca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;a=x[a+4>>2];b=jg(d+4|0,b);x[31609]=0;V(1012,a|0,b|0,c|0,1);a=x[31609];x[31609]=0;if((a|0)!=1){tb(b);fb=d+16|0;return}a=N()|0;tb(b);Q(a|0);p()}function mi(a){var b=0,c=0,d=0,e=0;b=fb-16|0;fb=b;c=2;if(a>>>0>=2){x[b+12>>2]=a>>>1;x[b+8>>2]=a^-1;d=b,e=x[Hb(b+12|0,b+8|0)>>2]+a|0,x[d+12>>2]=e;x[b+8>>2]=-1;c=x[Hb(b+12|0,b+8|0)>>2]}fb=b+16|0;return c}function m0(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[a>>2],x[a+8>>2],8)){a=0;while(1){if((a|0)!=8){dh(a+b|0);a=a+1|0;continue}break}break a}$k(c+8|0,b);sd(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function jK(a,b,c,d,e,f){var g=0,h=0,i=0;g=fb-16|0;fb=g;v[g+15|0]=0;v[g+14|0]=f;v[g+13|0]=e;v[g+12|0]=37;if(f){rg(g+13|0,g+14|0)}h=c,i=(fa(b|0,Xc(b,x[c>>2])|0,g+12|0,d|0,a|0)|0)+b|0,x[h>>2]=i;fb=g+16|0}function Sha(a){a=a|0;var b=0,c=0,d=0;b=fb-32|0;fb=b;a:{if(Vg(a)>>>0<=12){if(uh(1073741823)>>>0<=12){break a}c=Ab(a);d=a;a=Zf(b+12|0,13,oc(x[a>>2],x[a+4>>2]),c);Tm(d,a);Yf(a)}fb=b+32|0;return}ed();p()}function vl(a){a=a|0;var b=0;x[a>>2]=94580;x[31609]=0;O(113,a|0,0);b=x[31609];x[31609]=0;if((b|0)!=1){_b(a+28|0);Db(x[a+32>>2]);Db(x[a+36>>2]);Db(x[a+48>>2]);Db(x[a+60>>2]);return a|0}T(0)|0;Sb();p()}function s9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-16|0;fb=d;f=x[x[b>>2]+20>>2];e=x[c+12>>2];x[d+8>>2]=x[c+8>>2];x[d+12>>2]=e;e=x[c+4>>2];x[d>>2]=x[c>>2];x[d+4>>2]=e;ib[f|0](a,b,d,8);fb=d+16|0}function iS(a,b,c){var d=0,e=0;d=Mc(a);e=Cb(x[a+4>>2],y[a+11|0]);a:{if(d-e>>>0>=c>>>0){if(!c){break a}d=Kb(a);Xg(d+e|0,b,c);b=c+e|0;lg(a,b);hd(b+d|0,0);return a}Sq(a,d,(c-d|0)+e|0,e,e,0,c,b)}return a}function bca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;b=x[b+4>>2];c=jg(d+4|0,c);x[31609]=0;S(998,a|0,b|0,c|0);a=x[31609];x[31609]=0;if((a|0)!=1){tb(c);fb=d+16|0;return}a=N()|0;tb(c);Q(a|0);p()}function JX(a,b){a=a|0;b=b|0;var c=0,d=0;d=x[a>>2];c=65535;a:{if(!Je(d,x[a+4>>2],b)){break a}d=jE(a,x[aj(d,b)+12>>2]);c=65535;if((d|0)==65535){break a}c=x[a>>2];a=aj(c,b);nR(aj(c,d),a);c=d}return c|0}function GJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;if(uh(1073741823)>>>0<b>>>0){ed();p()}nJ(c+8|0,ht(a),b);b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;d=Ab(a),e=b+(x[c+12>>2]<<2)|0,x[d>>2]=e;fb=c+16|0}function zx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=fb-16|0;fb=e;x[e+12>>2]=d;d=Cb(x[b+4>>2],y[b+11|0]);if(d>>>0<c>>>0){en();p()}b=Kb(b);x[e+8>>2]=d-c;Fu(a,b+c|0,x[Hb(e+12|0,e+8|0)>>2]);fb=e+16|0}function l$(a){var b=0;a:{if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=443372356|y[a+4|0]!=32|(!y[a+46|0]|(y[a+45|0]-17&255)>>>0<240)){break a}if(!y[a+47|0]){break a}b=y[a+49|0]<101}return b}function c_(a,b){var c=0,d=0,e=0;d=fb-16|0;fb=d;c=xh(d+4|0,a,1);a=x[c+4>>2];e=x[c+8>>2];while(1){if((a|0)==(e|0)){kc(c);fb=d+16|0}else{bp(a,z[b>>1]|z[b+2>>1]<<16);a=a+4|0;x[c+4>>2]=a;continue}break}}function a3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=fb-16|0;fb=e;x[e+12>>2]=d;d=Cb(x[b+4>>2],y[b+11|0]);if(d>>>0<c>>>0){en();p()}b=Kb(b);x[e+8>>2]=d-c;eG(a,b+c|0,x[Hb(e+12|0,e+8|0)>>2]);fb=e+16|0}function W2(a,b){a=a|0;b=b|0;var c=0;a=Pt(a);x[a>>2]=93384;b=Uc(a+32|0,b);x[a+44>>2]=0;x[a+48>>2]=8;x[31609]=0;W(112,a|0);c=x[31609];x[31609]=0;if((c|0)!=1){return a|0}c=N()|0;tb(b);go(a);Q(c|0);p()}function Hw(a,b){var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[a>>2],x[a+8>>2],256)){a=0;while(1){if((a|0)!=256){dh(a+b|0);a=a+1|0;continue}break}break a}cc(c+8|0,b,256);sd(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function qU(a,b,c,d,e,f){x[a+40>>2]=0;x[a+44>>2]=0;C[a+32>>3]=f;C[a+24>>3]=e;C[a+16>>3]=d;C[a+8>>3]=c;C[a>>3]=b;x[a+48>>2]=0;x[a+52>>2]=0;x[a+56>>2]=0;x[a+60>>2]=0;a=a- -64|0;x[a>>2]=0;x[a+4>>2]=0}function ce(a,b){var c=0,d=0,e=0;d=z[a+24>>1];if((d|0)!=(b&65535)){c=z[a+22>>1]-1&127;w[a+22>>1]=c;e=z[a+20>>1];if(e>>>0<=127){w[a+20>>1]=e+1}c=(c<<2)+a|0;w[c+26>>1]=b-d;w[c+28>>1]=0;w[a+24>>1]=b}}function E_(a){var b=0,c=0,d=0;a:{if(jd(a,22281,11)){break a}b=63;while(1){d=(b|0)==215;if(d){break a}c=a+b|0;if(y[c+16|0]>3|y[c+17|0]>3){break a}b=b+19|0;if(y[c+18|0]<16){continue}break}}return d}function ws(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;if(b){d=Mc(a);e=Cb(x[a+4>>2],y[a+11|0]);if(d-e>>>0<b>>>0){bn(a,d,(b-d|0)+e|0,e,e,0,0)}d=Kb(a);am(d+e|0,b,c);b=b+e|0;lg(a,b);hd(b+d|0,0)}return a|0}function uj(a){var b=0;b=32767;a:{if(a>=E(32766.5)){break a}b=32768;if(a<=E(-32767.5)){break a}a=E(a+E(.5));b:{if(E(F(a))<E(2147483648)){b=~~a;break b}b=-2147483648}b=b+(b>>15)|0}return b<<16>>16}function tda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=fb-16|0;fb=d;e=x[a+4>>2];a=x[b+4>>2];b=x[b>>2];x[d+8>>2]=b;x[d+12>>2]=a;f=x[c>>2];c=x[c+4>>2];x[d>>2]=b;x[d+4>>2]=a;Nz(e,d,f,c,1);fb=d+16|0}function xV(a){var b=0,c=0;a:{b:{c=a&240;if((c|0)!=192){if((c|0)==240){break b}b=3;if((c|0)!=208){break a}}b=2;break a}a=a+15|0;b=1;if((a&255)>>>0>2){break a}b=131842>>>(a<<3&248)|0}return b&255}function wX(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;rX(c+8|0,b);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){sX(b)}return a}function m$(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;mw(c+8|0,b);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){fw(b)}return a}function jqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;if(uh(1073741823)>>>0<b>>>0){ed();p()}LF(c+8|0,b);b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;d=Ab(a),e=b+(x[c+12>>2]<<2)|0,x[d>>2]=e;fb=c+16|0}function ik(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;$k(c+8|0,b);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){al(b)}return a}function eP(a,b){var c=E(0),d=E(0);if(!((b|0)<0|z[a+480188>>1]<=b>>>0)){a=D(b,872)+a|0;c=E(E(y[a+1075834|0])*E(.0078125));d=E(c*c);c=E(E(y[a+1075835|0])*E(.0078125));c=E(M(E(d+E(c*c))))}return c}function dY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;a:{if(!On(b,a)|!c){break a}mh(d+8|0,a);a=0;while(1){if(a>>>0>=4){break a}b=x[d+8>>2];rg(xb(b,a),xb(b,a|1));a=a+2|0;continue}}fb=d+16|0}function dE(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;yr(c+8|0,b);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){q$(b)}return a}function aS(a){var b=0,c=0;a=a+906300|0;c=vk(a);while(1){if((a|0)!=(c|0)){b=x[a>>2];a:{if(!b){break a}if(!(ib[x[x[b>>2]+120>>2]](b)|0)){break a}ib[x[x[b>>2]+100>>2]](b)}a=a+160|0;continue}break}}function _F(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;$r(c+8|0,b);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){as(b)}return a}function SW(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;jx(c+8|0,b);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){kx(b)}return a}function O$(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;lw(c+8|0,b);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){oE(b)}return a}function NW(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;F_(c+8|0,b);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){G_(b)}return a}function LG(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;JG(c+8|0,b);d=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);e=x[c+4>>2];if((e|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;a=(d|0)==(e|0);if(!a){vx(b)}return a}function Jja(a,b){a=a|0;b=b|0;var c=0;b=fb-16|0;fb=b;c=-1;a:{if(!ik(a,b+8|0)){break a}c=0;if(!zR(x[b+8>>2],x[b+12>>2])){break a}c=-1;if(!fF(a,b+4|0)){break a}c=yR(x[b+4>>2])}fb=b+16|0;return c|0}function Cr(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;v[a+6|0]=0;v[a+7|0]=0;v[a+8|0]=0;v[a+9|0]=0;v[a+10|0]=0;v[a+11|0]=0;v[a+12|0]=0;v[a+13|0]=0;v[a+14|0]=0;v[a+15|0]=0}function u0(a,b){var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[a>>2],x[a+8>>2],512)){a=0;while(1){if((a|0)!=512){Dn(a+b|0);a=a+4|0;continue}break}break a}zE(c+8|0,b);sd(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function lm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;if(uh(1073741823)>>>0<b>>>0){ed();p()}Oj(c+8|0,b);b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;d=Ab(a),e=b+(x[c+12>>2]<<2)|0,x[d>>2]=e;fb=c+16|0}function gE(a,b){var c=0;c=fb-16|0;fb=c;x[c+12>>2]=1;x[c+8>>2]=a>>>4;b=Yb(128/(D(x[Xe(c+12|0,c+8|0)>>2],b)|0)|0,1,15);v[c+7|0]=1;v[c+6|0]=a&15;a=cf(c+7|0,c+6|0);fb=c+16|0;return y[a|0]|b<<4&240}function c1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;if(uh(214748364)>>>0<b>>>0){ed();p()}SE(c+8|0,b);b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;d=Ab(a),e=b+D(x[c+12>>2],20)|0,x[d>>2]=e;fb=c+16|0}function _ka(a){a=a|0;var b=0,c=0,d=0,e=0;b=fb-16|0;fb=b;if(uh(2147483647)>>>0<=2303){ed();p()}Zw(b+8|0,2304);c=x[b+8>>2];x[a+4>>2]=c;x[a>>2]=c;d=Ab(a),e=(x[b+12>>2]<<1)+c|0,x[d>>2]=e;fb=b+16|0}function Z9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;if(uh(357913941)>>>0<b>>>0){ed();p()}WG(c+8|0,b);b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;d=Ab(a),e=b+D(x[c+12>>2],12)|0,x[d>>2]=e;fb=c+16|0}function JC(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;if(uh(2147483647)>>>0<b>>>0){ed();p()}Zw(c+8|0,b);b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;d=Ab(a),e=b+(x[c+12>>2]<<1)|0,x[d>>2]=e;fb=c+16|0}function Aia(a,b,c){a=a|0;b=b|0;c=E(c);var d=0,e=0,f=E(0);d=fb-16|0;fb=d;e=d,f=E(E(ib[x[x[a>>2]+48>>2]](a,b))+c),B[e+12>>2]=f;HT(d+12|0,E(0),E(1));ib[x[x[a>>2]+44>>2]](a,b,B[d+12>>2]);fb=d+16|0}function wL(a){var b=0,c=0,d=0;d=x[a>>2];while(1){c=v[d|0];if(Nh(c)){d=d+1|0;x[a>>2]=d;if(b>>>0<=214748364){c=c-48|0;b=D(b,10);b=(c|0)>(b^2147483647)?-1:c+b|0}else{b=-1}continue}break}return b}function oU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;if(uh(536870911)>>>0<b>>>0){ed();p()}sG(c+8|0,b);b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;d=Ab(a),e=b+(x[c+12>>2]<<3)|0,x[d>>2]=e;fb=c+16|0}function nU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;if(uh(268435455)>>>0<b>>>0){ed();p()}TV(c+8|0,b);b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;d=Ab(a),e=b+(x[c+12>>2]<<4)|0,x[d>>2]=e;fb=c+16|0}function Zp(a,b,c){var d=0;d=fb-16|0;fb=d;if(y[b|0]){x[d+8>>2]=0;x[d+12>>2]=0;b=py(d+4|0,b,Df(b),d+8|0,c);if(b>>>0<=4294967293){x[a>>2]=x[d+4>>2]}a=b>>>0<4294967294}else{a=0}fb=d+16|0;return a}function YL(a,b){var c=0,d=0,e=0,f=E(0),g=E(0),h=0;b=(b|0)>0?b:0;h=a+2304|0;while(1){if((b|0)!=(d|0)){c=d<<2;e=c+a|0;f=B[e>>2];c=c+h|0;g=B[c>>2];B[e>>2]=f+g;B[c>>2]=f-g;d=d+1|0;continue}break}}function SS(a,b,c){var d=0,e=0;d=fb-16|0;fb=d;a=fs(d+4|0,a,b);b=x[a+4>>2];e=x[a+8>>2];while(1){if((b|0)==(e|0)){kc(a);fb=d+16|0}else{RS(b,x[c>>2],x[c+4>>2]);b=b+8|0;x[a+4>>2]=b;continue}break}}function IZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=fb-16|0;fb=d;ng(a,d+14|0);e=z[d+14>>1];gS(b,e);c=0;while(1){if((c|0)==(e|0)){QA(b);fb=d+16|0}else{Hk(a,yb(x[b>>2],c));c=c+1|0;continue}break}}function FZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;if(uh(715827882)>>>0<b>>>0){ed();p()}pZ(c+8|0,b);b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;d=Ab(a),e=b+D(x[c+12>>2],6)|0,x[d>>2]=e;fb=c+16|0}function maa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=fb-16|0;fb=e;f=x[d+4>>2];g=x[d>>2];x[e+8>>2]=g;x[e+12>>2]=f;d=x[x[b>>2]+40>>2];x[e>>2]=g;x[e+4>>2]=f;ib[d|0](a,b,c,e);fb=e+16|0}function bka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=fb-16|0;fb=d;e=z[a+28>>1];w[d+12>>1]=e;f=d,g=(oc(x[a+4>>2],x[a+8>>2])+e|0)-1|0,w[f+14>>1]=g;a=aR(a,b,c,d+12|0);fb=d+16|0;return a|0}function OA(a,b){var c=0;a=qW(a,b);v[a+12|0]=y[b+12|0];c=y[b+13|0]|y[b+14|0]<<8|(y[b+15|0]<<16|y[b+16|0]<<24);v[a+13|0]=c;v[a+14|0]=c>>>8;v[a+15|0]=c>>>16;v[a+16|0]=c>>>24;v[a+17|0]=y[b+17|0]}function lc(a,b,c,d,e){var f=0;f=fb-32|0;fb=f;lf(f+16|0,d,e);d=x[x[b>>2]+28>>2];e=x[f+20>>2];x[f+8>>2]=x[f+16>>2];x[f+12>>2]=e;ib[d|0](f+24|0,b,c,f+8|0);lf(a,x[f+24>>2],x[f+28>>2]);fb=f+32|0}function gk(a,b){var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=b;d=b;b=uh(2147483647);if(d>>>0<=b>>>0){a=In(a);if(a>>>0<b>>>1>>>0){x[c+8>>2]=a<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;return b}ed();p()}function cJ(a){a=a|0;var b=0,c=0,d=0;x[a>>2]=95212;d=a+8|0;while(1){b=x[a+8>>2];if(oc(b,x[a+12>>2])>>>0>c>>>0){b=x[yb(b,c)>>2];if(b){vm(b)}c=c+1|0;continue}break}tb(a+152|0);oy(d);return a|0}function Mf(a,b){var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=b;d=b;b=uh(1073741823);if(d>>>0<=b>>>0){a=Vg(a);if(a>>>0<b>>>1>>>0){x[c+8>>2]=a<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;return b}ed();p()}function Fj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;a:{d=Rl(a,b);if((d|0)==255){break a}zk(a,b);Oq(a,b,0,0);if(!c){break a}e=bc(a+26|0,d),f=65535,w[e>>1]=f;a=xb(a+62|0,b);v[a|0]=y[a|0]|128}}function tD(a,b){var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=b;d=b;b=uh(715827882);if(d>>>0<=b>>>0){a=hw(a);if(a>>>0<b>>>1>>>0){x[c+8>>2]=a<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;return b}ed();p()}function pG(a,b){var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=b;d=b;b=uh(119304647);if(d>>>0<=b>>>0){a=hx(a);if(a>>>0<b>>>1>>>0){x[c+8>>2]=a<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;return b}ed();p()}function is(a,b){var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=b;d=b;b=uh(536870911);if(d>>>0<=b>>>0){a=Tn(a);if(a>>>0<b>>>1>>>0){x[c+8>>2]=a<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;return b}ed();p()}function cN(){var a=0,b=0,c=0,d=0;a=fb-16|0;fb=a;b=Ec(1298480);x[31609]=0;c=R(1127,b|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){b=yf(a+12|0,c);fb=a+16|0;return x[b>>2]}a=N()|0;Db(b);Q(a|0);p()}function Vq(a,b){var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=b;d=b;b=uh(134217727);if(d>>>0<=b>>>0){a=Yo(a);if(a>>>0<b>>>1>>>0){x[c+8>>2]=a<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;return b}ed();p()}function VV(a,b){var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=b;d=b;b=uh(268435455);if(d>>>0<=b>>>0){a=kv(a);if(a>>>0<b>>>1>>>0){x[c+8>>2]=a<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;return b}ed();p()}function VD(a,b){var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=b;d=b;b=uh(214748364);if(d>>>0<=b>>>0){a=UE(a);if(a>>>0<b>>>1>>>0){x[c+8>>2]=a<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;return b}ed();p()}function Pp(a,b){var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=b;d=b;b=uh(357913941);if(d>>>0<=b>>>0){a=dl(a);if(a>>>0<b>>>1>>>0){x[c+8>>2]=a<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;return b}ed();p()}function OJ(a,b){var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=b;d=b;b=uh(178956970);if(d>>>0<=b>>>0){a=it(a);if(a>>>0<b>>>1>>>0){x[c+8>>2]=a<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;return b}ed();p()}function JD(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;d=c,e=(kq(b)+-4.8737671609324025)*(a&32768?28.85390081777927:34.624680981335125),C[d+8>>3]=e;IT(c+8|0,127);a=_l(C[c+8>>3]);fb=c+16|0;return a}function zu(a){var b=0;x[31609]=0;a=R(852,a|0)|0;b=x[31609];x[31609]=0;a:{if((b|0)==1){Y(T(0)|0)|0;x[31609]=0;X(26);b=x[31609];x[31609]=0;a=0;if((b|0)==1){break a}}return a}T(0)|0;Sb();p()}function t$(a,b){var c=0,d=0;c=fb-16|0;fb=c;lw(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function o$(a,b){var c=0,d=0;c=fb-16|0;fb=c;mw(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function n$(a,b){var c=0,d=0;c=fb-16|0;fb=c;yr(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function lx(a,b){var c=0,d=0;c=fb-16|0;fb=c;jx(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function kR(a,b){var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=b;d=b;b=uh(82595524);if(d>>>0<=b>>>0){a=Du(a);if(a>>>0<b>>>1>>>0){x[c+8>>2]=a<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;return b}ed();p()}function jZ(a,b){var c=0,d=0;c=fb-16|0;fb=c;iZ(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function iG(a,b){var c=0,d=0;c=fb-16|0;fb=c;JG(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function gA(a,b){var c=0,d=0;d=fb-32|0;fb=d;c=Ab(a);c=Zf(d+12|0,Mf(a,oc(x[a>>2],x[a+4>>2])+1|0),oc(x[a>>2],x[a+4>>2]),c);uq(x[c+8>>2],x[b>>2]);x[c+8>>2]=x[c+8>>2]+4;Tm(a,c);Yf(c);fb=d+32|0}function eh(a,b){var c=0,d=0;c=fb-16|0;fb=c;Tr(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function aG(a,b){var c=0,d=0;c=fb-16|0;fb=c;$r(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function YW(a){var b=0,c=0,d=0;c=y[a+32|0]|y[a+33|0]<<8;b=y[a+36|0]|y[a+37|0]<<8;a=y[a+34|0]|y[a+35|0]<<8;b=b+a|0;a=(a>>>0>b>>>0|d)<<1|b>>>31;b=b<<1;c=b+c|0;hb=b>>>0>c>>>0?a+1|0:a;return c}function RC(a,b){var c=0,d=0;c=fb-16|0;fb=c;WC(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function On(a,b){var c=0,d=0;c=fb-16|0;fb=c;mh(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function Kx(a,b,c){var d=0;d=fb-16|0;fb=d;cc(d+8|0,b,c);b=x[d+12>>2];lc(d,x[a>>2],x[a+8>>2],x[d+8>>2],x[d+12>>2]);c=x[d+4>>2];if((b|0)==(c|0)){Vb(a,x[d+12>>2])}fb=d+16|0;return(b|0)==(c|0)}function K0(a,b){var c=0,d=0;c=fb-16|0;fb=c;J0(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function Jw(a){var b=0;b=x[a+72>>2];x[a+72>>2]=b-1|b;b=x[a>>2];if(b&8){x[a>>2]=b|32;return-1}x[a+4>>2]=0;x[a+8>>2]=0;b=x[a+44>>2];x[a+28>>2]=b;x[a+20>>2]=b;x[a+16>>2]=b+x[a+48>>2];return 0}function F$(a,b){var c=0,d=0;c=fb-16|0;fb=c;fE(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function EV(a){var b=0,c=0,d=0;c=y[a+64|0]|y[a+65|0]<<8;b=y[a+72|0]|y[a+73|0]<<8;a=y[a+70|0]|y[a+71|0]<<8;b=b+a|0;a=(a>>>0>b>>>0|d)<<2|b>>>30;b=b<<2;c=b+c|0;hb=b>>>0>c>>>0?a+1|0:a;return c}function DB(a,b,c,d){var e=0,f=0,g=0;e=c-b|0;a:{if((e|0)<=9){g=e;e=D(32-G(d|1)|0,1233)>>>12|0;f=61;if((g|0)<(e+(A[(e<<2)+121088>>2]<=d>>>0)|0)){break a}}c=zB(b,d);f=0}x[a+4>>2]=f;x[a>>2]=c}function Cp(a,b){var c=0,d=0;c=fb-16|0;fb=c;Bp(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function CI(a,b,c,d){a:{if(!a){break a}b:{switch(b+2|0){case 0:v[a|0]=c;return;case 1:w[a>>1]=c;return;case 2:case 3:x[a>>2]=c;return;case 5:break b;default:break a}}x[a>>2]=c;x[a+4>>2]=d}}function BX(a,b){var c=0,d=0;c=fb-16|0;fb=c;gD(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function BE(a,b){var c=0,d=0;c=fb-16|0;fb=c;$j(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function AE(a,b){var c=0,d=0;c=fb-16|0;fb=c;Ir(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function $X(a,b){var c=0,d=0;c=fb-16|0;fb=c;Gv(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){Vb(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function zz(a,b,c,d,e,f,g,h,i){var j=0;j=fb-16|0;fb=j;Ug(j,b,c,d,e,f,g,h,i^-2147483648);d=x[j>>2];c=x[j+4>>2];b=x[j+12>>2];x[a+8>>2]=x[j+8>>2];x[a+12>>2]=b;x[a>>2]=d;x[a+4>>2]=c;fb=j+16|0}function gM(a,b){var c=0,d=0;d=fb-32|0;fb=d;c=Ab(a);c=qn(d+12|0,Wl(a,Xc(x[a>>2],x[a+4>>2])+1|0),Xc(x[a>>2],x[a+4>>2]),c);po(x[c+8>>2],y[b|0]);x[c+8>>2]=x[c+8>>2]+1;cr(a,c);pn(c);fb=d+32|0}function WU(a){a=a|0;var b=0,c=0;b=fb-32|0;fb=b;v[a+16|0]=0;c=cC(b,x[a+12>>2]);x[31609]=0;O(783,a|0,c|0);a=x[31609];x[31609]=0;if((a|0)!=1){Bk(c);fb=b+32|0;return}a=N()|0;Bk(c);Q(a|0);p()}function Tf(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb+-64|0;fb=c;d=rA(c+12|0,a);x[31609]=0;S(199,a|0,b|0,d|0);a=x[31609];x[31609]=0;if((a|0)!=1){wk(d);fb=c- -64|0;return}a=N()|0;wk(d);Q(a|0);p()}function zg(a,b){var c=0,d=0;c=fb-16|0;fb=c;x[c+8>>2]=x[b+8>>2];d=x[b+4>>2];x[c>>2]=x[b>>2];x[c+4>>2]=d;b=x[c+4>>2];x[a>>2]=x[c>>2];x[a+4>>2]=b;x[a+8>>2]=x[c+8>>2];v[a+12|0]=0;fb=c+16|0}function zZ(a,b,c,d){var e=0;e=fb-16|0;fb=e;x[e+12>>2]=b;x[e+8>>2]=d;c=UG(a,c,x[Hb(e+12|0,e+8|0)>>2]);a:{if(c){break a}c=0;if((b|0)==(d|0)){break a}c=b>>>0<d>>>0?-1:1}fb=e+16|0;return c}function w_(a,b,c,d){var e=0;e=fb-16|0;fb=e;x[e+12>>2]=b;x[e+8>>2]=d;c=nt(a,c,x[Hb(e+12|0,e+8|0)>>2]);a:{if(c){break a}c=0;if((b|0)==(d|0)){break a}c=b>>>0<d>>>0?-1:1}fb=e+16|0;return c}function ji(a,b){var c=0,d=0;c=y[a|0];d=y[b|0];a:{if(!c|(d|0)!=(c|0)){break a}while(1){d=y[b+1|0];c=y[a+1|0];if(!c){break a}b=b+1|0;a=a+1|0;if((c|0)==(d|0)){continue}break}}return c-d|0}function Z3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=x[a+84>>2];d=c+256|0;f=Mz(e,0,d);d=f?f-e|0:d;c=c>>>0>d>>>0?d:c;zc(b,e,c);b=e+d|0;x[a+84>>2]=b;x[a+8>>2]=b;x[a+4>>2]=c+e;return c|0}function Xfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=fb-16|0;fb=f;x[f+8>>2]=x[a+8>>2];g=x[a+4>>2];x[f>>2]=x[a>>2];x[f+4>>2]=g;a=wP(f,b,c,d,0,0,0,0,e);fb=f+16|0;return a|0}function Hk(a,b){var c=0,d=0;c=fb-32|0;fb=c;x[c+28>>2]=0;cy(c+8|0,c+28|0);d=c+20|0;Om(d,a,x[c+8>>2],x[c+12>>2]);a=x[c+24>>2];Mm(d,x[c+28>>2]);x[b>>2]=x[c+20>>2];fb=c+32|0;return(a|0)==4}function to(a){var b=0,c=0;b=fb-16|0;fb=b;a:{if(!UM(y[a+20|0])){x[31609]=0;O(1134,b+15|0,a|0);c=x[31609];x[31609]=0;if((c|0)==1){break a}}v[a+20|0]=255;fb=b+16|0;return}T(0)|0;Sb();p()}function Zra(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;d=Mb(x[a>>2],x[a+8>>2],12);a:{if(!d){v[c|0]=0;Uh(b,12,c);break a}yr(c+8|0,b);sd(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0;return d|0}function Yt(a){var b=0,c=0,d=0;c=1;while(1){if(c){c=0;b=x[a+4>>2];d=((b<<2)+(Tw(x[a>>2],1)^270549120)|0)+2019860093|0;x[a>>2]=d;b=b+D(Tw(d,16),5)|0;x[a+4>>2]=b;continue}break}return b}function YG(a,b){var c=0,d=0;d=fb-32|0;fb=d;c=Ab(a);c=zm(d+12|0,Pp(a,Ud(x[a>>2],x[a+4>>2])+1|0),Ud(x[a>>2],x[a+4>>2]),c);vs(x[c+8>>2],b);x[c+8>>2]=x[c+8>>2]+12;Bx(a,c);us(c);fb=d+32|0}function sp(a,b,c){var d=0,e=0;d=fb-16|0;fb=d;a=dj(d+4|0,a,b);b=x[a+4>>2];e=x[a+8>>2];while(1){if((b|0)==(e|0)){kc(a);fb=d+16|0}else{nm(b,z[c>>1]);b=b+2|0;x[a+4>>2]=b;continue}break}}function oA(a,b,c){var d=0,e=0;d=fb-16|0;fb=d;a=xh(d+4|0,a,b);b=x[a+4>>2];e=x[a+8>>2];while(1){if((b|0)==(e|0)){kc(a);fb=d+16|0}else{uk(b,B[c>>2]);b=b+4|0;x[a+4>>2]=b;continue}break}}function YE(a,b,c){var d=0,e=0;d=fb-16|0;fb=d;a=xh(d+4|0,a,b);b=x[a+4>>2];e=x[a+8>>2];while(1){if((b|0)==(e|0)){kc(a);fb=d+16|0}else{uq(b,x[c>>2]);b=b+4|0;x[a+4>>2]=b;continue}break}}function Wl(a,b){var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=b;d=b;b=uh(-1);if(d>>>0<=b>>>0){a=$o(a);if(a>>>0<b>>>1>>>0){x[c+8>>2]=a<<1;b=x[bd(c+8|0,c+12|0)>>2]}fb=c+16|0;return b}ed();p()}function Vh(a,b){var c=0;b=Vc(b);c=x[a+8>>2];if(oc(c,x[a+12>>2])>>>0>b>>>0){a=x[yb(c,b)>>2]!=0}else{a=0}if(!a){a=Ej(ac(4));x[a>>2]=124996;da(a|0,125132,1229);p()}return x[yb(c,b)>>2]}function Ml(a){var b=0;a=ni(a);b=2147483647;a:{if(a>=E(2147483648)){break a}b=-2147483648;if(a<=E(-2147483648)){break a}b=~~a;if(E(F(a))<E(2147483648)){break a}b=-2147483648}return b}function MP(a){var b=0,c=0;if(!a){return 1}if((a|0)>=-99999){b=+(a|0)*3.321928094887362/2e3;c=b+.5;a:{if(F(c)<2147483648){a=~~c;break a}a=-2147483648}b=zi(b-+(a|0))}else{b=0}return b}function J7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=a;h=b;a=ib[x[x[a+8>>2]+20>>2]](a+8|0)|0;b=Kb(a);return rk(g,h,c,d,e,f,b,b+(Cb(x[a+4>>2],y[a+11|0])<<2)|0)|0}function zp(a,b,c){var d=0,e=0;d=fb-16|0;fb=d;a=Xo(d+4|0,a,b);b=x[a+4>>2];e=x[a+8>>2];while(1){if((b|0)==(e|0)){kc(a);fb=d+16|0}else{po(b,y[c|0]);b=b+1|0;x[a+4>>2]=b;continue}break}}function csa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;fZ(b,c);c=Mb(x[a>>2],x[a+8>>2],c<<2);if(c){eZ(d+8|0,x[b>>2],x[b+4>>2]);sd(d,a,x[d+8>>2],x[d+12>>2])}fb=d+16|0;return c|0}function coa(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;d=Mb(x[a>>2],x[a+8>>2],4);a:{if(!d){v[c|0]=0;j$(b,4,c);break a}mh(c+8|0,b);sd(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0;return d|0}function Vr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;if((b|0)<0){ed();p()}LF(c+8|0,(b-1>>>5|0)+1|0);b=x[c+8>>2];x[a+4>>2]=0;x[a>>2]=b;d=Ab(a),e=x[c+12>>2],x[d>>2]=e;fb=c+16|0}function Lm(a,b){x[a+28>>2]=0;w[a+24>>1]=65535;x[a+16>>2]=0;x[a+20>>2]=0;x[a+4>>2]=0;x[a+8>>2]=0;v[a|0]=0;x[a+32>>2]=11;x[a+36>>2]=b;Nb(a+40|0);Nb(a+52|0);Rb(a- -64|0,0,48);return a}function IP(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var f=0,g=0;f=fb-16|0;fb=f;x[f+8>>2]=x[a+8>>2];g=x[a+4>>2];x[f>>2]=x[a>>2];x[f+4>>2]=g;c=HP(f,b,c,d,e,0,0,0,0);fb=f+16|0;return+c}function u2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;uG(b,c);c=Mb(x[a>>2],x[a+8>>2],c<<3);if(c){tG(d+8|0,x[b>>2],x[b+4>>2]);sd(d,a,x[d+8>>2],x[d+12>>2])}fb=d+16|0;return c|0}function j2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;x[d+12>>2]=c;c=0;a=ib[x[x[a>>2]+24>>2]](a)|0;if(a>>>0>b>>>0){x[d+8>>2]=a-b;c=x[Hb(d+12|0,d+8|0)>>2]}fb=d+16|0;return c|0}function Zt(a){var b=0,c=0,d=0;b=fb-16|0;fb=b;x[b+12>>2]=12;while(1){x[b+8>>2]=32;if(A[Hb(b+12|0,b+8|0)>>2]<=c>>>0){fb=b+16|0;a=d&4095}else{c=c+15|0;d=Co(a);continue}break}return a}function Wk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;if(uh(-1)>>>0<b>>>0){ed();p()}qg(c+8|0,b);b=x[c+8>>2];x[a+4>>2]=b;x[a>>2]=b;d=Ab(a),e=b+x[c+12>>2]|0,x[d>>2]=e;fb=c+16|0}function LB(a){var b=0,c=0;b=x[a>>2];c=x[b>>2];a:{if(!c){while(1){c=Th(b);b=x[b+8>>2];if(c){continue}break}break a}while(1){b=c;c=x[b+4>>2];if(c){continue}break}}x[a>>2]=b;return a}function Hu(a,b){var c=0;a=DS(a);x[a>>2]=x[b>>2];x[a+4>>2]=x[b+4>>2];x[a+8>>2]=x[b+8>>2];x[a+12>>2]=x[b+12>>2];x[a+16>>2]=x[b+16>>2];c=x[b+28>>2];x[a+24>>2]=x[b+24>>2];x[a+28>>2]=c}function yT(a,b,c,d){a:{if((a|0)!=67108864){break a}a=D(d,872)+c|0;x[a+704>>2]=x[a+704>>2]&-129;a=d^1;if(a>>>0>=(b&65535)>>>0){break a}a=D(a,872)+c|0;x[a+704>>2]=x[a+704>>2]&-129}}function t2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=!b|(b>>>0>d>>>0|a>>>0>=d>>>0|d-a>>>0<b>>>0);a:{if(d){break a}a=a+b|0;if(Xc(x[c>>2],x[c+4>>2])>>>0>=a>>>0){break a}Kk(c,a)}return!d|0}function foa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;pW(b,c);if(Mb(x[a>>2],x[a+8>>2],c<<8)){c=x[b>>2];cc(d+8|0,c,Sh(c,x[b+4>>2])<<8);sd(d,a,x[d+8>>2],x[d+12>>2])}fb=d+16|0}function sD(a,b){var c=0;c=y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24);v[a|0]=c;v[a+1|0]=c>>>8;v[a+2|0]=c>>>16;v[a+3|0]=c>>>24;b=y[b+4|0]|y[b+5|0]<<8;v[a+4|0]=b;v[a+5|0]=b>>>8}function Zz(a){var b=0,c=0,d=0;C[a+4272>>3]=C[a+4280>>3];c=a;d=a+4296|0;a=0;while(1){if(a>>>0<32){a=a+15|0;b=Co(d)|b<<15;continue}break}C[c+4280>>3]=+(b|0)*-4.656612873077393e-10}function PR(a){var b=0,c=0,d=0;b=fb-16|0;fb=b;while(1){x[b+12>>2]=7;x[b+8>>2]=32;if(A[Hb(b+12|0,b+8|0)>>2]<=c>>>0){fb=b+16|0;a=d&127}else{c=c+15|0;d=Co(a);continue}break}return a}function Kh(a,b,c){a:{if(b>>>0<=c>>>0){a=ac(8);x[31609]=0;b=R(188,a|0)|0;c=x[31609];x[31609]=0;if((c|0)!=1){break a}b=N()|0;ic(a);Q(b|0);p()}return y[a+c|0]}da(b|0,24472,162);p()}function Aoa(a,b){a=a|0;b=b|0;var c=0,d=0;b=fb-16|0;fb=b;d=b+8|0;c=-1;a:{if(!ik(a,d)){break a}c=0;if(!rW(d)){break a}c=-1;if(!jh(a,4)){break a}c=QW(a)>>>31|0}fb=b+16|0;return c|0}function yj(a){var b=0,c=0;b=x[a+20>>2];b=Jn(y[b+28|0]|y[b+29|0]<<8|(y[b+30|0]<<16|y[b+31|0]<<24));if(!(b>>>0>249|y[a+4200|0]>=b>>>0)){c=x[$d(x[a+16>>2]+906300|0,b)>>2]}return c}function sA(a,b,c,d){var e=0,f=0;e=fb-16|0;fb=e;d=Br(e+4|0,a,d);f=x[d+4>>2];a=fb-16|0;fb=a;fd(a+8|0,b,c);b=vu(f,pR(x[a+8>>2],x[a+12>>2],f));fb=a+16|0;x[d+4>>2]=b;kc(d);fb=e+16|0}function ep(a){var b=0,c=0;b=x[31366];c=a+7&-8;a=b+c|0;a:{if(!(a>>>0<=b>>>0?c:0)){if(a>>>0<=jb()<<16>>>0){break a}if(eb(a|0)|0){break a}}x[31484]=48;return-1}x[31366]=a;return b}function _5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((b|0)!=(c|0)){a=x[b>>2];if(a>>>0<=127){a=x[(a<<2)+95344>>2]}else{a=0}x[d>>2]=a;d=d+4|0;b=b+4|0;continue}break}return c|0}function Ul(a,b){var c=0,d=0,e=0;x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);x[a>>2]=x[b>>2];x[a+4>>2]=x[b+4>>2];c=Ab(b);d=Ab(a),e=x[c>>2],x[d>>2]=e;x[c>>2]=0;x[b>>2]=0;x[b+4>>2]=0;return a}function Qra(a,b){a=a|0;b=b|0;var c=0;c=fb-32|0;fb=c;x[c+24>>2]=0;x[c+28>>2]=0;x[c+16>>2]=0;x[c+20>>2]=0;x[c+8>>2]=0;x[c+12>>2]=0;x[c>>2]=0;x[c+4>>2]=0;HZ(b,c);GZ(a,c);fb=c+32|0}function P7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=a;h=b;a=ib[x[x[a+8>>2]+20>>2]](a+8|0)|0;b=Kb(a);return sk(g,h,c,d,e,f,b,Cb(x[a+4>>2],y[a+11|0])+b|0)|0}function Aga(a,b,c){a=a|0;b=b|0;c=E(c);var d=0,e=0,f=E(0);if(b>>>0<=12){c=Pd(c,E(0));d=a+4208|0;if((b|0)==12){c=E(ni(E(c*E(3)))/E(3));b=12}e=yb(d,b),f=c,B[e>>2]=f;v[a+5046|0]=1}}function $T(a,b,c,d){var e=0,f=0;e=fb-16|0;fb=e;while(1){if(c){f=Pl(z[c+16>>1],x[c+20>>2],a,b);d=f?d:c;c=x[(f?c+4|0:c)>>2];continue}break}a=vb(e+12|0,d);fb=e+16|0;return x[a>>2]}function xD(a,b,c){var d=0,e=0;d=fb-16|0;fb=d;a=Br(d+4|0,a,b);b=x[a+4>>2];e=x[a+8>>2];while(1){if((b|0)==(e|0)){kc(a);fb=d+16|0}else{sD(b,c);b=b+6|0;x[a+4>>2]=b;continue}break}}function raa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;x[d+12>>2]=c;pz(a,b,c);c=0;a=x[a+16>>2];if(a>>>0>b>>>0){x[d+8>>2]=a-b;c=x[Hb(d+8|0,d+12|0)>>2]}fb=d+16|0;return c|0}function k3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=fb-16|0;fb=e;a=x[a+4>>2];f=x[b+4>>2];b=x[b>>2];x[e>>2]=b;x[e+4>>2]=f;x[e+8>>2]=b;x[e+12>>2]=f;Oz(a,e,c,d,1);fb=e+16|0}function Qia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=fb-16|0;fb=e;f=x[c>>2];if(f>>>0<Xc(a,b)>>>0){a=sl(e+4|0,xb(a,f),z[c+20>>1]);g=Jy(d,a);Eb(a)}fb=e+16|0;return g|0}function sq(a){var b=0;b=x[a+24>>2];x[31609]=0;W(853,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){Td(a+68|0);nf(a+36|0);Bl(a+32|0);wh(a+24|0);vh(a+4|0);return Wc(a)}T(0)|0;Sb();p()}function l3(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;a=x[a+4>>2];d=x[b>>2];b=x[b+4>>2];x[c>>2]=d;x[c+4>>2]=b;x[c+8>>2]=d;x[c+12>>2]=b;a=oP(a,c,1);fb=c+16|0;gb=hb;return a|0}function kta(a,b){a=a|0;b=b|0;if(!n$(a,b)){v[b|0]=0;v[b+1|0]=0;v[b+2|0]=0;v[b+3|0]=0;v[b+4|0]=0;v[b+5|0]=0;v[b+6|0]=0;v[b+7|0]=0;v[b+8|0]=0;v[b+9|0]=0;v[b+10|0]=0;v[b+11|0]=0}}function kY(a){var b=0,c=0,d=0;b=x[a>>2];if(x[b>>2]){d=x[b>>2];c=x[b+4>>2];while(1){if((c|0)!=(d|0)){c=c-24|0;ub(c);continue}break}x[b+4>>2]=d;a=x[a>>2];b=x[a>>2];it(a);Db(b)}}function gN(a){var b=0,c=0,d=0;b=x[a>>2];if(x[b>>2]){d=x[b>>2];c=x[b+4>>2];while(1){if((c|0)!=(d|0)){c=c-16|0;Qj(c);continue}break}x[b+4>>2]=d;a=x[a>>2];b=x[a>>2];kv(a);Db(b)}}function LH(a){var b=0,c=0,d=0;b=x[a>>2];if(x[b>>2]){d=x[b>>2];c=x[b+4>>2];while(1){if((c|0)!=(d|0)){c=c-12|0;Eb(c);continue}break}x[b+4>>2]=d;a=x[a>>2];b=x[a>>2];dl(a);Db(b)}}function Tia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;x[d+12>>2]=b;while(1){if(Ib(b,c)){x[d+8>>2]=x[b>>2];xA(a,d+8|0);b=x[We(d+12|0)>>2];continue}else{fb=d+16|0}break}}function FN(a,b,c){var d=0;d=fb-32|0;fb=d;x[d+28>>2]=c;x[d+24>>2]=0;x[d+12>>2]=4;c=d+16|0;rz(c,a,d+24|0,x[Hb(d+28|0,d+12|0)>>2]);Mm(c,x[d+24>>2]);x[b>>2]=x[d+16>>2];fb=d+32|0}function pc(a,b){a=a|0;b=b|0;var c=0;a=Ej(a);x[a+4>>2]=0;x[a>>2]=47568;c=Gd(_c(x[b+4>>2],y[b+11|0])+1|0);x[a+4>>2]=c;if(c){zc(c,Kb(b),_c(x[b+4>>2],y[b+11|0])+1|0)}return a|0}function A4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;while(1){if((b|0)!=(c|0)){f=dy(x[b>>2],x[a+8>>2]);v[e|0]=(f|0)==-1?d:f;e=e+1|0;b=b+4|0;continue}break}return c|0}function yw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;Kk(b,c);if(Mb(x[a>>2],x[a+8>>2],c)){c=x[b>>2];cc(d+8|0,c,Xc(c,x[b+4>>2]));sd(d,a,x[d+8>>2],x[d+12>>2])}fb=d+16|0}function wd(a,b){var c=0,d=0,e=0;a:{c=OC(b);d=tn(a);if(c>>>0<=d>>>0){b=XC(Kb(a),b,c);lg(a,c);yd((c<<2)+b|0,0);break a}e=a;a=Cb(x[a+4>>2],y[a+11|0]);rI(e,d,c-d|0,a,0,a,c,b)}}function oca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;a=x[a+4>>2];d=x[b+4>>2];b=x[b>>2];x[c>>2]=b;x[c+4>>2]=d;x[c+8>>2]=b;x[c+12>>2]=d;e=pP(a,c,1);fb=c+16|0;return+e}function oD(a,b){var c=0,d=0;c=fb-16|0;fb=c;a=xh(c+4|0,a,b);b=x[a+4>>2];d=x[a+8>>2];while(1){if((b|0)==(d|0)){kc(a);fb=c+16|0}else{Dn(b);b=b+4|0;x[a+4>>2]=b;continue}break}}function fY(a,b){var c=0,d=0;c=fb-16|0;fb=c;Gv(c+8|0,b);b=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function b7(a){a=a|0;var b=0,c=0,d=0;b=fb-16|0;fb=b;c=rh(b+12|0,x[a+8>>2]);d=LK(0,0,4);qh(c);fb=b+16|0;if(d){a=-1}else{a=x[a+8>>2];if(!a){return 1}a=(MJ(a)|0)==1}return a|0}function aF(a,b){var c=0,d=0;c=fb-16|0;fb=c;mh(c+8|0,b);b=x[c+12>>2];qd(c,a,x[c+8>>2],x[c+12>>2]);d=x[c+4>>2];if((b|0)==(d|0)){id(a,x[c+12>>2])}fb=c+16|0;return(b|0)==(d|0)}function Uq(a,b){var c=0,d=0;c=fb-16|0;fb=c;a=xh(c+4|0,a,b);b=x[a+4>>2];d=x[a+8>>2];while(1){if((b|0)==(d|0)){kc(a);fb=c+16|0}else{CV(b);b=b+4|0;x[a+4>>2]=b;continue}break}}function RE(a,b){var c=0,d=0;c=fb-16|0;fb=c;a=dj(c+4|0,a,b);b=x[a+4>>2];d=x[a+8>>2];while(1){if((b|0)==(d|0)){kc(a);fb=c+16|0}else{_w(b);b=b+2|0;x[a+4>>2]=b;continue}break}}function Qg(a,b,c,d){var e=0;a=((b|0)/8|0)+a|0;e=Kh(x[d>>2],x[d+4>>2],a);return((Kh(x[d>>2],x[d+4>>2],a+1|0)<<8|e<<16|Kh(x[d>>2],x[d+4>>2],a+2|0))<<(b&7)&16777215)>>>24-c|0}function QX(a,b){var c=0,d=0;c=fb-16|0;fb=c;a=Xo(c+4|0,a,b);b=x[a+4>>2];d=x[a+8>>2];while(1){if((b|0)==(d|0)){kc(a);fb=c+16|0}else{tX(b);b=b+1|0;x[a+4>>2]=b;continue}break}}function Hz(a,b){var c=0,d=0;if(b>>>0<2147483632){if(Ok(b)){x[a>>2]=0;x[a+4>>2]=0;x[a+8>>2]=0;Ne(a,b);return a}c=Fh(b)+1|0;d=Ec(c);of(a,c);yd(a,d);Bd(a,b);return a}pf();p()}function zn(a,b,c,d){var e=0,f=0;e=fb-16|0;fb=e;d=Xo(e+4|0,a,d);f=x[d+4>>2];a=fb-16|0;fb=a;fd(a+8|0,b,c);b=Y_(x[a+8>>2],x[a+12>>2],f);fb=a+16|0;x[d+4>>2]=b;kc(d);fb=e+16|0}function zY(a,b,c,d){var e=0,f=0;e=fb-16|0;fb=e;d=xh(e+4|0,a,d);f=x[d+4>>2];a=fb-16|0;fb=a;fd(a+8|0,b,c);b=yY(x[a+8>>2],x[a+12>>2],f);fb=a+16|0;x[d+4>>2]=b;kc(d);fb=e+16|0}function xq(a,b,c,d){var e=0,f=0;e=fb-16|0;fb=e;d=xh(e+4|0,a,d);f=x[d+4>>2];a=fb-16|0;fb=a;fd(a+8|0,b,c);b=tA(x[a+8>>2],x[a+12>>2],f);fb=a+16|0;x[d+4>>2]=b;kc(d);fb=e+16|0}function ii(a,b){a=a|0;b=b|0;var c=0;c=fb-32|0;fb=c;v[c+31|0]=0;vj(c+8|0,c+31|0);Om(c+20|0,a,x[c+8>>2],x[c+12>>2]);a=x[c+24>>2];v[b|0]=y[c+31|0];fb=c+32|0;return(a|0)==1|0}function dv(a,b,c,d){var e=0,f=0;e=fb-16|0;fb=e;d=dj(e+4|0,a,d);f=x[d+4>>2];a=fb-16|0;fb=a;fd(a+8|0,b,c);b=_U(x[a+8>>2],x[a+12>>2],f);fb=a+16|0;x[d+4>>2]=b;kc(d);fb=e+16|0}function U3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;ib[x[x[a>>2]+12>>2]](d+8|0,a,b);a=x[d+8>>2];b=x[c>>2];c=mc(x[d+12>>2],x[c+4>>2]);fb=d+16|0;return(a|0)==(b|0)&c}function TG(a){var b=0;a:{b:{if(a>>>0>=18285141){if(a>>>0>18350591){break b}b=1;if((a|0)!=18350080){break a}}return 0}b=0;if((a|0)==18350592){break a}b=(a&255)!=0}return b}function M_(a){var b=0;a:{if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=-28163770){break a}if(jd(a+44|0,18464,3)){break a}b=(y[a+47|0]|y[a+48|0]<<8)>>>0>97}return b}function sF(a,b,c){var d=0;d=fb-16|0;fb=d;a=Ap(d+4|0,a+8|0,b);b=x[a>>2];while(1){if((b|0)!=x[a+4>>2]){nm(b,z[c>>1]);b=x[a>>2]+2|0;x[a>>2]=b;continue}break}je(a);fb=d+16|0}function rf(a,b,c){var d=0,e=0,f=0;d=fb-16|0;fb=d;x[d+8>>2]=c;x[d+4>>2]=31;e=d,f=e0(b,c),x[e+12>>2]=f;c=b;b=vE(d+4|0);yk(c,c+b|0,a);e=xb(a,b),f=0,v[e|0]=f;g0(a);fb=d+16|0}function gka(){var a=0,b=0,c=0;a=fb-16|0;fb=a;b=Ec(1);x[31609]=0;X(58);c=x[31609];x[31609]=0;if((c|0)!=1){b=yf(a+12|0,b);fb=a+16|0;return x[b>>2]}a=N()|0;Db(b);Q(a|0);p()}function Y5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a:{while(1){if((c|0)==(d|0)){break a}a=x[c>>2];if(!(a>>>0>127|!(x[(a<<2)+95344>>2]&b))){c=c+4|0;continue}break}d=c}return d|0}function Pca(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;a=x[a+4>>2];d=x[b+4>>2];b=x[b>>2];x[c>>2]=b;x[c+4>>2]=d;x[c+8>>2]=b;x[c+12>>2]=d;a=qP(a,c,1);fb=c+16|0;return a|0}function Mta(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;$k(c+8|0,b);b=x[c+12>>2];lc(c,x[a>>2],x[a+8>>2],x[c+8>>2],x[c+12>>2]);if((b|0)==x[c+4>>2]){Vb(a,x[c+12>>2])}fb=c+16|0}function ng(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-32|0;fb=c;w[c+30>>1]=0;mk(c+8|0,c+30|0);d=c+20|0;Om(d,a,x[c+8>>2],x[c+12>>2]);bj(d,z[c+30>>1]);w[b>>1]=z[c+20>>1];fb=c+32|0}function lZ(a,b,c){var d=0;d=fb-16|0;fb=d;a=BC(d+4|0,a+8|0,b);b=x[a>>2];while(1){if((b|0)!=x[a+4>>2]){po(b,y[c|0]);b=x[a>>2]+1|0;x[a>>2]=b;continue}break}je(a);fb=d+16|0}function k2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=ib[x[x[a>>2]+24>>2]](a)|0;a:{if(!c){d=1;if((a|0)==(b|0)){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function Px(a,b,c,d,e){var f=0;a:{f=zu(4332);if(f){x[31609]=0;ha(e|0,f|0,a|0,b|0,c|0,d|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break a}}return f}a=N()|0;Db(f);Q(a|0);p()}function Fsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;a:{if(a){ib[x[x[a>>2]+8>>2]](a,b,c);break a}if((b|0)>=6){break a}kS(d,9169,10907,172,42);MG(d,b,c)}fb=d+16|0}function xA(a,b){a=a|0;b=b|0;var c=0;if(A[a+4>>2]<A[Ab(a)>>2]){c=fb-16|0;fb=c;a=xh(c+4|0,a,1);uq(x[a+4>>2],x[b>>2]);x[a+4>>2]=x[a+4>>2]+4;kc(a);fb=c+16|0;return}gA(a,b)}function uka(a,b){a=a|0;b=b|0;var c=0;a=og(a);c=Vi(x[b>>2]);b=Pf(b);x[31609]=0;S(847,a|0,c|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}b=N()|0;bT(a);Q(b|0);p()}function qT(a,b,c){var d=0;d=c&15;if(d){v[b+824|0]=d}c=c&240;if(c){v[b+823|0]=c>>>4}x[b+88>>2]=x[b+88>>2]|131072;if(!(!d|!Ob(a+1074312|0,80))){v[b+824|0]=y[b+824|0]<<2}}function Z5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){a:{if((c|0)!=(d|0)){a=x[c>>2];if(a>>>0>127|!(x[(a<<2)+95344>>2]&b)){break a}}else{c=d}return c|0}c=c+4|0;continue}}function PS(a,b){a=a|0;b=b|0;var c=0,d=0;c=Mc(a);d=Cb(x[a+4>>2],y[a+11|0]);if((c|0)==(d|0)){SB(a,c,1,c,c,0)}c=Kb(a);am(c+d|0,1,b);b=d+1|0;lg(a,b);hd(b+c|0,0);return a|0}function Im(a){a=a<<24|(a&65280)<<8|(a>>>8&65280|a>>>24);a=a>>>4&252645135|(a&252645135)<<4;a=a>>>2&858993459|(a&858993459)<<2;return a>>>1&1431655765|(a&1431655765)<<1}function DV(a,b,c,d){a=Zb(a,b,c);b=x[a+4>>2];a:{if((d|0)>=0){b=b+d|0;c=x[a>>2]+(b>>>3&536870908)|0;break a}b=b+d|0;c=x[a>>2]+((b-31|0)/32<<2)|0}x[a>>2]=c;x[a+4>>2]=b&31}function qda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=fb-16|0;fb=d;a=x[a+4>>2];e=x[b+4>>2];b=x[b>>2];x[d>>2]=b;x[d+4>>2]=e;x[d+8>>2]=b;x[d+12>>2]=e;Qz(a,d,c,1);fb=d+16|0}function jr(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;d=Mb(x[a>>2],x[a+8>>2],4);a:{if(!d){qD(b);break a}mh(c+8|0,b);sd(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0;return d|0}function ZL(a){var b=0,c=0;a:{if(y[a|0]!=255){break a}b=y[a+1|0];if(!(b&6)|(b&240)!=240&(b&254)!=226){break a}a=y[a+2|0];if((a&240)==240){break a}c=(a&12)!=12}return c}function Yja(){var a=0,b=0,c=0;a=fb-16|0;fb=a;b=Dc(a+4|0,10281);x[31609]=0;W(62,b|0);c=x[31609];x[31609]=0;if((c|0)!=1){tb(b);fb=a+16|0;return}a=N()|0;tb(b);Q(a|0);p()}function Sca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=fb-16|0;fb=d;b=x[b+4>>2];e=x[c+4>>2];c=x[c>>2];x[d>>2]=c;x[d+4>>2]=e;x[d+8>>2]=c;x[d+12>>2]=e;nP(a,b,d,1);fb=d+16|0}function Ev(a){var b=0,c=0,d=0,e=0;while(1){a:{if((b|0)==32){e=c;break a}d=y[a+b|0];if((d-1&255)>>>0<31|((c^1)&1?0:d)){break a}b=b+1|0;c=!d|c;continue}break}return e&1}function s5(a,b,c){a=a|0;b=b|0;c=c|0;a=zJ(a,c);x[a>>2]=96668;b=Kb(b);x[31609]=0;O(1368,a|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}b=N()|0;ky(a);Q(b|0);p()}function q5(a,b,c){a=a|0;b=b|0;c=c|0;a=yJ(a,c);x[a>>2]=96708;b=Kb(b);x[31609]=0;O(1369,a|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}b=N()|0;ly(a);Q(b|0);p()}function mda(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=fb-16|0;fb=d;a=x[a+4>>2];e=x[b+4>>2];b=x[b>>2];x[d>>2]=b;x[d+4>>2]=e;x[d+8>>2]=b;x[d+12>>2]=e;Pz(a,d,c,1);fb=d+16|0}function jd(a,b,c){var d=0,e=0,f=0;a:{if(!c){break a}while(1){d=y[a|0];e=y[b|0];if((d|0)==(e|0)){b=b+1|0;a=a+1|0;c=c-1|0;if(c){continue}break a}break}f=d-e|0}return f}function RM(a,b){var c=0,d=0;c=fb-16|0;fb=c;a=Xo(c+4|0,a,b);b=x[a+4>>2];d=x[a+8>>2];while(1){if((b|0)==(d|0)){kc(a);fb=c+16|0}else{b=b+1|0;x[a+4>>2]=b;continue}break}}function Noa(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-48|0;fb=c;d=-1;a:{if(!NW(a,c)){break a}d=0;if(!MW(c)){break a}d=xe(a,b,LW(y[c+31|0],y[c+33|0]),hb)}fb=c+48|0;return d|0}function Kpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;uG(b,c);if(Mb(x[a>>2],x[a+8>>2],c<<3)){tG(d+8|0,x[b>>2],x[b+4>>2]);sd(d,a,x[d+8>>2],x[d+12>>2])}fb=d+16|0}function zk(a,b){var c=0,d=0,e=0;a:{c=Rl(a,b);if((c|0)==255){break a}if(Gj(x[a>>2])){break a}d=xb(a+8|0,c);e=y[d|0]&223;v[d|0]=e;Ah(x[a>>2],x[a+4>>2],b,bv(c)|176,e)}}function saa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;pz(a,b,c);a=x[a+16>>2];a:{if(!c){d=1;if((a|0)==(b|0)){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function ld(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=Df(b);d=Mc(a);if(c>>>0<=d>>>0){Vu(a,Pi(Kb(a),b,c),c);break a}e=a;a=Cb(x[a+4>>2],y[a+11|0]);Yp(e,d,c-d|0,a,0,a,c,b)}}function kD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;fZ(b,c);if(Mb(x[a>>2],x[a+8>>2],c<<2)){eZ(d+8|0,x[b>>2],x[b+4>>2]);sd(d,a,x[d+8>>2],x[d+12>>2])}fb=d+16|0}function _H(a,b,c){var d=0;a:{if(!a){a=ac(8);x[31609]=0;c=R(c|0,a|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){break a}b=N()|0;ic(a);Q(b|0);p()}return}da(c|0,b|0,1e3);p()}function Z1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;x[d+12>>2]=c;c=0;a=x[a+16>>2];if(a>>>0>b>>>0){x[d+8>>2]=a-b;c=x[Hb(d+12|0,d+8|0)>>2]}fb=d+16|0;return c|0}function PW(a,b){var c=0;c=fb-32|0;fb=c;AX(c+24|0,a);fe(c+16|0,b);a=x[c+20>>2];x[c+8>>2]=x[c+16>>2];x[c+12>>2]=a;a=Ic(x[c+24>>2],x[c+28>>2],c+8|0);fb=c+32|0;return a}function Oda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Cb(x[b+4>>2],y[b+11|0]);e=a;a=Cb(x[c+4>>2],y[c+11|0]);b=Xg(Kb(Hz(e,d+a|0)),Kb(b),d)+d|0;am(Xg(b,Kb(c),a)+a|0,1,0)}function $h(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=cs(b);d=Mc(a);if(c>>>0<=d>>>0){Vu(a,Pi(Kb(a),b,c),c);break a}e=a;a=Cb(x[a+4>>2],y[a+11|0]);Sq(e,d,c-d|0,a,0,a,c,b)}}function yZ(a,b,c){var d=0,e=0,f=0;d=fb-16|0;fb=d;b=gc(b);a=Dh(a,Ec(32),Og(d+8|0,b));b=x[a>>2]+16|0;w[b>>1]=z[x[c>>2]>>1];Fb(b+4|0);e=gc(a),f=1,v[e+4|0]=f;fb=d+16|0}function tV(a){var b=0,c=0;a:{if(y[a|0]!=255){break a}b=y[a+1|0];if(!(b&6)|(b&224)!=224|(b&24)==8){break a}a=y[a+2|0];if((a&12)==12){break a}c=(a&240)!=240}return c}function qX(a){if(!((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=541938512|(y[a+8|0]|y[a+9|0]<<8|(y[a+10|0]<<16|y[a+11|0]<<24))!=1162627398)){return 1}return 0}function l2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;x[d+12>>2]=c;c=0;a=x[a+8>>2];if(a>>>0>b>>>0){x[d+8>>2]=a-b;c=x[Hb(d+12|0,d+8|0)>>2]}fb=d+16|0;return c|0}function OX(a){if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))==1297239878){a=(y[a+8|0]|y[a+9|0]<<8|(y[a+10|0]<<16|y[a+11|0]<<24))==1279545165}else{a=0}return a}function Ksa(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[b>>2],x[b+8>>2],12)){w[c>>1]=0;XZ(a,6,c);break a}yr(c+8|0,a);sd(c,b,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function H9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=fb-16|0;fb=e;a=_y(Pa(x[a+60>>2],b|0,c|0,d&255,e+8|0)|0);fb=e+16|0;hb=a?-1:x[e+12>>2];return(a?-1:x[e+8>>2])|0}function vpa(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[b>>2],x[b+8>>2],8)){w[c>>1]=0;XZ(a,4,c);break a}$k(c+8|0,a);sd(c,b,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function kL(a,b){var c=0,d=0,e=0,f=0;c=x[a+24>>2];if((c|0)==x[a+28>>2]){return e=a,f=zf(b),d=x[x[a>>2]+52>>2],ib[d](e|0,f|0)|0}x[a+24>>2]=c+1;v[c|0]=b;return zf(b)}function Nd(a,b){var c=0;c=fb-32|0;fb=c;fe(c+24|0,a);a=qc(c+16|0,b);b=x[a+4>>2];x[c+8>>2]=x[a>>2];x[c+12>>2]=b;a=Ic(x[c+24>>2],x[c+28>>2],c+8|0);fb=c+32|0;return a}function JT(a,b){a=a|0;b=b|0;var c=0;if(A[a+4>>2]<A[Ab(a)>>2]){c=fb-16|0;fb=c;a=vv(c+4|0,a,1);vs(x[a+4>>2],b);x[a+4>>2]=x[a+4>>2]+12;kc(a);fb=c+16|0;return}YG(a,b)}function npa(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[b>>2],x[b+8>>2],5)){v[c|0]=0;Uh(a,5,c);break a}$j(c+8|0,a);sd(c,b,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function ZW(a){var b=0;if(!((y[a+44|0]|y[a+45|0]<<8|(y[a+46|0]<<16|y[a+47|0]<<24))!=1297236819|y[a+29|0]!=16)){b=((y[a+42|0]|y[a+43|0]<<8)-1&65535)>>>0<2}return b}function Pd(a,b){var c=0,d=0,e=0,f=E(0);c=fb-16|0;fb=c;x[c+8>>2]=1065353216;B[c+12>>2]=b;e=c,f=ag(a),B[e+4>>2]=f;d=Sv(c+4|0,c+12|0,c+8|0);fb=c+16|0;return B[d>>2]}function z3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;x[d+12>>2]=x[c>>2];a=ib[x[x[a>>2]+16>>2]](a,b,d+12|0)|0;if(a){x[c>>2]=x[d+12>>2]}fb=d+16|0;return a|0}function yda(a,b){a=a|0;b=b|0;var c=0;a=ac(8);x[31609]=0;b=P(1051,a|0,12113)|0;c=x[31609];x[31609]=0;if((c|0)!=1){da(b|0,124900,162);p()}b=N()|0;ic(a);Q(b|0);p()}function vE(a){var b=0,c=0;a:{c=yb(a,3);if((c|0)==(a|0)){break a}b=a;while(1){b=b+4|0;if((c|0)==(b|0)){break a}a=sE(x[b>>2],x[a>>2])?b:a;continue}}return x[a>>2]}function rM(a,b){var c=0,d=0;c=Xc(x[a+4>>2],x[a+8>>2]);b=x[a+16>>2]+b|0;if(c>>>0<b>>>0){d=a+4|0;a:{if(c){a=mi(c);if(b>>>0<=a>>>0){break a}}a=sM(b,65536)}Kk(d,a)}}function mm(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[b>>2],x[b+8>>2],4)){v[c|0]=0;Uh(a,4,c);break a}mh(c+8|0,a);sd(c,b,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function aka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=fb-16|0;fb=c;d=c,e=uh(b),x[d+12>>2]=e;x[c+8>>2]=0;d=a,e=x[_j(c+12|0,c+8|0,42224)>>2],x[d+36>>2]=e;wq(a);fb=c+16|0}function _8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=fb-16|0;fb=e;x[e>>2]=c;x[e+4>>2]=d;x[e+8>>2]=c;x[e+12>>2]=d;a=ZK(a,e,b);x[a>>2]=94260;fb=e+16|0;return a|0}function Tq(a){x[a+8>>2]=0;x[a+12>>2]=0;x[a>>2]=128;x[a+4>>2]=256;x[a+32>>2]=363;x[a+36>>2]=952;x[a+16>>2]=48e3;x[a+20>>2]=2;x[a+24>>2]=128;x[a+28>>2]=0;return a}function T_(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[b>>2],x[b+8>>2],6)){v[c|0]=0;Uh(a,6,c);break a}XD(c+8|0,a);sd(c,b,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function Fpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=fb-80|0;fb=d;e=d+14|0;c=-1;a:{if(!O$(a,e)){break a}c=0;if(!HX(e)){break a}c=xe(a,b,GX(e),hb)}fb=d+80|0;return c|0}function Ec(a){a=a|0;var b=0;a=a>>>0<=1?1:a;a:{while(1){b=Gd(a);if(b){break a}b=x[125431];if(b){ib[b|0]();continue}break}da(un(ac(4))|0,124540,34);p()}return b|0}function C4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;while(1){if((b|0)!=(c|0)){e=d,f=PI(v[b|0],x[a+8>>2]),x[e>>2]=f;d=d+4|0;b=b+1|0;continue}break}return c|0}function $2(a,b){a=a|0;b=b|0;var c=0;if(A[a+4>>2]<A[Ab(a)>>2]){c=fb-16|0;fb=c;a=Cx(c+4|0,a);vs(x[a+4>>2],b);x[a+4>>2]=x[a+4>>2]+12;kc(a);fb=c+16|0;return}YG(a,b)}function mia(a){a=a|0;var b=0;b=fb-16|0;fb=b;BQ(b+8|0,a,0);if(x[b+12>>2]){a=x[a+20>>2];x[a+148>>2]=-1;AQ(a+4|0,wb(x[b+8>>2]),Zj(x[b+8>>2],x[b+12>>2]))}fb=b+16|0}function mS(a){var b=0,c=0,d=0;b=x[a+112>>2];if((b|0)>=11){b=378;while(1){if(b|c){lS(a);d=b;b=b-1|0;c=c-!d|0;continue}break}b=0}x[a+112>>2]=b+1;a=lS(a);return a}function kA(a,b){var c=0;c=fb-16|0;fb=c;a=Gn(c+4|0,a+8|0,b);b=x[a>>2];while(1){if((b|0)!=x[a+4>>2]){CV(b);b=x[a>>2]+4|0;x[a>>2]=b;continue}break}je(a);fb=c+16|0}function T0(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=-1;if(eh(a,c+11|0)){x[c+4>>2]=y[c+11|0];d=L0(a,b,x[Hb(c+4|0,c+12|0)>>2])}fb=c+16|0;return d|0}function MD(a){var b=0,c=0;b=fb-16|0;fb=b;w[b+14>>1]=a;Hf(b+14|0,4095);a=z[b+14>>1];c=LD(zi(+((a&255)>>>0)*.00390625)*32768);fb=b+16|0;return c>>>15-(a>>>8|0)|0}function LE(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;x[c+12>>2]=-1;if(eh(a,c+11|0)){x[c+4>>2]=y[c+11|0];d=I0(a,b,x[Hb(c+4|0,c+12|0)>>2])}fb=c+16|0;return d|0}function rW(a){if((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))==1299020115){a=($b(y[a+4|0]|y[a+5|0]<<8|(y[a+6|0]<<16|y[a+7|0]<<24))|0)==1}else{a=0}return a}function pla(a,b){a=a|0;b=b|0;a=tc(a);v[a+534|0]=0;x[a+4>>2]=0;x[31609]=0;O(788,a|0,b|0);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}b=N()|0;Hl(a);Q(b|0);p()}function cV(a,b,c,d){var e=0;e=fb-32|0;fb=e;fd(e+24|0,b,c);aV(e+16|0,x[e+24>>2],x[e+28>>2],d);b=UX(b,x[e+16>>2]);x[e+12>>2]=x[e+20>>2];rc(a,b,e+12|0);fb=e+32|0}function VH(a,b,c){var d=E(0);a:{if((b|0)<0|z[a+480188>>1]<=b>>>0){break a}a=D(b,872)+a|0;if(!(v[a+1075081|0]&1)){break a}d=E(E(y[a+c|0])*E(.0078125))}return d}function Qt(a){var b=0;a:{if((ff(a)|0)!=79){break a}if((ff(a)|0)!=103){break a}if((ff(a)|0)!=103){break a}b=(ff(a)|0)==83}if(!b){fc(a,30);return 0}return SL(a)}function Nw(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[b>>2],x[b+8>>2],2)){v[c|0]=0;tF(a,c);break a}Bp(c+8|0,a);sd(c,b,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function FS(a,b){var c=0;c=fb-32|0;fb=c;a=ye(c+8|0,a,b);a=Gu(c+16|0,x[a>>2],x[a+4>>2]);a=ye(c+24|0,x[a>>2],x[a+4>>2]);b=x[a>>2];fb=c+32|0;hb=x[a+4>>2];return b}function $D(a,b,c,d){var e=0;e=fb-32|0;fb=e;fd(e+24|0,b,c);cv(e+16|0,x[e+24>>2],x[e+28>>2],d);b=X_(b,x[e+16>>2]);x[e+12>>2]=x[e+20>>2];rc(a,b,e+12|0);fb=e+32|0}function wn(a){var b=0;b=2147483647;a:{if(a>=2147483647){break a}b=-2147483648;if(a<=-2147483648){break a}if(F(a)<2147483648){return~~a}b=-2147483648}return b}function gG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{d=Nb(a+8|0);x[31609]=0;S(169,a|0,b|0,c|0);a=x[31609];x[31609]=0;if((a|0)!=1){break a}a=N()|0;ec(d);Q(a|0);p()}}function dN(a,b){var c=0;c=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=c;c=x[b+20>>2];x[a+16>>2]=x[b+16>>2];x[a+20>>2]=c;c=x[b+12>>2];x[a+8>>2]=x[b+8>>2];x[a+12>>2]=c}function uC(a){var b=0;a=Ge(a);b=32767;a:{if(a>=32767){break a}b=32768;if(a<=-32768){break a}b=~~a;if(F(a)<2147483648){break a}b=-2147483648}return b<<16>>16}function sS(){var a=0,b=0,c=0,d=0;a=fb-16|0;fb=a;b=a+12|0;while(1){if(c>>>0<32){c=c+48|0;d=TA(126480);continue}break}x[b>>2]=d;Co(b);fb=a+16|0;return x[b>>2]}function q6(a){a=a|0;if(y[499944]){return x[124985]}if(!y[501096]){v[501096]=1}wd(501072,104244);wd(501084,104256);v[499944]=1;x[124985]=501072;return 501072}function V8(a,b){a=a|0;b=b|0;var c=0,d=0;b=KD(x[b>>2]);x[a+36>>2]=b;c=a,d=Lh(b),x[c+44>>2]=d;c=a,d=ho(x[a+36>>2]),v[c+53|0]=d;if(x[a+44>>2]>=9){fo(5563);p()}}function Sia(a){a=a|0;var b=0;b=fb-16|0;fb=b;Qc(b+4|0,a+32|0,4);if(!Gb(x[x[b+4>>2]>>2],x[b+8>>2])){yy(a)}a=vb(b+12|0,wb(x[a+52>>2]));fb=b+16|0;return x[a>>2]}function SP(a){a=a|0;var b=0;x[a+4240>>2]=0;x[a+4244>>2]=0;b=a+4264|0;x[b>>2]=0;x[b+4>>2]=0;b=a+4256|0;x[b>>2]=0;x[b+4>>2]=0;a=a+4248|0;x[a>>2]=0;x[a+4>>2]=0}function Ria(a){a=a|0;var b=0;b=fb-16|0;fb=b;Qc(b+4|0,a+32|0,4);if(!Gb(x[x[b+4>>2]>>2],x[b+8>>2])){yy(a)}a=vb(b+12|0,wb(x[a+56>>2]));fb=b+16|0;return x[a>>2]}function N8(a,b){a=a|0;b=b|0;var c=0,d=0;b=Py(x[b>>2]);x[a+36>>2]=b;c=a,d=Lh(b),x[c+44>>2]=d;c=a,d=ho(x[a+36>>2]),v[c+53|0]=d;if(x[a+44>>2]>=9){fo(5563);p()}}function D8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=0;while(1){if((b|0)!=(c|0)){a=x[b>>2]+(a<<4)|0;d=a&-268435456;a=(d|d>>>24)^a;b=b+4|0;continue}break}return a|0}function or(a){var b=0,c=0,d=0,e=0;c=x[a+4>>2];b=x[c>>2];x[a+4>>2]=b;if(b){xn(b,a)}b=x[a+8>>2];x[c+8>>2]=b;d=b+(Th(a)?0:4)|0,e=c,x[d>>2]=e;x[c>>2]=a;xn(a,c)}function nr(a){var b=0,c=0,d=0,e=0;c=x[a>>2];b=x[c+4>>2];x[a>>2]=b;if(b){xn(b,a)}b=x[a+8>>2];x[c+8>>2]=b;d=b+(Th(a)?0:4)|0,e=c,x[d>>2]=e;x[c+4>>2]=a;xn(a,c)}function Yna(a,b){a=a|0;b=b|0;var c=0,d=0;d=fb-48|0;fb=d;c=-1;a:{if(!NW(a,d)){break a}c=0;if(!OV(d)){break a}c=xe(a,b,NV(y[d+47|0]),hb)}fb=d+48|0;return c|0}function WH(a,b,c){var d=E(0);a:{if((b|0)<0|z[a+480188>>1]<=b>>>0){break a}a=D(b,872)+a|0;if(v[a+1075081|0]&1){break a}d=E(E(y[a+c|0])*E(.0078125))}return d}function Vb(a,b){a=a|0;b=b|0;var c=0;c=Mb(x[a>>2],x[a+8>>2],b);a:{if(c){b=x[a+8>>2]+b|0;break a}b=x[a>>2];b=ib[x[x[b>>2]+24>>2]](b)|0}x[a+8>>2]=b;return c|0}function Qe(a,b){var c=0;c=x[a>>2];x[a>>2]=b;a:{if(c){a=x[gc(a)>>2];x[31609]=0;W(a|0,c|0);a=x[31609];x[31609]=0;if((a|0)==1){break a}}return}T(0)|0;Sb();p()}function QQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fb-16|0;fb=d;while(1){if((b|0)==(c|0)){fb=d+16|0}else{x[d+12>>2]=x[b>>2];xA(a,d+12|0);b=b+4|0;continue}break}}function G8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=0;while(1){if((b|0)!=(c|0)){a=v[b|0]+(a<<4)|0;d=a&-268435456;a=(d|d>>>24)^a;b=b+1|0;continue}break}return a|0}function $aa(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;x[c+12>>2]=1135;x[c+8>>2]=1136;x[c+4>>2]=1137;x[c>>2]=1138;ib[x[lq(c,tk(y[b+20|0]))>>2]](a,b);fb=c+16|0}function j6(a){a=a|0;if(y[499936]){return x[124983]}if(!y[501064]){v[501064]=1}ld(501040,13958);ld(501052,13937);v[499936]=1;x[124983]=501040;return 501040}function Iu(a,b){var c=0,d=0,e=E(0);c=fb-16|0;fb=c;B[c+12>>2]=b;x[c+8>>2]=0;x[c+4>>2]=1065353216;d=a,e=B[Sv(c+12|0,c+8|0,c+4|0)>>2],B[d+144>>2]=e;fb=c+16|0}function Dla(a,b){a=a|0;b=b|0;a=Nb(a);v[a+16|0]=0;x[a+12>>2]=b;x[31609]=0;W(782,a|0);b=x[31609];x[31609]=0;if((b|0)!=1){return a|0}b=N()|0;$B(a);Q(b|0);p()}function zj(a,b,c,d){var e=0;e=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=e;e=x[b+12>>2];x[a+8>>2]=x[b+8>>2];x[a+12>>2]=e;C[a>>3]=C[a>>3]-c;C[a+8>>3]=C[a+8>>3]-d}function k0(a,b,c){var d=0;b=b-a>>2;while(1){if((b|0)>0){d=x[c>>2];v[a|0]=d;v[a+1|0]=d>>>8;v[a+2|0]=d>>>16;v[a+3|0]=d>>>24;b=b-1|0;a=a+4|0;continue}break}}function jz(a,b){var c=0;while(1){c=(b|0)>=120?120:b;a=E(a*E(B[((c&3)<<2)+81984>>2]*E(1073741824>>>(c>>2)|0)));b=b-c|0;if((b|0)>0){continue}break}return a}function gj(a,b,c,d,e){a:{e=zu(e);if(e){x[31609]=0;ba(d|0,e|0,a|0,b|0,c|0)|0;a=x[31609];x[31609]=0;if((a|0)==1){break a}}return e}a=N()|0;Db(e);Q(a|0);p()}function dr(a,b){var c=0,d=0;a:{if(!a){break a}c=Iua(a,0,b,0);d=hb;if((a|b)>>>0<65536){break a}c=d?-1:c}a=Gd(c);if(!(!a|!(y[a-4|0]&3))){Rb(a,0,c)}return a}function _1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=x[a+16>>2];a:{if(!c){d=1;if((a|0)==(b|0)){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function VZ(a,b){var c=0;c=Iua(b&65535,0,384,0);b=a&65535;a=b>>>30|0;b=b<<2;c=c+b|0;a=a+hb|0;a=b>>>0>c>>>0?a+1|0:a;b=c+256|0;hb=b>>>0<256?a+1|0:a;return b}function Bi(a){var b=0,c=0;b=a*a;c=b*a;return E(c*(b*b)*(b*2718311493989822e-21+-.00019839334836096632)+(c*(b*.008333329385889463+-.16666666641626524)+a))}function qga(a){a=a|0;var b=0,c=E(0);v[a+4202|0]=1;b=a,c=CB(E(E(E(E(A[x[a+16>>2]+24620>>2])/E(3))+E(-80))/E(15920)),E(0),E(1)),B[b+4272>>2]=c;TP(a);SP(a)}function m2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=x[a+8>>2];a:{if(!c){d=1;if((a|0)==(b|0)){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function ZV(a){x[a>>2]=0;x[a+4>>2]=0;x[a+88>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;rC(a+112|0,48e3);x[a+668>>2]=0;qC(a+724|0);qC(a+732|0);qC(a+740|0);Ng(a+788|0)}function ZU(a,b,c,d){var e=0;e=fb-32|0;fb=e;fd(e+24|0,b,c);aV(e+16|0,x[e+24>>2],x[e+28>>2],d);b=x[e+16>>2];x[e+12>>2]=x[e+20>>2];rc(a,b,e+12|0);fb=e+32|0}function ZB(a,b,c,d){var e=0;e=fb-32|0;fb=e;fd(e+24|0,b,c);cv(e+16|0,x[e+24>>2],x[e+28>>2],d);b=x[e+16>>2];x[e+12>>2]=x[e+20>>2];rc(a,b,e+12|0);fb=e+32|0}function V2(a,b,c){a=a|0;b=b|0;c=c|0;a=zs(a,x[b+28>>2]);ZG(b+28|0,c);x[31609]=0;O(113,b|0,1);b=x[31609];x[31609]=0;if((b|0)==1){b=N()|0;_b(a);Q(b|0);p()}}function Hv(a,b,c,d){var e=0;e=fb-32|0;fb=e;fd(e+24|0,b,c);bD(e+16|0,x[e+24>>2],x[e+28>>2],d);b=x[e+16>>2];x[e+12>>2]=x[e+20>>2];rc(a,b,e+12|0);fb=e+32|0}function vX(a){var b=0;if(!((y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))!=441273424|y[a+5|0]!=16|(y[a+54|0]-33&255)>>>0<224)){b=y[a+4|0]>95}return b}function no(a,b){var c=0,d=0;b=b+7&-8;d=x[a+80>>2];a:{if(d){b=x[a+92>>2]-b|0;c=0;if((b|0)<x[a+88>>2]){break a}x[a+92>>2]=b;return b+d|0}c=Gd(b)}return c}function ah(a){var b=0,c=0;b=x[a>>2];c=x[b+4>>2];a:{if(!c){while(1){if(!Th(b)){b=x[b+8>>2];continue}break}b=x[b+8>>2];break a}b=$Z(c)}x[a>>2]=b;return a}function qW(a,b){var c=0,d=0,e=0;pr(a);x[a>>2]=x[b>>2];x[a+4>>2]=x[b+4>>2];c=Ab(b);d=Ab(a),e=x[c>>2],x[d>>2]=e;x[c>>2]=0;x[b>>2]=0;x[b+4>>2]=0;return a}function R5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;while(1){if((b|0)!=(c|0)){a=x[b>>2];v[e|0]=a>>>0<128?a:d;e=e+1|0;b=b+4|0;continue}break}return c|0}function Loa(a,b){a=a|0;b=b|0;var c=0,d=0;d=fb+-64|0;fb=d;c=-1;a:{if(!m$(a,d)){break a}c=0;if(!HW(d)){break a}c=xe(a,b,GW(d),hb)}fb=d- -64|0;return c|0}function An(a,b){var c=0,d=0,e=0;dw(a);x[a>>2]=x[b>>2];x[a+4>>2]=x[b+4>>2];c=Ab(b);d=Ab(a),e=x[c>>2],x[d>>2]=e;x[c>>2]=0;x[b>>2]=0;x[b+4>>2]=0;return a}function wZ(a,b,c){var d=0;d=fb-32|0;fb=d;x[d+28>>2]=c;v[d+27|0]=0;x[d+12>>2]=1;rz(d+16|0,a,d+27|0,x[Hb(d+28|0,d+12|0)>>2]);v[b|0]=y[d+27|0];fb=d+32|0}function oo(a,b){x[a+20>>2]=0;x[a+24>>2]=b;x[a+12>>2]=0;x[a+4>>2]=4098;x[a+8>>2]=6;x[a+16>>2]=!b;Rb(a+32|0,0,40);pL(a+28|0);x[a+72>>2]=0;x[a+76>>2]=-1}function dd(a,b){a=a|0;b=b|0;var c=0,d=0;a:{if(A[a+8>>2]<b>>>0){d=x[a>>2];c=0;if(!(ib[x[x[d>>2]+32>>2]](d,0,b)|0)){break a}}x[a+8>>2]=b;c=1}return c|0}function VW(a,b,c,d){var e=0;e=c&4;a:{if((b&255)!=4){b=e?16:8;break a}b=16;if(e){break a}b=8;if(c&2){break a}Zc(a,8,1,0,10);return}Zc(a,b,c&2|1,0,d^1)}function FO(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=fb-32|0;fb=h;i=h+8|0;cM(i,b,c,d,e,f,g);Uc(a,h+20|0);an(i);fb=h+32|0}function Bta(a,b){a=a|0;b=b|0;var c=0,d=0;d=fb+-64|0;fb=d;c=-1;a:{if(!m$(a,d)){break a}c=0;if(!l$(d)){break a}c=xe(a,b,k$(d),0)}fb=d- -64|0;return c|0}function sT(a,b,c){var d=0,e=0;x[b+56>>2]=0;d=b,e=Fo(a,z[b+70>>1],x[b+48>>2],c,0),w[d+68>>1]=e;if(!(!(y[a+480180|0]&5)|x[b+60>>2]==-1)){x[b+60>>2]=0}}function i$(a,b){var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[b>>2],x[b+8>>2],8)){v[c|0]=0;Uh(a,8,c);break a}$k(c+8|0,a);sd(c,b,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function fx(a,b){var c=0;c=fb-16|0;fb=c;a:{if(!Mb(x[b>>2],x[b+8>>2],3)){v[c|0]=0;Uh(a,3,c);break a}ex(c+8|0,a);sd(c,b,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function Dq(a,b,c){var d=0;a:{if(b&67109888){break a}if(!Cj(c)){break a}b=y[c+34|0];if((b+5&255)>>>0<6){break a}d=x[$d(a+906300|0,b-1|0)>>2]}return d}function DJ(a){x[a>>2]=0;x[a+4>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;w[a+20>>1]=0;x[a+16>>2]=-1;x[a+8>>2]=0;x[a+12>>2]=0;x[a>>2]=0}function rpa(a,b){a=a|0;b=b|0;var c=0,d=0;d=fb-96|0;fb=d;c=-1;a:{if(!wX(a,d)){break a}c=0;if(!vX(d)){break a}c=xe(a,b,uX(d),hb)}fb=d+96|0;return c|0}function nh(a,b){var c=0;if(vd(y[a+11|0])){c=x[a>>2];$i(x[a+8>>2]);Db(c)}c=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=c;x[a+8>>2]=x[b+8>>2];Ne(b,0);yd(b,0)}function XQ(a){var b=0,c=0;b=fb-16|0;fb=b;B[b+12>>2]=F(a);x[b+8>>2]=646978941;x[b+4>>2]=1259902592;c=Sv(b+12|0,b+8|0,b+4|0);fb=b+16|0;return B[c>>2]}function Uoa(a,b){a=a|0;b=b|0;var c=0,d=0;d=fb-96|0;fb=d;c=-1;a:{if(!wX(a,d)){break a}c=0;if(!ZW(d)){break a}c=xe(a,b,YW(d),hb)}fb=d+96|0;return c|0}function SG(){var a=0,b=0,c=0;b=fb-16|0;fb=b;a=Dc(b+4|0,15059);if(_c(x[a+4>>2],y[a+11|0])){c=(Tg(a,13959)|0)!=-1}else{c=0}tb(a);fb=b+16|0;return c|0}function PI(a,b){var c=0,d=0;c=fb-16|0;fb=c;d=rh(c+12|0,b);b=a&255;if(b>>>0>=128){b=(a|0)==-1?-1:x[x[124115]>>2]?-1:a&57343}qh(d);fb=c+16|0;return b}function O9(a,b,c){a=a|0;b=b|0;c=c|0;a:{a=jg(a,b);x[31609]=0;P(71,a+12|0,c|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){break a}b=N()|0;tb(a);Q(b|0);p()}}function J5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;while(1){if((b|0)!=(c|0)){a=v[b|0];v[e|0]=(a|0)<0?d:a;e=e+1|0;b=b+1|0;continue}break}return c|0}function DH(a,b,c){var d=0,e=0;while(1){if((a|0)!=(b|0)){e=y[a|0];d=e<<24>>24;if((d|0)>=0){d=x[(e<<2)+c>>2]}v[a|0]=d;a=a+1|0;continue}break}return b}function $w(a,b,c,d,e){var f=0;while(1){if((d|0)!=(f|0)){B[b>>2]=E(x[a>>2])*e;B[c>>2]=E(x[a+4>>2])*e;f=f+1|0;c=c+4|0;a=a+8|0;b=b+4|0;continue}break}}function us(a){var b=0,c=0;c=x[a+4>>2];while(1){b=x[a+8>>2];if((b|0)!=(c|0)){b=b-12|0;x[a+8>>2]=b;Eb(b);continue}break}c=x[a>>2];if(c){ts(a);Db(c)}}function kX(a){var b=0,c=0;c=x[a+4>>2];while(1){b=x[a+8>>2];if((b|0)!=(c|0)){b=b-56|0;x[a+8>>2]=b;ar(b);continue}break}c=x[a>>2];if(c){nc(a);Db(c)}}function ix(a){var b=0,c=0;c=x[a+4>>2];while(1){b=x[a+8>>2];if((b|0)!=(c|0)){b=b-36|0;x[a+8>>2]=b;Gp(b);continue}break}c=x[a>>2];if(c){nc(a);Db(c)}}function hR(a){var b=0,c=0;c=x[a+4>>2];while(1){b=x[a+8>>2];if((b|0)!=(c|0)){b=b-52|0;x[a+8>>2]=b;wk(b);continue}break}c=x[a>>2];if(c){nc(a);Db(c)}}function bw(a){var b=0,c=0;c=x[a+4>>2];while(1){b=x[a+8>>2];if((b|0)!=(c|0)){b=b-20|0;x[a+8>>2]=b;ub(b);continue}break}c=x[a>>2];if(c){nc(a);Db(c)}}function YB(a){var b=0,c=0;c=x[a+4>>2];while(1){b=x[a+8>>2];if((b|0)!=(c|0)){b=b-32|0;x[a+8>>2]=b;Bk(b);continue}break}c=x[a>>2];if(c){ts(a);Db(c)}}function V$(a){var b=0,c=0;c=x[a+4>>2];while(1){b=x[a+8>>2];if((b|0)!=(c|0)){b=b-28|0;x[a+8>>2]=b;Hd(b);continue}break}c=x[a>>2];if(c){nc(a);Db(c)}}function Rq(a,b,c){a:{if(!Ob(c+1074312|0,102)){break a}c=z[a+692>>1]+1|0;w[a+784>>1]=c;if(!(v[a+89|0]&1)){break a}w[a+784>>1]=c|32768}x[a+692>>2]=b}function PA(a){if(y[a+480224|0]==2){return+A[a+1074420>>2]/1e4}return+A[a+24620>>2]/(+A[a+1074404>>2]*+(D(x[a+1074408>>2],x[a+1074416>>2])>>>0))*60}function I3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(lh(a,x[b+8>>2],f)){Wx(b,c,d,e);return}a=x[a+8>>2];ib[x[x[a>>2]+20>>2]](a,b,c,d,e,f)}function GI(a,b,c){var d=0,e=0,f=0,g=0;d=OC(b);if(d>>>0<c>>>0){uI(a,b,d+1|0);return d}if(c){e=a;a=c-1|0;f=uI(e,b,a)+(a<<2)|0,g=0,x[f>>2]=g}return d}function BS(a,b){var c=0,d=0;c=fb-16|0;fb=c;b=ye(c+8|0,Iua(b,b>>31,500654080,20),hb);d=x[b>>2];b=x[b+4>>2];fb=c+16|0;x[a>>2]=d;x[a+4>>2]=b;return a}function uX(a){var b=0,c=0,d=0,e=0;d=y[a+4|0];e=y[a+92|0];c=y[a+94|0]|y[a+95|0]<<8;b=c+y[a+93|0]|0;a=0;b=b+e|0;a=(b<<2)+d|0;a=a-96|0;hb=0;return a}function q$(a){v[a+8|0]=0;v[a+9|0]=0;v[a+10|0]=0;v[a+11|0]=0;v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;v[a+6|0]=0;v[a+7|0]=0}function iI(a){var b=0,c=0;c=a>>>23&255;b=0;a:{if(c>>>0<127){break a}b=2;if(c>>>0>150){break a}c=1<<150-c;b=0;if(c-1&a){break a}b=a&c?1:2}return b}function ef(a,b){var c=0;c=fb-16|0;fb=c;a:{if(!b){Qc(c+8|0,a+32|0,5);if(Gb(x[x[c+8>>2]>>2],x[c+12>>2])){break a}}x[a+28>>2]=x[a+28>>2]+1}fb=c+16|0}function cja(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-32|0;fb=c;w[c+30>>1]=b;b=c+30|0;Bp(c+20|0,b);d=x[c+20>>2];Bp(c+12|0,b);sl(a,d,x[c+16>>2]);fb=c+32|0}function Z8(a,b){a=a|0;b=b|0;var c=0,d=0;c=x[a+40>>2];while(1){if(c){c=c-1|0;d=c<<2;ib[x[x[a+32>>2]+d>>2]](b,a,x[d+x[a+36>>2]>>2]);continue}break}}function Ws(a){var b=0,c=0,d=0;if(!a){return 0}d=108144;while(1){b=d;c=x[b>>2];if(c){d=b+4|0;if((a|0)!=(c|0)){continue}}break}return((c?b:0)|0)!=0}function UB(a,b,c){var d=0,e=0,f=0;d=Rl(a,b);if((d|0)!=255){e=bc(a+26|0,d),f=c,w[e>>1]=f;a=a+62|0;e=xb(a,b),f=255,v[e|0]=f;e=xb(a,c),f=d,v[e|0]=f}}function Mga(a,b,c){a=a|0;b=b|0;c=E(c);var d=0,e=0,f=E(0);if(b>>>0<=1){c=Pd(c,E(0));if((b|0)==1){d=1;c=ni(c)}e=yb(a+4208|0,d),f=c,B[e>>2]=f;ZP(a)}}function GU(a){var b=0,c=0,d=0;d=y[a+26|0];b=d+27|0;while(1){if((c|0)==(d|0)){a=b&65535}else{b=y[(a+c|0)+27|0]+b|0;c=c+1|0;continue}break}return a}function GP(a,b){a=a|0;b=b|0;var c=0,d=0;d=fb-16|0;fb=d;c=fu(Ec(12));x[c+8>>2]=b;x[c+4>>2]=a;x[c>>2]=47468;a=yf(d+12|0,c);fb=d+16|0;return x[a>>2]}function D_(a,b){var c=0;c=Iua(b&255,0,9,0);b=a&255;a=b>>>31|0;b=b<<1;c=c+b|0;a=a+hb|0;a=b>>>0>c>>>0?a+1|0:a;b=c+11|0;hb=b>>>0<11?a+1|0:a;return b}function Cs(a,b,c,d){var e=0;e=ac(8);x[31609]=0;a=P(d|0,e|0,a|0)|0;d=x[31609];x[31609]=0;if((d|0)!=1){da(a|0,c|0,b|0);p()}a=N()|0;ic(e);Q(a|0);p()}function sla(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-32|0;fb=c;v[c+31|0]=b;b=c+31|0;Tr(c+20|0,b);d=x[c+20>>2];Tr(c+12|0,b);sl(a,d,x[c+16>>2]);fb=c+32|0}function jP(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=fb-32|0;fb=h;i=h+8|0;cM(i,b,c,d,e,f,g);Uc(a,i);an(i);fb=h+32|0}function jG(a){a=a|0;var b=0;a=Fb(a);x[31609]=0;R(168,a+12|0)|0;b=x[31609];x[31609]=0;if((b|0)!=1){tc(a+32|0);return a|0}b=N()|0;tb(a);Q(b|0);p()}function Yi(a,b){var c=0;c=x[a>>2];if($c(c,x[a+4>>2])>>>0>b>>>0){a=x[a+24>>2];a=Je(x[a+484344>>2],x[a+484348>>2],z[bc(c,b)>>1])}else{a=0}return a}function ME(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;v[a+6|0]=0;v[a+7|0]=0;v[a+7|0]=0;v[a+8|0]=0;v[a+9|0]=0;v[a+10|0]=0}function JB(a){var b=0,c=0;b=fb-16|0;fb=b;x[b+12>>2]=a;c=b+12|0;a=1;while(1){if((a|0)>0){ah(c);a=a-1|0;continue}break}fb=b+16|0;return x[b+12>>2]}function yt(a){var b=0,c=0;b=fb-16|0;fb=b;c=-1;a:{if(zt(a)){break a}if((ib[x[a+32>>2]](a,b+15|0,1)|0)!=1){break a}c=y[b+15|0]}fb=b+16|0;return c}function jq(a,b){var c=0;a:{if(!ZL(b)|(y[b+1|0]^y[a+1|0])>>>0>1){break a}b=y[b+2|0];a=y[a+2|0];if((b^a)&12){break a}c=a>>>0<16^b>>>0>15}return c}function fua(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;x[c+12>>2]=-1;if(eh(a,c+11|0)){x[c+4>>2]=y[c+11|0];h0(a,b,x[Hb(c+4|0,c+12|0)>>2])}fb=c+16|0}function LP(a,b){var c=0;if(a>.999999){c=0}else{a=a*a;b=hf(31415.926535897932/b);c=Ui(32768/(1-a)*(1-(a*b+M((a+a)*(1-b)-a*a*(1-b*b)))))}return c}function lT(a,b){v[a+840|0]=b;v[a+812|0]=b;v[a+811|0]=b;v[a+809|0]=b;v[a+807|0]=b;v[a+806|0]=b;v[a+833|0]=b;v[a+826|0]=b>>>4;v[a+827|0]=b<<2&60}function gl(a,b,c){if(a>>>0<b>>>0){zc(a,b,c);return}if(c){a=a+c|0;b=b+c|0;while(1){a=a-1|0;b=b-1|0;v[a|0]=y[b|0];c=c-1|0;if(c){continue}break}}}function fm(a,b,c,d){var e=0;e=D(b,c);a:{if(x[d+76>>2]<0){a=vw(a,e,d);break a}a=vw(a,e,d)}if((e|0)==(a|0)){return b?c:0}return(a>>>0)/(b>>>0)|0}function Z0(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;x[c+12>>2]=-1;if(eh(a,c+11|0)){x[c+4>>2]=y[c+11|0];N0(a,b,x[Hb(c+4|0,c+12|0)>>2])}fb=c+16|0}function $fa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(!b){Iz(a,0,0,0,0,0,0,c,d);return}Iz(a,x[b>>2],x[b+4>>2],x[b+8>>2],x[b+12>>2],x[b+24>>2],b,c,d)}function wY(a){var b=0;if(!(jd(a,15101,3)|(y[a+4|0]|y[a+5|0]<<8|(y[a+6|0]<<16|y[a+7|0]<<24))-2147483647>>>0<2147484072)){b=y[a+3|0]<6}return b}function bF(a,b){var c=0;a:{if(!(y[a+2|0]|y[a+3|0]<<8)|(!y[a|0]|!y[a+1|0])){break a}c=1;if(b>>>0<9){break a}c=(y[a+4|0]-1&255)>>>0<32}return c}function Vs(a){if(a>>>0<=254){return(a+1&127)>>>0>32}return(a&65534)!=65534&a-65532>>>0<1048580|(a-57344>>>0<8185|a>>>0<8232|a-8234>>>0<47062)}function Npa(a,b){a=a|0;b=b|0;a:{if(a>>>0>=515){a=Rg(b);Rg(b);break a}a=gh(b);gh(b)}while(1){if(a){if(a&1){Vb(b,260)}a=a>>>1|0;continue}break}}function Nm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Df(b);e=a;a=Cb(x[c+4>>2],y[c+11|0]);b=Dg(Kb(Hz(e,d+a|0)),b,d)+d|0;am(Dg(b,Kb(c),a)+a|0,1,0)}function HL(a,b,c,d,e,f){var g=0,h=0;g=x[a+32>>2];if(!y[a+23|0]){x[(c<<2)+g>>2]=b;return}h=g;g=d<<2;x[h+g>>2]=b;v[x[a+8>>2]+d|0]=e;x[f+g>>2]=c}function Am(a,b){var c=0,d=0;d=x[a+4>>2];c=x[a+8>>2];while(1){if((c|0)!=(d|0)){c=c-b|0;x[a+8>>2]=c;continue}break}b=x[a>>2];if(b){nc(a);Db(b)}}function yW(a){var b=0,c=0;c=x[a+4>>2];b=x[a+8>>2];while(1){if((b|0)!=(c|0)){b=b-12|0;x[a+8>>2]=b;continue}break}b=x[a>>2];if(b){ts(a);Db(b)}}function _f(a){a=a|0;var b=0;x[a>>2]=42712;x[x[a+20>>2]>>2]=0;b=x[a+16>>2];x[b+946300>>2]=x[b+946300>>2]-1;x[a+20>>2]=0;xQ(a+44|0);return a|0}function Zu(a,b){var c=0,d=0;d=Yj(a,b);while(1){a:{c=d;if(!(c&65535)){c=0;break a}d=c-1|0;if(!Je(a,b,d&65535)){continue}}break}return c&65535}function Uu(a,b){var c=0;c=fb-16|0;fb=c;fe(c+8|0,a);fe(c,b);b=x[c>>2];a=w_(x[c+8>>2],x[c+12>>2],b,x[c+4>>2]);fb=c+16|0;return vd(a?a>>31|1:0)}function SV(a){var b=0,c=0;c=x[a+4>>2];b=x[a+8>>2];while(1){if((b|0)!=(c|0)){b=b-32|0;x[a+8>>2]=b;continue}break}b=x[a>>2];if(b){ts(a);Db(b)}}function P$(a,b,c){var d=0;d=fb-16|0;fb=d;mm(d+12|0,b);x[d+8>>2]=y[d+12|0]|y[d+13|0]<<8|(y[d+14|0]<<16|y[d+15|0]<<24);dp(a,d+8|0,c);fb=d+16|0}function Mn(a,b){var c=0;a=Qn(a);x[a>>2]=78448;c=x[b+8>>2];x[a+4>>2]=x[b+4>>2];x[a+8>>2]=c;v[a+16|0]=y[b+16|0];x[a+12>>2]=x[b+12>>2];return a}function GR(a,b){var c=0;c=fb-16|0;fb=c;fe(c+8|0,a);fe(c,b);b=x[c>>2];a=zZ(x[c+8>>2],x[c+12>>2],b,x[c+4>>2]);fb=c+16|0;return vd(a?a>>31|1:0)}function Ai(a){var b=0;a=a*a;b=a*a;return E(a*b*(a*2439044879627741e-20+-.001388676377460993)+(b*.04166662332373906+(a*-.499999997251031+1)))}function mE(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;w[c+14>>1]=1;d=c,e=dm(a,b),w[d+12>>1]=e;a=qe(c+14|0,c+12|0);fb=c+16|0;return z[a>>1]-1&65535}function dy(a,b){var c=0;c=fb-16|0;fb=c;b=rh(c+12|0,b);if(a>>>0>=128){a=(a&-128)!=57216?-1:x[x[124115]>>2]?-1:a&255}qh(b);fb=c+16|0;return a}function EO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=fb-32|0;fb=g;h=g+8|0;dM(h,b,c,d,e,f);Uc(a,g+20|0);an(h);fb=g+32|0}function zb(a,b){var c=0;if(vd(y[a+11|0])){Db(x[a>>2])}c=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=c;x[a+8>>2]=x[b+8>>2];Ne(b,0);hd(b,0);return a}function up(a,b){var c=0;a:{if(!b){break a}if(!Mb(x[a>>2],x[a+8>>2],b)){break a}if(b>>>0<=3){c=DF(a,b);break a}c=Rg(a);Vb(a,b-4|0)}return c}function nf(a){var b=0,c=0,d=0;d=fb-16|0;fb=d;b=vb(d+12|0,a);c=x[b>>2];if(x[c>>2]){Nc(c);b=x[b>>2];c=x[b>>2];it(b);Db(c)}fb=d+16|0;return a}function n_(a){var b=0,c=0,d=0;b=fb-16|0;fb=b;c=b,d=$b(a),x[c+12>>2]=d;x[b+8>>2]=236;a=bd(b+12|0,b+8|0);fb=b+16|0;hb=0;return x[a>>2]-216|0}function Pw(a,b){var c=0;a:{if(!b){break a}if(!Mb(x[a>>2],x[a+8>>2],b)){break a}if(b>>>0<=1){c=CF(a,1);break a}c=gh(a);Vb(a,b-2|0)}return c}function Oe(a,b,c){v[a+11|0]=c;v[a+10|0]=b;v[a+12|0]=y[a+12|0]&251;w[a+8>>1]=65535;x[a>>2]=0;x[a+4>>2]=0;v[a+12|0]=y[a+12|0]&252|1;return a}function Lb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=fb-16|0;fb=d;if(b>>>0>=122){Pq(12226);p()}e=d+8|0;Jb(e,a,b);kf(e,c);fb=d+16|0;return a|0}function pL(a){var b=0,c=0;x[31609]=0;c=ca(1222)|0;b=x[31609];x[31609]=0;if((b|0)!=1){b=a;a=x[c>>2];x[b>>2]=a;qm(a);return}T(0)|0;Sb();p()}function mI(a,b,c,d,e){var f=0;f=c;c=0;a:{if(!d){break a}c=b>>8;if(!(b&1)){break a}c=Tx(x[d>>2],c)}ib[x[x[a>>2]+28>>2]](a,f,c+d|0,b&2?e:2)}function a6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=fb-16|0;fb=a;x[a+12>>2]=e;x[a+8>>2]=d-c;b=Hb(a+12|0,a+8|0);fb=a+16|0;return x[b>>2]}function Kl(a){var b=0,c=0,d=0;b=fb-16|0;fb=b;c=x[a+24>>2];d=x[a+40>>2];x[b+12>>2]=1;a=bd(a+20|0,b+12|0);fb=b+16|0;return D(x[a>>2],c+d|0)}function uQ(a,b){var c=0;c=x[b+4>>2];if(x[a>>2]==(b|0)){x[a>>2]=c}a=x[b+8>>2];if(c){x[c+8>>2]=a}if(a){x[a+4>>2]=c}x[b+4>>2]=0;x[b+8>>2]=0}function lia(a,b){a=a|0;b=b|0;var c=0;b=fb-16|0;fb=b;c=x[a+20>>2];se(b,x[c+4>>2],x[c+8>>2]);zQ(a,Zb(b+8|0,x[b>>2],x[b+4>>2]),0);fb=b+16|0}function gd(a){var b=0;b=fb-16|0;fb=b;x[b+12>>2]=a;x[b+8>>2]=-32768;x[b+4>>2]=32767;a=Xe(b+8|0,Cd(b+12|0,b+4|0));fb=b+16|0;return w[a>>1]}function e$(a){var b=0,c=0,d=0;c=fb-16|0;fb=c;b=c+13|0;fx(b,a);a=y[xb(b,0)|0];d=y[xb(b,1)|0];b=y[xb(b,2)|0];fb=c+16|0;return d<<8|a|b<<16}function dk(a,b,c){var d=0,e=0,f=0;d=fb-16|0;fb=d;v[d+15|0]=b;v[d+14|0]=127;e=a,f=y[Qb(d+15|0,d+14|0)|0]|(c?-128:0),v[e+21|0]=f;fb=d+16|0}function ck(a,b,c){var d=0,e=0,f=0;d=fb-16|0;fb=d;v[d+15|0]=b;v[d+14|0]=127;e=a,f=y[Qb(d+15|0,d+14|0)|0]|(c?-128:0),v[e+22|0]=f;fb=d+16|0}function Ska(a){a=a|0;var b=0;b=x[a>>2];if(ib[x[x[b>>2]+32>>2]](b,0,32)|0){a=x[a>>2];a=ib[x[x[a>>2]+32>>2]](a,32,1)^1}else{a=0}return a|0}function LO(a,b){var c=0,d=0;a:{if(!Ut(b)){break a}c=x[a+484344>>2];if(!Je(c,x[a+484348>>2],b&65535)){break a}d=x[Wb(c,b)+12>>2]}return d}function DC(a,b){var c=0,d=0;x[a>>2]=x[b>>2];x[a+4>>2]=x[b+4>>2];x[a+8>>2]=x[b+8>>2];x[b>>2]=0;x[b+4>>2]=0;c=Ab(b),d=0,x[c>>2]=d;return a}function AC(a){a=50-(D(y[(a>>>4|0)+29872|0],a&15)>>>4|0)|0;a=a>>>0>23863?65536:23863/(a>>>0)|0;return Gc((a+119315e4>>>0)/(a<<1>>>0)|0,0)}function G4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;while(1){if((b|0)!=(c|0)){d=b,e=$x(x[b>>2]),x[d>>2]=e;b=b+4|0;continue}break}return c|0}function EH(a,b,c){var d=0;while(1){if((a|0)!=(b|0)){d=x[a>>2];if(d>>>0<=127){d=x[(d<<2)+c>>2]}x[a>>2]=d;a=a+4|0;continue}break}return b}function E4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;while(1){if((b|0)!=(c|0)){d=b,e=ay(x[b>>2]),x[d>>2]=e;b=b+4|0;continue}break}return c|0}function id(a,b){var c=0,d=0,e=0;c=jh(a,b);if(c){x[a+12>>2]=x[a+12>>2]+b;return c}d=a,e=ib[x[x[a>>2]+24>>2]](a)|0,x[d+12>>2]=e;return c}function iP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=fb-32|0;fb=g;h=g+8|0;dM(h,b,c,d,e,f);Uc(a,h);an(h);fb=g+32|0}function hY(a){w[a+10>>1]=0;w[a+12>>1]=0;w[a+8>>1]=1084;x[a>>2]=0;x[a+4>>2]=40;v[a+13|0]=0;v[a+14|0]=0;v[a+15|0]=0;v[a+16|0]=0;return a}function _C(a){var b=0;b=Bb(y[a+26|0]|y[a+27|0]<<8);return((y[a+24|0]>15)+(y[a+25|0]>64)|0)+(Bb(y[a+22|0]|y[a+23|0]<<8)<<1>>>0<b>>>0)|0}function JS(a,b,c,d){var e=0;e=a+1074376|0;pB(a,e,b,c,d);e=0-y[(D(b,872)+e|0)+1428|0]|0;if(d){c=0}else{c=Ju(x[a+480180>>2])}zo(a,b,e,c)}function F9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=b;b=x[b>>2]+7&-8;x[c>>2]=b+16;d=a,e=Ex(x[b>>2],x[b+4>>2],x[b+8>>2],x[b+12>>2]),C[d>>3]=e}function Ey(a,b,c){var d=0;d=b-a>>2;a:{if(d){while(1){if(x[a>>2]==(c|0)){break a}a=a+4|0;d=d-1|0;if(d){continue}break}}a=0}return a?a:b}function wka(a,b){a=a|0;b=b|0;a=iB(a);x[31609]=0;O(844,a|0,b|0);b=x[31609];x[31609]=0;if((b|0)==1){b=N()|0;Gq(a);Q(b|0);p()}return a|0}function q4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;while(1){if((b|0)!=(c|0)){d=b,e=ql(y[b|0]),v[d|0]=e;b=b+1|0;continue}break}return c|0}function pn(a){var b=0,c=0;c=x[a+4>>2];b=x[a+8>>2];while(1){if((b|0)!=(c|0)){b=b-1|0;x[a+8>>2]=b;continue}break}a=x[a>>2];if(a){Db(a)}}function o4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;while(1){if((b|0)!=(c|0)){d=b,e=tt(y[b|0]),v[d|0]=e;b=b+1|0;continue}break}return c|0}function dia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;if(!(!d|!Tc(c&255))){CQ(a,8,E(0))}a=yj(a);if(a){ib[x[x[a>>2]+96>>2]](a,b,c,d,e)}}function _ba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=gu(x[a+32>>2],b,c,d,3);if(a>>>0<=46){a=y[a+42080|0]}else{a=0}return(a>>>0<5?a+1|0:0)|0}function Gua(a,b){a=a|0;b=b|0;x[a+4>>2]=b;v[a|0]=0;b=x[x[b>>2]-12>>2]+b|0;if(!x[b+16>>2]){b=x[b+72>>2];if(b){rp(b)}v[a|0]=1}return a|0}function Gu(a,b,c){var d=0;d=fb-16|0;fb=d;b=ye(d+8|0,Iua(b,c,1e6,0),hb);c=x[b>>2];b=x[b+4>>2];fb=d+16|0;x[a>>2]=c;x[a+4>>2]=b;return a}function AW(a){var b=0,c=0;c=fb-16|0;fb=c;b=vb(c+12|0,a);a=x[b>>2];if(x[a>>2]){vW(a,x[a>>2]);a=x[b>>2];b=x[a>>2];dl(a);Db(b)}fb=c+16|0}function $ba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=gu(x[a+32>>2],b,c,d,2);if(a>>>0<=15){a=y[a+42128|0]}else{a=0}return(a>>>0<5?a+1|0:0)|0}function Uca(a,b){a=a|0;b=b|0;var c=0;if((a|0)!=(b|0)){c=x[a+4>>2];if(c){Db(c);x[a+4>>2]=0}x[a+4>>2]=x[b+4>>2];x[b+4>>2]=0}return a|0}function ri(a,b,c){v[a|0]=b;v[a+1|0]=b>>>8;v[a+2|0]=b>>>16;v[a+3|0]=b>>>24;v[a+4|0]=c;v[a+5|0]=c>>>8;v[a+6|0]=c>>>16;v[a+7|0]=c>>>24}function lY(a){var b=0;b=fb-16|0;fb=b;x[b+12>>2]=a;x[b+8>>2]=-128;x[b+4>>2]=127;a=Xe(b+8|0,Cd(b+12|0,b+4|0));fb=b+16|0;return v[a|0]}function Vka(a,b){a=a|0;b=b|0;a=AE(a,b);if(!a){v[b+6|0]=0;v[b+2|0]=0;v[b+3|0]=0;v[b+4|0]=0;v[b+5|0]=0;v[b|0]=0;v[b+1|0]=0}return a|0}function $ga(a,b,c){a=a|0;b=b|0;c=E(c);var d=0;if(b>>>0<=4){c=Pd(c,E(0));d=((b<<2)+a|0)+4220|0;if((b|0)==4){c=ni(c)}B[d>>2]=c;aQ(a)}}function ki(a,b){var c=0,d=0;c=x[a>>2];d=x[a+4>>2];b=x[a+16>>2]+b|0;a=x[a+12>>2];b=(b|0)%(a|0)|0;return B[Pc(c,d,(b>>31&a)+b|0)>>2]}function bg(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;if(b>>>0>=122){Pq(12191);p()}d=c+8|0;Jb(d,a,b);kf(d,0);fb=c+16|0;return a|0}function Uy(a){a=a|0;var b=0;b=x[a+12>>2];if((b|0)==x[a+16>>2]){return ib[x[x[a>>2]+40>>2]](a)|0}x[a+12>>2]=b+1;return zf(v[b|0])|0}function Lt(a,b){var c=0,d=0;a:{if(b>>>0<=31){d=x[a>>2];c=a+4|0;break a}b=b-32|0;c=a}c=x[c>>2];x[a>>2]=d<<b;x[a+4>>2]=c<<b|d>>>32-b}function KS(a,b,c,d){var e=0;e=a+1074376|0;qB(a,e,b,c,d);e=y[(D(b,872)+e|0)+1427|0];if(d){c=0}else{c=Ju(x[a+480180>>2])}zo(a,b,e,c)}function li(a,b){var c=0,d=0,e=0;o(+a);c=j(1)|0;d=j(0)|0;o(+b);e=j(1)|0;j(0)|0;l(0,d|0);l(1,c&2147483647|e&-2147483648);return+n()}function Ot(a,b){var c=0,d=0;c=x[a+4>>2];a:{if(b>>>0<=31){d=x[a>>2];break a}b=b-32|0;d=c;c=0}x[a+4>>2]=c>>>b;x[a>>2]=c<<32-b|d>>>b}function B9(a){a=a|0;var b=0;if((ib[x[x[a>>2]+36>>2]](a)|0)!=-1){b=a;a=x[a+12>>2];x[b+12>>2]=a+1;a=zf(v[a|0])}else{a=-1}return a|0}function Aka(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;if(b>>>0>=250){Pq(12226);p()}d=c+8|0;Jb(d,a,b);ap(d);fb=c+16|0;return a|0}function WY(a,b){var c=0;c=fb-16|0;fb=c;a=xh(c+4|0,a,1);bp(x[a+4>>2],z[b>>1]|z[b+2>>1]<<16);x[a+4>>2]=x[a+4>>2]+4;kc(a);fb=c+16|0}function GL(a,b){a:{if(a&255){a=1;if((b|0)!=255){break a}_(14279,13274,1180,5734);p()}if((b|0)==255){return 0}a=b>>>0>10}return a}function Eh(a){var b=0;b=fb-16|0;fb=b;x[b+12>>2]=a;x[b+8>>2]=0;x[b+4>>2]=255;a=Xe(b+8|0,Cd(b+12|0,b+4|0));fb=b+16|0;return y[a|0]}function bD(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;f=b;b=c-b|0;g=e,h=XC(d,f,b>>2)+b|0,x[g+12>>2]=h;rc(a,c,e+12|0);fb=e+16|0}function aV(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;f=b;b=c-b|0;g=e,h=$U(d,f,b>>1)+b|0,x[g+12>>2]=h;rc(a,c,e+12|0);fb=e+16|0}function xH(a,b,c){var d=0;d=fb-16|0;fb=d;x[d+8>>2]=a;x[d+12>>2]=b;x[d>>2]=c;x[d+4>>2]=0;a=Ur(d+8|0,d);fb=d+16|0;return x[a>>2]}function rT(a,b,c,d){a:{if(d>>>0>=64){d=-1;if(y[a+480180|0]&2){break a}}x[b+56>>2]=0;d=Fo(a,z[b+70>>1],x[b+48>>2],c,0)}return d}function pK(a,b,c,d,e,f){a=ib[x[x[a+8>>2]+4>>2]](a+8|0)|0;a=xt(c,d,a,a+288|0,f,e,0)-a|0;if((a|0)<=287){x[b>>2]=((a|0)/12|0)%12}}function o9(a){a=a|0;var b=0;if((ib[x[x[a>>2]+36>>2]](a)|0)!=-1){b=a;a=x[a+12>>2];x[b+12>>2]=a+4;a=x[a>>2]}else{a=-1}return a|0}function me(a){var b=0;a=x[a+4>>2];if(a){if(vm(a)){a:{b=a+8|0;if(x[b>>2]){if((mx(b)|0)!=-1){break a}}ib[x[x[a>>2]+16>>2]](a)}}}}function lK(a,b,c,d,e,f){a=ib[x[x[a+8>>2]+4>>2]](a+8|0)|0;a=st(c,d,a,a+288|0,f,e,0)-a|0;if((a|0)<=287){x[b>>2]=((a|0)/12|0)%12}}function ez(a,b,c){var d=0;d=x[a+32>>2];if(A[a+40>>2]<d+c>>>0){x[a+96>>2]=1;return 0}zc(b,d,c);x[a+32>>2]=x[a+32>>2]+c;return 1}function eH(a,b,c,d){a=Nb(a);x[31609]=0;S(d|0,a|0,b|0,c|0);b=x[31609];x[31609]=0;if((b|0)!=1){return a}b=N()|0;wc(a);Q(b|0);p()}function T5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((b|0)!=(c|0)){x[d>>2]=v[b|0];d=d+4|0;b=b+1|0;continue}break}return c|0}function NB(a,b){var c=0;c=x[a+484360>>2];b=b&255;if(Hj(c,x[a+484364>>2])>>>0<=b>>>0){return Xb(c,y[a+484376|0])}return Nj(c,b)}function EC(a,b){var c=0;c=fb-16|0;fb=c;a=Zb(c+8|0,(b>>>3&536870908)+a|0,1<<b);a=Gb(x[x[a>>2]>>2],x[a+4>>2]);fb=c+16|0;return a}function yC(a){var b=0,c=0;c=fb-16|0;fb=c;a=vb(c+12|0,a);b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];dl(a);Db(b)}fb=c+16|0}function xS(a){var b=0,c=0;c=fb-16|0;fb=c;a=vb(c+12|0,a);b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];v$(a);Db(b)}fb=c+16|0}function ur(a){var b=0;b=-1;a:{if(a>=4294967295){break a}b=0;if(a<=0){break a}if(a<4294967296&a>=0){return~~a>>>0}b=0}return b}function tv(a){var b=0,c=0;c=fb-16|0;fb=c;a=vb(c+12|0,a);b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];pC(a);Db(b)}fb=c+16|0}function pu(a){var b=0;b=C[a+4248>>3]/+A[x[a+16>>2]+24620>>2];C[a+4264>>3]=b;if(y[a+4240|0]){C[a+4264>>3]=b*(C[a+4288>>3]/60)}}function oS(a){var b=0,c=0;c=fb-16|0;fb=c;a=vb(c+12|0,a);b=x[a>>2];if(x[b>>2]){Eu(b);a=x[a>>2];b=x[a>>2];Du(a);Db(b)}fb=c+16|0}function nu(a){var b=0,c=0;c=fb-16|0;fb=c;a=vb(c+12|0,a);b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];dA(a);Db(b)}fb=c+16|0}function ke(a){var b=0,c=0;c=fb-16|0;fb=c;a=vb(c+12|0,a);b=x[a>>2];if(x[b>>2]){f0(b);a=x[a>>2];b=x[a>>2];tE(a);Db(b)}fb=c+16|0}function kU(a){var b=0,c=0;c=fb-16|0;fb=c;a=vb(c+12|0,a);b=x[a>>2];if(x[b>>2]){fU(b);a=x[a>>2];b=x[a>>2];dl(a);Db(b)}fb=c+16|0}function hS(a){var b=0,c=0;c=fb-16|0;fb=c;a=vb(c+12|0,a);b=x[a>>2];if(x[b>>2]){Kp(b);a=x[a>>2];b=x[a>>2];hx(a);Db(b)}fb=c+16|0}function fG(a,b){var c=0;c=x[b+4>>2];if(c){cc(a,c,x[b>>2]);return}c=x[b+8>>2];b=x[b+12>>2];if(!mc(c,b)){se(a,c,b);return}Md(a)}function bH(a,b,c){a=ni(a);a:{if(a>=b){break a}c=0;if(a<=E(0)){break a}if(a<E(4294967296)&a>=E(0)){c=~~a>>>0;break a}}return c}function Zo(a){var b=0,c=0;c=fb-16|0;fb=c;a=vb(c+12|0,a);b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];VY(a);Db(b)}fb=c+16|0}function Si(a){var b=0,c=0;c=fb-16|0;fb=c;a=vb(c+12|0,a);b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];Yo(a);Db(b)}fb=c+16|0}function RT(a){var b=0,c=0;c=fb-16|0;fb=c;a=vb(c+12|0,a);b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];HB(a);Db(b)}fb=c+16|0}function PU(a,b,c,d,e){x[a+12>>2]=e;x[a+8>>2]=d;x[a+4>>2]=c;x[a>>2]=b;if(b){Bd(b,a)}if(c){Bd(c,a)}if(d){Bd(d,a)}if(e){Bd(e,a)}}function L5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((b|0)!=(c|0)){v[d|0]=y[b|0];d=d+1|0;b=b+1|0;continue}break}return c|0}function $B(a){var b=0,c=0;c=fb-16|0;fb=c;a=vb(c+12|0,a);b=x[a>>2];if(x[b>>2]){VU(b);a=x[a>>2];b=x[a>>2];Yo(a);Db(b)}fb=c+16|0}function jO(a){a=a|0;var b=0,c=0;b=fb-16|0;fb=b;c=fu(Ec(8));x[c+4>>2]=a;x[c>>2]=48416;a=yf(b+12|0,c);fb=b+16|0;return x[a>>2]}function cv(a,b,c,d){var e=0,f=0,g=0,h=0;e=fb-16|0;fb=e;f=b;b=c-b|0;g=e,h=bC(d,f,b)+b|0,x[g+12>>2]=h;rc(a,c,e+12|0);fb=e+16|0}function bN(a){a=a|0;var b=0,c=0;b=fb-16|0;fb=b;c=OM(Ec(8));x[c+4>>2]=a;x[c>>2]=73448;a=yf(b+12|0,c);fb=b+16|0;return x[a>>2]}function Zx(a,b){var c=0,d=0,e=0,f=0;c=Df(b);d=Ec(c+13|0);x[d+8>>2]=0;x[d+4>>2]=c;x[d>>2]=c;e=a,f=zc(nc(d),b,c+1|0),x[e>>2]=f}function OG(a){a=a|0;var b=0;a=Fb(a);x[31609]=0;O(130,a|0,13785);b=x[31609];x[31609]=0;if((b|0)==1){b=N()|0;tb(a);Q(b|0);p()}}function Mr(a,b){return Gk(y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24),y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))?b:a}function G3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(lh(a,x[b+8>>2],0)){Ux(b,c,d);return}a=x[a+8>>2];ib[x[x[a>>2]+28>>2]](a,b,c,d)}function qK(a,b,c,d,e,f){a=ib[x[x[a+8>>2]>>2]](a+8|0)|0;a=xt(c,d,a,a+168|0,f,e,0)-a|0;if((a|0)<=167){x[b>>2]=((a|0)/12|0)%7}}function mK(a,b,c,d,e,f){a=ib[x[x[a+8>>2]>>2]](a+8|0)|0;a=st(c,d,a,a+168|0,f,e,0)-a|0;if((a|0)<=167){x[b>>2]=((a|0)/12|0)%7}}function Xl(a,b){var c=0;a:{if(A[a+12>>2]<b>>>0){c=0;if(!(ib[x[x[a>>2]+32>>2]](a,0,b)|0)){break a}}x[a+12>>2]=b;c=1}return c}function Sc(a,b,c){var d=0;d=a;a=c&31;if((c&63)>>>0>=32){c=b>>31;a=b>>a}else{c=b>>a;a=((1<<a)-1&b)<<32-a|d>>>a}hb=c;return a}function HY(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;w[c+14>>1]=b;if((dm(x[a>>2],x[a+4>>2])|0)!=65535){E0(a,c+14|0)}fb=c+16|0}function Gg(a,b,c){var d=0;d=4;a:{b:{switch(b-1|0){case 0:d=c;break a;case 1:break b;default:break a}}d=c?3:2}return Mo(a,d)}function GT(a){uB(a);x[a>>2]=0;x[a+4>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;a=og(a);og(a+12|0);v[a+24|0]=1}function El(a,b,c,d){var e=0;e=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=e;e=x[b+12>>2];x[a+8>>2]=x[b+8>>2];x[a+12>>2]=e;zA(a,c,d)}function lr(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return ib[x[x[a>>2]+12>>2]](a,b,c,d,e,f,g,h)|0}function Lha(a,b,c){a=a|0;b=b|0;c=E(c);var d=0,e=0;if(b>>>0<=2){d=(a+b|0)+4232|0,e=Bh(E(Pd(c,E(0))*E(127))),v[d|0]=e;lu(a)}}function Fia(a,b,c){a=a|0;b=b|0;c=E(c);var d=0,e=0;if(b>>>0<=3){d=(a+b|0)+4264|0,e=Bh(E(Pd(c,E(0))*E(255))),v[d|0]=e;ru(a)}}function yI(a,b,c,d,e,f,g,h,i){x[a>>2]=b;x[a+4>>2]=c;x[a+8>>2]=d;x[a+12>>2]=e&65535|(i>>>16&32768|(e&2147418112)>>>16)<<16}function jp(a){x[a+32>>2]=0;x[a+24>>2]=0;x[a+28>>2]=0;x[a>>2]=0;x[a+4>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;x[a+16>>2]=0;return a}function IC(a){x[a>>2]=0;x[a+4>>2]=0;x[a+24>>2]=0;x[a+28>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;return a}function ER(a,b){var c=0;if(!(y[a|0]!=y[b|0]|C[a+8>>3]!=C[b+8>>3]|y[a+16|0]!=y[b+16|0])){c=x[a+20>>2]==x[b+20>>2]}return c}function Cu(a,b,c){c=c&255;while(1){a:{if(!b){a=0;break a}if(mc(y[a|0],c)){break a}b=b-1|0;a=a+1|0;continue}break}return a}function $G(a,b){x[a>>2]=b;pL(a+4|0);x[a+24>>2]=0;x[a+28>>2]=0;x[a+16>>2]=0;x[a+20>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;return a}function oe(a,b){return(y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))==(y[b|0]|y[b+1|0]<<8|(y[b+2|0]<<16|y[b+3|0]<<24))}function VX(a,b,c){c=c&65535;while(1){a:{if((a|0)!=(b|0)){if((c|0)!=z[a>>1]){break a}}else{a=b}return a}a=a+2|0;continue}}function He(a,b,c){var d=0;a:{if((b|0)>(c|0)){break a}d=x[a>>2];if((d|0)>=(b|0)){b=c;if((d|0)<=(b|0)){break a}}x[a>>2]=b}}function Ep(a,b,c){var d=0;a:{if(b>>>0>c>>>0){break a}d=x[a>>2];if(d>>>0>=b>>>0){b=c;if(d>>>0<=b>>>0){break a}}x[a>>2]=b}}function qF(a,b){var c=0;c=Iua(b&255,0,1536,0);b=hb;a=Iua(a&255,0,25,0);c=a+c|0;b=hb+b|0;hb=a>>>0>c>>>0?b+1|0:b;return c}function ph(a,b,c,d,e){var f=0;f=fb-16|0;fb=f;x[f+12>>2]=e;c=rh(f+8|0,c);a=qt(a,b,d,x[f+12>>2]);qh(c);fb=f+16|0;return a}function iY(a,b){var c=0;c=fb-16|0;fb=c;a:{if(!jh(a,4)){qD(b);break a}mh(c+8|0,b);ZC(c,a,x[c+8>>2],x[c+12>>2])}fb=c+16|0}function hV(a,b,c,d,e,f,g){v[a+17|0]=g;v[a+16|0]=f;x[a+12>>2]=e;x[a+8>>2]=d;x[a+4>>2]=c;x[a>>2]=b;if(d){eV(a,1);eV(a,0)}}function gV(a,b,c,d,e,f,g){v[a+17|0]=g;v[a+16|0]=f;x[a+12>>2]=e;x[a+8>>2]=d;x[a+4>>2]=c;x[a>>2]=b;if(d){fV(a,1);fV(a,0)}}function fW(a){var b=0;if(!(y[a+35|0]&2)){a=a+68|0;b=9;while(1){if(b){x[a>>2]=268435456;b=b-1|0;a=a+4|0;continue}break}}}function dL(a){var b=0;b=x[a+12>>2];if((b|0)==x[a+16>>2]){return ib[x[x[a>>2]+40>>2]](a)|0}x[a+12>>2]=b+4;return x[b>>2]}function KW(a){var b=0,c=0;while(1){b=c;if((b|0)!=8){c=b+1|0;if((y[a+b|0]-32&255)>>>0<95){continue}}break}return(b|0)==8}function hT(a,b,c,d){var e=0,f=0;if(c&255){e=a,f=Yb(x[a>>2]+((D(c<<24>>24,(d^-1|-256)+b|0)|0)/2|0)|0,0,256),x[e>>2]=f}}function ff(a){var b=0;b=x[a+32>>2];a:{if(b>>>0>=A[a+40>>2]){x[a+96>>2]=1;a=0;break a}x[a+32>>2]=b+1;a=y[b|0]}return a}function eu(a){a=a|0;var b=0;x[a>>2]=47628;Bd(a,0);b=x[a+8>>2];if(b){ib[x[x[b>>2]+4>>2]](b)}x[a+8>>2]=0;return Qm(a)|0}function eF(a){var b=0;b=0;a:{if(jd(a,14249,3)){break a}a=y[a+3|0];b=1;if((a|0)==1){break a}b=(a-8&255)>>>0<7}return b}function e3(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=b;b=0;return ib[a|0](h|b,c,d,e,b|f,g)|0}function bla(a){a=a|0;var b=0,c=0;b=fb-16|0;fb=b;c=yf(b+12|0,Rb(Ec(6668),0,6668));fb=b+16|0;x[a>>2]=x[c>>2];return a|0}function Yfa(a){a=a|0;var b=0;b=fb-16|0;fb=b;if(a){a=qc(b+8|0,a);a=Sz(x[a>>2],x[a+4>>2])}else{a=0}fb=b+16|0;return a|0}function XZ(a,b,c){var d=0;while(1){if(b){d=y[c|0]|y[c+1|0]<<8;v[a|0]=d;v[a+1|0]=d>>>8;b=b-1|0;a=a+2|0;continue}break}}function HX(a){var b=0;if(!(jd(a,13926,3)|y[a+3|0]>31|(v[a+27|0]<0|y[a+32|0]>64))){b=(y[a+33|0]-1&255)>>>0<32}return b}function $u(a){var b=0,c=0,d=0;d=a*a;a=0;b=1;c=1;while(1){a=a+2;c=d*c/(a*a);b=b+c;if(b*1e-7<c){continue}break}return b}function xK(a,b,c){var d=0;d=fb-16|0;fb=d;x[d+12>>2]=c;b=rh(d+8|0,b);a=wK(a,9278,x[d+12>>2]);qh(b);fb=d+16|0;return a}function tga(a,b,c){a=a|0;b=b|0;c=E(c);var d=0,e=E(0);if(b>>>0<=2){c=Pd(c,E(0));d=yb(a+4208|0,b),e=c,B[d>>2]=e;TP(a)}}function si(a){var b=0;while(1){a:{if((b|0)!=47){if(y[b+42160|0]!=(a|0)){break a}}else{b=0}return b}b=b+1|0;continue}}function oha(a,b,c){a=a|0;b=b|0;c=E(c);var d=0,e=E(0);if(b>>>0<=5){c=Pd(c,E(0));d=yb(a+4208|0,b),e=c,B[d>>2]=e;gQ(a)}}function mga(a,b,c){a=a|0;b=b|0;c=E(c);var d=0,e=E(0);if(b>>>0<=3){c=Pd(c,E(0));d=yb(a+4208|0,b),e=c,B[d>>2]=e;RP(a)}}function gha(a,b,c){a=a|0;b=b|0;c=E(c);var d=0,e=E(0);if(b>>>0<=4){c=Pd(c,E(0));d=yb(a+4208|0,b),e=c,B[d>>2]=e;cQ(a)}}function gH(a,b,c){a=Ge(a);a:{if(a>=b){break a}c=0;if(a<=0){break a}if(a<4294967296&a>=0){c=~~a>>>0;break a}}return c}function Y8(a,b){a=a|0;b=b|0;var c=0,d=0;ib[x[x[a>>2]+24>>2]](a)|0;b=KD(x[b>>2]);x[a+36>>2]=b;c=a,d=ho(b),v[c+44|0]=d}function Rs(a){if(a>>>0<=131071){return y[(a>>>3&31|y[(a>>>8|0)+112800|0]<<5)+112800|0]>>>(a&7)&1}return a>>>0<196606}function Q8(a,b){a=a|0;b=b|0;var c=0,d=0;ib[x[x[a>>2]+24>>2]](a)|0;b=Py(x[b>>2]);x[a+36>>2]=b;c=a,d=ho(b),v[c+44|0]=d}function uI(a,b,c){var d=0;if(c){d=a;while(1){x[d>>2]=x[b>>2];d=d+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}return a}function oV(a){x[a+700>>2]=0;w[a+842>>1]=0;x[a+688>>2]=0;x[a>>2]=0;x[a+4>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;x[a+16>>2]=0}function f0(a){var b=0,c=0;c=x[a>>2];b=x[a+4>>2];while(1){if((b|0)!=(c|0)){b=b-28|0;Hd(b);continue}break}x[a+4>>2]=c}function a0(a){var b=0;if(!y[a+12|0]){b=fb-16|0;fb=b;vb(b+12|0,x[x[a+8>>2]>>2]);vb(b+8|0,x[x[a+4>>2]>>2]);fb=b+16|0}}function Kp(a){var b=0,c=0;c=x[a>>2];b=x[a+4>>2];while(1){if((b|0)!=(c|0)){b=b-36|0;Gp(b);continue}break}x[a+4>>2]=c}function Gh(a){var b=0;on(a);b=pv(x[a>>2],_k(z[a+34>>1]));x[a+20>>2]=b;if(!b){return 0}return Rk(x[a>>2],z[a+34>>1])}function A8(a){a=a|0;var b=0,c=0;c=x[a+4>>2];b=x[a>>2];a=x[a+8>>2];b=b+(a>>1)|0;if(a&1){c=x[c+x[b>>2]>>2]}ib[c|0](b)}function uh(a){var b=0;b=fb-16|0;fb=b;x[b+12>>2]=a;x[b+8>>2]=2147483647;a=Hb(b+12|0,b+8|0);fb=b+16|0;return x[a>>2]}function pr(a){var b=0,c=0,d=0;if(x[a>>2]){Nc(a);b=x[a>>2];Vg(a);Db(b);c=Ab(a),d=0,x[c>>2]=d;x[a>>2]=0;x[a+4>>2]=0}}function oR(a){var b=0,c=0,d=0;if(x[a>>2]){Nc(a);b=x[a>>2];hw(a);Db(b);c=Ab(a),d=0,x[c>>2]=d;x[a>>2]=0;x[a+4>>2]=0}}function bV(a){var b=0,c=0,d=0;if(x[a>>2]){Nc(a);b=x[a>>2];In(a);Db(b);c=Ab(a),d=0,x[c>>2]=d;x[a>>2]=0;x[a+4>>2]=0}}function bU(a){var b=0,c=0,d=0;if(x[a>>2]){Nc(a);b=x[a>>2];Tn(a);Db(b);c=Ab(a),d=0,x[c>>2]=d;x[a>>2]=0;x[a+4>>2]=0}}function Ota(a,b){a=a|0;b=b|0;var c=0,d=0;b=fb-80|0;fb=b;c=-1;d=a;a=b+14|0;if(O$(d,a)){c=N$(a)}fb=b+80|0;return c|0}function zc(a,b,c){var d=0;if(c){d=a;while(1){v[d|0]=y[b|0];d=d+1|0;b=b+1|0;c=c-1|0;if(c){continue}break}}return a}function qua(a,b){a=a|0;b=b|0;var c=0,d=0;b=fb-16|0;fb=b;c=-1;d=a;a=b+8|0;if(ik(d,a)){c=r0(a)}fb=b+16|0;return c|0}function kM(a,b){var c=0;c=fb-16|0;fb=c;a=Xo(c+4|0,a,1);po(x[a+4>>2],y[b|0]);x[a+4>>2]=x[a+4>>2]+1;kc(a);fb=c+16|0}function j0(a,b,c,d,e){v[a+4|0]=b;v[a|0]=69;v[a+1|0]=99;v[a+2|0]=104;v[a+3|0]=111;v[a+7|0]=e;v[a+6|0]=d;v[a+5|0]=c}function Xpa(a,b){a=a|0;b=b|0;var c=0,d=0;b=fb-16|0;fb=b;c=-1;d=a;a=b+4|0;if(dE(d,a)){c=OX(a)}fb=b+16|0;return c|0}function Lqa(a,b){a=a|0;b=b|0;var c=0,d=0;b=fb-16|0;fb=b;c=-1;d=a;a=b+8|0;if(ik(d,a)){c=wY(a)}fb=b+16|0;return c|0}function EL(a,b,c){var d=0,e=0,f=0;e=c*c;C[a>>3]=e;f=c;d=c*134217729;c=d+(c-d);d=f-c;C[b>>3]=d*d+((c+c)*d+(c*c-e))}function ut(a,b){a:{if((a|0)==(b|0)){break a}while(1){b=b-4|0;if(b>>>0<=a>>>0){break a}Tb(a,b);a=a+4|0;continue}}}function pT(a,b){var c=0;c=b&15;if(c){v[a+827|0]=c<<2}b=b&240;if(b){v[a+826|0]=b>>>4}x[a+88>>2]=x[a+88>>2]|262144}function hL(a,b){a=a|0;b=b|0;var c=0;c=x[a>>2];a:{if(!c){break a}if(!mc(kL(c,b),-1)){break a}x[a>>2]=0}return a|0}function dS(a,b){var c=0;c=fb-16|0;fb=c;a=kC(c+4|0,a);uq(x[a+4>>2],x[b>>2]);x[a+4>>2]=x[a+4>>2]+4;kc(a);fb=c+16|0}function bQ(a){a=a|0;x[a+4244>>2]=0;x[a+4248>>2]=0;x[a+4228>>2]=0;x[a+4232>>2]=0;a=a+4252|0;x[a>>2]=0;x[a+4>>2]=0}function Nda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(a){c=a;a=ib[x[x[b>>2]+8>>2]](b)|0;d=c,e=Cg(a?a:22292),x[d>>2]=e}}function JR(a,b){var c=0,d=0;c=x[a+4>>2];d=x[b+4>>2];if((c|0)==(d|0)){a=IR(x[a>>2],c,x[b>>2],d)}else{a=1}return!a}function Il(a,b){var c=0;c=b&15;if(c){v[a+824|0]=c<<2}b=b&240;if(b){v[a+823|0]=b>>>4}x[a+88>>2]=x[a+88>>2]|131072}function Em(a,b){a:{if((a|0)==(b|0)){break a}while(1){b=b-1|0;if(b>>>0<=a>>>0){break a}rg(a,b);a=a+1|0;continue}}}function _P(a){var b=0,c=0;c=x[a+4>>2];b=x[a+8>>2];while(1){if((b|0)!=(c|0)){b=b-4|0;x[a+8>>2]=b;continue}break}}function _A(a,b){var c=0;c=fb-16|0;fb=c;a=ye(c+8|0,Jua(a,b,1e6,0),hb);b=x[a>>2];fb=c+16|0;hb=x[a+4>>2];return b}function YM(a,b,c){while(1){a:{if((a|0)!=(b|0)){if(!Nd(c,x[a>>2])){break a}}else{a=b}return a}a=a+8|0;continue}}function Ll(a,b){var c=0;c=1;a:{switch((b&255)-4|0){default:c=(a&255)==11;break;case 0:case 2:break a}}return c}function yH(a,b){var c=0,d=0;c=a+68|0;a=0;while(1){if((a|0)!=9){d=yb(c,a);a=a+1|0;x[d>>2]=a<<b;continue}break}}function lh(a,b,c){if(!c){return x[a+4>>2]==x[b+4>>2]}if((a|0)==(b|0)){return 1}return!ji(x[a+4>>2],x[b+4>>2])}function kf(a,b){var c=0;c=x[a+4>>2];if(b){a=x[a>>2];x[a>>2]=x[a>>2]|c;return}a=x[a>>2];x[a>>2]=x[a>>2]&(c^-1)}function jw(a,b){var c=0;c=fb-16|0;fb=c;x[c+12>>2]=(D(a,b)>>>0)/255;He(c+12|0,0,15);fb=c+16|0;return y[c+12|0]}function cm(a){var b=0;b=fb-16|0;fb=b;x[b+12>>2]=a;x[b+8>>2]=65535;a=Hb(b+12|0,b+8|0);fb=b+16|0;return z[a>>1]}function cR(a){var b=0;b=fb-16|0;fb=b;x[b+12>>2]=a;x[b+8>>2]=32767;a=Hb(b+12|0,b+8|0);fb=b+16|0;return w[a>>1]}function Qs(a){if(a>>>0<=131071){a=y[(a>>>3&31|y[(a>>>8|0)+116704|0]<<5)+116704|0]>>>(a&7)&1}else{a=0}return a}function Kha(a,b){a=a|0;b=b|0;var c=E(0);if(b>>>0<=2){c=E(E(y[(a+b|0)+4232|0])/E(127))}else{c=E(0)}return E(c)}function En(a){a=y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24);return a<<24|(a&65280)<<8|(a>>>8&65280|a>>>24)}function Eia(a,b){a=a|0;b=b|0;var c=E(0);if(b>>>0<=3){c=E(E(y[(a+b|0)+4264|0])/E(255))}else{c=E(0)}return E(c)}function x2(a){a=a|0;var b=0,c=0,d=0;b=fb-32|0;fb=b;c=-1;d=a;a=b+8|0;if(LG(d,a)){c=KG(a)}fb=b+32|0;return c|0}function vq(a,b){var c=0;c=fb-32|0;fb=c;mh(c+16|0,b);Om(c+24|0,a,x[c+16>>2],x[c+20>>2]);mh(c+8|0,b);fb=c+32|0}function ew(a){var b=0;b=fb-16|0;fb=b;w[b+14>>1]=a;w[b+12>>1]=255;a=Oc(b+14|0,b+12|0);fb=b+16|0;return y[a|0]}function _3(){if(y[499812]){return x[124952]}zs(499804,x[oH()>>2]);v[499812]=1;x[124952]=499804;return 499804}function XP(a){a=a|0;var b=0;b=4960;while(1){b=b-24|0;wc(b+a|0);if((b|0)!=4504){continue}break}return _f(a)|0}function Sx(a,b,c,d,e,f,g){var h=0;h=b>>8;if(b&1){h=Tx(x[e>>2],h)}ib[x[x[a>>2]+20>>2]](a,c,d,e+h|0,b&2?f:2,g)}function R1(a){a=a|0;var b=0,c=0,d=0;b=fb-16|0;fb=b;c=-1;d=a;a=b+8|0;if(ik(d,a)){c=hG(a)}fb=b+16|0;return c|0}function OR(a,b){a:{switch(b-1|0){default:return a+724|0;case 0:return a+732|0;case 1:break a}}return a+740|0}function Nl(a,b,c,d){var e=0;e=fb-16|0;fb=e;x[e+12>>2]=d;x[e+8>>2]=c;Zb(a,b,x[Hb(e+12|0,e+8|0)>>2]);fb=e+16|0}function Fk(a,b){var c=0;c=fb-16|0;fb=c;x[c+12>>2]=a;a=c+12|0;x[a>>2]=x[a>>2]+(b<<2);fb=c+16|0;return x[a>>2]}function DS(a){x[a>>2]=0;x[a+4>>2]=0;x[a+24>>2]=0;x[a+28>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;x[a+16>>2]=0;return a}function oK(a,b,c,d,e){b=jj(b,c,d,e,4);if(!(y[d|0]&4)){x[a>>2]=((b|0)<69?b+2e3|0:b>>>0<100?b+1900|0:b)-1900}}function mL(a){var b=0;b=x[a+12>>2];if((b|0)==x[a+16>>2]){return ib[x[x[a>>2]+36>>2]](a)|0}return zf(v[b|0])}function kK(a,b,c,d,e){b=ij(b,c,d,e,4);if(!(y[d|0]&4)){x[a>>2]=((b|0)<69?b+2e3|0:b>>>0<100?b+1900|0:b)-1900}}function MU(a){var b=0;b=x[a+4>>2];w[a+70>>1]=y[((z[b+20>>1]>>>6|z[b+22>>1]<<4)&65535)+27392|0]>>>z[a+68>>1]}function wfa(){var a=0;a=fb-16|0;fb=a;if($a(a+12|0,4)|0){It(x[31484],12726);p()}fb=a+16|0;return x[a+12>>2]}function ti(a){var b=0;b=fb-16|0;fb=b;x[b+12>>2]=a;x[b+8>>2]=255;a=Hb(b+12|0,b+8|0);fb=b+16|0;return y[a|0]}function rV(a,b){a=a|0;b=b|0;var c=0;c=Cb(x[a+4>>2],y[a+11|0]);if(c>>>0<b>>>0){ws(a,b-c|0,0);return}WT(a,b)}function rA(a,b){a=Nb(a);x[a+20>>2]=0;x[a+12>>2]=0;x[a+16>>2]=0;Nb(a+24|0);Fb(a+36|0);x[a+48>>2]=b;return a}function iea(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return UH(a,b,c,d,e,f,g,12993,1078)|0}function aea(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return UH(a,b,c,d,e,f,g,13061,1085)|0}function aY(a,b){v[a+6|0]=255;x[a+16>>2]=0;w[a+4>>1]=0;x[a>>2]=0;if(b>=0){C[a+8>>3]=b;x[a+16>>2]=3}return a}function VL(a,b,c,d){B[d+4>>2]=a+c;a=E(a+E(c*E(-.5)));b=E(b*E(.8660253882408142));B[d+8>>2]=a-b;B[d>>2]=b+a}function Uqa(a,b){a=a|0;b=b|0;if(!RY(a,b)){v[b+4|0]=0;v[b+5|0]=0;v[b|0]=0;v[b+1|0]=0;v[b+2|0]=0;v[b+3|0]=0}}function Pl(a,b,c,d){a=a&65535;c=c&65535;a=(a|0)!=(c|0)?a>>>0<c>>>0?-1:1:0;if(Mj(a)){a=aU(b,d)}return vd(a)}function Ax(a){var b=0;b=fb-16|0;fb=b;x[b+12>>2]=a;x[b+12>>2]=x[b+12>>2]+12;fb=b+16|0;return Op(x[b+12>>2])}function Pu(a){var b=0,c=0;while(1){if(b>>>0>=8){a=c<<24>>24}else{b=b+15|0;c=Co(a);continue}break}return a}function Ow(a,b){a:{switch(b-1|0){default:return a+48|0;case 0:return a+68|0;case 1:break a}}return a+88|0}function LW(a,b){var c=0;c=b&255;b=c>>>24|0;a=a&255?1120:1056;c=a+(c<<8)|0;hb=a>>>0>c>>>0?b+1|0:b;return c}function tl(a){var b=0;b=x[a+12>>2];if((b|0)==x[a+16>>2]){return ib[x[x[a>>2]+36>>2]](a)|0}return x[b>>2]}function hI(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=a;a=0;return Jz(g|a,b,c,d,a|e,f)|0}function dJ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;x[e>>2]=c;x[h>>2]=f;return 3}function Ob(a,b){var c=0;c=fb-16|0;fb=c;WF(c+8|0,a,b);a=Gb(x[x[c+8>>2]>>2],x[c+12>>2]);fb=c+16|0;return a}function Ns(a,b,c,d,e,f){var g=0;g=b>>8;if(b&1){g=Tx(x[d>>2],g)}ib[x[x[a>>2]+24>>2]](a,c,d+g|0,b&2?e:2,f)}function N$(a){return(y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))==1179468868&(y[a+4|0]-1&255)>>>0<10}function MN(a,b){a=a|0;b=b|0;a=Ej(a);x[a+4>>2]=0;x[a>>2]=47568;x[a+4>>2]=x[b+4>>2];x[b+4>>2]=0;return a|0}function Cua(a){a=a|0;var b=0;b=x[a+76>>2];if(mc(-1,b)){b=mF(x[a+28>>2],32);x[a+76>>2]=b}return b<<24>>24}function yX(a){var b=0;a=a&15;b=0;a:{if(!a){break a}b=12-a|0;if(a>>>0<=12){break a}b=24-a|0}return b&255}function wda(a){a=a|0;var b=0;b=fb-16|0;fb=b;fe(b+8|0,a);a=Sz(x[b+8>>2],x[b+12>>2]);fb=b+16|0;return a|0}function vW(a,b){var c=0;c=x[a+4>>2];while(1){if((b|0)!=(c|0)){c=c-12|0;yC(c);continue}break}x[a+4>>2]=b}function nS(a,b){var c=0;c=x[a+4>>2];while(1){if((b|0)!=(c|0)){c=c-52|0;wk(c);continue}break}x[a+4>>2]=b}function mz(a,b,c){b=(D(D(kz(a),lz(a,b)),125)>>>0)/(aM(a,b)>>>0)|0;a=(a&6)==6?b&134217724:b;return a?a:c}function i0(a,b){a=rm(a,x[b>>2],x[b+4>>2]);x[a+8>>2]=x[b+8>>2];rm(a+12|0,x[b+12>>2],x[b+16>>2]);return a}function fl(a,b){var c=0;c=fb-16|0;fb=c;x[c+12>>2]=a;x[c+12>>2]=x[c+12>>2]-b;fb=c+16|0;return x[c+12>>2]}function eU(a,b){var c=0;c=x[a+4>>2];while(1){if((b|0)!=(c|0)){c=c-12|0;tf(c);continue}break}x[a+4>>2]=b}function dda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return CO(x[a+4>>2],b,c,d,e,f,g)|0}function ada(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return vO(x[a+4>>2],b,c,d,e,f,g)|0}function UU(a,b){var c=0;c=x[a+4>>2];while(1){if((b|0)!=(c|0)){c=c-32|0;Bk(c);continue}break}x[a+4>>2]=b}function TE(a,b){var c=0;c=x[a+4>>2];while(1){if((b|0)!=(c|0)){c=c-20|0;ub(c);continue}break}x[a+4>>2]=b}function Pb(a,b,c){var d=0;c=c+x[a+4>>2]|0;d=b;b=x[a>>2]+b|0;c=d>>>0>b>>>0?c+1|0:c;x[a>>2]=b;x[a+4>>2]=c}function HT(a,b,c){var d=E(0);a:{if(b>c){break a}d=B[a>>2];if(!(d<b)){b=c;if(!(d>b)){break a}}B[a>>2]=b}}function pj(a){a:{a=a&74;if(a){if((a|0)==64){return 8}if((a|0)!=8){break a}return 16}return 0}return 10}function fv(a,b){b=Iua(a,a>>31,b,b>>31);a=hb;b=b+5e5|0;a=b>>>0<5e5?a+1|0:a;return Gc(Jua(b,a,1e6,0),hb)}function My(a){if(!x[a+136>>2]){x[a+136>>2]=x[x[124115]>>2]?104928:104904}if(!x[a+72>>2]){x[a+72>>2]=1}}function MJ(a){var b=0,c=0;b=fb-16|0;fb=b;a=rh(b+12|0,a);c=x[x[124115]>>2];qh(a);fb=b+16|0;return c?4:1}function IT(a,b){var c=0,d=0;a:{if(b<0){break a}c=C[a>>3];if(!(c<0)){d=b;if(!(b<c)){break a}}C[a>>3]=d}}function np(a){a=a|0;var b=0,c=0;b=fb-16|0;fb=b;if(On(a,b+12|0)){c=$b(x[b+12>>2])}fb=b+16|0;return c|0}function Qk(a){a=a|0;var b=0,c=0;b=fb-16|0;fb=b;if(Cp(a,b+14|0)){c=Bb(z[b+14>>1])}fb=b+16|0;return c|0}function zv(a){var b=0;b=x[a+4>>2];a:{if((b|0)!=31){b=b+1|0;break a}x[a>>2]=x[a>>2]+4;b=0}x[a+4>>2]=b}function yS(a){a=Fb(a);Fb(a+12|0);Fb(a+24|0);Fb(a+36|0);Fb(a+48|0);Fc(a+60|0,0);x[a+64>>2]=0;return a}function dw(a){var b=0,c=0;if(x[a>>2]){Nc(a);Db(x[a>>2]);b=Ab(a),c=0,x[b>>2]=c;x[a>>2]=0;x[a+4>>2]=0}}function _v(a){a=a|0;var b=0;w[a+34>>1]=0;b=a+43|0;Rm(b,b+22|0,78544);x[a+20>>2]=0;nd(a,0);return a|0}function YZ(a,b){var c=0,d=0,e=0;c=fb-16|0;fb=c;d=c,e=Bb(b&65535),w[d+14>>1]=e;Wv(a,c+14|0);fb=c+16|0}function Rb(a,b,c){var d=0;if(c){d=a;while(1){v[d|0]=b;d=d+1|0;c=c-1|0;if(c){continue}break}}return a}function FV(a){if(((y[a+68|0]|y[a+69|0]<<8)-128&65535)>>>0>=65409){a=jd(a,18321,17)}else{a=1}return!a}function xqa(a){a=a|0;var b=0;b=fb-16|0;fb=b;a=Cp(a,b+14|0);fb=b+16|0;return(a?z[b+14>>1]:0)<<16>>16}function vS(a){x[a+20>>2]=0;v[a+16|0]=7;x[a+8>>2]=1889785610;x[a+12>>2]=1072630333;v[a|0]=3;return a}function tf(a){var b=0,c=0;b=fb-16|0;fb=b;a=x[vb(b+12|0,a)>>2];c=x[a>>2];if(c){Ab(a);Db(c)}fb=b+16|0}function fia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=yj(a);if(a){ib[x[x[a>>2]+88>>2]](a,b,c,d,e)}}function bE(a,b){if(b>>>0<=126){Ue(((b<<5)+a|0)+480280|0);Po((D(b,872)+a|0)+1074992|0,a,b,67108864)}}function al(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;v[a+6|0]=0;v[a+7|0]=0}function R9(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;M0(c+8|0,b);yp(a,x[c+8>>2],x[c+12>>2]);fb=c+16|0}function QH(a,b,c){var d=0;d=fb-16|0;fb=d;c=Dc(d+4|0,c);a=pc(a,c);tb(c);x[a>>2]=b;fb=d+16|0;return a}function Ig(a,b,c){var d=0;d=x[a>>2];c=x[a+4>>2]-(c+(d>>>0<b>>>0)|0)|0;b=d-b|0;x[a>>2]=b;x[a+4>>2]=c}function HV(a){ke(a+140|0);ub(a+120|0);ub(a+100|0);ub(a+80|0);ub(a+60|0);ub(a+40|0);ub(a+20|0);ub(a)}function GE(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;v[a+6|0]=0}function BZ(a,b){var c=0;c=x[a>>2];x[a>>2]=b;if(c){AZ(c+52|0);tb(c+40|0);wc(c+16|0);wc(c+4|0);Db(c)}}function B1(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;Fn(c+8|0,b);yp(a,x[c+8>>2],x[c+12>>2]);fb=c+16|0}function A1(a,b){a=a|0;b=b|0;x[a>>2]=0;x[a+4>>2]=0;Fc(a+8|0,0);Vr(a,127);MF(a,127,y[b|0]);return a|0}function py(a,b,c,d,e){var f=0;f=fb-16|0;fb=f;e=rh(f+12|0,e);a=eq(a,b,c,d);qh(e);fb=f+16|0;return a}function nJ(a,b,c){a:{if(!(y[b+120|0]|c>>>0>30)){v[b+120|0]=1;break a}b=EY(c)}x[a+4>>2]=c;x[a>>2]=b}function mn(a,b,c){var d=0,e=0;d=fb-16|0;fb=d;e=a;a=Zb(d+8|0,b,c);cc(e,x[a>>2],x[a+4>>2]);fb=d+16|0}function hU(a,b,c){var d=0;d=fb-16|0;fb=d;a=vb(d+12|0,$T(b,c,de(a),gc(a)));fb=d+16|0;return x[a>>2]}function bia(a,b,c){a=a|0;b=b|0;c=c|0;a=yj(a);if(!a){return 0}return ib[x[x[a>>2]+104>>2]](a,b,c)|0}function _R(a,b){if(b>>>0<=255){a=x[((b<<2)+a|0)+900380>>2];a=a?a+492|0:22292}else{a=22292}return a}function Uc(a,b){var c=0;c=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=c;x[a+8>>2]=x[b+8>>2];wx(b);return a}function Kda(a,b){a=a|0;b=b|0;var c=0;b=Kb(b);c=x[a+4>>2];if(c){ib[c|0](b,x[a+8>>2]);return}ju(b,a)}function IF(a,b,c,d,e,f,g){a=vb(a,b);vb(a+4|0,c);vb(a+8|0,d);vb(a+12|0,e);vb(a+16|0,f);vb(a+20|0,g)}function Ei(a,b,c,d,e){var f=0;f=fb-16|0;fb=f;e=rh(f+12|0,e);a=iK(a,b,c,d);qh(e);fb=f+16|0;return a}function $5(a,b,c){a=a|0;b=b|0;c=c|0;if(c>>>0<=127){a=(x[(c<<2)+95344>>2]&b)!=0}else{a=0}return a|0}function Qw(a){a=a|0;var b=0;b=fb-16|0;fb=b;a=eh(a,b+15|0);fb=b+16|0;return(a?y[b+15|0]:0)<<24>>24}function qw(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;d=a;a=Dc(c+4|0,b);Uc(d,a);tb(a);fb=c+16|0}function nra(a){a=a|0;var b=0;b=fb-16|0;fb=b;a=On(a,b+12|0);fb=b+16|0;return E(a?B[b+12>>2]:E(0))}function mea(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ZH(a,b,c,d,e,f,10664,1075)|0}function kt(a,b){a=a|0;b=b|0;b=x[b+68>>2];v[a|0]=b;v[a+1|0]=b>>>8;v[a+2|0]=b>>>16;v[a+3|0]=b>>>24}function gg(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;d=a;a=uc(c+4|0,b);Uc(d,a);tb(a);fb=c+16|0}function cK(a,b){a=a|0;b=b|0;b=x[b+64>>2];v[a|0]=b;v[a+1|0]=b>>>8;v[a+2|0]=b>>>16;v[a+3|0]=b>>>24}function Zea(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ZH(a,b,c,d,e,f,10709,1048)|0}function ZJ(a,b){a=a|0;b=b|0;b=x[b+72>>2];v[a|0]=b;v[a+1|0]=b>>>8;v[a+2|0]=b>>>16;v[a+3|0]=b>>>24}function Od(){var a=0;if(y[499788]){return x[124946]}a=nk(14337);v[499788]=1;x[124946]=a;return a}function $Q(a,b){var c=0;c=fb-16|0;fb=c;a=ye(c+8|0,a,b);b=x[a>>2];fb=c+16|0;hb=x[a+4>>2];return b}function yua(a,b){a=a|0;b=b|0;if(!BE(a,b)){v[b+1|0]=0;v[b+2|0]=0;v[b+3|0]=0;v[b+4|0]=0;v[b|0]=0}}function x9(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ib[x[x[a>>2]+24>>2]](a,b,c,d,e,f)|0}function w9(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ib[x[x[a>>2]+16>>2]](a,b,c,d,e,f)|0}function v9(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ib[x[x[a>>2]+28>>2]](a,b,c,d,e,f)|0}function u9(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ib[x[x[a>>2]+20>>2]](a,b,c,d,e,f)|0}function t9(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ib[x[x[a>>2]+44>>2]](a,b,c,d,e,f)|0}function rz(a,b,c,d){var e=0;e=fb-16|0;fb=e;cc(e+8|0,c,d);$M(a,b,x[e+8>>2],x[e+12>>2]);fb=e+16|0}function Yz(a,b,c){b=b-a>>2;while(1){if((b|0)>0){x[a>>2]=x[c>>2];b=b-1|0;a=a+4|0;continue}break}}function QD(a,b){var c=0;c=fb-16|0;fb=c;x[c+12>>2]=a;a=B_(c+12|0,0-b|0);fb=c+16|0;return x[a>>2]}function Om(a,b,c,d){var e=0;e=fb-16|0;fb=e;lf(e+8|0,c,d);$M(a,b,x[e+8>>2],x[e+12>>2]);fb=e+16|0}function CS(a,b,c,d){return(a|0)!=(c|0)|(b|0)!=(d|0)?a>>>0<c>>>0&(b|0)<=(d|0)|(b|0)<(d|0)?-1:1:0}function mca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;jP(a,x[b+4>>2],c,d,e,f,g)}function hca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;FO(a,x[b+4>>2],c,d,e,f,g)}function g9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ib[x[x[b>>2]+16>>2]](a,b,x[c+8>>2],x[c+12>>2],0,d)}function ax(a,b){a=bG(a,x[b>>2],x[b+4>>2]);x[a+8>>2]=x[b+8>>2];bG(a+12|0,x[b+12>>2],x[b+16>>2])}function aba(a){a=a|0;var b=0;b=fb-16|0;fb=b;a=yf(b+12|0,Ul(Ec(12),a));fb=b+16|0;return x[a>>2]}function Tja(a,b){a=a|0;b=b|0;Mi(a);Mi(a);a:{if(b>>>0>=60){Vb(a,4);break a}Mi(a)}return Mi(a)|0}function IX(a){var b=0,c=0;b=1;c=x[a>>2];a:{if((c|0)>0){b=120;if(c>>>0<121){break a}}x[a>>2]=b}}function I2(a,b){a=a|0;b=b|0;var c=0,d=0;c=fb-16|0;fb=c;d=c+4|0;YI(d,b);Rh(a,d);tb(d);fb=c+16|0}function D0(a,b){a=a|0;b=b|0;if(!BE(a,b)){v[b|0]=0;v[b+1|0]=0;v[b+2|0]=0;v[b+3|0]=0;v[b+4|0]=0}}function A3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(lh(a,x[b+8>>2],f)){Wx(b,c,d,e)}}function vK(a){var b=0;b=x[124115];if(a){x[124115]=(a|0)==-1?501692:a}return(b|0)==501692?-1:b}function dca(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;iP(a,x[x[b+4>>2]+24>>2],c,d,e,f)}function cca(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;EO(a,x[x[b+4>>2]+24>>2],c,d,e,f)}function Zd(a){a=a|0;var b=0;b=fb-16|0;fb=b;a=eh(a,b+15|0);fb=b+16|0;return(a?y[b+15|0]:0)&255}function T$(a){var b=0;if(!(jd(a,24724,20)|(y[a+25|0]-9&255)>>>0<248)){b=v[a+47|0]>=0}return b}function QW(a){var b=0,c=0;b=fb-16|0;fb=b;if(aF(a,b+12|0)){c=$b(x[b+12>>2])}fb=b+16|0;return c}function ND(a){var b=0,c=0;b=fb-16|0;fb=b;if(Cp(a,b+14|0)){c=ze(w[b+14>>1])}fb=b+16|0;return c}function IL(a){var b=0;b=+((a&2097151)>>>0);return E(kk(+E((a|0)<0?-b:b),(a>>>21&1023)-788|0))}function I$(a,b){return(Yb((D(a>>>4|0,b)>>>0)/15|0,1,15)<<4|Yb((D(a&15,b)>>>0)/15|0,1,15))&255}function gca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return gu(x[x[a+4>>2]+24>>2],b,c,d,e)|0}function fqa(a){a=a|0;var b=0,c=0;b=fb-32|0;fb=b;c=a;a=_h(b+12|0);uY(c,a,0,0);ub(a);fb=b+32|0}function fD(a,b){var c=0;c=fb-16|0;fb=c;x[c+12>>2]=a;xY(c+12|0,b);fb=c+16|0;return x[c+12>>2]}function aZ(a){return(y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))==1279544644&y[a+4|0]<32}function a$(a,b){var c=0;c=fb-16|0;fb=c;x[c+12>>2]=a;$_(c+12|0,b);fb=c+16|0;return x[c+12>>2]}function Rm(a,b,c){b=b-a|0;while(1){if((b|0)>0){v[a|0]=y[c|0];b=b-1|0;a=a+1|0;continue}break}}function Qm(a){a=a|0;var b=0;x[a>>2]=47588;b=x[a+4>>2];if(b){Db(sq(b))}x[a+4>>2]=0;return a|0}function Ic(a,b,c){var d=0;d=x[c+4>>2];if((d|0)==(b|0)){a=w_(a,b,x[c>>2],d)}else{a=1}return!a}function uf(a,b){var c=0;c=fb-16|0;fb=c;x[c+12>>2]=a;a=CU(c+12|0,b);fb=c+16|0;return x[a>>2]}function q9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return ib[x[x[a>>2]+32>>2]](a,b,c,d,e)|0}function et(a){a=a|0;var b=0;x[a>>2]=95296;b=x[a+8>>2];if(!(!b|!y[a+12|0])){Db(b)}return a|0}function TX(a,b){var c=0;c=fb-16|0;fb=c;x[c+12>>2]=a;a=SX(c+12|0,b);fb=c+16|0;return x[a>>2]}function RQ(a){var b=0;b=fb-16|0;fb=b;x[b+12>>2]=a;xY(b+12|0,-1);fb=b+16|0;return x[b+12>>2]}function OC(a){var b=0,c=0;c=a;while(1){b=c;c=b+4|0;if(x[b>>2]){continue}break}return b-a>>2}function tB(a){var b=0;x[a+84>>2]=0;x[a+88>>2]=0;b=x[a+80>>2];x[a+92>>2]=b;x[a+96>>2]=b<<12}function r0(a){return(y[a|0]|y[a+1|0]<<8|(y[a+2|0]<<16|y[a+3|0]<<24))==810369604&y[a+4|0]<4}function qy(a,b,c){var d=0;d=fb-16|0;fb=d;c=rh(d+12|0,c);a=Jt(a,b);qh(c);fb=d+16|0;return a}function gh(a){var b=0;b=fb-16|0;fb=b;a=Cp(a,b+14|0);fb=b+16|0;return(a?z[b+14>>1]:0)&65535}function gga(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Iz(a,b,c,d,e,0,0,f,g)}function eg(a){var b=0,c=0;while(1){c=b&65535;if(c>>>0<127){bE(a,c);b=b+1|0;continue}break}}function b5(a,b){a=a|0;b=b|0;a=xd(a,0);$I(a+8|0,b);x[a>>2]=100324;x[a>>2]=100608;return a|0}function VE(a){var b=0;b=x[a>>2];if(x[b>>2]){TE(b,x[b>>2]);a=x[a>>2];b=x[a>>2];UE(a);Db(b)}}function PD(a){var b=0;b=fb-16|0;fb=b;x[b+12>>2]=0;Bu(b+12|0,a);fb=b+16|0;return x[b+12>>2]}function JN(a,b,c,d,e){if(!((b|0)==(c|0)|(d|0)>=0)){v[b|0]=45;d=IN(d);b=b+1|0}xU(a,b,c,d,e)}function Hpa(a){a=a|0;var b=0;b=fb-16|0;fb=b;a=Zh(a,b+8|0);fb=b+16|0;return+(a?C[b+8>>3]:0)}function HF(a,b){if((a&4088)>>>0>=520){b=Tw(0-Lua(b^1230262859,25)|0,4)^1247037516}return b}function $4(a,b){a=a|0;b=b|0;a=xd(a,0);$I(a+8|0,b);x[a>>2]=100480;x[a>>2]=100724;return a|0}function ux(a,b){a=a|0;b=b|0;b=b-1|0;if(b>>>0<=4){b=x[(b<<2)+22304>>2]}else{b=9758}uc(a,b)}function lL(a){var b=0;b=x[a>>2];if(b){if(!mc(mL(b),-1)){return!x[a>>2]}x[a>>2]=0}return 1}function hia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=yj(a);if(a){ib[x[x[a>>2]+76>>2]](a,b,c,d)}}function gia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=yj(a);if(a){ib[x[x[a>>2]+84>>2]](a,b,c,d)}}function eia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=yj(a);if(a){ib[x[x[a>>2]+92>>2]](a,b,c,d)}}function bG(a,b,c){var d=0;d=fb-16|0;fb=d;b=rm(d+8|0,b,c);EG(b,a);me(b);fb=d+16|0;return a}function YP(a,b){var c=0;c=x[a+12>>2];if((c|0)>0){x[a+20>>2]=(x[a+16>>2]+(b+c|0)|0)%(c|0)}}function Fh(a){var b=0;if(a>>>0>=11){b=a+16&-16;a=b-1|0;a=(a|0)==11?b:a}else{a=10}return a}function Bm(a,b,c){var d=E(0);if(b>>>0<=c>>>0){d=B[yb(a+4208|0,b)>>2]}else{d=E(0)}return d}function sy(a,b,c,d){var e=0;e=fb-16|0;fb=e;x[e+12>>2]=d;a=qt(a,b,c,d);fb=e+16|0;return a}function sx(){var a=0,b=0;a=fb-16|0;fb=a;b=yf(a+12|0,Nb(Ec(12)));fb=a+16|0;return x[b>>2]}function nq(a){a=a|0;var b=0;x[a>>2]=47568;b=x[a+4>>2];if(b){Db(b);x[a+4>>2]=0}return a|0}function mA(a,b){if((a|0)>=0){return(a>>>0)%(b>>>0)|0}return(((a^-1)>>>0)%(b>>>0)^-1)+b|0}function jF(a){var b=0;b=a&255;a=b>>>21|0;b=(b<<11)+2624|0;hb=b>>>0<2624?a+1|0:a;return b}function cs(a){var b=0;while(1){if(!mc(y[a|0],0)){a=a+1|0;b=b+1|0;continue}break}return b}function U2(a,b,c){a=a|0;b=b|0;c=c|0;ib[x[x[b>>2]+8>>2]](b,c);zs(a,x[b+4>>2]);ZG(b+4|0,c)}function Lua(a,b){var c=0,d=0;c=b&31;d=(-1>>>c&a)<<c;c=a;a=0-b&31;return d|(c&-1<<a)>>>a}
function Fl(a,b,c){a=a+1074992|0;return x[(a+D(b,872)|0)+680>>2]>x[(a+D(c,872)|0)+680>>2]}function DU(a,b,c){while(1){if((b|0)!=(c|0)){AU(a,y[b|0]);b=b+1|0;continue}break}return a}function C$(a,b,c){var d=0;d=fb-16|0;fb=d;ri(d+8|0,b,c);fb=d+16|0;return x[d+8>>2]==(a|0)}function BJ(a,b){a=xd(a,b);v[a+12|0]=0;x[a+8>>2]=0;x[a>>2]=95296;x[a+8>>2]=95344;return a}function wS(a){var b=0;b=a+4e4|0;while(1){b=UA(b-160|0);if((b|0)!=(a|0)){continue}break}}function sn(a){var b=0;if(a>>>0>=2){b=KY(a+1|0);a=b-1|0;a=(a|0)==2?b:a}else{a=1}return a}function nw(a,b){var c=0;c=fb-16|0;fb=c;a=vb(c+12|0,D(b,6)+a|0);fb=c+16|0;return x[a>>2]}function jia(a,b){a=a|0;b=b|0;a=yj(a);if(!a){return 1}return ib[x[x[a>>2]+68>>2]](a,b)|0}function hn(a,b){var c=0;c=fb-16|0;fb=c;a=vb(c+12|0,(b<<1)+a|0);fb=c+16|0;return x[a>>2]}function au(a){if(UM(a)){a=ac(4);x[a>>2]=0;a=Ej(a);x[a>>2]=124064;da(a|0,124100,34);p()}}function YS(a,b){var c=0;c=y[a+851|0];if(c&1){v[a+851|0]=c|64;x[a+852>>2]=x[a+852>>2]+b}}function XB(a,b){a=Ul(a,b);Uc(a+12|0,b+12|0);w[a+28>>1]=z[b+28>>1];x[a+24>>2]=x[b+24>>2]}function Mx(a,b,c,d){var e=0;e=x[b>>2];x[a+8>>2]=b;x[a>>2]=e;x[a+4>>2]=(c<<d)+e;return a}function AX(a,b){var c=0;c=fb-16|0;fb=c;Fn(c+8|0,b);uZ(a,x[c+8>>2],x[c+12>>2]);fb=c+16|0}function yJ(a,b){a=xd(a,b);x[a+8>>2]=46;x[a+12>>2]=44;x[a>>2]=96584;Fb(a+16|0);return a}function vm(a){var b=0;b=mx(a+4|0);if((b|0)==-1){ib[x[x[a>>2]+8>>2]](a)}return(b|0)==-1}function tW(a,b,c){var d=0;d=x[b>>2];x[a+8>>2]=b;x[a>>2]=d;x[a+4>>2]=D(c,12)+d;return a}function rs(a,b,c,d){if(!((b|0)==(c|0)|(d|0)>=0)){v[b|0]=45;d=IN(d);b=b+1|0}DB(a,b,c,d)}function lea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return YH(a,b,c,d,e,12449,1076)|0}function fL(a){var b=0;b=x[a>>2];if(b){if(!jo(tl(b))){return!x[a>>2]}x[a>>2]=0}return 1}function b2(a){a=a|0;var b=0;b=x[a+4>>2];return(ib[x[x[b>>2]+20>>2]](b)|0)+x[a+12>>2]|0}function am(a,b,c){var d=0;d=fb-16|0;fb=d;v[d+15|0]=c;Uh(a,b,d+15|0);fb=d+16|0;return a}function Yea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return YH(a,b,c,d,e,12549,1049)|0}function YJ(a,b){var c=0;c=fb-16|0;fb=c;x[c+12>>2]=b;a=wK(a,11204,b);fb=c+16|0;return a}function Sv(a,b,c){var d=E(0);d=B[a>>2];if(!Rv(d,B[b>>2])){b=Rv(B[c>>2],d)?c:a}return b}function Ng(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0;return a}function Eq(a,b,c){a=Kl(a)-x[a+16>>2]|0;if(a>>>0>=2){c=E(E(E(c-b)/E(a>>>0))+b)}return c}function DD(a){var b=0;b=wV(a);while(1){if((a|0)!=(b|0)){g0(a);a=a+32|0;continue}break}}function tJ(a,b){a=xd(a,b);b=a+8|0;x[b>>2]=104276;x[a>>2]=99260;x[b>>2]=99308;return a}function sJ(a,b){a=xd(a,b);b=a+8|0;x[b>>2]=104312;x[a>>2]=99524;x[b>>2]=99572;return a}function s0(a,b,c){v[a+2|0]=1;b=b&15;if(c){b=y[b+24672|0]}else{b=(b<<2)+4|0}v[a+4|0]=b}function l5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ib[x[x[b>>2]+16>>2]](a,b,c,d,e,8)}function ju(a,b){a=a|0;b=b|0;b=fb-16|0;fb=b;x[b>>2]=a;xP(18472,b);iu(125480);fb=b+16|0}function hea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return TH(a,b,c,d,e,9642,1079)|0}function P5(a,b){a=a|0;b=b|0;if((b|0)>=0){b=x[((b&255)<<2)+107120>>2]}return b<<24>>24}function NV(a){var b=0;b=a&255;a=b>>>27|0;b=(b<<5)+259|0;hb=b>>>0<259?a+1|0:a;return b}function N5(a,b){a=a|0;b=b|0;if((b|0)>=0){b=x[((b&255)<<2)+105584>>2]}return b<<24>>24}function HU(a,b){return(a>>>0<=62?63-(D((b^-1)&63,(a?a+1|0:0)&255)>>>6|0)|b&192:b)&255}function HE(a,b){a=a|0;b=b|0;var c=0;c=fb-16|0;fb=c;v[c+15|0]=b;Bw(a,c+15|0);fb=c+16|0}function H2(){var a=0;a:{if(TG(20054022)){break a}if(SG()){break a}a=RG()^1}return a|0}function FG(a,b){var c=0;c=fb-16|0;fb=c;b=Ff(c+8|0,b);EG(b,a);me(b);fb=c+16|0;return a}function Ac(a,b){var c=0,d=0;c=fb-16|0;fb=c;d=c+8|0;Fn(d,a);om(d,b);fb=c+16|0;return a}function $da(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return TH(a,b,c,d,e,9714,1086)|0}function yk(a,b,c){var d=0;d=fb-16|0;fb=d;ZB(d+8|0,a,b,c);fb=d+16|0;return x[d+12>>2]}function wI(a){return(a|0)!=0&(a|0)!=104904&(a|0)!=104928&(a|0)!=501600&(a|0)!=501624}function uA(a,b,c){var d=0;d=fb-16|0;fb=d;sR(d+8|0,a,b,c);fb=d+16|0;return x[d+12>>2]}function tA(a,b,c){var d=0;d=fb-16|0;fb=d;Hv(d+8|0,a,b,c);fb=d+16|0;return x[d+12>>2]}function pJ(a){var b=0;b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];ny(ht(a),x[a>>2],Vg(a))}}function f8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return HH(b,c,d,e,f,1)|0}function d8(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return HH(b,c,d,e,f,0)|0}function aC(a,b,c){var d=0;d=fb-16|0;fb=d;ZU(d+8|0,a,b,c);fb=d+16|0;return x[d+12>>2]}function X7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return FH(b,c,d,e,f,1)|0}function V7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return FH(b,c,d,e,f,0)|0}function UJ(a,b){var c=0,d=0;Qe(a,ne(b));b=gc(b);c=gc(a),d=x[b>>2],x[c>>2]=d;return a}function RJ(a,b,c){var d=0;d=fb-16|0;fb=d;$D(d+8|0,a,b,c);fb=d+16|0;return x[d+12>>2]}function Ov(a,b){var c=0;c=fb-16|0;fb=c;w[c+14>>1]=b;Kv(a+236|0,128,c+14|0);fb=c+16|0}function Nu(a,b){if(!(v[b+851|0]&1&x[a+480180>>2]==8)){JA(a,b,0);JA(a,b,1);JA(a,b,2)}}function Lv(a,b,c){var d=0;d=fb-16|0;fb=d;BY(d+8|0,a,b,c);fb=d+16|0;return x[d+12>>2]}function L9(a,b){a=a|0;b=b|0;a=z[a>>1];b=z[b>>1];return(a>>>0<b>>>0?-1:a>>>0>b>>>0)|0}function K9(a,b){a=a|0;b=b|0;a=x[a>>2];b=x[b>>2];return(a>>>0<b>>>0?-1:a>>>0>b>>>0)|0}function Av(a,b){a:{if(b){break a}if(a>>>0<=3){a=a|-16;break a}a=a>>>2|0}return a&255}function xC(a,b){var c=0;c=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=c;x[a+8>>2]=x[b+8>>2]}function jf(a){a=a|0;var b=0;b=x[a>>2];return(ib[x[x[b>>2]+24>>2]](b)|0)-x[a+8>>2]|0}function eda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return BO(x[a+4>>2],b,c,d,e)|0}function bda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return uO(x[a+4>>2],b,c,d,e)|0}function _j(a,b,c){var d=0;d=x[a>>2];if(!Yq(d,x[b>>2])){b=Yq(x[c>>2],d)?c:a}return b}function Yg(a,b,c){var d=0;d=C[a>>3];if(!GV(d,C[b>>3])){b=GV(C[c>>3],d)?c:a}return b}function Ufa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return uP(a,b,c,d,0,0,0,0,e)|0}function Rg(a){var b=0;b=fb-16|0;fb=b;a=On(a,b+12|0);fb=b+16|0;return a?x[b+12>>2]:0}function Je(a,b,c){if(Cn(a,b,c)){a=aj(a,c);a=Ib(x[a>>2],x[a+4>>2])}else{a=0}return a}function Co(a){var b=0;b=a;a=x[a>>2];x[b>>2]=D(a,214013)+2531011;return a>>>16&32767}function B4(a,b,c){a=a|0;b=b|0;c=c|0;a=dy(b,x[a+8>>2]);return((a|0)==-1?c:a)<<24>>24}function $V(a,b,c,d,e,f){a=vb(a,b);vb(a+4|0,c);vb(a+8|0,d);vb(a+12|0,e);vb(a+16|0,f)}function xZ(a){var b=0;b=x[a>>2];x[a>>2]=0;if(b){if(y[gc(a)+4|0]){Qj(b+16|0)}Db(b)}}function wia(a){a=a|0;v[a+4202|0]=1;x[a+4232>>2]=x[x[a+16>>2]+24620>>2];ru(a);FQ(a)}function wW(a){var b=0;b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];Ab(a);Db(b)}}function ry(a){a=a|0;x[a>>2]=96496;if(x[a+8>>2]!=(Od()|0)){kl(x[a+8>>2])}return a|0}function mW(a){var b=0;b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];kv(a);Db(b)}}function lz(a,b){return y[(D(a>>>1&3,15)+D(a>>>3&1,45)+((b&240)>>>4)|0)+80881|0]<<1}function ie(a){var b=0;b=fb-16|0;fb=b;x[b+12>>2]=48552;rc(a,48448,b+12|0);fb=b+16|0}function fq(a){a=a|0;x[a+56>>2]=93920;x[a>>2]=93900;Bt(a+4|0);vl(a+56|0);return a|0}function dW(a){var b=0;b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];hx(a);Db(b)}}function cU(a){var b=0;b=x[a>>2];x[a>>2]=0;if(b){if(y[gc(a)+4|0]){dU(b+16|0)}Db(b)}}function c0(a,b,c){a=a|0;b=b|0;c=c|0;return b0(a,b,Kb(c),Cb(x[c+4>>2],y[c+11|0]))|0}function Zj(a,b){var c=0;c=fb-16|0;fb=c;a=vb(c+12|0,a+b|0);fb=c+16|0;return x[a>>2]}function Yga(a){a=a|0;v[a+4202|0]=1;x[a+4256>>2]=x[x[a+16>>2]+24620>>2];aQ(a);$P(a)}function TA(a){var b=0;b=fb-16|0;fb=b;vb(b+12|0,a+116|0);a=mS(a);fb=b+16|0;return a}function SQ(a){var b=0;b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];Vg(a);Db(b)}}function PF(a){var b=0;b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];In(a);Db(b)}}function Gf(a){a=a|0;x[a+60>>2]=94084;x[a>>2]=94064;Bt(a+8|0);vl(a+60|0);return a|0}function GG(a){var b=0;b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];Tn(a);Db(b)}}function Ff(a,b){x[a>>2]=x[b>>2];x[a+4>>2]=x[b+4>>2];x[b>>2]=0;x[b+4>>2]=0;return a}function FR(a){var b=0;b=x[a>>2];x[a>>2]=0;if(b){if(y[gc(a)+4|0]){Eb(b+16|0)}Db(b)}}function E$(a){var b=0;b=x[a>>2];if(x[b>>2]){Nc(b);a=x[a>>2];b=x[a>>2];hw(a);Db(b)}}function $l(a,b){var c=0,d=0,e=0;c=x[a+24>>2];d=a,e=Ye(zi(b)*+(c>>>0)),x[d+24>>2]=e}function oT(a,b){var c=0;c=b&15;if(c){v[a+830|0]=c}b=b&240;if(b){v[a+829|0]=b>>>4}}function lv(a,b){a=Bb(a&65535);b=Bb(b&65535);return(a|0)!=(b|0)?a>>>0<b>>>0?-1:1:0}function Tp(a,b,c,d){x[a>>2]=b;b=x[b+4>>2];x[a+4>>2]=b;x[a+8>>2]=b+(c<<d);return a}function Rp(a,b,c,d){x[a>>2]=b;b=x[b+4>>2];x[a+4>>2]=b;x[a+8>>2]=b+D(c,d);return a}function LL(a,b){b=x[a+32>>2]+b|0;x[a+32>>2]=b;if(b>>>0>=A[a+40>>2]){x[a+96>>2]=1}}function xP(a,b){var c=0;c=fb-16|0;fb=c;x[c+12>>2]=b;yL(125480,a,b,0,0);fb=c+16|0}function pg(a){var b=0;b=fb-16|0;fb=b;a=vb(b+12|0,gc(a));fb=b+16|0;return x[a>>2]}function Zca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return aI(a,b,c,d,e,1116)|0}function YQ(a,b,c){while(1){if(b){B[a>>2]=B[c>>2];b=b-1|0;a=a+4|0;continue}break}}function Wo(a,b){a=zc(a,b,34);w[a+34>>1]=z[b+34>>1];zc(a+36|0,b+36|0,68);return a}function Vi(a){var b=0;b=fb-16|0;fb=b;a=vb(b+12|0,wb(a));fb=b+16|0;return x[a>>2]}function V6(){var a=0,b=0,c=0;a=xd(501152,1);x[a>>2]=96496;b=a,c=Od(),x[b+8>>2]=c}function R_(a,b){var c=0;c=Kb(a);return Q_(c,(Cb(x[a+4>>2],y[a+11|0])+c|0)+1|0,b)}function Pf(a){var b=0;b=fb-16|0;fb=b;a=vb(b+12|0,pg(a));fb=b+16|0;return x[a>>2]}function OV(a){if((y[a+14|0]-53&255)>>>0>=252){a=jd(a,15644,14)}else{a=1}return!a}function Kv(a,b,c){while(1){if(b){w[a>>1]=z[c>>1];b=b-1|0;a=a+2|0;continue}break}}function KF(a,b,c){while(1){if(b){x[a>>2]=x[c>>2];b=b-1|0;a=a+4|0;continue}break}}function Js(a,b,c,d){if(b>>>0>=d>>>0){Tj();p()}c=Ec(D(b,c));x[a+4>>2]=b;x[a>>2]=c}function Gda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Is(a,b,c,d,e,1101)|0}function Fda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Is(a,b,c,d,e,1103)|0}function Eda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Is(a,b,c,d,e,1105)|0}function BC(a,b,c){var d=0;d=x[b>>2];x[a+8>>2]=b;x[a>>2]=d;x[a+4>>2]=c+d;return a}function wM(a){a=Qn(a);x[a>>2]=77596;Nb(a+4|0);v[a+20|0]=0;x[a+16>>2]=0;return a}function lO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Hs(a,b,c,d,e,1100)|0}function iO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Hs(a,b,c,d,e,1102)|0}function hO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Hs(a,b,c,d,e,1104)|0}function gO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Hs(a,b,c,d,e,1020)|0}function f3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=ib[a|0](b,c,d)|0;gb=hb;return a|0}function _N(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ox(a,b,c,d,e,1101)|0}function ZN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Es(a,b,c,d,e,1101)|0}function YN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ox(a,b,c,d,e,1103)|0}function Xg(a,b,c){var d=0;d=fb-16|0;fb=d;ZB(d+8|0,b,b+c|0,a);fb=d+16|0;return a}function WN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Es(a,b,c,d,e,1103)|0}function VN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ox(a,b,c,d,e,1105)|0}function UN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Es(a,b,c,d,e,1105)|0}function Pk(a,b){var c=0;c=x[b+4>>2];x[a>>2]=x[b>>2];x[a+4>>2]=c;hc(a+8|0,b+8|0)}function PX(a){var b=0;while(1){if((b|0)!=512){dh(a+b|0);b=b+1|0;continue}break}}function Bfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Is(a,b,c,d,e,994)|0}function zH(a,b){x[a>>2]=b;tb(a+48|0);tb(a+36|0);tb(a+24|0);tb(a+12|0);return a}function ui(a){return(hk(x[a>>2],x[a+4>>2])|0)!=(0-hk(x[a+12>>2],x[a+16>>2])|0)}function tP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return aI(a,b,c,d,e,995)|0}function og(a){var b=0,c=0;tc(a+4|0);Fc(a+8|0,0);b=a,c=gc(a),x[b>>2]=c;return a}function nK(){var a=0;a=fb-16|0;x[a+8>>2]=0;x[a+12>>2]=1048576;return C[a+8>>3]}function lsa(a,b,c){a=a|0;b=b|0;c=c|0;Uc(a,tZ(b,Kb(c),Cb(x[c+4>>2],y[c+11|0])))}function j$(a,b,c){while(1){if(b){v[a|0]=y[c|0];b=b-1|0;a=a+1|0;continue}break}}function i3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ib[a|0](b,c,d,e,f)}function gaa(a){a=a|0;a=x[a+24>>2];return nM(x[(x[x[a>>2]-12>>2]+a|0)+16>>2])^1}function fd(a,b,c){var d=0;d=fb-16|0;fb=d;x[d+12>>2]=c;rn(a,b,d+12|0);fb=d+16|0}function cg(a){var b=0;b=xb(a,2);return y[xb(a,1)|0]<<8|y[b|0]<<16|y[xb(a,0)|0]}function cS(a,b){var c=0,d=0;c=fb-16|0;fb=c;d=c+4|0;KC(d,1,b);Cc(a,d);fb=c+16|0}function Ub(a){var b=0;if(vd(y[a+11|0])){b=x[a>>2];$i(x[a+8>>2]);Db(b)}return a}function TN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Es(a,b,c,d,e,994)|0}function Nx(a,b,c,d){if(b>>>0>=d>>>0){Tj();p()}c=Ec(b<<c);x[a+4>>2]=b;x[a>>2]=c}function Jf(a,b,c){if((c|0)>=0){a=(x[((c&255)<<2)+a>>2]&b)!=0}else{a=0}return a}function Jba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;return qN(a-88|0,b,c,d,e)|0}function Ix(a,b){b=a+b|0;while(1){b=tb(b-12|0);if((b|0)!=(a|0)){continue}break}}function AU(a,b){var c=0;c=a;a=x[a>>2];x[c>>2]=a<<8^x[((a>>>24^b)<<2)+27532>>2]}function AH(a,b){x[a>>2]=b;Ub(a+52|0);Ub(a+40|0);Ub(a+28|0);tb(a+16|0);return a}function xw(a,b){return Ye(zi((+(a|0)*128+ +(b|0))*.0006510416666666666)*8363)}function qD(a){var b=0;while(1){if((b|0)!=4){dh(a+b|0);b=b+1|0;continue}break}}function p6(a){a=a|0;if(!y[500040]){vn(500028,96812);v[500040]=1}return 500028}function o6(a){a=a|0;if(!y[500072]){vn(500060,96896);v[500072]=1}return 500060}function n6(a){a=a|0;if(!y[499976]){vn(499964,96740);v[499976]=1}return 499964}function m6(a){a=a|0;if(!y[500008]){vn(499996,96776);v[500008]=1}return 499996}function i6(a){a=a|0;if(!y[500024]){Dc(500012,13633);v[500024]=1}return 500012}function f6(a){a=a|0;if(!y[499992]){Dc(499980,13827);v[499992]=1}return 499980}function c3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ib[a|0](b,c,d,e)|0}function b$(a,b){a=a|0;b=b|0;if(x[a+4>>2]!=x[Ab(a)>>2]){kM(a,b);return}gM(a,b)}function Zw(a,b){var c=0;if((b|0)<0){Tj();p()}c=Ec(b<<1);x[a+4>>2]=b;x[a>>2]=c}function Vo(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0;v[a+4|0]=0;v[a+5|0]=0}function S4(a,b){a=a|0;b=b|0;a=Ej(a);x[a>>2]=124592;Zx(a+4|0,Kb(b));return a|0}function P3(a,b,c){a=a|0;b=b|0;c=c|0;if(!y[501720]){v[501720]=1}Zb(a,c,125924)}function Hca(a,b){a=a|0;b=b|0;a=x[a+4>>2];return KO(x[a+24>>2],B[a+48>>2],b)|0}function DA(a,b){a=a|0;b=b|0;if(x[a+4>>2]!=x[Ab(a)>>2]){dS(a,b);return}gA(a,b)}function wb(a){var b=0;b=fb-16|0;fb=b;a=vb(b+12|0,a);fb=b+16|0;return x[a>>2]}function vB(a,b){var c=0;c=a;a=(b>>>0)/100|0;return Jl(Jl(c,a),D(a,-100)+b|0)}function tba(a,b){a=a|0;b=b|0;rp(x[a+4>>2]);mG(rG(x[a+4>>2],b));rp(x[a+4>>2])}function sj(a,b,c){if(x[a+80>>2]){x[a+92>>2]=x[a+92>>2]+(c+7&-8);return}Db(b)}function sf(a){if(vd(y[a+11|0])){hd(x[a>>2],0);Bd(a,0);return}hd(a,0);Ne(a,0)}function sB(a,b){var c=0;c=a;a=(b>>>0)/1e4|0;return vB(Jl(c,a),D(a,-1e4)+b|0)}function im(a,b){var c=0,d=0;c=fb-16|0;fb=c;d=c+8|0;M0(d,a);om(d,b);fb=c+16|0}function iA(a,b){if((a|0)>=0){return(a|0)%(b|0)|0}return((a^-1)%(b|0)^-1)+b|0}function hA(a,b){if((a|0)>=0){return(a|0)/(b|0)|0}return((a+1|0)/(b|0)|0)-1|0}function h6(a){a=a|0;if(!y[500056]){Dc(500044,9269);v[500056]=1}return 500044}function gea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Xn(a,b,c,d,12950,1080)|0}function g6(a){a=a|0;if(!y[499960]){Dc(499948,5265);v[499960]=1}return 499948}function fS(a,b){a=a|0;b=b|0;if(A[a+4>>2]<A[Ab(a)>>2]){dS(a,b);return}gA(a,b)}function dea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Xn(a,b,c,d,13024,1082)|0}function _ga(a,b){a=a|0;b=b|0;return E(b>>>0<=4?B[((b<<2)+a|0)+4220>>2]:E(0))}function VT(a){x[a>>2]=0;x[a+4>>2]=0;x[a>>2]=-2078137563;x[a+4>>2]=-873292572}function Rj(a){var b=0;b=fb-16|0;fb=b;a=yf(b+12|0,a);fb=b+16|0;return x[a>>2]}function Qu(a,b){var c=0;c=a;a=(b>>>0)/1e6|0;return sB(Jl(c,a),D(a,-1e6)+b|0)}function F3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(lh(a,x[b+8>>2],0)){Ux(b,c,d)}}function Be(a,b){var c=0,d=0;c=fb-16|0;fb=c;d=c+8|0;Uw(d,a);om(d,b);fb=c+16|0}function Aj(a){if(Ob(a+1074312|0,7)){a=yn(x[a+480180>>2])^1}else{a=0}return a}function AB(a){var b=0;if(!(y[a+2|0]|(y[a|0]|y[a+1|0]))){b=!y[a+3|0]}return b}function zJ(a,b){a=xd(a,b);w[a+8>>1]=11310;x[a>>2]=96544;Fb(a+12|0);return a}function tK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ib[x[x[a>>2]+48>>2]](a,b,c,d)|0}function jea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Xn(a,b,c,d,9436,1077)|0}function he(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=x[b+8>>2];Vb(b,c);px(a,b,d,c)}function fea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Xn(a,b,c,d,9597,1081)|0}function cea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Xn(a,b,c,d,9675,1083)|0}function bea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Xn(a,b,c,d,9467,1084)|0}function Ze(a){var b=0;b=fb-16|0;fb=b;Nn(b+8|0,a);fb=b+16|0;return x[b+8>>2]}function X5(a,b){a=a|0;b=b|0;if(b>>>0<=127){b=x[(b<<2)+107120>>2]}return b|0}function V5(a,b){a=a|0;b=b|0;if(b>>>0<=127){b=x[(b<<2)+105584>>2]}return b|0}function US(a,b,c){var d=0;return!b|!(y[a+35|0]&4?!a|(c|0)!=1:1)?d:y[b+34|0]}function AK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ib[x[x[a>>2]+32>>2]](a,b,c,d)|0}function yU(a,b){b=1/(1/(b*6.283185307179586/3546895)+1);qU(a,b,0,0,b+-1,0)}function vC(a,b){return(+(a>>>0)+ +(b|0)*4294967296)*2.3283064365386963e-10}function qQ(a){a=a|0;x[a>>2]=44684;wc(a+4276|0);wc(a+4264|0);return _f(a)|0}function h8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return IH(b,c,d,e,1)|0}function fda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return DO(x[a+4>>2],b,c,d)|0}
function e8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return IH(b,c,d,e,0)|0}function bL(a,b,c,d,e,f,g,h){return ib[x[x[a>>2]+16>>2]](a,b,c,d,e,f,g,h)|0}function aM(a,b){a=a^-1;return x[(b&12)+80884>>2]>>>(a>>>3&1)>>>(a>>>4&1)|0}function Z7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return GH(b,c,d,e,1)|0}function Xo(a,b,c){x[a>>2]=b;b=x[b+4>>2];x[a+4>>2]=b;x[a+8>>2]=b+c;return a}function W7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return GH(b,c,d,e,0)|0}function Ih(a,b){var c=0;c=a;a=x[a+8>>2];b=a-b|0;x[c+8>>2]=a>>>0>=b>>>0?b:0}function $Z(a){var b=0;while(1){b=a;a=x[a>>2];if(a){continue}break}return b}function $8(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)!=1){_K(a,c);return}Dc(a,7920)}function xG(a,b){a=a|0;b=b|0;a=Ej(a);x[a>>2]=124592;Zx(a+4|0,b);return a|0}function lda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return AO(x[a+4>>2],b,c,d)|0}function kda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return yO(x[a+4>>2],b,c,d)|0}function ida(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return zO(x[a+4>>2],b,c,d)|0}function hda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return xO(x[a+4>>2],b,c,d)|0}function ci(a,b,c){x[a+8>>2]=b;x[a+12>>2]=c;x[a>>2]=0;x[a+4>>2]=0;return a}function cda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return wO(x[a+4>>2],b,c,d)|0}function Xha(a,b){a=a|0;b=b|0;a=x[a+20>>2];v[a+24|0]=y[a+24|0]&253|(b?2:0)}function T3(a,b,c){a=a|0;b=b|0;c=c|0;return mc(a,x[b+4>>2])&x[b>>2]==(c|0)}function Ip(a,b){x[a>>2]=x[b>>2];x[a+4>>2]=x[b+4>>2];x[b>>2]=0;x[b+4>>2]=0}function Dk(a){var b=0;b=z[a+172>>1];a=z[a+156>>1];return(IV(a)?b:a)&65535}function xz(a,b){var c=0,d=0;c=vb(a,x[x[b>>2]-12>>2]+b|0),d=b,x[c+4>>2]=d}function wc(a){var b=0;b=fb-16|0;fb=b;SQ(vb(b+12|0,a));fb=b+16|0;return a}function wG(a,b){a=Ff(a,b);x[a+8>>2]=x[b+8>>2];Ff(a+12|0,b+12|0);return a}function rj(a,b,c){a=a|0;b=b|0;c=c|0;return ib[x[x[a>>2]+12>>2]](a,b,c)|0}function rG(a,b){a=a|0;b=b|0;return BF(a,Kb(b),Cb(x[b+4>>2],y[b+11|0]))|0}function mp(a,b,c){a=a|0;b=b|0;c=c|0;return ib[x[x[a>>2]+48>>2]](a,b,c)|0}function kd(a,b){a=FG(a,b);x[a+8>>2]=x[b+8>>2];FG(a+12|0,b+12|0);return a}function ec(a){var b=0;b=fb-16|0;fb=b;JZ(vb(b+12|0,a));fb=b+16|0;return a}function bY(a,b){v[a+6|0]=255;x[a+16>>2]=b;w[a+4>>1]=0;x[a>>2]=0;return a}function Zc(a,b,c,d,e){v[a+3|0]=e;v[a+2|0]=d;v[a+1|0]=c;v[a|0]=b;return a}function Mb(a,b,c){a=a|0;b=b|0;c=c|0;return ib[x[x[a>>2]+32>>2]](a,b,c)|0}function Kb(a){var b=0,c=0,d=0;return b=x[a>>2],c=a,d=vd(y[a+11|0]),d?b:c}function Jra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=c,e=up(a,b),x[d>>2]=e}function JF(a,b){while(1){if(b){x[a>>2]=0;b=b-1|0;a=a+4|0;continue}break}}function Ira(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=c,e=Pw(a,b),w[d>>1]=e}function sL(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ci(a,-1,-1)}function Oy(a,b){var c=0;c=Tt(a+4|0);x[a>>2]=94712;x[c>>2]=94732;oo(c,b)}function Ny(a,b){var c=0;c=SK(a+4|0);x[a>>2]=95080;x[c>>2]=95100;oo(c,b)}function Mm(a,b){v[a|0]=b;v[a+1|0]=b>>>8;v[a+2|0]=b>>>16;v[a+3|0]=b>>>24}function zda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Fs(a,b,c,d,1113)|0}function zN(a){a=a|0;return+(+A[x[a+32>>2]+480240>>2]*152587890625e-16)}function y3(a){a=a|0;if(!a){return 0}return(hB(a,124148,124292)|0)!=0|0}function qc(a,b){var c=0,d=0;x[a>>2]=b;c=a,d=Df(b),x[c+4>>2]=d;return a}function nua(a){a=a|0;x[a+16>>2]=x[a+16>>2]|1;if(v[a+20|0]&1){ua();p()}}function lQ(a){a=a|0;return E(E(E(B[yb(a+4208|0,5)>>2]*E(198))+E(-99)))}function hE(a,b,c){var d=0;d=(b|0)/(c|0)|0;x[a>>2]=d;x[a+4>>2]=b-D(c,d)}function bz(a){return((Oh(a)+(Oh(a)<<8)|0)+(Oh(a)<<16)|0)+(Oh(a)<<24)|0}function _p(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;x[e>>2]=c;return 3}function Wca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return PH(a,b,c,d,1116)|0}function Roa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;fH(a,b,c,d,e,133)}function OU(a,b){x[a+4>>2]=0;x[a+8>>2]=0;x[a>>2]=b?b:49716;x[a+12>>2]=0}function Mc(a){if(vd(y[a+11|0])){a=$i(x[a+8>>2])-1|0}else{a=10}return a}function IU(a){if(a>>>0<=8){return y[a+27520|0]}return y[a+27511|0]|256}function EI(a,b,c){var d=0;d=c;c=Df(b);if(d>>>0>c>>>0){oO(a,b)}return c}function D$(a,b,c){a=a&255;return a>>>0>=(b&255)>>>0&a>>>0<=(c&255)>>>0}function Cda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Fs(a,b,c,d,1107)|0}function Bda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Fs(a,b,c,d,1109)|0}function Ada(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Fs(a,b,c,d,1111)|0}function vD(a,b){if(b){vD(a,x[b>>2]);vD(a,x[b+4>>2]);Qj(b+16|0);Db(b)}}function uD(a,b){if(b){uD(a,x[b>>2]);uD(a,x[b+4>>2]);Qj(b+16|0);Db(b)}}function tn(a){if(vd(y[a+11|0])){a=$i(x[a+8>>2])-1|0}else{a=1}return a}function nv(a,b){a=a&255;b=b&255;return(a|0)!=(b|0)?a>>>0<b>>>0?-1:1:0}function msa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;fH(a,b,c,d,e,91)}function jB(a,b){x[a>>2]=x[b>>2];w[a+4>>1]=z[b+4>>1];v[a+6|0]=y[b+6|0]}function gX(a,b,c,d){x[a>>2]=b;x[a+4>>2]=c;Zb(a+8|0,x[d>>2],x[d+4>>2])}function fO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Gs(a,b,c,d,1106)|0}function eO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Gs(a,b,c,d,1108)|0}function di(a,b){a=a|0;b=b|0;v[a|0]=2;v[a+1|0]=3;v[a+2|0]=0;v[a+3|0]=4}function dO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Gs(a,b,c,d,1110)|0}function cC(a,b){a=Nb(a);Fb(a+12|0);w[a+28>>1]=0;x[a+24>>2]=b;return a}function bs(a){x[a>>2]=0;x[a+4>>2]=0;x[a+8>>2]=0;x[a+12>>2]=0;return a}function bO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Gs(a,b,c,d,1112)|0}function Yca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return PH(a,b,c,d,995)|0}function Vx(a,b,c){if(!(x[a+28>>2]==1|x[a+4>>2]!=(b|0))){x[a+28>>2]=c}}function Us(a){return a>>>0<32|a-127>>>0<33|(a&-2)==8232|a-65529>>>0<3}function Tj(){var a=0;a=un(ac(4));x[a>>2]=124476;da(a|0,124552,34);p()}function SN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ds(a,b,c,d,1107)|0}function RN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ds(a,b,c,d,1109)|0}function PN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ds(a,b,c,d,1111)|0}function ON(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ds(a,b,c,d,1113)|0}function Lq(a,b){if(b){Lq(a,x[b>>2]);Lq(a,x[b+4>>2]);dU(b+16|0);Db(b)}}function Iqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Qx(a,b,c,d,586)|0}function FB(a,b){if(b){FB(a,x[b>>2]);FB(a,x[b+4>>2]);an(b+16|0);Db(b)}}function CA(a,b){if(b){CA(a,x[b>>2]);CA(a,x[b+4>>2]);Eb(b+16|0);Db(b)}}function qx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Qx(a,b,c,d,163)|0}function my(a){a=a|0;if(x[a+8>>2]!=(Od()|0)){kl(x[a+8>>2])}return a|0}function kS(a,b,c,d,e){x[a+12>>2]=e;x[a+8>>2]=d;x[a+4>>2]=c;x[a>>2]=b}function jU(a,b,c){if(Je(a,b,c)){a=x[Wb(a,c)+12>>2]}else{a=1}return a}function hq(a){if(y[a+2|0]&2){a=(y[a+1|0]&6)==6?4:1}else{a=0}return a}function g3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ib[a|0](b,c,d,e)}function g$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Qx(a,b,c,d,339)|0}function aW(a,b,c,d,e){a=vb(a,b);vb(a+4|0,c);vb(a+8|0,d);vb(a+12|0,e)}function _M(a,b){var c=0;c=x[a>>2];x[a>>2]=b;if(c){to(c+120|0);Db(c)}}function JZ(a){var b=0;b=x[a>>2];if(x[b>>2]){Nc(b);Db(x[x[a>>2]>>2])}}function h7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;jg(a,f)}function g7(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;$p(a,f)}function d3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ib[a|0](b,c,d)|0}function QY(a,b){x[a>>2]=x[b>>2];w[a+4>>1]=z[b+4>>1];hc(a+8|0,b+8|0)}function B8(a){a=a|0;var b=0;b=x[124954]+1|0;x[124954]=b;x[a+4>>2]=b}function zO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return SH(a,b,c,d,2)|0}function yu(a,b,c){var d=0;d=fb-16|0;fb=d;ZU(d+8|0,a,b,c);fb=d+16|0}function yO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return RH(a,b,c,d,4)|0}function xO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return RH(a,b,c,d,2)|0}function eI(a,b,c,d,e,f,g){return Ja(a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function eD(a,b,c){var d=0;d=fb-16|0;fb=d;Hv(d+8|0,a,b,c);fb=d+16|0}function dV(a,b,c){var d=0;d=fb-16|0;fb=d;cV(d+8|0,a,b,c);fb=d+16|0}function aE(a,b,c){var d=0;d=fb-16|0;fb=d;$D(d+8|0,a,b,c);fb=d+16|0}function XS(a,b){x[a+852>>2]=x[a+852>>2]+b;v[a+851|0]=y[a+851|0]|64}function Ur(a,b){return Sw(x[b>>2],x[b+4>>2],x[a>>2],x[a+4>>2])?b:a}function Qr(a,b,c){if($c(a,b)>>>0<=c>>>0){Iw();p()}return(c<<1)+a|0}function Pc(a,b,c){if(oc(a,b)>>>0<=c>>>0){Iw();p()}return(c<<2)+a|0}function Cm(a,b){return b?a<<24|(a&65280)<<8|(a>>>8&65280|a>>>24):a}function B0(a,b){return dt(x[b>>2],x[b+4>>2],x[a>>2],x[a+4>>2])?b:a}function AO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return SH(a,b,c,d,4)|0}function $Y(a){v[a+4|0]=0;v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0}function w4(a,b){a=a|0;b=b|0;a=bJ(a,b,1);x[a>>2]=104348;return a|0}function qg(a,b){a=a|0;b=b|0;var c=0;c=Ec(b);x[a+4>>2]=b;x[a>>2]=c}function pga(a,b,c){a=a|0;b=b|0;c=c|0;return gj(a,b,c,975,86224)|0}function pd(a){a=(a|0)>=32767?32767:a;return(a|0)<=-32768?-32768:a}function ny(a,b,c){a:{if((a|0)==(b|0)){v[b+120|0]=0;break a}Db(b)}}function jV(a,b){var c=0,d=0;c=vb(a,x[b>>2]),d=y[b+4|0],v[c+4|0]=d}function S5(a,b,c){a=a|0;b=b|0;c=c|0;return(b>>>0<128?b:c)<<24>>24}function R4(a,b){a=a|0;b=b|0;a=aJ(a,b,1);x[a>>2]=104444;return a|0}function Oj(a,b){a=a|0;b=b|0;var c=0;c=EY(b);x[a+4>>2]=b;x[a>>2]=c}function Jda(a,b){a=a|0;b=b|0;if(!x[31609]){x[31609]=a;x[31610]=b}}function xm(a,b){a=a|0;b=b|0;return ib[x[x[a>>2]+32>>2]](a,0,b)|0}function xN(a){a=a|0;return+(+x[x[a+32>>2]+1074456>>2]*.00390625)}function wga(a,b,c){a=a|0;b=b|0;c=c|0;return gj(a,b,c,974,4276)|0}function uY(a,b,c,d){a=Ie(a,b);w[a+22>>1]=d;w[a+20>>1]=c;return a}function tia(a,b,c){a=a|0;b=b|0;c=c|0;return gj(a,b,c,948,4304)|0}function tha(a,b,c){a=a|0;b=b|0;c=c|0;return gj(a,b,c,967,4280)|0}function ro(a,b){if(A[a+4>>2]<A[Ab(a)>>2]){kM(a,b);return}gM(a,b)}function qla(a,b){a=a|0;b=b|0;a=aw(a,b);x[a>>2]=124800;return a|0}function qk(a,b){a=a|0;b=b|0;return ib[x[x[a>>2]+52>>2]](a,b,0)|0}function pp(a,b){x[a>>2]=x[(x[x[b>>2]-12>>2]+b|0)+24>>2];return a}function kha(a,b,c){a=a|0;b=b|0;c=c|0;return gj(a,b,c,968,4276)|0}function gI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return pO(a,b,c,d)|0}function dta(a,b){a=a|0;b=b|0;a=aw(a,b);x[a>>2]=124748;return a|0}function cha(a,b,c){a=a|0;b=b|0;c=c|0;return gj(a,b,c,969,4268)|0}function c2(a){a=a|0;a=x[a+4>>2];return ib[x[x[a>>2]+16>>2]](a)|0}function Wj(a,b){if(Mg(x[a>>2],x[a+4>>2])>>>0>b>>>0){v[a+16|0]=b}}function Pga(a,b,c){a=a|0;b=b|0;c=c|0;return gj(a,b,c,971,4228)|0}function Nha(a,b,c){a=a|0;b=b|0;c=c|0;return gj(a,b,c,964,4236)|0}function Kia(a,b,c){a=a|0;b=b|0;c=c|0;return gj(a,b,c,940,4268)|0}function Jp(a,b,c){a=Ff(a,b);x[a+8>>2]=0;Ff(a+12|0,c);me(c);me(b)}function Gga(a,b,c){a=a|0;b=b|0;c=c|0;return gj(a,b,c,972,5048)|0}function Dh(a,b,c){a=vb(a,b);mr(a+4|0,x[c>>2],x[c+4>>2]);return a}function DL(a,b){a=BL(a-1|0);if(!a){a=BL(b);a=a?a+32|0:0}return a}function xv(a){var b=0;b=fb-16|0;fb=b;wW(vb(b+12|0,a));fb=b+16|0}function vz(a){var b=0;b=fb-16|0;fb=b;gN(vb(b+12|0,a));fb=b+16|0}function qY(a){var b=0;b=fb-16|0;fb=b;kY(vb(b+12|0,a));fb=b+16|0}function p_(a,b){a=a|0;b=b|0;a=aw(a,b);x[a>>2]=124612;return a|0}function oy(a){var b=0;b=fb-16|0;fb=b;pJ(vb(b+12|0,a));fb=b+16|0}function od(a){var b=0;b=fb-16|0;fb=b;PF(vb(b+12|0,a));fb=b+16|0}function nW(a){var b=0;b=fb-16|0;fb=b;dW(vb(b+12|0,a));fb=b+16|0}function ln(a){var b=0;b=fb-16|0;fb=b;mW(vb(b+12|0,a));fb=b+16|0}function lca(a,b){a=a|0;b=b|0;return E(fP(x[x[a+4>>2]+24>>2],b))}function kca(a,b){a=a|0;b=b|0;return E(eP(x[x[a+4>>2]+24>>2],b))}function jca(a,b){a=a|0;b=b|0;return E(bP(x[x[a+4>>2]+24>>2],b))}function fca(a,b){a=a|0;b=b|0;return E(dP(x[x[a+4>>2]+24>>2],b))}function er(a,b,c){a=Bb(a&65535);return(a|0)>=(b|0)&(a|0)<=(c|0)}function ega(a,b){a=a|0;b=b|0;if(!b){return 3}x[b>>2]=a;return 0}function eca(a,b){a=a|0;b=b|0;return E(cP(x[x[a+4>>2]+24>>2],b))}function dt(a,b,c,d){return a>>>0<c>>>0&(b|0)<=(d|0)|(b|0)<(d|0)}function d2(a){a=a|0;a=x[a+4>>2];return ib[x[x[a>>2]+8>>2]](a)|0}function Ys(a){var b=0;b=fb-16|0;fb=b;qh(rh(b+12|0,a));fb=b+16|0}function YA(a){tb(a+48|0);tb(a+36|0);tb(a+24|0);tb(a+12|0);tb(a)}function UP(a){return E(E(B[yb(a+4208|0,11)>>2]*E(19980))+E(20))}function Td(a){var b=0;b=fb-16|0;fb=b;LH(vb(b+12|0,a));fb=b+16|0}function Rc(a){var b=0;b=fb-16|0;fb=b;VE(vb(b+12|0,a));fb=b+16|0}function Nk(a){var b=0;b=fb-16|0;fb=b;E$(vb(b+12|0,a));fb=b+16|0}function Ce(a){var b=0;b=fb-16|0;fb=b;GG(vb(b+12|0,a));fb=b+16|0}function CG(a,b,c){a=Qn(a);x[a+8>>2]=c;x[a+4>>2]=b;x[a>>2]=78448}function $s(a){a=a|0;x[a>>2]=96376;kl(x[a+16>>2]);return et(a)|0}function rca(a,b){a=a|0;b=b|0;return LO(x[x[a+4>>2]+24>>2],b)|0}function km(a,b){a=a|0;b=b|0;return ib[x[x[a>>2]+28>>2]](a,b)|0}function du(a,b){var c=0;c=G(a)+32|0;a=G(b);return(a|0)==32?c:a}function Xka(a,b){a=a|0;b=b|0;a=YY(a,b);if(!a){XY(b)}return a|0}function Wc(a){var b=0;b=x[a>>2];x[a>>2]=0;if(b){su(b)}return a}function VP(a){return E(E(B[yb(a+4208|0,0)>>2]*E(1e4))+E(-1e4))}function Sw(a,b,c,d){return(b|0)==(d|0)&a>>>0<c>>>0|b>>>0<d>>>0}function Ms(a){var b=0;b=fb-16|0;C[b+8>>3]=a;return C[b+8>>3]*a}function Ky(a,b){a=a|0;b=b|0;return ib[x[x[a>>2]+12>>2]](a,b)|0}function Gx(a){var b=0;b=fb-16|0;B[b+12>>2]=a;return B[b+12>>2]}function Esa(a,b){a=a|0;b=b|0;a=_Z(a,b);if(!a){ZZ(b)}return a|0}function Cg(a){var b=0;b=dr(Df(a)+1|0,1);if(b){oO(b,a)}return b}function At(a,b){a=a|0;b=b|0;return ib[x[x[a>>2]+44>>2]](a,b)|0}function Ao(a,b,c,d){a=nv(a,c);if(Mj(a)){a=aU(b,d)}return vd(a)}function Ag(a,b,c,d){x[a+8>>2]=d;x[a+4>>2]=c;x[a>>2]=b;return a}function $6(a){a=a|0;a=x[a+8>>2];if(!a){return 1}return MJ(a)|0}function z7(a,b){a=a|0;b=b|0;VS(a,Uy(x[b>>2])<<24>>24,x[b>>2])}function xr(a,b){a=a|0;b=b|0;a=o$(a,b);if(!a){fw(b)}return a|0}function wi(a,b){a=a|0;b=b|0;a=Zh(a,b);if(!a){al(b)}return a|0}function ol(a){return wb(Kb(a)+(Cb(x[a+4>>2],y[a+11|0])<<2)|0)}function ns(a,b){a=a|0;b=b|0;a=iG(a,b);if(!a){vx(b)}return a|0}function jh(a,b){return ib[x[x[a>>2]+32>>2]](a,x[a+12>>2],b)|0}function jda(a,b,c){a=a|0;b=b|0;c=c|0;return+tO(x[a+4>>2],b,c)}function jQ(a){a=a|0;return Ck(E(B[yb(a+4208|0,4)>>2]*E(4)))|0}function gx(a,b){a=Uc(a,b);hc(a+12|0,b+12|0);re(a+32|0,b+32|0)}function gp(a,b){a=a|0;b=b|0;a=n$(a,b);if(!a){q$(b)}return a|0}function e0(a,b){if(!b){return-1}b=rq(a,b,0);return b?b-a|0:-1}function dx(a,b){a=a|0;b=b|0;a=aG(a,b);if(!a){as(b)}return a|0}function Zr(a,b){var c=0;c=b+1|0;x[a>>2]=x[a>>2]>(c|0)?c:b+2|0}function Xga(a,b,c){a=a|0;b=b|0;c=c|0;return Px(a,b,c,0,970)|0}function WW(a){return y[a+15|0]<<12|y[a+14|0]<<4|y[a+13|0]<<20}function WR(a,b,c,d){w[a+4>>1]=c;v[a+6|0]=b;x[a>>2]=d;return a}function Qga(a,b,c){a=a|0;b=b|0;c=c|0;return Px(a,b,c,1,970)|0}function Or(a,b){a=a|0;b=b|0;a=On(a,b);if(!a){Dn(b)}return a|0}function Lp(a,b){a=a|0;b=b|0;a=lx(a,b);if(!a){kx(b)}return a|0}function KT(a,b){a=a|0;b=b|0;a=F$(a,b);if(!a){Cr(b)}return a|0}function F0(a,b){a=a|0;b=b|0;a=AE(a,b);if(!a){GE(b)}return a|0}function Dha(a,b,c){a=a|0;b=b|0;c=c|0;return Px(a,b,c,0,966)|0}function CD(a,b){a=a|0;b=b|0;a=jZ(a,b);if(!a){rD(b)}return a|0}function AS(a,b,c,d){w[a>>1]=b;v[a+2|0]=y[c|0];v[a+3|0]=y[d|0]}function $R(a,b){return b>>>0>=4e3?22292:((b<<5)+a|0)+946304|0}function uha(a){a=a|0;return E(E(B[yb(a+4208|0,6)>>2]*E(20)))}function sM(a,b){a=(a+b|0)-1|0;return a-((a>>>0)%(b>>>0)|0)|0}function rm(a,b,c){x[a+4>>2]=c;x[a>>2]=b;if(c){qm(c)}return a}function pba(a,b){a=a|0;b=b|0;x[a>>2]=x[b>>2];jg(a+4|0,b+4|0)}function pS(a,b){var c=0;c=x[a>>2];x[a>>2]=b;if(c){Db(Hl(c))}}function pI(a,b){var c=0;c=a;a=x[a>>2]+b|0;x[c>>2]=a;return a}function nka(a){a=a|0;a=aw(a,22292);x[a>>2]=124692;return a|0}function k$(a){return(y[a+47|0]+y[a+45|0]|0)+(y[a+46|0]<<5)|0}function fta(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;hH(a,b,c,d,363)}function cia(a){a=a|0;a=yj(a);if(a){ib[x[x[a>>2]+100>>2]](a)}}function Vra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;hH(a,b,c,d,474)}function Rta(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;pH(a,b,c,d,133)}function Rl(a,b){a=v[xb(a+62|0,b)|0];return((a|0)<0?-1:a)&255}function Jk(a){var b=0;b=x[a>>2];x[a>>2]=0;if(b){gc(a);Db(b)}}function HG(a,b){var c=0;c=x[a>>2];x[a>>2]=b;if(c){Db(ec(c))}}function EY(a){if(a>>>0>=1073741824){Tj();p()}return Ec(a<<2)}function $b(a){return a<<24|(a&65280)<<8|(a>>>8&65280|a>>>24)}function tm(a){a=DG(a,0);x[a+8>>2]=0;x[a>>2]=120944;return a}function tS(a){x[a>>2]=0;Nb(a+4|0);Rb(a+16|0,0,144);return a}function sY(a){var b=0;b=x[a+100>>2];x[a+100>>2]=0;return b}
function qj(a){var b=0;o(+a);b=j(1)|0;j(0)|0;return b>>>20|0}function kQ(a){a=a|0;return E(E(B[yb(a+4208|0,2)>>2]*E(10)))}function hh(a,b,c,d){hb=b-((a>>>0<c>>>0)+d|0)|0;return a-c|0}function aw(a,b){a=Ej(a);x[a>>2]=124572;Zx(a+4|0,b);return a}function _z(a){a=a|0;x[a+32>>2]=0;x[a+28>>2]=x[a+28>>2]&-7|2}function Xra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;pH(a,b,c,d,91)}function W5(a,b,c){a=a|0;b=b|0;c=c|0;return EH(b,c,107120)|0}function W1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cc(a,x[d>>2],0)}function U5(a,b,c){a=a|0;b=b|0;c=c|0;return EH(b,c,105584)|0}function Tb(a,b){var c=0;c=x[a>>2];x[a>>2]=x[b>>2];x[b>>2]=c}function Rga(a){a=a|0;return E(E(B[yb(a+4208|0,6)>>2]*E(4)))}function O5(a,b,c){a=a|0;b=b|0;c=c|0;return DH(b,c,107120)|0}function MR(a,b){var c=0;c=z[a>>1];w[a>>1]=z[b>>1];w[b>>1]=c}function M5(a,b,c){a=a|0;b=b|0;c=c|0;return DH(b,c,105584)|0}function Bt(a){a=a|0;x[a>>2]=93384;tb(a+32|0);return go(a)|0}function BN(a){a=a|0;return+(65536/+A[x[a+32>>2]+480244>>2])}function BL(a){var b=0,c=0,d=0;return b=Hua(a),c=0,d=a,d?b:c}function zr(a){return x[a+20>>2]+(x[a+8>>2]-x[a+24>>2]|0)|0}function z0(a,b,c){a=a|0;b=b|0;c=c|0;return tH(a,b,c,262)|0}function yl(a){var b=0;b=x[a>>2];x[a>>2]=0;if(b){Db(nf(b))}}function xo(a,b){return(((a<<12&b>>31)+b|0)/4096|0)%(a|0)|0}function wba(a,b,c){a=a|0;b=b|0;c=c|0;Uc(a,b0(c,0,b,Df(b)))}function vZ(a){if(Gk(-1,a)^1){a=Gk(a,0)^1}else{a=0}return a}function uz(a,b,c,d,e,f){return MH(a,b,c,d,e,f,73508,74304)}function tz(a,b,c,d,e,f){return MH(a,b,c,d,e,f,74352,75116)}function tC(a,b){if(b){tC(a,x[b>>2]);tC(a,x[b+4>>2]);Db(b)}}function sC(a,b){if(b){sC(a,x[b>>2]);sC(a,x[b+4>>2]);Db(b)}}function rq(a,b,c){if(!b){return 0}return qq(a,c<<24>>24,b)}function rh(a,b){var c=0,d=0;c=a,d=vK(b),x[c>>2]=d;return a}function pM(a,b){a=Qn(a);x[a+4>>2]=b;x[a>>2]=77132;return a}function oqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dH(a,b,c,d,3)}function mx(a){var b=0;b=a;a=x[a>>2]-1|0;x[b>>2]=a;return a}function kw(a,b,c){a=a|0;b=b|0;c=c|0;return tH(a,b,c,322)|0}function kba(a){a=a|0;Kz(a,2,100);Wj(x[a+24>>2]+484360|0,0)}function iN(a,b){a=a|0;b=+b;OH(a,b,1e4,1074420,9379,512,32)}function hD(a,b){if(b){hD(a,x[b>>2]);hD(a,x[b+4>>2]);Db(b)}}function h3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ib[a|0](b,c,d)}function dF(a){return!jd(a,14245,3)&(y[a+3|0]-10&255)>>>0<5}function cx(a,b){return iS(a,Kb(b),Cb(x[b+4>>2],y[b+11|0]))}function ct(a){a=a|0;x[a>>2]=96428;kl(x[a+8>>2]);return a|0}function cT(a){var b=0;b=x[a>>2];x[a>>2]=0;if(b){Db(kB(b))}}function Zs(a,b){var c=0,d=0;c=a,d=nk(b),x[c>>2]=d;return a}function Yy(a,b){return Ht(a,Kb(b),Cb(x[b+4>>2],y[b+11|0]))}function Upa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dH(a,b,c,d,2)}function QM(a,b){a=a|0;b=b|0;return Sd(x[b>>2],x[b+4>>2])|0}function PM(a,b){a=a|0;b=b|0;return Pj(x[b>>2],x[b+4>>2])|0}function Mu(a,b){if(b){Mu(a,x[b>>2]);Mu(a,x[b+4>>2]);Db(b)}}function Lu(a,b){if(b){Lu(a,x[b>>2]);Lu(a,x[b+4>>2]);Db(b)}}function ID(a,b){if(b){ID(a,x[b>>2]);ID(a,x[b+4>>2]);Db(b)}}function HI(a){a=a|0;x[a>>2]=95264;kl(x[a+8>>2]);return a|0}function HD(a,b){if(b){HD(a,x[b>>2]);HD(a,x[b+4>>2]);Db(b)}}function Fja(a,b,c){a=a|0;b=b|0;c=c|0;return eH(a,b,c,63)|0}function FI(a){a=a|0;x[a>>2]=95232;kl(x[a+8>>2]);return a|0}function F1(a){a=a|0;a=zG(a,13438);x[a>>2]=24492;return a|0}function zA(a,b,c){C[a>>3]=C[a>>3]+b;C[a+8>>3]=C[a+8>>3]+c}function yz(a){return(Kb(a)+Cb(x[a+4>>2],y[a+11|0])|0)-1|0}function yp(a,b,c){a=a|0;b=b|0;c=c|0;Yl(a,b,Hi(b,b+c|0,0))}function r2(a){a=a|0;a=zG(a,8720);x[a>>2]=28836;return a|0}function fI(a,b,c){b=La(1005,a|0,b|0,c|0)|0;hb=gb;return b}function ap(a){var b=0;b=x[a>>2];x[b>>2]=x[b>>2]|x[a+4>>2]}function Wn(a,b,c,d){x[a+16>>2]=d;x[a+12>>2]=c;x[a+8>>2]=b}function S3(a){a=a|0;a=p_(a,7956);x[a>>2]=40200;return a|0}function RO(a){return Ij(Xb(x[a+484360>>2],y[a+484376|0]))}function Q_(a,b,c){if(Gk(c,a)){a=0}else{a=Gk(c,b)}return a}function K5(a,b,c){a=a|0;b=b|0;c=c|0;return((b|0)<0?c:b)|0}function J8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;hb=0;return 0}function yN(a,b){a=a|0;b=+b;OH(a,b,256,1074456,11768,1,0)}function xea(a,b){a=a|0;b=b|0;return Yn(a,b,11833,1065)|0}function vea(a,b){a=a|0;b=b|0;return Yn(a,b,11863,1067)|0}function rK(a,b,c){a=a|0;b=b|0;c=c|0;Fu(a,b,c);return a|0}function pea(a,b){a=a|0;b=b|0;return Yn(a,b,11959,1070)|0}function nea(a,b){a=a|0;b=b|0;return Yn(a,b,11927,1071)|0}function md(a,b,c,d){return Yc(a,D(z[b+480188>>1],c)+d|0)}function lg(a,b){if(vd(y[a+11|0])){Bd(a,b);return}Ne(a,b)}function gz(a,b){return x[((a>>>24^b)<<2)+495328>>2]^a<<8}function _$(a,b){v[a|0]=y[b|0];v[a+1|0]=y[b+1|0];return a}function ZM(a,b){var c=0;c=x[a>>2];x[a>>2]=b;if(c){su(c)}}function Yf(a){var b=0;_P(a);b=x[a>>2];if(b){Uz(a);Db(b)}}function Xea(a,b){a=a|0;b=b|0;return Yn(a,b,11895,1050)|0}function So(a){x[a>>2]=0;x[a+4>>2]=0;Fc(a+8|0,0);return a}function QL(a){while(1){if((Rt(a)|0)!=-1){continue}break}}function LF(a,b){var c=0;c=Ec(b<<2);x[a+4>>2]=b;x[a>>2]=c}function HA(a,b){var c=0;c=x[a>>2];x[a>>2]=b;if(c){Db(c)}}function Gra(a,b,c){a=a|0;b=b|0;c=c|0;Yl(a,b,Xc(b,c)+b|0)}function Gea(a,b){a=a|0;b=b|0;return Yn(a,b,11798,1057)|0}function Gc(a,b){return vH(a,b,2147483647,-2147483648,-1)}function Fx(a,b,c){x[a+28>>2]=c;x[a+20>>2]=b;x[a+24>>2]=b}function Fea(a,b){a=a|0;b=b|0;return $H(a,b,13410,1058)|0}function Ef(a){return wb(Kb(a)+Cb(x[a+4>>2],y[a+11|0])|0)}function zM(a,b){a=a|0;b=b|0;el(a,b,1192,1191,1190,1189)}function yM(a,b){a=a|0;b=b|0;el(a,b,1188,1187,1186,1185)}function wha(a){a=a|0;return B[yb(a+4208|0,3)>>2]<E(1)|0}function tj(a){return ff(a)|ff(a)<<8|ff(a)<<16|ff(a)<<24}function s2(a,b,c){a=a|0;b=b|0;c=c|0;px(a,b,x[b+8>>2],c)}function rg(a,b){var c=0;c=y[a|0];v[a|0]=y[b|0];v[b|0]=c}function rL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ci(a,-1,-1)}function ox(a){a=a|0;x[a>>2]=124592;lI(a+4|0);return a|0}function ola(a,b,c){a=a|0;b=b|0;c=c|0;return Mb(a,b,c)|0}function ly(a){a=a|0;x[a>>2]=96584;tb(a+16|0);return a|0}function lC(a,b){Tb(a,b);Tb(a+4|0,b+4|0);Tb(Ab(a),Ab(b))}function ky(a){a=a|0;x[a>>2]=96544;tb(a+12|0);return a|0}function ZG(a,b){qm(x[b>>2]);vm(x[a>>2]);x[a>>2]=x[b>>2]}function YD(a,b){v[x[a>>2]]=y[b|0];v[x[a+4>>2]]=y[b+1|0]}function Tga(a){a=a|0;return B[yb(a+4208|0,1)>>2]<E(1)|0}function Ph(a,b,c){v[a|0]=y[a|0]|b;x[a+4>>2]=x[a+4>>2]|c}function P_(a){a=a|0;x[a>>2]=124572;lI(a+4|0);return a|0}function PB(a,b){C[a>>3]=C[a>>3]*b;C[a+8>>3]=C[a+8>>3]*b}function Nv(a){wc(a+88|0);wc(a+68|0);wc(a+48|0);return a}function N9(a,b,c){a=a|0;b=b|0;c=c|0;return Gd(D(b,c))|0}function Jga(a){a=a|0;ZP(a);v[a+4202|0]=1;x[a+4224>>2]=0}function JV(a,b,c,d){Zb(Zb(a,b,c)+8|0,x[d>>2],x[d+4>>2])}function JM(a,b){a=a|0;b=b|0;el(a,b,1168,1167,1166,1165)}function IM(a,b){a=a|0;b=b|0;el(a,b,1163,1162,1161,1160)}function FM(a,b){a=a|0;b=b|0;el(a,b,1176,1175,1174,1173)}function EM(a,b){a=a|0;b=b|0;el(a,b,1172,1171,1170,1169)}function Dn(a){v[a|0]=0;v[a+1|0]=0;v[a+2|0]=0;v[a+3|0]=0}function DM(a,b){a=a|0;b=b|0;el(a,b,1184,1183,1182,1181)}function CM(a,b){a=a|0;b=b|0;el(a,b,1180,1179,1178,1177)}function $S(a,b){a=_S(a,b);_S(a+12|0,b+12|0);v[a+24|0]=1}function yR(a){return(a|0)==1179012417|(a|0)==538987841}function vM(a){a=a|0;x[a>>2]=77596;ec(a+4|0);return a|0}function vG(a){a=a|0;x[a>>2]=41504;me(a+4|0);return a|0}function rn(a,b,c){x[a>>2]=b;x[a+4>>2]=x[c>>2];return a}function pda(a,b,c){a=a|0;b=b|0;c=c|0;Kz(x[a+4>>2],b,c)}function oJ(a){var b=0;b=x[a>>2];x[a>>2]=0;if(b){vm(b)}}function lM(a){a=a|0;x[a>>2]=77984;ec(a+8|0);return a|0}function lI(a){a=cl(x[a>>2]);if((mx(a+8|0)|0)<0){Db(a)}}function hg(a,b,c,d,e){return Na(a|0,b|0,c|0,d|0,e|0)|0}function go(a){a=a|0;x[a>>2]=93256;_b(a+4|0);return a|0}function fX(a,b,c,d){return!((a|0)==(c|0)&(b|0)==(d|0))}function _t(a){a=a|0;x[a>>2]=48636;vz(a+4|0);return a|0}function UT(a){var b=0;b=x[a>>2];x[a>>2]=0;if(b){Db(b)}}function Tfa(a,b){a=a|0;b=b|0;return $H(a,b,6432,998)|0}function Sn(a){var b=0;b=x[a+8>>2];x[a+8>>2]=0;return b}function Rca(a,b,c){a=a|0;b=b|0;c=c|0;TO(a,x[b+4>>2],c)}function Qka(a,b,c){a=a|0;b=b|0;c=c|0;_G(a,b,c,834,833)}function QO(a){return Zu(x[a+484344>>2],x[a+484348>>2])}function OD(a){a=a&255;return Tc(a)^1|(a-49&255)>>>0<36}function Nb(a){x[a>>2]=0;x[a+4>>2]=0;tc(a+8|0);return a}function Ld(a,b,c){return a>>>0<b>>>0?b:a>>>0<c>>>0?a:c}function Kka(a,b,c){a=a|0;b=b|0;c=c|0;cI(a,b,c,838,839)}function JK(a,b,c){a=vb(a,b);vb(a+4|0,x[c>>2]);return a}function Hi(a,b,c){a=qq(a,c<<24>>24,b-a|0);return a?a:b}function Gja(a,b,c){a=a|0;b=b|0;c=c|0;_G(a,b,c,910,909)}function Ct(a){a=a|0;x[a>>2]=93320;_b(a+4|0);return a|0}function $L(a,b,c){x[a+4>>2]=0;x[a>>2]=b;x[a+8>>2]=c<<3}function zca(a,b){a=a|0;b=b|0;return NO(x[a+4>>2],b)|0}function z6(){xd(501384,1);mJ(501392);x[125346]=100324}function xna(a,b){a=a|0;b=b|0;Mh(a,b,587,1058,-1332,3)}function x6(){xd(501400,1);mJ(501408);x[125350]=100480}function via(a,b,c){a=a|0;b=b|0;c=c|0;Zb(a,b+4260|0,8)}function sh(a,b){a=a|0;b=b|0;ib[x[x[b>>2]+20>>2]](a,b)}function s7(a,b){a=a|0;b=b|0;Zb(a,dL(x[b>>2]),x[b>>2])}function oda(a,b){a=a|0;b=b|0;rO(x[x[a+4>>2]+24>>2],b)}function oL(a){a=a|0;return Ft(x[x[a>>2]-12>>2]+a|0)|0}function kz(a){return(a&6)==6?384:1152>>>((a&14)==2)|0}function ksa(a,b){a=a|0;b=b|0;Mh(a,b,415,1042,-1332,2)}function jL(a){a=a|0;return Et(x[x[a>>2]-12>>2]+a|0)|0}function gi(a,b){a=a|0;b=b|0;ib[x[x[b>>2]+24>>2]](a,b)}function fi(a,b){a=a|0;b=b|0;ib[x[x[b>>2]+28>>2]](a,b)}function f9(a){a=a|0;return fq(x[x[a>>2]-12>>2]+a|0)|0}function d9(a){a=a|0;return Gf(x[x[a>>2]-12>>2]+a|0)|0}function cua(a,b){a=a|0;b=b|0;Mh(a,b,295,1058,-1332,2)}function aU(a,b){return(a|0)!=(b|0)?a>>>0<b>>>0?-1:1:0}function Yb(a,b,c){return(a|0)<(b|0)?b:(a|0)<(c|0)?a:c}function Woa(a,b){a=a|0;b=b|0;Mh(a,b,260,1042,-1332,2)}function Oh(a){var b=0;b=Rt(a);x[a+1396>>2]=0;return b}function H8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Yl(a,c,d)}function Gna(a,b){a=a|0;b=b|0;if(!BX(a,b)){Rb(b,0,40)}}function Fra(a,b){a=a|0;b=b|0;return Dc(a,b?b:22292)|0}function Fm(a,b){x[a+16>>2]=!x[a+24>>2]|(x[a+16>>2]|b)}function Fha(a,b,c){a=a|0;b=b|0;c=c|0;Zb(a,b+4228|0,7)}function E8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dq(a,c,d)}function CR(a,b){return D(b&65535,a&65535)+7>>>3&65535}function Bua(a,b){a=a|0;b=b|0;Mh(a,b,260,1025,-1284,2)}function Aaa(a,b){a=a|0;b=b|0;JT(x[a>>2],b);return a|0}function xd(a,b){a=DG(a,b-1|0);x[a>>2]=96952;return a}function xQ(a){wc(a+36|0);wc(a+24|0);nu(a+12|0);nu(a)}function uca(a){a=a|0;return pq(x[x[a+4>>2]+24>>2])|0}function uc(a,b){a=a|0;b=b|0;eG(a,b,cs(b));return a|0}function uT(a,b,c,d){return gd(Fo(a,b,c,d,0)-32768|0)}function uR(a,b){return(b>>>0>15?63:v[a+b|0])<<24>>24}function tb(a){if(vd(y[a+11|0])){Db(x[a>>2])}return a}function tR(a,b){return(b>>>0>46?63:v[a+b|0])<<24>>24}function r4(a,b){a=a|0;b=b|0;return ql(b&255)<<24>>24}function p4(a,b){a=a|0;b=b|0;return tt(b&255)<<24>>24}function oj(a){a=a|0;return ib[x[x[a>>2]+16>>2]](a)|0}function nl(a,b){return ib[x[x[a>>2]+36>>2]](a,b,0)|0}function nj(a){a=a|0;return ib[x[x[a>>2]+12>>2]](a)|0}function ls(a,b){a=hc(a,b);Rb(a+20|0,0,1040);return a}function kea(a,b){a=a|0;b=b|0;Mh(a,b,79,1025,-1284,4)}function kB(a){Gq(a+223860|0);ec(a+223848|0);return a}function ica(a){a=a|0;return _O(x[x[a+4>>2]+24>>2])|0}function fg(a,b,c,d){b=b+d|0;hb=a+c>>>0<c>>>0?b+1|0:b}function eE(a,b){a=Ie(a,b);Rb(a+20|0,0,1040);return a}function dD(a,b){a=a|0;b=b|0;Mh(a,b,587,1058,-1332,2)}function bf(a,b,c,d){v[a+8|0]=d;x[a+4>>2]=c;x[a>>2]=b}function aia(a){a=a|0;v[a+4202|0]=1;pu(a);Zz(a);yQ(a)}function af(a,b,c,d){cc(a,md(b,c,d,0),z[c+480188>>1])}function _da(a,b){a=a|0;b=b|0;Mh(a,b,13,1025,-1284,2)}function XN(a,b){hb=0-(((a|0)!=0)+b|0)|0;return 0-a|0}function Tda(a,b){a=a|0;b=b|0;Mh(a,b,79,1025,-1284,2)}function Qca(a){a=a|0;return RO(x[x[a+4>>2]+24>>2])|0}function Oca(a){a=a|0;return ZO(x[x[a+4>>2]+24>>2])|0}function Nra(a,b){a=a|0;b=b|0;Mh(a,b,79,1042,-1332,2)}function Nca(a){a=a|0;return oq(x[x[a+4>>2]+24>>2])|0}function Mqa(a,b,c){a=a|0;b=b|0;c=c|0;Uc(a,c0(c,0,b))}function Lh(a){a=a|0;return ib[x[x[a>>2]+24>>2]](a)|0}function Lca(a){a=a|0;return wo(x[x[a+4>>2]+24>>2])|0}function Kca(a){a=a|0;return QO(x[x[a+4>>2]+24>>2])|0}function Jv(a,b){a=a|0;b=b|0;Mh(a,b,588,1058,-1332,2)}function Ida(a,b){a=a|0;b=b|0;Mh(a,b,80,1025,-1284,2)}function HK(a,b,c){a=sI(a,b,c,0,-2147483648);return a}function Gca(a){a=a|0;return IO(x[x[a+4>>2]+24>>2])|0}function Dca(a){a=a|0;return aP(x[x[a+4>>2]+24>>2])|0}function Dc(a,b){a=a|0;b=b|0;Fu(a,b,Df(b));return a|0}function D4(a,b){a=a|0;b=b|0;return PI(b,x[a+8>>2])|0}function Cca(a){a=a|0;return YO(x[x[a+4>>2]+24>>2])|0}function C2(a,b,c){a=a|0;b=b|0;c=c|0;cI(a,b,c,74,147)}function Bca(a){a=a|0;return XO(x[x[a+4>>2]+24>>2])|0}function y$(a,b,c,d){return Sp(a,b,c,d,40,107374183)}function xu(a){a=a|0;a=_h(a);x[a+20>>2]=0;return a|0}function vr(a,b,c,d,e){Zb(a,b+d|0,(e|0)==-1?c-d|0:e)}function vha(a){a=a|0;return E(B[yb(a+4208|0,1)>>2])}function vda(a){a=a|0;return Sz(x[a>>2],x[a+4>>2])|0}function oG(a,b,c,d){return Sp(a,b,c,d,36,119304648)}function fe(a,b){Zb(a,Kb(b),Cb(x[b+4>>2],y[b+11|0]))}function fC(a){a=Nb(a);x[a+12>>2]=0;w[a+16>>1]=65280}function ee(a,b,c){v[a|0]=b;v[a+1|0]=y[c|0];return a}function bx(a){a=a|0;return ib[x[x[a>>2]+8>>2]](a)|0}function ao(a,b,c,d){return(a|0)==(c|0)&(b|0)==(d|0)}function X$(a,b,c,d){return Sp(a,b,c,d,28,153391690)}function VF(a,b){return(y[b+34|0]&8)>>>3&(a&2050)==2}function Sga(a){a=a|0;return E(B[yb(a+4208|0,3)>>2])}function Nba(a,b,c){a=a|0;b=b|0;c=c|0;uN(a-88|0,b,c)}function Ls(a,b,c,d,e,f){Ka(a|0,b|0,c|0,d|0,e|0,f|0)}function Lr(a,b,c){if(b){kP(a+36|0,b,Hi(b,b+c|0,0))}}function Lba(a,b,c){a=a|0;b=b|0;c=c|0;sN(a-88|0,b,c)}function LJ(a,b,c,d){return Sp(a,b,c,d,24,178956971)}function I4(a,b){a=a|0;b=b|0;Mh(a,b,13,1058,-1332,2)}function Hua(a){if(a){return 31-G(a-1^a)|0}return 32}function GQ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0}function EX(a){var b=0;a=a+8|0;hb=a>>>0<8|b;return a}function DG(a,b){x[a+4>>2]=b;x[a>>2]=124044;return a}function AY(a,b,c){if(c){gl(a,b,(c<<2)-1|0)}return a}function zpa(a,b){a=a|0;b=b|0;return Kx(a,b,1100)|0}function yx(a,b){a=a|0;b=b|0;return iS(a,b,cs(b))|0}function xp(a,b,c){Zb(a,(c>>>3&536870908)+b|0,c&31)}function xl(a,b,c){x[a>>2]=b;x[a+4>>2]=c-b;return a}function wca(a){a=a|0;return+WO(x[x[a+4>>2]+24>>2])}function vua(a,b,c){a=a|0;b=b|0;c=c|0;Vp(a,b,c,261)}function vU(a,b){x[a+8>>2]=0;x[a+12>>2]=0;C[a>>3]=b}function ssa(a,b){a=a|0;b=b|0;return As(a,b,1228)|0}function sm(a){a=a|0;a=nc(a);ib[x[x[a>>2]>>2]](a)|0}function qC(a){v[a+6|0]=0;w[a+4>>1]=65535;x[a>>2]=0}function ne(a){var b=0;b=x[a>>2];x[a>>2]=0;return b}function nda(a,b){a=a|0;b=+b;return+sO(x[a+4>>2],b)}function nca(a){a=a|0;return+PA(x[x[a+4>>2]+24>>2])}function mQ(a){a=a|0;return E(B[yb(a+4208|0,0)>>2])}function lua(a,b){a=a|0;b=b|0;Jx(a,b,260,274,-1332)}function lqa(a,b,c){a=a|0;b=b|0;c=c|0;Bs(a,b,c,595)}function kqa(a,b,c){a=a|0;b=b|0;c=c|0;Bs(a,b,c,596)}function jsa(a,b,c){a=a|0;b=b|0;c=c|0;Vp(a,b,c,416)}function j3(a){a=a|0;a=ib[a|0]()|0;gb=hb;return a|0}function gqa(a,b,c){a=a|0;b=b|0;c=c|0;mH(a,b,c,502)}function eqa(a,b,c){a=a|0;b=b|0;c=c|0;uH(a,b,c,303)}function dqa(a,b,c){a=a|0;b=b|0;c=c|0;aH(a,b,c,303)}function bpa(a,b){a=a|0;b=b|0;return As(a,b,1224)|0}function _ta(a,b,c){a=a|0;b=b|0;c=c|0;Bs(a,b,c,298)}function _aa(a,b){a=a|0;b=b|0;return As(a,b,1227)|0}function ZA(a,b){x[a>>2]=b;x[a+4>>2]=b>>31;return a}function Xta(a,b,c){a=a|0;b=b|0;c=c|0;jH(a,b,c,303)}function X1(a,b){a=a|0;b=b|0;return BF(a,b,Df(b))|0}function Wna(a,b,c){a=a|0;b=b|0;c=c|0;Uc(a,yx(b,c))}function WF(a,b,c){Zb(a,(c>>>3&536870908)+b|0,1<<c)}function Vsa(a,b,c){a=a|0;b=b|0;c=c|0;q_(a,c,b,0,0)}function Qqa(a,b,c){a=a|0;b=b|0;c=c|0;nH(a,b,c,256)}function QT(a,b,c,d){return Sp(a,b,c,d,7,613566757)}function Q9(a,b,c){a=a|0;b=b|0;c=c|0;Bs(a,b,c,1210)}function Pba(a,b,c){a=a|0;b=b|0;c=+c;wN(a-88|0,b,c)}function Mba(a,b){a=a|0;b=b|0;return tN(a-88|0,b)|0}function Lj(a){if(!a){return 0}return x[a+44>>2]!=0}function Kba(a,b){a=a|0;b=b|0;return rN(a-88|0,b)|0}function Ipa(a,b){a=a|0;b=b|0;return ai(a,b,1030)|0}function GN(a){a=a|0;a=x[a+4>>2];return(a?a:5011)|0}function Dba(a,b,c){a=a|0;b=b|0;c=+c;mN(a-92|0,b,c)}function Cj(a){if(!a){return 0}return Kj(y[a+31|0])}function Bba(a,b,c){a=a|0;b=b|0;c=+c;kN(a-92|0,b,c)}function BG(a){return AL(a,E(15845632502852868e13))}function $F(a){return AL(a,E(2524354896707238e-44))}function zja(a,b){a=a|0;b=b|0;return ai(a,b,326)|0}function zga(a,b){a=a|0;b=b|0;return E(Bm(a,b,12))}function zG(a,b){a=xG(a,b);x[a>>2]=124852;return a}function xJ(a,b){a=xd(a,b);x[a>>2]=100840;return a}function wJ(a,b){a=xd(a,b);x[a>>2]=100988;return a}function vJ(a,b){a=xd(a,b);x[a>>2]=101104;return a}function uua(a,b,c){a=a|0;b=b|0;c=c|0;uH(a,b,c,47)}function uba(a){a=a|0;x[a>>2]=48416;return fu(a)|0}function uJ(a,b){a=xd(a,b);x[a>>2]=101220;return a}function rda(a,b,c){a=a|0;b=b|0;c=c|0;Vp(a,b,c,82)}function rJ(a,b){a=xd(a,b);x[a>>2]=102408;return a}function qJ(a,b){a=xd(a,b);x[a>>2]=102528;return a}function _y(a){if(!a){return 0}x[31484]=a;return-1}function Zna(a,b,c){a=a|0;b=b|0;c=c|0;jH(a,b,c,47)}function Zm(a){Bj(a+724|0);Bj(a+732|0);Bj(a+740|0)}function Zk(a,b){return(a&65535)>>>0<(b&65535)>>>0}function X2(a,b){a=a|0;b=b|0;return As(a,b,1226)|0}function Ica(a,b,c){a=a|0;b=b|0;c=c|0;aH(a,b,c,47)}function IG(a,b,c){a=a|0;b=b|0;c=c|0;Uc(a,cx(b,c))}function Hqa(a,b){a=a|0;b=b|0;return ai(a,b,422)|0}function Dr(a,b,c){a=a|0;b=b|0;c=c|0;mH(a,b,c,123)}function Dda(a,b,c){a=a|0;b=b|0;c=c|0;Vp(a,b,c,81)}function DY(a,b,c){a=a|0;b=b|0;c=c|0;Uc(a,Yy(b,c))}function Csa(a,b){a=a|0;b=b|0;return ai(a,b,308)|0}function Cqa(a,b){a=a|0;b=b|0;return ai(a,b,826)|0}function Cja(a,b){a=a|0;b=b|0;return ai(a,b,225)|0}function zqa(a,b){a=a|0;b=b|0;return ai(a,b,41)|0}function zR(a,b){return(a|0)==1179011410&b>>>0>80}function ye(a,b,c){x[a>>2]=b;x[a+4>>2]=c;return a}function xja(a,b){a=a|0;b=b|0;return ai(a,b,60)|0}function x1(a,b,c){a=a|0;b=b|0;c=c|0;Vp(a,b,c,18)}function v$(a){return(x[Ab(a)>>2]-x[a>>2]|0)/40|0}function th(a,b){a=a|0;b=b|0;return lL(a)^lL(b)^1}function tE(a){return(x[Ab(a)>>2]-x[a>>2]|0)/28|0}function sga(a,b){a=a|0;b=b|0;return E(Bm(a,b,2))}function ppa(a,b){a=a|0;b=b|0;return ai(a,b,71)|0}function nha(a,b){a=a|0;b=b|0;return E(Bm(a,b,5))}function lX(a){return(x[Ab(a)>>2]-x[a>>2]|0)/56|0}function kga(a,b){a=a|0;b=b|0;return E(Bm(a,b,3))}function kO(a){x[a+4>>2]=0;x[a>>2]=47588;return a}function kF(a){return!jd(a,24576,25)&y[a+34|0]<65}function jI(a){return(a<<1)+16777216>>>0<16777217}function it(a){return(x[Ab(a)>>2]-x[a>>2]|0)/24|0}function hx(a){return(x[Ab(a)>>2]-x[a>>2]|0)/36|0}function hra(a,b){a=a|0;b=b|0;return ai(a,b,91)|0}function hi(a,b){a=a|0;b=b|0;return fL(a)^fL(b)^1}function fha(a,b){a=a|0;b=b|0;return E(Bm(a,b,4))}function f2(a,b){a=a|0;b=b|0;Jx(a,b,13,257,-1284)}function dn(a,b,c){x[a+4>>2]=c;w[a>>1]=b;return a}function dl(a){return(x[Ab(a)>>2]-x[a>>2]|0)/12|0}function cra(a,b){a=a|0;b=b|0;if(!YY(a,b)){XY(b)}}function c$(a,b){a=a|0;b=b|0;return iH(a,b,345)|0}function Zb(a,b,c){x[a+4>>2]=c;x[a>>2]=b;return a}function VY(a){return(x[Ab(a)>>2]-x[a>>2]|0)/33|0}function UE(a){return(x[Ab(a)>>2]-x[a>>2]|0)/20|0}function SZ(a){if(!(a&255)){return 1}return Tc(a)}function Rpa(a,b){a=a|0;b=b|0;if(!AE(a,b)){GE(b)}}function Ql(a,b,c){C[a+8>>3]=c;C[a>>3]=b;return a}function Ps(a){return a-48>>>0<10|(a|32)-97>>>0<6}function Oba(a,b){a=a|0;b=b|0;return+vN(a-88|0,b)}function NZ(a,b){a=a|0;b=b|0;return iH(a,b,322)|0}function N4(a,b){a=a|0;b=b|0;Jx(a,b,13,290,-1332)}function Mja(a,b){a=a|0;b=b|0;if(!iG(a,b)){vx(b)}}function Lga(a,b){a=a|0;b=b|0;return E(Bm(a,b,1))}function Jsa(a,b){a=a|0;b=b|0;if(!_Z(a,b)){ZZ(b)}}function Isa(a,b){a=a|0;b=b|0;return ai(a,b,78)|0}function Iq(a,b){x[a+4>>2]=256;x[a>>2]=b;return a}function Eja(a,b){a=a|0;b=b|0;return ai(a,b,73)|0}function EJ(a,b){a=xd(a,b);x[a>>2]=98308;return a}function Du(a){return(x[Ab(a)>>2]-x[a>>2]|0)/52|0}function DI(a){return(Nh(a)|0)!=0|(a|32)-97>>>0<6}function Cba(a,b){a=a|0;b=b|0;return+lN(a-92|0,b)}function CJ(a,b){a=xd(a,b);x[a>>2]=98340;return a}function Aha(a,b){a=a|0;b=b|0;return E(Bm(a,b,6))}function Aba(a,b){a=a|0;b=b|0;return+jN(a-92|0,b)}function AJ(a,b){a=xd(a,b);x[a>>2]=97008;return a}function wx(a){x[a>>2]=0;x[a+4>>2]=0;x[a+8>>2]=0}function ww(a,b){a=a|0;b=b|0;if(!Cp(a,b)){qp(b)}}function tu(a){a=a|0;wc(a+4208|0);return _f(a)|0}function qR(a,b,c){if(c){gl(a,b,D(c,6))}return a}function p$(a,b){a=a|0;b=b|0;if(!o$(a,b)){fw(b)}}function mta(a,b){a=a|0;b=b|0;Up(a,b,362,361,8)}
function lD(a,b){a=a|0;b=b|0;if(!jZ(a,b)){rD(b)}}function kE(a,b){a=a|0;b=b|0;if(!F$(a,b)){Cr(b)}}function iw(a){return(a|0)<=0?1:a>>>0>=120?120:a}function ip(a,b){a=a|0;b=b|0;if(!Zh(a,b)){al(b)}}function hw(a){return(x[Ab(a)>>2]-x[a>>2]|0)/6|0}function hQ(a){a=a|0;wc(a+4256|0);return _f(a)|0}function f_(a,b){a=a|0;b=b|0;if(!aG(a,b)){as(b)}}function fF(a,b){a=aF(a,b);if(!a){Dn(b)}return a}function bi(a,b,c){return Fa(1010,a|0,b|0,c|0)|0}function Zl(a,b,c){v[a+2|0]=c;w[a>>1]=b;return a}function VS(a,b,c){x[a+4>>2]=c;v[a|0]=b;return a}function VB(a){x[a+24>>2]=z[a+20>>1]<<z[a+22>>1]}function SX(a,b){x[a>>2]=x[a>>2]+(b<<1);return a}function S0(a,b){a=a|0;b=b|0;if(!K0(a,b)){IE(b)}}function Rn(a,b,c){a=Md(a);x[a+4>>2]=c;x[a>>2]=b}function Mda(a){a=a|0;return QH(a,47528,12605)|0}function M$(a,b){a=t$(a,b);if(!a){oE(b)}return a}function HB(a){return(x[Ab(a)>>2]-x[a>>2]|0)/7|0}function Ew(a,b){a=a|0;b=b|0;if(!lx(a,b)){kx(b)}}function DQ(a){a=a|0;ec(a+4208|0);return _f(a)|0}function Bz(a,b){x[a>>2]=x[b>>2];Uc(a+4|0,b+4|0)}function B_(a,b){x[a>>2]=x[a>>2]+D(b,6);return a}function z5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499836))}function xga(a){a=a|0;WP(a);Tz(a);v[a+4202|0]=1}function x5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499844))}function wua(a,b,c){a=a|0;b=b|0;c=c|0;A0(a,b,c)}function w5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499852))}function w1(a,b){a=a|0;b=b|0;Qp(a,b);return a|0}function v5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499868))}function uB(a){if(y[a+24|0]){dT(a);v[a+24|0]=0}}function u5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499860))}function tL(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function t5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499876))}function r5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499884))}function qe(a,b){return Zk(z[a>>1],z[b>>1])?b:a}function qca(a){a=a|0;return+C[x[a+4>>2]+16>>3]}function pY(a){var b=0;b=x[a>>2];we(a);return b}function p5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499892))}function oua(a,b){a=a|0;b=b|0;Up(a,b,297,296,8)}function n5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499704))}function mJ(a){var b=0,c=0;b=a,c=Od(),x[b>>2]=c}function lha(a){a=a|0;v[a+4202|0]=1;eQ(a);gQ(a)}function kla(a,b,c){a=a|0;b=b|0;c=c|0;he(a,b,c)}function k5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499712))}function jra(a,b){a=a|0;b=b|0;Up(a,b,520,519,6)}function jpa(a,b){a=a|0;b=b|0;Up(a,b,682,681,8)}function i5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499720))}function ho(a){return ib[x[x[a>>2]+28>>2]](a)|0}function g5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499728))}function fba(a,b){a=a|0;b=b|0;Uc(a,nO(b,18281))}function e5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499672))}function dha(a){a=a|0;v[a+4202|0]=1;cQ(a);bQ(a)}function c5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499680))}function bd(a,b){return Gk(x[a>>2],x[b>>2])?b:a}function a5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499688))}function _4(a,b){a=a|0;b=b|0;ad(a,b,Vc(499696))}function Z4(a,b){a=a|0;b=b|0;ad(a,b,Vc(499768))}function Y4(a,b){a=a|0;b=b|0;ad(a,b,Vc(499776))}function Xz(a,b){return Rv(B[a>>2],B[b>>2])?b:a}function Xj(a,b){a=a|0;b=b|0;d0(a,x[a+16>>2]|b)}function Xe(a,b){return Yq(x[a>>2],x[b>>2])?b:a}function Tv(a,b){a=a|0;b=b|0;return Mb(a,b,1)^1}function Sm(a,b){return Rv(B[b>>2],B[a>>2])?b:a}function Oc(a,b){return Zk(z[b>>1],z[a>>1])?b:a}function Lk(a){return ib[x[x[a>>2]+36>>2]](a)|0}function Lda(a){a=a|0;return QH(a,47548,8191)|0}function Kt(a,b){if(!a){return 0}return Jt(a,b)}function Jl(a,b){return $m((b<<1)+121136|0,2,a)}function Hb(a,b){return Gk(x[b>>2],x[a>>2])?b:a}function H0(a,b){return(b&255)==2&(a&255)>>>0<3}function E5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499624))}function Cd(a,b){return Yq(x[b>>2],x[a>>2])?b:a}function C5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499632))}function Bpa(a,b){a=a|0;b=b|0;Up(a,b,649,648,8)}function B5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499828))}function A5(a,b){a=a|0;b=b|0;ad(a,b,Vc(499820))}function yE(a,b,c){a=a|0;b=b|0;c=c|0;h0(a,b,c)}function un(a){a=Ej(a);x[a>>2]=124456;return a}function rP(a){x[a>>2]=0;x[a+4>>2]=-1;return a}function pca(a){a=a|0;return x[x[a+4>>2]+8>>2]}function oi(a,b){return(D(b,104)+a|0)+484380|0}function oaa(a){a=a|0;x[a>>2]=77232;return a|0}function mf(a,b){v[a+4|0]=1;x[a>>2]=b;return a}function kaa(a){a=a|0;x[a>>2]=76732;return a|0}function jja(a,b){a=a|0;b=b|0;QA(mR(a+24|0,b))}function iaa(a,b){a=a|0;b=b|0;JH(a,b,1204,292)}function eea(a,b){a=a|0;b=b|0;return cx(a,b)|0}function eaa(a){a=a|0;x[a>>2]=78040;return a|0}function bv(a){return(a>>>0<9?a:a-9|256)&65535}function Zn(a,b,c,d,e){Oa(a|0,b|0,c|0,d|0,e|0)}function Xt(a,b){return(a&255)>>>0<(b&255)>>>0}function XC(a,b,c){if(c){gl(a,b,c<<2)}return a}function Wi(a,b){return y[a+b|0]!=63&b>>>0<=46}function Wea(a){a=a|0;return XH(a,7109,1054)|0}function V3(a,b,c){a=a|0;b=b|0;c=c|0;Zb(a,c,b)}function Og(a,b){v[a+4|0]=0;x[a>>2]=b;return a}function LZ(a,b,c){a=a|0;b=b|0;c=c|0;I0(a,b,c)}function L$(a,b,c){a=a|0;b=b|0;c=c|0;L0(a,b,c)}function Ks(a,b,c,d,e){Ea(a|0,b|0,c|0,d|0,e|0)}function Kf(a,b,c){if(!(y[a|0]&32)){vw(b,c,a)}}function Jn(a){return(a>>>0<=127?-1:a^128)&255}function Jka(a,b){a=a|0;b=b|0;return Yy(a,b)|0}function Hg(a,b,c){a=Jua(a,b,c,c>>31);return a}function Eea(a){a=a|0;return XH(a,6626,1062)|0}function EU(a){QB(a);Rb(a+27|0,0,255);return a}function Apa(a,b){a=a|0;b=b|0;return BX(a,b)|0}function $v(a,b){return y[a+b|0]!=63&b>>>0<=15}function $U(a,b,c){if(c){gl(a,b,c<<1)}return a}function zsa(a,b){a=a|0;b=b|0;Lx(a,b,17,3,16)}function yca(a,b){a=a|0;b=b|0;MO(a,x[b+4>>2])}function yP(a,b){a=a|0;b=b|0;return nO(a,b)|0}function xca(a,b){a=a|0;b=b|0;GO(a,x[b+4>>2])}function xc(a,b){if(A[a>>2]>b>>>0){x[a>>2]=b}}function xaa(a,b){a=a|0;b=b|0;JH(a,b,1200,36)}function vi(a,b){if(x[a>>2]>(b|0)){x[a>>2]=b}}function uaa(a){a=a|0;tM(a);return x[a+16>>2]}function sda(a,b){a=a|0;b=b|0;Lz(x[a+4>>2],b)}function sca(a,b){a=a|0;b=b|0;UO(a,x[b+4>>2])}function nL(a){a=a|0;Vy(x[x[a>>2]-12>>2]+a|0)}function mu(a,b){a=a|0;b=b|0;return jg(a,b)|0}function kua(a,b){a=a|0;b=b|0;Lx(a,b,44,2,44)}function iL(a){a=a|0;Ty(x[x[a>>2]-12>>2]+a|0)}function i2(a){a=a|0;x[a>>2]=78312;return a|0}function gv(a,b,c,d){return(b-d|0)+(a-c<<3)|0}function fu(a){a=a|0;x[a>>2]=48396;return a|0}function e9(a){a=a|0;aL(x[x[a>>2]-12>>2]+a|0)}function dA(a){return x[Ab(a)>>2]-x[a>>2]>>11}function cf(a,b){return Xt(y[a|0],y[b|0])?b:a}function cZ(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function c9(a){a=a|0;$K(x[x[a>>2]-12>>2]+a|0)}function bta(a,b){a=a|0;b=b|0;qH(a,b,366,365)}function aX(a){a=Iua(a&65535,0,80,0);return a}function Y1(a){a=a|0;x[a>>2]=41368;return a|0}function V1(a){a=a|0;x[a>>2]=41128;return a|0}function Uta(a,b){a=a|0;b=b|0;qH(a,b,306,305)}function Tt(a){a=TL(a);x[a>>2]=94552;return a}function SK(a){a=TL(a);x[a>>2]=94944;return a}function Qb(a,b){return Xt(y[b|0],y[a|0])?b:a}function PJ(a,b,c){a=a|0;b=b|0;c=c|0;return-1}function Md(a){x[a>>2]=0;x[a+4>>2]=0;return a}function Mca(a,b){a=a|0;b=b|0;OO(a,x[b+4>>2])}function L_(a){a=(a&65535)-98|0;hb=0;return a}function Kq(a){return(a-65&255)>>>0<26?a|32:a}function K$(a){v[a+12|0]=y[a+12|0]|2;return a}function J2(a,b){a=a|0;b=b|0;return yx(a,b)|0}function Iy(a,b,c){a=sI(a,b,c,-1,-1);return a}function Hf(a,b){if(z[a>>1]>b>>>0){w[a>>1]=b}}function Fca(a,b){a=a|0;b=b|0;HO(a,x[b+4>>2])}function Eca(a,b){a=a|0;b=b|0;hP(a,x[b+4>>2])}function CW(a){return Ye(443250/+(a>>>0)*1e4)}function $9(a){a=a|0;x[a>>2]=77652;return a|0}function y6(a){a=a|0;ad(a,501384,Vc(499688))}function w6(a){a=a|0;ad(a,501400,Vc(499696))}function vu(a,b){return D((b-a|0)/6|0,6)+a|0}function vca(a){a=a|0;return $O(x[a+4>>2])|0}function vaa(a){a=a|0;tM(a);return x[a+4>>2]}function v6(a){a=a|0;ad(a,501416,Vc(499768))}function uZ(a,b,c){Zb(a,b,Hi(b,b+c|0,0)-b|0)}function u6(a){a=a|0;ad(a,501424,Vc(499776))}function tk(a){a=a&255;return(a|0)==255?-1:a}function qI(a,b,c){a=a|0;b=b|0;c=c|0;_K(a,c)}function pC(a){return x[Ab(a)>>2]-x[a>>2]>>8}function kv(a){return x[Ab(a)>>2]-x[a>>2]>>4}function iB(a){v[a+24|0]=0;v[a|0]=0;return a}function _6(a){a=a|0;ad(a,501104,Vc(499624))}function Z6(a){a=a|0;ad(a,501112,Vc(499632))}function Yo(a){return x[Ab(a)>>2]-x[a>>2]>>5}function Y6(a){a=a|0;ad(a,501120,Vc(499828))}function X6(a){a=a|0;ad(a,501136,Vc(499820))}function W6(a){a=a|0;ad(a,501144,Vc(499836))}function Vz(a){return E(E(a*E(7900))+E(100))}function Vg(a){return x[Ab(a)>>2]-x[a>>2]>>2}function Uz(a){return x[nc(a)>>2]-x[a>>2]>>2}function U6(a){a=a|0;ad(a,501152,Vc(499844))}function Tn(a){return x[Ab(a)>>2]-x[a>>2]>>3}function Th(a){return x[x[a+8>>2]>>2]==(a|0)}function T6(a){a=a|0;ad(a,501168,Vc(499852))}function S6(a){a=a|0;ad(a,501176,Vc(499868))}function R6(a){a=a|0;ad(a,501184,Vc(499860))}function Q6(a){a=a|0;ad(a,501192,Vc(499876))}function P6(a){a=a|0;ad(a,501200,Vc(499884))}function O6(a){a=a|0;ad(a,501224,Vc(499892))}function N6(a){a=a|0;ad(a,501256,Vc(499640))}function M6(a){a=a|0;ad(a,501264,Vc(499648))}function L6(a){a=a|0;ad(a,501272,Vc(499656))}function K6(a){a=a|0;ad(a,501280,Vc(499664))}function Jca(a){a=a|0;return PO(x[a+4>>2])|0}function JQ(a){x[a>>2]=x[a>>2]-2048;return a}function J9(a){a=a|0;return Ba(x[a+60>>2])|0}function J6(a){a=a|0;ad(a,501288,Vc(499704))}function In(a){return x[Ab(a)>>2]-x[a>>2]>>1}function I6(a){a=a|0;ad(a,501296,Vc(499712))}function H6(a){a=a|0;ad(a,501304,Vc(499720))}function G6(a){a=a|0;ad(a,501312,Vc(499728))}function Fp(a,b,c,d){a=Jua(a,b,c,d);return a}function F6(a){a=a|0;ad(a,501320,Vc(499736))}function E6(a){a=a|0;ad(a,501328,Vc(499744))}function D6(a){a=a|0;ad(a,501336,Vc(499752))}function Ck(a){return bH(a,E(4294967296),-1)}function Cb(a,b){if(!vd(b)){a=Hh(b)}return a}function CY(a,b,c){w[a>>1]=b;v[a+2|0]=y[c|0]}function C6(a){a=a|0;ad(a,501344,Vc(499760))}function B6(a){a=a|0;ad(a,501352,Vc(499672))}function A6(a){a=a|0;ad(a,501368,Vc(499680))}function $z(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0}function zia(a,b){a=a|0;b=b|0;v[a+4201|0]=b}function su(a){a=a|0;ib[x[x[a>>2]+4>>2]](a)}function io(a){a=a|0;dL(x[a>>2]);return a|0}function bp(a,b){w[a>>1]=b;w[a+2>>1]=b>>>16}function bC(a,b,c){if(c){gl(a,b,c)}return a}function Xw(a,b){if(b){Dc(a,b);return}Fb(a)}function Xq(a,b){return a<<16>>16<b<<16>>16}function XV(a){x[a>>2]=x[a>>2]-256;return a}function XO(a){return A[a+1074420>>2]/1e4|0}function Wha(a,b,c){a=a|0;b=b|0;c=c|0;Md(a)}function Uv(){da(un(ac(4))|0,124540,34);p()}function Sl(a,b){return Xq(z[a>>1],z[b>>1])}function Of(a,b){if(y[a|0]>b>>>0){v[a|0]=b}}function Ji(a,b){a=a|0;b=b|0;return E(E(0))}function H4(a,b){a=a|0;b=b|0;return $x(b)|0}function Gm(a){a=a|0;Uy(x[a>>2]);return a|0}function F4(a,b){a=a|0;b=b|0;return ay(b)|0}function EB(a){v[a+4|0]=0;v[a|0]=0;return a}function Cn(a,b,c){return Yj(a,b)>>>0>c>>>0}function CU(a,b){x[a>>2]=x[a>>2]+b;return a}function $o(a){return x[Ab(a)>>2]-x[a>>2]|0}function ym(a){x[a>>2]=x[a>>2]+12;return a}function y9(a){a=a|0;return Vh(a,499640)|0}function wk(a){tb(a+36|0);wc(a+24|0);Nk(a)}function vf(a,b,c){a=Iua(c,0,a,b);return a}function u$(a){x[a>>2]=x[a>>2]-40;return a}function tca(a){a=a|0;return+VO(x[a+4>>2])}function r9(a){a=a|0;return Vh(a,499656)|0}function pw(a){x[a>>2]=x[a>>2]-28;return a}function on(a){dC(x[a+20>>2]);x[a+20>>2]=0}function o2(a){a=a|0;return x[a+4>>2]!=0|0}function ml(a,b){ib[x[x[b>>2]+44>>2]](a,b)}function ll(a,b){ib[x[x[b>>2]+32>>2]](a,b)}function lk(a){x[a>>2]=x[a>>2]-12;return a}function lW(a,b,c,d){Zb(a,b,(d|0)==-1?c:d)}function lG(a){x[a>>2]=x[a>>2]-36;return a}function jt(a,b){ib[x[x[b>>2]+40>>2]](a,b)}function jX(a){x[a>>2]=x[a>>2]-56;return a}function gR(a){x[a>>2]=x[a>>2]-52;return a}function ft(a){x[a>>2]=x[a>>2]-24;return a}function fo(a){a=a|0;Cs(a,162,124900,1051)}function fA(a){x[a>>2]=x[a>>2]+24;return a}function eua(a,b){a=a|0;b=b|0;FE(a+36|0,b)}function em(a){x[a>>2]=x[a>>2]+28;return a}function cka(a,b){a=a|0;b=b|0;ps(a+40|0,b)}function ar(a){tf(a+24|0);ec(a+12|0);ec(a)}function Zq(a){x[a>>2]=x[a>>2]+32;return a}function Xba(a,b){a=a|0;b=b|0;EN(a-88|0,b)}function Wq(a){x[a>>2]=x[a>>2]-16;return a}function Wba(a,b){a=a|0;b=b|0;DN(a-88|0,b)}function WS(a,b){return xH(a,b,2147483647)}function Vl(a){x[a>>2]=x[a>>2]+52;return a}function Ut(a){return(a|0)<=65535&(a|0)>=0}function Uo(a){x[a>>2]=x[a>>2]+16;return a}function To(a){x[a>>2]=x[a>>2]-32;return a}function TY(a){x[a>>2]=x[a>>2]-33;return a}function T4(a){a=a|0;Cs(a,162,124900,1231)}function Ry(a){a=a|0;return Vh(a,499820)|0}function Qf(a){x[a>>2]=x[a>>2]+20;return a}function Py(a){a=a|0;return Vh(a,499836)|0}function PP(a){return E(E(a*E(96))+E(-96))}function O_(a){x[a>>2]=x[a>>2]-20;return a}function Ly(a){a=a|0;return Vh(a,499884)|0}function LI(a){a=a|0;return AH(a,101648)|0}function Kg(a){return E(F(a))==E(Infinity)}function KI(a){a=a|0;return AH(a,101544)|0}function KD(a){a=a|0;return Vh(a,499844)|0}function JI(a){a=a|0;return zH(a,101440)|0}function Iba(a,b){a=a|0;b=b|0;pN(a-88|0,b)}function II(a){a=a|0;return zH(a,101336)|0}function Gp(a){ms(a+32|0);ub(a+12|0);tb(a)}function Goa(a,b){a=a|0;b=b|0;lH(a,b,2,31)}function Fy(a){a=a|0;return Vh(a,499892)|0}function Fw(a){a=a|0;return Vh(a,499828)|0}function Fba(a,b){a=a|0;b=b|0;oN(a-92|0,b)}function Eba(a,b){a=a|0;b=b|0;nN(a-92|0,b)}function AL(a,b){return E(Gx(a?E(-b):b)*b)}function zs(a,b){x[a>>2]=b;qm(b);return a}function ze(a){return Bb(a&65535)<<16>>16}function zba(a){a=a|0;return mq(a-96|0)|0}function xsa(a,b){a=a|0;b=b|0;yi(a,b,282)}function xj(a){x[a>>2]=x[a>>2]-4;return a}function xba(a,b){a=a|0;b=+b;iN(a-96|0,b)}function xW(a){x[a>>2]=x[a>>2]-1;return a}function we(a){x[a>>2]=x[a>>2]+1;return a}function vy(a,b){a=a|0;b=b|0;jg(a,b+12|0)}function ul(a){a=a|0;return mL(a)<<24>>24}function ty(a,b){a=a|0;b=b|0;jg(a,b+16|0)}function tg(a){x[a>>2]=x[a>>2]+6;return a}function oz(a,b,c){Zb(a,(c<<12)+b|0,4096)}function oN(a,b){a=a|0;b=b|0;NH(a,b,2048)}function nz(a,b){a=a|0;b=b|0;jg(a,b+36|0)}function nN(a,b){a=a|0;b=b|0;NH(a,b,4096)}function mq(a){a=a|0;sq(a+8|0);return a|0}function mZ(a){x[a>>2]=x[a>>2]-6;return a}function ge(a){x[a>>2]=x[a>>2]+2;return a}function fK(a,b){a=a|0;b=b|0;jg(a,b+24|0)}function ev(a){Rm(a,Ro(a),78544);return a}function es(a){x[a>>2]=x[a>>2]-8;return a}function eK(a,b){a=a|0;b=b|0;jg(a,b+48|0)}function dI(a){a=Da(a|0)|0;hb=gb;return a}function bK(a,b){a=a|0;b=b|0;$p(a,b+28|0)}function aua(a,b){a=a|0;b=b|0;yi(a,b,136)}function aK(a,b){a=a|0;b=b|0;$p(a,b+40|0)}function Zba(a){a=a|0;return mq(a-88|0)|0}function Xk(a){x[a>>2]=x[a>>2]-2;return a}function We(a){x[a>>2]=x[a>>2]+4;return a}function WO(a){return+A[a+1074420>>2]/1e4}function Vm(a){return E(F(a))<E(Infinity)}function Vba(a,b){a=a|0;b=+b;CN(a-88|0,b)}function Tba(a,b){a=a|0;b=+b;AN(a-88|0,b)}function T9(a,b){a=a|0;b=b|0;wm(a,b+12|0)}function Rf(a){a=a|0;_h(a+8|0);return a|0}function Rba(a,b){a=a|0;b=+b;yN(a-88|0,b)}function Qpa(a,b){a=a|0;b=b|0;yi(a,b,274)}function QP(a){a=a|0;Rb(a+4296|0,0,81928)}function OB(a){x[a>>2]=x[a>>2]+8;return a}function NC(a,b,c){return UX(a,VX(a,b,c))}function Lpa(a,b){a=a|0;b=b|0;yi(a,b,106)}function LT(a){x[a>>2]=x[a>>2]-7;return a}function Hta(a,b){a=a|0;b=b|0;lH(a,b,3,8)}function Hq(a,b){v[a|0]=b+48;return a+1|0}function Hba(a){a=a|0;return mq(a-92|0)|0}function Gha(a){a=a|0;v[a+4202|0]=1;sQ(a)}function Ft(a){a=a|0;vl(a+8|0);return a|0}function Et(a){a=a|0;vl(a+4|0);return a|0}function Dg(a,b,c){yk(b,b+c|0,a);return a}function Cga(a){a=a|0;return x[a+4260>>2]}function BB(a,b){if(B[a>>2]>b){B[a>>2]=b}}function $J(a,b){a=a|0;b=b|0;$p(a,b+52|0)}function ysa(a,b){a=a|0;b=b|0;Lr(a,b,17)}function ys(a,b){x[a+24>>2]=x[a+24>>2]+b}function yia(a){a=a|0;return y[a+4201|0]}function xia(a){a=a|0;return y[a+4202|0]}function tt(a){return a-65>>>0<26?a|32:a}function ql(a){return a-97>>>0<26?a&95:a}function of(a,b){x[a+8>>2]=b|-2147483648}function mr(a,b,c){x[a>>2]=b;x[a+4>>2]=c}function mo(a,b,c){return ib[c|0](a,b)|0}function le(a,b){return(b|0)!=0&(a|0)!=0}function kg(a,b){a=Jua(0,a,b,0);return a}function kc(a){x[x[a>>2]+4>>2]=x[a+4>>2]}function iua(a,b){a=a|0;b=b|0;sH(a,b,28)}function hta(a,b){a=a|0;b=b|0;yi(a,b,34)}function hl(a){return(a|0)==32|a-9>>>0<5}function e6(a,b){a=a|0;b=b|0;vn(a,96616)}function d6(a,b){a=a|0;b=b|0;vn(a,96636)}function cga(a){a=a|0;return(a|0)==277|0}function c6(a,b){a=a|0;b=b|0;Dc(a,11296)}function bj(a,b){v[a|0]=b;v[a+1|0]=b>>>8}function b6(a,b){a=a|0;b=b|0;Dc(a,11413)}function _k(a){return D(Kn(a),_d(a))&255}function Xx(a){return a-501744>>>2&65535}function Pr(a,b,c,d,e){wH(a,b,c,d,e,256)}function Pqa(a,b){a=a|0;b=b|0;yi(a,b,42)}function Kw(a,b,c,d,e){wH(a,b,c,d,e,128)}function Jpa(a,b){a=a|0;b=b|0;yi(a,b,72)}function JY(a,b){a=a|0;b=b|0;yi(a,b,284)}function EG(a,b){Tb(a,b);Tb(a+4|0,b+4|0)}function Bj(a){w[a+4>>1]=65535;x[a>>2]=0}function xY(a,b){x[a>>2]=x[a>>2]+(b<<2)}function x0(a,b,c){return!jd(a,c,b-a|0)}function um(a){a=x[a+8>>2];if(a){Db(a)}}function pi(a){return(a&65535)>>>0<3999}function p0(a,b){a=a|0;b=b|0;yi(a,b,50)}function nga(a){a=a|0;return-2013527448}function nI(a){return(z[a+2>>1]<<2)+a|0}function jY(a,b){a=a|0;b=b|0;return b|0}function i1(a,b){a=a|0;b=b|0;yi(a,b,59)}function hK(a,b){a=a|0;b=b|0;qf(a,1,45)}function gK(a,b){a=a|0;b=b|0;Ay(a,1,45)}function fP(a,b){return WH(a,b,1075834)}function dP(a,b){return VH(a,b,1075834)}function cP(a,b){return VH(a,b,1075835)}function bra(a,b){a=a|0;b=b|0;N0(a,b,8)}function bP(a,b){return WH(a,b,1075835)}function _g(a,b,c){v[a+4|0]=c;x[a>>2]=b}function Zv(a,b,c){return a<b?b:a>c?c:a}function XI(a){a=a|0;return ud(a-8|0)|0}function X0(a,b){a=a|0;b=b|0;Lr(a,b,11)}function WI(a){a=a|0;return jy(a-8|0)|0}function VI(a){a=a|0;return iy(a-8|0)|0}function Uba(a){a=a|0;return+BN(a-88|0)}function UI(a){a=a|0;return hy(a-8|0)|0}function TK(a){x[a+4>>2]=x[a+4>>2]|8192}function TI(a){a=a|0;return gy(a-8|0)|0}function Sba(a){a=a|0;return+zN(a-88|0)}function SI(a){a=a|0;return fy(a-8|0)|0}function RI(a){a=a|0;return ey(a-8|0)|0}function Qba(a){a=a|0;return+xN(a-88|0)}function Os(a){return(a|0)==32|(a|0)==9}function OS(a,b){return(Rl(a,b)|0)!=255}function M3(a){a=a|0;if(a){pI(jl(a),1)}}function LD(a){return gH(a,65535,65535)}function GZ(a,b){a=a|0;b=b|0;Lr(a,b,32)}function Dj(a,b){return rB(a&255,b&255)}function CB(a,b,c){return a<b?b:a>c?c:a}function Bb(a){return(a<<8|a>>>8)&65535}function AP(a,b,c){return eH(a,b,c,68)}
function $y(a){return(q(a),j(2))>>>20|0}function $m(a,b,c){return yk(a,a+b|0,c)}function $$(a,b){x[a>>2]=x[a>>2]+(b<<1)}function xx(a,b){x[a+4>>2]=3;x[a>>2]=b}function wna(a){a=a|0;XW(a);return a|0}function vv(a,b,c){return Rp(a,b,c,12)}function vj(a,b){x[a+4>>2]=1;x[a>>2]=b}function uy(a){a=a|0;return x[a+12>>2]}function uga(a){a=a|0;return 302837129}function se(a,b,c){xl(a,b,Xc(b,c)+b|0)}function qha(a){a=a|0;return-285139079}function qaa(a){a=a|0;return y[a+40|0]}function pia(a){a=a|0;return 542066252}function mk(a,b){x[a+4>>2]=2;x[a>>2]=b}function lt(a){a=a|0;return 2147483647}function je(a){x[x[a+8>>2]>>2]=x[a>>2]}function iE(a){return a>>>0>=120?120:a}function hha(a){a=a|0;return-284078960}function fga(a,b){a=a|0;b=b|0;return 3}function dga(a,b){a=a|0;b=b|0;return 2}function dK(a){a=a|0;return x[a+60>>2]}function cy(a,b){x[a+4>>2]=4;x[a>>2]=b}function aha(a){a=a|0;return-281111764}function a_(a,b,c){Zl(a,b&65535,c&255)}function a2(a){a=a|0;return x[a+16>>2]}function _J(a){a=a|0;return x[a+64>>2]}function XM(a){return a?(a|0)==2?3:2:1}function X4(a,b){a=a|0;b=b|0;CH(a,b,0)}function Wd(a,b){return Kb(a)+(b<<2)|0}function W4(a,b){a=a|0;b=b|0;CH(a,b,1)}function Vu(a,b,c){lg(a,c);hd(b+c|0,0)}function Vga(a){a=a|0;return-271958638}function V4(a,b){a=a|0;b=b|0;BH(a,b,0)}function U4(a,b){a=a|0;b=b|0;BH(a,b,1)}function Tu(a,b){return vH(a,b,-1,0,0)}function R2(a,b){a=a|0;b=b|0;ws(a,1,b)}function Nga(a){a=a|0;return-620920304}function NK(a,b){return(eo(a,b)|0)!=-1}function IQ(a){a=a|0;return 1869112133}function HJ(a,b,c){return Rp(a,b,c,24)}function Ej(a){x[a>>2]=125152;return a}function Dw(a,b,c){return Rp(a,b,c,20)}function Dga(a){a=a|0;return-275227023}function Cha(a){a=a|0;return-270114148}function CX(a,b){a=a|0;b=b|0;sH(a,b,4)}function Bh(a){return bH(a,E(255),255)}function B$(a,b,c){return Rp(a,b,c,40)}function zka(a,b){a=a|0;b=b|0;lU(a,b)}function yn(a){return(a&740327453)!=0}function yka(a,b){a=a|0;b=b|0;PS(a,b)}function xh(a,b,c){return Tp(a,b,c,2)}function xR(a,b){Zc(a,b&4?16:8,1,0,0)}function tG(a,b,c){cc(a,b,ih(b,c)<<3)}function rY(a){hz(a);Ke(x[a+80>>2],a)}function qh(a){a=x[a>>2];if(a){vK(a)}}function nla(a,b){a=a|0;b=b|0;Vb(a,b)}function nO(a,b){return Ht(a,b,Df(b))}function mC(a,b,c){return Tp(a,b,c,5)}function ks(a){a=a|0;return x[a+4>>2]}function jv(a,b,c){return Tp(a,b,c,4)}function js(a){a=a|0;return x[a+8>>2]}function il(a){a=x[a>>2];if(a){kl(a)}}function hp(a,b){w[a+8>>1]=b;return a}function fs(a,b,c){return Tp(a,b,c,3)}function eZ(a,b,c){cc(a,b,oc(b,c)<<2)}function dj(a,b,c){return Tp(a,b,c,1)}function bZ(a,b,c){eD(a,(b<<2)+a|0,c)}function aP(a){return z[a+1074448>>1]}function aA(a,b){a=a|0;b=b|0;return 1}function ZO(a){return x[a+1074424>>2]}function Yta(a,b){a=a|0;b=b|0;Yy(a,b)}function Yj(a,b){return jm(a,b)&65535}function YO(a){return x[a+1074416>>2]}function WG(a,b){Js(a,b,12,357913942)}function Ve(a,b){x[a+4>>2]=b;return a}function U8(a){a=a|0;return QK(a,0)|0}function Ts(a){return(ay(a)|0)!=(a|0)}function Tl(a,b){return v[a|0]<v[b|0]}function Ti(a,b,c){bZ(b,c,a);return a}function Tha(a,b){a=a|0;b=b|0;vF(a,b)}function TW(a){return(a|0)>=120?120:a}function TL(a){x[a>>2]=94580;return a}function T8(a){a=a|0;return QK(a,1)|0}function Ss(a){return($x(a)|0)!=(a|0)}function SE(a,b){Js(a,b,20,214748365)}function Rz(a){a=a|0;_H(a,47448,1001)}function Qn(a){x[a>>2]=77184;return a}function QV(a,b,c){return Mx(a,b,c,5)}function OM(a){x[a>>2]=48716;return a}function MI(a){a=E(a-a);return E(a/a)}function M8(a){a=a|0;return OK(a,0)|0}function L8(a){a=a|0;return OK(a,1)|0}function Kj(a){return(a-1&255)>>>0<17}function KP(a){return Ui(MP(a)*32768)}function KM(a){x[a>>2]=74328;return a}function Ika(a,b){a=a|0;b=b|0;Fr(a,b)}function IV(a){return(a&65535)==65534}function Gz(a){x[a>>2]=48232;return a}function Gt(a,b){a=a|0;b=b|0;return-1}function Gn(a,b,c){return Mx(a,b,c,2)}function Fz(a){x[a>>2]=48256;return a}function Fi(a,b,c){Uc(Uc(a,b)+12|0,c)}function Ez(a){x[a>>2]=48336;return a}function EP(a,b){a=a|0;b=b|0;return 0}function Dz(a){x[a>>2]=48376;return a}function Br(a,b,c){return Rp(a,b,c,6)}function BT(a,b){return(0-b|0)!=(a|0)}function Ap(a,b,c){return Mx(a,b,c,1)}function z2(a,b){a=a|0;b=b|0;$n(a,b)}function xy(a){a=a|0;return v[a+8|0]}function wy(a){a=a|0;return v[a+9|0]}function wo(a){return z[a+480188>>1]}function vta(a){a=a|0;return e$(a)|0}function vF(a,b){a=a|0;b=b|0;x_(a,b)}function sP(a){a=a|0;_H(a,47392,999)}function sG(a,b){Nx(a,b,3,536870912)}function qm(a){x[a+4>>2]=x[a+4>>2]+1}function pq(a){return z[a+480192>>1]}function pZ(a,b){Js(a,b,6,715827883)}function ota(a){a=a|0;return Ec(a)|0}function oq(a){return z[a+480190>>1]}function kW(a,b){return D(b,872)+a|0}function jT(a){return(a+5&255)>>>0<2}function jR(a,b){Js(a,b,52,82595525)}function jC(a,b,c,d,e){xU(a,b,c,d,e)}function hv(a){return x[Ab(a)>>2]<<5}function hC(a,b){a=a|0;b=b|0;rV(a,b)}function cz(a){return!jd(a,125472,6)}function bR(a,b){return Fk(a,b-a>>2)}function _O(a){return z[a+480214>>1]}function _2(a,b){a=a|0;b=b|0;Hx(a,b)}function ZD(a,b,c){vb(vb(a,b)+4|0,c)}function Yx(a){return(a<<2)+501744|0}function X3(a,b){a=a|0;b=b|0;cx(a,b)}function Wja(a){a=a|0;return Mi(a)|0}function W9(a,b){a=a|0;b=b|0;mu(a,b)}function Uk(a,b){a=a|0;b=b|0;wm(a,b)}function Uf(a,b){a=a|0;b=b|0;jg(a,b)}function UX(a,b){return TX(a,b-a>>1)}function TV(a,b){Nx(a,b,4,268435456)}function Ssa(a){a=a|0;return ND(a)|0}function S2(a,b){a=a|0;b=b|0;xs(a,b)}function Rr(a,b){a=a|0;b=b|0;fx(a,b)}function RW(a){return(a&255)>>>0<129}function RV(a,b){Nx(a,b,5,134217728)}function PC(a,b){if(!$X(a,b)){RX(b)}}function NP(a){x[a>>2]=0;x[a+4>>2]=0}function L2(a,b){a=a|0;b=b|0;Np(a,b)}function Iga(a){a=a|0;x[a+4224>>2]=0}function IO(a){return x[a+480272>>2]}function HQ(a,b,c){a=a|0;b=b|0;c=c|0}function Fr(a,b){a=a|0;b=b|0;Uf(a,b)}function Fka(a){a=a|0;return Lh(a)|0}function Ch(a){nf(a+52|0);ec(a+40|0)}function Af(a){return F(a)==Infinity}function $n(a,b){a=a|0;b=b|0;Uk(a,b)}function $d(a,b){return D(b,160)+a|0}function yY(a,b,c){return Lv(a,b,c)}function yA(a,b){return D(b,28)+a|0}function wv(a){if(!y[a+4|0]){wW(a)}}function wf(a,b){return D(b,24)+a|0}function vb(a,b){x[a>>2]=b;return a}function v2(a){a=a|0;return Rg(a)|0}function sv(a,b){return D(b,36)+a|0}function sl(a,b,c){return rK(a,b,c)}function re(a,b){return Fc(a,ne(b))}function qq(a,b,c){return Mz(a,b,c)}function q0(a){a=a|0;return bx(a)|0}function pR(a,b,c){return uA(a,b,c)}function oY(a){if(!y[a+4|0]){kY(a)}}function nt(a,b,c){return jd(a,b,c)}function mc(a,b){return(a|0)==(b|0)}function mU(a){if(!y[a+4|0]){mW(a)}}function m9(a){a=a|0;return tl(a)|0}function jy(a){a=a|0;return a+184|0}function jm(a,b){return(b-a|0)/52|0}function iy(a){a=a|0;return a+472|0}function ir(a){return(a&255)==1?1:2}function hy(a){a=a|0;return a+496|0}function hj(a,b){return(b-a|0)/24|0}function hN(a){if(!y[a+4|0]){gN(a)}}function hM(a){if(!y[a+4|0]){LH(a)}}function gy(a){a=a|0;return a+508|0}function fy(a){a=a|0;return a+520|0}function f7(a){a=a|0;return ry(a)|0}function ey(a){a=a|0;return a+532|0}function eja(a){a=a|0;Lr(a,22292,1)}function eW(a){if(!y[a+4|0]){dW(a)}}function eL(a){a=a|0;return vl(a)|0}function ds(a,b){return(b-a|0)/36|0}function dm(a,b){return cm($c(a,b))}function ch(a,b){return D(b,20)+a|0}function bm(a){if(!y[a+4|0]){E$(a)}}function bh(a){if(!y[a+4|0]){SQ(a)}}function aj(a,b){return D(b,52)+a|0}function aca(a,b){a=a|0;b=b|0;gP(a)}function aD(a,b){return uf(a,0-b|0)}function _u(a){if(!y[a+4|0]){GG(a)}}function _l(a){return gH(a,255,255)}function _Y(a,b){return D(b,33)+a|0}function _U(a,b,c){return aC(a,b,c)}function _D(a,b){return uf(a,b-a|0)}function Zi(a){if(!y[a+4|0]){JZ(a)}}function Y_(a,b,c){return yk(a,b,c)}function YK(a){a=a|0;return ox(a)|0}function Xb(a,b){return Pe(a,b&255)}function Ww(a){v[a+2|0]=0;w[a>>1]=0}function WE(a){if(!y[a+4|0]){VE(a)}}function Vd(a,b){return D(b,12)+a|0}function Ud(a,b){return(b-a|0)/12|0}function UG(a,b,c){return nt(a,b,c)}function T1(a){a=a|0;jG(Rb(a,0,36))}function Sj(a){if(!y[a+4|0]){PF(a)}}function Sf(a,b){return(b-a|0)/20|0}function SF(a){a=a|0;return gh(a)|0}function S1(a){a=a|0;return _h(a)|0}function Pv(a,b){return(b-a|0)/33|0}function Pi(a,b,c){return bC(a,b,c)}function Lw(a,b){w[a>>1]=b;return a}function Lka(a){a=a|0;bI(a,115,114)}function Ju(a){return!(a&204473357)}function Hj(a,b){return Mg(a,b)&255}function Gr(a,b){return(b-a|0)/28|0}function Gq(a){if(y[a+24|0]){dT(a)}}function Gl(a){return D$(a,251,255)}function Gk(a,b){return a>>>0<b>>>0}function Fd(a,b){return(a|0)!=(b|0)}function FJ(a){if(!y[a+4|0]){pJ(a)}}function FC(a,b){return D(b,56)+a|0}function EF(a){a=a|0;return Zd(a)|0}function De(a,b,c){return JK(a,b,c)}function Bv(a,b){return(b-a|0)/56|0}function Ar(a,b){return(b-a|0)/40|0}function Aca(a,b){a=a|0;b=b|0;SO(a)}function zy(a,b){return!(b>>>31|0)}function zF(a){return(a&255)+704|0}function wu(a,b){return(a-b|0)/6|0}function vd(a){return(a&128)>>>7|0}function uo(a,b){x[a+1298472>>2]=b}function ud(a){a=a|0;return a+16|0}function rl(a){return(a&255)>>>0>1}function qp(a){v[a|0]=0;v[a+1|0]=0}function qG(a,b){return Xo(a,b,36)}function kT(a){Ce(a+8|0);cT(a+4|0)}function iq(a,b){v[a|0]=b;return a}function ei(a,b){a=a|0;b=b|0;Fb(a)}function _r(a,b){return(b<<11)+a|0}function _Z(a,b){return Kx(a,b,56)}function Z$(a,b){return Xo(a,b,28)}function Yq(a,b){return(a|0)<(b|0)}function Yc(a,b){return D(b,6)+a|0}function YY(a,b){return Kx(a,b,18)}function WJ(a){return Vh(a,499712)}function VJ(a){return Vh(a,499704)}function UM(a){return(tk(a)|0)==-1}function TM(a,b){a=a|0;b=b|0;Xm(b)}function TJ(a){return Vh(a,499728)}function SM(a,b){a=a|0;b=b|0;ec(b)}function SJ(a){return Vh(a,499720)}function Rk(a,b){return D(_k(b),a)}function Qy(a){return mc(a,-1)?0:a}function Mo(a,b){return(b<<13)+a|0}function M9(a,b){a=a|0;b=b|0;Db(b)}function JJ(a){C[(fb-16|0)+8>>3]=a}function Ik(a,b){return(b-a|0)/6|0}function Ii(a){a=a|0;v[a+4202|0]=0}function GB(a,b){return(b-a|0)/7|0}function Cx(a,b){return Xo(a,b,12)}function Bc(a,b){return xH(a,b,-1)}function Al(a,b){return(a+b|0)-1|0}function $i(a){return a&2147483647}function yb(a,b){return(b<<2)+a|0}function w3(a){a=a|0;return 13108}function vt(a,b){return JK(a,0,b)}function v3(a){a=a|0;return 10825}function tc(a){x[a>>2]=0;return a}function rO(a,b){x[a+480272>>2]=b}function mqa(a){a=a|0;gg(a,16854)}function kC(a,b){return Xo(a,b,4)}function jn(a,b){return(b<<8)+a|0}function jka(a){a=a|0;vg(a,Ij(a))}function hpa(a){a=a|0;HY(a,65535)}function gL(a){return $G(a,93320)}function eM(a){return a+1298412|0}function de(a){return x[gc(a)>>2]}function dc(a,b){return Kb(a)+b|0}function dC(a){if(a){Db(a+-64|0)}}function cF(a){return a>>>0>8?5:4}function bc(a,b){return(b<<1)+a|0}function ag(a){return a!=a?E(0):a}function a9(a){a=a|0;return 10422}function Yk(a){w[a>>1]=0;return a}function Yd(a,b){return(b<<4)+a|0}function YT(a,b){return Xo(a,b,8)}function Xh(a){x[a>>2]=1;return a}function Wra(a){a=a|0;gg(a,16251)}function WK(a){x[a+72>>2]=496676}
function W$(a){Cs(a,17,124780,33)}function UA(a){ec(a+4|0);return a}function Tx(a,b){return x[a+b>>2]}function Tc(a){return D$(a,1,120)}function TF(a){return(a&16)>>>4|0}function Se(a,b){return(b<<3)+a|0}function R3(a){a=a|0;return 13222}function Q3(a){a=a|0;return 10302}function Pt(a){return $G(a,93256)}function Pq(a){Cs(a,17,124832,51)}function Pe(a,b){return(b<<5)+a|0}function Nh(a){return a-48>>>0<10}function Ib(a,b){return mc(a,b)^1}function Do(a){return a+1074328|0}function Bn(a){x[a>>2]=2;return a}function Az(a,b){return ER(a,b)^1}function yba(a){a=a|0;cu(a-96|0)}function x3(a){a=a|0;return 9861}function wF(a,b,c,d){px(a,b,c,d)}function vQ(a){return(a&8)>>>3|0}function uv(a){v[a|0]=0;return a}function ug(a,b,c,d){bf(a,c,d,b)}function u3(a){a=a|0;return 5720}function sta(a){a=a|0;gg(a,3872)}function ow(a,b,c){nH(a,b,c,128)}function nqa(a){a=a|0;gg(a,3985)}function lf(a,b,c){xl(a,b,b+c|0)}function lF(a){Rm(a,Mp(a),78544)}function aO(a){a=a|0;eu(a);Db(a)}function Yba(a){a=a|0;cu(a-88|0)}function W3(a){a=a|0;return 6920}function UK(a){x[a+72>>2]=496760}function UF(a){return(a&2)>>>1|0}function Tw(a,b){return Lua(a,b)}function Sra(a){a=a|0;gg(a,4484)}function Soa(a){a=a|0;gg(a,4165)}function Ora(a){a=a|0;gg(a,4378)}function Ne(a,b){v[a+11|0]=b&127}function NN(a){a=a|0;Qm(a);Db(a)}function N3(a){a=a|0;return 6901}function Lg(a,b){vb(tc(a)+4|0,b)}function KV(a,b,c,d){JV(a,b,c,d)}function KN(a){a=a|0;nq(a);Db(a)}function IY(a,b){zc(a,b+4|0,256)}function Gqa(a){a=a|0;qw(a,3863)}function Gba(a){a=a|0;cu(a-92|0)}function Eqa(a){a=a|0;qw(a,4887)}function Dua(a){a=a|0;gg(a,4358)}function D2(a){a=a|0;gg(a,16881)}function B2(a){a=a|0;bI(a,50,49)}function Aw(a,b,c,d){DB(a,b,c,d)}function zd(a){return wb(Kb(a))}function yh(a,b){return _c(a,b)}function yf(a,b){return Fc(a,b)}function xi(a,b){return Fd(a,b)}function xg(a){tb(a+20|0);tb(a)}function xE(a,b,c){bf(a,c,30,b)}function wt(a,b){return Ud(a,b)}function ub(a){me(a+12|0);me(a)}function sE(a,b){return Gk(a,b)}function rha(a){a=a|0;Db(hQ(a))}function rR(a,b){return vu(a,b)}function rE(a,b){return kp(b,a)}function qia(a){a=a|0;Db(DQ(a))}function qi(a,b,c){bf(a,c,20,b)}function mt(a){a=a|0;return 127}function mj(a,b){return a>>>b&1}function lq(a,b){return yb(a,b)}function lA(a,b){return bR(a,b)}function kl(a){if(wI(a)){Db(a)}}function k_(a,b,c){bf(a,c,24,b)}function ht(a){return Ab(a+8|0)}function hk(a,b){return b-a>>11}function hc(a,b){return wG(a,b)}function ek(a,b,c){bf(a,c,13,b)}function dT(a){bT(a+12|0);aT(a)}function d$(a,b){return Ak(b,a)}function caa(a){a=a|0;Db(lM(a))}function bM(a,b){return ih(a,b)}function an(a){tb(a+12|0);tb(a)}function _o(a,b){return Zk(a,b)}function _c(a,b){return Cb(a,b)}function Zg(a,b){return Ib(a,b)}function Yh(a,b){return Ow(a,b)}function Ye(a){return ur(Ge(a))}function Xi(a,b,c){bf(a,c,28,b)}function X_(a,b){return _D(a,b)}function Wg(a){return jT(a&255)}function Wb(a,b){return aj(a,b)}function Waa(a){a=a|0;Db(_t(a))}function VG(a,b){return Uc(a,b)}function Ui(a){return wn(Ge(a))}function Te(a,b,c){bf(a,c,32,b)}function TT(a,b){return $c(a,b)}function Sk(a,b,c){bf(a,c,22,b)}function Sd(a,b){return oc(a,b)}function Rw(a,b){return DF(a,b)}function Ru(a){gU(a+12|0);kU(a)}function QR(a,b){return OR(a,b)}function Pj(a,b){return Xc(a,b)}function Oi(a,b){return(a|b)!=0}function OE(a){return(a&255)==1}function Nt(a,b,c){Zb(a,b,1<<c)}function Nj(a,b){return Pe(a,b)}function Mk(a,b,c){bf(a,c,12,b)}function Me(a){a=a|0;return a|0}function MA(a){w[a+480214>>1]=0}function KC(a,b,c){bf(a,c,64,b)}function Jy(a,b){return oh(a,b)}function Jg(a){return Qi(a)?0:a}function Ie(a,b){return i0(a,b)}function Id(a){return(a&255)!=0}function Hl(a){HA(a,0);return a}function Hc(a,b){return _r(a,b)}function Gb(a,b){return(a&b)!=0}function GF(a,b){return CF(a,b)}function Fc(a,b){return vb(a,b)}function Ega(a){a=a|0;Db(XP(a))}function E2(a){a=a|0;gg(a,4532)}function Bo(a,b){return Xt(a,b)}function Bk(a){tb(a+12|0);od(a)}function Bga(a){a=a|0;return 13}function Bf(a,b){return eh(a,b)}function Ad(a,b){return!Cb(a,b)}function wV(a){return a+4896|0}function wC(a){return a+4096|0}function uM(a){a=a|0;Db(vM(a))}function u4(a){a=a|0;Db(OI(a))}function rB(a,b){return a<<8|b}function pha(a){a=a|0;return 6}function pQ(a){a=a|0;Db(qQ(a))}function pE(a){return fl(a,28)}function ou(a){return a>>>27^a}function oia(a){a=a|0;return 9}function oc(a,b){return b-a>>2}function nX(a,b){Lx(a,b,5,3,4)}function mO(a){a=a|0;Db(nq(a))}function lJ(a){a=a|0;Db(ly(a))}function l4(a){a=a|0;Db(LI(a))}function ku(a){a=a|0;Db(_f(a))}function kp(a,b){return a-b>>1}function kZ(a,b){xl(a,b,ud(b))}function kJ(a){a=a|0;Db(ky(a))}function kG(a){return fl(a,36)}function k4(a){a=a|0;Db(KI(a))}function jo(a){return(a|0)==-1}function j4(a){a=a|0;Db(JI(a))}function ih(a,b){return b-a>>3}function iX(a){return fl(a,56)}function i4(a){a=a|0;Db(II(a))}function h9(a){a=a|0;Db(Bt(a))}function gt(a){a=a|0;Db(my(a))}function fc(a,b){x[a+100>>2]=b}function fR(a){return fl(a,52)}function f4(a){a=a|0;Db(HI(a))}function e2(a){a=a|0;Db(vG(a))}function cu(a){a=a|0;Db(mq(a))}function cA(a){a=a|0;Db(tu(a))}function c4(a){a=a|0;Db(FI(a))}function aL(a){a=a|0;Db(fq(a))}function _n(a){a=a|0;Db(P_(a))}function _d(a){return a&64?2:1}function Xy(a){a=a|0;Db(vl(a))}function Wy(a){a=a|0;Db(go(a))}function WT(a,b){Vu(a,Kb(a),b)}function Vy(a){a=a|0;Db(Ft(a))}function Ty(a){a=a|0;Db(Et(a))}function Sy(a){a=a|0;Db(Ct(a))}function Sh(a,b){return b-a>>8}function RU(a){return fl(a,32)}function QI(a){a=a|0;Db(ct(a))}function Q5(a){a=a|0;Db(et(a))}function Pn(a){a=a|0;Db(ox(a))}function P4(a){a=a|0;Db(ZI(a))}function Op(a){return fl(a,12)}function Ok(a){return a>>>0<11}function N_(a){return fl(a,20)}function NJ(a){a=a|0;Db(ry(a))}function NI(a){a=a|0;Db($s(a))}function Mv(a,b){return a-b>>2}function Mg(a,b){return b-a>>5}function Ke(a,b){if(!a){Db(b)}}function KQ(a){return a-2048|0}function JO(a,b){cH(a,b,22292)}function I5(a){a=a|0;Db(cJ(a))}function HN(a,b){cH(a,b,13618)}function Ek(a,b){return b-a>>4}function Cz(a){return fl(a,16)}function AG(a){return a+1024|0}function $c(a,b){return b-a>>1}function $K(a){a=a|0;Db(Gf(a))}function yo(a){a=a|0;return 4}function xb(a,b){return a+b|0}function w0(a,b){cc(a,b,1954)}function vk(a){return a+4e4|0}function vV(a){return a+512|0}function tr(a){return a+256|0}function tp(a){return a>>>0<5}function tQ(a){a=a|0;return 3}function t0(a,b){bf(a,b,13,1)}function qL(a){a=a|0;return-1}function pk(a){return(a&5)!=0}function pX(a,b){bf(a,b,33,1)}function pD(a,b){cc(a,b,4896)}function op(a,b){zb(a+12|0,b)}function oQ(a){a=a|0;return 7}function nM(a){return pk(a)^1}function jc(a){a=a|0;return 0}function gZ(a){jp(Rb(a,0,40))}function fr(a){return a>>>0<2}function dQ(a){a=a|0;return 5}function bu(a,b){x[a+32>>2]=b}function ay(a){return tI(a,0)}function YV(a){return a-256|0}function Xc(a,b){return b-a|0}function Wr(a,b){bf(a,b,26,3)}function SC(a,b){cc(a,b,1024)}function QC(a){return a+128|0}function No(a,b){x[a+36>>2]=b}function Mj(a){return!(a&255)}function Le(a){a=a|0;return 2}function Kn(a){return a&1?2:1}function I_(a,b){bf(a,b,40,2)}function Gj(a){return Ed(a)^1}function GA(a,b){v[a+34|0]=b}
function Fe(a){a=a|0;return 1}function Fb(a){wx(a);return a}function Ed(a){return(a|0)!=0}function DX(a,b){cc(a,b,1108)}function DR(a,b,c){Ql(a,b,-c)}function DP(){return 20054022}function Ak(a,b){return a-b|0}function $x(a){return tI(a,1)}function $e(a,b){w[a+28>>1]=b}function zq(a,b){B[a+4>>2]=b}function z_(a,b){cc(a,b,157)}function zE(a,b){cc(a,b,512)}function zD(a,b,c){ee(a,b,c)}function yq(a,b){v[a+33|0]=b}function yF(a,b){cc(a,b,772)}function xn(a,b){x[a+8>>2]=b}function vA(a,b){HA(a,ne(b))}function uF(a,b){bf(a,b,8,3)}function t_(a,b){cc(a,b,206)}function sw(a,b){cc(a,b,192)}function rx(a,b){HG(a,ne(b))}function rd(a,b){return a>>b}function rc(a,b,c){rn(a,b,c)}function pF(a,b){cc(a,b,497)}function nc(a){return a+12|0}function nC(a){return a-16|0}function m_(a,b){cc(a,b,236)}function mX(a){return a-56|0}function lp(a,b){Ie(a,b+8|0)}function jl(a){return a-24|0}function i_(a){return a+10|0}function iW(a,b){zc(a,b,128)}function hZ(a,b){cc(a,b,128)}function gw(a){return a-40|0}function gr(a,b){return a<<b}function gn(a){return a-32|0}function fU(a){eU(a,x[a>>2])}function ej(a){return a-36|0}function d_(a,b){cc(a,b,102)}function dX(a,b){cc(a,b,146)}function cp(a){return a+14|0}function cl(a){return a-12|0}function cc(a,b,c){Zb(a,b,c)}function YX(a,b){cc(a,b,600)}function XT(a,b,c){ye(a,b,c)}function WC(a,b){cc(a,b,130)}function VU(a){UU(a,x[a>>2])}function VR(a){return a+24|0}function Uh(a,b,c){j$(a,b,c)}function UZ(a,b){cc(a,b,576)}function UY(a){return a-33|0}function S$(a,b){cc(a,b,610)}function Ro(a){return a+32|0}function Re(a,b){a=a|0;b=b|0}function RZ(a,b){cc(a,b,674)}function RS(a,b,c){mr(a,b,c)}function RD(a,b){bf(a,b,8,2)}function Qc(a,b,c){Nt(a,b,c)}function PG(a,b,c){gf(a,c,b)}function O0(a,b,c){df(a,c,b)}function Nc(a){Bd(a,x[a>>2])}function Mp(a){return a+20|0}function MX(a,b){cc(a,b,126)}function KZ(a){return a+36|0}function KY(a){return a+3&-4}function Jb(a,b,c){WF(a,b,c)}function IB(a){v[a+6152|0]=0}function FP(a){return a+48|0}function FA(a,b){v[a+32|0]=b}function Eu(a){nS(a,x[a>>2])}function Er(a){return a-28|0}function EW(a,b){cc(a,b,204)}function EA(a,b){v[a+35|0]=b}function C_(a,b){cc(a,b,218)}function Bd(a,b){x[a+4>>2]=b}function BV(a,b){cc(a,b,263)}function Aq(a,b){B[a+8>>2]=b}function $q(a,b,c){xp(a,b,c)}function $W(a,b){cc(a,b,608)}function zf(a){return a&255}function yr(a,b){cc(a,b,12)}function xf(a){return a-4|0}function wg(a,b){v[a+3|0]=b}function wE(a,b){rH(a,b,32)}function vp(a,b){v[a+1|0]=b}function v0(a){Rb(a,0,1954)}function uu(a){Rb(a,0,2048)}function uda(a){a=a|0;zP(a)}function uE(a){x[a+12>>2]=0}function rw(a,b){rH(a,b,64)}function rX(a,b){cc(a,b,96)}function pf(){W$(11050);p()}function nZ(a){return a-6|0}function nD(a,b){cc(a,b,33)}function mw(a,b){cc(a,b,64)}function lw(a,b){cc(a,b,66)}function jx(a,b){cc(a,b,20)}function j_(a){return a+6|0}function iZ(a,b){cc(a,b,80)}function iF(a,b){cc(a,b,38)}function gc(a){return a+4|0}function gF(a,b){yi(a,b,37)}function gD(a,b){cc(a,b,40)}function fE(a,b){cc(a,b,16)}function en(){Pq(11050);p()}function cw(a,b){cc(a,b,22)}function _i(a){return a+3|0}function _e(a){return a+2|0}function VA(a){Rb(a,0,4096)}function Uw(a,b){Zb(a,b,22)}function Rv(a,b){return a<b}function QE(a,b){cc(a,b,32)}function NY(a,b){cc(a,b,52)}function Mw(a,b){cc(a,b,11)}function MT(a){return a-7|0}function M0(a,b){Zb(a,b,20)}function K_(a,b){cc(a,b,98)}function Jc(a){return a+1|0}function JG(a,b){cc(a,b,24)}function J0(a,b){cc(a,b,17)}function IN(a){return 0-a|0}function Hp(a){return a-8|0}function Hn(a){return a-2|0}function Hh(a){return a&127}function Gv(a,b){cc(a,b,30)}function GV(a,b){return a<b}function Fn(a,b){Zb(a,b,32)}function F_(a,b){cc(a,b,48)}function Cw(a,b){cc(a,b,65)}function Cq(a){Rb(a,0,8192)}function CP(){return 524288}function BW(a){return a-1|0}function BU(a,b){cc(a,b,27)}function Ab(a){return a+8|0}function A$(a,b){zc(a,b,40)}function $r(a,b){cc(a,b,36)}function yg(a){v[a+12|0]=1}function yd(a,b){x[a>>2]=b}function yc(a){x[a+8>>2]=0}function y_(a){Rb(a,0,157)}function xF(a){Rb(a,0,772)}function vc(a){a=a|0;Db(a)}function uk(a,b){B[a>>2]=b}function tF(a,b){Uh(a,2,b)}function sia(a){a=a|0;gb=a}function s_(a){Rb(a,0,206)}function qs(a){a=a|0;ss(a)}function oF(a){Rb(a,0,497)}function nn(a,b){xp(a,b,0)}function nQ(a,b){YQ(a,3,b)}function mh(a,b){cc(a,b,4)}function l_(a){Rb(a,0,236)}function iha(){return fb|0}function iD(a){hD(a,de(a))}function gU(a){Lq(a,de(a))}function ex(a,b){cc(a,b,3)}function ed(){W$(7718);p()}function cX(a){Rb(a,0,146)}function cW(a){sC(a,de(a))}function bt(a){kl(x[a>>2])}function b_(a){ID(a,de(a))}function bW(a){tC(a,de(a))}function bT(a){Lu(a,de(a))}function b1(a){a=a|0;_h(a)}function aT(a){Mu(a,de(a))}function _fa(a){a=a|0;fb=a}function _b(a){vm(x[a>>2])}function _W(a){Rb(a,0,608)}function Yv(a){HD(a,de(a))}function XX(a){Rb(a,0,600)}function XD(a,b){cc(a,b,6)}function WV(a){Rb(a,0,256)}function Tr(a,b){cc(a,b,1)}function TZ(a){Rb(a,0,576)}function R$(a){Rb(a,0,610)}function Qi(a){return a!=a}function Ol(a){FB(a,de(a))}function OZ(a){Rb(a,0,192)}function MC(a){Rb(a,0,130)}function LX(a){Rb(a,0,126)}function Iw(){Pq(7718);p()}function Ir(a,b){cc(a,b,7)}function HR(a){CA(a,de(a))}function DW(a){Rb(a,0,204)}function CZ(a){uD(a,de(a))}function Bp(a,b){cc(a,b,2)}function AZ(a){vD(a,de(a))}function $k(a,b){cc(a,b,8)}function $j(a,b){cc(a,b,5)}function sX(a){Rb(a,0,96)}function rD(a){Rb(a,0,80)}function qO(){return 2048}function oE(a){Rb(a,0,66)}function hd(a,b){v[a|0]=b}function hF(a){Rb(a,0,38)}function fw(a){Rb(a,0,64)}function as(a){Rb(a,0,36)}function ZZ(a){Rb(a,0,56)}function SY(a){Rb(a,0,33)}function Qd(a){v[a+4|0]=1}function MY(a){Rb(a,0,52)}function LQ(a){Am(a,2048)}function Jh(a){tb(a+16|0)}function J_(a){Rb(a,0,98)}function G_(a){Rb(a,0,48)}function Dp(a){return a&1}function xX(a,b){Ie(a,b)}function vs(a,b){VG(a,b)}function uq(a,b){vb(a,b)}function sW(a,b){Ul(a,b)}function qE(a,b){Pk(a,b)}function po(a,b){iq(a,b)}function nm(a,b){Lw(a,b)}function mD(a,b){QY(a,b)}function lR(a,b){nS(a,b)}function ig(a,b){d0(a,b)}function eA(a,b){re(a,b)}function dU(a){Ce(a+8|0)}function cd(a,b){zs(a,b)}function Wu(a,b){YR(a,b)}function WD(a,b){hc(a,b)}function TU(a,b){UU(a,b)}function Sg(a){a=a|0;p()}function ST(a,b){$$(a,b)}function Rh(a,b){Qo(a,b)}function Rd(a,b){Og(a,b)}function Qo(a,b){Uc(a,b)}function Qj(a){tb(a+4|0)}function QU(a,b){ng(a,b)}function Nn(a,b){fG(a,b)}function Kc(a){ec(a+8|0)}function Jd(a,b){Bd(a,b)}function Hd(a){ub(a+8|0)}function Gi(a,b){ii(a,b)}function FU(a,b){Ih(a,b)}function $_(a,b){CU(a,b)}function zI(a){Ix(a,48)}function wp(a){yH(a,11)}function w$(a){Am(a,40)}function fp(a){yH(a,16)}function dh(a){v[a|0]=0}function Un(a){Ix(a,36)}function IJ(a){Am(a,24)}function Bg(a){Ix(a,24)}function $ja(){ua();p()}function wh(a){aN(a,0)}function vh(a){ZM(a,0)}function qZ(a){Am(a,6)}function oI(){va();p()}function ms(a){HG(a,0)}function mg(a){BZ(a,0)}function gs(a){Am(a,8)}function cj(a){Am(a,2)}function XA(a){qS(a,0)}function WA(a){pS(a,0)}function TR(a){uS(a,0)}function OT(a){Am(a,7)}function Lc(a){Qe(a,0)}function K3(){oI();p()}function Bl(a){_M(a,0)}function uW(a){Nb(a)}function ts(a){nc(a)}function tX(a){uv(a)}function pV(a){we(a)}function oW(a){We(a)}function _w(a){Yk(a)}function _T(a){So(a)}function Xm(a){wc(a)}function Lf(a){a=a|0}function LC(a){tg(a)}function Eb(a){tb(a)}function CV(a){tc(a)}
// EMSCRIPTEN_END_FUNCS
e=y;var ib=c([null,uc,IG,wm,p2,yG,f2,X1,U1,rG,mG,pe,z1,x1,vF,s1,p_,P_,Zna,Rna,Pna,Gua,Cua,tw,Xj,nua,Z,Vsa,Fw,km,hL,Lh,mp,dta,Me,boa,Dc,H5,KD,Kk,lr,vn,lsa,q_,Yl,rV,hC,Sma,nma,lU,dla,qla,qg,pka,Oj,gka,$ja,_ja,Yja,xA,Fja,vja,lga,Tia,QQ,E9,D9,It,QQ,wfa,kP,jg,Rea,kea,eea,_da,Tda,Oda,Ida,Dda,rda,Ica,gda,Uy,ua,Mb,l5,N4,I4,z4,s4,$n,$3,zka,X3,yka,S3,da,p3,b3,a3,$2,_2,Z2,oH,Y2,X2,W2,V2,U2,S2,R2,T2,Z8,xs,Qp,qg,Q2,SG,RG,P2,zx,O2,QG,Uf,N2,L2,J2,qs,ps,$h,gg,G2,Np,I2,H2,F2,M2,E2,NG,D2,NG,K2,OG,C2,B2,A2,z2,y2,dd,Mb,v2,Lp,u2,Lh,t2,sd,s2,bl,sd,qx,r2,ox,nx,T1,q2,h2,g2,S1,P1,M1,L1,bx,jG,K1,J1,Uja,Vja,JT,Sja,Tja,DA,xu,Vb,Wja,he,gG,G1,F1,SF,D1,C1,SF,EF,Qw,w1,Pg,EF,Nw,fja,pja,eja,jf,Gka,E1,sg,tua,Fka,Fta,$E,_E,l1,k1,ZE,j1,dg,i1,h1,Cc,Ew,g1,f1,e1,Tf,d1,lm,c1,XE,b1,_0,LE,Z0,Y0,X0,yw,W0,nF,KE,V0,U0,T0,S0,R0,HE,P0,F0,Dd,FE,Dua,Bua,EE,DE,Aua,zua,yua,Ew,xua,E0,wua,zw,vua,uua,Wk,oua,Hr,mua,Lb,bg,gg,lua,yE,kua,ld,Qk,jua,iua,hua,q0,p0,nd,gua,np,fua,eua,dua,m0,l0,Kk,qw,cua,bua,yla,aua,fh,$ta,_ta,Uta,Vj,Xta,Wta,Vta,Zta,Yta,Uf,c0,Zh,Rf,Rta,Qta,Pta,Mta,Vj,Uj,Lta,Kta,Jta,lE,L$,kE,Ita,Hta,Gta,Wk,s$,p$,Cta,xta,g$,so,wta,vg,Q$,vta,yw,uta,tta,cE,sta,f$,nx,rta,c$,b$,r_,qta,Wk,mta,Hr,ak,lta,kta,p0,jta,ita,hta,U_,T_,mm,gta,fta,eta,bta,Vj,S_,cta,Zh,Rf,jE,Ysa,Dr,f$,Rsa,Qsa,Psa,Osa,Lsa,Hr,Ksa,Jsa,ip,U_,Isa,Hsa,gg,Gsa,Fsa,Esa,Dsa,Csa,h_,Bsa,Asa,rK,g_,zsa,ysa,D0,f_,xsa,wsa,vsa,Ela,usa,e_,tsa,e_,Ssa,rsa,Vj,ssa,Zh,Rf,bk,msa,ksa,jsa,isa,fsa,esa,dsa,csa,bsa,ip,asa,$ra,_ra,CD,y1,Zra,Yra,Xra,Wra,Vra,NZ,Ura,v1,Tra,Sra,Rra,Qra,MZ,Pra,nsa,Ora,Nra,gg,Mra,nE,Lra,osa,Kra,Jra,Ira,yD,yD,LZ,Hra,Gra,IZ,yD,FZ,Fra,S8,Era,Dra,Cra,Bra,Ara,zra,yra,EZ,sd,jr,nra,Wv,xra,Sia,Ria,Qia,Pia,Oia,Nia,wra,vra,ng,ura,tra,sra,rra,IG,xla,vla,cja,nja,oja,qra,DZ,pra,ora,eka,Lia,Uk,QG,tla,Ala,sla,rla,Uv,jra,ira,hra,gra,fra,era,dra,cra,bra,ara,$qa,Zqa,Yqa,_qa,RY,Rf,JY,lD,Vqa,kD,Uqa,Tqa,Sqa,Rqa,jD,Qqa,Qw,ZE,Pqa,HY,GY,Oqa,Or,Nqa,qf,Mqa,DY,ip,ww,ip,f_,Rr,gg,$E,ip,so,Jqa,Iqa,Hqa,Gqa,dD,Jv,Fqa,Eqa,Dqa,Cqa,Bqa,Aqa,zqa,yqa,xqa,wqa,vqa,uqa,tqa,sqa,rqa,wD,qqa,pqa,oqa,gg,HZ,GZ,ED,nqa,mqa,EE,nx,lqa,kqa,jqa,iqa,hqa,bla,ala,$ka,dqa,eqa,Fr,fqa,gqa,kw,dY,aqa,Eka,gla,Yu,Dka,Cka,DT,Su,xT,Bka,nT,JU,Aka,RB,Fj,wi,Vpa,Upa,xr,bqa,Tv,Rpa,z0,Qpa,Ppa,JX,jr,Opa,Npa,Gw,Mpa,DZ,Lpa,Kpa,wr,Jpa,Ipa,Hpa,Gpa,JC,Bpa,HC,Apa,zpa,CX,yp,ypa,Vj,Zh,Rf,wi,vpa,upa,tpa,spa,kD,ppa,opa,wr,npa,lm,qja,kpa,jpa,Uj,zX,HC,zw,ipa,CX,hpa,gpa,fpa,Dv,epa,Dv,dpa,xm,A1,apa,Vj,cpa,CC,hX,bpa,Zh,Rf,xr,Zoa,Woa,lD,Voa,Soa,Roa,XW,Gw,CD,Qoa,EE,gg,Hoa,Goa,Ew,Foa,Eoa,Doa,Coa,_v,Boa,np,yoa,xoa,woa,voa,uoa,toa,kn,pW,soa,roa,qoa,poa,ooa,noa,moa,loa,koa,joa,ioa,hoa,goa,kD,foa,eoa,doa,Tv,coa,aoa,$na,Hr,Ska,Lp,q0,Zka,Yka,Hr,Xka,wi,Lp,Wka,Vka,Uka,_na,_V,Wna,Vna,Una,Tna,Sna,Vr,Nna,Mna,Lna,Kna,Jna,Ina,Hna,Gna,Fna,Ena,Dna,t3,YI,Cna,gg,Bna,Ana,cla,Fla,ota,WU,Cla,Bla,zla,wla,ula,KU,mla,ola,nla,lla,Zd,kla,zU,jla,ila,hla,oU,nU,Lo,iU,fla,ela,_ka,gp,Qka,Uj,KT,ns,Rja,Qja,Pja,Hka,Oja,B1,Nja,dx,ns,F0,Mja,KT,Oka,Lja,Tka,Vj,Zh,Rf,Rka,Vj,Zh,Rf,Pka,Vj,Zh,Rf,Mka,Jka,Ika,Me,P0,xka,wka,vka,uka,tka,ska,Dla,wna,JP,rka,Ec,oka,ija,nka,x2,R1,I1,O1,lka,kka,H1,Q1,w2,N1,gS,jka,ika,hka,fS,eS,SA,fka,pla,dka,cka,bka,aka,eR,aja,rja,yx,PS,yG,MG,DA,fS,Xja,Uk,ws,Nr,Lka,Nka,Hja,Gja,Uj,Eja,HC,Dja,Cja,Bja,xr,Aja,wi,zja,yja,xja,wja,uja,Vj,Zh,Rf,Ija,mja,lja,kja,jja,ii,Pm,hja,gja,dja,_ia,Zia,Yia,Xia,Wia,aR,bja,wq,_Q,pl,ii,ng,Uia,Mia,s9,Via,$ia,Jia,Iia,_ha,Hia,Gia,NQ,Zf,ZQ,ria,$ha,qn,Vha,Kja,Uha,Sha,Rha,Qha,DA,Tha,te,mu,mu,Pha,Oha,Mha,AQ,rQ,sha,jha,bha,Wga,Oga,Fga,Hga,vga,oga,GP,ju,hga,gga,yaa,zaa,BP,$fa,zP,yP,Zja,Baa,Wfa,GP,Vfa,hba,Xaa,kba,tP,iM,sP,Rz,Sfa,Mda,nq,Lda,Nm,qP,eba,oP,dba,pP,cba,nP,rK,wba,Nfa,fba,Qz,DY,Pz,Oz,Nz,Dfa,Bfa,sP,Rz,yfa,xfa,vfa,ufa,tfa,sfa,rfa,qfa,pfa,ofa,nfa,mfa,lfa,kfa,jfa,ifa,hfa,gfa,ffa,efa,dfa,cfa,bfa,afa,$ea,jP,iP,hP,xG,R9,lba,gP,VO,aba,UO,TO,vba,U9,V9,SO,_9,PO,OO,nz,MO,Rz,KO,HO,GO,vo,T9,S9,FO,EO,DO,CO,BO,AO,zO,yO,xO,wO,vO,uO,Lz,tO,sO,bS,Fv,Kz,Jz,Rda,pO,Qda,Pda,Nda,jO,Gda,tP,Fda,_ca,Eda,Zca,Cda,Yca,Bda,Xca,Ada,Wca,zda,Vca,xda,jaa,iM,br,Kka,Hx,os,nU,rba,qba,pba,nba,jba,qka,gba,_aa,bba,A9,r9,q9,$aa,TM,SM,TM,SM,lm,Wk,Wk,QM,PM,QM,PM,$t,Re,$t,Re,Yaa,$t,Re,$t,Re,mka,iba,sba,mba,ux,HM,Raa,HM,Qaa,_,GM,Paa,GM,Oaa,sz,sz,sz,Laa,Wt,Wt,Wt,Wt,BM,Iaa,BM,Haa,AM,Gaa,AM,Faa,qz,qz,qz,Caa,Vt,Vt,Vt,Vt,Aaa,cN,bN,Jz,xM,xaa,waa,naa,oM,iaa,haa,daa,Z9,Y9,X9,W9,Q9,P9,O9,XR,xna,N9,M9,L9,K9,G9,F9,ZK,YK,_3,y9,x9,w9,v9,u9,t9,Me,O3,S4,_8,YK,Py,Ly,gi,fi,xt,Db,Uv,th,ul,Ky,Gm,B8,A8,oj,sh,AK,nj,Z3,Ry,Fy,gi,fi,st,hi,m9,km,io,oj,sh,tK,nj,g8,Y3,b8,cL,Y7,At,mp,T7,ot,Lf,B7,fo,A7,z7,y7,XJ,w7,Ht,u7,t7,rj,s7,XJ,q7,tZ,o7,n7,k7,j7,_6,Z6,Y6,X6,W6,V6,U6,T6,S6,R6,Q6,P6,O6,N6,M6,L6,K6,J6,I6,H6,G6,F6,E6,D6,C6,B6,A6,z6,y6,x6,w6,v6,u6,GJ,t6,G5,F5,E5,D5,C5,bJ,B5,aJ,A5,z5,y5,x5,w5,v5,u5,t5,s5,r5,q5,p5,o5,n5,m5,k5,j5,i5,h5,g5,f5,e5,d5,c5,b5,a5,$4,_4,Z4,Y4,T4,g4,h4,X4,W4,V4,U4,Dm,$p,w4,v4,R4,Q4,y4,x4,qk,n4,m4,dq,Ay,Yl,oI,Pn,ks,vna,una,tna,sna,rna,qna,pna,ona,nna,mna,lna,kna,jna,ina,hna,gna,fna,ena,dna,cna,bna,ana,$ma,_ma,Zma,Yma,Xma,Wma,Vma,Uma,Tma,Rma,Qma,Pma,Oma,Nma,Mma,Lma,Kma,Jma,Ima,Hma,Gma,Fma,Ema,Dma,Cma,Bma,Ama,zma,yma,xma,wma,vma,uma,tma,sma,rma,qma,pma,oma,mma,lma,kma,jma,ima,hma,gma,fma,ema,dma,cma,bma,ama,$la,_la,Zla,Yla,Xla,Wla,Vla,Ula,Tla,Sla,Rla,Qla,Pla,Ola,Nla,Mla,Lla,Kla,Jla,Ila,Hla,Gla,Pn,Qna,Ona,hsa,gsa,Uoa,Toa,Noa,Moa,Xqa,Wqa,Fpa,Epa,lra,kra,qua,pua,ata,$sa,a1,$0,Fua,Eua,xpa,wpa,Yoa,Xoa,Yna,Xna,Ota,Nta,Eta,Dta,p1,o1,n1,m1,mpa,lpa,$oa,_oa,Tpa,Spa,mra,cZ,Xsa,Wsa,qsa,psa,Tta,Sta,pta,nta,rpa,qpa,Jja,tja,sja,Nsa,Msa,Usa,Tsa,Xpa,Wpa,Aoa,zoa,Dpa,Cpa,_sa,Zsa,Poa,Ooa,Joa,Ioa,zta,yta,Loa,Koa,cqa,Zpa,Ypa,r1,q1,u1,t1,sua,rua,Lqa,Kqa,Bta,Ata,$pa,_pa,zna,yna,_n,ks,V1,vc,sm,EP,vc,Me,vc,jc,Fe,Fe,jc,jc,W1,k2,j2,Y1,vc,sm,vc,vG,e2,d2,Fe,c2,b2,a2,$1,_1,Z1,tu,cA,su,IQ,jc,Lf,jc,jc,jc,Re,yo,Fia,Eia,Dia,Cia,Bia,Ji,aA,aA,$z,HQ,$z,GQ,$z,GQ,Lf,cZ,Aia,zia,yia,xia,wia,Ii,FQ,Xha,jc,jc,Fe,_z,Le,Le,Fe,via,uia,Re,Lf,Re,Lf,DQ,qia,pia,jc,Lf,jc,jc,jc,Re,oia,CQ,nia,mia,lia,kia,Ji,jia,iia,hia,gia,fia,eia,dia,cia,bia,aia,Ii,yQ,jc,jc,Fe,Le,Le,Fe,BQ,zQ,_f,Sg,K3,Zha,bA,Yha,jc,Wha,HQ,Dha,tha,kha,cha,Xga,Pga,Gga,wga,pga,Qga,Kia,tia,Nha,tu,cA,IQ,jc,Lf,jc,jc,jc,Re,tQ,Lha,Kha,Jha,Iha,Hha,Ji,Gha,Ii,sQ,jc,jc,Fe,Le,Le,Fe,Fha,Eha,hQ,rha,qha,jc,Lf,jc,jc,jc,Re,pha,oha,nha,mha,Ji,lha,Ii,eQ,jc,jc,Fe,Le,Le,ku,hha,jc,Lf,jc,jc,jc,Re,dQ,gha,fha,eha,Ji,dha,Ii,bQ,jc,jc,Fe,Le,Le,tu,cA,aha,jc,Lf,jc,jc,jc,Re,dQ,$ga,_ga,Zga,Ji,Yga,Ii,$P,jc,jc,Fe,Le,Le,qQ,pQ,Vga,jc,Lf,jc,jc,jc,Re,oQ,Uga,Aha,zha,Ji,yha,Ii,xha,jc,jc,Fe,Le,Le,Re,Lf,mQ,Tga,Sga,lQ,Rga,kQ,jQ,pQ,Cha,oQ,Bha,mQ,wha,vha,lQ,uha,kQ,jQ,ku,Nga,jc,Lf,jc,jc,jc,Re,Le,Mga,Lga,Kga,Ji,Jga,Ii,Iga,jc,jc,Fe,Le,Le,XP,Ega,Dga,jc,Lf,jc,jc,Cga,Re,Bga,Aga,zga,yga,Ji,xga,Ii,Tz,jc,jc,Fe,Le,Le,Re,Lf,ku,uga,jc,Lf,jc,jc,jc,Re,tQ,tga,sga,rga,Ji,qga,Ii,SP,jc,jc,Fe,Le,Le,ku,nga,jc,Lf,jc,jc,jc,Re,yo,mga,kga,jga,Ji,iga,Ii,QP,jc,jc,Fe,Le,Le,fu,vc,Kda,mO,GN,mO,KN,Qm,NN,eu,aO,mq,cu,$ba,_ba,EN,DN,CN,BN,AN,zN,yN,xN,wN,vN,uN,tN,sN,rN,qN,pN,oN,nN,mN,lN,kN,jN,iN,Zba,Yba,Xba,Wba,Vba,Uba,Tba,Sba,Rba,Qba,Pba,Oba,Nba,Mba,Lba,Kba,Jba,Iba,Hba,Gba,Fba,Eba,Dba,Cba,Bba,Aba,zba,yba,xba,Me,Sg,Me,Sg,Me,Sg,Me,Sg,Sg,uba,vc,tba,_t,Waa,oba,Me,Sg,Me,vc,Vaa,Uaa,Sg,vc,Zaa,Me,vc,Taa,Saa,vc,JM,IM,Sg,vc,Naa,Maa,vc,FM,EM,vc,Kaa,Jaa,vc,DM,CM,vc,Eaa,Daa,vc,zM,yM,kaa,vc,sm,vc,vc,Fe,Fe,jc,jc,ks,maa,laa,Sg,Sg,oaa,vc,sm,vc,vM,uM,Fe,jc,Fe,vaa,uaa,taa,saa,raa,qaa,paa,Sg,$9,vc,sm,vc,lM,caa,baa,aaa,Sg,eaa,vc,sm,vc,uM,gaa,faa,i2,vc,sm,vc,vc,o2,Fe,Fe,ks,js,n2,m2,l2,J9,I9,H9,go,Wy,Re,tL,sL,rL,jc,jc,C9,qL,B9,Gt,z9,Gt,Ct,Sy,Re,tL,sL,rL,jc,jc,p9,qL,o9,Gt,n9,Gt,Bt,h9,i9,g9,l9,k9,j9,fq,aL,f9,e9,Et,Ty,jL,iL,Gf,$K,d9,c9,Ft,Vy,oL,nL,Me,vc,a9,V3,U3,T3,$8,Pn,Wy,N8,M8,L8,K8,eL,Xy,vl,Xy,Wy,Q8,RK,P8,O8,Sy,V8,U8,T8,R8,Ft,Vy,oL,nL,eL,Xy,Sy,Y8,RK,X8,W8,Et,Ty,jL,iL,b9,jc,J8,cJ,I5,su,FI,c4,b4,a4,G8,HI,f4,e4,d4,D8,et,Q5,P5,O5,N5,M5,jY,L5,K5,J5,$s,NI,r4,q4,p4,o4,ct,QI,M4,L4,K4,J4,H4,G4,F4,E4,D4,C4,B4,A4,ry,NJ,e7,d7,c7,b7,jc,a7,$6,ky,kJ,xy,wy,vy,c6,b6,ly,lJ,js,uy,ty,e6,d6,kJ,lJ,Me,vc,vc,$5,_5,Z5,Y5,X5,W5,V5,U5,jY,T5,S5,R5,vc,dJ,dJ,_p,Fe,Fe,a6,Fe,vc,gJ,fJ,_p,jc,jc,eJ,yo,vc,gJ,fJ,_p,jc,jc,eJ,yo,vc,jJ,iJ,_p,jc,jc,hJ,yo,vc,jJ,iJ,_p,jc,jc,hJ,yo,Me,vc,I8,H8,Me,vc,F8,E8,vc,C8,z8,y8,x8,EK,EK,w8,v8,u8,t8,s8,vc,r8,q8,p8,o8,sK,sK,n8,m8,l8,k8,j8,vc,i8,h8,f8,e8,d8,c8,a8,$7,vc,_7,Z7,X7,W7,V7,U7,S7,R7,Me,vc,Le,Q7,P7,O7,N7,M7,L7,l6,k6,j6,i6,h6,g6,f6,Me,vc,Le,K7,J7,I7,H7,G7,F7,s6,r6,q6,p6,o6,n6,m6,OI,u4,t4,ud,jy,iy,hy,gy,fy,ey,XI,WI,VI,UI,TI,SI,RI,ZI,P4,O4,ud,jy,iy,hy,gy,fy,ey,XI,WI,VI,UI,TI,SI,RI,my,gt,E7,my,gt,D7,gt,gt,vc,mt,mt,ei,ei,ei,hK,jc,di,di,vc,mt,mt,ei,ei,ei,hK,jc,di,di,vc,lt,lt,ei,ei,ei,gK,jc,di,di,vc,lt,lt,ei,ei,ei,gK,jc,di,di,II,i4,xy,wy,vy,fK,nz,eK,dK,cK,kt,JI,j4,xy,wy,vy,fK,nz,eK,dK,cK,kt,KI,k4,js,uy,ty,bK,aK,$J,_J,kt,ZJ,LI,l4,js,uy,ty,bK,aK,$J,_J,kt,ZJ,vc,C7,x7,vc,v7,r7,vc,p7,m7,vc,l7,i7,vc,PJ,h7,Re,vc,PJ,g7,Re,vc,vc,Me,vc,f7,NJ,Me,vc,Me,vc,Me,vc,Me,vc,NI,QI,Me,Sg,vc,W3,vc,R3,qI,vc,Q3,P3,qI,Pn,Sg,vc,N3,va,Me,vc,Lf,Lf,J3,B3,D3,E3,vc,w3,vc,v3,_n,Pn,_n,_n,_n,_n,Pn,vc,u3,vc,A3,C3,F3,vc,I3,H3,G3,vc,x3]);function jb(){return u.byteLength/65536|0}function ob(pb){pb=pb|0;var kb=jb()|0;var lb=kb+pb|0;if(kb<lb&&lb<65536){var mb=new ArrayBuffer(D(lb,65536));var nb=new Int8Array(mb);nb.set(v);v=new Int8Array(mb);w=new Int16Array(mb);x=new Int32Array(mb);y=new Uint8Array(mb);z=new Uint16Array(mb);A=new Uint32Array(mb);B=new Float32Array(mb);C=new Float64Array(mb);u=mb;t.buffer=u;e=y}return kb}return{"va":Q0,"wa":CP,"xa":CP,"ya":DP,"za":DP,"Aa":vc,"Ba":Db,"Ca":aga,"Da":BP,"Ea":Zfa,"Fa":Yfa,"Ga":ju,"Ha":Re,"Ia":cga,"Ja":bga,"Ka":fga,"La":aA,"Ma":dga,"Na":EP,"Oa":ega,"Pa":Me,"Qa":IP,"Ra":HP,"Sa":IP,"Ta":qO,"Ua":s3,"Va":r3,"Wa":q3,"Xa":Xfa,"Ya":wP,"Za":Ufa,"_a":uP,"$a":Jfa,"ab":Xda,"bb":Yda,"cb":Hfa,"db":Gfa,"eb":Ffa,"fb":Ifa,"gb":Zda,"hb":oea,"ib":Sda,"jb":qea,"kb":Hea,"lb":Vda,"mb":sea,"nb":Wda,"ob":rea,"pb":Uda,"qb":bea,"rb":$da,"sb":aea,"tb":jea,"ub":hea,"vb":iea,"wb":cea,"xb":dea,"yb":fea,"zb":gea,"Ab":Eea,"Bb":Fea,"Cb":Pea,"Db":Kea,"Eb":Jea,"Fb":Iea,"Gb":Oea,"Hb":Nea,"Ib":Lea,"Jb":Mea,"Kb":Uea,"Lb":Vea,"Mb":Qea,"Nb":Tea,"Ob":Sea,"Pb":yea,"Qb":Dea,"Rb":Bea,"Sb":Aea,"Tb":Cea,"Ub":zea,"Vb":nea,"Wb":Xea,"Xb":xea,"Yb":vea,"Zb":Gea,"_b":pea,"$b":wea,"ac":uea,"bc":tea,"cc":Yea,"dc":lea,"ec":Zea,"fc":mea,"gc":Wea,"hc":Tfa,"ic":Rfa,"jc":o3,"kc":Qfa,"lc":Pfa,"mc":Ofa,"nc":Mfa,"oc":n3,"pc":Lfa,"qc":Kfa,"rc":Efa,"sc":Cfa,"tc":Afa,"uc":_ea,"vc":zfa,"wc":pc,"xc":GN,"yc":nq,"zc":Gd,"Ac":LN,"Bc":MN,"Cc":Tca,"Dc":Uca,"Ec":KN,"Fc":uda,"Gc":wda,"Hc":vda,"Ic":$N,"Jc":$N,"Kc":qO,"Lc":hI,"Mc":hI,"Nc":gI,"Oc":gI,"Pc":m3,"Qc":ON,"Rc":SN,"Sc":_N,"Tc":ZN,"Uc":PN,"Vc":VN,"Wc":UN,"Xc":RN,"Yc":YN,"Zc":WN,"_c":TN,"$c":Qm,"ad":NN,"bd":sda,"cd":pca,"dd":oda,"ed":Gca,"fd":tca,"gd":nda,"hd":qca,"id":jda,"jd":Hca,"kd":pda,"ld":cda,"md":bda,"nd":ada,"od":fda,"pd":eda,"qd":dda,"rd":hda,"sd":kda,"td":ida,"ud":lda,"vd":Aca,"wd":Rca,"xd":nca,"yd":Cca,"zd":Bca,"Ad":wca,"Bd":Dca,"Cd":vca,"Dd":Oca,"Ed":ica,"Fd":kca,"Gd":lca,"Hd":jca,"Id":fca,"Jd":eca,"Kd":Jca,"Ld":Lca,"Md":Qca,"Nd":Kca,"Od":uca,"Pd":Nca,"Qd":xca,"Rd":Eca,"Sd":Mca,"Td":yca,"Ud":sca,"Vd":Fca,"Wd":zca,"Xd":rca,"Yd":gca,"Zd":dca,"_d":cca,"$d":mca,"ae":hca,"be":aca,"ce":bca,"de":Pca,"ee":l3,"fe":oca,"ge":Sca,"he":$ca,"ie":qda,"je":k3,"ke":mda,"le":tda,"me":bO,"ne":dO,"oe":eO,"pe":fO,"qe":hO,"re":iO,"se":lO,"te":gO,"ue":eu,"ve":aO,"we":cO,"xe":yda,"ye":Hda,"ze":pc,"Ae":LN,"Be":MN,"Ce":nq,"De":ON,"Ee":SN,"Fe":_N,"Ge":ZN,"He":PN,"Ie":VN,"Je":UN,"Ke":RN,"Le":YN,"Me":WN,"Ne":TN,"Oe":Qm,"Pe":bO,"Qe":dO,"Re":eO,"Se":fO,"Te":hO,"Ue":iO,"Ve":lO,"We":gO,"Xe":eu,"Ye":cO,"Ze":ib,"_e":Jda,"$e":sia,"af":iha,"bf":_fa,"cf":L3,"df":M3,"ef":z3,"ff":y3,"gf":j3,"hf":i3,"jf":g3,"kf":c3,"lf":h3,"mf":g3,"nf":f3,"of":d3,"pf":e3,"qf":d3,"rf":c3,"sf":c3}}return qb(sb)}
// EMSCRIPTEN_END_ASM


)(info);
  },

  instantiate: /** @suppress{checkTypes} */ function(binary, info) {
    return {
      then: function(ok) {
        var module = new WebAssembly.Module(binary);
        ok({
          'instance': new WebAssembly.Instance(module, info)
        });
        // Emulate a simple WebAssembly.instantiate(..).then(()=>{}).catch(()=>{}) syntax.
        return { catch: function() {} };
      }
    };
  },

  RuntimeError: Error
};

// We don't need to actually download a wasm binary, mark it as present but empty.
wasmBinary = [];
